#!/opt/local/bin/scheme --program

;; @generated by Idris 0.7.0-55c2cd32e, Chez backend
(import (chezscheme))
(case (machine-type)
  [(i3fb ti3fb a6fb ta6fb) #f]
  [(i3le ti3le a6le ta6le tarm64le) (load-shared-object "libc.so.6")]
  [(i3osx ti3osx a6osx ta6osx tarm64osx tppc32osx tppc64osx) (load-shared-object "libc.dylib")]
  [(i3nt ti3nt a6nt ta6nt) (load-shared-object "msvcrt.dll")]
  [else (load-shared-object "libc.so")])

(load-shared-object "libidris2_support.dylib")

(let ()
(define (blodwen-os)
  (case (machine-type)
    [(i3le ti3le a6le ta6le tarm64le) "unix"]  ; GNU/Linux
    [(i3ob ti3ob a6ob ta6ob tarm64ob) "unix"]  ; OpenBSD
    [(i3fb ti3fb a6fb ta6fb tarm64fb) "unix"]  ; FreeBSD
    [(i3nb ti3nb a6nb ta6nb tarm64nb) "unix"]  ; NetBSD
    [(i3osx ti3osx a6osx ta6osx tarm64osx tppc32osx tppc64osx) "darwin"]
    [(i3nt ti3nt a6nt ta6nt tarm64nt) "windows"]
    [else "unknown"]))

(define blodwen-lazy
  (lambda (f)
    (let ([evaluated #f] [res void])
      (lambda ()
        (if (not evaluated)
            (begin (set! evaluated #t)
                   (set! res (f))
                   (set! f void))
            (void))
        res))))

(define (blodwen-toSignedInt x bits)
  (if (logbit? bits x)
      (logor x (ash -1 bits))
      (logand x (sub1 (ash 1 bits)))))

(define (blodwen-toUnsignedInt x bits)
  (logand x (sub1 (ash 1 bits))))

(define (blodwen-euclidDiv a b)
  (let ((q (quotient a b))
        (r (remainder a b)))
    (if (< r 0)
      (if (> b 0) (- q 1) (+ q 1))
      q)))

(define (blodwen-euclidMod a b)
  (let ((r (remainder a b)))
    (if (< r 0)
      (if (> b 0) (+ r b) (- r b))
      r)))

; flonum constants

(define (blodwen-calcFlonumUnitRoundoff)
  (let loop [(uro 1.0)]
    (if (fl= 1.0 (fl+ 1.0 uro))
      uro
      (loop (fl/ uro 2.0)))))

(define (blodwen-calcFlonumEpsilon)
  (fl* (blodwen-calcFlonumUnitRoundoff) 2.0))

(define (blodwen-flonumNaN)
  +nan.0)

(define (blodwen-flonumInf)
  +inf.0)

; Bits

(define bu+ (lambda (x y bits) (blodwen-toUnsignedInt (+ x y) bits)))
(define bu- (lambda (x y bits) (blodwen-toUnsignedInt (- x y) bits)))
(define bu* (lambda (x y bits) (blodwen-toUnsignedInt (* x y) bits)))
(define bu/ (lambda (x y bits) (blodwen-toUnsignedInt (quotient x y) bits)))

(define bs+ (lambda (x y bits) (blodwen-toSignedInt (+ x y) bits)))
(define bs- (lambda (x y bits) (blodwen-toSignedInt (- x y) bits)))
(define bs* (lambda (x y bits) (blodwen-toSignedInt (* x y) bits)))
(define bs/ (lambda (x y bits) (blodwen-toSignedInt (blodwen-euclidDiv x y) bits)))

(define (integer->bits8 x) (logand x (sub1 (ash 1 8))))
(define (integer->bits16 x) (logand x (sub1 (ash 1 16))))
(define (integer->bits32 x) (logand x (sub1 (ash 1 32))))
(define (integer->bits64 x) (logand x (sub1 (ash 1 64))))

(define (bits16->bits8 x) (logand x (sub1 (ash 1 8))))
(define (bits32->bits8 x) (logand x (sub1 (ash 1 8))))
(define (bits64->bits8 x) (logand x (sub1 (ash 1 8))))
(define (bits32->bits16 x) (logand x (sub1 (ash 1 16))))
(define (bits64->bits16 x) (logand x (sub1 (ash 1 16))))
(define (bits64->bits32 x) (logand x (sub1 (ash 1 32))))

(define (blodwen-bits-shl-signed x y bits) (blodwen-toSignedInt (ash x y) bits))

(define (blodwen-bits-shl x y bits) (logand (ash x y) (sub1 (ash 1 bits))))

(define blodwen-shl (lambda (x y) (ash x y)))
(define blodwen-shr (lambda (x y) (ash x (- y))))
(define blodwen-and (lambda (x y) (logand x y)))
(define blodwen-or (lambda (x y) (logor x y)))
(define blodwen-xor (lambda (x y) (logxor x y)))

(define cast-num
  (lambda (x)
    (if (number? x) x 0)))
(define destroy-prefix
  (lambda (x)
    (cond
      ((equal? x "") "")
      ((equal? (string-ref x 0) #\#) "")
      (else x))))

(define exact-floor
  (lambda (x)
    (inexact->exact (floor x))))

(define exact-truncate
  (lambda (x)
    (inexact->exact (truncate x))))

(define exact-truncate-boundedInt
  (lambda (x y)
    (blodwen-toSignedInt (exact-truncate x) y)))

(define exact-truncate-boundedUInt
  (lambda (x y)
    (blodwen-toUnsignedInt (exact-truncate x) y)))

(define cast-char-boundedInt
  (lambda (x y)
    (blodwen-toSignedInt (char->integer x) y)))

(define cast-char-boundedUInt
  (lambda (x y)
    (blodwen-toUnsignedInt (char->integer x) y)))

(define cast-string-int
  (lambda (x)
    (exact-truncate (cast-num (string->number (destroy-prefix x))))))

(define cast-string-boundedInt
  (lambda (x y)
    (blodwen-toSignedInt (cast-string-int x) y)))

(define cast-string-boundedUInt
  (lambda (x y)
    (blodwen-toUnsignedInt (cast-string-int x) y)))

(define cast-int-char
  (lambda (x)
    (if (or
          (and (>= x 0) (<= x #xd7ff))
          (and (>= x #xe000) (<= x #x10ffff)))
        (integer->char x)
        (integer->char 0))))

(define cast-string-double
  (lambda (x)
    (exact->inexact (cast-num (string->number (destroy-prefix x))))))


(define (string-concat xs) (apply string-append xs))
(define (string-unpack s) (string->list s))
(define (string-pack xs) (list->string xs))

(define string-cons (lambda (x y) (string-append (string x) y)))
(define string-reverse (lambda (x)
  (list->string (reverse (string->list x)))))
(define (string-substr off len s)
    (let* ((l (string-length s))
          (b (max 0 off))
          (x (max 0 len))
          (end (min l (+ b x))))
          (if (> b l)
              ""
              (substring s b end))))

(define (blodwen-string-iterator-new s)
  0)

(define (blodwen-string-iterator-to-string _ s ofs f)
  (f (substring s ofs (string-length s))))

(define (blodwen-string-iterator-next s ofs)
  (if (>= ofs (string-length s))
      '() ; EOF
      (cons (string-ref s ofs) (+ ofs 1))))

(define either-left
  (lambda (x)
    (vector 0 x)))

(define either-right
  (lambda (x)
    (vector 1 x)))

(define blodwen-error-quit
  (lambda (msg)
    (display msg)
    (newline)
    (exit 1)))

(define (blodwen-get-line p)
    (if (port? p)
        (let ((str (get-line p)))
            (if (eof-object? str)
                ""
                str))
        void))

(define (blodwen-get-char p)
    (if (port? p)
        (let ((chr (get-char p)))
            (if (eof-object? chr)
                #\nul
                chr))
        void))

;; Buffers

(define (blodwen-new-buffer size)
  (make-bytevector size 0))

(define (blodwen-buffer-size buf)
  (bytevector-length buf))

(define (blodwen-buffer-setbyte buf loc val)
  (bytevector-u8-set! buf loc val))

(define (blodwen-buffer-getbyte buf loc)
  (bytevector-u8-ref buf loc))

(define (blodwen-buffer-setbits16 buf loc val)
  (bytevector-u16-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getbits16 buf loc)
  (bytevector-u16-ref buf loc (native-endianness)))

(define (blodwen-buffer-setbits32 buf loc val)
  (bytevector-u32-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getbits32 buf loc)
  (bytevector-u32-ref buf loc (native-endianness)))

(define (blodwen-buffer-setbits64 buf loc val)
  (bytevector-u64-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getbits64 buf loc)
  (bytevector-u64-ref buf loc (native-endianness)))

(define (blodwen-buffer-setint8 buf loc val)
  (bytevector-s8-set! buf loc val))

(define (blodwen-buffer-getint8 buf loc)
  (bytevector-s8-ref buf loc))

(define (blodwen-buffer-setint16 buf loc val)
  (bytevector-s16-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getint16 buf loc)
  (bytevector-s16-ref buf loc (native-endianness)))

(define (blodwen-buffer-setint32 buf loc val)
  (bytevector-s32-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getint32 buf loc)
  (bytevector-s32-ref buf loc (native-endianness)))

(define (blodwen-buffer-setint buf loc val)
  (bytevector-s64-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getint buf loc)
  (bytevector-s64-ref buf loc (native-endianness)))

(define (blodwen-buffer-setint64 buf loc val)
  (bytevector-s64-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getint64 buf loc)
  (bytevector-s64-ref buf loc (native-endianness)))

(define (blodwen-buffer-setdouble buf loc val)
  (bytevector-ieee-double-set! buf loc val (native-endianness)))

(define (blodwen-buffer-getdouble buf loc)
  (bytevector-ieee-double-ref buf loc (native-endianness)))

(define (blodwen-stringbytelen str)
  (bytevector-length (string->utf8 str)))

(define (blodwen-buffer-setstring buf loc val)
  (let* [(strvec (string->utf8 val))
         (len (bytevector-length strvec))]
    (bytevector-copy! strvec 0 buf loc len)))

(define (blodwen-buffer-getstring buf loc len)
  (let [(newvec (make-bytevector len))]
    (bytevector-copy! buf loc newvec 0 len)
    (utf8->string newvec)))

(define (blodwen-buffer-copydata buf start len dest loc)
  (bytevector-copy! buf start dest loc len))

;; Threads

(define-record thread-handle (semaphore))

(define (blodwen-thread proc)
  (let [(sema (blodwen-make-semaphore 0))]
    (fork-thread (lambda () (proc (vector 0)) (blodwen-semaphore-post sema)))
    (make-thread-handle sema)
    ))

(define (blodwen-thread-wait handle)
  (blodwen-semaphore-wait (thread-handle-semaphore handle)))

;; Thread mailboxes

(define blodwen-thread-data
  (make-thread-parameter #f))

(define (blodwen-get-thread-data ty)
  (blodwen-thread-data))

(define (blodwen-set-thread-data ty a)
  (blodwen-thread-data a))

;; Semaphore

(define-record semaphore (box mutex condition))

(define (blodwen-make-semaphore init)
  (make-semaphore (box init) (make-mutex) (make-condition)))

(define (blodwen-semaphore-post sema)
  (with-mutex (semaphore-mutex sema)
    (let [(sema-box (semaphore-box sema))]
      (set-box! sema-box (+ (unbox sema-box) 1))
      (condition-signal (semaphore-condition sema))
    )))

(define (blodwen-semaphore-wait sema)
  (with-mutex (semaphore-mutex sema)
    (let [(sema-box (semaphore-box sema))]
      (when (= (unbox sema-box) 0)
        (condition-wait (semaphore-condition sema) (semaphore-mutex sema)))
      (set-box! sema-box (- (unbox sema-box) 1))
      )))

;; Barrier

(define-record barrier (count-box num-threads mutex cond))

(define (blodwen-make-barrier num-threads)
  (make-barrier (box 0) num-threads (make-mutex) (make-condition)))

(define (blodwen-barrier-wait barrier)
  (let [(count-box (barrier-count-box barrier))
        (num-threads (barrier-num-threads barrier))
        (mutex (barrier-mutex barrier))
        (condition (barrier-cond barrier))]
    (with-mutex mutex
    (let* [(count-old (unbox count-box))
           (count-new (+ count-old 1))]
      (set-box! count-box count-new)
      (if (= count-new num-threads)
          (condition-broadcast condition)
          (condition-wait condition mutex))
      ))))

;; Channel
; With thanks to Alain Zscheile (@zseri) for help with understanding condition
; variables, and figuring out where the problems were and how to solve them.

(define-record channel (read-mut read-cv read-box val-cv val-box))

(define (blodwen-make-channel ty)
  (make-channel
    (make-mutex)
    (make-condition)
    (box #t)
    (make-condition)
    (box '())
    ))

; block on the read status using read-cv until the value has been read
(define (channel-put-while-helper chan)
  (let ([read-mut (channel-read-mut chan)]
        [read-box (channel-read-box chan)]
        [read-cv  (channel-read-cv  chan)]
        )
    (if (unbox read-box)
      (void)    ; val has been read, so everything is fine
      (begin    ; otherwise, block/spin with cv
        (condition-wait read-cv read-mut)
        (channel-put-while-helper chan)
        )
      )))

(define (blodwen-channel-put ty chan val)
  (with-mutex (channel-read-mut chan)
    (channel-put-while-helper chan)
    (let ([read-box (channel-read-box chan)]
          [val-box  (channel-val-box  chan)]
          )
      (set-box! val-box val)
      (set-box! read-box #f)
      ))
  (condition-signal (channel-val-cv chan))
  )

; block on the value until it has been set
(define (channel-get-while-helper chan)
  (let ([read-mut (channel-read-mut chan)]
        [read-box (channel-read-box chan)]
        [val-cv   (channel-val-cv   chan)]
        )
    (if (unbox read-box)
      (begin
        (condition-wait val-cv read-mut)
        (channel-get-while-helper chan)
        )
      (void)
      )))

(define (blodwen-channel-get ty chan)
  (mutex-acquire (channel-read-mut chan))
  (channel-get-while-helper chan)
  (let* ([val-box  (channel-val-box  chan)]
         [read-box (channel-read-box chan)]
         [read-cv  (channel-read-cv  chan)]
         [the-val  (unbox val-box)]
         )
    (set-box! val-box '())
    (set-box! read-box #t)
    (mutex-release (channel-read-mut chan))
    (condition-signal read-cv)
    the-val))

;; Mutex

(define (blodwen-make-mutex)
  (make-mutex))
(define (blodwen-mutex-acquire mutex)
  (mutex-acquire mutex))
(define (blodwen-mutex-release mutex)
  (mutex-release mutex))

;; Condition variable

(define (blodwen-make-condition)
  (make-condition))
(define (blodwen-condition-wait condition mutex)
  (condition-wait condition mutex))
(define (blodwen-condition-wait-timeout condition mutex timeout)
  (let* [(sec (div timeout 1000000))
         (micro (mod timeout 1000000))]
    (condition-wait condition mutex (make-time 'time-duration (* 1000 micro) sec))))
(define (blodwen-condition-signal condition)
  (condition-signal condition))
(define (blodwen-condition-broadcast condition)
  (condition-broadcast condition))

;; Future

(define-record future-internal (result ready mutex signal))
(define (blodwen-make-future work)
  (let ([future (make-future-internal #f #f (make-mutex) (make-condition))])
    (fork-thread (lambda ()
      (let ([result (work)])
        (with-mutex (future-internal-mutex future)
          (set-future-internal-result! future result)
          (set-future-internal-ready! future #t)
          (condition-broadcast (future-internal-signal future))))))
    future))
(define (blodwen-await-future ty future)
  (let ([mutex (future-internal-mutex future)])
    (with-mutex mutex
      (if (not (future-internal-ready future))
          (condition-wait (future-internal-signal future) mutex))
      (future-internal-result future))))

(define (blodwen-sleep s) (sleep (make-time 'time-duration 0 s)))
(define (blodwen-usleep s)
  (let ((sec (div s 1000000))
        (micro (mod s 1000000)))
       (sleep (make-time 'time-duration (* 1000 micro) sec))))

(define (blodwen-clock-time-utc) (current-time 'time-utc))
(define (blodwen-clock-time-monotonic) (current-time 'time-monotonic))
(define (blodwen-clock-time-duration) (current-time 'time-duration))
(define (blodwen-clock-time-process) (current-time 'time-process))
(define (blodwen-clock-time-thread) (current-time 'time-thread))
(define (blodwen-clock-time-gccpu) (current-time 'time-collector-cpu))
(define (blodwen-clock-time-gcreal) (current-time 'time-collector-real))
(define (blodwen-is-time? clk) (if (time? clk) 1 0))
(define (blodwen-clock-second time) (time-second time))
(define (blodwen-clock-nanosecond time) (time-nanosecond time))


(define (blodwen-arg-count)
  (length (command-line)))

(define (blodwen-arg n)
  (if (< n (length (command-line))) (list-ref (command-line) n) ""))

(define (blodwen-hasenv var)
  (if (eq? (getenv var) #f) 0 1))

;; Randoms
(define random-seed-register 0)
(define (initialize-random-seed-once)
  (if (= (virtual-register random-seed-register) 0)
      (let ([seed (time-nanosecond (current-time))])
        (set-virtual-register! random-seed-register seed)
        (random-seed seed))))

(define (blodwen-random-seed seed)
  (set-virtual-register! random-seed-register seed)
  (random-seed seed))
(define blodwen-random
  (case-lambda
    ;; no argument, pick a real value from [0, 1.0)
    [() (begin
          (initialize-random-seed-once)
          (random 1.0))]
    ;; single argument k, pick an integral value from [0, k)
    [(k)
      (begin
        (initialize-random-seed-once)
        (if (> k 0)
              (random k)
              (assertion-violationf 'blodwen-random "invalid range argument ~a" k)))]))

;; For finalisers

(define blodwen-finaliser (make-guardian))
(define (blodwen-register-object obj proc)
  (let [(x (cons obj proc))]
       (blodwen-finaliser x)
       x))
(define blodwen-run-finalisers
  (lambda ()
    (let run ()
      (let ([x (blodwen-finaliser)])
        (when x
          (((cdr x) (car x)) 'erased)
          (run))))))

;; For creating and reading back scheme objects

; read a scheme string and evaluate it, returning 'Just result' on success
; TODO: catch exception!
(define (blodwen-eval-scheme str)
  (guard
     (x [#t '()]) ; Nothing on failure
     (box (eval (read (open-input-string str)))))
  ); box == Just

(define (blodwen-eval-okay obj)
  (if (null? obj)
      0
      1))

(define (blodwen-get-eval-result obj)
  (unbox obj))

(define (blodwen-debug-scheme obj)
  (display obj) (newline))

(define (blodwen-is-number obj)
  (if (number? obj) 1 0))

(define (blodwen-is-integer obj)
  (if (and (number? obj) (exact? obj)) 1 0))

(define (blodwen-is-float obj)
  (if (flonum? obj) 1 0))

(define (blodwen-is-char obj)
  (if (char? obj) 1 0))

(define (blodwen-is-string obj)
  (if (string? obj) 1 0))

(define (blodwen-is-procedure obj)
  (if (procedure? obj) 1 0))

(define (blodwen-is-symbol obj)
  (if (symbol? obj) 1 0))

(define (blodwen-is-vector obj)
  (if (vector? obj) 1 0))

(define (blodwen-is-nil obj)
  (if (null? obj) 1 0))

(define (blodwen-is-pair obj)
  (if (pair? obj) 1 0))

(define (blodwen-is-box obj)
  (if (box? obj) 1 0))

(define (blodwen-make-symbol str)
  (string->symbol str))

; The below rely on checking that the objects are the right type first.

(define (blodwen-vector-ref obj i)
  (vector-ref obj i))

(define (blodwen-vector-length obj)
  (vector-length obj))

(define (blodwen-vector-list obj)
  (vector->list obj))

(define (blodwen-unbox obj)
  (unbox obj))

(define (blodwen-apply obj arg)
  (obj arg))

(define (blodwen-force obj)
  (obj))

(define (blodwen-read-symbol sym)
  (symbol->string sym))

(define (blodwen-id x) x)
(define PreludeC-45Types-fastUnpack (lambda (farg-0) (string-unpack farg-0)))
(define PreludeC-45Types-fastPack (lambda (farg-0) (string-pack farg-0)))
(define PreludeC-45Types-fastConcat (lambda (farg-0) (string-concat farg-0)))
(define PreludeC-45IO-prim__putStr (lambda (farg-0 farg-1) ((foreign-procedure "idris2_putStr" (string) void) farg-0)))
(define PreludeC-45IO-prim__putChar (lambda (farg-0 farg-1) ((foreign-procedure "putchar" (char) void) farg-0)))
(define PreludeC-45IO-prim__getString (lambda (farg-0) ((foreign-procedure "idris2_getString" (void*) string) farg-0)))
(define PreludeC-45IO-prim__getStr (lambda (farg-0) ((foreign-procedure "idris2_getStr" () string) )))
(define PreludeC-45IO-prim__getChar (lambda (farg-0) ((foreign-procedure "getchar" () char) )))
(define PrimIO-prim__nullAnyPtr (lambda (farg-0) ((foreign-procedure "idris2_isNull" (void*) int) farg-0)))
(define SystemC-45Directory-prim__openDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_openDir" (string) void*) farg-0)))
(define SystemC-45Directory-prim__dirEntry (lambda (farg-0 farg-1) ((foreign-procedure "idris2_nextDirEntry" (void*) void*) farg-0)))
(define SystemC-45Directory-prim__currentDir (lambda (farg-0) ((foreign-procedure "idris2_currentDirectory" () void*) )))
(define SystemC-45Directory-prim__createDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_createDir" (string) int) farg-0)))
(define SystemC-45Directory-prim__closeDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_closeDir" (void*) void) farg-0)))
(define SystemC-45Directory-prim__changeDir (lambda (farg-0 farg-1) ((foreign-procedure "idris2_changeDir" (string) int) farg-0)))
(define SystemC-45FFI-prim__free (lambda (farg-0 farg-1) ((foreign-procedure "idris2_free" (void*) void) farg-0)))
(define SystemC-45FileC-45Virtual-prim__stdout (lambda () ((foreign-procedure "idris2_stdout" () void*) )))
(define SystemC-45FileC-45Virtual-prim__stdin (lambda () ((foreign-procedure "idris2_stdin" () void*) )))
(define SystemC-45FileC-45ReadWrite-prim__writeLine (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_writeLine" (void* string) int) farg-0 farg-1)))
(define SystemC-45FileC-45ReadWrite-prim__seekLine (lambda (farg-0 farg-1) ((foreign-procedure "idris2_seekLine" (void*) int) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__removeFile (lambda (farg-0 farg-1) ((foreign-procedure "idris2_removeFile" (string) int) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__readLine (lambda (farg-0 farg-1) ((foreign-procedure "idris2_readLine" (void*) void*) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__readChar (lambda (farg-0 farg-1) ((foreign-procedure "fgetc" (void*) int) farg-0)))
(define SystemC-45FileC-45ReadWrite-prim__eof (lambda (farg-0 farg-1) ((foreign-procedure "idris2_eof" (void*) int) farg-0)))
(define SystemC-45FileC-45Error-prim__fileErrno (lambda (farg-0) ((foreign-procedure "idris2_fileErrno" () int) )))
(define SystemC-45FileC-45Error-prim__error (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileError" (void*) int) farg-0)))
(define SystemC-45Errno-prim__strerror (lambda (farg-0 farg-1) ((foreign-procedure "idris2_strerror" (int) string) farg-0)))
(define SystemC-45Errno-prim__getErrno (lambda (farg-0) ((foreign-procedure "idris2_getErrno" () int) )))
(define SystemC-45FileC-45Handle-prim__open (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_openFile" (string string) void*) farg-0 farg-1)))
(define SystemC-45FileC-45Handle-prim__close (lambda (farg-0 farg-1) ((foreign-procedure "idris2_closeFile" (void*) void) farg-0)))
(define SystemC-45FileC-45Process-prim__popen (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_popen" (string string) void*) farg-0 farg-1)))
(define SystemC-45FileC-45Process-prim__pclose (lambda (farg-0 farg-1) ((foreign-procedure "idris2_pclose" (void*) int) farg-0)))
(define SystemC-45FileC-45Process-prim__flush (lambda (farg-0 farg-1) ((foreign-procedure "fflush" (void*) int) farg-0)))
(define SystemC-45FileC-45Permissions-prim__chmod (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idris2_chmod" (string int) int) farg-0 farg-1)))
(define SystemC-45FileC-45Meta-prim__fileSize (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileSize" (void*) int) farg-0)))
(define SystemC-45FileC-45Meta-prim__fileIsTTY (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileIsTTY" (void*) int) farg-0)))
(define SystemC-45FileC-45Buffer-prim__writeBufferData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4) ((foreign-procedure "idris2_writeBufferData" (void* u8* int int) int) farg-0 farg-1 farg-2 farg-3)))
(define SystemC-45FileC-45Buffer-prim__readBufferData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4) ((foreign-procedure "idris2_readBufferData" (void* u8* int int) int) farg-0 farg-1 farg-2 farg-3)))
(define DataC-45Buffer-stringByteLength (lambda (farg-0) (blodwen-stringbytelen farg-0)))
(define DataC-45Buffer-prim__setString (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setstring farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__setInt (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setint farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__setDouble (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setdouble farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__setBits8 (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-setbyte farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__newBuffer (lambda (farg-0 farg-1) (blodwen-new-buffer farg-0)))
(define DataC-45Buffer-prim__getString (lambda (farg-0 farg-1 farg-2 farg-3) (blodwen-buffer-getstring farg-0 farg-1 farg-2)))
(define DataC-45Buffer-prim__getInt (lambda (farg-0 farg-1 farg-2) (blodwen-buffer-getint farg-0 farg-1)))
(define DataC-45Buffer-prim__getDouble (lambda (farg-0 farg-1 farg-2) (blodwen-buffer-getdouble farg-0 farg-1)))
(define DataC-45Buffer-prim__getBits8 (lambda (farg-0 farg-1 farg-2) (blodwen-buffer-getbyte farg-0 farg-1)))
(define DataC-45Buffer-prim__copyData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4 farg-5) (blodwen-buffer-copydata farg-0 farg-1 farg-2 farg-3 farg-4)))
(define DataC-45Buffer-prim__bufferSize (lambda (farg-0) (blodwen-buffer-size farg-0)))
(define System-prim__system (lambda (farg-0 farg-1) ((foreign-procedure "idris2_system" (string) int) farg-0)))
(define System-prim__getEnv (lambda (farg-0 farg-1) ((foreign-procedure "getenv" (string) void*) farg-0)))
(define System-prim__getArgCount (lambda (farg-0) (blodwen-arg-count )))
(define System-prim__getArg (lambda (farg-0 farg-1) (blodwen-arg farg-0)))
(define System-prim__exit (lambda (farg-0 farg-1) ((foreign-procedure "exit" (int) void) farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeVectorToList (lambda (farg-0) (blodwen-vector-list farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeVectorRef (lambda (farg-0 farg-1) (blodwen-vector-ref farg-0 farg-1)))
(define LibrariesC-45UtilsC-45Scheme-unsafeVectorLength (lambda (farg-0) (blodwen-vector-length farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeUnbox (lambda (farg-0) (blodwen-unbox farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeSnd (lambda (farg-0) (cdr farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeReadSymbol (lambda (farg-0) (blodwen-read-symbol farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetString (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetInteger (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetFloat (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeGetChar (lambda (farg-0) (blodwen-id farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeFst (lambda (farg-0) (car farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeForce (lambda (farg-0) (blodwen-force farg-0)))
(define LibrariesC-45UtilsC-45Scheme-unsafeApply (lambda (farg-0 farg-1) (blodwen-apply farg-0 farg-1)))
(define LibrariesC-45UtilsC-45Scheme-prim_isVector (lambda (farg-0) (blodwen-is-vector farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isSymbol (lambda (farg-0) (blodwen-is-symbol farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isString (lambda (farg-0) (blodwen-is-string farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isProcedure (lambda (farg-0) (blodwen-is-procedure farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isPair (lambda (farg-0) (blodwen-is-pair farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isInteger (lambda (farg-0) (blodwen-is-integer farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isFloat (lambda (farg-0) (blodwen-is-float farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isChar (lambda (farg-0) (blodwen-is-char farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim_isBox (lambda (farg-0) (blodwen-is-box farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim__evalScheme (lambda (farg-0) (blodwen-eval-scheme farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim__evalResult (lambda (farg-0) (blodwen-get-eval-result farg-0)))
(define LibrariesC-45UtilsC-45Scheme-prim__evalOkay (lambda (farg-0) (blodwen-eval-okay farg-0)))
(define LibrariesC-45SystemC-45FileC-45Buffer-prim__writeBufferData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4) ((foreign-procedure "idris2_writeBufferData" (void* u8* int int) int) farg-0 farg-1 farg-2 farg-3)))
(define LibrariesC-45SystemC-45FileC-45Buffer-prim__readBufferData (lambda (farg-0 farg-1 farg-2 farg-3 farg-4) ((foreign-procedure "idris2_readBufferData" (void* u8* int int) int) farg-0 farg-1 farg-2 farg-3)))
(define SystemC-45Clock-prim__osClockValid (lambda (farg-0 farg-1) (blodwen-is-time? farg-0)))
(define SystemC-45Clock-prim__osClockSecond (lambda (farg-0 farg-1) (blodwen-clock-second farg-0)))
(define SystemC-45Clock-prim__osClockNanosecond (lambda (farg-0 farg-1) (blodwen-clock-nanosecond farg-0)))
(define SystemC-45Clock-prim__clockTimeUtc (lambda (farg-0) (blodwen-clock-time-utc )))
(define SystemC-45Clock-prim__clockTimeThread (lambda (farg-0) (blodwen-clock-time-thread )))
(define SystemC-45Clock-prim__clockTimeProcess (lambda (farg-0) (blodwen-clock-time-process )))
(define SystemC-45Clock-prim__clockTimeMonotonic (lambda (farg-0) (blodwen-clock-time-monotonic )))
(define SystemC-45Clock-prim__clockTimeGcReal (lambda (farg-0) (blodwen-clock-time-gcreal )))
(define SystemC-45Clock-prim__clockTimeGcCpu (lambda (farg-0) (blodwen-clock-time-gccpu )))
(define LibrariesC-45DataC-45StringC-45Iterator-uncons (lambda (farg-0 farg-1) (blodwen-string-iterator-next farg-0 farg-1)))
(define LibrariesC-45DataC-45StringC-45Iterator-fromString (lambda (farg-0) (blodwen-string-iterator-new farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeStatusTimeSec (lambda (farg-0 farg-1) ((foreign-procedure "idris2_filetimeStatusTimeSec" (void*) int) farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeStatusTimeNsec (lambda (farg-0 farg-1) ((foreign-procedure "idris2_filetimeStatusTimeNsec" (void*) int) farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeModifiedTimeSec (lambda (farg-0 farg-1) ((foreign-procedure "idris2_filetimeModifiedTimeSec" (void*) int) farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeModifiedTimeNsec (lambda (farg-0 farg-1) ((foreign-procedure "idris2_filetimeModifiedTimeNsec" (void*) int) farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeAccessTimeSec (lambda (farg-0 farg-1) ((foreign-procedure "idris2_filetimeAccessTimeSec" (void*) int) farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeAccessTimeNsec (lambda (farg-0 farg-1) ((foreign-procedure "idris2_filetimeAccessTimeNsec" (void*) int) farg-0)))
(define LibrariesC-45SystemC-45FileC-45Meta-prim__fileTime (lambda (farg-0 farg-1) ((foreign-procedure "idris2_fileTime" (void*) void*) farg-0)))
(define LibrariesC-45UtilsC-45Term-prim__setupTerm (lambda (farg-0) ((foreign-procedure "idris2_setupTerm" () void) )))
(define LibrariesC-45UtilsC-45Term-prim__getTermCols (lambda (farg-0) ((foreign-procedure "idris2_getTermCols" () int) )))
(define NetworkC-45FFI-prim__idrnet_socket (lambda (farg-0 farg-1 farg-2 farg-3) ((foreign-procedure "idrnet_socket" (int int int) int) farg-0 farg-1 farg-2)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_unix (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_unix" (void*) string) farg-0)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_port (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_port" (int) int) farg-0)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_ipv4 (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_ipv4" (void*) string) farg-0)))
(define NetworkC-45FFI-prim__idrnet_sockaddr_family (lambda (farg-0 farg-1) ((foreign-procedure "idrnet_sockaddr_family" (void*) int) farg-0)))
(define NetworkC-45FFI-prim__idrnet_listen (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idrnet_listen" (int int) int) farg-0 farg-1)))
(define NetworkC-45FFI-prim__idrnet_fdopen (lambda (farg-0 farg-1 farg-2) ((foreign-procedure "idrnet_fdopen" (int string) void*) farg-0 farg-1)))
(define NetworkC-45FFI-prim__idrnet_create_sockaddr (lambda (farg-0) ((foreign-procedure "idrnet_create_sockaddr" () void*) )))
(define NetworkC-45FFI-prim__idrnet_bind (lambda (farg-0 farg-1 farg-2 farg-3 farg-4 farg-5) ((foreign-procedure "idrnet_bind" (int int int string int) int) farg-0 farg-1 farg-2 farg-3 farg-4)))
(define NetworkC-45FFI-prim__idrnet_accept (lambda (farg-0 farg-1 farg-2) ((foreign-procedure __collect_safe "idrnet_accept" (int void*) int) farg-0 farg-1)))
(define NetworkC-45SocketC-45Data-prim__idrnet_errno (lambda (farg-0) ((foreign-procedure "idrnet_errno" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_unspec (lambda (farg-0) ((foreign-procedure "idrnet_af_unspec" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_unix (lambda (farg-0) ((foreign-procedure "idrnet_af_unix" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_inet6 (lambda (farg-0) ((foreign-procedure "idrnet_af_inet6" () int) )))
(define NetworkC-45SocketC-45Data-prim__idrnet_af_inet (lambda (farg-0) ((foreign-procedure "idrnet_af_inet" () int) )))
(define PreludeC-45Types-u--foldl_Foldable_List (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--foldl_Foldable_List arg-2 ((arg-2 arg-3) e-2) e-3))))))
(define PreludeC-45Types-u--foldMap_Foldable_List (lambda (arg-2 arg-3 ext-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--acc) (lambda (u--elem) (let ((e-1 (car arg-2))) ((e-1 u--acc) (arg-3 u--elem))))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define PreludeC-45Basics-flip (lambda (arg-3 ext-0 ext-1) ((arg-3 ext-1) ext-0)))
(define PreludeC-45Types-u--foldlM_Foldable_List (lambda (arg-3 arg-4 arg-5 ext-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-4 u--b eta-0)))))) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-5))) ext-0)))
(define PreludeC-45Types-u--foldr_Foldable_List (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) ((arg-2 e-2) (PreludeC-45Types-u--foldr_Foldable_List arg-2 arg-3 e-3)))))))
(define PreludeC-45Types-u--null_Foldable_List (lambda (arg-1) (if (null? arg-1) 1 0)))
(define csegen-14 (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldr_Foldable_List u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldl_Foldable_List u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-10911) (PreludeC-45Types-u--null_Foldable_List arg-10911))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldlM_Foldable_List i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-10940) arg-10940)) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-10954) (PreludeC-45Types-u--foldMap_Foldable_List i_con-0 u--f arg-10954))))))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Char (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-17 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-686 arg-689)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-22 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-686 arg-689)))))
(define csegen-23 (lambda (arg-0) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-0 #\:)))
(define csegen-26 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 (vector 0 ))))))
(define AlgebraC-45ZeroOneOmega-rigMult (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 0)(else (cond ((equal? arg-1 0) 0)(else (cond ((equal? arg-0 1) arg-1)(else (cond ((equal? arg-1 1) arg-0)(else 2))))))))))
(define AlgebraC-45ZeroOneOmega-rigPlus (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1)(else (cond ((equal? arg-1 0) arg-0)(else 2))))))
(define csegen-29 (vector (lambda (arg-823) (lambda (arg-826) (AlgebraC-45ZeroOneOmega-rigPlus arg-823 arg-826))) 0 (lambda (arg-835) (lambda (arg-838) (AlgebraC-45ZeroOneOmega-rigMult arg-835 arg-838))) 1))
(define AlgebraC-45Semiring-erased (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) e-2)))
(define csegen-30 (AlgebraC-45Semiring-erased csegen-29))
(define DataC-45List1-forget (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cons e-1 e-2)))))
(define DataC-45List1-reverseOnto (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (DataC-45List1-reverseOnto (cons e-2 (DataC-45List1-forget arg-1)) e-3))))))
(define DataC-45List1-singleton (lambda (arg-1) (cons arg-1 '())))
(define DataC-45List1-reverse (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (DataC-45List1-reverseOnto (DataC-45List1-singleton e-1) e-2)))))
(define DataC-45List-span (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (let ((sc2 (DataC-45List-span arg-1 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (cons e-2 e-5) e-4))))) (else (cons '() (cons e-2 e-3))))))))))
(define DataC-45List-break (lambda (arg-1 arg-2) (DataC-45List-span (lambda (eta-0) (let ((sc0 (arg-1 eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) arg-2)))
(define DataC-45List-split (lambda (arg-1 arg-2) (let ((sc0 (DataC-45List-break arg-1 arg-2))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-3) (DataC-45List1-singleton e-2) (let ((e-7 (cdr e-3))) (cons e-2 (DataC-45List1-forget (DataC-45List-split arg-1 e-7))))))))))
(define PreludeC-45TypesC-45SnocList-C-60C-62C-62 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 (cons e-3 arg-2)))))))
(define PreludeC-45TypesC-45List-mapAppend (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-2 '()) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (PreludeC-45TypesC-45List-mapAppend (cons arg-2 (arg-3 e-1)) arg-3 e-2))))))
(define DataC-45List1-u--map_Functor_List1 (lambda (arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cons (arg-2 e-1) (PreludeC-45TypesC-45List-mapAppend '() arg-2 e-2))))))
(define DataC-45String-split (lambda (arg-0 arg-1) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45List-split arg-0 (PreludeC-45Types-fastUnpack arg-1)))))
(define csegen-520 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\.)))
(define CoreC-45NameC-45Namespace-mkNamespacedIdent (lambda (arg-0) (let ((u--nns (DataC-45List1-reverse (DataC-45String-split csegen-520 arg-0)))) (let ((u--name (let ((e-1 (car u--nns))) e-1))) (let ((u--ns (let ((e-2 (cdr u--nns))) e-2))) (if (null? u--ns) (cons '() u--name) (cons (box u--ns) u--name)))))))
(define PreludeC-45Basics-uncurry (lambda (arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) ((arg-3 e-2) e-3)))))
(define CoreC-45NameC-45Namespace-mkNestedNamespace (lambda (arg-0 arg-1) (if (null? arg-0) (cons arg-1 '()) (let ((e-2 (unbox arg-0))) (cons arg-1 e-2)))))
(define csegen-521 (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Namespace-mkNestedNamespace eta-0 eta-1))))
(define CoreC-45NameC-45Namespace-mkNamespace (lambda (arg-0) (cond ((equal? arg-0 "") '())(else (PreludeC-45Basics-uncurry csegen-521 (CoreC-45NameC-45Namespace-mkNamespacedIdent arg-0))))))
(define CoreC-45NameC-45Namespace-typesNS (CoreC-45NameC-45Namespace-mkNamespace "Prelude.Types"))
(define csegen-31 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "prim__integerToNat"))))
(define CoreC-45NameC-45Namespace-eqOrdNS (CoreC-45NameC-45Namespace-mkNamespace "Prelude.EqOrd"))
(define csegen-32 (vector 0 CoreC-45NameC-45Namespace-eqOrdNS (vector 1 (vector 0 "compareInteger"))))
(define CoreC-45Core-coreFail (lambda (arg-1 ext-0) (vector 0 arg-1)))
(define CoreC-45Core-u--throw_Catchable_Core_Error (lambda (ext-1 ext-0) (CoreC-45Core-coreFail ext-1 ext-0)))
(define CoreC-45BinaryC-45Prims-corrupt (lambda (arg-1 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 2 arg-1)) ext-0)))
(define LibrariesC-45UtilsC-45Binary-incLoc (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector e-0 (+ e-1 arg-0) e-2 e-3)))))))
(define LibrariesC-45UtilsC-45Binary-toRead (lambda (arg-0) (- (let ((e-3 (vector-ref arg-0 3))) e-3) (let ((e-1 (vector-ref arg-0 1))) e-1))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define CoreC-45BinaryC-45Prims-getTag (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-toRead e-5) 1))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (DataC-45Buffer-prim__getBits8 (let ((e-0 (vector-ref e-5 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-5 1))) e-1) 63) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 1 e-5)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) clam-0)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 1 "Bits8")) clam-0))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-getName (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (if (null? arg-1) '() (let ((e-3 (car arg-1))) (box e-3))))(else (let ((e-1 (- arg-0 1))) (if (null? arg-1) '() (let ((e-7 (cdr arg-1))) (CoreC-45TTC-getName e-1 e-7))))))))
(define DataC-45Vect-reverseOnto (lambda (arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (DataC-45Vect-reverseOnto (cons e-3 arg-3) e-4))))))
(define DataC-45Vect-reverse (lambda (ext-0) (DataC-45Vect-reverseOnto '() ext-0)))
(define CoreC-45BinaryC-45Prims-n--11095-8298-u--readElems (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (cond ((equal? arg-6 0) (lambda (eta-0) (vector 1 (DataC-45Vect-reverse arg-5))))(else (let ((e-0 (- arg-6 1))) (lambda (eta-0) (let ((act-1 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) eta-0)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45BinaryC-45Prims-n--11095-8298-u--readElems arg-1 arg-2 arg-3 (cons e-5 arg-5) e-0))) eff-0) eta-0)))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (CoreC-45BinaryC-45Prims-n--11095-8298-u--readElems arg-2 arg-3 arg-1 '() arg-1)))
(define PreludeC-45TypesC-45List-reverseOnto (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45List-reverseOnto (cons e-2 arg-1) e-3))))))
(define PreludeC-45TypesC-45List-reverse (lambda (ext-0) (PreludeC-45TypesC-45List-reverseOnto '() ext-0)))
(define PreludeC-45TypesC-45List-tailRecAppend (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-reverseOnto arg-2 (PreludeC-45TypesC-45List-reverse arg-1))))
(define PreludeC-45Types-prim__integerToNat (lambda (arg-0) (let ((sc0 (or (and (<= 0 arg-0) 1) 0))) (cond ((equal? sc0 0) 0)(else arg-0)))))
(define Builtin-fst (lambda (arg-2) (let ((e-2 (car arg-2))) e-2)))
(define Builtin-snd (lambda (arg-2) (let ((e-3 (cdr arg-2))) e-3)))
(define PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (string-append "(" (string-append (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (e-1 e-2))) (string-append ", " (string-append (let ((sc1 (Builtin-snd arg-2))) (let ((e-1 (car sc1))) (e-1 e-3))) ")"))))))))
(define PreludeC-45Show-firstCharIs (lambda (arg-0 arg-1) (cond ((equal? arg-1 "") 0)(else (arg-0 (string-ref arg-1 0))))))
(define PreludeC-45Show-showParens (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1) (else (string-append "(" (string-append arg-1 ")"))))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define PreludeC-45Show-precCon (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) (else 6))))
(define PreludeC-45EqOrd-u--C-60_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45Show-u--compare_Ord_Prec (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((4) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Integer e-0 e-1)))(else (PreludeC-45EqOrd-u--compare_Ord_Integer (PreludeC-45Show-precCon arg-0) (PreludeC-45Show-precCon arg-1))))))(else (PreludeC-45EqOrd-u--compare_Ord_Integer (PreludeC-45Show-precCon arg-0) (PreludeC-45Show-precCon arg-1))))))
(define PreludeC-45Show-u--C-62C-61_Ord_Prec (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Show-u--compare_Ord_Prec arg-0 arg-1) 0)))
(define csegen-147 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\-)))
(define PreludeC-45Show-primNumShow (lambda (arg-1 arg-2 arg-3) (let ((u--str (arg-1 arg-3))) (PreludeC-45Show-showParens (let ((sc0 (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 5 )))) (cond ((equal? sc0 1) (PreludeC-45Show-firstCharIs csegen-147 u--str)) (else 0))) u--str))))
(define PreludeC-45Show-u--showPrec_Show_Integer (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Integer (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Integer (vector 0 ) arg-0)))
(define csegen-1054 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Integer u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Integer u--d u--x)))))
(define csegen-1608 (cons csegen-1054 csegen-1054))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 255) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-toRead e-6) 8))) (cond ((equal? sc3 1) (let ((act-3 (let ((act-3 (DataC-45Buffer-prim__getInt (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) clam-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 8 e-6)))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) clam-1)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 1 (string-append "Int " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1608 (cons (let ((e-1 (vector-ref e-6 1))) e-1) (let ((e-2 (vector-ref e-6 2))) e-2)))))) clam-1))))))) eff-0) clam-0))))))(else (vector 1 (bs- e-5 (blodwen-toSignedInt 127 63) 63))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-n--10851-8068-u--readElems (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-4 0) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-reverse arg-3))))(else (let ((e-0 (- arg-4 1))) (lambda (eta-0) (let ((act-1 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) eta-0)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45BinaryC-45Prims-n--10851-8068-u--readElems arg-1 arg-2 (cons e-5 arg-3) e-0))) eff-0) eta-0)))))))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45BinaryC-45Prims-n--10851-8068-u--readElems arg-1 arg-2 '() (PreludeC-45Types-prim__integerToNat e-5)))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 '())) ((equal? e-5 1) (let ((act-2 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) clam-0)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "Maybe" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-fromLimbs (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (+ e-2 (blodwen-shl (CoreC-45BinaryC-45Prims-fromLimbs e-3) 32)))))))
(define LibrariesC-45UtilsC-45Binary-appended (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector e-0 (+ e-1 arg-0) e-2 (+ e-3 arg-0))))))))
(define LibrariesC-45UtilsC-45Binary-avail (lambda (arg-0) (- (- (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-1 (vector-ref arg-0 1))) e-1)) 1)))
(define DataC-45Buffer-copyData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (DataC-45Buffer-prim__copyData arg-2 arg-3 arg-4 arg-5 arg-6 eta-0))))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define DataC-45Buffer-newBuffer (lambda (arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-2 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (DataC-45Buffer-prim__newBuffer arg-2 eta-0))))) (lambda (u--buf) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (box u--buf)))))))))) (else (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '())))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define DataC-45Buffer-resizeBuffer (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (DataC-45Buffer-newBuffer arg-1 arg-3)) (lambda (_-0) (if (null? _-0) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '())))) (let ((e-6 (unbox _-0))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (DataC-45Buffer-prim__bufferSize arg-2)))))) (lambda (u--oldsize) (let ((u--len (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-3 u--oldsize))) (cond ((equal? sc3 1) arg-3) (else u--oldsize))))) (let ((e-13 (car arg-1))) (let ((e-15 (vector-ref e-13 1))) ((((e-15 'erased) 'erased) (DataC-45Buffer-copyData arg-1 arg-2 0 u--len e-6 0)) (lambda (_-10649) (let ((e-18 (car arg-1))) (let ((e-21 (vector-ref e-18 0))) (let ((e-23 (vector-ref e-21 1))) ((e-23 'erased) (box e-6))))))))))))))))))))))
(define PreludeC-45IO-u--map_Functor_IO (lambda (arg-2 arg-3 ext-0) (let ((act-2 (arg-3 ext-0))) (arg-2 act-2))))
(define csegen-75 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO u--func arg-8885 eta-0)))))) (lambda (u--a) (lambda (arg-9931) (lambda (eta-0) arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (lambda (world-4) (let ((act-5 (arg-9937 world-4))) (let ((act-3 (arg-9944 world-4))) (act-5 act-3))))))))))
(define csegen-81 (vector csegen-75 (lambda (u--b) (lambda (u--a) (lambda (arg-10411) (lambda (arg-10414) (lambda (world-0) (let ((act-1 (arg-10411 world-0))) ((arg-10414 act-1) world-0))))))) (lambda (u--a) (lambda (arg-10425) (lambda (world-0) (let ((act-1 (arg-10425 world-0))) (act-1 world-0)))))))
(define csegen-82 (cons csegen-81 (lambda (u--a) (lambda (arg-13095) arg-13095))))
(define CoreC-45BinaryC-45Prims-extendBinary (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((u--newsize (* e-2 2))) (let ((u--sC-39 (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer (- u--newsize e-1) arg-0))) (cond ((equal? sc0 1) (+ u--newsize arg-0)) (else u--newsize))))) (lambda (eta-0) (let ((act-1 (let ((act-1 ((DataC-45Buffer-resizeBuffer csegen-82 e-0 (blodwen-toSignedInt u--sC-39 63)) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Buffer expansion failed") clam-0) (let ((e-4 (unbox e-5))) (vector 1 (vector e-4 e-1 u--sC-39 e-3))))))) eff-0) eta-0))))))))))))))
(define CoreC-45BinaryC-45Prims-tag (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-avail e-5) 1))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (DataC-45Buffer-prim__setBits8 (let ((e-0 (vector-ref e-5 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-5 1))) e-1) 63) (blodwen-toUnsignedInt arg-1 8) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 1 e-5)))) (vector 1 act-3)))))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-extendBinary 1 e-5) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (DataC-45Buffer-prim__setBits8 (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) (blodwen-toUnsignedInt arg-1 8) eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 1 e-6)))) (vector 1 act-4)))))))) eff-0) clam-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int (lambda (arg-0 arg-1) (lambda (clam-0) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-1 (blodwen-toSignedInt -127 63)))) (cond ((equal? sc1 1) (PreludeC-45EqOrd-u--C-60_Ord_Int arg-1 (blodwen-toSignedInt 128 63))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45BinaryC-45Prims-tag arg-0 (bs+ arg-1 (blodwen-toSignedInt 127 63) 63) clam-0)) (else (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 (blodwen-toSignedInt 255 63) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-avail e-6) 8))) (cond ((equal? sc3 1) (let ((act-3 (let ((act-3 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) arg-1 clam-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-6)))) (vector 1 act-4)))))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-extendBinary 8 e-6) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (let ((act-4 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-7 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-7 1))) e-1) 63) arg-1 eta-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-7)))) (vector 1 act-5)))))))) eff-0) clam-1))))))))))) eff-0) clam-0))))))))))))))
(define csegen-1562 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-5542 eta-0)))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1562 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (- 0 (CoreC-45BinaryC-45Prims-fromLimbs e-6)))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1562 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45BinaryC-45Prims-fromLimbs e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "Integer" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-prim__integerToNat e-5))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_ConInfo (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (vector 1 (vector 3 ))) ((equal? e-5 4) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 e-6))))) eff-0) clam-0)))))) ((equal? e-5 5) (vector 1 (vector 5 ))) ((equal? e-5 6) (vector 1 (vector 6 ))) ((equal? e-5 7) (vector 1 (vector 7 ))) ((equal? e-5 8) (vector 1 (vector 8 ))) ((equal? e-5 9) (vector 1 (vector 9 ))) ((equal? e-5 10) (vector 1 (vector 10 )))(else (CoreC-45BinaryC-45Prims-corrupt "ConInfo" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 ext-0) (let ((act-1 (let ((sc0 (Builtin-fst arg-2))) (let ((e-2 (cdr sc0))) ((e-2 arg-3) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (Builtin-snd arg-2))) (let ((e-2 (cdr sc1))) ((e-2 arg-3) eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--len e-5)) (lambda (eta-1) (let ((act-3 (let ((sc2 (PreludeC-45EqOrd-u--C-60_Ord_Integer u--len 0))) (cond ((equal? sc2 1) (CoreC-45BinaryC-45Prims-corrupt "String" eta-1)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-toRead e-6) u--len))) (cond ((equal? sc3 1) (let ((act-4 (let ((act-4 (DataC-45Buffer-prim__getString (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) e-5 eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc u--len e-6)))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-8))))))) eff-0) eta-1)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 1 (string-append "String length " (string-append (PreludeC-45Show-u--show_Show_Integer u--len) (string-append " at " (PreludeC-45Show-u--show_Show_Integer (let ((e-1 (vector-ref e-6 1))) e-1))))))) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_String (lambda (arg-0 arg-1) (let ((u--ireq (DataC-45Buffer-stringByteLength arg-1))) (let ((u--req u--ireq)) (lambda (eta-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 u--ireq) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-avail e-6) u--req))) (cond ((equal? sc2 1) (let ((act-3 (let ((act-3 (DataC-45Buffer-prim__setString (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) arg-1 clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--req e-6)))) (vector 1 act-4)))))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-extendBinary u--req e-6) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (DataC-45Buffer-prim__setString (let ((e-0 (vector-ref e-7 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-7 1))) e-1) 63) arg-1 eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--req e-7)))) (vector 1 act-5)))))))) eff-0) clam-0))))))))))) eff-0) eta-0)))))))))))))
(define csegen-1559 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-5542 eta-0)))))
(define csegen-1603 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 e-5))))))
(define CoreC-45TTC-u--fromBuf_TTC_Namespace (lambda (ext-0 ext-1) (PreludeC-45IO-u--map_Functor_IO csegen-1603 (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 ext-0 eta-0)) ext-1)))
(define csegen-1563 (cons csegen-1562 csegen-1562))
(define CoreC-45TTC-u--fromBuf_TTC_Name (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 (vector 0 e-6)))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 (vector 1 e-6)))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 9) (vector 1 (vector 1 (vector 2 ))))(else (CoreC-45BinaryC-45Prims-corrupt "Name" clam-0)))))) eff-0) ext-0)))))))
(define PreludeC-45Show-u--showPrec_Show_Int (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Int (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int (vector 0 ) arg-0)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (((e-1 arg-3) e-2) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((sc2 (Builtin-snd arg-2))) (let ((e-1 (car sc2))) (((e-1 arg-3) e-3) ext-0))))))))))
(define CoreC-45Core-traverse_ (lambda (arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((eff-0 (let ((eff-0 (arg-2 e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((let ((eff-1 (CoreC-45Core-traverse_ arg-2 e-3))) eff-1) world-0)))))))))))
(define CoreC-45BinaryC-45Prims-n--10833-8023-u--length_aux (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-3 (cdr arg-4))) (CoreC-45BinaryC-45Prims-n--10833-8023-u--length_aux arg-1 arg-2 arg-3 e-3 (bs+ arg-5 1 63))))))
(define CoreC-45BinaryC-45Prims-n--10833-8022-u--TailRec_length (lambda (arg-1 arg-2 arg-3 arg-4) (CoreC-45BinaryC-45Prims-n--10833-8023-u--length_aux arg-1 arg-2 arg-3 arg-4 0)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-2 (CoreC-45BinaryC-45Prims-n--10833-8022-u--TailRec_length arg-1 arg-3 arg-2 arg-3)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (clam-0) (let ((e-1 (car arg-1))) ((e-1 arg-2) clam-0))) arg-3) ext-0))))))
(define CoreC-45TTC-u--toBuf_TTC_Namespace (lambda (arg-0 ext-0 ext-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 ext-0 ext-1)))
(define CoreC-45TTC-u--toBuf_TTC_Name (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_Namespace arg-0 e-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-1) clam-0)))))))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-16 (vector-ref e-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-16) clam-0)))))) ((1) (let ((e-17 (vector-ref e-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-17) clam-0)))))) (else (CoreC-45BinaryC-45Prims-tag arg-0 9 clam-0))))) ((2) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-3) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-4) clam-0)))))))))) ((3) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-5) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-6) clam-0)))))))))) ((4) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-7) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-8) clam-0)))))))))) ((5) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 e-9 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-10) clam-0)))))))))) ((6) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-11) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-12) clam-0)))))))))) ((7) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-13) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-14) clam-0)))))))))) (else (let ((e-15 (vector-ref arg-1 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't write resolved name " (PreludeC-45Show-u--show_Show_Int e-15))) clam-0)))))))
(define csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_Name arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Name arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CConAltC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_ConInfo arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1562 arg-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-1 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-0) arg-1 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits16 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toUnsignedInt e-5 16)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits32 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toUnsignedInt e-5 32)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits64 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toUnsignedInt e-5 64)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits8 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toUnsignedInt e-5 8)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Char (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cast-int-char e-5))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Double (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-toRead e-5) 8))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (DataC-45Buffer-prim__getDouble (let ((e-0 (vector-ref e-5 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-5 1))) e-1) 63) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 8 e-5)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) clam-0)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 1 "Double")) clam-0))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int16 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toSignedInt e-5 15)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int32 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toSignedInt e-5 31)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int64 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toSignedInt e-5 63)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 eta-0)) ext-0)))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int8 (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (blodwen-toSignedInt e-5 7)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0)) ext-0)))
(define CoreC-45TTC-u--fromBuf_TTC_PrimType (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2)) ((equal? e-5 3) (vector 1 3)) ((equal? e-5 4) (vector 1 4)) ((equal? e-5 5) (vector 1 5)) ((equal? e-5 6) (vector 1 6)) ((equal? e-5 7) (vector 1 7)) ((equal? e-5 8) (vector 1 8)) ((equal? e-5 9) (vector 1 9)) ((equal? e-5 10) (vector 1 10)) ((equal? e-5 11) (vector 1 11)) ((equal? e-5 12) (vector 1 12)) ((equal? e-5 13) (vector 1 13))(else (CoreC-45BinaryC-45Prims-corrupt "PrimType" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_Constant (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-6))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int8 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int16 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int32 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-6))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int64 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 e-6))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-6))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits8 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-6))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits16 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-6))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits32 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-6))))) eff-0) clam-0)))))) ((equal? e-5 9) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bits64 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-6))))) eff-0) clam-0)))))) ((equal? e-5 10) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-6))))) eff-0) clam-0)))))) ((equal? e-5 11) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Char arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-6))))) eff-0) clam-0)))))) ((equal? e-5 12) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Double arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 12 e-6))))) eff-0) clam-0)))))) ((equal? e-5 13) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-6))))) eff-0) clam-0)))))) ((equal? e-5 14) (vector 1 (vector 14 )))(else (CoreC-45BinaryC-45Prims-corrupt "Constant" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CConstAltC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-n--14837-8227-u--fromBuf1 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 5) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-6))))) eff-0) clam-0)))))) ((equal? e-5 11) (vector 1 (vector 16 ))) ((equal? e-5 12) (vector 1 (vector 17 ))) ((equal? e-5 13) (vector 1 (vector 18 ))) ((equal? e-5 17) (vector 1 (vector 22 ))) ((equal? e-5 19) (vector 1 (vector 24 ))) ((equal? e-5 20) (vector 1 (vector 25 ))) ((equal? e-5 22) (vector 1 (vector 27 ))) ((equal? e-5 23) (vector 1 (vector 28 ))) ((equal? e-5 24) (vector 1 (vector 29 ))) ((equal? e-5 25) (vector 1 (vector 30 ))) ((equal? e-5 26) (vector 1 (vector 31 ))) ((equal? e-5 27) (vector 1 (vector 32 ))) ((equal? e-5 32) (vector 1 (vector 33 ))) ((equal? e-5 33) (vector 1 (vector 34 ))) ((equal? e-5 34) (vector 1 (vector 35 ))) ((equal? e-5 99) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 36 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn 1" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-n--14837-8228-u--fromBuf2 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-6))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-6))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 e-6))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-6))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 12 e-6))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-6))))) eff-0) clam-0)))))) ((equal? e-5 9) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 14 e-6))))) eff-0) clam-0)))))) ((equal? e-5 10) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 15 e-6))))) eff-0) clam-0)))))) ((equal? e-5 14) (vector 1 (vector 19 ))) ((equal? e-5 15) (vector 1 (vector 20 ))) ((equal? e-5 16) (vector 1 (vector 21 ))) ((equal? e-5 21) (vector 1 (vector 26 ))) ((equal? e-5 35) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-6))))) eff-0) clam-0)))))) ((equal? e-5 36) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-6))))) eff-0) clam-0)))))) ((equal? e-5 37) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-6))))) eff-0) clam-0)))))) ((equal? e-5 38) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-6))))) eff-0) clam-0)))))) ((equal? e-5 39) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PrimType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-6))))) eff-0) clam-0)))))) ((equal? e-5 101) (vector 1 (vector 38 )))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn 2" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-n--14837-8229-u--fromBuf3 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 18) (vector 1 (vector 23 ))) ((equal? e-5 100) (vector 1 (vector 37 )))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn 3" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40PrimFnC-32C-36nC-41 (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (lambda (eta-0) (CoreC-45BinaryC-45Prims-corrupt "PrimFn" eta-0)))(else (let ((e-0 (- arg-0 1))) (cond ((equal? e-0 0) (lambda (eta-0) (CoreC-45TTC-n--14837-8227-u--fromBuf1 arg-1 arg-0 eta-0)))(else (let ((e-1 (- e-0 1))) (cond ((equal? e-1 0) (lambda (eta-0) (CoreC-45TTC-n--14837-8228-u--fromBuf2 arg-1 arg-0 eta-0)))(else (let ((e-2 (- e-1 1))) (lambda (clam-0) (cond ((equal? e-2 0) (CoreC-45TTC-n--14837-8229-u--fromBuf3 arg-1 arg-0 clam-0))(else (CoreC-45BinaryC-45Prims-corrupt "PrimFn" clam-0)))))))))))))))
(define CoreC-45Core-C-60C-42C-62 (lambda (arg-2 arg-3 ext-0) (let ((act-5 (let ((act-5 (lambda (eta-0) (lambda (eta-1) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (case (vector-ref eta-1 0) ((1) (let ((e-8 (vector-ref eta-1 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref eta-1 1))) (vector 0 e-11))))))))))) (let ((act-3 (arg-2 ext-0))) (act-5 act-3))))) (let ((act-3 (arg-3 ext-0))) (act-5 act-3)))))
(define CoreC-45TTC-u--fromBuf_TTC_ModuleIdent (lambda (ext-0 ext-1) (PreludeC-45IO-u--map_Functor_IO csegen-1603 (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 ext-0 eta-0)) ext-1)))
(define CoreC-45TTC-u--fromBuf_TTC_VirtualIdent (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 )))(else (CoreC-45BinaryC-45Prims-corrupt "VirtualIdent" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_OriginDesc (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 0 eta-1)))) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_ModuleIdent arg-0 eta-0)) clam-0)) ((equal? e-5 1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 1 eta-1)))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 eta-0)) clam-0)) ((equal? e-5 2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 2 eta-1)))) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_VirtualIdent arg-0 eta-0)) clam-0))(else (CoreC-45BinaryC-45Prims-corrupt "OriginDesc" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_FC (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (vector 1 (vector 2 ))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "FC" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1))(else (CoreC-45BinaryC-45Prims-corrupt "Bool" clam-0)))))) eff-0) ext-0)))))))
(define csegen-1604 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cond ((equal? e-5 1) 0) (else 1))))))))
(define CoreC-45TTC-u--fromBuf_TTC_InlineOk (lambda (ext-0 ext-1) (PreludeC-45IO-u--map_Functor_IO csegen-1604 (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool ext-0 eta-0)) ext-1)))
(define CoreC-45TTC-u--fromBuf_TTC_LazyReason (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "LazyReason" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-n--11074-8266-u--writeAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 ext-0) (if (null? arg-6) (vector 1 (vector 0 )) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (let ((act-1 (let ((e-1 (car arg-2))) (((e-1 arg-4) e-3) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-n--11074-8266-u--writeAll arg-1 arg-2 arg-3 arg-4 e-4 ext-0)))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (eta-0) (CoreC-45BinaryC-45Prims-n--11074-8266-u--writeAll arg-1 arg-2 arg-4 arg-3 arg-4 eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits16 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 arg-1)))
(define CoreC-45BinaryC-45Prims-toLimbs (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 0))) (cond ((equal? sc0 1) '()) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 -1))) (cond ((equal? sc1 1) (cons -1 '())) (else (cons (blodwen-toSignedInt (blodwen-and arg-0 4294967295) 63) (CoreC-45BinaryC-45Prims-toLimbs (blodwen-shr arg-0 32)))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer (lambda (arg-0 arg-1 ext-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-1 0))) (cond ((equal? sc0 1) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1562 arg-0 (CoreC-45BinaryC-45Prims-toLimbs (- 0 arg-1)) ext-0))))) (else (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1562 arg-0 (CoreC-45BinaryC-45Prims-toLimbs arg-1) ext-0)))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits32 (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 arg-1 eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits64 (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 arg-1 eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits8 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 arg-1)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Char (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (cast-char-boundedInt arg-1 63))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Double (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-avail e-5) 8))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (DataC-45Buffer-prim__setDouble (let ((e-0 (vector-ref e-5 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-5 1))) e-1) 63) arg-1 clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-5)))) (vector 1 act-3)))))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-extendBinary 8 e-5) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (DataC-45Buffer-prim__setDouble (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) arg-1 eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-6)))) (vector 1 act-4)))))))) eff-0) clam-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int16 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 arg-1)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int32 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 arg-1)))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int64 (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 arg-1 eta-0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int8 (lambda (arg-0 arg-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 arg-1)))
(define CoreC-45TTC-u--toBuf_TTC_PrimType (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((equal? arg-1 2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((equal? arg-1 3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((equal? arg-1 4) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((equal? arg-1 5) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((equal? arg-1 6) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((equal? arg-1 7) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((equal? arg-1 8) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((equal? arg-1 9) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((equal? arg-1 10) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) ((equal? arg-1 11) (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0)) ((equal? arg-1 12) (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 13 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_Constant (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-0) ext-0)))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int8 arg-0 e-1) ext-0)))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int16 arg-0 e-2) ext-0)))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int32 arg-0 e-3) ext-0)))))) ((4) (let ((e-4 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int64 arg-0 e-4) ext-0)))))) ((5) (let ((e-5 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 e-5 ext-0)))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits8 arg-0 e-6) ext-0)))))) ((7) (let ((e-7 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits16 arg-0 e-7) ext-0)))))) ((8) (let ((e-8 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits32 arg-0 e-8) ext-0)))))) ((9) (let ((e-9 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bits64 arg-0 e-9) ext-0)))))) ((10) (let ((e-10 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-10) ext-0)))))) ((11) (let ((e-11 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Char arg-0 e-11) ext-0)))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Double arg-0 e-12 ext-0)))))) ((13) (let ((e-13 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-0 e-13 ext-0)))))) (else (CoreC-45BinaryC-45Prims-tag arg-0 14 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CConstAltC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-2 ext-0))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (CoreC-45BinaryC-45Prims-tag arg-2 0 clam-0) (let ((e-2 (unbox arg-3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-2 1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-1 (car arg-1))) (((e-1 arg-2) e-2) clam-0))))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40PrimFnC-32C-36nC-41 (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-0 (- arg-0 1))) (cond ((equal? e-0 0) (lambda (clam-0) (case (vector-ref arg-2 0) ((5) (let ((e-18 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-18 clam-0)))))) ((16) (CoreC-45BinaryC-45Prims-tag arg-1 11 clam-0)) ((17) (CoreC-45BinaryC-45Prims-tag arg-1 12 clam-0)) ((18) (CoreC-45BinaryC-45Prims-tag arg-1 13 clam-0)) ((22) (CoreC-45BinaryC-45Prims-tag arg-1 17 clam-0)) ((24) (CoreC-45BinaryC-45Prims-tag arg-1 19 clam-0)) ((25) (CoreC-45BinaryC-45Prims-tag arg-1 20 clam-0)) ((27) (CoreC-45BinaryC-45Prims-tag arg-1 22 clam-0)) ((28) (CoreC-45BinaryC-45Prims-tag arg-1 23 clam-0)) ((29) (CoreC-45BinaryC-45Prims-tag arg-1 24 clam-0)) ((30) (CoreC-45BinaryC-45Prims-tag arg-1 25 clam-0)) ((31) (CoreC-45BinaryC-45Prims-tag arg-1 26 clam-0)) ((32) (CoreC-45BinaryC-45Prims-tag arg-1 27 clam-0)) ((33) (CoreC-45BinaryC-45Prims-tag arg-1 32 clam-0)) ((34) (CoreC-45BinaryC-45Prims-tag arg-1 33 clam-0)) ((35) (CoreC-45BinaryC-45Prims-tag arg-1 34 clam-0)) (else (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 99 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-19 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-20 clam-0)))))))))))))(else (let ((e-1 (- e-0 1))) (cond ((equal? e-1 0) (lambda (clam-1) (case (vector-ref arg-2 0) ((0) (let ((e-3 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 0 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-3 clam-1)))))) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 1 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-4 clam-1)))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 2 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-5 clam-1)))))) ((3) (let ((e-6 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 3 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-6 clam-1)))))) ((4) (let ((e-7 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 4 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-7 clam-1)))))) ((6) (let ((e-8 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 35 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-8 clam-1)))))) ((7) (let ((e-9 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 36 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-9 clam-1)))))) ((8) (let ((e-10 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 37 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-10 clam-1)))))) ((9) (let ((e-11 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 38 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-11 clam-1)))))) ((10) (let ((e-12 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 39 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-12 clam-1)))))) ((11) (let ((e-13 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 6 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-13 clam-1)))))) ((12) (let ((e-14 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 7 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-14 clam-1)))))) ((13) (let ((e-15 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 8 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-15 clam-1)))))) ((14) (let ((e-16 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 9 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-16 clam-1)))))) ((15) (let ((e-17 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 10 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PrimType arg-1 e-17 clam-1)))))) ((19) (CoreC-45BinaryC-45Prims-tag arg-1 14 clam-1)) ((20) (CoreC-45BinaryC-45Prims-tag arg-1 15 clam-1)) ((21) (CoreC-45BinaryC-45Prims-tag arg-1 16 clam-1)) ((26) (CoreC-45BinaryC-45Prims-tag arg-1 21 clam-1)) (else (CoreC-45BinaryC-45Prims-tag arg-1 (blodwen-toSignedInt 101 63) clam-1)))))(else (let ((e-2 (- e-1 1))) (cond ((equal? e-2 0) (lambda (clam-2) (case (vector-ref arg-2 0) ((23) (CoreC-45BinaryC-45Prims-tag arg-1 18 clam-2)) (else (CoreC-45BinaryC-45Prims-tag arg-1 (blodwen-toSignedInt 100 63) clam-2)))))(else (blodwen-error-quit "Nat case not covered"))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat (lambda (arg-0 arg-1) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 arg-1 eta-0))))
(define CoreC-45TTC-u--toBuf_TTC_ConInfo (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((4) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-0) ext-0)))))) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((7) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((8) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((9) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_ModuleIdent (lambda (arg-0 ext-0 ext-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 ext-0 ext-1)))
(define CoreC-45TTC-u--toBuf_TTC_VirtualIdent (lambda (arg-0 arg-1 ext-0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)))
(define CoreC-45TTC-u--toBuf_TTC_OriginDesc (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_ModuleIdent arg-0 e-0 ext-0)))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-1) ext-0)))))) (else (let ((e-2 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_VirtualIdent arg-0 e-2 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_FC (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-0 e-0 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 e-1 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 e-2 ext-0)))))))))))))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-0 e-3 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 e-4 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-0 e-5 ext-0)))))))))))))) (else (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)))))
(define CoreC-45CompileExpr-u--C-61C-61_Eq_InlineOk (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool (lambda (arg-0 arg-1) (lambda (clam-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 clam-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 1 clam-0))))))
(define CoreC-45TTC-u--toBuf_TTC_InlineOk (lambda (arg-0 ext-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (CoreC-45CompileExpr-u--C-61C-61_Eq_InlineOk 0 ext-0))))
(define CoreC-45TTC-u--toBuf_TTC_LazyReason (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-3 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-2) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-6 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-7) ext-0)))))))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-9 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-10) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-10 arg-0) arg-1 e-11 ext-0)))))))))))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-15 (vector-ref arg-2 3))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-13 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-14) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_InlineOk arg-1 e-15) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-16 ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-14 arg-0) arg-1 e-17 ext-0)))))))))))))))))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-19 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-20 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-21 ext-0)))))))))))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-23 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-24) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_ConInfo arg-1 e-25 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1562 arg-1 e-26) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-27 ext-0)))))))))))))))))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-30 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-29) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_C-40PrimFnC-32C-36nC-41 e-29 arg-1 e-31) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 e-29 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-32) ext-0)))))))))))))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-34 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-35) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-36 ext-0)))))))))))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-38 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-39 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-40 ext-0)))))))))))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-42 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-43 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-44 ext-0)))))))))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-46 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-47 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-48 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-49) ext-0)))))))))))))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-51 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 e-52 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-53 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-54) ext-0)))))))))))))))))) ((12) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 12 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-56 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-57 ext-0)))))))))) ((13) (let ((e-59 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-59 ext-0)))))) (else (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-1 e-61 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-1 e-62) ext-0)))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CConAltC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_ConInfo arg-1 e-2 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1562 arg-1 e-3) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-1 e-4 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-1 e-5 ext-0))))))))))))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc4 (CoreC-45TTC-getName e-7 arg-0))) (if (null? sc4) (CoreC-45BinaryC-45Prims-corrupt "CExp" clam-1) (vector 1 (vector 0 e-7 e-6))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-7 arg-0) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_InlineOk arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 (cons e-7 arg-0) arg-1 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 3 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-2) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-2)))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-2)))) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_ConInfo arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1562 arg-1 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-4) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-4)))) (lambda (arg-5542) (lambda (eta-4) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-4)))) arg-1 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 5 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45TTC-u--fromBuf_TTC_C-40PrimFnC-32C-36nC-41 e-7 arg-1) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 e-7 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-3) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-3)))) (lambda (arg-5542) (lambda (eta-3) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-3)))) arg-1) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 6 e-7 e-6 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-2) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-2)))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-2)))) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 7 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 9) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 10) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-2) (CoreC-45TTC-u--toBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-2)))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40CConAltC-32C-36varsC-41 arg-0 arg-5542 eta-2)))) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-3) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-3)))) (lambda (arg-5542) (lambda (eta-3) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-3)))) arg-1 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 10 e-6 e-7 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 11) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-2) (CoreC-45TTC-u--toBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-2)))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40CConstAltC-32C-36varsC-41 arg-0 arg-5542 eta-2)))) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-3) (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-3)))) (lambda (arg-5542) (lambda (eta-3) (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 arg-0 arg-5542 eta-3)))) arg-1 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 11 e-6 e-7 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 12) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 12 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 13) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-6))))) eff-0) clam-0)))))) ((equal? e-5 14) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 14 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "CExp" clam-0)))))) eff-0) ext-0)))))))
(define csegen-1594 (lambda () (cons csegen-1559 (csegen-1593))))
(define csegen-1597 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1594) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1594) arg-5542 eta-0))))))
(define CoreC-45TTC-u--toBuf_TTC_CFType (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((7) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((8) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((9) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((10) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((11) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((12) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((13) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((14) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((18) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) ((19) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-0 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-1 ext-0)))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-2 ext-0)))))) ((21) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-3) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1597) arg-0 e-4 ext-0)))))))))) ((22) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-5) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1593) arg-0 e-6 ext-0)))))))))) ((15) (CoreC-45BinaryC-45Prims-tag arg-0 15 ext-0)) ((16) (CoreC-45BinaryC-45Prims-tag arg-0 16 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 17 ext-0)) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 18 ext-0)) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 19 ext-0)) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 20 ext-0)) ((17) (CoreC-45BinaryC-45Prims-tag arg-0 21 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 22 ext-0)))))
(define csegen-1593 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_CFType arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_CFType arg-5542 eta-0))))))
(define CoreC-45TTC-u--fromBuf_TTC_CFType (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 7 ))) ((equal? e-5 3) (vector 1 (vector 8 ))) ((equal? e-5 4) (vector 1 (vector 9 ))) ((equal? e-5 5) (vector 1 (vector 10 ))) ((equal? e-5 6) (vector 1 (vector 11 ))) ((equal? e-5 7) (vector 1 (vector 12 ))) ((equal? e-5 8) (vector 1 (vector 13 ))) ((equal? e-5 9) (vector 1 (vector 14 ))) ((equal? e-5 10) (vector 1 (vector 18 ))) ((equal? e-5 11) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 19 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 12) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 20 e-6))))) eff-0) clam-0)))))) ((equal? e-5 13) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1597) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 21 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 14) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1593) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 22 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 15) (vector 1 (vector 15 ))) ((equal? e-5 16) (vector 1 (vector 16 ))) ((equal? e-5 17) (vector 1 (vector 3 ))) ((equal? e-5 18) (vector 1 (vector 4 ))) ((equal? e-5 19) (vector 1 (vector 5 ))) ((equal? e-5 20) (vector 1 (vector 6 ))) ((equal? e-5 21) (vector 1 (vector 17 ))) ((equal? e-5 22) (vector 1 (vector 2 )))(else (CoreC-45BinaryC-45Prims-corrupt "CFType" clam-0)))))) eff-0) ext-0)))))))
(define csegen-1535 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_CDef (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 e-6 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1562 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1535 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1593) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_CFType arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40CExpC-32C-36varsC-41 '() arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "CDef" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_CDef (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-0 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 e-0 arg-0 e-1 ext-0)))))))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1562 arg-0 e-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-3) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1535 arg-0 e-4) ext-0)))))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 e-5 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-1593) arg-0 e-6 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_CFType arg-0 e-7 ext-0)))))))))))))) (else (let ((e-8 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CExpC-32C-36varsC-41 '() arg-0 e-8 ext-0)))))))))
(define csegen-38 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_CDef arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_CDef arg-5542 eta-0)))))
(define csegen-44 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-5542 eta-0)))))
(define csegen-45 (cons csegen-41 csegen-44))
(define csegen-48 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-45 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-45 arg-5542 eta-0)))))
(define csegen-51 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-48 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-48 arg-5542 eta-0)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define LibrariesC-45DataC-45IntMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-10)) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45IntMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45IntMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45IntMap-treeLookup arg-1 e-3)))))
(define CoreC-45Context-getContent (lambda (ext-0) (let ((e-4 (vector-ref ext-0 4))) e-4)))
(define DataC-45IORef-newIORef (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (box arg-3))))) (lambda (u--m) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) u--m))))))))))
(define CoreC-45Core-newRef (lambda (arg-2 arg-3) (let ((eff-0 (lambda (world-0) (let ((act-1 ((DataC-45IORef-newIORef csegen-82 arg-3) world-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (eta-0) (vector 1 e-5)))) eff-1) world-0)))))))))
(define LibrariesC-45DataC-45IOArray-max (lambda (ext-0) (let ((e-1 (car ext-0))) e-1)))
(define LibrariesC-45DataC-45IOArray-writeArray (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-4 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-4 (LibrariesC-45DataC-45IOArray-max arg-3))))))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 0 )))))) (else (let ((e-2 (cdr arg-2))) ((e-2 'erased) (lambda (eta-0) (vector-set! (let ((e-3 (cdr arg-3))) e-3) arg-4 (box arg-5))))))))))
(define LibrariesC-45DataC-45NameMap-empty '())
(define CoreC-45Name-nameTag (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 6) ((6) 7) ((7) 8) (else 9))))
(define PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car arg-5))) (let ((e-7 (cdr arg-5))) (let ((sc2 (let ((e-1 (vector-ref arg-2 0))) (let ((e-13 (cdr e-1))) ((e-13 e-2) e-6))))) (cond ((equal? sc2 1) (let ((e-12 (vector-ref arg-2 1))) ((e-12 e-2) e-6))) (else (let ((e-12 (vector-ref arg-3 1))) ((e-12 e-3) e-7)))))))))))
(define PreludeC-45EqOrd-u--compare_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45Types-case--compare-6807 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-3 arg-5))(else arg-6))))
(define PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? arg-3) 2 (let ((e-10 (car arg-3))) (let ((e-11 (cdr arg-3))) (PreludeC-45Types-case--compare-6807 arg-1 e-2 e-3 e-10 e-11 (let ((e-12 (vector-ref arg-1 1))) ((e-12 e-2) e-10)))))))))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string<=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string<? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string>=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (or (and (string>? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_String arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--max_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_String arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_String (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_String arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-519 (vector csegen-22 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_String arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_String arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_String arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_String arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_String arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_String arg-1626 arg-1629)))))
(define CoreC-45NameC-45Namespace-u--compare_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-0 arg-1)))
(define CoreC-45Name-usernameTag (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 2) (else 3))))
(define CoreC-45Name-u--compare_Ord_UserName (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_String e-0 e-2)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1)))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-3 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_String e-1 e-3)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1)))))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1)))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-usernameTag arg-0) (CoreC-45Name-usernameTag arg-1))))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--max_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Int arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-223 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int arg-686 arg-689)))))
(define csegen-231 (vector csegen-223 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_Int arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_Int arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_Int arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_Int arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_Int arg-1626 arg-1629)))))
(define CoreC-45Name-u--compare_Ord_Name (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--compare_Ord_Name e-1 e-17))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace e-0 e-16)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-18 (vector-ref arg-1 1))) (CoreC-45Name-u--compare_Ord_UserName e-2 e-18)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1)))))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-4 e-20))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_String e-3 e-19)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((3) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-6 e-22))) (cond ((equal? sc2 1) (CoreC-45Name-u--compare_Ord_Name e-5 e-21)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((4) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((4) (let ((e-24 (vector-ref arg-1 2))) (CoreC-45Name-u--compare_Ord_Name e-8 e-24)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1)))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((5) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--compare_Ord_Name e-10 e-26))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 e-9 e-25)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-12 e-28))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_String e-11 e-27)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-14 e-30))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--compare_Ord_String e-13 e-29)) ((equal? sc2 2) 2) (else 0))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))) ((8) (let ((e-15 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-31 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int e-15 e-31)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Name-nameTag arg-0) (CoreC-45Name-nameTag arg-1))))))
(define CoreC-45Name-u--C-60C-61_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 2)))
(define LibrariesC-45DataC-45NameMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (CoreC-45Name-u--compare_Ord_Name arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45NameMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45NameMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45NameMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45NameMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ e-2 1) e-5))))))))))
(define csegen-793 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Basics-uncurry (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (LibrariesC-45DataC-45NameMap-insert eta-3 eta-4 eta-5)))) eta-2)) eta-0 eta-1))))
(define LibrariesC-45DataC-45NameMap-fromList (lambda (arg-1) (PreludeC-45Types-u--foldl_Foldable_List csegen-793 LibrariesC-45DataC-45NameMap-empty arg-1)))
(define CoreC-45Name-isUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((3) 0) ((2) 0) ((0) (let ((e-5 (vector-ref arg-0 2))) (CoreC-45Name-isUserName e-5))) ((4) (let ((e-7 (vector-ref arg-0 2))) (CoreC-45Name-isUserName e-7)))(else 1))))
(define LibrariesC-45DataC-45WithDefault-specified (lambda (ext-0) (box ext-0)))
(define CoreC-45TT-unchecked (cons (vector 0 ) (vector 0 )))
(define LibrariesC-45DataC-45WithDefault-defaulted '())
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 (lambda (arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 LibrariesC-45DataC-45WithDefault-defaulted)) ((equal? e-5 1) (let ((act-2 (let ((e-2 (cdr arg-2))) ((e-2 arg-3) clam-0)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45WithDefault-specified e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "WithDefault" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Term-apply (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45TTC-45Term-apply arg-1 (vector 4 arg-1 arg-2 e-2) e-3))))))
(define CoreC-45FC-emptyFC (vector 2 ))
(define PreludeC-45Types-maybe (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (arg-2) (let ((e-2 (unbox arg-4))) ((arg-3) e-2)))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (let ((act-2 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) clam-0)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "PiInfo" clam-0)))))) eff-0) ext-0)))))))
(define AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega 2)
(define csegen-1598 (vector 1 csegen-30))
(define AlgebraC-45Semiring-linear (lambda (arg-1) (let ((e-4 (vector-ref arg-1 3))) e-4)))
(define csegen-1416 (AlgebraC-45Semiring-linear csegen-29))
(define csegen-1599 (vector 1 csegen-1416))
(define CoreC-45TTC-u--fromBuf_TTC_RigCount (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) csegen-1598) ((equal? e-5 1) csegen-1599) ((equal? e-5 2) (vector 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))(else (CoreC-45BinaryC-45Prims-corrupt "RigCount" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Term-n--6581-4652-u--getFA (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((4) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (CoreC-45TTC-45Term-n--6581-4652-u--getFA arg-1 (cons e-3 arg-2) e-2))))(else (cons arg-3 arg-2)))))
(define CoreC-45TTC-45Term-getFnArgs (lambda (arg-1) (CoreC-45TTC-45Term-n--6581-4652-u--getFA arg-1 '() arg-1)))
(define PreludeC-45Types-u--C-60_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Integer arg-0 arg-1) 0)))
(define CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-2 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-2 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-2 2 ext-0)) (else (let ((e-4 (vector-ref arg-3 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-2 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-1 (car arg-1))) (((e-1 arg-2) e-4) ext-0))))))))))
(define AlgebraC-45Semiring-elimSemi (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (let ((sc1 (Builtin-snd arg-2))) (let ((e-1 (car sc1))) ((e-1 arg-6) (let ((sc2 (Builtin-fst arg-2))) (let ((e-5 (vector-ref sc2 1))) e-5))))))) (cond ((equal? sc0 1) arg-3) (else (let ((sc1 (let ((sc2 (Builtin-snd arg-2))) (let ((e-1 (car sc2))) ((e-1 arg-6) (let ((sc3 (Builtin-fst arg-2))) (let ((e-4 (vector-ref sc3 3))) e-4))))))) (cond ((equal? sc1 1) arg-4) (else (arg-5 arg-6)))))))))
(define AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (lambda (arg-0 arg-1) (let ((sc0 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-930 (cons (lambda (arg-676) (lambda (arg-679) (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega arg-686 arg-689)))))
(define csegen-931 (cons csegen-29 csegen-930))
(define CoreC-45TTC-u--toBuf_TTC_RigCount (lambda (arg-0 ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-0 0 eta-0)) (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-0 1 eta-0)) (lambda (eta-0) (lambda (eta-1) (CoreC-45BinaryC-45Prims-tag arg-0 2 eta-1))) ext-0)))
(define CoreC-45TTC-u--toBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-3 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-4) ext-0)))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-7) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-8) ext-0)))))))))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-12) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-13 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-14) ext-0)))))))))))))) ((3) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-17) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-18 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-19) ext-0)))))))))))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-22) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-23) ext-0)))))))))) (else (let ((e-27 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-1 e-27) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_NameType (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-0) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-1) ext-0)))))))))) (else (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-3) ext-0)))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_UseSide (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (lambda (clam-0) (let ((sc1 (PreludeC-45Types-u--C-60_Ord_Nat e-4 243))) (cond ((equal? sc1 1) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 (bs+ (blodwen-toSignedInt e-4 63) 13 63) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-44 arg-1 e-3) clam-0))))) (else (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-44 arg-1 e-3) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-4) clam-0)))))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_NameType arg-1 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-9) eta-0))))))))))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-12) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-1)))) arg-1 e-14 eta-0))))))))))) ((3) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-17) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 arg-0 arg-1 e-18 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 (cons e-17 arg-0) arg-1 e-19) eta-0))))))))))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((sc1 (CoreC-45TTC-45Term-getFnArgs (vector 4 e-21 e-22 e-23)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (lambda (clam-0) (if (null? e-3) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 12 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-3 clam-0))))))) (let ((e-1 (car e-3))) (let ((e-4 (cdr e-3))) (if (null? e-4) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-1) clam-0))))))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 12 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-3 clam-0))))))))))))))))))) ((5) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-27) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_UseSide arg-1 e-26 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-28) eta-0))))))))))))))) ((6) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 6 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-31 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-32) eta-0))))))))))) ((7) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-35 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-36) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-37) eta-0))))))))))))))) ((8) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 8 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-1 e-40 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-41) eta-0))))))))))) ((9) (let ((e-44 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 9 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-44 eta-0))))))) ((10) (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-1 10 eta-0))) (else (let ((e-50 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-50) eta-0))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-1)))) arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 CoreC-45FC-emptyFC e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 CoreC-45FC-emptyFC e-6 e-7 (vector 10 CoreC-45FC-emptyFC (vector 0 ))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-1)))) arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 CoreC-45FC-emptyFC e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-1)))) arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 CoreC-45FC-emptyFC e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 CoreC-45FC-emptyFC e-6 e-7 (vector 10 CoreC-45FC-emptyFC (vector 0 ))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 CoreC-45FC-emptyFC e-6 (vector 10 CoreC-45FC-emptyFC (vector 0 ))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "Binder" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_NameType (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "NameType" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_UseSide (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1))(else (CoreC-45BinaryC-45Prims-corrupt "UseSide" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-44 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((PreludeC-45Types-maybe (lambda () (lambda (eta-2) (CoreC-45BinaryC-45Prims-corrupt "Term" eta-2))) (lambda () (lambda (eta-2) (lambda (eta-3) (vector 1 eta-2)))) (CoreC-45TTC-getName e-7 arg-0)) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 CoreC-45FC-emptyFC e-6 e-7))))) eff-0) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_NameType arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 CoreC-45FC-emptyFC e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-1)))) arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 CoreC-45FC-emptyFC e-6 0 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 (cons e-6 arg-0) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 CoreC-45FC-emptyFC e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 CoreC-45FC-emptyFC e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_UseSide arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 CoreC-45FC-emptyFC e-7 e-6 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 CoreC-45FC-emptyFC e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 7 CoreC-45FC-emptyFC e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 CoreC-45FC-emptyFC e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 9) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 CoreC-45FC-emptyFC e-6))))) eff-0) clam-0)))))) ((equal? e-5 10) (vector 1 (vector 10 CoreC-45FC-emptyFC (vector 0 )))) ((equal? e-5 11) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 CoreC-45FC-emptyFC e-6))))) eff-0) clam-0)))))) ((equal? e-5 12) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-5542 eta-1)))) arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-apply CoreC-45FC-emptyFC e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-44 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--idx (PreludeC-45Types-prim__integerToNat (bs- e-5 13 63)))) (lambda (clam-1) (let ((sc2 (CoreC-45TTC-getName u--idx arg-0))) (if (null? sc2) (CoreC-45BinaryC-45Prims-corrupt "Term" clam-1) (vector 1 (vector 0 CoreC-45FC-emptyFC e-6 u--idx)))))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Context-holeInit (lambda (arg-0) (cons arg-0 0)))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CaseAltC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-0) arg-1 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 0 e-6 e-7 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (cons e-6 (cons e-7 arg-0)) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "CaseAlt" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-1 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-5542 eta-0)))) arg-1 e-5 ext-0)))))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 e-8) ext-0)))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-1 e-10) ext-0)))))) (else (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_C-40CaseAltC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-1 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-1 e-3 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-1 e-4 ext-0)))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-6) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-1 e-7) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (cons e-6 (cons e-7 arg-0)) arg-1 e-8 ext-0)))))))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_Constant arg-1 e-10 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 e-11 ext-0)))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-1 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 arg-0 arg-1 e-13 ext-0)))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-2) (CoreC-45TTC-u--toBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-5529 arg-5534 eta-2)))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40CaseAltC-32C-36varsC-41 arg-0 arg-5542 eta-2)))) arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-6 e-7 (vector 10 CoreC-45FC-emptyFC (vector 0 )) e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 0 e-6))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0)))))) ((equal? e-5 3) (vector 1 (vector 3 )))(else (CoreC-45BinaryC-45Prims-corrupt "CaseTree" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_HoleInfo (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 '())) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "HoleInfo" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_PMDefInfo (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_HoleInfo arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_TypeFlags (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 (lambda (arg-2 arg-3 ext-0) (let ((act-1 (let ((sc0 (Builtin-fst arg-2))) (let ((e-2 (cdr sc0))) ((e-2 arg-3) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 ((Builtin-snd arg-2) e-5))) (let ((e-2 (cdr sc1))) ((e-2 arg-3) eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 (lambda (arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (((e-1 arg-3) e-2) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((sc2 ((Builtin-snd arg-2) e-2))) (let ((e-1 (car sc2))) (((e-1 arg-3) e-3) ext-0))))))))))
(define CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-0 arg-1 ext-0) (if (null? arg-0) (vector 1 '()) (let ((e-3 (cdr arg-0))) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 e-3 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-3 arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-0) (vector 1 (vector 0 )) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_C-40BinderC-32C-40TermC-32C-36varsC-41C-41 e-3 arg-1 e-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-3 arg-1 e-9) clam-0)))))))))))
(define csegen-1577 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-5542 eta-0)))) (lambda (u--y) (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-5530) (lambda (arg-5535) (CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-5530 arg-5535))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-5542 eta-1)))) (cons (lambda (arg-5530) (lambda (arg-5535) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-5531) (lambda (arg-5536) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5531 arg-5536))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5542 eta-2)))) (cons (lambda (arg-5531) (lambda (arg-5536) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5531 arg-5536))) (lambda (arg-5542) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5542 eta-2))))) arg-5530 arg-5535 eta-1)))) (lambda (arg-5542) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-5530) (lambda (arg-5535) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5530 arg-5535))) (lambda (arg-5543) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5543 eta-2)))) (cons (lambda (arg-5530) (lambda (arg-5535) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5530 arg-5535))) (lambda (arg-5543) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5543 eta-2))))) arg-5542 eta-1))))) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-5529 arg-5534))) (lambda (arg-5543) (lambda (eta-1) (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 u--y arg-5543 eta-1)))) (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-5530) (lambda (arg-5535) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5530 arg-5535))) (lambda (arg-5543) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5543 eta-2)))) (cons (lambda (arg-5530) (lambda (arg-5535) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5530 arg-5535))) (lambda (arg-5543) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5543 eta-2))))) arg-5529 arg-5534 eta-1)))) (lambda (arg-5543) (lambda (eta-1) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5529 arg-5534))) (lambda (arg-5544) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5544 eta-2)))) (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5529 arg-5534))) (lambda (arg-5544) (lambda (eta-2) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 u--y arg-5544 eta-2))))) arg-5543 eta-1))))) arg-5542 eta-0)))))))
(define csegen-1580 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 csegen-1577 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40DPairC-32C-36aC-41C-32C-36pC-41 csegen-1577 arg-5542 eta-0)))))
(define csegen-1581 (cons csegen-44 csegen-1535))
(define csegen-1584 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1581 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1581 arg-5542 eta-0)))))
(define csegen-1587 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_Def (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PMDefInfo arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40CaseTreeC-32C-36varsC-41 e-7 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1580 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 1 e-6 e-7 e-8 (vector 2 "") e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1584 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45TTC-u--fromBuf_TTC_TypeFlags arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1587 arg-0 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (vector 6 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-6 (CoreC-45ContextC-45Context-holeInit e-7)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1562 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 9) (vector 1 (vector 10 ))) ((equal? e-5 10) (vector 1 (vector 12 ))) ((equal? e-5 11) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Integer arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "Def" clam-0)))))) eff-0) ext-0)))))))
(define csegen-1590 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_Covering (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1590 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "Covering" clam-0)))))) eff-0) ext-0)))))))
(define csegen-1553 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_FC arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_FC arg-5542 eta-0)))) csegen-41))
(define csegen-1556 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1553 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1553 arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_PartialReason (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1556 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1556 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "PartialReason" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_Terminating (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_PartialReason arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "Terminating" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_Totality (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Terminating arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Covering arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-1 (unbox arg-3))) (box (arg-2 e-1))))))
(define CoreC-45TTC-u--fromBuf_TTC_Visibility (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "Visibility" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_Visibility (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define csegen-1566 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_Visibility arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_TotalReq (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "TotalReq" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--fromBuf_TTC_DefFlag (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 2) (vector 1 (vector 0 ))) ((equal? e-5 3) (vector 1 (vector 3 ))) ((equal? e-5 4) (vector 1 (vector 4 ))) ((equal? e-5 5) (vector 1 (vector 5 ))) ((equal? e-5 6) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-6))))) eff-0) clam-0)))))) ((equal? e-5 7) (vector 1 (vector 7 ))) ((equal? e-5 8) (vector 1 (vector 8 ))) ((equal? e-5 9) (vector 1 (vector 9 '()))) ((equal? e-5 10) (vector 1 (vector 10 ))) ((equal? e-5 11) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_ConInfo arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-6))))) eff-0) clam-0)))))) ((equal? e-5 12) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 12 e-6))))) eff-0) clam-0)))))) ((equal? e-5 13) (vector 1 (vector 1 ))) ((equal? e-5 15) (vector 1 (vector 2 )))(else (CoreC-45BinaryC-45Prims-corrupt "DefFlag" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_TotalReq (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define CoreC-45TTC-u--toBuf_TTC_DefFlag (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 13 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 15 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((6) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_TotalReq arg-0 e-0 ext-0)))))) ((7) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) ((8) (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)) ((9) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((10) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) ((11) (let ((e-2 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (CoreC-45TTC-u--toBuf_TTC_ConInfo arg-0 e-2 ext-0)))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 12 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-3) ext-0)))))))))
(define csegen-1569 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_DefFlag arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_DefFlag arg-5542 eta-0)))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (let ((act-1 (let ((e-2 (cdr arg-1))) ((e-2 arg-2) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 arg-1 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((e-1 (car arg-1))) (((e-1 arg-2) (let ((e-4 (car arg-3))) e-4)) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 arg-1 arg-2 (let ((e-2 (cdr arg-3))) e-2) ext-0))))))
(define CoreC-45TTC-u--fromBuf_TTC_SizeChange (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "SizeChange" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_SizeChange (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define csegen-1539 (cons csegen-1535 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_SizeChange arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_SizeChange arg-5542 eta-0))))))
(define csegen-1542 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1539 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1539 arg-5542 eta-0)))))
(define csegen-1546 (cons csegen-1535 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40List1C-32C-36aC-41 csegen-1542 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40List1C-32C-36aC-41 csegen-1542 arg-5542 eta-0))))))
(define csegen-1549 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1546 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1546 arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_SCCall (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1549 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_SCCall (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1549 arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_FC arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2) ext-0)))))))))
(define csegen-1572 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_SCCall arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_SCCall arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_GlobalDef (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-38 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-51 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--refsR (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (LibrariesC-45DataC-45NameMap-fromList eta-1)) e-6))) (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-51 arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--refs (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-5) (LibrariesC-45DataC-45NameMap-fromList eta-5)) e-10))) (lambda (eta-5) (let ((act-7 (CoreC-45TTC-u--fromBuf_TTC_Def arg-0 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc7 (CoreC-45Name-isUserName e-9))) (cond ((equal? sc7 1) (let ((act-8 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-11 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-13 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-10))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-14 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-1566 arg-0 eta-11))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-12) (let ((act-15 (CoreC-45TTC-u--fromBuf_TTC_Totality arg-0 eta-12))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-13) (let ((act-16 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-13))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-14) (let ((act-17 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1569 arg-0 eta-14))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-15) (let ((act-18 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-15))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-16) (let ((act-19 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-16))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((e-23 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-17) (let ((act-20 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1572 arg-0 eta-17))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((e-24 (vector-ref act-20 1))) ((let ((eff-0 (lambda (eta-18) (vector 1 (vector e-7 e-9 e-12 e-13 e-14 e-15 e-16 e-8 e-17 e-18 e-19 e-20 e-21 u--refs u--refsR e-22 e-23 1 e-11 e-5 '() e-24 '()))))) eff-0) eta-17)))))))) eff-0) eta-16)))))))) eff-0) eta-15)))))))) eff-0) eta-14)))))))) eff-0) eta-13)))))))) eff-0) eta-12)))))))) eff-0) eta-11)))))))) eff-0) eta-10)))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) clam-0)))))) (else (vector 1 (vector e-7 e-9 (vector 10 e-7 (vector 0 )) '() '() '() '() e-8 '() (LibrariesC-45DataC-45WithDefault-specified 2) CoreC-45TT-unchecked 0 '() u--refs u--refsR 0 0 1 e-11 e-5 '() '() '())))))))) eff-0) eta-5))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Core-traverseC-39 (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-reverse arg-4))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((eff-0 (arg-2 e-2))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (CoreC-45Core-traverseC-39 arg-2 e-3 (cons e-5 arg-4)))) eff-1) world-0))))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((act-1 (let ((e-3 (cdr arg-1))) (((e-3 arg-2) e-2) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box e-5))))) eff-0) ext-0)))))))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car arg-5))) (let ((e-7 (cdr arg-5))) (let ((sc2 (let ((e-1 (car arg-2))) ((e-1 e-2) e-6)))) (cond ((equal? sc2 1) (let ((e-1 (car arg-3))) ((e-1 e-3) e-7))) (else 0)))))))))
(define PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? arg-3) 0 (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (let ((sc2 (let ((e-1 (car arg-1))) ((e-1 e-2) e-6)))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 arg-1 e-3 e-7)) (else 0)))))))))))
(define CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace (lambda (arg-0 arg-1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 arg-0 arg-1)))
(define CoreC-45Name-u--C-61C-61_Eq_UserName (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-2)))(else 0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-3 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-3)))(else 0)))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0)))(else 0))))
(define CoreC-45Name-u--C-61C-61_Eq_Name (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-17))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 e-16)) (else 0))))))(else 0))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-18 (vector-ref arg-1 1))) (CoreC-45Name-u--C-61C-61_Eq_UserName e-2 e-18)))(else 0)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-4 e-20))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-3 e-19)) (else 0))))))(else 0))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((3) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-21))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 e-22)) (else 0))))))(else 0))))) ((4) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((4) (let ((e-24 (vector-ref arg-1 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-24)))(else 0)))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((5) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 e-9 e-25))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-26)) (else 0))))))(else 0))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-12 e-28))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-11 e-27)) (else 0))))))(else 0))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-14 e-30))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-13 e-29)) (else 0))))))(else 0))))) ((8) (let ((e-15 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-31 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-15 e-31)))(else 0))))(else 0))))
(define LibrariesC-45DataC-45NameMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-10)) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45NameMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45NameMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45NameMap-treeLookup arg-1 e-3)))))
(define CoreC-45Context-getNameID (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2))))))
(define CoreC-45CoreC-45PiInfo-traverse (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (lambda (eta-0) (vector 1 (vector 1 )))) ((0) (lambda (eta-0) (vector 1 (vector 0 )))) ((2) (lambda (eta-0) (vector 1 (vector 2 )))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((eff-0 (arg-2 e-4))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-1) world-0))))))))))))
(define CoreC-45CoreC-45Binder-traverse (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((eff-0 (CoreC-45CoreC-45PiInfo-traverse arg-2 e-3))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (let ((eff-1 (arg-2 e-4))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-2 (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-5 e-6))))) eff-2) world-1))))))))) eff-1) world-0)))))))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (let ((eff-0 (arg-2 e-8))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (let ((eff-1 (arg-2 e-9))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-2 (lambda (eta-0) (vector 1 (vector 1 e-6 e-7 e-5 e-10))))) eff-2) world-1))))))))) eff-1) world-0)))))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((eff-0 (CoreC-45CoreC-45PiInfo-traverse arg-2 e-13))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (let ((eff-1 (arg-2 e-14))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-2 (lambda (eta-0) (vector 1 (vector 2 e-11 e-12 e-5 e-6))))) eff-2) world-1))))))))) eff-1) world-0)))))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (let ((eff-0 (CoreC-45CoreC-45PiInfo-traverse arg-2 e-18))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (let ((eff-1 (arg-2 e-19))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-2 (lambda (eta-0) (vector 1 (vector 3 e-16 e-17 e-5 e-6))))) eff-2) world-1))))))))) eff-1) world-0)))))))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((eff-0 (arg-2 e-23))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (let ((eff-1 (arg-2 e-24))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-2 (lambda (eta-0) (vector 1 (vector 4 e-21 e-22 e-5 e-6))))) eff-2) world-1))))))))) eff-1) world-0)))))))))))) (else (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((eff-0 (arg-2 e-28))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (eta-0) (vector 1 (vector 5 e-26 e-27 e-5))))) eff-1) world-0))))))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((sc1 (CoreC-45Context-getNameID e-3 arg-1))) (if (null? sc1) (vector 1 (vector 1 e-1 e-2 e-3)) (let ((e-4 (unbox sc1))) (vector 1 (vector 1 e-1 e-2 (vector 8 e-4)))))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (arg-3) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (CoreC-45Context-getNameID e-6 arg-1))) (if (null? sc2) (vector 1 (vector 2 e-5 e-6 e-7 e-9)) (let ((e-1 (unbox sc2))) (vector 1 (vector 2 e-5 e-6 e-1 e-9)))))))) eff-0) clam-0)))))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-10 e-11 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-16) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-17) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-15 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-21) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-22) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-26) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-24 e-25 e-5))))) eff-0) clam-0))))))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-30) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-31) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-28 e-29 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-35) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-33 e-34 e-5))))) eff-0) clam-0))))))))) ((11) (let ((e-37 (vector-ref arg-2 1))) (let ((e-38 (vector-ref arg-2 2))) (let ((sc1 (CoreC-45Context-getNameID e-38 arg-1))) (if (null? sc1) (vector 1 (vector 11 e-37 e-38)) (let ((e-1 (unbox sc1))) (vector 1 (vector 11 e-37 (vector 8 e-1)))))))))(else (vector 1 arg-2))))))
(define CoreC-45Context-u--resolved_HasNames_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (CoreC-45Context-getNameID e-1 arg-1))) (if (null? sc2) (vector 1 (vector 0 e-1 e-2 e-3 e-5)) (let ((e-6 (unbox sc2))) (vector 1 (vector 0 (vector 8 e-6) e-2 e-3 e-5)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6 e-7 e-5))))) eff-0) ext-0))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-10 e-5))))) eff-0) ext-0)))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (arg-3) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40CaseAltC-32C-36varsC-41 arg-1 arg-3 eta-1))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-5))))) eff-0) ext-0))))))))(else (vector 1 arg-2)))))
(define CoreC-45Context-u--resolved_HasNames_Name (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (vector 1 (vector 8 e-0))))(else (let ((sc0 (CoreC-45Context-getNameID arg-1 arg-0))) (if (null? sc0) (vector 1 arg-1) (let ((e-1 (unbox sc0))) (vector 1 (vector 8 e-1))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-6 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Context-n--13902-9841-u--resolvedNamesPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-5 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-11) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-2 (cons e-5 (cons e-8 e-9))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Context-u--resolved_HasNames_Def (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Context-n--13902-9841-u--resolvedNamesPat e-4 e-1 e-3 e-2 e-0 arg-0 eta-2)) e-4 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-0 e-1 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((6) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (let ((e-11 (vector-ref arg-1 7))) (let ((e-12 (vector-ref arg-1 8))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-10 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-1)) e-11 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 e-5 e-6 e-7 e-8 e-9 e-13 e-14 e-12))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))) ((8) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-15) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-13 e-14 e-5))))) eff-0) ext-0))))))))) ((9) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-16) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-5 e-17 e-18))))) eff-0) ext-0)))))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--resolved_HasNames_SCCall (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (vector e-5 e-1 e-2))))))) eff-0) ext-0)))))))
(define CoreC-45Context-u--resolved_HasNames_Covering (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0)) e-0 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-5))))) eff-0) ext-0))))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45Core-traversePair (lambda (arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((eff-0 (arg-3 e-3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (cons e-2 e-5)))))) eff-0 eta-0)))))))
(define CoreC-45Context-u--resolved_HasNames_PartialReason (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-0 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-5))))) eff-0) ext-0))))))) ((2) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-1)) eta-0)) e-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-1)) eta-0)) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45Context-u--resolved_HasNames_Terminating (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_PartialReason arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-5))))) eff-0) ext-0)))))))(else (vector 1 arg-1)))))
(define CoreC-45Context-u--resolved_HasNames_Totality (lambda (arg-0 arg-1 ext-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_Terminating arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_Covering arg-0 e-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (cons (cons e-1 e-2) arg-3)))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 (LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 arg-3 e-7) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 (LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 (LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 arg-3 e-14) e-12) e-10))))))))
(define LibrariesC-45DataC-45NameMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45NameMap-n--5790-11773-u--treeToListC-39 '() ext-0)))
(define LibrariesC-45DataC-45NameMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45NameMap-treeToList e-3)))))
(define CoreC-45Context-n--14542-10294-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-2 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-n--14542-10294-u--insertAll arg-1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-5 e-7 arg-3) e-3))) eff-0) clam-0)))))))))))))
(define CoreC-45Context-u--full_HasNames_C-40NameMapC-32C-36aC-41 (lambda (arg-1 arg-2) (CoreC-45Context-n--14542-10294-u--insertAll arg-2 arg-1 LibrariesC-45DataC-45NameMap-empty (LibrariesC-45DataC-45NameMap-toList arg-2))))
(define CoreC-45Context-n--14554-10334-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-2 e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-n--14554-10334-u--insertAll arg-1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-5 e-7 arg-3) e-3))) eff-0) clam-0)))))))))))))
(define CoreC-45Context-u--resolved_HasNames_C-40NameMapC-32C-36aC-41 (lambda (arg-1 arg-2) (CoreC-45Context-n--14554-10334-u--insertAll arg-2 arg-1 LibrariesC-45DataC-45NameMap-empty (LibrariesC-45DataC-45NameMap-toList arg-2))))
(define csegen-1293 (lambda () (cons (lambda (arg-7719) (lambda (arg-7722) (CoreC-45Context-u--full_HasNames_C-40NameMapC-32C-36aC-41 arg-7719 arg-7722))) (lambda (arg-7729) (lambda (arg-7732) (CoreC-45Context-u--resolved_HasNames_C-40NameMapC-32C-36aC-41 arg-7729 arg-7732))))))
(define CoreC-45Context-u--resolved_HasNames_GlobalDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_Def arg-0 (let ((e-18 (vector-ref arg-1 18))) e-18) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-u--resolved_HasNames_Totality arg-0 (let ((e-10 (vector-ref arg-1 10))) e-10) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-1293) arg-0 (let ((e-13 (vector-ref arg-1 13))) e-13) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 (csegen-1293) arg-0 (let ((e-14 (vector-ref arg-1 14))) e-14) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (lambda (eta-6) (CoreC-45Context-u--resolved_HasNames_SCCall arg-0 eta-5 eta-6))) (let ((e-21 (vector-ref arg-1 21))) e-21) '()) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-28 (vector-ref arg-1 5))) (let ((e-27 (vector-ref arg-1 6))) (let ((e-26 (vector-ref arg-1 7))) (let ((e-25 (vector-ref arg-1 8))) (let ((e-24 (vector-ref arg-1 9))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-22 (vector-ref arg-1 22))) (vector e-0 e-1 e-5 e-3 e-4 e-28 e-27 e-26 e-25 e-24 e-7 e-11 e-12 e-8 e-9 e-15 e-16 e-17 e-6 e-19 e-20 e-10 e-22)))))))))))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8)))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (vector 2 e-10 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11))))) (else (let ((e-13 (vector-ref arg-2 1))) (vector 3 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13)))))))
(define CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (vector 1 )) ((0) (vector 0 )) ((2) (vector 2 )) (else (let ((e-4 (vector-ref arg-3 1))) (vector 3 (arg-2 e-4)))))))
(define CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (vector 0 e-1 e-2 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo arg-2 e-3) (arg-2 e-4))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (vector 1 e-6 e-7 (arg-2 e-8) (arg-2 e-9))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (vector 2 e-11 e-12 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo arg-2 e-13) (arg-2 e-14))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (vector 3 e-16 e-17 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo arg-2 e-18) (arg-2 e-19))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (vector 4 e-21 e-22 (arg-2 e-23) (arg-2 e-24))))))) (else (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (vector 5 e-26 e-27 (arg-2 e-28)))))))))
(define DataC-45List-isNil (lambda (arg-1) (if (null? arg-1) 1 0)))
(define CoreC-45TTC-45Term-u--restoreNS_StripNamespace_Name (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((u--nm (vector 0 e-0 e-1))) (let ((sc1 (DataC-45List-isNil e-0))) (cond ((equal? sc1 1) (vector 0 arg-0 e-1)) (else u--nm)))))))(else arg-1))))
(define CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 1 e-1 e-2 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_Name arg-1 e-3)))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-3) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (vector 3 e-10 e-11 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (arg-3) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-13))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (vector 4 e-15 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-16) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-17)))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (vector 5 e-19 e-20 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-21) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-22))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (vector 6 e-24 e-25 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-26)))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (vector 7 e-28 e-29 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-30) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-31))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (vector 8 e-33 e-34 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-35))))))(else arg-2))))
(define CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector 0 e-1 e-2 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 arg-1 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (vector 1 e-7 (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-8)))))(else arg-2))))
(define CoreC-45Context-n--14279-10090-u--restoreNSpat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-10) (CoreC-45TTC-45Term-u--restoreNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-11))))))))))))
(define CoreC-45Context-u--restoreNS_StripNamespace_Def (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (vector 1 e-0 e-1 (CoreC-45CaseC-45CaseTree-u--restoreNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2) e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Context-n--14279-10090-u--restoreNSpat e-4 e-1 e-3 e-2 e-0 arg-0 eta-0)) e-4))))))))(else arg-1))))
(define CoreC-45Context-u--restoreNS_StripNamespace_GlobalDef (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (CoreC-45Context-u--restoreNS_StripNamespace_Def arg-0 e-18) e-19 e-20 e-21 e-22))))))))))))))))))))))))))
(define CoreC-45Context-decode (lambda (ext-4 ext-1 ext-2 ext-3 ext-0) (case (vector-ref ext-3 0) ((0) (let ((e-0 (vector-ref ext-3 1))) (let ((e-1 (vector-ref ext-3 2))) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_GlobalDef e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--a (CoreC-45Context-getContent ext-4))) (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox u--a))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-u--resolved_HasNames_GlobalDef ext-4 (CoreC-45Context-u--restoreNS_StripNamespace_GlobalDef e-0 e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (cond ((equal? ext-2 1) (let ((act-5 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 e-7 ext-1 (vector 1 e-8)) eta-3))) (vector 1 act-5))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-8))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) (else (let ((e-2 (vector-ref ext-3 1))) (vector 1 e-2))))))
(define LibrariesC-45DataC-45IOArray-readArray (lambda (arg-2 arg-3 arg-4) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-4 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-4 (LibrariesC-45DataC-45IOArray-max arg-3))))))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '()))))) (else (let ((e-2 (cdr arg-2))) ((e-2 'erased) (lambda (eta-0) (vector-ref (let ((e-3 (cdr arg-3))) e-3) arg-4)))))))))
(define CoreC-45Context-case--returnDef-6301 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((sc1 (let ((e-6 (vector-ref e-0 1))) e-6))) (cond ((equal? sc1 1) (box (cons arg-1 arg-0))) (else '())))))(else '()))))
(define CoreC-45Context-returnDef (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 0) (box (cons arg-1 arg-2))) (else (CoreC-45Context-case--returnDef-6301 arg-2 arg-1 (let ((e-18 (vector-ref arg-2 18))) e-18))))))
(define CoreC-45Context-lookupCtxtExactI (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (lambda (clam-0) (let ((sc1 (LibrariesC-45DataC-45IntMap-lookup e-0 (let ((e-6 (vector-ref arg-1 6))) e-6)))) (if (null? sc1) (let ((act-1 (let ((act-1 (unbox (let ((e-4 (vector-ref arg-1 4))) e-4)))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((LibrariesC-45DataC-45IOArray-readArray csegen-82 e-5 e-0) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-3 (CoreC-45Context-decode arg-1 e-0 1 e-1 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) e-0 e-7))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-1 (unbox sc1))) (let ((act-1 (CoreC-45Context-decode arg-1 e-0 1 e-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) e-0 e-5))))) eff-0) clam-0)))))))))))(else (let ((sc0 (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)))) (if (null? sc0) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc0))) (CoreC-45Context-lookupCtxtExactI (vector 8 e-1) arg-1))))))))
(define csegen-1274 (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) e-3)))
(define CoreC-45Context-case--lookupCtxtExact-6496 (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (let ((act-1 (let ((act-1 (unbox (let ((e-4 (vector-ref arg-1 4))) e-4)))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((LibrariesC-45DataC-45IOArray-readArray csegen-82 e-5 arg-0) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-3 (CoreC-45Context-decode arg-1 arg-0 1 e-1 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe csegen-1274 (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) arg-0 e-7)))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-2))) (let ((act-1 (CoreC-45Context-decode arg-1 arg-0 1 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe csegen-1274 (CoreC-45Context-returnDef (let ((e-9 (vector-ref arg-1 9))) e-9) arg-0 e-5)))))) eff-0) ext-0)))))))))
(define CoreC-45Context-lookupCtxtExact (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (lambda (eta-0) (CoreC-45Context-case--lookupCtxtExact-6496 e-0 arg-1 (LibrariesC-45DataC-45IntMap-lookup e-0 (let ((e-6 (vector-ref arg-1 6))) e-6)) eta-0))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExactI arg-0 arg-1) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((e-6 (cdr e-1))) (vector 1 (box e-6)))))))) eff-0) eta-0))))))))))
(define CoreC-45Context-u--full_HasNames_Name (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 e-0) arg-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 (vector 8 e-0)) (let ((e-1 (unbox e-5))) (vector 1 (let ((e-24 (vector-ref e-1 1))) e-24))))))) eff-0) ext-0)))))))(else (vector 1 arg-1)))))
(define csegen-54 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (CoreC-45Context-u--resolved_HasNames_Name arg-7729 arg-7732)))))
(define PreludeC-45TypesC-45List-mapMaybeAppend (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-2 '()) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((sc1 (arg-3 e-1))) (if (null? sc1) (PreludeC-45TypesC-45List-mapMaybeAppend arg-2 arg-3 e-2) (let ((e-3 (unbox sc1))) (PreludeC-45TypesC-45List-mapMaybeAppend (cons arg-2 e-3) arg-3 e-2)))))))))
(define DataC-45List-catMaybes (lambda (ext-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) eta-0) ext-0)))
(define csegen-55 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-catMaybes e-5)))))))
(define csegen-57 (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45TypesC-45List-tailRecAppend arg-8474 arg-8477))) '()))
(define csegen-59 (cons (lambda (arg-8474) (lambda (arg-8477) (string-append arg-8474 arg-8477))) ""))
(define csegen-63 (lambda (eta-0) (lambda (eta-1) (CoreC-45Core-traverse_ eta-0 eta-1))))
(define PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AnyBool (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) 1) (else arg-1))))
(define csegen-107 (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AnyBool arg-8474 arg-8477))) 0))
(define PreludeC-45Types-elemBy (lambda (arg-2 arg-3 arg-4 ext-0) (let ((e-6 (vector-ref arg-2 5))) (((((e-6 'erased) 'erased) csegen-107) (arg-3 arg-4)) ext-0))))
(define PreludeC-45Types-elem (lambda (arg-2 arg-3 ext-1 ext-0) (PreludeC-45Types-elemBy arg-2 (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-3))) ((e-1 eta-0) eta-1)))) ext-1 ext-0)))
(define CoreC-45Name-isOpChar (lambda (arg-0) (PreludeC-45Types-elem csegen-14 csegen-17 arg-0 (PreludeC-45Types-fastUnpack ":!#$%&*+./<=>?@\\^|-~"))))
(define PreludeC-45TypesC-45String-length (lambda (arg-0) (PreludeC-45Types-prim__integerToNat (string-length arg-0))))
(define PreludeC-45Types-substr (lambda (arg-0 arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 (PreludeC-45TypesC-45String-length arg-2)))) (cond ((equal? sc0 1) (string-substr (blodwen-toSignedInt arg-0 63) (blodwen-toSignedInt arg-1 63) arg-2)) (else "")))))
(define LibrariesC-45DataC-45StringC-45Extra-drop (lambda (arg-0 arg-1) (PreludeC-45Types-substr arg-0 (PreludeC-45TypesC-45String-length arg-1) arg-1)))
(define LibrariesC-45DataC-45StringC-45Extra-join (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45StringC-45Extra-drop (PreludeC-45TypesC-45String-length arg-1) (let ((e-2 (vector-ref arg-2 1))) (((((e-2 'erased) 'erased) (lambda (u--acc) (lambda (u--x) (string-append u--acc (string-append arg-1 u--x))))) "") arg-3)))))
(define CoreC-45NameC-45Namespace-showSep (lambda (arg-0 ext-0) (LibrariesC-45DataC-45StringC-45Extra-join arg-0 csegen-14 ext-0)))
(define CoreC-45NameC-45Namespace-showNSWithSep (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-showSep arg-0 (PreludeC-45TypesC-45List-reverse arg-1))))
(define CoreC-45NameC-45Namespace-u--show_Show_Namespace (lambda (ext-0) (CoreC-45NameC-45Namespace-showNSWithSep "." ext-0)))
(define CoreC-45Name-u--show_Show_UserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "." e-1))) (else "_"))))
(define CoreC-45Name-u--show_Show_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (case (vector-ref e-16 0) ((1) (string-append (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (string-append ".(" (string-append (CoreC-45Name-u--show_Show_Name e-1) ")")))) ((0) (let ((e-18 (vector-ref e-16 1))) (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Name-isOpChar eta-0)) (PreludeC-45Types-fastUnpack e-18)))) (cond ((equal? sc3 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (cons ".(" (cons e-18 (cons ")" '())))))) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (cons "." (cons e-18 '())))))))))(else (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (cons "." (cons (CoreC-45Name-u--show_Show_Name e-1) '()))))))))(else (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0) (cons "." (cons (CoreC-45Name-u--show_Show_Name e-1) '()))))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45Name-u--show_Show_UserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (string-append "{" (string-append e-3 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Int e-4) "}"))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (string-append "{P:" (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Int e-6) "}"))))))) ((4) (let ((e-7 (vector-ref arg-0 1))) e-7)) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-21 (car e-9))) (let ((e-22 (cdr e-9))) (string-append (PreludeC-45Show-u--show_Show_Int e-21) (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Int e-22) (string-append ":" (CoreC-45Name-u--show_Show_Name e-10)))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (string-append "case block in " e-11))) ((7) (let ((e-13 (vector-ref arg-0 1))) (string-append "with block in " e-13))) (else (let ((e-15 (vector-ref arg-0 1))) (string-append "$resolved" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CoreC-45Name-u--showPrec_Show_Name (lambda (arg-0 arg-1) (CoreC-45Name-u--show_Show_Name arg-1)))
(define csegen-65 (cons (lambda (u--x) (CoreC-45Name-u--show_Show_Name u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Name-u--showPrec_Show_Name u--d u--x)))))
(define CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (case (vector-ref e-3 0) ((8) (let ((e-39 (vector-ref e-3 1))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 e-39) arg-1) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 (vector 1 e-1 e-2 (vector 8 e-39))) (let ((e-4 (unbox e-5))) (vector 1 (vector 1 e-1 e-2 (let ((e-27 (vector-ref e-4 1))) e-27)))))))) eff-0) clam-0)))))))(else (vector 1 arg-2))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (arg-3) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 e-7) arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (if (null? e-10) (vector 2 e-5 e-6 e-7 e-9) (let ((e-2 (unbox e-10))) (vector 2 e-5 (let ((e-1 (vector-ref e-2 1))) e-1) e-7 e-9))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-10 e-11 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-16) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-17) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-15 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-21) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-22) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-26) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-24 e-25 e-5))))) eff-0) clam-0))))))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-30) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-31) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-28 e-29 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-35) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-33 e-34 e-5))))) eff-0) clam-0))))))))) ((11) (let ((e-37 (vector-ref arg-2 1))) (let ((e-38 (vector-ref arg-2 2))) (case (vector-ref e-38 0) ((8) (let ((e-40 (vector-ref e-38 1))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 e-40) arg-1) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-5) (vector 1 (vector 11 e-37 (vector 8 e-40))) (let ((e-1 (unbox e-5))) (vector 1 (vector 11 e-37 (let ((e-24 (vector-ref e-1 1))) e-24)))))))) eff-0) clam-0)))))))(else (vector 1 arg-2))))))(else (vector 1 arg-2))))))
(define csegen-68 (cons (lambda (arg-7719) (lambda (arg-7722) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-7719 arg-7722))) (lambda (arg-7729) (lambda (arg-7732) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-7729 arg-7732)))))
(define csegen-84 (cons csegen-65 csegen-65))
(define SystemC-45Info-os (blodwen-os))
(define csegen-96 (PreludeC-45Types-elem csegen-14 csegen-22 SystemC-45Info-os (cons "windows" (cons "mingw32" (cons "cygwin32" '())))))
(define csegen-103 (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))
(define csegen-108 (lambda (arg-5904) (lambda (arg-5907) (+ arg-5904 arg-5907))))
(define csegen-109 (lambda (arg-5914) (lambda (arg-5917) (* arg-5914 arg-5917))))
(define csegen-110 (vector csegen-108 csegen-109 (lambda (arg-5924) (PreludeC-45Types-prim__integerToNat arg-5924))))
(define PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-3 1))) (arg-4 e-5))))))
(define csegen-150 (lambda (u--b) (lambda (u--a) (lambda (arg-10411) (lambda (arg-10414) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 arg-10411 arg-10414))))))
(define PreludeC-45Types-u--join_Monad_C-40EitherC-32C-36eC-41 (lambda (arg-2) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 arg-2 (lambda (eta-0) eta-0))))
(define csegen-151 (lambda (u--a) (lambda (arg-10425) (PreludeC-45Types-u--join_Monad_C-40EitherC-32C-36eC-41 arg-10425))))
(define PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) arg-4) (else (let ((e-5 (vector-ref arg-5 1))) ((arg-3 e-5) arg-4))))))
(define PreludeC-45Types-u--foldMap_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4 ext-0) (PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-3))) ((e-1 (arg-4 eta-0)) eta-1)))) (let ((e-2 (cdr arg-3))) e-2) ext-0)))
(define PreludeC-45Types-u--foldl_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-3 arg-4 arg-5) ((PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (eta-2 (eta-3 eta-4))))) (lambda (eta-2) (PreludeC-45Basics-flip arg-3 eta-0 eta-2)) eta-1))) (lambda (eta-0) eta-0) arg-5) arg-4)))
(define PreludeC-45Types-u--foldlM_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (PreludeC-45Types-u--foldl_Foldable_C-40EitherC-32C-36eC-41 (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-5 u--b eta-0)))))) (let ((e-1 (vector-ref arg-4 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-6))) ext-0)))
(define PreludeC-45Types-u--null_Foldable_C-40EitherC-32C-36eC-41 (lambda (arg-2) (case (vector-ref arg-2 0) ((0) 1) (else 0))))
(define PreludeC-45Types-u--toList_Foldable_C-40EitherC-32C-36eC-41 (lambda (ext-0) (PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 csegen-103 '() ext-0)))
(define csegen-167 (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldr_Foldable_C-40EitherC-32C-36eC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldl_Foldable_C-40EitherC-32C-36eC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-10911) (PreludeC-45Types-u--null_Foldable_C-40EitherC-32C-36eC-41 arg-10911))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (PreludeC-45Types-u--foldlM_Foldable_C-40EitherC-32C-36eC-41 i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-10940) (PreludeC-45Types-u--toList_Foldable_C-40EitherC-32C-36eC-41 arg-10940))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-10954) (PreludeC-45Types-u--foldMap_Foldable_C-40EitherC-32C-36eC-41 i_con-0 u--f arg-10954))))))))
(define PreludeC-45Types-u--traverse_Traversable_C-40EitherC-32C-36eC-41 (lambda (arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-4 1))) ((e-4 'erased) (vector 0 e-2))))) (else (let ((e-5 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-4 0))) ((((e-1 'erased) 'erased) (lambda (eta-0) (vector 1 eta-0))) (arg-5 e-5))))))))
(define csegen-171 (lambda (u--b) (lambda (u--a) (lambda (u--f) (lambda (i_con-0) (lambda (arg-14093) (lambda (arg-14100) (PreludeC-45Types-u--traverse_Traversable_C-40EitherC-32C-36eC-41 i_con-0 arg-14093 arg-14100))))))))
(define csegen-181 (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))
(define csegen-182 (lambda (__leftTupleSection-0) (lambda (__infixTupleSection-0) (cons __leftTupleSection-0 __infixTupleSection-0))))
(define PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AllBool (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) arg-1) (else 0))))
(define csegen-186 (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45InterfacesC-45BoolC-45Semigroup-u--C-60C-43C-62_Semigroup_AllBool arg-8474 arg-8477))) 1))
(define csegen-189 (vector (lambda (arg-5904) (lambda (arg-5907) (bs+ arg-5904 arg-5907 63))) (lambda (arg-5914) (lambda (arg-5917) (bs* arg-5914 arg-5917 63))) (lambda (arg-5924) (blodwen-toSignedInt arg-5924 63))))
(define PreludeC-45Num-u--div_Integral_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 63))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:128:3--130:40")))))))
(define PreludeC-45Num-u--mod_Integral_Int (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:131:3--133:40")))))))
(define csegen-235 (cons (vector csegen-189 (lambda (arg-6312) (lambda (arg-6315) (PreludeC-45Num-u--div_Integral_Int arg-6312 arg-6315))) (lambda (arg-6322) (lambda (arg-6325) (PreludeC-45Num-u--mod_Integral_Int arg-6322 arg-6325)))) (cons csegen-231 (vector csegen-189 (lambda (arg-6023) (bs- 0 arg-6023 63)) (lambda (arg-6029) (lambda (arg-6032) (bs- arg-6029 arg-6032 63)))))))
(define csegen-237 (vector (vector 2 ) 1 3 10))
(define PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (lambda (arg-2 arg-3) (if (null? arg-2) '() (let ((e-1 (unbox arg-2))) (if (null? arg-3) '() (let ((e-3 (unbox arg-3))) (box (e-1 e-3))))))))
(define csegen-255 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (PreludeC-45Types-u--map_Functor_Maybe u--func arg-8885))))) (lambda (u--a) (lambda (arg-9931) (box arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe arg-9937 arg-9944)))))))
(define PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (lambda (arg-1 arg-2) (if (null? arg-1) (arg-2) (let ((e-1 (unbox arg-1))) (box e-1)))))
(define csegen-258 (vector csegen-255 (lambda (u--a) '()) (lambda (u--a) (lambda (arg-10313) (lambda (arg-10316) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe arg-10313 arg-10316))))))
(define csegen-259 (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)))
(define IdrisC-45Syntax-u--full_HasNames_IFaceInfo (lambda (arg-0 arg-1 ext-0) (vector 1 arg-1)))
(define IdrisC-45Syntax-u--resolved_HasNames_IFaceInfo (lambda (arg-0 arg-1 ext-0) (vector 1 arg-1)))
(define csegen-262 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (IdrisC-45Syntax-u--full_HasNames_IFaceInfo arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (IdrisC-45Syntax-u--resolved_HasNames_IFaceInfo arg-7729 arg-7732 eta-0))))))
(define CoreC-45FC-showPos (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (string-append (PreludeC-45Show-u--show_Show_Int (bs+ e-2 1 63)) (string-append ":" (PreludeC-45Show-u--show_Show_Int (bs+ e-3 1 63))))))))
(define CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent (lambda (ext-0) (CoreC-45NameC-45Namespace-showNSWithSep "." ext-0)))
(define PreludeC-45Types-getAt (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) '() (let ((e-3 (car arg-2))) (box e-3))))(else (let ((e-1 (- arg-1 1))) (if (null? arg-2) '() (let ((e-7 (cdr arg-2))) (PreludeC-45Types-getAt e-1 e-7))))))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char<=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char>=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45Types-isDigit (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\0))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\9)) (else 0)))))
(define PreludeC-45Show-protectEsc (lambda (arg-0 arg-1 arg-2) (string-append arg-1 (string-append (let ((sc0 (PreludeC-45Show-firstCharIs arg-0 arg-2))) (cond ((equal? sc0 1) "\\&") (else ""))) arg-2))))
(define PreludeC-45EqOrd-u--C-62_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char>? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45Show-n--2439-11931-u--asciiTab (lambda (arg-0) (cons "NUL" (cons "SOH" (cons "STX" (cons "ETX" (cons "EOT" (cons "ENQ" (cons "ACK" (cons "BEL" (cons "BS" (cons "HT" (cons "LF" (cons "VT" (cons "FF" (cons "CR" (cons "SO" (cons "SI" (cons "DLE" (cons "DC1" (cons "DC2" (cons "DC3" (cons "DC4" (cons "NAK" (cons "SYN" (cons "ETB" (cons "CAN" (cons "EM" (cons "SUB" (cons "ESC" (cons "FS" (cons "GS" (cons "RS" (cons "US" '()))))))))))))))))))))))))))))))))))
(define PreludeC-45Show-showLitChar (lambda (arg-0) (cond ((equal? arg-0 (integer->char 7)) (lambda (arg-1) (string-append "\\a" arg-1))) ((equal? arg-0 (integer->char 8)) (lambda (arg-1) (string-append "\\b" arg-1))) ((equal? arg-0 (integer->char 12)) (lambda (arg-1) (string-append "\\f" arg-1))) ((equal? arg-0 (integer->char 10)) (lambda (arg-1) (string-append "\\n" arg-1))) ((equal? arg-0 (integer->char 13)) (lambda (arg-1) (string-append "\\r" arg-1))) ((equal? arg-0 (integer->char 9)) (lambda (arg-1) (string-append "\\t" arg-1))) ((equal? arg-0 (integer->char 11)) (lambda (arg-1) (string-append "\\v" arg-1))) ((equal? arg-0 (integer->char 14)) (lambda (eta-0) (PreludeC-45Show-protectEsc (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\H)) "\\SO" eta-0))) ((equal? arg-0 (integer->char 127)) (lambda (arg-1) (string-append "\\DEL" arg-1))) ((equal? arg-0 #\\) (lambda (arg-1) (string-append "\\\\" arg-1)))(else (lambda (clam-0) (let ((sc0 (PreludeC-45Types-getAt (PreludeC-45Types-prim__integerToNat (char->integer arg-0)) (PreludeC-45Show-n--2439-11931-u--asciiTab arg-0)))) (if (null? sc0) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Char arg-0 (integer->char 127)))) (cond ((equal? sc1 1) (string-cons #\\ (PreludeC-45Show-protectEsc (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) (PreludeC-45Show-u--show_Show_Int (cast-char-boundedInt arg-0 63)) clam-0))) (else (string-cons arg-0 clam-0)))) (let ((e-1 (unbox sc0))) (string-cons #\\ (string-append e-1 clam-0))))))))))
(define PreludeC-45Show-showLitString (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) clam-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (string-append "\\\"" ((PreludeC-45Show-showLitString e-3) clam-0)))(else ((PreludeC-45Show-showLitChar e-2) ((PreludeC-45Show-showLitString e-3) clam-0))))))))))
(define PreludeC-45Show-u--show_Show_String (lambda (arg-0) (string-cons #\" ((PreludeC-45Show-showLitString (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define CoreC-45FC-u--show_Show_VirtualIdent (lambda (arg-0) "(Interactive)"))
(define CoreC-45FC-u--show_Show_OriginDesc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_String e-1))) (else (let ((e-2 (vector-ref arg-0 1))) (CoreC-45FC-u--show_Show_VirtualIdent e-2))))))
(define CoreC-45FC-u--show_Show_FC (lambda (arg-0) (case (vector-ref arg-0 0) ((2) "EmptyFC") ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_OriginDesc e-0) (string-append ":" (string-append (CoreC-45FC-showPos e-1) (string-append "--" (CoreC-45FC-showPos e-2))))))))) (else (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_OriginDesc e-3) (string-append ":" (string-append (CoreC-45FC-showPos e-4) (string-append "--" (CoreC-45FC-showPos e-5))))))))))))
(define CoreC-45FC-u--showPrec_Show_FC (lambda (arg-0 arg-1) (CoreC-45FC-u--show_Show_FC arg-1)))
(define csegen-264 (cons (lambda (u--x) (CoreC-45FC-u--show_Show_FC u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45FC-u--showPrec_Show_FC u--d u--x)))))
(define csegen-265 (cons csegen-264 csegen-65))
(define csegen-266 (lambda (u--n) (string-append "." (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-265 u--n))))
(define PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-4)))
(define csegen-269 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-265 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-265 u--d u--x)))))
(define IdrisC-45Syntax-u--C-61C-61_Eq_Fixity (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define csegen-273 (lambda (eta-0) (IdrisC-45Syntax-u--C-61C-61_Eq_Fixity (let ((sc0 (Builtin-snd eta-0))) (let ((e-2 (vector-ref sc0 2))) e-2)) 3)))
(define CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-276 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent arg-686 arg-689)))))
(define CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-0 arg-1)))
(define CoreC-45NameC-45Namespace-u--C-60C-61_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--C-60_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-62C-61_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-62_Ord_ModuleIdent (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--max_Ord_ModuleIdent (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-62_Ord_ModuleIdent arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45NameC-45Namespace-u--min_Ord_ModuleIdent (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-60_Ord_ModuleIdent arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-284 (vector csegen-276 (lambda (arg-1566) (lambda (arg-1569) (CoreC-45NameC-45Namespace-u--compare_Ord_ModuleIdent arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45NameC-45Namespace-u--C-60_Ord_ModuleIdent arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45NameC-45Namespace-u--C-62_Ord_ModuleIdent arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45NameC-45Namespace-u--C-60C-61_Ord_ModuleIdent arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45NameC-45Namespace-u--C-62C-61_Ord_ModuleIdent arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45NameC-45Namespace-u--max_Ord_ModuleIdent arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45NameC-45Namespace-u--min_Ord_ModuleIdent arg-1626 arg-1629)))))
(define LibrariesC-45DataC-45SortedMap-empty (lambda (arg-2) (vector 0 arg-2)))
(define csegen-285 (LibrariesC-45DataC-45SortedMap-empty csegen-284))
(define LibrariesC-45TextC-45LexerC-45Core-pred (lambda (ext-0) (vector 4 ext-0)))
(define LibrariesC-45TextC-45Lexer-is (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 arg-0)))))
(define LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (lambda (ext-0 ext-1) (vector 8 ext-0 ext-1)))
(define LibrariesC-45TextC-45LexerC-45Core-empty (vector 0 ))
(define LibrariesC-45TextC-45Lexer-opt (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 arg-0 LibrariesC-45TextC-45LexerC-45Core-empty)))
(define LibrariesC-45TextC-45Lexer-some (lambda (arg-0) (vector 5 arg-0 (lambda () (LibrariesC-45TextC-45Lexer-many arg-0)))))
(define LibrariesC-45TextC-45Lexer-many (lambda (arg-0) (LibrariesC-45TextC-45Lexer-opt (LibrariesC-45TextC-45Lexer-some arg-0))))
(define csegen-303 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\#)))
(define csegen-305 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-is #\-)))
(define PreludeC-45Types-isLower (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\a))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\z)) (else 0)))))
(define PreludeC-45Types-isUpper (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\A))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\Z)) (else 0)))))
(define PreludeC-45Types-isAlpha (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isUpper arg-0))) (cond ((equal? sc0 1) 1) (else (PreludeC-45Types-isLower arg-0))))))
(define ParserC-45LexerC-45Common-isIdentStart (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\_) 1)(else (cond ((equal? arg-0 1) (let ((sc1 (PreludeC-45Types-isUpper arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (cast-int-char (blodwen-toSignedInt 160 63)))))))(else (let ((sc0 (PreludeC-45Types-isAlpha arg-1))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (cast-int-char (blodwen-toSignedInt 160 63))))))))))))
(define PreludeC-45Types-isAlphaNum (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isDigit arg-0))) (cond ((equal? sc0 1) 1) (else (PreludeC-45Types-isAlpha arg-0))))))
(define ParserC-45LexerC-45Common-isIdentTrailing (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 #\-) 1)(else (cond ((equal? arg-1 #\') 1) ((equal? arg-1 #\_) 1)(else (let ((sc1 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (cast-int-char (blodwen-toSignedInt 160 63)))))))))))(else (cond ((equal? arg-1 #\') 1) ((equal? arg-1 #\_) 1)(else (let ((sc0 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-1 (cast-int-char (blodwen-toSignedInt 160 63))))))))))))
(define csegen-771 (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 2 eta-0)))
(define ParserC-45LexerC-45Common-identNormal (vector 5 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentStart 2 eta-0))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45LexerC-45Core-pred csegen-771)))))
(define csegen-436 (vector 5 (LibrariesC-45TextC-45Lexer-is #\?) (lambda () ParserC-45LexerC-45Common-identNormal)))
(define LibrariesC-45TextC-45Lexer-isNot (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 arg-0)))))
(define csegen-459 (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot (integer->char 10))))
(define csegen-460 (vector 5 (LibrariesC-45TextC-45Lexer-is #\.) (lambda () ParserC-45LexerC-45Common-identNormal)))
(define csegen-469 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0))))
(define CoreC-45NameC-45Namespace-u--showPrec_Show_Namespace (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-u--show_Show_Namespace arg-1)))
(define csegen-487 (cons (lambda (u--x) (CoreC-45NameC-45Namespace-u--show_Show_Namespace u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45NameC-45Namespace-u--showPrec_Show_Namespace u--d u--x)))))
(define PreludeC-45Show-showArg (lambda (arg-1 arg-2) (string-append " " (let ((e-2 (cdr arg-1))) ((e-2 (vector 6 )) arg-2)))))
(define PreludeC-45Show-showCon (lambda (arg-0 arg-1 arg-2) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-0 (vector 6 )) (string-append arg-1 arg-2))))
(define CoreC-45Name-u--showPrec_Show_RawUNUserName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (PreludeC-45Show-showCon arg-0 "Basic " e-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45Show-showCon arg-0 "Field " e-1))) (else "Underscore"))))
(define CoreC-45Name-u--show_Show_RawUNUserName (lambda (arg-0) (CoreC-45Name-u--showPrec_Show_RawUNUserName (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_String (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_String arg-1)))
(define csegen-493 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_String u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_String u--d u--x)))))
(define csegen-495 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Int u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Int u--d u--x)))))
(define csegen-496 (cons csegen-495 csegen-495))
(define csegen-499 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-496 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-496 u--d u--x)))))
(define CoreC-45Name-u--showPrec_Show_RawName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "NS" (string-append (PreludeC-45Show-showArg csegen-487 e-0) (PreludeC-45Show-showArg (csegen-489) e-1)))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45Show-showCon arg-0 "UN" (PreludeC-45Show-showArg (cons (lambda (u--x) (CoreC-45Name-u--show_Show_RawUNUserName u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Name-u--showPrec_Show_RawUNUserName u--d u--x)))) e-2)))) ((2) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "MN" (string-append (PreludeC-45Show-showArg csegen-493 e-3) (PreludeC-45Show-showArg csegen-495 e-4)))))) ((3) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "PV" (string-append (PreludeC-45Show-showArg (csegen-489) e-5) (PreludeC-45Show-showArg csegen-495 e-6)))))) ((4) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "DN" (string-append (PreludeC-45Show-showArg csegen-493 e-7) (PreludeC-45Show-showArg (csegen-489) e-8)))))) ((5) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "Nested" (string-append (PreludeC-45Show-showArg csegen-499 e-9) (PreludeC-45Show-showArg (csegen-489) e-10)))))) ((6) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "CaseBlock" (string-append (PreludeC-45Show-showArg csegen-493 e-11) (PreludeC-45Show-showArg csegen-495 e-12)))))) ((7) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "WithBlock" (string-append (PreludeC-45Show-showArg csegen-493 e-13) (PreludeC-45Show-showArg csegen-495 e-14)))))) (else (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45Show-showCon arg-0 "Resolved" (PreludeC-45Show-showArg csegen-495 e-15)))))))
(define CoreC-45Name-u--show_Show_RawName (lambda (arg-0) (CoreC-45Name-u--showPrec_Show_RawName (vector 0 ) arg-0)))
(define csegen-489 (lambda () (cons (lambda (u--x) (CoreC-45Name-u--show_Show_RawName u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Name-u--showPrec_Show_RawName u--d u--x))))))
(define csegen-500 (lambda (arg-0) (lambda (arg-1) (let ((sc0 (or (and (char=? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1))))))
(define LibrariesC-45DataC-45StringC-45Extra-dropLast (lambda (arg-0 arg-1) (string-reverse (LibrariesC-45DataC-45StringC-45Extra-drop arg-0 (string-reverse arg-1)))))
(define DataC-45List-isPrefixOfBy (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) 1 (if (null? arg-4) 0 (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (let ((sc4 ((arg-2 e-1) e-4))) (cond ((equal? sc4 1) (DataC-45List-isPrefixOfBy arg-2 e-2 e-5)) (else 0)))))))))))
(define DataC-45String-strM (lambda (arg-0) (cond ((equal? arg-0 "") '())(else (cons (string-ref arg-0 0) (substring arg-0 1 (string-length arg-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--unsafeTextWithoutNewLines-10735 (lambda (arg-1 arg-2) (cond ((equal? arg-1 "") (if (null? arg-2) (vector 0 ) (let ((e-0 (car arg-2))) (let ((e-1 (cdr arg-2))) (let ((u--str (string-cons e-0 e-1))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 ""))) (cond ((equal? sc3 1) (vector 1 e-0)) (else (vector 2 (blodwen-toSignedInt (PreludeC-45TypesC-45String-length u--str) 63) u--str)))))))))(else (let ((e-0 (car arg-2))) (let ((e-1 (cdr arg-2))) (let ((u--str (string-cons e-0 e-1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 ""))) (cond ((equal? sc1 1) (vector 1 e-0)) (else (vector 2 (blodwen-toSignedInt (PreludeC-45TypesC-45String-length u--str) 63) u--str)))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--unsafeTextWithoutNewLines-10735 arg-1 (DataC-45String-strM arg-1))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41 (vector 0 ))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (arg-1 arg-2) (if (null? arg-2) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45Types-u--foldl_Foldable_List arg-1 e-2 e-3))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line (vector 4 (lambda () (vector 3 )) (lambda () (vector 1 #\ ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (lambda (ext-0 ext-1) (vector 5 ext-0 ext-1)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) u--y))) ext-0)))
(define DataC-45String-n--3979-9380-u--linesHelp (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (if (null? arg-2) '() (if (null? arg-2) (cons (PreludeC-45TypesC-45List-reverse arg-1) '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 (integer->char 10)) (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-3))) ((equal? e-2 (integer->char 13)) (if (null? e-3) (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-3)) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (cond ((equal? e-5 (integer->char 10)) (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-6)))(else (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-3))))))))(else (DataC-45String-n--3979-9380-u--linesHelp arg-0 (cons e-2 arg-1) e-3))))))) (if (null? arg-2) (cons (PreludeC-45TypesC-45List-reverse arg-1) '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 (integer->char 10)) (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-3))) ((equal? e-2 (integer->char 13)) (if (null? e-3) (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-3)) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (cond ((equal? e-5 (integer->char 10)) (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-6)))(else (cons (PreludeC-45TypesC-45List-reverse arg-1) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() e-3))))))))(else (DataC-45String-n--3979-9380-u--linesHelp arg-0 (cons e-2 arg-1) e-3)))))))))
(define PreludeC-45Types-n--10194-9458-u--unpackC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) arg-3) (else (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-0 (bs- arg-1 1 63) arg-2 (cons (string-ref arg-2 arg-1) arg-3)))))))
(define csegen-504 (cons (lambda (arg-11067) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45String-n--3979-9380-u--linesHelp (let ((sc0 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))))) 63) 1 63) 0) 1) 0))) (cond ((equal? sc0 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))) (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))))) 63) 1 63) 1 63) (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))) (cons (string-ref (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))) (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))))) 63) 1 63)) '())))(else '()))) '() (let ((sc0 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))))) 63) 1 63) 0) 1) 0))) (cond ((equal? sc0 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))) (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))))) 63) 1 63) 1 63) (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))) (cons (string-ref (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))) (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11067 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63) 1 63) arg-11067 (cons (string-ref arg-11067 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11067)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11067)) (else arg-11067))))) 63) 1 63)) '())))(else '())))))))) (lambda (arg-11073) (lambda (arg-11076) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45String-n--3979-9380-u--linesHelp (let ((sc0 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))))) 63) 1 63) 0) 1) 0))) (cond ((equal? sc0 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))) (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))))) 63) 1 63) 1 63) (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))) (cons (string-ref (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))) (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))))) 63) 1 63)) '())))(else '()))) '() (let ((sc0 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))))) 63) 1 63) 0) 1) 0))) (cond ((equal? sc0 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))) (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))))) 63) 1 63) 1 63) (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))) (cons (string-ref (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))) (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length (let ((sc1 (DataC-45List-isPrefixOfBy csegen-500 (cons (integer->char 10) '()) (PreludeC-45TypesC-45List-reverseOnto '() (let ((sc2 (or (and (< (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 0) 1) 0))) (cond ((equal? sc2 0) (PreludeC-45Types-n--10194-9458-u--unpackC-39 arg-11076 (bs- (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63) 1 63) arg-11076 (cons (string-ref arg-11076 (bs- (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (string-length arg-11076)) 63) 1 63)) '())))(else '()))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-11076)) (else arg-11076))))) 63) 1 63)) '())))(else '())))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 (lambda (arg-2 arg-3) (let ((e-2 (car arg-2))) (e-2 arg-3))))
(define csegen-505 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "_"))
(define DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (car arg-1))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) (vector 0 (vector 0 ))) (else (vector 1 (lambda (eta-0) (vector 0 ))))))))
(define DecidableC-45Equality-u--decEq_DecEq_Int (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a csegen-223 ext-0 ext-1)))
(define csegen-507 (lambda (eta-0) (lambda (eta-1) (DecidableC-45Equality-u--decEq_DecEq_Int eta-0 eta-1))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_Char (lambda (arg-0) (cond ((equal? arg-0 (integer->char 10)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)(else (vector 1 arg-0)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--prettyPrec_Pretty_Void_Char (lambda (arg-0 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_Char arg-1)))
(define csegen-681 (cons (lambda (arg-11067) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_Char arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--prettyPrec_Pretty_Void_Char arg-11073 arg-11076)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\.))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-2 arg-1) arg-3)))
(define csegen-510 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot eta-0 eta-1))))
(define DecidableC-45Equality-u--decEq_DecEq_String (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a csegen-22 ext-0 ext-1)))
(define csegen-511 (lambda (eta-0) (lambda (eta-1) (DecidableC-45Equality-u--decEq_DecEq_String eta-0 eta-1))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Volume (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-3))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-3 e-4)) (else 0))))))(else 0)))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-2 e-5)))(else 0))))(else 0))))
(define LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Volume (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Volume arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-524 (cons (lambda (arg-676) (lambda (arg-679) (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Volume arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Volume arg-686 arg-689)))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-1)))(else 0))))(else 0))))
(define LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Body (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-527 (cons (lambda (arg-676) (lambda (arg-679) (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Body arg-686 arg-689)))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_PathTokenKind (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) 1 0) (let ((e-0 (unbox arg-0))) (if (null? arg-1) 0 (let ((e-1 (unbox arg-1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 e-1)))))))
(define LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_PathTokenKind (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_PathTokenKind arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45UtilsC-45Path-u--TokType_TokenKind_PathTokenKind (lambda (arg-0) (if (null? arg-0) (vector "String" ) (vector "Builtin.Unit" ))))
(define LibrariesC-45UtilsC-45Path-u--tokValue_TokenKind_PathTokenKind (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (vector 0 ))))
(define csegen-533 (cons (cons (lambda (arg-676) (lambda (arg-679) (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_PathTokenKind arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_PathTokenKind arg-686 arg-689)))) (cons (lambda (arg-823) (LibrariesC-45UtilsC-45Path-u--TokType_TokenKind_PathTokenKind arg-823)) (lambda (u--kind) (lambda (arg-832) (LibrariesC-45UtilsC-45Path-u--tokValue_TokenKind_PathTokenKind u--kind arg-832))))))
(define LibrariesC-45TextC-45Parser-match (lambda (arg-2 arg-3) (vector 1 "Unrecognised input" (lambda (u--t) (let ((sc0 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) ((e-1 (let ((e-4 (car u--t))) e-4)) arg-3))))) (cond ((equal? sc0 1) (box (let ((sc1 (Builtin-snd arg-2))) (let ((e-2 (cdr sc1))) ((e-2 arg-3) (let ((e-3 (cdr u--t))) e-3)))))) (else '())))))))
(define csegen-534 (LibrariesC-45TextC-45Parser-match csegen-533 '()))
(define csegen-542 (LibrariesC-45TextC-45Parser-match csegen-533 (box #\\)))
(define LibrariesC-45UtilsC-45Path-bodySeparator (vector 13 1 1 csegen-542 (lambda () (LibrariesC-45TextC-45Parser-match csegen-533 (box #\/)))))
(define csegen-536 (vector 9 1 csegen-534 (lambda () (lambda (u--server) (vector 11 1 LibrariesC-45UtilsC-45Path-bodySeparator (lambda () (vector 9 0 csegen-534 (lambda () (lambda (u--share) (vector 0 (vector 0 u--server u--share)))))))))))
(define LibrariesC-45TextC-45Quantity-exactly (lambda (arg-0) (cons arg-0 (box arg-0))))
(define DataC-45Nat-isSucc (lambda (arg-0) (cond ((equal? arg-0 0) 0)(else 1))))
(define csegen-541 (DataC-45Nat-isSucc (let ((sc0 (LibrariesC-45TextC-45Quantity-exactly 2))) (let ((e-0 (car sc0))) e-0))))
(define LibrariesC-45TextC-45Quantity-atLeast (lambda (arg-0) (cons arg-0 '())))
(define LibrariesC-45TextC-45Quantity-atMost (lambda (arg-0) (cons 0 (box arg-0))))
(define LibrariesC-45TextC-45Quantity-between (lambda (arg-0 arg-1) (cons arg-0 (box arg-1))))
(define LibrariesC-45TextC-45Parser-count1 (lambda (arg-3 arg-4) (vector 9 (let ((sc0 (DataC-45Nat-isSucc (let ((e-0 (car arg-3))) e-0)))) (cond ((equal? sc0 1) 1) (else 0))) arg-4 (lambda () (lambda (u--x) (vector 10 (DataC-45Nat-isSucc (let ((e-0 (car arg-3))) e-0)) 0 (LibrariesC-45TextC-45Parser-count arg-3 arg-4) (lambda (u--xs) (vector 0 (cons u--x u--xs)))))))))
(define LibrariesC-45TextC-45Parser-option (lambda (arg-3 arg-4 arg-5) (cond ((equal? arg-3 0) (vector 13 0 0 arg-5 (lambda () (vector 0 arg-4)))) (else (vector 13 1 0 arg-5 (lambda () (vector 0 arg-4)))))))
(define LibrariesC-45TextC-45Parser-some (lambda (arg-3) (vector 9 0 arg-3 (lambda () (lambda (bind-0) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many arg-3) (lambda (bind-1) (vector 0 (cons bind-0 bind-1)))))))))
(define LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 (lambda (arg-4 arg-5 arg-6) (cond ((equal? arg-4 0) (case (vector-ref arg-6 0) ((0) (let ((e-65 (vector-ref arg-6 1))) (vector 0 (arg-5 e-65))))(else (case (vector-ref arg-6 0) ((4) (let ((e-49 (vector-ref arg-6 1))) (let ((e-50 (vector-ref arg-6 2))) (let ((e-51 (vector-ref arg-6 3))) (vector 4 e-49 e-50 e-51))))) ((6) (let ((e-56 (vector-ref arg-6 1))) (vector 6 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-56)))) ((8) (let ((e-61 (vector-ref arg-6 1))) (vector 8 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-61))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((1) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (vector 1 e-43 (lambda (eta-0) (PreludeC-45Types-u--map_Functor_Maybe arg-5 (e-44 eta-0)))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))))))))))(else (case (vector-ref arg-6 0) ((4) (let ((e-49 (vector-ref arg-6 1))) (let ((e-50 (vector-ref arg-6 2))) (let ((e-51 (vector-ref arg-6 3))) (vector 4 e-49 e-50 e-51))))) ((6) (let ((e-56 (vector-ref arg-6 1))) (vector 6 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-56)))) ((8) (let ((e-61 (vector-ref arg-6 1))) (vector 8 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 arg-5 e-61))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((1) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (vector 1 e-43 (lambda (eta-0) (PreludeC-45Types-u--map_Functor_Maybe arg-5 (e-44 eta-0)))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))))))(else (case (vector-ref arg-6 0) ((13) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (let ((e-39 (vector-ref arg-6 4))) (vector 13 e-36 e-37 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-36 arg-5 e-38) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-37 arg-5 (e-39)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((9) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 9 e-30 e-31 (lambda () (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-30 arg-5 ((e-32) u--val)))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))))))(else (case (vector-ref arg-6 0) ((10) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((e-25 (vector-ref arg-6 4))) (vector 10 e-22 e-23 e-24 (lambda (u--val) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-23 arg-5 (e-25 u--val)))))))))(else (cond ((equal? arg-4 1) (case (vector-ref arg-6 0) ((11) (let ((e-15 (vector-ref arg-6 1))) (let ((e-16 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 3))) (vector 11 e-15 e-16 (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-15 arg-5 (e-17))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0)))))))))))(else (case (vector-ref arg-6 0) ((12) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((e-5 (vector-ref arg-6 3))) (let ((e-6 (vector-ref arg-6 4))) (vector 12 e-3 e-4 e-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 e-4 arg-5 e-6))))))) ((14) (let ((e-11 (vector-ref arg-6 1))) (vector 10 arg-4 0 (vector 14 e-11) (lambda (eta-0) (vector 0 (arg-5 eta-0))))))(else (cond (else (vector 10 0 0 arg-6 (lambda (eta-0) (vector 0 (arg-5 eta-0))))))))))))))))))))))))
(define LibrariesC-45TextC-45Parser-many (lambda (arg-3) (LibrariesC-45TextC-45Parser-option 1 '() (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some arg-3)))))
(define LibrariesC-45TextC-45Parser-count (lambda (arg-3 arg-4) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-0 0) (if (null? e-1) (LibrariesC-45TextC-45Parser-many arg-4) (let ((e-5 (unbox e-1))) (cond ((equal? e-5 0) (vector 0 '()))(else (let ((e-6 (- e-5 1))) (LibrariesC-45TextC-45Parser-option 1 '() (LibrariesC-45TextC-45Parser-count1 (LibrariesC-45TextC-45Quantity-atMost e-6) arg-4))))))))(else (let ((e-2 (- e-0 1))) (if (null? e-1) (LibrariesC-45TextC-45Parser-count1 (LibrariesC-45TextC-45Quantity-atLeast e-2) arg-4) (let ((e-9 (unbox e-1))) (cond ((equal? e-9 0) (vector 4 '() 0 "Quantity out of order"))(else (let ((e-10 (- e-9 1))) (LibrariesC-45TextC-45Parser-count1 (LibrariesC-45TextC-45Quantity-between (+ e-2 1) e-10) arg-4)))))))))))))
(define csegen-544 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 csegen-541 (lambda (eta-0) (vector 0 )) (LibrariesC-45TextC-45Parser-count (LibrariesC-45TextC-45Quantity-exactly 2) csegen-542)))
(define csegen-547 (vector 11 1 (LibrariesC-45TextC-45Parser-match csegen-533 (box #\?)) (lambda () (vector 11 0 csegen-542 (lambda () (vector 0 (vector 0 )))))))
(define SystemC-45Info-isWindows csegen-96)
(define LibrariesC-45UtilsC-45Path-pathSeparator (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) #\;) (else #\:))))
(define csegen-574 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 LibrariesC-45UtilsC-45Path-pathSeparator)))
(define LibrariesC-45TextC-45Parser-optional (lambda (arg-3 arg-4) (LibrariesC-45TextC-45Parser-option arg-3 '() (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-3 (lambda (eta-0) (box eta-0)) arg-4))))
(define csegen-579 (LibrariesC-45TextC-45Parser-optional 1 (LibrariesC-45TextC-45Parser-some LibrariesC-45UtilsC-45Path-bodySeparator)))
(define PreludeC-45Types-isSpace (lambda (arg-0) (cond ((equal? arg-0 #\ ) 1) ((equal? arg-0 (integer->char 9)) 1) ((equal? arg-0 (integer->char 13)) 1) ((equal? arg-0 (integer->char 10)) 1) ((equal? arg-0 (integer->char 12)) 1) ((equal? arg-0 (integer->char 11)) 1) ((equal? arg-0 (integer->char 160)) 1)(else 0))))
(define csegen-597 (lambda (u--char) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--char #\.))) (cond ((equal? sc0 1) 1) (else (PreludeC-45Types-isSpace u--char))))))
(define csegen-602 (cons (cons "End of input" '()) '()))
(define LibrariesC-45TextC-45Lexer-any (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) 1)))
(define LibrariesC-45TextC-45Lexer-escape (lambda (arg-0 arg-1) (vector 5 arg-0 (lambda () arg-1))))
(define csegen-647 (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-escape (LibrariesC-45TextC-45Lexer-is #\\) LibrariesC-45TextC-45Lexer-any) LibrariesC-45TextC-45Lexer-any))
(define csegen-649 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isSpace eta-0))))
(define csegen-678 (lambda (arg-0) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-0 (integer->char 10))))
(define csegen-679 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 (integer->char 10))))
(define DataC-45List-isSuffixOfBy (lambda (arg-2 arg-3 arg-4) (DataC-45List-isPrefixOfBy arg-2 (PreludeC-45TypesC-45List-reverse arg-3) (PreludeC-45TypesC-45List-reverse arg-4))))
(define DataC-45List-isSuffixOf (lambda (arg-1 ext-0 ext-1) (DataC-45List-isSuffixOfBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45String-isSuffixOf (lambda (arg-0 arg-1) (DataC-45List-isSuffixOf csegen-17 (PreludeC-45Types-fastUnpack arg-0) (PreludeC-45Types-fastUnpack arg-1))))
(define DataC-45String-linesC-39 (lambda (arg-0) (DataC-45String-n--3979-9380-u--linesHelp arg-0 '() arg-0)))
(define DataC-45String-lines (lambda (arg-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45String-linesC-39 (PreludeC-45Types-fastUnpack arg-0)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (lambda (arg-0) (let ((u--strC-39 (let ((sc0 (DataC-45String-isSuffixOf "\xa;" arg-0))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Extra-dropLast 1 arg-0)) (else arg-0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unsafeTextWithoutNewLines eta-0)) (DataC-45String-lines u--strC-39))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--prettyPrec_Pretty_Void_String (lambda (arg-0 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String arg-1)))
(define csegen-702 (cons (lambda (arg-11067) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--prettyPrec_Pretty_Void_String arg-11073 arg-11076)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 (vector 1 #\ )) arg-2)))
(define csegen-716 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 eta-0 eta-1))))
(define csegen-717 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 eta-0 eta-1))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-722 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Integer arg-686 arg-689)))))
(define csegen-753 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 eta-0)))
(define csegen-755 (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))
(define csegen-765 (vector 5 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentStart 1 eta-0))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 1 eta-0)))))))
(define csegen-779 (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentTrailing 0 eta-0)))
(define LibrariesC-45DataC-45SortedMap-treeInsertC-39 (lambda (arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (let ((sc1 (let ((e-2 (vector-ref arg-4 1))) ((e-2 arg-5) e-3)))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-5 arg-6) (cons arg-5 (vector 0 e-3 e-4))))) ((equal? sc1 1) (vector 0 (vector 0 arg-5 arg-6))) (else (vector 1 (cons (vector 0 e-3 e-4) (cons e-3 (vector 0 arg-5 arg-6)))))))))) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 3))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-10)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-9))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-10 e-11)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-12 (cdr e-5))) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (vector 0 (vector 2 e-8 e-14 e-13 e-10 e-11))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-11))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-9 e-10 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-12 (cdr e-5))) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (vector 0 (vector 2 e-9 e-10 e-8 e-14 e-13))))))))))))))))) (else (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-19 (vector-ref arg-7 4))) (let ((e-20 (vector-ref arg-7 5))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-17)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-16))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-17 e-18 e-19 e-20)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-12 e-13) (cons e-17 (vector 1 e-18 e-19 e-20))))))))))))) (else (let ((sc2 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-19)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-18))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-16 e-17 e-2 e-19 e-20)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (cons (vector 1 e-16 e-17 e-8) (cons e-12 (vector 1 e-13 e-19 e-20))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 e-20))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-16 e-17 e-18 e-19 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (cons (vector 1 e-16 e-17 e-18) (cons e-19 (vector 1 e-8 e-12 e-13)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-treeInsert (lambda (arg-4 arg-5 arg-6 arg-7) (let ((sc0 (LibrariesC-45DataC-45SortedMap-treeInsertC-39 arg-4 arg-5 arg-6 arg-7))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45SortedMap-insert (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (vector 1 e-2 0 (vector 0 arg-2 arg-3)))) (else (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-treeInsert e-5 arg-2 arg-3 e-7))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 1 e-5 e-6 e-2))) (else (let ((e-8 (vector-ref sc1 1))) (vector 1 e-5 (+ e-6 1) e-8))))))))))))
(define csegen-790 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Basics-uncurry (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (LibrariesC-45DataC-45SortedMap-insert eta-3 eta-4 eta-5)))) eta-2)) eta-0 eta-1))))
(define csegen-829 (cons 0 (cons 1 '())))
(define IdrisC-45SyntaxC-45Pragmas-allLangExts csegen-829)
(define IdrisC-45SyntaxC-45Pragmas-u--show_Show_LangExt (lambda (arg-0) (cond ((equal? arg-0 0) "ElabReflection") (else "Borrowing"))))
(define csegen-800 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Pragmas-u--show_Show_LangExt eta-0)) IdrisC-45SyntaxC-45Pragmas-allLangExts))
(define CoreC-45Name-u--C-47C-61_Eq_Name (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-832 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45Name-u--C-61C-61_Eq_Name arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45Name-u--C-47C-61_Eq_Name arg-686 arg-689)))))
(define PreludeC-45Show-n--3221-12652-u--showC-39 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-3) (string-append arg-3 (let ((e-1 (car arg-1))) (e-1 e-2))) (PreludeC-45Show-n--3221-12652-u--showC-39 arg-1 arg-2 (string-append arg-3 (string-append (let ((e-1 (car arg-1))) (e-1 e-2)) ", ")) e-3)))))))
(define PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (string-append "[" (string-append (PreludeC-45Show-n--3221-12652-u--showC-39 arg-1 arg-2 "" arg-2) "]"))))
(define AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega (lambda (arg-0) (cond ((equal? arg-0 0) "Rig0") ((equal? arg-0 1) "Rig1") (else "RigW"))))
(define csegen-851 (lambda (u--nm) (string-append " proof " (CoreC-45Name-u--show_Show_Name u--nm))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-2) (string-append " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-3)))))) ((1) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((e-9 (vector-ref arg-2 5))) (let ((e-11 (vector-ref arg-2 7))) (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-6) (string-append " with (" (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-7) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-8) (string-append ")" (string-append (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-851) e-9) (string-append "\xa;\x9;" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-11))))))))))))))) (else (let ((e-14 (vector-ref arg-2 2))) (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-14) " impossible"))))))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 arg-3)))
(define DataC-45List-mergeReplicate (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons arg-1 (cons e-2 (DataC-45List-mergeReplicate arg-1 e-3))))))))
(define DataC-45List-intersperse (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons e-2 (DataC-45List-mergeReplicate arg-1 e-3)))))))
(define PreludeC-45Show-u--show_Show_Bool (lambda (arg-0) (cond ((equal? arg-0 1) "True") (else "False"))))
(define TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) "%unsafe") ((1) "%inline") ((2) "%noinline") ((3) "%deprecate") ((4) "%tcinline") ((5) (let ((e-6 (vector-ref arg-2 1))) (string-append "%hint " (PreludeC-45Show-u--show_Show_Bool e-6)))) ((6) (let ((e-8 (vector-ref arg-2 1))) (string-append "%globalhint " (PreludeC-45Show-u--show_Show_Bool e-8)))) ((7) "%extern") ((8) (let ((e-11 (vector-ref arg-2 1))) (string-append "%foreign " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 eta-0)) e-11))))) ((9) (let ((e-13 (vector-ref arg-2 1))) (string-append "%export " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 eta-0)) e-13))))) ((10) "%invertible") ((11) (let ((e-16 (vector-ref arg-2 1))) (cond ((equal? e-16 0) "total") ((equal? e-16 1) "covering") (else "partial")))) ((12) "%macro") (else (let ((e-19 (vector-ref arg-2 1))) (string-append "%spec " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-19))))))))
(define TTImpC-45TTImp-u--showPrec_Show_C-40FnOptC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 arg-1 arg-3)))
(define CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) "Implicit") ((1) "Explicit") ((2) "AutoImplicit") (else (let ((e-4 (vector-ref arg-2 1))) (string-append "DefImplicit " (let ((e-1 (car arg-1))) (e-1 e-4))))))))
(define CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (string-append "(%claim " (string-append (CoreC-45Name-u--show_Show_Name e-3) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-4) ")"))))))))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ImpTyC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 arg-3)))
(define TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 5))) (if (null? e-3) (string-append "(%data " (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-5) ")")))) (let ((e-11 (unbox e-3))) (string-append "(%data " (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-11) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-5) ")")))))))))))) (else (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (string-append "(%datadecl " (string-append (CoreC-45Name-u--show_Show_Name e-8) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-9) ")"))))))))))
(define TTImpC-45TTImp-u--show_Show_C-40IFieldC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((1) (string-append (CoreC-45Name-u--show_Show_Name e-4) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5))))(else (string-append "{" (string-append (CoreC-45Name-u--show_Show_Name e-4) (string-append " : " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5) "}")))))))))))
(define AlgebraC-45ZeroOneOmega-u--showPrec_Show_ZeroOneOmega (lambda (arg-0 arg-1) (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega arg-1)))
(define csegen-849 (cons (lambda (u--x) (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega u--x)) (lambda (u--d) (lambda (u--x) (AlgebraC-45ZeroOneOmega-u--showPrec_Show_ZeroOneOmega u--d u--x)))))
(define TTImpC-45TTImp-u--show_Show_C-40ImpRecordC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-5 (vector-ref arg-2 4))) (let ((e-6 (vector-ref arg-2 5))) (string-append "record " (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (u--d) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-3)))) x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) u--d x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (u--d) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-3) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-3 x-3)))) d-2 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-2) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x)))) e-3) (string-append " " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append "\xa;\x9;" (string-append (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40IFieldC-39C-32C-36nmC-41 arg-1 eta-0)) e-6)) "\xa;"))))))))))))))
(define CoreC-45Context-u--show_Show_BuiltinType (lambda (arg-0) (cond ((equal? arg-0 0) "Natural") ((equal? arg-0 1) "NaturalToInteger") (else "IntegerToNatural"))))
(define PreludeC-45Show-u--show_Show_Nat (lambda (arg-0) (PreludeC-45Show-u--show_Show_Integer arg-0)))
(define TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40FnOptC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-4) (string-append " " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-2) (string-append " " (TTImpC-45TTImp-u--show_Show_C-40ImpTyC-39C-32C-36nmC-41 arg-1 e-5))))))))) ((1) (let ((e-10 (vector-ref arg-2 4))) (TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 arg-1 e-10))) ((2) (let ((e-13 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 3))) (string-append "(%def " (string-append (CoreC-45Name-u--show_Show_Name e-13) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-14) ")"))))))) ((3) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (string-append "parameters " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (u--d) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-3)))) x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) u--d x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (u--d) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-0) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-3)))) x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) d-0 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-0) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-1) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-3)))) x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) d-1 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-1) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-2) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-3)))) x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (x-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-3)) (lambda (d-3) (lambda (x-3) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-3 x-3)))) d-2 x-2)))) (cons (lambda (x-2) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 x-2)) (lambda (d-2) (lambda (x-2) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x)))) e-17) (string-append "\xa;\x9;" (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 eta-0)) e-18)))))))) ((4) (let ((e-24 (vector-ref arg-2 5))) (TTImpC-45TTImp-u--show_Show_C-40ImpRecordC-39C-32C-36nmC-41 arg-1 e-24))) ((5) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (string-append "fail" (string-append (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-0) (string-append " " (PreludeC-45Show-u--show_Show_String eta-0)))) e-27) (string-append "\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (string-append "  " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 eta-0))) e-28)))))))) ((6) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (string-append "namespace " (string-append (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-31) (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 eta-0)) e-32))))))) ((7) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (string-append "%transform " (string-append (CoreC-45Name-u--show_Show_Name e-35) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-36) (string-append " ==> " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-37)))))))))) ((8) (let ((e-40 (vector-ref arg-2 2))) (string-append "%runElab " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-40)))) ((9) "[externally defined pragma]") ((10) (let ((e-46 (vector-ref arg-2 1))) (if (null? e-46) "%logging off" (let ((e-53 (unbox e-46))) (let ((e-56 (car e-53))) (let ((e-57 (cdr e-53))) (string-append "%logging " (if (null? e-56) (PreludeC-45Show-u--show_Show_Nat e-57) (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse "." e-56)) (string-append " " (PreludeC-45Show-u--show_Show_Nat e-57))))))))))) (else (let ((e-49 (vector-ref arg-2 2))) (let ((e-50 (vector-ref arg-2 3))) (string-append "%builtin " (string-append (CoreC-45Context-u--show_Show_BuiltinType e-49) (string-append " " (CoreC-45Name-u--show_Show_Name e-50))))))))))
(define TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 arg-3)))
(define PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) "Nothing" (let ((e-2 (unbox arg-3))) (PreludeC-45Show-showCon arg-2 "Just" (PreludeC-45Show-showArg arg-1 e-2))))))
(define TTImpC-45TTImp-u--show_Show_C-40IFieldUpdateC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (string-append (CoreC-45NameC-45Namespace-showSep "->" e-1) (string-append " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-2)))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (string-append (CoreC-45NameC-45Namespace-showSep "->" e-4) (string-append " $= " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-5)))))))))
(define PreludeC-45Show-u--showPrec_Show_Bits16 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Bits16 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits16 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Bits32 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Bits32 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits32 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Bits64 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Bits64 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits64 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Bits8 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Bits8 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Bits8 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--show_Show_Char (lambda (arg-0) (cond ((equal? arg-0 #\') "'\\''")(else (string-cons #\' ((PreludeC-45Show-showLitChar arg-0) "'"))))))
(define PreludeC-45Show-u--showPrec_Show_Double (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Double (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Double (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Int16 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Int16 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int16 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Int32 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Int32 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int32 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Int64 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Int64 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int64 (vector 0 ) arg-0)))
(define PreludeC-45Show-u--showPrec_Show_Int8 (lambda (ext-0 ext-1) (PreludeC-45Show-primNumShow (lambda (eta-0) (number->string eta-0)) ext-0 ext-1)))
(define PreludeC-45Show-u--show_Show_Int8 (lambda (arg-0) (PreludeC-45Show-u--showPrec_Show_Int8 (vector 0 ) arg-0)))
(define CoreC-45TTC-45Primitive-u--show_Show_PrimType (lambda (arg-0) (cond ((equal? arg-0 0) "Int") ((equal? arg-0 1) "Int8") ((equal? arg-0 2) "Int16") ((equal? arg-0 3) "Int32") ((equal? arg-0 4) "Int64") ((equal? arg-0 5) "Integer") ((equal? arg-0 6) "Bits8") ((equal? arg-0 7) "Bits16") ((equal? arg-0 8) "Bits32") ((equal? arg-0 9) "Bits64") ((equal? arg-0 10) "String") ((equal? arg-0 11) "Char") ((equal? arg-0 12) "Double") (else "%World"))))
(define CoreC-45TTC-45Primitive-u--show_Show_Constant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int64 e-4))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((6) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits8 e-6))) ((7) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits16 e-7))) ((8) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits32 e-8))) ((9) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits64 e-9))) ((10) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_String e-10))) ((11) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Char e-11))) ((12) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Double e-12))) ((13) (let ((e-13 (vector-ref arg-0 1))) (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-13))) (else "%MkWorld"))))
(define CoreC-45OptionsC-45Log-u--show_Show_LogLevel (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (if (null? e-0) (PreludeC-45Show-u--show_Show_Nat e-1) (string-append (PreludeC-45Types-fastConcat (DataC-45List-intersperse "." e-0)) (string-append ":" (PreludeC-45Show-u--show_Show_Nat e-1))))))))
(define TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (car arg-1))) (e-4 e-2)))) ((1) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (string-append "(%pi " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-5) (string-append " " (string-append (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-6) (string-append " " (string-append (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-65 (vector 6 ) e-7) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-8) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-9) ")")))))))))))))))) ((2) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((e-15 (vector-ref arg-2 5))) (let ((e-16 (vector-ref arg-2 6))) (string-append "(%lam " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-12) (string-append " " (string-append (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-13) (string-append " " (string-append (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-65 (vector 6 ) e-14) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-15) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-16) ")")))))))))))))))) ((3) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (let ((e-23 (vector-ref arg-2 6))) (let ((e-24 (vector-ref arg-2 7))) (string-append "(%let " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-20) (string-append " " (string-append " " (string-append (CoreC-45Name-u--show_Show_Name e-21) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-22) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-23) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-24) ")"))))))))))))))))) ((4) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((e-30 (vector-ref arg-2 5))) (string-append "(%case (" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-28) (string-append " : " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-29) (string-append ") " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-30) ")")))))))))) ((5) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (string-append "(%local (" (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-33) (string-append ") " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-34) ")"))))))) ((6) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (let ((e-40 (vector-ref arg-2 5))) (string-append "(%caselocal (" (string-append (CoreC-45Name-u--show_Show_Name e-37) (string-append " " (string-append (CoreC-45Name-u--show_Show_Name e-38) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-39) (string-append ") " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-40) ")"))))))))))))) ((7) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (string-append "(%record " (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40IFieldUpdateC-39C-32C-36nmC-41 arg-1 eta-0)) e-43)) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-44) ")"))))))) ((8) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (string-append "(" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-47) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-48) ")"))))))) ((10) (let ((e-51 (vector-ref arg-2 2))) (let ((e-52 (vector-ref arg-2 3))) (let ((e-53 (vector-ref arg-2 4))) (string-append "(" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-51) (string-append " [" (string-append (CoreC-45Name-u--show_Show_Name e-52) (string-append " = " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-53) "])")))))))))) ((9) (let ((e-56 (vector-ref arg-2 2))) (let ((e-57 (vector-ref arg-2 3))) (string-append "(" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-56) (string-append " [" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-57) "])"))))))) ((11) (let ((e-60 (vector-ref arg-2 2))) (let ((e-61 (vector-ref arg-2 3))) (string-append "(" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-60) (string-append " | " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-61) ")"))))))) ((12) "%search") ((13) (let ((e-68 (vector-ref arg-2 3))) (string-append "(|" (string-append (CoreC-45NameC-45Namespace-showSep "," (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 eta-0)) e-68)) "|)")))) ((14) (let ((e-71 (vector-ref arg-2 2))) (let ((e-72 (vector-ref arg-2 3))) (string-append "(%rewrite (" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-71) (string-append ") (" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-72) "))"))))))) ((15) (let ((e-75 (vector-ref arg-2 2))) (string-append "(%coerced " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-75) ")")))) ((16) (let ((e-79 (vector-ref arg-2 3))) (string-append "(%bindhere " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-79) ")")))) ((17) (let ((e-82 (vector-ref arg-2 2))) (string-append "$" e-82))) ((18) (let ((e-87 (vector-ref arg-2 4))) (let ((e-88 (vector-ref arg-2 5))) (string-append (CoreC-45Name-u--show_Show_Name e-87) (string-append "@(" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-88) ")")))))) ((19) (let ((e-92 (vector-ref arg-2 3))) (string-append ".(" (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-92) ")")))) ((20) (let ((e-96 (vector-ref arg-2 3))) (string-append "(%delayed " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-96) ")")))) ((21) (let ((e-99 (vector-ref arg-2 2))) (string-append "(%delay " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-99) ")")))) ((22) (let ((e-102 (vector-ref arg-2 2))) (string-append "(%force " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-102) ")")))) ((23) (let ((e-105 (vector-ref arg-2 2))) (string-append "(%quote " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-105) ")")))) ((24) (let ((e-108 (vector-ref arg-2 2))) (string-append "(%quotename " (string-append (CoreC-45Name-u--show_Show_Name e-108) ")")))) ((25) (let ((e-111 (vector-ref arg-2 2))) (string-append "(%quotedecl " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 arg-1 u--d u--x)))) e-111) ")")))) ((26) (let ((e-114 (vector-ref arg-2 2))) (string-append "(%unquote " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-114) ")")))) ((27) (let ((e-118 (vector-ref arg-2 3))) (string-append "(%runelab " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-118) ")")))) ((28) (let ((e-121 (vector-ref arg-2 2))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-121))) ((30) (let ((e-124 (vector-ref arg-2 2))) (string-append "?" e-124))) ((31) (let ((e-127 (vector-ref arg-2 2))) (let ((e-128 (vector-ref arg-2 3))) (string-append "(%logging " (string-append (CoreC-45OptionsC-45Log-u--show_Show_LogLevel e-127) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-128) ")"))))))) ((29) "%type") ((32) (let ((e-133 (vector-ref arg-2 2))) (cond ((equal? e-133 1) "_") (else "?")))) (else (let ((e-136 (vector-ref arg-2 2))) (let ((e-137 (vector-ref arg-2 3))) (string-append "(%with " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-269 e-136) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 e-137) ")"))))))))))
(define TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 arg-1 arg-3)))
(define csegen-835 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--d u--x)))))
(define csegen-838 (cons (lambda (u--x) (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 csegen-835 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Binder-u--showPrec_Show_C-40PiInfoC-32C-36tC-41 csegen-835 u--d u--x)))))
(define csegen-839 (cons csegen-65 csegen-838))
(define PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (unbox arg-2))) (if (null? arg-3) 0 (let ((e-8 (unbox arg-3))) (let ((e-1 (car arg-1))) ((e-1 e-2) e-8))))))))
(define PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-845 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-832 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-832 arg-686 arg-689)))))
(define LibrariesC-45DataC-45SortedSet-insert (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedMap-insert arg-1 (vector 0 ) arg-2)))
(define csegen-846 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-insert eta-0 eta-1))))
(define csegen-847 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip csegen-846 eta-0 eta-1))))
(define CoreC-45Name-u--C-60_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 0)))
(define CoreC-45Name-u--C-62C-61_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 0)))
(define CoreC-45Name-u--C-62_Ord_Name (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_Name arg-0 arg-1) 2)))
(define CoreC-45Name-u--max_Ord_Name (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-62_Ord_Name arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45Name-u--min_Ord_Name (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-60_Ord_Name arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-861 (vector csegen-832 (lambda (arg-1566) (lambda (arg-1569) (CoreC-45Name-u--compare_Ord_Name arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45Name-u--C-60_Ord_Name arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45Name-u--C-62_Ord_Name arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45Name-u--C-60C-61_Ord_Name arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45Name-u--C-62C-61_Ord_Name arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45Name-u--max_Ord_Name arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45Name-u--min_Ord_Name arg-1626 arg-1629)))))
(define LibrariesC-45DataC-45SortedSet-empty (lambda (arg-1) (LibrariesC-45DataC-45SortedMap-empty arg-1)))
(define csegen-862 (LibrariesC-45DataC-45SortedSet-empty csegen-861))
(define CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 (lambda (arg-1) "[closure]"))
(define CoreC-45Value-u--showPrec_Show_C-40ClosureC-32C-36freeC-41 (lambda (arg-1 arg-2) (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 arg-2)))
(define csegen-864 (cons (lambda (u--x) (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Value-u--showPrec_Show_C-40ClosureC-32C-36freeC-41 u--d u--x)))))
(define csegen-870 (lambda (eta-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-265 eta-0)))
(define PreludeC-45Show-u--showPrec_Show_Nat (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_Nat arg-1)))
(define csegen-895 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Nat u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Nat u--d u--x)))))
(define CoreC-45TTC-45Term-u--showPrec_Show_NameType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) "Bound") ((1) "Func") ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "DataCon" (string-append (PreludeC-45Show-showArg csegen-495 e-0) (PreludeC-45Show-showArg csegen-895 e-1)))))) (else (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "TyCon" (string-append (PreludeC-45Show-showArg csegen-495 e-2) (PreludeC-45Show-showArg csegen-895 e-3)))))))))
(define CoreC-45TTC-45Term-u--show_Show_NameType (lambda (arg-0) (CoreC-45TTC-45Term-u--showPrec_Show_NameType (vector 0 ) arg-0)))
(define csegen-873 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_NameType u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_NameType u--d u--x)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\,))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\ ))
(define csegen-879 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space) eta-0 eta-1))))
(define csegen-880 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String " -> ") eta-0 eta-1))))
(define CoreC-45TTC-45Binder-n--2822-4445-u--go (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (case (vector-ref arg-4 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-4 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-4 0) ((2) 1)(else 0))) ((3) (let ((e-4 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((3) (let ((e-9 (vector-ref arg-4 1))) ((arg-2 e-4) e-9)))(else 0))))(else 0))))
(define CoreC-45TTC-45Binder-eqPiInfoBy (lambda (arg-2 ext-0 ext-1) (CoreC-45TTC-45Binder-n--2822-4445-u--go arg-2 ext-0 ext-1)))
(define CoreC-45TTC-45Binder-n--4944-6634-u--go (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((0) (let ((e-31 (vector-ref arg-4 2))) (let ((e-32 (vector-ref arg-4 3))) (let ((e-33 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-2 e-31))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TTC-45Binder-eqPiInfoBy arg-2 e-3 e-32))) (cond ((equal? sc3 1) ((arg-2 e-4) e-33)) (else 0)))) (else 0)))))))(else 0)))))) ((1) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((1) (let ((e-36 (vector-ref arg-4 2))) (let ((e-37 (vector-ref arg-4 3))) (let ((e-38 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-7 e-36))) (cond ((equal? sc2 1) (let ((sc3 ((arg-2 e-8) e-37))) (cond ((equal? sc3 1) ((arg-2 e-9) e-38)) (else 0)))) (else 0)))))))(else 0)))))) ((2) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((2) (let ((e-41 (vector-ref arg-4 2))) (let ((e-42 (vector-ref arg-4 3))) (let ((e-43 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-12 e-41))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TTC-45Binder-eqPiInfoBy arg-2 e-13 e-42))) (cond ((equal? sc3 1) ((arg-2 e-14) e-43)) (else 0)))) (else 0)))))))(else 0)))))) ((3) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((3) (let ((e-46 (vector-ref arg-4 2))) (let ((e-47 (vector-ref arg-4 3))) (let ((e-48 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-17 e-46))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TTC-45Binder-eqPiInfoBy arg-2 e-18 e-47))) (cond ((equal? sc3 1) ((arg-2 e-19) e-48)) (else 0)))) (else 0)))))))(else 0)))))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((4) (let ((e-51 (vector-ref arg-4 2))) (let ((e-52 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 4))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-22 e-51))) (cond ((equal? sc2 1) (let ((sc3 ((arg-2 e-23) e-52))) (cond ((equal? sc3 1) ((arg-2 e-24) e-53)) (else 0)))) (else 0)))))))(else 0)))))) ((5) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-56 (vector-ref arg-4 2))) (let ((e-57 (vector-ref arg-4 3))) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-27 e-56))) (cond ((equal? sc2 1) ((arg-2 e-28) e-57)) (else 0))))))(else 0)))))(else 0))))
(define CoreC-45TTC-45Binder-eqBinderBy (lambda (arg-2 ext-0 ext-1) (CoreC-45TTC-45Binder-n--4944-6634-u--go arg-2 ext-0 ext-1)))
(define CoreC-45TTC-45Term-eqWhyErasedBy (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((1) (case (vector-ref arg-4 0) ((1) 1)(else 0))) ((0) (case (vector-ref arg-4 0) ((0) 1)(else 0))) ((2) (let ((e-3 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((2) (let ((e-7 (vector-ref arg-4 1))) ((arg-2 e-3) e-7)))(else 0))))(else 0))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0))) ((equal? arg-0 4) (cond ((equal? arg-1 4) 1)(else 0))) ((equal? arg-0 5) (cond ((equal? arg-1 5) 1)(else 0))) ((equal? arg-0 6) (cond ((equal? arg-1 6) 1)(else 0))) ((equal? arg-0 7) (cond ((equal? arg-1 7) 1)(else 0))) ((equal? arg-0 8) (cond ((equal? arg-1 8) 1)(else 0))) ((equal? arg-0 9) (cond ((equal? arg-1 9) 1)(else 0))) ((equal? arg-0 10) (cond ((equal? arg-1 10) 1)(else 0))) ((equal? arg-0 11) (cond ((equal? arg-1 11) 1)(else 0))) ((equal? arg-0 12) (cond ((equal? arg-1 12) 1)(else 0))) ((equal? arg-0 13) (cond ((equal? arg-1 13) 1)(else 0)))(else 0))))
(define CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-0 e-14)))(else 0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 e-1 e-15)))(else 0)))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 e-2 e-16)))(else 0)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 e-3 e-17)))(else 0)))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 e-4 e-18)))(else 0)))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer e-5 e-19)))(else 0)))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 e-6 e-20)))(else 0)))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 e-7 e-21)))(else 0)))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 e-8 e-22)))(else 0)))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 e-9 e-23)))(else 0)))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-10 e-24)))(else 0)))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-11 e-25)))(else 0)))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-26 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Double e-12 e-26)))(else 0)))) ((13) (let ((e-13 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((13) (let ((e-27 (vector-ref arg-1 1))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-13 e-27)))(else 0)))) ((14) (case (vector-ref arg-1 0) ((14) 1)(else 0)))(else 0))))
(define DataC-45List-u--zipWith_Zippable_List (lambda (arg-3 arg-4 arg-5) (if (null? arg-4) '() (if (null? arg-5) '() (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((e-4 (car arg-5))) (let ((e-5 (cdr arg-5))) (cons ((arg-3 e-1) e-4) (DataC-45List-u--zipWith_Zippable_List arg-3 e-2 e-5))))))))))
(define DataC-45List-u--zip_Zippable_List (lambda (ext-0 ext-1) (DataC-45List-u--zipWith_Zippable_List csegen-182 ext-0 ext-1)))
(define CoreC-45TTC-45Term-eqTerm (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((0) (let ((e-55 (vector-ref arg-3 3))) (or (and (= e-4 e-55) 1) 0)))(else 0)))) ((1) (let ((e-9 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((1) (let ((e-60 (vector-ref arg-3 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-9 e-60)))(else 0)))) ((2) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((2) (let ((e-64 (vector-ref arg-3 3))) (let ((e-65 (vector-ref arg-3 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-13 e-64))) (cond ((equal? sc2 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (PreludeC-45Basics-uncurry (csegen-896) eta-0)) (DataC-45List-u--zip_Zippable_List e-14 e-65))) (else 0))))))(else 0))))) ((3) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((3) (let ((e-69 (vector-ref arg-3 3))) (let ((e-70 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TTC-45Binder-eqBinderBy (csegen-896) e-18 e-69))) (cond ((equal? sc2 1) (CoreC-45TTC-45Term-eqTerm e-19 e-70)) (else 0))))))(else 0))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((4) (let ((e-73 (vector-ref arg-3 2))) (let ((e-74 (vector-ref arg-3 3))) (let ((sc2 (CoreC-45TTC-45Term-eqTerm e-22 e-73))) (cond ((equal? sc2 1) (CoreC-45TTC-45Term-eqTerm e-23 e-74)) (else 0))))))(else 0))))) ((5) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((5) (let ((e-78 (vector-ref arg-3 3))) (let ((e-79 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TTC-45Term-eqTerm e-27 e-78))) (cond ((equal? sc2 1) (CoreC-45TTC-45Term-eqTerm e-28 e-79)) (else 0))))))(else 0))))) ((6) (let ((e-32 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((6) (let ((e-83 (vector-ref arg-3 3))) (CoreC-45TTC-45Term-eqTerm e-32 e-83)))(else 0)))) ((7) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-87 (vector-ref arg-3 3))) (let ((e-88 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TTC-45Term-eqTerm e-36 e-87))) (cond ((equal? sc2 1) (CoreC-45TTC-45Term-eqTerm e-37 e-88)) (else 0))))))(else 0))))) ((8) (let ((e-41 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((8) (let ((e-92 (vector-ref arg-3 3))) (CoreC-45TTC-45Term-eqTerm e-41 e-92)))(else 0)))) ((9) (let ((e-44 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((9) (let ((e-95 (vector-ref arg-3 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-44 e-95)))(else 0)))) ((10) (let ((e-47 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((10) (let ((e-98 (vector-ref arg-3 2))) (CoreC-45TTC-45Term-eqWhyErasedBy (csegen-896) e-47 e-98)))(else 0)))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))
(define csegen-896 (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45TTC-45Term-eqTerm eta-0 eta-1)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (lambda (ext-0 ext-1) (vector 11 ext-0 ext-1)))
(define IdrisC-45PrettyC-45Annotations-keyword (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) ext-0)))
(define csegen-921 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ";")))
(define csegen-927 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "}")))
(define csegen-934 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\0)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space))
(define csegen-937 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\1)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space))
(define csegen-943 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "{")))
(define csegen-960 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "->")))
(define CoreC-45FC-u--showPrec_Show_OriginDesc (lambda (arg-0 arg-1) (CoreC-45FC-u--show_Show_OriginDesc arg-1)))
(define csegen-962 (cons (lambda (u--x) (CoreC-45FC-u--show_Show_OriginDesc u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45FC-u--showPrec_Show_OriginDesc u--d u--x)))))
(define csegen-965 (lambda (_-0) (box (+ _-0 1))))
(define CoreC-45TTC-45Var-nameAt (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cond ((equal? arg-3 0) e-1)(else (let ((e-3 (- arg-3 1))) (CoreC-45TTC-45Var-nameAt e-2 e-3))))))))
(define Algebra-showCount (lambda (ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 "0 " "1 " (lambda (eta-0) "") ext-0)))
(define CoreC-45TTC-45Term-withPiInfo (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) (string-append "(" (string-append arg-3 ")"))) ((0) (string-append "{" (string-append arg-3 "}"))) ((2) (string-append "{auto " (string-append arg-3 "}"))) (else (let ((e-4 (vector-ref arg-2 1))) (string-append "{default " (string-append (let ((e-1 (car arg-1))) (e-1 e-4)) (string-append " " (string-append arg-3 "}")))))))))
(define CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-2)))
(define CoreC-45TTC-45Term-n--8014-6017-u--showApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-5 (vector-ref arg-3 3))) (if (null? arg-4) (string-append (CoreC-45Name-u--show_Show_Name (CoreC-45TTC-45Var-nameAt arg-2 e-5)) (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Nat e-5) "]"))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((1) (let ((e-10 (vector-ref arg-3 3))) (if (null? arg-4) (CoreC-45Name-u--show_Show_Name e-10) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((2) (let ((e-13 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 4))) (if (null? arg-4) (string-append "?" (string-append (CoreC-45Name-u--show_Show_Name e-13) (string-append "_" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-15)))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))))) ((3) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (let ((e-20 (vector-ref arg-3 4))) (case (vector-ref e-19 0) ((0) (let ((e-57 (vector-ref e-19 2))) (let ((e-58 (vector-ref e-19 3))) (let ((e-59 (vector-ref e-19 4))) (if (null? arg-4) (string-append "\\" (string-append (CoreC-45TTC-45Term-withPiInfo (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-58 (string-append (Algebra-showCount e-57) (string-append (CoreC-45Name-u--show_Show_Name e-18) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-59))))) (string-append " => " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20)))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((1) (let ((e-62 (vector-ref e-19 2))) (let ((e-63 (vector-ref e-19 3))) (let ((e-64 (vector-ref e-19 4))) (if (null? arg-4) (string-append "let " (string-append (Algebra-showCount e-62) (string-append (CoreC-45Name-u--show_Show_Name e-18) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-64) (string-append " = " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-63) (string-append " in " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))))))))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((2) (let ((e-67 (vector-ref e-19 2))) (let ((e-68 (vector-ref e-19 3))) (let ((e-69 (vector-ref e-19 4))) (if (null? arg-4) (string-append (CoreC-45TTC-45Term-withPiInfo (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-68 (string-append (Algebra-showCount e-67) (string-append (CoreC-45Name-u--show_Show_Name e-18) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-69))))) (string-append " -> " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((3) (let ((e-72 (vector-ref e-19 2))) (let ((e-73 (vector-ref e-19 3))) (let ((e-74 (vector-ref e-19 4))) (if (null? arg-4) (string-append (CoreC-45TTC-45Term-withPiInfo (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-73 (string-append "pat " (string-append (Algebra-showCount e-72) (string-append (CoreC-45Name-u--show_Show_Name e-18) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-74)))))) (string-append " => " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((4) (let ((e-77 (vector-ref e-19 2))) (let ((e-78 (vector-ref e-19 3))) (let ((e-79 (vector-ref e-19 4))) (if (null? arg-4) (string-append "plet " (string-append (Algebra-showCount e-77) (string-append (CoreC-45Name-u--show_Show_Name e-18) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-79) (string-append " = " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-78) (string-append " in " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))))))))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((5) (let ((e-82 (vector-ref e-19 2))) (let ((e-83 (vector-ref e-19 3))) (if (null? arg-4) (string-append "pty " (string-append (Algebra-showCount e-82) (string-append (CoreC-45Name-u--show_Show_Name e-18) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-83) (string-append " => " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-18 arg-2) e-20))))))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))(else (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))))))) ((4) (if (null? arg-4) "[can't happen]" (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))) ((5) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (if (null? arg-4) (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-28) (string-append "@" (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-29))) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")"))))))))) ((6) (let ((e-33 (vector-ref arg-3 3))) (if (null? arg-4) (string-append "%Delayed " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-33)) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((7) (let ((e-38 (vector-ref arg-3 4))) (if (null? arg-4) (string-append "%Delay " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-38)) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((8) (let ((e-42 (vector-ref arg-3 3))) (if (null? arg-4) (string-append "%Force " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-42)) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((9) (let ((e-45 (vector-ref arg-3 2))) (if (null? arg-4) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-45) (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))) ((10) (let ((e-48 (vector-ref arg-3 2))) (case (vector-ref e-48 0) ((2) (let ((e-98 (vector-ref e-48 1))) (if (null? arg-4) (string-append ".(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-98) ")")) (if (null? arg-4) "[__]" (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))(else (if (null? arg-4) "[__]" (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))) ((11) (if (null? arg-4) "Type" (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))(else (if (null? arg-4) "???" (string-append "(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 arg-3) (string-append " " (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 eta-0)) arg-4)) ")")))))))))
(define CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-1))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (CoreC-45TTC-45Term-n--8014-6017-u--showApp arg-0 arg-1 arg-0 e-2 e-3))))))
(define csegen-969 (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() eta-0)))
(define PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 arg-1 (vector 0 ) arg-2)))
(define csegen-972 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-65 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-65 u--d u--x)))))
(define CoreC-45Name-displayUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) (else "_"))))
(define CoreC-45Name-nameRoot (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-nameRoot e-1))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45Name-displayUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) e-3)) ((3) (let ((e-5 (vector-ref arg-0 1))) (CoreC-45Name-nameRoot e-5))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CoreC-45Name-nameRoot e-8))) ((5) (let ((e-10 (vector-ref arg-0 2))) (CoreC-45Name-nameRoot e-10))) ((6) (let ((e-11 (vector-ref arg-0 1))) (string-append "$" (PreludeC-45Show-u--show_Show_String e-11)))) ((7) (let ((e-13 (vector-ref arg-0 1))) (string-append "$" (PreludeC-45Show-u--show_Show_String e-13)))) (else (let ((e-15 (vector-ref arg-0 1))) (string-append "$" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 (lambda (arg-1 ext-0) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 (DataC-45List1-forget ext-0))))
(define CoreC-45Core-u--show_Show_DotReason (lambda (arg-0) (cond ((equal? arg-0 0) "Non linear pattern variable") ((equal? arg-0 1) "Variable applied to arguments") ((equal? arg-0 2) "Not a constructor application or primitive") ((equal? arg-0 3) "Erased argument") ((equal? arg-0 4) "User dotted") ((equal? arg-0 5) "Unknown reason") (else "Under-applied constructor"))))
(define PrimIO-unsafeCreateWorld (lambda (arg-1) (arg-1 #f)))
(define PrimIO-unsafePerformIO (lambda (arg-1) (PrimIO-unsafeCreateWorld (lambda (u--w) (let ((eff-0 (arg-1 u--w))) eff-0)))))
(define SystemC-45Errno-strerror (lambda (arg-0) (PrimIO-unsafePerformIO (lambda (eta-0) (SystemC-45Errno-prim__strerror arg-0 eta-0)))))
(define SystemC-45FileC-45Error-u--show_Show_FileError (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (SystemC-45Errno-strerror e-0))) ((1) "File Read Error") ((2) "File Write Error") ((3) "File Not Found") ((4) "Permission Denied") (else "File Exists"))))
(define CoreC-45Core-u--show_Show_TTCErrorMsg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((u--age (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int e-1 e-2))) (cond ((equal? sc1 1) "older") (else "newer"))))) (string-append "TTC data is in an " (string-append u--age (string-append " format, file: " (string-append e-0 (string-append ", expected version: " (string-append (PreludeC-45Show-u--show_Show_Int e-2) (string-append ", actual version: " (PreludeC-45Show-u--show_Show_Int e-1))))))))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (string-append "End of buffer when reading " e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (string-append "Corrupt TTC data for " e-4))))))
(define CoreC-45TT-u--show_Show_Visibility (lambda (arg-0) (cond ((equal? arg-0 0) "private") ((equal? arg-0 1) "export") (else "public export"))))
(define CoreC-45Core-u--show_Show_Warning (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-0) e-1)))) ((1) (let ((e-3 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-3) ":Unreachable clause"))) ((2) (let ((e-6 (vector-ref arg-0 1))) (string-append (CoreC-45FC-u--show_Show_FC e-6) ":Shadowing names"))) ((3) (let ((e-8 (vector-ref arg-0 1))) (string-append (CoreC-45FC-u--show_Show_FC e-8) ":Incompatible Visibility"))) ((4) (let ((e-12 (vector-ref arg-0 1))) (string-append (CoreC-45FC-u--show_Show_FC e-12) ":Shadowing names"))) ((5) (let ((e-14 (vector-ref arg-0 1))) (let ((e-15 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-14) (string-append ":Deprecated " e-15))))) (else (let ((e-17 (vector-ref arg-0 1))) (let ((e-18 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-17) e-18)))))))
(define CoreC-45Core-n--8799-7358-u--showRel (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 "irrelevant" "relevant" (lambda (eta-0) "non-linear") ext-0)))
(define CoreC-45Core-n--8799-7359-u--showRig (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 "irrelevant" "linear" (lambda (eta-0) "unrestricted") ext-0)))
(define csegen-975 (lambda () (cons csegen-972 (csegen-974))))
(define PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 arg-3)))
(define csegen-981 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-493 u--d u--x)))))
(define csegen-982 (cons csegen-264 csegen-493))
(define CoreC-45Core-u--show_Show_Error (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45Core-u--show_Show_Error e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (string-append (CoreC-45FC-u--show_Show_FC e-2) (string-append ":Type mismatch: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-1 e-5) (string-append " and " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-1 e-6)))))))))) ((2) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (let ((e-11 (vector-ref arg-0 5))) (let ((e-12 (vector-ref arg-0 6))) (string-append (CoreC-45FC-u--show_Show_FC e-8) (string-append ":" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-7 e-11) (string-append " and " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-7 e-12) " are not equal")))))))))) ((3) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (let ((e-17 (vector-ref arg-0 5))) (let ((e-18 (vector-ref arg-0 6))) (string-append (CoreC-45FC-u--show_Show_FC e-14) (string-append ":Pattern variable " (string-append (CoreC-45Name-u--show_Show_Name e-17) (string-append " unifies with " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-13 e-18)))))))))) ((4) (let ((e-19 (vector-ref arg-0 1))) (let ((e-20 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 4))) (let ((e-23 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-20) (string-append ":Cycle detected in metavariable solution " (string-append (CoreC-45Name-u--show_Show_Name e-22) (string-append " = " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-19 e-23)))))))))) ((5) (let ((e-24 (vector-ref arg-0 1))) (let ((e-25 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 5))) (let ((e-29 (vector-ref arg-0 6))) (let ((e-30 (vector-ref arg-0 7))) (string-append (CoreC-45FC-u--show_Show_FC e-25) (string-append ":When unifying: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-24 e-28) (string-append " and " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-24 e-29) (string-append "\xa;\x9;" (CoreC-45Core-u--show_Show_Error e-30))))))))))))) ((6) (let ((e-31 (vector-ref arg-0 1))) (let ((e-32 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-32) (string-append ":" (case (vector-ref e-34 0) ((0) (let ((e-2 (vector-ref e-34 1))) (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-31 e-2) " is not a valid impossible pattern because it typechecks"))) (else (let ((e-5 (vector-ref e-34 1))) (string-append "Not a valid impossible pattern:\xa;\x9;" (CoreC-45Core-u--show_Show_Error e-5))))))))))) ((7) (let ((e-35 (vector-ref arg-0 1))) (let ((e-36 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-35) (string-append ":Undefined name " (CoreC-45Name-u--show_Show_Name e-36)))))) ((8) (let ((e-37 (vector-ref arg-0 1))) (let ((e-38 (vector-ref arg-0 2))) (let ((e-39 (vector-ref arg-0 3))) (if (null? e-39) (string-append (CoreC-45FC-u--show_Show_FC e-37) (string-append ":Name " (string-append (CoreC-45Name-u--show_Show_Name e-38) " is private"))) (let ((e-221 (unbox e-39))) (string-append (CoreC-45FC-u--show_Show_FC e-37) (string-append ":Name " (string-append (CoreC-45Name-u--show_Show_Name e-38) (string-append " is inaccessible since " (string-append (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-221) " is not explicitly imported"))))))))))) ((9) (let ((e-40 (vector-ref arg-0 1))) (let ((e-41 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-40) (string-append ":Return type of " (string-append (CoreC-45Name-u--show_Show_Name e-41) " must be Type")))))) ((10) (let ((e-42 (vector-ref arg-0 1))) (let ((e-43 (vector-ref arg-0 2))) (let ((e-44 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-42) (string-append ":Return type of " (string-append (CoreC-45Name-u--show_Show_Name e-43) (string-append " must be in " (CoreC-45Name-u--show_Show_Name e-44))))))))) ((11) (let ((e-45 (vector-ref arg-0 1))) (let ((e-46 (vector-ref arg-0 2))) (let ((e-47 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-45) (string-append ":" (string-append (CoreC-45Name-u--show_Show_Name e-46) (string-append " is not covering:\xa;\x9;" (case (vector-ref e-47 0) ((0) "Oh yes it is (Internal error!)") ((1) (let ((e-0 (vector-ref e-47 1))) (string-append "Missing cases:\xa;\x9;" (CoreC-45NameC-45Namespace-showSep "\xa;\x9;" (PreludeC-45TypesC-45List-mapAppend '() csegen-969 e-0))))) (else (let ((e-1 (vector-ref e-47 1))) (string-append "Calls non covering function" (if (null? e-1) (string-append "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))) (let ((e-3 (car e-1))) (let ((e-2 (cdr e-1))) (if (null? e-2) (string-append " " (CoreC-45Name-u--show_Show_Name e-3)) (string-append "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))))))))))))))))))) ((12) (let ((e-48 (vector-ref arg-0 1))) (let ((e-49 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-48) (string-append ":" (string-append (CoreC-45Name-u--show_Show_Name e-49) " is not total")))))) ((13) (let ((e-51 (vector-ref arg-0 1))) (let ((e-52 (vector-ref arg-0 2))) (let ((e-53 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-51) (string-append ":There are " (string-append (PreludeC-45Show-u--show_Show_Nat e-52) (string-append " uses of linear name " (CoreC-45Name-u--show_Show_Name e-53))))))))) ((14) (let ((e-54 (vector-ref arg-0 1))) (let ((e-55 (vector-ref arg-0 2))) (let ((e-56 (vector-ref arg-0 3))) (let ((e-57 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-54) (string-append ":Trying to use " (string-append (CoreC-45Core-n--8799-7359-u--showRig e-57 e-56 e-55 e-54 e-56) (string-append " name " (string-append (CoreC-45Name-u--show_Show_Name e-55) (string-append " in " (string-append (CoreC-45Core-n--8799-7358-u--showRel e-57 e-56 e-55 e-54 e-57) " context")))))))))))) ((15) (let ((e-58 (vector-ref arg-0 1))) (let ((e-59 (vector-ref arg-0 2))) (let ((e-61 (vector-ref arg-0 4))) (let ((e-62 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-59) (string-append ":" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-58 e-61) (string-append " borrows argument " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-58 e-62) " so must be fully applied")))))))))) ((16) (let ((e-63 (vector-ref arg-0 1))) (let ((e-64 (vector-ref arg-0 2))) (let ((e-66 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-64) (string-append ":" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-63 e-66) " borrows, so must return a concrete type"))))))) ((17) (let ((e-67 (vector-ref arg-0 1))) (let ((e-68 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-67) (string-append ":Ambiguous name " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-68)))))) ((18) (let ((e-69 (vector-ref arg-0 1))) (let ((e-70 (vector-ref arg-0 2))) (let ((e-72 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-70) (string-append ":Ambiguous elaboration " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-69 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-69 u--d u--x)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-72)))))))) ((19) (let ((e-73 (vector-ref arg-0 1))) (let ((e-74 (vector-ref arg-0 2))) (let ((e-77 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-74) (string-append ":Ambiguous search " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-73 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-73 u--d u--x)))) e-77))))))) ((20) (let ((e-78 (vector-ref arg-0 1))) (let ((e-79 (vector-ref arg-0 2))) (let ((e-80 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-78) (string-append ":Ambiguity too deep in " (string-append (CoreC-45Name-u--show_Show_Name e-79) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-80))))))))) ((21) (let ((e-81 (vector-ref arg-0 1))) (string-append "No successful elaboration: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-975) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-975) u--d u--x)))) e-81)))) ((22) (let ((e-83 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-83) ":Can't infer type of record to update"))) ((23) (let ((e-85 (vector-ref arg-0 1))) (let ((e-86 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-85) (string-append ":Duplicated record update paths: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-981 e-86)))))) ((24) (let ((e-87 (vector-ref arg-0 1))) (let ((e-88 (vector-ref arg-0 2))) (let ((e-89 (vector-ref arg-0 3))) (if (null? e-89) (string-append (CoreC-45FC-u--show_Show_FC e-87) (string-append ":" (string-append e-88 " is not part of a record type"))) (let ((e-224 (unbox e-89))) (string-append (CoreC-45FC-u--show_Show_FC e-87) (string-append ":Record type " (string-append (CoreC-45Name-u--show_Show_Name e-224) (string-append " has no field " e-88)))))))))) ((25) (let ((e-90 (vector-ref arg-0 1))) (let ((e-91 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-90) (string-append ":" (string-append (CoreC-45Name-u--show_Show_Name e-91) " is not a record type")))))) ((26) (let ((e-92 (vector-ref arg-0 1))) (let ((e-93 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-92) (string-append ":Field update " (string-append (CoreC-45NameC-45Namespace-showSep "->" e-93) " not compatible with other updates")))))) ((27) (let ((e-94 (vector-ref arg-0 1))) (let ((e-95 (vector-ref arg-0 2))) (let ((e-97 (vector-ref arg-0 4))) (let ((e-98 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-95) (string-append ":" (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-97) (string-append " are not valid arguments in " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-94 e-98)))))))))) ((28) (let ((e-99 (vector-ref arg-0 1))) (let ((e-100 (vector-ref arg-0 2))) (let ((e-102 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-100) (string-append ":Need to bind implicits " (string-append (CoreC-45NameC-45Namespace-showSep "," (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (string-append (CoreC-45Name-u--show_Show_Name (Builtin-fst u--x)) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-99 (Builtin-snd u--x))))) e-102)) "\xa;(The front end should probably have done this for you. Please report!)"))))))) ((29) (let ((e-103 (vector-ref arg-0 1))) (let ((e-104 (vector-ref arg-0 2))) (let ((e-106 (vector-ref arg-0 4))) (let ((e-107 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-104) (string-append ":Can't bind name " (string-append (CoreC-45Name-nameRoot e-106) (string-append " with type " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-103 e-107)))))))))) ((30) (let ((e-108 (vector-ref arg-0 1))) (let ((e-109 (vector-ref arg-0 2))) (let ((e-112 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-109) (string-append ":Can't solve goal " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-108 e-112))))))) ((31) (let ((e-114 (vector-ref arg-0 1))) (let ((e-115 (vector-ref arg-0 2))) (let ((e-116 (vector-ref arg-0 3))) (let ((e-119 (vector-ref arg-0 6))) (string-append (CoreC-45FC-u--show_Show_FC e-115) (string-append ":Can't solve goal " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-114 e-119) (string-append " since argument " (string-append (CoreC-45Name-u--show_Show_Name e-116) " can't be inferred")))))))))) ((32) (let ((e-120 (vector-ref arg-0 1))) (string-append "Unsolved holes " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-269 e-120)))) ((33) (let ((e-121 (vector-ref arg-0 1))) (let ((e-122 (vector-ref arg-0 2))) (let ((e-124 (vector-ref arg-0 4))) (let ((e-125 (vector-ref arg-0 5))) (let ((e-126 (vector-ref arg-0 6))) (string-append (CoreC-45FC-u--show_Show_FC e-122) (string-append ":Can't infer type for " (string-append (CoreC-45Name-u--show_Show_Name e-124) (string-append " (got " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-121 e-126) (string-append " with hole " (string-append (CoreC-45Name-u--show_Show_Name e-125) ")"))))))))))))) ((34) (let ((e-128 (vector-ref arg-0 2))) (let ((e-130 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-128) (string-append ":Named hole " (string-append (CoreC-45Name-u--show_Show_Name e-130) " is solved by unification")))))) ((35) (let ((e-132 (vector-ref arg-0 1))) (let ((e-133 (vector-ref arg-0 2))) (let ((e-134 (vector-ref arg-0 3))) (let ((e-135 (vector-ref arg-0 4))) (let ((e-136 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-132) (string-append ":" (string-append (CoreC-45TT-u--show_Show_Visibility e-133) (string-append " " (string-append (CoreC-45Name-u--show_Show_Name e-134) (string-append " cannot refer to " (string-append (CoreC-45TT-u--show_Show_Visibility e-135) (string-append " " (CoreC-45Name-u--show_Show_Name e-136))))))))))))))) ((36) (let ((e-137 (vector-ref arg-0 1))) (let ((e-138 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-137) (string-append ":Non linear pattern variable " (CoreC-45Name-u--show_Show_Name e-138)))))) ((37) (let ((e-139 (vector-ref arg-0 1))) (let ((e-140 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-139) (string-append ":Pattern not allowed here: " (CoreC-45Name-u--show_Show_Name e-140)))))) ((38) (let ((e-141 (vector-ref arg-0 1))) (let ((e-142 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-141) (string-append ":No type declaration for " (CoreC-45Name-u--show_Show_Name e-142)))))) ((39) (let ((e-143 (vector-ref arg-0 1))) (let ((e-144 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-143) (string-append ":" (string-append (CoreC-45Name-u--show_Show_Name e-144) " is already defined")))))) ((40) (let ((e-145 (vector-ref arg-0 1))) (let ((e-146 (vector-ref arg-0 2))) (let ((e-148 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-146) (string-append ":Not a function type: " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-145 e-148))))))) ((41) (let ((e-149 (vector-ref arg-0 1))) (let ((e-150 (vector-ref arg-0 2))) (let ((e-152 (vector-ref arg-0 4))) (let ((e-153 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-150) (string-append ":Rewriting by " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-149 e-152) (string-append " did not change type " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-149 e-153)))))))))) ((42) (let ((e-154 (vector-ref arg-0 1))) (let ((e-155 (vector-ref arg-0 2))) (let ((e-157 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-155) (string-append ":" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-154 e-157) " is not a rewrite rule type"))))))) ((43) (let ((e-158 (vector-ref arg-0 1))) (let ((e-159 (vector-ref arg-0 2))) (let ((e-160 (vector-ref arg-0 3))) (case (vector-ref e-160 0) ((0) (string-append (CoreC-45FC-u--show_Show_FC e-158) (string-append ":Patterns for " (string-append (CoreC-45Name-u--show_Show_Name e-159) " have different numbers of arguments")))) ((1) (string-append (CoreC-45FC-u--show_Show_FC e-158) (string-append ":Patterns for " (string-append (CoreC-45Name-u--show_Show_Name e-159) " require matching on different types")))) ((4) (string-append (CoreC-45FC-u--show_Show_FC e-158) (string-append ":Can't infer type to match in " (CoreC-45Name-u--show_Show_Name e-159)))) ((2) (let ((e-225 (vector-ref e-160 1))) (let ((e-229 (car e-225))) (let ((e-230 (cdr e-225))) (let ((e-234 (cdr e-230))) (string-append (CoreC-45FC-u--show_Show_FC e-158) (string-append ":Attempt to match on erased argument " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-229 e-234) (string-append " in " (CoreC-45Name-u--show_Show_Name e-159)))))))))) (else (let ((e-226 (vector-ref e-160 1))) (string-append (CoreC-45FC-u--show_Show_FC e-158) (string-append ":Constructor " (string-append (CoreC-45Name-u--show_Show_Name e-226) " is not fully applied")))))))))) ((44) (let ((e-161 (vector-ref arg-0 1))) (let ((e-162 (vector-ref arg-0 2))) (let ((e-164 (vector-ref arg-0 4))) (string-append (CoreC-45FC-u--show_Show_FC e-162) (string-append ":Can't match on " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-161 e-164) " as it is has a polymorphic type"))))))) ((45) (let ((e-165 (vector-ref arg-0 1))) (let ((e-166 (vector-ref arg-0 2))) (let ((e-168 (vector-ref arg-0 4))) (let ((e-169 (vector-ref arg-0 5))) (let ((e-170 (vector-ref arg-0 6))) (string-append (CoreC-45FC-u--show_Show_FC e-166) (string-append ":Can't match on " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-165 e-169) (string-append " (" (string-append (CoreC-45Core-u--show_Show_DotReason e-168) (string-append ")" (string-append " - it elaborates to " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-165 e-170)))))))))))))) ((46) (let ((e-171 (vector-ref arg-0 1))) (let ((e-172 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-171) (string-append ":" (string-append e-172 " can't be bound here")))))) ((47) (let ((e-173 (vector-ref arg-0 1))) (let ((e-174 (vector-ref arg-0 2))) (let ((e-176 (vector-ref arg-0 4))) (let ((e-177 (vector-ref arg-0 5))) (string-append (CoreC-45FC-u--show_Show_FC e-174) (string-append ":Bad elaborator script " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-173 e-176) (string-append " (" (string-append e-177 ")")))))))))) ((48) (let ((e-178 (vector-ref arg-0 1))) (string-append "Error during reflection: " (CoreC-45Core-u--show_Show_Error e-178)))) ((49) (let ((e-179 (vector-ref arg-0 1))) (let ((e-180 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-179) (string-append ":" e-180))))) ((50) (let ((e-181 (vector-ref arg-0 1))) (string-append "Error in TTC file: " (CoreC-45Core-u--show_Show_TTCErrorMsg e-181)))) ((51) (let ((e-182 (vector-ref arg-0 1))) (let ((e-183 (vector-ref arg-0 2))) (string-append "File error (" (string-append e-182 (string-append "): " (SystemC-45FileC-45Error-u--show_Show_FileError e-183))))))) ((52) (let ((e-184 (vector-ref arg-0 1))) (string-append "Can't find package " e-184))) ((53) "Implicit lazy functions are not yet supported") ((54) "Defining lazy functions via pattern matching is not yet supported") ((55) (let ((e-187 (vector-ref arg-0 1))) (string-append (CoreC-45FC-u--show_Show_FC e-187) ":Can't parse literate"))) ((56) (let ((e-188 (vector-ref arg-0 1))) (let ((e-189 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-188) (string-append ":Lexer error (" (string-append (PreludeC-45Show-u--show_Show_String e-189) ")")))))) ((57) (let ((e-190 (vector-ref arg-0 1))) (string-append "Parse errors (" (string-append (DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-982 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-982 u--d u--x)))) e-190) ")")))) ((58) (let ((e-191 (vector-ref arg-0 1))) (let ((e-192 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-191) (string-append ":" (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-192) " not found")))))) ((59) (let ((e-193 (vector-ref arg-0 1))) (string-append "Module imports form a cycle: " (CoreC-45NameC-45Namespace-showSep " -> " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-0)) e-193))))) ((60) "Internal error when resolving implicit laziness") ((61) (let ((e-194 (vector-ref arg-0 1))) (string-append "INTERNAL ERROR: " e-194))) ((62) (let ((e-195 (vector-ref arg-0 1))) (string-append "Error: " e-195))) ((63) (let ((e-196 (vector-ref arg-0 1))) (let ((e-197 (vector-ref arg-0 2))) (string-append (CoreC-45FC-u--show_Show_FC e-196) (string-append ":The given specifier " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-197) " was not accepted by any available backend.")))))) ((64) (let ((e-199 (vector-ref arg-0 2))) (string-append "Invalid multiline string: " e-199))) ((65) (let ((e-200 (vector-ref arg-0 1))) (string-append "Timeout in " e-200))) ((66) "Failing block did not fail") ((67) (let ((e-202 (vector-ref arg-0 1))) (let ((e-203 (vector-ref arg-0 2))) (let ((e-204 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-202) (string-append ":Failing block failed with the wrong error:\xa;" (string-append "Expected: " (string-append e-203 (string-append "\xa;" (string-append "but got: " (DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 (csegen-974) e-204))))))))))) ((68) (let ((e-205 (vector-ref arg-0 1))) (let ((e-206 (vector-ref arg-0 2))) (let ((e-207 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-205) (string-append ":When elaborating type of " (string-append (CoreC-45Name-u--show_Show_Name e-206) (string-append ":\xa;" (CoreC-45Core-u--show_Show_Error e-207))))))))) ((69) (let ((e-208 (vector-ref arg-0 1))) (let ((e-209 (vector-ref arg-0 2))) (let ((e-210 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-208) (string-append ":When elaborating type of constructor " (string-append (CoreC-45Name-u--show_Show_Name e-209) (string-append ":\xa;" (CoreC-45Core-u--show_Show_Error e-210))))))))) ((70) (let ((e-211 (vector-ref arg-0 1))) (let ((e-212 (vector-ref arg-0 2))) (let ((e-213 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-211) (string-append ":When elaborating left hand side of " (string-append (CoreC-45Name-u--show_Show_Name e-212) (string-append ":\xa;" (CoreC-45Core-u--show_Show_Error e-213))))))))) ((71) (let ((e-214 (vector-ref arg-0 1))) (let ((e-215 (vector-ref arg-0 2))) (let ((e-216 (vector-ref arg-0 3))) (string-append (CoreC-45FC-u--show_Show_FC e-214) (string-append ":When elaborating right hand side of " (string-append (CoreC-45Name-u--show_Show_Name e-215) (string-append ":\xa;" (CoreC-45Core-u--show_Show_Error e-216))))))))) ((72) (let ((e-217 (vector-ref arg-0 1))) (let ((e-218 (vector-ref arg-0 2))) (string-append (CoreC-45Core-u--show_Show_Error e-217) (string-append "\xa;Did you mean" (if (null? e-218) (string-append " any of: " (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) (DataC-45List1-forget e-218))) "?")) (let ((e-1 (car e-218))) (let ((e-2 (cdr e-218))) (if (null? e-2) (string-append ": " (string-append e-1 "?")) (string-append " any of: " (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) (DataC-45List1-forget e-218))) "?"))))))))))) (else (let ((e-219 (vector-ref arg-0 1))) (CoreC-45Core-u--show_Show_Warning e-219))))))
(define CoreC-45Core-u--showPrec_Show_Error (lambda (arg-0 arg-1) (CoreC-45Core-u--show_Show_Error arg-1)))
(define csegen-974 (lambda () (cons (lambda (u--x) (CoreC-45Core-u--show_Show_Error u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Core-u--showPrec_Show_Error u--d u--x))))))
(define csegen-988 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (lambda (eta-1) (cons e-5 eta-1))))))))
(define CoreC-45CoreC-45Functor-u--map_Functor_CORECore (lambda (ext-2 ext-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (ext-2 e-5)))))) ext-1 ext-0)))
(define csegen-993 (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (lambda (eta-0) (CoreC-45CoreC-45Functor-u--map_Functor_CORECore u--func arg-8885 eta-0)))))))
(define CoreC-45CoreC-45Applicative-u--C-60C-42C-62_Applicative_CORECore (lambda (ext-2 ext-1 ext-0) (CoreC-45Core-C-60C-42C-62 ext-2 ext-1 ext-0)))
(define CoreC-45CoreC-45Applicative-u--pure_Applicative_CORECore (lambda (ext-0 ext-1) (vector 1 ext-0)))
(define csegen-999 (vector csegen-993 (lambda (u--a) (lambda (arg-9931) (lambda (eta-0) (CoreC-45CoreC-45Applicative-u--pure_Applicative_CORECore arg-9931 eta-0)))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (lambda (eta-0) (CoreC-45CoreC-45Applicative-u--C-60C-42C-62_Applicative_CORECore arg-9937 arg-9944 eta-0))))))))
(define CoreC-45CoreC-45Monad-u--C-62C-62C-61_Monad_CORECore (lambda (ext-2 ext-1 ext-0) (let ((act-1 (ext-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (ext-1 e-5))) eff-0) ext-0)))))))
(define CoreC-45CoreC-45Monad-u--join_Monad_CORECore (lambda (arg-1 ext-0) (let ((act-1 (arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) (e-5 ext-0)))))))
(define csegen-1005 (vector csegen-999 (lambda (u--b) (lambda (u--a) (lambda (arg-10411) (lambda (arg-10414) (lambda (eta-0) (CoreC-45CoreC-45Monad-u--C-62C-62C-61_Monad_CORECore arg-10411 arg-10414 eta-0)))))) (lambda (u--a) (lambda (arg-10425) (lambda (eta-0) (CoreC-45CoreC-45Monad-u--join_Monad_CORECore arg-10425 eta-0))))))
(define csegen-1007 (lambda (eta-0) (cons CoreC-45FC-emptyFC (Builtin-snd eta-0))))
(define AlgebraC-45SizeChange-u--show_Show_SizeChange (lambda (arg-0) (cond ((equal? arg-0 0) "Smaller") ((equal? arg-0 1) "Same") (else "Unknown"))))
(define AlgebraC-45SizeChange-u--showPrec_Show_SizeChange (lambda (arg-0 arg-1) (AlgebraC-45SizeChange-u--show_Show_SizeChange arg-1)))
(define csegen-1012 (cons csegen-895 (cons (lambda (u--x) (AlgebraC-45SizeChange-u--show_Show_SizeChange u--x)) (lambda (u--d) (lambda (u--x) (AlgebraC-45SizeChange-u--showPrec_Show_SizeChange u--d u--x))))))
(define csegen-1015 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1012 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1012 u--d u--x)))))
(define DataC-45List1-u--showPrec_Show_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 arg-1 arg-3)))
(define csegen-1019 (cons csegen-895 (cons (lambda (u--x) (DataC-45List1-u--show_Show_C-40List1C-32C-36aC-41 csegen-1015 u--x)) (lambda (u--d) (lambda (u--x) (DataC-45List1-u--showPrec_Show_C-40List1C-32C-36aC-41 csegen-1015 u--d u--x))))))
(define PreludeC-45Show-u--showPrec_Show_Bool (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_Bool arg-1)))
(define csegen-1024 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Bool u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Bool u--d u--x)))))
(define csegen-1025 (cons csegen-1024 csegen-895))
(define csegen-1029 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-895 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-895 u--d u--x)))))
(define PreludeC-45Types-u--C-47C-61_Eq_Nat (lambda (arg-0 arg-1) (let ((sc0 (or (and (= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1032 (cons (lambda (arg-676) (lambda (arg-679) (or (and (= arg-676 arg-679) 1) 0))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-686 arg-689)))))
(define AlgebraC-45SizeChange-u--C-61C-61_Eq_SizeChange (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define AlgebraC-45SizeChange-u--C-47C-61_Eq_SizeChange (lambda (arg-0 arg-1) (let ((sc0 (AlgebraC-45SizeChange-u--C-61C-61_Eq_SizeChange arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1035 (cons (lambda (arg-676) (lambda (arg-679) (AlgebraC-45SizeChange-u--C-61C-61_Eq_SizeChange arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (AlgebraC-45SizeChange-u--C-47C-61_Eq_SizeChange arg-686 arg-689)))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1038 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1032 csegen-1035 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1032 csegen-1035 arg-686 arg-689)))))
(define DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc2 (let ((e-6 (car arg-1))) ((e-6 e-1) e-4)))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 arg-1 e-2 e-5)) (else 0)))))))))
(define DataC-45List1-u--C-47C-61_Eq_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1041 (cons (lambda (arg-676) (lambda (arg-679) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 csegen-1038 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (DataC-45List1-u--C-47C-61_Eq_C-40List1C-32C-36aC-41 csegen-1038 arg-686 arg-689)))))
(define csegen-1044 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1032 csegen-1041 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1032 csegen-1041 arg-686 arg-689)))))
(define csegen-1048 (lambda (eta-0) (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat eta-0))))
(define PreludeC-45Types-u--C-62_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Integer arg-0 arg-1) 2)))
(define PreludeC-45Types-u--max_Ord_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--C-62_Ord_Nat arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-1049 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Types-u--max_Ord_Nat eta-0 eta-1))))
(define csegen-1055 (vector csegen-108 csegen-109 (lambda (arg-5924) arg-5924)))
(define csegen-1059 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_Integer arg-1566 arg-1569))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--max_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-1066 (vector csegen-722 csegen-1059 (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_Integer arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_Integer arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_Integer arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_Integer arg-1626 arg-1629)))))
(define csegen-1068 (vector csegen-1055 (lambda (arg-6023) (- 0 arg-6023)) (lambda (arg-6029) (lambda (arg-6032) (- arg-6029 arg-6032)))))
(define PreludeC-45Num-u--div_Integral_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidDiv arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:91:3--93:44")))))))
(define PreludeC-45Num-u--mod_Integral_Integer (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:94:3--96:44")))))))
(define csegen-1070 (cons (vector csegen-1055 (lambda (arg-6312) (lambda (arg-6315) (PreludeC-45Num-u--div_Integral_Integer arg-6312 arg-6315))) (lambda (arg-6322) (lambda (arg-6325) (PreludeC-45Num-u--mod_Integral_Integer arg-6322 arg-6325)))) (cons csegen-1066 csegen-1068)))
(define csegen-1079 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\:)))
(define csegen-1240 (lambda (u--n) (string-append " (newtype by " (string-append (PreludeC-45Show-u--show_Show_Nat u--n) ")"))))
(define CoreC-45CompileExpr-u--show_Show_CFType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "Unit") ((1) "Int") ((2) "Integer") ((3) "Int_8") ((4) "Int_16") ((5) "Int_32") ((6) "Int_64") ((7) "Bits_8") ((8) "Bits_16") ((9) "Bits_32") ((10) "Bits_64") ((11) "String") ((12) "Double") ((13) "Char") ((14) "Ptr") ((15) "GCPtr") ((16) "Buffer") ((17) "ForeignObj") ((18) "%World") ((19) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (CoreC-45CompileExpr-u--show_Show_CFType e-0) (string-append " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-1)))))) ((20) (let ((e-2 (vector-ref arg-0 1))) (string-append "IORes " (CoreC-45CompileExpr-u--show_Show_CFType e-2)))) ((21) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (string-append "struct " (string-append (PreludeC-45Show-u--show_Show_String e-3) (string-append " " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-493 (csegen-1242)) eta-0)) e-4)))))))) (else (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " " (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-u--show_Show_CFType eta-0)) e-6))))))))))
(define CoreC-45CompileExpr-u--showPrec_Show_CFType (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_CFType arg-1)))
(define csegen-1242 (lambda () (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_CFType u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_CFType u--d u--x))))))
(define CoreC-45CompileExpr-u--show_Show_ConInfo (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "[datacon]") ((1) "[tycon]") ((2) "[nil]") ((3) "[cons]") ((4) (let ((e-0 (vector-ref arg-0 1))) (string-append "[enum " (string-append (PreludeC-45Show-u--show_Show_Nat e-0) "]")))) ((5) "[nothing]") ((6) "[just]") ((7) "[record]") ((8) "[zero]") ((9) "[succ]") (else "[unit]"))))
(define CoreC-45CompileExpr-n--7229-4894-u--showFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) "")(else (string-append (CoreC-45CompileExpr-u--show_Show_ConInfo arg-5) " ")))))
(define CoreC-45CompileExpr-u--show_Show_NamedConAlt (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (string-append "(%concase " (string-append (CoreC-45CompileExpr-n--7229-4894-u--showFlag e-4 e-3 e-2 e-1 e-0 e-1) (string-append (CoreC-45Name-u--show_Show_Name e-0) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-2) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-3) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-4) ")"))))))))))))))))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedConAlt (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedConAlt arg-1)))
(define CoreC-45CompileExpr-u--show_Show_NamedConstAlt (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (string-append "(%constcase " (string-append (CoreC-45TTC-45Primitive-u--show_Show_Constant e-0) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-1) ")"))))))))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedConstAlt (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedConstAlt arg-1)))
(define DataC-45Vect-foldrImpl (lambda (arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (arg-5 arg-4) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (DataC-45Vect-foldrImpl arg-3 arg-4 (lambda (eta-0) (arg-5 ((arg-3 e-3) eta-0))) e-4))))))
(define DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4 arg-5) (DataC-45Vect-foldrImpl arg-3 arg-4 (lambda (eta-0) eta-0) arg-5)))
(define DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 (lambda (ext-0) (DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 csegen-103 '() ext-0)))
(define DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (lambda (arg-2 ext-0) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-2 (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 ext-0))))
(define CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (string-append "+" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-0)))) ((1) (let ((e-1 (vector-ref arg-1 1))) (string-append "-" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-1)))) ((2) (let ((e-2 (vector-ref arg-1 1))) (string-append "*" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-2)))) ((3) (let ((e-3 (vector-ref arg-1 1))) (string-append "/" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-3)))) ((4) (let ((e-4 (vector-ref arg-1 1))) (string-append "%" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-4)))) ((5) (let ((e-5 (vector-ref arg-1 1))) (string-append "neg " (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-5)))) ((6) (let ((e-6 (vector-ref arg-1 1))) (string-append "shl " (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-6)))) ((7) (let ((e-7 (vector-ref arg-1 1))) (string-append "shr " (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-7)))) ((8) (let ((e-8 (vector-ref arg-1 1))) (string-append "and " (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-8)))) ((9) (let ((e-9 (vector-ref arg-1 1))) (string-append "or " (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-9)))) ((10) (let ((e-10 (vector-ref arg-1 1))) (string-append "xor " (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-10)))) ((11) (let ((e-11 (vector-ref arg-1 1))) (string-append "<" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-11)))) ((12) (let ((e-12 (vector-ref arg-1 1))) (string-append "<=" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-12)))) ((13) (let ((e-13 (vector-ref arg-1 1))) (string-append "==" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-13)))) ((14) (let ((e-14 (vector-ref arg-1 1))) (string-append ">=" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-14)))) ((15) (let ((e-15 (vector-ref arg-1 1))) (string-append ">" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-15)))) ((16) "op_strlen") ((17) "op_strhead") ((18) "op_strtail") ((19) "op_strindex") ((20) "op_strcons") ((21) "++") ((22) "op_strrev") ((23) "op_strsubstr") ((24) "op_doubleExp") ((25) "op_doubleLog") ((26) "op_doublePow") ((27) "op_doubleSin") ((28) "op_doubleCos") ((29) "op_doubleTan") ((30) "op_doubleASin") ((31) "op_doubleACos") ((32) "op_doubleATan") ((33) "op_doubleSqrt") ((34) "op_doubleFloor") ((35) "op_doubleCeiling") ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (string-append "cast-" (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-16) (string-append "-" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-17))))))) ((37) "believe_me") (else "crash"))))
(define CoreC-45TTC-45Term-u--show_Show_LazyReason (lambda (arg-0) (cond ((equal? arg-0 0) "Inf") ((equal? arg-0 1) "Lazy") (else "Unkown"))))
(define CoreC-45CompileExpr-n--6901-4660-u--showFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) "")(else (string-append (CoreC-45CompileExpr-u--show_Show_ConInfo arg-5) " ")))))
(define CoreC-45CompileExpr-u--show_Show_NamedCExp (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (string-append "!" (CoreC-45Name-u--show_Show_Name e-1)))) ((1) (let ((e-3 (vector-ref arg-0 2))) (CoreC-45Name-u--show_Show_Name e-3))) ((2) (let ((e-5 (vector-ref arg-0 2))) (let ((e-6 (vector-ref arg-0 3))) (string-append "(%lam " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-6) ")"))))))) ((3) (let ((e-8 (vector-ref arg-0 2))) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (string-append "(%let " (string-append (CoreC-45Name-u--show_Show_Name e-8) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-9) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-10) ")")))))))))) ((4) (let ((e-12 (vector-ref arg-0 2))) (let ((e-13 (vector-ref arg-0 3))) (string-append "(" (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-12) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) e-13) ")"))))))) ((5) (let ((e-14 (vector-ref arg-0 1))) (let ((e-15 (vector-ref arg-0 2))) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (let ((e-18 (vector-ref arg-0 5))) (string-append "(%con " (string-append (CoreC-45CompileExpr-n--6901-4660-u--showFlag e-14 e-18 e-17 e-16 e-15 e-16) (string-append (CoreC-45Name-u--show_Show_Name e-15) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-17) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) e-18) ")"))))))))))))) ((6) (let ((e-21 (vector-ref arg-0 3))) (let ((e-22 (vector-ref arg-0 4))) (string-append "(" (string-append (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-21) (string-append " " (string-append (DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (csegen-1244) e-22) ")"))))))) ((7) (let ((e-24 (vector-ref arg-0 2))) (let ((e-25 (vector-ref arg-0 3))) (string-append "(%extern " (string-append (CoreC-45Name-u--show_Show_Name e-24) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) e-25) ")"))))))) ((8) (let ((e-27 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 3))) (string-append "(%force " (string-append (CoreC-45TTC-45Term-u--show_Show_LazyReason e-27) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-28) ")"))))))) ((9) (let ((e-30 (vector-ref arg-0 2))) (let ((e-31 (vector-ref arg-0 3))) (string-append "(%delay " (string-append (CoreC-45TTC-45Term-u--show_Show_LazyReason e-30) (string-append " " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-31) ")"))))))) ((10) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (let ((e-35 (vector-ref arg-0 4))) (string-append "(%case " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-33) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedConAlt u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedConAlt u--d u--x)))) e-34) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1244) e-35) ")")))))))))) ((11) (let ((e-37 (vector-ref arg-0 2))) (let ((e-38 (vector-ref arg-0 3))) (let ((e-39 (vector-ref arg-0 4))) (string-append "(%case " (string-append (CoreC-45CompileExpr-u--show_Show_NamedCExp e-37) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedConstAlt u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedConstAlt u--d u--x)))) e-38) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1244) e-39) ")")))))))))) ((12) (let ((e-41 (vector-ref arg-0 2))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-41))) ((13) "___") (else (let ((e-44 (vector-ref arg-0 2))) (string-append "(CRASH " (string-append (PreludeC-45Show-u--show_Show_String e-44) ")")))))))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedCExp (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedCExp arg-1)))
(define csegen-1244 (lambda () (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedCExp u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedCExp u--d u--x))))))
(define CoreC-45CaseC-45CaseTree-u--show_Show_Pat (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (string-append (CoreC-45Name-u--show_Show_Name e-1) (string-append "@(" (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-2) ")")))))) ((1) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (let ((e-7 (vector-ref arg-0 5))) (string-append (CoreC-45Name-u--show_Show_Name e-4) (string-append " " (string-append (PreludeC-45Show-u--show_Show_Int e-5) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1258) e-7))))))))) ((2) (let ((e-9 (vector-ref arg-0 2))) (let ((e-11 (vector-ref arg-0 4))) (string-append "<TyCon>" (string-append (CoreC-45Name-u--show_Show_Name e-9) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1258) e-11))))))) ((3) (let ((e-13 (vector-ref arg-0 2))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-13))) ((4) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (string-append "(" (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-16) (string-append " -> " (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-17) ")"))))))) ((5) (let ((e-21 (vector-ref arg-0 4))) (string-append "(Delay " (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat e-21) ")")))) ((6) (let ((e-23 (vector-ref arg-0 2))) (CoreC-45Name-u--show_Show_Name e-23))) (else (let ((e-25 (vector-ref arg-0 2))) (string-append ".(" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-25) ")")))))))
(define CoreC-45CaseC-45CaseTree-u--showPrec_Show_Pat (lambda (arg-0 arg-1) (CoreC-45CaseC-45CaseTree-u--show_Show_Pat arg-1)))
(define csegen-1258 (lambda () (cons (lambda (u--x) (CoreC-45CaseC-45CaseTree-u--show_Show_Pat u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CaseC-45CaseTree-u--showPrec_Show_Pat u--d u--x))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 arg-3) arg-2)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbrace (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\{))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbrace (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\}))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbrace LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbrace ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (lambda (arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (let ((e-1 (car arg-2))) (e-1 ext-0)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\:))
(define DataC-45Maybe-fromMaybe (lambda (arg-1 arg-2) (if (null? arg-2) (arg-1) (let ((e-2 (unbox arg-2))) e-2))))
(define PreludeC-45Interfaces-guard (lambda (arg-1 arg-2) (cond ((equal? arg-2 1) (let ((e-1 (vector-ref arg-1 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) (vector 0 ))))) (else (let ((e-2 (vector-ref arg-1 1))) (e-2 'erased))))))
(define PreludeC-45Types-strUncons (lambda (arg-0) (cond ((equal? arg-0 "") '())(else (box (cons (string-ref arg-0 0) (substring arg-0 1 (string-length arg-0))))))))
(define PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (lambda (arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (unbox arg-2))) (arg-3 e-2)))))
(define CoreC-45Name-isOpUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (DataC-45Maybe-fromMaybe (lambda () 0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) (PreludeC-45Types-strUncons e-0)) (lambda (u--c) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Name-isOpChar u--c)) (lambda (_-10649) (box 1)))))))) ((1) 0) (else 0))))
(define CoreC-45Name-isPrettyOp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((1) arg-0) ((0) (CoreC-45Name-isOpUserName e-0))(else 0)))) ((4) (let ((e-1 (vector-ref arg-1 1))) (CoreC-45Name-isOpUserName (vector 0 e-1))))(else 0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lparen (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\())
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rparen (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lparen LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rparen ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (lambda (arg-1 ext-0) (cond ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens ext-0)) (else ext-0))))
(define CoreC-45Name-prettyOp (lambda (arg-0 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (CoreC-45Name-isPrettyOp arg-0 arg-1) (CoreC-45Name-u--pretty_Pretty_Void_Name arg-1))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline (vector 7 (lambda () (vector 1 #\ )) (lambda () (vector 3 ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline) u--y))) ext-0)))
(define DataC-45List-dropWhile (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (DataC-45List-dropWhile arg-1 e-3)) (else (cons e-2 e-3)))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-case--wordsC-44helper-5200 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((sc1 (DataC-45List-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-3))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons e-2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-n--3788-5188-u--helper arg-1 e-3))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-n--3788-5188-u--helper (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-case--wordsC-44helper-5200 arg-1 arg-2 (DataC-45List-dropWhile (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-words (lambda (arg-1) (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-n--3788-5188-u--helper arg-1 (PreludeC-45Types-fastUnpack arg-1))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-words ext-0))))
(define CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_Namespace (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-510 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String eta-0)) (PreludeC-45TypesC-45List-reverse arg-0)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 ext-0)))
(define CoreC-45Name-u--pretty_Pretty_Void_UserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ".") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-1)))) (else csegen-505))))
(define CoreC-45Name-u--pretty_Pretty_Void_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_Namespace e-0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (CoreC-45Name-prettyOp 1 e-1))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45Name-u--pretty_Pretty_Void_UserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-3) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_Char #\P) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (CoreC-45Name-u--pretty_Pretty_Void_Name e-5)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-6)))))) ((4) (let ((e-7 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-7))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-18 (car e-9))) (let ((e-19 (cdr e-9))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-18) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-19)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (CoreC-45Name-u--pretty_Pretty_Void_Name e-10))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "case block in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-11)))) ((7) (let ((e-13 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with block in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-13)))) (else (let ((e-15 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "$resolved") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Int e-15))))))))
(define CoreC-45Name-u--prettyPrec_Pretty_Void_Name (lambda (arg-0 arg-1) (CoreC-45Name-u--pretty_Pretty_Void_Name arg-1)))
(define csegen-1260 (cons (lambda (arg-11067) (CoreC-45Name-u--pretty_Pretty_Void_Name arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45Name-u--prettyPrec_Pretty_Void_Name arg-11073 arg-11076)))))
(define IdrisC-45PrettyC-45Annotations-arrow csegen-960)
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-716 ext-0)))
(define PreludeC-45Show-u--C-62_Ord_Prec (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Show-u--compare_Ord_Prec arg-0 arg-1) 2)))
(define CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_PrimType (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 '()) (cond ((equal? arg-0 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Int")) ((equal? arg-0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Int8")) ((equal? arg-0 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Int16")) ((equal? arg-0 3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Int32")) ((equal? arg-0 4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Int64")) ((equal? arg-0 5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Integer")) ((equal? arg-0 6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Bits8")) ((equal? arg-0 7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Bits16")) ((equal? arg-0 8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Bits32")) ((equal? arg-0 9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Bits64")) ((equal? arg-0 10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "String")) ((equal? arg-0 11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Char")) ((equal? arg-0 12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Double")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "%World"))))))
(define CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant (lambda (arg-0) (case (vector-ref arg-0 0) ((13) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_PrimType e-0)))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 '()) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45TTC-45Primitive-u--show_Show_Constant arg-0)))))))
(define CoreC-45CaseC-45CaseTree-u--pretty_Pretty_IdrisSyntax_Pat (lambda (arg-0) (CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_IdrisSyntax_Pat (vector 0 ) arg-0)))
(define csegen-1268 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 '() u--d u--x)))))
(define CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_IdrisSyntax_Pat (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "@")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_IdrisSyntax_Pat e-2))))))) ((1) (let ((e-4 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-4) (PreludeC-45TypesC-45List-mapAppend '() (csegen-1263) e-7))))))) ((2) (let ((e-9 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-9) (PreludeC-45TypesC-45List-mapAppend '() (csegen-1263) e-11))))))) ((3) (let ((e-13 (vector-ref arg-1 2))) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant e-13))) ((4) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_IdrisSyntax_Pat e-16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-arrow (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_IdrisSyntax_Pat e-17))))))) ((5) (let ((e-21 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Delay") (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_IdrisSyntax_Pat e-21))))) ((6) (let ((e-23 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-23))) (else (let ((e-25 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ".")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1268 e-25))))))))
(define csegen-1263 (lambda () (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--prettyPrec_Pretty_IdrisSyntax_Pat (vector 6 ) eta-0))))
(define CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (arg-3) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-6 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Context-u--full_HasNames_Transform (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-0 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-0 e-5 e-6 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define CoreC-45Context-u--resolved_HasNames_Transform (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-0 e-5 e-6 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define csegen-1273 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Transform arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Transform arg-7729 arg-7732 eta-0))))))
(define csegen-1275 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (box e-5)))))))
(define csegen-1278 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 0 eta-1 eta-2 eta-3)))))))
(define csegen-1281 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (vector 1 eta-1 eta-2 eta-3 eta-4 eta-5)))))))))
(define csegen-1284 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 2 eta-1 eta-2 eta-3 eta-4))))))))
(define csegen-1287 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 4 eta-1 eta-2 eta-3 eta-4))))))))
(define csegen-1290 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector 5 eta-1 eta-2 eta-3 eta-4))))))))
(define csegen-1294 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-5)))))))
(define csegen-1295 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-5)))))))
(define csegen-1296 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-5)))))))
(define csegen-1297 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 21 e-5)))))))
(define csegen-1298 (lambda (eta-0) (lambda (eta-1) (CoreC-45Core-traverseC-39 eta-0 eta-1 '()))))
(define csegen-1299 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (lambda (__infixTupleSection-0) (cons e-5 __infixTupleSection-0))))))))
(define csegen-1300 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 32 e-5)))))))
(define csegen-1301 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 48 e-5)))))))
(define csegen-1302 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (lambda (eta-1) (vector 72 e-5 eta-1))))))))
(define csegen-1303 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 73 e-5)))))))
(define csegen-1304 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 3 e-5)))))))
(define SystemC-45FFI-free (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45FFI-prim__free arg-2 eta-0))))))
(define SystemC-45Directory-currentDir (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__currentDir eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--res) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '()))))) (else (let ((u--s (PreludeC-45IO-prim__getString u--res))) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (SystemC-45FFI-free arg-1 u--res)) (lambda (_-10649) (let ((e-12 (car arg-1))) (let ((e-15 (vector-ref e-12 0))) (let ((e-17 (vector-ref e-15 1))) ((e-17 'erased) (box u--s)))))))))))))))))))
(define csegen-1310 (SystemC-45Directory-currentDir csegen-82))
(define csegen-1311 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't get current directory") eta-0)))
(define csegen-1313 (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)))
(define csegen-1314 (lambda (u--g) (cons (let ((e-18 (vector-ref u--g 18))) e-18) (let ((e-2 (vector-ref u--g 2))) e-2))))
(define csegen-1315 (lambda (eta-0) (let ((e-18 (vector-ref eta-0 18))) e-18)))
(define CoreC-45CompileExpr-u--C-61C-61_Eq_ConInfo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-1 (vector-ref arg-1 1))) (or (and (= e-0 e-1) 1) 0)))(else 0)))) ((5) (case (vector-ref arg-1 0) ((5) 1)(else 0))) ((6) (case (vector-ref arg-1 0) ((6) 1)(else 0))) ((7) (case (vector-ref arg-1 0) ((7) 1)(else 0))) ((8) (case (vector-ref arg-1 0) ((8) 1)(else 0))) ((9) (case (vector-ref arg-1 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-1 0) ((10) 1)(else 0)))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_TotalReq (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_DefFlag (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-1 0) ((4) 1)(else 0))) ((5) (case (vector-ref arg-1 0) ((5) 1)(else 0))) ((6) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-4 (vector-ref arg-1 1))) (CoreC-45TT-u--C-61C-61_Eq_TotalReq e-0 e-4)))(else 0)))) ((7) (case (vector-ref arg-1 0) ((7) 1)(else 0))) ((8) (case (vector-ref arg-1 0) ((8) 1)(else 0))) ((9) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-832 csegen-1032 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-832 csegen-1032 arg-686 arg-689)))) e-1 e-5)))(else 0)))) ((10) (case (vector-ref arg-1 0) ((10) 1)(else 0))) ((11) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45CompileExpr-u--C-61C-61_Eq_ConInfo e-2 e-6)))(else 0)))) ((12) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-7 (vector-ref arg-1 1))) (or (and (= e-3 e-7) 1) 0)))(else 0))))(else 0))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_DefFlag arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1319 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45ContextC-45Context-u--C-61C-61_Eq_DefFlag arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-686 arg-689)))))
(define csegen-1325 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (vector eta-1 eta-2 eta-3 eta-4 eta-5 eta-6 eta-7)))))))))))
(define CoreC-45Options-u--C-61C-61_Eq_CG (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (case (vector-ref arg-1 0) ((0) 1)(else 0))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-1 0) ((4) 1)(else 0))) ((5) (case (vector-ref arg-1 0) ((5) 1)(else 0))) ((6) (case (vector-ref arg-1 0) ((6) 1)(else 0))) ((7) (case (vector-ref arg-1 0) ((7) 1)(else 0))) ((8) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-1)))(else 0))))(else 0))))
(define CoreC-45Options-u--C-47C-61_Eq_CG (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Options-u--C-61C-61_Eq_CG arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1331 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45Options-u--C-61C-61_Eq_CG arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45Options-u--C-47C-61_Eq_CG arg-686 arg-689)))))
(define csegen-1333 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)))
(define csegen-1338 (vector '() '() '() '() '() '() '()))
(define LibrariesC-45DataC-45StringC-45Iterator-withString (lambda (arg-1 arg-2) (arg-2 (LibrariesC-45DataC-45StringC-45Iterator-fromString arg-1))))
(define LibrariesC-45DataC-45StringC-45Iterator-n--2779-2205-u--loop (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((sc0 (LibrariesC-45DataC-45StringC-45Iterator-uncons arg-1 arg-5))) (if (null? sc0) arg-4 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45DataC-45StringC-45Iterator-n--2779-2205-u--loop arg-1 arg-2 arg-3 ((arg-3 arg-4) e-2) e-3)))))))
(define LibrariesC-45DataC-45StringC-45Iterator-foldl (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45StringC-45Iterator-withString arg-3 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Iterator-n--2779-2205-u--loop arg-3 arg-2 arg-1 arg-2 eta-0)))))
(define CoreC-45Hash-u--hash_Hashable_Char (lambda (ext-0) (cast-char-boundedInt ext-0 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Char (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Char arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_String (lambda (arg-0 ext-0) (LibrariesC-45DataC-45StringC-45Iterator-foldl (lambda (eta-0) (lambda (eta-1) (CoreC-45Hash-u--hashWithSalt_Hashable_Char eta-0 eta-1))) arg-0 ext-0)))
(define CoreC-45Hash-u--hash_Hashable_String (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_String (blodwen-toSignedInt 5381 63) ext-0)))
(define csegen-1355 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_String arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_String arg-4541 arg-4544)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) arg-1 63)))
(define PreludeC-45Num-u--abs_Abs_Int (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-0 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (bs- 0 arg-0 63)) (else arg-0)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (PreludeC-45Num-u--abs_Abs_Int arg-2) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 arg-1 (bs+ (bs* arg-2 33 63) (let ((e-1 (car arg-1))) (e-1 e-2)) 63) e-3))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Namespace (lambda (arg-0 arg-1) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 csegen-1355 arg-0 arg-1)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Name (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_String arg-0 e-0))) ((4) (let ((e-3 (vector-ref arg-1 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name arg-0 e-3))) ((0) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Namespace arg-0 e-4) e-5)))) ((8) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int arg-0 e-6)))(else (CoreC-45Hash-u--hashWithSalt_Hashable_String arg-0 (CoreC-45Name-u--show_Show_Name arg-1))))))
(define CoreC-45Hash-u--hash_Hashable_Name (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (blodwen-toSignedInt 5381 63) ext-0)))
(define csegen-1357 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_Name arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_Name arg-4541 arg-4544)))))
(define CoreC-45Hash-u--hash_Hashable_Nat (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Nat (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Nat arg-1) 63)))
(define csegen-1359 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_Nat arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_Nat arg-4541 arg-4544)))))
(define csegen-1361 (cons (lambda (arg-4535) arg-4535) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_Int arg-4541 arg-4544)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (cdr arg-3))) ((e-4 (let ((e-5 (cdr arg-2))) ((e-5 arg-4) e-2))) e-3))))))
(define CoreC-45Hash-u--hash_Hashable_Integer (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Integer (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Integer arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_CFType (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0)) ((1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) ((7) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ((8) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3)) ((9) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4)) ((10) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5)) ((11) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6)) ((12) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7)) ((13) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8)) ((14) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9)) ((15) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10)) ((16) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11)) ((18) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12)) ((19) (let ((e-0 (vector-ref ext-0 1))) (let ((e-1 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13) e-0) e-1)))) ((20) (let ((e-2 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14) e-2))) ((21) (let ((e-3 (vector-ref ext-0 1))) (let ((e-4 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1355 (csegen-1363) arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1355 (csegen-1363) arg-4541 arg-4544)))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 15) e-3) e-4)))) ((22) (let ((e-5 (vector-ref ext-0 1))) (let ((e-6 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-1363) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 16) e-5) e-6)))) ((3) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 17)) ((4) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 18)) ((5) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 19)) ((6) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 20)) ((17) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 21)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 22)))))
(define CoreC-45Hash-u--hash_Hashable_CFType (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (blodwen-toSignedInt 5381 63) ext-0)))
(define csegen-1363 (lambda () (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_CFType arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType arg-4541 arg-4544))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (PreludeC-45Num-u--abs_Abs_Int arg-3) (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 arg-2 (bs+ (bs* arg-3 33 63) (let ((e-1 (car arg-2))) (e-1 e-3)) 63) e-4))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (PreludeC-45Num-u--abs_Abs_Int arg-2) (let ((e-2 (unbox arg-3))) (let ((e-3 (cdr arg-1))) ((e-3 arg-2) e-2))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (lambda (arg-0 ext-0) (cond ((equal? ext-0 0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) ((equal? ext-0 1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ((equal? ext-0 2) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3)) ((equal? ext-0 3) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4)) ((equal? ext-0 4) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5)) ((equal? ext-0 5) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6)) ((equal? ext-0 6) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7)) ((equal? ext-0 7) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8)) ((equal? ext-0 8) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9)) ((equal? ext-0 9) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10)) ((equal? ext-0 10) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11)) ((equal? ext-0 11) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12)) ((equal? ext-0 12) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40PrimFnC-32C-36arityC-41 (lambda (arg-1 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-0 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 0) e-0))) ((1) (let ((e-1 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 1) e-1))) ((2) (let ((e-2 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 2) e-2))) ((3) (let ((e-3 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 3) e-3))) ((4) (let ((e-4 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 4) e-4))) ((5) (let ((e-5 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 5) e-5))) ((6) (let ((e-6 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 6) e-6))) ((7) (let ((e-7 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 7) e-7))) ((8) (let ((e-8 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 8) e-8))) ((9) (let ((e-9 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 9) e-9))) ((10) (let ((e-10 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 10) e-10))) ((11) (let ((e-11 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 11) e-11))) ((12) (let ((e-12 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 12) e-12))) ((13) (let ((e-13 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 13) e-13))) ((14) (let ((e-14 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 14) e-14))) ((15) (let ((e-15 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 15) e-15))) ((16) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 16)) ((17) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 17)) ((18) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 18)) ((19) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 19)) ((20) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 20)) ((21) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 21)) ((22) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 22)) ((23) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 23)) ((24) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 24)) ((25) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 25)) ((27) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 26)) ((28) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 27)) ((29) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 28)) ((30) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 29)) ((31) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 30)) ((32) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 31)) ((33) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 32)) ((34) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 33)) ((35) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 34)) ((36) (let ((e-16 (vector-ref ext-0 1))) (let ((e-17 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 35) e-16) e-17)))) ((37) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 36)) ((38) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 37)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 38)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_ConInfo (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0)) ((1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) ((2) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ((3) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3)) ((4) (let ((e-0 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Nat (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4) e-0))) ((5) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5)) ((6) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6)) ((7) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7)) ((8) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8)) ((9) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10)))))
(define CoreC-45Hash-u--hash_Hashable_Bits16 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits16 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits16 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Bits32 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits32 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits32 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Bits64 (lambda (ext-0) (blodwen-toSignedInt ext-0 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits64 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits64 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Bits8 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Bits8 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Bits8 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Double (lambda (ext-0) (CoreC-45Hash-u--hash_Hashable_String (PreludeC-45Show-u--show_Show_Double ext-0))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Double (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Double arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Int16 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int16 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int16 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Int32 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int32 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int32 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Int64 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int64 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int64 arg-1) 63)))
(define CoreC-45Hash-u--hash_Hashable_Int8 (lambda (ext-0) ext-0))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Int8 (lambda (arg-0 arg-1) (bs+ (bs* arg-0 33 63) (CoreC-45Hash-u--hash_Hashable_Int8 arg-1) 63)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_Constant (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-0 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) e-0))) ((1) (let ((e-1 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int8 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) e-1))) ((2) (let ((e-2 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int16 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2) e-2))) ((3) (let ((e-3 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int32 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3) e-3))) ((4) (let ((e-4 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Int64 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4) e-4))) ((5) (let ((e-5 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5) e-5))) ((6) (let ((e-6 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits8 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6) e-6))) ((7) (let ((e-7 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits16 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7) e-7))) ((8) (let ((e-8 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits32 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8) e-8))) ((9) (let ((e-9 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Bits64 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9) e-9))) ((10) (let ((e-10 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10) e-10))) ((11) (let ((e-11 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Char (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11) e-11))) ((12) (let ((e-12 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_Double (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12) e-12))) ((13) (let ((e-13 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_PrimType (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13) e-13))) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_LazyReason (lambda (arg-0 ext-0) (cond ((equal? ext-0 0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0)) ((equal? ext-0 1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1)) (else (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedConAlt (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 csegen-1357 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 csegen-1361 (CoreC-45Hash-u--hashWithSalt_Hashable_ConInfo (CoreC-45Hash-u--hashWithSalt_Hashable_Name arg-0 e-0) e-1) e-2) e-3) e-4))))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedConstAlt (lambda (arg-0 arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Constant arg-0 e-0) e-1)))))
(define CoreC-45Hash-u--hash_Hashable_NamedConAlt (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConAlt (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hash_Hashable_NamedConstAlt (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConstAlt (blodwen-toSignedInt 5381 63) ext-0)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-1 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) e-1))) ((1) (let ((e-3 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) e-3))) ((2) (let ((e-5 (vector-ref ext-0 2))) (let ((e-6 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2) e-5) e-6)))) ((3) (let ((e-8 (vector-ref ext-0 2))) (let ((e-9 (vector-ref ext-0 3))) (let ((e-10 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3) e-8) e-9) e-10))))) ((4) (let ((e-12 (vector-ref ext-0 2))) (let ((e-13 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-1365) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 4) e-12) e-13)))) ((5) (let ((e-15 (vector-ref ext-0 2))) (let ((e-16 (vector-ref ext-0 3))) (let ((e-17 (vector-ref ext-0 4))) (let ((e-18 (vector-ref ext-0 5))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-1365) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 csegen-1361 (CoreC-45Hash-u--hashWithSalt_Hashable_ConInfo (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 5) e-15) e-16) e-17) e-18)))))) ((6) (let ((e-21 (vector-ref ext-0 3))) (let ((e-22 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (csegen-1365) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PrimFnC-32C-36arityC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 6) e-21) e-22)))) ((7) (let ((e-24 (vector-ref ext-0 2))) (let ((e-25 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-1365) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 7) e-24) e-25)))) ((8) (let ((e-27 (vector-ref ext-0 2))) (let ((e-28 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_LazyReason (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 8) e-27) e-28)))) ((9) (let ((e-30 (vector-ref ext-0 2))) (let ((e-31 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_LazyReason (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 9) e-30) e-31)))) ((10) (let ((e-33 (vector-ref ext-0 2))) (let ((e-34 (vector-ref ext-0 3))) (let ((e-35 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-1365) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_NamedConAlt arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConAlt arg-4541 arg-4544)))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 10) e-33) e-34) e-35))))) ((11) (let ((e-37 (vector-ref ext-0 2))) (let ((e-38 (vector-ref ext-0 3))) (let ((e-39 (vector-ref ext-0 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 (csegen-1365) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_NamedConstAlt arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedConstAlt arg-4541 arg-4544)))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 11) e-37) e-38) e-39))))) ((12) (let ((e-41 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Constant (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 12) e-41))) ((13) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 13)) (else (let ((e-44 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 14) e-44))))))
(define CoreC-45Hash-u--hash_Hashable_NamedCExp (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (blodwen-toSignedInt 5381 63) ext-0)))
(define csegen-1365 (lambda () (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_NamedCExp arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp arg-4541 arg-4544))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 0)) ((1) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 1)) ((2) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 2)) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 3)) e-4)))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (lambda (arg-0 ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) (lambda (eta-0) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2)) ext-0)))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40BinderC-32C-36tyC-41 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (cdr arg-1))) ((e-5 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 arg-1 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 0) e-2) e-3)) e-4)))))) ((1) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (let ((e-3 (cdr arg-1))) ((e-3 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 1) e-7)) e-8))) e-9)))))) ((2) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 arg-1 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 2) e-12) e-13)) e-14)))))) ((3) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40PiInfoC-32C-36tC-41 arg-1 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 3) e-17) e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((e-2 (cdr arg-1))) ((e-2 (let ((e-3 (cdr arg-1))) ((e-3 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 4) e-22)) e-23))) e-24)))))) (else (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-2 (cdr arg-1))) ((e-2 (CoreC-45Hash-u--hashWithSalt_Hashable_RigCount (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-2 5) e-27)) e-28))))))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_Nat (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 0) e-4))) ((1) (let ((e-9 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 1) e-9))) ((2) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-1374) (CoreC-45Hash-u--hashWithSalt_Hashable_Int (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 2) e-13) e-14)))) ((3) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40BinderC-32C-36tyC-41 (csegen-1374) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 3) e-18) e-19)))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 4) e-22) e-23)))) ((5) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 5) e-27) e-28)))) ((6) (let ((e-32 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 6) e-32))) ((7) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 7) e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-2 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 8) e-41))) ((9) (let ((e-44 (vector-ref arg-2 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_String (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 9) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-44)))) ((10) (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 10)) (else (let ((e-50 (vector-ref arg-2 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-1 11) e-50))))))
(define CoreC-45Hash-u--hash_Hashable_C-40TermC-32C-36varsC-41 (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 (blodwen-toSignedInt 5381 63) ext-0)))
(define csegen-1374 (lambda () (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_C-40TermC-32C-36varsC-41 arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40TermC-32C-36varsC-41 arg-4541 arg-4544))))))
(define csegen-1375 (CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) (blodwen-toSignedInt 0 63)))
(define CoreC-45Value-u--full_HasNames_C-40NHeadC-32C-36freeC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-1 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-1 e-2 eta-0)) ext-0))))(else (vector 1 arg-2)))))
(define CoreC-45Value-u--full_HasNames_C-40NFC-32C-36freeC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 1 (vector 0 e-1 e-2 e-3 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45Value-u--full_HasNames_C-40NHeadC-32C-36freeC-41 arg-1 e-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6 e-5 e-8))))) eff-0) ext-0))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((e-14 (vector-ref arg-2 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-10 e-5 e-12 e-13 e-14))))) eff-0) ext-0))))))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (let ((e-20 (vector-ref arg-2 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-17 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-16 e-5 e-18 e-19 e-20))))) eff-0) ext-0))))))))))) ((4) (let ((e-22 (vector-ref arg-2 1))) (let ((e-23 (vector-ref arg-2 2))) (let ((e-24 (vector-ref arg-2 3))) (let ((e-25 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45Value-u--full_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-24 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Value-u--full_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-25 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-22 e-23 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((5) (let ((e-27 (vector-ref arg-2 1))) (let ((e-28 (vector-ref arg-2 2))) (let ((e-29 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45Value-u--full_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-29 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-27 e-28 e-5))))) eff-0) ext-0))))))))) ((6) (let ((e-31 (vector-ref arg-2 1))) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (let ((e-34 (vector-ref arg-2 4))) (vector 1 (vector 6 e-31 e-32 e-33 e-34))))))) ((7) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45Value-u--full_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-38 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-36 e-37 e-5 e-39))))) eff-0) ext-0)))))))))) ((8) (let ((e-41 (vector-ref arg-2 1))) (let ((e-42 (vector-ref arg-2 2))) (vector 1 (vector 8 e-41 e-42))))) ((9) (let ((e-44 (vector-ref arg-2 1))) (let ((e-45 (vector-ref arg-2 2))) (vector 1 (vector 9 e-44 e-45))))) (else (let ((e-47 (vector-ref arg-2 1))) (let ((e-48 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-48 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-47 e-5))))) eff-0) ext-0)))))))))))
(define CoreC-45Value-u--resolved_HasNames_C-40NHeadC-32C-36freeC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-1 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-1 e-2) ext-0))))(else (vector 1 arg-2)))))
(define CoreC-45Value-u--resolved_HasNames_C-40NFC-32C-36freeC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 1 (vector 0 e-1 e-2 e-3 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45Value-u--resolved_HasNames_C-40NHeadC-32C-36freeC-41 arg-1 e-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6 e-5 e-8))))) eff-0) ext-0))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((e-14 (vector-ref arg-2 5))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-1 e-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-10 e-5 e-12 e-13 e-14))))) eff-0) ext-0))))))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (let ((e-20 (vector-ref arg-2 5))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-1 e-17) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-16 e-5 e-18 e-19 e-20))))) eff-0) ext-0))))))))))) ((4) (let ((e-22 (vector-ref arg-2 1))) (let ((e-23 (vector-ref arg-2 2))) (let ((e-24 (vector-ref arg-2 3))) (let ((e-25 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45Value-u--resolved_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-24 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Value-u--resolved_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-25 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-22 e-23 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((5) (let ((e-27 (vector-ref arg-2 1))) (let ((e-28 (vector-ref arg-2 2))) (let ((e-29 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45Value-u--resolved_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-29 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-27 e-28 e-5))))) eff-0) ext-0))))))))) ((6) (let ((e-31 (vector-ref arg-2 1))) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (let ((e-34 (vector-ref arg-2 4))) (vector 1 (vector 6 e-31 e-32 e-33 e-34))))))) ((7) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45Value-u--resolved_HasNames_C-40NFC-32C-36freeC-41 arg-1 e-38 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-36 e-37 e-5 e-39))))) eff-0) ext-0)))))))))) ((8) (let ((e-41 (vector-ref arg-2 1))) (let ((e-42 (vector-ref arg-2 2))) (vector 1 (vector 8 e-41 e-42))))) ((9) (let ((e-44 (vector-ref arg-2 1))) (let ((e-45 (vector-ref arg-2 2))) (vector 1 (vector 9 e-44 e-45))))) (else (let ((e-47 (vector-ref arg-2 1))) (let ((e-48 (vector-ref arg-2 2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-1 e-48) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-47 e-5))))) eff-0) ext-0)))))))))))
(define csegen-1378 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Value-u--full_HasNames_C-40NFC-32C-36freeC-41 arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Value-u--resolved_HasNames_C-40NFC-32C-36freeC-41 arg-7729 arg-7732 eta-0))))))
(define LibrariesC-45DataC-45ListC-45SizeOf-suc (lambda (arg-3) (+ arg-3 1)))
(define CoreC-45NameC-45Scoped-GenWeakenWeakens (lambda (arg-1) (cons (lambda (nm-4459) (lambda (vars-4460) (((((arg-1 'erased) 'erased) 'erased) 0) (LibrariesC-45DataC-45ListC-45SizeOf-suc 0)))) (lambda (vars-4478) (lambda (ns-4479) ((((arg-1 'erased) 'erased) 'erased) 0))))))
(define LibrariesC-45DataC-45ListC-45SizeOf-C-43 (lambda (arg-3 arg-4) (+ arg-3 arg-4)))
(define DataC-45So-choose (lambda (arg-0) (cond ((equal? arg-0 1) (vector 0 (vector 0 ))) (else (vector 1 (vector 0 ))))))
(define CoreC-45TTC-45Var-locateIsVar (lambda (arg-4 arg-5) (let ((sc0 (DataC-45So-choose (PreludeC-45Types-u--C-60_Ord_Nat arg-4 arg-5)))) (case (vector-ref sc0 0) ((0) (vector 0 (vector 0 ))) (else (vector 1 (vector 0 )))))))
(define CoreC-45TTC-45Var-locateNVar (lambda (arg-4 arg-5) (let ((sc0 (CoreC-45TTC-45Var-locateIsVar arg-5 arg-4))) (case (vector-ref sc0 0) ((0) (vector 0 arg-5)) (else (vector 1 (PreludeC-45Types-prim__integerToNat (- arg-5 arg-4))))))))
(define CoreC-45TTC-45Var-weakenNVar (lambda (arg-4 arg-5) (+ arg-4 arg-5)))
(define CoreC-45TTC-45Var-insertNVarNames (lambda (arg-4 arg-5 arg-6) (let ((sc0 (CoreC-45TTC-45Var-locateNVar arg-4 arg-6))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) e-2)) (else (let ((e-5 (vector-ref sc0 1))) (CoreC-45TTC-45Var-weakenNVar (LibrariesC-45DataC-45ListC-45SizeOf-C-43 arg-4 arg-5) e-5)))))))
(define CoreC-45TTC-45Term-insertNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((eff-0 (CoreC-45TTC-45Var-insertNVarNames arg-3 arg-4 e-4))) (vector 0 e-2 e-3 eff-0)))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-insertNames arg-3 arg-4 eta-0)) e-14))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (vector 3 e-16 e-17 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TTC-45Term-insertNames arg-3 arg-4 eta-0)) e-18) (CoreC-45TTC-45Term-insertNames (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 e-19))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (vector 4 e-21 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-22) (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-23)))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (vector 5 e-25 e-26 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-27) (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-28))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (vector 6 e-30 e-31 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-32)))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (let ((e-37 (vector-ref arg-5 4))) (vector 7 e-34 e-35 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-36) (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-37))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (let ((e-41 (vector-ref arg-5 3))) (vector 8 e-39 e-40 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-41)))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (case (vector-ref e-47 0) ((1) (vector 10 e-46 (vector 1 ))) ((0) (vector 10 e-46 (vector 0 ))) (else (let ((e-54 (vector-ref e-47 1))) (vector 10 e-46 (vector 2 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-54))))))))) (else (let ((e-49 (vector-ref arg-5 1))) (let ((e-50 (vector-ref arg-5 2))) (vector 11 e-49 e-50)))))))
(define CoreC-45TTC-45Term-u--genWeakenNs_GenWeaken_Term (lambda (ext-0 ext-1 ext-2) (CoreC-45TTC-45Term-insertNames ext-0 ext-1 ext-2)))
(define CoreC-45TTC-45Term-WeakenTerm (CoreC-45NameC-45Scoped-GenWeakenWeakens (lambda (outer-4316) (lambda (ns-4317) (lambda (local-4318) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45TTC-45Term-u--genWeakenNs_GenWeaken_Term eta-0 eta-1 eta-2)))))))))
(define CoreC-45TTC-45Term-fnType (lambda (arg-0 arg-1 arg-2 arg-3) (vector 3 CoreC-45FC-emptyFC (vector 2 "_" 0) (vector 2 arg-1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) arg-2) (let ((sc0 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc0))) (((e-1 'erased) 'erased) arg-3))))))
(define csegen-1385 (lambda (eta-0) (lambda (eta-1) (CoreC-45TTC-45Term-fnType '() CoreC-45FC-emptyFC eta-0 eta-1))))
(define csegen-1411 (vector 11 CoreC-45FC-emptyFC (vector 2 "top" 0)))
(define csegen-1413 (vector 0 CoreC-45FC-emptyFC '() 1))
(define csegen-1501 (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (PreludeC-45TypesC-45List-mapAppend '() u--func arg-8885))))))
(define PreludeC-45Types-listBindOnto (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (PreludeC-45TypesC-45List-reverse arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-listBindOnto arg-2 (PreludeC-45TypesC-45List-reverseOnto arg-3 (arg-2 e-2)) e-3))))))
(define PreludeC-45Types-listBind (lambda (arg-2 arg-3) (PreludeC-45Types-listBindOnto arg-3 '() arg-2)))
(define PreludeC-45Types-u--C-60C-42C-62_Applicative_List (lambda (arg-2 arg-3) (PreludeC-45Types-listBind arg-2 (lambda (u--f) (PreludeC-45TypesC-45List-mapAppend '() u--f arg-3)))))
(define PreludeC-45Types-u--pure_Applicative_List (lambda (arg-1) (cons arg-1 '())))
(define csegen-1509 (vector (vector csegen-1501 (lambda (u--a) (lambda (arg-9931) (PreludeC-45Types-u--pure_Applicative_List arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (PreludeC-45Types-u--C-60C-42C-62_Applicative_List arg-9937 arg-9944)))))) (lambda (u--a) '()) (lambda (u--a) (lambda (arg-10313) (lambda (arg-10316) (PreludeC-45TypesC-45List-tailRecAppend arg-10313 (arg-10316)))))))
(define CoreC-45TTC-45Primitive-u--C-47C-61_Eq_PrimType (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1512 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_PrimType arg-686 arg-689)))))
(define csegen-1617 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Buffer creation failed") eta-0)))
(define csegen-1622 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 arg-686 arg-689)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 2)))
(define PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 0)))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 0)))
(define PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5) 2)))
(define PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5))) (cond ((equal? sc0 1) arg-4) (else arg-5)))))
(define PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 arg-3 arg-4 arg-5))) (cond ((equal? sc0 1) arg-4) (else arg-5)))))
(define csegen-1630 (vector csegen-1622 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-1626 arg-1629)))))
(define csegen-1631 (lambda (eta-0) (lambda (eta-1) (PreludeC-45TypesC-45List-mapMaybeAppend '() eta-0 eta-1))))
(define LibrariesC-45DataC-45Version-n--4336-3065-u--showTag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) "" (let ((e-2 (unbox arg-3))) (string-append "-" e-2)))))
(define LibrariesC-45DataC-45Version-showVersion (lambda (arg-0 arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((e-4 (car e-0))) (let ((e-5 (cdr e-0))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse "." (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_Nat eta-0)) (cons e-4 (cons e-8 (cons e-9 '())))))) (cond ((equal? arg-0 1) (LibrariesC-45DataC-45Version-n--4336-3065-u--showTag e-4 e-8 e-9 e-1 arg-0)) (else "")))))))))))
(define IdrisPaths-idrisVersion (cons (cons 0 (cons 7 0)) ""))
(define IdrisC-45Version-with--version-3796 (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-3 "") (cons e-2 '()))(else (cons e-2 (box e-3))))))))
(define IdrisC-45Version-version (IdrisC-45Version-with--version-3796 IdrisPaths-idrisVersion))
(define csegen-1634 (LibrariesC-45DataC-45Version-showVersion 0 IdrisC-45Version-version))
(define PreludeC-45Types-u--C-60C-61_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Integer arg-0 arg-1) 2)))
(define PreludeC-45Types-u--C-62C-61_Ord_Nat (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Integer arg-0 arg-1) 0)))
(define PreludeC-45Types-u--min_Ord_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_Nat arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-1647 (vector csegen-1032 csegen-1059 (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45Types-u--C-60_Ord_Nat arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45Types-u--C-62_Ord_Nat arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45Types-u--C-62C-61_Ord_Nat arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45Types-u--max_Ord_Nat arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45Types-u--min_Ord_Nat arg-1626 arg-1629)))))
(define LibrariesC-45DataC-45Version-u--C-61C-61_Eq_VersionTokenKind (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define LibrariesC-45DataC-45Version-u--C-47C-61_Eq_VersionTokenKind (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45DataC-45Version-u--C-61C-61_Eq_VersionTokenKind arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define LibrariesC-45DataC-45Version-u--TokType_TokenKind_VersionTokenKind (lambda (arg-0) (cond ((equal? arg-0 0) (vector "String" )) ((equal? arg-0 2) (vector "Builtin.Unit" )) ((equal? arg-0 3) (vector "Builtin.Unit" )) (else (vector "Prelude.Types.Nat" )))))
(define DataC-45String-stringToNatOrZ (lambda (ext-0) (PreludeC-45Types-prim__integerToNat (cast-string-int ext-0))))
(define LibrariesC-45DataC-45Version-u--tokValue_TokenKind_VersionTokenKind (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1) ((equal? arg-0 2) (vector 0 )) ((equal? arg-0 3) (vector 0 )) (else (DataC-45String-stringToNatOrZ arg-1)))))
(define csegen-1672 (cons (cons (lambda (arg-676) (lambda (arg-679) (LibrariesC-45DataC-45Version-u--C-61C-61_Eq_VersionTokenKind arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (LibrariesC-45DataC-45Version-u--C-47C-61_Eq_VersionTokenKind arg-686 arg-689)))) (cons (lambda (arg-823) (LibrariesC-45DataC-45Version-u--TokType_TokenKind_VersionTokenKind arg-823)) (lambda (u--kind) (lambda (arg-832) (LibrariesC-45DataC-45Version-u--tokValue_TokenKind_VersionTokenKind u--kind arg-832))))))
(define csegen-1673 (LibrariesC-45TextC-45Parser-match csegen-1672 1))
(define csegen-1674 (LibrariesC-45TextC-45Parser-match csegen-1672 2))
(define csegen-1713 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char #\. arg-0)))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-124C-41 (lambda (arg-1 arg-2 ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-5 e-3))))) eff-0) ext-0)))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-124C-41 (lambda (arg-1 arg-2 ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-1 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-5 e-3))))) eff-0) ext-0)))))))))
(define csegen-1728 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-124C-41 arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40ListC-32C-36aC-41C-41C-124C-41 arg-7729 arg-7732 eta-0))))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Transform arg-0 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_Transform arg-0 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define csegen-1731 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32TransformC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32TransformC-41C-124C-41 arg-7729 arg-7732 eta-0))))))
(define csegen-1734 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_Namespace arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-5542 eta-0)))))
(define csegen-1735 (cons csegen-1734 csegen-1562))
(define csegen-1738 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1735 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1735 arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_CG (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (vector 1 (vector 3 ))) ((equal? e-5 4) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-6))))) eff-0) clam-0)))))) ((equal? e-5 5) (vector 1 (vector 4 ))) ((equal? e-5 6) (vector 1 (vector 5 ))) ((equal? e-5 7) (vector 1 (vector 6 ))) ((equal? e-5 8) (vector 1 (vector 7 )))(else (CoreC-45BinaryC-45Prims-corrupt "CG" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_CG (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((8) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-0) ext-0)))))) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((5) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((6) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)))))
(define csegen-1741 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_CG arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_CG arg-5542 eta-0)))))
(define csegen-1744 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-5542 eta-0)))))
(define csegen-1745 (cons csegen-1559 csegen-1744))
(define csegen-1749 (cons csegen-1741 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1745 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1745 arg-5542 eta-0))))))
(define csegen-1752 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1749 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1749 arg-5542 eta-0)))))
(define csegen-1755 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_ModuleIdent arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_ModuleIdent arg-5542 eta-0)))))
(define csegen-1756 (cons csegen-44 csegen-1734))
(define csegen-1760 (cons csegen-1755 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1756 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1756 arg-5542 eta-0))))))
(define csegen-1763 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1760 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1760 arg-5542 eta-0)))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Binary (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--len e-5)) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-toRead e-6) u--len))) (cond ((equal? sc2 1) (let ((act-3 (let ((act-3 ((DataC-45Buffer-newBuffer csegen-82 e-5) clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (CoreC-45BinaryC-45Prims-corrupt "Binary" clam-1) (let ((e-1 (unbox e-7))) (let ((act-4 (let ((act-4 ((DataC-45Buffer-copyData csegen-82 (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-4 (vector-ref e-6 1))) e-4) 63) e-5 e-1 0) clam-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc u--len e-6)))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (vector e-1 0 u--len u--len))))))))))))) eff-0) clam-0)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 1 "Binary")) clam-0))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_Binary (lambda (arg-0 arg-1) (let ((u--len (let ((e-3 (vector-ref arg-1 3))) e-3))) (let ((u--ilen (blodwen-toSignedInt u--len 63))) (lambda (eta-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 u--ilen) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-avail e-6) u--len))) (cond ((equal? sc2 1) (let ((act-3 (let ((act-3 ((DataC-45Buffer-copyData csegen-82 (let ((e-0 (vector-ref arg-1 0))) e-0) 0 u--ilen (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63)) clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--len e-6)))) (vector 1 act-4)))))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-extendBinary u--len e-6) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((DataC-45Buffer-copyData csegen-82 (let ((e-0 (vector-ref arg-1 0))) e-0) 0 u--ilen (let ((e-0 (vector-ref e-7 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-7 1))) e-1) 63)) eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended u--len e-7)))) (vector 1 act-5)))))))) eff-0) clam-0))))))))))) eff-0) eta-0)))))))))))))
(define csegen-1767 (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Binary arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Binary arg-5542 eta-0))))))
(define csegen-1770 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1767 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1767 arg-5542 eta-0)))))
(define csegen-1771 (cons csegen-41 csegen-48))
(define csegen-1774 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1771 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1771 arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_PairNames (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_PairNames (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0)))))))))
(define csegen-1777 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_PairNames arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_PairNames arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_RewriteNames (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_RewriteNames (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-1 (cdr arg-1))) e-1)) ext-0))))))
(define csegen-1780 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_RewriteNames arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_RewriteNames arg-5542 eta-0)))))
(define csegen-1781 (cons csegen-41 csegen-1744))
(define csegen-1784 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1781 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1781 arg-5542 eta-0)))))
(define csegen-1785 (cons csegen-1741 csegen-1559))
(define csegen-1788 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1785 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1785 arg-5542 eta-0)))))
(define CoreC-45TTC-u--fromBuf_TTC_Transform (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-5 arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 e-5 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_C-40TermC-32C-36varsC-41 e-5 arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_Transform (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-0 arg-0 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 e-0 arg-0 e-3) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 e-0 arg-0 e-4) ext-0))))))))))))))))))))
(define csegen-1792 (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_Transform arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_Transform arg-5542 eta-0))))))
(define csegen-1795 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1792 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1792 arg-5542 eta-0)))))
(define csegen-1796 (cons csegen-1559 csegen-1559))
(define csegen-1799 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1796 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1796 arg-5542 eta-0)))))
(define csegen-1803 (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1799 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1799 arg-5542 eta-0))))))
(define csegen-1806 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1803 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1803 arg-5542 eta-0)))))
(define PreludeC-45EqOrd-u--C-61C-61_Eq_Bool (lambda (arg-0 arg-1) (cond ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0)))(else 0))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bool (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1814 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bool arg-686 arg-689)))))
(define CoreC-45NameC-45Namespace-u--C-47C-61_Eq_Namespace (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1817 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_Namespace arg-686 arg-689)))))
(define csegen-1820 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1814 csegen-1817 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1814 csegen-1817 arg-686 arg-689)))))
(define csegen-1823 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-276 csegen-1820 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-276 csegen-1820 arg-686 arg-689)))))
(define PreludeC-45Types-either (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) ((arg-3) e-2))) (else (let ((e-5 (vector-ref arg-5 1))) ((arg-4) e-5))))))
(define CoreC-45Core-traverseList1 (lambda (arg-2 arg-3) (let ((u--x (let ((e-1 (car arg-3))) e-1))) (let ((u--xs (let ((e-2 (cdr arg-3))) e-2))) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (vector 1 csegen-181)) (arg-2 u--x) eta-1)) (CoreC-45Core-traverseC-39 arg-2 u--xs '()) eta-0))))))
(define CoreC-45Context-u--full_HasNames_CaseError (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 (vector 0 )))) ((1) (lambda (eta-0) (vector 1 (vector 1 )))) ((2) (let ((e-0 (vector-ref arg-1 1))) (lambda (clam-0) (let ((e-4 (car e-0))) (let ((e-5 (cdr e-0))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 (cons e-4 (cons e-6 e-7))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) ((3) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1304 (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-1 eta-1)) eta-0)))) (else (lambda (eta-0) (vector 1 (vector 4 )))))))
(define CoreC-45Context-u--full_HasNames_Covering (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0)) e-0 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-5))))) eff-0) ext-0))))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45Context-u--full_HasNames_PartialReason (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (vector 1 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-0 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-5))))) eff-0) ext-0))))))) ((2) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-1 eta-2))) eta-0)) e-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-1 eta-2))) eta-0)) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45Context-u--full_HasNames_Warning (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (vector 1 (vector 0 e-0 e-1))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-6 (vector-ref eta-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 1 e-2 e-3 e-6 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-4 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-5) ext-0)))))) ((2) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-6 e-5)))))) (CoreC-45Core-traverseList1 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (CoreC-45Core-traverseList1 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-2 eta-3))) eta-1)) eta-0)) e-7) ext-0)))) ((3) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 3 e-8 e-9 e-10 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-11 eta-0)) ext-0)))))) ((4) (vector 1 arg-1)) ((5) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-14 e-15 e-5)))))) (if (null? e-16) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-16))) (let ((eff-0 (CoreC-45Core-traversePair (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) ext-0))))) (else (let ((e-17 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 2))) (vector 1 (vector 6 e-17 e-18))))))))
(define CoreC-45Context-u--full_HasNames_Error (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1294 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-0 eta-0)) ext-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-7 (vector-ref eta-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 1 e-1 e-2 e-3 e-7 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-3 e-4 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-3 e-5) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-3 e-6) ext-0)))))))) ((2) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (let ((e-11 (vector-ref arg-1 5))) (let ((e-12 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 2 e-7 e-8 e-9 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-9 e-10 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-9 e-11) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-9 e-12) ext-0)))))))) ((3) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (let ((e-18 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 3 e-13 e-14 e-15 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-16 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-17 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-18) ext-0)))))))) ((4) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (let ((e-22 (vector-ref arg-1 4))) (let ((e-23 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 4 e-19 e-20 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-21 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-22 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-23) ext-0))))))) ((5) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (let ((e-27 (vector-ref arg-1 4))) (let ((e-28 (vector-ref arg-1 5))) (let ((e-29 (vector-ref arg-1 6))) (let ((e-30 (vector-ref arg-1 7))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 5 e-24 e-25 e-26 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-26 e-27 eta-3)) eta-2)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-26 e-28) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-26 e-29) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error e-26 e-30 eta-0)) ext-0))))))))) ((6) (let ((e-31 (vector-ref arg-1 1))) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (let ((e-34 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 6 e-31 e-32 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-33 eta-1)) eta-0)) (PreludeC-45Types-either (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1295 (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0) eta-1)))) (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1296 (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Error arg-0 eta-0 eta-2)) eta-1)))) e-34) ext-0)))))) ((7) (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-35 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-36 eta-0)) ext-0)))) ((8) (let ((e-37 (vector-ref arg-1 1))) (let ((e-38 (vector-ref arg-1 2))) (let ((e-39 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 8 e-37 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-38 eta-1)) eta-0)) (lambda (eta-0) (vector 1 e-39)) ext-0))))) ((9) (let ((e-40 (vector-ref arg-1 1))) (let ((e-41 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-40 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-41 eta-0)) ext-0)))) ((10) (let ((e-42 (vector-ref arg-1 1))) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 10 e-42 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-43 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-44 eta-0)) ext-0))))) ((11) (let ((e-45 (vector-ref arg-1 1))) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 11 e-45 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-46 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Covering arg-0 e-47 eta-0)) ext-0))))) ((12) (let ((e-48 (vector-ref arg-1 1))) (let ((e-49 (vector-ref arg-1 2))) (let ((e-50 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 12 e-48 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-49 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_PartialReason arg-0 e-50 eta-0)) ext-0))))) ((13) (let ((e-51 (vector-ref arg-1 1))) (let ((e-52 (vector-ref arg-1 2))) (let ((e-53 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 13 e-51 e-52 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-53 eta-0)) ext-0))))) ((14) (let ((e-54 (vector-ref arg-1 1))) (let ((e-55 (vector-ref arg-1 2))) (let ((e-56 (vector-ref arg-1 3))) (let ((e-57 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 14 e-54 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-55 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-56)) eta-0)) (lambda (eta-0) (vector 1 e-57)) ext-0)))))) ((15) (let ((e-58 (vector-ref arg-1 1))) (let ((e-59 (vector-ref arg-1 2))) (let ((e-60 (vector-ref arg-1 3))) (let ((e-61 (vector-ref arg-1 4))) (let ((e-62 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 15 e-58 e-59 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-60 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-61) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-62) ext-0))))))) ((16) (let ((e-63 (vector-ref arg-1 1))) (let ((e-64 (vector-ref arg-1 2))) (let ((e-65 (vector-ref arg-1 3))) (let ((e-66 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 16 e-63 e-64 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-65 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-66) ext-0)))))) ((17) (let ((e-67 (vector-ref arg-1 1))) (let ((e-68 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 17 e-67 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-68 '()) ext-0)))) ((18) (let ((e-69 (vector-ref arg-1 1))) (let ((e-70 (vector-ref arg-1 2))) (let ((e-71 (vector-ref arg-1 3))) (let ((e-72 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 18 e-69 e-70 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-71 eta-1)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-2 e-5)))))) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-2 e-3) clam-1))))) e-72 '()) ext-0)))))) ((19) (let ((e-73 (vector-ref arg-1 1))) (let ((e-74 (vector-ref arg-1 2))) (let ((e-75 (vector-ref arg-1 3))) (let ((e-76 (vector-ref arg-1 4))) (let ((e-77 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 19 e-73 e-74 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-75 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-76) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0)) e-77 '()) ext-0))))))) ((20) (let ((e-78 (vector-ref arg-1 1))) (let ((e-79 (vector-ref arg-1 2))) (let ((e-80 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 20 e-78 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-79 eta-1)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-80 '()) ext-0))))) ((21) (let ((e-81 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1297 (PreludeC-45Basics-flip csegen-1298 e-81 (lambda (lamc-0) (lambda (clam-2) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1299 (if (null? e-2) (lambda (eta-1) (vector 1 '())) (let ((e-4 (unbox e-2))) (let ((eff-0 (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-4 eta-1)))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))))) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-3 eta-0)) clam-2)))))) ext-0))) ((22) (let ((e-82 (vector-ref arg-1 1))) (let ((e-83 (vector-ref arg-1 2))) (let ((e-84 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 22 e-82 e-83 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-84 eta-0)) ext-0))))) ((23) (let ((e-85 (vector-ref arg-1 1))) (let ((e-86 (vector-ref arg-1 2))) (vector 1 (vector 23 e-85 e-86))))) ((24) (let ((e-87 (vector-ref arg-1 1))) (let ((e-88 (vector-ref arg-1 2))) (let ((e-89 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 24 e-87 e-88 e-5)))))) (if (null? e-89) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-89))) (let ((eff-0 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 eta-0)))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) ext-0))))) ((25) (let ((e-90 (vector-ref arg-1 1))) (let ((e-91 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 25 e-90 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-91 eta-0)) ext-0)))) ((26) (let ((e-92 (vector-ref arg-1 1))) (let ((e-93 (vector-ref arg-1 2))) (vector 1 (vector 26 e-92 e-93))))) ((27) (let ((e-94 (vector-ref arg-1 1))) (let ((e-95 (vector-ref arg-1 2))) (let ((e-96 (vector-ref arg-1 3))) (let ((e-97 (vector-ref arg-1 4))) (let ((e-98 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 27 e-94 e-95 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-96 eta-2)) eta-1)) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-1 eta-2))) e-97 '()) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-98) ext-0))))))) ((28) (let ((e-99 (vector-ref arg-1 1))) (let ((e-100 (vector-ref arg-1 2))) (let ((e-101 (vector-ref arg-1 3))) (let ((e-102 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 28 e-99 e-100 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-101 eta-1)) eta-0)) (PreludeC-45Basics-flip csegen-1298 e-102 (lambda (lamc-0) (lambda (clam-3) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1299 (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) clam-3)))))) ext-0)))))) ((29) (let ((e-103 (vector-ref arg-1 1))) (let ((e-104 (vector-ref arg-1 2))) (let ((e-105 (vector-ref arg-1 3))) (let ((e-106 (vector-ref arg-1 4))) (let ((e-107 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 29 e-103 e-104 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-105 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-106 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-107) ext-0))))))) ((30) (let ((e-108 (vector-ref arg-1 1))) (let ((e-109 (vector-ref arg-1 2))) (let ((e-110 (vector-ref arg-1 3))) (let ((e-111 (vector-ref arg-1 4))) (let ((e-112 (vector-ref arg-1 5))) (let ((e-113 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 30 e-108 e-109 e-110 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-110 e-111 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 e-110 e-112) eta-0)) (if (null? e-113) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-113))) (let ((eff-0 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error e-110 e-2 eta-0)))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) ext-0)))))))) ((31) (let ((e-114 (vector-ref arg-1 1))) (let ((e-115 (vector-ref arg-1 2))) (let ((e-116 (vector-ref arg-1 3))) (let ((e-117 (vector-ref arg-1 4))) (let ((e-118 (vector-ref arg-1 5))) (let ((e-119 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 31 e-114 e-115 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_Name arg-0 e-116 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-117)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-118 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-119) ext-0)))))))) ((32) (let ((e-120 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1300 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-1 eta-2))) eta-0)) e-120 '()) ext-0))) ((33) (let ((e-121 (vector-ref arg-1 1))) (let ((e-122 (vector-ref arg-1 2))) (let ((e-123 (vector-ref arg-1 3))) (let ((e-124 (vector-ref arg-1 4))) (let ((e-125 (vector-ref arg-1 5))) (let ((e-126 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 33 e-121 e-122 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-123 eta-3)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-124 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-125 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-126) ext-0)))))))) ((34) (let ((e-127 (vector-ref arg-1 1))) (let ((e-128 (vector-ref arg-1 2))) (let ((e-129 (vector-ref arg-1 3))) (let ((e-130 (vector-ref arg-1 4))) (let ((e-131 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 34 e-127 e-128 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-129 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-130 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-131) ext-0))))))) ((35) (let ((e-132 (vector-ref arg-1 1))) (let ((e-133 (vector-ref arg-1 2))) (let ((e-134 (vector-ref arg-1 3))) (let ((e-135 (vector-ref arg-1 4))) (let ((e-136 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 35 e-132 e-133 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-134 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-135)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-136 eta-0)) ext-0))))))) ((36) (let ((e-137 (vector-ref arg-1 1))) (let ((e-138 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 36 e-137 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-138 eta-0)) ext-0)))) ((37) (let ((e-139 (vector-ref arg-1 1))) (let ((e-140 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 37 e-139 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-140 eta-0)) ext-0)))) ((38) (let ((e-141 (vector-ref arg-1 1))) (let ((e-142 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 38 e-141 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-142 eta-0)) ext-0)))) ((39) (let ((e-143 (vector-ref arg-1 1))) (let ((e-144 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 39 e-143 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-144 eta-0)) ext-0)))) ((40) (let ((e-145 (vector-ref arg-1 1))) (let ((e-146 (vector-ref arg-1 2))) (let ((e-147 (vector-ref arg-1 3))) (let ((e-148 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 40 e-145 e-146 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-147 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-148) ext-0)))))) ((41) (let ((e-149 (vector-ref arg-1 1))) (let ((e-150 (vector-ref arg-1 2))) (let ((e-151 (vector-ref arg-1 3))) (let ((e-152 (vector-ref arg-1 4))) (let ((e-153 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 41 e-149 e-150 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-151 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-152) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-153) ext-0))))))) ((42) (let ((e-154 (vector-ref arg-1 1))) (let ((e-155 (vector-ref arg-1 2))) (let ((e-156 (vector-ref arg-1 3))) (let ((e-157 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 42 e-154 e-155 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-156 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-157) ext-0)))))) ((43) (let ((e-158 (vector-ref arg-1 1))) (let ((e-159 (vector-ref arg-1 2))) (let ((e-160 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 43 e-158 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-159 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_CaseError arg-0 e-160) ext-0))))) ((44) (let ((e-161 (vector-ref arg-1 1))) (let ((e-162 (vector-ref arg-1 2))) (let ((e-163 (vector-ref arg-1 3))) (let ((e-164 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 44 e-161 e-162 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-163 eta-1)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-164) ext-0)))))) ((45) (let ((e-165 (vector-ref arg-1 1))) (let ((e-166 (vector-ref arg-1 2))) (let ((e-167 (vector-ref arg-1 3))) (let ((e-168 (vector-ref arg-1 4))) (let ((e-169 (vector-ref arg-1 5))) (let ((e-170 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 45 e-165 e-166 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-167 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-168)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-169) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-170) ext-0)))))))) ((46) (let ((e-171 (vector-ref arg-1 1))) (let ((e-172 (vector-ref arg-1 2))) (vector 1 (vector 46 e-171 e-172))))) ((47) (let ((e-173 (vector-ref arg-1 1))) (let ((e-174 (vector-ref arg-1 2))) (let ((e-175 (vector-ref arg-1 3))) (let ((e-176 (vector-ref arg-1 4))) (let ((e-177 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 47 e-173 e-174 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-175 eta-2)) eta-1)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-176) eta-0)) (lambda (eta-0) (vector 1 e-177)) ext-0))))))) ((48) (let ((e-178 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1301 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-178 eta-0)) ext-0))) ((49) (let ((e-179 (vector-ref arg-1 1))) (let ((e-180 (vector-ref arg-1 2))) (vector 1 (vector 49 e-179 e-180))))) ((50) (let ((e-181 (vector-ref arg-1 1))) (vector 1 (vector 50 e-181)))) ((51) (let ((e-182 (vector-ref arg-1 1))) (let ((e-183 (vector-ref arg-1 2))) (vector 1 (vector 51 e-182 e-183))))) ((52) (let ((e-184 (vector-ref arg-1 1))) (vector 1 (vector 52 e-184)))) ((53) (let ((e-185 (vector-ref arg-1 1))) (vector 1 (vector 53 e-185)))) ((54) (let ((e-186 (vector-ref arg-1 1))) (vector 1 (vector 54 e-186)))) ((55) (let ((e-187 (vector-ref arg-1 1))) (vector 1 (vector 55 e-187)))) ((56) (let ((e-188 (vector-ref arg-1 1))) (let ((e-189 (vector-ref arg-1 2))) (vector 1 (vector 56 e-188 e-189))))) ((57) (let ((e-190 (vector-ref arg-1 1))) (vector 1 (vector 57 e-190)))) ((58) (let ((e-191 (vector-ref arg-1 1))) (let ((e-192 (vector-ref arg-1 2))) (vector 1 (vector 58 e-191 e-192))))) ((59) (let ((e-193 (vector-ref arg-1 1))) (vector 1 (vector 59 e-193)))) ((60) (vector 1 (vector 60 ))) ((61) (let ((e-194 (vector-ref arg-1 1))) (vector 1 (vector 61 e-194)))) ((62) (let ((e-195 (vector-ref arg-1 1))) (vector 1 (vector 62 e-195)))) ((63) (let ((e-196 (vector-ref arg-1 1))) (let ((e-197 (vector-ref arg-1 2))) (vector 1 (vector 63 e-196 e-197))))) ((64) (let ((e-198 (vector-ref arg-1 1))) (let ((e-199 (vector-ref arg-1 2))) (vector 1 (vector 64 e-198 e-199))))) ((65) (let ((e-200 (vector-ref arg-1 1))) (vector 1 (vector 65 e-200)))) ((66) (let ((e-201 (vector-ref arg-1 1))) (vector 1 (vector 66 e-201)))) ((67) (let ((e-202 (vector-ref arg-1 1))) (let ((e-203 (vector-ref arg-1 2))) (let ((e-204 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 67 e-202 e-203 e-5)))))) (CoreC-45Core-traverseList1 (lambda (arg-2) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 arg-2 eta-0))) e-204) ext-0))))) ((68) (let ((e-205 (vector-ref arg-1 1))) (let ((e-206 (vector-ref arg-1 2))) (let ((e-207 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 68 e-205 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-206 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-207 eta-0)) ext-0))))) ((69) (let ((e-208 (vector-ref arg-1 1))) (let ((e-209 (vector-ref arg-1 2))) (let ((e-210 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 69 e-208 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-209 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-210 eta-0)) ext-0))))) ((70) (let ((e-211 (vector-ref arg-1 1))) (let ((e-212 (vector-ref arg-1 2))) (let ((e-213 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 70 e-211 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-212 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-213 eta-0)) ext-0))))) ((71) (let ((e-214 (vector-ref arg-1 1))) (let ((e-215 (vector-ref arg-1 2))) (let ((e-216 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 71 e-214 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-215 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-0 e-216 eta-0)) ext-0))))) ((72) (let ((e-217 (vector-ref arg-1 1))) (let ((e-218 (vector-ref arg-1 2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1302 (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Error arg-0 e-217 eta-1)) eta-0)) (lambda (eta-0) (vector 1 e-218)) ext-0)))) (else (let ((e-219 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1303 (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Warning arg-0 e-219 eta-0)) ext-0))))))
(define CoreC-45Context-u--resolved_HasNames_CaseError (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 (vector 0 )))) ((1) (lambda (eta-0) (vector 1 (vector 1 )))) ((2) (let ((e-0 (vector-ref arg-1 1))) (lambda (clam-0) (let ((e-4 (car e-0))) (let ((e-5 (cdr e-0))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 (cons e-4 (cons e-6 e-7))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) ((3) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1304 (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-1) eta-0)))) (else (lambda (eta-0) (vector 1 (vector 4 )))))))
(define CoreC-45Context-u--resolved_HasNames_Warning (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (vector 1 (vector 0 e-0 e-1))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-6 (vector-ref eta-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 1 e-2 e-3 e-6 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-4 eta-1)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-5) ext-0)))))) ((2) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-6 e-5)))))) (CoreC-45Core-traverseList1 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (CoreC-45Core-traverseList1 (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-2)) eta-1)) eta-0)) e-7) ext-0)))) ((3) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 3 e-8 e-9 e-10 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-11) ext-0)))))) ((4) (vector 1 arg-1)) ((5) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-14 e-15 e-5)))))) (if (null? e-16) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-16))) (let ((eff-0 (CoreC-45Core-traversePair (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) ext-0))))) (else (let ((e-17 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 2))) (vector 1 (vector 6 e-17 e-18))))))))
(define CoreC-45Context-u--resolved_HasNames_Error (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1294 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-0 eta-0)) ext-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-7 (vector-ref eta-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 1 e-1 e-2 e-3 e-7 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-3 e-4 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-3 e-5) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-3 e-6) ext-0)))))))) ((2) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (let ((e-11 (vector-ref arg-1 5))) (let ((e-12 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 2 e-7 e-8 e-9 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-9 e-10 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-9 e-11) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-9 e-12) ext-0)))))))) ((3) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (let ((e-18 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 3 e-13 e-14 e-15 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-16 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-17) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-18) ext-0)))))))) ((4) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (let ((e-22 (vector-ref arg-1 4))) (let ((e-23 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 4 e-19 e-20 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-21 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-22) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-23) ext-0))))))) ((5) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (let ((e-27 (vector-ref arg-1 4))) (let ((e-28 (vector-ref arg-1 5))) (let ((e-29 (vector-ref arg-1 6))) (let ((e-30 (vector-ref arg-1 7))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 5 e-24 e-25 e-26 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-26 e-27 eta-3)) eta-2)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-26 e-28) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-26 e-29) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error e-26 e-30 eta-0)) ext-0))))))))) ((6) (let ((e-31 (vector-ref arg-1 1))) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (let ((e-34 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 6 e-31 e-32 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-33 eta-1)) eta-0)) (PreludeC-45Types-either (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1295 (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0) eta-1)))) (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1296 (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_Error arg-0 eta-0 eta-2)) eta-1)))) e-34) ext-0)))))) ((7) (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-35 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-36) ext-0)))) ((8) (let ((e-37 (vector-ref arg-1 1))) (let ((e-38 (vector-ref arg-1 2))) (let ((e-39 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 8 e-37 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-38) eta-0)) (lambda (eta-0) (vector 1 e-39)) ext-0))))) ((9) (let ((e-40 (vector-ref arg-1 1))) (let ((e-41 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-40 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-41) ext-0)))) ((10) (let ((e-42 (vector-ref arg-1 1))) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 10 e-42 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-43) eta-0)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-44) ext-0))))) ((11) (let ((e-45 (vector-ref arg-1 1))) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 11 e-45 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-46) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Covering arg-0 e-47 eta-0)) ext-0))))) ((12) (let ((e-48 (vector-ref arg-1 1))) (let ((e-49 (vector-ref arg-1 2))) (let ((e-50 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 12 e-48 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-49) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_PartialReason arg-0 e-50 eta-0)) ext-0))))) ((13) (let ((e-51 (vector-ref arg-1 1))) (let ((e-52 (vector-ref arg-1 2))) (let ((e-53 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 13 e-51 e-52 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-53) ext-0))))) ((14) (let ((e-54 (vector-ref arg-1 1))) (let ((e-55 (vector-ref arg-1 2))) (let ((e-56 (vector-ref arg-1 3))) (let ((e-57 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 14 e-54 e-5 eta-3 eta-4)))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-55) eta-1)) (lambda (eta-1) (vector 1 e-56)) eta-0)) (lambda (eta-0) (vector 1 e-57)) ext-0)))))) ((15) (let ((e-58 (vector-ref arg-1 1))) (let ((e-59 (vector-ref arg-1 2))) (let ((e-60 (vector-ref arg-1 3))) (let ((e-61 (vector-ref arg-1 4))) (let ((e-62 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 15 e-58 e-59 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-60 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-61) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-62) ext-0))))))) ((16) (let ((e-63 (vector-ref arg-1 1))) (let ((e-64 (vector-ref arg-1 2))) (let ((e-65 (vector-ref arg-1 3))) (let ((e-66 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 16 e-63 e-64 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-65 eta-1)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-66) ext-0)))))) ((17) (let ((e-67 (vector-ref arg-1 1))) (let ((e-68 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 17 e-67 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-68 '()) ext-0)))) ((18) (let ((e-69 (vector-ref arg-1 1))) (let ((e-70 (vector-ref arg-1 2))) (let ((e-71 (vector-ref arg-1 3))) (let ((e-72 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 18 e-69 e-70 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-71 eta-1)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-2 e-5)))))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-2 e-3) clam-1))))) e-72 '()) ext-0)))))) ((19) (let ((e-73 (vector-ref arg-1 1))) (let ((e-74 (vector-ref arg-1 2))) (let ((e-75 (vector-ref arg-1 3))) (let ((e-76 (vector-ref arg-1 4))) (let ((e-77 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 19 e-73 e-74 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-75 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-76) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 eta-0)) e-77 '()) ext-0))))))) ((20) (let ((e-78 (vector-ref arg-1 1))) (let ((e-79 (vector-ref arg-1 2))) (let ((e-80 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 20 e-78 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-79) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-0)) e-80 '()) ext-0))))) ((21) (let ((e-81 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1297 (PreludeC-45Basics-flip csegen-1298 e-81 (lambda (lamc-0) (lambda (clam-2) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1299 (if (null? e-2) (lambda (eta-1) (vector 1 '())) (let ((e-4 (unbox e-2))) (let ((eff-0 (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-4))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))))) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-3 eta-0)) clam-2)))))) ext-0))) ((22) (let ((e-82 (vector-ref arg-1 1))) (let ((e-83 (vector-ref arg-1 2))) (let ((e-84 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 22 e-82 e-83 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-84 eta-0)) ext-0))))) ((23) (let ((e-85 (vector-ref arg-1 1))) (let ((e-86 (vector-ref arg-1 2))) (vector 1 (vector 23 e-85 e-86))))) ((24) (let ((e-87 (vector-ref arg-1 1))) (let ((e-88 (vector-ref arg-1 2))) (let ((e-89 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 24 e-87 e-88 e-5)))))) (if (null? e-89) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-89))) (let ((eff-0 (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) ext-0))))) ((25) (let ((e-90 (vector-ref arg-1 1))) (let ((e-91 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 25 e-90 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-91) ext-0)))) ((26) (let ((e-92 (vector-ref arg-1 1))) (let ((e-93 (vector-ref arg-1 2))) (vector 1 (vector 26 e-92 e-93))))) ((27) (let ((e-94 (vector-ref arg-1 1))) (let ((e-95 (vector-ref arg-1 2))) (let ((e-96 (vector-ref arg-1 3))) (let ((e-97 (vector-ref arg-1 4))) (let ((e-98 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 27 e-94 e-95 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-96 eta-2)) eta-1)) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-1)) e-97 '()) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-98) ext-0))))))) ((28) (let ((e-99 (vector-ref arg-1 1))) (let ((e-100 (vector-ref arg-1 2))) (let ((e-101 (vector-ref arg-1 3))) (let ((e-102 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 28 e-99 e-100 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-101 eta-1)) eta-0)) (PreludeC-45Basics-flip csegen-1298 e-102 (lambda (lamc-0) (lambda (clam-3) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1299 (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) clam-3)))))) ext-0)))))) ((29) (let ((e-103 (vector-ref arg-1 1))) (let ((e-104 (vector-ref arg-1 2))) (let ((e-105 (vector-ref arg-1 3))) (let ((e-106 (vector-ref arg-1 4))) (let ((e-107 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 29 e-103 e-104 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-105 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-106) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-107) ext-0))))))) ((30) (let ((e-108 (vector-ref arg-1 1))) (let ((e-109 (vector-ref arg-1 2))) (let ((e-110 (vector-ref arg-1 3))) (let ((e-111 (vector-ref arg-1 4))) (let ((e-112 (vector-ref arg-1 5))) (let ((e-113 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 30 e-108 e-109 e-110 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 e-110 e-111 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 e-110 e-112) eta-0)) (if (null? e-113) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-113))) (let ((eff-0 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error e-110 e-2 eta-0)))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) ext-0)))))))) ((31) (let ((e-114 (vector-ref arg-1 1))) (let ((e-115 (vector-ref arg-1 2))) (let ((e-116 (vector-ref arg-1 3))) (let ((e-117 (vector-ref arg-1 4))) (let ((e-118 (vector-ref arg-1 5))) (let ((e-119 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 31 e-114 e-115 e-5 eta-4 eta-5 eta-6))))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-116) eta-2)) (lambda (eta-2) (vector 1 e-117)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-118 eta-1)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-119) ext-0)))))))) ((32) (let ((e-120 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1300 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-1)) eta-0)) e-120 '()) ext-0))) ((33) (let ((e-121 (vector-ref arg-1 1))) (let ((e-122 (vector-ref arg-1 2))) (let ((e-123 (vector-ref arg-1 3))) (let ((e-124 (vector-ref arg-1 4))) (let ((e-125 (vector-ref arg-1 5))) (let ((e-126 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 33 e-121 e-122 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-123 eta-3)) eta-2)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-124) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-125) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-126) ext-0)))))))) ((34) (let ((e-127 (vector-ref arg-1 1))) (let ((e-128 (vector-ref arg-1 2))) (let ((e-129 (vector-ref arg-1 3))) (let ((e-130 (vector-ref arg-1 4))) (let ((e-131 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 34 e-127 e-128 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-129 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-130) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-131) ext-0))))))) ((35) (let ((e-132 (vector-ref arg-1 1))) (let ((e-133 (vector-ref arg-1 2))) (let ((e-134 (vector-ref arg-1 3))) (let ((e-135 (vector-ref arg-1 4))) (let ((e-136 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 35 e-132 e-133 e-5 eta-3 eta-4)))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-134) eta-1)) (lambda (eta-1) (vector 1 e-135)) eta-0)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-136) ext-0))))))) ((36) (let ((e-137 (vector-ref arg-1 1))) (let ((e-138 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 36 e-137 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-138) ext-0)))) ((37) (let ((e-139 (vector-ref arg-1 1))) (let ((e-140 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 37 e-139 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-140) ext-0)))) ((38) (let ((e-141 (vector-ref arg-1 1))) (let ((e-142 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 38 e-141 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-142) ext-0)))) ((39) (let ((e-143 (vector-ref arg-1 1))) (let ((e-144 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 39 e-143 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-144) ext-0)))) ((40) (let ((e-145 (vector-ref arg-1 1))) (let ((e-146 (vector-ref arg-1 2))) (let ((e-147 (vector-ref arg-1 3))) (let ((e-148 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 40 e-145 e-146 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-147 eta-1)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-148) ext-0)))))) ((41) (let ((e-149 (vector-ref arg-1 1))) (let ((e-150 (vector-ref arg-1 2))) (let ((e-151 (vector-ref arg-1 3))) (let ((e-152 (vector-ref arg-1 4))) (let ((e-153 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 41 e-149 e-150 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-151 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-152) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-153) ext-0))))))) ((42) (let ((e-154 (vector-ref arg-1 1))) (let ((e-155 (vector-ref arg-1 2))) (let ((e-156 (vector-ref arg-1 3))) (let ((e-157 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 42 e-154 e-155 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-156 eta-1)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-157) ext-0)))))) ((43) (let ((e-158 (vector-ref arg-1 1))) (let ((e-159 (vector-ref arg-1 2))) (let ((e-160 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 43 e-158 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-159) eta-0)) (CoreC-45Context-u--resolved_HasNames_CaseError arg-0 e-160) ext-0))))) ((44) (let ((e-161 (vector-ref arg-1 1))) (let ((e-162 (vector-ref arg-1 2))) (let ((e-163 (vector-ref arg-1 3))) (let ((e-164 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 44 e-161 e-162 e-5 eta-2))))))) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-163 eta-1)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-164) ext-0)))))) ((45) (let ((e-165 (vector-ref arg-1 1))) (let ((e-166 (vector-ref arg-1 2))) (let ((e-167 (vector-ref arg-1 3))) (let ((e-168 (vector-ref arg-1 4))) (let ((e-169 (vector-ref arg-1 5))) (let ((e-170 (vector-ref arg-1 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 45 e-165 e-166 e-5 eta-4 eta-5 eta-6))))))))) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-167 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-168)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-169) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-170) ext-0)))))))) ((46) (let ((e-171 (vector-ref arg-1 1))) (let ((e-172 (vector-ref arg-1 2))) (vector 1 (vector 46 e-171 e-172))))) ((47) (let ((e-173 (vector-ref arg-1 1))) (let ((e-174 (vector-ref arg-1 2))) (let ((e-175 (vector-ref arg-1 3))) (let ((e-176 (vector-ref arg-1 4))) (let ((e-177 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 47 e-173 e-174 e-5 eta-3 eta-4)))))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-175 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-176) eta-0)) (lambda (eta-0) (vector 1 e-177)) ext-0))))))) ((48) (let ((e-178 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1301 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-178 eta-0)) ext-0))) ((49) (let ((e-179 (vector-ref arg-1 1))) (let ((e-180 (vector-ref arg-1 2))) (vector 1 (vector 49 e-179 e-180))))) ((50) (let ((e-181 (vector-ref arg-1 1))) (vector 1 (vector 50 e-181)))) ((51) (let ((e-182 (vector-ref arg-1 1))) (let ((e-183 (vector-ref arg-1 2))) (vector 1 (vector 51 e-182 e-183))))) ((52) (let ((e-184 (vector-ref arg-1 1))) (vector 1 (vector 52 e-184)))) ((53) (let ((e-185 (vector-ref arg-1 1))) (vector 1 (vector 53 e-185)))) ((54) (let ((e-186 (vector-ref arg-1 1))) (vector 1 (vector 54 e-186)))) ((55) (let ((e-187 (vector-ref arg-1 1))) (vector 1 (vector 55 e-187)))) ((56) (let ((e-188 (vector-ref arg-1 1))) (let ((e-189 (vector-ref arg-1 2))) (vector 1 (vector 56 e-188 e-189))))) ((57) (let ((e-190 (vector-ref arg-1 1))) (vector 1 (vector 57 e-190)))) ((58) (let ((e-191 (vector-ref arg-1 1))) (let ((e-192 (vector-ref arg-1 2))) (vector 1 (vector 58 e-191 e-192))))) ((59) (let ((e-193 (vector-ref arg-1 1))) (vector 1 (vector 59 e-193)))) ((60) (vector 1 (vector 60 ))) ((61) (let ((e-194 (vector-ref arg-1 1))) (vector 1 (vector 61 e-194)))) ((62) (let ((e-195 (vector-ref arg-1 1))) (vector 1 (vector 62 e-195)))) ((63) (let ((e-196 (vector-ref arg-1 1))) (let ((e-197 (vector-ref arg-1 2))) (vector 1 (vector 63 e-196 e-197))))) ((64) (let ((e-198 (vector-ref arg-1 1))) (let ((e-199 (vector-ref arg-1 2))) (vector 1 (vector 64 e-198 e-199))))) ((65) (let ((e-200 (vector-ref arg-1 1))) (vector 1 (vector 65 e-200)))) ((66) (let ((e-201 (vector-ref arg-1 1))) (vector 1 (vector 66 e-201)))) ((67) (let ((e-202 (vector-ref arg-1 1))) (let ((e-203 (vector-ref arg-1 2))) (let ((e-204 (vector-ref arg-1 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 67 e-202 e-203 e-5)))))) (CoreC-45Core-traverseList1 (lambda (arg-2) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 arg-2 eta-0))) e-204) ext-0))))) ((68) (let ((e-205 (vector-ref arg-1 1))) (let ((e-206 (vector-ref arg-1 2))) (let ((e-207 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 68 e-205 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-206) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-207 eta-0)) ext-0))))) ((69) (let ((e-208 (vector-ref arg-1 1))) (let ((e-209 (vector-ref arg-1 2))) (let ((e-210 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 69 e-208 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-209) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-210 eta-0)) ext-0))))) ((70) (let ((e-211 (vector-ref arg-1 1))) (let ((e-212 (vector-ref arg-1 2))) (let ((e-213 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 70 e-211 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-212) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-213 eta-0)) ext-0))))) ((71) (let ((e-214 (vector-ref arg-1 1))) (let ((e-215 (vector-ref arg-1 2))) (let ((e-216 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 71 e-214 e-5 eta-2))))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-215) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-216 eta-0)) ext-0))))) ((72) (let ((e-217 (vector-ref arg-1 1))) (let ((e-218 (vector-ref arg-1 2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1302 (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Error arg-0 e-217 eta-1)) eta-0)) (lambda (eta-0) (vector 1 e-218)) ext-0)))) (else (let ((e-219 (vector-ref arg-1 1))) (PreludeC-45IO-u--map_Functor_IO csegen-1303 (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Warning arg-0 e-219 eta-0)) ext-0))))))
(define csegen-1827 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Error arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Error arg-7729 arg-7732 eta-0))))))
(define csegen-1828 (cons csegen-264 csegen-849))
(define csegen-1832 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1828 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1828 u--d u--x))))))
(define csegen-1833 (cons csegen-65 csegen-495))
(define csegen-1838 (cons csegen-495 csegen-269))
(define csegen-1842 (lambda (eta-0) (Builtin-snd (Builtin-snd eta-0))))
(define LibrariesC-45DataC-45IntMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (PreludeC-45EqOrd-u--compare_Ord_Int arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45IntMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45IntMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45IntMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45IntMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ e-2 1) e-5))))))))))
(define LibrariesC-45DataC-45IntMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-flip (lambda (eta-3) (PreludeC-45Basics-uncurry (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (LibrariesC-45DataC-45IntMap-insert eta-4 eta-5 eta-6)))) eta-3)) eta-1 eta-2))) eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (cons (cons e-1 e-2) arg-3)))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 (LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 arg-3 e-7) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 (LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 (LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 arg-3 e-14) e-12) e-10))))))))
(define LibrariesC-45DataC-45IntMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45IntMap-n--5358-3210-u--treeToListC-39 '() ext-0)))
(define LibrariesC-45DataC-45IntMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45IntMap-treeToList e-3)))))
(define LibrariesC-45DataC-45IntMap-n--5911-3767-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-listBind (LibrariesC-45DataC-45IntMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45IntMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45IntMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45IntMap-insertFrom (LibrariesC-45DataC-45IntMap-n--5911-3767-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45IntMap-merge (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45IntMap-mergeWith (lambda (eta-0) (lambda (eta-1) ((arg-1 eta-0) eta-1))) ext-0 ext-1)))
(define LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45IntMap-merge arg-1 ext-0 ext-1)))
(define LibrariesC-45DataC-45IntMap-empty '())
(define LibrariesC-45DataC-45IntMap-u--neutral_Monoid_C-40IntMapC-32C-36vC-41 (lambda (arg-1) LibrariesC-45DataC-45IntMap-empty))
(define csegen-1845 (cons (lambda (arg-8474) (lambda (arg-8477) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) arg-8474 arg-8477))) (LibrariesC-45DataC-45IntMap-u--neutral_Monoid_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))))))
(define csegen-1846 (cons csegen-495 csegen-65))
(define PreludeC-45Show-u--showPrec_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (PreludeC-45Show-showCon arg-3 "Left" (PreludeC-45Show-showArg (Builtin-fst arg-2) e-2)))) (else (let ((e-5 (vector-ref arg-4 1))) (PreludeC-45Show-showCon arg-3 "Right" (PreludeC-45Show-showArg (Builtin-snd arg-2) e-5)))))))
(define PreludeC-45Show-u--show_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (lambda (arg-2 arg-3) (PreludeC-45Show-u--showPrec_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 arg-2 (vector 0 ) arg-3)))
(define CompilerC-45VMCode-u--show_Show_Reg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "RVAL") ((1) (let ((e-0 (vector-ref arg-0 1))) (string-append "v" (PreludeC-45Show-u--show_Show_Int e-0)))) (else "DISCARD"))))
(define csegen-1854 (lambda () (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1851) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-1851) u--d u--x))))))
(define csegen-1855 (lambda () (cons (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 csegen-1846 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 csegen-1846 u--d u--x)))) (csegen-1854))))
(define CoreC-45TTC-45Primitive-u--showPrec_Show_Constant (lambda (arg-0 arg-1) (CoreC-45TTC-45Primitive-u--show_Show_Constant arg-1)))
(define csegen-1860 (cons (lambda (u--x) (CoreC-45TTC-45Primitive-u--show_Show_Constant u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Primitive-u--showPrec_Show_Constant u--d u--x)))))
(define csegen-1861 (lambda () (cons csegen-1860 (csegen-1854))))
(define CompilerC-45VMCode-u--show_Show_VMInst (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (string-append "DECLARE " (CompilerC-45VMCode-u--show_Show_Reg e-0)))) ((1) "START") ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-1) (string-append " := " (CompilerC-45VMCode-u--show_Show_Reg e-2)))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-3) (string-append " := MKCON " (string-append (PreludeC-45Show-u--show_Show_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 csegen-1846 e-4) (string-append " (" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-5)) ")"))))))))) ((4) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (let ((e-9 (vector-ref arg-0 4))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-6) (string-append " := MKCLOSURE " (string-append (CoreC-45Name-u--show_Show_Name e-7) (string-append " " (string-append (PreludeC-45Show-u--show_Show_Nat e-8) (string-append " (" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-9)) ")")))))))))))) ((5) (let ((e-10 (vector-ref arg-0 1))) (let ((e-11 (vector-ref arg-0 2))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-10) (string-append " := MKCONSTANT " (CoreC-45TTC-45Primitive-u--show_Show_Constant e-11)))))) ((6) (let ((e-12 (vector-ref arg-0 1))) (let ((e-13 (vector-ref arg-0 2))) (let ((e-14 (vector-ref arg-0 3))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-12) (string-append " := " (string-append (CompilerC-45VMCode-u--show_Show_Reg e-13) (string-append " @ " (CompilerC-45VMCode-u--show_Show_Reg e-14))))))))) ((7) (let ((e-15 (vector-ref arg-0 1))) (let ((e-16 (vector-ref arg-0 2))) (let ((e-17 (vector-ref arg-0 3))) (let ((e-18 (vector-ref arg-0 4))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-15) (string-append " := " (string-append (cond ((equal? e-16 1) "TAILCALL ") (else "CALL ")) (string-append (CoreC-45Name-u--show_Show_Name e-17) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-18)) ")"))))))))))) ((8) (let ((e-20 (vector-ref arg-0 1))) (let ((e-21 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 3))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-20) (string-append " := " (string-append "OP " (string-append (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-21) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-22))) ")")))))))))) ((9) (let ((e-23 (vector-ref arg-0 1))) (let ((e-24 (vector-ref arg-0 2))) (let ((e-25 (vector-ref arg-0 3))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-23) (string-append " := " (string-append "EXTPRIM " (string-append (CoreC-45Name-u--show_Show_Name e-24) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-u--show_Show_Reg eta-0)) e-25)) ")")))))))))) ((10) (let ((e-26 (vector-ref arg-0 1))) (let ((e-27 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 3))) (string-append "CASE " (string-append (CompilerC-45VMCode-u--show_Show_Reg e-26) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1855) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1855) u--d u--x)))) e-27) (string-append " {default: " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1854) e-28) "}")))))))))) ((11) (let ((e-29 (vector-ref arg-0 1))) (let ((e-30 (vector-ref arg-0 2))) (let ((e-31 (vector-ref arg-0 3))) (string-append "CASE " (string-append (CompilerC-45VMCode-u--show_Show_Reg e-29) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1861) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-1861) u--d u--x)))) e-30) (string-append " {default: " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1854) e-31) "}")))))))))) ((12) (let ((e-32 (vector-ref arg-0 1))) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-32) (string-append " := PROJECT(" (string-append (CompilerC-45VMCode-u--show_Show_Reg e-33) (string-append ", " (string-append (PreludeC-45Show-u--show_Show_Int e-34) ")"))))))))) ((13) (let ((e-35 (vector-ref arg-0 1))) (string-append (CompilerC-45VMCode-u--show_Show_Reg e-35) " := NULL"))) (else (let ((e-36 (vector-ref arg-0 1))) (string-append "ERROR " (PreludeC-45Show-u--show_Show_String e-36)))))))
(define CompilerC-45VMCode-u--showPrec_Show_VMInst (lambda (arg-0 arg-1) (CompilerC-45VMCode-u--show_Show_VMInst arg-1)))
(define csegen-1851 (lambda () (cons (lambda (u--x) (CompilerC-45VMCode-u--show_Show_VMInst u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45VMCode-u--showPrec_Show_VMInst u--d u--x))))))
(define CompilerC-45VMCode-n--9645-3815-u--findConstVarAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CompilerC-45VMCode-findVars eta-0)) e-3))))
(define CompilerC-45VMCode-n--9645-3769-u--findVarAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CompilerC-45VMCode-findVars eta-0)) e-3))))
(define CompilerC-45VMCode-findVars (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((1) (let ((e-34 (vector-ref e-0 1))) (cons e-34 '())))(else '())))) ((3) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref e-2 0) ((1) (let ((e-35 (vector-ref e-2 1))) (cons e-35 '())))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref e-5 0) ((1) (let ((e-36 (vector-ref e-5 1))) (cons e-36 '())))(else '())))) ((5) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref e-9 0) ((1) (let ((e-37 (vector-ref e-9 1))) (cons e-37 '())))(else '())))) ((6) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref e-11 0) ((1) (let ((e-38 (vector-ref e-11 1))) (cons e-38 '())))(else '())))) ((7) (let ((e-14 (vector-ref arg-0 1))) (case (vector-ref e-14 0) ((1) (let ((e-39 (vector-ref e-14 1))) (cons e-39 '())))(else '())))) ((8) (let ((e-19 (vector-ref arg-0 1))) (case (vector-ref e-19 0) ((1) (let ((e-40 (vector-ref e-19 1))) (cons e-40 '())))(else '())))) ((9) (let ((e-22 (vector-ref arg-0 1))) (case (vector-ref e-22 0) ((1) (let ((e-41 (vector-ref e-22 1))) (cons e-41 '())))(else '())))) ((10) (let ((e-25 (vector-ref arg-0 1))) (let ((e-26 (vector-ref arg-0 2))) (let ((e-27 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CompilerC-45VMCode-n--9645-3769-u--findVarAlt e-25 e-27 e-26 eta-0)) e-26) (DataC-45Maybe-fromMaybe (lambda () '()) (PreludeC-45Types-u--map_Functor_Maybe (csegen-1865) e-27))))))) ((11) (let ((e-28 (vector-ref arg-0 1))) (let ((e-29 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CompilerC-45VMCode-n--9645-3815-u--findConstVarAlt e-28 e-30 e-29 eta-0)) e-29) (DataC-45Maybe-fromMaybe (lambda () '()) (PreludeC-45Types-u--map_Functor_Maybe (csegen-1865) e-30))))))) ((12) (let ((e-31 (vector-ref arg-0 1))) (case (vector-ref e-31 0) ((1) (let ((e-42 (vector-ref e-31 1))) (cons e-42 '())))(else '()))))(else '()))))
(define csegen-1865 (lambda () (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (CompilerC-45VMCode-findVars eta-1)) eta-0))))
(define LibrariesC-45DataC-45IntMap-singleton (lambda (arg-1 arg-2) (LibrariesC-45DataC-45IntMap-insert arg-1 arg-2 LibrariesC-45DataC-45IntMap-empty)))
(define CompilerC-45VMCode-collectReg (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45DataC-45IntMap-singleton e-0 (vector 0 ))))(else LibrariesC-45DataC-45IntMap-empty))))
(define DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 arg-3 ((arg-3 arg-4) e-3) e-4))))))
(define DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4 ext-0) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (u--acc) (lambda (u--elem) (let ((e-1 (car arg-3))) ((e-1 u--acc) (arg-4 u--elem))))) (let ((e-2 (cdr arg-3))) e-2) ext-0)))
(define csegen-1867 (lambda () (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-1) (CompilerC-45VMCode-collectUsed eta-1)) eta-0))))
(define CompilerC-45VMCode-collectUsed (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45VMCode-collectReg e-0))) ((1) LibrariesC-45DataC-45IntMap-empty) ((2) (let ((e-2 (vector-ref arg-0 2))) (CompilerC-45VMCode-collectReg e-2))) ((3) (let ((e-5 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-5))) ((4) (let ((e-9 (vector-ref arg-0 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-9))) ((5) LibrariesC-45DataC-45IntMap-empty) ((6) (let ((e-13 (vector-ref arg-0 2))) (let ((e-14 (vector-ref arg-0 3))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) (CompilerC-45VMCode-collectReg e-13) (CompilerC-45VMCode-collectReg e-14))))) ((7) (let ((e-18 (vector-ref arg-0 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-18))) ((8) (let ((e-22 (vector-ref arg-0 3))) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-22))) ((9) (let ((e-25 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectReg eta-0)) e-25))) ((10) (let ((e-26 (vector-ref arg-0 1))) (let ((e-27 (vector-ref arg-0 2))) (let ((e-28 (vector-ref arg-0 3))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) (CompilerC-45VMCode-collectReg e-26) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (csegen-1866) e-27)) (PreludeC-45Types-maybe (lambda () LibrariesC-45DataC-45IntMap-empty) (lambda () (csegen-1867)) e-28)))))) ((11) (let ((e-29 (vector-ref arg-0 1))) (let ((e-30 (vector-ref arg-0 2))) (let ((e-31 (vector-ref arg-0 3))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) (LibrariesC-45DataC-45IntMap-u--C-60C-43C-62_Semigroup_C-40IntMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) (CompilerC-45VMCode-collectReg e-29) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (csegen-1866) e-30)) (PreludeC-45Types-maybe (lambda () LibrariesC-45DataC-45IntMap-empty) (lambda () (csegen-1867)) e-31)))))) ((12) (let ((e-33 (vector-ref arg-0 2))) (CompilerC-45VMCode-collectReg e-33))) ((13) LibrariesC-45DataC-45IntMap-empty) (else LibrariesC-45DataC-45IntMap-empty))))
(define csegen-1866 (lambda () (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-1) (CompilerC-45VMCode-collectUsed eta-1)) (Builtin-snd eta-0)))))
(define csegen-1871 (lambda (eta-0) (string-append " " (CoreC-45TTC-45Term-u--show_Show_LazyReason eta-0))))
(define CompilerC-45ANF-showLazy (lambda (ext-0) (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-1871) ext-0)))
(define DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (cons (arg-3 e-3) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 arg-3 e-4)))))))
(define CompilerC-45ANF-n--9025-3102-u--showArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (string-append "v" (PreludeC-45Show-u--show_Show_Int arg-5))))
(define CompilerC-45ANF-u--show_Show_AConAlt (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (string-append "%conalt " (string-append (CoreC-45Name-u--show_Show_Name e-0) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-n--9025-3102-u--showArg e-1 e-4 e-3 e-2 e-0 eta-0)) e-3)) (string-append ") => " (CompilerC-45ANF-u--show_Show_ANF e-4)))))))))))))
(define CompilerC-45ANF-u--show_Show_AConstAlt (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (string-append "%constalt(" (string-append (CoreC-45TTC-45Primitive-u--show_Show_Constant e-0) (string-append ") => " (CompilerC-45ANF-u--show_Show_ANF e-1))))))))
(define CompilerC-45ANF-u--show_Show_AVar (lambda (arg-0) (if (null? arg-0) "[__]" (let ((e-0 (unbox arg-0))) (string-append "v" (PreludeC-45Show-u--show_Show_Int e-0))))))
(define CompilerC-45ANF-u--show_Show_ANF (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45ANF-u--show_Show_AVar e-1))) ((1) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 4))) (string-append (CoreC-45Name-u--show_Show_Name e-4) (string-append (CompilerC-45ANF-showLazy e-3) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-5)) ")")))))))) ((2) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (let ((e-9 (vector-ref arg-0 4))) (string-append "<" (string-append (CoreC-45Name-u--show_Show_Name e-7) (string-append " underapp " (string-append (PreludeC-45Show-u--show_Show_Nat e-8) (string-append ">(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-9)) ")")))))))))) ((3) (let ((e-11 (vector-ref arg-0 2))) (let ((e-12 (vector-ref arg-0 3))) (let ((e-13 (vector-ref arg-0 4))) (string-append (CompilerC-45ANF-u--show_Show_AVar e-12) (string-append (CompilerC-45ANF-showLazy e-11) (string-append " @ (" (string-append (CompilerC-45ANF-u--show_Show_AVar e-13) ")")))))))) ((4) (let ((e-15 (vector-ref arg-0 2))) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (string-append "%let v" (string-append (PreludeC-45Show-u--show_Show_Int e-15) (string-append " = (" (string-append (CompilerC-45ANF-u--show_Show_ANF e-16) (string-append ") in (" (string-append (CompilerC-45ANF-u--show_Show_ANF e-17) ")")))))))))) ((5) (let ((e-19 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 5))) (string-append "%con " (string-append (CoreC-45Name-u--show_Show_Name e-19) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-22)) ")"))))))) ((6) (let ((e-25 (vector-ref arg-0 2))) (let ((e-26 (vector-ref arg-0 3))) (let ((e-27 (vector-ref arg-0 4))) (string-append "%op " (string-append (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-26) (string-append (CompilerC-45ANF-showLazy e-25) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-27))) ")"))))))))) ((7) (let ((e-29 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 3))) (let ((e-31 (vector-ref arg-0 4))) (string-append "%extprim " (string-append (CoreC-45Name-u--show_Show_Name e-30) (string-append (CompilerC-45ANF-showLazy e-29) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AVar eta-0)) e-31)) ")"))))))))) ((8) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (let ((e-35 (vector-ref arg-0 4))) (string-append "%case " (string-append (CompilerC-45ANF-u--show_Show_AVar e-33) (string-append " of { " (string-append (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AConAlt eta-0)) e-34)) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1870) e-35) " }")))))))))) ((9) (let ((e-37 (vector-ref arg-0 2))) (let ((e-38 (vector-ref arg-0 3))) (let ((e-39 (vector-ref arg-0 4))) (string-append "%case " (string-append (CompilerC-45ANF-u--show_Show_AVar e-37) (string-append " of { " (string-append (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ANF-u--show_Show_AConstAlt eta-0)) e-38)) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (csegen-1870) e-39) " }")))))))))) ((10) (let ((e-41 (vector-ref arg-0 2))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-41))) ((11) "___") (else (let ((e-44 (vector-ref arg-0 2))) (string-append "%CRASH(" (string-append (PreludeC-45Show-u--show_Show_String e-44) ")")))))))
(define CompilerC-45ANF-u--showPrec_Show_ANF (lambda (arg-0 arg-1) (CompilerC-45ANF-u--show_Show_ANF arg-1)))
(define csegen-1870 (lambda () (cons (lambda (u--x) (CompilerC-45ANF-u--show_Show_ANF u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45ANF-u--showPrec_Show_ANF u--d u--x))))))
(define CoreC-45Name-with--userNameEq-11468 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (box (vector 0 ))) (else '()))))
(define CoreC-45Name-with--userNameEq-11493 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (box (vector 0 ))) (else '()))))
(define CoreC-45Name-userNameEq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45Name-with--userNameEq-11468 e-0 e-2 (DecidableC-45Equality-u--decEq_DecEq_String e-0 e-2))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-3 (vector-ref arg-1 1))) (CoreC-45Name-with--userNameEq-11493 e-1 e-3 (DecidableC-45Equality-u--decEq_DecEq_String e-1 e-3))))(else '())))) ((2) (case (vector-ref arg-1 0) ((2) (box (vector 0 )))(else '())))(else '()))))
(define PreludeC-45Basics-irrelevantEq (vector 0 ))
(define ControlC-45Function-biinj (cons PreludeC-45Basics-irrelevantEq PreludeC-45Basics-irrelevantEq))
(define DecidableC-45EqualityC-45Core-decEqCong (lambda (arg-6) (case (vector-ref arg-6 0) ((0) (vector 0 (vector 0 ))) (else (let ((e-3 (vector-ref arg-6 1))) (vector 1 (lambda (u--c) (e-3 PreludeC-45Basics-irrelevantEq))))))))
(define DecidableC-45EqualityC-45Core-decEqCong2 (lambda (arg-9 arg-10) (case (vector-ref arg-9 0) ((0) (DecidableC-45EqualityC-45Core-decEqCong (arg-10))) (else (let ((e-3 (vector-ref arg-9 1))) (vector 1 (lambda (u--c) (let ((sc1 ControlC-45Function-biinj)) (e-3 (vector 0 ))))))))))
(define DecidableC-45Equality-u--decEq_DecEq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (DecidableC-45EqualityC-45Core-decEqCong2 (((Builtin-fst arg-2) e-2) e-6) (lambda () (((Builtin-snd arg-2) e-3) e-7)))))))))
(define PreludeC-45Uninhabited-void (lambda (ext-0) (display "Error: Executed 'void'")))
(define PreludeC-45Uninhabited-absurd (lambda (arg-2 arg-3) (PreludeC-45Uninhabited-void 'erased)))
(define DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40BuiltinC-46C-40C-61C-61C-61C-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-44C-40C-40BuiltinC-46C-40C-126C-61C-126C-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-124C-41 (lambda (arg-0) (blodwen-error-quit "No clauses")))
(define DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40BuiltinC-46C-40C-61C-61C-61C-41C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-44C-40C-40BuiltinC-46C-40C-126C-61C-126C-41C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-124C-41 (lambda (arg-0) (blodwen-error-quit "No clauses")))
(define DecidableC-45Equality-u--decEq_DecEq_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) (vector 0 (vector 0 )) (vector 1 (lambda (eta-0) (PreludeC-45Uninhabited-absurd (lambda (eta-1) (DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40BuiltinC-46C-40C-61C-61C-61C-41C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-44C-40C-40BuiltinC-46C-40C-126C-61C-126C-41C-32NilC-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-124C-41 eta-1)) eta-0)))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? arg-3) (vector 1 (lambda (eta-0) (PreludeC-45Uninhabited-absurd (lambda (eta-1) (DataC-45List-u--uninhabited_Uninhabited_C-40C-124C-40C-40BuiltinC-46C-40C-61C-61C-61C-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-44C-40C-40BuiltinC-46C-40C-126C-61C-126C-41C-32C-40C-40C-58C-58C-32C-36xC-41C-32C-36xsC-41C-41C-32NilC-41C-124C-41 eta-1)) eta-0))) (let ((e-10 (car arg-3))) (let ((e-11 (cdr arg-3))) (DecidableC-45EqualityC-45Core-decEqCong2 ((arg-1 e-2) e-10) (lambda () (DecidableC-45Equality-u--decEq_DecEq_C-40ListC-32C-36aC-41 arg-1 e-3 e-11)))))))))))
(define CoreC-45NameC-45Namespace-mkNSInjective (lambda (arg-2) (vector 0 )))
(define CoreC-45NameC-45Namespace-with--decEq-8933 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (vector 1 (lambda (eta-0) (e-1 (CoreC-45NameC-45Namespace-mkNSInjective eta-0)))))) (else (vector 0 (vector 0 ))))))
(define CoreC-45NameC-45Namespace-u--decEq_DecEq_Namespace (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-with--decEq-8933 arg-0 arg-1 (DecidableC-45Equality-u--decEq_DecEq_C-40ListC-32C-36aC-41 csegen-511 arg-0 arg-1))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11551 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (box (vector 0 )))))
(define CoreC-45Name-with--nameEq-11540 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11551 arg-4 arg-3 (CoreC-45Name-nameEq arg-3 arg-4) arg-0)) (else '()))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11605 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (box (vector 0 ))) (else '()))))
(define CoreC-45Name-with--nameEq-11590 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11605 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0)) (else '()))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11641 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (box (vector 0 ))) (else '()))))
(define CoreC-45Name-with--nameEq-11630 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) '() (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11641 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11680 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (box (vector 0 )))))
(define CoreC-45Name-with--nameEq-11669 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11680 arg-4 arg-3 (CoreC-45Name-nameEq arg-3 arg-4) arg-0)) (else '()))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11733 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (box (vector 0 )))))
(define CoreC-45Name-with--nameEq-11711 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) '()) (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11733 arg-4 arg-3 (CoreC-45Name-nameEq arg-3 arg-4) arg-0)))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11772 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) '()) (else (box (vector 0 ))))))
(define CoreC-45Name-with--nameEq-11753 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) '()) (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11772 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0)))))
(define CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11816 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) '()) (else (box (vector 0 ))))))
(define CoreC-45Name-with--nameEq-11797 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((1) '()) (else (CoreC-45Name-with--withC-32blockC-32inC-32nameEq-11816 arg-4 arg-3 (DecidableC-45Equality-u--decEq_DecEq_Int arg-3 arg-4) arg-0)))))
(define CoreC-45Name-with--nameEq-11841 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (box (vector 0 ))) (else '()))))
(define CoreC-45Name-nameEq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11540 e-0 e-16 (CoreC-45NameC-45Namespace-u--decEq_DecEq_Namespace e-0 e-16) e-1 e-17))))(else '()))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--xy) (vector 0 )) (CoreC-45Name-userNameEq e-2 e-18))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11590 e-3 e-19 (DecidableC-45Equality-u--decEq_DecEq_String e-3 e-19) e-4 e-20))))(else '()))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((3) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11630 e-5 e-21 (CoreC-45Name-nameEq e-5 e-21) e-6 e-22))))(else '()))))) ((4) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((4) (let ((e-23 (vector-ref arg-1 1))) (let ((e-24 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11669 e-7 e-23 (DecidableC-45Equality-u--decEq_DecEq_String e-7 e-23) e-8 e-24))))(else '()))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((5) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11711 e-9 e-25 (DecidableC-45Equality-u--decEq_DecEq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-507 csegen-507) e-9 e-25) e-10 e-26))))(else '()))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11753 e-11 e-27 (DecidableC-45Equality-u--decEq_DecEq_String e-11 e-27) e-12 e-28))))(else '()))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (CoreC-45Name-with--nameEq-11797 e-13 e-29 (DecidableC-45Equality-u--decEq_DecEq_String e-13 e-29) e-14 e-30))))(else '()))))) ((8) (let ((e-15 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-31 (vector-ref arg-1 1))) (CoreC-45Name-with--nameEq-11841 e-15 e-31 (DecidableC-45Equality-u--decEq_DecEq_Int e-15 e-31))))(else '()))))(else '()))))
(define CoreC-45TTC-45Primitive-primFnEq (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-0 e-18))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-1 e-19))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((2) (let ((e-2 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((2) (let ((e-20 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-2 e-20))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((3) (let ((e-3 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((3) (let ((e-21 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-3 e-21))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((4) (let ((e-4 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((4) (let ((e-22 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-4 e-22))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((5) (let ((e-5 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-5 e-23))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((6) (let ((e-6 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((6) (let ((e-24 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-6 e-24))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((7) (let ((e-7 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((7) (let ((e-25 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-7 e-25))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((8) (let ((e-8 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((8) (let ((e-26 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-8 e-26))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((9) (let ((e-9 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((9) (let ((e-27 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-9 e-27))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((10) (let ((e-10 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((10) (let ((e-28 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-10 e-28))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((11) (let ((e-11 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((11) (let ((e-29 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-11 e-29))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((12) (let ((e-12 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((12) (let ((e-30 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-12 e-30))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((13) (let ((e-13 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((13) (let ((e-31 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-13 e-31))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((14) (let ((e-14 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((14) (let ((e-32 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-14 e-32))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((15) (let ((e-15 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((15) (let ((e-33 (vector-ref arg-3 1))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-15 e-33))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '())))))(else '())))) ((16) (case (vector-ref arg-3 0) ((16) (box (vector 0 )))(else '()))) ((17) (case (vector-ref arg-3 0) ((17) (box (vector 0 )))(else '()))) ((18) (case (vector-ref arg-3 0) ((18) (box (vector 0 )))(else '()))) ((19) (case (vector-ref arg-3 0) ((19) (box (vector 0 )))(else '()))) ((20) (case (vector-ref arg-3 0) ((20) (box (vector 0 )))(else '()))) ((21) (case (vector-ref arg-3 0) ((21) (box (vector 0 )))(else '()))) ((22) (case (vector-ref arg-3 0) ((22) (box (vector 0 )))(else '()))) ((23) (case (vector-ref arg-3 0) ((23) (box (vector 0 )))(else '()))) ((24) (case (vector-ref arg-3 0) ((24) (box (vector 0 )))(else '()))) ((25) (case (vector-ref arg-3 0) ((25) (box (vector 0 )))(else '()))) ((26) (case (vector-ref arg-3 0) ((26) (box (vector 0 )))(else '()))) ((27) (case (vector-ref arg-3 0) ((27) (box (vector 0 )))(else '()))) ((28) (case (vector-ref arg-3 0) ((28) (box (vector 0 )))(else '()))) ((29) (case (vector-ref arg-3 0) ((29) (box (vector 0 )))(else '()))) ((30) (case (vector-ref arg-3 0) ((30) (box (vector 0 )))(else '()))) ((31) (case (vector-ref arg-3 0) ((31) (box (vector 0 )))(else '()))) ((32) (case (vector-ref arg-3 0) ((32) (box (vector 0 )))(else '()))) ((33) (case (vector-ref arg-3 0) ((33) (box (vector 0 )))(else '()))) ((34) (case (vector-ref arg-3 0) ((34) (box (vector 0 )))(else '()))) ((35) (case (vector-ref arg-3 0) ((35) (box (vector 0 )))(else '()))) ((36) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((36) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((sc2 (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-16 e-34))) (cond ((equal? sc3 1) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-17 e-35)) (else 0))))) (cond ((equal? sc2 1) (box (vector 0 ))) (else '()))))))(else '()))))) ((37) (case (vector-ref arg-3 0) ((37) (box (vector 0 )))(else '()))) ((38) (case (vector-ref arg-3 0) ((38) (box (vector 0 )))(else '())))(else '()))))
(define DataC-45Vect-u--C-61C-61_Eq_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) 1 (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (let ((sc2 (let ((e-1 (car arg-2))) ((e-1 e-3) e-8)))) (cond ((equal? sc2 1) (DataC-45Vect-u--C-61C-61_Eq_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 arg-2 e-4 e-9)) (else 0))))))))))
(define CoreC-45TTC-45Term-u--C-61C-61_Eq_LazyReason (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define CoreC-45Name-namesEq (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (box (vector 0 )) '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? arg-1) '() (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-nameEq e-2 e-6) (lambda (u--p) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-namesEq e-3 e-7) (lambda (u--ps) (box (vector 0 ))))))))))))))
(define CoreC-45Ord-u--C-61C-61_Eq_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-2 0))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-11 (vector-ref arg-2 4))) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-223 e-3 e-9))) (cond ((equal? sc0 1) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-7))) (cond ((equal? sc1 1) ((let ((sc2 (CoreC-45Name-namesEq e-4 e-10))) (if (null? sc2) (lambda () 0) (lambda () (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-5 e-11)))))) (else 0)))) (else 0)))))))))))))
(define CoreC-45Ord-u--C-47C-61_Eq_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CConAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1919 (lambda () (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45Ord-u--C-61C-61_Eq_C-40CConAltC-32C-36varsC-41 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45Ord-u--C-47C-61_Eq_C-40CConAltC-32C-36varsC-41 arg-686 arg-689))))))
(define CoreC-45Ord-u--C-61C-61_Eq_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-1 e-4))) (cond ((equal? sc2 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-2 e-5)) (else 0)))))))))
(define CoreC-45Ord-u--C-47C-61_Eq_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1930 (lambda () (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45Ord-u--C-61C-61_Eq_C-40CConstAltC-32C-36varsC-41 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45Ord-u--C-47C-61_Eq_C-40CConstAltC-32C-36varsC-41 arg-686 arg-689))))))
(define CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((0) (let ((e-65 (vector-ref arg-2 1))) (or (and (= e-2 e-65) 1) 0)))(else 0)))) ((1) (let ((e-7 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((1) (let ((e-70 (vector-ref arg-2 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-70)))(else 0)))) ((2) (let ((e-10 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((2) (let ((e-73 (vector-ref arg-2 2))) (let ((e-74 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Name-nameEq e-10 e-73))) (if (null? sc2) 0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-11 e-74))))))(else 0))))) ((3) (let ((e-14 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((3) (let ((e-77 (vector-ref arg-2 2))) (let ((e-79 (vector-ref arg-2 4))) (let ((e-80 (vector-ref arg-2 5))) (let ((sc2 (CoreC-45Name-nameEq e-14 e-77))) (if (null? sc2) 0 (let ((sc3 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-16 e-79))) (cond ((equal? sc3 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-17 e-80)) (else 0)))))))))(else 0)))))) ((4) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-83 (vector-ref arg-2 2))) (let ((e-84 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-20 e-83))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-1875) e-21 e-84)) (else 0))))))(else 0))))) ((5) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (let ((e-27 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((5) (let ((e-87 (vector-ref arg-2 2))) (let ((e-89 (vector-ref arg-2 4))) (let ((e-90 (vector-ref arg-2 5))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-223 e-26 e-89))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-24 e-87))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-1875) e-27 e-90)) (else 0)))) (else 0)))))))(else 0)))))) ((6) (let ((e-31 (vector-ref arg-1 3))) (let ((e-32 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((6) (let ((e-94 (vector-ref arg-2 3))) (let ((e-95 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45TTC-45Primitive-primFnEq e-31 e-94))) (if (null? sc2) 0 (DataC-45Vect-u--C-61C-61_Eq_C-40C-40VectC-32C-36nC-41C-32C-36aC-41 (csegen-1875) e-32 e-95))))))(else 0))))) ((7) (let ((e-35 (vector-ref arg-1 2))) (let ((e-36 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((7) (let ((e-98 (vector-ref arg-2 2))) (let ((e-99 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-35 e-98))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-1875) e-36 e-99)) (else 0))))))(else 0))))) ((8) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-102 (vector-ref arg-2 2))) (let ((e-103 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45TTC-45Term-u--C-61C-61_Eq_LazyReason e-39 e-102))) (cond ((equal? sc2 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-40 e-103)) (else 0))))))(else 0))))) ((9) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((9) (let ((e-106 (vector-ref arg-2 2))) (let ((e-107 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45TTC-45Term-u--C-61C-61_Eq_LazyReason e-43 e-106))) (cond ((equal? sc2 1) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-44 e-107)) (else 0))))))(else 0))))) ((10) (let ((e-47 (vector-ref arg-1 2))) (let ((e-48 (vector-ref arg-1 3))) (let ((e-49 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((10) (let ((e-110 (vector-ref arg-2 2))) (let ((e-111 (vector-ref arg-2 3))) (let ((e-112 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-47 e-110))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-1919) e-48 e-111))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-1875) e-49 e-112)) (else 0)))) (else 0)))))))(else 0)))))) ((11) (let ((e-52 (vector-ref arg-1 2))) (let ((e-53 (vector-ref arg-1 3))) (let ((e-54 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((11) (let ((e-115 (vector-ref arg-2 2))) (let ((e-116 (vector-ref arg-2 3))) (let ((e-117 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 e-52 e-115))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (csegen-1930) e-53 e-116))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 (csegen-1875) e-54 e-117)) (else 0)))) (else 0)))))))(else 0)))))) ((12) (let ((e-57 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((12) (let ((e-120 (vector-ref arg-2 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-57 e-120)))(else 0)))) ((13) (case (vector-ref arg-2 0) ((13) 1)(else 0))) ((14) (let ((e-62 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((14) (let ((e-125 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-62 e-125)))(else 0))))(else 0))))
(define CoreC-45Ord-u--C-47C-61_Eq_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-1875 (lambda () (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45Ord-u--C-61C-61_Eq_C-40CExpC-32C-36varsC-41 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45Ord-u--C-47C-61_Eq_C-40CExpC-32C-36varsC-41 arg-686 arg-689))))))
(define LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) (arg-1)) (else 2))))
(define PreludeC-45Basics-on (lambda (arg-3 arg-4 ext-0 ext-1) ((arg-3 (arg-4 ext-0)) (arg-4 ext-1))))
(define CoreC-45TTC-45Primitive-n--7113-6401-u--tag (lambda (arg-0) (cond ((equal? arg-0 0) 1) ((equal? arg-0 1) 2) ((equal? arg-0 2) 3) ((equal? arg-0 3) 4) ((equal? arg-0 4) 5) ((equal? arg-0 5) 6) ((equal? arg-0 6) 7) ((equal? arg-0 7) 8) ((equal? arg-0 8) 9) ((equal? arg-0 9) 10) ((equal? arg-0 10) 11) ((equal? arg-0 11) 12) ((equal? arg-0 12) 13) (else 14))))
(define CoreC-45TTC-45Primitive-u--compare_Ord_PrimType (lambda (ext-0 ext-1) (PreludeC-45Basics-on (lambda (eta-0) (lambda (eta-1) (PreludeC-45EqOrd-u--compare_Ord_Int eta-0 eta-1))) (lambda (eta-0) (CoreC-45TTC-45Primitive-n--7113-6401-u--tag eta-0)) ext-0 ext-1)))
(define CoreC-45TTC-45Primitive-n--10405-9559-u--tag (lambda (arg-2 arg-3 arg-5) (case (vector-ref arg-5 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) ((6) 6) ((7) 7) ((8) 8) ((9) 9) ((10) 10) ((11) 11) ((12) 12) ((13) 13) ((14) 14) ((15) 15) ((16) 16) ((17) 17) ((18) 18) ((19) 19) ((20) 20) ((21) 21) ((22) 22) ((23) 23) ((24) 24) ((25) 25) ((26) 26) ((27) 27) ((28) 28) ((29) 29) ((30) 30) ((31) 31) ((32) 32) ((33) 33) ((34) 34) ((35) 35) ((36) 36) ((37) 37) (else 38))))
(define CoreC-45TTC-45Primitive-primFnCmp (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-0 e-18)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-1 e-19)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((2) (let ((e-20 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-2 e-20)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((3) (let ((e-21 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-3 e-21)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((4) (let ((e-22 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-4 e-22)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((5) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-5 e-23)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((6) (let ((e-24 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-6 e-24)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((7) (let ((e-25 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-7 e-25)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((8) (let ((e-8 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((8) (let ((e-26 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-8 e-26)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((9) (let ((e-9 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((9) (let ((e-27 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-9 e-27)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((10) (let ((e-10 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((10) (let ((e-28 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-10 e-28)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((11) (let ((e-11 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((11) (let ((e-29 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-11 e-29)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((12) (let ((e-12 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((12) (let ((e-30 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-12 e-30)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((13) (let ((e-13 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((13) (let ((e-31 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-13 e-31)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((14) (let ((e-14 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((14) (let ((e-32 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-14 e-32)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((15) (let ((e-15 (vector-ref arg-2 1))) (case (vector-ref arg-3 0) ((15) (let ((e-33 (vector-ref arg-3 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-15 e-33)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))) ((36) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((36) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-16 e-34) (lambda () (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-17 e-35))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-2) (CoreC-45TTC-45Primitive-n--10405-9559-u--tag arg-3 arg-2 arg-3))))))
(define PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) 1 0) (let ((e-2 (unbox arg-2))) (if (null? arg-3) 2 (let ((e-8 (unbox arg-3))) (let ((e-10 (vector-ref arg-1 1))) ((e-10 e-2) e-8))))))))
(define CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-2 0))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-11 (vector-ref arg-2 4))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 csegen-231 e-3 e-9) (lambda () (CoreC-45Name-u--compare_Ord_Name e-1 e-7))) (let ((sc0 (CoreC-45Name-namesEq e-4 e-10))) (if (null? sc0) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 csegen-861 e-4 e-10)) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-5 e-11)))))))))))))))
(define CoreC-45Ord-u--C-60C-61_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bits8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (or (and (char<? arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Char (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Double arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Double arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define PreludeC-45EqOrd-u--C-60_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (< arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--compare_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define CoreC-45TTC-45Primitive-n--7345-6714-u--tag (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) ((6) 6) ((7) 7) ((8) 8) ((9) 9) ((10) 10) ((11) 11) ((12) 12) ((13) 13) (else 14))))
(define CoreC-45TTC-45Primitive-u--compare_Ord_Constant (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-14 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int e-0 e-14)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-15 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int8 e-1 e-15)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-16 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int16 e-2 e-16)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-17 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int32 e-3 e-17)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-18 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Int64 e-4 e-18)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-19 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Integer e-5 e-19)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-20 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits8 e-6 e-20)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-21 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits16 e-7 e-21)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-22 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits32 e-8 e-22)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-23 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Bits64 e-9 e-23)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-24 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_String e-10 e-24)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-25 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Char e-11 e-25)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-26 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--compare_Ord_Double e-12 e-26)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1)))))) ((13) (let ((e-13 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((13) (let ((e-27 (vector-ref arg-1 1))) (CoreC-45TTC-45Primitive-u--compare_Ord_PrimType e-13 e-27)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-0) (CoreC-45TTC-45Primitive-n--7345-6714-u--tag arg-1 arg-0 arg-1))))))
(define CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45TTC-45Primitive-u--compare_Ord_Constant e-1 e-4) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-2 e-5)))))))))
(define CoreC-45Ord-u--C-60C-61_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-60_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-60_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62C-61_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62C-61_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-62_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2) 2)))
(define DataC-45Vect-case--compare-3292 (lambda (arg-1 arg-3 arg-4 arg-5 arg-6 arg-8) (cond ((equal? arg-8 1) (DataC-45Vect-u--compare_Ord_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 arg-1 arg-4 arg-6))(else arg-8))))
(define DataC-45Vect-u--compare_Ord_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) 1 (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (DataC-45Vect-case--compare-3292 arg-2 e-3 e-4 e-8 e-9 (let ((e-2 (vector-ref arg-2 1))) ((e-2 e-3) e-8))))))))))
(define CoreC-45Ord-lrTag (lambda (arg-0) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) 1) (else 2))))
(define CoreC-45Ord-u--compare_Ord_LazyReason (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-lrTag arg-0) (CoreC-45Ord-lrTag arg-1))))
(define CoreC-45Ord-u--max_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--max_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--min_Ord_C-40CConAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_C-40CConAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--min_Ord_C-40CConstAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_C-40CConstAltC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-n--7062-2400-u--tag (lambda (arg-1 arg-2 arg-4) (case (vector-ref arg-4 0) ((0) 0) ((1) 1) ((2) 2) ((3) 3) ((4) 4) ((5) 5) ((6) 6) ((7) 7) ((8) 8) ((9) 9) ((10) 10) ((11) 11) ((12) 12) ((13) 13) (else 14))))
(define CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((0) (let ((e-65 (vector-ref arg-2 1))) (PreludeC-45EqOrd-u--compare_Ord_Integer e-2 e-65)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((1) (let ((e-70 (vector-ref arg-2 2))) (CoreC-45Name-u--compare_Ord_Name e-7 e-70)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))) ((2) (let ((e-10 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((2) (let ((e-73 (vector-ref arg-2 2))) (let ((e-74 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Name-nameEq e-10 e-73))) (if (null? sc2) (CoreC-45Name-u--compare_Ord_Name e-10 e-73) (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-11 e-74))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))) ((3) (let ((e-14 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((3) (let ((e-77 (vector-ref arg-2 2))) (let ((e-79 (vector-ref arg-2 4))) (let ((e-80 (vector-ref arg-2 5))) (let ((sc2 (CoreC-45Name-nameEq e-14 e-77))) (if (null? sc2) (CoreC-45Name-u--compare_Ord_Name e-14 e-77) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-16 e-79) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-17 e-80)))))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))))) ((4) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-83 (vector-ref arg-2 2))) (let ((e-84 (vector-ref arg-2 3))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-20 e-83) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-1886) e-21 e-84))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))) ((5) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (let ((e-27 (vector-ref arg-1 5))) (case (vector-ref arg-2 0) ((5) (let ((e-87 (vector-ref arg-2 2))) (let ((e-89 (vector-ref arg-2 4))) (let ((e-90 (vector-ref arg-2 5))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 csegen-231 e-26 e-89) (lambda () (CoreC-45Name-u--compare_Ord_Name e-24 e-87))) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-1886) e-27 e-90)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))))) ((6) (let ((e-31 (vector-ref arg-1 3))) (let ((e-32 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((6) (let ((e-94 (vector-ref arg-2 3))) (let ((e-95 (vector-ref arg-2 4))) (let ((sc2 (CoreC-45TTC-45Primitive-primFnEq e-31 e-94))) (if (null? sc2) (CoreC-45TTC-45Primitive-primFnCmp e-31 e-94) (DataC-45Vect-u--compare_Ord_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 (csegen-1886) e-32 e-95))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))) ((7) (let ((e-35 (vector-ref arg-1 2))) (let ((e-36 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((7) (let ((e-98 (vector-ref arg-2 2))) (let ((e-99 (vector-ref arg-2 3))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Name-u--compare_Ord_Name e-35 e-98) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (csegen-1886) e-36 e-99))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))) ((8) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-102 (vector-ref arg-2 2))) (let ((e-103 (vector-ref arg-2 3))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Ord-u--compare_Ord_LazyReason e-39 e-102) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-40 e-103))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))) ((9) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((9) (let ((e-106 (vector-ref arg-2 2))) (let ((e-107 (vector-ref arg-2 3))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Ord-u--compare_Ord_LazyReason e-43 e-106) (lambda () (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-44 e-107))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))) ((10) (let ((e-47 (vector-ref arg-1 2))) (let ((e-48 (vector-ref arg-1 3))) (let ((e-49 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((10) (let ((e-110 (vector-ref arg-2 2))) (let ((e-111 (vector-ref arg-2 3))) (let ((e-112 (vector-ref arg-2 4))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-47 e-110) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (vector (csegen-1919) (lambda (arg-1566) (lambda (arg-1569) (CoreC-45Ord-u--compare_Ord_C-40CConAltC-32C-36varsC-41 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45Ord-u--C-60_Ord_C-40CConAltC-32C-36varsC-41 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45Ord-u--C-62_Ord_C-40CConAltC-32C-36varsC-41 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45Ord-u--C-60C-61_Ord_C-40CConAltC-32C-36varsC-41 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45Ord-u--C-62C-61_Ord_C-40CConAltC-32C-36varsC-41 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45Ord-u--max_Ord_C-40CConAltC-32C-36varsC-41 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45Ord-u--min_Ord_C-40CConAltC-32C-36varsC-41 arg-1626 arg-1629)))) e-48 e-111))) (lambda () (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-1886) e-49 e-112)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))))) ((11) (let ((e-52 (vector-ref arg-1 2))) (let ((e-53 (vector-ref arg-1 3))) (let ((e-54 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((11) (let ((e-115 (vector-ref arg-2 2))) (let ((e-116 (vector-ref arg-2 3))) (let ((e-117 (vector-ref arg-2 4))) (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (LibrariesC-45DataC-45OrderingC-45Extra-thenCmp (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 e-52 e-115) (lambda () (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (vector (csegen-1930) (lambda (arg-1566) (lambda (arg-1569) (CoreC-45Ord-u--compare_Ord_C-40CConstAltC-32C-36varsC-41 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45Ord-u--C-60_Ord_C-40CConstAltC-32C-36varsC-41 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45Ord-u--C-62_Ord_C-40CConstAltC-32C-36varsC-41 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45Ord-u--C-60C-61_Ord_C-40CConstAltC-32C-36varsC-41 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45Ord-u--C-62C-61_Ord_C-40CConstAltC-32C-36varsC-41 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45Ord-u--max_Ord_C-40CConstAltC-32C-36varsC-41 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45Ord-u--min_Ord_C-40CConstAltC-32C-36varsC-41 arg-1626 arg-1629)))) e-53 e-116))) (lambda () (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (csegen-1886) e-54 e-117)))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))))) ((12) (let ((e-57 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((12) (let ((e-120 (vector-ref arg-2 2))) (CoreC-45TTC-45Primitive-u--compare_Ord_Constant e-57 e-120)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2)))))) ((13) (case (vector-ref arg-2 0) ((13) 1)(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))) ((14) (let ((e-62 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((14) (let ((e-125 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--compare_Ord_String e-62 e-125)))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))(else (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-1) (CoreC-45Ord-n--7062-2400-u--tag arg-2 arg-1 arg-2))))))
(define CoreC-45Ord-u--C-60C-61_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--C-60_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62C-61_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 0)))
(define CoreC-45Ord-u--C-62_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2) 2)))
(define CoreC-45Ord-u--max_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-62_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define CoreC-45Ord-u--min_Ord_C-40CExpC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45Ord-u--C-60_Ord_C-40CExpC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) arg-1) (else arg-2)))))
(define csegen-1886 (lambda () (vector (csegen-1875) (lambda (arg-1566) (lambda (arg-1569) (CoreC-45Ord-u--compare_Ord_C-40CExpC-32C-36varsC-41 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45Ord-u--C-60_Ord_C-40CExpC-32C-36varsC-41 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45Ord-u--C-62_Ord_C-40CExpC-32C-36varsC-41 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45Ord-u--C-60C-61_Ord_C-40CExpC-32C-36varsC-41 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45Ord-u--C-62C-61_Ord_C-40CExpC-32C-36varsC-41 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45Ord-u--max_Ord_C-40CExpC-32C-36varsC-41 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45Ord-u--min_Ord_C-40CExpC-32C-36varsC-41 arg-1626 arg-1629))))))
(define DataC-45Vect-u--foldlM_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (u--ma) (lambda (u--b) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) u--ma) (lambda (eta-0) (PreludeC-45Basics-flip arg-5 u--b eta-0)))))) (let ((e-1 (vector-ref arg-4 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) arg-6))) ext-0)))
(define DataC-45Vect-u--null_Foldable_C-40VectC-32C-36nC-41 (lambda (arg-2) (if (null? arg-2) 1 0)))
(define csegen-1914 (vector (lambda (u--acc) (lambda (u--elem) (lambda (u--func) (lambda (u--init) (lambda (u--input) (DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (u--acc) (lambda (u--func) (lambda (u--init) (lambda (u--input) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 u--func u--init u--input)))))) (lambda (u--elem) (lambda (arg-10911) (DataC-45Vect-u--null_Foldable_C-40VectC-32C-36nC-41 arg-10911))) (lambda (u--elem) (lambda (u--acc) (lambda (u--m) (lambda (i_con-0) (lambda (u--funcM) (lambda (u--init) (lambda (u--input) (DataC-45Vect-u--foldlM_Foldable_C-40VectC-32C-36nC-41 i_con-0 u--funcM u--init u--input)))))))) (lambda (u--elem) (lambda (arg-10940) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-10940))) (lambda (u--a) (lambda (u--m) (lambda (i_con-0) (lambda (u--f) (lambda (arg-10954) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 i_con-0 u--f arg-10954))))))))
(define DataC-45List-u--unzipWith_Zippable_List (lambda (arg-3 arg-4) (if (null? arg-4) (cons '() '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (arg-3 e-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (DataC-45List-u--unzipWith_Zippable_List arg-3 e-3))) (let ((e-7 (car sc2))) (let ((e-6 (cdr sc2))) (cons (cons e-5 e-7) (cons e-4 e-6)))))))))))))
(define DataC-45List-u--unzip_Zippable_List (lambda (ext-0) (DataC-45List-u--unzipWith_Zippable_List (lambda (eta-0) eta-0) ext-0)))
(define csegen-1915 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-u--unzip_Zippable_List e-5)))))))
(define csegen-1939 (lambda (eta-0) (lambda (eta-1) (bs+ eta-0 eta-1 63))))
(define CoreC-45NameC-45Namespace-primIONS (CoreC-45NameC-45Namespace-mkNamespace "PrimIO"))
(define csegen-1940 (vector 0 CoreC-45NameC-45Namespace-primIONS (vector 1 (vector 0 "io_bind"))))
(define DataC-45String-n--3846-9250-u--unlinesC-39 (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons e-2 (cons "\xa;" (DataC-45String-n--3846-9250-u--unlinesC-39 e-3))))))))
(define DataC-45String-fastUnlines (lambda (ext-0) (PreludeC-45Types-fastConcat (DataC-45String-n--3846-9250-u--unlinesC-39 ext-0))))
(define CoreC-45CaseC-45CaseTree-showCA (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) (cons e-1 e-3))) (string-append " => " (CoreC-45CaseC-45CaseTree-showCT (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-1 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (string-append "Delay " (string-append (CoreC-45Name-u--show_Show_Name e-7) (string-append " => " (CoreC-45CaseC-45CaseTree-showCT (cons e-6 (cons e-7 arg-0)) arg-1 e-8)))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (string-append "Constant " (string-append (CoreC-45TTC-45Primitive-u--show_Show_Constant e-10) (string-append " => " (CoreC-45CaseC-45CaseTree-showCT arg-0 arg-1 e-11))))))) (else (let ((e-13 (vector-ref arg-2 1))) (string-append "_ => " (CoreC-45CaseC-45CaseTree-showCT arg-0 arg-1 e-13)))))))
(define CoreC-45CaseC-45CaseTree-showCT (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (string-append "case " (string-append (CoreC-45Name-u--show_Show_Name e-1) (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Nat e-2) (string-append "] : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-4) (string-append " of" (string-append "\xa;" (string-append arg-1 (string-append " { " (string-append (CoreC-45NameC-45Namespace-showSep (string-append "\xa;" (string-append arg-1 " | ")) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-showCA arg-0 (string-append "  " arg-1) eta-0)) e-5)) (string-append "\xa;" (string-append arg-1 " }")))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Int e-7) (string-append "] " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (string-append "Error: " (PreludeC-45Show-u--show_Show_String e-10)))) (else "Impossible"))))
(define CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-0 ext-0) (CoreC-45CaseC-45CaseTree-showCT arg-0 "" ext-0)))
(define CoreC-45ContextC-45Context-u--show_Show_Def (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "undefined") ((1) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((e-3 (vector-ref arg-0 4))) (DataC-45String-fastUnlines (cons (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-1) ";") (cons (string-append "Compile time tree: " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-1 e-2)) (cons (string-append "Run time tree: " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-1 e-3)) '())))))))) ((5) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (string-append "DataCon " (string-append (PreludeC-45Show-u--show_Show_Int e-5) (string-append " " (string-append (PreludeC-45Show-u--show_Show_Nat e-6) (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (u--n) (string-append " (newtype by " (string-append (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1025 u--n) ")")))) e-7))))))))) ((6) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-10 (vector-ref arg-0 3))) (let ((e-13 (vector-ref arg-0 6))) (let ((e-14 (vector-ref arg-0 7))) (let ((e-15 (vector-ref arg-0 8))) (string-append "TyCon " (string-append (PreludeC-45Show-u--show_Show_Int e-8) (string-append " " (string-append (PreludeC-45Show-u--show_Show_Nat e-9) (string-append " params: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-895 e-10) (string-append " constructors: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-14) (string-append " mutual with: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-13) (string-append " detaggable by: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-1029 e-15))))))))))))))))))) ((2) (let ((e-16 (vector-ref arg-0 1))) (string-append "<external def with arity " (string-append (PreludeC-45Show-u--show_Show_Nat e-16) ">")))) ((3) (let ((e-17 (vector-ref arg-0 1))) (let ((e-18 (vector-ref arg-0 2))) (string-append "<foreign def with arity " (string-append (PreludeC-45Show-u--show_Show_Nat e-17) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-18) ">"))))))) ((4) (let ((e-19 (vector-ref arg-0 1))) (string-append "<builtin with arith " (string-append (PreludeC-45Show-u--show_Show_Nat e-19) ">")))) ((7) (let ((e-22 (vector-ref arg-0 2))) (string-append "Hole" (let ((sc1 (let ((e-0 (car e-22))) e-0))) (cond ((equal? sc1 1) " [impl]") (else "")))))) ((8) (let ((e-25 (vector-ref arg-0 3))) (string-append "Search in " (CoreC-45Name-u--show_Show_Name e-25)))) ((9) (let ((e-26 (vector-ref arg-0 1))) (let ((e-28 (vector-ref arg-0 3))) (string-append "Guess " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-26) (string-append " when " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 e-28))))))) ((11) (let ((e-29 (vector-ref arg-0 1))) (string-append "Universe level #" (PreludeC-45Show-u--show_Show_Integer e-29)))) ((10) "Bound name") (else "Delayed"))))
(define CoreC-45ContextC-45Context-u--showPrec_Show_Def (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_Def arg-1)))
(define csegen-1947 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_Def u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_Def u--d u--x)))))
(define csegen-1950 (vector 1 (vector 22 (vector 1 (vector 0 "Type")) '())))
(define csegen-1952 (vector 1 (vector 22 (vector 1 (vector 0 "__")) '())))
(define CoreC-45Context-u--full_HasNames_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-1 arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (vector 0 e-1 e-2 e-3 e-5)) (let ((e-7 (unbox e-6))) (vector 1 (vector 0 (let ((e-29 (vector-ref e-7 1))) e-29) e-2 e-3 e-5))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6 e-7 e-5))))) eff-0) ext-0))))))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-10 e-5))))) eff-0) ext-0)))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (arg-3) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40CaseAltC-32C-36varsC-41 arg-1 arg-3 eta-1))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-5))))) eff-0) ext-0))))))))(else (vector 1 arg-2)))))
(define CoreC-45Context-n--13894-9685-u--fullNamesPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-5 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-5 e-11) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-2 (cons e-5 (cons e-8 e-9))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Context-u--full_HasNames_Def (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-0 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Context-n--13894-9685-u--fullNamesPat e-4 e-1 e-3 e-2 e-0 arg-0 eta-2)) e-4 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-0 e-1 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((6) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (let ((e-11 (vector-ref arg-1 7))) (let ((e-12 (vector-ref arg-1 8))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) e-10 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-1 eta-2))) e-11 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 e-5 e-6 e-7 e-8 e-9 e-13 e-14 e-12))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))) ((8) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-0 e-15 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-13 e-14 e-5))))) eff-0) ext-0))))))))) ((9) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-16) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-5 e-17 e-18))))) eff-0) ext-0)))))))))(else (vector 1 arg-1)))))
(define csegen-1966 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Def arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Def arg-7729 arg-7732 eta-0))))))
(define System-exitWith (lambda (arg-2 arg-3) (if (null? arg-3) (let ((e-2 (cdr arg-2))) ((e-2 'erased) (lambda (eta-0) (System-prim__exit 0 eta-0)))) (let ((e-0 (car arg-3))) (let ((e-2 (cdr arg-2))) ((e-2 'erased) (lambda (eta-0) (System-prim__exit e-0 eta-0))))))))
(define csegen-1969 (System-exitWith csegen-82 (cons 1 (vector 0 ))))
(define LibrariesC-45DataC-45UserNameMap-empty '())
(define LibrariesC-45DataC-45ANameMap-empty (cons LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45UserNameMap-empty))
(define IdrisC-45Syntax-n--17143-7692-u--initDocStrings LibrariesC-45DataC-45ANameMap-empty)
(define CoreC-45Name-userNameRoot (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-userNameRoot e-1))) ((1) (let ((e-2 (vector-ref arg-0 1))) (box e-2))) ((4) (let ((e-4 (vector-ref arg-0 2))) (CoreC-45Name-userNameRoot e-4)))(else '()))))
(define CoreC-45Name-u--C-60C-61_Ord_UserName (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45Name-u--compare_Ord_UserName arg-0 arg-1) 2)))
(define LibrariesC-45DataC-45UserNameMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (CoreC-45Name-u--compare_Ord_UserName arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45UserNameMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45UserNameMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45UserNameMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ e-2 1) e-5))))))))))
(define LibrariesC-45DataC-45UserNameMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_UserName arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-10)) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_UserName arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45UserNameMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45UserNameMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45UserNameMap-treeLookup arg-1 e-3)))))
(define LibrariesC-45DataC-45ANameMap-n--3984-12729-u--update (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (cons (cons arg-3 arg-4) '()) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-3 (Builtin-fst e-2)))) (cond ((equal? sc1 1) (cons (cons arg-3 arg-4) e-3)) (else (cons e-2 (LibrariesC-45DataC-45ANameMap-n--3984-12729-u--update arg-1 arg-2 arg-3 arg-4 e-3))))))))))
(define LibrariesC-45DataC-45ANameMap-case--addToHier-12810 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-2 (let ((e-2 (unbox arg-4))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-2))) (if (null? sc1) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (cons arg-3 arg-1) '()) arg-2) (let ((e-3 (unbox sc1))) (LibrariesC-45DataC-45UserNameMap-insert e-2 (LibrariesC-45DataC-45ANameMap-n--3984-12729-u--update arg-1 arg-2 arg-3 arg-1 e-3) arg-2))))))))
(define LibrariesC-45DataC-45ANameMap-addToHier (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45ANameMap-case--addToHier-12810 arg-2 arg-3 arg-1 (CoreC-45Name-userNameRoot arg-1))))
(define LibrariesC-45DataC-45ANameMap-addName (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((u--dictC-39 (LibrariesC-45DataC-45NameMap-insert arg-1 arg-2 e-1))) (let ((u--hierC-39 (LibrariesC-45DataC-45ANameMap-addToHier arg-1 arg-2 e-2))) (cons u--dictC-39 u--hierC-39)))))))
(define LibrariesC-45DataC-45ANameMap-n--4326-13032-u--fromListC-39 (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45ANameMap-n--4326-13032-u--fromListC-39 (LibrariesC-45DataC-45ANameMap-addName e-6 e-7 arg-1) e-3))))))))
(define LibrariesC-45DataC-45ANameMap-fromList (lambda (ext-0) (LibrariesC-45DataC-45ANameMap-n--4326-13032-u--fromListC-39 LibrariesC-45DataC-45ANameMap-empty ext-0)))
(define IdrisC-45Syntax-n--17143-7693-u--initFixities (LibrariesC-45DataC-45ANameMap-fromList (cons (cons (vector 1 (vector 0 "-")) csegen-237) (cons (cons (vector 1 (vector 0 "negate")) csegen-237) (cons (cons (vector 1 (vector 0 "=")) (vector (vector 2 ) 1 2 0)) '())))))
(define IdrisC-45Syntax-n--17143-7694-u--initSaveDocStrings LibrariesC-45DataC-45NameMap-empty)
(define IdrisC-45Syntax-initSyntax (vector IdrisC-45Syntax-n--17143-7693-u--initFixities '() csegen-285 csegen-285 '() LibrariesC-45DataC-45ANameMap-empty IdrisC-45Syntax-n--17143-7694-u--initSaveDocStrings IdrisC-45Syntax-n--17143-7692-u--initDocStrings '() '() (vector 0 (vector 2 ) (vector 1 (vector 0 "main"))) '()))
(define csegen-1981 (CoreC-45Core-newRef (vector "Idris.Syntax.Syn" ) IdrisC-45Syntax-initSyntax))
(define SystemC-45FileC-45Virtual-stdin (SystemC-45FileC-45Virtual-prim__stdin))
(define SystemC-45FileC-45Virtual-stdout (SystemC-45FileC-45Virtual-prim__stdout))
(define csegen-1983 (vector 0 0 SystemC-45FileC-45Virtual-stdin SystemC-45FileC-45Virtual-stdout))
(define CoreC-45UnifyState-initUState (vector LibrariesC-45DataC-45IntMap-empty LibrariesC-45DataC-45IntMap-empty LibrariesC-45DataC-45IntMap-empty LibrariesC-45DataC-45IntMap-empty LibrariesC-45DataC-45IntMap-empty LibrariesC-45DataC-45IntMap-empty '() '() 0 0 '() 0))
(define csegen-1985 (CoreC-45Core-newRef (vector "Core.UnifyState.UST" ) CoreC-45UnifyState-initUState))
(define csegen-1987 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (Builtin-fst eta-0))))
(define csegen-1994 (LibrariesC-45DataC-45Version-showVersion 1 IdrisC-45Version-version))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 ext-0) (vector 1 (vector 0 ))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 ext-0) (vector 1 (vector 0 ))))
(define csegen-2002 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124UnitC-44MkUnitC-124C-41 arg-5542 eta-0)))))
(define csegen-2006 (let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr "Processing as TTImp\xa;" world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))
(define YaffleC-45Main-u--full_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 ext-0) (vector 1 (vector 0 ))))
(define YaffleC-45Main-u--resolved_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 ext-0) (vector 1 (vector 0 ))))
(define csegen-2010 (cons (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (YaffleC-45Main-u--full_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (YaffleC-45Main-u--resolved_HasNames_C-40C-124UnitC-44MkUnitC-124C-41 arg-7729 arg-7732 eta-0))))) csegen-2002))
(define csegen-2012 (let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr "Written TTC\xa;" world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))
(define YaffleC-45Main-usage "Usage: yaffle <input file> [--timing]")
(define csegen-2013 (lambda (eta-0) (PreludeC-45IO-prim__putStr (string-append YaffleC-45Main-usage "\xa;") eta-0)))
(define CoreC-45TT-u--show_Show_KindedName (lambda (ext-0) (CoreC-45Name-u--show_Show_Name (let ((e-2 (vector-ref ext-0 2))) e-2))))
(define CoreC-45TT-u--showPrec_Show_KindedName (lambda (arg-0 arg-1) (CoreC-45TT-u--show_Show_KindedName arg-1)))
(define csegen-2016 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_KindedName u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_KindedName u--d u--x)))))
(define csegen-2025 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 csegen-65 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpClauseC-39C-32C-36nmC-41 csegen-65 u--d u--x)))))
(define csegen-2027 (let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr "Failed\xa;" world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))
(define csegen-2039 (cons csegen-499 csegen-499))
(define csegen-2043 (cons csegen-962 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2039 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2039 u--d u--x))))))
(define csegen-2046 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2043 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2043 u--d u--x)))))
(define ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration (lambda (arg-0) (cond ((equal? arg-0 0) "comment") ((equal? arg-0 1) "type") ((equal? arg-0 2) "function") ((equal? arg-0 3) "data") ((equal? arg-0 4) "keyword") ((equal? arg-0 5) "bound") ((equal? arg-0 6) "namespace") ((equal? arg-0 7) "postulate") (else "module"))))
(define csegen-2049 (cons (cons (lambda (u--x) (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration u--x)) (lambda (u--d) (lambda (u--x) (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration u--x)))) csegen-972))
(define csegen-2053 (cons csegen-2046 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2049 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2049 u--d u--x))))))
(define csegen-2056 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2053 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2053 u--d u--x)))))
(define csegen-2062 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1563 arg-5542 eta-0)))))
(define csegen-2063 (cons csegen-2062 csegen-2062))
(define csegen-2067 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-5542 eta-0)))) (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2063 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2063 arg-5542 eta-0))))))
(define csegen-2070 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2067 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2067 arg-5542 eta-0)))))
(define csegen-2071 (cons csegen-1535 csegen-1590))
(define csegen-2074 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2071 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2071 arg-5542 eta-0)))))
(define csegen-2075 (cons csegen-2070 csegen-2074))
(define csegen-2078 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2075 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2075 arg-5542 eta-0)))))
(define csegen-2079 (cons csegen-41 csegen-2074))
(define csegen-2083 (cons csegen-2070 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2079 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2079 arg-5542 eta-0))))))
(define csegen-2086 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2083 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2083 arg-5542 eta-0)))))
(define csegen-2087 (cons csegen-41 csegen-1590))
(define csegen-2090 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2087 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2087 arg-5542 eta-0)))))
(define csegen-2091 (cons csegen-2070 csegen-41))
(define LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 (lambda (ext-0) ((let ((eff-0 (lambda (arg-2895) (Builtin-snd arg-2895)))) (lambda (arg-0) (eff-0 arg-0))) (Builtin-fst ext-0))))
(define csegen-2095 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2091 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2091 arg-5542 eta-0)))) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0))))
(define CoreC-45Metadata-u--fromBuf_TTC_Decoration (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 1)) ((equal? e-5 1) (vector 1 2)) ((equal? e-5 2) (vector 1 3)) ((equal? e-5 3) (vector 1 4)) ((equal? e-5 4) (vector 1 5)) ((equal? e-5 5) (vector 1 6)) ((equal? e-5 6) (vector 1 7)) ((equal? e-5 7) (vector 1 8)) ((equal? e-5 8) (vector 1 0))(else (CoreC-45BinaryC-45Prims-corrupt "Decoration" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-u--toBuf_TTC_Decoration (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 2) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((equal? arg-1 3) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((equal? arg-1 4) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) ((equal? arg-1 5) (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)) ((equal? arg-1 6) (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0)) ((equal? arg-1 7) (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0)) ((equal? arg-1 8) (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0)))))
(define csegen-2102 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45Metadata-u--toBuf_TTC_Decoration arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45Metadata-u--fromBuf_TTC_Decoration arg-5542 eta-0)))) (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-5542 eta-0))))))
(define csegen-2106 (cons csegen-2070 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2102 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2102 arg-5542 eta-0))))))
(define csegen-2110 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2106 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2106 arg-5542 eta-0)))) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0))))
(define csegen-2111 (cons csegen-2070 csegen-2070))
(define csegen-2115 (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2111 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2111 arg-5542 eta-0)))) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0))))
(define csegen-2116 (cons csegen-895 csegen-1268))
(define csegen-2119 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2116 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2116 u--d u--x)))))
(define csegen-2120 (cons csegen-2046 csegen-2119))
(define csegen-2124 (cons csegen-65 csegen-2119))
(define csegen-2128 (cons csegen-2046 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2124 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2124 u--d u--x))))))
(define csegen-2131 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2128 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2128 u--d u--x)))))
(define csegen-2132 (cons csegen-65 csegen-1268))
(define csegen-2136 (cons csegen-2046 csegen-65))
(define csegen-2140 (cons csegen-2046 csegen-2046))
(define CoreC-45Name-dropNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) e-1))(else arg-0))))
(define csegen-2144 (lambda (u--x) (lambda (u--y) (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS u--x) (CoreC-45Name-dropNS u--y)))))
(define LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Digit (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) ((arg-2 e-1) arg-3))) ((1) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) ((arg-2 e-3) ((arg-2 e-4) arg-3))))) ((2) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) ((arg-2 e-6) ((arg-2 e-7) ((arg-2 e-8) arg-3))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) ((arg-2 e-10) ((arg-2 e-11) ((arg-2 e-12) ((arg-2 e-13) arg-3))))))))))))
(define LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Node (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) ((arg-2 e-2) ((arg-2 e-3) arg-3))))) (else (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) ((arg-2 e-6) ((arg-2 e-7) ((arg-2 e-8) arg-3))))))))))
(define LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) arg-3) ((1) (let ((e-2 (vector-ref arg-4 1))) ((arg-2 e-2) arg-3))) (else (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (let ((e-7 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Digit arg-2 (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Node arg-2 eta-2 eta-3))) eta-0 eta-1))) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_Digit arg-2 arg-3 e-7) e-6) e-5))))))))
(define LibrariesC-45DataC-45PosMap-u--foldMap_Foldable_PosMap (lambda (arg-2 arg-3 ext-0) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 (arg-3 eta-0)) eta-1)))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define csegen-2145 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--foldMap_Foldable_PosMap csegen-57 eta-0 eta-1))))
(define LibrariesC-45DataC-45PosMap-u--cast_Cast_FileRange_RMFileRange (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons (cons e-2 e-3) e-3)))))
(define LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a (lambda (arg-1 ext-0) (LibrariesC-45DataC-45PosMap-u--cast_Cast_FileRange_RMFileRange (arg-1 ext-0))))
(define csegen-2146 (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) eta-0)))
(define LibrariesC-45DataC-45PosMap-greater (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-1 (car e-0))) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 (Builtin-fst e-1) arg-0))))))
(define LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (lambda (ext-0) (box ext-0)))
(define LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval '())
(define LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval) ((1) (let ((e-2 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-2)))) (else (let ((e-4 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval e-4))))))
(define LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (lambda (arg-0 arg-1) (let ((e-1 (cdr arg-0))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 e-1 e-3)))))))
(define LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (arg-1 e-1))) ((1) (let ((e-3 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 2))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 e-3) (arg-1 e-4))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 e-6) (arg-1 e-7)) (arg-1 e-8)))))) (else (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 e-10) (arg-1 e-11)) (arg-1 e-12)) (arg-1 e-13))))))))))
(define LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) (else (let ((e-5 (vector-ref arg-1 1))) e-5)))))
(define LibrariesC-45DataC-45PosMap-n--5633-4876-u--value (lambda (arg-1 arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-3))) (if (null? sc0) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-4) ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-2)) (let ((e-0 (unbox sc0))) (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-4) e-0) ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-2)))))))
(define LibrariesC-45DataC-45PosMap-deep (lambda (arg-1 arg-2 arg-3 arg-4) (vector 2 (LibrariesC-45DataC-45PosMap-n--5633-4876-u--value arg-1 arg-4 arg-3 arg-2) arg-2 arg-3 arg-4)))
(define LibrariesC-45DataC-45PosMap-node3 (lambda (arg-1 arg-2 arg-3 arg-4) (vector 1 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 arg-2) (arg-1 arg-3)) (arg-1 arg-4)) arg-2 arg-3 arg-4)))
(define LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 1 arg-2)) ((1) (let ((e-2 (vector-ref arg-3 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 arg-2) (vector 0 ) (vector 0 e-2)))) (else (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (case (vector-ref e-5 0) ((0) (let ((e-9 (vector-ref e-5 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 arg-2 e-9) e-6 e-7))) ((1) (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 2 arg-2 e-11 e-12) e-6 e-7)))) ((2) (let ((e-14 (vector-ref e-5 1))) (let ((e-15 (vector-ref e-5 2))) (let ((e-16 (vector-ref e-5 3))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 3 arg-2 e-14 e-15 e-16) e-6 e-7))))) (else (let ((e-18 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (let ((e-20 (vector-ref e-5 3))) (let ((e-21 (vector-ref e-5 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 arg-2 e-18) (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-19 e-20 e-21) e-6) e-7))))))))))))))
(define LibrariesC-45DataC-45PosMap-digitToTree (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (vector 1 e-1))) ((1) (let ((e-3 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 2))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 e-3) (vector 0 ) (vector 0 e-4))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 e-6 e-7) (vector 0 ) (vector 0 e-8)))))) (else (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 e-10 e-11) (vector 0 ) (vector 1 e-12 e-13))))))))))
(define LibrariesC-45DataC-45PosMap-nodeToDigit (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 1 e-2 e-3)))) (else (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (vector 2 e-6 e-7 e-8))))))))
(define LibrariesC-45DataC-45PosMap-viewl (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) '()) ((1) (let ((e-2 (vector-ref arg-2 1))) (cons e-2 (vector 0 )))) (else (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (case (vector-ref e-5 0) ((0) (let ((e-9 (vector-ref e-5 1))) (cons e-9 (LibrariesC-45DataC-45PosMap-rotl arg-1 e-6 e-7)))) ((1) (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (cons e-11 (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 e-12) e-6 e-7))))) ((2) (let ((e-14 (vector-ref e-5 1))) (let ((e-15 (vector-ref e-5 2))) (let ((e-16 (vector-ref e-5 3))) (cons e-14 (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 1 e-15 e-16) e-6 e-7)))))) (else (let ((e-18 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (let ((e-20 (vector-ref e-5 3))) (let ((e-21 (vector-ref e-5 4))) (cons e-18 (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 2 e-19 e-20 e-21) e-6 e-7)))))))))))))))
(define LibrariesC-45DataC-45PosMap-rotl (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45PosMap-viewl (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2))) (if (null? sc0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 arg-3) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2))) (if (null? sc1) (vector 2 ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-3) (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-2) e-3 arg-3) (let ((e-0 (unbox sc1))) (vector 2 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange e-0 ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-3)) (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-2) e-3 arg-3))))))))))
(define LibrariesC-45DataC-45PosMap-deepl (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) (LibrariesC-45DataC-45PosMap-rotl arg-1 arg-3 arg-4) (let ((e-2 (unbox arg-2))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 arg-3 arg-4)))))
(define LibrariesC-45DataC-45PosMap-viewr (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) '()) ((1) (let ((e-2 (vector-ref arg-2 1))) (cons (vector 0 ) e-2))) (else (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (case (vector-ref e-7 0) ((0) (let ((e-9 (vector-ref e-7 1))) (cons (LibrariesC-45DataC-45PosMap-rotr arg-1 e-5 e-6) e-9))) ((1) (let ((e-11 (vector-ref e-7 1))) (let ((e-12 (vector-ref e-7 2))) (cons (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 0 e-11)) e-12)))) ((2) (let ((e-14 (vector-ref e-7 1))) (let ((e-15 (vector-ref e-7 2))) (let ((e-16 (vector-ref e-7 3))) (cons (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 1 e-14 e-15)) e-16))))) (else (let ((e-18 (vector-ref e-7 1))) (let ((e-19 (vector-ref e-7 2))) (let ((e-20 (vector-ref e-7 3))) (let ((e-21 (vector-ref e-7 4))) (cons (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 2 e-18 e-19 e-20)) e-21))))))))))))))
(define LibrariesC-45DataC-45PosMap-rotr (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45PosMap-viewr (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-3))) (if (null? sc0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 arg-2) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-3))) (if (null? sc1) (vector 2 ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-2) arg-2 e-2 (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-3)) (let ((e-0 (unbox sc1))) (vector 2 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) arg-2) e-0) arg-2 e-2 (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 e-3)))))))))))
(define LibrariesC-45DataC-45PosMap-deepr (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (LibrariesC-45DataC-45PosMap-rotr arg-1 arg-2 arg-3) (let ((e-2 (unbox arg-4))) (LibrariesC-45DataC-45PosMap-deep arg-1 arg-2 arg-3 e-2)))))
(define LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (if (null? arg-1) arg-0 (let ((e-0 (unbox arg-0))) (let ((e-1 (unbox arg-1))) (box (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange e-0 e-1))))))))
(define LibrariesC-45DataC-45PosMap-searchDigit (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (cons '() (cons e-1 '())))) ((1) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (let ((u--va (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-3))))) (let ((u--vb (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-4)) arg-5))) (let ((sc1 ((arg-2 u--va) u--vb))) (cond ((equal? sc1 1) (cons '() (cons e-3 (box (vector 0 e-4))))) (else (cons (box (vector 0 e-3)) (cons e-4 '())))))))))) ((2) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((u--va (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-6))))) (let ((u--vab (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--va (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-7))))) (let ((u--vc (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-8)) arg-5))) (let ((u--vbc (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-7)) u--vc))) (let ((sc1 ((arg-2 u--va) u--vbc))) (cond ((equal? sc1 1) (cons '() (cons e-6 (box (vector 1 e-7 e-8))))) (else (let ((sc2 ((arg-2 u--vab) u--vc))) (cond ((equal? sc2 1) (cons (box (vector 0 e-6)) (cons e-7 (box (vector 0 e-8))))) (else (cons (box (vector 1 e-6 e-7)) (cons e-8 '())))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((u--va (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-10))))) (let ((u--vab (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--va (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-11))))) (let ((u--vabc (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vab (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-12))))) (let ((u--vd (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-13)) arg-5))) (let ((u--vcd (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-12)) u--vd))) (let ((u--vbcd (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval (arg-1 e-11)) u--vcd))) (let ((sc1 ((arg-2 u--va) u--vbcd))) (cond ((equal? sc1 1) (cons '() (cons e-10 (box (vector 2 e-11 e-12 e-13))))) (else (let ((sc2 ((arg-2 u--vab) u--vcd))) (cond ((equal? sc2 1) (cons (box (vector 0 e-10)) (cons e-11 (box (vector 1 e-12 e-13))))) (else (let ((sc3 ((arg-2 u--vabc) u--vd))) (cond ((equal? sc3 1) (cons (box (vector 1 e-10 e-11)) (cons e-12 (box (vector 0 e-13))))) (else (cons (box (vector 2 e-10 e-11 e-12)) (cons e-13 '())))))))))))))))))))))))))
(define LibrariesC-45DataC-45PosMap-searchNode (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-searchDigit arg-1 arg-2 arg-3 (LibrariesC-45DataC-45PosMap-nodeToDigit arg-1 arg-4) arg-5)))
(define LibrariesC-45DataC-45PosMap-searchTree (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) '()) ((1) (let ((e-2 (vector-ref arg-4 1))) (box (cons (vector 0 ) (cons e-2 (vector 0 )))))) (else (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (let ((e-7 (vector-ref arg-4 4))) (let ((u--vm (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) e-6))) (let ((u--vsr (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) e-7)) arg-5))) (let ((u--vmsr (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vm u--vsr))) (let ((u--vlp (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval arg-3 (LibrariesC-45DataC-45PosMap-u--cast_Cast_RMFileRange_Interval ((let ((eff-0 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40DigitC-32C-36aC-41 arg-1 arg-2933)))) (lambda (arg-0) (eff-0 arg-0))) e-5))))) (let ((u--vlpm (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vlp u--vm))) (let ((sc1 ((arg-2 u--vlp) u--vmsr))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45PosMap-searchDigit arg-1 arg-2 arg-3 e-5 u--vmsr))) (let ((e-2 (car sc2))) (let ((e-3 (cdr sc2))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (box (cons (PreludeC-45Types-maybe (lambda () (vector 0 )) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 eta-0))) e-2) (cons e-9 (LibrariesC-45DataC-45PosMap-deepl arg-1 e-8 e-6 e-7)))))))))) (else (let ((sc2 ((arg-2 u--vlpm) u--vsr))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45PosMap-searchTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 u--vlp e-6 u--vsr) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((sc5 (LibrariesC-45DataC-45PosMap-searchNode arg-1 arg-2 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval u--vlp (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) e-2)) e-9 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_Interval (LibrariesC-45DataC-45PosMap-measureTree (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) e-8) u--vsr)))) (let ((e-11 (car sc5))) (let ((e-10 (cdr sc5))) (let ((e-13 (car e-10))) (let ((e-12 (cdr e-10))) (box (cons (LibrariesC-45DataC-45PosMap-deepr arg-1 e-5 e-2 e-11) (cons e-13 (LibrariesC-45DataC-45PosMap-deepl arg-1 e-12 e-8 e-7)))))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45PosMap-searchDigit arg-1 arg-2 u--vlpm e-7 arg-5))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (box (cons (LibrariesC-45DataC-45PosMap-deepr arg-1 e-5 e-6 e-2) (cons e-9 (PreludeC-45Types-maybe (lambda () (vector 0 )) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45PosMap-digitToTree arg-1 eta-0))) e-8)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45PosMap-split (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (cons (vector 0 ) (vector 0 )))(else (let ((sc0 (LibrariesC-45DataC-45PosMap-searchTree arg-1 (lambda (u--a) (lambda (_-10811) (arg-2 u--a))) LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval arg-3 LibrariesC-45DataC-45PosMap-u--neutral_Monoid_Interval))) (if (null? sc0) (cons arg-3 (vector 0 )) (let ((e-1 (unbox sc0))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (arg-2 (LibrariesC-45DataC-45PosMap-measureTree arg-1 arg-3)))) (cond ((equal? sc3 1) (cons e-5 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-9 e-10))) (else (cons arg-3 (vector 0 ))))))))))))))))
(define LibrariesC-45DataC-45PosMap-takeUntil (lambda (arg-1 arg-2 ext-0) (Builtin-fst (LibrariesC-45DataC-45PosMap-split arg-1 arg-2 ext-0))))
(define LibrariesC-45DataC-45PosMap-atleast (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-2 (cdr e-0))) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-0 e-2))))))
(define LibrariesC-45DataC-45PosMap-dropUntil (lambda (arg-1 arg-2 ext-0) (Builtin-snd (LibrariesC-45DataC-45PosMap-split arg-1 arg-2 ext-0))))
(define LibrariesC-45DataC-45PosMap-n--12691-11681-u--matches (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((sc0 (LibrariesC-45DataC-45PosMap-viewl arg-1 (LibrariesC-45DataC-45PosMap-dropUntil arg-1 (lambda (eta-0) (LibrariesC-45DataC-45PosMap-atleast arg-4 eta-0)) arg-5)))) (if (null? sc0) '() (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons e-2 (LibrariesC-45DataC-45PosMap-n--12691-11681-u--matches arg-1 arg-2 arg-3 arg-4 e-3))))))))
(define LibrariesC-45DataC-45PosMap-inRange (lambda (arg-1 arg-2 arg-3 arg-4) (LibrariesC-45DataC-45PosMap-n--12691-11681-u--matches arg-1 arg-4 arg-3 arg-2 (LibrariesC-45DataC-45PosMap-takeUntil arg-1 (lambda (eta-0) (LibrariesC-45DataC-45PosMap-greater arg-3 eta-0)) arg-4))))
(define LibrariesC-45DataC-45PosMap-exactRange (lambda (arg-1 arg-2 arg-3 arg-4) (PreludeC-45Basics-flip csegen-1631 (LibrariesC-45DataC-45PosMap-inRange arg-1 arg-2 arg-3 arg-4) (lambda (u--a) (let ((sc0 (arg-1 u--a))) (let ((e-0 (car sc0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1622 csegen-1622 e-0 (cons arg-2 arg-3))) (lambda (_-10649) (box u--a)))))))))
(define csegen-2147 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (LibrariesC-45DataC-45PosMap-exactRange csegen-2146 eta-0 eta-1 eta-2)))))
(define csegen-2165 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (vector 7 ))))
(define ParserC-45RuleC-45Source-symbol (lambda (arg-0) (vector 1 (string-append "Expected '" (string-append arg-0 "'")) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))))(else '()))))))
(define csegen-2242 (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 u--ps)))))
(define CoreC-45TTC-45Binder-u--traverse_Traversable_PiInfo (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) (vector 0 )))) ((1) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) (vector 1 )))) ((2) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) (vector 2 )))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-3 0))) ((((e-1 'erased) 'erased) (lambda (eta-0) (vector 3 eta-0))) (arg-4 e-4))))))))
(define CoreC-45TTC-45Binder-u--traverse_Traversable_Binder (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-3 2))) ((((e-5 'erased) 'erased) (let ((e-10 (vector-ref arg-3 0))) ((((e-10 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (vector 0 e-1 e-2 eta-0 eta-1)))) (CoreC-45TTC-45Binder-u--traverse_Traversable_PiInfo arg-3 arg-4 e-3)))) (arg-4 e-4)))))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((e-9 (vector-ref arg-5 4))) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-10 (vector-ref arg-3 0))) ((((e-10 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (vector 1 e-6 e-7 eta-0 eta-1)))) (arg-4 e-8)))) (arg-4 e-9)))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-6 (vector-ref arg-3 0))) ((((e-6 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (vector 2 e-11 e-12 eta-0 eta-1)))) (CoreC-45TTC-45Binder-u--traverse_Traversable_PiInfo arg-3 arg-4 e-13)))) (arg-4 e-14)))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-6 (vector-ref arg-3 0))) ((((e-6 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (vector 3 e-16 e-17 eta-0 eta-1)))) (CoreC-45TTC-45Binder-u--traverse_Traversable_PiInfo arg-3 arg-4 e-18)))) (arg-4 e-19)))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-6 (vector-ref arg-3 0))) ((((e-6 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (vector 4 e-21 e-22 eta-0 eta-1)))) (arg-4 e-23)))) (arg-4 e-24)))))))) (else (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-28 (vector-ref arg-5 3))) (let ((e-1 (vector-ref arg-3 0))) ((((e-1 'erased) 'erased) (lambda (eta-0) (vector 5 e-26 e-27 eta-0))) (arg-4 e-28))))))))))
(define CoreC-45TTC-45Term-shrinkBinder (lambda (arg-2 arg-3) (CoreC-45TTC-45Binder-u--traverse_Traversable_Binder csegen-255 (lambda (u--t) (CoreC-45TTC-45Term-shrinkTerm u--t arg-3)) arg-2)))
(define CoreC-45TTC-45VarC-45Var-later (lambda (arg-3) (+ arg-3 1)))
(define CoreC-45TTC-45Var-shrinkIsVar (lambda (arg-4 arg-6) (case (vector-ref arg-6 0) ((0) (box arg-4))(else (cond ((equal? arg-4 0) (case (vector-ref arg-6 0) ((1) '()) (else (box 0))))(else (let ((e-0 (- arg-4 1))) (case (vector-ref arg-6 0) ((1) (let ((e-15 (vector-ref arg-6 1))) (CoreC-45TTC-45Var-shrinkIsVar e-0 e-15))) (else (let ((e-20 (vector-ref arg-6 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45TTC-45VarC-45Var-later eta-0)) (CoreC-45TTC-45Var-shrinkIsVar e-0 e-20))))))))))))
(define PreludeC-45Types-u--traverse_Traversable_List (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) '())) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (vector-ref arg-3 2))) ((((e-4 'erased) 'erased) (let ((e-6 (vector-ref arg-3 2))) ((((e-6 'erased) 'erased) (let ((e-10 (vector-ref arg-3 1))) ((e-10 'erased) csegen-103))) (arg-4 e-2)))) (PreludeC-45Types-u--traverse_Traversable_List arg-3 arg-4 e-3))))))))
(define CoreC-45TTC-45Term-shrinkTerms (lambda (arg-2 arg-3) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (u--t) (CoreC-45TTC-45Term-shrinkTerm u--t arg-3)) arg-2)))
(define CoreC-45TTC-45Term-shrinkTerm (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Var-shrinkIsVar e-4 arg-3) (lambda (_-0) (box (vector 0 e-2 e-3 _-0)))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (box (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerms e-14 arg-3) (lambda (bind-0) (box (vector 2 e-11 e-12 e-13 bind-0))))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkBinder e-18 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-19 (vector 2 arg-3)) (lambda (bind-1) (box (vector 3 e-16 e-17 bind-0 bind-1))))))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-22 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-23 arg-3) (lambda (bind-1) (box (vector 4 e-21 bind-0 bind-1)))))))))) ((5) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-27 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-28 arg-3) (lambda (bind-1) (box (vector 5 e-25 e-26 bind-0 bind-1))))))))))) ((6) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-32 arg-3) (lambda (bind-0) (box (vector 6 e-30 e-31 bind-0)))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-36 arg-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-37 arg-3) (lambda (bind-1) (box (vector 7 e-34 e-35 bind-0 bind-1))))))))))) ((8) (let ((e-39 (vector-ref arg-2 1))) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkTerm e-41 arg-3) (lambda (bind-0) (box (vector 8 e-39 e-40 bind-0)))))))) ((9) (let ((e-43 (vector-ref arg-2 1))) (let ((e-44 (vector-ref arg-2 2))) (box (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (case (vector-ref e-47 0) ((0) (box (vector 10 e-46 (vector 0 )))) ((1) (box (vector 10 e-46 (vector 1 )))) (else (let ((e-54 (vector-ref e-47 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 10 e-46 (vector 2 eta-0))) (CoreC-45TTC-45Term-shrinkTerm e-54 arg-3)))))))) (else (let ((e-49 (vector-ref arg-2 1))) (let ((e-50 (vector-ref arg-2 2))) (box (vector 11 e-49 e-50))))))))
(define CoreC-45TTC-45Term-u--shrink_IsScoped_Term (lambda (ext-0 ext-1) (CoreC-45TTC-45Term-shrinkTerm ext-0 ext-1)))
(define CoreC-45TTC-45Term-thinBinder (lambda (arg-2 arg-3) (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (u--t) (CoreC-45TTC-45Term-thinTerm u--t arg-3)) arg-2)))
(define CoreC-45TTC-45Var-thinIsVar (lambda (arg-4 arg-6) (case (vector-ref arg-6 0) ((0) arg-4) ((1) (let ((e-17 (vector-ref arg-6 1))) (CoreC-45TTC-45VarC-45Var-later (CoreC-45TTC-45Var-thinIsVar arg-4 e-17))))(else (cond ((equal? arg-4 0) 0)(else (let ((e-0 (- arg-4 1))) (let ((e-10 (vector-ref arg-6 1))) (CoreC-45TTC-45VarC-45Var-later (CoreC-45TTC-45Var-thinIsVar e-0 e-10))))))))))
(define CoreC-45TTC-45Term-thinTerms (lambda (arg-2 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (CoreC-45TTC-45Term-thinTerm u--t arg-3)) arg-2)))
(define CoreC-45TTC-45Term-thinTerm (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((eff-0 (CoreC-45TTC-45Var-thinIsVar e-4 arg-3))) (vector 0 e-2 e-3 eff-0)))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (vector 2 e-11 e-12 e-13 (CoreC-45TTC-45Term-thinTerms e-14 arg-3))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 4))) (vector 3 e-16 e-17 (CoreC-45TTC-45Term-thinBinder e-18 arg-3) (CoreC-45TTC-45Term-thinTerm e-19 (vector 2 arg-3)))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (vector 4 e-21 (CoreC-45TTC-45Term-thinTerm e-22 arg-3) (CoreC-45TTC-45Term-thinTerm e-23 arg-3)))))) ((5) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (vector 5 e-25 e-26 (CoreC-45TTC-45Term-thinTerm e-27 arg-3) (CoreC-45TTC-45Term-thinTerm e-28 arg-3))))))) ((6) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (vector 6 e-30 e-31 (CoreC-45TTC-45Term-thinTerm e-32 arg-3)))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (vector 7 e-34 e-35 (CoreC-45TTC-45Term-thinTerm e-36 arg-3) (CoreC-45TTC-45Term-thinTerm e-37 arg-3))))))) ((8) (let ((e-39 (vector-ref arg-2 1))) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (vector 8 e-39 e-40 (CoreC-45TTC-45Term-thinTerm e-41 arg-3)))))) ((9) (let ((e-43 (vector-ref arg-2 1))) (let ((e-44 (vector-ref arg-2 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (case (vector-ref e-47 0) ((1) (vector 10 e-46 (vector 1 ))) ((0) (vector 10 e-46 (vector 0 ))) (else (let ((e-54 (vector-ref e-47 1))) (vector 10 e-46 (vector 2 (CoreC-45TTC-45Term-thinTerm e-54 arg-3))))))))) (else (let ((e-49 (vector-ref arg-2 1))) (let ((e-50 (vector-ref arg-2 2))) (vector 11 e-49 e-50)))))))
(define CoreC-45TTC-45Term-u--thin_IsScoped_Term (lambda (ext-0 ext-1) (CoreC-45TTC-45Term-thinTerm ext-0 ext-1)))
(define csegen-2277 (vector CoreC-45TTC-45Term-WeakenTerm (lambda (u--ys) (lambda (u--xs) (lambda (arg-4685) (lambda (arg-4689) arg-4689)))) (lambda (xs-4418) (lambda (ys-4419) (lambda (eta-0) (lambda (eta-1) (CoreC-45TTC-45Term-u--thin_IsScoped_Term eta-0 eta-1))))) (lambda (xs-4430) (lambda (ys-4431) (lambda (eta-0) (lambda (eta-1) (CoreC-45TTC-45Term-u--shrink_IsScoped_Term eta-0 eta-1)))))))
(define CoreC-45FC-u--C-61C-61_Eq_OriginDesc (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 1))) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent e-0 e-3)))(else 0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-4 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-4)))(else 0)))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0)))(else 0))))
(define CoreC-45FC-u--C-61C-61_Eq_FC (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((0) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_OriginDesc e-0 e-6))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 e-1 e-7))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 e-2 e-8)) (else 0)))) (else 0)))))))(else 0)))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((1) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((e-11 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_OriginDesc e-3 e-9))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 e-4 e-10))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 e-5 e-11)) (else 0)))) (else 0)))))))(else 0)))))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0)))(else 0))))
(define IdrisC-45Error-u--C-61C-61_Eq_FileError (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-0 e-1)))(else 0)))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-1 0) ((4) 1)(else 0))) ((5) (case (vector-ref arg-1 0) ((5) 1)(else 0)))(else 0))))
(define IdrisC-45Error-u--C-61C-61_Eq_TTCErrorMsg (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 e-5))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-1 e-6))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-2 e-7)) (else 0)))) (else 0)))))))(else 0)))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-8 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-3 e-8)))(else 0)))) ((2) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-9 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-4 e-9)))(else 0))))(else 0))))
(define CoreC-45TT-u--C-61C-61_Eq_Visibility (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define csegen-3018 (cons (lambda (arg-676) (lambda (arg-679) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 csegen-832 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (DataC-45List1-u--C-47C-61_Eq_C-40List1C-32C-36aC-41 csegen-832 arg-686 arg-689)))))
(define CoreC-45FC-u--C-47C-61_Eq_FC (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45FC-u--C-61C-61_Eq_FC arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-3012 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45FC-u--C-61C-61_Eq_FC arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45FC-u--C-47C-61_Eq_FC arg-686 arg-689)))))
(define csegen-3024 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3012 csegen-832 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3012 csegen-832 arg-686 arg-689)))))
(define IdrisC-45Error-u--C-61C-61_Eq_Warning (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((0) (let ((e-17 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-0 e-17))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-18)) (else 0))))))(else 0))))) ((1) (let ((e-3 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((1) (let ((e-20 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-3 e-20)))(else 0)))) ((2) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-23 (vector-ref arg-1 1))) (let ((e-24 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-6 e-23))) (cond ((equal? sc2 1) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-22 csegen-3018 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-22 csegen-3018 arg-686 arg-689)))) e-7 e-24)) (else 0))))))(else 0))))) ((3) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-10 (vector-ref arg-0 3))) (let ((e-11 (vector-ref arg-0 4))) (case (vector-ref arg-1 0) ((3) (let ((e-25 (vector-ref arg-1 1))) (let ((e-26 (vector-ref arg-1 2))) (let ((e-27 (vector-ref arg-1 3))) (let ((e-28 (vector-ref arg-1 4))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-8 e-25))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Visibility e-9 e-26))) (cond ((equal? sc3 1) (let ((sc4 (CoreC-45TT-u--C-61C-61_Eq_Visibility e-10 e-27))) (cond ((equal? sc4 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-11 e-28)) (else 0)))) (else 0)))) (else 0))))))))(else 0))))))) ((5) (let ((e-12 (vector-ref arg-0 1))) (let ((e-13 (vector-ref arg-0 2))) (let ((e-14 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((5) (let ((e-29 (vector-ref arg-1 1))) (let ((e-30 (vector-ref arg-1 2))) (let ((e-31 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-12 e-29))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-13 e-30))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-3024 e-14 e-31)) (else 0)))) (else 0)))))))(else 0)))))) ((6) (let ((e-15 (vector-ref arg-0 1))) (let ((e-16 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-32 (vector-ref arg-1 1))) (let ((e-33 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-15 e-32))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-16 e-33)) (else 0))))))(else 0)))))(else 0))))
(define PreludeC-45Types-u--C-47C-61_Eq_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-2546 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45Types-u--C-47C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 arg-686 arg-689)))))
(define csegen-3015 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3012 csegen-22 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3012 csegen-22 arg-686 arg-689)))))
(define IdrisC-45Error-u--C-61C-61_Eq_Error (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-218 (vector-ref arg-1 1))) (IdrisC-45Error-u--C-61C-61_Eq_Error e-0 e-218)))(else 0)))) ((1) (let ((e-2 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((1) (let ((e-220 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-2 e-220)))(else 0)))) ((2) (let ((e-8 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((2) (let ((e-226 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-8 e-226)))(else 0)))) ((3) (let ((e-14 (vector-ref arg-0 2))) (let ((e-15 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 5))) (case (vector-ref arg-1 0) ((3) (let ((e-232 (vector-ref arg-1 2))) (let ((e-233 (vector-ref arg-1 3))) (let ((e-235 (vector-ref arg-1 5))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-14 e-232))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45FC-u--C-61C-61_Eq_FC e-15 e-233))) (cond ((equal? sc3 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-17 e-235)) (else 0)))) (else 0)))))))(else 0)))))) ((4) (let ((e-20 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 4))) (case (vector-ref arg-1 0) ((4) (let ((e-238 (vector-ref arg-1 2))) (let ((e-240 (vector-ref arg-1 4))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-20 e-238))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-22 e-240)) (else 0))))))(else 0))))) ((5) (let ((e-25 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 7))) (case (vector-ref arg-1 0) ((5) (let ((e-243 (vector-ref arg-1 2))) (let ((e-248 (vector-ref arg-1 7))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-25 e-243))) (cond ((equal? sc2 1) (IdrisC-45Error-u--C-61C-61_Eq_Error e-30 e-248)) (else 0))))))(else 0))))) ((6) (let ((e-32 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((6) (let ((e-250 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-32 e-250)))(else 0)))) ((7) (let ((e-35 (vector-ref arg-0 1))) (let ((e-36 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((7) (let ((e-253 (vector-ref arg-1 1))) (let ((e-254 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-35 e-253))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-36 e-254)) (else 0))))))(else 0))))) ((8) (let ((e-37 (vector-ref arg-0 1))) (let ((e-38 (vector-ref arg-0 2))) (let ((e-39 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((8) (let ((e-255 (vector-ref arg-1 1))) (let ((e-256 (vector-ref arg-1 2))) (let ((e-257 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-37 e-255))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-38 e-256))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-1817 e-39 e-257)) (else 0)))) (else 0)))))))(else 0)))))) ((9) (let ((e-40 (vector-ref arg-0 1))) (let ((e-41 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((9) (let ((e-258 (vector-ref arg-1 1))) (let ((e-259 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-40 e-258))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-41 e-259)) (else 0))))))(else 0))))) ((10) (let ((e-42 (vector-ref arg-0 1))) (let ((e-43 (vector-ref arg-0 2))) (let ((e-44 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((10) (let ((e-260 (vector-ref arg-1 1))) (let ((e-261 (vector-ref arg-1 2))) (let ((e-262 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-42 e-260))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-43 e-261))) (cond ((equal? sc3 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-44 e-262)) (else 0)))) (else 0)))))))(else 0)))))) ((11) (let ((e-45 (vector-ref arg-0 1))) (let ((e-46 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((11) (let ((e-263 (vector-ref arg-1 1))) (let ((e-264 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-45 e-263))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-46 e-264)) (else 0))))))(else 0))))) ((12) (let ((e-48 (vector-ref arg-0 1))) (let ((e-49 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((12) (let ((e-266 (vector-ref arg-1 1))) (let ((e-267 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-48 e-266))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-49 e-267)) (else 0))))))(else 0))))) ((13) (let ((e-51 (vector-ref arg-0 1))) (let ((e-52 (vector-ref arg-0 2))) (let ((e-53 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((13) (let ((e-269 (vector-ref arg-1 1))) (let ((e-270 (vector-ref arg-1 2))) (let ((e-271 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-51 e-269))) (cond ((equal? sc2 1) (let ((sc3 (or (and (= e-52 e-270) 1) 0))) (cond ((equal? sc3 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-53 e-271)) (else 0)))) (else 0)))))))(else 0)))))) ((14) (let ((e-54 (vector-ref arg-0 1))) (let ((e-55 (vector-ref arg-0 2))) (let ((e-56 (vector-ref arg-0 3))) (let ((e-57 (vector-ref arg-0 4))) (case (vector-ref arg-1 0) ((14) (let ((e-272 (vector-ref arg-1 1))) (let ((e-273 (vector-ref arg-1 2))) (let ((e-274 (vector-ref arg-1 3))) (let ((e-275 (vector-ref arg-1 4))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-54 e-272))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-55 e-273))) (cond ((equal? sc3 1) (let ((sc4 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-56 e-274))) (cond ((equal? sc4 1) (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-57 e-275)) (else 0)))) (else 0)))) (else 0))))))))(else 0))))))) ((15) (let ((e-59 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((15) (let ((e-277 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-59 e-277)))(else 0)))) ((16) (let ((e-64 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((16) (let ((e-282 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-64 e-282)))(else 0)))) ((17) (let ((e-67 (vector-ref arg-0 1))) (let ((e-68 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((17) (let ((e-285 (vector-ref arg-1 1))) (let ((e-286 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-67 e-285))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-832 e-68 e-286)) (else 0))))))(else 0))))) ((18) (let ((e-70 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((18) (let ((e-288 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-70 e-288)))(else 0)))) ((19) (let ((e-74 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((19) (let ((e-292 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-74 e-292)))(else 0)))) ((20) (let ((e-78 (vector-ref arg-0 1))) (let ((e-79 (vector-ref arg-0 2))) (let ((e-80 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((20) (let ((e-296 (vector-ref arg-1 1))) (let ((e-297 (vector-ref arg-1 2))) (let ((e-298 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-78 e-296))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-79 e-297))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-832 e-80 e-298)) (else 0)))) (else 0)))))))(else 0)))))) ((21) (let ((e-81 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((21) (let ((e-299 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-845 (csegen-2282) arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-845 (csegen-2282) arg-686 arg-689)))) e-81 e-299)))(else 0)))) ((22) (let ((e-83 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((22) (let ((e-301 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-83 e-301)))(else 0)))) ((23) (let ((e-85 (vector-ref arg-0 1))) (let ((e-86 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((23) (let ((e-303 (vector-ref arg-1 1))) (let ((e-304 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-85 e-303))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-2546 e-86 e-304)) (else 0))))))(else 0))))) ((24) (let ((e-87 (vector-ref arg-0 1))) (let ((e-88 (vector-ref arg-0 2))) (let ((e-89 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((24) (let ((e-305 (vector-ref arg-1 1))) (let ((e-306 (vector-ref arg-1 2))) (let ((e-307 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-87 e-305))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-88 e-306))) (cond ((equal? sc3 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-832 e-89 e-307)) (else 0)))) (else 0)))))))(else 0)))))) ((25) (let ((e-90 (vector-ref arg-0 1))) (let ((e-91 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((25) (let ((e-308 (vector-ref arg-1 1))) (let ((e-309 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-90 e-308))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-91 e-309)) (else 0))))))(else 0))))) ((26) (let ((e-92 (vector-ref arg-0 1))) (let ((e-93 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((26) (let ((e-310 (vector-ref arg-1 1))) (let ((e-311 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-92 e-310))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 e-93 e-311)) (else 0))))))(else 0))))) ((27) (let ((e-95 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((27) (let ((e-313 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-95 e-313)))(else 0)))) ((28) (let ((e-100 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((28) (let ((e-318 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-100 e-318)))(else 0)))) ((29) (let ((e-104 (vector-ref arg-0 2))) (let ((e-106 (vector-ref arg-0 4))) (case (vector-ref arg-1 0) ((29) (let ((e-322 (vector-ref arg-1 2))) (let ((e-324 (vector-ref arg-1 4))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-104 e-322))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-106 e-324)) (else 0))))))(else 0))))) ((30) (let ((e-109 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((30) (let ((e-327 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-109 e-327)))(else 0)))) ((31) (let ((e-115 (vector-ref arg-0 2))) (let ((e-116 (vector-ref arg-0 3))) (let ((e-117 (vector-ref arg-0 4))) (case (vector-ref arg-1 0) ((31) (let ((e-333 (vector-ref arg-1 2))) (let ((e-334 (vector-ref arg-1 3))) (let ((e-335 (vector-ref arg-1 4))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-115 e-333))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-116 e-334))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-117 e-335)) (else 0)))) (else 0)))))))(else 0)))))) ((32) (let ((e-120 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((32) (let ((e-338 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-3024 e-120 e-338)))(else 0)))) ((33) (let ((e-122 (vector-ref arg-0 2))) (let ((e-124 (vector-ref arg-0 4))) (let ((e-125 (vector-ref arg-0 5))) (case (vector-ref arg-1 0) ((33) (let ((e-340 (vector-ref arg-1 2))) (let ((e-342 (vector-ref arg-1 4))) (let ((e-343 (vector-ref arg-1 5))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-122 e-340))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-124 e-342))) (cond ((equal? sc3 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-125 e-343)) (else 0)))) (else 0)))))))(else 0)))))) ((34) (let ((e-128 (vector-ref arg-0 2))) (let ((e-130 (vector-ref arg-0 4))) (case (vector-ref arg-1 0) ((34) (let ((e-346 (vector-ref arg-1 2))) (let ((e-348 (vector-ref arg-1 4))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-128 e-346))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-130 e-348)) (else 0))))))(else 0))))) ((35) (let ((e-132 (vector-ref arg-0 1))) (let ((e-133 (vector-ref arg-0 2))) (let ((e-134 (vector-ref arg-0 3))) (let ((e-135 (vector-ref arg-0 4))) (let ((e-136 (vector-ref arg-0 5))) (case (vector-ref arg-1 0) ((35) (let ((e-350 (vector-ref arg-1 1))) (let ((e-351 (vector-ref arg-1 2))) (let ((e-352 (vector-ref arg-1 3))) (let ((e-353 (vector-ref arg-1 4))) (let ((e-354 (vector-ref arg-1 5))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-132 e-350))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Visibility e-133 e-351))) (cond ((equal? sc3 1) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-134 e-352))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Visibility e-135 e-353))) (cond ((equal? sc5 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-136 e-354)) (else 0)))) (else 0)))) (else 0)))) (else 0)))))))))(else 0)))))))) ((36) (let ((e-137 (vector-ref arg-0 1))) (let ((e-138 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((36) (let ((e-355 (vector-ref arg-1 1))) (let ((e-356 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-137 e-355))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-138 e-356)) (else 0))))))(else 0))))) ((37) (let ((e-139 (vector-ref arg-0 1))) (let ((e-140 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((37) (let ((e-357 (vector-ref arg-1 1))) (let ((e-358 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-139 e-357))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-140 e-358)) (else 0))))))(else 0))))) ((38) (let ((e-141 (vector-ref arg-0 1))) (let ((e-142 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((38) (let ((e-359 (vector-ref arg-1 1))) (let ((e-360 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-141 e-359))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-142 e-360)) (else 0))))))(else 0))))) ((39) (let ((e-143 (vector-ref arg-0 1))) (let ((e-144 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((39) (let ((e-361 (vector-ref arg-1 1))) (let ((e-362 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-143 e-361))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-144 e-362)) (else 0))))))(else 0))))) ((40) (let ((e-146 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((40) (let ((e-364 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-146 e-364)))(else 0)))) ((41) (let ((e-150 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((41) (let ((e-368 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-150 e-368)))(else 0)))) ((42) (let ((e-155 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((42) (let ((e-373 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-155 e-373)))(else 0)))) ((43) (let ((e-158 (vector-ref arg-0 1))) (let ((e-159 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((43) (let ((e-376 (vector-ref arg-1 1))) (let ((e-377 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-158 e-376))) (cond ((equal? sc2 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-159 e-377)) (else 0))))))(else 0))))) ((44) (let ((e-162 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((44) (let ((e-380 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-162 e-380)))(else 0)))) ((45) (let ((e-166 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((45) (let ((e-384 (vector-ref arg-1 2))) (CoreC-45FC-u--C-61C-61_Eq_FC e-166 e-384)))(else 0)))) ((46) (let ((e-171 (vector-ref arg-0 1))) (let ((e-172 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((46) (let ((e-389 (vector-ref arg-1 1))) (let ((e-390 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-171 e-389))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-172 e-390)) (else 0))))))(else 0))))) ((47) (let ((e-174 (vector-ref arg-0 2))) (let ((e-177 (vector-ref arg-0 5))) (case (vector-ref arg-1 0) ((47) (let ((e-392 (vector-ref arg-1 2))) (let ((e-395 (vector-ref arg-1 5))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-174 e-392))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-177 e-395)) (else 0))))))(else 0))))) ((48) (let ((e-178 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((48) (let ((e-396 (vector-ref arg-1 1))) (IdrisC-45Error-u--C-61C-61_Eq_Error e-178 e-396)))(else 0)))) ((49) (let ((e-179 (vector-ref arg-0 1))) (let ((e-180 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((49) (let ((e-397 (vector-ref arg-1 1))) (let ((e-398 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-179 e-397))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-180 e-398)) (else 0))))))(else 0))))) ((50) (let ((e-181 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((50) (let ((e-399 (vector-ref arg-1 1))) (IdrisC-45Error-u--C-61C-61_Eq_TTCErrorMsg e-181 e-399)))(else 0)))) ((51) (let ((e-182 (vector-ref arg-0 1))) (let ((e-183 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((51) (let ((e-400 (vector-ref arg-1 1))) (let ((e-401 (vector-ref arg-1 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-182 e-400))) (cond ((equal? sc2 1) (IdrisC-45Error-u--C-61C-61_Eq_FileError e-183 e-401)) (else 0))))))(else 0))))) ((52) (let ((e-184 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((52) (let ((e-402 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-184 e-402)))(else 0)))) ((55) (let ((e-185 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((55) (let ((e-403 (vector-ref arg-1 1))) (CoreC-45FC-u--C-61C-61_Eq_FC e-185 e-403)))(else 0)))) ((56) (let ((e-186 (vector-ref arg-0 1))) (let ((e-187 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((56) (let ((e-404 (vector-ref arg-1 1))) (let ((e-405 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-186 e-404))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-187 e-405)) (else 0))))))(else 0))))) ((57) (let ((e-188 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((57) (let ((e-406 (vector-ref arg-1 1))) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 csegen-3015 e-188 e-406)))(else 0)))) ((58) (let ((e-189 (vector-ref arg-0 1))) (let ((e-190 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((58) (let ((e-407 (vector-ref arg-1 1))) (let ((e-408 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-189 e-407))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent e-190 e-408)) (else 0))))))(else 0))))) ((59) (let ((e-191 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((59) (let ((e-409 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-276 e-191 e-409)))(else 0)))) ((60) (case (vector-ref arg-1 0) ((60) 1)(else 0))) ((61) (let ((e-192 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((61) (let ((e-410 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-192 e-410)))(else 0)))) ((62) (let ((e-193 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((62) (let ((e-411 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-193 e-411)))(else 0)))) ((63) (let ((e-194 (vector-ref arg-0 1))) (let ((e-195 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((63) (let ((e-412 (vector-ref arg-1 1))) (let ((e-413 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-194 e-412))) (cond ((equal? sc2 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 e-195 e-413)) (else 0))))))(else 0))))) ((64) (let ((e-196 (vector-ref arg-0 1))) (let ((e-197 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((64) (let ((e-414 (vector-ref arg-1 1))) (let ((e-415 (vector-ref arg-1 2))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-196 e-414))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-197 e-415)) (else 0))))))(else 0))))) ((65) (let ((e-198 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((65) (let ((e-416 (vector-ref arg-1 1))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-198 e-416)))(else 0)))) ((66) (let ((e-199 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((66) (let ((e-417 (vector-ref arg-1 1))) (CoreC-45FC-u--C-61C-61_Eq_FC e-199 e-417)))(else 0)))) ((67) (let ((e-200 (vector-ref arg-0 1))) (let ((e-201 (vector-ref arg-0 2))) (let ((e-202 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((67) (let ((e-418 (vector-ref arg-1 1))) (let ((e-419 (vector-ref arg-1 2))) (let ((e-420 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-200 e-418))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-201 e-419))) (cond ((equal? sc3 1) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 (csegen-2282) e-202 e-420)) (else 0)))) (else 0)))))))(else 0)))))) ((68) (let ((e-203 (vector-ref arg-0 1))) (let ((e-204 (vector-ref arg-0 2))) (let ((e-205 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((68) (let ((e-421 (vector-ref arg-1 1))) (let ((e-422 (vector-ref arg-1 2))) (let ((e-423 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-203 e-421))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-204 e-422))) (cond ((equal? sc3 1) (IdrisC-45Error-u--C-61C-61_Eq_Error e-205 e-423)) (else 0)))) (else 0)))))))(else 0)))))) ((69) (let ((e-206 (vector-ref arg-0 1))) (let ((e-207 (vector-ref arg-0 2))) (let ((e-208 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((69) (let ((e-424 (vector-ref arg-1 1))) (let ((e-425 (vector-ref arg-1 2))) (let ((e-426 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-206 e-424))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-207 e-425))) (cond ((equal? sc3 1) (IdrisC-45Error-u--C-61C-61_Eq_Error e-208 e-426)) (else 0)))) (else 0)))))))(else 0)))))) ((70) (let ((e-209 (vector-ref arg-0 1))) (let ((e-210 (vector-ref arg-0 2))) (let ((e-211 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((70) (let ((e-427 (vector-ref arg-1 1))) (let ((e-428 (vector-ref arg-1 2))) (let ((e-429 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-209 e-427))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-210 e-428))) (cond ((equal? sc3 1) (IdrisC-45Error-u--C-61C-61_Eq_Error e-211 e-429)) (else 0)))) (else 0)))))))(else 0)))))) ((71) (let ((e-212 (vector-ref arg-0 1))) (let ((e-213 (vector-ref arg-0 2))) (let ((e-214 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((71) (let ((e-430 (vector-ref arg-1 1))) (let ((e-431 (vector-ref arg-1 2))) (let ((e-432 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_FC e-212 e-430))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-213 e-431))) (cond ((equal? sc3 1) (IdrisC-45Error-u--C-61C-61_Eq_Error e-214 e-432)) (else 0)))) (else 0)))))))(else 0)))))) ((72) (let ((e-215 (vector-ref arg-0 1))) (let ((e-216 (vector-ref arg-0 2))) (case (vector-ref arg-1 0) ((72) (let ((e-433 (vector-ref arg-1 1))) (let ((e-434 (vector-ref arg-1 2))) (let ((sc2 (IdrisC-45Error-u--C-61C-61_Eq_Error e-215 e-433))) (cond ((equal? sc2 1) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 csegen-22 e-216 e-434)) (else 0))))))(else 0))))) ((73) (let ((e-217 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((73) (let ((e-435 (vector-ref arg-1 1))) (IdrisC-45Error-u--C-61C-61_Eq_Warning e-217 e-435)))(else 0))))(else 0))))
(define IdrisC-45Error-u--C-47C-61_Eq_Error (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45Error-u--C-61C-61_Eq_Error arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-2282 (lambda () (cons (lambda (arg-676) (lambda (arg-679) (IdrisC-45Error-u--C-61C-61_Eq_Error arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (IdrisC-45Error-u--C-47C-61_Eq_Error arg-686 arg-689))))))
(define csegen-2286 (lambda (clam-0) (lambda (clam-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe clam-0 clam-1))))
(define csegen-2287 (lambda (eta-0) (let ((e-13 (vector-ref eta-0 13))) e-13)))
(define CoreC-45TerminationC-45SizeChange-u--C-61C-61_Eq_Graph (lambda (arg-0 arg-1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-1044 (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0))))
(define CoreC-45TerminationC-45SizeChange-u--C-47C-61_Eq_Graph (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TerminationC-45SizeChange-u--C-61C-61_Eq_Graph arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-2291 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45TerminationC-45SizeChange-u--C-61C-61_Eq_Graph arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45TerminationC-45SizeChange-u--C-47C-61_Eq_Graph arg-686 arg-689)))))
(define DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 (DataC-45List1-forget arg-2) (DataC-45List1-forget arg-3))))
(define DataC-45List1-u--C-60C-61_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define DataC-45List1-u--C-60_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define DataC-45List1-u--C-62C-61_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define DataC-45List1-u--C-62_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define DataC-45List1-u--max_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (DataC-45List1-u--C-62_Ord_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define DataC-45List1-u--min_Ord_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (DataC-45List1-u--C-60_Ord_C-40List1C-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define AlgebraC-45SizeChange-u--compare_Ord_SizeChange (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else (cond ((equal? arg-1 2) 2)(else (cond ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else (cond ((equal? arg-1 1) 2)(else (cond (else (cond (else 1))))))))))))))
(define AlgebraC-45SizeChange-u--C-60C-61_Ord_SizeChange (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (AlgebraC-45SizeChange-u--compare_Ord_SizeChange arg-0 arg-1) 2)))
(define AlgebraC-45SizeChange-u--C-60_Ord_SizeChange (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (AlgebraC-45SizeChange-u--compare_Ord_SizeChange arg-0 arg-1) 0)))
(define AlgebraC-45SizeChange-u--C-62C-61_Ord_SizeChange (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (AlgebraC-45SizeChange-u--compare_Ord_SizeChange arg-0 arg-1) 0)))
(define AlgebraC-45SizeChange-u--C-62_Ord_SizeChange (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (AlgebraC-45SizeChange-u--compare_Ord_SizeChange arg-0 arg-1) 2)))
(define AlgebraC-45SizeChange-u--max_Ord_SizeChange (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) arg-1) ((equal? arg-0 1) (cond ((equal? arg-1 2) 1)(else arg-1))) (else 0))))
(define AlgebraC-45SizeChange-u--min_Ord_SizeChange (lambda (arg-0 arg-1) (let ((sc0 (AlgebraC-45SizeChange-u--C-60_Ord_SizeChange arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-2307 (vector csegen-1035 (lambda (arg-1566) (lambda (arg-1569) (AlgebraC-45SizeChange-u--compare_Ord_SizeChange arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (AlgebraC-45SizeChange-u--C-60_Ord_SizeChange arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (AlgebraC-45SizeChange-u--C-62_Ord_SizeChange arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (AlgebraC-45SizeChange-u--C-60C-61_Ord_SizeChange arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (AlgebraC-45SizeChange-u--C-62C-61_Ord_SizeChange arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (AlgebraC-45SizeChange-u--max_Ord_SizeChange arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (AlgebraC-45SizeChange-u--min_Ord_SizeChange arg-1626 arg-1629)))))
(define csegen-2315 (vector csegen-1038 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2307 arg-1626 arg-1629)))))
(define csegen-2323 (vector csegen-1041 (lambda (arg-1566) (lambda (arg-1569) (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (DataC-45List1-u--C-60_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (DataC-45List1-u--C-62_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (DataC-45List1-u--C-60C-61_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (DataC-45List1-u--C-62C-61_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (DataC-45List1-u--max_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (DataC-45List1-u--min_Ord_C-40List1C-32C-36aC-41 csegen-2315 arg-1626 arg-1629)))))
(define CoreC-45TerminationC-45SizeChange-u--compare_Ord_Graph (lambda (arg-0 arg-1) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 (vector csegen-1044 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-2323 arg-1626 arg-1629)))) (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0))))
(define CoreC-45TerminationC-45SizeChange-u--C-60C-61_Ord_Graph (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TerminationC-45SizeChange-u--compare_Ord_Graph arg-0 arg-1) 2)))
(define CoreC-45TerminationC-45SizeChange-u--C-60_Ord_Graph (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TerminationC-45SizeChange-u--compare_Ord_Graph arg-0 arg-1) 0)))
(define CoreC-45TerminationC-45SizeChange-u--C-62C-61_Ord_Graph (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TerminationC-45SizeChange-u--compare_Ord_Graph arg-0 arg-1) 0)))
(define CoreC-45TerminationC-45SizeChange-u--C-62_Ord_Graph (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TerminationC-45SizeChange-u--compare_Ord_Graph arg-0 arg-1) 2)))
(define CoreC-45TerminationC-45SizeChange-u--max_Ord_Graph (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TerminationC-45SizeChange-u--C-62_Ord_Graph arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45TerminationC-45SizeChange-u--min_Ord_Graph (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TerminationC-45SizeChange-u--C-60_Ord_Graph arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-2299 (vector csegen-2291 (lambda (arg-1566) (lambda (arg-1569) (CoreC-45TerminationC-45SizeChange-u--compare_Ord_Graph arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45TerminationC-45SizeChange-u--C-60_Ord_Graph arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45TerminationC-45SizeChange-u--C-62_Ord_Graph arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45TerminationC-45SizeChange-u--C-60C-61_Ord_Graph arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45TerminationC-45SizeChange-u--C-62C-61_Ord_Graph arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45TerminationC-45SizeChange-u--max_Ord_Graph arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45TerminationC-45SizeChange-u--min_Ord_Graph arg-1626 arg-1629)))))
(define csegen-2334 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-832 csegen-2291 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-832 csegen-2291 arg-686 arg-689)))))
(define csegen-2345 (vector csegen-2334 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2299 arg-1626 arg-1629)))))
(define AlgebraC-45SizeChange-u--plusNeutral_Semiring_SizeChange 2)
(define AlgebraC-45SizeChange-u--neutral_Monoid_SizeChange 1)
(define AlgebraC-45SizeChange-u--timesNeutral_Semiring_SizeChange AlgebraC-45SizeChange-u--neutral_Monoid_SizeChange)
(define AlgebraC-45SizeChange-u--C-60C-43C-62_Semigroup_SizeChange (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) 2) ((equal? arg-0 1) arg-1)(else (cond ((equal? arg-1 2) 2)(else (cond (else 0))))))))
(define AlgebraC-45SizeChange-u--C-124C-42C-124_Semiring_SizeChange (lambda (ext-0 ext-1) (AlgebraC-45SizeChange-u--C-60C-43C-62_Semigroup_SizeChange ext-0 ext-1)))
(define AlgebraC-45SizeChange-u--C-124C-43C-124_Semiring_SizeChange (lambda (ext-0 ext-1) (AlgebraC-45SizeChange-u--max_Ord_SizeChange ext-0 ext-1)))
(define csegen-2362 (cons csegen-1035 (vector (lambda (arg-823) (lambda (arg-826) (AlgebraC-45SizeChange-u--C-124C-43C-124_Semiring_SizeChange arg-823 arg-826))) AlgebraC-45SizeChange-u--plusNeutral_Semiring_SizeChange (lambda (arg-835) (lambda (arg-838) (AlgebraC-45SizeChange-u--C-124C-42C-124_Semiring_SizeChange arg-835 arg-838))) AlgebraC-45SizeChange-u--timesNeutral_Semiring_SizeChange)))
(define CoreC-45Context-u--full_HasNames_Terminating (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((2) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45Context-u--full_HasNames_PartialReason arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-5))))) eff-0) ext-0)))))))(else (vector 1 arg-1)))))
(define csegen-2365 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Terminating arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Terminating arg-7729 arg-7732 eta-0))))))
(define CoreC-45NameC-45Namespace-builtinNS (CoreC-45NameC-45Namespace-mkNamespace "Builtin"))
(define csegen-2366 (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "assert_total"))))
(define CoreC-45TerminationC-45CallGraph-sizeEq (lambda (arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-52 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((0) (let ((e-81 (vector-ref arg-4 3))) (or (and (= e-52 e-81) 1) 0)))(else (case (vector-ref arg-4 0) ((5) (let ((e-46 (vector-ref arg-4 3))) (let ((e-47 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-46))) (cond ((equal? sc2 1) 1) (else (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-47)))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-14 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((6) (let ((e-30 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-14 e-30)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((7) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (let ((sc3 (CoreC-45TerminationC-45CallGraph-sizeEq e-18 e-34))) (cond ((equal? sc3 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-19 e-35)) (else 0))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-23 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-39 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-23 e-39)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-26 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((9) (let ((e-42 (vector-ref arg-4 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-42)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))))))) ((1) (let ((e-57 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((1) (let ((e-86 (vector-ref arg-4 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-57 e-86)))(else (case (vector-ref arg-4 0) ((5) (let ((e-46 (vector-ref arg-4 3))) (let ((e-47 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-46))) (cond ((equal? sc2 1) 1) (else (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-47)))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-14 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((6) (let ((e-30 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-14 e-30)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((7) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (let ((sc3 (CoreC-45TerminationC-45CallGraph-sizeEq e-18 e-34))) (cond ((equal? sc3 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-19 e-35)) (else 0))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-23 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-39 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-23 e-39)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-26 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((9) (let ((e-42 (vector-ref arg-4 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-42)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))))))) ((2) (let ((e-61 (vector-ref arg-3 3))) (let ((e-62 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((2) (let ((e-90 (vector-ref arg-4 3))) (let ((e-91 (vector-ref arg-4 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-61 e-90))) (cond ((equal? sc2 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (PreludeC-45Basics-uncurry (csegen-2367) eta-0)) (DataC-45List-u--zip_Zippable_List e-62 e-91))) (else 0))))))(else (case (vector-ref arg-4 0) ((5) (let ((e-46 (vector-ref arg-4 3))) (let ((e-47 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-46))) (cond ((equal? sc2 1) 1) (else (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-47)))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-14 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((6) (let ((e-30 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-14 e-30)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((7) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (let ((sc3 (CoreC-45TerminationC-45CallGraph-sizeEq e-18 e-34))) (cond ((equal? sc3 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-19 e-35)) (else 0))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-23 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-39 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-23 e-39)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-26 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((9) (let ((e-42 (vector-ref arg-4 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-42)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))))))) ((3) (let ((e-66 (vector-ref arg-3 3))) (let ((e-67 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((3) (let ((e-95 (vector-ref arg-4 3))) (let ((e-96 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TTC-45Binder-eqBinderBy (csegen-2367) e-66 e-95))) (cond ((equal? sc2 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-67 e-96)) (else 0))))))(else (case (vector-ref arg-4 0) ((5) (let ((e-46 (vector-ref arg-4 3))) (let ((e-47 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-46))) (cond ((equal? sc2 1) 1) (else (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-47)))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-14 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((6) (let ((e-30 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-14 e-30)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((7) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (let ((sc3 (CoreC-45TerminationC-45CallGraph-sizeEq e-18 e-34))) (cond ((equal? sc3 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-19 e-35)) (else 0))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-23 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-39 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-23 e-39)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-26 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((9) (let ((e-42 (vector-ref arg-4 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-42)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))))))) ((4) (let ((e-70 (vector-ref arg-3 2))) (let ((e-71 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((4) (let ((e-99 (vector-ref arg-4 2))) (let ((e-100 (vector-ref arg-4 3))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq e-70 e-99))) (cond ((equal? sc2 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-71 e-100)) (else 0))))))(else (case (vector-ref arg-4 0) ((5) (let ((e-46 (vector-ref arg-4 3))) (let ((e-47 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-46))) (cond ((equal? sc2 1) 1) (else (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-47)))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-14 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((6) (let ((e-30 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-14 e-30)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((7) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (let ((sc3 (CoreC-45TerminationC-45CallGraph-sizeEq e-18 e-34))) (cond ((equal? sc3 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-19 e-35)) (else 0))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-23 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-39 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-23 e-39)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-26 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((9) (let ((e-42 (vector-ref arg-4 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-42)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))))))) ((5) (let ((e-76 (vector-ref arg-3 4))) (CoreC-45TerminationC-45CallGraph-sizeEq e-76 arg-4)))(else (case (vector-ref arg-4 0) ((5) (let ((e-46 (vector-ref arg-4 3))) (let ((e-47 (vector-ref arg-4 4))) (let ((sc1 (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-46))) (cond ((equal? sc1 1) 1) (else (CoreC-45TerminationC-45CallGraph-sizeEq arg-3 e-47)))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-14 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((6) (let ((e-30 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-14 e-30)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((7) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((7) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45TerminationC-45CallGraph-sizeEq e-18 e-34))) (cond ((equal? sc2 1) (CoreC-45TerminationC-45CallGraph-sizeEq e-19 e-35)) (else 0))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-23 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-39 (vector-ref arg-4 3))) (CoreC-45TerminationC-45CallGraph-sizeEq e-23 e-39)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0)))))))) ((9) (let ((e-26 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((9) (let ((e-42 (vector-ref arg-4 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-42)))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-8 (vector-ref arg-4 2))) (case (vector-ref e-8 0) ((2) (let ((e-10 (vector-ref e-8 1))) (CoreC-45TTC-45Term-eqTerm arg-3 e-10)))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))(else (case (vector-ref arg-3 0) ((11) (case (vector-ref arg-4 0) ((11) 1)(else 0)))(else 0))))))))))))
(define csegen-2367 (lambda () (lambda (eta-0) (lambda (eta-1) (CoreC-45TerminationC-45CallGraph-sizeEq eta-0 eta-1)))))
(define csegen-2373 (vector 0 csegen-30))
(define TTImpC-45ElabC-45Check-u--C-61C-61_Eq_ElabOpt (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define TTImpC-45ElabC-45Check-u--C-47C-61_Eq_ElabOpt (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45ElabC-45Check-u--C-61C-61_Eq_ElabOpt arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-2376 (cons (lambda (arg-676) (lambda (arg-679) (TTImpC-45ElabC-45Check-u--C-61C-61_Eq_ElabOpt arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (TTImpC-45ElabC-45Check-u--C-47C-61_Eq_ElabOpt arg-686 arg-689)))))
(define AlgebraC-45ZeroOneOmega-u--C-60C-61_Preorder_ZeroOneOmega (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 1) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else (cond ((equal? arg-1 2) 1)(else 0)))))(else (cond ((equal? arg-1 2) 1)(else 0))))))
(define AlgebraC-45ZeroOneOmega-u--preorderRefl_Preorder_ZeroOneOmega (lambda (arg-0) (cond ((equal? arg-0 0) (vector 0 )) ((equal? arg-0 1) (vector 0 )) (else (vector 0 )))))
(define AlgebraC-45ZeroOneOmega-u--preorderTrans_Preorder_ZeroOneOmega (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-0 0) (vector 0 )) ((equal? arg-0 1) (cond ((equal? arg-1 1) arg-4) (else (cond ((equal? arg-2 1) (vector 0 )) (else (vector 0 )))))) (else (cond (else arg-4))))))
(define csegen-2382 (vector (lambda (arg-823) (lambda (arg-826) (AlgebraC-45ZeroOneOmega-u--C-60C-61_Preorder_ZeroOneOmega arg-823 arg-826))) (lambda (u--x) (AlgebraC-45ZeroOneOmega-u--preorderRefl_Preorder_ZeroOneOmega u--x)) (lambda (u--x) (lambda (u--y) (lambda (u--z) (lambda (arg-847) (lambda (arg-853) (AlgebraC-45ZeroOneOmega-u--preorderTrans_Preorder_ZeroOneOmega u--x u--y u--z arg-847 arg-853))))))))
(define CoreC-45Reflect-builtin (lambda (arg-0) (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 arg-0)))))
(define CoreC-45Context-lookupExactBy (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-2 arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (vector 1 (box (arg-1 e-1)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-lookupDefExact (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupExactBy csegen-1315 ext-2 ext-1 ext-0)))
(define CoreC-45Reflect-getCon (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-lookupDefExact arg-3 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 arg-1 arg-3) eta-0)) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((5) (let ((e-2 (vector-ref e-1 1))) (let ((e-3 (vector-ref e-1 2))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 1 arg-1 (vector 2 e-2 e-3) arg-3))))) ((6) (let ((e-13 (vector-ref e-1 1))) (let ((e-6 (vector-ref e-1 2))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 1 arg-1 (vector 3 e-13 e-6) arg-3)))))(else (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 1 arg-1 (vector 1 ) arg-3)))))))) eff-0) ext-0)))))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-builtin "MkUnit") ext-0)))
(define csegen-2384 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124UnitC-44MkUnitC-124C-41 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))))
(define CoreC-45Reflect-appCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 (let ((e-0 (vector-ref arg-2 0))) e-0) (CoreC-45TTC-45Term-apply arg-1 e-5 arg-4)))) eff-0) ext-0)))))))
(define CoreC-45NameC-45Namespace-reflectionTTImpNS (CoreC-45NameC-45Namespace-mkNamespace "Language.Reflection.TTImp"))
(define CoreC-45Reflect-reflectionttimp (lambda (arg-0) (vector 0 CoreC-45NameC-45Namespace-reflectionTTImpNS (vector 1 (vector 0 arg-0)))))
(define CoreC-45NameC-45Namespace-basicsNS (CoreC-45NameC-45Namespace-mkNamespace "Prelude.Basics"))
(define CoreC-45Reflect-basics (lambda (arg-0) (vector 0 CoreC-45NameC-45Namespace-basicsNS (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-basics "Nil") (cons (vector 10 arg-3 (vector 0 )) '()) clam-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-1 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 arg-1 u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792))))))))) (lambda (arg-0) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) (lambda (arg-11) ((((((eff-0 arg-2) arg-0) arg-8) arg-9) arg-10) arg-11))))))) arg-3) arg-4) arg-5) arg-6) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-basics "::") (cons (vector 10 arg-3 (vector 0 )) (cons e-5 (cons e-6 '()))) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))
(define CoreC-45Reflect-preludetypes (lambda (arg-0) (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-preludetypes "Nothing") (cons (vector 10 arg-3 (vector 0 )) '()) clam-0) (let ((e-2 (unbox arg-7))) (let ((act-1 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-preludetypes "Just") (cons (vector 10 arg-3 (vector 0 )) (cons e-5 '())) eta-0)))) eff-0) clam-0))))))))))
(define CoreC-45NameC-45Namespace-reflectionTTNS (CoreC-45NameC-45Namespace-mkNamespace "Language.Reflection.TT"))
(define CoreC-45Reflect-reflectiontt (lambda (arg-0) (vector 0 CoreC-45NameC-45Namespace-reflectionTTNS (vector 1 (vector 0 arg-0)))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "ImplicitArg") (cons (vector 10 arg-3 (vector 0 )) '()) clam-0)) ((1) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "ExplicitArg") (cons (vector 10 arg-3 (vector 0 )) '()) clam-0)) ((2) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "AutoImplicit") (cons (vector 10 arg-3 (vector 0 )) '()) clam-0)) (else (let ((e-4 (vector-ref arg-7 1))) (let ((act-1 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-reflectiontt "DefImplicit") (cons (vector 10 arg-3 (vector 0 )) (cons e-5 '())) eta-0)))) eff-0) clam-0)))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_AltType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "FirstSuccess") ext-0)) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Unique") ext-0)) (else (let ((e-3 (vector-ref arg-5 1))) (let ((act-1 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UniqueDefault") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_RigCount (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (AlgebraC-45Semiring-elimSemi csegen-931 (lambda (eta-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "M0") eta-0)) (lambda (eta-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "M1") eta-0)) (lambda (eta-0) (lambda (eta-1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MW") eta-1))) arg-5)))
(define TTImpC-45Reflect-u--reflect_Reflect_BindMode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "PI") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "PATTERN") ext-0)) ((2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "COVERAGE") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NONE") ext-0)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bool (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-basics "True") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-basics "False") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits16 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 7 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits32 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 8 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits64 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 9 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Bits8 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 6 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Char (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 11 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Double (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 12 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 0 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int16 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 2 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int32 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 3 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int64 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 4 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Int8 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 1 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Integer (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 5 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_PrimType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "IntType") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int8Type") clam-0)) ((equal? arg-5 2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int16Type") clam-0)) ((equal? arg-5 3) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int32Type") clam-0)) ((equal? arg-5 4) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Int64Type") clam-0)) ((equal? arg-5 5) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "IntegerType") clam-0)) ((equal? arg-5 6) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits8Type") clam-0)) ((equal? arg-5 7) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits16Type") clam-0)) ((equal? arg-5 8) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits32Type") clam-0)) ((equal? arg-5 9) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bits64Type") clam-0)) ((equal? arg-5 10) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "StringType") clam-0)) ((equal? arg-5 11) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "CharType") clam-0)) ((equal? arg-5 12) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "DoubleType") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "WorldType") clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_String (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (vector 1 (vector 9 arg-1 (vector 10 arg-5)))))
(define CoreC-45Reflect-u--reflect_Reflect_Constant (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int8 arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I8") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((2) (let ((e-2 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int16 arg-0 arg-1 arg-2 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I16") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int32 arg-0 arg-1 arg-2 arg-3 arg-4 e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I32") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((4) (let ((e-4 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int64 arg-0 arg-1 arg-2 arg-3 arg-4 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "I64") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((5) (let ((e-5 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Integer arg-0 arg-1 arg-2 arg-3 arg-4 e-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "BI") (cons e-6 '()) eta-0)))) eff-0) clam-0))))))) ((6) (let ((e-6 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Bits8 arg-0 arg-1 arg-2 arg-3 arg-4 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B8") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((7) (let ((e-7 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Bits16 arg-0 arg-1 arg-2 arg-3 arg-4 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B16") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((8) (let ((e-8 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Bits32 arg-0 arg-1 arg-2 arg-3 arg-4 e-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B32") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((9) (let ((e-9 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Bits64 arg-0 arg-1 arg-2 arg-3 arg-4 e-9 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "B64") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((10) (let ((e-10 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Str") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((11) (let ((e-11 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Char arg-0 arg-1 arg-2 arg-3 arg-4 e-11 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Ch") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((12) (let ((e-12 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Double arg-0 arg-1 arg-2 arg-3 arg-4 e-12 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Db") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((13) (let ((e-13 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_PrimType arg-0 arg-1 arg-2 arg-3 arg-4 e-13) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PrT") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "WorldVal") clam-0))))))
(define TTImpC-45Reflect-u--reflect_Reflect_DotReason (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NonLinearVar") ext-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "VarApplied") ext-0)) ((equal? arg-5 2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NotConstructor") ext-0)) ((equal? arg-5 3) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ErasedArg") ext-0)) ((equal? arg-5 4) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UserDotted") ext-0)) ((equal? arg-5 5) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UnknownDot") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UnderAppliedCon") ext-0)))))
(define csegen-2466 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (vars-0) (lambda (arg-1781) (lambda (arg-1784) (lambda (onLHS-0) (lambda (arg-1789) (lambda (arg-1793) (lambda (eta-0) (CoreC-45Reflect-u--reflect_Reflect_String vars-0 arg-1781 arg-1784 onLHS-0 arg-1789 arg-1793 eta-0)))))))) u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792))))))))
(define CoreC-45Reflect-u--reflect_Reflect_ModuleIdent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (((((((let ((eff-0 csegen-2466)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkMI") (cons e-5 '()) eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Reflect-u--reflect_Reflect_VirtualIdent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Interactive") ext-0)))
(define CoreC-45Reflect-u--reflect_Reflect_OriginDesc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_ModuleIdent arg-0 arg-1 arg-2 arg-3 arg-4 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PhysicalIdrSrc") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PhysicalPkgSrc") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) (else (let ((e-2 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_VirtualIdent arg-0 arg-1 arg-2 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Virtual") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((act-1 (((((((let ((eff-0 (Builtin-fst arg-2))) (lambda (arg-0) (lambda (arg-1) (lambda (arg-9) (lambda (arg-10) (lambda (arg-11) ((((((eff-0 arg-3) arg-0) arg-1) arg-9) arg-10) arg-11))))))) arg-4) arg-5) arg-6) arg-7) e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 (Builtin-snd arg-2))) (lambda (arg-0) (lambda (arg-1) (lambda (arg-9) (lambda (arg-10) (lambda (arg-11) ((((((eff-0 arg-3) arg-0) arg-1) arg-9) arg-10) arg-11))))))) arg-4) arg-5) arg-6) arg-7) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-3 arg-4 arg-5 (CoreC-45Reflect-builtin "MkPair") (cons (vector 10 arg-4 (vector 0 )) (cons (vector 10 arg-4 (vector 0 )) (cons e-5 (cons e-6 '())))) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define csegen-2468 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-0) (CoreC-45Reflect-u--reflect_Reflect_Int u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-0)))))))))
(define csegen-2470 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-0) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2468 csegen-2468) u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-0)))))))))
(define CoreC-45Reflect-u--reflect_Reflect_FC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-3 1) (lambda (eta-0) (vector 1 (vector 10 arg-1 (vector 0 )))))(else (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_OriginDesc arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 csegen-2470)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((((((let ((eff-0 csegen-2470)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-2) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkFC") (cons e-5 (cons e-6 (cons e-7 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((1) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_OriginDesc arg-0 arg-1 arg-2 arg-3 arg-4 e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 csegen-2470)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((((((let ((eff-0 csegen-2470)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkFC") (cons e-6 (cons e-7 (cons e-8 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "EmptyFC") clam-0))))))))
(define csegen-2398 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_String eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_IFieldUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2398 arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ISetField") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2398 arg-0 arg-1 arg-2 arg-3 arg-4 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ISetFieldApp") (cons e-6 (cons e-7 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_LazyReason (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "LInf") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "LLazy") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "LUnknown") clam-0))))))
(define CoreC-45Reflect-cantReflect (lambda (arg-1 arg-2 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append "Can't reflect as " arg-2)) ext-0)))
(define CoreC-45Reflect-u--reflect_Reflect_Namespace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (((((((let ((eff-0 csegen-2466)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkNS") (cons e-5 '()) eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Reflect-u--reflect_Reflect_UserName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Basic") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Field") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) (else (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Underscore") '() clam-0))))))
(define csegen-2467 (lambda () (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (CoreC-45Reflect-u--reflect_Reflect_Name u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792)))))))))
(define CoreC-45Reflect-u--reflect_Reflect_Name (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_UserName arg-0 arg-1 arg-2 arg-3 arg-4 e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "UN") (cons e-5 '()) eta-0)))) eff-0) clam-0))))))) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MN") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((0) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Namespace arg-0 arg-1 arg-2 arg-3 arg-4 e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 (csegen-2467))) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "NS") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((4) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 (csegen-2467))) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "DN") (cons e-7 (cons e-8 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((5) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((act-1 (((((((let ((eff-0 csegen-2470)) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((let ((eff-0 (csegen-2467))) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Nested") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((6) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-9 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "CaseBlock") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((7) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-11 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-12 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "WithBlock") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((8) (let ((e-13 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 8 e-13) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((8) (lambda (eta-0) (CoreC-45Reflect-cantReflect arg-1 "Name directly, Resolved is intentionally internal" eta-0)))(else ((((((let ((eff-0 (csegen-2467))) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-5))))) eff-0) clam-0)))))))(else (CoreC-45Reflect-cantReflect arg-1 "Name, reflecting it is unimplemented or intentionally internal" clam-0))))))
(define CoreC-45Reflect-u--reflect_Reflect_Nat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-5 0) (lambda (eta-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-preludetypes "Z") eta-0)))(else (let ((e-0 (- arg-5 1))) (lambda (eta-0) (let ((act-1 (((((((let ((eff-0 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (CoreC-45Reflect-u--reflect_Reflect_Nat u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792))))))))) (lambda (arg-6) (lambda (arg-7) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) ((((((eff-0 arg-0) arg-6) arg-7) arg-8) arg-9) arg-10))))))) arg-1) arg-2) arg-3) arg-4) e-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-preludetypes "S") (cons e-5 '()) eta-1)))) eff-0) eta-0)))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_UseSide (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UseLeft") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UseRight") ext-0)))))
(define csegen-2387 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_Name eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))
(define csegen-2430 (lambda () (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (TTImpC-45Reflect-u--reflect_Reflect_RawImp u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792)))))))))
(define CoreC-45Reflect-u--reflect_Reflect_TotalReq (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Total") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "CoveringOnly") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "PartialOK") clam-0))))))
(define TTImpC-45Reflect-u--reflect_Reflect_FnOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Unsafe") ext-0)) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Inline") ext-0)) ((2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NoInline") ext-0)) ((3) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Deprecate") ext-0)) ((4) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "TCInline") ext-0)) ((5) (let ((e-6 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Hint") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((6) (let ((e-8 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "GlobalHint") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((7) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ExternFn") ext-0)) ((8) (let ((e-11 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ForeignFn") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((9) (let ((e-13 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-13) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ForeignExport") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((10) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Invertible") ext-0)) ((11) (let ((e-16 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_TotalReq arg-0 arg-1 arg-2 arg-3 arg-4 e-16) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Totality") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((12) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Macro") ext-0)) (else (let ((e-19 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2387 arg-0 arg-1 arg-2 arg-3 arg-4 e-19) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "SpecArgs") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))))))
(define csegen-2431 (lambda () (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_FnOpt u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-0))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_WithFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Syntactic") ext-0)))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "PatClause") (cons e-5 (cons e-6 (cons e-7 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((e-9 (vector-ref arg-5 5))) (let ((e-10 (vector-ref arg-5 6))) (let ((e-11 (vector-ref arg-5 7))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-7) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-8) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2387 arg-0 arg-1 arg-2 arg-3 arg-4 e-9) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-5) (TTImpC-45Reflect-u--reflect_Reflect_WithFlag u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-5)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-10) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2432) arg-0 arg-1 arg-2 arg-3 arg-4 e-11) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "WithClause") (cons e-12 (cons e-13 (cons e-14 (cons e-15 (cons e-16 (cons e-17 (cons e-18 '()))))))) eta-6)))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))) (else (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-13) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-14) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ImpossibleClause") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define csegen-2432 (lambda () (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_ImpClause u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-0))))))))))
(define LibrariesC-45DataC-45WithDefault-onWithDefault (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (arg-3) (let ((e-4 (unbox arg-5))) (arg-4 e-4)))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (LibrariesC-45DataC-45WithDefault-onWithDefault (lambda () (lambda (eta-0) (CoreC-45Reflect-appCon arg-3 arg-4 arg-5 (CoreC-45Reflect-reflectionttimp "DefaultedValue") (cons (vector 10 arg-4 (vector 0 )) (cons (vector 10 arg-4 (vector 0 )) '())) eta-0))) (lambda (u--x) (lambda (eta-0) (let ((act-1 (((((((arg-2 arg-3) arg-4) arg-5) arg-6) arg-7) u--x) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-3 arg-4 arg-5 (CoreC-45Reflect-reflectionttimp "SpecifiedValue") (cons (vector 10 arg-4 (vector 0 )) (cons (vector 10 arg-4 (vector 0 )) (cons e-5 '()))) eta-1)))) eff-0) eta-0))))))) arg-8)))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkTy") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_DataOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2387 arg-0 arg-1 arg-2 arg-3 arg-4 e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "SearchBy") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NoHints") ext-0)) ((2) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "UniqueSearch") ext-0)) ((3) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "External") ext-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "NoNewtype") ext-0)))))
(define csegen-2447 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_DataOpt u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-0)))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2447 arg-0 arg-1 arg-2 arg-3 arg-4 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-4) (TTImpC-45Reflect-u--reflect_Reflect_ImpTy u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-4)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkData") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) (else (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-9) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkLater") (cons e-5 (cons e-6 (cons e-10 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_IField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkIField") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define csegen-2446 (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2387 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-14) (lambda (eta-15) (lambda (eta-16) (lambda (eta-17) (lambda (eta-18) (lambda (eta-19) (CoreC-45Reflect-u--reflect_Reflect_RigCount eta-14 eta-15 eta-16 eta-17 eta-18 eta-19))))))) (lambda (eta-14) (lambda (eta-15) (lambda (eta-16) (lambda (eta-17) (lambda (eta-18) (lambda (eta-19) (lambda (eta-20) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-21) (lambda (eta-22) (lambda (eta-23) (lambda (eta-24) (lambda (eta-25) (lambda (eta-26) (CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-2430) eta-21 eta-22 eta-23 eta-24 eta-25 eta-26))))))) (csegen-2430)) eta-14 eta-15 eta-16 eta-17 eta-18 eta-19 eta-20))))))))) eta-7 eta-8 eta-9 eta-10 eta-11 eta-12 eta-13))))))))) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6))))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpRecord (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((e-6 (vector-ref arg-5 5))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2446) arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2447 arg-0 arg-1 arg-2 arg-3 arg-4 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-5) (TTImpC-45Reflect-u--reflect_Reflect_IField u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-5)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-6) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "MkRecord") (cons e-7 (cons e-8 (cons e-9 (cons e-10 (cons e-11 (cons e-12 '())))))) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_Visibility (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (cond ((equal? arg-5 0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Private") clam-0)) ((equal? arg-5 1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Export") clam-0)) (else (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Public") clam-0))))))
(define csegen-2449 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_Visibility eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))
(define csegen-2450 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_TotalReq eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_ImpDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_Visibility arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2431) arg-0 arg-1 arg-2 arg-3 arg-4 e-4) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45Reflect-u--reflect_Reflect_ImpTy arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IClaim") (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '()))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (let ((e-10 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-2449 arg-0 arg-1 arg-2 arg-3 arg-4 e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2450 arg-0 arg-1 arg-2 arg-3 arg-4 e-9) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45Reflect-u--reflect_Reflect_ImpData arg-0 arg-1 arg-2 arg-3 arg-4 e-10 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IData") (cons e-5 (cons e-6 (cons e-11 (cons e-12 '())))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((2) (let ((e-12 (vector-ref arg-5 1))) (let ((e-13 (vector-ref arg-5 2))) (let ((e-14 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-12) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2432) arg-0 arg-1 arg-2 arg-3 arg-4 e-14) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IDef") (cons e-5 (cons e-6 (cons e-7 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-16) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2446) arg-0 arg-1 arg-2 arg-3 arg-4 e-17) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2433) arg-0 arg-1 arg-2 arg-3 arg-4 e-18) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IParameters") (cons e-5 (cons e-6 (cons e-7 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((4) (let ((e-20 (vector-ref arg-5 1))) (let ((e-21 (vector-ref arg-5 2))) (let ((e-22 (vector-ref arg-5 3))) (let ((e-23 (vector-ref arg-5 4))) (let ((e-24 (vector-ref arg-5 5))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-20) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2398 arg-0 arg-1 arg-2 arg-3 arg-4 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-2449 arg-0 arg-1 arg-2 arg-3 arg-4 e-22) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2450 arg-0 arg-1 arg-2 arg-3 arg-4 e-23) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45Reflect-u--reflect_Reflect_ImpRecord arg-0 arg-1 arg-2 arg-3 arg-4 e-24 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IRecord") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 '()))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((5) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-28 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-26) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2398 arg-0 arg-1 arg-2 arg-3 arg-4 e-27) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2433) arg-0 arg-1 arg-2 arg-3 arg-4 e-28) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IFail") (cons e-5 (cons e-6 (cons e-7 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-30) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Reflect-u--reflect_Reflect_Namespace arg-0 arg-1 arg-2 arg-3 arg-4 e-31 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2433) arg-0 arg-1 arg-2 arg-3 arg-4 e-32) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "INamespace") (cons e-5 (cons e-6 (cons e-7 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (let ((e-37 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-34) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-35) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-36) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-37) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ITransform") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "Can't reflect a %runElab") ext-0)) ((9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "Can't reflect a pragma") ext-0)) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2398 eta-7 eta-8 eta-9 eta-10 eta-11 eta-12))))))) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (CoreC-45Reflect-u--reflect_Reflect_Nat eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-46) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILog") (cons e-5 '()) eta-0)))) eff-0) ext-0))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "Can't reflect a %builtin") ext-0)))))
(define csegen-2433 (lambda () (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-0) (TTImpC-45Reflect-u--reflect_Reflect_ImpDecl u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-0))))))))))
(define csegen-2438 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (CoreC-45Reflect-u--reflect_Reflect_FC eta-7 eta-8 eta-9 eta-10 eta-11 eta-12))))))) csegen-2387) eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))))
(define TTImpC-45Reflect-u--reflect_Reflect_RawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-11) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-12) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IVar") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((1) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (let ((e-18 (vector-ref arg-5 5))) (let ((e-19 (vector-ref arg-5 6))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-14) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-16) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2387 arg-0 arg-1 arg-2 arg-3 arg-4 e-17) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-18) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-19) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IPi") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '())))))) eta-6)))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((2) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((e-25 (vector-ref arg-5 5))) (let ((e-26 (vector-ref arg-5 6))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-22) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40PiInfoC-32C-36tC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-23) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2387 arg-0 arg-1 arg-2 arg-3 arg-4 e-24) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-25) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-26) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILam") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 '())))))) eta-6)))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((3) (let ((e-28 (vector-ref arg-5 1))) (let ((e-29 (vector-ref arg-5 2))) (let ((e-30 (vector-ref arg-5 3))) (let ((e-31 (vector-ref arg-5 4))) (let ((e-32 (vector-ref arg-5 5))) (let ((e-33 (vector-ref arg-5 6))) (let ((e-34 (vector-ref arg-5 7))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-28) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-29) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_RigCount arg-0 arg-1 arg-2 arg-3 arg-4 e-30) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-31) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-32) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-33) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-7 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-34) eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-7) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILet") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 (cons e-10 (cons e-11 '()))))))) eta-7)))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((4) (let ((e-36 (vector-ref arg-5 1))) (let ((e-37 (vector-ref arg-5 2))) (let ((e-38 (vector-ref arg-5 3))) (let ((e-39 (vector-ref arg-5 4))) (let ((e-40 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-36) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2431) arg-0 arg-1 arg-2 arg-3 arg-4 e-37) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-38) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-39) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2432) arg-0 arg-1 arg-2 arg-3 arg-4 e-40) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ICase") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 '()))))) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((5) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-42) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2433) arg-0 arg-1 arg-2 arg-3 arg-4 e-43) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-44) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ILocal") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((6) (let ((e-50 (vector-ref arg-5 5))) (TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-50))) ((7) (let ((e-52 (vector-ref arg-5 1))) (let ((e-53 (vector-ref arg-5 2))) (let ((e-54 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-52) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-2) (TTImpC-45Reflect-u--reflect_Reflect_IFieldUpdate u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-2)))))))) arg-0 arg-1 arg-2 arg-3 arg-4 e-53) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-54) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IUpdate") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((8) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (let ((e-58 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-56) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-57) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-58) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IApp") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-60 (vector-ref arg-5 1))) (let ((e-61 (vector-ref arg-5 2))) (let ((e-62 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-61) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-62) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IAutoApp") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((10) (let ((e-64 (vector-ref arg-5 1))) (let ((e-65 (vector-ref arg-5 2))) (let ((e-66 (vector-ref arg-5 3))) (let ((e-67 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-64) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-65) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-66) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-67) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "INamedApp") (cons e-5 (cons e-6 (cons e-7 (cons e-8 '())))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((11) (let ((e-69 (vector-ref arg-5 1))) (let ((e-70 (vector-ref arg-5 2))) (let ((e-71 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-69) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-70) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-71) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IWithApp") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((12) (let ((e-73 (vector-ref arg-5 1))) (let ((e-74 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-73) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Nat arg-0 arg-1 arg-2 arg-3 arg-4 e-74) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "ISearch") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((13) (let ((e-76 (vector-ref arg-5 1))) (let ((e-77 (vector-ref arg-5 2))) (let ((e-78 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-76) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45Reflect-u--reflect_Reflect_AltType arg-0 arg-1 arg-2 arg-3 arg-4 e-77 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2430) arg-0 arg-1 arg-2 arg-3 arg-4 e-78) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IAlternative") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((14) (let ((e-80 (vector-ref arg-5 1))) (let ((e-81 (vector-ref arg-5 2))) (let ((e-82 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-80) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-81) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-82) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IRewrite") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((15) (let ((e-85 (vector-ref arg-5 2))) (TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-85))) ((16) (let ((e-87 (vector-ref arg-5 1))) (let ((e-88 (vector-ref arg-5 2))) (let ((e-89 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-87) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45Reflect-u--reflect_Reflect_BindMode arg-0 arg-1 arg-2 arg-3 arg-4 e-88 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-89) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IBindHere") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((17) (let ((e-91 (vector-ref arg-5 1))) (let ((e-92 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-91) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-92 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IBindVar") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((18) (let ((e-94 (vector-ref arg-5 1))) (let ((e-95 (vector-ref arg-5 2))) (let ((e-96 (vector-ref arg-5 3))) (let ((e-97 (vector-ref arg-5 4))) (let ((e-98 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-94) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-95) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Reflect-u--reflect_Reflect_UseSide arg-0 arg-1 arg-2 arg-3 arg-4 e-96 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-97) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-98) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IAs") (cons e-5 (cons e-6 (cons e-7 (cons e-8 (cons e-9 '()))))) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((19) (let ((e-100 (vector-ref arg-5 1))) (let ((e-101 (vector-ref arg-5 2))) (let ((e-102 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-100) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45Reflect-u--reflect_Reflect_DotReason arg-0 arg-1 arg-2 arg-3 arg-4 e-101 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-102) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IMustUnify") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((20) (let ((e-104 (vector-ref arg-5 1))) (let ((e-105 (vector-ref arg-5 2))) (let ((e-106 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-104) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_LazyReason arg-0 arg-1 arg-2 arg-3 arg-4 e-105) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-106) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IDelayed") (cons e-5 (cons e-6 (cons e-7 '()))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((21) (let ((e-108 (vector-ref arg-5 1))) (let ((e-109 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-108) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-109) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IDelay") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((22) (let ((e-111 (vector-ref arg-5 1))) (let ((e-112 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-111) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-112) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IForce") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((23) (let ((e-114 (vector-ref arg-5 1))) (let ((e-115 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-114) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-115) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IQuote") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((24) (let ((e-117 (vector-ref arg-5 1))) (let ((e-118 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-117) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-1 arg-2 arg-3 arg-4 e-118) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IQuoteName") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((25) (let ((e-120 (vector-ref arg-5 1))) (let ((e-121 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-120) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (csegen-2433) arg-0 arg-1 arg-2 arg-3 arg-4 e-121) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IQuoteDecl") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((26) (let ((e-123 (vector-ref arg-5 1))) (let ((e-124 (vector-ref arg-5 2))) (lambda (clam-0) (case (vector-ref e-124 0) ((0) (let ((e-143 (vector-ref e-124 2))) (vector 1 (vector 1 e-123 (vector 0 ) e-143))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't reflect an unquote: escapes should be lifted out") clam-0))))))) ((27) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't reflect a %runElab") eta-0))) ((28) (let ((e-130 (vector-ref arg-5 1))) (let ((e-131 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-130) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Constant arg-0 arg-1 arg-2 arg-3 arg-4 e-131) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IPrimVal") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((29) (let ((e-133 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-133) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IType") (cons e-5 '()) eta-1)))) eff-0) eta-0)))))))) ((30) (let ((e-135 (vector-ref arg-5 1))) (let ((e-136 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-135) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Reflect-u--reflect_Reflect_String arg-0 arg-1 arg-2 arg-3 arg-4 e-136 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IHole") (cons e-5 (cons e-6 '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((31) (let ((e-140 (vector-ref arg-5 3))) (TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-140)))(else (cond ((equal? arg-3 1) (lambda (clam-0) (case (vector-ref arg-5 0) ((32) (vector 1 (vector 10 arg-1 (vector 0 ))))(else (case (vector-ref arg-5 0) ((32) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Implicit") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2438 arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IWithUnambigNames") (cons e-7 (cons e-8 (cons e-9 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))(else (lambda (clam-2) (case (vector-ref arg-5 0) ((32) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-1) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Bool arg-0 arg-1 arg-2 arg-3 arg-4 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "Implicit") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-2)))))))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_FC arg-0 arg-1 arg-2 arg-3 arg-4 e-4) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2438 arg-0 arg-1 arg-2 arg-3 arg-4 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-1 arg-2 arg-3 arg-4 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectionttimp "IWithUnambigNames") (cons e-7 (cons e-8 (cons e-9 '()))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2)))))))))))))))))
(define csegen-2385 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (TTImpC-45Reflect-u--reflect_Reflect_RawImp eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))
(define csegen-2388 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 csegen-2387 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))
(define csegen-2399 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2398 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))))
(define CoreC-45NameC-45Namespace-reflectionNS (CoreC-45NameC-45Namespace-mkNamespace "Language.Reflection"))
(define csegen-2401 (vector 0 CoreC-45NameC-45Namespace-reflectionNS (vector 1 (vector 0 "Elab"))))
(define CoreC-45Value-getLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-6 (vector-ref arg-1 1))) e-6)) ((2) (let ((e-10 (vector-ref arg-1 1))) e-10)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-22 (vector-ref arg-1 1))) e-22)) ((5) (let ((e-27 (vector-ref arg-1 1))) e-27)) ((6) (let ((e-31 (vector-ref arg-1 1))) e-31)) ((7) (let ((e-36 (vector-ref arg-1 1))) e-36)) ((8) (let ((e-41 (vector-ref arg-1 1))) e-41)) ((9) (let ((e-44 (vector-ref arg-1 1))) e-44)) (else (let ((e-47 (vector-ref arg-1 1))) e-47)))))
(define CoreC-45Context-toFullNames (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-1 (car arg-2))) ((e-1 (let ((e-0 (vector-ref e-5 0))) e-0)) arg-3)))) eff-0) ext-0)))))))
(define CoreC-45Context-getSession (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 2))) e-41)))))) eff-0) ext-0)))))))
(define DataC-45These-fromThis (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (box e-2))) ((1) '()) (else (let ((e-8 (vector-ref arg-2 1))) (box e-8))))))
(define CoreC-45OptionsC-45Log-n--6793-7405-u--here (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (DataC-45These-fromThis arg-3))) (if (null? sc0) 0 (let ((e-2 (unbox sc0))) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-0 e-2))))))
(define DataC-45These-fromThat (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) ((1) (let ((e-5 (vector-ref arg-2 1))) (box e-5))) (else (let ((e-9 (vector-ref arg-2 2))) (box e-9))))))
(define LibrariesC-45DataC-45StringMap-treeLookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 e-1))) (cond ((equal? sc1 1) (box e-2)) (else '())))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-6))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-5)) (else (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-7)))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-11))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-10)) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-13))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-12)) (else (LibrariesC-45DataC-45StringMap-treeLookup arg-2 e-14))))))))))))))))
(define LibrariesC-45DataC-45StringMap-lookup (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45StringMap-treeLookup arg-1 e-3)))))
(define CoreC-45OptionsC-45Log-n--6793-7406-u--there (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) 0 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (DataC-45Maybe-fromMaybe (lambda () 0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45These-fromThat arg-3) (lambda (u--assoc) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45StringMap-lookup e-2 u--assoc) (lambda (u--next) (box (CoreC-45OptionsC-45Log-n--6775-7393-u--go arg-0 arg-1 arg-2 e-3 u--next))))))))))))
(define CoreC-45OptionsC-45Log-n--6775-7393-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CoreC-45OptionsC-45Log-n--6793-7405-u--here arg-0 arg-1 arg-2 arg-4 arg-3))) (cond ((equal? sc0 1) 1) (else (CoreC-45OptionsC-45Log-n--6793-7406-u--there arg-0 arg-1 arg-2 arg-4 arg-3))))))
(define CoreC-45OptionsC-45Log-keepLog (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (cond ((equal? e-1 0) 1)(else (CoreC-45OptionsC-45Log-n--6775-7393-u--go e-1 e-0 arg-1 e-0 arg-1)))))))
(define CoreC-45OptionsC-45Log-mkLogLevelC-39 (lambda (arg-0 arg-1) (cons (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (DataC-45List1-forget eta-0))) arg-0) arg-1)))
(define CoreC-45OptionsC-45Log-mkUnverifiedLogLevel (lambda (arg-0 ext-0) (cond ((equal? arg-0 "") (CoreC-45OptionsC-45Log-mkLogLevelC-39 '() ext-0))(else (CoreC-45OptionsC-45Log-mkLogLevelC-39 (box (DataC-45String-split csegen-520 arg-0)) ext-0)))))
(define CoreC-45ContextC-45Log-unverifiedLogging (lambda (arg-0 arg-1 arg-2 ext-0) (cond ((equal? arg-2 0) (vector 1 1))(else (let ((act-1 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((sc1 (let ((e-8 (vector-ref e-5 8))) e-8))) (cond ((equal? sc1 1) (CoreC-45OptionsC-45Log-keepLog (CoreC-45OptionsC-45Log-mkUnverifiedLogLevel arg-1 arg-2) (let ((e-9 (vector-ref e-5 9))) e-9))) (else 0))))))) eff-0) ext-0)))))))))
(define CoreC-45TTC-45Term-applyStackWithFC (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45TTC-45Term-applyStackWithFC (vector 4 e-6 arg-1 e-7) e-3))))))))
(define CoreC-45Context-clearDefs (lambda (arg-0 ext-0) (vector 1 (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (let ((e-11 (vector-ref arg-0 11))) (let ((e-12 (vector-ref arg-0 12))) (let ((e-13 (vector-ref arg-0 13))) (let ((e-14 (vector-ref arg-0 14))) (let ((e-15 (vector-ref arg-0 15))) (let ((e-16 (vector-ref arg-0 16))) (let ((e-17 (vector-ref arg-0 17))) (let ((e-18 (vector-ref arg-0 18))) (let ((e-19 (vector-ref arg-0 19))) (let ((e-20 (vector-ref arg-0 20))) (let ((e-21 (vector-ref arg-0 21))) (let ((e-22 (vector-ref arg-0 22))) (let ((e-23 (vector-ref arg-0 23))) (let ((e-24 (vector-ref arg-0 24))) (let ((e-25 (vector-ref arg-0 25))) (let ((e-26 (vector-ref arg-0 26))) (let ((e-27 (vector-ref arg-0 27))) (let ((e-28 (vector-ref arg-0 28))) (let ((e-29 (vector-ref arg-0 29))) (let ((e-30 (vector-ref arg-0 30))) (let ((e-31 (vector-ref arg-0 31))) (let ((e-32 (vector-ref arg-0 32))) (let ((e-33 (vector-ref e-0 0))) (let ((e-34 (vector-ref e-0 1))) (let ((e-35 (vector-ref e-0 2))) (let ((e-36 (vector-ref e-0 3))) (let ((e-37 (vector-ref e-0 4))) (let ((e-38 (vector-ref e-0 5))) (let ((e-39 (vector-ref e-0 6))) (let ((e-40 (vector-ref e-0 7))) (let ((e-41 (vector-ref e-0 8))) (let ((e-43 (vector-ref e-0 10))) (let ((e-44 (vector-ref e-0 11))) (vector (vector e-33 e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 1 e-43 e-44) e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))
(define CoreC-45Value-defaultOpts (vector 0 0 1 0 0 '() '() 1))
(define CoreC-45NormaliseC-45Eval-evalWithOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0 ext-1 ext-2 ext-3) (CoreC-45NormaliseC-45Eval-eval arg-3 arg-4 arg-0 arg-1 arg-2 ext-0 ext-1 ext-2 ext-3)))
(define CoreC-45NormaliseC-45Eval-evalLocClosure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 e-1 arg-0 e-2 e-4 e-3 e-5 arg-7))))))) (else (let ((e-8 (vector-ref arg-8 2))) (let ((e-9 (vector-ref arg-8 3))) (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 e-8 e-9 arg-7)))))))
(define PreludeC-45TypesC-45List-lengthPlus (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45List-lengthPlus (+ arg-1 1) e-3)))))
(define PreludeC-45TypesC-45List-lengthTR (lambda (ext-0) (PreludeC-45TypesC-45List-lengthPlus 0 ext-0)))
(define LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (lambda (arg-1) (PreludeC-45TypesC-45List-lengthTR arg-1)))
(define CoreC-45Env-getBinderUnder (lambda (arg-2 arg-3 arg-4 arg-5 arg-7) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? arg-4 0) (let ((e-7 (car arg-7))) (CoreC-45TTC-45Binder-u--map_Functor_Binder (let ((e-3 (cdr arg-2))) (((e-3 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-1 arg-5)))) e-7)))(else (let ((e-3 (- arg-4 1))) (let ((e-13 (cdr arg-7))) (CoreC-45Env-getBinderUnder arg-2 e-2 e-3 (cons e-1 arg-5) e-13)))))))))
(define CoreC-45Env-getBinder (lambda (arg-2 arg-3 arg-4 arg-6) (CoreC-45Env-getBinderUnder arg-2 arg-3 arg-4 '() arg-6)))
(define CoreC-45NormaliseC-45Eval-evalLocal (lambda (arg-0 arg-1 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 arg-12) (if (null? arg-12) (let ((sc1 (let ((sc2 (let ((sc3 (let ((e-0 (vector-ref arg-1 0))) e-0))) (cond ((equal? sc3 1) 1) (else (let ((e-1 (vector-ref arg-1 1))) e-1)))))) (cond ((equal? sc2 1) 0) (else (DataC-45Maybe-fromMaybe (lambda () 1) arg-8)))))) (cond ((equal? sc1 1) (let ((sc2 (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-5 arg-9 arg-6))) (case (vector-ref sc2 0) ((1) (let ((e-3 (vector-ref sc2 3))) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-4 arg-5 '() arg-6 '() e-3 arg-11)))(else (lambda (eta-0) (vector 1 (vector 1 arg-7 (vector 0 arg-8 arg-9) arg-11))))))) (else (lambda (eta-0) (vector 1 (vector 1 arg-7 (vector 0 arg-8 arg-9) arg-11)))))) (cond ((equal? arg-9 0) (let ((e-4 (car arg-12))) (CoreC-45NormaliseC-45Eval-evalLocClosure arg-0 arg-1 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 e-4)))(else (let ((e-0 (- arg-9 1))) (let ((e-10 (cdr arg-12))) (CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-4 arg-5 arg-6 arg-7 arg-8 e-0 arg-11 e-10))))))))
(define SystemC-45Clock-isClockMandatory (lambda (arg-0) (cond ((equal? arg-0 5) 1) ((equal? arg-0 6) 1)(else 0))))
(define SystemC-45Clock-clockTimeGcCpu (lambda (ext-0) (SystemC-45Clock-prim__clockTimeGcCpu ext-0)))
(define SystemC-45Clock-clockTimeGcReal (lambda (ext-0) (SystemC-45Clock-prim__clockTimeGcReal ext-0)))
(define SystemC-45Clock-clockTimeMonotonic (lambda (ext-0) (SystemC-45Clock-prim__clockTimeMonotonic ext-0)))
(define SystemC-45Clock-clockTimeProcess (lambda (ext-0) (SystemC-45Clock-prim__clockTimeProcess ext-0)))
(define SystemC-45Clock-clockTimeThread (lambda (ext-0) (SystemC-45Clock-prim__clockTimeThread ext-0)))
(define SystemC-45Clock-clockTimeUtc (lambda (ext-0) (SystemC-45Clock-prim__clockTimeUtc ext-0)))
(define SystemC-45Clock-fetchOSClock (lambda (arg-0 ext-0) (cond ((equal? arg-0 0) (SystemC-45Clock-clockTimeUtc ext-0)) ((equal? arg-0 1) (SystemC-45Clock-clockTimeMonotonic ext-0)) ((equal? arg-0 3) (SystemC-45Clock-clockTimeProcess ext-0)) ((equal? arg-0 4) (SystemC-45Clock-clockTimeThread ext-0)) ((equal? arg-0 5) (SystemC-45Clock-clockTimeGcCpu ext-0)) ((equal? arg-0 6) (SystemC-45Clock-clockTimeGcReal ext-0)) (else (SystemC-45Clock-clockTimeMonotonic ext-0)))))
(define SystemC-45Clock-osClockNanosecond (lambda (arg-0 ext-0) (SystemC-45Clock-prim__osClockNanosecond arg-0 ext-0)))
(define SystemC-45Clock-osClockSecond (lambda (arg-0 ext-0) (SystemC-45Clock-prim__osClockSecond arg-0 ext-0)))
(define SystemC-45Clock-fromOSClock (lambda (arg-0 arg-1 ext-0) (let ((act-1 (SystemC-45Clock-osClockSecond arg-1 ext-0))) (let ((act-2 (SystemC-45Clock-osClockNanosecond arg-1 ext-0))) (vector arg-0 act-1 act-2)))))
(define SystemC-45Clock-osClockValid (lambda (arg-0 ext-0) (SystemC-45Clock-prim__osClockValid arg-0 ext-0)))
(define SystemC-45Clock-with--clockTime-4345 (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (let ((act-1 (SystemC-45Clock-fetchOSClock arg-0 ext-0))) (SystemC-45Clock-fromOSClock arg-0 act-1 ext-0))) (else (let ((act-1 (SystemC-45Clock-fetchOSClock arg-0 ext-0))) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 (blodwen-toSignedInt 1 63))) (lambda (eta-0) (SystemC-45Clock-osClockValid act-1 eta-0)) ext-0))) (cond ((equal? act-2 1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (box eta-0)) (lambda (eta-0) (SystemC-45Clock-fromOSClock arg-0 act-1 eta-0)) ext-0)) (else '()))))))))
(define SystemC-45Clock-clockTime (lambda (arg-0 ext-0) (SystemC-45Clock-with--clockTime-4345 arg-0 (SystemC-45Clock-isClockMandatory arg-0) ext-0)))
(define SystemC-45Clock-nanoseconds (lambda (arg-1) (let ((e-2 (vector-ref arg-1 2))) e-2)))
(define SystemC-45Clock-seconds (lambda (arg-1) (let ((e-1 (vector-ref arg-1 1))) e-1)))
(define CoreC-45Context-n--35105-29909-u--nano 1000000000)
(define CoreC-45Context-getTime (lambda (ext-0) (let ((act-1 (let ((act-1 (SystemC-45Clock-clockTime 1 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (+ (* (SystemC-45Clock-seconds e-5) CoreC-45Context-n--35105-29909-u--nano) (SystemC-45Clock-nanoseconds e-5)))))) eff-0) ext-0)))))))
(define CoreC-45Context-case--checkTimer-30094 (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-1 (CoreC-45Context-getTime clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Integer e-7 e-5))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 65 e-6) clam-1)) (else (vector 1 (vector 0 )))))))) eff-0) clam-0))))))))))))
(define CoreC-45Context-checkTimer (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-case--checkTimer-30094 arg-0 e-5 (let ((e-28 (vector-ref e-5 28))) e-28)))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45WithDefault-collapseDefault (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-4 (unbox arg-2))) e-4))))
(define CoreC-45NormaliseC-45Eval-argsFromStack (lambda (arg-0 arg-1 arg-3 arg-4) (if (null? arg-3) (box (cons '() arg-4)) (let ((e-3 (cdr arg-3))) (if (null? arg-4) '() (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Eval-argsFromStack arg-0 arg-1 e-3 e-7) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) (box (cons (cons (Builtin-snd e-6) e-5) e-4)))))))))))))
(define CoreC-45NormaliseC-45Eval-n--9391-5572-u--takeStk (lambda (arg-0 arg-1 arg-3 arg-4 arg-6 arg-7 arg-8) (cond ((equal? arg-6 0) (box (cons (DataC-45Vect-reverse arg-8) arg-7)))(else (let ((e-0 (- arg-6 1))) (if (null? arg-7) '() (let ((e-3 (car arg-7))) (let ((e-4 (cdr arg-7))) (CoreC-45NormaliseC-45Eval-n--9391-5572-u--takeStk arg-0 arg-1 arg-3 arg-4 e-0 e-4 (cons (Builtin-snd e-3) arg-8))))))))))
(define CoreC-45NormaliseC-45Eval-takeFromStack (lambda (arg-0 arg-1 arg-3 arg-4) (CoreC-45NormaliseC-45Eval-n--9391-5572-u--takeStk arg-0 arg-1 arg-4 arg-3 arg-3 arg-4 '())))
(define CoreC-45NormaliseC-45Eval-n--9386-5716-u--evalAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 ext-0) (if (null? arg-9) (vector 1 '()) (let ((e-3 (car arg-9))) (let ((e-4 (cdr arg-9))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-2 arg-0 e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Eval-n--9386-5716-u--evalAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45NormaliseC-45Eval-case--evalOp-5758 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (arg-3))) (let ((e-1 (unbox arg-8))) (lambda (clam-0) (if (null? e-1) (vector 1 (arg-3)) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (let ((act-1 (CoreC-45NormaliseC-45Eval-n--9386-5716-u--evalAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((sc4 (arg-6 e-6))) (if (null? sc4) (arg-3) (let ((e-2 (unbox sc4))) e-2))))))) eff-0) clam-0))))) (vector 1 (arg-3)))))))))))
(define CoreC-45NormaliseC-45Eval-evalOp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (CoreC-45NormaliseC-45Eval-case--evalOp-5758 arg-0 arg-1 arg-4 arg-7 arg-6 arg-3 arg-5 arg-2 (CoreC-45NormaliseC-45Eval-takeFromStack arg-0 arg-1 arg-3 arg-6))))
(define CoreC-45Primitives-add (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-12 (vector-ref arg-1 1))) (box (vector 5 (+ e-0 e-12)))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (vector 0 (bs+ e-1 e-13 63)))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (vector 1 (bs+ e-2 e-14 7)))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (vector 2 (bs+ e-3 e-15 15)))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (vector 3 (bs+ e-4 e-16 31)))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (vector 4 (bs+ e-5 e-17 63)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-18 (vector-ref arg-1 1))) (box (vector 6 (bu+ e-6 e-18 8)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-19 (vector-ref arg-1 1))) (box (vector 7 (bu+ e-7 e-19 16)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-20 (vector-ref arg-1 1))) (box (vector 8 (bu+ e-8 e-20 32)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-21 (vector-ref arg-1 1))) (box (vector 9 (bu+ e-9 e-21 64)))))(else '())))) ((11) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-22 (vector-ref arg-1 1))) (box (vector 11 (cast-int-char (bs+ (cast-char-boundedInt e-10 63) (cast-char-boundedInt e-22 63) 63))))))(else '())))) ((12) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-23 (vector-ref arg-1 1))) (box (vector 12 (+ e-11 e-23)))))(else '()))))(else '()))))
(define CoreC-45Primitives-band (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (box (vector 0 (blodwen-and e-0 e-10)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (box (vector 1 (blodwen-and e-1 e-11)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (box (vector 2 (blodwen-and e-2 e-12)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (box (vector 3 (blodwen-and e-3 e-13)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (box (vector 4 (blodwen-and e-4 e-14)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (box (vector 5 (blodwen-and e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (box (vector 6 (blodwen-and e-6 e-16)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (box (vector 7 (blodwen-and e-7 e-17)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (box (vector 8 (blodwen-and e-8 e-18)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (box (vector 9 (blodwen-and e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-believeMe (lambda (arg-1) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-10 0) ((2) (if (null? e-11) (box e-10) '())) ((3) (if (null? e-11) (box e-10) '())) ((8) (if (null? e-11) (box e-10) '())) ((10) (let ((e-29 (vector-ref e-10 1))) (let ((e-30 (vector-ref e-10 2))) (if (null? e-11) (box (vector 10 e-29 e-30)) '()))))(else '()))))))))
(define CoreC-45Primitives-binOp (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) '() (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (case (vector-ref e-9 0) ((8) (let ((e-13 (vector-ref e-9 2))) (if (null? e-10) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 eta-0)) ((arg-0 e-6) e-13)) '())))(else '()))))))))(else '())))))))
(define CoreC-45Primitives-bor (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (box (vector 0 (blodwen-or e-0 e-10)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (box (vector 1 (blodwen-or e-1 e-11)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (box (vector 2 (blodwen-or e-2 e-12)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (box (vector 3 (blodwen-or e-3 e-13)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (box (vector 4 (blodwen-or e-4 e-14)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (box (vector 5 (blodwen-or e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (box (vector 6 (blodwen-or e-6 e-16)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (box (vector 7 (blodwen-or e-7 e-17)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (box (vector 8 (blodwen-or e-8 e-18)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (box (vector 9 (blodwen-or e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-bxor (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (box (vector 0 (blodwen-xor e-0 e-10)))))(else '())))) ((6) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-11 (vector-ref arg-1 1))) (box (vector 6 (blodwen-xor e-1 e-11)))))(else '())))) ((7) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-12 (vector-ref arg-1 1))) (box (vector 7 (blodwen-xor e-2 e-12)))))(else '())))) ((8) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-13 (vector-ref arg-1 1))) (box (vector 8 (blodwen-xor e-3 e-13)))))(else '())))) ((9) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-14 (vector-ref arg-1 1))) (box (vector 9 (blodwen-xor e-4 e-14)))))(else '())))) ((1) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-15 (vector-ref arg-1 1))) (box (vector 1 (blodwen-xor e-5 e-15)))))(else '())))) ((2) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-16 (vector-ref arg-1 1))) (box (vector 2 (blodwen-xor e-6 e-16)))))(else '())))) ((3) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-17 (vector-ref arg-1 1))) (box (vector 3 (blodwen-xor e-7 e-17)))))(else '())))) ((4) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-18 (vector-ref arg-1 1))) (box (vector 4 (blodwen-xor e-8 e-18)))))(else '())))) ((5) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-19 (vector-ref arg-1 1))) (box (vector 5 (blodwen-xor e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-constantIntegerValue (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (box e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (box e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (box e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (box e-4))) ((5) (let ((e-5 (vector-ref arg-0 1))) (box e-5))) ((6) (let ((e-6 (vector-ref arg-0 1))) (box e-6))) ((7) (let ((e-7 (vector-ref arg-0 1))) (box e-7))) ((8) (let ((e-8 (vector-ref arg-0 1))) (box e-8))) ((9) (let ((e-9 (vector-ref arg-0 1))) (box e-9)))(else '()))))
(define CoreC-45Primitives-castBits16 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 7 (blodwen-toUnsignedInt eta-0 16)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castBits32 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 8 (blodwen-toUnsignedInt eta-0 32)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castBits64 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 9 (blodwen-toUnsignedInt eta-0 64)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castBits8 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 6 (blodwen-toUnsignedInt eta-0 8)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castChar (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-11)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-12)))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-13)))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-14)))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-15)))) '()))) ((5) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 11 (cast-int-char e-16)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castDouble (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-11)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-12)))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-13)))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-14)))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-15)))) '()))) ((5) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (exact->inexact e-16)))) '()))) ((10) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (cast-string-double e-17)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castInt (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((1) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-7))) '()))) ((2) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-8))) '()))) ((3) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-9))) '()))) ((4) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-10))) '()))) ((5) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (blodwen-toSignedInt e-11 63)))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-12))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-13))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 e-14))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (blodwen-toSignedInt e-15 63)))) '()))) ((12) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (exact-truncate-boundedInt e-16 63)))) '()))) ((11) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (cast-char-boundedInt e-17 63)))) '()))) ((10) (let ((e-18 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (cast-string-boundedInt e-18 63)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castInt16 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 2 (blodwen-toSignedInt eta-0 15)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt32 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 3 (blodwen-toSignedInt eta-0 31)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt64 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 4 (blodwen-toSignedInt eta-0 63)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInt8 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 (vector 1 (blodwen-toSignedInt eta-0 7)))) (CoreC-45Primitives-constantIntegerValue e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-castInteger (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-7))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-8))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-9))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-10))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-11))) '()))) ((6) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-12))) '()))) ((7) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-13))) '()))) ((8) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-14))) '()))) ((9) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 e-15))) '()))) ((11) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (cast-char-boundedInt e-16 63)))) '()))) ((12) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (exact-truncate e-17)))) '()))) ((10) (let ((e-18 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 5 (cast-string-int e-18)))) '())))(else '())))))(else '())))))))
(define LibrariesC-45UtilsC-45String-stripSurrounds (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-substr arg-0 (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45String-length arg-2) (+ arg-0 arg-1))) arg-2)))
(define LibrariesC-45UtilsC-45String-stripQuotes (lambda (ext-0) (LibrariesC-45UtilsC-45String-stripSurrounds 1 1 ext-0)))
(define CoreC-45Primitives-castString (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int e-7)))) '()))) ((1) (let ((e-8 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int8 e-8)))) '()))) ((2) (let ((e-9 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int16 e-9)))) '()))) ((3) (let ((e-10 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int32 e-10)))) '()))) ((4) (let ((e-11 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Int64 e-11)))) '()))) ((5) (let ((e-12 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Integer e-12)))) '()))) ((6) (let ((e-13 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits8 e-13)))) '()))) ((7) (let ((e-14 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits16 e-14)))) '()))) ((8) (let ((e-15 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits32 e-15)))) '()))) ((9) (let ((e-16 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Bits64 e-16)))) '()))) ((11) (let ((e-17 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (LibrariesC-45UtilsC-45String-stripQuotes (PreludeC-45Show-u--show_Show_Char e-17))))) '()))) ((12) (let ((e-18 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (PreludeC-45Show-u--show_Show_Double e-18)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-castTo (lambda (arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45Primitives-castInt ext-0)) ((equal? arg-1 1) (CoreC-45Primitives-castInt8 ext-0)) ((equal? arg-1 2) (CoreC-45Primitives-castInt16 ext-0)) ((equal? arg-1 3) (CoreC-45Primitives-castInt32 ext-0)) ((equal? arg-1 4) (CoreC-45Primitives-castInt64 ext-0)) ((equal? arg-1 5) (CoreC-45Primitives-castInteger ext-0)) ((equal? arg-1 6) (CoreC-45Primitives-castBits8 ext-0)) ((equal? arg-1 7) (CoreC-45Primitives-castBits16 ext-0)) ((equal? arg-1 8) (CoreC-45Primitives-castBits32 ext-0)) ((equal? arg-1 9) (CoreC-45Primitives-castBits64 ext-0)) ((equal? arg-1 10) (CoreC-45Primitives-castString ext-0)) ((equal? arg-1 11) (CoreC-45Primitives-castChar ext-0)) ((equal? arg-1 12) (CoreC-45Primitives-castDouble ext-0)) (else '()))))
(define PreludeC-45Num-u--div_Integral_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-1 0))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 16))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:296:3--298:43")))))))
(define PreludeC-45Num-u--div_Integral_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-1 0))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 32))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:324:3--326:43")))))))
(define PreludeC-45Num-u--div_Integral_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-1 0))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 64))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:352:3--354:43")))))))
(define PreludeC-45Num-u--div_Integral_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-1 0))) (cond ((equal? sc0 0) (bu/ arg-0 arg-1 8))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:268:3--270:42")))))))
(define PreludeC-45Num-u--div_Integral_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-1 0))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 15))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:184:3--186:42")))))))
(define PreludeC-45Num-u--div_Integral_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-1 0))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 31))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:212:3--214:42")))))))
(define PreludeC-45Num-u--div_Integral_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-1 0))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 63))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:240:3--242:42")))))))
(define PreludeC-45Num-u--div_Integral_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-1 0))) (cond ((equal? sc0 0) (bs/ arg-0 arg-1 7))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in div at Prelude.Num:156:3--158:41")))))))
(define CoreC-45Primitives-div (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-11 (vector-ref arg-1 1))) (cond ((equal? e-11 0) '())(else (box (vector 5 (PreludeC-45Num-u--div_Integral_Integer e-0 e-11)))))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-12 (vector-ref arg-1 1))) (cond ((equal? e-12 0) '())(else (box (vector 0 (PreludeC-45Num-u--div_Integral_Int e-1 e-12)))))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-13 (vector-ref arg-1 1))) (cond ((equal? e-13 0) '())(else (box (vector 1 (PreludeC-45Num-u--div_Integral_Int8 e-2 e-13)))))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-14 (vector-ref arg-1 1))) (cond ((equal? e-14 0) '())(else (box (vector 2 (PreludeC-45Num-u--div_Integral_Int16 e-3 e-14)))))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-15 (vector-ref arg-1 1))) (cond ((equal? e-15 0) '())(else (box (vector 3 (PreludeC-45Num-u--div_Integral_Int32 e-4 e-15)))))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-16 (vector-ref arg-1 1))) (cond ((equal? e-16 0) '())(else (box (vector 4 (PreludeC-45Num-u--div_Integral_Int64 e-5 e-16)))))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-17 (vector-ref arg-1 1))) (cond ((equal? e-17 0) '())(else (box (vector 6 (PreludeC-45Num-u--div_Integral_Bits8 e-6 e-17)))))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-18 (vector-ref arg-1 1))) (cond ((equal? e-18 0) '())(else (box (vector 7 (PreludeC-45Num-u--div_Integral_Bits16 e-7 e-18)))))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-19 (vector-ref arg-1 1))) (cond ((equal? e-19 0) '())(else (box (vector 8 (PreludeC-45Num-u--div_Integral_Bits32 e-8 e-19)))))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-20 (vector-ref arg-1 1))) (cond ((equal? e-20 0) '())(else (box (vector 9 (PreludeC-45Num-u--div_Integral_Bits64 e-9 e-20)))))))(else '())))) ((12) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-21 (vector-ref arg-1 1))) (box (vector 12 (/ e-10 e-21)))))(else '()))))(else '()))))
(define CoreC-45Primitives-doubleOp (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((12) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 12 (arg-1 e-7)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-doubleACos (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flacos eta-0)) ext-0)))
(define CoreC-45Primitives-doubleASin (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flasin eta-0)) ext-0)))
(define CoreC-45Primitives-doubleATan (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flatan eta-0)) ext-0)))
(define CoreC-45Primitives-doubleCeiling (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flceiling eta-0)) ext-0)))
(define CoreC-45Primitives-doubleCos (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flcos eta-0)) ext-0)))
(define CoreC-45Primitives-doubleExp (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flexp eta-0)) ext-0)))
(define CoreC-45Primitives-doubleFloor (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flfloor eta-0)) ext-0)))
(define CoreC-45Primitives-doubleLog (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (fllog eta-0)) ext-0)))
(define CoreC-45Primitives-n--11693-6212-u--powC-39 (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((12) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((12) (let ((e-1 (vector-ref arg-2 1))) (box (vector 12 (flexpt e-0 e-1)))))(else '()))))(else '()))))
(define CoreC-45Primitives-doublePow (lambda (arg-0 ext-0) (CoreC-45Primitives-binOp (lambda (eta-0) (lambda (eta-1) (CoreC-45Primitives-n--11693-6212-u--powC-39 arg-0 eta-0 eta-1))) arg-0 ext-0)))
(define CoreC-45Primitives-doubleSin (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flsin eta-0)) ext-0)))
(define CoreC-45Primitives-doubleSqrt (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (flsqrt eta-0)) ext-0)))
(define CoreC-45Primitives-doubleTan (lambda (ext-0) (CoreC-45Primitives-doubleOp (lambda (eta-0) (fltan eta-0)) ext-0)))
(define CoreC-45Primitives-toInt (lambda (arg-0) (cond ((equal? arg-0 1) (vector 0 1)) (else (vector 0 0)))))
(define CoreC-45Primitives-eq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-61C-61_Eq_Double e-12 e-25)))))(else '()))))(else '()))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (> arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define CoreC-45Primitives-gt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (>= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define CoreC-45Primitives-gte (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-62C-61_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define CoreC-45Primitives-lt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Double (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int16 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int32 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int64 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Int8 (lambda (arg-0 arg-1) (let ((sc0 (or (and (<= arg-0 arg-1) 1) 0))) (cond ((equal? sc0 0) 0)(else 1)))))
(define CoreC-45Primitives-lte (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int e-0 e-13)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int8 e-1 e-14)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int16 e-2 e-15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int32 e-3 e-16)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Int64 e-4 e-17)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-18 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Integer e-5 e-18)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits8 e-6 e-19)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits16 e-7 e-20)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits32 e-8 e-21)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Bits64 e-9 e-22)))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-23 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_String e-10 e-23)))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-24 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-11 e-24)))))(else '())))) ((12) (let ((e-12 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-25 (vector-ref arg-1 1))) (box (CoreC-45Primitives-toInt (PreludeC-45EqOrd-u--C-60C-61_Ord_Double e-12 e-25)))))(else '()))))(else '()))))
(define PreludeC-45Num-u--mod_Integral_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:299:3--301:43")))))))
(define PreludeC-45Num-u--mod_Integral_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:327:3--329:43")))))))
(define PreludeC-45Num-u--mod_Integral_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:355:3--357:43")))))))
(define PreludeC-45Num-u--mod_Integral_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:271:3--273:42")))))))
(define PreludeC-45Num-u--mod_Integral_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:187:3--189:42")))))))
(define PreludeC-45Num-u--mod_Integral_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:215:3--217:42")))))))
(define PreludeC-45Num-u--mod_Integral_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:243:3--245:42")))))))
(define PreludeC-45Num-u--mod_Integral_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-1 0))) (cond ((equal? sc0 0) (blodwen-euclidMod arg-0 arg-1))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Prelude.Num.case block in mod at Prelude.Num:159:3--161:41")))))))
(define CoreC-45Primitives-mod (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-10 (vector-ref arg-1 1))) (cond ((equal? e-10 0) '())(else (box (vector 5 (PreludeC-45Num-u--mod_Integral_Integer e-0 e-10)))))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-11 (vector-ref arg-1 1))) (cond ((equal? e-11 0) '())(else (box (vector 0 (PreludeC-45Num-u--mod_Integral_Int e-1 e-11)))))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-12 (vector-ref arg-1 1))) (cond ((equal? e-12 0) '())(else (box (vector 1 (PreludeC-45Num-u--mod_Integral_Int8 e-2 e-12)))))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-13 (vector-ref arg-1 1))) (cond ((equal? e-13 0) '())(else (box (vector 2 (PreludeC-45Num-u--mod_Integral_Int16 e-3 e-13)))))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-14 (vector-ref arg-1 1))) (cond ((equal? e-14 0) '())(else (box (vector 3 (PreludeC-45Num-u--mod_Integral_Int32 e-4 e-14)))))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-15 (vector-ref arg-1 1))) (cond ((equal? e-15 0) '())(else (box (vector 4 (PreludeC-45Num-u--mod_Integral_Int64 e-5 e-15)))))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (cond ((equal? e-16 0) '())(else (box (vector 6 (PreludeC-45Num-u--mod_Integral_Bits8 e-6 e-16)))))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (cond ((equal? e-17 0) '())(else (box (vector 7 (PreludeC-45Num-u--mod_Integral_Bits16 e-7 e-17)))))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (cond ((equal? e-18 0) '())(else (box (vector 8 (PreludeC-45Num-u--mod_Integral_Bits32 e-8 e-18)))))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (cond ((equal? e-19 0) '())(else (box (vector 9 (PreludeC-45Num-u--mod_Integral_Bits64 e-9 e-19)))))))(else '()))))(else '()))))
(define CoreC-45Primitives-mul (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-11 (vector-ref arg-1 1))) (box (vector 5 (* e-0 e-11)))))(else '())))) ((6) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-12 (vector-ref arg-1 1))) (box (vector 6 (bu* e-1 e-12 8)))))(else '())))) ((7) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-13 (vector-ref arg-1 1))) (box (vector 7 (bu* e-2 e-13 16)))))(else '())))) ((8) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-14 (vector-ref arg-1 1))) (box (vector 8 (bu* e-3 e-14 32)))))(else '())))) ((9) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-15 (vector-ref arg-1 1))) (box (vector 9 (bu* e-4 e-15 64)))))(else '())))) ((0) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-16 (vector-ref arg-1 1))) (box (vector 0 (bs* e-5 e-16 63)))))(else '())))) ((1) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-17 (vector-ref arg-1 1))) (box (vector 1 (bs* e-6 e-17 7)))))(else '())))) ((2) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-18 (vector-ref arg-1 1))) (box (vector 2 (bs* e-7 e-18 15)))))(else '())))) ((3) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-19 (vector-ref arg-1 1))) (box (vector 3 (bs* e-8 e-19 31)))))(else '())))) ((4) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-20 (vector-ref arg-1 1))) (box (vector 4 (bs* e-9 e-20 63)))))(else '())))) ((12) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-21 (vector-ref arg-1 1))) (box (vector 12 (* e-10 e-21)))))(else '()))))(else '()))))
(define CoreC-45Primitives-neg (lambda (arg-0) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (box (vector 5 (- 0 e-0))))) ((0) (let ((e-1 (vector-ref arg-0 1))) (box (vector 0 (bs- 0 e-1 63))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (box (vector 1 (bs- 0 e-2 7))))) ((2) (let ((e-3 (vector-ref arg-0 1))) (box (vector 2 (bs- 0 e-3 15))))) ((3) (let ((e-4 (vector-ref arg-0 1))) (box (vector 3 (bs- 0 e-4 31))))) ((4) (let ((e-5 (vector-ref arg-0 1))) (box (vector 4 (bs- 0 e-5 63))))) ((6) (let ((e-6 (vector-ref arg-0 1))) (box (vector 6 (bu- 0 e-6 8))))) ((7) (let ((e-7 (vector-ref arg-0 1))) (box (vector 7 (bu- 0 e-7 16))))) ((8) (let ((e-8 (vector-ref arg-0 1))) (box (vector 8 (bu- 0 e-8 32))))) ((9) (let ((e-9 (vector-ref arg-0 1))) (box (vector 9 (bu- 0 e-9 64))))) ((12) (let ((e-10 (vector-ref arg-0 1))) (box (vector 12 (- e-10)))))(else '()))))
(define CoreC-45Primitives-shiftl (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (box (vector 0 (blodwen-bits-shl-signed e-0 e-10 63)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (box (vector 1 (blodwen-bits-shl-signed e-1 e-11 7)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (box (vector 2 (blodwen-bits-shl-signed e-2 e-12 15)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (box (vector 3 (blodwen-bits-shl-signed e-3 e-13 31)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (box (vector 4 (blodwen-bits-shl-signed e-4 e-14 63)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (box (vector 5 (blodwen-shl e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (box (vector 6 (blodwen-bits-shl e-6 e-16 8)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (box (vector 7 (blodwen-bits-shl e-7 e-17 16)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (box (vector 8 (blodwen-bits-shl e-8 e-18 32)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (box (vector 9 (blodwen-bits-shl e-9 e-19 64)))))(else '()))))(else '()))))
(define CoreC-45Primitives-shiftr (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-10 (vector-ref arg-1 1))) (box (vector 0 (blodwen-shr e-0 e-10)))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-11 (vector-ref arg-1 1))) (box (vector 1 (blodwen-shr e-1 e-11)))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-12 (vector-ref arg-1 1))) (box (vector 2 (blodwen-shr e-2 e-12)))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-13 (vector-ref arg-1 1))) (box (vector 3 (blodwen-shr e-3 e-13)))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-14 (vector-ref arg-1 1))) (box (vector 4 (blodwen-shr e-4 e-14)))))(else '())))) ((5) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-15 (vector-ref arg-1 1))) (box (vector 5 (blodwen-shr e-5 e-15)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-16 (vector-ref arg-1 1))) (box (vector 6 (blodwen-shr e-6 e-16)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-17 (vector-ref arg-1 1))) (box (vector 7 (blodwen-shr e-7 e-17)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-18 (vector-ref arg-1 1))) (box (vector 8 (blodwen-shr e-8 e-18)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-19 (vector-ref arg-1 1))) (box (vector 9 (blodwen-shr e-9 e-19)))))(else '()))))(else '()))))
(define CoreC-45Primitives-strAppend (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((10) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) (box (vector 8 e-5 (vector 10 (string-append e-7 e-15)))) '())))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strCons (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((11) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((10) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) (box (vector 8 e-5 (vector 10 (string-cons e-7 e-15)))) '())))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strHead (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (cond ((equal? e-7 "") (if (null? e-3) '() (if (null? e-3) (box (vector 8 e-5 (vector 11 (string-ref e-7 0)))) '())))(else (if (null? e-3) (box (vector 8 e-5 (vector 11 (string-ref e-7 0)))) '())))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strIndex (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((0) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) (let ((sc7 (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-15 0))) (cond ((equal? sc8 1) (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45Types-prim__integerToNat e-15) (PreludeC-45TypesC-45String-length e-7))) (else 0))))) (cond ((equal? sc7 1) (box (vector 8 e-5 (vector 11 (string-ref e-7 e-15))))) (else '()))) '())))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strLength (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 0 (blodwen-toSignedInt (PreludeC-45TypesC-45String-length e-7) 63)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-strReverse (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) (box (vector 8 e-5 (vector 10 (string-reverse e-7)))) '())))(else '())))))(else '())))))))
(define CoreC-45Primitives-strSubstr (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((0) (let ((e-7 (vector-ref e-6 1))) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((8) (let ((e-14 (vector-ref e-10 2))) (case (vector-ref e-14 0) ((0) (let ((e-15 (vector-ref e-14 1))) (if (null? e-11) '() (let ((e-18 (car e-11))) (let ((e-19 (cdr e-11))) (case (vector-ref e-18 0) ((8) (let ((e-22 (vector-ref e-18 2))) (case (vector-ref e-22 0) ((10) (let ((e-23 (vector-ref e-22 1))) (if (null? e-19) (box (vector 8 e-5 (vector 10 (string-substr e-7 e-15 e-23)))) '())))(else '()))))(else '())))))))(else '()))))(else '())))))))(else '())))))(else '())))))))
(define CoreC-45Primitives-strTail (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((10) (let ((e-7 (vector-ref e-6 1))) (cond ((equal? e-7 "") (if (null? e-3) '() (if (null? e-3) (box (vector 8 e-5 (vector 10 (substring e-7 1 (string-length e-7))))) '())))(else (if (null? e-3) (box (vector 8 e-5 (vector 10 (substring e-7 1 (string-length e-7))))) '())))))(else '())))))(else '())))))))
(define CoreC-45Primitives-sub (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((5) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-12 (vector-ref arg-1 1))) (box (vector 5 (- e-0 e-12)))))(else '())))) ((0) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-13 (vector-ref arg-1 1))) (box (vector 0 (bs- e-1 e-13 63)))))(else '())))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-14 (vector-ref arg-1 1))) (box (vector 1 (bs- e-2 e-14 7)))))(else '())))) ((2) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-15 (vector-ref arg-1 1))) (box (vector 2 (bs- e-3 e-15 15)))))(else '())))) ((3) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-16 (vector-ref arg-1 1))) (box (vector 3 (bs- e-4 e-16 31)))))(else '())))) ((4) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-17 (vector-ref arg-1 1))) (box (vector 4 (bs- e-5 e-17 63)))))(else '())))) ((6) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-18 (vector-ref arg-1 1))) (box (vector 6 (bu- e-6 e-18 8)))))(else '())))) ((7) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-19 (vector-ref arg-1 1))) (box (vector 7 (bu- e-7 e-19 16)))))(else '())))) ((8) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-20 (vector-ref arg-1 1))) (box (vector 8 (bu- e-8 e-20 32)))))(else '())))) ((9) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-21 (vector-ref arg-1 1))) (box (vector 9 (bu- e-9 e-21 64)))))(else '())))) ((11) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-22 (vector-ref arg-1 1))) (box (vector 11 (cast-int-char (bs- (cast-char-boundedInt e-10 63) (cast-char-boundedInt e-22 63) 63))))))(else '())))) ((12) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((12) (let ((e-23 (vector-ref arg-1 1))) (box (vector 12 (- e-11 e-23)))))(else '()))))(else '()))))
(define CoreC-45Primitives-unaryOp (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((8) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-5 eta-0)) (arg-0 e-6)) '()))))(else '())))))))
(define CoreC-45Primitives-getOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-add eta-1 eta-2))) arg-2 eta-0))) ((1) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-sub eta-1 eta-2))) arg-2 eta-0))) ((2) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-mul eta-1 eta-2))) arg-2 eta-0))) ((3) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-div eta-1 eta-2))) arg-2 eta-0))) ((4) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-mod eta-1 eta-2))) arg-2 eta-0))) ((5) (lambda (eta-0) (CoreC-45Primitives-unaryOp (lambda (eta-1) (CoreC-45Primitives-neg eta-1)) arg-2 eta-0))) ((6) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-shiftl eta-1 eta-2))) arg-2 eta-0))) ((7) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-shiftr eta-1 eta-2))) arg-2 eta-0))) ((8) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-band eta-1 eta-2))) arg-2 eta-0))) ((9) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-bor eta-1 eta-2))) arg-2 eta-0))) ((10) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-bxor eta-1 eta-2))) arg-2 eta-0))) ((11) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-lt eta-1 eta-2))) arg-2 eta-0))) ((12) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-lte eta-1 eta-2))) arg-2 eta-0))) ((13) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-eq eta-1 eta-2))) arg-2 eta-0))) ((14) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-gte eta-1 eta-2))) arg-2 eta-0))) ((15) (lambda (eta-0) (CoreC-45Primitives-binOp (lambda (eta-1) (lambda (eta-2) (CoreC-45Primitives-gt eta-1 eta-2))) arg-2 eta-0))) ((16) (lambda (eta-0) (CoreC-45Primitives-strLength eta-0))) ((17) (lambda (eta-0) (CoreC-45Primitives-strHead eta-0))) ((18) (lambda (eta-0) (CoreC-45Primitives-strTail eta-0))) ((19) (lambda (eta-0) (CoreC-45Primitives-strIndex eta-0))) ((20) (lambda (eta-0) (CoreC-45Primitives-strCons eta-0))) ((21) (lambda (eta-0) (CoreC-45Primitives-strAppend eta-0))) ((22) (lambda (eta-0) (CoreC-45Primitives-strReverse eta-0))) ((23) (lambda (eta-0) (CoreC-45Primitives-strSubstr eta-0))) ((24) (lambda (eta-0) (CoreC-45Primitives-doubleExp eta-0))) ((25) (lambda (eta-0) (CoreC-45Primitives-doubleLog eta-0))) ((26) (lambda (eta-0) (CoreC-45Primitives-doublePow arg-2 eta-0))) ((27) (lambda (eta-0) (CoreC-45Primitives-doubleSin eta-0))) ((28) (lambda (eta-0) (CoreC-45Primitives-doubleCos eta-0))) ((29) (lambda (eta-0) (CoreC-45Primitives-doubleTan eta-0))) ((30) (lambda (eta-0) (CoreC-45Primitives-doubleASin eta-0))) ((31) (lambda (eta-0) (CoreC-45Primitives-doubleACos eta-0))) ((32) (lambda (eta-0) (CoreC-45Primitives-doubleATan eta-0))) ((33) (lambda (eta-0) (CoreC-45Primitives-doubleSqrt eta-0))) ((34) (lambda (eta-0) (CoreC-45Primitives-doubleFloor eta-0))) ((35) (lambda (eta-0) (CoreC-45Primitives-doubleCeiling eta-0))) ((36) (let ((e-17 (vector-ref arg-1 2))) (lambda (eta-0) (CoreC-45Primitives-castTo e-17 eta-0)))) ((37) (lambda (eta-0) (CoreC-45Primitives-believeMe eta-0)))(else (lambda (eta-0) '())))))
(define AlgebraC-45Semiring-isErased (lambda (arg-1 ext-0) (AlgebraC-45Semiring-elimSemi arg-1 1 0 (lambda (eta-0) 0) ext-0)))
(define CoreC-45ContextC-45Log-unverifiedLogC (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (arg-3 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? arg-1 "") (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-2) (string-append ": " e-6))) "\xa;") clam-1))) (vector 1 act-3)))(else (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-1 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-2) (string-append ": " e-6))))) "\xa;") clam-1))) (vector 1 act-3))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define CoreC-45Value-u--show_Show_C-40NHeadC-32C-36freeC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 2))) (string-append (CoreC-45Name-u--show_Show_Name (CoreC-45TTC-45Var-nameAt arg-0 e-3)) (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Nat e-3) "]"))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (CoreC-45Name-u--show_Show_Name e-7))) (else (let ((e-9 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 3))) (string-append "?" (string-append (CoreC-45Name-u--show_Show_Name e-9) (string-append "_[" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-11)) " closures]"))))))))))
(define CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-3 0) ((0) (let ((e-51 (vector-ref e-3 2))) (let ((e-52 (vector-ref e-3 3))) (let ((e-53 (vector-ref e-3 4))) (string-append "\\" (string-append (CoreC-45TTC-45Term-withPiInfo csegen-864 e-52 (string-append (Algebra-showCount e-51) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-53))))) " => [closure]")))))) ((1) (let ((e-56 (vector-ref e-3 2))) (let ((e-57 (vector-ref e-3 3))) (let ((e-58 (vector-ref e-3 4))) (string-append "let " (string-append (Algebra-showCount e-56) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (string-append (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-58) (string-append " = " (string-append (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-57) " in [closure]"))))))))))) ((2) (let ((e-61 (vector-ref e-3 2))) (let ((e-62 (vector-ref e-3 3))) (let ((e-63 (vector-ref e-3 4))) (string-append (CoreC-45TTC-45Term-withPiInfo csegen-864 e-62 (string-append (Algebra-showCount e-61) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-63))))) " -> [closure]"))))) ((3) (let ((e-66 (vector-ref e-3 2))) (let ((e-67 (vector-ref e-3 3))) (let ((e-68 (vector-ref e-3 4))) (string-append (CoreC-45TTC-45Term-withPiInfo csegen-864 e-67 (string-append "pat " (string-append (Algebra-showCount e-66) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-68)))))) " => [closure]"))))) ((4) (let ((e-71 (vector-ref e-3 2))) (let ((e-72 (vector-ref e-3 3))) (let ((e-73 (vector-ref e-3 4))) (string-append "plet " (string-append (Algebra-showCount e-71) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (string-append (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-73) (string-append " = " (string-append (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-72) " in [closure]"))))))))))) (else (let ((e-76 (vector-ref e-3 2))) (let ((e-77 (vector-ref e-3 3))) (string-append "pty " (string-append (Algebra-showCount e-76) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (string-append (CoreC-45Value-u--show_Show_C-40ClosureC-32C-36freeC-41 e-77) " => [closure]")))))))))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (string-append (CoreC-45Value-u--show_Show_C-40NHeadC-32C-36freeC-41 arg-0 e-7) (string-append " [" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-8)) " closures]")))))) ((2) (let ((e-11 (vector-ref arg-1 2))) (let ((e-14 (vector-ref arg-1 5))) (string-append (CoreC-45Name-u--show_Show_Name e-11) (string-append " [" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-14)) " closures]")))))) ((3) (let ((e-17 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 5))) (string-append (CoreC-45Name-u--show_Show_Name e-17) (string-append " [" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-20)) " closures]")))))) ((4) (let ((e-24 (vector-ref arg-1 3))) (let ((e-25 (vector-ref arg-1 4))) (string-append (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-24) (string-append "@" (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-25)))))) ((5) (let ((e-29 (vector-ref arg-1 3))) (string-append "%Delayed " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-29)))) ((6) "%Delay [closure]") ((7) (let ((e-38 (vector-ref arg-1 3))) (let ((e-39 (vector-ref arg-1 4))) (string-append "%Force " (string-append (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-0 e-38) (string-append " [" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-39)) " closures]"))))))) ((8) (let ((e-42 (vector-ref arg-1 2))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-42))) ((9) "[__]") (else "Type"))))
(define CoreC-45ContextC-45Log-log (lambda (arg-0 arg-1 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (cond ((equal? arg-1 "") (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (arg-4)))) "\xa;") clam-0))) (vector 1 act-2)))(else (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-1 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (arg-4)))))) "\xa;") clam-0))) (vector 1 act-2))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Eval-getCaseBound (lambda (arg-0 arg-1 arg-4 arg-5 arg-6) (if (null? arg-4) (if (null? arg-5) (box arg-6) '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? arg-5) '() (let ((e-11 (cdr arg-5))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-2) (cons e-2 arg-2)) (CoreC-45NormaliseC-45Eval-getCaseBound arg-0 arg-1 e-3 e-11 arg-6)))))))))
(define CoreC-45NormaliseC-45Eval-evalConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((sc0 (CoreC-45NormaliseC-45Eval-getCaseBound arg-0 arg-1 arg-11 arg-10 arg-6))) (if (null? sc0) (lambda (eta-0) (vector 1 (vector 2 ))) (let ((e-1 (unbox sc0))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-tailRecAppend arg-10 arg-3) arg-4 arg-5 e-1 arg-7 arg-8 arg-9 arg-12 eta-0)))))))
(define CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((2) 1) ((3) 1) ((8) 1) ((0) 1) ((10) 1) ((6) 1)(else 0))))
(define CoreC-45NormaliseC-45Eval-tryAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-10 0) ((9) (let ((e-4 (vector-ref arg-10 2))) (case (vector-ref e-4 0) ((2) (let ((e-34 (vector-ref e-4 1))) (CoreC-45NormaliseC-45Eval-tryAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-34 arg-11)))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))) ((2) (let ((e-8 (vector-ref arg-10 3))) (let ((e-10 (vector-ref arg-10 5))) (case (vector-ref arg-11 0) ((0) (let ((e-37 (vector-ref arg-11 2))) (let ((e-38 (vector-ref arg-11 3))) (let ((e-39 (vector-ref arg-11 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-37 e-8))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalConAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-38 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-10) e-39)) (else (lambda (eta-0) (vector 1 (vector 1 ))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))) ((3) (let ((e-13 (vector-ref arg-10 2))) (let ((e-16 (vector-ref arg-10 5))) (case (vector-ref arg-11 0) ((0) (let ((e-41 (vector-ref arg-11 1))) (let ((e-43 (vector-ref arg-11 3))) (let ((e-44 (vector-ref arg-11 4))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-13 e-41))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Eval-evalConAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-43 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-16) e-44)) (else (lambda (eta-0) (vector 1 (vector 1 ))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))) ((8) (let ((e-19 (vector-ref arg-10 2))) (case (vector-ref arg-11 0) ((0) (let ((e-46 (vector-ref arg-11 1))) (let ((e-48 (vector-ref arg-11 3))) (let ((e-49 (vector-ref arg-11 4))) (if (null? e-48) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_Constant e-19))) e-46))) (cond ((equal? sc3 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-49 eta-0))) (else (lambda (eta-0) (vector 1 (vector 1 )))))) (lambda (eta-0) (vector 1 (vector 1 )))))))) ((2) (let ((e-51 (vector-ref arg-11 1))) (let ((e-52 (vector-ref arg-11 2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-51 e-19))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-52 eta-0))) (else (lambda (eta-0) (vector 1 (vector 1 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))) ((10) (case (vector-ref arg-11 0) ((0) (let ((e-54 (vector-ref arg-11 1))) (let ((e-56 (vector-ref arg-11 3))) (let ((e-57 (vector-ref arg-11 4))) (case (vector-ref e-54 0) ((1) (let ((e-58 (vector-ref e-54 1))) (case (vector-ref e-58 0) ((0) (let ((e-59 (vector-ref e-58 1))) (cond ((equal? e-59 "Type") (if (null? e-56) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-57 eta-0)) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc7 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc7 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc5 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc5 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc4 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc4 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc3 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc3 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))) ((0) (let ((e-24 (vector-ref arg-10 1))) (let ((e-25 (vector-ref arg-10 2))) (let ((e-26 (vector-ref arg-10 3))) (let ((e-27 (vector-ref arg-10 4))) (case (vector-ref e-26 0) ((2) (let ((e-62 (vector-ref e-26 1))) (let ((e-63 (vector-ref e-26 2))) (let ((e-64 (vector-ref e-26 3))) (let ((e-65 (vector-ref e-26 4))) (case (vector-ref arg-11 0) ((0) (let ((e-67 (vector-ref arg-11 1))) (let ((e-69 (vector-ref arg-11 3))) (let ((e-70 (vector-ref arg-11 4))) (case (vector-ref e-67 0) ((1) (let ((e-71 (vector-ref e-67 1))) (case (vector-ref e-71 0) ((0) (let ((e-72 (vector-ref e-71 1))) (cond ((equal? e-72 "->") (if (null? e-69) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc8 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc8 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))) (let ((e-74 (car e-69))) (let ((e-75 (cdr e-69))) (if (null? e-75) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc9 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc9 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))) (let ((e-77 (car e-75))) (let ((e-78 (cdr e-75))) (if (null? e-78) (CoreC-45NormaliseC-45Eval-evalConAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-74 (cons e-77 '())) (cons e-65 (cons (vector 1 arg-7 arg-5 (vector 0 e-24 e-25 (vector 0 e-62 e-63 e-64 e-65) e-27)) '())) e-70) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc10 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc10 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc6 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc6 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc5 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc5 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc4 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc4 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc3 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc3 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))))) ((6) (let ((e-31 (vector-ref arg-10 3))) (let ((e-32 (vector-ref arg-10 4))) (case (vector-ref arg-11 0) ((1) (let ((e-81 (vector-ref arg-11 1))) (let ((e-82 (vector-ref arg-11 2))) (let ((e-83 (vector-ref arg-11 3))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 (cons e-81 (cons e-82 arg-4)) arg-3 arg-5 (cons e-31 (cons e-32 arg-6)) arg-7 arg-8 arg-9 e-83 eta-0))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc2 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 ))))))))))(else (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((sc1 (CoreC-45NormaliseC-45Eval-n--9392-5094-u--concrete arg-0 arg-1 arg-3 arg-4 e-1 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-2 arg-10))) (cond ((equal? sc1 1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 eta-0))) (else (lambda (eta-0) (vector 1 (vector 2 ))))))))(else (lambda (eta-0) (vector 1 (vector 2 )))))))))
(define CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseAltC-32C-36varsC-41 (lambda (arg-0 ext-0) (CoreC-45CaseC-45CaseTree-showCA arg-0 "" ext-0)))
(define CoreC-45NormaliseC-45Eval-findAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (let ((act-1 (CoreC-45ContextC-45Log-log arg-2 "eval.casetree.stuck" 2 (lambda () "Ran out of alternatives") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 2 ))))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-tryAlt arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((0) (lambda (eta-0) (vector 1 e-5))) ((1) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-findAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 eta-0))) (else (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.casetree.stuck" 5 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-2 csegen-1378 arg-10 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Context-toFullNames arg-2 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40CaseAltC-32C-36varsC-41 arg-7719 arg-7722 eta-3)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_C-40CaseAltC-32C-36varsC-41 arg-7729 arg-7732 eta-3))))) e-2 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-4) eta-4) (cons "Got stuck matching " (cons (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-4 e-6) (cons " against " (cons (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseAltC-32C-36varsC-41 arg-3 e-7) '()))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 (vector 2 )))))))))) eff-0) ext-0))))))))))
(define CoreC-45NormaliseC-45Eval-updateLocal (lambda (arg-0 arg-1 arg-5 arg-6 arg-7 arg-9 arg-10) (cond ((equal? arg-7 0) (if (null? arg-9) arg-9 (let ((e-5 (cdr arg-9))) (cons (vector 1 arg-5 arg-6 arg-10) e-5))))(else (let ((e-0 (- arg-7 1))) (if (null? arg-9) arg-9 (let ((e-9 (car arg-9))) (let ((e-10 (cdr arg-9))) (cons e-9 (CoreC-45NormaliseC-45Eval-updateLocal arg-0 arg-1 arg-5 arg-6 e-0 e-10 arg-10))))))))))
(define CoreC-45NormaliseC-45Eval-evalTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-10 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-2 arg-4 arg-5 arg-8 '() e-2 '() arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.casetree" 5 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-2 csegen-1378 e-6 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Evaluated " (cons (CoreC-45Name-u--show_Show_Name e-1) (cons " to " (cons (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-4 e-7) '()))))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((u--locC-39 (CoreC-45NormaliseC-45Eval-updateLocal arg-0 arg-1 arg-7 arg-5 e-2 arg-6 e-6))) (CoreC-45NormaliseC-45Eval-findAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--locC-39 arg-7 arg-8 arg-9 e-6 e-5 eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-8 (vector-ref arg-10 2))) (vector 1 (vector 0 (vector arg-3 arg-6 e-8)))))(else (vector 1 (vector 2 ))))))
(define CoreC-45NormaliseC-45Eval-case--caseC-32blockC-32inC-32evalDef-5934 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (lambda (clam-0) (if (null? arg-17) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-16 "eval.def.underapplied" 50 (lambda (eta-0) (let ((act-1 (CoreC-45Context-toFullNames arg-16 csegen-1378 (arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Cannot reduce under-applied " (cons (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-2 e-5) '()))))))) eff-0) eta-0)))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (arg-8))))) (let ((e-2 (unbox arg-17))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-1 (CoreC-45NormaliseC-45Eval-evalTree arg-0 arg-1 arg-16 arg-3 arg-2 arg-15 e-5 arg-14 arg-12 e-6 arg-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-7 0) ((0) (let ((e-1 (vector-ref e-7 1))) (let ((e-3 (vector-ref e-1 0))) (let ((e-4 (vector-ref e-1 1))) (let ((e-8 (vector-ref e-1 2))) (let ((e-11 (vector-ref arg-14 5))) (if (null? e-11) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-16 arg-2 e-3 arg-0 arg-14 arg-15 e-4 e-8 e-6) (let ((e-16 (unbox e-11))) (cond ((equal? e-16 0) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-16 "eval.def.stuck" 50 (lambda () "Recursion depth limit exceeded") eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-17 (vector-ref act-2 1))) (vector 0 e-17))) (else (vector 1 (arg-8)))))))(else (let ((e-17 (- e-16 1))) (let ((u--optsC-39 (let ((e-25 (vector-ref arg-14 0))) (let ((e-24 (vector-ref arg-14 1))) (let ((e-23 (vector-ref arg-14 2))) (let ((e-22 (vector-ref arg-14 3))) (let ((e-21 (vector-ref arg-14 4))) (let ((e-19 (vector-ref arg-14 6))) (let ((e-18 (vector-ref arg-14 7))) (vector e-25 e-24 e-23 e-22 e-21 (box e-17) e-19 e-18)))))))))) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-16 arg-2 e-3 arg-0 u--optsC-39 arg-15 e-4 e-8 e-6)))))))))))))(else (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-16 "eval.def.stuck" 50 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-16 csegen-1378 (arg-8) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "evalTree failed on " (cons (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-2 e-8) '()))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (arg-8)))))))))) eff-0) clam-0))))))))))))
(define CoreC-45NormaliseC-45Eval-evalDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-9 0) ((1) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (let ((e-2 (vector-ref arg-9 3))) (let ((e-3 (vector-ref arg-9 4))) (let ((e-4 (vector-ref arg-9 5))) (let ((sc1 (let ((sc2 (let ((e-6 (vector-ref e-0 1))) e-6))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (let ((sc4 (let ((e-12 (vector-ref arg-5 0))) e-12))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (let ((e-11 (vector-ref arg-5 1))) e-11))) (cond ((equal? sc5 1) 1) (else (let ((e-8 (vector-ref arg-5 4))) e-8))))))))) (cond ((equal? sc3 1) (let ((sc4 (cond ((equal? arg-6 1) (let ((sc6 (AlgebraC-45Semiring-isErased csegen-931 arg-8))) (cond ((equal? sc6 1) 0) (else 1)))) (else 0)))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (cond ((equal? arg-6 1) (let ((e-12 (vector-ref arg-5 0))) e-12)) (else 0)))) (cond ((equal? sc5 1) 1) (else (let ((sc6 (let ((e-8 (vector-ref arg-5 4))) e-8))) (cond ((equal? sc6 1) (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 5 ) arg-10)) (else 0)))))))))) (else 1)))))))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-case--caseC-32blockC-32inC-32evalDef-5934 arg-0 arg-1 arg-3 e-1 e-3 e-4 e-2 e-0 arg-12 arg-11 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 (CoreC-45NormaliseC-45Eval-argsFromStack arg-0 arg-1 e-1 arg-11))) (else (lambda (eta-0) (vector 1 (arg-12)))))))))))) ((4) (let ((e-5 (vector-ref arg-9 1))) (let ((e-6 (vector-ref arg-9 2))) (CoreC-45NormaliseC-45Eval-evalOp arg-0 arg-1 arg-2 e-5 arg-3 (CoreC-45Primitives-getOp e-6 arg-3) arg-11 arg-12))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.def.stuck" 50 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-2 csegen-1378 (arg-12) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Cannot reduce def " (cons (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-3 e-5) (cons ": it is a " (cons (CoreC-45ContextC-45Context-u--show_Show_Def arg-9) '()))))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (arg-12))))))))))
(define CoreC-45TTC-45Primitive-isConstantType (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (cond ((equal? e-1 "Int") (box 0)) ((equal? e-1 "Int8") (box 1)) ((equal? e-1 "Int16") (box 2)) ((equal? e-1 "Int32") (box 3)) ((equal? e-1 "Int64") (box 4)) ((equal? e-1 "Integer") (box 5)) ((equal? e-1 "Bits8") (box 6)) ((equal? e-1 "Bits16") (box 7)) ((equal? e-1 "Bits32") (box 8)) ((equal? e-1 "Bits64") (box 9)) ((equal? e-1 "String") (box 10)) ((equal? e-1 "Char") (box 11)) ((equal? e-1 "Double") (box 12)) ((equal? e-1 "%World") (box 13))(else '()))))(else '()))))(else '()))))
(define CoreC-45Value-ntCon (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (cond ((equal? e-2 "Type") (cond ((equal? arg-4 0) (if (null? arg-5) (vector 10 arg-1 (vector 2 "top" 0)) (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc7 (CoreC-45TTC-45Primitive-isConstantType arg-2))) (if (null? sc7) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-3 (unbox sc7))) (vector 8 arg-1 (vector 13 e-3))))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc5 (CoreC-45TTC-45Primitive-isConstantType arg-2))) (if (null? sc5) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-3 (unbox sc5))) (vector 8 arg-1 (vector 13 e-3))))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5))))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc4 (CoreC-45TTC-45Primitive-isConstantType arg-2))) (if (null? sc4) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-3 (unbox sc4))) (vector 8 arg-1 (vector 13 e-3))))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc3 (CoreC-45TTC-45Primitive-isConstantType arg-2))) (if (null? sc3) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-2 (unbox sc3))) (vector 8 arg-1 (vector 13 e-2))))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))))(else (cond ((equal? arg-4 0) (if (null? arg-5) (let ((sc2 (CoreC-45TTC-45Primitive-isConstantType arg-2))) (if (null? sc2) (vector 3 arg-1 arg-2 arg-3 0 '()) (let ((e-1 (unbox sc2))) (vector 8 arg-1 (vector 13 e-1))))) (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))(else (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5)))))))
(define CoreC-45NameC-45Namespace-isParentOf (lambda (arg-0 arg-1) (DataC-45List-isSuffixOf csegen-22 arg-0 arg-1)))
(define CoreC-45Context-reducibleIn (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((1) (cond ((equal? arg-2 1) (CoreC-45NameC-45Namespace-isParentOf e-0 arg-0)) ((equal? arg-2 0) (CoreC-45NameC-45Namespace-isParentOf e-0 arg-0))(else 1)))(else 1)))))(else 1))))
(define CoreC-45Context-reducibleInAny (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (u--ns) (CoreC-45Context-reducibleIn u--ns arg-1 arg-2)) arg-0)))
(define DataC-45List-lookupBy (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 ((arg-3 arg-4) e-6))) (cond ((equal? sc2 1) (box e-7)) (else (DataC-45List-lookupBy arg-3 arg-4 e-3)))))))))))
(define DataC-45List-lookup (lambda (arg-2 ext-0 ext-1) (DataC-45List-lookupBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define CoreC-45NormaliseC-45Eval-n--9054-1890-u--set (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-6 arg-2))) (cond ((equal? sc2 1) (cons (cons e-6 arg-3) e-3)) (else (cons (cons e-6 e-7) (CoreC-45NormaliseC-45Eval-n--9054-1890-u--set arg-0 arg-1 arg-2 arg-3 e-3))))))))))))
(define CoreC-45NormaliseC-45Eval-updateLimit (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-0 0) ((1) (vector 1 (let ((sc1 (DataC-45List-isNil (let ((e-6 (vector-ref arg-2 6))) e-6)))) (cond ((equal? sc1 1) (box arg-2)) (else (let ((sc2 (DataC-45List-lookup csegen-832 arg-1 (let ((e-6 (vector-ref arg-2 6))) e-6)))) (if (null? sc2) '() (let ((e-2 (unbox sc2))) (cond ((equal? e-2 0) '())(else (let ((e-3 (- e-2 1))) (box (let ((e-0 (vector-ref arg-2 0))) (let ((e-1 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (let ((e-7 (vector-ref arg-2 7))) (vector e-0 e-1 e-9 e-8 e-4 e-5 (CoreC-45NormaliseC-45Eval-n--9054-1890-u--set arg-2 arg-1 arg-1 e-3 e-6) e-7)))))))))))))))))))))(else (vector 1 (box arg-2))))))
(define CoreC-45NormaliseC-45Eval-evalRef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-7 0) ((2) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (vector 1 (vector 2 arg-6 arg-8 e-0 e-1 arg-9))))) ((3) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (vector 1 (CoreC-45Value-ntCon arg-6 arg-8 e-2 e-3 arg-9))))) ((0) (vector 1 (arg-10))) (else (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-8 (let ((e-0 (vector-ref arg-0 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nt (vector 1 ))) (if (null? e-5) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.stuck.outofscope" 5 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-2 csegen-54 arg-8 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Stuck function: " (CoreC-45Name-u--show_Show_Name e-6)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (arg-10)))))) (let ((e-1 (unbox e-5))) (let ((u--redok1 (let ((e-3 (vector-ref arg-1 3))) e-3))) (let ((u--redok2 (CoreC-45Context-reducibleInAny (cons (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-3 (vector-ref arg-0 3))) e-3)) (let ((e-24 (vector-ref e-1 1))) e-24) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-1 9))) e-9))))) (let ((u--redok (cond ((equal? u--redok1 1) 1) (else u--redok2)))) (lambda (eta-0) (let ((act-2 (CoreC-45Context-checkTimer arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (cond ((equal? u--redok2 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "eval.stuck" 5 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-2 csegen-54 arg-8 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Stuck function: " (cons (CoreC-45Name-u--show_Show_Name e-7) '()))))))) eff-0) eta-1)))))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (cond ((equal? u--redok 1) (let ((act-4 (CoreC-45NormaliseC-45Eval-updateLimit u--nt arg-8 arg-1 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (let ((act-5 (CoreC-45ContextC-45Log-log arg-2 "eval.stuck" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Function " (cons (CoreC-45Name-u--show_Show_Name arg-8) (cons " past reduction limit" '()))))) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (arg-10))))) (let ((e-2 (unbox e-8))) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalDef arg-0 arg-1 arg-2 arg-3 arg-4 e-2 arg-5 arg-6 (let ((e-24 (vector-ref e-1 7))) e-24) (let ((e-18 (vector-ref e-1 18))) e-18) (let ((e-12 (vector-ref e-1 12))) e-12) arg-9 arg-10) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 e-9)))) eff-0) clam-1)))))))))) eff-0) eta-0)))))) (else (vector 1 (arg-10))))))))))))))))))) eff-0) ext-0)))))))))
(define CoreC-45NormaliseC-45Eval-evalMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--argsC-39 (let ((sc0 (DataC-45List-isNil arg-9))) (cond ((equal? sc0 1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-8)) (else (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-8) arg-9)))))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalRef arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-5 (vector 1 ) (vector 8 arg-7) u--argsC-39 (lambda () (vector 1 arg-5 (vector 2 arg-6 arg-7 arg-8) arg-9)) eta-0)))))
(define CoreC-45TTC-45Term-u--traverse_Traversable_WhyErased (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) (vector 0 )))) ((1) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) (vector 1 )))) (else (let ((e-3 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-3 0))) ((((e-1 'erased) 'erased) (lambda (eta-0) (vector 2 eta-0))) (arg-4 e-3))))))))
(define CoreC-45NormaliseC-45Eval-n--9380-2711-u--closeArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) '() (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (cons (vector 0 arg-2 arg-1 arg-9 arg-10 e-2) (CoreC-45NormaliseC-45Eval-n--9380-2711-u--closeArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3)))))))
(define CoreC-45NormaliseC-45Eval-eval (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-2 arg-3 arg-5 e-2 e-3 e-4 arg-8 arg-6))))) ((1) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalRef arg-0 arg-1 arg-2 arg-3 arg-5 0 e-7 e-8 e-9 arg-8 (lambda () (vector 1 e-7 (vector 1 e-8 e-9) arg-8)) eta-0)))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Eval-evalMeta arg-0 arg-1 arg-2 arg-3 arg-5 e-11 e-12 e-13 (CoreC-45NormaliseC-45Eval-n--9380-2711-u--closeArgs arg-0 arg-1 arg-4 arg-3 e-14 e-13 e-12 e-11 arg-8 arg-6 arg-5 arg-2 e-14) arg-8)))))) ((3) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-19 (vector-ref arg-7 4))) (case (vector-ref e-18 0) ((0) (if (null? arg-8) (let ((u--bC-39 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (vector 0 arg-4 arg-1 arg-6 arg-5 eta-0)) e-18))) (lambda (eta-0) (vector 1 (vector 0 e-16 e-17 u--bC-39 (lambda (u--defsC-39) (lambda (u--arg) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 (cons e-17 arg-4) u--defsC-39 arg-1 arg-5 (cons u--arg arg-6) e-19 arg-8))))))) (let ((e-62 (car arg-8))) (let ((e-63 (cdr arg-8))) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons e-17 arg-4) arg-5 (cons (Builtin-snd e-62) arg-6) e-19 e-63))))) ((1) (let ((e-57 (vector-ref e-18 1))) (let ((e-58 (vector-ref e-18 2))) (let ((e-59 (vector-ref e-18 3))) (let ((e-60 (vector-ref e-18 4))) (let ((u--b (vector 1 e-57 e-58 e-59 e-60))) (let ((sc2 (let ((sc3 (let ((sc4 (let ((e-0 (vector-ref arg-1 0))) e-0))) (cond ((equal? sc4 1) 1) (else (let ((e-1 (vector-ref arg-1 1))) e-1)))))) (cond ((equal? sc3 1) (let ((sc4 (let ((e-4 (vector-ref arg-1 4))) e-4))) (cond ((equal? sc4 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc2 1) (let ((u--bC-39 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (vector 0 arg-4 arg-1 arg-6 arg-5 eta-0)) u--b))) (lambda (eta-0) (vector 1 (vector 0 e-16 e-17 u--bC-39 (lambda (u--defsC-39) (lambda (u--arg) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 (cons e-17 arg-4) u--defsC-39 arg-1 arg-5 (cons u--arg arg-6) e-19 arg-8)))))))) (else (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons e-17 arg-4) arg-5 (cons (vector 0 arg-4 arg-1 arg-6 arg-5 e-59) arg-6) e-19 arg-8))))))))))(else (let ((u--bC-39 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (vector 0 arg-4 arg-1 arg-6 arg-5 eta-0)) e-18))) (lambda (eta-0) (vector 1 (vector 0 e-16 e-17 u--bC-39 (lambda (u--defsC-39) (lambda (u--arg) (CoreC-45NormaliseC-45Eval-evalWithOpts arg-2 arg-3 (cons e-17 arg-4) u--defsC-39 arg-1 arg-5 (cons u--arg arg-6) e-19 arg-8)))))))))))))) ((4) (let ((e-21 (vector-ref arg-7 1))) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (let ((sc1 (let ((e-7 (vector-ref arg-1 7))) e-7))) (cond ((equal? sc1 0) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-23 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22 (cons (cons e-21 (vector 1 arg-1 arg-5 e-5)) arg-8)))) eff-0) eta-0))))))) (else (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-22 (cons (cons e-21 (vector 0 arg-4 arg-1 arg-6 arg-5 e-23)) arg-8))))))))) ((5) (let ((e-25 (vector-ref arg-7 1))) (let ((e-26 (vector-ref arg-7 2))) (let ((e-27 (vector-ref arg-7 3))) (let ((e-28 (vector-ref arg-7 4))) (let ((sc1 (let ((e-2 (vector-ref arg-1 2))) e-2))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-28 arg-8)) (else (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27 arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-28 arg-8) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-25 e-26 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((6) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-32 arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-30 e-31 e-5))))) eff-0) eta-0)))))))))) ((7) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (let ((e-37 (vector-ref arg-7 4))) (lambda (eta-0) (vector 1 (vector 6 e-34 e-35 (vector 0 arg-4 arg-1 arg-6 arg-5 e-36) (vector 0 arg-4 arg-1 arg-6 arg-5 e-37))))))))) ((8) (let ((e-39 (vector-ref arg-7 1))) (let ((e-40 (vector-ref arg-7 2))) (let ((e-41 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-41 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((6) (let ((e-1 (vector-ref e-5 1))) (let ((e-4 (vector-ref e-5 4))) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons (vector 1 (vector 0 "fvar")) arg-4) arg-5 (cons e-4 arg-6) (vector 0 e-1 '() 0) arg-8))))(else (lambda (eta-1) (vector 1 (vector 7 e-39 e-40 e-5 arg-8))))))) eff-0) eta-0)))))))))) ((9) (let ((e-43 (vector-ref arg-7 1))) (let ((e-44 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 8 e-43 e-44)))))) ((10) (let ((e-46 (vector-ref arg-7 1))) (let ((e-47 (vector-ref arg-7 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 9 e-46 e-5)))))) (CoreC-45TTC-45Term-u--traverse_Traversable_WhyErased csegen-999 (lambda (u--t) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--t arg-8)) e-47) eta-0))))) (else (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (vector 10 e-49 e-50)))))))))
(define CoreC-45NormaliseC-45Eval-applyToStack (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((0) (lambda (clam-0) (if (null? arg-6) (vector 1 (vector 0 e-1 e-2 e-3 (lambda (u--defsC-39) (lambda (u--arg) (lambda (eta-0) (let ((act-1 (((e-4 u--defsC-39) u--arg) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6))) eff-0) eta-0)))))))))) (let ((e-60 (car arg-6))) (let ((e-61 (cdr arg-6))) (let ((act-1 (((e-4 arg-0) (Builtin-snd e-60)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-5 e-61))) eff-0) clam-0)))))))))) ((1) (let ((e-55 (vector-ref e-3 1))) (let ((e-56 (vector-ref e-3 2))) (let ((e-57 (vector-ref e-3 3))) (let ((e-58 (vector-ref e-3 4))) (let ((u--b (vector 1 e-55 e-56 e-57 e-58))) (lambda (clam-1) (let ((sc2 (let ((sc3 (let ((sc4 (let ((e-0 (vector-ref arg-1 0))) e-0))) (cond ((equal? sc4 1) 1) (else (let ((e-11 (vector-ref arg-1 1))) e-11)))))) (cond ((equal? sc3 1) (let ((sc4 (let ((e-8 (vector-ref arg-1 4))) e-8))) (cond ((equal? sc4 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc2 1) (vector 1 (vector 0 e-1 e-2 u--b (lambda (u--defsC-39) (lambda (u--arg) (lambda (eta-0) (let ((act-1 (((e-4 u--defsC-39) u--arg) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6))) eff-0) eta-0))))))))))) (else (let ((act-1 (((e-4 arg-0) e-57) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6))) eff-0) clam-1)))))))))))))))(else (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-3 (lambda (u--defsC-39) (lambda (u--arg) (lambda (eta-1) (let ((act-1 (((e-4 u--defsC-39) u--arg) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6))) eff-0) eta-1)))))))))))))))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (case (vector-ref e-7 0) ((1) (let ((e-63 (vector-ref e-7 1))) (let ((e-64 (vector-ref e-7 2))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalRef arg-0 arg-1 arg-2 arg-3 arg-4 0 e-6 e-63 e-64 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-6) (lambda () (vector 1 e-6 (vector 1 e-63 e-64) (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-6))) eta-0))))) ((0) (let ((e-67 (vector-ref e-7 1))) (let ((e-68 (vector-ref e-7 2))) (CoreC-45NormaliseC-45Eval-evalLocal arg-0 arg-1 arg-2 arg-3 arg-4 e-6 e-67 e-68 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-6) '())))) (else (let ((e-71 (vector-ref e-7 1))) (let ((e-72 (vector-ref e-7 2))) (let ((e-73 (vector-ref e-7 3))) (CoreC-45NormaliseC-45Eval-evalMeta arg-0 arg-1 arg-2 arg-3 arg-4 e-6 e-71 e-72 e-73 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-6))))))))))) ((2) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-13 (vector-ref arg-5 4))) (let ((e-14 (vector-ref arg-5 5))) (lambda (eta-0) (vector 1 (vector 2 e-10 e-11 e-12 e-13 (PreludeC-45TypesC-45List-tailRecAppend e-14 arg-6)))))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (let ((e-20 (vector-ref arg-5 5))) (lambda (eta-0) (vector 1 (vector 3 e-16 e-17 e-18 e-19 (PreludeC-45TypesC-45List-tailRecAppend e-20 arg-6)))))))))) ((4) (let ((e-22 (vector-ref arg-5 1))) (let ((e-23 (vector-ref arg-5 2))) (let ((e-24 (vector-ref arg-5 3))) (let ((e-25 (vector-ref arg-5 4))) (let ((sc1 (let ((e-2 (vector-ref arg-1 2))) e-2))) (cond ((equal? sc1 1) (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-25 arg-6)) (else (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-24 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-25 arg-6) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-22 e-23 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((5) (let ((e-27 (vector-ref arg-5 1))) (let ((e-28 (vector-ref arg-5 2))) (let ((e-29 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-29 arg-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-27 e-28 e-5))))) eff-0) eta-0)))))))))) ((6) (lambda (eta-0) (vector 1 arg-5))) ((7) (let ((e-36 (vector-ref arg-5 1))) (let ((e-37 (vector-ref arg-5 2))) (let ((e-38 (vector-ref arg-5 3))) (let ((e-39 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 e-38 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((6) (let ((e-1 (vector-ref e-5 1))) (let ((e-4 (vector-ref e-5 4))) (CoreC-45NormaliseC-45Eval-eval arg-0 arg-1 arg-2 arg-3 (cons (vector 1 (vector 0 "fvar")) '()) arg-4 (cons e-4 '()) (vector 0 e-1 '() 0) arg-6))))(else (lambda (eta-1) (vector 1 (vector 7 e-36 e-37 e-5 (PreludeC-45TypesC-45List-tailRecAppend e-39 arg-6)))))))) eff-0) eta-0))))))))))) ((8) (lambda (eta-0) (vector 1 arg-5))) ((9) (let ((e-44 (vector-ref arg-5 1))) (let ((e-45 (vector-ref arg-5 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 9 e-44 e-5)))))) (CoreC-45TTC-45Term-u--traverse_Traversable_WhyErased csegen-999 (lambda (u--t) (CoreC-45NormaliseC-45Eval-applyToStack arg-0 arg-1 arg-2 arg-3 arg-4 u--t arg-6)) e-45) eta-0))))) (else (lambda (eta-0) (vector 1 arg-5))))))
(define CoreC-45NormaliseC-45Eval-evalClosure (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (CoreC-45NormaliseC-45Eval-eval arg-2 e-2 arg-0 arg-1 e-1 e-4 e-3 e-5 '()))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (CoreC-45NormaliseC-45Eval-applyToStack arg-2 e-7 arg-0 arg-1 e-8 e-9 '()))))))))
(define CoreC-45NormaliseC-45Quote-genName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-quoteArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-quoteArgWithFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (CoreC-45Core-traversePair (lambda (eta-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0 eta-1))) ext-0)))
(define CoreC-45NormaliseC-45Quote-quoteArgsWithFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteArgWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) ext-0 '())))
(define CoreC-45NormaliseC-45Quote-quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-8 1))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45NormaliseC-45Quote-quoteBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((e-9 (vector-ref arg-8 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-6 e-7 e-5 e-10))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((2) (let ((e-11 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 2))) (let ((e-13 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-11 e-12 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((3) (let ((e-16 (vector-ref arg-8 1))) (let ((e-17 (vector-ref arg-8 2))) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-19) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-18 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-16 e-17 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((4) (let ((e-21 (vector-ref arg-8 1))) (let ((e-22 (vector-ref arg-8 2))) (let ((e-23 (vector-ref arg-8 3))) (let ((e-24 (vector-ref arg-8 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-23) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-24) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-21 e-22 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) (else (let ((e-26 (vector-ref arg-8 1))) (let ((e-27 (vector-ref arg-8 2))) (let ((e-28 (vector-ref arg-8 3))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-28) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-26 e-27 e-5))))) eff-0) ext-0))))))))))))
(define CoreC-45NormaliseC-45Quote-quoteArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0 eta-1))) ext-0 '())))
(define CoreC-45NormaliseC-45Quote-n--7831-7678-u--addLater (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-15 arg-16) (if (null? arg-16) arg-15 (let ((e-3 (cdr arg-16))) (let ((eff-0 (CoreC-45NormaliseC-45Quote-n--7831-7678-u--addLater arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-15 e-3))) (+ eff-0 1))))))
(define CoreC-45NormaliseC-45Quote-n--7831-7841-u--findName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12) (case (vector-ref arg-12 0) ((0) '()) (else (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-5))) (cond ((equal? sc2 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Quote-n--7831-7841-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) csegen-965))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Quote-n--7831-7841-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) csegen-965)))))))))
(define CoreC-45NormaliseC-45Quote-quoteHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (let ((eff-0 (CoreC-45NormaliseC-45Quote-n--7831-7678-u--addLater arg-2 e-3 e-2 arg-8 arg-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-3 arg-1))) (lambda (eta-0) (vector 1 (vector 0 arg-6 e-2 eff-0))))))) ((1) (let ((e-6 (vector-ref arg-9 1))) (let ((e-7 (vector-ref arg-9 2))) (lambda (clam-0) (case (vector-ref e-6 0) ((0) (case (vector-ref e-7 0) ((2) (let ((e-12 (vector-ref e-7 1))) (let ((e-13 (vector-ref e-7 2))) (vector 1 (let ((sc3 (CoreC-45NormaliseC-45Quote-n--7831-7841-u--findName arg-1 arg-2 e-13 e-12 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-7))) (if (null? sc3) (vector 1 arg-6 (vector 0 ) (vector 2 e-12 e-13)) (let ((e-1 (unbox sc3))) (vector 0 arg-6 '() e-1))))))))(else (vector 1 (vector 1 arg-6 e-6 e-7)))))(else (vector 1 (vector 1 arg-6 e-6 e-7)))))))) (else (let ((e-9 (vector-ref arg-9 1))) (let ((e-10 (vector-ref arg-9 2))) (let ((e-11 (vector-ref arg-9 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 e-11) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 arg-6 e-9 e-10 e-5))))) eff-0) eta-0)))))))))))))
(define CoreC-45NormaliseC-45Eval-toClosure (lambda (arg-1 arg-2 arg-3) (vector 0 '() arg-1 '() arg-2 arg-3)))
(define CoreC-45NormaliseC-45Quote-n--7945-8508-u--isRef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) 1)(else 0))))
(define CoreC-45NormaliseC-45Quote-n--7945-8868-u--toHolesOnly (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (let ((e-5 (vector-ref arg-13 5))) (vector 0 e-1 (let ((e-11 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (let ((e-9 (vector-ref e-2 4))) (let ((e-8 (vector-ref e-2 5))) (let ((e-6 (vector-ref e-2 6))) (let ((e-7 (vector-ref e-2 7))) (vector 1 1 e-11 e-10 e-9 e-8 e-6 e-7))))))) e-3 e-4 e-5)))))))(else arg-13))))
(define CoreC-45NormaliseC-45Quote-quoteGenNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-1 (CoreC-45NormaliseC-45Quote-genName arg-3 "qv" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (((e-4 arg-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-7 (vector 1 e-1 (vector 0 ) e-5))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 (cons e-2 arg-1) arg-2 arg-3 arg-4 arg-5 (vector 1 e-2 e-5 arg-6) arg-7 e-6 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-quoteBinder arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-1 e-2 e-7 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((act-1 ((CoreC-45NormaliseC-45Quote-quoteHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-6 arg-7 e-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((e-2 (vector-ref arg-4 2))) (if (null? e-2) (vector 1 arg-4) (let ((e-3 (unbox e-2))) (cond ((equal? e-3 0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Size limit exceeded") eta-0))(else (let ((e-4 (- e-3 1))) (vector 1 (let ((e-11 (vector-ref arg-4 0))) (let ((e-10 (vector-ref arg-4 1))) (vector e-11 e-10 (box e-4))))))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((sc3 (let ((sc4 (let ((e-1 (vector-ref arg-4 1))) e-1))) (cond ((equal? sc4 1) (let ((sc5 (let ((e-0 (vector-ref arg-4 0))) e-0))) (cond ((equal? sc5 1) 0) (else (CoreC-45NormaliseC-45Quote-n--7945-8508-u--isRef arg-1 arg-2 e-8 e-7 e-6 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-7))))) (else 0))))) (cond ((equal? sc3 1) (let ((act-3 (CoreC-45Context-clearDefs arg-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 e-9 e-10 arg-6 arg-7 e-8))) eff-0) eta-1)))))) (else ((CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (vector 0 e-1 e-2))) arg-5 arg-6 arg-7 e-8) eta-1)))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-5 e-10))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((2) (let ((e-10 (vector-ref arg-8 1))) (let ((e-11 (vector-ref arg-8 2))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-13 (vector-ref arg-8 4))) (let ((e-14 (vector-ref arg-8 5))) (let ((act-1 ((CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-10 (vector 2 e-12 e-13) e-11) e-5))))) eff-0) ext-0))))))))))) ((3) (let ((e-16 (vector-ref arg-8 1))) (let ((e-17 (vector-ref arg-8 2))) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (let ((e-20 (vector-ref arg-8 5))) (let ((act-1 ((CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-20) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-16 (vector 3 e-18 e-19) e-17) e-5))))) eff-0) ext-0))))))))))) ((4) (let ((e-22 (vector-ref arg-8 1))) (let ((e-23 (vector-ref arg-8 2))) (let ((e-24 (vector-ref arg-8 3))) (let ((e-25 (vector-ref arg-8 4))) (let ((act-1 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-24 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-25 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-22 e-23 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((5) (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((act-1 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-29 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-27 e-28 e-5))))) eff-0) ext-0))))))))) ((6) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-33 (vector-ref arg-8 3))) (let ((e-34 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 (CoreC-45NormaliseC-45Quote-n--7945-8868-u--toHolesOnly arg-1 arg-2 e-34 e-33 e-32 e-31 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-34)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 (CoreC-45NormaliseC-45Quote-n--7945-8868-u--toHolesOnly arg-1 arg-2 e-34 e-33 e-32 e-31 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 e-33)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-7 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 7 e-31 e-32 e-8 e-6))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((7) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (let ((e-39 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45NormaliseC-45Quote-quoteArgsWithFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-39) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-38 0) ((6) (let ((e-4 (vector-ref e-38 4))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 arg-5 e-4) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-7 e-5))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))(else (let ((act-2 (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-38 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 8 e-36 e-37 e-6) e-5))))) eff-0) clam-1)))))))))) eff-0) ext-0)))))))))) ((8) (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (vector 1 (vector 9 e-41 e-42))))) ((9) (let ((e-44 (vector-ref arg-8 1))) (let ((e-45 (vector-ref arg-8 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 10 e-44 e-5)))))) (CoreC-45TTC-45Term-u--traverse_Traversable_WhyErased csegen-999 (lambda (u--nf) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--nf eta-0))) e-45) ext-0)))) (else (let ((e-47 (vector-ref arg-8 1))) (let ((e-48 (vector-ref arg-8 2))) (vector 1 (vector 11 e-47 e-48))))))))
(define CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 '() arg-1 arg-2 arg-3 arg-4 (vector 0 ) arg-5 arg-6 eta-0))))
(define CoreC-45NormaliseC-45Quote-u--quote_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 e-5 (vector 1 0 '()) arg-2 arg-3 arg-4))) eff-0) ext-0)))))))
(define CoreC-45Normalise-logNF (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-6 arg-6 arg-7 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-68 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (cond ((equal? arg-2 "") (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8)))))) "\xa;") eta-2))) (vector 1 act-5)))(else (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8)))))))) "\xa;") eta-2))) (vector 1 act-5))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define CoreC-45Env-mkEnv (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (cons (vector 3 arg-0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 10 arg-0 (vector 0 ))) (CoreC-45Env-mkEnv arg-0 e-3))))))
(define CoreC-45Reflect-cantReify (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Normalise-logNF arg-2 arg-1 "reflection.reify" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Can't reify as " (cons arg-4 '())))) (CoreC-45Env-mkEnv CoreC-45FC-emptyFC arg-2) arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't reify as " arg-4)) ext-0))))))
(define CoreC-45Name-dropAllNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-dropAllNS e-1)))(else arg-0))))
(define CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-4 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Nil") (lambda (eta-0) (vector 1 '()))) ((equal? e-8 "::") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0)) (let ((e-9 (cdr e-5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-12) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0)) (let ((e-15 (cdr e-12))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0)) (let ((e-17 (car e-11))) (let ((e-18 (cdr e-11))) (if (null? e-17) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0)) (let ((e-22 (cdr e-17))) (lambda (clam-1) (if (null? e-18) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-15) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 ((((arg-1 arg-2) arg-3) arg-4) e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-22) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (((let ((eff-0 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 arg-1 u--c u--vars arg-1714 arg-1717))))))) (lambda (arg-0) (lambda (arg-6) ((((eff-0 arg-2) arg-3) arg-0) arg-6)))) arg-4) e-16))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-13 e-16))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" clam-1))))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "List" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-2 arg-3 arg-5 "List" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-4 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Nothing") (lambda (eta-0) (vector 1 '()))) ((equal? e-8 "Just") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" eta-0)) (let ((e-9 (cdr e-5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-12) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" eta-0)) (let ((e-15 (cdr e-12))) (lambda (clam-1) (if (null? e-11) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-15) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 ((((arg-1 arg-2) arg-3) arg-4) e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box e-13))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" clam-1)))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "Maybe" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-2 arg-3 arg-5 "Maybe" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((e-5 (vector-ref arg-5 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-4 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "ImplicitArg") (lambda (eta-0) (vector 1 (vector 0 )))) ((equal? e-8 "ExplicitArg") (lambda (eta-0) (vector 1 (vector 1 )))) ((equal? e-8 "AutoImplicit") (lambda (eta-0) (vector 1 (vector 2 )))) ((equal? e-8 "DefImplicit") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" eta-0)) (let ((e-9 (cdr e-5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-12) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" eta-0)) (let ((e-15 (cdr e-12))) (lambda (clam-1) (if (null? e-11) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-3 arg-4 e-15) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 ((((arg-1 arg-2) arg-3) arg-4) e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-13))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" clam-1)))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-2 arg-3 u--val "PiInfo" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-2 arg-3 arg-5 "PiInfo" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((2) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0)) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-13) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0)) (let ((e-17 (car e-13))) (let ((e-18 (cdr e-13))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0)) (let ((e-20 (car e-14))) (let ((e-21 (cdr e-14))) (if (null? e-20) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0)) (let ((e-24 (car e-20))) (let ((e-25 (cdr e-20))) (lambda (clam-0) (if (null? e-21) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 (cons e-7 (cons e-10 (cons (cons e-17 e-18) (cons (cons e-24 e-25) '()))))))) (let ((sc9 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc9 0) ((1) (let ((e-0 (vector-ref sc9 1))) (case (vector-ref e-0 0) ((0) (let ((e-9 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-9 "MkPair") (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-3 arg-4 arg-5 e-18) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-12 (vector-ref act-2 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (((let ((eff-0 (Builtin-fst arg-2))) (lambda (arg-0) (lambda (arg-1) ((((eff-0 arg-3) arg-4) arg-0) arg-1)))) arg-5) e-12))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-12 (vector-ref act-2 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-3 arg-4 arg-5 e-25) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (((let ((eff-0 (Builtin-snd arg-2))) (lambda (arg-0) (lambda (arg-1) ((((eff-0 arg-3) arg-4) arg-0) arg-1)))) arg-5) e-15))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-12 e-15))))) eff-0) eta-0)))))))) eff-0) clam-1))))))(else (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "Pair" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "Pair" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "Pair" eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" clam-0)))))))))))))))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "Pair" eta-0))))))
(define TTImpC-45Reflect-u--reify_Reify_AltType (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "FirstSuccess") (lambda (eta-0) (vector 1 (vector 0 )))) ((equal? e-8 "Unique") (lambda (eta-0) (vector 1 (vector 1 )))) ((equal? e-8 "UniqueDefault") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "AltType" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (lambda (clam-0) (if (null? e-10) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "AltType" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 eta-0)))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-13))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "AltType" clam-0)))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "AltType" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "AltType" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "AltType" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "AltType" ext-0)))))
(define CoreC-45Reflect-u--reify_Reify_RigCount (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-7 "M0") csegen-1598) ((equal? e-7 "M1") csegen-1599) ((equal? e-7 "MW") (vector 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Count" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Count" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Count" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Count" clam-0))))))
(define TTImpC-45Reflect-u--reify_Reify_BindMode (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "PI") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "BindMode" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (lambda (clam-0) (if (null? e-10) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "BindMode" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-13))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-13))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "BindMode" clam-0))))))))) ((equal? e-8 "PATTERN") (lambda (eta-0) (vector 1 (vector 1 )))) ((equal? e-8 "COVERAGE") (lambda (eta-0) (vector 1 (vector 2 )))) ((equal? e-8 "NONE") (lambda (eta-0) (vector 1 (vector 3 ))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "BindMode" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "BindMode" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "BindMode" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "BindMode" ext-0)))))
(define CoreC-45Reflect-u--reify_Reify_Bool (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-7 "True") (vector 1 1)) ((equal? e-7 "False") (vector 1 0))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Bool" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Bool" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Bool" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bool" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits16 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((7) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits16" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits16" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits32 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((8) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits32" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits32" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits64 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((9) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits64" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits64" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Bits8 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((6) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits8" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Bits8" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Char (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((11) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Char" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Char" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Double (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((12) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Double" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Double" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int16 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((2) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int16" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int16" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int32 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((3) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int32" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int32" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int64 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((4) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int64" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int64" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Int8 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int8" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Int8" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Integer (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((5) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Integer" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Integer" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_PrimType (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "IntType") (lambda (clam-1) (if (null? e-5) (vector 1 0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-1)))) ((equal? e-8 "Int8Type") (lambda (clam-2) (if (null? e-5) (vector 1 1) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-2)))) ((equal? e-8 "Int16Type") (lambda (clam-3) (if (null? e-5) (vector 1 2) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-3)))) ((equal? e-8 "Int32Type") (lambda (clam-4) (if (null? e-5) (vector 1 3) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-4)))) ((equal? e-8 "Int64Type") (lambda (clam-5) (if (null? e-5) (vector 1 4) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-5)))) ((equal? e-8 "IntegerType") (lambda (clam-6) (if (null? e-5) (vector 1 5) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-6)))) ((equal? e-8 "Bits8Type") (lambda (clam-7) (if (null? e-5) (vector 1 6) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-7)))) ((equal? e-8 "Bits16Type") (lambda (clam-8) (if (null? e-5) (vector 1 7) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-8)))) ((equal? e-8 "Bits32Type") (lambda (clam-9) (if (null? e-5) (vector 1 8) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-9)))) ((equal? e-8 "Bits64Type") (lambda (clam-10) (if (null? e-5) (vector 1 9) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-10)))) ((equal? e-8 "StringType") (lambda (clam-11) (if (null? e-5) (vector 1 10) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-11)))) ((equal? e-8 "CharType") (lambda (clam-12) (if (null? e-5) (vector 1 11) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-12)))) ((equal? e-8 "DoubleType") (lambda (clam-13) (if (null? e-5) (vector 1 12) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-13)))) ((equal? e-8 "WorldType") (lambda (clam-14) (if (null? e-5) (vector 1 13) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" clam-14))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "PrimType" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "PrimType" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_String (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-2 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((10) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "String" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "String" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_Constant (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "I") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-12 (cdr e-10))) (lambda (clam-1) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-13))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-1))))))))) ((equal? e-8 "I8") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-15) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-20 (cdr e-15))) (lambda (clam-2) (if (null? e-16) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int8 arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-9))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-2))))))))) ((equal? e-8 "I16") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-23 (car e-5))) (let ((e-24 (cdr e-5))) (if (null? e-23) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-28 (cdr e-23))) (lambda (clam-3) (if (null? e-24) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-28) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int16 arg-0 arg-1 arg-2 e-9))) eff-0) clam-3))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-9))))) eff-0) clam-3))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-3))))))))) ((equal? e-8 "I32") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-31 (car e-5))) (let ((e-32 (cdr e-5))) (if (null? e-31) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-36 (cdr e-31))) (lambda (clam-4) (if (null? e-32) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int32 arg-0 arg-1 arg-2 e-9))) eff-0) clam-4))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-9))))) eff-0) clam-4))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-4))))))))) ((equal? e-8 "I64") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-39 (car e-5))) (let ((e-40 (cdr e-5))) (if (null? e-39) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-44 (cdr e-39))) (lambda (clam-5) (if (null? e-40) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-44) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int64 arg-0 arg-1 arg-2 e-9))) eff-0) clam-5))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 e-9))))) eff-0) clam-5))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-5))))))))) ((equal? e-8 "BI") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-47 (car e-5))) (let ((e-48 (cdr e-5))) (if (null? e-47) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-52 (cdr e-47))) (lambda (clam-6) (if (null? e-48) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Integer arg-0 arg-1 arg-2 e-9))) eff-0) clam-6))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-9))))) eff-0) clam-6))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-6))))))))) ((equal? e-8 "B8") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-55 (car e-5))) (let ((e-56 (cdr e-5))) (if (null? e-55) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-60 (cdr e-55))) (lambda (clam-7) (if (null? e-56) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-60) clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bits8 arg-0 arg-1 arg-2 e-9))) eff-0) clam-7))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-9))))) eff-0) clam-7))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-7))))))))) ((equal? e-8 "B16") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-63 (car e-5))) (let ((e-64 (cdr e-5))) (if (null? e-63) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-68 (cdr e-63))) (lambda (clam-8) (if (null? e-64) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-68) clam-8))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bits16 arg-0 arg-1 arg-2 e-9))) eff-0) clam-8))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-9))))) eff-0) clam-8))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-8))))))))) ((equal? e-8 "B32") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-71 (car e-5))) (let ((e-72 (cdr e-5))) (if (null? e-71) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-76 (cdr e-71))) (lambda (clam-9) (if (null? e-72) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-76) clam-9))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bits32 arg-0 arg-1 arg-2 e-9))) eff-0) clam-9))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-9))))) eff-0) clam-9))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-9))))))))) ((equal? e-8 "B64") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-79 (car e-5))) (let ((e-80 (cdr e-5))) (if (null? e-79) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-84 (cdr e-79))) (lambda (clam-10) (if (null? e-80) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-84) clam-10))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bits64 arg-0 arg-1 arg-2 e-9))) eff-0) clam-10))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-9))))) eff-0) clam-10))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-10))))))))) ((equal? e-8 "Str") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-87 (car e-5))) (let ((e-88 (cdr e-5))) (if (null? e-87) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-92 (cdr e-87))) (lambda (clam-11) (if (null? e-88) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-92) clam-11))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-11))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-9))))) eff-0) clam-11))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-11))))))))) ((equal? e-8 "Ch") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-95 (car e-5))) (let ((e-96 (cdr e-5))) (if (null? e-95) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-100 (cdr e-95))) (lambda (clam-12) (if (null? e-96) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-100) clam-12))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Char arg-0 arg-1 arg-2 e-9))) eff-0) clam-12))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-9))))) eff-0) clam-12))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-12))))))))) ((equal? e-8 "Db") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-103 (car e-5))) (let ((e-104 (cdr e-5))) (if (null? e-103) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-108 (cdr e-103))) (lambda (clam-13) (if (null? e-104) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-108) clam-13))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Double arg-0 arg-1 arg-2 e-9))) eff-0) clam-13))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 12 e-9))))) eff-0) clam-13))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-13))))))))) ((equal? e-8 "PrT") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-111 (car e-5))) (let ((e-112 (cdr e-5))) (if (null? e-111) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)) (let ((e-116 (cdr e-111))) (lambda (clam-14) (if (null? e-112) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-116) clam-14))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_PrimType arg-0 arg-1 arg-2 e-9))) eff-0) clam-14))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-9))))) eff-0) clam-14))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-14))))))))) ((equal? e-8 "WorldVal") (lambda (clam-15) (if (null? e-5) (vector 1 (vector 14 )) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" clam-15))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Constant" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Constant" clam-0))))))
(define TTImpC-45Reflect-u--reify_Reify_DotReason (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (lambda (clam-0) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "NonLinearVar") (vector 1 0)) ((equal? e-8 "VarApplied") (vector 1 1)) ((equal? e-8 "NotConstructor") (vector 1 2)) ((equal? e-8 "ErasedArg") (vector 1 3)) ((equal? e-8 "UserDotted") (vector 1 4)) ((equal? e-8 "UnknownDot") (vector 1 5)) ((equal? e-8 "UnderAppliedCon") (vector 1 6))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DotReason" clam-0)))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DotReason" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DotReason" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "DotReason" ext-0)))))
(define csegen-2459 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (c-0) (lambda (vars-0) (lambda (arg-1715) (lambda (arg-1718) (CoreC-45Reflect-u--reify_Reify_String c-0 vars-0 arg-1715 arg-1718))))) u--c u--vars arg-1714 arg-1717))))))
(define CoreC-45Reflect-u--reify_Reify_ModuleIdent (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "ModuleIdent" eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "ModuleIdent" eta-0)) (let ((e-11 (car e-7))) (let ((e-12 (cdr e-7))) (lambda (clam-0) (if (null? e-8) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 (cons (cons e-11 e-12) '())))) (let ((sc5 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc5 0) ((1) (let ((e-0 (vector-ref sc5 1))) (case (vector-ref e-0 0) ((0) (let ((e-9 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-9 "MkMI") (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (((let ((eff-0 csegen-2459)) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-10))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 e-10)))) eff-0) clam-1))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ModuleIdent" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ModuleIdent" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ModuleIdent" eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "ModuleIdent" clam-0)))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "ModuleIdent" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_VirtualIdent (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Interactive") (lambda (clam-1) (if (null? e-5) (vector 1 (vector 0 )) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "VirtualIdent" clam-1))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "VirtualIdent" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "VirtualIdent" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "VirtualIdent" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "VirtualIdent" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_OriginDesc (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "PhysicalIdrSrc") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)) (let ((e-12 (cdr e-10))) (lambda (clam-1) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_ModuleIdent arg-0 arg-1 arg-2 e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-13))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" clam-1))))))))) ((equal? e-8 "PhysicalPkgSrc") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-15) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)) (let ((e-20 (cdr e-15))) (lambda (clam-2) (if (null? e-16) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-9))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" clam-2))))))))) ((equal? e-8 "Virtual") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)) (let ((e-23 (car e-5))) (let ((e-24 (cdr e-5))) (if (null? e-23) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)) (let ((e-28 (cdr e-23))) (lambda (clam-3) (if (null? e-24) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-28) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_VirtualIdent arg-0 arg-1 arg-2 e-9))) eff-0) clam-3))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-9))))) eff-0) clam-3))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" clam-3)))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "OriginDesc" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "OriginDesc" clam-0))))))
(define csegen-2461 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (CoreC-45Reflect-u--reify_Reify_Int u--c u--vars arg-1714 arg-1717))))))
(define csegen-2463 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2461 csegen-2461) u--c u--vars arg-1714 arg-1717))))))
(define CoreC-45Reflect-u--reify_Reify_FC (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkFC") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)) (let ((e-12 (cdr e-10))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)) (let ((e-19 (cdr e-14))) (if (null? e-15) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)) (let ((e-21 (car e-15))) (let ((e-22 (cdr e-15))) (if (null? e-21) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)) (let ((e-26 (cdr e-21))) (lambda (clam-1) (if (null? e-22) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_OriginDesc arg-0 arg-1 arg-2 e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (((let ((eff-0 csegen-2463)) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-16))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (((let ((eff-0 csegen-2463)) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-17))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-13 e-16 e-17))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" clam-1))))))))))))))))))) ((equal? e-8 "EmptyFC") (lambda (eta-0) (vector 1 (vector 2 ))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FC" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "FC" clam-0))))))
(define csegen-2423 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_String eta-0 eta-1 eta-2 eta-3))))))
(define TTImpC-45Reflect-u--reify_Reify_IFieldUpdate (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "ISetField") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)) (let ((e-12 (cdr e-10))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (lambda (clam-0) (if (null? e-14) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" clam-0) (let ((e-19 (cdr e-14))) (if (null? e-15) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2423 arg-0 arg-1 arg-2 e-13))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-16 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-13 e-16))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" clam-0)))))))))))))) ((equal? e-8 "ISetFieldApp") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)) (let ((e-22 (car e-5))) (let ((e-23 (cdr e-5))) (if (null? e-22) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)) (let ((e-27 (cdr e-22))) (if (null? e-23) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)) (let ((e-29 (car e-23))) (let ((e-30 (cdr e-23))) (lambda (clam-1) (if (null? e-29) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" clam-1) (let ((e-34 (cdr e-29))) (if (null? e-30) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-27) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2423 arg-0 arg-1 arg-2 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-34) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" clam-1))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IFieldUpdate" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "IFieldUpdate" ext-0)))))
(define CoreC-45Reflect-u--reify_Reify_LazyReason (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-7 "LInf") (vector 1 0)) ((equal? e-7 "LLazy") (vector 1 1)) ((equal? e-7 "LUnknown") (vector 1 2))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "LazyReason" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "LazyReason" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "LazyReason" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "LazyReason" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Namespace (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Namespace" eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Namespace" eta-0)) (let ((e-11 (car e-7))) (let ((e-12 (cdr e-7))) (lambda (clam-0) (if (null? e-8) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 (cons (cons e-11 e-12) '())))) (let ((sc5 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc5 0) ((1) (let ((e-0 (vector-ref sc5 1))) (case (vector-ref e-0 0) ((0) (let ((e-9 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-9 "MkNS") (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (((let ((eff-0 csegen-2459)) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-10))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 e-10)))) eff-0) clam-1))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Namespace" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Namespace" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Namespace" eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Namespace" clam-0)))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Namespace" eta-0))))))
(define CoreC-45Reflect-u--reify_Reify_UserName (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Basic") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-14 (cdr e-9))) (lambda (clam-1) (if (null? e-10) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-14) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-11))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-11))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-1))))))))) ((equal? e-8 "Field") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-17 (car e-5))) (let ((e-18 (cdr e-5))) (if (null? e-17) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-22 (cdr e-17))) (lambda (clam-2) (if (null? e-18) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-22) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-9))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-2))))))))) ((equal? e-8 "Underscore") (lambda (clam-3) (if (null? e-5) (vector 1 (vector 2 )) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-3))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)))))) ((0) (let ((e-7 (vector-ref sc2 2))) (lambda (clam-4) (case (vector-ref e-7 0) ((1) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, reifying it is unimplemented or intentionally internal" clam-4))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-4))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Name, value is not an NDCon interally" clam-0))))))
(define csegen-2460 (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (CoreC-45Reflect-u--reify_Reify_Name u--c u--vars arg-1714 arg-1717)))))))
(define CoreC-45Reflect-u--reify_Reify_Name (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "UN") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-14 (cdr e-9))) (lambda (clam-1) (if (null? e-10) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-14) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_UserName arg-0 arg-1 arg-2 e-11))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-11))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-1))))))))) ((equal? e-8 "MN") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-17 (car e-5))) (let ((e-18 (cdr e-5))) (if (null? e-17) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-22 (cdr e-17))) (if (null? e-18) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-24 (car e-18))) (let ((e-25 (cdr e-18))) (if (null? e-24) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-29 (cdr e-24))) (lambda (clam-2) (if (null? e-25) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-22) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-2)))))))))))))) ((equal? e-8 "NS") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-32 (car e-5))) (let ((e-33 (cdr e-5))) (if (null? e-32) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-37 (cdr e-32))) (if (null? e-33) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-39 (car e-33))) (let ((e-40 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-44 (cdr e-39))) (lambda (clam-3) (if (null? e-40) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-37) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Namespace arg-0 arg-1 arg-2 e-9))) eff-0) clam-3))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-44) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (((let ((eff-0 (csegen-2460))) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-3))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-3)))))))))))))) ((equal? e-8 "DN") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-47 (car e-5))) (let ((e-48 (cdr e-5))) (if (null? e-47) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-52 (cdr e-47))) (if (null? e-48) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-54 (car e-48))) (let ((e-55 (cdr e-48))) (if (null? e-54) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-59 (cdr e-54))) (lambda (clam-4) (if (null? e-55) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-4))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-59) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (((let ((eff-0 (csegen-2460))) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-4))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-4)))))))))))))) ((equal? e-8 "Nested") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-62 (car e-5))) (let ((e-63 (cdr e-5))) (if (null? e-62) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-67 (cdr e-62))) (if (null? e-63) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-69 (car e-63))) (let ((e-70 (cdr e-63))) (if (null? e-69) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-74 (cdr e-69))) (lambda (clam-5) (if (null? e-70) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-67) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (((let ((eff-0 csegen-2463)) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-9))) eff-0) clam-5))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-74) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (((let ((eff-0 (csegen-2460))) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-5))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-5)))))))))))))) ((equal? e-8 "CaseBlock") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-77 (car e-5))) (let ((e-78 (cdr e-5))) (if (null? e-77) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-82 (cdr e-77))) (if (null? e-78) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-84 (car e-78))) (let ((e-85 (cdr e-78))) (if (null? e-84) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-89 (cdr e-84))) (lambda (clam-6) (if (null? e-85) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-82) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-6))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-89) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-6))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-6)))))))))))))) ((equal? e-8 "WithBlock") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-92 (car e-5))) (let ((e-93 (cdr e-5))) (if (null? e-92) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-97 (cdr e-92))) (if (null? e-93) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-99 (car e-93))) (let ((e-100 (cdr e-93))) (if (null? e-99) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)) (let ((e-104 (cdr e-99))) (lambda (clam-7) (if (null? e-100) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-97) clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-9))) eff-0) clam-7))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-104) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Int arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-7))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-7))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)))))) ((0) (let ((e-7 (vector-ref sc2 2))) (lambda (clam-8) (case (vector-ref e-7 0) ((1) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, reifying it is unimplemented or intentionally internal" clam-8))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" clam-8))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Name, the name was not found in context" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Name, value is not an NDCon interally" clam-0))))))
(define CoreC-45Reflect-u--reify_Reify_Nat (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Z") (lambda (eta-0) (vector 1 0))) ((equal? e-8 "S") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Nat" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-10) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Nat" eta-0)) (let ((e-12 (cdr e-10))) (lambda (clam-1) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (((let ((eff-0 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (CoreC-45Reflect-u--reify_Reify_Nat u--c u--vars arg-1714 arg-1717))))))) (lambda (arg-4) (lambda (arg-5) ((((eff-0 arg-0) arg-1) arg-4) arg-5)))) arg-2) e-13))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (+ e-13 1))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Nat" clam-1)))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Nat" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Nat" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Nat" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Nat" clam-0))))))
(define TTImpC-45Reflect-u--reify_Reify_UseSide (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (lambda (clam-0) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "UseLeft") (vector 1 0)) ((equal? e-8 "UseRight") (vector 1 1))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "UseSide" clam-0)))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "UseSide" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "UseSide" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "UseSide" ext-0)))))
(define csegen-2403 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_Name eta-0 eta-1 eta-2 eta-3))))))
(define CoreC-45Reflect-u--reify_Reify_TotalReq (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-7 "Total") (vector 1 0)) ((equal? e-7 "CoveringOnly") (vector 1 1)) ((equal? e-7 "PartialOK") (vector 1 2))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TotalReq" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TotalReq" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TotalReq" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "TotalReq" clam-0))))))
(define TTImpC-45Reflect-u--reify_Reify_FnOpt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "Inline") (lambda (eta-0) (vector 1 (vector 1 )))) ((equal? e-8 "Unsafe") (lambda (eta-0) (vector 1 (vector 0 )))) ((equal? e-8 "NoInline") (lambda (eta-0) (vector 1 (vector 2 )))) ((equal? e-8 "Deprecate") (lambda (eta-0) (vector 1 (vector 3 )))) ((equal? e-8 "TCInline") (lambda (eta-0) (vector 1 (vector 4 )))) ((equal? e-8 "Hint") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (lambda (clam-0) (if (null? e-10) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bool arg-0 arg-1 arg-2 e-13))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-13))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-0))))))))) ((equal? e-8 "GlobalHint") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (lambda (clam-1) (if (null? e-15) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-1) (let ((e-20 (cdr e-15))) (if (null? e-16) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bool arg-0 arg-1 arg-2 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-9))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-1))))))))) ((equal? e-8 "ExternFn") (lambda (eta-0) (vector 1 (vector 7 )))) ((equal? e-8 "ForeignFn") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)) (let ((e-23 (car e-5))) (let ((e-24 (cdr e-5))) (lambda (clam-2) (if (null? e-23) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-2) (let ((e-28 (cdr e-23))) (if (null? e-24) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-28) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2402) arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-9))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-2))))))))) ((equal? e-8 "ForeignExport") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)) (let ((e-31 (car e-5))) (let ((e-32 (cdr e-5))) (lambda (clam-3) (if (null? e-31) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-3) (let ((e-36 (cdr e-31))) (if (null? e-32) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2402) arg-0 arg-1 arg-2 e-9))) eff-0) clam-3))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-9))))) eff-0) clam-3))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-3))))))))) ((equal? e-8 "Invertible") (lambda (eta-0) (vector 1 (vector 10 )))) ((equal? e-8 "Totality") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)) (let ((e-39 (car e-5))) (let ((e-40 (cdr e-5))) (lambda (clam-4) (if (null? e-39) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-4) (let ((e-44 (cdr e-39))) (if (null? e-40) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-44) clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_TotalReq arg-0 arg-1 arg-2 e-9))) eff-0) clam-4))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-9))))) eff-0) clam-4))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-4))))))))) ((equal? e-8 "Macro") (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-8 "SpecArgs") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)) (let ((e-47 (car e-5))) (let ((e-48 (cdr e-5))) (lambda (clam-5) (if (null? e-47) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-5) (let ((e-52 (cdr e-47))) (if (null? e-48) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2403 arg-0 arg-1 arg-2 e-9))) eff-0) clam-5))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-9))))) eff-0) clam-5))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" clam-5)))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "FnOpt" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "FnOpt" ext-0)))))
(define csegen-2404 (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_FnOpt u--c u--vars arg-1714 arg-1717 eta-0))))))))
(define TTImpC-45Reflect-u--reify_Reify_WithFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (lambda (clam-0) (cond ((equal? e-8 "Syntactic") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (vector 1 (vector 0 )) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "WithFlag" clam-0))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "WithFlag" clam-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "WithFlag" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "WithFlag" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "WithFlag" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_ImpClause (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "PatClause") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (lambda (clam-0) (if (null? e-11) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" clam-0) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-16 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-17 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-15 e-16 e-17))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" clam-0)))))))))))))) ((equal? e-8 "WithClause") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-17 (car sc5))) (let ((e-18 (cdr sc5))) (if (null? e-18) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-20 (car e-18))) (let ((e-21 (cdr e-18))) (if (null? e-21) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (lambda (clam-1) (if (null? e-33) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" clam-1) (let ((e-35 (car e-33))) (let ((e-36 (cdr e-33))) (if (null? e-36) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-17) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-12 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2403 arg-0 arg-1 arg-2 e-13))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-32) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-5) (TTImpC-45Reflect-u--reify_Reify_WithFlag u--c u--vars arg-1714 arg-1717 eta-5)))))) arg-0 arg-1 arg-2 e-14))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (let ((act-8 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-35) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-8 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2405) arg-0 arg-1 arg-2 e-15))) eff-0) eta-5))))))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector 1 e-9 e-10 e-11 e-12 e-13 e-14 e-15))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" clam-1)))))))))))))))))))))))))) ((equal? e-8 "ImpossibleClause") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)) (let ((e-39 (car sc5))) (let ((e-40 (cdr sc5))) (lambda (clam-2) (if (null? e-40) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" clam-2) (let ((e-42 (car e-40))) (let ((e-43 (cdr e-40))) (if (null? e-43) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-39) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-42) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" clam-2)))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Clause" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Clause" ext-0)))))
(define csegen-2405 (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_ImpClause u--c u--vars arg-1714 arg-1717 eta-0))))))))
(define CoreC-45Reflect-u--reify_Reify_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "DefaultedValue") (lambda (eta-0) (vector 1 LibrariesC-45DataC-45WithDefault-defaulted))) ((equal? e-8 "SpecifiedValue") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0)) (let ((e-9 (cdr e-5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0)) (let ((e-11 (cdr e-9))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-13) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0)) (let ((e-18 (cdr e-13))) (lambda (clam-1) (if (null? e-14) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-3 arg-4 arg-5 e-18) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 ((((arg-2 arg-3) arg-4) arg-5) e-15))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45WithDefault-specified e-15))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" clam-1)))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-3 arg-4 u--val "WithDefault" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-3 arg-4 arg-6 "WithDefault" clam-0))))))
(define TTImpC-45Reflect-u--reify_Reify_ImpTy (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkTy") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (lambda (clam-0) (if (null? e-14) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" clam-0) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-18))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-19 (vector-ref act-4 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-19))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-19 (vector-ref act-4 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-20 (vector-ref act-5 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-20 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-20 (vector-ref act-5 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-15 e-18 e-19 e-20))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" clam-0)))))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "ITy" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "ITy" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_DataOpt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "SearchBy") (if (null? e-5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DataOpt" eta-0)) (let ((e-10 (car e-5))) (let ((e-9 (cdr e-5))) (lambda (clam-0) (if (null? e-10) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DataOpt" clam-0) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2403 arg-0 arg-1 arg-2 e-13))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-13))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DataOpt" clam-0))))))))) ((equal? e-8 "NoHints") (lambda (eta-0) (vector 1 (vector 1 )))) ((equal? e-8 "UniqueSearch") (lambda (eta-0) (vector 1 (vector 2 )))) ((equal? e-8 "External") (lambda (eta-0) (vector 1 (vector 3 )))) ((equal? e-8 "NoNewtype") (lambda (eta-0) (vector 1 (vector 4 ))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DataOpt" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DataOpt" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "DataOpt" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "DataOpt" ext-0)))))
(define csegen-2419 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_DataOpt u--c u--vars arg-1714 arg-1717 eta-0)))))))
(define TTImpC-45Reflect-u--reify_Reify_ImpData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkData") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (lambda (clam-0) (if (null? e-17) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" clam-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-18))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (csegen-2402) arg-0 arg-1 arg-2 e-21))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-22 (vector-ref act-5 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2419 arg-0 arg-1 arg-2 e-22))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-22 (vector-ref act-5 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-23 (vector-ref act-6 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_ImpTy u--c u--vars arg-1714 arg-1717 eta-4)))))) arg-0 arg-1 arg-2 e-23))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-23 (vector-ref act-6 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 0 e-15 e-18 e-21 e-22 e-23))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" clam-0)))))))))))))))))))) ((equal? e-8 "MkLater") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)) (let ((e-23 (car sc5))) (let ((e-24 (cdr sc5))) (if (null? e-24) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (lambda (clam-1) (if (null? e-27) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" clam-1) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" clam-1))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Data" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Data" ext-0)))))
(define TTImpC-45Reflect-u--reify_Reify_IField (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkIField") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0)) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (lambda (clam-0) (if (null? e-17) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" clam-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-18))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-2402) arg-0 arg-1 arg-2 e-21))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-22 (vector-ref act-5 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-22))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-22 (vector-ref act-5 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-23 (vector-ref act-6 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-23 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-23 (vector-ref act-6 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector e-15 e-18 e-21 e-22 e-23))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" clam-0))))))))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "IField" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "IField" ext-0)))))
(define csegen-2418 (lambda () (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2403 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (CoreC-45Reflect-u--reify_Reify_RigCount eta-8 eta-9 eta-10 eta-11))))) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-12) (lambda (eta-13) (lambda (eta-14) (lambda (eta-15) (CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-2402) eta-12 eta-13 eta-14 eta-15))))) (csegen-2402)) eta-8 eta-9 eta-10 eta-11)))))) eta-4 eta-5 eta-6 eta-7)))))) eta-0 eta-1 eta-2 eta-3)))))))
(define TTImpC-45Reflect-u--reify_Reify_ImpRecord (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "MkRecord") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0)) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0)) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (lambda (clam-0) (if (null? e-20) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" clam-0) (let ((e-22 (car e-20))) (let ((e-23 (cdr e-20))) (if (null? e-23) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-18))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2418) arg-0 arg-1 arg-2 e-21))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-24 (vector-ref act-5 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2419 arg-0 arg-1 arg-2 e-24))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-24 (vector-ref act-5 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-25 (vector-ref act-6 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-25))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-25 (vector-ref act-6 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-22) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-26 (vector-ref act-7 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-7 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-5) (TTImpC-45Reflect-u--reify_Reify_IField u--c u--vars arg-1714 arg-1717 eta-5)))))) arg-0 arg-1 arg-2 e-26))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-26 (vector-ref act-7 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector e-15 e-18 e-21 e-24 e-25 e-26))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" clam-0)))))))))))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Record" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Record" ext-0)))))
(define CoreC-45Reflect-u--reify_Reify_Visibility (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-0 (vector-ref sc2 1))) (case (vector-ref e-0 0) ((0) (let ((e-7 (vector-ref e-0 1))) (lambda (clam-1) (cond ((equal? e-7 "Private") (vector 1 0)) ((equal? e-7 "Export") (vector 1 1)) ((equal? e-7 "Public") (vector 1 2))(else (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Visibility" clam-1))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Visibility" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Visibility" eta-0)))))))) eff-0) clam-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Visibility" clam-0))))))
(define csegen-2421 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_Visibility eta-0 eta-1 eta-2 eta-3))))))
(define csegen-2422 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_TotalReq eta-0 eta-1 eta-2 eta-3))))))
(define TTImpC-45Reflect-u--reify_Reify_ImpDecl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "IClaim") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (if (null? e-9) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (lambda (clam-0) (if (null? e-17) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-0) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (if (null? e-20) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-15))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-18))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-13) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Visibility arg-0 arg-1 arg-2 e-21))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-21 (vector-ref act-4 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-16) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-22 (vector-ref act-5 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2404) arg-0 arg-1 arg-2 e-22))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-22 (vector-ref act-5 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-19) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-23 (vector-ref act-6 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_ImpTy arg-0 arg-1 arg-2 e-23 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-23 (vector-ref act-6 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 0 e-15 e-18 e-21 e-22 e-23))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-0)))))))))))))))))))) ((equal? e-8 "IData") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-23 (car sc5))) (let ((e-24 (cdr sc5))) (if (null? e-24) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (lambda (clam-1) (if (null? e-30) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-1) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (if (null? e-33) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-2421 arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2422 arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-32) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45Reflect-u--reify_Reify_ImpData arg-0 arg-1 arg-2 e-12 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 1 e-9 e-10 e-11 e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-1))))))))))))))))) ((equal? e-8 "IDef") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-36 (car sc5))) (let ((e-37 (cdr sc5))) (if (null? e-37) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-39 (car e-37))) (let ((e-40 (cdr e-37))) (lambda (clam-2) (if (null? e-40) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-2) (let ((e-42 (car e-40))) (let ((e-43 (cdr e-40))) (if (null? e-43) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-39) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-42) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2405) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-2)))))))))))))) ((equal? e-8 "IParameters") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-46 (car sc5))) (let ((e-47 (cdr sc5))) (if (null? e-47) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-49 (car e-47))) (let ((e-50 (cdr e-47))) (lambda (clam-3) (if (null? e-50) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-3) (let ((e-52 (car e-50))) (let ((e-53 (cdr e-50))) (if (null? e-53) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-46) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-3))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-49) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2418) arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2406) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-3)))))))))))))) ((equal? e-8 "IRecord") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-56 (car sc5))) (let ((e-57 (cdr sc5))) (if (null? e-57) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-59 (car e-57))) (let ((e-60 (cdr e-57))) (if (null? e-60) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-62 (car e-60))) (let ((e-63 (cdr e-60))) (if (null? e-63) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-65 (car e-63))) (let ((e-66 (cdr e-63))) (lambda (clam-4) (if (null? e-66) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-4) (let ((e-68 (car e-66))) (let ((e-69 (cdr e-66))) (if (null? e-69) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-56) clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-4))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-59) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2423 arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-62) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-2421 arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-65) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2422 arg-0 arg-1 arg-2 e-12))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-68) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_ImpRecord arg-0 arg-1 arg-2 e-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 4 e-9 e-10 e-11 e-12 e-13))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-4)))))))))))))))))))) ((equal? e-8 "IFail") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-72 (car sc5))) (let ((e-73 (cdr sc5))) (if (null? e-73) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-75 (car e-73))) (let ((e-76 (cdr e-73))) (lambda (clam-5) (if (null? e-76) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-5) (let ((e-78 (car e-76))) (let ((e-79 (cdr e-76))) (if (null? e-79) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-72) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-5))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-75) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2423 arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-78) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2406) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-5)))))))))))))) ((equal? e-8 "INamespace") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-82 (car sc5))) (let ((e-83 (cdr sc5))) (if (null? e-83) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-85 (car e-83))) (let ((e-86 (cdr e-83))) (lambda (clam-6) (if (null? e-86) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-6) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-82) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-6))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-85) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Namespace arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-88) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2406) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 6 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-6)))))))))))))) ((equal? e-8 "ITransform") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-92 (car sc5))) (let ((e-93 (cdr sc5))) (if (null? e-93) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-95 (car e-93))) (let ((e-96 (cdr e-93))) (if (null? e-96) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)) (let ((e-98 (car e-96))) (let ((e-99 (cdr e-96))) (lambda (clam-7) (if (null? e-99) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-7) (let ((e-101 (car e-99))) (let ((e-102 (cdr e-99))) (if (null? e-102) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-92) clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-7))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-95) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-98) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-101) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-12 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 7 e-9 e-10 e-11 e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-7))))))))))))))))) ((equal? e-8 "ILog") (lambda (clam-8) (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-8) (let ((e-105 (car sc5))) (let ((e-106 (cdr sc5))) (if (null? e-106) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-105) clam-8))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 csegen-2423 eta-4 eta-5 eta-6 eta-7))))) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reify_Reify_Nat eta-4 eta-5 eta-6 eta-7)))))) eta-0 eta-1 eta-2 eta-3))))) arg-0 arg-1 arg-2 e-9))) eff-0) clam-8))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-9))))) eff-0) clam-8))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" clam-8))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "Decl" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "Decl" ext-0)))))
(define csegen-2406 (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_ImpDecl u--c u--vars arg-1714 arg-1717 eta-0))))))))
(define TTImpC-45Reflect-u--reify_Reify_RawImp (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--val (vector 2 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CoreC-45Name-dropAllNS e-6))) (case (vector-ref sc2 0) ((1) (let ((e-7 (vector-ref sc2 1))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (cond ((equal? e-8 "IVar") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-10 (car sc5))) (let ((e-9 (cdr sc5))) (lambda (clam-0) (if (null? e-9) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-0) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (if (null? e-11) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-13))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-14))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-13 e-14))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-0))))))))))) ((equal? e-8 "IPi") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-14 (car sc5))) (let ((e-15 (cdr sc5))) (if (null? e-15) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-17 (car e-15))) (let ((e-18 (cdr e-15))) (if (null? e-18) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-20 (car e-18))) (let ((e-21 (cdr e-18))) (if (null? e-21) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (lambda (clam-1) (if (null? e-27) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-1) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-14) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-17) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-20) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-2402) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2403 arg-0 arg-1 arg-2 e-12))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-26) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-29) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-16 (vector-ref act-7 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-16 eta-5)))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-16 (vector-ref act-7 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 1 e-9 e-10 e-11 e-12 e-13 e-16))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-1))))))))))))))))))))))) ((equal? e-8 "ILam") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-33 (car sc5))) (let ((e-34 (cdr sc5))) (if (null? e-34) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-36 (car e-34))) (let ((e-37 (cdr e-34))) (if (null? e-37) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-39 (car e-37))) (let ((e-40 (cdr e-37))) (if (null? e-40) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-42 (car e-40))) (let ((e-43 (cdr e-40))) (if (null? e-43) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-45 (car e-43))) (let ((e-46 (cdr e-43))) (lambda (clam-2) (if (null? e-46) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-2) (let ((e-48 (car e-46))) (let ((e-49 (cdr e-46))) (if (null? e-49) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-33) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-2))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-36) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-39) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40PiInfoC-32C-36tC-41 (csegen-2402) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-42) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40MaybeC-32C-36aC-41 csegen-2403 arg-0 arg-1 arg-2 e-12))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-45) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-48) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-14 eta-5)))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 2 e-9 e-10 e-11 e-12 e-13 e-14))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-2))))))))))))))))))))))) ((equal? e-8 "ILet") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-52 (car sc5))) (let ((e-53 (cdr sc5))) (if (null? e-53) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-55 (car e-53))) (let ((e-56 (cdr e-53))) (if (null? e-56) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-58 (car e-56))) (let ((e-59 (cdr e-56))) (if (null? e-59) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-61 (car e-59))) (let ((e-62 (cdr e-59))) (if (null? e-62) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-64 (car e-62))) (let ((e-65 (cdr e-62))) (if (null? e-65) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-67 (car e-65))) (let ((e-68 (cdr e-65))) (lambda (clam-3) (if (null? e-68) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-3) (let ((e-70 (car e-68))) (let ((e-71 (cdr e-68))) (if (null? e-71) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-52) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-3))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-55) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-58) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_RigCount arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-61) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-12))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-64) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-67) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-14 eta-5)))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (let ((act-8 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-70) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-15 eta-6)))) eff-0) eta-5))))))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector 3 e-9 e-10 e-11 e-12 e-13 e-14 e-15))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-3)))))))))))))))))))))))))) ((equal? e-8 "ICase") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-74 (car sc5))) (let ((e-75 (cdr sc5))) (if (null? e-75) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-77 (car e-75))) (let ((e-78 (cdr e-75))) (if (null? e-78) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-80 (car e-78))) (let ((e-81 (cdr e-78))) (if (null? e-81) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-83 (car e-81))) (let ((e-84 (cdr e-81))) (lambda (clam-4) (if (null? e-84) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-4) (let ((e-86 (car e-84))) (let ((e-87 (cdr e-84))) (if (null? e-87) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-74) clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-4))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-77) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2404) arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-80) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-83) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-12 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-86) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2405) arg-0 arg-1 arg-2 e-13))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 4 e-9 e-10 e-11 e-12 e-13))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-4)))))))))))))))))))) ((equal? e-8 "ILocal") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-90 (car sc5))) (let ((e-91 (cdr sc5))) (if (null? e-91) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-93 (car e-91))) (let ((e-94 (cdr e-91))) (lambda (clam-5) (if (null? e-94) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-5) (let ((e-96 (car e-94))) (let ((e-97 (cdr e-94))) (if (null? e-97) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-90) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-5))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-93) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2406) arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-96) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-5)))))))))))))) ((equal? e-8 "IUpdate") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-100 (car sc5))) (let ((e-101 (cdr sc5))) (if (null? e-101) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-103 (car e-101))) (let ((e-104 (cdr e-101))) (lambda (clam-6) (if (null? e-104) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-6) (let ((e-106 (car e-104))) (let ((e-107 (cdr e-104))) (if (null? e-107) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-100) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-6))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-103) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_IFieldUpdate u--c u--vars arg-1714 arg-1717 eta-1)))))) arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-106) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 7 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-6)))))))))))))) ((equal? e-8 "IApp") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-110 (car sc5))) (let ((e-111 (cdr sc5))) (if (null? e-111) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-113 (car e-111))) (let ((e-114 (cdr e-111))) (lambda (clam-7) (if (null? e-114) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-7) (let ((e-116 (car e-114))) (let ((e-117 (cdr e-114))) (if (null? e-117) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-110) clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-7))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-113) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-116) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-7)))))))))))))) ((equal? e-8 "INamedApp") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-120 (car sc5))) (let ((e-121 (cdr sc5))) (if (null? e-121) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-123 (car e-121))) (let ((e-124 (cdr e-121))) (if (null? e-124) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-126 (car e-124))) (let ((e-127 (cdr e-124))) (lambda (clam-8) (if (null? e-127) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-8) (let ((e-129 (car e-127))) (let ((e-130 (cdr e-127))) (if (null? e-130) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-120) clam-8))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-8))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-123) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-126) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-129) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-12 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 10 e-9 e-10 e-11 e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-8))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-8))))))))))))))))) ((equal? e-8 "IAutoApp") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-133 (car sc5))) (let ((e-134 (cdr sc5))) (if (null? e-134) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-136 (car e-134))) (let ((e-137 (cdr e-134))) (lambda (clam-9) (if (null? e-137) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-9) (let ((e-139 (car e-137))) (let ((e-140 (cdr e-137))) (if (null? e-140) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-133) clam-9))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-9))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-136) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-139) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-9)))))))))))))) ((equal? e-8 "IWithApp") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-143 (car sc5))) (let ((e-144 (cdr sc5))) (if (null? e-144) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-146 (car e-144))) (let ((e-147 (cdr e-144))) (lambda (clam-10) (if (null? e-147) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-10) (let ((e-149 (car e-147))) (let ((e-150 (cdr e-147))) (if (null? e-150) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-143) clam-10))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-10))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-146) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-149) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 11 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-10))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-10)))))))))))))) ((equal? e-8 "ISearch") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-153 (car sc5))) (let ((e-154 (cdr sc5))) (lambda (clam-11) (if (null? e-154) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-11) (let ((e-156 (car e-154))) (let ((e-157 (cdr e-154))) (if (null? e-157) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-153) clam-11))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-11))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-156) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Nat arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 12 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-11))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-11))))))))))) ((equal? e-8 "IAlternative") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-160 (car sc5))) (let ((e-161 (cdr sc5))) (if (null? e-161) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-163 (car e-161))) (let ((e-164 (cdr e-161))) (lambda (clam-12) (if (null? e-164) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-12) (let ((e-166 (car e-164))) (let ((e-167 (cdr e-164))) (if (null? e-167) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-160) clam-12))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-12))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-163) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_AltType arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-166) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2402) arg-0 arg-1 arg-2 e-11))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 13 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-12))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-12)))))))))))))) ((equal? e-8 "IRewrite") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-170 (car sc5))) (let ((e-171 (cdr sc5))) (if (null? e-171) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-173 (car e-171))) (let ((e-174 (cdr e-171))) (lambda (clam-13) (if (null? e-174) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-13) (let ((e-176 (car e-174))) (let ((e-177 (cdr e-174))) (if (null? e-177) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-170) clam-13))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-13))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-173) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-176) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 14 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-13))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-13)))))))))))))) ((equal? e-8 "IBindHere") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-180 (car sc5))) (let ((e-181 (cdr sc5))) (if (null? e-181) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-183 (car e-181))) (let ((e-184 (cdr e-181))) (lambda (clam-14) (if (null? e-184) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-14) (let ((e-186 (car e-184))) (let ((e-187 (cdr e-184))) (if (null? e-187) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-180) clam-14))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-14))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-183) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_BindMode arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-186) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 16 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-14))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-14)))))))))))))) ((equal? e-8 "IBindVar") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-190 (car sc5))) (let ((e-191 (cdr sc5))) (lambda (clam-15) (if (null? e-191) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-15) (let ((e-193 (car e-191))) (let ((e-194 (cdr e-191))) (if (null? e-194) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-190) clam-15))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-15))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-193) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-15))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-15))))))))))) ((equal? e-8 "IAs") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-197 (car sc5))) (let ((e-198 (cdr sc5))) (if (null? e-198) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-200 (car e-198))) (let ((e-201 (cdr e-198))) (if (null? e-201) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-203 (car e-201))) (let ((e-204 (cdr e-201))) (if (null? e-204) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-206 (car e-204))) (let ((e-207 (cdr e-204))) (lambda (clam-16) (if (null? e-207) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-16) (let ((e-209 (car e-207))) (let ((e-210 (cdr e-207))) (if (null? e-210) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-197) clam-16))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-16))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-200) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-203) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_UseSide arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-206) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-12))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-209) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 18 e-9 e-10 e-11 e-12 e-13))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-16))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-16)))))))))))))))))))) ((equal? e-8 "IMustUnify") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-213 (car sc5))) (let ((e-214 (cdr sc5))) (if (null? e-214) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-216 (car e-214))) (let ((e-217 (cdr e-214))) (lambda (clam-17) (if (null? e-217) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-17) (let ((e-219 (car e-217))) (let ((e-220 (cdr e-217))) (if (null? e-220) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-213) clam-17))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-17))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-216) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_DotReason arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-219) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 19 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-17))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-17)))))))))))))) ((equal? e-8 "IDelayed") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-223 (car sc5))) (let ((e-224 (cdr sc5))) (if (null? e-224) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-226 (car e-224))) (let ((e-227 (cdr e-224))) (lambda (clam-18) (if (null? e-227) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-18) (let ((e-229 (car e-227))) (let ((e-230 (cdr e-227))) (if (null? e-230) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-223) clam-18))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-18))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-226) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_LazyReason arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-229) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 20 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-18))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-18)))))))))))))) ((equal? e-8 "IDelay") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-233 (car sc5))) (let ((e-234 (cdr sc5))) (lambda (clam-19) (if (null? e-234) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-19) (let ((e-236 (car e-234))) (let ((e-237 (cdr e-234))) (if (null? e-237) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-233) clam-19))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-19))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-236) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 21 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-19))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-19))))))))))) ((equal? e-8 "IForce") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-240 (car sc5))) (let ((e-241 (cdr sc5))) (lambda (clam-20) (if (null? e-241) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-20) (let ((e-243 (car e-241))) (let ((e-244 (cdr e-241))) (if (null? e-244) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-240) clam-20))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-20))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-243) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 22 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-20))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-20))))))))))) ((equal? e-8 "IQuote") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-247 (car sc5))) (let ((e-248 (cdr sc5))) (lambda (clam-21) (if (null? e-248) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-21) (let ((e-250 (car e-248))) (let ((e-251 (cdr e-248))) (if (null? e-251) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-247) clam-21))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-21))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-250) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 23 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-21))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-21))))))))))) ((equal? e-8 "IQuoteName") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-254 (car sc5))) (let ((e-255 (cdr sc5))) (lambda (clam-22) (if (null? e-255) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-22) (let ((e-257 (car e-255))) (let ((e-258 (cdr e-255))) (if (null? e-258) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-254) clam-22))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-22))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-257) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 24 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-22))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-22))))))))))) ((equal? e-8 "IQuoteDecl") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-261 (car sc5))) (let ((e-262 (cdr sc5))) (lambda (clam-23) (if (null? e-262) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-23) (let ((e-264 (car e-262))) (let ((e-265 (cdr e-262))) (if (null? e-265) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-261) clam-23))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-23))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-264) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (csegen-2406) arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 25 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-23))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-23))))))))))) ((equal? e-8 "IUnquote") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-268 (car sc5))) (let ((e-269 (cdr sc5))) (lambda (clam-24) (if (null? e-269) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-24) (let ((e-271 (car e-269))) (let ((e-272 (cdr e-269))) (if (null? e-272) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-268) clam-24))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-24))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-271) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-10 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 26 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-24))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-24))))))))))) ((equal? e-8 "IPrimVal") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-275 (car sc5))) (let ((e-276 (cdr sc5))) (lambda (clam-25) (if (null? e-276) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-25) (let ((e-278 (car e-276))) (let ((e-279 (cdr e-276))) (if (null? e-279) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-275) clam-25))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-25))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-278) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Constant arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 28 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-25))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-25))))))))))) ((equal? e-8 "IType") (lambda (clam-26) (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-26) (let ((e-282 (car sc5))) (let ((e-283 (cdr sc5))) (if (null? e-283) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-282) clam-26))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-26))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 29 e-9))))) eff-0) clam-26))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-26)))))))) ((equal? e-8 "IHole") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-286 (car sc5))) (let ((e-287 (cdr sc5))) (lambda (clam-27) (if (null? e-287) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-27) (let ((e-289 (car e-287))) (let ((e-290 (cdr e-287))) (if (null? e-290) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-286) clam-27))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-27))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-289) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 30 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-27))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-27))))))))))) ((equal? e-8 "Implicit") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-293 (car sc5))) (let ((e-294 (cdr sc5))) (lambda (clam-28) (if (null? e-294) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-28) (let ((e-296 (car e-294))) (let ((e-297 (cdr e-294))) (if (null? e-297) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-293) clam-28))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-28))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-296) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Bool arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 32 e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-28))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-28))))))))))) ((equal? e-8 "IWithUnambigNames") (let ((sc5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5))) (if (null? sc5) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-300 (car sc5))) (let ((e-301 (cdr sc5))) (if (null? e-301) (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)) (let ((e-303 (car e-301))) (let ((e-304 (cdr e-301))) (lambda (clam-29) (if (null? e-304) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-29) (let ((e-306 (car e-304))) (let ((e-307 (cdr e-304))) (if (null? e-307) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-300) clam-29))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-0 arg-1 arg-2 e-9))) eff-0) clam-29))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-303) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CoreC-45Reflect-u--reify_Reify_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (CoreC-45Reflect-u--reify_Reify_FC eta-5 eta-6 eta-7 eta-8))))) csegen-2403) eta-1 eta-2 eta-3 eta-4))))) arg-0 arg-1 arg-2 e-10))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-306) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-0 arg-1 arg-2 e-11 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 33 e-9 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-29))))) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" clam-29))))))))))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0))))))(else (lambda (eta-0) (CoreC-45Reflect-cantReify arg-0 arg-1 u--val "TTImp" eta-0)))))))) eff-0) ext-0)))))))))))(else (CoreC-45Reflect-cantReify arg-0 arg-1 arg-3 "TTImp" ext-0)))))
(define csegen-2402 (lambda () (lambda (u--c) (lambda (u--vars) (lambda (arg-1714) (lambda (arg-1717) (lambda (eta-0) (TTImpC-45Reflect-u--reify_Reify_RawImp u--c u--vars arg-1714 arg-1717 eta-0))))))))
(define csegen-2471 (lambda (u--x) (or (and (= (Builtin-fst u--x) 0) 1) 0)))
(define csegen-2472 (lambda (eta-0) (vector 1 (vector 1 (vector 0 "__")))))
(define CoreC-45NormaliseC-45Eval-nf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CoreC-45NormaliseC-45Eval-eval arg-2 CoreC-45Value-defaultOpts arg-0 arg-1 '() arg-3 '() arg-4 '())))
(define csegen-2499 (vector '() 0 '() (vector 0 )))
(define CoreC-45Unify-success csegen-2499)
(define CoreC-45Unify-unify (lambda (arg-1 arg-2 arg-3 arg-4 ext-1 ext-0) (lambda (clam-0) (let ((e-1 (car arg-1))) (lambda (arg-5) (lambda (arg-6) ((((((((e-1 arg-2) arg-3) arg-4) ext-1) ext-0) clam-0) arg-5) arg-6)))))))
(define CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 (lambda (ext-0 ext-1) (CoreC-45TTC-45Term-eqTerm ext-0 ext-1)))
(define CoreC-45Unify-isHoleApp (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((2) 1)(else 0))))(else 0))))
(define CoreC-45Unify-lower (lambda (ext-0) (let ((e-1 (cdr ext-0))) (cons 0 e-1))))
(define CoreC-45Unify-convertError (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-1 e-6 arg-4 arg-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-1 e-6 arg-4 arg-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 arg-1 arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) arg-4 e-7 e-8) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-genVarName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8))))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Bounds-sizeOf (lambda (arg-1) (case (vector-ref arg-1 0) ((0) 0) (else (let ((e-3 (vector-ref arg-1 3))) (LibrariesC-45DataC-45ListC-45SizeOf-suc (CoreC-45TTC-45Bounds-sizeOf e-3)))))))
(define CoreC-45TT-addVars (lambda (arg-4 ext-0 ext-1) (CoreC-45TTC-45Var-insertNVarNames arg-4 (CoreC-45TTC-45Bounds-sizeOf ext-0) ext-1)))
(define LibrariesC-45DataC-45SnocListC-45SizeOf-C-58C-60 (lambda (arg-2) (+ arg-2 1)))
(define CoreC-45TTC-45Var-insertVarNames (lambda (arg-3 arg-4 arg-5) (CoreC-45TTC-45Var-insertNVarNames arg-3 arg-4 arg-5)))
(define CoreC-45TTC-45Var-u--genWeakenNs_GenWeaken_C-40VarC-32C-91aC-32C-61C-32NameC-93C-41 (lambda (ext-0 ext-1 ext-2) (CoreC-45TTC-45Var-insertVarNames ext-0 ext-1 ext-2)))
(define CoreC-45TTC-45Var-WeakenVar (CoreC-45NameC-45Scoped-GenWeakenWeakens (lambda (outer-4791) (lambda (ns-4792) (lambda (local-4793) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45TTC-45Var-u--genWeakenNs_GenWeaken_C-40VarC-32C-91aC-32C-61C-32NameC-93C-41 eta-0 eta-1 eta-2)))))))))
(define CoreC-45TT-resolveRef (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-6 0) ((0) '()) (else (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-8 e-2))) (cond ((equal? sc1 1) (box (let ((sc2 CoreC-45TTC-45Var-WeakenVar)) (let ((e-4 (cdr sc2))) ((((e-4 'erased) 'erased) arg-4) arg-5))))) (else (CoreC-45TT-resolveRef arg-4 (LibrariesC-45DataC-45SnocListC-45SizeOf-C-58C-60 arg-5) e-3 arg-7 arg-8))))))))))
(define CoreC-45TT-mkLocals (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((eff-0 (CoreC-45TT-addVars arg-3 arg-4 e-4))) (vector 0 e-2 e-3 eff-0)))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (case (vector-ref e-8 0) ((0) (DataC-45Maybe-fromMaybe (lambda () (vector 1 e-7 (vector 0 ) e-9)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-resolveRef arg-3 0 arg-4 e-7 e-9) (lambda (_-0) (box (vector 0 e-7 '() _-0))))))(else (vector 1 e-7 e-8 e-9))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (DataC-45Maybe-fromMaybe (lambda () (vector 2 e-11 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TT-mkLocals arg-3 arg-4 eta-0)) e-14))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-resolveRef arg-3 0 arg-4 e-11 e-12) (lambda (_-0) (box (vector 0 e-11 '() _-0)))))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (vector 3 e-16 e-17 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-mkLocals arg-3 arg-4 eta-0)) e-18) (CoreC-45TT-mkLocals (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 e-19))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (vector 4 e-21 (CoreC-45TT-mkLocals arg-3 arg-4 e-22) (CoreC-45TT-mkLocals arg-3 arg-4 e-23)))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (vector 5 e-25 e-26 (CoreC-45TT-mkLocals arg-3 arg-4 e-27) (CoreC-45TT-mkLocals arg-3 arg-4 e-28))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (vector 6 e-30 e-31 (CoreC-45TT-mkLocals arg-3 arg-4 e-32)))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (let ((e-37 (vector-ref arg-5 4))) (vector 7 e-34 e-35 (CoreC-45TT-mkLocals arg-3 arg-4 e-36) (CoreC-45TT-mkLocals arg-3 arg-4 e-37))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (let ((e-41 (vector-ref arg-5 3))) (vector 8 e-39 e-40 (CoreC-45TT-mkLocals arg-3 arg-4 e-41)))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (case (vector-ref e-47 0) ((1) (vector 10 e-46 (vector 1 ))) ((0) (vector 10 e-46 (vector 0 ))) (else (let ((e-54 (vector-ref e-47 1))) (vector 10 e-46 (vector 2 (CoreC-45TT-mkLocals arg-3 arg-4 e-54))))))))) (else (let ((e-49 (vector-ref arg-5 1))) (let ((e-50 (vector-ref arg-5 2))) (vector 11 e-49 e-50)))))))
(define CoreC-45TT-refsToLocals (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) arg-3)(else (CoreC-45TT-mkLocals 0 arg-2 arg-3)))))
(define DataC-45List-deleteBy (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 ((arg-2 arg-3) e-2))) (cond ((equal? sc1 1) e-3) (else (cons e-2 (DataC-45List-deleteBy arg-2 arg-3 e-3))))))))))
(define DataC-45List-n--4927-5480-u--nubByC-39 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-elemBy csegen-14 arg-2 e-2 arg-1))) (cond ((equal? sc1 1) (DataC-45List-n--4927-5480-u--nubByC-39 arg-1 arg-2 e-3)) (else (cons e-2 (DataC-45List-n--4927-5480-u--nubByC-39 (cons e-2 arg-1) arg-2 e-3))))))))))
(define DataC-45List-nubBy (lambda (ext-0 ext-1) (DataC-45List-n--4927-5480-u--nubByC-39 '() ext-0 ext-1)))
(define DataC-45List-unionBy (lambda (arg-1 arg-2 arg-3) (PreludeC-45TypesC-45List-tailRecAppend arg-2 (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (DataC-45List-deleteBy arg-1 eta-2 eta-3))) eta-0 eta-1))) (DataC-45List-nubBy arg-1 arg-3) arg-2))))
(define DataC-45List-union (lambda (arg-1 ext-0 ext-1) (DataC-45List-unionBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define CoreC-45Unify-union (lambda (arg-0 arg-1) (vector (DataC-45List-union csegen-223 (let ((e-0 (vector-ref arg-0 0))) e-0) (let ((e-0 (vector-ref arg-1 0))) e-0)) (let ((sc0 (let ((e-1 (vector-ref arg-0 1))) e-1))) (cond ((equal? sc0 1) 1) (else (let ((e-1 (vector-ref arg-1 1))) e-1)))) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-2 (vector-ref arg-1 2))) e-2)) (vector 0 ))))
(define CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure arg-0 arg-1 e-5 (vector 1 0 '()) arg-2 arg-3 arg-4 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Binder-binderType (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 4))) e-4)) ((1) (let ((e-9 (vector-ref arg-1 4))) e-9)) ((2) (let ((e-14 (vector-ref arg-1 4))) e-14)) ((3) (let ((e-19 (vector-ref arg-1 4))) e-19)) ((4) (let ((e-24 (vector-ref arg-1 4))) e-24)) (else (let ((e-28 (vector-ref arg-1 3))) e-28)))))
(define CoreC-45TTC-45Binder-multiplicity (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) e-2)) ((1) (let ((e-7 (vector-ref arg-1 2))) e-7)) ((2) (let ((e-12 (vector-ref arg-1 2))) e-12)) ((3) (let ((e-17 (vector-ref arg-1 2))) e-17)) ((4) (let ((e-22 (vector-ref arg-1 2))) e-22)) (else (let ((e-27 (vector-ref arg-1 2))) e-27)))))
(define CoreC-45Env-abstractFullEnvType (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (case (vector-ref e-8 0) ((2) (let ((e-11 (vector-ref e-8 1))) (let ((e-12 (vector-ref e-8 2))) (let ((e-13 (vector-ref e-8 3))) (let ((e-14 (vector-ref e-8 4))) (CoreC-45Env-abstractFullEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 2 e-11 e-12 e-13 e-14) arg-3)))))))(else (let ((u--bnd (vector 2 arg-1 (CoreC-45TTC-45Binder-multiplicity e-8) (vector 1 ) (CoreC-45TTC-45Binder-binderType e-8)))) (CoreC-45Env-abstractFullEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 u--bnd arg-3))))))))))))
(define CoreC-45Context-initSize (blodwen-toSignedInt 10000 63))
(define CoreC-45Context-Grow CoreC-45Context-initSize)
(define CoreC-45Context-case--addPossible-5622 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) arg-0 (let ((e-2 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-0))) (if (null? sc1) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 0 arg-2 arg-1) '()) arg-0) (let ((e-3 (unbox sc1))) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 0 arg-2 arg-1) e-3) arg-0))))))))
(define CoreC-45Context-addPossible (lambda (arg-0 arg-1 arg-2) (CoreC-45Context-case--addPossible-5622 arg-2 arg-1 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define LibrariesC-45DataC-45IOArray-newArray (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (make-vector arg-3 '()))))) (lambda (bind-0) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (cons arg-3 bind-0)))))))))))
(define LibrariesC-45DataC-45IOArray-n--2946-1166-u--copyFrom (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-7 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 0 )))))) (else (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (vector-ref arg-5 arg-7))))) (lambda (u--el) (let ((e-7 (car arg-2))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (let ((e-11 (cdr arg-2))) ((e-11 'erased) (lambda (eta-0) (vector-set! arg-6 arg-7 u--el))))) (lambda (_-10649) (LibrariesC-45DataC-45IOArray-n--2946-1166-u--copyFrom arg-2 arg-3 arg-4 arg-5 arg-6 (bs- arg-7 1 63)))))))))))))))
(define LibrariesC-45DataC-45IOArray-newArrayCopy (lambda (arg-2 arg-3 arg-4) (let ((u--newsizeC-39 (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-3 (LibrariesC-45DataC-45IOArray-max arg-4)))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45IOArray-max arg-4)) (else arg-3))))) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45IOArray-newArray arg-2 u--newsizeC-39)) (lambda (u--arrC-39) (let ((e-7 (car arg-2))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (LibrariesC-45DataC-45IOArray-n--2946-1166-u--copyFrom arg-2 arg-4 arg-3 (let ((e-11 (cdr arg-4))) e-11) (let ((e-11 (cdr u--arrC-39))) e-11) (bs- (LibrariesC-45DataC-45IOArray-max arg-4) (blodwen-toSignedInt 1 63) 63))) (lambda (_-10649) (let ((e-12 (car arg-2))) (let ((e-15 (vector-ref e-12 0))) (let ((e-17 (vector-ref e-15 1))) ((e-17 'erased) u--arrC-39)))))))))))))))
(define CoreC-45Context-newEntry (lambda (arg-0 arg-1) (let ((u--idx (let ((e-1 (vector-ref arg-1 1))) e-1))) (let ((u--a (let ((e-4 (vector-ref arg-1 4))) e-4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox u--a))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--idx (LibrariesC-45DataC-45IOArray-max e-5)))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 ((LibrariesC-45DataC-45IOArray-newArrayCopy csegen-82 (bs+ (LibrariesC-45DataC-45IOArray-max e-5) CoreC-45Context-Grow 63) e-5) eta-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (set-box! u--a e-6))) (vector 1 act-3))))) eff-0) eta-1)))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (cons u--idx (let ((e-0 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-13 (vector-ref arg-1 5))) (let ((e-12 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (vector e-0 (bs+ u--idx 1 63) (LibrariesC-45DataC-45NameMap-insert arg-0 u--idx e-2) (CoreC-45Context-addPossible arg-0 u--idx e-3) e-4 e-13 e-12 e-7 e-8 e-9 e-10 e-11)))))))))))))))))))) eff-0) eta-0))))))))))
(define CoreC-45Context-getPosition (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (lambda (eta-0) (vector 1 (cons e-0 arg-1)))))(else (let ((sc0 (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)))) (if (null? sc0) (CoreC-45Context-newEntry arg-0 arg-1) (let ((e-1 (unbox sc0))) (lambda (eta-0) (vector 1 (cons e-1 arg-1))))))))))
(define CoreC-45Context-addCtxt (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (or (and (= (let ((e-5 (vector-ref arg-2 5))) e-5) 0) 1) 0))) (cond ((equal? sc0 1) (let ((act-1 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((u--a (let ((e-4 (vector-ref e-3 4))) e-4))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox u--a))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 e-6 e-2 (vector 1 arg-1)) eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (cons e-2 e-3)))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))) (else (let ((act-1 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-2 (let ((e-0 (vector-ref e-3 0))) (let ((e-1 (vector-ref e-3 1))) (let ((e-14 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((e-4 (vector-ref e-3 4))) (let ((e-12 (vector-ref e-3 5))) (let ((e-6 (vector-ref e-3 6))) (let ((e-7 (vector-ref e-3 7))) (let ((e-8 (vector-ref e-3 8))) (let ((e-9 (vector-ref e-3 9))) (let ((e-10 (vector-ref e-3 10))) (let ((e-11 (vector-ref e-3 11))) (vector e-0 e-1 e-14 e-13 e-4 e-12 (LibrariesC-45DataC-45IntMap-insert e-2 (vector 1 arg-1) e-6) e-7 e-8 e-9 e-10 e-11)))))))))))))))))))) eff-0) ext-0))))))))))
(define LibrariesC-45DataC-45NameMap-branch4 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8))))
(define LibrariesC-45DataC-45NameMap-branch5 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 2 arg-6 arg-7 arg-8 arg-9 arg-10))))
(define LibrariesC-45DataC-45NameMap-branch6 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 2 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8) arg-9 (vector 1 arg-10 arg-11 arg-12))))
(define LibrariesC-45DataC-45NameMap-branch7 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 2 (vector 2 arg-2 arg-3 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10) arg-11 (vector 1 arg-12 arg-13 arg-14))))
(define LibrariesC-45DataC-45NameMap-merge1 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch5 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch6 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((e-10 (vector-ref arg-4 4))) (let ((e-11 (vector-ref arg-4 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch6 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch7 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45NameMap-merge2 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch5 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch6 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45NameMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45NameMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45NameMap-merge3 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-4 0) ((1) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-branch5 e-2 e-3 e-4 arg-3 e-14 e-15 e-16 arg-5 arg-6))))) (else (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (let ((e-22 (vector-ref arg-4 4))) (let ((e-23 (vector-ref arg-4 5))) (LibrariesC-45DataC-45NameMap-branch6 e-2 e-3 e-4 arg-3 e-19 e-20 e-21 e-22 e-23 arg-5 arg-6)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-4 0) ((1) (let ((e-26 (vector-ref arg-4 1))) (let ((e-27 (vector-ref arg-4 2))) (let ((e-28 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 e-26 e-27 e-28 arg-5 arg-6))))) (else (let ((e-31 (vector-ref arg-4 1))) (let ((e-32 (vector-ref arg-4 2))) (let ((e-33 (vector-ref arg-4 3))) (let ((e-34 (vector-ref arg-4 4))) (let ((e-35 (vector-ref arg-4 5))) (LibrariesC-45DataC-45NameMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 e-31 e-32 e-33 e-34 e-35 arg-5 arg-6)))))))))))))))))
(define LibrariesC-45DataC-45NameMap-treeDelete (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 e-2))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (vector 0 (vector 0 e-2 e-3))))))))(else (let ((e-0 (- arg-1 1))) (cond ((equal? e-0 0) (case (vector-ref arg-3 0) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-8))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-7))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-2 e-8 e-9)))) (else (vector 1 e-9))))) (else (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-9))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-7 e-8 e-2)))) (else (vector 1 e-7))))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (let ((e-16 (vector-ref arg-3 5))) (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-2 e-13 e-14 e-15 e-16)))) (else (vector 0 (vector 1 e-14 e-15 e-16)))))) (else (let ((sc3 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-15))) (cond ((equal? sc3 1) (let ((sc4 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-14))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-2 e-15 e-16)))) (else (vector 0 (vector 1 e-12 e-13 e-16)))))) (else (let ((sc4 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-2 e-16))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-14 e-15 e-2)))) (else (vector 0 (vector 1 e-12 e-13 e-14)))))))))))))))))))(else (let ((e-4 (- e-0 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-20))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete (+ e-4 1) arg-2 e-19))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-20 e-21)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-21 0) ((1) (let ((e-2 (vector-ref e-21 1))) (let ((e-3 (vector-ref e-21 2))) (let ((e-6 (vector-ref e-21 3))) (vector 1 (vector 2 e-5 e-20 e-2 e-3 e-6)))))) (else (let ((e-7 (vector-ref e-21 1))) (let ((e-8 (vector-ref e-21 2))) (let ((e-9 (vector-ref e-21 3))) (let ((e-10 (vector-ref e-21 4))) (let ((e-11 (vector-ref e-21 5))) (vector 0 (LibrariesC-45DataC-45NameMap-branch4 e-5 e-20 e-7 e-8 e-9 e-10 e-11)))))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete (+ e-4 1) arg-2 e-21))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-19 e-20 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-19 0) ((1) (let ((e-2 (vector-ref e-19 1))) (let ((e-3 (vector-ref e-19 2))) (let ((e-6 (vector-ref e-19 3))) (vector 1 (vector 2 e-2 e-3 e-6 e-20 e-5)))))) (else (let ((e-7 (vector-ref e-19 1))) (let ((e-8 (vector-ref e-19 2))) (let ((e-9 (vector-ref e-19 3))) (let ((e-10 (vector-ref e-19 4))) (let ((e-11 (vector-ref e-19 5))) (vector 0 (LibrariesC-45DataC-45NameMap-branch4 e-7 e-8 e-9 e-10 e-11 e-20 e-5)))))))))))))))))))) (else (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (let ((e-28 (vector-ref arg-3 5))) (let ((sc1 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-25))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete (+ e-4 1) arg-2 e-24))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-25 e-26 e-27 e-28)))) (else (let ((e-5 (vector-ref sc2 1))) (vector 0 (LibrariesC-45DataC-45NameMap-merge1 e-5 e-25 e-26 e-27 e-28))))))) (else (let ((sc2 (CoreC-45Name-u--C-60C-61_Ord_Name arg-2 e-27))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete (+ e-4 1) arg-2 e-26))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-2 e-27 e-28)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45NameMap-merge2 e-24 e-25 e-5 e-27 e-28))))))) (else (let ((sc3 (LibrariesC-45DataC-45NameMap-treeDelete (+ e-4 1) arg-2 e-28))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-26 e-27 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45NameMap-merge3 e-24 e-25 e-26 e-27 e-5)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45NameMap-delete (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (let ((sc2 (LibrariesC-45DataC-45NameMap-treeDelete 0 arg-1 e-3))) (case (vector-ref sc2 0) ((0) (let ((e-4 (vector-ref sc2 1))) (cons 0 e-4))) (else '()))))(else (let ((e-4 (- e-2 1))) (let ((sc1 (LibrariesC-45DataC-45NameMap-treeDelete (+ e-4 1) arg-1 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-5 (vector-ref sc1 1))) (cons (+ e-4 1) e-5))) (else (let ((e-5 (vector-ref sc1 1))) (cons e-4 e-5)))))))))))))
(define CoreC-45Context-clearUserHole (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 (LibrariesC-45DataC-45NameMap-delete arg-1 e-25) e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-addDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-addCtxt arg-1 arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 (let ((act-3 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-36 (vector-ref e-5 2))) (let ((e-35 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-34 (vector-ref e-5 5))) (let ((e-33 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-3 e-1 e-36 e-35 e-4 e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (let ((e-18 (vector-ref arg-2 18))) (case (vector-ref e-18 0) ((0) (vector 1 (vector 0 ))) ((7) (vector 1 (vector 0 )))(else ((CoreC-45Context-clearUserHole arg-0 (let ((e-49 (vector-ref arg-2 1))) e-49)) clam-0)))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (vector 1 e-2)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-addGuessName (lambda (arg-0 arg-1 arg-2 arg-3) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 (LibrariesC-45DataC-45IntMap-insert arg-3 (cons arg-1 arg-2) e-1) e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-inCurrentNS (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) (vector 1 e-0)))))) eff-0) ext-0))))))) ((6) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 (let ((e-34 (vector-ref e-5 2))) e-34) arg-1))))) eff-0) ext-0)))))) ((7) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) arg-1))))) eff-0) ext-0)))))) ((5) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 (let ((e-2 (vector-ref e-7 2))) e-2) arg-1))))) eff-0) ext-0)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) arg-1))))) eff-0) ext-0)))))) ((4) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 (let ((e-2 (vector-ref e-5 2))) e-2) arg-1))))) eff-0) ext-0))))))(else (vector 1 arg-1)))))
(define CoreC-45UnifyState-genName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-inCurrentNS arg-0 (vector 2 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 e-7)))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Env-length (lambda (arg-2) (if (null? arg-2) 0 (let ((e-5 (cdr arg-2))) (+ (CoreC-45Env-length e-5) 1)))))
(define CoreC-45ContextC-45Log-logTerm (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (CoreC-45Context-toFullNames arg-1 csegen-68 arg-6 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? arg-2 "") (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-6)))))) "\xa;") clam-1))) (vector 1 act-3)))(else (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-6)))))))) "\xa;") clam-1))) (vector 1 act-3))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-mkConstant (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (let ((u--ty (CoreC-45TTC-45Binder-binderType e-8))) (CoreC-45UnifyState-mkConstant e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 0 arg-1 (CoreC-45TTC-45Binder-multiplicity e-8) (vector 1 ) u--ty) arg-3))))))))))
(define CoreC-45Context-newDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector arg-0 arg-1 arg-4 '() '() '() '() arg-2 arg-3 arg-5 CoreC-45TT-unchecked 0 '() '() '() 0 0 0 arg-6 '() '() '() '())))
(define CoreC-45TTC-45Binder-isLet (lambda (arg-1) (case (vector-ref arg-1 0) ((1) 1)(else 0))))
(define PreludeC-45TypesC-45SnocList-lengthPlus (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (PreludeC-45TypesC-45SnocList-lengthPlus (+ arg-1 1) e-2)))))
(define PreludeC-45TypesC-45SnocList-lengthTR (lambda (ext-0) (PreludeC-45TypesC-45SnocList-lengthPlus 0 ext-0)))
(define CoreC-45UnifyState-mkLocal (lambda (arg-3 arg-4 arg-5) (vector 0 arg-4 (box (CoreC-45TTC-45Binder-isLet arg-5)) (PreludeC-45TypesC-45SnocList-lengthTR arg-3))))
(define CoreC-45UnifyState-mkConstantAppArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (let ((u--rec (CoreC-45UnifyState-mkConstantAppArgs e-3 arg-2 arg-3 e-9 (cons arg-5 e-2)))) (let ((sc2 (cond ((equal? arg-2 1) 1) (else (let ((sc4 (CoreC-45TTC-45Binder-isLet e-8))) (cond ((equal? sc4 1) 0) (else 1))))))) (cond ((equal? sc2 1) (cons (CoreC-45UnifyState-mkLocal arg-5 arg-3 e-8) u--rec)) (else u--rec)))))))))))
(define CoreC-45UnifyState-n--11780-6457-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-1 1 arg-6 arg-4 '())))) u--args)))
(define CoreC-45UnifyState-newConstant (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((u--def (CoreC-45UnifyState-mkConstant arg-0 arg-3 arg-5 arg-6))) (let ((u--defty (CoreC-45Env-abstractFullEnvType arg-0 arg-3 arg-5 arg-7))) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genName arg-2 arg-1 "postpone" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--guess (CoreC-45Context-newDef arg-3 e-5 arg-4 '() u--defty (LibrariesC-45DataC-45WithDefault-specified 2) (vector 9 u--def (CoreC-45Env-length arg-5) arg-8)))) (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-2 "unify.constant" 5 (lambda () (string-append "Adding new constant " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1832 (cons e-5 (cons arg-3 arg-4))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45ContextC-45Log-logTerm '() arg-2 "unify.constant" 10 (lambda () (string-append "New constant type " (CoreC-45Name-u--show_Show_Name e-5))) u--defty eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Context-addDef arg-2 e-5 u--guess eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45UnifyState-addGuessName arg-1 arg-3 e-5 e-8) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-3 e-5 e-8 (CoreC-45UnifyState-n--11780-6457-u--envArgs arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1))))))))) eff-0) eta-1))))))))))))))) eff-0) eta-0))))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32unifyBothBinders-24407 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (if (null? arg-26) (let ((act-1 (((arg-12 arg-20) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-15 (vector 1 arg-16 (vector 0 ) arg-24))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((arg-9 arg-20) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-15 (vector 1 arg-16 (vector 0 ) arg-24))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2476) (cons arg-13 arg-0) arg-19 arg-18 (CoreC-45Unify-lower arg-17) arg-16) arg-25) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-7)) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-8)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((act-1 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-19 arg-0 arg-21 arg-15 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-19 arg-0 arg-21 arg-15 arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45UnifyState-newConstant arg-0 arg-18 arg-19 arg-16 csegen-30 arg-15 (vector 3 arg-14 arg-13 (vector 0 arg-8 arg-7 (vector 1 ) e-5) (vector 0 arg-14 '() 0)) (vector 3 arg-14 arg-13 (vector 2 arg-8 arg-7 (vector 1 ) e-5) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) e-6)))) arg-26) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (((arg-12 arg-20) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-15 (vector 1 arg-16 (vector 0 ) arg-24))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (((arg-9 arg-20) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-15 (vector 4 arg-16 e-7 (vector 1 arg-16 (vector 0 ) arg-24)))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-8 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-19 arg-0 arg-21 arg-15 e-9 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (((((CoreC-45Unify-unify (csegen-2476) (cons arg-13 arg-0) arg-19 arg-18 (CoreC-45Unify-lower arg-17) arg-16) arg-25) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-10)) (CoreC-45TT-refsToLocals (vector 1 arg-13 arg-24 (vector 0 )) e-11)) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (CoreC-45Unify-union arg-23 e-12))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))
(define CoreC-45NormaliseC-45Convert-allConvNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (if (null? arg-7) (vector 1 1) (vector 1 0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? arg-7) (vector 1 0) (let ((e-6 (car arg-7))) (let ((e-7 (cdr arg-7))) (let ((act-1 ((CoreC-45NormaliseC-45Convert-allConvNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-6)) (else (lambda (eta-0) (vector 1 0)))))) eff-0) clam-0))))))))))))))
(define CoreC-45NormaliseC-45Convert-n--8409-8122-u--quickConvHead (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (case (vector-ref arg-6 0) ((0) 1)(else 0))) ((1) (let ((e-7 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((1) (let ((e-19 (vector-ref arg-6 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-19)))(else 0)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (case (vector-ref arg-6 0) ((2) (let ((e-21 (vector-ref arg-6 1))) (CoreC-45Name-u--C-61C-61_Eq_Name e-9 e-21)))(else 0))))(else 0))))
(define CoreC-45NormaliseC-45Convert-n--8409-8121-u--quickConvArg (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) 1)(else (case (vector-ref arg-6 0) ((0) 1)(else (case (vector-ref arg-5 0) ((1) (let ((e-5 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((1) (let ((e-49 (vector-ref arg-6 2))) (CoreC-45NormaliseC-45Convert-n--8409-8122-u--quickConvHead arg-1 arg-2 arg-3 arg-4 e-5 e-49)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((2) (let ((e-10 (vector-ref arg-5 3))) (case (vector-ref arg-6 0) ((2) (let ((e-54 (vector-ref arg-6 3))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 e-54)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((3) (let ((e-15 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((3) (let ((e-59 (vector-ref arg-6 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-15 e-59)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((4) (let ((e-23 (vector-ref arg-5 4))) (case (vector-ref arg-6 0) ((4) (let ((e-67 (vector-ref arg-6 4))) (CoreC-45NormaliseC-45Convert-n--8409-8121-u--quickConvArg arg-1 arg-2 arg-3 arg-4 e-23 e-67)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((5) (let ((e-27 (vector-ref arg-5 3))) (case (vector-ref arg-6 0) ((5) (let ((e-71 (vector-ref arg-6 3))) (CoreC-45NormaliseC-45Convert-n--8409-8121-u--quickConvArg arg-1 arg-2 arg-3 arg-4 e-27 e-71)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((6) (case (vector-ref arg-6 0) ((6) 1)(else (case (vector-ref arg-6 0) ((9) 1)(else 0))))) ((7) (let ((e-36 (vector-ref arg-5 3))) (case (vector-ref arg-6 0) ((7) (let ((e-80 (vector-ref arg-6 3))) (CoreC-45NormaliseC-45Convert-n--8409-8121-u--quickConvArg arg-1 arg-2 arg-3 arg-4 e-36 e-80)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((8) (let ((e-40 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((8) (let ((e-84 (vector-ref arg-6 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-40 e-84)))(else (case (vector-ref arg-6 0) ((9) 1)(else 0)))))) ((10) (case (vector-ref arg-6 0) ((10) 1)(else (case (vector-ref arg-6 0) ((9) 1)(else 0))))) ((9) 1)(else (case (vector-ref arg-6 0) ((9) 1)(else 0))))))))))
(define CoreC-45NormaliseC-45Convert-quickConv (lambda (arg-1 arg-2) (if (null? arg-1) (if (null? arg-2) 1 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? arg-2) 0 (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (let ((sc2 (CoreC-45NormaliseC-45Convert-n--8409-8121-u--quickConvArg e-2 e-3 e-6 e-7 e-2 e-6))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-quickConv e-3 e-7)) (else 0)))))))))))
(define CoreC-45NormaliseC-45Convert-allConv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 eta-0)) arg-6 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 eta-1)) arg-7 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc2 (CoreC-45NormaliseC-45Convert-quickConv e-5 e-6))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConvNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6)) (else (lambda (eta-1) (vector 1 0))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-n--8449-8479-u--weakenP (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-17) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (cons (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) e-2))) (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) e-3))))))))
(define CoreC-45NormaliseC-45Convert-n--8449-8478-u--extend (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-13) (if (null? arg-14) (box arg-15) '()) (let ((e-3 (cdr arg-13))) (if (null? arg-14) '() (let ((e-7 (cdr arg-14))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--8449-8478-u--extend arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 e-7 arg-15) (lambda (u--rest) (box (cons (cons 0 0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45NormaliseC-45Convert-n--8449-8479-u--weakenP arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 eta-0)) u--rest)))))))))))
(define CoreC-45NormaliseC-45Convert-n--8449-8477-u--dropV (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 arg-15) (if (null? arg-14) (box arg-15) (let ((e-3 (cdr arg-14))) (cond ((equal? arg-15 0) '())(else (let ((e-9 (- arg-15 1))) (CoreC-45NormaliseC-45Convert-n--8449-8477-u--dropV arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 e-9))))))))
(define CoreC-45NormaliseC-45Convert-n--8449-8476-u--dropP (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--8449-8477-u--dropV arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--8449-8477-u--dropV arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 e-3) (lambda (bind-1) (box (cons bind-0 bind-1))))))))))
(define CoreC-45NormaliseC-45Convert-case--caseC-32blockC-32inC-32getMatchingVarAlt-8774 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-13) (vector 1 '()) (let ((e-1 (unbox arg-13))) (let ((act-1 ((CoreC-45NormaliseC-45Convert-getMatchingVars arg-12 (PreludeC-45TypesC-45List-tailRecAppend arg-2 arg-0) (PreludeC-45TypesC-45List-tailRecAppend arg-6 arg-1) arg-11 e-1 arg-3 arg-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 '()) (let ((e-2 (unbox e-5))) (vector 1 (box (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CoreC-45NormaliseC-45Convert-n--8449-8476-u--dropP arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-2 arg-6 eta-0)) e-2)))))))) eff-0) ext-0)))))))))
(define CoreC-45NormaliseC-45Convert-getMatchingVarAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref arg-6 0) ((0) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-11))) (cond ((equal? sc2 1) (lambda (eta-0) (CoreC-45NormaliseC-45Convert-case--caseC-32blockC-32inC-32getMatchingVarAlt-8774 arg-1 arg-2 e-3 e-4 e-2 e-1 e-13 e-14 e-12 e-11 arg-4 arg-3 arg-0 (CoreC-45NormaliseC-45Convert-n--8449-8478-u--extend arg-1 arg-2 e-3 e-4 e-2 e-1 e-13 e-14 e-12 e-11 arg-4 arg-3 arg-0 e-3 e-13 arg-4) eta-0))) (else (lambda (eta-0) (vector 1 '()))))))))))(else (lambda (eta-0) (vector 1 '()))))))))) ((2) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((2) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-16))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-getMatchingVars arg-0 arg-1 arg-2 arg-3 arg-4 e-7 e-17)) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 '()))))))) ((3) (let ((e-9 (vector-ref arg-5 1))) (case (vector-ref arg-6 0) ((3) (let ((e-19 (vector-ref arg-6 1))) (CoreC-45NormaliseC-45Convert-getMatchingVars arg-0 arg-1 arg-2 arg-3 arg-4 e-9 e-19)))(else (lambda (eta-0) (vector 1 '()))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45NormaliseC-45Convert-getMatchingVarAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-5) (if (null? arg-6) (vector 1 (box arg-4)) (vector 1 '())) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? arg-6) (vector 1 '()) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (let ((act-1 ((CoreC-45NormaliseC-45Convert-getMatchingVarAlt arg-0 arg-1 arg-2 arg-3 arg-4 e-2 e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox e-5))) (CoreC-45NormaliseC-45Convert-getMatchingVarAlts arg-0 arg-1 arg-2 arg-3 e-1 e-3 e-7))))) eff-0) clam-0))))))))))))))
(define CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 (lambda (arg-2 arg-3) (or (and (= arg-2 arg-3) 1) 0)))
(define CoreC-45NormaliseC-45Convert-n--7765-7112-u--findIdx (lambda (arg-0 arg-1 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 e-6 arg-9))) (cond ((equal? sc2 1) (box e-7)) (else (CoreC-45NormaliseC-45Convert-n--7765-7112-u--findIdx arg-0 arg-1 arg-3 arg-5 arg-6 arg-7 e-3 arg-9)))))))))))
(define CoreC-45NormaliseC-45Convert-n--7765-7293-u--tryUpdatePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) (box (vector 1 ))) ((0) (box (vector 0 ))) ((2) (box (vector 2 ))) (else (let ((e-4 (vector-ref arg-7 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-4) (lambda (bind-0) (box (vector 3 bind-0)))))))))
(define CoreC-45NormaliseC-45Convert-n--7765-7292-u--tryUpdateB (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7765-7293-u--tryUpdatePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-4) (lambda (bind-1) (box (vector 0 e-1 e-2 bind-0 bind-1))))))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-8) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-9) (lambda (bind-1) (box (vector 1 e-6 e-7 bind-0 bind-1))))))))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7765-7293-u--tryUpdatePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-6 e-14) (lambda (bind-1) (box (vector 2 e-11 e-12 bind-0 bind-1)))))))))))(else '()))))
(define CoreC-45NormaliseC-45Convert-n--7765-7294-u--weakenP (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (cons (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) e-2))) (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) e-3))))))))
(define CoreC-45NormaliseC-45Convert-tryUpdate (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7765-7112-u--findIdx arg-0 arg-1 e-4 e-3 e-2 arg-2 arg-2 e-4) (lambda (_-0) (box (vector 0 e-2 e-3 _-0)))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (box (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 eta-0)) e-14) (lambda (bind-0) (box (vector 2 e-11 e-12 e-13 bind-0))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-n--7765-7292-u--tryUpdateB arg-0 arg-1 e-17 e-19 e-18 e-16 arg-2 e-18) (lambda (u--bC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate (cons e-17 arg-0) (cons e-17 arg-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45NormaliseC-45Convert-n--7765-7294-u--weakenP arg-0 arg-1 e-17 e-19 e-18 e-16 arg-2 e-17 eta-0)) arg-2) e-19) (lambda (bind-0) (box (vector 3 e-16 e-17 u--bC-39 bind-0))))))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-22) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-23) (lambda (bind-1) (box (vector 4 e-21 bind-0 bind-1)))))))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-27) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-28) (lambda (bind-1) (box (vector 5 e-25 e-26 bind-0 bind-1))))))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-32) (lambda (bind-0) (box (vector 6 e-30 e-31 bind-0)))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-36) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-37) (lambda (bind-1) (box (vector 7 e-34 e-35 bind-0 bind-1))))))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 e-41) (lambda (bind-0) (box (vector 8 e-39 e-40 bind-0)))))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (box (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 10 e-46 eta-0)) (CoreC-45TTC-45Term-u--traverse_Traversable_WhyErased csegen-255 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-tryUpdate arg-0 arg-1 arg-2 eta-0)) e-47))))) (else (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (box (vector 11 e-49 e-50))))))))
(define CoreC-45TTC-45Term-getLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) e-2)) ((1) (let ((e-7 (vector-ref arg-1 1))) e-7)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-21 (vector-ref arg-1 1))) e-21)) ((5) (let ((e-25 (vector-ref arg-1 1))) e-25)) ((6) (let ((e-30 (vector-ref arg-1 1))) e-30)) ((7) (let ((e-34 (vector-ref arg-1 1))) e-34)) ((8) (let ((e-39 (vector-ref arg-1 1))) e-39)) ((9) (let ((e-43 (vector-ref arg-1 1))) e-43)) ((10) (let ((e-46 (vector-ref arg-1 1))) e-46)) (else (let ((e-49 (vector-ref arg-1 1))) e-49)))))
(define CoreC-45NormaliseC-45Convert-u--convGen_Convert_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 arg-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convert_Convert_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Term arg-0 arg-1 e-5 0 arg-2 arg-3 arg-4 arg-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-case--getMatchingVars-9186 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (if (null? arg-9) (vector 1 '()) (let ((e-1 (unbox arg-9))) (let ((act-1 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-8 arg-1 arg-7 (CoreC-45Env-mkEnv (CoreC-45TTC-45Term-getLoc arg-2) arg-1) e-1 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-5 1) (vector 1 (box arg-6))) (else (vector 1 '())))))) eff-0) ext-0)))))))))
(define CoreC-45NormaliseC-45Convert-getMatchingVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 4))) (case (vector-ref arg-6 0) ((0) (let ((e-14 (vector-ref arg-6 2))) (let ((e-17 (vector-ref arg-6 4))) (CoreC-45NormaliseC-45Convert-getMatchingVarAlts arg-0 arg-1 arg-2 arg-3 (cons (cons e-2 e-14) arg-4) e-5 e-17))))(else (lambda (eta-0) (vector 1 '()))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((1) (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (lambda (eta-0) (CoreC-45NormaliseC-45Convert-case--getMatchingVars-9186 arg-1 arg-2 e-8 e-7 e-20 e-19 arg-4 arg-3 arg-0 (CoreC-45NormaliseC-45Convert-tryUpdate arg-1 arg-2 arg-4 e-8) eta-0)))))(else (lambda (eta-0) (vector 1 '()))))))) ((2) (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (vector 1 (box arg-4)))(else (vector 1 '()))))) ((3) (lambda (clam-1) (case (vector-ref arg-6 0) ((3) (vector 1 (box arg-4)))(else (vector 1 '())))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45NormaliseC-45Convert-n--8554-9345-u--getArgPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (cond ((equal? arg-10 0) (let ((e-2 (car arg-11))) (box e-2)))(else (let ((e-0 (- arg-10 1))) (let ((e-6 (cdr arg-11))) (CoreC-45NormaliseC-45Convert-n--8554-9345-u--getArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-0 e-6))))))))
(define CoreC-45NormaliseC-45Convert-n--8554-9344-u--convertMatches (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((sc2 (CoreC-45NormaliseC-45Convert-n--8554-9345-u--getArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 arg-2))) (if (null? sc2) (vector 1 0) (let ((e-1 (unbox sc2))) (let ((sc3 (CoreC-45NormaliseC-45Convert-n--8554-9345-u--getArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7 arg-1))) (if (null? sc3) (vector 1 0) (let ((e-4 (unbox sc3))) (let ((act-1 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 e-1 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Convert-n--8554-9344-u--convertMatches arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 arg-13 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cond ((equal? e-5 1) e-8) (else 0)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))))))
(define CoreC-45NormaliseC-45Convert-chkSameDefs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-1 (CoreC-45Context-lookupDefExact arg-6 (let ((e-0 (vector-ref arg-4 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (let ((act-2 (CoreC-45Context-lookupDefExact arg-7 (let ((e-0 (vector-ref arg-4 0))) e-0) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (vector 1 0) (let ((e-9 (unbox e-8))) (case (vector-ref e-9 0) ((1) (let ((e-13 (vector-ref e-9 2))) (let ((e-12 (vector-ref e-9 3))) (let ((act-3 ((CoreC-45NormaliseC-45Convert-getMatchingVars arg-0 e-3 e-13 arg-4 '() e-4 e-12) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-15) (lambda (eta-0) (vector 1 0)) (let ((e-16 (unbox e-15))) (CoreC-45NormaliseC-45Convert-n--8554-9344-u--convertMatches arg-1 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-3 e-13 e-16))))) eff-0) clam-1))))))))(else (vector 1 0)))))))) eff-0) clam-0))))))))(else (vector 1 0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-n--8591-9929-u--findArgPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((0) (let ((e-2 (vector-ref arg-14 2))) (box e-2)))(else '()))))
(define CoreC-45NormaliseC-45Convert-n--8591-9930-u--getScrutinee (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 arg-15) (cond ((equal? arg-14 0) (if (null? arg-15) '() (let ((e-2 (car arg-15))) (box e-2))))(else (let ((e-0 (- arg-14 1))) (if (null? arg-15) '() (let ((e-6 (cdr arg-15))) (CoreC-45NormaliseC-45Convert-n--8591-9930-u--getScrutinee arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-0 e-6))))))))
(define CoreC-45NormaliseC-45Convert-chkConvCaseBlock (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (case (vector-ref arg-9 0) ((1) (let ((e-4 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((0) (let ((e-3 (vector-ref e-6 2))) (case (vector-ref e-3 0) ((6) (let ((act-2 (CoreC-45Context-u--full_HasNames_Name (let ((e-41 (vector-ref arg-5 0))) e-41) e-5 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 2))) (case (vector-ref e-10 0) ((6) (let ((act-3 (CoreC-45NormaliseC-45Convert-chkSameDefs arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-2 e-5 arg-8 arg-10 clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-14 0) (let ((act-4 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-47 (vector-ref arg-5 0))) e-47)) clam-3))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-15) (vector 1 0) (let ((e-16 (unbox e-15))) (let ((act-5 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-49 (vector-ref arg-5 0))) e-49)) clam-4))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (if (null? e-17) (lambda (eta-0) (vector 1 0)) (let ((e-18 (unbox e-17))) (let ((e-23 (vector-ref e-16 18))) (case (vector-ref e-23 0) ((1) (let ((e-44 (vector-ref e-23 3))) (let ((e-51 (vector-ref e-18 18))) (case (vector-ref e-51 0) ((1) (let ((e-72 (vector-ref e-51 3))) (let ((sc16 (CoreC-45NormaliseC-45Convert-n--8591-9929-u--findArgPos arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-44))) (if (null? sc16) (lambda (eta-0) (vector 1 0)) (let ((e-75 (unbox sc16))) (let ((sc17 (CoreC-45NormaliseC-45Convert-n--8591-9929-u--findArgPos arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-72))) (if (null? sc17) (lambda (eta-0) (vector 1 0)) (let ((e-76 (unbox sc17))) (lambda (clam-5) (let ((sc18 (CoreC-45NormaliseC-45Convert-n--8591-9930-u--getScrutinee arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-75 arg-8))) (if (null? sc18) (vector 1 0) (let ((e-77 (unbox sc18))) (let ((sc19 (CoreC-45NormaliseC-45Convert-n--8591-9930-u--getScrutinee arg-1 e-4 e-1 e-2 e-5 arg-10 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-76 arg-10))) (if (null? sc19) (vector 1 0) (let ((e-78 (unbox sc19))) (let ((act-6 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-77 e-78 eta-0)) clam-5))) (case (vector-ref act-6 0) ((0) (let ((e-79 (vector-ref act-6 1))) (vector 0 e-79))) (else (vector 1 (CoreC-45FC-u--C-61C-61_Eq_FC (let ((e-102 (vector-ref e-16 0))) e-102) (let ((e-102 (vector-ref e-18 0))) e-102)))))))))))))))))))))(else (lambda (eta-0) (vector 1 0)))))))(else (lambda (eta-0) (vector 1 0))))))))) eff-0) clam-4)))))))))) eff-0) clam-3)))))) (else (vector 1 1)))))) eff-0) clam-2))))))(else (vector 1 0)))))(else (vector 1 0)))))) eff-0) clam-1))))))(else (vector 1 0)))))(else (vector 1 0)))))) eff-0) clam-0))))))))(else (vector 1 0))))))(else (vector 1 0))))))
(define CoreC-45NormaliseC-45Convert-chkConvHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 2))) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (let ((e-15 (vector-ref arg-7 2))) (vector 1 (or (and (= e-3 e-15) 1) 0))))(else (vector 1 0)))))) ((1) (let ((e-7 (vector-ref arg-6 2))) (lambda (clam-1) (case (vector-ref arg-7 0) ((1) (let ((e-19 (vector-ref arg-7 2))) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-19))))(else (vector 1 0)))))) ((2) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((2) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (lambda (clam-0) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 e-22))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-11 e-23 clam-0)) (else (vector 1 0))))))))(else (lambda (eta-0) (vector 1 0)))))))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45TTC-45Term-compatible (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) 1)(else (cond ((equal? arg-1 2) 1)(else (CoreC-45TTC-45Term-u--C-61C-61_Eq_LazyReason arg-0 arg-1)))))))
(define CoreC-45NormaliseC-45Convert-convBinders (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((2) (let ((e-2 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((2) (let ((e-12 (vector-ref arg-7 2))) (let ((e-14 (vector-ref arg-7 4))) (lambda (clam-0) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-2 e-12))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-14 clam-0))))))))(else (lambda (clam-1) (let ((sc1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (CoreC-45TTC-45Binder-multiplicity arg-6) (CoreC-45TTC-45Binder-multiplicity arg-7)))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TTC-45Binder-binderType arg-6) (CoreC-45TTC-45Binder-binderType arg-7) clam-1)))))))))) ((0) (let ((e-7 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((0) (let ((e-17 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 4))) (lambda (clam-2) (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-7 e-17))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 e-19 clam-2))))))))(else (lambda (clam-3) (let ((sc1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (CoreC-45TTC-45Binder-multiplicity arg-6) (CoreC-45TTC-45Binder-multiplicity arg-7)))) (cond ((equal? sc1 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TTC-45Binder-binderType arg-6) (CoreC-45TTC-45Binder-binderType arg-7) clam-3))))))))))(else (lambda (clam-4) (let ((sc0 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (CoreC-45TTC-45Binder-multiplicity arg-6) (CoreC-45TTC-45Binder-multiplicity arg-7)))) (cond ((equal? sc0 1) (vector 1 0)) (else (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TTC-45Binder-binderType arg-6) (CoreC-45TTC-45Binder-binderType arg-7) clam-4)))))))))
(define CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-2)))
(define CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-5)))
(define CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13 arg-14 arg-15) (if (null? arg-14) arg-15 (if (null? arg-15) '() (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-13 arg-14))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (+ arg-13 1) arg-14 e-3)) (else (cons e-2 (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (+ arg-13 1) arg-14 e-3)))))))))))
(define CoreC-45NormaliseC-45Convert-n--13179-12245-u--getInfPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (case (vector-ref arg-12 0) ((1) (let ((e-2 (vector-ref arg-12 2))) (cond ((equal? arg-9 1) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-8 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 '()) (let ((e-3 (unbox e-5))) (vector 1 (let ((e-6 (vector-ref e-3 6))) e-6))))))) eff-0) clam-0)))))) (else (vector 1 '())))))(else (vector 1 '()))))))
(define CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-109 (vector-ref arg-6 1))) (let ((e-110 (vector-ref arg-6 2))) (let ((e-111 (vector-ref arg-6 3))) (let ((e-112 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((0) (let ((e-121 (vector-ref arg-7 3))) (let ((e-122 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 (CoreC-45NormaliseC-45Quote-genName arg-2 "conv" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--c (vector 0 '() CoreC-45Value-defaultOpts '() arg-5 (vector 1 e-109 (vector 0 ) e-5)))) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Convert-convBinders arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-111 e-121) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-6 1) (let ((act-3 (((e-112 arg-4) u--c) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (((e-122 arg-4) u--c) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 e-8))) eff-0) eta-2)))))))) eff-0) clam-0)))))) (else (vector 1 0)))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))(else (case (vector-ref e-111 0) ((0) (let ((e-114 (vector-ref e-111 1))) (let ((e-115 (vector-ref e-111 2))) (let ((e-116 (vector-ref e-111 3))) (let ((e-117 (vector-ref e-111 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45CoreC-45PiInfo-traverse (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 clam-0 eta-2))) e-116) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 e-117 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-5 arg-7 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 (vector 3 e-109 e-110 (vector 0 e-114 e-115 e-6 e-7) (vector 4 e-109 (let ((sc6 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc6))) (((e-1 'erased) 'erased) e-8))) (vector 0 e-109 '() 0)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-99 (vector-ref arg-7 1))) (let ((e-100 (vector-ref arg-7 2))) (let ((e-101 (vector-ref arg-7 3))) (case (vector-ref e-101 0) ((0) (let ((e-104 (vector-ref e-101 1))) (let ((e-105 (vector-ref e-101 2))) (let ((e-106 (vector-ref e-101 3))) (let ((e-107 (vector-ref e-101 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45CoreC-45PiInfo-traverse (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 clam-0 eta-2))) e-106) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 e-107 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-5 arg-6 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 (vector 3 e-99 e-100 (vector 0 e-104 e-105 e-6 e-7) (vector 4 e-99 (let ((sc7 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc7))) (((e-1 'erased) 'erased) e-8))) (vector 0 e-99 '() 0)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-7))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (let ((e-61 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-19 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Convert-n--13179-12245-u--getInfPos arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 e-19) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-2)))) eff-0) eta-1))))))) (else (CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-18 arg-2 arg-3 arg-4 arg-5 e-19 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0) e-60 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-0) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-1) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((2) (let ((e-24 (vector-ref arg-6 3))) (let ((e-26 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-65 (vector-ref arg-7 3))) (let ((e-67 (vector-ref arg-7 5))) (lambda (clam-2) (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-24 e-65))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-67) clam-2)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-3) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-4) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((3) (let ((e-29 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-70 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 5))) (lambda (clam-5) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-29 e-70))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-32) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-73) clam-5)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-6) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-7) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((4) (let ((e-37 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-78 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-37 e-78)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-8) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-9) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((5) (let ((e-40 (vector-ref arg-6 2))) (let ((e-41 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-81 (vector-ref arg-7 2))) (let ((e-82 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45TTC-45Term-compatible e-40 e-81))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-41 e-82)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-10) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-11) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((6) (let ((e-44 (vector-ref arg-6 2))) (let ((e-46 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-85 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 4))) (lambda (clam-11) (let ((sc4 (CoreC-45TTC-45Term-compatible e-44 e-85))) (cond ((equal? sc4 1) (let ((act-1 (cond ((equal? e-44 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-11))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-46 e-87 eta-0)))) eff-0) clam-11)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-12) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-13) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((7) (let ((e-49 (vector-ref arg-6 2))) (let ((e-50 (vector-ref arg-6 3))) (let ((e-51 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-90 (vector-ref arg-7 2))) (let ((e-91 (vector-ref arg-7 3))) (let ((e-92 (vector-ref arg-7 4))) (lambda (clam-14) (let ((sc4 (CoreC-45TTC-45Term-compatible e-49 e-90))) (cond ((equal? sc4 1) (let ((act-1 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-50 e-91) clam-14))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-15) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-51) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-92) clam-15)) (else (vector 1 0)))))) eff-0) clam-14)))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-15) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-16) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((8) (let ((e-54 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-95 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-54 e-95)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-17) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-18) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((9) (let ((e-57 (vector-ref arg-6 2))) (case (vector-ref e-57 0) ((2) (let ((e-97 (vector-ref e-57 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-97 arg-7)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-19) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-20) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-21) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-22) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (let ((e-61 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-19 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Convert-n--13179-12245-u--getInfPos arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 e-19) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-2)))) eff-0) eta-1))))))) (else (CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-18 arg-2 arg-3 arg-4 arg-5 e-19 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0) e-60 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-23) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-24) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((2) (let ((e-24 (vector-ref arg-6 3))) (let ((e-26 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-65 (vector-ref arg-7 3))) (let ((e-67 (vector-ref arg-7 5))) (lambda (clam-25) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-24 e-65))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-67) clam-25)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-26) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-27) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((3) (let ((e-29 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-70 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 5))) (lambda (clam-28) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-29 e-70))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-32) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-73) clam-28)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-29) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-30) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((4) (let ((e-37 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-78 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-37 e-78)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-31) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-32) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((5) (let ((e-40 (vector-ref arg-6 2))) (let ((e-41 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-81 (vector-ref arg-7 2))) (let ((e-82 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45TTC-45Term-compatible e-40 e-81))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-41 e-82)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-33) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-34) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((6) (let ((e-44 (vector-ref arg-6 2))) (let ((e-46 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-85 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 4))) (lambda (clam-33) (let ((sc3 (CoreC-45TTC-45Term-compatible e-44 e-85))) (cond ((equal? sc3 1) (let ((act-1 (cond ((equal? e-44 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-33))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-46 e-87 eta-0)))) eff-0) clam-33)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-35) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-36) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((7) (let ((e-49 (vector-ref arg-6 2))) (let ((e-50 (vector-ref arg-6 3))) (let ((e-51 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-90 (vector-ref arg-7 2))) (let ((e-91 (vector-ref arg-7 3))) (let ((e-92 (vector-ref arg-7 4))) (lambda (clam-36) (let ((sc3 (CoreC-45TTC-45Term-compatible e-49 e-90))) (cond ((equal? sc3 1) (let ((act-1 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-50 e-91) clam-36))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-37) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-51) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-92) clam-37)) (else (vector 1 0)))))) eff-0) clam-36)))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-38) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-39) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((8) (let ((e-54 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-95 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-54 e-95)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-40) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-41) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((9) (let ((e-57 (vector-ref arg-6 2))) (case (vector-ref e-57 0) ((2) (let ((e-97 (vector-ref e-57 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-97 arg-7)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-42) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-43) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-44) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-45) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-99 (vector-ref arg-7 1))) (let ((e-100 (vector-ref arg-7 2))) (let ((e-101 (vector-ref arg-7 3))) (case (vector-ref e-101 0) ((0) (let ((e-104 (vector-ref e-101 1))) (let ((e-105 (vector-ref e-101 2))) (let ((e-106 (vector-ref e-101 3))) (let ((e-107 (vector-ref e-101 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45CoreC-45PiInfo-traverse (lambda (clam-0) (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 clam-0 eta-2))) e-106) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-5 e-107 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-5 arg-6 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-4 arg-5 (vector 3 e-99 e-100 (vector 0 e-104 e-105 e-6 e-7) (vector 4 e-99 (let ((sc6 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc6))) (((e-1 'erased) 'erased) e-8))) (vector 0 e-99 '() 0)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-7))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (let ((e-61 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-19 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Convert-n--13179-12245-u--getInfPos arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 e-19) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-2)))) eff-0) eta-1))))))) (else (CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-18 arg-2 arg-3 arg-4 arg-5 e-19 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0) e-60 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-46) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-47) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((2) (let ((e-24 (vector-ref arg-6 3))) (let ((e-26 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-65 (vector-ref arg-7 3))) (let ((e-67 (vector-ref arg-7 5))) (lambda (clam-48) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-24 e-65))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-67) clam-48)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-49) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-50) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((3) (let ((e-29 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-70 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 5))) (lambda (clam-51) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-29 e-70))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-32) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-73) clam-51)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-52) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-53) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((4) (let ((e-37 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-78 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-37 e-78)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-54) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-55) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((5) (let ((e-40 (vector-ref arg-6 2))) (let ((e-41 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-81 (vector-ref arg-7 2))) (let ((e-82 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45TTC-45Term-compatible e-40 e-81))) (cond ((equal? sc3 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-41 e-82)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-56) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-57) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((6) (let ((e-44 (vector-ref arg-6 2))) (let ((e-46 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-85 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 4))) (lambda (clam-55) (let ((sc3 (CoreC-45TTC-45Term-compatible e-44 e-85))) (cond ((equal? sc3 1) (let ((act-1 (cond ((equal? e-44 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-55))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-46 e-87 eta-0)))) eff-0) clam-55)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-58) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-59) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((7) (let ((e-49 (vector-ref arg-6 2))) (let ((e-50 (vector-ref arg-6 3))) (let ((e-51 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-90 (vector-ref arg-7 2))) (let ((e-91 (vector-ref arg-7 3))) (let ((e-92 (vector-ref arg-7 4))) (lambda (clam-58) (let ((sc3 (CoreC-45TTC-45Term-compatible e-49 e-90))) (cond ((equal? sc3 1) (let ((act-1 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-50 e-91) clam-58))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-60) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-51) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-92) clam-60)) (else (vector 1 0)))))) eff-0) clam-58)))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-61) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-62) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((8) (let ((e-54 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-95 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-54 e-95)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-63) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-64) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((9) (let ((e-57 (vector-ref arg-6 2))) (case (vector-ref e-57 0) ((2) (let ((e-97 (vector-ref e-57 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-97 arg-7)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-65) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-66) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-67) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-68) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((1) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (let ((e-61 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Convert-chkConvHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-19 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Convert-n--13179-12245-u--getInfPos arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 e-19) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) (CoreC-45NormaliseC-45Convert-n--13179-12244-u--dropInf arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0 0 e-6 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)) eta-2)))) eff-0) eta-1))))))) (else (CoreC-45NormaliseC-45Convert-chkConvCaseBlock arg-0 arg-1 e-18 arg-2 arg-3 arg-4 arg-5 e-19 (CoreC-45NormaliseC-45Convert-n--13179-12242-u--args1 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0) e-60 (CoreC-45NormaliseC-45Convert-n--13179-12243-u--args2 arg-1 e-59 e-20 e-19 e-18 e-61 e-60 arg-5 arg-4 arg-3 arg-2 arg-0)))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-69) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-70) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((2) (let ((e-24 (vector-ref arg-6 3))) (let ((e-26 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-65 (vector-ref arg-7 3))) (let ((e-67 (vector-ref arg-7 5))) (lambda (clam-71) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-24 e-65))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-67) clam-71)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-72) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-73) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((3) (let ((e-29 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-70 (vector-ref arg-7 2))) (let ((e-73 (vector-ref arg-7 5))) (lambda (clam-74) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-29 e-70))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-32) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-73) clam-74)) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-75) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-76) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((4) (let ((e-37 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((4) (let ((e-78 (vector-ref arg-7 4))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-37 e-78)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-77) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-78) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((5) (let ((e-40 (vector-ref arg-6 2))) (let ((e-41 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-81 (vector-ref arg-7 2))) (let ((e-82 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45TTC-45Term-compatible e-40 e-81))) (cond ((equal? sc2 1) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-41 e-82)) (else (lambda (eta-0) (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-79) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-80) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((6) (let ((e-44 (vector-ref arg-6 2))) (let ((e-46 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-85 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 4))) (lambda (clam-77) (let ((sc2 (CoreC-45TTC-45Term-compatible e-44 e-85))) (cond ((equal? sc2 1) (let ((act-1 (cond ((equal? e-44 1) (vector 1 arg-4))(else (CoreC-45Context-clearDefs arg-4 clam-77))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 arg-2 arg-3 e-5 arg-5 e-46 e-87 eta-0)))) eff-0) clam-77)))))) (else (vector 1 0))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-81) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-82) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))) ((7) (let ((e-49 (vector-ref arg-6 2))) (let ((e-50 (vector-ref arg-6 3))) (let ((e-51 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-90 (vector-ref arg-7 2))) (let ((e-91 (vector-ref arg-7 3))) (let ((e-92 (vector-ref arg-7 4))) (lambda (clam-80) (let ((sc2 (CoreC-45TTC-45Term-compatible e-49 e-90))) (cond ((equal? sc2 1) (let ((act-1 ((CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-50 e-91) clam-80))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-83) (cond ((equal? e-5 1) (CoreC-45NormaliseC-45Convert-allConv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-51) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-92) clam-83)) (else (vector 1 0)))))) eff-0) clam-80)))))) (else (vector 1 0)))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-84) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-85) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))))) ((8) (let ((e-54 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((8) (let ((e-95 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-54 e-95)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-86) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-87) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0)))))))))))))) ((9) (let ((e-57 (vector-ref arg-6 2))) (case (vector-ref e-57 0) ((2) (let ((e-97 (vector-ref e-57 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-97 arg-7)))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-88) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-89) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-14 (vector-ref arg-7 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16)))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-90) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))(else (case (vector-ref arg-6 0) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-7 0) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-91) (case (vector-ref arg-6 0) ((10) (case (vector-ref arg-7 0) ((10) (vector 1 1))(else (vector 1 0))))(else (vector 1 0))))))))))))))))))
(define CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-4 arg-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convert_Convert_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Convert-u--convGen_Convert_Closure arg-0 arg-1 e-5 0 arg-2 arg-3 arg-4 arg-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32unifyD-27385 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (case (vector-ref e-2 0) ((1) (let ((e-14 (vector-ref e-2 2))) (case (vector-ref e-14 0) ((2) (case (vector-ref e-3 0) ((1) (let ((e-22 (vector-ref e-3 2))) (case (vector-ref e-22 0) ((2) ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12))(else (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-11 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-5 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-6) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-7) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-8) e-9))) eff-0) eta-4)))))))) eff-0) eta-3))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-0 (vector-ref e-8 0))) (if (null? e-0) (vector 1 e-8) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-8 arg-3) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) e-10))) eff-0) clam-0)))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-11 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-5 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-6) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-7) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-8) e-9))) eff-0) eta-4)))))))) eff-0) eta-3))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-0 (vector-ref e-8 0))) (if (null? e-0) (vector 1 e-8) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-8 arg-3) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) e-10))) eff-0) clam-1)))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))(else (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 2))) (case (vector-ref e-6 0) ((2) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-8 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-12 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-16) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-12) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-17) e-18))) eff-0) eta-4)))))))) eff-0) eta-3))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (let ((e-0 (vector-ref e-17 0))) (if (null? e-0) (lambda (eta-4) (vector 1 e-17)) ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12)))))(else ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12)))))))(else (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 2))) (case (vector-ref e-6 0) ((2) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-9 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 e-8 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 arg-9 arg-5 arg-12 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-13) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-9 arg-5 e-12) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) e-14) e-15))) eff-0) eta-4)))))))) eff-0) eta-3))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (let ((e-0 (vector-ref e-14 0))) (if (null? e-0) (lambda (eta-4) (vector 1 e-14)) ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12)))))(else ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-7 arg-6) arg-5) arg-11) arg-12))))))))))
(define CoreC-45Unify-u--unifyD_Unify_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Closure arg-1 arg-0 e-6 arg-5 arg-6 arg-7 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-7 1) (vector 1 CoreC-45Unify-success)) (else (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-6) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-7) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Unify-case--caseC-32blockC-32inC-32unifyD-27385 arg-0 arg-1 arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 e-5 e-6 0 e-8 e-9 (cons e-8 e-9)))) eff-0) eta-2)))))))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-u--unifyWithLazyD_Unify_Closure (lambda (arg-0 ext-7 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-0) (CoreC-45Unify-u--unifyD_Unify_Closure arg-0 ext-7 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-0)))
(define csegen-2502 (lambda () (cons (lambda (u--vars) (lambda (arg-13788) (lambda (arg-13793) (lambda (arg-13798) (lambda (arg-13801) (lambda (arg-13804) (lambda (arg-13808) (lambda (arg-13814) (lambda (eta-0) (CoreC-45Unify-u--unifyD_Unify_Closure u--vars arg-13788 arg-13793 arg-13798 arg-13801 arg-13804 arg-13808 arg-13814 eta-0)))))))))) (lambda (u--vars) (lambda (arg-13830) (lambda (arg-13835) (lambda (arg-13840) (lambda (arg-13843) (lambda (arg-13846) (lambda (arg-13850) (lambda (arg-13853) (lambda (eta-0) (CoreC-45Unify-u--unifyWithLazyD_Unify_Closure u--vars arg-13830 arg-13835 arg-13840 arg-13843 arg-13846 arg-13850 arg-13853 eta-0)))))))))))))
(define CoreC-45Unify-unifyBothBinders (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-8 0) ((2) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (lambda (clam-0) (case (vector-ref arg-12 0) ((2) (let ((e-11 (vector-ref arg-12 1))) (let ((e-12 (vector-ref arg-12 2))) (let ((e-13 (vector-ref arg-12 3))) (let ((e-14 (vector-ref arg-12 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-2 e-12))) (cond ((equal? sc3 1) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 (vector 2 e-1 e-2 e-3 e-4) arg-9) (vector 0 arg-10 arg-11 (vector 2 e-11 e-12 e-13 e-14) arg-13) clam-1)) (else (let ((act-2 (CoreC-45Context-clearDefs e-5 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-6 arg-5 e-4 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.binder" 10 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-6 arg-5 e-14 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (string-append "Unifying arg types " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-7) (string-append " and " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-8)))))))) eff-0) eta-2)))))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((act-5 (((((CoreC-45Unify-unify (csegen-2502) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-4) e-14) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (CoreC-45UnifyState-genVarName arg-0 arg-1 "x" eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--envC-39 (cons (vector 2 e-11 e-12 (vector 1 ) e-7) arg-5))) (lambda (eta-3) (CoreC-45Unify-case--caseC-32blockC-32inC-32unifyBothBinders-24407 arg-2 e-4 e-3 e-2 e-1 e-14 e-13 e-12 e-11 arg-13 arg-11 arg-10 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-5 e-6 e-7 e-9 e-10 u--envC-39 (let ((e-0 (vector-ref e-9 0))) e-0) eta-3))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))) eff-0) clam-0))))))))))(else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 arg-8 arg-9) (vector 0 arg-10 arg-11 arg-12 arg-13) clam-0))))))))) ((0) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((e-9 (vector-ref arg-8 4))) (lambda (clam-2) (case (vector-ref arg-12 0) ((0) (let ((e-16 (vector-ref arg-12 1))) (let ((e-17 (vector-ref arg-12 2))) (let ((e-18 (vector-ref arg-12 3))) (let ((e-19 (vector-ref arg-12 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-7 e-17))) (cond ((equal? sc3 1) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 (vector 0 e-6 e-7 e-8 e-9) arg-9) (vector 0 arg-10 arg-11 (vector 0 e-16 e-17 e-18 e-19) arg-13) clam-3)) (else (let ((act-2 (CoreC-45Context-clearDefs e-5 clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (((((CoreC-45Unify-unify (csegen-2502) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-9) e-19) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45UnifyState-genVarName arg-0 arg-1 "x" eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-10 arg-5 e-9 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--envC-39 (cons (vector 0 e-6 e-7 (vector 1 ) e-13) arg-5))) (lambda (eta-3) (let ((act-6 (((arg-9 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-5 (vector 1 arg-4 (vector 0 ) e-12))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (((arg-13 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-5 (vector 1 arg-4 (vector 0 ) e-12))) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-10 arg-5 e-14 eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-10 arg-5 e-15 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (((((CoreC-45Unify-unify (csegen-2476) (cons arg-7 arg-2) arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) u--envC-39) (CoreC-45TT-refsToLocals (vector 1 arg-7 e-12 (vector 0 )) e-20)) (CoreC-45TT-refsToLocals (vector 1 arg-7 e-12 (vector 0 )) e-21)) eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (CoreC-45Unify-union e-11 e-22))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))))))) eff-0) clam-2))))))))))(else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 arg-8 arg-9) (vector 0 arg-10 arg-11 arg-12 arg-13) clam-2)))))))))(else (lambda (eta-0) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 0 arg-6 arg-7 arg-8 arg-9) (vector 0 arg-10 arg-11 arg-12 arg-13) eta-0))))))
(define CoreC-45Unify-dumpArg (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-logTerm (PreludeC-45TypesC-45List-tailRecAppend e-1 arg-0) arg-1 "unify" 20 (lambda () "Term: ") e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-7 (vector 0 e-1 e-2 e-3 e-4 e-5)) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 20 (lambda () "  ") arg-2 e-9 eta-2)))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-6 arg-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 20 (lambda () "  ") arg-2 e-7 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Unify-convertErrorS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (cond ((equal? arg-3 1) (CoreC-45Unify-convertError arg-1 arg-2 arg-4 arg-5 arg-7 arg-6 clam-0)) (else (CoreC-45Unify-convertError arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 clam-0))))))
(define CoreC-45UnifyState-addConstraint (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cid (let ((e-9 (vector-ref e-5 9))) e-9))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 (LibrariesC-45DataC-45IntMap-insert u--cid arg-2 e-4) e-12 e-6 e-7 e-8 (bs+ u--cid 1 63) e-10 e-11))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 u--cid)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-constrain (lambda (arg-0) (vector (cons arg-0 '()) 0 '() (vector 0 ))))
(define DataC-45Nat-lte (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 1)(else (cond ((equal? arg-1 0) 0)(else (cond ((equal? arg-0 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-0 (- arg-0 1))) (cond ((equal? arg-1 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-1 (- arg-1 1))) (DataC-45Nat-lte e-0 e-1)))))))))))))
(define DataC-45Nat-divC-39 (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-0 0) 0)(else (let ((e-0 (- arg-0 1))) (let ((sc0 (DataC-45Nat-lte arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else (+ (DataC-45Nat-divC-39 e-0 (PreludeC-45Types-prim__integerToNat (- arg-1 (+ arg-2 1))) arg-2) 1)))))))))
(define DataC-45Nat-divNatNZ (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-0 (- arg-1 1))) (DataC-45Nat-divC-39 arg-0 arg-0 e-0))))))
(define DataC-45Nat-divNat (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Data.Nat.divNat at Data.Nat:376:1--376:59")))(else (let ((e-0 (- arg-1 1))) (DataC-45Nat-divNatNZ arg-0 (+ e-0 1)))))))
(define LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop (lambda (arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-4 (vector-ref arg-4 1))) ((((e-4 'erased) 'erased) (arg-5 e-1)) (lambda (_-0) (if (null? _-0) (let ((e-8 (vector-ref arg-4 0))) (let ((e-10 (vector-ref e-8 1))) ((e-10 'erased) arg-7))) (let ((e-6 (unbox _-0))) (let ((e-9 (vector-ref arg-4 0))) (let ((e-11 (vector-ref e-9 1))) ((e-11 'erased) (LibrariesC-45DataC-45NameMap-insert e-1 e-6 arg-7))))))))))) ((1) (let ((e-5 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop arg-4 arg-5 arg-7 e-5)) (lambda (u--acc) (LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop arg-4 arg-5 u--acc e-7))))))) (else (let ((e-10 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 5))) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop arg-4 arg-5 arg-7 e-10)) (lambda (u--acc) (let ((e-5 (vector-ref arg-4 1))) ((((e-5 'erased) 'erased) (LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop arg-4 arg-5 u--acc e-12)) (lambda (acc-0) (LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop arg-4 arg-5 acc-0 e-14))))))))))))))
(define LibrariesC-45DataC-45NameMap-treeMapMaybeM (lambda (arg-4 arg-5 ext-0) (LibrariesC-45DataC-45NameMap-n--7070-13060-u--loop arg-4 arg-5 LibrariesC-45DataC-45NameMap-empty ext-0)))
(define LibrariesC-45DataC-45NameMap-mapMaybeM (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) '()))) (let ((e-3 (cdr arg-5))) (LibrariesC-45DataC-45NameMap-treeMapMaybeM arg-3 arg-4 e-3)))))
(define PreludeC-45Interfaces-C-42C-62 (lambda (arg-3 arg-4 arg-5) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (((let ((eff-0 (let ((e-6 (vector-ref arg-3 0))) e-6))) (lambda (arg-0) (lambda (arg-1) ((((eff-0 'erased) 'erased) arg-0) arg-1)))) (lambda (eta-0) (lambda (eta-1) eta-1))) arg-4)) arg-5))))
(define PreludeC-45Interfaces-traverse_ (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-1 (vector-ref arg-5 0))) (((((e-1 'erased) 'erased) (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-C-42C-62 arg-4 (arg-6 eta-0) eta-1)))) (let ((e-8 (vector-ref arg-4 1))) ((e-8 'erased) (vector 0 )))) ext-0))))
(define PreludeC-45Interfaces-for_ (lambda (arg-4 arg-5 ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-traverse_ arg-4 arg-5 eta-0 eta-1))) ext-0 ext-1)))
(define Builtin-idris_crash (lambda (ext-0) (blodwen-error-quit (string-append "ERROR: " ext-0))))
(define LibrariesC-45DataC-45ListC-45Extra-minimum (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (let ((e-8 (vector-ref arg-1 7))) ((e-8 eta-0) eta-1)))) e-1 e-2)))))
(define LibrariesC-45DataC-45IOMatrix-new (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (make-vector (bs* arg-3 arg-4 63) '()))))) (lambda (bind-0) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector arg-3 arg-4 bind-0)))))))))))
(define LibrariesC-45DataC-45IOMatrix-toPosition (lambda (arg-1 arg-2 arg-3) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-2 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-3 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-2 e-1))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-3 e-2)))))))))))) (cond ((equal? sc0 1) 0) (else 1)))) (lambda (_-10649) (box (bs+ (bs* arg-2 e-2 63) arg-3 63))))))))
(define LibrariesC-45DataC-45IOMatrix-read (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (LibrariesC-45DataC-45IOMatrix-toPosition arg-3 arg-4 arg-5))) (if (null? sc0) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '())))) (let ((e-2 (unbox sc0))) (let ((e-3 (cdr arg-2))) ((e-3 'erased) (lambda (eta-0) (vector-ref (let ((e-4 (vector-ref arg-3 2))) e-4) e-2)))))))))
(define LibrariesC-45DataC-45IOMatrix-write (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (LibrariesC-45DataC-45IOMatrix-toPosition arg-3 arg-4 arg-5))) (if (null? sc0) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) 0)))) (let ((e-2 (unbox sc0))) (let ((e-1 (car arg-2))) (let ((e-6 (vector-ref e-1 0))) (let ((e-9 (vector-ref e-6 0))) ((((e-9 'erased) 'erased) (lambda (eta-0) 1)) (let ((e-10 (cdr arg-2))) ((e-10 'erased) (lambda (eta-0) (vector-set! (let ((e-12 (vector-ref arg-3 2))) e-12) e-2 (box arg-6))))))))))))))
(define PreludeC-45Types-countFrom (lambda (arg-1 arg-2) (cons arg-1 (lambda () (PreludeC-45Types-countFrom (arg-2 arg-1) arg-2)))))
(define PreludeC-45Types-takeUntil (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((sc1 (arg-1 e-1))) (cond ((equal? sc1 1) (cons e-1 '())) (else (cons e-1 (PreludeC-45Types-takeUntil arg-1 (e-2))))))))))
(define PreludeC-45Types-u--rangeFromTo_Range_C-36a (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((sc1 (Builtin-fst (Builtin-snd arg-1)))) (let ((e-2 (vector-ref sc1 1))) ((e-2 arg-2) arg-3))))) (cond ((equal? sc0 0) (PreludeC-45Types-takeUntil (lambda (arg-0) (let ((sc1 (Builtin-fst (Builtin-snd arg-1)))) (let ((e-6 (vector-ref sc1 5))) ((e-6 arg-0) arg-3)))) (PreludeC-45Types-countFrom arg-2 (lambda (arg-0) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-1 (vector-ref sc1 0))) (let ((e-6 (vector-ref e-1 0))) ((e-6 arg-0) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-9 (vector-ref sc1 0))) (let ((e-10 (vector-ref e-9 2))) (e-10 1)))))))))))) ((equal? sc0 1) (PreludeC-45Types-u--pure_Applicative_List arg-2)) (else (PreludeC-45Types-takeUntil (lambda (arg-0) (let ((sc1 (Builtin-fst (Builtin-snd arg-1)))) (let ((e-5 (vector-ref sc1 4))) ((e-5 arg-0) arg-3)))) (PreludeC-45Types-countFrom arg-2 (lambda (u--x) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-3 (vector-ref sc1 2))) ((e-3 u--x) (let ((sc1 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-6 (vector-ref sc1 0))) (let ((e-7 (vector-ref e-6 2))) (e-7 1)))))))))))))))
(define LibrariesC-45TextC-45DistanceC-45Levenshtein-compute (lambda (arg-1 arg-2 arg-3) (let ((u--w (string-length arg-2))) (let ((u--h (string-length arg-3))) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45IOMatrix-new arg-1 (bs+ u--w 1 63) (bs+ u--h 1 63))) (lambda (u--mat) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (PreludeC-45Interfaces-for_ (let ((e-12 (car arg-1))) (let ((e-15 (vector-ref e-12 0))) e-15)) csegen-14 (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 0 u--w) (lambda (u--i) (LibrariesC-45DataC-45IOMatrix-write arg-1 u--mat u--i 0 u--i)))) (lambda (_-10649) (let ((e-12 (car arg-1))) (let ((e-14 (vector-ref e-12 1))) ((((e-14 'erased) 'erased) (PreludeC-45Interfaces-for_ (let ((e-17 (car arg-1))) (let ((e-20 (vector-ref e-17 0))) e-20)) csegen-14 (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 0 u--h) (lambda (u--j) (LibrariesC-45DataC-45IOMatrix-write arg-1 u--mat 0 u--j u--j)))) (lambda (_-10650) ((let ((u--get (lambda (u--i) (lambda (u--j) (let ((e-17 (car arg-1))) (let ((e-19 (vector-ref e-17 1))) ((((e-19 'erased) 'erased) (LibrariesC-45DataC-45IOMatrix-read arg-1 u--mat u--i u--j)) (lambda (bind-0) (if (null? bind-0) (Builtin-idris_crash "INTERNAL ERROR: Badly initialised matrix") (let ((e-21 (unbox bind-0))) (let ((e-23 (car arg-1))) (let ((e-26 (vector-ref e-23 0))) (let ((e-28 (vector-ref e-26 1))) ((e-28 'erased) e-21)))))))))))))) (lambda () (let ((e-17 (car arg-1))) (let ((e-19 (vector-ref e-17 1))) ((((e-19 'erased) 'erased) (PreludeC-45Interfaces-for_ (let ((e-22 (car arg-1))) (let ((e-25 (vector-ref e-22 0))) e-25)) csegen-14 (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 1 u--h) (lambda (u--j) (PreludeC-45Interfaces-for_ (let ((e-22 (car arg-1))) (let ((e-25 (vector-ref e-22 0))) e-25)) csegen-14 (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 1 u--w) (lambda (u--i) (let ((u--cost (let ((u--c (string-ref arg-2 (bs- u--i 1 63)))) (let ((u--d (string-ref arg-3 (bs- u--j 1 63)))) (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c u--d))) (cond ((equal? sc4 1) (blodwen-toSignedInt 0 63)) (else (let ((sc5 (let ((sc6 (PreludeC-45Types-isAlpha u--c))) (cond ((equal? sc6 1) (PreludeC-45Types-isAlpha u--d)) (else 0))))) (cond ((equal? sc5 1) (blodwen-toSignedInt 1 63)) (else (let ((sc6 (let ((sc7 (PreludeC-45Types-isDigit u--c))) (cond ((equal? sc7 1) (PreludeC-45Types-isDigit u--d)) (else 0))))) (cond ((equal? sc6 1) (blodwen-toSignedInt 1 63)) (else (blodwen-toSignedInt 2 63)))))))))))))) (let ((e-22 (car arg-1))) (let ((e-24 (vector-ref e-22 1))) ((((e-24 'erased) 'erased) ((u--get u--i) (bs- u--j 1 63))) (lambda (bind-0) (let ((e-27 (car arg-1))) (let ((e-29 (vector-ref e-27 1))) ((((e-29 'erased) 'erased) ((u--get (bs- u--i 1 63)) u--j)) (lambda (bind-1) (let ((e-32 (car arg-1))) (let ((e-34 (vector-ref e-32 1))) ((((e-34 'erased) 'erased) ((u--get (bs- u--i 1 63)) (bs- u--j 1 63))) (lambda (bind-2) (LibrariesC-45DataC-45IOMatrix-write arg-1 u--mat u--i u--j (LibrariesC-45DataC-45ListC-45Extra-minimum csegen-231 (cons (bs+ (blodwen-toSignedInt 1 63) bind-0 63) (cons (bs+ (blodwen-toSignedInt 1 63) bind-1 63) (cons (bs+ u--cost bind-2 63) '()))))))))))))))))))))))) (lambda (_-10651) (let ((e-22 (car arg-1))) (let ((e-25 (vector-ref e-22 0))) (let ((e-28 (vector-ref e-25 0))) ((((e-28 'erased) 'erased) csegen-1333) ((u--get u--w) u--h))))))))))))))))))))))))))))
(define CoreC-45Context-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32getSimilarNames-16982 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 '()) (let ((e-1 (unbox arg-6))) (let ((act-1 (let ((act-1 ((LibrariesC-45TextC-45DistanceC-45Levenshtein-compute csegen-82 arg-2 e-1) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (PreludeC-45Types-u--C-60C-61_Ord_Nat e-5 arg-4))) (cond ((equal? sc2 1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-3 0))) e-0)) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-6) (vector 1 '()) (let ((e-2 (unbox e-6))) (vector 1 (box (cons (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-2 9))) e-9)) e-5)))))))) eff-0) clam-1)))))) (else (vector 1 '()))))))) eff-0) ext-0)))))))))
(define CoreC-45Context-case--getSimilarNames-16891 (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (let ((sc1 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length e-2) 1))) (cond ((equal? sc1 1) (vector 1 (box (cons e-2 '())))) (else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--threshold (PreludeC-45Types-u--max_Ord_Nat 1 (DataC-45Nat-divNat (PreludeC-45TypesC-45String-length e-2) 3)))) (let ((u--test (lambda (u--nm) (lambda (eta-0) (CoreC-45Context-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32getSimilarNames-16982 arg-0 arg-1 e-2 e-5 u--threshold u--nm (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (CoreC-45Name-u--show_Show_UserName eta-1)) (CoreC-45Name-userNameRoot u--nm)) eta-0))))) (lambda (eta-0) (let ((act-2 ((LibrariesC-45DataC-45NameMap-mapMaybeM csegen-1005 u--test (let ((e-0 (vector-ref e-5 0))) (let ((e-44 (vector-ref e-0 2))) e-44))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons e-2 (LibrariesC-45DataC-45NameMap-toList e-6))))))) eff-0) eta-0)))))))))) eff-0) clam-0)))))))))))))
(define CoreC-45Context-getSimilarNames (lambda (arg-0 arg-1) (CoreC-45Context-case--getSimilarNames-16891 arg-1 arg-0 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45Name-u--show_Show_UserName eta-0)) (CoreC-45Name-userNameRoot arg-1)))))
(define DataC-45List-nub (lambda (arg-1 ext-0) (DataC-45List-nubBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0)))
(define DataC-45Either-lefts (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (cons e-6 (DataC-45Either-lefts e-3)))) (else (DataC-45Either-lefts e-3))))))))
(define DataC-45Either-rights (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (DataC-45Either-rights e-3)) (else (let ((e-9 (vector-ref e-2 1))) (cons e-9 (DataC-45Either-rights e-3))))))))))
(define DataC-45Either-partitionEithers (lambda (arg-2) (cons (DataC-45Either-lefts arg-2) (DataC-45Either-rights arg-2))))
(define DataC-45List-mergeBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (if (null? arg-3) arg-2 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc4 ((arg-1 e-1) e-4))) (cond ((equal? sc4 0) (cons e-1 (DataC-45List-mergeBy arg-1 e-2 (cons e-4 e-5))))(else (cons e-4 (DataC-45List-mergeBy arg-1 (cons e-1 e-2) e-5)))))))))))))
(define DataC-45List-n--7826-8306-u--splitRec (lambda (arg-1 arg-2 arg-4 arg-5 arg-6) (if (null? arg-4) (cons arg-5 (arg-6 '())) (let ((e-2 (cdr arg-4))) (if (null? e-2) (cons arg-5 (arg-6 '())) (let ((e-5 (cdr e-2))) (if (null? arg-5) (cons arg-5 (arg-6 '())) (let ((e-7 (car arg-5))) (let ((e-8 (cdr arg-5))) (DataC-45List-n--7826-8306-u--splitRec arg-1 arg-2 e-5 e-8 (lambda (eta-0) (arg-6 (cons e-7 eta-0)))))))))))))
(define DataC-45List-n--7826-8305-u--split (lambda (arg-1 arg-2 arg-3) (DataC-45List-n--7826-8306-u--splitRec arg-1 arg-2 arg-3 arg-3 (lambda (eta-0) eta-0))))
(define DataC-45List-sortBy (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (cons e-2 '()) (let ((sc2 (DataC-45List-n--7826-8305-u--split arg-2 arg-1 arg-2))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (DataC-45List-mergeBy arg-1 (DataC-45List-sortBy arg-1 e-5) (DataC-45List-sortBy arg-1 e-4)))))))))))
(define CoreC-45NameC-45Namespace-C-60C-46C-62 (lambda (arg-0 arg-1) (PreludeC-45TypesC-45List-tailRecAppend arg-1 arg-0)))
(define CoreC-45NameC-45Namespace-emptyNS (CoreC-45NameC-45Namespace-mkNamespace ""))
(define CoreC-45Name-splitNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((sc1 (CoreC-45Name-splitNS e-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 e-2) e-3)))))))(else (cons CoreC-45NameC-45Namespace-emptyNS arg-0)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultPageWidth (cons 80 1.0))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultLayoutOptions LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultPageWidth)
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (lambda (arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) 0) (else (case (vector-ref arg-2 0) ((0) 1) ((1) (let ((e-3 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (bs- arg-1 1 63) (e-3)))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (bs- arg-1 e-5 63) (e-7))))) ((3) 1) ((4) (let ((e-13 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits arg-1 e-13))) (else (let ((e-15 (vector-ref arg-2 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits arg-1 e-15)))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13415-u--initialIndentation (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (box e-1))) ((4) (let ((e-5 (vector-ref arg-4 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13415-u--initialIndentation arg-1 arg-2 arg-3 e-5))) ((5) (let ((e-7 (vector-ref arg-4 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13415-u--initialIndentation arg-1 arg-2 arg-3 e-7)))(else '()))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13416-u--selectNicer (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 ((((arg-3 arg-4) arg-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13415-u--initialIndentation arg-1 arg-2 arg-3 (arg-7))) arg-6))) (cond ((equal? sc0 1) arg-6) (else (arg-7))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (vector 0 )) ((2) (let ((e-2 (vector-ref arg-6 1))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))) (else (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((e-6 (vector-ref arg-6 3))) (case (vector-ref e-5 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 e-6)) ((1) (let ((e-9 (vector-ref e-5 1))) (vector 1 e-9 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 (bs+ arg-5 1 63) e-6))))) ((2) (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (vector 2 e-11 e-12 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 (bs+ arg-5 e-11 63) e-6)))))) ((3) (let ((u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 e-4 e-4 e-6))) (let ((u--iC-39 (case (vector-ref u--x 0) ((0) (blodwen-toSignedInt 0 63)) ((3) (blodwen-toSignedInt 0 63))(else e-4)))) (vector 3 u--iC-39 u--x)))) ((4) (let ((e-15 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-15) e-6)))) ((5) (let ((e-18 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 e-18 (vector 1 e-4 e-19 e-6)))))) ((6) (let ((e-21 (vector-ref e-5 1))) (let ((e-22 (vector-ref e-5 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 (bs+ e-4 e-21 63) e-22 e-6))))) ((7) (let ((e-24 (vector-ref e-5 1))) (let ((e-25 (vector-ref e-5 2))) (let ((u--xC-39 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-24) e-6)))) (let ((u--yC-39 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-25) e-6)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13416-u--selectNicer arg-1 arg-2 arg-3 arg-4 arg-5 u--xC-39 (lambda () u--yC-39))))))) ((8) (let ((e-27 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-27 arg-5) e-6)))) ((9) (let ((e-29 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-29 arg-2) e-6)))) ((10) (let ((e-31 (vector-ref e-5 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 (e-31 e-4) e-6)))) (else (let ((e-33 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (vector 4 e-33 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-1 arg-2 arg-3 arg-4 arg-5 (vector 1 e-4 e-34 (vector 2 e-6)))))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutWadlerLeijen (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--8056-13414-u--best arg-3 arg-2 arg-1 0 0 (vector 1 0 arg-3 (vector 0 )))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutWadlerLeijen (lambda (_-13713) (lambda (_-13716) (lambda (_-13719) (lambda (u--sdoc) 1)))) '() ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-round (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Double arg-0 (exact->inexact 0)))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Double (- arg-0 (flfloor arg-0)) 0.5))) (cond ((equal? sc1 1) (exact-truncate-boundedInt (flfloor arg-0) 63)) (else (exact-truncate-boundedInt (flceiling arg-0) 63))))) (else (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Double (- (flceiling arg-0) arg-0) 0.5))) (cond ((equal? sc1 1) (exact-truncate-boundedInt (flceiling arg-0) 63)) (else (exact-truncate-boundedInt (flfloor arg-0) 63)))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-remainingWidth (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--columnsLeftInLine (bs- arg-0 arg-3 63))) (let ((u--ribbonWidth (PreludeC-45EqOrd-u--max_Ord_Int (blodwen-toSignedInt 0 63) (PreludeC-45EqOrd-u--min_Ord_Int arg-0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-round (* (exact->inexact arg-0) arg-1)))))) (let ((u--columnsLeftInRibbon (bs- (bs+ arg-2 u--ribbonWidth 63) arg-3 63))) (PreludeC-45EqOrd-u--min_Ord_Int u--columnsLeftInLine u--columnsLeftInRibbon))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty (lambda (arg-1 ext-0) (if (null? arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded ext-0) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutWadlerLeijen (lambda (u--lineIndent) (lambda (u--currentColumn) (lambda (_-13839) (lambda (u--sdoc) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fits (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-remainingWidth e-1 e-2 u--lineIndent u--currentColumn) u--sdoc))))) arg-1 ext-0))))))
(define DataC-45List-replicateTR (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) arg-1)(else (let ((e-0 (- arg-2 1))) (DataC-45List-replicateTR (cons arg-3 arg-1) e-0 arg-3))))))
(define DataC-45String-replicate (lambda (arg-0 arg-1) (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-0 arg-1))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textReplicateChar (lambda (arg-0 ext-0) (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat arg-0) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textReplicateChar arg-0 #\ )))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) eta-0)) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (lambda (eta-0) (string-cons e-2 ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (e-3)) eta-0)))))) ((2) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (lambda (eta-0) (string-append e-6 ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (e-7)) eta-0)))))) ((3) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (lambda (eta-0) (string-append (string-cons (integer->char 10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-9)) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow e-10) eta-0)))))) ((4) (let ((e-13 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow e-13))) (else (let ((e-15 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow e-15))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (lambda (arg-1) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-renderShow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-defaultLayoutOptions arg-1)) "")))
(define CoreC-45Context-n--21457-17175-u--showNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((u--adj (cond ((equal? arg-6 1) " (not exported)") (else "")))) (let ((u--root (CoreC-45Name-nameRoot arg-7))) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-5 u--root))) (cond ((equal? sc0 1) (let ((u--full (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (CoreC-45Name-u--pretty_Pretty_Void_Name arg-7)))) (let ((sc1 (let ((sc2 (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-5 u--full))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45Name-u--show_Show_Name arg-4) u--full)))))) (cond ((equal? sc2 1) (cond ((equal? arg-6 1) 0) (else 1))) (else 0))))) (cond ((equal? sc1 1) '())(else (box (string-append u--full u--adj)))))))(else (box (string-append u--root u--adj)))))))))
(define CoreC-45Context-showSimilarNames (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (DataC-45Either-partitionEithers (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc3 (CoreC-45NameC-45Namespace-isParentOf (Builtin-fst (CoreC-45Name-splitNS e-2)) arg-0))) (cond ((equal? sc3 0) (cond ((equal? e-6 0) (vector 1 (cons e-2 e-7)))(else (vector 0 (cons e-2 e-7)))))(else (vector 0 (cons e-2 e-7)))))))))) arg-3)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((u--sorted (lambda (eta-0) (DataC-45List-sortBy (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-on (lambda (eta-3) (lambda (eta-4) (PreludeC-45EqOrd-u--compare_Ord_Integer eta-3 eta-4))) (lambda (eta-3) (Builtin-snd eta-3)) eta-1 eta-2))) eta-0)))) (let ((u--roots1 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CoreC-45Context-n--21457-17175-u--showNames arg-3 arg-2 arg-1 arg-0 arg-1 arg-2 0 (Builtin-fst eta-0))) (u--sorted e-2)))) (let ((u--roots2 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CoreC-45Context-n--21457-17175-u--showNames arg-3 arg-2 arg-1 arg-0 arg-1 arg-2 1 (Builtin-fst eta-0))) (u--sorted e-3)))) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-nub csegen-22 u--roots1) (DataC-45List-nub csegen-22 u--roots2))))))))))
(define CoreC-45Context-maybeMisspelling (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-getSimilarNames arg-1 arg-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((u--candidates (CoreC-45Context-showSimilarNames e-5 arg-3 e-8 e-7))) (lambda (clam-0) (if (null? u--candidates) (CoreC-45Core-u--throw_Catchable_Core_Error arg-2 clam-0) (let ((e-2 (car u--candidates))) (let ((e-3 (cdr u--candidates))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 72 arg-2 (cons e-2 e-3)) clam-0)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-undefinedName (lambda (arg-1 arg-2 arg-3 ext-0) (CoreC-45Context-maybeMisspelling arg-1 (vector 7 arg-2 arg-3) arg-3 ext-0)))
(define CoreC-45Unify-n--9724-14582-u--checkDefined (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (case (vector-ref arg-10 0) ((1) (let ((e-2 (vector-ref arg-10 2))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-6 (let ((e-0 (vector-ref arg-9 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (CoreC-45Context-undefinedName arg-8 arg-6 e-6 clam-1) (vector 1 (vector 0 )))))) eff-0) clam-0)))))))(else (vector 1 (vector 0 ))))))(else (vector 1 (vector 0 )))))))
(define CoreC-45Unify-postpone (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "unify.postpone" 10 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-6 arg-7 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-6 arg-8 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-68 e-7 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45Context-toFullNames arg-1 csegen-68 e-8 eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (string-append arg-5 (string-append ": " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9) (string-append " =?= " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-10))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Unify-n--9724-14582-u--checkDefined arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 arg-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45Unify-n--9724-14582-u--checkDefined arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 arg-8) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45UnifyState-addConstraint arg-2 arg-1 (vector 0 arg-0 arg-3 (let ((e-0 (car arg-4))) e-0) arg-6 arg-7 arg-8) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "unify.postpone" 10 (lambda () (string-append (PreludeC-45Show-u--show_Show_Int e-10) (string-append " NEW CONSTRAINT " (CoreC-45FC-u--show_Show_FC arg-3)))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45Normalise-logNF arg-0 arg-1 "unify.postpone" 10 (lambda () "X") arg-6 arg-7 eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (CoreC-45Normalise-logNF arg-0 arg-1 "unify.postpone" 10 (lambda () "Y") arg-6 arg-8 eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45Unify-constrain e-10)))))))))))))) eff-0) eta-1))))))))))))))))) eff-0) eta-0))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-postponeS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (cond ((equal? arg-3 1) (CoreC-45Unify-postpone arg-0 arg-1 arg-2 arg-4 (CoreC-45Unify-lower arg-5) arg-6 arg-7 arg-9 arg-8 clam-0)) (else (CoreC-45Unify-postpone arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 clam-0))))))
(define CoreC-45NormaliseC-45Eval-evalArg (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 arg-3)))
(define LibrariesC-45DataC-45NameMap-keys (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45DataC-45NameMap-toList ext-0))))
(define CoreC-45TTC-45Term-u--foldr_Foldable_WhyErased (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) ((arg-2 e-1) arg-3)))(else arg-3))))
(define CoreC-45TT-n--9781-7679-u--addMetaArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) arg-7 (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (CoreC-45TT-n--9781-7679-u--addMetaArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (CoreC-45TT-addMetas arg-6 arg-7 e-2) e-3))))))
(define CoreC-45TT-addMetas (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) arg-2) ((1) arg-2) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (CoreC-45TT-n--9781-7679-u--addMetaArgs e-14 e-13 e-12 e-11 arg-2 arg-1 (LibrariesC-45DataC-45NameMap-insert (cond ((equal? arg-1 1) (vector 8 e-13)) (else e-12)) 0 arg-2) e-14)))))) ((3) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (case (vector-ref e-18 0) ((1) (let ((e-54 (vector-ref e-18 3))) (let ((e-55 (vector-ref e-18 4))) (CoreC-45TT-addMetas arg-1 (CoreC-45TT-addMetas arg-1 (CoreC-45TT-addMetas arg-1 arg-2 e-54) e-55) e-19))))(else (CoreC-45TT-addMetas arg-1 (CoreC-45TT-addMetas arg-1 arg-2 (CoreC-45TTC-45Binder-binderType e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (CoreC-45TT-addMetas arg-1 (CoreC-45TT-addMetas arg-1 arg-2 e-22) e-23)))) ((5) (let ((e-28 (vector-ref arg-3 4))) (CoreC-45TT-addMetas arg-1 arg-2 e-28))) ((6) (let ((e-32 (vector-ref arg-3 3))) (CoreC-45TT-addMetas arg-1 arg-2 e-32))) ((7) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (CoreC-45TT-addMetas arg-1 (CoreC-45TT-addMetas arg-1 arg-2 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-3 3))) (CoreC-45TT-addMetas arg-1 arg-2 e-41))) ((9) arg-2) ((10) (let ((e-47 (vector-ref arg-3 2))) (CoreC-45TTC-45Term-u--foldr_Foldable_WhyErased (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (CoreC-45TT-addMetas arg-1 eta-2 eta-3))) eta-0 eta-1))) arg-2 e-47))) (else arg-2))))
(define CoreC-45TT-getMetas (lambda (arg-1) (CoreC-45TT-addMetas 0 LibrariesC-45DataC-45NameMap-empty arg-1)))
(define CoreC-45Unify-case--chaseMetas-14418 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupDefExact arg-0 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (CoreC-45Unify-chaseMetas arg-3 arg-1 (LibrariesC-45DataC-45NameMap-insert arg-0 (vector 0 ) arg-2)) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-4 (vector-ref e-1 3))) (case (vector-ref e-4 0) ((1) (let ((e-9 (vector-ref e-4 2))) (let ((u--sns (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-9)))) (CoreC-45Unify-chaseMetas arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--sns arg-1) (LibrariesC-45DataC-45NameMap-insert arg-0 (vector 0 ) arg-2)))))(else (CoreC-45Unify-chaseMetas arg-3 arg-1 (LibrariesC-45DataC-45NameMap-insert arg-0 (vector 0 ) arg-2))))))(else (CoreC-45Unify-chaseMetas arg-3 arg-1 (LibrariesC-45DataC-45NameMap-insert arg-0 (vector 0 ) arg-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CoreC-45Unify-chaseMetas arg-3 arg-1 arg-2))))
(define CoreC-45Unify-chaseMetas (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45NameMap-keys arg-2))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CoreC-45Unify-case--chaseMetas-14418 e-2 e-3 arg-2 arg-0 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-2)))))))
(define CoreC-45Unify-getMetaNames (lambda (arg-1 arg-2) (let ((u--metas (CoreC-45TT-getMetas arg-2))) (CoreC-45Unify-chaseMetas arg-1 (LibrariesC-45DataC-45NameMap-keys u--metas) LibrariesC-45DataC-45NameMap-empty))))
(define CoreC-45Normalise-normalise (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Unify-case--occursCheckC-44failOnStrongRigid-15997 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-3) (lambda (eta-0) (vector 1 (vector 0 ))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((1) (lambda (eta-0) (vector 1 (vector 0 ))))(else (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--11176-15903-u--failOnStrongRigid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 1 arg-8 eta-0)) e-3)))))(else (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--11176-15903-u--failOnStrongRigid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-8 eta-0)) e-3))))))))
(define CoreC-45Unify-n--11176-15903-u--failOnStrongRigid (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((2) (let ((e-2 (vector-ref arg-9 2))) (let ((sc1 (cond ((equal? arg-7 1) (CoreC-45Name-u--C-61C-61_Eq_Name e-2 arg-2)) (else 0)))) (cond ((equal? sc1 1) arg-8) (else (lambda (eta-0) (vector 1 (vector 0 ))))))))(else (CoreC-45Unify-case--occursCheckC-44failOnStrongRigid-15997 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-8 arg-7 (CoreC-45TTC-45Term-getFnArgs arg-9))))))
(define CoreC-45Unify-case--occursCheck-16142 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (cond ((equal? arg-8 0) (vector 1 (box arg-1)))(else (let ((act-1 (let ((act-1 (unbox arg-6))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalise arg-6 arg-0 e-5 arg-4 arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Unify-getMetaNames arg-6 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-832 arg-2 e-7))) (cond ((equal? sc3 1) (let ((act-4 ((CoreC-45Unify-n--11176-15903-u--failOnStrongRigid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 4 arg-0 arg-5 arg-4 arg-2 e-6) eta-2)) e-6) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 '()))))) (else (vector 1 (box e-6)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Unify-occursCheck (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((CoreC-45Unify-getMetaNames arg-1 arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Unify-case--occursCheck-16142 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (PreludeC-45Types-elem csegen-14 csegen-832 arg-5 e-5) eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Unify-n--10398-15220-u--inArgs (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) 0 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-8 e-2))) (cond ((equal? sc1 1) 1) (else (CoreC-45Unify-n--10398-15220-u--inArgs arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))))))))
(define CoreC-45Unify-getVars (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((9) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((2) (let ((e-17 (vector-ref e-6 1))) (CoreC-45Unify-getVars arg-0 arg-1 (cons e-17 e-3))))(else '())))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (case (vector-ref e-9 0) ((0) (let ((e-20 (vector-ref e-9 1))) (let ((e-21 (vector-ref e-9 2))) (if (null? e-10) (let ((sc4 (CoreC-45Unify-n--10398-15220-u--inArgs arg-0 e-21 e-20 e-8 e-3 arg-1 e-21 arg-1))) (cond ((equal? sc4 1) '()) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-getVars arg-0 (cons e-21 arg-1) e-3) (lambda (u--xsC-39) (box (cons e-21 u--xsC-39))))))) '()))))(else '())))))) ((4) (let ((e-15 (vector-ref e-2 4))) (CoreC-45Unify-getVars arg-0 arg-1 (cons e-15 e-3))))(else '())))))))
(define CoreC-45TTC-45VarC-45Var-isLater (lambda (arg-3) (cond ((equal? arg-3 0) '())(else (let ((e-5 (- arg-3 1))) (box e-5))))))
(define CoreC-45TTC-45Var-dropFirst (lambda (ext-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CoreC-45TTC-45VarC-45Var-isLater eta-0)) ext-0)))
(define CoreC-45Unify-n--10565-15352-u--anyFirst (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) 0 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? e-2 0) 1)(else (CoreC-45Unify-n--10565-15352-u--anyFirst arg-0 arg-1 arg-2 e-3))))))))
(define CoreC-45Unify-toThin (lambda (arg-0 arg-1) (if (null? arg-0) (cons '() (vector 0 )) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (CoreC-45Unify-toThin e-3 (CoreC-45TTC-45Var-dropFirst arg-1)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (CoreC-45Unify-n--10565-15352-u--anyFirst e-2 e-3 arg-1 arg-1))) (cond ((equal? sc2 1) (cons (cons e-2 e-5) (vector 2 e-4))) (else (cons e-5 (vector 1 e-4)))))))))))))
(define CoreC-45TTC-45Var-u--shrink_IsScoped_C-40VarC-32C-91aC-32C-61C-32NameC-93C-41 (lambda (arg-2 ext-0) (CoreC-45TTC-45Var-shrinkIsVar arg-2 ext-0)))
(define CoreC-45Unify-updateVars (lambda (arg-2 arg-3) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (u--v) (CoreC-45TTC-45Var-u--shrink_IsScoped_C-40VarC-32C-91aC-32C-61C-32NameC-93C-41 u--v arg-3)) arg-2)))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnv-15599 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (box (cons e-2 (cons (CoreC-45Unify-updateVars arg-8 e-3) e-3)))))))
(define CoreC-45Unify-case--patternEnv-15554 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (unbox arg-8))) (CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnv-15599 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-2 (CoreC-45Unify-toThin arg-0 e-2))))))
(define CoreC-45Unify-patternEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalArg arg-0 arg-2 e-6 eta-2)) arg-4 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45Unify-case--patternEnv-15554 arg-2 arg-4 arg-3 arg-1 arg-0 e-5 e-6 e-7 (CoreC-45Unify-getVars arg-2 '() e-7)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convert_Convert_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 e-5 0 arg-2 arg-3 arg-4 arg-5))) eff-0) ext-0)))))))
(define CoreC-45Unify-postponePatVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--x (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 u--x arg-11 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-2) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Not in pattern fragment" arg-6 u--x arg-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define CoreC-45Context-lookupTyExact (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupExactBy csegen-1313 ext-2 ext-1 ext-0)))
(define CoreC-45Unify-getArgTypes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (case (vector-ref e-4 0) ((2) (let ((e-10 (vector-ref e-4 4))) (lambda (clam-0) (if (null? arg-4) (if (null? arg-4) (vector 1 (box '())) (vector 1 '())) (let ((e-12 (car arg-4))) (let ((e-13 (cdr arg-4))) (let ((act-1 (let ((act-1 (((e-5 arg-2) e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Unify-getArgTypes arg-0 arg-1 arg-2 e-6 e-13))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-2 e-10) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (cons e-11 e-1)))))) eff-0) clam-1)))))))))) eff-0) clam-0)))))))))))(else (lambda (clam-2) (if (null? arg-4) (vector 1 (box '())) (vector 1 '()))))))))(else (lambda (clam-3) (if (null? arg-4) (vector 1 (box '())) (vector 1 '())))))))
(define CoreC-45Unify-case--headsConvert-19715 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-0) (if (null? e-2) (vector 1 0) (let ((e-5 (car e-2))) (if (null? e-3) (vector 1 0) (let ((e-8 (car e-3))) (let ((act-1 (CoreC-45Normalise-logNF arg-0 arg-7 "unify.head" 10 (lambda () "Unifying head") arg-3 e-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-7 "unify.head" 10 (lambda () ".........with") arg-3 e-8 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-7 arg-6 arg-5 arg-4) arg-3) e-5) e-8) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (DataC-45List-isNil (let ((e-0 (vector-ref e-11 0))) e-0)))))) eff-0) clam-0)))))))))))))))))))))
(define CoreC-45Unify-headsConvert (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "unify.head" 10 (lambda () "Nothing to convert") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 1))))) (let ((e-1 (unbox arg-6))) (if (null? arg-7) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "unify.head" 10 (lambda () "Nothing to convert") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 1))))) (let ((e-3 (unbox arg-7))) (CoreC-45Unify-case--headsConvert-19715 arg-0 e-1 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 (cons (PreludeC-45TypesC-45List-reverse e-1) (PreludeC-45TypesC-45List-reverse e-3)))))))))
(define CoreC-45Context-branchCtxt (lambda (arg-0 ext-0) (vector 1 (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (let ((e-11 (vector-ref arg-0 11))) (vector e-0 e-1 e-2 e-3 e-4 (+ e-5 1) e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))))
(define CoreC-45Context-setCtxt (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector arg-1 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-branch (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-branchCtxt (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-setCtxt arg-0 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-n--11536-7431-u--commitStaged (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-1) (vector 0 ) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 arg-2 e-6 e-7) ext-0))) (CoreC-45Context-n--11536-7431-u--commitStaged arg-0 e-3 arg-2 ext-0)))))))))
(define CoreC-45Context-case--commitCtxt-7469 (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 arg-0)))(else (let ((e-0 (- arg-1 1))) (cond ((equal? e-0 0) (let ((u--a (let ((e-4 (vector-ref arg-0 4))) e-4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox u--a))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (CoreC-45Context-n--11536-7431-u--commitStaged arg-0 (LibrariesC-45DataC-45IntMap-toList (let ((e-6 (vector-ref arg-0 6))) e-6)) e-5 eta-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (let ((e-14 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (let ((e-11 (vector-ref arg-0 11))) (vector e-14 e-1 e-2 e-3 e-4 0 LibrariesC-45DataC-45IntMap-empty e-7 e-8 e-9 e-10 e-11)))))))))))))))))) eff-0) eta-0))))))))(else (lambda (eta-0) (vector 1 (let ((e-12 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (let ((e-10 (vector-ref arg-0 10))) (let ((e-11 (vector-ref arg-0 11))) (vector e-12 e-1 e-2 e-3 e-4 e-0 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))))))))
(define CoreC-45Context-commitCtxt (lambda (arg-0) (CoreC-45Context-case--commitCtxt-7469 arg-0 (let ((e-5 (vector-ref arg-0 5))) e-5))))
(define CoreC-45Context-commit (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-commitCtxt (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Context-setCtxt arg-0 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Core-u--catch_Catchable_Core_Error (lambda (arg-1 arg-2 ext-0) (let ((act-1 (arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) ((let ((eff-0 (arg-2 e-2))) eff-0) ext-0))) (else (let ((e-5 (vector-ref act-1 1))) (vector 1 e-5)))))))
(define CoreC-45UnifyState-tryErrorUnify (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-branch arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-3 (arg-4 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-commit arg-1 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (vector 1 e-7)))))))) eff-0) eta-2)))))) (lambda (u--err) (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-2 e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (cond ((equal? arg-3 1) (CoreC-45Context-toFullNames arg-1 csegen-1827 u--err eta-2)) (else (vector 1 u--err))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-1))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-37 (vector-ref e-6 5))) (let ((e-36 (vector-ref e-6 6))) (let ((e-35 (vector-ref e-6 7))) (let ((e-34 (vector-ref e-6 8))) (let ((e-33 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-37 e-36 e-35 e-34 e-33 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 (let ((e-43 (vector-ref e-9 27))) e-43) e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 (vector 0 e-8)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-tryUnify (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45UnifyState-tryErrorUnify arg-1 arg-2 0 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (lambda (eta-0) (vector 1 e-2)))) (else arg-4)))) eff-0) ext-0)))))))
(define CoreC-45Unify-ufail (lambda (arg-1 arg-2 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 arg-2) ext-0)))
(define CoreC-45Unify-unifyInvertible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyExact (vector 8 arg-8) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Unify-ufail arg-5 (string-append "No such metavariable " (CoreC-45Name-u--show_Show_Name arg-7)) clam-0) (let ((e-1 (unbox e-6))) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-2 e-5 arg-6 e-1) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Unify-getArgTypes arg-2 arg-0 e-5 e-7 (PreludeC-45TypesC-45List-tailRecAppend arg-9 arg-10)))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((PreludeC-45Types-maybe (lambda () (lambda (eta-2) (vector 1 '()))) (lambda () (lambda (u--ty) (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-2 e-5 arg-6 u--ty) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Unify-getArgTypes arg-2 arg-0 e-5 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-13)))) eff-0) eta-2)))))))) arg-11) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Unify-headsConvert arg-2 arg-0 arg-1 arg-4 arg-5 arg-6 e-7 e-8) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (cond ((equal? e-9 1) (let ((sc7 (PreludeC-45TypesC-45List-reverse arg-10))) (if (null? sc7) (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application [2]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13)) (let ((e-11 (car sc7))) (let ((e-10 (cdr sc7))) (let ((sc8 (PreludeC-45TypesC-45List-reverse arg-13))) (if (null? sc8) (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application [2]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13)) (let ((e-13 (car sc8))) (let ((e-12 (cdr sc8))) (lambda (eta-3) (CoreC-45UnifyState-tryUnify arg-0 arg-1 (lambda (clam-1) (cond ((equal? arg-3 1) (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" 10 (lambda () "Unifying invertible") clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (((((CoreC-45Unify-unify (csegen-2502) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) (Builtin-snd e-13)) e-11) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" 10 (lambda () (string-append "Constraints " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 (let ((e-0 (vector-ref e-15 0))) e-0)))) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (((((CoreC-45Unify-unify (csegen-2479) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) (arg-12 (PreludeC-45TypesC-45List-reverse e-12))) (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) e-10)))) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (CoreC-45Unify-union e-15 e-17))))) eff-0) eta-4))))))))))) eff-0) clam-1))))))))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" 10 (lambda () "Unifying invertible") clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (((((CoreC-45Unify-unify (csegen-2502) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) e-11) (Builtin-snd e-13)) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (CoreC-45ContextC-45Log-log arg-0 "unify.invertible" 10 (lambda () (string-append "Constraints " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 (let ((e-0 (vector-ref e-15 0))) e-0)))) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (((((CoreC-45Unify-unify (csegen-2479) arg-2 arg-0 arg-1 arg-4 arg-5) arg-6) (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) e-10)))) (arg-12 (PreludeC-45TypesC-45List-reverse e-12))) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (CoreC-45Unify-union e-15 e-17))))) eff-0) eta-4))))))))))) eff-0) clam-1))))))))))) (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application [1]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13)) eta-3))))))))))) (else (lambda (eta-3) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-5 arg-4 "Postponing hole application [3]" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) (arg-12 arg-13) eta-3)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-n--14595-20581-u--isPatName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((3) 1)(else 0))))
(define CoreC-45Unify-unifyHoleApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((3) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (let ((e-5 (vector-ref arg-11 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact e-2 (let ((e-0 (vector-ref e-6 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-7 (lambda (eta-3) (vector 3 e-1 e-2 e-3 e-4 eta-3)) e-5 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((2) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (let ((e-10 (vector-ref arg-11 4))) (let ((e-11 (vector-ref arg-11 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact e-8 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (lambda (eta-3) (vector 2 e-7 e-8 e-9 e-10 eta-3)) e-11 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((1) (let ((e-13 (vector-ref arg-11 1))) (let ((e-14 (vector-ref arg-11 2))) (let ((e-15 (vector-ref arg-11 3))) (case (vector-ref e-14 0) ((0) (let ((e-18 (vector-ref e-14 1))) (let ((e-19 (vector-ref e-14 2))) (lambda (eta-0) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() (lambda (eta-1) (vector 1 e-13 (vector 0 e-18 e-19) eta-1)) e-15 eta-0))))) ((2) (let ((e-22 (vector-ref e-14 1))) (let ((e-23 (vector-ref e-14 2))) (let ((e-24 (vector-ref e-14 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 e-23) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--tm (vector 1 e-13 (vector 2 e-22 e-23 e-24) e-15))) (if (null? e-6) (lambda (eta-2) (CoreC-45Context-undefinedName arg-0 e-13 arg-7 eta-2)) (let ((e-1 (unbox e-6))) (let ((u--inv (let ((sc5 (CoreC-45Unify-n--14595-20581-u--isPatName arg-2 e-24 e-23 e-22 e-15 e-13 u--tm arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-22))) (cond ((equal? sc5 1) 1) (else (let ((e-26 (vector-ref e-1 15))) e-26)))))) (cond ((equal? u--inv 1) (lambda (eta-2) (CoreC-45Unify-unifyInvertible arg-0 arg-1 arg-2 arg-3 (CoreC-45Unify-lower arg-4) arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() (lambda (eta-3) (vector 1 e-13 (vector 2 e-22 e-23 e-24) eta-3)) e-15 eta-2))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) u--tm))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) arg-11)))))))(else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing hole application" arg-6 (vector 1 arg-5 (vector 2 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-10)) arg-11)))))
(define CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_NF arg-0 arg-1 e-5 arg-2 arg-3 arg-4 arg-5))) eff-0) ext-0)))))))
(define CoreC-45Unify-solvedHole (lambda (arg-0) (vector '() 1 (cons arg-0 '()) (vector 0 ))))
(define DataC-45Maybe-toMaybe (lambda (arg-1 arg-2) (cond ((equal? arg-1 1) (box (arg-2))) (else '()))))
(define CoreC-45NormaliseC-45Quote-quoteWithPiGen (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 1))) (let ((e-10 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-12 (vector-ref e-3 4))) (let ((act-1 (CoreC-45NormaliseC-45Quote-genName arg-3 "qv" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (((e-4 arg-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-7 (vector 1 e-1 (vector 0 ) e-5))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Quote-quoteWithPiGen arg-0 (cons e-2 arg-1) arg-2 arg-3 arg-4 arg-5 (vector 1 e-2 e-5 arg-6) arg-7 e-7))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-2 e-6 e-12) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 e-6 arg-6 arg-7 e-8 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45NormaliseC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 e-6 arg-6 arg-7 e-11 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 3 e-1 e-2 (vector 2 e-9 e-10 e-13 e-8) e-7))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))(else (let ((act-1 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6 arg-7 arg-8 eta-0)))) eff-0) clam-0)))))))))))) ((9) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 10 e-6 e-5)))))) (CoreC-45TTC-45Term-u--traverse_Traversable_WhyErased csegen-999 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteWithPiGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) e-7) clam-0))))(else (let ((act-1 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6 arg-7 arg-8 eta-0)))) eff-0) clam-0))))))))))
(define CoreC-45NormaliseC-45Quote-quoteWithPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Quote-quoteWithPiGen arg-0 '() arg-1 e-5 (vector 1 0 '()) arg-2 (vector 0 ) arg-3 arg-4))) eff-0) ext-0)))))))
(define CoreC-45Normalise-normalisePis (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (CoreC-45NormaliseC-45Quote-quoteWithPi arg-0 arg-1 arg-2 arg-3 e-5 clam-0))(else (vector 1 arg-4)))))(else (vector 1 arg-4)))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45IntMap-branch4 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8))))
(define LibrariesC-45DataC-45IntMap-branch5 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 2 arg-6 arg-7 arg-8 arg-9 arg-10))))
(define LibrariesC-45DataC-45IntMap-branch6 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 2 (vector 1 arg-2 arg-3 arg-4) arg-5 (vector 1 arg-6 arg-7 arg-8) arg-9 (vector 1 arg-10 arg-11 arg-12))))
(define LibrariesC-45DataC-45IntMap-branch7 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 2 (vector 2 arg-2 arg-3 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10) arg-11 (vector 1 arg-12 arg-13 arg-14))))
(define LibrariesC-45DataC-45IntMap-merge1 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch5 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch6 arg-2 arg-3 e-2 e-3 e-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((e-10 (vector-ref arg-4 4))) (let ((e-11 (vector-ref arg-4 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch6 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch7 arg-2 arg-3 e-7 e-8 e-9 e-10 e-11 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45IntMap-merge2 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-6 0) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (let ((e-16 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch5 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-14 e-15 e-16))))) (else (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (let ((e-22 (vector-ref arg-6 4))) (let ((e-23 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch6 e-2 e-3 e-4 arg-3 arg-4 arg-5 e-19 e-20 e-21 e-22 e-23)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-6 0) ((1) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (LibrariesC-45DataC-45IntMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-26 e-27 e-28))))) (else (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (let ((e-34 (vector-ref arg-6 4))) (let ((e-35 (vector-ref arg-6 5))) (LibrariesC-45DataC-45IntMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 arg-4 arg-5 e-31 e-32 e-33 e-34 e-35)))))))))))))))))
(define LibrariesC-45DataC-45IntMap-merge3 (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (case (vector-ref arg-4 0) ((1) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (LibrariesC-45DataC-45IntMap-branch5 e-2 e-3 e-4 arg-3 e-14 e-15 e-16 arg-5 arg-6))))) (else (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (let ((e-22 (vector-ref arg-4 4))) (let ((e-23 (vector-ref arg-4 5))) (LibrariesC-45DataC-45IntMap-branch6 e-2 e-3 e-4 arg-3 e-19 e-20 e-21 e-22 e-23 arg-5 arg-6)))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((e-11 (vector-ref arg-2 5))) (case (vector-ref arg-4 0) ((1) (let ((e-26 (vector-ref arg-4 1))) (let ((e-27 (vector-ref arg-4 2))) (let ((e-28 (vector-ref arg-4 3))) (LibrariesC-45DataC-45IntMap-branch6 e-7 e-8 e-9 e-10 e-11 arg-3 e-26 e-27 e-28 arg-5 arg-6))))) (else (let ((e-31 (vector-ref arg-4 1))) (let ((e-32 (vector-ref arg-4 2))) (let ((e-33 (vector-ref arg-4 3))) (let ((e-34 (vector-ref arg-4 4))) (let ((e-35 (vector-ref arg-4 5))) (LibrariesC-45DataC-45IntMap-branch7 e-7 e-8 e-9 e-10 e-11 arg-3 e-31 e-32 e-33 e-34 e-35 arg-5 arg-6)))))))))))))))))
(define LibrariesC-45DataC-45IntMap-treeDelete (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-2))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (vector 0 (vector 0 e-2 e-3))))))))(else (let ((e-0 (- arg-1 1))) (cond ((equal? e-0 0) (case (vector-ref arg-3 0) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-8))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-7))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-2 e-8 e-9)))) (else (vector 1 e-9))))) (else (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-9))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-7 e-8 e-2)))) (else (vector 1 e-7))))))))))) (else (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (let ((e-16 (vector-ref arg-3 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-2 e-13 e-14 e-15 e-16)))) (else (vector 0 (vector 1 e-14 e-15 e-16)))))) (else (let ((sc3 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-15))) (cond ((equal? sc3 1) (let ((sc4 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-14))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-2 e-15 e-16)))) (else (vector 0 (vector 1 e-12 e-13 e-16)))))) (else (let ((sc4 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-2 e-16))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-12 e-13 e-14 e-15 e-2)))) (else (vector 0 (vector 1 e-12 e-13 e-14)))))))))))))))))))(else (let ((e-4 (- e-0 1))) (case (vector-ref arg-3 0) ((1) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-20))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete (+ e-4 1) arg-2 e-19))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-20 e-21)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-21 0) ((1) (let ((e-2 (vector-ref e-21 1))) (let ((e-3 (vector-ref e-21 2))) (let ((e-6 (vector-ref e-21 3))) (vector 1 (vector 2 e-5 e-20 e-2 e-3 e-6)))))) (else (let ((e-7 (vector-ref e-21 1))) (let ((e-8 (vector-ref e-21 2))) (let ((e-9 (vector-ref e-21 3))) (let ((e-10 (vector-ref e-21 4))) (let ((e-11 (vector-ref e-21 5))) (vector 0 (LibrariesC-45DataC-45IntMap-branch4 e-5 e-20 e-7 e-8 e-9 e-10 e-11)))))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete (+ e-4 1) arg-2 e-21))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-19 e-20 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-19 0) ((1) (let ((e-2 (vector-ref e-19 1))) (let ((e-3 (vector-ref e-19 2))) (let ((e-6 (vector-ref e-19 3))) (vector 1 (vector 2 e-2 e-3 e-6 e-20 e-5)))))) (else (let ((e-7 (vector-ref e-19 1))) (let ((e-8 (vector-ref e-19 2))) (let ((e-9 (vector-ref e-19 3))) (let ((e-10 (vector-ref e-19 4))) (let ((e-11 (vector-ref e-19 5))) (vector 0 (LibrariesC-45DataC-45IntMap-branch4 e-7 e-8 e-9 e-10 e-11 e-20 e-5)))))))))))))))))))) (else (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (let ((e-28 (vector-ref arg-3 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-25))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete (+ e-4 1) arg-2 e-24))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-25 e-26 e-27 e-28)))) (else (let ((e-5 (vector-ref sc2 1))) (vector 0 (LibrariesC-45DataC-45IntMap-merge1 e-5 e-25 e-26 e-27 e-28))))))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 e-27))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete (+ e-4 1) arg-2 e-26))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-2 e-27 e-28)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45IntMap-merge2 e-24 e-25 e-5 e-27 e-28))))))) (else (let ((sc3 (LibrariesC-45DataC-45IntMap-treeDelete (+ e-4 1) arg-2 e-28))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-24 e-25 e-26 e-27 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45IntMap-merge3 e-24 e-25 e-26 e-27 e-5)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45IntMap-delete (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (let ((sc2 (LibrariesC-45DataC-45IntMap-treeDelete 0 arg-1 e-3))) (case (vector-ref sc2 0) ((0) (let ((e-4 (vector-ref sc2 1))) (cons 0 e-4))) (else '()))))(else (let ((e-4 (- e-2 1))) (let ((sc1 (LibrariesC-45DataC-45IntMap-treeDelete (+ e-4 1) arg-1 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-5 (vector-ref sc1 1))) (cons (+ e-4 1) e-5))) (else (let ((e-5 (vector-ref sc1 1))) (cons e-4 e-5)))))))))))))
(define CoreC-45UnifyState-removeHole (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector (LibrariesC-45DataC-45IntMap-delete arg-1 e-0) e-1 (LibrariesC-45DataC-45IntMap-delete arg-1 e-2) (LibrariesC-45DataC-45IntMap-delete arg-1 e-3) e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Unify-n--11799-16503-u--noMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 arg-16) (case (vector-ref arg-15 0) ((4) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (cond ((equal? arg-16 0) 0)(else (let ((e-48 (- arg-16 1))) (let ((sc1 (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2 e-48))) (cond ((equal? sc1 1) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3 e-48)) (else 0))))))))) ((3) (let ((e-7 (vector-ref arg-15 3))) (let ((e-8 (vector-ref arg-15 4))) (cond ((equal? arg-16 0) 0)(else (let ((e-49 (- arg-16 1))) (let ((sc1 (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (CoreC-45TTC-45Binder-binderType e-7) e-49))) (cond ((equal? sc1 1) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-8 e-49)) (else 0))))))))) ((2) 0) ((6) (let ((e-17 (vector-ref arg-15 3))) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-17 arg-16))) ((7) (let ((e-21 (vector-ref arg-15 3))) (let ((e-22 (vector-ref arg-15 4))) (let ((sc1 (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-21 arg-16))) (cond ((equal? sc1 1) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-22 arg-16)) (else 0)))))) ((8) (let ((e-26 (vector-ref arg-15 3))) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-26 arg-16))) ((5) (let ((e-30 (vector-ref arg-15 3))) (let ((e-31 (vector-ref arg-15 4))) (let ((sc1 (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-30 arg-16))) (cond ((equal? sc1 1) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-31 arg-16)) (else 0)))))) ((0) 1) ((1) 1) ((9) 1) ((11) 1)(else 0))))
(define CoreC-45Unify-n--11799-16501-u--isSimple (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15) (case (vector-ref arg-15 0) ((2) 1) ((3) (let ((e-8 (vector-ref arg-15 3))) (let ((e-9 (vector-ref arg-15 4))) (case (vector-ref e-8 0) ((0) (CoreC-45Unify-n--11799-16501-u--isSimple arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-9))(else (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 0)))))) ((4) (let ((e-12 (vector-ref arg-15 2))) (let ((e-13 (vector-ref arg-15 3))) (let ((sc1 (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-12 6))) (cond ((equal? sc1 1) (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-13 3)) (else 0))))))(else (CoreC-45Unify-n--11799-16503-u--noMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 0)))))
(define CoreC-45Unify-getIVars (lambda (arg-2) (if (null? arg-2) '() (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (cons e-4 (CoreC-45Unify-getIVars e-5)))))))
(define CoreC-45NameC-45Scoped-n--4312-4576-u--go (lambda (arg-2 arg-3 arg-6 ext-0) ((((arg-2 'erased) 'erased) (let ((e-2 (cdr arg-3))) (((e-2 'erased) 'erased) arg-6))) ext-0)))
(define CoreC-45NameC-45Scoped-FunctorWeaken (lambda (arg-2 arg-3) (cons (lambda (nm-4599) (lambda (vars-4600) (lambda (eta-0) (CoreC-45NameC-45Scoped-n--4312-4576-u--go arg-2 arg-3 (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) eta-0)))) (lambda (vars-4614) (lambda (ns-4615) (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Scoped-n--4312-4576-u--go arg-2 arg-3 eta-0 eta-1))))))))
(define CoreC-45NameC-45Scoped-MaybeWeaken (lambda (arg-1) (CoreC-45NameC-45Scoped-FunctorWeaken (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45Types-u--map_Functor_Maybe eta-2 eta-3))))) arg-1)))
(define CoreC-45Unify-u--weakenNs_Weaken_C-40IVarsC-32C-36vsC-41 (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (cons (let ((sc1 (CoreC-45NameC-45Scoped-MaybeWeaken CoreC-45TTC-45Var-WeakenVar))) (let ((e-2 (cdr sc1))) ((((e-2 'erased) 'erased) arg-3) e-4))) (CoreC-45Unify-u--weakenNs_Weaken_C-40IVarsC-32C-36vsC-41 arg-3 e-5)))))))
(define CoreC-45Unify-u--weaken_Weaken_C-40IVarsC-32C-36vsC-41 (lambda (ext-0) (CoreC-45Unify-u--weakenNs_Weaken_C-40IVarsC-32C-36vsC-41 (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) ext-0)))
(define CoreC-45Unify-n--11799-16505-u--updateIVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-16 arg-17) (if (null? arg-16) '() (let ((e-3 (car arg-16))) (let ((e-4 (cdr arg-16))) (if (null? e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45TTC-45VarC-45Var-later eta-0)) (CoreC-45Unify-n--11799-16505-u--updateIVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-4 arg-17)) (let ((e-7 (unbox e-3))) (let ((sc2 (CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 arg-17 e-7))) (cond ((equal? sc2 1) (box 0)) (else (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45TTC-45VarC-45Var-later eta-0)) (CoreC-45Unify-n--11799-16505-u--updateIVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-4 arg-17))))))))))))
(define CoreC-45Unify-n--11872-17084-u--updateIVarsPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((1) (box (vector 1 ))) ((0) (box (vector 0 ))) ((2) (box (vector 2 ))) (else (let ((e-4 (vector-ref arg-24 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-4) (lambda (u--tC-39) (box (vector 3 u--tC-39)))))))))
(define CoreC-45Unify-n--11872-17083-u--updateIVarsB (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((0) (let ((e-1 (vector-ref arg-24 1))) (let ((e-2 (vector-ref arg-24 2))) (let ((e-3 (vector-ref arg-24 3))) (let ((e-4 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11872-17084-u--updateIVarsPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-3) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-4) (lambda (bind-0) (box (vector 0 e-1 e-2 u--pC-39 bind-0))))))))))) ((1) (let ((e-6 (vector-ref arg-24 1))) (let ((e-7 (vector-ref arg-24 2))) (let ((e-8 (vector-ref arg-24 3))) (let ((e-9 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-8) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-9) (lambda (bind-1) (box (vector 1 e-6 e-7 bind-0 bind-1))))))))))) ((2) (let ((e-11 (vector-ref arg-24 1))) (let ((e-12 (vector-ref arg-24 2))) (let ((e-13 (vector-ref arg-24 3))) (let ((e-14 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11872-17084-u--updateIVarsPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-13) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-14) (lambda (bind-0) (box (vector 2 e-11 e-12 u--pC-39 bind-0))))))))))) ((3) (let ((e-16 (vector-ref arg-24 1))) (let ((e-17 (vector-ref arg-24 2))) (let ((e-18 (vector-ref arg-24 3))) (let ((e-19 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11872-17084-u--updateIVarsPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 e-18) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-19) (lambda (bind-0) (box (vector 3 e-16 e-17 u--pC-39 bind-0))))))))))) ((4) (let ((e-21 (vector-ref arg-24 1))) (let ((e-22 (vector-ref arg-24 2))) (let ((e-23 (vector-ref arg-24 3))) (let ((e-24 (vector-ref arg-24 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-23) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-24) (lambda (bind-1) (box (vector 4 e-21 e-22 bind-0 bind-1))))))))))) (else (let ((e-26 (vector-ref arg-24 1))) (let ((e-27 (vector-ref arg-24 2))) (let ((e-28 (vector-ref arg-24 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-21 arg-22 arg-23 e-28) (lambda (bind-0) (box (vector 5 e-26 e-27 bind-0)))))))))))
(define CoreC-45Unify-n--11799-16506-u--updateIVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-17 0) ((0) (let ((e-2 (vector-ref arg-17 1))) (let ((e-3 (vector-ref arg-17 2))) (let ((e-4 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16505-u--updateIVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-16 e-4) (lambda (_-0) (box (vector 0 e-2 e-3 _-0)))))))) ((1) (let ((e-7 (vector-ref arg-17 1))) (let ((e-8 (vector-ref arg-17 2))) (let ((e-9 (vector-ref arg-17 3))) (box (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-17 1))) (let ((e-12 (vector-ref arg-17 2))) (let ((e-13 (vector-ref arg-17 3))) (let ((e-14 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 eta-0)) e-14) (lambda (bind-0) (box (vector 2 e-11 e-12 e-13 bind-0))))))))) ((3) (let ((e-16 (vector-ref arg-17 1))) (let ((e-17 (vector-ref arg-17 2))) (let ((e-18 (vector-ref arg-17 3))) (let ((e-19 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11872-17083-u--updateIVarsB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 e-17 e-19 e-18 e-16 arg-14 arg-16 arg-14 arg-15 arg-16 e-18) (lambda (u--bC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-17 arg-14) (cons e-17 arg-15) (cons (box 0) (CoreC-45Unify-u--weaken_Weaken_C-40IVarsC-32C-36vsC-41 arg-16)) e-19) (lambda (u--scC-39) (box (vector 3 e-16 e-17 u--bC-39 u--scC-39))))))))))) ((4) (let ((e-21 (vector-ref arg-17 1))) (let ((e-22 (vector-ref arg-17 2))) (let ((e-23 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-22) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-23) (lambda (bind-1) (box (vector 4 e-21 bind-0 bind-1)))))))))) ((5) (let ((e-25 (vector-ref arg-17 1))) (let ((e-26 (vector-ref arg-17 2))) (let ((e-27 (vector-ref arg-17 3))) (let ((e-28 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-27) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-28) (lambda (bind-1) (box (vector 5 e-25 e-26 bind-0 bind-1))))))))))) ((6) (let ((e-30 (vector-ref arg-17 1))) (let ((e-31 (vector-ref arg-17 2))) (let ((e-32 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-32) (lambda (bind-0) (box (vector 6 e-30 e-31 bind-0)))))))) ((7) (let ((e-34 (vector-ref arg-17 1))) (let ((e-35 (vector-ref arg-17 2))) (let ((e-36 (vector-ref arg-17 3))) (let ((e-37 (vector-ref arg-17 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-36) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-37) (lambda (bind-1) (box (vector 7 e-34 e-35 bind-0 bind-1))))))))))) ((8) (let ((e-39 (vector-ref arg-17 1))) (let ((e-40 (vector-ref arg-17 2))) (let ((e-41 (vector-ref arg-17 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-41) (lambda (bind-0) (box (vector 8 e-39 e-40 bind-0)))))))) ((9) (let ((e-43 (vector-ref arg-17 1))) (let ((e-44 (vector-ref arg-17 2))) (box (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-17 1))) (let ((e-47 (vector-ref arg-17 2))) (case (vector-ref e-47 0) ((1) (box (vector 10 e-46 (vector 1 )))) ((0) (box (vector 10 e-46 (vector 0 )))) (else (let ((e-54 (vector-ref e-47 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 10 e-46 (vector 2 eta-0))) (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-54)))))))) (else (let ((e-49 (vector-ref arg-17 1))) (let ((e-50 (vector-ref arg-17 2))) (box (vector 11 e-49 e-50))))))))
(define CoreC-45TTC-45Var-u--show_Show_C-40VarC-32C-36nsC-41 (lambda (arg-2) (PreludeC-45Show-u--show_Show_Nat arg-2)))
(define CoreC-45TTC-45Var-u--showPrec_Show_C-40VarC-32C-36nsC-41 (lambda (arg-2 arg-3) (CoreC-45TTC-45Var-u--show_Show_C-40VarC-32C-36nsC-41 arg-3)))
(define csegen-2489 (cons (lambda (u--x) (CoreC-45TTC-45Var-u--show_Show_C-40VarC-32C-36nsC-41 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Var-u--showPrec_Show_C-40VarC-32C-36nsC-41 u--d u--x)))))
(define csegen-2492 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-2489 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-2489 u--d u--x)))))
(define csegen-2495 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2492 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-2492 u--d u--x)))))
(define CoreC-45Unify-n--11799-16502-u--mkDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-16) (case (vector-ref arg-19 0) ((3) (let ((e-2 (vector-ref arg-19 1))) (let ((e-3 (vector-ref arg-19 2))) (let ((e-4 (vector-ref arg-19 3))) (let ((e-5 (vector-ref arg-19 4))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Unify-n--11799-16502-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 arg-16 (cons '() arg-17) arg-18 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (if (null? eta-2) (lambda (eta-3) (vector 1 '())) (let ((e-11 (unbox eta-2))) (let ((eff-0 (eta-1 e-11))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))))))) e-6 (lambda (u--scC-39) (let ((u--b (vector 1 e-7 e-8 e-9 e-10))) (lambda (clam-2) (let ((sc4 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term u--scC-39 (vector 1 (vector 0 ))))) (if (null? sc4) (vector 1 (vector 3 e-2 e-3 u--b u--scC-39)) (let ((e-1 (unbox sc4))) (vector 1 e-1)))))))))) eff-0) eta-0)))))))))))(else (if (null? arg-16) (lambda (clam-4) (let ((sc3 (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc3) (CoreC-45Unify-ufail arg-11 (string-append "Can't make solution for " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2495 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-4) (let ((e-1 (unbox sc3))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))(else (if (null? arg-16) (lambda (clam-5) (let ((sc2 (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc2) (CoreC-45Unify-ufail arg-11 (string-append "Can't make solution for " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2495 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-5) (let ((e-1 (unbox sc2))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))) (let ((e-12 (car arg-16))) (let ((e-13 (cdr arg-16))) (case (vector-ref arg-19 0) ((3) (let ((e-15 (vector-ref arg-19 1))) (let ((e-16 (vector-ref arg-19 2))) (let ((e-17 (vector-ref arg-19 3))) (let ((e-18 (vector-ref arg-19 4))) (case (vector-ref e-17 0) ((2) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Unify-n--11799-16502-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-16 arg-14) arg-15 e-13 (cons (box e-12) arg-17) arg-18 e-18) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (vector 3 e-15 e-16 (vector 0 e-20 e-21 (vector 1 ) (vector 10 e-15 (vector 0 ))) eta-2)) e-5))))) eff-0) eta-0)))))))))(else (case (vector-ref arg-19 0) ((3) (let ((e-2 (vector-ref arg-19 1))) (let ((e-3 (vector-ref arg-19 2))) (let ((e-4 (vector-ref arg-19 3))) (let ((e-5 (vector-ref arg-19 4))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Unify-n--11799-16502-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 arg-16 (cons '() arg-17) arg-18 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (if (null? eta-2) (lambda (eta-3) (vector 1 '())) (let ((e-11 (unbox eta-2))) (let ((eff-0 (eta-1 e-11))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))))))) e-6 (lambda (u--scC-39) (let ((u--b (vector 1 e-7 e-8 e-9 e-10))) (lambda (clam-0) (let ((sc5 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term u--scC-39 (vector 1 (vector 0 ))))) (if (null? sc5) (vector 1 (vector 3 e-2 e-3 u--b u--scC-39)) (let ((e-1 (unbox sc5))) (vector 1 e-1)))))))))) eff-0) eta-0)))))))))))(else (if (null? arg-16) (lambda (clam-0) (let ((sc4 (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc4) (CoreC-45Unify-ufail arg-11 (string-append "Can't make solution for " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2495 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-0) (let ((e-1 (unbox sc4))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))(else (if (null? arg-16) (lambda (clam-1) (let ((sc3 (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc3) (CoreC-45Unify-ufail arg-11 (string-append "Can't make solution for " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2495 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-1) (let ((e-1 (unbox sc3))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))))(else (case (vector-ref arg-19 0) ((3) (let ((e-2 (vector-ref arg-19 1))) (let ((e-3 (vector-ref arg-19 2))) (let ((e-4 (vector-ref arg-19 3))) (let ((e-5 (vector-ref arg-19 4))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Unify-n--11799-16502-u--mkDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 arg-16 (cons '() arg-17) arg-18 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (if (null? eta-2) (lambda (eta-3) (vector 1 '())) (let ((e-11 (unbox eta-2))) (let ((eff-0 (eta-1 e-11))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))))))) e-6 (lambda (u--scC-39) (let ((u--b (vector 1 e-7 e-8 e-9 e-10))) (lambda (clam-1) (let ((sc4 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term u--scC-39 (vector 1 (vector 0 ))))) (if (null? sc4) (vector 1 (vector 3 e-2 e-3 u--b u--scC-39)) (let ((e-1 (unbox sc4))) (vector 1 e-1)))))))))) eff-0) eta-0)))))))))))(else (if (null? arg-16) (lambda (clam-2) (let ((sc3 (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc3) (CoreC-45Unify-ufail arg-11 (string-append "Can't make solution for " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2495 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-2) (let ((e-1 (unbox sc3))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))(else (if (null? arg-16) (lambda (clam-3) (let ((sc2 (CoreC-45Unify-n--11799-16506-u--updateIVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-17 arg-18))) (if (null? sc2) (CoreC-45Unify-ufail arg-11 (string-append "Can't make solution for " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2495 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-15 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-15 u--d u--x))))) (cons (CoreC-45Unify-getIVars arg-17) arg-18))))) clam-3) (let ((e-1 (unbox sc2))) (vector 1 (box e-1)))))) (lambda (eta-0) (vector 1 '()))))))))))))
(define CoreC-45Unify-tryInstantiate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-3 arg-0 "unify.instantiate" 5 (lambda () (string-append "Instantiating in " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-3))) arg-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((e-1 (vector-ref arg-10 1))) (case (vector-ref e-1 0) ((3) (let ((e-25 (vector-ref e-1 1))) (let ((e-24 (vector-ref e-1 2))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 3 arg-2 arg-4 (CoreC-45TTC-45Term-getLoc arg-12) arg-6 (vector 3 e-25 e-24) arg-12) ext-0))))(else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45Normalise-normalisePis arg-0 '() e-7 '() (let ((e-2 (vector-ref arg-10 2))) e-2) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (CoreC-45ContextC-45Log-logTerm '() arg-0 "unify.instantiate" 5 (lambda () (string-append "Type: " (CoreC-45Name-u--show_Show_Name arg-7))) (let ((e-2 (vector-ref arg-10 2))) e-2) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45ContextC-45Log-logTerm '() arg-0 "unify.instantiate" 5 (lambda () (string-append "Type: " (CoreC-45Name-u--show_Show_Name arg-7))) e-8 eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45ContextC-45Log-log arg-0 "unify.instantiate" 5 (lambda () (string-append "With locs: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2489 arg-11))) eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45ContextC-45Log-log arg-0 "unify.instantiate" 5 (lambda () (string-append "From vars: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-3))) eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 (unbox arg-0))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-10 ((CoreC-45Unify-n--11799-16502-u--mkDef arg-2 arg-3 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 '() arg-3 arg-11 '() arg-13 e-8) eta-2))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-14) (let ((act-11 (CoreC-45ContextC-45Log-log arg-0 "unify.instantiate" 5 (lambda () "Postponed") clam-0))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (vector 1 0)))) (let ((e-1 (unbox e-14))) (let ((act-11 (CoreC-45ContextC-45Log-logTerm '() arg-0 "unify.instantiate" 5 (lambda () "Definition") e-1 clam-0))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((u--simpleDef (vector (box arg-9) (let ((sc12 (CoreC-45Name-isUserName arg-7))) (cond ((equal? sc12 1) 0) (else (CoreC-45Unify-n--11799-16501-u--isSimple arg-2 arg-3 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 e-1)))) 0))) (let ((u--newdef (let ((e-0 (vector-ref arg-10 0))) (let ((e-34 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (let ((e-33 (vector-ref arg-10 5))) (let ((e-32 (vector-ref arg-10 6))) (let ((e-31 (vector-ref arg-10 7))) (let ((e-30 (vector-ref arg-10 8))) (let ((e-29 (vector-ref arg-10 9))) (let ((e-28 (vector-ref arg-10 10))) (let ((e-27 (vector-ref arg-10 11))) (let ((e-26 (vector-ref arg-10 12))) (let ((e-25 (vector-ref arg-10 13))) (let ((e-24 (vector-ref arg-10 14))) (let ((e-23 (vector-ref arg-10 15))) (let ((e-16 (vector-ref arg-10 16))) (let ((e-17 (vector-ref arg-10 17))) (let ((e-19 (vector-ref arg-10 19))) (let ((e-20 (vector-ref arg-10 20))) (let ((e-21 (vector-ref arg-10 21))) (let ((e-22 (vector-ref arg-10 22))) (vector e-0 e-34 e-2 e-3 e-4 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-16 e-17 (vector 1 u--simpleDef '() (vector 1 0 e-1) (vector 1 0 e-1) '()) e-19 e-20 e-21 e-22))))))))))))))))))))))))) (let ((act-12 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Context-addDef arg-0 (vector 8 arg-8) u--newdef eta-3)) clam-0))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 ((CoreC-45UnifyState-removeHole arg-1 arg-8) clam-0))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (vector 1 1))))))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))
(define CoreC-45Unify-n--14681-20942-u--inNoSolve (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((sc0 (LibrariesC-45DataC-45IntMap-lookup arg-16 arg-17))) (if (null? sc0) 0 1))))
(define CoreC-45Unify-n--14681-20943-u--solutionHeadSame (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-16 0) ((1) (let ((e-2 (vector-ref arg-16 2))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 arg-9)))(else 0))))(else 0))))
(define CoreC-45Unify-solveHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (clam-0) (let ((sc3 (let ((sc4 (CoreC-45Unify-n--14681-20943-u--solutionHeadSame arg-2 arg-3 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 arg-15))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14681-20942-u--inNoSolve arg-2 arg-3 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-1 arg-0 arg-8 (let ((e-14 (vector-ref e-6 5))) e-14))))))) (cond ((equal? sc3 1) (vector 1 (box CoreC-45Unify-success))) (else (let ((act-4 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-8) (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't happen: Lost hole " (CoreC-45Name-u--show_Show_Name arg-7))) clam-1) (let ((e-1 (unbox e-8))) (let ((act-5 (CoreC-45Unify-tryInstantiate arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45List-lengthTR arg-9) e-1 arg-11 arg-13 arg-14 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (DataC-45Maybe-toMaybe e-9 (lambda () (CoreC-45Unify-solvedHole arg-8))))))) eff-0) clam-1)))))))))) eff-0) clam-0))))))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-n--17960-22011-u--solveOrElsePostpone (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 ext-0) (let ((act-1 (CoreC-45Unify-solveHole arg-12 arg-11 arg-16 arg-0 arg-6 arg-9 arg-7 arg-5 arg-4 arg-3 arg-2 arg-17 arg-18 arg-26 arg-28 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (DataC-45Maybe-fromMaybe eta-0 eta-1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0))) e-5) (lambda () (CoreC-45Unify-postponeS arg-0 arg-12 arg-11 arg-10 arg-8 arg-9 "Can't instantiate" arg-7 (vector 1 arg-8 (vector 2 arg-5 arg-4 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-2)) arg-1))))) eff-0) ext-0)))))))
(define CoreC-45Unify-unifyHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--args (let ((sc2 (DataC-45List-isNil arg-11))) (cond ((equal? sc2 1) arg-10) (else (PreludeC-45TypesC-45List-tailRecAppend arg-10 arg-11)))))) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.hole" 10 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CoreC-45NormaliseC-45Eval-evalArg arg-0 arg-2 e-6 eta-3)) u--args '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-6 arg-6 clam-0 eta-4))) e-7 '()) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-6 arg-6 arg-12 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (string-append "Unifying: " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-8) (string-append " with " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 e-9)))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Unify-patternEnv arg-0 arg-1 arg-2 arg-6 u--args eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-2) (let ((act-5 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-9) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (if (null? e-9) (CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-1 (unbox e-9))) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((7) (let ((sc8 (let ((e-38 (vector-ref e-1 15))) e-38))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyHoleApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12)) (else (CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12)))))(else (CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12)))))))) eff-0) eta-2)))))) (let ((e-2 (unbox e-8))) (lambda (clam-0) (let ((e-10 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (let ((act-5 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-9) (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (let ((bind-0 (box (cons e-10 (cons e-12 e-11))))) (if (null? e-13) (CoreC-45Unify-postponePatVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-1 (unbox e-13))) (let ((_-0 (box e-1))) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((7) (let ((e-35 (vector-ref e-18 1))) (let ((e-34 (vector-ref e-18 2))) (let ((u--qopts (vector 0 0 (box (let ((e-64 (vector-ref e-5 4))) (let ((e-75 (vector-ref e-64 3))) (let ((e-80 (vector-ref e-75 5))) e-80))))))) (lambda (eta-2) (let ((act-6 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-2 u--qopts e-6 arg-6 arg-12 eta-3)) (lambda (u--err) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-5 arg-6 arg-12 eta-3))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-36 (vector-ref act-6 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45Unify-occursCheck arg-2 arg-0 arg-5 arg-6 arg-4 arg-8 e-36 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-37 (vector-ref act-7 1))) (vector 0 e-37))) (else (let ((e-37 (vector-ref act-7 1))) ((let ((eff-0 (if (null? e-37) (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Occurs check failed" arg-6 (vector 1 arg-5 (vector 2 arg-8 arg-9 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-11)) arg-12) (let ((e-38 (unbox e-37))) (let ((_-1 (box e-38))) (lambda (clam-1) (let ((sc13 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-38 e-11))) (if (null? sc13) (let ((act-8 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-2 e-5 arg-6 arg-12 clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-39 (vector-ref act-8 1))) (vector 0 e-39))) (else (let ((e-39 (vector-ref act-8 1))) ((let ((eff-0 (let ((sc15 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-39 e-11))) (if (null? sc15) (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Can't shrink" arg-6 (vector 1 arg-5 (vector 2 arg-8 arg-9 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-11)) arg-12) (let ((e-40 (unbox sc15))) (lambda (eta-4) (CoreC-45Unify-n--17960-22011-u--solveOrElsePostpone arg-2 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-5 e-6 u--args e-10 e-12 e-11 bind-0 e-1 _-0 e-35 e-34 u--qopts e-36 e-38 _-1 e-40 eta-4))))))) eff-0) clam-1))))) (let ((e-39 (unbox sc13))) (CoreC-45Unify-n--17960-22011-u--solveOrElsePostpone arg-2 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-5 e-6 u--args e-10 e-12 e-11 bind-0 e-1 _-0 e-35 e-34 u--qopts e-36 e-38 _-1 e-39 clam-1)))))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))(else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Delayed hole" arg-6 (vector 1 arg-5 (vector 2 arg-8 arg-9 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (__infixTupleSection-0) (cons (vector 2 ) __infixTupleSection-0)) arg-11)) arg-12)))))))))) eff-0) clam-0)))))))))))))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Convert-u--convertInf_Convert_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Convert-u--convGen_Convert_NF arg-0 arg-1 e-5 1 arg-2 arg-3 arg-4 arg-5))) eff-0) ext-0)))))))
(define CoreC-45Unify-unifyIfEq (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convertInf_Convert_NF arg-0 arg-2 e-5 arg-6 arg-7 arg-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (lambda (clam-0) (cond ((equal? arg-3 1) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 arg-5 (string-append "Postponing unifyIfEq " (PreludeC-45Show-u--show_Show_Bool (let ((e-0 (car arg-5))) e-0))) arg-6 arg-7 arg-8 clam-0)) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-6 arg-7 arg-8 clam-0)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-unifyApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-8 0) ((2) (let ((e-56 (vector-ref arg-8 1))) (let ((e-57 (vector-ref arg-8 2))) (let ((e-58 (vector-ref arg-8 3))) (lambda (eta-0) (CoreC-45Unify-unifyHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-56 e-57 e-58 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-9) arg-10 eta-0))))))(else (case (vector-ref arg-10 0) ((1) (let ((e-43 (vector-ref arg-10 1))) (let ((e-44 (vector-ref arg-10 2))) (let ((e-45 (vector-ref arg-10 3))) (case (vector-ref e-44 0) ((2) (let ((e-50 (vector-ref e-44 1))) (let ((e-51 (vector-ref e-44 2))) (let ((e-52 (vector-ref e-44 3))) (lambda (eta-0) (CoreC-45Unify-unifyHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-43 e-50 e-51 e-52 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-45) (vector 1 arg-7 arg-8 arg-9) eta-0))))))(else (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Name against app, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 1) (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 arg-10 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) eta-0)) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) arg-10 eta-0)))))))))) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (if (null? arg-9) (case (vector-ref arg-10 0) ((1) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (case (vector-ref e-34 0) ((0) (let ((e-38 (vector-ref e-34 1))) (let ((e-39 (vector-ref e-34 2))) (if (null? e-35) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (let ((sc7 (or (and (= e-6 e-39) 1) 0))) (cond ((equal? sc7 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing var" arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) '()) (vector 1 e-33 (vector 0 e-38 e-39) '()))))))) eff-0) eta-0))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-0) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-1) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-2) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-2)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-2)))))))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-3) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-3)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-3))))))))))))))(else (lambda (clam-4) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-4)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-4)))))))))))))))) ((9) (let ((e-48 (vector-ref arg-10 2))) (case (vector-ref e-48 0) ((2) (let ((e-54 (vector-ref e-48 1))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-54)))(else (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Name against app, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 1) (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 arg-10 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) eta-0)) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) arg-10 eta-0)))))))))) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (if (null? arg-9) (case (vector-ref arg-10 0) ((1) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (case (vector-ref e-34 0) ((0) (let ((e-38 (vector-ref e-34 1))) (let ((e-39 (vector-ref e-34 2))) (if (null? e-35) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (let ((sc7 (or (and (= e-6 e-39) 1) 0))) (cond ((equal? sc7 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing var" arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) '()) (vector 1 e-33 (vector 0 e-38 e-39) '()))))))) eff-0) eta-0))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-5) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-5)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-5))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-6) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-6)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-6))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-7) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-7)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-7)))))))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-8) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-8)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-8))))))))))))))(else (lambda (clam-9) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-9)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-9))))))))))))))(else (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Name against app, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 1) (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 arg-10 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) eta-0)) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-5 arg-4 arg-6 (vector 1 arg-7 (vector 1 e-1 e-2) arg-9) arg-10 eta-0)))))))))) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (if (null? arg-9) (case (vector-ref arg-10 0) ((1) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (case (vector-ref e-34 0) ((0) (let ((e-38 (vector-ref e-34 1))) (let ((e-39 (vector-ref e-34 2))) (if (null? e-35) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (let ((sc6 (or (and (= e-6 e-39) 1) 0))) (cond ((equal? sc6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 arg-3 arg-5 arg-4 "Postponing var" arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) '()) (vector 1 e-33 (vector 0 e-38 e-39) '()))))))) eff-0) eta-0))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-10) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-10)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-10))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-11) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-11)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-11))))))))))))))))(else (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-12) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-12)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-12)))))))))))) (case (vector-ref arg-10 0) ((0) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((2) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((3) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((8) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10)) ((10) (CoreC-45Unify-convertErrorS arg-2 arg-0 arg-3 arg-5 arg-6 (vector 1 arg-7 (vector 0 e-5 e-6) arg-9) arg-10))(else (lambda (clam-13) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-13)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-7 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-13))))))))))))))(else (lambda (clam-14) (cond ((equal? arg-3 0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 0 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-14)))))) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-6 arg-10 (vector 1 arg-7 arg-8 arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-postponeS arg-2 arg-0 arg-1 1 arg-5 arg-4 "Postponing constraint" arg-6 (vector 1 arg-7 arg-8 arg-9) arg-10))))) eff-0) eta-0)))))))) eff-0) clam-14))))))))))))))))
(define CoreC-45Unify-unifyArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (lambda (clam-0) (if (null? arg-9) (vector 1 CoreC-45Unify-success) (CoreC-45Unify-ufail arg-6 "" clam-0))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-1) (if (null? arg-9) (CoreC-45Unify-ufail arg-6 "" clam-1) (let ((e-6 (car arg-9))) (let ((e-7 (cdr arg-9))) (let ((act-1 ((CoreC-45Unify-unifyArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-7) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((CoreC-45Unify-unify (Builtin-fst arg-1) arg-2 arg-3 arg-4 (CoreC-45Unify-lower arg-5) arg-6) arg-7) e-2) e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Unify-union e-8 e-5))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))
(define CoreC-45Unify-isDefInvertible (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-2) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 arg-1 (vector 8 arg-2)) clam-0) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-15 (vector-ref e-1 15))) e-15))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Unify-n--14828-23355-u--localsIn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (vector 1 0) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((act-1 (let ((act-1 (unbox arg-15))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-15 arg-0 e-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-6 0) ((1) (let ((e-7 (vector-ref e-6 2))) (case (vector-ref e-7 0) ((0) (lambda (eta-1) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (+ e-10 1))))) eff-0) eta-1)))))))(else (lambda (eta-1) (CoreC-45Unify-n--14828-23355-u--localsIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3 eta-1))))))(else (lambda (eta-1) (CoreC-45Unify-n--14828-23355-u--localsIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3 eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Unify-n--14828-23356-u--pv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-16 0) ((3) 1)(else 0))))
(define CoreC-45NormaliseC-45Quote-u--quoteLHS_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure arg-0 arg-1 e-5 (vector 1 1 '()) arg-2 arg-3 arg-4 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_Closure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure arg-0 arg-1 e-5 arg-2 arg-3 arg-4 arg-5 eta-0)))) eff-0) ext-0)))))))
(define csegen-2508 (lambda () (cons (csegen-2502) (vector (lambda (u--c) (lambda (u--vars) (lambda (arg-6759) (lambda (arg-6762) (lambda (arg-6766) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure u--c u--vars arg-6759 arg-6762 arg-6766 eta-0))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-6785) (lambda (arg-6788) (lambda (arg-6792) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteLHS_Quote_Closure u--c u--vars arg-6785 arg-6788 arg-6792 eta-0))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-6808) (lambda (arg-6811) (lambda (arg-6814) (lambda (arg-6818) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_Closure u--c u--vars arg-6808 arg-6811 arg-6814 arg-6818 eta-0)))))))) (lambda (u--c) (lambda (u--vars) (lambda (arg-6836) (lambda (arg-6841) (lambda (arg-6844) (lambda (arg-6847) (lambda (arg-6851) (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Closure u--c u--vars arg-6836 arg-6841 arg-6844 arg-6847 arg-6851 eta-0)))))))))))))
(define CoreC-45Unify-unifyBothApps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-7 0) ((0) (let ((e-50 (vector-ref arg-7 1))) (let ((e-51 (vector-ref arg-7 2))) (if (null? arg-8) (case (vector-ref arg-10 0) ((0) (let ((e-56 (vector-ref arg-10 1))) (let ((e-57 (vector-ref arg-10 2))) (if (null? arg-11) (lambda (clam-0) (let ((sc4 (or (and (= e-51 e-57) 1) 0))) (cond ((equal? sc4 1) (vector 1 CoreC-45Unify-success)) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 1 arg-6 (vector 0 e-50 e-51) '()) (vector 1 arg-9 (vector 0 e-56 e-57) '()) clam-0))))) (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc8 (or (and (= e-41 e-46) 1) 0))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc9 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc12 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc12 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc12 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc12 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc10 (let ((sc11 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc11 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc13 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc13 1) 1) (else (let ((sc14 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc14 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc13 (let ((sc14 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc14 1) (let ((sc15 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc15 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc13 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc8 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc11 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc8 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc11 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc9 (let ((sc10 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc10 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc12 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc12 1) 1) (else (let ((sc13 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc13 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc12 (let ((sc13 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc13 1) (let ((sc14 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc14 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc12 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))))))(else (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc6 (or (and (= e-41 e-46) 1) 0))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc7 (let ((sc8 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc8 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc10 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc10 1) 1) (else (let ((sc11 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc11 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc10 (let ((sc11 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc11 1) (let ((sc12 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc12 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))))))) (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc6 (or (and (= e-41 e-46) 1) 0))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc7 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc10 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc8 (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc9 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc11 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc12 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc11 (let ((sc12 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc13 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc11 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc9 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc7 (let ((sc8 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc8 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc10 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc10 1) 1) (else (let ((sc11 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc11 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc10 (let ((sc11 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc11 1) (let ((sc12 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc12 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc10 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))))))(else (if (null? arg-3) (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc6 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc4 (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc5 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc7 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc8 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc7 (let ((sc8 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc8 1) (let ((sc9 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc9 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc5 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))) (let ((e-36 (car arg-3))) (let ((e-37 (cdr arg-3))) (cond ((equal? e-37 1) (case (vector-ref arg-7 0) ((0) (let ((e-40 (vector-ref arg-7 1))) (let ((e-41 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-45 (vector-ref arg-10 1))) (let ((e-46 (vector-ref arg-10 2))) (let ((u--mode (cons e-36 1))) (let ((sc4 (or (and (= e-41 e-46) 1) 0))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (lambda (eta-0) (CoreC-45Unify-postpone arg-2 arg-0 arg-1 arg-4 u--mode "Postponing local app" arg-5 (vector 1 arg-6 (vector 0 e-40 e-41) arg-8) (vector 1 arg-9 (vector 0 e-45 e-46) arg-11) eta-0)))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc8 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc8 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc6 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc7 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc9 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc10 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc9 (let ((sc10 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc10 1) (let ((sc11 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc11 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc9 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc7 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc5 (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc6 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc8 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc8 1) 1) (else (let ((sc9 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc9 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc8 (let ((sc9 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc9 1) (let ((sc10 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc10 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc8 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc6 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((0) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.application" 10 (lambda () "Both local apps, unifyIfEq") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 (vector 1 arg-6 (vector 0 e-20 e-21) arg-8) (vector 1 arg-9 (vector 0 e-29 e-30) arg-11) eta-0))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc6 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))))))))) ((2) (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref arg-10 0) ((2) (let ((e-33 (vector-ref arg-10 1))) (let ((e-34 (vector-ref arg-10 2))) (let ((e-35 (vector-ref arg-10 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-isDefInvertible arg-0 arg-4 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc4 (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-25 e-34))) (cond ((equal? sc5 1) (cond ((equal? e-5 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 3)))) (else 0))))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8)) (PreludeC-45TypesC-45List-tailRecAppend e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)))) (else (lambda (eta-1) (let ((act-2 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-26 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Unify-n--14828-23355-u--localsIn arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-35 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xbigger (let ((sc7 (PreludeC-45Types-u--C-62_Ord_Nat e-6 e-7))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (or (and (= e-6 e-7) 1) 0))) (cond ((equal? sc8 1) (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45List-lengthTR arg-8) (PreludeC-45TypesC-45List-lengthTR arg-11))) (else 0)))))))) (let ((sc7 (let ((sc8 (cond ((equal? u--xbigger 1) 1) (else (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))))) (cond ((equal? sc8 1) (let ((sc9 (CoreC-45Unify-n--14828-23356-u--pv arg-2 e-26 e-25 e-24 e-35 e-34 e-33 arg-11 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 e-24))) (cond ((equal? sc9 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc7 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 (vector 2 e-33 e-34 e-35) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-9 (vector 2 e-33 e-34 e-35) arg-11 (vector 1 arg-6 (vector 2 e-24 e-25 e-26) arg-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 (vector 2 e-24 e-25 e-26) arg-8 (vector 1 arg-9 arg-10 arg-11))))))))(else (case (vector-ref arg-10 0) ((2) (let ((e-15 (vector-ref arg-10 1))) (let ((e-16 (vector-ref arg-10 2))) (let ((e-17 (vector-ref arg-10 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 arg-6 (vector 2 e-15 e-16 e-17) arg-11 (vector 1 arg-6 arg-7 arg-8))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 (vector 2 e-15 e-16 e-17) arg-11)))))))))(else (if (null? arg-3) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-1 3) (case (vector-ref arg-7 0) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 3))) (let ((u--fx (vector 1 e-3 e-4))) (let ((u--fy (vector 1 e-6 e-7))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 e-7))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))) ((equal? e-1 2) (case (vector-ref arg-7 0) ((1) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (case (vector-ref arg-10 0) ((1) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((u--mode (cons e-0 2))) (let ((u--fx (vector 1 e-9 e-10))) (let ((u--fy (vector 1 e-12 e-13))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-13))) (cond ((equal? sc5 1) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify.application" 5 (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-8) '()) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (clam-0) (lambda (eta-4) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-2 e-5 arg-5 clam-0 eta-4))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-snd eta-4)) arg-11) '()) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Matching args " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-6) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-2 u--d u--x)))) e-7)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 u--mode arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-11)) eta-0)))))) (else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 u--mode arg-4 arg-5 arg-6 u--fx arg-8 (vector 1 arg-9 u--fy arg-11)))))))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11)))))(else (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 arg-9 arg-10 arg-11))))))))))))))))))))
(define CoreC-45Unify-n--14952-25783-u--isDelay (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((5) 1)(else 0))))
(define csegen-2509 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 "")))))
(define CoreC-45Unify-unifyNoEta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((2) (let ((e-29 (vector-ref arg-6 1))) (let ((e-30 (vector-ref arg-6 2))) (let ((e-31 (vector-ref arg-6 3))) (let ((e-32 (vector-ref arg-6 4))) (let ((e-33 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((2) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (let ((e-61 (vector-ref arg-7 3))) (let ((e-62 (vector-ref arg-7 4))) (let ((e-63 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-31 e-61))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-33) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-63))) (else (lambda (eta-1) (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 2 e-29 e-30 e-31 e-32 e-33) (vector 2 e-59 e-60 e-61 e-62 e-63) eta-1))))))) eff-0) eta-0)))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))))))))))) ((3) (let ((e-35 (vector-ref arg-6 1))) (let ((e-36 (vector-ref arg-6 2))) (let ((e-37 (vector-ref arg-6 3))) (let ((e-38 (vector-ref arg-6 4))) (let ((e-39 (vector-ref arg-6 5))) (case (vector-ref arg-7 0) ((3) (let ((e-65 (vector-ref arg-7 1))) (let ((e-66 (vector-ref arg-7 2))) (let ((e-67 (vector-ref arg-7 3))) (let ((e-68 (vector-ref arg-7 4))) (let ((e-69 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" 20 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 e-36 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-66 eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (string-append "Comparing type constructors " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " and " (CoreC-45Name-u--show_Show_Name e-6)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-36 e-66))) (cond ((equal? sc3 1) (let ((u--xs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-39))) (let ((u--ys (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-69))) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" 20 (lambda (eta-1) (vector 1 (string-append "Constructor " (CoreC-45Name-u--show_Show_Name e-36)))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" 20 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-2509 (CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CoreC-45Unify-dumpArg arg-2 arg-0 arg-5 eta-2 eta-3))) u--xs) eta-1)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "unify" 20 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-2509 (CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CoreC-45Unify-dumpArg arg-2 arg-0 arg-5 eta-2 eta-3))) u--ys) eta-1)) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 u--xs u--ys) eta-0))))))))))))) (else (CoreC-45Unify-convertError arg-2 arg-0 arg-4 arg-5 (vector 3 e-35 e-36 e-37 e-38 e-39) (vector 3 e-65 e-66 e-67 e-68 e-69) eta-0))))))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))))))))))) ((5) (let ((e-43 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-73 (vector-ref arg-7 3))) ((((CoreC-45Unify-unify (csegen-2479) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-43) e-73)))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))))))) ((6) (let ((e-47 (vector-ref arg-6 3))) (let ((e-48 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((6) (let ((e-77 (vector-ref arg-7 3))) (let ((e-78 (vector-ref arg-7 4))) (CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (cons e-47 (cons e-48 '())) (cons e-77 (cons e-78 '()))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))))) ((7) (let ((e-52 (vector-ref arg-6 3))) (let ((e-53 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((7) (let ((e-82 (vector-ref arg-7 3))) (let ((e-83 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 (((((CoreC-45Unify-unify (csegen-2479) arg-2 arg-0 arg-1 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-52) e-82) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Unify-unifyArgs (csegen-2508) arg-2 arg-0 arg-1 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-53) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-83)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45Unify-union e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))))) ((1) (let ((e-55 (vector-ref arg-6 1))) (let ((e-56 (vector-ref arg-6 2))) (let ((e-57 (vector-ref arg-6 3))) (case (vector-ref e-56 0) ((2) (let ((e-89 (vector-ref e-56 1))) (let ((e-90 (vector-ref e-56 2))) (let ((e-91 (vector-ref e-56 3))) (case (vector-ref arg-7 0) ((1) (let ((e-93 (vector-ref arg-7 1))) (let ((e-94 (vector-ref arg-7 2))) (let ((e-95 (vector-ref arg-7 3))) (case (vector-ref e-94 0) ((2) (let ((e-97 (vector-ref e-94 1))) (let ((e-98 (vector-ref e-94 2))) (let ((e-99 (vector-ref e-94 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-2 e-5 arg-5 arg-6 arg-7 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--fx (vector 2 e-89 e-90 e-91))) (let ((u--fy (vector 2 e-97 e-98 e-99))) (cond ((equal? e-6 1) (lambda (eta-2) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-55 u--fx e-57 e-93 u--fy e-95))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-85 (vector-ref arg-7 1))) (let ((e-86 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 3))) (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-55 e-56 e-57 e-85 e-86 e-87)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc6 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc6 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc8 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc8 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc7 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc7 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc7 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc7 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-85 (vector-ref arg-7 1))) (let ((e-86 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 3))) (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-55 e-56 e-57 e-85 e-86 e-87)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc5 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc5 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc7 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc7 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-85 (vector-ref arg-7 1))) (let ((e-86 (vector-ref arg-7 2))) (let ((e-87 (vector-ref arg-7 3))) (CoreC-45Unify-unifyBothApps arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-55 e-56 e-57 e-85 e-86 e-87)))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc4 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc4 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc6 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc6 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))))))))(else (case (vector-ref arg-7 0) ((9) (let ((e-25 (vector-ref arg-7 2))) (case (vector-ref e-25 0) ((2) (let ((e-27 (vector-ref e-25 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-27)))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc3 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc5 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc5 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))(else (case (vector-ref arg-6 0) ((9) (let ((e-16 (vector-ref arg-6 2))) (case (vector-ref e-16 0) ((2) (let ((e-22 (vector-ref e-16 1))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22 arg-7)))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc2 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc2 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc4 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc4 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 e-18 e-19 e-20 arg-7)))))(else (case (vector-ref arg-7 0) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((sc1 (CoreC-45Unify-u--C-47C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc1 1) (CoreC-45Unify-unifyApp arg-0 arg-1 arg-2 1 arg-3 arg-4 arg-5 e-6 e-7 e-8 arg-6)) (else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Unify if Eq due to something with app") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 1 arg-4 arg-3 arg-5 arg-6 (vector 1 e-6 e-7 e-8) eta-0)))))))))))) ((4) (let ((e-13 (vector-ref arg-7 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13)))(else (case (vector-ref arg-6 0) ((4) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45Unify-unifyNoEta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 arg-7)))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "unify.noeta" 10 (lambda () "Nothing else worked, unifyIfEq") eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Unify-unifyIfEq arg-0 arg-1 arg-2 (let ((sc3 (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-6))) (cond ((equal? sc3 1) 1) (else (CoreC-45Unify-n--14952-25783-u--isDelay arg-2 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 arg-0 arg-7)))) arg-4 arg-3 arg-5 arg-6 arg-7 eta-2))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))))))))
(define CoreC-45Unify-u--unifyD_Unify_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (case (vector-ref arg-7 0) ((0) (let ((e-21 (vector-ref arg-7 1))) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (let ((e-24 (vector-ref arg-7 4))) (CoreC-45Unify-unifyBothBinders arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 e-11 e-12 e-13 e-14 e-21 e-22 e-23 e-24))))))(else (case (vector-ref e-13 0) ((0) (let ((e-16 (vector-ref e-13 1))) (let ((e-17 (vector-ref e-13 2))) (let ((e-18 (vector-ref e-13 3))) (let ((e-19 (vector-ref e-13 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "EtaR") arg-5 arg-6 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "...with") arg-5 arg-7 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((u--tmx (vector 0 e-11 e-12 (vector 0 e-16 e-17 e-18 e-19) e-14))) (let ((sc5 (CoreC-45Unify-isHoleApp arg-7))) (cond ((equal? sc5 1) (let ((act-4 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-5 arg-5 u--tmx arg-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (cond ((equal? e-8 1) (lambda (eta-2) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 u--tmx arg-7))))) eff-0) eta-1)))))) (else (let ((act-4 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-8 arg-5 e-19 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-8 arg-5 arg-7 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (vector 3 e-11 e-12 (vector 0 e-16 e-17 (vector 1 ) e-9) (vector 4 e-11 (let ((sc9 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc9))) (((e-1 'erased) 'erased) e-10))) (vector 0 e-11 '() 0)))))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "Expand") arg-5 e-10 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) u--tmx) e-10) eta-4))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))))))))) eff-0) eta-0)))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "EtaL") arg-5 arg-6 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((act-3 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "...with") arg-5 arg-7 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((u--tmy (vector 0 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) e-4))) (let ((sc6 (CoreC-45Unify-isHoleApp arg-6))) (cond ((equal? sc6 1) (let ((act-4 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-5 arg-5 arg-6 u--tmy eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (cond ((equal? e-16 1) (lambda (eta-2) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 arg-6 u--tmy))))) eff-0) eta-1)))))) (else (let ((act-4 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-16 arg-5 e-9 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-16 arg-5 arg-6 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-18 (vector-ref act-6 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (vector 3 e-1 e-2 (vector 0 e-6 e-7 (vector 1 ) e-17) (vector 4 e-1 (let ((sc10 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-20 (car sc10))) (((e-20 'erased) 'erased) e-18))) (vector 0 e-1 '() 0)))))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-18 (vector-ref act-6 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "Expand") arg-5 e-18 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-19 (vector-ref act-7 1))) (vector 0 e-19))) (else (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-18) u--tmy) eta-4))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))))))))) eff-0) eta-0)))))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7))))))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "EtaL") arg-5 arg-6 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((act-3 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "...with") arg-5 arg-7 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((u--tmy (vector 0 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) e-4))) (let ((sc5 (CoreC-45Unify-isHoleApp arg-6))) (cond ((equal? sc5 1) (let ((act-4 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-5 arg-5 arg-6 u--tmy eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (cond ((equal? e-12 1) (lambda (eta-2) (vector 1 CoreC-45Unify-success))) (else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 (CoreC-45Unify-lower arg-3) arg-4 arg-5 arg-6 u--tmy))))) eff-0) eta-1)))))) (else (let ((act-4 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-12 arg-5 e-9 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-12 arg-5 arg-6 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 (vector 3 e-1 e-2 (vector 0 e-6 e-7 (vector 1 ) e-13) (vector 4 e-1 (let ((sc9 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-16 (car sc9))) (((e-16 'erased) 'erased) e-14))) (vector 0 e-1 '() 0)))))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45Normalise-logNF arg-0 arg-1 "unify" 10 (lambda () "Expand") arg-5 e-14 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-14) u--tmy) eta-4))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))))))))) eff-0) eta-0)))))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7))))))))(else (CoreC-45Unify-unifyNoEta arg-1 arg-2 arg-0 arg-3 arg-4 arg-5 arg-6 arg-7)))))))
(define CoreC-45Unify-u--unifyWithLazyD_Unify_NF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((5) (let ((e-5 (vector-ref arg-6 1))) (let ((e-6 (vector-ref arg-6 2))) (let ((e-7 (vector-ref arg-6 3))) (case (vector-ref arg-7 0) ((5) (let ((e-11 (vector-ref arg-7 3))) ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-7) e-11)))(else (let ((u--x (vector 5 e-5 e-6 e-7))) (lambda (clam-0) (let ((sc1 (let ((sc2 (CoreC-45Unify-isHoleApp arg-7))) (cond ((equal? sc2 1) (let ((sc3 (CoreC-45Unify-u--C-61C-61_Eq_UnifyMode (let ((e-1 (cdr arg-3))) e-1) 2))) (cond ((equal? sc3 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc1 1) (CoreC-45Unify-postpone arg-0 arg-1 arg-2 arg-4 arg-3 "Postponing in lazy" arg-5 u--x arg-7 clam-0)) (else (let ((act-1 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) e-7) arg-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (vector e-0 e-1 e-2 (vector 1 e-6))))))))) eff-0) clam-0))))))))))))))))(else (case (vector-ref arg-7 0) ((5) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 (CoreC-45Unify-lower arg-3) arg-4) arg-5) arg-6) e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (let ((e-0 (vector-ref e-5 0))) (let ((e-7 (vector-ref e-5 1))) (let ((e-6 (vector-ref e-5 2))) (vector e-0 e-7 e-6 (vector 2 e-2))))))))) eff-0) eta-0)))))))))(else ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-3 arg-4) arg-5) arg-6) arg-7)))))))
(define csegen-2479 (lambda () (cons (lambda (u--vars) (lambda (arg-13788) (lambda (arg-13793) (lambda (arg-13798) (lambda (arg-13801) (lambda (arg-13804) (lambda (arg-13808) (lambda (arg-13814) (CoreC-45Unify-u--unifyD_Unify_NF u--vars arg-13788 arg-13793 arg-13798 arg-13801 arg-13804 arg-13808 arg-13814))))))))) (lambda (u--vars) (lambda (arg-13830) (lambda (arg-13835) (lambda (arg-13840) (lambda (arg-13843) (lambda (arg-13846) (lambda (arg-13850) (lambda (arg-13853) (CoreC-45Unify-u--unifyWithLazyD_Unify_NF u--vars arg-13830 arg-13835 arg-13840 arg-13843 arg-13846 arg-13850 arg-13853))))))))))))
(define CoreC-45Unify-u--unifyD_Unify_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (clam-0) (let ((sc2 (CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-6 arg-7))) (cond ((equal? sc2 1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "unify.equal" 10 (lambda () (string-append "Skipped unification (equal already): " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-6) (string-append " and " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-7))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 CoreC-45Unify-success))))) (else (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-6) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 arg-3 arg-4) arg-5) e-7) e-8))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))) eff-0) eta-0))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-unifyWithLazy (lambda (arg-1 arg-2 arg-3 arg-4 ext-1 ext-0) (lambda (clam-0) (let ((e-2 (cdr arg-1))) (lambda (arg-5) (lambda (arg-6) ((((((((e-2 arg-2) arg-3) arg-4) ext-1) ext-0) clam-0) arg-5) arg-6)))))))
(define CoreC-45Unify-u--unifyWithLazyD_Unify_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (clam-0) (let ((sc2 (CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-6 arg-7))) (cond ((equal? sc2 1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "unify.equal" 10 (lambda () (string-append "Skipped unification (equal already): " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-6) (string-append " and " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-7))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 CoreC-45Unify-success))))) (else (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-6) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 ((((CoreC-45Unify-unifyWithLazy (csegen-2479) arg-0 arg-1 arg-2 arg-3 arg-4) arg-5) e-7) e-8))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))) eff-0) eta-0))))))) eff-0) ext-0)))))))
(define csegen-2476 (lambda () (cons (lambda (u--vars) (lambda (arg-13788) (lambda (arg-13793) (lambda (arg-13798) (lambda (arg-13801) (lambda (arg-13804) (lambda (arg-13808) (lambda (arg-13814) (lambda (eta-0) (CoreC-45Unify-u--unifyD_Unify_Term u--vars arg-13788 arg-13793 arg-13798 arg-13801 arg-13804 arg-13808 arg-13814 eta-0)))))))))) (lambda (u--vars) (lambda (arg-13830) (lambda (arg-13835) (lambda (arg-13840) (lambda (arg-13843) (lambda (arg-13846) (lambda (arg-13850) (lambda (arg-13853) (lambda (eta-0) (CoreC-45Unify-u--unifyWithLazyD_Unify_Term u--vars arg-13830 arg-13835 arg-13840 arg-13843 arg-13846 arg-13850 arg-13853 eta-0)))))))))))))
(define csegen-2498 (lambda (eta-0) (box (vector 7 0 (CoreC-45ContextC-45Context-holeInit 0)))))
(define csegen-2536 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-22 csegen-22 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-22 csegen-22 arg-686 arg-689)))))
(define csegen-2540 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (lambda (eta-1) (cons e-5 eta-1))))))))
(define DataC-45Maybe-isJust (lambda (arg-1) (if (null? arg-1) 0 1)))
(define LibrariesC-45DataC-45SortedMap-treeLookup (lambda (arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (let ((sc1 (let ((e-1 (vector-ref arg-4 0))) (let ((e-12 (car e-1))) ((e-12 arg-5) e-3))))) (cond ((equal? sc1 1) (box e-4)) (else '())))))) ((1) (let ((e-9 (vector-ref arg-6 1))) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-10)))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-9)) (else (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-11)))))))) (else (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (let ((sc1 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-17)))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-16)) (else (let ((sc2 (let ((e-5 (vector-ref arg-4 4))) ((e-5 arg-5) e-19)))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-18)) (else (LibrariesC-45DataC-45SortedMap-treeLookup arg-4 arg-5 e-20))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-lookup (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) '()) (else (let ((e-5 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 3))) (LibrariesC-45DataC-45SortedMap-treeLookup e-5 arg-2 e-7)))))))
(define LibrariesC-45DataC-45SortedSet-contains (lambda (arg-1 arg-2) (DataC-45Maybe-isJust (LibrariesC-45DataC-45SortedMap-lookup arg-1 arg-2))))
(define csegen-2543 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-contains eta-0 eta-1))))
(define PreludeC-45Types-u--C-60C-61_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define PreludeC-45Types-u--C-60_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define PreludeC-45Types-u--C-62C-61_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 0)))
(define PreludeC-45Types-u--C-62_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3) 2)))
(define PreludeC-45Types-u--max_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-62_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define PreludeC-45Types-u--min_Ord_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_C-40ListC-32C-36aC-41 arg-1 arg-2 arg-3))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define csegen-2555 (LibrariesC-45DataC-45SortedSet-empty (vector csegen-2546 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45Types-u--compare_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45Types-u--C-60_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45Types-u--C-62_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45Types-u--C-60C-61_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45Types-u--C-62C-61_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45Types-u--max_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45Types-u--min_Ord_C-40ListC-32C-36aC-41 csegen-519 arg-1626 arg-1629))))))
(define LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 (lambda (arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (arg-5 (cons e-3 e-4))))) ((1) (let ((e-9 (vector-ref arg-6 1))) (let ((e-11 (vector-ref arg-6 3))) (LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 arg-5 e-11))) e-9)))) (else (let ((e-16 (vector-ref arg-6 1))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-20 (vector-ref arg-6 5))) (LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 (lambda (arg-1) (cons arg-1 (LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 arg-5 e-20))) e-18))) e-16))))))))
(define LibrariesC-45DataC-45SortedMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-n--6604-4348-u--treeToListC-39 (lambda (arg-0) (cons arg-0 '())) ext-0)))
(define LibrariesC-45DataC-45SortedMap-toList (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) (else (let ((e-7 (vector-ref arg-2 3))) (LibrariesC-45DataC-45SortedMap-treeToList e-7))))))
(define LibrariesC-45DataC-45SortedMap-keys (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45DataC-45SortedMap-toList ext-0))))
(define LibrariesC-45DataC-45SortedSet-toList (lambda (arg-1) (LibrariesC-45DataC-45SortedMap-keys arg-1)))
(define LibrariesC-45DataC-45SortedSet-u--foldr_Foldable_SortedSet (lambda (arg-2 arg-3 arg-4) (PreludeC-45Types-u--foldr_Foldable_List arg-2 arg-3 (LibrariesC-45DataC-45SortedSet-toList arg-4))))
(define LibrariesC-45DataC-45SortedSet-union (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedSet-u--foldr_Foldable_SortedSet csegen-846 arg-1 arg-2)))
(define LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45SortedSet-union ext-0 ext-1)))
(define LibrariesC-45DataC-45SortedSet-u--neutral_Monoid_C-40SortedSetC-32C-36kC-41 (lambda (arg-1) (LibrariesC-45DataC-45SortedSet-empty arg-1)))
(define csegen-2558 (cons (lambda (arg-8474) (lambda (arg-8477) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 arg-8474 arg-8477))) (LibrariesC-45DataC-45SortedSet-u--neutral_Monoid_C-40SortedSetC-32C-36kC-41 csegen-861)))
(define csegen-2566 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 csegen-65 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40ImpDeclC-39C-32C-36nmC-41 csegen-65 u--d u--x)))))
(define csegen-2567 (cons csegen-2382 csegen-930))
(define csegen-2568 (let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 ))))) eff-0))
(define TTImpC-45ElabC-45Check-u--show_Show_C-40ImplBindingC-32C-36varsC-41 (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-0 u--d u--x)))) (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-0 u--d u--x))))) (cons e-3 e-4)))))) (else (let ((e-5 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (string-append (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-5 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-5 u--d u--x)))) (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-5 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-5 u--d u--x))))) (cons e-8 e-9)) (string-append "@" (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-5 e-8))))))))))
(define TTImpC-45ElabC-45Check-u--showPrec_Show_C-40ImplBindingC-32C-36varsC-41 (lambda (arg-1 arg-2) (TTImpC-45ElabC-45Check-u--show_Show_C-40ImplBindingC-32C-36varsC-41 arg-2)))
(define csegen-2572 (cons csegen-65 (cons (lambda (u--x) (TTImpC-45ElabC-45Check-u--show_Show_C-40ImplBindingC-32C-36varsC-41 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45ElabC-45Check-u--showPrec_Show_C-40ImplBindingC-32C-36varsC-41 u--d u--x))))))
(define csegen-2575 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2572 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2572 u--d u--x)))))
(define csegen-2578 (vector 1 (cons (vector 3 (vector 2 "Coverage check")) '())))
(define CoreC-45Context-u--full_HasNames_Clause (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45Context-u--full_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector e-0 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define CoreC-45Context-u--resolved_HasNames_Clause (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (vector 1 (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (vector e-0 eta-3 eta-4 eta-5)))))) (lambda (eta-2) (CoreC-45Context-u--resolved_HasNames_C-40C-40EnvC-32TermC-41C-32C-36varsC-41 arg-0 e-1 eta-2)) eta-1)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-2) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-3) ext-0)))))))
(define csegen-2583 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Clause arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Clause arg-7729 arg-7732 eta-0))))))
(define csegen-2591 (cons csegen-972 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2489 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-2489 u--d u--x))))))
(define csegen-2595 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2591 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2591 u--d u--x))))))
(define TTImpC-45ElabC-45App-isBindAllExpPattern (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) 1)(else 0))))(else 0))))
(define csegen-2599 (lambda (eta-0) (let ((sc0 (TTImpC-45ElabC-45App-isBindAllExpPattern (Builtin-fst eta-0)))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45UnifyState-u--C-61C-61_Eq_DelayReason (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0))) ((equal? arg-0 4) (cond ((equal? arg-1 4) 1)(else 0)))(else 0))))
(define csegen-2602 (lambda (arg-0) (CoreC-45UnifyState-u--C-61C-61_Eq_DelayReason arg-0 0)))
(define csegen-2603 (lambda (eta-0) (CoreC-45Name-u--show_Show_Name (Builtin-fst eta-0))))
(define csegen-2605 (cons csegen-1024 csegen-835))
(define csegen-2608 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2605 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2605 u--d u--x)))))
(define csegen-2610 (lambda (eta-0) (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 eta-0)))
(define CoreC-45LinearCheck-u--show_Show_ArgUsage (lambda (arg-0) (cond ((equal? arg-0 0) "any") ((equal? arg-0 1) "0") ((equal? arg-0 2) "1") ((equal? arg-0 3) "keep") (else "unknown"))))
(define CoreC-45LinearCheck-u--showPrec_Show_ArgUsage (lambda (arg-0 arg-1) (CoreC-45LinearCheck-u--show_Show_ArgUsage arg-1)))
(define csegen-2612 (cons (lambda (u--x) (CoreC-45LinearCheck-u--show_Show_ArgUsage u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45LinearCheck-u--showPrec_Show_ArgUsage u--d u--x)))))
(define csegen-2613 (cons csegen-65 csegen-2612))
(define csegen-2617 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen: names don't match in pattern type") eta-0)))
(define CoreC-45ContextC-45Context-u--show_Show_Clause (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-0) (string-append ": " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-0 e-2) (string-append " = " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-0 e-3))))))))))
(define CoreC-45ContextC-45Context-u--showPrec_Show_Clause (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_Clause arg-1)))
(define csegen-2619 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_Clause u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_Clause u--d u--x)))))
(define csegen-2622 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_C-40CaseTreeC-32C-36varsC-41 arg-7729 arg-7732 eta-0))))))
(define csegen-2623 (cons csegen-838 csegen-65))
(define csegen-2626 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2623 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2623 u--d u--x)))))
(define csegen-2629 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-2626 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-2626 u--d u--x)))))
(define PreludeC-45Types-u--join_Monad_Maybe (lambda (arg-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe arg-1 (lambda (eta-0) eta-0))))
(define csegen-2648 (vector csegen-255 (lambda (u--b) (lambda (u--a) (lambda (arg-10411) (lambda (arg-10414) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe arg-10411 arg-10414))))) (lambda (u--a) (lambda (arg-10425) (PreludeC-45Types-u--join_Monad_Maybe arg-10425)))))
(define csegen-2652 (cons csegen-65 csegen-849))
(define csegen-2656 (cons csegen-493 csegen-835))
(define csegen-2659 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2656 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2656 u--d u--x)))))
(define csegen-2660 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 '())))))
(define csegen-2663 (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (u--func arg-8885))))))
(define csegen-2671 (vector (vector csegen-2663 (lambda (u--a) (lambda (arg-9931) arg-9931)) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (arg-9937 arg-9944)))))) (lambda (u--b) (lambda (u--a) (lambda (arg-10411) (lambda (arg-10414) (arg-10414 arg-10411))))) (lambda (u--a) (lambda (arg-10425) arg-10425))))
(define csegen-2675 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (eta-2 eta-3))))))
(define ControlC-45MonadC-45StateC-45State-u--C-60C-42C-62_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (arg-5 ext-0)) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) (let ((e-7 (vector-ref arg-4 1))) ((((e-7 'erased) 'erased) (arg-6 e-5)) (lambda (_-1) (let ((e-10 (car _-1))) (let ((e-9 (cdr _-1))) (let ((e-13 (vector-ref arg-4 0))) (let ((e-15 (vector-ref e-13 1))) ((e-15 'erased) (cons e-10 (e-4 e-9)))))))))))))))))
(define ControlC-45MonadC-45StateC-45State-u--map_Functor_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (lambda (arg-4 arg-5 arg-6 ext-0) ((((arg-4 'erased) 'erased) (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-2 (arg-5 e-3)))))) (arg-6 ext-0))))
(define ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 (lambda (arg-3 arg-4 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) (cons ext-0 arg-4))))))
(define csegen-2684 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--map_Functor_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2663 u--func arg-8885 eta-0)))))) (lambda (u--a) (lambda (arg-9931) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 arg-9931 eta-0)))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-60C-42C-62_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 arg-9937 arg-9944 eta-0))))))))
(define csegen-2686 (cons csegen-493 csegen-493))
(define csegen-2689 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2686 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2686 u--d u--x)))))
(define CoreC-45TT-u--show_Show_TotalReq (lambda (arg-0) (cond ((equal? arg-0 0) "total") ((equal? arg-0 1) "covering") (else "partial"))))
(define CoreC-45ContextC-45Context-u--show_Show_DefFlag (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "inline") ((1) "noinline") ((2) "deprecate") ((3) "invertible") ((4) "overloadable") ((5) "tcinline") ((6) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45TT-u--show_Show_TotalReq e-0))) ((7) "blockedhint") ((8) "macro") ((9) "partialeval") ((10) "allguarded") ((11) (let ((e-2 (vector-ref arg-0 1))) (string-append "contype " (CoreC-45CompileExpr-u--show_Show_ConInfo e-2)))) (else (let ((e-3 (vector-ref arg-0 1))) (string-append "identity " (PreludeC-45Show-u--show_Show_Nat e-3)))))))
(define CoreC-45ContextC-45Context-u--showPrec_Show_DefFlag (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_DefFlag arg-1)))
(define csegen-2699 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_DefFlag u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_DefFlag u--d u--x)))))
(define csegen-2703 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-835 u--d u--x)))))
(define csegen-2704 (cons csegen-65 csegen-835))
(define csegen-2707 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2704 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2704 u--d u--x)))))
(define csegen-2710 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2707 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-2707 u--d u--x)))))
(define csegen-2711 (cons csegen-2703 csegen-2710))
(define csegen-2715 (cons csegen-2703 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2711 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2711 u--d u--x))))))
(define csegen-2720 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ""))
(define csegen-2721 (vector 1 csegen-2720))
(define csegen-2724 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ":"))))
(define csegen-2726 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 eta-0)))
(define csegen-2728 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Delay")))
(define csegen-2729 (IdrisC-45PrettyC-45Annotations-keyword csegen-505))
(define IdrisC-45PrettyC-45Annotations-equals (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "=")))
(define csegen-2730 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-equals LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))
(define csegen-2731 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-arrow LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline))
(define CoreC-45Name-u--prettyPrec_Pretty_Void_UserName (lambda (arg-0 arg-1) (CoreC-45Name-u--pretty_Pretty_Void_UserName arg-1)))
(define csegen-2733 (cons (lambda (arg-11067) (CoreC-45Name-u--pretty_Pretty_Void_UserName arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45Name-u--prettyPrec_Pretty_Void_UserName arg-11073 arg-11076)))))
(define IdrisC-45PrettyC-45Annotations-fatArrow (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "=>")))
(define csegen-2735 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-langle (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\<))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rangle (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\>))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-langle LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rangle ext-0)))
(define csegen-2739 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "definitions")))))
(define csegen-2755 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "|]")))
(define CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_Void_Namespace (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_Namespace arg-1)))
(define csegen-2757 (cons (lambda (arg-11067) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_Namespace arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_Void_Namespace arg-11073 arg-11076)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-column (lambda (ext-0) (vector 8 ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (vector 6 arg-1 arg-2)))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nesting (lambda (ext-0) (vector 10 ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-column (lambda (u--k) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nesting (lambda (u--i) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest (bs- u--k u--i 63) arg-1)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (lambda (ext-0) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate eta-0 eta-1)))) ext-0)))
(define IdrisC-45Pretty-appPrec (vector 6 ))
(define IdrisC-45PrettyC-45Annotations-auto_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "auto")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-backslash (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\\))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (lambda (arg-1 arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose arg-1 arg-2 ext-0)))
(define AlgebraC-45Semiring-isRigOther (lambda (arg-1 ext-0) (AlgebraC-45Semiring-elimSemi arg-1 0 0 (lambda (eta-0) 1) ext-0)))
(define AlgebraC-45Semiring-branchVal (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (AlgebraC-45Semiring-isRigOther arg-2 arg-5))) (cond ((equal? sc0 1) (arg-3)) (else (arg-4))))))
(define IdrisC-45PrettyC-45Annotations-case_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "case")))
(define IdrisC-45PrettyC-45Annotations-default_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "default")))
(define IdrisC-45PrettyC-45Annotations-do_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "do")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-1 1))) (vector 1 e-2))) ((2) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (vector 2 e-4 e-5)))) ((3) (vector 0 )) ((4) (let ((e-9 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-9)))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-12))))) ((6) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (vector 6 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-15))))) ((7) (let ((e-17 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-17)))) ((8) (let ((e-20 (vector-ref arg-1 1))) (vector 8 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-20 u--x)))))) ((9) (let ((e-22 (vector-ref arg-1 1))) (vector 9 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-22 u--x)))))) ((10) (let ((e-24 (vector-ref arg-1 1))) (vector 10 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-24 u--x)))))) (else (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (vector 11 e-26 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten e-27))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--map_Functor_FlattenResult (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (vector 0 (arg-2 e-1)))) ((1) (vector 1 )) (else (vector 2 )))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--changesUponFlattening-10012 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((2) (vector 2 ))(else (case (vector-ref e-3 0) ((2) (vector 2 ))(else (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((0) (let ((e-8 (vector-ref e-3 1))) (vector 0 (vector 5 e-5 e-8)))) (else (vector 0 (vector 5 e-5 arg-1)))))) (else (case (vector-ref e-3 0) ((0) (let ((e-11 (vector-ref e-3 1))) (vector 0 (vector 5 arg-2 e-11)))) (else (vector 1 )))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (vector 1 )) ((1) (vector 1 )) ((2) (vector 1 )) ((3) (vector 2 )) ((4) (let ((e-9 (vector-ref arg-1 2))) (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-9))))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-case--changesUponFlattening-10012 e-12 e-11 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-12)))))) ((6) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--map_Functor_FlattenResult (lambda (eta-0) (vector 6 e-14 eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-15))))) ((7) (let ((e-17 (vector-ref arg-1 1))) (vector 0 (e-17)))) ((8) (let ((e-20 (vector-ref arg-1 1))) (vector 0 (vector 8 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-20 eta-0))))))) ((9) (let ((e-22 (vector-ref arg-1 1))) (vector 0 (vector 9 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-22 eta-0))))))) ((10) (let ((e-24 (vector-ref arg-1 1))) (vector 0 (vector 10 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatten (e-24 eta-0))))))) (else (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--map_Functor_FlattenResult (lambda (eta-0) (vector 11 e-26 eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening e-27))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (lambda (arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (vector 7 e-1 e-2)))) ((4) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening (e-5)))) (case (vector-ref sc1 0) ((0) (let ((e-1 (vector-ref sc1 1))) (vector 7 (lambda () e-1) e-4))) ((1) (vector 7 e-5 e-4)) (else (e-4)))))))(else (let ((sc0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-changesUponFlattening arg-1))) (case (vector-ref sc0 0) ((0) (let ((e-1 (vector-ref sc0 1))) (vector 7 (lambda () e-1) (lambda () arg-1)))) ((1) arg-1) (else arg-1)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest arg-1 arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline (vector 3 ))
(define IdrisC-45PrettyC-45Annotations-hole (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) ext-0)))
(define IdrisC-45PrettyC-45Annotations-in_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "in")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-replicateChar (lambda (arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-1 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (vector 0 )) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 (blodwen-toSignedInt 1 63)))) (cond ((equal? sc1 1) (vector 1 arg-2)) (else (vector 2 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textReplicateChar arg-1 arg-2))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (lambda (arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-replicateChar arg-1 #\ )))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces arg-1) arg-2))))
(define CoreC-45Name-isRF (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 e-2) e-3)))) (CoreC-45Name-isRF e-1))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref e-2 0) ((1) (let ((e-3 (vector-ref e-2 1))) (box (cons CoreC-45NameC-45Namespace-emptyNS e-3))))(else '()))))(else '()))))
(define CoreC-45Name-isUnderscoreName (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) 1)(else 0)))) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 "_") 1)(else 0))))(else 0))))
(define IdrisC-45Pretty-kindAnn (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe e-0 (lambda (u--cat) (box (case (vector-ref u--cat 0) ((0) (vector 4 )) ((1) (vector 3 e-1)) ((2) (vector 2 (box e-1))) (else (vector 1 (box e-1)))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\[))
(define IdrisC-45PrettyC-45Annotations-lcurly csegen-943)
(define IdrisC-45Pretty-leftAppPrec (vector 0 ))
(define IdrisC-45PrettyC-45Annotations-let_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "let")))
(define IdrisC-45PrettyC-45Annotations-of_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "of")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\|))
(define IdrisC-45PrettyC-45Annotations-pragma (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 ) ext-0)))
(define IdrisC-45PrettyC-45Annotations-impossible_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "impossible")))
(define IdrisC-45PrettyC-45Annotations-semi csegen-921)
(define csegen-2779 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe))
(define csegen-2781 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with alts not possible"))))
(define IdrisC-45Pretty-prettyAlt (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2779 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-fatArrow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-3) IdrisC-45PrettyC-45Annotations-semi))))))) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2779 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2781 IdrisC-45PrettyC-45Annotations-semi))) (else (let ((e-13 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2779 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-impossible_ IdrisC-45PrettyC-45Annotations-semi))))))))
(define IdrisC-45Pretty-prettyBinder (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-lineC-39 (vector 4 (lambda () (vector 3 )) (lambda () (vector 0 ))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-lineC-39) u--y))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-cat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-encloseSep (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 arg-2) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 e-2) arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-cat (DataC-45List-u--zipWith_Zippable_List csegen-717 (cons arg-1 (DataC-45List-replicateTR '() (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-4) 1)) arg-3)) arg-4)) arg-2)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda (ext-0 ext-1) (vector 4 ext-0 ext-1)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-list (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-encloseSep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 "[ ")) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 "["))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-flatAlt (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 " ]")) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 "]"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 ", ") ext-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyList (lambda (arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-list (PreludeC-45TypesC-45List-mapAppend '() (lambda (clam-0) (let ((e-2 (car arg-2))) (e-2 clam-0))) ext-0)))))
(define CoreC-45Name-isOpName (lambda (ext-0) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (CoreC-45Name-isOpUserName eta-0))) (CoreC-45Name-userNameRoot ext-0))))
(define IdrisC-45Pretty-prettyOp (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((u--op (vector e-0 e-1 e-2))) (let ((sc0 (CoreC-45Name-isOpName e-2))) (cond ((equal? sc0 1) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (IdrisC-45Pretty-kindAnn u--op)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (vector 1 #\`) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (IdrisC-45Pretty-kindAnn u--op)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2))) (vector 1 #\`)))))))))))
(define IdrisC-45Pretty-prettyPClause (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-fatArrow (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-3)))))) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2779 csegen-2781)) (else (let ((e-13 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-13) IdrisC-45PrettyC-45Annotations-impossible_))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (vector 0 ))
(define IdrisC-45PrettyC-45Annotations-prettyRig (lambda (ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 csegen-934 csegen-937 (lambda (eta-0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) ext-0)))
(define IdrisC-45PrettyC-45Annotations-rewrite_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "rewrite")))
(define csegen-2777 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "<-")))
(define IdrisC-45Pretty-prettyPDo (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-2))) ((1) (let ((e-6 (vector-ref arg-0 3))) (let ((e-7 (vector-ref arg-0 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2777 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-7)))))) ((2) (let ((e-10 (vector-ref arg-0 2))) (let ((e-11 (vector-ref arg-0 3))) (let ((e-12 (vector-ref arg-0 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2777 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyAlt eta-0)) e-12)))))))))) ((3) (let ((e-16 (vector-ref arg-0 3))) (let ((e-17 (vector-ref arg-0 4))) (let ((e-19 (vector-ref arg-0 6))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-17) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-16)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-19)))))))) ((4) (let ((e-22 (vector-ref arg-0 2))) (let ((e-24 (vector-ref arg-0 4))) (let ((e-25 (vector-ref arg-0 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-22) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-24) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fillSep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyAlt eta-0)) e-25))))))))))) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ csegen-2739)) (else (let ((e-31 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-rewrite_ (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-31)))))))
(define IdrisC-45Pretty-prettyFieldPath (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround csegen-960 eta-0 eta-1))) (PreludeC-45TypesC-45List-mapAppend '() csegen-753 arg-0))))
(define IdrisC-45Pretty-prettyPFieldUpdate (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyFieldPath e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-2)))))) (else (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyFieldPath e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "$=")) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-5)))))))))
(define IdrisC-45Pretty-prettyPStr (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-2))) (else (let ((e-5 (vector-ref arg-0 2))) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-5))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (cons e-2 '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-2 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate arg-1 e-3))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\]))
(define IdrisC-45PrettyC-45Annotations-rcurly csegen-927)
(define IdrisC-45PrettyC-45Annotations-record_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "record")))
(define IdrisC-45Pretty-startPrec (vector 0 ))
(define DataC-45List-unconsC-39 (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (box (cons e-2 e-3)))))))
(define DataC-45List-tailC-39 (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-unconsC-39 ext-0))))
(define IdrisC-45PrettyC-45Annotations-with_ (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "with")))
(define PreludeC-45Types-u--rangeFromTo_Range_Nat (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--compare_Ord_Integer arg-0 arg-1))) (cond ((equal? sc0 0) (PreludeC-45Types-takeUntil (lambda (arg-2) (PreludeC-45Types-u--C-62C-61_Ord_Nat arg-2 arg-1)) (PreludeC-45Types-countFrom arg-0 (lambda (eta-0) (+ eta-0 1))))) ((equal? sc0 1) (PreludeC-45Types-u--pure_Applicative_List arg-0)) (else (PreludeC-45Types-takeUntil (lambda (arg-2) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-2 arg-1)) (PreludeC-45Types-countFrom arg-0 (lambda (u--n) (PreludeC-45Types-prim__integerToNat (- u--n 1))))))))))
(define IdrisC-45Pretty-n--10844-5689-u--continuation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm arg-3)))
(define IdrisC-45Pretty-n--10844-7041-u--deGuard (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-2 0) ((7) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((e-6 (vector-ref e-2 3))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((u--tm (vector 0 e-1 (vector 7 e-4 (vector 0 e-8 e-9) e-6)))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-3 (vector-ref e-9 2))) e-3)) (vector 1 (vector 0 "guard"))))) (cond ((equal? sc3 1) (vector 0 e-1 e-6)) (else u--tm)))))))(else arg-4))))))(else arg-4)))))(else arg-4))))
(define IdrisC-45Pretty-n--10844-7042-u--dePure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((7) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((u--tm (vector 7 e-1 (vector 0 e-5 e-6) e-3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-4 (vector-ref e-6 2))) e-4)) (vector 1 (vector 0 "pure"))))) (cond ((equal? sc2 1) e-3) (else u--tm)))))))(else arg-4))))))(else arg-4))))
(define IdrisC-45Pretty-n--10844-5690-u--fullLet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-7 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig arg-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm arg-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2730 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm arg-4)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) IdrisC-45PrettyC-45Annotations-in_) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (IdrisC-45Pretty-n--10844-5689-u--continuation arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))))))))
(define IdrisC-45Pretty-n--10844-5448-u--getLamNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((2) (let ((e-2 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (IdrisC-45Pretty-n--10844-5448-u--getLamNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-2 (cons e-4 e-5)) arg-7) e-6))))))(else (cons (PreludeC-45TypesC-45List-reverse arg-7) arg-8)))))
(define IdrisC-45Pretty-n--10844-5691-u--getPRefName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-2 (vector-ref arg-8 2))) (box (let ((e-3 (vector-ref e-2 2))) e-3))))(else '()))))
(define IdrisC-45Pretty-n--10844-5449-u--prettyBindings (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((25) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-11))) (case (vector-ref e-11 0) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (IdrisC-45Pretty-n--10844-5449-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-11) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (IdrisC-45Pretty-n--10844-5449-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))))))))(else (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-11))) (case (vector-ref e-11 0) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (IdrisC-45Pretty-n--10844-5449-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-6) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-11) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (IdrisC-45Pretty-n--10844-5449-u--prettyBindings arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))))))))))
(define csegen-2763 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "**")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))
(define csegen-2772 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "..")))
(define csegen-2773 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 (Builtin-snd eta-0))))
(define IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) ((LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (IdrisC-45Pretty-kindAnn e-2)) (CoreC-45Name-prettyOp 0 (let ((e-3 (vector-ref e-2 2))) e-3))))) ((1) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (case (vector-ref e-6 0) ((1) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (AlgebraC-45Semiring-branchVal csegen-931 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-arrow (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) csegen-505) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))) e-5))) (let ((e-215 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-215)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))))))) ((0) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2733 (vector 2 ))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9))))) (let ((e-218 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-218)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))))))) ((2) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (AlgebraC-45Semiring-branchVal csegen-931 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2735 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-auto_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) csegen-505) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))) e-5))) (let ((e-221 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-auto_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-221)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))))))) (else (let ((e-212 (vector-ref e-6 1))) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-default_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-212) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) csegen-505) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9))))) (let ((e-224 (unbox e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-default_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-212) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-5) (IdrisC-45Pretty-prettyBinder e-224)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2731 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-9)))))))))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (let ((sc1 (IdrisC-45Pretty-n--10844-5448-u--getLamNames e-11 e-13 e-16 e-15 e-14 e-12 arg-0 (cons (cons e-12 (cons e-14 e-15)) '()) e-16))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-backslash (IdrisC-45Pretty-n--10844-5449-u--prettyBindings e-11 e-13 e-16 e-15 e-14 e-12 arg-0 e-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2735 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-3))))))))))))))) ((3) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (let ((e-22 (vector-ref arg-1 5))) (let ((e-23 (vector-ref arg-1 6))) (let ((e-24 (vector-ref arg-1 7))) (case (vector-ref e-21 0) ((25) (let ((e-226 (vector-ref e-21 1))) (DataC-45Maybe-fromMaybe (lambda () (IdrisC-45Pretty-n--10844-5690-u--fullLet e-18 e-226 e-24 e-23 e-22 e-20 e-19 arg-0)) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45Pretty-n--10844-5691-u--getPRefName e-18 e-226 e-24 e-23 e-22 e-20 e-19 arg-0 e-20) (lambda (u--nName) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45Pretty-n--10844-5691-u--getPRefName e-18 e-226 e-24 e-23 e-22 e-20 e-19 arg-0 e-22) (lambda (u--valName) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45Name-u--show_Show_Name u--nName) (CoreC-45Name-u--show_Show_Name u--valName))) (lambda (_-10649) (box (IdrisC-45Pretty-n--10844-5689-u--continuation e-18 e-226 e-24 e-23 e-22 e-20 e-19 arg-0)))))))) (lambda () (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45Pretty-n--10844-5691-u--getPRefName e-18 e-226 e-24 e-23 e-22 e-20 e-19 arg-0 e-20) (lambda (u--nName) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Name-isUnderscoreName u--nName)) (lambda (_-10649) (box (IdrisC-45Pretty-n--10844-5689-u--continuation e-18 e-226 e-24 e-23 e-22 e-20 e-19 arg-0)))))))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-prettyRig e-19) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-20)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-21) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2730 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-22)))))))) (if (null? e-24) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-in_ LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-softline) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyAlt eta-0)) e-24)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) IdrisC-45PrettyC-45Annotations-in_))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-23))))))))))))))))))) ((4) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-case_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-28) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-of_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (let ((u--punctuation (cons IdrisC-45PrettyC-45Annotations-lcurly (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) IdrisC-45PrettyC-45Annotations-semi) (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 (PreludeC-45Types-u--rangeFromTo_Range_Nat 1 (PreludeC-45TypesC-45List-lengthTR e-29)))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-u--zipWith_Zippable_List csegen-716 u--punctuation (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyPClause eta-0)) e-29)) (cons IdrisC-45PrettyC-45Annotations-rcurly '()))))))))))))) ((5) (let ((e-33 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2739 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) IdrisC-45PrettyC-45Annotations-in_) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-33)))))))) ((6) (let ((e-36 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-record_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyPFieldUpdate eta-0)) e-36))))))))) ((7) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (let ((u--catchall (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-leftAppPrec e-39) (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-40))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-0 IdrisC-45Pretty-appPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (case (vector-ref e-39 0) ((0) (let ((e-1 (vector-ref e-39 1))) (let ((e-2 (vector-ref e-39 2))) (let ((u--f (vector 0 e-1 e-2))) (let ((sc2 (DataC-45Maybe-isJust (CoreC-45Name-isRF (let ((e-3 (vector-ref e-2 2))) e-3))))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-leftAppPrec e-40) (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec u--f))) (else (u--catchall))))))))(else (u--catchall))))))))) ((8) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-43) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-44)))))) ((11) (let ((e-47 (vector-ref arg-1 2))) (let ((e-48 (vector-ref arg-1 3))) (cond ((equal? e-47 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Inf") (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-48))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Lazy") (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-48)))))))) ((12) (let ((e-51 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Delay") (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-51))))) ((13) (let ((e-54 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Force") (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-appPrec e-54))))) ((10) (let ((e-57 (vector-ref arg-1 2))) (let ((e-58 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-leftAppPrec e-57) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "@") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-58))))))))) ((9) (let ((e-61 (vector-ref arg-1 2))) (let ((e-62 (vector-ref arg-1 3))) (let ((e-63 (vector-ref arg-1 4))) (case (vector-ref e-63 0) ((0) (let ((e-229 (vector-ref e-63 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-62 (let ((e-2 (vector-ref e-229 2))) e-2)))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-leftAppPrec e-61) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-62)))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-leftAppPrec e-61) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-62) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 (let ((e-2 (vector-ref e-229 2))) e-2)))))))))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm IdrisC-45Pretty-leftAppPrec e-61) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-62) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-63))))))))))))) ((14) (IdrisC-45PrettyC-45Annotations-pragma (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "%search"))) ((16) (let ((e-69 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-69)))))) ((17) (let ((e-72 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-72)))))) ((18) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-angles (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "declaration"))))))) ((19) (let ((e-78 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "~") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-78)))))) ((20) (let ((e-81 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PrettyC-45Annotations-pragma (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "%runElab")) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-81))))) ((15) (let ((e-84 (vector-ref arg-1 2))) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant e-84))) ((21) (let ((e-88 (vector-ref arg-1 3))) (IdrisC-45PrettyC-45Annotations-hole (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (string-cons #\? e-88))))) ((22) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 '()) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Type"))) ((23) (let ((e-94 (vector-ref arg-1 3))) (let ((e-95 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-94) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "@")) (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-95))))) ((24) (let ((e-98 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-98)))) ((25) csegen-505) ((26) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "?"))) ((27) (let ((e-106 (vector-ref arg-1 3))) (let ((e-107 (vector-ref arg-1 4))) (let ((e-108 (vector-ref arg-1 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-0 (vector 6 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-107) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyOp e-106) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-108))))))))) ((28) (let ((e-112 (vector-ref arg-1 3))) (let ((e-113 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-prettyOp e-112) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-113)))))) ((29) (let ((e-117 (vector-ref arg-1 3))) (let ((e-118 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-prettyOp e-117) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-118)))))) ((30) (let ((e-122 (vector-ref arg-1 3))) (let ((e-123 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-122) (IdrisC-45Pretty-prettyOp e-123)))))) ((31) (let ((e-126 (vector-ref arg-1 2))) (let ((e-127 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm (vector 1 ) e-126) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm (vector 1 ) e-127))))))) ((32) (let ((e-130 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-130)))) ((33) (let ((e-134 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "++") (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyPStr eta-0)) e-134)))))) ((34) (let ((e-139 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "multiline") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "++") (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyPStr eta-0)) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-139)))))))) ((35) (let ((e-143 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-do_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate IdrisC-45PrettyC-45Annotations-semi (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyPDo eta-0)) e-143)))))))))) ((36) (let ((e-146 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "!") (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-146)))) ((37) (let ((e-149 (vector-ref arg-1 2))) (let ((e-150 (vector-ref arg-1 3))) (if (null? e-149) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "[|")) csegen-2755 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-150)) (let ((e-232 (unbox e-149))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2757 e-232) (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ".[|"))) csegen-2755 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-150))))))) ((38) (let ((e-154 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() (csegen-2760) e-154)))))))) ((39) (let ((e-158 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "[<") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() (csegen-2760) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-158 '()))))))))) ((40) (let ((e-161 (vector-ref arg-1 2))) (let ((e-162 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-161) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-162))))))) ((41) (let ((e-166 (vector-ref arg-1 3))) (let ((e-167 (vector-ref arg-1 4))) (let ((e-168 (vector-ref arg-1 5))) (case (vector-ref e-167 0) ((25) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-166) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2763 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-168))))))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-166) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-167) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2763 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-168))))))))))))) ((42) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "()")) ((43) (let ((e-173 (vector-ref arg-1 2))) (let ((e-174 (vector-ref arg-1 3))) (let ((e-175 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "if")) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-173)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "then")) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-174)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "else")) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-175)) '())))))))))))) ((44) (let ((e-177 (vector-ref arg-1 1))) (let ((e-178 (vector-ref arg-1 2))) (let ((e-179 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (IdrisC-45Pretty-n--10844-7042-u--dePure e-177 e-179 e-178 arg-0 e-178)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Pretty-prettyPDo (IdrisC-45Pretty-n--10844-7041-u--deGuard e-177 e-179 e-178 arg-0 eta-0))) e-179))))))))))) ((45) (let ((e-182 (vector-ref arg-1 2))) (let ((e-183 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-rewrite_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-182) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) IdrisC-45PrettyC-45Annotations-in_) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-183)))))))) ((46) (let ((e-186 (vector-ref arg-1 2))) (let ((e-187 (vector-ref arg-1 3))) (let ((e-188 (vector-ref arg-1 4))) (if (null? e-187) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-186) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2772 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-188)))) (let ((e-237 (unbox e-187))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-186) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-237) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2772 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-188))))))))))) ((47) (let ((e-191 (vector-ref arg-1 2))) (let ((e-192 (vector-ref arg-1 3))) (if (null? e-192) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-191) csegen-2772)) (let ((e-240 (unbox e-192))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-brackets LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-lbracket LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-rbracket (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-191) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-240) csegen-2772)))))))) ((50) (let ((e-196 (vector-ref arg-1 3))) (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-0 e-196))) ((48) (let ((e-199 (vector-ref arg-1 2))) (let ((e-200 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-199) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-510 (PreludeC-45TypesC-45List-mapAppend '() csegen-2773 e-200)))))))) ((49) (let ((e-203 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-510 (PreludeC-45TypesC-45List-mapAppend '() csegen-2773 e-203)))))) (else (let ((e-206 (vector-ref arg-1 2))) (let ((e-207 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 IdrisC-45Pretty-startPrec) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-with_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyList csegen-1260 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-206)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-207)))))))))))
(define IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (lambda (arg-0) (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm (vector 0 ) arg-0)))
(define csegen-2760 (lambda () (lambda (eta-0) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (Builtin-snd eta-0)))))
(define CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_ModuleIdent (lambda (ext-0) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_Namespace ext-0)))
(define CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_Void_ModuleIdent (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_ModuleIdent arg-1)))
(define csegen-2789 (cons (lambda (arg-11067) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_ModuleIdent arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45NameC-45Namespace-u--prettyPrec_Pretty_Void_ModuleIdent arg-11073 arg-11076)))))
(define csegen-2802 (LibrariesC-45DataC-45SortedSet-empty csegen-231))
(define csegen-2808 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Error compiling Delay pattern match") eta-0)))
(define csegen-2809 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-5)))))))
(define csegen-2812 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (vector eta-1 eta-2 eta-3 eta-4))))))))
(define csegen-2815 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (cons eta-1 eta-2))))))
(define csegen-2816 (lambda (eta-0) (lambda (eta-1) (cons eta-0 eta-1))))
(define csegen-2819 (lambda (eta-0) (lambda (eta-1) (PreludeC-45TypesC-45List-mapAppend '() eta-0 eta-1))))
(define csegen-2826 (vector 1 csegen-2802))
(define csegen-2832 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5)))))))
(define CoreC-45TTC-45Term-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-2838 (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45TTC-45Term-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 arg-686 arg-689)))))
(define csegen-2840 (cons csegen-838 csegen-835))
(define TTImpC-45TTImp-u--C-61C-61_Eq_DataOpt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-832 e-0 e-1)))(else 0)))) ((1) (case (vector-ref arg-1 0) ((1) 1)(else 0))) ((2) (case (vector-ref arg-1 0) ((2) 1)(else 0))) ((3) (case (vector-ref arg-1 0) ((3) 1)(else 0))) ((4) (case (vector-ref arg-1 0) ((4) 1)(else 0)))(else 0))))
(define TTImpC-45TTImp-u--C-47C-61_Eq_DataOpt (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45TTImp-u--C-61C-61_Eq_DataOpt arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-2850 (cons (lambda (arg-676) (lambda (arg-679) (TTImpC-45TTImp-u--C-61C-61_Eq_DataOpt arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (TTImpC-45TTImp-u--C-47C-61_Eq_DataOpt arg-686 arg-689)))))
(define csegen-2851 (lambda (eta-0) (let ((e-3 (vector-ref eta-0 3))) e-3)))
(define csegen-2852 (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)))
(define TTImpC-45ProcessData-hasArgs (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (case (vector-ref arg-2 0) ((3) (let ((e-14 (vector-ref arg-2 3))) (let ((e-15 (vector-ref arg-2 4))) (case (vector-ref e-14 0) ((2) (let ((e-18 (vector-ref e-14 2))) (let ((sc3 (AlgebraC-45Semiring-isErased csegen-931 e-18))) (cond ((equal? sc3 1) (TTImpC-45ProcessData-hasArgs 0 e-15)) (else 0)))))(else 1)))))(else 1)))(else (let ((e-0 (- arg-1 1))) (case (vector-ref arg-2 0) ((3) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (case (vector-ref e-4 0) ((2) (let ((e-8 (vector-ref e-4 2))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-8))) (cond ((equal? sc2 1) (TTImpC-45ProcessData-hasArgs (+ e-0 1) e-5)) (else (TTImpC-45ProcessData-hasArgs e-0 e-5))))))(else 0)))))(else 0)))))))
(define csegen-2853 (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 0 eta-0)))
(define csegen-2856 (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 1 eta-0)))
(define csegen-2860 (lambda (eta-0) (TTImpC-45ProcessData-hasArgs 2 eta-0)))
(define CoreC-45ContextC-45Data-n--8059-2245-u--justPos (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (CoreC-45ContextC-45Data-n--8059-2245-u--justPos arg-1 (+ arg-2 1) e-3) (cons arg-2 (CoreC-45ContextC-45Data-n--8059-2245-u--justPos arg-1 (+ arg-2 1) e-3))))))))
(define CoreC-45ContextC-45Data-toPos (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (unbox arg-1))) (CoreC-45ContextC-45Data-n--8059-2245-u--justPos e-2 0 e-2)))))
(define csegen-2868 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45ContextC-45Data-toPos e-5)))))))
(define TTImpC-45ProcessBuiltin-termConMatch (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-44 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((0) (let ((e-77 (vector-ref arg-3 3))) (or (and (= e-44 e-77) 1) 0)))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0)))))))))))) ((1) (let ((e-49 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((1) (let ((e-82 (vector-ref arg-3 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-49 e-82)))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0)))))))))))) ((2) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((2) (let ((e-86 (vector-ref arg-3 3))) (let ((e-87 (vector-ref arg-3 4))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-53 e-86))) (cond ((equal? sc2 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (PreludeC-45Basics-uncurry (csegen-2870) eta-0)) (DataC-45List-u--zip_Zippable_List e-54 e-87))) (else 0))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))) ((3) (let ((e-58 (vector-ref arg-2 3))) (let ((e-59 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((3) (let ((e-91 (vector-ref arg-3 3))) (let ((e-92 (vector-ref arg-3 4))) (let ((sc2 (CoreC-45TTC-45Binder-eqBinderBy (csegen-2870) e-58 e-91))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-termConMatch e-59 e-92)) (else 0))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))) ((4) (let ((e-62 (vector-ref arg-2 2))) (case (vector-ref arg-3 0) ((4) (let ((e-95 (vector-ref arg-3 2))) (TTImpC-45ProcessBuiltin-termConMatch e-62 e-95)))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0)))))))))))) ((5) (let ((e-67 (vector-ref arg-2 3))) (let ((e-68 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((5) (let ((e-100 (vector-ref arg-3 3))) (let ((e-101 (vector-ref arg-3 4))) (let ((sc2 (TTImpC-45ProcessBuiltin-termConMatch e-67 e-100))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-termConMatch e-68 e-101)) (else 0))))))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc3 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc3 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))) ((6) (let ((e-72 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-72 arg-3)))(else (case (vector-ref arg-3 0) ((6) (let ((e-39 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-39)))(else (case (vector-ref arg-2 0) ((7) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((7) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((sc2 (TTImpC-45ProcessBuiltin-termConMatch e-25 e-34))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-termConMatch e-26 e-35)) (else 0))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))) ((8) (let ((e-30 (vector-ref arg-2 3))) (TTImpC-45ProcessBuiltin-termConMatch e-30 arg-3)))(else (case (vector-ref arg-3 0) ((8) (let ((e-21 (vector-ref arg-3 3))) (TTImpC-45ProcessBuiltin-termConMatch arg-2 e-21)))(else (case (vector-ref arg-2 0) ((9) (case (vector-ref arg-3 0) ((9) 1)(else 0))) ((10) (case (vector-ref arg-3 0) ((10) 1)(else 0))) ((11) (case (vector-ref arg-3 0) ((11) 1)(else 0)))(else 0))))))))))))
(define csegen-2870 (lambda () (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessBuiltin-termConMatch eta-0 eta-1)))))
(define LibrariesC-45TextC-45Parser-sepBy1 (lambda (arg-4 arg-5 arg-6) (vector 10 arg-4 0 (vector 10 0 arg-4 (vector 0 csegen-181) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 u--f arg-6))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (vector 10 1 arg-4 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) arg-5) (lambda (f-0) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 f-0 arg-6)))))))))
(define ParserC-45RuleC-45Source-identPart (vector 1 "Expected name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ParserC-45RuleC-45Source-unqualifiedName ParserC-45RuleC-45Source-identPart)
(define csegen-2874 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") ParserC-45RuleC-45Source-unqualifiedName))
(define csegen-2894 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 0 (vector 2 ))))
(define ParserC-45RuleC-45Source-namespacedIdent (vector 1 "Expected namespaced name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((10) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (box (cons (box e-0) e-1))))) ((9) (let ((e-2 (vector-ref lcase-0 1))) (box (cons '() e-2))))(else '())))))
(define ParserC-45LexerC-45Source-groupClose (lambda (arg-0) (cond ((equal? arg-0 ".(") ")") ((equal? arg-0 "@{") "}") ((equal? arg-0 "[|") "|]") ((equal? arg-0 ".[|") "|]") ((equal? arg-0 "(") ")") ((equal? arg-0 "[") "]") ((equal? arg-0 "[<") "]") ((equal? arg-0 "[>") "]") ((equal? arg-0 "{") "}") ((equal? arg-0 "`(") ")") ((equal? arg-0 "`{") "}") ((equal? arg-0 "`[") "]")(else ""))))
(define ParserC-45LexerC-45Source-groupSymbols (cons ".(" (cons ".[|" (cons "@{" (cons "[|" (cons "(" (cons "{" (cons "[<" (cons "[>" (cons "[" (cons "`(" (cons "`{" (cons "`[" '())))))))))))))
(define ParserC-45LexerC-45Source-reservedInfixSymbols (cons "%" (cons "\\" (cons ":" (cons "=" (cons ":=" (cons "$=" (cons "|" (cons "|||" (cons "<-" (cons "->" (cons "=>" (cons "?" (cons "!" (cons "&" (cons "**" (cons ".." (cons "~" (cons "@" '())))))))))))))))))))
(define ParserC-45LexerC-45Source-symbols (cons "," (cons ";" (cons "_" (cons "`" '())))))
(define ParserC-45LexerC-45Source-reservedSymbols (PreludeC-45TypesC-45List-tailRecAppend ParserC-45LexerC-45Source-symbols (PreludeC-45TypesC-45List-tailRecAppend ParserC-45LexerC-45Source-groupSymbols (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45LexerC-45Source-groupClose eta-0)) ParserC-45LexerC-45Source-groupSymbols) ParserC-45LexerC-45Source-reservedInfixSymbols))))
(define LibrariesC-45TextC-45Parser-when (lambda (arg-2 arg-3) (cond ((equal? arg-2 1) (arg-3)) (else (vector 0 (vector 0 ))))))
(define ParserC-45RuleC-45Source-isNotReservedSymbol (lambda (arg-0) (LibrariesC-45TextC-45Parser-when (PreludeC-45Types-elem csegen-14 csegen-22 (let ((e-1 (vector-ref arg-0 0))) e-1) ParserC-45LexerC-45Source-reservedSymbols) (lambda () (vector 4 (box (let ((e-3 (vector-ref arg-0 2))) e-3)) 0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Can't use reserved symbol " (cons (let ((e-1 (vector-ref arg-0 0))) e-1) '()))))))))
(define ParserC-45RuleC-45Source-operatorCandidate (vector 1 "Expected operator" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (box (vector 1 (vector 0 e-0)))))(else '())))))
(define ParserC-45RuleC-45Source-aDotIdent (vector 1 "Expected dot+identifier" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((11) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ParserC-45RuleC-45Source-postfixProj (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 1 eta-0))) ParserC-45RuleC-45Source-aDotIdent))
(define LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (vector (arg-2 e-1) e-2 e-3))))))
(define ParserC-45RuleC-45Source-opNonNS (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (vector 14 (vector 13 1 1 ParserC-45RuleC-45Source-operatorCandidate (lambda () ParserC-45RuleC-45Source-postfixProj))) (lambda () (lambda (u--id) (vector 12 0 1 (ParserC-45RuleC-45Source-isNotReservedSymbol (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (CoreC-45Name-nameRoot eta-0)) u--id)) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (let ((e-1 (vector-ref u--id 0))) e-1))))))))))))
(define ParserC-45RuleC-45Source-case--isCapitalisedIdent-6838 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-1 "") (if (null? arg-4) arg-3 (let ((e-0 (car arg-4))) (let ((sc3 (let ((sc4 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc4 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (cast-int-char (blodwen-toSignedInt 160 63)))))))) (cond ((equal? sc3 1) (vector 0 (vector 0 ))) (else arg-3))))))(else (let ((e-0 (car arg-4))) (let ((sc1 (let ((sc2 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc2 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (cast-int-char (blodwen-toSignedInt 160 63)))))))) (cond ((equal? sc1 1) (vector 0 (vector 0 ))) (else arg-3))))))))
(define ParserC-45RuleC-45Source-isCapitalisedIdent (lambda (arg-0) (let ((u--val (let ((e-1 (vector-ref arg-0 0))) e-1))) (let ((u--loc (let ((e-3 (vector-ref arg-0 2))) e-3))) (let ((u--err (vector 4 (box u--loc) 0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Expected a capitalised identifier, got: " (cons u--val '())))))) (ParserC-45RuleC-45Source-case--isCapitalisedIdent-6838 arg-0 u--val u--loc u--err (DataC-45String-strM u--val)))))))
(define ParserC-45RuleC-45Source-identWithCapital (lambda (arg-0 arg-1) (LibrariesC-45TextC-45Parser-when arg-0 (lambda () (ParserC-45RuleC-45Source-isCapitalisedIdent arg-1)))))
(define ParserC-45RuleC-45Source-reservedNames (cons "Type" (cons "Int" (cons "Int8" (cons "Int16" (cons "Int32" (cons "Int64" (cons "Integer" (cons "Bits8" (cons "Bits16" (cons "Bits32" (cons "Bits64" (cons "String" (cons "Char" (cons "Double" (cons "Lazy" (cons "Inf" (cons "Force" (cons "Delay" '())))))))))))))))))))
(define ParserC-45RuleC-45Source-isNotReservedName (lambda (arg-0) (LibrariesC-45TextC-45Parser-when (PreludeC-45Types-elem csegen-14 csegen-22 (let ((e-1 (vector-ref arg-0 0))) e-1) ParserC-45RuleC-45Source-reservedNames) (lambda () (vector 4 (box (let ((e-3 (vector-ref arg-0 2))) e-3)) 0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Can't use reserved name " (cons (let ((e-1 (vector-ref arg-0 0))) e-1) '()))))))))
(define CoreC-45Name-mkNamespacedName (lambda (arg-0 arg-1) (if (null? arg-0) (vector 1 arg-1) (let ((e-2 (unbox arg-0))) (vector 0 e-2 (vector 1 arg-1))))))
(define ParserC-45RuleC-45Source-n--11940-7349-u--nameNS (lambda (arg-0 arg-1) (let ((u--id (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (Builtin-snd eta-0)) arg-1))) (vector 12 0 0 (ParserC-45RuleC-45Source-identWithCapital arg-0 u--id) (vector 12 0 0 (ParserC-45RuleC-45Source-isNotReservedName u--id) (vector 0 (PreludeC-45Basics-uncurry (lambda (eta-0) (lambda (eta-1) (CoreC-45Name-mkNamespacedName eta-0 eta-1))) (let ((e-1 (vector-ref arg-1 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (cons e-5 (vector 0 e-4))))))))))))
(define ParserC-45RuleC-45Source-unqualifiedOperatorName (vector 1 "Expected operator" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) e-0) (PreludeC-45Interfaces-guard csegen-258 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 e-0 ParserC-45LexerC-45Source-reservedSymbols))) (cond ((equal? sc1 1) 0) (else 1)))))))(else '())))))
(define ParserC-45RuleC-45Source-operator (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) ParserC-45RuleC-45Source-unqualifiedOperatorName))
(define ParserC-45RuleC-45Source-n--11940-7350-u--opNS (lambda (arg-0 arg-1) (vector 12 0 1 (ParserC-45RuleC-45Source-isCapitalisedIdent (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (Builtin-snd eta-0)) arg-1)) (let ((u--ns (PreludeC-45Basics-uncurry csegen-521 (let ((e-1 (vector-ref arg-1 0))) e-1)))) (vector 11 1 (ParserC-45RuleC-45Source-symbol ".(") (lambda () (vector 9 1 (vector 13 1 1 ParserC-45RuleC-45Source-operator (lambda () ParserC-45RuleC-45Source-postfixProj)) (lambda () (lambda (u--n) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (vector 0 u--ns u--n)))))))))))))
(define ParserC-45RuleC-45Source-nameWithCapital (lambda (arg-0) (vector 13 1 1 ParserC-45RuleC-45Source-opNonNS (lambda () (vector 9 0 (vector 14 ParserC-45RuleC-45Source-namespacedIdent) (lambda () (lambda (u--nsx) (vector 13 1 0 (ParserC-45RuleC-45Source-n--11940-7350-u--opNS arg-0 u--nsx) (lambda () (ParserC-45RuleC-45Source-n--11940-7349-u--nameNS arg-0 u--nsx))))))))))
(define ParserC-45RuleC-45Source-name (ParserC-45RuleC-45Source-nameWithCapital 0))
(define csegen-2899 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f ParserC-45RuleC-45Source-name)))
(define csegen-2914 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) ParserC-45RuleC-45Source-unqualifiedName))
(define csegen-2916 (vector 0 csegen-30))
(define csegen-2917 (vector 0 csegen-1416))
(define ParserC-45RuleC-45Source-exactIdent (lambda (arg-0) (vector 1 (string-append "Expected " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))))(else '()))))))
(define ParserC-45RuleC-45Source-builtinType (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Source-exactIdent "Natural")) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (ParserC-45RuleC-45Source-exactIdent "NaturalToInteger")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 2) (ParserC-45RuleC-45Source-exactIdent "IntegerToNatural")))))))
(define csegen-2944 (vector 12 0 1 (vector 7 ) (vector 9 1 ParserC-45RuleC-45Source-builtinType (lambda () (lambda (u--t) (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (cons u--t u--n))))))))))
(define csegen-2952 (vector 0 (cons LibrariesC-45DataC-45WithDefault-defaulted '())))
(define LibrariesC-45TextC-45Bounded-startBounds (lambda (arg-0) (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (let ((e-1 (vector-ref arg-0 1))) e-1))))
(define LibrariesC-45TextC-45Parser-location (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (LibrariesC-45TextC-45Bounded-startBounds eta-0)) (vector 15 )))
(define LibrariesC-45TextC-45Parser-column (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (Builtin-snd eta-0)) LibrariesC-45TextC-45Parser-location))
(define ParserC-45RuleC-45Source-n--10442-5903-u--isEOI (lambda (arg-0) (case (vector-ref arg-0 0) ((17) 1)(else 0))))
(define ParserC-45RuleC-45Source-eoi (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (vector 0 )) (vector 2 "Expected end of input" (lambda (eta-0) (ParserC-45RuleC-45Source-n--10442-5903-u--isEOI eta-0)))))
(define ParserC-45RuleC-45Source-keyword (lambda (arg-0) (vector 1 (string-append "Expected '" (string-append arg-0 "'")) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((18) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))))(else '()))))))
(define ParserC-45RuleC-45Source-continueF (lambda (arg-0 arg-1) (vector 13 0 0 (vector 12 0 0 ParserC-45RuleC-45Source-eoi arg-0) (lambda () (vector 13 1 0 (vector 11 0 (ParserC-45RuleC-45Source-keyword "where") (lambda () arg-0)) (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (LibrariesC-45TextC-45Parser-when (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-1) (lambda () arg-0))))))))))
(define ParserC-45RuleC-45Source-continue (lambda (ext-0) (ParserC-45RuleC-45Source-continueF (vector 4 '() 0 "Unexpected end of expression") ext-0)))
(define TTImpC-45Parser-implicitArg (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 9 1 csegen-2914 (lambda () (lambda (u--x) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (box u--x) u--tm)))))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (cons (box u--x) (vector 0 (vector 0 arg-0 u--start u--end) u--x)))))))))))))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "@{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons '() u--tm))))))))))))))
(define TTImpC-45Parser-as (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 csegen-2914 (lambda () (lambda (u--x) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--nameEnd) (vector 11 1 (ParserC-45RuleC-45Source-symbol "@") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--pat) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 18 (vector 0 arg-0 u--start u--end) (vector 0 arg-0 u--start u--nameEnd) 1 u--x u--pat))))))))))))))))))
(define DataC-45List-drop (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) '() (let ((e-4 (cdr arg-2))) (DataC-45List-drop e-0 e-4))))))))
(define DataC-45List-isPrefixOf (lambda (arg-1 ext-0 ext-1) (DataC-45List-isPrefixOfBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define PreludeC-45Types-isHexDigit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isDigit arg-0))) (cond ((equal? sc0 1) 1) (else (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Char #\a arg-0))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\f)) (else 0))))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_Char #\A arg-0))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\F)) (else 0)))))))))))
(define PreludeC-45Types-isOctDigit (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-0 #\0))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-0 #\7)) (else 0)))))
(define ParserC-45SupportC-45Escaping-hex (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7)) ((equal? arg-0 #\8) (box 8)) ((equal? arg-0 #\9) (box 9)) ((equal? arg-0 #\a) (box 10)) ((equal? arg-0 #\b) (box 11)) ((equal? arg-0 #\c) (box 12)) ((equal? arg-0 #\d) (box 13)) ((equal? arg-0 #\e) (box 14)) ((equal? arg-0 #\f) (box 15))(else '()))))
(define PreludeC-45Types-toLower (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isUpper arg-0))) (cond ((equal? sc0 1) (cast-int-char (bs+ (cast-char-boundedInt arg-0 63) 32 63))) (else arg-0)))))
(define ParserC-45SupportC-45Escaping-n--3755-3064-u--toHex (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (box 0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-hex (PreludeC-45Types-toLower e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-n--3755-3064-u--toHex arg-0 arg-1 arg-2 (bs* arg-3 16 63) e-3) (lambda (bind-1) (box (bs+ (bs* bind-0 arg-3 63) bind-1 63)))))))))))
(define ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3495 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-n--3755-3064-u--toHex arg-0 arg-1 arg-2 1 (PreludeC-45TypesC-45List-reverse e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (lambda (bind-1) (box (cons (cast-int-char bind-0) bind-1)))))))))))
(define ParserC-45SupportC-45Escaping-oct (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7))(else '()))))
(define ParserC-45SupportC-45Escaping-n--3755-3065-u--toOct (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (box 0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-oct (PreludeC-45Types-toLower e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-n--3755-3065-u--toOct arg-0 arg-1 arg-2 (bs* arg-3 8 63) e-3) (lambda (bind-1) (box (bs+ (bs* bind-0 arg-3 63) bind-1 63)))))))))))
(define ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3567 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-n--3755-3065-u--toOct arg-0 arg-1 arg-2 1 (PreludeC-45TypesC-45List-reverse e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (lambda (bind-1) (box (cons (cast-int-char bind-0) bind-1)))))))))))
(define ParserC-45SupportC-45Escaping-getEsc (lambda (arg-0) (cond ((equal? arg-0 "NUL") (box (integer->char 0))) ((equal? arg-0 "SOH") (box (integer->char 1))) ((equal? arg-0 "STX") (box (integer->char 2))) ((equal? arg-0 "ETX") (box (integer->char 3))) ((equal? arg-0 "EOT") (box (integer->char 4))) ((equal? arg-0 "ENQ") (box (integer->char 5))) ((equal? arg-0 "ACK") (box (integer->char 6))) ((equal? arg-0 "BEL") (box (integer->char 7))) ((equal? arg-0 "BS") (box (integer->char 8))) ((equal? arg-0 "HT") (box (integer->char 9))) ((equal? arg-0 "LF") (box (integer->char 10))) ((equal? arg-0 "VT") (box (integer->char 11))) ((equal? arg-0 "FF") (box (integer->char 12))) ((equal? arg-0 "CR") (box (integer->char 13))) ((equal? arg-0 "SO") (box (integer->char 14))) ((equal? arg-0 "SI") (box (integer->char 15))) ((equal? arg-0 "DLE") (box (integer->char 16))) ((equal? arg-0 "DC1") (box (integer->char 17))) ((equal? arg-0 "DC2") (box (integer->char 18))) ((equal? arg-0 "DC3") (box (integer->char 19))) ((equal? arg-0 "DC4") (box (integer->char 20))) ((equal? arg-0 "NAK") (box (integer->char 21))) ((equal? arg-0 "SYN") (box (integer->char 22))) ((equal? arg-0 "ETB") (box (integer->char 23))) ((equal? arg-0 "CAN") (box (integer->char 24))) ((equal? arg-0 "EM") (box (integer->char 25))) ((equal? arg-0 "SUB") (box (integer->char 26))) ((equal? arg-0 "ESC") (box (integer->char 27))) ((equal? arg-0 "FS") (box (integer->char 28))) ((equal? arg-0 "GS") (box (integer->char 29))) ((equal? arg-0 "RS") (box (integer->char 30))) ((equal? arg-0 "US") (box (integer->char 31))) ((equal? arg-0 "SP") (box #\ )) ((equal? arg-0 "DEL") (box (integer->char 127)))(else '()))))
(define ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3634 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (if (null? e-3) (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (if (null? e-10) (let ((sc5 (ParserC-45SupportC-45Escaping-getEsc (PreludeC-45Types-fastPack (cons e-6 (cons e-9 '())))))) (if (null? sc5) (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 arg-3) (let ((e-1 (unbox sc5))) (box (cons e-1 '()))))) (let ((e-12 (car e-10))) (let ((e-13 (cdr e-10))) (let ((sc5 (ParserC-45SupportC-45Escaping-getEsc (PreludeC-45Types-fastPack (cons e-6 (cons e-9 (cons e-12 '()))))))) (if (null? sc5) (let ((sc6 (ParserC-45SupportC-45Escaping-getEsc (PreludeC-45Types-fastPack (cons e-6 (cons e-9 '())))))) (if (null? sc6) (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 arg-3) (let ((e-1 (unbox sc6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 (cons e-12 e-13)) (lambda (bind-0) (box (cons e-1 bind-0))))))) (let ((e-1 (unbox sc5))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-13) (lambda (bind-0) (box (cons e-1 bind-0)))))))))))))))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-3) (lambda (bind-0) (box (cons (cast-int-char (cast-string-boundedInt (PreludeC-45Types-fastPack e-2) 63)) bind-0)))))))))
(define ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32unescapeC-39-3184 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3634 arg-0 arg-1 arg-2 arg-3 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) arg-3)) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\\) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons #\\ bind-0))))) ((equal? e-1 (integer->char 10)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box bind-0)))) ((equal? e-1 #\&) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box bind-0)))) ((equal? e-1 #\a) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 7) bind-0))))) ((equal? e-1 #\b) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 8) bind-0))))) ((equal? e-1 #\f) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 12) bind-0))))) ((equal? e-1 #\n) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 10) bind-0))))) ((equal? e-1 #\r) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 13) bind-0))))) ((equal? e-1 #\t) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 9) bind-0))))) ((equal? e-1 #\v) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons (integer->char 11) bind-0))))) ((equal? e-1 #\') (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons #\' bind-0))))) ((equal? e-1 #\") (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-2 e-2) (lambda (bind-0) (box (cons #\" bind-0))))) ((equal? e-1 #\x) (ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3495 arg-0 arg-1 arg-2 e-2 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isHexDigit eta-0)) e-2))) ((equal? e-1 #\o) (ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3567 arg-0 arg-1 arg-2 e-2 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isOctDigit eta-0)) e-2)))(else (ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32unescapeC-39-3634 arg-0 arg-1 arg-2 arg-3 (DataC-45List-span (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) arg-3)))))))))
(define ParserC-45SupportC-45Escaping-unescapeC-39 (lambda (arg-0 arg-1) (if (null? arg-1) (box '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (DataC-45List-isPrefixOf csegen-17 arg-0 (cons e-2 e-3)))) (cond ((equal? sc1 1) (ParserC-45SupportC-45Escaping-case--caseC-32blockC-32inC-32unescapeC-39-3184 e-2 e-3 arg-0 (DataC-45List-drop (PreludeC-45TypesC-45List-lengthTR arg-0) (cons e-2 e-3)))) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescapeC-39 arg-0 e-3) (lambda (bind-0) (box (cons e-2 bind-0))))))))))))
(define ParserC-45SupportC-45Escaping-unescape (lambda (arg-0 arg-1) (let ((u--escapeChars (cons #\\ (DataC-45List-replicateTR '() arg-0 #\#)))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (ParserC-45SupportC-45Escaping-unescapeC-39 u--escapeChars (PreludeC-45Types-fastUnpack arg-1))))))
(define ParserC-45Support-getCharLit (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ParserC-45SupportC-45Escaping-unescape 0 arg-0) (lambda (u--e) (let ((sc0 (or (and (= (PreludeC-45TypesC-45String-length u--e) 1) 1) 0))) (cond ((equal? sc0 1) (box (string-ref u--e 0))) (else (let ((sc1 (or (and (= (PreludeC-45TypesC-45String-length u--e) 0) 1) 0))) (cond ((equal? sc1 1) (box (integer->char 0))) (else '()))))))))))
(define ParserC-45RuleC-45Source-constant (vector 1 "Expected constant" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((0) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 11 eta-0)) (ParserC-45Support-getCharLit e-0)))) ((1) (let ((e-1 (vector-ref lcase-0 1))) (box (vector 12 e-1)))) ((2) (let ((e-2 (vector-ref lcase-0 1))) (box (vector 5 e-2)))) ((9) (let ((e-3 (vector-ref lcase-0 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Primitive-isConstantType (vector 1 (vector 0 e-3))) (lambda (lcase-1) (cond ((equal? lcase-1 13) '())(else (box (vector 13 lcase-1))))))))(else '())))))
(define ParserC-45RuleC-45Source-holeName (vector 1 "Expected hole name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((8) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ParserC-45RuleC-45Source-pragma (lambda (arg-0) (vector 1 (string-append "Expected pragma " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((19) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))))(else '()))))))
(define ParserC-45RuleC-45Source-simpleStrLit (vector 1 "Expected string literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (let ((e-0 (vector-ref lcase-0 1))) (ParserC-45SupportC-45Escaping-unescape 0 e-0)))(else '())))))
(define ParserC-45RuleC-45Source-strBegin (vector 1 "Expected string begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (cond ((equal? e-1 1) (box e-0))(else '())))))(else '())))))
(define ParserC-45RuleC-45Source-strEnd (vector 1 "Expected string end" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((4) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Source-simpleStr (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) ParserC-45RuleC-45Source-strBegin) csegen-2165)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-option 1 "" ParserC-45RuleC-45Source-simpleStrLit))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f ParserC-45RuleC-45Source-strEnd))))
(define TTImpC-45Parser-atom (lambda (arg-0) (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Source-constant (lambda () (lambda (u--x) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 28 (vector 0 arg-0 u--start u--end) u--x))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Source-simpleStr (lambda () (lambda (u--str) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 28 (vector 0 arg-0 u--start u--end) (vector 10 u--str)))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "Type") (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 29 (vector 0 arg-0 u--start u--end))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-symbol "_") (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 32 (vector 0 arg-0 u--start u--end) 1)))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-symbol "?") (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 32 (vector 0 arg-0 u--start u--end) 0)))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 0 (ParserC-45RuleC-45Source-pragma "search") (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 12 (vector 0 arg-0 u--start u--end) 1000)))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--x) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 u--start u--end) u--x))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "$") (lambda () (vector 9 0 ParserC-45RuleC-45Source-unqualifiedName (lambda () (lambda (u--x) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 17 (vector 0 arg-0 u--start u--end) u--x))))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Source-holeName (lambda () (lambda (u--x) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 30 (vector 0 arg-0 u--start u--end) u--x)))))))))))))))))))))))))))
(define TTImpC-45Parser-pibindAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 arg-0 e-6 arg-1 e-10 e-11 (TTImpC-45Parser-pibindAll arg-0 arg-1 e-3 arg-3)))))))))))
(define ParserC-45RuleC-45Source-isTerminator (lambda (arg-0) (case (vector-ref arg-0 0) ((12) (let ((e-0 (vector-ref arg-0 1))) (cond ((equal? e-0 ",") 1) ((equal? e-0 "]") 1) ((equal? e-0 ";") 1) ((equal? e-0 "}") 1) ((equal? e-0 ")") 1) ((equal? e-0 "|") 1) ((equal? e-0 "**") 1)(else 0)))) ((18) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 "in") 1) ((equal? e-1 "then") 1) ((equal? e-1 "else") 1) ((equal? e-1 "where") 1)(else 0)))) ((6) 1) ((17) 1)(else 0))))
(define ParserC-45RuleC-45Source-atEnd (lambda (arg-0) (vector 13 0 0 ParserC-45RuleC-45Source-eoi (lambda () (vector 13 0 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (vector 0 )) (vector 2 "Expected end of block" (lambda (eta-0) (ParserC-45RuleC-45Source-isTerminator eta-0)))) (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (LibrariesC-45TextC-45Parser-when (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-0))) (cond ((equal? sc0 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Not the end of a block entry")))))))))))
(define TTImpC-45Parser-getMult (lambda (arg-0) (if (null? arg-0) (vector 0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-1 (unbox arg-0))) (cond ((equal? e-1 0) csegen-2916) ((equal? e-1 1) csegen-2917)(else (vector 4 '() 1 "Invalid multiplicity (must be 0 or 1)")))))))
(define ParserC-45RuleC-45Source-intLit (vector 1 "Expected integer literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define TTImpC-45Parser-multiplicity (vector 13 1 0 (vector 9 0 ParserC-45RuleC-45Source-intLit (lambda () (lambda (u--c) (vector 0 (box u--c))))) (lambda () (vector 0 '()))))
(define TTImpC-45Parser-pibindListName (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 10 0 1 TTImpC-45Parser-multiplicity (lambda (u--rigc) (vector 9 1 csegen-2874 (lambda () (lambda (u--ns) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-2) (lambda () (lambda (u--ty) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons u--rig (cons (vector 1 (vector 0 u--n)) u--ty))) (DataC-45List1-forget u--ns)))))))))))))))) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (vector 10 0 1 TTImpC-45Parser-multiplicity (lambda (u--rigc) (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-2) (lambda () (lambda (u--ty) (vector 10 0 0 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 0 (cons u--rig (cons u--n u--ty)))))))))))))))))))))
(define TTImpC-45Parser-pibindList (lambda (arg-0 arg-1 arg-2) (vector 9 0 (TTImpC-45Parser-pibindListName arg-0 arg-1 arg-2) (lambda () (lambda (u--params) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons (box e-6) e-7))))))) u--params)))))))
(define TTImpC-45Parser-autoImplicitPi (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-keyword "auto") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-pibindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "->") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) (vector 2 ) u--binders u--scope)))))))))))))))))))))))
(define TTImpC-45Parser-bindSymbol (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-symbol "->") (lambda () (vector 0 (vector 1 )))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-symbol "=>") (lambda () (vector 0 (vector 2 )))))))
(define TTImpC-45Parser-explicitPi (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 9 1 (TTImpC-45Parser-pibindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 9 1 TTImpC-45Parser-bindSymbol (lambda () (lambda (u--exp) (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) u--exp u--binders u--scope)))))))))))))))))))))
(define TTImpC-45Parser-forall_ (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "forall") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--nstart) (vector 9 1 csegen-2874 (lambda () (lambda (u--ns) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--nend) (let ((u--nfc (vector 0 arg-0 u--nstart u--nend))) (let ((u--binders (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons csegen-30 (cons (box (vector 1 (vector 0 u--n))) (vector 32 u--nfc 0)))) (DataC-45List1-forget u--ns)))) (vector 11 1 (ParserC-45RuleC-45Source-symbol ".") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) (vector 0 ) u--binders u--scope)))))))))))))))))))))))))
(define TTImpC-45Parser-implicitPi (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 9 1 (TTImpC-45Parser-pibindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "->") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-pibindAll (vector 0 arg-0 u--start u--end) (vector 0 ) u--binders u--scope))))))))))))))))))))
(define TTImpC-45Parser-bindList (lambda (arg-0 arg-1 arg-2) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (vector 10 0 1 TTImpC-45Parser-multiplicity (lambda (u--rigc) (vector 9 0 ParserC-45RuleC-45Source-unqualifiedName (lambda () (lambda (u--n) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (vector 32 (vector 0 arg-0 arg-1 u--end) 0) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (TTImpC-45Parser-appExpr arg-0 arg-2)))) (lambda (u--ty) (vector 10 0 0 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 0 (cons u--rig (cons (vector 1 (vector 0 u--n)) u--ty))))))))))))))))))
(define ParserC-45RuleC-45Source-mustContinue (lambda (arg-0 arg-1) (if (null? arg-1) (ParserC-45RuleC-45Source-continueF (vector 4 '() 1 "Unexpected end of expression") arg-0) (let ((e-2 (unbox arg-1))) (ParserC-45RuleC-45Source-continueF (vector 4 '() 1 (string-append "Expected '" (string-append e-2 "'"))) arg-0)))))
(define TTImpC-45Parser-n--9772-4430-u--bindAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 2 arg-2 e-6 (vector 1 ) (box e-10) e-11 (TTImpC-45Parser-n--9772-4430-u--bindAll arg-0 arg-1 arg-2 e-3 arg-4)))))))))))
(define TTImpC-45Parser-lam (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-symbol "\\") (lambda () (vector 9 1 (TTImpC-45Parser-bindList arg-0 u--start arg-1) (lambda () (lambda (u--binders) (vector 11 1 (ParserC-45RuleC-45Source-symbol "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-1 '()) (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-n--9772-4430-u--bindAll arg-1 arg-0 (vector 0 arg-0 u--start u--end) u--binders u--scope)))))))))))))))))))
(define ParserC-45RuleC-45Source-checkValid (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (vector 0 (vector 0 ))) ((1) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45TextC-45Parser-when (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 e-0))) (cond ((equal? sc1 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Invalid indentation"))))) ((2) (let ((e-1 (vector-ref arg-0 1))) (LibrariesC-45TextC-45Parser-when (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-1 e-1))) (cond ((equal? sc1 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Invalid indentation"))))) (else (vector 4 '() 0 "End of block")))))
(define ParserC-45RuleC-45Source-n--12696-8105-u--afterDedent (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-3 arg-0))) (cond ((equal? sc1 1) (vector 0 (vector 0 ))) (else (vector 4 '() 0 "Not the end of a block entry"))))) ((2) (let ((e-0 (vector-ref arg-2 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-3 arg-0))) (cond ((equal? sc1 1) (vector 0 (vector 1 e-0))) (else (vector 4 '() 0 "Not the end of a block entry")))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-3 arg-0))) (cond ((equal? sc1 1) (vector 0 (vector 1 e-1))) (else (vector 4 '() 0 "Not the end of a block entry")))))) (else (vector 0 (vector 3 ))))))
(define ParserC-45RuleC-45Source-n--12696-8106-u--afterSemi (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (let ((e-0 (vector-ref arg-2 1))) (vector 2 e-0))) ((2) (let ((e-1 (vector-ref arg-2 1))) (vector 2 e-1))) (else (vector 3 )))))
(define ParserC-45RuleC-45Source-terminator (lambda (arg-0 arg-1) (vector 13 0 0 (vector 12 0 0 ParserC-45RuleC-45Source-eoi (vector 0 (vector 3 ))) (lambda () (vector 13 1 0 (vector 11 0 (ParserC-45RuleC-45Source-symbol ";") (lambda () (vector 0 (ParserC-45RuleC-45Source-n--12696-8106-u--afterSemi arg-1 arg-0 arg-0)))) (lambda () (vector 13 0 0 (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (ParserC-45RuleC-45Source-n--12696-8105-u--afterDedent arg-1 arg-0 arg-0 u--col))) (lambda () (vector 0 (vector 3 ))))))))))
(define ParserC-45RuleC-45Source-blockEntry (lambda (arg-1 arg-2) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 12 0 1 (ParserC-45RuleC-45Source-checkValid arg-1 u--col) (vector 9 0 (arg-2 u--col) (lambda () (lambda (u--p) (vector 10 0 0 (ParserC-45RuleC-45Source-terminator arg-1 u--col) (lambda (u--validC-39) (vector 0 (cons u--p u--validC-39))))))))))))
(define ParserC-45RuleC-45Source-blockEntries (lambda (arg-1 arg-2) (vector 13 0 0 (vector 12 0 0 ParserC-45RuleC-45Source-eoi (vector 0 '())) (lambda () (vector 13 1 0 (vector 9 0 (ParserC-45RuleC-45Source-blockEntry arg-1 arg-2) (lambda () (lambda (u--res) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-2) (lambda (u--ts) (vector 0 (cons (Builtin-fst u--res) u--ts))))))) (lambda () (vector 0 '())))))))
(define ParserC-45RuleC-45Source-block (lambda (arg-1) (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (vector 0 ) arg-1) csegen-2242)))) (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (ParserC-45RuleC-45Source-blockEntries (vector 1 u--col) arg-1)))))))
(define LibrariesC-45TextC-45Bounded-endBounds (lambda (arg-0) (cons (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-3 (vector-ref arg-0 3))) e-3))))
(define LibrariesC-45TextC-45Bounded-end (lambda (ext-0) (LibrariesC-45TextC-45Bounded-endBounds (let ((e-3 (vector-ref ext-0 2))) e-3))))
(define LibrariesC-45TextC-45Bounded-start (lambda (ext-0) (LibrariesC-45TextC-45Bounded-startBounds (let ((e-3 (vector-ref ext-0 2))) e-3))))
(define CoreC-45FC-boundToFC (lambda (arg-1 arg-2) (vector 0 arg-1 (LibrariesC-45TextC-45Bounded-start arg-2) (LibrariesC-45TextC-45Bounded-end arg-2))))
(define TTImpC-45Parser-n--8592-7880-u--isClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-2))) (cond ((equal? sc1 1) (box e-3)) (else '()))))))(else '()))))
(define TTImpC-45Parser-n--8592-7881-u--spanMap (lambda (arg-0 arg-1 arg-2 arg-3 arg-6 arg-7) (if (null? arg-7) (cons '() '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (arg-6 e-2))) (if (null? sc1) (cons '() (cons e-2 e-3)) (let ((e-4 (unbox sc1))) (let ((sc2 (TTImpC-45Parser-n--8592-7881-u--spanMap arg-0 arg-1 arg-2 arg-3 arg-6 e-3))) (let ((e-6 (car sc2))) (let ((e-5 (cdr sc2))) (cons (PreludeC-45TypesC-45List-tailRecAppend e-4 e-6) e-5))))))))))))
(define TTImpC-45Parser-collectDefs (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((sc2 (TTImpC-45Parser-n--8592-7881-u--spanMap e-7 e-6 e-5 e-3 (lambda (eta-0) (TTImpC-45Parser-n--8592-7880-u--isClause e-7 e-6 e-5 e-3 e-6 eta-0)) e-3))) (let ((e-8 (car sc2))) (let ((e-4 (cdr sc2))) (cons (vector 2 e-5 e-6 (PreludeC-45TypesC-45List-tailRecAppend e-7 e-8)) (TTImpC-45Parser-collectDefs e-4))))))))) ((6) (let ((e-9 (vector-ref e-2 1))) (let ((e-10 (vector-ref e-2 2))) (let ((e-11 (vector-ref e-2 3))) (cons (vector 6 e-9 e-10 (TTImpC-45Parser-collectDefs e-11)) (TTImpC-45Parser-collectDefs e-3)))))) ((5) (let ((e-13 (vector-ref e-2 1))) (let ((e-14 (vector-ref e-2 2))) (let ((e-15 (vector-ref e-2 3))) (cons (vector 5 e-13 e-14 (TTImpC-45Parser-collectDefs e-15)) (TTImpC-45Parser-collectDefs e-3))))))(else (cons e-2 (TTImpC-45Parser-collectDefs e-3)))))))))
(define TTImpC-45Parser-dataOpt (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "noHints") (lambda () (vector 0 (vector 1 )))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "uniqueSearch") (lambda () (vector 0 (vector 2 )))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "search") (lambda () (vector 9 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--ns) (vector 0 (vector 0 u--ns))))))))))))
(define TTImpC-45Parser-dataOpts (LibrariesC-45TextC-45Parser-option 1 '() (vector 11 1 (ParserC-45RuleC-45Source-symbol "[") (lambda () (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") TTImpC-45Parser-dataOpt) (lambda () (lambda (u--dopts) (vector 11 0 (ParserC-45RuleC-45Source-symbol "]") (lambda () (vector 0 (DataC-45List1-forget u--dopts)))))))))))
(define TTImpC-45Parser-tyDecl (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--nameEnd) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--ty) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector (vector 0 arg-0 u--start u--end) (vector 0 arg-0 u--start u--nameEnd) u--n u--ty)))))))))))))))))))
(define TTImpC-45Parser-dataDecl (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "data") (lambda () (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--ty) (vector 11 0 (ParserC-45RuleC-45Source-keyword "where") (lambda () (vector 10 0 0 TTImpC-45Parser-dataOpts (lambda (u--opts) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (TTImpC-45Parser-tyDecl arg-0 eta-0))) (lambda (u--cs) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 u--start u--end) u--n (box u--ty) u--opts u--cs))))))))))))))))))))))))
(define TTImpC-45Parser-totalityOpt (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-keyword "partial") (lambda () (vector 0 2))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-keyword "total") (lambda () (vector 0 0))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "covering") (lambda () (vector 0 1))))))))
(define TTImpC-45Parser-visOption (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-keyword "public") (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "export") (lambda () (vector 0 2))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-keyword "export") (lambda () (vector 0 1))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "private") (lambda () (vector 0 0))))))))
(define TTImpC-45Parser-visibility (vector 13 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (LibrariesC-45DataC-45WithDefault-specified eta-0)) TTImpC-45Parser-visOption) (lambda () (vector 0 LibrariesC-45DataC-45WithDefault-defaulted))))
(define TTImpC-45Parser-dataVisOpt (vector 13 1 0 (vector 9 0 TTImpC-45Parser-visOption (lambda () (lambda (u--vis) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 TTImpC-45Parser-totalityOpt) (lambda (u--mbtot) (vector 0 (cons (LibrariesC-45DataC-45WithDefault-specified u--vis) u--mbtot))))))) (lambda () (vector 13 1 0 (vector 9 0 TTImpC-45Parser-totalityOpt (lambda () (lambda (u--tot) (vector 10 0 0 TTImpC-45Parser-visibility (lambda (u--vis) (vector 0 (cons u--vis (box u--tot)))))))) (lambda () csegen-2952)))))
(define ParserC-45RuleC-45Source-nonEmptyBlock (lambda (arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-blockEntry (vector 0 ) arg-1) (lambda () (lambda (u--res) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-1) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (Builtin-fst u--res) u--ps)))))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 9 0 (ParserC-45RuleC-45Source-blockEntry (vector 1 u--col) arg-1) (lambda () (lambda (u--res) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-1) (lambda (u--ps) (vector 0 (cons (Builtin-fst u--res) u--ps)))))))))))))
(define TTImpC-45Parser-n--12570-5811-u--getFn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 2))) (vector 0 e-2))) ((8) (let ((e-5 (vector-ref arg-5 2))) (TTImpC-45Parser-n--12570-5811-u--getFn arg-0 arg-1 arg-2 arg-3 arg-4 e-5))) ((9) (let ((e-9 (vector-ref arg-5 2))) (TTImpC-45Parser-n--12570-5811-u--getFn arg-0 arg-1 arg-2 arg-3 arg-4 e-9))) ((10) (let ((e-13 (vector-ref arg-5 2))) (TTImpC-45Parser-n--12570-5811-u--getFn arg-0 arg-1 arg-2 arg-3 arg-4 e-13)))(else (vector 4 '() 0 "Not a function application")))))
(define TTImpC-45Parser-parseRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (TTImpC-45Parser-expr arg-1 arg-2) (lambda () (lambda (u--rhs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (let ((u--fc (vector 0 arg-1 arg-3 u--end))) (vector 10 0 0 (TTImpC-45Parser-n--12570-5811-u--getFn arg-4 arg-3 arg-2 arg-1 arg-0 arg-4) (lambda (bind-0) (vector 0 (cons bind-0 (vector 0 u--fc arg-4 u--rhs))))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-keyword "with") (lambda () (vector 10 0 1 TTImpC-45Parser-multiplicity (lambda (u--m) (vector 10 0 1 (TTImpC-45Parser-getMult u--m) (lambda (u--rig) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--wstart) (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-1 arg-2) (lambda () (lambda (u--wval) (vector 11 1 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-keyword "proof")) csegen-2899)) (lambda (u--prf) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (TTImpC-45Parser-clause (+ arg-0 1) arg-1 eta-0))) (lambda () (lambda (u--ws) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (let ((u--fc (vector 0 arg-1 arg-3 u--end))) (vector 10 0 0 (TTImpC-45Parser-n--12570-5811-u--getFn arg-4 arg-3 arg-2 arg-1 arg-0 arg-4) (lambda (bind-0) (vector 0 (cons bind-0 (vector 1 u--fc arg-4 u--rig u--wval u--prf '() (DataC-45List1-forget (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (Builtin-snd eta-0)) u--ws)))))))))))))))))))))))))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "impossible") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (let ((u--fc (vector 0 arg-1 arg-3 u--end))) (vector 10 0 0 (TTImpC-45Parser-n--12570-5811-u--getFn arg-4 arg-3 arg-2 arg-1 arg-0 arg-4) (lambda (bind-0) (vector 0 (cons bind-0 (vector 2 u--fc arg-4)))))))))))))))))
(define TTImpC-45Parser-n--12588-6151-u--applyArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (TTImpC-45Parser-n--12588-6151-u--applyArgs arg-0 arg-1 arg-2 (vector 8 e-6 arg-3 e-7) e-3))))))))
(define TTImpC-45Parser-n--12588-6152-u--parseWithArg (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol "|") (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 (TTImpC-45Parser-expr arg-1 arg-0) (lambda () (lambda (u--tm) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (cons (vector 0 arg-1 u--start u--end) u--tm)))))))))))))
(define TTImpC-45Parser-clause (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 (TTImpC-45Parser-expr arg-1 arg-2) (lambda () (lambda (u--lhs) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-n--12588-6152-u--parseWithArg arg-2 arg-1 arg-0)) (lambda (u--extra) (let ((sc0 (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-0 (PreludeC-45TypesC-45List-lengthTR u--extra)))) (cond ((equal? sc0 1) (vector 4 '() 1 "Wrong number of 'with' arguments")) (else (TTImpC-45Parser-parseRHS arg-0 arg-1 arg-2 u--start (TTImpC-45Parser-n--12588-6151-u--applyArgs arg-2 arg-1 arg-0 u--lhs u--extra))))))))))))))
(define TTImpC-45Parser-definition (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 (TTImpC-45Parser-clause 0 arg-0 arg-1) (lambda () (lambda (u--nd) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 2 (vector 0 arg-0 u--start u--end) (Builtin-fst u--nd) (cons (Builtin-snd u--nd) '()))))))))))))
(define TTImpC-45Parser-logLevel (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) '()) (ParserC-45RuleC-45Source-exactIdent "off")) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 csegen-103 ParserC-45RuleC-45Source-unqualifiedName) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many ParserC-45RuleC-45Source-aDotIdent))))) (lambda (u--topic) (vector 9 0 ParserC-45RuleC-45Source-intLit (lambda () (lambda (u--lvl) (vector 0 (box (cons u--topic (PreludeC-45Types-prim__integerToNat u--lvl))))))))))))
(define TTImpC-45Parser-directive (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-pragma "logging") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 TTImpC-45Parser-logLevel (lambda () (lambda (u--lvl) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 10 u--lvl))))))))) (lambda () (vector 9 0 (vector 14 (vector 11 1 (ParserC-45RuleC-45Source-pragma "builtin") (lambda () csegen-2944))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))))
(define TTImpC-45Parser-getRight (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) (else (let ((e-5 (vector-ref arg-2 1))) (box e-5))))))
(define TTImpC-45Parser-getVisibility (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 0 0) (let ((e-8 (car arg-1))) (let ((e-9 (cdr arg-1))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 1))) (TTImpC-45Parser-getVisibility (box e-12) e-9)))(else (let ((e-2 (cdr arg-1))) (TTImpC-45Parser-getVisibility arg-0 e-2))))))) (let ((e-5 (unbox arg-0))) (if (null? arg-1) (vector 0 e-5) (let ((e-15 (car arg-1))) (case (vector-ref e-15 0) ((0) (vector 4 '() 1 "Multiple visibility modifiers"))(else (let ((e-2 (cdr arg-1))) (TTImpC-45Parser-getVisibility arg-0 e-2))))))))))
(define ParserC-45RuleC-45Source-namespaceId (vector 9 0 (vector 14 ParserC-45RuleC-45Source-namespacedIdent) (lambda () (lambda (u--nsid) (vector 12 0 0 (ParserC-45RuleC-45Source-isCapitalisedIdent (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (Builtin-snd eta-0)) u--nsid)) (vector 0 (PreludeC-45Basics-uncurry csegen-521 (let ((e-1 (vector-ref u--nsid 0))) e-1))))))))
(define TTImpC-45Parser-namespaceDecl (vector 11 1 (ParserC-45RuleC-45Source-keyword "namespace") (lambda () (vector 12 0 1 (vector 7 ) ParserC-45RuleC-45Source-namespaceId))))
(define ParserC-45RuleC-45Source-blockAfter (lambda (arg-1 arg-2) (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (vector 0 ) arg-2) csegen-2242)))) (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-1))) (cond ((equal? sc0 1) (vector 0 '())) (else (ParserC-45RuleC-45Source-blockEntries (vector 1 u--col) arg-2))))))))))
(define TTImpC-45Parser-n--13739-6967-u--fieldBody (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 csegen-2874 (lambda () (lambda (u--ns) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-1 arg-0) (lambda () (lambda (u--ty) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (vector (vector 0 arg-1 u--start u--end) csegen-1416 arg-2 (vector 1 (vector 0 u--n)) u--ty)) (DataC-45List1-forget u--ns)))))))))))))))))
(define TTImpC-45Parser-fieldDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-n--13739-6967-u--fieldBody arg-1 arg-0 (vector 0 )) (lambda () (lambda (u--fs) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))) (lambda () (vector 9 0 (TTImpC-45Parser-n--13739-6967-u--fieldBody arg-1 arg-0 (vector 1 )) (lambda () (lambda (u--fs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))
(define TTImpC-45Parser-recordParam (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 (TTImpC-45Parser-pibindListName arg-0 u--start arg-1) (lambda () (lambda (u--params) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-6 (cons e-2 (cons (vector 1 ) e-7)))))))) u--params))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 10 0 1 (vector 13 1 0 (vector 10 0 1 csegen-2894 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-keyword "auto")))) (lambda () (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-keyword "default") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--t) (vector 0 (vector 3 u--t))))))) (lambda () (vector 0 (vector 0 )))))) (lambda (u--info) (vector 9 1 (TTImpC-45Parser-pibindListName arg-0 u--start arg-1) (lambda () (lambda (u--params) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-6 (cons e-2 (cons u--info e-7)))))))) u--params)))))))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (cons (cons u--n (cons AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (cons (vector 1 ) (vector 32 (vector 0 arg-0 u--start u--end) 0)))) '())))))))))))))))
(define TTImpC-45Parser-recordDecl (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 10 0 1 TTImpC-45Parser-dataVisOpt (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (ParserC-45RuleC-45Source-keyword "record") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-recordParam arg-0 arg-1)) (lambda (u--paramss) (let ((u--params (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--paramss))) (vector 11 1 (ParserC-45RuleC-45Source-keyword "where") (lambda () (vector 10 0 1 TTImpC-45Parser-dataOpts (lambda (u--opts) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "constructor") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--dc) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (TTImpC-45Parser-fieldDecl arg-0 eta-0))) (lambda (u--flds) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (let ((u--fc (vector 0 arg-0 u--start u--end))) (vector 4 u--fc '() e-2 e-3 (vector u--fc u--n u--params u--opts u--dc (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--flds)))))))))))))))))))))))))))))))))))))
(define TTImpC-45Parser-fnDirectOpt (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "hint") (lambda () (vector 0 (vector 5 1)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "chaser") (lambda () (vector 0 (vector 5 0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "globalhint") (lambda () (vector 0 (vector 6 1)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "defaulthint") (lambda () (vector 0 (vector 6 0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "inline") (lambda () (vector 0 (vector 1 )))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "noinline") (lambda () (vector 0 (vector 2 )))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-pragma "deprecate") (lambda () (vector 0 (vector 3 )))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-pragma "extern") (lambda () (vector 0 (vector 7 )))))))))))))))))))
(define TTImpC-45Parser-fnOpt (vector 9 0 TTImpC-45Parser-totalityOpt (lambda () (lambda (u--x) (vector 0 (vector 11 u--x))))))
(define TTImpC-45Parser-visOpt (vector 13 1 1 (vector 9 0 TTImpC-45Parser-visOption (lambda () (lambda (u--vis) (vector 0 (vector 0 u--vis))))) (lambda () (vector 13 1 1 (vector 9 0 TTImpC-45Parser-fnOpt (lambda () (lambda (u--tot) (vector 0 (vector 1 u--tot))))) (lambda () (vector 9 0 TTImpC-45Parser-fnDirectOpt (lambda () (lambda (u--opt) (vector 0 (vector 1 u--opt))))))))))
(define TTImpC-45Parser-topDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 10 0 1 TTImpC-45Parser-dataVisOpt (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 9 0 (TTImpC-45Parser-dataDecl arg-0 arg-1) (lambda () (lambda (u--dat) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 1 (vector 0 arg-0 u--start u--end) e-2 e-3 u--dat))))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 TTImpC-45Parser-namespaceDecl (lambda () (lambda (u--ns) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (TTImpC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ds) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 6 (vector 0 arg-0 u--start u--end) u--ns (DataC-45List1-forget u--ds))))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many TTImpC-45Parser-visOpt) (lambda (u--visOpts) (vector 10 0 1 (TTImpC-45Parser-getVisibility '() u--visOpts) (lambda (u--vis) (let ((u--opts (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (TTImpC-45Parser-getRight eta-0)) u--visOpts))) (vector 10 0 1 TTImpC-45Parser-multiplicity (lambda (u--m) (vector 10 0 1 (TTImpC-45Parser-getMult u--m) (lambda (u--rig) (vector 9 0 (TTImpC-45Parser-tyDecl arg-0 arg-1) (lambda () (lambda (u--claim) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 u--start u--end) u--rig u--vis u--opts u--claim)))))))))))))))))) (lambda () (vector 13 1 1 (TTImpC-45Parser-recordDecl arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-directive arg-0 arg-1) (lambda () (TTImpC-45Parser-definition arg-0 arg-1)))))))))))))
(define TTImpC-45Parser-let_ (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "let") (lambda () (vector 10 0 1 TTImpC-45Parser-multiplicity (lambda (u--rigc) (vector 10 0 1 (TTImpC-45Parser-getMult u--rigc) (lambda (u--rig) (vector 9 1 (vector 14 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 11 1 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--val) (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 11 1 (ParserC-45RuleC-45Source-keyword "in") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (let ((u--fc (vector 0 arg-0 u--start u--end))) (vector 3 u--fc (CoreC-45FC-boundToFC arg-0 u--n) u--rig (let ((e-1 (vector-ref u--n 0))) e-1) (vector 32 u--fc 0) u--val u--scope)))))))))))))))))))))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "let") (lambda () (vector 10 0 1 (ParserC-45RuleC-45Source-block (lambda (eta-0) (TTImpC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 11 1 (ParserC-45RuleC-45Source-keyword "in") (lambda () (vector 9 0 (TTImpC-45Parser-typeExpr arg-0 arg-1) (lambda () (lambda (u--scope) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 5 (vector 0 arg-0 u--start u--end) (TTImpC-45Parser-collectDefs u--ds) u--scope))))))))))))))))))))
(define TTImpC-45Parser-binder (lambda (arg-0 arg-1) (vector 13 1 1 (TTImpC-45Parser-autoImplicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-forall_ arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-implicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-explicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-lam arg-0 arg-1) (lambda () (TTImpC-45Parser-let_ arg-0 arg-1)))))))))))))
(define TTImpC-45Parser-field (lambda (arg-0 arg-1) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol "->") ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--path) (vector 9 1 (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-symbol "=") (lambda () (vector 0 (lambda (eta-0) (lambda (eta-1) (vector 0 eta-0 eta-1)))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-symbol "$=") (lambda () (vector 0 (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0 eta-1)))))))) (lambda () (lambda (u--upd) (vector 9 0 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--val) (vector 0 ((u--upd (DataC-45List1-forget u--path)) u--val)))))))))))))
(define TTImpC-45Parser-record_ (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "record") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (ParserC-45RuleC-45Source-symbol ",") (TTImpC-45Parser-field arg-0 arg-1)) (lambda () (lambda (u--fs) (vector 11 1 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--sc) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 7 (vector 0 arg-0 u--start u--end) (DataC-45List1-forget u--fs) u--sc)))))))))))))))))))))
(define TTImpC-45Parser-rewrite_ (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-keyword "rewrite") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--rule) (vector 11 1 (ParserC-45RuleC-45Source-keyword "in") (lambda () (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 14 (vector 0 arg-0 u--start u--end) u--rule u--tm))))))))))))))))))
(define TTImpC-45Parser-simpleExpr (lambda (arg-0 arg-1) (vector 13 1 1 (TTImpC-45Parser-as arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-atom arg-0) (lambda () (vector 13 1 1 (TTImpC-45Parser-binder arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-rewrite_ arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-record_ arg-0 arg-1) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-symbol "(") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--e) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 u--e))))))))))))))))))))
(define TTImpC-45Parser-argExpr (lambda (arg-0 arg-1) (vector 13 1 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--arg) (vector 0 (vector 0 u--arg)))))) (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (TTImpC-45Parser-implicitArg arg-0 arg-1) (lambda () (lambda (u--arg) (vector 0 (vector 1 u--arg))))))))))
(define TTImpC-45Parser-caseRHS (lambda (arg-0 arg-1 arg-2 arg-3) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--rhs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 0 (vector 0 arg-0 arg-2 u--end) arg-3 u--rhs))))))))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-keyword "impossible") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 2 (vector 0 arg-0 arg-2 u--end) arg-3)))))))))))
(define TTImpC-45Parser-caseAlt (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 1 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--lhs) (TTImpC-45Parser-caseRHS arg-0 arg-1 u--start u--lhs))))))))
(define TTImpC-45Parser-case_ (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many TTImpC-45Parser-fnOpt) (lambda (u--opts) (vector 11 1 (ParserC-45RuleC-45Source-keyword "case") (lambda () (vector 9 1 (TTImpC-45Parser-expr arg-0 arg-1) (lambda () (lambda (u--scr) (vector 11 0 (ParserC-45RuleC-45Source-keyword "of") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (TTImpC-45Parser-caseAlt arg-0 eta-0))) (lambda (u--alts) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (let ((u--fc (vector 0 arg-0 u--start u--end))) (vector 4 u--fc u--opts u--scr (vector 32 u--fc 0) u--alts))))))))))))))))))))
(define TTImpC-45Parser-lazy (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Lazy") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 20 (vector 0 arg-0 u--start u--end) 1 u--tm))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Inf") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 20 (vector 0 arg-0 u--start u--end) 0 u--tm))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Delay") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 21 (vector 0 arg-0 u--start u--end) u--tm))))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "Force") (lambda () (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--tm) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 22 (vector 0 arg-0 u--start u--end) u--tm)))))))))))))))))))
(define TTImpC-45Parser-n--9636-3034-u--applyExpImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (TTImpC-45Parser-n--9636-3034-u--applyExpImp arg-0 arg-1 arg-2 arg-3 (vector 8 (vector 0 arg-1 arg-2 arg-3) arg-4 e-6) e-3))) (else (let ((e-9 (vector-ref e-2 1))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (if (null? e-12) (TTImpC-45Parser-n--9636-3034-u--applyExpImp arg-0 arg-1 arg-2 arg-3 (vector 9 (vector 0 arg-1 arg-2 arg-3) arg-4 e-13) e-3) (let ((e-15 (unbox e-12))) (TTImpC-45Parser-n--9636-3034-u--applyExpImp arg-0 arg-1 arg-2 arg-3 (vector 10 (vector 0 arg-1 arg-2 arg-3) arg-4 e-15 e-13) e-3)))))))))))))
(define TTImpC-45Parser-appExpr (lambda (arg-0 arg-1) (vector 13 1 1 (TTImpC-45Parser-case_ arg-0 arg-1) (lambda () (vector 13 1 1 (TTImpC-45Parser-lazy arg-0 arg-1) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 (TTImpC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--f) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (TTImpC-45Parser-argExpr arg-0 arg-1)) (lambda (u--args) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-n--9636-3034-u--applyExpImp arg-1 arg-0 u--start u--end u--f u--args)))))))))))))))))
(define TTImpC-45Parser-n--9858-5534-u--mkPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (vector 1 (vector 0 arg-1 arg-2 arg-3) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega e-6 '() arg-4 (TTImpC-45Parser-n--9858-5534-u--mkPi arg-0 arg-1 arg-2 arg-3 e-7 e-3)))))))))
(define TTImpC-45Parser-typeExpr (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--arg) (vector 13 1 0 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (vector 9 0 (LibrariesC-45TextC-45Parser-some (vector 9 1 TTImpC-45Parser-bindSymbol (lambda () (lambda (u--exp) (vector 9 0 (TTImpC-45Parser-appExpr arg-0 arg-1) (lambda () (lambda (u--op) (vector 0 (cons u--exp u--op))))))))) (lambda () (lambda (u--rest) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (TTImpC-45Parser-n--9858-5534-u--mkPi arg-1 arg-0 u--start u--end u--arg (DataC-45List1-forget u--rest))))))))) (lambda () (vector 0 u--arg))))))))))
(define TTImpC-45Parser-expr (lambda (ext-0 ext-1) (TTImpC-45Parser-typeExpr ext-0 ext-1)))
(define ParserC-45RuleC-45Source-init 0)
(define csegen-2967 (TTImpC-45Parser-expr (vector 2 (vector 0 )) ParserC-45RuleC-45Source-init))
(define CoreC-45FC-prettyPos (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (CoreC-45FC-showPos ext-0))))
(define CoreC-45FC-u--pretty_Pretty_Void_FC (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "EmptyFC")) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-962 e-0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (CoreC-45FC-prettyPos e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "--")) (CoreC-45FC-prettyPos e-2)))))) (else (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-962 e-3) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (CoreC-45FC-prettyPos e-4)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "--")) (CoreC-45FC-prettyPos e-5)))))))))
(define CoreC-45FC-u--prettyPrec_Pretty_Void_FC (lambda (arg-0 arg-1) (CoreC-45FC-u--pretty_Pretty_Void_FC arg-1)))
(define csegen-3005 (cons (lambda (arg-11067) (CoreC-45FC-u--pretty_Pretty_Void_FC arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45FC-u--prettyPrec_Pretty_Void_FC arg-11073 arg-11076)))))
(define csegen-3006 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45String-lines e-5)))))))
(define CoreC-45TT-u--pretty_Pretty_Void_Visibility (lambda (arg-0) (cond ((equal? arg-0 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "private")) ((equal? arg-0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "export")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "public") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "export"))))))
(define CoreC-45TT-u--prettyPrec_Pretty_Void_Visibility (lambda (arg-0 arg-1) (CoreC-45TT-u--pretty_Pretty_Void_Visibility arg-1)))
(define csegen-3029 (cons (lambda (arg-11067) (CoreC-45TT-u--pretty_Pretty_Void_Visibility arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45TT-u--prettyPrec_Pretty_Void_Visibility arg-11073 arg-11076)))))
(define csegen-3035 (cons (lambda (arg-11067) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (IdrisC-45Pretty-u--prettyPrec_Pretty_IdrisSyntax_IPTerm arg-11073 arg-11076)))))
(define csegen-3037 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "and"))
(define IdrisC-45Error-keyword (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) ext-0)))
(define csegen-3055 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "export")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "public") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "export"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "modifier. By default, all names are") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "private")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "in namespace blocks.")))))))
(define csegen-3061 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\s) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))
(define IdrisC-45Pretty-code (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) ext-0)))
(define csegen-3081 (lambda (eta-0) (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 eta-0))))
(define SystemC-45FileC-45Error-u--showPrec_Show_FileError (lambda (arg-0 arg-1) (SystemC-45FileC-45Error-u--show_Show_FileError arg-1)))
(define csegen-3096 (cons (lambda (u--x) (SystemC-45FileC-45Error-u--show_Show_FileError u--x)) (lambda (u--d) (lambda (u--x) (SystemC-45FileC-45Error-u--showPrec_Show_FileError u--d u--x)))))
(define IdrisC-45Pretty-errorDesc (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) ext-0)))
(define csegen-3105 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Couldn't parse any alternatives") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))
(define csegen-3125 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "?"))
(define csegen-3126 (lambda (eta-0) (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 eta-0))))
(define IdrisC-45DocC-45Annotations-header (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) arg-0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)))
(define csegen-3136 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Constructor")))
(define csegen-3137 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Constructors")))
(define csegen-3138 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 eta-0)))
(define csegen-3139 (lambda (eta-0) (vector 1 (cons '() '()))))
(define csegen-3141 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Projections")))
(define csegen-3146 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Implementations")))
(define csegen-3149 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Fixity Declarations")) (vector 3 )))
(define csegen-3153 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Hints")))
(define csegen-3154 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Visibility")))
(define csegen-3156 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Totality")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\;))
(define CoreC-45TT-u--pretty_Pretty_Void_Covering (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "covering")) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering all cases")) (else (let ((e-1 (vector-ref arg-0 1))) (if (null? e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering due to calls to functions") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) e-1))) (let ((e-3 (car e-1))) (let ((e-4 (cdr e-1))) (if (null? e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering due to call to function") (CoreC-45Name-u--pretty_Pretty_Void_Name e-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not covering due to calls to functions") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) e-1))))))))))))
(define CoreC-45TT-u--pretty_Pretty_Void_PartialReason (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not strictly positive")) ((1) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to calls to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) e-0))) (let ((e-5 (car e-0))) (let ((e-6 (cdr e-0))) (if (null? e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to call to") (CoreC-45Name-u--pretty_Pretty_Void_Name e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to calls to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) e-0))))))))) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (if (null? e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to function") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Void_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "being reachable via") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-880 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-1)))))) (let ((e-10 (cdr e-1))) (if (null? e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to call to") (CoreC-45Name-u--pretty_Pretty_Void_Name e-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to function") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45Name-u--pretty_Pretty_Void_Name e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "being reachable via") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-880 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-1)))))))))))) (else (let ((e-3 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "possibly not terminating due to recursive path") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-880 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--pretty_Pretty_Void_Name eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-3)))))))))
(define CoreC-45TT-u--pretty_Pretty_Void_Terminating (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not yet checked")) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "terminating")) (else (let ((e-0 (vector-ref arg-0 1))) (CoreC-45TT-u--pretty_Pretty_Void_PartialReason e-0))))))
(define CoreC-45TT-u--pretty_Pretty_Void_Totality (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (case (vector-ref e-0 0) ((1) (case (vector-ref e-1 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "total"))(else (CoreC-45TT-u--pretty_Pretty_Void_Covering e-1))))(else (case (vector-ref e-1 0) ((0) (CoreC-45TT-u--pretty_Pretty_Void_Terminating e-0))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45TT-u--pretty_Pretty_Void_Covering e-1) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-semi) (CoreC-45TT-u--pretty_Pretty_Void_Terminating e-0))))))))))
(define CoreC-45TT-u--prettyPrec_Pretty_Void_Totality (lambda (arg-0 arg-1) (CoreC-45TT-u--pretty_Pretty_Void_Totality arg-1)))
(define csegen-3158 (cons (lambda (arg-11067) (CoreC-45TT-u--pretty_Pretty_Void_Totality arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45TT-u--prettyPrec_Pretty_Void_Totality arg-11073 arg-11076)))))
(define csegen-3165 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--pure_Applicative_List e-5)))))))
(define csegen-3176 (vector 1 1 0 1))
(define csegen-3248 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Laziness compiler primitive")))
(define csegen-3715 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "holes") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))
(define ProtocolC-45IDE-u--toSExp_SExpable_C-40SpanC-32C-36aC-41 (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 0 (cons (vector 3 e-1) (cons (vector 3 e-2) (cons (arg-1 e-3) '())))))))))
(define ProtocolC-45IDEC-45Decoration-u--toSExp_SExpable_Decoration (lambda (arg-0) (vector 0 (cons (vector 4 "decor") (cons (vector 4 (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration arg-0)) '())))))
(define ProtocolC-45IDEC-45Formatting-u--show_Show_Formatting (lambda (arg-0) (cond ((equal? arg-0 0) "bold") ((equal? arg-0 1) "italic") (else "underline"))))
(define ProtocolC-45IDEC-45Formatting-u--toSExp_SExpable_Formatting (lambda (arg-0) (vector 0 (cons (vector 4 "text-formatting") (cons (vector 4 (ProtocolC-45IDEC-45Formatting-u--show_Show_Formatting arg-0)) '())))))
(define ProtocolC-45IDEC-45Formatting-u--toSExp_SExpable_Properties (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (vector 0 (DataC-45List-catMaybes (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (ProtocolC-45IDEC-45Formatting-u--toSExp_SExpable_Formatting eta-0)) e-1) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (ProtocolC-45IDEC-45Decoration-u--toSExp_SExpable_Decoration eta-0)) e-0) '()))))))))
(define csegen-3717 (lambda (eta-0) (ProtocolC-45IDE-u--toSExp_SExpable_C-40SpanC-32C-36aC-41 (lambda (eta-1) (ProtocolC-45IDEC-45Formatting-u--toSExp_SExpable_Properties eta-1)) eta-0)))
(define ProtocolC-45SExp-u--toSExp_SExpable_Int (lambda (ext-0) (vector 3 ext-0)))
(define csegen-3718 (cons (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_Int eta-0)) (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_Int eta-0))))
(define csegen-3774 (cons (lambda (arg-8474) (lambda (arg-8477) (vector 0 ))) (vector 0 )))
(define csegen-3785 (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-union eta-0 eta-1))))
(define CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TTC-45Primitive-u--C-60C-61_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TTC-45Primitive-u--compare_Ord_Constant arg-0 arg-1) 2)))
(define CoreC-45TTC-45Primitive-u--C-60_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TTC-45Primitive-u--compare_Ord_Constant arg-0 arg-1) 0)))
(define CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TTC-45Primitive-u--compare_Ord_Constant arg-0 arg-1) 0)))
(define CoreC-45TTC-45Primitive-u--C-62_Ord_Constant (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TTC-45Primitive-u--compare_Ord_Constant arg-0 arg-1) 2)))
(define CoreC-45TTC-45Primitive-u--max_Ord_Constant (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TTC-45Primitive-u--C-62_Ord_Constant arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45TTC-45Primitive-u--min_Ord_Constant (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TTC-45Primitive-u--C-60_Ord_Constant arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-3796 (vector (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (CoreC-45TTC-45Primitive-u--compare_Ord_Constant arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45TTC-45Primitive-u--C-60_Ord_Constant arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45TTC-45Primitive-u--C-62_Ord_Constant arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45TTC-45Primitive-u--C-60C-61_Ord_Constant arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Constant arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45TTC-45Primitive-u--max_Ord_Constant arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45TTC-45Primitive-u--min_Ord_Constant arg-1626 arg-1629)))))
(define csegen-3803 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2025 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-2025 u--d u--x))))))
(define csegen-3808 (lambda (eta-0) (lambda (eta-1) (PreludeC-45TypesC-45List-tailRecAppend eta-0 eta-1))))
(define csegen-3813 (vector 1 (cons '() (lambda (eta-0) (vector 1 '())))))
(define csegen-3814 (lambda (eta-0) csegen-3813))
(define csegen-3823 (lambda (eta-0) (let ((e-4 (vector-ref eta-0 3))) e-4)))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_AltTypeC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (vector 1 )) (else (let ((e-3 (vector-ref arg-3 1))) (vector 2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-3)))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_FnOptC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (vector 1 )) ((2) (vector 2 )) ((3) (vector 3 )) ((4) (vector 4 )) ((5) (let ((e-6 (vector-ref arg-3 1))) (vector 5 e-6))) ((6) (let ((e-8 (vector-ref arg-3 1))) (vector 6 e-8))) ((7) (vector 7 )) ((8) (let ((e-11 (vector-ref arg-3 1))) (vector 8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-11)))) ((9) (let ((e-13 (vector-ref arg-3 1))) (vector 9 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-13)))) ((10) (vector 10 )) ((11) (let ((e-16 (vector-ref arg-3 1))) (vector 11 e-16))) ((12) (vector 12 )) (else (let ((e-19 (vector-ref arg-3 1))) (vector 13 e-19))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldUpdateC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-2))))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (vector 1 e-4 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-5))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (vector 0 e-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-2) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-3)))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (let ((e-9 (vector-ref arg-3 5))) (let ((e-10 (vector-ref arg-3 6))) (let ((e-11 (vector-ref arg-3 7))) (vector 1 e-5 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-6) e-7 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-8) e-9 e-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 arg-2 eta-0)) e-11)))))))))) (else (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (vector 2 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-14))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpTyC-39 (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (vector e-1 e-2 e-3 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-4))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDataC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-3) e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpTyC-39 arg-2 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 1 e-7 e-8 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-9)))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpParameterC-39 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-10) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-11))))))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldC-39 (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector e-1 e-2 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-3) e-4 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-5)))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpRecordC-39 (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((e-6 (vector-ref arg-3 5))) (vector e-1 e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpParameterC-39 arg-2 eta-0)) e-3) e-4 e-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldC-39 arg-2 eta-0)) e-6))))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_FnOptC-39 arg-2 eta-0)) e-4) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpTyC-39 arg-2 e-5)))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (vector 1 e-7 e-8 e-9 (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDataC-39 arg-2 e-10))))))) ((2) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (vector 2 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 arg-2 eta-0)) e-14)))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (vector 3 e-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpParameterC-39 arg-2 eta-0)) e-17) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-18)))))) ((4) (let ((e-20 (vector-ref arg-3 1))) (let ((e-21 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 3))) (let ((e-23 (vector-ref arg-3 4))) (let ((e-24 (vector-ref arg-3 5))) (vector 4 e-20 e-21 e-22 e-23 (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpRecordC-39 arg-2 e-24)))))))) ((5) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (vector 5 e-26 e-27 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-28)))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (vector 6 e-30 e-31 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-32)))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (vector 7 e-34 e-35 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-36) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-37))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (vector 8 e-39 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-40))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 e-43 (lambda (vars-9221) (e-44 vars-9221))))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (vector 10 e-46))) (else (let ((e-48 (vector-ref arg-3 1))) (let ((e-49 (vector-ref arg-3 2))) (let ((e-50 (vector-ref arg-3 3))) (vector 11 e-48 e-49 e-50))))))))
(define TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-1 (arg-2 e-2))))) ((1) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (let ((e-8 (vector-ref arg-3 5))) (let ((e-9 (vector-ref arg-3 6))) (vector 1 e-4 e-5 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-6) e-7 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-8) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-9))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-15 (vector-ref arg-3 5))) (let ((e-16 (vector-ref arg-3 6))) (vector 2 e-11 e-12 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-13) e-14 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-15) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-16))))))))) ((3) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (let ((e-23 (vector-ref arg-3 6))) (let ((e-24 (vector-ref arg-3 7))) (vector 3 e-18 e-19 e-20 e-21 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-22) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-23) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-24)))))))))) ((4) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (let ((e-30 (vector-ref arg-3 5))) (vector 4 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_FnOptC-39 arg-2 eta-0)) e-27) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-28) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-29) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpClauseC-39 arg-2 eta-0)) e-30)))))))) ((5) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (vector 5 e-32 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-33) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-34)))))) ((6) (let ((e-36 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-38 (vector-ref arg-3 3))) (let ((e-39 (vector-ref arg-3 4))) (let ((e-40 (vector-ref arg-3 5))) (vector 6 e-36 e-37 e-38 e-39 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-40)))))))) ((7) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 7 e-42 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_IFieldUpdateC-39 arg-2 eta-0)) e-43) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-44)))))) ((8) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (vector 8 e-46 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-47) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-48)))))) ((9) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (vector 9 e-50 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-51) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-52)))))) ((10) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (let ((e-56 (vector-ref arg-3 3))) (let ((e-57 (vector-ref arg-3 4))) (vector 10 e-54 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-55) e-56 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-57))))))) ((11) (let ((e-59 (vector-ref arg-3 1))) (let ((e-60 (vector-ref arg-3 2))) (let ((e-61 (vector-ref arg-3 3))) (vector 11 e-59 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-60) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-61)))))) ((12) (let ((e-63 (vector-ref arg-3 1))) (let ((e-64 (vector-ref arg-3 2))) (vector 12 e-63 e-64)))) ((13) (let ((e-66 (vector-ref arg-3 1))) (let ((e-67 (vector-ref arg-3 2))) (let ((e-68 (vector-ref arg-3 3))) (vector 13 e-66 (TTImpC-45TTImpC-45Functor-u--map_Functor_AltTypeC-39 arg-2 e-67) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 eta-0)) e-68)))))) ((14) (let ((e-70 (vector-ref arg-3 1))) (let ((e-71 (vector-ref arg-3 2))) (let ((e-72 (vector-ref arg-3 3))) (vector 14 e-70 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-71) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-72)))))) ((15) (let ((e-74 (vector-ref arg-3 1))) (let ((e-75 (vector-ref arg-3 2))) (vector 15 e-74 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-75))))) ((16) (let ((e-77 (vector-ref arg-3 1))) (let ((e-78 (vector-ref arg-3 2))) (let ((e-79 (vector-ref arg-3 3))) (vector 16 e-77 e-78 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-79)))))) ((17) (let ((e-81 (vector-ref arg-3 1))) (let ((e-82 (vector-ref arg-3 2))) (vector 17 e-81 e-82)))) ((18) (let ((e-84 (vector-ref arg-3 1))) (let ((e-85 (vector-ref arg-3 2))) (let ((e-86 (vector-ref arg-3 3))) (let ((e-87 (vector-ref arg-3 4))) (let ((e-88 (vector-ref arg-3 5))) (vector 18 e-84 e-85 e-86 e-87 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-88)))))))) ((19) (let ((e-90 (vector-ref arg-3 1))) (let ((e-91 (vector-ref arg-3 2))) (let ((e-92 (vector-ref arg-3 3))) (vector 19 e-90 e-91 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-92)))))) ((20) (let ((e-94 (vector-ref arg-3 1))) (let ((e-95 (vector-ref arg-3 2))) (let ((e-96 (vector-ref arg-3 3))) (vector 20 e-94 e-95 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-96)))))) ((21) (let ((e-98 (vector-ref arg-3 1))) (let ((e-99 (vector-ref arg-3 2))) (vector 21 e-98 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-99))))) ((22) (let ((e-101 (vector-ref arg-3 1))) (let ((e-102 (vector-ref arg-3 2))) (vector 22 e-101 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-102))))) ((23) (let ((e-104 (vector-ref arg-3 1))) (let ((e-105 (vector-ref arg-3 2))) (vector 23 e-104 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-105))))) ((24) (let ((e-107 (vector-ref arg-3 1))) (let ((e-108 (vector-ref arg-3 2))) (vector 24 e-107 e-108)))) ((25) (let ((e-110 (vector-ref arg-3 1))) (let ((e-111 (vector-ref arg-3 2))) (vector 25 e-110 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Functor-u--map_Functor_ImpDeclC-39 arg-2 eta-0)) e-111))))) ((26) (let ((e-113 (vector-ref arg-3 1))) (let ((e-114 (vector-ref arg-3 2))) (vector 26 e-113 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-114))))) ((27) (let ((e-116 (vector-ref arg-3 1))) (let ((e-117 (vector-ref arg-3 2))) (let ((e-118 (vector-ref arg-3 3))) (vector 27 e-116 e-117 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-118)))))) ((28) (let ((e-120 (vector-ref arg-3 1))) (let ((e-121 (vector-ref arg-3 2))) (vector 28 e-120 e-121)))) ((29) (let ((e-123 (vector-ref arg-3 1))) (vector 29 e-123))) ((30) (let ((e-125 (vector-ref arg-3 1))) (let ((e-126 (vector-ref arg-3 2))) (vector 30 e-125 e-126)))) ((31) (let ((e-128 (vector-ref arg-3 1))) (let ((e-129 (vector-ref arg-3 2))) (let ((e-130 (vector-ref arg-3 3))) (vector 31 e-128 e-129 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-130)))))) ((32) (let ((e-132 (vector-ref arg-3 1))) (let ((e-133 (vector-ref arg-3 2))) (vector 32 e-132 e-133)))) (else (let ((e-135 (vector-ref arg-3 1))) (let ((e-136 (vector-ref arg-3 2))) (let ((e-137 (vector-ref arg-3 3))) (vector 33 e-135 e-136 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 arg-2 e-137)))))))))
(define csegen-3827 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-5)))))))
(define IdrisC-45PackageC-45Types-u--show_Show_PkgVersion (lambda (arg-0) (CoreC-45NameC-45Namespace-showSep "." (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_Nat eta-0)) (DataC-45List1-forget arg-0)))))
(define IdrisC-45PackageC-45Types-u--showPrec_Show_PkgVersion (lambda (arg-0 arg-1) (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion arg-1)))
(define csegen-3833 (cons (lambda (u--x) (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45PackageC-45Types-u--showPrec_Show_PkgVersion u--d u--x)))))
(define csegen-3841 (vector 0 (vector 2 ) (vector 1 (vector 0 "main"))))
(define csegen-3842 (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)))
(define csegen-3863 (lambda (arg-0) (DataC-45String-isSuffixOf ".ipkg" arg-0)))
(define csegen-3872 (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Not a searchable hole"))))
(define CoreC-45FC-defaultFC (cons (vector 2 (vector 0 )) (cons (cons 0 0) (cons 0 0))))
(define CoreC-45FC-justFC (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 e-2 e-6 e-7)))))))
(define CoreC-45FC-replFC (CoreC-45FC-justFC CoreC-45FC-defaultFC))
(define csegen-3874 (lambda (eta-0) (vector 21 CoreC-45FC-replFC 1 eta-0)))
(define csegen-3876 (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Don't know what to do"))))
(define SystemC-45FileC-45Process-fflush (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-8 (vector-ref e-5 0))) ((((e-8 'erased) 'erased) (lambda (eta-0) (vector 0 ))) (let ((e-9 (cdr arg-1))) ((e-9 'erased) (lambda (eta-0) (SystemC-45FileC-45Process-prim__flush arg-2 eta-0))))))))))
(define csegen-3886 (SystemC-45FileC-45Process-fflush csegen-82 SystemC-45FileC-45Virtual-stdout))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 e-2))) ((2) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (vector 2 e-4 e-5)))) ((3) (vector 3 )) ((4) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (vector 4 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-8))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-9))))))) ((5) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-12))))) ((6) (let ((e-14 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 2))) (vector 6 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-15))))) ((7) (let ((e-17 (vector-ref arg-3 1))) (let ((e-18 (vector-ref arg-3 2))) (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-17))) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-18))))))) ((8) (let ((e-20 (vector-ref arg-3 1))) (vector 8 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-20 u--x)))))) ((9) (let ((e-22 (vector-ref arg-3 1))) (vector 9 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-22 u--x)))))) ((10) (let ((e-24 (vector-ref arg-3 1))) (vector 10 (lambda (u--x) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 (e-24 u--x)))))) (else (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (vector 11 eta-0 eta-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations arg-2 e-27) (arg-2 e-26))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (arg-2 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-alterAnnotations (lambda (eta-0) (PreludeC-45Types-u--pure_Applicative_List (arg-2 eta-0))) ext-0)))
(define csegen-3892 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-1) (vector 6 eta-1)) eta-0)))
(define csegen-3894 (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "No search results")))))
(define csegen-3895 (lambda (eta-0) csegen-3872))
(define csegen-3896 (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "No more results"))))
(define csegen-3898 (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Source line not found"))))
(define csegen-3899 (lambda (eta-0) csegen-3898))
(define csegen-3903 (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Can't make lifted definition"))))
(define csegen-3904 (lambda (eta-0) csegen-3903))
(define csegen-3906 (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Invalid literate Idris")))))
(define csegen-3908 (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Source line not available")))))
(define csegen-3911 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-lookupCtxtExact eta-0 eta-1))))
(define csegen-3912 (lambda (eta-0) (let ((e-1 (vector-ref eta-0 1))) e-1)))
(define CoreC-45OptionsC-45Log-u--showPrec_Show_LogLevel (lambda (arg-0 arg-1) (CoreC-45OptionsC-45Log-u--show_Show_LogLevel arg-1)))
(define csegen-3952 (cons (lambda (u--x) (CoreC-45OptionsC-45Log-u--show_Show_LogLevel u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45OptionsC-45Log-u--showPrec_Show_LogLevel u--d u--x)))))
(define csegen-3961 (lambda (eta-0) (let ((sc0 (PreludeC-45Types-isSpace eta-0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define csegen-3962 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45Name-nameRoot e-2) "-"))) (cond ((equal? sc1 1) 0) (else 1))))))
(define csegen-3963 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-2 (vector 1 (vector 0 "-"))))) (cond ((equal? sc1 1) 0) (else 1))))))
(define CoreC-45NameC-45Namespace-u--showPrec_Show_ModuleIdent (lambda (arg-0 arg-1) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1)))
(define csegen-3969 (cons (cons (lambda (u--x) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45NameC-45Namespace-u--showPrec_Show_ModuleIdent u--d u--x)))) csegen-493))
(define csegen-3972 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (Builtin-snd e-5)))))))
(define csegen-3974 (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) e-11)))))
(define csegen-3980 (vector 0 (vector 2 ) (vector 2 "lamc" 0)))
(define csegen-3983 (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0)))
(define csegen-3984 (cons csegen-972 csegen-835))
(define csegen-3991 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2566 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-2566 u--d u--x))))))
(define csegen-3995 (cons csegen-849 csegen-835))
(define csegen-3998 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3995 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3995 u--d u--x)))))
(define csegen-3999 (cons csegen-65 csegen-3998))
(define csegen-4002 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3999 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3999 u--d u--x)))))
(define csegen-4003 (cons csegen-972 csegen-3998))
(define csegen-4012 (cons csegen-849 csegen-838))
(define csegen-4016 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4012 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4012 u--d u--x))))))
(define csegen-4019 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4016 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4016 u--d u--x)))))
(define csegen-4023 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4019 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-4019 u--d u--x))))))
(define csegen-4033 (cons (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-835 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-835 u--d u--x)))) csegen-835))
(define csegen-4037 (cons csegen-849 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4033 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4033 u--d u--x))))))
(define csegen-4041 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4037 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4037 u--d u--x))))))
(define csegen-4046 (cons csegen-65 csegen-264))
(define csegen-4058 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "B")))
(define csegen-4077 (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Bad expression, expected") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-4058 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "_ -> B")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "A -> B")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ", where")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "A")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "and") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-4058 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "are spines of global names")))))))))))))
(define csegen-4080 (box (cons (box 7) (box 0))))
(define LibrariesC-45DataC-45SortedMap-fromList (lambda (arg-2 arg-3) (PreludeC-45Types-u--foldl_Foldable_List csegen-790 (LibrariesC-45DataC-45SortedMap-empty arg-2) arg-3)))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_AltType (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 0 ))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (let ((act-2 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "AltType" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_BindMode (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-6))))) eff-0) clam-0)))))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 3 ))) ((equal? e-5 3) (vector 1 (vector 2 )))(else (CoreC-45BinaryC-45Prims-corrupt "BindMode" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_AltType (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-3) ext-0)))))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_BindMode (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-0) ext-0)))))) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpClause (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-0 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 1 e-6 e-7 e-8 e-9 e-10 '() e-11))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "ImpClause" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpClause (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-3) ext-0)))))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-5 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-6) ext-0)))))))))) (else (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (let ((e-12 (vector-ref arg-1 5))) (let ((e-14 (vector-ref arg-1 7))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-8 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-9) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-10) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-11) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 e-12) ext-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-0 e-14 ext-0)))))))))))))))))))))))))))))
(define csegen-4188 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpClause arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpClause arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_FnOpt (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 (vector 1 ))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-6))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-6))))) eff-0) clam-0)))))) ((equal? e-5 3) (vector 1 (vector 7 ))) ((equal? e-5 4) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-6))))) eff-0) clam-0)))))) ((equal? e-5 5) (vector 1 (vector 10 ))) ((equal? e-5 6) (vector 1 (vector 11 0))) ((equal? e-5 7) (vector 1 (vector 11 1))) ((equal? e-5 8) (vector 1 (vector 11 2))) ((equal? e-5 9) (vector 1 (vector 12 ))) ((equal? e-5 10) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-6))))) eff-0) clam-0)))))) ((equal? e-5 11) (vector 1 (vector 4 ))) ((equal? e-5 12) (vector 1 (vector 2 ))) ((equal? e-5 13) (vector 1 (vector 0 ))) ((equal? e-5 14) (vector 1 (vector 3 ))) ((equal? e-5 15) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-6))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "FnOpt" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_FnOpt (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 0 clam-0)) ((5) (let ((e-2 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-2) clam-0)))))) ((6) (let ((e-4 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-4) clam-0)))))) ((7) (CoreC-45BinaryC-45Prims-tag arg-0 3 clam-0)) ((8) (let ((e-7 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 e-7 clam-0)))))) ((10) (CoreC-45BinaryC-45Prims-tag arg-0 5 clam-0)) ((11) (let ((e-10 (vector-ref arg-1 1))) (cond ((equal? e-10 0) (CoreC-45BinaryC-45Prims-tag arg-0 6 clam-0)) ((equal? e-10 1) (CoreC-45BinaryC-45Prims-tag arg-0 7 clam-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 8 clam-0))))) ((12) (CoreC-45BinaryC-45Prims-tag arg-0 9 clam-0)) ((13) (let ((e-13 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-13 clam-0)))))) ((4) (CoreC-45BinaryC-45Prims-tag arg-0 11 clam-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 12 clam-0)) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 13 clam-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 14 clam-0)) (else (let ((e-19 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 15 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 e-19 clam-0))))))))))
(define csegen-4198 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_FnOpt arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_FnOpt arg-5542 eta-0))))))
(define CoreC-45ContextC-45TTC-u--fromBuf_TTC_BuiltinType (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2))(else (CoreC-45BinaryC-45Prims-corrupt "BuiltinType" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_DataOpt (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-6))))) eff-0) clam-0)))))) ((equal? e-5 1) (vector 1 (vector 1 ))) ((equal? e-5 2) (vector 1 (vector 2 ))) ((equal? e-5 3) (vector 1 (vector 3 ))) ((equal? e-5 4) (vector 1 (vector 4 )))(else (CoreC-45BinaryC-45Prims-corrupt "DataOpt" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_DataOpt (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-0 ext-0)))))) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) ((3) (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0)))))
(define csegen-4225 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_DataOpt arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_DataOpt arg-5542 eta-0)))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpTy (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-5 e-6 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpTy (lambda (arg-0 arg-1 ext-0) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-2 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-3) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-4) ext-0))))))))))))))))
(define csegen-4235 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpTy arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpTy arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpData (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-4182) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4225 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4235) arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 0 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "ImpData" clam-0)))))) eff-0) ext-0)))))))
(define csegen-4211 (lambda () (cons (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-5542 eta-0)))) (csegen-4182))))
(define csegen-4215 (lambda () (cons (cons (lambda (arg-5529) (lambda (arg-5534) (CoreC-45TTC-u--toBuf_TTC_RigCount arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-5542 eta-0)))) (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-4211) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-4211) arg-5542 eta-0)))))))
(define csegen-4219 (lambda () (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-4215) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-4215) arg-5542 eta-0)))))))
(define csegen-4222 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-4219) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (csegen-4219) arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_IField (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector e-5 e-6 e-7 e-8 e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_IField (lambda (arg-0 arg-1 ext-0) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-0 e-3 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-4) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-5) ext-0))))))))))))))))))))
(define csegen-4228 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_IField arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_IField arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpRecord (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4222) arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4225 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4228) arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector e-5 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define csegen-4179 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45TTC-u--toBuf_TTC_TotalReq arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-5542 eta-0)))))
(define csegen-4229 (cons csegen-1744 csegen-1535))
(define csegen-4232 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4229 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4229 arg-5542 eta-0)))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpDecl (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4198) arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpTy arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 0 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-1566 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4179 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpData arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 1 e-6 e-7 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4222) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1559 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-1566 arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4179 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpRecord arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 4 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 6 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 7 e-6 e-7 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4232 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-6))))) eff-0) clam-0)))))) ((equal? e-5 9) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45TTC-u--fromBuf_TTC_BuiltinType arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 11 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "ImpDecl" clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 (lambda (arg-2 arg-3 arg-4) (LibrariesC-45DataC-45WithDefault-onWithDefault (lambda () (lambda (eta-0) (CoreC-45BinaryC-45Prims-tag arg-3 0 eta-0))) (lambda (u--v) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-3 1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-1 (car arg-2))) (((e-1 arg-3) u--v) eta-0))))))) arg-4)))
(define CoreC-45ContextC-45TTC-u--toBuf_TTC_BuiltinType (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpData (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 (csegen-4182) arg-0 e-3) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4225 arg-0 e-4 ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4235) arg-0 e-5 ext-0)))))))))))))))))))))) (else (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-7 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-8) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-9) ext-0)))))))))))))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpRecord (lambda (arg-0 arg-1 ext-0) (let ((e-1 (vector-ref arg-1 0))) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((e-6 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4222) arg-0 e-3 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4225 arg-0 e-4 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((act-5 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-5) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4228) arg-0 e-6 ext-0))))))))))))))))))))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpDecl (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_Visibility arg-0 e-3 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4198) arg-0 e-4 ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpTy arg-0 e-5 ext-0)))))))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-7 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-1566 arg-0 e-8) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4179 arg-0 e-9) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpData arg-0 e-10 ext-0)))))))))))))))))) ((2) (let ((e-12 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 2))) (let ((e-14 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-12 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-13) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-0 e-14 ext-0)))))))))))))) ((3) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-16 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4222) arg-0 e-17 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 e-18 ext-0)))))))))))))) ((4) (let ((e-20 (vector-ref arg-1 1))) (let ((e-21 (vector-ref arg-1 2))) (let ((e-22 (vector-ref arg-1 3))) (let ((e-23 (vector-ref arg-1 4))) (let ((e-24 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-20 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1559 arg-0 e-21) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-1566 arg-0 e-22) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4179 arg-0 e-23) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpRecord arg-0 e-24 ext-0)))))))))))))))))))))) ((6) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-26 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_Namespace arg-0 e-27 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 e-28 ext-0)))))))))))))) ((7) (let ((e-30 (vector-ref arg-1 1))) (let ((e-31 (vector-ref arg-1 2))) (let ((e-32 (vector-ref arg-1 3))) (let ((e-33 (vector-ref arg-1 4))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-30 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-31) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-32) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-33) ext-0)))))))))))))))))) ((8) (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-35 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-36) ext-0)))))))))) ((9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't write Pragma") ext-0)) ((10) (let ((e-42 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4232 arg-0 e-42) ext-0)))))) ((11) (let ((e-44 (vector-ref arg-1 1))) (let ((e-45 (vector-ref arg-1 2))) (let ((e-46 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-44 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45ContextC-45TTC-u--toBuf_TTC_BuiltinType arg-0 e-45 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-46) ext-0)))))))))))))) (else (vector 1 (vector 0 ))))))
(define csegen-4201 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_ImpDecl arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_ImpDecl arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_IFieldUpdate (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "IFieldUpdate" clam-0)))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_IFieldUpdate (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 e-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-2) ext-0)))))))))) (else (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 e-4 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-5) ext-0)))))))))))))
(define csegen-4204 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_IFieldUpdate arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_IFieldUpdate arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) eta-0))))))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-5) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-0 e-6 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 e-7) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-8) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-9) eta-0))))))))))))))))))))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-11 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-0 e-13 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 e-14) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-15) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-16) eta-0))))))))))))))))))))))))))) ((3) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (let ((e-22 (vector-ref arg-1 5))) (let ((e-23 (vector-ref arg-1 6))) (let ((e-24 (vector-ref arg-1 7))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-18 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-19 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-20) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-21) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-22) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-23) eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-24) eta-0))))))))))))))))))))))))))))))) ((4) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (let ((e-30 (vector-ref arg-1 5))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-26 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4198) arg-0 e-27 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-28) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-29) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-0 e-30 eta-0))))))))))))))))))))))) ((5) (let ((e-32 (vector-ref arg-1 1))) (let ((e-33 (vector-ref arg-1 2))) (let ((e-34 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-32 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 e-33 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-34) eta-0))))))))))))))) ((6) (let ((e-40 (vector-ref arg-1 5))) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-40))) ((7) (let ((e-42 (vector-ref arg-1 1))) (let ((e-43 (vector-ref arg-1 2))) (let ((e-44 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 6 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-42 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4204) arg-0 e-43 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-44) eta-0))))))))))))))) ((8) (let ((e-46 (vector-ref arg-1 1))) (let ((e-47 (vector-ref arg-1 2))) (let ((e-48 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-46 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-47) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-48) eta-0))))))))))))))) ((10) (let ((e-50 (vector-ref arg-1 1))) (let ((e-51 (vector-ref arg-1 2))) (let ((e-52 (vector-ref arg-1 3))) (let ((e-53 (vector-ref arg-1 4))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 8 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-50 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-51) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-52) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-53) eta-0))))))))))))))))))) ((11) (let ((e-55 (vector-ref arg-1 1))) (let ((e-56 (vector-ref arg-1 2))) (let ((e-57 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 9 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-55 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-56) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-57) eta-0))))))))))))))) ((12) (let ((e-59 (vector-ref arg-1 1))) (let ((e-60 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 10 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-59 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-60) eta-0))))))))))) ((13) (let ((e-62 (vector-ref arg-1 1))) (let ((e-63 (vector-ref arg-1 2))) (let ((e-64 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-62 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_AltType arg-0 e-63 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 e-64 eta-0))))))))))))))) ((14) (let ((e-66 (vector-ref arg-1 1))) (let ((e-67 (vector-ref arg-1 2))) (let ((e-68 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 12 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-66 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-67) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-68) eta-0))))))))))))))) ((15) (let ((e-70 (vector-ref arg-1 1))) (let ((e-71 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 13 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-70 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-71) eta-0))))))))))) ((16) (let ((e-73 (vector-ref arg-1 1))) (let ((e-74 (vector-ref arg-1 2))) (let ((e-75 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 14 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-73 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_BindMode arg-0 e-74 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-75) eta-0))))))))))))))) ((17) (let ((e-77 (vector-ref arg-1 1))) (let ((e-78 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 15 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-77 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-78) eta-0))))))))))) ((18) (let ((e-80 (vector-ref arg-1 1))) (let ((e-81 (vector-ref arg-1 2))) (let ((e-82 (vector-ref arg-1 3))) (let ((e-83 (vector-ref arg-1 4))) (let ((e-84 (vector-ref arg-1 5))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 16 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-80 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-81 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_UseSide arg-0 e-82 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-83) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-84) eta-0))))))))))))))))))))))) ((19) (let ((e-86 (vector-ref arg-1 1))) (let ((e-88 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 17 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-86 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-88) eta-0))))))))))) ((20) (let ((e-90 (vector-ref arg-1 1))) (let ((e-91 (vector-ref arg-1 2))) (let ((e-92 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 18 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-90 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_LazyReason arg-0 e-91 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-92) eta-0))))))))))))))) ((21) (let ((e-94 (vector-ref arg-1 1))) (let ((e-95 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 19 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-94 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-95) eta-0))))))))))) ((22) (let ((e-97 (vector-ref arg-1 1))) (let ((e-98 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 20 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-97 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-98) eta-0))))))))))) ((23) (let ((e-100 (vector-ref arg-1 1))) (let ((e-101 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 21 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-100 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-101) eta-0))))))))))) ((24) (let ((e-103 (vector-ref arg-1 1))) (let ((e-104 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 22 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-103 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-104) eta-0))))))))))) ((25) (let ((e-106 (vector-ref arg-1 1))) (let ((e-107 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 23 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-106 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 e-107 eta-0))))))))))) ((26) (let ((e-109 (vector-ref arg-1 1))) (let ((e-110 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 24 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-109 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-110) eta-0))))))))))) ((27) (let ((e-112 (vector-ref arg-1 1))) (let ((e-113 (vector-ref arg-1 2))) (let ((e-114 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-112 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-113) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-114) eta-0))))))))))))))) ((28) (let ((e-116 (vector-ref arg-1 1))) (let ((e-117 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 26 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-116 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Constant arg-0 e-117 eta-0))))))))))) ((29) (let ((e-119 (vector-ref arg-1 1))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-119 eta-0))))))) ((30) (let ((e-121 (vector-ref arg-1 1))) (let ((e-122 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 28 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-121 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 e-122) eta-0))))))))))) ((31) (let ((e-126 (vector-ref arg-1 3))) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-126))) ((32) (let ((e-128 (vector-ref arg-1 1))) (let ((e-129 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 29 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-128 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-129) eta-0))))))))))) ((33) (let ((e-132 (vector-ref arg-1 2))) (let ((e-133 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 30 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1556 arg-0 e-132 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-133) eta-0))))))))))) (else (let ((e-135 (vector-ref arg-1 1))) (let ((e-136 (vector-ref arg-1 2))) (let ((e-137 (vector-ref arg-1 3))) (lambda (eta-0) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 31 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-135 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-136) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-137) eta-0))))))))))))))))))
(define csegen-4182 (lambda () (cons (lambda (arg-5529) (lambda (arg-5534) (TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-5529 arg-5534))) (lambda (arg-5542) (lambda (eta-0) (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-5542 eta-0))))))
(define TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 1) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 1 e-6 e-7 e-8 e-9 e-10 e-11))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 2) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_C-40PiInfoC-32C-36tC-41 (csegen-4182) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 2 e-6 e-7 e-8 e-9 e-10 e-11))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 3) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector 3 e-6 e-7 e-8 e-9 e-10 e-11 e-12))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 4) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4198) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 4 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 5) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 6) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4204) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 7 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 7) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 8) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 10 e-6 e-7 e-8 e-9))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 9) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 11 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 10) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 12 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 11) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_AltType arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 13 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 12) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 14 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 13) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 15 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 14) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_BindMode arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 16 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 15) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 16) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_UseSide arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 18 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 17) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 19 e-6 5 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 18) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_LazyReason arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 20 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 19) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 21 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 20) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 22 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 21) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 23 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 22) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 24 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 23) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4201) arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 25 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 24) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 26 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 25) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 27 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 26) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_Constant arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 28 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 27) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 29 e-6))))) eff-0) clam-0)))))) ((equal? e-5 28) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 30 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 29) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 32 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 30) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1556 arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 33 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-5 31) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45BinaryC-45Prims-corrupt "RawImp" clam-0)))))) eff-0) ext-0)))))))
(define IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_Fixity (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-getTag arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (vector 1 0)) ((equal? e-5 1) (vector 1 1)) ((equal? e-5 2) (vector 1 2)) ((equal? e-5 3) (vector 1 3))(else (CoreC-45BinaryC-45Prims-corrupt "Fixity" clam-0)))))) eff-0) ext-0)))))))
(define IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_FixityInfo (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_Visibility arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_Fixity arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Nat arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-5 e-6 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_Fixity (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((equal? arg-1 1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) ((equal? arg-1 2) (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0)) (else (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0)))))
(define IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_FixityInfo (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_Visibility arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_Fixity arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 (let ((e-3 (vector-ref arg-1 3))) e-3)) ext-0))))))))))))
(define csegen-4147 (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_FixityInfo arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_FixityInfo arg-5542 eta-0))))))
(define csegen-4150 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4147 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4147 arg-5542 eta-0)))))
(define csegen-4151 (cons csegen-1755 csegen-1559))
(define csegen-4154 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4151 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4151 arg-5542 eta-0)))))
(define IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_Import (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_FC arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Bool arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45TTC-u--fromBuf_TTC_ModuleIdent arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-5 e-6 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_Import (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_ModuleIdent arg-0 e-2 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TTC-u--toBuf_TTC_Namespace arg-0 e-3 ext-0))))))))))))))))
(define csegen-4158 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_Import arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_Import arg-5542 eta-0)))))
(define csegen-4162 (cons csegen-1755 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4158 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4158 arg-5542 eta-0))))))
(define csegen-4165 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4162 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4162 arg-5542 eta-0)))))
(define IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_Method (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45TTC-u--fromBuf_TTC_RigCount arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4179 arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-5 e-6 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_Method (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((act-1 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-4179 arg-0 e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 e-3) ext-0))))))))))))))))
(define csegen-4185 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_Method arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_Method arg-5542 eta-0)))))
(define csegen-4192 (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4188) arg-5542 eta-0))))))
(define csegen-4195 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4192 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4192 arg-5542 eta-0)))))
(define IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_IFaceInfo (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45TTC-u--fromBuf_TTC_Name arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4185 arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4195 arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector e-5 e-6 e-7 e-8 e-9 e-10))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_IFaceInfo (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-1 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-2 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (csegen-4182) arg-0 e-3 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4185 arg-0 e-4 ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4195 arg-0 e-5 ext-0))))))))))))))))))))))))
(define csegen-4169 (cons csegen-41 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_IFaceInfo arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_IFaceInfo arg-5542 eta-0))))))
(define csegen-4172 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4169 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4169 arg-5542 eta-0)))))
(define csegen-4173 (cons csegen-41 csegen-1559))
(define csegen-4176 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4173 arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4173 arg-5542 eta-0)))))
(define IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_SyntaxInfo (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4150 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4154 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4165 arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4172 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-4176 arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (TTImpC-45TTImpC-45TTC-u--fromBuf_TTC_RawImp arg-0 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (vector (LibrariesC-45DataC-45ANameMap-fromList e-5) '() (LibrariesC-45DataC-45SortedMap-fromList csegen-284 e-6) (LibrariesC-45DataC-45SortedMap-fromList csegen-284 e-7) '() (LibrariesC-45DataC-45ANameMap-fromList e-8) LibrariesC-45DataC-45NameMap-empty (LibrariesC-45DataC-45ANameMap-fromList e-9) e-10 '() e-11 e-12))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define PreludeC-45TypesC-45List-filterAppend (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-1 '()) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((sc1 (arg-2 e-1))) (cond ((equal? sc1 1) (PreludeC-45TypesC-45List-filterAppend (cons arg-1 e-1) arg-2 e-2)) (else (PreludeC-45TypesC-45List-filterAppend arg-1 arg-2 e-2)))))))))
(define LibrariesC-45DataC-45ANameMap-toList (lambda (arg-1) (LibrariesC-45DataC-45NameMap-toList (let ((e-1 (car arg-1))) e-1))))
(define csegen-4155 (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent eta-0 eta-1))))
(define IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_SyntaxInfo (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4150 arg-0 (LibrariesC-45DataC-45ANameMap-toList (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4154 arg-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--n) (PreludeC-45Types-elemBy csegen-14 csegen-4155 (Builtin-fst u--n) (let ((e-1 (vector-ref arg-1 1))) e-1))) (LibrariesC-45DataC-45SortedMap-toList (let ((e-2 (vector-ref arg-1 2))) e-2))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4165 arg-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--n) (PreludeC-45Types-elemBy csegen-14 csegen-4155 (Builtin-fst u--n) (let ((e-1 (vector-ref arg-1 1))) e-1))) (LibrariesC-45DataC-45SortedMap-toList (let ((e-3 (vector-ref arg-1 3))) e-3))) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4172 arg-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--n) (PreludeC-45Types-elem csegen-14 csegen-832 (Builtin-fst u--n) (let ((e-4 (vector-ref arg-1 4))) e-4))) (LibrariesC-45DataC-45ANameMap-toList (let ((e-14 (vector-ref arg-1 5))) e-14))) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-4176 arg-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--n) (DataC-45Maybe-isJust (LibrariesC-45DataC-45NameMap-lookup (Builtin-fst u--n) (let ((e-14 (vector-ref arg-1 6))) e-14)))) (LibrariesC-45DataC-45ANameMap-toList (let ((e-13 (vector-ref arg-1 7))) e-13))) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 (let ((e-13 (vector-ref arg-1 8))) e-13) ext-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((TTImpC-45TTImpC-45TTC-u--toBuf_TTC_RawImp arg-0 (let ((e-12 (vector-ref arg-1 10))) e-12)) ext-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 (let ((e-12 (vector-ref arg-1 11))) e-12) ext-0))))))))))))))))))))))))
(define csegen-4083 (cons (lambda (arg-5529) (lambda (arg-5534) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--toBuf_TTC_SyntaxInfo arg-5529 arg-5534 eta-0)))) (lambda (arg-5542) (lambda (eta-0) (IdrisC-45SyntaxC-45TTC-u--fromBuf_TTC_SyntaxInfo arg-5542 eta-0)))))
(define csegen-4085 (cons csegen-487 csegen-495))
(define csegen-4088 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4085 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4085 u--d u--x)))))
(define csegen-4091 (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1817 csegen-223 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1817 csegen-223 arg-686 arg-689)))))
(define CoreC-45NameC-45Namespace-u--C-60C-61_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--C-60_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-62C-61_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 0)))
(define CoreC-45NameC-45Namespace-u--C-62_Ord_Namespace (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-0 arg-1) 2)))
(define CoreC-45NameC-45Namespace-u--max_Ord_Namespace (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-62_Ord_Namespace arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CoreC-45NameC-45Namespace-u--min_Ord_Namespace (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-60_Ord_Namespace arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-4099 (vector csegen-1817 (lambda (arg-1566) (lambda (arg-1569) (CoreC-45NameC-45Namespace-u--compare_Ord_Namespace arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CoreC-45NameC-45Namespace-u--C-60_Ord_Namespace arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CoreC-45NameC-45Namespace-u--C-62_Ord_Namespace arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CoreC-45NameC-45Namespace-u--C-60C-61_Ord_Namespace arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CoreC-45NameC-45Namespace-u--C-62C-61_Ord_Namespace arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CoreC-45NameC-45Namespace-u--max_Ord_Namespace arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CoreC-45NameC-45Namespace-u--min_Ord_Namespace arg-1626 arg-1629)))))
(define csegen-4107 (vector csegen-4091 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4099 csegen-231 arg-1626 arg-1629)))))
(define DataC-45String-joinBy (lambda (arg-0 arg-1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse arg-0 arg-1))))
(define DataC-45String-unwords (lambda (ext-0) (DataC-45String-joinBy " " ext-0)))
(define IdrisC-45Syntax-u--show_Show_Import (lambda (arg-0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (DataC-45String-unwords (DataC-45List-catMaybes (cons (box "import") (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) "public") (PreludeC-45Interfaces-guard csegen-258 e-1)) (cons (box (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-2)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (string-append "as " (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-3))) (PreludeC-45Interfaces-guard csegen-258 (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_Namespace e-2 e-3))) '())))))))))))
(define IdrisC-45Syntax-u--showPrec_Show_Import (lambda (arg-0 arg-1) (IdrisC-45Syntax-u--show_Show_Import arg-1)))
(define csegen-4110 (cons (lambda (u--x) (IdrisC-45Syntax-u--show_Show_Import u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45Syntax-u--showPrec_Show_Import u--d u--x)))))
(define PreludeC-45EqOrd-u--compare_Ord_Bool (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1) (else 0))) (else (cond ((equal? arg-1 0) 2) (else 1))))))
(define PreludeC-45EqOrd-u--C-60C-61_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 2)))
(define PreludeC-45EqOrd-u--C-60_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 0)))
(define PreludeC-45EqOrd-u--C-62C-61_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 0)))
(define PreludeC-45EqOrd-u--C-62_Ord_Bool (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (PreludeC-45EqOrd-u--compare_Ord_Bool arg-0 arg-1) 2)))
(define PreludeC-45EqOrd-u--max_Ord_Bool (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-62_Ord_Bool arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define PreludeC-45EqOrd-u--min_Ord_Bool (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Bool arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-4122 (vector csegen-1814 (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_Bool arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_Bool arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_Bool arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_Bool arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_Bool arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_Bool arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_Bool arg-1626 arg-1629)))))
(define csegen-4143 (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)))
(define csegen-4238 (LibrariesC-45TextC-45Parser-option 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (ParserC-45RuleC-45Source-symbol "!"))))
(define csegen-4239 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (blodwen-toSignedInt eta-0 63)) (vector 8 ParserC-45RuleC-45Source-intLit)))
(define IdrisC-45Parser-pdef (cons 1 1))
(define ParserC-45RuleC-45Source-actD (lambda (arg-0) (vector 16 (cons (cons '() arg-0) '()))))
(define ParserC-45RuleC-45Source-decorationFromBounded (lambda (arg-1 arg-2 arg-3) (cons (cons arg-1 (cons (LibrariesC-45TextC-45Bounded-start arg-3) (LibrariesC-45TextC-45Bounded-end arg-3))) (cons arg-2 '()))))
(define IdrisC-45Parser-decorate (lambda (arg-1 arg-2 arg-3) (vector 9 0 (vector 14 arg-3) (lambda () (lambda (u--res) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (ParserC-45RuleC-45Source-decorationFromBounded arg-1 arg-2 u--res)) (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1))))))))
(define IdrisC-45Parser-decoratedSymbol (lambda (arg-0 arg-1) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-symbol arg-1))))
(define IdrisC-45Parser-bindSymbol (lambda (arg-0) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 )) (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 2 )) (IdrisC-45Parser-decoratedSymbol arg-0 "=>"))))))
(define IdrisC-45Parser-decoratedKeyword (lambda (arg-0 arg-1) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-keyword arg-1))))
(define LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause (lambda (arg-3 arg-4 arg-5 arg-6) (vector 13 arg-3 arg-3 arg-6 (lambda () (vector 4 (box arg-4) 1 arg-5)))))
(define IdrisC-45Parser-pibindAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (CoreC-45FC-boundToFC arg-0 e-10) e-6 arg-1 (let ((e-1 (vector-ref e-10 0))) e-1) e-11 (IdrisC-45Parser-pibindAll arg-0 arg-1 e-3 arg-3)))))))))))
(define IdrisC-45Parser-boundedNameDecoration (lambda (arg-0 arg-1 arg-2) (cons (cons arg-0 (cons (LibrariesC-45TextC-45Bounded-start arg-2) (LibrariesC-45TextC-45Bounded-end arg-2))) (cons arg-1 (box (let ((e-1 (vector-ref arg-2 0))) e-1))))))
(define PreludeC-45TypesC-45SnocList-C-60C-62C-60 (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 (cons arg-1 e-2) e-3))))))
(define DataC-45SnocList-u--cast_Cast_C-40ListC-32C-36aC-41_C-40SnocListC-32C-36aC-41 (lambda (arg-1) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-1)))
(define IdrisC-45Parser-decorateBoundedNames (lambda (arg-0 arg-1 arg-2) (vector 16 (cons (DataC-45SnocList-u--cast_Cast_C-40ListC-32C-36aC-41_C-40SnocListC-32C-36aC-41 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Parser-boundedNameDecoration arg-0 arg-1 eta-0)) arg-2)) '()))))
(define IdrisC-45Parser-multiplicity (lambda (arg-0) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-decorate arg-0 4 ParserC-45RuleC-45Source-intLit)) (lambda (bind-0) (if (null? bind-0) (vector 0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-1 (unbox bind-0))) (cond ((equal? e-1 0) csegen-2916) ((equal? e-1 1) csegen-2917)(else (vector 4 '() 0 "Invalid multiplicity (must be 0 or 1)")))))))))
(define IdrisC-45Parser-n--13539-11493-u--binderName (lambda (arg-0 arg-1) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 eta-0)) ParserC-45RuleC-45Source-unqualifiedName) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 2 )) (ParserC-45RuleC-45Source-symbol "_"))))))
(define IdrisC-45Parser-pibindListName (lambda (arg-0 arg-1) (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 14 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 eta-0)) (IdrisC-45Parser-n--13539-11493-u--binderName arg-1 arg-0)))) (lambda () (lambda (u--ns) (let ((ns-0 (DataC-45List1-forget u--ns))) (vector 12 0 1 (IdrisC-45Parser-decorateBoundedNames arg-0 5 ns-0) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--ty) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons u--rig (cons u--n u--ty))) ns-0)))))))))))))))))
(define IdrisC-45Parser-pibindList (lambda (arg-0 arg-1) (vector 9 0 (IdrisC-45Parser-pibindListName arg-0 arg-1) (lambda () (lambda (u--params) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (box eta-0)) e-6) e-7))))))) u--params)))))))
(define IdrisC-45Parser-autoImplicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "auto") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-pibindList arg-0 arg-1) (lambda () (lambda (u--binders) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 u--binders)))))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return an auto implicit argument" (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 (vector 2 ) (let ((e-1 (vector-ref u--b 0))) e-1) u--scope))))))))))))
(define ParserC-45RuleC-45Source-debugInfo (vector 1 "Expected a magic debug info directive" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((20) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define IdrisC-45Parser-debugString (lambda (arg-0) (vector 9 0 (vector 14 ParserC-45RuleC-45Source-debugInfo) (lambda () (lambda (u--di) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--di) (vector 10 (let ((sc0 (let ((e-1 (vector-ref u--di 0))) e-1))) (cond ((equal? sc0 0) (let ((u--bnds (let ((e-3 (vector-ref u--di 2))) e-3))) (DataC-45String-joinBy ", " (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "File " (cons (CoreC-45FC-u--show_Show_OriginDesc arg-0) '()))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "line " (cons (PreludeC-45Show-u--show_Show_Int (let ((e-0 (vector-ref u--bnds 0))) e-0)) '()))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "characters " (cons (PreludeC-45Show-u--show_Show_Int (let ((e-1 (vector-ref u--bnds 1))) e-1)) (cons (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (let ((e-0 (vector-ref u--bnds 0))) e-0) (let ((e-2 (vector-ref u--bnds 2))) e-2)))) (cond ((equal? sc1 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "-" (cons (PreludeC-45Show-u--show_Show_Int (let ((e-3 (vector-ref u--bnds 3))) e-3)) '())))) (else ""))) '())))) '())))))) ((equal? sc0 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (CoreC-45FC-u--show_Show_OriginDesc arg-0) '()))) ((equal? sc0 2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (PreludeC-45Show-u--show_Show_Int (let ((e-3 (vector-ref u--di 2))) (let ((e-0 (vector-ref e-3 0))) e-0))) '()))) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (PreludeC-45Show-u--show_Show_Int (let ((e-3 (vector-ref u--di 2))) (let ((e-6 (vector-ref e-3 1))) e-6))) '())))))))))))))
(define ParserC-45RuleC-45Source-actH (lambda (arg-0) (vector 16 (cons '() (cons arg-0 '())))))
(define IdrisC-45Parser-decoratedPragma (lambda (arg-0 arg-1) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-pragma arg-1))))
(define IdrisC-45Parser-dependentDecorate (lambda (arg-1 arg-2 arg-3) (vector 9 0 (vector 14 arg-2) (lambda () (lambda (u--res) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (ParserC-45RuleC-45Source-decorationFromBounded arg-1 (arg-3 (let ((e-1 (vector-ref u--res 0))) e-1)) u--res)) (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1))))))))
(define CoreC-45TTC-45Primitive-isPrimType (lambda (arg-0) (case (vector-ref arg-0 0) ((13) 1)(else 0))))
(define IdrisC-45Parser-atom (lambda (arg-0) (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-exactIdent "Type"))) (lambda () (lambda (u--x) (vector 0 (vector 22 (CoreC-45FC-boundToFC arg-0 u--x)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--x) (vector 0 (vector 0 (CoreC-45FC-boundToFC arg-0 u--x) (let ((e-1 (vector-ref u--x 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-dependentDecorate arg-0 ParserC-45RuleC-45Source-constant (lambda (u--c) (let ((sc0 (CoreC-45TTC-45Primitive-isPrimType u--c))) (cond ((equal? sc0 1) 1) (else 3)))))) (lambda () (lambda (u--x) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--x) (let ((e-1 (vector-ref u--x 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-0 "_")) (lambda () (lambda (u--x) (vector 0 (vector 25 (CoreC-45FC-boundToFC arg-0 u--x)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol "?")) (lambda () (lambda (u--x) (vector 0 (vector 26 (CoreC-45FC-boundToFC arg-0 u--x)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 ParserC-45RuleC-45Source-holeName) (lambda () (lambda (u--x) (vector 12 0 0 (ParserC-45RuleC-45Source-actH (let ((e-1 (vector-ref u--x 0))) e-1)) (vector 0 (vector 21 (CoreC-45FC-boundToFC arg-0 u--x) 0 (let ((e-1 (vector-ref u--x 0))) e-1))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-pragma "MkWorld"))) (lambda () (lambda (u--x) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--x) (vector 14 )))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-pragma "World"))) (lambda () (lambda (u--x) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--x) (vector 13 13)))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedPragma arg-0 "search")) (lambda () (lambda (u--x) (vector 0 (vector 14 (CoreC-45FC-boundToFC arg-0 u--x) 50)))))))))))))))))))))))
(define IdrisC-45Parser-continueWith (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-mustContinue arg-0 (box arg-1))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol arg-1))))))
(define IdrisC-45Parser-continueWithDecorated (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-mustContinue arg-1 (box arg-2))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-0 arg-2))))))
(define IdrisC-45Parser-decoratedSimpleBinderName (lambda (arg-0) (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-unqualifiedName)))
(define LibrariesC-45TextC-45Bounded-irrelevantBounds (lambda (arg-1) (vector arg-1 1 (vector -1 -1 -1 -1))))
(define LibrariesC-45TextC-45Bounded-mergeBounds (lambda (arg-2 arg-3) (let ((e-6 (vector-ref arg-2 1))) (cond ((equal? e-6 1) (let ((e-9 (vector-ref arg-3 0))) (let ((e-10 (vector-ref arg-3 1))) (cond ((equal? e-10 1) (LibrariesC-45TextC-45Bounded-irrelevantBounds e-9))(else arg-3)))))(else (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (cond ((equal? e-2 1) (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) e-1) arg-2))(else (let ((sc0 (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 (LibrariesC-45TextC-45Bounded-start arg-2) (LibrariesC-45TextC-45Bounded-start arg-3)))) (let ((e-8 (car sc0))) (let ((e-4 (cdr sc0))) (let ((sc1 (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 (LibrariesC-45TextC-45Bounded-end arg-2) (LibrariesC-45TextC-45Bounded-end arg-3)))) (let ((e-10 (car sc1))) (let ((e-9 (cdr sc1))) (vector (let ((e-13 (vector-ref arg-3 0))) e-13) 0 (vector e-8 e-4 e-10 e-9)))))))))))))))))
(define IdrisC-45Parser-commitKeyword (lambda (arg-0 arg-1 arg-2) (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-1 (box arg-2)) (vector 11 0 (vector 13 1 1 (IdrisC-45Parser-decoratedKeyword arg-0 arg-2) (lambda () (vector 4 '() 1 (string-append "Expected '" (string-append arg-2 "'"))))) (lambda () (ParserC-45RuleC-45Source-mustContinue arg-1 '()))))))
(define LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 (lambda (arg-4 arg-5 arg-6 arg-7) (vector 13 arg-4 arg-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 (lambda (eta-0) (vector 0 eta-0)) arg-6) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-5 (lambda (eta-0) (vector 1 eta-0)) (arg-7))))))
(define IdrisC-45Parser-caseRHS (lambda (arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-3 '()) (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-3))))) (lambda () (lambda (u--rhs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-3) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rhs)))) (vector 0 (vector 0 u--fc arg-4 (let ((e-1 (vector-ref u--rhs 0))) e-1) '()))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-1 "impossible")) (lambda () (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-3) (vector 0 (vector 2 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--end)) arg-4)))))) (lambda () (vector 4 '() 1 "Expected '=>' or 'impossible'")))))))
(define IdrisC-45Parser-parens (lambda (arg-1 arg-2 arg-3) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 arg-1 (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 0 (lambda (eta-0) eta-0))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-2 "(")))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-1 u--f arg-3)))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-2 ")"))))))
(define IdrisC-45Parser-decoratedSimpleNamedArg (lambda (arg-0) (vector 13 1 1 (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-unqualifiedName) (lambda () (IdrisC-45Parser-parens 1 arg-0 (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-unqualifiedOperatorName))))))
(define DataC-45List-isCons (lambda (arg-1) (if (null? arg-1) 0 1)))
(define LibrariesC-45TextC-45Parser-sepBy (lambda (arg-4 arg-5 arg-6) (LibrariesC-45TextC-45Parser-option arg-4 '() (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 arg-4 arg-5 arg-6)))))
(define IdrisC-45Parser-n--13351-7496-u--underscore (lambda (arg-0 arg-1 arg-2 arg-3) (vector 2 (vector 1 (vector 2 )) (vector 25 arg-3))))
(define IdrisC-45Parser-n--13351-7495-u--braceArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-3 "{")) (lambda () (lambda (u--start) (vector 8 (vector 10 0 1 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-3 ",") (vector 9 0 (vector 14 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleNamedArg arg-3))) (lambda () (lambda (u--x) (let ((u--fc (CoreC-45FC-boundToFC arg-3 u--x))) (LibrariesC-45TextC-45Parser-option 1 (vector 2 (let ((e-1 (vector-ref u--x 0))) e-1) (vector 0 u--fc (let ((e-1 (vector-ref u--x 0))) e-1))) (vector 9 0 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-3 "=")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-3 arg-4)))) (lambda () (lambda (u--tm) (vector 0 (vector 2 (let ((e-1 (vector-ref u--x 0))) e-1) u--tm))))))))))) (lambda (u--list) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (let ((sc0 (DataC-45List-isCons u--list))) (cond ((equal? sc0 1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-3 ",") (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-3 "_")) (lambda () (lambda (u--x) (vector 0 (cons (IdrisC-45Parser-n--13351-7496-u--underscore arg-0 arg-1 arg-2 (CoreC-45FC-boundToFC arg-3 u--x)) '())))))))) (else (vector 4 '() 0 "non-empty list required"))))) (lambda (u--matchAny) (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-3 "}")) (lambda () (lambda (u--end) (vector 10 0 0 (let ((u--fc (CoreC-45FC-boundToFC arg-3 (LibrariesC-45TextC-45Bounded-mergeBounds u--start u--end)))) (vector 0 (let ((sc0 (DataC-45List-isNil u--list))) (cond ((equal? sc0 1) (cons (IdrisC-45Parser-n--13351-7496-u--underscore arg-0 arg-1 arg-2 u--fc) '())) (else u--matchAny))))) (lambda (matchAny-0) (vector 0 (PreludeC-45TypesC-45List-tailRecAppend matchAny-0 u--list))))))))))))))) (lambda () (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-3 "@{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-3 arg-4) (lambda () (lambda (u--tm) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-3 "}") (lambda () (vector 0 (cons (vector 1 u--tm) '()))))))))))))))
(define IdrisC-45Parser-argExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 9 0 (IdrisC-45Parser-simpleExpr arg-1 arg-2) (lambda () (lambda (u--arg) (case (vector-ref u--arg 0) ((21) (let ((e-1 (vector-ref u--arg 1))) (let ((e-3 (vector-ref u--arg 3))) (vector 0 (cons (vector 0 (vector 21 e-1 1 e-3)) '())))))(else (vector 0 (cons (vector 0 u--arg) '())))))))) (lambda () (vector 13 1 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (IdrisC-45Parser-n--13351-7495-u--braceArgs arg-2 arg-1 arg-0 arg-1 arg-2)) (let ((sc0 (let ((e-1 (cdr arg-0))) e-1))) (cond ((equal? sc0 1) (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "|") (lambda () (vector 9 0 (IdrisC-45Parser-expr (let ((e-0 (car arg-0))) (cons e-0 0)) arg-1 arg-2) (lambda () (lambda (u--arg) (vector 0 (cons (vector 3 u--arg) '())))))))))) (else (lambda () (vector 4 '() 0 "| not allowed here"))))))))))
(define IdrisC-45Parser-n--13795-14994-u--noMangleWarning (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "DEPRECATED: \"%nomangle\".\xa;  Use \"%export\" instead" '()))))
(define IdrisC-45Parser-fnDirectOpt (lambda (arg-0) (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "hint") (lambda () (vector 0 (vector 0 (vector 5 1))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "globalhint") (lambda () (vector 0 (vector 0 (vector 6 0))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "defaulthint") (lambda () (vector 0 (vector 0 (vector 6 1))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "inline") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 1 )))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "unsafe") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 0 )))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "noinline") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 2 )))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "deprecate") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 3 )))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "tcinline") (lambda () (vector 12 0 0 (vector 7 ) (vector 0 (vector 0 (vector 4 )))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "extern") (lambda () (vector 0 (vector 0 (vector 7 ))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "macro") (lambda () (vector 0 (vector 0 (vector 12 ))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "spec") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") ParserC-45RuleC-45Source-name) (lambda (u--ns) (vector 0 (vector 0 (vector 13 u--ns))))))) (lambda () (vector 13 1 1 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "foreign") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 eta-0))) (lambda (u--cs) (vector 0 (vector 1 u--cs)))))) (lambda () (vector 11 0 (vector 13 1 1 (IdrisC-45Parser-decoratedPragma arg-0 "export") (lambda () (vector 10 1 0 (vector 14 (IdrisC-45Parser-decoratedPragma arg-0 "nomangle")) (lambda (u--res) (vector 12 0 0 (vector 5 (box (let ((e-3 (vector-ref u--res 2))) e-3)) (IdrisC-45Parser-n--13795-14994-u--noMangleWarning arg-0)) (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1))))))) (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 eta-0))) (lambda (u--cs) (vector 0 (vector 2 u--cs))))))))))))))))))))))))))))))))
(define CoreC-45FC-virtualiseFC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (vector 1 e-0 e-1 e-2)))))(else arg-0))))
(define IdrisC-45Parser-case_ (lambda (arg-0 arg-1) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-fnDirectOpt arg-0)) (lambda (u--opts) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "case") (lambda () (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--scr) (vector 11 0 (vector 8 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "of")) (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-caseAlt arg-0 eta-0))) (lambda (u--alts) (vector 0 (cons u--scr u--alts)))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 4 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--b)) u--opts e-2 e-3)))))))))))))
(define DataC-45List1-cons (lambda (arg-1 arg-2) (cons arg-1 (DataC-45List1-forget arg-2))))
(define DataC-45Either-n--3269-3740-u--compressLefts (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (cons (vector 0 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 1))) (DataC-45Either-n--3269-3740-u--compressLefts arg-2 arg-3 (DataC-45List1-cons e-5 arg-4) e-2)))(else (cons (vector 0 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)))))))))
(define DataC-45Either-n--3269-3778-u--compressRights (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (cons (vector 1 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (case (vector-ref e-1 0) ((1) (let ((e-5 (vector-ref e-1 1))) (DataC-45Either-n--3269-3778-u--compressRights arg-2 arg-3 (DataC-45List1-cons e-5 arg-4) e-2)))(else (cons (vector 1 (DataC-45List1-reverse arg-4)) (DataC-45Either-compress arg-5)))))))))
(define DataC-45Either-compress (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (DataC-45Either-n--3269-3740-u--compressLefts e-6 e-3 (DataC-45List1-singleton e-6) e-3))) (else (let ((e-9 (vector-ref e-2 1))) (DataC-45Either-n--3269-3778-u--compressRights e-9 e-3 (DataC-45List1-singleton e-9) e-3)))))))))
(define IdrisC-45ParserC-45Let-n--8565-5190-u--groups (lambda (arg-1 arg-2 arg-3 arg-4) (DataC-45Either-compress (DataC-45List1-forget (DataC-45List1-u--map_Functor_List1 (lambda (u--b) (let ((e-1 (vector-ref u--b 0))) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (vector 0 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) e-4) u--b)))) (else (let ((e-5 (vector-ref e-1 1))) (vector 1 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) e-5) u--b))))))) arg-2)))))
(define DataC-45List1-n--3040-2661-u--loop (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (DataC-45List1-n--3040-2661-u--loop arg-1 arg-2 e-2 e-3))))))
(define DataC-45List1-last (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (DataC-45List1-n--3040-2661-u--loop e-1 e-2 e-1 e-2)))))
(define DataC-45List1-u--foldMap_Foldable_List1 (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((e-4 (car arg-2))) ((e-4 (arg-3 e-1)) (PreludeC-45Types-u--foldMap_Foldable_List arg-2 arg-3 e-2)))))))
(define csegen-4712 (lambda (eta-0) (let ((e-1 (vector-ref eta-0 0))) e-1)))
(define IdrisC-45ParserC-45Let-n--8565-5191-u--mkLet (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (arg-4 (DataC-45List1-forget e-2)))) (else (let ((e-5 (vector-ref arg-5 1))) (let ((u--bounds (LibrariesC-45TextC-45Bounded-mergeBounds (let ((e-1 (car e-5))) e-1) (DataC-45List1-last e-5)))) (arg-3 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 csegen-4712 e-5)) u--bounds))))))))
(define IdrisC-45ParserC-45Let-letFactory (lambda (arg-1 arg-2 arg-3 arg-4) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (IdrisC-45ParserC-45Let-n--8565-5191-u--mkLet arg-4 arg-3 arg-2 arg-1 eta-0)) arg-4 (IdrisC-45ParserC-45Let-n--8565-5190-u--groups arg-4 arg-3 arg-2 arg-1))))
(define LibrariesC-45UtilsC-45String-lowerFirst (lambda (arg-0) (cond ((equal? arg-0 "") 0)(else (PreludeC-45Types-isLower (string-ref arg-0 0))))))
(define CoreC-45Name-isPatternVariable (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45UtilsC-45String-lowerFirst e-0))) ((1) 0) (else 1))))
(define IdrisC-45ParserC-45Let-case--mkDoLetsC-44buildDoLets-5362 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-0 (vector-ref arg-5 0))) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-1 0) ((0) (let ((e-6 (vector-ref e-1 1))) (let ((e-7 (vector-ref e-1 2))) (case (vector-ref e-7 0) ((1) (let ((e-10 (vector-ref e-7 1))) (if (null? e-4) (cons (let ((sc3 (CoreC-45Name-isPatternVariable e-10))) (cond ((equal? sc3 1) (vector 3 arg-4 e-6 (vector 1 e-10) e-0 e-2 e-3)) (else (vector 4 arg-4 (vector 0 e-6 (vector 1 e-10)) e-2 e-3 '())))) (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-0 arg-1 arg-3)) (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-0 arg-1 arg-3)))))(else (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-0 arg-1 arg-3))))))) ((25) (let ((e-9 (vector-ref e-1 1))) (if (null? e-4) (cons (vector 3 arg-4 e-9 (vector 1 (vector 2 )) e-0 e-2 e-3) (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-0 arg-1 arg-3)) (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-0 arg-1 arg-3)))))(else (cons (vector 4 arg-4 e-1 e-2 e-3 e-4) (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-0 arg-1 arg-3)))))))))))
(define IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 e-2))) (IdrisC-45ParserC-45Let-case--mkDoLetsC-44buildDoLets-5362 arg-0 arg-1 e-2 e-3 u--fc (let ((e-1 (vector-ref e-2 0))) e-1))))))))
(define IdrisC-45ParserC-45Let-mkDoLets (lambda (arg-0 arg-1) (IdrisC-45ParserC-45Let-letFactory (lambda (u--binds) (lambda (u--rest) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45ParserC-45Let-n--8743-5343-u--buildDoLets arg-1 arg-0 u--binds) u--rest))) (lambda (u--decls) (lambda (u--rest) (cons (vector 5 (CoreC-45FC-boundToFC arg-0 u--decls) (let ((e-1 (vector-ref u--decls 0))) e-1)) u--rest))) arg-1 '())))
(define IdrisC-45Parser-plhs (cons 0 0))
(define IdrisC-45Parser-pnowith (cons 1 0))
(define IdrisC-45Parser-validPatternVar (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) (vector 0 (vector 0 ))) ((0) (let ((e-1 (vector-ref e-0 1))) (LibrariesC-45TextC-45Parser-when (let ((sc2 (LibrariesC-45UtilsC-45String-lowerFirst e-1))) (cond ((equal? sc2 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Not a pattern variable")))))(else (vector 4 '() 0 "Not a pattern variable")))))(else (vector 4 '() 0 "Not a pattern variable")))))
(define IdrisC-45Parser-case--doAct-13938 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (vector 0 (cons (vector 1 (CoreC-45FC-boundToFC arg-1 arg-2) (CoreC-45FC-boundToFC arg-1 e-2) (let ((e-1 (vector-ref e-2 0))) e-1) e-3) '()))))))
(define csegen-4306 (vector 0 csegen-2816))
(define IdrisC-45Parser-doAct (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (vector 14 (vector 13 1 1 ParserC-45RuleC-45Source-name (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 2 ))) (ParserC-45RuleC-45Source-symbol "_"))))) (lambda () (lambda (u--n) (vector 12 0 1 (IdrisC-45Parser-validPatternVar (let ((e-1 (vector-ref u--n 0))) e-1)) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "<-") (lambda () (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--val) (vector 0 (cons u--n u--val)))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (IdrisC-45Parser-case--doAct-13938 arg-1 arg-0 u--b (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "let") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-letBlock arg-0 eta-0))) (lambda () (lambda (u--res) (vector 13 1 0 (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-0 "in")) (lambda () (lambda (u--b) (vector 4 (box (let ((e-3 (vector-ref u--b 2))) e-3)) 1 "Let-in not supported in do block. Did you mean (let ... in ...)?")))) (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (IdrisC-45ParserC-45Let-mkDoLets arg-0 u--res))))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "rewrite")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (cons (vector 6 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)) '())))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-expr IdrisC-45Parser-plhs arg-0 arg-1)) (lambda () (lambda (u--e) (vector 13 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (cons (vector 0 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--e)) (let ((e-1 (vector-ref u--e 0))) e-1)) '())) (ParserC-45RuleC-45Source-atEnd arg-1)) (lambda () (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "<-")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (vector 10 1 0 (vector 10 0 1 csegen-4306 (lambda (f-0) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 f-0 (IdrisC-45Parser-expr IdrisC-45Parser-pnowith arg-0 arg-1)))) (lambda (f-0) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 f-0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-patAlt arg-0 eta-0)))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (let ((u--fc (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds u--e u--b))))) (vector 0 (cons (vector 2 u--fc (let ((e-8 (vector-ref u--e 0))) e-8) e-5 e-4) '())))))))))))))))))))))))
(define IdrisC-45Parser-doBlock (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "do")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-doAct arg-0 eta-0))))))) (lambda () (lambda (u--b) (vector 12 0 0 (vector 7 ) (vector 0 (vector 35 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--b)) '() (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) (let ((e-1 (vector-ref u--b 0))) e-1)))))))) (lambda () (vector 9 0 (vector 14 ParserC-45RuleC-45Source-namespacedIdent) (lambda () (lambda (u--nsdo) (let ((e-1 (vector-ref u--nsdo 0))) (if (null? e-1) (vector 4 '() 0 "Not a namespaced 'do'") (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (cond ((equal? e-4 "do") (vector 12 0 0 (vector 7 ) (vector 10 0 0 (vector 14 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-doAct arg-0 eta-0)))) (lambda (u--actions) (let ((u--fc (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds u--nsdo u--actions))))) (vector 0 (vector 35 u--fc e-5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) (let ((e-8 (vector-ref u--actions 0))) e-8)))))))))(else (vector 4 '() 0 "Not a namespaced 'do'"))))))))))))))
(define IdrisC-45Parser-iOperator (vector 13 1 1 ParserC-45RuleC-45Source-operator (lambda () (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-symbol "`")) csegen-2899)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol "`")))))))
(define IdrisC-45Parser-if_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "if") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "then") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "else") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--e) (vector 0 (cons u--x (cons u--t u--e)))))))))))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (vector 8 (ParserC-45RuleC-45Source-atEnd arg-1)) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 43 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7))))))))))))))
(define IdrisC-45Parser-bindList (lambda (arg-0 arg-1) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 0 (vector 14 (IdrisC-45Parser-simpleExpr arg-0 arg-1)) (lambda () (lambda (u--pat) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 (vector 26 (CoreC-45FC-boundToFC arg-0 u--pat)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 ":")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-opExpr IdrisC-45Parser-pdef arg-0 arg-1))))) (lambda (u--ty) (vector 0 (cons u--rig (cons u--pat u--ty))))))))))))))
(define IdrisC-45Parser-commitSymbol (lambda (arg-0 arg-1) (vector 13 1 1 (IdrisC-45Parser-decoratedSymbol arg-0 arg-1) (lambda () (vector 4 '() 1 (string-append "Expected '" (string-append arg-1 "'")))))))
(define IdrisC-45Parser-n--13604-12228-u--bindAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 2 (CoreC-45FC-boundToFC arg-1 e-10) e-6 (vector 1 ) (let ((e-1 (vector-ref e-10 0))) e-1) e-11 (IdrisC-45Parser-n--13604-12228-u--bindAll arg-0 arg-1 e-3 arg-3)))))))))))
(define IdrisC-45Parser-n--13604-12229-u--continueLam (lambda (arg-0 arg-1) (vector 9 1 (IdrisC-45Parser-bindList arg-1 arg-0) (lambda () (lambda (u--binders) (vector 11 1 (IdrisC-45Parser-commitSymbol arg-1 "=>") (lambda () (vector 12 0 1 (ParserC-45RuleC-45Source-mustContinue arg-0 '()) (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-0) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-n--13604-12228-u--bindAll arg-0 arg-1 u--binders u--scope)))))))))))))
(define IdrisC-45Parser-n--13604-12230-u--continueLamCase (lambda (arg-0 arg-1 arg-2) (vector 9 0 (vector 14 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-caseAlt arg-1 eta-0))))) (lambda () (lambda (u--b) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-1 u--b))) (let ((u--fcCase (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-1 arg-2)))) (let ((u--n (vector 2 "lcase" 0))) (vector 2 u--fcCase AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 0 u--fcCase u--n) (vector 26 u--fcCase) (vector 4 (CoreC-45FC-virtualiseFC u--fc) '() (vector 0 u--fcCase u--n) (let ((e-1 (vector-ref u--b 0))) e-1))))))))))))
(define IdrisC-45Parser-lam (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "\\") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-0 "case"))) (lambda (u--switch) (if (null? u--switch) (IdrisC-45Parser-n--13604-12229-u--continueLam arg-1 arg-0) (let ((e-2 (unbox u--switch))) (IdrisC-45Parser-n--13604-12230-u--continueLamCase arg-1 arg-0 e-2))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-mustFailBecause (lambda (arg-3 arg-4) (vector 13 1 0 (vector 9 0 (vector 14 arg-4) (lambda () (lambda (u--res) (vector 4 (box (let ((e-3 (vector-ref u--res 2))) e-3)) 1 arg-3)))) (lambda () (vector 0 (vector 0 ))))))
(define IdrisC-45Parser-lazy (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-exactIdent "Lazy"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45ParserC-45Core-mustFailBecause "Lazy only takes one argument" (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (IdrisC-45Parser-simpleExpr arg-0 arg-1))))))) (lambda () (lambda (u--tm) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--tm) 1 (let ((e-1 (vector-ref u--tm 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 1 (ParserC-45RuleC-45Source-exactIdent "Inf"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45ParserC-45Core-mustFailBecause "Inf only takes one argument" (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (IdrisC-45Parser-simpleExpr arg-0 arg-1))))))) (lambda () (lambda (u--tm) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--tm) 0 (let ((e-1 (vector-ref u--tm 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-exactIdent "Delay"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45ParserC-45Core-mustFailBecause "Delay only takes one argument" (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (IdrisC-45Parser-simpleExpr arg-0 arg-1))))))) (lambda () (lambda (u--tm) (vector 0 (vector 12 (CoreC-45FC-boundToFC arg-0 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1)))))) (lambda () (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decorate arg-0 3 (ParserC-45RuleC-45Source-exactIdent "Force"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45ParserC-45Core-mustFailBecause "Force only takes one argument" (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (IdrisC-45Parser-simpleExpr arg-0 arg-1))))))) (lambda () (lambda (u--tm) (vector 0 (vector 13 (CoreC-45FC-boundToFC arg-0 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1))))))))))))))
(define IdrisC-45Parser-n--13362-8004-u--nameList (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "[") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 ",") (vector 14 ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--ns) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-1 "]") (lambda () (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons (CoreC-45FC-boundToFC arg-1 u--n) (let ((e-1 (vector-ref u--n 0))) e-1))) (DataC-45List1-forget u--ns)))))))))))))
(define IdrisC-45Parser-n--13362-8005-u--singleName (lambda (arg-0 arg-1) (vector 9 0 (vector 14 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (cons (cons (CoreC-45FC-boundToFC arg-1 u--n) (let ((e-1 (vector-ref u--n 0))) e-1)) '())))))))
(define IdrisC-45Parser-with_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "with") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (vector 13 1 1 (IdrisC-45Parser-n--13362-8005-u--singleName arg-1 arg-0) (lambda () (IdrisC-45Parser-n--13362-8004-u--nameList arg-1 arg-0))) (lambda () (lambda (u--ns) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--rhs) (vector 0 (cons u--ns u--rhs)))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 51 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))
(define IdrisC-45Parser-n--13340-7226-u--applyExpImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (IdrisC-45Parser-n--13340-7226-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 7 (vector 0 arg-1 arg-3 arg-4) arg-5 e-4) e-3))) ((1) (let ((e-5 (vector-ref e-2 1))) (IdrisC-45Parser-n--13340-7226-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 10 (vector 0 arg-1 arg-3 arg-4) arg-5 e-5) e-3))) ((2) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((u--fc (vector 0 arg-1 arg-3 arg-4))) (IdrisC-45Parser-n--13340-7226-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 9 u--fc arg-5 e-6 e-7) e-3))))) (else (let ((e-8 (vector-ref e-2 1))) (IdrisC-45Parser-n--13340-7226-u--applyExpImp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 8 (vector 0 arg-1 arg-3 arg-4) arg-5 e-8) e-3)))))))))
(define IdrisC-45Parser-appExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-case_ arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-doBlock arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-lam arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-lazy arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-if_ arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-with_ arg-1 arg-2) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 csegen-2816 (IdrisC-45Parser-simpleExpr arg-1 arg-2)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-argExpr arg-0 arg-1 arg-2)))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (IdrisC-45Parser-n--13340-7226-u--applyExpImp arg-2 arg-1 arg-0 (LibrariesC-45TextC-45Bounded-start u--b) (LibrariesC-45TextC-45Bounded-end u--b) e-2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-3)))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 csegen-2816 (vector 14 IdrisC-45Parser-iOperator)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-2))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 28 (CoreC-45FC-boundToFC arg-1 u--b) (CoreC-45FC-boundToFC arg-1 e-2) (let ((e-1 (vector-ref e-2 0))) e-1) e-3))))))))) (lambda () (vector 4 '() 0 "Expected 'case', 'if', 'do', application or operator expression")))))))))))))))))))
(define IdrisC-45Parser-opExpr (lambda (arg-0 arg-1 arg-2) (vector 9 0 (vector 14 (IdrisC-45Parser-appExpr arg-0 arg-1 arg-2)) (lambda () (lambda (u--l) (vector 13 1 0 (let ((sc0 (let ((e-0 (car arg-0))) e-0))) (cond ((equal? sc0 1) (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-continue arg-2)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 "="))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-opExpr arg-0 arg-1 arg-2))))) (lambda () (lambda (u--r) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds u--l u--r)))) (let ((u--opFC (CoreC-45FC-virtualiseFC u--fc))) (vector 27 u--fc u--opFC (vector 1 (vector 0 "=")) (let ((e-1 (vector-ref u--l 0))) e-1) (let ((e-1 (vector-ref u--r 0))) e-1))))))))) (else (vector 4 '() 0 "= not allowed")))) (lambda () (vector 13 1 0 (vector 9 0 (vector 14 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 9 1 (vector 14 IdrisC-45Parser-iOperator) (lambda () (lambda (u--op) (vector 9 0 (let ((e-1 (vector-ref u--op 0))) (case (vector-ref e-1 0) ((1) (let ((e-0 (vector-ref e-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-4 (vector-ref e-0 1))) (cond ((equal? e-4 "$") (IdrisC-45Parser-typeExpr arg-0 arg-1 arg-2))(else (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))))(else (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))))(else (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))) (lambda () (lambda (u--e) (vector 0 (cons u--op u--e)))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds u--l u--b)))) (let ((u--opFC (CoreC-45FC-boundToFC arg-1 e-2))) (vector 0 (vector 27 u--fc u--opFC (let ((e-1 (vector-ref e-2 0))) e-1) (let ((e-1 (vector-ref u--l 0))) e-1) e-3))))))))))) (lambda () (vector 0 (let ((e-1 (vector-ref u--l 0))) e-1)))))))))))
(define IdrisC-45Parser-caseAlt (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (IdrisC-45Parser-opExpr IdrisC-45Parser-plhs arg-0 arg-1)) (lambda () (lambda (u--lhs) (IdrisC-45Parser-caseRHS arg-0 u--lhs arg-1 (let ((e-1 (vector-ref u--lhs 0))) e-1)))))))
(define IdrisC-45Parser-patAlt (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "|") (lambda () (IdrisC-45Parser-caseAlt arg-0 arg-1)))))
(define IdrisC-45Parser-pnoeq (lambda (ext-0) (let ((e-1 (cdr ext-0))) (cons 0 e-1))))
(define IdrisC-45Parser-n--13612-12422-u--letBinder (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 csegen-2816 (IdrisC-45Parser-multiplicity arg-1)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-expr IdrisC-45Parser-plhs arg-1 arg-0))))) (lambda () (lambda (u--s) (vector 10 0 1 (vector 0 (let ((e-1 (vector-ref u--s 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 (vector 25 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-1 u--s))) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-1 ":")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-typeExpr (IdrisC-45Parser-pnoeq IdrisC-45Parser-pdef) arg-1 arg-0))))) (lambda (u--ty) (vector 11 1 (vector 13 1 1 (IdrisC-45Parser-decoratedSymbol arg-1 "=") (lambda () (IdrisC-45Parser-decoratedSymbol arg-1 ":="))) (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pnowith arg-1 arg-0) (lambda () (lambda (u--val) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-patAlt arg-1 eta-0))) (lambda (u--alts) (vector 0 (vector e-2 e-3 u--ty u--val u--alts))))))))))))))))))))
(define IdrisC-45Syntax-isPDef (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (box (cons e-1 e-2)))))(else '()))))
(define DataC-45List-spanBy (lambda (arg-2 arg-3) (if (null? arg-3) (cons '() '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (arg-2 e-2))) (if (null? sc1) (cons '() (cons e-2 e-3)) (let ((e-4 (unbox sc1))) (let ((sc2 (DataC-45List-spanBy arg-2 e-3))) (let ((e-6 (car sc2))) (let ((e-5 (cdr sc2))) (cons (cons e-4 e-6) e-5))))))))))))
(define CoreC-45FC-mergeFC (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((sc2 (CoreC-45FC-u--C-61C-61_Eq_OriginDesc e-0 e-3))) (cond ((equal? sc2 1) (box (vector 0 e-0 (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 e-1 e-4) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 e-2 e-5)))) (else '())))))))(else '()))))))(else '()))))
(define IdrisC-45Parser-case--collectDefs-23077 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((u--csC-39 (PreludeC-45TypesC-45List-tailRecAppend arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-2))))) (let ((u--annotC-39 (PreludeC-45Types-u--foldr_Foldable_List (lambda (u--fc1) (lambda (u--fc2) (DataC-45Maybe-fromMaybe (lambda () (vector 2 )) (CoreC-45FC-mergeFC u--fc1 u--fc2)))) arg-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) e-2)))) (cons (vector 1 u--annotC-39 u--csC-39) (IdrisC-45Parser-collectDefs e-3))))))))
(define IdrisC-45Parser-collectDefs (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (IdrisC-45Parser-case--collectDefs-23077 e-6 e-5 e-3 (DataC-45List-spanBy (lambda (eta-0) (IdrisC-45Syntax-isPDef eta-0)) e-3))))) ((11) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (cons (vector 11 e-8 e-9 (IdrisC-45Parser-collectDefs e-10)) (IdrisC-45Parser-collectDefs e-3)))))) ((9) (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (cons (vector 9 e-12 (IdrisC-45Parser-collectDefs e-13)) (IdrisC-45Parser-collectDefs e-3)))))(else (cons e-2 (IdrisC-45Parser-collectDefs e-3)))))))))
(define ParserC-45RuleC-45Source-anyKeyword (vector 1 "Expected a keyword" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((18) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ParserC-45RuleC-45Source-anyReservedIdent (vector 9 0 (vector 14 ParserC-45RuleC-45Source-identPart) (lambda () (lambda (u--id) (vector 12 0 0 (LibrariesC-45TextC-45Parser-when (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-22 (let ((e-1 (vector-ref u--id 0))) e-1) ParserC-45RuleC-45Source-reservedNames))) (cond ((equal? sc0 1) 0) (else 1))) (lambda () (vector 4 (box (let ((e-3 (vector-ref u--id 2))) e-3)) 0 "Expected reserved identifier"))) (vector 0 u--id))))))
(define IdrisC-45Parser-builtinDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "builtin") (lambda () csegen-2944))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 15 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))
(define DataC-45Either-getRight (lambda (arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (box e-2)))(else '()))))
(define IdrisC-45Parser-getVisibility (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 0 0) (let ((e-8 (car arg-1))) (let ((e-9 (cdr arg-1))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 1))) (IdrisC-45Parser-getVisibility (box e-12) e-9)))(else (let ((e-2 (cdr arg-1))) (IdrisC-45Parser-getVisibility arg-0 e-2))))))) (let ((e-5 (unbox arg-0))) (if (null? arg-1) (vector 0 e-5) (let ((e-15 (car arg-1))) (case (vector-ref e-15 0) ((0) (vector 4 '() 1 "Multiple visibility modifiers"))(else (let ((e-2 (cdr arg-1))) (IdrisC-45Parser-getVisibility arg-0 e-2))))))))))
(define ParserC-45RuleC-45Source-documentationC-39 (vector 1 "Expected documentation comment" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((15) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ParserC-45RuleC-45Source-documentation (lambda (arg-0) (vector 9 0 (vector 14 (LibrariesC-45TextC-45Parser-some ParserC-45RuleC-45Source-documentationC-39)) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (ParserC-45RuleC-45Source-decorationFromBounded arg-0 0 u--b)) (vector 0 (DataC-45String-fastUnlines (DataC-45List1-forget (let ((e-1 (vector-ref u--b 0))) e-1))))))))))
(define ParserC-45RuleC-45Source-optDocumentation (lambda (arg-0) (LibrariesC-45TextC-45Parser-option 1 "" (ParserC-45RuleC-45Source-documentation arg-0))))
(define IdrisC-45Parser-tyDecls (lambda (arg-0 arg-1 arg-2 arg-3) (vector 9 0 (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-2 ",") (vector 10 0 1 (vector 10 0 0 csegen-4306 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-optDocumentation arg-2)))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (vector 14 arg-0))))) (lambda () (lambda (u--docns) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-2 ":")) (lambda () (lambda (u--b) (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Expected a type declaration" (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-2 arg-3) (lambda () (lambda (u--ty) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (cons (let ((e-1 (vector-ref e-3 0))) e-1) (cons (CoreC-45FC-boundToFC arg-2 e-3) u--ty)))))) u--docns)))))))))))) (lambda () (lambda (u--bs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-3) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector e-10 e-10 e-6 (string-append arg-1 e-2) e-11)))))))) u--bs))))))))
(define IdrisC-45Parser-totalityOpt (lambda (arg-0) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 2) (IdrisC-45Parser-decoratedKeyword arg-0 "partial")) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (IdrisC-45Parser-decoratedKeyword arg-0 "total")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (IdrisC-45Parser-decoratedKeyword arg-0 "covering"))))))))
(define IdrisC-45Parser-fnOpt (lambda (arg-0) (vector 9 0 (IdrisC-45Parser-totalityOpt arg-0) (lambda () (lambda (u--x) (vector 0 (vector 0 (vector 11 u--x))))))))
(define IdrisC-45Parser-visOption (lambda (arg-0) (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "public")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 2) (IdrisC-45Parser-decoratedKeyword arg-0 "export"))))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-0 "public")) (lambda () (lambda (u--x) (vector 4 (box (let ((e-3 (vector-ref u--x 2))) e-3)) 1 "\"public\" keyword by itself is not an export modifier, did you mean \"public export\"?")))) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (IdrisC-45Parser-decoratedKeyword arg-0 "export")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (IdrisC-45Parser-decoratedKeyword arg-0 "private"))))))))))
(define IdrisC-45Parser-visOpt (lambda (arg-0) (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-visOption arg-0) (lambda () (lambda (u--vis) (vector 0 (vector 0 u--vis))))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-fnOpt arg-0) (lambda () (lambda (u--tot) (vector 0 (vector 1 u--tot))))) (lambda () (vector 9 0 (IdrisC-45Parser-fnDirectOpt arg-0) (lambda () (lambda (u--opt) (vector 0 (vector 1 u--opt)))))))))))
(define IdrisC-45Parser-claims (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-visOpt arg-0)) (lambda (u--visOpts) (vector 10 0 1 (IdrisC-45Parser-getVisibility '() u--visOpts) (lambda (u--vis) (let ((u--opts (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (DataC-45Either-getRight eta-0)) u--visOpts))) (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 0 (IdrisC-45Parser-tyDecls (IdrisC-45Parser-decorate arg-0 2 ParserC-45RuleC-45Source-name) u--doc arg-0 arg-1) (lambda () (lambda (u--cls) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (u--cl) (cons u--doc (cons u--vis (cons u--opts (cons u--rig u--cl))))) u--cls))))))))))))))) (lambda () (lambda (u--bs) (vector 0 (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 0 (CoreC-45FC-boundToFC arg-0 u--bs) e-14 e-6 e-10 e-15))))))))) (let ((e-1 (vector-ref u--bs 0))) e-1))))))))
(define ParserC-45RuleC-45Source-capitalisedName (ParserC-45RuleC-45Source-nameWithCapital 1))
(define IdrisC-45Parser-decoratedDataTypeName (lambda (arg-0) (IdrisC-45Parser-decorate arg-0 1 (vector 13 1 1 ParserC-45RuleC-45Source-opNonNS (lambda () ParserC-45RuleC-45Source-capitalisedName)))))
(define ParserC-45RuleC-45Source-atEndIndent (lambda (arg-0) (vector 13 0 0 ParserC-45RuleC-45Source-eoi (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (LibrariesC-45TextC-45Parser-when (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-0))) (cond ((equal? sc0 1) 0) (else 1))) (lambda () (vector 4 '() 0 "Not the end of a block entry")))))))))
(define IdrisC-45Parser-dataOpt (lambda (arg-0) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 )) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "noHints"))) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 2 )) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "uniqueSearch"))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "search")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 eta-0)) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-name)))))) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 3 )) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "external"))) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 4 )) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "noNewtype")))))))))))))
(define IdrisC-45Parser-dataOpts (lambda (arg-0) (LibrariesC-45TextC-45Parser-option 1 '() (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "[") (lambda () (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-dataOpt arg-0)) (lambda () (lambda (u--opts) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "]") (lambda () (vector 0 (DataC-45List1-forget u--opts))))))))))))
(define ParserC-45RuleC-45Source-capitalisedIdent (vector 9 0 (vector 14 ParserC-45RuleC-45Source-identPart) (lambda () (lambda (u--id) (vector 12 0 0 (ParserC-45RuleC-45Source-isCapitalisedIdent u--id) (vector 12 0 0 (ParserC-45RuleC-45Source-isNotReservedName u--id) (vector 0 (let ((e-1 (vector-ref u--id 0))) e-1))))))))
(define ParserC-45RuleC-45Source-dataConstructorName (vector 13 1 1 ParserC-45RuleC-45Source-opNonNS (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) ParserC-45RuleC-45Source-capitalisedIdent))))
(define IdrisC-45Parser-decoratedDataConstructorName (lambda (arg-0) (IdrisC-45Parser-decorate arg-0 3 ParserC-45RuleC-45Source-dataConstructorName)))
(define IdrisC-45Parser-dataBody (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 13 0 1 (vector 10 0 0 (PreludeC-45Types-maybe (lambda () (vector 4 '() 0 "Telescope is not optional in forward declaration")) (lambda () (lambda (eta-0) (vector 0 eta-0))) arg-6) (lambda (u--ty) (vector 12 0 0 (ParserC-45RuleC-45Source-atEndIndent arg-5) (vector 0 (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) arg-4 u--ty))))) (lambda () (vector 9 0 (vector 14 (vector 11 0 (vector 8 (IdrisC-45Parser-decoratedKeyword arg-1 "where")) (lambda () (vector 10 0 0 (IdrisC-45Parser-dataOpts arg-1) (lambda (u--opts) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter arg-2 (lambda (eta-0) (IdrisC-45Parser-tyDecls (vector 8 (IdrisC-45Parser-decoratedDataConstructorName arg-1)) "" arg-1 eta-0))) (lambda (u--cs) (vector 0 (cons u--opts (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (DataC-45List1-forget eta-0)) u--cs)))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 0 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--b)) arg-4 arg-6 e-2 e-3)))))))))))))
(define IdrisC-45Parser-gadtData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 ":") (lambda () (vector 12 0 1 (vector 7 ) (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-5))))) (lambda (u--ty) (IdrisC-45Parser-dataBody arg-1 arg-2 arg-3 (let ((e-1 (vector-ref arg-4 0))) e-1) arg-5 u--ty)))))
(define IdrisC-45Parser-mkTyConType (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (vector 22 (CoreC-45FC-virtualiseFC arg-1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--bfc (CoreC-45FC-boundToFC arg-0 e-2))) (vector 1 u--bfc AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) '() (vector 22 (CoreC-45FC-virtualiseFC arg-1)) (IdrisC-45Parser-mkTyConType arg-0 arg-1 e-3))))))))
(define IdrisC-45Syntax-papply (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45Syntax-papply arg-1 (vector 7 arg-1 arg-2 e-2) e-3))))))
(define IdrisC-45Parser-mkDataConType (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (box arg-1) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 1 arg-0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) '() e-4 eta-0)) (IdrisC-45Parser-mkDataConType arg-0 arg-1 e-3)))) ((1) (let ((e-5 (vector-ref e-2 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 1 arg-0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 2 ) '() e-5 eta-0)) (IdrisC-45Parser-mkDataConType arg-0 arg-1 e-3))))(else '())))))))
(define IdrisC-45Parser-simpleCon (lambda (arg-0 arg-1 arg-2) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--cdoc) (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedDataConstructorName arg-0)) (lambda () (lambda (u--cname) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-argExpr IdrisC-45Parser-plhs arg-0 arg-2)) (lambda (u--params) (vector 0 (cons u--cdoc (cons (let ((e-1 (vector-ref u--cname 0))) e-1) (cons (CoreC-45FC-boundToFC arg-0 u--cname) u--params)))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-2) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--cfc (CoreC-45FC-boundToFC arg-0 u--b))) (DataC-45Maybe-fromMaybe (lambda () (vector 4 '() 1 "Named arguments not allowed in ADT constructors")) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 0 (vector u--cfc e-10 e-6 e-2 eta-0))) (IdrisC-45Parser-mkDataConType u--cfc arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-11)))))))))))))))))))
(define IdrisC-45Parser-simpleData (lambda (arg-1 arg-2 arg-3 arg-4) (vector 9 0 (vector 14 (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 14 (IdrisC-45Parser-decorate arg-1 5 ParserC-45RuleC-45Source-name))) (lambda (u--params) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-1 "=")) (lambda () (lambda (u--tyend) (vector 8 (let ((u--tyfc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--tyend)))) (let ((u--tyCon (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) (let ((e-1 (vector-ref arg-3 0))) e-1)))) (let ((u--toPRef (lambda (u--t) (vector 0 (CoreC-45FC-boundToFC arg-1 u--t) (let ((e-1 (vector-ref u--t 0))) e-1))))) (let ((u--conRetTy (IdrisC-45Syntax-papply u--tyfc u--tyCon (PreludeC-45TypesC-45List-mapAppend '() u--toPRef u--params)))) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 "|") (IdrisC-45Parser-simpleCon arg-1 u--conRetTy arg-4)) (lambda () (lambda (u--cons) (vector 0 (cons u--params (cons u--tyfc (DataC-45List1-forget u--cons)))))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 0 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b)) (let ((e-1 (vector-ref arg-3 0))) e-1) (box (IdrisC-45Parser-mkTyConType arg-1 e-6 e-2)) '() e-7)))))))))))))
(define IdrisC-45Parser-dataDeclBody (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "data") (lambda () (vector 9 0 (vector 8 (vector 14 (IdrisC-45Parser-decoratedDataTypeName arg-0))) (lambda () (lambda (u--n) (vector 0 (cons u--col u--n)))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 13 1 0 (IdrisC-45Parser-simpleData arg-0 u--b e-3 arg-1) (lambda () (IdrisC-45Parser-gadtData arg-0 e-2 u--b e-3 arg-1))))))))))))
(define IdrisC-45Parser-visibility (lambda (arg-0) (vector 13 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (LibrariesC-45DataC-45WithDefault-specified eta-0)) (IdrisC-45Parser-visOption arg-0)) (lambda () (vector 0 LibrariesC-45DataC-45WithDefault-defaulted)))))
(define IdrisC-45Parser-dataVisOpt (lambda (arg-0) (vector 13 1 0 (vector 9 0 (IdrisC-45Parser-visOption arg-0) (lambda () (lambda (u--vis) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-totalityOpt arg-0)) (lambda (u--mbtot) (vector 0 (cons (LibrariesC-45DataC-45WithDefault-specified u--vis) u--mbtot))))))) (lambda () (vector 13 1 0 (vector 9 0 (IdrisC-45Parser-totalityOpt arg-0) (lambda () (lambda (u--tot) (vector 10 0 0 (IdrisC-45Parser-visibility arg-0) (lambda (u--vis) (vector 0 (cons u--vis (box u--tot)))))))) (lambda () csegen-2952))))))
(define IdrisC-45Parser-dataDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 1 (IdrisC-45Parser-dataVisOpt arg-0) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 9 0 (IdrisC-45Parser-dataDeclBody arg-0 arg-1) (lambda () (lambda (u--dat) (vector 0 (cons u--doc (cons e-2 (cons e-3 u--dat)))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 0 (vector 2 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-10 e-11)))))))))))))))
(define ParserC-45RuleC-45Source-nonEmptyBlockAfter (lambda (arg-1 arg-2) (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-blockEntry (vector 0 ) arg-2) (lambda () (lambda (u--res) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-2) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (Builtin-fst u--res) u--ps)))))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-1))) (cond ((equal? sc0 0) (vector 9 0 (ParserC-45RuleC-45Source-blockEntry (vector 1 u--col) arg-2) (lambda () (lambda (u--res) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (Builtin-snd u--res) arg-2) (lambda (u--ps) (vector 0 (cons (Builtin-fst u--res) u--ps)))))))) (else (vector 4 '() 1 "Expected an indented non-empty block"))))))))))
(define IdrisC-45Parser-whereBlock (lambda (arg-0 arg-1) (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-0 "where") (lambda () (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter arg-1 (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 0 (IdrisC-45Parser-collectDefs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--ds)))))))))
(define IdrisC-45Parser-withFlags (lambda (arg-0) (vector 13 1 0 (vector 11 0 (IdrisC-45Parser-decoratedPragma arg-0 "syntactic") (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (arg-1) (cons (vector 0 ) arg-1)) (IdrisC-45Parser-withFlags arg-0)))) (lambda () (vector 0 '())))))
(define IdrisC-45Parser-withProblem (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (vector 8 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-0 "("))) (lambda () (lambda (u--start) (vector 9 0 (IdrisC-45Parser-bracketedExpr arg-0 u--start arg-2) (lambda () (lambda (u--wval) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "proof")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-0)))))) (lambda (u--prf) (vector 0 (vector u--rig u--wval u--prf))))))))))))))
(define csegen-4480 (vector 14 (vector 2 "Unrecognised token" (lambda (eta-0) 1))))
(define IdrisC-45Syntax-applyArgs (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (IdrisC-45Syntax-applyArgs (vector 7 e-6 arg-1 e-7) e-3))))))))
(define csegen-4481 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Syntax-applyArgs eta-0 eta-1))))
(define IdrisC-45Parser-parseRHS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 "=") (lambda () (vector 8 (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-2 arg-5) (lambda () (lambda (u--rhs) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 '() (IdrisC-45Parser-whereBlock arg-2 arg-4)) (lambda (u--ws) (vector 0 (cons u--rhs u--ws))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 csegen-4480 (lambda (u--bC-39) (vector 12 0 0 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 0 (let ((e-3 (vector-ref u--bC-39 2))) e-3) "Not the end of a block entry, check indentation" (ParserC-45RuleC-45Source-atEnd arg-5)) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--fc (CoreC-45FC-boundToFC arg-2 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--b)))) (vector 0 (vector 0 u--fc (PreludeC-45Basics-uncurry csegen-4481 arg-6) e-2 e-3))))))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-2 "with") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (IdrisC-45Parser-withFlags arg-2) (lambda (u--flags) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-2 "|") (IdrisC-45Parser-withProblem arg-2 arg-4 arg-5)) (lambda () (lambda (u--wps) (vector 9 0 (vector 8 (ParserC-45RuleC-45Source-nonEmptyBlockAfter arg-4 (lambda (eta-0) (IdrisC-45Parser-clause (+ (+ (PreludeC-45TypesC-45List-lengthTR (let ((e-2 (cdr u--wps))) e-2)) 1) arg-1) (box arg-6) arg-2 eta-0)))) (lambda () (lambda (u--ws) (vector 0 (cons u--flags (cons u--wps (DataC-45List1-forget u--ws)))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--fc (CoreC-45FC-boundToFC arg-2 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--b)))) (vector 0 (vector 1 u--fc (PreludeC-45Basics-uncurry csegen-4481 arg-6) e-6 e-2 e-7)))))))))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-2 "impossible")) (lambda () (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-5) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-2 (LibrariesC-45TextC-45Bounded-mergeBounds arg-3 u--end)))) (vector 2 u--fc (PreludeC-45Basics-uncurry csegen-4481 arg-6))))))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10048-u--go3TupledPTerms (lambda (arg-1 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons (cons e-6 (cons e-10 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-11))) (IdrisC-45SyntaxC-45Traversals-n--10261-10048-u--go3TupledPTerms arg-1 e-3)))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10064-u--goPiInfo (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (vector 3 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-1))))(else arg-2))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10049-u--go4TupledPTerms (lambda (arg-1 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (cons (cons e-6 (cons e-10 (cons (IdrisC-45SyntaxC-45Traversals-n--10261-10064-u--goPiInfo arg-1 e-14) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-15)))) (IdrisC-45SyntaxC-45Traversals-n--10261-10049-u--go4TupledPTerms arg-1 e-3)))))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10050-u--goImplicits (lambda (arg-1 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (cons (cons e-6 (cons e-10 (cons e-14 (cons (IdrisC-45SyntaxC-45Traversals-n--10261-10064-u--goPiInfo arg-1 e-18) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-19))))) (IdrisC-45SyntaxC-45Traversals-n--10261-10050-u--goImplicits arg-1 e-3)))))))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10060-u--goPTypeDecl (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector e-1 e-2 e-3 e-4 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-5)))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10052-u--goPDataDecl (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (vector 0 e-1 e-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 eta-0)) e-3) e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10060-u--goPTypeDecl arg-1 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (vector 1 e-7 e-8 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-9)))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10055-u--goPField (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((e-6 (vector-ref arg-2 5))) (vector e-1 e-2 e-3 (IdrisC-45SyntaxC-45Traversals-n--10261-10064-u--goPiInfo arg-1 e-4) e-5 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-6))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10057-u--goPFnOpt (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) arg-2) ((1) (let ((e-3 (vector-ref arg-2 1))) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 eta-0)) e-3)))) (else (let ((e-5 (vector-ref arg-2 1))) (vector 2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 eta-0)) e-5)))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10062-u--goPairedPTerms (lambda (arg-1 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (cons (cons e-6 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-7)) (IdrisC-45SyntaxC-45Traversals-n--10261-10062-u--goPairedPTerms arg-1 e-3)))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (vector 0 e-1 e-2 e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10057-u--goPFnOpt arg-1 eta-0)) e-4) (IdrisC-45SyntaxC-45Traversals-n--10261-10060-u--goPTypeDecl arg-1 e-5)))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (vector 1 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause arg-1 eta-0)) e-8))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((e-14 (vector-ref arg-2 5))) (vector 2 e-10 e-11 e-12 e-13 (IdrisC-45SyntaxC-45Traversals-n--10261-10052-u--goPDataDecl arg-1 e-14)))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (vector 3 e-16 (IdrisC-45SyntaxC-45Traversals-n--10261-10049-u--go4TupledPTerms arg-1 e-17) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-18)))))) ((4) (let ((e-20 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 3))) (vector 4 e-20 (IdrisC-45SyntaxC-45Traversals-n--10261-10062-u--goPairedPTerms arg-1 e-21) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-22)))))) ((5) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((e-27 (vector-ref arg-2 4))) (let ((e-28 (vector-ref arg-2 5))) (let ((e-29 (vector-ref arg-2 6))) (let ((e-30 (vector-ref arg-2 7))) (let ((e-31 (vector-ref arg-2 8))) (let ((e-32 (vector-ref arg-2 9))) (vector 5 e-24 e-25 (IdrisC-45SyntaxC-45Traversals-n--10261-10062-u--goPairedPTerms arg-1 e-26) e-27 e-28 (IdrisC-45SyntaxC-45Traversals-n--10261-10048-u--go3TupledPTerms arg-1 e-29) e-30 e-31 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-32)))))))))))) ((6) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (let ((e-38 (vector-ref arg-2 5))) (let ((e-39 (vector-ref arg-2 6))) (let ((e-40 (vector-ref arg-2 7))) (let ((e-41 (vector-ref arg-2 8))) (let ((e-42 (vector-ref arg-2 9))) (let ((e-43 (vector-ref arg-2 10))) (let ((e-44 (vector-ref arg-2 11))) (vector 6 e-34 e-35 e-36 e-37 (IdrisC-45SyntaxC-45Traversals-n--10261-10050-u--goImplicits arg-1 e-38) (IdrisC-45SyntaxC-45Traversals-n--10261-10062-u--goPairedPTerms arg-1 e-39) e-40 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 eta-0)) e-41) e-42 e-43 (PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) arg-0)) e-44)))))))))))))) ((7) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((e-50 (vector-ref arg-2 5))) (case (vector-ref e-50 0) ((0) (let ((e-84 (vector-ref e-50 1))) (let ((e-85 (vector-ref e-50 2))) (let ((e-86 (vector-ref e-50 3))) (let ((e-87 (vector-ref e-50 4))) (let ((e-88 (vector-ref e-50 5))) (vector 7 e-46 e-47 e-48 e-49 (vector 0 e-84 (IdrisC-45SyntaxC-45Traversals-n--10261-10049-u--go4TupledPTerms arg-1 e-85) e-86 e-87 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10055-u--goPField arg-1 eta-0)) e-88))))))))) (else (let ((e-90 (vector-ref e-50 1))) (let ((e-91 (vector-ref e-50 2))) (vector 7 e-46 e-47 e-48 e-49 (vector 1 e-90 (IdrisC-45SyntaxC-45Traversals-n--10261-10049-u--go4TupledPTerms arg-1 e-91))))))))))))) ((8) (let ((e-52 (vector-ref arg-2 1))) (let ((e-53 (vector-ref arg-2 2))) (let ((e-54 (vector-ref arg-2 3))) (vector 8 e-52 e-53 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-54)))))) ((9) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (vector 9 e-56 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-57))))) ((10) arg-2) ((11) (let ((e-65 (vector-ref arg-2 1))) (let ((e-66 (vector-ref arg-2 2))) (let ((e-67 (vector-ref arg-2 3))) (vector 11 e-65 e-66 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-67)))))) ((12) (let ((e-69 (vector-ref arg-2 1))) (let ((e-70 (vector-ref arg-2 2))) (let ((e-71 (vector-ref arg-2 3))) (let ((e-72 (vector-ref arg-2 4))) (vector 12 e-69 e-70 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-71) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-72))))))) ((13) (let ((e-74 (vector-ref arg-2 1))) (let ((e-75 (vector-ref arg-2 2))) (vector 13 e-74 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-75))))) ((14) arg-2) (else arg-2))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10061-u--goPWithProblem (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector e-1 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-2) e-3))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 0 e-1 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-2) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (vector 1 e-6 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-7) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10061-u--goPWithProblem arg-1 eta-0)) e-8) e-9 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause arg-1 eta-0)) e-10)))))))) (else (let ((e-12 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 2))) (vector 2 e-12 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-13))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10054-u--goPDo (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (vector 0 e-1 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-2))))) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (vector 1 e-4 e-5 e-6 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-7))))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (vector 2 e-9 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-10) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause arg-1 eta-0)) e-12))))))) ((3) (let ((e-14 (vector-ref arg-2 1))) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (let ((e-18 (vector-ref arg-2 5))) (let ((e-19 (vector-ref arg-2 6))) (vector 3 e-14 e-15 e-16 e-17 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-18) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-19))))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (let ((e-25 (vector-ref arg-2 5))) (vector 4 e-21 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-22) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-23) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-24) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause arg-1 eta-0)) e-25)))))))) ((5) (let ((e-27 (vector-ref arg-2 1))) (let ((e-28 (vector-ref arg-2 2))) (vector 5 e-27 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-28))))) (else (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (vector 6 e-30 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-31))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10056-u--goPFieldUpdate (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (vector 0 e-1 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-2))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (vector 1 e-4 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-5))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10058-u--goPStr (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (vector 1 e-1 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-2)))))(else arg-2))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10063-u--goPairedSnocPTerms (lambda (arg-1 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (IdrisC-45SyntaxC-45Traversals-n--10261-10063-u--goPairedSnocPTerms arg-1 e-2) (cons e-6 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-7))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (arg-1 arg-2)) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (arg-1 (vector 1 e-4 e-5 (IdrisC-45SyntaxC-45Traversals-n--10261-10064-u--goPiInfo arg-1 e-6) e-7 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-8) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-9)))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((e-15 (vector-ref arg-2 5))) (let ((e-16 (vector-ref arg-2 6))) (arg-1 (vector 2 e-11 e-12 (IdrisC-45SyntaxC-45Traversals-n--10261-10064-u--goPiInfo arg-1 e-13) e-14 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-15) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-16)))))))))) ((3) (let ((e-18 (vector-ref arg-2 1))) (let ((e-19 (vector-ref arg-2 2))) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (let ((e-23 (vector-ref arg-2 6))) (let ((e-24 (vector-ref arg-2 7))) (arg-1 (vector 3 e-18 e-19 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-20) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-21) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-22) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-23) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause arg-1 eta-0)) e-24))))))))))) ((4) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (arg-1 (vector 4 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10057-u--goPFnOpt arg-1 eta-0)) e-27) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-28) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10051-u--goPClause arg-1 eta-0)) e-29)))))))) ((5) (let ((e-31 (vector-ref arg-2 1))) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (arg-1 (vector 5 e-31 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-32) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-33))))))) ((6) (let ((e-35 (vector-ref arg-2 1))) (let ((e-36 (vector-ref arg-2 2))) (arg-1 (vector 6 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10056-u--goPFieldUpdate arg-1 eta-0)) e-36)))))) ((7) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (arg-1 (vector 7 e-38 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-39) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-40))))))) ((8) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (arg-1 (vector 8 e-42 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-43) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-44))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (arg-1 (vector 10 e-46 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-47) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-48))))))) ((9) (let ((e-50 (vector-ref arg-2 1))) (let ((e-51 (vector-ref arg-2 2))) (let ((e-52 (vector-ref arg-2 3))) (let ((e-53 (vector-ref arg-2 4))) (arg-1 (vector 9 e-50 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-51) e-52 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-53)))))))) ((11) (let ((e-55 (vector-ref arg-2 1))) (let ((e-56 (vector-ref arg-2 2))) (let ((e-57 (vector-ref arg-2 3))) (arg-1 (vector 11 e-55 e-56 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-57))))))) ((12) (let ((e-59 (vector-ref arg-2 1))) (let ((e-60 (vector-ref arg-2 2))) (arg-1 (vector 12 e-59 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-60)))))) ((13) (let ((e-62 (vector-ref arg-2 1))) (let ((e-63 (vector-ref arg-2 2))) (arg-1 (vector 13 e-62 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-63)))))) ((14) (arg-1 arg-2)) ((15) (arg-1 arg-2)) ((16) (let ((e-71 (vector-ref arg-2 1))) (let ((e-72 (vector-ref arg-2 2))) (arg-1 (vector 16 e-71 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-72)))))) ((17) (arg-1 arg-2)) ((18) (let ((e-77 (vector-ref arg-2 1))) (let ((e-78 (vector-ref arg-2 2))) (arg-1 (vector 18 e-77 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10053-u--goPDecl arg-1 eta-0)) e-78)))))) ((19) (let ((e-80 (vector-ref arg-2 1))) (let ((e-81 (vector-ref arg-2 2))) (arg-1 (vector 19 e-80 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-81)))))) ((20) (let ((e-83 (vector-ref arg-2 1))) (let ((e-84 (vector-ref arg-2 2))) (arg-1 (vector 20 e-83 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-84)))))) ((21) (arg-1 arg-2)) ((22) (arg-1 arg-2)) ((23) (let ((e-92 (vector-ref arg-2 1))) (let ((e-93 (vector-ref arg-2 2))) (let ((e-94 (vector-ref arg-2 3))) (let ((e-95 (vector-ref arg-2 4))) (arg-1 (vector 23 e-92 e-93 e-94 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-95)))))))) ((24) (let ((e-97 (vector-ref arg-2 1))) (let ((e-98 (vector-ref arg-2 2))) (arg-1 (vector 24 e-97 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-98)))))) ((25) (arg-1 arg-2)) ((26) (arg-1 arg-2)) ((27) (let ((e-104 (vector-ref arg-2 1))) (let ((e-105 (vector-ref arg-2 2))) (let ((e-106 (vector-ref arg-2 3))) (let ((e-107 (vector-ref arg-2 4))) (let ((e-108 (vector-ref arg-2 5))) (arg-1 (vector 27 e-104 e-105 e-106 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-107) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-108))))))))) ((28) (let ((e-110 (vector-ref arg-2 1))) (let ((e-111 (vector-ref arg-2 2))) (let ((e-112 (vector-ref arg-2 3))) (let ((e-113 (vector-ref arg-2 4))) (arg-1 (vector 28 e-110 e-111 e-112 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-113)))))))) ((29) (let ((e-115 (vector-ref arg-2 1))) (let ((e-116 (vector-ref arg-2 2))) (let ((e-117 (vector-ref arg-2 3))) (let ((e-118 (vector-ref arg-2 4))) (arg-1 (vector 29 e-115 e-116 e-117 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-118)))))))) ((30) (let ((e-120 (vector-ref arg-2 1))) (let ((e-121 (vector-ref arg-2 2))) (let ((e-122 (vector-ref arg-2 3))) (let ((e-123 (vector-ref arg-2 4))) (arg-1 (vector 30 e-120 e-121 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-122) e-123))))))) ((31) (let ((e-125 (vector-ref arg-2 1))) (let ((e-126 (vector-ref arg-2 2))) (let ((e-127 (vector-ref arg-2 3))) (arg-1 (vector 31 e-125 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-126) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-127))))))) ((32) (let ((e-129 (vector-ref arg-2 1))) (let ((e-130 (vector-ref arg-2 2))) (arg-1 (vector 32 e-129 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-130)))))) ((33) (let ((e-132 (vector-ref arg-2 1))) (let ((e-133 (vector-ref arg-2 2))) (let ((e-134 (vector-ref arg-2 3))) (arg-1 (vector 33 e-132 e-133 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10058-u--goPStr arg-1 eta-0)) e-134))))))) ((34) (let ((e-136 (vector-ref arg-2 1))) (let ((e-137 (vector-ref arg-2 2))) (let ((e-138 (vector-ref arg-2 3))) (let ((e-139 (vector-ref arg-2 4))) (arg-1 (vector 34 e-136 e-137 e-138 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--10261-10058-u--goPStr arg-1 eta-1)) eta-0)) e-139)))))))) ((35) (let ((e-141 (vector-ref arg-2 1))) (let ((e-142 (vector-ref arg-2 2))) (let ((e-143 (vector-ref arg-2 3))) (arg-1 (vector 35 e-141 e-142 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10054-u--goPDo arg-1 eta-0)) e-143))))))) ((36) (let ((e-145 (vector-ref arg-2 1))) (let ((e-146 (vector-ref arg-2 2))) (arg-1 (vector 36 e-145 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-146)))))) ((37) (let ((e-148 (vector-ref arg-2 1))) (let ((e-149 (vector-ref arg-2 2))) (let ((e-150 (vector-ref arg-2 3))) (arg-1 (vector 37 e-148 e-149 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-150))))))) ((38) (let ((e-152 (vector-ref arg-2 1))) (let ((e-153 (vector-ref arg-2 2))) (let ((e-154 (vector-ref arg-2 3))) (arg-1 (vector 38 e-152 e-153 (IdrisC-45SyntaxC-45Traversals-n--10261-10062-u--goPairedPTerms arg-1 e-154))))))) ((39) (let ((e-156 (vector-ref arg-2 1))) (let ((e-157 (vector-ref arg-2 2))) (let ((e-158 (vector-ref arg-2 3))) (arg-1 (vector 39 e-156 e-157 (IdrisC-45SyntaxC-45Traversals-n--10261-10063-u--goPairedSnocPTerms arg-1 e-158))))))) ((40) (let ((e-160 (vector-ref arg-2 1))) (let ((e-161 (vector-ref arg-2 2))) (let ((e-162 (vector-ref arg-2 3))) (arg-1 (vector 40 e-160 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-161) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-162))))))) ((41) (let ((e-164 (vector-ref arg-2 1))) (let ((e-165 (vector-ref arg-2 2))) (let ((e-166 (vector-ref arg-2 3))) (let ((e-167 (vector-ref arg-2 4))) (let ((e-168 (vector-ref arg-2 5))) (arg-1 (vector 41 e-164 e-165 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-166) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-167) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-168))))))))) ((42) (arg-1 arg-2)) ((43) (let ((e-172 (vector-ref arg-2 1))) (let ((e-173 (vector-ref arg-2 2))) (let ((e-174 (vector-ref arg-2 3))) (let ((e-175 (vector-ref arg-2 4))) (arg-1 (vector 43 e-172 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-173) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-174) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-175)))))))) ((44) (let ((e-177 (vector-ref arg-2 1))) (let ((e-178 (vector-ref arg-2 2))) (let ((e-179 (vector-ref arg-2 3))) (arg-1 (vector 44 e-177 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-178) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10054-u--goPDo arg-1 eta-0)) e-179))))))) ((45) (let ((e-181 (vector-ref arg-2 1))) (let ((e-182 (vector-ref arg-2 2))) (let ((e-183 (vector-ref arg-2 3))) (arg-1 (vector 45 e-181 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-182) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-183))))))) ((46) (let ((e-185 (vector-ref arg-2 1))) (let ((e-186 (vector-ref arg-2 2))) (let ((e-187 (vector-ref arg-2 3))) (let ((e-188 (vector-ref arg-2 4))) (arg-1 (vector 46 e-185 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-186) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 eta-0)) e-187) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-188)))))))) ((47) (let ((e-190 (vector-ref arg-2 1))) (let ((e-191 (vector-ref arg-2 2))) (let ((e-192 (vector-ref arg-2 3))) (arg-1 (vector 47 e-190 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-191) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 eta-0)) e-192))))))) ((50) (let ((e-194 (vector-ref arg-2 1))) (let ((e-195 (vector-ref arg-2 2))) (let ((e-196 (vector-ref arg-2 3))) (arg-1 (vector 50 e-194 e-195 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-196))))))) ((48) (let ((e-198 (vector-ref arg-2 1))) (let ((e-199 (vector-ref arg-2 2))) (let ((e-200 (vector-ref arg-2 3))) (arg-1 (vector 48 e-198 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-199) e-200)))))) ((49) (arg-1 arg-2)) (else (let ((e-205 (vector-ref arg-2 1))) (let ((e-206 (vector-ref arg-2 2))) (let ((e-207 (vector-ref arg-2 3))) (arg-1 (vector 51 e-205 e-206 (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 e-207))))))))))
(define IdrisC-45SyntaxC-45Traversals-mapPTerm (lambda (arg-1 ext-0) (IdrisC-45SyntaxC-45Traversals-n--10261-10059-u--goPTerm arg-1 ext-0)))
(define IdrisC-45SyntaxC-45Traversals-substFC (lambda (arg-1 ext-0) (IdrisC-45SyntaxC-45Traversals-mapPTerm (lambda (lcase-0) (case (vector-ref lcase-0 0) ((0) (let ((e-2 (vector-ref lcase-0 2))) (vector 0 arg-1 e-2))) ((1) (let ((e-5 (vector-ref lcase-0 2))) (let ((e-6 (vector-ref lcase-0 3))) (let ((e-7 (vector-ref lcase-0 4))) (let ((e-8 (vector-ref lcase-0 5))) (let ((e-9 (vector-ref lcase-0 6))) (vector 1 arg-1 e-5 e-6 e-7 e-8 e-9))))))) ((2) (let ((e-12 (vector-ref lcase-0 2))) (let ((e-13 (vector-ref lcase-0 3))) (let ((e-14 (vector-ref lcase-0 4))) (let ((e-15 (vector-ref lcase-0 5))) (let ((e-16 (vector-ref lcase-0 6))) (vector 2 arg-1 e-12 e-13 e-14 e-15 e-16))))))) ((3) (let ((e-19 (vector-ref lcase-0 2))) (let ((e-20 (vector-ref lcase-0 3))) (let ((e-21 (vector-ref lcase-0 4))) (let ((e-22 (vector-ref lcase-0 5))) (let ((e-23 (vector-ref lcase-0 6))) (let ((e-24 (vector-ref lcase-0 7))) (vector 3 arg-1 e-19 e-20 e-21 e-22 e-23 e-24)))))))) ((4) (let ((e-27 (vector-ref lcase-0 2))) (let ((e-28 (vector-ref lcase-0 3))) (let ((e-29 (vector-ref lcase-0 4))) (vector 4 arg-1 e-27 e-28 e-29))))) ((5) (let ((e-32 (vector-ref lcase-0 2))) (let ((e-33 (vector-ref lcase-0 3))) (vector 5 arg-1 e-32 e-33)))) ((6) (let ((e-36 (vector-ref lcase-0 2))) (vector 6 arg-1 e-36))) ((7) (let ((e-39 (vector-ref lcase-0 2))) (let ((e-40 (vector-ref lcase-0 3))) (vector 7 arg-1 e-39 e-40)))) ((8) (let ((e-43 (vector-ref lcase-0 2))) (let ((e-44 (vector-ref lcase-0 3))) (vector 8 arg-1 e-43 e-44)))) ((9) (let ((e-47 (vector-ref lcase-0 2))) (let ((e-48 (vector-ref lcase-0 3))) (let ((e-49 (vector-ref lcase-0 4))) (vector 9 arg-1 e-47 e-48 e-49))))) ((10) (let ((e-52 (vector-ref lcase-0 2))) (let ((e-53 (vector-ref lcase-0 3))) (vector 10 arg-1 e-52 e-53)))) ((11) (let ((e-56 (vector-ref lcase-0 2))) (let ((e-57 (vector-ref lcase-0 3))) (vector 11 arg-1 e-56 e-57)))) ((12) (let ((e-60 (vector-ref lcase-0 2))) (vector 12 arg-1 e-60))) ((13) (let ((e-63 (vector-ref lcase-0 2))) (vector 13 arg-1 e-63))) ((14) (let ((e-66 (vector-ref lcase-0 2))) (vector 14 arg-1 e-66))) ((15) (let ((e-69 (vector-ref lcase-0 2))) (vector 15 arg-1 e-69))) ((16) (let ((e-72 (vector-ref lcase-0 2))) (vector 16 arg-1 e-72))) ((17) (let ((e-75 (vector-ref lcase-0 2))) (vector 17 arg-1 e-75))) ((18) (let ((e-78 (vector-ref lcase-0 2))) (vector 18 arg-1 e-78))) ((19) (let ((e-81 (vector-ref lcase-0 2))) (vector 19 arg-1 e-81))) ((20) (let ((e-84 (vector-ref lcase-0 2))) (vector 20 arg-1 e-84))) ((21) (let ((e-87 (vector-ref lcase-0 2))) (let ((e-88 (vector-ref lcase-0 3))) (vector 21 arg-1 e-87 e-88)))) ((22) (vector 22 arg-1)) ((23) (let ((e-94 (vector-ref lcase-0 3))) (let ((e-95 (vector-ref lcase-0 4))) (vector 23 arg-1 arg-1 e-94 e-95)))) ((24) (let ((e-98 (vector-ref lcase-0 2))) (vector 24 arg-1 e-98))) ((25) (vector 25 arg-1)) ((26) (vector 26 arg-1)) ((27) (let ((e-106 (vector-ref lcase-0 3))) (let ((e-107 (vector-ref lcase-0 4))) (let ((e-108 (vector-ref lcase-0 5))) (vector 27 arg-1 arg-1 e-106 e-107 e-108))))) ((28) (let ((e-112 (vector-ref lcase-0 3))) (let ((e-113 (vector-ref lcase-0 4))) (vector 28 arg-1 arg-1 e-112 e-113)))) ((29) (let ((e-117 (vector-ref lcase-0 3))) (let ((e-118 (vector-ref lcase-0 4))) (vector 29 arg-1 arg-1 e-117 e-118)))) ((30) (let ((e-122 (vector-ref lcase-0 3))) (let ((e-123 (vector-ref lcase-0 4))) (vector 30 arg-1 arg-1 e-122 e-123)))) ((31) (let ((e-126 (vector-ref lcase-0 2))) (let ((e-127 (vector-ref lcase-0 3))) (vector 31 arg-1 e-126 e-127)))) ((32) (let ((e-130 (vector-ref lcase-0 2))) (vector 32 arg-1 e-130))) ((33) (let ((e-133 (vector-ref lcase-0 2))) (let ((e-134 (vector-ref lcase-0 3))) (vector 33 arg-1 e-133 e-134)))) ((34) (let ((e-137 (vector-ref lcase-0 2))) (let ((e-138 (vector-ref lcase-0 3))) (let ((e-139 (vector-ref lcase-0 4))) (vector 34 arg-1 e-137 e-138 e-139))))) ((35) (let ((e-142 (vector-ref lcase-0 2))) (let ((e-143 (vector-ref lcase-0 3))) (vector 35 arg-1 e-142 e-143)))) ((36) (let ((e-146 (vector-ref lcase-0 2))) (vector 36 arg-1 e-146))) ((37) (let ((e-149 (vector-ref lcase-0 2))) (let ((e-150 (vector-ref lcase-0 3))) (vector 37 arg-1 e-149 e-150)))) ((38) (let ((e-154 (vector-ref lcase-0 3))) (vector 38 arg-1 arg-1 e-154))) ((39) (let ((e-158 (vector-ref lcase-0 3))) (vector 39 arg-1 arg-1 e-158))) ((40) (let ((e-161 (vector-ref lcase-0 2))) (let ((e-162 (vector-ref lcase-0 3))) (vector 40 arg-1 e-161 e-162)))) ((41) (let ((e-166 (vector-ref lcase-0 3))) (let ((e-167 (vector-ref lcase-0 4))) (let ((e-168 (vector-ref lcase-0 5))) (vector 41 arg-1 arg-1 e-166 e-167 e-168))))) ((42) (vector 42 arg-1)) ((43) (let ((e-173 (vector-ref lcase-0 2))) (let ((e-174 (vector-ref lcase-0 3))) (let ((e-175 (vector-ref lcase-0 4))) (vector 43 arg-1 e-173 e-174 e-175))))) ((44) (let ((e-178 (vector-ref lcase-0 2))) (let ((e-179 (vector-ref lcase-0 3))) (vector 44 arg-1 e-178 e-179)))) ((45) (let ((e-182 (vector-ref lcase-0 2))) (let ((e-183 (vector-ref lcase-0 3))) (vector 45 arg-1 e-182 e-183)))) ((46) (let ((e-186 (vector-ref lcase-0 2))) (let ((e-187 (vector-ref lcase-0 3))) (let ((e-188 (vector-ref lcase-0 4))) (vector 46 arg-1 e-186 e-187 e-188))))) ((47) (let ((e-191 (vector-ref lcase-0 2))) (let ((e-192 (vector-ref lcase-0 3))) (vector 47 arg-1 e-191 e-192)))) ((48) (let ((e-195 (vector-ref lcase-0 2))) (let ((e-196 (vector-ref lcase-0 3))) (vector 48 arg-1 e-195 e-196)))) ((49) (let ((e-199 (vector-ref lcase-0 2))) (vector 49 arg-1 e-199))) ((50) (let ((e-202 (vector-ref lcase-0 2))) (let ((e-203 (vector-ref lcase-0 3))) (vector 50 arg-1 e-202 e-203)))) (else (let ((e-206 (vector-ref lcase-0 2))) (let ((e-207 (vector-ref lcase-0 3))) (vector 51 arg-1 e-206 e-207)))))) ext-0)))
(define IdrisC-45Parser-n--22575-16243-u--clauseLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (if (null? arg-7) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 '())) (IdrisC-45Parser-opExpr IdrisC-45Parser-plhs arg-5 arg-0)) (let ((e-2 (unbox arg-7))) (vector 9 0 (IdrisC-45Parser-opExpr IdrisC-45Parser-plhs arg-5 arg-0) (lambda () (lambda (u--e) (vector 0 (case (vector-ref u--e 0) ((25) (let ((e-1 (vector-ref u--e 1))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-1))) (let ((e-4 (car e-2))) (let ((e-3 (cdr e-2))) (cons (IdrisC-45SyntaxC-45Traversals-substFC u--vfc e-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-6 (car eta-0))) (let ((e-5 (cdr eta-0))) (cons e-6 (IdrisC-45SyntaxC-45Traversals-substFC u--vfc e-5))))) e-3)))))))(else (cons u--e '())))))))))))
(define IdrisC-45Parser-n--22575-16244-u--parseWithArg (lambda (arg-0 arg-1 arg-2 arg-3) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "|") (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-expr IdrisC-45Parser-plhs arg-1 arg-0)) (lambda () (lambda (u--tm) (vector 0 (cons (CoreC-45FC-boundToFC arg-1 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1))))))))))
(define IdrisC-45Parser-clause (lambda (arg-0 arg-1 arg-2 arg-3) (vector 9 1 (vector 14 (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 9 0 (IdrisC-45Parser-n--22575-16243-u--clauseLHS arg-3 arg-2 arg-0 arg-1 arg-2 arg-3 arg-1) (lambda () (lambda (u--lhsws) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-n--22575-16244-u--parseWithArg arg-3 arg-2 arg-0 arg-1)) (lambda (u--extra) (vector 0 (cons u--col (let ((e-2 (car u--lhsws))) (let ((e-3 (cdr u--lhsws))) (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 u--extra)))))))))))))) (lambda () (lambda (u--b) (let ((u--col (Builtin-fst (let ((e-1 (vector-ref u--b 0))) e-1)))) (let ((u--lhs (Builtin-snd (let ((e-1 (vector-ref u--b 0))) e-1)))) (let ((u--extra (Builtin-snd u--lhs))) (let ((sc0 (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-0 (PreludeC-45TypesC-45List-lengthTR u--extra)))) (cond ((equal? sc0 1) (vector 4 '() 1 (string-append "Wrong number of 'with' arguments:" (string-append " expected " (string-append (PreludeC-45Show-u--show_Show_Nat arg-0) (string-append " but got " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR u--extra)))))))) (else (IdrisC-45Parser-parseRHS arg-0 arg-2 u--b u--col arg-3 u--lhs))))))))))))
(define IdrisC-45Parser-definition (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (IdrisC-45Parser-clause 0 '() arg-0 arg-1)) (lambda () (lambda (u--nd) (vector 0 (vector 1 (CoreC-45FC-boundToFC arg-0 u--nd) (cons (let ((e-1 (vector-ref u--nd 0))) e-1) '()))))))))
(define IdrisC-45Parser-extension (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Source-exactIdent "ElabReflection")) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (ParserC-45RuleC-45Source-exactIdent "Borrowing")) (lambda () (vector 4 '() 0 "expected either 'ElabReflection' or 'Borrowing'"))))))
(define ParserC-45RuleC-45Source-n--12094-7507-u--checkFixity (lambda (arg-0 arg-1) (cond ((equal? arg-0 "infixl") (vector 0 0)) ((equal? arg-0 "infixr") (vector 0 1)) ((equal? arg-0 "infix") (vector 0 2)) ((equal? arg-0 "prefix") (vector 0 3))(else (vector 4 (box arg-1) 0 "")))))
(define ParserC-45RuleC-45Source-fixityNS (vector 9 1 (vector 14 ParserC-45RuleC-45Source-namespacedIdent) (lambda () (lambda (u--namespacePrefix) (let ((u--nsVal (let ((e-1 (vector-ref u--namespacePrefix 0))) e-1))) (vector 10 0 1 (ParserC-45RuleC-45Source-n--12094-7507-u--checkFixity (Builtin-snd u--nsVal) (let ((e-3 (vector-ref u--namespacePrefix 2))) e-3)) (lambda (u--fx) (vector 11 1 (ParserC-45RuleC-45Source-symbol ".(") (lambda () (vector 9 1 ParserC-45RuleC-45Source-unqualifiedOperatorName (lambda () (lambda (u--n) (vector 11 0 (ParserC-45RuleC-45Source-symbol ")") (lambda () (vector 0 (vector 1 u--fx (vector 0 (PreludeC-45Basics-uncurry csegen-521 u--nsVal) (vector 1 (vector 0 u--n)))))))))))))))))))
(define csegen-4322 (LibrariesC-45TextC-45Parser-optional 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45String-split csegen-1713 eta-0)) ParserC-45RuleC-45Source-simpleStr)))
(define IdrisC-45Parser-logLevel (lambda (arg-0) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) '()) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "off"))) (lambda () (vector 13 1 1 (vector 10 0 1 csegen-4322 (lambda (u--topic) (vector 9 0 ParserC-45RuleC-45Source-intLit (lambda () (lambda (u--lvl) (vector 0 (box (CoreC-45OptionsC-45Log-mkLogLevelC-39 u--topic (PreludeC-45Types-prim__integerToNat u--lvl))))))))) (lambda () (vector 4 '() 0 "expected a log level")))))))
(define IdrisC-45Parser-onoff (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (ParserC-45RuleC-45Source-exactIdent "on")) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Source-exactIdent "off")) (lambda () (vector 4 '() 0 "expected 'on' or 'off'"))))))
(define IdrisC-45Parser-directive (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "hide") (lambda () (vector 9 0 (vector 13 1 1 ParserC-45RuleC-45Source-fixityNS (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 eta-0)) ParserC-45RuleC-45Source-name))) (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 0 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "unhide") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 1 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "logging") (lambda () (vector 9 0 (IdrisC-45Parser-logLevel arg-0) (lambda () (lambda (u--lvl) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 2 u--lvl)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "auto_lazy") (lambda () (vector 9 0 IdrisC-45Parser-onoff (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 3 u--b)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "unbound_implicits") (lambda () (vector 9 0 IdrisC-45Parser-onoff (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 4 u--b)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "prefix_record_projections") (lambda () (vector 9 0 IdrisC-45Parser-onoff (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 21 u--b)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "ambiguity_depth") (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--lvl) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 5 (PreludeC-45Types-prim__integerToNat u--lvl))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "auto_implicit_depth") (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--dpt) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 22 (PreludeC-45Types-prim__integerToNat u--dpt))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "nf_metavar_threshold") (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--dpt) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 23 (PreludeC-45Types-prim__integerToNat u--dpt))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "search_timeout") (lambda () (vector 9 0 (IdrisC-45Parser-decorate arg-0 4 ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--t) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 24 u--t)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "pair") (lambda () (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--ty) (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--f) (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--s) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 6 u--ty u--f u--s)))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "rewrite") (lambda () (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--eq) (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--rw) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 7 u--eq u--rw))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "integerLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 8 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "stringLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 9 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "charLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 10 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "doubleLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 11 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "TTImpLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 12 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "nameLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 13 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "declsLit") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 14 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "name") (lambda () (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-decoratedSimpleBinderName arg-0)) (lambda () (lambda (u--ns) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 16 u--n (DataC-45List1-forget u--ns)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "start") (lambda () (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--e) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 17 u--e)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "allow_overloads") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 18 u--n)))))))) (lambda () (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "language") (lambda () (vector 9 0 (vector 8 IdrisC-45Parser-extension) (lambda () (lambda (u--e) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 19 u--e)))))))) (lambda () (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "default") (lambda () (vector 9 0 (IdrisC-45Parser-totalityOpt arg-0) (lambda () (lambda (u--tot) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (vector 20 u--tot))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-directiveDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (IdrisC-45Parser-directive arg-0 arg-1)) (lambda () (lambda (u--b) (vector 0 (vector 14 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1))))))))
(define IdrisC-45Parser-failDecls (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "failing") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-decorate arg-0 3 ParserC-45RuleC-45Source-simpleStr)) (lambda (u--msg) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (__infixTupleSection-0) (cons u--msg __infixTupleSection-0)) (ParserC-45RuleC-45Source-nonEmptyBlockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0)))))))))))) (lambda () (lambda (u--msgds) (vector 0 (let ((e-1 (vector-ref u--msgds 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (let ((u--fc (CoreC-45FC-boundToFC arg-0 u--msgds))) (vector 8 u--fc e-5 (IdrisC-45Parser-collectDefs (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) e-4)))))))))))))
(define IdrisC-45Parser-exportVisibility (lambda (arg-0) (vector 13 1 0 (IdrisC-45Parser-visOption arg-0) (lambda () (vector 0 1)))))
(define IdrisC-45Parser-fix (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Source-keyword "infixl")) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (ParserC-45RuleC-45Source-keyword "infixr")) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 2) (ParserC-45RuleC-45Source-keyword "infix")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 3) (ParserC-45RuleC-45Source-keyword "prefix")))))))))
(define IdrisC-45Parser-fixDecl (lambda (arg-0 arg-1) (vector 10 0 1 (IdrisC-45Parser-exportVisibility arg-0) (lambda (u--vis) (vector 9 0 (vector 14 (vector 9 1 (IdrisC-45Parser-decorate arg-0 4 IdrisC-45Parser-fix) (lambda () (lambda (u--fixity) (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-decorate arg-0 4 ParserC-45RuleC-45Source-intLit) (lambda () (lambda (u--prec) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") IdrisC-45Parser-iOperator) (lambda () (lambda (u--ops) (vector 0 (cons u--fixity (cons u--prec u--ops)))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 10 (CoreC-45FC-boundToFC arg-0 u--b) u--vis e-2 (PreludeC-45Types-prim__integerToNat e-6) eta-0)) (DataC-45List1-forget e-7))))))))))))))))
(define IdrisC-45Parser-constraints (lambda (arg-0 arg-1) (vector 13 1 0 (vector 9 1 (IdrisC-45Parser-appExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "=>") (lambda () (vector 10 0 0 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--more) (vector 0 (cons (cons '() u--tm) u--more))))))))) (lambda () (vector 13 1 0 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "(") (lambda () (vector 9 1 (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "=>") (lambda () (vector 10 0 0 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--more) (vector 0 (cons (cons (box u--n) u--tm) u--more)))))))))))))))))) (lambda () (vector 0 '())))))))
(define IdrisC-45Parser-ifaceParam (lambda (arg-0 arg-1) (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "(") (lambda () (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-0) (lambda (u--rig) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--ns) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--tm) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 0 (cons (DataC-45List1-forget u--ns) (cons u--rig u--tm))))))))))))))))) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-name)) (lambda () (lambda (u--n) (vector 0 (cons (cons (let ((e-1 (vector-ref u--n 0))) e-1) '()) (cons csegen-30 (vector 26 (CoreC-45FC-boundToFC arg-0 u--n))))))))))))
(define IdrisC-45Parser-recordConstructor (lambda (arg-0) (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "constructor")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-decoratedDataConstructorName arg-0)) (lambda () (lambda (u--n) (vector 0 (cons u--doc u--n)))))))))))
(define IdrisC-45Parser-ifaceDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 1 (IdrisC-45Parser-visibility arg-0) (lambda (u--vis) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "interface") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--cons) (vector 9 1 (IdrisC-45Parser-decorate arg-0 1 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-ifaceParam arg-0 arg-1)) (lambda (u--paramss) (let ((u--params (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (n-0) (cons n-0 e-3)) e-2)))) u--paramss))) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "|")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-decorate arg-0 5 ParserC-45RuleC-45Source-name)))))) (lambda (u--det) (vector 11 0 (IdrisC-45Parser-decoratedKeyword arg-0 "where") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-recordConstructor arg-0)) (lambda (u--dc) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--body) (vector 0 (lambda (u--fc) (vector 5 u--fc u--vis u--cons u--n u--doc u--params u--det u--dc (IdrisC-45Parser-collectDefs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--body))))))))))))))))))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b)))))))))
(define IdrisC-45Parser-n--26879-20138-u--adjust (lambda (arg-0 arg-1 arg-2 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-2 e-6)) (cons e-2 (cons (let ((e-1 (vector-ref e-6 0))) e-1) e-7)))))))))
(define IdrisC-45Parser-defImplicitField (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "default") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (IdrisC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--t) (vector 0 (vector 3 u--t))))))))))
(define PreludeC-45InterfacesC-45Functor-u--map_Functor_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (arg-4 arg-5 ext-0 ext-1) ((((arg-4 'erased) 'erased) (lambda (arg-1) ((((arg-5 'erased) 'erased) ext-0) arg-1))) ext-1)))
(define IdrisC-45Parser-n--26879-20140-u--isDefaultImplicit (lambda (arg-0 arg-1 arg-2 arg-4) (case (vector-ref arg-4 0) ((3) 1)(else 0))))
(define IdrisC-45Parser-n--26879-20139-u--go (lambda (arg-0 arg-1 arg-2) (vector 13 1 0 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 "{") (lambda () (vector 10 0 1 (vector 14 (LibrariesC-45TextC-45Parser-option 1 (vector 0 ) (IdrisC-45Parser-defImplicitField arg-2 arg-1))) (lambda (u--piInfo) (vector 12 0 1 (LibrariesC-45TextC-45Parser-when (cond ((equal? arg-0 1) 0) (else (IdrisC-45Parser-n--26879-20140-u--isDefaultImplicit arg-0 arg-1 arg-2 (let ((e-1 (vector-ref u--piInfo 0))) e-1)))) (lambda () (vector 4 (box (let ((e-3 (vector-ref u--piInfo 2))) e-3)) 1 "Default implicits are allowed only for named implementations"))) (vector 9 1 (PreludeC-45InterfacesC-45Functor-u--map_Functor_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 eta-2 eta-3))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45TypesC-45List-mapAppend '() eta-2 eta-3))))) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons e-6 (cons (let ((e-1 (vector-ref u--piInfo 0))) e-1) e-7)))))))) (IdrisC-45Parser-pibindListName arg-2 arg-1)) (lambda () (lambda (u--ns) (vector 11 1 (IdrisC-45Parser-commitSymbol arg-2 "}") (lambda () (vector 11 0 (IdrisC-45Parser-commitSymbol arg-2 "->") (lambda () (vector 10 0 0 (IdrisC-45Parser-n--26879-20139-u--go arg-0 arg-1 arg-2) (lambda (u--more) (vector 0 (cons u--ns u--more)))))))))))))))) (lambda () (vector 0 '())))))
(define IdrisC-45Parser-implBinds (lambda (arg-0 arg-1 arg-2) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (IdrisC-45Parser-n--26879-20138-u--adjust arg-2 arg-1 arg-0 eta-2)) eta-1)) eta-0)) (IdrisC-45Parser-n--26879-20139-u--go arg-2 arg-1 arg-0))))
(define IdrisC-45Parser-implDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-visOpt arg-0)) (lambda (u--visOpts) (vector 10 0 1 (IdrisC-45Parser-getVisibility '() u--visOpts) (lambda (u--vis) (let ((u--opts (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (DataC-45Either-getRight eta-0)) u--visOpts))) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 12 0 1 (LibrariesC-45TextC-45Parser-option 1 (vector 0 ) (IdrisC-45Parser-decoratedKeyword arg-0 "implementation")) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "[")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-0 2 ParserC-45RuleC-45Source-name))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-0 "]"))))) (lambda (u--iname) (vector 10 0 1 (IdrisC-45Parser-implBinds arg-0 arg-1 (DataC-45Maybe-isJust u--iname)) (lambda (u--impls) (vector 10 0 1 (IdrisC-45Parser-constraints arg-0 arg-1) (lambda (u--cons) (vector 9 0 (IdrisC-45Parser-decorate arg-0 1 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (vector 10 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) (ParserC-45RuleC-45Source-continue arg-1)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda (u--params) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 '() (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "using")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some (IdrisC-45Parser-decorate arg-0 2 ParserC-45RuleC-45Source-name))))))) (lambda (u--nusing) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "where")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))))))) (lambda (u--body) (vector 0 (lambda (u--fc) (vector 6 u--fc u--vis u--opts 0 u--impls u--cons u--n u--params u--iname u--nusing (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45Parser-collectDefs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) eta-0))) u--body)))))))))))))))))))))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b))))))))))
(define IdrisC-45Parser-mutualDecls (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "mutual") (lambda () (vector 12 0 1 (vector 7 ) (ParserC-45RuleC-45Source-nonEmptyBlockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))))))))) (lambda () (lambda (u--ds) (vector 0 (vector 9 (CoreC-45FC-boundToFC arg-0 u--ds) (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) (let ((e-1 (vector-ref u--ds 0))) e-1)))))))))
(define IdrisC-45Parser-namespaceHead (lambda (arg-0) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "namespace") (lambda () (IdrisC-45Parser-decorate arg-0 6 (vector 8 ParserC-45RuleC-45Source-namespaceId))))))
(define IdrisC-45Parser-namespaceDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 9 0 (IdrisC-45Parser-namespaceHead arg-0) (lambda () (lambda (u--ns) (vector 10 0 0 (ParserC-45RuleC-45Source-blockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 0 (cons u--doc (cons u--ns u--ds))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 11 (CoreC-45FC-boundToFC arg-0 u--b) e-6 (IdrisC-45Parser-collectDefs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-7))))))))))))))
(define IdrisC-45Parser-typedArg (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-parens 1 arg-0 (IdrisC-45Parser-pibindListName arg-0 arg-1)) (lambda () (lambda (u--params) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (let ((e-1 (vector-ref e-6 0))) e-1) (cons e-2 (cons (vector 1 ) e-7)))))))) u--params))))) (lambda () (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (vector 13 1 0 (vector 10 0 1 csegen-2894 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedKeyword arg-0 "auto")))) (lambda () (vector 13 1 0 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedKeyword arg-0 "default")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 3 eta-0)) (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (vector 0 (vector 0 )))))) (lambda (u--info) (vector 9 1 (IdrisC-45Parser-pibindListName arg-0 arg-1) (lambda () (lambda (u--params) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (let ((e-1 (vector-ref e-6 0))) e-1) (cons e-2 (cons u--info e-7)))))))) u--params))))))))))))))))
(define IdrisC-45Parser-n--28601-21859-u--newParamDecls (lambda (arg-0 arg-1 arg-2 arg-3) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-1) eta-1) eta-0)) (LibrariesC-45TextC-45Parser-some (IdrisC-45Parser-typedArg arg-2 arg-3)))))
(define IdrisC-45Parser-n--28601-21860-u--oldParamDecls (lambda (arg-0 arg-1 arg-2 arg-3) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-2 ",") (vector 9 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-2)) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-2 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-2 arg-3) (lambda () (lambda (u--ty) (vector 0 (cons u--x (cons AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (cons (vector 1 ) u--ty))))))))))))) (lambda (u--ps) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-2 ")") (lambda () (vector 0 u--ps)))))))))
(define IdrisC-45Parser-paramDecls (lambda (arg-0 arg-1) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--startCol) (vector 9 1 (vector 14 (IdrisC-45Parser-decoratedKeyword arg-0 "parameters")) (lambda () (lambda (u--b1) (vector 12 0 1 (vector 7 ) (vector 9 1 (vector 14 (vector 13 1 1 (IdrisC-45Parser-n--28601-21859-u--newParamDecls arg-1 arg-0 arg-0 arg-1) (lambda () (IdrisC-45Parser-n--28601-21860-u--oldParamDecls arg-1 arg-0 arg-0 arg-1)))) (lambda () (lambda (u--args) (vector 12 0 1 (vector 7 ) (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-nonEmptyBlockAfter u--startCol (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0)))) (lambda () (lambda (u--declarations) (vector 10 0 0 (vector 0 (LibrariesC-45TextC-45Bounded-mergeBounds u--b1 (LibrariesC-45TextC-45Bounded-mergeBounds u--args u--declarations))) (lambda (u--mergedBounds) (vector 0 (vector 3 (CoreC-45FC-boundToFC arg-0 u--mergedBounds) (let ((e-1 (vector-ref u--args 0))) e-1) (IdrisC-45Parser-collectDefs (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) (let ((e-1 (vector-ref u--declarations 0))) e-1))))))))))))))))))))))
(define ParserC-45RuleC-45Source-n--13238-8664-u--restOfBlock (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries (vector 0 ) arg-2) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons '() u--ps)))))) (let ((e-1 (unbox arg-5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (vector 10 0 1 (ParserC-45RuleC-45Source-blockEntries e-6 arg-2) (lambda (u--ps) (vector 11 0 (ParserC-45RuleC-45Source-symbol "}") (lambda () (vector 0 (cons (box e-5) u--ps))))))))))))
(define ParserC-45RuleC-45Source-blockWithOptHeaderAfter (lambda (arg-2 arg-3 arg-4) (vector 13 1 0 (vector 11 1 (ParserC-45RuleC-45Source-symbol "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (ParserC-45RuleC-45Source-blockEntry (vector 0 ) arg-3)) (lambda (u--hidt) (ParserC-45RuleC-45Source-n--13238-8664-u--restOfBlock arg-4 arg-3 arg-2 u--hidt)))))) (lambda () (vector 10 0 0 LibrariesC-45TextC-45Parser-column (lambda (u--col) (let ((sc0 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int u--col arg-2))) (cond ((equal? sc0 1) (vector 0 (cons '() '()))) (else (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (ParserC-45RuleC-45Source-blockEntry (vector 1 u--col) arg-3)) (lambda (u--hidt) (vector 10 0 0 (ParserC-45RuleC-45Source-blockEntries (vector 1 u--col) arg-4) (lambda (u--ps) (vector 0 (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) u--hidt) u--ps)))))))))))))))
(define IdrisC-45Parser-autoImplicitField (lambda (arg-1 arg-2) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 2 )) (IdrisC-45Parser-decoratedKeyword arg-1 "auto"))))
(define IdrisC-45Parser-n--27801-21057-u--fieldBody (lambda (arg-0 arg-1 arg-2 arg-3) (vector 9 0 (vector 14 (vector 10 0 1 (IdrisC-45Parser-multiplicity arg-1) (lambda (u--rig) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 ",") (vector 13 1 1 (IdrisC-45Parser-decorate arg-1 2 ParserC-45RuleC-45Source-name) (lambda () (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "_")) (lambda () (lambda (u--b) (vector 4 (box (let ((e-3 (vector-ref u--b 2))) e-3)) 1 "Fields have to be named"))))))) (lambda () (lambda (u--ns) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-0) (lambda () (lambda (u--ty) (vector 0 (lambda (u--fc) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (vector u--fc arg-2 u--rig arg-3 u--n u--ty)) (DataC-45List1-forget u--ns))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-1 u--b)))))))))
(define IdrisC-45Parser-fieldDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 (vector 0 ) (vector 13 1 1 (IdrisC-45Parser-autoImplicitField arg-0 arg-1) (lambda () (IdrisC-45Parser-defImplicitField arg-0 arg-1)))) (lambda (u--impl) (vector 9 1 (IdrisC-45Parser-n--27801-21057-u--fieldBody arg-1 arg-0 u--doc u--impl) (lambda () (lambda (u--fs) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))))))) (lambda () (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 9 0 (IdrisC-45Parser-n--27801-21057-u--fieldBody arg-1 arg-0 u--doc (vector 1 )) (lambda () (lambda (u--fs) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 0 u--fs)))))))))))
(define IdrisC-45Parser-recordBody (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector 13 0 1 (vector 12 0 0 (ParserC-45RuleC-45Source-atEndIndent arg-1) (vector 0 (lambda (u--fc) (vector 7 u--fc arg-2 arg-3 arg-4 (vector 1 arg-6 arg-7))))) (lambda () (vector 11 0 (vector 8 (IdrisC-45Parser-decoratedKeyword arg-0 "where")) (lambda () (vector 10 0 0 (IdrisC-45Parser-dataOpts arg-0) (lambda (u--opts) (vector 10 0 0 (ParserC-45RuleC-45Source-blockWithOptHeaderAfter arg-5 (lambda (u--idt) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-recordConstructor arg-0)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-atEnd u--idt))))) (lambda (eta-0) (IdrisC-45Parser-fieldDecl arg-0 eta-0))) (lambda (u--dcflds) (vector 0 (lambda (u--fc) (vector 7 u--fc arg-2 arg-3 arg-4 (vector 0 arg-6 arg-7 u--opts (Builtin-fst u--dcflds) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) (Builtin-snd u--dcflds))))))))))))))))
(define IdrisC-45Parser-recordParam (lambda (arg-0 arg-1) (vector 13 1 1 (IdrisC-45Parser-typedArg arg-0 arg-1) (lambda () (vector 9 0 (vector 14 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-0))) (lambda () (lambda (u--n) (vector 0 (cons (cons (let ((e-1 (vector-ref u--n 0))) e-1) (cons AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (cons (vector 1 ) (vector 26 (CoreC-45FC-boundToFC arg-0 u--n))))) '())))))))))
(define IdrisC-45Parser-recordDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 1 (IdrisC-45Parser-dataVisOpt arg-0) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "record") (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-decoratedDataTypeName arg-0)) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-1) (IdrisC-45Parser-recordParam arg-0 arg-1))) (lambda (u--paramss) (let ((u--params (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--paramss))) (IdrisC-45Parser-recordBody arg-0 arg-1 u--doc e-2 e-3 u--col u--n u--params)))))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (e-1 (CoreC-45FC-boundToFC arg-0 u--b)))))))))
(define IdrisC-45Parser-runElabDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "runElab") (lambda () (IdrisC-45Parser-expr IdrisC-45Parser-pnowith arg-0 arg-1)))) (lambda () (lambda (u--tm) (vector 0 (vector 13 (CoreC-45FC-boundToFC arg-0 u--tm) (let ((e-1 (vector-ref u--tm 0))) e-1))))))))
(define DataC-45String-span (lambda (arg-0 arg-1) (let ((sc0 (DataC-45List-span arg-0 (PreludeC-45Types-fastUnpack arg-1)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons (PreludeC-45Types-fastPack e-2) (PreludeC-45Types-fastPack e-3)))))))
(define IdrisC-45Parser-n--24508-17745-u--drop (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 e-2))) (cond ((equal? sc1 1) (IdrisC-45Parser-n--24508-17745-u--drop arg-0 arg-1 e-3)) (else (cons e-2 e-3)))))))))
(define IdrisC-45Parser-stripBraces (lambda (arg-0) (PreludeC-45Types-fastPack (IdrisC-45Parser-n--24508-17745-u--drop arg-0 #\{ (PreludeC-45TypesC-45List-reverse (IdrisC-45Parser-n--24508-17745-u--drop arg-0 #\} (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-fastUnpack arg-0))))))))
(define IdrisC-45Parser-transformDecl (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "transform") (lambda () (vector 9 1 ParserC-45RuleC-45Source-simpleStr (lambda () (lambda (u--n) (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-plhs arg-0 arg-1) (lambda () (lambda (u--lhs) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "=") (lambda () (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pnowith arg-0 arg-1) (lambda () (lambda (u--rhs) (vector 0 (cons u--n (cons u--lhs u--rhs))))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector 12 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7)))))))))))))
(define DataC-45String-with--asList-9518 (lambda (arg-0 arg-1) (cond ((equal? arg-0 "") (if (null? arg-1) (vector 0 ) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (vector 1 e-0 e-1 (lambda () (DataC-45String-asList e-1)))))))(else (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (vector 1 e-0 e-1 (lambda () (DataC-45String-asList e-1)))))))))
(define DataC-45String-asList (lambda (arg-0) (DataC-45String-with--asList-9518 arg-0 (DataC-45String-strM arg-0))))
(define DataC-45String-with--ltrim-9542 (lambda (arg-0 arg-1) (cond ((equal? arg-0 "") (case (vector-ref arg-1 0) ((0) "")(else (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((u--str (string-cons e-0 e-1))) (let ((sc2 (PreludeC-45Types-isSpace e-0))) (cond ((equal? sc2 1) (DataC-45String-with--ltrim-9542 e-1 (e-2))) (else u--str))))))))))(else (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((u--str (string-cons e-0 e-1))) (let ((sc1 (PreludeC-45Types-isSpace e-0))) (cond ((equal? sc1 1) (DataC-45String-with--ltrim-9542 e-1 (e-2))) (else u--str)))))))))))
(define DataC-45String-ltrim (lambda (arg-0) (DataC-45String-with--ltrim-9542 arg-0 (DataC-45String-asList arg-0))))
(define DataC-45String-trim (lambda (ext-0) (DataC-45String-ltrim (string-reverse (DataC-45String-ltrim (string-reverse ext-0))))))
(define IdrisC-45Parser-usingDecls (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 10 0 1 LibrariesC-45TextC-45Parser-column (lambda (u--col) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "using") (lambda () (vector 12 0 1 (vector 7 ) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-sepBy 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 9 1 ParserC-45RuleC-45Source-unqualifiedName (lambda () (lambda (u--x) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ":") (lambda () (vector 0 (vector 1 (vector 0 u--x))))))))) (lambda (u--n) (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--ty) (vector 0 (cons u--n u--ty)))))))) (lambda (u--us) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlockAfter u--col (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ds) (vector 0 (cons u--us u--ds))))))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 4 (CoreC-45FC-boundToFC arg-0 u--b) e-2 (IdrisC-45Parser-collectDefs (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) e-3)))))))))))))
(define csegen-4309 (lambda (u--d) (vector 0 (cons u--d '()))))
(define IdrisC-45Parser-topDecl (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 1 ParserC-45RuleC-45Source-anyReservedIdent (lambda () (lambda (u--id) (vector 4 (box (let ((e-3 (vector-ref u--id 2))) e-3)) 1 "Cannot begin a declaration with a reserved identifier")))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-dataDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-claims arg-0 arg-1) (lambda () (lambda (u--ds) (vector 0 (DataC-45List1-forget u--ds))))) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-directiveDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-implDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-definition arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (IdrisC-45Parser-fixDecl arg-0 arg-1) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-ifaceDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-recordDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-namespaceDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-failDecls arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-mutualDecls arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-paramDecls arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-usingDecls arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-builtinDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-runElabDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (IdrisC-45Parser-transformDecl arg-0 arg-1) (lambda () csegen-4309)) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 1 "Expected CG directive" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((16) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '()))))) (lambda () (lambda (u--dstr) (vector 0 (cons (let ((u--cgrest (DataC-45String-span (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0)) (let ((e-1 (vector-ref u--dstr 0))) e-1)))) (vector 14 (CoreC-45FC-boundToFC arg-0 u--dstr) (vector 15 (Builtin-fst u--cgrest) (IdrisC-45Parser-stripBraces (DataC-45String-trim (Builtin-snd u--cgrest)))))) '()))))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 ParserC-45RuleC-45Source-anyKeyword) (lambda () (lambda (u--kw) (vector 4 (box (let ((e-3 (vector-ref u--kw 2))) e-3)) 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Keyword '" (cons (let ((e-1 (vector-ref u--kw 0))) e-1) (cons "' is not a valid start to a declaration" '())))))))) (lambda () (vector 4 '() 1 "Couldn't parse declaration")))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-n--13612-12423-u--letDecl (lambda (arg-0 arg-1) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (IdrisC-45Parser-collectDefs (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-1) eta-1) eta-0))) (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (vector 6 (IdrisC-45Parser-topDecl arg-1 eta-0)))))))
(define IdrisC-45Parser-letBlock (lambda (arg-0 arg-1) (vector 14 (LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 1 1 (IdrisC-45Parser-n--13612-12422-u--letBinder arg-1 arg-0) (lambda () (IdrisC-45Parser-n--13612-12423-u--letDecl arg-1 arg-0))))))
(define IdrisC-45ParserC-45Let-n--8679-5288-u--buildLets (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-1 (vector-ref e-2 0))) (let ((e-0 (vector-ref e-1 0))) (let ((e-9 (vector-ref e-1 1))) (let ((e-8 (vector-ref e-1 2))) (let ((e-7 (vector-ref e-1 3))) (let ((e-6 (vector-ref e-1 4))) (let ((u--fc (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 e-2)))) (vector 3 u--fc e-0 e-9 e-8 e-7 (IdrisC-45ParserC-45Let-n--8679-5288-u--buildLets arg-0 e-3 arg-2) e-6)))))))))))))
(define IdrisC-45ParserC-45Let-mkLets (lambda (arg-0 ext-0 ext-1) (IdrisC-45ParserC-45Let-letFactory (lambda (eta-0) (lambda (eta-1) (IdrisC-45ParserC-45Let-n--8679-5288-u--buildLets arg-0 eta-0 eta-1))) (lambda (u--decls) (lambda (u--scope) (vector 5 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--decls)) (let ((e-1 (vector-ref u--decls 0))) e-1) u--scope))) ext-0 ext-1)))
(define IdrisC-45Parser-let_ (lambda (arg-0 arg-1) (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "let") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-letBlock arg-0 eta-0))) (lambda () (lambda (u--res) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "in") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45ParserC-45Let-mkLets arg-0 u--res u--scope)))))))))))))))
(define IdrisC-45Parser-rewrite_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "rewrite") (lambda () (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--rule) (vector 11 1 (IdrisC-45Parser-commitKeyword arg-0 arg-1 "in") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--tm) (vector 0 (cons u--rule u--tm))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 45 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3)))))))))))
(define IdrisC-45Parser-expr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-let_ arg-1 arg-2) (lambda () (vector 13 1 1 (IdrisC-45Parser-rewrite_ arg-1 arg-2) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-1 "runElab") (lambda () (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-2)))) (lambda () (lambda (u--b) (vector 0 (vector 20 (CoreC-45FC-boundToFC arg-1 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (IdrisC-45Parser-opExpr arg-0 arg-1 arg-2)))))))))
(define IdrisC-45Parser-nestedDpair (lambda (arg-1 arg-2 arg-3) (vector 13 1 1 (IdrisC-45Parser-dpairType arg-1 arg-2 arg-3) (lambda () (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-3) (lambda () (lambda (u--l) (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "**")) (lambda () (lambda (u--loc) (vector 9 0 (vector 14 (vector 13 1 1 (IdrisC-45Parser-nestedDpair arg-1 u--loc arg-3) (lambda () (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-3)))) (lambda () (lambda (u--rest) (vector 0 (vector 41 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest)) (CoreC-45FC-boundToFC arg-1 u--loc) u--l (vector 25 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest))) (let ((e-1 (vector-ref u--rest 0))) e-1))))))))))))))))
(define IdrisC-45Parser-dpairType (lambda (arg-1 arg-2 arg-3) (vector 9 1 (vector 14 (vector 9 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-1)) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 ":") (lambda () (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-3) (lambda () (lambda (u--ty) (vector 0 (cons u--x u--ty))))))))))) (lambda () (lambda (u--loc) (vector 10 0 1 (vector 0 (let ((e-1 (vector-ref u--loc 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "**")) (lambda () (lambda (u--op) (vector 9 0 (vector 14 (vector 13 1 1 (IdrisC-45Parser-nestedDpair arg-1 u--loc arg-3) (lambda () (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-3)))) (lambda () (lambda (u--rest) (vector 0 (vector 41 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest)) (CoreC-45FC-boundToFC arg-1 u--op) (vector 0 (CoreC-45FC-boundToFC arg-1 u--loc) e-2) e-3 (let ((e-1 (vector-ref u--rest 0))) e-1))))))))))))))))))
(define CoreC-45FC-isNonEmptyFC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (box (cons e-0 (cons e-1 e-2))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (box (cons e-3 (cons e-4 e-5))))))) (else '()))))
(define CoreC-45FC-toNonEmptyFC (lambda (ext-0) (DataC-45Maybe-fromMaybe (lambda () CoreC-45FC-defaultFC) (CoreC-45FC-isNonEmptyFC ext-0))))
(define IdrisC-45Parser-n--13462-9941-u--lams (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) arg-6 (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-6))) (vector 2 u--vfc AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-7 (vector 26 u--vfc) (IdrisC-45Parser-n--13462-9941-u--lams arg-1 arg-2 arg-3 arg-4 e-3 arg-6))))))))))
(define IdrisC-45Parser-n--13462-9940-u--buildOutput (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (IdrisC-45Parser-n--13462-9941-u--lams arg-1 arg-2 arg-3 arg-4 e-2 (vector 40 arg-5 arg-1 e-3))))))
(define IdrisC-45Parser-n--13462-9943-u--optionalPair (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (let ((u--var (vector 0 e-2 (vector 2 "__infixTupleSection" arg-5)))) (cons (bs+ arg-5 1 63) (cons (cons (cons e-2 u--var) '()) u--var))) (let ((e-5 (unbox e-3))) (cons arg-5 (cons '() e-5))))))))
(define IdrisC-45Parser-case--nonEmptyTupleC-44mergePairs-10072 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (IdrisC-45Parser-n--13462-9942-u--mergePairs arg-1 arg-2 arg-3 arg-4 e-2 arg-5 arg-6))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (PreludeC-45TypesC-45List-tailRecAppend e-6 e-5) (vector 40 (Builtin-fst arg-5) e-7 e-4)))))))))))
(define IdrisC-45Parser-n--13462-9942-u--mergePairs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (Builtin-snd (IdrisC-45Parser-n--13462-9943-u--optionalPair arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (IdrisC-45Parser-case--nonEmptyTupleC-44mergePairs-10072 arg-1 arg-2 arg-3 arg-4 e-2 e-3 arg-6 arg-5 (IdrisC-45Parser-n--13462-9943-u--optionalPair arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)))))))
(define IdrisC-45Parser-nonEmptyTuple (lambda (arg-1 arg-2 arg-3 arg-4) (vector 9 1 (LibrariesC-45TextC-45Parser-some (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol ",")) (lambda () (lambda (u--b) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-3)) (lambda (u--exp) (vector 0 (cons (CoreC-45FC-boundToFC arg-1 u--b) u--exp)))))))) (lambda () (lambda (u--vals) (vector 9 0 (IdrisC-45Parser-continueWithDecorated arg-1 arg-3 ")") (lambda () (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '()))) (vector 0 (let ((e-1 (car u--vals))) (let ((e-2 (cdr u--vals))) (IdrisC-45Parser-n--13462-9940-u--buildOutput arg-4 arg-3 arg-2 arg-1 (Builtin-fst e-1) (IdrisC-45Parser-n--13462-9942-u--mergePairs arg-4 arg-3 arg-2 arg-1 0 e-1 e-2))))))))))))))
(define IdrisC-45Parser-tuple (lambda (arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (IdrisC-45Parser-nonEmptyTuple arg-1 arg-2 arg-3 arg-4) (lambda () (vector 9 0 (vector 14 (IdrisC-45Parser-continueWithDecorated arg-1 arg-3 ")")) (lambda () (lambda (u--end) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '()))) (vector 0 (vector 32 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--end)) arg-4))))))))))
(define csegen-4273 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol ")"))))
(define csegen-4328 (vector 14 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-some (vector 14 ParserC-45RuleC-45Source-postfixProj)))))
(define IdrisC-45Parser-bracketedExpr (lambda (arg-1 arg-2 arg-3) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (vector 14 IdrisC-45Parser-iOperator) (lambda () (lambda (u--op) (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-3) (lambda () (lambda (u--e) (vector 11 0 (IdrisC-45Parser-continueWithDecorated arg-1 arg-3 ")") (lambda () (vector 0 (cons u--op u--e))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '()))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b)))) (let ((u--opFC (CoreC-45FC-boundToFC arg-1 e-2))) (vector 0 (vector 29 u--fc u--opFC (let ((e-1 (vector-ref e-2 0))) e-1) e-3)))))))))))) (lambda () (vector 13 1 1 (vector 9 1 csegen-4328 (lambda () (lambda (u--b) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-1 ")") (lambda () (vector 12 0 0 (ParserC-45RuleC-45Source-actD (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '()))) (let ((u--projs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--proj) (cons (CoreC-45FC-boundToFC arg-1 u--proj) (let ((e-1 (vector-ref u--proj 0))) e-1))) (let ((e-1 (vector-ref u--b 0))) e-1)))) (vector 0 (vector 49 (CoreC-45FC-boundToFC arg-1 u--b) u--projs))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-continueWith arg-3 ")")) (lambda () (lambda (u--b) (vector 0 (vector 42 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b))))))) (lambda () (vector 13 1 1 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-dpairType arg-1 arg-2 arg-3)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-1 1 (ParserC-45RuleC-45Source-symbol ")")))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (ParserC-45RuleC-45Source-actD (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 1 '())))))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-1 arg-3)) (lambda () (lambda (u--e) (vector 13 1 1 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "**")) (lambda () (lambda (u--loc) (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 13 1 1 (IdrisC-45Parser-nestedDpair arg-1 u--loc arg-3) (lambda () (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-3)))) csegen-4273)) (lambda () (lambda (u--rest) (vector 0 (vector 41 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest)) (CoreC-45FC-boundToFC arg-1 u--loc) (let ((e-1 (vector-ref u--e 0))) e-1) (vector 25 (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--rest))) (let ((e-1 (vector-ref u--rest 0))) e-1))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 14 IdrisC-45Parser-iOperator)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 ")"))))) (lambda () (lambda (u--op) (vector 12 0 0 (ParserC-45RuleC-45Source-actD (cons (CoreC-45FC-toNonEmptyFC (CoreC-45FC-boundToFC arg-1 arg-2)) (cons 4 '()))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--op)))) (let ((u--opFC (CoreC-45FC-boundToFC arg-1 (let ((e-1 (vector-ref u--op 0))) e-1)))) (vector 0 (vector 30 u--fc u--opFC (let ((e-1 (vector-ref u--e 0))) e-1) (let ((e-1 (vector-ref u--op 0))) (let ((e-6 (vector-ref e-1 0))) e-6)))))))))) (lambda () (IdrisC-45Parser-tuple arg-1 arg-2 arg-3 (let ((e-1 (vector-ref u--e 0))) e-1))))))))) (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--here) (let ((u--fc (vector 0 arg-1 u--here u--here))) (let ((u--var (vector 0 u--fc (vector 2 "__leftTupleSection" 0)))) (vector 9 0 (vector 14 (IdrisC-45Parser-nonEmptyTuple arg-1 arg-2 arg-3 u--var)) (lambda () (lambda (u--ts) (vector 0 (vector 2 u--fc AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) u--var (vector 26 u--fc) (let ((e-1 (vector-ref u--ts 0))) e-1))))))))))))))))))))))
(define ParserC-45RuleC-45Source-namespacedSymbol (lambda (arg-0) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) '()) (ParserC-45RuleC-45Source-symbol arg-0)) (lambda () (vector 9 1 ParserC-45RuleC-45Source-namespaceId (lambda () (lambda (u--ns) (vector 11 0 (ParserC-45RuleC-45Source-symbol (string-append "." arg-0)) (lambda () (vector 0 (box u--ns)))))))))))
(define IdrisC-45Parser-decoratedNamespacedSymbol (lambda (arg-0 arg-1) (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-namespacedSymbol arg-1))))
(define IdrisC-45Parser-decorateKeywords (lambda (arg-1 arg-2) (vector 16 (cons (DataC-45SnocList-u--cast_Cast_C-40ListC-32C-36aC-41_C-40SnocListC-32C-36aC-41 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45RuleC-45Source-decorationFromBounded arg-1 4 eta-0)) arg-2)) '()))))
(define IdrisC-45Parser-getInitRange (lambda (arg-0) (if (null? arg-0) (vector 4 '() 1 "Invalid list range syntax") (let ((e-1 (car arg-0))) (let ((e-2 (cdr arg-0))) (if (null? e-2) (vector 0 (cons (let ((e-5 (vector-ref e-1 0))) e-5) '())) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) (vector 0 (cons (let ((e-7 (vector-ref e-1 0))) e-7) (box (let ((e-7 (vector-ref e-5 0))) e-7)))) (vector 4 '() 1 "Invalid list range syntax"))))))))))
(define IdrisC-45Parser-listRange (lambda (arg-1 arg-2 arg-3 arg-4) (vector 13 1 1 (vector 9 0 (vector 14 (IdrisC-45Parser-decoratedSymbol arg-1 "]")) (lambda () (lambda (u--b) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--b)))) (vector 10 0 0 (IdrisC-45Parser-getInitRange arg-4) (lambda (u--rstate) (vector 12 0 0 (IdrisC-45Parser-decorateKeywords arg-1 arg-4) (vector 0 (vector 47 u--fc (Builtin-fst u--rstate) (Builtin-snd u--rstate)))))))))) (lambda () (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-1 arg-3)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decoratedSymbol arg-1 "]"))))) (lambda () (lambda (u--y) (let ((u--fc (CoreC-45FC-boundToFC arg-1 (LibrariesC-45TextC-45Bounded-mergeBounds arg-2 u--y)))) (vector 10 0 0 (IdrisC-45Parser-getInitRange arg-4) (lambda (u--rstate) (vector 12 0 0 (IdrisC-45Parser-decorateKeywords arg-1 arg-4) (vector 0 (vector 46 u--fc (Builtin-fst u--rstate) (Builtin-snd u--rstate) (let ((e-1 (vector-ref u--y 0))) e-1))))))))))))))
(define IdrisC-45Parser-listExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pnowith arg-0 arg-2) (lambda () (lambda (u--ret) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "|") (lambda () (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (IdrisC-45Parser-doAct arg-0 arg-2)) (lambda () (lambda (u--conds) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "]") (lambda () (vector 0 (cons u--ret u--conds))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 44 (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds arg-1 u--b)) e-2 (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) e-3)))))))))) (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 '() (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-2) (lambda () (lambda (u--hd) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol ",")) (lambda () (lambda (u--b) (vector 9 0 (vector 8 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-2)) (lambda () (lambda (u--x) (vector 0 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) u--x) u--b))))))))) (lambda (u--tl) (vector 0 (cons (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) u--hd) arg-1) u--tl)))))))) (lambda (u--xs) (vector 13 1 1 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "..") (lambda () (IdrisC-45Parser-listRange arg-0 arg-1 arg-2 u--xs))) (lambda () (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol "]")) (lambda () (lambda (u--b) (vector 0 (let ((u--fc (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds arg-1 u--b)))) (let ((u--nilFC (let ((sc0 (PreludeC-45Types-u--null_Foldable_List u--xs))) (cond ((equal? sc0 1) u--fc) (else (CoreC-45FC-boundToFC arg-0 u--b)))))) (vector 38 u--fc u--nilFC (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (cons (CoreC-45FC-boundToFC arg-0 u--t) (let ((e-1 (vector-ref u--t 0))) e-1))) u--xs))))))))))))))))
(define ParserC-45RuleC-45Source-interpBegin (vector 1 "Expected string interp begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Source-interpEnd (vector 1 "Expected string interp end" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((6) (box (vector 0 )))(else '())))))
(define IdrisC-45Parser-interpBlock (lambda (arg-0 arg-1 arg-2) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) ParserC-45RuleC-45Source-interpBegin) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (vector 8 (IdrisC-45Parser-expr arg-0 arg-1 arg-2)))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f ParserC-45RuleC-45Source-interpEnd)))))
(define ParserC-45RuleC-45Source-multilineBegin (vector 1 "Expected multiline string begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (cond ((equal? e-1 0) (box e-0))(else '())))))(else '())))))
(define ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (DataC-45List1-singleton '()) (if (null? arg-1) (DataC-45List1-singleton (PreludeC-45TypesC-45List-reverse arg-0)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 (integer->char 10)) (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 10) arg-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-3))) ((equal? e-2 (integer->char 13)) (if (null? e-3) (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 13) arg-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-3)) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (cond ((equal? e-5 (integer->char 10)) (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 10) (cons (integer->char 13) arg-0))) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-6)))(else (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 13) arg-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-3))))))))(else (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp (cons e-2 arg-0) e-3))))))) (if (null? arg-1) (DataC-45List1-singleton (PreludeC-45TypesC-45List-reverse arg-0)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 (integer->char 10)) (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 10) arg-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-3))) ((equal? e-2 (integer->char 13)) (if (null? e-3) (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 13) arg-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-3)) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (cond ((equal? e-5 (integer->char 10)) (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 10) (cons (integer->char 13) arg-0))) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-6)))(else (DataC-45List1-cons (PreludeC-45TypesC-45List-reverse (cons (integer->char 13) arg-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() e-3))))))))(else (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp (cons e-2 arg-0) e-3)))))))))
(define ParserC-45RuleC-45Source-strLitLines (vector 1 "Expected string literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (let ((e-0 (vector-ref lcase-0 1))) (box (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (ParserC-45RuleC-45Source-n--10713-6157-u--linesHelp '() (PreludeC-45Types-fastUnpack e-0))))))(else '())))))
(define DataC-45List-init (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) '() (cons e-1 (DataC-45List-init e-2)))))))
(define DataC-45List-last (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) e-1 (DataC-45List-last e-2))))))
(define IdrisC-45Parser-case--multilineStrC-44toLines-14734 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (IdrisC-45Parser-n--13784-14700-u--toLines arg-0 arg-1 arg-2 arg-4 (cons arg-6 (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) e-2)) arg-5))) (else (let ((e-5 (vector-ref arg-7 1))) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (IdrisC-45Parser-n--13784-14700-u--toLines arg-0 arg-1 arg-2 arg-4 (cons arg-6 (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) e-7)) arg-5) (let ((e-11 (car e-8))) (let ((e-12 (cdr e-8))) (let ((u--fc (CoreC-45FC-boundToFC arg-1 arg-3))) (IdrisC-45Parser-n--13784-14700-u--toLines arg-0 arg-1 arg-2 arg-4 (cons '() (vector 0 u--fc (DataC-45List-last e-8))) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 (cons arg-5 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-6 (cons (vector 0 u--fc e-7) '()))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--str) (cons (vector 0 u--fc u--str) '())) (let ((u--strs (cons e-11 e-12))) (DataC-45List-init u--strs))))))))))))))))
(define IdrisC-45Parser-n--13784-14700-u--toLines (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-5 (cons (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-4 '()) '())) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45Parser-case--multilineStrC-44toLines-14734 arg-0 arg-1 arg-2 e-2 e-3 arg-5 arg-4 (let ((e-1 (vector-ref e-2 0))) e-1)))))))
(define IdrisC-45Parser-multilineStr (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-decorate arg-1 3 (vector 9 0 (vector 14 (vector 9 1 ParserC-45RuleC-45Source-multilineBegin (lambda () (lambda (u--hashtag) (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 14 (LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 1 1 (IdrisC-45Parser-interpBlock arg-0 arg-1 arg-2) (lambda () ParserC-45RuleC-45Source-strLitLines)))) (lambda (u--xs) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--endloc) (vector 11 0 ParserC-45RuleC-45Source-strEnd (lambda () (vector 0 (cons u--hashtag (cons u--endloc (IdrisC-45Parser-n--13784-14700-u--toLines arg-2 arg-1 arg-0 u--xs '() '()))))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (let ((e-11 (cdr e-6))) (vector 34 (CoreC-45FC-boundToFC arg-1 u--b) e-5 (PreludeC-45Types-prim__integerToNat e-11) e-7))))))))))))))
(define IdrisC-45Parser-n--13675-13170-u--fieldName (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-0 (vector-ref arg-3 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) e-1)) ((1) (let ((e-2 (vector-ref e-0 1))) e-2))(else "_impossible"))))(else "_impossible"))))
(define IdrisC-45Parser-n--13675-13171-u--recFieldCompat (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-decorate arg-1 2 ParserC-45RuleC-45Source-postfixProj) (lambda () (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-1 "->")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-1 2 ParserC-45RuleC-45Source-name))))))))
(define IdrisC-45Parser-field (lambda (arg-0 arg-1 arg-2) (vector 9 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45Parser-n--13675-13170-u--fieldName arg-2 arg-1 arg-0 eta-1)) eta-0)) (vector 10 1 0 (vector 10 0 1 (vector 0 csegen-103) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-decorate arg-1 2 ParserC-45RuleC-45Source-name)))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-many (IdrisC-45Parser-n--13675-13171-u--recFieldCompat arg-2 arg-1 arg-0)))))) (lambda () (lambda (u--path) (vector 9 1 (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 0 eta-1 eta-2)))) (cond ((equal? arg-0 1) (IdrisC-45Parser-decoratedSymbol arg-1 "=")) (else (IdrisC-45Parser-decoratedSymbol arg-1 ":=")))) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1 eta-2)))) (IdrisC-45Parser-decoratedSymbol arg-1 "$=")))) (lambda () (lambda (u--upd) (vector 9 0 (IdrisC-45Parser-typeExpr IdrisC-45Parser-plhs arg-1 arg-2) (lambda () (lambda (u--val) (vector 0 ((u--upd u--path) u--val)))))))))))))
(define IdrisC-45Parser-n--13667-13042-u--body (lambda (arg-0 arg-1 arg-2) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-1 "{") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-1 ",") (IdrisC-45Parser-field arg-2 arg-1 arg-0)) (lambda () (lambda (u--fs) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-1 "}") (lambda () (vector 0 (DataC-45List1-forget u--fs))))))))))))
(define IdrisC-45Parser-n--13667-13043-u--oldSyntaxWarning (lambda (arg-0 arg-1) (DataC-45String-fastUnlines (cons "DEPRECATED: old record update syntax." (cons "  Use \"{ f := v } p\" instead of \"record { f = v } p\"" (cons "  and \"{ f $= v } p\" instead of \"record { f $= v } p\"" '()))))))
(define IdrisC-45Parser-record_ (lambda (arg-0 arg-1) (vector 9 0 (vector 13 1 1 (vector 10 1 0 (vector 14 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "record") (lambda () (vector 12 0 1 (vector 7 ) (IdrisC-45Parser-n--13667-13042-u--body arg-1 arg-0 1)))))) (lambda (u--res) (vector 12 0 0 (vector 5 (box (let ((e-3 (vector-ref u--res 2))) e-3)) (IdrisC-45Parser-n--13667-13043-u--oldSyntaxWarning arg-1 arg-0)) (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1))))) (lambda () (vector 14 (IdrisC-45Parser-n--13667-13042-u--body arg-1 arg-0 0)))) (lambda () (lambda (u--b) (vector 0 (vector 6 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1))))))))
(define IdrisC-45Parser-n--13773-14452-u--toPStr (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (case (vector-ref e-1 0) ((1) (let ((e-4 (vector-ref e-1 1))) (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (if (null? e-8) (vector 1 (vector 0 (CoreC-45FC-boundToFC arg-1 arg-3) e-7)) (vector 0 "Multi-line string is expected to begin with \"\"\"")))))) (else (let ((e-5 (vector-ref e-1 1))) (vector 1 (vector 1 (CoreC-45FC-boundToFC arg-1 arg-3) e-5))))))))
(define IdrisC-45Parser-singlelineStr (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-decorate arg-1 3 (vector 9 0 (vector 14 (vector 9 1 (vector 14 ParserC-45RuleC-45Source-strBegin) (lambda () (lambda (u--begin) (vector 12 0 1 (vector 7 ) (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 14 (LibrariesC-45TextC-45ParserC-45Core-C-60C-124C-124C-62 1 1 (IdrisC-45Parser-interpBlock arg-0 arg-1 arg-2) (lambda () ParserC-45RuleC-45Source-strLitLines)))) (lambda (u--xs) (vector 10 0 1 (let ((sc0 (PreludeC-45Types-u--traverse_Traversable_List (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-2 (vector-ref arg-9937 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (IdrisC-45Parser-n--13773-14452-u--toPStr arg-2 arg-1 arg-0 eta-0)) u--xs))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 4 (box (let ((e-3 (vector-ref u--begin 2))) e-3)) 1 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (vector 0 e-5))))) (lambda (u--pstrs) (vector 11 0 ParserC-45RuleC-45Source-strEnd (lambda () (vector 0 (cons (let ((e-1 (vector-ref u--begin 0))) e-1) u--pstrs))))))))))))) (lambda () (lambda (u--b) (vector 0 (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (vector 33 (CoreC-45FC-boundToFC arg-1 u--b) e-5 e-4)))))))))))
(define DataC-45SnocList-mapTRC-39 (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-2) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (DataC-45SnocList-mapTRC-39 (cons (arg-3 e-2) arg-2) arg-3 e-1))))))
(define DataC-45SnocList-mapTR (lambda (ext-0 ext-1) (DataC-45SnocList-mapTRC-39 '() ext-0 ext-1)))
(define DataC-45SnocList-u--null_Foldable_SnocList (lambda (arg-1) (if (null? arg-1) 1 0)))
(define IdrisC-45Parser-snocListExpr (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-2) (lambda () (lambda (u--x) (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol ",")) (lambda () (lambda (u--b) (vector 0 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) u--x) u--b))))))))) (lambda (u--hd) (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-2) (lambda () (lambda (u--tl) (vector 0 (cons u--hd u--tl)))))))) (lambda (u--mHeadTail) (vector 9 0 (vector 14 (ParserC-45RuleC-45Source-symbol "]")) (lambda () (lambda (u--b) (vector 0 (let ((u--xs (if (null? u--mHeadTail) '() (let ((e-2 (unbox u--mHeadTail))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (cons (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() e-5) (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) e-6) u--b)))))))) (let ((u--fc (CoreC-45FC-boundToFC arg-0 (LibrariesC-45TextC-45Bounded-mergeBounds arg-1 u--b)))) (let ((u--nilFC (let ((sc0 (DataC-45SnocList-u--null_Foldable_SnocList u--xs))) (cond ((equal? sc0 1) u--fc) (else (CoreC-45FC-boundToFC arg-0 arg-1)))))) (vector 39 u--fc u--nilFC (DataC-45SnocList-mapTR (lambda (u--t) (cons (CoreC-45FC-boundToFC arg-0 u--t) (let ((e-1 (vector-ref u--t 0))) e-1))) u--xs)))))))))))))
(define IdrisC-45Parser-simplerExpr (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (vector 14 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 (vector 0 eta-0))) (IdrisC-45Parser-decoratedSimpleBinderName arg-0))) (lambda () (lambda (u--x) (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "@") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (IdrisC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--expr) (vector 0 (cons u--x u--expr)))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 23 (CoreC-45FC-boundToFC arg-0 u--b) (CoreC-45FC-boundToFC arg-0 e-2) (let ((e-1 (vector-ref e-2 0))) e-1) e-3))))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 1 (IdrisC-45Parser-decoratedNamespacedSymbol arg-0 "[|") (lambda () (lambda (u--mns) (vector 9 1 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "|]") (lambda () (vector 0 (cons u--t u--mns))))))))))) (lambda () (lambda (u--b) (vector 0 (vector 37 (CoreC-45FC-boundToFC arg-0 u--b) (Builtin-snd (let ((e-1 (vector-ref u--b 0))) e-1)) (Builtin-fst (let ((e-1 (vector-ref u--b 0))) e-1))))))) (lambda () (vector 13 1 1 (IdrisC-45Parser-atom arg-0) (lambda () (vector 13 1 1 (IdrisC-45Parser-record_ arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-singlelineStr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-multilineStr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 ".(") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 0 u--t)))))))))) (lambda () (lambda (u--b) (vector 0 (vector 24 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "`(") (lambda () (vector 9 1 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 ")") (lambda () (vector 0 u--t))))))))) (lambda () (lambda (u--b) (vector 0 (vector 16 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "`{") (lambda () (vector 9 1 ParserC-45RuleC-45Source-name (lambda () (lambda (u--t) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 u--t))))))))) (lambda () (lambda (u--b) (vector 0 (vector 17 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "`[") (lambda () (vector 9 1 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ts) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "]") (lambda () (vector 0 u--ts))))))))) (lambda () (lambda (u--b) (vector 0 (vector 18 (CoreC-45FC-boundToFC arg-0 u--b) (IdrisC-45Parser-collectDefs (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) (let ((e-1 (vector-ref u--b 0))) e-1)))))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "~")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--b) (vector 0 (vector 19 (CoreC-45FC-boundToFC arg-0 u--b) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "(")) (lambda () (lambda (u--start) (IdrisC-45Parser-bracketedExpr arg-0 u--start arg-1)))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (ParserC-45RuleC-45Source-symbol "[<")) (lambda () (lambda (u--start) (IdrisC-45Parser-snocListExpr arg-0 u--start arg-1)))) (lambda () (vector 13 1 1 (vector 9 1 (vector 14 (vector 13 1 1 (ParserC-45RuleC-45Source-symbol "[>") (lambda () (ParserC-45RuleC-45Source-symbol "[")))) (lambda () (lambda (u--start) (IdrisC-45Parser-listExpr arg-0 u--start arg-1)))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (IdrisC-45Parser-decoratedSymbol arg-0 "!")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (IdrisC-45Parser-simpleExpr arg-0 arg-1))))) (lambda () (lambda (u--b) (vector 0 (vector 36 (CoreC-45FC-virtualiseFC (CoreC-45FC-boundToFC arg-0 u--b)) (let ((e-1 (vector-ref u--b 0))) e-1)))))) (lambda () (vector 13 1 1 (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedPragma arg-0 "logging") (lambda () (vector 10 0 1 csegen-4322 (lambda (u--topic) (vector 9 1 ParserC-45RuleC-45Source-intLit (lambda () (lambda (u--lvl) (vector 9 0 (IdrisC-45Parser-expr IdrisC-45Parser-pdef arg-0 arg-1) (lambda () (lambda (u--e) (vector 0 (cons (CoreC-45OptionsC-45Log-mkLogLevelC-39 u--topic (PreludeC-45Types-prim__integerToNat u--lvl)) u--e))))))))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (vector 0 (vector 50 (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-3))))))))) (lambda () (vector 10 1 0 (vector 14 (IdrisC-45Parser-lam arg-0 arg-1)) (lambda (u--res) (vector 12 0 0 (vector 5 (box (let ((e-3 (vector-ref u--res 2))) e-3)) "DEPRECATED: trailing lambda. Use a $ or parens") (vector 0 (let ((e-1 (vector-ref u--res 0))) e-1)))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-simpleExpr (lambda (arg-0 arg-1) (vector 13 1 1 (vector 9 0 (vector 14 (vector 9 0 (IdrisC-45Parser-simplerExpr arg-0 arg-1) (lambda () (lambda (u--root) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (vector 14 ParserC-45RuleC-45Source-postfixProj)) (lambda (u--projs) (vector 0 (cons u--root u--projs)))))))) (lambda () (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--projs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--proj) (cons (CoreC-45FC-boundToFC arg-0 u--proj) (let ((e-1 (vector-ref u--proj 0))) e-1))) e-3))) (vector 0 (if (null? u--projs) e-2 (vector 48 (CoreC-45FC-boundToFC arg-0 u--b) e-2 u--projs))))))))))) (lambda () (vector 13 1 1 (IdrisC-45Parser-debugString arg-0) (lambda () (vector 9 0 csegen-4328 (lambda () (lambda (u--b) (vector 0 (let ((u--projs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--proj) (cons (CoreC-45FC-boundToFC arg-0 u--proj) (let ((e-1 (vector-ref u--proj 0))) e-1))) (let ((e-1 (vector-ref u--b 0))) e-1)))) (vector 49 (CoreC-45FC-boundToFC arg-0 u--b) u--projs))))))))))))
(define IdrisC-45Parser-defaultImplicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "default") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 1 (IdrisC-45Parser-simpleExpr arg-0 arg-1) (lambda () (lambda (u--t) (vector 9 1 (IdrisC-45Parser-pibindList arg-0 arg-1) (lambda () (lambda (u--binders) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 (cons u--t u--binders)))))))))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return a default implicit argument" (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (let ((e-1 (vector-ref u--b 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (IdrisC-45Parser-pibindAll arg-0 (vector 3 e-5) e-4 u--scope)))))))))))))))
(define IdrisC-45Parser-explicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (IdrisC-45Parser-parens 1 arg-0 (IdrisC-45Parser-pibindList arg-0 arg-1))) (lambda () (lambda (u--b) (vector 9 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return a named argument" (IdrisC-45Parser-bindSymbol arg-0)) (lambda () (lambda (u--exp) (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 u--exp (let ((e-1 (vector-ref u--b 0))) e-1) u--scope)))))))))))))
(define IdrisC-45Parser-forall_ (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "forall") (lambda () (vector 12 0 1 (vector 7 ) (vector 9 0 (LibrariesC-45TextC-45Parser-sepBy1 1 (IdrisC-45Parser-decoratedSymbol arg-0 ",") (vector 14 (IdrisC-45Parser-decoratedSimpleBinderName arg-0))) (lambda () (lambda (u--ns) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons csegen-30 (cons (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (box (vector 1 (vector 0 eta-0)))) u--n) (vector 25 (CoreC-45FC-boundToFC arg-0 u--n))))) (DataC-45List1-forget u--ns)))))))))) (lambda () (lambda (u--b) (vector 10 0 1 csegen-4480 (lambda (u--bC-39) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--bC-39 2))) e-3) "Expected ',' or '.'" (IdrisC-45Parser-decoratedSymbol arg-0 ".")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 (vector 0 ) (let ((e-1 (vector-ref u--b 0))) e-1) u--scope))))))))))))))
(define IdrisC-45Parser-implicitPi (lambda (arg-0 arg-1) (vector 9 1 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedSymbol arg-0 "{") (lambda () (vector 9 1 (IdrisC-45Parser-pibindList arg-0 arg-1) (lambda () (lambda (u--binders) (vector 11 0 (IdrisC-45Parser-decoratedSymbol arg-0 "}") (lambda () (vector 0 u--binders))))))))) (lambda () (lambda (u--b) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-mustWorkBecause 1 (let ((e-3 (vector-ref u--b 2))) e-3) "Cannot return an implicit argument" (IdrisC-45Parser-decoratedSymbol arg-0 "->")) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef arg-0 arg-1)) (lambda () (lambda (u--scope) (vector 0 (IdrisC-45Parser-pibindAll arg-0 (vector 0 ) (let ((e-1 (vector-ref u--b 0))) e-1) u--scope))))))))))))
(define IdrisC-45Parser-binder (lambda (arg-0 arg-1) (vector 13 1 1 (IdrisC-45Parser-autoImplicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-defaultImplicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-forall_ arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-implicitPi arg-0 arg-1) (lambda () (vector 13 1 1 (IdrisC-45Parser-explicitPi arg-0 arg-1) (lambda () (IdrisC-45Parser-lam arg-0 arg-1)))))))))))))
(define IdrisC-45Parser-n--13740-14238-u--mkPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (let ((e-2 (unbox arg-5))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (vector 1 arg-3 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega e-5 '() arg-4 e-6)))))))
(define IdrisC-45Parser-typeExpr (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (IdrisC-45Parser-binder arg-1 arg-2) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (u--arg_mscope) (let ((u--fc (CoreC-45FC-boundToFC arg-1 u--arg_mscope))) (let ((e-1 (vector-ref u--arg_mscope 0))) (let ((e-5 (car e-1))) (let ((e-4 (cdr e-1))) (IdrisC-45Parser-n--13740-14238-u--mkPi arg-2 arg-1 arg-0 u--fc e-5 e-4)))))) (vector 14 (vector 9 0 (IdrisC-45Parser-expr arg-0 arg-1 arg-2) (lambda () (lambda (u--arg) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 12 0 1 (ParserC-45RuleC-45Source-continue arg-2) (vector 9 1 (IdrisC-45Parser-bindSymbol arg-1) (lambda () (lambda (u--bd) (vector 9 0 (vector 8 (IdrisC-45Parser-typeExpr arg-0 arg-1 arg-2)) (lambda () (lambda (u--scope) (vector 0 (cons u--bd u--scope)))))))))) (lambda (u--mscope) (vector 0 (cons u--arg u--mscope)))))))))))))
(define csegen-4244 (IdrisC-45Parser-typeExpr IdrisC-45Parser-pdef (vector 2 (vector 0 )) ParserC-45RuleC-45Source-init))
(define csegen-4245 (vector 8 csegen-4244))
(define csegen-4256 (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f ParserC-45RuleC-45Source-eoi)))
(define csegen-4338 (cons "t" (cons "type" '())))
(define csegen-4343 (cons "s" (cons "search" '())))
(define csegen-4347 (cons "module" (cons "import" '())))
(define csegen-4352 (cons "q" (cons "quit" (cons "exit" '()))))
(define csegen-4361 (cons "c" (cons "compile" '())))
(define csegen-4367 (cons "l" (cons "load" '())))
(define csegen-4370 (cons "r" (cons "reload" '())))
(define csegen-4373 (cons "e" (cons "edit" '())))
(define csegen-4376 (cons "miss" (cons "missing" '())))
(define csegen-4382 (cons "log" (cons "logging" '())))
(define csegen-4386 (cons "colour" (cons "color" '())))
(define csegen-4389 (cons "m" (cons "metavars" '())))
(define csegen-4395 (cons "cs" (cons "casesplit" '())))
(define csegen-4399 (cons "ac" (cons "addclause" '())))
(define csegen-4403 (cons "ml" (cons "makelemma" '())))
(define csegen-4407 (cons "mc" (cons "makecase" '())))
(define csegen-4411 (cons "mw" (cons "makewith" '())))
(define csegen-4419 (cons "ps" (cons "proofsearch" '())))
(define csegen-4429 (cons "?" (cons "h" (cons "help" '()))))
(define csegen-4433 (cons "fs" (cons "fsearch" '())))
(define csegen-4685 (cons (vector 12 "n" (vector 10 )) '()))
(define CompilerC-45InterpreterC-45VMCode-unit (vector 2 (vector 0 0)))
(define csegen-4714 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 CompilerC-45InterpreterC-45VMCode-unit)))))
(define csegen-4722 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1)))))))
(define CompilerC-45InterpreterC-45VMCode-showSep (lambda (arg-0 arg-1) (if (null? arg-1) "" (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (CompilerC-45InterpreterC-45VMCode-showDepth arg-0 e-2) (string-append (CompilerC-45InterpreterC-45VMCode-showDepth arg-0 e-2) (string-append ", " (CompilerC-45InterpreterC-45VMCode-showSep arg-0 e-3)))))))))
(define CompilerC-45InterpreterC-45VMCode-showType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "Closure") ((1) "Constructor") ((2) "Constant") (else "Null"))))
(define CompilerC-45InterpreterC-45VMCode-showDepth (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (CompilerC-45InterpreterC-45VMCode-showType arg-1))(else (let ((e-0 (- arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (string-append (CoreC-45Name-u--show_Show_Name e-3) (string-append "-" (string-append (PreludeC-45Show-u--show_Show_Nat e-1) (string-append "(" (string-append (CompilerC-45InterpreterC-45VMCode-showSep e-0 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '())) ")"))))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (case (vector-ref e-4 0) ((0) (let ((e-9 (vector-ref e-4 1))) (string-append "tag" (string-append (PreludeC-45Show-u--show_Show_Int e-9) (string-append "(" (string-append (CompilerC-45InterpreterC-45VMCode-showSep e-0 e-5) ")"))))))(else (CompilerC-45InterpreterC-45VMCode-showType arg-1)))))) ((2) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-6)))(else (CompilerC-45InterpreterC-45VMCode-showType arg-1))))))))
(define CompilerC-45InterpreterC-45VMCode-u--show_Show_Object (lambda (ext-0) (CompilerC-45InterpreterC-45VMCode-showDepth 5 ext-0)))
(define CompilerC-45InterpreterC-45VMCode-u--showPrec_Show_Object (lambda (arg-0 arg-1) (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object arg-1)))
(define csegen-4745 (cons (lambda (u--x) (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45InterpreterC-45VMCode-u--showPrec_Show_Object u--d u--x)))))
(define CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) arg-1)(else (case (vector-ref arg-1 0) ((0) arg-0)(else (vector 6 arg-0 arg-1)))))))
(define CompilerC-45ESC-45Doc-u--fromString_FromString_Doc (lambda (ext-0) (vector 4 ext-0)))
(define CompilerC-45ESC-45Doc-softColon (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ":") (vector 2 )))
(define csegen-4762 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "h") CompilerC-45ESC-45Doc-softColon))
(define CompilerC-45ESC-45Doc-u--neutral_Monoid_Doc (vector 0 ))
(define csegen-4846 (cons (lambda (arg-8474) (lambda (arg-8477) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-8474 arg-8477))) CompilerC-45ESC-45Doc-u--neutral_Monoid_Doc))
(define CompilerC-45ESC-45Codegen-applyList (lambda (arg-0 arg-1 arg-2 arg-3) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4846 (lambda (eta-0) eta-0) (DataC-45List-intersperse arg-2 arg-3))) arg-1)))
(define CompilerC-45ESC-45Doc-softComma (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ",") (vector 2 )))
(define CompilerC-45ESC-45Codegen-app (lambda (arg-0 arg-1) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (CompilerC-45ESC-45Codegen-applyList (vector 4 "(") (vector 4 ")") CompilerC-45ESC-45Doc-softComma arg-1))))
(define CompilerC-45ESC-45Codegen-callFun (lambda (ext-0 ext-1) (CompilerC-45ESC-45Codegen-app (vector 4 ext-0) ext-1)))
(define CompilerC-45ESC-45Codegen-callFun1 (lambda (arg-0 ext-0) (CompilerC-45ESC-45Codegen-callFun arg-0 (PreludeC-45Types-u--pure_Applicative_List ext-0))))
(define CompilerC-45ESC-45Codegen-esName (lambda (arg-0) (string-append "_" arg-0)))
(define CompilerC-45ESC-45Codegen-jsCrashExp (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "crashExp") ext-0)))
(define ProtocolC-45Hex-hexDigit (lambda (arg-0) (cond ((equal? arg-0 0) #\0) ((equal? arg-0 1) #\1) ((equal? arg-0 2) #\2) ((equal? arg-0 3) #\3) ((equal? arg-0 4) #\4) ((equal? arg-0 5) #\5) ((equal? arg-0 6) #\6) ((equal? arg-0 7) #\7) ((equal? arg-0 8) #\8) ((equal? arg-0 9) #\9) ((equal? arg-0 10) #\a) ((equal? arg-0 11) #\b) ((equal? arg-0 12) #\c) ((equal? arg-0 13) #\d) ((equal? arg-0 14) #\e) ((equal? arg-0 15) #\f)(else #\X))))
(define ProtocolC-45Hex-n--4518-3623-u--asHexC-39 (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (ProtocolC-45Hex-n--4518-3623-u--asHexC-39 arg-0 (blodwen-shr arg-1 4) (cons (ProtocolC-45Hex-hexDigit (blodwen-and arg-1 15)) arg-2))))))
(define ProtocolC-45Hex-asHex (lambda (arg-0) (cond ((equal? arg-0 0) "0")(else (PreludeC-45Types-fastPack (ProtocolC-45Hex-n--4518-3623-u--asHexC-39 arg-0 arg-0 '()))))))
(define CompilerC-45ESC-45Codegen-n--12103-2521-u--okchar (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-1 #\ ))) (cond ((equal? sc1 1) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\\))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\"))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\'))) (cond ((equal? sc4 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-1 #\~)) (else 0)))) (else 0)))) (else 0)))) (else 0))))) (cond ((equal? sc0 1) (string arg-1)) (else (cond ((equal? arg-1 (integer->char 0)) "\\0") ((equal? arg-1 #\') "\\'") ((equal? arg-1 #\") "\\\"") ((equal? arg-1 (integer->char 13)) "\\r") ((equal? arg-1 (integer->char 10)) "\\n")(else (string-append "\\u{" (string-append (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-1 64)) "}")))))))))
(define CompilerC-45ESC-45Codegen-jsString (lambda (arg-0) (string-append "'" (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--12103-2521-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0)) "'"))))
(define CompilerC-45ESC-45Codegen-jsStringDoc (lambda (ext-0) (vector 4 (CompilerC-45ESC-45Codegen-jsString ext-0))))
(define csegen-4837 (vector 1 (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc "Error: Executed 'void'"))))
(define csegen-4838 (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-8 (vector-ref e-5 8))) e-8)))))))
(define csegen-4848 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "{h") CompilerC-45ESC-45Doc-softColon) (vector 4 "0}")))
(define csegen-4849 (LibrariesC-45DataC-45SortedMap-empty csegen-861))
(define csegen-4854 (lambda (u--t) (cons (Builtin-fst u--t) u--t)))
(define csegen-4884 (cons "scheme" (cons "C" '())))
(define LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (arg-1 arg-2 ext-0) (arg-1 (arg-2 ext-0))))
(define csegen-4890 (cons (lambda (arg-8474) (lambda (arg-8477) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-8474 arg-8477 eta-0)))) (lambda (eta-0) eta-0)))
(define csegen-4893 (lambda (eta-0) (vector 1 (cons '() (lambda (u--xs) (cons "" u--xs))))))
(define csegen-4896 (lambda (eta-0) (vector 1 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 eta-1 eta-2 eta-3)))))))
(define csegen-4897 (vector 1 (lambda (u--xs) (cons "" u--xs))))
(define csegen-4898 (lambda (eta-0) csegen-4897))
(define LibrariesC-45DataC-45StringC-45Builder-char (lambda (arg-0 ext-0) (cons (string arg-0) ext-0)))
(define CompilerC-45SchemeC-45Gambit-showGambitChar (lambda (arg-0 arg-1) (lambda (clam-0) (cond ((equal? arg-0 #\\) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\\\\" eta-0)) arg-1 clam-0))(else (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int (cast-char-boundedInt arg-0 63) 32))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons (string-append "\\x" (string-append (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-0 64)) ";")) eta-0)) arg-1 clam-0)) (else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-char arg-0 eta-0)) arg-1 clam-0)))))))))
(define CompilerC-45SchemeC-45Gambit-showGambitString (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "\\\"" eta-1)) (CompilerC-45SchemeC-45Gambit-showGambitString e-3 arg-1) eta-0)))(else (CompilerC-45SchemeC-45Gambit-showGambitChar e-2 (CompilerC-45SchemeC-45Gambit-showGambitString e-3 arg-1)))))))))
(define CompilerC-45SchemeC-45Gambit-gambitString (lambda (arg-0 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\"" eta-0)) (CompilerC-45SchemeC-45Gambit-showGambitString (PreludeC-45Types-fastUnpack arg-0) (lambda (u--xs) (cons "\"" u--xs))) ext-0)))
(define csegen-4899 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-gambitString eta-0 eta-1))))
(define csegen-4903 (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "(error \"bad getField\")" eta-1)))))
(define csegen-4905 (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "(error \"bad setField\")" eta-1)))))
(define csegen-4920 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "void" u--xs)))))
(define csegen-4922 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "int" u--xs)))))
(define csegen-4924 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "char" u--xs)))))
(define csegen-4940 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "double" u--xs)))))
(define csegen-4954 (vector 1 (lambda (u--xs) (cons "'()" u--xs))))
(define csegen-4957 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "'erased" u--xs)))))
(define csegen-4990 (lambda (arg-0) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-0 #\.)))
(define ProtocolC-45Hex-leftPad (lambda (arg-0 arg-1 arg-2) (let ((sc0 (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45TypesC-45String-length arg-2) arg-1))) (cond ((equal? sc0 1) (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() (PreludeC-45Types-prim__integerToNat (- arg-1 (PreludeC-45TypesC-45String-length arg-2))) arg-0)) arg-2)) (else arg-2)))))
(define CompilerC-45SchemeC-45Racket-showRacketChar (lambda (arg-0 arg-1) (lambda (clam-0) (cond ((equal? arg-0 #\\) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\\\\" eta-0)) arg-1 clam-0))(else (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int (cast-char-boundedInt arg-0 63) 32))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Int (cast-char-boundedInt arg-0 63) (blodwen-toSignedInt 126 63))))))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons (string-append "\\u" (ProtocolC-45Hex-leftPad #\0 4 (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-0 64)))) eta-0)) arg-1 clam-0)) (else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-char arg-0 eta-0)) arg-1 clam-0)))))))))
(define CompilerC-45SchemeC-45Racket-showRacketString (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "\\\"" eta-1)) (CompilerC-45SchemeC-45Racket-showRacketString e-3 arg-1) eta-0)))(else (CompilerC-45SchemeC-45Racket-showRacketChar e-2 (CompilerC-45SchemeC-45Racket-showRacketString e-3 arg-1)))))))))
(define CompilerC-45SchemeC-45Racket-racketString (lambda (arg-0 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\"" eta-0)) (CompilerC-45SchemeC-45Racket-showRacketString (PreludeC-45Types-fastUnpack arg-0) (lambda (u--xs) (cons "\"" u--xs))) ext-0)))
(define csegen-4998 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Racket-racketString eta-0 eta-1))))
(define csegen-5006 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "compileExpr returned Nothing") eta-0)))
(define csegen-5016 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_int8" u--xs)))))
(define csegen-5036 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_pointer" u--xs)))))
(define CoreC-45Hash-u--hashWithSalt_Hashable_NamedDef (lambda (arg-0 ext-0) (case (vector-ref ext-0 0) ((0) (let ((e-0 (vector-ref ext-0 1))) (let ((e-1 (vector-ref ext-0 2))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 csegen-1357 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 0) e-0) e-1)))) ((1) (let ((e-2 (vector-ref ext-0 1))) (let ((e-3 (vector-ref ext-0 2))) (let ((e-4 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 csegen-1359 (CoreC-45Hash-u--hashWithSalt_Hashable_Nat (CoreC-45Hash-u--hashWithSalt_Hashable_C-40MaybeC-32C-36aC-41 csegen-1361 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 1) e-2) e-3) e-4))))) ((2) (let ((e-5 (vector-ref ext-0 1))) (let ((e-6 (vector-ref ext-0 2))) (let ((e-7 (vector-ref ext-0 3))) (CoreC-45Hash-u--hashWithSalt_Hashable_CFType (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (csegen-1363) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 csegen-1355 (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 2) e-5) e-6) e-7))))) (else (let ((e-8 (vector-ref ext-0 1))) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedCExp (CoreC-45Hash-u--hashWithSalt_Hashable_Integer arg-0 3) e-8))))))
(define CoreC-45Hash-u--hash_Hashable_NamedDef (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedDef (blodwen-toSignedInt 5381 63) ext-0)))
(define csegen-5044 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_NamedDef arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_NamedDef arg-4541 arg-4544)))))
(define csegen-5049 (CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Loaded" ) (cons "libc" (cons "libc 6" '()))))
(define CoreC-45Core-cond (lambda (arg-1 arg-2) (if (null? arg-1) (arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-1 (e-6))) (cond ((equal? e-1 1) (e-7)) (else (CoreC-45Core-cond e-3 arg-2)))))))))))
(define CompilerC-45SchemeC-45Common-getScrutineeTemp (lambda (arg-0 ext-0) (cons (string-append "sc" (PreludeC-45Show-u--show_Show_Nat arg-0)) ext-0)))
(define CoreC-45Core-traverseVect (lambda (arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 '()) (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (vector 1 csegen-755)) (arg-3 e-3) eta-0)) (CoreC-45Core-traverseVect arg-3 e-4) clam-0)))))))
(define CompilerC-45SchemeC-45Common-schArgs (lambda (arg-0 arg-1 arg-2 arg-4 arg-5) (CoreC-45Core-traverseVect (lambda (eta-0) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-4 eta-0)) arg-5)))
(define CompilerC-45SchemeC-45Common-schCaseDef (lambda (arg-0 ext-0) (if (null? arg-0) (cons "" ext-0) (let ((e-2 (unbox arg-0))) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(else " eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-2 (lambda (u--xs) (cons ")" u--xs)) eta-0)) ext-0)))))
(define LibrariesC-45DataC-45StringC-45Builder-showB (lambda (arg-1 ext-0 ext-1) (cons (let ((e-1 (car arg-1))) (e-1 ext-0)) ext-1)))
(define CompilerC-45SchemeC-45Common-n--8835-2500-u--okchar (lambda (arg-0 arg-1 ext-0) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\_)))))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Builder-char arg-1 ext-0)) (else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "C-" eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (cast-char-boundedInt arg-1 63) eta-0)) ext-0))))))
(define CompilerC-45SchemeC-45Common-schString (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Common-n--8835-2500-u--okchar arg-0 eta-0 eta-1))) (PreludeC-45Types-fastUnpack arg-0))))
(define CompilerC-45SchemeC-45Common-schUserName (lambda (arg-0 ext-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "u--" eta-0)) (CompilerC-45SchemeC-45Common-schString e-0) ext-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "rf--" eta-0)) (CompilerC-45SchemeC-45Common-schString e-1) ext-0))) (else (cons "u--_" ext-0)))))
(define CompilerC-45SchemeC-45Common-schName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (lambda (clam-0) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (case (vector-ref e-16 0) ((0) (let ((e-17 (vector-ref e-16 1))) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "-" eta-1)) (CompilerC-45SchemeC-45Common-schString e-17) eta-0)) clam-0)))(else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "-" eta-1)) (CompilerC-45SchemeC-45Common-schName e-1) eta-0)) clam-0)))))(else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "-" eta-1)) (CompilerC-45SchemeC-45Common-schName e-1) eta-0)) clam-0))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-schUserName e-2 eta-0)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schString e-3) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "-" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-4 eta-2)) eta-1)) eta-0))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "pat--" eta-1)) (CompilerC-45SchemeC-45Common-schName e-5) eta-0)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CompilerC-45SchemeC-45Common-schName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (lambda (clam-1) (let ((e-20 (car e-9))) (let ((e-21 (cdr e-9))) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "n--" eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-20 eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "-" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-21 eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "-" eta-4)) (CompilerC-45SchemeC-45Common-schName e-10) eta-3)) eta-2)) eta-1)) eta-0)) clam-1))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "case--" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schString e-11) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "-" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-12 eta-3)) eta-2)) eta-1)) eta-0))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "with--" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schString e-13) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "-" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-14 eta-3)) eta-2)) eta-1)) eta-0))))) (else (let ((e-15 (vector-ref arg-0 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "fn--" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-15 eta-1)) eta-0)))))))
(define CompilerC-45SchemeC-45Common-usedCon (lambda (arg-0 arg-1) (let ((e-4 (vector-ref arg-1 4))) (CompilerC-45SchemeC-45Common-used arg-0 e-4))))
(define CompilerC-45SchemeC-45Common-usedConst (lambda (arg-0 arg-1) (let ((e-1 (cdr arg-1))) (CompilerC-45SchemeC-45Common-used arg-0 e-1))))
(define CompilerC-45SchemeC-45Common-used (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-1))) ((1) 0) ((2) (let ((e-6 (vector-ref arg-1 3))) (CompilerC-45SchemeC-45Common-used arg-0 e-6))) ((3) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-9))) (cond ((equal? sc1 1) 1) (else (CompilerC-45SchemeC-45Common-used arg-0 e-10))))))) ((4) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-12))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) e-13))))))) ((5) (let ((e-18 (vector-ref arg-1 5))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) e-18))) ((6) (let ((e-22 (vector-ref arg-1 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-22)))) ((7) (let ((e-25 (vector-ref arg-1 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0)) e-25))) ((8) (let ((e-28 (vector-ref arg-1 3))) (CompilerC-45SchemeC-45Common-used arg-0 e-28))) ((9) (let ((e-31 (vector-ref arg-1 3))) (CompilerC-45SchemeC-45Common-used arg-0 e-31))) ((10) (let ((e-33 (vector-ref arg-1 2))) (let ((e-34 (vector-ref arg-1 3))) (let ((e-35 (vector-ref arg-1 4))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-33))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45SchemeC-45Common-usedCon arg-0 eta-0)) e-34))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0))) e-35))))))))))) ((11) (let ((e-37 (vector-ref arg-1 2))) (let ((e-38 (vector-ref arg-1 3))) (let ((e-39 (vector-ref arg-1 4))) (let ((sc1 (CompilerC-45SchemeC-45Common-used arg-0 e-37))) (cond ((equal? sc1 1) 1) (else (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45SchemeC-45Common-usedConst arg-0 eta-0)) e-38))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-used arg-0 eta-0))) e-39)))))))))))(else 0))))
(define CompilerC-45SchemeC-45Common-bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) arg-7 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (CompilerC-45SchemeC-45Common-used e-2 arg-4))) (cond ((equal? sc1 1) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(let ((" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(vector-ref " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-3 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-895 arg-5 eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons "))) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 (+ arg-5 1) e-3 arg-7) (lambda (u--xs) (cons ")" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0))) (else (CompilerC-45SchemeC-45Common-bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 (+ arg-5 1) e-3 arg-7)))))))))
(define CompilerC-45SchemeC-45Common-showTag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (arg-2 (CoreC-45Name-u--show_Show_Name arg-3)) (let ((e-1 (unbox arg-4))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-1 eta-0))))))
(define CompilerC-45SchemeC-45Common-schConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-0 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "((" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-showTag arg-0 arg-1 arg-2 e-0 e-2) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons ") " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-bindArgs arg-0 arg-1 arg-2 arg-4 e-4 1 e-3 e-5) (lambda (u--xs) (cons ")" u--xs)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) ext-0)))))))))))
(define CompilerC-45SchemeC-45Common-schConUncheckedAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-bindArgs arg-0 arg-1 arg-2 arg-4 e-4 1 e-3 e-5))))) eff-0) ext-0)))))))))
(define LibrariesC-45DataC-45StringC-45Builder-n--3525-2824-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cons arg-3 (e-2 (LibrariesC-45DataC-45StringC-45Builder-n--3525-2824-u--go arg-0 arg-1 arg-2 arg-3 e-3 arg-5))))))))
(define LibrariesC-45DataC-45StringC-45Builder-sepBy (lambda (arg-0 arg-1) (if (null? arg-1) (lambda (eta-0) eta-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) e-2 (lambda (u--ys) (e-2 (LibrariesC-45DataC-45StringC-45Builder-n--3525-2824-u--go e-2 e-3 arg-0 arg-0 e-3 u--ys)))))))))
(define CompilerC-45SchemeC-45Common-var (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define CompilerC-45SchemeC-45Common-n--11722-5897-u--showAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) csegen-4897 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (if (null? e-3) (let ((act-1 (CompilerC-45SchemeC-45Common-schConUncheckedAlt arg-0 arg-1 arg-2 (+ arg-5 1) arg-6 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(else " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))) eff-0) clam-0))))) (let ((act-1 (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 arg-2 (+ arg-5 1) arg-6 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11722-5897-u--showAlts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) e-6 eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define CompilerC-45SchemeC-45Common-schCaseTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((PreludeC-45Types-maybe (lambda () csegen-4957) (lambda () (lambda (eta-2) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 eta-2))) arg-6) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--n (lambda (eta-2) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-2)))) (lambda (clam-0) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc3 1) (vector 1 e-6)) (else (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(let ((" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ")) " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (if (null? e-4) (lambda (clam-0) (if (null? arg-6) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (lambda (clam-1) (let ((sc4 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc4 1) (let ((act-2 (CompilerC-45SchemeC-45Common-schConUncheckedAlt arg-0 arg-1 arg-2 (+ arg-3 1) e-5 e-3 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 e-6)))) eff-0) clam-1)))))) (else (let ((act-2 (CompilerC-45SchemeC-45Common-schConUncheckedAlt arg-0 arg-1 arg-2 (+ arg-3 1) u--n e-3 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(let ((" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ")) " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) clam-1)))))))))))) eff-0) clam-0))))) (if (null? arg-6) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (lambda (clam-3) (let ((sc5 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc5 1) (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11722-5897-u--showAlts arg-0 arg-1 arg-2 arg-5 arg-4 arg-3 e-5 arg-5) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(case (vector-ref " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " 0) " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) clam-3)))))) (else (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11722-5897-u--showAlts arg-0 arg-1 arg-2 arg-5 arg-4 arg-3 u--n arg-5) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(let ((" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ")) (case (vector-ref " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons " 0) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons "))" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) clam-3)))))))))))) eff-0) clam-0))))) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 u--v) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box e-6))))) eff-0) eta-1)))))))) arg-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--n (lambda (eta-1) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-1)))) (lambda (clam-4) (let ((sc6 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc6 1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 arg-2 (+ arg-3 1) e-5 eta-1 eta-2))) arg-5 '()) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(case (vector-ref " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " 0) " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (CompilerC-45SchemeC-45Common-schCaseDef e-6 eta-7)) (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) clam-4)))))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 arg-2 (+ arg-3 1) u--n eta-1 eta-2))) arg-5 '()) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(let ((" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ")) (case (vector-ref " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons " 0) " eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (CompilerC-45SchemeC-45Common-schCaseDef e-6 eta-11)) (lambda (u--xs) (cons "))" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) clam-4)))))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) (lambda (clam-5) (if (null? arg-6) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (lambda (clam-6) (let ((sc4 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc4 1) (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11722-5897-u--showAlts arg-0 arg-1 arg-2 arg-5 arg-4 arg-3 e-5 arg-5) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(case (vector-ref " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " 0) " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) clam-6)))))) (else (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11722-5897-u--showAlts arg-0 arg-1 arg-2 arg-5 arg-4 arg-3 u--n arg-5) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(let ((" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ")) (case (vector-ref " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons " 0) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons "))" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) clam-6)))))))))))) eff-0) clam-5))))) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 u--v) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box e-6))))) eff-0) eta-1)))))))) arg-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--n (lambda (eta-1) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-1)))) (lambda (clam-7) (let ((sc5 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc5 1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 arg-2 (+ arg-3 1) e-5 eta-1 eta-2))) arg-5 '()) clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(case (vector-ref " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " 0) " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (CompilerC-45SchemeC-45Common-schCaseDef e-6 eta-7)) (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) clam-7)))))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConAlt arg-0 arg-1 arg-2 (+ arg-3 1) u--n eta-1 eta-2))) arg-5 '()) clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(let ((" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ")) (case (vector-ref " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons " 0) " eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (CompilerC-45SchemeC-45Common-schCaseDef e-6 eta-11)) (lambda (u--xs) (cons "))" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) clam-7)))))))))))) eff-0) eta-0)))))))) eff-0) clam-5)))))))))))))
(define CompilerC-45SchemeC-45Common-schPrimType (lambda (arg-0 ext-0) (cons "#t" ext-0)))
(define CompilerC-45SchemeC-45Common-schConstant (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-0 eta-0)))) ((1) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Int8 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Int8 u--d u--x)))) e-1 eta-0)))) ((2) (let ((e-2 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Int16 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Int16 u--d u--x)))) e-2 eta-0)))) ((3) (let ((e-3 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Int32 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Int32 u--d u--x)))) e-3 eta-0)))) ((4) (let ((e-4 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Int64 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Int64 u--d u--x)))) e-4 eta-0)))) ((5) (let ((e-5 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-1054 e-5 eta-0)))) ((6) (let ((e-6 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Bits8 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Bits8 u--d u--x)))) e-6 eta-0)))) ((7) (let ((e-7 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Bits16 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Bits16 u--d u--x)))) e-7 eta-0)))) ((8) (let ((e-8 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Bits32 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Bits32 u--d u--x)))) e-8 eta-0)))) ((9) (let ((e-9 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Bits64 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Bits64 u--d u--x)))) e-9 eta-0)))) ((10) (let ((e-10 (vector-ref arg-1 1))) (arg-0 e-10))) ((11) (let ((e-11 (vector-ref arg-1 1))) (lambda (clam-0) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (cast-char-boundedInt e-11 63) 32))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60_Ord_Int (cast-char-boundedInt e-11 63) (blodwen-toSignedInt 127 63))) (else 0))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "#\\" eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-char e-11 eta-0)) clam-0)) (else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(integer->char " eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (cast-char-boundedInt e-11 63) eta-1)) (lambda (u--xs) (cons ")" u--xs)) eta-0)) clam-0))))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_Double u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_Double u--d u--x)))) e-12 eta-0)))) ((13) (let ((e-13 (vector-ref arg-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-schPrimType e-13 eta-0)))) (else (lambda (u--xs) (cons "#f" u--xs))))))
(define CompilerC-45SchemeC-45Common-schConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-0 (car arg-5))) (let ((e-1 (cdr arg-5))) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "((equal? " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-4 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schConstant arg-2 e-0) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ") " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) ext-0)))))))))
(define CompilerC-45SchemeC-45Common-schConstructor (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(vector " eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (arg-0 (CoreC-45Name-u--show_Show_Name arg-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " arg-3) (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)) eta-0)) ext-0) (let ((e-1 (unbox arg-2))) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(vector " eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-1 eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " arg-3) (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)) eta-0)) ext-0)))))
(define CompilerC-45SchemeC-45Common-n--11729-6385-u--buildCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-8) (if (null? arg-9) (if (null? arg-10) (lambda (u--xs) (cons "#f" u--xs)) (let ((e-16 (unbox arg-10))) e-16)) (let ((e-10 (unbox arg-9))) (if (null? arg-10) e-10 (let ((e-14 (unbox arg-10))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(if (null? " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-7 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-14 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-10 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0)))))) (let ((e-1 (unbox arg-8))) (if (null? arg-9) (if (null? arg-10) e-1 (let ((e-8 (unbox arg-10))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(if (null? " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-7 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-1 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-8 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0)))) (let ((e-4 (unbox arg-9))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(if (null? " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-7 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-1 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-4 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0))))))))
(define CompilerC-45SchemeC-45Common-n--12785-6589-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-14) arg-15 (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CompilerC-45SchemeC-45Common-used e-6 arg-12))) (cond ((equal? sc2 1) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(let ((" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-6) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-7 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-13 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons "))) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-n--12785-6589-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3 arg-15) (lambda (u--xs) (cons ")" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0))) (else (CompilerC-45SchemeC-45Common-n--12785-6589-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3 arg-15)))))))))))
(define CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (case (vector-ref e-5 0) ((3) (if (null? e-7) (CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-6 1) e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (CompilerC-45SchemeC-45Common-n--12785-6589-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-4 e-6 e-10 e-13 e-8 arg-7 (cons (cons e-10 (lambda (u--xs) (cons "car" u--xs))) (cons (cons e-13 (lambda (u--xs) (cons "cdr" u--xs))) '())) e-9)))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)))))))))(else (CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)))))))))))))
(define CompilerC-45SchemeC-45Common-n--11729-6387-u--getNilCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-5 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 4))) (case (vector-ref e-5 0) ((2) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-6 1) e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-9))))) eff-0) eta-0)))))))(else (CompilerC-45SchemeC-45Common-n--11729-6387-u--getNilCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))
(define CompilerC-45SchemeC-45Common-schListCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (lambda (eta-0) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) u--v) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box e-6))))) eff-0) eta-1)))))))) arg-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45SchemeC-45Common-n--11729-6387-u--getNilCode arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 arg-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc3 1) (let ((act-4 ((CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 e-5 arg-5) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45SchemeC-45Common-n--11729-6385-u--buildCase arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 e-5 e-7 e-8 e-6))))) eff-0) clam-0)))))) (else (let ((act-4 ((CompilerC-45SchemeC-45Common-n--11729-6386-u--getConsCode arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 u--n arg-5) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(let ((" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons ")) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-n--11729-6385-u--buildCase arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 u--n e-7 e-8 e-6) (lambda (u--xs) (cons ")" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) clam-0))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Common-n--11730-6899-u--buildCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-8) (if (null? arg-9) (if (null? arg-10) (lambda (u--xs) (cons "#f" u--xs)) (let ((e-16 (unbox arg-10))) e-16)) (let ((e-10 (unbox arg-9))) (if (null? arg-10) e-10 (let ((e-14 (unbox arg-10))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(if (null? " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-7 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-14 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-10 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0)))))) (let ((e-1 (unbox arg-8))) (if (null? arg-9) (if (null? arg-10) e-1 (let ((e-8 (unbox arg-10))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(if (null? " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-7 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-1 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-8 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0)))) (let ((e-4 (unbox arg-9))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(if (null? " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-7 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-1 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-4 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0))))))))
(define CompilerC-45SchemeC-45Common-n--13327-7100-u--bindArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((sc0 (CompilerC-45SchemeC-45Common-used arg-13 arg-11))) (cond ((equal? sc0 1) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(let ((" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName arg-13) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(unbox " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-12 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons "))) " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-14 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0))) (else arg-14)))))
(define CompilerC-45SchemeC-45Common-n--11730-6900-u--getJustCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (case (vector-ref e-5 0) ((6) (if (null? e-7) (CompilerC-45SchemeC-45Common-n--11730-6900-u--getJustCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-6 1) e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (CompilerC-45SchemeC-45Common-n--13327-7100-u--bindArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-4 e-6 e-10 e-8 arg-7 e-10 e-9)))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-n--11730-6900-u--getJustCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3))))))(else (CompilerC-45SchemeC-45Common-n--11730-6900-u--getJustCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)))))))))))))
(define CompilerC-45SchemeC-45Common-n--11730-6901-u--getNothingCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-5 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 4))) (case (vector-ref e-5 0) ((5) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-6 1) e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-9))))) eff-0) eta-0)))))))(else (CompilerC-45SchemeC-45Common-n--11730-6901-u--getNothingCode arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))
(define CompilerC-45SchemeC-45Common-schMaybeCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (lambda (eta-0) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) u--v) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box e-6))))) eff-0) eta-1)))))))) arg-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45SchemeC-45Common-n--11730-6901-u--getNothingCode arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 arg-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc3 1) (let ((act-4 ((CompilerC-45SchemeC-45Common-n--11730-6900-u--getJustCode arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 e-5 arg-5) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45SchemeC-45Common-n--11730-6899-u--buildCase arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 e-5 e-7 e-8 e-6))))) eff-0) clam-0)))))) (else (let ((act-4 ((CompilerC-45SchemeC-45Common-n--11730-6900-u--getJustCode arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 u--n arg-5) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(let ((" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons ")) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-n--11730-6899-u--buildCase arg-0 arg-1 arg-2 arg-6 arg-5 arg-4 arg-3 u--n e-7 e-8 e-6) (lambda (u--xs) (cons ")" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) clam-0))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Common-op (lambda (arg-0 arg-1 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(" eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons arg-0 eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " arg-1) (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)) eta-0)) ext-0)))
(define CompilerC-45SchemeC-45Common-add (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "+" (cons arg-1 (cons arg-2 '())) eta-0)) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-0) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "+" (cons arg-1 (cons arg-2 '())) clam-0) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs+" (cons arg-1 (cons arg-2 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-0)) '()))) clam-0)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "bu+" (cons arg-1 (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '()))) eta-0))))(else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "+" (cons arg-1 (cons arg-2 '())) eta-0))))))))
(define CompilerC-45SchemeC-45Common-boolop (lambda (arg-0 arg-1 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(or (and " eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op arg-0 arg-1 eta-1)) (lambda (u--xs) (cons " 1) 0)" u--xs)) eta-0)) ext-0)))
(define CoreC-45TTC-45Primitive-intKind (lambda (arg-0) (cond ((equal? arg-0 5) (box (vector 0 '()))) ((equal? arg-0 1) (box (vector 0 (box 8)))) ((equal? arg-0 2) (box (vector 0 (box 16)))) ((equal? arg-0 3) (box (vector 0 (box 32)))) ((equal? arg-0 4) (box (vector 0 (box 64)))) ((equal? arg-0 0) (box (vector 0 (box 64)))) ((equal? arg-0 6) (box (vector 1 8))) ((equal? arg-0 7) (box (vector 1 16))) ((equal? arg-0 8) (box (vector 1 32))) ((equal? arg-0 9) (box (vector 1 64)))(else '()))))
(define CompilerC-45Common-case--castInt-6038 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (cond ((equal? e-6 11) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1))))))))))) (let ((e-19 (cdr e-3))) (if (null? e-19) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1))))))))))) (let ((e-21 (unbox e-19))) (let ((e-1 (vector-ref arg-4 0))) ((e-1 e-21) arg-1))))))) ((equal? e-6 10) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1))))))))))) (let ((e-25 (cdr e-3))) (if (null? e-25) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1))))))))))) (let ((e-27 (unbox e-25))) (let ((e-10 (vector-ref arg-4 2))) ((e-10 e-27) arg-1))))))) ((equal? e-6 12) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1))))))))))) (let ((e-31 (cdr e-3))) (if (null? e-31) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1))))))))))) (let ((e-33 (unbox e-31))) (let ((e-5 (vector-ref arg-4 4))) ((e-5 e-33) arg-1)))))))(else (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (let ((e-14 (vector-ref arg-4 1))) ((e-14 e-9) arg-1))) ((equal? e-12 10) (let ((e-4 (vector-ref arg-4 3))) ((e-4 e-9) arg-1))) ((equal? e-12 12) (let ((e-10 (vector-ref arg-4 5))) ((e-10 e-9) arg-1)))(else (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "invalid cast: + " (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-3) (string-append " + ' -> ' + " (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2))))) eta-0)) (let ((e-15 (unbox e-13))) (let ((e-8 (vector-ref arg-4 6))) (((e-8 e-9) e-15) arg-1)))))))))))))))))))))
(define CompilerC-45Common-castInt (lambda (arg-1 arg-2 arg-3 arg-4) (CompilerC-45Common-case--castInt-6038 arg-4 arg-3 arg-2 arg-1 (cons (cons arg-2 (CoreC-45TTC-45Primitive-intKind arg-2)) (cons arg-3 (CoreC-45TTC-45Primitive-intKind arg-3))))))
(define CompilerC-45SchemeC-45Common-n--9508-3157-u--charTo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (lambda (clam-0) (if (null? e-0) (CompilerC-45SchemeC-45Common-op "char->integer" (cons arg-1 '()) clam-0) (let ((e-2 (unbox e-0))) (CompilerC-45SchemeC-45Common-op "cast-char-boundedInt" (cons arg-1 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-2 1 63) eta-0)) '())) clam-0)))))) (else (let ((e-1 (vector-ref arg-0 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "cast-char-boundedUInt" (cons arg-1 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-1 eta-1)) '())) eta-0)))))))
(define CompilerC-45SchemeC-45Common-n--9508-3158-u--dblTo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (lambda (clam-0) (if (null? e-0) (CompilerC-45SchemeC-45Common-op "exact-truncate" (cons arg-1 '()) clam-0) (let ((e-2 (unbox e-0))) (CompilerC-45SchemeC-45Common-op "exact-truncate-boundedInt" (cons arg-1 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-2 1 63) eta-0)) '())) clam-0)))))) (else (let ((e-1 (vector-ref arg-0 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "exact-truncate-boundedUInt" (cons arg-1 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-1 eta-1)) '())) eta-0)))))))
(define CoreC-45TTC-45Primitive-u--compare_Ord_Precision (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) 1 2) (let ((e-0 (unbox arg-0))) (if (null? arg-1) 0 (let ((e-1 (unbox arg-1))) (PreludeC-45EqOrd-u--compare_Ord_Int e-0 e-1)))))))
(define CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CoreC-45TTC-45Primitive-u--compare_Ord_Precision arg-0 arg-1) 0)))
(define CompilerC-45SchemeC-45Common-n--9508-3159-u--intTo (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-8 (vector-ref arg-1 1))) (if (null? e-8) arg-2 (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc5 1) arg-2) (else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-1)) '())) eta-0)))))))) (else (let ((e-3 (vector-ref arg-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '())) eta-0))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc5 1) arg-2) (else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-7 1 63) eta-1)) '())) eta-0)))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc4 1) arg-2) (else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-6 eta-1)) '())) eta-0))))))))))))))(else (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc3 1) arg-2) (else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-1)) '())) eta-0)))))))) (else (let ((e-3 (vector-ref arg-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '())) eta-0))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc3 1) arg-2) (else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toSignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-7 1 63) eta-1)) '())) eta-0)))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc2 1) arg-2) (else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-toUnsignedInt" (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-6 eta-1)) '())) eta-0)))))))))))))))
(define CompilerC-45SchemeC-45Common-n--9508-3160-u--strTo (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (lambda (clam-0) (if (null? e-0) (CompilerC-45SchemeC-45Common-op "cast-string-int" (cons arg-1 '()) clam-0) (let ((e-2 (unbox e-0))) (CompilerC-45SchemeC-45Common-op "cast-string-boundedInt" (cons arg-1 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-2 1 63) eta-0)) '())) clam-0)))))) (else (let ((e-1 (vector-ref arg-0 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "cast-string-boundedUInt" (cons arg-1 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-1 eta-1)) '())) eta-0)))))))
(define CompilerC-45SchemeC-45Common-constPrimitives (vector (lambda (u--k) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--9508-3157-u--charTo u--k eta-0))))) (lambda (_-3557) (lambda (u--x) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "cast-int-char" (cons u--x '()) eta-1)))))) (lambda (u--k) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--9508-3160-u--strTo u--k eta-0))))) (lambda (_-3535) (lambda (u--x) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "number->string" (cons u--x '()) eta-1)))))) (lambda (u--k) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--9508-3158-u--dblTo u--k eta-0))))) (lambda (_-3513) (lambda (u--x) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "exact->inexact" (cons u--x '()) eta-1)))))) (lambda (u--k1) (lambda (u--k2) (lambda (eta-0) (lambda (eta-1) (vector 1 (CompilerC-45SchemeC-45Common-n--9508-3159-u--intTo u--k1 u--k2 eta-0))))))))
(define CompilerC-45SchemeC-45Common-div (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "/" (cons arg-1 (cons arg-2 '())) eta-0)) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-0) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "blodwen-euclidDiv" (cons arg-1 (cons arg-2 '())) clam-0) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs/" (cons arg-1 (cons arg-2 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-0)) '()))) clam-0)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "bu/" (cons arg-1 (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '()))) eta-0))))(else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "/" (cons arg-1 (cons arg-2 '())) eta-0))))))))
(define CompilerC-45SchemeC-45Common-mul (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "*" (cons arg-1 (cons arg-2 '())) eta-0)) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-0) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "*" (cons arg-1 (cons arg-2 '())) clam-0) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs*" (cons arg-1 (cons arg-2 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-0)) '()))) clam-0)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "bu*" (cons arg-1 (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '()))) eta-0))))(else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "*" (cons arg-1 (cons arg-2 '())) eta-0))))))))
(define CompilerC-45SchemeC-45Common-shl (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-shl" (cons arg-1 (cons arg-2 '())) eta-0)) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-0) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "blodwen-shl" (cons arg-1 (cons arg-2 '())) clam-0) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "blodwen-bits-shl-signed" (cons arg-1 (cons arg-2 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-0)) '()))) clam-0)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-bits-shl" (cons arg-1 (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '()))) eta-0))))(else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-shl" (cons arg-1 (cons arg-2 '())) eta-0))))))))
(define CompilerC-45SchemeC-45Common-sub (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "-" (cons arg-1 (cons arg-2 '())) eta-0)) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-0) (if (null? e-2) (CompilerC-45SchemeC-45Common-op "-" (cons arg-1 (cons arg-2 '())) clam-0) (let ((e-4 (unbox e-2))) (CompilerC-45SchemeC-45Common-op "bs-" (cons arg-1 (cons arg-2 (cons (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 (bs- e-4 1 63) eta-0)) '()))) clam-0)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "bu-" (cons arg-1 (cons arg-2 (cons (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-495 e-3 eta-1)) '()))) eta-0))))(else (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "-" (cons arg-1 (cons arg-2 '())) eta-0))))))))
(define CompilerC-45SchemeC-45Common-schOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (lambda (clam-0) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (vector 1 (CompilerC-45SchemeC-45Common-add (CoreC-45TTC-45Primitive-intKind e-0) e-20 e-24))))))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-29 (car arg-2))) (let ((e-30 (cdr arg-2))) (lambda (clam-1) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (vector 1 (CompilerC-45SchemeC-45Common-sub (CoreC-45TTC-45Primitive-intKind e-1) e-29 e-33))))))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (let ((e-38 (car arg-2))) (let ((e-39 (cdr arg-2))) (lambda (clam-2) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (vector 1 (CompilerC-45SchemeC-45Common-mul (CoreC-45TTC-45Primitive-intKind e-2) e-38 e-42))))))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-3) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (CompilerC-45SchemeC-45Common-div (CoreC-45TTC-45Primitive-intKind e-3) e-47 e-51))))))))) ((4) (let ((e-56 (car arg-2))) (let ((e-57 (cdr arg-2))) (lambda (clam-4) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-euclidMod" (cons e-56 (cons e-60 '())) eta-0))))))))) ((5) (lambda (clam-5) (let ((e-65 (car arg-2))) (let ((e-66 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "-" (cons e-65 '()) eta-0))))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (lambda (clam-6) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (vector 1 (CompilerC-45SchemeC-45Common-shl (CoreC-45TTC-45Primitive-intKind e-6) e-70 e-74))))))))) ((7) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-7) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-shr" (cons e-79 (cons e-83 '())) eta-0))))))))) ((8) (let ((e-88 (car arg-2))) (let ((e-89 (cdr arg-2))) (lambda (clam-8) (let ((e-92 (car e-89))) (let ((e-93 (cdr e-89))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-and" (cons e-88 (cons e-92 '())) eta-0))))))))) ((9) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (lambda (clam-9) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-or" (cons e-97 (cons e-101 '())) eta-0))))))))) ((10) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-10) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "blodwen-xor" (cons e-106 (cons e-110 '())) eta-0))))))))) ((11) (let ((e-11 (vector-ref arg-1 1))) (cond ((equal? e-11 11) (if (null? arg-2) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-13) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0)))))))) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (if (null? e-125) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-12) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0)))))))) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (if (null? e-129) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "char<?" (cons e-124 (cons e-128 '())) eta-1)))) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-11) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0)))))))))))))))) ((equal? e-11 10) (if (null? arg-2) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-16) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0)))))))) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (if (null? e-134) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-15) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0)))))))) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (if (null? e-138) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "string<?" (cons e-133 (cons e-137 '())) eta-1)))) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-14) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0))))))))))))))))(else (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (lambda (clam-17) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<" (cons e-115 (cons e-119 '())) eta-0)))))))))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (cond ((equal? e-12 11) (if (null? arg-2) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-20) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0)))))))) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (if (null? e-152) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-19) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0)))))))) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (if (null? e-156) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "char<=?" (cons e-151 (cons e-155 '())) eta-1)))) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-18) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0)))))))))))))))) ((equal? e-12 10) (if (null? arg-2) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-23) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0)))))))) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (if (null? e-161) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-22) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0)))))))) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (if (null? e-165) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "string<=?" (cons e-160 (cons e-164 '())) eta-1)))) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-21) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0))))))))))))))))(else (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (lambda (clam-24) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "<=" (cons e-142 (cons e-146 '())) eta-0)))))))))))) ((13) (let ((e-13 (vector-ref arg-1 1))) (cond ((equal? e-13 11) (if (null? arg-2) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-27) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0)))))))) (let ((e-178 (car arg-2))) (let ((e-179 (cdr arg-2))) (if (null? e-179) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-26) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0)))))))) (let ((e-182 (car e-179))) (let ((e-183 (cdr e-179))) (if (null? e-183) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "char=?" (cons e-178 (cons e-182 '())) eta-1)))) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-25) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0)))))))))))))))) ((equal? e-13 10) (if (null? arg-2) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-30) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0)))))))) (let ((e-187 (car arg-2))) (let ((e-188 (cdr arg-2))) (if (null? e-188) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-29) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0)))))))) (let ((e-191 (car e-188))) (let ((e-192 (cdr e-188))) (if (null? e-192) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "string=?" (cons e-187 (cons e-191 '())) eta-1)))) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-28) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0))))))))))))))))(else (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-31) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop "=" (cons e-169 (cons e-173 '())) eta-0)))))))))))) ((14) (let ((e-14 (vector-ref arg-1 1))) (cond ((equal? e-14 11) (if (null? arg-2) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-34) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0)))))))) (let ((e-205 (car arg-2))) (let ((e-206 (cdr arg-2))) (if (null? e-206) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-33) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0)))))))) (let ((e-209 (car e-206))) (let ((e-210 (cdr e-206))) (if (null? e-210) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "char>=?" (cons e-205 (cons e-209 '())) eta-1)))) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-32) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0)))))))))))))))) ((equal? e-14 10) (if (null? arg-2) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-37) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0)))))))) (let ((e-214 (car arg-2))) (let ((e-215 (cdr arg-2))) (if (null? e-215) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-36) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0)))))))) (let ((e-218 (car e-215))) (let ((e-219 (cdr e-215))) (if (null? e-219) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "string>=?" (cons e-214 (cons e-218 '())) eta-1)))) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-35) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0))))))))))))))))(else (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-38) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">=" (cons e-196 (cons e-200 '())) eta-0)))))))))))) ((15) (let ((e-15 (vector-ref arg-1 1))) (cond ((equal? e-15 11) (if (null? arg-2) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-41) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0)))))))) (let ((e-232 (car arg-2))) (let ((e-233 (cdr arg-2))) (if (null? e-233) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-40) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0)))))))) (let ((e-236 (car e-233))) (let ((e-237 (cdr e-233))) (if (null? e-237) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "char>?" (cons e-232 (cons e-236 '())) eta-1)))) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-39) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0)))))))))))))))) ((equal? e-15 10) (if (null? arg-2) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-44) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0)))))))) (let ((e-241 (car arg-2))) (let ((e-242 (cdr arg-2))) (if (null? e-242) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-43) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0)))))))) (let ((e-245 (car e-242))) (let ((e-246 (cdr e-242))) (if (null? e-246) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-boolop "string>?" (cons e-241 (cons e-245 '())) eta-1)))) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-42) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0))))))))))))))))(else (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-45) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-boolop ">" (cons e-223 (cons e-227 '())) eta-0)))))))))))) ((16) (lambda (clam-46) (let ((e-250 (car arg-2))) (let ((e-251 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-length" (cons e-250 '()) eta-0))))))) ((17) (lambda (clam-47) (let ((e-255 (car arg-2))) (let ((e-256 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-ref" (cons e-255 (cons (lambda (u--xs) (cons "0" u--xs)) '())) eta-0))))))) ((18) (lambda (clam-48) (let ((e-260 (car arg-2))) (let ((e-261 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "substring" (cons e-260 (cons (lambda (u--xs) (cons "1" u--xs)) (cons (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "string-length" (cons e-260 '()) eta-1)) '()))) eta-0))))))) ((19) (let ((e-265 (car arg-2))) (let ((e-266 (cdr arg-2))) (lambda (clam-49) (let ((e-269 (car e-266))) (let ((e-270 (cdr e-266))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-ref" (cons e-265 (cons e-269 '())) eta-0))))))))) ((20) (let ((e-274 (car arg-2))) (let ((e-275 (cdr arg-2))) (lambda (clam-50) (let ((e-278 (car e-275))) (let ((e-279 (cdr e-275))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-cons" (cons e-274 (cons e-278 '())) eta-0))))))))) ((21) (let ((e-283 (car arg-2))) (let ((e-284 (cdr arg-2))) (lambda (clam-51) (let ((e-287 (car e-284))) (let ((e-288 (cdr e-284))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-append" (cons e-283 (cons e-287 '())) eta-0))))))))) ((22) (lambda (clam-52) (let ((e-292 (car arg-2))) (let ((e-293 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-reverse" (cons e-292 '()) eta-0))))))) ((23) (let ((e-297 (car arg-2))) (let ((e-298 (cdr arg-2))) (let ((e-301 (car e-298))) (let ((e-302 (cdr e-298))) (lambda (clam-53) (let ((e-305 (car e-302))) (let ((e-306 (cdr e-302))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "string-substr" (cons e-297 (cons e-301 (cons e-305 '()))) eta-0))))))))))) ((24) (lambda (clam-54) (let ((e-310 (car arg-2))) (let ((e-311 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flexp" (cons e-310 '()) eta-0))))))) ((25) (lambda (clam-55) (let ((e-315 (car arg-2))) (let ((e-316 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "fllog" (cons e-315 '()) eta-0))))))) ((26) (let ((e-320 (car arg-2))) (let ((e-321 (cdr arg-2))) (lambda (clam-56) (let ((e-324 (car e-321))) (let ((e-325 (cdr e-321))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flexpt" (cons e-320 (cons e-324 '())) eta-0))))))))) ((27) (lambda (clam-57) (let ((e-329 (car arg-2))) (let ((e-330 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flsin" (cons e-329 '()) eta-0))))))) ((28) (lambda (clam-58) (let ((e-334 (car arg-2))) (let ((e-335 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flcos" (cons e-334 '()) eta-0))))))) ((29) (lambda (clam-59) (let ((e-339 (car arg-2))) (let ((e-340 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "fltan" (cons e-339 '()) eta-0))))))) ((30) (lambda (clam-60) (let ((e-344 (car arg-2))) (let ((e-345 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flasin" (cons e-344 '()) eta-0))))))) ((31) (lambda (clam-61) (let ((e-349 (car arg-2))) (let ((e-350 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flacos" (cons e-349 '()) eta-0))))))) ((32) (lambda (clam-62) (let ((e-354 (car arg-2))) (let ((e-355 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flatan" (cons e-354 '()) eta-0))))))) ((33) (lambda (clam-63) (let ((e-359 (car arg-2))) (let ((e-360 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flsqrt" (cons e-359 '()) eta-0))))))) ((34) (lambda (clam-64) (let ((e-364 (car arg-2))) (let ((e-365 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flfloor" (cons e-364 '()) eta-0))))))) ((35) (lambda (clam-65) (let ((e-369 (car arg-2))) (let ((e-370 (cdr arg-2))) (vector 1 (lambda (eta-0) (CompilerC-45SchemeC-45Common-op "flceiling" (cons e-369 '()) eta-0))))))) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (cond ((equal? e-16 12) (cond ((equal? e-17 10) (if (null? arg-2) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))) (let ((e-379 (car arg-2))) (let ((e-380 (cdr arg-2))) (if (null? e-380) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "number->string" (cons e-379 '()) eta-1)))) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374)))))) ((equal? e-16 11) (cond ((equal? e-17 10) (if (null? arg-2) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))) (let ((e-384 (car arg-2))) (let ((e-385 (cdr arg-2))) (if (null? e-385) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "string" (cons e-384 '()) eta-1)))) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374)))))) ((equal? e-16 10) (cond ((equal? e-17 12) (if (null? arg-2) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))) (let ((e-389 (car arg-2))) (let ((e-390 (cdr arg-2))) (if (null? e-390) (lambda (eta-0) (vector 1 (lambda (eta-1) (CompilerC-45SchemeC-45Common-op "cast-string-double" (cons e-389 '()) eta-1)))) (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374))))))(else (let ((e-374 (car arg-2))) (let ((e-375 (cdr arg-2))) (CompilerC-45Common-castInt CompilerC-45SchemeC-45Common-constPrimitives e-16 e-17 e-374)))))))) ((37) (let ((e-395 (cdr arg-2))) (let ((e-399 (cdr e-395))) (lambda (clam-66) (let ((e-402 (car e-399))) (let ((e-403 (cdr e-399))) (vector 1 e-402))))))) (else (let ((e-408 (cdr arg-2))) (lambda (clam-67) (let ((e-411 (car e-408))) (let ((e-412 (cdr e-408))) (vector 1 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(blodwen-error-quit (string-append \"ERROR: \" " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-411 (lambda (u--xs) (cons "))" u--xs)) eta-1)) eta-0)))))))))))
(define CompilerC-45SchemeC-45Common-n--11731-6258-u--getAltCode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-6 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-bindArgs arg-0 arg-1 arg-2 arg-7 e-4 0 e-3 e-5))))) eff-0) ext-0)))))))))
(define CompilerC-45SchemeC-45Common-schRecordCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-5) (vector 1 (lambda (u--xs) (cons "#f" u--xs))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) arg-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (let ((sc3 (CompilerC-45SchemeC-45Common-var arg-4))) (cond ((equal? sc3 1) (lambda (eta-0) (CompilerC-45SchemeC-45Common-n--11731-6258-u--getAltCode arg-0 arg-1 arg-2 arg-6 e-2 arg-4 arg-3 e-5 e-2 eta-0))) (else (lambda (eta-0) (let ((act-2 (CompilerC-45SchemeC-45Common-n--11731-6258-u--getAltCode arg-0 arg-1 arg-2 arg-6 e-2 arg-4 arg-3 u--n e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(let ((" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ")) " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))))))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Case of a record has multiple alternatives") clam-0))))))))
(define CompilerC-45SchemeC-45Common-schRecordCon (lambda (arg-0 arg-1 arg-2 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "(vector " eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " arg-2) (lambda (u--xs) (cons ")" u--xs)) eta-0)) ext-0)))
(define CompilerC-45SchemeC-45Common-toPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newIORef")))) (lambda () (vector 0 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__readIORef")))) (lambda () (vector 1 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__writeIORef")))) (lambda () (vector 2 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newArray")))) (lambda () (vector 3 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arrayGet")))) (lambda () (vector 4 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arraySet")))) (lambda () (vector 5 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__getField")))) (lambda () (vector 6 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__setField")))) (lambda () (vector 7 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__void")))) (lambda () (vector 8 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__os")))) (lambda () (vector 9 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__codegen")))) (lambda () (vector 10 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollect")))) (lambda () (vector 11 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollectAny")))) (lambda () (vector 12 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__makeFuture")))) (lambda () (vector 13 ))) '())))))))))))))) (lambda () (vector 14 arg-0)))))(else (vector 14 arg-0)))))
(define CompilerC-45SchemeC-45Common-n--11727-7717-u--listCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-1 (car arg-8))) (let ((e-4 (vector-ref e-1 1))) (case (vector-ref e-4 0) ((2) 1) ((3) 1)(else 0)))))))
(define CompilerC-45SchemeC-45Common-n--11727-7718-u--maybeCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-1 (car arg-8))) (let ((e-4 (vector-ref e-1 1))) (case (vector-ref e-4 0) ((5) 1) ((6) 1)(else 0)))))))
(define CompilerC-45SchemeC-45Common-n--11727-7719-u--recordCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-1 (car arg-8))) (let ((e-4 (vector-ref e-1 1))) (case (vector-ref e-4 0) ((7) 1)(else 0)))))))
(define CompilerC-45SchemeC-45Common-n--11727-7837-u--showConstAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) csegen-4898 (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-0) (if (null? e-2) (let ((act-1 (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 arg-2 (+ arg-6 1) arg-7 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11727-7837-u--showConstAlts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) e-6 eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-5 (cdr e-2))) (if (null? e-3) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-6 1) e-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(else " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))) eff-0) clam-0))))) (let ((act-1 (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 arg-2 (+ arg-6 1) arg-7 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11727-7837-u--showConstAlts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) e-7 eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CompilerC-45SchemeC-45Common-schExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schName e-1))))) ((1) (let ((e-3 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schName e-3))))) ((2) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(lambda (" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons ") " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-7 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0))))))))) ((3) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((e-10 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(let ((" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-8) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons ")) " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((4) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (case (vector-ref e-12 0) ((1) (let ((e-45 (vector-ref e-12 1))) (let ((e-46 (vector-ref e-12 2))) (if (null? e-13) (let ((u--x (vector 1 e-45 e-46))) (let ((sc3 (LibrariesC-45DataC-45SortedSet-contains e-46 arg-0))) (cond ((equal? sc3 1) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 u--x)) (else (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 u--x) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)))))) eff-0) eta-0)))))))))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 eta-2)) e-13 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-6) (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 eta-2)) e-13 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-6) (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((5) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (let ((e-17 (vector-ref arg-4 4))) (let ((e-18 (vector-ref arg-4 5))) (case (vector-ref e-16 0) ((2) (lambda (clam-0) (if (null? e-18) csegen-4954 (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad NIL") clam-0)))) ((3) (if (null? e-18) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad CONS") eta-0)) (let ((e-50 (car e-18))) (let ((e-51 (cdr e-18))) (lambda (clam-0) (if (null? e-51) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad CONS") clam-0) (let ((e-53 (car e-51))) (let ((e-54 (cdr e-51))) (if (null? e-54) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-50) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-53) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(cons " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad CONS") clam-0)))))))))) ((5) (lambda (clam-2) (if (null? e-18) csegen-4954 (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad NOTHING") clam-2)))) ((6) (lambda (clam-1) (if (null? e-18) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad JUST") clam-1) (let ((e-58 (car e-18))) (let ((e-59 (cdr e-18))) (if (null? e-59) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-58) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(box " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Bad JUST") clam-1))))))) ((7) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 eta-1)) e-18 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (CompilerC-45SchemeC-45Common-schRecordCon arg-2 e-15 e-5 eta-2)))))) eff-0) eta-0)))))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 eta-1)) e-18 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConstructor arg-2 e-15 e-17 e-5 eta-2)))))) eff-0) eta-0))))))))))))) ((6) (let ((e-21 (vector-ref arg-4 3))) (let ((e-22 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schArgs arg-0 arg-1 arg-2 arg-3 e-22) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45SchemeC-45Common-schOp e-21 e-5))) eff-0) eta-0))))))))) ((7) (let ((e-24 (vector-ref arg-4 2))) (let ((e-25 (vector-ref arg-4 3))) (((arg-1 arg-3) (CompilerC-45SchemeC-45Common-toPrim e-24)) e-25)))) ((8) (let ((e-28 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-28) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) ((9) (let ((e-31 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-31) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(lambda () " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) ((10) (let ((e-32 (vector-ref arg-4 1))) (let ((e-33 (vector-ref arg-4 2))) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (CoreC-45Core-cond (cons (cons (lambda () (CompilerC-45SchemeC-45Common-n--11727-7719-u--recordCase arg-0 arg-1 arg-2 e-35 e-34 e-33 e-32 arg-3 e-34)) (lambda () (CompilerC-45SchemeC-45Common-schRecordCase arg-0 arg-1 arg-2 arg-3 e-33 e-34 e-35))) (cons (cons (lambda () (CompilerC-45SchemeC-45Common-n--11727-7718-u--maybeCase arg-0 arg-1 arg-2 e-35 e-34 e-33 e-32 arg-3 e-34)) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-schMaybeCase arg-0 arg-1 arg-2 arg-3 e-33 e-34 e-35 eta-0)))) (cons (cons (lambda () (CompilerC-45SchemeC-45Common-n--11727-7717-u--listCase arg-0 arg-1 arg-2 e-35 e-34 e-33 e-32 arg-3 e-34)) (lambda () (lambda (eta-0) (CompilerC-45SchemeC-45Common-schListCase arg-0 arg-1 arg-2 arg-3 e-33 e-34 e-35 eta-0)))) '()))) (lambda () (CompilerC-45SchemeC-45Common-schCaseTree arg-0 arg-1 arg-2 arg-3 e-33 e-34 e-35)))))))) ((11) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (let ((e-38 (vector-ref arg-4 3))) (let ((e-39 (vector-ref arg-4 4))) (lambda (clam-4) (if (null? e-39) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) e-37) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (lambda (eta-0) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-0)))) (lambda (clam-5) (let ((sc3 (CompilerC-45SchemeC-45Common-var e-37))) (cond ((equal? sc3 1) (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11727-7837-u--showConstAlts arg-0 arg-1 arg-2 e-38 e-37 e-36 arg-3 e-5 e-38) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(cond " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))) eff-0) clam-5)))))) (else (let ((act-2 ((CompilerC-45SchemeC-45Common-n--11727-7837-u--showConstAlts arg-0 arg-1 arg-2 e-38 e-37 e-36 arg-3 u--n e-38) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(let ((" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ")) (cond " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons "))" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) clam-5)))))))))))) eff-0) clam-4))))) (let ((act-1 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--v) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 u--v) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-5))))) eff-0) eta-0)))))))) e-39) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 (+ arg-3 1) e-37) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--n (lambda (eta-1) (CompilerC-45SchemeC-45Common-getScrutineeTemp arg-3 eta-1)))) (lambda (clam-6) (let ((sc4 (CompilerC-45SchemeC-45Common-var e-37))) (cond ((equal? sc4 1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 arg-2 (+ arg-3 1) e-6 eta-1 eta-2))) e-38 '()) clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(cond " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (CompilerC-45SchemeC-45Common-schCaseDef e-5 eta-5)) (lambda (u--xs) (cons ")" u--xs)) eta-4)) eta-3)) eta-2)))))) eff-0) clam-6)))))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConstAlt arg-0 arg-1 arg-2 (+ arg-3 1) u--n eta-1 eta-2))) e-38 '()) clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(let ((" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--n (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ")) (cond " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (CompilerC-45SchemeC-45Common-schCaseDef e-5 eta-9)) (lambda (u--xs) (cons "))" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) clam-6)))))))))))) eff-0) eta-0)))))))) eff-0) clam-4)))))))))))) ((12) (let ((e-41 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schConstant arg-2 e-41))))) ((13) csegen-4957) (else (let ((e-44 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(blodwen-error-quit " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-493 e-44 eta-3)) (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))))))
(define CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "NewIORef") ((1) "ReadIORef") ((2) "WriteIORef") ((3) "NewArray") ((4) "ArrayGet") ((5) "ArraySet") ((6) "GetField") ((7) "SetField") ((8) "VoidElim") ((9) "SysOS") ((10) "SysCodegen") ((11) "OnCollect") ((12) "OnCollectAny") ((13) "MakeFuture") (else (let ((e-0 (vector-ref arg-0 1))) (string-append "Unknown " (CoreC-45Name-u--show_Show_Name e-0)))))))
(define CompilerC-45SchemeC-45Common-schExtCommon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-3 (cdr arg-5))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-0) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(box " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-7 (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-0))))))))))) ((1) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-13 (cdr arg-5))) (if (null? e-13) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-15 (car e-13))) (let ((e-16 (cdr e-13))) (lambda (clam-1) (if (null? e-16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-1) (let ((e-19 (cdr e-16))) (if (null? e-19) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-15) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(unbox " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-1))))))))))) ((2) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-23 (cdr arg-5))) (if (null? e-23) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-25 (car e-23))) (let ((e-26 (cdr e-23))) (if (null? e-26) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-28 (car e-26))) (let ((e-29 (cdr e-26))) (lambda (clam-2) (if (null? e-29) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-2) (let ((e-32 (cdr e-29))) (if (null? e-32) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-25) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-28) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(set-box! " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-2)))))))))))))) ((3) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-36 (cdr arg-5))) (if (null? e-36) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-38 (car e-36))) (let ((e-39 (cdr e-36))) (if (null? e-39) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-41 (car e-39))) (let ((e-42 (cdr e-39))) (lambda (clam-3) (if (null? e-42) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-3) (let ((e-45 (cdr e-42))) (if (null? e-45) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-38) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-41) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(make-vector " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-3))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-3)))))))))))))) ((4) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-49 (cdr arg-5))) (if (null? e-49) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-51 (car e-49))) (let ((e-52 (cdr e-49))) (if (null? e-52) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-54 (car e-52))) (let ((e-55 (cdr e-52))) (lambda (clam-4) (if (null? e-55) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-4) (let ((e-58 (cdr e-55))) (if (null? e-58) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-51) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-54) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(vector-ref " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-4))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-4)))))))))))))) ((5) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-62 (cdr arg-5))) (if (null? e-62) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-64 (car e-62))) (let ((e-65 (cdr e-62))) (if (null? e-65) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-67 (car e-65))) (let ((e-68 (cdr e-65))) (if (null? e-68) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-70 (car e-68))) (let ((e-71 (cdr e-68))) (lambda (clam-5) (if (null? e-71) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-5) (let ((e-74 (cdr e-71))) (if (null? e-74) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-64) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-67) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 arg-3 e-70) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(vector-set! " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons " " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-7 (lambda (u--xs) (cons ")" u--xs)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-5))))))))))))))))) ((8) (if (null? arg-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0)) (let ((e-78 (cdr arg-5))) (lambda (clam-6) (if (null? e-78) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-6) (let ((e-81 (cdr e-78))) (if (null? e-81) (vector 1 (lambda (eta-0) (cons "(display \"Error: Executed 'void'\")" eta-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-6)))))))) ((9) (lambda (clam-7) (if (null? arg-5) (vector 1 (lambda (eta-0) (cons "(blodwen-os)" eta-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) clam-7)))) ((14) (let ((e-0 (vector-ref arg-4 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't compile unknown external primitive " (CoreC-45Name-u--show_Show_Name e-0))) eta-0))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed external primitive " (string-append (CompilerC-45SchemeC-45Common-u--show_Show_ExtPrim arg-4) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1244) arg-5))))) eta-0))))))
(define CompilerC-45SchemeC-45Chez-showChezChar (lambda (arg-0 arg-1) (lambda (clam-0) (cond ((equal? arg-0 #\\) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\\\\" eta-0)) arg-1 clam-0))(else (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Int (cast-char-boundedInt arg-0 63) 32))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Int (cast-char-boundedInt arg-0 63) (blodwen-toSignedInt 126 63))))))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons (string-append "\\x" (string-append (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-0 64)) ";")) eta-0)) arg-1 clam-0)) (else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-char arg-0 eta-0)) arg-1 clam-0)))))))))
(define CompilerC-45SchemeC-45Chez-showChezString (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cond ((equal? e-2 #\") (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "\\\"" eta-1)) (CompilerC-45SchemeC-45Chez-showChezString e-3 arg-1) eta-0)))(else (CompilerC-45SchemeC-45Chez-showChezChar e-2 (CompilerC-45SchemeC-45Chez-showChezString e-3 arg-1)))))))))
(define CompilerC-45SchemeC-45Chez-chezString (lambda (arg-0 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\"" eta-0)) (CompilerC-45SchemeC-45Chez-showChezString (PreludeC-45Types-fastUnpack arg-0) (lambda (u--xs) (cons "\"" u--xs))) ext-0)))
(define csegen-5051 (lambda (eta-0) (lambda (eta-1) (CompilerC-45SchemeC-45Chez-chezString eta-0 eta-1))))
(define csegen-5111 (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "(blodwen-error-quit \"bad getField\")" eta-1)))))
(define csegen-5113 (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "(blodwen-error-quit \"bad setField\")" eta-1)))))
(define CompilerC-45SchemeC-45Chez-chezExtPrim (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((6) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (case (vector-ref e-1 0) ((12) (let ((e-20 (vector-ref e-1 2))) (case (vector-ref e-20 0) ((10) (let ((e-21 (vector-ref e-20 1))) (if (null? e-2) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))) (let ((e-24 (cdr e-2))) (if (null? e-24) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))) (let ((e-27 (cdr e-24))) (if (null? e-27) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (case (vector-ref e-32 0) ((12) (let ((e-35 (vector-ref e-32 2))) (case (vector-ref e-35 0) ((10) (let ((e-36 (vector-ref e-35 1))) (if (null? e-33) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))) (let ((e-39 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-1 eta-2 eta-3)))) csegen-5051 0 e-29) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(ftype-ref " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons e-21 eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " (" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-36 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ") " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-5111 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))))) ((7) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-42 (car arg-3))) (let ((e-43 (cdr arg-3))) (case (vector-ref e-42 0) ((12) (let ((e-67 (vector-ref e-42 2))) (case (vector-ref e-67 0) ((10) (let ((e-68 (vector-ref e-67 1))) (if (null? e-43) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-71 (cdr e-43))) (if (null? e-71) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-74 (cdr e-71))) (if (null? e-74) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-76 (car e-74))) (let ((e-77 (cdr e-74))) (if (null? e-77) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (case (vector-ref e-79 0) ((12) (let ((e-82 (vector-ref e-79 2))) (case (vector-ref e-82 0) ((10) (let ((e-83 (vector-ref e-82 1))) (if (null? e-80) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-86 (cdr e-80))) (if (null? e-86) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-92 (cdr e-89))) (if (null? e-92) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-1 eta-2 eta-3)))) csegen-5051 0 e-76) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-2 eta-3 eta-4)))) csegen-5051 0 e-88) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(ftype-set! " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons e-68 eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " (" eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons e-83 eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons ") " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons " " eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-5113 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))))))))))))))))))) ((10) (if (null? arg-3) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "\"chez\"" u--xs)))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))) ((11) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-97 (cdr arg-3))) (if (null? e-97) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-99 (car e-97))) (let ((e-100 (cdr e-97))) (if (null? e-100) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-102 (car e-100))) (let ((e-103 (cdr e-100))) (if (null? e-103) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-106 (cdr e-103))) (if (null? e-106) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-1 eta-2 eta-3)))) csegen-5051 0 e-99) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-2 eta-3 eta-4)))) csegen-5051 0 e-102) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(blodwen-register-object " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))))) ((12) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-109 (car arg-3))) (let ((e-110 (cdr arg-3))) (if (null? e-110) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-112 (car e-110))) (let ((e-113 (cdr e-110))) (if (null? e-113) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-116 (cdr e-113))) (if (null? e-116) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-1 eta-2 eta-3)))) csegen-5051 0 e-109) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-2 eta-3 eta-4)))) csegen-5051 0 e-112) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(blodwen-register-object " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))))) ((13) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-120 (cdr arg-3))) (if (null? e-120) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3) (let ((e-122 (car e-120))) (let ((e-123 (cdr e-120))) (if (null? e-123) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-1 eta-2 eta-3)))) csegen-5051 0 e-122) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(blodwen-make-future " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3))))))))(else (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim arg-0 eta-0 eta-1 eta-2)))) csegen-5051 arg-1 arg-2 arg-3)))))
(define csegen-5050 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Chez-chezExtPrim csegen-862 eta-0 eta-1 eta-2)))))
(define CompilerC-45Separate-u--C-61C-61_Eq_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 arg-1)))
(define CompilerC-45Separate-u--C-47C-61_Eq_CompilationUnitId (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Separate-u--C-61C-61_Eq_CompilationUnitId arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CompilerC-45Separate-u--compare_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int arg-0 arg-1)))
(define CompilerC-45Separate-u--C-60C-61_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 2)))
(define CompilerC-45Separate-u--C-60_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 0)))
(define CompilerC-45Separate-u--C-62C-61_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 0)))
(define CompilerC-45Separate-u--C-62_Ord_CompilationUnitId (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-0 arg-1) 2)))
(define CompilerC-45Separate-u--max_Ord_CompilationUnitId (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Separate-u--C-62_Ord_CompilationUnitId arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CompilerC-45Separate-u--min_Ord_CompilationUnitId (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Separate-u--C-60_Ord_CompilationUnitId arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define csegen-5070 (vector (cons (lambda (arg-676) (lambda (arg-679) (CompilerC-45Separate-u--C-61C-61_Eq_CompilationUnitId arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CompilerC-45Separate-u--C-47C-61_Eq_CompilationUnitId arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (CompilerC-45Separate-u--compare_Ord_CompilationUnitId arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (CompilerC-45Separate-u--C-60_Ord_CompilationUnitId arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (CompilerC-45Separate-u--C-62_Ord_CompilationUnitId arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (CompilerC-45Separate-u--C-60C-61_Ord_CompilationUnitId arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (CompilerC-45Separate-u--C-62C-61_Ord_CompilationUnitId arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (CompilerC-45Separate-u--max_Ord_CompilationUnitId arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (CompilerC-45Separate-u--min_Ord_CompilationUnitId arg-1626 arg-1629)))))
(define csegen-5071 (LibrariesC-45DataC-45SortedSet-empty csegen-4099))
(define CompilerC-45Separate-getNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0))(else CoreC-45NameC-45Namespace-emptyNS))))
(define LibrariesC-45DataC-45SortedSet-singleton (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedSet-insert arg-2 (LibrariesC-45DataC-45SortedSet-empty arg-1))))
(define PreludeC-45Types-u--foldr_Foldable_Maybe (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (unbox arg-4))) ((arg-2 e-2) arg-3)))))
(define PreludeC-45Types-u--foldMap_Foldable_Maybe (lambda (arg-2 arg-3 ext-0) (PreludeC-45Types-u--foldr_Foldable_Maybe (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 (arg-3 eta-0)) eta-1)))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConAlt (lambda (arg-0) (let ((e-4 (vector-ref arg-0 4))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-4))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConstAlt (lambda (arg-0) (let ((e-1 (cdr arg-0))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-1))))
(define csegen-5075 (cons (lambda (arg-8474) (lambda (arg-8477) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 arg-8474 arg-8477))) (LibrariesC-45DataC-45SortedSet-u--neutral_Monoid_C-40SortedSetC-32C-36kC-41 csegen-4099)))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp (lambda (arg-0) (case (vector-ref arg-0 0) ((0) csegen-5071) ((1) (let ((e-3 (vector-ref arg-0 2))) (LibrariesC-45DataC-45SortedSet-singleton csegen-4099 (CompilerC-45Separate-getNS e-3)))) ((2) (let ((e-6 (vector-ref arg-0 3))) ((csegen-5072) e-6))) ((3) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 ((csegen-5072) e-9) ((csegen-5072) e-10))))) ((4) (let ((e-12 (vector-ref arg-0 2))) (let ((e-13 (vector-ref arg-0 3))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 ((csegen-5072) e-12) (PreludeC-45Types-u--foldMap_Foldable_List csegen-5075 (csegen-5072) e-13))))) ((5) (let ((e-18 (vector-ref arg-0 5))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-5075 (csegen-5072) e-18))) ((8) (let ((e-21 (vector-ref arg-0 3))) ((csegen-5072) e-21))) ((9) (let ((e-24 (vector-ref arg-0 3))) ((csegen-5072) e-24))) ((13) csegen-5071) ((12) csegen-5071) ((6) (let ((e-31 (vector-ref arg-0 4))) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 csegen-5075 (csegen-5072) e-31))) ((7) (let ((e-34 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-5075 (csegen-5072) e-34))) ((10) (let ((e-36 (vector-ref arg-0 2))) (let ((e-37 (vector-ref arg-0 3))) (let ((e-38 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 ((csegen-5072) e-36) (PreludeC-45Types-u--foldMap_Foldable_List csegen-5075 (let ((eff-0 (lambda (arg-5104) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConAlt arg-5104)))) (lambda (arg-1) (eff-0 arg-1))) e-37)) (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-5075 (csegen-5072) e-38)))))) ((11) (let ((e-40 (vector-ref arg-0 2))) (let ((e-41 (vector-ref arg-0 3))) (let ((e-42 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-4099 ((csegen-5072) e-40) (PreludeC-45Types-u--foldMap_Foldable_List csegen-5075 (let ((eff-0 (lambda (arg-5104) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedConstAlt arg-5104)))) (lambda (arg-1) (eff-0 arg-1))) e-41)) (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-5075 (csegen-5072) e-42)))))) (else csegen-5071))))
(define csegen-5072 (lambda () (let ((eff-0 (lambda (arg-5104) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp arg-5104)))) (lambda (arg-0) (eff-0 arg-0)))))
(define csegen-5081 (LibrariesC-45DataC-45SortedMap-empty csegen-4099))
(define csegen-5135 (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "void*" u--xs)))))
(define csegen-5138 (cons "RefC" (cons "C" '())))
(define csegen-5139 (lambda (u--a) (string-append "arglist->args[" (string-append (PreludeC-45Show-u--show_Show_Nat u--a) "]"))))
(define LibrariesC-45DataC-45DList-snoc (lambda (arg-1 arg-2 ext-0) (arg-1 (cons arg-2 ext-0))))
(define csegen-5151 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (LibrariesC-45DataC-45DList-snoc eta-0 eta-1 eta-2)))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String (lambda (arg-0) (case (vector-ref arg-0 0) ((4) (let ((e-1 (vector-ref arg-0 1))) (box e-1)))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String (lambda (arg-0) (vector 4 arg-0)))
(define csegen-5198 (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String arg-1849))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toSignedInt e-1 63))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (lambda (arg-0) (vector 2 arg-0)))
(define csegen-5199 (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int arg-1849))))
(define csegen-5200 (cons csegen-5199 csegen-5199))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((sc1 (Builtin-fst arg-2))) (let ((e-3 (cdr sc1))) (e-3 e-1))) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((sc1 (Builtin-snd arg-2))) (let ((e-3 (cdr sc1))) (e-3 e-2))) (lambda (bind-1) (box (cons bind-0 bind-1)))))))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (box '())) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((e-4 (cdr arg-1))) (e-4 e-2)) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40ListC-32C-36aC-41 arg-1 e-3) (lambda (bind-1) (box (cons bind-0 bind-1)))))))))(else '()))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Namespace (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40ListC-32C-36aC-41 csegen-5198 arg-0) (lambda (bind-0) (box bind-0)))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((8) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (cond ((equal? e-1 0) (if (null? e-2) '() (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (if (null? e-9) '() (let ((e-11 (car e-9))) (let ((e-12 (cdr e-9))) (if (null? e-12) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Namespace e-8) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-11) (lambda (bind-1) (box (vector 0 bind-0 bind-1)))))) '())))))))) ((equal? e-1 2) (if (null? e-2) '() (let ((e-15 (car e-2))) (let ((e-16 (cdr e-2))) (if (null? e-16) '() (let ((e-18 (car e-16))) (let ((e-19 (cdr e-16))) (if (null? e-19) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-15) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-18) (lambda (bind-1) (box (vector 2 bind-0 bind-1)))))) '())))))))) ((equal? e-1 3) (if (null? e-2) '() (let ((e-22 (car e-2))) (let ((e-23 (cdr e-2))) (if (null? e-23) '() (let ((e-25 (car e-23))) (let ((e-26 (cdr e-23))) (if (null? e-26) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-22) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-25) (lambda (bind-1) (box (vector 3 bind-0 bind-1)))))) '())))))))) ((equal? e-1 4) (if (null? e-2) '() (let ((e-29 (car e-2))) (let ((e-30 (cdr e-2))) (if (null? e-30) '() (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (if (null? e-33) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-29) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-32) (lambda (bind-1) (box (vector 4 bind-0 bind-1)))))) '())))))))) ((equal? e-1 5) (if (null? e-2) '() (let ((e-36 (car e-2))) (let ((e-37 (cdr e-2))) (if (null? e-37) '() (let ((e-40 (cdr e-37))) (if (null? e-40) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-36) (lambda (bind-0) (box (vector 1 (vector 1 bind-0))))) '()))))))) ((equal? e-1 6) (if (null? e-2) '() (let ((e-43 (car e-2))) (let ((e-44 (cdr e-2))) (if (null? e-44) '() (let ((e-46 (car e-44))) (let ((e-47 (cdr e-44))) (if (null? e-47) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5200 e-43) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name e-46) (lambda (bind-1) (box (vector 5 bind-0 bind-1)))))) '())))))))) ((equal? e-1 7) (if (null? e-2) '() (let ((e-50 (car e-2))) (let ((e-51 (cdr e-2))) (if (null? e-51) '() (let ((e-53 (car e-51))) (let ((e-54 (cdr e-51))) (if (null? e-54) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-50) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-53) (lambda (bind-1) (box (vector 6 bind-0 bind-1)))))) '())))))))) ((equal? e-1 8) (if (null? e-2) '() (let ((e-57 (car e-2))) (let ((e-58 (cdr e-2))) (if (null? e-58) '() (let ((e-60 (car e-58))) (let ((e-61 (cdr e-58))) (if (null? e-61) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_String e-57) (lambda (bind-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int e-60) (lambda (bind-1) (box (vector 7 bind-0 bind-1)))))) '())))))))) ((equal? e-1 9) (if (null? e-2) (box (vector 1 (vector 2 ))) '()))(else '()))))) ((2) (let ((e-4 (vector-ref arg-0 1))) (box (vector 8 (blodwen-toSignedInt e-4 63))))) ((4) (let ((e-6 (vector-ref arg-0 1))) (box (vector 1 (vector 0 e-6)))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (vector 1 (let ((sc1 (Builtin-fst arg-2))) (let ((e-1 (car sc1))) (e-1 e-2))) (let ((sc1 (Builtin-snd arg-2))) (let ((e-1 (car sc1))) (e-1 e-3))))))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (if (null? arg-2) (vector 0 ) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (vector 1 (let ((e-1 (car arg-1))) (e-1 e-2)) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40ListC-32C-36aC-41 arg-1 e-3)))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Namespace (lambda (arg-0) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40ListC-32C-36aC-41 csegen-5198 arg-0)))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_UserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector 8 5 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-1) '())))) (else (vector 8 9 '())))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (vector 8 0 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Namespace e-0) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-1) '())))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_UserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (vector 8 2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-3) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (vector 8 3 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-6) '())))))) ((4) (let ((e-7 (vector-ref arg-0 1))) (let ((e-8 (vector-ref arg-0 2))) (vector 8 4 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-8) '())))))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (vector 8 6 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5200 e-9) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-10) '())))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (vector 8 7 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-11) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-12) '())))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (vector 8 8 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-13) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-14) '())))))) (else (let ((e-15 (vector-ref arg-0 1))) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-15))))))
(define csegen-5205 (cons (lambda (arg-1843) (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-1843)) (lambda (arg-1849) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name arg-1849))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Integer (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box e-1)))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Integer (lambda (arg-0) (vector 2 arg-0)))
(define csegen-5206 (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Integer arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Integer arg-1849))))
(define csegen-5207 (cons csegen-5205 csegen-5206))
(define csegen-5211 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 0 eta-0 eta-1 eta-2 eta-3))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_ModuleIdent (lambda (arg-0) (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Namespace arg-0)))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_OriginDesc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (vector 8 0 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_ModuleIdent e-0) '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector 8 1 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_String e-1) '())))) (else (vector 0 )))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (vector 8 0 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_OriginDesc e-0) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5200 e-1) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5200 e-2) '())))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (vector 8 1 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_OriginDesc e-3) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5200 e-4) (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5200 e-5) '())))))))) (else (vector 0 )))))
(define csegen-5241 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC CoreC-45FC-emptyFC) '()))
(define CoreC-45SchemeEvalC-45Compile-n--7242-1701-u--okchar (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\_)))))) (cond ((equal? sc0 1) (string arg-1)) (else (string-append "C-" (PreludeC-45Show-u--show_Show_Int (cast-char-boundedInt arg-1 63))))))))
(define CoreC-45SchemeEvalC-45Compile-schString (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (CoreC-45SchemeEvalC-45Compile-n--7242-1701-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0))))
(define CoreC-45SchemeEvalC-45Compile-schVarUN (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45SchemeEvalC-45Compile-schString e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "rf--" (CoreC-45SchemeEvalC-45Compile-schString e-1)))) (else "_US_"))))
(define CoreC-45SchemeEvalC-45Compile-schVarName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((1) (let ((e-16 (vector-ref e-1 1))) (string-append (CoreC-45SchemeEvalC-45Compile-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (string-append "-" (CoreC-45SchemeEvalC-45Compile-schVarUN e-16)))))(else (string-append (CoreC-45SchemeEvalC-45Compile-schString (CoreC-45NameC-45Namespace-showNSWithSep "-" e-0)) (string-append "-" (CoreC-45SchemeEvalC-45Compile-schVarName e-1)))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (string-append "u--" (CoreC-45SchemeEvalC-45Compile-schVarUN e-2)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (string-append (CoreC-45SchemeEvalC-45Compile-schString e-3) (string-append "-" (PreludeC-45Show-u--show_Show_Int e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (string-append "pat--" (CoreC-45SchemeEvalC-45Compile-schVarName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CoreC-45SchemeEvalC-45Compile-schVarName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-19 (car e-9))) (let ((e-20 (cdr e-9))) (string-append "n--" (string-append (PreludeC-45Show-u--show_Show_Int e-19) (string-append "-" (string-append (PreludeC-45Show-u--show_Show_Int e-20) (string-append "-" (CoreC-45SchemeEvalC-45Compile-schVarName e-10))))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (string-append "case--" (string-append (CoreC-45SchemeEvalC-45Compile-schString e-11) (string-append "-" (PreludeC-45Show-u--show_Show_Int e-12))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (string-append "with--" (string-append (CoreC-45SchemeEvalC-45Compile-schString e-13) (string-append "-" (PreludeC-45Show-u--show_Show_Int e-14))))))) (else (let ((e-15 (vector-ref arg-0 1))) (string-append "fn--" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define csegen-5242 (lambda (eta-0) (vector 11 (CoreC-45SchemeEvalC-45Compile-schVarName eta-0))))
(define csegen-5272 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "\\")))
(define CoreC-45CompileExprC-45Pretty-prettyNamedCExp (lambda (ext-0) (CoreC-45CompileExprC-45Pretty-prettyPrecNamedCExp (vector 0 ) ext-0)))
(define CoreC-45CompileExprC-45Pretty-prettyAlts (lambda (arg-1 arg-2 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-u--zipWith_Zippable_List (lambda (u--s) (lambda (u--p) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 u--s (arg-1 u--p)))) (cons csegen-943 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) csegen-921) arg-2)) arg-2) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--deflt) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "; _")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2735 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (CoreC-45CompileExprC-45Pretty-prettyNamedCExp u--deflt)))) '()))) arg-3) (cons csegen-927 '()))))))
(define CoreC-45CompileExpr-u--showPrec_Show_ConInfo (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_ConInfo arg-1)))
(define CoreC-45CompileExprC-45Pretty-prettyFlag (lambda (arg-1) (case (vector-ref arg-1 0) ((0) '())(else (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_ConInfo u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_ConInfo u--d u--x)))) arg-1))))))
(define CoreC-45CompileExprC-45Pretty-prettyCon (lambda (arg-0 arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (DataC-45List-catMaybes (cons (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (let ((sc0 (CoreC-45CompileExpr-u--C-61C-61_Eq_ConInfo arg-1 (vector 1 )))) (cond ((equal? sc0 1) (vector 1 (box arg-0))) (else (vector 2 (box arg-0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "tag =") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 eta-0)))) arg-2) (cons (CoreC-45CompileExprC-45Pretty-prettyFlag arg-1) '())))))))
(define CoreC-45CompileExprC-45Pretty-prettyName (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-group (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep ext-0))))
(define CoreC-45CompileExprC-45Pretty-prettyNamedConAlt (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons (CoreC-45CompileExprC-45Pretty-prettyCon e-0 e-1 e-2) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExprC-45Pretty-prettyName eta-0)) e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2735 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-4))) '())))))))))))
(define CoreC-45CompileExprC-45Pretty-prettyNamedConstAlt (lambda (arg-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-2735 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-1))))))))
(define CoreC-45TTC-45Primitive-prettyOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-20 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "+")) e-24))))))) ((1) (let ((e-29 (car arg-2))) (let ((e-30 (cdr arg-2))) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-29 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "-")) e-33))))))) ((2) (let ((e-38 (car arg-2))) (let ((e-39 (cdr arg-2))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-38 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "*")) e-42))))))) ((3) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-47 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`div`")) e-51))))))) ((4) (let ((e-56 (car arg-2))) (let ((e-57 (cdr arg-2))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-56 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`mod`")) e-60))))))) ((5) (let ((e-65 (car arg-2))) (let ((e-66 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "-")) e-65)))) ((6) (let ((e-70 (car arg-2))) (let ((e-71 (cdr arg-2))) (let ((e-74 (car e-71))) (let ((e-75 (cdr e-71))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "shiftl")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-70 e-74))))))) ((7) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "shiftr")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-79 e-83))))))) ((8) (let ((e-88 (car arg-2))) (let ((e-89 (cdr arg-2))) (let ((e-92 (car e-89))) (let ((e-93 (cdr e-89))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-88 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "&&")) e-92))))))) ((9) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-97 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "||")) e-101))))))) ((10) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-106 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`xor`")) e-110))))))) ((11) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-115 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "<")) e-119))))))) ((12) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-124 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "<=")) e-128))))))) ((13) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-133 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "==")) e-137))))))) ((14) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-142 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ">=")) e-146))))))) ((15) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-151 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ">")) e-155))))))) ((16) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "length")) e-160)))) ((17) (let ((e-165 (car arg-2))) (let ((e-166 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "head")) e-165)))) ((18) (let ((e-170 (car arg-2))) (let ((e-171 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "tail")) e-170)))) ((19) (let ((e-175 (car arg-2))) (let ((e-176 (cdr arg-2))) (let ((e-179 (car e-176))) (let ((e-180 (cdr e-176))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-175 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "[")) e-179) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "]"))))))))) ((20) (let ((e-184 (car arg-2))) (let ((e-185 (cdr arg-2))) (let ((e-188 (car e-185))) (let ((e-189 (cdr e-185))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-184 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "::")) e-188))))))) ((21) (let ((e-193 (car arg-2))) (let ((e-194 (cdr arg-2))) (let ((e-197 (car e-194))) (let ((e-198 (cdr e-194))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-193 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "++")) e-197))))))) ((22) (let ((e-202 (car arg-2))) (let ((e-203 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "reverse")) e-202)))) ((23) (let ((e-207 (car arg-2))) (let ((e-208 (cdr arg-2))) (let ((e-211 (car e-208))) (let ((e-212 (cdr e-208))) (let ((e-215 (car e-212))) (let ((e-216 (cdr e-212))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-207 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "[")) e-211) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ","))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-215 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "]")))))))))))) ((24) (let ((e-220 (car arg-2))) (let ((e-221 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "exp")) e-220)))) ((25) (let ((e-225 (car arg-2))) (let ((e-226 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "log")) e-225)))) ((26) (let ((e-230 (car arg-2))) (let ((e-231 (cdr arg-2))) (let ((e-234 (car e-231))) (let ((e-235 (cdr e-231))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-230 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "`pow`")) e-234))))))) ((27) (let ((e-239 (car arg-2))) (let ((e-240 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "sin")) e-239)))) ((28) (let ((e-244 (car arg-2))) (let ((e-245 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "cos")) e-244)))) ((29) (let ((e-249 (car arg-2))) (let ((e-250 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "tan")) e-249)))) ((30) (let ((e-254 (car arg-2))) (let ((e-255 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "asin")) e-254)))) ((31) (let ((e-259 (car arg-2))) (let ((e-260 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "acos")) e-259)))) ((32) (let ((e-264 (car arg-2))) (let ((e-265 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "atan")) e-264)))) ((33) (let ((e-269 (car arg-2))) (let ((e-270 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "sqrt")) e-269)))) ((34) (let ((e-274 (car arg-2))) (let ((e-275 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "floor")) e-274)))) ((35) (let ((e-279 (car arg-2))) (let ((e-280 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "ceiling")) e-279)))) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (let ((e-284 (car arg-2))) (let ((e-285 (cdr arg-2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "[")) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_PrimType e-16)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "->")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_PrimType e-17) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "]"))) e-284)))))))) ((37) (let ((e-289 (car arg-2))) (let ((e-290 (cdr arg-2))) (let ((e-293 (car e-290))) (let ((e-294 (cdr e-290))) (let ((e-297 (car e-294))) (let ((e-298 (cdr e-294))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "believe_me")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-289 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-293 e-297)))))))))) (else (let ((e-302 (car arg-2))) (let ((e-303 (cdr arg-2))) (let ((e-306 (car e-303))) (let ((e-307 (cdr e-303))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "crash")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 e-302 e-306))))))))))
(define CoreC-45TTC-45Term-u--showPrec_Show_LazyReason (lambda (arg-0 arg-1) (CoreC-45TTC-45Term-u--show_Show_LazyReason arg-1)))
(define csegen-5277 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_LazyReason u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_LazyReason u--d u--x)))))
(define CoreC-45CompileExprC-45Pretty-prettyPrecNamedCExp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (CoreC-45CompileExprC-45Pretty-prettyName e-1)))) ((1) (let ((e-3 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 e-3) (CoreC-45CompileExprC-45Pretty-prettyName e-3)))) ((2) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-5272 (CoreC-45CompileExprC-45Pretty-prettyName e-5)) IdrisC-45PrettyC-45Annotations-fatArrow) (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-6)))))) ((3) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (let ((e-10 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-let_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CompileExprC-45Pretty-prettyName e-8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-9) IdrisC-45PrettyC-45Annotations-in_)))) (cons (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-10) '())))))))) ((4) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-12) (PreludeC-45TypesC-45List-mapAppend '() (csegen-5273) e-13))))))) ((5) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (let ((e-18 (vector-ref arg-1 5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons (CoreC-45CompileExprC-45Pretty-prettyCon e-15 e-16 e-17) (PreludeC-45TypesC-45List-mapAppend '() (csegen-5273) e-18))))))))) ((6) (let ((e-21 (vector-ref arg-1 3))) (let ((e-22 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (CoreC-45TTC-45Primitive-prettyOp e-21 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (csegen-5273) e-22)))))) ((7) (let ((e-24 (vector-ref arg-1 2))) (let ((e-25 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 e-24) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-24)) (PreludeC-45TypesC-45List-mapAppend '() (csegen-5273) e-25))))))) ((8) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Force")) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-5277 e-27) (cons (CoreC-45CompileExprC-45Pretty-prettyPrecNamedCExp (vector 6 ) e-28) '())))))))) ((9) (let ((e-30 (vector-ref arg-1 2))) (let ((e-31 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons csegen-2728 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-5277 e-30) (cons (CoreC-45CompileExprC-45Pretty-prettyPrecNamedCExp (vector 6 ) e-31) '())))))))) ((10) (let ((e-33 (vector-ref arg-1 2))) (let ((e-34 (vector-ref arg-1 3))) (let ((e-35 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-case_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-33) IdrisC-45PrettyC-45Annotations-of_)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (CoreC-45CompileExprC-45Pretty-prettyAlts (lambda (eta-0) (CoreC-45CompileExprC-45Pretty-prettyNamedConAlt eta-0)) e-34 e-35)) '())))))))) ((11) (let ((e-37 (vector-ref arg-1 2))) (let ((e-38 (vector-ref arg-1 3))) (let ((e-39 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-case_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CompileExprC-45Pretty-prettyNamedCExp e-37) IdrisC-45PrettyC-45Annotations-of_)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (CoreC-45CompileExprC-45Pretty-prettyAlts (lambda (eta-0) (CoreC-45CompileExprC-45Pretty-prettyNamedConstAlt eta-0)) e-38 e-39)) '())))))))) ((12) (let ((e-41 (vector-ref arg-1 2))) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant e-41))) ((13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "___")) (else (let ((e-44 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parenthesise (PreludeC-45Show-u--C-62_Ord_Prec arg-0 (vector 0 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "crash")) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-493 e-44) '())))))))))
(define csegen-5273 (lambda () (lambda (eta-0) (CoreC-45CompileExprC-45Pretty-prettyPrecNamedCExp (vector 6 ) eta-0))))
(define csegen-5517 (cons csegen-3096 csegen-495))
(define ParserC-45RuleC-45Package-dotC-39 (vector 1 "Expected dot" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-integerLit (vector 1 "Expected integer" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((14) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define csegen-5522 (LibrariesC-45TextC-45Parser-sepBy1 1 ParserC-45RuleC-45Package-dotC-39 ParserC-45RuleC-45Package-integerLit))
(define csegen-5541 (lambda (eta-0) (lambda (eta-1) (vector 15 eta-0 eta-1))))
(define ParserC-45RuleC-45Package-exactProperty (lambda (arg-0) (vector 1 (string-append "Expected property " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (if (null? e-0) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 e-1))) (cond ((equal? sc2 1) (box arg-0)) (else '()))) '()))))(else '()))))))
(define csegen-5551 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "version")))
(define csegen-5683 (vector 1 (vector 0 (vector 28 (vector 0 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)))))
(define csegen-5684 (vector 1 (vector 0 (vector 6 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))
(define IdrisC-45Parser-extractNames (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-2 (vector-ref arg-0 1))) e-2)) (else (let ((e-4 (vector-ref arg-0 1))) (cons e-4 '()))))))
(define IdrisC-45Parser-n--32911-26165-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define LibrariesC-45TextC-45Parser-choiceMap (lambda (arg-5 arg-6 arg-7 arg-8) (let ((e-1 (vector-ref arg-7 0))) (((((e-1 'erased) 'erased) (lambda (u--x) (lambda (u--acc) (vector 13 arg-5 arg-5 (arg-6 u--x) (lambda () u--acc))))) (vector 4 '() 0 "No more options")) arg-8))))
(define LibrariesC-45TextC-45Parser-choice (lambda (arg-4 arg-5 ext-0) (LibrariesC-45TextC-45Parser-choiceMap arg-5 (lambda (eta-0) eta-0) arg-4 ext-0)))
(define IdrisC-45Parser-replCmd (lambda (arg-0) (if (null? arg-0) (vector 4 '() 0 "Unrecognised command") (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (vector 13 1 1 (ParserC-45RuleC-45Source-exactIdent e-2) (lambda () (vector 13 1 1 (ParserC-45RuleC-45Source-symbol e-2) (lambda () (IdrisC-45Parser-replCmd e-3))))))))))
(define IdrisC-45Parser-runParseCmd (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (IdrisC-45Parser-replCmd e-0))) ((1) (let ((e-2 (vector-ref arg-0 1))) (LibrariesC-45TextC-45Parser-choice csegen-14 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45RuleC-45Source-keyword eta-0)) e-2)))) (else (let ((e-4 (vector-ref arg-0 1))) (ParserC-45RuleC-45Source-exactIdent e-4))))))
(define IdrisC-45Parser-n--32911-26164-u--autoNumber (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) '()) (ParserC-45RuleC-45Source-keyword "auto")) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (box (PreludeC-45Types-prim__integerToNat eta-0))) ParserC-45RuleC-45Source-intLit)))))
(define IdrisC-45Parser-n--32911-26166-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-n--32911-26164-u--autoNumber arg-0 arg-1 arg-2)) (lambda () (lambda (u--mi) (vector 0 (arg-1 u--mi)))))))))))
(define IdrisC-45Parser-autoNumberArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32911-26165-u--names arg-2 arg-1 arg-0) (cons (vector 6 ) (cons arg-2 (IdrisC-45Parser-n--32911-26166-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33076-26340-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33076-26341-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 1 (vector 8 ParserC-45RuleC-45Source-unqualifiedName) (lambda () (lambda (u--n) (vector 9 0 (vector 8 (IdrisC-45Parser-expr IdrisC-45Parser-pdef (vector 2 (vector 0 )) ParserC-45RuleC-45Source-init)) (lambda () (lambda (u--tm) (vector 0 ((arg-1 u--tm) u--n))))))))))))))
(define IdrisC-45Parser-compileArgsCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33076-26340-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 8 ) (cons (vector 2 ) '()))) (cons arg-2 (IdrisC-45Parser-n--33076-26341-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--32707-25954-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--32707-25955-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-topDecl (vector 2 (vector 0 )) ParserC-45RuleC-45Source-init)) (lambda () (lambda (u--tm) (vector 0 (arg-1 u--tm)))))))))))
(define IdrisC-45Parser-declsArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32707-25954-u--names arg-2 arg-1 arg-0) (cons (vector 4 ) (cons arg-2 (IdrisC-45Parser-n--32707-25955-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--32363-25604-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define ParserC-45RuleC-45Source-anyReservedSymbol (vector 1 "Expected a reserved symbol" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((12) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) e-0) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45Types-elem csegen-14 csegen-22 e-0 ParserC-45LexerC-45Source-reservedSymbols)))))(else '())))))
(define ParserC-45RuleC-45Source-moduleIdent (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) eta-0) ParserC-45RuleC-45Source-namespaceId))
(define IdrisC-45Parser-n--32380-25608-u--placeholeder (lambda (arg-0 arg-1 arg-2) (vector 21 (vector 2 ) 0 "lazyDocPlaceholeder")))
(define IdrisC-45Parser-n--32363-25603-u--docLazyPrim (lambda (arg-0 arg-1 arg-2) (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "Lazy") (lambda () (vector 0 (vector 11 (vector 2 ) 1 (IdrisC-45Parser-n--32380-25608-u--placeholeder arg-0 arg-1 arg-2))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "Inf") (lambda () (vector 0 (vector 11 (vector 2 ) 0 (IdrisC-45Parser-n--32380-25608-u--placeholeder arg-0 arg-1 arg-2))))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "Delay") (lambda () (vector 0 (vector 12 (vector 2 ) (IdrisC-45Parser-n--32380-25608-u--placeholeder arg-0 arg-1 arg-2))))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "Force") (lambda () (vector 0 (vector 13 (vector 2 ) (IdrisC-45Parser-n--32380-25608-u--placeholeder arg-0 arg-1 arg-2)))))))))))))
(define IdrisC-45Parser-n--32363-25605-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) (vector 4 eta-1))) (ParserC-45RuleC-45Source-keyword "module")) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f ParserC-45RuleC-45Source-moduleIdent))) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 eta-0)) ParserC-45RuleC-45Source-anyKeyword) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 1 eta-0)) (vector 13 1 1 (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) ParserC-45RuleC-45Source-anyReservedSymbol) csegen-4256) (lambda () (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (IdrisC-45Parser-parens 1 (vector 2 (vector 0 )) ParserC-45RuleC-45Source-anyReservedSymbol)) csegen-4256)))) (lambda () (vector 13 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 2 eta-0)) (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 0) (ParserC-45RuleC-45Source-symbol "[|"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol "|]")))) (lambda () (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (ParserC-45RuleC-45Source-symbol "`{"))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol "}")))) (lambda () (vector 13 1 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 2) (ParserC-45RuleC-45Source-symbol "`("))) csegen-4273) (lambda () (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 3) (ParserC-45RuleC-45Source-symbol "`["))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (ParserC-45RuleC-45Source-symbol "]"))))))))))) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 3 eta-0)) (vector 13 1 1 (IdrisC-45Parser-n--32363-25603-u--docLazyPrim arg-0 arg-1 arg-2) (lambda () csegen-4244)))))))))))) (lambda () (lambda (u--dir) (vector 0 (arg-1 u--dir)))))))))))
(define IdrisC-45Parser-docArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32363-25604-u--names arg-2 arg-1 arg-0) (cons (vector 3 ) (cons arg-2 (IdrisC-45Parser-n--32363-25605-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33376-26660-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33376-26661-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 10 0 1 csegen-4238 (lambda (u--upd) (vector 9 1 csegen-4239 (lambda () (lambda (u--line) (vector 9 1 csegen-4239 (lambda () (lambda (u--col) (vector 9 0 (vector 8 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 28 ((((arg-1 u--upd) u--line) u--col) u--n))))))))))))))))))))
(define IdrisC-45Parser-editLineColNameArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33376-26660-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 12 "l" (vector 5 )) (cons (vector 12 "c" (vector 5 )) csegen-4685))) (cons arg-2 (IdrisC-45Parser-n--33376-26661-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33241-26515-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33241-26516-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 10 0 1 csegen-4238 (lambda (u--upd) (vector 9 1 csegen-4239 (lambda () (lambda (u--line) (vector 9 0 (vector 8 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (vector 28 (((arg-1 u--upd) u--line) u--n)))))))))))))))))
(define IdrisC-45Parser-editLineNameArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33241-26515-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 12 "l" (vector 5 )) csegen-4685)) (cons arg-2 (IdrisC-45Parser-n--33241-26516-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33707-27008-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33707-27009-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 10 0 1 csegen-4238 (lambda (u--upd) (vector 9 1 csegen-4239 (lambda () (lambda (u--line) (vector 9 0 (vector 8 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 0 (vector 8 (LibrariesC-45TextC-45Parser-sepBy 1 (ParserC-45RuleC-45Source-symbol ",") ParserC-45RuleC-45Source-name)) (lambda (u--hints) (vector 0 (vector 28 ((((arg-1 u--upd) u--line) u--n) u--hints)))))))))))))))))))
(define IdrisC-45Parser-editLineNameCSVArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33707-27008-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 12 "l" (vector 5 )) (cons (vector 12 "n" (vector 10 )) (cons (vector 12 "h" (vector 14 (vector 1 ))) '())))) (cons arg-2 (IdrisC-45Parser-n--33707-27009-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33872-27180-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33872-27181-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 10 0 1 csegen-4238 (lambda (u--upd) (vector 9 1 csegen-4239 (lambda () (lambda (u--line) (vector 9 0 (vector 8 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 10 0 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) (LibrariesC-45TextC-45Parser-option 1 0 ParserC-45RuleC-45Source-intLit)) (lambda (u--nreject) (vector 0 (vector 28 ((((arg-1 u--upd) u--line) u--n) u--nreject)))))))))))))))))))
(define IdrisC-45Parser-editLineNameOptionArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33872-27180-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 12 "l" (vector 5 )) (cons (vector 12 "n" (vector 10 )) (cons (vector 12 "r" (vector 13 "0" (vector 5 ))) '())))) (cons arg-2 (IdrisC-45Parser-n--33872-27181-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33544-26837-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33544-26838-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 10 0 1 csegen-4238 (lambda (u--upd) (vector 9 1 csegen-4239 (lambda () (lambda (u--line) (vector 9 1 (vector 8 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--h) (vector 9 0 csegen-4245 (lambda () (lambda (u--n) (vector 0 (vector 28 ((((arg-1 u--upd) u--line) u--h) u--n))))))))))))))))))))
(define IdrisC-45Parser-editLineNamePTermArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33544-26837-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 12 "l" (vector 5 )) (cons (vector 12 "c" (vector 5 )) (cons (vector 12 "h" (vector 10 )) (cons (vector 12 "e" (vector 2 )) '()))))) (cons arg-2 (IdrisC-45Parser-n--33544-26838-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--32296-25534-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--32296-25535-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 csegen-4245 (lambda () (lambda (u--tm) (vector 0 (arg-1 u--tm)))))))))))
(define IdrisC-45Parser-exprArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32296-25534-u--names arg-2 arg-1 arg-0) (cons (vector 2 ) (cons arg-2 (IdrisC-45Parser-n--32296-25535-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--30950-24171-u--explain (lambda (arg-0 arg-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--s) (cons u--s arg-1)) arg-0)))
(define IdrisC-45Parser-knownCommands (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4338 "Check the type of an expression") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "ti" "Check the type of an expression, showing implicit arguments") (cons (cons "printdef" "Show the definition of a pattern-matching function") '())) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4343 "Search for values by type") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "di" "Show debugging information for a name") '()) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4347 "Import an extra module") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "package" "Import every module of the package") '()) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4352 "Exit the Idris system") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "cwd" "Displays the current working directory") (cons (cons "cd" "Change the current working directory") (cons (cons "sh" "Run a shell command") (cons (cons "set" (DataC-45String-fastUnlines (cons "Set an option" (cons "  eval                specify what evaluation mode to use:" (cons "                        typecheck|tc" (cons "                        normalise|normalize|normal" (cons "                        execute|exec" (cons "                        scheme" (cons "" (cons "  editor              specify the name of the editor command" (cons "" (cons "  cg                  specify the codegen/backend to use" (cons "                      builtin codegens are:" (cons "                        chez" (cons "                        racket" (cons "                        refc" (cons "                        node" (cons "" (cons "  showimplicits       enable displaying implicit arguments as part of the" (cons "                      output" (cons "" (cons "  shownamespace       enable displaying namespaces as part of the output" (cons "" (cons "  showmachinenames    enable displaying machine names as part of the" (cons "                      output" (cons "" (cons "  showtypes           enable displaying the type of the term as part of" (cons "                      the output" (cons "" (cons "  profile" (cons "" (cons "  evaltiming          enable timing how long evaluation takes and" (cons "                      displaying this before the printing of the output" '()))))))))))))))))))))))))))))))))) (cons (cons "unset" "Unset an option") (cons (cons "opts" "Show current options settings") '())))))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4361 "Compile to an executable") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "exec" "Compile to an executable and run") (cons (cons "directive" "Set a codegen-specific directive") '())) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4367 "Load a file") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4370 "Reload current file") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4373 "Edit current file using $EDITOR or $VISUAL") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4376 "Show missing clauses") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "total" "Check the totality of a name") (cons (cons "doc" "Show documentation for a keyword, a name, or a primitive") (cons (cons "browse" "Browse contents of a namespace") '()))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4382 "Set logging level") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "consolewidth" "Set the width of the console output (0 for unbounded) (auto by default)") '()) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4386 "Whether to use colour for the console output (enabled by default)") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4389 "Show remaining proof obligations (metavariables or holes)") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "typeat" "Show type of term <n> defined on line <l> and column <c>") '()) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4395 "Case split term <n> defined on line <l> and column <c>") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4399 "Add clause to term <n> defined on line <l>") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4403 "Make lemma for term <n> defined on line <l>") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4407 "Make case on term <n> defined on line <l>") (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4411 "Add with expression on term <n> defined on line <l>") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "intro" "Introduce unambiguous constructor in hole <n> defined on line <l>") (cons (cons "refine" "Refine hole <h> with identifier <n> on line <l> and column <c>") '())) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4419 "Search for a proof") (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "psnext" "Show next proof") (cons (cons "gd" "Try to generate a definition using proof-search") (cons (cons "gdnext" "Show next definition") (cons (cons "version" "Display the Idris version") '())))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Parser-n--30950-24171-u--explain csegen-4429 (DataC-45String-fastUnlines (cons "Display help text, optionally of a specific command.\xa;" (cons "If run without arguments, lists all the REPL commands along with their" (cons "initial line of help text.\xa;" (cons "More detailed help can then be obtained by running the :help command" (cons "with another command as an argument, e.g." (cons "  > :help :help" (cons "  > :help :set" (cons "(the leading ':' in the command argument is optional)" '())))))))))) (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "let" (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Define a new value.\xa;\xa;First, declare the type of your new value, e.g.\xa;  :let myValue : List Nat\xa;\xa;Then, define the value:\xa;  :let myValue = [1, 2, 3]\xa;\xa;Now the value is in scope at the REPL:\xa;  > map (+ 2) myValue\xa;  [3, 4, 5]" '()))) '()) (IdrisC-45Parser-n--30950-24171-u--explain csegen-4433 "Search for global definitions by sketching the names distribution of the wanted type(s)."))))))))))))))))))))))))))))))))
(define IdrisC-45Parser-firstHelpLine (lambda (arg-0) (let ((sc0 (DataC-45String-split (lambda (eta-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char (integer->char 10) eta-0)) (DataC-45Maybe-fromMaybe (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Failed to look up '" (cons arg-0 (cons "' (SHOULDN'T HAPPEN!)" '()))))) (DataC-45List-lookup csegen-22 arg-0 IdrisC-45Parser-knownCommands))))) (let ((e-1 (car sc0))) e-1))))
(define IdrisC-45Parser-n--32170-25405-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-cmdName (lambda (arg-0) (vector 10 0 1 (LibrariesC-45TextC-45Parser-optional 1 (ParserC-45RuleC-45Source-symbol ":")) (lambda (u--_) (vector 1 (string-append "Unrecognised REPL command '" (string-append arg-0 "'")) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))) (cond ((equal? sc1 1) (box e-0)) (else '()))))) ((18) (let ((e-1 (vector-ref lcase-0 1))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 arg-0))) (cond ((equal? sc1 1) (box e-1)) (else '()))))) ((12) (let ((e-2 (vector-ref lcase-0 1))) (cond ((equal? e-2 "?") (box "?")) ((equal? e-2 ":?") (box "?"))(else '()))))(else '()))))))))
(define IdrisC-45Parser-getHelpType (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (LibrariesC-45TextC-45Parser-choice csegen-14 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Parser-cmdName (Builtin-fst eta-0))) IdrisC-45Parser-knownCommands))) (lambda (u--optCmd) (vector 0 (if (null? u--optCmd) '() (let ((e-2 (unbox u--optCmd))) (box (DataC-45Maybe-fromMaybe (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Unrecognised command '" (cons e-2 (cons "'" '()))))) (DataC-45List-lookup csegen-22 e-2 IdrisC-45Parser-knownCommands)))))))))
(define IdrisC-45Parser-n--32170-25406-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 10 0 0 IdrisC-45Parser-getHelpType (lambda (u--helpType) (vector 0 (arg-1 u--helpType))))))))))
(define IdrisC-45Parser-helpCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32170-25405-u--names arg-2 arg-1 arg-0) (cons (vector 10 ) (cons arg-2 (IdrisC-45Parser-n--32170-25406-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33167-26431-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--33167-26432-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-logLevel (vector 2 (vector 0 )))) (lambda () (lambda (u--lvl) (vector 0 (arg-1 u--lvl)))))))))))
(define IdrisC-45Parser-loggingArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33167-26431-u--names arg-2 arg-1 arg-0) (cons (vector 15 (cons (vector 10 ) (cons (vector 5 ) '()))) (cons arg-2 (IdrisC-45Parser-n--33167-26432-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--32231-25467-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--32231-25468-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 ParserC-45RuleC-45Source-moduleIdent) (lambda () (lambda (u--n) (vector 0 (arg-1 u--n)))))))))))
(define IdrisC-45Parser-moduleArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32231-25467-u--names arg-2 arg-1 arg-0) (cons (vector 9 ) (cons arg-2 (IdrisC-45Parser-n--32231-25468-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--31964-25193-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--31964-25194-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 ParserC-45RuleC-45Source-name) (lambda () (lambda (u--n) (vector 0 (arg-1 u--n)))))))))))
(define IdrisC-45Parser-nameArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--31964-25193-u--names arg-2 arg-1 arg-0) (cons (vector 1 ) (cons arg-2 (IdrisC-45Parser-n--31964-25194-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--31915-25140-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--31915-25141-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 0 arg-1)))))))
(define IdrisC-45Parser-noArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--31915-25140-u--names arg-2 arg-1 arg-0) (cons (vector 0 ) (cons arg-2 (IdrisC-45Parser-n--31915-25141-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--33011-26269-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define ParserC-45RuleC-45Source-onOffLit (vector 1 "Expected on or off" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (let ((e-0 (vector-ref lcase-0 1))) (cond ((equal? e-0 "on") (box 1)) ((equal? e-0 "off") (box 0))(else '()))))(else '())))))
(define IdrisC-45Parser-n--33011-26270-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 ParserC-45RuleC-45Source-onOffLit) (lambda () (lambda (u--i) (vector 0 (arg-1 u--i)))))))))))
(define IdrisC-45Parser-onOffArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--33011-26269-u--names arg-2 arg-1 arg-0) (cons (vector 11 ) (cons arg-2 (IdrisC-45Parser-n--33011-26270-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--32774-26027-u--names (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45Parser-extractNames arg-3)))
(define IdrisC-45Parser-parseMode (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "typecheck") (lambda () (vector 0 0))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "tc") (lambda () (vector 0 0))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "normalise") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "default") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "normal") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "normalize") (lambda () (vector 0 1))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "execute") (lambda () (vector 0 2))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "exec") (lambda () (vector 0 2))) (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "scheme") (lambda () (vector 0 3))))))))))))))))))))
(define IdrisC-45Parser-setVarOption (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "eval") (lambda () (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 1 IdrisC-45Parser-parseMode) (lambda (u--mode) (vector 0 (vector 4 u--mode)))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "editor") (lambda () (vector 9 0 ParserC-45RuleC-45Source-unqualifiedName (lambda () (lambda (u--e) (vector 0 (vector 5 u--e))))))) (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "cg") (lambda () (vector 9 0 ParserC-45RuleC-45Source-unqualifiedName (lambda () (lambda (u--c) (vector 0 (vector 6 u--c))))))))))))
(define IdrisC-45Parser-setOption (lambda (arg-0) (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "showimplicits") (lambda () (vector 0 (vector 0 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "shownamespace") (lambda () (vector 0 (vector 1 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "showmachinenames") (lambda () (vector 0 (vector 2 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "showtypes") (lambda () (vector 0 (vector 3 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "profile") (lambda () (vector 0 (vector 7 arg-0)))) (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "evaltiming") (lambda () (vector 0 (vector 8 arg-0)))) (cond ((equal? arg-0 1) (lambda () IdrisC-45Parser-setVarOption)) (else (lambda () (vector 4 '() 1 "Unrecognised option")))))))))))))))))
(define IdrisC-45Parser-n--32774-26028-u--parse (lambda (arg-0 arg-1 arg-2 arg-3) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-3) (lambda () (vector 9 0 (vector 8 (IdrisC-45Parser-setOption arg-1)) (lambda () (lambda (u--opt) (vector 0 (arg-2 u--opt)))))))))))
(define IdrisC-45Parser-optArgCmd (lambda (arg-0 arg-1 arg-2 arg-3) (cons (IdrisC-45Parser-n--32774-26027-u--names arg-3 arg-2 arg-1 arg-0) (cons (vector 7 ) (cons arg-3 (IdrisC-45Parser-n--32774-26028-u--parse arg-3 arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-n--32030-25261-u--names (lambda (arg-0 arg-1 arg-2) (IdrisC-45Parser-extractNames arg-2)))
(define IdrisC-45Parser-n--32030-25262-u--parse (lambda (arg-0 arg-1 arg-2) (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (IdrisC-45Parser-runParseCmd arg-2) (lambda () (vector 9 0 (vector 8 ParserC-45RuleC-45Source-simpleStr) (lambda () (lambda (u--s) (vector 0 (arg-1 u--s)))))))))))
(define IdrisC-45Parser-stringArgCmd (lambda (arg-0 arg-1 arg-2) (cons (IdrisC-45Parser-n--32030-25261-u--names arg-2 arg-1 arg-0) (cons (vector 10 ) (cons arg-2 (IdrisC-45Parser-n--32030-25262-u--parse arg-2 arg-1 arg-0))))))
(define IdrisC-45Parser-parserCommandsForHelp (cons (IdrisC-45Parser-exprArgCmd (vector 0 csegen-4338) (lambda (eta-0) (vector 2 eta-0)) (IdrisC-45Parser-firstHelpLine "t")) (cons (IdrisC-45Parser-exprArgCmd (vector 0 (cons "ti" '())) (lambda (eta-0) (vector 3 eta-0)) (IdrisC-45Parser-firstHelpLine "ti")) (cons (IdrisC-45Parser-exprArgCmd (vector 0 (cons "printdef" '())) (lambda (eta-0) (vector 4 eta-0)) (IdrisC-45Parser-firstHelpLine "printdef")) (cons (IdrisC-45Parser-exprArgCmd (vector 0 csegen-4343) (lambda (eta-0) (vector 12 eta-0)) (IdrisC-45Parser-firstHelpLine "s")) (cons (IdrisC-45Parser-nameArgCmd (vector 2 "di") (lambda (eta-0) (vector 14 eta-0)) (IdrisC-45Parser-firstHelpLine "di")) (cons (IdrisC-45Parser-moduleArgCmd (vector 1 csegen-4347) (lambda (eta-0) (vector 7 eta-0)) (IdrisC-45Parser-firstHelpLine "module")) (cons (IdrisC-45Parser-stringArgCmd (vector 0 (cons "package" '())) (lambda (eta-0) (vector 33 eta-0)) (IdrisC-45Parser-firstHelpLine "package")) (cons (IdrisC-45Parser-noArgCmd (vector 0 csegen-4352) (vector 31 ) (IdrisC-45Parser-firstHelpLine "q")) (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "cwd" '())) (vector 19 ) (IdrisC-45Parser-firstHelpLine "cwd")) (cons (IdrisC-45Parser-stringArgCmd (vector 0 (cons "cd" '())) (lambda (eta-0) (vector 18 eta-0)) (IdrisC-45Parser-firstHelpLine "cd")) (cons (IdrisC-45Parser-stringArgCmd (vector 0 (cons "sh" '())) (lambda (eta-0) (vector 29 eta-0)) (IdrisC-45Parser-firstHelpLine "sh")) (cons (IdrisC-45Parser-optArgCmd (vector 2 "set") (lambda (eta-0) (vector 15 eta-0)) 1 (IdrisC-45Parser-firstHelpLine "set")) (cons (IdrisC-45Parser-optArgCmd (vector 2 "unset") (lambda (eta-0) (vector 15 eta-0)) 0 (IdrisC-45Parser-firstHelpLine "unset")) (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "opts" '())) (vector 16 ) (IdrisC-45Parser-firstHelpLine "opts")) (cons (IdrisC-45Parser-compileArgsCmd (vector 0 csegen-4361) (lambda (eta-0) (lambda (eta-1) (vector 9 eta-0 eta-1))) (IdrisC-45Parser-firstHelpLine "c")) (cons (IdrisC-45Parser-exprArgCmd (vector 2 "exec") (lambda (eta-0) (vector 10 eta-0)) (IdrisC-45Parser-firstHelpLine "exec")) (cons (IdrisC-45Parser-stringArgCmd (vector 2 "directive") (lambda (eta-0) (vector 17 eta-0)) (IdrisC-45Parser-firstHelpLine "directive")) (cons (IdrisC-45Parser-stringArgCmd (vector 0 csegen-4367) (lambda (eta-0) (vector 6 eta-0)) (IdrisC-45Parser-firstHelpLine "l")) (cons (IdrisC-45Parser-noArgCmd (vector 0 csegen-4370) (vector 5 ) (IdrisC-45Parser-firstHelpLine "r")) (cons (IdrisC-45Parser-noArgCmd (vector 0 csegen-4373) (vector 8 ) (IdrisC-45Parser-firstHelpLine "e")) (cons (IdrisC-45Parser-nameArgCmd (vector 0 csegen-4376) (lambda (eta-0) (vector 20 eta-0)) (IdrisC-45Parser-firstHelpLine "miss")) (cons (IdrisC-45Parser-nameArgCmd (vector 1 (cons "total" '())) (lambda (eta-0) (vector 21 eta-0)) (IdrisC-45Parser-firstHelpLine "total")) (cons (IdrisC-45Parser-docArgCmd (vector 2 "doc") (lambda (eta-0) (vector 22 eta-0)) (IdrisC-45Parser-firstHelpLine "doc")) (cons (IdrisC-45Parser-moduleArgCmd (vector 2 "browse") (lambda (eta-0) (vector 23 eta-0)) (IdrisC-45Parser-firstHelpLine "browse")) (cons (IdrisC-45Parser-loggingArgCmd (vector 0 csegen-4382) (lambda (eta-0) (vector 24 eta-0)) (IdrisC-45Parser-firstHelpLine "log")) (cons (IdrisC-45Parser-autoNumberArgCmd (vector 0 (cons "consolewidth" '())) (lambda (eta-0) (vector 25 eta-0)) (IdrisC-45Parser-firstHelpLine "consolewidth")) (cons (IdrisC-45Parser-onOffArgCmd (vector 0 csegen-4386) (lambda (eta-0) (vector 26 eta-0)) (IdrisC-45Parser-firstHelpLine "colour")) (cons (IdrisC-45Parser-noArgCmd (vector 0 csegen-4389) (vector 27 ) (IdrisC-45Parser-firstHelpLine "m")) (cons (IdrisC-45Parser-editLineColNameArgCmd (vector 0 (cons "typeat" '())) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 0 eta-1 eta-2 eta-3))))) (IdrisC-45Parser-firstHelpLine "typeat")) (cons (IdrisC-45Parser-editLineColNameArgCmd (vector 0 csegen-4395) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 1 eta-0 eta-1 eta-2 eta-3))))) (IdrisC-45Parser-firstHelpLine "cs")) (cons (IdrisC-45Parser-editLineNameArgCmd (vector 0 csegen-4399) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 2 eta-0 eta-1 eta-2)))) (IdrisC-45Parser-firstHelpLine "ac")) (cons (IdrisC-45Parser-editLineNameArgCmd (vector 0 csegen-4403) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 9 eta-0 eta-1 eta-2)))) (IdrisC-45Parser-firstHelpLine "ml")) (cons (IdrisC-45Parser-editLineNameArgCmd (vector 0 csegen-4407) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 10 eta-0 eta-1 eta-2)))) (IdrisC-45Parser-firstHelpLine "mc")) (cons (IdrisC-45Parser-editLineNameArgCmd (vector 0 csegen-4411) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 11 eta-0 eta-1 eta-2)))) (IdrisC-45Parser-firstHelpLine "mw")) (cons (IdrisC-45Parser-editLineNameArgCmd (vector 0 (cons "intro" '())) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 4 eta-0 eta-1 eta-2)))) (IdrisC-45Parser-firstHelpLine "intro")) (cons (IdrisC-45Parser-editLineNamePTermArgCmd (vector 0 (cons "refine" '())) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 3 eta-0 eta-1 eta-2 eta-3))))) (IdrisC-45Parser-firstHelpLine "refine")) (cons (IdrisC-45Parser-editLineNameCSVArgCmd (vector 0 csegen-4419) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 5 eta-0 eta-1 eta-2 eta-3))))) (IdrisC-45Parser-firstHelpLine "ps")) (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "psnext" '())) (vector 28 (vector 6 )) (IdrisC-45Parser-firstHelpLine "psnext")) (cons (IdrisC-45Parser-editLineNameOptionArgCmd (vector 0 (cons "gd" '())) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (vector 7 eta-0 eta-1 eta-2 eta-3))))) (IdrisC-45Parser-firstHelpLine "gd")) (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "gdnext" '())) (vector 28 (vector 8 )) (IdrisC-45Parser-firstHelpLine "gdnext")) (cons (IdrisC-45Parser-noArgCmd (vector 0 (cons "version" '())) (vector 30 ) (IdrisC-45Parser-firstHelpLine "version")) (cons (IdrisC-45Parser-helpCmd (vector 0 csegen-4429) (lambda (eta-0) (vector 11 eta-0)) (IdrisC-45Parser-firstHelpLine "?")) (cons (IdrisC-45Parser-declsArgCmd (vector 1 (cons "let" '())) (lambda (eta-0) (vector 0 eta-0)) (IdrisC-45Parser-firstHelpLine "let")) (cons (IdrisC-45Parser-exprArgCmd (vector 0 csegen-4433) (lambda (eta-0) (vector 13 eta-0)) (IdrisC-45Parser-firstHelpLine "fs")) '())))))))))))))))))))))))))))))))))))))))))))))
(define csegen-5691 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (Builtin-fst eta-0)) IdrisC-45Parser-parserCommandsForHelp))
(define csegen-5692 (lambda (eta-0) (PreludeC-45Show-u--show_Show_String (Builtin-fst eta-0))))
(define CoreC-45OptionsC-45Log-knownTopics (cons (cons "auto" (box "Auto proof search")) (cons (cons "auto.determining" (box "Checking that interface's determining argument are concrete")) (cons (cons "builtin.Natural" (box "Log each encountered %builtin Natural declaration.")) (cons (cons "builtin.NaturalToInteger" (box "Log each encountered %builtin NaturalToInteger declaration.")) (cons (cons "builtin.IntegerToNatural" (box "Log each encountered %builtin IntegerToNatural declaration.")) (cons (cons "compile.execute" '()) (cons (cons "compile.export" (box "Log each name exported using %export")) (cons (cons "compile.casetree" '()) (cons (cons "compile.casetree.clauses" '()) (cons (cons "compile.casetree.getpmdef" '()) (cons (cons "compile.casetree.intermediate" '()) (cons (cons "compile.casetree.measure" (box "Log the node counts of each runtime case tree.")) (cons (cons "compile.casetree.missing" (box "Log when we add an error case for uncovered branches.")) (cons (cons "compile.casetree.partition" '()) (cons (cons "compile.casetree.pick" '()) (cons (cons "compiler.const-fold" (box "Log definitions before and after constant folding.")) (cons (cons "compiler.cse" (box "Log information about common sub-expression elimination.")) (cons (cons "compiler.identity" (box "Log definitions that are equivalent to identity at runtime.")) (cons (cons "compiler.inline.eval" (box "Log function definitions before and after inlining.")) (cons (cons "compiler.inline.heuristic" (box "Log names the inlining heuristic(s) have decided to inline.")) (cons (cons "compiler.inline.io_bind" (box "Log the attempts to inline `io_bind`.")) (cons (cons "compiler.interpreter" (box "Log the call-stack of the VMCode interpreter.")) (cons (cons "compiler.javascript.doc" (box "Generating doc comments for the JS backend.")) (cons (cons "compiler.newtype.world" (box "Inlining matches on newtypes.")) (cons (cons "compiler.refc" '()) (cons (cons "compiler.refc.cc" '()) (cons (cons "compiler.scheme.chez" '()) (cons (cons "coverage" '()) (cons (cons "coverage.empty" '()) (cons (cons "coverage.missing" '()) (cons (cons "coverage.recover" '()) (cons (cons "declare.data" '()) (cons (cons "declare.data.constructor" '()) (cons (cons "declare.data.parameters" '()) (cons (cons "declare.def" '()) (cons (cons "declare.def.alias" '()) (cons (cons "declare.def.clause" '()) (cons (cons "declare.def.clause.impossible" '()) (cons (cons "declare.def.clause.with" '()) (cons (cons "declare.def.impossible" '()) (cons (cons "declare.def.lhs" '()) (cons (cons "declare.def.lhs.implicits" '()) (cons (cons "declare.param" '()) (cons (cons "declare.record" '()) (cons (cons "declare.record.field" '()) (cons (cons "declare.record.parameters" (box "Showing the implicitlty bound parameters")) (cons (cons "declare.record.projection" '()) (cons (cons "declare.record.projection.prefix" '()) (cons (cons "declare.type" '()) (cons (cons "desugar.idiom" '()) (cons (cons "desugar.failing" (box "Log result of desugaring a `failing' block")) (cons (cons "desugar.fixity" (box "Log result of desugaring a fixity declaration")) (cons (cons "desugar.lhs" (box "Log result of desugaring a left hand side")) (cons (cons "doc.data" '()) (cons (cons "doc.implementation" '()) (cons (cons "doc.record" '()) (cons (cons "doc.module" '()) (cons (cons "doc.module.definitions" '()) (cons (cons "elab" '()) (cons (cons "elab.ambiguous" '()) (cons (cons "elab.app.var" '()) (cons (cons "elab.app.dot" (box "Dealing with forced expressions when elaborating applications")) (cons (cons "elab.app.lhs" '()) (cons (cons "elab.as" '()) (cons (cons "elab.bindnames" '()) (cons (cons "elab.binder" '()) (cons (cons "elab.case" '()) (cons (cons "elab.def.local" '()) (cons (cons "elab.delay" '()) (cons (cons "elab.failing" (box "Elaborating a 'failing' block.")) (cons (cons "elab.hole" '()) (cons (cons "elab.implicits" '()) (cons (cons "elab.implementation" '()) (cons (cons "elab.interface" '()) (cons (cons "elab.interface.default" '()) (cons (cons "elab.local" '()) (cons (cons "elab.prune" '()) (cons (cons "elab.record" '()) (cons (cons "elab.retry" '()) (cons (cons "elab.rewrite" '()) (cons (cons "elab.unify" '()) (cons (cons "elab.update" '()) (cons (cons "elab.with" '()) (cons (cons "eval.casetree" '()) (cons (cons "eval.casetree.stuck" '()) (cons (cons "eval.def.underapplied" (box "Evaluating definitions (unavailable by default, edit Core.Normalise.Eval & recompile)")) (cons (cons "eval.def.stuck" (box "Evaluating definitions (unavailable by default, edit Core.Normalise.Eval & recompile)")) (cons (cons "eval.eta" '()) (cons (cons "eval.ref" (box "Evaluating refs (unavailable by default, edit Core.Normalise.Eval & recompile)")) (cons (cons "eval.stuck" '()) (cons (cons "eval.stuck.outofscope" '()) (cons (cons "ide-mode.completion" (box "Autocompletion requests")) (cons (cons "ide-mode.hole" (box "Displaying hole contexts")) (cons (cons "ide-mode.highlight" '()) (cons (cons "ide-mode.highlight.alias" '()) (cons (cons "ide-mode.send" (box "The IDE mode's SExp traffic")) (cons (cons "ide-mode.recv" (box "Messages received by the IDE mode")) (cons (cons "import" '()) (cons (cons "import.file" '()) (cons (cons "interaction.casesplit" '()) (cons (cons "interaction.generate" '()) (cons (cons "interaction.search" '()) (cons (cons "metadata.names" '()) (cons (cons "module" '()) (cons (cons "module.hash" '()) (cons (cons "package.depends" (box "Log which packages are being added")) (cons (cons "quantity" '()) (cons (cons "quantity.hole" '()) (cons (cons "quantity.hole.update" '()) (cons (cons "reflection.reify" (box "Log what's happening when converting an `NF` to some real value")) (cons (cons "repl.eval" '()) (cons (cons "resugar.var" (box "Resugaring variables")) (cons (cons "resugar.sectionL" (box "Resugaring left sections")) (cons (cons "specialise" (box "Generating a partially-evaluated specialised version of a function")) (cons (cons "specialise.declare" (box "Declaring our intention to specialise a function")) (cons (cons "specialise.fail" (box "Generating the specialised function failed")) (cons (cons "specialise.flags" (box "Listing the definition flags propagated to the specialised function")) (cons (cons "totality" '()) (cons (cons "totality.positivity" '()) (cons (cons "totality.requirement" '()) (cons (cons "totality.termination" '()) (cons (cons "totality.termination.calc" '()) (cons (cons "totality.termination.guarded" '()) (cons (cons "totality.termination.sizechange" '()) (cons (cons "totality.termination.sizechange.checkCall" '()) (cons (cons "totality.termination.sizechange.checkCall.inPath" '()) (cons (cons "totality.termination.sizechange.checkCall.inPathNot.restart" '()) (cons (cons "totality.termination.sizechange.checkCall.inPathNot.return" '()) (cons (cons "totality.termination.sizechange.inPath" '()) (cons (cons "totality.termination.sizechange.isTerminating" '()) (cons (cons "totality.termination.sizechange.needsChecking" '()) (cons (cons "transform.lhs" '()) (cons (cons "transform.rhs" '()) (cons (cons "ttc.read" '()) (cons (cons "ttc.write" '()) (cons (cons "typesearch.equiv" '()) (cons (cons "unelab.case" (box "Unelaborating a case block")) (cons (cons "unelab.case.clause" (box "Unelaborating a case block's clauses")) (cons (cons "unelab.var" '()) (cons (cons "unify" '()) (cons (cons "unify.application" '()) (cons (cons "unify.binder" '()) (cons (cons "unify.constant" '()) (cons (cons "unify.constraint" '()) (cons (cons "unify.delay" '()) (cons (cons "unify.equal" '()) (cons (cons "unify.head" '()) (cons (cons "unify.hole" '()) (cons (cons "unify.instantiate" '()) (cons (cons "unify.invertible" '()) (cons (cons "unify.meta" '()) (cons (cons "unify.noeta" '()) (cons (cons "unify.postpone" '()) (cons (cons "unify.retry" '()) (cons (cons "unify.search" '()) (cons (cons "unify.unsolved" '()) '())))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define csegen-5693 (PreludeC-45TypesC-45List-mapAppend '() csegen-5692 CoreC-45OptionsC-45Log-knownTopics))
(define csegen-5694 (lambda (u--x) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum u--x))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char u--x (cast-int-char (blodwen-toSignedInt 160 63)))))))) (cond ((equal? sc0 1) 0) (else 1)))))
(define u--prim__sub_Integer (lambda (arg-0 arg-1) (- arg-0 arg-1)))
(define CoreC-45Core-coreRun (lambda (arg-2 arg-3 arg-4 ext-0) (let ((act-1 (arg-2 ext-0))) ((PreludeC-45Types-either (lambda () arg-3) (lambda () arg-4) act-1) ext-0))))
(define System-getArgs (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (System-prim__getArgCount eta-0))))) (lambda (u--n) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Int u--n (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (PreludeC-45Basics-flip (lambda (clam-0) (lambda (clam-1) (PreludeC-45Types-u--traverse_Traversable_List (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10)) clam-0 clam-1))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 0 (bs- u--n 1 63)) (lambda (eta-0) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-1) (System-prim__getArg eta-0 eta-1))))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '())))))))))))))
(define LibrariesC-45DataC-45StringMap-singleton (lambda (arg-1 arg-2) (cons 0 (vector 0 arg-1 arg-2))))
(define LibrariesC-45DataC-45StringTrie-singleton (lambda (arg-1 arg-2) (if (null? arg-1) (vector 0 arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (vector 1 (LibrariesC-45DataC-45StringMap-singleton e-2 (LibrariesC-45DataC-45StringTrie-singleton e-3 arg-2))))))))
(define CoreC-45OptionsC-45Log-defaultLogLevel (LibrariesC-45DataC-45StringTrie-singleton '() 0))
(define CoreC-45Options-defaultSession (vector 0 1 0 0 (vector 0 ) '() 1000 0 0 CoreC-45OptionsC-45Log-defaultLogLevel '() 0 '() '() '() '() 0 1 0 0 1 0 '() 0 0))
(define IdrisC-45CommandLine-formatSocketAddress (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (string-append e-2 (string-append ":" (PreludeC-45Show-u--show_Show_Int e-3)))))))
(define DataC-45String-break (lambda (arg-0 ext-0) (DataC-45String-span (lambda (eta-0) (let ((sc0 (arg-0 eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) ext-0)))
(define DataC-45String-parseNumWithoutSign (lambda (arg-0 arg-1) (if (null? arg-0) (box arg-1) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-2 #\0))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-2 #\9)) (else 0))))) (cond ((equal? sc1 1) (DataC-45String-parseNumWithoutSign e-3 (+ (* arg-1 10) (bs- (cast-char-boundedInt e-2 63) (cast-char-boundedInt #\0 63) 63)))) (else '()))))))))
(define DataC-45String-with--parsePositiveC-44parsePosTrimmed-9869 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 "") (if (null? arg-4) '() (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (cond ((equal? e-0 #\+) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0)))(else (let ((sc3 (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc4 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (bs- (cast-char-boundedInt e-0 63) (cast-char-boundedInt #\0 63) 63)))) (else '())))))))))(else (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (cond ((equal? e-0 #\+) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0)))(else (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc1 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (bs- (cast-char-boundedInt e-0 63) (cast-char-boundedInt #\0 63) 63)))) (else '())))))))))))
(define DataC-45String-n--4450-9863-u--parsePosTrimmed (lambda (arg-1 arg-2 arg-3) (DataC-45String-with--parsePositiveC-44parsePosTrimmed-9869 'erased arg-1 arg-3 arg-3 (DataC-45String-strM arg-3))))
(define DataC-45String-parsePositive (lambda (arg-1 arg-2) (DataC-45String-n--4450-9863-u--parsePosTrimmed arg-1 arg-2 (DataC-45String-trim arg-2))))
(define IdrisC-45CommandLine-n--4601-1855-u--portPart (lambda (arg-0 arg-1 arg-2) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 ""))) (cond ((equal? sc0 1) '()) (else (box (substring arg-2 1 (string-length arg-2))))))))
(define IdrisC-45CommandLine-case--ideSocketModeAddress-1903 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--port (DataC-45Maybe-fromMaybe (lambda () (blodwen-toSignedInt 0 63)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45CommandLine-n--4601-1855-u--portPart arg-0 arg-1 e-3) (lambda (eta-0) (DataC-45String-parsePositive csegen-189 eta-0)))))) (let ((u--host (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 ""))) (cond ((equal? sc1 1) "localhost") (else e-2))))) (cons u--host u--port)))))))
(define IdrisC-45CommandLine-ideSocketModeAddress (lambda (arg-0) (if (null? arg-0) (cons "localhost" 0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((27) (let ((e-4 (vector-ref e-2 1))) (IdrisC-45CommandLine-case--ideSocketModeAddress-1903 e-3 e-4 (DataC-45String-break csegen-1079 e-4))))(else (IdrisC-45CommandLine-ideSocketModeAddress e-3))))))))
(define IdrisC-45CommandLine-optSeparator (vector '() '() '() '()))
(define IdrisC-45CommandLine-recogniseHelpTopic (lambda (arg-0) (cond ((equal? arg-0 "logging") (box 0)) ((equal? arg-0 "pragma") (box 1))(else '()))))
(define IdrisC-45CommandLine-showDefault (lambda (arg-1 arg-2) (string-append "(default " (string-append (let ((e-1 (car arg-1))) (e-1 arg-2)) ")"))))
(define CoreC-45Options-u--show_Show_CG (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "chez") ((1) "chez-sep") ((2) "racket") ((3) "gambit") ((4) "node") ((5) "javascript") ((6) "refc") ((7) "vmcode-interp") (else (let ((e-0 (vector-ref arg-0 1))) e-0)))))
(define CoreC-45Options-u--showPrec_Show_CG (lambda (arg-0 arg-1) (CoreC-45Options-u--show_Show_CG arg-1)))
(define IdrisC-45CommandLine-options (cons (vector (cons "--check" (cons "-c" '())) '() (cons (vector 0 ) '()) (box "Exit after checking source file")) (cons (vector (cons "--output" (cons "-o" '())) (cons (vector 0 "file") '()) (lambda (u--f) (cons (vector 1 u--f) (cons (vector 14 ) '()))) (box "Specify output file")) (cons (vector (cons "--exec" (cons "-x" '())) (cons (vector 0 "name") '()) (lambda (u--f) (cons (vector 2 u--f) (cons (vector 14 ) '()))) (box "Execute function after checking source file")) (cons (vector (cons "--no-prelude" '()) '() (cons (vector 5 ) '()) (box "Don't implicitly import Prelude")) (cons (vector (cons "--codegen" (cons "--cg" '())) (cons (vector 0 "backend") '()) (lambda (u--f) (cons (vector 3 u--f) '())) (box (string-append "Set code generator " (IdrisC-45CommandLine-showDefault (cons (lambda (u--x) (CoreC-45Options-u--show_Show_CG u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Options-u--showPrec_Show_CG u--d u--x)))) (let ((sc0 CoreC-45Options-defaultSession)) (let ((e-4 (vector-ref sc0 4))) e-4)))))) (cons (vector (cons "--incremental-cg" (cons "--inc" '())) (cons (vector 0 "backend") '()) (lambda (u--f) (cons (vector 44 u--f) '())) (box "Incremental code generation on given backend")) (cons (vector (cons "--whole-program" (cons "--wp" '())) '() (cons (vector 45 ) '()) (box "Use whole program compilation (overrides --inc)")) (cons (vector (cons "--directive" '()) (cons (vector 0 "directive") '()) (lambda (u--d) (cons (vector 4 u--d) '())) (box "Pass a directive to the current code generator")) (cons (vector (cons "--package" (cons "-p" '())) (cons (vector 0 "package") '()) (lambda (u--f) (cons (vector 21 u--f) '())) (box "Add a package as a dependency")) (cons (vector (cons "--source-dir" '()) (cons (vector 0 "dir") '()) (lambda (u--d) (cons (vector 6 u--d) '())) (box "Set source directory")) (cons (vector (cons "--build-dir" '()) (cons (vector 0 "dir") '()) (lambda (u--d) (cons (vector 7 u--d) '())) (box "Set build directory")) (cons (vector (cons "--output-dir" '()) (cons (vector 0 "dir") '()) (lambda (u--d) (cons (vector 8 u--d) '())) (box "Set output directory")) (cons (vector (cons "--profile" '()) '() (cons (vector 9 ) '()) (box "Generate profile data when compiling, if supported")) (cons (vector (cons "--no-cse" '()) '() (cons (vector 49 ) '()) (box "Disable common subexpression elimination")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--total" '()) '() (cons (vector 48 ) '()) (box "Require functions to be total by default")) (cons (vector (cons "-Werror" '()) '() (cons (vector 40 ) '()) (box "Treat warnings as errors")) (cons (vector (cons "-Wno-shadowing" '()) '() (cons (vector 41 ) '()) (box "Do not print shadowing warnings")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "-Xcheck-hashes" '()) '() (cons (vector 42 ) '()) (box "Use SHA256 hashes instead of modification time to determine if a source file needs rebuilding")) (cons (vector (cons "-Xcase-tree-opt" '()) '() (cons (vector 43 ) '()) (box "Apply experimental optimizations to case tree generation")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--prefix" '()) '() (cons (vector 24 1) '()) (box "Show installation prefix")) (cons (vector (cons "--paths" '()) '() (cons (vector 24 2) '()) (box "Show paths")) (cons (vector (cons "--libdir" '()) '() (cons (vector 24 0) '()) (box "Show library directory")) (cons (vector (cons "--list-packages" '()) '() (cons (vector 22 ) '()) (box "List installed packages")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--init" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 7 u--f) '())) (box "Interactively initialise a new project")) (cons (vector (cons "--build" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 0 u--f) '())) (box "Build modules/executable for the given package")) (cons (vector (cons "--install" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 1 u--f) '())) (box "Install the given package")) (cons (vector (cons "--install-with-src" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 2 u--f) '())) (box "Install the given package")) (cons (vector (cons "--mkdoc" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 3 u--f) '())) (box "Build documentation for the given package")) (cons (vector (cons "--typecheck" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 4 u--f) '())) (box "Typechecks the given package without code generation")) (cons (vector (cons "--clean" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 5 u--f) '())) (box "Clean intermediate files/executables for the given package")) (cons (vector (cons "--repl" '()) (cons (vector 1 "package file") '()) (lambda (u--f) (cons (vector 23 6 u--f) '())) (box "Build the given package and launch a REPL instance.")) (cons (vector (cons "--find-ipkg" '()) '() (cons (vector 36 ) '()) (box "Find and use an .ipkg file in a parent directory.")) (cons (vector (cons "--ignore-missing-ipkg" '()) '() (cons (vector 35 ) '()) (box "Fail silently if a dependency is missing.")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--ide-mode" '()) '() (cons (vector 26 ) '()) (box "Run the REPL with machine-readable syntax")) (cons (vector (cons "--ide-mode-socket" '()) (cons (vector 1 "host:port") '()) (lambda (u--hp) (cons (vector 27 (DataC-45Maybe-fromMaybe (lambda () (IdrisC-45CommandLine-formatSocketAddress (IdrisC-45CommandLine-ideSocketModeAddress '()))) u--hp)) '())) (box "Run the ide socket mode on given host and port (random open socket by default)")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--client" '()) (cons (vector 0 "REPL command") '()) (lambda (u--f) (cons (vector 34 u--f) '())) (box "Run a REPL command then quit immediately")) (cons (vector (cons "--timing" '()) (cons (vector 3 "level") '()) (lambda (u--n) (cons (vector 37 u--n) '())) (box "Display timing logs")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--no-banner" '()) '() (cons (vector 13 ) '()) (box "Suppress the banner")) (cons (vector (cons "--quiet" (cons "-q" '())) '() (cons (vector 14 ) '()) (box "Quiet mode; display fewer messages")) (cons (vector (cons "--console-width" '()) (cons (vector 3 "console width") '()) (lambda (u--l) (cons (vector 18 u--l) '())) (box "Width for console output (0 for unbounded) (auto by default)")) (cons (vector (cons "--show-machine-names" '()) '() (cons (vector 15 ) '()) (box "Show machine names when pretty printing")) (cons (vector (cons "--show-namespaces" '()) '() (cons (vector 16 ) '()) (box "Show namespaces when pretty printing")) (cons (vector (cons "--color" (cons "--colour" '())) '() (cons (vector 19 1) '()) (box "Forces colored console output (enabled by default)")) (cons (vector (cons "--no-color" (cons "--no-colour" '())) '() (cons (vector 19 0) '()) (box "Disables colored console output")) (cons (vector (cons "--verbose" '()) '() (cons (vector 17 ) '()) (box "Verbose mode (default)")) (cons (vector (cons "--log" '()) (cons (vector 4 "log level") '()) (lambda (u--l) (cons (vector 20 u--l) '())) (box "Global log level (0 by default)")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--version" (cons "-v" '())) '() (cons (vector 10 ) '()) (box "Display version string")) (cons (vector (cons "--ttc-version" '()) '() (cons (vector 11 ) '()) (box "Display TTC version string")) (cons (vector (cons "--help" (cons "-h" (cons "-?" '()))) (cons (vector 1 "topic") '()) (lambda (u--tp) (cons (vector 12 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe u--tp (lambda (eta-0) (IdrisC-45CommandLine-recogniseHelpTopic eta-0)))) '())) (box "Display help text")) (cons (vector (cons "--yaffle" (cons "--ttimp" '())) (cons (vector 0 "ttimp file") '()) (lambda (u--f) (cons (vector 28 u--f) '())) '()) (cons (vector (cons "--ttm" '()) (cons (vector 0 "ttimp file") '()) (lambda (u--f) (cons (vector 29 u--f) '())) '()) (cons (vector (cons "--dumpcases" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 30 u--f) '())) '()) (cons (vector (cons "--dumplifted" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 31 u--f) '())) '()) (cons (vector (cons "--dumpanf" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 32 u--f) '())) '()) (cons (vector (cons "--dumpvmcode" '()) (cons (vector 0 "output file") '()) (lambda (u--f) (cons (vector 33 u--f) '())) '()) (cons (vector (cons "--debug-elab-check" '()) '() (cons (vector 38 ) '()) '()) (cons (vector (cons "--alt-error-count" '()) (cons (vector 2 "alternative count") '()) (lambda (u--c) (cons (vector 39 u--c) '())) (box "Outputs errors for the given number of alternative parsing attempts.")) (cons IdrisC-45CommandLine-optSeparator (cons (vector (cons "--bash-completion" '()) (cons (vector 0 "input") (cons (vector 0 "previous input") '())) (lambda (u--w1) (lambda (u--w2) (cons (vector 46 u--w1 u--w2) '()))) (box "Print bash autocompletion information")) (cons (vector (cons "--bash-completion-script" '()) (cons (vector 0 "function name") '()) (lambda (u--n) (cons (vector 47 u--n) '())) (box "Generate a bash script to activate autocompletion for Idris2")) '())))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45CommandLine-checkNat (lambda (arg-0) (DataC-45Maybe-toMaybe (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-0 0) (lambda () (PreludeC-45Types-prim__integerToNat arg-0)))))
(define DataC-45String-isPrefixOf (lambda (arg-0 arg-1) (DataC-45List-isPrefixOf csegen-17 (PreludeC-45Types-fastUnpack arg-0) (PreludeC-45Types-fastUnpack arg-1))))
(define DataC-45Either-maybeToEither (lambda (arg-2 arg-3) (if (null? arg-3) (vector 0 (arg-2)) (let ((e-1 (unbox arg-3))) (vector 1 e-1)))))
(define DataC-45String-with--parseIntegerC-44parseIntTrimmed-9982 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-4 "") (if (null? arg-5) '() (let ((e-0 (car arg-5))) (let ((e-1 (cdr arg-5))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\-))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--y) (let ((e-2 (vector-ref arg-2 1))) (e-2 (let ((e-5 (vector-ref arg-1 2))) (e-5 u--y))))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0))) (else (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\+))) (cond ((equal? sc4 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0))) (else (let ((sc5 (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc6 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc5 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (bs- (cast-char-boundedInt e-0 63) (cast-char-boundedInt #\0 63) 63)))) (else '())))))))))))))(else (let ((e-0 (car arg-5))) (let ((e-1 (cdr arg-5))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\-))) (cond ((equal? sc1 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--y) (let ((e-2 (vector-ref arg-2 1))) (e-2 (let ((e-5 (vector-ref arg-1 2))) (e-5 u--y))))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char e-0 #\+))) (cond ((equal? sc2 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) 0))) (else (let ((sc3 (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char e-0 #\0))) (cond ((equal? sc4 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char e-0 #\9)) (else 0))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref arg-1 2))) (e-3 eta-0))) (DataC-45String-parseNumWithoutSign (PreludeC-45Types-fastUnpack e-1) (bs- (cast-char-boundedInt e-0 63) (cast-char-boundedInt #\0 63) 63)))) (else '())))))))))))))))
(define DataC-45String-n--4554-9976-u--parseIntTrimmed (lambda (arg-1 arg-2 arg-3 arg-4) (DataC-45String-with--parseIntegerC-44parseIntTrimmed-9982 'erased arg-1 arg-2 arg-4 arg-4 (DataC-45String-strM arg-4))))
(define DataC-45String-parseInteger (lambda (arg-1 arg-2 arg-3) (DataC-45String-n--4554-9976-u--parseIntTrimmed arg-1 arg-2 arg-3 (DataC-45String-trim arg-3))))
(define CoreC-45OptionsC-45Log-parseLogLevel (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((u--nns (DataC-45String-split csegen-1079 arg-0))) (let ((u--n (let ((e-1 (car u--nns))) e-1))) (let ((u--ns (let ((e-2 (cdr u--nns))) e-2))) (if (null? u--ns) (box (cons (lambda (eta-0) (cons '() eta-0)) u--n)) (let ((e-2 (car u--ns))) (let ((e-3 (cdr u--ns))) (if (null? e-3) (box (cons (lambda (eta-0) (CoreC-45OptionsC-45Log-mkUnverifiedLogLevel u--n eta-0)) e-2)) '()))))))) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45String-parsePositive csegen-1055 e-3) (lambda (u--lvl) (box (e-2 (PreludeC-45Types-prim__integerToNat u--lvl)))))))))))
(define IdrisC-45CommandLine-u--show_Show_OptType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (string-append "<" (string-append e-0 ">")))) ((2) (let ((e-1 (vector-ref arg-0 1))) (string-append "<" (string-append e-1 ">")))) ((4) (let ((e-2 (vector-ref arg-0 1))) (string-append "<" (string-append e-2 ">")))) ((1) (let ((e-3 (vector-ref arg-0 1))) (string-append "[" (string-append e-3 "]")))) (else (let ((e-4 (vector-ref arg-0 1))) (string-append "<" (string-append e-4 ">")))))))
(define IdrisC-45CommandLine-processArgs (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-1) (vector 1 (cons arg-3 arg-2)) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((0) (if (null? arg-2) (vector 0 (string-append "Missing required argument " (string-append (IdrisC-45CommandLine-u--show_Show_OptType e-2) (string-append " for flag " arg-0)))) (let ((e-11 (car arg-2))) (let ((e-12 (cdr arg-2))) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-12 (arg-3 e-11)))))) ((2) (if (null? arg-2) (vector 0 (string-append "Missing required argument " (string-append (IdrisC-45CommandLine-u--show_Show_OptType e-2) (string-append " for flag " arg-0)))) (let ((e-15 (car arg-2))) (let ((e-16 (cdr arg-2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (DataC-45Either-maybeToEither (lambda () (string-append "Expected Nat argument " (string-append (PreludeC-45Show-u--show_Show_String e-15) (string-append " for flag " arg-0)))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45String-parseInteger csegen-1055 csegen-1068 e-15) (lambda (eta-0) (IdrisC-45CommandLine-checkNat eta-0)))) (lambda (u--arg) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-16 (arg-3 u--arg)))))))) ((4) (if (null? arg-2) (vector 0 (string-append "Missing required argument " (string-append (IdrisC-45CommandLine-u--show_Show_OptType e-2) (string-append " for flag " arg-0)))) (let ((e-19 (car arg-2))) (let ((e-20 (cdr arg-2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (DataC-45Either-maybeToEither (lambda () (string-append "Expected LogLevel argument " (string-append (PreludeC-45Show-u--show_Show_String e-19) (string-append " for flag " arg-0)))) (CoreC-45OptionsC-45Log-parseLogLevel e-19)) (lambda (u--arg) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-20 (arg-3 u--arg)))))))) ((1) (if (null? arg-2) (IdrisC-45CommandLine-processArgs arg-0 e-3 '() (arg-3 '())) (let ((e-23 (car arg-2))) (let ((e-24 (cdr arg-2))) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-24 (arg-3 (DataC-45Maybe-toMaybe (let ((sc3 (DataC-45String-isPrefixOf "-" e-23))) (cond ((equal? sc3 1) 0) (else 1))) (lambda () e-23)))))))) (else (if (null? arg-2) (vector 0 (string-append "Missing required argument " (string-append (IdrisC-45CommandLine-u--show_Show_OptType e-2) (string-append " for flag " arg-0)))) (let ((e-27 (car arg-2))) (let ((e-28 (cdr arg-2))) (cond ((equal? e-27 "auto") (IdrisC-45CommandLine-processArgs arg-0 e-3 e-28 (arg-3 '())))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (DataC-45Either-maybeToEither (lambda () (string-append "Expected Nat or \"auto\" argument " (string-append (PreludeC-45Show-u--show_Show_String e-27) (string-append " for flag " arg-0)))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45String-parseInteger csegen-1055 csegen-1068 e-27) (lambda (eta-0) (IdrisC-45CommandLine-checkNat eta-0)))) (lambda (u--arg) (IdrisC-45CommandLine-processArgs arg-0 e-3 e-28 (arg-3 (box u--arg)))))))))))))))))
(define IdrisC-45CommandLine-matchFlag (lambda (arg-0 arg-1) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 e-2 (let ((e-0 (vector-ref arg-0 0))) e-0)))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-processArgs e-2 (let ((e-1 (vector-ref arg-0 1))) e-1) e-3 (let ((e-5 (vector-ref arg-0 2))) e-5)) (lambda (u--args) (vector 1 (box u--args))))) (else (vector 1 '())))))))))
(define IdrisC-45CommandLine-findMatch (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 1 (cons '() '())) (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (vector 1 (cons (cons (vector 25 e-6) '()) e-7))))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-matchFlag e-2 arg-1) (lambda (bind-0) (if (null? bind-0) (IdrisC-45CommandLine-findMatch e-3 arg-1) (let ((e-4 (unbox bind-0))) (vector 1 e-4))))))))))
(define IdrisC-45CommandLine-parseOpts (lambda (arg-0 arg-1) (if (null? arg-1) (vector 1 '()) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-findMatch arg-0 arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (IdrisC-45CommandLine-parseOpts arg-0 e-3) (lambda (u--cls) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-2 u--cls)))))))))))
(define IdrisC-45CommandLine-getOpts (lambda (arg-0) (IdrisC-45CommandLine-parseOpts IdrisC-45CommandLine-options arg-0)))
(define IdrisC-45CommandLine-getCmdOpts (lambda (ext-0) (let ((act-1 ((System-getArgs csegen-82) ext-0))) (if (null? act-1) (vector 0 "Invalid command line") (let ((e-2 (cdr act-1))) (IdrisC-45CommandLine-getOpts e-2))))))
(define CoreC-45OptionsC-45Log-n--6397-7011-u--helpTopic (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((u--title (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "+") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-2)))) (let ((u--blurb (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow eta-0)) '()))) e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons u--title u--blurb))))))))
(define CoreC-45OptionsC-45Log-helpTopics (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45OptionsC-45Log-n--6397-7011-u--helpTopic eta-0)) CoreC-45OptionsC-45Log-knownTopics))))
(define IdrisC-45SyntaxC-45Pragmas-allPragmas (cons 0 (cons 1 (cons 2 (cons 3 (cons 4 (cons 5 (cons 6 (cons 7 (cons 8 (cons 9 (cons 10 (cons 11 (cons 12 (cons 13 (cons 14 (cons 15 (cons 16 (cons 17 (cons 18 (cons 19 (cons 20 '()))))))))))))))))))))))
(define IdrisC-45SyntaxC-45Pragmas-pragmaArgs (lambda (arg-0) (cond ((equal? arg-0 0) (cons (vector 0 "nm") '())) ((equal? arg-0 1) (cons (vector 0 "nm") '())) ((equal? arg-0 2) (cons (vector 5 ) (cons (vector 6 ) '()))) ((equal? arg-0 3) (cons (vector 4 ) '())) ((equal? arg-0 4) (cons (vector 4 ) '())) ((equal? arg-0 5) (cons (vector 6 ) '())) ((equal? arg-0 6) (cons (vector 2 ) '())) ((equal? arg-0 7) (cons (vector 3 ) '())) ((equal? arg-0 8) (cons (vector 0 "nm") '())) ((equal? arg-0 9) (cons (vector 0 "nm") '())) ((equal? arg-0 10) (cons (vector 0 "nm") '())) ((equal? arg-0 11) (cons (vector 0 "nm") '())) ((equal? arg-0 12) (cons (vector 1 ) '())) ((equal? arg-0 13) (cons (vector 7 ) '())) ((equal? arg-0 14) (cons (vector 0 "nm") '())) ((equal? arg-0 15) (cons (vector 8 ) '())) ((equal? arg-0 16) (cons (vector 9 ) '())) ((equal? arg-0 17) (cons (vector 4 ) '())) ((equal? arg-0 18) (cons (vector 6 ) '())) ((equal? arg-0 19) (cons (vector 6 ) '())) (else (cons (vector 6 ) '())))))
(define IdrisC-45SyntaxC-45Pragmas-u--show_Show_KwPragma (lambda (arg-0) (cond ((equal? arg-0 0) "%hide") ((equal? arg-0 1) "%unhide") ((equal? arg-0 2) "%logging") ((equal? arg-0 3) "%auto_lazy") ((equal? arg-0 4) "%unbound_implicits") ((equal? arg-0 5) "%ambiguity_depth") ((equal? arg-0 6) "%pair") ((equal? arg-0 7) "%rewrite") ((equal? arg-0 8) "%integerLit") ((equal? arg-0 9) "%stringLit") ((equal? arg-0 10) "%charLit") ((equal? arg-0 11) "%doubleLit") ((equal? arg-0 12) "%name") ((equal? arg-0 13) "%start") ((equal? arg-0 14) "%allow_overloads") ((equal? arg-0 15) "%language") ((equal? arg-0 16) "%default") ((equal? arg-0 17) "%prefix_record_projections") ((equal? arg-0 18) "%auto_implicit_depth") ((equal? arg-0 19) "%nf_metavar_threshold") (else "%search_timeout"))))
(define IdrisC-45SyntaxC-45Pragmas-u--show_Show_PragmaArg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) "nm xs f") ((2) "ty fst snd") ((3) "eq rew") ((4) "on|off") ((5) "[topic]") ((6) "nat") ((7) "expr") ((8) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse "|" csegen-800))) (else "partial|total|covering"))))
(define IdrisC-45SyntaxC-45Pragmas-pragmaTopics (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-0) (string-append "+ " arg-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--kw) (DataC-45String-unwords (cons (IdrisC-45SyntaxC-45Pragmas-u--show_Show_KwPragma u--kw) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45SyntaxC-45Pragmas-u--show_Show_PragmaArg eta-0)) (IdrisC-45SyntaxC-45Pragmas-pragmaArgs u--kw))))) IdrisC-45SyntaxC-45Pragmas-allPragmas)))))
(define CoreC-45Binary-ttcVersion (blodwen-toSignedInt 2023090800 63))
(define IdrisC-45Env-envs (cons (cons "EDITOR" "Editor used in REPL :e command.") (cons (cons "IDRIS2_PREFIX" "Idris2 installation prefix.") (cons (cons "IDRIS2_PATH" "Directories where Idris2 looks for import files.") (cons (cons "IDRIS2_PACKAGE_PATH" "Directories where Idris2 looks for Idris 2 packages.") (cons (cons "IDRIS2_DATA" "Directories where Idris2 looks for data files.") (cons (cons "IDRIS2_LIBS" "Directories where Idris2 looks for libraries (for code generation).") (cons (cons "IDRIS2_CG" "Codegen backend.") (cons (cons "IDRIS2_INC_CGS" "Code generators to use (comma separated) when compiling modules incrementally.") (cons (cons "CHEZ" "Chez backend: chez executable.") (cons (cons "RACKET" "Racket backend: racket executable.") (cons (cons "RACKET_RACO" "Racket backend: raco executable.") (cons (cons "GAMBIT_GSI" "Gambit backend: gsi executable.") (cons (cons "GAMBIT_GSC" "Gambit backend: gsc executable.") (cons (cons "GAMBIT_GSC_BACKEND" "Gambit backend: arguments passed to gsc.") (cons (cons "IDRIS2_CC" "RefC backend: C compiler executable.") (cons (cons "IDRIS2_CFLAGS" "RefC backend: C compiler flags.") (cons (cons "IDRIS2_CPPFLAGS" "RefC backend: C preprocessor flags.") (cons (cons "IDRIS2_LDFLAGS" "RefC backend: C linker flags.") (cons (cons "IDRIS2_LDLIBS" "RefC backend: C linker library names or flags.") (cons (cons "CC" "RefC backend: C compiler executable (IDRIS2_CC takes precedence).") (cons (cons "CFLAGS" "RefC backend: C compiler flags (IDRIS2_CFLAGS takes precedence).") (cons (cons "CPPFLAGS" "RefC backend: C preprocessor flags (IDRIS2_CPPFLAGS takes precedence).") (cons (cons "LDFLAGS" "RefC backend: C linker flags (IDRIS2_LDFLAGS takes precedence).") (cons (cons "LDLIBS" "RefC backend: C linker library names or flags (IDRIS2_LDLIBS takes precedence).") (cons (cons "NODE" "NodeJS backend: NodeJS executable.") (cons (cons "PATH" "PATH variable is used to search for executables in certain codegens.") (cons (cons "NO_COLOR" "Instruct Idris not to print color to stdout. Passing the --color/--colour option will supersede this env var.") '()))))))))))))))))))))))))))))
(define IdrisC-45CommandLine-n--6714-3979-u--showSep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) "" (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) e-2 (string-append e-2 (string-append arg-4 (IdrisC-45CommandLine-n--6714-3979-u--showSep arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))))))
(define IdrisC-45CommandLine-optShow (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (if (null? e-0) (cons "" (box "")) (cons (string-append (IdrisC-45CommandLine-n--6714-3979-u--showSep e-3 e-1 e-2 e-0 ", " e-0) (string-append " " (IdrisC-45CommandLine-n--6714-3979-u--showSep e-3 e-1 e-2 e-0 " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45CommandLine-u--show_Show_OptType eta-0)) e-1)))) e-3))))))))
(define IdrisC-45CommandLine-firstColumnWidth (let ((u--maxOpt (PreludeC-45Types-u--foldr_Foldable_List csegen-1049 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45TypesC-45String-length (Builtin-fst (IdrisC-45CommandLine-optShow eta-0)))) IdrisC-45CommandLine-options)))) (let ((u--maxEnv (PreludeC-45Types-u--foldr_Foldable_List csegen-1049 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45TypesC-45String-length (let ((e-0 (car eta-0))) e-0))) IdrisC-45Env-envs)))) (PreludeC-45Types-u--max_Ord_Nat u--maxOpt u--maxEnv))))
(define IdrisC-45CommandLine-n--6832-4084-u--optUsage (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (u--h) (string-append "  " (string-append e-2 (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() (PreludeC-45Types-prim__integerToNat (- (+ arg-1 2) (PreludeC-45TypesC-45String-length e-2))) #\ )) (string-append u--h "\xa;")))))) e-3)))))
(define IdrisC-45CommandLine-makeTextFromOptionsOrEnvs (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (IdrisC-45CommandLine-n--6832-4084-u--optUsage arg-0 IdrisC-45CommandLine-firstColumnWidth eta-0)) arg-0)))
(define IdrisC-45CommandLine-envsUsage (IdrisC-45CommandLine-makeTextFromOptionsOrEnvs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--e) (cons (let ((e-0 (car u--e))) e-0) (box (let ((e-1 (cdr u--e))) e-1)))) IdrisC-45Env-envs)))
(define IdrisC-45CommandLine-optsUsage (IdrisC-45CommandLine-makeTextFromOptionsOrEnvs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45CommandLine-optShow eta-0)) IdrisC-45CommandLine-options)))
(define LibrariesC-45DataC-45Version-u--show_Show_Version (lambda (ext-0) (LibrariesC-45DataC-45Version-showVersion 1 ext-0)))
(define IdrisC-45CommandLine-versionMsg (string-append "Idris 2, version " (LibrariesC-45DataC-45Version-u--show_Show_Version IdrisC-45Version-version)))
(define IdrisC-45CommandLine-usage (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons IdrisC-45CommandLine-versionMsg (cons "\xa;Usage: idris2 [options] [input file]\xa;\xa;Available options:\xa;" (cons IdrisC-45CommandLine-optsUsage (cons "\xa;Environment variables:\xa;" (cons IdrisC-45CommandLine-envsUsage '())))))))
(define IdrisC-45Driver-quitOpts (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) 1) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((10) (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append IdrisC-45CommandLine-versionMsg "\xa;") world-0))) 0))) ((11) (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (PreludeC-45Show-u--show_Show_Int CoreC-45Binary-ttcVersion) "\xa;") world-0))) 0))) ((12) (let ((e-4 (vector-ref e-2 1))) (if (null? e-4) (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append IdrisC-45CommandLine-usage "\xa;") world-0))) 0)) (let ((e-7 (unbox e-4))) (cond ((equal? e-7 0) (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append CoreC-45OptionsC-45Log-helpTopics "\xa;") world-0))) 0))) ((equal? e-7 1) (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append IdrisC-45SyntaxC-45Pragmas-pragmaTopics "\xa;") world-0))) 0)))(else (IdrisC-45Driver-quitOpts e-3)))))))(else (IdrisC-45Driver-quitOpts e-3))))))))
(define LibrariesC-45UtilsC-45Term-setupTerm (lambda (ext-0) (LibrariesC-45UtilsC-45Term-prim__setupTerm ext-0)))
(define CoreC-45Core-C-42C-62 (lambda (arg-2 arg-3 ext-0) (let ((act-5 (let ((act-5 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-C-42C-62 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-2 (vector-ref arg-9937 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) eta-0 eta-1))))) (let ((act-3 (arg-2 ext-0))) (act-5 act-3))))) (let ((act-3 (arg-3 ext-0))) (act-5 act-3)))))
(define CoreC-45Options-addCG (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 (cons arg-0 e-8) e-9)))))))))))))
(define CoreC-45Context-addBuiltin (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45Context-addDef arg-1 arg-2 (vector CoreC-45FC-emptyFC arg-2 arg-3 '() '() '() '() AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega '() (LibrariesC-45DataC-45WithDefault-specified 2) arg-4 0 (cons (vector 0 ) '()) '() '() 0 0 1 (vector 4 arg-0 arg-5) '() '() '() '()) eta-0)) ext-0)))
(define CoreC-45Context-recordWarning (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 (cons arg-1 e-29) e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setCompiled (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 arg-1 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 (box arg-2) e-20 e-21 e-22))))))))))))))))))))))) eta-1)) clam-0)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getPArgs-7455 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-7 "Badly formed struct type") clam-0) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-7 "Badly formed struct type") clam-0) (let ((e-4 (car e-2))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((8) (let ((e-3 (vector-ref e-6 2))) (case (vector-ref e-3 0) ((10) (let ((e-8 (vector-ref e-3 1))) (vector 1 (cons e-8 e-1))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc e-6) "Unknown field name") clam-1)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc e-6) "Unknown field name") clam-1)))))) eff-0) clam-0)))))))))))))
(define CompilerC-45CompileExpr-getPArgs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((2) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((_-0 (vector 2 e-1 e-2 e-3 e-4 e-6))) (CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getPArgs-7455 arg-2 arg-1 arg-0 e-2 e-3 e-4 e-6 e-1 _-0 (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-6))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc e-5) "Badly formed struct type") eta-0)))))) eff-0) ext-0)))))))
(define CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getFieldArgs-7662 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (vector 1 '())) (let ((e-2 (cdr arg-9))) (if (null? e-2) (lambda (eta-0) (vector 1 '())) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (let ((act-1 (CompilerC-45CompileExpr-getFieldArgs arg-2 arg-1 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45CompileExpr-getPArgs arg-2 arg-1 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-10 (car e-9))) (let ((e-3 (cdr e-9))) (vector 1 (cons (cons e-10 e-3) e-6))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (vector 1 '())))))))))))))
(define CompilerC-45CompileExpr-getFieldArgs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((2) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((_-0 (vector 2 e-1 e-2 e-3 e-4 e-6))) (CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32getFieldArgs-7662 arg-2 arg-1 arg-0 e-2 e-3 e-4 e-6 e-1 _-0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-6)))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc e-5) "Badly formed struct type") eta-0)))))) eff-0) ext-0)))))))
(define CompilerC-45CompileExpr-getNArgs (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (cond ((equal? e-3 "IORes") (lambda (clam-0) (if (null? arg-3) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-5 (car arg-3))) (let ((e-6 (cdr arg-3))) (if (null? e-6) (vector 1 (vector 7 e-5)) (vector 1 (vector 0 arg-2 arg-3)))))))) ((equal? e-3 "Ptr") (lambda (clam-1) (if (null? arg-3) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-10 (cdr arg-3))) (if (null? e-10) (vector 1 (vector 3 )) (vector 1 (vector 0 arg-2 arg-3))))))) ((equal? e-3 "AnyPtr") (lambda (clam-2) (if (null? arg-3) (vector 1 (vector 3 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "GCPtr") (lambda (clam-2) (if (null? arg-3) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-15 (cdr arg-3))) (if (null? e-15) (vector 1 (vector 4 )) (vector 1 (vector 0 arg-2 arg-3))))))) ((equal? e-3 "GCAnyPtr") (lambda (clam-4) (if (null? arg-3) (vector 1 (vector 4 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "Buffer") (lambda (clam-5) (if (null? arg-3) (vector 1 (vector 5 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "ForeignObj") (lambda (clam-6) (if (null? arg-3) (vector 1 (vector 6 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "Unit") (lambda (clam-7) (if (null? arg-3) (vector 1 (vector 2 )) (vector 1 (vector 0 arg-2 arg-3))))) ((equal? e-3 "Struct") (if (null? arg-3) (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3))) (let ((e-22 (car arg-3))) (let ((e-23 (cdr arg-3))) (lambda (clam-3) (if (null? e-23) (vector 1 (vector 0 arg-2 arg-3)) (let ((e-25 (car e-23))) (let ((e-26 (cdr e-23))) (if (null? e-26) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-22) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-4) (case (vector-ref e-5 0) ((8) (let ((e-4 (vector-ref e-5 2))) (case (vector-ref e-4 0) ((10) (let ((e-7 (vector-ref e-4 1))) (let ((act-2 (CompilerC-45CompileExpr-getFieldArgs arg-0 arg-1 e-25 clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-8))))) eff-0) clam-4)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc e-5) "Unknown name for struct") clam-4)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc e-5) "Unknown name for struct") clam-4)))))) eff-0) clam-3))))) (vector 1 (vector 0 arg-2 arg-3)))))))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))(else (lambda (eta-0) (vector 1 (vector 0 arg-2 arg-3)))))))
(define CompilerC-45CompileExpr-nfToCFType (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-41 (vector-ref arg-3 2))) (case (vector-ref e-41 0) ((13) (let ((e-42 (vector-ref e-41 1))) (cond ((equal? e-42 0) (lambda (eta-0) (vector 1 (vector 1 )))) ((equal? e-42 5) (lambda (eta-0) (vector 1 (vector 2 )))) ((equal? e-42 6) (lambda (eta-0) (vector 1 (vector 7 )))) ((equal? e-42 7) (lambda (eta-0) (vector 1 (vector 8 )))) ((equal? e-42 8) (lambda (eta-0) (vector 1 (vector 9 )))) ((equal? e-42 9) (lambda (eta-0) (vector 1 (vector 10 )))) ((equal? e-42 1) (lambda (eta-0) (vector 1 (vector 3 )))) ((equal? e-42 2) (lambda (eta-0) (vector 1 (vector 4 )))) ((equal? e-42 3) (lambda (eta-0) (vector 1 (vector 5 )))) ((equal? e-42 4) (lambda (eta-0) (vector 1 (vector 6 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((8) (let ((e-33 (vector-ref arg-3 2))) (case (vector-ref e-33 0) ((13) (let ((e-34 (vector-ref e-33 1))) (cond ((equal? e-34 10) (lambda (eta-0) (vector 1 (vector 11 ))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-0) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-1))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-2) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-2))))))))) e-9 '()) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-1)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-1))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))(else (lambda (clam-3) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-4) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-4))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-4))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-5) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-5))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-5))))))))) e-9 '()) clam-4))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-4)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-4))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-4))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))))))) ((equal? arg-2 1) (lambda (clam-1) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-1)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-7) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-7))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-7))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-8) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-8))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-8))))))))) e-9 '()) clam-7))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-7)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-7))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-7))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))))(else (lambda (clam-9) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-10) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-10))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-10))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-11) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-11))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-11))))))))) e-9 '()) clam-10))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-10)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-10))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-10))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-2) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-13) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-13))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-13))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-14) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-14))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-14))))))))) e-9 '()) clam-13))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-13)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-13))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-13))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))))))))(else (lambda (clam-15) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-16) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-16))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-16))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-17) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-17))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-17))))))))) e-9 '()) clam-16))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-16)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-16))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-16))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-15))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-15))))))))))) ((equal? arg-2 1) (lambda (clam-3) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-3)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-19) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-19))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-19))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-20) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-20))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-20))))))))) e-9 '()) clam-19))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-19)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-19))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-19))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))))))(else (lambda (clam-21) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-22) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-22))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-22))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-23) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-23))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-23))))))))) e-9 '()) clam-22))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-22)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-22))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-22))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-21))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-21))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-4) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-25) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-25))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-25))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-26) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-26))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-26))))))))) e-9 '()) clam-25))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-25)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-25))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-25))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4))))))))))))))(else (lambda (clam-27) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-28) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-28))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-28))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-29) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-29))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-29))))))))) e-9 '()) clam-28))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-28)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-28))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-28))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-27))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-27))))))))))) ((equal? arg-2 1) (lambda (clam-5) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-5)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-31) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-31))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-31))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-32) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-32))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-32))))))))) e-9 '()) clam-31))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-31)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-31))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-31))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5)))))))))))(else (lambda (clam-33) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-34) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-34))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-34))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-35) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-35))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-35))))))))) e-9 '()) clam-34))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-34)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-34))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-34))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-33))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-33))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-6) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-37) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-37))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-37))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-38) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-38))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-38))))))))) e-9 '()) clam-37))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-37)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-37))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-37))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6))))))))))))))(else (lambda (clam-39) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-40) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-40))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-40))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-41) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-41))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-41))))))))) e-9 '()) clam-40))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-40)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-40))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-40))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-39))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-39))))))))))) ((equal? arg-2 1) (lambda (clam-7) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-7)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-43) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-43))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-43))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-44) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-44))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-44))))))))) e-9 '()) clam-43))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-43)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-43))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-43))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7)))))))))))(else (lambda (clam-45) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-46) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-46))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-46))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-47) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-47))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-47))))))))) e-9 '()) clam-46))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-46)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-46))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-46))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-45))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-45))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-8) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-8)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-49) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-49))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-49))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-50) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-50))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-50))))))))) e-9 '()) clam-49))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-49)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-49))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-49))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-8))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-8))))))))))))))(else (lambda (clam-51) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-52) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-52))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-52))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-53) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-53))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-53))))))))) e-9 '()) clam-52))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-52)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-52))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-52))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-51))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-51))))))))))) ((equal? arg-2 1) (lambda (clam-9) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-9)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-55) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-55))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-55))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-56) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-56))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-56))))))))) e-9 '()) clam-55))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-55)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-55))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-55))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9)))))))))))(else (lambda (clam-57) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-58) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-58))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-58))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-59) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-59))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-59))))))))) e-9 '()) clam-58))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-58)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-58))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-58))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-57))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-57))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-10) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-10)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-61) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-61))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-61))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-62) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-62))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-62))))))))) e-9 '()) clam-61))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-61)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-61))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-61))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-10))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-10))))))))))))))(else (lambda (clam-63) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-64) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-64))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-64))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-65) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-65))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-65))))))))) e-9 '()) clam-64))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-64)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-64))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-64))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-63))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-63))))))))))) ((equal? arg-2 1) (lambda (clam-11) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-11)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-67) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-67))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-67))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-68) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-68))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-68))))))))) e-9 '()) clam-67))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-67)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-67))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-67))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-11))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-11)))))))))))(else (lambda (clam-69) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-70) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-70))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-70))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-71) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-71))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-71))))))))) e-9 '()) clam-70))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-70)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-70))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-70))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-69))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-69))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-12) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-12)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-73) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-73))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-73))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-74) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-74))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-74))))))))) e-9 '()) clam-73))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-73)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-73))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-73))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-12))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-12))))))))))))))(else (lambda (clam-75) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-76) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-76))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-76))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-77) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-77))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-77))))))))) e-9 '()) clam-76))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-76)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-76))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-76))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-75))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-75))))))))))) ((equal? arg-2 1) (lambda (clam-13) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-13)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-79) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-79))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-79))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-80) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-80))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-80))))))))) e-9 '()) clam-79))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-79)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-79))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-79))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-13))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-13)))))))))))(else (lambda (clam-81) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-82) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-82))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-82))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-83) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-83))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-83))))))))) e-9 '()) clam-82))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-82)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-82))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-82))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-81))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-81))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-14) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-14)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-85) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-85))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-85))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-86) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-86))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-86))))))))) e-9 '()) clam-85))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-85)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-85))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-85))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-14))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-14))))))))))))))(else (lambda (clam-87) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-88) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-88))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-88))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-89) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-89))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-89))))))))) e-9 '()) clam-88))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-88)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-88))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-88))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-87))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-87))))))))))) ((equal? arg-2 1) (lambda (clam-15) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-15)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-91) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-91))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-91))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-92) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-92))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-92))))))))) e-9 '()) clam-91))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-91)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-91))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-91))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-15))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-15)))))))))))(else (lambda (clam-93) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-94) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-94))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-94))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-95) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-95))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-95))))))))) e-9 '()) clam-94))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-94)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-94))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-94))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-93))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-93))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-16) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-16)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-97) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-97))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-97))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-98) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-98))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-98))))))))) e-9 '()) clam-97))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-97)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-97))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-97))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-16))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-16))))))))))))))(else (lambda (clam-99) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-100) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-100))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-100))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-101) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-101))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-101))))))))) e-9 '()) clam-100))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-100)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-100))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-100))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-99))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-99))))))))))) ((equal? arg-2 1) (lambda (clam-17) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-17)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-103) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-103))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-103))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-104) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-104))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-104))))))))) e-9 '()) clam-103))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-103)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-103))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-103))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-17))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-17)))))))))))(else (lambda (clam-105) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-106) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-106))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-106))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-107) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-107))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-107))))))))) e-9 '()) clam-106))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-106)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-106))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-106))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-105))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-105))))))))))))))) ((equal? arg-2 1) (case (vector-ref arg-3 0) ((8) (let ((e-37 (vector-ref arg-3 2))) (case (vector-ref e-37 0) ((13) (let ((e-38 (vector-ref e-37 1))) (cond ((equal? e-38 10) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "String not allowed in a foreign struct") eta-0)))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-18) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-18)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-109) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-109))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-109))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-110) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-110))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-110))))))))) e-9 '()) clam-109))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-109)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-109))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-109))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-18))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-18))))))))))))))(else (lambda (clam-111) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-112) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-112))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-112))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-113) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-113))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-113))))))))) e-9 '()) clam-112))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-112)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-112))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-112))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-111))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-111))))))))))) ((equal? arg-2 1) (lambda (clam-19) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-19)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-115) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-115))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-115))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-116) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-116))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-116))))))))) e-9 '()) clam-115))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-115)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-115))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-115))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-19))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-19)))))))))))(else (lambda (clam-117) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-118) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-118))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-118))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-119) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-119))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-119))))))))) e-9 '()) clam-118))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-118)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-118))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-118))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-117))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-117))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-20) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-20)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-121) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-121))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-121))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-122) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-122))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-122))))))))) e-9 '()) clam-121))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-121)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-121))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-121))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-20))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-20))))))))))))))(else (lambda (clam-123) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-124) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-124))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-124))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-125) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-125))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-125))))))))) e-9 '()) clam-124))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-124)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-124))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-124))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-123))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-123))))))))))) ((equal? arg-2 1) (lambda (clam-21) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-21)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-127) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-127))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-127))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-128) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-128))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-128))))))))) e-9 '()) clam-127))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-127)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-127))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-127))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-21))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-21)))))))))))(else (lambda (clam-129) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-130) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-130))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-130))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-131) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-131))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-131))))))))) e-9 '()) clam-130))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-130)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-130))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-130))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-129))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-129))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-22) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-22)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-133) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-133))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-133))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-134) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-134))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-134))))))))) e-9 '()) clam-133))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-133)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-133))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-133))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-22))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-22))))))))))))))(else (lambda (clam-135) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-136) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-136))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-136))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-137) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-137))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-137))))))))) e-9 '()) clam-136))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-136)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-136))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-136))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-135))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-135))))))))))) ((equal? arg-2 1) (lambda (clam-23) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-23)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-139) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-139))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-139))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-140) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-140))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-140))))))))) e-9 '()) clam-139))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-139)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-139))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-139))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-23))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-23)))))))))))(else (lambda (clam-141) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-142) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-142))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-142))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-143) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-143))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-143))))))))) e-9 '()) clam-142))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-142)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-142))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-142))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-141))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-141))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-24) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-24)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-145) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-145))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-145))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-146) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-146))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-146))))))))) e-9 '()) clam-145))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-145)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-145))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-145))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-24))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-24))))))))))))))(else (lambda (clam-147) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-148) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-148))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-148))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-149) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-149))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-149))))))))) e-9 '()) clam-148))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-148)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-148))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-148))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-147))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-147))))))))))) ((equal? arg-2 1) (lambda (clam-25) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-25)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-151) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-151))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-151))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-152) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-152))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-152))))))))) e-9 '()) clam-151))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-151)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-151))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-151))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-25))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-25)))))))))))(else (lambda (clam-153) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-154) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-154))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-154))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-155) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-155))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-155))))))))) e-9 '()) clam-154))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-154)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-154))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-154))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-153))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-153))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-26) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-26)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-157) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-157))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-157))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-158) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-158))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-158))))))))) e-9 '()) clam-157))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-157)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-157))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-157))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-26))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-26))))))))))))))(else (lambda (clam-159) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-160) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-160))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-160))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-161) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-161))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-161))))))))) e-9 '()) clam-160))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-160)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-160))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-160))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-159))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-159))))))))))) ((equal? arg-2 1) (lambda (clam-27) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-27)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-163) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-163))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-163))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-164) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-164))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-164))))))))) e-9 '()) clam-163))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-163)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-163))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-163))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-27))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-27)))))))))))(else (lambda (clam-165) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-166) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-166))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-166))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-167) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-167))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-167))))))))) e-9 '()) clam-166))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-166)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-166))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-166))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-165))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-165))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-28) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-28)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-169) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-169))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-169))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-170) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-170))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-170))))))))) e-9 '()) clam-169))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-169)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-169))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-169))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-28))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-28))))))))))))))(else (lambda (clam-171) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-172) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-172))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-172))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-173) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-173))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-173))))))))) e-9 '()) clam-172))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-172)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-172))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-172))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-171))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-171))))))))))) ((equal? arg-2 1) (lambda (clam-29) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-29)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-175) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-175))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-175))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-176) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-176))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-176))))))))) e-9 '()) clam-175))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-175)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-175))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-175))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-29))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-29)))))))))))(else (lambda (clam-177) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-178) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-178))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-178))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-179) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-179))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-179))))))))) e-9 '()) clam-178))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-178)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-178))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-178))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-177))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-177))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-30) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-30)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-181) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-181))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-181))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-182) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-182))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-182))))))))) e-9 '()) clam-181))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-181)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-181))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-181))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-30))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-30))))))))))))))(else (lambda (clam-183) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-184) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-184))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-184))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-185) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-185))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-185))))))))) e-9 '()) clam-184))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-184)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-184))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-184))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-183))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-183))))))))))) ((equal? arg-2 1) (lambda (clam-31) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-31)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-187) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-187))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-187))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-188) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-188))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-188))))))))) e-9 '()) clam-187))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-187)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-187))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-187))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-31))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-31)))))))))))(else (lambda (clam-189) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-190) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-190))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-190))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-191) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-191))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-191))))))))) e-9 '()) clam-190))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-190)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-190))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-190))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-189))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-189))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-32) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-32)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-193) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-193))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-193))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-194) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-194))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-194))))))))) e-9 '()) clam-193))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-193)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-193))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-193))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-32))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-32))))))))))))))(else (lambda (clam-195) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-196) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-196))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-196))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-197) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-197))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-197))))))))) e-9 '()) clam-196))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-196)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-196))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-196))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-195))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-195))))))))))) ((equal? arg-2 1) (lambda (clam-33) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-33)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-199) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-199))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-199))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-200) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-200))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-200))))))))) e-9 '()) clam-199))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-199)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-199))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-199))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-33))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-33)))))))))))(else (lambda (clam-201) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-202) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-202))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-202))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-203) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-203))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-203))))))))) e-9 '()) clam-202))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-202)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-202))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-202))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-201))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-201))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-34) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-34)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-205) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-205))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-205))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-206) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-206))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-206))))))))) e-9 '()) clam-205))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-205)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-205))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-205))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-34))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-34))))))))))))))(else (lambda (clam-207) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-208) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-208))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-208))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-209) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-209))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-209))))))))) e-9 '()) clam-208))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-208)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-208))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-208))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-207))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-207))))))))))) ((equal? arg-2 1) (lambda (clam-35) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-35)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-211) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-211))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-211))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-212) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-212))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-212))))))))) e-9 '()) clam-211))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-211)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-211))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-211))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-35))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-35)))))))))))(else (lambda (clam-213) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-214) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-214))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-214))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-215) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-215))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-215))))))))) e-9 '()) clam-214))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-214)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-214))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-214))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-213))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-213)))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-36) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-36)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-217) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-217))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-217))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-218) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-218))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-218))))))))) e-9 '()) clam-217))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-217)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-217))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-217))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-36))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-36))))))))))))))(else (lambda (clam-219) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-220) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-220))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-220))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-221) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-221))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-221))))))))) e-9 '()) clam-220))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-220)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-220))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-220))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-219))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-219))))))))))) ((equal? arg-2 1) (lambda (clam-37) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-37)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-223) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-223))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-223))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-224) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-224))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-224))))))))) e-9 '()) clam-223))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-223)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-223))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-223))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-37))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-37)))))))))))(else (lambda (clam-225) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-226) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-226))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-226))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-227) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-227))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-227))))))))) e-9 '()) clam-226))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-226)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-226))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-226))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-225))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-225))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-38) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-38)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-229) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-229))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-229))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-230) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-230))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-230))))))))) e-9 '()) clam-229))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-229)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-229))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-229))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-38))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-38))))))))))))))(else (lambda (clam-231) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-232) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-232))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-232))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-233) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-233))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-233))))))))) e-9 '()) clam-232))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-232)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-232))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-232))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-231))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-231))))))))))) ((equal? arg-2 1) (lambda (clam-39) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-39)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-235) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-235))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-235))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-236) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-236))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-236))))))))) e-9 '()) clam-235))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-235)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-235))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-235))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-39))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-39)))))))))))(else (lambda (clam-237) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-238) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-238))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-238))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-239) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-239))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-239))))))))) e-9 '()) clam-238))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-238)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-238))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-238))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-237))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-237))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-40) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-40)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-241) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-241))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-241))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-242) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-242))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-242))))))))) e-9 '()) clam-241))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-241)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-241))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-241))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-40))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-40))))))))))))))(else (lambda (clam-243) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-244) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-244))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-244))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-245) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-245))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-245))))))))) e-9 '()) clam-244))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-244)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-244))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-244))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-243))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-243))))))))))) ((equal? arg-2 1) (lambda (clam-41) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-41)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-247) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-247))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-247))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-248) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-248))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-248))))))))) e-9 '()) clam-247))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-247)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-247))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-247))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-41))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-41)))))))))))(else (lambda (clam-249) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-250) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-250))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-250))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-251) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-251))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-251))))))))) e-9 '()) clam-250))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-250)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-250))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-250))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-249))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-249))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((8) (let ((e-33 (vector-ref arg-3 2))) (case (vector-ref e-33 0) ((13) (let ((e-34 (vector-ref e-33 1))) (cond ((equal? e-34 10) (lambda (eta-0) (vector 1 (vector 11 ))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-42) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-42)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-253) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-253))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-253))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-254) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-254))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-254))))))))) e-9 '()) clam-253))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-253)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-253))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-253))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-42))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-42))))))))))))))(else (lambda (clam-255) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-256) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-256))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-256))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-257) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-257))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-257))))))))) e-9 '()) clam-256))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-256)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-256))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-256))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-255))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-255))))))))))) ((equal? arg-2 1) (lambda (clam-43) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-43)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-259) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-259))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-259))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-260) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-260))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-260))))))))) e-9 '()) clam-259))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-259)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-259))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-259))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-43))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-43)))))))))))(else (lambda (clam-261) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-262) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-262))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-262))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-263) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-263))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-263))))))))) e-9 '()) clam-262))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-262)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-262))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-262))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-261))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-261))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-44) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-44)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-265) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-265))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-265))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-266) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-266))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-266))))))))) e-9 '()) clam-265))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-265)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-265))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-265))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-44))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-44))))))))))))))(else (lambda (clam-267) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-268) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-268))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-268))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-269) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-269))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-269))))))))) e-9 '()) clam-268))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-268)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-268))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-268))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-267))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-267))))))))))) ((equal? arg-2 1) (lambda (clam-45) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-45)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-271) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-271))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-271))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-272) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-272))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-272))))))))) e-9 '()) clam-271))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-271)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-271))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-271))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-45))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-45)))))))))))(else (lambda (clam-273) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-274) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-274))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-274))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-275) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-275))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-275))))))))) e-9 '()) clam-274))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-274)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-274))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-274))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-273))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-273))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-46) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-46)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-277) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-277))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-277))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-278) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-278))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-278))))))))) e-9 '()) clam-277))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-277)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-277))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-277))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-46))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-46))))))))))))))(else (lambda (clam-279) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-280) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-280))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-280))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-281) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-281))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-281))))))))) e-9 '()) clam-280))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-280)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-280))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-280))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-279))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-279))))))))))) ((equal? arg-2 1) (lambda (clam-47) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-47)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-283) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-283))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-283))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-284) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-284))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-284))))))))) e-9 '()) clam-283))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-283)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-283))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-283))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-47))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-47)))))))))))(else (lambda (clam-285) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-286) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-286))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-286))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-287) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-287))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-287))))))))) e-9 '()) clam-286))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-286)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-286))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-286))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-285))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-285))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-48) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-48)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-289) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-289))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-289))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-290) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-290))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-290))))))))) e-9 '()) clam-289))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-289)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-289))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-289))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-48))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-48))))))))))))))(else (lambda (clam-291) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-292) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-292))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-292))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-293) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-293))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-293))))))))) e-9 '()) clam-292))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-292)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-292))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-292))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-291))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-291))))))))))) ((equal? arg-2 1) (lambda (clam-49) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-49)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-295) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-295))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-295))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-296) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-296))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-296))))))))) e-9 '()) clam-295))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-295)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-295))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-295))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-49))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-49)))))))))))(else (lambda (clam-297) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-298) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-298))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-298))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-299) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-299))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-299))))))))) e-9 '()) clam-298))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-298)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-298))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-298))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-297))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-297))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-50) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-50)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-301) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-301))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-301))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-302) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-302))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-302))))))))) e-9 '()) clam-301))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-301)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-301))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-301))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-50))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-50))))))))))))))(else (lambda (clam-303) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-304) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-304))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-304))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-305) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-305))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-305))))))))) e-9 '()) clam-304))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-304)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-304))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-304))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-303))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-303))))))))))) ((equal? arg-2 1) (lambda (clam-51) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-51)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-307) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-307))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-307))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-308) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-308))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-308))))))))) e-9 '()) clam-307))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-307)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-307))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-307))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-51))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-51)))))))))))(else (lambda (clam-309) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-310) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-310))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-310))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-311) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-311))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-311))))))))) e-9 '()) clam-310))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-310)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-310))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-310))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-309))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-309))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-52) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-52)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-313) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-313))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-313))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-314) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-314))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-314))))))))) e-9 '()) clam-313))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-313)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-313))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-313))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-52))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-52))))))))))))))(else (lambda (clam-315) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-316) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-316))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-316))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-317) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-317))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-317))))))))) e-9 '()) clam-316))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-316)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-316))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-316))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-315))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-315))))))))))) ((equal? arg-2 1) (lambda (clam-53) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-53)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-319) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-319))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-319))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-320) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-320))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-320))))))))) e-9 '()) clam-319))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-319)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-319))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-319))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-53))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-53)))))))))))(else (lambda (clam-321) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-322) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-322))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-322))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-323) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-323))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-323))))))))) e-9 '()) clam-322))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-322)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-322))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-322))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-321))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-321))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-54) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-54)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-325) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-325))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-325))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-326) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-326))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-326))))))))) e-9 '()) clam-325))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-325)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-325))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-325))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-54))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-54))))))))))))))(else (lambda (clam-327) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-328) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-328))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-328))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-329) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-329))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-329))))))))) e-9 '()) clam-328))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-328)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-328))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-328))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-327))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-327))))))))))) ((equal? arg-2 1) (lambda (clam-55) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-55)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-331) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-331))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-331))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-332) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-332))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-332))))))))) e-9 '()) clam-331))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-331)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-331))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-331))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-55))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-55)))))))))))(else (lambda (clam-333) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-334) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-334))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-334))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-335) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-335))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-335))))))))) e-9 '()) clam-334))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-334)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-334))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-334))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-333))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-333))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-56) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-56)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-337) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-337))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-337))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-338) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-338))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-338))))))))) e-9 '()) clam-337))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-337)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-337))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-337))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-56))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-56))))))))))))))(else (lambda (clam-339) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-340) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-340))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-340))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-341) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-341))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-341))))))))) e-9 '()) clam-340))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-340)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-340))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-340))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-339))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-339))))))))))) ((equal? arg-2 1) (lambda (clam-57) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-57)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-343) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-343))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-343))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-344) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-344))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-344))))))))) e-9 '()) clam-343))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-343)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-343))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-343))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-57))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-57)))))))))))(else (lambda (clam-345) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-346) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-346))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-346))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-347) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-347))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-347))))))))) e-9 '()) clam-346))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-346)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-346))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-346))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-345))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-345))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-58) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-58)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-349) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-349))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-349))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-350) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-350))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-350))))))))) e-9 '()) clam-349))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-349)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-349))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-349))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-58))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-58))))))))))))))(else (lambda (clam-351) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-352) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-352))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-352))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-353) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-353))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-353))))))))) e-9 '()) clam-352))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-352)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-352))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-352))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-351))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-351))))))))))) ((equal? arg-2 1) (lambda (clam-59) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-59)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-355) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-355))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-355))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-356) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-356))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-356))))))))) e-9 '()) clam-355))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-355)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-355))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-355))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-59))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-59)))))))))))(else (lambda (clam-357) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-358) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-358))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-358))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-359) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-359))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-359))))))))) e-9 '()) clam-358))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-358)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-358))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-358))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-357))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-357))))))))))))))) ((equal? arg-2 1) (case (vector-ref arg-3 0) ((8) (let ((e-37 (vector-ref arg-3 2))) (case (vector-ref e-37 0) ((13) (let ((e-38 (vector-ref e-37 1))) (cond ((equal? e-38 10) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "String not allowed in a foreign struct") eta-0)))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-60) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-60)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-361) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-361))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-361))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-362) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-362))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-362))))))))) e-9 '()) clam-361))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-361)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-361))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-361))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-60))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-60))))))))))))))(else (lambda (clam-363) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-364) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-364))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-364))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-365) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-365))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-365))))))))) e-9 '()) clam-364))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-364)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-364))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-364))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-363))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-363))))))))))) ((equal? arg-2 1) (lambda (clam-61) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-61)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-367) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-367))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-367))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-368) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-368))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-368))))))))) e-9 '()) clam-367))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-367)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-367))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-367))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-61))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-61)))))))))))(else (lambda (clam-369) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-370) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-370))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-370))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-371) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-371))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-371))))))))) e-9 '()) clam-370))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-370)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-370))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-370))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-369))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-369))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-62) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-62)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-373) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-373))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-373))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-374) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-374))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-374))))))))) e-9 '()) clam-373))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-373)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-373))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-373))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-62))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-62))))))))))))))(else (lambda (clam-375) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-376) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-376))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-376))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-377) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-377))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-377))))))))) e-9 '()) clam-376))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-376)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-376))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-376))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-375))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-375))))))))))) ((equal? arg-2 1) (lambda (clam-63) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-63)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-379) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-379))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-379))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-380) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-380))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-380))))))))) e-9 '()) clam-379))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-379)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-379))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-379))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-63))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-63)))))))))))(else (lambda (clam-381) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-382) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-382))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-382))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-383) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-383))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-383))))))))) e-9 '()) clam-382))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-382)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-382))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-382))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-381))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-381))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-64) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-64)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-385) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-385))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-385))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-386) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-386))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-386))))))))) e-9 '()) clam-385))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-385)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-385))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-385))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-64))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-64))))))))))))))(else (lambda (clam-387) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-388) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-388))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-388))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-389) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-389))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-389))))))))) e-9 '()) clam-388))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-388)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-388))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-388))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-387))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-387))))))))))) ((equal? arg-2 1) (lambda (clam-65) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-65)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-391) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-391))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-391))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-392) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-392))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-392))))))))) e-9 '()) clam-391))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-391)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-391))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-391))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-65))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-65)))))))))))(else (lambda (clam-393) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-394) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-394))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-394))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-395) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-395))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-395))))))))) e-9 '()) clam-394))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-394)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-394))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-394))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-393))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-393))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-66) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-66)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-397) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-397))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-397))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-398) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-398))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-398))))))))) e-9 '()) clam-397))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-397)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-397))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-397))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-66))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-66))))))))))))))(else (lambda (clam-399) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-400) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-400))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-400))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-401) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-401))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-401))))))))) e-9 '()) clam-400))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-400)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-400))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-400))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-399))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-399))))))))))) ((equal? arg-2 1) (lambda (clam-67) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-67)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-403) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-403))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-403))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-404) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-404))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-404))))))))) e-9 '()) clam-403))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-403)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-403))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-403))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-67))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-67)))))))))))(else (lambda (clam-405) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-406) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-406))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-406))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-407) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-407))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-407))))))))) e-9 '()) clam-406))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-406)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-406))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-406))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-405))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-405))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-68) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-68)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-409) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-409))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-409))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-410) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-410))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-410))))))))) e-9 '()) clam-409))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-409)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-409))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-409))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-68))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-68))))))))))))))(else (lambda (clam-411) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-412) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-412))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-412))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-413) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-413))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-413))))))))) e-9 '()) clam-412))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-412)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-412))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-412))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-411))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-411))))))))))) ((equal? arg-2 1) (lambda (clam-69) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-69)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-415) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-415))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-415))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-416) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-416))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-416))))))))) e-9 '()) clam-415))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-415)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-415))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-415))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-69))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-69)))))))))))(else (lambda (clam-417) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-418) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-418))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-418))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-419) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-419))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-419))))))))) e-9 '()) clam-418))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-418)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-418))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-418))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-417))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-417))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-70) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-70)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-421) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-421))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-421))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-422) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-422))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-422))))))))) e-9 '()) clam-421))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-421)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-421))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-421))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-70))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-70))))))))))))))(else (lambda (clam-423) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-424) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-424))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-424))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-425) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-425))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-425))))))))) e-9 '()) clam-424))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-424)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-424))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-424))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-423))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-423))))))))))) ((equal? arg-2 1) (lambda (clam-71) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-71)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-427) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-427))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-427))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-428) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-428))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-428))))))))) e-9 '()) clam-427))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-427)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-427))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-427))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-71))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-71)))))))))))(else (lambda (clam-429) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-430) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-430))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-430))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-431) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-431))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-431))))))))) e-9 '()) clam-430))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-430)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-430))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-430))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-429))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-429))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-72) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-72)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-433) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-433))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-433))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-434) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-434))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-434))))))))) e-9 '()) clam-433))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-433)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-433))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-433))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-72))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-72))))))))))))))(else (lambda (clam-435) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-436) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-436))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-436))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-437) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-437))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-437))))))))) e-9 '()) clam-436))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-436)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-436))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-436))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-435))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-435))))))))))) ((equal? arg-2 1) (lambda (clam-73) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-73)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-439) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-439))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-439))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-440) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-440))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-440))))))))) e-9 '()) clam-439))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-439)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-439))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-439))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-73))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-73)))))))))))(else (lambda (clam-441) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-442) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-442))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-442))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-443) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-443))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-443))))))))) e-9 '()) clam-442))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-442)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-442))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-442))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-441))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-441))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-74) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-74)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-445) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-445))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-445))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-446) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-446))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-446))))))))) e-9 '()) clam-445))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-445)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-445))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-445))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-74))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-74))))))))))))))(else (lambda (clam-447) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-448) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-448))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-448))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-449) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-449))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-449))))))))) e-9 '()) clam-448))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-448)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-448))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-448))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-447))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-447))))))))))) ((equal? arg-2 1) (lambda (clam-75) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-75)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-451) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-451))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-451))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-452) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-452))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-452))))))))) e-9 '()) clam-451))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-451)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-451))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-451))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-75))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-75)))))))))))(else (lambda (clam-453) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-454) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-454))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-454))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-455) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-455))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-455))))))))) e-9 '()) clam-454))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-454)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-454))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-454))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-453))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-453))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-76) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-76)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-457) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-457))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-457))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-458) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-458))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-458))))))))) e-9 '()) clam-457))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-457)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-457))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-457))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-76))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-76))))))))))))))(else (lambda (clam-459) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-460) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-460))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-460))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-461) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-461))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-461))))))))) e-9 '()) clam-460))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-460)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-460))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-460))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-459))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-459))))))))))) ((equal? arg-2 1) (lambda (clam-77) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-77)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-463) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-463))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-463))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-464) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-464))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-464))))))))) e-9 '()) clam-463))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-463)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-463))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-463))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-77))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-77)))))))))))(else (lambda (clam-465) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-466) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-466))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-466))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-467) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-467))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-467))))))))) e-9 '()) clam-466))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-466)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-466))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-466))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-465))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-465)))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-78) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-78)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-469) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-469))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-469))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-470) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-470))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-470))))))))) e-9 '()) clam-469))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-469)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-469))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-469))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-78))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-78))))))))))))))(else (lambda (clam-471) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-472) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-472))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-472))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-473) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-473))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-473))))))))) e-9 '()) clam-472))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-472)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-472))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-472))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-471))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-471))))))))))) ((equal? arg-2 1) (lambda (clam-79) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-79)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-475) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-475))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-475))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-476) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-476))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-476))))))))) e-9 '()) clam-475))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-475)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-475))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-475))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-79))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-79)))))))))))(else (lambda (clam-477) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-478) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-478))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-478))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-479) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-479))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-479))))))))) e-9 '()) clam-478))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-478)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-478))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-478))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-477))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-477))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-80) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-80)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-481) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-481))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-481))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-482) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-482))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-482))))))))) e-9 '()) clam-481))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-481)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-481))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-481))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-80))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-80))))))))))))))(else (lambda (clam-483) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-484) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-484))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-484))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-485) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-485))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-485))))))))) e-9 '()) clam-484))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-484)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-484))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-484))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-483))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-483))))))))))) ((equal? arg-2 1) (lambda (clam-81) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-81)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-487) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-487))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-487))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-488) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-488))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-488))))))))) e-9 '()) clam-487))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-487)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-487))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-487))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-81))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-81)))))))))))(else (lambda (clam-489) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-490) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-490))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-490))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-491) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-491))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-491))))))))) e-9 '()) clam-490))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-490)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-490))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-490))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-489))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-489))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-82) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-82)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-493) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-493))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-493))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-494) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-494))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-494))))))))) e-9 '()) clam-493))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-493)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-493))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-493))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-82))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-82))))))))))))))(else (lambda (clam-495) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-496) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-496))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-496))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-497) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-497))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-497))))))))) e-9 '()) clam-496))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-496)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-496))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-496))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-495))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-495))))))))))) ((equal? arg-2 1) (lambda (clam-83) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-83)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-499) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-499))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-499))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-500) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-500))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-500))))))))) e-9 '()) clam-499))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-499)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-499))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-499))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-83))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-83)))))))))))(else (lambda (clam-501) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-502) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-502))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-502))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-503) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-503))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-503))))))))) e-9 '()) clam-502))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-502)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-502))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-502))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-501))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-501))))))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((8) (let ((e-33 (vector-ref arg-3 2))) (case (vector-ref e-33 0) ((13) (let ((e-34 (vector-ref e-33 1))) (cond ((equal? e-34 10) (lambda (eta-0) (vector 1 (vector 11 ))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-84) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-84)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-505) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-505))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-505))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-506) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-506))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-506))))))))) e-9 '()) clam-505))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-505)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-505))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-505))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-84))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-84))))))))))))))(else (lambda (clam-507) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-508) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-508))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-508))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-509) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-509))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-509))))))))) e-9 '()) clam-508))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-508)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-508))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-508))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-507))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-507))))))))))) ((equal? arg-2 1) (lambda (clam-85) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-85)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-511) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-511))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-511))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-512) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-512))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-512))))))))) e-9 '()) clam-511))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-511)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-511))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-511))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-85))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-85)))))))))))(else (lambda (clam-513) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-514) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-514))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-514))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-515) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-515))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-515))))))))) e-9 '()) clam-514))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-514)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-514))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-514))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-513))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-513))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-86) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-86)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-517) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-517))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-517))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-518) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-518))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-518))))))))) e-9 '()) clam-517))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-517)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-517))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-517))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-86))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-86))))))))))))))(else (lambda (clam-519) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-520) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-520))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-520))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-521) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-521))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-521))))))))) e-9 '()) clam-520))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-520)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-520))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-520))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-519))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-519))))))))))) ((equal? arg-2 1) (lambda (clam-87) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-87)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-523) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-523))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-523))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-524) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-524))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-524))))))))) e-9 '()) clam-523))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-523)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-523))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-523))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-87))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-87)))))))))))(else (lambda (clam-525) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-526) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-526))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-526))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-527) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-527))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-527))))))))) e-9 '()) clam-526))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-526)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-526))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-526))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-525))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-525))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-88) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-88)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-529) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-529))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-529))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-530) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-530))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-530))))))))) e-9 '()) clam-529))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-529)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-529))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-529))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-88))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-88))))))))))))))(else (lambda (clam-531) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-532) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-532))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-532))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-533) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-533))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-533))))))))) e-9 '()) clam-532))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-532)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-532))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-532))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-531))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-531))))))))))) ((equal? arg-2 1) (lambda (clam-89) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-89)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-535) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-535))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-535))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-536) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-536))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-536))))))))) e-9 '()) clam-535))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-535)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-535))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-535))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-89))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-89)))))))))))(else (lambda (clam-537) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-538) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-538))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-538))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-539) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-539))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-539))))))))) e-9 '()) clam-538))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-538)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-538))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-538))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-537))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-537))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-90) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-90)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-541) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-541))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-541))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-542) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-542))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-542))))))))) e-9 '()) clam-541))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-541)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-541))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-541))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-90))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-90))))))))))))))(else (lambda (clam-543) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-544) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-544))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-544))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-545) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-545))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-545))))))))) e-9 '()) clam-544))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-544)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-544))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-544))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-543))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-543))))))))))) ((equal? arg-2 1) (lambda (clam-91) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-91)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-547) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-547))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-547))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-548) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-548))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-548))))))))) e-9 '()) clam-547))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-547)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-547))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-547))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-91))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-91)))))))))))(else (lambda (clam-549) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-550) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-550))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-550))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-551) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-551))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-551))))))))) e-9 '()) clam-550))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-550)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-550))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-550))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-549))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-549))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-92) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-92)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-553) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-553))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-553))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-554) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-554))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-554))))))))) e-9 '()) clam-553))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-553)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-553))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-553))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-92))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-92))))))))))))))(else (lambda (clam-555) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-556) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-556))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-556))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-557) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-557))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-557))))))))) e-9 '()) clam-556))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-556)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-556))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-556))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-555))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-555))))))))))) ((equal? arg-2 1) (lambda (clam-93) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-93)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-559) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-559))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-559))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-560) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-560))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-560))))))))) e-9 '()) clam-559))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-559)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-559))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-559))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-93))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-93)))))))))))(else (lambda (clam-561) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-562) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-562))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-562))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-563) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-563))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-563))))))))) e-9 '()) clam-562))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-562)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-562))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-562))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-561))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-561))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-94) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-94)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-565) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-565))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-565))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-566) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-566))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-566))))))))) e-9 '()) clam-565))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-565)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-565))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-565))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-94))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-94))))))))))))))(else (lambda (clam-567) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-568) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-568))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-568))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-569) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-569))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-569))))))))) e-9 '()) clam-568))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-568)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-568))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-568))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-567))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-567))))))))))) ((equal? arg-2 1) (lambda (clam-95) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-95)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-571) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-571))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-571))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-572) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-572))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-572))))))))) e-9 '()) clam-571))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-571)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-571))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-571))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-95))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-95)))))))))))(else (lambda (clam-573) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-574) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-574))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-574))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-575) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-575))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-575))))))))) e-9 '()) clam-574))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-574)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-574))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-574))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-573))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-573))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-96) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-96)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-577) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-577))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-577))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-578) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-578))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-578))))))))) e-9 '()) clam-577))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-577)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-577))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-577))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-96))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-96))))))))))))))(else (lambda (clam-579) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-580) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-580))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-580))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-581) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-581))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-581))))))))) e-9 '()) clam-580))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-580)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-580))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-580))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-579))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-579))))))))))) ((equal? arg-2 1) (lambda (clam-97) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-97)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-583) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-583))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-583))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-584) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-584))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-584))))))))) e-9 '()) clam-583))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-583)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-583))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-583))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-97))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-97)))))))))))(else (lambda (clam-585) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-586) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-586))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-586))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-587) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-587))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-587))))))))) e-9 '()) clam-586))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-586)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-586))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-586))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-585))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-585))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-98) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-98)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-589) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-589))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-589))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-590) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-590))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-590))))))))) e-9 '()) clam-589))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-589)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-589))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-589))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-98))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-98))))))))))))))(else (lambda (clam-591) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-592) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-592))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-592))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-593) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-593))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-593))))))))) e-9 '()) clam-592))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-592)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-592))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-592))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-591))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-591))))))))))) ((equal? arg-2 1) (lambda (clam-99) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-99)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-595) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-595))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-595))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-596) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-596))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-596))))))))) e-9 '()) clam-595))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-595)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-595))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-595))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-99))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-99)))))))))))(else (lambda (clam-597) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-598) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-598))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-598))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-599) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-599))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-599))))))))) e-9 '()) clam-598))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-598)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-598))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-598))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-597))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-597))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-100) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-100)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-601) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-601))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-601))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-602) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-602))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-602))))))))) e-9 '()) clam-601))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-601)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-601))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-601))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-100))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-100))))))))))))))(else (lambda (clam-603) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-604) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-604))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-604))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-605) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-605))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-605))))))))) e-9 '()) clam-604))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-604)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-604))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-604))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-603))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-603))))))))))) ((equal? arg-2 1) (lambda (clam-101) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-101)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-607) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-607))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-607))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-608) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-608))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-608))))))))) e-9 '()) clam-607))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-607)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-607))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-607))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-101))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-101)))))))))))(else (lambda (clam-609) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-610) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-610))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-610))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-611) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-611))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-611))))))))) e-9 '()) clam-610))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-610)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-610))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-610))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-609))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-609))))))))))))))) ((equal? arg-2 1) (case (vector-ref arg-3 0) ((8) (let ((e-37 (vector-ref arg-3 2))) (case (vector-ref e-37 0) ((13) (let ((e-38 (vector-ref e-37 1))) (cond ((equal? e-38 10) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "String not allowed in a foreign struct") eta-0)))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-102) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-102)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-613) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-613))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-613))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-614) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-614))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-614))))))))) e-9 '()) clam-613))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-613)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-613))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-613))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-102))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-102))))))))))))))(else (lambda (clam-615) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-616) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-616))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-616))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-617) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-617))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-617))))))))) e-9 '()) clam-616))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-616)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-616))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-616))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-615))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-615))))))))))) ((equal? arg-2 1) (lambda (clam-103) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-103)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-619) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-619))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-619))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-620) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-620))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-620))))))))) e-9 '()) clam-619))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-619)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-619))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-619))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-103))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-103)))))))))))(else (lambda (clam-621) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-622) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-622))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-622))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-623) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-623))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-623))))))))) e-9 '()) clam-622))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-622)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-622))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-622))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-621))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-621))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-104) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-104)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-625) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-625))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-625))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-626) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-626))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-626))))))))) e-9 '()) clam-625))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-625)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-625))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-625))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-104))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-104))))))))))))))(else (lambda (clam-627) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-628) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-628))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-628))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-629) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-629))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-629))))))))) e-9 '()) clam-628))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-628)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-628))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-628))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-627))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-627))))))))))) ((equal? arg-2 1) (lambda (clam-105) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-105)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-631) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-631))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-631))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-632) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-632))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-632))))))))) e-9 '()) clam-631))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-631)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-631))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-631))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-105))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-105)))))))))))(else (lambda (clam-633) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-634) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-634))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-634))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-635) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-635))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-635))))))))) e-9 '()) clam-634))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-634)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-634))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-634))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-633))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-633))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-106) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-106)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-637) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-637))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-637))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-638) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-638))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-638))))))))) e-9 '()) clam-637))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-637)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-637))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-637))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-106))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-106))))))))))))))(else (lambda (clam-639) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-640) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-640))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-640))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-641) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-641))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-641))))))))) e-9 '()) clam-640))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-640)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-640))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-640))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-639))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-639))))))))))) ((equal? arg-2 1) (lambda (clam-107) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-107)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-643) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-643))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-643))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-644) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-644))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-644))))))))) e-9 '()) clam-643))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-643)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-643))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-643))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-107))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-107)))))))))))(else (lambda (clam-645) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-646) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-646))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-646))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-647) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-647))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-647))))))))) e-9 '()) clam-646))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-646)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-646))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-646))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-645))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-645))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-108) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-108)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-649) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-649))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-649))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-650) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-650))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-650))))))))) e-9 '()) clam-649))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-649)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-649))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-649))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-108))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-108))))))))))))))(else (lambda (clam-651) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-652) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-652))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-652))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-653) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-653))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-653))))))))) e-9 '()) clam-652))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-652)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-652))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-652))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-651))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-651))))))))))) ((equal? arg-2 1) (lambda (clam-109) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-109)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-655) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-655))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-655))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-656) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-656))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-656))))))))) e-9 '()) clam-655))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-655)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-655))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-655))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-109))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-109)))))))))))(else (lambda (clam-657) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-658) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-658))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-658))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-659) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-659))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-659))))))))) e-9 '()) clam-658))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-658)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-658))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-658))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-657))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-657))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-110) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-110)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-661) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-661))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-661))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-662) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-662))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-662))))))))) e-9 '()) clam-661))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-661)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-661))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-661))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-110))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-110))))))))))))))(else (lambda (clam-663) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-664) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-664))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-664))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-665) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-665))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-665))))))))) e-9 '()) clam-664))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-664)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-664))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-664))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-663))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-663))))))))))) ((equal? arg-2 1) (lambda (clam-111) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-111)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-667) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-667))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-667))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-668) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-668))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-668))))))))) e-9 '()) clam-667))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-667)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-667))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-667))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-111))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-111)))))))))))(else (lambda (clam-669) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-670) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-670))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-670))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-671) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-671))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-671))))))))) e-9 '()) clam-670))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-670)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-670))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-670))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-669))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-669))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-112) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-112)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-673) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-673))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-673))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-674) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-674))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-674))))))))) e-9 '()) clam-673))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-673)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-673))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-673))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-112))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-112))))))))))))))(else (lambda (clam-675) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-676) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-676))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-676))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-677) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-677))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-677))))))))) e-9 '()) clam-676))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-676)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-676))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-676))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-675))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-675))))))))))) ((equal? arg-2 1) (lambda (clam-113) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-113)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-679) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-679))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-679))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-680) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-680))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-680))))))))) e-9 '()) clam-679))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-679)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-679))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-679))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-113))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-113)))))))))))(else (lambda (clam-681) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-682) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-682))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-682))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-683) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-683))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-683))))))))) e-9 '()) clam-682))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-682)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-682))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-682))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-681))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-681))))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-114) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-114)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-685) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-685))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-685))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-686) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-686))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-686))))))))) e-9 '()) clam-685))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-685)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-685))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-685))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-114))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-114))))))))))))))(else (lambda (clam-687) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-688) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-688))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-688))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-689) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-689))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-689))))))))) e-9 '()) clam-688))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-688)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-688))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-688))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-687))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-687))))))))))) ((equal? arg-2 1) (lambda (clam-115) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-115)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-691) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-691))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-691))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-692) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-692))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-692))))))))) e-9 '()) clam-691))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-691)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-691))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-691))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-115))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-115)))))))))))(else (lambda (clam-693) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-694) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-694))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-694))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-695) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-695))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-695))))))))) e-9 '()) clam-694))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-694)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-694))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-694))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-693))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-693))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-116) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-116)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-697) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-697))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-697))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-698) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-698))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-698))))))))) e-9 '()) clam-697))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-697)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-697))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-697))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-116))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-116))))))))))))))(else (lambda (clam-699) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-700) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-700))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-700))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-701) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-701))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-701))))))))) e-9 '()) clam-700))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-700)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-700))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-700))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-699))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-699))))))))))) ((equal? arg-2 1) (lambda (clam-117) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-117)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-703) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-703))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-703))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-704) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-704))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-704))))))))) e-9 '()) clam-703))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-703)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-703))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-703))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-117))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-117)))))))))))(else (lambda (clam-705) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-706) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-706))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-706))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-707) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-707))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-707))))))))) e-9 '()) clam-706))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-706)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-706))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-706))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-705))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-705))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-118) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-118)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-709) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-709))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-709))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-710) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-710))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-710))))))))) e-9 '()) clam-709))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-709)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-709))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-709))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-118))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-118))))))))))))))(else (lambda (clam-711) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-712) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-712))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-712))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-713) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-713))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-713))))))))) e-9 '()) clam-712))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-712)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-712))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-712))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-711))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-711))))))))))) ((equal? arg-2 1) (lambda (clam-119) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-119)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-715) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-715))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-715))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-716) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-716))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-716))))))))) e-9 '()) clam-715))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-715)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-715))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-715))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-119))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-119)))))))))))(else (lambda (clam-717) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-718) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-718))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-718))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-719) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-719))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-719))))))))) e-9 '()) clam-718))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-718)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-718))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-718))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-717))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-717)))))))))))))))(else (case (vector-ref arg-3 0) ((8) (let ((e-29 (vector-ref arg-3 2))) (case (vector-ref e-29 0) ((13) (let ((e-30 (vector-ref e-29 1))) (cond ((equal? e-30 12) (lambda (eta-0) (vector 1 (vector 12 )))) ((equal? e-30 11) (lambda (eta-0) (vector 1 (vector 13 )))) ((equal? e-30 13) (lambda (eta-0) (vector 1 (vector 18 ))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-120) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-120)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-721) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-721))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-721))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-722) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-722))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-722))))))))) e-9 '()) clam-721))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-721)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-721))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-721))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-120))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-120))))))))))))))(else (lambda (clam-723) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-724) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-724))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-724))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-725) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-725))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-725))))))))) e-9 '()) clam-724))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-724)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-724))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-724))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-723))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-723))))))))))) ((equal? arg-2 1) (lambda (clam-121) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-121)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-727) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-727))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-727))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-728) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-728))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-728))))))))) e-9 '()) clam-727))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-727)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-727))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-727))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-121))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-121)))))))))))(else (lambda (clam-729) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-730) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-730))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-730))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-731) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-731))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-731))))))))) e-9 '()) clam-730))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-730)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-730))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-730))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-729))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-729))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-122) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-122)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-733) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-733))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-733))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-734) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-734))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-734))))))))) e-9 '()) clam-733))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-733)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-733))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-733))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-122))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-122))))))))))))))(else (lambda (clam-735) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-736) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-736))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-736))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-737) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-737))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-737))))))))) e-9 '()) clam-736))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-736)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-736))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-736))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-735))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-735))))))))))) ((equal? arg-2 1) (lambda (clam-123) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-123)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-739) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-739))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-739))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-740) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-740))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-740))))))))) e-9 '()) clam-739))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-739)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-739))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-739))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-123))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-123)))))))))))(else (lambda (clam-741) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-742) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-742))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-742))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-743) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-743))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-743))))))))) e-9 '()) clam-742))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-742)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-742))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-742))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-741))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-741))))))))))))))(else (cond ((equal? arg-2 0) (case (vector-ref arg-3 0) ((0) (let ((e-13 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (lambda (clam-124) (case (vector-ref e-15 0) ((2) (let ((e-21 (vector-ref e-15 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-13 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-13 0 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 19 e-6 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-124)))))))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-745) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-745))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-745))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-746) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-746))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-17) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-18))))) eff-0) eta-2)))))))) eff-0) clam-746))))))))) e-9 '()) clam-745))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-745)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-745))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-745))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-124))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-124))))))))))))))(else (lambda (clam-747) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-748) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-748))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-748))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-749) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-749))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-749))))))))) e-9 '()) clam-748))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-748)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-748))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-748))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-747))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-747))))))))))) ((equal? arg-2 1) (lambda (clam-125) (case (vector-ref arg-3 0) ((0) (let ((e-23 (vector-ref arg-3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-23 "Function types not allowed in a foreign struct") clam-125)))(else (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-751) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-751))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-751))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-752) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-752))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-752))))))))) e-9 '()) clam-751))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-751)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-751))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-751))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-125))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-125)))))))))))(else (lambda (clam-753) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-getNArgs arg-0 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-754) (case (vector-ref e-8 0) ((0) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 eta-2)) e-9 '()) clam-754))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 eta-3)) e-10 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 22 e-7 e-11))))) eff-0) eta-2)))))))) eff-0) clam-754))))))) ((1) (let ((e-10 (vector-ref e-8 1))) (let ((e-9 (vector-ref e-8 2))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-755) (let ((e-12 (car lamc-0))) (let ((e-11 (cdr lamc-0))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-11) clam-755))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 1 e-13) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-12 e-14))))) eff-0) eta-2)))))))) eff-0) clam-755))))))))) e-9 '()) clam-754))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 21 e-10 e-11))))) eff-0) clam-754)))))))) ((2) (vector 1 (vector 0 ))) ((3) (vector 1 (vector 14 ))) ((4) (vector 1 (vector 15 ))) ((5) (vector 1 (vector 16 ))) ((6) (vector 1 (vector 17 ))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-6 e-9) clam-754))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45CompileExpr-nfToCFType arg-0 e-1 arg-2 e-10) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 20 e-11))))) eff-0) eta-2)))))))) eff-0) clam-754))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-753))))))))) ((10) csegen-1950) ((9) csegen-1952)(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 '() e-5 '() arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-3) (string-append "Can't marshal type for foreign call " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-753))))))))))))))))))
(define CompilerC-45CompileExpr-getCFTypes (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-nfToCFType arg-0 e-1 0 e-10))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (CompilerC-45CompileExpr-getCFTypes arg-0 (cons e-10 arg-1) e-11))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (let ((act-1 ((CompilerC-45CompileExpr-nfToCFType arg-0 (CoreC-45Value-getLoc arg-2) 0 arg-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (PreludeC-45TypesC-45List-reverse arg-1) e-5))))) eff-0) clam-0)))))))))))(else (let ((act-1 ((CompilerC-45CompileExpr-nfToCFType arg-0 (CoreC-45Value-getLoc arg-2) 0 arg-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (PreludeC-45TypesC-45List-reverse arg-1) e-5))))) eff-0) clam-0))))))))))
(define CoreC-45Context-getFullName (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 e-0) (let ((e-34 (vector-ref e-5 0))) e-34)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (vector 8 e-0)) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-25 (vector-ref e-1 1))) e-25))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))(else (vector 1 arg-1)))))
(define PreludeC-45TypesC-45List-length (lambda (arg-1) (if (null? arg-1) 0 (let ((e-3 (cdr arg-1))) (+ (PreludeC-45TypesC-45List-length e-3) 1)))))
(define CompilerC-45CompileExpr-mkArgList (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (cons '() '()))(else (let ((e-0 (- arg-1 1))) (let ((sc0 (CompilerC-45CompileExpr-mkArgList (bs+ arg-0 1 63) e-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons (cons (vector 2 "arg" arg-0) e-2) (cons (vector 2 "arg" arg-0) e-3))))))))))
(define CompilerC-45CompileExpr-mkSub (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (cons arg-1 (vector 0 )) (if (null? arg-1) (cons '() (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc2 (CompilerC-45CompileExpr-mkSub (+ arg-0 1) e-3 arg-2))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-0 arg-2))) (cond ((equal? sc3 1) (cons e-5 (vector 1 e-4))) (else (cons (cons e-2 e-5) (vector 2 e-4))))))))))))))
(define CompilerC-45CompileExpr-numArgs (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 2))) (vector 1 (vector 2 e-5))))(else (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref arg-1 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 2 0))) (let ((e-4 (unbox e-5))) (let ((e-18 (vector-ref e-4 18))) (case (vector-ref e-18 0) ((5) (let ((e-29 (vector-ref e-18 2))) (let ((e-28 (vector-ref e-18 3))) (lambda (clam-1) (if (null? e-28) (vector 1 (vector 1 e-29 (let ((e-50 (vector-ref e-4 3))) e-50))) (let ((e-31 (unbox e-28))) (if (null? e-31) (vector 1 (vector 2 0)) (let ((e-32 (cdr e-31))) (vector 1 (vector 0 e-29 e-32)))))))))) ((1) (let ((e-31 (vector-ref e-18 2))) (lambda (eta-0) (vector 1 (vector 1 (PreludeC-45TypesC-45List-lengthTR e-31) (let ((e-52 (vector-ref e-4 3))) e-52)))))) ((2) (let ((e-28 (vector-ref e-18 1))) (lambda (eta-0) (vector 1 (vector 2 e-28))))) ((3) (let ((e-29 (vector-ref e-18 1))) (lambda (eta-0) (vector 1 (vector 2 e-29))))) ((4) (let ((e-29 (vector-ref e-18 1))) (lambda (eta-0) (vector 1 (vector 2 e-29)))))(else (lambda (eta-0) (vector 1 (vector 2 0)))))))))) eff-0) clam-0))))))))))(else (vector 1 (vector 2 0)))))))
(define CoreC-45NameC-45Scoped-keeps (lambda (arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-3 (cdr arg-3))) (vector 2 (CoreC-45NameC-45Scoped-keeps e-3 arg-4))))))
(define CoreC-45CompileExpr-shrinkConAlt (lambda (arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-shrinkCExp (CoreC-45NameC-45Scoped-keeps e-4 arg-2) e-5)))))))))
(define CoreC-45CompileExpr-shrinkConstAlt (lambda (arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cons e-1 (CoreC-45CompileExpr-shrinkCExp arg-2 e-2))))))
(define CoreC-45CompileExpr-shrinkCExp (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45TTC-45Var-shrinkIsVar e-2 arg-2))) (if (null? sc1) (vector 13 e-3) (let ((e-4 (unbox sc1))) (vector 0 e-4 e-3))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((u--scC-39 (CoreC-45CompileExpr-shrinkCExp (vector 2 arg-2) e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((u--scC-39 (CoreC-45CompileExpr-shrinkCExp (vector 2 arg-2) e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-shrinkCExp arg-2 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (vector 4 e-19 (CoreC-45CompileExpr-shrinkCExp arg-2 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((e-32 (vector-ref arg-3 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-3 1))) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-shrinkCExp arg-2 e-40)))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-shrinkCExp arg-2 e-44)))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (let ((e-49 (vector-ref arg-3 4))) (vector 10 e-46 (CoreC-45CompileExpr-shrinkCExp arg-2 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-shrinkConAlt arg-2 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-3 1))) (let ((e-52 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 3))) (let ((e-54 (vector-ref arg-3 4))) (vector 11 e-51 (CoreC-45CompileExpr-shrinkCExp arg-2 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-shrinkConstAlt arg-2 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-shrinkCExp arg-2 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-3 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-3 1))) (let ((e-62 (vector-ref arg-3 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-getFC (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 2))) e-3)) ((1) (let ((e-6 (vector-ref arg-1 1))) e-6)) ((2) (let ((e-9 (vector-ref arg-1 1))) e-9)) ((3) (let ((e-13 (vector-ref arg-1 1))) e-13)) ((4) (let ((e-19 (vector-ref arg-1 1))) e-19)) ((5) (let ((e-23 (vector-ref arg-1 1))) e-23)) ((6) (let ((e-30 (vector-ref arg-1 2))) e-30)) ((7) (let ((e-34 (vector-ref arg-1 1))) e-34)) ((8) (let ((e-38 (vector-ref arg-1 1))) e-38)) ((9) (let ((e-42 (vector-ref arg-1 1))) e-42)) ((10) (let ((e-46 (vector-ref arg-1 1))) e-46)) ((11) (let ((e-51 (vector-ref arg-1 1))) e-51)) ((12) (let ((e-56 (vector-ref arg-1 1))) e-56)) ((13) (let ((e-59 (vector-ref arg-1 1))) e-59)) (else (let ((e-61 (vector-ref arg-1 1))) e-61)))))
(define CompilerC-45CompileExpr-magic__natUnsuc (lambda (arg-0 arg-1 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (vector 6 2 arg-0 (vector 1 5) (cons e-2 (cons (vector 12 arg-0 (vector 5 1)) '())))))))
(define CompilerC-45CompileExpr-trySBranch (lambda (arg-1 arg-2) (let ((e-2 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (case (vector-ref e-2 0) ((9) (if (null? e-4) '() (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (if (null? e-8) (box (vector 3 (CoreC-45CompileExpr-getFC arg-1) e-7 0 (CompilerC-45CompileExpr-magic__natUnsuc (CoreC-45CompileExpr-getFC arg-1) (CoreC-45CompileExpr-getFC arg-1) (cons arg-1 '())) e-5)) '())))))(else '())))))))
(define CompilerC-45CompileExpr-getSBranch (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (CompilerC-45CompileExpr-trySBranch arg-1 e-2) (lambda () (CompilerC-45CompileExpr-getSBranch arg-1 e-3))))))))
(define CompilerC-45CompileExpr-tryZBranch (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (case (vector-ref e-2 0) ((8) (if (null? e-4) (box e-5) '()))(else '())))))))
(define CompilerC-45CompileExpr-getZBranch (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (CompilerC-45CompileExpr-tryZBranch e-2) (lambda () (CompilerC-45CompileExpr-getZBranch e-3))))))))
(define CompilerC-45CompileExpr-natBranch (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) (case (vector-ref e-2 0) ((8) 1) ((9) 1)(else 0)))))
(define CompilerC-45CompileExpr-newMN (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))) eff-0) ext-0)))))))
(define CoreC-45CompileExpr-insertNamesConstAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-2))))))
(define CoreC-45CompileExpr-insertNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((eff-0 (CoreC-45TTC-45Var-insertNVarNames arg-3 arg-4 e-2))) (vector 0 eff-0 e-3))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((u--scC-39 (CoreC-45CompileExpr-insertNames (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (let ((u--scC-39 (CoreC-45CompileExpr-insertNames (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-insertNamesConAlt arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CoreC-45CompileExpr-insertNames arg-3 arg-4 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-insertNamesConstAlt arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-insertNames arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-insertNamesConAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-insertNames (LibrariesC-45DataC-45ListC-45SizeOf-C-43 (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4) arg-3) arg-4 e-5)))))))))
(define CoreC-45CompileExpr-u--weakenNs_Weaken_CConAlt (lambda (arg-2 arg-3) (CoreC-45CompileExpr-insertNamesConAlt 0 arg-2 arg-3)))
(define CoreC-45CompileExpr-u--weaken_Weaken_CConAlt (lambda (ext-0) (CoreC-45CompileExpr-u--weakenNs_Weaken_CConAlt (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) ext-0)))
(define CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (lambda (arg-2 arg-3) (CoreC-45CompileExpr-insertNames 0 arg-2 arg-3)))
(define CoreC-45CompileExpr-u--weaken_Weaken_CExp (lambda (ext-0) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) ext-0)))
(define CompilerC-45CompileExpr-builtinNatTree (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((10) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-2 0) ((0) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (vector 1 (let ((u--sc (vector 0 e-7 e-8))) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CompilerC-45CompileExpr-natBranch eta-0)) e-3))) (cond ((equal? sc2 1) (let ((u--defb (DataC-45Maybe-fromMaybe (lambda () (vector 14 e-1 "Nat case not covered")) e-4))) (let ((u--salt (PreludeC-45Types-maybe (lambda () u--defb) (lambda () (lambda (eta-0) eta-0)) (CompilerC-45CompileExpr-getSBranch u--sc e-3)))) (let ((u--zalt (PreludeC-45Types-maybe (lambda () u--defb) (lambda () (lambda (eta-0) eta-0)) (CompilerC-45CompileExpr-getZBranch e-3)))) (vector 11 e-1 u--sc (cons (cons (vector 5 0) u--zalt) '()) (box u--salt)))))) (else (vector 10 e-1 u--sc e-3 e-4)))))))))(else (let ((act-1 (CompilerC-45CompileExpr-newMN arg-1 "succ" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45CompileExpr-builtinNatTree arg-1 (vector 10 e-1 (vector 0 0 e-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45CompileExpr-u--weaken_Weaken_CConAlt eta-1)) e-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (CoreC-45CompileExpr-u--weaken_Weaken_CExp eta-1)) e-4))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-1 e-5 0 e-2 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))(else (vector 1 arg-2))))))
(define CompilerC-45CompileExpr-n--12005-4795-u--ciFlags (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (case (vector-ref arg-2 0) ((6) (vector 1 ))(else (vector 0 ))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((11) (let ((e-4 (vector-ref e-2 1))) e-4))(else (CompilerC-45CompileExpr-n--12005-4795-u--ciFlags arg-0 arg-1 arg-2 e-3))))))))
(define CompilerC-45CompileExpr-dconFlag (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't find " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0) (let ((e-1 (unbox e-6))) (vector 1 (CompilerC-45CompileExpr-n--12005-4795-u--ciFlags arg-1 arg-0 (let ((e-18 (vector-ref e-1 18))) e-18) (let ((e-12 (vector-ref e-1 12))) e-12)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45CompileExpr-mkDropSubst (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cons '() (vector 0 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (CompilerC-45CompileExpr-mkDropSubst (+ arg-0 1) arg-1 arg-2 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-0 arg-1))) (cond ((equal? sc2 1) (cons e-5 (vector 1 e-4))) (else (cons (cons e-2 e-5) (vector 2 e-4)))))))))))))
(define CompilerC-45CompileExpr-n--12838-5711-u--dcon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((5) 1)(else 0))))
(define CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32conCases-5772 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((5) (let ((e-2 (vector-ref arg-12 3))) (if (null? e-2) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-8 arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (CompilerC-45CompileExpr-mkDropSubst 0 (let ((e-3 (vector-ref arg-10 3))) e-3) arg-1 arg-0))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (let ((act-2 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) arg-8 arg-7 arg-6 arg-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-conCases arg-1 arg-8 arg-7 arg-6 arg-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc6 (CompilerC-45CompileExpr-n--12838-5711-u--dcon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-18 (vector-ref arg-10 18))) e-18)))) (cond ((equal? sc6 1) (let ((act-4 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector e-5 e-8 (box arg-3) e-4 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))) eff-0) clam-1)))))) (else (let ((act-4 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector e-5 e-8 '() e-4 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))) eff-0) clam-1))))))))))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))) eff-0) eta-0)))))) (CompilerC-45CompileExpr-conCases arg-1 arg-8 arg-7 arg-6 arg-5))))(else (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-8 arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc1 (CompilerC-45CompileExpr-mkDropSubst 0 (let ((e-3 (vector-ref arg-10 3))) e-3) arg-1 arg-0))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-2 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) arg-8 arg-7 arg-6 arg-2) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-conCases arg-1 arg-8 arg-7 arg-6 arg-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc4 (CompilerC-45CompileExpr-n--12838-5711-u--dcon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-18 (vector-ref arg-10 18))) e-18)))) (cond ((equal? sc4 1) (let ((act-4 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 clam-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector e-5 e-8 (box arg-3) e-2 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))) eff-0) clam-3)))))) (else (let ((act-4 (CompilerC-45CompileExpr-dconFlag arg-8 e-5 clam-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector e-5 e-8 '() e-2 (CoreC-45CompileExpr-shrinkCExp e-3 e-6)) e-7))))) eff-0) clam-3))))))))))) eff-0) eta-1)))))))) eff-0) clam-2))))))))))) eff-0) eta-0))))))))))
(define CompilerC-45CompileExpr-conCases (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-9 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-10) (lambda (eta-2) (let ((act-3 (CoreC-45Context-getFullName arg-1 e-5 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-0) arg-1 arg-2 arg-3 e-8) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 ((CompilerC-45CompileExpr-conCases arg-0 arg-1 arg-2 arg-3 e-3) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (cons (vector e-11 (vector 1 ) '() e-7 e-12) e-13))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) (let ((e-1 (unbox e-10))) (let ((_-0 (box e-1))) (CompilerC-45CompileExpr-case--caseC-32blockC-32inC-32conCases-5772 e-7 arg-0 e-8 e-6 e-5 e-3 arg-3 arg-2 arg-1 e-9 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (CompilerC-45CompileExpr-conCases arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define CompilerC-45CompileExpr-constCases (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-5 0) ((14) (CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-3))(else (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (cons e-5 e-7) e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define CompilerC-45CompileExpr-enumTag (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-0 255))) (cond ((equal? sc0 1) (vector 6 (blodwen-toUnsignedInt arg-1 8))) (else (let ((sc1 (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-0 65535))) (cond ((equal? sc1 1) (vector 7 (blodwen-toUnsignedInt arg-1 16))) (else (vector 8 (blodwen-toUnsignedInt arg-1 32))))))))))
(define CompilerC-45CompileExpr-n--11747-4574-u--toEnum (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (case (vector-ref e-2 0) ((4) (let ((e-6 (vector-ref e-2 1))) (if (null? e-3) '() (let ((e-8 (unbox e-3))) (if (null? e-4) (box (cons (CompilerC-45CompileExpr-enumTag e-6 e-8) e-5)) '())))))(else '()))))))))
(define CompilerC-45CompileExpr-enumTree (lambda (arg-1) (case (vector-ref arg-1 0) ((10) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((u--x (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CompilerC-45CompileExpr-n--11747-4574-u--toEnum e-4 e-3 e-2 e-1 eta-0)) e-3))) (if (null? u--x) (vector 10 e-1 e-2 e-3 e-4) (let ((e-5 (unbox u--x))) (vector 11 e-1 e-2 e-5 e-4)))))))))(else arg-1))))
(define CompilerC-45CompileExpr-getDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-6))))) eff-0) eta-0)))))))) ((2) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (case (vector-ref e-7 0) ((14) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-5))))) eff-0) eta-0)))))))(else (CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 e-3))))))(else (CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define CoreC-45TTC-45SubstC-45Var-index (lambda (arg-3 arg-4) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cond ((equal? arg-4 0) e-4)(else (let ((e-11 (- arg-4 1))) (CoreC-45TTC-45SubstC-45Var-index e-5 e-11))))))))
(define CoreC-45TTC-45Var-locateVar (lambda (arg-3 arg-4) (let ((sc0 (CoreC-45TTC-45Var-locateNVar arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5)))))))
(define CoreC-45TTC-45Subst-findDrop (lambda (arg-3 arg-4 arg-5 arg-6) (let ((sc0 (CoreC-45TTC-45Var-locateVar arg-4 arg-5))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (CoreC-45TTC-45SubstC-45Var-index arg-6 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (arg-3 e-5)))))))
(define CoreC-45TTC-45Subst-find (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (CoreC-45TTC-45Var-locateVar arg-6 arg-8))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) ((arg-5 'erased) e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-2 (cdr arg-4))) ((((e-2 'erased) 'erased) arg-6) (CoreC-45TTC-45Subst-findDrop (arg-5 'erased) arg-7 e-5 arg-9)))))))))
(define CoreC-45CompileExpr-substConAlt (lambda (arg-3 arg-4 arg-5 arg-6) (let ((e-1 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (let ((e-5 (vector-ref arg-6 4))) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-substEnv (LibrariesC-45DataC-45ListC-45SizeOf-C-43 (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4) arg-3) arg-4 arg-5 e-5)))))))))
(define CoreC-45CompileExpr-substConstAlt (lambda (arg-3 arg-4 arg-5 arg-6) (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (cons e-1 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-2))))))
(define CoreC-45CompileExpr-substEnv (lambda (arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (CoreC-45TTC-45Subst-find (cons (lambda (u--nm) (lambda (u--vars) (lambda (arg-4039) (CoreC-45CompileExpr-u--weaken_Weaken_CExp arg-4039)))) (lambda (vars-6703) (lambda (ns-6704) (lambda (eta-0) (lambda (eta-1) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp eta-0 eta-1)))))) (lambda (vars-6860) (lambda (lamc-0) (vector 0 lamc-0 e-3))) arg-3 arg-4 e-2 arg-5)))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-6 1))) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (let ((u--scC-39 (CoreC-45CompileExpr-substEnv (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 arg-5 e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-6 1))) (let ((e-14 (vector-ref arg-6 2))) (let ((e-15 (vector-ref arg-6 3))) (let ((e-16 (vector-ref arg-6 4))) (let ((e-17 (vector-ref arg-6 5))) (let ((u--scC-39 (CoreC-45CompileExpr-substEnv (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 arg-5 e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-6 1))) (let ((e-20 (vector-ref arg-6 2))) (let ((e-21 (vector-ref arg-6 3))) (vector 4 e-19 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-6 1))) (let ((e-24 (vector-ref arg-6 2))) (let ((e-25 (vector-ref arg-6 3))) (let ((e-26 (vector-ref arg-6 4))) (let ((e-27 (vector-ref arg-6 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-6 1))) (let ((e-30 (vector-ref arg-6 2))) (let ((e-31 (vector-ref arg-6 3))) (let ((e-32 (vector-ref arg-6 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-6 1))) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-40)))))) ((9) (let ((e-42 (vector-ref arg-6 1))) (let ((e-43 (vector-ref arg-6 2))) (let ((e-44 (vector-ref arg-6 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-44)))))) ((10) (let ((e-46 (vector-ref arg-6 1))) (let ((e-47 (vector-ref arg-6 2))) (let ((e-48 (vector-ref arg-6 3))) (let ((e-49 (vector-ref arg-6 4))) (vector 10 e-46 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-substConAlt arg-3 arg-4 arg-5 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-6 1))) (let ((e-52 (vector-ref arg-6 2))) (let ((e-53 (vector-ref arg-6 3))) (let ((e-54 (vector-ref arg-6 4))) (vector 11 e-51 (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-substConstAlt arg-3 arg-4 arg-5 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-substEnv arg-3 arg-4 arg-5 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-6 1))) (let ((e-57 (vector-ref arg-6 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-6 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-6 1))) (let ((e-62 (vector-ref arg-6 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-substs (lambda (arg-0 arg-1 ext-0 ext-1 ext-2) (CoreC-45CompileExpr-substEnv 0 ext-0 ext-1 ext-2)))
(define CoreC-45CompileExpr-elem (lambda (arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-1 e-2))) (cond ((equal? sc1 1) 1) (else (CoreC-45CompileExpr-elem arg-1 e-3)))))))))
(define CoreC-45CompileExpr-tryNext (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (vector 2 (CoreC-45Name-displayUserName e-0) 0))) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (vector 2 e-1 (bs+ e-2 1 63)))))(else (vector 2 (CoreC-45Name-nameRoot arg-0) 0)))))
(define CoreC-45CompileExpr-uniqueName (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45CompileExpr-elem arg-1 arg-2))) (cond ((equal? sc0 1) (CoreC-45CompileExpr-uniqueName (CoreC-45CompileExpr-tryNext arg-1) arg-2)) (else arg-1)))))
(define CoreC-45CompileExpr-addLocs (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((u--rec (CoreC-45CompileExpr-addLocs e-3 arg-2))) (cons (CoreC-45CompileExpr-uniqueName e-2 u--rec) u--rec)))))))
(define CoreC-45CompileExpr-conArgs (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (cons e-6 (CoreC-45CompileExpr-conArgs e-3 e-7))))))))
(define CoreC-45CompileExpr-forgetConAlt (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((u--argsC-39 (CoreC-45CompileExpr-addLocs e-4 arg-1))) (vector e-1 e-2 e-3 (CoreC-45CompileExpr-conArgs e-4 u--argsC-39) (CoreC-45CompileExpr-forgetExp u--argsC-39 e-5))))))))))
(define CoreC-45CompileExpr-forgetConstAlt (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cons e-1 (CoreC-45CompileExpr-forgetExp arg-1 e-2))))))
(define CoreC-45CompileExpr-getLocName (lambda (arg-2 arg-3) (cond ((equal? arg-2 0) (let ((e-3 (car arg-3))) e-3))(else (let ((e-0 (- arg-2 1))) (let ((e-8 (cdr arg-3))) (CoreC-45CompileExpr-getLocName e-0 e-8)))))))
(define CoreC-45CompileExpr-forgetExp (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 0 e-3 (CoreC-45CompileExpr-getLocName e-2 arg-1))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((u--locsC-39 (CoreC-45CompileExpr-addLocs (cons e-10 '()) arg-1))) (vector 2 e-9 (CoreC-45CompileExpr-getLocName 0 u--locsC-39) (CoreC-45CompileExpr-forgetExp u--locsC-39 e-11))))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (let ((u--locsC-39 (CoreC-45CompileExpr-addLocs (cons e-14 '()) arg-1))) (vector 3 e-13 (CoreC-45CompileExpr-getLocName 0 u--locsC-39) (CoreC-45CompileExpr-forgetExp arg-1 e-16) (CoreC-45CompileExpr-forgetExp u--locsC-39 e-17)))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (vector 4 e-19 (CoreC-45CompileExpr-forgetExp arg-1 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-forgetExp arg-1 e-40)))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-forgetExp arg-1 e-44)))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (vector 10 e-46 (CoreC-45CompileExpr-forgetExp arg-1 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-forgetConAlt arg-1 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (vector 11 e-51 (CoreC-45CompileExpr-forgetExp arg-1 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-forgetConstAlt arg-1 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-forgetExp arg-1 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-2 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (vector 14 e-61 e-62)))))))
(define CoreC-45CompileExpr-forget (lambda (arg-0 arg-1) (CoreC-45CompileExpr-forgetExp (CoreC-45CompileExpr-addLocs arg-0 '()) arg-1)))
(define CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedCExp (CoreC-45CompileExpr-forget arg-0 arg-1))))
(define CompilerC-45CompileExpr-n--12882-6142-u--mkSubst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (cons 0 '()) (let ((e-3 (cdr arg-15))) (let ((sc1 (CompilerC-45CompileExpr-n--12882-6142-u--mkSubst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (+ arg-12 1) arg-13 arg-14 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (or (and (= arg-12 arg-14) 1) 0))) (cond ((equal? sc2 1) (cons (LibrariesC-45DataC-45ListC-45SizeOf-suc e-5) (cons arg-13 e-4))) (else (cons (LibrariesC-45DataC-45ListC-45SizeOf-suc e-5) (cons (vector 13 arg-8) e-4))))))))))))
(define CompilerC-45CompileExpr-getNewType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((3) (lambda (eta-0) (vector 1 '()))) ((0) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (let ((e-9 (vector-ref e-2 3))) (let ((e-10 (vector-ref e-2 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupDefExact e-7 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 '())) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((5) (let ((e-4 (vector-ref e-1 3))) (if (null? e-4) (lambda (eta-2) (vector 1 '())) (let ((e-13 (unbox e-4))) (if (null? e-13) (lambda (eta-2) (vector 1 '())) (let ((e-15 (car e-13))) (let ((e-14 (cdr e-13))) (lambda (clam-0) (cond ((equal? e-15 1) (let ((sc9 (CompilerC-45CompileExpr-n--12882-6142-u--mkSubst e-9 arg-0 e-10 e-8 e-7 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 0 arg-4 e-14 e-9))) (let ((e-17 (car sc9))) (let ((e-16 (cdr sc9))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "compiler.newtype.world" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Inlining case on " (cons (CoreC-45Name-u--show_Show_Name arg-5) (cons " (no world)" '()))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((act-4 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-0) arg-1 arg-2 arg-5 e-10) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-19 (vector-ref act-4 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box (CoreC-45CompileExpr-substs e-9 arg-0 e-17 e-16 e-19)))))) eff-0) clam-0)))))))))))) (else (let ((sc9 (CompilerC-45CompileExpr-n--12882-6142-u--mkSubst e-9 arg-0 e-10 e-8 e-7 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 0 (vector 0 0 arg-3) e-14 e-9))) (let ((e-17 (car sc9))) (let ((e-16 (cdr sc9))) (let ((act-3 ((CompilerC-45CompileExpr-toCExpTree (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-0) arg-1 arg-2 arg-5 e-10) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--scope (CoreC-45CompileExpr-insertNames (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-9) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons (vector 2 "eff" 0) '())) e-18))) (let ((u--tm (vector 3 arg-3 (vector 2 "eff" 0) 1 arg-4 (CoreC-45CompileExpr-substs e-9 (cons (vector 2 "eff" 0) arg-0) e-17 e-16 u--scope)))) (lambda (eta-2) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "compiler.newtype.world" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Kept the scrutinee " (cons (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-0 u--tm) '())))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-19 (vector-ref act-4 1))) (vector 0 e-19))) (else (vector 1 (box u--tm)))))))))) eff-0) clam-0))))))))))))))))))(else (lambda (eta-2) (vector 1 '())))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (CompilerC-45CompileExpr-getNewType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))))
(define CompilerC-45CompileExpr-weakenVar (lambda (arg-3) (+ arg-3 1)))
(define CompilerC-45CompileExpr-n--9908-2886-u--mkApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-4 (case (vector-ref arg-4 0) ((4) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (vector 4 e-1 e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-5)))))) ((5) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) (let ((e-9 (vector-ref arg-4 5))) (vector 5 e-5 e-6 e-7 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-5)))))))) ((7) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (vector 7 e-11 e-12 (PreludeC-45TypesC-45List-tailRecAppend e-13 arg-5))))))(else (vector 4 (CoreC-45CompileExpr-getFC arg-4) arg-4 arg-5))))))
(define CompilerC-45CompileExpr-n--9908-2887-u--mkLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (vector 0 arg-5 arg-4)))
(define CompilerC-45CompileExpr-etaExpand (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (CompilerC-45CompileExpr-n--9908-2886-u--mkApp arg-0 arg-4 arg-3 arg-1 arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CompileExpr-n--9908-2887-u--mkLocal arg-0 arg-4 arg-3 arg-1 (CoreC-45CompileExpr-getFC arg-3) eta-0)) (PreludeC-45TypesC-45List-reverse arg-4))))(else (let ((e-0 (- arg-2 1))) (vector 2 (CoreC-45CompileExpr-getFC arg-3) (vector 2 "eta" arg-1) (CompilerC-45CompileExpr-etaExpand (cons (vector 2 "eta" arg-1) arg-0) (bs+ arg-1 1 63) e-0 (CoreC-45CompileExpr-u--weaken_Weaken_CExp arg-3) (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CompileExpr-weakenVar eta-0)) arg-4)))))))))
(define CompilerC-45CompileExpr-n--10041-3045-u--addArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((4) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (vector 4 e-1 e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 (cons arg-6 '()))))))) ((5) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((e-9 (vector-ref arg-5 5))) (vector 5 e-5 e-6 e-7 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons arg-6 '()))))))))) ((7) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (vector 7 e-11 e-12 (PreludeC-45TypesC-45List-tailRecAppend e-13 (cons arg-6 '())))))))(else (vector 4 (CoreC-45CompileExpr-getFC arg-5) arg-5 (cons arg-6 '()))))))
(define CompilerC-45CompileExpr-n--10041-3016-u--applyAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CompilerC-45CompileExpr-n--10041-3016-u--applyAll arg-0 arg-1 arg-2 (vector 4 (CoreC-45CompileExpr-getFC arg-3) arg-3 (cons e-2 '())) e-3))))))
(define CompilerC-45CompileExpr-expandToArity (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((13) (let ((e-6 (vector-ref arg-2 1))) (vector 13 e-6)))(else (cond ((equal? arg-1 0) (CompilerC-45CompileExpr-n--10041-3016-u--applyAll arg-0 arg-3 arg-2 arg-2 arg-3))(else (let ((e-1 (- arg-1 1))) (if (null? arg-3) (CompilerC-45CompileExpr-etaExpand arg-0 0 arg-1 arg-2 '()) (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (CompilerC-45CompileExpr-expandToArity arg-0 e-1 (CompilerC-45CompileExpr-n--10041-3045-u--addArg arg-0 e-1 e-3 e-4 arg-2 arg-2 e-3) e-4)))))))))))
(define CompilerC-45CompileExpr-n--10172-3127-u--keep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (if (null? arg-7) (vector 13 (CoreC-45CompileExpr-getFC arg-2)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (or (and (= arg-6 arg-3) 1) 0))) (cond ((equal? sc1 1) e-2) (else (CompilerC-45CompileExpr-n--10172-3127-u--keep arg-0 arg-1 arg-2 arg-3 arg-4 (+ arg-6 1) e-3)))))))))
(define CompilerC-45CompileExpr-n--10172-3128-u--keepArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (case (vector-ref arg-6 0) ((2) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (vector 2 e-1 e-2 (CompilerC-45CompileExpr-n--10172-3128-u--keepArg arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))) ((5) (let ((e-9 (vector-ref arg-6 5))) (CompilerC-45CompileExpr-n--10172-3127-u--keep arg-0 arg-1 arg-2 arg-3 arg-4 0 e-9)))(else (vector 13 (CoreC-45CompileExpr-getFC arg-2))))))
(define CompilerC-45CompileExpr-applyNewType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--fnC-39 (CompilerC-45CompileExpr-expandToArity arg-0 arg-1 arg-3 arg-4))) (CompilerC-45CompileExpr-n--10172-3128-u--keepArg arg-0 arg-4 arg-3 arg-2 arg-1 u--fnC-39))))
(define DataC-45Vect-toVect (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) (box '()) '()))(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) '() (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-toVect e-0 e-4) (lambda (u--xsC-39) (box (cons e-3 u--xsC-39))))))))))))
(define CompilerC-45CompileExpr-n--10720-3617-u--fire (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (let ((e-1 (vector-ref arg-3 2))) (let ((e-2 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-11 (vector-ref arg-4 5))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Name-u--C-61C-61_Eq_Name e-0 e-8)) (lambda (_-10649) (PreludeC-45Types-u--map_Functor_Maybe ((e-2 e-7) 'erased) (DataC-45Vect-toVect e-1 e-11))))))))(else '())))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((4) (let ((e-13 (vector-ref arg-4 1))) (let ((e-14 (vector-ref arg-4 2))) (let ((e-15 (vector-ref arg-4 3))) (case (vector-ref e-14 0) ((1) (let ((e-17 (vector-ref e-14 1))) (let ((e-18 (vector-ref e-14 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Name-u--C-61C-61_Eq_Name e-3 e-18)) (lambda (_-10649) (PreludeC-45Types-u--map_Functor_Maybe (((e-5 e-13) e-17) 'erased) (DataC-45Vect-toVect e-4 e-15)))))))(else '()))))))(else '()))))))(else '()))))
(define CompilerC-45CompileExpr-n--10720-3618-u--go (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (CompilerC-45CompileExpr-n--10720-3617-u--fire arg-1 arg-2 e-2 arg-4))) (if (null? sc1) (CompilerC-45CompileExpr-n--10720-3618-u--go arg-1 arg-2 e-3 arg-4) (let ((e-4 (unbox sc1))) e-4))))))))
(define CompilerC-45CompileExpr-magic (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 2 e-1 e-2 (CompilerC-45CompileExpr-magic arg-1 e-3))))))(else (CompilerC-45CompileExpr-n--10720-3618-u--go arg-2 arg-1 arg-1 arg-2)))))
(define CompilerC-45CompileExpr-magic__natMinus (lambda (arg-0 arg-1 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 arg-0 (vector 1 arg-1 csegen-31) (cons (vector 6 2 arg-0 (vector 1 5) (cons e-2 (cons e-6 '()))) '()))))))))
(define CompilerC-45CompileExpr-natHack (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "natToInteger"))) 1 (lambda (_-3969) (lambda (_-3972) (lambda (vars-3975) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-2))))))) (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "integerToNat"))) 1 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (let ((e-2 (car eta-3))) (let ((e-3 (cdr eta-3))) (vector 4 eta-0 (vector 1 eta-1 csegen-31) (cons e-2 '()))))))))) (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "plus"))) 2 (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-3948) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 6 2 u--fc (vector 0 5) (cons e-2 (cons e-6 '())))))))))))) (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "mult"))) 2 (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-3932) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 6 2 u--fc (vector 2 5) (cons e-2 (cons e-6 '())))))))))))) (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "minus"))) 2 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45CompileExpr-magic__natMinus eta-0 eta-1 eta-3)))))) (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "equalNat"))) 2 (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-3907) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 6 2 u--fc (vector 13 5) (cons e-2 (cons e-6 '())))))))))))) (cons (vector 1 (vector 0 CoreC-45NameC-45Namespace-typesNS (vector 1 (vector 0 "compareNat"))) 2 (lambda (u--fc) (lambda (u--fcC-39) (lambda (vars-3891) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 4 u--fc (vector 1 u--fcC-39 csegen-32) (cons e-2 (cons e-6 '())))))))))))) '()))))))))
(define CompilerC-45CompileExpr-builtinMagic (lambda (ext-0) (CompilerC-45CompileExpr-magic CompilerC-45CompileExpr-natHack ext-0)))
(define CompilerC-45CompileExpr-dropFrom (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-2 arg-1))) (cond ((equal? sc1 1) (CompilerC-45CompileExpr-dropFrom arg-1 (+ arg-2 1) e-3)) (else (cons e-2 (CompilerC-45CompileExpr-dropFrom arg-1 (+ arg-2 1) e-3))))))))))
(define CompilerC-45CompileExpr-dropPos (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 2 e-1 e-2 (CompilerC-45CompileExpr-dropPos arg-1 e-3)))))) ((4) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (case (vector-ref e-6 0) ((4) (vector 4 e-5 (CompilerC-45CompileExpr-dropPos arg-1 e-6) e-7))(else (vector 4 e-5 e-6 (CompilerC-45CompileExpr-dropFrom arg-1 0 e-7)))))))) ((5) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (let ((e-13 (vector-ref arg-2 5))) (vector 5 e-9 e-10 e-11 e-12 (CompilerC-45CompileExpr-dropFrom arg-1 0 e-13))))))))(else arg-2))))
(define CompilerC-45CompileExpr-eraseConArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--fnC-39 (CompilerC-45CompileExpr-expandToArity arg-0 arg-1 arg-3 arg-4))) (let ((sc0 (DataC-45List-isNil arg-2))) (cond ((equal? sc0 1) u--fnC-39) (else (CompilerC-45CompileExpr-dropPos arg-2 u--fnC-39)))))))
(define AlgebraC-45Semiring-branchZero (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (AlgebraC-45Semiring-isErased arg-2 arg-5))) (cond ((equal? sc0 1) (arg-3)) (else (arg-4))))))
(define CompilerC-45CompileExpr-toCExpTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 3))) (lambda (eta-0) (vector 1 (vector 0 e-4 e-2)))))) ((1) (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (lambda (clam-0) (case (vector-ref e-8 0) ((2) (let ((e-51 (vector-ref e-8 1))) (let ((act-1 (CoreC-45Context-getFullName arg-1 e-9 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45CompileExpr-dconFlag arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((4) (let ((e-0 (vector-ref e-6 1))) (vector 1 (vector 12 e-7 (CompilerC-45CompileExpr-enumTag e-0 e-51))))) ((8) (vector 1 (vector 12 e-7 (vector 5 0)))) ((9) (let ((act-3 (CompilerC-45CompileExpr-newMN arg-2 "succ" clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-7 e-10 (vector 6 2 e-7 (vector 0 5) (cons (vector 12 e-7 (vector 5 1)) (cons (vector 0 0 e-7) '())))))))) eff-0) clam-1))))))(else (vector 1 (vector 5 e-7 e-5 e-6 (box e-51) '()))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) ((3) (vector 1 (vector 5 e-7 e-9 (vector 1 ) '() '())))(else (let ((act-1 (CoreC-45Context-getFullName arg-1 e-9 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 e-7 (vector 1 e-7 e-5) '()))))) eff-0) clam-0)))))))))))) ((2) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-14 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 eta-1)) e-14 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-11 (vector 1 e-11 e-12) e-5))))) eff-0) eta-0)))))))))) ((3) (let ((e-16 (vector-ref arg-4 1))) (let ((e-17 (vector-ref arg-4 2))) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (lambda (clam-2) (case (vector-ref e-18 0) ((0) (let ((act-1 ((CompilerC-45CompileExpr-toCExp (cons e-17 arg-0) arg-1 arg-2 arg-3 e-19) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-16 e-17 e-5))))) eff-0) clam-2)))))) ((1) (let ((e-62 (vector-ref e-18 2))) (let ((e-63 (vector-ref e-18 3))) (let ((act-1 ((CompilerC-45CompileExpr-toCExp (cons e-17 arg-0) arg-1 arg-2 arg-3 e-19) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-63) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (AlgebraC-45Semiring-branchZero csegen-931 (lambda () (CoreC-45CompileExpr-shrinkCExp (vector 1 (vector 0 )) e-5)) (lambda () (vector 3 e-16 e-17 0 e-6 e-5)) e-62))))) eff-0) eta-0)))))))) eff-0) clam-2)))))))) ((2) (let ((e-69 (vector-ref e-18 4))) (let ((act-1 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-69) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45CompileExpr-toCExp (cons e-17 arg-0) arg-1 arg-2 arg-3 e-19) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-16 (vector 1 (vector 0 "->")) (vector 1 ) '() (cons e-5 (cons (vector 2 e-16 e-17 e-6) '()))))))) eff-0) eta-0)))))))) eff-0) clam-2)))))))(else (vector 1 (vector 13 e-16)))))))))) ((4) (let ((e-21 (vector-ref arg-4 1))) (let ((e-22 (vector-ref arg-4 2))) (let ((e-23 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-22) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-23) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-21 e-5 (cons e-6 '())))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((5) (let ((e-28 (vector-ref arg-4 4))) (CompilerC-45CompileExpr-toCExpTm arg-0 arg-1 arg-2 arg-3 e-28))) ((6) (let ((e-30 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 13 e-30))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-37 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-37) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 9 e-34 e-35 e-5))))) eff-0) eta-0)))))))))) ((8) (let ((e-39 (vector-ref arg-4 1))) (let ((e-40 (vector-ref arg-4 2))) (let ((e-41 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-41) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-39 e-40 e-5))))) eff-0) eta-0)))))))))) ((9) (let ((e-43 (vector-ref arg-4 1))) (let ((e-44 (vector-ref arg-4 2))) (lambda (clam-3) (case (vector-ref e-44 0) ((13) (let ((e-70 (vector-ref e-44 1))) (vector 1 (vector 5 e-43 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-70))) (vector 1 ) '() '()))))(else (vector 1 (vector 12 e-43 e-44)))))))) ((10) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 13 e-46))))) (else (let ((e-49 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 5 e-49 (vector 1 (vector 0 "Type")) (vector 1 ) '() '()))))))))
(define CompilerC-45CompileExpr-case--toCExp-5416 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CompileExpr-toCExp arg-0 arg-4 arg-3 arg-2 eta-0)) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-toCExpTm arg-0 arg-4 arg-3 arg-2 e-2) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-numArgs e-6 e-2) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (case (vector-ref e-8 0) ((2) (let ((e-0 (vector-ref e-8 1))) (let ((u--res (CompilerC-45CompileExpr-expandToArity arg-0 e-0 e-7 e-5))) (lambda (eta-3) (vector 1 (CompilerC-45CompileExpr-builtinMagic u--res)))))) ((0) (let ((e-1 (vector-ref e-8 1))) (let ((e-4 (vector-ref e-8 2))) (let ((u--res (CompilerC-45CompileExpr-applyNewType arg-0 e-1 e-4 e-7 e-5))) (lambda (eta-3) (vector 1 (CompilerC-45CompileExpr-builtinMagic u--res))))))) (else (let ((e-9 (vector-ref e-8 1))) (let ((e-4 (vector-ref e-8 2))) (let ((u--res (CompilerC-45CompileExpr-eraseConArgs arg-0 e-9 e-4 e-7 e-5))) (lambda (eta-3) (vector 1 (CompilerC-45CompileExpr-builtinMagic u--res)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CompilerC-45CompileExpr-toCExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (eta-0) (CompilerC-45CompileExpr-case--toCExp-5416 arg-0 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-4) eta-0))))
(define CompilerC-45CompileExpr-unitTree (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((10) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (DataC-45Maybe-fromMaybe (let ((u--exp (vector 10 e-1 e-2 e-3 e-4))) (lambda () (lambda (eta-0) (vector 1 u--exp)))) (if (null? e-3) '() (let ((e-6 (car e-3))) (let ((e-5 (cdr e-3))) (let ((e-10 (vector-ref e-6 1))) (let ((e-7 (vector-ref e-6 3))) (let ((e-8 (vector-ref e-6 4))) (case (vector-ref e-10 0) ((10) (if (null? e-7) (if (null? e-5) (box (lambda (clam-0) (case (vector-ref e-2 0) ((0) (vector 1 e-8))(else (let ((act-1 (CompilerC-45CompileExpr-newMN arg-1 "_unit" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-12 (vector-ref act-1 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-1 e-12 1 e-2 (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-8)))))) eff-0) clam-0))))))))) '()) '()))(else '()))))))))))))))(else (lambda (eta-0) (vector 1 arg-2))))))
(define CompilerC-45CompileExpr-toCExpTreeC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (if (null? e-5) (lambda (eta-0) (vector 1 (vector 14 (CoreC-45TTC-45Term-getLoc e-4) (string-append "Missing case tree in " (CoreC-45Name-u--show_Show_Name arg-3))))) (let ((e-13 (car e-5))) (let ((e-14 (cdr e-5))) (case (vector-ref e-13 0) ((0) (let ((e-17 (vector-ref e-13 1))) (let ((e-18 (vector-ref e-13 2))) (let ((e-19 (vector-ref e-13 3))) (let ((e-20 (vector-ref e-13 4))) (let ((u--fc (CoreC-45TTC-45Term-getLoc e-4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-getNewType arg-0 arg-1 arg-2 u--fc (vector 0 e-2 u--fc) arg-3 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--alts (cons (vector 0 e-17 e-18 e-19 e-20) e-14))) (lambda (clam-0) (if (null? e-6) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45CompileExpr-conCases arg-0 arg-1 arg-2 arg-3 u--alts) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 u--alts) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc8 (DataC-45List-isNil e-8))) (cond ((equal? sc8 1) (vector 1 (DataC-45Maybe-fromMaybe (lambda () (vector 13 u--fc)) e-9))) (else (let ((act-5 ((CompilerC-45CompileExpr-builtinNatTree arg-2 (vector 10 u--fc (vector 0 e-2 u--fc) e-8 e-9)) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (CompilerC-45CompileExpr-unitTree arg-2 (CompilerC-45CompileExpr-enumTree e-10)))) eff-0) clam-1))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-0)))) (let ((e-3 (unbox e-6))) (vector 1 e-3))))))) eff-0) eta-0)))))))))))) ((1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Unexpected DelayCase") eta-0))) ((2) (let ((u--fc (CoreC-45TTC-45Term-getLoc e-4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-constCases arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45CompileExpr-getDef arg-0 arg-1 arg-2 arg-3 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc5 (DataC-45List-isNil e-6))) (cond ((equal? sc5 1) (vector 1 (DataC-45Maybe-fromMaybe (lambda () (vector 13 u--fc)) e-7))) (else (vector 1 (vector 11 u--fc (vector 0 e-2 u--fc) e-6 e-7)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (else (let ((e-29 (vector-ref e-13 1))) (CompilerC-45CompileExpr-toCExpTree arg-0 arg-1 arg-2 arg-3 e-29))))))))))) ((1) (let ((e-8 (vector-ref arg-4 2))) (CompilerC-45CompileExpr-toCExp arg-0 arg-1 arg-2 arg-3 e-8))) ((2) (let ((e-10 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 14 CoreC-45FC-emptyFC e-10))))) (else (lambda (eta-0) (vector 1 (vector 14 CoreC-45FC-emptyFC (string-append "Impossible case encountered in " (CoreC-45Name-u--show_Show_Name arg-3)))))))))
(define CompilerC-45CompileExpr-toCExpTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (if (null? e-5) (CompilerC-45CompileExpr-toCExpTreeC-39 arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-7 (car e-5))) (case (vector-ref e-7 0) ((1) (let ((e-10 (vector-ref e-7 1))) (let ((e-11 (vector-ref e-7 2))) (let ((e-12 (vector-ref e-7 3))) (let ((u--fc (CoreC-45TTC-45Term-getLoc e-4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45CompileExpr-toCExpTree (cons e-10 (cons e-11 arg-0)) arg-1 arg-2 arg-3 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 u--fc e-11 0 (vector 8 u--fc 0 (vector 0 e-2 (CoreC-45TTC-45Term-getLoc e-4))) (vector 3 u--fc e-10 0 (vector 13 u--fc) e-6)))))) eff-0) eta-0)))))))))))(else (CompilerC-45CompileExpr-toCExpTreeC-39 arg-0 arg-1 arg-2 arg-3 arg-4)))))))))(else (CompilerC-45CompileExpr-toCExpTreeC-39 arg-0 arg-1 arg-2 arg-3 arg-4)))))
(define CompilerC-45CompileExpr-n--16636-9139-u--getVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-7) (if (null? arg-7) '() (let ((e-3 (cdr arg-7))) (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CompileExpr-weakenVar eta-0)) (CompilerC-45CompileExpr-n--16636-9139-u--getVars arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))))
(define CompilerC-45CompileExpr-n--16636-9299-u--getVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) (if (null? arg-8) '() (let ((e-3 (cdr arg-8))) (cons 0 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45CompileExpr-weakenVar eta-0)) (CompilerC-45CompileExpr-n--16636-9299-u--getVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))))))
(define CompilerC-45CompileExpr-n--16636-9140-u--toArgExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (vector 0 arg-6 CoreC-45FC-emptyFC)))
(define CompilerC-45CompileExpr-n--16636-9300-u--toArgExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (vector 0 arg-7 CoreC-45FC-emptyFC)))
(define CompilerC-45CompileExpr-lamRHSenv (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (cons 0 '()) (let ((e-3 (cdr arg-2))) (let ((sc1 (CompilerC-45CompileExpr-lamRHSenv (bs+ arg-0 1 63) arg-1 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (LibrariesC-45DataC-45ListC-45SizeOf-suc e-5) (cons (vector 1 arg-1 (vector 2 "x" arg-0)) e-4)))))))))
(define CompilerC-45CompileExpr-getNewArgs (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-10 (car arg-2))) (let ((e-11 (cdr arg-2))) (case (vector-ref e-10 0) ((1) (let ((e-14 (vector-ref e-10 2))) (cons e-14 (CompilerC-45CompileExpr-getNewArgs e-3 e-11))))(else (cons e-2 (CompilerC-45CompileExpr-getNewArgs e-3 e-11)))))))))))
(define CompilerC-45CompileExpr-mkBounds (lambda (arg-0) (if (null? arg-0) (vector 0 ) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (vector 1 e-2 e-2 (CompilerC-45CompileExpr-mkBounds e-3)))))))
(define CoreC-45CompileExpr-mkLocalsConAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-mkLocals (LibrariesC-45DataC-45ListC-45SizeOf-C-43 (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4) arg-3) arg-4 e-5)))))))))
(define CoreC-45CompileExpr-mkLocalsConstAlt (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-2))))))
(define CoreC-45CompileExpr-mkLocals (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((eff-0 (CoreC-45TT-addVars arg-3 arg-4 e-2))) (vector 0 eff-0 e-3))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (DataC-45Maybe-fromMaybe (lambda () (vector 1 e-6 e-7)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TT-resolveRef arg-3 0 arg-4 e-6 e-7) (lambda (_-0) (box (vector 0 _-0 e-6)))))))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((u--scC-39 (CoreC-45CompileExpr-mkLocals (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 e-11))) (vector 2 e-9 e-10 u--scC-39)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (let ((u--scC-39 (CoreC-45CompileExpr-mkLocals (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 e-17))) (vector 3 e-13 e-14 e-15 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-16) u--scC-39)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-mkLocalsConAlt arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CoreC-45CompileExpr-mkLocals arg-3 arg-4 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExpr-mkLocalsConstAlt arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-mkLocals arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CompilerC-45CompileExpr-n--16552-8887-u--lamBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CompilerC-45CompileExpr-n--16552-8887-u--lamBind arg-0 arg-1 arg-2 e-3 (vector 2 arg-2 e-2 arg-4)))))))
(define CompilerC-45CompileExpr-case--lamRHS-8917 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--tmExp (CoreC-45CompileExpr-substs arg-0 '() e-2 e-3 arg-1))) (let ((u--newArgs (PreludeC-45TypesC-45List-reverse (CompilerC-45CompileExpr-getNewArgs arg-0 e-3)))) (let ((u--bounds (CompilerC-45CompileExpr-mkBounds u--newArgs))) (let ((u--expLocs (CoreC-45CompileExpr-mkLocals 0 u--bounds u--tmExp))) (CompilerC-45CompileExpr-n--16552-8887-u--lamBind arg-0 arg-1 (CoreC-45CompileExpr-getFC arg-1) (PreludeC-45TypesC-45List-tailRecAppend '() (PreludeC-45TypesC-45List-tailRecAppend u--newArgs '())) u--expLocs)))))))))
(define CompilerC-45CompileExpr-lamRHS (lambda (arg-0 arg-1) (CompilerC-45CompileExpr-case--lamRHS-8917 arg-0 arg-1 (CompilerC-45CompileExpr-lamRHSenv 0 (CoreC-45CompileExpr-getFC arg-1) arg-0))))
(define CompilerC-45CompileExpr-n--16636-9003-u--toLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cond ((equal? arg-9 1) (case (vector-ref arg-10 0) ((0) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (vector 0 '() (CompilerC-45CompileExpr-lamRHS e-0 e-1)))))(else arg-10)))(else arg-10))))
(define CompilerC-45CompileExpr-toCDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 (vector 14 CoreC-45FC-emptyFC (string-append "Encountered undefined name " (CoreC-45Name-u--show_Show_Name e-5)))))))) eff-0) eta-0))))))) ((1) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (let ((e-2 (vector-ref arg-4 3))) (let ((e-3 (vector-ref arg-4 4))) (let ((e-4 (vector-ref arg-4 5))) (lambda (clam-0) (let ((sc1 (CompilerC-45CompileExpr-mkSub 0 e-1 arg-3))) (let ((e-6 (car sc1))) (let ((e-5 (cdr sc1))) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.CompileExpr.NextMN" ) 0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45CompileExpr-toCExpTree e-1 arg-0 e-7 arg-1 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45CompileExpr-n--16636-9003-u--toLam e-1 e-2 e-4 e-3 e-0 arg-3 arg-2 arg-1 arg-0 (let ((e-9 (vector-ref e-0 2))) e-9) (let ((sc4 (DataC-45List-isNil arg-3))) (cond ((equal? sc4 1) (vector 0 e-1 e-8)) (else (vector 0 e-6 (CoreC-45CompileExpr-shrinkCExp e-5 e-8)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))) ((2) (let ((e-5 (vector-ref arg-4 1))) (lambda (clam-1) (let ((sc1 (CompilerC-45CompileExpr-mkArgList 0 e-5))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-2 (vector 7 CoreC-45FC-emptyFC e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CompilerC-45CompileExpr-n--16636-9140-u--toArgExp arg-3 e-5 arg-2 arg-1 arg-0 eta-1)) (CompilerC-45CompileExpr-n--16636-9139-u--getVars arg-3 e-5 arg-2 arg-1 arg-0 e-3)))))))) eff-0) clam-1))))))))))) ((3) (let ((e-7 (vector-ref arg-4 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-2) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45CompileExpr-getCFTypes arg-0 '() e-8))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (vector 1 (vector 2 e-7 e-2 e-3))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((4) (let ((e-8 (vector-ref arg-4 1))) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-3) (let ((sc1 (CompilerC-45CompileExpr-mkArgList 0 e-8))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (vector 1 (vector 0 e-2 (vector 6 e-8 CoreC-45FC-emptyFC e-9 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45CompileExpr-n--16636-9300-u--toArgExp arg-3 e-8 e-9 arg-2 arg-1 arg-0 eta-0)) (CompilerC-45CompileExpr-n--16636-9299-u--getVars arg-3 e-8 e-9 arg-2 arg-1 arg-0 e-3)))))))))))) ((5) (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((u--nt (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) e-12))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45CompileExpr-numArgs e-5 (vector 1 (vector 2 ) (vector 2 e-10 e-11) arg-1)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--arityC-39 (case (vector-ref e-6 0) ((0) (let ((e-0 (vector-ref e-6 1))) e-0)) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((e-3 (vector-ref e-6 2))) (PreludeC-45Types-prim__integerToNat (- e-2 (PreludeC-45TypesC-45List-length e-3)))))) (else (let ((e-4 (vector-ref e-6 1))) e-4))))) (lambda (eta-2) (vector 1 (vector 1 (box e-10) u--arityC-39 u--nt)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((6) (let ((e-14 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 1 '() e-14 '()))))) ((7) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 (vector 14 CoreC-45FC-emptyFC (string-append "Encountered unimplemented hole " (CoreC-45Name-u--show_Show_Name e-5)))))))) eff-0) eta-0))))))) ((9) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 (vector 14 CoreC-45FC-emptyFC (string-append "Encountered constrained hole " (CoreC-45Name-u--show_Show_Name e-5)))))))) eff-0) eta-0))))))) ((8) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 (vector 14 CoreC-45FC-emptyFC (string-append "Encountered incomplete proof search " (CoreC-45Name-u--show_Show_Name e-5)))))))) eff-0) eta-0)))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 (vector 14 CoreC-45FC-emptyFC (string-append "Encountered uncompilable name " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 csegen-1947) (cons e-5 arg-4))))))))) eff-0) eta-0))))))))))
(define CompilerC-45CompileExpr-n--17412-9674-u--noDefYet (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (if (null? arg-3) 0 1))(else 0))))
(define CompilerC-45CompileExpr-compileDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Trying to compile unknown name " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0) (let ((e-1 (unbox e-6))) (let ((act-3 (CoreC-45Context-getSession arg-0 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc4 (CompilerC-45CompileExpr-n--17412-9674-u--noDefYet arg-1 arg-0 (let ((e-18 (vector-ref e-1 18))) e-18) (let ((e-22 (vector-ref e-7 22))) e-22)))) (cond ((equal? sc4 1) (CoreC-45Context-recordWarning arg-0 (vector 6 CoreC-45FC-emptyFC (string-append "Compiling hole " (CoreC-45Name-u--show_Show_Name arg-1))))) (else (lambda (eta-1) (let ((act-4 (let ((act-4 (CoreC-45Context-toFullNames arg-0 csegen-1966 (let ((e-18 (vector-ref e-1 18))) e-18) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CompilerC-45CompileExpr-toCDef arg-0 arg-1 (let ((e-2 (vector-ref e-1 2))) e-2) (let ((e-3 (vector-ref e-1 3))) e-3) e-8))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Context-setCompiled arg-0 arg-1 e-8 eta-2)))) eff-0) eta-1))))))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Primitives-prim (lambda (arg-0) (vector 1 (vector 0 (string-append "prim__" arg-0)))))
(define CoreC-45Primitives-opName (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "add_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-0))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "sub_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-1))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "mul_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-2))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "div_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-3))))) ((4) (let ((e-4 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "mod_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-4))))) ((5) (let ((e-5 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "negate_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-5))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "shl_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-6))))) ((7) (let ((e-7 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "shr_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-7))))) ((8) (let ((e-8 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "and_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-8))))) ((9) (let ((e-9 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "or_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-9))))) ((10) (let ((e-10 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "xor_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-10))))) ((11) (let ((e-11 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "lt_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-11))))) ((12) (let ((e-12 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "lte_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-12))))) ((13) (let ((e-13 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "eq_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-13))))) ((14) (let ((e-14 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "gte_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-14))))) ((15) (let ((e-15 (vector-ref arg-1 1))) (CoreC-45Primitives-prim (string-append "gt_" (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-15))))) ((16) (CoreC-45Primitives-prim "strLength")) ((17) (CoreC-45Primitives-prim "strHead")) ((18) (CoreC-45Primitives-prim "strTail")) ((19) (CoreC-45Primitives-prim "strIndex")) ((20) (CoreC-45Primitives-prim "strCons")) ((21) (CoreC-45Primitives-prim "strAppend")) ((22) (CoreC-45Primitives-prim "strReverse")) ((23) (CoreC-45Primitives-prim "strSubstr")) ((24) (CoreC-45Primitives-prim "doubleExp")) ((25) (CoreC-45Primitives-prim "doubleLog")) ((26) (CoreC-45Primitives-prim "doublePow")) ((27) (CoreC-45Primitives-prim "doubleSin")) ((28) (CoreC-45Primitives-prim "doubleCos")) ((29) (CoreC-45Primitives-prim "doubleTan")) ((30) (CoreC-45Primitives-prim "doubleASin")) ((31) (CoreC-45Primitives-prim "doubleACos")) ((32) (CoreC-45Primitives-prim "doubleATan")) ((33) (CoreC-45Primitives-prim "doubleSqrt")) ((34) (CoreC-45Primitives-prim "doubleFloor")) ((35) (CoreC-45Primitives-prim "doubleCeiling")) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (CoreC-45Primitives-prim (string-append "cast_" (string-append (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-16) (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-17))))))) ((37) (CoreC-45Primitives-prim "believe_me")) (else (CoreC-45Primitives-prim "crash")))))
(define CoreC-45InitPrimitives-addPrim (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-addBuiltin (let ((e-0 (vector-ref arg-1 0))) e-0) arg-0 (CoreC-45Primitives-opName (let ((e-1 (vector-ref arg-1 1))) e-1)) (let ((e-2 (vector-ref arg-1 2))) e-2) (let ((e-3 (vector-ref arg-1 3))) e-3) (let ((e-1 (vector-ref arg-1 1))) e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CompilerC-45CompileExpr-compileDef arg-0 (CoreC-45Primitives-opName (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))))))
(define CoreC-45Primitives-primTyVal (lambda (ext-0) (vector 9 CoreC-45FC-emptyFC (vector 13 ext-0))))
(define CoreC-45Primitives-constTy (lambda (arg-0 arg-1 arg-2) (let ((u--arr csegen-1385)) ((u--arr (CoreC-45Primitives-primTyVal arg-0)) ((u--arr (CoreC-45Primitives-primTyVal arg-1)) (CoreC-45Primitives-primTyVal arg-2))))))
(define CoreC-45Primitives-arithTy (lambda (arg-0) (CoreC-45Primitives-constTy arg-0 arg-0 arg-0)))
(define CoreC-45Primitives-pi (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (vector 3 CoreC-45FC-emptyFC (vector 1 (vector 0 arg-1)) (vector 2 CoreC-45FC-emptyFC arg-2 arg-3 arg-4) arg-5)))
(define CoreC-45Primitives-believeMeTy (CoreC-45Primitives-pi "a" csegen-30 (vector 1 ) csegen-1411 (CoreC-45Primitives-pi "b" csegen-30 (vector 1 ) csegen-1411 (CoreC-45Primitives-pi "x" csegen-1416 (vector 1 ) csegen-1413 csegen-1413))))
(define CoreC-45Primitives-cmpTy (lambda (arg-0) (CoreC-45Primitives-constTy arg-0 arg-0 0)))
(define CoreC-45Primitives-constTy3 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--arr csegen-1385)) ((u--arr (CoreC-45Primitives-primTyVal arg-0)) ((u--arr (CoreC-45Primitives-primTyVal arg-1)) ((u--arr (CoreC-45Primitives-primTyVal arg-2)) (CoreC-45Primitives-primTyVal arg-3)))))))
(define CoreC-45Primitives-crashTy (CoreC-45Primitives-pi "a" csegen-30 (vector 1 ) csegen-1411 (CoreC-45Primitives-pi "msg" AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 9 CoreC-45FC-emptyFC (vector 13 10)) csegen-1413)))
(define CoreC-45Primitives-predTy (lambda (arg-0 arg-1) (let ((u--arr csegen-1385)) ((u--arr (CoreC-45Primitives-primTyVal arg-0)) (CoreC-45Primitives-primTyVal arg-1)))))
(define CoreC-45Primitives-doubleTy (CoreC-45Primitives-predTy 12 12))
(define CoreC-45Primitives-integralTypes (cons 0 (cons 1 (cons 2 (cons 3 (cons 4 (cons 5 (cons 6 (cons 7 (cons 8 (cons 9 '())))))))))))
(define CoreC-45TT-isTotal (cons (vector 0 ) (vector 0 )))
(define CoreC-45TT-notCovering (cons (vector 0 ) (vector 1 '())))
(define CoreC-45Primitives-numTypes (PreludeC-45TypesC-45List-tailRecAppend CoreC-45Primitives-integralTypes (cons 12 '())))
(define CoreC-45Primitives-primTypes (PreludeC-45TypesC-45List-tailRecAppend CoreC-45Primitives-numTypes (cons 10 (cons 11 '()))))
(define CoreC-45Primitives-allPrimitives (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 0 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-numTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 1 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-numTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 2 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-numTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 1 (vector 5 u--t) (CoreC-45Primitives-predTy u--t u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-numTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 3 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-notCovering)) CoreC-45Primitives-numTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 4 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-notCovering)) CoreC-45Primitives-integralTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 6 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-integralTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 7 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-integralTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 8 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-integralTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 9 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-integralTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 10 u--t) (CoreC-45Primitives-arithTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-integralTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 11 u--t) (CoreC-45Primitives-cmpTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-primTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 12 u--t) (CoreC-45Primitives-cmpTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-primTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 13 u--t) (CoreC-45Primitives-cmpTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-primTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 14 u--t) (CoreC-45Primitives-cmpTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-primTypes) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (vector 2 (vector 15 u--t) (CoreC-45Primitives-cmpTy u--t) CoreC-45TT-isTotal)) CoreC-45Primitives-primTypes) (PreludeC-45TypesC-45List-tailRecAppend (cons (vector 1 (vector 16 ) (CoreC-45Primitives-predTy 10 0) CoreC-45TT-isTotal) (cons (vector 1 (vector 17 ) (CoreC-45Primitives-predTy 10 11) CoreC-45TT-notCovering) (cons (vector 1 (vector 18 ) (CoreC-45Primitives-predTy 10 10) CoreC-45TT-notCovering) (cons (vector 2 (vector 19 ) (CoreC-45Primitives-constTy 10 0 11) CoreC-45TT-notCovering) (cons (vector 2 (vector 20 ) (CoreC-45Primitives-constTy 11 10 10) CoreC-45TT-isTotal) (cons (vector 2 (vector 21 ) (CoreC-45Primitives-arithTy 10) CoreC-45TT-isTotal) (cons (vector 1 (vector 22 ) (CoreC-45Primitives-predTy 10 10) CoreC-45TT-isTotal) (cons (vector 3 (vector 23 ) (CoreC-45Primitives-constTy3 0 0 10 10) CoreC-45TT-isTotal) (cons (vector 3 (vector 37 ) CoreC-45Primitives-believeMeTy CoreC-45TT-isTotal) (cons (vector 2 (vector 38 ) CoreC-45Primitives-crashTy CoreC-45TT-notCovering) '())))))))))) (PreludeC-45TypesC-45List-tailRecAppend (cons (vector 1 (vector 24 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 25 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 2 (vector 26 ) (CoreC-45Primitives-arithTy 12) CoreC-45TT-isTotal) (cons (vector 1 (vector 27 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 28 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 29 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 30 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 31 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 32 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 33 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 34 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) (cons (vector 1 (vector 35 ) CoreC-45Primitives-doubleTy CoreC-45TT-isTotal) '())))))))))))) (PreludeC-45Types-listBind CoreC-45Primitives-primTypes (lambda (u--t1) (PreludeC-45Types-listBind CoreC-45Primitives-primTypes (lambda (u--t2) (PreludeC-45Types-listBind (PreludeC-45Interfaces-guard csegen-1509 (let ((sc0 (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_PrimType u--t1 u--t2))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1512 csegen-1512 (cons u--t1 u--t2) (cons 10 11)))) (cond ((equal? sc1 1) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1512 csegen-1512 (cons u--t1 u--t2) (cons 12 11)))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1512 csegen-1512 (cons u--t1 u--t2) (cons 11 12))) (else 0)))) (else 0)))) (else 0)))) (lambda (_-10649) (PreludeC-45Types-u--pure_Applicative_List (vector 1 (vector 36 u--t1 u--t2) (CoreC-45Primitives-predTy u--t1 u--t2) CoreC-45TT-isTotal)))))))))))))))))))))))))))
(define CoreC-45InitPrimitives-addPrimitives (lambda (arg-0) (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45InitPrimitives-addPrim arg-0 eta-0 eta-1))) CoreC-45Primitives-allPrimitives)))
(define IdrisC-45Driver-banner (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "     ____    __     _         ___\xa;    /  _/___/ /____(_)____   |__ \\\xa;    / // __  / ___/ / ___/   __/ /     Version " (cons csegen-1994 (cons "\xa;  _/ // /_/ / /  / (__  )   / __/      https://www.idris-lang.org\xa; /___/\\__,_/_/  /_/____/   /____/      Type :? for help\xa;\xa;Welcome to Idris 2.  Enjoy yourself!" '())))))
(define IdrisC-45Driver-checkVerbose (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((17) 1)(else (IdrisC-45Driver-checkVerbose e-3))))))))
(define LibrariesC-45UtilsC-45Path-isAbsoluteC-39 (lambda (arg-0) (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) (let ((e-0 (vector-ref arg-0 0))) (if (null? e-0) 0 (let ((e-4 (unbox e-0))) (case (vector-ref e-4 0) ((0) 1) (else (let ((e-8 (vector-ref arg-0 1))) e-8))))))) (else (let ((e-1 (vector-ref arg-0 1))) e-1))))))
(define LibrariesC-45UtilsC-45Path-appendC-39 (lambda (arg-0 arg-1) (let ((sc0 (let ((sc1 (LibrariesC-45UtilsC-45Path-isAbsoluteC-39 arg-1))) (cond ((equal? sc1 1) 1) (else (DataC-45Maybe-isJust (let ((e-0 (vector-ref arg-1 0))) e-0))))))) (cond ((equal? sc0 1) arg-1) (else (let ((sc1 (let ((e-1 (vector-ref arg-1 1))) e-1))) (cond ((equal? sc1 1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector (let ((e-7 (vector-ref arg-0 0))) e-7) e-1 e-2 e-3))))) (else (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (vector e-0 e-1 (PreludeC-45TypesC-45List-tailRecAppend (let ((e-5 (vector-ref arg-0 2))) e-5) (let ((e-5 (vector-ref arg-1 2))) e-5)) (let ((e-4 (vector-ref arg-1 3))) e-4))))))))))))
(define LibrariesC-45UtilsC-45Path-emptyPath (vector '() 0 '() 0))
(define LibrariesC-45TextC-45LexerC-45Core-scan (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-1 0) ((0) (box (cons arg-2 arg-3))) ((1) '()) ((2) (if (null? arg-3) (box (cons arg-2 '())) '())) ((3) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool (DataC-45Maybe-isJust (LibrariesC-45TextC-45LexerC-45Core-scan e-3 arg-2 arg-3)) e-2))) (cond ((equal? sc1 1) (box (cons arg-2 arg-3))) (else '())))))) ((4) (let ((e-4 (vector-ref arg-1 1))) (if (null? arg-3) '() (let ((e-25 (car arg-3))) (let ((e-26 (cdr arg-3))) (let ((sc2 (e-4 e-25))) (cond ((equal? sc2 1) (box (cons (cons e-25 arg-2) e-26))) (else '())))))))) ((5) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45TextC-45LexerC-45Core-scan e-6 arg-2 arg-3) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (LibrariesC-45TextC-45LexerC-45Core-scan (e-7) e-2 e-3)))))))) ((6) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45TextC-45LexerC-45Core-scan e-10 arg-2 arg-3) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (LibrariesC-45TextC-45LexerC-45Core-scan e-11 e-2 e-3)))))))) ((7) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45TextC-45LexerC-45Core-scan e-13 arg-2 arg-3) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (LibrariesC-45TextC-45LexerC-45Core-scan e-14 e-2 e-3)))))))) (else (let ((e-17 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 2))) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45LexerC-45Core-scan e-18 arg-2 arg-3)) (lambda () (lambda (eta-0) (box eta-0))) (LibrariesC-45TextC-45LexerC-45Core-scan e-17 arg-2 arg-3))))))))
(define LibrariesC-45TextC-45LexerC-45Core-n--3961-2522-u--countNLs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (PreludeC-45TypesC-45List-lengthTR (PreludeC-45TypesC-45List-filterAppend '() csegen-679 arg-7))))
(define LibrariesC-45TextC-45LexerC-45Core-n--3961-2523-u--getCols (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((sc0 (DataC-45List-span csegen-678 arg-7))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-3) (bs+ arg-8 (blodwen-toSignedInt (PreludeC-45TypesC-45List-lengthTR e-2) 63) 63) (blodwen-toSignedInt (PreludeC-45TypesC-45List-lengthTR e-2) 63)))))))
(define LibrariesC-45TextC-45LexerC-45Core-case--tokeniseC-44getFirstToken-2657 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (LibrariesC-45TextC-45LexerC-45Core-n--3961-2524-u--getFirstToken arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-10) (let ((e-1 (unbox arg-11))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((u--lineC-39 (bs+ arg-5 (blodwen-toSignedInt (LibrariesC-45TextC-45LexerC-45Core-n--3961-2522-u--countNLs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) 63) 63))) (let ((u--colC-39 (LibrariesC-45TextC-45LexerC-45Core-n--3961-2523-u--getCols arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 arg-4))) (box (cons (vector (arg-8 (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-5))) 0 (vector arg-5 arg-4 u--lineC-39 u--colC-39)) (cons u--lineC-39 (cons u--colC-39 e-6))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-n--3961-2524-u--getFirstToken (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45TextC-45LexerC-45Core-case--tokeniseC-44getFirstToken-2657 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6 e-7 e-3 arg-8 (LibrariesC-45TextC-45LexerC-45Core-scan e-6 '() arg-8)))))))))
(define LibrariesC-45TextC-45LexerC-45Core-case--tokenise-2747 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (cons (PreludeC-45TypesC-45List-reverse arg-3) (cons arg-5 (cons arg-4 arg-1))) (let ((e-1 (unbox arg-7))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((sc4 (arg-6 (let ((e-4 (vector-ref e-5 0))) e-4)))) (cond ((equal? sc4 1) (cons (PreludeC-45TypesC-45List-reverse arg-3) (cons arg-5 (cons arg-4 '())))) (else (LibrariesC-45TextC-45LexerC-45Core-tokenise arg-6 e-9 e-13 (cons e-5 arg-3) arg-2 e-14))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-tokenise (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (LibrariesC-45TextC-45LexerC-45Core-case--tokenise-2747 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (LibrariesC-45TextC-45LexerC-45Core-n--3961-2524-u--getFirstToken arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-5 arg-6))))
(define LibrariesC-45TextC-45LexerC-45Core-lex (lambda (arg-1 arg-2) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-tokenise (lambda (eta-0) 0) 0 0 '() arg-1 (PreludeC-45Types-fastUnpack arg-2)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons e-10 (PreludeC-45Types-fastPack e-11)))))))))))))
(define LibrariesC-45TextC-45LexerC-45Core-reject (lambda (ext-0) (vector 3 0 ext-0)))
(define LibrariesC-45TextC-45Lexer-non (lambda (arg-0) (vector 6 (LibrariesC-45TextC-45LexerC-45Core-reject arg-0) LibrariesC-45TextC-45Lexer-any)))
(define LibrariesC-45TextC-45Lexer-oneOf (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--x) (PreludeC-45Types-elem csegen-14 csegen-17 u--x (PreludeC-45Types-fastUnpack arg-0))))))
(define LibrariesC-45TextC-45Lexer-toTokenMap (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (lambda (eta-0) (cons e-3 eta-0)))))) ext-0)))
(define LibrariesC-45UtilsC-45Path-pathTokenMap (LibrariesC-45TextC-45Lexer-toTokenMap (cons (cons (LibrariesC-45TextC-45Lexer-is #\/) (box #\/)) (cons (cons (LibrariesC-45TextC-45Lexer-is #\\) (box #\\)) (cons (cons (LibrariesC-45TextC-45Lexer-is #\:) (box #\:)) (cons (cons (LibrariesC-45TextC-45Lexer-is #\?) (box #\?)) (cons (cons (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45Lexer-non (LibrariesC-45TextC-45Lexer-oneOf "/\\:?"))) '()) '())))))))
(define LibrariesC-45UtilsC-45Path-lexPath (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-lex LibrariesC-45UtilsC-45Path-pathTokenMap arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-7 (cdr e-3))) e-2))))))
(define DataC-45List-headC-39 (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-unconsC-39 ext-0))))
(define LibrariesC-45TextC-45ParserC-45Core-mergeWith (lambda (arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (let ((e-6 (vector-ref arg-5 4))) (let ((e-7 (vector-ref arg-5 5))) (vector 1 e-3 e-4 e-5 (LibrariesC-45TextC-45Bounded-mergeBounds arg-4 e-6) e-7)))))))(else arg-5))))
(define LibrariesC-45TextC-45Bounded-removeIrrelevance (lambda (arg-1) (let ((e-1 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 2))) (vector e-1 1 e-3)))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-4034 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-3 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 3))) (vector 0 e-3 0 e-5))))(else arg-10))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-4135 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-3 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 3))) (vector 0 e-3 1 e-5))))(else arg-10))))
(define DataC-45List1-appendl (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cons e-1 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-2))))))
(define DataC-45List1-C-43C-43 (lambda (arg-1 arg-2) (DataC-45List1-appendl arg-1 (DataC-45List1-forget arg-2))))
(define LibrariesC-45TextC-45ParserC-45Core-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32doParse-4634 (lambda (arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-16 0) ((0) (let ((e-3 (vector-ref arg-16 1))) (let ((e-4 (vector-ref arg-16 2))) (let ((e-5 (vector-ref arg-16 3))) (let ((sc1 (cond ((equal? e-3 1) 1) (else e-4)))) (cond ((equal? sc1 1) (vector 0 e-3 e-4 e-5)) (else (vector 0 arg-9 0 (DataC-45List1-C-43C-43 arg-12 e-5))))))))) (else (let ((e-9 (vector-ref arg-16 1))) (let ((e-10 (vector-ref arg-16 2))) (let ((e-12 (vector-ref arg-16 4))) (let ((e-13 (vector-ref arg-16 5))) (vector 1 e-9 e-10 arg-9 e-12 e-13)))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-4512 (lambda (arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-3 (vector-ref arg-13 1))) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (let ((sc1 (cond ((equal? e-3 1) 1) (else e-4)))) (cond ((equal? sc1 1) (vector 0 arg-10 e-4 e-5)) (else (LibrariesC-45TextC-45ParserC-45Core-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32doParse-4634 arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 e-4 e-3 arg-4 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-3 arg-4 arg-11 0 (arg-6) arg-9))))))))) (else (let ((e-9 (vector-ref arg-13 1))) (let ((e-10 (vector-ref arg-13 2))) (let ((e-12 (vector-ref arg-13 4))) (let ((e-13 (vector-ref arg-13 5))) (vector 1 e-9 e-10 arg-10 e-12 e-13)))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-4882 (lambda (arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((0) (let ((e-3 (vector-ref arg-14 1))) (let ((e-4 (vector-ref arg-14 2))) (let ((e-5 (vector-ref arg-14 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref arg-14 1))) (let ((e-10 (vector-ref arg-14 2))) (let ((e-11 (vector-ref arg-14 3))) (let ((e-12 (vector-ref arg-14 4))) (let ((e-13 (vector-ref arg-14 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-3 e-9 e-10 e-11 (arg-8 (let ((e-1 (vector-ref e-12 0))) e-1)) e-13)))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-5000 (lambda (arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-3 (vector-ref arg-13 1))) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref arg-13 1))) (let ((e-10 (vector-ref arg-13 2))) (let ((e-11 (vector-ref arg-13 3))) (let ((e-12 (vector-ref arg-13 4))) (let ((e-13 (vector-ref arg-13 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-3 e-9 e-10 e-11 ((arg-7) (let ((e-1 (vector-ref e-12 0))) e-1)) e-13)))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-case--doParse-5325 (lambda (arg-3 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-3 (vector-ref arg-11 1))) (let ((e-4 (vector-ref arg-11 2))) (let ((e-5 (vector-ref arg-11 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref arg-11 1))) (let ((e-10 (vector-ref arg-11 2))) (let ((e-11 (vector-ref arg-11 3))) (let ((e-12 (vector-ref arg-11 4))) (let ((e-13 (vector-ref arg-11 5))) (vector 1 e-9 e-10 e-11 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) e-12) e-12) e-13))))))))))
(define LibrariesC-45TextC-45ParserC-45Core-doParse (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-8 0) ((0) (let ((e-3 (vector-ref arg-8 1))) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds e-3) arg-9))) ((5) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (vector 1 arg-5 (cons (cons e-6 e-7) arg-6) arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds (vector 0 )) arg-9)))) ((4) (let ((e-12 (vector-ref arg-8 1))) (let ((e-13 (vector-ref arg-8 2))) (let ((e-14 (vector-ref arg-8 3))) (vector 0 arg-7 e-13 (cons (cons e-14 (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe e-12 (lambda () (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-3 (vector-ref eta-0 2))) e-3)) (DataC-45List-headC-39 arg-9))))) '())))))) ((6) (let ((e-19 (vector-ref arg-8 1))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-4034 arg-4 arg-5 e-19 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-19 arg-9)))) ((7) (vector 1 arg-5 arg-6 1 (LibrariesC-45TextC-45Bounded-irrelevantBounds (vector 0 )) arg-9)) ((8) (let ((e-26 (vector-ref arg-8 1))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-4135 arg-4 arg-5 e-26 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-26 arg-9)))) ((1) (let ((e-30 (vector-ref arg-8 1))) (let ((e-31 (vector-ref arg-8 2))) (if (null? arg-9) (vector 0 arg-7 0 csegen-602) (let ((e-85 (car arg-9))) (let ((e-86 (cdr arg-9))) (let ((sc2 (e-31 (let ((e-1 (vector-ref e-85 0))) e-1)))) (if (null? sc2) (vector 0 arg-7 0 (cons (cons e-30 (box (let ((e-3 (vector-ref e-85 2))) e-3))) '())) (let ((e-2 (unbox sc2))) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) e-2) e-85) e-86)))))))))) ((3) (if (null? arg-9) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds (vector 0 )) '()) (let ((e-89 (car arg-9))) (vector 0 arg-7 0 (cons (cons "Expected end of input" (box (let ((e-3 (vector-ref e-89 2))) e-3))) '()))))) ((2) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (if (null? arg-9) (vector 0 arg-7 0 csegen-602) (let ((e-93 (car arg-9))) (let ((e-94 (cdr arg-9))) (let ((sc2 (e-37 (let ((e-1 (vector-ref e-93 0))) e-1)))) (cond ((equal? sc2 1) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-removeIrrelevance e-93) (cons e-93 e-94))) (else (vector 0 arg-7 0 (cons (cons e-36 (box (let ((e-3 (vector-ref e-93 2))) e-3))) '()))))))))))) ((13) (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (let ((e-43 (vector-ref arg-8 3))) (let ((e-44 (vector-ref arg-8 4))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-4512 arg-4 arg-5 e-42 e-44 e-41 e-43 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 0 e-43 arg-9))))))) ((10) (let ((e-49 (vector-ref arg-8 1))) (let ((e-50 (vector-ref arg-8 2))) (let ((e-51 (vector-ref arg-8 3))) (let ((e-52 (vector-ref arg-8 4))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-4882 arg-4 e-49 e-50 arg-5 e-52 e-51 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-51 arg-9))))))) ((9) (let ((e-57 (vector-ref arg-8 1))) (let ((e-58 (vector-ref arg-8 2))) (let ((e-59 (vector-ref arg-8 3))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-5000 arg-4 e-57 arg-5 e-59 e-58 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-58 arg-9)))))) ((12) (let ((e-65 (vector-ref arg-8 3))) (let ((e-66 (vector-ref arg-8 4))) (let ((sc1 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-65 arg-9))) (case (vector-ref sc1 0) ((0) (let ((e-3 (vector-ref sc1 1))) (let ((e-4 (vector-ref sc1 2))) (let ((e-5 (vector-ref sc1 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref sc1 1))) (let ((e-10 (vector-ref sc1 2))) (let ((e-11 (vector-ref sc1 3))) (let ((e-12 (vector-ref sc1 4))) (let ((e-13 (vector-ref sc1 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 e-9 e-10 e-11 e-66 e-13))))))))))))) ((11) (let ((e-71 (vector-ref arg-8 2))) (let ((e-72 (vector-ref arg-8 3))) (let ((sc1 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-71 arg-9))) (case (vector-ref sc1 0) ((0) (let ((e-3 (vector-ref sc1 1))) (let ((e-4 (vector-ref sc1 2))) (let ((e-5 (vector-ref sc1 3))) (vector 0 e-3 e-4 e-5))))) (else (let ((e-9 (vector-ref sc1 1))) (let ((e-10 (vector-ref sc1 2))) (let ((e-11 (vector-ref sc1 3))) (let ((e-12 (vector-ref sc1 4))) (let ((e-13 (vector-ref sc1 5))) (LibrariesC-45TextC-45ParserC-45Core-mergeWith e-12 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 e-9 e-10 e-11 (e-72) e-13))))))))))))) ((14) (let ((e-77 (vector-ref arg-8 1))) (LibrariesC-45TextC-45ParserC-45Core-case--doParse-5325 arg-4 arg-5 e-77 arg-9 arg-7 arg-6 (LibrariesC-45TextC-45ParserC-45Core-doParse arg-4 arg-5 arg-6 arg-7 e-77 arg-9)))) ((15) (if (null? arg-9) (vector 0 arg-7 0 csegen-602) (let ((e-97 (car arg-9))) (let ((e-98 (cdr arg-9))) (vector 1 arg-5 arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds (let ((e-3 (vector-ref e-97 2))) e-3)) (cons e-97 e-98)))))) (else (let ((e-82 (vector-ref arg-8 1))) (vector 1 ((arg-4 arg-5) e-82) arg-6 arg-7 (LibrariesC-45TextC-45Bounded-irrelevantBounds (vector 0 )) arg-9))))))
(define LibrariesC-45TextC-45ParserC-45Core-parse (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-doParse (lambda (eta-0) (lambda (eta-1) (vector 0 ))) (vector 0 ) '() 0 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-5 (vector-ref sc0 3))) (vector 0 e-5))) (else (let ((e-10 (vector-ref sc0 2))) (let ((e-12 (vector-ref sc0 4))) (let ((e-13 (vector-ref sc0 5))) (vector 1 (cons e-10 (cons (let ((e-1 (vector-ref e-12 0))) e-1) e-13)))))))))))
(define DataC-45List-delete (lambda (arg-1 ext-0 ext-1) (DataC-45List-deleteBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define LibrariesC-45UtilsC-45Path-parseBody (vector 9 0 csegen-534 (lambda () (lambda (u--text) (cond ((equal? u--text "..") (vector 0 (vector 1 ))) ((equal? u--text ".") (vector 0 (vector 0 )))(else (vector 0 (vector 2 u--text))))))))
(define PreludeC-45Types-toUpper (lambda (arg-0) (let ((sc0 (PreludeC-45Types-isLower arg-0))) (cond ((equal? sc0 1) (cast-int-char (bs- (cast-char-boundedInt arg-0 63) 32 63))) (else arg-0)))))
(define LibrariesC-45UtilsC-45Path-disk (vector 9 1 csegen-534 (lambda () (lambda (u--text) (vector 10 0 1 (let ((sc0 (PreludeC-45Types-fastUnpack u--text))) (if (null? sc0) (vector 4 '() 0 "Expects disk") (let ((e-1 (car sc0))) (vector 0 e-1)))) (lambda (u--disk) (vector 11 0 (LibrariesC-45TextC-45Parser-match csegen-533 (box #\:)) (lambda () (vector 0 (vector 1 (PreludeC-45Types-toUpper u--disk)))))))))))
(define LibrariesC-45UtilsC-45Path-unc (let ((sc0 csegen-541)) (cond ((equal? sc0 0) (vector 12 0 1 csegen-544 (lambda () csegen-536))) (else (vector 11 1 csegen-544 (lambda () csegen-536))))))
(define LibrariesC-45UtilsC-45Path-verbatim (let ((sc0 csegen-541)) (cond ((equal? sc0 0) (vector 12 0 1 csegen-544 (lambda () csegen-547))) (else (vector 11 1 csegen-544 (lambda () csegen-547))))))
(define LibrariesC-45UtilsC-45Path-verbatimDisk (vector 11 1 LibrariesC-45UtilsC-45Path-verbatim (lambda () (vector 9 0 LibrariesC-45UtilsC-45Path-disk (lambda () (lambda (u--disk) (vector 0 u--disk)))))))
(define LibrariesC-45UtilsC-45Path-verbatimUnc (vector 11 1 LibrariesC-45UtilsC-45Path-verbatim (lambda () csegen-536)))
(define LibrariesC-45UtilsC-45Path-parseVolume (vector 13 1 1 LibrariesC-45UtilsC-45Path-verbatimUnc (lambda () (vector 13 1 1 LibrariesC-45UtilsC-45Path-verbatimDisk (lambda () (vector 13 1 1 LibrariesC-45UtilsC-45Path-unc (lambda () LibrariesC-45UtilsC-45Path-disk)))))))
(define LibrariesC-45UtilsC-45Path-parsePath (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 LibrariesC-45UtilsC-45Path-parseVolume) (lambda (u--vol) (vector 10 0 0 csegen-579 (lambda (u--root) (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 (LibrariesC-45TextC-45Parser-some LibrariesC-45UtilsC-45Path-bodySeparator) LibrariesC-45UtilsC-45Path-parseBody) (lambda (u--body) (vector 10 0 0 csegen-579 (lambda (u--trailSep) (let ((body-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (DataC-45String-ltrim e-0) "")))(else 1))) u--body))) (let ((body-1 (if (null? body-0) '() (let ((e-2 (car body-0))) (let ((e-3 (cdr body-0))) (cons e-2 (DataC-45List-delete csegen-527 (vector 0 ) e-3))))))) (vector 0 (vector u--vol (DataC-45Maybe-isJust u--root) body-1 (DataC-45Maybe-isJust u--trailSep))))))))))))))
(define LibrariesC-45UtilsC-45Path-parse (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parse 0 LibrariesC-45UtilsC-45Path-parsePath (LibrariesC-45UtilsC-45Path-lexPath arg-0)))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 1))) (if (null? e-2) LibrariesC-45UtilsC-45Path-emptyPath (let ((e-6 (cdr e-2))) (if (null? e-6) LibrariesC-45UtilsC-45Path-emptyPath (let ((e-9 (car e-6))) e-9))))))(else LibrariesC-45UtilsC-45Path-emptyPath)))))
(define LibrariesC-45UtilsC-45Path-C-47C-62 (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-appendC-39 arg-0 (LibrariesC-45UtilsC-45Path-parse arg-1))))
(define LibrariesC-45UtilsC-45Path-dirSeparator (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) #\\) (else #\/))))
(define DataC-45String-singleton (lambda (arg-0) (string-cons arg-0 "")))
(define LibrariesC-45UtilsC-45Path-u--show_Show_Body (lambda (arg-0) (case (vector-ref arg-0 0) ((0) ".") ((1) "..") (else (let ((e-0 (vector-ref arg-0 1))) e-0)))))
(define LibrariesC-45UtilsC-45Path-u--show_Show_Volume (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append "\\\\" (string-append e-0 (string-append "\\" e-1)))))) (else (let ((e-2 (vector-ref arg-0 1))) (string-append (DataC-45String-singleton e-2) ":"))))))
(define LibrariesC-45UtilsC-45Path-u--show_Show_Path (lambda (arg-0) (let ((u--sep (DataC-45String-singleton LibrariesC-45UtilsC-45Path-dirSeparator))) (let ((u--showVol (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Volume eta-0))) (let ((e-0 (vector-ref arg-0 0))) e-0)))) (let ((u--showRoot (let ((sc0 (let ((e-1 (vector-ref arg-0 1))) e-1))) (cond ((equal? sc0 1) u--sep) (else ""))))) (let ((u--showBody (LibrariesC-45DataC-45StringC-45Extra-join u--sep csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Body eta-0)) (let ((e-2 (vector-ref arg-0 2))) e-2))))) (let ((u--showTrail (let ((sc0 (let ((e-3 (vector-ref arg-0 3))) e-3))) (cond ((equal? sc0 1) u--sep) (else ""))))) (string-append u--showVol (string-append u--showRoot (string-append u--showBody u--showTrail))))))))))
(define LibrariesC-45UtilsC-45Path-C-60C-47C-62 (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-C-47C-62 (LibrariesC-45UtilsC-45Path-parse arg-0) arg-1))))
(define CoreC-45Directory-cleanPath (lambda (ext-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (let ((sc0 (LibrariesC-45UtilsC-45Path-parse ext-0))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (vector e-0 e-1 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-0) (LibrariesC-45UtilsC-45Path-u--C-47C-61_Eq_Body arg-0 (vector 0 ))) e-2) 0))))))))
(define LibrariesC-45UtilsC-45Path-n--7407-7493-u--dropBody (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) (box arg-3) (if (null? arg-3) '() (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (let ((sc4 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Body e-1 e-4))) (cond ((equal? sc4 1) (LibrariesC-45UtilsC-45Path-n--7407-7493-u--dropBody arg-0 arg-1 e-2 e-5)) (else '())))))))))))
(define LibrariesC-45UtilsC-45Path-case--caseC-32blockC-32inC-32dropBase-7565 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((sc0 (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-524 arg-5 e-0))) (cond ((equal? sc1 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool arg-4 e-1)) (else 0))))) (cond ((equal? sc0 1) (box (vector 0 ))) (else '()))) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Path-n--7407-7493-u--dropBody arg-0 arg-1 arg-3 e-2) (lambda (u--body) (box (LibrariesC-45UtilsC-45Path-u--show_Show_Path (vector '() 0 u--body e-3)))))))))))))
(define LibrariesC-45UtilsC-45Path-dropBase (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45UtilsC-45Path-parse arg-0))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (LibrariesC-45UtilsC-45Path-case--caseC-32blockC-32inC-32dropBase-7565 arg-1 arg-0 e-3 e-2 e-1 e-0 (LibrariesC-45UtilsC-45Path-parse arg-1)))))))))
(define LibrariesC-45UtilsC-45Path-n--6992-7086-u--findNormal (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (case (vector-ref e-1 0) ((2) (let ((e-3 (vector-ref e-1 1))) (box e-3))) ((0) (LibrariesC-45UtilsC-45Path-n--6992-7086-u--findNormal arg-0 e-2))(else '())))))))
(define LibrariesC-45UtilsC-45Path-fileNameC-39 (lambda (arg-0) (LibrariesC-45UtilsC-45Path-n--6992-7086-u--findNormal arg-0 (PreludeC-45TypesC-45List-reverse (let ((e-2 (vector-ref arg-0 2))) e-2)))))
(define LibrariesC-45UtilsC-45Path-case--splitParentC-39-7002 (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((u--parent (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (vector e-0 e-1 (DataC-45List-init (cons e-2 e-3)) 0))))) (let ((u--child (vector '() 0 (cons (DataC-45List-last (cons e-2 e-3)) '()) (let ((e-4 (vector-ref arg-0 3))) e-4)))) (box (cons u--parent u--child)))))))))
(define LibrariesC-45UtilsC-45Path-splitParentC-39 (lambda (arg-0) (LibrariesC-45UtilsC-45Path-case--splitParentC-39-7002 arg-0 (let ((e-2 (vector-ref arg-0 2))) e-2))))
(define LibrariesC-45UtilsC-45Path-parentC-39 (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45UtilsC-45Path-splitParentC-39 ext-0))))
(define LibrariesC-45UtilsC-45Path-setFileNameC-39 (lambda (arg-0 arg-1) (let ((sc0 (DataC-45Maybe-isJust (LibrariesC-45UtilsC-45Path-fileNameC-39 arg-1)))) (cond ((equal? sc0 1) (LibrariesC-45UtilsC-45Path-appendC-39 (DataC-45Maybe-fromMaybe (lambda () LibrariesC-45UtilsC-45Path-emptyPath) (LibrariesC-45UtilsC-45Path-parentC-39 arg-1)) (LibrariesC-45UtilsC-45Path-parse arg-0))) (else (LibrariesC-45UtilsC-45Path-appendC-39 arg-1 (LibrariesC-45UtilsC-45Path-parse arg-0)))))))
(define LibrariesC-45UtilsC-45Path-case--splitExtensions-7233 (lambda (arg-0 arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (cond ((equal? e-1 "") (if (null? e-2) (cons e-1 e-2) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (cons (string-append "." e-4) e-5)))))(else (cons e-1 e-2)))))))
(define LibrariesC-45UtilsC-45Path-splitExtensions (lambda (arg-0) (LibrariesC-45UtilsC-45Path-case--splitExtensions-7233 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45List-split csegen-520 (PreludeC-45Types-fastUnpack arg-0))))))
(define LibrariesC-45UtilsC-45Path-case--C-60C-46C-46C-62-7935 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-1 (let ((e-1 (unbox arg-5))) (let ((sc1 (LibrariesC-45UtilsC-45Path-splitExtensions e-1))) (let ((e-2 (car sc1))) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-setFileNameC-39 (string-append e-2 arg-4) arg-2))))))))
(define LibrariesC-45UtilsC-45Path-C-60C-46C-46C-62 (lambda (arg-0 arg-1) (let ((u--pathC-39 (LibrariesC-45UtilsC-45Path-parse arg-0))) (let ((u--ext (PreludeC-45Types-fastPack (DataC-45List-dropWhile csegen-597 (PreludeC-45Types-fastUnpack arg-1))))) (let ((ext-0 (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--ext ""))) (cond ((equal? sc0 1) "") (else (string-append "." u--ext)))))) (LibrariesC-45UtilsC-45Path-case--C-60C-46C-46C-62-7935 arg-1 arg-0 u--pathC-39 u--ext ext-0 (LibrariesC-45UtilsC-45Path-fileNameC-39 u--pathC-39)))))))
(define LibrariesC-45UtilsC-45Path-dropExtensions (lambda (arg-0) (LibrariesC-45UtilsC-45Path-C-60C-46C-46C-62 arg-0 "")))
(define LibrariesC-45UtilsC-45Path-isAbsolute (lambda (ext-0) (LibrariesC-45UtilsC-45Path-isAbsoluteC-39 (LibrariesC-45UtilsC-45Path-parse ext-0))))
(define LibrariesC-45UtilsC-45Path-n--6788-6892-u--iterateBody (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (cons (vector '() 0 (cons e-2 '()) arg-2) '()) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (vector '() 0 (cons e-2 '()) 0) (LibrariesC-45UtilsC-45Path-n--6788-6892-u--iterateBody arg-0 (cons e-6 e-7) arg-2))))))))))
(define LibrariesC-45UtilsC-45Path-n--6788-6893-u--splitRoot (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (if (null? e-0) (cond ((equal? e-1 0) (cons '() arg-1))(else (cons (box (vector e-0 e-1 '() 0)) (vector '() 0 e-2 e-3)))) (cons (box (vector e-0 e-1 '() 0)) (vector '() 0 e-2 e-3)))))))))
(define LibrariesC-45UtilsC-45Path-splitPathC-39 (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-n--6788-6893-u--splitRoot arg-0 arg-0))) (let ((e-2 (car sc0))) (if (null? e-2) (LibrariesC-45UtilsC-45Path-n--6788-6892-u--iterateBody arg-0 (let ((e-5 (vector-ref arg-0 2))) e-5) (let ((e-4 (vector-ref arg-0 3))) e-4)) (let ((e-5 (unbox e-2))) (cons e-5 (LibrariesC-45UtilsC-45Path-n--6788-6892-u--iterateBody arg-0 (let ((e-6 (vector-ref arg-0 2))) e-6) (let ((e-4 (vector-ref arg-0 3))) e-4)))))))))
(define LibrariesC-45UtilsC-45Path-splitPath (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path eta-0)) (LibrariesC-45UtilsC-45Path-splitPathC-39 (LibrariesC-45UtilsC-45Path-parse ext-0)))))
(define CoreC-45Directory-mbPathToNS (lambda (arg-0 arg-1 arg-2) (let ((u--sdir (DataC-45Maybe-fromMaybe (lambda () "") arg-1))) (let ((u--base (let ((sc0 (LibrariesC-45UtilsC-45Path-isAbsolute arg-2))) (cond ((equal? sc0 1) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-0 u--sdir)) (else u--sdir))))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (PreludeC-45TypesC-45List-reverse (LibrariesC-45UtilsC-45Path-splitPath (LibrariesC-45UtilsC-45Path-dropExtensions eta-0)))) (PreludeC-45Basics-on (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45Path-dropBase eta-0 eta-1))) (lambda (eta-0) (CoreC-45Directory-cleanPath eta-0)) u--base arg-2))))))
(define CoreC-45Directory-corePathToNS (lambda (arg-0 arg-1 arg-2) (let ((u--err (vector 62 (string-append "Source file " (string-append (PreludeC-45Show-u--show_Show_String arg-2) (string-append " is not in the source directory " (PreludeC-45Show-u--show_Show_String (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-0 (DataC-45Maybe-fromMaybe (lambda () "") arg-1))))))))) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) (CoreC-45Directory-mbPathToNS arg-0 arg-1 arg-2)))))
(define CoreC-45Directory-ctxtPathToNS (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--wdir (let ((e-4 (vector-ref e-5 4))) (let ((e-43 (vector-ref e-4 0))) (let ((e-53 (vector-ref e-43 0))) e-53))))) (let ((u--sdir (let ((e-4 (vector-ref e-5 4))) (let ((e-43 (vector-ref e-4 0))) (let ((e-52 (vector-ref e-43 1))) e-52))))) (CoreC-45Directory-corePathToNS u--wdir u--sdir arg-1))))) eff-0) ext-0)))))))
(define ParserC-45Unlit-styleBird (vector '() (cons ">" (cons "<" '())) (cons ".lidr" '())))
(define ParserC-45Unlit-styleCMark (vector (cons (cons "```idris" "```") (cons (cons "~~~idris" "~~~") (cons (cons "<!-- idris" "-->") '()))) '() (cons ".md" (cons ".markdown" '()))))
(define ParserC-45Unlit-styleOrg (vector (cons (cons "#+BEGIN_SRC idris" "#+END_SRC") (cons (cons "#+begin_src idris" "#+end_src") (cons (cons "#+BEGIN_COMMENT idris" "#+END_COMMENT") (cons (cons "#+begin_comment idris" "#+end_comment") '())))) (cons "#+IDRIS:" '()) (cons ".org" '())))
(define ParserC-45Unlit-styleTeX (vector (cons (cons "\\begin{code}" "\\end{code}") (cons (cons "\\begin{hidden}" "\\end{hidden}") '())) '() (cons ".tex" (cons ".ltx" '()))))
(define ParserC-45Unlit-n--4635-6158-u--hasSuffix (lambda (arg-0 arg-1) (DataC-45String-isSuffixOf arg-1 arg-0)))
(define ParserC-45Unlit-n--4635-6159-u--isStyle (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (ParserC-45Unlit-n--4635-6158-u--hasSuffix arg-0 eta-0)) (let ((e-2 (vector-ref arg-1 2))) e-2)))) (cond ((equal? sc0 1) (box arg-1)) (else '())))))
(define ParserC-45Unlit-isLitFile (lambda (arg-0) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-n--4635-6159-u--isStyle arg-0 ParserC-45Unlit-styleBird) (lambda () (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-n--4635-6159-u--isStyle arg-0 ParserC-45Unlit-styleOrg) (lambda () (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-n--4635-6159-u--isStyle arg-0 ParserC-45Unlit-styleCMark) (lambda () (ParserC-45Unlit-n--4635-6159-u--isStyle arg-0 ParserC-45Unlit-styleTeX)))))))))
(define IdrisC-45REPLC-45Opts-n--10638-6344-u--litStyle (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (unbox arg-3))) (ParserC-45Unlit-isLitFile e-2)))))
(define IdrisC-45REPLC-45Opts-defaultOpts (lambda (arg-0 arg-1 arg-2) (vector 0 1 0 arg-0 (IdrisC-45REPLC-45Opts-n--10638-6344-u--litStyle arg-2 arg-1 arg-0 arg-0) "" "vim" '() arg-1 "" '() '() '() arg-2 '() 1 1)))
(define IdrisC-45REPLC-45Common-doPrint (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 2) 1) ((equal? arg-1 1) 1) (else 1))) ((equal? arg-0 1) (cond ((equal? arg-1 2) 1) ((equal? arg-1 1) 1) (else 0))) (else (cond ((equal? arg-1 2) 1) ((equal? arg-1 1) 0) (else 0))))))
(define IdrisC-45REPLC-45Common-case--printWithStatus-5668 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((1) (let ((e-0 (vector-ref arg-6 1))) (let ((sc1 (IdrisC-45REPLC-45Common-doPrint arg-1 e-0))) (cond ((equal? sc1 1) (let ((act-1 ((arg-3 arg-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append e-5 "\xa;") eta-0))) (vector 1 act-2))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) (else (vector 1 (vector 0 )))))))
(define IdrisC-45REPLC-45Common-printWithStatus (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45REPLC-45Common-case--printWithStatus-5668 arg-4 arg-3 arg-2 arg-1 e-5 (let ((e-8 (vector-ref e-5 8))) e-8)))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold (PreludeC-45Types-u--pure_Applicative_List (vector 3 0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color (lambda (arg-0) (PreludeC-45Types-u--pure_Applicative_List (vector 1 arg-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-italic (PreludeC-45Types-u--pure_Applicative_List (vector 3 3)))
(define IdrisC-45Pretty-syntaxAnn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 10)) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 12)) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 9)) ((3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 10)) ((4) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-italic) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 15)) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 13)))))
(define IdrisC-45Pretty-colorAnn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 3) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold)) ((1) (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 9) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold)) ((2) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold) ((3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 12)) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 5)) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-color 2)) ((6) (let ((e-0 (vector-ref arg-0 1))) (IdrisC-45Pretty-syntaxAnn e-0))) (else '()))))
(define IdrisC-45REPLC-45Opts-getColor (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-15 (vector-ref e-5 15))) e-15)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define IdrisC-45REPLC-45Opts-getConsoleWidth (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-14 (vector-ref e-5 14))) e-14)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define LibrariesC-45UtilsC-45Term-getTermCols (lambda (ext-0) (LibrariesC-45UtilsC-45Term-prim__getTermCols ext-0)))
(define IdrisC-45PrettyC-45Render-getPageWidth (lambda (arg-0 ext-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getConsoleWidth arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 (let ((act-2 (LibrariesC-45UtilsC-45Term-getTermCols clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) '()) (else (cons e-6 1.0)))))))) eff-0) clam-0))))) (let ((e-2 (unbox e-5))) (cond ((equal? e-2 0) (vector 1 '()))(else (vector 1 (cons (blodwen-toSignedInt e-2 63) 1.0))))))))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (vector 1 e-2 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 (e-3))))))) ((2) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (vector 2 e-5 e-6 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 (e-7)))))))) ((3) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (vector 3 e-9 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 e-10))))) ((4) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (vector 4 (arg-2 e-12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 e-13))))) (else (let ((e-15 (vector-ref arg-3 1))) (vector 5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 e-15)))))))
(define ControlC-45MonadC-45ST-newSTRef (lambda (arg-2 ext-0) (let ((act-1 ((DataC-45IORef-newIORef csegen-82 arg-2) ext-0))) act-1)))
(define ControlC-45MonadC-45ST-runST (lambda (arg-1) (let ((eff-0 (arg-1 'erased))) (PrimIO-unsafePerformIO eff-0))))
(define ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (arg-3 arg-4 ext-0) (let ((act-1 (arg-3 ext-0))) ((let ((eff-0 (arg-4 act-1))) eff-0) ext-0))))
(define ControlC-45MonadC-45ST-u--map_Functor_C-40STC-32C-36sC-41 (lambda (arg-3 arg-4 ext-0) (PreludeC-45IO-u--map_Functor_IO arg-3 arg-4 ext-0)))
(define LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Blink_String (lambda (arg-0) (cond ((equal? arg-0 0) "5") ((equal? arg-0 1) "6") (else "25"))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Color_String (lambda (arg-0) (cond ((equal? arg-0 0) "0") ((equal? arg-0 1) "1") ((equal? arg-0 2) "2") ((equal? arg-0 3) "3") ((equal? arg-0 4) "4") ((equal? arg-0 5) "5") ((equal? arg-0 6) "6") ((equal? arg-0 7) "7") ((equal? arg-0 8) "8") ((equal? arg-0 9) "9") ((equal? arg-0 10) "10") ((equal? arg-0 11) "11") ((equal? arg-0 12) "12") ((equal? arg-0 13) "13") ((equal? arg-0 14) "14") (else "15"))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Style_String (lambda (arg-0) (cond ((equal? arg-0 0) "1") ((equal? arg-0 1) "2") ((equal? arg-0 2) "22") ((equal? arg-0 3) "3") ((equal? arg-0 4) "4") ((equal? arg-0 5) "21") ((equal? arg-0 6) "24") ((equal? arg-0 7) "9") (else "29"))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-n--3452-2723-u--toCode (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) "0") ((1) (let ((e-0 (vector-ref arg-1 1))) (string-append "38;5;" (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Color_String e-0)))) ((2) (let ((e-1 (vector-ref arg-1 1))) (string-append "48;5;" (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Color_String e-1)))) ((3) (let ((e-2 (vector-ref arg-1 1))) (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Style_String e-2))) (else (let ((e-3 (vector-ref arg-1 1))) (LibrariesC-45ControlC-45ANSIC-45SGR-u--cast_Cast_Blink_String e-3))))))
(define LibrariesC-45ControlC-45ANSIC-45SGR-escapeSGR (lambda (arg-0) (string-append "\x1b;[" (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse ";" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45ControlC-45ANSIC-45SGR-n--3452-2723-u--toCode arg-0 eta-0)) arg-0))) "m"))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5082-u--peek (lambda (arg-0 arg-2 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (unbox arg-2)) (lambda (_-0) (lambda (clam-0) (if (null? _-0) '() (let ((e-1 (car _-0))) (box e-1))))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5083-u--pop (lambda (arg-0 arg-2 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (unbox arg-2)) (lambda (_-0) (lambda (clam-0) (if (null? _-0) '() (let ((e-1 (car _-0))) (let ((e-2 (cdr _-0))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (set-box! arg-2 e-2)) (lambda (_-10649) (lambda (eta-0) (box e-1))) clam-0)))))) ext-0)))
(define ControlC-45MonadC-45ST-modifySTRef (lambda (arg-2 arg-3 ext-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (unbox arg-2)) (lambda (u--val) (lambda (eta-0) (set-box! arg-2 (arg-3 u--val)))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5084-u--push (lambda (arg-0 arg-2 arg-3 ext-0) (ControlC-45MonadC-45ST-modifySTRef arg-2 (lambda (arg-1) (cons arg-3 arg-1)) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5085-u--writeOutput (lambda (arg-0 arg-2 arg-3 ext-0) (ControlC-45MonadC-45ST-modifySTRef arg-2 (lambda (arg-1) (string-append arg-1 arg-3)) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go (lambda (arg-0 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5085-u--writeOutput arg-0 arg-3 (DataC-45String-singleton e-2) eta-0)) (lambda (_-10649) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go arg-0 arg-2 arg-3 (e-3) eta-0))) ext-0)))) ((2) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5085-u--writeOutput arg-0 arg-3 e-6 eta-0)) (lambda (_-10649) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go arg-0 arg-2 arg-3 (e-7) eta-0))) ext-0)))) ((3) (let ((e-9 (vector-ref arg-4 1))) (let ((e-10 (vector-ref arg-4 2))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5085-u--writeOutput arg-0 arg-3 (string-append (DataC-45String-singleton (integer->char 10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-9)) eta-0)) (lambda (_-10649) (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go arg-0 arg-2 arg-3 e-10 eta-0))) ext-0)))) ((4) (let ((e-12 (vector-ref arg-4 1))) (let ((e-13 (vector-ref arg-4 2))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5082-u--peek arg-0 arg-2 eta-0)) (lambda (_-0) (if (null? _-0) (lambda (eta-0) (set-box! arg-2 '())) (let ((e-1 (unbox _-0))) (let ((u--newStyle (PreludeC-45TypesC-45List-tailRecAppend e-12 e-1))) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5084-u--push arg-0 arg-2 u--newStyle eta-1)) (lambda (_-10649) (lambda (eta-1) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5085-u--writeOutput arg-0 arg-3 (LibrariesC-45ControlC-45ANSIC-45SGR-escapeSGR u--newStyle) eta-2)) (lambda (_-10650) (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go arg-0 arg-2 arg-3 e-13 eta-2))) eta-1))) eta-0)))))) ext-0)))) (else (let ((e-15 (vector-ref arg-4 1))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5083-u--pop arg-0 arg-2 eta-0)) (lambda (u--_) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5082-u--peek arg-0 arg-2 eta-1)) (lambda (_-0) (lambda (clam-1) (if (null? _-0) (set-box! arg-2 '()) (let ((e-1 (unbox _-0))) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5085-u--writeOutput arg-0 arg-3 (LibrariesC-45ControlC-45ANSIC-45SGR-escapeSGR (cons (vector 0 ) e-1)) eta-1)) (lambda (_-10649) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go arg-0 arg-2 arg-3 e-15 eta-1))) clam-1))))) eta-0))) ext-0))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-renderString (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () "<internal pretty printing error>") (ControlC-45MonadC-45ST-runST (lambda (s-5437) (lambda (eta-0) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-1) (ControlC-45MonadC-45ST-newSTRef (cons '() '()) eta-1)) (lambda (u--styleStackRef) (lambda (eta-1) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-2) (ControlC-45MonadC-45ST-newSTRef "" eta-2)) (lambda (u--outputRef) (lambda (eta-2) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-n--4460-5081-u--go arg-0 u--styleStackRef u--outputRef arg-0 eta-3)) (lambda (_-10649) (lambda (eta-3) (ControlC-45MonadC-45ST-u--C-62C-62C-61_Monad_C-40STC-32C-36sC-41 (lambda (eta-4) (unbox u--styleStackRef)) (lambda (lcase-0) (lambda (clam-0) (if (null? lcase-0) '() (let ((e-3 (cdr lcase-0))) (if (null? e-3) (ControlC-45MonadC-45ST-u--map_Functor_C-40STC-32C-36sC-41 (lambda (eta-4) (box eta-4)) (lambda (eta-4) (unbox u--outputRef)) clam-0) '()))))) eta-3))) eta-2))) eta-1))) eta-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS (lambda (arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 1 e-2 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS (e-3))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (vector 2 e-5 e-6 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS (e-7)))))))) ((3) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (vector 3 e-9 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS e-10))))) ((4) (let ((e-13 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS e-13))) (else (let ((e-15 (vector-ref arg-2 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS e-15))))))
(define IdrisC-45PrettyC-45Render-render (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getColor arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45PrettyC-45Render-getPageWidth arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--layout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty e-6 arg-3))) (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-renderString (cond ((equal? e-5 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotateS arg-2 u--layout)) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS u--layout))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Pretty-render (lambda (arg-0 ext-1 ext-0) (IdrisC-45PrettyC-45Render-render arg-0 (lambda (eta-0) (IdrisC-45Pretty-colorAnn eta-0)) ext-1 ext-0)))
(define IdrisC-45REPLC-45Common-printError (lambda (arg-0 arg-1 ext-0) (IdrisC-45REPLC-45Common-printWithStatus arg-0 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Pretty-render arg-0 eta-0 eta-1))) arg-1 1 ext-0)))
(define IdrisC-45REPL-displayErrors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((12) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (IdrisC-45REPLC-45Common-printError arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "File error in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (SystemC-45FileC-45Error-u--show_Show_FileError e-1)))) ext-0))))(else (vector 1 (vector 0 ))))))
(define CoreC-45Options-availableCGs (lambda (arg-0) (PreludeC-45TypesC-45List-tailRecAppend (cons (cons "chez" (vector 0 )) (cons (cons "chez-sep" (vector 1 )) (cons (cons "racket" (vector 2 )) (cons (cons "node" (vector 4 )) (cons (cons "javascript" (vector 5 )) (cons (cons "refc" (vector 6 )) (cons (cons "gambit" (vector 3 )) (cons (cons "vmcode-interp" (vector 7 )) '())))))))) (let ((e-8 (vector-ref arg-0 8))) e-8))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\"))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\=))
(define CoreC-45Context-getPPrint (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 1))) e-42)))))) eff-0) ext-0)))))))
(define IdrisC-45Pretty-meta (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) ext-0)))
(define PreludeC-45Interfaces-mapHom (lambda (arg-3 arg-4 ext-0) (let ((e-1 (vector-ref arg-3 0))) (((((((e-1 'erased) 'erased) 'erased) 'erased) arg-4) arg-4) ext-0))))
(define IdrisC-45REPLC-45Opts-getCurrentElabSource (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-9 (vector-ref e-5 9))) e-9)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define DataC-45List-snoc (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons arg-2 '()))))
(define IdrisC-45Error-n--12991-6869-u--pad (lambda (arg-0 arg-1 arg-2 arg-3) (string-append (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-2 (PreludeC-45TypesC-45String-length arg-3))) #\0) arg-3)))
(define IdrisC-45Error-n--12991-6867-u--addLineNumbers (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (Builtin-snd (PreludeC-45Types-u--foldl_Foldable_List (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (+ e-2 1) (DataC-45List-snoc e-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Error-n--12991-6869-u--pad arg-0 arg-1 arg-2 (PreludeC-45Show-u--show_Show_Nat (+ e-2 1)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe))) clam-0))))))) (cons arg-3 '()) arg-4))))
(define DataC-45List-take (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons e-2 (DataC-45List-take e-0 e-3))))))))))
(define IdrisC-45Error-n--12991-6868-u--extractRange (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (DataC-45List-take (+ (PreludeC-45Types-prim__integerToNat (- arg-3 arg-2)) 1) (DataC-45List-drop arg-2 arg-4))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc-7060 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((u--nsize (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat (+ e-2 1))))) (let ((u--head (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3005 arg-0)))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-3006 (lambda (eta-1) (IdrisC-45REPLC-45Opts-getCurrentElabSource arg-1 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (or (and (= arg-5 e-2) 1) 0))) (cond ((equal? sc2 1) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt (+ (+ u--nsize arg-6) 4) 63)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- e-3 arg-6)) #\^)))))) (let ((u--firstr (PreludeC-45Types-prim__integerToNat (- e-2 4)))) (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons u--head '())) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Error-n--12991-6867-u--addLineNumbers arg-0 arg-1 u--nsize u--firstr (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--12991-6868-u--extractRange arg-0 arg-1 u--firstr e-2 e-5))) (cons u--emph '())))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))) (else (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons u--head (IdrisC-45Error-n--12991-6867-u--addLineNumbers arg-0 arg-1 u--nsize arg-5 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--12991-6868-u--extractRange arg-0 arg-1 arg-5 (PreludeC-45Types-u--min_Ord_Nat e-2 (+ arg-5 5)) e-5)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))))) eff-0) eta-0))))))))))))
(define IdrisC-45Error-case--ploc-6988 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (let ((e-1 (unbox arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) csegen-1333 e-9))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc-7060 arg-0 arg-1 e-5 e-9 e-10 e-2 e-3 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-7 (car arg-9215))) (let ((e-4 (cdr arg-9215))) (cons (arg-9201 e-7) (arg-9208 e-4))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-7 (car arg-9236))) (let ((e-4 (cdr arg-9236))) (cons (arg-9229 e-7) e-4)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-7 (car arg-9250))) (let ((e-4 (cdr arg-9250))) (cons e-7 (arg-9243 e-4)))))))))) csegen-1333 e-10)))))))))))))
(define IdrisC-45Error-ploc (lambda (arg-0 arg-1) (IdrisC-45Error-case--ploc-6988 arg-1 arg-0 (CoreC-45FC-isNonEmptyFC arg-1))))
(define LibrariesC-45DataC-45ListC-45Extra-elemAt (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? arg-2 0) (box e-2))(else (let ((e-4 (- arg-2 1))) (LibrariesC-45DataC-45ListC-45Extra-elemAt e-3 e-4)))))))))
(define IdrisC-45Pretty-error (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) ext-0)))
(define IdrisC-45Pretty-fileCtxt (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) ext-0)))
(define IdrisC-45Error-n--13443-7296-u--pad (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (string-append (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-3 (PreludeC-45TypesC-45String-length arg-4))) #\0) arg-4)))
(define IdrisC-45Error-n--13443-7294-u--addLineNumbers (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (Builtin-snd (PreludeC-45Types-u--foldl_Foldable_List (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (+ e-2 1) (DataC-45List-snoc e-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Error-n--13443-7296-u--pad arg-0 arg-1 arg-2 arg-3 (PreludeC-45Show-u--show_Show_Nat (+ e-2 1)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe))) clam-0))))))) (cons arg-4 '()) arg-5))))
(define IdrisC-45Error-n--13443-7295-u--extractRange (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (DataC-45List-take (+ (PreludeC-45Types-prim__integerToNat (- arg-4 arg-3)) 1) (DataC-45List-drop arg-3 arg-5))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-7860 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (cond ((equal? e-2 1) (if (null? e-3) (lambda (clam-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (cond ((equal? e-10 1) (cond ((equal? e-11 1) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (lambda () csegen-753) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt arg-14 63)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (- arg-15 arg-9)) 63))) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-12 arg-15)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 (+ arg-13 1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc '()))))))))))) ((equal? e-11 0) (let ((u--line1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (lambda () csegen-753) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt arg-14 63)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^))))))) (let ((u--line2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (lambda () csegen-753) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-16))))) (let ((u--emph2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt arg-15 63)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-12 arg-15)) #\^))))))) (let ((u--numbered (let ((sc5 (or (and (= (PreludeC-45Types-prim__integerToNat (- arg-16 arg-10)) 1) 1) 0))) (cond ((equal? sc5 1) '()) (else (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (+ arg-13 1) (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 (+ arg-13 1) arg-10 arg-20)))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 (+ arg-13 1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line1 (cons u--emph1 '()))))) '())))) (PreludeC-45TypesC-45List-tailRecAppend u--numbered (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 (+ arg-16 1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line2 (cons u--emph2 '()))))) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc '())))))))))))))(else (lambda (clam-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))) ((equal? e-10 0) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (lambda () csegen-753) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt arg-14 63)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 (+ arg-13 1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) '())))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (+ arg-13 1) (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 (+ arg-13 1) (PreludeC-45Types-u--max_Ord_Nat arg-10 arg-11) arg-20))) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc '())))))))))(else (lambda (clam-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))))))) ((equal? e-2 0) (if (null? e-3) (lambda (clam-5) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))) (let ((e-14 (car e-3))) (let ((e-15 (cdr e-3))) (cond ((equal? e-14 1) (cond ((equal? e-15 1) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (lambda () csegen-753) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt arg-14 63)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-9 arg-14)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (cons arg-19 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 (+ arg-13 1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) '())))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (+ arg-13 1) (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 (+ arg-13 1) (PreludeC-45Types-u--max_Ord_Nat arg-10 arg-11) arg-20))) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc '()))))))))) ((equal? e-15 0) (let ((u--top (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 (+ arg-13 1) (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 (+ arg-13 1) arg-10 arg-20))))) (let ((u--line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (lambda () csegen-753) (LibrariesC-45DataC-45ListC-45Extra-elemAt arg-20 arg-13))))) (let ((u--emph (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt arg-15 63)) (IdrisC-45Pretty-error (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-12 arg-15)) #\^))))))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-tailRecAppend (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (cons arg-19 '()))) (PreludeC-45TypesC-45List-tailRecAppend u--top (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-fileCtxt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 (+ arg-16 1)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons u--line (cons u--emph '()))))) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc '())))))))))))(else (lambda (clam-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))))(else (lambda (clam-4) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))))))(else (lambda (clam-6) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc (cons arg-18 (IdrisC-45Error-n--13443-7294-u--addLineNumbers arg-0 arg-1 arg-2 arg-17 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-753 (IdrisC-45Error-n--13443-7295-u--extractRange arg-0 arg-1 arg-2 arg-13 arg-11 arg-20)))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)))))))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-7634 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((sc1 (PreludeC-45Types-u--C-62_Ord_Nat e-2 (+ arg-13 5)))) (cond ((equal? sc1 1) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 (vector 0 arg-3 arg-4 arg-5)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 (vector 0 arg-6 arg-7 arg-8)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (else (let ((u--nsize (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat (+ e-2 1))))) (let ((u--head (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3005 (vector 0 arg-3 arg-4 arg-8))))) (let ((u--firstRow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (blodwen-toSignedInt (+ u--nsize 2) 63)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-pipe)))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-3006 (lambda (eta-1) (IdrisC-45REPLC-45Opts-getCurrentElabSource arg-2 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-7860 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-14 arg-13 e-2 e-3 arg-9 arg-10 arg-11 arg-12 u--nsize u--head u--firstRow e-5 (cons (or (and (= arg-9 arg-13) 1) 0) (cons (or (and (= arg-12 e-2) 1) 0) (or (and (= arg-9 arg-12) 1) 0)))))) eff-0) eta-0))))))))))))))))
(define IdrisC-45Error-ploc2 (lambda (arg-0 arg-1 arg-2) (let ((sc0 (CoreC-45FC-isNonEmptyFC arg-1))) (if (null? sc0) (IdrisC-45Error-ploc arg-0 arg-2) (let ((e-1 (unbox sc0))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (CoreC-45FC-isNonEmptyFC arg-2))) (if (null? sc3) (IdrisC-45Error-ploc arg-0 arg-1) (let ((e-2 (unbox sc3))) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-12 (car e-7))) (let ((e-11 (cdr e-7))) (let ((sc6 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-4 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-4) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-4 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-4) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-4 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-4 (arg-9243 e-3)))))))))) csegen-1333 e-9))) (let ((e-4 (car sc6))) (let ((e-3 (cdr sc6))) (let ((sc7 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-14 (car arg-9215))) (let ((e-13 (cdr arg-9215))) (cons (arg-9201 e-14) (arg-9208 e-13))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-14 (car arg-9236))) (let ((e-13 (cdr arg-9236))) (cons (arg-9229 e-14) e-13)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-14 (car arg-9250))) (let ((e-13 (cdr arg-9250))) (cons e-14 (arg-9243 e-13)))))))))) csegen-1333 e-12))) (let ((e-14 (car sc7))) (let ((e-13 (cdr sc7))) (let ((sc8 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-16 (car arg-9215))) (let ((e-15 (cdr arg-9215))) (cons (arg-9201 e-16) (arg-9208 e-15))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-16 (car arg-9236))) (let ((e-15 (cdr arg-9236))) (cons (arg-9229 e-16) e-15)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-16 (car arg-9250))) (let ((e-15 (cdr arg-9250))) (cons e-16 (arg-9243 e-15)))))))))) csegen-1333 e-10))) (let ((e-16 (car sc8))) (let ((e-15 (cdr sc8))) (IdrisC-45Error-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32ploc2-7634 arg-2 arg-1 arg-0 e-5 e-9 e-10 e-8 e-12 e-11 e-4 e-3 e-13 e-14 e-16 e-15 (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-18 (car arg-9215))) (let ((e-17 (cdr arg-9215))) (cons (arg-9201 e-18) (arg-9208 e-17))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-18 (car arg-9236))) (let ((e-17 (cdr arg-9236))) (cons (arg-9229 e-18) e-17)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-18 (car arg-9250))) (let ((e-17 (cdr arg-9250))) (cons e-18 (arg-9243 e-17)))))))))) csegen-1333 e-11)))))))))))))))))))))))))))
(define CoreC-45Context-prettyName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((5) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (clam-0) (if (null? e-0) (vector 1 (CoreC-45Name-u--show_Show_Name arg-1)) (let ((e-10 (car e-0))) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 (vector 8 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-prettyName arg-0 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-prettyName arg-0 e-1) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append e-6 (string-append "," e-7)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))) ((6) (let ((e-2 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (string-append "case block in " e-2))))) ((7) (let ((e-4 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (string-append "with block in " e-4))))) ((0) (let ((e-7 (vector-ref arg-1 2))) (CoreC-45Context-prettyName arg-0 e-7)))(else (lambda (eta-0) (vector 1 (CoreC-45Name-u--show_Show_Name arg-1)))))))
(define CoreC-45NormaliseC-45Eval-nfOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (CoreC-45NormaliseC-45Eval-eval arg-3 arg-2 arg-0 arg-1 '() arg-4 '() arg-5 '())))
(define CoreC-45Value-withHoles (vector 1 1 0 0 0 '() '() 1))
(define CoreC-45Normalise-normaliseHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 CoreC-45Value-withHoles arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Binder-binderLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-6 (vector-ref arg-1 1))) e-6)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-21 (vector-ref arg-1 1))) e-21)) (else (let ((e-26 (vector-ref arg-1 1))) e-26)))))
(define CoreC-45Env-getBinderLoc (lambda (arg-2 arg-3 arg-5) (let ((e-2 (cdr arg-2))) (cond ((equal? arg-3 0) (let ((e-7 (car arg-5))) (CoreC-45TTC-45Binder-binderLoc e-7)))(else (let ((e-3 (- arg-3 1))) (let ((e-13 (cdr arg-5))) (CoreC-45Env-getBinderLoc e-2 e-3 e-13))))))))
(define IdrisC-45Error-pShowMN (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (let ((sc1 (CoreC-45Name-dropAllNS (CoreC-45TTC-45Var-nameAt arg-1 e-4)))) (case (vector-ref sc1 0) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "implicitly bound at") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3005 (CoreC-45Env-getBinderLoc arg-1 e-4 arg-3))))))(else arg-4)))))(else arg-4))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy (lambda (arg-3 arg-4 arg-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate arg-4 (let ((e-2 (car arg-3))) (e-2 arg-5)))))
(define IdrisC-45Resugar-startPrec 0)
(define IdrisC-45SyntaxC-45Traversals-n--8605-8310-u--goMPTerm (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) ext-0)))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8306-u--go3TupledPTerms (lambda (arg-1 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (cons (cons e-6 (cons e-10 e-5)) eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-11) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8306-u--go3TupledPTerms arg-1 e-3) clam-0)))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8334-u--goPiInfo (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 3 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-1) ext-0)))(else (vector 1 arg-2)))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8307-u--go4TupledPTerms (lambda (arg-1 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-4 (vector-ref eta-2 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (u--d) (lambda (u--ts) (cons (cons e-6 (cons e-10 (cons e-5 u--d))) u--ts)))))))) (lambda (eta-2) (IdrisC-45SyntaxC-45Traversals-n--8605-8334-u--goPiInfo arg-1 e-14 eta-2)) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-15) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8307-u--go4TupledPTerms arg-1 e-3) clam-0)))))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8308-u--goImplicits (lambda (arg-1 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (lambda (clam-0) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (cons (cons e-6 (cons e-10 (cons e-14 e-5))) eta-2))))))) (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1299 (lambda (eta-3) (IdrisC-45SyntaxC-45Traversals-n--8605-8334-u--goPiInfo arg-1 e-18 eta-3)) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-19) eta-1)) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8308-u--goImplicits arg-1 e-3) clam-0)))))))))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8309-u--goMPDecls (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-2 eta-0)) ext-0)))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8329-u--goPTypeDecl (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-5) ext-0))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8330-u--goPTypeDecls (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8329-u--goPTypeDecl arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8330-u--goPTypeDecls arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8313-u--goPDataDecl (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-6 (vector-ref eta-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 0 e-1 e-2 e-6 eta-3 eta-4)))))))) (lambda (eta-2) (IdrisC-45SyntaxC-45Traversals-n--8605-8310-u--goMPTerm arg-1 e-3 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-4)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8330-u--goPTypeDecls arg-1 e-5 eta-0)) ext-0))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-7 e-8 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-9) ext-0))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8318-u--goPField (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((e-6 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-7 (vector-ref eta-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector e-1 e-2 e-3 e-7 eta-3 eta-4)))))))) (lambda (eta-2) (IdrisC-45SyntaxC-45Traversals-n--8605-8334-u--goPiInfo arg-1 e-4 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-5)) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-6) ext-0)))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8321-u--goPFields (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8318-u--goPField arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8321-u--goPFields arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8328-u--goPTerms (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8328-u--goPTerms arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8322-u--goPFnOpt (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 arg-2)) ((1) (let ((e-3 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8328-u--goPTerms arg-1 e-3 eta-0)) ext-0))) (else (let ((e-5 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector 2 e-6)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8328-u--goPTerms arg-1 e-5 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8323-u--goPFnOpts (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8322-u--goPFnOpt arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8323-u--goPFnOpts arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8332-u--goPairedPTerms (lambda (arg-1 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (cons (cons e-6 e-5) eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-7) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8332-u--goPairedPTerms arg-1 e-3) clam-0)))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8314-u--goPDecl (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-6 (vector-ref eta-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 0 e-1 e-2 e-3 e-6 eta-2))))))) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8323-u--goPFnOpts arg-1 e-4 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8329-u--goPTypeDecl arg-1 e-5 eta-0)) clam-0))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-7 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-8 eta-0)) clam-0)))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (let ((e-14 (vector-ref arg-2 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-10 e-11 e-12 e-13 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8313-u--goPDataDecl arg-1 e-14 eta-0)) clam-0))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-16 e-5 eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8307-u--go4TupledPTerms arg-1 e-17) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-18 eta-0)) clam-0))))) ((4) (let ((e-20 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 4 e-20 e-5 eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8332-u--goPairedPTerms arg-1 e-21) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-22 eta-0)) clam-0))))) ((5) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (let ((e-27 (vector-ref arg-2 4))) (let ((e-28 (vector-ref arg-2 5))) (let ((e-29 (vector-ref arg-2 6))) (let ((e-30 (vector-ref arg-2 7))) (let ((e-31 (vector-ref arg-2 8))) (let ((e-32 (vector-ref arg-2 9))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (CoreC-45Core-C-60C-42C-62 (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-6) (case (vector-ref eta-6 0) ((0) (let ((e-2 (vector-ref eta-6 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-6 1))) (vector 1 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (vector 5 e-24 e-25 e-5 eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8332-u--goPairedPTerms arg-1 e-26) eta-5)) (lambda (eta-5) (vector 1 e-27)) eta-4)) (lambda (eta-4) (vector 1 e-28)) eta-3)) (IdrisC-45SyntaxC-45Traversals-n--8605-8306-u--go3TupledPTerms arg-1 e-29) eta-2)) (lambda (eta-2) (vector 1 e-30)) eta-1)) (lambda (eta-1) (vector 1 e-31)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-32 eta-0)) clam-0))))))))))) ((6) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (let ((e-38 (vector-ref arg-2 5))) (let ((e-39 (vector-ref arg-2 6))) (let ((e-40 (vector-ref arg-2 7))) (let ((e-41 (vector-ref arg-2 8))) (let ((e-42 (vector-ref arg-2 9))) (let ((e-43 (vector-ref arg-2 10))) (let ((e-44 (vector-ref arg-2 11))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (CoreC-45Core-C-60C-42C-62 (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-6) (case (vector-ref eta-6 0) ((0) (let ((e-2 (vector-ref eta-6 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-6 1))) (vector 1 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (vector 6 e-34 e-35 e-36 e-37 e-5 eta-7 eta-8 eta-9 eta-10 eta-11 eta-12)))))))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8308-u--goImplicits arg-1 e-38) eta-5)) (IdrisC-45SyntaxC-45Traversals-n--8605-8332-u--goPairedPTerms arg-1 e-39) eta-4)) (lambda (eta-4) (vector 1 e-40)) eta-3)) (lambda (eta-3) (IdrisC-45SyntaxC-45Traversals-n--8605-8328-u--goPTerms arg-1 e-41 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-42)) eta-1)) (lambda (eta-1) (vector 1 e-43)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8309-u--goMPDecls arg-1 e-44 eta-0)) clam-0))))))))))))) ((7) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((e-50 (vector-ref arg-2 5))) (case (vector-ref e-50 0) ((0) (let ((e-84 (vector-ref e-50 1))) (let ((e-85 (vector-ref e-50 2))) (let ((e-86 (vector-ref e-50 3))) (let ((e-87 (vector-ref e-50 4))) (let ((e-88 (vector-ref e-50 5))) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 0 e-84 e-5 eta-4 eta-5 eta-6))))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8307-u--go4TupledPTerms arg-1 e-85) eta-2)) (lambda (eta-2) (vector 1 e-86)) eta-1)) (lambda (eta-1) (vector 1 e-87)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8321-u--goPFields arg-1 e-88 eta-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-46 e-47 e-48 e-49 e-5))))) eff-0) clam-0))))))))))) (else (let ((e-90 (vector-ref e-50 1))) (let ((e-91 (vector-ref e-50 2))) (let ((act-1 ((IdrisC-45SyntaxC-45Traversals-n--8605-8307-u--go4TupledPTerms arg-1 e-91) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-46 e-47 e-48 e-49 (vector 1 e-90 e-5)))))) eff-0) clam-0))))))))))))))) ((8) (let ((e-52 (vector-ref arg-2 1))) (let ((e-53 (vector-ref arg-2 2))) (let ((e-54 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 8 e-52 e-53 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-54 eta-0)) clam-0))))) ((9) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-56 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-57 eta-0)) clam-0)))) ((10) (vector 1 arg-2)) ((11) (let ((e-65 (vector-ref arg-2 1))) (let ((e-66 (vector-ref arg-2 2))) (let ((e-67 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 11 e-65 e-66 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-67 eta-0)) clam-0))))) ((12) (let ((e-69 (vector-ref arg-2 1))) (let ((e-70 (vector-ref arg-2 2))) (let ((e-71 (vector-ref arg-2 3))) (let ((e-72 (vector-ref arg-2 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 12 e-69 e-70 e-5 eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-71) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-72) clam-0)))))) ((13) (let ((e-74 (vector-ref arg-2 1))) (let ((e-75 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 13 e-74 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-75) clam-0)))) ((14) (vector 1 arg-2)) (else (vector 1 arg-2))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (IdrisC-45SyntaxC-45Traversals-n--8605-8314-u--goPDecl arg-1 e-2) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8331-u--goPWithProblem (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector e-1 e-5 eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) eta-0)) (lambda (eta-0) (vector 1 e-3)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8311-u--goPClause (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-5 (vector-ref eta-2 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 0 e-1 e-5 eta-3 eta-4)))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-3) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-4 eta-0)) ext-0)))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 1 e-6 e-5 eta-4 eta-5 eta-6))))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-7) eta-2)) (CoreC-45Core-traverseList1 (lambda (eta-2) (lambda (eta-3) (IdrisC-45SyntaxC-45Traversals-n--8605-8331-u--goPWithProblem arg-1 eta-2 eta-3))) e-8) eta-1)) (lambda (eta-1) (vector 1 e-9)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-10 eta-0)) ext-0))))))) (else (let ((e-12 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-12 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-13) ext-0)))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8311-u--goPClause arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8316-u--goPDo (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) ext-0)))) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-0 1))) (vector 1 (vector 1 e-4 e-5 e-6 e-8)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-7) ext-0)))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 2 e-9 e-5 eta-3 eta-4)))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-10) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-11) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-12 eta-0)) ext-0)))))) ((3) (let ((e-14 (vector-ref arg-2 1))) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (let ((e-18 (vector-ref arg-2 5))) (let ((e-19 (vector-ref arg-2 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-14 e-15 e-16 e-17 e-5 eta-2))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-18) eta-0)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-19) ext-0)))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (let ((e-24 (vector-ref arg-2 4))) (let ((e-25 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (vector 4 e-21 e-5 eta-4 eta-5 eta-6))))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-22) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-23) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-24) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-25 eta-0)) ext-0))))))) ((5) (let ((e-27 (vector-ref arg-2 1))) (let ((e-28 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-27 e-5)))))) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-28 eta-0)) ext-0)))) (else (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-30 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-31) ext-0)))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8317-u--goPDos (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8316-u--goPDo arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8317-u--goPDos arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8319-u--goPFieldUpdate (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) ext-0)))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector 1 e-4 e-6)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-5) ext-0)))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8320-u--goPFieldUpdates (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8319-u--goPFieldUpdate arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8320-u--goPFieldUpdates arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8324-u--goPStr (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-1 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-2) ext-0))))(else (vector 1 arg-2)))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8326-u--goPStrings (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8324-u--goPStr arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8326-u--goPStrings arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8325-u--goPStringLines (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8326-u--goPStrings arg-1 e-2 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8325-u--goPStringLines arg-1 e-3 eta-0)) ext-0))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8333-u--goPairedSnocPTerms (lambda (arg-1 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-988 (IdrisC-45SyntaxC-45Traversals-n--8605-8333-u--goPairedSnocPTerms arg-1 e-2) eta-0)) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (cons e-6 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-7) eta-0)) clam-0)))))))))
(define IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (arg-1 arg-2)) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref eta-4 1))) (vector 1 (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (vector 1 e-4 e-5 e-10 eta-5 eta-6 eta-7))))))))) (lambda (eta-4) (IdrisC-45SyntaxC-45Traversals-n--8605-8334-u--goPiInfo arg-1 e-6 eta-4)) eta-3)) (lambda (eta-3) (vector 1 e-7)) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-8) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-10))) eff-0) eta-0))))))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((e-15 (vector-ref arg-2 5))) (let ((e-16 (vector-ref arg-2 6))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-4 1))) (vector 1 (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (vector 2 e-11 e-12 e-5 eta-5 eta-6 eta-7))))))))) (lambda (eta-4) (IdrisC-45SyntaxC-45Traversals-n--8605-8334-u--goPiInfo arg-1 e-13 eta-4)) eta-3)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-14) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-15) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))))) ((3) (let ((e-18 (vector-ref arg-2 1))) (let ((e-19 (vector-ref arg-2 2))) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (let ((e-23 (vector-ref arg-2 6))) (let ((e-24 (vector-ref arg-2 7))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-5) (case (vector-ref eta-5 0) ((0) (let ((e-2 (vector-ref eta-5 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-5 1))) (vector 1 (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (vector 3 e-18 e-19 e-5 eta-6 eta-7 eta-8 eta-9)))))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-20) eta-4)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-21) eta-3)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-22) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-23) eta-1)) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-24 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))))))) ((4) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 4 e-26 e-5 eta-4 eta-5)))))))) (lambda (eta-3) (IdrisC-45SyntaxC-45Traversals-n--8605-8323-u--goPFnOpts arg-1 e-27 eta-3)) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-28) eta-1)) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8312-u--goPClauses arg-1 e-29 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((5) (let ((e-31 (vector-ref arg-2 1))) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 5 e-31 e-5 eta-3))))))) (lambda (eta-2) (IdrisC-45SyntaxC-45Traversals-n--8605-8315-u--goPDecls arg-1 e-32 eta-2)) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-33) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((6) (let ((e-35 (vector-ref arg-2 1))) (let ((e-36 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 6 e-35 e-5)))))) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8320-u--goPFieldUpdates arg-1 e-36 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((7) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 7 e-38 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-39) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-40) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((8) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 8 e-42 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-43) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-44) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 10 e-46 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-47) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-48) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((9) (let ((e-50 (vector-ref arg-2 1))) (let ((e-51 (vector-ref arg-2 2))) (let ((e-52 (vector-ref arg-2 3))) (let ((e-53 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 9 e-50 e-5 eta-4 eta-5)))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-51) eta-2)) (lambda (eta-2) (vector 1 e-52)) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-53) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((11) (let ((e-55 (vector-ref arg-2 1))) (let ((e-56 (vector-ref arg-2 2))) (let ((e-57 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 11 e-55 e-56 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-57) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((12) (let ((e-59 (vector-ref arg-2 1))) (let ((e-60 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 12 e-59 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((13) (let ((e-62 (vector-ref arg-2 1))) (let ((e-63 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 13 e-62 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-63) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((14) (arg-1 arg-2)) ((15) (arg-1 arg-2)) ((16) (let ((e-71 (vector-ref arg-2 1))) (let ((e-72 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 16 e-71 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-72) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((17) (arg-1 arg-2)) ((18) (let ((e-77 (vector-ref arg-2 1))) (let ((e-78 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 18 e-77 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8314-u--goPDecl arg-1 eta-1)) e-78 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((19) (let ((e-80 (vector-ref arg-2 1))) (let ((e-81 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 19 e-80 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-81) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((20) (let ((e-83 (vector-ref arg-2 1))) (let ((e-84 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 20 e-83 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-84) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((21) (arg-1 arg-2)) ((22) (arg-1 arg-2)) ((23) (let ((e-92 (vector-ref arg-2 1))) (let ((e-93 (vector-ref arg-2 2))) (let ((e-94 (vector-ref arg-2 3))) (let ((e-95 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 23 e-92 e-93 e-94 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-95) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((24) (let ((e-97 (vector-ref arg-2 1))) (let ((e-98 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 24 e-97 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-98) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((25) (arg-1 arg-2)) ((26) (arg-1 arg-2)) ((27) (let ((e-104 (vector-ref arg-2 1))) (let ((e-105 (vector-ref arg-2 2))) (let ((e-106 (vector-ref arg-2 3))) (let ((e-107 (vector-ref arg-2 4))) (let ((e-108 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 27 e-104 e-105 e-106 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-107) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-108) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))))) ((28) (let ((e-110 (vector-ref arg-2 1))) (let ((e-111 (vector-ref arg-2 2))) (let ((e-112 (vector-ref arg-2 3))) (let ((e-113 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 28 e-110 e-111 e-112 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-113) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((29) (let ((e-115 (vector-ref arg-2 1))) (let ((e-116 (vector-ref arg-2 2))) (let ((e-117 (vector-ref arg-2 3))) (let ((e-118 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 29 e-115 e-116 e-117 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-118) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((30) (let ((e-120 (vector-ref arg-2 1))) (let ((e-121 (vector-ref arg-2 2))) (let ((e-122 (vector-ref arg-2 3))) (let ((e-123 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 30 e-120 e-121 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-122) eta-1)) (lambda (eta-1) (vector 1 e-123)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((31) (let ((e-125 (vector-ref arg-2 1))) (let ((e-126 (vector-ref arg-2 2))) (let ((e-127 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 31 e-125 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-126) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-127) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((32) (let ((e-129 (vector-ref arg-2 1))) (let ((e-130 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 32 e-129 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-130) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((33) (let ((e-132 (vector-ref arg-2 1))) (let ((e-133 (vector-ref arg-2 2))) (let ((e-134 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 33 e-132 e-133 e-5)))))) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8326-u--goPStrings arg-1 e-134 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((34) (let ((e-136 (vector-ref arg-2 1))) (let ((e-137 (vector-ref arg-2 2))) (let ((e-138 (vector-ref arg-2 3))) (let ((e-139 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 34 e-136 e-137 e-138 e-5)))))) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8325-u--goPStringLines arg-1 e-139 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((35) (let ((e-141 (vector-ref arg-2 1))) (let ((e-142 (vector-ref arg-2 2))) (let ((e-143 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 35 e-141 e-142 e-5)))))) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8317-u--goPDos arg-1 e-143 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((36) (let ((e-145 (vector-ref arg-2 1))) (let ((e-146 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 36 e-145 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-146) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))) ((37) (let ((e-148 (vector-ref arg-2 1))) (let ((e-149 (vector-ref arg-2 2))) (let ((e-150 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 37 e-148 e-149 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-150) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((38) (let ((e-152 (vector-ref arg-2 1))) (let ((e-153 (vector-ref arg-2 2))) (let ((e-154 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 38 e-152 e-153 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8332-u--goPairedPTerms arg-1 e-154) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((39) (let ((e-156 (vector-ref arg-2 1))) (let ((e-157 (vector-ref arg-2 2))) (let ((e-158 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 39 e-156 e-157 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8333-u--goPairedSnocPTerms arg-1 e-158) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((40) (let ((e-160 (vector-ref arg-2 1))) (let ((e-161 (vector-ref arg-2 2))) (let ((e-162 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 40 e-160 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-161) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-162) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((41) (let ((e-164 (vector-ref arg-2 1))) (let ((e-165 (vector-ref arg-2 2))) (let ((e-166 (vector-ref arg-2 3))) (let ((e-167 (vector-ref arg-2 4))) (let ((e-168 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 41 e-164 e-165 e-5 eta-4 eta-5)))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-166) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-167) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-168) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))))) ((42) (arg-1 arg-2)) ((43) (let ((e-172 (vector-ref arg-2 1))) (let ((e-173 (vector-ref arg-2 2))) (let ((e-174 (vector-ref arg-2 3))) (let ((e-175 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 43 e-172 e-5 eta-4 eta-5)))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-173) eta-2)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-174) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-175) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((44) (let ((e-177 (vector-ref arg-2 1))) (let ((e-178 (vector-ref arg-2 2))) (let ((e-179 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 44 e-177 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-178) eta-1)) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8317-u--goPDos arg-1 e-179 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((45) (let ((e-181 (vector-ref arg-2 1))) (let ((e-182 (vector-ref arg-2 2))) (let ((e-183 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 45 e-181 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-182) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-183) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((46) (let ((e-185 (vector-ref arg-2 1))) (let ((e-186 (vector-ref arg-2 2))) (let ((e-187 (vector-ref arg-2 3))) (let ((e-188 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-3 1))) (vector 1 (lambda (eta-4) (lambda (eta-5) (vector 46 e-185 e-5 eta-4 eta-5)))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-186) eta-2)) (lambda (eta-2) (IdrisC-45SyntaxC-45Traversals-n--8605-8310-u--goMPTerm arg-1 e-187 eta-2)) eta-1)) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-188) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0))))))))))) ((47) (let ((e-190 (vector-ref arg-2 1))) (let ((e-191 (vector-ref arg-2 2))) (let ((e-192 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 47 e-190 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-191) eta-1)) (lambda (eta-1) (IdrisC-45SyntaxC-45Traversals-n--8605-8310-u--goMPTerm arg-1 e-192 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((50) (let ((e-194 (vector-ref arg-2 1))) (let ((e-195 (vector-ref arg-2 2))) (let ((e-196 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 50 e-194 e-195 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-196) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((48) (let ((e-198 (vector-ref arg-2 1))) (let ((e-199 (vector-ref arg-2 2))) (let ((e-200 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 48 e-198 e-5 eta-3))))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-199) eta-1)) (lambda (eta-1) (vector 1 e-200)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))) ((49) (let ((e-202 (vector-ref arg-2 1))) (let ((e-203 (vector-ref arg-2 2))) (arg-1 (vector 49 e-202 e-203))))) (else (let ((e-205 (vector-ref arg-2 1))) (let ((e-206 (vector-ref arg-2 2))) (let ((e-207 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 51 e-205 e-206 e-5)))))) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 e-207) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (arg-1 e-5))) eff-0) eta-0)))))))))))))
(define IdrisC-45SyntaxC-45Traversals-mapPTermM (lambda (arg-1 ext-0) (IdrisC-45SyntaxC-45Traversals-n--8605-8327-u--goPTerm arg-1 ext-0)))
(define CoreC-45Name-with--mkUserName-9219 (lambda (arg-0 arg-1) (if (null? arg-1) (vector 0 arg-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (cond ((equal? e-0 #\.) (vector 1 e-1))(else (vector 0 arg-0))))))))
(define CoreC-45Name-mkUserName (lambda (arg-0) (cond ((equal? arg-0 "_") (vector 2 ))(else (CoreC-45Name-with--mkUserName-9219 arg-0 (DataC-45String-strM arg-0))))))
(define IdrisC-45Resugar-n--15578-17921-u--cleanName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-0 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 e-0)))) ((2) (let ((e-2 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 1 (CoreC-45Name-mkUserName e-2)))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 1 (CoreC-45Name-mkUserName e-4)))))) ((0) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 0 e-6 e-5)))))) (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 e-7) eta-0))))) ((5) (let ((e-9 (vector-ref arg-2 2))) (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 e-9))) ((1) (let ((e-10 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 1 e-10)))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 1 (CoreC-45Name-mkUserName e-5))))))) (CoreC-45Context-prettyName arg-1 arg-2) eta-0))))))
(define IdrisC-45Resugar-n--15578-17919-u--cleanBinderName (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((2) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (lambda (clam-0) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (cond ((equal? e-2 "__con") (vector 1 '()))(else (PreludeC-45IO-u--map_Functor_IO csegen-1275 (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 arg-3) clam-0)))))(else (PreludeC-45IO-u--map_Functor_IO csegen-1275 (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 arg-3) clam-0))))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 arg-3) eta-0)))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 arg-3) eta-0))))))
(define IdrisC-45Resugar-n--15578-17920-u--cleanKindedName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (vector-ref arg-2 0))) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector e-0 e-1 e-5)))))) (IdrisC-45Resugar-n--15578-17921-u--cleanName arg-0 arg-1 e-2) ext-0))))))
(define IdrisC-45Resugar-n--15578-17922-u--cleanNode (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (lambda (eta-0) (IdrisC-45Resugar-n--15578-17920-u--cleanKindedName arg-0 arg-1 e-2 eta-0)) clam-0)))) ((27) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref eta-0 1))) (vector 1 (vector 27 e-4 e-5 e-9 e-7 e-8)))))) (lambda (eta-0) (IdrisC-45Resugar-n--15578-17920-u--cleanKindedName arg-0 arg-1 e-6 eta-0)) clam-0))))))) ((28) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 28 e-10 e-11 e-5 e-13)))))) (lambda (eta-0) (IdrisC-45Resugar-n--15578-17920-u--cleanKindedName arg-0 arg-1 e-12 eta-0)) clam-0)))))) ((29) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((e-18 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 29 e-15 e-16 e-5 e-18)))))) (lambda (eta-0) (IdrisC-45Resugar-n--15578-17920-u--cleanKindedName arg-0 arg-1 e-17 eta-0)) clam-0)))))) ((30) (let ((e-20 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 3))) (let ((e-23 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 30 e-20 e-21 e-22 e-5)))))) (lambda (eta-0) (IdrisC-45Resugar-n--15578-17920-u--cleanKindedName arg-0 arg-1 e-23 eta-0)) clam-0)))))) ((1) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (let ((e-29 (vector-ref arg-2 5))) (let ((e-30 (vector-ref arg-2 6))) (if (null? e-28) (vector 1 arg-2) (let ((e-32 (unbox e-28))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 1 e-25 e-26 e-27 e-5 e-29 e-30)))))) (IdrisC-45Resugar-n--15578-17919-u--cleanBinderName arg-0 arg-1 e-27 e-32) clam-0))))))))))(else (vector 1 arg-2))))))
(define IdrisC-45Resugar-cleanPTerm (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (let ((e-1 (vector-ref e-5 1))) e-1))) (cond ((equal? sc1 1) (lambda (eta-0) (vector 1 arg-1))) (else (IdrisC-45SyntaxC-45Traversals-mapPTermM (lambda (eta-0) (IdrisC-45Resugar-n--15578-17922-u--cleanNode arg-1 arg-0 eta-0)) arg-1)))))) eff-0) ext-0)))))))
(define IdrisC-45Resugar-appPrec 999)
(define IdrisC-45Resugar-argPrec 1000)
(define IdrisC-45Resugar-n--11002-13777-u--needed (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((32) 0) ((0) 0) ((40) 0) ((41) 0) ((42) 0) ((44) 0) ((38) 0) ((39) 0) ((46) 0) ((47) 0) ((15) 0) ((37) 0) ((36) 0)(else 1))))
(define IdrisC-45Resugar-addBracket (lambda (arg-1 arg-2) (let ((sc0 (IdrisC-45Resugar-n--11002-13777-u--needed arg-2 arg-1 arg-2))) (cond ((equal? sc0 1) (vector 32 arg-1 arg-2)) (else arg-2)))))
(define IdrisC-45Syntax-u--C-47C-61_Eq_Fixity (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45Syntax-u--C-61C-61_Eq_Fixity arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45Syntax-infixes (lambda (ext-0) (LibrariesC-45DataC-45ANameMap-fromList (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (cons (let ((e-0 (vector-ref e-3 0))) e-0) (cons (let ((e-5 (vector-ref e-3 2))) e-5) (let ((e-4 (vector-ref e-3 3))) e-4))))))) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (IdrisC-45Syntax-u--C-47C-61_Eq_Fixity (let ((sc0 (Builtin-snd eta-0))) (let ((e-2 (vector-ref sc0 2))) e-2)) 3)) (LibrariesC-45DataC-45ANameMap-toList (let ((e-0 (vector-ref ext-0 0))) e-0)))))))
(define LibrariesC-45DataC-45ANameMap-lookupExact (lambda (arg-1 arg-2) (LibrariesC-45DataC-45NameMap-lookup arg-1 (let ((e-1 (car arg-2))) e-1))))
(define CoreC-45NameC-45Namespace-isApproximationOf (lambda (arg-0 arg-1) (DataC-45List-isPrefixOf csegen-22 arg-0 arg-1)))
(define CoreC-45Name-matches (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (CoreC-45NameC-45Namespace-isApproximationOf e-0 e-2)))(else 1))))(else 1))))
(define LibrariesC-45DataC-45ANameMap-case--lookupName-12619 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (let ((sc1 (LibrariesC-45DataC-45ANameMap-lookupExact arg-2 arg-1))) (if (null? sc1) '() (let ((e-2 (unbox sc1))) (cons (cons arg-2 e-2) '())))) (let ((e-2 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 (let ((e-3 (cdr arg-1))) e-3)))) (if (null? sc1) '() (let ((e-3 (unbox sc1))) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CoreC-45Name-matches arg-2 (Builtin-fst eta-0))) e-3))))))))
(define LibrariesC-45DataC-45ANameMap-lookupName (lambda (arg-1 arg-2) (LibrariesC-45DataC-45ANameMap-case--lookupName-12619 arg-2 arg-1 (CoreC-45Name-userNameRoot arg-1))))
(define IdrisC-45Resugar-unbracketApp (lambda (arg-1) (case (vector-ref arg-1 0) ((32) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((7) e-2)(else arg-1))))(else arg-1))))
(define IdrisC-45Resugar-mkOp (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (lambda (clam-0) (case (vector-ref e-2 0) ((7) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((0) (let ((e-12 (vector-ref e-6 1))) (let ((e-13 (vector-ref e-6 2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--raw (let ((e-4 (vector-ref e-13 2))) e-4))) (let ((u--rootName (vector 1 (vector 0 (CoreC-45Name-nameRoot u--raw))))) (let ((u--asOp (vector 27 e-1 e-12 e-13 (IdrisC-45Resugar-unbracketApp e-7) (IdrisC-45Resugar-unbracketApp e-3)))) (let ((u--tm (vector 7 e-1 (vector 7 e-5 (vector 0 e-12 e-13) e-7) e-3))) (lambda (clam-1) (let ((sc4 (PreludeC-45Types-u--null_Foldable_List (LibrariesC-45DataC-45ANameMap-lookupName u--rootName (IdrisC-45Syntax-infixes e-8))))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45Name-dropNS u--raw))) (case (vector-ref sc5 0) ((4) (let ((e-0 (vector-ref sc5 1))) (vector 1 (let ((sc6 (CoreC-45Name-isOpUserName (vector 0 e-0)))) (cond ((equal? sc6 1) u--asOp) (else u--tm))))))(else (vector 1 u--tm))))) (else (vector 1 u--asOp))))))))))) eff-0) clam-0))))))))(else (vector 1 arg-1))))))) ((0) (let ((e-9 (vector-ref e-2 1))) (let ((e-10 (vector-ref e-2 2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (let ((e-4 (vector-ref e-10 2))) e-4))) (let ((u--asOp (vector 30 e-1 e-9 (IdrisC-45Resugar-unbracketApp e-3) e-10))) (let ((u--tm (vector 7 e-1 (vector 0 e-9 e-10) e-3))) (lambda (clam-2) (let ((sc3 (PreludeC-45Types-u--null_Foldable_List (LibrariesC-45DataC-45ANameMap-lookupName (vector 1 (vector 0 (CoreC-45Name-nameRoot u--n))) (IdrisC-45Syntax-infixes e-5))))) (cond ((equal? sc3 1) (let ((sc4 (CoreC-45Name-dropNS u--n))) (case (vector-ref sc4 0) ((4) (let ((e-0 (vector-ref sc4 1))) (vector 1 (let ((sc5 (CoreC-45Name-isOpUserName (vector 0 e-0)))) (cond ((equal? sc5 1) u--asOp) (else u--tm))))))(else (vector 1 u--tm))))) (else (vector 1 u--asOp)))))))))) eff-0) clam-0))))))))(else (vector 1 arg-1))))))))(else (lambda (eta-0) (vector 1 arg-1))))))
(define IdrisC-45Syntax-showPTerm (lambda (arg-1 ext-0) (IdrisC-45Syntax-showPTermPrec arg-1 (vector 0 ) ext-0)))
(define IdrisC-45Syntax-showAlt (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (string-append " | " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-2) (string-append " => " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-3) ";"))))))) ((1) " | <<with alts not possible>>;") (else (let ((e-13 (vector-ref arg-2 2))) (string-append " | " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-13) " impossible;")))))))
(define IdrisC-45Syntax-showDo (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (IdrisC-45Syntax-showPTerm arg-1 e-2))) ((1) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (string-append (CoreC-45Name-u--show_Show_Name e-6) (string-append " <- " (IdrisC-45Syntax-showPTerm arg-1 e-7)))))) ((2) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (string-append (IdrisC-45Syntax-showPTerm arg-1 e-10) (string-append " <- " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-11) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (IdrisC-45Syntax-showAlt arg-1 eta-0)) e-12)))))))) ((3) (let ((e-16 (vector-ref arg-2 3))) (let ((e-19 (vector-ref arg-2 6))) (string-append "let " (string-append (CoreC-45Name-u--show_Show_Name e-16) (string-append " = " (IdrisC-45Syntax-showPTerm arg-1 e-19))))))) ((4) (let ((e-22 (vector-ref arg-2 2))) (let ((e-24 (vector-ref arg-2 4))) (let ((e-25 (vector-ref arg-2 5))) (string-append "let " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-22) (string-append " = " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-24) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (IdrisC-45Syntax-showAlt arg-1 eta-0)) e-25))))))))) ((5) "let { << definitions >>  }") (else (let ((e-31 (vector-ref arg-2 2))) (string-append "rewrite " (IdrisC-45Syntax-showPTerm arg-1 e-31)))))))
(define IdrisC-45Syntax-showOpPrec (lambda (arg-1 arg-2 arg-3) (let ((u--op (arg-1 arg-3))) (let ((sc0 (CoreC-45Name-isOpName u--op))) (cond ((equal? sc0 1) (CoreC-45Name-u--showPrec_Show_Name arg-2 u--op)) (else (string-append "`" (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 u--op) "`"))))))))
(define IdrisC-45Syntax-showPStr (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45Show-u--show_Show_String e-2))) (else (let ((e-5 (vector-ref arg-2 2))) (IdrisC-45Syntax-showPTerm arg-1 e-5))))))
(define IdrisC-45Syntax-showUpdate (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (string-append (CoreC-45NameC-45Namespace-showSep "." e-1) (string-append " = " (IdrisC-45Syntax-showPTerm arg-1 e-2)))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (string-append (CoreC-45NameC-45Namespace-showSep "." e-4) (string-append " $= " (IdrisC-45Syntax-showPTerm arg-1 e-5)))))))))
(define IdrisC-45Syntax-n--14203-6066-u--deGuard (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (case (vector-ref e-2 0) ((7) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((e-6 (vector-ref e-2 3))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((u--tm (vector 0 e-1 (vector 7 e-4 (vector 0 e-8 e-9) e-6)))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (arg-1 e-9)) (vector 1 (vector 0 "guard"))))) (cond ((equal? sc3 1) (vector 0 e-1 e-6)) (else u--tm)))))))(else arg-6))))))(else arg-6)))))(else arg-6))))
(define IdrisC-45Syntax-n--14203-6067-u--dePure (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((7) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((u--tm (vector 7 e-1 (vector 0 e-5 e-6) e-3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (arg-1 e-6)) (vector 1 (vector 0 "pure"))))) (cond ((equal? sc2 1) e-3) (else u--tm)))))))(else arg-6))))))(else arg-6))))
(define IdrisC-45Syntax-n--14203-5316-u--showCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (string-append (IdrisC-45Syntax-showPTerm arg-1 e-2) (string-append " => " (IdrisC-45Syntax-showPTerm arg-1 e-3)))))) ((1) " | <<with alts not possible>>") (else (let ((e-13 (vector-ref arg-7 2))) (string-append (IdrisC-45Syntax-showPTerm arg-1 e-13) " impossible"))))))
(define IdrisC-45Syntax-showPTermPrec (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (CoreC-45Name-u--showPrec_Show_Name arg-2 (arg-1 e-2)))) ((1) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (let ((e-8 (vector-ref arg-3 5))) (let ((e-9 (vector-ref arg-3 6))) (case (vector-ref e-6 0) ((1) (if (null? e-7) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append " -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9))) (let ((e-215 (unbox e-7))) (string-append "(" (string-append (Algebra-showCount e-5) (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-215) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append ") -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))) ((0) (if (null? e-7) (string-append "{" (string-append (Algebra-showCount e-5) (string-append "_ : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))) (let ((e-218 (unbox e-7))) (string-append "{" (string-append (Algebra-showCount e-5) (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-218) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))) ((2) (if (null? e-7) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append " => " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9))) (let ((e-221 (unbox e-7))) (string-append "{auto " (string-append (Algebra-showCount e-5) (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-221) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))) (else (let ((e-212 (vector-ref e-6 1))) (if (null? e-7) (string-append "{default " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-212) (string-append " " (string-append (Algebra-showCount e-5) (string-append "_ : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))) (let ((e-224 (unbox e-7))) (string-append "{default " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-212) (string-append " " (string-append (Algebra-showCount e-5) (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-224) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-8) (string-append "} -> " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-9)))))))))))))))))))) ((2) (let ((e-12 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-15 (vector-ref arg-3 5))) (let ((e-16 (vector-ref arg-3 6))) (case (vector-ref e-15 0) ((25) (string-append "\\" (string-append (Algebra-showCount e-12) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-14) (string-append " => " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-16))))))(else (string-append "\\" (string-append (Algebra-showCount e-12) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-14) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-15) (string-append " => " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-16)))))))))))))) ((3) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (let ((e-23 (vector-ref arg-3 6))) (let ((e-24 (vector-ref arg-3 7))) (case (vector-ref e-21 0) ((25) (string-append "let " (string-append (Algebra-showCount e-19) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-20) (string-append " = " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-22) (string-append " in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-23))))))))(else (string-append "let " (string-append (Algebra-showCount e-19) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-20) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-21) (string-append " = " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-22) (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (IdrisC-45Syntax-showAlt arg-1 eta-0)) e-24) (string-append " in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-23))))))))))))))))))) ((4) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (string-append "case " (string-append (IdrisC-45Syntax-showPTerm arg-1 e-28) (string-append " of { " (string-append (CoreC-45NameC-45Namespace-showSep " ; " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-n--14203-5316-u--showCase arg-1 arg-2 e-26 e-27 e-29 e-28 eta-0)) e-29)) " }"))))))))) ((5) (let ((e-33 (vector-ref arg-3 3))) (string-append "let { << definitions >>  } in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-33)))) ((6) (let ((e-36 (vector-ref arg-3 2))) (string-append "record { " (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showUpdate arg-1 eta-0)) e-36)) " }")))) ((7) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (let ((u--catchall (lambda () (string-append (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-39) (string-append " " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-40)))))) (case (vector-ref e-39 0) ((0) (let ((e-1 (vector-ref e-39 1))) (let ((e-2 (vector-ref e-39 2))) (let ((u--f (vector 0 e-1 e-2))) (let ((sc2 (DataC-45Maybe-isJust (CoreC-45Name-isRF (arg-1 e-2))))) (cond ((equal? sc2 1) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-40) (string-append " " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) u--f)))) (else (u--catchall))))))))(else (u--catchall))))))) ((8) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-43) (string-append " | " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-44)))))) ((10) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-47) (string-append " @{" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-48) "}")))))) ((11) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (cond ((equal? e-51 0) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (string-append "Inf " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-52))))(else (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (string-append "Lazy " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-52)))))))) ((12) (let ((e-55 (vector-ref arg-3 2))) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (string-append "Delay " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-55))))) ((13) (let ((e-58 (vector-ref arg-3 2))) (PreludeC-45Show-showParens (PreludeC-45Show-u--C-62C-61_Ord_Prec arg-2 (vector 6 )) (string-append "Force " (IdrisC-45Syntax-showPTermPrec arg-1 (vector 6 ) e-58))))) ((9) (let ((e-61 (vector-ref arg-3 2))) (let ((e-62 (vector-ref arg-3 3))) (let ((e-63 (vector-ref arg-3 4))) (case (vector-ref e-63 0) ((0) (let ((e-231 (vector-ref e-63 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-62 (arg-1 e-231)))) (cond ((equal? sc2 1) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-61) (string-append " {" (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-62) "}")))) (else (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-61) (string-append " {" (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-62) (string-append " = " (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 (arg-1 e-231)) "}"))))))))))(else (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-61) (string-append " {" (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-62) (string-append " = " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-63) "}"))))))))))) ((14) "%search") ((16) (let ((e-69 (vector-ref arg-3 2))) (string-append "`(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-69) ")")))) ((17) (let ((e-72 (vector-ref arg-3 2))) (string-append "`{" (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-72) "}")))) ((18) "`[ <<declaration>> ]") ((19) (let ((e-78 (vector-ref arg-3 2))) (string-append "~(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-78) ")")))) ((20) (let ((e-81 (vector-ref arg-3 2))) (string-append "%runElab " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-81)))) ((15) (let ((e-84 (vector-ref arg-3 2))) (CoreC-45TTC-45Primitive-u--showPrec_Show_Constant arg-2 e-84))) ((21) (let ((e-88 (vector-ref arg-3 3))) (string-append "?" e-88))) ((22) "Type") ((23) (let ((e-94 (vector-ref arg-3 3))) (let ((e-95 (vector-ref arg-3 4))) (string-append (CoreC-45Name-u--showPrec_Show_Name arg-2 e-94) (string-append "@" (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-95)))))) ((24) (let ((e-98 (vector-ref arg-3 2))) (string-append "." (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-98)))) ((25) "_") ((26) "?") ((27) (let ((e-106 (vector-ref arg-3 3))) (let ((e-107 (vector-ref arg-3 4))) (let ((e-108 (vector-ref arg-3 5))) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-107) (string-append " " (string-append (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-106) (string-append " " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-108))))))))) ((28) (let ((e-112 (vector-ref arg-3 3))) (let ((e-113 (vector-ref arg-3 4))) (string-append (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-112) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-113))))) ((29) (let ((e-117 (vector-ref arg-3 3))) (let ((e-118 (vector-ref arg-3 4))) (string-append "(" (string-append (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-117) (string-append " " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-118) ")"))))))) ((30) (let ((e-122 (vector-ref arg-3 3))) (let ((e-123 (vector-ref arg-3 4))) (string-append "(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-122) (string-append " " (string-append (IdrisC-45Syntax-showOpPrec arg-1 arg-2 e-123) ")"))))))) ((31) (let ((e-126 (vector-ref arg-3 2))) (let ((e-127 (vector-ref arg-3 3))) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-126) (string-append " = " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-127)))))) ((32) (let ((e-130 (vector-ref arg-3 2))) (string-append "(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-130) ")")))) ((33) (let ((e-134 (vector-ref arg-3 3))) (LibrariesC-45DataC-45StringC-45Extra-join " ++ " csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showPStr arg-1 eta-0)) e-134)))) ((34) (let ((e-139 (vector-ref arg-3 4))) (string-append "multiline (" (string-append (LibrariesC-45DataC-45StringC-45Extra-join " ++ " csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showPStr arg-1 eta-0)) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-139))) ")")))) ((35) (let ((e-143 (vector-ref arg-3 3))) (string-append "do " (CoreC-45NameC-45Namespace-showSep " ; " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showDo arg-1 eta-0)) e-143))))) ((36) (let ((e-146 (vector-ref arg-3 2))) (string-append "!" (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-146)))) ((37) (let ((e-149 (vector-ref arg-3 2))) (let ((e-150 (vector-ref arg-3 3))) (if (null? e-149) (string-append "[|" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-150) "|]")) (let ((e-234 (unbox e-149))) (string-append (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-234) (string-append ".[|" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-150) "|]")))))))) ((38) (let ((e-154 (vector-ref arg-3 3))) (string-append "[" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 (Builtin-snd eta-0))) e-154)) "]")))) ((39) (let ((e-158 (vector-ref arg-3 3))) (string-append "[<" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 (Builtin-snd eta-0))) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-158 '()))) "]")))) ((40) (let ((e-161 (vector-ref arg-3 2))) (let ((e-162 (vector-ref arg-3 3))) (string-append "(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-161) (string-append ", " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-162) ")"))))))) ((41) (let ((e-166 (vector-ref arg-3 3))) (let ((e-167 (vector-ref arg-3 4))) (let ((e-168 (vector-ref arg-3 5))) (case (vector-ref e-167 0) ((25) (string-append "(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-166) (string-append " ** " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-168) ")")))))(else (string-append "(" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-166) (string-append " : " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-167) (string-append " ** " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-168) ")")))))))))))) ((42) "()") ((43) (let ((e-173 (vector-ref arg-3 2))) (let ((e-174 (vector-ref arg-3 3))) (let ((e-175 (vector-ref arg-3 4))) (string-append "if " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-173) (string-append " then " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-174) (string-append " else " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-175)))))))))) ((44) (let ((e-177 (vector-ref arg-3 1))) (let ((e-178 (vector-ref arg-3 2))) (let ((e-179 (vector-ref arg-3 3))) (string-append "[" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 (IdrisC-45Syntax-n--14203-6067-u--dePure arg-1 e-177 e-179 e-178 arg-2 e-178)) (string-append " | " (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-showDo arg-1 (IdrisC-45Syntax-n--14203-6066-u--deGuard arg-1 e-177 e-179 e-178 arg-2 eta-0))) e-179)) "]")))))))) ((45) (let ((e-182 (vector-ref arg-3 2))) (let ((e-183 (vector-ref arg-3 3))) (string-append "rewrite " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-182) (string-append " in " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-183))))))) ((46) (let ((e-186 (vector-ref arg-3 2))) (let ((e-187 (vector-ref arg-3 3))) (let ((e-188 (vector-ref arg-3 4))) (if (null? e-187) (string-append "[" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-186) (string-append " .. " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-188) "]")))) (let ((e-239 (unbox e-187))) (string-append "[" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-186) (string-append ", " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-239) (string-append " .. " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-188) "]")))))))))))) ((47) (let ((e-191 (vector-ref arg-3 2))) (let ((e-192 (vector-ref arg-3 3))) (if (null? e-192) (string-append "[" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-191) " .. ]")) (let ((e-242 (unbox e-192))) (string-append "[" (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-191) (string-append ", " (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-242) " .. ]"))))))))) ((50) (let ((e-196 (vector-ref arg-3 3))) (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-196))) ((48) (let ((e-199 (vector-ref arg-3 2))) (let ((e-200 (vector-ref arg-3 3))) (string-append (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-199) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 csegen-266 e-200))))) ((49) (let ((e-203 (vector-ref arg-3 2))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 csegen-266 e-203))) (else (let ((e-206 (vector-ref arg-3 2))) (let ((e-207 (vector-ref arg-3 3))) (string-append "with " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-269 e-206) (string-append " " (IdrisC-45Syntax-showPTermPrec arg-1 arg-2 e-207))))))))))
(define IdrisC-45Syntax-u--showPrec_Show_IPTerm (lambda (ext-0 ext-1) (IdrisC-45Syntax-showPTermPrec csegen-259 ext-0 ext-1)))
(define IdrisC-45Syntax-u--show_Show_IPTerm (lambda (arg-0) (IdrisC-45Syntax-u--showPrec_Show_IPTerm (vector 0 ) arg-0)))
(define IdrisC-45Resugar-mkSectionL (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (case (vector-ref e-4 0) ((0) (let ((e-8 (vector-ref e-4 1))) (let ((e-9 (vector-ref e-4 2))) (case (vector-ref e-6 0) ((7) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (case (vector-ref e-12 0) ((7) (let ((e-15 (vector-ref e-12 1))) (let ((e-16 (vector-ref e-12 2))) (let ((e-17 (vector-ref e-12 3))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 1))) (let ((e-20 (vector-ref e-16 2))) (case (vector-ref e-17 0) ((0) (let ((e-22 (vector-ref e-17 1))) (let ((e-23 (vector-ref e-17 2))) (let ((e-24 (vector-ref e-23 0))) (let ((e-25 (vector-ref e-23 1))) (let ((e-26 (vector-ref e-23 2))) (lambda (clam-0) (if (null? e-24) (vector 1 arg-2) (let ((e-28 (unbox e-24))) (case (vector-ref e-28 0) ((0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "resugar.sectionL" 30 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "SectionL candidate: " (cons (IdrisC-45Syntax-u--show_Show_IPTerm arg-2) '())))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((u--tm (vector 2 e-1 e-2 e-3 (vector 0 e-8 e-9) e-5 (vector 7 e-11 (vector 7 e-15 (vector 0 e-19 e-20) (vector 0 e-22 (vector (box (vector 0 )) e-25 e-26))) e-13)))) (let ((sc9 (CoreC-45Name-u--C-61C-61_Eq_Name (let ((e-14 (vector-ref e-9 1))) e-14) e-25))) (cond ((equal? sc9 1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--n (let ((e-14 (vector-ref e-20 2))) e-14))) (let ((u--asOp (vector 29 e-1 e-19 e-20 (IdrisC-45Resugar-unbracketApp e-13)))) (lambda (clam-1) (let ((sc11 (PreludeC-45Types-u--null_Foldable_List (LibrariesC-45DataC-45ANameMap-lookupName (vector 1 (vector 0 (CoreC-45Name-nameRoot u--n))) (let ((e-0 (vector-ref e-10 0))) e-0))))) (cond ((equal? sc11 1) (let ((sc12 (CoreC-45Name-dropNS u--n))) (case (vector-ref sc12 0) ((4) (let ((e-0 (vector-ref sc12 1))) (vector 1 (let ((sc13 (CoreC-45Name-isOpUserName (vector 0 e-0)))) (cond ((equal? sc13 1) u--asOp) (else u--tm))))))(else (vector 1 u--tm))))) (else (vector 1 u--asOp))))))))) eff-0) clam-0))))))(else (vector 1 u--tm)))))))))(else (vector 1 arg-2))))))))))))(else (lambda (eta-0) (vector 1 arg-2)))))))(else (lambda (eta-0) (vector 1 arg-2))))))))(else (lambda (eta-0) (vector 1 arg-2))))))))(else (lambda (eta-0) (vector 1 arg-2)))))))(else (lambda (eta-0) (vector 1 arg-2)))))))))))(else (lambda (eta-0) (vector 1 arg-2))))))
(define IdrisC-45Resugar-bracket (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((IdrisC-45Resugar-mkOp arg-1 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-mkSectionL arg-0 arg-1 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45Types-u--C-62_Ord_Nat arg-2 arg-3))) (cond ((equal? sc2 1) (vector 1 (IdrisC-45Resugar-addBracket CoreC-45FC-emptyFC e-6))) (else (vector 1 e-6))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Resugar-showImplicits (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-0 (vector-ref e-5 0))) e-0))))) eff-0) ext-0)))))))
(define IdrisC-45Resugar-toPClause (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-5 e-6 '()))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((e-9 (vector-ref arg-2 5))) (let ((e-10 (vector-ref arg-2 6))) (let ((e-11 (vector-ref arg-2 7))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-2 eta-3))) e-11 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-5 e-12 (cons (vector e-7 e-13 e-9) '()) e-10 e-14))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-13 e-5))))) eff-0) ext-0)))))))))))
(define IdrisC-45Resugar-toPTypeDecl (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 "" e-5))))) eff-0) ext-0)))))))))))
(define IdrisC-45Resugar-toPData (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-1 (if (null? e-3) (vector 1 '()) (let ((e-6 (unbox e-3))) ((let ((eff-0 (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-6))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPTypeDecl arg-0 arg-1 eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-4 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-9) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-8 e-5))))) eff-0) ext-0))))))))))))
(define IdrisC-45Resugar-toPFnOpt (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((8) (let ((e-1 (vector-ref arg-2 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec eta-0)) e-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-5))))) eff-0) ext-0)))))))(else (vector 1 (vector 0 arg-2))))))
(define IdrisC-45Resugar-toPField (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec eta-1)) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector e-1 "" e-2 e-7 e-4 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define IdrisC-45Resugar-n--13138-17428-u--mapPiInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-8 1))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-7 arg-6 IdrisC-45Resugar-startPrec e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define IdrisC-45Resugar-toPRecord (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((e-6 (vector-ref arg-2 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-8 (car lamc-0))) (let ((e-7 (cdr lamc-0))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-11) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-13 (vector-ref act-1 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Resugar-n--13138-17428-u--mapPiInfo e-6 e-5 e-4 e-3 e-2 e-1 arg-1 arg-0 e-12 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-14 (vector-ref act-2 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-8 (cons e-10 (cons e-14 e-13))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPField arg-0 arg-1 eta-1 eta-2))) e-6 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-2 (cons e-7 (cons e-4 (cons (box (cons "" e-5)) e-8)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))
(define IdrisC-45Resugar-toPDecl (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPFnOpt arg-0 arg-1 eta-0 eta-1))) e-4 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Resugar-toPTypeDecl arg-0 arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (vector 0 e-1 e-2 e-3 e-6 e-7)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((act-1 (IdrisC-45Resugar-toPData arg-0 arg-1 e-10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (vector 2 e-7 "" e-8 e-9 e-5)))))) eff-0) ext-0)))))))))) ((2) (let ((e-12 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-0 eta-1))) e-14 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (vector 1 e-12 e-5)))))) eff-0) ext-0)))))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-0 eta-1))) e-18 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-2 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec eta-1)) e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-11) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-2 (cons e-6 (cons e-8 e-9))))))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))))) e-17 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (vector 3 e-16 e-6 (DataC-45List-catMaybes e-5))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((4) (let ((e-20 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 3))) (let ((e-23 (vector-ref arg-2 4))) (let ((e-24 (vector-ref arg-2 5))) (let ((act-1 (IdrisC-45Resugar-toPRecord arg-0 arg-1 e-24 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-1) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 (box (vector 7 e-20 "" e-22 e-23 (vector 0 e-2 e-6 e-10 e-14 e-15))))))))))))))) eff-0) ext-0)))))))))) ((5) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-0 eta-1))) e-28 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (vector 8 e-26 e-27 (DataC-45List-catMaybes e-5))))))) eff-0) ext-0))))))))) ((6) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-0 eta-1))) e-32 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (vector 11 e-30 e-31 (DataC-45List-catMaybes e-5))))))) eff-0) ext-0))))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-36) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-37) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (vector 12 e-34 (CoreC-45Name-u--show_Show_Name e-35) e-5 e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((8) (let ((e-39 (vector-ref arg-2 1))) (let ((e-40 (vector-ref arg-2 2))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-40) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (vector 13 e-39 e-5)))))) eff-0) ext-0)))))))) ((9) (vector 1 '())) ((10) (vector 1 '())) (else (let ((e-48 (vector-ref arg-2 1))) (let ((e-49 (vector-ref arg-2 2))) (let ((e-50 (vector-ref arg-2 3))) (vector 1 (box (vector 15 e-48 e-49 e-50))))))))))
(define IdrisC-45Resugar-toPFieldUpdate (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-5))))) eff-0) ext-0)))))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-4 e-6))))) eff-0) ext-0)))))))))))
(define CoreC-45NameC-45Namespace-dpairNS (CoreC-45NameC-45Namespace-mkNamespace "Builtin.DPair"))
(define IdrisC-45Resugar-extractDouble (lambda (arg-0) (case (vector-ref arg-0 0) ((7) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (case (vector-ref e-2 0) ((0) (let ((e-12 (vector-ref e-2 2))) (let ((e-14 (vector-ref e-12 1))) (case (vector-ref e-14 0) ((0) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((1) (let ((e-18 (vector-ref e-17 1))) (case (vector-ref e-18 0) ((0) (let ((e-19 (vector-ref e-18 1))) (cond ((equal? e-19 "fromDouble") (IdrisC-45Resugar-extractDouble e-3)) ((equal? e-19 "negate") (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (- eta-0)) (IdrisC-45Resugar-extractDouble e-3)))(else '()))))(else '()))))(else '()))))(else '())))))(else '()))))) ((15) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref e-6 0) ((12) (let ((e-20 (vector-ref e-6 1))) (box e-20)))(else '())))) ((32) (let ((e-9 (vector-ref arg-0 2))) (IdrisC-45Resugar-extractDouble e-9)))(else '()))))
(define IdrisC-45Resugar-extractInteger (lambda (arg-0) (case (vector-ref arg-0 0) ((7) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (case (vector-ref e-2 0) ((0) (let ((e-12 (vector-ref e-2 2))) (let ((e-14 (vector-ref e-12 1))) (case (vector-ref e-14 0) ((0) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((1) (let ((e-18 (vector-ref e-17 1))) (case (vector-ref e-18 0) ((0) (let ((e-19 (vector-ref e-18 1))) (cond ((equal? e-19 "fromInteger") (IdrisC-45Resugar-extractInteger e-3)) ((equal? e-19 "negate") (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (- 0 eta-0)) (IdrisC-45Resugar-extractInteger e-3)))(else '()))))(else '()))))(else '()))))(else '())))))(else '()))))) ((15) (let ((e-6 (vector-ref arg-0 2))) (case (vector-ref e-6 0) ((5) (let ((e-20 (vector-ref e-6 1))) (box e-20)))(else '())))) ((32) (let ((e-9 (vector-ref arg-0 2))) (IdrisC-45Resugar-extractInteger e-9)))(else '()))))
(define CoreC-45NameC-45Namespace-preludeNS (CoreC-45NameC-45Namespace-mkNamespace "Prelude"))
(define IdrisC-45Resugar-extractNat (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-14 (vector-ref e-2 1))) (case (vector-ref e-14 0) ((0) (let ((e-16 (vector-ref e-14 1))) (let ((e-17 (vector-ref e-14 2))) (case (vector-ref e-17 0) ((1) (let ((e-18 (vector-ref e-17 1))) (case (vector-ref e-18 0) ((0) (let ((e-19 (vector-ref e-18 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-19 "Z")) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-16 CoreC-45NameC-45Namespace-typesNS))) (cond ((equal? sc4 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-16 CoreC-45NameC-45Namespace-preludeNS))))) (lambda (_-10650) (box arg-0)))))))(else '()))))(else '())))))(else '()))))) ((7) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (case (vector-ref e-5 0) ((0) (let ((e-22 (vector-ref e-5 2))) (let ((e-24 (vector-ref e-22 1))) (case (vector-ref e-24 0) ((0) (let ((e-26 (vector-ref e-24 1))) (let ((e-27 (vector-ref e-24 2))) (case (vector-ref e-27 0) ((1) (let ((e-28 (vector-ref e-27 1))) (case (vector-ref e-28 0) ((0) (let ((e-29 (vector-ref e-28 1))) (cond ((equal? e-29 "S") (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-26 CoreC-45NameC-45Namespace-typesNS))) (cond ((equal? sc6 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-26 CoreC-45NameC-45Namespace-preludeNS))))) (lambda (_-10649) (IdrisC-45Resugar-extractNat (+ arg-0 1) e-6)))) ((equal? e-29 "fromInteger") (IdrisC-45Resugar-extractNat arg-0 e-6))(else '()))))(else '()))))(else '())))))(else '())))))(else '()))))) ((15) (let ((e-9 (vector-ref arg-1 2))) (case (vector-ref e-9 0) ((5) (let ((e-30 (vector-ref e-9 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-60C-61_Ord_Integer 0 e-30)) (lambda (_-10649) (box (+ arg-0 (PreludeC-45Types-prim__integerToNat e-30)))))))(else '())))) ((32) (let ((e-12 (vector-ref arg-1 2))) (IdrisC-45Resugar-extractNat arg-0 e-12)))(else '()))))
(define IdrisC-45Syntax-getPTermLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-4 (vector-ref arg-1 1))) e-4)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-18 (vector-ref arg-1 1))) e-18)) ((4) (let ((e-26 (vector-ref arg-1 1))) e-26)) ((5) (let ((e-31 (vector-ref arg-1 1))) e-31)) ((6) (let ((e-35 (vector-ref arg-1 1))) e-35)) ((7) (let ((e-38 (vector-ref arg-1 1))) e-38)) ((8) (let ((e-42 (vector-ref arg-1 1))) e-42)) ((10) (let ((e-46 (vector-ref arg-1 1))) e-46)) ((9) (let ((e-50 (vector-ref arg-1 1))) e-50)) ((11) (let ((e-55 (vector-ref arg-1 1))) e-55)) ((12) (let ((e-59 (vector-ref arg-1 1))) e-59)) ((13) (let ((e-62 (vector-ref arg-1 1))) e-62)) ((14) (let ((e-65 (vector-ref arg-1 1))) e-65)) ((15) (let ((e-68 (vector-ref arg-1 1))) e-68)) ((16) (let ((e-71 (vector-ref arg-1 1))) e-71)) ((17) (let ((e-74 (vector-ref arg-1 1))) e-74)) ((18) (let ((e-77 (vector-ref arg-1 1))) e-77)) ((19) (let ((e-80 (vector-ref arg-1 1))) e-80)) ((20) (let ((e-83 (vector-ref arg-1 1))) e-83)) ((21) (let ((e-86 (vector-ref arg-1 1))) e-86)) ((22) (let ((e-90 (vector-ref arg-1 1))) e-90)) ((23) (let ((e-92 (vector-ref arg-1 1))) e-92)) ((24) (let ((e-97 (vector-ref arg-1 1))) e-97)) ((25) (let ((e-100 (vector-ref arg-1 1))) e-100)) ((26) (let ((e-102 (vector-ref arg-1 1))) e-102)) ((27) (let ((e-104 (vector-ref arg-1 1))) e-104)) ((28) (let ((e-110 (vector-ref arg-1 1))) e-110)) ((29) (let ((e-115 (vector-ref arg-1 1))) e-115)) ((30) (let ((e-120 (vector-ref arg-1 1))) e-120)) ((31) (let ((e-125 (vector-ref arg-1 1))) e-125)) ((32) (let ((e-129 (vector-ref arg-1 1))) e-129)) ((33) (let ((e-132 (vector-ref arg-1 1))) e-132)) ((34) (let ((e-136 (vector-ref arg-1 1))) e-136)) ((35) (let ((e-141 (vector-ref arg-1 1))) e-141)) ((36) (let ((e-145 (vector-ref arg-1 1))) e-145)) ((37) (let ((e-148 (vector-ref arg-1 1))) e-148)) ((38) (let ((e-152 (vector-ref arg-1 1))) e-152)) ((39) (let ((e-156 (vector-ref arg-1 1))) e-156)) ((40) (let ((e-160 (vector-ref arg-1 1))) e-160)) ((41) (let ((e-164 (vector-ref arg-1 1))) e-164)) ((42) (let ((e-170 (vector-ref arg-1 1))) e-170)) ((43) (let ((e-172 (vector-ref arg-1 1))) e-172)) ((44) (let ((e-177 (vector-ref arg-1 1))) e-177)) ((45) (let ((e-181 (vector-ref arg-1 1))) e-181)) ((46) (let ((e-185 (vector-ref arg-1 1))) e-185)) ((47) (let ((e-190 (vector-ref arg-1 1))) e-190)) ((48) (let ((e-194 (vector-ref arg-1 1))) e-194)) ((49) (let ((e-198 (vector-ref arg-1 1))) e-198)) ((50) (let ((e-201 (vector-ref arg-1 1))) e-201)) (else (let ((e-205 (vector-ref arg-1 1))) e-205)))))
(define IdrisC-45Resugar-unbracket (lambda (arg-1) (case (vector-ref arg-1 0) ((32) (let ((e-2 (vector-ref arg-1 2))) e-2))(else arg-1))))
(define IdrisC-45Resugar-sugarAppM (lambda (arg-0) (case (vector-ref arg-0 0) ((7) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (case (vector-ref e-2 0) ((7) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((7) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((0) (let ((e-17 (vector-ref e-10 2))) (let ((e-19 (vector-ref e-17 1))) (case (vector-ref e-19 0) ((0) (let ((e-22 (vector-ref e-19 2))) (let ((sc5 (CoreC-45Name-nameRoot e-22))) (cond ((equal? sc5 "rangeFromThenTo") (box (vector 46 e-1 (IdrisC-45Resugar-unbracket e-11) (box (IdrisC-45Resugar-unbracket e-7)) (IdrisC-45Resugar-unbracket e-3))))(else '())))))(else (let ((sc4 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc4) (let ((sc5 (IdrisC-45Resugar-extractInteger arg-0))) (if (null? sc5) (let ((sc6 (IdrisC-45Resugar-extractDouble arg-0))) (if (null? sc6) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-13 (vector-ref e-4 1))) (case (vector-ref e-13 0) ((0) (let ((e-21 (vector-ref e-13 1))) (let ((e-15 (vector-ref e-13 2))) (let ((sc9 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-21))) (cond ((equal? sc9 1) (let ((sc10 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc10 "Unit") (box (vector 42 e-8))) ((equal? sc10 "MkUnit") (box (vector 42 e-8)))(else '())))) (else (let ((sc10 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc10 "Nil") (box (vector 38 e-8 e-8 '()))) ((equal? sc10 "Lin") (box (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-12 0) ((0) (let ((e-14 (vector-ref e-12 2))) (let ((e-22 (vector-ref e-14 1))) (case (vector-ref e-22 0) ((0) (let ((e-23 (vector-ref e-22 2))) (let ((sc10 (CoreC-45Name-nameRoot e-23))) (cond ((equal? sc10 "rangeFrom") (box (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc6))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 12 e-4)))))) (let ((e-4 (unbox sc5))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))) (let ((e-4 (unbox sc4))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))))))))(else (let ((sc3 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc3) (let ((sc4 (IdrisC-45Resugar-extractInteger arg-0))) (if (null? sc4) (let ((sc5 (IdrisC-45Resugar-extractDouble arg-0))) (if (null? sc5) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-13 (vector-ref e-4 1))) (case (vector-ref e-13 0) ((0) (let ((e-16 (vector-ref e-13 1))) (let ((e-15 (vector-ref e-13 2))) (let ((sc8 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-16))) (cond ((equal? sc8 1) (let ((sc9 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc9 "Unit") (box (vector 42 e-8))) ((equal? sc9 "MkUnit") (box (vector 42 e-8)))(else '())))) (else (let ((sc9 (CoreC-45Name-nameRoot e-15))) (cond ((equal? sc9 "Nil") (box (vector 38 e-8 e-8 '()))) ((equal? sc9 "Lin") (box (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-12 0) ((0) (let ((e-14 (vector-ref e-12 2))) (let ((e-16 (vector-ref e-14 1))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 2))) (let ((sc9 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc9 "rangeFrom") (box (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc5))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 12 e-4)))))) (let ((e-4 (unbox sc4))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))) (let ((e-4 (unbox sc3))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4))))))))))) ((0) (let ((e-13 (vector-ref e-6 1))) (let ((e-14 (vector-ref e-6 2))) (let ((e-24 (vector-ref e-14 1))) (case (vector-ref e-24 0) ((0) (let ((e-26 (vector-ref e-24 1))) (let ((e-27 (vector-ref e-24 2))) (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-26))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45Name-nameRoot e-27))) (cond ((equal? sc5 "Pair") (box (vector 40 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "MkPair") (box (vector 40 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "Equal") (box (vector 31 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "===") (box (vector 31 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc5 "~=~") (box (vector 31 e-1 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-3))))(else '())))) (else (let ((sc5 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-dpairNS e-26))) (cond ((equal? sc5 1) (let ((sc6 (CoreC-45Name-nameRoot e-27))) (cond ((equal? sc6 "DPair") (let ((sc7 (IdrisC-45Resugar-unbracket e-3))) (case (vector-ref sc7 0) ((2) (let ((e-4 (vector-ref sc7 4))) (let ((e-8 (vector-ref sc7 6))) (box (vector 41 e-1 e-13 e-4 (IdrisC-45Resugar-unbracket e-7) (IdrisC-45Resugar-unbracket e-8))))))(else '())))) ((equal? sc6 "MkDPair") (box (vector 41 e-1 e-13 (IdrisC-45Resugar-unbracket e-7) (vector 25 e-13) (IdrisC-45Resugar-unbracket e-3))))(else '())))) (else (let ((sc6 (CoreC-45Name-nameRoot e-27))) (cond ((equal? sc6 "::") (let ((sc7 (IdrisC-45Resugar-sugarApp (IdrisC-45Resugar-unbracket e-3)))) (case (vector-ref sc7 0) ((38) (let ((e-9 (vector-ref sc7 1))) (let ((e-8 (vector-ref sc7 2))) (let ((e-4 (vector-ref sc7 3))) (box (vector 38 e-9 e-8 (cons (cons e-13 (IdrisC-45Resugar-unbracketApp e-7)) e-4)))))))(else '())))) ((equal? sc6 ":<") (let ((sc7 (IdrisC-45Resugar-sugarApp (IdrisC-45Resugar-unbracket e-7)))) (case (vector-ref sc7 0) ((39) (let ((e-9 (vector-ref sc7 1))) (let ((e-8 (vector-ref sc7 2))) (let ((e-4 (vector-ref sc7 3))) (box (vector 39 e-9 e-8 (cons e-4 (cons e-13 (IdrisC-45Resugar-unbracketApp e-3)))))))))(else '())))) ((equal? sc6 "rangeFromTo") (box (vector 46 e-1 (IdrisC-45Resugar-unbracket e-7) '() (IdrisC-45Resugar-unbracket e-3)))) ((equal? sc6 "rangeFromThen") (box (vector 47 e-1 (IdrisC-45Resugar-unbracket e-7) (box (IdrisC-45Resugar-unbracket e-3)))))(else '()))))))))))))(else (let ((sc3 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc3) (let ((sc4 (IdrisC-45Resugar-extractInteger arg-0))) (if (null? sc4) (let ((sc5 (IdrisC-45Resugar-extractDouble arg-0))) (if (null? sc5) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-10 (vector-ref e-4 1))) (case (vector-ref e-10 0) ((0) (let ((e-15 (vector-ref e-10 1))) (let ((e-12 (vector-ref e-10 2))) (let ((sc8 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-15))) (cond ((equal? sc8 1) (let ((sc9 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc9 "Unit") (box (vector 42 e-8))) ((equal? sc9 "MkUnit") (box (vector 42 e-8)))(else '())))) (else (let ((sc9 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc9 "Nil") (box (vector 38 e-8 e-8 '()))) ((equal? sc9 "Lin") (box (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-9 0) ((0) (let ((e-15 (vector-ref e-9 2))) (let ((e-18 (vector-ref e-15 1))) (case (vector-ref e-18 0) ((0) (let ((e-20 (vector-ref e-18 2))) (let ((sc9 (CoreC-45Name-nameRoot e-20))) (cond ((equal? sc9 "rangeFrom") (box (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc5))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 12 e-4)))))) (let ((e-4 (unbox sc4))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))) (let ((e-4 (unbox sc3))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4))))))))))))(else (let ((sc2 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc2) (let ((sc3 (IdrisC-45Resugar-extractInteger arg-0))) (if (null? sc3) (let ((sc4 (IdrisC-45Resugar-extractDouble arg-0))) (if (null? sc4) (case (vector-ref arg-0 0) ((0) (let ((e-8 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-10 (vector-ref e-4 1))) (case (vector-ref e-10 0) ((0) (let ((e-13 (vector-ref e-10 1))) (let ((e-12 (vector-ref e-10 2))) (let ((sc7 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-13))) (cond ((equal? sc7 1) (let ((sc8 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc8 "Unit") (box (vector 42 e-8))) ((equal? sc8 "MkUnit") (box (vector 42 e-8)))(else '())))) (else (let ((sc8 (CoreC-45Name-nameRoot e-12))) (cond ((equal? sc8 "Nil") (box (vector 38 e-8 e-8 '()))) ((equal? sc8 "Lin") (box (vector 39 e-8 e-8 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (case (vector-ref e-9 0) ((0) (let ((e-14 (vector-ref e-9 2))) (let ((e-16 (vector-ref e-14 1))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 2))) (let ((sc8 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc8 "rangeFrom") (box (vector 47 e-4 (IdrisC-45Resugar-unbracket e-8) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc4))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 12 e-4)))))) (let ((e-4 (unbox sc3))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))) (let ((e-4 (unbox sc2))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))))))))(else (let ((sc1 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc1) (let ((sc2 (IdrisC-45Resugar-extractInteger arg-0))) (if (null? sc2) (let ((sc3 (IdrisC-45Resugar-extractDouble arg-0))) (if (null? sc3) (case (vector-ref arg-0 0) ((0) (let ((e-5 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-8 (vector-ref e-4 1))) (case (vector-ref e-8 0) ((0) (let ((e-10 (vector-ref e-8 1))) (let ((e-11 (vector-ref e-8 2))) (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-10))) (cond ((equal? sc6 1) (let ((sc7 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc7 "Unit") (box (vector 42 e-5))) ((equal? sc7 "MkUnit") (box (vector 42 e-5)))(else '())))) (else (let ((sc7 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc7 "Nil") (box (vector 38 e-5 e-5 '()))) ((equal? sc7 "Lin") (box (vector 39 e-5 e-5 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (let ((e-6 (vector-ref arg-0 3))) (case (vector-ref e-5 0) ((0) (let ((e-14 (vector-ref e-5 2))) (let ((e-16 (vector-ref e-14 1))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 2))) (let ((sc7 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc7 "rangeFrom") (box (vector 47 e-4 (IdrisC-45Resugar-unbracket e-6) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-4 (unbox sc3))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 12 e-4)))))) (let ((e-4 (unbox sc2))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4)))))) (let ((e-4 (unbox sc1))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-4))))))))))))(else (let ((sc0 (IdrisC-45Resugar-extractNat 0 arg-0))) (if (null? sc0) (let ((sc1 (IdrisC-45Resugar-extractInteger arg-0))) (if (null? sc1) (let ((sc2 (IdrisC-45Resugar-extractDouble arg-0))) (if (null? sc2) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-8 (vector-ref e-2 1))) (case (vector-ref e-8 0) ((0) (let ((e-10 (vector-ref e-8 1))) (let ((e-11 (vector-ref e-8 2))) (let ((sc5 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace CoreC-45NameC-45Namespace-builtinNS e-10))) (cond ((equal? sc5 1) (let ((sc6 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc6 "Unit") (box (vector 42 e-1))) ((equal? sc6 "MkUnit") (box (vector 42 e-1)))(else '())))) (else (let ((sc6 (CoreC-45Name-nameRoot e-11))) (cond ((equal? sc6 "Nil") (box (vector 38 e-1 e-1 '()))) ((equal? sc6 "Lin") (box (vector 39 e-1 e-1 '())))(else '())))))))))(else '())))))) ((7) (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (let ((e-6 (vector-ref arg-0 3))) (case (vector-ref e-5 0) ((0) (let ((e-14 (vector-ref e-5 2))) (let ((e-16 (vector-ref e-14 1))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 2))) (let ((sc6 (CoreC-45Name-nameRoot e-19))) (cond ((equal? sc6 "rangeFrom") (box (vector 47 e-4 (IdrisC-45Resugar-unbracket e-6) '())))(else '())))))(else '())))))(else '()))))))(else '())) (let ((e-2 (unbox sc2))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 12 e-2)))))) (let ((e-2 (unbox sc1))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-2)))))) (let ((e-2 (unbox sc0))) (box (vector 15 (IdrisC-45Syntax-getPTermLoc arg-0) (vector 5 e-2))))))))))
(define IdrisC-45Resugar-sugarApp (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () arg-0) (IdrisC-45Resugar-sugarAppM arg-0))))
(define IdrisC-45Resugar-case--toPRef-15502 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-3 (vector arg-2 arg-1 (vector 2 e-0 e-1))))))))) ((3) (let ((e-2 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-3 (vector arg-2 arg-1 e-2))))))) ((4) (let ((e-4 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-3 (vector arg-2 arg-1 (vector 1 (vector 0 e-4))))))))) ((5) (let ((e-7 (vector-ref arg-4 2))) (IdrisC-45Resugar-toPRef arg-3 (vector arg-2 arg-1 e-7))))(else (lambda (eta-0) (vector 1 (IdrisC-45Resugar-sugarApp (vector 0 arg-3 (vector arg-2 arg-1 arg-4)))))))))
(define IdrisC-45Resugar-toPRef (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (IdrisC-45Resugar-case--toPRef-15502 e-2 e-1 e-0 arg-0 (CoreC-45Name-dropNS e-2)))))))
(define IdrisC-45Resugar-mkApp (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-10) (let ((u--ap (IdrisC-45Resugar-sugarApp (vector 7 e-6 arg-2 e-11)))) (IdrisC-45Resugar-mkApp arg-0 arg-1 u--ap e-3)) (let ((e-14 (unbox e-10))) (if (null? e-14) (let ((u--ap (IdrisC-45Resugar-sugarApp (vector 10 e-6 arg-2 e-11)))) (IdrisC-45Resugar-mkApp arg-0 arg-1 u--ap e-3)) (let ((e-17 (unbox e-14))) (lambda (eta-0) (let ((act-1 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (let ((u--ap (vector 9 e-6 arg-2 e-17 e-11))) (IdrisC-45Resugar-mkApp arg-0 arg-1 u--ap e-3))) (else (IdrisC-45Resugar-mkApp arg-0 arg-1 arg-2 e-3))))) eff-0) eta-0)))))))))))))))))))
(define IdrisC-45Resugar-showFullEnv (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2))))) eff-0) ext-0)))))))
(define IdrisC-45Resugar-toPTermApp (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((8) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-2 (cons (cons e-1 (cons '() e-5)) arg-3) eta-0)))) eff-0) ext-0))))))))) ((10) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-6 (cons (cons e-5 (cons (box (box e-7)) e-9)) arg-3) eta-0)))) eff-0) ext-0)))))))))) ((0) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (let ((e-2 (vector-ref e-11 2))) e-2) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--fn (vector 0 e-10 e-11))) (lambda (clam-1) (if (null? e-6) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-appPrec u--fn) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (IdrisC-45Resugar-mkApp arg-0 arg-1 e-7 arg-3))) eff-0) clam-1))))) (let ((e-2 (unbox e-6))) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-appPrec u--fn) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (IdrisC-45Resugar-showFullEnv arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--argsC-39 (cond ((equal? e-8 1) arg-3) (else (DataC-45List-drop (PreludeC-45TypesC-45List-length (let ((e-25 (vector-ref e-2 8))) e-25)) arg-3))))) (IdrisC-45Resugar-mkApp arg-0 arg-1 e-7 u--argsC-39)))) eff-0) eta-1)))))))) eff-0) clam-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))(else (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-appPrec arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45Resugar-mkApp arg-0 arg-1 e-5 arg-3))) eff-0) ext-0)))))))))
(define IdrisC-45Resugar-tyPrec 1)
(define IdrisC-45Resugar-n--13005-16337-u--mkIf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((4) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (if (null? e-4) arg-8 (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (let ((e-12 (vector-ref e-6 4))) (case (vector-ref e-10 0) ((0) (let ((e-14 (vector-ref e-10 1))) (let ((e-15 (vector-ref e-10 2))) (if (null? e-12) (if (null? e-7) arg-8 (let ((e-18 (car e-7))) (let ((e-19 (cdr e-7))) (case (vector-ref e-18 0) ((0) (let ((e-21 (vector-ref e-18 1))) (let ((e-22 (vector-ref e-18 2))) (let ((e-23 (vector-ref e-18 3))) (let ((e-24 (vector-ref e-18 4))) (case (vector-ref e-22 0) ((0) (let ((e-26 (vector-ref e-22 1))) (let ((e-27 (vector-ref e-22 2))) (if (null? e-24) (if (null? e-19) (let ((u--tm (vector 4 e-1 e-2 e-3 (cons (vector 0 e-9 (vector 0 e-14 e-15) e-11 '()) (cons (vector 0 e-21 (vector 0 e-26 e-27) e-23 '()) '()))))) (let ((sc10 (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-5 (vector-ref e-15 2))) e-5)) (vector 1 (vector 0 "True"))))) (cond ((equal? sc11 1) (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS (let ((e-5 (vector-ref e-27 2))) e-5)) (vector 1 (vector 0 "False")))) (else 0))))) (cond ((equal? sc10 1) (vector 43 e-1 e-3 e-11 e-23)) (else u--tm)))) arg-8) arg-8))))(else arg-8)))))))(else arg-8))))) arg-8))))(else arg-8)))))))(else arg-8))))))))))(else arg-8))))
(define TTImpC-45TTImp-getFieldUpdatePath (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) (else (let ((e-4 (vector-ref arg-1 1))) e-4)))))
(define TTImpC-45TTImp-getFieldUpdateTerm (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) e-2)) (else (let ((e-5 (vector-ref arg-1 2))) e-5)))))
(define TTImpC-45Utils-findAllNames (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-0))) (cond ((equal? sc1 1) '()) (else (cons e-2 '())))))) ((1) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (let ((u--envC-39 (if (null? e-7) arg-0 (let ((e-2 (unbox e-7))) (cons e-2 arg-0))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-8) (TTImpC-45Utils-findAllNames u--envC-39 e-9))))))) ((2) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (let ((u--envC-39 (if (null? e-14) arg-0 (let ((e-2 (unbox e-14))) (cons e-2 arg-0))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames u--envC-39 e-15) (TTImpC-45Utils-findAllNames u--envC-39 e-16))))))) ((8) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-19) (TTImpC-45Utils-findAllNames arg-0 e-20))))) ((10) (let ((e-23 (vector-ref arg-1 2))) (let ((e-25 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-23) (TTImpC-45Utils-findAllNames arg-0 e-25))))) ((9) (let ((e-28 (vector-ref arg-1 2))) (let ((e-29 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-28) (TTImpC-45Utils-findAllNames arg-0 e-29))))) ((11) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-32) (TTImpC-45Utils-findAllNames arg-0 e-33))))) ((18) (let ((e-38 (vector-ref arg-1 4))) (let ((e-39 (vector-ref arg-1 5))) (cons e-38 (TTImpC-45Utils-findAllNames arg-0 e-39))))) ((19) (let ((e-43 (vector-ref arg-1 3))) (TTImpC-45Utils-findAllNames arg-0 e-43))) ((20) (let ((e-47 (vector-ref arg-1 3))) (TTImpC-45Utils-findAllNames arg-0 e-47))) ((21) (let ((e-50 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-50))) ((22) (let ((e-53 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-53))) ((23) (let ((e-56 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-56))) ((26) (let ((e-59 (vector-ref arg-1 2))) (TTImpC-45Utils-findAllNames arg-0 e-59))) ((13) (let ((e-63 (vector-ref arg-1 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findAllNames arg-0 eta-0)) e-63))) ((7) (let ((e-66 (vector-ref arg-1 2))) (let ((e-67 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findAllNames arg-0 e-67) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findAllNames arg-0 (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-66) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 1 (vector 0 eta-1))) (TTImpC-45TTImp-getFieldUpdatePath eta-0))) e-66))))))(else '()))))
(define TTImpC-45Utils-n--9531-1031-u--getFromClause (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (cons e-2 (cons e-3 '()))))) ((1) (let ((e-6 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-11 (vector-ref arg-1 7))) (PreludeC-45Types-listBind e-11 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (cons e-8 (cons e-6 '())) (TTImpC-45Utils-n--9531-1031-u--getFromClause arg-0 bind-0)))))))) (else (let ((e-14 (vector-ref arg-1 2))) (cons e-14 '()))))))
(define TTImpC-45Utils-n--9531-1033-u--getFromPiInfo (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (cons e-1 '())))(else '()))))
(define TTImpC-45Utils-n--9531-1032-u--getFromIField (lambda (arg-0 arg-1) (let ((e-3 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-n--9531-1033-u--getFromPiInfo arg-0 e-3) (cons e-5 '()))))))
(define TTImpC-45Utils-n--9531-1034-u--getFromTy (lambda (arg-0 arg-1) (let ((e-4 (vector-ref arg-1 3))) e-4)))
(define TTImpC-45Utils-n--9531-1035-u--getParamTy (lambda (arg-0 arg-4) (let ((e-3 (cdr arg-4))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) e-11)))))
(define TTImpC-45Utils-rawImpFromDecl (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-5 (vector-ref arg-0 5))) (cons (TTImpC-45Utils-n--9531-1034-u--getFromTy arg-0 e-5) '()))) ((1) (let ((e-10 (vector-ref arg-0 4))) (case (vector-ref e-10 0) ((0) (let ((e-54 (vector-ref e-10 3))) (let ((e-56 (vector-ref e-10 5))) ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () csegen-103) e-54) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-n--9531-1034-u--getFromTy arg-0 eta-0)) e-56))))) (else (let ((e-60 (vector-ref e-10 3))) (cons e-60 '())))))) ((2) (let ((e-14 (vector-ref arg-0 3))) (PreludeC-45Types-listBind e-14 (lambda (bind-0) (TTImpC-45Utils-n--9531-1031-u--getFromClause arg-0 bind-0))))) ((3) (let ((e-17 (vector-ref arg-0 2))) (let ((e-18 (vector-ref arg-0 3))) (PreludeC-45Types-listBind e-18 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-rawImpFromDecl bind-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-n--9531-1035-u--getParamTy arg-0 eta-0)) e-17))))))) ((4) (let ((e-20 (vector-ref arg-0 1))) (let ((e-21 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 3))) (let ((e-23 (vector-ref arg-0 4))) (let ((e-24 (vector-ref arg-0 5))) (let ((e-62 (vector-ref e-24 0))) (let ((e-63 (vector-ref e-24 1))) (let ((e-64 (vector-ref e-24 2))) (let ((e-65 (vector-ref e-24 3))) (let ((e-66 (vector-ref e-24 4))) (let ((e-67 (vector-ref e-24 5))) (PreludeC-45Types-listBind (PreludeC-45TypesC-45List-mapAppend '() csegen-1842 e-64) (lambda (_-0) (let ((u--decl (vector 4 e-20 e-21 e-22 e-23 (vector e-62 e-63 e-64 e-65 e-66 e-67)))) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-listBind e-67 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-n--9531-1033-u--getFromPiInfo u--decl e-2) (PreludeC-45TypesC-45List-tailRecAppend (cons e-3 '()) (TTImpC-45Utils-n--9531-1032-u--getFromIField u--decl bind-0)))))))))))))))))))))) ((5) (let ((e-28 (vector-ref arg-0 3))) (PreludeC-45Types-listBind e-28 (lambda (bind-0) (TTImpC-45Utils-rawImpFromDecl bind-0))))) ((6) (let ((e-32 (vector-ref arg-0 3))) (PreludeC-45Types-listBind e-32 (lambda (bind-0) (TTImpC-45Utils-rawImpFromDecl bind-0))))) ((7) (let ((e-36 (vector-ref arg-0 3))) (let ((e-37 (vector-ref arg-0 4))) (cons e-36 (cons e-37 '()))))) ((8) '()) ((9) '()) ((10) '()) (else '()))))
(define TTImpC-45Utils-n--9901-1663-u--getRawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (cons e-2 (cons e-3 '()))))) ((1) (let ((e-6 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 4))) (let ((e-11 (vector-ref arg-7 7))) (PreludeC-45Types-listBind e-11 (lambda (bind-0) (PreludeC-45TypesC-45List-tailRecAppend (cons e-8 (cons e-6 '())) (TTImpC-45Utils-n--9901-1663-u--getRawImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 bind-0)))))))) (else (let ((e-14 (vector-ref arg-7 2))) (cons e-14 '()))))))
(define TTImpC-45Utils-findBindableNamesQuot (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (PreludeC-45Types-listBind (cons e-5 (cons e-6 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((2) (let ((e-12 (vector-ref arg-2 5))) (let ((e-13 (vector-ref arg-2 6))) (PreludeC-45Types-listBind (cons e-12 (cons e-13 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((3) (let ((e-19 (vector-ref arg-2 5))) (let ((e-20 (vector-ref arg-2 6))) (let ((e-21 (vector-ref arg-2 7))) (PreludeC-45Types-listBind (cons e-19 (cons e-20 (cons e-21 '()))) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0))))))) ((4) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (PreludeC-45Types-listBind e-27 (lambda (bind-0) (PreludeC-45Types-listBind (PreludeC-45TypesC-45List-tailRecAppend (cons e-25 (cons e-26 '())) (TTImpC-45Utils-n--9901-1663-u--getRawImp e-24 e-27 e-26 e-25 e-23 arg-1 arg-0 bind-0)) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-1))))))))))) ((5) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (PreludeC-45Types-listBind e-30 (lambda (bind-0) (PreludeC-45Types-listBind (cons e-31 (TTImpC-45Utils-rawImpFromDecl bind-0)) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-1)))))))) ((6) (let ((e-37 (vector-ref arg-2 5))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-37))) ((8) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (PreludeC-45Types-listBind (cons e-40 (cons e-41 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((10) (let ((e-44 (vector-ref arg-2 2))) (let ((e-46 (vector-ref arg-2 4))) (PreludeC-45Types-listBind (cons e-44 (cons e-46 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((9) (let ((e-49 (vector-ref arg-2 2))) (let ((e-50 (vector-ref arg-2 3))) (PreludeC-45Types-listBind (cons e-49 (cons e-50 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((11) (let ((e-53 (vector-ref arg-2 2))) (let ((e-54 (vector-ref arg-2 3))) (PreludeC-45Types-listBind (cons e-53 (cons e-54 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((14) (let ((e-57 (vector-ref arg-2 2))) (let ((e-58 (vector-ref arg-2 3))) (PreludeC-45Types-listBind (cons e-57 (cons e-58 '())) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((15) (let ((e-61 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-61))) ((16) (let ((e-65 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-65))) ((7) (let ((e-68 (vector-ref arg-2 2))) (let ((e-69 (vector-ref arg-2 3))) (PreludeC-45Types-listBind (cons e-69 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-getFieldUpdateTerm eta-0)) e-68)) (lambda (bind-0) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 bind-0)))))) ((18) (let ((e-75 (vector-ref arg-2 5))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-75))) ((20) (let ((e-79 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-79))) ((21) (let ((e-82 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-82))) ((22) (let ((e-85 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-85))) ((26) (let ((e-88 (vector-ref arg-2 2))) (TTImpC-45Utils-findBindableNames 1 arg-0 arg-1 e-88))) ((33) (let ((e-92 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-92))) ((0) '()) ((12) '()) ((13) '()) ((17) '()) ((28) '()) ((29) '()) ((30) '()) ((32) '()) ((19) (let ((e-120 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-120))) ((31) (let ((e-124 (vector-ref arg-2 3))) (TTImpC-45Utils-findBindableNamesQuot arg-0 arg-1 e-124))) ((23) '()) ((24) '()) ((25) '()) (else '()))))
(define TTImpC-45Utils-genUniqueStr (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-22 arg-1 arg-0))) (cond ((equal? sc0 1) (TTImpC-45Utils-genUniqueStr arg-0 (string-append arg-1 "'"))) (else arg-1)))))
(define TTImpC-45Utils-findBindableNames (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-0 1) (case (vector-ref arg-3 0) ((0) (let ((e-69 (vector-ref arg-3 2))) (case (vector-ref e-69 0) ((1) (let ((e-70 (vector-ref e-69 1))) (case (vector-ref e-70 0) ((0) (let ((e-71 (vector-ref e-70 1))) (let ((u--nm (vector 1 (vector 0 e-71)))) (let ((sc4 (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 u--nm arg-1))) (cond ((equal? sc5 1) 0) (else (LibrariesC-45UtilsC-45String-lowerFirst e-71)))))) (cond ((equal? sc4 1) (cons (cons e-71 (TTImpC-45Utils-genUniqueStr arg-2 e-71)) '())) (else '()))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-65 (vector-ref e-35 1))) (case (vector-ref e-65 0) ((0) (let ((e-66 (vector-ref e-65 1))) (cons (cons e-66 (TTImpC-45Utils-genUniqueStr arg-2 e-66)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-listBind e-56 (lambda (bind-0) (PreludeC-45Types-listBind (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60))) ((7) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-64) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-63)))))(else '()))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-65 (vector-ref e-35 1))) (case (vector-ref e-65 0) ((0) (let ((e-66 (vector-ref e-65 1))) (cons (cons e-66 (TTImpC-45Utils-genUniqueStr arg-2 e-66)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-listBind e-56 (lambda (bind-0) (PreludeC-45Types-listBind (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60))) ((7) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-64) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-63)))))(else '()))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-65 (vector-ref e-35 1))) (case (vector-ref e-65 0) ((0) (let ((e-66 (vector-ref e-65 1))) (cons (cons e-66 (TTImpC-45Utils-genUniqueStr arg-2 e-66)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-listBind e-56 (lambda (bind-0) (PreludeC-45Types-listBind (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60))) ((7) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-64) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-63)))))(else '())))))(else (case (vector-ref arg-3 0) ((1) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-4) arg-1 (let ((e-7 (unbox e-4))) (cons e-7 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-5) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-6))))))) ((2) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--envC-39 (if (null? e-11) arg-1 (let ((e-2 (unbox e-11))) (cons e-2 arg-1))))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-12) (TTImpC-45Utils-findBindableNames 1 u--envC-39 arg-2 e-13))))))) ((8) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-16) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-17))))) ((10) (let ((e-20 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-20) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-22))))) ((9) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-25) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-26))))) ((11) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 0 arg-1 arg-2 e-29) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-30))))) ((18) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (case (vector-ref e-35 0) ((1) (let ((e-65 (vector-ref e-35 1))) (case (vector-ref e-65 0) ((0) (let ((e-66 (vector-ref e-65 1))) (cons (cons e-66 (TTImpC-45Utils-genUniqueStr arg-2 e-66)) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))(else (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-36)))))) ((19) (let ((e-40 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-40))) ((20) (let ((e-44 (vector-ref arg-3 3))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-44))) ((21) (let ((e-47 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-47))) ((22) (let ((e-50 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 e-50))) ((23) (let ((e-53 (vector-ref arg-3 2))) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 e-53))) ((25) (let ((e-56 (vector-ref arg-3 2))) (PreludeC-45Types-listBind e-56 (lambda (bind-0) (PreludeC-45Types-listBind (TTImpC-45Utils-rawImpFromDecl bind-0) (lambda (bind-1) (TTImpC-45Utils-findBindableNamesQuot arg-1 arg-2 bind-1))))))) ((13) (let ((e-60 (vector-ref arg-3 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames arg-0 arg-1 arg-2 eta-0)) e-60))) ((7) (let ((e-63 (vector-ref arg-3 2))) (let ((e-64 (vector-ref arg-3 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 e-64) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findBindableNames 1 arg-1 arg-2 (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-63)))))(else '()))))))
(define IdrisC-45Resugar-n--13005-15849-u--needsBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-1 (unbox arg-8))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (let ((u--ret (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 arg-0))) (let ((u--ns (TTImpC-45Utils-findBindableNames 0 '() '() u--ret))) (let ((u--allNs (TTImpC-45Utils-findAllNames '() u--ret))) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-832 e-1 u--allNs))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-22 e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) u--ns)))) (cond ((equal? sc4 1) 0) (else 1)))) (else 0))))))))(else 0))))(else 0))))))
(define IdrisC-45Resugar-toPTerm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (let ((e-3 (vector-ref e-5 3))) e-3))) (cond ((equal? sc2 1) (lambda (eta-1) (vector 1 (vector 0 e-1 e-2)))) (else (IdrisC-45Resugar-toPRef e-1 e-2)))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "resugar.var" 70 (lambda () (DataC-45String-unwords (cons "Resugaring" (cons (CoreC-45Name-u--show_Show_RawName (let ((e-3 (vector-ref e-2 2))) e-3)) (cons "to" (cons (IdrisC-45Syntax-u--show_Show_IPTerm e-5) '())))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 e-5))))))) eff-0) eta-0))))))))) ((1) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (let ((e-8 (vector-ref arg-3 5))) (let ((e-9 (vector-ref arg-3 6))) (lambda (clam-0) (case (vector-ref e-6 0) ((0) (let ((act-1 (IdrisC-45Resugar-showImplicits arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-10 1) (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-tyPrec e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-tyPrec e-9) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-tyPrec (vector 1 e-4 e-5 (vector 0 ) e-7 e-11 e-12) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (else (let ((sc4 (IdrisC-45Resugar-n--13005-15849-u--needsBind e-9 e-8 e-7 e-5 e-4 arg-2 arg-1 arg-0 e-7))) (cond ((equal? sc4 1) (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-tyPrec e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-tyPrec e-9) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-tyPrec (vector 1 e-4 e-5 (vector 0 ) e-7 e-11 e-12) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (else (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-9)))))))) eff-0) clam-0))))))(else (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-appPrec e-8) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-tyPrec e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-2) (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec eta-2)) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-tyPrec (vector 1 e-4 e-5 e-12 e-7 e-10 e-11) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (let ((e-15 (vector-ref arg-3 5))) (let ((e-16 (vector-ref arg-3 6))) (let ((u--n (if (null? e-14) (vector 1 (vector 2 )) (let ((e-2 (unbox e-14))) e-2)))) (lambda (eta-0) (let ((act-1 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (cond ((equal? e-5 1) ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-tyPrec e-15) eta-1)) (else (vector 1 (vector 25 e-11)))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-16) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-4) (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec eta-4)) e-13) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--var (vector 0 e-11 (vector (box (vector 0 )) u--n u--n)))) (lambda (eta-4) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (vector 2 e-11 e-12 e-8 u--var e-6 e-7) eta-4))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((3) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (let ((e-21 (vector-ref arg-3 4))) (let ((e-22 (vector-ref arg-3 5))) (let ((e-23 (vector-ref arg-3 6))) (let ((e-24 (vector-ref arg-3 7))) (lambda (eta-0) (let ((act-1 (IdrisC-45Resugar-showImplicits arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (cond ((equal? e-5 1) ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-22) eta-1)) (else (vector 1 (vector 25 e-18)))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-23) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-24) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--var (vector 0 e-19 (vector (box (vector 0 )) e-21 e-21)))) (lambda (eta-4) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (vector 3 e-18 e-20 u--var e-6 e-7 e-8 '()) eta-4))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((4) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (let ((e-30 (vector-ref arg-3 5))) (if (null? e-30) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPFnOpt arg-0 arg-1 eta-1 eta-2))) e-27 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-28) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-3 eta-4))) e-30 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (IdrisC-45Resugar-n--13005-16337-u--mkIf e-30 e-29 e-28 e-27 e-26 arg-2 arg-1 arg-0 (vector 4 e-26 e-5 e-6 e-7)) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (let ((e-140 (car e-30))) (let ((e-141 (cdr e-30))) (lambda (clam-0) (case (vector-ref e-140 0) ((0) (let ((e-144 (vector-ref e-140 2))) (let ((e-145 (vector-ref e-140 3))) (if (null? e-141) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-28) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-144) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-145) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (vector 3 e-26 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega e-6 (vector 25 e-26) e-5 e-7 '()) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPFnOpt arg-0 arg-1 eta-0 eta-1))) e-27 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-28) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-2 eta-3))) e-30 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (IdrisC-45Resugar-n--13005-16337-u--mkIf e-30 e-29 e-28 e-27 e-26 arg-2 arg-1 arg-0 (vector 4 e-26 e-5 e-6 e-7)) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-toPFnOpt arg-0 arg-1 eta-0 eta-1))) e-27 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-28) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45Resugar-toPClause arg-0 arg-1 eta-2 eta-3))) e-30 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (IdrisC-45Resugar-n--13005-16337-u--mkIf e-30 e-29 e-28 e-27 e-26 arg-2 arg-1 arg-0 (vector 4 e-26 e-5 e-6 e-7)) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))) ((5) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-1 eta-2))) e-33 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-34) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (vector 5 e-32 (DataC-45List-catMaybes e-5) e-6) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((6) (let ((e-40 (vector-ref arg-3 5))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-40))) ((7) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPFieldUpdate arg-0 arg-1 eta-1 eta-2))) e-43 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-44) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec (vector 7 e-42 (vector 6 e-42 e-5) e-6) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((8) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-48) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-47 (cons (cons e-46 (cons '() e-5)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-appPrec e-6 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-52) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-51 (cons (cons e-50 (cons (box '()) e-5)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-appPrec e-6 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((11) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (let ((e-56 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-56) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-55) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-appPrec (vector 8 e-54 e-6 e-5) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((10) (let ((e-58 (vector-ref arg-3 1))) (let ((e-59 (vector-ref arg-3 2))) (let ((e-60 (vector-ref arg-3 3))) (let ((e-61 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-61) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Resugar-toPTermApp arg-0 arg-1 e-59 (cons (cons e-58 (cons (box (box e-60)) e-5)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Resugar-showImplicits arg-0 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-7 1) (lambda (eta-3) (IdrisC-45Resugar-bracket arg-0 arg-1 arg-2 IdrisC-45Resugar-startPrec e-6 eta-3))) (else (IdrisC-45Resugar-mkOp arg-1 e-6))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((12) (let ((e-63 (vector-ref arg-3 1))) (let ((e-64 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 14 e-63 e-64)))))) ((13) (let ((e-66 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 25 e-66))))) ((14) (let ((e-70 (vector-ref arg-3 1))) (let ((e-71 (vector-ref arg-3 2))) (let ((e-72 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-71) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-72) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 45 e-70 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((15) (let ((e-75 (vector-ref arg-3 2))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-75))) ((28) (let ((e-77 (vector-ref arg-3 1))) (let ((e-78 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 15 e-77 e-78)))))) ((30) (let ((e-80 (vector-ref arg-3 1))) (let ((e-81 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 21 e-80 0 e-81)))))) ((29) (let ((e-83 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 22 e-83))))) ((17) (let ((e-85 (vector-ref arg-3 1))) (let ((e-86 (vector-ref arg-3 2))) (let ((u--nm (vector 1 (vector 0 e-86)))) (lambda (eta-0) (vector 1 (vector 0 e-85 (vector (box (vector 0 )) u--nm u--nm)))))))) ((16) (let ((e-90 (vector-ref arg-3 3))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-90))) ((18) (let ((e-92 (vector-ref arg-3 1))) (let ((e-93 (vector-ref arg-3 2))) (let ((e-95 (vector-ref arg-3 4))) (let ((e-96 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-96) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 23 e-92 e-93 e-95 e-5))))) eff-0) eta-0))))))))))) ((19) (let ((e-98 (vector-ref arg-3 1))) (let ((e-100 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-100) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 24 e-98 e-5))))) eff-0) eta-0))))))))) ((20) (let ((e-102 (vector-ref arg-3 1))) (let ((e-103 (vector-ref arg-3 2))) (let ((e-104 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-104) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 11 e-102 e-103 e-5))))) eff-0) eta-0)))))))))) ((21) (let ((e-106 (vector-ref arg-3 1))) (let ((e-107 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-107) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 12 e-106 e-5))))) eff-0) eta-0))))))))) ((22) (let ((e-109 (vector-ref arg-3 1))) (let ((e-110 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-110) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 13 e-109 e-5))))) eff-0) eta-0))))))))) ((23) (let ((e-112 (vector-ref arg-3 1))) (let ((e-113 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-113) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 16 e-112 e-5))))) eff-0) eta-0))))))))) ((24) (let ((e-115 (vector-ref arg-3 1))) (let ((e-116 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (vector 17 e-115 e-116)))))) ((25) (let ((e-118 (vector-ref arg-3 1))) (let ((e-119 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-toPDecl arg-0 arg-1 eta-1 eta-2))) e-119 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 18 e-118 (DataC-45List-catMaybes e-5)))))) eff-0) eta-0))))))))) ((26) (let ((e-121 (vector-ref arg-3 1))) (let ((e-122 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-122) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 19 e-121 e-5))))) eff-0) eta-0))))))))) ((27) (let ((e-124 (vector-ref arg-3 1))) (let ((e-126 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-argPrec e-126) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 20 e-124 e-5))))) eff-0) eta-0))))))))) ((31) (let ((e-130 (vector-ref arg-3 3))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 e-130))) ((32) (let ((e-132 (vector-ref arg-3 1))) (let ((e-133 (vector-ref arg-3 2))) (lambda (clam-2) (cond ((equal? e-133 1) (vector 1 (vector 25 e-132))) (else (vector 1 (vector 26 e-132)))))))) (else (let ((e-135 (vector-ref arg-3 1))) (let ((e-136 (vector-ref arg-3 2))) (let ((e-137 (vector-ref arg-3 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 51 e-135 e-136 e-5)))))) (IdrisC-45Resugar-toPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec e-137) eta-0)))))))))
(define IdrisC-45Resugar-toCleanPTerm (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((IdrisC-45Resugar-toPTerm arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-cleanPTerm arg-0 e-5 eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45TTImp-getFnArgs (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((8) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (TTImpC-45TTImp-getFnArgs e-2 (cons (vector 0 e-1 e-3) arg-2)))))) ((10) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (TTImpC-45TTImp-getFnArgs e-6 (cons (vector 2 e-5 e-7 e-8) arg-2))))))) ((9) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (let ((e-12 (vector-ref arg-1 3))) (TTImpC-45TTImp-getFnArgs e-11 (cons (vector 1 e-10 e-12) arg-2))))))(else (cons arg-1 arg-2)))))
(define TTImpC-45Unelab-n--8804-10630-u--apply (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (TTImpC-45Unelab-n--8804-10630-u--apply arg-1 arg-2 arg-3 arg-4 (vector 8 e-5 arg-5 e-6) e-3)))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (TTImpC-45Unelab-n--8804-10630-u--apply arg-1 arg-2 arg-3 arg-4 (vector 9 e-8 arg-5 e-9) e-3)))) (else (let ((e-11 (vector-ref e-2 1))) (let ((e-12 (vector-ref e-2 2))) (let ((e-13 (vector-ref e-2 3))) (TTImpC-45Unelab-n--8804-10630-u--apply arg-1 arg-2 arg-3 arg-4 (vector 10 e-11 arg-5 e-12 e-13) e-3)))))))))))
(define TTImpC-45Unelab-case--dropParams-10664 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (cons arg-1 arg-2))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((sc2 (DataC-45List-lookup csegen-832 (let ((e-4 (vector-ref e-6 2))) e-4) arg-3))) (if (null? sc2) (vector 1 (cons arg-1 arg-2)) (let ((e-4 (unbox sc2))) (vector 1 (cons (TTImpC-45Unelab-n--8804-10630-u--apply arg-1 arg-2 arg-3 arg-4 (vector 0 e-5 e-6) (DataC-45List-drop e-4 e-3)) arg-2))))))))(else (vector 1 (cons arg-1 arg-2))))))))))
(define TTImpC-45Unelab-dropParams (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (TTImpC-45Unelab-case--dropParams-10664 e-2 e-3 arg-2 arg-1 (TTImpC-45TTImp-getFnArgs e-2 '()))))))
(define CoreC-45Context-n--22356-17976-u--findAlias (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 arg-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 arg-0))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 e-4))) (else (CoreC-45Context-n--22356-17976-u--findAlias arg-0 arg-1 e-3)))))))(else (CoreC-45Context-n--22356-17976-u--findAlias arg-0 arg-1 e-3))))))))
(define CoreC-45Context-case--aliasName-18044 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 arg-0)) (let ((e-1 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-1 (let ((e-0 (vector-ref arg-2 0))) (let ((e-42 (vector-ref e-0 3))) e-42))))) (if (null? sc1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-2 (unbox sc1))) (CoreC-45Context-n--22356-17976-u--findAlias arg-0 arg-1 e-2))))))))
(define CoreC-45Context-aliasName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-case--aliasName-18044 arg-1 arg-0 e-5 (CoreC-45Name-userNameRoot arg-1)))) eff-0) ext-0)))))))
(define CoreC-45NameC-45Scoped-compat (lambda (arg-4 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) 1) ext-0))))
(define CoreC-45NormaliseC-45Eval-gErased (lambda (arg-1) (vector 1 (lambda (eta-0) (vector 1 (vector 10 arg-1 (vector 0 )))) (lambda (eta-0) (lambda (eta-1) (vector 1 (vector 9 arg-1 (vector 0 ))))))))
(define CoreC-45NormaliseC-45Eval-gType (lambda (arg-1 arg-2) (vector 1 (lambda (eta-0) (vector 1 (vector 11 arg-1 arg-2))) (lambda (eta-0) (lambda (eta-1) (vector 1 (vector 10 arg-1 arg-2)))))))
(define CoreC-45NormaliseC-45Eval-getNF (lambda (arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) (e-3 arg-1))))
(define CoreC-45NormaliseC-45Eval-getTerm (lambda (arg-1) (let ((e-2 (vector-ref arg-1 1))) e-2)))
(define CoreC-45Normalise-glueBack (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 0 (lambda (eta-0) (let ((act-1 (CoreC-45Context-clearDefs arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 e-5 arg-3 arg-4 eta-1)))) eff-0) eta-0)))))) (lambda (eta-0) (lambda (eta-1) (vector 1 arg-4))))))
(define CoreC-45NormaliseC-45Eval-gnf (lambda (arg-0 arg-1 arg-2) (vector 1 (lambda (eta-0) (vector 1 arg-2)) (lambda (u--c) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox u--c))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf u--c arg-0 e-5 arg-1 arg-2))) eff-0) eta-0))))))))))
(define TTImpC-45Unelab-unelabPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-4 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (vector 1 (vector 3 e-2)))))) eff-0) ext-0))))))))))
(define TTImpC-45Unelab-n--8583-9215-u--usedBinder (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((sc1 (TTImpC-45Unelab-used arg-5 e-3))) (cond ((equal? sc1 1) 1) (else (TTImpC-45Unelab-used arg-5 e-4)))))))(else (TTImpC-45Unelab-used arg-5 (CoreC-45TTC-45Binder-binderType arg-6))))))
(define TTImpC-45Unelab-used (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (or (and (= arg-1 e-4) 1) 0))) ((3) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((sc1 (TTImpC-45Unelab-n--8583-9215-u--usedBinder e-7 e-8 e-10 e-9 arg-1 e-9))) (cond ((equal? sc1 1) 1) (else (TTImpC-45Unelab-used (+ arg-1 1) e-10))))))))) ((2) (let ((e-15 (vector-ref arg-2 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45Unelab-used arg-1 eta-0)) e-15))) ((4) (let ((e-18 (vector-ref arg-2 2))) (let ((e-19 (vector-ref arg-2 3))) (let ((sc1 (TTImpC-45Unelab-used arg-1 e-18))) (cond ((equal? sc1 1) 1) (else (TTImpC-45Unelab-used arg-1 e-19))))))) ((5) (let ((e-24 (vector-ref arg-2 4))) (TTImpC-45Unelab-used arg-1 e-24))) ((6) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45Unelab-used arg-1 e-28))) ((7) (let ((e-33 (vector-ref arg-2 4))) (TTImpC-45Unelab-used arg-1 e-33))) ((8) (let ((e-37 (vector-ref arg-2 3))) (TTImpC-45Unelab-used arg-1 e-37)))(else 0))))
(define TTImpC-45Unelab-n--8894-12946-u--isDefImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15) (case (vector-ref arg-15 0) ((3) 1)(else 0))))
(define TTImpC-45Unelab-n--8894-12947-u--isNoSugar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((1) 1)(else 0))))
(define TTImpC-45Unelab-unelabBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-5))) (let ((act-2 (TTImpC-45Unelab-unelabPi arg-0 arg-1 arg-2 arg-3 arg-5 e-3 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 2 arg-4 e-2 e-8 (box arg-6) e-7 arg-9) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 2 e-1 e-2 e-3 e-4) arg-10))))))) eff-0) clam-1))))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-5))) (let ((act-2 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-9 clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (let ((e-11 (car e-10))) (vector 1 (cons (vector 3 arg-4 (vector 2 ) e-7 arg-6 e-11 e-2 arg-9) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 1 e-6 e-7 e-8 e-9) arg-10)))))))) eff-0) clam-2))))))))) eff-0) ext-0)))))))))) ((2) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-2 (car e-5))) (let ((act-2 (TTImpC-45Unelab-unelabPi arg-0 arg-1 arg-2 arg-3 arg-5 e-13 clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--nm (let ((sc4 (let ((sc5 (TTImpC-45Unelab-used 0 arg-8))) (cond ((equal? sc5 1) 1) (else (TTImpC-45Unelab-n--8894-12947-u--isNoSugar arg-0 e-11 e-14 e-13 e-12 arg-6 arg-10 arg-9 arg-8 arg-5 arg-4 arg-3 arg-2 arg-1 arg-2)))))) (cond ((equal? sc4 1) (box arg-6)) (else (let ((sc5 (let ((sc6 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega e-12 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) (cond ((equal? sc6 1) 1) (else (TTImpC-45Unelab-n--8894-12946-u--isDefImp arg-0 e-11 e-14 e-13 e-12 arg-6 arg-10 arg-9 arg-8 arg-5 arg-4 arg-3 arg-2 arg-1 e-13)))))) (cond ((equal? sc5 1) (box (vector 1 (vector 2 )))) (else '())))))))) (lambda (eta-0) (vector 1 (cons (vector 1 arg-4 e-12 e-6 u--nm e-2 arg-9) (CoreC-45NormaliseC-45Eval-gType arg-4 (vector 2 "top" 0)))))))) eff-0) clam-4))))))))) eff-0) ext-0)))))))))) ((3) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 4))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-19 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-5) (vector 1 (cons arg-9 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 5 e-16 e-17 e-19) arg-10))))))) eff-0) ext-0))))))))) ((4) (let ((e-21 (vector-ref arg-7 1))) (let ((e-22 (vector-ref arg-7 2))) (let ((e-23 (vector-ref arg-7 3))) (let ((e-24 (vector-ref arg-7 4))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-23 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-6) (let ((e-2 (car e-5))) (let ((act-2 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-24 clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-7) (let ((e-7 (car e-6))) (vector 1 (cons (vector 3 arg-4 (vector 2 ) e-22 arg-6 e-7 e-2 arg-9) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 3 arg-4 arg-6 (vector 4 e-21 e-22 e-23 e-24) arg-10)))))))) eff-0) clam-6))))))))) eff-0) ext-0)))))))))) (else (let ((e-28 (vector-ref arg-7 3))) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-5 e-28 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-8) (vector 1 (cons arg-9 (CoreC-45NormaliseC-45Eval-gType arg-4 (vector 2 "top" 0))))))) eff-0) ext-0))))))))))
(define TTImpC-45Unelab-n--8845-11328-u--next (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((2) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (vector 2 e-0 (bs+ e-1 1 63))))) ((1) (let ((e-2 (vector-ref arg-9 1))) (vector 2 (CoreC-45Name-u--show_Show_UserName e-2) 0))) ((0) (let ((e-3 (vector-ref arg-9 1))) (let ((e-4 (vector-ref arg-9 2))) (vector 0 e-3 (TTImpC-45Unelab-n--8845-11328-u--next arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-4)))))(else (vector 2 (CoreC-45Name-u--show_Show_Name arg-9) 0)))))
(define TTImpC-45Unelab-n--8845-11329-u--uniqueLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-832 arg-10 arg-9))) (cond ((equal? sc0 1) (TTImpC-45Unelab-n--8845-11329-u--uniqueLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (TTImpC-45Unelab-n--8845-11328-u--next arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10))) (else arg-10)))))
(define TTImpC-45Unelab-n--8780-9545-u--findArgPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 2))) (box e-2)))(else '()))))
(define TTImpC-45Unelab-n--8780-9546-u--idxOrMaybe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (cond ((equal? arg-7 0) (if (null? arg-8) '() (let ((e-3 (car arg-8))) (box e-3))))(else (let ((e-1 (- arg-7 1))) (if (null? arg-8) '() (let ((e-7 (cdr arg-8))) (TTImpC-45Unelab-n--8780-9546-u--idxOrMaybe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1 e-7))))))))
(define PreludeC-45Interfaces-sequence (lambda (arg-3 arg-4 ext-0) (let ((e-3 (vector-ref arg-4 2))) ((((((e-3 'erased) 'erased) 'erased) arg-3) (lambda (eta-0) eta-0)) ext-0))))
(define CoreC-45Env-extend (lambda (arg-2 ext-0 ext-1) (cons ext-0 ext-1)))
(define CoreC-45Env-C-43C-43 (lambda (arg-1 arg-2 arg-3) (if (null? arg-1) arg-3 (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-7 (car arg-2))) (let ((e-8 (cdr arg-2))) (CoreC-45Env-extend e-1 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) eta-0) e-7) (CoreC-45Env-C-43C-43 e-2 e-8 arg-3)))))))))
(define CoreC-45Normalise-logTermNFC-39 (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-5 arg-6 arg-7 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-1 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (cond ((equal? arg-2 "") (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7)))))) "\xa;") eta-2))) (vector 1 act-4)))(else (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7)))))))) "\xa;") eta-2))) (vector 1 act-4))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Binder-piInfo (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 3))) e-3)) ((1) (vector 1 )) ((2) (let ((e-13 (vector-ref arg-1 3))) e-13)) ((3) (let ((e-18 (vector-ref arg-1 3))) e-18)) ((4) (vector 1 )) (else (vector 1 )))))
(define CoreC-45Normalise-n--9181-8042-u--dumpEnv (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) (lambda (clam-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (let ((e-8 (car arg-8))) (let ((e-9 (cdr arg-8))) (case (vector-ref e-8 0) ((1) (let ((e-12 (vector-ref e-8 2))) (let ((e-13 (vector-ref e-8 3))) (let ((e-14 (vector-ref e-8 4))) (let ((act-1 (CoreC-45Normalise-logTermNFC-39 e-3 arg-6 arg-1 arg-5 (lambda () (string-append arg-4 (string-append ": let " (CoreC-45Name-u--show_Show_Name e-2)))) e-9 e-13 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Normalise-logTermNFC-39 e-3 arg-6 arg-1 arg-5 (lambda () (string-append arg-4 (string-append ":" (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-12) (string-append " " (CoreC-45Name-u--show_Show_Name e-2)))))) e-9 e-14 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((CoreC-45Normalise-n--9181-8042-u--dumpEnv arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-3 e-9) clam-0)))))))))))(else (let ((act-1 (CoreC-45Normalise-logTermNFC-39 e-3 arg-6 arg-1 arg-5 (lambda () (string-append arg-4 (string-append ":" (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega (CoreC-45TTC-45Binder-multiplicity e-8)) (string-append " " (string-append (CoreC-45TTC-45Binder-u--show_Show_C-40PiInfoC-32C-36tC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-3 u--d u--x)))) (CoreC-45TTC-45Binder-piInfo e-8)) (string-append " " (CoreC-45Name-u--show_Show_Name e-2)))))))) e-9 (CoreC-45TTC-45Binder-binderType e-8) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((CoreC-45Normalise-n--9181-8042-u--dumpEnv arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 e-3 e-9) clam-0))))))))))))))
(define CoreC-45Normalise-logEnv (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (cond ((equal? arg-2 "") (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " arg-5))) "\xa;") clam-0))) (vector 1 act-2)))(else (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " arg-5))))) "\xa;") clam-0))) (vector 1 act-2)))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45Normalise-n--9181-8042-u--dumpEnv arg-0 arg-2 arg-6 arg-5 arg-4 arg-1 arg-0 arg-6) clam-0))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define TTImpC-45Unelab-n--8780-9544-u--argVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((5) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Unelab-n--8780-9544-u--argVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) (TTImpC-45Unelab-n--8780-9544-u--argVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4))))) ((0) (let ((e-9 (vector-ref arg-7 3))) (cons e-9 '())))(else '()))))
(define DataC-45List-find (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (box e-2)) (else (DataC-45List-find arg-1 e-3)))))))))
(define TTImpC-45Unelab-n--8780-9550-u--substVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((u--tm (vector 0 e-2 e-3 e-4))) (let ((sc1 (DataC-45List-find (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) (or (and (= e-4 eta-1) 1) 0)) (Builtin-fst eta-0))) arg-7))) (if (null? sc1) u--tm (let ((e-1 (unbox sc1))) (let ((e-6 (cdr e-1))) e-6))))))))) ((2) (let ((e-7 (vector-ref arg-8 1))) (let ((e-8 (vector-ref arg-8 2))) (let ((e-9 (vector-ref arg-8 3))) (let ((e-10 (vector-ref arg-8 4))) (vector 2 e-7 e-8 e-9 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 eta-0)) e-10))))))) ((3) (let ((e-12 (vector-ref arg-8 1))) (let ((e-13 (vector-ref arg-8 2))) (let ((e-14 (vector-ref arg-8 3))) (let ((e-15 (vector-ref arg-8 4))) (vector 3 e-12 e-13 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 eta-0)) e-14) (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (clam-0) (let ((e-2 (car clam-0))) (let ((e-3 (cdr clam-0))) (cons (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc2 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) eta-0)))) e-2) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-3))))))) arg-7) e-15))))))) ((4) (let ((e-17 (vector-ref arg-8 1))) (let ((e-18 (vector-ref arg-8 2))) (let ((e-19 (vector-ref arg-8 3))) (vector 4 e-17 (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-18) (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-19)))))) ((5) (let ((e-21 (vector-ref arg-8 1))) (let ((e-22 (vector-ref arg-8 2))) (let ((e-23 (vector-ref arg-8 3))) (let ((e-24 (vector-ref arg-8 4))) (vector 5 e-21 e-22 e-23 (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-24))))))) ((6) (let ((e-26 (vector-ref arg-8 1))) (let ((e-27 (vector-ref arg-8 2))) (let ((e-28 (vector-ref arg-8 3))) (vector 6 e-26 e-27 (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-28)))))) ((7) (let ((e-30 (vector-ref arg-8 1))) (let ((e-31 (vector-ref arg-8 2))) (let ((e-32 (vector-ref arg-8 3))) (let ((e-33 (vector-ref arg-8 4))) (vector 7 e-30 e-31 (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-32) (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-33))))))) ((8) (let ((e-35 (vector-ref arg-8 1))) (let ((e-36 (vector-ref arg-8 2))) (let ((e-37 (vector-ref arg-8 3))) (vector 8 e-35 e-36 (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-37))))))(else arg-8))))
(define TTImpC-45Unelab-n--8780-9549-u--substArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9) (let ((u--substsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (clam-0) (let ((e-2 (car clam-0))) (let ((e-3 (cdr clam-0))) (cons (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) eta-0) e-2) (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc1))) ((((e-4 'erased) 'erased) arg-7) e-3))))))) arg-8))) (TTImpC-45Unelab-n--8780-9550-u--substVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--substsC-39 arg-9))))
(define TTImpC-45Unelab-case--unelabCaseC-44mkClause-9975 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox arg-14))) (let ((u--rhs (TTImpC-45Unelab-n--8780-9549-u--substArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-6) (DataC-45List-u--zip_Zippable_List (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Unelab-n--8780-9544-u--argVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0)) arg-13) arg-10) arg-9))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-6 arg-5 "unelab.case.clause" 20 (lambda () "Unelaborating LHS") e-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (TTImpC-45Unelab-unelabTy arg-6 arg-5 (vector 0 ) arg-4 arg-7 e-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-logTerm (PreludeC-45TypesC-45List-tailRecAppend arg-6 arg-0) arg-5 "unelab.case.clause" 20 (lambda () "Unelaborating RHS") u--rhs eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Normalise-logEnv arg-6 arg-5 "unelab.case.clause" 20 "In Env" arg-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (TTImpC-45Unelab-unelabTy (PreludeC-45TypesC-45List-tailRecAppend arg-6 arg-0) arg-5 (vector 0 ) arg-4 (CoreC-45Env-C-43C-43 arg-6 arg-7 arg-3) u--rhs eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box (vector 0 arg-12 (Builtin-fst e-6) (Builtin-fst e-9))))))) eff-0) eta-1)))))))))))))) eff-0) eta-0))))))))))))))
(define TTImpC-45Unelab-n--8780-9548-u--mkClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45ContextC-45Log-logTerm e-2 arg-5 "unelab.case.clause" 20 (lambda () "Unelaborating clause") e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((u--patArgs (Builtin-snd (CoreC-45TTC-45Term-getFnArgs e-10)))) ((TTImpC-45Unelab-case--unelabCaseC-44mkClause-9975 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-6 e-10 e-11 arg-8 arg-7 arg-6 u--patArgs (TTImpC-45Unelab-n--8780-9546-u--idxOrMaybe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 u--patArgs)) clam-0))))))))))))))
(define TTImpC-45Unelab-case--unelabCaseC-44mkCase-10178 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox arg-9))) (let ((u--fc (CoreC-45TTC-45Term-getLoc e-1))) (lambda (eta-0) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-5 (vector 0 ) arg-4 arg-3 e-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (PreludeC-45Interfaces-sequence csegen-255 (vector csegen-1501 csegen-14 (lambda (u--b) (lambda (u--a) (lambda (u--f) (lambda (i_con-0) (lambda (arg-14093) (lambda (arg-14100) (PreludeC-45Types-u--traverse_Traversable_List i_con-0 arg-14093 arg-14100)))))))) e-6)))))) (CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45Unelab-n--8780-9548-u--mkClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--fc arg-7 arg-6 eta-1)) arg-8 '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-4 (unbox e-6))) (vector 1 (box (vector 4 u--fc '() e-2 (vector 32 u--fc 0) e-4)))))))) eff-0) clam-0))))))))) eff-0) eta-0)))))))))))
(define TTImpC-45Unelab-n--8780-9547-u--mkCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((sc0 (PreludeC-45Types-u--null_Foldable_List arg-8))) (cond ((equal? sc0 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-log arg-5 "unelab.case.clause" 20 (lambda () (DataC-45String-unwords (cons "Ignoring" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 eta-0)) arg-8)))) ext-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((TTImpC-45Unelab-case--unelabCaseC-44mkCase-10178 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8 arg-7 arg-6 (TTImpC-45Unelab-n--8780-9546-u--idxOrMaybe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8)) ext-0))))))
(define TTImpC-45Unelab-case--caseC-32blockC-32inC-32unelabCase-10409 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((1) (let ((e-1 (vector-ref arg-9 2))) (let ((e-2 (vector-ref arg-9 3))) (let ((e-4 (vector-ref arg-9 5))) (let ((sc1 (TTImpC-45Unelab-n--8780-9545-u--findArgPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2))) (if (null? sc1) (lambda (eta-0) (vector 1 '())) (let ((e-5 (unbox sc1))) (lambda (clam-0) (let ((sc2 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-1) (PreludeC-45TypesC-45List-lengthTR e-1)) 1) 0))) (cond ((equal? sc2 1) (TTImpC-45Unelab-n--8780-9547-u--mkCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4 e-5 arg-1 clam-0)) (else (vector 1 '()))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45Unelab-unelabCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-4 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (TTImpC-45Unelab-case--caseC-32blockC-32inC-32unelabCase-10409 arg-0 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45Unelab-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32unelabTyC-39-11771 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (lambda (clam-0) (if (null? arg-17) (vector 1 '()) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 3))) (let ((act-1 (CoreC-45Context-getFullName arg-8 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-8 0) ((0) (let ((e-1 (vector-ref e-8 2))) (lambda (clam-1) (case (vector-ref e-1 0) ((6) (TTImpC-45Unelab-unelabCase arg-0 arg-8 arg-6 arg-5 e-8 e-3 clam-1))(else (vector 1 '()))))))(else (lambda (eta-0) (vector 1 '())))))) eff-0) clam-0)))))))(else (vector 1 '())))))))))
(define TTImpC-45Unelab-unelabTyC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 3))) (let ((u--nm (CoreC-45TTC-45Var-nameAt arg-0 e-4))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "unelab.case" 20 (lambda () (string-append "Found local name: " (CoreC-45Name-u--show_Show_Name u--nm))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((u--ty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 (CoreC-45TTC-45Binder-binderType (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-0 e-4 arg-4))))) (vector 1 (cons (vector 0 e-2 (vector (box (vector 0 )) u--nm u--nm)) u--ty))))))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact e-9 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (case (vector-ref arg-2 0) ((2) (vector 1 (cons (vector 32 e-7 1) (CoreC-45NormaliseC-45Eval-gErased e-7))))(else (vector 1 (cons (vector 0 e-7 (vector (box e-8) e-9 e-9)) (CoreC-45NormaliseC-45Eval-gErased e-7))))) (let ((e-1 (unbox e-6))) (let ((act-3 (CoreC-45Context-getFullName arg-1 e-9 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (case (vector-ref arg-2 0) ((1) (vector 1 e-10))(else (CoreC-45Context-aliasName arg-1 e-10 eta-2))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "unelab.var" 50 (lambda () (DataC-45String-unwords (cons "Found name:" (cons (CoreC-45Name-u--show_Show_Name e-9) (cons (string-append " (aka " (string-append (CoreC-45Name-u--show_Show_Name e-10) ")")) (cons "sugared to" (cons (CoreC-45Name-u--show_Show_Name e-11) '()))))))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 0 e-7 (vector (box e-8) e-10 e-11)) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 e-1))))))))) eff-0) eta-2)))))))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--mkn (CoreC-45Name-nameRoot e-12))) (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-13) (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--term (if (null? e-6) (vector 30 e-11 u--mkn) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((8) (let ((e-3 (vector-ref e-1 2))) (vector 12 e-11 e-3)))(else (vector 30 e-11 u--mkn))))))) (lambda (eta-2) (let ((act-3 (CoreC-45Context-lookupTyExact (vector 8 e-13) (let ((e-0 (vector-ref e-5 0))) e-0) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (case (vector-ref arg-2 0) ((2) (vector 1 (cons (vector 32 e-11 1) (CoreC-45NormaliseC-45Eval-gErased e-11))))(else (vector 1 (cons u--term (CoreC-45NormaliseC-45Eval-gErased e-11))))) (let ((e-1 (unbox e-7))) (vector 1 (cons u--term (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 e-1)))))))) eff-0) eta-2))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 (TTImpC-45Unelab-unelabTy (cons e-17 arg-0) arg-1 arg-2 arg-3 (cons e-18 arg-4) e-19 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (cond ((equal? e-0 1) (let ((u--xC-39 (TTImpC-45Unelab-n--8845-11329-u--uniqueLocal arg-0 e-17 e-19 e-18 e-16 arg-4 arg-3 arg-2 arg-1 arg-0 e-17))) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Unelab-unelabBinder arg-0 arg-1 arg-2 arg-3 e-16 arg-4 u--xC-39 e-18 (CoreC-45NameC-45Scoped-compat csegen-2277 e-19) e-2 (CoreC-45NameC-45Scoped-compat csegen-2277 e-6) eta-2)))) eff-0) eta-1))))))))(else (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Unelab-unelabBinder arg-0 arg-1 arg-2 arg-3 e-16 arg-4 e-17 e-18 e-19 e-2 e-6 eta-2)))) eff-0) eta-1))))))))))(else (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45Unelab-unelabBinder arg-0 arg-1 arg-2 arg-3 e-16 arg-4 e-17 e-18 e-19 e-2 e-6 eta-2)))) eff-0) eta-1)))))))))))) eff-0) eta-0))))))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-4 e-22 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--tm (vector 4 e-21 e-22 e-23))) (lambda (clam-2) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (TTImpC-45Unelab-unelabTy arg-0 arg-1 arg-2 arg-3 arg-4 e-23 clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-3))) (lambda (clam-3) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-3) clam-3))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((_-1 (cons e-7 e-4))) (case (vector-ref arg-2 0) ((1) (vector 1 '())) ((2) (vector 1 '()))(else ((TTImpC-45Unelab-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32unelabTyC-39-11771 arg-0 e-23 e-22 e-21 u--tm arg-4 arg-3 arg-2 arg-1 e-2 e-3 _-0 e-7 e-4 _-1 e-8 e-9 (CoreC-45TTC-45Term-getFnArgs u--tm)) eta-2)))))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (if (null? e-10) (case (vector-ref e-8 0) ((0) (let ((e-13 (vector-ref e-8 2))) (let ((e-12 (vector-ref e-8 3))) (let ((e-11 (vector-ref e-8 4))) (lambda (clam-4) (case (vector-ref e-12 0) ((2) (let ((e-15 (vector-ref e-12 3))) (case (vector-ref e-15 0) ((1) (let ((act-6 (((e-11 e-9) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-4 e-23)) clam-4))) (case (vector-ref act-6 0) ((0) (let ((e-18 (vector-ref act-6 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (vector 8 e-21 e-2 e-7) (CoreC-45Normalise-glueBack arg-1 arg-0 e-9 arg-4 e-18)))))) eff-0) clam-4))))))(else (let ((act-6 (((e-11 e-9) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-4 e-23)) clam-4))) (case (vector-ref act-6 0) ((0) (let ((e-18 (vector-ref act-6 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (vector 10 e-21 e-2 e-13 e-7) (CoreC-45Normalise-glueBack arg-1 arg-0 e-9 arg-4 e-18)))))) eff-0) clam-4)))))))))(else (vector 1 (cons (vector 8 e-21 e-2 e-7) (CoreC-45NormaliseC-45Eval-gErased e-21))))))))))(else (lambda (eta-3) (vector 1 (cons (vector 8 e-21 e-2 e-7) (CoreC-45NormaliseC-45Eval-gErased e-21)))))) (let ((e-11 (unbox e-10))) (lambda (eta-3) (vector 1 (cons e-11 (CoreC-45NormaliseC-45Eval-gErased e-21)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-3))))))))))) eff-0) clam-2))))))))))) eff-0) eta-0)))))))))) ((5) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (let ((e-28 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-27) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-2 (car e-5))) (let ((act-2 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-28) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (lambda (clam-3) (case (vector-ref e-2 0) ((0) (let ((e-8 (vector-ref e-2 2))) (case (vector-ref arg-2 0) ((1) (vector 1 (cons (vector 18 e-25 (CoreC-45TTC-45Term-getLoc e-27) e-26 (let ((e-9 (vector-ref e-8 2))) e-9) e-7) e-4)))(else (vector 1 (cons e-7 e-4))))))(else (vector 1 (cons e-7 e-4))))))))) eff-0) clam-5))))))))) eff-0) eta-0))))))))))) ((6) (let ((e-30 (vector-ref arg-5 1))) (let ((e-31 (vector-ref arg-5 2))) (let ((e-32 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-32) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-7) (let ((e-2 (car e-5))) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 20 e-30 e-31 e-2) (CoreC-45NormaliseC-45Eval-gErased e-30)))))) eff-0) clam-7)))))))) eff-0) eta-0)))))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-37 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-37) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-8) (let ((e-2 (car e-5))) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 21 e-34 e-2) (CoreC-45NormaliseC-45Eval-gErased e-34)))))) eff-0) clam-8)))))))) eff-0) eta-0))))))))) ((8) (let ((e-39 (vector-ref arg-5 1))) (let ((e-41 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-41) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-9) (let ((e-2 (car e-5))) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 22 e-39 e-2) (CoreC-45NormaliseC-45Eval-gErased e-39)))))) eff-0) clam-9)))))))) eff-0) eta-0))))))))) ((9) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (cons (vector 28 e-43 e-44) (CoreC-45NormaliseC-45Eval-gErased e-43))))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (case (vector-ref e-47 0) ((2) (let ((e-52 (vector-ref e-47 1))) (TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-52)))(else (lambda (eta-0) (vector 1 (cons (vector 32 e-46 1) (CoreC-45NormaliseC-45Eval-gErased e-46))))))))) (else (let ((e-49 (vector-ref arg-5 1))) (lambda (eta-0) (vector 1 (cons (vector 29 e-49) (CoreC-45NormaliseC-45Eval-gType e-49 (vector 2 "top" 0))))))))))
(define TTImpC-45Unelab-unelabTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((TTImpC-45Unelab-unelabTyC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45Unelab-dropParams arg-1 arg-3 e-5))) eff-0) ext-0)))))))
(define TTImpC-45Unelab-n--13643-13594-u--showNScope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) "[no locals in scope]" (string-append "[locals in scope: " (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) (DataC-45List-nub csegen-832 arg-8))) "]")))))
(define TTImpC-45Unelab-n--13643-13596-u--toName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-4 (vector-ref arg-8 3))) (box (CoreC-45TTC-45Var-nameAt arg-0 e-4))))(else '()))))
(define TTImpC-45Unelab-n--13643-13595-u--showScope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (string-append " " (TTImpC-45Unelab-n--13643-13594-u--showNScope arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (TTImpC-45Unelab-n--13643-13596-u--toName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-8)))))
(define TTImpC-45Unelab-unelabNest (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((u--mkn (string-append (CoreC-45Name-nameRoot e-2) (TTImpC-45Unelab-n--13643-13595-u--showScope arg-0 e-4 e-3 e-2 e-1 arg-3 arg-2 arg-1 e-4)))) (lambda (eta-0) (vector 1 (vector 30 e-1 u--mkn)))))))))(else (lambda (eta-0) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 0 ) arg-2 arg-3 arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (Builtin-fst e-5))))) eff-0) eta-0))))))))))
(define TTImpC-45Unelab-unelab (lambda (arg-0 arg-1 ext-0 ext-1) (TTImpC-45Unelab-unelabNest arg-0 arg-1 '() ext-0 ext-1)))
(define IdrisC-45Resugar-resugar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((TTImpC-45Unelab-unelab arg-0 arg-1 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-toCleanPTerm arg-1 arg-2 IdrisC-45Resugar-startPrec e-5 eta-0)))) eff-0) ext-0)))))))
(define IdrisC-45Error-pshow (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-5 arg-3 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-3 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (IdrisC-45Error-pShowMN arg-0 e-6 arg-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-3) (vector 6 eta-3)) e-7)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Error-pshowNoNorm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-3 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45Error-pShowMN arg-0 arg-4 arg-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-2) (vector 6 eta-2)) e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))
(define CoreC-45Context-n--10847-6815-u--hlookup (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 1) '()) (else (LibrariesC-45DataC-45NameMap-lookup arg-3 arg-4)))))
(define CoreC-45Context-n--10847-6817-u--resn (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) e-6))))
(define CoreC-45Context-n--10847-6816-u--lookupPossibles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-reverse arg-3))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (CoreC-45Context-n--10847-6815-u--hlookup arg-0 arg-1 arg-2 e-4 (let ((e-10 (vector-ref arg-0 10))) e-10)))) (if (null? sc2) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 e-5) arg-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-6) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 arg-3 e-3) (let ((e-1 (unbox e-6))) (let ((sc5 (let ((sc6 (CoreC-45Name-matches arg-1 e-4))) (cond ((equal? sc6 1) (let ((sc7 (PreludeC-45Types-elem csegen-14 csegen-223 e-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45Context-n--10847-6817-u--resn arg-0 arg-1 arg-2 eta-1)) arg-3)))) (cond ((equal? sc7 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc5 1) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 (cons (cons e-4 (cons e-5 e-1)) arg-3) e-3)) (else (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 arg-3 e-3)))))))) eff-0) eta-0)))))) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 arg-3 e-3)))))) (else (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (let ((sc2 (CoreC-45Context-n--10847-6815-u--hlookup arg-0 arg-1 arg-2 e-7 (let ((e-10 (vector-ref arg-0 10))) e-10)))) (if (null? sc2) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 e-8) arg-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 arg-3 e-3) (let ((e-1 (unbox e-5))) (let ((sc5 (let ((sc6 (CoreC-45Name-matches arg-1 e-6))) (cond ((equal? sc6 1) (let ((sc7 (PreludeC-45Types-elem csegen-14 csegen-223 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45Context-n--10847-6817-u--resn arg-0 arg-1 arg-2 eta-1)) arg-3)))) (cond ((equal? sc7 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc5 1) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 (cons (cons e-7 (cons e-8 e-1)) arg-3) e-3)) (else (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 arg-3 e-3)))))))) eff-0) eta-0)))))) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 arg-3 e-3)))))))))))))
(define CoreC-45Context-case--lookupCtxtNameC-39-7209 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExactI arg-1 arg-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (cons (cons arg-1 (cons e-7 e-6)) '()))))))))) eff-0) eta-0)))))) (let ((e-2 (unbox arg-3))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 (let ((e-3 (vector-ref arg-0 3))) e-3)))) (if (null? sc1) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc1))) (CoreC-45Context-n--10847-6816-u--lookupPossibles arg-0 arg-1 arg-2 '() e-1))))))))
(define CoreC-45Context-lookupCtxtNameC-39 (lambda (arg-0 arg-1 arg-2) (CoreC-45Context-case--lookupCtxtNameC-39-7209 arg-2 arg-1 arg-0 (CoreC-45Name-userNameRoot arg-1))))
(define CoreC-45Context-lookupCtxtName (lambda (ext-0 ext-1) (CoreC-45Context-lookupCtxtNameC-39 0 ext-0 ext-1)))
(define CoreC-45NameC-45Namespace-numNS (CoreC-45NameC-45Namespace-mkNamespace "Prelude.Num"))
(define IdrisC-45DocC-45String-prettyKindedName (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (unbox arg-0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-2)) arg-1)))))
(define IdrisC-45DocC-45String-case--prettyName-9885 (lambda (arg-0 arg-1) (if (null? arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Name-nameRoot arg-0)) (let ((e-2 (unbox arg-1))) (let ((sc1 (CoreC-45Name-isOpUserName e-2))) (cond ((equal? sc1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2733 e-2))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2733 e-2))))))))
(define IdrisC-45DocC-45String-prettyName (lambda (arg-0) (IdrisC-45DocC-45String-case--prettyName-9885 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define CoreC-45ContextC-45Context-defNameType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) (box (vector 1 ))) ((2) (box (vector 1 ))) ((3) (box (vector 1 ))) ((4) (box (vector 1 ))) ((5) (let ((e-10 (vector-ref arg-0 1))) (let ((e-11 (vector-ref arg-0 2))) (box (vector 2 e-10 e-11))))) ((6) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (box (vector 3 e-13 e-14))))) ((7) (box (vector 1 ))) ((8) '()) ((9) '()) ((10) (box (vector 0 ))) ((11) '()) (else '()))))
(define CoreC-45ContextC-45Context-gDefKindedName (lambda (arg-0) (let ((u--nm (let ((e-1 (vector-ref arg-0 1))) e-1))) (vector (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref arg-0 18))) e-18)) u--nm u--nm))))
(define IdrisC-45Pretty-showCategory (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-annotateM (PreludeC-45Types-u--map_Functor_Maybe arg-1 (IdrisC-45Pretty-kindAnn (CoreC-45ContextC-45Context-gDefKindedName arg-2))))))
(define CoreC-45TT-defaultKindedName (lambda (arg-0) (vector '() arg-0 arg-0)))
(define CoreC-45Core-filterM (lambda (arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((eff-0 (arg-1 e-2))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (cond ((equal? e-5 1) (let ((eff-1 (CoreC-45Core-filterM arg-1 e-3))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-2 (lambda (eta-0) (vector 1 (cons e-2 e-6))))) eff-2) world-1)))))))) (else (CoreC-45Core-filterM arg-1 e-3))))) eff-1) world-0))))))))))))
(define CoreC-45Context-n--26357-21657-u--direct (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (Builtin-snd ext-0)))
(define CoreC-45Context-n--26357-21658-u--isDefault (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (Builtin-snd ext-0)))
(define CoreC-45Context-isHidden (lambda (arg-0 arg-1) (DataC-45Maybe-isJust (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-10 (vector-ref arg-1 10))) e-10)))))
(define CoreC-45Context-n--26357-21659-u--notHidden (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 ext-0) (let ((e-2 (car arg-5))) (let ((act-1 (CoreC-45Context-toFullNames arg-3 csegen-54 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((sc2 (CoreC-45Context-isHidden e-5 arg-6))) (cond ((equal? sc2 1) 0) (else 1))))))) eff-0) ext-0))))))))
(define CoreC-45Context-getSearchData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 eta-1)) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((6) (let ((e-11 (vector-ref e-1 4))) (let ((e-10 (vector-ref e-1 5))) (lambda (eta-1) (let ((act-3 (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc5 (LibrariesC-45DataC-45NameMap-lookup e-12 (let ((e-38 (vector-ref e-5 7))) e-38)))) (if (null? sc5) (lambda (eta-2) (vector 1 '())) (let ((e-13 (unbox sc5))) (CoreC-45Core-filterM (lambda (u--x) (lambda (eta-2) (CoreC-45Context-n--26357-21659-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-2))) e-13)))))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? arg-2 1) (let ((act-4 ((CoreC-45Core-filterM (lambda (u--x) (lambda (eta-2) (let ((act-4 (CoreC-45Context-n--26357-21659-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (let ((sc7 (CoreC-45Context-n--26357-21658-u--isDefault arg-3 arg-2 arg-1 arg-0 u--x))) (cond ((equal? sc7 1) e-13) (else 0))))))) eff-0) eta-2))))))) (LibrariesC-45DataC-45NameMap-toList (let ((e-37 (vector-ref e-5 8))) e-37))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--defns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-13))) (lambda (eta-2) (vector 1 (cons '() (cons (cons 0 u--defns) '()))))))) eff-0) clam-0)))))) (else (let ((act-4 ((CoreC-45Core-filterM (lambda (u--x) (lambda (eta-2) (CoreC-45Context-n--26357-21659-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-2))) (LibrariesC-45DataC-45NameMap-toList (let ((e-36 (vector-ref e-5 9))) e-36))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--opens (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-13))) (lambda (eta-2) (let ((act-5 ((CoreC-45Core-filterM (lambda (u--x) (lambda (eta-3) (let ((act-5 (CoreC-45Context-n--26357-21659-u--notHidden arg-3 arg-2 arg-1 arg-0 u--x (let ((e-0 (vector-ref e-5 0))) e-0) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (let ((sc8 (CoreC-45Context-n--26357-21658-u--isDefault arg-3 arg-2 arg-1 arg-0 u--x))) (cond ((equal? sc8 1) 0) (else e-14))))))) eff-0) eta-3))))))) (LibrariesC-45DataC-45NameMap-toList (let ((e-38 (vector-ref e-5 8))) e-38))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--autos (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) e-14))) (let ((u--tyhs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-3) (CoreC-45Context-n--26357-21657-u--direct arg-3 arg-2 arg-1 arg-0 eta-3)) e-12)))) (let ((u--chasers (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-3) (let ((sc8 (CoreC-45Context-n--26357-21657-u--direct arg-3 arg-2 arg-1 arg-0 eta-3))) (cond ((equal? sc8 1) 0) (else 1)))) e-12)))) (lambda (eta-3) (vector 1 (cons e-11 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-4) (DataC-45List-isCons (Builtin-snd eta-4))) (cons (cons 0 u--opens) (cons (cons 0 u--autos) (cons (cons (let ((sc8 (let ((e-0 (car e-10))) e-0))) (cond ((equal? sc8 1) 0) (else 1))) u--tyhs) (cons (cons 1 u--chasers) '()))))))))))))) eff-0) eta-2))))))))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))))(else (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Resugar-pterm (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45Resugar-toCleanPTerm arg-0 arg-1 IdrisC-45Resugar-startPrec arg-2 ext-0)))
(define IdrisC-45DocC-45Annotations-dCon (lambda (arg-0 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 2 (box arg-0))) ext-0)))
(define IdrisC-45DocC-45String-prettyType (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-1 '() e-5 '() arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-1 csegen-68 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (IdrisC-45Resugar-resugar '() arg-1 arg-2 '() e-7 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 arg-3 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-n--12935-10842-u--reflowDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 eta-0))) (DataC-45String-lines arg-6))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getDConDoc-11049 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (vector 1 arg-13)) (let ((e-1 (car arg-14))) (let ((e-2 (cdr arg-14))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-13)) (let ((e-6 (cdr e-1))) (cond ((equal? e-6 "") (lambda (clam-0) (if (null? e-2) (vector 1 arg-13) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-13 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--12935-10842-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-13)))))(else (lambda (clam-1) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-13 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--12935-10842-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-13))))))))))))
(define IdrisC-45DocC-45String-n--12935-10832-u--getDConDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (let ((act-3 (let ((act-3 (unbox arg-3))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (IdrisC-45DocC-45String-prettyType arg-4 arg-3 (lambda (eta-2) (vector 6 eta-2)) (let ((e-2 (vector-ref e-1 2))) e-2) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--conWithTypeDoc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 arg-7) (cond ((equal? arg-6 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45Annotations-dCon arg-7 (IdrisC-45DocC-45String-prettyName arg-7)) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (cons e-8 '()))))) (else (IdrisC-45DocC-45Annotations-dCon arg-7 (IdrisC-45DocC-45String-prettyName arg-7))))))) (let ((_-0 (box e-1))) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getDConDoc-11049 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 e-1 _-0 e-7 e-8 u--conWithTypeDoc (LibrariesC-45DataC-45ANameMap-lookupName arg-7 (let ((e-13 (vector-ref e-7 7))) e-13))))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-n--12935-10838-u--getImplDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-3 (IdrisC-45DocC-45String-prettyType arg-4 arg-3 (lambda (eta-1) (vector 6 eta-1)) (let ((e-2 (vector-ref e-1 2))) e-2) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 arg-6) e-7) '()))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-methodsConfig (vector 1 0 1 0))
(define IdrisC-45DocC-45String-n--12935-10840-u--getMethDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (LibrariesC-45DataC-45ANameMap-lookupName (let ((e-0 (vector-ref arg-6 0))) e-0) (let ((e-7 (vector-ref e-5 7))) e-7)))) (if (null? sc1) (vector 1 '()) (let ((e-1 (car sc1))) (let ((e-2 (cdr sc1))) (if (null? e-2) (PreludeC-45IO-u--map_Functor_IO csegen-3165 (IdrisC-45DocC-45String-n--12935-10843-u--showDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 IdrisC-45DocC-45String-methodsConfig e-1) clam-0) (vector 1 '()))))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-11892 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) '() (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (if (null? e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Implementation")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) e-2)) '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3146 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 arg-16))) '()))) '())))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-12048 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) '() (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Methods")) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 arg-13))) '()))) '()))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-12209 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Parameters")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 arg-8)))) '()))))
(define IdrisC-45DocC-45String-n--12935-10837-u--getIFaceDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((u--params (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-12209 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 (let ((e-7 (vector-ref e-3 2))) e-7)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-pterm arg-4 arg-3 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-3) (CoreC-45TT-defaultKindedName eta-3)) eta-1) eta-2))) (let ((e-6 (vector-ref e-3 3))) e-6) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--constraints (if (null? e-5) '() (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Constraints")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-2) (vector 6 eta-2)) eta-1)) e-5)))) '())))) (lambda (eta-1) (let ((act-2 (let ((act-2 (CoreC-45Context-toFullNames arg-4 csegen-54 (let ((e-0 (vector-ref e-3 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (CoreC-45Name-dropNS e-6))) (case (vector-ref sc3 0) ((1) (let ((act-3 (IdrisC-45DocC-45String-n--12935-10832-u--getDConDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 e-6 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-3136 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) e-7)) '()))))) eff-0) clam-0))))))(else (vector 1 '()))))))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45DocC-45String-n--12935-10840-u--getMethDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-3 eta-4))) (let ((e-4 (vector-ref e-3 4))) e-4) '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--meths (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-12048 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 u--params e-5 u--constraints e-6 e-7 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-3) eta-3) e-7)))) (lambda (eta-3) (let ((act-4 (CoreC-45Context-getSearchData arg-4 arg-2 0 e-2 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (let ((e-1 (cdr e-8))) (if (null? e-1) (vector 1 '()) (let ((e-9 (car e-1))) (let ((e-10 (cdr e-9))) ((CoreC-45Core-traverseC-39 (lambda (eta-5) (lambda (eta-6) (IdrisC-45DocC-45String-n--12935-10838-u--getImplDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-5 eta-6))) e-10 '()) eta-4))))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--insts (IdrisC-45DocC-45String-case--getDocsForNameC-44getIFaceDoc-11892 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-3 u--params e-5 u--constraints e-6 e-7 u--meths e-8 e-9 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-5) eta-5) e-9)))) (lambda (eta-5) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend u--params (PreludeC-45TypesC-45List-tailRecAppend u--constraints (PreludeC-45TypesC-45List-tailRecAppend e-6 (PreludeC-45TypesC-45List-tailRecAppend u--meths u--insts)))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))))
(define CoreC-45TTC-45Binder-u--foldr_Foldable_PiInfo (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) arg-3) ((1) arg-3) ((2) arg-3) (else (let ((e-4 (vector-ref arg-4 1))) ((arg-2 e-4) arg-3))))))
(define CoreC-45TTC-45Binder-u--foldr_Foldable_Binder (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (CoreC-45TTC-45Binder-u--foldr_Foldable_PiInfo arg-2 ((arg-2 e-4) arg-3) e-3)))) ((1) (let ((e-8 (vector-ref arg-4 3))) (let ((e-9 (vector-ref arg-4 4))) ((arg-2 e-8) ((arg-2 e-9) arg-3))))) ((2) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (CoreC-45TTC-45Binder-u--foldr_Foldable_PiInfo arg-2 ((arg-2 e-14) arg-3) e-13)))) ((3) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (CoreC-45TTC-45Binder-u--foldr_Foldable_PiInfo arg-2 ((arg-2 e-19) arg-3) e-18)))) ((4) (let ((e-23 (vector-ref arg-4 3))) (let ((e-24 (vector-ref arg-4 4))) ((arg-2 e-23) ((arg-2 e-24) arg-3))))) (else (let ((e-28 (vector-ref arg-4 3))) ((arg-2 e-28) arg-3))))))
(define CoreC-45TTC-45Binder-u--foldMap_Foldable_Binder (lambda (arg-2 arg-3 ext-0) (CoreC-45TTC-45Binder-u--foldr_Foldable_Binder (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-2))) ((e-1 (arg-3 eta-0)) eta-1)))) (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define CoreC-45TTC-45Traversals-n--5150-7234-u--gos (lambda (arg-2 arg-3 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (CoreC-45TTC-45Traversals-n--5150-7234-u--gos arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 arg-5 e-2) e-3))))))
(define CoreC-45TTC-45Traversals-n--5150-7233-u--go (lambda (arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) arg-5) ((1) (let ((e-9 (vector-ref arg-6 3))) (let ((e-1 (car arg-2))) ((e-1 arg-5) (arg-3 e-9))))) ((2) (let ((e-14 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5150-7234-u--gos arg-2 arg-3 arg-5 e-14))) ((3) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 (let ((e-1 (car arg-2))) ((e-1 arg-5) (CoreC-45TTC-45Binder-u--foldMap_Foldable_Binder arg-2 (lambda (eta-0) (CoreC-45TTC-45Traversals-onPRefs arg-2 arg-3 eta-0)) e-18))) e-19)))) ((4) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 arg-5 e-22) e-23)))) ((5) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 arg-5 e-27) e-28)))) ((6) (let ((e-32 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 arg-5 e-32))) ((7) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 arg-5 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 arg-5 e-41))) ((9) arg-5) ((10) arg-5) (else arg-5))))
(define CoreC-45TTC-45Traversals-onPRefs (lambda (arg-2 arg-3 ext-0) (CoreC-45TTC-45Traversals-n--5150-7233-u--go arg-2 arg-3 (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define LibrariesC-45DataC-45NameMap-singleton (lambda (arg-1 arg-2) (cons 0 (vector 0 arg-1 arg-2))))
(define LibrariesC-45DataC-45NameMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List csegen-793 eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45NameMap-n--6554-12541-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-listBind (LibrariesC-45DataC-45NameMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45NameMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45NameMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45NameMap-insertFrom (LibrariesC-45DataC-45NameMap-n--6554-12541-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45NameMap-merge (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45NameMap-mergeWith (lambda (eta-0) (lambda (eta-1) ((arg-1 eta-0) eta-1))) ext-0 ext-1)))
(define LibrariesC-45DataC-45NameMap-u--C-60C-43C-62_Semigroup_C-40NameMapC-32C-36vC-41 (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45NameMap-merge arg-1 ext-0 ext-1)))
(define LibrariesC-45DataC-45NameMap-u--neutral_Monoid_C-40NameMapC-32C-36vC-41 (lambda (arg-1) LibrariesC-45DataC-45NameMap-empty))
(define CoreC-45TTC-45Traversals-allGlobals (lambda (ext-0) (CoreC-45TTC-45Traversals-onPRefs (cons (lambda (arg-8474) (lambda (arg-8477) (LibrariesC-45DataC-45NameMap-u--C-60C-43C-62_Semigroup_C-40NameMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))) arg-8474 arg-8477))) (LibrariesC-45DataC-45NameMap-u--neutral_Monoid_C-40NameMapC-32C-36vC-41 (lambda (eta-0) (lambda (eta-1) (vector 0 ))))) (lambda (u--n) (LibrariesC-45DataC-45NameMap-singleton u--n (vector 0 ))) ext-0)))
(define LibrariesC-45DataC-45NameMap-values (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (LibrariesC-45DataC-45NameMap-toList ext-0))))
(define IdrisC-45DocC-45String-case--getImplDocs-10310 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Hint")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) e-2)) '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3153 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 arg-5))) '()))) '())))))))
(define IdrisC-45DocC-45String-getImplDocs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((PreludeC-45Basics-flip csegen-1298 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) (LibrariesC-45DataC-45NameMap-values (let ((e-7 (vector-ref e-5 7))) e-7))) (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-1 (unbox e-6))) (lambda (clam-1) (let ((sc4 (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref e-1 18))) e-18)))) (if (null? sc4) (vector 1 '()) (let ((e-4 (unbox sc4))) (case (vector-ref e-4 0) ((1) (let ((act-3 (let ((act-3 (CoreC-45Normalise-normaliseHoles arg-0 '() e-5 '() (let ((e-27 (vector-ref e-1 2))) e-27) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 csegen-68 e-7 eta-1)))) eff-0) clam-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((arg-2 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-8 1) (let ((act-5 (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-7 clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-3) (vector 6 eta-3)) e-9)) '()))))) eff-0) clam-2)))))) (else (vector 1 '())))))) eff-0) eta-1)))))))) eff-0) clam-1))))))(else (vector 1 '()))))))))))) eff-0) clam-0))))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45DocC-45String-case--getImplDocs-10310 arg-2 arg-1 arg-0 e-5 e-6 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) eta-2) e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define PreludeC-45Show-u--show_Show_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0) "()"))
(define PreludeC-45Show-u--showPrec_Show_C-40C-124UnitC-44MkUnitC-124C-41 (lambda (arg-0 arg-1) (PreludeC-45Show-u--show_Show_C-40C-124UnitC-44MkUnitC-124C-41 arg-1)))
(define LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (string-append "Leaf: " (string-append (CoreC-45Name-u--show_Show_Name e-1) (string-append " -> " (string-append (let ((e-4 (car arg-2))) (e-4 e-2)) "\xa;"))))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (string-append "Branch2: " (string-append (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-5) (string-append "\xa; < " (string-append (CoreC-45Name-u--show_Show_Name e-6) (string-append "\xa;" (string-append (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-7) "\xa;")))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((e-14 (vector-ref arg-3 5))) (string-append "Branch3: " (string-append (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-10) (string-append "\xa; < " (string-append (CoreC-45Name-u--show_Show_Name e-11) (string-append "\xa;" (string-append (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-12) (string-append "\xa; < " (string-append (CoreC-45Name-u--show_Show_Name e-13) (string-append "\xa;" (string-append (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-2 e-14) "\xa;")))))))))))))))))))
(define LibrariesC-45DataC-45NameMap-u--show_Show_C-40NameMapC-32C-36vC-41 (lambda (arg-1 arg-2) (if (null? arg-2) "Empty NameMap" (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (string-append "NameMap M(" (string-append (PreludeC-45Show-u--show_Show_Nat e-2) (string-append "):\xa;" (LibrariesC-45DataC-45NameMap-u--show_Show_C-40C-40TreeC-32C-36nC-41C-32C-36vC-41 arg-1 e-3)))))))))
(define IdrisC-45DocC-45String-getHintsForType (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "doc.data" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Looking at " (cons (CoreC-45Name-u--show_Show_Name arg-2) '())))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (IdrisC-45DocC-45String-getImplDocs arg-0 arg-1 (lambda (u--ty) (let ((u--nms (CoreC-45TTC-45Traversals-allGlobals u--ty))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "doc.data" 10 (lambda () (DataC-45String-fastUnlines (cons (string-append "Candidate: " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() u--ty)) (cons (string-append "Containing names: " (LibrariesC-45DataC-45NameMap-u--show_Show_C-40NameMapC-32C-36vC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124UnitC-44MkUnitC-124C-41 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124UnitC-44MkUnitC-124C-41 u--d u--x)))) u--nms)) '())))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (DataC-45Maybe-isJust (LibrariesC-45DataC-45NameMap-lookup arg-2 u--nms))))))))) ext-0))))))
(define CoreC-45Name-displayName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((sc1 (CoreC-45Name-displayName e-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (box (PreludeC-45Types-maybe (lambda () e-0) (lambda () (lambda (arg-1) (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 arg-1))) e-2)) e-3))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (cons '() (CoreC-45Name-displayUserName e-2)))) ((2) (let ((e-3 (vector-ref arg-0 1))) (cons '() e-3))) ((3) (let ((e-5 (vector-ref arg-0 1))) (CoreC-45Name-displayName e-5))) ((4) (let ((e-7 (vector-ref arg-0 1))) (cons '() e-7))) ((5) (let ((e-10 (vector-ref arg-0 2))) (CoreC-45Name-displayName e-10))) ((6) (let ((e-11 (vector-ref arg-0 1))) (cons '() (string-append "case block in " (PreludeC-45Show-u--show_Show_String e-11))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (cons '() (string-append "with block in " (PreludeC-45Show-u--show_Show_String e-13))))) (else (let ((e-15 (vector-ref arg-0 1))) (cons '() (string-append "$resolved" (PreludeC-45Show-u--show_Show_Int e-15))))))))
(define LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop (lambda (arg-2 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((sc1 (arg-2 e-1))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45NameMap-insert e-1 e-2 arg-4))(else arg-4)))))) ((1) (let ((e-5 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 3))) (LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop arg-2 (LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop arg-2 arg-4 e-5) e-7)))) (else (let ((e-10 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 5))) (LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop arg-2 (LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop arg-2 (LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop arg-2 arg-4 e-10) e-12) e-14))))))))
(define LibrariesC-45DataC-45NameMap-treeFilterBy (lambda (arg-2 ext-0) (LibrariesC-45DataC-45NameMap-n--6727-12711-u--loop arg-2 LibrariesC-45DataC-45NameMap-empty ext-0)))
(define LibrariesC-45DataC-45NameMap-filterBy (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45NameMap-treeFilterBy arg-1 e-3)))))
(define CoreC-45Context-getFieldNames (lambda (arg-0 arg-1) (let ((u--nms (let ((e-2 (vector-ref arg-0 2))) e-2))) (LibrariesC-45DataC-45NameMap-keys (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45NameMap-filterBy eta-0 eta-1))) u--nms (lambda (u--n) (let ((sc0 (CoreC-45Name-isRF u--n))) (if (null? sc0) 0 (let ((e-2 (unbox sc0))) (let ((e-5 (car e-2))) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-5 arg-1)))))))))))
(define IdrisC-45DocC-45Annotations-fun (lambda (arg-0 ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 3 arg-0)) ext-0)))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getFieldDoc-12366 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-12)) (let ((e-1 (car arg-13))) (let ((e-2 (cdr arg-13))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-12)) (let ((e-6 (cdr e-1))) (cond ((equal? e-6 "") (lambda (clam-0) (if (null? e-2) (vector 1 arg-12) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-12 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--12935-10842-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-12)))))(else (lambda (clam-1) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons arg-12 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (IdrisC-45DocC-45String-n--12935-10842-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6)))) '())))) (vector 1 arg-12))))))))))))
(define IdrisC-45DocC-45String-n--12935-10834-u--getFieldDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (vector 1 (vector 0 )) (let ((e-1 (unbox e-7))) (let ((act-4 (IdrisC-45DocC-45String-prettyType arg-4 arg-3 (lambda (eta-2) (vector 6 eta-2)) (let ((e-2 (vector-ref e-1 2))) e-2) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--projDecl (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 arg-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) (IdrisC-45PrettyC-45Annotations-prettyRig (let ((e-24 (vector-ref e-1 7))) e-24))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (IdrisC-45DocC-45Annotations-fun arg-6 (IdrisC-45DocC-45String-prettyName arg-6)) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (cons e-8 '())))))))) (let ((_-0 (box e-1))) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getFieldDoc-12366 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-6 e-1 _-0 e-8 u--projDecl (LibrariesC-45DataC-45ANameMap-lookupName arg-6 (let ((e-13 (vector-ref e-5 7))) e-13))))))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getFieldsDoc-12527 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (if (null? e-2) (lambda (eta-0) (vector 1 '())) (let ((e-5 (unbox e-2))) (let ((u--recNS (CoreC-45NameC-45Namespace-C-60C-46C-62 e-5 (CoreC-45NameC-45Namespace-mkNamespace e-3)))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fields (CoreC-45Context-getFieldNames (let ((e-0 (vector-ref e-6 0))) e-0) u--recNS))) (lambda (clam-0) (if (null? u--fields) (vector 1 '()) (let ((e-7 (car u--fields))) (let ((e-4 (cdr u--fields))) (if (null? e-4) (let ((act-2 (IdrisC-45DocC-45String-n--12935-10834-u--getFieldDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Projection")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) e-8))))))) eff-0) clam-0))))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-n--12935-10834-u--getFieldDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) u--fields '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3141 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 e-8))) '())))))))) eff-0) clam-0))))))))))))) eff-0) eta-0))))))))))))))
(define IdrisC-45DocC-45String-n--12935-10835-u--getFieldsDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (IdrisC-45DocC-45String-case--getDocsForNameC-44getFieldsDoc-12527 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (CoreC-45Name-displayName arg-6))))
(define IdrisC-45DocC-45String-n--12935-10844-u--showTotal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (car arg-6))) (case (vector-ref e-0 0) ((0) '())(else (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-3156 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3158 arg-6)))))))))
(define IdrisC-45DocC-45String-n--12935-10845-u--showVisible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-3154 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3029 arg-6)))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getExtra-12769 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((1) (lambda (eta-0) (vector 1 (cons '() (DataC-45List-catMaybes (cons (IdrisC-45DocC-45String-n--12935-10844-u--showTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-10 (vector-ref arg-6 10))) e-10)) (cons (box (IdrisC-45DocC-45String-n--12935-10845-u--showVisible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref arg-6 9))) e-9)))) '()))))))) ((6) (let ((e-11 (vector-ref arg-9 7))) (let ((u--tot (DataC-45List-catMaybes (cons (IdrisC-45DocC-45String-n--12935-10844-u--showTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-25 (vector-ref arg-6 10))) e-25)) (cons (box (IdrisC-45DocC-45String-n--12935-10845-u--showVisible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-26 (vector-ref arg-6 9))) e-26)))) '()))))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (PreludeC-45Basics-flip (lambda (eta-4) (lambda (eta-5) (lambda (world-0) (let ((act-1 (eta-4 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-1 1))) ((let ((eff-0 (eta-5 e-13))) eff-0) world-0)))))))) eta-2 (eta-1 eta-3))))) (lambda (eta-1) (lambda (eta-2) (IdrisC-45DocC-45String-n--12935-10832-u--getDConDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 eta-1 eta-2))) (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-4 csegen-54 eta-1 eta-2)))) e-11 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (if (null? e-13) (vector 1 (cons (box "data") '())) (let ((e-2 (car e-13))) (let ((e-3 (cdr e-13))) (if (null? e-3) (let ((u--cdoc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-3136 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) e-2)))) (let ((act-2 ((IdrisC-45DocC-45String-n--12935-10835-u--getFieldsDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-14) (vector 1 (cons (box "data") (cons u--cdoc '()))) (let ((e-4 (unbox e-14))) (vector 1 (cons (box "record") (cons u--cdoc (cons e-4 '()))))))))) eff-0) eta-1)))))) (vector 1 (cons (box "data") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3137 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 e-13))) '()))) '()))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45DocC-45String-getHintsForType arg-4 arg-3 arg-7 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (let ((e-2 (car e-14))) (let ((e-3 (cdr e-14))) (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend u--tot (PreludeC-45TypesC-45List-tailRecAppend e-3 e-15))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))(else csegen-3139))))
(define IdrisC-45DocC-45String-n--12935-10833-u--getExtra (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (LibrariesC-45DataC-45ANameMap-lookupName arg-6 (let ((e-12 (vector-ref e-5 5))) e-12)))) (if (null? sc1) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForNameC-44getExtra-12769 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-6 e-5 (let ((e-18 (vector-ref arg-7 18))) e-18)) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (lambda (clam-0) (if (null? e-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (cons (box "interface") (PreludeC-45Types-u--pure_Applicative_List e-6))))))) (IdrisC-45DocC-45String-n--12935-10837-u--getIFaceDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) clam-0) (vector 1 (cons '() '())))))))))) eff-0) ext-0)))))))
(define IdrisC-45Syntax-u--show_Show_Fixity (lambda (arg-0) (cond ((equal? arg-0 0) "infixl") ((equal? arg-0 1) "infixr") ((equal? arg-0 2) "infix") (else "prefix"))))
(define IdrisC-45DocC-45String-n--12975-11366-u--printName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-3 (cdr arg-7))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Syntax-u--show_Show_Fixity e-10)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "operator,") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "level") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (PreludeC-45Show-u--show_Show_Nat e-11)) '())))))))))))
(define IdrisC-45DocC-45String-n--12935-10839-u--getInfixDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--names (LibrariesC-45DataC-45ANameMap-lookupName (vector 1 (vector 0 (CoreC-45Name-nameRoot arg-6))) (IdrisC-45Syntax-infixes e-5)))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45DocC-45String-n--12975-11366-u--printName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-1)) u--names)))))) eff-0) ext-0)))))))
(define IdrisC-45Syntax-prefixes (lambda (ext-0) (LibrariesC-45DataC-45ANameMap-fromList (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (cons (let ((e-0 (vector-ref e-3 0))) e-0) (let ((e-4 (vector-ref e-3 3))) e-4)))))) (PreludeC-45TypesC-45List-filterAppend '() csegen-273 (LibrariesC-45DataC-45ANameMap-toList (let ((e-0 (vector-ref ext-0 0))) e-0)))))))
(define IdrisC-45DocC-45String-n--12977-11447-u--printPrefixName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-3 (cdr arg-7))) (let ((e-7 (cdr e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "prefix operator, level") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (PreludeC-45Show-u--show_Show_Nat e-7)))))))
(define IdrisC-45DocC-45String-n--12935-10841-u--getPrefixDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--names (LibrariesC-45DataC-45ANameMap-lookupName (vector 1 (vector 0 (CoreC-45Name-nameRoot arg-6))) (IdrisC-45Syntax-prefixes e-5)))) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45DocC-45String-n--12977-11447-u--printPrefixName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-1)) u--names)))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-case--getDocsForNameC-44getFixityDoc-11530 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-3) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Fixity Declaration")) e-2) '()) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-3149 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat arg-9))) '())))))))
(define IdrisC-45DocC-45String-n--12935-10836-u--getFixityDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (IdrisC-45DocC-45String-n--12935-10839-u--getInfixDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45DocC-45String-n--12935-10841-u--getPrefixDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45DocC-45String-case--getDocsForNameC-44getFixityDoc-11530 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-6 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-n--12935-10843-u--showDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-6 (car arg-7))) (let ((e-7 (cdr arg-7))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-6 (let ((e-39 (vector-ref e-5 0))) e-39)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (CoreC-45Context-undefinedName arg-4 arg-2 e-6 clam-1) (let ((e-4 (unbox e-8))) (let ((act-3 (cond ((equal? e-3 1) (IdrisC-45DocC-45String-n--12935-10833-u--getExtra arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 e-4 clam-1)) (else (vector 1 (cons '() '())))))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-11 (car e-9))) (let ((e-10 (cdr e-9))) (let ((act-4 ((PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (world-0) (let ((act-4 (eta-1 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (eta-2 e-12))) eff-0) world-0)))))))) (lambda (eta-1) (lambda (eta-2) (IdrisC-45Resugar-resugar '() arg-4 arg-3 '() eta-1 eta-2))) (lambda (eta-1) (CoreC-45Normalise-normaliseHoles arg-4 '() e-5 '() (let ((e-32 (vector-ref e-4 2))) e-32) eta-1))) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--ty (cond ((equal? e-2 1) ((case (vector-ref e-12 0) ((1) (let ((e-16 (vector-ref e-12 3))) (let ((e-13 (vector-ref e-12 6))) (case (vector-ref e-16 0) ((2) (lambda () e-13))(else (lambda () e-12))))))(else (lambda () e-12))))) (else e-12)))) (lambda (eta-1) (let ((act-5 (CoreC-45Context-aliasName arg-4 e-6 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--prig (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) (IdrisC-45PrettyC-45Annotations-prettyRig (let ((e-29 (vector-ref e-4 7))) e-29))))) (let ((u--cat (IdrisC-45Pretty-showCategory (lambda (eta-2) (vector 6 eta-2)) e-4))) (let ((u--nm (IdrisC-45DocC-45String-prettyKindedName e-11 (u--cat (cond ((equal? e-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Name-u--show_Show_Name e-13))) (else (IdrisC-45DocC-45String-prettyName e-13))))))) (let ((u--deprecated (let ((sc8 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 2 ) (let ((e-24 (vector-ref e-4 12))) e-24)))) (cond ((equal? sc8 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "=DEPRECATED=")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line)) (else LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))) (let ((u--docDecl (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--deprecated (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--prig u--nm) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-2) (vector 6 eta-2)) u--ty) '())))))))) (let ((u--docText (let ((u--docs (IdrisC-45DocC-45String-n--12935-10842-u--reflowDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 5 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat u--docs))) (PreludeC-45Interfaces-guard csegen-258 (let ((sc8 (PreludeC-45Types-u--null_Foldable_List u--docs))) (cond ((equal? sc8 1) 0) (else 1)))))))) (lambda (eta-2) (let ((act-6 (IdrisC-45DocC-45String-n--12935-10836-u--getFixityDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--docBody (let ((u--docs ((PreludeC-45Types-maybe (lambda () (lambda (eta-3) eta-3)) (lambda () csegen-103) u--docText) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (PreludeC-45TypesC-45List-tailRecAppend e-10 e-14))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--l) (lambda (u--r) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--l LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) u--r))) u--docs))) (PreludeC-45Interfaces-guard csegen-1509 (let ((sc9 (PreludeC-45Types-u--null_Foldable_List u--docs))) (cond ((equal? sc9 1) 0) (else 1)))))))) (let ((u--maybeDocDecl (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 e-0) (lambda (_-10649) (box u--docDecl))))) (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (DataC-45List-catMaybes (cons u--maybeDocDecl (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (box eta-4)) u--docBody)))))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1))))))))) eff-0) clam-2)))))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForName-13976 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-13) (vector 1 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45DocC-45String-n--12935-10843-u--showDoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-0 eta-0)) arg-13 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat e-5))))) eff-0) ext-0))))))))
(define IdrisC-45DocC-45String-case--getDocsForName-13933 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (CoreC-45Context-undefinedName arg-4 arg-2 arg-1 eta-0)) (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (let ((u--all (cons e-1 e-2))) (lambda (eta-0) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForName-13976 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-1 u--all (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (u--n) (LibrariesC-45DataC-45ANameMap-lookupName u--n (let ((e-7 (vector-ref arg-6 7))) e-7))) u--all) eta-0))))))))
(define IdrisC-45DocC-45String-getDocsForName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--extra (let ((sc2 (CoreC-45Name-nameRoot arg-4))) (cond ((equal? sc2 "-") (cons (vector 0 CoreC-45NameC-45Namespace-numNS (vector 1 (vector 0 "negate"))) '()))(else '()))))) (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtName arg-4 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (IdrisC-45DocC-45String-case--getDocsForName-13933 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 u--extra e-7 (PreludeC-45TypesC-45List-tailRecAppend u--extra (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-7))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hcat (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-717 ext-0)))
(define IdrisC-45DocC-45String-justUserDoc (vector 0 0 1 0))
(define IdrisC-45Resugar-sugarName (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (string-append "(implicit) " e-0))) ((3) (let ((e-2 (vector-ref arg-0 1))) (IdrisC-45Resugar-sugarName e-2))) ((4) (let ((e-4 (vector-ref arg-0 1))) e-4))(else (CoreC-45Name-u--show_Show_Name arg-0)))))
(define IdrisC-45Pretty-warning (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) ext-0)))
(define IdrisC-45Error-n--15196-8995-u--pshadowing (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-2) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is shadowing") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 (DataC-45List1-forget e-3)))))))))))
(define IdrisC-45Error-pwarningRaw (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (let ((e-1 (vector-ref arg-3 2))) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-1) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) ext-0)))))))) ((1) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-1 (IdrisC-45Error-pshow e-2 arg-0 arg-1 e-4 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unreachable clause:") (IdrisC-45Pretty-code e-6))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (DataC-45List-snoc (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "We are about to implicitly bind the following lowercase names.") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "You may be unintentionally shadowing the associated global definitions:") (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45Error-n--15196-8995-u--pshadowing e-7 e-6 arg-2 arg-1 arg-0 eta-1)) (DataC-45List1-forget e-7)))) e-5)))))) eff-0) ext-0)))))))) ((3) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-warning (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Resugar-sugarName e-11))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "has been forward-declared with") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3029 e-9)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "visibility, cannot change to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3029 e-10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow ". This will be an error in a later release."))))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) ext-0)))))))))) ((4) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-12) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "You may be unintentionally shadowing the following local bindings:") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hcat (PreludeC-45TypesC-45List-mapAppend '() csegen-1987 (DataC-45List1-forget e-13)))) (cons e-5 '())))))))) eff-0) ext-0)))))))) ((5) (let ((e-15 (vector-ref arg-3 2))) (let ((e-16 (vector-ref arg-3 3))) (let ((act-1 (if (null? e-16) (vector 1 '()) (let ((e-2 (unbox e-16))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (car e-2))) (let ((e-3 (cdr e-2))) (IdrisC-45DocC-45String-getDocsForName arg-2 arg-0 arg-1 e-4 e-3 IdrisC-45DocC-45String-justUserDoc clam-1)))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (DataC-45List-catMaybes (cons (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Deprecation warning:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-15))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 7 )) eta-1)) e-5) '())))))))) eff-0) ext-0)))))))) (else (let ((e-17 (vector-ref arg-3 1))) (let ((e-18 (vector-ref arg-3 2))) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-17) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-18) (cons e-5 '()))))))) eff-0) ext-0)))))))))))
(define CoreC-45Context-setPPrint (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-43 arg-1 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define LibrariesC-45DataC-45List1-n--3051-3533-u--go (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (cons '() arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45List1-n--3051-3533-u--go arg-1 arg-2 e-2 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons arg-3 e-5) e-4)))))))))
(define LibrariesC-45DataC-45List1-unsnoc (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45DataC-45List1-n--3051-3533-u--go e-1 e-2 e-1 e-2)))))
(define CoreC-45TT-u--prettyPrec_Pretty_Void_PartialReason (lambda (arg-0 arg-1) (CoreC-45TT-u--pretty_Pretty_Void_PartialReason arg-1)))
(define CoreC-45Core-u--pretty_Pretty_C-36ann_DotReason (lambda (arg-1) (cond ((equal? arg-1 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Non linear pattern variable")) ((equal? arg-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Variable applied to arguments")) ((equal? arg-1 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Not a constructor application or primitive")) ((equal? arg-1 3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Erased argument")) ((equal? arg-1 4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "User dotted")) ((equal? arg-1 5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unknown reason")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Under-applied constructor")))))
(define CoreC-45Core-u--showPrec_Show_TTCErrorMsg (lambda (arg-0 arg-1) (CoreC-45Core-u--show_Show_TTCErrorMsg arg-1)))
(define IdrisC-45Error-n--15588-11340-u--allUndefined (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) '() (let ((e-7 (cdr e-2))) (case (vector-ref e-7 0) ((7) (if (null? e-3) (box e-7) (IdrisC-45Error-n--15588-11340-u--allUndefined arg-0 arg-1 arg-2 arg-3 e-3)))(else '())))))))))
(define IdrisC-45Error-n--15588-12007-u--dropEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((3) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (case (vector-ref e-3 0) ((2) (IdrisC-45Error-n--15588-12007-u--dropEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 arg-9) (cons e-3 arg-10) e-4)) ((1) (IdrisC-45Error-n--15588-12007-u--dropEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 arg-9) (cons e-3 arg-10) e-4))(else (cons arg-9 (cons arg-10 arg-11))))))))(else (cons arg-9 (cons arg-10 arg-11))))))
(define IdrisC-45Error-n--15588-13445-u--prettyErrors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (cond ((equal? arg-5 0) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "... (" (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-6)) (cons " others)" '())))))))))(else (let ((e-0 (- arg-5 1))) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--idx (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-prim__integerToNat (- arg-4 e-0))))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-1 e-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-n--15588-13445-u--prettyErrors arg-0 arg-1 arg-2 arg-3 arg-4 e-0 e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-warning (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons u--idx (cons ": " (cons e-7 '())))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5) e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))))
(define IdrisC-45Error-n--15588-13444-u--listErrors (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 2))) (let ((e-51 (vector-ref e-41 17))) e-51)))))))) (lambda (eta-0) (let ((act-1 (unbox arg-3))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45Error-n--15588-13445-u--prettyErrors arg-0 arg-1 arg-2 arg-3 e-5 e-5 (DataC-45List-nub csegen-3015 (PreludeC-45TypesC-45List-reverse (DataC-45List1-forget arg-0)))))) eff-0) ext-0)))))))
(define IdrisC-45Error-case--caseC-32blockC-32inC-32perrorRawC-44order-9563 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (cons arg-10 (vector 2 )) (let ((e-1 (unbox arg-14))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-12 e-9))) (cond ((equal? sc3 1) (cons arg-10 arg-9)) (else (let ((sc4 (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 arg-12 e-9))) (cond ((equal? sc5 1) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 arg-13 e-10)) (else 0))))) (cond ((equal? sc4 1) (cons arg-10 arg-9)) (else (cons arg-9 arg-10))))))))))))))
(define IdrisC-45Error-n--15588-9495-u--order (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((sc0 (CoreC-45FC-isNonEmptyFC arg-9))) (if (null? sc0) (cons (vector 2 ) arg-10) (let ((e-1 (unbox sc0))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (IdrisC-45Error-case--caseC-32blockC-32inC-32perrorRawC-44order-9563 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-5 e-9 e-10 (CoreC-45FC-isNonEmptyFC arg-10)))))))))))
(define IdrisC-45Error-n--15588-11341-u--pAlterror (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-2) (let ((act-1 ((IdrisC-45Error-perrorRaw arg-3 arg-2 arg-1 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Possible error") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 e-5)))))) eff-0) clam-0))))) (let ((e-5 (unbox e-2))) (let ((act-1 (CoreC-45Context-getFullName arg-3 e-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-aliasName arg-3 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45Error-perrorRaw arg-3 arg-2 arg-1 e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "If") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-7)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) e-8)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define IdrisC-45Error-n--15588-12325-u--prettyHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((IdrisC-45Error-ploc arg-1 e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-n--15588-12325-u--prettyHoles arg-0 arg-1 arg-2 arg-3 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-7)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "introduced at:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 e-8))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define IdrisC-45Error-n--15588-10762-u--prettyRel (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "irrelevant") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "relevant") (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "non-linear")) ext-0)))
(define IdrisC-45Error-n--15588-10763-u--prettyRig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "irrelevant") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "linear") (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "unrestricted")) ext-0)))
(define IdrisC-45Error-n--15588-9496-u--prettyVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((3) (let ((e-0 (vector-ref arg-9 1))) (IdrisC-45Error-n--15588-9496-u--prettyVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-0)))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-9)))))
(define IdrisC-45Error-n--15588-11860-u--tshow (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((act-1 (IdrisC-45Error-pshow arg-7 arg-6 arg-5 arg-8 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-code e-5))))))) eff-0) ext-0)))))))))
(define IdrisC-45Error-case--perrorRaw-12103 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (IdrisC-45Error-pshow e-2 arg-8 arg-7 e-6 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-6 arg-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't find an implementation for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-8))) (lambda (eta-1) (let ((act-3 (let ((act-3 (set-box! arg-8 arg-9))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (if (null? arg-1) (vector 1 u--res) (let ((e-4 (unbox arg-1))) (let ((act-4 ((IdrisC-45Error-perrorRaw arg-8 arg-7 arg-6 e-4) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--res LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Possible cause:") e-10)))))) eff-0) eta-1)))))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define IdrisC-45Error-perrorRaw (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-0 (vector-ref arg-3 1))) (IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-0))) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setCtxt arg-0 e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((act-3 (IdrisC-45Error-pshow e-1 arg-0 arg-1 e-4 e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (IdrisC-45Error-pshow e-1 arg-0 arg-1 e-4 e-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((IdrisC-45Error-ploc arg-2 e-2) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Mismatch between") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (IdrisC-45Pretty-code e-9) (cons csegen-3037 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-10) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) '())))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-11))) (lambda (eta-4) (let ((act-6 (let ((act-6 (set-box! arg-0 e-7))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (vector 1 u--res)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))))) ((2) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (let ((e-11 (vector-ref arg-3 5))) (let ((e-12 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setCtxt arg-0 e-9) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (IdrisC-45Error-pshow e-7 arg-0 arg-1 e-10 e-11 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (IdrisC-45Error-pshow e-7 arg-0 arg-1 e-10 e-12 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((IdrisC-45Error-ploc arg-2 e-8) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't solve constraint between") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (IdrisC-45Pretty-code e-13) (cons csegen-3037 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-14) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) '())))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-15))) (lambda (eta-4) (let ((act-6 (let ((act-6 (set-box! arg-0 e-5))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 u--res)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))))) ((3) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((e-18 (vector-ref arg-3 6))) (lambda (clam-0) (let ((sc1 (IdrisC-45Error-n--15588-9495-u--order e-13 e-18 e-17 e-16 e-15 e-14 arg-2 arg-1 arg-0 e-14 e-15))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-1 (IdrisC-45Error-pshow e-13 arg-0 arg-1 e-16 e-18 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc2 arg-2 e-2 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Pattern variable") (cons (IdrisC-45Pretty-code (IdrisC-45Error-n--15588-9496-u--prettyVar e-13 e-18 e-17 e-16 e-15 e-14 arg-2 arg-1 arg-0 e-17)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "unifies with") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) '())))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: Use the same name for both pattern variables, since they unify.")))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (let ((e-23 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-22) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Error-pshow e-19 arg-0 arg-1 e-21 e-23 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Error-ploc arg-2 e-20) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Cycle detected in solution of metavariable") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (IdrisC-45Pretty-code e-6))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((5) (let ((e-24 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (let ((e-28 (vector-ref arg-3 5))) (let ((e-29 (vector-ref arg-3 6))) (let ((e-30 (vector-ref arg-3 7))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setCtxt arg-0 e-26) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (IdrisC-45Error-pshow e-24 arg-0 arg-1 e-27 e-28 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (IdrisC-45Error-pshow e-24 arg-0 arg-1 e-27 e-29 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-30) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "When unifying:") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "    ")) (IdrisC-45Pretty-code e-7)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "and:")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "    ")) (IdrisC-45Pretty-code e-8))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-9))) (lambda (eta-4) (let ((act-6 (let ((act-6 (set-box! arg-0 e-5))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 u--res)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))))) ((6) (let ((e-31 (vector-ref arg-3 1))) (let ((e-32 (vector-ref arg-3 2))) (let ((e-33 (vector-ref arg-3 3))) (let ((e-34 (vector-ref arg-3 4))) (lambda (clam-1) (case (vector-ref e-34 0) ((0) (let ((e-222 (vector-ref e-34 1))) (let ((act-1 (IdrisC-45Error-pshow e-31 arg-0 arg-1 e-33 e-222 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-32) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a valid impossible case."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-0)))))))) eff-0) clam-1))))))) (else (let ((e-225 (vector-ref e-34 1))) (let ((act-1 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-225) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Impossible pattern gives an error") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) clam-1)))))))))))))) ((7) (let ((e-35 (vector-ref arg-3 1))) (let ((e-36 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-35) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Undefined name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-36)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line e-5)))))) eff-0) eta-0))))))))) ((8) (let ((e-37 (vector-ref arg-3 1))) (let ((e-38 (vector-ref arg-3 2))) (let ((e-39 (vector-ref arg-3 3))) (lambda (clam-2) (if (null? e-39) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-37) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-38)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is private.")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: add an explicit")) csegen-3055))))) eff-0) clam-2))))) (let ((e-227 (unbox e-39))) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-37) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-38)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is inaccessible since") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2757 e-227)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not explicitly imported.")))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: add an explicit")) csegen-3055))))) eff-0) clam-2)))))))))))) ((9) (let ((e-40 (vector-ref arg-3 1))) (let ((e-41 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-40) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Return type of") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-41)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "must be") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Type")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((10) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-42) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Return type of") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-43)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "must be in") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-44)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line e-5)))))) eff-0) eta-0)))))))))) ((11) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (lambda (clam-3) (case (vector-ref e-47 0) ((0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Internal error") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Coverage of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-46)))))))) ((1) (let ((e-229 (vector-ref e-47 1))) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-46) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-45) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45Error-pshow '() arg-0 arg-1 '() eta-2 eta-3))) e-229 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not covering."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Missing cases")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))) (else (let ((e-230 (vector-ref e-47 1))) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-46) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-45) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not covering."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Calls non covering function")) (if (null? e-230) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-3061 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 e-230))) (let ((e-1 (car e-230))) (let ((e-2 (cdr e-230))) (if (null? e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-3061 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 e-230)))))))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))))))))) ((12) (let ((e-48 (vector-ref arg-3 1))) (let ((e-49 (vector-ref arg-3 2))) (let ((e-50 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-49) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-48) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not total,") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 (cons (lambda (arg-11067) (CoreC-45TT-u--pretty_Pretty_Void_PartialReason arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45TT-u--prettyPrec_Pretty_Void_PartialReason arg-11073 arg-11076)))) e-50)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((13) (let ((e-51 (vector-ref arg-3 1))) (let ((e-52 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-51) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "There are") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-52) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "uses of linear name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Resugar-sugarName e-53))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: linearly bounded variables must be used exactly once."))))))) eff-0) eta-0)))))))))) ((14) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (let ((e-56 (vector-ref arg-3 3))) (let ((e-57 (vector-ref arg-3 4))) (lambda (clam-4) (let ((sc1 (AlgebraC-45Semiring-isErased csegen-931 e-56))) (cond ((equal? sc1 1) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-54) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-55)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not accessible in this context."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) clam-4)))))) (else (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-54) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Trying to use") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-n--15588-10763-u--prettyRig e-57 e-56 e-55 e-54 arg-2 arg-1 arg-0 e-56) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Resugar-sugarName e-55))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-n--15588-10762-u--prettyRel e-57 e-56 e-55 e-54 arg-2 arg-1 arg-0 e-57) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "context.")))))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) clam-4)))))))))))))) ((15) (let ((e-58 (vector-ref arg-3 1))) (let ((e-59 (vector-ref arg-3 2))) (let ((e-60 (vector-ref arg-3 3))) (let ((e-61 (vector-ref arg-3 4))) (let ((e-62 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-58 arg-0 arg-1 e-60 e-61 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Error-pshow e-58 arg-0 arg-1 e-60 e-62 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Error-ploc arg-2 e-59) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "borrows argument") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "so must be fully applied."))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((16) (let ((e-63 (vector-ref arg-3 1))) (let ((e-64 (vector-ref arg-3 2))) (let ((e-65 (vector-ref arg-3 3))) (let ((e-66 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-63 arg-0 arg-1 e-65 e-66 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-64) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "borrows, so must return a concrete type."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((17) (let ((e-67 (vector-ref arg-3 1))) (let ((e-68 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-67) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Ambiguous name") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyList csegen-1260 e-68)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((18) (let ((e-69 (vector-ref arg-3 1))) (let ((e-70 (vector-ref arg-3 2))) (let ((e-71 (vector-ref arg-3 3))) (let ((e-72 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (vector e-0 e-1 e-2 1))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-5) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-setCtxt arg-0 e-2) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (IdrisC-45Error-pshow e-69 arg-0 arg-1 e-71 e-3 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (set-box! arg-0 e-7))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (vector 1 e-9))))))) eff-0) eta-2))))))))))) eff-0) clam-5))))))))) e-72 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((IdrisC-45Error-ploc arg-2 e-70) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Ambiguous elaboration. Possible results") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7)) '()))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-8))) (lambda (eta-3) (let ((act-5 ((CoreC-45Context-setPPrint arg-0 e-5) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 u--res)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))) ((19) (let ((e-73 (vector-ref arg-3 1))) (let ((e-74 (vector-ref arg-3 2))) (let ((e-75 (vector-ref arg-3 3))) (let ((e-76 (vector-ref arg-3 4))) (let ((e-77 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshowNoNorm e-73 arg-0 arg-1 e-75 e-76 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-74) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45Error-pshowNoNorm e-73 arg-0 arg-1 e-75 eta-3 eta-4))) e-77 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Multiple solutions found in search of") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 e-5) (cons e-6 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Possible correct results") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7)) '())))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((20) (let ((e-78 (vector-ref arg-3 1))) (let ((e-79 (vector-ref arg-3 2))) (let ((e-80 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 e-79 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-getFullName arg-0 eta-2 eta-3))) e-80 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Error-ploc arg-2 e-78) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Maximum ambiguity depth exceeded in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-5)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-4) (lambda (eta-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 " --> ") eta-4 eta-5))) (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 e-6))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line e-7) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: the default ambiguity depth limit is 3, the")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "%ambiguity_depth")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "pragma can be used to extend this limit, but beware compilation times can be severely impacted.")))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((21) (let ((e-81 (vector-ref arg-3 1))) (let ((sc1 (IdrisC-45Error-n--15588-11340-u--allUndefined e-81 arg-2 arg-1 arg-0 e-81))) (if (null? sc1) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Error-n--15588-11341-u--pAlterror e-81 arg-2 arg-1 arg-0 eta-1)) e-81 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Sorry, I can't find any elaboration which works. All errors") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-5)))))) eff-0) eta-0)))))) (let ((e-1 (unbox sc1))) (IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-1)))))) ((22) (let ((e-83 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-83) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type for this record update.")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) ((23) (let ((e-85 (vector-ref arg-3 1))) (let ((e-86 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-85) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Duplicated record update paths:")) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-3) (vector 6 eta-3)) (IdrisC-45Pretty-prettyFieldPath eta-2)))) e-86) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line e-5) '())))))))) eff-0) eta-0))))))))) ((24) (let ((e-87 (vector-ref arg-3 1))) (let ((e-88 (vector-ref arg-3 2))) (let ((e-89 (vector-ref arg-3 3))) (lambda (clam-6) (if (null? e-89) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-87) clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-88)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not part of a record type."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) clam-6))))) (let ((e-233 (unbox e-89))) (let ((act-1 (CoreC-45Context-getFullName arg-0 e-233 clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-87) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Record type") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "has no field") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-88)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-0)))))))) eff-0) clam-6)))))))))))) ((25) (let ((e-90 (vector-ref arg-3 1))) (let ((e-91 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 e-91 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-90) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a record type."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((26) (let ((e-92 (vector-ref arg-3 1))) (let ((e-93 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-92) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Field update") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) (IdrisC-45Pretty-prettyFieldPath e-93)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not compatible with other updates at") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))))) eff-0) eta-0))))))))) ((27) (let ((e-94 (vector-ref arg-3 1))) (let ((e-95 (vector-ref arg-3 2))) (let ((e-96 (vector-ref arg-3 3))) (let ((e-97 (vector-ref arg-3 4))) (let ((e-98 (vector-ref arg-3 5))) (lambda (clam-0) (if (null? e-97) (let ((act-1 (IdrisC-45Error-pshow e-94 arg-0 arg-1 e-96 e-98 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-95) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-3081 e-97)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "are not valid arguments in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-235 (car e-97))) (let ((e-236 (cdr e-97))) (if (null? e-236) (let ((act-1 (IdrisC-45Error-pshow e-94 arg-0 arg-1 e-96 e-98 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-95) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-235)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a valid argument in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((act-1 (IdrisC-45Error-pshow e-94 arg-0 arg-1 e-96 e-98 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-95) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-3081 e-97)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "are not valid arguments in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))) ((28) (let ((e-99 (vector-ref arg-3 1))) (let ((e-100 (vector-ref arg-3 2))) (let ((e-101 (vector-ref arg-3 3))) (let ((e-102 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Error-n--15588-11860-u--tshow e-99 e-102 e-101 e-100 arg-2 arg-1 arg-0 e-99 e-101 eta-1 eta-2))) e-102 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-100) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Need to bind implicits") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((29) (let ((e-103 (vector-ref arg-3 1))) (let ((e-104 (vector-ref arg-3 2))) (let ((e-105 (vector-ref arg-3 3))) (let ((e-106 (vector-ref arg-3 4))) (let ((e-107 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-103 arg-0 arg-1 e-105 e-107 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-104) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't bind name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Name-nameRoot e-106))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with type") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: try an explicit bind.")))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((30) (let ((e-108 (vector-ref arg-3 1))) (let ((e-109 (vector-ref arg-3 2))) (let ((e-110 (vector-ref arg-3 3))) (let ((e-111 (vector-ref arg-3 4))) (let ((e-112 (vector-ref arg-3 5))) (let ((e-113 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setCtxt arg-0 e-110) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((IdrisC-45Error-case--perrorRaw-12103 e-108 e-113 e-112 e-111 e-110 e-109 arg-2 arg-1 arg-0 e-5 (IdrisC-45Error-n--15588-12007-u--dropEnv e-108 e-113 e-112 e-111 e-110 e-109 arg-2 arg-1 arg-0 e-108 e-111 e-112)) eta-1))))))) eff-0) eta-0))))))))))))) ((31) (let ((e-114 (vector-ref arg-3 1))) (let ((e-115 (vector-ref arg-3 2))) (let ((e-116 (vector-ref arg-3 3))) (let ((e-118 (vector-ref arg-3 5))) (let ((e-119 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-114 arg-0 arg-1 e-118 e-119 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-115) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't find an implementation for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "since I can't infer a value for argument")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-116)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((32) (let ((e-120 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-n--15588-12325-u--prettyHoles e-120 arg-2 arg-1 arg-0 e-120) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unsolved holes") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) ((33) (let ((e-121 (vector-ref arg-3 1))) (let ((e-122 (vector-ref arg-3 2))) (let ((e-123 (vector-ref arg-3 3))) (let ((e-124 (vector-ref arg-3 4))) (let ((e-125 (vector-ref arg-3 5))) (let ((e-126 (vector-ref arg-3 6))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-121 arg-0 arg-1 e-123 e-126 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-122) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type for argument") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-124)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Got")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "with hole") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-125)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((34) (let ((e-127 (vector-ref arg-3 1))) (let ((e-128 (vector-ref arg-3 2))) (let ((e-129 (vector-ref arg-3 3))) (let ((e-130 (vector-ref arg-3 4))) (let ((e-131 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-127 arg-0 arg-1 e-129 e-131 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-128) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Named hole") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-meta (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-130)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "has been solved by unification.")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Result")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((35) (let ((e-132 (vector-ref arg-3 1))) (let ((e-133 (vector-ref arg-3 2))) (let ((e-134 (vector-ref arg-3 3))) (let ((e-135 (vector-ref arg-3 4))) (let ((e-136 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-132) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3029 e-133)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Resugar-sugarName e-134))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "cannot refer to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Error-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3029 e-135)) (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Resugar-sugarName e-136)))))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))))))) ((36) (let ((e-137 (vector-ref arg-3 1))) (let ((e-138 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-137) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Non linear pattern") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Resugar-sugarName e-138))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((37) (let ((e-139 (vector-ref arg-3 1))) (let ((e-140 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-139) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Pattern not allowed here") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-140)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((38) (let ((e-141 (vector-ref arg-3 1))) (let ((e-142 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-141) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No type declaration for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-142)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((39) (let ((e-143 (vector-ref arg-3 1))) (let ((e-144 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-143) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-144)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is already defined."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((40) (let ((e-145 (vector-ref arg-3 1))) (let ((e-146 (vector-ref arg-3 2))) (let ((e-147 (vector-ref arg-3 3))) (let ((e-148 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-145 arg-0 arg-1 e-147 e-148 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-146) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a function type."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((41) (let ((e-149 (vector-ref arg-3 1))) (let ((e-150 (vector-ref arg-3 2))) (let ((e-151 (vector-ref arg-3 3))) (let ((e-152 (vector-ref arg-3 4))) (let ((e-153 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-149 arg-0 arg-1 e-151 e-152 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Error-pshow e-149 arg-0 arg-1 e-151 e-153 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Error-ploc arg-2 e-150) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Rewriting by") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "did not change type") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code e-6) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((42) (let ((e-154 (vector-ref arg-3 1))) (let ((e-155 (vector-ref arg-3 2))) (let ((e-156 (vector-ref arg-3 3))) (let ((e-157 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-154 arg-0 arg-1 e-156 e-157 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-155) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a rewrite rule type."))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((43) (let ((e-158 (vector-ref arg-3 1))) (let ((e-159 (vector-ref arg-3 2))) (let ((e-160 (vector-ref arg-3 3))) (case (vector-ref e-160 0) ((0) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-159) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-158) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Patterns for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "have differing numbers of arguments.")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((1) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-159) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-158) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Patterns for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "require matching on different types.")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((4) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-159) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-158) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type to match in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (let ((e-238 (vector-ref e-160 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-158) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Constructor") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-238)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not fully applied.")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) (else (let ((e-239 (vector-ref e-160 1))) (lambda (clam-1) (let ((e-242 (car e-239))) (let ((e-243 (cdr e-239))) (let ((e-246 (car e-243))) (let ((e-247 (cdr e-243))) (let ((act-1 (IdrisC-45Error-pshow e-242 arg-0 arg-1 e-246 e-247 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-prettyName arg-0 e-159) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45Error-ploc arg-2 e-158) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Attempt to match on erased argument") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-6)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))))) ((45) (let ((e-161 (vector-ref arg-3 1))) (let ((e-162 (vector-ref arg-3 2))) (let ((e-163 (vector-ref arg-3 3))) (let ((e-164 (vector-ref arg-3 4))) (let ((e-165 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-161 arg-0 arg-1 e-163 e-165 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-162) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't match on") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (CoreC-45Core-u--pretty_Pretty_C-36ann_DotReason e-164)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((44) (let ((e-167 (vector-ref arg-3 1))) (let ((e-168 (vector-ref arg-3 2))) (let ((e-169 (vector-ref arg-3 3))) (let ((e-170 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-167 arg-0 arg-1 e-169 e-170 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-168) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't match on") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "as it must have a polymorphic type.")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((46) (let ((e-171 (vector-ref arg-3 1))) (let ((e-172 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-171) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't infer type for unbound implicit name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-172)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Suggestion: try making it a bound implicit.")))))) eff-0) eta-0))))))))) ((47) (let ((e-173 (vector-ref arg-3 1))) (let ((e-174 (vector-ref arg-3 2))) (let ((e-175 (vector-ref arg-3 3))) (let ((e-176 (vector-ref arg-3 4))) (let ((e-177 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-pshow e-173 arg-0 arg-1 e-175 e-176 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-174) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((u--scriptFC (CoreC-45TTC-45Term-getLoc e-176))) (let ((sc3 (DataC-45Maybe-isJust (CoreC-45FC-isNonEmptyFC u--scriptFC)))) (cond ((equal? sc3 1) (let ((act-3 ((IdrisC-45Error-ploc arg-2 u--scriptFC) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Stuck place in the script:")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-7))))) eff-0) eta-2)))))) (else (vector 1 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Bad elaborator script") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-code e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-177)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6) e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((48) (let ((e-178 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-178) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error during reflection") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) e-5))))) eff-0) eta-0)))))))) ((49) (let ((e-179 (vector-ref arg-3 1))) (let ((e-180 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-179) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-180) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((50) (let ((e-181 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error in TTC file") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (CoreC-45Core-u--show_Show_TTCErrorMsg u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45Core-u--showPrec_Show_TTCErrorMsg u--d u--x)))) e-181))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "the most likely case is that the ./build directory in your current project contains files from a previous build of idris2 or the idris2 executable is from a different build than the installed .ttc files"))))))) ((51) (let ((e-182 (vector-ref arg-3 1))) (let ((e-183 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "File error in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-182) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-3096 e-183))))))) ((52) (let ((e-184 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't find package ") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-184))))))) ((53) (let ((e-185 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-185) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Implicit lazy functions are not yet supported.")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) ((54) (let ((e-186 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-186) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Defining lazy functions via pattern matching is not yet supported.")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) ((55) (let ((e-187 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-187) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Can't parse literate.")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) ((56) (let ((e-188 (vector-ref arg-3 1))) (let ((e-189 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-188) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-189)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((57) (let ((e-190 (vector-ref arg-3 1))) (if (null? e-190) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-n--15588-13444-u--listErrors e-190 arg-2 arg-1 arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-3105 e-5))))) eff-0) eta-0)))))) (let ((e-249 (car e-190))) (let ((e-250 (cdr e-190))) (lambda (clam-2) (if (null? e-249) (let ((act-1 (IdrisC-45Error-n--15588-13444-u--listErrors e-190 arg-2 arg-1 arg-0 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-3105 e-5))))) eff-0) clam-2))))) (let ((e-253 (car e-249))) (let ((e-254 (cdr e-249))) (if (null? e-250) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-253) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-254)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) clam-2))))) (let ((act-1 (IdrisC-45Error-n--15588-13444-u--listErrors e-190 arg-2 arg-1 arg-0 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 csegen-3105 e-5))))) eff-0) clam-2))))))))))))))) ((58) (let ((e-191 (vector-ref arg-3 1))) (let ((e-192 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-191) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Module") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2789 e-192)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not found")))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((59) (let ((e-193 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Module imports form a cycle") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-1) (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 " -> ") eta-1 eta-2))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2789 eta-1)) e-193))))))) ((60) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Internal error when resolving implicit laziness"))))) ((61) (let ((e-194 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "INTERNAL ERROR") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-194)))))) ((62) (let ((e-195 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Error") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-195)))))) ((63) (let ((e-196 (vector-ref arg-3 1))) (let ((e-197 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cgs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref e-5 4))) e-4))))) (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-ploc arg-2 e-196) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--res (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (string-append "The given specifier '" (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-197) "' was not accepted by any backend. Available backends"))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ", ")) u--y))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow eta-2)) u--cgs))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Some backends have additional specifier rules, refer to their documentation.") '())))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-6))) (lambda (eta-2) (vector 1 u--res))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))) ((64) (let ((e-198 (vector-ref arg-3 1))) (let ((e-199 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-198) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing multi-line string") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-199) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0))))))))) ((65) (let ((e-200 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Timeout in") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-200))))))) ((66) (let ((e-201 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-ploc arg-2 e-201) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Failing block did not fail") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-line) e-5))))) eff-0) eta-0)))))))) ((67) (let ((e-203 (vector-ref arg-3 2))) (let ((e-204 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 eta-1)) (DataC-45List1-forget e-204) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Failing block failed with the wrong error") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Expected") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-203)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "but got:"))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-5) '())))))))) eff-0) eta-0))))))))) ((68) (let ((e-206 (vector-ref arg-3 2))) (let ((e-207 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-206) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-207) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing type of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (cons e-6 '()))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((69) (let ((e-209 (vector-ref arg-3 2))) (let ((e-210 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-209) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-210) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing constructor") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (cons e-6 '()))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((70) (let ((e-212 (vector-ref arg-3 2))) (let ((e-213 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-212) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-213) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing left hand side of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (cons e-6 '()))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((71) (let ((e-215 (vector-ref arg-3 2))) (let ((e-216 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-prettyName arg-0 e-215) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-216) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-errorDesc (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "While processing right hand side of") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-5)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (cons e-6 '()))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((72) (let ((e-217 (vector-ref arg-3 1))) (let ((e-218 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-217) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 e-5 (if (null? e-218) (let ((sc3 (LibrariesC-45DataC-45List1-unsnoc e-218))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Did you mean any of:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-3126 e-2)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-3)) csegen-3125))))))) (let ((e-1 (car e-218))) (let ((e-2 (cdr e-218))) (if (null? e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Did you mean:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-1)) csegen-3125)) (let ((sc4 (LibrariesC-45DataC-45List1-unsnoc e-218))) (let ((e-4 (car sc4))) (let ((e-3 (cdr sc4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Did you mean any of:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-3126 e-4)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "or") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-3)) csegen-3125)))))))))))))))) eff-0) eta-0))))))))) (else (let ((e-219 (vector-ref arg-3 1))) (lambda (eta-0) (IdrisC-45Error-pwarningRaw arg-0 arg-1 arg-2 e-219 eta-0)))))))
(define IdrisC-45Error-perror (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-1827 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45Error-perrorRaw arg-0 arg-1 arg-2 e-5))) eff-0) ext-0)))))))
(define IdrisC-45Error-display (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (IdrisC-45Error-perror arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 1 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Error:")) e-5))))) eff-0) ext-0)))))))
(define ProtocolC-45IDEC-45Formatting-mkDecor (lambda (arg-0) (cons (box arg-0) '())))
(define IdrisC-45Pretty-syntaxToDecoration (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) (box 1)) ((2) (box 3)) ((3) (box 2)) ((4) (box 5)) ((5) (box 4)) (else '()))))
(define IdrisC-45IDEModeC-45Pretty-syntaxToProperties (lambda (arg-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (ProtocolC-45IDEC-45Formatting-mkDecor eta-0)) (IdrisC-45Pretty-syntaxToDecoration arg-0))))
(define IdrisC-45IDEModeC-45Pretty-annToProperties (lambda (arg-0) (case (vector-ref arg-0 0) ((0) csegen-4080) ((1) csegen-4080) ((2) '()) ((3) (box (ProtocolC-45IDEC-45Formatting-mkDecor 1))) ((4) (box (ProtocolC-45IDEC-45Formatting-mkDecor 5))) ((5) (box (ProtocolC-45IDEC-45Formatting-mkDecor 2))) ((6) (let ((e-0 (vector-ref arg-0 1))) (IdrisC-45IDEModeC-45Pretty-syntaxToProperties e-0))) (else (box (ProtocolC-45IDEC-45Formatting-mkDecor 0))))))
(define IdrisC-45PrettyC-45Render-renderWithoutColor (lambda (arg-1 arg-2 ext-0) (let ((act-1 (IdrisC-45PrettyC-45Render-getPageWidth arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--layout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty e-5 arg-2))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-renderString (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-unAnnotateS u--layout))))))) eff-0) ext-0)))))))
(define SystemC-45FileC-45Support-ok (lambda (arg-3 arg-4) (let ((e-1 (car arg-3))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 1 arg-4)))))))
(define SystemC-45FileC-45Error-returnError (lambda (arg-2) (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-2))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Error-prim__fileErrno eta-0))))) (lambda (u--err) (let ((e-7 (car arg-2))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (cond ((equal? u--err 0) (vector 1 )) ((equal? u--err 1) (vector 2 )) ((equal? u--err 2) (vector 3 )) ((equal? u--err 3) (vector 4 )) ((equal? u--err 4) (vector 5 ))(else (vector 0 (bs- u--err 5 63)))))))))))))))
(define SystemC-45FileC-45ReadWrite-fPutStr (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__writeLine arg-2 arg-3 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 (vector 0 )))))))))))
(define IdrisC-45IDEModeC-45Commands-sendStr (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (vector 0 )) (SystemC-45FileC-45ReadWrite-fPutStr csegen-82 arg-0 arg-1) ext-0)))
(define ProtocolC-45SExp-n--3419-5089-u--escapeChar (lambda (arg-0) (cond ((equal? arg-0 #\\) (cons #\\ (cons #\\ '()))) ((equal? arg-0 #\") (cons #\\ (cons #\" '())))(else (cons arg-0 '())))))
(define ProtocolC-45SExp-escape (lambda (ext-0) (PreludeC-45Types-fastPack (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (ProtocolC-45SExp-n--3419-5089-u--escapeChar eta-0)) (PreludeC-45Types-fastUnpack ext-0)))))
(define ProtocolC-45SExp-join (lambda (arg-0 arg-1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse arg-0 arg-1))))
(define ProtocolC-45SExp-u--show_Show_SExp (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (string-append "(" (string-append (ProtocolC-45SExp-join " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ProtocolC-45SExp-u--show_Show_SExp eta-0)) e-0)) ")")))) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "\"" (string-append (ProtocolC-45SExp-escape e-1) "\"")))) ((2) (let ((e-2 (vector-ref arg-0 1))) (string-append ":" (PreludeC-45Show-u--show_Show_Bool e-2)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Integer e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (string-append ":" e-4))))))
(define ProtocolC-45SExp-case--toSExp-5529 (lambda (arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (vector 0 (cons ((let ((eff-0 (Builtin-fst arg-2))) (lambda (arg-0) (eff-0 arg-0))) arg-3) e-0))))(else (vector 0 (cons ((let ((eff-0 (Builtin-fst arg-2))) (lambda (arg-0) (eff-0 arg-0))) arg-3) (cons arg-5 '())))))))
(define ProtocolC-45SExp-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (lambda (arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (ProtocolC-45SExp-case--toSExp-5529 arg-2 e-2 e-3 ((let ((eff-0 (Builtin-snd arg-2))) (lambda (arg-0) (eff-0 arg-0))) e-3))))))
(define ProtocolC-45SExp-u--toSExp_SExpable_Integer (lambda (ext-0) (vector 3 ext-0)))
(define ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-0) (arg-1 arg-0)) arg-2))))
(define ProtocolC-45SExp-u--toSExp_SExpable_C-40List1C-32C-36aC-41 (lambda (arg-1 arg-2) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-0) (arg-1 arg-0)) (DataC-45List1-forget arg-2)))))
(define ProtocolC-45SExp-u--toSExp_SExpable_String (lambda (ext-0) (vector 1 ext-0)))
(define ProtocolC-45IDEC-45FileContext-u--toSExp_SExpable_FileContext (lambda (arg-0) (vector 0 (cons (vector 0 (cons (vector 4 "filename") (cons (ProtocolC-45SExp-u--toSExp_SExpable_String (let ((e-0 (car arg-0))) e-0)) '()))) (cons (vector 0 (cons (vector 4 "start") (cons (vector 3 (let ((e-1 (cdr arg-0))) (let ((e-5 (vector-ref e-1 0))) e-5))) (cons (vector 3 (let ((e-1 (cdr arg-0))) (let ((e-4 (vector-ref e-1 1))) e-4))) '())))) (cons (vector 0 (cons (vector 4 "end") (cons (vector 3 (let ((e-1 (cdr arg-0))) (let ((e-2 (vector-ref e-1 2))) e-2))) (cons (vector 3 (let ((e-1 (cdr arg-0))) (let ((e-3 (vector-ref e-1 3))) e-3))) '())))) '()))))))
(define ProtocolC-45IDEC-45Holes-u--toSExp_SExpable_HolePremise (lambda (arg-0) (vector 0 (cons (vector 1 (let ((e-0 (car arg-0))) e-0)) (cons (vector 1 (let ((e-1 (cdr arg-0))) e-1)) (cons (vector 0 '()) '()))))))
(define ProtocolC-45IDEC-45Holes-u--toSExp_SExpable_HoleData (lambda (arg-0) (vector 0 (cons (vector 1 (PreludeC-45Show-u--show_Show_String (let ((e-0 (vector-ref arg-0 0))) e-0))) (cons (ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (arg-5218) (ProtocolC-45IDEC-45Holes-u--toSExp_SExpable_HolePremise arg-5218)) (let ((e-2 (vector-ref arg-0 2))) e-2)) (cons (vector 0 (cons (ProtocolC-45SExp-u--toSExp_SExpable_String (let ((e-1 (vector-ref arg-0 1))) e-1)) (cons (vector 0 '()) '()))) '()))))))
(define ProtocolC-45SExp-u--toSExp_SExpable_Nat (lambda (ext-0) (vector 3 ext-0)))
(define ProtocolC-45IDEC-45Result-u--toSExp_SExpable_IdrisVersion (lambda (arg-0) (vector 0 (cons (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_Nat eta-0)) (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (cons (let ((e-1 (vector-ref arg-0 1))) e-1) (cons (let ((e-2 (vector-ref arg-0 2))) e-2) '()))))) (cons (vector 0 (cons (vector 1 (DataC-45Maybe-fromMaybe (lambda () "") (let ((e-3 (vector-ref arg-0 3))) e-3))) '())) '())))))
(define ProtocolC-45IDEC-45Result-u--toSExp_SExpable_MetaVarLemma (lambda (arg-0) (vector 0 (cons (vector 4 "metavariable-lemma") (cons (vector 0 (cons (vector 4 "replace-metavariable") (cons (vector 1 (let ((e-0 (car arg-0))) e-0)) '()))) (cons (vector 0 (cons (vector 4 "definition-type") (cons (vector 1 (let ((e-1 (cdr arg-0))) e-1)) '()))) '()))))))
(define ProtocolC-45SExp-u--toSExp_SExpable_Bool (lambda (ext-0) (vector 2 ext-0)))
(define ProtocolC-45IDEC-45Result-sexpOptionVal (lambda (arg-0 ext-0) (cond ((equal? arg-0 0) (ProtocolC-45SExp-u--toSExp_SExpable_Bool ext-0)) ((equal? arg-0 1) (ProtocolC-45SExp-u--toSExp_SExpable_String ext-0)) (else (ProtocolC-45SExp-u--toSExp_SExpable_String ext-0)))))
(define ProtocolC-45IDEC-45Result-u--toSExp_SExpable_REPLOption (lambda (arg-0) (let ((e-1 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 (let ((e-5 (vector-ref arg-0 0))) e-5)) (cons (ProtocolC-45IDEC-45Result-sexpOptionVal e-1 (let ((e-3 (vector-ref arg-0 2))) e-3)) '()))))))
(define ProtocolC-45IDEC-45Result-u--toSExp_SExpable_Result (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (ProtocolC-45SExp-u--toSExp_SExpable_String e-0))) ((1) (ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_Int eta-0)) '())) ((2) (let ((e-1 (vector-ref arg-0 1))) (ProtocolC-45IDEC-45Result-u--toSExp_SExpable_IdrisVersion e-1))) ((3) (let ((e-2 (vector-ref arg-0 1))) (ProtocolC-45IDEC-45Result-u--toSExp_SExpable_MetaVarLemma e-2))) ((4) (let ((e-3 (vector-ref arg-0 1))) (ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-1) (ProtocolC-45SExp-u--toSExp_SExpable_String eta-1)) (lambda (eta-1) (ProtocolC-45IDEC-45FileContext-u--toSExp_SExpable_FileContext eta-1))) eta-0)) e-3))) ((5) (let ((e-4 (vector-ref arg-0 1))) (ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (eta-0) (ProtocolC-45IDEC-45Holes-u--toSExp_SExpable_HoleData eta-0)) e-4))) ((7) (let ((e-5 (vector-ref arg-0 1))) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 eta-0)) e-5)))) ((6) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (vector 0 (cons (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 eta-0)) e-6)) (cons (vector 1 e-7) '())))))) ((8) (let ((e-8 (vector-ref arg-0 1))) (ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (arg-5218) (ProtocolC-45IDEC-45Result-u--toSExp_SExpable_REPLOption arg-5218)) e-8))) (else (let ((e-9 (vector-ref arg-0 1))) (ProtocolC-45SExp-u--toSExp_SExpable_C-40List1C-32C-36aC-41 (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_String eta-0)) e-9))))))
(define ProtocolC-45IDEC-45Highlight-u--toSExp_SExpable_Highlight (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (vector 0 (cons (ProtocolC-45IDEC-45FileContext-u--toSExp_SExpable_FileContext e-0) (cons (vector 0 (cons (vector 0 (cons (vector 4 "name") (cons (vector 1 e-1) '()))) (cons (vector 0 (cons (vector 4 "namespace") (cons (vector 1 e-7) '()))) (cons (ProtocolC-45IDEC-45Decoration-u--toSExp_SExpable_Decoration e-4) (cons (vector 0 (cons (vector 4 "implicit") (cons (ProtocolC-45SExp-u--toSExp_SExpable_Bool e-2) '()))) (cons (vector 0 (cons (vector 4 "key") (cons (vector 1 e-3) '()))) (cons (vector 0 (cons (vector 4 "doc-overview") (cons (vector 1 e-5) '()))) (cons (vector 0 (cons (vector 4 "type") (cons (vector 1 e-6) '()))) '())))))))) '())))))))))))))
(define ProtocolC-45IDEC-45Highlight-u--toSExp_SExpable_LwHighlight (lambda (arg-0) (vector 0 (cons (ProtocolC-45IDEC-45FileContext-u--toSExp_SExpable_FileContext (let ((e-0 (car arg-0))) e-0)) (cons (vector 0 (cons (ProtocolC-45IDEC-45Decoration-u--toSExp_SExpable_Decoration (let ((e-1 (cdr arg-0))) e-1)) '())) '())))))
(define ProtocolC-45IDEC-45Highlight-u--toSExp_SExpable_SourceHighlight (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (ProtocolC-45IDEC-45Highlight-u--toSExp_SExpable_Highlight e-0))) (else (let ((e-1 (vector-ref arg-0 1))) (ProtocolC-45IDEC-45Highlight-u--toSExp_SExpable_LwHighlight e-1))))))
(define ProtocolC-45IDE-u--toSExp_SExpable_ReplyPayload (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (vector 0 (cons (vector 4 "ok") (cons (ProtocolC-45IDEC-45Result-u--toSExp_SExpable_Result e-0) (if (null? e-1) '() (cons (vector 0 (PreludeC-45TypesC-45List-mapAppend '() csegen-3717 e-1)) '())))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (vector 0 (cons (vector 4 "ok") (cons (vector 0 (cons (vector 4 "highlight-source") (cons (ProtocolC-45SExp-u--toSExp_SExpable_C-40ListC-32C-36aC-41 (lambda (eta-0) (ProtocolC-45IDEC-45Highlight-u--toSExp_SExpable_SourceHighlight eta-0)) e-2) '()))) '()))))) (else (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (vector 0 (cons (vector 4 "error") (cons (ProtocolC-45SExp-u--toSExp_SExpable_String e-3) (if (null? e-4) '() (cons (vector 0 (PreludeC-45TypesC-45List-mapAppend '() csegen-3717 e-4)) '())))))))))))
(define ProtocolC-45IDE-u--toSExp_SExpable_Reply (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (ProtocolC-45SExp-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (lambda (eta-0) eta-0) (lambda (eta-0) (ProtocolC-45SExp-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3718 eta-0))) (cons (vector 4 "protocol-version") (cons e-0 e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (vector 0 (cons (vector 4 "return") (cons (ProtocolC-45IDE-u--toSExp_SExpable_ReplyPayload e-2) (cons (ProtocolC-45SExp-u--toSExp_SExpable_Integer e-3) '()))))))) ((2) (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (vector 0 (cons (vector 4 "output") (cons (ProtocolC-45IDE-u--toSExp_SExpable_ReplyPayload e-4) (cons (ProtocolC-45SExp-u--toSExp_SExpable_Integer e-5) '()))))))) ((3) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (vector 0 (cons (vector 4 "write-string") (cons (ProtocolC-45SExp-u--toSExp_SExpable_String e-6) (cons (ProtocolC-45SExp-u--toSExp_SExpable_Integer e-7) '()))))))) ((4) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (vector 0 (cons (vector 4 "set-prompt") (cons (ProtocolC-45SExp-u--toSExp_SExpable_String e-8) (cons (ProtocolC-45SExp-u--toSExp_SExpable_Integer e-9) '()))))))) (else (let ((e-10 (vector-ref arg-0 1))) (let ((e-11 (vector-ref arg-0 2))) (let ((e-12 (vector-ref arg-0 3))) (let ((e-13 (vector-ref arg-0 4))) (vector 0 (cons (vector 4 "warning") (cons (vector 0 (cons (ProtocolC-45SExp-u--toSExp_SExpable_String (let ((e-0 (car e-10))) e-0)) (cons (ProtocolC-45SExp-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3718 (cons (let ((e-1 (cdr e-10))) (let ((e-5 (vector-ref e-1 0))) e-5)) (let ((e-1 (cdr e-10))) (let ((e-4 (vector-ref e-1 1))) e-4)))) (cons (ProtocolC-45SExp-u--toSExp_SExpable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3718 (cons (let ((e-1 (cdr e-10))) (let ((e-2 (vector-ref e-1 2))) e-2)) (let ((e-1 (cdr e-10))) (let ((e-3 (vector-ref e-1 3))) e-3)))) (cons (ProtocolC-45SExp-u--toSExp_SExpable_String e-11) (if (null? e-12) '() (cons (vector 0 (PreludeC-45TypesC-45List-mapAppend '() csegen-3717 e-12)) '()))))))) (cons (ProtocolC-45SExp-u--toSExp_SExpable_Integer e-13) '()))))))))))))
(define IdrisC-45IDEModeC-45Commands-send (lambda (arg-0 arg-1 arg-2) (let ((u--r (string-append (ProtocolC-45SExp-u--show_Show_SExp (ProtocolC-45IDE-u--toSExp_SExpable_Reply arg-2)) "\xa;"))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.send" 20 (lambda () u--r) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (IdrisC-45IDEModeC-45Commands-sendStr arg-1 (ProtocolC-45Hex-leftPad #\0 6 (ProtocolC-45Hex-asHex (blodwen-toUnsignedInt (PreludeC-45TypesC-45String-length u--r) 64))) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (IdrisC-45IDEModeC-45Commands-sendStr arg-1 u--r eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((SystemC-45FileC-45Process-fflush csegen-82 arg-1) eta-0))) (vector 1 act-4)))))))))))))))
(define IdrisC-45REPLC-45Common-iputStrLn (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-8 (vector-ref e-5 8))) (lambda (clam-0) (case (vector-ref e-8 0) ((1) (let ((e-18 (vector-ref e-8 1))) (cond ((equal? e-18 2) (let ((act-2 (IdrisC-45Pretty-render arg-1 arg-2 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-19 (vector-ref act-2 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (PreludeC-45IO-prim__putStr (string-append e-19 "\xa;") eta-0))) (vector 1 act-3))))) eff-0) clam-0))))))(else (vector 1 (vector 0 )))))) (else (let ((e-20 (vector-ref e-8 1))) (let ((e-18 (vector-ref e-8 3))) (let ((act-2 (IdrisC-45PrettyC-45Render-renderWithoutColor arg-1 arg-2 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-21 (vector-ref act-2 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45Commands-send arg-0 e-18 (vector 3 e-21 e-20)))) eff-0) clam-0))))))))))))) eff-0) ext-0)))))))
(define SystemC-45FileC-45Handle-closeFile (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45FileC-45Handle-prim__close arg-2 eta-0))))))
(define SystemC-45FileC-45Mode-modeStr (lambda (arg-0) (cond ((equal? arg-0 0) (let ((sc1 SystemC-45Info-isWindows)) (cond ((equal? sc1 1) "rb") (else "r")))) ((equal? arg-0 1) (let ((sc1 SystemC-45Info-isWindows)) (cond ((equal? sc1 1) "wb") (else "w")))) ((equal? arg-0 2) (let ((sc1 SystemC-45Info-isWindows)) (cond ((equal? sc1 1) "ab") (else "a")))) ((equal? arg-0 3) (let ((sc1 SystemC-45Info-isWindows)) (cond ((equal? sc1 1) "rb+") (else "r+")))) ((equal? arg-0 4) (let ((sc1 SystemC-45Info-isWindows)) (cond ((equal? sc1 1) "wb+") (else "w+")))) (else (let ((sc1 SystemC-45Info-isWindows)) (cond ((equal? sc1 1) "ab+") (else "a+")))))))
(define SystemC-45FileC-45Handle-openFile (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Handle-prim__open arg-2 (SystemC-45FileC-45Mode-modeStr arg-3) eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--res) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 u--res))))))))))
(define CoreC-45Directory-firstAvailable (lambda (arg-0 arg-1 ext-0) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "import.file" 30 (lambda () (string-append "Attempting to read " e-2)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (let ((act-2 ((SystemC-45FileC-45Handle-openFile csegen-82 e-2 0) ext-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-6 0) ((1) (let ((e-4 (vector-ref e-6 1))) (lambda (eta-0) (let ((act-3 (let ((act-3 ((SystemC-45FileC-45Handle-closeFile csegen-82 e-4) eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (vector 1 (box e-2)))))))) (else (lambda (eta-0) (CoreC-45Directory-firstAvailable arg-0 e-3 eta-0)))))) eff-0) ext-0)))))))))))))
(define CoreC-45Context-getDirs (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-43 (vector-ref e-4 0))) e-43)))))) eff-0) ext-0)))))))
(define ParserC-45Unlit-listOfExtensionsLiterate (let ((u--exts (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (let ((e-2 (vector-ref eta-0 2))) e-2)) (cons ParserC-45Unlit-styleBird (cons ParserC-45Unlit-styleOrg (cons ParserC-45Unlit-styleCMark (cons ParserC-45Unlit-styleTeX '()))))))) (PreludeC-45Types-listBind (cons "" (cons ".idr" (cons ".lidr" '()))) (lambda (u--pfx) (PreludeC-45Types-listBind u--exts (lambda (u--ext) (PreludeC-45Types-u--pure_Applicative_List (string-append u--pfx u--ext))))))))
(define CoreC-45Directory-listOfExtensionsStr (PreludeC-45TypesC-45List-tailRecAppend ParserC-45Unlit-listOfExtensionsLiterate (cons ".yaff" (cons ".idr" '()))))
(define LibrariesC-45UtilsC-45Path-joinPath (lambda (arg-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45Path-C-47C-62 eta-0 eta-1))) (LibrariesC-45UtilsC-45Path-parse "") arg-0))))
(define CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath (lambda (ext-0) (LibrariesC-45UtilsC-45Path-joinPath (PreludeC-45TypesC-45List-reverse ext-0))))
(define CoreC-45Directory-nsToSource (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fnameOrig (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-2))) (let ((u--fnameBase (CoreC-45Directory-cleanPath (PreludeC-45Types-maybe (lambda () u--fnameOrig) (lambda () (lambda (u--srcdir) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--srcdir u--fnameOrig))) (let ((e-1 (vector-ref e-5 1))) e-1))))) (let ((u--fs (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-3) (string-append u--fnameBase arg-3)) CoreC-45Directory-listOfExtensionsStr))) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-firstAvailable arg-0 u--fs eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 arg-1 arg-2) clam-0) (let ((e-1 (unbox e-6))) (vector 1 e-1)))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (cons (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-3 '()) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-4 '()))) ((1) (let ((e-14 (vector-ref arg-6 1))) (let ((e-15 (vector-ref arg-6 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 (+ arg-2 1) (cons arg-3 (string e-14)) arg-4 arg-5 (e-15))))) ((2) (let ((e-17 (vector-ref arg-6 1))) (let ((e-18 (vector-ref arg-6 2))) (let ((e-19 (vector-ref arg-6 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 (+ (PreludeC-45Types-prim__integerToNat e-17) arg-2) (cons arg-3 e-18) arg-4 arg-5 (e-19)))))) ((3) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((u--text (string-cons (integer->char 10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-21)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 (+ (+ (PreludeC-45Types-prim__integerToNat e-21) 1) arg-2) (cons arg-3 u--text) arg-4 arg-5 e-22))))) ((4) (let ((e-24 (vector-ref arg-6 1))) (let ((e-25 (vector-ref arg-6 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 arg-2 arg-3 arg-4 (cons (cons arg-2 e-24) arg-5) e-25))))(else (if (null? arg-5) (let ((e-11 (vector-ref arg-6 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 arg-2 arg-3 arg-4 '() e-11)) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (let ((e-9 (vector-ref arg-6 1))) (let ((u--span (vector e-6 (PreludeC-45Types-prim__integerToNat (- arg-2 e-6)) e-7))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 arg-2 arg-3 (cons arg-4 u--span) e-2 e-9))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-displaySpans (lambda (arg-1) (let ((sc0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-n--9196-14477-u--go arg-1 0 '() '() '() arg-1))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) e-2) e-3))))))
(define IdrisC-45PrettyC-45Render-renderWithSpans (lambda (arg-1 arg-2 ext-0) (let ((act-1 (IdrisC-45PrettyC-45Render-getPageWidth arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--layout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutPretty e-5 arg-2))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-displaySpans u--layout)))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45Span-u--traverse_Traversable_Span (lambda (arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-3 0))) ((((e-6 'erased) 'erased) (lambda (eta-0) (vector e-1 e-2 eta-0))) (arg-4 e-3))))))))
(define IdrisC-45Pretty-renderWithDecorations (lambda (arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (IdrisC-45PrettyC-45Render-renderWithSpans arg-3 arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((u--spans (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (LibrariesC-45DataC-45Span-u--traverse_Traversable_Span csegen-255 arg-4 eta-0)) e-3))) (lambda (eta-0) (vector 1 (cons e-2 u--spans)))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45Commands-u--cast_Cast_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32NonEmptyFCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32NonEmptyFCC-41C-124C-41_FileContext (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-10))) (let ((e-15 (cdr e-10))) (let ((e-18 (car e-11))) (let ((e-19 (cdr e-11))) (cons e-2 (vector e-14 e-15 e-18 e-19)))))))))))))
(define IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32emitProblem-5957 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (IdrisC-45REPLC-45Common-iputStrLn arg-7 arg-6 arg-13 eta-0)) (let ((e-2 (unbox arg-14))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((act-1 (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((u--fc (vector 0 (vector 0 e-0) e-9 e-10))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (CoreC-45Directory-nsToSource arg-7 u--fc e-0 eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 1 "(File-Not-Found)"))) clam-0)))) ((1) (let ((e-1 (vector-ref e-5 1))) (vector 1 e-1))) (else (vector 1 "(Interactive)"))))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Pretty-renderWithDecorations arg-7 arg-6 (lambda (eta-1) (IdrisC-45IDEModeC-45Pretty-annToProperties eta-1)) arg-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--nfc (cons e-5 (cons e-9 e-10)))) (let ((e-4 (car e-8))) (let ((e-3 (cdr e-8))) (IdrisC-45IDEModeC-45Commands-send arg-7 arg-11 (vector 5 (IdrisC-45IDEModeC-45Commands-u--cast_Cast_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32NonEmptyFCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32NonEmptyFCC-41C-124C-41_FileContext (cons e-7 u--nfc)) e-4 e-3 arg-12))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define IdrisC-45REPLC-45Common-emitProblem (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-8 (vector-ref e-5 8))) (case (vector-ref e-8 0) ((1) (let ((act-2 ((arg-5 arg-4) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-19 (vector-ref act-2 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45REPLC-45Common-printWithStatus arg-2 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Pretty-render arg-2 eta-1 eta-2))) e-19 arg-8 eta-0)))) eff-0) clam-0)))))) (else (let ((e-20 (vector-ref e-8 1))) (let ((e-19 (vector-ref e-8 2))) (let ((e-18 (vector-ref e-8 3))) (let ((act-2 ((arg-6 arg-4) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-21 (vector-ref act-2 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32emitProblem-5957 arg-8 arg-7 arg-6 arg-5 arg-3 arg-2 arg-1 e-5 e-19 arg-4 e-18 e-20 e-21 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45FC-toNonEmptyFC eta-0)) (arg-7 arg-4))))) eff-0) clam-0)))))))))))))) eff-0) ext-0)))))))
(define CoreC-45Core-getWarningLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-3 (vector-ref arg-0 2))) e-3)) ((2) (let ((e-6 (vector-ref arg-0 1))) e-6)) ((3) (let ((e-8 (vector-ref arg-0 1))) e-8)) ((4) (let ((e-12 (vector-ref arg-0 1))) e-12)) ((5) (let ((e-14 (vector-ref arg-0 1))) (let ((e-16 (vector-ref arg-0 3))) (DataC-45Maybe-fromMaybe (lambda () e-14) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) e-16))))) (else (let ((e-17 (vector-ref arg-0 1))) e-17)))))
(define CoreC-45Core-getErrorLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45Core-getErrorLoc e-0))) ((1) (let ((e-2 (vector-ref arg-0 2))) (box e-2))) ((2) (let ((e-8 (vector-ref arg-0 2))) (box e-8))) ((3) (let ((e-14 (vector-ref arg-0 2))) (box e-14))) ((4) (let ((e-20 (vector-ref arg-0 2))) (box e-20))) ((5) (let ((e-25 (vector-ref arg-0 2))) (box e-25))) ((6) (let ((e-32 (vector-ref arg-0 2))) (box e-32))) ((7) (let ((e-35 (vector-ref arg-0 1))) (box e-35))) ((8) (let ((e-37 (vector-ref arg-0 1))) (box e-37))) ((9) (let ((e-40 (vector-ref arg-0 1))) (box e-40))) ((10) (let ((e-42 (vector-ref arg-0 1))) (box e-42))) ((11) (let ((e-45 (vector-ref arg-0 1))) (box e-45))) ((12) (let ((e-48 (vector-ref arg-0 1))) (box e-48))) ((13) (let ((e-51 (vector-ref arg-0 1))) (box e-51))) ((14) (let ((e-54 (vector-ref arg-0 1))) (box e-54))) ((15) (let ((e-59 (vector-ref arg-0 2))) (box e-59))) ((16) (let ((e-64 (vector-ref arg-0 2))) (box e-64))) ((17) (let ((e-67 (vector-ref arg-0 1))) (box e-67))) ((18) (let ((e-70 (vector-ref arg-0 2))) (box e-70))) ((19) (let ((e-74 (vector-ref arg-0 2))) (box e-74))) ((20) (let ((e-78 (vector-ref arg-0 1))) (box e-78))) ((21) (let ((e-81 (vector-ref arg-0 1))) (if (null? e-81) '() (let ((e-221 (car e-81))) (let ((e-227 (cdr e-221))) (CoreC-45Core-getErrorLoc e-227)))))) ((22) (let ((e-83 (vector-ref arg-0 2))) (box e-83))) ((23) (let ((e-85 (vector-ref arg-0 1))) (box e-85))) ((24) (let ((e-87 (vector-ref arg-0 1))) (box e-87))) ((25) (let ((e-90 (vector-ref arg-0 1))) (box e-90))) ((26) (let ((e-92 (vector-ref arg-0 1))) (box e-92))) ((27) (let ((e-95 (vector-ref arg-0 2))) (box e-95))) ((28) (let ((e-100 (vector-ref arg-0 2))) (box e-100))) ((29) (let ((e-104 (vector-ref arg-0 2))) (box e-104))) ((30) (let ((e-109 (vector-ref arg-0 2))) (box e-109))) ((31) (let ((e-115 (vector-ref arg-0 2))) (box e-115))) ((32) (let ((e-120 (vector-ref arg-0 1))) (if (null? e-120) '() (let ((e-229 (car e-120))) (let ((e-234 (car e-229))) (box e-234)))))) ((33) (let ((e-122 (vector-ref arg-0 2))) (box e-122))) ((34) (let ((e-128 (vector-ref arg-0 2))) (box e-128))) ((35) (let ((e-132 (vector-ref arg-0 1))) (box e-132))) ((36) (let ((e-137 (vector-ref arg-0 1))) (box e-137))) ((37) (let ((e-139 (vector-ref arg-0 1))) (box e-139))) ((38) (let ((e-141 (vector-ref arg-0 1))) (box e-141))) ((39) (let ((e-143 (vector-ref arg-0 1))) (box e-143))) ((40) (let ((e-146 (vector-ref arg-0 2))) (box e-146))) ((41) (let ((e-150 (vector-ref arg-0 2))) (box e-150))) ((42) (let ((e-155 (vector-ref arg-0 2))) (box e-155))) ((43) (let ((e-158 (vector-ref arg-0 1))) (box e-158))) ((44) (let ((e-162 (vector-ref arg-0 2))) (box e-162))) ((45) (let ((e-166 (vector-ref arg-0 2))) (box e-166))) ((46) (let ((e-171 (vector-ref arg-0 1))) (box e-171))) ((47) (let ((e-174 (vector-ref arg-0 2))) (box e-174))) ((48) (let ((e-178 (vector-ref arg-0 1))) (CoreC-45Core-getErrorLoc e-178))) ((49) (let ((e-179 (vector-ref arg-0 1))) (box e-179))) ((50) '()) ((51) '()) ((52) '()) ((53) (let ((e-185 (vector-ref arg-0 1))) (box e-185))) ((54) (let ((e-186 (vector-ref arg-0 1))) (box e-186))) ((55) (let ((e-187 (vector-ref arg-0 1))) (box e-187))) ((56) (let ((e-188 (vector-ref arg-0 1))) (box e-188))) ((57) (let ((e-190 (vector-ref arg-0 1))) (let ((e-237 (car e-190))) (let ((e-241 (car e-237))) (box e-241))))) ((58) (let ((e-191 (vector-ref arg-0 1))) (box e-191))) ((59) '()) ((60) '()) ((61) '()) ((62) '()) ((63) (let ((e-196 (vector-ref arg-0 1))) (box e-196))) ((64) (let ((e-198 (vector-ref arg-0 1))) (box e-198))) ((65) '()) ((68) (let ((e-203 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-203))) ((69) (let ((e-206 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-206))) ((66) (let ((e-207 (vector-ref arg-0 1))) (box e-207))) ((67) (let ((e-208 (vector-ref arg-0 1))) (box e-208))) ((70) (let ((e-213 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-213))) ((71) (let ((e-216 (vector-ref arg-0 3))) (CoreC-45Core-getErrorLoc e-216))) ((72) (let ((e-217 (vector-ref arg-0 1))) (CoreC-45Core-getErrorLoc e-217))) (else (let ((e-219 (vector-ref arg-0 1))) (box (CoreC-45Core-getWarningLoc e-219)))))))
(define IdrisC-45REPLC-45Common-emitError (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (IdrisC-45REPLC-45Common-emitProblem arg-0 arg-1 arg-2 arg-3 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-display arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-perror arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (CoreC-45Core-getErrorLoc eta-0)) 1 ext-0)))
(define IdrisC-45Driver-findInput (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((25) (let ((e-4 (vector-ref e-2 1))) (box e-4)))(else (IdrisC-45Driver-findInput e-3))))))))
(define CoreC-45Context-addDataDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 e-45 e-46 e-47 e-48 e-49 e-50 e-51 (PreludeC-45TypesC-45List-tailRecAppend e-52 (cons arg-1 '()))) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-addPackageDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 e-45 e-46 e-47 e-48 e-49 (cons arg-1 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-2 arg-1)) e-50)) e-51 e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define LibrariesC-45DataC-45StringMap-empty '())
(define DataC-45String-indent (lambda (arg-0 arg-1) (string-append (DataC-45String-replicate arg-0 #\ ) arg-1)))
(define IdrisC-45Package-reason (lambda (arg-0) (if (null? arg-0) "no matching version is installed" (let ((e-2 (unbox arg-0))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "assigned version " (cons (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion e-2) (cons " which is out of bounds" '()))))))))
(define IdrisC-45PackageC-45Types-n--5001-5741-u--lowerBounds (lambda (arg-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--v) (string-append (let ((sc0 (let ((e-1 (vector-ref arg-0 1))) e-1))) (cond ((equal? sc0 1) ">= ") (else "> "))) (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion u--v))) (let ((e-0 (vector-ref arg-0 0))) e-0))))
(define DataC-45Maybe-isNothing (lambda (arg-1) (if (null? arg-1) 1 0)))
(define IdrisC-45PackageC-45Types-n--5001-5742-u--noBounds (lambda (arg-0) (let ((sc0 (DataC-45Maybe-isNothing (let ((e-0 (vector-ref arg-0 0))) e-0)))) (cond ((equal? sc0 1) (DataC-45Maybe-isNothing (let ((e-2 (vector-ref arg-0 2))) e-2))) (else 0)))))
(define IdrisC-45PackageC-45Types-n--5001-5743-u--upperBounds (lambda (arg-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--v) (string-append (let ((sc0 (let ((e-3 (vector-ref arg-0 3))) e-3))) (cond ((equal? sc0 1) "<= ") (else "< "))) (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion u--v))) (let ((e-2 (vector-ref arg-0 2))) e-2))))
(define IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds (lambda (arg-0) (let ((sc0 (IdrisC-45PackageC-45Types-n--5001-5742-u--noBounds arg-0))) (cond ((equal? sc0 1) "any") (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse " && " (DataC-45List-catMaybes (cons (IdrisC-45PackageC-45Types-n--5001-5741-u--lowerBounds arg-0) (cons (IdrisC-45PackageC-45Types-n--5001-5743-u--upperBounds arg-0) '()))))))))))
(define IdrisC-45Package-n--19011-11188-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (let ((u--pre (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "required " (cons (let ((e-0 (car arg-1))) e-0) (cons " " (cons (IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds (let ((e-1 (cdr arg-1))) e-1)) (cons " but" '())))))))) (PreludeC-45Types-fastConcat (DataC-45List-intersperse "; " (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-3 (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons u--pre (cons " " (cons (IdrisC-45Package-reason arg-0) '())))) '()))))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((u--v (DataC-45Maybe-fromMaybe (lambda () (cons 0 '())) (let ((e-1 (vector-ref e-2 1))) e-1)))) (IdrisC-45Package-n--19011-11188-u--go arg-0 arg-1 arg-2 (cons arg-3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (let ((e-0 (vector-ref e-2 0))) e-0) (cons "-" (cons (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion u--v) '()))))) e-3)))))))
(define IdrisC-45Package-printResolutionError (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (IdrisC-45Package-n--19011-11188-u--go e-2 e-1 e-0 '() e-0))))))
(define IdrisC-45Package-printErrs (lambda (arg-0 arg-1) (DataC-45String-fastUnlines (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Failed to resolve the dependencies for " (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (cons ":" '())))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (DataC-45String-indent 2 (IdrisC-45Package-printResolutionError eta-0))) arg-1)))))
(define IdrisC-45PackageC-45Types-exactBounds (lambda (arg-0) (vector arg-0 1 arg-0 1)))
(define SystemC-45Directory-closeDir (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45Directory-prim__closeDir arg-2 eta-0))))))
(define SystemC-45Errno-getErrno (lambda (arg-1) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45Errno-prim__getErrno eta-0))))))
(define SystemC-45Directory-nextDirEntry (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__dirEntry arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--res) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (SystemC-45Errno-getErrno arg-1)) (lambda (bind-0) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int bind-0 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (let ((e-12 (car arg-1))) (let ((e-15 (vector-ref e-12 0))) (let ((e-17 (vector-ref e-15 1))) ((e-17 'erased) (vector 1 '()))))))))))))) (else (let ((u--n (PreludeC-45IO-prim__getString u--res))) (let ((sc2 (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--n "."))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--n "..")))))) (cond ((equal? sc2 1) (SystemC-45Directory-nextDirEntry arg-1 arg-2)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (box u--n)))))))))))))))))))
(define PreludeC-45InterfacesC-45Monad-u--C-62C-62C-61_Monad_ComposeC-40C-40C-46C-32C-36mC-41C-32C-36tC-41 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) arg-7) (lambda (eta-0) (((let ((eff-0 (let ((e-6 (vector-ref arg-4 0))) (let ((e-9 (vector-ref e-6 0))) e-9)))) (lambda (arg-0) (lambda (arg-1) ((((eff-0 'erased) 'erased) arg-0) arg-1)))) (lambda (clam-0) (let ((e-4 (vector-ref arg-5 2))) ((e-4 'erased) clam-0)))) (let ((e-4 (vector-ref arg-6 2))) ((((((e-4 'erased) 'erased) 'erased) (let ((e-9 (vector-ref arg-4 0))) e-9)) arg-8) eta-0))))))))
(define SystemC-45Directory-n--3611-1655-u--C-62C-62C-61 (lambda (arg-1 arg-2 ext-0 ext-1) (PreludeC-45InterfacesC-45Monad-u--C-62C-62C-61_Monad_ComposeC-40C-40C-46C-32C-36mC-41C-32C-36tC-41 csegen-81 (vector (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-2 (vector-ref arg-9937 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) csegen-150 csegen-151) (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) csegen-167 csegen-171) ext-0 ext-1)))
(define SystemC-45Directory-collectDir (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (SystemC-45Directory-n--3611-1655-u--C-62C-62C-61 arg-1 arg-2 (SystemC-45Directory-nextDirEntry csegen-82 arg-2) (lambda (_-0) (if (null? _-0) (lambda (eta-0) (vector 1 '())) (let ((e-3 (unbox _-0))) (SystemC-45Directory-n--3611-1655-u--C-62C-62C-61 arg-1 arg-2 (SystemC-45Directory-collectDir csegen-82 arg-2) (lambda (u--ns) (lambda (eta-0) (vector 1 (cons e-3 u--ns)))))))))))))
(define SystemC-45Directory-ok (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 1 arg-3)))))))
(define SystemC-45Directory-openDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__openDir arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--res) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45Directory-ok arg-1 u--res))))))))))
(define SystemC-45Directory-listDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45Directory-openDir arg-1 arg-2)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45Directory-collectDir arg-1 e-6)) (lambda (u--ns) (let ((e-13 (car arg-1))) (let ((e-15 (vector-ref e-13 1))) ((((e-15 'erased) 'erased) (SystemC-45Directory-closeDir arg-1 e-6)) (lambda (u--ignore) (let ((e-18 (car arg-1))) (let ((e-21 (vector-ref e-18 0))) (let ((e-23 (vector-ref e-21 1))) ((e-23 'erased) u--ns)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 e-6))))))))))))))
(define DataC-45List1-u--traverse_Traversable_List1 (lambda (arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (let ((e-6 (vector-ref arg-3 2))) ((((e-6 'erased) 'erased) (let ((e-10 (vector-ref arg-3 1))) ((e-10 'erased) csegen-181))) (arg-4 e-1)))) (PreludeC-45Types-u--traverse_Traversable_List arg-3 arg-4 e-2)))))))
(define IdrisC-45SetOptions-n--13111-5573-u--toVersion (lambda (arg-0 ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) eta-0) (DataC-45List1-u--traverse_Traversable_List1 csegen-255 (lambda (eta-0) (DataC-45String-parsePositive csegen-110 eta-0)) (DataC-45String-split csegen-520 ext-0)))))
(define IdrisC-45SetOptions-case--pkgDir-5634 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) (vector arg-0 e-3 '()) (let ((sc2 (IdrisC-45SetOptions-n--13111-5573-u--toVersion arg-0 e-3))) (if (null? sc2) (vector arg-0 arg-0 '()) (let ((e-1 (unbox sc2))) (vector arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse "-" e-2)) (box e-1))))))))))
(define IdrisC-45SetOptions-pkgDir (lambda (arg-0) (IdrisC-45SetOptions-case--pkgDir-5634 arg-0 (LibrariesC-45DataC-45List1-unsnoc (DataC-45String-split csegen-147 arg-0)))))
(define IdrisC-45SetOptions-getPackageDirs (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45SetOptions-pkgDir eta-1)) (PreludeC-45Types-either (lambda () (lambda (eta-1) '())) (lambda () (lambda (eta-1) eta-1)) eta-0))) (SystemC-45Directory-listDir csegen-82 arg-0) ext-0)))
(define IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion (lambda (arg-0 arg-1) (DataC-45List1-u--compare_Ord_C-40List1C-32C-36aC-41 csegen-1647 arg-0 arg-1)))
(define IdrisC-45PackageC-45Types-u--C-60C-61_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 2)))
(define IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 0)))
(define IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 0)))
(define IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-0 arg-1) 2)))
(define IdrisC-45PackageC-45Types-inBounds (lambda (arg-0 arg-1) (let ((u--v (DataC-45Maybe-fromMaybe (lambda () (cons 0 '())) arg-0))) (let ((sc0 (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (u--vC-39) (let ((sc1 (let ((e-1 (vector-ref arg-1 1))) e-1))) (cond ((equal? sc1 1) (IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion u--v u--vC-39)) (else (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion u--v u--vC-39)))))) (let ((e-0 (vector-ref arg-1 0))) e-0)))) (cond ((equal? sc0 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (u--vC-39) (let ((sc1 (let ((e-3 (vector-ref arg-1 3))) e-3))) (cond ((equal? sc1 1) (IdrisC-45PackageC-45Types-u--C-60C-61_Ord_PkgVersion u--v u--vC-39)) (else (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion u--v u--vC-39)))))) (let ((e-2 (vector-ref arg-1 2))) e-2))) (else 0))))))
(define IdrisC-45SetOptions-n--13262-5740-u--checkBounds (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 arg-1))) (cond ((equal? sc0 1) (IdrisC-45PackageC-45Types-inBounds e-2 arg-0)) (else 0)))) (lambda (_-10649) (box (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 e-0) e-2)))))))))
(define IdrisC-45SetOptions-candidateDirs (lambda (arg-0 arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) (IdrisC-45SetOptions-n--13262-5740-u--checkBounds arg-2 arg-1 arg-0 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SetOptions-getPackageDirs arg-0 eta-0)) ext-0)))
(define CoreC-45Directory-pkgGlobalDirectory (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-10 (vector-ref e-5 5))) e-10) (string-append "idris2-" csegen-1634)))))) eff-0) ext-0)))))))
(define CoreC-45Directory-pkgLocalDirectory (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (csegen-1310 eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't get current directory") clam-0) (let ((e-1 (unbox e-6))) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 (let ((e-3 (vector-ref e-5 3))) e-3)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion (lambda (arg-0 arg-1) (DataC-45List1-u--C-61C-61_Eq_C-40List1C-32C-36aC-41 csegen-1032 arg-0 arg-1)))
(define IdrisC-45PackageC-45Types-u--C-47C-61_Eq_PkgVersion (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45PackageC-45Types-u--max_Ord_PkgVersion (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define IdrisC-45PackageC-45Types-u--min_Ord_PkgVersion (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define IdrisC-45SetOptions-findPkgDirs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Directory-pkgGlobalDirectory arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Directory-pkgLocalDirectory arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (IdrisC-45SetOptions-candidateDirs e-6 arg-1 arg-2 eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (IdrisC-45SetOptions-candidateDirs e-5 arg-1 arg-2 eta-2))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-getDirs arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 ((PreludeC-45Types-u--traverse_Traversable_List csegen-75 (lambda (u--d) (lambda (eta-5) (IdrisC-45SetOptions-candidateDirs u--d arg-1 arg-2 eta-5))) (let ((e-12 (vector-ref e-9 7))) e-12)) eta-4))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--allFiles (let ((sc6 (DataC-45List-isNil e-7))) (cond ((equal? sc6 1) (PreludeC-45TypesC-45List-tailRecAppend e-8 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-5) eta-5) e-10))) (else e-7))))) (lambda (eta-5) (vector 1 (DataC-45List-sortBy (lambda (u--x) (lambda (u--y) (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 (vector (cons (lambda (arg-676) (lambda (arg-679) (IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (IdrisC-45PackageC-45Types-u--C-47C-61_Eq_PkgVersion arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (IdrisC-45PackageC-45Types-u--compare_Ord_PkgVersion arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (IdrisC-45PackageC-45Types-u--C-60C-61_Ord_PkgVersion arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (IdrisC-45PackageC-45Types-u--max_Ord_PkgVersion arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (IdrisC-45PackageC-45Types-u--min_Ord_PkgVersion arg-1626 arg-1629)))) (Builtin-snd u--y) (Builtin-snd u--x)))) u--allFiles)))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45SetOptions-findPkgDir (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45SetOptions-findPkgDirs arg-0 arg-1 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((sc3 (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 2))) (let ((e-62 (vector-ref e-42 7))) e-62))))) (cond ((equal? sc3 1) (vector 1 '())) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 52 (string-append arg-1 (string-append " (" (string-append (IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds arg-2) ")")))) clam-0)))) (let ((e-2 (car e-6))) (let ((e-8 (car e-2))) (vector 1 (box e-8)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (arg-3 (cons e-1 e-2))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 arg-3 e-7))) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 (lambda (arg-1) (cons arg-1 (LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 arg-3 e-14))) e-12))) e-10))))))))
(define LibrariesC-45DataC-45StringMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45StringMap-n--5358-3210-u--treeToListC-39 (lambda (arg-0) (cons arg-0 '())) ext-0)))
(define LibrariesC-45DataC-45StringMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45StringMap-treeToList e-3)))))
(define LibrariesC-45UtilsC-45Path-case--splitFileName-7153 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (cons arg-0 "") (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cond ((equal? e-6 #\.) (if (null? e-7) (cons arg-0 "") (cons (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-7)) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-2)))))(else (cons (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-7)) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-2))))))))))))
(define LibrariesC-45UtilsC-45Path-splitFileName (lambda (arg-0) (LibrariesC-45UtilsC-45Path-case--splitFileName-7153 arg-0 (DataC-45List-break csegen-520 (PreludeC-45TypesC-45List-reverse (PreludeC-45Types-fastUnpack arg-0))))))
(define LibrariesC-45UtilsC-45Path-case--C-60C-46C-62-7818 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-1 (let ((e-1 (unbox arg-5))) (let ((sc1 (LibrariesC-45UtilsC-45Path-splitFileName e-1))) (let ((e-2 (car sc1))) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-setFileNameC-39 (string-append e-2 arg-4) arg-2))))))))
(define LibrariesC-45UtilsC-45Path-C-60C-46C-62 (lambda (arg-0 arg-1) (let ((u--pathC-39 (LibrariesC-45UtilsC-45Path-parse arg-0))) (let ((u--ext (PreludeC-45Types-fastPack (DataC-45List-dropWhile csegen-597 (PreludeC-45Types-fastUnpack arg-1))))) (let ((ext-0 (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--ext ""))) (cond ((equal? sc0 1) "") (else (string-append "." u--ext)))))) (LibrariesC-45UtilsC-45Path-case--C-60C-46C-62-7818 arg-1 arg-0 u--pathC-39 u--ext ext-0 (LibrariesC-45UtilsC-45Path-fileNameC-39 u--pathC-39)))))))
(define CompilerC-45Common-exists (lambda (arg-0 ext-0) (let ((act-1 ((SystemC-45FileC-45Handle-openFile csegen-82 arg-0 0) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 ((SystemC-45FileC-45Handle-closeFile csegen-82 e-2) ext-0))) 1))) (else 0)))))
(define LibrariesC-45DataC-45StringMap-treeInsertC-39 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (PreludeC-45EqOrd-u--compare_Ord_String arg-2 e-1))) (cond ((equal? sc1 0) (vector 1 (cons (vector 0 arg-2 arg-3) (cons arg-2 (vector 0 e-1 e-2))))) ((equal? sc1 1) (vector 0 (vector 0 arg-2 arg-3))) (else (vector 1 (cons (vector 0 e-1 e-2) (cons e-1 (vector 0 arg-2 arg-3)))))))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-6))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-5))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-6 e-7)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-10 e-12 e-13 e-6 e-7))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-5 e-6 e-2)))) (else (let ((e-8 (vector-ref sc2 1))) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 0 (vector 2 e-5 e-6 e-10 e-12 e-13))))))))))))))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-11))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-10))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-11 e-12 e-13 e-14)))) (else (let ((e-5 (vector-ref sc2 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-8 e-16 e-15) (cons e-11 (vector 1 e-12 e-13 e-14))))))))))))) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60C-61_Ord_String arg-2 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-12))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-2 e-13 e-14)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-8) (cons e-16 (vector 1 e-15 e-13 e-14))))))))))))) (else (let ((sc3 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 e-14))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-10 e-11 e-12 e-13 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-16 (car e-9))) (let ((e-15 (cdr e-9))) (vector 1 (cons (vector 1 e-10 e-11 e-12) (cons e-13 (vector 1 e-8 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45StringMap-treeInsert (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45StringMap-treeInsertC-39 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (vector 1 (vector 1 e-8 e-12 e-13))))))))))))
(define LibrariesC-45DataC-45StringMap-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons 0 (vector 0 arg-1 arg-2)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45StringMap-treeInsert arg-1 arg-2 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (cons e-2 e-4))) (else (let ((e-5 (vector-ref sc1 1))) (cons (+ e-2 1) e-5))))))))))
(define CoreC-45Context-setSourceDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 arg-1 e-45 e-46 e-47 e-48 e-49 e-50 e-51 e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45Error-pwarning (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Warning arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Warning arg-7729 arg-7732 eta-0))))) arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Error-pwarningRaw arg-0 arg-1 arg-2 e-5 eta-0)))) eff-0) ext-0)))))))
(define IdrisC-45Error-displayWarning (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (IdrisC-45Error-pwarning arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 0 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Warning:")) e-5))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Common-emitWarning (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (IdrisC-45REPLC-45Common-emitProblem arg-0 arg-1 arg-2 arg-3 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-displayWarning arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (lambda (eta-1) (IdrisC-45Error-pwarning arg-0 arg-2 arg-1 eta-0 eta-1))) (lambda (eta-0) (box (CoreC-45Core-getWarningLoc eta-0))) 2 ext-0)))
(define IdrisC-45Package-addField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 2))) (vector 1 (let ((e-26 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-26 (box e-1) e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((1) (let ((e-3 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-25 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 (box e-3) e-25 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((2) (let ((e-4 (vector-ref arg-5 1))) (let ((act-1 (IdrisC-45REPLC-45Common-emitWarning arg-0 arg-2 arg-1 (vector 5 e-4 "version numbers must now be of the form x.y.z" '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-6)))))) ((3) (let ((e-7 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-26 (vector-ref arg-6 6))) (let ((e-25 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 (box e-7) e-4 e-5 e-26 e-25 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((4) (let ((e-9 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-26 (vector-ref arg-6 8))) (let ((e-25 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 (box e-9) e-5 e-6 e-7 e-26 e-25 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((5) (let ((e-11 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-26 (vector-ref arg-6 10))) (let ((e-25 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 (box e-11) e-6 e-7 e-8 e-9 e-26 e-25 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((6) (let ((e-13 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-26 (vector-ref arg-6 12))) (let ((e-25 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (box e-13) e-7 e-8 e-9 e-10 e-11 e-26 e-25 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((7) (let ((e-15 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-26 (vector-ref arg-6 14))) (let ((e-25 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 (box e-15) e-8 e-9 e-10 e-11 e-12 e-13 e-26 e-25 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((8) (let ((e-17 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-26 (vector-ref arg-6 16))) (let ((e-25 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 (box e-17) e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-26 e-25 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((9) (let ((e-19 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-26 (vector-ref arg-6 18))) (let ((e-25 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 (box e-19) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-26 e-25 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((10) (let ((e-21 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-26 (vector-ref arg-6 20))) (let ((e-25 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 (box e-21) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-26 e-25 e-22 e-23 e-24)))))))))))))))))))))))))))) ((11) (let ((e-22 (vector-ref arg-5 1))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-25 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-22 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-25 e-23 e-24)))))))))))))))))))))))))))) ((12) (let ((e-23 (vector-ref arg-5 1))) (let ((act-1 (let ((act-1 (set-box! arg-3 e-23))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-6)))))) ((13) (let ((e-24 (vector-ref arg-5 1))) (let ((e-25 (vector-ref arg-5 2))) (let ((act-1 (let ((act-1 (set-box! arg-4 (box (cons e-24 e-25))))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-6))))))) ((14) (let ((e-26 (vector-ref arg-5 1))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (box e-26) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((15) (let ((e-27 (vector-ref arg-5 1))) (let ((e-28 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (box (cons e-27 e-28)) e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24))))))))))))))))))))))))))))) ((16) (let ((e-30 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 (box e-30) e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((17) (let ((e-32 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 (box e-32) e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((18) (let ((e-34 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (box e-34) e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) ((19) (let ((e-35 (vector-ref arg-5 1))) (let ((e-36 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 (box (cons e-35 e-36)) e-20 e-21 e-22 e-23 e-24))))))))))))))))))))))))))))) ((20) (let ((e-37 (vector-ref arg-5 1))) (let ((e-38 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 (box (cons e-37 e-38)) e-21 e-22 e-23 e-24))))))))))))))))))))))))))))) ((21) (let ((e-39 (vector-ref arg-5 1))) (let ((e-40 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 (box (cons e-39 e-40)) e-22 e-23 e-24))))))))))))))))))))))))))))) ((22) (let ((e-41 (vector-ref arg-5 1))) (let ((e-42 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-23 (vector-ref arg-6 23))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (box (cons e-41 e-42)) e-23 e-24))))))))))))))))))))))))))))) ((23) (let ((e-43 (vector-ref arg-5 1))) (let ((e-44 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-24 (vector-ref arg-6 24))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 (box (cons e-43 e-44)) e-24))))))))))))))))))))))))))))) (else (let ((e-45 (vector-ref arg-5 1))) (let ((e-46 (vector-ref arg-5 2))) (vector 1 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (let ((e-7 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (let ((e-10 (vector-ref arg-6 10))) (let ((e-11 (vector-ref arg-6 11))) (let ((e-12 (vector-ref arg-6 12))) (let ((e-13 (vector-ref arg-6 13))) (let ((e-14 (vector-ref arg-6 14))) (let ((e-15 (vector-ref arg-6 15))) (let ((e-16 (vector-ref arg-6 16))) (let ((e-17 (vector-ref arg-6 17))) (let ((e-18 (vector-ref arg-6 18))) (let ((e-19 (vector-ref arg-6 19))) (let ((e-20 (vector-ref arg-6 20))) (let ((e-21 (vector-ref arg-6 21))) (let ((e-22 (vector-ref arg-6 22))) (let ((e-23 (vector-ref arg-6 23))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 (box (cons e-45 e-46))))))))))))))))))))))))))))))))))
(define IdrisC-45Package-n--18353-10611-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (if (null? arg-8) (vector 1 arg-9) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((act-1 (IdrisC-45Package-addField arg-5 arg-4 arg-3 arg-6 arg-7 e-2 arg-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Package-n--18353-10611-u--go arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-5 eta-0)))) eff-0) ext-0))))))))))
(define IdrisC-45Package-n--18353-10612-u--toSource (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 (CoreC-45Directory-nsToSource arg-5 e-2 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-3 e-5))))) eff-0) ext-0)))))))))
(define IdrisC-45Package-addFields (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.Package.ParsedMods" ) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "Idris.Package.MainMod" ) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Package-n--18353-10611-u--go arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 arg-4 arg-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (cond ((equal? arg-3 1) ((CoreC-45Context-setSourceDir arg-0 (let ((e-16 (vector-ref e-7 16))) e-16)) eta-2)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (unbox e-5))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (unbox e-6))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (lambda (eta-6) (IdrisC-45Package-n--18353-10612-u--toSource arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-5 eta-6))) e-9 '()) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (if (null? e-10) (vector 1 '()) (let ((e-2 (unbox e-10))) ((let ((eff-0 (lambda (eta-6) (IdrisC-45Package-n--18353-10612-u--toSource arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-2 eta-6)))) (lambda (eta-6) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-6))) eta-5))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-32 (vector-ref e-7 5))) (let ((e-31 (vector-ref e-7 6))) (let ((e-30 (vector-ref e-7 7))) (let ((e-29 (vector-ref e-7 8))) (let ((e-28 (vector-ref e-7 9))) (let ((e-27 (vector-ref e-7 10))) (let ((e-26 (vector-ref e-7 11))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (vector e-0 e-1 e-2 e-3 e-4 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-11 e-12 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45PackageC-45Types-initPkgDesc (lambda (arg-0) (vector arg-0 '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '() '())))
(define DataC-45Fuel-forever (lambda () (box (lambda () (DataC-45Fuel-forever)))))
(define SystemC-45FileC-45ReadWrite-fEOF (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__eof arg-2 eta-0))))) (lambda (u--res) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int u--res (blodwen-toSignedInt 0 63))))))))))))
(define SystemC-45FileC-45Error-fileError (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Error-prim__error arg-2 eta-0))))) (lambda (u--x) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int u--x (blodwen-toSignedInt 0 63))))))))))))
(define PreludeC-45InterfacesC-45Applicative-u--pure_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (arg-3 arg-4 ext-0) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) (let ((e-5 (vector-ref arg-4 1))) ((e-5 'erased) ext-0))))))
(define SystemC-45FileC-45ReadWrite-getStringAndFree (lambda (arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr arg-3) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc0 1) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Error-fileError arg-1 arg-2)) (lambda (bind-0) (cond ((equal? bind-0 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (PreludeC-45InterfacesC-45Applicative-u--pure_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) e-10)) (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-6 (vector-ref arg-8885 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-8885 1))) (vector 1 (u--func e-6))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-6 (vector-ref arg-9937 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-6 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) "")))))))) (else (let ((u--s (PreludeC-45IO-prim__getString arg-3))) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FFI-free arg-1 arg-3)) (lambda (_-10649) (SystemC-45FileC-45Support-ok arg-1 u--s)))))))))))
(define SystemC-45FileC-45ReadWrite-fGetLine (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__readLine arg-2 eta-0))))) (lambda (u--res) (SystemC-45FileC-45ReadWrite-getStringAndFree arg-1 arg-2 u--res)))))))
(define SystemC-45FileC-45ReadWrite-fSeekLine (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__seekLine arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 (vector 0 )))))))))))
(define PreludeC-45InterfacesC-45Applicative-u--C-60C-42C-62_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (lambda (arg-4 arg-5 arg-6 arg-7) (let ((e-3 (vector-ref arg-4 2))) ((((e-3 'erased) 'erased) (let ((e-4 (vector-ref arg-4 2))) ((((e-4 'erased) 'erased) (let ((e-8 (vector-ref arg-4 1))) ((e-8 'erased) (lambda (clam-0) (lambda (clam-1) (let ((e-10 (vector-ref arg-5 2))) ((((e-10 'erased) 'erased) clam-0) clam-1))))))) arg-6))) arg-7))))
(define SystemC-45FileC-45ReadWrite-readLinesOnto (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (vector 1 (cons 0 (PreludeC-45TypesC-45List-reverse arg-2))))))) (let ((e-0 (unbox arg-4))) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45ReadWrite-fEOF arg-1 arg-5)) (lambda (_-0) (cond ((equal? _-0 0) (cond ((equal? arg-3 0) (PreludeC-45InterfacesC-45Monad-u--C-62C-62C-61_Monad_ComposeC-40C-40C-46C-32C-36mC-41C-32C-36tC-41 (let ((e-7 (car arg-1))) e-7) (vector (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-6 (vector-ref arg-8885 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-8885 1))) (vector 1 (u--func e-6))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-6 (vector-ref arg-9937 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-6 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) csegen-150 csegen-151) (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-6 (vector-ref arg-8885 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref arg-8885 1))) (vector 1 (u--func e-6))))))))) csegen-167 csegen-171) (SystemC-45FileC-45ReadWrite-fGetLine arg-1 arg-5) (lambda (u--str) (SystemC-45FileC-45ReadWrite-readLinesOnto arg-1 (cons u--str arg-2) 0 (e-0) arg-5))))(else (let ((e-6 (- arg-3 1))) (PreludeC-45Interfaces-C-42C-62 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (PreludeC-45InterfacesC-45Functor-u--map_Functor_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-14 (vector-ref e-11 0))) e-14))) (lambda (b-0) (lambda (a-0) (lambda (func-0) (lambda (arg-8886) (case (vector-ref arg-8886 0) ((0) (let ((e-7 (vector-ref arg-8886 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-8886 1))) (vector 1 (func-0 e-7))))))))) u--func arg-8885))))) (lambda (u--a) (lambda (arg-9931) (PreludeC-45InterfacesC-45Applicative-u--pure_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) e-11)) (vector (lambda (u--b) (lambda (a-0) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-7 (vector-ref arg-8885 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-8885 1))) (vector 1 (u--func e-7))))))))) (lambda (a-0) (lambda (arg-9932) (vector 1 arg-9932))) (lambda (u--b) (lambda (a-0) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-7 (vector-ref arg-9937 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-7 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (PreludeC-45InterfacesC-45Applicative-u--C-60C-42C-62_Applicative_ComposeC-40C-40C-46C-32C-36fC-41C-32C-36gC-41 (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) e-11)) (vector (lambda (b-0) (lambda (a-0) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-7 (vector-ref arg-8885 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-8885 1))) (vector 1 (u--func e-7))))))))) (lambda (a-0) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (b-0) (lambda (a-0) (lambda (arg-9938) (lambda (arg-9945) (case (vector-ref arg-9938 0) ((0) (let ((e-7 (vector-ref arg-9938 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref arg-9938 1))) (case (vector-ref arg-9945 0) ((1) (let ((e-8 (vector-ref arg-9945 1))) (vector 1 (e-7 e-8)))) (else (let ((e-11 (vector-ref arg-9945 1))) (vector 0 e-11)))))))))))) arg-9937 arg-9944)))))) (SystemC-45FileC-45ReadWrite-fSeekLine arg-1 arg-5) (SystemC-45FileC-45ReadWrite-readLinesOnto arg-1 arg-2 e-6 (box e-0) arg-5)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (cons 1 (PreludeC-45TypesC-45List-reverse arg-2)))))))))))))))))
(define SystemC-45FileC-45Handle-withFile (lambda (arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (car arg-3))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-3 arg-4 arg-5)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-3))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (arg-7 e-6)) (lambda (u--res) (let ((e-13 (car arg-3))) (let ((e-15 (vector-ref e-13 1))) ((((e-15 'erased) 'erased) (SystemC-45FileC-45Handle-closeFile arg-3 e-6)) (lambda (_-10649) (let ((e-18 (car arg-3))) (let ((e-21 (vector-ref e-18 0))) (let ((e-23 (vector-ref e-21 1))) ((e-23 'erased) u--res)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-3))) (let ((e-11 (vector-ref e-8 0))) (let ((e-14 (vector-ref e-11 0))) ((((e-14 'erased) 'erased) (lambda (eta-0) (vector 0 eta-0))) (arg-6 e-6))))))))))))))
(define SystemC-45FileC-45ReadWrite-readFilePage (lambda (arg-1 arg-2 arg-3 arg-4) (SystemC-45FileC-45Handle-withFile arg-1 arg-4 0 (lambda (eta-0) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) eta-0))))) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-readLinesOnto arg-1 '() arg-2 arg-3 eta-0)))))
(define SystemC-45FileC-45ReadWrite-readFile (lambda (arg-1 ext-0) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-8 (vector-ref e-5 0))) ((((e-8 'erased) 'erased) (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-9 (vector-ref eta-0 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-fastConcat (Builtin-snd e-9)))))))) (SystemC-45FileC-45ReadWrite-readFilePage arg-1 0 (DataC-45Fuel-forever) ext-0)))))))
(define ParserC-45Support-fromLexError (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((2) (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 56 (vector 0 arg-0 (cons e-6 e-10) (cons e-6 (bs+ e-10 1 63))) "Can't recognise token.")))) (let ((e-17 (cdr e-3))) (if (null? e-17) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 56 (vector 0 arg-0 (cons e-6 e-10) (cons e-6 (bs+ e-10 1 63))) "Can't recognise token.")))) (vector 56 (vector 0 arg-0 e-12 e-13) "Bracket is not properly closed.")))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 56 (vector 0 arg-0 (cons e-6 e-10) (cons e-6 (bs+ e-10 1 63))) "Can't recognise token."))))))))))
(define LibrariesC-45DataC-45StringC-45Extra-strSnoc (lambda (arg-0 arg-1) (string-append arg-0 (DataC-45String-singleton arg-1))))
(define ParserC-45Support-n--6518-4051-u--fromError (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (if (null? e-2) (cons (vector 0 arg-3 (cons 0 0) (cons 0 0)) (LibrariesC-45DataC-45StringC-45Extra-strSnoc e-1 #\.)) (let ((e-5 (unbox e-2))) (let ((u--start (LibrariesC-45TextC-45Bounded-startBounds e-5))) (let ((u--end (LibrariesC-45TextC-45Bounded-endBounds e-5))) (let ((u--fc (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-223 csegen-223 u--start u--end))) (cond ((equal? sc2 1) (vector 0 arg-3 u--start (let ((e-4 (car u--start))) (let ((e-3 (cdr u--start))) (cons e-4 (bs+ e-3 1 63)))))) (else (vector 0 arg-3 u--start u--end)))))) (cons u--fc (LibrariesC-45DataC-45StringC-45Extra-strSnoc e-1 #\.)))))))))))
(define ParserC-45Support-fromParsingErrors (lambda (arg-2 arg-3 ext-0) (vector 57 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (ParserC-45Support-n--6518-4051-u--fromError arg-2 arg-3 eta-0)) ext-0))))
(define LibrariesC-45TextC-45LexerC-45Core-lexTo (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-tokenise arg-1 0 0 '() arg-2 (PreludeC-45Types-fastUnpack arg-3)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons e-10 (PreludeC-45Types-fastPack e-11)))))))))))))
(define ParserC-45LexerC-45Package-andop (vector 5 (LibrariesC-45TextC-45Lexer-is #\&) (lambda () (LibrariesC-45TextC-45Lexer-is #\&))))
(define ParserC-45LexerC-45Common-comment (vector 5 (vector 5 (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (LibrariesC-45TextC-45Lexer-is #\-))) (lambda () csegen-305)) (lambda () (LibrariesC-45TextC-45LexerC-45Core-reject (LibrariesC-45TextC-45Lexer-is #\})))) (lambda () csegen-459)))
(define ParserC-45LexerC-45Package-dot (LibrariesC-45TextC-45Lexer-is #\.))
(define ParserC-45LexerC-45Package-eqop (vector 5 (LibrariesC-45TextC-45Lexer-is #\=) (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))
(define ParserC-45LexerC-45Package-equals (LibrariesC-45TextC-45Lexer-is #\=))
(define ParserC-45LexerC-45Package-gt (LibrariesC-45TextC-45Lexer-is #\>))
(define ParserC-45LexerC-45Package-gte (vector 5 (LibrariesC-45TextC-45Lexer-is #\>) (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))
(define ParserC-45LexerC-45Common-identAllowDashes (vector 5 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (ParserC-45LexerC-45Common-isIdentStart 0 eta-0))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45LexerC-45Core-pred csegen-779)))))
(define LibrariesC-45TextC-45Lexer-digit (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isDigit eta-0))))
(define LibrariesC-45TextC-45Lexer-digits (LibrariesC-45TextC-45Lexer-some LibrariesC-45TextC-45Lexer-digit))
(define LibrariesC-45TextC-45Lexer-intLit (vector 6 (LibrariesC-45TextC-45Lexer-opt (LibrariesC-45TextC-45Lexer-is #\-)) LibrariesC-45TextC-45Lexer-digits))
(define ParserC-45LexerC-45Package-lt (LibrariesC-45TextC-45Lexer-is #\<))
(define ParserC-45LexerC-45Package-lte (vector 5 (LibrariesC-45TextC-45Lexer-is #\<) (lambda () (LibrariesC-45TextC-45Lexer-is #\=))))
(define LibrariesC-45TextC-45LexerC-45Core-expect (lambda (ext-0) (vector 3 1 ext-0)))
(define ParserC-45LexerC-45Common-namespaceIdent (vector 5 csegen-765 (lambda () (LibrariesC-45TextC-45Lexer-many (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\.) (lambda () csegen-765)) (lambda () (LibrariesC-45TextC-45LexerC-45Core-expect (LibrariesC-45TextC-45Lexer-is #\.))))))))
(define ParserC-45LexerC-45Common-namespacedIdent (vector 5 ParserC-45LexerC-45Common-namespaceIdent (lambda () (LibrariesC-45TextC-45Lexer-opt csegen-460))))
(define ParserC-45LexerC-45Package-separator (LibrariesC-45TextC-45Lexer-is #\,))
(define LibrariesC-45TextC-45LexerC-45Core-concatMap (lambda (arg-2 arg-3) (if (null? arg-3) (vector 0 ) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (arg-2 e-2) (vector 7 (arg-2 e-2) (LibrariesC-45TextC-45LexerC-45Core-concatMap arg-2 e-3))))))))
(define LibrariesC-45TextC-45LexerC-45Core-fail (vector 1 ))
(define LibrariesC-45TextC-45Lexer-exact (lambda (arg-0) (let ((sc0 (PreludeC-45Types-fastUnpack arg-0))) (if (null? sc0) LibrariesC-45TextC-45LexerC-45Core-fail (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45TextC-45LexerC-45Core-concatMap (lambda (eta-0) (LibrariesC-45TextC-45Lexer-is eta-0)) (cons e-2 e-3))))))))
(define LibrariesC-45TextC-45Lexer-newline (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-exact "\xd;\xa;") (LibrariesC-45TextC-45Lexer-oneOf "\xd;\xa;")))
(define LibrariesC-45TextC-45Lexer-space csegen-649)
(define ParserC-45LexerC-45Common-spacesOrNewlines (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45Lexer-space LibrariesC-45TextC-45Lexer-newline)))
(define LibrariesC-45TextC-45Lexer-manyUntil (lambda (arg-1 arg-2) (LibrariesC-45TextC-45Lexer-many (vector 6 (LibrariesC-45TextC-45LexerC-45Core-reject arg-1) arg-2))))
(define LibrariesC-45TextC-45Lexer-manyThen (lambda (arg-1 arg-2) (vector 6 (LibrariesC-45TextC-45Lexer-manyUntil arg-1 arg-2) arg-1)))
(define LibrariesC-45TextC-45Lexer-surround (lambda (arg-0 arg-1 arg-2) (vector 5 arg-0 (lambda () (LibrariesC-45TextC-45Lexer-manyThen arg-1 arg-2)))))
(define LibrariesC-45TextC-45Lexer-quote (lambda (arg-0 arg-1) (LibrariesC-45TextC-45Lexer-surround arg-0 arg-0 arg-1)))
(define LibrariesC-45TextC-45Lexer-stringLit (LibrariesC-45TextC-45Lexer-quote (LibrariesC-45TextC-45Lexer-is #\") csegen-647))
(define ParserC-45LexerC-45Package-rawTokens (cons (cons ParserC-45LexerC-45Common-comment (lambda (eta-0) (vector 0 (LibrariesC-45DataC-45StringC-45Extra-drop 2 eta-0)))) (cons (cons ParserC-45LexerC-45Common-namespacedIdent (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (vector 3 eta-1 eta-2))) (CoreC-45NameC-45Namespace-mkNamespacedIdent eta-0)))) (cons (cons ParserC-45LexerC-45Common-identAllowDashes (lambda (eta-0) (vector 3 '() eta-0))) (cons (cons ParserC-45LexerC-45Package-separator (lambda (eta-0) (vector 4 ))) (cons (cons ParserC-45LexerC-45Package-dot (lambda (eta-0) (vector 5 ))) (cons (cons ParserC-45LexerC-45Package-lte (lambda (eta-0) (vector 6 ))) (cons (cons ParserC-45LexerC-45Package-gte (lambda (eta-0) (vector 7 ))) (cons (cons ParserC-45LexerC-45Package-lt (lambda (eta-0) (vector 8 ))) (cons (cons ParserC-45LexerC-45Package-gt (lambda (eta-0) (vector 9 ))) (cons (cons ParserC-45LexerC-45Package-eqop (lambda (eta-0) (vector 10 ))) (cons (cons ParserC-45LexerC-45Package-andop (lambda (eta-0) (vector 11 ))) (cons (cons ParserC-45LexerC-45Package-equals (lambda (eta-0) (vector 2 ))) (cons (cons ParserC-45LexerC-45Common-spacesOrNewlines (lambda (eta-0) (vector 12 ))) (cons (cons LibrariesC-45TextC-45Lexer-stringLit (lambda (u--s) (vector 13 (LibrariesC-45UtilsC-45String-stripQuotes u--s)))) (cons (cons LibrariesC-45TextC-45Lexer-intLit (lambda (u--i) (vector 14 (cast-string-int u--i)))) '()))))))))))))))))
(define ParserC-45LexerC-45Package-n--5348-9671-u--useful (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) 0) ((12) 0)(else 1))))
(define ParserC-45LexerC-45Package-case--lex-9690 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (vector 0 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (vector 0 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cond ((equal? e-11 "") (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (ParserC-45LexerC-45Package-n--5348-9671-u--useful arg-0 (let ((e-1 (vector-ref eta-0 0))) e-1))) e-2) (cons (vector (vector 1 ) 0 (vector e-6 e-10 e-6 e-10)) '()))))(else (vector 0 e-3)))))))))))))
(define ParserC-45LexerC-45Package-lex (lambda (arg-0) (ParserC-45LexerC-45Package-case--lex-9690 arg-0 (LibrariesC-45TextC-45LexerC-45Core-lexTo (lambda (eta-0) 0) ParserC-45LexerC-45Package-rawTokens arg-0))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyMaybe (lambda (arg-2 ext-0) (PreludeC-45Types-maybe (lambda () LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41) (lambda () (lambda (clam-0) (let ((e-2 (car arg-2))) (e-2 clam-0)))) ext-0)))
(define ParserC-45LexerC-45Package-u--pretty_Pretty_Void_Token (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Comment:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-0)))) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "EndOfInput")) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Equals")) ((3) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "DotSepIdentifier:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyMaybe csegen-2757 e-1) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-2)))))) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Separator")) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Dot")) ((6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "LTE")) ((7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "GTE")) ((8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "LT")) ((9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "GT")) ((10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "EqOp")) ((11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "AndOp")) ((12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Space")) ((13) (let ((e-3 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "StringLit:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-3)))) (else (let ((e-4 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "IntegerLit:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1054 e-4)))))))
(define ParserC-45LexerC-45Package-u--show_Show_Token (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (string-append "Comment: " e-0))) ((1) "EndOfInput") ((2) "Equals") ((3) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (string-append "DotSepIdentifier: " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-487 e-1) (string-append "." (PreludeC-45Show-u--show_Show_String e-2))))))) ((4) "Separator") ((5) "Dot") ((6) "LTE") ((7) "GTE") ((8) "LT") ((9) "GT") ((10) "EqOp") ((11) "AndOp") ((12) "Space") ((13) (let ((e-3 (vector-ref arg-0 1))) (string-append "StringLit: " e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (string-append "IntegerLit: " (PreludeC-45Show-u--show_Show_Integer e-4)))))))
(define ParserC-45Package-runParser (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ParserC-45LexerC-45Package-lex arg-2))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLexError (vector 1 arg-1) (cons (vector 1 ) e-2))))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (u--toks) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parse 1 arg-3 u--toks))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromParsingErrors (cons (cons (lambda (u--x) (ParserC-45LexerC-45Package-u--show_Show_Token u--x)) (lambda (u--d) (lambda (u--x) (ParserC-45LexerC-45Package-u--show_Show_Token u--x)))) (cons (lambda (arg-11067) (ParserC-45LexerC-45Package-u--pretty_Pretty_Void_Token arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (ParserC-45LexerC-45Package-u--pretty_Pretty_Void_Token arg-11076))))) (vector 1 arg-1) e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (_-0) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (vector 1 e-6)))))))))
(define ParserC-45Package-parseFile (lambda (arg-1 arg-2 ext-0) (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-1) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (ParserC-45Package-runParser arg-1 e-2 arg-2))) (else (let ((e-5 (vector-ref act-1 1))) (vector 0 (vector 51 arg-1 e-5))))))))
(define LibrariesC-45TextC-45Parser-choose (lambda (arg-4 arg-5 arg-6 arg-7) (vector 13 arg-4 arg-5 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-4 (lambda (eta-0) (vector 0 eta-0)) arg-6) (lambda () (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 arg-5 (lambda (eta-0) (vector 1 eta-0)) arg-7)))))
(define ParserC-45RuleC-45Package-equals (vector 1 "Expected equals" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-moduleIdent (vector 1 "Expected module identifier" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (box (CoreC-45NameC-45Namespace-mkNestedNamespace e-0 e-1)))))(else '())))))
(define ParserC-45RuleC-45Package-packageName (vector 1 "Expected package name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (if (null? e-0) (let ((sc2 (let ((sc3 (PreludeC-45Types-fastUnpack e-1))) (if (null? sc3) 0 (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (let ((sc4 (ParserC-45LexerC-45Common-isIdentStart 0 e-2))) (cond ((equal? sc4 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 csegen-779 e-3)) (else 0))))))))) (cond ((equal? sc2 1) (box e-1)) (else '()))) '()))))(else '())))))
(define ParserC-45RuleC-45Package-sepC-39 (vector 1 "Expected separator" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((4) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-sep (lambda (arg-1) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (DataC-45List1-forget eta-0)) (LibrariesC-45TextC-45Parser-sepBy1 1 ParserC-45RuleC-45Package-sepC-39 arg-1))))
(define ParserC-45RuleC-45Package-stringLit (vector 1 "Expected string" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((13) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ParserC-45RuleC-45Package-andop (vector 1 "Expected &&" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((11) (box (vector 0 )))(else '())))))
(define IdrisC-45PackageC-45Types-anyBounds (vector '() 1 '() 1))
(define ParserC-45RuleC-45Package-eqop (vector 1 "Expected ==" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((10) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-gt (vector 1 "Expected >=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((9) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-gte (vector 1 "Expected >=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-lt (vector 1 "Expected <=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((8) (box (vector 0 )))(else '())))))
(define ParserC-45RuleC-45Package-lte (vector 1 "Expected <=" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((6) (box (vector 0 )))(else '())))))
(define IdrisC-45Package-n--15555-7893-u--bound (lambda (arg-0) (vector 13 1 1 (vector 11 1 ParserC-45RuleC-45Package-lte (lambda () (vector 9 0 csegen-5522 (lambda () (lambda (u--vs) (vector 0 (cons (vector 0 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) u--vs) 1) '()))))))) (lambda () (vector 13 1 1 (vector 11 1 ParserC-45RuleC-45Package-gte (lambda () (vector 9 0 csegen-5522 (lambda () (lambda (u--vs) (vector 0 (cons (vector 1 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) u--vs) 1) '()))))))) (lambda () (vector 13 1 1 (vector 11 1 ParserC-45RuleC-45Package-lt (lambda () (vector 9 0 csegen-5522 (lambda () (lambda (u--vs) (vector 0 (cons (vector 0 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) u--vs) 0) '()))))))) (lambda () (vector 13 1 1 (vector 11 1 ParserC-45RuleC-45Package-gt (lambda () (vector 9 0 csegen-5522 (lambda () (lambda (u--vs) (vector 0 (cons (vector 1 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) u--vs) 0) '()))))))) (lambda () (vector 11 1 ParserC-45RuleC-45Package-eqop (lambda () (vector 9 0 csegen-5522 (lambda () (lambda (u--vs) (vector 0 (cons (vector 0 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) u--vs) 1) (cons (vector 1 arg-0 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) u--vs) 1) '()))))))))))))))))))
(define IdrisC-45Package-n--15555-7896-u--mkBound (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (vector 0 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (PreludeC-45Types-maybe (lambda () (IdrisC-45Package-n--15555-7896-u--mkBound arg-0 e-2 (let ((e-0 (vector-ref arg-2 0))) (let ((e-8 (vector-ref arg-2 1))) (vector e-0 e-8 (box e-5) e-6))))) (lambda () (lambda (_-8193) (vector 4 '() 0 "Dependency already has an upper bound"))) (let ((e-7 (vector-ref arg-2 2))) e-7))))) (else (let ((e-8 (vector-ref e-1 2))) (let ((e-9 (vector-ref e-1 3))) (PreludeC-45Types-maybe (lambda () (IdrisC-45Package-n--15555-7896-u--mkBound arg-0 e-2 (let ((e-4 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector (box e-8) e-9 e-4 e-3))))) (lambda () (lambda (_-8233) (vector 4 '() 0 "Dependency already has a lower bound"))) (let ((e-0 (vector-ref arg-2 0))) e-0)))))))))))
(define IdrisC-45Package-n--15555-7894-u--depends (lambda (arg-0) (vector 9 0 ParserC-45RuleC-45Package-packageName (lambda () (lambda (u--name) (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 ParserC-45RuleC-45Package-andop (IdrisC-45Package-n--15555-7893-u--bound arg-0)) (lambda (u--bs) (vector 10 0 0 (IdrisC-45Package-n--15555-7896-u--mkBound arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--bs) IdrisC-45PackageC-45Types-anyBounds) (lambda (bind-0) (vector 0 (cons u--name bind-0)))))))))))
(define IdrisC-45Package-n--15555-7895-u--langversions (lambda (arg-0) (vector 10 0 0 (LibrariesC-45TextC-45Parser-sepBy 1 ParserC-45RuleC-45Package-andop (IdrisC-45Package-n--15555-7893-u--bound arg-0)) (lambda (u--bs) (IdrisC-45Package-n--15555-7896-u--mkBound arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--bs) IdrisC-45PackageC-45Types-anyBounds)))))
(define IdrisC-45Package-n--15555-7897-u--strField (lambda (arg-0 arg-1 arg-2) (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty arg-2)) (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 9 0 ParserC-45RuleC-45Package-stringLit (lambda () (lambda (u--str) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 ((arg-1 (vector 0 (vector 1 arg-0) u--start u--end)) u--str))))))))))))))))
(define IdrisC-45Package-field (lambda (arg-0) (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 3 eta-0 eta-1))) "authors") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 4 eta-0 eta-1))) "maintainers") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 5 eta-0 eta-1))) "license") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 6 eta-0 eta-1))) "brief") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 7 eta-0 eta-1))) "readme") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 8 eta-0 eta-1))) "homepage") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 9 eta-0 eta-1))) "sourceloc") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 10 eta-0 eta-1))) "bugtracker") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 csegen-5541 "options") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 csegen-5541 "opts") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 16 eta-0 eta-1))) "sourcedir") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 17 eta-0 eta-1))) "builddir") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 18 eta-0 eta-1))) "outputdir") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 19 eta-0 eta-1))) "prebuild") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 20 eta-0 eta-1))) "postbuild") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 21 eta-0 eta-1))) "preinstall") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 22 eta-0 eta-1))) "postinstall") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 23 eta-0 eta-1))) "preclean") (lambda () (vector 13 1 1 (IdrisC-45Package-n--15555-7897-u--strField arg-0 (lambda (eta-0) (lambda (eta-1) (vector 24 eta-0 eta-1))) "postclean") (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 csegen-5551 (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 9 0 (LibrariesC-45TextC-45Parser-choose 1 1 ParserC-45RuleC-45Package-stringLit csegen-5522) (lambda () (lambda (u--vs) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (case (vector-ref u--vs 0) ((0) (let ((e-2 (vector-ref u--vs 1))) (vector 0 (vector 2 (vector 0 (vector 1 arg-0) u--start u--end) e-2)))) (else (let ((e-5 (vector-ref u--vs 1))) (vector 0 (vector 0 (vector 0 (vector 1 arg-0) u--start u--end) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-prim__integerToNat eta-0)) e-5)))))))))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "langversion")) (lambda () (vector 8 (vector 10 0 0 (IdrisC-45Package-n--15555-7895-u--langversions arg-0) (lambda (u--lvs) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 1 (vector 0 (vector 1 arg-0) u--start u--end) u--lvs))))))))))) (lambda () (vector 13 1 1 (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 11 1 csegen-5551 (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 9 0 ParserC-45RuleC-45Package-stringLit (lambda () (lambda (u--v) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 2 (vector 0 (vector 1 arg-0) u--start u--end) u--v)))))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "depends")) (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 9 0 (ParserC-45RuleC-45Package-sep (IdrisC-45Package-n--15555-7894-u--depends arg-0)) (lambda () (lambda (u--ds) (vector 0 (vector 11 u--ds)))))))))) (lambda () (vector 13 1 1 (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "modules")) (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 9 0 (ParserC-45RuleC-45Package-sep (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Package-moduleIdent (lambda () (lambda (u--m) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (cons (vector 0 (vector 1 arg-0) u--start u--end) u--m)))))))))) (lambda () (lambda (u--ms) (vector 0 (vector 12 u--ms)))))))))) (lambda () (vector 13 1 1 (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "main")) (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 10 0 1 LibrariesC-45TextC-45Parser-location (lambda (u--start) (vector 9 0 ParserC-45RuleC-45Package-moduleIdent (lambda () (lambda (u--m) (vector 10 0 0 LibrariesC-45TextC-45Parser-location (lambda (u--end) (vector 0 (vector 13 (vector 0 (vector 1 arg-0) u--start u--end) u--m)))))))))))))) (lambda () (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "executable")) (lambda () (vector 8 (vector 11 1 ParserC-45RuleC-45Package-equals (lambda () (vector 9 0 (vector 13 1 1 ParserC-45RuleC-45Package-stringLit (lambda () ParserC-45RuleC-45Package-packageName)) (lambda () (lambda (u--e) (vector 0 (vector 14 u--e))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define IdrisC-45Package-parsePkgDesc (lambda (arg-0) (vector 11 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (vector 0 )) (ParserC-45RuleC-45Package-exactProperty "package")) (lambda () (vector 9 0 ParserC-45RuleC-45Package-packageName (lambda () (lambda (u--name) (vector 10 0 0 (LibrariesC-45TextC-45Parser-many (IdrisC-45Package-field arg-0)) (lambda (u--fields) (vector 10 0 0 (vector 2 "Unrecognised token" (lambda (eta-0) 1)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (vector 0 (cons u--name u--fields))) ((3) (let ((e-1 (vector-ref _-0 2))) (vector 4 '() 0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Unrecognised property " (cons (PreludeC-45Show-u--show_Show_String e-1) '()))))))(else (vector 4 '() 0 "Expected end of file"))))))))))))))
(define IdrisC-45REPLC-45Opts-setCurrentElabSource (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 arg-1 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45Package-parsePkgFile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (ParserC-45Package-parseFile arg-4 (IdrisC-45Package-parsePkgDesc arg-4) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (lambda (clam-0) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (IdrisC-45Package-addFields arg-0 arg-1 arg-2 arg-3 e-9 (IdrisC-45PackageC-45Types-initPkgDesc e-8) clam-0)))))) (else (let ((e-6 (vector-ref e-5 1))) (lambda (eta-0) (let ((act-2 (let ((act-2 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-4) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-2 (vector-ref e-7 1))) (let ((act-3 ((IdrisC-45REPLC-45Opts-setCurrentElabSource arg-2 e-2) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 (IdrisC-45Error-perror arg-0 arg-1 arg-2 e-6 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (IdrisC-45Pretty-render arg-2 e-9 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 62 e-10) eta-2)))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error e-6 clam-0)))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define IdrisC-45Package-toCandidate (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (vector arg-0 e-3 e-2)))))
(define IdrisC-45Package-prepend (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (vector (cons arg-0 e-0) e-1 e-2))))))
(define IdrisC-45Package-n--19186-11374-u--go (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 1 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-2 '()))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((arg-0 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-0 (vector-ref e-5 1))) (lambda (eta-0) (IdrisC-45Package-n--19186-11374-u--go arg-0 arg-1 (PreludeC-45TypesC-45SnocList-C-60C-62C-60 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45Package-prepend e-2 eta-1)) e-0)) e-3 eta-0)))) (else (let ((e-1 (vector-ref e-5 1))) (lambda (eta-0) (vector 1 (vector 0 e-1)))))))) eff-0) ext-0))))))))))
(define IdrisC-45Package-tryAll (lambda (arg-0 arg-1) (lambda (eta-0) (IdrisC-45Package-n--19186-11374-u--go arg-1 arg-0 '() arg-0 eta-0))))
(define IdrisC-45Package-case--addDepsC-44getTransitiveDeps-11522 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-3 "package.depends" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "adding new dependency: " (cons (let ((e-0 (car arg-4))) e-0) (cons " (" (cons (IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds (let ((e-1 (cdr arg-4))) e-1)) (cons ")" '()))))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (IdrisC-45SetOptions-findPkgDirs arg-3 (let ((e-0 (car arg-4))) e-0) (let ((e-1 (cdr arg-4))) e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--candidates (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45Package-toCandidate (let ((e-0 (car arg-4))) e-0) eta-1)) e-6))) (if (null? u--candidates) (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-3))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc5 (let ((e-4 (vector-ref e-7 4))) (let ((e-43 (vector-ref e-4 2))) (let ((e-63 (vector-ref e-43 7))) e-63))))) (cond ((equal? sc5 1) (IdrisC-45Package-n--19268-11459-u--getTransitiveDeps arg-0 arg-1 arg-2 arg-3 arg-5 arg-6)) (else (lambda (eta-2) (vector 1 (vector 1 (cons (vector '() arg-4 '()) '()))))))))) eff-0) eta-1)))))) (IdrisC-45Package-tryAll u--candidates (lambda (lamc-0) (let ((e-0 (vector-ref lamc-0 0))) (let ((e-1 (vector-ref lamc-0 1))) (let ((e-2 (vector-ref lamc-0 2))) (let ((u--pkgFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 e-0 "ipkg")))) (lambda (eta-1) (let ((act-3 (let ((act-3 (CompilerC-45Common-exists u--pkgFile eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-7 1) (lambda (eta-2) (let ((act-4 (IdrisC-45Package-parsePkgFile arg-3 arg-2 arg-1 0 u--pkgFile eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (IdrisC-45Package-n--19268-11459-u--getTransitiveDeps arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend (let ((e-11 (vector-ref e-8 11))) e-11) arg-5) (LibrariesC-45DataC-45StringMap-insert (let ((e-31 (vector-ref e-8 0))) e-31) (let ((e-30 (vector-ref e-8 1))) e-30) arg-6)))) eff-0) eta-2))))))) (else (IdrisC-45Package-n--19268-11459-u--getTransitiveDeps arg-0 arg-1 arg-2 arg-3 arg-5 (LibrariesC-45DataC-45StringMap-insert e-0 e-1 arg-6)))))) eff-0) eta-1)))))))))))))))) eff-0) eta-0))))))))) (let ((e-1 (unbox arg-7))) (let ((sc1 (IdrisC-45PackageC-45Types-inBounds e-1 (let ((e-2 (cdr arg-4))) e-2)))) (cond ((equal? sc1 1) (IdrisC-45Package-n--19268-11459-u--getTransitiveDeps arg-0 arg-1 arg-2 arg-3 arg-5 arg-6)) (else (lambda (eta-0) (vector 1 (vector 1 (cons (vector '() arg-4 (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe e-1 (lambda () (box (cons 0 '()))))) '())))))))))))
(define IdrisC-45Package-n--19268-11459-u--getTransitiveDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) (lambda (eta-0) (let ((act-1 ((PreludeC-45Basics-flip csegen-1298 (LibrariesC-45DataC-45StringMap-toList arg-5) (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (IdrisC-45SetOptions-findPkgDir arg-3 e-2 (IdrisC-45PackageC-45Types-exactBounds e-3) clam-0)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 (DataC-45List-catMaybes e-5)))))) eff-0) eta-0)))))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (IdrisC-45Package-case--addDepsC-44getTransitiveDeps-11522 arg-0 arg-1 arg-2 arg-3 e-2 e-3 arg-5 (LibrariesC-45DataC-45StringMap-lookup (let ((e-0 (car e-2))) e-0) arg-5)))))))
(define IdrisC-45Package-addDeps (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((IdrisC-45Package-n--19268-11459-u--getTransitiveDeps arg-3 arg-2 arg-1 arg-0 (let ((e-11 (vector-ref arg-3 11))) e-11) LibrariesC-45DataC-45StringMap-empty) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "package.depends" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "all depends: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-0) '())))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Context-addPackageDir arg-0 eta-0)) e-0) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Context-addDataDir arg-0 eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-4) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 "data")) e-0)) clam-0))))))))) (else (let ((e-1 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (vector 2 ) (IdrisC-45Package-printErrs arg-3 e-1)) clam-0))))))) eff-0) ext-0)))))))
(define SystemC-45Directory-changeDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__changeDir arg-2 eta-0))))) (lambda (u--ok) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--ok (blodwen-toSignedInt 0 63))))))))))))
(define LibrariesC-45UtilsC-45Path-fileName (lambda (ext-0) (LibrariesC-45UtilsC-45Path-fileNameC-39 (LibrariesC-45UtilsC-45Path-parse ext-0))))
(define DataC-45Maybe-filter (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (unbox arg-2))) (DataC-45Maybe-toMaybe (arg-1 e-2) (lambda () e-2))))))
(define LibrariesC-45UtilsC-45Path-extension (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Path-fileName arg-0) (lambda (eta-0) (DataC-45Maybe-filter (lambda (arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-1 "")) (box (Builtin-snd (LibrariesC-45UtilsC-45Path-splitFileName eta-0))))))))
(define LibrariesC-45UtilsC-45Path-splitParent (lambda (arg-0) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Path-splitParentC-39 (LibrariesC-45UtilsC-45Path-parse arg-0)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (box (cons (LibrariesC-45UtilsC-45Path-u--show_Show_Path e-2) (LibrariesC-45UtilsC-45Path-u--show_Show_Path e-3)))))))))
(define CoreC-45Directory-n--9667-6891-u--findIpkgFileC-39 (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((SystemC-45Directory-listDir csegen-82 arg-0) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((sc1 (DataC-45List-find (lambda (u--f) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-22 (LibrariesC-45UtilsC-45Path-extension u--f) (box "ipkg"))) e-2))) (if (null? sc1) (let ((sc2 (LibrariesC-45UtilsC-45Path-splitParent arg-0))) (if (null? sc2) '() (let ((e-1 (unbox sc2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CoreC-45Directory-n--9667-6891-u--findIpkgFileC-39 e-5 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-6 arg-1) ext-0)))))) (let ((e-1 (unbox sc1))) (box (cons arg-0 (cons e-1 arg-1)))))))) (else '())))))
(define CoreC-45Directory-findIpkgFile (lambda (ext-0) (let ((act-1 (csegen-1310 ext-0))) (if (null? act-1) '() (let ((e-1 (unbox act-1))) (let ((act-2 (CoreC-45Directory-n--9667-6891-u--findIpkgFileC-39 e-1 "" ext-0))) act-2))))))
(define IdrisC-45SetOptions-addPkgDir (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (IdrisC-45SetOptions-findPkgDir arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-5))) (CoreC-45Context-addPackageDir arg-0 e-1))))) eff-0) ext-0)))))))
(define IdrisC-45SetOptions-completionScript (lambda (arg-0) (let ((u--funC-39 (string-append "_" arg-0))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons u--funC-39 (cons "()\xa;{\xa;  ED=$([ -z $2 ] && echo \"--\" || echo $2)\xa;  COMPREPLY=($(idris2 --bash-completion $ED $3))\xa;}\xa;\xa;complete -F " (cons u--funC-39 (cons " -o default idris2" '()))))))))
(define CoreC-45Options-outputDirWithDefault (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref arg-0 2))) e-2) "exec")) (let ((e-4 (vector-ref arg-0 4))) e-4))))
(define CoreC-45Options-toString (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "+ Working Directory      :: " (cons (PreludeC-45Show-u--show_Show_String e-0) (cons "\xa;+ Source Directory       :: " (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-493 e-1) (cons "\xa;+ Build Directory        :: " (cons (PreludeC-45Show-u--show_Show_String e-2) (cons "\xa;+ Local Depend Directory :: " (cons (PreludeC-45Show-u--show_Show_String e-3) (cons "\xa;+ Output Directory       :: " (cons (PreludeC-45Show-u--show_Show_String (CoreC-45Options-outputDirWithDefault arg-0)) (cons "\xa;+ Installation Prefix    :: " (cons (PreludeC-45Show-u--show_Show_String e-5) (cons "\xa;+ Extra Directories      :: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-6) (cons "\xa;+ Package Directories    :: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-7) (cons "\xa;+ CG Library Directories :: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-8) (cons "\xa;+ Data Directories       :: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-9) '()))))))))))))))))))))))))))))))))
(define IdrisC-45SetOptions-dirOption (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (cond ((equal? arg-3 0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-5 (vector-ref arg-2 5))) e-5) (string-append "idris2-" csegen-1634)) "\xa;") ext-0))) (vector 1 act-1))) ((equal? arg-3 2) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Options-toString arg-2)) ext-0)) (else (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (let ((e-5 (vector-ref arg-2 5))) e-5) "\xa;") ext-0))) (vector 1 act-1))))))
(define DataC-45String-toLower (lambda (arg-0) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Types-toLower eta-0)) (PreludeC-45Types-fastUnpack arg-0)))))
(define CoreC-45Options-getCG (lambda (arg-0 arg-1) (DataC-45List-lookup csegen-22 (DataC-45String-toLower arg-1) (CoreC-45Options-availableCGs arg-0))))
(define DataC-45These-these (lambda (arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (arg-3 e-2))) ((1) (let ((e-5 (vector-ref arg-6 1))) (arg-4 e-5))) (else (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) ((arg-5 e-8) e-9)))))))
(define LibrariesC-45DataC-45StringTrie-n--3173-4463-u--end (lambda (arg-1 arg-2 arg-3 arg-4) (LibrariesC-45DataC-45StringTrie-singleton arg-2 (arg-4 '()))))
(define LibrariesC-45DataC-45StringTrie-n--3173-4464-u--rec (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (PreludeC-45Types-maybe (lambda () (LibrariesC-45DataC-45StringMap-insert arg-1 (LibrariesC-45DataC-45StringTrie-n--3173-4463-u--end arg-1 arg-2 arg-3 arg-4) arg-5)) (lambda () (lambda (u--tm) (LibrariesC-45DataC-45StringMap-insert arg-1 (LibrariesC-45DataC-45StringTrie-insertWith arg-2 arg-4 u--tm) arg-5))) (LibrariesC-45DataC-45StringMap-lookup arg-1 arg-5))))
(define LibrariesC-45DataC-45StringTrie-insertWith (lambda (arg-1 arg-2 arg-3) (if (null? arg-1) (DataC-45These-these (lambda (eta-0) (vector 0 (arg-2 (box eta-0)))) (lambda (eta-0) (vector 2 (arg-2 '()) eta-0)) (lambda (eta-0) (lambda (eta-1) (vector 2 (arg-2 (box eta-0)) eta-1))) arg-3) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (DataC-45These-these (lambda (u--x) (vector 2 u--x (LibrariesC-45DataC-45StringMap-singleton e-2 (LibrariesC-45DataC-45StringTrie-n--3173-4463-u--end e-2 e-3 arg-3 arg-2)))) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45StringTrie-n--3173-4464-u--rec e-2 e-3 arg-3 arg-2 eta-0))) (lambda (u--x) (lambda (eta-0) (vector 2 u--x (LibrariesC-45DataC-45StringTrie-n--3173-4464-u--rec e-2 e-3 arg-3 arg-2 eta-0)))) arg-3))))))
(define LibrariesC-45DataC-45StringTrie-insert (lambda (arg-1 arg-2 ext-0) (LibrariesC-45DataC-45StringTrie-insertWith arg-1 (lambda (eta-0) arg-2) ext-0)))
(define CoreC-45OptionsC-45Log-insertLogLevel (lambda (arg-0 ext-0) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (LibrariesC-45DataC-45StringTrie-insert e-0 e-1 ext-0)))))
(define IdrisC-45SetOptions-n--13635-6080-u--notDenylisted (lambda (arg-0 ext-0) (let ((sc0 (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (PreludeC-45Types-elem csegen-14 csegen-22 eta-0 eta-1))) (cons "include" (cons "lib" (cons "support" (cons "refc" '())))) (let ((e-1 (vector-ref ext-0 1))) e-1)))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45SetOptions-n--13635-6081-u--notHidden (lambda (arg-0 ext-0) (let ((sc0 (DataC-45String-isPrefixOf "." (let ((e-1 (vector-ref ext-0 1))) e-1)))) (cond ((equal? sc0 1) 0) (else 1)))))
(define IdrisC-45SetOptions-n--13635-6082-u--viable (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45SetOptions-n--13635-6081-u--notHidden arg-0 arg-1))) (cond ((equal? sc0 1) (IdrisC-45SetOptions-n--13635-6080-u--notDenylisted arg-0 arg-1)) (else 0)))))
(define IdrisC-45SetOptions-visiblePackages (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (IdrisC-45SetOptions-n--13635-6082-u--viable arg-0 eta-1)) eta-0)) (lambda (eta-0) (IdrisC-45SetOptions-getPackageDirs arg-0 eta-0)) ext-0)))
(define PreludeC-45Types-u--join_Monad_List (lambda (arg-1) (PreludeC-45Types-listBind arg-1 (lambda (eta-0) eta-0))))
(define IdrisC-45SetOptions-findPackages (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Directory-pkgGlobalDirectory arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45SetOptions-visiblePackages e-5 eta-0))) (vector 1 act-2))))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getDirs arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((PreludeC-45Types-u--traverse_Traversable_List csegen-75 (lambda (u--d) (lambda (eta-2) (IdrisC-45SetOptions-visiblePackages u--d eta-2))) (let ((e-7 (vector-ref e-6 7))) e-7)) eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (CoreC-45Directory-pkgLocalDirectory arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (IdrisC-45SetOptions-visiblePackages e-8 eta-3))) (vector 1 act-5))))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--join_Monad_List e-7) e-8)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45SetOptions-n--13778-6243-u--pkgDesc (lambda (arg-0 arg-1 arg-2) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-3833 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-3833 u--d u--x)))) e-2)))))))
(define IdrisC-45SetOptions-listPackages (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-sortBy (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-on (lambda (eta-3) (lambda (eta-4) (PreludeC-45EqOrd-u--compare_Ord_String eta-3 eta-4))) csegen-3842 eta-1 eta-2))) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findPackages arg-0 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (IdrisC-45SetOptions-n--13778-6243-u--pkgDesc arg-1 arg-0 eta-0) eta-1))) e-5))) eff-0) ext-0)))))))
(define IdrisC-45SetOptions-codegens (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref e-5 4))) e-4)))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define IdrisC-45SetOptions-findIpkg (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (csegen-1310 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't get current directory") clam-0) (let ((e-1 (unbox e-5))) (let ((act-2 (let ((act-2 ((SystemC-45Directory-listDir csegen-82 e-1) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (vector 1 (PreludeC-45TypesC-45List-filterAppend '() csegen-3863 e-2)))) (else (vector 1 '())))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45SetOptions-n--14047-6504-u--prefixes (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-1) (string-append (string-append e-2 ".") arg-1)) (IdrisC-45SetOptions-n--14047-6504-u--prefixes e-3))))))))
(define IdrisC-45SetOptions-logLevels (PreludeC-45Types-listBind (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) CoreC-45OptionsC-45Log-knownTopics) (lambda (eta-0) (IdrisC-45SetOptions-n--14047-6504-u--prefixes (DataC-45List1-forget (DataC-45String-split csegen-520 eta-0))))))
(define IdrisC-45CommandLine-optionFlags (PreludeC-45Types-listBind IdrisC-45CommandLine-options (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0))))
(define LibrariesC-45DataC-45ListC-45Extra-dedup (lambda (arg-1 arg-2) (if (null? arg-2) arg-2 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (if (null? e-2) arg-2 (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (let ((u--xs (cons e-4 e-5))) (let ((sc2 (let ((e-6 (car arg-1))) ((e-6 e-1) e-4)))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45ListC-45Extra-dedup arg-1 u--xs)) (else (cons e-1 (LibrariesC-45DataC-45ListC-45Extra-dedup arg-1 u--xs))))))))))))))
(define DataC-45List-sort (lambda (arg-1 ext-0) (DataC-45List-sortBy (lambda (eta-0) (lambda (eta-1) (let ((e-2 (vector-ref arg-1 1))) ((e-2 eta-0) eta-1)))) ext-0)))
(define LibrariesC-45DataC-45ListC-45Extra-sortedNub (lambda (arg-1 ext-0) (LibrariesC-45DataC-45ListC-45Extra-dedup (let ((e-1 (vector-ref arg-1 0))) e-1) (DataC-45List-sort arg-1 ext-0))))
(define IdrisC-45SetOptions-prefixOnly (lambda (arg-0 ext-0) (LibrariesC-45DataC-45ListC-45Extra-sortedNub csegen-519 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--s) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-0 u--s))) (cond ((equal? sc0 1) (DataC-45String-isPrefixOf arg-0 u--s)) (else 0)))) ext-0))))
(define IdrisC-45SetOptions-prefixOnlyIfNonEmpty (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 "--") clam-0)(else (IdrisC-45SetOptions-prefixOnly arg-0 clam-0))))))
(define IdrisC-45SetOptions-opts (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 "--") (cond ((equal? arg-2 "idris2") (lambda (eta-0) (vector 1 IdrisC-45CommandLine-optionFlags)))(else (cond ((equal? arg-2 "--cg") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "--codegen") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "-p") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45TypesC-45List-mapAppend '() csegen-3842 e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--package") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45TypesC-45List-mapAppend '() csegen-3842 e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--log") (lambda (eta-0) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) IdrisC-45SetOptions-logLevels))))(else (cond ((equal? arg-1 "--") (lambda (clam-0) (cond ((equal? arg-2 "-o") (vector 1 '())) ((equal? arg-2 "--output") (vector 1 '())) ((equal? arg-2 "--source-dir") (vector 1 '())) ((equal? arg-2 "--build-dir") (vector 1 '())) ((equal? arg-2 "--output-dir") (vector 1 '()))(else (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-0))(else (vector 1 (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-22 arg-1 IdrisC-45CommandLine-optionFlags))) (cond ((equal? sc2 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 IdrisC-45CommandLine-optionFlags)))))))))))(else (lambda (clam-1) (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1))(else (vector 1 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 arg-1 IdrisC-45CommandLine-optionFlags))) (cond ((equal? sc1 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 IdrisC-45CommandLine-optionFlags)))))))))))))))(else (cond ((equal? arg-2 "--cg") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "--codegen") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-1) (IdrisC-45SetOptions-codegens arg-0 eta-1)) eta-0))) ((equal? arg-2 "-p") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45TypesC-45List-mapAppend '() csegen-3842 e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--package") (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) (PreludeC-45TypesC-45List-mapAppend '() csegen-3842 e-5))))))) (lambda (eta-1) (IdrisC-45SetOptions-findPackages arg-0 eta-1)) eta-0))) ((equal? arg-2 "--log") (lambda (eta-0) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) IdrisC-45SetOptions-logLevels))))(else (cond ((equal? arg-1 "--") (lambda (clam-1) (cond ((equal? arg-2 "-o") (vector 1 '())) ((equal? arg-2 "--output") (vector 1 '())) ((equal? arg-2 "--source-dir") (vector 1 '())) ((equal? arg-2 "--build-dir") (vector 1 '())) ((equal? arg-2 "--output-dir") (vector 1 '()))(else (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-1))(else (vector 1 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 arg-1 IdrisC-45CommandLine-optionFlags))) (cond ((equal? sc1 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 IdrisC-45CommandLine-optionFlags)))))))))))(else (lambda (clam-3) (cond ((equal? arg-2 "--build") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--install") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--mkdoc") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--typecheck") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--clean") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3)) ((equal? arg-2 "--repl") (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 ((IdrisC-45SetOptions-prefixOnlyIfNonEmpty arg-1) e-5)))))) (lambda (eta-0) (IdrisC-45SetOptions-findIpkg arg-0 eta-0)) clam-3))(else (vector 1 (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-22 arg-1 IdrisC-45CommandLine-optionFlags))) (cond ((equal? sc0 1) '()) (else (IdrisC-45SetOptions-prefixOnly arg-1 IdrisC-45CommandLine-optionFlags))))))))))))))))
(define CoreC-45Context-setBuildDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 arg-1 e-46 e-47 e-48 e-49 e-50 e-51 e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setCG (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-35 0))) (let ((e-44 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-48 (vector-ref e-35 5))) (let ((e-49 (vector-ref e-35 6))) (let ((e-50 (vector-ref e-35 7))) (let ((e-51 (vector-ref e-35 8))) (let ((e-52 (vector-ref e-35 9))) (let ((e-53 (vector-ref e-35 10))) (let ((e-54 (vector-ref e-35 11))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 (vector e-68 e-44 e-45 e-46 arg-1 e-48 e-49 e-50 e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45REPLC-45Opts-setColor (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 arg-1 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45REPLC-45Opts-setConsoleWidth (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 arg-1 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setDebugElabCheck (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-35 0))) (let ((e-44 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-47 (vector-ref e-35 4))) (let ((e-48 (vector-ref e-35 5))) (let ((e-49 (vector-ref e-35 6))) (let ((e-50 (vector-ref e-35 7))) (let ((e-51 (vector-ref e-35 8))) (let ((e-52 (vector-ref e-35 9))) (let ((e-53 (vector-ref e-35 10))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 (vector e-68 e-44 e-45 e-46 e-47 e-48 e-49 e-50 e-51 e-52 e-53 arg-1 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define SystemC-45FileC-45Permissions-chmodRaw (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Permissions-prim__chmod arg-2 arg-3 eta-0))))) (lambda (u--ok) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--ok (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (vector 0 ))))))) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define SystemC-45Escape-n--3241-886-u--escapeArgChar (lambda (arg-0 arg-1) (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\%))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\^))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\&))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\<))) (cond ((equal? sc5 1) 1) (else (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\>))) (cond ((equal? sc6 1) 1) (else (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\|))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\'))) (cond ((equal? sc8 1) 1) (else (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\"))) (cond ((equal? sc9 1) 1) (else (let ((sc10 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\`))) (cond ((equal? sc10 1) 1) (else (let ((sc11 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\ ))) (cond ((equal? sc11 1) 1) (else (let ((sc12 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 (integer->char 9)))) (cond ((equal? sc12 1) 1) (else (let ((sc13 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 (integer->char 10)))) (cond ((equal? sc13 1) 1) (else (let ((sc14 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\;))) (cond ((equal? sc14 1) 1) (else (let ((sc15 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\,))) (cond ((equal? sc15 1) 1) (else (let ((sc16 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\=))) (cond ((equal? sc16 1) 1) (else (let ((sc17 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 (integer->char 11)))) (cond ((equal? sc17 1) 1) (else (let ((sc18 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 (integer->char 12)))) (cond ((equal? sc18 1) 1) (else (let ((sc19 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 (integer->char 255)))) (cond ((equal? sc19 1) 1) (else (let ((sc20 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\())) (cond ((equal? sc20 1) 1) (else (let ((sc21 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\)))) (cond ((equal? sc21 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\!))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (cond ((equal? sc1 1) (cons #\^ (cons arg-1 '()))) (else (cons arg-1 '()))))) (else (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\$))) (cond ((equal? sc2 1) 1) (else (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\`))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\\))) (cond ((equal? sc4 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\")))))))))))) (cond ((equal? sc1 1) (cons #\\ (cons arg-1 '()))) (else (cons arg-1 '())))))))))
(define SystemC-45Escape-escapeArg (lambda (arg-0) (let ((u--escapedCmdChars (PreludeC-45Types-fastPack (PreludeC-45Types-listBind (PreludeC-45Types-fastUnpack arg-0) (lambda (eta-0) (SystemC-45Escape-n--3241-886-u--escapeArgChar arg-0 eta-0)))))) (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) u--escapedCmdChars) (else (string-append "\"" (string-append u--escapedCmdChars "\""))))))))
(define SystemC-45Escape-escapeCmd (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (SystemC-45Escape-escapeArg eta-0)) arg-0)))))
(define System-system (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (System-prim__system arg-2 eta-0))))))
(define SystemC-45Escaped-system (lambda (arg-1 ext-0) (System-system arg-1 (SystemC-45Escape-escapeCmd ext-0))))
(define SystemC-45FileC-45ReadWrite-writeFile (lambda (arg-1 arg-2 arg-3) (SystemC-45FileC-45Handle-withFile arg-1 arg-2 1 (lambda (eta-0) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) eta-0))))) (lambda (eta-0) (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (SystemC-45FileC-45ReadWrite-fPutStr arg-1 eta-1 eta-2))) arg-3 eta-0)))))
(define CompilerC-45SchemeC-45Chez-compileToSO (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--tmpFileAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 "compileChez"))) (let ((u--build (string-append "(parameterize ([optimize-level 3] " (string-append (cond ((equal? arg-1 1) "[compile-profile #t] ") (else "")) (string-append "[compile-file-message #f]) (compile-program " (string-append (PreludeC-45Show-u--show_Show_String arg-4) "))")))))) (lambda (eta-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--tmpFileAbs u--build) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 u--tmpFileAbs (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-2))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 ((SystemC-45Escaped-system csegen-82 (cons arg-2 (cons "--script" (cons u--tmpFileAbs '())))) world-0))) (vector 1 act-3))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 (vector 0 ))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 u--tmpFileAbs e-6) clam-0))))))) eff-0) eta-0))))))))))
(define LibrariesC-45DataC-45StringC-45Builder-toList (lambda (arg-1) (arg-1 '())))
(define LibrariesC-45DataC-45StringC-45Builder-build (lambda (ext-0) (PreludeC-45Types-fastConcat (LibrariesC-45DataC-45StringC-45Builder-toList ext-0))))
(define LibrariesC-45TextC-45Lexer-alphaNum csegen-469)
(define LibrariesC-45DataC-45Version-versionTokenMap (LibrariesC-45TextC-45Lexer-toTokenMap (cons (cons (LibrariesC-45TextC-45Lexer-is #\.) 2) (cons (cons (LibrariesC-45TextC-45Lexer-is #\-) 3) (cons (cons LibrariesC-45TextC-45Lexer-digits 1) (cons (cons (LibrariesC-45TextC-45Lexer-some LibrariesC-45TextC-45Lexer-alphaNum) 0) '()))))))
(define LibrariesC-45DataC-45Version-lexVersion (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Core-lex LibrariesC-45DataC-45Version-versionTokenMap arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-7 (cdr e-3))) e-2))))))
(define LibrariesC-45DataC-45Version-versionParser (vector 9 1 csegen-1673 (lambda () (lambda (u--maj) (vector 11 1 csegen-1674 (lambda () (vector 9 1 csegen-1673 (lambda () (lambda (u--min) (vector 11 1 csegen-1674 (lambda () (vector 9 0 csegen-1673 (lambda () (lambda (u--patch) (vector 10 0 0 (LibrariesC-45TextC-45Parser-optional 1 (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (LibrariesC-45TextC-45Parser-match csegen-1672 3)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f (LibrariesC-45TextC-45Parser-match csegen-1672 0))))) (lambda (u--optTag) (vector 0 (cons (cons u--maj (cons u--min u--patch)) u--optTag))))))))))))))))))
(define LibrariesC-45DataC-45Version-parseVersion (lambda (arg-0) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parse 1 LibrariesC-45DataC-45Version-versionParser (LibrariesC-45DataC-45Version-lexVersion arg-0)))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 1))) (if (null? e-2) '() (let ((e-6 (cdr e-2))) (if (null? e-6) '() (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (if (null? e-10) (box e-9) '()))))))))(else '())))))
(define SystemC-45FileC-45Process-pclose (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (SystemC-45FileC-45Process-prim__pclose arg-2 eta-0))))))
(define SystemC-45FileC-45Process-popen (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Process-prim__popen arg-2 (SystemC-45FileC-45Mode-modeStr arg-3) eta-0))))) (lambda (u--ptr) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--ptr) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 u--ptr))))))))))))))
(define CompilerC-45SchemeC-45Chez-n--12071-1070-u--cmd (lambda (arg-0) (string-append arg-0 " --version 2>&1")))
(define CompilerC-45SchemeC-45Chez-chezVersion (lambda (arg-0 ext-0) (let ((act-1 ((SystemC-45FileC-45Process-popen csegen-82 (CompilerC-45SchemeC-45Chez-n--12071-1070-u--cmd arg-0) 0) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 ((SystemC-45FileC-45ReadWrite-fGetLine csegen-82 e-2) ext-0))) (case (vector-ref act-2 0) ((1) (let ((e-3 (vector-ref act-2 1))) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (vector 0 )) (SystemC-45FileC-45Process-pclose csegen-82 e-2) ext-0))) (LibrariesC-45DataC-45Version-parseVersion e-3)))) (else '()))))) (else '())))))
(define SystemC-45FileC-45Meta-fileSize (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Meta-prim__fileSize arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Support-ok arg-1 u--res)) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define LibrariesC-45SystemC-45FileC-45Buffer-readBufferData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Buffer-prim__readBufferData arg-2 arg-3 arg-4 arg-5 eta-0))))) (lambda (u--read) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--read (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (vector 0 ))))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (vector 1 )))))))))))))))
(define LibrariesC-45SystemC-45FileC-45Buffer-createBufferFromFile (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 0)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45FileC-45Meta-fileSize arg-1 e-6)) (lambda (_-1) (case (vector-ref _-1 0) ((1) (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-16 (vector-ref e-14 1))) ((((e-16 'erased) 'erased) (DataC-45Buffer-newBuffer arg-1 e-12)) (lambda (_-2) (if (null? _-2) (let ((e-19 (car arg-1))) (let ((e-22 (vector-ref e-19 0))) (let ((e-24 (vector-ref e-22 1))) ((e-24 'erased) (vector 0 (vector 1 )))))) (let ((e-18 (unbox _-2))) (let ((e-20 (car arg-1))) (let ((e-22 (vector-ref e-20 1))) ((((e-22 'erased) 'erased) (LibrariesC-45SystemC-45FileC-45Buffer-readBufferData arg-1 e-6 e-18 0 e-12)) (lambda (_-3) (case (vector-ref _-3 0) ((1) (let ((e-26 (car arg-1))) (let ((e-28 (vector-ref e-26 1))) ((((e-28 'erased) 'erased) (SystemC-45FileC-45Handle-closeFile arg-1 e-6)) (lambda (_-10649) (let ((e-31 (car arg-1))) (let ((e-34 (vector-ref e-31 0))) (let ((e-36 (vector-ref e-34 1))) ((e-36 'erased) (vector 1 e-18)))))))))) (else (let ((e-24 (vector-ref _-3 1))) (let ((e-26 (car arg-1))) (let ((e-29 (vector-ref e-26 0))) (let ((e-31 (vector-ref e-29 1))) ((e-31 'erased) (vector 0 e-24)))))))))))))))))))) (else (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 0 e-12)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 e-6))))))))))))))
(define LibrariesC-45UtilsC-45Binary-readFromFile (lambda (arg-0 ext-0) (let ((act-1 ((LibrariesC-45SystemC-45FileC-45Buffer-createBufferFromFile csegen-82 arg-0) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 (DataC-45Buffer-prim__bufferSize e-2))) (let ((u--bsize act-2)) (vector 1 (vector e-2 0 u--bsize u--bsize)))))) (else (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5)))))))
(define LibrariesC-45SystemC-45FileC-45Buffer-writeBufferData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Buffer-prim__writeBufferData arg-2 arg-3 arg-4 arg-5 eta-0))))) (lambda (u--written) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--written arg-5))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (vector 0 ))))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (cons (vector 2 ) u--written)))))))))))))))
(define LibrariesC-45SystemC-45FileC-45Buffer-writeBufferToFile (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 1)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (LibrariesC-45SystemC-45FileC-45Buffer-writeBufferData arg-1 e-6 arg-3 0 arg-4)) (lambda (_-1) (case (vector-ref _-1 0) ((1) (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-16 (vector-ref e-14 1))) ((((e-16 'erased) 'erased) (SystemC-45FileC-45Handle-closeFile arg-1 e-6)) (lambda (_-10649) (let ((e-19 (car arg-1))) (let ((e-22 (vector-ref e-19 0))) (let ((e-24 (vector-ref e-22 1))) ((e-24 'erased) (vector 1 e-12))))))))))) (else (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 0 e-12)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 (cons e-6 (blodwen-toSignedInt 0 63))))))))))))))))
(define LibrariesC-45UtilsC-45Binary-writeToFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((LibrariesC-45SystemC-45FileC-45Buffer-writeBufferToFile csegen-82 arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) (blodwen-toSignedInt (let ((e-3 (vector-ref arg-1 3))) e-3) 63)) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (vector 1 e-2))) (else (let ((e-5 (vector-ref act-1 1))) (let ((e-8 (car e-5))) (vector 0 e-8))))))))
(define CompilerC-45Common-copyLib (lambda (arg-0) (lambda (clam-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 e-3))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile e-3 clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-5 0) ((1) (let ((e-4 (vector-ref e-5 1))) (let ((act-2 (let ((act-2 (LibrariesC-45UtilsC-45Binary-writeToFile e-2 e-4 clam-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-6 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 e-2 e-7) clam-2))))))) eff-0) clam-1))))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-0)))))))))))))
(define System-getEnv (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (System-prim__getEnv arg-2 eta-0))))) (lambda (u--env) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int (PrimIO-prim__nullAnyPtr u--env) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) '()))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (box (PreludeC-45IO-prim__getString u--env)))))))))))))))
(define SystemC-45FileC-45Meta-exists (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 0)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45FileC-45Handle-closeFile arg-1 e-6)) (lambda (_-10649) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) 1)))))))))) (else (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) 0))))))))))))
(define SystemC-45FileC-45Meta-firstExists (lambda (arg-1 arg-2) (if (null? arg-2) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) '())))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-1 (car arg-1))) (let ((e-6 (vector-ref e-1 1))) ((((e-6 'erased) 'erased) (SystemC-45FileC-45Meta-exists arg-1 e-2)) (lambda (bind-0) (cond ((equal? bind-0 1) (let ((e-9 (car arg-1))) (let ((e-12 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-12 1))) ((e-14 'erased) (box e-2)))))) (else (SystemC-45FileC-45Meta-firstExists arg-1 e-3))))))))))))
(define LibrariesC-45UtilsC-45Path-pathLookup (lambda (arg-0 ext-0) (let ((act-1 ((System-getEnv csegen-82 "PATH") ext-0))) (let ((u--extensions (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) (cons ".exe" (cons ".cmd" (cons ".bat" (cons "" '()))))) (else (cons "" '())))))) (let ((u--pathList (DataC-45List1-forget (DataC-45String-split csegen-574 (DataC-45Maybe-fromMaybe (lambda () "/usr/bin:/usr/local/bin") act-1))))) (let ((u--candidates (PreludeC-45Types-listBind u--pathList (lambda (u--p) (PreludeC-45Types-listBind arg-0 (lambda (u--x) (PreludeC-45Types-listBind u--extensions (lambda (u--y) (PreludeC-45Types-u--pure_Applicative_List (string-append u--p (string-append "/" (string-append u--x u--y)))))))))))) ((SystemC-45FileC-45Meta-firstExists csegen-82 u--candidates) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-findChez (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "CHEZ") ext-0))) (if (null? act-1) (let ((act-2 (LibrariesC-45UtilsC-45Path-pathLookup (cons "chez" (cons "chezscheme" (cons "chez-scheme" (cons "chezscheme9.5" (cons "scheme" '()))))) ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env scheme") act-2)) (let ((e-2 (unbox act-1))) e-2)))))
(define CoreC-45Directory-n--8849-6129-u--libDirs (lambda (arg-0 arg-1 ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--x "lib")) ext-0)))
(define CoreC-45Directory-findLibraryFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--packageLibs (CoreC-45Directory-n--8849-6129-u--libDirs arg-1 arg-0 (let ((e-7 (vector-ref e-5 7))) e-7)))) (let ((u--extraLibs (CoreC-45Directory-n--8849-6129-u--libDirs arg-1 arg-0 (let ((e-6 (vector-ref e-5 6))) e-6)))) (let ((u--fs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--p) (CoreC-45Directory-cleanPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p arg-1))) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-8 (vector-ref e-5 8))) e-8) (PreludeC-45TypesC-45List-tailRecAppend u--packageLibs u--extraLibs))))) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-firstAvailable arg-0 u--fs eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't find library " arg-1)) clam-0) (let ((e-1 (unbox e-6))) (vector 1 e-1)))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define DataC-45String-n--3874-9281-u--wordsHelper (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (cons arg-2 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-1 '())))))
(define DataC-45String-n--3874-9280-u--wordsC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-1) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 (DataC-45String-n--3874-9281-u--wordsHelper arg-0 arg-2 arg-3) '()) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((sc1 (PreludeC-45Types-isSpace e-1))) (cond ((equal? sc1 1) (DataC-45String-n--3874-9280-u--wordsC-39 arg-0 e-2 '() (DataC-45String-n--3874-9281-u--wordsHelper arg-0 arg-2 arg-3))) (else (DataC-45String-n--3874-9280-u--wordsC-39 arg-0 e-2 (cons arg-2 e-1) arg-3)))))))))
(define DataC-45String-words (lambda (arg-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45String-n--3874-9280-u--wordsC-39 arg-0 (PreludeC-45Types-fastUnpack arg-0) '() '()))))
(define CompilerC-45Common-dylib_suffix (CoreC-45Core-cond (cons (cons (lambda () csegen-96) (lambda () "dll")) (cons (cons (lambda () (PreludeC-45EqOrd-u--C-61C-61_Eq_String SystemC-45Info-os "darwin")) (lambda () "dylib")) '())) (lambda () "so")))
(define CompilerC-45Common-case--locate-5181 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) "" (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-17 #\. (PreludeC-45Types-fastUnpack e-2)))) (cond ((equal? sc2 1) e-2) (else (string-append e-2 (string-append "." CompilerC-45Common-dylib_suffix))))) (let ((e-6 (car e-3))) (CoreC-45Core-cond (cons (cons (lambda () (PreludeC-45EqOrd-u--C-61C-61_Eq_String CompilerC-45Common-dylib_suffix "dll")) (lambda () (string-append e-2 (string-append "-" (string-append e-6 ".dll"))))) (cons (cons (lambda () (PreludeC-45EqOrd-u--C-61C-61_Eq_String CompilerC-45Common-dylib_suffix "dylib")) (lambda () (string-append e-2 (string-append "." (string-append e-6 ".dylib"))))) '())) (lambda () (string-append e-2 (string-append "." (string-append CompilerC-45Common-dylib_suffix (string-append "." e-6)))))))))))))
(define CompilerC-45Common-locate (lambda (arg-0 arg-1) (let ((u--fname (CompilerC-45Common-case--locate-5181 arg-1 arg-0 (DataC-45String-words arg-1)))) (lambda (eta-0) (let ((act-1 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (CoreC-45Directory-findLibraryFile arg-0 u--fname eta-1)) (lambda (u--err) (lambda (eta-1) (vector 1 u--fname))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons u--fname e-5))))) eff-0) eta-0)))))))))
(define CompilerC-45SchemeC-45Chez-n--12215-1210-u--isLib (lambda (arg-0 arg-1 arg-2) (let ((sc0 (DataC-45String-isPrefixOf "lib" arg-2))) (cond ((equal? sc0 1) (box (DataC-45String-trim (PreludeC-45Types-substr 3 (PreludeC-45TypesC-45String-length arg-2) arg-2)))) (else '())))))
(define CompilerC-45SchemeC-45Chez-findLibs (lambda (arg-0 arg-1) (let ((u--libs (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45SchemeC-45Chez-n--12215-1210-u--isLib arg-1 arg-0 (DataC-45String-trim eta-0))) arg-1))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45Common-locate arg-0 eta-0)) (DataC-45List-nub csegen-22 u--libs) '()))))
(define CompilerC-45VMCode-n--9834-3880-u--declareAll (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cons (vector 1 ) arg-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-223 e-2 arg-2))) (cond ((equal? sc1 1) (CompilerC-45VMCode-n--9834-3880-u--declareAll arg-0 arg-1 arg-2 e-3)) (else (cons (vector 0 (vector 1 e-2)) (CompilerC-45VMCode-n--9834-3880-u--declareAll arg-0 arg-1 (cons e-2 arg-2) e-3))))))))))
(define CompilerC-45VMCode-declareVars (lambda (arg-0 arg-1) (let ((u--vs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CompilerC-45VMCode-findVars eta-0)) arg-1))) (CompilerC-45VMCode-n--9834-3880-u--declareAll arg-1 arg-0 arg-0 u--vs))))
(define CompilerC-45VMCode-projectArgs (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (LibrariesC-45DataC-45IntMap-lookup e-2 arg-2))) (if (null? sc1) (CompilerC-45VMCode-projectArgs arg-0 (bs+ arg-1 1 63) arg-2 e-3) (cons (vector 12 (vector 1 e-2) (vector 1 arg-0) arg-1) (CompilerC-45VMCode-projectArgs arg-0 (bs+ arg-1 1 63) arg-2 e-3)))))))))
(define CompilerC-45VMCode-toReg (lambda (arg-0) (if (null? arg-0) (vector 2 ) (let ((e-0 (unbox arg-0))) (vector 1 e-0)))))
(define CompilerC-45VMCode-n--9383-3577-u--toVMConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((u--body (CompilerC-45VMCode-toVM arg-5 arg-4 e-4))) (let ((u--used (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectUsed eta-0)) u--body))) (cons (PreludeC-45Types-maybe (lambda () (vector 1 e-0)) (lambda () (lambda (eta-0) (vector 0 eta-0))) e-2) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45VMCode-projectArgs arg-0 0 u--used e-3) u--body))))))))))
(define CompilerC-45VMCode-n--9383-3631-u--toVMConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (car arg-6))) (let ((e-1 (cdr arg-6))) (cons e-0 (CompilerC-45VMCode-toVM arg-5 arg-4 e-1))))))
(define CompilerC-45VMCode-toVM (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((2) '())(else (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (if (null? e-1) (cons (vector 13 arg-1) '()) (let ((e-45 (unbox e-1))) (cons (vector 2 arg-1 (vector 1 e-45)) '()))))) ((1) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (cons (vector 7 arg-1 arg-0 e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-5)) '())))) ((2) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (cons (vector 4 arg-1 e-7 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-9)) '()))))) ((3) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (cons (vector 6 arg-1 (CompilerC-45VMCode-toReg e-12) (CompilerC-45VMCode-toReg e-13)) '())))) ((4) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45VMCode-toVM 0 (vector 1 e-15) e-16) (CompilerC-45VMCode-toVM arg-0 arg-1 e-17)))))) ((5) (let ((e-19 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (if (null? e-21) (cons (vector 3 arg-1 (vector 1 e-19) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-22)) '()) (let ((e-47 (unbox e-21))) (cons (vector 3 arg-1 (vector 0 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-22)) '()))))))) ((6) (let ((e-26 (vector-ref arg-2 3))) (let ((e-27 (vector-ref arg-2 4))) (cons (vector 8 arg-1 e-26 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-27)) '())))) ((7) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (cons (vector 9 arg-1 e-30 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-toReg eta-0)) e-31)) '())))) ((8) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (let ((e-35 (vector-ref arg-2 4))) (if (null? e-33) (cons (vector 13 arg-1) '()) (let ((e-49 (unbox e-33))) (if (null? e-34) (cons (vector 10 (vector 1 e-49) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-n--9383-3577-u--toVMConAlt e-49 e-35 e-34 e-32 arg-1 arg-0 eta-0)) e-34) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-35)) '()) (let ((e-51 (car e-34))) (let ((e-52 (cdr e-34))) (let ((e-56 (vector-ref e-51 3))) (let ((e-57 (vector-ref e-51 4))) (if (null? e-52) (if (null? e-35) (let ((u--body (CompilerC-45VMCode-toVM arg-0 arg-1 e-57))) (let ((u--used (PreludeC-45Types-u--foldMap_Foldable_List csegen-1845 (lambda (eta-0) (CompilerC-45VMCode-collectUsed eta-0)) u--body))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45VMCode-projectArgs e-49 0 u--used e-56) u--body))) (cons (vector 10 (vector 1 e-49) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-n--9383-3577-u--toVMConAlt e-49 e-35 e-34 e-32 arg-1 arg-0 eta-0)) e-34) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-35)) '())) (cons (vector 10 (vector 1 e-49) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-n--9383-3577-u--toVMConAlt e-49 e-35 e-34 e-32 arg-1 arg-0 eta-0)) e-34) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-35)) '())))))))))))))) ((9) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (if (null? e-37) (cons (vector 13 arg-1) '()) (let ((e-60 (unbox e-37))) (cons (vector 11 (vector 1 e-60) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45VMCode-n--9383-3631-u--toVMConstAlt e-60 e-39 e-38 e-36 arg-1 arg-0 eta-0)) e-38) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45VMCode-toVM arg-0 arg-1 eta-0)) e-39)) '())))))))) ((10) (let ((e-41 (vector-ref arg-2 2))) (cons (vector 5 arg-1 e-41) '()))) ((11) (cons (vector 13 arg-1) '())) ((12) (let ((e-44 (vector-ref arg-2 2))) (cons (vector 14 e-44) '())))(else (cons (vector 13 arg-1) '())))))))
(define CompilerC-45VMCode-toVMDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (box (vector 0 e-0 (CompilerC-45VMCode-declareVars e-0 (CompilerC-45VMCode-toVM 1 (vector 0 ) e-1))))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (box (vector 1 e-2 e-3 e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (box (vector 2 (CompilerC-45VMCode-declareVars '() (CompilerC-45VMCode-toVM 1 (vector 0 ) e-5))))))(else '()))))
(define CompilerC-45VMCode-allDefs (lambda (ext-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45VMCode-toVMDef e-3) (lambda (u--dC-39) (box (cons e-2 u--dC-39))))))) ext-0)))
(define CompilerC-45CompileExpr-compileExp (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.CompileExpr.NextMN" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45CompileExpr-toCExp '() arg-0 e-5 (vector 1 (vector 0 "main")) arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 e-6)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45CSE-ReplaceMap (vector "Libraries.Data.SortedMap.SortedMap" (vector "Core.Name.Name" ) (vector "Builtin.Pair" (vector "Core.CompileExpr.CExp" '()) (vector "Compiler.Opts.CSE.Count" ))))
(define CompilerC-45OptsC-45CSE-analyzeConAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (vector 1 (cons (+ e-8 1) (vector e-1 e-2 e-3 e-4 e-7)))))))) eff-0) ext-0))))))))))))
(define CompilerC-45OptsC-45CSE-analyzeConstAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-4 1) (cons e-1 e-3)))))))) eff-0) ext-0)))))))))
(define PreludeC-45InterfacesC-45NumC-45Semigroup-u--C-60C-43C-62_Semigroup_AdditiveC-36a (lambda (arg-1 ext-0 ext-1) (let ((e-1 (vector-ref arg-1 0))) ((e-1 ext-0) ext-1))))
(define PreludeC-45InterfacesC-45NumC-45Monoid-u--neutral_Monoid_AdditiveC-36a (lambda (arg-1) (let ((e-3 (vector-ref arg-1 2))) (e-3 0))))
(define PreludeC-45Interfaces-sum (lambda (arg-2 arg-3 ext-0) (let ((e-6 (vector-ref arg-3 5))) (((((e-6 'erased) 'erased) (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45InterfacesC-45NumC-45Semigroup-u--C-60C-43C-62_Semigroup_AdditiveC-36a arg-2 arg-8474 arg-8477))) (PreludeC-45InterfacesC-45NumC-45Monoid-u--neutral_Monoid_AdditiveC-36a arg-2))) (lambda (eta-0) eta-0)) ext-0))))
(define CompilerC-45OptsC-45CSE-analyzeList (lambda (arg-1 arg-2 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-1915 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyze arg-1 eta-0)) arg-2 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (PreludeC-45Interfaces-sum csegen-1055 csegen-14 e-2) e-3))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45CSE-analyzeMaybe (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 (cons 0 '())) (let ((e-2 (unbox arg-2))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-4 (box e-3)))))))) eff-0) ext-0)))))))))
(define DataC-45Vect-u--unzipWith_Zippable_C-40VectC-32C-36kC-41 (lambda (arg-4 arg-5) (if (null? arg-5) (cons '() '()) (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (let ((sc1 (arg-4 e-3))) (let ((e-2 (car sc1))) (let ((e-5 (cdr sc1))) (let ((sc2 (DataC-45Vect-u--unzipWith_Zippable_C-40VectC-32C-36kC-41 arg-4 e-4))) (let ((e-7 (car sc2))) (let ((e-6 (cdr sc2))) (cons (cons e-2 e-7) (cons e-5 e-6)))))))))))))
(define DataC-45Vect-u--unzip_Zippable_C-40VectC-32C-36kC-41 (lambda (ext-0) (DataC-45Vect-u--unzipWith_Zippable_C-40VectC-32C-36kC-41 (lambda (eta-0) eta-0) ext-0)))
(define CompilerC-45OptsC-45CSE-analyzeVect (lambda (arg-2 arg-3 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45Vect-u--unzip_Zippable_C-40VectC-32C-36kC-41 e-5)))))) (CoreC-45Core-traverseVect (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyze arg-2 eta-0)) arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (PreludeC-45Interfaces-sum csegen-1055 csegen-1914 e-2) e-3))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45CSE-analyzeSubExp (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 (cons 1 arg-2))) ((1) (vector 1 (cons 1 arg-2))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 2 e-9 e-10 e-3)))))))) eff-0) ext-0))))))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-15 (vector-ref arg-2 3))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-16) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-17) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (+ (+ e-2 e-7) 1) (vector 3 e-13 e-14 e-15 e-3 e-4)))))))) eff-0) clam-2)))))))))) eff-0) ext-0))))))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-20) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (CompilerC-45OptsC-45CSE-analyzeList arg-1 e-21 clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (+ (+ e-2 e-7) 1) (vector 4 e-19 e-3 e-4)))))))) eff-0) clam-4)))))))))) eff-0) ext-0))))))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (let ((act-1 (CompilerC-45OptsC-45CSE-analyzeList arg-1 e-27 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-6) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 5 e-23 e-24 e-25 e-26 e-3)))))))) eff-0) ext-0))))))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (let ((act-1 (CompilerC-45OptsC-45CSE-analyzeVect arg-1 e-32 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-7) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 6 e-29 e-30 e-31 e-3)))))))) eff-0) ext-0)))))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((act-1 (CompilerC-45OptsC-45CSE-analyzeList arg-1 e-36 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-8) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 7 e-34 e-35 e-3)))))))) eff-0) ext-0))))))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-40) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-9) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 8 e-38 e-39 e-3)))))))) eff-0) ext-0))))))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-44) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-10) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (+ e-2 1) (vector 9 e-42 e-43 e-3)))))))) eff-0) ext-0))))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-47) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-11) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-1915 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45OptsC-45CSE-analyzeConAlt arg-1 eta-0 eta-1))) e-48 '()) clam-11))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-12) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 (CompilerC-45OptsC-45CSE-analyzeMaybe arg-1 e-49 clam-12))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-13) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (vector 1 (cons (+ (+ (+ e-2 (PreludeC-45Interfaces-sum csegen-1055 csegen-14 e-7)) e-10) 1) (vector 10 e-46 e-3 e-4 e-9)))))))) eff-0) clam-12)))))))))) eff-0) clam-11)))))))))) eff-0) ext-0)))))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (let ((act-1 ((CompilerC-45OptsC-45CSE-analyze arg-1 e-52) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-14) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-1915 (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45OptsC-45CSE-analyzeConstAlt arg-1 eta-0 eta-1))) e-53 '()) clam-14))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-15) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 (CompilerC-45OptsC-45CSE-analyzeMaybe arg-1 e-54 clam-15))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-16) (let ((e-10 (car e-8))) (let ((e-9 (cdr e-8))) (vector 1 (cons (+ (+ (+ e-2 (PreludeC-45Interfaces-sum csegen-1055 csegen-14 e-7)) e-10) 1) (vector 11 e-51 e-3 e-4 e-9)))))))) eff-0) clam-15)))))))))) eff-0) clam-14)))))))))) eff-0) ext-0)))))))))) ((12) (vector 1 (cons 1 arg-2))) ((13) (vector 1 (cons 1 arg-2))) (else (vector 1 (cons 1 arg-2))))))
(define CompilerC-45OptsC-45CSE-dropConAlt (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector e-1 e-2 e-3 e-4 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv e-4 e-5)))))))))
(define CompilerC-45OptsC-45CSE-dropConstAlt (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (cons e-1 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-2))))))
(define CompilerC-45OptsC-45CSE-dropVar (lambda (arg-2 arg-3) (if (null? arg-2) '() (let ((e-3 (cdr arg-2))) (cond ((equal? arg-3 0) (box 0))(else (let ((e-4 (- arg-3 1))) (let ((sc1 (CompilerC-45OptsC-45CSE-dropVar e-3 e-4))) (if (null? sc1) '() (let ((e-1 (unbox sc1))) (box (+ e-1 1))))))))))))
(define DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (lambda (arg-4 arg-5 arg-6) (if (null? arg-6) (let ((e-2 (vector-ref arg-4 1))) ((e-2 'erased) '())) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (let ((e-5 (vector-ref arg-4 2))) ((((e-5 'erased) 'erased) (let ((e-6 (vector-ref arg-4 2))) ((((e-6 'erased) 'erased) (let ((e-10 (vector-ref arg-4 1))) ((e-10 'erased) csegen-755))) (arg-5 e-3)))) (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 arg-4 arg-5 e-4))))))))
(define PreludeC-45Types-u--traverse_Traversable_Maybe (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-2 (vector-ref arg-3 1))) ((e-2 'erased) '())) (let ((e-2 (unbox arg-5))) (let ((e-1 (vector-ref arg-3 0))) ((((e-1 'erased) 'erased) (lambda (eta-0) (box eta-0))) (arg-4 e-2)))))))
(define CompilerC-45OptsC-45CSE-dropEnv (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--q) (vector 0 e-2 e-3)) (CompilerC-45OptsC-45CSE-dropVar arg-1 e-2))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (box (vector 1 e-6 e-7))))) ((2) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 2 e-9 e-10 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv (cons e-10 arg-1) e-11)))))) ((3) (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (let ((e-15 (vector-ref arg-2 3))) (let ((e-16 (vector-ref arg-2 4))) (let ((e-17 (vector-ref arg-2 5))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (lambda (eta-1) (vector 3 e-13 e-14 e-15 eta-0 eta-1))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-16)) (CompilerC-45OptsC-45CSE-dropEnv (cons e-14 arg-1) e-17)))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (lambda (eta-1) (vector 4 e-19 eta-0 eta-1))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-20)) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (let ((e-27 (vector-ref arg-2 5))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 5 e-23 e-24 e-25 e-26 eta-0)) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-2 1))) (let ((e-30 (vector-ref arg-2 2))) (let ((e-31 (vector-ref arg-2 3))) (let ((e-32 (vector-ref arg-2 4))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 6 e-29 e-30 e-31 eta-0)) (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 7 e-34 e-35 eta-0)) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 8 e-38 e-39 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-40)))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 9 e-42 e-43 eta-0)) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-44)))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 10 e-46 eta-0 eta-1 eta-2)))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-47)) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropConAlt arg-1 eta-0)) e-48)) (PreludeC-45Types-u--traverse_Traversable_Maybe csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-2 1))) (let ((e-52 (vector-ref arg-2 2))) (let ((e-53 (vector-ref arg-2 3))) (let ((e-54 (vector-ref arg-2 4))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (vector 11 e-51 eta-0 eta-1 eta-2)))) (CompilerC-45OptsC-45CSE-dropEnv arg-1 e-52)) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropConstAlt arg-1 eta-0)) e-53)) (PreludeC-45Types-u--traverse_Traversable_Maybe csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45CSE-dropEnv arg-1 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (box (vector 12 e-56 e-57))))) ((13) (let ((e-59 (vector-ref arg-2 1))) (box (vector 13 e-59)))) (else (let ((e-61 (vector-ref arg-2 1))) (let ((e-62 (vector-ref arg-2 2))) (box (vector 14 e-61 e-62))))))))
(define CompilerC-45OptsC-45CSE-store (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-1 5))) (cond ((equal? sc0 1) (vector 1 '())) (else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-0 (car e-5))) (let ((e-1 (cdr e-5))) (let ((act-2 (let ((sc3 (LibrariesC-45DataC-45SortedMap-lookup (cons arg-1 arg-2) e-0))) (if (null? sc3) (vector 1 (cons (vector 2 "csegen" e-1) (cons 1 (bs+ e-1 1 63)))) (let ((e-2 (unbox sc3))) (let ((e-7 (car e-2))) (let ((e-6 (cdr e-2))) (vector 1 (cons e-7 (cons (+ e-6 1) e-1)))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-3 (let ((act-3 (set-box! arg-0 (cons (LibrariesC-45DataC-45SortedMap-insert (cons arg-1 arg-2) (cons e-2 e-8) e-0) e-7)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (box e-2)))))))))))) eff-0) clam-1)))))))))) eff-0) ext-0))))))))))
(define CompilerC-45OptsC-45CSE-case--caseC-32blockC-32inC-32analyze-7454 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 (cons arg-3 arg-4)) (let ((e-1 (unbox arg-6))) (let ((act-1 (CompilerC-45OptsC-45CSE-store arg-1 arg-3 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 (cons arg-3 arg-4)) (let ((e-2 (unbox e-5))) (vector 1 (cons arg-3 (vector 1 (vector 2 ) e-2)))))))) eff-0) ext-0)))))))))
(define CompilerC-45OptsC-45CSE-analyze (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((6) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) ((7) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) ((8) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) ((9) (lambda (eta-0) (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0)))(else (lambda (eta-0) (let ((act-1 (CompilerC-45OptsC-45CSE-analyzeSubExp arg-1 arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((_-0 (cons e-2 e-3))) (lambda (eta-1) (CompilerC-45OptsC-45CSE-case--caseC-32blockC-32inC-32analyze-7454 arg-1 arg-2 e-2 e-3 _-0 (CompilerC-45OptsC-45CSE-dropEnv '() e-3) eta-1))))))) eff-0) eta-0))))))))))
(define CompilerC-45OptsC-45CSE-analyzeDef (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-0 (Builtin-snd e-5))))))) (CompilerC-45OptsC-45CSE-analyze arg-0 e-1) ext-0)))) ((1) (vector 1 arg-1)) ((2) (vector 1 arg-1)) (else (vector 1 arg-1)))))
(define CompilerC-45OptsC-45CSE-compileName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 50 (lambda () (string-append "Couldn't find " (CoreC-45Name-u--show_Show_Name arg-1))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 '()))))) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 50 (lambda () (string-append "Couldn't compile " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-26 (vector-ref act-3 1))) (vector 0 e-26))) (else (vector 1 '())))) (let ((e-26 (unbox e-19))) (vector 1 (box (cons arg-1 (cons (let ((e-49 (vector-ref e-1 0))) e-49) e-26)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45CSE-n--12872-9745-u--toDef (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) '() (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((1) (box (cons e-2 (cons (vector 2 ) (vector 0 '() e-6)))))(else '()))))))))))
(define CompilerC-45OptsC-45CSE-newToplevelDefs (lambda (arg-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45OptsC-45CSE-n--12872-9745-u--toDef arg-0 eta-0)) (LibrariesC-45DataC-45SortedMap-toList arg-0))))
(define CompilerC-45OptsC-45CSE-replaceConAlt (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-1 (vector-ref arg-4 0))) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-5) ext-0))))))))
(define CompilerC-45OptsC-45CSE-replaceConstAlt (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-2) ext-0)))))
(define CompilerC-45OptsC-45CSE-replaceRef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () (string-append "Trying to replace " (string-append (CoreC-45Name-u--show_Show_Name arg-5) ": "))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-5 e-6)))))) (lambda (eta-0) (let ((act-2 (unbox arg-1))) (vector 1 act-2))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () "  not a name generated during CSE") eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (vector 1 arg-4 arg-5)))))) (let ((e-2 (unbox e-6))) (lambda (clam-0) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-7 0) ((1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () "  already replaced: Occurs many times") clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 (vector 4 (vector 2 ) (vector 1 arg-4 arg-5) '())))))) ((0) (let ((act-3 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () "  already replaced: Occurs once") clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 e-8))))) (else (let ((e-9 (vector-ref e-7 1))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () (string-append "  expression of unknown quantity (" (string-append (PreludeC-45Show-u--show_Show_Integer e-9) " occurences)"))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 ((CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 e-9 e-8) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc7 (PreludeC-45EqOrd-u--C-62_Ord_Integer e-9 arg-3))) (cond ((equal? sc7 1) (let ((act-5 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-5) " assigned quantity \"Many\"")) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((act-6 ((let ((eff-0 (lambda (world-0) (let ((act-6 (unbox arg-1))) (vector 1 act-6))))) (lambda (world-0) (let ((act-6 (eff-0 world-0))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-1 (lambda (world-1) (let ((act-7 (set-box! arg-1 (LibrariesC-45DataC-45SortedMap-insert arg-5 (cons e-11 (vector 1 )) e-13)))) (vector 1 act-7))))) eff-1) world-0))))))) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (vector 1 (vector 4 (vector 2 ) (vector 1 arg-4 arg-5) '()))))))))) (else (let ((act-5 (CoreC-45ContextC-45Log-log arg-2 "compiler.cse" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-5) " assigned quantity \"Once\"")) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((act-6 ((let ((eff-0 (lambda (world-0) (let ((act-6 (unbox arg-1))) (vector 1 act-6))))) (lambda (world-0) (let ((act-6 (eff-0 world-0))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-1 (lambda (world-1) (let ((act-7 (set-box! arg-1 (LibrariesC-45DataC-45SortedMap-insert arg-5 (cons e-11 (vector 0 )) e-13)))) (vector 1 act-7))))) eff-1) world-0))))))) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (vector 1 e-11))))))))))))) eff-0) clam-0)))))))))))))))))) eff-0) ext-0))))))))))
(define CompilerC-45OptsC-45CSE-replaceExp (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (vector 1 arg-4)) ((1) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (CompilerC-45OptsC-45CSE-replaceRef arg-1 arg-2 arg-3 e-6 e-7 clam-0)))) ((2) (let ((e-9 (vector-ref arg-4 1))) (let ((e-10 (vector-ref arg-4 2))) (let ((e-11 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-9 e-10 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-11) clam-0))))) ((3) (let ((e-13 (vector-ref arg-4 1))) (let ((e-14 (vector-ref arg-4 2))) (let ((e-15 (vector-ref arg-4 3))) (let ((e-16 (vector-ref arg-4 4))) (let ((e-17 (vector-ref arg-4 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-13 e-14 e-15 e-5 eta-2))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-16) eta-0)) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-17) clam-0))))))) ((4) (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 4 e-19 e-5 eta-2))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-20) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-0)) e-21 '()) clam-0))))) ((5) (let ((e-23 (vector-ref arg-4 1))) (let ((e-24 (vector-ref arg-4 2))) (let ((e-25 (vector-ref arg-4 3))) (let ((e-26 (vector-ref arg-4 4))) (let ((e-27 (vector-ref arg-4 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-23 e-24 e-25 e-26 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-0)) e-27 '()) clam-0))))))) ((6) (let ((e-29 (vector-ref arg-4 1))) (let ((e-30 (vector-ref arg-4 2))) (let ((e-31 (vector-ref arg-4 3))) (let ((e-32 (vector-ref arg-4 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-29 e-30 e-31 e-5)))))) (CoreC-45Core-traverseVect (lambda (eta-0) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-0)) e-32) clam-0)))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-34 e-35 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 eta-0)) e-36 '()) clam-0))))) ((8) (let ((e-38 (vector-ref arg-4 1))) (let ((e-39 (vector-ref arg-4 2))) (let ((e-40 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 8 e-38 e-39 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-40) clam-0))))) ((9) (let ((e-42 (vector-ref arg-4 1))) (let ((e-43 (vector-ref arg-4 2))) (let ((e-44 (vector-ref arg-4 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-42 e-43 e-5)))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-44) clam-0))))) ((10) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (let ((e-48 (vector-ref arg-4 3))) (let ((e-49 (vector-ref arg-4 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 10 e-46 e-5 eta-3 eta-4)))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-47) eta-1)) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45CSE-replaceConAlt arg-1 arg-2 arg-3 eta-1 eta-2))) e-48 '()) eta-0)) (if (null? e-49) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-49))) (let ((eff-0 (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) clam-0)))))) ((11) (let ((e-51 (vector-ref arg-4 1))) (let ((e-52 (vector-ref arg-4 2))) (let ((e-53 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 11 e-51 e-5 eta-3 eta-4)))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-52) eta-1)) (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45CSE-replaceConstAlt arg-1 arg-2 arg-3 eta-1 eta-2))) e-53 '()) eta-0)) (if (null? e-54) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox e-54))) (let ((eff-0 (CompilerC-45OptsC-45CSE-replaceExp arg-1 arg-2 arg-3 e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) clam-0)))))) ((12) (vector 1 arg-4)) ((13) (vector 1 arg-4)) (else (vector 1 arg-4))))))
(define CompilerC-45OptsC-45CSE-replaceDef (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-2 (cons e-6 (vector 0 e-8 e-5)))))))) (CompilerC-45OptsC-45CSE-replaceExp arg-0 arg-1 1 e-9) clam-0)))) ((1) (vector 1 (cons e-2 (cons e-6 e-7)))) ((2) (vector 1 (cons e-2 (cons e-6 e-7)))) (else (vector 1 (cons e-2 (cons e-6 e-7))))))))))))
(define CompilerC-45OptsC-45CSE-toReplaceMap (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-fromList csegen-861 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (cons e-10 (cons e-7 (vector 2 e-11))))))))) (LibrariesC-45DataC-45SortedMap-toList ext-0)))))
(define CompilerC-45OptsC-45CSE-u--show_Show_Count (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "Once") ((1) "Many") (else (let ((e-0 (vector-ref arg-0 1))) (string-append "C " (PreludeC-45Show-u--show_Show_Integer e-0)))))))
(define CompilerC-45OptsC-45CSE-cse (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-55 (CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45CSE-compileName arg-1 eta-1 eta-2))) arg-2 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (let ((e-4 (vector-ref e-5 4))) (let ((e-42 (vector-ref e-4 2))) (let ((e-51 (vector-ref e-42 18))) e-51))))) (cond ((equal? sc2 1) (vector 1 (cons e-6 arg-3))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "compiler.cse" 10 (lambda () (string-append "Analysing " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-2)) " names"))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-newRef (vector "Compiler.Opts.CSE.Sts" ) (cons (LibrariesC-45DataC-45SortedMap-empty (vector (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-722 (csegen-1875) arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-722 (csegen-1875) arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1066 (csegen-1886) arg-1626 arg-1629))))) 0)) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Core-traversePair (lambda (eta-3) (CoreC-45Core-traversePair (lambda (eta-4) (lambda (eta-5) (CompilerC-45OptsC-45CSE-analyzeDef e-8 eta-4 eta-5))) eta-3)) eta-2)) e-6 '()) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (let ((act-6 (unbox e-8))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-0 (car e-10))) (let ((act-7 ((CoreC-45Core-newRef CompilerC-45OptsC-45CSE-ReplaceMap (CompilerC-45OptsC-45CSE-toReplaceMap e-0)) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-8 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CompilerC-45OptsC-45CSE-replaceDef e-11 arg-1 eta-4)) e-9 '()) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-9 ((CompilerC-45OptsC-45CSE-replaceExp e-11 arg-1 1 arg-3) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-10 (let ((act-10 (unbox e-11))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--filtered (LibrariesC-45DataC-45SortedMap-toList e-14))) (lambda (eta-6) (let ((act-11 (CoreC-45ContextC-45Log-log arg-1 "compiler.cse" 10 (lambda () (DataC-45String-fastUnlines (cons "Found the following unadjusted subexpressions:" (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-15 (cdr e-3))) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append ": count " (CompilerC-45OptsC-45CSE-u--show_Show_Count e-15))))))) u--filtered)))) eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((u--newDefs (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45OptsC-45CSE-newToplevelDefs e-14) e-12))) (vector 1 (cons u--newDefs e-13)))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) clam-1))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Common-n--13182-2242-u--fullShow (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((4) (let ((e-1 (vector-ref arg-4 2))) (CoreC-45Name-u--show_Show_Name e-1)))(else (CoreC-45Name-u--show_Show_Name arg-4)))))
(define CompilerC-45Common-n--13182-2241-u--dumpDef (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (string-append (CompilerC-45Common-n--13182-2242-u--fullShow arg-1 arg-2 arg-3 e-2) (string-append " = " (string-append (let ((e-1 (car arg-1))) (e-1 e-3)) "\xa;")))))))
(define CompilerC-45Common-dumpIR (lambda (arg-1 arg-2 arg-3) (let ((u--cstrs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45Common-n--13182-2241-u--dumpDef arg-1 arg-3 arg-2 eta-0)) arg-3))) (lambda (eta-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-2 (PreludeC-45Types-fastConcat u--cstrs)) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-2 e-6) clam-0))))))) eff-0) eta-0)))))))))
(define CompilerC-45Inline-getArity (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45TypesC-45List-lengthTR e-0))) ((1) (let ((e-3 (vector-ref arg-0 2))) e-3)) ((2) (let ((e-6 (vector-ref arg-0 2))) (PreludeC-45TypesC-45List-lengthTR e-6))) (else 0))))
(define CompilerC-45Inline-unload (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CompilerC-45Inline-unload e-3 (vector 4 (CoreC-45CompileExpr-getFC arg-2) arg-2 (cons e-2 '()))))))))
(define CompilerC-45Inline-n--13381-5670-u--fixArityAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((act-1 ((CompilerC-45Inline-fixArityTm (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-6 e-5 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-4 e-6))))) eff-0) ext-0))))))))))))
(define CompilerC-45Inline-n--13381-5732-u--fixArityConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-0 arg-6 e-2 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-1 e-5))))) eff-0) ext-0)))))))))
(define CompilerC-45Inline-n--13381-5547-u--traverseArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 ext-0) (if (null? arg-8) (vector 1 '()) (let ((e-3 (car arg-8))) (let ((e-4 (cdr arg-8))) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-7 arg-5 e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45Inline-n--13381-5547-u--traverseArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CompilerC-45Inline-fixArityTm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (CompilerC-45Inline-unload arg-3 (vector 1 e-2 e-3)))) (let ((e-1 (unbox e-6))) (let ((u--arity (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) 0 (let ((e-28 (unbox e-19))) (CompilerC-45Inline-getArity e-28)))))) (lambda (eta-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 u--arity (vector 4 e-2 (vector 1 e-2 e-3) '()) arg-3)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-fixArityTm (cons e-6 arg-0) arg-1 e-7 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 2 e-5 e-6 e-8) arg-3))))) eff-0) eta-0)))))))))) ((3) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (let ((e-13 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-12 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-fixArityTm (cons e-10 arg-0) arg-1 e-13 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 3 e-9 e-10 e-11 e-5 e-6) arg-3))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (lambda (clam-0) (case (vector-ref e-16 0) ((1) (let ((e-52 (vector-ref e-16 1))) (let ((e-53 (vector-ref e-16 2))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-53 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--outf (vector 4 e-15 (vector 1 e-52 e-53) e-17))) (let ((u--f (vector 1 e-52 e-53))) (lambda (clam-1) (if (null? e-6) (vector 1 (CompilerC-45Inline-unload arg-3 u--outf)) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-17 '()) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--f (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-3)))) eff-0) clam-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-17 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45Inline-fixArityTm arg-0 arg-1 e-16 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-3)))) eff-0) clam-0)))))))))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((e-23 (vector-ref arg-2 5))) (lambda (clam-0) (if (null? arg-3) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-23 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-19 e-20 e-21 e-22 e-5))))) eff-0) clam-0))))) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3))))))))))) ((6) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (lambda (clam-1) (if (null? arg-3) (let ((act-1 (CompilerC-45Inline-n--13381-5547-u--traverseArgs arg-0 e-25 e-28 e-27 e-26 arg-1 arg-0 e-28 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-25 e-26 e-27 e-5))))) eff-0) clam-1))))) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3)))))))))) ((7) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (lambda (clam-2) (if (null? arg-3) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (u--tm) (CompilerC-45Inline-fixArityTm arg-0 arg-1 u--tm '())) e-32 '()) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 7 e-30 e-31 e-5))))) eff-0) clam-2))))) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3))))))))) ((8) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-36 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 8 e-34 e-35 e-5) arg-3))))) eff-0) eta-0)))))))))) ((9) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-40 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 9 e-38 e-39 e-5) arg-3))))) eff-0) eta-0)))))))))) ((10) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (let ((e-45 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-43 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45Inline-n--13381-5670-u--fixArityAlt arg-0 e-45 e-44 e-43 e-42 arg-3 arg-1 eta-2 eta-3))) e-44 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (if (null? e-45) (vector 1 '()) (let ((e-2 (unbox e-45))) ((let ((eff-0 (CompilerC-45Inline-fixArityTm arg-0 arg-1 e-2 '()))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))) eta-2))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 10 e-42 e-5 e-6 e-7) arg-3))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((11) (let ((e-47 (vector-ref arg-2 1))) (let ((e-48 (vector-ref arg-2 2))) (let ((e-49 (vector-ref arg-2 3))) (let ((e-50 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-fixArityTm arg-0 arg-1 e-48 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45Inline-n--13381-5732-u--fixArityConstAlt arg-0 e-50 e-49 e-48 e-47 arg-3 arg-1 eta-2 eta-3))) e-49 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (if (null? e-50) (vector 1 '()) (let ((e-2 (unbox e-50))) ((let ((eff-0 (CompilerC-45Inline-fixArityTm arg-0 arg-1 e-2 '()))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))) eta-2))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 (vector 11 e-47 e-5 e-6 e-7) arg-3))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (lambda (clam-5) (if (null? arg-3) (vector 1 arg-2) (vector 1 (CompilerC-45CompileExpr-expandToArity arg-0 0 arg-2 arg-3))))))))
(define CompilerC-45Inline-fixArity (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((act-1 ((CompilerC-45Inline-fixArityTm e-0 arg-0 e-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-0 e-5))))) eff-0) ext-0)))))))) ((3) (let ((e-2 (vector-ref arg-1 1))) (let ((act-1 ((CompilerC-45Inline-fixArityTm '() arg-0 e-2 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0)))))))(else (vector 1 arg-1)))))
(define CompilerC-45Inline-fixArityDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) (vector 1 (vector 0 )) (let ((e-26 (unbox e-19))) (let ((act-3 (CompilerC-45Inline-fixArity arg-0 e-26 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-27 (vector-ref act-3 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-setCompiled arg-0 arg-1 e-27 eta-1)))) eff-0) clam-0))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-fixArityExp (lambda (arg-0 arg-1 arg-2) (CompilerC-45Inline-fixArityTm arg-0 arg-1 arg-2 '())))
(define CoreC-45CompileExpr-forgetDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((u--ns (CoreC-45CompileExpr-addLocs e-0 '()))) (let ((u--argsC-39 (CoreC-45CompileExpr-conArgs e-0 u--ns))) (vector 0 u--argsC-39 (CoreC-45CompileExpr-forget e-0 e-1))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (vector 1 e-2 e-3 e-4))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (vector 2 e-5 e-6 e-7))))) (else (let ((e-8 (vector-ref arg-0 1))) (vector 3 (CoreC-45CompileExpr-forget '() e-8)))))))
(define CompilerC-45Common-getMinimalDef (lambda (arg-0 ext-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (vector 1 (cons e-0 '())))) (else (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-38 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-51 e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--refsR (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (LibrariesC-45DataC-45NameMap-fromList eta-2)) e-7))) (lambda (eta-2) (let ((act-4 (CoreC-45TTC-u--fromBuf_TTC_FC e-5 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_RigCount e-5 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45TTC-u--fromBuf_TTC_Name e-5 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--def (vector e-8 e-10 (vector 10 e-8 (vector 0 )) '() '() '() '() e-9 '() (LibrariesC-45DataC-45WithDefault-specified 2) (cons (vector 0 ) (vector 0 )) 0 '() '() u--refsR 0 0 1 (vector 0 ) e-6 '() '() '()))) (lambda (eta-5) (vector 1 (cons u--def (box (cons e-1 e-2)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define CoreC-45Context-lookupContextEntry (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((8) (let ((e-0 (vector-ref arg-0 1))) (let ((sc1 (LibrariesC-45DataC-45IntMap-lookup e-0 (let ((e-6 (vector-ref arg-1 6))) e-6)))) (if (null? sc1) (let ((u--a (let ((e-4 (vector-ref arg-1 4))) e-4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox u--a))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((LibrariesC-45DataC-45IOArray-readArray csegen-82 e-5 e-0) eta-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (vector 1 (box (cons e-0 e-1)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (let ((e-1 (unbox sc1))) (lambda (eta-0) (vector 1 (box (cons e-0 e-1)))))))))(else (let ((sc0 (LibrariesC-45DataC-45NameMap-lookup arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)))) (if (null? sc0) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc0))) (CoreC-45Context-lookupContextEntry (vector 8 e-1) arg-1))))))))
(define CoreC-45ContextC-45Context-refersToRuntime (lambda (arg-0) (PreludeC-45Types-maybe (lambda () LibrariesC-45DataC-45NameMap-empty) (lambda () (lambda (eta-0) eta-0)) (let ((e-14 (vector-ref arg-0 14))) e-14))))
(define CoreC-45Context-toResolvedNames (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (cdr arg-2))) ((e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) arg-3)))) eff-0) ext-0)))))))
(define CompilerC-45Common-getAllDesc (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-1) (vector 1 (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((8) (let ((e-4 (vector-ref e-2 1))) (let ((act-1 (let ((act-1 ((LibrariesC-45DataC-45IOArray-readArray csegen-82 arg-2 e-4) clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (vector 8 e-4))) (if (null? e-5) (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupContextEntry u--n (let ((e-0 (vector-ref arg-3 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 20 (lambda () (string-append "Couldn't find " (CoreC-45Name-u--show_Show_Name u--n))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else ((CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3) clam-1)))) (let ((e-7 (unbox e-6))) (let ((e-8 (cdr e-7))) (let ((act-3 (CompilerC-45Common-getMinimalDef e-8 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 u--n e-12 eta-1)) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((sc10 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-29 (vector-ref e-12 7))) e-29) csegen-30))) (cond ((equal? sc10 1) (let ((act-5 (let ((act-5 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 arg-2 e-4 (cons e-4 e-11)) clam-2))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((u--refs (CoreC-45ContextC-45Context-refersToRuntime e-12))) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toResolvedNames arg-0 csegen-54 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys u--refs) '()) clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (CompilerC-45Common-getAllDesc arg-0 (PreludeC-45TypesC-45List-tailRecAppend e-15 e-3) arg-2 arg-3))) eff-0) clam-2)))))))))) (else (let ((act-5 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 20 (lambda () (string-append "Dropping " (string-append (CoreC-45Name-u--show_Show_Name u--n) " because it's erased"))) clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else ((CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3) clam-2))))))))))))))) eff-0) clam-1))))))))))) eff-0) eta-0)))))) (CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3))))) eff-0) clam-0)))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 20 (lambda () (string-append "Ignoring " (string-append (CoreC-45Name-u--show_Show_Name e-2) " because it's not a Resolved name"))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((CompilerC-45Common-getAllDesc arg-0 e-3 arg-2 arg-3) clam-0))))))))))))
(define CompilerC-45Common-warnIfHole (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((3) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (string-append "Warning: compiling hole " (CoreC-45Name-u--show_Show_Name arg-0)) "\xa;") ext-0))) (vector 1 act-1)))(else (vector 1 (vector 0 ))))))
(define CompilerC-45Common-getNamedDef (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--ndef (CoreC-45CompileExpr-forgetDef e-7))) (lambda (eta-0) (let ((act-1 (CompilerC-45Common-warnIfHole e-2 u--ndef eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (cons e-2 (cons e-6 u--ndef))))))))))))))
(define CoreC-45Context-getNextEntry (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-0 (vector-ref e-5 0))) (let ((e-44 (vector-ref e-0 1))) e-44)))))) eff-0) ext-0)))))))
(define CoreC-45TT-n--9930-7811-u--addRefsArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (CoreC-45TT-n--9930-7811-u--addRefsArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CoreC-45TT-addRefs arg-7 arg-6 arg-8 e-2) e-3))))))
(define CoreC-45TT-addRefs (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) arg-3) ((1) (let ((e-9 (vector-ref arg-4 3))) (LibrariesC-45DataC-45NameMap-insert e-9 arg-1 arg-3))) ((2) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (CoreC-45TT-n--9930-7811-u--addRefsArgs e-14 e-13 e-12 e-11 arg-3 arg-2 arg-1 arg-3 e-14)))))) ((3) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (case (vector-ref e-18 0) ((1) (let ((e-54 (vector-ref e-18 3))) (let ((e-55 (vector-ref e-18 4))) (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-54) e-55) e-19))))(else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 (CoreC-45TTC-45Binder-binderType e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-4 2))) (let ((e-23 (vector-ref arg-4 3))) (case (vector-ref e-22 0) ((4) (let ((e-58 (vector-ref e-22 2))) (let ((e-59 (vector-ref e-22 3))) (case (vector-ref e-58 0) ((1) (let ((e-63 (vector-ref e-58 3))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-63 arg-2))) (cond ((equal? sc3 1) (CoreC-45TT-addRefs 1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-63 1 arg-3) e-23)) (else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 (LibrariesC-45DataC-45NameMap-insert e-63 arg-1 arg-3) e-59) e-23))))))(else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-22) e-23))))))(else (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-22) e-23)))))) ((5) (let ((e-28 (vector-ref arg-4 4))) (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-28))) ((6) (let ((e-32 (vector-ref arg-4 3))) (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-32))) ((7) (let ((e-36 (vector-ref arg-4 3))) (let ((e-37 (vector-ref arg-4 4))) (CoreC-45TT-addRefs arg-1 arg-2 (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-4 3))) (CoreC-45TT-addRefs arg-1 arg-2 arg-3 e-41))) ((9) arg-3) ((10) (let ((e-47 (vector-ref arg-4 2))) (CoreC-45TTC-45Term-u--foldr_Foldable_WhyErased (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (CoreC-45TT-addRefs arg-1 arg-2 eta-2 eta-3))) eta-0 eta-1))) arg-3 e-47))) (else arg-3))))
(define CoreC-45TT-getRefs (lambda (arg-1 arg-2) (CoreC-45TT-addRefs 0 arg-1 LibrariesC-45DataC-45NameMap-empty arg-2)))
(define DataC-45Vect-tail (lambda (arg-2) (let ((e-3 (cdr arg-2))) e-3)))
(define CompilerC-45LambdaLift-contractUsed (lambda (arg-2) (DataC-45Vect-tail arg-2)))
(define CompilerC-45LambdaLift-contractUsedMany (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-3 (cdr arg-1))) (CompilerC-45LambdaLift-contractUsedMany e-3 (CompilerC-45LambdaLift-contractUsed arg-2))))))
(define CompilerC-45LambdaLift-dropIdx (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-1) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))) (let ((e-9 (cdr arg-1))) (cond ((equal? arg-2 0) (if (null? arg-3) (if (null? arg-4) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))) (let ((e-14 (car arg-4))) (cond ((equal? e-14 0) 0) ((equal? e-14 1) (Builtin-idris_crash "INTERNAL ERROR: Referenced variable marked as unused"))(else (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))))))) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4))))))))(else (let ((e-10 (- arg-2 1))) (if (null? arg-3) (if (null? arg-4) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4)))))) (let ((e-19 (car arg-4))) (let ((e-20 (cdr arg-4))) (cond ((equal? e-19 0) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx e-9 e-10 '() e-20))) ((equal? e-19 1) (CompilerC-45LambdaLift-dropIdx e-9 e-10 '() e-20))(else (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4))))))))))) (cond ((equal? arg-2 0) 0)(else (let ((e-0 (- arg-2 1))) (let ((e-6 (cdr arg-3))) (CoreC-45TTC-45VarC-45Var-later (CompilerC-45LambdaLift-dropIdx arg-1 e-0 e-6 arg-4))))))))))))))
(define CompilerC-45LambdaLift-n--9717-5282-u--dropConCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-1 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((e-5 (vector-ref arg-8 4))) (let ((u--droppedSc (CompilerC-45LambdaLift-dropUnused arg-2 arg-0 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-1) arg-7 e-5))) (vector e-1 e-2 e-3 e-4 u--droppedSc)))))))))
(define CompilerC-45LambdaLift-n--9717-5356-u--dropConstCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-1 (car arg-8))) (let ((e-2 (cdr arg-8))) (cons e-1 (CompilerC-45LambdaLift-dropUnused arg-2 arg-0 arg-1 arg-7 e-2))))))
(define CompilerC-45LambdaLift-dropUnused (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((10) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (vector 10 e-1 e-2)))) ((11) (let ((e-4 (vector-ref arg-4 1))) (vector 11 e-4))) ((12) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (vector 12 e-6 e-7)))) ((0) (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((eff-0 (CompilerC-45LambdaLift-dropIdx arg-0 e-10 arg-2 arg-3))) (vector 0 eff-0 e-11))))) ((5) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (let ((e-17 (vector-ref arg-4 4))) (let ((e-18 (vector-ref arg-4 5))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-18))) (vector 5 e-14 e-15 e-16 e-17 u--argsC-39)))))))) ((4) (let ((e-20 (vector-ref arg-4 1))) (let ((e-21 (vector-ref arg-4 2))) (let ((e-22 (vector-ref arg-4 3))) (let ((e-23 (vector-ref arg-4 4))) (let ((u--valC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-22))) (let ((u--scC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 (cons e-21 arg-2) arg-3 e-23))) (vector 4 e-20 e-21 u--valC-39 u--scC-39)))))))) ((3) (let ((e-25 (vector-ref arg-4 1))) (let ((e-26 (vector-ref arg-4 2))) (let ((e-27 (vector-ref arg-4 3))) (let ((e-28 (vector-ref arg-4 4))) (let ((u--cC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-27))) (let ((u--argC-39 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-28))) (vector 3 e-25 e-26 u--cC-39 u--argC-39)))))))) ((6) (let ((e-30 (vector-ref arg-4 1))) (let ((e-31 (vector-ref arg-4 2))) (let ((e-32 (vector-ref arg-4 3))) (let ((e-33 (vector-ref arg-4 4))) (let ((e-34 (vector-ref arg-4 5))) (let ((u--argsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-34))) (vector 6 e-30 e-31 e-32 e-33 u--argsC-39)))))))) ((7) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (let ((e-38 (vector-ref arg-4 3))) (let ((e-39 (vector-ref arg-4 4))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-39))) (vector 7 e-36 e-37 e-38 u--argsC-39))))))) ((1) (let ((e-41 (vector-ref arg-4 1))) (let ((e-42 (vector-ref arg-4 2))) (let ((e-43 (vector-ref arg-4 3))) (let ((e-44 (vector-ref arg-4 4))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-44))) (vector 1 e-41 e-42 e-43 u--argsC-39))))))) ((2) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (let ((e-48 (vector-ref arg-4 3))) (let ((e-49 (vector-ref arg-4 4))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-49))) (vector 2 e-46 e-47 e-48 u--argsC-39))))))) ((8) (let ((e-51 (vector-ref arg-4 1))) (let ((e-52 (vector-ref arg-4 2))) (let ((e-53 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 4))) (let ((u--altsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-n--9717-5282-u--dropConCase arg-1 arg-2 arg-0 e-54 e-53 e-52 e-51 arg-3 eta-0)) e-53))) (vector 8 e-51 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-52) u--altsC-39 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-54)))))))) (else (let ((e-56 (vector-ref arg-4 1))) (let ((e-57 (vector-ref arg-4 2))) (let ((e-58 (vector-ref arg-4 3))) (let ((e-59 (vector-ref arg-4 4))) (let ((u--altsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-n--9717-5356-u--dropConstCase arg-1 arg-2 arg-0 e-59 e-58 e-57 e-56 arg-3 eta-0)) e-58))) (vector 9 e-56 (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 e-57) u--altsC-39 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45LambdaLift-dropUnused arg-0 arg-1 arg-2 arg-3 eta-0)) e-59)))))))))))
(define CompilerC-45LambdaLift-dropped (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (cond ((equal? e-6 0) (cons e-2 (CompilerC-45LambdaLift-dropped e-3 e-7))) (else (CompilerC-45LambdaLift-dropped e-3 e-7))))))))))
(define CompilerC-45LambdaLift-n--9165-3389-u--mkName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (vector 0 e-0 (CompilerC-45LambdaLift-n--9165-3389-u--mkName arg-0 e-1 arg-2))))) ((1) (let ((e-2 (vector-ref arg-1 1))) (vector 2 (CoreC-45Name-displayUserName e-2) arg-2))) ((4) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45LambdaLift-n--9165-3389-u--mkName arg-0 e-4 arg-2))) ((6) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (vector 2 (string-append "case block in " (string-append e-5 (string-append " (" (string-append (PreludeC-45Show-u--show_Show_Int e-6) ")")))) arg-2)))) ((7) (let ((e-7 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 2))) (vector 2 (string-append "with block in " (string-append e-7 (string-append " (" (string-append (PreludeC-45Show-u--show_Show_Int e-8) ")")))) arg-2))))(else (vector 2 (CoreC-45Name-u--show_Show_Name arg-1) arg-2)))))
(define CompilerC-45LambdaLift-genName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--i (let ((e-2 (vector-ref e-5 2))) e-2))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (vector e-0 e-1 (bs+ u--i 1 63))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (CompilerC-45LambdaLift-n--9165-3389-u--mkName arg-0 (let ((e-0 (vector-ref e-5 0))) e-0) u--i))))))))) eff-0) ext-0)))))))
(define CompilerC-45LambdaLift-getUnused (lambda (arg-1) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (cond ((equal? eta-0 1) 0) (else 1))) arg-1)))
(define DataC-45Vect-replicate (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (cons arg-2 (DataC-45Vect-replicate e-0 arg-2)))))))
(define CompilerC-45LambdaLift-initUsed (lambda (arg-0) (DataC-45Vect-replicate (PreludeC-45TypesC-45List-lengthTR arg-0) 0)))
(define DataC-45Vect-replaceAt (lambda (arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (let ((e-6 (cdr arg-4))) (cons arg-3 e-6)))(else (let ((e-2 (- arg-2 1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (cons e-9 (DataC-45Vect-replaceAt e-2 arg-3 e-10)))))))))
(define CompilerC-45LambdaLift-n--9486-3699-u--finIdx (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (let ((e-2 (cdr arg-5))) (cond ((equal? arg-6 0) 0)(else (let ((e-3 (- arg-6 1))) (+ (CompilerC-45LambdaLift-n--9486-3699-u--finIdx arg-1 arg-2 arg-3 e-2 e-3) 1)))))))
(define CompilerC-45LambdaLift-markUsed (lambda (arg-1 arg-2 arg-4) (let ((u--newUsed (DataC-45Vect-replaceAt (CompilerC-45LambdaLift-n--9486-3699-u--finIdx arg-1 arg-4 arg-2 arg-1 arg-2) 1 arg-4))) u--newUsed)))
(define DataC-45Vect-C-43C-43 (lambda (arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (cons e-3 (DataC-45Vect-C-43C-43 e-4 arg-4)))))))
(define CompilerC-45LambdaLift-weakenUsed (lambda (arg-1 arg-2) (DataC-45Vect-C-43C-43 (DataC-45Vect-replicate (PreludeC-45TypesC-45List-lengthTR arg-1) 0) arg-2)))
(define CompilerC-45LambdaLift-n--9669-4767-u--usedConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-4 (vector-ref arg-9 3))) (let ((e-5 (vector-ref arg-9 4))) (CompilerC-45LambdaLift-contractUsedMany e-4 (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-6 (CompilerC-45LambdaLift-weakenUsed e-4 arg-8) e-5))))))
(define CompilerC-45LambdaLift-n--9669-4814-u--usedConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (cdr arg-9))) (CompilerC-45LambdaLift-usedVars arg-0 arg-6 arg-8 e-2))))
(define CompilerC-45LambdaLift-usedVars (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (CompilerC-45LambdaLift-markUsed arg-0 e-2 arg-2))) ((1) (let ((e-9 (vector-ref arg-3 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-9))) ((2) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-14))) ((3) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 (CompilerC-45LambdaLift-usedVars arg-0 arg-1 arg-2 e-19) e-18)))) ((4) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((u--innerUsed (CompilerC-45LambdaLift-contractUsed (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend (cons e-22 '()) arg-0) arg-1 (CompilerC-45LambdaLift-weakenUsed (cons e-22 '()) arg-2) e-24)))) (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend '() arg-0) arg-1 u--innerUsed e-23)))))) ((5) (let ((e-30 (vector-ref arg-3 5))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-30))) ((6) (let ((e-36 (vector-ref arg-3 5))) (DataC-45Vect-u--foldl_Foldable_C-40VectC-32C-36nC-41 (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-36))) ((7) (let ((e-41 (vector-ref arg-3 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 eta-0 eta-1))) arg-2 e-41))) ((8) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (let ((e-45 (vector-ref arg-3 3))) (let ((e-46 (vector-ref arg-3 4))) (let ((u--defUsed (PreludeC-45Types-maybe (lambda () arg-2) (lambda () (lambda (eta-0) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 arg-2 eta-0))) e-46))) (let ((u--scDefUsed (CompilerC-45LambdaLift-usedVars arg-0 arg-1 u--defUsed e-44))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-n--9669-4767-u--usedConAlt arg-0 e-46 e-45 e-44 e-43 arg-2 arg-1 '() eta-0 eta-1))) u--scDefUsed e-45)))))))) ((9) (let ((e-48 (vector-ref arg-3 1))) (let ((e-49 (vector-ref arg-3 2))) (let ((e-50 (vector-ref arg-3 3))) (let ((e-51 (vector-ref arg-3 4))) (let ((u--defUsed (PreludeC-45Types-maybe (lambda () arg-2) (lambda () (lambda (eta-0) (CompilerC-45LambdaLift-usedVars arg-0 arg-1 arg-2 eta-0))) e-51))) (let ((u--scDefUsed (CompilerC-45LambdaLift-usedVars arg-0 arg-1 u--defUsed e-49))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45LambdaLift-n--9669-4814-u--usedConstAlt arg-0 e-51 e-50 e-49 e-48 arg-2 arg-1 '() eta-0 eta-1))) u--scDefUsed e-50)))))))) ((10) arg-2) ((11) arg-2) (else arg-2))))
(define CompilerC-45LambdaLift-n--9619-3942-u--allPrfs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) '() (let ((e-3 (cdr arg-7))) (let ((e-6 (car arg-8))) (let ((e-7 (cdr arg-8))) (cond ((equal? e-6 0) (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) (CompilerC-45LambdaLift-n--9619-3942-u--allPrfs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-7)))) (else (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) (CompilerC-45LambdaLift-n--9619-3942-u--allPrfs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-7))))))))))
(define CompilerC-45LambdaLift-n--9619-3943-u--allVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (vector 0 lamc-0 arg-7)) (CompilerC-45LambdaLift-n--9619-3942-u--allPrfs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9))))
(define CompilerC-45LambdaLift-makeLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((2) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (CompilerC-45LambdaLift-makeLam arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-5) e-3))))(else (lambda (eta-0) (let ((act-1 ((CompilerC-45LambdaLift-liftExp (PreludeC-45TypesC-45List-tailRecAppend arg-5 arg-1) arg-0 arg-2 arg-3 arg-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--scUsedL (CompilerC-45LambdaLift-usedVars (PreludeC-45TypesC-45List-tailRecAppend arg-5 arg-1) arg-0 (CompilerC-45LambdaLift-initUsed (PreludeC-45TypesC-45List-tailRecAppend arg-5 arg-1)) e-5))) (let ((u--unusedContracted (CompilerC-45LambdaLift-contractUsedMany arg-5 u--scUsedL))) (let ((u--unused (CompilerC-45LambdaLift-getUnused u--unusedContracted))) (let ((u--sclC-39 (CompilerC-45LambdaLift-dropUnused arg-1 arg-0 arg-5 u--unused e-5))) (lambda (eta-1) (let ((act-2 (CompilerC-45LambdaLift-genName arg-0 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-0))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (vector e-0 (cons (cons e-6 (vector 0 (CompilerC-45LambdaLift-dropped arg-1 u--unused) arg-5 u--sclC-39)) e-1) e-2))))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-4 e-6 (PreludeC-45TypesC-45List-lengthTR arg-5) (CompilerC-45LambdaLift-n--9619-3943-u--allVars arg-2 arg-3 arg-5 arg-1 arg-6 arg-4 arg-0 arg-4 arg-1 u--unused))))))))) eff-0) eta-1)))))))))))) eff-0) eta-0))))))))))
(define CompilerC-45LambdaLift-unload (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 arg-3)) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CompilerC-45LambdaLift-unload arg-1 '() (vector 3 arg-1 arg-2 arg-3 e-2) e-3))))))
(define CompilerC-45LambdaLift-n--9648-4513-u--liftConAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-1 (vector-ref arg-9 0))) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (let ((e-4 (vector-ref arg-9 3))) (let ((e-5 (vector-ref arg-9 4))) (let ((act-1 ((CompilerC-45LambdaLift-liftExp (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-7 arg-1 arg-2 e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-4 e-6))))) eff-0) ext-0))))))))))))
(define CompilerC-45LambdaLift-n--9648-4575-u--liftConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-1 ((CompilerC-45LambdaLift-liftExp arg-0 arg-7 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-1 e-5))))) eff-0) ext-0)))))))))
(define CompilerC-45LambdaLift-n--9648-4327-u--traverseArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 ext-0) (if (null? arg-9) (vector 1 '()) (let ((e-3 (car arg-9))) (let ((e-4 (cdr arg-9))) (let ((act-1 ((CompilerC-45LambdaLift-liftExp arg-0 arg-7 arg-1 '() e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45LambdaLift-n--9648-4327-u--traverseArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CompilerC-45LambdaLift-liftExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 0 e-2 e-3)))))) ((1) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 1 e-6 arg-3 e-7 '())))))) ((2) (let ((e-9 (vector-ref arg-4 1))) (let ((e-10 (vector-ref arg-4 2))) (let ((e-11 (vector-ref arg-4 3))) (CompilerC-45LambdaLift-makeLam arg-1 arg-0 arg-2 arg-3 e-9 (cons e-10 '()) e-11))))) ((3) (let ((e-13 (vector-ref arg-4 1))) (let ((e-14 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 4))) (let ((e-17 (vector-ref arg-4 5))) (lambda (eta-0) (let ((act-1 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45LambdaLift-liftExp (cons e-14 arg-0) arg-1 arg-2 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-13 e-14 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((4) (let ((e-19 (vector-ref arg-4 1))) (let ((e-20 (vector-ref arg-4 2))) (let ((e-21 (vector-ref arg-4 3))) (lambda (clam-0) (case (vector-ref e-20 0) ((1) (let ((e-65 (vector-ref e-20 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-0)) e-21 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-19 arg-3 e-65 e-5))))) eff-0) clam-0)))))))(else (let ((act-1 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-20) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-1)) e-21 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45LambdaLift-unload e-19 arg-3 e-5 e-6))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) ((5) (let ((e-23 (vector-ref arg-4 1))) (let ((e-24 (vector-ref arg-4 2))) (let ((e-25 (vector-ref arg-4 3))) (let ((e-26 (vector-ref arg-4 4))) (let ((e-27 (vector-ref arg-4 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-1)) e-27 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-23 e-24 e-25 e-26 e-5))))) eff-0) eta-0)))))))))))) ((6) (let ((e-29 (vector-ref arg-4 1))) (let ((e-30 (vector-ref arg-4 2))) (let ((e-31 (vector-ref arg-4 3))) (let ((e-32 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 (CompilerC-45LambdaLift-n--9648-4327-u--traverseArgs arg-0 arg-2 arg-3 e-29 e-32 e-31 e-30 arg-1 e-32 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 e-29 e-30 arg-3 e-31 e-5))))) eff-0) eta-0))))))))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() eta-1)) e-36 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-34 arg-3 e-35 e-5))))) eff-0) eta-0)))))))))) ((8) (let ((e-38 (vector-ref arg-4 1))) (let ((e-40 (vector-ref arg-4 3))) (cond ((equal? arg-2 1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-40)) (else (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() (vector 4 e-38 e-40 (cons (vector 13 e-38) '())))))))) ((9) (let ((e-42 (vector-ref arg-4 1))) (let ((e-43 (vector-ref arg-4 2))) (let ((e-44 (vector-ref arg-4 3))) (cond ((equal? arg-2 1) (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 (box e-43) e-44)) (else (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() (vector 2 e-42 (vector 2 "act" 0) (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-44))))))))) ((10) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (let ((e-48 (vector-ref arg-4 3))) (let ((e-49 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-47) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45LambdaLift-n--9648-4513-u--liftConAlt arg-0 arg-2 arg-3 e-49 e-48 e-47 e-46 arg-1 arg-3 eta-2 eta-3))) e-48 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (if (null? e-49) (vector 1 '()) (let ((e-2 (unbox e-49))) ((let ((eff-0 (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-2))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))) eta-2))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 8 e-46 e-5 e-6 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((11) (let ((e-51 (vector-ref arg-4 1))) (let ((e-52 (vector-ref arg-4 2))) (let ((e-53 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-52) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45LambdaLift-n--9648-4575-u--liftConstAlt arg-0 arg-2 arg-3 e-54 e-53 e-52 e-51 arg-1 '() eta-2 eta-3))) e-53 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (if (null? e-54) (vector 1 '()) (let ((e-2 (unbox e-54))) ((let ((eff-0 (CompilerC-45LambdaLift-liftExp arg-0 arg-1 arg-2 '() e-2))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))) eta-2))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 9 e-51 e-5 e-6 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((12) (let ((e-56 (vector-ref arg-4 1))) (let ((e-57 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 10 e-56 e-57)))))) ((13) (let ((e-59 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 (vector 11 e-59))))) (else (let ((e-61 (vector-ref arg-4 1))) (let ((e-62 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (vector 12 e-61 e-62)))))))))
(define CompilerC-45LambdaLift-liftBody (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.LambdaLift.Lifts" ) (vector arg-2 '() 0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45LambdaLift-liftExp arg-0 e-5 arg-1 '() arg-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-6 (let ((e-1 (vector-ref e-7 1))) e-1)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45LambdaLift-lambdaLiftDef (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-1 (CompilerC-45LambdaLift-liftBody e-0 arg-0 arg-1 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (cons arg-1 (vector 0 e-0 '() e-2)) e-3))))))) eff-0) ext-0)))))))) ((1) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (vector 1 (cons (cons arg-1 (vector 1 e-2 e-3 e-4)) '())))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (vector 1 (cons (cons arg-1 (vector 2 e-5 e-6 e-7)) '())))))) (else (let ((e-8 (vector-ref arg-2 1))) (let ((act-1 (CompilerC-45LambdaLift-liftBody '() arg-0 arg-1 e-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons (cons arg-1 (vector 3 e-2)) e-3))))))) eff-0) ext-0))))))))))
(define CompilerC-45LambdaLift-lambdaLift (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-7 (cdr e-3))) (lambda (eta-0) (CompilerC-45LambdaLift-lambdaLiftDef arg-1 e-2 e-7 eta-0)))))))
(define CoreC-45ContextC-45Log-micro 1000000)
(define CoreC-45ContextC-45Log-nano 1000000000)
(define CoreC-45ContextC-45Log-n--8075-4978-u--addZeros (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) "000" (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (string-append "00" (string e-2)) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (string-append "0" (string-append (string e-2) (string e-6))) (PreludeC-45Types-fastPack arg-6))))))))))
(define CoreC-45ContextC-45Log-logTimeWhen (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-2 1) (lambda (eta-0) (let ((act-1 (let ((act-1 (SystemC-45Clock-clockTime 3 eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--t (+ (* (SystemC-45Clock-seconds e-5) CoreC-45ContextC-45Log-nano) (SystemC-45Clock-nanoseconds e-5)))) (lambda (eta-1) (let ((act-2 (arg-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (SystemC-45Clock-clockTime 3 eta-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--tC-39 (+ (* (SystemC-45Clock-seconds e-7) CoreC-45ContextC-45Log-nano) (SystemC-45Clock-nanoseconds e-7)))) (let ((u--time (- u--tC-39 u--t))) (lambda (eta-3) (let ((act-4 (let ((act-4 (let ((u--header (string-append "TIMING " (string-append (DataC-45String-replicate arg-3 #\+) (let ((sc4 (PreludeC-45Types-u--C-60_Ord_Nat 0 arg-3))) (cond ((equal? sc4 1) " ") (else ""))))))) (PreludeC-45IO-prim__putStr (string-append (string-append u--header (string-append (arg-4) (string-append ": " (string-append (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer u--time CoreC-45ContextC-45Log-nano)) (string-append "." (string-append (CoreC-45ContextC-45Log-n--8075-4978-u--addZeros arg-5 arg-4 arg-3 arg-2 arg-1 (PreludeC-45Types-fastUnpack (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer (PreludeC-45Num-u--mod_Integral_Integer u--time CoreC-45ContextC-45Log-nano) CoreC-45ContextC-45Log-micro)))) "s")))))) "\xa;") eta-3)))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-6))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))) (else arg-5))))
(define CoreC-45ContextC-45Log-logTime (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45ContextC-45Log-logTimeWhen arg-1 (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (arg-0) (PreludeC-45Types-u--C-60C-61_Ord_Nat arg-2 arg-0))) (let ((e-10 (vector-ref e-5 10))) e-10)) arg-2 arg-3 arg-4))) eff-0) ext-0)))))))
(define CompilerC-45Inline-getLams (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (CompilerC-45Inline-getLams (cons e-2 arg-1) (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-2) (bs+ arg-3 1 63) (cons (vector 1 e-1 (vector 2 "ext" arg-3)) arg-4) e-3)))))(else (cons arg-1 (cons arg-2 (cons arg-4 arg-5)))))))
(define CompilerC-45Inline-getNewArgs (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-10 (car arg-2))) (let ((e-11 (cdr arg-2))) (case (vector-ref e-10 0) ((1) (let ((e-14 (vector-ref e-10 2))) (cons e-14 (CompilerC-45Inline-getNewArgs e-3 e-11))))(else (cons e-2 (CompilerC-45Inline-getNewArgs e-3 e-11)))))))))))
(define CompilerC-45Inline-mkBounds (lambda (arg-0) (if (null? arg-0) (vector 0 ) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (vector 1 e-2 e-2 (CompilerC-45Inline-mkBounds e-3)))))))
(define CompilerC-45Inline-case--mergeLambdas-6028 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--expNs (CoreC-45CompileExpr-substs e-2 arg-1 e-6 e-10 e-11))) (let ((u--newArgs (PreludeC-45TypesC-45List-reverse (CompilerC-45Inline-getNewArgs e-2 e-10)))) (let ((u--expLocs (CoreC-45CompileExpr-mkLocals (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-1) (CompilerC-45Inline-mkBounds u--newArgs) u--expNs))) (cons (PreludeC-45TypesC-45List-tailRecAppend arg-1 (PreludeC-45TypesC-45List-tailRecAppend u--newArgs '())) u--expLocs))))))))))))
(define CompilerC-45Inline-mergeLambdas (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (CompilerC-45Inline-case--mergeLambdas-6028 e-2 arg-0 e-3 e-1 (CompilerC-45Inline-getLams '() 0 0 '() (vector 2 e-1 e-2 e-3)))))))(else (cons arg-0 arg-1)))))
(define CompilerC-45Inline-mergeLam (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((sc1 (CompilerC-45Inline-mergeLambdas e-0 e-1))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (vector 1 (vector 0 e-2 e-3))))))))(else (vector 1 arg-1))))))
(define CompilerC-45Inline-case--caseC-32blockC-32inC-32mergeLamDef-6817 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (let ((sc3 (DataC-45List-isNil (let ((e-22 (vector-ref e-5 22))) e-22)))) (cond ((equal? sc3 1) 0) (else (let ((e-6 (vector-ref e-0 2))) e-6)))))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 (vector 0 )))) (else (lambda (clam-0) (let ((e-19 (vector-ref arg-3 19))) (if (null? e-19) (vector 1 (vector 0 )) (let ((e-29 (unbox e-19))) (let ((act-2 ((CompilerC-45Inline-mergeLam arg-1 e-29) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-30 (vector-ref act-2 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Context-setCompiled arg-1 arg-0 e-30 eta-0)))) eff-0) clam-0)))))))))))))) eff-0) ext-0)))))))(else (vector 1 (vector 0 ))))))
(define CompilerC-45Inline-mergeLamDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (lambda (eta-1) (CompilerC-45Inline-case--caseC-32blockC-32inC-32mergeLamDef-6817 arg-1 arg-0 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Common-natHackNames (cons (vector 1 (vector 0 "prim__sub_Integer")) (cons csegen-31 (cons csegen-32 '()))))
(define CompilerC-45Common-nonErased (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 1) (let ((e-1 (unbox e-6))) (vector 1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-7 (vector-ref e-1 7))) e-7) csegen-30))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addEntry (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (or (and (= (let ((e-5 (vector-ref arg-2 5))) e-5) 0) 1) 0))) (cond ((equal? sc0 1) (let ((act-1 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((u--a (let ((e-4 (vector-ref e-3 4))) e-4))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox u--a))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 e-6 e-2 arg-1) eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (cons e-2 e-3)))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))) (else (let ((act-1 ((CoreC-45Context-getPosition arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-2 (let ((e-0 (vector-ref e-3 0))) (let ((e-1 (vector-ref e-3 1))) (let ((e-14 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((e-4 (vector-ref e-3 4))) (let ((e-12 (vector-ref e-3 5))) (let ((e-6 (vector-ref e-3 6))) (let ((e-7 (vector-ref e-3 7))) (let ((e-8 (vector-ref e-3 8))) (let ((e-9 (vector-ref e-3 9))) (let ((e-10 (vector-ref e-3 10))) (let ((e-11 (vector-ref e-3 11))) (vector e-0 e-1 e-14 e-13 e-4 e-12 (LibrariesC-45DataC-45IntMap-insert e-2 arg-1 e-6) e-7 e-8 e-9 e-10 e-11)))))))))))))))))))) eff-0) ext-0))))))))))
(define CoreC-45Context-addContextEntry (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-addEntry arg-2 (vector 0 arg-1 arg-3) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 (let ((act-3 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-36 (vector-ref e-5 2))) (let ((e-35 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-34 (vector-ref e-5 5))) (let ((e-33 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-3 e-1 e-36 e-35 e-4 e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Common-replaceEntry (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (lambda (clam-0) (if (null? e-3) (vector 1 (vector 0 )) (let ((e-6 (unbox e-3))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45Context-addContextEntry arg-0 e-9 (vector 8 e-2) e-10 eta-0)) clam-0))))))))))
(define CompilerC-45ANF-nextVar (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) ext-0)))))))
(define CompilerC-45ANF-bindArgs (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 2))) (let ((act-1 ((CompilerC-45ANF-bindArgs arg-0 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (cons e-5 '()) e-6))))) eff-0) clam-0))))))) ((11) (let ((act-1 ((CompilerC-45ANF-bindArgs arg-0 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (cons '() '()) e-5))))) eff-0) clam-0))))))(else (let ((act-1 (CompilerC-45ANF-nextVar arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45ANF-bindArgs arg-0 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons (box e-5) (box e-2)) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define CompilerC-45ANF-n--9440-3477-u--doBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (arg-0 (PreludeC-45TypesC-45List-reverse arg-4)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (if (null? e-6) (CompilerC-45ANF-n--9440-3477-u--doBind arg-0 arg-1 arg-2 arg-3 (cons e-6 arg-4) e-3) (let ((e-8 (unbox e-6))) (if (null? e-7) (CompilerC-45ANF-n--9440-3477-u--doBind arg-0 arg-1 arg-2 arg-3 (cons e-6 arg-4) e-3) (let ((e-10 (unbox e-7))) (vector 4 arg-2 e-8 e-10 (CompilerC-45ANF-n--9440-3477-u--doBind arg-0 arg-1 arg-2 arg-3 (cons (box e-8) arg-4) e-3)))))))))))))
(define CompilerC-45ANF-letBind (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CompilerC-45ANF-bindArgs arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CompilerC-45ANF-n--9440-3477-u--doBind arg-3 arg-2 arg-1 arg-0 '() e-5))))) eff-0) ext-0)))))))
(define CompilerC-45ANF-anfArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ANF-anf arg-0 arg-1 arg-3 eta-0)) arg-4 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CompilerC-45ANF-letBind arg-1 arg-2 e-5 arg-5 eta-0)))) eff-0) ext-0)))))))
(define CompilerC-45ANF-n--9595-3971-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 ext-0) (if (null? arg-9) (vector 1 (cons '() arg-10)) (let ((e-3 (cdr arg-9))) (let ((act-1 (CompilerC-45ANF-nextVar arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45ANF-n--9595-3971-u--bindArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (cons e-5 e-7) (cons e-5 e-4)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CompilerC-45ANF-anfConAlt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-1 (CompilerC-45ANF-n--9595-3971-u--bindArgs arg-0 e-4 e-5 e-3 e-2 e-1 arg-2 arg-1 e-4 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((act-2 ((CompilerC-45ANF-anf (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-1 e-7 e-5) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-8 e-9))))) eff-0) clam-1)))))))))) eff-0) ext-0))))))))))))
(define CompilerC-45ANF-anfConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((act-1 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-1 e-5))))) eff-0) ext-0)))))))))
(define CompilerC-45ANF-lookup (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-3 (car arg-4))) e-3))(else (let ((e-0 (- arg-2 1))) (let ((e-8 (cdr arg-4))) (CompilerC-45ANF-lookup e-0 e-8)))))))
(define CompilerC-45ANF-mlet (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (vector 1 (arg-3 e-1))))(else (let ((act-1 (CompilerC-45ANF-nextVar arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 arg-1 e-5 arg-2 (arg-3 (box e-5))))))) eff-0) ext-0)))))))))
(define CompilerC-45ANF-anf (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (vector 1 (vector 0 e-3 (box (CompilerC-45ANF-lookup e-2 arg-2))))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-6 arg-2 e-9 (lambda (eta-0) (vector 1 e-6 e-7 e-8 eta-0)) clam-0)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-11 arg-2 e-14 (lambda (eta-0) (vector 2 e-11 e-12 e-13 eta-0)) clam-0)))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-16 arg-2 (cons e-18 (cons e-19 '())) (lambda (lcase-0) (if (null? lcase-0) (vector 12 e-16 "Can't happen (AApp)") (let ((e-1 (car lcase-0))) (let ((e-2 (cdr lcase-0))) (if (null? e-2) (vector 12 e-16 "Can't happen (AApp)") (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 3 e-16 e-17 e-1 e-4) (vector 12 e-16 "Can't happen (AApp)"))))))))) clam-0)))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (let ((act-1 (CompilerC-45ANF-nextVar arg-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--vsC-39 (cons e-5 arg-2))) (lambda (eta-0) (let ((act-2 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-23) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45ANF-anf (cons e-22 arg-0) arg-1 u--vsC-39 e-24) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-21 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) clam-0)))))))))) ((5) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((e-29 (vector-ref arg-3 4))) (let ((e-30 (vector-ref arg-3 5))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-26 arg-2 e-30 (lambda (eta-0) (vector 5 e-26 e-27 e-28 e-29 eta-0)) clam-0))))))) ((6) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (let ((e-35 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ANF-anf arg-0 arg-1 arg-2 eta-0)) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-36) '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CompilerC-45ANF-letBind arg-1 e-33 e-5 (lambda (u--args) (let ((sc2 (DataC-45Vect-toVect e-32 u--args))) (if (null? sc2) (vector 12 e-33 "Can't happen (AOp)") (let ((e-2 (unbox sc2))) (vector 6 e-33 e-34 e-35 e-2))))) eta-0)))) eff-0) clam-0))))))))))) ((7) (let ((e-38 (vector-ref arg-3 1))) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (let ((e-41 (vector-ref arg-3 4))) (CompilerC-45ANF-anfArgs arg-0 arg-1 e-38 arg-2 e-41 (lambda (eta-0) (vector 7 e-38 e-39 e-40 eta-0)) clam-0)))))) ((8) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (let ((e-45 (vector-ref arg-3 3))) (let ((e-46 (vector-ref arg-3 4))) (let ((act-1 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-44) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ANF-anfConAlt arg-0 arg-1 arg-2 eta-1 eta-2))) e-45 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (if (null? e-46) (vector 1 '()) (let ((e-2 (unbox e-46))) ((let ((eff-0 (CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CompilerC-45ANF-mlet arg-1 e-43 e-5 (lambda (u--x) (vector 8 e-43 u--x e-6 e-7)) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((9) (let ((e-48 (vector-ref arg-3 1))) (let ((e-49 (vector-ref arg-3 2))) (let ((e-50 (vector-ref arg-3 3))) (let ((e-51 (vector-ref arg-3 4))) (let ((act-1 ((CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-49) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ANF-anfConstAlt arg-0 arg-1 arg-2 eta-1 eta-2))) e-50 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (if (null? e-51) (vector 1 '()) (let ((e-2 (unbox e-51))) ((let ((eff-0 (CompilerC-45ANF-anf arg-0 arg-1 arg-2 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CompilerC-45ANF-mlet arg-1 e-48 e-5 (lambda (u--x) (vector 9 e-48 u--x e-6 e-7)) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((10) (let ((e-53 (vector-ref arg-3 1))) (let ((e-54 (vector-ref arg-3 2))) (vector 1 (vector 10 e-53 e-54))))) ((11) (let ((e-56 (vector-ref arg-3 1))) (vector 1 (vector 11 e-56)))) (else (let ((e-58 (vector-ref arg-3 1))) (let ((e-59 (vector-ref arg-3 2))) (vector 1 (vector 12 e-58 e-59)))))))))
(define CompilerC-45ANF-n--10172-4119-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 ext-0) (if (null? arg-5) (vector 1 (cons '() arg-6)) (let ((e-3 (cdr arg-5))) (let ((act-1 (CompilerC-45ANF-nextVar arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45ANF-n--10172-4119-u--bindArgs arg-0 arg-1 arg-2 arg-4 e-3 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (cons e-5 e-7) (cons e-5 e-4)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CompilerC-45ANF-toANF (lambda (arg-0 ext-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.ANF.Next" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45ANF-n--10172-4119-u--bindArgs e-1 e-0 e-2 e-5 e-0 '() eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 (CompilerC-45ANF-n--10172-4119-u--bindArgs e-1 e-0 e-2 e-5 e-1 e-3 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (let ((act-4 ((CompilerC-45ANF-anf (PreludeC-45TypesC-45List-tailRecAppend e-1 e-0) e-5 e-8 e-2) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 (PreludeC-45TypesC-45List-tailRecAppend e-4 (PreludeC-45TypesC-45List-reverse e-9)) e-10))))) eff-0) clam-2)))))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (vector 1 (vector 1 e-3 e-4 e-5)))))) ((2) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (vector 1 (vector 2 e-6 e-7 e-8)))))) (else (let ((e-9 (vector-ref arg-0 1))) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.ANF.Next" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45ANF-anf '() e-5 '() e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define LibrariesC-45DataC-45IOArray-n--3143-1354-u--iter (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-4 arg-5))) (cond ((equal? sc0 1) (let ((e-1 (car arg-2))) (let ((e-5 (vector-ref e-1 0))) (let ((e-7 (vector-ref e-5 1))) ((e-7 'erased) (PreludeC-45TypesC-45List-reverse arg-6)))))) (else (let ((e-1 (car arg-2))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45IOArray-readArray arg-2 arg-3 arg-4)) (lambda (u--el) (LibrariesC-45DataC-45IOArray-n--3143-1354-u--iter arg-2 arg-3 (bs+ arg-4 1 63) arg-5 (cons u--el arg-6)))))))))))
(define LibrariesC-45DataC-45IOArray-toList (lambda (arg-2 arg-3) (LibrariesC-45DataC-45IOArray-n--3143-1354-u--iter arg-2 arg-3 0 (LibrariesC-45DataC-45IOArray-max arg-3) '())))
(define CompilerC-45Common-n--12067-1352-u--tag (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-2 0) 0) ((equal? arg-2 1) 1) ((equal? arg-2 2) 2) (else 3))))
(define CompilerC-45Common-u--compare_Ord_UsePhase (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int (CompilerC-45Common-n--12067-1352-u--tag arg-1 arg-0 arg-0) (CompilerC-45Common-n--12067-1352-u--tag arg-1 arg-0 arg-1))))
(define CompilerC-45Common-u--C-62C-61_Ord_UsePhase (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (CompilerC-45Common-u--compare_Ord_UsePhase arg-0 arg-1) 0)))
(define CompilerC-45Common-u--C-62_Ord_UsePhase (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CompilerC-45Common-u--compare_Ord_UsePhase arg-0 arg-1) 2)))
(define CompilerC-45Common-u--max_Ord_UsePhase (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45Common-u--C-62_Ord_UsePhase arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define CompilerC-45ANF-u--show_Show_ANFDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 e-0) (string-append ": " (CompilerC-45ANF-u--show_Show_ANF e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (string-append "Constructor tag " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-2) (string-append " arity " (string-append (PreludeC-45Show-u--show_Show_Nat e-3) (string-append " newtype by " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-895 e-4)))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (string-append "Foreign call " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-5) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1242) e-6) (string-append " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-7)))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (string-append "Error: " (CompilerC-45ANF-u--show_Show_ANF e-8)))))))
(define CompilerC-45ANF-u--showPrec_Show_ANFDef (lambda (arg-0 arg-1) (CompilerC-45ANF-u--show_Show_ANFDef arg-1)))
(define CompilerC-45LambdaLift-showLazy (lambda (ext-0) (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-1871) ext-0)))
(define CompilerC-45LambdaLift-u--showPrec_Show_C-40LiftedC-32C-36vsC-41 (lambda (arg-0 arg-1 arg-2) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 arg-2)))
(define CompilerC-45LambdaLift-u--show_Show_C-40LiftedConAltC-32C-36vsC-41 (lambda (arg-0 arg-1) (let ((e-1 (vector-ref arg-1 0))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (string-append "%conalt " (string-append (CoreC-45Name-u--show_Show_Name e-1) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-4)) (string-append ") => " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) e-5)))))))))))
(define CompilerC-45LambdaLift-u--show_Show_C-40LiftedConstAltC-32C-36vsC-41 (lambda (arg-0 arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (string-append "%constalt(" (string-append (CoreC-45TTC-45Primitive-u--show_Show_Constant e-1) (string-append ") => " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-2))))))))
(define CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (string-append "!" (CoreC-45Name-u--show_Show_Name (CoreC-45TTC-45Var-nameAt arg-0 e-2))))) ((1) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (string-append (CoreC-45Name-u--show_Show_Name e-8) (string-append (CompilerC-45LambdaLift-showLazy e-7) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-9)) ")")))))))) ((2) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (string-append "<" (string-append (CoreC-45Name-u--show_Show_Name e-12) (string-append " underapp " (string-append (PreludeC-45Show-u--show_Show_Nat e-13) (string-append ">(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-14)) ")")))))))))) ((3) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (string-append (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-18) (string-append (CompilerC-45LambdaLift-showLazy e-17) (string-append " @ (" (string-append (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-19) ")")))))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (let ((e-23 (vector-ref arg-1 3))) (let ((e-24 (vector-ref arg-1 4))) (string-append "%let " (string-append (CoreC-45Name-u--show_Show_Name e-22) (string-append " = " (string-append (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-23) (string-append " in " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (cons e-22 arg-0) e-24)))))))))) ((5) (let ((e-27 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 5))) (string-append "%con " (string-append (CoreC-45Name-u--show_Show_Name e-27) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-30)) ")"))))))) ((6) (let ((e-34 (vector-ref arg-1 3))) (let ((e-35 (vector-ref arg-1 4))) (let ((e-36 (vector-ref arg-1 5))) (string-append "%op " (string-append (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 e-35) (string-append (CompilerC-45LambdaLift-showLazy e-34) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-36))) ")"))))))))) ((7) (let ((e-39 (vector-ref arg-1 2))) (let ((e-40 (vector-ref arg-1 3))) (let ((e-41 (vector-ref arg-1 4))) (string-append "%extprim " (string-append (CoreC-45Name-u--show_Show_Name e-40) (string-append (CompilerC-45LambdaLift-showLazy e-39) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 eta-0)) e-41)) ")"))))))))) ((8) (let ((e-44 (vector-ref arg-1 2))) (let ((e-45 (vector-ref arg-1 3))) (let ((e-46 (vector-ref arg-1 4))) (string-append "%case " (string-append (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-44) (string-append " of { " (string-append (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedConAltC-32C-36vsC-41 arg-0 eta-0)) e-45)) (string-append " " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45LambdaLift-u--showPrec_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--d u--x)))) e-46)))))))))) ((9) (let ((e-49 (vector-ref arg-1 2))) (let ((e-50 (vector-ref arg-1 3))) (let ((e-51 (vector-ref arg-1 4))) (string-append "%case " (string-append (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 e-49) (string-append " of { " (string-append (CoreC-45NameC-45Namespace-showSep "| " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedConstAltC-32C-36vsC-41 arg-0 eta-0)) e-50)) (string-append " " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45LambdaLift-u--showPrec_Show_C-40LiftedC-32C-36vsC-41 arg-0 u--d u--x)))) e-51)))))))))) ((10) (let ((e-54 (vector-ref arg-1 2))) (CoreC-45TTC-45Primitive-u--show_Show_Constant e-54))) ((11) "___") (else (let ((e-59 (vector-ref arg-1 2))) (string-append "%CRASH(" (string-append (PreludeC-45Show-u--show_Show_String e-59) ")")))))))
(define CompilerC-45LambdaLift-u--show_Show_LiftedDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-0) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (PreludeC-45TypesC-45List-reverse e-1)) (string-append ": " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 (PreludeC-45TypesC-45List-tailRecAppend e-1 e-0) e-2)))))))) ((1) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 3))) (string-append "Constructor tag " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-3) (string-append " arity " (string-append (PreludeC-45Show-u--show_Show_Nat e-4) (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-1240) e-5))))))))) ((2) (let ((e-6 (vector-ref arg-0 1))) (let ((e-7 (vector-ref arg-0 2))) (let ((e-8 (vector-ref arg-0 3))) (string-append "Foreign call " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-6) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1242) e-7) (string-append " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-8)))))))))) (else (let ((e-9 (vector-ref arg-0 1))) (string-append "Error: " (CompilerC-45LambdaLift-u--show_Show_C-40LiftedC-32C-36vsC-41 '() e-9)))))))
(define CompilerC-45LambdaLift-u--showPrec_Show_LiftedDef (lambda (arg-0 arg-1) (CompilerC-45LambdaLift-u--show_Show_LiftedDef arg-1)))
(define CoreC-45CompileExpr-u--show_Show_NamedDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-0) (string-append ": " (CoreC-45CompileExpr-u--show_Show_NamedCExp e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (string-append "Constructor tag " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-2) (string-append " arity " (string-append (PreludeC-45Show-u--show_Show_Nat e-3) (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-1240) e-4))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (string-append "Foreign call " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-5) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1242) e-6) (string-append " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-7)))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (string-append "Error: " (CoreC-45CompileExpr-u--show_Show_NamedCExp e-8)))))))
(define CoreC-45CompileExpr-u--showPrec_Show_NamedDef (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_NamedDef arg-1)))
(define CompilerC-45VMCode-u--show_Show_VMDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 e-0) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1851) e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (string-append "Foreign call " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-2) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1242) e-3) (string-append " " (CoreC-45CompileExpr-u--show_Show_CFType e-4)))))))))) (else (let ((e-5 (vector-ref arg-0 1))) (string-append "Error: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1851) e-5)))))))
(define CompilerC-45VMCode-u--showPrec_Show_VMDef (lambda (arg-0 arg-1) (CompilerC-45VMCode-u--show_Show_VMDef arg-1)))
(define CompilerC-45Common-n--13415-2463-u--lookupBackend (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (let ((sc2 (DataC-45List-find (lambda (lamc-0) (let ((e-5 (car lamc-0))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 e-5))) e-7))) (if (null? sc2) (CompilerC-45Common-n--13415-2463-u--lookupBackend arg-0 arg-1 arg-2 arg-3 arg-4 e-3 (cons e-6 e-7)) (let ((e-1 (unbox sc2))) (let ((e-8 (cdr e-1))) (box (cons e-6 e-8)))))))))))))
(define CompilerC-45Common-n--13415-2462-u--getExports (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-5 e-3))))) eff-0) clam-0))))))))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45Common-n--13415-2463-u--lookupBackend arg-0 arg-1 arg-2 arg-3 arg-4 arg-3 eta-0)) (LibrariesC-45DataC-45NameMap-toList (let ((e-31 (vector-ref arg-5 31))) e-31))) '())))
(define CompilerC-45Common-getCompileDataWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 10 (lambda () (string-append "Getting compiled data for: " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-4))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--phase (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (PreludeC-45Types-maybe (lambda () (lambda (eta-3) eta-3)) (lambda () (lambda (eta-3) (lambda (eta-4) (CompilerC-45Common-u--max_Ord_UsePhase eta-3 eta-4)))) eta-2)) eta-0 eta-1))) arg-3 (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) 0) (let ((e-12 (vector-ref e-6 12))) e-12)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) 1) (let ((e-13 (vector-ref e-6 13))) e-13)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) 2) (let ((e-14 (vector-ref e-6 14))) e-14)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) 3) (let ((e-15 (vector-ref e-6 15))) e-15)) '()))))))) (let ((u--metas (CoreC-45TT-addMetas 1 LibrariesC-45DataC-45NameMap-empty arg-4))) (lambda (eta-0) (let ((act-3 ((PreludeC-45Basics-flip csegen-63 (LibrariesC-45DataC-45NameMap-keys u--metas) (lambda (u--metanm) (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-lookupCtxtExact u--metanm (let ((e-0 (vector-ref e-7 0))) e-0)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-3) (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 50 (lambda () (DataC-45String-unwords (cons "Couldn't find" (cons (CoreC-45Name-u--show_Show_Name u--metanm) (cons "(probably impossible)" '()))))) eta-3)) (let ((e-1 (unbox e-8))) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((7) (let ((u--fulln (let ((e-51 (vector-ref e-1 1))) e-51))) (let ((u--cexp (vector 3 (vector 14 CoreC-45FC-emptyFC (string-append "Encountered unimplemented hole " (CoreC-45Name-u--show_Show_Name u--fulln)))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-4) (CoreC-45Context-addDef arg-0 u--metanm (let ((e-52 (vector-ref e-1 0))) (let ((e-51 (vector-ref e-1 1))) (let ((e-50 (vector-ref e-1 2))) (let ((e-49 (vector-ref e-1 3))) (let ((e-48 (vector-ref e-1 4))) (let ((e-47 (vector-ref e-1 5))) (let ((e-46 (vector-ref e-1 6))) (let ((e-45 (vector-ref e-1 7))) (let ((e-44 (vector-ref e-1 8))) (let ((e-43 (vector-ref e-1 9))) (let ((e-42 (vector-ref e-1 10))) (let ((e-41 (vector-ref e-1 11))) (let ((e-40 (vector-ref e-1 12))) (let ((e-39 (vector-ref e-1 13))) (let ((e-38 (vector-ref e-1 14))) (let ((e-37 (vector-ref e-1 15))) (let ((e-36 (vector-ref e-1 16))) (let ((e-35 (vector-ref e-1 17))) (let ((e-34 (vector-ref e-1 18))) (let ((e-31 (vector-ref e-1 21))) (let ((e-30 (vector-ref e-1 22))) (vector e-52 e-51 e-50 e-49 e-48 e-47 e-46 e-45 e-44 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 (box u--cexp) (box (CoreC-45CompileExpr-forgetDef u--cexp)) e-31 e-30)))))))))))))))))))))) eta-4)) eta-3)))))(else (lambda (eta-3) (vector 1 (vector 0 )))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--refs (CoreC-45TT-getRefs (vector 8 -1) arg-4))) (lambda (eta-1) (let ((act-5 (let ((sc4 (DataC-45List-isNil arg-1))) (cond ((equal? sc4 1) (vector 1 '())) (else ((CompilerC-45Common-n--13415-2462-u--getExports arg-4 arg-3 arg-2 arg-1 arg-0 e-8) eta-1)))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "compile.export" 25 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "exporting: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) e-9)) '())))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((u--ns (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45NameMap-keys (LibrariesC-45DataC-45NameMap-mergeWith (lambda (eta-3) (lambda (eta-4) eta-3)) u--metas u--refs)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) e-9)))) (let ((act-7 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 70 (lambda () (string-append "Found names: " (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (DataC-45List-intersperse ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (CoreC-45Name-u--show_Show_Name eta-3)) u--ns))))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45Context-toFullNames arg-0 csegen-68 arg-4 eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (CoreC-45Context-toResolvedNames arg-0 csegen-54 eta-4 eta-5))) CompilerC-45Common-natHackNames '()) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-10 (CoreC-45Context-getNextEntry arg-0 eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-11 (let ((act-11 ((LibrariesC-45DataC-45IOArray-newArray csegen-82 e-14) eta-5))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-12 (let ((act-12 (unbox arg-0))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-13 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Get names") (CompilerC-45Common-getAllDesc arg-0 (PreludeC-45TypesC-45List-tailRecAppend e-13 u--ns) e-15 e-16) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 (let ((act-14 ((LibrariesC-45DataC-45IOArray-toList csegen-82 e-15) eta-7))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (let ((u--entries (DataC-45List-catMaybes e-18))) (let ((u--allNs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-8) (vector 8 (Builtin-fst eta-8))) u--entries))) (lambda (eta-8) (let ((act-15 ((CoreC-45Core-traverseC-39 (lambda (eta-9) (lambda (eta-10) (CoreC-45Context-toFullNames arg-0 csegen-54 eta-9 eta-10))) u--allNs '()) eta-8))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-16 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 30 (lambda () (string-append "All names: " (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-10) eta-10) (DataC-45List-intersperse ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-10) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-84 eta-10)) (DataC-45List-u--zip_Zippable_List u--allNs e-19)))))) eta-9))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((act-17 ((CoreC-45Core-filterM (lambda (eta-10) (lambda (eta-11) (CompilerC-45Common-nonErased arg-0 eta-10 eta-11))) e-19) eta-9))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-18 (CoreC-45ContextC-45Log-log arg-0 "compile.execute" 40 (lambda () (string-append "Kept: " (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-11) eta-11) (DataC-45List-intersperse ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-11) (CoreC-45Name-u--show_Show_Name eta-11)) e-21))))) eta-10))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((act-19 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Merge lambda") (CoreC-45Core-traverse_ (lambda (eta-11) (lambda (eta-12) (CompilerC-45Inline-mergeLamDef arg-0 eta-11 eta-12))) e-21) eta-10))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((act-20 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Fix arity") (CoreC-45Core-traverse_ (lambda (eta-11) (lambda (eta-12) (CompilerC-45Inline-fixArityDef arg-0 eta-11 eta-12))) e-21) eta-10))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((act-21 (let ((act-21 (CompilerC-45CompileExpr-compileExp arg-0 e-12 eta-10))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (CompilerC-45Inline-fixArityExp '() arg-0 e-25))) eff-0) eta-10))))))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-22 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "CSE") (lambda (eta-12) (CompilerC-45OptsC-45CSE-cse arg-0 e-21 e-25 eta-12)) eta-11))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((e-26 (vector-ref act-22 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-26))) (let ((e-3 (cdr e-26))) (let ((act-23 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Forget names") (CoreC-45Core-traverseC-39 (lambda (eta-12) (CompilerC-45Common-getNamedDef arg-0 eta-12)) e-2 '()) clam-0))) (case (vector-ref act-23 0) ((0) (let ((e-4 (vector-ref act-23 1))) (vector 0 e-4))) (else (let ((e-27 (vector-ref act-23 1))) ((let ((eff-0 (let ((u--mainname (vector 2 "__mainExpression" 0))) (lambda (eta-12) (let ((act-24 (CompilerC-45LambdaLift-liftBody '() arg-2 u--mainname e-3 eta-12))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((e-28 (vector-ref act-24 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-29 (car e-28))) (let ((e-4 (cdr e-28))) (let ((act-25 (let ((sc26 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase u--phase 1))) (cond ((equal? sc26 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Lambda lift") (CoreC-45Core-traverseC-39 (lambda (eta-13) (CompilerC-45LambdaLift-lambdaLift arg-0 arg-2 eta-13)) e-2 '()) clam-1)) (else (vector 1 '())))))) (case (vector-ref act-25 0) ((0) (let ((e-30 (vector-ref act-25 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-25 1))) ((let ((eff-0 (let ((u--lifted (cons (cons u--mainname (vector 0 '() '() e-29)) (PreludeC-45TypesC-45List-tailRecAppend e-4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-13) eta-13) e-30))))) (lambda (eta-13) (let ((act-26 (let ((sc27 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase u--phase 2))) (cond ((equal? sc27 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Get ANF") (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-2) (let ((e-32 (car lamc-0))) (let ((e-31 (cdr lamc-0))) (let ((act-26 (CompilerC-45ANF-toANF e-31 clam-2))) (case (vector-ref act-26 0) ((0) (let ((e-33 (vector-ref act-26 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-26 1))) ((let ((eff-0 (lambda (eta-14) (vector 1 (cons e-32 e-33))))) eff-0) clam-2))))))))) u--lifted '()) eta-13)) (else (vector 1 '())))))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-26 1))) ((let ((eff-0 (lambda (eta-14) (let ((act-27 (let ((sc28 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase u--phase 3))) (cond ((equal? sc28 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Get VM Code") (lambda (eta-15) (vector 1 (CompilerC-45VMCode-allDefs e-31))) eta-14)) (else (vector 1 '())))))) (case (vector-ref act-27 0) ((0) (let ((e-32 (vector-ref act-27 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-27 1))) ((let ((eff-0 (lambda (eta-15) (let ((act-28 (let ((act-28 (unbox arg-0))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-33 (vector-ref act-28 1))) (vector 0 e-33))) (else ((let ((eff-0 (lambda (eta-16) (let ((act-29 (let ((e-46 (vector-ref e-6 12))) (if (null? e-46) (vector 1 (vector 0 )) (let ((e-57 (unbox e-46))) (let ((act-29 (let ((act-29 (PreludeC-45IO-prim__putStr (string-append (string-append "Dumping case trees to " e-57) "\xa;") eta-16))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-58 (vector-ref act-29 1))) (vector 0 e-58))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_NamedDef u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_NamedDef u--d u--x)))) e-57 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-60 (car lamc-0))) (let ((e-59 (cdr lamc-0))) (let ((e-61 (cdr e-59))) (cons e-60 e-61))))) e-27)) eta-16))))))))) (case (vector-ref act-29 0) ((0) (let ((e-34 (vector-ref act-29 1))) (vector 0 e-34))) (else (let ((act-30 (let ((e-46 (vector-ref e-6 13))) (if (null? e-46) (vector 1 (vector 0 )) (let ((e-58 (unbox e-46))) (let ((act-30 (let ((act-30 (PreludeC-45IO-prim__putStr (string-append (string-append "Dumping lambda lifted defs to " e-58) "\xa;") eta-16))) (vector 1 act-30)))) (case (vector-ref act-30 0) ((0) (let ((e-59 (vector-ref act-30 1))) (vector 0 e-59))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CompilerC-45LambdaLift-u--show_Show_LiftedDef u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45LambdaLift-u--showPrec_Show_LiftedDef u--d u--x)))) e-58 u--lifted) eta-16))))))))) (case (vector-ref act-30 0) ((0) (let ((e-35 (vector-ref act-30 1))) (vector 0 e-35))) (else (let ((act-31 (let ((e-46 (vector-ref e-6 14))) (if (null? e-46) (vector 1 (vector 0 )) (let ((e-59 (unbox e-46))) (let ((act-31 (let ((act-31 (PreludeC-45IO-prim__putStr (string-append (string-append "Dumping ANF defs to " e-59) "\xa;") eta-16))) (vector 1 act-31)))) (case (vector-ref act-31 0) ((0) (let ((e-60 (vector-ref act-31 1))) (vector 0 e-60))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CompilerC-45ANF-u--show_Show_ANFDef u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45ANF-u--showPrec_Show_ANFDef u--d u--x)))) e-59 e-31) eta-16))))))))) (case (vector-ref act-31 0) ((0) (let ((e-36 (vector-ref act-31 1))) (vector 0 e-36))) (else (let ((act-32 (let ((e-46 (vector-ref e-6 15))) (if (null? e-46) (vector 1 (vector 0 )) (let ((e-60 (unbox e-46))) (let ((act-32 (let ((act-32 (PreludeC-45IO-prim__putStr (string-append (string-append "Dumping VM defs to " e-60) "\xa;") eta-16))) (vector 1 act-32)))) (case (vector-ref act-32 0) ((0) (let ((e-61 (vector-ref act-32 1))) (vector 0 e-61))) (else ((CompilerC-45Common-dumpIR (cons (lambda (u--x) (CompilerC-45VMCode-u--show_Show_VMDef u--x)) (lambda (u--d) (lambda (u--x) (CompilerC-45VMCode-u--showPrec_Show_VMDef u--d u--x)))) e-60 e-32) eta-16))))))))) (case (vector-ref act-32 0) ((0) (let ((e-37 (vector-ref act-32 1))) (vector 0 e-37))) (else (let ((act-33 ((CoreC-45Core-traverse_ (lambda (eta-17) (CompilerC-45Common-replaceEntry arg-0 eta-17)) u--entries) eta-16))) (case (vector-ref act-33 0) ((0) (let ((e-38 (vector-ref act-33 1))) (vector 0 e-38))) (else (vector 1 (vector e-3 e-9 e-27 u--lifted e-31 e-32)))))))))))))))))))) eff-0) eta-15))))))) eff-0) eta-14)))))))) eff-0) eta-13))))))))) eff-0) clam-1)))))))))) eff-0) eta-12))))))))) eff-0) clam-0)))))))))) eff-0) eta-11)))))))) eff-0) eta-10))))))))))))))))) eff-0) eta-9))))))))))) eff-0) eta-8)))))))))) eff-0) eta-7))))))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))))) eff-0) ext-0))))))))))
(define CompilerC-45Common-getCompileData (lambda (arg-0 ext-3 ext-1 ext-2 ext-0) (CompilerC-45Common-getCompileDataWith arg-0 '() ext-3 ext-1 ext-2 ext-0)))
(define CoreC-45Context-n--29545-24554-u--getDir (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45Options-u--C-61C-61_Eq_CG arg-0 e-2))) (cond ((equal? sc1 1) (box e-3)) (else '())))))))
(define CoreC-45Context-getDirectives (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 2))) (let ((e-63 (vector-ref e-41 5))) e-63))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) (CoreC-45Context-n--29545-24554-u--getDir arg-1 arg-0 eta-1)) (let ((e-20 (vector-ref e-5 20))) e-20))))))) eff-0) ext-0)))))))
(define CoreC-45Core-readFile (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-0) world-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (vector 1 e-2))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-0 e-6) clam-0))))))) eff-1) world-0)))))))))
(define CompilerC-45Common-case--getExtraRuntimeC-44getArg-5445 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (DataC-45String-trim e-2) "extraRuntime"))) (cond ((equal? sc1 1) (box (DataC-45String-trim (PreludeC-45Types-substr 1 (PreludeC-45TypesC-45String-length e-3) e-3)))) (else '())))))))
(define CompilerC-45Common-n--16767-5425-u--getArg (lambda (arg-0 arg-1) (CompilerC-45Common-case--getExtraRuntimeC-44getArg-5445 arg-0 arg-1 (DataC-45String-break (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 #\=)) arg-1))))
(define CompilerC-45Common-n--16767-5426-u--paths (lambda (arg-0) (DataC-45List-nub csegen-22 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45Common-n--16767-5425-u--getArg arg-0 eta-0)) (PreludeC-45TypesC-45List-reverse arg-0)))))
(define CompilerC-45Common-getExtraRuntime (lambda (arg-0 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-readFile eta-0)) (CompilerC-45Common-n--16767-5426-u--paths arg-0) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (DataC-45List-intersperse "\xa;" e-5)))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-mkArgs (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((18) (cons (cons (vector 2 "farg" arg-0) 0) (CompilerC-45SchemeC-45Chez-mkArgs arg-0 e-3)))(else (cons (cons (vector 2 "farg" arg-0) 1) (CompilerC-45SchemeC-45Chez-mkArgs (bs+ arg-0 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Chez-cftySpec (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) csegen-4920) ((1) csegen-4922) ((3) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "integer-8" u--xs))))) ((4) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "integer-16" eta-1))))) ((5) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "integer-32" eta-1))))) ((6) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "integer-64" eta-1))))) ((7) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-8" eta-1))))) ((8) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-16" eta-1))))) ((9) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-32" eta-1))))) ((10) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-64" eta-1))))) ((11) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "string" u--xs))))) ((12) csegen-4940) ((13) csegen-4924) ((14) csegen-5135) ((15) csegen-5135) ((16) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "u8*" u--xs))))) ((19) csegen-5135) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Chez-cftySpec arg-0 e-2))) ((21) (let ((e-3 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(* " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons e-3 eta-3)) (lambda (eta-3) (cons ")" eta-3)) eta-2)) eta-1))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Can't pass argument of type " (string-append (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Chez-n--14452-3354-u--showFld (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CompilerC-45SchemeC-45Chez-cftySpec CoreC-45FC-emptyFC e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "[" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons e-2 eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons "]" u--xs)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) ext-0)))))))))
(define CompilerC-45SchemeC-45Chez-mkStruct (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((21) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-mkStruct arg-0 eta-1)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-1) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-22 e-0 e-6))) (cond ((equal? sc3 1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-2) eta-2) e-5))) (else (let ((act-3 (let ((act-3 (set-box! arg-0 (cons e-0 e-6)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-n--14452-3354-u--showFld e-1 e-0 arg-0 eta-2 eta-3))) e-1 '()) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-4) eta-4) e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "(define-ftype " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-0 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " (struct\xa;\x9;" eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy "\xa;\x9;" e-8) (lambda (u--xs) (cons "))\xa;" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) clam-0)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Chez-mkStruct arg-0 e-2))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 csegen-4896 (CompilerC-45SchemeC-45Chez-mkStruct arg-0 e-3) eta-1)) (CompilerC-45SchemeC-45Chez-mkStruct arg-0 e-4) eta-0)))))(else csegen-4898))))
(define CompilerC-45SchemeC-45Chez-handleRet (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConstructor csegen-5051 (vector 1 (vector 2 )) (box 0) '() eta-2)) eta-1)) eta-0)))(else arg-1))))
(define CompilerC-45SchemeC-45Chez-n--13382-2410-u--applyLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-2) (CompilerC-45SchemeC-45Chez-n--13382-2410-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-8 (lambda (u--xs) (cons " #f)" u--xs)) eta-1)) eta-0)) e-3) (let ((e-6 (unbox e-2))) (CompilerC-45SchemeC-45Chez-n--13382-2410-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-8 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)) e-3))))))))
(define CompilerC-45SchemeC-45Chez-n--13382-2415-u--mkNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((18) (cons '() (CompilerC-45SchemeC-45Chez-n--13382-2415-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))(else (cons (box (lambda (eta-0) (cons (string-append "cb" (PreludeC-45Show-u--show_Show_Int arg-8)) eta-0))) (CompilerC-45SchemeC-45Chez-n--13382-2415-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Chez-n--13382-2414-u--mkFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--argns (CompilerC-45SchemeC-45Chez-n--13382-2415-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 0 arg-8))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(lambda (" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (DataC-45List-catMaybes u--argns)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Chez-n--13382-2410-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 u--argns) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))))
(define CompilerC-45SchemeC-45Chez-n--13382-2416-u--notWorld (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((18) 0)(else 1))))
(define CompilerC-45SchemeC-45Chez-n--13382-2412-u--callback (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((19) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (CompilerC-45SchemeC-45Chez-n--13382-2412-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-0 arg-9) e-1))))(else (let ((u--args (PreludeC-45TypesC-45List-reverse arg-9))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-cftySpec arg-5 eta-1)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (CompilerC-45SchemeC-45Chez-n--13382-2416-u--notWorld arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1)) u--args) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Chez-cftySpec arg-5 arg-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(let ([c-code (foreign-callable #f " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Chez-n--13382-2414-u--mkFun arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--args arg-10 arg-8) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " (" eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-5) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons ") " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons ")])" eta-10)) (lambda (eta-10) (cons " (lock-object c-code) (foreign-callable-entry-point c-code))" eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define CompilerC-45SchemeC-45Chez-n--13382-2411-u--buildArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-3 0) ((19) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (CompilerC-45SchemeC-45Chez-n--13382-2412-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CompilerC-45SchemeC-45Common-schName e-2) (cons e-4 '()) e-5)))) ((15) (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(car " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-2) (lambda (u--xs) (cons ")" u--xs)) eta-2)) eta-1)))))(else (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Common-schName e-2)))))))))
(define CompilerC-45SchemeC-45Chez-cCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-6 0) ((20) (let ((e-0 (vector-ref arg-6 1))) (case (vector-ref e-0 0) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-22 arg-4 e-5))) (cond ((equal? sc2 1) (vector 1 '())) (else (let ((act-2 (let ((act-2 (set-box! arg-1 (cons arg-4 e-5)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (box arg-4)))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Chez-cftySpec arg-2 (Builtin-snd eta-2))) arg-5 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45SchemeC-45Chez-cftySpec arg-2 arg-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--callConv (lambda (clam-1) (cond ((equal? arg-7 1) (cons " __collect_safe" clam-1)) (else (cons "" clam-1)))))) (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CompilerC-45SchemeC-45Chez-n--13382-2411-u--buildArg arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-4)) arg-5 '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--call (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "((foreign-procedure" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--callConv (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-493 arg-3 eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons " (" eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons ") " eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-8 (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-13) (cons ") " eta-13)) (lambda (eta-13) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-9) (lambda (u--xs) (cons ")" u--xs)) eta-13)) eta-12)) eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)))) (lambda (eta-4) (vector 1 (cons e-6 (case (vector-ref arg-6 0) ((20) (CompilerC-45SchemeC-45Chez-handleRet arg-6 u--call))(else u--call)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 arg-4 e-5))) (cond ((equal? sc1 1) (vector 1 '())) (else (let ((act-2 (let ((act-2 (set-box! arg-1 (cons arg-4 e-5)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (box arg-4)))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Chez-cftySpec arg-2 (Builtin-snd eta-2))) arg-5 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45SchemeC-45Chez-cftySpec arg-2 arg-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--callConv (lambda (clam-2) (cond ((equal? arg-7 1) (cons " __collect_safe" clam-2)) (else (cons "" clam-2)))))) (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CompilerC-45SchemeC-45Chez-n--13382-2411-u--buildArg arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-4)) arg-5 '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--call (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "((foreign-procedure" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--callConv (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-493 arg-3 eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons " (" eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-7) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons ") " eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-8 (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-13) (cons ") " eta-13)) (lambda (eta-13) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-9) (lambda (u--xs) (cons ")" u--xs)) eta-13)) eta-12)) eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)))) (lambda (eta-4) (vector 1 (cons e-6 (case (vector-ref arg-6 0) ((20) (CompilerC-45SchemeC-45Chez-handleRet arg-6 u--call))(else u--call)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))
(define CompilerC-45Common-n--16166-4883-u--hasTarget (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (DataC-45String-span csegen-23 arg-4))) (let ((e-2 (car sc0))) (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 arg-3)))))
(define CompilerC-45Common-case--parseCCC-44getOpts-4906 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cond ((equal? e-3 "") (cons e-2 '()))(else (cons e-2 (CompilerC-45Common-n--16166-4882-u--getOpts arg-0 arg-1 arg-2 (substring e-3 1 (string-length e-3))))))))))
(define CompilerC-45Common-n--16166-4882-u--getOpts (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-3 "") '())(else (CompilerC-45Common-case--parseCCC-44getOpts-4906 arg-0 arg-1 arg-2 arg-3 (DataC-45String-span (lambda (arg-4) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-4 #\,)) arg-3))))))
(define CompilerC-45Common-case--caseC-32blockC-32inC-32parseCCC-44findTarget-5035 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (cond ((equal? e-3 "") (box (cons (DataC-45String-trim e-2) '())))(else (box (cons (DataC-45String-trim e-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (DataC-45String-trim eta-0)) (CompilerC-45Common-n--16166-4882-u--getOpts arg-0 arg-1 arg-2 (substring e-3 1 (string-length e-3))))))))))))
(define CompilerC-45Common-n--16166-4881-u--findTarget (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (CompilerC-45Common-n--16166-4883-u--hasTarget arg-0 arg-1 arg-2 arg-3 e-2))) (cond ((equal? sc1 1) (CompilerC-45Common-case--caseC-32blockC-32inC-32parseCCC-44findTarget-5035 arg-0 arg-1 arg-2 e-2 e-3 arg-3 (DataC-45String-span csegen-23 e-2))) (else (CompilerC-45Common-n--16166-4881-u--findTarget arg-0 arg-1 arg-2 arg-3 e-3)))))))))
(define CompilerC-45Common-parseCC (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (CompilerC-45Common-n--16166-4881-u--findTarget e-2 e-3 arg-1 e-2 arg-1) (lambda () (CompilerC-45Common-parseCC e-3 arg-1))))))))
(define CompilerC-45SchemeC-45Chez-schemeCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--call (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons arg-1 eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (CompilerC-45SchemeC-45Common-schName eta-4)) arg-2)) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))) (lambda (clam-0) (case (vector-ref arg-3 0) ((20) (vector 1 u--call))(else (vector 1 u--call)))))))
(define LibrariesC-45DataC-45Version-case--compare-3405 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-4 1) (PreludeC-45Types-u--compare_Ord_C-40MaybeC-32C-36aC-41 csegen-519 arg-0 arg-2))(else arg-4))))
(define LibrariesC-45DataC-45Version-u--compare_Ord_Version (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45Version-case--compare-3405 e-1 e-0 e-3 e-2 (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 (vector (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1032 csegen-1032 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1032 csegen-1032 arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1647 csegen-1647 arg-1626 arg-1629)))) e-0 e-2))))))))
(define LibrariesC-45DataC-45Version-u--C-60_Ord_Version (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (LibrariesC-45DataC-45Version-u--compare_Ord_Version arg-0 arg-1) 0)))
(define CompilerC-45SchemeC-45Chez-unsupportedCallingConvention (lambda (arg-0) (if (null? arg-0) 1 (let ((e-2 (unbox arg-0))) (LibrariesC-45DataC-45Version-u--C-60_Ord_Version e-2 (cons (cons 9 (cons 5 0)) '()))))))
(define CompilerC-45SchemeC-45Chez-useCC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((sc0 (CompilerC-45Common-parseCC (cons "scheme,chez" (cons "scheme" (cons "C__collect_safe" (cons "C" '())))) arg-3))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0)) (let ((e-1 (unbox sc0))) (if (null? e-1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0)) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (cond ((equal? e-4 "scheme,chez") (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) clam-0) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (let ((act-1 ((CompilerC-45SchemeC-45Chez-schemeCall arg-2 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-4) arg-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons '() e-6))))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) clam-0))))))) ((equal? e-4 "scheme") (lambda (clam-1) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) clam-1) (let ((e-11 (car e-5))) (let ((e-12 (cdr e-5))) (if (null? e-12) (let ((act-1 ((CompilerC-45SchemeC-45Chez-schemeCall arg-2 e-11 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-4) arg-5) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons '() e-6))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) clam-1))))))) ((equal? e-4 "C__collect_safe") (if (null? e-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0)) (let ((e-15 (car e-5))) (let ((e-16 (cdr e-5))) (if (null? e-16) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0)) (let ((e-18 (car e-16))) (let ((sc5 (CompilerC-45SchemeC-45Chez-unsupportedCallingConvention arg-6))) (cond ((equal? sc5 1) (CompilerC-45SchemeC-45Chez-cCall arg-0 arg-1 arg-2 e-15 e-18 arg-4 arg-5 0)) (else (CompilerC-45SchemeC-45Chez-cCall arg-0 arg-1 arg-2 e-15 e-18 arg-4 arg-5 1)))))))))) ((equal? e-4 "C") (if (null? e-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0)) (let ((e-21 (car e-5))) (let ((e-22 (cdr e-5))) (if (null? e-22) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0)) (let ((e-24 (car e-22))) (CompilerC-45SchemeC-45Chez-cCall arg-0 arg-1 arg-2 e-21 e-24 arg-4 arg-5 0)))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-2 arg-3) eta-0))))))))))))
(define CompilerC-45SchemeC-45Chez-schFgnDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((u--argns (CompilerC-45SchemeC-45Chez-mkArgs 0 e-1))) (let ((u--allargns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) u--argns))) (let ((u--useargns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (Builtin-snd eta-0)) u--argns)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Chez-mkStruct arg-2 eta-1)) e-1 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Chez-mkStruct arg-2 e-2) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CompilerC-45SchemeC-45Chez-useCC arg-0 arg-1 arg-3 e-0 (DataC-45List-u--zip_Zippable_List u--useargns e-1) e-2 arg-6) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-u--full_HasNames_Name (let ((e-41 (vector-ref e-8 0))) e-41) arg-4 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons e-4 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) eta-6) e-5) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons "(define " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-9) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons " (lambda (" eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-11) (CompilerC-45SchemeC-45Common-schName eta-11)) u--allargns)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-12) (cons ") " eta-12)) (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-3 (lambda (u--xs) (cons "))\xa;" u--xs)) eta-12)) eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5))))))) eff-0) eta-3)))))))) eff-0) clam-0)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))(else csegen-4893))))
(define CompilerC-45SchemeC-45Chez-getFgnCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Chez-schFgnDef arg-0 arg-1 arg-2 e-6 e-2 e-7 arg-3)))))))
(define CompilerC-45SchemeC-45Common-schArglist (lambda (arg-0) (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45SchemeC-45Common-schName eta-0)) arg-0))))
(define CompilerC-45SchemeC-45Common-schDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (lambda (clam-0) (if (null? e-0) (let ((sc2 (LibrariesC-45DataC-45SortedSet-contains arg-4 arg-0))) (cond ((equal? sc2 1) (let ((act-1 (CoreC-45Context-getFullName arg-3 arg-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 0 e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(define " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")\xa;" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (let ((act-1 (CoreC-45Context-getFullName arg-3 arg-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 0 e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(define " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " (lambda () " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons "))\xa;" u--xs)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) (let ((act-1 (CoreC-45Context-getFullName arg-3 arg-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 0 e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(define " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " (lambda (" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schArglist e-0) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ") " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons "))\xa;" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((3) (let ((e-2 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-3 arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 arg-1 arg-2 0 e-2) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(define (" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-5) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " . any-args) " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")\xa;" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((2) csegen-4898) (else csegen-4898))))
(define CompilerC-45SchemeC-45Common-getScheme (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Common-schDef arg-1 arg-2 arg-3 arg-0 e-2 e-7))))))
(define CompilerC-45SchemeC-45Chez-locateLib (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CompilerC-45Common-locate arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CompilerC-45Common-copyLib (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 e-2) e-3)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))) eff-0) ext-0)))))))
(define CoreC-45Directory-findDataFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--p) (CoreC-45Directory-cleanPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p arg-1))) (let ((e-9 (vector-ref e-5 9))) e-9)))) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-firstAvailable arg-0 u--fs eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't find data file " (string-append arg-1 (string-append " in any of " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--fs))))) clam-0) (let ((e-1 (unbox e-6))) (vector 1 e-1)))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Directory-readDataFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Directory-findDataFile arg-0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 e-5) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (vector 1 e-2))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 e-5 e-7) clam-0))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-schFooter (lambda (arg-0 arg-1 ext-0) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "\xa;  (collect 4)\xa;  (blodwen-run-finalisers)\xa;  " (cons (cond ((equal? arg-0 1) "(profile-dump-html)") (else "")) (cons "\xa;  " (cons (cond ((equal? arg-1 1) ")") (else "")) '()))))) ext-0)))
(define LibrariesC-45UtilsC-45String-n--2718-891-u--escape (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-17 arg-2 arg-0))) (cond ((equal? sc0 1) (cons arg-1 (cons arg-2 arg-3))) (else (cons arg-2 arg-3))))))
(define LibrariesC-45UtilsC-45String-escapeGeneric (lambda (arg-0 arg-1 ext-0) (PreludeC-45Types-fastPack (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45String-n--2718-891-u--escape arg-1 arg-0 eta-0 eta-1))) '() (PreludeC-45Types-fastUnpack ext-0)))))
(define LibrariesC-45UtilsC-45String-escapeStringChez (lambda (ext-0) (LibrariesC-45UtilsC-45String-escapeGeneric #\\ (cons #\' (cons #\\ '())) ext-0)))
(define CompilerC-45Generated-generatedString (lambda (arg-0) (string-append "@" (string-append "generated by Idris " (string-append (LibrariesC-45DataC-45Version-u--show_Show_Version IdrisC-45Version-version) (string-append ", " (string-append arg-0 " backend")))))))
(define CompilerC-45SchemeC-45Chez-schHeader (lambda (arg-0 arg-1 arg-2 ext-0) (cons (string-append (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_String SystemC-45Info-os "windows"))) (cond ((equal? sc0 1) (string-append "#!" (string-append arg-0 (cond ((equal? arg-2 1) " --program\xa;\xa;") (else " --script\xa;\xa;"))))) (else ""))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons ";; " (cons (CompilerC-45Generated-generatedString "Chez") (cons "\xa;(import (chezscheme))\xa;(case (machine-type)\xa;  [(i3fb ti3fb a6fb ta6fb) #f]\xa;  [(i3le ti3le a6le ta6le tarm64le) (load-shared-object \"libc.so.6\")]\xa;  [(i3osx ti3osx a6osx ta6osx tarm64osx tppc32osx tppc64osx) (load-shared-object \"libc.dylib\")]\xa;  [(i3nt ti3nt a6nt ta6nt) (load-shared-object \"msvcrt.dll\")]\xa;  [else (load-shared-object \"libc.so\")])\xa;\xa;" (cons (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (string-append "(load-shared-object \"" (string-append (LibrariesC-45UtilsC-45String-escapeStringChez u--x) "\")"))) arg-1)) (cons "\xa;\xa;" (cons (cond ((equal? arg-2 1) "(let ()") (else "(source-directories (cons (getenv \"IDRIS2_INC_SRC\") (source-directories)))")) (cons "\xa;" '()))))))))) ext-0)))
(define CompilerC-45OptsC-45ToplevelConstants-calls (lambda (arg-0) (case (vector-ref arg-0 0) ((0) csegen-862) ((1) (let ((e-3 (vector-ref arg-0 2))) (LibrariesC-45DataC-45SortedSet-singleton csegen-861 e-3))) ((2) (let ((e-6 (vector-ref arg-0 3))) (CompilerC-45OptsC-45ToplevelConstants-calls e-6))) ((3) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (CompilerC-45OptsC-45ToplevelConstants-calls e-10) (CompilerC-45OptsC-45ToplevelConstants-calls e-9))))) ((4) (let ((e-12 (vector-ref arg-0 2))) (let ((e-13 (vector-ref arg-0 3))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (CompilerC-45OptsC-45ToplevelConstants-calls e-12) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-calls eta-0)) e-13))))) ((5) (let ((e-18 (vector-ref arg-0 5))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-calls eta-0)) e-18))) ((6) (let ((e-22 (vector-ref arg-0 4))) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 csegen-2558 (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-calls eta-0)) e-22))) ((7) (let ((e-25 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-calls eta-0)) e-25))) ((8) (let ((e-28 (vector-ref arg-0 3))) (CompilerC-45OptsC-45ToplevelConstants-calls e-28))) ((9) (let ((e-31 (vector-ref arg-0 3))) (CompilerC-45OptsC-45ToplevelConstants-calls e-31))) ((10) (let ((e-33 (vector-ref arg-0 2))) (let ((e-34 (vector-ref arg-0 3))) (let ((e-35 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (CompilerC-45OptsC-45ToplevelConstants-calls e-33) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (lamc-0) (let ((e-4 (vector-ref lamc-0 4))) (CompilerC-45OptsC-45ToplevelConstants-calls e-4))) e-34)) (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-2558 (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-calls eta-0)) e-35)))))) ((11) (let ((e-37 (vector-ref arg-0 2))) (let ((e-38 (vector-ref arg-0 3))) (let ((e-39 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (CompilerC-45OptsC-45ToplevelConstants-calls e-37) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (lamc-0) (let ((e-1 (cdr lamc-0))) (CompilerC-45OptsC-45ToplevelConstants-calls e-1))) e-38)) (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-2558 (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-calls eta-0)) e-39)))))) ((12) csegen-862) ((13) csegen-862) (else csegen-862))))
(define CompilerC-45OptsC-45ToplevelConstants-defCalls (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45OptsC-45ToplevelConstants-calls e-1))) ((1) csegen-862) ((2) csegen-862) (else (let ((e-8 (vector-ref arg-0 1))) (CompilerC-45OptsC-45ToplevelConstants-calls e-8))))))
(define CompilerC-45OptsC-45ToplevelConstants-callGraph (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-fromList csegen-861 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (cons e-2 (CompilerC-45OptsC-45ToplevelConstants-defCalls e-7)))))) ext-0))))
(define LibrariesC-45DataC-45SortedSet-fromList (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedMap-fromList arg-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--i) (cons u--i (vector 0 ))) arg-2))))
(define CompilerC-45OptsC-45ToplevelConstants-isConstant (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) 0 (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (if (null? e-8) (let ((sc4 (LibrariesC-45DataC-45SortedSet-contains e-2 arg-0))) (cond ((equal? sc4 1) 0) (else 1))) 0)))(else 0)))))))))
(define CompilerC-45OptsC-45ToplevelConstants-isRecursive (lambda (arg-0 arg-1) (if (null? arg-1) 1 (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45SortedSet-contains e-1 eta-0))) (LibrariesC-45DataC-45SortedMap-lookup e-1 arg-0)) 1))))))
(define LibrariesC-45DataC-45Graph-initial (lambda (arg-1) (vector (LibrariesC-45DataC-45SortedMap-empty arg-1) '() 0 '() 0)))
(define LibrariesC-45DataC-45SortedMap-adjust (lambda (arg-2 arg-3 arg-4) (let ((sc0 (LibrariesC-45DataC-45SortedMap-lookup arg-2 arg-4))) (if (null? sc0) arg-4 (let ((e-2 (unbox sc0))) (LibrariesC-45DataC-45SortedMap-insert arg-2 (arg-3 e-2) arg-4))))))
(define LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44loop-4129 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (let ((u--tsC-39 (LibrariesC-45DataC-45Graph-n--3617-3795-u--strongConnect arg-1 arg-2 arg-7 arg-5))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-lookup arg-5 (let ((e-1 (vector-ref u--tsC-39 0))) e-1)))) (if (null? sc1) (let ((e-1 (vector-ref u--tsC-39 0))) (let ((e-2 (vector-ref u--tsC-39 1))) (let ((e-3 (vector-ref u--tsC-39 2))) (let ((e-4 (vector-ref u--tsC-39 3))) (vector e-1 e-2 e-3 e-4 1))))) (let ((e-2 (unbox sc1))) (let ((e-1 (vector-ref u--tsC-39 0))) (let ((e-6 (vector-ref u--tsC-39 1))) (let ((e-3 (vector-ref u--tsC-39 2))) (let ((e-4 (vector-ref u--tsC-39 3))) (let ((e-5 (vector-ref u--tsC-39 4))) (vector (LibrariesC-45DataC-45SortedMap-adjust arg-3 (lambda (rec-0) (let ((e-0 (vector-ref rec-0 0))) (let ((e-8 (vector-ref rec-0 1))) (let ((e-7 (vector-ref rec-0 2))) (vector e-0 (PreludeC-45EqOrd-u--min_Ord_Int (let ((e-10 (vector-ref e-2 1))) e-10) e-8) e-7))))) e-1) e-6 e-3 e-4 e-5)))))))))) (let ((e-2 (unbox arg-8))) (let ((sc1 (let ((e-3 (vector-ref e-2 2))) e-3))) (cond ((equal? sc1 0) arg-7) (else (let ((e-1 (vector-ref arg-7 0))) (let ((e-6 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector (LibrariesC-45DataC-45SortedMap-adjust arg-3 (lambda (rec-0) (let ((e-0 (vector-ref rec-0 0))) (let ((e-8 (vector-ref rec-0 1))) (let ((e-7 (vector-ref rec-0 2))) (vector e-0 (PreludeC-45EqOrd-u--min_Ord_Int (let ((e-11 (vector-ref e-2 0))) e-11) e-8) e-7))))) e-1) e-6 e-3 e-4 e-5)))))))))))))
(define LibrariesC-45DataC-45Graph-n--3630-3806-u--loop (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (LibrariesC-45DataC-45Graph-n--3630-3806-u--loop arg-1 arg-2 arg-3 arg-4 (LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44loop-4129 arg-1 arg-2 arg-3 arg-4 e-2 e-3 arg-5 (LibrariesC-45DataC-45SortedMap-lookup e-2 (let ((e-1 (vector-ref arg-5 0))) e-1))) e-3))))))
(define LibrariesC-45DataC-45Graph-n--3630-3807-u--tsC-39 (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (vector-ref arg-4 0))) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (vector (LibrariesC-45DataC-45SortedMap-insert arg-3 (vector (let ((e-8 (vector-ref arg-4 2))) e-8) (let ((e-8 (vector-ref arg-4 2))) e-8) 1) e-1) (cons arg-3 e-2) (bs+ (blodwen-toSignedInt 1 63) e-3 63) e-4 e-5))))))))
(define LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44createComponent-3826 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (vector e-1 e-2 e-3 e-4 1))))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((u--tsC-39 (let ((e-1 (vector-ref arg-7 0))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector (LibrariesC-45DataC-45SortedMap-adjust e-2 (lambda (rec-0) (let ((e-0 (vector-ref rec-0 0))) (let ((e-9 (vector-ref rec-0 1))) (vector e-0 e-9 0)))) e-1) e-3 e-6 e-4 e-5))))))) (let ((sc1 (let ((e-1 (vector-ref arg-1 0))) (let ((e-12 (car e-1))) ((e-12 e-2) arg-6))))) (cond ((equal? sc1 1) (let ((e-1 (vector-ref u--tsC-39 0))) (let ((e-7 (vector-ref u--tsC-39 1))) (let ((e-6 (vector-ref u--tsC-39 2))) (let ((e-4 (vector-ref u--tsC-39 3))) (let ((e-5 (vector-ref u--tsC-39 4))) (vector e-1 e-7 e-6 (cons (cons arg-6 arg-5) e-4) e-5))))))) (else (LibrariesC-45DataC-45Graph-n--3630-3805-u--createComponent arg-1 arg-2 arg-3 arg-4 u--tsC-39 arg-6 (cons e-2 arg-5)))))))))))
(define LibrariesC-45DataC-45Graph-n--3630-3805-u--createComponent (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnectC-44createComponent-3826 arg-1 arg-2 arg-3 arg-4 arg-7 arg-6 arg-5 (let ((e-2 (vector-ref arg-5 1))) e-2))))
(define LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnect-4578 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (vector e-1 e-2 e-3 e-4 1))))) (let ((e-2 (unbox arg-6))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (let ((e-0 (vector-ref e-2 0))) e-0) (let ((e-1 (vector-ref e-2 1))) e-1)))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45Graph-n--3630-3805-u--createComponent arg-1 arg-2 arg-3 arg-4 arg-5 arg-3 '())) (else arg-5)))))))
(define LibrariesC-45DataC-45Graph-n--3617-3795-u--strongConnect (lambda (arg-1 arg-2 arg-3 arg-4) (let ((u--tsC-39C-39 (let ((sc0 (LibrariesC-45DataC-45SortedMap-lookup arg-4 arg-2))) (if (null? sc0) (LibrariesC-45DataC-45Graph-n--3630-3807-u--tsC-39 arg-1 arg-2 arg-4 arg-3) (let ((e-2 (unbox sc0))) (LibrariesC-45DataC-45Graph-n--3630-3806-u--loop arg-1 arg-2 arg-4 arg-3 (LibrariesC-45DataC-45Graph-n--3630-3807-u--tsC-39 arg-1 arg-2 arg-4 arg-3) (LibrariesC-45DataC-45SortedSet-toList e-2))))))) (LibrariesC-45DataC-45Graph-case--tarjanC-44strongConnect-4578 arg-1 arg-2 arg-4 arg-3 u--tsC-39C-39 (LibrariesC-45DataC-45SortedMap-lookup arg-4 (let ((e-1 (vector-ref u--tsC-39C-39 0))) e-1))))))
(define LibrariesC-45DataC-45Graph-n--3617-3794-u--loop (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (let ((sc1 (let ((e-5 (vector-ref arg-3 4))) e-5))) (cond ((equal? sc1 1) '()) (else (let ((e-4 (vector-ref arg-3 3))) e-4)))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-lookup e-2 (let ((e-1 (vector-ref arg-3 0))) e-1)))) (if (null? sc1) (LibrariesC-45DataC-45Graph-n--3617-3794-u--loop arg-1 arg-2 (LibrariesC-45DataC-45Graph-n--3617-3795-u--strongConnect arg-1 arg-2 arg-3 e-2) e-3) (LibrariesC-45DataC-45Graph-n--3617-3794-u--loop arg-1 arg-2 arg-3 e-3))))))))
(define LibrariesC-45DataC-45Graph-tarjan (lambda (arg-1 arg-2) (LibrariesC-45DataC-45Graph-n--3617-3794-u--loop arg-1 arg-2 (LibrariesC-45DataC-45Graph-initial arg-1) (LibrariesC-45DataC-45SortedMap-keys arg-2))))
(define CompilerC-45OptsC-45ToplevelConstants-recursiveFunctions (lambda (arg-0) (let ((u--groups (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-isRecursive arg-0 eta-0)) (LibrariesC-45DataC-45Graph-tarjan csegen-861 arg-0)))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-0) (LibrariesC-45DataC-45SortedSet-fromList csegen-861 (DataC-45List1-forget eta-0))) u--groups))))
(define CompilerC-45OptsC-45ToplevelConstants-appendDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 e-1 (cons e-2 arg-1) e-3 e-4))))))))) (vector 1 act-2))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45ToplevelConstants-getCalls (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-toList eta-1))) (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-4 (vector-ref e-5 4))) e-4)))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define CompilerC-45OptsC-45ToplevelConstants-checkCrash (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((3) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-10 (vector-ref e-5 2))) (let ((e-9 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-10 e-9 e-4))))))))) (vector 1 act-2))))) eff-1) world-0)))))))) ((0) (let ((e-10 (vector-ref e-7 2))) (case (vector-ref e-10 0) ((14) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-13 (vector-ref e-5 2))) (let ((e-8 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-13 e-8 e-4))))))))) (vector 1 act-2))))) eff-1) world-0)))))))) ((6) (let ((e-13 (vector-ref e-10 1))) (let ((e-15 (vector-ref e-10 3))) (cond ((equal? e-13 0) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc7 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-5 1))) e-1) eta-2)) e-8))) (cond ((equal? sc7 1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-11 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-12 e-11 e-4))))))))) (vector 1 act-3))) (else (vector 1 (vector 0 )))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (let ((e-17 (- e-13 1))) (cond ((equal? e-17 0) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc7 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-5 1))) e-1) eta-2)) e-8))) (cond ((equal? sc7 1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-11 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-12 e-11 e-4))))))))) (vector 1 act-3))) (else (vector 1 (vector 0 )))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (let ((e-18 (- e-17 1))) (cond ((equal? e-18 0) (case (vector-ref e-15 0) ((38) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-11 (vector-ref e-5 2))) (let ((e-8 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-11 e-8 e-4))))))))) (vector 1 act-2))))) eff-1) world-0))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc7 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-5 1))) e-1) eta-2)) e-8))) (cond ((equal? sc7 1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-11 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-12 e-11 e-4))))))))) (vector 1 act-3))) (else (vector 1 (vector 0 )))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc6 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-5 1))) e-1) eta-2)) e-8))) (cond ((equal? sc6 1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-11 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-12 e-11 e-4))))))))) (vector 1 act-3))) (else (vector 1 (vector 0 )))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-5 1))) e-1) eta-2)) e-8))) (cond ((equal? sc5 1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-11 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-12 e-11 e-4))))))))) (vector 1 act-3))) (else (vector 1 (vector 0 )))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-5) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-5 1))) e-1) eta-2)) e-8))) (cond ((equal? sc4 1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-10 (vector-ref e-5 2))) (let ((e-9 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector e-0 (LibrariesC-45DataC-45SortedSet-insert e-2 e-1) e-10 e-9 e-4))))))))) (vector 1 act-3))) (else (vector 1 (vector 0 )))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define CompilerC-45OptsC-45ToplevelConstants-getTriple (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-3 (vector-ref e-5 3))) e-3))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define CompilerC-45OptsC-45ToplevelConstants-isProcessed (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedSet-contains arg-1 (let ((e-0 (vector-ref e-5 0))) e-0))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define CompilerC-45OptsC-45ToplevelConstants-markProcessed (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (vector (LibrariesC-45DataC-45SortedSet-insert arg-1 e-0) e-1 e-2 e-3 e-4))))))))) (vector 1 act-2))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45ToplevelConstants-sortDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CompilerC-45OptsC-45ToplevelConstants-isProcessed arg-0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 (CompilerC-45OptsC-45ToplevelConstants-markProcessed arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CompilerC-45OptsC-45ToplevelConstants-getCalls arg-0 arg-1 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45ToplevelConstants-sortDef arg-0 eta-1 eta-2))) e-7) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CompilerC-45OptsC-45ToplevelConstants-getTriple arg-0 arg-1 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-9) (vector 1 (vector 0 )) (let ((e-1 (unbox e-9))) (let ((act-6 (CompilerC-45OptsC-45ToplevelConstants-appendDef arg-0 e-1 clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else ((CompilerC-45OptsC-45ToplevelConstants-checkCrash arg-0 e-1) clam-1))))))))) eff-0) eta-0))))))))))) eff-0) clam-0))))))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45ToplevelConstants-sortDefs (lambda (arg-0) (let ((u--graph (CompilerC-45OptsC-45ToplevelConstants-callGraph arg-0))) (let ((u--rec (CompilerC-45OptsC-45ToplevelConstants-recursiveFunctions u--graph))) (let ((u--consts (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ToplevelConstants-isConstant u--rec eta-0)) arg-0)))) (let ((u--init (vector csegen-862 csegen-862 '() (LibrariesC-45DataC-45SortedMap-fromList csegen-861 (PreludeC-45TypesC-45List-mapAppend '() csegen-4854 arg-0)) u--graph))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.Opts.ToplevelConstants.SortTag" ) u--init) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CompilerC-45OptsC-45ToplevelConstants-sortDef e-5 eta-2 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) arg-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--sorted (PreludeC-45TypesC-45SnocList-C-60C-62C-62 (let ((e-2 (vector-ref e-7 2))) e-2) '()))) (let ((consts-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-2) (let ((sc3 (PreludeC-45Basics-flip csegen-2543 (let ((e-1 (vector-ref e-7 1))) e-1) eta-2))) (cond ((equal? sc3 1) 0) (else 1)))) u--consts))) (lambda (eta-2) (vector 1 (cons u--sorted (LibrariesC-45DataC-45SortedSet-fromList csegen-861 consts-0)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))))
(define CompilerC-45SchemeC-45Chez-compileToSS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-getDirectives arg-0 (vector 0 ) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Chez-findLibs arg-0 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (CompilerC-45Common-copyLib eta-2)) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CompilerC-45Common-getCompileData arg-0 0 0 arg-3 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--ndefs (let ((e-2 (vector-ref e-8 2))) e-2))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-8 0))) e-0)))) (lambda (eta-2) (let ((act-5 (let ((act-5 (unbox arg-0))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-3) (let ((act-6 (csegen-5049 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Structs" ) '()) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (let ((act-8 (CompilerC-45SchemeC-45Chez-findChez eta-5))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (let ((act-9 (CompilerC-45SchemeC-45Chez-chezVersion e-12 eta-6))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 ((CoreC-45Core-traverseC-39 (lambda (eta-8) (CompilerC-45SchemeC-45Chez-getFgnCall arg-0 e-10 e-11 e-13 eta-8)) u--ndefs '()) eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-11 ((CoreC-45Core-traverseC-39 (lambda (eta-9) (lambda (eta-10) (CompilerC-45SchemeC-45Chez-locateLib arg-0 arg-2 eta-9 eta-10))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-9) (Builtin-fst eta-9)) e-14) '()) eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 ((CompilerC-45OptsC-45ToplevelConstants-sortDefs u--ndefs) eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-16))) (let ((e-3 (cdr e-16))) (let ((act-13 (CoreC-45ContextC-45Log-logTime arg-0 3 (lambda () "Print as scheme") (CoreC-45Core-traverseC-39 (lambda (eta-10) (CompilerC-45SchemeC-45Common-getScheme arg-0 e-3 (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (CompilerC-45SchemeC-45Chez-chezExtPrim e-3 eta-11 eta-12 eta-13)))) csegen-5051 eta-10)) e-2 '()) clam-0))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (let ((u--code (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-11) eta-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-11) (Builtin-snd eta-11)) e-14)) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-11) eta-11) e-17) eta-10)))) (lambda (eta-10) (let ((act-14 ((CompilerC-45SchemeC-45Common-schExp e-3 (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (CompilerC-45SchemeC-45Chez-chezExtPrim e-3 eta-11 eta-12 eta-13)))) csegen-5051 0 u--ctm) eta-10))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-15 (CoreC-45Directory-readDataFile arg-0 "chez/support.ss" eta-11))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-12) (let ((act-16 (CompilerC-45Common-getExtraRuntime e-5 eta-12))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (let ((u--scm (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-13) eta-13) (cons (lambda (eta-13) (CompilerC-45SchemeC-45Chez-schHeader e-12 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-14) (Builtin-snd eta-14)) e-6) e-15) 1 eta-13)) (cons (lambda (eta-13) (cons e-19 eta-13)) (cons (lambda (eta-13) (cons e-20 eta-13)) (cons u--code (cons (lambda (eta-13) (cons "(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))\xa;" eta-13)) (cons e-18 (cons (lambda (eta-13) (CompilerC-45SchemeC-45Chez-schFooter arg-1 1 eta-13)) '())))))))))) (lambda (eta-13) (let ((act-17 (let ((act-17 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-4 (LibrariesC-45DataC-45StringC-45Builder-build u--scm)) eta-13))) (vector 1 act-17)))) (case (vector-ref act-17 0) ((0) (let ((e-4 (vector-ref act-17 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (case (vector-ref e-21 0) ((1) (let ((eff-0 (lambda (world-0) (let ((act-18 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 arg-4 (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-18))))) (lambda (eta-14) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-14)))) (else (let ((e-22 (vector-ref e-21 1))) (lambda (eta-14) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-4 e-22) eta-14))))))) eff-0) eta-13))))))))) eff-0) eta-12)))))))) eff-0) eta-11)))))))) eff-0) eta-10))))))))) eff-0) clam-0)))))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-startChezPreamble (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "#!/bin/sh\xa;# " (cons (CompilerC-45Generated-generatedString "Chez") (cons "\xa;\xa;set -e # exit on any error\xa;\xa;if [ \"$(uname)\" = Darwin ]; then\xa;  DIR=$(zsh -c 'printf %s \"$0:A:h\"' \"$0\")\xa;else\xa;  DIR=$(dirname \"$(readlink -f -- \"$0\")\")\xa;fi\xa;" '())))))
(define CompilerC-45SchemeC-45Chez-startChez (lambda (arg-0 arg-1) (string-append CompilerC-45SchemeC-45Chez-startChezPreamble (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "export LD_LIBRARY_PATH=\"$DIR/" (cons arg-0 (cons ":$LD_LIBRARY_PATH\"\xa;export DYLD_LIBRARY_PATH=\"$DIR/" (cons arg-0 (cons ":$DYLD_LIBRARY_PATH\"\xa;export IDRIS2_INC_SRC=\"$DIR/" (cons arg-0 (cons "\"\xa;\xa;\"$DIR/" (cons arg-1 (cons "\" \"$@\"" '())))))))))))))
(define CompilerC-45SchemeC-45Chez-makeSh (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-0 (CompilerC-45SchemeC-45Chez-startChez arg-1 arg-2)) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-0 e-6) clam-0))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-startChezCmd (lambda (arg-0 arg-1 arg-2 arg-3) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "@echo off\xa;\xa;rem " (cons (CompilerC-45Generated-generatedString "Chez") (cons "\xa;\xa;set APPDIR=%~dp0\xa;set PATH=%APPDIR%" (cons arg-1 (cons ";%PATH%\xa;set IDRIS2_INC_SRC=%APPDIR%" (cons arg-1 (cons "\xa;\xa;\"" (cons arg-0 (cons "\" " (cons arg-3 (cons " \"%APPDIR%" (cons arg-2 (cons "\" %*" '()))))))))))))))))
(define CompilerC-45SchemeC-45Chez-startChezWinSh (lambda (arg-0 arg-1 arg-2 arg-3) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "#!/bin/sh\xa;# " (cons (CompilerC-45Generated-generatedString "Chez") (cons "\xa;\xa;set -e # exit on any error\xa;\xa;DIR=$(dirname \"$(readlink -f -- \"$0\" || cygpath -a -- \"$0\")\")\xa;PATH=\"$DIR/" (cons arg-1 (cons ":$PATH\"\xa;\xa;export IDRIS2_INC_SRC=\"$DIR/" (cons arg-1 (cons "\"\xa;\xa;\"" (cons arg-0 (cons "\" " (cons arg-3 (cons " \"$DIR/" (cons arg-2 (cons "\" \"$@\"" '()))))))))))))))))
(define CompilerC-45SchemeC-45Chez-makeShWindows (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--cmdFile (string-append arg-1 ".cmd"))) (lambda (eta-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--cmdFile (CompilerC-45SchemeC-45Chez-startChezCmd arg-0 arg-2 arg-3 arg-4)) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((act-2 (let ((act-2 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-1 (CompilerC-45SchemeC-45Chez-startChezWinSh arg-0 arg-2 arg-3 arg-4)) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-1 e-7) clam-1))))))) eff-0) clam-0)))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 u--cmdFile e-6) clam-0))))))) eff-0) eta-0)))))))))
(define SystemC-45Directory-createDir (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45Directory-prim__createDir arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45Directory-ok arg-1 (vector 0 ))) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define CoreC-45Directory-dirExists (lambda (arg-0 ext-0) (let ((act-1 ((SystemC-45Directory-openDir csegen-82 arg-0) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 ((SystemC-45Directory-closeDir csegen-82 e-2) ext-0))) 1))) (else 0)))))
(define LibrariesC-45UtilsC-45Path-parent (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45UtilsC-45Path-u--show_Show_Path eta-0)) (LibrariesC-45UtilsC-45Path-parentC-39 (LibrariesC-45UtilsC-45Path-parse ext-0)))))
(define LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Path (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-1 0))) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((sc0 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-524 e-0 e-4))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bool e-1 e-5))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-527 e-2 e-6)) (else 0)))) (else 0)))))))))))
(define CoreC-45Directory-mkdirAll (lambda (arg-0 ext-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-u--C-61C-61_Eq_Path (LibrariesC-45UtilsC-45Path-parse arg-0) LibrariesC-45UtilsC-45Path-emptyPath))) (cond ((equal? sc0 1) (vector 1 (vector 0 ))) (else (let ((act-1 (CoreC-45Directory-dirExists arg-0 ext-0))) (cond ((equal? act-1 1) (vector 1 (vector 0 ))) (else (let ((act-2 (let ((sc2 (LibrariesC-45UtilsC-45Path-parent arg-0))) (if (null? sc2) (vector 1 (vector 0 )) (let ((e-1 (unbox sc2))) (CoreC-45Directory-mkdirAll e-1 ext-0)))))) (case (vector-ref act-2 0) ((1) ((SystemC-45Directory-createDir csegen-82 arg-0) ext-0))(else act-2)))))))))))
(define CompilerC-45SchemeC-45Chez-compileExprWhole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((u--appDirRel (string-append arg-6 "_app"))) (let ((u--appDirGen (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 u--appDirRel))) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (CoreC-45Directory-mkdirAll u--appDirGen world-0))) (vector 1 act-1))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (csegen-1310 eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) csegen-1311 (let ((e-1 (unbox e-6))) (let ((u--outSsFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-6 "ss")))) (let ((u--outSoFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-6 "so")))) (let ((u--outSsAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 arg-4) u--outSsFile))) (lambda (eta-1) (let ((act-3 (let ((act-3 (CompilerC-45SchemeC-45Chez-findChez eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-getSession arg-1 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--prof (let ((e-16 (vector-ref e-8 16))) e-16))) (lambda (eta-3) (let ((act-5 (CoreC-45ContextC-45Log-logTime arg-1 2 (lambda () "Compile to scheme") (lambda (eta-4) (CompilerC-45SchemeC-45Chez-compileToSS arg-1 (cond ((equal? arg-0 1) u--prof) (else 0)) u--appDirGen arg-5 u--outSsAbs eta-4)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45ContextC-45Log-logTime arg-1 2 (lambda () "Make SO") (cond ((equal? arg-0 1) (CompilerC-45SchemeC-45Chez-compileToSO arg-1 u--prof e-7 u--appDirGen u--outSsAbs)) (else (lambda (eta-4) (vector 1 (vector 0 ))))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 arg-6))) (let ((act-7 (let ((sc7 SystemC-45Info-isWindows)) (cond ((equal? sc7 1) ((CompilerC-45SchemeC-45Chez-makeShWindows e-7 u--outShRel u--appDirRel (cond ((equal? arg-0 1) u--outSoFile) (else u--outSsFile)) "--program") eta-3)) (else (CompilerC-45SchemeC-45Chez-makeSh u--outShRel u--appDirRel (cond ((equal? arg-0 1) u--outSoFile) (else u--outSsFile)) eta-3)))))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((let ((eff-0 (lambda (world-0) (let ((act-8 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 u--outShRel (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-8))))) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-4))) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (vector 1 (box u--outShRel))))))))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))))) eff-0) eta-0)))))))))))))
(define CompilerC-45Common-compileTerm (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-68 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45CompileExpr-compileExp arg-0 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45Inline-fixArityExp '() arg-0 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-loadLib (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CompilerC-45SchemeC-45Chez-locateLib arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append "(load-shared-object \"" (string-append (LibrariesC-45UtilsC-45String-escapeStringChez e-5) "\")\xa;")))))) eff-0) ext-0)))))))
(define CoreC-45Directory-extraSearchDirectories (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-1) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 (PreludeC-45Show-u--show_Show_Int CoreC-45Binary-ttcVersion))) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-6 (vector-ref e-5 6))) e-6) (let ((e-7 (vector-ref e-5 7))) e-7))))))) eff-0) ext-0)))))))
(define CoreC-45Directory-ttcBuildDirectory (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref e-5 2))) e-2) "ttc") (PreludeC-45Show-u--show_Show_Int CoreC-45Binary-ttcVersion)))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-loadSO (lambda (arg-0 arg-1 arg-2 ext-0) (cond ((equal? arg-2 "") (vector 1 ""))(else (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Directory-ttcBuildDirectory arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Directory-extraSearchDirectories arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--fs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--p) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p arg-2)) (cons e-6 e-7)))) (lambda (eta-2) (let ((act-4 (CoreC-45Directory-firstAvailable arg-0 u--fs eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Missing .so:" arg-2)) eta-3)) (let ((e-1 (unbox e-8))) (let ((u--modfname (PreludeC-45Types-fastConcat (DataC-45List-intersperse "-" (LibrariesC-45UtilsC-45Path-splitPath arg-2))))) (lambda (eta-3) (let ((act-5 ((CompilerC-45Common-copyLib (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 u--modfname) e-1)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (string-append "(load \"" (string-append (LibrariesC-45UtilsC-45String-escapeStringChez u--modfname) "\")\xa;")))))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))
(define CompilerC-45SchemeC-45Chez-compileToSSInc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (CompilerC-45SchemeC-45Chez-findChez ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45Common-compileTerm arg-0 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ctm (CoreC-45CompileExpr-forget '() e-6))) (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-4) (CompilerC-45SchemeC-45Chez-loadLib arg-0 arg-3 eta-2 eta-4)) eta-3))) (DataC-45List-nub csegen-22 arg-2) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-5) (CompilerC-45SchemeC-45Chez-loadSO arg-0 arg-3 eta-3 eta-5)) eta-4))) (DataC-45List-nub csegen-22 arg-1) '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CompilerC-45SchemeC-45Common-schExp csegen-862 csegen-5050 csegen-5051 0 u--ctm) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Directory-readDataFile arg-0 "chez/support.ss" eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--scm (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (CompilerC-45SchemeC-45Chez-schHeader e-5 '() 0 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons e-10 eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-8) eta-8) e-7) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-9) eta-9) e-8) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons "(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))\xa;" eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-9 (lambda (eta-11) (CompilerC-45SchemeC-45Chez-schFooter 0 0 eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)))) (lambda (eta-5) (let ((act-7 (let ((act-7 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-5 (LibrariesC-45DataC-45StringC-45Builder-build u--scm)) eta-5))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-11 0) ((1) (let ((act-8 ((let ((eff-0 (lambda (world-0) (let ((act-8 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 arg-5 (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-8))))) (lambda (eta-6) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-6))) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (vector 1 (vector 0 )))))) (else (let ((e-12 (vector-ref e-11 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-5 e-12) clam-0))))))) eff-0) eta-5))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-compileExprInc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (DataC-45List-lookup csegen-1331 (vector 0 ) (let ((e-23 (vector-ref e-5 23))) e-23)))) (if (null? sc1) (lambda (eta-0) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr "Missing incremental compile data, reverting to whole program compilation\xa;" eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CompilerC-45SchemeC-45Chez-compileExprWhole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) eta-0))))) (let ((e-1 (unbox sc1))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((u--appDirRel (string-append arg-6 "_app"))) (let ((u--appDirGen (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 u--appDirRel))) (lambda (eta-0) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 (CoreC-45Directory-mkdirAll u--appDirGen world-0))) (vector 1 act-2))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (csegen-1310 eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-9) csegen-1311 (let ((e-2 (unbox e-9))) (let ((u--outSsFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-6 "ss")))) (let ((u--outSsAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-2 arg-4) u--outSsFile))) (lambda (eta-1) (let ((act-4 (let ((act-4 (CompilerC-45SchemeC-45Chez-findChez eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CompilerC-45SchemeC-45Chez-compileToSSInc arg-1 e-7 e-6 u--appDirGen arg-5 u--outSsAbs eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 arg-6))) (let ((act-6 (let ((sc8 SystemC-45Info-isWindows)) (cond ((equal? sc8 1) ((CompilerC-45SchemeC-45Chez-makeShWindows e-10 u--outShRel u--appDirRel u--outSsFile "--script") eta-2)) (else (CompilerC-45SchemeC-45Chez-makeSh u--outShRel u--appDirRel u--outSsFile eta-2)))))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 u--outShRel (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-7))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-3))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (vector 1 (box u--outShRel))))))))))))))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))))))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (let ((sc2 (let ((e-23 (vector-ref e-5 23))) e-23))) (cond ((equal? sc2 1) 0) (else (PreludeC-45Types-elem csegen-14 csegen-1331 (vector 0 ) (let ((e-22 (vector-ref e-5 22))) e-22))))))) (cond ((equal? sc1 1) (lambda (eta-0) (CompilerC-45SchemeC-45Chez-compileExprInc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0))) (else (CompilerC-45SchemeC-45Chez-compileExprWhole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CompilerC-45SchemeC-45Chez-compileExpr 0 arg-0 arg-1 arg-2 arg-2 arg-3 "_tmpchez" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-5006 (let ((e-1 (unbox e-5))) (let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45Escaped-system csegen-82 (cons e-1 '())) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))))) eff-0) ext-0)))))))
(define CompilerC-45Common-compDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) (vector 1 '()) (let ((e-26 (unbox e-19))) (vector 1 (box (cons arg-1 (cons (let ((e-49 (vector-ref e-1 0))) e-49) e-26)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Common-getIncCompileData (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ns (LibrariesC-45DataC-45NameMap-keys (let ((e-24 (vector-ref e-5 24))) e-24)))) (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 csegen-54 eta-1 eta-2))) u--ns '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-filterM (lambda (eta-2) (lambda (eta-3) (CompilerC-45Common-nonErased arg-0 eta-2 eta-3))) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO csegen-55 (CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CompilerC-45Common-compDef arg-0 eta-3 eta-4))) e-7 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CompilerC-45Common-getNamedDef arg-0 eta-4)) e-8 '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((sc5 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase arg-2 1))) (cond ((equal? sc5 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Lambda lift") (CoreC-45Core-traverseC-39 (lambda (eta-5) (CompilerC-45LambdaLift-lambdaLift arg-0 arg-1 eta-5)) e-8 '()) eta-4)) (else (vector 1 '())))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--lifted (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-5) eta-5) e-10))) (lambda (eta-5) (let ((act-7 (let ((sc6 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase arg-2 2))) (cond ((equal? sc6 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Get ANF") (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-7 (CompilerC-45ANF-toANF e-3 clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (cons e-2 e-11))))) eff-0) clam-0))))))))) u--lifted '()) eta-5)) (else (vector 1 '())))))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (let ((sc7 (CompilerC-45Common-u--C-62C-61_Ord_UsePhase arg-2 3))) (cond ((equal? sc7 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Get VM Code") (lambda (eta-7) (vector 1 (CompilerC-45VMCode-allDefs e-11))) eta-6)) (else (vector 1 '())))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (vector (vector 13 CoreC-45FC-emptyFC) '() e-9 u--lifted e-11 e-12))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Directory-getObjFileName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Directory-ctxtPathToNS arg-0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fname (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-5) arg-2))) (lambda (eta-0) (vector 1 u--fname))))) eff-0) ext-0)))))))
(define CoreC-45Directory-getTTCFileName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Directory-ctxtPathToNS arg-0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fname (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-5) arg-2))) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-ttcBuildDirectory arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-6 u--fname))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-incCompile (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Directory-getTTCFileName arg-0 arg-2 "ss" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Directory-getTTCFileName arg-0 arg-2 "so" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Directory-getObjFileName arg-0 arg-2 "so" eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CompilerC-45Common-getIncCompileData arg-0 0 0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-getDirs arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Directory-ttcBuildDirectory arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--ndefs (let ((e-2 (vector-ref e-8 2))) e-2))) (lambda (clam-0) (let ((sc6 (DataC-45List-isNil u--ndefs))) (cond ((equal? sc6 1) (vector 1 (box (cons "" '())))) (else (let ((act-7 (csegen-5049 clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Structs" ) '()) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (let ((act-9 (CompilerC-45SchemeC-45Chez-findChez eta-6))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (let ((act-10 (CompilerC-45SchemeC-45Chez-chezVersion e-13 eta-7))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-11 ((CoreC-45Core-traverseC-39 (lambda (eta-9) (CompilerC-45SchemeC-45Chez-getFgnCall arg-0 e-11 e-12 e-14 eta-9)) u--ndefs '()) eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 ((CompilerC-45OptsC-45ToplevelConstants-sortDefs u--ndefs) eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-16))) (let ((e-3 (cdr e-16))) (let ((act-13 ((CoreC-45Core-traverseC-39 (lambda (eta-10) (CompilerC-45SchemeC-45Common-getScheme arg-0 e-3 (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (CompilerC-45SchemeC-45Chez-chezExtPrim e-3 eta-11 eta-12 eta-13)))) csegen-5051 eta-10)) e-2 '()) clam-1))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (let ((u--code (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-10) eta-10) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-10) (Builtin-snd eta-10)) e-15) e-17)))) (lambda (eta-10) (let ((act-14 (let ((act-14 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 e-5 (LibrariesC-45DataC-45StringC-45Builder-build u--code)) eta-10))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (case (vector-ref e-18 0) ((1) (let ((u--tmpFileAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-10 "compileChez"))) (let ((u--build (string-append "(parameterize ([optimize-level 3] " (string-append "[compile-file-message #f]) (compile-file " (string-append (PreludeC-45Show-u--show_Show_String e-5) "))"))))) (lambda (eta-11) (let ((act-15 (let ((act-15 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--tmpFileAbs u--build) eta-11))) (vector 1 act-15)))) (case (vector-ref act-15 0) ((0) (let ((e-19 (vector-ref act-15 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-15 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-19 0) ((1) (let ((act-16 ((let ((eff-0 (lambda (world-0) (let ((act-16 ((SystemC-45Escaped-system csegen-82 (cons e-13 (cons "--script" (cons u--tmpFileAbs '())))) world-0))) (vector 1 act-16))))) (lambda (eta-12) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-12))) clam-2))) (case (vector-ref act-16 0) ((0) (let ((e-21 (vector-ref act-16 1))) (vector 0 e-21))) (else (vector 1 (box (cons e-7 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-12) (Builtin-fst eta-12)) e-15)))))))) (else (let ((e-20 (vector-ref e-19 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 u--tmpFileAbs e-20) clam-2))))))) eff-0) eta-11))))))))) (else (let ((e-19 (vector-ref e-18 1))) (lambda (eta-11) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 e-5 e-19) eta-11))))))) eff-0) eta-10))))))))) eff-0) clam-1)))))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) clam-0)))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Chez-codegenChez (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CompilerC-45SchemeC-45Chez-compileExpr 1 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Chez-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) (box (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Chez-incCompile eta-0 eta-1 eta-2 eta-3)))))) (box "so"))))
(define CompilerC-45SchemeC-45ChezSep-compileChezLibraries (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Escaped-system csegen-82 (cons "echo" (cons (DataC-45String-unwords (PreludeC-45Types-listBind arg-2 (lambda (u--ssFile) (PreludeC-45Types-u--pure_Applicative_List (string-append "'(parameterize ([optimize-level 3] [compile-file-message #f]) (compile-library " (string-append (LibrariesC-45DataC-45StringC-45Builder-build (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString u--ssFile eta-0))) (string-append "))'" (string-append " '(delete-file " (string-append (LibrariesC-45DataC-45StringC-45Builder-build (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString u--ssFile eta-0))) ")'"))))))))) (cons "|" (cons arg-0 (cons "-q" (cons "--libdirs" (cons arg-1 '())))))))) world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0)))))
(define CompilerC-45SchemeC-45ChezSep-compileChezLibrary (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Escaped-system csegen-82 (cons "echo" (cons (string-append "'(parameterize ([optimize-level 3] [compile-file-message #f]) (compile-library " (string-append (LibrariesC-45DataC-45StringC-45Builder-build (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString arg-2 eta-0))) "))'")) (cons (string-append "'(delete-file " (string-append (LibrariesC-45DataC-45StringC-45Builder-build (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString arg-2 eta-0))) ")'")) (cons "|" (cons arg-0 (cons "-q" (cons "--libdirs" (cons arg-1 '()))))))))) world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0)))))
(define CompilerC-45SchemeC-45ChezSep-compileChezProgram (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Escaped-system csegen-82 (cons "echo" (cons (string-append "'(parameterize ([optimize-level 3] [compile-file-message #f]) (compile-program " (string-append (LibrariesC-45DataC-45StringC-45Builder-build (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString arg-2 eta-0))) "))'")) (cons (string-append "'(delete-file " (string-append (LibrariesC-45DataC-45StringC-45Builder-build (lambda (eta-0) (CompilerC-45SchemeC-45Chez-chezString arg-2 eta-0))) ")'")) (cons "|" (cons arg-0 (cons "-q" (cons "--libdirs" (cons arg-1 '()))))))))) world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0)))))
(define CompilerC-45SchemeC-45ChezSep-case--chezNS-1532 (lambda (arg-0 arg-1) (cond ((equal? arg-1 "") "unqualified")(else arg-1))))
(define CompilerC-45SchemeC-45ChezSep-chezNS (lambda (arg-0) (CompilerC-45SchemeC-45ChezSep-case--chezNS-1532 arg-0 (CoreC-45NameC-45Namespace-showNSWithSep "-" arg-0))))
(define DataC-45List1-foldl1By (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (PreludeC-45Types-u--foldl_Foldable_List arg-2 (arg-3 e-1) e-2)))))
(define DataC-45List1-foldl1 (lambda (arg-1 ext-0) (DataC-45List1-foldl1By arg-1 (lambda (eta-0) eta-0) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-chezLibraryName (lambda (arg-1) (CompilerC-45SchemeC-45ChezSep-chezNS (DataC-45List1-foldl1 (lambda (eta-0) (lambda (eta-1) (CoreC-45NameC-45Namespace-u--min_Ord_Namespace eta-0 eta-1))) (let ((e-2 (vector-ref arg-1 1))) e-2)))))
(define LibrariesC-45DataC-45SortedMap-branch4 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 1 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10))))
(define LibrariesC-45DataC-45SortedMap-branch5 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 1 (vector 1 arg-4 arg-5 arg-6) arg-7 (vector 2 arg-8 arg-9 arg-10 arg-11 arg-12))))
(define LibrariesC-45DataC-45SortedMap-branch6 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (vector 2 (vector 1 arg-4 arg-5 arg-6) arg-7 (vector 1 arg-8 arg-9 arg-10) arg-11 (vector 1 arg-12 arg-13 arg-14))))
(define LibrariesC-45DataC-45SortedMap-branch7 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (vector 2 (vector 2 arg-4 arg-5 arg-6 arg-7 arg-8) arg-9 (vector 1 arg-10 arg-11 arg-12) arg-13 (vector 1 arg-14 arg-15 arg-16))))
(define LibrariesC-45DataC-45SortedMap-merge1 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-6 0) ((1) (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((e-6 (vector-ref arg-6 3))) (case (vector-ref arg-8 0) ((1) (let ((e-20 (vector-ref arg-8 1))) (let ((e-21 (vector-ref arg-8 2))) (let ((e-22 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch5 arg-4 arg-5 e-4 e-5 e-6 arg-7 e-20 e-21 e-22))))) (else (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((e-30 (vector-ref arg-8 4))) (let ((e-31 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch6 arg-4 arg-5 e-4 e-5 e-6 arg-7 e-27 e-28 e-29 e-30 e-31)))))))))))) (else (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((e-15 (vector-ref arg-6 5))) (case (vector-ref arg-8 0) ((1) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch6 arg-4 arg-5 e-11 e-12 e-13 e-14 e-15 arg-7 e-36 e-37 e-38))))) (else (let ((e-43 (vector-ref arg-8 1))) (let ((e-44 (vector-ref arg-8 2))) (let ((e-45 (vector-ref arg-8 3))) (let ((e-46 (vector-ref arg-8 4))) (let ((e-47 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch7 arg-4 arg-5 e-11 e-12 e-13 e-14 e-15 arg-7 e-43 e-44 e-45 e-46 e-47)))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-merge2 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-4 0) ((1) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (case (vector-ref arg-8 0) ((1) (let ((e-20 (vector-ref arg-8 1))) (let ((e-21 (vector-ref arg-8 2))) (let ((e-22 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch5 e-4 e-5 e-6 arg-5 arg-6 arg-7 e-20 e-21 e-22))))) (else (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((e-30 (vector-ref arg-8 4))) (let ((e-31 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch6 e-4 e-5 e-6 arg-5 arg-6 arg-7 e-27 e-28 e-29 e-30 e-31)))))))))))) (else (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (let ((e-15 (vector-ref arg-4 5))) (case (vector-ref arg-8 0) ((1) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (LibrariesC-45DataC-45SortedMap-branch6 e-11 e-12 e-13 e-14 e-15 arg-5 arg-6 arg-7 e-36 e-37 e-38))))) (else (let ((e-43 (vector-ref arg-8 1))) (let ((e-44 (vector-ref arg-8 2))) (let ((e-45 (vector-ref arg-8 3))) (let ((e-46 (vector-ref arg-8 4))) (let ((e-47 (vector-ref arg-8 5))) (LibrariesC-45DataC-45SortedMap-branch7 e-11 e-12 e-13 e-14 e-15 arg-5 arg-6 arg-7 e-43 e-44 e-45 e-46 e-47)))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-merge3 (lambda (arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-4 0) ((1) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (case (vector-ref arg-6 0) ((1) (let ((e-20 (vector-ref arg-6 1))) (let ((e-21 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 3))) (LibrariesC-45DataC-45SortedMap-branch5 e-4 e-5 e-6 arg-5 e-20 e-21 e-22 arg-7 arg-8))))) (else (let ((e-27 (vector-ref arg-6 1))) (let ((e-28 (vector-ref arg-6 2))) (let ((e-29 (vector-ref arg-6 3))) (let ((e-30 (vector-ref arg-6 4))) (let ((e-31 (vector-ref arg-6 5))) (LibrariesC-45DataC-45SortedMap-branch6 e-4 e-5 e-6 arg-5 e-27 e-28 e-29 e-30 e-31 arg-7 arg-8)))))))))))) (else (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (let ((e-15 (vector-ref arg-4 5))) (case (vector-ref arg-6 0) ((1) (let ((e-36 (vector-ref arg-6 1))) (let ((e-37 (vector-ref arg-6 2))) (let ((e-38 (vector-ref arg-6 3))) (LibrariesC-45DataC-45SortedMap-branch6 e-11 e-12 e-13 e-14 e-15 arg-5 e-36 e-37 e-38 arg-7 arg-8))))) (else (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (let ((e-45 (vector-ref arg-6 3))) (let ((e-46 (vector-ref arg-6 4))) (let ((e-47 (vector-ref arg-6 5))) (LibrariesC-45DataC-45SortedMap-branch7 e-11 e-12 e-13 e-14 e-15 arg-5 e-43 e-44 e-45 e-46 e-47 arg-7 arg-8)))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-treeDelete (lambda (arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-4 0) (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((sc2 (let ((e-1 (vector-ref arg-3 0))) (let ((e-12 (car e-1))) ((e-12 arg-5) e-4))))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (vector 0 (vector 0 e-4 e-5))))))))(else (let ((e-0 (- arg-4 1))) (cond ((equal? e-0 0) (case (vector-ref arg-6 0) ((1) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((sc2 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-12)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-11))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-2 e-12 e-13)))) (else (vector 1 e-13))))) (else (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-13))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 1 e-11 e-12 e-2)))) (else (vector 1 e-11))))))))))) (else (let ((e-18 (vector-ref arg-6 1))) (let ((e-19 (vector-ref arg-6 2))) (let ((e-20 (vector-ref arg-6 3))) (let ((e-21 (vector-ref arg-6 4))) (let ((e-22 (vector-ref arg-6 5))) (let ((sc2 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-19)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-18))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-2 e-19 e-20 e-21 e-22)))) (else (vector 0 (vector 1 e-20 e-21 e-22)))))) (else (let ((sc3 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-21)))) (cond ((equal? sc3 1) (let ((sc4 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-20))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-18 e-19 e-2 e-21 e-22)))) (else (vector 0 (vector 1 e-18 e-19 e-22)))))) (else (let ((sc4 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 0 arg-5 e-22))) (case (vector-ref sc4 0) ((0) (let ((e-2 (vector-ref sc4 1))) (vector 0 (vector 2 e-18 e-19 e-20 e-21 e-2)))) (else (vector 0 (vector 1 e-18 e-19 e-20)))))))))))))))))))(else (let ((e-6 (- e-0 1))) (case (vector-ref arg-6 0) ((1) (let ((e-27 (vector-ref arg-6 1))) (let ((e-28 (vector-ref arg-6 2))) (let ((e-29 (vector-ref arg-6 3))) (let ((sc1 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-28)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ e-6 1) arg-5 e-27))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-2 e-28 e-29)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-29 0) ((1) (let ((e-4 (vector-ref e-29 1))) (let ((e-8 (vector-ref e-29 2))) (let ((e-7 (vector-ref e-29 3))) (vector 1 (vector 2 e-5 e-28 e-4 e-8 e-7)))))) (else (let ((e-11 (vector-ref e-29 1))) (let ((e-12 (vector-ref e-29 2))) (let ((e-13 (vector-ref e-29 3))) (let ((e-14 (vector-ref e-29 4))) (let ((e-15 (vector-ref e-29 5))) (vector 0 (LibrariesC-45DataC-45SortedMap-branch4 e-5 e-28 e-11 e-12 e-13 e-14 e-15)))))))))))))) (else (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ e-6 1) arg-5 e-29))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 1 e-27 e-28 e-2)))) (else (let ((e-5 (vector-ref sc2 1))) (case (vector-ref e-27 0) ((1) (let ((e-4 (vector-ref e-27 1))) (let ((e-8 (vector-ref e-27 2))) (let ((e-7 (vector-ref e-27 3))) (vector 1 (vector 2 e-4 e-8 e-7 e-28 e-5)))))) (else (let ((e-11 (vector-ref e-27 1))) (let ((e-12 (vector-ref e-27 2))) (let ((e-13 (vector-ref e-27 3))) (let ((e-14 (vector-ref e-27 4))) (let ((e-15 (vector-ref e-27 5))) (vector 0 (LibrariesC-45DataC-45SortedMap-branch4 e-11 e-12 e-13 e-14 e-15 e-28 e-5)))))))))))))))))))) (else (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (let ((e-38 (vector-ref arg-6 5))) (let ((sc1 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-35)))) (cond ((equal? sc1 1) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ e-6 1) arg-5 e-34))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 0 (vector 2 e-2 e-35 e-36 e-37 e-38)))) (else (let ((e-5 (vector-ref sc2 1))) (vector 0 (LibrariesC-45DataC-45SortedMap-merge1 e-5 e-35 e-36 e-37 e-38))))))) (else (let ((sc2 (let ((e-5 (vector-ref arg-3 4))) ((e-5 arg-5) e-37)))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ e-6 1) arg-5 e-36))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-34 e-35 e-2 e-37 e-38)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45SortedMap-merge2 e-34 e-35 e-5 e-37 e-38))))))) (else (let ((sc3 (LibrariesC-45DataC-45SortedMap-treeDelete arg-3 (+ e-6 1) arg-5 e-38))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (vector 2 e-34 e-35 e-36 e-37 e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 0 (LibrariesC-45DataC-45SortedMap-merge3 e-34 e-35 e-36 e-37 e-5)))))))))))))))))))))))))))
(define LibrariesC-45DataC-45SortedMap-delete (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (cond ((equal? e-6 0) (let ((sc2 (LibrariesC-45DataC-45SortedMap-treeDelete e-5 0 arg-2 e-7))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (vector 1 e-5 0 e-2))) (else (vector 0 e-5)))))(else (let ((e-8 (- e-6 1))) (let ((sc1 (LibrariesC-45DataC-45SortedMap-treeDelete e-5 (+ e-8 1) arg-2 e-7))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 1 e-5 (+ e-8 1) e-2))) (else (let ((e-9 (vector-ref sc1 1))) (vector 1 e-5 e-8 e-9)))))))))))))))
(define LibrariesC-45DataC-45SortedSet-delete (lambda (arg-1 arg-2) (LibrariesC-45DataC-45SortedMap-delete arg-1 arg-2)))
(define LibrariesC-45DataC-45SortedMap-insertFrom (lambda (arg-3 ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (let ((e-2 (vector-ref arg-3 1))) (((((e-2 'erased) 'erased) csegen-790) eta-0) clam-0)))) ext-0 ext-1)))
(define LibrariesC-45DataC-45SortedMap-n--8137-5915-u--inserted (lambda (arg-2 arg-3 arg-4) (PreludeC-45Types-listBind (LibrariesC-45DataC-45SortedMap-toList arg-2) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-4) (LibrariesC-45DataC-45SortedMap-lookup e-2 arg-3)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45SortedMap-mergeWith (lambda (arg-2 arg-3 arg-4) (LibrariesC-45DataC-45SortedMap-insertFrom csegen-14 (LibrariesC-45DataC-45SortedMap-n--8137-5915-u--inserted arg-4 arg-3 arg-2) arg-3)))
(define LibrariesC-45DataC-45SortedMap-singleton (lambda (arg-2 arg-3 arg-4) (LibrariesC-45DataC-45SortedMap-insert arg-3 arg-4 (LibrariesC-45DataC-45SortedMap-empty arg-2))))
(define CompilerC-45Separate-n--8016-5041-u--addOne (lambda (arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45SortedMap-mergeWith csegen-3808 (LibrariesC-45DataC-45SortedMap-singleton csegen-4099 (CompilerC-45Separate-getNS e-2) (let ((u--ndef (cons e-2 e-3))) (cons u--ndef '()))) arg-1)))))
(define CompilerC-45Separate-splitByNS (lambda (ext-0) (LibrariesC-45DataC-45SortedMap-toList (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CompilerC-45Separate-n--8016-5041-u--addOne eta-0 eta-1))) csegen-5081 ext-0))))
(define DataC-45List1-u--C-62C-62C-61_Monad_List1 (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (DataC-45List1-appendl (arg-3 e-1) (PreludeC-45Types-listBind e-2 (lambda (eta-0) (DataC-45List1-forget (arg-3 eta-0)))))))))
(define CompilerC-45Separate-n--9239-6267-u--definitions (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (DataC-45List1-u--foldMap_Foldable_List1 csegen-57 (lambda (eta-0) eta-0) (DataC-45List1-u--C-62C-62C-61_Monad_List1 arg-3 (lambda (u--ns) (DataC-45List1-singleton (DataC-45Maybe-fromMaybe (lambda () '()) (LibrariesC-45DataC-45SortedMap-lookup u--ns arg-5))))))))
(define CompilerC-45Separate-n--9239-6268-u--dependencies (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45SortedSet-fromList csegen-5070 (PreludeC-45Types-listBind (DataC-45List1-forget arg-3) (lambda (u--ns) (PreludeC-45Types-listBind (LibrariesC-45DataC-45SortedSet-toList (DataC-45Maybe-fromMaybe (lambda () csegen-5071) (LibrariesC-45DataC-45SortedMap-lookup u--ns arg-7))) (lambda (u--depsNS) (let ((sc0 (LibrariesC-45DataC-45SortedMap-lookup u--depsNS arg-6))) (if (null? sc0) '() (let ((e-2 (unbox sc0))) (cons e-2 '())))))))))))
(define CompilerC-45Separate-n--9226-6183-u--mkUnit (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector arg-6 arg-7 (LibrariesC-45DataC-45SortedSet-delete arg-6 (CompilerC-45Separate-n--9239-6268-u--dependencies arg-1 arg-2 arg-7 arg-6 arg-5 arg-4 arg-3)) (CompilerC-45Separate-n--9239-6267-u--definitions arg-1 arg-2 arg-7 arg-6 arg-5 arg-4 arg-3))))
(define CompilerC-45Separate-n--9226-6184-u--withCUID (lambda (arg-1 arg-2 arg-4) (PreludeC-45Types-listBind (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-u--rangeFromTo_Range_Nat 0 (PreludeC-45TypesC-45List-lengthTR arg-4)) arg-4) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_List (cons (blodwen-toSignedInt e-2 63) e-3))))))))
(define CompilerC-45Separate-getCompilationUnits (lambda (arg-1 arg-2) (let ((u--defsByNS (LibrariesC-45DataC-45SortedMap-fromList csegen-4099 (CompilerC-45Separate-splitByNS arg-2)))) (let ((u--nsDeps (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45SortedMap-mergeWith csegen-3785 eta-0 eta-1))) csegen-5081 (PreludeC-45Types-listBind arg-2 (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45DataC-45SortedMap-singleton csegen-4099 (CompilerC-45Separate-getNS e-2) (LibrariesC-45DataC-45SortedSet-delete (CompilerC-45Separate-getNS e-2) (arg-1 e-3))))))))))) (let ((u--components (PreludeC-45TypesC-45List-reverse (LibrariesC-45DataC-45Graph-tarjan csegen-4099 u--nsDeps)))) (let ((u--nsMap (LibrariesC-45DataC-45SortedMap-fromList csegen-4099 (PreludeC-45Types-listBind (CompilerC-45Separate-n--9226-6184-u--withCUID arg-1 arg-2 u--components) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-listBind (DataC-45List1-forget e-3) (lambda (u--ns) (PreludeC-45Types-u--pure_Applicative_List (cons u--ns e-2))))))))))) (let ((u--units (PreludeC-45Types-listBind (CompilerC-45Separate-n--9226-6184-u--withCUID arg-1 arg-2 u--components) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--pure_Applicative_List (CompilerC-45Separate-n--9226-6183-u--mkUnit arg-1 arg-2 u--nsDeps u--nsMap u--defsByNS e-2 e-3)))))))) (vector u--units (LibrariesC-45DataC-45SortedMap-fromList csegen-5070 (PreludeC-45Types-listBind u--units (lambda (u--unit) (PreludeC-45Types-u--pure_Applicative_List (cons (let ((e-1 (vector-ref u--unit 0))) e-1) u--unit))))) u--nsMap))))))))
(define CompilerC-45SchemeC-45ChezSep-schFooter (lambda (ext-0) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "\xa;(collect 4)\xa;(blodwen-run-finalisers)" '())) ext-0)))
(define CompilerC-45SchemeC-45ChezSep-schHeader (lambda (arg-0 arg-1 ext-0) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "(import (chezscheme) (support)\xa;    " (cons (DataC-45String-unwords (PreludeC-45Types-listBind arg-1 (lambda (u--cu) (PreludeC-45Types-u--pure_Applicative_List (string-append "(" (string-append u--cu ")")))))) (cons ")\xa;(case (machine-type)\xa;  [(i3le ti3le a6le ta6le tarm64le) (load-shared-object \"libc.so.6\")]\xa;  [(i3osx ti3osx a6osx ta6osx tarm64osx tppc32osx tppc64osx) (load-shared-object \"libc.dylib\")]\xa;  [(i3nt ti3nt a6nt ta6nt) (load-shared-object \"msvcrt.dll\")]\xa;  [else (load-shared-object \"libc.so\")]\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45Types-listBind arg-0 (lambda (u--lib) (PreludeC-45Types-u--pure_Applicative_List (string-append "  (load-shared-object \"" (string-append (LibrariesC-45UtilsC-45String-escapeStringChez u--lib) "\")")))))) (cons ")\xa;" '())))))) ext-0)))
(define CoreC-45Core-writeFile (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-0 arg-1) world-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-0 e-6) clam-0))))))) eff-1) world-0)))))))))
(define CompilerC-45Separate-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 (lambda (arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (let ((e-4 (cdr arg-1))) ((e-4 arg-2) e-3)))))
(define CompilerC-45Separate-u--hashWithSalt_Hashable_CompilationUnitId (lambda (arg-0 arg-1) (CoreC-45Hash-u--hashWithSalt_Hashable_Int arg-0 arg-1)))
(define CompilerC-45Separate-u--hash_Hashable_CompilationUnitId (lambda (ext-0) (CompilerC-45Separate-u--hashWithSalt_Hashable_CompilationUnitId (blodwen-toSignedInt 5381 63) ext-0)))
(define CompilerC-45Separate-u--hashWithSalt_Hashable_C-40CompilationUnitC-32C-36defC-41 (lambda (arg-1 arg-2 arg-3) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1357 arg-1 arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1357 arg-1 arg-4541 arg-4544)))) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 (cons (lambda (arg-4535) (CompilerC-45Separate-u--hash_Hashable_CompilationUnitId arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CompilerC-45Separate-u--hashWithSalt_Hashable_CompilationUnitId arg-4541 arg-4544)))) arg-2 (LibrariesC-45DataC-45SortedSet-toList (let ((e-3 (vector-ref arg-3 2))) e-3))) (let ((e-4 (vector-ref arg-3 3))) e-4))))
(define CompilerC-45Separate-u--hash_Hashable_C-40CompilationUnitC-32C-36defC-41 (lambda (arg-1 ext-0) (CompilerC-45Separate-u--hashWithSalt_Hashable_C-40CompilationUnitC-32C-36defC-41 arg-1 (blodwen-toSignedInt 5381 63) ext-0)))
(define CompilerC-45Separate-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 (lambda (arg-1 ext-0) (CompilerC-45Separate-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 arg-1 (blodwen-toSignedInt 5381 63) ext-0)))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36aC-41C-124C-41 (lambda (arg-1 arg-2) (let ((e-3 (cdr arg-2))) (arg-1 e-3))))
(define CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-1))) ((1) csegen-5071) ((2) csegen-5071) (else (let ((e-8 (vector-ref arg-0 1))) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedCExp e-8))))))
(define CompilerC-45SchemeC-45ChezSep-compileToSS (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-getDirectives arg-0 (vector 0 ) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Chez-findLibs arg-0 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (CompilerC-45Common-copyLib eta-2)) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (CompilerC-45SchemeC-45Chez-chezVersion arg-1 eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CompilerC-45Common-getCompileData arg-0 0 0 arg-3 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-9 0))) e-0)))) (let ((u--ndefs (let ((e-2 (vector-ref e-9 2))) e-2))) (let ((u--cui (CompilerC-45Separate-getCompilationUnits (lambda (eta-3) (CompilerC-45Separate-u--nsRefs_HasNamespaces_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36aC-41C-124C-41 (lambda (eta-4) (CompilerC-45Separate-u--nsRefs_HasNamespaces_NamedDef eta-4)) eta-3)) u--ndefs))) (lambda (eta-3) (let ((act-6 (CoreC-45Directory-readDataFile arg-0 "chez/support-sep.ss" eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--supportHash (PreludeC-45Show-u--show_Show_Int (CoreC-45Hash-u--hash_Hashable_String e-10)))) (lambda (eta-4) (let ((act-7 (let ((act-7 (let ((act-7 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "support.hash")) eta-4))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-11 0) ((0) (vector 1 1)) (else (let ((e-12 (vector-ref e-11 1))) (vector 1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-12 u--supportHash)))))))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (cond ((equal? e-11 1) (let ((act-8 ((CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "support.ss") e-10) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else ((CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "support.hash") u--supportHash) eta-5))))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 ((PreludeC-45Basics-flip csegen-1298 (let ((e-1 (vector-ref u--cui 0))) e-1) (lambda (u--cu) (let ((u--chezLib (CompilerC-45SchemeC-45ChezSep-chezLibraryName u--cu))) (let ((u--cuHash (PreludeC-45Show-u--show_Show_Int (CompilerC-45Separate-u--hash_Hashable_C-40CompilationUnitC-32C-36defC-41 (cons (lambda (arg-4535) (CompilerC-45Separate-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 csegen-5044 arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CompilerC-45Separate-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32FCC-41C-32C-36defC-41C-44C-40C-40BuiltinC-46MkPairC-32FCC-41C-32C-36defC-41C-124C-41 csegen-5044 arg-4541 arg-4544)))) u--cu)))) (lambda (eta-6) (let ((act-9 (let ((act-9 (let ((act-9 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--chezLib "hash"))) eta-6))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-13 0) ((0) (vector 1 1)) (else (let ((e-14 (vector-ref e-13 1))) (vector 1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-14 u--cuHash)))))))) eff-0) eta-6))))))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (cond ((equal? e-13 1) (let ((act-10 (let ((act-10 (unbox arg-0))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-8) (let ((act-11 (csegen-5049 eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Chez.Structs" ) '()) eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (let ((u--imports (DataC-45String-unwords (PreludeC-45Types-listBind (LibrariesC-45DataC-45SortedSet-toList (let ((e-3 (vector-ref u--cu 2))) e-3)) (lambda (u--cuid) (PreludeC-45Types-u--pure_Applicative_List (string-append "(" (string-append (PreludeC-45Types-maybe (lambda () "unqualified") (lambda () (lambda (eta-10) (CompilerC-45SchemeC-45ChezSep-chezLibraryName eta-10))) (LibrariesC-45DataC-45SortedMap-lookup u--cuid (let ((e-2 (vector-ref u--cui 1))) e-2))) ")")))))))) (let ((u--exports (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (DataC-45List-catMaybes (PreludeC-45Types-listBind (let ((e-4 (vector-ref u--cu 3))) e-4) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-17 (cdr e-3))) (PreludeC-45Types-u--pure_Applicative_List (case (vector-ref e-17 0) ((1) '())(else (box (CompilerC-45SchemeC-45Common-schName e-2)))))))))))))) (let ((u--header (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons "(library (" eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-12) (cons u--chezLib eta-12)) (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-13) (cons ")\xa;" eta-13)) (lambda (eta-13) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-14) (cons "  (export " eta-14)) (lambda (eta-14) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--exports (lambda (eta-15) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-16) (cons ")\xa;" eta-16)) (lambda (eta-16) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-17) (cons "  (import (chezscheme) (support) " eta-17)) (lambda (eta-17) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-18) (cons u--imports eta-18)) (lambda (eta-18) (cons ")\xa;\xa;" eta-18)) eta-17)) eta-16)) eta-15)) eta-14)) eta-13)) eta-12)) eta-11)) eta-10)))) (let ((u--footer (lambda (eta-10) (cons ")" eta-10)))) (lambda (eta-10) (let ((act-13 ((CoreC-45Core-traverseC-39 (lambda (eta-11) (CompilerC-45SchemeC-45Chez-getFgnCall arg-0 e-15 e-16 e-8 eta-11)) (let ((e-4 (vector-ref u--cu 3))) e-4) '()) eta-10))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-14 ((CoreC-45Core-traverseC-39 (lambda (eta-12) (CompilerC-45SchemeC-45Common-getScheme arg-0 csegen-862 csegen-5050 csegen-5051 eta-12)) (let ((e-4 (vector-ref u--cu 3))) e-4) '()) eta-11))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-12) (let ((act-15 ((CoreC-45Core-traverseC-39 (lambda (eta-13) (lambda (eta-14) (PreludeC-45IO-u--map_Functor_IO csegen-2540 (lambda (eta-15) (CompilerC-45SchemeC-45Chez-loadLib arg-0 arg-2 eta-13 eta-15)) eta-14))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-13) (Builtin-fst eta-13)) e-17) '()) eta-12))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-13) (let ((act-16 (CoreC-45ContextC-45Log-log arg-0 "compiler.scheme.chez" 3 (lambda () (string-append "Generating code for " u--chezLib)) eta-13))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((act-17 ((CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--chezLib "ss")) (LibrariesC-45DataC-45StringC-45Builder-build (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-14) eta-14) (PreludeC-45TypesC-45List-tailRecAppend (cons u--header '()) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-14) (Builtin-snd eta-14)) e-17) (PreludeC-45TypesC-45List-tailRecAppend e-18 (PreludeC-45TypesC-45List-tailRecAppend e-19 (cons u--footer '())))))))) eta-13))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else ((CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--chezLib "hash")) u--cuHash) eta-13)))))))))) eff-0) eta-12)))))))) eff-0) eta-11)))))))) eff-0) eta-10)))))))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7))))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (vector 1 (cons u--chezLib e-13)))))))) eff-0) eta-6)))))))))) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CompilerC-45SchemeC-45Common-schExp csegen-862 csegen-5050 csegen-5051 0 u--ctm) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-11 ((CoreC-45Core-writeFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "mainprog.ss") (LibrariesC-45DataC-45StringC-45Builder-build (LibrariesC-45DataC-45StringC-45Builder-sepBy "\xa;" (cons (lambda (eta-8) (CompilerC-45SchemeC-45ChezSep-schHeader (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-9) (Builtin-snd eta-9)) e-6) (PreludeC-45Types-listBind e-13 (lambda (u--lib) (PreludeC-45Types-u--pure_Applicative_List (let ((e-0 (car u--lib))) e-0)))) eta-8)) (cons (lambda (eta-8) (cons "(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))" eta-8)) (cons e-14 (cons (lambda (eta-8) (CompilerC-45SchemeC-45ChezSep-schFooter eta-8)) '()))))))) eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (vector 1 (cons e-11 e-13)))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4))))))))) eff-0) eta-3))))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45ChezSep-startChez (lambda (arg-0 arg-1 arg-2) (string-append CompilerC-45SchemeC-45Chez-startChezPreamble (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "export LD_LIBRARY_PATH=\"$DIR/" (cons arg-1 (cons ":$LD_LIBRARY_PATH\"\xa;export DYLD_LIBRARY_PATH=\"$DIR/" (cons arg-1 (cons ":$DYLD_LIBRARY_PATH\"\xa;\xa;\"" (cons arg-0 (cons "\" -q   --libdirs \"$DIR/" (cons arg-1 (cons "\"   --program \"$DIR/" (cons arg-2 (cons "\"   \"$@\"" '())))))))))))))))
(define CompilerC-45SchemeC-45ChezSep-makeSh (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45Core-writeFile arg-1 (CompilerC-45SchemeC-45ChezSep-startChez arg-0 arg-2 arg-3))))
(define CompilerC-45SchemeC-45ChezSep-startChezCmd (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "@echo off\xa;\xa;rem " (cons (CompilerC-45Generated-generatedString "ChezSep") (cons "\xa;\xa;set APPDIR=%~dp0\xa;set PATH=%APPDIR%" (cons arg-1 (cons ";%PATH%\xa;\xa;\"" (cons arg-0 (cons "\" -q   --libdirs \"%APPDIR%" (cons arg-1 (cons "\"   --program \"%APPDIR%" (cons arg-2 (cons "\"   %*" '()))))))))))))))
(define CompilerC-45SchemeC-45ChezSep-startChezWinSh (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "#!/bin/sh\xa;# " (cons (CompilerC-45Generated-generatedString "ChezSep") (cons "\xa;\xa;set -e # exit on any error\xa;\xa;DIR=$(dirname \"$(readlink -f -- \"$0\" || cygpath -a -- \"$0\")\")\xa;PATH=\"$DIR/" (cons arg-1 (cons ":$PATH\"\xa;\xa;\"" (cons arg-0 (cons "\" --program \"$DIR/" (cons arg-2 (cons "\" \"$@\"\xa;\"" (cons arg-0 (cons "\" -q   --libdirs \"$DIR/" (cons arg-1 (cons "\"   --program \"$DIR/" (cons arg-2 (cons "\"   \"$@\"" '()))))))))))))))))))
(define CompilerC-45SchemeC-45ChezSep-makeShWindows (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--cmdFile (string-append arg-1 ".cmd"))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-writeFile u--cmdFile (CompilerC-45SchemeC-45ChezSep-startChezCmd arg-0 arg-2 arg-3)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Core-writeFile arg-1 (CompilerC-45SchemeC-45ChezSep-startChezWinSh arg-0 arg-2 arg-3)) eta-0))))))))
(define CompilerC-45SchemeC-45ChezSep-touch (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Escaped-system csegen-82 (cons "touch" (cons arg-0 '()))) world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0)))))
(define CompilerC-45SchemeC-45ChezSep-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (csegen-1310 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-1311 (let ((u--appDirSh (string-append arg-6 "_app"))) (let ((u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 u--appDirSh))) (lambda (eta-0) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 (CoreC-45Directory-mkdirAll u--appDirRel world-0))) (vector 1 act-2))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (CompilerC-45SchemeC-45Chez-findChez eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CompilerC-45SchemeC-45ChezSep-compileToSS arg-1 e-7 u--appDirRel arg-5 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((act-5 (CoreC-45ContextC-45Log-logTime arg-1 2 (lambda () "Make SO") (lambda (clam-1) (cond ((equal? arg-0 1) (let ((act-5 (cond ((equal? e-2 1) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "compiler.scheme.chez" 3 (lambda () "Compiling support") clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else ((CompilerC-45SchemeC-45ChezSep-compileChezLibrary e-7 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel "support.ss")) clam-1))))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 ((CompilerC-45SchemeC-45ChezSep-compileChezLibraries e-7 u--appDirRel (PreludeC-45Types-listBind e-3 (lambda (u--lib) (PreludeC-45Types-listBind (PreludeC-45Interfaces-guard csegen-1509 (let ((e-4 (cdr u--lib))) e-4)) (lambda (_-10649) (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (let ((e-0 (car u--lib))) e-0) "ss")))))))) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 ((PreludeC-45Basics-flip csegen-63 e-3 (lambda (u--lib) (lambda (eta-2) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "compiler.scheme.chez" 3 (lambda () (string-append "Touching " (let ((e-0 (car u--lib))) e-0))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else ((CompilerC-45SchemeC-45ChezSep-touch (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (let ((e-0 (car u--lib))) e-0) "so"))) eta-2))))))) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else ((CompilerC-45SchemeC-45ChezSep-compileChezProgram e-7 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel "mainprog.ss")) clam-1))))))))))) (else (vector 1 (vector 0 ))))) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 arg-6))) (let ((u--launchTargetSh (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirSh (LibrariesC-45UtilsC-45Path-C-60C-46C-62 "mainprog" (cond ((equal? arg-0 1) "so") (else "ss")))))) (let ((act-6 (let ((sc7 SystemC-45Info-isWindows)) (cond ((equal? sc7 1) ((CompilerC-45SchemeC-45ChezSep-makeShWindows e-7 u--outShRel u--appDirSh u--launchTargetSh) clam-0)) (else ((CompilerC-45SchemeC-45ChezSep-makeSh e-7 u--outShRel u--appDirSh u--launchTargetSh) clam-0)))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 u--outShRel (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-7))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (vector 1 (box u--outShRel)))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45ChezSep-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CompilerC-45SchemeC-45ChezSep-compileExpr 0 arg-0 arg-1 arg-2 arg-2 arg-3 "_tmpchez" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-5006 (let ((e-1 (unbox e-5))) (let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45Escaped-system csegen-82 (cons e-1 '())) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45ChezSep-codegenChezSep (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CompilerC-45SchemeC-45ChezSep-compileExpr 1 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45ChezSep-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) '() '())))
(define CompilerC-45SchemeC-45Gambit-gambitPrim (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((6) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (case (vector-ref e-1 0) ((12) (let ((e-20 (vector-ref e-1 2))) (case (vector-ref e-20 0) ((10) (let ((e-21 (vector-ref e-20 1))) (if (null? e-2) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))) (let ((e-24 (cdr e-2))) (if (null? e-24) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))) (let ((e-27 (cdr e-24))) (if (null? e-27) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (case (vector-ref e-32 0) ((12) (let ((e-35 (vector-ref e-32 2))) (case (vector-ref e-35 0) ((10) (let ((e-36 (vector-ref e-35 1))) (if (null? e-33) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))) (let ((e-39 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4899 0 e-29) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons e-21 eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "-" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-36 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))))) ((7) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-42 (car arg-3))) (let ((e-43 (cdr arg-3))) (case (vector-ref e-42 0) ((12) (let ((e-67 (vector-ref e-42 2))) (case (vector-ref e-67 0) ((10) (let ((e-68 (vector-ref e-67 1))) (if (null? e-43) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-71 (cdr e-43))) (if (null? e-71) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-74 (cdr e-71))) (if (null? e-74) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-76 (car e-74))) (let ((e-77 (cdr e-74))) (if (null? e-77) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (case (vector-ref e-79 0) ((12) (let ((e-82 (vector-ref e-79 2))) (case (vector-ref e-82 0) ((10) (let ((e-83 (vector-ref e-82 1))) (if (null? e-80) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-86 (cdr e-80))) (if (null? e-86) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-92 (cdr e-89))) (if (null? e-92) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4899 0 e-76) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-2 eta-3 eta-4)))) csegen-4899 0 e-88) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons e-68 eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons "-" eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons e-83 eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons "-set! " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons " " eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))))))))))))))))))) ((10) (if (null? arg-3) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "\"gambit\"" u--xs)))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))(else (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-gambitPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4899 arg-1 arg-2 arg-3)))))
(define CompilerC-45SchemeC-45Gambit-mkArgs (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((18) (cons (cons (vector 2 "farg" arg-0) 0) (CompilerC-45SchemeC-45Gambit-mkArgs arg-0 e-3)))(else (cons (cons (vector 2 "farg" arg-0) 1) (CompilerC-45SchemeC-45Gambit-mkArgs (bs+ arg-0 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Gambit-notWorld (lambda (arg-0) (case (vector-ref arg-0 0) ((18) 0)(else 1))))
(define CompilerC-45SchemeC-45Gambit-n--12039-6324-u--funTySpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((19) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-0 0) ((18) (CompilerC-45SchemeC-45Gambit-n--12039-6324-u--funTySpec arg-0 arg-1 arg-2 arg-3 e-1))(else (CompilerC-45SchemeC-45Gambit-n--12039-6324-u--funTySpec arg-0 arg-1 arg-2 (cons e-0 arg-3) e-1))))))(else (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-cftySpec arg-2 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-cftySpec arg-2 eta-2)) (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-notWorld eta-2)) arg-3)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(function (" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-6) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ") " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))
(define CompilerC-45SchemeC-45Gambit-cftySpec (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) csegen-4920) ((1) csegen-4922) ((3) csegen-4924) ((4) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "short" u--xs))))) ((5) csegen-4922) ((6) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "long" u--xs))))) ((7) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-char" eta-1))))) ((8) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-short" eta-1))))) ((9) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-int" eta-1))))) ((10) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "unsigned-long" eta-1))))) ((11) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "UTF-8-string" eta-1))))) ((12) csegen-4940) ((13) csegen-4924) ((14) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "(pointer void)" eta-1))))) ((20) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Gambit-cftySpec arg-0 e-0))) ((21) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons e-1 eta-2)) (lambda (eta-2) (cons "*/nonnull" eta-2)) eta-1)))))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45SchemeC-45Gambit-n--12039-6324-u--funTySpec e-4 e-3 arg-0 (cons e-3 '()) e-4))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Can't pass argument of type " (string-append (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Gambit-n--13810-7922-u--showFld (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-cftySpec CoreC-45FC-emptyFC e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons e-2 eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) ext-0)))))))))
(define CompilerC-45SchemeC-45Gambit-mkStruct (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((21) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 eta-1)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-1) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-22 e-0 e-6))) (cond ((equal? sc3 1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-2) eta-2) e-5))) (else (let ((act-3 (let ((act-3 (set-box! arg-0 (cons e-0 e-6)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Gambit-n--13810-7922-u--showFld e-1 e-0 arg-0 eta-2 eta-3))) e-1 '()) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-4) eta-4) e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "(define-c-struct " eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-0 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-8) (lambda (u--xs) (cons ")\xa;" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) clam-0)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 e-2))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 csegen-4896 (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 e-3) eta-1)) (CompilerC-45SchemeC-45Gambit-mkStruct arg-0 e-4) eta-0)))))(else csegen-4898))))
(define CompilerC-45SchemeC-45Gambit-n--11918-6164-u--funTySpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((19) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-0 0) ((18) (CompilerC-45SchemeC-45Gambit-n--11918-6164-u--funTySpec arg-0 arg-1 arg-2 arg-3 e-1))(else (CompilerC-45SchemeC-45Gambit-n--11918-6164-u--funTySpec arg-0 arg-1 arg-2 (cons e-0 arg-3) e-1))))))(else (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-cType arg-2 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-cType arg-2 eta-2)) (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-notWorld eta-2)) arg-3)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " (*)(" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy ", " e-6) (lambda (u--xs) (cons ")" u--xs)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))
(define CompilerC-45SchemeC-45Gambit-cType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) csegen-4920) ((1) csegen-4922) ((11) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "char *" u--xs))))) ((12) csegen-4940) ((13) csegen-4924) ((14) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "void *" u--xs))))) ((20) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Gambit-cType arg-0 e-0))) ((21) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "struct " eta-2)) (lambda (eta-2) (cons e-1 eta-2)) eta-1)))))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45SchemeC-45Gambit-n--11918-6164-u--funTySpec e-4 e-3 arg-0 (cons e-3 '()) e-4))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Can't pass argument of type " (string-append (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Gambit-handleRet (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConstructor csegen-4899 (vector 1 (vector 0 "")) (box 0) '() eta-2)) eta-1)) eta-0)))(else arg-1))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6600-u--applyLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-2) (CompilerC-45SchemeC-45Gambit-n--12386-6600-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-8 (lambda (u--xs) (cons " #f)" u--xs)) eta-1)) eta-0)) e-3) (let ((e-6 (unbox e-2))) (CompilerC-45SchemeC-45Gambit-n--12386-6600-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-8 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)) e-3))))))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6606-u--mkNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((18) (cons '() (CompilerC-45SchemeC-45Gambit-n--12386-6606-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))(else (cons (box (lambda (eta-0) (cons (string-append "cb" (PreludeC-45Show-u--show_Show_Int arg-8)) eta-0))) (CompilerC-45SchemeC-45Gambit-n--12386-6606-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6605-u--mkFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--argns (CompilerC-45SchemeC-45Gambit-n--12386-6606-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 0 arg-8))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(lambda (" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-2) eta-2) u--argns)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Gambit-n--12386-6600-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 u--argns) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6604-u--callback (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((19) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (CompilerC-45SchemeC-45Gambit-n--12386-6604-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-0 arg-9) e-1))))(else (let ((u--args (PreludeC-45TypesC-45List-reverse arg-9))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-cftySpec arg-5 eta-1)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-notWorld eta-1)) u--args) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Gambit-cftySpec arg-5 arg-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (CompilerC-45SchemeC-45Gambit-n--12386-6605-u--mkFun arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--args arg-10 arg-8) (cons e-5 e-6)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6601-u--buildArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-3 0) ((19) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (let ((u--arg (CompilerC-45SchemeC-45Common-schName e-2))) (let ((u--schemeWrap (arg-3 (LibrariesC-45DataC-45StringC-45Builder-build u--arg)))) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-n--12386-6604-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--arg (cons e-4 '()) e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (vector 1 (cons (lambda (eta-1) (cons u--schemeWrap eta-1)) (box (vector u--arg u--schemeWrap e-8 e-10 e-9))))))))))) eff-0) eta-0)))))))))))(else (lambda (eta-0) (vector 1 (cons (CompilerC-45SchemeC-45Common-schName e-2) '())))))))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6602-u--buildCFunWrapDeclaration (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons "\xa;(c-declare #<<c-declare-end\xa;" eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-9 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-8 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy ", " arg-10) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons ");" eta-6)) (lambda (eta-6) (cons "\xa;c-declare-end\xa;)\xa;" eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0)) ext-0)))
(define DataC-45List-replaceWhen (lambda (arg-1 arg-2 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--c) (let ((sc0 (arg-1 u--c))) (cond ((equal? sc0 1) arg-2) (else u--c)))) arg-3)))
(define DataC-45List-replaceOn (lambda (arg-1 arg-2 ext-0 ext-1) (DataC-45List-replaceWhen (lambda (arg-0) (let ((e-1 (car arg-1))) ((e-1 arg-0) arg-2))) ext-0 ext-1)))
(define CompilerC-45SchemeC-45Gambit-n--12386-6607-u--replaceChar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (PreludeC-45Types-fastPack (DataC-45List-replaceOn csegen-17 arg-8 arg-9 (PreludeC-45Types-fastUnpack ext-0)))))
(define CompilerC-45SchemeC-45Gambit-n--12386-6603-u--buildCWrapperDefs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((u--box (lambda (eta-0) (cons (string-append e-1 "-box") eta-0)))) (let ((u--setBox (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "\xa; (set-box! " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--box (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-2 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))) (let ((u--cWrapName (CompilerC-45SchemeC-45Gambit-n--12386-6607-u--replaceChar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 #\- #\_ e-1))) (let ((u--boxDef (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "\xa;(define " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--box (lambda (eta-2) (cons " (box #f))\xa;" eta-2)) eta-1)) eta-0)))) (let ((u--args (lambda (clam-0) (let ((sc0 (PreludeC-45Types-u--C-62_Ord_Nat (PreludeC-45TypesC-45List-lengthTR e-3) 0))) (cond ((equal? sc0 1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons " " eta-0)) (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--i) (lambda (eta-0) (cons (string-append "farg-" (PreludeC-45Show-u--show_Show_Integer u--i)) eta-0))) (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-1070 0 (- (PreludeC-45TypesC-45List-lengthTR e-3) 1)))) clam-0)) (else (cons "" clam-0))))))) (let ((u--cWrapDef (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "\xa;(c-define " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "(" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons e-1 eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--args (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons ")" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " (" eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-3) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons ")" eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons " " eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-4 (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons " \"" eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-12) (cons u--cWrapName eta-12)) (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-13) (cons "\"" eta-13)) (lambda (eta-13) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-14) (cons " \"\"" eta-14)) (lambda (eta-14) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-15) (cons "\xa; ((unbox " eta-15)) (lambda (eta-15) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--box (lambda (eta-16) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-17) (cons ")" eta-17)) (lambda (eta-17) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--args (lambda (eta-18) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-19) (cons ")" eta-19)) (lambda (eta-19) (cons "\xa;)\xa;" eta-19)) eta-18)) eta-17)) eta-16)) eta-15)) eta-14)) eta-13)) eta-12)) eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)) eta-1)) eta-0)))) (vector u--setBox u--boxDef u--cWrapDef)))))))))))))
(define CompilerC-45SchemeC-45Gambit-cCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-cftySpec arg-2 (Builtin-snd eta-0))) arg-6 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45SchemeC-45Gambit-cftySpec arg-2 arg-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Gambit-n--12386-6601-u--buildArg arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-2)) arg-6 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CompilerC-45SchemeC-45Gambit-cType arg-2 (Builtin-snd eta-3))) arg-6 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CompilerC-45SchemeC-45Gambit-cType arg-2 arg-7) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--cWrapperDefs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (CompilerC-45SchemeC-45Gambit-n--12386-6603-u--buildCWrapperDefs arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-4)) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-4) (Builtin-snd eta-4)) e-7)))) (let ((u--cFunWrapDeclaration (lambda (eta-4) (CompilerC-45SchemeC-45Gambit-n--12386-6602-u--buildCFunWrapDeclaration arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (lambda (eta-5) (cons arg-3 eta-5)) e-9 e-8 eta-4)))) (let ((u--wrapDeclarations (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--cFunWrapDeclaration (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) (let ((e-1 (vector-ref eta-6 1))) e-1)) u--cWrapperDefs) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) (let ((e-2 (vector-ref eta-6 2))) e-2)) u--cWrapperDefs) eta-5)) eta-4)))) (let ((u--setBoxes (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-4) (let ((e-0 (vector-ref eta-4 0))) e-0)) u--cWrapperDefs))) (let ((u--call (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons " ((c-lambda (" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-5) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons ") " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons " " eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-showB csegen-493 arg-3 eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons ") " eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-12) (Builtin-fst eta-12)) e-7)) (lambda (u--xs) (cons ")" u--xs)) eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)))) (let ((u--body (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--setBoxes (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons "\xa;" eta-6)) u--call eta-5)) eta-4)))) (lambda (eta-4) (vector 1 (case (vector-ref arg-7 0) ((20) (cons (CompilerC-45SchemeC-45Gambit-handleRet arg-7 u--body) u--wrapDeclarations))(else (cons u--body u--wrapDeclarations))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Gambit-schemeCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--call (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons arg-1 eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (CompilerC-45SchemeC-45Common-schName eta-4)) arg-2)) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))) (lambda (clam-0) (case (vector-ref arg-3 0) ((20) (vector 1 u--call))(else (vector 1 u--call)))))))
(define CompilerC-45SchemeC-45Gambit-n--13368-7530-u--fnWrapName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (string-append arg-7 (string-append "-" (string-append arg-6 "-cFunWrap")))))
(define CompilerC-45SchemeC-45Gambit-case--useCC-7569 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) eta-0)) (let ((e-2 (unbox arg-6))) (if (null? e-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) eta-0)) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (cond ((equal? e-5 "scheme,gambit") (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) clam-0) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-schemeCall arg-3 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-1) arg-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons '() (cons e-7 (lambda (u--xs) (cons "" u--xs)))))))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) clam-0))))))) ((equal? e-5 "scheme") (lambda (clam-1) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) clam-1) (let ((e-12 (car e-6))) (let ((e-13 (cdr e-6))) (if (null? e-13) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-schemeCall arg-3 e-12 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-1) arg-0) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons '() (cons e-7 (lambda (u--xs) (cons "" u--xs)))))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) clam-1))))))) ((equal? e-5 "C") (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) eta-0)) (let ((e-16 (car e-6))) (let ((e-17 (cdr e-6))) (if (null? e-17) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) eta-0)) (let ((e-19 (car e-17))) (let ((e-20 (cdr e-17))) (lambda (clam-2) (if (null? e-20) (let ((act-1 (CompilerC-45SchemeC-45Gambit-cCall arg-5 arg-4 arg-3 e-16 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-n--13368-7530-u--fnWrapName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-16 eta-0)) e-19 arg-1 arg-0 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (vector 1 (cons (box e-19) (cons e-4 e-3)))))))) eff-0) clam-2))))) (let ((e-24 (cdr e-20))) (if (null? e-24) (let ((act-1 (CompilerC-45SchemeC-45Gambit-cCall arg-5 arg-4 arg-3 e-16 (lambda (eta-0) (CompilerC-45SchemeC-45Gambit-n--13368-7530-u--fnWrapName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-16 eta-0)) e-19 arg-1 arg-0 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (vector 1 (cons (box e-19) (cons e-4 e-3)))))))) eff-0) clam-2))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) clam-2))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-3 arg-2) eta-0)))))))))))
(define CompilerC-45SchemeC-45Gambit-useCC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (CompilerC-45SchemeC-45Gambit-case--useCC-7569 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (CompilerC-45Common-parseCC (cons "scheme,gambit" csegen-4884) arg-3))))
(define CompilerC-45SchemeC-45Gambit-schFgnDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((u--argns (CompilerC-45SchemeC-45Gambit-mkArgs 0 e-1))) (let ((u--allargns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) u--argns))) (let ((u--useargns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (Builtin-snd eta-0)) u--argns)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Gambit-mkStruct arg-2 eta-1)) e-1 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Gambit-mkStruct arg-2 e-2) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CompilerC-45SchemeC-45Gambit-useCC arg-0 arg-1 arg-3 e-0 (DataC-45List-u--zip_Zippable_List u--useargns e-1) e-2) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-u--full_HasNames_Name (let ((e-43 (vector-ref e-10 0))) e-43) arg-4 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons e-4 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) eta-6) e-5) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-8 (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-9) (cons "(define " eta-9)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-11) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons " (lambda (" eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-12) (CompilerC-45SchemeC-45Common-schName eta-12)) u--allargns)) (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-13) (cons ") " eta-13)) (lambda (eta-13) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-9 (lambda (u--xs) (cons "))\xa;" u--xs)) eta-13)) eta-12)) eta-11)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5))))))) eff-0) eta-3)))))))) eff-0) clam-0)))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))(else csegen-4893))))
(define CompilerC-45SchemeC-45Gambit-getFgnCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Gambit-schFgnDef arg-0 arg-1 arg-2 e-6 e-2 e-7)))))))
(define CompilerC-45SchemeC-45Gambit-schHeader (lambda (ext-0) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons ";; " (cons (CompilerC-45Generated-generatedString "Gambit") (cons "\xa;(declare (block)\xa;  (inlining-limit 450)\xa;  (standard-bindings)\xa;  (extended-bindings)\xa;  (not safe)\xa;  (optimize-dead-definitions))\xa;" '())))) ext-0)))
(define CompilerC-45SchemeC-45Gambit-compileToSCM (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CompilerC-45Common-getCompileData arg-0 0 0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ndefs (let ((e-2 (vector-ref e-5 2))) e-2))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-5 0))) e-0)))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Gambit.Loaded" ) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Gambit.Structs" ) '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CompilerC-45SchemeC-45Gambit-getFgnCall arg-0 e-7 e-8 eta-4)) u--ndefs '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CompilerC-45OptsC-45ToplevelConstants-sortDefs u--ndefs) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-3 (cdr e-10))) (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (CompilerC-45SchemeC-45Common-getScheme arg-0 e-3 (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (CompilerC-45SchemeC-45Gambit-gambitPrim e-3 eta-6 eta-7 eta-8)))) csegen-4899 eta-5)) u--ndefs '()) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--code (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) eta-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-6) (Builtin-snd eta-6)) e-9)) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) eta-6) e-11) eta-5)))) (lambda (eta-5) (let ((act-8 ((CompilerC-45SchemeC-45Common-schExp e-3 (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (CompilerC-45SchemeC-45Gambit-gambitPrim e-3 eta-6 eta-7 eta-8)))) csegen-4899 0 u--ctm) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (CoreC-45Directory-readDataFile arg-0 "gambit/support.scm" eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (CoreC-45Context-getDirectives arg-0 (vector 3 ) eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-11 (CompilerC-45Common-getExtraRuntime e-14 eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 (CoreC-45Directory-readDataFile arg-0 "gambit/foreign.scm" eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (let ((u--scm (LibrariesC-45DataC-45StringC-45Builder-sepBy "\xa;" (cons (lambda (eta-10) (CompilerC-45SchemeC-45Gambit-schHeader eta-10)) (cons (lambda (eta-10) (cons e-13 eta-10)) (cons (lambda (eta-10) (cons e-15 eta-10)) (cons (lambda (eta-10) (cons e-16 eta-10)) (cons u--code (cons e-12 '()))))))))) (lambda (eta-10) (let ((act-13 (let ((act-13 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-2 (LibrariesC-45DataC-45StringC-45Builder-build u--scm)) eta-10))) (vector 1 act-13)))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-17 0) ((1) (vector 1 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-11) (Builtin-fst eta-11)) e-9))) (else (let ((e-18 (vector-ref e-17 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-2 e-18) clam-1))))))) eff-0) eta-10))))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))) eff-0) clam-0))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define DataC-45List-singleton (lambda (arg-1) (cons arg-1 '())))
(define CompilerC-45SchemeC-45Gambit-findGSC (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "GAMBIT_GSC") ext-0))) (PreludeC-45Types-maybe (lambda () (cons "/usr/bin/env" (cons "gsc" '()))) (lambda () (lambda (eta-0) (DataC-45List-singleton eta-0))) act-1))))
(define CompilerC-45SchemeC-45Gambit-findGSCBackend (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "GAMBIT_GSC_BACKEND") ext-0))) (if (null? act-1) '() (let ((e-2 (unbox act-1))) (cons "-cc" (cons e-2 '())))))))
(define CompilerC-45SchemeC-45Gambit-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--srcPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 "scm")))) (let ((u--execPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (lambda (eta-0) (let ((act-1 (CompilerC-45SchemeC-45Gambit-compileToSCM arg-0 arg-4 u--srcPath eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Directory-findLibraryFile arg-0 eta-2 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-6) (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-6 "a")) (DataC-45List-nub csegen-22 e-5)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (CompilerC-45SchemeC-45Gambit-findGSC eta-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 (CompilerC-45SchemeC-45Gambit-findGSCBackend eta-3))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-getDirectives arg-0 (vector 3 ) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--gscCompileOpts (let ((sc5 (DataC-45List-find (lambda (arg-6) (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-6 "C")) e-9))) (if (null? sc5) (PreludeC-45TypesC-45List-tailRecAppend e-8 (PreludeC-45TypesC-45List-tailRecAppend (cons "-exe" (cons "-cc-options" (cons "-Wno-implicit-function-declaration" (cons "-ld-options" '())))) e-6)) (cons "-c" '()))))) (let ((u--cmd (PreludeC-45TypesC-45List-tailRecAppend e-7 (PreludeC-45TypesC-45List-tailRecAppend u--gscCompileOpts (cons "-o" (cons u--execPath (cons u--srcPath '()))))))) (lambda (eta-5) (let ((act-6 (let ((act-6 ((SystemC-45Escaped-system csegen-82 u--cmd) eta-5))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 0))) (cond ((equal? sc6 1) (vector 1 (box u--execPath))) (else (vector 1 '()))))))) eff-0) eta-5)))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))
(define CompilerC-45SchemeC-45Gambit-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CompilerC-45SchemeC-45Gambit-compileExpr arg-0 arg-1 arg-2 arg-2 arg-3 "_tmpgambit") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "compileExpr returned Nothing") clam-0) (let ((e-1 (unbox e-5))) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45Escaped-system csegen-82 (cons e-1 '())) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Gambit-codegenGambit (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45SchemeC-45Gambit-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Gambit-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) '() '())))
(define CompilerC-45ESC-45Javascript-htmlFooter (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "\xa;    </script>\xa;  </body>\xa;</html>" '())))
(define CompilerC-45ESC-45Javascript-htmlHeader (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "<html>\xa;  <head>\xa;    <meta charset='utf-8'>\xa;  </head>\xa;  <body>\xa;    <script type='text/javascript'>\xa;" '())))
(define CompilerC-45ESC-45Javascript-addHeaderAndFooter (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (DataC-45String-toLower eta-0)) (LibrariesC-45UtilsC-45Path-extension arg-0)))) (if (null? sc0) arg-1 (let ((e-1 (unbox sc0))) (cond ((equal? e-1 "html") (string-append CompilerC-45ESC-45Javascript-htmlHeader (string-append arg-1 CompilerC-45ESC-45Javascript-htmlFooter)))(else arg-1)))))))
(define CompilerC-45ESC-45State-addRef (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 e-4 e-10 (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-2 e-6) e-7 e-8 e-9)))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45ESC-45Doc-n--3481-2782-u--go (lambda (arg-0) (case (vector-ref arg-0 0) ((0) '()) ((1) '()) ((2) '()) ((3) '()) ((4) (let ((e-1 (vector-ref arg-0 1))) (cons e-1 '()))) ((5) (let ((e-3 (vector-ref arg-0 2))) (CompilerC-45ESC-45Doc-n--3481-2782-u--go e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45ESC-45Doc-n--3481-2782-u--go e-4) (CompilerC-45ESC-45Doc-n--3481-2782-u--go e-5))))))))
(define CompilerC-45ESC-45Doc-compact (lambda (ext-0) (PreludeC-45Types-fastConcat (CompilerC-45ESC-45Doc-n--3481-2782-u--go ext-0))))
(define CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (lambda (arg-0 arg-1) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 (vector 4 " ")) arg-1)))
(define CompilerC-45ESC-45Doc-softEq (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (vector 2 ) (vector 4 "=")) (vector 2 )))
(define CompilerC-45ESC-45Codegen-constant (lambda (arg-0 arg-1) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 4 "const") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-0 CompilerC-45ESC-45Doc-softEq) arg-1) (vector 4 ";")))))
(define CompilerC-45ESC-45Doc-block (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4846 (lambda (eta-0) eta-0) (cons (vector 4 "{") (cons (vector 5 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (vector 1 ) arg-0)) (cons (vector 1 ) (cons (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "}") '())))))))
(define CompilerC-45ESC-45Codegen-function (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 4 "function") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-app arg-0 arg-1) (vector 2 )) (CompilerC-45ESC-45Doc-block arg-2)))))
(define CompilerC-45NoMangle-isNoMangle (lambda (arg-0 arg-1) (LibrariesC-45DataC-45NameMap-lookup arg-1 arg-0)))
(define CompilerC-45ESC-45State-keepRefName (lambda (arg-0 arg-1) (cond ((equal? arg-1 2) 0)(else 1))))
(define CompilerC-45ESC-45State-nextRef (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 (bs+ e-4 1 63) e-10 e-6 e-7 e-8 e-9)))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 (let ((e-4 (vector-ref e-5 4))) e-4))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45State-registerRef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (let ((sc2 (CompilerC-45ESC-45State-keepRefName arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)))) (cond ((equal? sc2 1) 1) (else (DataC-45Maybe-isJust (CompilerC-45NoMangle-isNoMangle (let ((e-9 (vector-ref e-5 9))) e-9) arg-1))))))) (cond ((equal? sc1 1) (let ((u--v (vector 0 arg-1))) (lambda (eta-0) (let ((act-2 ((CompilerC-45ESC-45State-addRef arg-0 arg-1 u--v) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 u--v))))))) (else (lambda (eta-0) (let ((act-2 (CompilerC-45ESC-45State-nextRef arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45ESC-45State-addRef arg-0 arg-1 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45State-getOrRegisterRef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-6 (vector-ref e-5 6))) e-6))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CompilerC-45ESC-45State-registerRef arg-0 arg-1 clam-0) (let ((e-2 (unbox e-5))) (vector 1 e-2)))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Doc-hsep (lambda (ext-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4846 (lambda (eta-0) eta-0) (DataC-45List-intersperse (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc " ") ext-0))))
(define CompilerC-45ESC-45Doc-n--3516-2820-u--nSpaces (lambda (arg-0) (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-0 #\ ))))
(define CompilerC-45ESC-45Doc-n--3516-2819-u--go (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) '()) ((1) (cons "\xa;" (cons arg-0 '()))) ((2) (cons " " '())) ((3) (let ((e-0 (vector-ref arg-1 1))) (cons "/* " (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45ESC-45Doc-n--3516-2819-u--go arg-0 e-0) (cons " */" '()))))) ((4) (let ((e-1 (vector-ref arg-1 1))) (cons e-1 '()))) ((5) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (CompilerC-45ESC-45Doc-n--3516-2819-u--go (string-append arg-0 (CompilerC-45ESC-45Doc-n--3516-2820-u--nSpaces e-2)) e-3)))) (else (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45ESC-45Doc-n--3516-2819-u--go arg-0 e-4) (CompilerC-45ESC-45Doc-n--3516-2819-u--go arg-0 e-5))))))))
(define CompilerC-45ESC-45Doc-pretty (lambda (ext-0) (PreludeC-45Types-fastConcat (CompilerC-45ESC-45Doc-n--3516-2819-u--go "" ext-0))))
(define CompilerC-45ESC-45Codegen-printDoc (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (CompilerC-45ESC-45Doc-pretty (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-1 (vector 1 )))) ((equal? arg-0 1) (CompilerC-45ESC-45Doc-compact arg-1)) (else (CompilerC-45ESC-45Doc-compact arg-1)))))
(define CompilerC-45ESC-45State-addLocal (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-2 e-10) e-6 e-7 e-8 e-9)))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45ESC-45State-keepLocalName (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((1) (cond ((equal? arg-1 0) 1)(else 0)))(else 0))))
(define CompilerC-45ESC-45State-nextLocal (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 (bs+ e-3 1 63) e-4 e-10 e-6 e-7 e-8 e-9)))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 1 (let ((e-3 (vector-ref e-5 3))) e-3))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45State-registerLocal (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (CompilerC-45ESC-45State-keepLocalName arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)))) (cond ((equal? sc1 1) (let ((u--v (vector 0 arg-1))) (lambda (eta-0) (let ((act-2 ((CompilerC-45ESC-45State-addLocal arg-0 arg-1 (vector 0 u--v)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 u--v))))))) (else (lambda (eta-0) (let ((act-2 (CompilerC-45ESC-45State-nextLocal arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45ESC-45State-addLocal arg-0 arg-1 (vector 0 e-6)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45State-reset (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 0 e-4 csegen-4849 e-6 e-7 e-8 e-9)))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45ESC-45Codegen-applyObj (lambda (ext-0) (CompilerC-45ESC-45Codegen-applyList (vector 4 "{") (vector 4 "}") CompilerC-45ESC-45Doc-softComma ext-0)))
(define CompilerC-45ESC-45Doc-hcat (lambda (ext-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4846 (lambda (eta-0) eta-0) ext-0)))
(define CompilerC-45ESC-45Codegen-conTags (lambda (arg-0) (DataC-45List-u--zipWith_Zippable_List (lambda (u--i) (lambda (u--a) (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "a") (cons (vector 4 (PreludeC-45Show-u--show_Show_Nat u--i)) (cons CompilerC-45ESC-45Doc-softColon (cons u--a '()))))))) (PreludeC-45Types-u--rangeFromTo_Range_Nat 1 (PreludeC-45TypesC-45List-lengthTR arg-0)) arg-0)))
(define CompilerC-45ESC-45Codegen-tag2es (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (cons (vector 4 (PreludeC-45Show-u--show_Show_Int e-0)) (box (vector 4 (CoreC-45Name-u--show_Show_Name (CoreC-45Name-dropNS e-1)))))))) (else (let ((e-2 (vector-ref arg-0 1))) (cons (CompilerC-45ESC-45Codegen-jsStringDoc (CoreC-45Name-u--show_Show_Name e-2)) '()))))))
(define CompilerC-45ESC-45Codegen-n--12881-3326-u--mkCon (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc csegen-4762 e-2) (let ((e-6 (unbox e-3))) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc csegen-4762 e-2) (vector 3 e-6))))))))
(define CompilerC-45ESC-45Codegen-applyCon (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-0 0) ((2) (if (null? arg-2) csegen-4848 (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Codegen-n--12881-3326-u--mkCon arg-0 arg-2 arg-1 (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2))))) ((5) (if (null? arg-2) csegen-4848 (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Codegen-n--12881-3326-u--mkCon arg-0 arg-2 arg-1 (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2))))) ((3) (CompilerC-45ESC-45Codegen-applyObj (CompilerC-45ESC-45Codegen-conTags arg-2))) ((6) (CompilerC-45ESC-45Codegen-applyObj (CompilerC-45ESC-45Codegen-conTags arg-2))) ((7) (CompilerC-45ESC-45Codegen-applyObj (CompilerC-45ESC-45Codegen-conTags arg-2))) ((10) (if (null? arg-2) (vector 4 "undefined") (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Codegen-n--12881-3326-u--mkCon arg-0 arg-2 arg-1 (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2)))))(else (CompilerC-45ESC-45Codegen-applyObj (cons (CompilerC-45ESC-45Codegen-n--12881-3326-u--mkCon arg-0 arg-2 arg-1 (CompilerC-45ESC-45Codegen-tag2es arg-1)) (CompilerC-45ESC-45Codegen-conTags arg-2)))))))
(define CompilerC-45ESC-45Codegen-jsPrimType (lambda (arg-0) "#t"))
(define CompilerC-45ESC-45Codegen-jsConstant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (string-append (PreludeC-45Show-u--show_Show_Int64 e-4) "n"))) ((5) (let ((e-5 (vector-ref arg-0 1))) (string-append (PreludeC-45Show-u--show_Show_Integer e-5) "n"))) ((6) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits8 e-6))) ((7) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits16 e-7))) ((8) (let ((e-8 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits32 e-8))) ((9) (let ((e-9 (vector-ref arg-0 1))) (string-append (PreludeC-45Show-u--show_Show_Bits64 e-9) "n"))) ((10) (let ((e-10 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsString e-10))) ((11) (let ((e-11 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsString (DataC-45String-singleton e-11)))) ((12) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Double e-12))) ((13) (let ((e-13 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsPrimType e-13))) (else (CompilerC-45ESC-45Codegen-esName "idrisworld")))))
(define CompilerC-45ESC-45Codegen-binOp (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "(") (cons arg-1 (cons (vector 4 arg-0) (cons arg-2 (cons (vector 4 ")") '()))))))))
(define CompilerC-45ESC-45Codegen-boundedOp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CompilerC-45ESC-45Codegen-callFun (PreludeC-45Types-fastConcat (cons "_" (cons arg-2 (cons (PreludeC-45Show-u--show_Show_Int arg-1) (cons arg-0 '()))))) (cons arg-3 (cons arg-4 '())))))
(define CompilerC-45ESC-45Codegen-boundedIntOp (lambda (ext-0 ext-1 ext-2 ext-3) (CompilerC-45ESC-45Codegen-boundedOp "s" ext-0 ext-1 ext-2 ext-3)))
(define CompilerC-45ESC-45Codegen-boundedUIntOp (lambda (ext-0 ext-1 ext-2 ext-3) (CompilerC-45ESC-45Codegen-boundedOp "u" ext-0 ext-1 ext-2 ext-3)))
(define CompilerC-45ESC-45Codegen-integerOp (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Codegen-callFun (PreludeC-45Types-fastConcat (cons "_" (cons arg-0 (cons "BigInt" '())))) (cons arg-1 (cons arg-2 '())))))
(define CompilerC-45ESC-45Codegen-arithOp (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45Codegen-binOp arg-1 eta-0 eta-1))) (let ((e-1 (unbox arg-0))) (lambda (clam-0) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (lambda (clam-1) (if (null? e-2) (cond ((equal? arg-1 "") (CompilerC-45ESC-45Codegen-integerOp arg-2 clam-0 clam-1))(else (CompilerC-45ESC-45Codegen-binOp arg-1 clam-0 clam-1))) (let ((e-4 (unbox e-2))) (CompilerC-45ESC-45Codegen-boundedIntOp e-4 arg-2 clam-0 clam-1)))))) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-1) (CompilerC-45ESC-45Codegen-boundedUIntOp e-3 arg-2 clam-0 eta-1))))(else (lambda (eta-1) (CompilerC-45ESC-45Codegen-binOp arg-1 clam-0 eta-1)))))))))
(define CompilerC-45ESC-45Codegen-boolOp (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") (CompilerC-45ESC-45Codegen-binOp arg-0 arg-1 arg-2)) (vector 4 "?1:0)"))))
(define CompilerC-45ESC-45Codegen-jsIntKind (lambda (arg-0) (cond ((equal? arg-0 0) (box (vector 0 (box 32))))(else (CoreC-45TTC-45Primitive-intKind arg-0)))))
(define CompilerC-45ESC-45State-error (lambda (ext-0 ext-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 ext-0) ext-1)))
(define CompilerC-45ESC-45State-errorConcat (lambda (ext-1 ext-0) (CompilerC-45ESC-45State-error (PreludeC-45Types-fastConcat ext-1) ext-0)))
(define CompilerC-45ESC-45Codegen-fromBigInt (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 "Number" ext-0)))
(define CompilerC-45ESC-45Codegen-useBigIntC-39 (lambda (ext-0) (PreludeC-45EqOrd-u--C-62_Ord_Int ext-0 32)))
(define CompilerC-45ESC-45Codegen-useBigInt (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) 1 (let ((e-2 (unbox e-0))) (CompilerC-45ESC-45Codegen-useBigIntC-39 e-2))))) (else (let ((e-1 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-useBigIntC-39 e-1))))))
(define CompilerC-45ESC-45Codegen-fromInt (lambda (arg-0) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-0))) (cond ((equal? sc0 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-fromBigInt eta-0))) (else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-jsAnyToString (lambda (arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(''+") arg-0) (vector 4 ")"))))
(define CompilerC-45ESC-45Codegen-jsCharOfInt (lambda (arg-0 ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "truncToChar") ((CompilerC-45ESC-45Codegen-fromInt arg-0) ext-0))))
(define CompilerC-45ESC-45Codegen-toBigInt (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 "BigInt" ext-0)))
(define CompilerC-45ESC-45Codegen-toInt (lambda (arg-0) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-0))) (cond ((equal? sc0 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-toBigInt eta-0))) (else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-jsIntOfChar (lambda (arg-0 arg-1) ((CompilerC-45ESC-45Codegen-toInt arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-1 (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ".codePointAt(0)")))))
(define CompilerC-45ESC-45Codegen-jsIntOfDouble (lambda (arg-0 ext-0) ((CompilerC-45ESC-45Codegen-toInt arg-0) (CompilerC-45ESC-45Codegen-callFun1 "Math.trunc" ext-0))))
(define CompilerC-45ESC-45Codegen-jsBigIntOfString (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "bigIntOfString") ext-0)))
(define CompilerC-45ESC-45Codegen-jsIntOfString (lambda (arg-0) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-0))) (cond ((equal? sc0 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-jsBigIntOfString eta-0))) (else (lambda (eta-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "intOfString") eta-0)))))))
(define CompilerC-45ESC-45Codegen-n--13702-4089-u--expand (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc0 0) (let ((sc1 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc1 1) (lambda (eta-0) (CompilerC-45ESC-45Codegen-toBigInt eta-0)))(else (lambda (eta-0) eta-0)))))(else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-n--13702-4091-u--shrink (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc0 1) (let ((sc1 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc1 0) (lambda (eta-0) (CompilerC-45ESC-45Codegen-fromBigInt eta-0)))(else (lambda (eta-0) eta-0)))))(else (lambda (eta-0) eta-0))))))
(define CompilerC-45ESC-45Codegen-truncateSigned (lambda (arg-0 arg-1) (let ((u--add (cond ((equal? arg-0 1) "BigInt") (else "Int")))) (lambda (eta-0) (CompilerC-45ESC-45Codegen-callFun1 (string-append (CompilerC-45ESC-45Codegen-esName "trunc") (string-append u--add (PreludeC-45Show-u--show_Show_Int arg-1))) eta-0)))))
(define CompilerC-45ESC-45Codegen-truncateUnsigned (lambda (arg-0 arg-1) (let ((u--add (cond ((equal? arg-0 1) "BigInt") (else "Int")))) (lambda (eta-0) (CompilerC-45ESC-45Codegen-callFun1 (string-append (CompilerC-45ESC-45Codegen-esName "truncU") (string-append u--add (PreludeC-45Show-u--show_Show_Int arg-1))) eta-0)))))
(define CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (lambda (clam-1) (if (null? e-0) (vector 1 clam-0) (let ((e-2 (unbox e-0))) (vector 1 ((CompilerC-45ESC-45Codegen-truncateSigned arg-3 e-2) clam-0))))))) (else (let ((e-1 (vector-ref arg-4 1))) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-truncateUnsigned arg-3 e-1) clam-0)))))))))
(define CoreC-45TTC-45Primitive-u--C-62_Ord_Precision (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TTC-45Primitive-u--compare_Ord_Precision arg-0 arg-1) 2)))
(define CompilerC-45ESC-45Codegen-case--castIntC-44intImpl-4259 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-3 0) ((0) (let ((e-10 (vector-ref e-3 1))) (if (null? e-10) (lambda (eta-0) (vector 1 arg-5)) (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision e-6 e-4))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((sc5 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc5 0) (let ((sc6 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc6 1) ((CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt arg-0 arg-1 arg-2 1 arg-3) (CompilerC-45ESC-45Codegen-toBigInt arg-0)))(else arg-6))))(else arg-6))))))) (else (let ((e-5 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((1) (let ((e-8 (vector-ref e-3 1))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-8 e-5))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-62_Ord_Precision e-9 (box e-5)))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))))))))))(else (case (vector-ref e-2 0) ((0) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision e-6 e-4))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((sc3 (CompilerC-45ESC-45Codegen-useBigInt arg-4))) (cond ((equal? sc3 0) (let ((sc4 (CompilerC-45ESC-45Codegen-useBigInt arg-3))) (cond ((equal? sc4 1) ((CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt arg-0 arg-1 arg-2 1 arg-3) (CompilerC-45ESC-45Codegen-toBigInt arg-0)))(else arg-6))))(else arg-6))))))) (else (let ((e-5 (vector-ref e-2 1))) (case (vector-ref e-3 0) ((1) (let ((e-8 (vector-ref e-3 1))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-8 e-5))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-62_Ord_Precision e-9 (box e-5)))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 arg-5))) (else arg-6)))))))))))))))
(define CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--expanded ((CompilerC-45ESC-45Codegen-n--13702-4089-u--expand arg-0 arg-1 arg-2 arg-3 arg-4) arg-0))) (let ((u--shrunk (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 ((CompilerC-45ESC-45Codegen-n--13702-4091-u--shrink arg-0 arg-1 arg-2 arg-3 arg-4) e-5)))))) ((CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt arg-3) arg-4) arg-0) eta-0)))) (CompilerC-45ESC-45Codegen-case--castIntC-44intImpl-4259 arg-0 arg-1 arg-2 arg-4 arg-3 u--expanded u--shrunk (cons arg-3 arg-4))))))
(define CompilerC-45ESC-45Codegen-case--castInt-4587 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (cond ((equal? e-6 11) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-19 (cdr e-3))) (if (null? e-19) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-21 (unbox e-19))) ((CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt e-21) e-21) (CompilerC-45ESC-45Codegen-jsIntOfChar e-21 arg-0))))))) ((equal? e-6 10) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-25 (cdr e-3))) (if (null? e-25) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-27 (unbox e-25))) ((CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt e-27) e-27) ((CompilerC-45ESC-45Codegen-jsIntOfString e-27) arg-0))))))) ((equal? e-6 12) (if (null? e-3) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-31 (cdr e-3))) (if (null? e-31) (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15)))))))))) (let ((e-33 (unbox e-31))) ((CompilerC-45ESC-45Codegen-n--13702-4092-u--truncInt arg-0 arg-1 arg-2 (CompilerC-45ESC-45Codegen-useBigInt e-33) e-33) (CompilerC-45ESC-45Codegen-jsIntOfDouble e-33 arg-0)))))))(else (if (null? e-7) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-9 (unbox e-7))) (if (null? e-3) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-12 (car e-3))) (let ((e-13 (cdr e-3))) (cond ((equal? e-12 11) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsCharOfInt e-9 arg-0)))) ((equal? e-12 10) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString arg-0)))) ((equal? e-12 12) (lambda (eta-0) (vector 1 ((CompilerC-45ESC-45Codegen-fromInt e-9) arg-0))))(else (if (null? e-13) (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "invalid cast: + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-2) (cons " + ' -> ' + " (cons (CoreC-45TTC-45Primitive-u--show_Show_PrimType arg-1) '())))) eta-0)) (let ((e-15 (unbox e-13))) (CompilerC-45ESC-45Codegen-n--13702-4090-u--intImpl arg-0 arg-1 arg-2 e-9 e-15))))))))))))))))))))
(define CompilerC-45ESC-45Codegen-castInt (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Codegen-case--castInt-4587 arg-2 arg-1 arg-0 (cons (cons arg-0 (CompilerC-45ESC-45Codegen-jsIntKind arg-0)) (cons arg-1 (CompilerC-45ESC-45Codegen-jsIntKind arg-1))))))
(define CompilerC-45ESC-45Codegen-case--jsMod-4007 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (CompilerC-45ESC-45Codegen-integerOp "mod" arg-1 arg-0) (let ((e-1 (unbox arg-3))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (CompilerC-45ESC-45Codegen-integerOp "mod" arg-1 arg-0) (let ((e-4 (unbox e-2))) (let ((sc3 (CompilerC-45ESC-45Codegen-useBigIntC-39 e-4))) (cond ((equal? sc3 1) (CompilerC-45ESC-45Codegen-integerOp "mod" arg-1 arg-0)) (else (CompilerC-45ESC-45Codegen-callFun "_mod" (cons arg-1 (cons arg-0 '())))))))))) ((1) (CompilerC-45ESC-45Codegen-binOp "%" arg-1 arg-0))(else (CompilerC-45ESC-45Codegen-integerOp "mod" arg-1 arg-0)))))))
(define CompilerC-45ESC-45Codegen-jsMod (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45Codegen-case--jsMod-4007 arg-2 arg-1 arg-0 (CompilerC-45ESC-45Codegen-jsIntKind arg-0))))
(define CompilerC-45ESC-45Codegen-jsNumberOfString (lambda (ext-0) (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "numberOfString") ext-0)))
(define CompilerC-45ESC-45Codegen-jsOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (lambda (clam-0) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-0) "+" "add") e-20) e-24))))))))) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-29 (car arg-2))) (let ((e-30 (cdr arg-2))) (lambda (clam-1) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-1) "-" "sub") e-29) e-33))))))))) ((2) (let ((e-2 (vector-ref arg-1 1))) (let ((e-38 (car arg-2))) (let ((e-39 (cdr arg-2))) (lambda (clam-2) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-2) "*" "mul") e-38) e-42))))))))) ((3) (let ((e-3 (vector-ref arg-1 1))) (cond ((equal? e-3 12) (if (null? arg-2) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-5) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-3) "" "div") e-47) e-51))))))) (let ((e-56 (car arg-2))) (let ((e-57 (cdr arg-2))) (if (null? e-57) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-4) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-3) "" "div") e-47) e-51))))))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (if (null? e-61) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp "/" e-56 e-60))) (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-3) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-3) "" "div") e-47) e-51)))))))))))))))(else (let ((e-47 (car arg-2))) (let ((e-48 (cdr arg-2))) (lambda (clam-6) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-3) "" "div") e-47) e-51))))))))))) ((4) (let ((e-4 (vector-ref arg-1 1))) (let ((e-65 (car arg-2))) (let ((e-66 (cdr arg-2))) (lambda (clam-7) (let ((e-69 (car e-66))) (let ((e-70 (cdr e-66))) (vector 1 (CompilerC-45ESC-45Codegen-jsMod e-4 e-65 e-69))))))))) ((5) (lambda (clam-8) (let ((e-74 (car arg-2))) (let ((e-75 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(-(") e-74) (vector 4 "))"))))))) ((6) (let ((e-6 (vector-ref arg-1 1))) (cond ((equal? e-6 3) (if (null? arg-2) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-11) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83))))))) (let ((e-88 (car arg-2))) (let ((e-89 (cdr arg-2))) (if (null? e-89) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-10) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83))))))) (let ((e-92 (car e-89))) (let ((e-93 (cdr e-89))) (if (null? e-93) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp "<<" e-88 e-92))) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-9) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83))))))))))))))) ((equal? e-6 0) (if (null? arg-2) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-14) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83))))))) (let ((e-97 (car arg-2))) (let ((e-98 (cdr arg-2))) (if (null? e-98) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-13) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83))))))) (let ((e-101 (car e-98))) (let ((e-102 (cdr e-98))) (if (null? e-102) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp "<<" e-97 e-101))) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-12) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83)))))))))))))))(else (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (lambda (clam-15) (let ((e-83 (car e-80))) (let ((e-84 (cdr e-80))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-6) "<<" "shl") e-79) e-83))))))))))) ((7) (let ((e-7 (vector-ref arg-1 1))) (cond ((equal? e-7 3) (if (null? arg-2) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-18) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110))))))) (let ((e-115 (car arg-2))) (let ((e-116 (cdr arg-2))) (if (null? e-116) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-17) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110))))))) (let ((e-119 (car e-116))) (let ((e-120 (cdr e-116))) (if (null? e-120) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp ">>" e-115 e-119))) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-16) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110))))))))))))))) ((equal? e-7 0) (if (null? arg-2) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-21) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110))))))) (let ((e-124 (car arg-2))) (let ((e-125 (cdr arg-2))) (if (null? e-125) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-20) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110))))))) (let ((e-128 (car e-125))) (let ((e-129 (cdr e-125))) (if (null? e-129) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-binOp ">>" e-124 e-128))) (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-19) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110)))))))))))))))(else (let ((e-106 (car arg-2))) (let ((e-107 (cdr arg-2))) (lambda (clam-22) (let ((e-110 (car e-107))) (let ((e-111 (cdr e-107))) (vector 1 (((CompilerC-45ESC-45Codegen-arithOp (CompilerC-45ESC-45Codegen-jsIntKind e-7) ">>" "shr") e-106) e-110))))))))))) ((8) (let ((e-8 (vector-ref arg-1 1))) (cond ((equal? e-8 8) (if (null? arg-2) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (lambda (clam-25) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-133 e-137))))))) (let ((e-142 (car arg-2))) (let ((e-143 (cdr arg-2))) (if (null? e-143) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (lambda (clam-24) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-133 e-137))))))) (let ((e-146 (car e-143))) (let ((e-147 (cdr e-143))) (if (null? e-147) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-boundedUIntOp 32 "and" e-142 e-146))) (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (lambda (clam-23) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-133 e-137)))))))))))))))(else (let ((e-133 (car arg-2))) (let ((e-134 (cdr arg-2))) (lambda (clam-26) (let ((e-137 (car e-134))) (let ((e-138 (cdr e-134))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "&" e-133 e-137))))))))))) ((9) (let ((e-9 (vector-ref arg-1 1))) (cond ((equal? e-9 8) (if (null? arg-2) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (lambda (clam-29) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-151 e-155))))))) (let ((e-160 (car arg-2))) (let ((e-161 (cdr arg-2))) (if (null? e-161) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (lambda (clam-28) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-151 e-155))))))) (let ((e-164 (car e-161))) (let ((e-165 (cdr e-161))) (if (null? e-165) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-boundedUIntOp 32 "or" e-160 e-164))) (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (lambda (clam-27) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-151 e-155)))))))))))))))(else (let ((e-151 (car arg-2))) (let ((e-152 (cdr arg-2))) (lambda (clam-30) (let ((e-155 (car e-152))) (let ((e-156 (cdr e-152))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "|" e-151 e-155))))))))))) ((10) (let ((e-10 (vector-ref arg-1 1))) (cond ((equal? e-10 8) (if (null? arg-2) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-33) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-169 e-173))))))) (let ((e-178 (car arg-2))) (let ((e-179 (cdr arg-2))) (if (null? e-179) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-32) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-169 e-173))))))) (let ((e-182 (car e-179))) (let ((e-183 (cdr e-179))) (if (null? e-183) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-boundedUIntOp 32 "xor" e-178 e-182))) (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-31) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-169 e-173)))))))))))))))(else (let ((e-169 (car arg-2))) (let ((e-170 (cdr arg-2))) (lambda (clam-34) (let ((e-173 (car e-170))) (let ((e-174 (cdr e-170))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "^" e-169 e-173))))))))))) ((11) (let ((e-187 (car arg-2))) (let ((e-188 (cdr arg-2))) (lambda (clam-35) (let ((e-191 (car e-188))) (let ((e-192 (cdr e-188))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp "<" e-187 e-191)))))))) ((12) (let ((e-196 (car arg-2))) (let ((e-197 (cdr arg-2))) (lambda (clam-36) (let ((e-200 (car e-197))) (let ((e-201 (cdr e-197))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp "<=" e-196 e-200)))))))) ((13) (let ((e-205 (car arg-2))) (let ((e-206 (cdr arg-2))) (lambda (clam-37) (let ((e-209 (car e-206))) (let ((e-210 (cdr e-206))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp "===" e-205 e-209)))))))) ((14) (let ((e-214 (car arg-2))) (let ((e-215 (cdr arg-2))) (lambda (clam-38) (let ((e-218 (car e-215))) (let ((e-219 (cdr e-215))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp ">=" e-214 e-218)))))))) ((15) (let ((e-223 (car arg-2))) (let ((e-224 (cdr arg-2))) (lambda (clam-39) (let ((e-227 (car e-224))) (let ((e-228 (cdr e-224))) (vector 1 (CompilerC-45ESC-45Codegen-boolOp ">" e-223 e-227)))))))) ((16) (lambda (clam-40) (let ((e-232 (car arg-2))) (let ((e-233 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc e-232 (vector 4 ".length"))))))) ((17) (lambda (clam-41) (let ((e-237 (car arg-2))) (let ((e-238 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") e-237) (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ".charAt(0))"))))))) ((18) (lambda (clam-42) (let ((e-242 (car arg-2))) (let ((e-243 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") e-242) (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc ".slice(1))"))))))) ((19) (let ((e-247 (car arg-2))) (let ((e-248 (cdr arg-2))) (lambda (clam-43) (let ((e-251 (car e-248))) (let ((e-252 (cdr e-248))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") e-247) (vector 4 ".charAt(")) e-251) (vector 4 "))"))))))))) ((20) (let ((e-256 (car arg-2))) (let ((e-257 (cdr arg-2))) (lambda (clam-44) (let ((e-260 (car e-257))) (let ((e-261 (cdr e-257))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "+" e-256 e-260)))))))) ((21) (let ((e-265 (car arg-2))) (let ((e-266 (cdr arg-2))) (lambda (clam-45) (let ((e-269 (car e-266))) (let ((e-270 (cdr e-266))) (vector 1 (CompilerC-45ESC-45Codegen-binOp "+" e-265 e-269)))))))) ((22) (lambda (clam-46) (let ((e-274 (car arg-2))) (let ((e-275 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 (CompilerC-45ESC-45Codegen-esName "strReverse") e-274)))))) ((23) (let ((e-279 (car arg-2))) (let ((e-280 (cdr arg-2))) (let ((e-283 (car e-280))) (let ((e-284 (cdr e-280))) (lambda (clam-47) (let ((e-287 (car e-284))) (let ((e-288 (cdr e-284))) (vector 1 (CompilerC-45ESC-45Codegen-callFun (CompilerC-45ESC-45Codegen-esName "substr") (cons e-279 (cons e-283 (cons e-287 '()))))))))))))) ((24) (lambda (clam-48) (let ((e-292 (car arg-2))) (let ((e-293 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.exp" e-292)))))) ((25) (lambda (clam-49) (let ((e-297 (car arg-2))) (let ((e-298 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.log" e-297)))))) ((26) (let ((e-302 (car arg-2))) (let ((e-303 (cdr arg-2))) (lambda (clam-50) (let ((e-306 (car e-303))) (let ((e-307 (cdr e-303))) (vector 1 (CompilerC-45ESC-45Codegen-callFun "Math.pow" (cons e-302 (cons e-306 '())))))))))) ((27) (lambda (clam-51) (let ((e-311 (car arg-2))) (let ((e-312 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.sin" e-311)))))) ((28) (lambda (clam-52) (let ((e-316 (car arg-2))) (let ((e-317 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.cos" e-316)))))) ((29) (lambda (clam-53) (let ((e-321 (car arg-2))) (let ((e-322 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.tan" e-321)))))) ((30) (lambda (clam-54) (let ((e-326 (car arg-2))) (let ((e-327 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.asin" e-326)))))) ((31) (lambda (clam-55) (let ((e-331 (car arg-2))) (let ((e-332 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.acos" e-331)))))) ((32) (lambda (clam-56) (let ((e-336 (car arg-2))) (let ((e-337 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.atan" e-336)))))) ((33) (lambda (clam-57) (let ((e-341 (car arg-2))) (let ((e-342 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.sqrt" e-341)))))) ((34) (lambda (clam-58) (let ((e-346 (car arg-2))) (let ((e-347 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.floor" e-346)))))) ((35) (lambda (clam-59) (let ((e-351 (car arg-2))) (let ((e-352 (cdr arg-2))) (vector 1 (CompilerC-45ESC-45Codegen-callFun1 "Math.ceil" e-351)))))) ((36) (let ((e-16 (vector-ref arg-1 1))) (let ((e-17 (vector-ref arg-1 2))) (cond ((equal? e-16 10) (cond ((equal? e-17 12) (if (null? arg-2) (cond ((equal? e-17 10) (if (null? arg-2) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))) (let ((e-361 (car arg-2))) (let ((e-362 (cdr arg-2))) (if (null? e-362) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-361))) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))))))(else (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))) (let ((e-366 (car arg-2))) (let ((e-367 (cdr arg-2))) (if (null? e-367) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsNumberOfString e-366))) (cond ((equal? e-17 10) (if (null? arg-2) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))) (let ((e-361 (car arg-2))) (let ((e-362 (cdr arg-2))) (if (null? e-362) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-361))) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))))))(else (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))))))))(else (cond ((equal? e-17 10) (if (null? arg-2) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))) (let ((e-361 (car arg-2))) (let ((e-362 (cdr arg-2))) (if (null? e-362) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-361))) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))))))(else (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))))))(else (cond ((equal? e-17 10) (if (null? arg-2) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))) (let ((e-361 (car arg-2))) (let ((e-362 (cdr arg-2))) (if (null? e-362) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-jsAnyToString e-361))) (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356))))))))(else (let ((e-356 (car arg-2))) (let ((e-357 (cdr arg-2))) (CompilerC-45ESC-45Codegen-castInt e-16 e-17 e-356)))))))))) ((37) (let ((e-372 (cdr arg-2))) (let ((e-376 (cdr e-372))) (lambda (clam-60) (let ((e-379 (car e-376))) (let ((e-380 (cdr e-376))) (vector 1 e-379))))))) (else (let ((e-385 (cdr arg-2))) (lambda (clam-61) (let ((e-388 (car e-385))) (let ((e-389 (cdr e-385))) (vector 1 (CompilerC-45ESC-45Codegen-jsCrashExp e-388))))))))))
(define CompilerC-45ESC-45State-case--addToPreamble-7351 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (let ((act-1 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((e-7 (vector-ref arg-3 7))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-0 e-7) e-8 e-9)))))))))))))) (vector 1 act-1))) (let ((e-2 (unbox arg-4))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-2 arg-0))) (cond ((equal? sc1 1) (lambda (eta-0) (vector 1 (vector 0 )))) (else (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "two incompatible definitions for " (cons arg-1 (cons "<|" (cons e-2 (cons "|> <|" (cons arg-0 (cons "|>" '()))))))) eta-0)))))))))
(define CompilerC-45ESC-45State-addToPreamble (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45ESC-45State-case--addToPreamble-7351 arg-2 arg-1 arg-0 e-5 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-7 (vector-ref e-5 7))) e-7))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Codegen-breakDrop1 (lambda (arg-0 ext-0) (let ((sc0 (DataC-45String-break (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 arg-0)) ext-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (cons e-2 (LibrariesC-45DataC-45StringC-45Extra-drop 1 e-3)))))))
(define CompilerC-45ESC-45Codegen-readCCPart (lambda (ext-0) (CompilerC-45ESC-45Codegen-breakDrop1 #\: ext-0)))
(define CompilerC-45ESC-45Codegen-searchForeign (lambda (arg-0 arg-1) (let ((u--pairs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45Codegen-readCCPart eta-0)) arg-1))) (let ((u--backends (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) u--pairs)))) (PreludeC-45Types-maybe (lambda () u--backends) (lambda () (lambda (eta-0) (vector 1 (Builtin-snd eta-0)))) (DataC-45List-find (lambda (eta-0) (PreludeC-45Types-elem csegen-14 csegen-22 (Builtin-fst eta-0) arg-0)) u--pairs))))))
(define CompilerC-45ESC-45Codegen-jsPrim (lambda (arg-0 arg-1 arg-2) (let ((sc0 (CoreC-45Name-dropAllNS arg-1))) (case (vector-ref sc0 0) ((1) (let ((e-4 (vector-ref sc0 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (cond ((equal? e-5 "prim__newIORef") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-8 (cdr arg-2))) (if (null? e-8) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (lambda (clam-0) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0) (let ((e-14 (cdr e-11))) (if (null? e-14) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "({value:") (cons e-10 (cons (vector 4 "})") '()))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))))))))))) ((equal? e-5 "prim__readIORef") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-18 (cdr arg-2))) (if (null? e-18) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-20 (car e-18))) (let ((e-21 (cdr e-18))) (lambda (clam-1) (if (null? e-21) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-1) (let ((e-24 (cdr e-21))) (if (null? e-24) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "(") (cons e-20 (cons (vector 4 ".value)") '()))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-1))))))))))) ((equal? e-5 "prim__writeIORef") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-28 (cdr arg-2))) (if (null? e-28) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-30 (car e-28))) (let ((e-31 (cdr e-28))) (if (null? e-31) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-33 (car e-31))) (let ((e-34 (cdr e-31))) (lambda (clam-2) (if (null? e-34) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-2) (let ((e-37 (cdr e-34))) (if (null? e-37) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "(") (cons e-30 (cons (vector 4 ".value=") (cons e-33 (cons (vector 4 ")") '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-2)))))))))))))) ((equal? e-5 "prim__newArray") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-41 (cdr arg-2))) (if (null? e-41) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-43 (car e-41))) (let ((e-44 (cdr e-41))) (if (null? e-44) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-46 (car e-44))) (let ((e-47 (cdr e-44))) (lambda (clam-3) (if (null? e-47) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-3) (let ((e-50 (cdr e-47))) (if (null? e-50) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "(Array(") (cons (CompilerC-45ESC-45Codegen-fromBigInt e-43) (cons (vector 4 ").fill(") (cons e-46 (cons (vector 4 "))") '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-3)))))))))))))) ((equal? e-5 "prim__arrayGet") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-54 (cdr arg-2))) (if (null? e-54) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-56 (car e-54))) (let ((e-57 (cdr e-54))) (if (null? e-57) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-59 (car e-57))) (let ((e-60 (cdr e-57))) (lambda (clam-4) (if (null? e-60) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-4) (let ((e-63 (cdr e-60))) (if (null? e-63) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "(") (cons e-56 (cons (vector 4 "[") (cons (CompilerC-45ESC-45Codegen-fromBigInt e-59) (cons (vector 4 "])") '()))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-4)))))))))))))) ((equal? e-5 "prim__arraySet") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-67 (cdr arg-2))) (if (null? e-67) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-69 (car e-67))) (let ((e-70 (cdr e-67))) (if (null? e-70) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-72 (car e-70))) (let ((e-73 (cdr e-70))) (if (null? e-73) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-75 (car e-73))) (let ((e-76 (cdr e-73))) (lambda (clam-5) (if (null? e-76) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-5) (let ((e-79 (cdr e-76))) (if (null? e-79) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (vector 4 "(") (cons e-69 (cons (vector 4 "[") (cons (CompilerC-45ESC-45Codegen-fromBigInt e-72) (cons (vector 4 "]=") (cons e-75 (cons (vector 4 ")") '()))))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-5))))))))))))))))) ((equal? e-5 "void") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-83 (cdr arg-2))) (lambda (clam-6) (if (null? e-83) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-6) (let ((e-86 (cdr e-83))) (if (null? e-86) csegen-4837 (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-6)))))))) ((equal? e-5 "prim__void") (if (null? arg-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)) (let ((e-90 (cdr arg-2))) (lambda (clam-7) (if (null? e-90) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-7) (let ((e-93 (cdr e-90))) (if (null? e-93) csegen-4837 (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-7)))))))) ((equal? e-5 "prim__codegen") (lambda (clam-8) (if (null? arg-2) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-4838 (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-9) (if (null? e-6) (vector 1 (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "\"javascript\"")) (let ((e-1 (car e-6))) (vector 1 (vector 4 (CompilerC-45ESC-45Codegen-jsString e-1)))))))) eff-0) clam-8))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-8)))) ((equal? e-5 "prim__os") (lambda (clam-10) (if (null? arg-2) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-4838 (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) clam-10))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-11) (let ((sc5 (CompilerC-45ESC-45Codegen-searchForeign e-6 (cons "node" '())))) (case (vector-ref sc5 0) ((1) (let ((act-2 (CompilerC-45ESC-45State-addToPreamble arg-0 "prim__os" "const _sysos = ((o => o === 'linux'?'unix':o==='win32'?'windows':o)(require('os').platform()));" clam-11))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (vector 4 (CompilerC-45ESC-45Codegen-esName "sysos"))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "prim not implemented: prim__os") clam-11))))))) eff-0) clam-10))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-10))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "prim not implemented: " (CoreC-45Name-u--show_Show_Name arg-1))) eta-0)))))))
(define CompilerC-45ESC-45Doc-lambdaArrow (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (vector 2 ) (vector 4 "=>")) (vector 2 )))
(define CompilerC-45ESC-45Codegen-n--12253-2670-u--okchar (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\_) "_")(else (let ((sc0 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc0 1) (string arg-1)) (else (string-append "x" (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-1 64))))))))))
(define CompilerC-45ESC-45Codegen-jsIdent (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--12253-2670-u--okchar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0))))
(define CompilerC-45ESC-45Codegen-jsReservedNames (cons "await" (cons "break" (cons "case" (cons "catch" (cons "class" (cons "const" (cons "continue" (cons "debugger" (cons "default" (cons "delete" (cons "do" (cons "else" (cons "enum" (cons "export" (cons "extends" (cons "false" (cons "finally" (cons "for" (cons "function" (cons "if" (cons "implements" (cons "import" (cons "in" (cons "instanceof" (cons "interface" (cons "let" (cons "new" (cons "null" (cons "package" (cons "private" (cons "protected" (cons "public" (cons "return" (cons "static" (cons "super" (cons "switch" (cons "this" (cons "throw" (cons "true" (cons "try" (cons "typeof" (cons "var" (cons "void" (cons "while" (cons "with" (cons "yield" '())))))))))))))))))))))))))))))))))))))))))))))))
(define CompilerC-45ESC-45Codegen-keywordSafe (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-22 arg-0 CompilerC-45ESC-45Codegen-jsReservedNames))) (cond ((equal? sc0 1) (string-append arg-0 "$")) (else arg-0)))))
(define CompilerC-45ESC-45Codegen-jsUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-keywordSafe (CompilerC-45ESC-45Codegen-jsIdent e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "rf__" (CompilerC-45ESC-45Codegen-jsIdent e-1)))) (else (CompilerC-45ESC-45Codegen-keywordSafe (CompilerC-45ESC-45Codegen-jsIdent "_"))))))
(define CompilerC-45ESC-45Codegen-jsMangleName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (CompilerC-45ESC-45Codegen-jsIdent (CoreC-45NameC-45Namespace-showNSWithSep "_" e-0)) (string-append "_" (CompilerC-45ESC-45Codegen-jsMangleName e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45ESC-45Codegen-jsUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (string-append (CompilerC-45ESC-45Codegen-jsIdent e-3) (string-append "_" (PreludeC-45Show-u--show_Show_Int e-4)))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (string-append "pat__" (CompilerC-45ESC-45Codegen-jsMangleName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CompilerC-45ESC-45Codegen-jsMangleName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (let ((e-18 (car e-9))) (let ((e-19 (cdr e-9))) (string-append "n__" (string-append (PreludeC-45Show-u--show_Show_Int e-18) (string-append "_" (string-append (PreludeC-45Show-u--show_Show_Int e-19) (string-append "_" (CompilerC-45ESC-45Codegen-jsMangleName e-10))))))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (string-append "case__" (string-append (CompilerC-45ESC-45Codegen-jsIdent e-11) (string-append "_" (PreludeC-45Show-u--show_Show_Int e-12))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (string-append "with__" (string-append (CompilerC-45ESC-45Codegen-jsIdent e-13) (string-append "_" (PreludeC-45Show-u--show_Show_Int e-14))))))) (else (let ((e-15 (vector-ref arg-0 1))) (string-append "fn__" (PreludeC-45Show-u--show_Show_Int e-15)))))))
(define CompilerC-45ESC-45Codegen-jsName (lambda (arg-0 arg-1) (let ((sc0 (CompilerC-45NoMangle-isNoMangle arg-0 arg-1))) (if (null? sc0) (CompilerC-45ESC-45Codegen-jsMangleName arg-1) (let ((e-1 (unbox sc0))) e-1)))))
(define CompilerC-45ESC-45Codegen-jsNameDoc (lambda (arg-0 ext-0) (vector 4 (CompilerC-45ESC-45Codegen-jsName arg-0 ext-0))))
(define CompilerC-45ESC-45Codegen-var (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45ESC-45Codegen-jsNameDoc arg-0 e-0))) ((1) (let ((e-1 (vector-ref arg-1 1))) (vector 4 (string-append "$" (ProtocolC-45Hex-asHex (blodwen-toUnsignedInt e-1 64)))))) (else (let ((e-2 (vector-ref arg-1 1))) (vector 4 (string-append "$R" (ProtocolC-45Hex-asHex (blodwen-toUnsignedInt e-2 64)))))))))
(define CompilerC-45ESC-45Codegen-lambdaArgs (lambda (arg-0 arg-1) (if (null? arg-1) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "()") CompilerC-45ESC-45Doc-lambdaArrow) (CompilerC-45ESC-45Doc-hcat (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-var arg-0 eta-0) CompilerC-45ESC-45Doc-lambdaArrow)) arg-1)))))
(define CompilerC-45ESC-45Codegen-minimal (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45ESC-45Codegen-var arg-0 e-0))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-minimal arg-0 e-2) (vector 4 ".a")) (vector 4 (PreludeC-45Show-u--show_Show_Nat e-1)))))))))
(define CompilerC-45ESC-45Doc-paren (lambda (arg-0) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "(") arg-0) (vector 4 ")"))))
(define CompilerC-45ESC-45Codegen-exp (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Codegen-minimal e-5 e-0))))) eff-0) eta-0)))))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-14 (vector-ref e-2 1))) (case (vector-ref e-14 0) ((3) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-3 (vector-ref eta-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-lambdaArgs e-5 e-1) (CompilerC-45ESC-45Doc-paren e-6))))))) (CompilerC-45ESC-45Codegen-exp arg-0 arg-1 e-14) eta-0)))) eff-0) clam-0))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-3 (vector-ref eta-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-lambdaArgs e-5 e-1) e-6)))))) (CompilerC-45ESC-45Codegen-exp arg-0 arg-1 e-14) eta-0)))) eff-0) clam-0)))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-3 (vector-ref eta-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-lambdaArgs e-5 e-1) (CompilerC-45ESC-45Doc-block e-6))))))) (CompilerC-45ESC-45Codegen-stmt (box '()) arg-0 arg-1 e-2) eta-0)))) eff-0) clam-0))))))))))) ((2) (let ((e-3 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 ((CompilerC-45ESC-45Codegen-exp arg-0 arg-1 e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45ESC-45Codegen-exp arg-0 arg-1 eta-2)) e-4 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Codegen-app e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((3) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Codegen-applyCon e-6 e-5 e-8)))))) (CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45ESC-45Codegen-exp arg-0 arg-1 eta-1)) e-7 '()) eta-0)))))) ((4) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45ESC-45Codegen-exp arg-0 arg-1 eta-1)) e-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-jsOp e-9 e-5))) eff-0) eta-0))))))))) ((5) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45ESC-45Codegen-exp arg-0 arg-1 eta-1)) e-12 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-jsPrim arg-0 e-11 e-5))) eff-0) eta-0))))))))) ((6) (let ((e-13 (vector-ref arg-2 1))) (lambda (eta-0) (vector 1 (vector 4 (CompilerC-45ESC-45Codegen-jsConstant e-13)))))) (else (lambda (eta-0) (vector 1 (vector 4 "undefined")))))))
(define CompilerC-45ESC-45Doc-vcat (lambda (ext-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4846 (lambda (eta-0) eta-0) (DataC-45List-intersperse (vector 1 ) ext-0))))
(define CompilerC-45ESC-45Codegen-insertBreak (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (cons e-3 (CompilerC-45ESC-45Doc-vcat (cons e-4 (cons (vector 4 "break;") '())))))))))
(define CompilerC-45ESC-45Doc-isMultiline (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 0) ((1) 1) ((2) 0) ((4) 0) ((3) (let ((e-1 (vector-ref arg-0 1))) (CompilerC-45ESC-45Doc-isMultiline e-1))) ((5) (let ((e-3 (vector-ref arg-0 2))) (CompilerC-45ESC-45Doc-isMultiline e-3))) (else (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (let ((sc1 (CompilerC-45ESC-45Doc-isMultiline e-4))) (cond ((equal? sc1 1) 1) (else (CompilerC-45ESC-45Doc-isMultiline e-5))))))))))
(define CompilerC-45ESC-45Codegen-n--16575-6880-u--anyCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--b (let ((sc0 (CompilerC-45ESC-45Doc-isMultiline arg-5))) (cond ((equal? sc0 1) (CompilerC-45ESC-45Doc-block arg-5)) (else arg-5))))) (if (null? arg-4) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-3 CompilerC-45ESC-45Doc-softColon) u--b) (let ((e-2 (unbox arg-4))) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc arg-3 CompilerC-45ESC-45Doc-softColon) (vector 3 e-2)) u--b))))))
(define CompilerC-45ESC-45Codegen-n--16575-6879-u--alt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CompilerC-45ESC-45Codegen-n--16575-6880-u--anyCase arg-0 arg-1 arg-2 (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 4 "case") e-6) e-7 e-3)))))))
(define CompilerC-45ESC-45Codegen-switch (lambda (arg-0 arg-1 arg-2) (let ((u--stmt (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "switch") (CompilerC-45ESC-45Doc-paren arg-0)) (vector 2 )))) (let ((u--defcase (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-57 (lambda (eta-0) (PreludeC-45Types-u--pure_Applicative_List (CompilerC-45ESC-45Codegen-n--16575-6880-u--anyCase arg-2 arg-1 arg-0 (vector 4 "default") '() eta-0))) arg-2))) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc u--stmt (CompilerC-45ESC-45Doc-block (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--16575-6879-u--alt arg-2 arg-1 arg-0 eta-0)) arg-1) u--defcase))))))))
(define CompilerC-45ESC-45Codegen-n--16846-7403-u--alt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (let ((e-1 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (case (vector-ref e-2 0) ((7) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (cons (vector 4 "undefined") (box (vector 4 "record"))) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0)) ((2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (cons (vector 4 "0") (box (vector 4 "nil"))) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0)) ((3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (cons (vector 4 "undefined") (box (vector 4 "cons"))) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0)) ((5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (cons (vector 4 "0") (box (vector 4 "nothing"))) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0)) ((6) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (cons (vector 4 "undefined") (box (vector 4 "just"))) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0)) ((10) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (cons (vector 4 "undefined") (box (vector 4 "unit"))) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0))(else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons (CompilerC-45ESC-45Codegen-tag2es e-1) e-5)))))) (CompilerC-45ESC-45Codegen-stmt (box arg-7) arg-5 arg-4 e-3) clam-0)))))))))
(define CompilerC-45ESC-45Codegen-n--16846-7666-u--alt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (let ((act-1 ((CompilerC-45ESC-45Codegen-stmt (box arg-0) arg-5 arg-4 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (cons (vector 4 (CompilerC-45ESC-45Codegen-jsConstant e-1)) '()) e-5))))) eff-0) ext-0)))))))))
(define CompilerC-45ESC-45Codegen-stmt (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) (lambda (clam-3) (case (vector-ref arg-3 0) ((1) (let ((e-20 (vector-ref arg-3 1))) (let ((e-21 (vector-ref arg-3 2))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Codegen-constant (CompilerC-45ESC-45Codegen-var e-5 e-20) e-6)))))) (CompilerC-45ESC-45Codegen-exp arg-1 arg-2 e-21) eta-0)))) eff-0) clam-3)))))))) ((3) (let ((e-22 (vector-ref arg-3 1))) (let ((e-23 (vector-ref arg-3 2))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-vcat (cons (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 4 "let") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-var e-5 e-22) (vector 4 ";"))) (cons e-6 '())))))))) (CompilerC-45ESC-45Codegen-stmt (box (box e-22)) arg-1 arg-2 e-23) eta-0)))) eff-0) clam-3))))))))(else (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ESC-45Codegen-stmt '() arg-1 arg-2 eta-0)) (DataC-45List1-forget e-1) '()) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45ESC-45Codegen-stmt arg-0 arg-1 arg-2 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons e-6 '()))))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))))) (let ((e-4 (unbox arg-0))) (if (null? e-4) (case (vector-ref arg-3 0) ((0) (let ((e-17 (vector-ref arg-3 1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 4 "return") (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc e-5 (vector 4 ";")))))))) (CompilerC-45ESC-45Codegen-exp arg-1 arg-2 e-17) eta-0))))(else (lambda (clam-0) (case (vector-ref arg-3 0) ((4) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (CompilerC-45ESC-45Codegen-n--16846-7403-u--alt e-4 e-9 e-8 e-7 arg-2 arg-1 arg-0 e-4 eta-0) eta-1))) e-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (if (null? e-9) (vector 1 '()) (let ((e-2 (unbox e-9))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 arg-2 e-2))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Codegen-switch (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-minimal e-11 e-7) (vector 4 ".h")) e-5 e-10))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((5) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (lambda (eta-2) (CompilerC-45ESC-45Codegen-n--16846-7666-u--alt e-4 e-13 e-12 e-11 arg-2 arg-1 arg-0 eta-0 eta-2)) eta-1))) e-12 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (if (null? e-13) (vector 1 '()) (let ((e-2 (unbox e-13))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 arg-2 e-2))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45ESC-45Codegen-exp arg-1 arg-2 e-11) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Codegen-switch e-7 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((6) (let ((e-15 (vector-ref arg-3 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc e-15)) (vector 4 ";")))))(else (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ESC-45Codegen-stmt '() arg-1 arg-2 eta-0)) (DataC-45List1-forget e-1) '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45ESC-45Codegen-stmt arg-0 arg-1 arg-2 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons e-6 '()))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) (let ((e-16 (unbox e-4))) (case (vector-ref arg-3 0) ((2) (let ((e-19 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Doc-hcat (cons (CompilerC-45ESC-45Codegen-var e-5 e-16) (cons CompilerC-45ESC-45Doc-softEq (cons e-6 (cons (vector 4 ";") '())))))))))) (CompilerC-45ESC-45Codegen-exp arg-1 arg-2 e-19) eta-1)))) eff-0) eta-0))))))))(else (lambda (clam-1) (case (vector-ref arg-3 0) ((4) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (CompilerC-45ESC-45Codegen-n--16846-7403-u--alt e-4 e-9 e-8 e-7 arg-2 arg-1 arg-0 e-4 eta-0) eta-1))) e-8 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (if (null? e-9) (vector 1 '()) (let ((e-2 (unbox e-9))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 arg-2 e-2))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Codegen-switch (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-minimal e-11 e-7) (vector 4 ".h")) e-5 e-10))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) ((5) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (CompilerC-45ESC-45Codegen-insertBreak e-4 e-5)))))) (lambda (eta-2) (CompilerC-45ESC-45Codegen-n--16846-7666-u--alt e-4 e-13 e-12 e-11 arg-2 arg-1 arg-0 eta-0 eta-2)) eta-1))) e-12 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (if (null? e-13) (vector 1 '()) (let ((e-2 (unbox e-13))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-stmt (box e-4) arg-1 arg-2 e-2))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45ESC-45Codegen-exp arg-1 arg-2 e-11) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Codegen-switch e-7 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) ((6) (let ((e-15 (vector-ref arg-3 1))) (vector 1 (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Codegen-jsCrashExp (CompilerC-45ESC-45Codegen-jsStringDoc e-15)) (vector 4 ";")))))(else (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45ESC-45Codegen-stmt '() arg-1 arg-2 eta-0)) (DataC-45List1-forget e-1) '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45ESC-45Codegen-stmt arg-0 arg-1 arg-2 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons e-6 '()))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))))))
(define CompilerC-45ESC-45ToAst-assign (lambda (arg-0 ext-0) (if (null? arg-0) (vector 0 ext-0) (let ((e-0 (unbox arg-0))) (vector 2 e-0 ext-0)))))
(define CompilerC-45ESC-45State-projections (lambda (arg-0 arg-1 arg-2) (let ((u--ps (DataC-45List-u--zip_Zippable_List (PreludeC-45Types-u--rangeFromTo_Range_Nat 1 (PreludeC-45TypesC-45List-lengthTR arg-2)) arg-2))) (CoreC-45Core-traverse_ (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CompilerC-45ESC-45State-addLocal arg-0 e-3 (vector 1 e-2 arg-1))))) u--ps))))
(define CompilerC-45ESC-45ToAst-tag (lambda (arg-0 arg-1) (if (null? arg-1) (vector 1 arg-0) (let ((e-2 (unbox arg-1))) (vector 0 e-2 arg-0)))))
(define CompilerC-45ESC-45ToAst-conAlt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((act-1 ((CompilerC-45ESC-45State-projections arg-0 arg-2 e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector (CompilerC-45ESC-45ToAst-tag e-0 e-2) e-1 e-6)))))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4) ext-0)))))))))))
(define CompilerC-45ESC-45ToAst-constAlt (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (car arg-2))) (let ((e-1 (cdr arg-2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-0 e-5)))))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-1) ext-0)))))
(define CompilerC-45ESC-45Ast-declare (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-1 (vector-ref arg-1 2))) (vector 1 arg-0 e-1))) ((7) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (vector 7 e-3 (CompilerC-45ESC-45Ast-declare arg-0 e-4)))))(else (vector 3 arg-0 arg-1)))))
(define CompilerC-45ESC-45State-getOrRegisterLocal (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45SortedMap-lookup arg-1 (let ((e-10 (vector-ref e-5 5))) e-10))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector 0 e-6)))))) (lambda (eta-0) (CompilerC-45ESC-45State-registerLocal arg-0 arg-1 eta-0)) clam-0) (let ((e-2 (unbox e-5))) (vector 1 e-2)))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45ToAst-getInteger (lambda (arg-0) (case (vector-ref arg-0 0) ((12) (let ((e-1 (vector-ref arg-0 2))) (case (vector-ref e-1 0) ((5) (let ((e-2 (vector-ref e-1 1))) (box e-2)))(else (CompilerC-45ESC-45ToAst-integerArith arg-0)))))(else (CompilerC-45ESC-45ToAst-integerArith arg-0)))))
(define CompilerC-45ESC-45ToAst-integerArith (lambda (arg-0) (case (vector-ref arg-0 0) ((6) (let ((e-0 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 3))) (let ((e-3 (vector-ref arg-0 4))) (cond ((equal? e-0 0) '())(else (let ((e-4 (- e-0 1))) (cond ((equal? e-4 0) '())(else (let ((e-5 (- e-4 1))) (cond ((equal? e-5 0) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (cond ((equal? e-6 5) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (if (null? e-11) '() (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (if (null? e-15) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (box (lambda (eta-0) (lambda (eta-1) (+ eta-0 eta-1)))) (CompilerC-45ESC-45ToAst-getInteger e-10)) (CompilerC-45ESC-45ToAst-getInteger e-14)) '()))))))))(else '())))) ((2) (let ((e-7 (vector-ref e-2 1))) (cond ((equal? e-7 5) (if (null? e-3) '() (let ((e-19 (car e-3))) (let ((e-20 (cdr e-3))) (if (null? e-20) '() (let ((e-23 (car e-20))) (let ((e-24 (cdr e-20))) (if (null? e-24) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (box (lambda (eta-0) (lambda (eta-1) (* eta-0 eta-1)))) (CompilerC-45ESC-45ToAst-getInteger e-19)) (CompilerC-45ESC-45ToAst-getInteger e-23)) '()))))))))(else '()))))(else '())))(else '()))))))))))))(else '()))))
(define CompilerC-45ESC-45ToAst-n--8471-8039-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 2))) (let ((e-2 (vector-ref arg-4 3))) (CompilerC-45ESC-45ToAst-n--8471-8039-u--go arg-0 arg-1 arg-2 (cons e-1 arg-3) e-2))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45State-registerLocal arg-2 eta-1 eta-2))) (PreludeC-45TypesC-45List-reverse arg-3) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-2 1))) (vector 1 (vector 1 e-5 e-6)))))) (CompilerC-45ESC-45ToAst-stmt arg-2 '() arg-4) eta-1)))) eff-0) eta-0))))))))))
(define CompilerC-45ESC-45ToAst-lambda (lambda (arg-0 arg-1 arg-2) (CompilerC-45ESC-45ToAst-n--8471-8039-u--go arg-2 arg-1 arg-0 (cons arg-1 '()) arg-2)))
(define CompilerC-45ESC-45ToAst-lift (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CompilerC-45ESC-45State-nextLocal arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45ESC-45ToAst-stmt arg-1 (box e-5) arg-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--pair (cons (cons (CompilerC-45ESC-45Ast-declare e-5 e-6) '()) (arg-4 e-5)))) (lambda (clam-0) (case (vector-ref e-6 0) ((2) (let ((e-1 (vector-ref e-6 2))) (vector 1 (PreludeC-45Types-maybe (lambda () u--pair) (lambda () (lambda (__infixTupleSection-0) (cons '() __infixTupleSection-0))) (arg-3 e-1)))))(else (vector 1 u--pair))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45ToAst-liftArg (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CompilerC-45ESC-45ToAst-lift arg-0 arg-1 (lambda (u--e) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) u--e) (PreludeC-45Interfaces-guard csegen-258 (e-5 u--e)))) (lambda (eta-1) (vector 0 (vector 0 eta-1))) eta-0)))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45ToAst-liftArgs (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-liftArg arg-0 eta-0 eta-1))) arg-1 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (Builtin-fst eta-1)) e-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-5)))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45ToAst-liftArgsVect (lambda (arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45Core-traverseVect (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-liftArg arg-1 eta-0 eta-1))) arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 csegen-57 (lambda (eta-1) (Builtin-fst eta-1)) e-5) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-1) (Builtin-snd eta-1)) e-5)))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45ToAst-liftFun (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CompilerC-45ESC-45ToAst-lift arg-0 arg-1 (lambda (u--e) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) u--e) (PreludeC-45Interfaces-guard csegen-258 (e-5 u--e)))) (lambda (eta-1) (vector 0 (vector 0 eta-1))) eta-0)))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Ast-toMinimal (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define CompilerC-45ESC-45ToAst-liftMinimal (lambda (arg-0 arg-1 ext-0) (CompilerC-45ESC-45ToAst-lift arg-0 arg-1 (lambda (eta-0) (CompilerC-45ESC-45Ast-toMinimal eta-0)) (lambda (eta-0) (vector 0 eta-0)) ext-0)))
(define CompilerC-45ESC-45Ast-prepend (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (vector 7 (cons e-2 e-3) arg-2))))))
(define CompilerC-45ESC-45ToAst-stmt (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 0 e-5))))))) (lambda (eta-1) (CompilerC-45ESC-45State-getOrRegisterLocal arg-0 e-1 eta-1)) eta-0)))) ((1) (let ((e-3 (vector-ref arg-2 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 0 (vector 0 e-5)))))))) (lambda (eta-1) (CompilerC-45ESC-45State-getOrRegisterRef arg-0 e-3 eta-1)) eta-0)))) ((2) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 e-7)))))) (CompilerC-45ESC-45ToAst-lambda arg-0 e-5 e-6) eta-0))))) ((3) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45State-nextLocal arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45ESC-45ToAst-stmt arg-0 (box e-5) e-9) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CompilerC-45ESC-45State-addLocal arg-0 e-8 (vector 0 e-5)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-10) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45ESC-45Ast-prepend (cons (CompilerC-45ESC-45Ast-declare e-5 e-6) '()) e-12))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((4) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45ToAst-liftFun arg-0 e-12 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (CompilerC-45ESC-45ToAst-liftArgs arg-0 e-13 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (CompilerC-45ESC-45Ast-prepend (PreludeC-45TypesC-45List-tailRecAppend e-2 e-7) (CompilerC-45ESC-45ToAst-assign arg-1 (vector 2 e-3 e-4))))))))) eff-0) clam-0)))))))))) eff-0) eta-0))))))))) ((5) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (let ((e-18 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45ToAst-liftArgs arg-0 e-18 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 3 (CompilerC-45ESC-45ToAst-tag e-15 e-17) e-16 e-3))))))))) eff-0) eta-0))))))))))) ((6) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (let ((u--o (vector 6 e-19 e-20 e-21 e-22))) (lambda (clam-3) (let ((sc1 (CompilerC-45ESC-45ToAst-integerArith u--o))) (if (null? sc1) (let ((act-1 (CompilerC-45ESC-45ToAst-liftArgsVect arg-0 e-22 clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 4 e-21 e-3))))))))) eff-0) clam-3))))) (let ((e-1 (unbox sc1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 6 (vector 5 e-1)))))))))))))) ((7) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45ToAst-liftArgs arg-0 e-25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 5 e-24 e-3))))))))) eff-0) eta-0))))))))) ((8) (let ((e-28 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45ToAst-liftFun arg-0 e-28 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-6) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 2 e-3 '()))))))))) eff-0) eta-0)))))))) ((9) (let ((e-31 (vector-ref arg-2 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 1 '() e-5))))))) (CompilerC-45ESC-45ToAst-stmt arg-0 '() e-31) eta-0)))) ((10) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (let ((e-35 (vector-ref arg-2 4))) (if (null? e-34) (if (null? e-35) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-11) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 eta-1 eta-2))) e-34 '()) clam-11))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (if (null? e-35) (vector 1 '()) (let ((e-4 (unbox e-35))) ((let ((eff-0 (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 4 arg-1 e-3 e-6 e-7)))))) eff-0) eta-1)))))))) eff-0) clam-11)))))))))) eff-0) eta-0)))))) (let ((e-52 (unbox e-35))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-52))) (let ((e-46 (car e-34))) (let ((e-47 (cdr e-34))) (lambda (clam-0) (if (null? e-47) (if (null? e-35) (let ((act-1 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-8) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-6 2))) e-4)))))) (lambda (eta-0) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 e-46 eta-0)) clam-8))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 e-6))))) eff-0) clam-8)))))))))) eff-0) clam-0))))) (let ((act-1 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-9) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 eta-0 eta-1))) e-34 '()) clam-9))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (if (null? e-35) (vector 1 '()) (let ((e-4 (unbox e-35))) ((let ((eff-0 (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 4 arg-1 e-3 e-6 e-7)))))) eff-0) eta-0)))))))) eff-0) clam-9)))))))))) eff-0) clam-0)))))) (let ((act-1 (CompilerC-45ESC-45ToAst-liftMinimal arg-0 e-33 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-10) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-conAlt arg-0 arg-1 e-3 eta-0 eta-1))) e-34 '()) clam-10))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (if (null? e-35) (vector 1 '()) (let ((e-4 (unbox e-35))) ((let ((eff-0 (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 4 arg-1 e-3 e-6 e-7)))))) eff-0) eta-0)))))))) eff-0) clam-10)))))))))) eff-0) clam-0)))))))))))))) ((11) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (if (null? e-38) (if (null? e-39) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45ToAst-liftArg arg-0 e-37 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-16) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 eta-1 eta-2))) e-38 '()) clam-16))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (if (null? e-39) (vector 1 '()) (let ((e-4 (unbox e-39))) ((let ((eff-0 (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 5 arg-1 e-3 e-6 e-7)))))) eff-0) eta-1)))))))) eff-0) clam-16)))))))))) eff-0) eta-0)))))) (let ((e-60 (unbox e-39))) (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-60))) (let ((e-54 (car e-38))) (let ((e-55 (cdr e-38))) (lambda (clam-1) (if (null? e-55) (if (null? e-39) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (cdr e-5))) e-2)))))) (lambda (eta-0) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 e-54 eta-0)) clam-1) (let ((act-1 (CompilerC-45ESC-45ToAst-liftArg arg-0 e-37 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-14) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 eta-0 eta-1))) e-38 '()) clam-14))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (if (null? e-39) (vector 1 '()) (let ((e-4 (unbox e-39))) ((let ((eff-0 (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 5 arg-1 e-3 e-6 e-7)))))) eff-0) eta-0)))))))) eff-0) clam-14)))))))))) eff-0) clam-1)))))) (let ((act-1 (CompilerC-45ESC-45ToAst-liftArg arg-0 e-37 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-15) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45ESC-45ToAst-constAlt arg-0 arg-1 eta-0 eta-1))) e-38 '()) clam-15))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (if (null? e-39) (vector 1 '()) (let ((e-4 (unbox e-39))) ((let ((eff-0 (CompilerC-45ESC-45ToAst-stmt arg-0 arg-1 e-4))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45ESC-45Ast-prepend e-2 (vector 5 arg-1 e-3 e-6 e-7)))))) eff-0) eta-0)))))))) eff-0) clam-15)))))))))) eff-0) clam-1)))))))))))))) ((12) (let ((e-41 (vector-ref arg-2 2))) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 6 e-41)))))) ((13) (lambda (eta-0) (vector 1 (CompilerC-45ESC-45ToAst-assign arg-1 (vector 7 ))))) (else (let ((e-44 (vector-ref arg-2 2))) (lambda (eta-0) (vector 1 (vector 6 e-44))))))))
(define PreludeC-45Types-u--toList_Foldable_Maybe (lambda (ext-0) (PreludeC-45Types-u--foldr_Foldable_Maybe csegen-103 '() ext-0)))
(define CompilerC-45ESC-45Codegen-def (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((act-1 ((CompilerC-45ESC-45State-reset arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compiler.javascript.doc" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Looking up " (cons (CoreC-45Name-u--show_Show_Name e-0) '())))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 ((CoreC-45Context-lookupCtxtExact e-0 (let ((e-38 (vector-ref e-6 0))) e-38)) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-8) (vector 1 '()) (let ((e-3 (unbox e-8))) (let ((sc5 (CoreC-45Name-dropNS e-0))) (case (vector-ref sc5 0) ((1) (let ((act-5 (IdrisC-45DocC-45String-prettyType arg-0 arg-1 (lambda (eta-1) (vector 0 )) (let ((e-29 (vector-ref e-3 2))) e-29) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (vector 4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 e-9))))))) eff-0) clam-0))))))(else (vector 1 '()))))))))) eff-0) eta-0)))))))))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CompilerC-45ESC-45State-getOrRegisterRef arg-2 e-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CompilerC-45ESC-45State-registerLocal arg-2 eta-3 eta-4))) e-1 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-3 (vector-ref eta-4 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref eta-4 1))) (vector 1 (let ((e-18 (vector-ref e-10 0))) e-18)))))) (lambda (eta-4) (let ((act-6 (unbox arg-2))) (vector 1 act-6))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 ((CompilerC-45ESC-45ToAst-stmt arg-2 '() e-2) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (CompilerC-45ESC-45Codegen-stmt (box '()) arg-2 arg-3 e-11))) eff-0) eta-4))))))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--cmt (vector 3 (CompilerC-45ESC-45Doc-hsep (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-0)) (PreludeC-45Types-u--toList_Foldable_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-5) (CompilerC-45ESC-45Doc-C-60C-43C-43C-62 (vector 4 ":") arg-5)) e-7))))))) (lambda (clam-2) (if (null? e-9) (let ((act-8 (let ((act-8 (unbox arg-3))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (CompilerC-45ESC-45Codegen-printDoc e-10 (CompilerC-45ESC-45Doc-vcat (cons u--cmt (cons (CompilerC-45ESC-45Codegen-constant (CompilerC-45ESC-45Codegen-var e-12 e-8) (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--C-60C-43C-62_Semigroup_Doc (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "__lazy(") (CompilerC-45ESC-45Codegen-function CompilerC-45ESC-45Doc-u--neutral_Monoid_Doc '() e-11)) (vector 4 ")"))) '())))))))) eff-0) clam-2))))) (let ((act-8 (let ((act-8 (unbox arg-3))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-3))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (CompilerC-45ESC-45Codegen-printDoc e-10 (CompilerC-45ESC-45Doc-vcat (cons u--cmt (cons (CompilerC-45ESC-45Codegen-function (CompilerC-45ESC-45Codegen-var e-12 e-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-7) (CompilerC-45ESC-45Codegen-var e-13 eta-7)) e-9) e-11) '())))))))) eff-0) eta-5)))))))) eff-0) clam-2)))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))
(define CompilerC-45ESC-45Codegen-stringList (lambda (ext-0) (PreludeC-45Types-fastConcat (DataC-45List-intersperse "," (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) ext-0)))))
(define CompilerC-45ESC-45Codegen-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeForeign-5806 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((act-1 (CoreC-45Directory-readDataFile arg-4 (string-append "js/" (string-append e-3 ".js")) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45ESC-45State-addToPreamble arg-3 e-3 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 (CompilerC-45ESC-45Codegen-constant arg-5 (vector 4 (string-append e-3 (string-append "_" e-2))))))))))) eff-0) ext-0)))))))))
(define CompilerC-45ESC-45Codegen-makeForeign (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (CompilerC-45ESC-45Codegen-var e-5 e-6)))))) (lambda (eta-1) (CompilerC-45ESC-45State-getOrRegisterRef arg-1 arg-3 eta-1)) eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (CompilerC-45ESC-45Codegen-readCCPart arg-4))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cond ((equal? e-2 "lambda") (lambda (eta-0) (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (CompilerC-45ESC-45Doc-paren (vector 4 e-3)))))) ((equal? e-2 "support") (lambda (eta-0) (CompilerC-45ESC-45Codegen-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeForeign-5806 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-3 "support" (CompilerC-45ESC-45Codegen-breakDrop1 #\, e-3) eta-0))) ((equal? e-2 "stringIterator") (lambda (clam-0) (cond ((equal? e-3 "new") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "__prim_stringIteratorNew")))) ((equal? e-3 "next") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "__prim_stringIteratorNext")))) ((equal? e-3 "toString") (vector 1 (CompilerC-45ESC-45Codegen-constant e-5 (CompilerC-45ESC-45Doc-u--fromString_FromString_Doc "__prim_stringIteratorToString"))))(else (CompilerC-45ESC-45State-errorConcat (cons "Invalid string iterator function: " (cons e-3 (cons ". " (cons "Supported functions are: " (cons (CompilerC-45ESC-45Codegen-stringList (cons "new" (cons "next" (cons "toString" '())))) (cons "." '())))))) clam-0)))))(else (lambda (eta-0) (CompilerC-45ESC-45State-errorConcat (cons "Invalid foreign type : " (cons e-2 (cons ". " (cons "Supported types are: " (cons (CompilerC-45ESC-45Codegen-stringList (cons "lambda" (cons "support" (cons "stringIterator" '())))) '()))))) eta-0))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Codegen-foreignDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-4838 (lambda (eta-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (CompilerC-45ESC-45Codegen-searchForeign e-5 arg-4))) (case (vector-ref sc1 0) ((1) (let ((e-2 (vector-ref sc1 1))) (CompilerC-45ESC-45Codegen-makeForeign arg-0 arg-1 arg-2 arg-3 e-2 clam-0))) (else (let ((e-6 (vector-ref sc1 1))) (CompilerC-45ESC-45State-errorConcat (cons "No supported backend found in the definition of " (cons (CoreC-45Name-u--show_Show_Name arg-3) (cons ". " (cons "Supported backends: " (cons (CompilerC-45ESC-45Codegen-stringList e-5) (cons ". " (cons "Backends in definition: " (cons (CompilerC-45ESC-45Codegen-stringList e-6) (cons "." '()))))))))) clam-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Codegen-foreign (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (if (null? e-3) (vector 1 '()) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((2) (let ((e-8 (vector-ref e-7 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--pure_Applicative_List (CompilerC-45ESC-45Doc-pretty e-5))))))) (lambda (eta-0) (CompilerC-45ESC-45Codegen-foreignDecl arg-1 arg-0 arg-2 e-2 e-8 eta-0)) clam-0)))(else (vector 1 '())))))))))))
(define CompilerC-45ESC-45TailRec-hasTailCalls (lambda (arg-0 arg-1) (if (null? arg-1) 1 (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (LibrariesC-45DataC-45SortedSet-contains e-1 eta-0))) (LibrariesC-45DataC-45SortedMap-lookup e-1 arg-0)) 1))))))
(define CompilerC-45ESC-45TailRec-tailCalls (lambda (arg-0) (case (vector-ref arg-0 0) ((3) (let ((e-3 (vector-ref arg-0 4))) (CompilerC-45ESC-45TailRec-tailCalls e-3))) ((4) (let ((e-5 (vector-ref arg-0 2))) (case (vector-ref e-5 0) ((1) (let ((e-16 (vector-ref e-5 2))) (LibrariesC-45DataC-45SortedSet-singleton csegen-861 e-16)))(else csegen-862)))) ((10) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (lamc-0) (let ((e-4 (vector-ref lamc-0 4))) (CompilerC-45ESC-45TailRec-tailCalls e-4))) e-9) (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-2558 (lambda (eta-0) (CompilerC-45ESC-45TailRec-tailCalls eta-0)) e-10))))) ((11) (let ((e-13 (vector-ref arg-0 3))) (let ((e-14 (vector-ref arg-0 4))) (LibrariesC-45DataC-45SortedSet-u--C-60C-43C-62_Semigroup_C-40SortedSetC-32C-36kC-41 csegen-861 (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (lamc-0) (let ((e-1 (cdr lamc-0))) (CompilerC-45ESC-45TailRec-tailCalls e-1))) e-13) (PreludeC-45Types-u--foldMap_Foldable_Maybe csegen-2558 (lambda (eta-0) (CompilerC-45ESC-45TailRec-tailCalls eta-0)) e-14)))))(else csegen-862))))
(define CompilerC-45ESC-45TailRec-indices (lambda (arg-1) (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 1 (blodwen-toSignedInt (PreludeC-45TypesC-45List-lengthTR arg-1) 63))))
(define CompilerC-45ESC-45TailRec-zipWithIndices (lambda (arg-1) (DataC-45List-u--zip_Zippable_List (CompilerC-45ESC-45TailRec-indices arg-1) arg-1)))
(define CompilerC-45ESC-45TailRec-n--7866-4672-u--fun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45SortedMap-lookup e-3 arg-2) (lambda (_-0) (let ((e-4 (cdr _-0))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (box (cons e-3 (vector e-3 e-2 e-6 e-7))))))))))))
(define CompilerC-45ESC-45TailRec-toGroup (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((u--ns (CompilerC-45ESC-45TailRec-zipWithIndices (DataC-45List1-forget e-3)))) (cons e-2 (LibrariesC-45DataC-45SortedMap-fromList csegen-861 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--7866-4672-u--fun e-2 e-3 arg-0 eta-0)) u--ns))))))))
(define LibrariesC-45DataC-45SortedMap-treeMap (lambda (arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 1))) (let ((e-4 (vector-ref arg-6 2))) (vector 0 e-3 (arg-5 e-4))))) ((1) (let ((e-9 (vector-ref arg-6 1))) (let ((e-10 (vector-ref arg-6 2))) (let ((e-11 (vector-ref arg-6 3))) (vector 1 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-9) e-10 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-11)))))) (else (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (vector 2 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-16) e-17 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-18) e-19 (LibrariesC-45DataC-45SortedMap-treeMap arg-5 e-20)))))))))))
(define LibrariesC-45DataC-45SortedMap-u--map_Functor_C-40SortedMapC-32C-36kC-41 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (vector 1 e-5 e-6 (LibrariesC-45DataC-45SortedMap-treeMap arg-3 e-7)))))))))
(define CompilerC-45ESC-45TailRec-tailCallGroups (lambda (arg-0) (let ((u--funMap (LibrariesC-45DataC-45SortedMap-fromList csegen-861 (PreludeC-45TypesC-45List-mapAppend '() csegen-4854 arg-0)))) (let ((u--graph (LibrariesC-45DataC-45SortedMap-u--map_Functor_C-40SortedMapC-32C-36kC-41 (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (CompilerC-45ESC-45TailRec-tailCalls e-7)))) u--funMap))) (let ((u--groups (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-hasTailCalls u--graph eta-0)) (LibrariesC-45DataC-45Graph-tarjan csegen-861 u--graph)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-toGroup u--funMap eta-0)) (CompilerC-45ESC-45TailRec-zipWithIndices u--groups)))))))
(define PreludeC-45EqOrd-comparing (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-2 1))) ((e-2 (arg-3 arg-4)) (arg-3 arg-5)))))
(define CompilerC-45ESC-45TailRec-tcContinueName (lambda (arg-0 arg-1) (vector 2 (string-append "TcContinue" (PreludeC-45Show-u--show_Show_Int arg-0)) arg-1)))
(define CompilerC-45ESC-45TailRec-n--8136-4915-u--con (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (vector e-0 e-1 e-2 e-3 (CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4)))))))))
(define CompilerC-45ESC-45TailRec-n--8136-4916-u--const (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-0 (car arg-6))) (let ((e-1 (cdr arg-6))) (cons e-0 (CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1))))))
(define CompilerC-45ESC-45TailRec-n--8136-4917-u--tcContinue (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (vector 5 (vector 2 ) (CompilerC-45ESC-45TailRec-tcContinueName arg-1 arg-6) (vector 0 ) (box arg-6) ext-0)))
(define CompilerC-45ESC-45TailRec-tcDoneName (lambda (arg-0) (vector 2 "TcDone" arg-0)))
(define CompilerC-45ESC-45TailRec-n--8136-4918-u--tcDone (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 5 (vector 2 ) (CompilerC-45ESC-45TailRec-tcDoneName arg-1) (vector 0 ) (box 0) (cons arg-6 '()))))
(define CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-0 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-6 2))) (let ((e-2 (vector-ref arg-6 3))) (let ((e-3 (vector-ref arg-6 4))) (vector 3 e-0 e-1 e-2 (CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))))))) ((4) (let ((e-4 (vector-ref arg-6 1))) (let ((e-5 (vector-ref arg-6 2))) (let ((e-6 (vector-ref arg-6 3))) (case (vector-ref e-5 0) ((1) (let ((e-17 (vector-ref e-5 1))) (let ((e-18 (vector-ref e-5 2))) (let ((u--x (vector 4 e-4 (vector 1 e-17 e-18) e-6))) (let ((sc2 (LibrariesC-45DataC-45SortedMap-lookup e-18 arg-0))) (if (null? sc2) (CompilerC-45ESC-45TailRec-n--8136-4918-u--tcDone arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--x) (let ((e-1 (unbox sc2))) (CompilerC-45ESC-45TailRec-n--8136-4917-u--tcContinue arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-7 (vector-ref e-1 1))) e-7) e-6))))))))(else (CompilerC-45ESC-45TailRec-n--8136-4918-u--tcDone arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6))))))) ((10) (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 3))) (let ((e-10 (vector-ref arg-6 4))) (vector 10 e-7 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8136-4915-u--con arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-9) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-10))))))) ((11) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (vector 11 e-11 e-12 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8136-4916-u--const arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-13) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-14))))))) ((14) arg-6)(else (CompilerC-45ESC-45TailRec-n--8136-4918-u--tcDone arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)))))
(define CompilerC-45ESC-45TailRec-conAlt (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (let ((e-2 (vector-ref arg-1 0))) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((u--name (CompilerC-45ESC-45TailRec-tcContinueName e-0 e-3))) (vector u--name (vector 0 ) (box e-3) e-4 (CompilerC-45ESC-45TailRec-n--8136-4919-u--toTc e-1 e-0 e-5 e-4 e-3 e-2 e-5)))))))))))
(define CompilerC-45ESC-45TailRec-tcArgName (vector 2 "$a" 0))
(define LibrariesC-45DataC-45SortedMap-values (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (LibrariesC-45DataC-45SortedMap-toList ext-0))))
(define CompilerC-45ESC-45TailRec-n--8322-5075-u--local (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (vector 0 (vector 2 ) ext-0)))
(define CompilerC-45ESC-45TailRec-tcFunction (lambda (ext-0) (vector 2 "$tcOpt" ext-0)))
(define CompilerC-45ESC-45TailRec-n--8322-5076-u--tcFun (lambda (arg-0 arg-1 arg-2 arg-3) (CompilerC-45ESC-45TailRec-tcFunction arg-1)))
(define CompilerC-45ESC-45TailRec-n--8322-5077-u--toFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((u--exps (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8322-5075-u--local arg-0 arg-1 arg-2 arg-3 eta-0)) e-2))) (let ((u--tcArg (vector 5 (vector 2 ) (CompilerC-45ESC-45TailRec-tcContinueName arg-1 e-1) (vector 0 ) (box e-1) u--exps))) (let ((u--tcFun (vector 1 (vector 2 ) (CompilerC-45ESC-45TailRec-n--8322-5076-u--tcFun arg-0 arg-1 arg-2 arg-3)))) (let ((u--body (vector 4 (vector 2 ) (vector 1 (vector 2 ) arg-3) (cons u--tcFun (cons u--tcArg '()))))) (vector e-0 e-2 u--body))))))))))
(define CompilerC-45ESC-45TailRec-convertTcGroup (lambda (arg-0 arg-1) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((u--functions (DataC-45List-sortBy (lambda (eta-0) (lambda (eta-1) (PreludeC-45EqOrd-comparing csegen-231 (lambda (eta-2) (let ((e-4 (vector-ref eta-2 1))) e-4)) eta-0 eta-1))) (LibrariesC-45DataC-45SortedMap-values e-1)))) (let ((u--branches (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-conAlt arg-1 eta-0)) u--functions))) (let ((u--switch (vector 10 (vector 2 ) (CompilerC-45ESC-45TailRec-n--8322-5075-u--local e-1 e-0 arg-1 arg-0 CompilerC-45ESC-45TailRec-tcArgName) u--branches '()))) (cons (vector (CompilerC-45ESC-45TailRec-n--8322-5076-u--tcFun e-1 e-0 arg-1 arg-0) (cons CompilerC-45ESC-45TailRec-tcArgName '()) u--switch) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8322-5077-u--toFun e-1 e-0 arg-1 arg-0 eta-0)) u--functions)))))))))
(define CompilerC-45ESC-45TailRec-n--8406-5168-u--toFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (LibrariesC-45DataC-45SortedSet-contains e-2 arg-2))) (cond ((equal? sc2 1) '()) (else (box (vector e-2 e-6 e-7)))))))))))
(define CompilerC-45ESC-45TailRec-tailRecOptim (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--regular (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8406-5168-u--toFun arg-3 arg-2 arg-1 arg-0 eta-0)) arg-3))) (let ((u--tailOpt (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CompilerC-45ESC-45TailRec-convertTcGroup arg-2 eta-0)) arg-0))) (PreludeC-45TypesC-45List-tailRecAppend u--tailOpt u--regular)))))
(define CompilerC-45ESC-45TailRec-n--8506-5252-u--def (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) '() (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (box (cons e-2 (cons e-8 e-9))))))(else '())))))))))
(define CompilerC-45ESC-45TailRec-functions (lambda (arg-0 arg-1) (let ((u--ts (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CompilerC-45ESC-45TailRec-n--8506-5252-u--def arg-1 arg-0 eta-0)) arg-1))) (let ((u--groups (CompilerC-45ESC-45TailRec-tailCallGroups u--ts))) (let ((u--names (LibrariesC-45DataC-45SortedSet-fromList csegen-861 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (LibrariesC-45DataC-45SortedMap-keys (let ((e-1 (cdr eta-0))) e-1))) u--groups)))) (CompilerC-45ESC-45TailRec-tailRecOptim u--groups u--names arg-0 u--ts))))))
(define CompilerC-45ESC-45State-init (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector arg-0 arg-1 arg-2 0 0 csegen-4849 csegen-4849 (LibrariesC-45DataC-45SortedMap-empty csegen-519) arg-3 arg-4)))
(define LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse (lambda (arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) ((arg-3 e-1) e-2) ext-0)))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-1 1))) (vector 1 (lambda (u--rC-39) (vector 1 e-8 e-6 u--rC-39))))))) (lambda (eta-1) (LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse arg-3 e-5 eta-1)) eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse arg-3 e-7 eta-0)) ext-0))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (u--mC-39) (lambda (u--rC-39) (vector 2 e-5 e-11 u--mC-39 e-13 u--rC-39)))))))) (lambda (eta-2) (LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse arg-3 e-10 eta-2)) eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse arg-3 e-12 eta-1)) eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse arg-3 e-14 eta-0)) ext-0))))))))))
(define LibrariesC-45DataC-45NameMapC-45Traversable-traverseNameMap (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-2 e-5)))))) (lambda (eta-0) (LibrariesC-45DataC-45NameMapC-45Traversable-treeTraverse arg-2 e-3 eta-0)) ext-0))))))
(define CompilerC-45NoMangle-n--6867-13571-u--lookupBackend (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (DataC-45List-lookup csegen-22 e-2 arg-4))) (if (null? sc1) (CompilerC-45NoMangle-n--6867-13571-u--lookupBackend arg-0 arg-1 arg-2 e-3 arg-4) (let ((e-1 (unbox sc1))) (box (cons e-2 e-1))))))))))
(define CompilerC-45NoMangle-case--initNoMangle-13666 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (vector 2 ) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "No valid %export specifier for " (cons (CoreC-45Name-u--show_Show_Name arg-4) (cons "\xa;  Supported backends: " (cons (CoreC-45NameC-45Namespace-showSep ", " arg-1) (cons "\xa;  Given backends: " (cons (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-5)) '())))))))) eta-0)) (let ((e-1 (unbox arg-6))) (lambda (clam-0) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((sc2 (arg-0 e-6))) (cond ((equal? sc2 1) (vector 1 e-6)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (vector 2 ) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "\"" (cons e-6 (cons "\" is not a valid name on " (cons e-5 (cons " backend" '()))))))) clam-0)))))))))))
(define CompilerC-45NoMangle-initNoMangle (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (LibrariesC-45DataC-45NameMapC-45Traversable-traverseNameMap (lambda (u--name) (lambda (u--exps) (CompilerC-45NoMangle-case--initNoMangle-13666 arg-2 arg-1 arg-0 e-5 u--name u--exps (CompilerC-45NoMangle-n--6867-13571-u--lookupBackend arg-2 arg-1 arg-0 arg-1 u--exps)))) (let ((e-31 (vector-ref e-5 31))) e-31) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-newRef (vector "Compiler.NoMangle.NoMangleMap" ) e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Codegen-isArg (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((7) 0) ((4) (let ((e-5 (vector-ref e-1 1))) (if (null? e-5) 0 1))) ((5) (let ((e-9 (vector-ref e-1 1))) (if (null? e-9) 0 1))) ((6) 0)(else 1))))(else 1)))(else 1))))
(define CompilerC-45ESC-45Codegen-isFun (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 0)(else 1))))
(define CompilerC-45ESC-45Codegen-mainExpr (vector 2 "__mainExpression" 0))
(define CompilerC-45ESC-45Codegen-tailRec (vector 1 (vector 0 "__tailRec")))
(define CompilerC-45ESC-45Codegen-n--18024-8266-u--validNameChar (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45Types-isAlphaNum arg-1))) (cond ((equal? sc0 1) 1) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\_))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\$)))))))))
(define CompilerC-45ESC-45Codegen-case--validJSName-8305 (lambda (arg-0 arg-1) (cond ((equal? arg-0 "") (if (null? arg-1) (lambda () 1) (let ((e-0 (car arg-1))) (lambda () (let ((sc3 (PreludeC-45Types-isDigit e-0))) (cond ((equal? sc3 1) 0) (else 1)))))))(else (let ((e-0 (car arg-1))) (lambda () (let ((sc1 (PreludeC-45Types-isDigit e-0))) (cond ((equal? sc1 1) 0) (else 1)))))))))
(define CompilerC-45ESC-45Codegen-validJSName (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-22 arg-0 CompilerC-45ESC-45Codegen-jsReservedNames))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45ESC-45Codegen-n--18024-8266-u--validNameChar arg-0 eta-0)) (PreludeC-45Types-fastUnpack arg-0)))) (cond ((equal? sc1 1) ((CompilerC-45ESC-45Codegen-case--validJSName-8305 arg-0 (DataC-45String-strM arg-0)))) (else 0))))))))
(define CompilerC-45ESC-45Codegen-compileToES (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CompilerC-45NoMangle-initNoMangle arg-0 arg-4 (lambda (eta-0) (CompilerC-45ESC-45Codegen-validJSName eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45Common-getCompileDataWith arg-0 arg-4 0 0 arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-getDirectives arg-0 arg-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--mode (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-22 "minimal" e-7))) (cond ((equal? sc3 1) 2) (else (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-22 "compact" e-7))) (cond ((equal? sc4 1) 1) (else 0)))))))) (lambda (eta-2) (let ((act-4 (let ((act-4 (let ((act-4 (unbox e-5))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Core-newRef (vector "Compiler.ES.State.ESs" ) (CompilerC-45ESC-45State-init u--mode (lambda (eta-3) (CompilerC-45ESC-45Codegen-isArg u--mode eta-3)) (lambda (eta-3) (CompilerC-45ESC-45Codegen-isFun eta-3)) arg-4 e-8)))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CompilerC-45ESC-45State-addRef e-8 CompilerC-45ESC-45Codegen-tailRec (vector 0 CompilerC-45ESC-45Codegen-tailRec)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((u--allDefs (cons (cons CompilerC-45ESC-45Codegen-mainExpr (cons (vector 2 ) (vector 0 '() (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-6 0))) e-0))))) (let ((e-2 (vector-ref e-6 2))) e-2)))) (let ((u--defs (CompilerC-45ESC-45TailRec-functions CompilerC-45ESC-45Codegen-tailRec u--allDefs))) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (CompilerC-45ESC-45Codegen-def arg-0 arg-1 e-8 e-5 eta-4 eta-5))) u--defs '()) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (PreludeC-45IO-u--map_Functor_IO csegen-2832 (CoreC-45Core-traverseC-39 (lambda (eta-5) (CompilerC-45ESC-45Codegen-foreign e-8 arg-0 e-5 eta-5)) u--allDefs '()) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (let ((act-8 (let ((act-8 (unbox e-5))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-7) (case (vector-ref eta-7 0) ((0) (let ((e-2 (vector-ref eta-7 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref eta-7 1))) (vector 1 (CompilerC-45ESC-45Doc-compact (CompilerC-45ESC-45Codegen-var e-12 e-13))))))) (lambda (eta-7) (CompilerC-45ESC-45State-getOrRegisterRef e-8 CompilerC-45ESC-45Codegen-mainExpr eta-7)) eta-6)))) eff-0) eta-5))))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--main (string-append "try{" (string-append e-12 "()}catch(e){if(e instanceof IdrisError){console.log('ERROR: ' + e.message)}else{throw e} }")))) (let ((u--allDecls (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-tailRecAppend e-11 e-10)))) (lambda (eta-6) (let ((act-9 (let ((act-9 (unbox e-8))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (CoreC-45Directory-readDataFile arg-0 "js/support.js" eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--pre (CoreC-45NameC-45Namespace-showSep "\xa;" (cons e-14 (LibrariesC-45DataC-45SortedMap-values (let ((e-17 (vector-ref e-13 7))) e-17)))))) (lambda (eta-8) (vector 1 (DataC-45String-fastUnlines (cons u--pre (cons u--allDecls (cons u--main '()))))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Javascript-compileToJS (lambda (arg-0 arg-1 arg-2 ext-0) (CompilerC-45ESC-45Codegen-compileToES arg-0 arg-1 (vector 5 ) arg-2 (cons "browser" (cons "javascript" '())) ext-0)))
(define CompilerC-45ESC-45Javascript-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CompilerC-45ESC-45Javascript-compileToJS arg-0 arg-1 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--res (CompilerC-45ESC-45Javascript-addHeaderAndFooter arg-5 e-5))) (let ((u--out (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (lambda (eta-0) (let ((act-2 ((CoreC-45Core-writeFile u--out u--res) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (box u--out)))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Javascript-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Javascript backend is only able to compile, use Node instead") ext-0)))
(define CompilerC-45ESC-45Javascript-codegenJavascript (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CompilerC-45ESC-45Javascript-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45ESC-45Javascript-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) '() '())))
(define CompilerC-45ESC-45Node-n--8966-1603-u--shebang (lambda (arg-0 arg-1 arg-2) "#!/usr/bin/env node\xa;"))
(define CompilerC-45ESC-45Node-compileToNode (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CompilerC-45ESC-45Codegen-compileToES arg-0 arg-1 (vector 4 ) arg-2 (cons "node" (cons "javascript" '())) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (CompilerC-45ESC-45Node-n--8966-1603-u--shebang arg-2 arg-1 arg-0) e-5))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Node-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CompilerC-45ESC-45Node-compileToNode arg-0 arg-1 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--out (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 arg-5))) (lambda (eta-0) (let ((act-2 ((CoreC-45Core-writeFile u--out e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (box u--out))))))))) eff-0) ext-0)))))))
(define CompilerC-45ESC-45Node-findNode (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "NODE") ext-0))) (if (null? act-1) (let ((act-2 (LibrariesC-45UtilsC-45Path-pathLookup (cons "node" '()) ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env node") act-2)) (let ((e-2 (unbox act-1))) e-2)))))
(define CompilerC-45ESC-45Node-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--outn (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "_tmp_node.js"))) (lambda (eta-0) (let ((act-1 (CompilerC-45ESC-45Node-compileToNode arg-0 arg-1 arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-writeFile u--outn e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (CompilerC-45ESC-45Node-findNode eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (vector 1 (string-append "\"" (string-append e-7 "\""))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-5 ((System-system csegen-82 (string-append e-8 (string-append " " u--outn))) world-0))) (vector 1 act-5))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-3))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))
(define CompilerC-45ESC-45Node-codegenNode (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CompilerC-45ESC-45Node-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45ESC-45Node-executeExpr eta-0 eta-1 eta-2 eta-3))))) '() '())))
(define CompilerC-45SchemeC-45Racket-mkArgs (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-2 0) ((18) (cons (cons (vector 2 "farg" arg-0) 0) (CompilerC-45SchemeC-45Racket-mkArgs arg-0 e-3)))(else (cons (cons (vector 2 "farg" arg-0) 1) (CompilerC-45SchemeC-45Racket-mkArgs (bs+ arg-0 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Racket-n--12438-1632-u--funTySpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((19) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-0 0) ((18) (CompilerC-45SchemeC-45Racket-n--12438-1632-u--funTySpec arg-0 arg-1 arg-2 arg-3 e-1))(else (CompilerC-45SchemeC-45Racket-n--12438-1632-u--funTySpec arg-0 arg-1 arg-2 (cons e-0 arg-3) e-1))))))(else (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Racket-cftySpec arg-2 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CompilerC-45SchemeC-45Racket-cftySpec arg-2 eta-2)) (PreludeC-45TypesC-45List-reverse arg-3) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(_fun " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-6) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " -> " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))
(define CompilerC-45SchemeC-45Racket-cftySpec (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_void" u--xs))))) ((1) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_int" u--xs))))) ((3) csegen-5016) ((4) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_int16" u--xs))))) ((5) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_int32" u--xs))))) ((6) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_int64" u--xs))))) ((7) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_uint8" u--xs))))) ((8) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_uint16" u--xs))))) ((9) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_uint32" u--xs))))) ((10) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_uint64" u--xs))))) ((11) (lambda (eta-0) (vector 1 (lambda (eta-1) (cons "_string/utf-8" eta-1))))) ((12) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_double" u--xs))))) ((13) csegen-5016) ((14) csegen-5036) ((15) csegen-5036) ((16) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "_bytes" u--xs))))) ((20) (let ((e-0 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Racket-cftySpec arg-0 e-0))) ((21) (let ((e-1 (vector-ref arg-1 1))) (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "_" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons e-1 eta-3)) (lambda (eta-3) (cons "-pointer" eta-3)) eta-2)) eta-1)))))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (CompilerC-45SchemeC-45Racket-n--12438-1632-u--funTySpec e-4 e-3 arg-0 (cons e-3 '()) e-4))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Can't pass argument of type " (string-append (CoreC-45CompileExpr-u--show_Show_CFType arg-1) " to foreign function"))) eta-0))))))
(define CompilerC-45SchemeC-45Racket-n--14117-3107-u--showFld (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CompilerC-45SchemeC-45Racket-cftySpec CoreC-45FC-emptyFC e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons "[" eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons e-2 eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons " " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons "]" u--xs)) eta-4)) eta-3)) eta-2)) eta-1)))))) eff-0) ext-0)))))))))
(define CompilerC-45SchemeC-45Racket-mkStruct (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((21) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-mkStruct arg-0 eta-1)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-1) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-22 e-0 e-6))) (cond ((equal? sc3 1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-2) eta-2) e-5))) (else (let ((act-3 (let ((act-3 (set-box! arg-0 (cons e-0 e-6)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-n--14117-3107-u--showFld e-1 e-0 arg-0 eta-2 eta-3))) e-1 '()) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-4) eta-4) e-5) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "(define-cstruct _" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-0 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " (" eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy "\xa;\x9;" e-8) (lambda (u--xs) (cons "))\xa;" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) clam-0)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45SchemeC-45Racket-mkStruct arg-0 e-2))) ((19) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 csegen-4896 (CompilerC-45SchemeC-45Racket-mkStruct arg-0 e-3) eta-1)) (CompilerC-45SchemeC-45Racket-mkStruct arg-0 e-4) eta-0)))))(else csegen-4898))))
(define CompilerC-45SchemeC-45Racket-case--getLibVers-1737 (lambda (arg-0 arg-1) (if (null? arg-1) (cons "" "") (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (let ((sc2 (DataC-45String-span csegen-4990 arg-0))) (let ((e-5 (car sc2))) (cons e-5 ""))) (cons (Builtin-fst (DataC-45String-span csegen-4990 e-2)) (string-append "'(" (string-append (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_String eta-0)) e-3)) " #f)")))))))))
(define CompilerC-45SchemeC-45Racket-getLibVers (lambda (arg-0) (CompilerC-45SchemeC-45Racket-case--getLibVers-1737 arg-0 (DataC-45String-words arg-0))))
(define CompilerC-45SchemeC-45Racket-cToRkt (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((13) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(integer->char " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-1 (lambda (u--xs) (cons ")" u--xs)) eta-1)) eta-0)))(else arg-1))))
(define CompilerC-45SchemeC-45Racket-handleRet (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-1 (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons " " eta-2)) (lambda (eta-2) (CompilerC-45SchemeC-45Common-schConstructor csegen-4998 (vector 1 (vector 0 "")) (box 0) '() eta-2)) eta-1)) eta-0)))(else (CompilerC-45SchemeC-45Racket-cToRkt arg-0 arg-1)))))
(define CompilerC-45SchemeC-45Racket-loadlib (lambda (arg-0 arg-1) (cond ((equal? arg-0 "libc") "(define-ffi-definer define-libc (ffi-lib #f))\xa;")(else (string-append "(define-ffi-definer define-" (string-append arg-0 (string-append " (ffi-lib \"" (string-append arg-0 (string-append "\" " (string-append arg-1 "))\xa;"))))))))))
(define CompilerC-45SchemeC-45Racket-rktToC (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((13) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(char->integer " eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-1 (lambda (u--xs) (cons ")" u--xs)) eta-1)) eta-0)))(else arg-1))))
(define CompilerC-45SchemeC-45Racket-n--12804-1955-u--applyLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) arg-9 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-2) (CompilerC-45SchemeC-45Racket-n--12804-1955-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-9 (lambda (u--xs) (cons " #f)" u--xs)) eta-1)) eta-0)) e-3) (let ((e-6 (unbox e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (CompilerC-45SchemeC-45Racket-n--12804-1955-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-9 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Racket-cToRkt e-10 e-9) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)) e-3))))))))))
(define CompilerC-45SchemeC-45Racket-n--12804-1958-u--mkNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) '() (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (case (vector-ref e-2 0) ((18) (cons '() (CompilerC-45SchemeC-45Racket-n--12804-1958-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3)))(else (cons (box (cons (lambda (eta-0) (cons (string-append "cb" (PreludeC-45Show-u--show_Show_Int arg-9)) eta-0)) e-2)) (CompilerC-45SchemeC-45Racket-n--12804-1958-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3)))))))))
(define CompilerC-45SchemeC-45Racket-n--12804-1957-u--mkFun (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--argns (CompilerC-45SchemeC-45Racket-n--12804-1958-u--mkNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 0 arg-9))) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(lambda (" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) (DataC-45List-catMaybes u--argns))) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons ") " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Racket-n--12804-1955-u--applyLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 u--argns) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))))
(define CompilerC-45SchemeC-45Racket-n--12804-1959-u--notWorld (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((18) 0)(else 1))))
(define CompilerC-45SchemeC-45Racket-n--12804-1956-u--callback (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((19) (let ((e-0 (vector-ref arg-11 1))) (let ((e-1 (vector-ref arg-11 2))) (CompilerC-45SchemeC-45Racket-n--12804-1956-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-0 arg-10) e-1))))(else (let ((u--args (PreludeC-45TypesC-45List-reverse arg-10))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-cftySpec arg-4 eta-1)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (CompilerC-45SchemeC-45Racket-n--12804-1959-u--notWorld arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-1)) u--args) '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Racket-cftySpec arg-4 arg-11) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (vector 1 (CompilerC-45SchemeC-45Racket-n--12804-1957-u--mkFun arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--args arg-11 arg-9))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))
(define CompilerC-45SchemeC-45Racket-n--12804-1960-u--useArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-3 0) ((19) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (CompilerC-45SchemeC-45Racket-n--12804-1956-u--callback arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (CompilerC-45SchemeC-45Common-schName e-2) (cons e-4 '()) e-5))))(else (lambda (eta-0) (vector 1 (CompilerC-45SchemeC-45Racket-rktToC e-3 (CompilerC-45SchemeC-45Common-schName e-2))))))))))
(define CompilerC-45SchemeC-45Racket-case--cCall-2185 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 e-2 arg-9))) (cond ((equal? sc1 1) (vector 1 "")) (else (let ((act-1 (let ((act-1 (set-box! arg-6 (cons e-2 arg-9)))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CompilerC-45Common-locate arg-7 arg-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 ((CompilerC-45Common-copyLib (cons (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-5 e-7) e-4)) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (vector 1 (CompilerC-45SchemeC-45Racket-loadlib e-2 e-3)))))))))) eff-0) ext-0))))))))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (u--a) (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Racket-cftySpec arg-4 (Builtin-snd u--a)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons u--a e-6))))) eff-0) eta-1))))))) arg-1 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45SchemeC-45Racket-cftySpec arg-4 arg-0) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-22 arg-3 arg-10))) (cond ((equal? sc4 1) csegen-4897) (else (let ((act-4 (let ((act-4 (set-box! arg-8 (cons arg-3 arg-10)))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(define-" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons e-2 eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons arg-3 eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons " (_fun " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-9) (Builtin-snd eta-9)) e-6)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons " -> " eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-7 (lambda (u--xs) (cons "))\xa;" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3))))))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CompilerC-45SchemeC-45Racket-n--12804-1960-u--useArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-4)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) e-6) '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--call (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "(" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons arg-3 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " e-9) (lambda (u--xs) (cons ")" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)))) (lambda (eta-4) (vector 1 (cons (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-5 eta-6)) e-8 eta-5)) (case (vector-ref arg-0 0) ((20) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45SchemeC-45Racket-handleRet e-0 u--call)))(else u--call)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CompilerC-45SchemeC-45Racket-cCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((20) (let ((e-0 (vector-ref arg-8 1))) (case (vector-ref e-0 0) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-case--cCall-2185 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 (CompilerC-45SchemeC-45Racket-getLibVers arg-6) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "Can't return GCPtr from a foreign function") clam-0)) ((16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "Can't return Buffer from a foreign function") clam-0))(else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-case--cCall-2185 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 (CompilerC-45SchemeC-45Racket-getLibVers arg-6) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))
(define CompilerC-45SchemeC-45Racket-schemeCall (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--call (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-1) (cons "(" eta-1)) (lambda (eta-1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-2) (cons arg-1 eta-2)) (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons " " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (CompilerC-45SchemeC-45Common-schName eta-4)) arg-2)) (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)) eta-1)) eta-0)))) (case (vector-ref arg-3 0) ((20) u--call)(else u--call)))))
(define CompilerC-45SchemeC-45Racket-useCC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (CompilerC-45Common-parseCC (cons "scheme,racket" csegen-4884) arg-5))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)) (let ((e-2 (unbox sc0))) (if (null? e-2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (cond ((equal? e-5 "scheme,racket") (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((u--body (CompilerC-45SchemeC-45Racket-schemeCall arg-4 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-6) arg-7))) (lambda (eta-0) (vector 1 (cons (lambda (u--xs) (cons "" u--xs)) u--body)))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (if (null? e-13) (let ((u--body (CompilerC-45SchemeC-45Racket-schemeCall arg-4 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-6) arg-7))) (lambda (eta-0) (vector 1 (cons (lambda (eta-1) (cons (string-append "(require " (string-append e-12 ")")) eta-1)) u--body)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)))))))))) ((equal? e-5 "scheme") (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)) (let ((e-16 (car e-6))) (let ((e-17 (cdr e-6))) (if (null? e-17) (let ((u--body (CompilerC-45SchemeC-45Racket-schemeCall arg-4 e-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-6) arg-7))) (lambda (eta-0) (vector 1 (cons (lambda (u--xs) (cons "" u--xs)) u--body)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0))))))) ((equal? e-5 "C") (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)) (let ((e-20 (car e-6))) (let ((e-21 (cdr e-6))) (if (null? e-21) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0)) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (CompilerC-45SchemeC-45Racket-cCall arg-0 arg-1 arg-2 arg-3 arg-4 e-20 e-23 arg-6 arg-7) (let ((e-28 (cdr e-24))) (if (null? e-28) (CompilerC-45SchemeC-45Racket-cCall arg-0 arg-1 arg-2 arg-3 arg-4 e-20 e-23 arg-6 arg-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 63 arg-4 arg-5) eta-0))))))))))))
(define CompilerC-45SchemeC-45Racket-schFgnDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((2) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((u--argns (CompilerC-45SchemeC-45Racket-mkArgs 0 e-1))) (let ((u--allargns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) u--argns))) (let ((u--useargns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (Builtin-snd eta-0)) u--argns)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45SchemeC-45Racket-mkStruct arg-3 eta-1)) e-1 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Racket-mkStruct arg-3 e-2) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CompilerC-45SchemeC-45Racket-useCC arg-0 arg-1 arg-2 arg-4 arg-5 e-0 (DataC-45List-u--zip_Zippable_List u--useargns e-1) e-2) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-u--full_HasNames_Name (let ((e-41 (vector-ref e-8 0))) e-41) arg-6 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-6) eta-6) e-5) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 e-4 eta-6)) eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons "(define " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (CompilerC-45SchemeC-45Common-schName e-9) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons " (lambda (" eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (LibrariesC-45DataC-45StringC-45Builder-sepBy " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-9) (CompilerC-45SchemeC-45Common-schName eta-9)) u--allargns)) (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons ") " eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-3 (lambda (u--xs) (cons "))\xa;" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5))))))) eff-0) eta-3)))))))) eff-0) clam-0)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))(else (lambda (eta-0) (vector 1 (cons (lambda (u--xs) (cons "" u--xs)) (lambda (u--xs) (cons "" u--xs)))))))))
(define CompilerC-45SchemeC-45Racket-getFgnCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (CompilerC-45SchemeC-45Racket-schFgnDef arg-0 arg-1 arg-2 arg-3 arg-4 e-6 e-2 e-7)))))))
(define CompilerC-45SchemeC-45Racket-racketPrim (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((6) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (case (vector-ref e-1 0) ((12) (let ((e-20 (vector-ref e-1 2))) (case (vector-ref e-20 0) ((10) (let ((e-21 (vector-ref e-20 1))) (if (null? e-2) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))) (let ((e-24 (cdr e-2))) (if (null? e-24) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))) (let ((e-27 (cdr e-24))) (if (null? e-27) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))) (let ((e-29 (car e-27))) (let ((e-30 (cdr e-27))) (if (null? e-30) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))) (let ((e-32 (car e-30))) (let ((e-33 (cdr e-30))) (case (vector-ref e-32 0) ((12) (let ((e-35 (vector-ref e-32 2))) (case (vector-ref e-35 0) ((10) (let ((e-36 (vector-ref e-35 1))) (if (null? e-33) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))) (let ((e-39 (cdr e-33))) (if (null? e-39) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4998 0 e-29) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(" eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons e-21 eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons "-" eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons e-36 eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons " " eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)) eta-2)))))) eff-0) eta-0)))))) (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))(else (if (null? e-2) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-5 (cdr e-2))) (if (null? e-5) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-8 (cdr e-5))) (if (null? e-8) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-11 (cdr e-8))) (if (null? e-11) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-14 (cdr e-11))) (if (null? e-14) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-17 (cdr e-14))) (if (null? e-17) csegen-4903 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))))) ((7) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-42 (car arg-3))) (let ((e-43 (cdr arg-3))) (case (vector-ref e-42 0) ((12) (let ((e-67 (vector-ref e-42 2))) (case (vector-ref e-67 0) ((10) (let ((e-68 (vector-ref e-67 1))) (if (null? e-43) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-71 (cdr e-43))) (if (null? e-71) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-74 (cdr e-71))) (if (null? e-74) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-76 (car e-74))) (let ((e-77 (cdr e-74))) (if (null? e-77) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-79 (car e-77))) (let ((e-80 (cdr e-77))) (case (vector-ref e-79 0) ((12) (let ((e-82 (vector-ref e-79 2))) (case (vector-ref e-82 0) ((10) (let ((e-83 (vector-ref e-82 1))) (if (null? e-80) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-86 (cdr e-80))) (if (null? e-86) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-88 (car e-86))) (let ((e-89 (cdr e-86))) (if (null? e-89) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))) (let ((e-92 (cdr e-89))) (if (null? e-92) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4998 0 e-76) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-2 eta-3 eta-4)))) csegen-4998 0 e-88) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(set-" eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-5) (cons e-68 eta-5)) (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons "-" eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-7) (cons e-83 eta-7)) (lambda (eta-7) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-8) (cons "! " eta-8)) (lambda (eta-8) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-9) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-10) (cons " " eta-10)) (lambda (eta-10) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-10)) eta-9)) eta-8)) eta-7)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))))))))))(else (if (null? e-43) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-46 (cdr e-43))) (if (null? e-46) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-49 (cdr e-46))) (if (null? e-49) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-52 (cdr e-49))) (if (null? e-52) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-55 (cdr e-52))) (if (null? e-55) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-58 (cdr e-55))) (if (null? e-58) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-61 (cdr e-58))) (if (null? e-61) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-64 (cdr e-61))) (if (null? e-64) csegen-4905 (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))))))))))))))))))) ((10) (if (null? arg-3) (lambda (eta-0) (vector 1 (lambda (u--xs) (cons "\"racket\"" u--xs)))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))) ((11) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-97 (cdr arg-3))) (if (null? e-97) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-99 (car e-97))) (let ((e-100 (cdr e-97))) (if (null? e-100) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-102 (car e-100))) (let ((e-103 (cdr e-100))) (if (null? e-103) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-106 (cdr e-103))) (if (null? e-106) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4998 0 e-99) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-2 eta-3 eta-4)))) csegen-4998 0 e-102) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(blodwen-register-object " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))))) ((12) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-109 (car arg-3))) (let ((e-110 (cdr arg-3))) (if (null? e-110) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-112 (car e-110))) (let ((e-113 (cdr e-110))) (if (null? e-113) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-116 (cdr e-113))) (if (null? e-116) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4998 0 e-109) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-2 eta-3 eta-4)))) csegen-4998 0 e-112) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-4) (cons "(blodwen-register-object " eta-4)) (lambda (eta-4) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (eta-5) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-6) (cons " " eta-6)) (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-6 (lambda (u--xs) (cons ")" u--xs)) eta-6)) eta-5)) eta-4)) eta-3)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))))) ((13) (if (null? arg-3) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-120 (cdr arg-3))) (if (null? e-120) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3) (let ((e-122 (car e-120))) (let ((e-123 (cdr e-120))) (if (null? e-123) (lambda (eta-0) (let ((act-1 ((CompilerC-45SchemeC-45Common-schExp arg-0 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-1 eta-2 eta-3)))) csegen-4998 0 e-122) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (lambda (eta-2) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-3) (cons "(blodwen-make-future " eta-3)) (lambda (eta-3) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-5 (lambda (u--xs) (cons ")" u--xs)) eta-3)) eta-2)))))) eff-0) eta-0)))))) (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3))))))))(else (CompilerC-45SchemeC-45Common-schExtCommon arg-0 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CompilerC-45SchemeC-45Racket-racketPrim arg-0 eta-0 eta-1 eta-2)))) csegen-4998 arg-1 arg-2 arg-3)))))
(define CompilerC-45SchemeC-45Racket-schFooter (lambda (ext-0) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons ")\xa;(collect-garbage)" '())) ext-0)))
(define CompilerC-45SchemeC-45Racket-schHeader (lambda (arg-0 arg-1 ext-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-0) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "#lang racket/base\xa;;; " (cons (CompilerC-45Generated-generatedString "Racket") (cons "\xa;(require racket/async-channel)         ; for asynchronous channels\xa;(require racket/future)                ; for parallelism/concurrency\xa;(require racket/math)                  ; for math ops\xa;(require racket/system)                ; for system\xa;(require racket/unsafe/ops)            ; for fast fixnum ops\xa;(require rnrs/bytevectors-6)           ; for buffers\xa;(require rnrs/io/ports-6)              ; for files\xa;(require srfi/19)                      ; for file handling and data\xa;(require ffi/unsafe ffi/unsafe/define) ; for calling C\xa;" (cons (cond ((equal? arg-0 1) "(require profile)") (else "")) (cons "\xa;(require racket/flonum)                ; for float-typed transcendental functions\xa;(require math/flonum)                  ; for flonum constants\xa;" '())))))) eta-0)) (lambda (eta-0) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 arg-1 (lambda (eta-1) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "\xa;(let ()\xa;" '())) eta-1)) eta-0)) ext-0)))
(define CompilerC-45SchemeC-45Racket-compileToRKT (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CompilerC-45Common-getCompileData arg-0 0 0 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ndefs (let ((e-2 (vector-ref e-5 2))) e-2))) (let ((u--ctm (CoreC-45CompileExpr-forget '() (let ((e-0 (vector-ref e-5 0))) e-0)))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Racket.Done" ) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Racket.Loaded" ) '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-newRef (vector "Compiler.Scheme.Racket.Structs" ) '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (CompilerC-45SchemeC-45Racket-getFgnCall e-7 arg-0 e-8 e-9 arg-1 eta-5)) u--ndefs '()) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CompilerC-45OptsC-45ToplevelConstants-sortDefs u--ndefs) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((act-8 ((CoreC-45Core-traverseC-39 (lambda (eta-6) (CompilerC-45SchemeC-45Common-getScheme arg-0 e-3 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (CompilerC-45SchemeC-45Racket-racketPrim e-3 eta-7 eta-8 eta-9)))) csegen-4998 eta-6)) e-2 '()) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--code (lambda (eta-6) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-7) eta-7) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-7) (Builtin-snd eta-7)) e-10)) (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-7) eta-7) e-12) eta-6)))) (lambda (eta-6) (let ((act-9 ((CompilerC-45SchemeC-45Common-schExp e-3 (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (CompilerC-45SchemeC-45Racket-racketPrim e-3 eta-7 eta-8 eta-9)))) csegen-4998 0 u--ctm) eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (CoreC-45Directory-readDataFile arg-0 "racket/support.rkt" eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-11 (CoreC-45Context-getDirectives arg-0 (vector 2 ) eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 (CompilerC-45Common-getExtraRuntime e-15 eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-13 (CoreC-45Context-getSession arg-0 eta-10))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (let ((u--prof (let ((e-26 (vector-ref e-17 16))) e-26))) (let ((u--runmain (lambda (clam-1) (cond ((equal? u--prof 1) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons "(profile (void " eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-13 (lambda (eta-12) (cons ") #:order 'self)\xa;" eta-12)) eta-11)) clam-1)) (else (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-11) (cons "(void " eta-11)) (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 e-13 (lambda (u--xs) (cons ")\xa;" u--xs)) eta-11)) clam-1)))))) (let ((u--scm (lambda (eta-11) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-12) (CompilerC-45SchemeC-45Racket-schHeader u--prof (PreludeC-45Types-u--foldMap_Foldable_List csegen-4890 (lambda (eta-13) eta-13) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-13) (Builtin-fst eta-13)) e-10)) eta-12)) (lambda (eta-12) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-13) (cons e-14 eta-13)) (lambda (eta-13) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 (lambda (eta-14) (cons e-16 eta-14)) (lambda (eta-14) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--code (lambda (eta-15) (LibrariesC-45DataC-45StringC-45Builder-C-43C-43 u--runmain (lambda (eta-16) (CompilerC-45SchemeC-45Racket-schFooter eta-16)) eta-15)) eta-14)) eta-13)) eta-12)) eta-11)))) (lambda (eta-11) (let ((act-14 (let ((act-14 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-3 (LibrariesC-45DataC-45StringC-45Builder-build u--scm)) eta-11))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-18 0) ((1) (let ((act-15 ((let ((eff-0 (lambda (world-0) (let ((act-15 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 arg-3 (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-15))))) (lambda (eta-12) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-12))) clam-2))) (case (vector-ref act-15 0) ((0) (let ((e-19 (vector-ref act-15 1))) (vector 0 e-19))) (else (vector 1 (vector 0 )))))) (else (let ((e-19 (vector-ref e-18 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-3 e-19) clam-2))))))) eff-0) eta-11))))))))))) eff-0) eta-10)))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6))))))))) eff-0) clam-0)))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Racket-findRacket (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "RACKET") ext-0))) (DataC-45Maybe-fromMaybe (lambda () "/usr/bin/env racket") act-1))))
(define CompilerC-45SchemeC-45Racket-findRacoExe (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "RACKET_RACO") ext-0))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-maybe (lambda () (cons "/usr/bin/env" (cons "raco" '()))) (lambda () (lambda (eta-0) (DataC-45List-singleton eta-0))) act-1) (cons "exe" '())))))
(define CompilerC-45SchemeC-45Racket-startRacket (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "#!/bin/sh\xa;# " (cons (CompilerC-45Generated-generatedString "Racket") (cons "\xa;\xa;set -e # exit on any error\xa;\xa;if [ \"$(uname)\" = Darwin ]; then\xa;  DIR=$(zsh -c 'printf %s \"$0:A:h\"' \"$0\")\xa;else\xa;  DIR=$(dirname \"$(readlink -f -- \"$0\")\")\xa;fi\xa;\xa;export LD_LIBRARY_PATH=\"$DIR/" (cons arg-1 (cons ":$LD_LIBRARY_PATH\"\xa;export DYLD_LIBRARY_PATH=\"$DIR/" (cons arg-1 (cons ":$DYLD_LIBRARY_PATH\"\xa;\xa;" (cons arg-0 (cons " \"$DIR/" (cons arg-2 (cons "\" \"$@\"" '()))))))))))))))
(define CompilerC-45SchemeC-45Racket-makeSh (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-1 (CompilerC-45SchemeC-45Racket-startRacket arg-0 arg-2 arg-3)) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-1 e-6) clam-0))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Racket-startRacketCmd (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "@echo off\xa;\xa;rem " (cons (CompilerC-45Generated-generatedString "Racket") (cons "\xa;\xa;set APPDIR=%~dp0\xa;set PATH=%APPDIR%" (cons arg-1 (cons ";%PATH%\xa;\xa;" (cons arg-0 (cons " \"%APPDIR%" (cons arg-2 (cons "\" %*" '()))))))))))))
(define CompilerC-45SchemeC-45Racket-startRacketWinSh (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "#!/bin/sh\xa;# " (cons (CompilerC-45Generated-generatedString "Racket") (cons "\xa;\xa;set -e # exit on any error\xa;\xa;DIR=$(dirname \"$(readlink -f -- \"$0\" || cygpath -a -- \"$0\")\")\xa;PATH=\"$DIR/" (cons arg-1 (cons ":$PATH\"\xa;\xa;" (cons arg-0 (cons " \"$DIR/" (cons arg-2 (cons "\" \"$@\"" '()))))))))))))
(define CompilerC-45SchemeC-45Racket-makeShWindows (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--cmdFile (string-append arg-1 ".cmd"))) (lambda (eta-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--cmdFile (CompilerC-45SchemeC-45Racket-startRacketCmd arg-0 arg-2 arg-3)) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((act-2 (let ((act-2 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-1 (CompilerC-45SchemeC-45Racket-startRacketWinSh arg-0 arg-2 arg-3)) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-1 e-7) clam-1))))))) eff-0) clam-0)))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 u--cmdFile e-6) clam-0))))))) eff-0) eta-0)))))))))
(define CompilerC-45SchemeC-45Racket-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((u--appDirRel (string-append arg-6 "_app"))) (let ((u--appDirGen (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 u--appDirRel))) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (CoreC-45Directory-mkdirAll u--appDirGen world-0))) (vector 1 act-1))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (csegen-1310 eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) csegen-1311 (let ((e-1 (unbox e-6))) (let ((u--ext (let ((sc3 SystemC-45Info-isWindows)) (cond ((equal? sc3 1) ".exe") (else ""))))) (let ((u--outRktFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-6 "rkt")))) (let ((u--outBinFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--appDirRel (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-6 u--ext)))) (let ((u--outRktAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 arg-4) u--outRktFile))) (let ((u--outBinAbs (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-1 arg-4) u--outBinFile))) (lambda (eta-1) (let ((act-3 (CompilerC-45SchemeC-45Racket-compileToRKT arg-1 u--appDirGen arg-5 u--outRktAbs eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (CompilerC-45SchemeC-45Racket-findRacoExe eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (CompilerC-45SchemeC-45Racket-findRacket eta-2))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (cond ((equal? arg-0 1) (CoreC-45ContextC-45Log-logTime arg-1 1 (lambda () "Build racket") (lambda (eta-4) (let ((act-6 ((SystemC-45Escaped-system csegen-82 (PreludeC-45TypesC-45List-tailRecAppend e-8 (cons "-o" (cons u--outBinAbs (cons u--outRktAbs '()))))) eta-4))) (vector 1 act-6))) eta-3)) (else (vector 1 0))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((sc7 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-10 0))) (cond ((equal? sc7 1) (let ((u--outShRel (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 arg-6))) (lambda (eta-4) (let ((act-7 (let ((sc8 SystemC-45Info-isWindows)) (cond ((equal? sc8 1) (cond ((equal? arg-0 1) ((CompilerC-45SchemeC-45Racket-makeShWindows "" u--outShRel u--appDirRel u--outBinFile) eta-4)) (else ((CompilerC-45SchemeC-45Racket-makeShWindows (string-append e-9 " ") u--outShRel u--appDirRel u--outRktFile) eta-4)))) (else (cond ((equal? arg-0 1) (CompilerC-45SchemeC-45Racket-makeSh "" u--outShRel u--appDirRel u--outBinFile eta-4)) (else (CompilerC-45SchemeC-45Racket-makeSh (string-append e-9 " ") u--outShRel u--appDirRel u--outRktFile eta-4)))))))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((let ((eff-0 (lambda (world-0) (let ((act-8 ((SystemC-45FileC-45Permissions-chmodRaw csegen-82 u--outShRel (blodwen-toSignedInt 493 63)) world-0))) (vector 1 act-8))))) (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-5))) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (vector 1 (box u--outShRel))))))))))) (else (lambda (eta-4) (vector 1 '()))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))))))))) eff-0) eta-0)))))))))))))
(define CompilerC-45SchemeC-45Racket-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CompilerC-45SchemeC-45Racket-compileExpr 0 arg-0 arg-1 arg-2 arg-2 arg-3 "_tmpracket") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-5006 (let ((e-1 (unbox e-5))) (let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45Escaped-system csegen-82 (cons e-1 '())) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))))) eff-0) ext-0)))))))
(define CompilerC-45SchemeC-45Racket-codegenRacket (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45SchemeC-45Racket-compileExpr 1 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45SchemeC-45Racket-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) '() '())))
(define CompilerC-45RefCC-45CC-clibdirs (lambda (arg-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--d) (string-append "-L" u--d)) arg-0)))
(define CompilerC-45RefCC-45CC-findCC (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "IDRIS2_CC") ext-0))) (if (null? act-1) (let ((act-2 ((System-getEnv csegen-82 "CC") ext-0))) (if (null? act-2) "cc" (let ((e-2 (unbox act-2))) e-2))) (let ((e-2 (unbox act-1))) e-2)))))
(define CompilerC-45RefCC-45CC-findCFLAGS (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "IDRIS2_CFLAGS") ext-0))) (if (null? act-1) (let ((act-2 ((System-getEnv csegen-82 "CFLAGS") ext-0))) (if (null? act-2) "" (let ((e-2 (unbox act-2))) e-2))) (let ((e-2 (unbox act-1))) e-2)))))
(define CompilerC-45RefCC-45CC-findLDFLAGS (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "IDRIS2_LDFLAGS") ext-0))) (if (null? act-1) (let ((act-2 ((System-getEnv csegen-82 "LDFLAGS") ext-0))) (if (null? act-2) "" (let ((e-2 (unbox act-2))) e-2))) (let ((e-2 (unbox act-1))) e-2)))))
(define CompilerC-45RefCC-45CC-findLDLIBS (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "IDRIS2_LDLIBS") ext-0))) (if (null? act-1) (let ((act-2 ((System-getEnv csegen-82 "LDLIBS") ext-0))) (if (null? act-2) "" (let ((e-2 (unbox act-2))) e-2))) (let ((e-2 (unbox act-1))) e-2)))))
(define CompilerC-45RefCC-45CC-compileCFile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (CompilerC-45RefCC-45CC-findCC ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CompilerC-45RefCC-45CC-findCFLAGS eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (CompilerC-45RefCC-45CC-findLDFLAGS eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (CompilerC-45RefCC-45CC-findLDLIBS eta-2))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-getDirs arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Directory-findDataFile arg-0 "refc" eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45Directory-findLibraryFile arg-0 "libidris2_support.a" eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--sharedFlag (cond ((equal? arg-1 1) (cons "-shared" '())) (else '())))) (let ((u--runcc (string-append (SystemC-45Escape-escapeCmd (PreludeC-45TypesC-45List-tailRecAppend (cons e-5 (cons "-Werror" '())) (PreludeC-45TypesC-45List-tailRecAppend u--sharedFlag (PreludeC-45TypesC-45List-tailRecAppend (cons arg-2 (cons "-o" (cons arg-3 (cons e-11 (cons "-lidris2_refc" (cons (string-append "-L" e-10) '())))))) (PreludeC-45TypesC-45List-tailRecAppend (CompilerC-45RefCC-45CC-clibdirs (let ((e-13 (vector-ref e-9 8))) e-13)) (cons "-lgmp" (cons "-lm" '()))))))) (string-append " " (DataC-45String-unwords (cons e-6 (cons e-7 (cons e-8 '())))))))) (lambda (eta-6) (let ((act-8 (CoreC-45ContextC-45Log-log arg-0 "compiler.refc.cc" 10 (lambda () u--runcc) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 ((System-system csegen-82 u--runcc) eta-6))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-13 0) (vector 1 (box arg-3)))(else (vector 1 '())))))) eff-0) eta-6))))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45CC-findCPPFLAGS (lambda (ext-0) (let ((act-1 ((System-getEnv csegen-82 "IDRIS2_CPPFLAGS") ext-0))) (if (null? act-1) (let ((act-2 ((System-getEnv csegen-82 "CPPFLAGS") ext-0))) (if (null? act-2) "" (let ((e-2 (unbox act-2))) e-2))) (let ((e-2 (unbox act-1))) e-2)))))
(define CompilerC-45RefCC-45CC-compileCObjectFile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (CompilerC-45RefCC-45CC-findCC ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CompilerC-45RefCC-45CC-findCFLAGS eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (CompilerC-45RefCC-45CC-findCPPFLAGS eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Directory-findDataFile arg-0 "refc" eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Directory-findDataFile arg-0 "c" eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--libraryFlag (cond ((equal? arg-1 1) (cons "-fpic" '())) (else '())))) (let ((u--runccobj (string-append (SystemC-45Escape-escapeCmd (PreludeC-45TypesC-45List-tailRecAppend (cons e-5 (cons "-Werror" (cons "-c" '()))) (PreludeC-45TypesC-45List-tailRecAppend u--libraryFlag (cons arg-2 (cons "-o" (cons arg-3 (cons (string-append "-I" e-8) (cons (string-append "-I" e-9) '())))))))) (string-append " " (string-append e-7 (string-append " " e-6)))))) (lambda (eta-4) (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "compiler.refc.cc" 10 (lambda () u--runccobj) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 ((System-system csegen-82 u--runccobj) eta-4))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-11 0) (vector 1 (box arg-3)))(else (vector 1 '())))))) eff-0) eta-4))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-addCommaToList (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons (string-append "  " e-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-1) (string-append ", " arg-1)) e-3)))))))
(define CompilerC-45RefCC-45RefC-showcCleanStringChar (lambda (arg-0) (lambda (clam-0) (cond ((equal? arg-0 #\ ) (string-append "_" clam-0)) ((equal? arg-0 #\!) (string-append "_bang" clam-0)) ((equal? arg-0 #\") (string-append "_quotation" clam-0)) ((equal? arg-0 #\#) (string-append "_number" clam-0)) ((equal? arg-0 #\$) (string-append "_dollar" clam-0)) ((equal? arg-0 #\%) (string-append "_percent" clam-0)) ((equal? arg-0 #\&) (string-append "_and" clam-0)) ((equal? arg-0 #\') (string-append "_tick" clam-0)) ((equal? arg-0 #\() (string-append "_parenOpen" clam-0)) ((equal? arg-0 #\)) (string-append "_parenClose" clam-0)) ((equal? arg-0 #\*) (string-append "_star" clam-0)) ((equal? arg-0 #\+) (string-append "_plus" clam-0)) ((equal? arg-0 #\,) (string-append "_comma" clam-0)) ((equal? arg-0 #\-) (string-append "__" clam-0)) ((equal? arg-0 #\.) (string-append "_dot" clam-0)) ((equal? arg-0 #\/) (string-append "_slash" clam-0)) ((equal? arg-0 #\:) (string-append "_colon" clam-0)) ((equal? arg-0 #\;) (string-append "_semicolon" clam-0)) ((equal? arg-0 #\<) (string-append "_lt" clam-0)) ((equal? arg-0 #\=) (string-append "_eq" clam-0)) ((equal? arg-0 #\>) (string-append "_gt" clam-0)) ((equal? arg-0 #\?) (string-append "_question" clam-0)) ((equal? arg-0 #\@) (string-append "_at" clam-0)) ((equal? arg-0 #\[) (string-append "_bracketOpen" clam-0)) ((equal? arg-0 #\\) (string-append "_backslash" clam-0)) ((equal? arg-0 #\]) (string-append "_bracketClose" clam-0)) ((equal? arg-0 #\^) (string-append "_hat" clam-0)) ((equal? arg-0 #\_) (string-append "_" clam-0)) ((equal? arg-0 #\`) (string-append "_backquote" clam-0)) ((equal? arg-0 #\{) (string-append "_braceOpen" clam-0)) ((equal? arg-0 #\|) (string-append "_or" clam-0)) ((equal? arg-0 #\}) (string-append "_braceClose" clam-0)) ((equal? arg-0 #\~) (string-append "_tilde" clam-0))(else (let ((sc0 (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-0 (cast-int-char 32)))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char arg-0 (cast-int-char (blodwen-toSignedInt 126 63)))))))) (cond ((equal? sc0 1) (string-append (string-append "u" (ProtocolC-45Hex-leftPad #\0 4 (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-0 64)))) clam-0)) (else (string-cons arg-0 clam-0)))))))))
(define CompilerC-45RefCC-45RefC-showcCleanString (lambda (arg-0 ext-0) (if (null? arg-0) ext-0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) ((CompilerC-45RefCC-45RefC-showcCleanStringChar e-2) (CompilerC-45RefCC-45RefC-showcCleanString e-3 ext-0)))))))
(define CompilerC-45RefCC-45RefC-cCleanString (lambda (arg-0) (CompilerC-45RefCC-45RefC-showcCleanString (PreludeC-45Types-fastUnpack arg-0) "")))
(define CompilerC-45RefCC-45RefC-cUserName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cCleanString e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "rec__" (CompilerC-45RefCC-45RefC-cCleanString e-1)))) (else (CompilerC-45RefCC-45RefC-cCleanString "_")))))
(define CompilerC-45RefCC-45RefC-cName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (CompilerC-45RefCC-45RefC-cCleanString (CoreC-45NameC-45Namespace-showNSWithSep "_" e-0)) (string-append "_" (CompilerC-45RefCC-45RefC-cName e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cUserName e-2))) ((2) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (string-append (CompilerC-45RefCC-45RefC-cCleanString e-3) (string-append "_" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-4))))))) ((3) (let ((e-5 (vector-ref arg-0 1))) (string-append "pat__" (CompilerC-45RefCC-45RefC-cName e-5)))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CompilerC-45RefCC-45RefC-cName e-8))) ((5) (let ((e-9 (vector-ref arg-0 1))) (let ((e-10 (vector-ref arg-0 2))) (string-append "n__" (string-append (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-496 e-9)) (string-append "_" (CompilerC-45RefCC-45RefC-cName e-10))))))) ((6) (let ((e-11 (vector-ref arg-0 1))) (let ((e-12 (vector-ref arg-0 2))) (string-append "case__" (string-append (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_String e-11)) (string-append "_" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-12)))))))) ((7) (let ((e-13 (vector-ref arg-0 1))) (let ((e-14 (vector-ref arg-0 2))) (string-append "with__" (string-append (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_String e-13)) (string-append "_" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-14)))))))) (else (let ((e-15 (vector-ref arg-0 1))) (string-append "fn__" (CompilerC-45RefCC-45RefC-cCleanString (PreludeC-45Show-u--show_Show_Int e-15))))))))
(define CompilerC-45RefCC-45RefC-varName (lambda (arg-0) (if (null? arg-0) "NULL" (let ((e-0 (unbox arg-0))) (string-append "var_" (PreludeC-45Show-u--show_Show_Int e-0))))))
(define CompilerC-45RefCC-45RefC-cArgsVectANF (lambda (arg-1 ext-0) (if (null? arg-1) (vector 1 '()) (let ((e-3 (car arg-1))) (let ((e-4 (cdr arg-1))) (let ((act-1 (CompilerC-45RefCC-45RefC-cArgsVectANF e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (CompilerC-45RefCC-45RefC-varName e-3) e-5))))) eff-0) ext-0))))))))))
(define CompilerC-45RefCC-45RefC-cPrimType (lambda (arg-0) (cond ((equal? arg-0 0) "Int64") ((equal? arg-0 1) "Int8") ((equal? arg-0 2) "Int16") ((equal? arg-0 3) "Int32") ((equal? arg-0 4) "Int64") ((equal? arg-0 5) "Integer") ((equal? arg-0 6) "Bits8") ((equal? arg-0 7) "Bits16") ((equal? arg-0 8) "Bits32") ((equal? arg-0 9) "Bits64") ((equal? arg-0 10) "string") ((equal? arg-0 11) "char") ((equal? arg-0 12) "double") (else "f32"))))
(define CompilerC-45RefCC-45RefC-n--11576-8543-u--showCChar (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\\) (lambda (arg-2) (string-append "\\\\" arg-2)))(else (lambda (clam-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-1 (cast-int-char 32)))) (cond ((equal? sc0 1) (string-append (string-append (string-append "\\x" (ProtocolC-45Hex-leftPad #\0 2 (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-1 64)))) "\"\"") clam-0)) (else (let ((sc1 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-1 (cast-int-char (blodwen-toSignedInt 127 63))))) (cond ((equal? sc1 1) (string-cons arg-1 clam-0)) (else (let ((sc2 (PreludeC-45EqOrd-u--C-60_Ord_Char arg-1 (cast-int-char (blodwen-toSignedInt 65536 63))))) (cond ((equal? sc2 1) (string-append (string-append (string-append "\\u" (ProtocolC-45Hex-leftPad #\0 4 (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-1 64)))) "\"\"") clam-0)) (else (string-append (string-append (string-append "\\U" (ProtocolC-45Hex-leftPad #\0 8 (ProtocolC-45Hex-asHex (cast-char-boundedUInt arg-1 64)))) "\"\"") clam-0)))))))))))))))
(define CompilerC-45RefCC-45RefC-n--11576-8544-u--showCString (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) clam-0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 #\") (string-append "\\\"" ((CompilerC-45RefCC-45RefC-n--11576-8544-u--showCString arg-0 e-3) clam-0)))(else ((CompilerC-45RefCC-45RefC-n--11576-8543-u--showCChar arg-0 e-2) ((CompilerC-45RefCC-45RefC-n--11576-8544-u--showCString arg-0 e-3) clam-0))))))))))
(define CompilerC-45RefCC-45RefC-cStringQuoted (lambda (arg-0) (string-cons #\" ((CompilerC-45RefCC-45RefC-n--11576-8544-u--showCString arg-0 (PreludeC-45Types-fastUnpack arg-0)) "\""))))
(define PreludeC-45Types-isNL (lambda (arg-0) (cond ((equal? arg-0 (integer->char 13)) 1) ((equal? arg-0 (integer->char 10)) 1)(else 0))))
(define CompilerC-45RefCC-45RefC-escapeChar (lambda (arg-0) (let ((sc0 (let ((sc1 (PreludeC-45Types-isAlphaNum arg-0))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Types-isNL arg-0)))))) (cond ((equal? sc0 1) (PreludeC-45Show-u--show_Show_Char arg-0)) (else (string-append "(char)" (PreludeC-45Show-u--show_Show_Int (cast-char-boundedInt arg-0 63))))))))
(define CompilerC-45RefCC-45RefC-showInt64Min (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-0 -9223372036854775808))) (cond ((equal? sc0 1) "INT64_MIN") (else (string-append "INT64_C(" (string-append (PreludeC-45Show-u--show_Show_Int64 arg-0) ")")))))))
(define CompilerC-45RefCC-45RefC-showIntMin (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-0 (blodwen-toSignedInt -9223372036854775808 63)))) (cond ((equal? sc0 1) "INT64_MIN") (else (string-append "INT64_C(" (string-append (PreludeC-45Show-u--show_Show_Int arg-0) ")")))))))
(define CompilerC-45RefCC-45RefC-cConstant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (string-append "(Value*)makeInt64(" (string-append (CompilerC-45RefCC-45RefC-showIntMin e-0) ")")))) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "(Value*)makeInt8(INT8_C(" (string-append (PreludeC-45Show-u--show_Show_Int8 e-1) "))")))) ((2) (let ((e-2 (vector-ref arg-0 1))) (string-append "(Value*)makeInt16(INT16_C(" (string-append (PreludeC-45Show-u--show_Show_Int16 e-2) "))")))) ((3) (let ((e-3 (vector-ref arg-0 1))) (string-append "(Value*)makeInt32(INT32_C(" (string-append (PreludeC-45Show-u--show_Show_Int32 e-3) "))")))) ((4) (let ((e-4 (vector-ref arg-0 1))) (string-append "(Value*)makeInt64(" (string-append (CompilerC-45RefCC-45RefC-showInt64Min e-4) ")")))) ((5) (let ((e-5 (vector-ref arg-0 1))) (string-append "(Value*)makeIntegerLiteral(\"" (string-append (PreludeC-45Show-u--show_Show_Integer e-5) "\")")))) ((6) (let ((e-6 (vector-ref arg-0 1))) (string-append "(Value*)makeBits8(UINT8_C(" (string-append (PreludeC-45Show-u--show_Show_Bits8 e-6) "))")))) ((7) (let ((e-7 (vector-ref arg-0 1))) (string-append "(Value*)makeBits16(UINT16_C(" (string-append (PreludeC-45Show-u--show_Show_Bits16 e-7) "))")))) ((8) (let ((e-8 (vector-ref arg-0 1))) (string-append "(Value*)makeBits32(UINT32_C(" (string-append (PreludeC-45Show-u--show_Show_Bits32 e-8) "))")))) ((9) (let ((e-9 (vector-ref arg-0 1))) (string-append "(Value*)makeBits64(UINT64_C(" (string-append (PreludeC-45Show-u--show_Show_Bits64 e-9) "))")))) ((12) (let ((e-10 (vector-ref arg-0 1))) (string-append "(Value*)makeDouble(" (string-append (PreludeC-45Show-u--show_Show_Double e-10) ")")))) ((11) (let ((e-11 (vector-ref arg-0 1))) (string-append "(Value*)makeChar(" (string-append (CompilerC-45RefCC-45RefC-escapeChar e-11) ")")))) ((10) (let ((e-12 (vector-ref arg-0 1))) (string-append "(Value*)makeString(" (string-append (CompilerC-45RefCC-45RefC-cStringQuoted e-12) ")")))) ((13) (let ((e-13 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cPrimType e-13))) (else "(Value*)makeWorld()"))))
(define CompilerC-45RefCC-45RefC-plainOp (lambda (arg-0 arg-1) (string-append arg-0 (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " arg-1) ")")))))
(define CompilerC-45RefCC-45RefC-cOp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((5) (let ((e-0 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-20 (car arg-2))) (let ((e-21 (cdr arg-2))) (if (null? e-21) (string-append "negate_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-0) (string-append "(" (string-append e-20 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))) ((16) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-25 (car arg-2))) (let ((e-26 (cdr arg-2))) (if (null? e-26) (string-append "stringLength(" (string-append e-25 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((17) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-30 (car arg-2))) (let ((e-31 (cdr arg-2))) (if (null? e-31) (string-append "head(" (string-append e-30 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((18) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-35 (car arg-2))) (let ((e-36 (cdr arg-2))) (if (null? e-36) (string-append "tail(" (string-append e-35 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((22) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-40 (car arg-2))) (let ((e-41 (cdr arg-2))) (if (null? e-41) (string-append "reverse(" (string-append e-40 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((36) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-45 (car arg-2))) (let ((e-46 (cdr arg-2))) (if (null? e-46) (string-append "cast_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-1) (string-append "_to_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-2) (string-append "(" (string-append e-45 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))) ((24) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-50 (car arg-2))) (let ((e-51 (cdr arg-2))) (if (null? e-51) (string-append "(Value*)makeDouble(exp(unpackDouble(" (string-append e-50 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((25) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-55 (car arg-2))) (let ((e-56 (cdr arg-2))) (if (null? e-56) (string-append "(Value*)makeDouble(log(unpackDouble(" (string-append e-55 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((26) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-60 (car arg-2))) (let ((e-61 (cdr arg-2))) (if (null? e-61) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-64 (car e-61))) (let ((e-65 (cdr e-61))) (if (null? e-65) (string-append "(Value*)makeDouble(pow(unpackDouble(" (string-append e-60 (string-append "), unpackDouble(" (string-append e-64 ")))")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((27) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-69 (car arg-2))) (let ((e-70 (cdr arg-2))) (if (null? e-70) (string-append "(Value*)makeDouble(sin(unpackDouble(" (string-append e-69 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((28) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-74 (car arg-2))) (let ((e-75 (cdr arg-2))) (if (null? e-75) (string-append "(Value*)makeDouble(cos(unpackDouble(" (string-append e-74 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((29) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-79 (car arg-2))) (let ((e-80 (cdr arg-2))) (if (null? e-80) (string-append "(Value*)makeDouble(tan(unpackDouble(" (string-append e-79 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((30) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-84 (car arg-2))) (let ((e-85 (cdr arg-2))) (if (null? e-85) (string-append "(Value*)makeDouble(asin(unpackDouble(" (string-append e-84 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((31) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-89 (car arg-2))) (let ((e-90 (cdr arg-2))) (if (null? e-90) (string-append "(Value*)makeDouble(acos(unpackDouble(" (string-append e-89 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((32) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-94 (car arg-2))) (let ((e-95 (cdr arg-2))) (if (null? e-95) (string-append "(Value*)makeDouble(atan(unpackDouble(" (string-append e-94 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((33) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-99 (car arg-2))) (let ((e-100 (cdr arg-2))) (if (null? e-100) (string-append "(Value*)makeDouble(sqrt(unpackDouble(" (string-append e-99 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((34) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-104 (car arg-2))) (let ((e-105 (cdr arg-2))) (if (null? e-105) (string-append "(Value*)makeDouble(floor(unpackDouble(" (string-append e-104 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((35) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-109 (car arg-2))) (let ((e-110 (cdr arg-2))) (if (null? e-110) (string-append "(Value*)makeDouble(ceil(unpackDouble(" (string-append e-109 ")))")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))) ((0) (let ((e-3 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-114 (car arg-2))) (let ((e-115 (cdr arg-2))) (if (null? e-115) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-118 (car e-115))) (let ((e-119 (cdr e-115))) (if (null? e-119) (string-append "add_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-3) (string-append "(" (string-append e-114 (string-append ", " (string-append e-118 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-123 (car arg-2))) (let ((e-124 (cdr arg-2))) (if (null? e-124) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-127 (car e-124))) (let ((e-128 (cdr e-124))) (if (null? e-128) (string-append "sub_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-4) (string-append "(" (string-append e-123 (string-append ", " (string-append e-127 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-132 (car arg-2))) (let ((e-133 (cdr arg-2))) (if (null? e-133) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-136 (car e-133))) (let ((e-137 (cdr e-133))) (if (null? e-137) (string-append "mul_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-5) (string-append "(" (string-append e-132 (string-append ", " (string-append e-136 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((3) (let ((e-6 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-141 (car arg-2))) (let ((e-142 (cdr arg-2))) (if (null? e-142) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-145 (car e-142))) (let ((e-146 (cdr e-142))) (if (null? e-146) (string-append "div_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-6) (string-append "(" (string-append e-141 (string-append ", " (string-append e-145 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((4) (let ((e-7 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-150 (car arg-2))) (let ((e-151 (cdr arg-2))) (if (null? e-151) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-154 (car e-151))) (let ((e-155 (cdr e-151))) (if (null? e-155) (string-append "mod_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-7) (string-append "(" (string-append e-150 (string-append ", " (string-append e-154 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((6) (let ((e-8 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-159 (car arg-2))) (let ((e-160 (cdr arg-2))) (if (null? e-160) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-163 (car e-160))) (let ((e-164 (cdr e-160))) (if (null? e-164) (string-append "shiftl_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-8) (string-append "(" (string-append e-159 (string-append ", " (string-append e-163 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((7) (let ((e-9 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-168 (car arg-2))) (let ((e-169 (cdr arg-2))) (if (null? e-169) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-172 (car e-169))) (let ((e-173 (cdr e-169))) (if (null? e-173) (string-append "shiftr_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-9) (string-append "(" (string-append e-168 (string-append ", " (string-append e-172 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((8) (let ((e-10 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-177 (car arg-2))) (let ((e-178 (cdr arg-2))) (if (null? e-178) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-181 (car e-178))) (let ((e-182 (cdr e-178))) (if (null? e-182) (string-append "and_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-10) (string-append "(" (string-append e-177 (string-append ", " (string-append e-181 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((9) (let ((e-11 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-186 (car arg-2))) (let ((e-187 (cdr arg-2))) (if (null? e-187) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-190 (car e-187))) (let ((e-191 (cdr e-187))) (if (null? e-191) (string-append "or_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-11) (string-append "(" (string-append e-186 (string-append ", " (string-append e-190 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((10) (let ((e-12 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-195 (car arg-2))) (let ((e-196 (cdr arg-2))) (if (null? e-196) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-199 (car e-196))) (let ((e-200 (cdr e-196))) (if (null? e-200) (string-append "xor_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-12) (string-append "(" (string-append e-195 (string-append ", " (string-append e-199 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((11) (let ((e-13 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-204 (car arg-2))) (let ((e-205 (cdr arg-2))) (if (null? e-205) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-208 (car e-205))) (let ((e-209 (cdr e-205))) (if (null? e-209) (string-append "lt_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-13) (string-append "(" (string-append e-204 (string-append ", " (string-append e-208 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((15) (let ((e-14 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-213 (car arg-2))) (let ((e-214 (cdr arg-2))) (if (null? e-214) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-217 (car e-214))) (let ((e-218 (cdr e-214))) (if (null? e-218) (string-append "gt_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-14) (string-append "(" (string-append e-213 (string-append ", " (string-append e-217 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((13) (let ((e-15 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-222 (car arg-2))) (let ((e-223 (cdr arg-2))) (if (null? e-223) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-226 (car e-223))) (let ((e-227 (cdr e-223))) (if (null? e-227) (string-append "eq_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-15) (string-append "(" (string-append e-222 (string-append ", " (string-append e-226 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((12) (let ((e-16 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-231 (car arg-2))) (let ((e-232 (cdr arg-2))) (if (null? e-232) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-235 (car e-232))) (let ((e-236 (cdr e-232))) (if (null? e-236) (string-append "lte_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-16) (string-append "(" (string-append e-231 (string-append ", " (string-append e-235 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((14) (let ((e-17 (vector-ref arg-1 1))) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-240 (car arg-2))) (let ((e-241 (cdr arg-2))) (if (null? e-241) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-244 (car e-241))) (let ((e-245 (cdr e-241))) (if (null? e-245) (string-append "gte_" (string-append (CompilerC-45RefCC-45RefC-cPrimType e-17) (string-append "(" (string-append e-240 (string-append ", " (string-append e-244 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((19) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-249 (car arg-2))) (let ((e-250 (cdr arg-2))) (if (null? e-250) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-253 (car e-250))) (let ((e-254 (cdr e-250))) (if (null? e-254) (string-append "strIndex(" (string-append e-249 (string-append ", " (string-append e-253 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((20) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-258 (car arg-2))) (let ((e-259 (cdr arg-2))) (if (null? e-259) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-262 (car e-259))) (let ((e-263 (cdr e-259))) (if (null? e-263) (string-append "strCons(" (string-append e-258 (string-append ", " (string-append e-262 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((21) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-267 (car arg-2))) (let ((e-268 (cdr arg-2))) (if (null? e-268) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-271 (car e-268))) (let ((e-272 (cdr e-268))) (if (null? e-272) (string-append "strAppend(" (string-append e-267 (string-append ", " (string-append e-271 ")")))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))) ((23) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-276 (car arg-2))) (let ((e-277 (cdr arg-2))) (if (null? e-277) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-280 (car e-277))) (let ((e-281 (cdr e-277))) (if (null? e-281) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-284 (car e-281))) (let ((e-285 (cdr e-281))) (if (null? e-285) (string-append "strSubstr(" (string-append e-276 (string-append ", " (string-append e-280 (string-append ", " (string-append e-284 ")")))))) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))))) ((37) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-290 (cdr arg-2))) (if (null? e-290) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-294 (cdr e-290))) (if (null? e-294) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-297 (car e-294))) (let ((e-298 (cdr e-294))) (if (null? e-298) (string-append "newReference(" (string-append e-297 ")")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))))))) ((38) (if (null? arg-2) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-303 (cdr arg-2))) (if (null? e-303) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)) (let ((e-306 (car e-303))) (let ((e-307 (cdr e-303))) (if (null? e-307) (string-append "idris2_crash(" (string-append e-306 ");")) (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2)))))))))(else (CompilerC-45RefCC-45RefC-plainOp (CoreC-45TTC-45Primitive-u--show_Show_C-40PrimFnC-32C-36arityC-41 arg-1) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-2))))))
(define CompilerC-45RefCC-45RefC-callByPosition (lambda (arg-0 ext-0) (cond ((equal? arg-0 0) (let ((e-1 (cdr ext-0))) e-1)) (else (let ((e-0 (car ext-0))) e-0)))))
(define DataC-45Nat-pred (lambda (arg-0) (cond ((equal? arg-0 0) 0)(else (let ((e-0 (- arg-0 1))) e-0)))))
(define CompilerC-45RefCC-45RefC-decreaseIndentation (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (DataC-45Nat-pred e-5)))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define LibrariesC-45DataC-45DList-appendR (lambda (arg-1 arg-2 ext-0) (arg-1 (PreludeC-45TypesC-45List-tailRecAppend arg-2 ext-0))))
(define CompilerC-45RefCC-45RefC-indentation (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() (* e-5 4) #\ )))))) eff-0) ext-0)))))))
(define DataC-45Nat-fromLteSucc (lambda (arg-2) (cond ((equal? arg-2 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-2 (- arg-2 1))) e-2)))))
(define DataC-45Nat-succNotLTEzero (lambda (arg-0) (blodwen-error-quit "No clauses")))
(define DataC-45Nat-isLTE (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (vector 0 0))(else (let ((e-0 (- arg-0 1))) (cond ((equal? arg-1 0) (vector 1 (lambda (eta-0) (DataC-45Nat-succNotLTEzero eta-0))))(else (let ((e-1 (- arg-1 1))) (let ((sc0 (DataC-45Nat-isLTE e-0 e-1))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 1))) (vector 1 (lambda (eta-0) (e-2 (DataC-45Nat-fromLteSucc eta-0)))))) (else (let ((e-3 (vector-ref sc0 1))) (vector 0 (+ e-3 1))))))))))))))
(define CompilerC-45RefCC-45RefC-lJust (lambda (arg-0 arg-1 arg-2) (let ((u--n (PreludeC-45TypesC-45String-length arg-0))) (let ((sc0 (DataC-45Nat-isLTE u--n arg-1))) (case (vector-ref sc0 0) ((0) (let ((u--missing (PreludeC-45Types-prim__integerToNat (- arg-1 u--n)))) (let ((u--fillBlock (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() u--missing arg-2)))) (string-append arg-0 u--fillBlock)))) (else arg-0))))))
(define CompilerC-45RefCC-45RefC-maxLineLengthForComment 60)
(define CompilerC-45RefCC-45RefC-emit (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((2) (lambda (eta-0) (let ((act-1 (CompilerC-45RefCC-45RefC-indentation arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (PreludeC-45Basics-flip csegen-5151 (string-append e-5 arg-3) e-6)))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) eta-0)))))))(else (let ((u--comment (string-append "// " (CoreC-45FC-u--show_Show_FC arg-2)))) (lambda (eta-0) (let ((act-1 (CompilerC-45RefCC-45RefC-indentation arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--indentedLine (string-append e-5 arg-3))) (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((sc2 (DataC-45Nat-isLTE (PreludeC-45TypesC-45String-length u--indentedLine) CompilerC-45RefCC-45RefC-maxLineLengthForComment))) (case (vector-ref sc2 0) ((0) (PreludeC-45Basics-flip csegen-5151 (string-append (CompilerC-45RefCC-45RefC-lJust u--indentedLine CompilerC-45RefCC-45RefC-maxLineLengthForComment #\ ) (string-append " " u--comment)) e-6)) (else (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (LibrariesC-45DataC-45DList-appendR eta-1 eta-2 eta-3)))) (cons u--indentedLine (cons (string-append (CompilerC-45RefCC-45RefC-lJust "" CompilerC-45RefCC-45RefC-maxLineLengthForComment #\ ) (string-append " " u--comment)) '())) e-6))))))) (vector 1 act-3))))) eff-1) world-0)))))))))) eff-0) eta-0)))))))))))
(define CompilerC-45RefCC-45RefC-freeTmpVars (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 (vector 0 )) (let ((e-1 (car e-5))) (let ((e-2 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (u--v) (CompilerC-45RefCC-45RefC-emit arg-1 arg-2 (vector 2 ) (string-append "removeReference(" (string-append u--v ");")))) e-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (set-box! arg-0 e-2))) (vector 1 act-3))))))))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-increaseIndentation (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (+ e-5 1)))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45RefCC-45RefC-newTemporaryVariableLevel (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (cons '() e-5)))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45RefCC-45RefC-n--14217-11427-u--varBindLines (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-15) (vector 1 (vector 0 )) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-11 arg-10 (vector 2 ) (string-append "Value * var_" (string-append (PreludeC-45Show-u--show_Show_Int e-2) (string-append " = ((Value_Constructor*)" (string-append arg-14 (string-append ")->args[" (string-append (PreludeC-45Show-u--show_Show_Nat arg-16) "];"))))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CompilerC-45RefCC-45RefC-n--14217-11427-u--varBindLines arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3 (+ arg-16 1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 (vector 0 )))))))))))))
(define CompilerC-45RefCC-45RefC-conBlocks (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-5) (vector 1 (vector 0 )) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "  case " (string-append (PreludeC-45Show-u--show_Show_Nat arg-7) ":"))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  {") clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-3) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((act-5 (CompilerC-45RefCC-45RefC-n--14217-11427-u--varBindLines e-5 e-8 e-7 e-6 e-4 e-3 arg-8 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 arg-4 e-7 0 clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-8 arg-8) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-7 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append arg-6 (string-append " = " (string-append (CompilerC-45RefCC-45RefC-callByPosition arg-8 e-14) ";")))) eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (let ((act-8 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-16 (vector-ref act-8 1))) (vector 0 e-16))) (else (let ((act-9 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "break;") eta-0))) (case (vector-ref act-9 0) ((0) (let ((e-17 (vector-ref act-9 1))) (vector 0 e-17))) (else (let ((act-10 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-3) eta-0))) (case (vector-ref act-10 0) ((0) (let ((e-18 (vector-ref act-10 1))) (vector 0 e-18))) (else (let ((act-11 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") eta-0))) (case (vector-ref act-11 0) ((0) (let ((e-19 (vector-ref act-11 1))) (vector 0 e-19))) (else ((CompilerC-45RefCC-45RefC-conBlocks arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 (+ arg-7 1) arg-8) eta-0))))))))))))))))))) eff-0) clam-0)))))))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-const2Integer (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) ((2) (let ((e-2 (vector-ref arg-0 1))) e-2)) ((3) (let ((e-3 (vector-ref arg-0 1))) e-3)) ((4) (let ((e-4 (vector-ref arg-0 1))) e-4)) ((5) (let ((e-5 (vector-ref arg-0 1))) e-5)) ((11) (let ((e-6 (vector-ref arg-0 1))) (char->integer e-6))) ((6) (let ((e-7 (vector-ref arg-0 1))) e-7)) ((7) (let ((e-8 (vector-ref arg-0 1))) e-8)) ((8) (let ((e-9 (vector-ref arg-0 1))) e-9)) ((9) (let ((e-10 (vector-ref arg-0 1))) e-10))(else arg-1))))
(define CompilerC-45RefCC-45RefC-constBlockSwitch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-4) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (let ((u--c (CompilerC-45RefCC-45RefC-const2Integer e-4 arg-6))) (lambda (eta-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "  case " (string-append (PreludeC-45Show-u--show_Show_Integer u--c) " :"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  {") eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-3) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-5 arg-7) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append arg-5 (string-append " = " (string-append (CompilerC-45RefCC-45RefC-callByPosition arg-7 e-10) ";")))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((act-7 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((act-8 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "break;") eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (let ((act-9 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-3) eta-1))) (case (vector-ref act-9 0) ((0) (let ((e-14 (vector-ref act-9 1))) (vector 0 e-14))) (else (let ((act-10 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") eta-1))) (case (vector-ref act-10 0) ((0) (let ((e-15 (vector-ref act-10 1))) (vector 0 e-15))) (else ((CompilerC-45RefCC-45RefC-constBlockSwitch arg-0 arg-1 arg-2 arg-3 e-3 arg-5 (+ arg-6 1) arg-7) eta-1))))))))))))))))))) eff-0) eta-0))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-constDefaultBlock (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-4) (vector 1 (vector 0 )) (let ((e-2 (unbox arg-4))) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  default :") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  {") ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-3) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-2 arg-6) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append arg-5 (string-append " = " (string-append (CompilerC-45RefCC-45RefC-callByPosition arg-6 e-9) ";")))) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((act-7 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((act-8 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-3) eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") eta-0))))))))))))) eff-0) ext-0)))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-n--14179-11274-u--getNameTag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-15) (vector 1 (cons "-1" (string-append "\"" (string-append (CompilerC-45RefCC-45RefC-cName arg-16) "\"")))) (let ((e-2 (unbox arg-15))) (vector 1 (cons (PreludeC-45Show-u--show_Show_Int e-2) "NULL"))))))
(define CompilerC-45RefCC-45RefC-copyConstructors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-5) (vector 1 (vector 0 )) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (let ((act-1 (CompilerC-45RefCC-45RefC-n--14179-11274-u--getNameTag e-5 e-8 e-7 e-6 e-4 e-3 arg-8 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 arg-0 e-6 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-11 (car e-9))) (let ((e-10 (cdr e-9))) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append arg-6 (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Nat arg-8) (string-append "].tag = " (string-append e-11 ";")))))) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-12 (vector-ref act-2 1))) (vector 0 e-12))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append arg-6 (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Nat arg-8) (string-append "].name = " (string-append e-10 ";")))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else ((CompilerC-45RefCC-45RefC-copyConstructors arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 arg-7 (+ arg-8 1)) clam-1)))))))))))) eff-0) clam-0))))))))))))))))
(define CompilerC-45RefCC-45RefC-fillConstructorArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-3) (vector 1 (vector 0 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (string-append arg-2 (string-append "->args[" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append "] = newReference(" (string-append (CompilerC-45RefCC-45RefC-varName e-2) ");")))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (CompilerC-45RefCC-45RefC-fillConstructorArgs arg-0 arg-1 arg-2 e-3 (+ arg-4 1) ext-0)))))))))
(define CompilerC-45RefCC-45RefC-getNextCounter (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (+ e-5 1)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-getNewVarThatWillNotBeFreedAtEndOfBlock (lambda (arg-0 ext-0) (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append "tmp_" (PreludeC-45Show-u--show_Show_Nat e-5)))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-integer_switch (lambda (arg-0) (if (null? arg-0) 1 (let ((e-2 (car arg-0))) (let ((e-4 (car e-2))) (case (vector-ref e-4 0) ((0) 1) ((1) 1) ((2) 1) ((3) 1) ((4) 1) ((6) 1) ((7) 1) ((8) 1) ((9) 1) ((5) 1) ((11) 1)(else 0)))))))
(define CompilerC-45RefCC-45RefC-n--13716-10632-u--pushArgToArglist (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-7) (vector 1 (vector 0 )) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-3 arg-2 (vector 2 ) (string-append arg-6 (string-append "->args[" (string-append (PreludeC-45Show-u--show_Show_Nat arg-8) (string-append "] = " (string-append " newReference(" (string-append (CompilerC-45RefCC-45RefC-varName e-2) ");"))))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (CompilerC-45RefCC-45RefC-n--13716-10632-u--pushArgToArglist arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 (+ arg-8 1) ext-0)))))))))
(define CompilerC-45RefCC-45RefC-makeArglist (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--arglist (string-append "arglist_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (lambda (eta-0) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "Value_Arglist *" (string-append u--arglist (string-append " = newArglist(" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append "," (string-append (PreludeC-45Show-u--show_Show_Nat (+ (PreludeC-45TypesC-45List-lengthTR arg-5) arg-4)) ");"))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CompilerC-45RefCC-45RefC-n--13716-10632-u--pushArgToArglist arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--arglist arg-5 0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 u--arglist))))))))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-extractConstant (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int8 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int16 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int32 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Int64 e-4))) ((5) (let ((e-5 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((12) (let ((e-6 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Double e-6))) ((11) (let ((e-7 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Char e-7))) ((10) (let ((e-8 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-cStringQuoted e-8))) ((6) (let ((e-9 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits8 e-9))) ((7) (let ((e-10 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits16 e-10))) ((8) (let ((e-11 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits32 e-11))) ((9) (let ((e-12 (vector-ref arg-0 1))) (PreludeC-45Show-u--show_Show_Bits64 e-12)))(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unable to extract constant: " (CompilerC-45RefCC-45RefC-cConstant arg-0)))))))
(define CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-4) (lambda (eta-0) (vector 1 (cons arg-6 arg-7))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (lambda (clam-0) (cond ((equal? arg-5 0) (case (vector-ref e-4 0) ((10) (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--constantArray (string-append "constantArray_" (PreludeC-45Show-u--show_Show_Nat e-6)))) (lambda (eta-0) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "char **" (string-append u--constantArray (string-append " = (char**)malloc(sizeof(char*) * " (string-append (PreludeC-45Show-u--show_Show_Nat (+ (PreludeC-45TypesC-45List-lengthTR e-3) 1)) ");"))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 (cons (cons e-4 e-5) e-3) 1 u--constantArray "multiStringCompare") eta-0)))))))) eff-0) clam-0)))))) ((12) (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--constantArray (string-append "constantArray_" (PreludeC-45Show-u--show_Show_Nat e-6)))) (lambda (eta-0) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "double *" (string-append u--constantArray (string-append " = (double*)malloc(sizeof(double) * " (string-append (PreludeC-45Show-u--show_Show_Nat (+ (PreludeC-45TypesC-45List-lengthTR e-3) 1)) ");"))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 (cons (cons e-4 e-5) e-3) 1 u--constantArray "multiDoubleCompare") eta-0)))))))) eff-0) clam-0))))))(else (vector 1 (cons "ERROR_NOT_DOUBLE_OR_STRING" "ERROR_NOT_DOUBLE_OR_STRING")))))(else (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append arg-6 (string-append "[" (string-append (PreludeC-45Show-u--show_Show_Int (bs- arg-5 1 63)) (string-append "] = " (string-append (CompilerC-45RefCC-45RefC-extractConstant e-4) ";")))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 e-3 (bs+ arg-5 1 63) arg-6 arg-7) clam-0))))))))))))))
(define CompilerC-45RefCC-45RefC-registerVariableForAutomaticFreeing (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (if (null? e-5) (cons (cons arg-1 '()) '()) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (cons arg-1 e-2) e-3))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45RefCC-45RefC-showTag (lambda (arg-0) (if (null? arg-0) "-1" (let ((e-2 (unbox arg-0))) (PreludeC-45Show-u--show_Show_Int e-2)))))
(define CompilerC-45RefCC-45RefC-toPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newIORef")))) (lambda () (vector 0 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__readIORef")))) (lambda () (vector 1 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__writeIORef")))) (lambda () (vector 2 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__newArray")))) (lambda () (vector 3 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arrayGet")))) (lambda () (vector 4 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__arraySet")))) (lambda () (vector 5 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__getField")))) (lambda () (vector 6 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__setField")))) (lambda () (vector 7 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__void")))) (lambda () (vector 8 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__os")))) (lambda () (vector 9 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__codegen")))) (lambda () (vector 10 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollect")))) (lambda () (vector 11 ))) (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-1 (vector 1 (vector 0 "prim__onCollectAny")))) (lambda () (vector 12 ))) '()))))))))))))) (lambda () (vector 13 arg-0)))))(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unknown primitive: " (CompilerC-45RefCC-45RefC-cName arg-0)))))))
(define CompilerC-45RefCC-45RefC-u--show_Show_ExtPrim (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "newIORef") ((1) "readIORef") ((2) "writeIORef") ((3) "newArray") ((4) "arrayGet") ((5) "arraySet") ((6) "getField") ((7) "setField") ((8) "voidElim") ((9) "sysOS") ((10) "sysCodegen") ((11) "onCollect") ((12) "onCollectAny") (else (let ((e-0 (vector-ref arg-0 1))) (string-append "Unknown " (CoreC-45Name-u--show_Show_Name e-0)))))))
(define CompilerC-45RefCC-45RefC-cStatementsFromANF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 2))) (let ((u--returnLine (string-append "newReference(" (string-append (CompilerC-45RefCC-45RefC-varName e-1) ")")))) (lambda (eta-0) (vector 1 (cons u--returnLine u--returnLine)))))) ((1) (let ((e-2 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (string-append "// start " (string-append (CompilerC-45RefCC-45RefC-cName e-4) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--v) (CompilerC-45RefCC-45RefC-varName u--v)) e-5)) ")"))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (CompilerC-45RefCC-45RefC-makeArglist arg-0 arg-1 arg-2 arg-3 0 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--f_ptr_name (string-append "fPtr_" (PreludeC-45Show-u--show_Show_Nat e-8)))) (lambda (eta-2) (let ((act-4 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (string-append "Value *(*" (string-append u--f_ptr_name (string-append ")(Value_Arglist*) = " (string-append (CompilerC-45RefCC-45RefC-cName e-4) "_arglist;"))))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((u--closure_name (string-append "closure_" (PreludeC-45Show-u--show_Show_Nat e-8)))) (let ((act-5 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (string-append "Value *" (string-append u--closure_name (string-append " = (Value*)makeClosureFromArglist(" (string-append u--f_ptr_name (string-append ", " (string-append e-7 ");"))))))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-2 (string-append "// end   " (string-append (CompilerC-45RefCC-45RefC-cName e-4) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--v) (CompilerC-45RefCC-45RefC-varName u--v)) e-5)) ")"))))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (vector 1 (cons (string-append "trampoline(" (string-append u--closure_name ")")) u--closure_name)))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((2) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((e-9 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 (CompilerC-45RefCC-45RefC-makeArglist arg-0 arg-1 arg-2 arg-3 e-8 e-9 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--f_ptr_name (string-append "closure_" (PreludeC-45Show-u--show_Show_Nat e-10)))) (let ((u--f_ptr (string-append "Value *(*" (string-append u--f_ptr_name (string-append ")(Value_Arglist*) = " (string-append (CompilerC-45RefCC-45RefC-cName e-7) "_arglist;")))))) (lambda (eta-2) (let ((act-3 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-6 u--f_ptr) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((u--returnLine (string-append "(Value*)makeClosureFromArglist(" (string-append u--f_ptr_name (string-append ", " (string-append e-5 ")")))))) (vector 1 (cons u--returnLine u--returnLine))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((3) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (lambda (eta-0) (vector 1 (cons (string-append "apply_closure(" (string-append (CompilerC-45RefCC-45RefC-varName e-12) (string-append ", " (string-append (CompilerC-45RefCC-45RefC-varName e-13) ")")))) (string-append "tailcall_apply_closure(" (string-append (CompilerC-45RefCC-45RefC-varName e-12) (string-append ", " (string-append (CompilerC-45RefCC-45RefC-varName e-13) ")")))))))))) ((4) (let ((e-14 (vector-ref arg-4 1))) (let ((e-15 (vector-ref arg-4 2))) (let ((e-16 (vector-ref arg-4 3))) (let ((e-17 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-16 1) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-14 (string-append "Value * var_" (string-append (PreludeC-45Show-u--show_Show_Int e-15) (string-append " = " (string-append (let ((e-0 (car e-5))) e-0) ";"))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-registerVariableForAutomaticFreeing arg-1 (string-append "var_" (PreludeC-45Show-u--show_Show_Int e-15))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-17 arg-5) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 e-8)))) eff-0) eta-1)))))))))))))) eff-0) eta-0))))))))))) ((5) (let ((e-18 (vector-ref arg-4 1))) (let ((e-19 (vector-ref arg-4 2))) (let ((e-20 (vector-ref arg-4 3))) (let ((e-21 (vector-ref arg-4 4))) (let ((e-22 (vector-ref arg-4 5))) (lambda (clam-0) (case (vector-ref e-20 0) ((10) (if (null? e-22) (vector 1 (cons "(Value*)NULL" "(Value*)NULL")) (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--constr (string-append "constructor_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (lambda (eta-0) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (string-append "Value_Constructor* " (string-append u--constr (string-append " = newConstructor(" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-22)) (string-append ", " (string-append (CompilerC-45RefCC-45RefC-showTag e-21) (string-append ", " (string-append "\"" (string-append (CompilerC-45RefCC-45RefC-cName e-19) "\");")))))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (string-append " // constructor " (CompilerC-45RefCC-45RefC-cName e-19))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CompilerC-45RefCC-45RefC-fillConstructorArgs arg-2 arg-3 u--constr e-22 0 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (cons (string-append "(Value*)" u--constr) (string-append "(Value*)" u--constr)))))))))))))))) eff-0) clam-0)))))))(else (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--constr (string-append "constructor_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (lambda (eta-0) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (string-append "Value_Constructor* " (string-append u--constr (string-append " = newConstructor(" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-22)) (string-append ", " (string-append (CompilerC-45RefCC-45RefC-showTag e-21) (string-append ", " (string-append "\"" (string-append (CompilerC-45RefCC-45RefC-cName e-19) "\");")))))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-18 (string-append " // constructor " (CompilerC-45RefCC-45RefC-cName e-19))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CompilerC-45RefCC-45RefC-fillConstructorArgs arg-2 arg-3 u--constr e-22 0 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (cons (string-append "(Value*)" u--constr) (string-append "(Value*)" u--constr)))))))))))))))) eff-0) clam-0)))))))))))))) ((6) (let ((e-26 (vector-ref arg-4 3))) (let ((e-27 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 (CompilerC-45RefCC-45RefC-cArgsVectANF e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--opStatement (CompilerC-45RefCC-45RefC-cOp e-26 e-5))) (lambda (eta-1) (vector 1 (cons u--opStatement u--opStatement)))))) eff-0) eta-0))))))))) ((7) (let ((e-28 (vector-ref arg-4 1))) (let ((e-30 (vector-ref arg-4 3))) (let ((e-31 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-28 (string-append "// call to external primitive " (CompilerC-45RefCC-45RefC-cName e-30))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--returnLine (string-append (CompilerC-45RefCC-45RefC-cCleanString (CompilerC-45RefCC-45RefC-u--show_Show_ExtPrim (CompilerC-45RefCC-45RefC-toPrim e-30))) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CompilerC-45RefCC-45RefC-varName eta-1)) e-31)) ")"))))) (vector 1 (cons u--returnLine u--returnLine))))))))))) ((8) (let ((e-32 (vector-ref arg-4 1))) (let ((e-33 (vector-ref arg-4 2))) (let ((e-34 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 (CompilerC-45RefCC-45RefC-getNextCounter arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45RefCC-45RefC-getNewVarThatWillNotBeFreedAtEndOfBlock arg-0 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--newValueLine (string-append "Value * " (string-append e-6 " = NULL;")))) (let ((u--constructorField (string-append "constructorField_" (PreludeC-45Show-u--show_Show_Nat e-5)))) (let ((u--constructorFieldLine (string-append "AConAlt * " (string-append u--constructorField (string-append "= newConstructorField(" (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-34)) ");")))))) (let ((u--switchLine (string-append "switch(compareConstructors(" (string-append (CompilerC-45RefCC-45RefC-varName e-33) (string-append ", " (string-append u--constructorField (string-append ", " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-34)) ")){")))))))) (lambda (eta-2) (let ((act-3 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-32 u--newValueLine) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-32 u--constructorFieldLine) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CompilerC-45RefCC-45RefC-copyConstructors arg-0 arg-1 arg-2 arg-3 (CompilerC-45RefCC-45RefC-varName e-33) e-34 u--constructorField e-6 0) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-32 u--switchLine) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((CompilerC-45RefCC-45RefC-conBlocks arg-0 arg-1 arg-2 arg-3 (CompilerC-45RefCC-45RefC-varName e-33) e-34 e-6 0 arg-5) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (if (null? e-35) (let ((act-8 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "free(" (string-append u--constructorField ");"))) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (vector 1 (cons e-6 e-6)))))))) (let ((e-2 (unbox e-35))) (let ((act-8 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  default : {") eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((act-9 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-3) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((act-10 ((CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-1) eta-2))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((act-11 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-0 arg-1 arg-2 arg-3 e-2 arg-5) eta-2))) (case (vector-ref act-11 0) ((0) (let ((e-3 (vector-ref act-11 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-12 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append e-6 (string-append " = " (string-append (CompilerC-45RefCC-45RefC-callByPosition arg-5 e-15) ";")))) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-3 (vector-ref act-12 1))) (vector 0 e-3))) (else (let ((act-13 (CompilerC-45RefCC-45RefC-freeTmpVars arg-1 arg-2 arg-3 eta-3))) (case (vector-ref act-13 0) ((0) (let ((e-3 (vector-ref act-13 1))) (vector 0 e-3))) (else (let ((act-14 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-3) eta-3))) (case (vector-ref act-14 0) ((0) (let ((e-3 (vector-ref act-14 1))) (vector 0 e-3))) (else (let ((act-15 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "  }") eta-3))) (case (vector-ref act-15 0) ((0) (let ((e-3 (vector-ref act-15 1))) (vector 0 e-3))) (else (let ((act-16 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-3))) (case (vector-ref act-16 0) ((0) (let ((e-3 (vector-ref act-16 1))) (vector 0 e-3))) (else (let ((act-17 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "free(" (string-append u--constructorField ");"))) eta-3))) (case (vector-ref act-17 0) ((0) (let ((e-3 (vector-ref act-17 1))) (vector 0 e-3))) (else (vector 1 (cons e-6 e-6))))))))))))))))))))))) eff-0) eta-2)))))))))))))))))))))))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((9) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (let ((e-38 (vector-ref arg-4 3))) (let ((e-39 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 (CompilerC-45RefCC-45RefC-getNewVarThatWillNotBeFreedAtEndOfBlock arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--newValueLine (string-append "Value * " (string-append e-5 " = NULL;")))) (lambda (eta-1) (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-36 u--newValueLine) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((sc3 (CompilerC-45RefCC-45RefC-integer_switch e-38))) (cond ((equal? sc3 1) (let ((act-3 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-36 (string-append "switch(extractInt(" (string-append (CompilerC-45RefCC-45RefC-varName e-37) ")){"))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-constBlockSwitch arg-0 arg-1 arg-2 arg-3 e-38 e-5 0 arg-5) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CompilerC-45RefCC-45RefC-constDefaultBlock arg-0 arg-1 arg-2 arg-3 e-39 e-5 arg-5 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 (cons e-5 e-5))))))))))))))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-makeNonIntSwitchStatementConst arg-0 arg-1 arg-2 arg-3 e-38 0 "" "") eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-4 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-36 (string-append "switch(" (string-append e-3 (string-append "(" (string-append (CompilerC-45RefCC-45RefC-varName e-37) (string-append ", " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-38)) (string-append ", " (string-append e-2 ")){"))))))))) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 ((CompilerC-45RefCC-45RefC-constBlockSwitch arg-0 arg-1 arg-2 arg-3 e-38 e-5 0 arg-5) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CompilerC-45RefCC-45RefC-constDefaultBlock arg-0 arg-1 arg-2 arg-3 e-39 e-5 arg-5 clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) "}") clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 (vector 2 ) (string-append "free(" (string-append e-2 ");"))) clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (vector 1 (cons e-5 e-5)))))))))))))))))))))) eff-0) eta-1))))))))))))))) eff-0) eta-0))))))))))) ((10) (let ((e-41 (vector-ref arg-4 2))) (lambda (eta-0) (vector 1 (cons (CompilerC-45RefCC-45RefC-cConstant e-41) (CompilerC-45RefCC-45RefC-cConstant e-41)))))) ((11) (lambda (eta-0) (vector 1 (cons "NULL" "NULL")))) (else (let ((e-43 (vector-ref arg-4 1))) (lambda (eta-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-2 arg-3 e-43 "// CRASH") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons "NULL" "NULL")))))))))))
(define CompilerC-45RefCC-45RefC-functionDefSignature (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fn (CompilerC-45RefCC-45RefC-cName e-5))) (lambda (eta-1) (vector 1 (string-append "\xa;\xa;Value *" (string-append u--fn "(void)"))))))) eff-0) eta-0)))))) (let ((u--argsStringList (CompilerC-45RefCC-45RefC-addCommaToList (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--i) (string-append "  Value * var_" (PreludeC-45Show-u--show_Show_Int u--i))) arg-2)))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fn (CompilerC-45RefCC-45RefC-cName e-5))) (lambda (eta-1) (vector 1 (string-append "\xa;\xa;Value *" (string-append u--fn (string-append "\xa;(\xa;" (string-append (CoreC-45NameC-45Namespace-showSep "\xa;" u--argsStringList) "\xa;)"))))))))) eff-0) eta-0))))))))))
(define CompilerC-45RefCC-45RefC-functionDefSignatureArglist (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append "Value *" (string-append (CompilerC-45RefCC-45RefC-cName e-5) "_arglist(Value_Arglist* arglist)")))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-getArgsNrList (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (cons arg-2 (CompilerC-45RefCC-45RefC-getArgsNrList e-3 (+ arg-2 1)))))))
(define CompilerC-45RefCC-45RefC-addHeader (lambda (arg-0 ext-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (LibrariesC-45DataC-45SortedSet-insert ext-0 e-5)))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CompilerC-45RefCC-45RefC-cTypeOfCFType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "void") ((1) "int64_t") ((7) "uint8_t") ((8) "uint16_t") ((9) "uint32_t") ((10) "uint64_t") ((11) "char *") ((12) "double") ((13) "char") ((14) "void *") ((15) "void *") ((16) "void *") ((18) "void *") ((19) "void *") ((20) "void *") ((21) "void *") ((22) "void *")(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-0)))))))
(define CompilerC-45RefCC-45RefC-discardLastArgument (lambda (arg-1) (if (null? arg-1) '() (DataC-45List-init arg-1))))
(define CompilerC-45RefCC-45RefC-additionalFFIStub (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((20) (let ((e-0 (vector-ref arg-2 1))) (CompilerC-45RefCC-45RefC-additionalFFIStub arg-0 (CompilerC-45RefCC-45RefC-discardLastArgument arg-1) e-0)))(else (string-append (CompilerC-45RefCC-45RefC-cTypeOfCFType arg-2) (string-append " (*" (string-append (CompilerC-45RefCC-45RefC-cName arg-0) (string-append ")(" (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45RefCC-45RefC-cTypeOfCFType eta-0)) arg-1))) ") = (void*)missing_ffi;\xa;")))))))))
(define CompilerC-45RefCC-45RefC-varNamesFromList (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (string-append "var_" (PreludeC-45Show-u--show_Show_Nat eta-0))) (CompilerC-45RefCC-45RefC-getArgsNrList arg-1 arg-2))))
(define DataC-45List-u--zipWith3_Zippable_List (lambda (arg-4 arg-5 arg-6 arg-7) (if (null? arg-5) '() (if (null? arg-6) '() (if (null? arg-7) '() (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-4 (car arg-6))) (let ((e-5 (cdr arg-6))) (let ((e-7 (car arg-7))) (let ((e-8 (cdr arg-7))) (cons (((arg-4 e-1) e-4) e-7) (DataC-45List-u--zipWith3_Zippable_List arg-4 e-2 e-5 e-8)))))))))))))
(define DataC-45List-u--zip3_Zippable_List (lambda (ext-0 ext-1 ext-2) (DataC-45List-u--zipWith3_Zippable_List (lambda (__leftTupleSection-0) (lambda (__infixTupleSection-0) (lambda (__infixTupleSection-1) (cons __leftTupleSection-0 (cons __infixTupleSection-0 __infixTupleSection-1))))) ext-0 ext-1 ext-2)))
(define CompilerC-45RefCC-45RefC-createFFIArgList (lambda (arg-0) (let ((u--sList (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45RefCC-45RefC-cTypeOfCFType eta-0)) arg-0))) (let ((u--varList (CompilerC-45RefCC-45RefC-varNamesFromList arg-0 1))) (lambda (eta-0) (vector 1 (DataC-45List-u--zip3_Zippable_List u--sList u--varList arg-0)))))))
(define CompilerC-45RefCC-45RefC-emitFDef (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (string-append "Value *" (string-append (CompilerC-45RefCC-45RefC-cName arg-2) "(void)"))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((act-1 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (string-append "Value *" (CompilerC-45RefCC-45RefC-cName arg-2))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) "(") clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-1) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (string-append "  Value *" e-10)) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 ((CoreC-45Core-traverse_ (lambda (lamc-0) (let ((e-4 (cdr lamc-0))) (let ((e-15 (car e-4))) (CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) (string-append ", Value *" e-15))))) e-3) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-1) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else ((CompilerC-45RefCC-45RefC-emit arg-0 arg-1 (vector 2 ) ")") clam-0)))))))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-extractValue (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) "NULL") ((1) (string-append "((Value_Int64*)" (string-append arg-2 ")->i64"))) ((3) (string-append "((Value_Int8*)" (string-append arg-2 ")->i8"))) ((4) (string-append "((Value_Int16*)" (string-append arg-2 ")->i16"))) ((5) (string-append "((Value_Int32*)" (string-append arg-2 ")->i32"))) ((6) (string-append "((Value_Int64*)" (string-append arg-2 ")->i64"))) ((7) (string-append "((Value_Bits8*)" (string-append arg-2 ")->ui8"))) ((8) (string-append "((Value_Bits16*)" (string-append arg-2 ")->ui16"))) ((9) (string-append "((Value_Bits32*)" (string-append arg-2 ")->ui32"))) ((10) (string-append "((Value_Bits64*)" (string-append arg-2 ")->ui64"))) ((11) (string-append "((Value_String*)" (string-append arg-2 ")->str"))) ((12) (string-append "((Value_Double*)" (string-append arg-2 ")->d"))) ((13) (string-append "((Value_Char*)" (string-append arg-2 ")->c"))) ((14) (string-append "((Value_Pointer*)" (string-append arg-2 ")->p"))) ((15) (string-append "((Value_GCPointer*)" (string-append arg-2 ")->p->p")))(else (cond ((equal? arg-0 0) (case (vector-ref arg-1 0) ((16) (string-append "((Value_Buffer*)" (string-append arg-2 ")->buffer->data")))(else (case (vector-ref arg-1 0) ((18) (string-append "(Value_World*)" arg-2)) ((19) (string-append "(Value_Closure*)" arg-2)) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45RefCC-45RefC-extractValue arg-0 e-2 arg-2))) ((21) (Builtin-idris_crash (string-append "INTERNAL ERROR: Struct access not implemented: " arg-2))) ((22) (string-append "(Value*)" arg-2))(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-1)))))))) ((equal? arg-0 1) (case (vector-ref arg-1 0) ((16) (string-append "((Value_Buffer*)" (string-append arg-2 ")->buffer")))(else (case (vector-ref arg-1 0) ((18) (string-append "(Value_World*)" arg-2)) ((19) (string-append "(Value_Closure*)" arg-2)) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45RefCC-45RefC-extractValue arg-0 e-2 arg-2))) ((21) (Builtin-idris_crash (string-append "INTERNAL ERROR: Struct access not implemented: " arg-2))) ((22) (string-append "(Value*)" arg-2))(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-1))))))))(else (case (vector-ref arg-1 0) ((18) (string-append "(Value_World*)" arg-2)) ((19) (string-append "(Value_Closure*)" arg-2)) ((20) (let ((e-2 (vector-ref arg-1 1))) (CompilerC-45RefCC-45RefC-extractValue arg-0 e-2 arg-2))) ((21) (Builtin-idris_crash (string-append "INTERNAL ERROR: Struct access not implemented: " arg-2))) ((22) (string-append "(Value*)" arg-2))(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-1)))))))))))
(define CompilerC-45RefCC-45RefC-packCFType (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) "NULL") ((1) (string-append "makeInt64(" (string-append arg-1 ")"))) ((3) (string-append "makeInt8(" (string-append arg-1 ")"))) ((4) (string-append "makeInt16(" (string-append arg-1 ")"))) ((5) (string-append "makeInt32(" (string-append arg-1 ")"))) ((6) (string-append "makeInt64(" (string-append arg-1 ")"))) ((10) (string-append "makeBits64(" (string-append arg-1 ")"))) ((9) (string-append "makeBits32(" (string-append arg-1 ")"))) ((8) (string-append "makeBits16(" (string-append arg-1 ")"))) ((7) (string-append "makeBits8(" (string-append arg-1 ")"))) ((11) (string-append "makeString(" (string-append arg-1 ")"))) ((12) (string-append "makeDouble(" (string-append arg-1 ")"))) ((13) (string-append "makeChar(" (string-append arg-1 ")"))) ((14) (string-append "makePointer(" (string-append arg-1 ")"))) ((15) (string-append "makePointer(" (string-append arg-1 ")"))) ((16) (string-append "makeBuffer(" (string-append arg-1 ")"))) ((18) (string-append "makeWorld(" (string-append arg-1 ")"))) ((19) (string-append "makeFunction(" (string-append arg-1 ")"))) ((20) (let ((e-2 (vector-ref arg-0 1))) (CompilerC-45RefCC-45RefC-packCFType e-2 arg-1))) ((21) (string-append "makeStruct(" (string-append arg-1 ")"))) ((22) arg-1)(else (Builtin-idris_crash (string-append "INTERNAL ERROR: Unknonw FFI type in C backend: " (CoreC-45CompileExpr-u--show_Show_CFType arg-0)))))))
(define CompilerC-45RefCC-45RefC-case--createCFunctions-13854 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (Builtin-idris_crash (string-append "INTERNAL ERROR: FFI not found for " (CompilerC-45RefCC-45RefC-cName arg-4))) (let ((e-1 (unbox arg-12))) (if (null? e-1) (Builtin-idris_crash (string-append "INTERNAL ERROR: FFI not found for " (CompilerC-45RefCC-45RefC-cName arg-4))) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (Builtin-idris_crash (string-append "INTERNAL ERROR: FFI not found for " (CompilerC-45RefCC-45RefC-cName arg-4))) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((u--cLang (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-4 "RefC"))) (cond ((equal? sc3 1) 1) (else 0))))) (let ((u--isStandardFFI (PreludeC-45Types-elem csegen-14 csegen-22 e-4 csegen-5138))) (let ((u--fctName (cond ((equal? u--isStandardFFI 1) (vector 1 (vector 0 e-7))) (else (vector 0 (CoreC-45NameC-45Namespace-mkNamespace e-4) arg-4))))) (lambda (eta-0) (let ((act-1 (cond ((equal? u--isStandardFFI 1) (if (null? e-8) (vector 1 (vector 0 )) (let ((e-2 (cdr e-8))) (if (null? e-2) (vector 1 (vector 0 )) (let ((e-9 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) ((CompilerC-45RefCC-45RefC-addHeader arg-5 e-9) eta-0) (vector 1 (vector 0 ))))))))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (CompilerC-45RefCC-45RefC-additionalFFIStub u--fctName arg-2 arg-1)) eta-0))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--fnDef (string-append "Value *" (string-append (CompilerC-45RefCC-45RefC-cName arg-4) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (DataC-45List-replicateTR '() (PreludeC-45TypesC-45List-lengthTR arg-2) "Value *")) ");")))))) (let ((act-2 (CompilerC-45RefCC-45RefC-functionDefSignatureArglist arg-11 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-9))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-9 (cons (string-append u--fnDef "\xa;") (cons (string-append e-9 ";\xa;") e-10))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-createFFIArgList arg-2) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) e-9) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "{") eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-6) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append "return " (CompilerC-45RefCC-45RefC-cName arg-4))) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-6) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "(") eta-2))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-6) eta-2))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((u--commaSepArglist (CompilerC-45RefCC-45RefC-addCommaToList (PreludeC-45TypesC-45List-mapAppend '() csegen-5139 (CompilerC-45RefCC-45RefC-getArgsNrList arg-2 0))))) (let ((act-12 ((CoreC-45Core-traverse_ (lambda (eta-3) (CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) eta-3)) u--commaSepArglist) eta-2))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-6) eta-2))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) ");") eta-2))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((act-15 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-6) eta-2))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((act-16 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-6) eta-2))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((act-17 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "}\xa;") eta-2))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((act-18 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "") eta-2))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((act-19 ((CompilerC-45RefCC-45RefC-emitFDef arg-7 arg-6 arg-4 e-11) eta-2))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((act-20 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "{") eta-2))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((act-21 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-6) eta-2))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((act-22 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append " // ffi call to " (CompilerC-45RefCC-45RefC-cName u--fctName))) eta-2))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((act-23 (case (vector-ref arg-1 0) ((20) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((act-23 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append (CompilerC-45RefCC-45RefC-cName u--fctName) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-31 (car e-3))) (let ((e-30 (cdr e-3))) (CompilerC-45RefCC-45RefC-extractValue u--cLang e-30 e-31))))) (CompilerC-45RefCC-45RefC-discardLastArgument e-11))) ");")))) eta-2))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "return NULL;") eta-2)))))(else (let ((act-23 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append (CompilerC-45RefCC-45RefC-cTypeOfCFType e-0) (string-append " retVal = " (string-append (CompilerC-45RefCC-45RefC-cName u--fctName) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-31 (car e-3))) (let ((e-30 (cdr e-3))) (CompilerC-45RefCC-45RefC-extractValue u--cLang e-30 e-31))))) (CompilerC-45RefCC-45RefC-discardLastArgument e-11))) ");")))))) eta-2))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append "return (Value*)" (string-append (CompilerC-45RefCC-45RefC-packCFType e-0 "retVal") ";"))) eta-2))))))))(else (let ((act-23 ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append (CompilerC-45RefCC-45RefC-cTypeOfCFType arg-1) (string-append " retVal = " (string-append (CompilerC-45RefCC-45RefC-cName u--fctName) (string-append "(" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (let ((e-31 (car e-3))) (let ((e-30 (cdr e-3))) (CompilerC-45RefCC-45RefC-extractValue u--cLang e-30 e-31))))) e-11)) ");")))))) eta-2))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) (string-append "return (Value*)" (string-append (CompilerC-45RefCC-45RefC-packCFType arg-1 "retVal") ";"))) eta-2)))))))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else (let ((act-24 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-6) eta-2))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else ((CompilerC-45RefCC-45RefC-emit arg-7 arg-6 (vector 2 ) "}") eta-2))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))))))))))))))))
(define CompilerC-45RefCC-45RefC-createCFunctions (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (lambda (eta-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-functionDefSignature arg-0 arg-8 e-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45RefCC-45RefC-functionDefSignatureArglist arg-0 arg-8 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-2))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-2 (cons (string-append e-5 ";\xa;") (cons (string-append e-6 ";\xa;") e-7))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CompilerC-45RefCC-45RefC-newTemporaryVariableLevel arg-3) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--argsNrs (CompilerC-45RefCC-45RefC-getArgsNrList e-0 0))) (let ((act-5 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) e-5) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "{") eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-5) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((CompilerC-45RefCC-45RefC-cStatementsFromANF arg-1 arg-3 arg-4 arg-5 e-1 0) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) (string-append "Value *returnValue = " (string-append (let ((e-2 (cdr e-12))) e-2) ";"))) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (CompilerC-45RefCC-45RefC-freeTmpVars arg-3 arg-4 arg-5 eta-3))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "return returnValue;") eta-3))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-5) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "}\xa;") eta-3))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "") eta-3))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((act-15 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) e-6) eta-3))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((act-16 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "{") eta-3))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((act-17 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-5) eta-3))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((act-18 (let ((act-18 (CoreC-45Context-getFullName arg-0 arg-8 eta-3))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-0 (CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) (string-append "return " (CompilerC-45RefCC-45RefC-cName e-22))))) eff-0) eta-3))))))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((act-19 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-5) eta-3))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((act-20 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "(") eta-3))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((act-21 ((CompilerC-45RefCC-45RefC-increaseIndentation arg-5) eta-3))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((u--commaSepArglist (CompilerC-45RefCC-45RefC-addCommaToList (PreludeC-45TypesC-45List-mapAppend '() csegen-5139 u--argsNrs)))) (let ((act-22 ((CoreC-45Core-traverse_ (lambda (eta-4) (CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) eta-4)) u--commaSepArglist) eta-3))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((act-23 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-5) eta-3))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else (let ((act-24 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) ");") eta-3))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((act-25 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-5) eta-3))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((act-26 ((CompilerC-45RefCC-45RefC-decreaseIndentation arg-5) eta-3))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((act-27 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "}\xa;") eta-3))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((act-28 ((CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) "") eta-3))) (case (vector-ref act-28 0) ((0) (let ((e-2 (vector-ref act-28 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) eff-0) eta-2)))))))))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((1) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (CompilerC-45RefCC-45RefC-emit arg-4 arg-5 (vector 2 ) (string-append "// Constructor tag " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-2) (string-append " arity " (PreludeC-45Show-u--show_Show_Nat e-3)))))))) ((2) (let ((e-5 (vector-ref arg-9 1))) (let ((e-6 (vector-ref arg-9 2))) (let ((e-7 (vector-ref arg-9 3))) (CompilerC-45RefCC-45RefC-case--createCFunctions-13854 arg-7 e-7 e-6 e-5 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (CompilerC-45Common-parseCC (PreludeC-45TypesC-45List-tailRecAppend arg-7 csegen-5138) e-5)))))) (else (let ((e-8 (vector-ref arg-9 1))) (Builtin-idris_crash (string-append "INTERNAL ERROR: Error with expression: " (CompilerC-45ANF-u--show_Show_ANF e-8))))))))
(define CompilerC-45RefCC-45RefC-footer (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45RefCC-45RefC-emit arg-1 arg-0 (vector 2 ) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "\xa;// main function\xa;int main(int argc, char *argv[])\xa;{\xa;    " (cons (let ((sc1 (LibrariesC-45DataC-45SortedSet-contains "idris_support.h" e-5))) (cond ((equal? sc1 1) "idris2_setArgs(argc, argv);") (else ""))) (cons "\xa;    global_IORef_Storage = NULL;\xa;    Value *mainExprVal = __mainExpression_0();\xa;    trampoline(mainExprVal);\xa;    return 0; // bye bye\xa;}" '()))))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45DList-appendL (lambda (arg-1 arg-2 ext-0) (PreludeC-45TypesC-45List-tailRecAppend arg-1 (arg-2 ext-0))))
(define CompilerC-45RefCC-45RefC-header (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--initLines (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "#include <runtime.h>\xa;/* " (cons (CompilerC-45Generated-generatedString "RefC") (cons " */\xa;\xa;/* a global storage for IO References */\xa;IORef_Storage * global_IORef_Storage;\xa;\xa;" '())))))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--headerFiles (LibrariesC-45DataC-45SortedSet-toList e-5))) (let ((u--headerLines (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--h) (string-append "#include <" (string-append u--h ">\xa;"))) u--headerFiles))) (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-2))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-2 (lambda (eta-2) (LibrariesC-45DataC-45DList-appendL (PreludeC-45TypesC-45List-tailRecAppend (cons u--initLines '()) (PreludeC-45TypesC-45List-tailRecAppend u--headerLines (PreludeC-45TypesC-45List-tailRecAppend (cons "\xa;// function definitions" '()) e-6))) e-7 eta-2))))) (vector 1 act-4))))) eff-1) world-0))))))))) eff-0) eta-1)))))))))) eff-0) eta-0)))))))))
(define LibrariesC-45DataC-45DList-reify (lambda (arg-1) (arg-1 '())))
(define CompilerC-45RefCC-45RefC-generateCSourceFile (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.RefC.RefC.ArgCounter" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "Compiler.RefC.RefC.FunctionDefinitions" ) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-newRef (vector "Compiler.RefC.RefC.TemporaryVariableTracker" ) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-newRef (vector "Compiler.RefC.RefC.OutfileText" ) (lambda (eta-3) eta-3)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-newRef (vector "Compiler.RefC.RefC.HeaderFiles" ) (LibrariesC-45DataC-45SortedSet-empty csegen-519)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Core-newRef (vector "Compiler.RefC.RefC.IndentLevel" ) 0) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CoreC-45Core-traverse_ (lambda (eta-6) (PreludeC-45Basics-uncurry (lambda (eta-7) (lambda (eta-8) (CompilerC-45RefCC-45RefC-createCFunctions arg-0 e-5 e-6 e-7 e-8 e-10 e-9 arg-1 eta-7 eta-8))) eta-6)) arg-2) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((CompilerC-45RefCC-45RefC-header arg-0 e-6 e-8 e-10 e-9) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (CompilerC-45RefCC-45RefC-footer e-10 e-8 e-9 eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (let ((act-10 (unbox e-8))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--code (PreludeC-45Types-fastConcat (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-4) (string-append arg-4 "\xa;")) (LibrariesC-45DataC-45DList-reify e-14))))) (lambda (eta-6) (let ((act-11 ((let ((eff-0 (lambda (world-0) (let ((act-11 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 arg-3 u--code) world-0))) (vector 1 act-11))))) (lambda (eta-7) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-7))) eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-log arg-0 "compiler.refc" 10 (lambda () (string-append "Generated C file " arg-3)) eta-6)))))))) eff-0) eta-5))))))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-0 2) (let ((u--outn (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (string-append arg-6 ".c")))) (let ((u--outobj (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (string-append arg-6 ".o")))) (let ((u--outexec (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 arg-6))) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (CoreC-45Directory-mkdirAll arg-4 world-0))) (vector 1 act-1))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CompilerC-45Common-getCompileData arg-1 0 2 arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--defs (let ((e-4 (vector-ref e-6 4))) e-4))) (lambda (eta-1) (let ((act-3 (CompilerC-45RefCC-45RefC-generateCSourceFile arg-1 '() u--defs u--outn eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CompilerC-45RefCC-45CC-compileCObjectFile arg-1 0 u--outn u--outobj eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-8) (vector 1 '()) (CompilerC-45RefCC-45CC-compileCFile arg-1 0 u--outobj u--outexec clam-0))))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45RefCC-45RefC-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CompilerC-45RefCC-45RefC-compileExpr 2 arg-0 arg-1 arg-2 arg-2 arg-3 "_tmp_refc") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (let ((eff-0 (lambda (world-0) (let ((act-2 (PreludeC-45IO-prim__putStr "Error: failed to compile\xa;" world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) (let ((eff-0 (lambda (world-0) (let ((act-2 ((System-system csegen-82 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 "_tmp_refc")) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0)))))) eff-0) ext-0)))))))
(define CompilerC-45RefCC-45RefC-codegenRefC (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (CompilerC-45RefCC-45RefC-compileExpr 2 eta-0 eta-1 eta-2 eta-3 eta-4 eta-5))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45RefCC-45RefC-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) '() '())))
(define CompilerC-45InterpreterC-45VMCode-compileExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "compile not implemeted for vmcode-interp") ext-0)))
(define PreludeC-45Types-pack (lambda (arg-0) (if (null? arg-0) "" (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (string-cons e-2 (PreludeC-45Types-pack e-3)))))))
(define CompilerC-45InterpreterC-45VMCode-saveLocals (lambda (arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (set-box! arg-1 e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45InterpreterC-45VMCode-beginFunction (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) (lambda (eta-0) (vector 1 arg-2)) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((0) (let ((e-3 (vector-ref e-1 1))) (case (vector-ref e-3 0) ((1) (let ((e-4 (vector-ref e-3 1))) (CompilerC-45InterpreterC-45VMCode-beginFunction arg-0 arg-1 e-2 (PreludeC-45EqOrd-u--max_Ord_Int e-4 arg-3))))(else (CompilerC-45InterpreterC-45VMCode-beginFunction arg-0 arg-1 e-2 arg-3))))) ((1) (lambda (eta-0) (let ((act-1 (let ((act-1 ((LibrariesC-45DataC-45IOArray-newArray csegen-82 (bs+ arg-3 1 63)) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-2 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 e-5 e-4 e-3) clam-0))) (vector 1 act-2)))))) arg-1 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-0))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-7 0))) (vector e-0 e-5 '()))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 e-2)))))))))) eff-0) eta-0)))))))(else (lambda (eta-0) (vector 1 arg-2)))))))))
(define CompilerC-45InterpreterC-45VMCode-n--10673-1809-u--showWithIndex (lambda (arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (if (null? arg-7) "" (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (string-append "  " (string-append (PreludeC-45Show-u--show_Show_Nat arg-5) (string-append ": " (string-append (let ((e-1 (car arg-6))) (e-1 e-2)) (string-append "\xa;" (CompilerC-45InterpreterC-45VMCode-n--10673-1809-u--showWithIndex arg-1 arg-2 arg-3 (+ arg-5 1) arg-6 e-3)))))))))))
(define CompilerC-45InterpreterC-45VMCode-interpError (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((act-2 (let ((act-2 ((LibrariesC-45DataC-45IOArray-toList csegen-82 e-1) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Interpreter Error in " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (DataC-45List-take 10 arg-2)) (string-append ":\xa;" (string-append arg-3 (string-append "\xa;\xa;locals:\xa;" (string-append (CompilerC-45InterpreterC-45VMCode-n--10673-1809-u--showWithIndex arg-1 arg-3 arg-2 0 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-4745 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-4745 u--d u--x)))) e-6) (string-append "\xa;return:\xa;  " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-4745 e-2))))))))) eta-0)))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define CompilerC-45InterpreterC-45VMCode-getReg (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-4722 (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((LibrariesC-45DataC-45IOArray-readArray csegen-82 e-5 e-0) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 (string-append "Missing local " (PreludeC-45Show-u--show_Show_Int e-0)) clam-0) (let ((e-1 (unbox e-6))) (vector 1 e-1)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))) ((0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 "Missing returnObj val" clam-1) (let ((e-1 (unbox e-5))) (vector 1 e-1)))))) eff-0) ext-0)))))) (else (vector 1 (vector 3 ))))))
(define CompilerC-45InterpreterC-45VMCode-NS_UN (lambda (arg-0 arg-1) (vector 0 arg-0 (vector 1 (vector 0 arg-1)))))
(define CoreC-45NameC-45Namespace-ioNS (CoreC-45NameC-45Namespace-mkNamespace "Prelude.IO"))
(define CompilerC-45InterpreterC-45VMCode-argError (lambda (arg-2 arg-3 arg-4 ext-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-3 (string-append "Unexpected arguments: " (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 csegen-59 (lambda (eta-0) (string-append " " (CompilerC-45InterpreterC-45VMCode-showDepth 1 eta-0))) arg-4)) ext-0)))
(define CompilerC-45InterpreterC-45VMCode-n--11434-2537-u--world (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (lambda (eta-0) (vector 1 (vector 0 )))) ((2) (let ((e-0 (vector-ref arg-2 1))) (lambda (clam-0) (case (vector-ref e-0 0) ((14) (vector 1 (vector 0 )))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "expected %MkWorld or Null, got " (cons (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object arg-2) '()))) clam-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "expected %MkWorld or Null, got " (cons (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object arg-2) '()))) eta-0))))))
(define CompilerC-45InterpreterC-45VMCode-n--11434-2533-u--prim_getChar (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-C-42C-62 (CompilerC-45InterpreterC-45VMCode-n--11434-2537-u--world arg-0 arg-1 e-2) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-4 (vector-ref eta-2 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (vector 2 (vector 11 e-5))))))) (lambda (eta-2) (let ((act-1 (PreludeC-45IO-prim__getChar eta-2))) (vector 1 act-1))) eta-1)) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))))
(define CompilerC-45InterpreterC-45VMCode-n--11434-2534-u--prim_getStr (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (lambda (eta-0) (CoreC-45Core-C-42C-62 (CompilerC-45InterpreterC-45VMCode-n--11434-2537-u--world arg-0 arg-1 e-2) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-4 (vector-ref eta-2 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (vector 2 (vector 10 e-5))))))) (lambda (eta-2) (let ((act-1 (PreludeC-45IO-prim__getStr eta-2))) (vector 1 act-1))) eta-1)) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))))
(define CompilerC-45InterpreterC-45VMCode-n--11434-2535-u--prim_putChar (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((11) (let ((e-5 (vector-ref e-4 1))) (if (null? e-3) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (if (null? e-9) (lambda (eta-0) (CoreC-45Core-C-42C-62 (CompilerC-45InterpreterC-45VMCode-n--11434-2537-u--world arg-0 arg-1 e-8) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-4714 (let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putChar e-5 world-0))) (vector 1 act-1))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))) eta-1)) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-n--11434-2536-u--prim_putStr (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((10) (let ((e-5 (vector-ref e-4 1))) (if (null? e-3) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (if (null? e-9) (lambda (eta-0) (CoreC-45Core-C-42C-62 (CompilerC-45InterpreterC-45VMCode-n--11434-2537-u--world arg-0 arg-1 e-8) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-4714 (let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr e-5 world-0))) (vector 1 act-1))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))) eta-1)) eta-0)) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0))))))(else (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-argError arg-0 arg-1 arg-2 eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-knownForeign (LibrariesC-45DataC-45NameMap-fromList (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN CoreC-45NameC-45Namespace-ioNS "prim__putChar") (cons 2 (lambda (conArg-2870) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--11434-2535-u--prim_putChar conArg-2870 eta-0 eta-1)))))) (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN CoreC-45NameC-45Namespace-ioNS "prim__getChar") (cons 1 (lambda (conArg-2852) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--11434-2533-u--prim_getChar conArg-2852 eta-0 eta-1)))))) (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN CoreC-45NameC-45Namespace-ioNS "prim__getStr") (cons 1 (lambda (conArg-2834) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--11434-2534-u--prim_getStr conArg-2834 eta-0 eta-1)))))) (cons (cons (CompilerC-45InterpreterC-45VMCode-NS_UN CoreC-45NameC-45Namespace-ioNS "prim__putStr") (cons 2 (lambda (conArg-2816) (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-n--11434-2536-u--prim_putStr conArg-2816 eta-0 eta-1)))))) '()))))))
(define CompilerC-45InterpreterC-45VMCode-n--11172-2314-u--getConst (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (vector 1 e-0)))(else (vector 0 arg-5)))))
(define CompilerC-45InterpreterC-45VMCode-case--callPrim-2343 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-2 (vector-ref arg-5 1))) (let ((sc1 ((CoreC-45Primitives-getOp arg-3 '()) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (vector 8 (vector 2 ) eta-0)) e-2)))) (if (null? sc1) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "OP: Error calling " (string-append (CoreC-45Name-u--show_Show_Name (CoreC-45Primitives-opName arg-3)) (string-append " with operands: " (DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 csegen-1860 e-2)))) eta-0)) (let ((e-1 (unbox sc1))) (lambda (clam-0) (case (vector-ref e-1 0) ((8) (let ((e-4 (vector-ref e-1 2))) (vector 1 (vector 2 e-4))))(else (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "OP: Error calling " (string-append (CoreC-45Name-u--show_Show_Name (CoreC-45Primitives-opName arg-3)) (string-append " with operands: " (DataC-45Vect-u--show_Show_C-40C-40VectC-32C-36lenC-41C-32C-36elemC-41 csegen-1860 e-2)))) clam-0))))))))) (else (let ((e-5 (vector-ref arg-5 1))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "OP: Expected Constant, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-0)))))))
(define CompilerC-45InterpreterC-45VMCode-callPrim (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((37) (if (null? arg-4) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2343 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-2 (vector-ref arg-9937 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--11172-2314-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)) (let ((e-3 (cdr arg-4))) (if (null? e-3) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2343 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-4 (vector-ref arg-8885 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-4 (vector-ref arg-9937 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--11172-2314-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)) (let ((e-7 (cdr e-3))) (if (null? e-7) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2343 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-4 (vector-ref arg-8885 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-4 (vector-ref arg-9937 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--11172-2314-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (lambda (eta-0) (vector 1 e-10)) (CompilerC-45InterpreterC-45VMCode-case--callPrim-2343 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-4 (vector-ref arg-8885 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-4 (vector-ref arg-9937 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-12 (vector-ref arg-9944 1))) (vector 0 e-12)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--11172-2314-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4)))))))))))(else (CompilerC-45InterpreterC-45VMCode-case--callPrim-2343 arg-1 arg-4 arg-3 arg-2 (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-2 (vector-ref arg-9937 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-n--11172-2314-u--getConst arg-1 arg-4 arg-3 arg-2 eta-0)) arg-4))))))
(define CompilerC-45InterpreterC-45VMCode-indexMaybe (lambda (arg-1 arg-2) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-2 0))) (cond ((equal? sc1 1) (box e-2)) (else (CompilerC-45InterpreterC-45VMCode-indexMaybe e-3 (bs- arg-2 1 63))))))))))
(define CompilerC-45InterpreterC-45VMCode-knownExtern LibrariesC-45DataC-45NameMap-empty)
(define CompilerC-45InterpreterC-45VMCode-setReg (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (vector e-0 e-1 (box arg-3))))))) (vector 1 act-2))))) eff-1) world-0)))))))) ((1) (let ((e-0 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-4722 (lambda (eta-1) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-0 (LibrariesC-45DataC-45IOArray-max e-5)))) (cond ((equal? sc2 1) (CompilerC-45InterpreterC-45VMCode-interpError arg-0 arg-1 (string-append "Attempt to set register: " (string-append (PreludeC-45Show-u--show_Show_Int e-0) (string-append ", size of locals: " (PreludeC-45Show-u--show_Show_Int (LibrariesC-45DataC-45IOArray-max e-5))))) eta-1)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((LibrariesC-45DataC-45IOArray-writeArray csegen-82 e-5 e-0 arg-3) eta-1))) (vector 1 act-3)))))))) eff-0) eta-0)))))))) (else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define PreludeC-45Types-u--C-61C-61_Eq_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((0) (let ((e-8 (vector-ref arg-4 1))) (let ((sc2 (Builtin-fst arg-2))) (let ((e-1 (car sc2))) ((e-1 e-2) e-8)))))(else 0)))) ((1) (let ((e-5 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((1) (let ((e-11 (vector-ref arg-4 1))) (let ((sc2 (Builtin-snd arg-2))) (let ((e-1 (car sc2))) ((e-1 e-5) e-11)))))(else 0))))(else 0))))
(define CompilerC-45InterpreterC-45VMCode-n--11948-3411-u--matchCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (if (null? arg-9) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-6 "CASE: Missing matching alternative or default" eta-0)) (let ((e-6 (unbox arg-9))) (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-0)) e-6))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-9 (car e-2))) (let ((e-10 (cdr e-2))) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_C-40C-40EitherC-32C-36aC-41C-32C-36bC-41 (cons csegen-223 csegen-832) arg-7 e-9))) (cond ((equal? sc2 1) (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-0)) e-10)) (else (CompilerC-45InterpreterC-45VMCode-n--11948-3411-u--matchCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-9)))))))))))
(define CompilerC-45InterpreterC-45VMCode-n--11948-3574-u--matchConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (if (null? arg-9) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-6 "CONSTCASE: Missing matching alternative or default" eta-0)) (let ((e-6 (unbox arg-9))) (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-0)) e-6))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-9 (car e-2))) (let ((e-10 (cdr e-2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant arg-7 e-9))) (cond ((equal? sc2 1) (CoreC-45Core-traverse_ (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-6 arg-1 eta-0)) e-10)) (else (CompilerC-45InterpreterC-45VMCode-n--11948-3574-u--matchConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 arg-9)))))))))))
(define CompilerC-45InterpreterC-45VMCode-case--step-3285 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-5 (string-append "EXTPRIM: Unkown foreign function: " (CoreC-45Name-u--show_Show_Name arg-3)) eta-0)) (let ((e-2 (unbox arg-6))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (lambda (clam-0) (let ((sc2 (DataC-45Vect-toVect e-5 arg-2))) (if (null? sc2) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-5 (string-append "EXTPRIM: Wrong number of arguments, found: " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-2)) (string-append ", expected: " (PreludeC-45Show-u--show_Show_Nat e-5)))) clam-0) (let ((e-3 (unbox sc2))) (let ((act-1 ((CoreC-45Core-traverseVect (lambda (eta-0) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-getReg arg-1 arg-5 eta-0 eta-1))) e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((((e-6 arg-1) arg-5) e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-1 arg-5 arg-4 e-8))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))
(define CompilerC-45InterpreterC-45VMCode-step (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (lambda (eta-0) (vector 1 (vector 0 )))) ((1) (lambda (eta-0) (vector 1 (vector 0 )))) ((2) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (lambda (eta-0) (let ((act-1 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-1 e-5))) eff-0) eta-0))))))))) ((3) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-3 (vector 1 e-4 e-6)))) eff-0) eta-0)))))))))) ((4) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-9 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-6 (vector 0 (DataC-45Nat-pred e-8) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() e-5) e-7)))) eff-0) eta-0))))))))))) ((5) (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-10 (vector 2 e-11))))) ((6) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-13 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-14 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((e-1 (vector-ref e-5 2))) (let ((e-2 (vector-ref e-5 3))) (cond ((equal? e-0 0) (lambda (eta-2) (let ((act-3 (CompilerC-45InterpreterC-45VMCode-callFunc arg-0 arg-2 arg-1 e-2 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-1 (cons e-6 '())) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-12 e-7))) eff-0) eta-2)))))))(else (let ((e-3 (- e-0 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-12 (vector 0 e-3 (cons e-1 e-6) e-2)))))))))(else (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (string-append "APPLY: While applying " (string-append (CompilerC-45VMCode-u--show_Show_Reg e-13) (string-append ", expected closure, found: " (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object e-5)))) eta-2)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((7) (let ((e-15 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-18 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CompilerC-45InterpreterC-45VMCode-callFunc arg-0 arg-2 arg-1 e-17 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-15 e-6))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((8) (let ((e-20 (vector-ref arg-3 1))) (let ((e-21 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseVect (lambda (eta-1) (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 eta-1 eta-2))) e-22) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45InterpreterC-45VMCode-callPrim arg-2 arg-1 e-21 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-20 e-6))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (CompilerC-45InterpreterC-45VMCode-case--step-3285 arg-0 arg-2 e-25 e-24 e-23 arg-1 (LibrariesC-45DataC-45NameMap-lookup e-24 CompilerC-45InterpreterC-45VMCode-knownExtern)))))) ((10) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-26 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-0 (vector-ref e-5 1))) (CompilerC-45InterpreterC-45VMCode-n--11948-3411-u--matchCon arg-0 arg-2 e-28 e-27 e-26 arg-1 arg-1 e-0 e-27 e-28)))(else (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (string-append "CASE: Expected Constructor, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-1)))))) eff-0) eta-0)))))))))) ((11) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-29 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((2) (let ((e-0 (vector-ref e-5 1))) (CompilerC-45InterpreterC-45VMCode-n--11948-3574-u--matchConst arg-0 arg-2 e-31 e-30 e-29 arg-1 arg-1 e-0 e-30 e-31)))(else (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (string-append "CONSTCASE: Expected Constant, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-1)))))) eff-0) eta-0)))))))))) ((12) (let ((e-32 (vector-ref arg-3 1))) (let ((e-33 (vector-ref arg-3 2))) (let ((e-34 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45InterpreterC-45VMCode-getReg arg-2 arg-1 e-33 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-0 (vector-ref e-5 1))) (let ((e-1 (vector-ref e-5 2))) (let ((u--valObj (vector 1 e-0 e-1))) (let ((sc3 (CompilerC-45InterpreterC-45VMCode-indexMaybe e-1 e-34))) (if (null? sc3) (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (string-append "PROJECT: Unable to project index " (string-append (PreludeC-45Show-u--show_Show_Int e-34) (string-append ", missing arguments for constructor:\xa;" (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object u--valObj)))) eta-1)) (let ((e-2 (unbox sc3))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-32 e-2))))))))(else (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (string-append "PROJECT: Expected Constructor, found " (CompilerC-45InterpreterC-45VMCode-showType e-5)) eta-1)))))) eff-0) eta-0)))))))))) ((13) (let ((e-35 (vector-ref arg-3 1))) (CompilerC-45InterpreterC-45VMCode-setReg arg-2 arg-1 e-35 (vector 3 )))) (else (let ((e-36 (vector-ref arg-3 1))) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-2 arg-1 (string-append "ERROR: " e-36) eta-0)))))))
(define CompilerC-45InterpreterC-45VMCode-case--caseC-32blockC-32inC-32callFunc-4113 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "Unkown foreign function: " (CoreC-45Name-u--show_Show_Name arg-3)) eta-0)) (let ((e-2 (unbox arg-12))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (DataC-45Vect-toVect e-5 arg-2))) (if (null? sc2) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "Wrong number of arguments, found: " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-2)) (string-append ", expected: " (PreludeC-45Show-u--show_Show_Nat e-5)))) eta-0)) (let ((e-3 (unbox sc2))) (((e-6 arg-1) arg-4) e-3))))))))))
(define CompilerC-45InterpreterC-45VMCode-case--callFunc-3973 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "Undefined function: " (CoreC-45Name-u--show_Show_Name arg-3)) eta-0)) (let ((e-2 (unbox arg-9))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (let ((e-4 (vector-ref e-2 2))) (lambda (eta-0) (let ((act-1 (let ((sc2 (PreludeC-45Types-u--C-47C-61_Eq_Nat (PreludeC-45TypesC-45List-lengthTR e-3) (PreludeC-45TypesC-45List-lengthTR arg-2)))) (cond ((equal? sc2 1) (CompilerC-45InterpreterC-45VMCode-interpError arg-1 arg-4 (string-append "Unexpected argument count during function call, expected: " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-3)) (string-append ", found: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-2))))) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CompilerC-45InterpreterC-45VMCode-beginFunction arg-1 (DataC-45List-u--zip_Zippable_List e-3 arg-2) e-4 (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-1) (lambda (eta-2) (PreludeC-45EqOrd-u--max_Ord_Int eta-1 eta-2))) -1 e-3)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-7 arg-1 eta-2)) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (CompilerC-45InterpreterC-45VMCode-getReg arg-1 arg-7 (vector 0 ) eta-1))))))) eff-0) eta-0)))))))))))) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (CompilerC-45InterpreterC-45VMCode-case--caseC-32blockC-32inC-32callFunc-4113 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-5 e-6 e-7 (LibrariesC-45DataC-45NameMap-lookup arg-3 CompilerC-45InterpreterC-45VMCode-knownForeign)))))) (else (let ((e-8 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (eta-1) (CompilerC-45InterpreterC-45VMCode-step arg-0 arg-7 arg-1 eta-1)) e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (CompilerC-45InterpreterC-45VMCode-getReg arg-1 arg-7 (vector 0 ) eta-0))))))))))))
(define CompilerC-45InterpreterC-45VMCode-callFunc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (CompilerC-45InterpreterC-45VMCode-saveLocals arg-1 (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 "compiler.interpreter" 25 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ind (cond ((equal? e-5 1) (PreludeC-45Types-pack (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) #\|) arg-2))) (else "")))) (lambda (eta-1) (let ((act-2 (cond ((equal? e-5 1) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append u--ind (string-append "Calling " (string-append (CoreC-45Name-u--show_Show_Name arg-3) (string-append " with args: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4745 arg-4))))) "\xa;") eta-1))) (vector 1 act-2))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--stkC-39 (cons arg-3 arg-2))) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (let ((e-0 (vector-ref e-7 0))) e-0)))))) (lambda (eta-2) (let ((act-3 (unbox arg-1))) (vector 1 act-3))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CompilerC-45InterpreterC-45VMCode-case--callFunc-3973 arg-0 arg-1 arg-4 arg-3 arg-2 e-5 u--ind u--stkC-39 e-7 (LibrariesC-45DataC-45NameMap-lookup arg-3 e-7)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (cond ((equal? e-5 1) (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append u--ind (string-append "Result: " (CompilerC-45InterpreterC-45VMCode-u--show_Show_Object e-8))) "\xa;") eta-3))) (vector 1 act-5))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-8))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))))) eff-0) eta-0)))))) ext-0)))
(define CompilerC-45InterpreterC-45VMCode-initInterpState (lambda (arg-0) (let ((u--defs (LibrariesC-45DataC-45NameMap-fromList arg-0))) (lambda (eta-0) (let ((act-1 (let ((act-1 ((LibrariesC-45DataC-45IOArray-newArray csegen-82 0) eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--returnObj (lambda (eta-1) '()))) (lambda (eta-1) (vector 1 (vector u--defs e-5 (u--returnObj 'erased))))))) eff-0) eta-0)))))))))
(define CompilerC-45InterpreterC-45VMCode-executeExpr (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CompilerC-45Common-getCompileData arg-0 0 3 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CompilerC-45InterpreterC-45VMCode-initInterpState (let ((e-6 (vector-ref e-5 5))) e-6)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-newRef (vector "Compiler.Interpreter.VMCode.State" ) e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CompilerC-45InterpreterC-45VMCode-callFunc arg-0 e-6 '() (vector 2 "__mainExpression" 0) '() eta-2)) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45InterpreterC-45VMCode-codegenVMCodeInterp (lambda () (vector (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CompilerC-45InterpreterC-45VMCode-compileExpr eta-0 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6)))))))) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (CompilerC-45InterpreterC-45VMCode-executeExpr eta-0 eta-1 eta-2 eta-3 eta-4)))))) '() '())))
(define IdrisC-45REPLC-45Opts-getCodegen (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45List-lookup csegen-22 arg-1 (let ((e-13 (vector-ref e-5 13))) e-13))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define IdrisC-45ProcessIdr-getCG (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 (box (CompilerC-45SchemeC-45Chez-codegenChez)))) ((1) (vector 1 (box (CompilerC-45SchemeC-45ChezSep-codegenChezSep)))) ((2) (vector 1 (box (CompilerC-45SchemeC-45Racket-codegenRacket)))) ((3) (vector 1 (box (CompilerC-45SchemeC-45Gambit-codegenGambit)))) ((4) (vector 1 (box (CompilerC-45ESC-45Node-codegenNode)))) ((5) (vector 1 (box (CompilerC-45ESC-45Javascript-codegenJavascript)))) ((6) (vector 1 (box (CompilerC-45RefCC-45RefC-codegenRefC)))) ((7) (vector 1 (box (CompilerC-45InterpreterC-45VMCode-codegenVMCodeInterp)))) (else (let ((e-0 (vector-ref arg-2 1))) (IdrisC-45REPLC-45Opts-getCodegen arg-0 e-0 ext-0))))))
(define CoreC-45Context-setSession (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 arg-1 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45SetOptions-case--setIncrementalCG-6828 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (cond ((equal? arg-1 1) (let ((act-1 (let ((act-1 (PreludeC-45IO-prim__putStr "No such code generator\xa;" clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "Code generators available: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref arg-4 4))) e-4))))) "\xa;") clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (csegen-1969 clam-0))) (vector 1 act-3))))))))) (else (vector 1 (vector 0 )))) (let ((e-1 (unbox arg-5))) (let ((act-1 (IdrisC-45ProcessIdr-getCG arg-2 arg-3 e-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (unbox e-5))) (let ((e-4 (vector-ref e-2 2))) (lambda (clam-1) (if (null? e-4) (cond ((equal? arg-1 1) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append arg-0 " does not support incremental builds") "\xa;") clam-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 (csegen-1969 clam-1))) (vector 1 act-3)))))) (else (vector 1 (vector 0 )))) (let ((act-2 (CoreC-45Context-getSession arg-3 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-3 (let ((e-33 (vector-ref e-8 0))) (let ((e-32 (vector-ref e-8 1))) (let ((e-31 (vector-ref e-8 2))) (let ((e-30 (vector-ref e-8 3))) (let ((e-29 (vector-ref e-8 4))) (let ((e-28 (vector-ref e-8 5))) (let ((e-27 (vector-ref e-8 6))) (let ((e-26 (vector-ref e-8 7))) (let ((e-25 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (vector e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (cons e-1 e-22) e-23 e-24))))))))))))))))))))))))))))) eff-0) clam-1)))))))))))) eff-0) clam-0))))))))))
(define IdrisC-45SetOptions-setIncrementalCG (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45SetOptions-case--setIncrementalCG-6828 arg-3 arg-2 arg-1 arg-0 e-5 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) arg-3)))) eff-0) ext-0)))))))
(define CoreC-45Context-setLogTimings (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-35 0))) (let ((e-44 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-47 (vector-ref e-35 4))) (let ((e-48 (vector-ref e-35 5))) (let ((e-49 (vector-ref e-35 6))) (let ((e-50 (vector-ref e-35 7))) (let ((e-51 (vector-ref e-35 8))) (let ((e-52 (vector-ref e-35 9))) (let ((e-54 (vector-ref e-35 11))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 (vector e-68 e-44 e-45 e-46 e-47 e-48 e-49 e-50 e-51 e-52 (box arg-1) e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45REPLC-45Opts-setOutput (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 arg-1 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setOutputDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 e-45 e-46 arg-1 e-48 e-49 e-50 e-51 e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45SetOptions-preOptions (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((13) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 1 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((1) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 3))) (let ((e-26 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 1 e-27 e-26 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((2) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-27 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-26 (vector-ref e-6 5))) (let ((e-25 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (vector e-0 e-1 1 e-27 e-4 e-26 e-25 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((26) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 1 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((27) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-25 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 1 e-27 e-4 e-26 e-25 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((0) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 1 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((9) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 1 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((14) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setOutput arg-1 (vector 1 1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((5) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector 1 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((3) (let ((e-7 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) e-7))) (if (null? sc3) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr "No such code generator\xa;" clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "Code generators available: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) (CoreC-45Options-availableCGs (let ((e-4 (vector-ref e-5 4))) e-4))))) "\xa;") clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (csegen-1969 clam-0))) (vector 1 act-4)))))))) (let ((e-1 (unbox sc3))) (let ((act-2 ((CoreC-45Context-setCG arg-0 e-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) clam-0)))))))))) eff-0) eta-0)))))))) ((4) (let ((e-8 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-25 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 (cons e-8 e-26) e-6 e-7 e-25 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24))))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((21) (let ((e-9 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45SetOptions-addPkgDir arg-0 e-9 IdrisC-45PackageC-45Types-anyBounds eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((6) (let ((e-10 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-setSourceDir arg-0 (box e-10)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((7) (let ((e-11 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-setBuildDir arg-0 e-11) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((8) (let ((e-12 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-setOutputDir arg-0 (box e-12)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((24) (let ((e-13 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45SetOptions-dirOption arg-0 arg-1 (let ((e-4 (vector-ref e-5 4))) (let ((e-46 (vector-ref e-4 0))) e-46)) e-13 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 0))))))) eff-0) eta-0)))))))) ((22) (lambda (eta-0) (let ((act-1 (IdrisC-45SetOptions-listPackages arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 0)))))) ((37) (let ((e-14 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-setLogTimings arg-0 (DataC-45Maybe-fromMaybe (lambda () 10) e-14)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((38) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-setDebugElabCheck arg-0 1) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((39) (let ((e-15 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-25 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-25 e-16 e-15 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((34) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setOutput arg-1 (vector 1 1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (let ((act-2 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-28 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-27 (vector-ref e-6 5))) (let ((e-26 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-25 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (vector e-0 e-1 1 e-28 e-4 e-27 e-26 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-25 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))))) ((36) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 1 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((35) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 1 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((30) (let ((e-17 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-25 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-6 e-7 e-8 e-9 e-10 e-11 (box e-17) e-13 e-14 e-15 e-16 e-25 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((31) (let ((e-18 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-25 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (box e-18) e-14 e-15 e-16 e-17 e-25 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((32) (let ((e-19 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-25 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (box e-19) e-15 e-16 e-17 e-18 e-25 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((33) (let ((e-20 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-25 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (box e-20) e-16 e-17 e-18 e-19 e-25 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((20) (let ((e-21 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-28 (vector-ref e-5 2))) (let ((e-27 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-25 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-6 e-7 1 (CoreC-45OptionsC-45Log-insertLogLevel e-21 e-9) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-25 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((18) (let ((e-22 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setConsoleWidth arg-1 e-22) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((15) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-6 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (vector e-0 1 e-6 e-4))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-1))))))) eff-0) eta-0))))))) ((16) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-6 (vector-ref e-5 2))) (vector e-0 e-1 e-6 1))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-1))))))) eff-0) eta-0))))))) ((19) (let ((e-23 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setColor arg-1 e-23) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))) ((40) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 1 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((41) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 0 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((42) (lambda (eta-0) (let ((act-1 (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "-Xcheck-hashes disabled (see issue #1935)") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (let ((act-2 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-28 (vector-ref e-6 2))) (let ((e-27 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-26 (vector-ref e-6 5))) (let ((e-25 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (vector e-0 e-1 e-28 e-27 e-4 e-26 e-25 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 1 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))))) ((43) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 1)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((44) (let ((e-24 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45SetOptions-setIncrementalCG arg-0 arg-1 1 e-24 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-1))))))) eff-0) eta-0))))))) ((45) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 1 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((46) (let ((e-25 (vector-ref e-2 1))) (let ((e-26 (vector-ref e-2 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45SetOptions-opts arg-0 e-25 e-26) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (DataC-45String-fastUnlines e-5) eta-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 0))))))) eff-0) eta-0))))))))) ((47) (let ((e-27 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (IdrisC-45SetOptions-completionScript e-27) "\xa;") eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 0))))))) ((48) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 0 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0)))))) ((49) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-27 (vector-ref e-5 2))) (let ((e-26 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-25 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 1 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) eta-0))))))(else (IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3))))))))
(define IdrisC-45Package-processOptions (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (unbox arg-2))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (IdrisC-45CommandLine-getOpts (DataC-45String-words e-6)))) (case (vector-ref sc2 0) ((1) (let ((e-3 (vector-ref sc2 1))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-preOptions arg-0 arg-1 e-3) clam-0))) (else (let ((e-7 (vector-ref sc2 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-5 e-7) clam-0))))))))))))
(define IdrisC-45REPLC-45Opts-setSource (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 arg-1 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setWorkingDir (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Directory-changeDir csegen-82 arg-1) world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (csegen-1310 ext-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) csegen-1311 (let ((e-1 (unbox e-6))) (let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-0))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-7 0))) (let ((e-36 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-35 (vector-ref e-7 5))) (let ((e-34 (vector-ref e-7 6))) (let ((e-33 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (let ((e-12 (vector-ref e-7 12))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (let ((e-25 (vector-ref e-7 25))) (let ((e-26 (vector-ref e-7 26))) (let ((e-27 (vector-ref e-7 27))) (let ((e-28 (vector-ref e-7 28))) (let ((e-29 (vector-ref e-7 29))) (let ((e-30 (vector-ref e-7 30))) (let ((e-31 (vector-ref e-7 31))) (let ((e-32 (vector-ref e-7 32))) (let ((e-46 (vector-ref e-4 0))) (let ((e-45 (vector-ref e-4 1))) (let ((e-44 (vector-ref e-4 2))) (let ((e-43 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-55 (vector-ref e-46 1))) (let ((e-54 (vector-ref e-46 2))) (let ((e-53 (vector-ref e-46 3))) (let ((e-47 (vector-ref e-46 4))) (let ((e-48 (vector-ref e-46 5))) (let ((e-49 (vector-ref e-46 6))) (let ((e-50 (vector-ref e-46 7))) (let ((e-51 (vector-ref e-46 8))) (let ((e-52 (vector-ref e-46 9))) (vector e-0 e-36 e-2 e-3 (vector (vector e-1 e-55 e-54 e-53 e-47 e-48 e-49 e-50 e-51 e-52) e-45 e-44 e-43 e-37 e-38 e-39 e-40 e-41 e-42) e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-4))))) eff-1) world-0))))))))))) eff-0) ext-0))))))))))
(define IdrisC-45Package-findIpkg (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Directory-findIpkgFile ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 arg-3)) (let ((e-1 (unbox e-5))) (lambda (clam-0) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45Directory-changeDir csegen-82 e-7) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-setWorkingDir arg-0 e-7 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (IdrisC-45Package-parsePkgFile arg-0 arg-2 arg-1 1 e-9 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-5 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 (vector 0 )))) (lambda () (lambda (eta-1) (CoreC-45Context-setBuildDir arg-0 eta-1))) (let ((e-17 (vector-ref e-12 17))) e-17)) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45Context-setOutputDir arg-0 (let ((e-18 (vector-ref e-12 18))) e-18)) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((IdrisC-45Package-processOptions arg-0 arg-1 (let ((e-15 (vector-ref e-12 15))) e-15)) eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (IdrisC-45Package-addDeps arg-0 arg-2 arg-1 e-12 eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((u--srcC-39 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-10 e-2))) (let ((act-9 ((IdrisC-45REPLC-45Opts-setSource arg-1 u--srcC-39) eta-0))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((act-10 ((let ((eff-0 (lambda (world-0) (let ((act-10 (unbox arg-1))) (vector 1 act-10))))) (lambda (world-0) (let ((act-10 (eff-0 world-0))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((e-18 (vector-ref act-10 1))) ((let ((eff-1 (lambda (world-1) (let ((act-11 (set-box! arg-1 (let ((e-0 (vector-ref e-18 0))) (let ((e-32 (vector-ref e-18 1))) (let ((e-31 (vector-ref e-18 2))) (let ((e-4 (vector-ref e-18 4))) (let ((e-30 (vector-ref e-18 5))) (let ((e-29 (vector-ref e-18 6))) (let ((e-28 (vector-ref e-18 7))) (let ((e-27 (vector-ref e-18 8))) (let ((e-26 (vector-ref e-18 9))) (let ((e-25 (vector-ref e-18 10))) (let ((e-24 (vector-ref e-18 11))) (let ((e-23 (vector-ref e-18 12))) (let ((e-22 (vector-ref e-18 13))) (let ((e-21 (vector-ref e-18 14))) (let ((e-20 (vector-ref e-18 15))) (let ((e-19 (vector-ref e-18 16))) (vector e-0 e-32 e-31 (box u--srcC-39) e-4 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22 e-21 e-20 e-19)))))))))))))))))))) (vector 1 act-11))))) eff-1) world-0))))))) eta-0))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (vector 1 (box u--srcC-39)))))))))))))))))))))))))) eff-0) clam-0)))))))))))))))))))) eff-0) ext-0)))))))
(define IdrisC-45SetOptions-ideMode (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((26) 1)(else (IdrisC-45SetOptions-ideMode e-3))))))))
(define IdrisC-45SetOptions-ideModeSocket (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((27) 1)(else (IdrisC-45SetOptions-ideModeSocket e-3))))))))
(define IdrisC-45Driver-ignoreMissingIpkg (lambda (arg-0) (if (null? arg-0) 0 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((35) 1)(else (IdrisC-45Driver-ignoreMissingIpkg e-3))))))))
(define CoreC-45Options-defaultDirs (vector "." '() "build" "depends" '() "/usr/local" (cons "." '()) '() '() '()))
(define CoreC-45Options-defaultElab (vector 1 1 1 3 50 25 1))
(define CoreC-45Options-defaultPPrint (vector 0 0 1 0))
(define CoreC-45Options-defaults (lambda (ext-0) (vector 1 (vector CoreC-45Options-defaultDirs CoreC-45Options-defaultPPrint CoreC-45Options-defaultSession CoreC-45Options-defaultElab '() '() csegen-1338 '() '() '()))))
(define CoreC-45NameC-45Namespace-partialEvalNS (CoreC-45NameC-45Namespace-mkNamespace "_PE"))
(define CoreC-45Context-initCtxtS (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 ((LibrariesC-45DataC-45IOArray-newArray csegen-82 arg-0) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Context.Context.Arr" ) e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 0 LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45UserNameMap-empty e-6 0 LibrariesC-45DataC-45IntMap-empty (cons CoreC-45NameC-45Namespace-partialEvalNS '()) 0 0 LibrariesC-45DataC-45NameMap-empty '()))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-initCtxt (lambda (ext-0) (CoreC-45Context-initCtxtS CoreC-45Context-initSize ext-0)))
(define CoreC-45NameC-45Namespace-mainNS (CoreC-45NameC-45Namespace-mkNamespace "Main"))
(define CoreC-45Context-initDefs (lambda (ext-0) (let ((act-1 (CoreC-45Context-initCtxt ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Options-defaults eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector e-5 '() CoreC-45NameC-45Namespace-mainNS '() e-6 LibrariesC-45DataC-45NameMap-empty (blodwen-toSignedInt 100 63) LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45NameMap-empty '() '() LibrariesC-45DataC-45NameMap-empty '() LibrariesC-45DataC-45NameMap-empty (blodwen-toSignedInt 5381 63) '() '() '() '() '() '() '() LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45StringMap-empty '() '() 0 LibrariesC-45DataC-45NameMap-empty '()))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45PosMap-empty (vector 0 ))
(define CoreC-45Metadata-initMetadata (lambda (arg-0) (vector '() '() '() '() '() LibrariesC-45DataC-45PosMap-empty arg-0 LibrariesC-45DataC-45PosMap-empty LibrariesC-45DataC-45PosMap-empty LibrariesC-45DataC-45PosMap-empty)))
(define CoreC-45Context-n--20928-16677-u--resetElab (lambda (arg-0 arg-1) (let ((u--tot (let ((e-2 (vector-ref arg-1 2))) (let ((e-33 (vector-ref e-2 1))) e-33)))) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (vector e-0 e-1 e-2 (let ((sc0 CoreC-45Options-defaultElab)) (let ((e-16 (vector-ref sc0 0))) (let ((e-15 (vector-ref sc0 1))) (let ((e-13 (vector-ref sc0 3))) (let ((e-12 (vector-ref sc0 4))) (let ((e-11 (vector-ref sc0 5))) (let ((e-10 (vector-ref sc0 6))) (vector e-16 e-15 u--tot e-13 e-12 e-11 e-10)))))))) e-4 e-5 e-6 e-7 e-8 e-9)))))))))))))
(define CoreC-45Context-clearCtxt (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-initDefs eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Context-n--20928-16677-u--resetElab arg-0 (let ((e-63 (vector-ref e-5 4))) e-63)) e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 (let ((e-40 (vector-ref e-5 27))) e-40) e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-lazyActive (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-44 (vector-ref e-36 1))) (let ((e-45 (vector-ref e-36 2))) (let ((e-46 (vector-ref e-36 3))) (let ((e-47 (vector-ref e-36 4))) (let ((e-48 (vector-ref e-36 5))) (let ((e-49 (vector-ref e-36 6))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector arg-1 e-44 e-45 e-46 e-47 e-48 e-49) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Directory-nsToPath (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Directory-ttcBuildDirectory arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Directory-extraSearchDirectories arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--fnameBase (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-2))) (let ((u--fs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--p) (CoreC-45Directory-cleanPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--p (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--fnameBase "ttc")))) (cons e-5 e-6)))) (lambda (eta-1) (let ((act-3 (CoreC-45Directory-firstAvailable arg-0 u--fs eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (vector 1 (vector 0 (vector 58 arg-1 arg-2))) (let ((e-1 (unbox e-7))) (vector 1 (vector 1 e-1))))))) eff-0) eta-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setUnboundImplicits (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-50 (vector-ref e-36 0))) (let ((e-45 (vector-ref e-36 2))) (let ((e-46 (vector-ref e-36 3))) (let ((e-47 (vector-ref e-36 4))) (let ((e-48 (vector-ref e-36 5))) (let ((e-49 (vector-ref e-36 6))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector e-50 arg-1 e-45 e-46 e-47 e-48 e-49) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45REPLC-45Common-emitWarnings (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ws (PreludeC-45TypesC-45List-reverse (let ((e-29 (vector-ref e-5 29))) e-29)))) (lambda (eta-0) (let ((act-2 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc2 (let ((e-19 (vector-ref e-6 19))) e-19))) (cond ((equal? sc2 1) (let ((u--errs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 73 eta-1)) u--ws))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (vector 1 u--errs)))) (CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPLC-45Common-emitError arg-0 arg-1 arg-2 eta-2 eta-3))) u--errs) eta-1)))) (else (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPLC-45Common-emitWarning arg-0 arg-1 arg-2 eta-2 eta-3))) u--ws) eta-1))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Common-emitWarningsAndErrors (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (IdrisC-45REPLC-45Common-emitWarnings arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45Common-emitError arg-0 arg-1 arg-2 eta-1 eta-2))) arg-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-checkTTCVersion (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int arg-1 arg-2))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 0 arg-0 arg-1 arg-2)) ext-0)) (else (vector 1 (vector 0 )))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-toRead e-5) 8))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (DataC-45Buffer-prim__getInt (let ((e-0 (vector-ref e-5 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-5 1))) e-1) 63) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-incLoc 8 e-5)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) clam-0)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 50 (vector 1 (string-append "Int " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1608 (cons (let ((e-1 (vector-ref e-5 1))) e-1) (let ((e-2 (vector-ref e-5 2))) e-2)))))) clam-0))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-getTotalReq (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TT2"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt (string-append "TTC header in " (string-append arg-0 (string-append " " (PreludeC-45Show-u--show_Show_String e-5)))) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Binary-checkTTCVersion arg-0 e-7 CoreC-45Binary-ttcVersion eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-1 eta-1))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-readTotalReq (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (lambda (eta-2) (CoreC-45Binary-getTotalReq arg-0 e-6 eta-2)) eta-1)) (lambda (u--err) (lambda (eta-1) (vector 1 '()))) eta-0)))) eff-0) clam-0))))))) (else (vector 1 '())))))) eff-0) ext-0)))))))
(define CoreC-45TT-u--C-47C-61_Eq_TotalReq (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-61C-61_Eq_TotalReq arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TT-u--C-60C-61_Ord_TotalReq (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) 1)(else (cond ((equal? arg-1 0) 1)(else (CoreC-45TT-u--C-61C-61_Eq_TotalReq arg-0 arg-1)))))))
(define CoreC-45TT-u--C-60_Ord_TotalReq (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-60C-61_Ord_TotalReq arg-0 arg-1))) (cond ((equal? sc0 1) (CoreC-45TT-u--C-47C-61_Eq_TotalReq arg-0 arg-1)) (else 0)))))
(define IdrisC-45ModTree-checkTotalReq (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "totality.requirement" 20 (lambda () (string-append "Reading totalReq from " arg-2)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Binary-readTotalReq arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "totality.requirement" 20 (lambda () (DataC-45String-unwords (cons "Got" (cons (CoreC-45TT-u--show_Show_TotalReq e-1) (cons "and expected" (cons (string-append (CoreC-45TT-u--show_Show_TotalReq arg-3) ":") (cons "we" (cons (let ((sc3 (CoreC-45TT-u--C-60_Ord_TotalReq e-1 arg-3))) (cond ((equal? sc3 1) "should") (else "shouldn't"))) (cons "rebuild" '()))))))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45TT-u--C-60_Ord_TotalReq e-1 arg-3)))))))))) eff-0) eta-0))))))))) (lambda (u--error) (lambda (eta-0) (vector 1 0))) ext-0)))
(define CoreC-45Binary-getHashes (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45Binary-getTotalReq arg-0 arg-1 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1559 arg-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-6 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Binary-getImportHashes (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45Binary-getHashes arg-0 arg-1 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1738 arg-1 ext-0))))))
(define CoreC-45Binary-getIncData (lambda (arg-0 arg-1 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45Binary-getImportHashes arg-0 arg-1 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1752 arg-1 ext-0))))))
(define CoreC-45Binary-readIncData (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-3 (CoreC-45Binary-getIncData arg-0 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 e-7)))) eff-0) eta-1)))))) (lambda (u--err) (lambda (eta-1) (vector 1 '()))) eta-0)))) eff-0) clam-0))))))) (else (vector 1 '())))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-missingIncremental (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1331 (let ((e-4 (vector-ref e-5 4))) e-4) (let ((e-22 (vector-ref e-5 22))) e-22)))) (cond ((equal? sc1 1) (let ((act-2 (CoreC-45Binary-readIncData arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (DataC-45Maybe-isNothing (DataC-45List-lookup csegen-1331 (let ((e-4 (vector-ref e-5 4))) e-4) e-6)))))) eff-0) clam-0)))))) (else (vector 1 0))))))) eff-0) eta-0)))))) (lambda (u--error) (lambda (eta-0) (vector 1 0))) ext-0)))
(define CoreC-45BinaryC-45Prims-n--12115-9228-u--err (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-coreFail (vector 61 (string-append "Can't get " (string-append arg-0 (string-append " of " arg-1)))) ext-0)))
(define LibrariesC-45UtilsC-45String-escapeStringUnix (lambda (ext-0) (LibrariesC-45UtilsC-45String-escapeGeneric #\\ (cons #\" (cons #\\ '())) ext-0)))
(define CoreC-45BinaryC-45Prims-n--12115-9229-u--osEscape (lambda (arg-0 arg-1 ext-0) (let ((sc0 SystemC-45Info-isWindows)) (cond ((equal? sc0 1) ext-0) (else (LibrariesC-45UtilsC-45String-escapeStringUnix ext-0))))))
(define CoreC-45BinaryC-45Prims-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32hashFileWith-9340 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (CoreC-45BinaryC-45Prims-n--12115-9228-u--err arg-0 arg-1 clam-0) (vector 1 (box (DataC-45List-last arg-6)))))))
(define CoreC-45BinaryC-45Prims-hashFileWith (lambda (arg-0 arg-1 ext-0) (if (null? arg-0) (vector 1 '()) (let ((e-2 (unbox arg-0))) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45Process-popen csegen-82 (string-append e-2 (string-append " \"" (string-append (CoreC-45BinaryC-45Prims-n--12115-9229-u--osEscape e-2 arg-1 arg-1) "\""))) 0) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-3 (vector-ref e-5 1))) (let ((act-2 (let ((act-2 ((SystemC-45FileC-45ReadWrite-fGetLine csegen-82 e-3) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 (vector 1 e-3))) (lambda (clam-1) (case (vector-ref e-6 0) ((1) (let ((e-4 (vector-ref e-6 1))) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (let ((act-3 ((SystemC-45FileC-45Process-pclose csegen-82 e-3) eta-0))) (vector 1 act-3))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((_-1 (vector 1 e-4))) ((CoreC-45BinaryC-45Prims-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32hashFileWith-9340 e-2 arg-1 e-3 _-0 e-4 _-1 (DataC-45String-words e-4)) clam-1))))))) (else (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (let ((act-3 ((SystemC-45FileC-45Process-pclose csegen-82 e-3) eta-0))) (vector 1 act-3))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45BinaryC-45Prims-n--12115-9228-u--err e-2 arg-1 clam-1)))))))))) eff-0) clam-0))))))) (else (CoreC-45BinaryC-45Prims-n--12115-9228-u--err e-2 arg-1 clam-0)))))) eff-0) ext-0)))))))))
(define CoreC-45Binary-readHashes (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (CoreC-45Binary-getHashes arg-0 e-6 eta-1)) (lambda (u--err) (lambda (eta-1) (vector 1 (cons '() 0)))) eta-0)))) eff-0) clam-0))))))) (else (vector 1 (cons '() 0))))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-unchangedHash (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-hashFileWith arg-0 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (let ((act-2 (CoreC-45Binary-readHashes arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 0) (let ((e-2 (car e-6))) (if (null? e-2) (vector 1 0) (let ((e-7 (unbox e-2))) (vector 1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-1 e-7))))))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45ModTree-needsBuildingDepHash (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Directory-getTTCFileName arg-0 arg-1 "ttc" eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1604 (lambda (eta-3) (IdrisC-45ProcessIdr-unchangedHash (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-4 9))) e-35)) e-6 arg-1 eta-3)) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (u--error) (lambda (eta-0) (vector 1 0))) ext-0)))
(define IdrisC-45ModTree-needsBuildingHash (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45ProcessIdr-unchangedHash (let ((e-4 (vector-ref e-5 4))) (let ((e-34 (vector-ref e-4 9))) e-34)) arg-2 arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-3) eta-3) e-7)))))) (CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45ModTree-needsBuildingDepHash arg-0 eta-2 eta-3))) arg-3 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cond ((equal? e-6 1) e-7) (else 1)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45SystemC-45FileC-45Meta-n--4271-1366-u--parseFileTime (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeAccessTimeSec arg-3 eta-0))))) (lambda (bind-0) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (let ((e-11 (cdr arg-1))) ((e-11 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeAccessTimeNsec arg-3 eta-0))))) (lambda (bind-1) (let ((e-12 (car arg-1))) (let ((e-14 (vector-ref e-12 1))) ((((e-14 'erased) 'erased) (let ((e-16 (cdr arg-1))) ((e-16 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeModifiedTimeSec arg-3 eta-0))))) (lambda (bind-2) (let ((e-17 (car arg-1))) (let ((e-19 (vector-ref e-17 1))) ((((e-19 'erased) 'erased) (let ((e-21 (cdr arg-1))) ((e-21 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeModifiedTimeNsec arg-3 eta-0))))) (lambda (bind-3) (let ((e-22 (car arg-1))) (let ((e-24 (vector-ref e-22 1))) ((((e-24 'erased) 'erased) (let ((e-26 (cdr arg-1))) ((e-26 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeStatusTimeSec arg-3 eta-0))))) (lambda (bind-4) (let ((e-27 (car arg-1))) (let ((e-29 (vector-ref e-27 1))) ((((e-29 'erased) 'erased) (let ((e-31 (cdr arg-1))) ((e-31 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__filetimeStatusTimeNsec arg-3 eta-0))))) (lambda (bind-5) (let ((e-32 (car arg-1))) (let ((e-35 (vector-ref e-32 0))) (let ((e-37 (vector-ref e-35 1))) ((e-37 'erased) (vector (cons bind-0 bind-1) (cons bind-2 bind-3) (cons bind-4 bind-5))))))))))))))))))))))))))))))))
(define LibrariesC-45SystemC-45FileC-45Meta-fileTime (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (LibrariesC-45SystemC-45FileC-45Meta-prim__fileTime arg-2 eta-0))))) (lambda (u--res) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (LibrariesC-45SystemC-45FileC-45Meta-n--4271-1366-u--parseFileTime arg-1 arg-2 u--res)) (lambda (u--ft) (let ((e-12 (car arg-1))) (let ((e-14 (vector-ref e-12 1))) ((((e-14 'erased) 'erased) (SystemC-45FFI-free arg-1 u--res)) (lambda (_-10649) ((let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Int (let ((e-0 (vector-ref u--ft 0))) (let ((e-19 (car e-0))) e-19)) (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) (lambda () (SystemC-45FileC-45Support-ok arg-1 u--ft))) (else (lambda () (SystemC-45FileC-45Error-returnError arg-1))))))))))))))))))))
(define CoreC-45BinaryC-45Prims-modTime (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45Handle-openFile csegen-82 arg-0 0) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 (let ((act-2 ((LibrariesC-45SystemC-45FileC-45Meta-fileTime csegen-82 e-2) clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((1) (let ((e-3 (vector-ref e-6 1))) (let ((act-3 (let ((act-3 ((SystemC-45FileC-45Handle-closeFile csegen-82 e-2) clam-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (let ((e-1 (vector-ref e-3 1))) e-1))))))) (else (let ((act-3 (let ((act-3 ((SystemC-45FileC-45Handle-closeFile csegen-82 e-2) clam-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 (cons 0 0)))))))))) eff-0) clam-0))))))) (else (vector 1 (cons 0 0))))))) eff-0) ext-0)))))))
(define LibrariesC-45SystemC-45FileC-45Meta-u--C-60_Ord_Timestamp (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Int (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0)))) (cond ((equal? sc0 1) 1) (else (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0)))) (cond ((equal? sc1 1) (PreludeC-45EqOrd-u--C-60_Ord_Int (let ((e-1 (cdr arg-0))) e-1) (let ((e-1 (cdr arg-1))) e-1))) (else 0))))))))
(define LibrariesC-45SystemC-45FileC-45Meta-u--C-61C-61_Eq_Timestamp (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0)))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (let ((e-1 (cdr arg-0))) e-1) (let ((e-1 (cdr arg-1))) e-1))) (else 0)))))
(define LibrariesC-45SystemC-45FileC-45Meta-u--compare_Ord_Timestamp (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45SystemC-45FileC-45Meta-u--C-60_Ord_Timestamp arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else (let ((sc1 (LibrariesC-45SystemC-45FileC-45Meta-u--C-61C-61_Eq_Timestamp arg-0 arg-1))) (cond ((equal? sc1 1) 1) (else 2))))))))
(define LibrariesC-45SystemC-45FileC-45Meta-u--C-62C-61_Ord_Timestamp (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Ordering (LibrariesC-45SystemC-45FileC-45Meta-u--compare_Ord_Timestamp arg-0 arg-1) 0)))
(define DataC-45String-padLeft (lambda (arg-0 arg-1 arg-2) (string-append (DataC-45String-replicate (PreludeC-45Types-prim__integerToNat (- arg-0 (PreludeC-45TypesC-45String-length arg-2))) arg-1) arg-2)))
(define LibrariesC-45SystemC-45FileC-45Meta-u--show_Show_Timestamp (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (PreludeC-45Show-u--show_Show_Int (let ((e-0 (car arg-0))) e-0)) (cons "." (cons (DataC-45String-padLeft 9 #\0 (PreludeC-45Show-u--show_Show_Int (let ((e-1 (cdr arg-0))) e-1))) '()))))))
(define IdrisC-45ProcessIdr-isTTCOutdated (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-modTime arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45BinaryC-45Prims-modTime eta-1 eta-2))) arg-2 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "module.hash" 20 (lambda () (DataC-45String-fastUnlines (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Checking whether source code mod times are newer than " (cons (LibrariesC-45SystemC-45FileC-45Meta-u--show_Show_Timestamp e-5) (cons "; src times:" '())))) (DataC-45List-u--zipWith_Zippable_List (lambda (u--src) (lambda (u--tm) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons u--src (cons " : " (cons (LibrariesC-45SystemC-45FileC-45Meta-u--show_Show_Timestamp u--tm) '())))))) arg-2 e-6)))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (arg-3) (LibrariesC-45SystemC-45FileC-45Meta-u--C-62C-61_Ord_Timestamp arg-3 e-5)) e-6)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45ModTree-needsBuildingTime (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (IdrisC-45ProcessIdr-isTTCOutdated arg-0 arg-2 (cons arg-1 arg-3) ext-0)))
(define SystemC-45FileC-45ReadWrite-removeFile (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__removeFile arg-2 eta-0))))) (lambda (u--res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--res (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (SystemC-45FileC-45Support-ok arg-1 (vector 0 ))) (else (SystemC-45FileC-45Error-returnError arg-1))))))))))
(define IdrisC-45ModTree-needsBuilding (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45Meta-exists csegen-82 arg-3) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (let ((e-21 (vector-ref e-6 21))) e-21)))))) (lambda (eta-0) (CoreC-45Context-getSession arg-0 eta-0)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (cond ((equal? e-6 1) (IdrisC-45ModTree-needsBuildingHash arg-0 arg-2 arg-3 arg-4 eta-0)) (else (IdrisC-45ModTree-needsBuildingTime arg-0 arg-2 arg-3 arg-4 eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-7 0) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "import" 20 (lambda () (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons (cond ((equal? e-6 1) "Hashes") (else "Mod Times")) (cons " still valid for " '()))) arg-2)) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (IdrisC-45ProcessIdr-missingIncremental arg-0 arg-3 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-9 0) (let ((act-6 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref eta-1 1))) (vector 1 (let ((e-3 (vector-ref e-10 3))) e-3)))))) (lambda (eta-1) (let ((act-6 (unbox arg-1))) (vector 1 act-6))) clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-10) (vector 1 0) (let ((e-1 (unbox e-10))) (let ((act-7 (CoreC-45ContextC-45Log-log arg-0 "totality.requirement" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Checking totality requirement of " (cons arg-2 (cons " (main file is " (cons e-1 (cons ")" '()))))))) clam-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((sc11 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-2 e-1))) (cond ((equal? sc11 1) (let ((act-8 (let ((act-8 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref eta-1 1))) (vector 1 (let ((e-33 (vector-ref e-12 1))) e-33)))))) (lambda (eta-1) (CoreC-45Context-getSession arg-0 eta-1)) clam-3))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45ModTree-checkTotalReq arg-0 arg-2 arg-3 e-12 eta-1)))) eff-0) clam-3))))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-4) (cond ((equal? e-12 1) (let ((act-9 (let ((act-9 ((SystemC-45FileC-45ReadWrite-removeFile csegen-82 arg-3) clam-4))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-5) (case (vector-ref e-13 0) ((1) (vector 1 1)) (else (let ((e-14 (vector-ref e-13 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-3 e-14) clam-5))))))) eff-0) clam-4)))))) (else (vector 1 0)))))) eff-0) clam-3)))))) (else (vector 1 0)))))))))))) eff-0) clam-2)))))) (else (vector 1 1)))))) eff-0) clam-1))))))))) (else (vector 1 1)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (vector 1 1)))))) eff-0) ext-0)))))))
(define CompilerC-45Common-incCompile (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (vector-ref arg-2 2))) (if (null? e-2) (lambda (eta-0) (vector 1 '())) (let ((e-4 (unbox e-2))) (((e-4 arg-0) arg-1) arg-3))))))
(define CoreC-45Directory-makeBuildDirectory (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Directory-ttcBuildDirectory arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ns (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 arg-1))))) (let ((u--ndir (LibrariesC-45UtilsC-45Path-joinPath u--ns))) (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Directory-mkdirAll (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-5 u--ndir) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-6 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-5 u--ndir) e-7) clam-0))))))) eff-0) eta-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45Syntax-addModDocInfo (lambda (arg-0 arg-1 arg-2 arg-3) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 (cons arg-1 e-1) (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-2 e-2) (LibrariesC-45DataC-45SortedMap-insert arg-1 arg-3 e-3) e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45ProcessIdr-prelude (vector (vector 0 (vector 2 (vector 0 )) (cons 0 0) (cons 0 0)) 0 CoreC-45NameC-45Namespace-preludeNS CoreC-45NameC-45Namespace-preludeNS))
(define IdrisC-45ProcessIdr-addPrelude (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-276 CoreC-45NameC-45Namespace-preludeNS (PreludeC-45TypesC-45List-mapAppend '() csegen-4143 arg-0)))) (cond ((equal? sc0 1) arg-0) (else (cons IdrisC-45ProcessIdr-prelude arg-0))))))
(define CoreC-45Context-addHash (lambda (arg-1 arg-2 arg-3) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (let ((e-34 (cdr arg-2))) ((e-34 eta-0) eta-1)))) arg-3 e-16) e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Hash-u--hash_Hashable_Namespace (lambda (ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_Namespace (blodwen-toSignedInt 5381 63) ext-0)))
(define IdrisC-45ProcessIdr-addPublicHash (lambda (arg-0 arg-1) (if (null? arg-1) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (lambda (clam-0) (cond ((equal? e-2 1) (if (null? e-3) (vector 1 (vector 0 )) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 ((CoreC-45Context-addHash arg-0 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_Namespace arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_Namespace arg-4541 arg-4544)))) e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((CoreC-45Context-addHash arg-0 csegen-1361 e-7) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (CoreC-45ContextC-45Log-log arg-0 "module.hash" 15 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Adding hash for a public import of " (cons (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-6) '())))) clam-0)))))))))))(else (vector 1 (vector 0 ))))))))))
(define LibrariesC-45DataC-45PosMap-node2 (lambda (arg-1 arg-2 arg-3) (vector 0 (LibrariesC-45DataC-45PosMap-u--C-60C-43C-62_Semigroup_RMFileRange (arg-1 arg-2) (arg-1 arg-3)) arg-2 arg-3)))
(define LibrariesC-45DataC-45PosMap-addDigits4 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-8 0) ((0) (let ((e-15 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-15) arg-9))) ((1) (let ((e-17 (vector-ref arg-8 1))) (let ((e-18 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-17 e-18) arg-9)))) ((2) (let ((e-20 (vector-ref arg-8 1))) (let ((e-21 (vector-ref arg-8 2))) (let ((e-22 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-9))))) (else (let ((e-24 (vector-ref arg-8 1))) (let ((e-25 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 3))) (let ((e-27 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-24) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-25 e-26 e-27) arg-9))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-8 0) ((0) (let ((e-29 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-7 e-29) arg-9))) ((1) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-9)))) ((2) (let ((e-34 (vector-ref arg-8 1))) (let ((e-35 (vector-ref arg-8 2))) (let ((e-36 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-34 e-35 e-36) arg-9))))) (else (let ((e-38 (vector-ref arg-8 1))) (let ((e-39 (vector-ref arg-8 2))) (let ((e-40 (vector-ref arg-8 3))) (let ((e-41 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-38 e-39) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-40 e-41) arg-9)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-8 0) ((0) (let ((e-43 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-7 e-43) arg-9))) ((1) (let ((e-45 (vector-ref arg-8 1))) (let ((e-46 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-7 e-45 e-46) arg-9)))) ((2) (let ((e-48 (vector-ref arg-8 1))) (let ((e-49 (vector-ref arg-8 2))) (let ((e-50 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-7 e-48) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-49 e-50) arg-9))))) (else (let ((e-52 (vector-ref arg-8 1))) (let ((e-53 (vector-ref arg-8 2))) (let ((e-54 (vector-ref arg-8 3))) (let ((e-55 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-7 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-9))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-8 0) ((0) (let ((e-57 (vector-ref arg-8 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-57) arg-9))) ((1) (let ((e-59 (vector-ref arg-8 1))) (let ((e-60 (vector-ref arg-8 2))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 arg-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-59 e-60) arg-9)))) ((2) (let ((e-62 (vector-ref arg-8 1))) (let ((e-63 (vector-ref arg-8 2))) (let ((e-64 (vector-ref arg-8 3))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-9))))) (else (let ((e-66 (vector-ref arg-8 1))) (let ((e-67 (vector-ref arg-8 2))) (let ((e-68 (vector-ref arg-8 3))) (let ((e-69 (vector-ref arg-8 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 arg-7 e-66) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-67 e-68 e-69) arg-9)))))))))))))))
(define LibrariesC-45DataC-45PosMap-C-124C-62 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (vector 1 arg-3)) ((1) (let ((e-2 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 (vector 0 e-2) (vector 0 ) (vector 0 arg-3)))) (else (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (case (vector-ref e-7 0) ((0) (let ((e-9 (vector-ref e-7 1))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 1 e-9 arg-3)))) ((1) (let ((e-11 (vector-ref e-7 1))) (let ((e-12 (vector-ref e-7 2))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 2 e-11 e-12 arg-3))))) ((2) (let ((e-14 (vector-ref e-7 1))) (let ((e-15 (vector-ref e-7 2))) (let ((e-16 (vector-ref e-7 3))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 e-6 (vector 3 e-14 e-15 e-16 arg-3)))))) (else (let ((e-18 (vector-ref e-7 1))) (let ((e-19 (vector-ref e-7 2))) (let ((e-20 (vector-ref e-7 3))) (let ((e-21 (vector-ref e-7 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-5 (LibrariesC-45DataC-45PosMap-C-124C-62 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) e-6 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-18 e-19 e-20)) (vector 1 e-21 arg-3)))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-6 arg-7)))))(else (case (vector-ref arg-7 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5) arg-6))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-6 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 arg-7)))))))(else (case (vector-ref arg-7 0) ((1) (let ((e-11 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5) arg-6) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits4 arg-1 e-3 e-4 arg-3 arg-4 arg-5 arg-6 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits3 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-7 0) ((0) (let ((e-15 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-15) arg-8))) ((1) (let ((e-17 (vector-ref arg-7 1))) (let ((e-18 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-17 e-18) arg-8)))) ((2) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (let ((e-22 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-8))))) (else (let ((e-24 (vector-ref arg-7 1))) (let ((e-25 (vector-ref arg-7 2))) (let ((e-26 (vector-ref arg-7 3))) (let ((e-27 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-24 e-25) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-26 e-27) arg-8))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-7 0) ((0) (let ((e-29 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 e-29) arg-8))) ((1) (let ((e-31 (vector-ref arg-7 1))) (let ((e-32 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-8)))) ((2) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 e-34) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-35 e-36) arg-8))))) (else (let ((e-38 (vector-ref arg-7 1))) (let ((e-39 (vector-ref arg-7 2))) (let ((e-40 (vector-ref arg-7 3))) (let ((e-41 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 arg-6 e-38) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-39 e-40 e-41) arg-8)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-7 0) ((0) (let ((e-43 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-43) arg-8))) ((1) (let ((e-45 (vector-ref arg-7 1))) (let ((e-46 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-45 e-46) arg-8)))) ((2) (let ((e-48 (vector-ref arg-7 1))) (let ((e-49 (vector-ref arg-7 2))) (let ((e-50 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-48 e-49 e-50) arg-8))))) (else (let ((e-52 (vector-ref arg-7 1))) (let ((e-53 (vector-ref arg-7 2))) (let ((e-54 (vector-ref arg-7 3))) (let ((e-55 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-8))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-7 0) ((0) (let ((e-57 (vector-ref arg-7 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-57) arg-8))) ((1) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-59 e-60) arg-8)))) ((2) (let ((e-62 (vector-ref arg-7 1))) (let ((e-63 (vector-ref arg-7 2))) (let ((e-64 (vector-ref arg-7 3))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-6 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-8))))) (else (let ((e-66 (vector-ref arg-7 1))) (let ((e-67 (vector-ref arg-7 2))) (let ((e-68 (vector-ref arg-7 3))) (let ((e-69 (vector-ref arg-7 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-6 e-66 e-67) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-68 e-69) arg-8)))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 arg-6))))(else (case (vector-ref arg-6 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-5 arg-6))))))(else (case (vector-ref arg-6 0) ((1) (let ((e-11 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) arg-5) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits3 arg-1 e-3 e-4 arg-3 arg-4 arg-5 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits2 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-6 0) ((0) (let ((e-15 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-15) arg-7))) ((1) (let ((e-17 (vector-ref arg-6 1))) (let ((e-18 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-17 e-18) arg-7)))) ((2) (let ((e-20 (vector-ref arg-6 1))) (let ((e-21 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-20 e-21 e-22) arg-7))))) (else (let ((e-24 (vector-ref arg-6 1))) (let ((e-25 (vector-ref arg-6 2))) (let ((e-26 (vector-ref arg-6 3))) (let ((e-27 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-24 e-25) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-26 e-27) arg-7))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-6 0) ((0) (let ((e-29 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-29) arg-7))) ((1) (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 e-31 e-32) arg-7)))) ((2) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-34) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-35 e-36) arg-7))))) (else (let ((e-38 (vector-ref arg-6 1))) (let ((e-39 (vector-ref arg-6 2))) (let ((e-40 (vector-ref arg-6 3))) (let ((e-41 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-5 e-38 e-39) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-40 e-41) arg-7)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-6 0) ((0) (let ((e-43 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 e-43) arg-7))) ((1) (let ((e-45 (vector-ref arg-6 1))) (let ((e-46 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-45 e-46) arg-7)))) ((2) (let ((e-48 (vector-ref arg-6 1))) (let ((e-49 (vector-ref arg-6 2))) (let ((e-50 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 e-48) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-49 e-50) arg-7))))) (else (let ((e-52 (vector-ref arg-6 1))) (let ((e-53 (vector-ref arg-6 2))) (let ((e-54 (vector-ref arg-6 3))) (let ((e-55 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 arg-5 e-52) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-53 e-54 e-55) arg-7))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-6 0) ((0) (let ((e-57 (vector-ref arg-6 1))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-5 e-57) arg-7))) ((1) (let ((e-59 (vector-ref arg-6 1))) (let ((e-60 (vector-ref arg-6 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-59 e-60) arg-7)))) ((2) (let ((e-62 (vector-ref arg-6 1))) (let ((e-63 (vector-ref arg-6 2))) (let ((e-64 (vector-ref arg-6 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-62 e-63 e-64) arg-7))))) (else (let ((e-66 (vector-ref arg-6 1))) (let ((e-67 (vector-ref arg-6 2))) (let ((e-68 (vector-ref arg-6 3))) (let ((e-69 (vector-ref arg-6 4))) (LibrariesC-45DataC-45PosMap-appendTree4 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 arg-5) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-66 e-67) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-68 e-69) arg-7)))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 arg-5)))(else (case (vector-ref arg-5 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-4 arg-5)))))(else (case (vector-ref arg-5 0) ((1) (let ((e-11 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) arg-4) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((e-9 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits2 arg-1 e-3 e-4 arg-3 arg-4 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits1 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-5 0) ((0) (let ((e-15 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 e-15) arg-6))) ((1) (let ((e-17 (vector-ref arg-5 1))) (let ((e-18 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-17 e-18) arg-6)))) ((2) (let ((e-20 (vector-ref arg-5 1))) (let ((e-21 (vector-ref arg-5 2))) (let ((e-22 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-6))))) (else (let ((e-24 (vector-ref arg-5 1))) (let ((e-25 (vector-ref arg-5 2))) (let ((e-26 (vector-ref arg-5 3))) (let ((e-27 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 arg-4 e-24) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-25 e-26 e-27) arg-6))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-5 0) ((0) (let ((e-29 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-3 e-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 e-29) arg-6))) ((1) (let ((e-31 (vector-ref arg-5 1))) (let ((e-32 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-6)))) ((2) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-34 e-35 e-36) arg-6))))) (else (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (let ((e-41 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-38 e-39) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-40 e-41) arg-6)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-5 0) ((0) (let ((e-43 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 e-43) arg-6))) ((1) (let ((e-45 (vector-ref arg-5 1))) (let ((e-46 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 e-45 e-46) arg-6)))) ((2) (let ((e-48 (vector-ref arg-5 1))) (let ((e-49 (vector-ref arg-5 2))) (let ((e-50 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 arg-4 e-48) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-49 e-50) arg-6))))) (else (let ((e-52 (vector-ref arg-5 1))) (let ((e-53 (vector-ref arg-5 2))) (let ((e-54 (vector-ref arg-5 3))) (let ((e-55 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 arg-4 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-6))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-5 0) ((0) (let ((e-57 (vector-ref arg-5 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 e-57) arg-6))) ((1) (let ((e-59 (vector-ref arg-5 1))) (let ((e-60 (vector-ref arg-5 2))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 arg-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-59 e-60) arg-6)))) ((2) (let ((e-62 (vector-ref arg-5 1))) (let ((e-63 (vector-ref arg-5 2))) (let ((e-64 (vector-ref arg-5 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-6))))) (else (let ((e-66 (vector-ref arg-5 1))) (let ((e-67 (vector-ref arg-5 2))) (let ((e-68 (vector-ref arg-5 3))) (let ((e-69 (vector-ref arg-5 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 arg-4 e-66) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-67 e-68 e-69) arg-6)))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 arg-4))(else (case (vector-ref arg-4 0) ((0) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3))(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 arg-3 arg-4))))(else (case (vector-ref arg-4 0) ((1) (let ((e-11 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 arg-3) e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((e-9 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits1 arg-1 e-3 e-4 arg-3 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-addDigits0 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (case (vector-ref arg-4 0) ((0) (let ((e-15 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 e-15) arg-5))) ((1) (let ((e-17 (vector-ref arg-4 1))) (let ((e-18 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 e-17 e-18) arg-5)))) ((2) (let ((e-20 (vector-ref arg-4 1))) (let ((e-21 (vector-ref arg-4 2))) (let ((e-22 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-1 e-20) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-21 e-22) arg-5))))) (else (let ((e-24 (vector-ref arg-4 1))) (let ((e-25 (vector-ref arg-4 2))) (let ((e-26 (vector-ref arg-4 3))) (let ((e-27 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-1 e-24 e-25) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-26 e-27) arg-5))))))))) ((1) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((0) (let ((e-29 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree1 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 e-29) arg-5))) ((1) (let ((e-31 (vector-ref arg-4 1))) (let ((e-32 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-3 e-4) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-31 e-32) arg-5)))) ((2) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 e-34) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-35 e-36) arg-5))))) (else (let ((e-38 (vector-ref arg-4 1))) (let ((e-39 (vector-ref arg-4 2))) (let ((e-40 (vector-ref arg-4 3))) (let ((e-41 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-3 e-4 e-38) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-39 e-40 e-41) arg-5)))))))))) ((2) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((0) (let ((e-43 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node2 arg-1 e-6 e-7) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-8 e-43) arg-5))) ((1) (let ((e-45 (vector-ref arg-4 1))) (let ((e-46 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-45 e-46) arg-5)))) ((2) (let ((e-48 (vector-ref arg-4 1))) (let ((e-49 (vector-ref arg-4 2))) (let ((e-50 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-48 e-49 e-50) arg-5))))) (else (let ((e-52 (vector-ref arg-4 1))) (let ((e-53 (vector-ref arg-4 2))) (let ((e-54 (vector-ref arg-4 3))) (let ((e-55 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-6 e-7 e-8) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-52 e-53) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-54 e-55) arg-5))))))))))) (else (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((0) (let ((e-57 (vector-ref arg-4 1))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 e-57) arg-5))) ((1) (let ((e-59 (vector-ref arg-4 1))) (let ((e-60 (vector-ref arg-4 2))) (LibrariesC-45DataC-45PosMap-appendTree2 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 e-59 e-60) arg-5)))) ((2) (let ((e-62 (vector-ref arg-4 1))) (let ((e-63 (vector-ref arg-4 2))) (let ((e-64 (vector-ref arg-4 3))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-13 e-62) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-63 e-64) arg-5))))) (else (let ((e-66 (vector-ref arg-4 1))) (let ((e-67 (vector-ref arg-4 2))) (let ((e-68 (vector-ref arg-4 3))) (let ((e-69 (vector-ref arg-4 4))) (LibrariesC-45DataC-45PosMap-appendTree3 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-40NodeC-32C-36aC-41 arg-2933)) arg-2 (LibrariesC-45DataC-45PosMap-node3 arg-1 e-10 e-11 e-12) (LibrariesC-45DataC-45PosMap-node3 arg-1 e-13 e-66 e-67) (LibrariesC-45DataC-45PosMap-node2 arg-1 e-68 e-69) arg-5)))))))))))))))
(define LibrariesC-45DataC-45PosMap-appendTree0 (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) arg-3)(else (case (vector-ref arg-3 0) ((0) arg-2)(else (case (vector-ref arg-2 0) ((1) (let ((e-13 (vector-ref arg-2 1))) (LibrariesC-45DataC-45PosMap-C-60C-124 arg-1 e-13 arg-3)))(else (case (vector-ref arg-3 0) ((1) (let ((e-11 (vector-ref arg-3 1))) (LibrariesC-45DataC-45PosMap-C-124C-62 arg-1 arg-2 e-11)))(else (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (LibrariesC-45DataC-45PosMap-deep arg-1 e-2 (LibrariesC-45DataC-45PosMap-addDigits0 arg-1 e-3 e-4 e-7 e-8) e-9)))))))))))))))))
(define LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-appendTree0 arg-1 arg-2 arg-3)))
(define LibrariesC-45DataC-45PosMap-larger (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-1 (car e-0))) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1630 csegen-1630 e-1 arg-0))))))
(define LibrariesC-45DataC-45PosMap-insert (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45PosMap-split (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-larger (arg-1 arg-2) eta-0)) arg-3))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) e-2 (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) arg-2 e-3)))))))
(define LibrariesC-45DataC-45PosMap-fromList (lambda (arg-1 ext-0) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (LibrariesC-45DataC-45PosMap-insert arg-1 eta-0 eta-1))) LibrariesC-45DataC-45PosMap-empty ext-0)))
(define LibrariesC-45DataC-45PosMap-largerC-39 (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-0 (unbox arg-1))) (let ((e-1 (car e-0))) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1630 csegen-1630 e-1 arg-0))))))
(define LibrariesC-45DataC-45PosMap-case--merge2-11528 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45PosMap-split (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-largerC-39 (arg-1 e-2) eta-0)) arg-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) e-5 (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) e-2 (LibrariesC-45DataC-45PosMap-merge1 arg-1 e-4 e-3)))))))))))
(define LibrariesC-45DataC-45PosMap-merge2 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-case--merge2-11528 arg-1 arg-3 arg-2 (LibrariesC-45DataC-45PosMap-viewl (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) arg-3))))
(define LibrariesC-45DataC-45PosMap-case--merge1-11449 (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-2 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45PosMap-split (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) (lambda (eta-0) (LibrariesC-45DataC-45PosMap-larger (arg-1 e-2) eta-0)) arg-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (LibrariesC-45DataC-45PosMap-C-43C-43 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) e-5 (LibrariesC-45DataC-45PosMap-C-60C-124 (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) e-2 (LibrariesC-45DataC-45PosMap-merge2 arg-1 e-3 e-4)))))))))))
(define LibrariesC-45DataC-45PosMap-merge1 (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-case--merge1-11449 arg-1 arg-3 arg-2 (LibrariesC-45DataC-45PosMap-viewl (lambda (arg-2933) (LibrariesC-45DataC-45PosMap-u--measureRM_MeasureRM_C-36a arg-1 arg-2933)) arg-2))))
(define LibrariesC-45DataC-45PosMap-union (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45PosMap-merge1 arg-1 arg-2 arg-3)))
(define CoreC-45Metadata-case--addSemanticDecorations-9547 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (let ((sc1 (DataC-45List-isNil e-3))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-log arg-1 "ide-mode.highlight" 19 (lambda () (string-append "ignored adding decorations to " (string-append (CoreC-45FC-u--show_Show_OriginDesc (let ((e-6 (vector-ref arg-3 6))) e-6)) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2056 e-3))))) ext-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-10 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (vector e-0 e-1 e-12 e-11 e-4 e-10 e-6 (LibrariesC-45DataC-45PosMap-union (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) (LibrariesC-45DataC-45PosMap-fromList (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) e-2) arg-4) e-8 e-9))))))))))))) (vector 1 act-2)))))))))
(define CoreC-45Metadata-addSemanticDecorations (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--posmap (let ((e-7 (vector-ref e-5 7))) e-7))) (lambda (eta-0) (CoreC-45Metadata-case--addSemanticDecorations-9547 arg-2 arg-1 arg-0 e-5 u--posmap (DataC-45List-span (lambda (eta-1) (CoreC-45FC-u--C-61C-61_Eq_OriginDesc (let ((e-6 (vector-ref e-5 6))) e-6) (Builtin-fst (Builtin-fst eta-1)))) arg-2) eta-0))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-addArityHash (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-26 (unbox e-19))) (case (vector-ref e-26 0) ((0) (let ((e-28 (vector-ref e-26 1))) (let ((sc5 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-42 (vector-ref e-1 9))) e-42)))) (cond ((equal? sc5 0) (lambda (eta-1) (vector 1 (vector 0 ))))(else (CoreC-45Context-addHash arg-0 (cons (lambda (arg-4535) (CoreC-45Hash-u--hash_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1357 csegen-1359 arg-4535)) (lambda (arg-4541) (lambda (arg-4544) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1357 csegen-1359 arg-4541 arg-4544)))) (cons arg-1 (PreludeC-45TypesC-45List-lengthTR e-28))))))))(else (lambda (eta-1) (vector 1 (vector 0 )))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45Identity-n--9844-3703-u--isId (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((12) 1)(else 0))))
(define CompilerC-45OptsC-45Identity-getArg (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (cond ((equal? arg-1 0) (box (vector 0 0 arg-0)))(else (let ((e-0 (- arg-1 1))) (let ((e-6 (cdr arg-2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45CompileExpr-u--weaken_Weaken_CExp eta-0)) (CompilerC-45OptsC-45Identity-getArg arg-0 e-0 e-6)))))))))
(define CompilerC-45OptsC-45Identity-idCDef (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 0 e-0 eta-0)) (CompilerC-45OptsC-45Identity-getArg (CoreC-45CompileExpr-getFC e-1) arg-0 e-0)))))(else (box arg-1)))))
(define CoreC-45CompileExpr-u--show_Show_CDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-0) (string-append ": " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 e-0 e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (string-append "Constructor tag " (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-495 e-2) (string-append " arity " (string-append (PreludeC-45Show-u--show_Show_Nat e-3) (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-1240) e-4))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (string-append "Foreign call " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 e-5) (string-append " " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1242) e-6) (string-append " -> " (CoreC-45CompileExpr-u--show_Show_CFType e-7)))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (string-append "Error: " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 '() e-8)))))))
(define CoreC-45CompileExpr-u--showPrec_Show_CDef (lambda (arg-0 arg-1) (CoreC-45CompileExpr-u--show_Show_CDef arg-1)))
(define CoreC-45Context-setFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((u--flagsC-39 (cons arg-3 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-3)) (let ((e-12 (vector-ref e-1 12))) e-12))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 u--flagsC-39 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-2)) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-unsetFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((u--flagsC-39 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-3)) (let ((e-12 (vector-ref e-1 12))) e-12)))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 u--flagsC-39 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-2)) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32rewriteIdentityFlag-3822 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-8) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-8))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compiler.identity" 5 (lambda () (string-append "\x9;new def: " (CoreC-45CompileExpr-u--show_Show_CDef e-1))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Context-unsetFlag arg-0 (vector 2 ) (vector 8 arg-3) arg-7 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-setFlag arg-0 (vector 2 ) (vector 8 arg-3) (vector 0 ) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Context-setCompiled arg-0 (vector 8 arg-3) e-1 ext-0))))))))))))))
(define CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32rewriteIdentityFlag-3753 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-6))) (case (vector-ref e-1 0) ((12) (let ((e-2 (vector-ref e-1 1))) (let ((act-1 (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-log arg-0 "compiler.identity" 5 (lambda () (string-append "found identity flag for: " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ", " (string-append (PreludeC-45Show-u--show_Show_Nat e-2) (string-append "\xa;\x9;old def: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_CDef u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_CDef u--d u--x)))) (let ((e-19 (vector-ref arg-4 19))) e-19)))))))) eta-0)))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((u--flg (vector 12 e-2))) (CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32rewriteIdentityFlag-3822 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 u--flg (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((e-19 (vector-ref arg-4 19))) e-19) (lambda (eta-0) (CompilerC-45OptsC-45Identity-idCDef e-2 eta-0))) clam-0)))))))(else (vector 1 (vector 0 )))))))))
(define CompilerC-45OptsC-45Identity-rewriteIdentityFlag (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((_-0 (box (cons e-8 e-7)))) (CompilerC-45OptsC-45Identity-case--caseC-32blockC-32inC-32rewriteIdentityFlag-3753 arg-0 arg-1 e-5 e-8 e-7 _-0 (DataC-45List-find (lambda (eta-1) (CompilerC-45OptsC-45Identity-n--9844-3703-u--isId arg-0 arg-1 eta-1)) (let ((e-12 (vector-ref e-7 12))) e-12)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-addRefsArgs (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (CompilerC-45Inline-addRefsArgs (CompilerC-45Inline-addRefs arg-1 e-2) e-3))))))
(define CompilerC-45Inline-addRefsConAlts (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-5 (vector-ref e-2 0))) (let ((e-9 (vector-ref e-2 4))) (CompilerC-45Inline-addRefsConAlts (CompilerC-45Inline-addRefs (LibrariesC-45DataC-45NameMap-insert e-5 0 arg-1) e-9) e-3))))))))
(define CompilerC-45Inline-addRefsConstAlts (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (cdr e-2))) (CompilerC-45Inline-addRefsConstAlts (CompilerC-45Inline-addRefs arg-1 e-6) e-3)))))))
(define CompilerC-45Inline-addRefs (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (LibrariesC-45DataC-45NameMap-insert e-2 0 arg-1))) ((2) (let ((e-6 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefs arg-1 e-6))) ((3) (let ((e-11 (vector-ref arg-2 4))) (let ((e-12 (vector-ref arg-2 5))) (CompilerC-45Inline-addRefs (CompilerC-45Inline-addRefs arg-1 e-11) e-12)))) ((4) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefsArgs (CompilerC-45Inline-addRefs arg-1 e-15) e-16)))) ((5) (let ((e-19 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 5))) (CompilerC-45Inline-addRefsArgs (LibrariesC-45DataC-45NameMap-insert e-19 0 arg-1) e-22)))) ((6) (let ((e-27 (vector-ref arg-2 4))) (CompilerC-45Inline-addRefsArgs arg-1 (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 e-27)))) ((7) (let ((e-31 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefsArgs arg-1 e-31))) ((8) (let ((e-35 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefs arg-1 e-35))) ((9) (let ((e-39 (vector-ref arg-2 3))) (CompilerC-45Inline-addRefs arg-1 e-39))) ((10) (let ((e-42 (vector-ref arg-2 2))) (let ((e-43 (vector-ref arg-2 3))) (let ((e-44 (vector-ref arg-2 4))) (let ((u--dsC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (eta-0) (CompilerC-45Inline-addRefs arg-1 eta-0))) e-44))) (CompilerC-45Inline-addRefsConAlts (CompilerC-45Inline-addRefs u--dsC-39 e-42) e-43)))))) ((11) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (let ((e-49 (vector-ref arg-2 4))) (let ((u--dsC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (eta-0) (CompilerC-45Inline-addRefs arg-1 eta-0))) e-49))) (CompilerC-45Inline-addRefsConstAlts (CompilerC-45Inline-addRefs u--dsC-39 e-47) e-48))))))(else arg-1))))
(define CompilerC-45Inline-getRefs (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CompilerC-45Inline-addRefs LibrariesC-45DataC-45NameMap-empty e-1)))(else LibrariesC-45DataC-45NameMap-empty))))
(define CompilerC-45Inline-case--caseC-32blockC-32inC-32updateCallGraph-6596 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox arg-5))) (let ((u--refs (CompilerC-45Inline-getRefs e-1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-1 arg-0 (let ((e-0 (vector-ref arg-3 0))) (let ((e-23 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((e-7 (vector-ref arg-3 7))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-10 (vector-ref arg-3 10))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (let ((e-17 (vector-ref arg-3 17))) (let ((e-18 (vector-ref arg-3 18))) (let ((e-19 (vector-ref arg-3 19))) (let ((e-20 (vector-ref arg-3 20))) (let ((e-21 (vector-ref arg-3 21))) (let ((e-22 (vector-ref arg-3 22))) (vector e-0 e-23 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (box u--refs) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-1)) eta-0)))))))
(define CompilerC-45Inline-updateCallGraph (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CompilerC-45Inline-case--caseC-32blockC-32inC-32updateCallGraph-6596 arg-1 arg-0 e-5 e-1 _-0 (let ((e-19 (vector-ref e-1 19))) e-19))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-n--15529-7165-u--nonErased (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (vector 1 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-7 (vector-ref e-1 7))) e-7) csegen-30))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45CaseOpts-allLams (lambda (arg-1) (if (null? arg-1) 1 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-9 (vector-ref e-2 4))) (case (vector-ref e-9 0) ((2) (CompilerC-45CaseOpts-allLams e-3))(else 0))))))))
(define CompilerC-45CaseOpts-allLamsConst (lambda (arg-1) (if (null? arg-1) 1 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) 0 (let ((e-6 (cdr e-2))) (case (vector-ref e-6 0) ((2) (CompilerC-45CaseOpts-allLamsConst e-3))(else 0)))))))))
(define CompilerC-45CaseOpts-caseLamConAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-6 (vector-ref eta-0 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (vector e-1 e-2 e-3 e-4 e-6)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-5) ext-0))))))))
(define CompilerC-45CaseOpts-caseLamConstAlt (lambda (arg-1 arg-2 ext-0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-2) ext-0)))))
(define CompilerC-45CaseOpts-getName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 "clam" e-5)))))))) eff-0) ext-0)))))))
(define CompilerC-45CaseOpts-shiftBinderConAlt (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-5 0))) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (vector e-1 e-2 e-3 e-4 (CompilerC-45CaseOpts-shiftBinder (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-2) arg-3 arg-4 e-5)))))))))
(define CompilerC-45CaseOpts-shiftBinderConstAlt (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cons e-1 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-2))))))
(define CoreC-45TTC-45Var-u--genWeakenNs_GenWeaken_C-40C-40NVarC-32C-91aC-32C-61C-32NameC-93C-41C-32C-36nmC-41 (lambda (ext-0 ext-1 ext-2) (CoreC-45TTC-45Var-insertNVarNames ext-0 ext-1 ext-2)))
(define CoreC-45TTC-45Var-WeakenNVar (CoreC-45NameC-45Scoped-GenWeakenWeakens (lambda (outer-5053) (lambda (ns-5054) (lambda (local-5055) (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45TTC-45Var-u--genWeakenNs_GenWeaken_C-40C-40NVarC-32C-91aC-32C-61C-32NameC-93C-41C-32C-36nmC-41 eta-0 eta-1 eta-2)))))))))
(define CoreC-45TTC-45VarC-45NVar-later (lambda (arg-4) (+ arg-4 1)))
(define CoreC-45TTC-45Var-insertNVar (lambda (arg-5 arg-6) (let ((sc0 (CoreC-45TTC-45Var-locateNVar arg-5 arg-6))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) e-2)) (else (let ((e-5 (vector-ref sc0 1))) (CoreC-45TTC-45Var-weakenNVar arg-5 (CoreC-45TTC-45VarC-45NVar-later e-5))))))))
(define CompilerC-45CaseOpts-shiftUnder (lambda (arg-4 arg-5) (cond ((equal? arg-5 0) (CoreC-45TTC-45Var-weakenNVar (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-4) 0))(else (let ((e-0 (- arg-5 1))) (CoreC-45TTC-45Var-insertNVar (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-4) e-0))))))
(define CompilerC-45CaseOpts-shiftVar (lambda (arg-3 arg-4 arg-5) (let ((u--out (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-3))) (let ((sc0 (CoreC-45TTC-45Var-locateNVar u--out arg-5))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) e-2)) (else (let ((e-5 (vector-ref sc0 1))) (let ((sc1 CoreC-45TTC-45Var-WeakenNVar)) (let ((e-2 (cdr sc1))) ((((e-2 'erased) 'erased) u--out) (CompilerC-45CaseOpts-shiftUnder arg-4 e-5)))))))))))
(define CompilerC-45CaseOpts-shiftBinder (lambda (arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((eff-0 (CompilerC-45CaseOpts-shiftVar arg-2 arg-3 e-2))) (vector 0 eff-0 e-3))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (vector 2 e-9 e-10 (CompilerC-45CaseOpts-shiftBinder (cons e-10 arg-2) arg-3 arg-4 e-11)))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (let ((e-17 (vector-ref arg-5 5))) (vector 3 e-13 e-14 e-15 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-16) (CompilerC-45CaseOpts-shiftBinder (cons e-14 arg-2) arg-3 arg-4 e-17)))))))) ((4) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (vector 4 e-19 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-21)))))) ((5) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((e-27 (vector-ref arg-5 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (let ((e-31 (vector-ref arg-5 3))) (let ((e-32 (vector-ref arg-5 4))) (vector 6 e-29 e-30 e-31 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-32))))))) ((7) (let ((e-34 (vector-ref arg-5 1))) (let ((e-35 (vector-ref arg-5 2))) (let ((e-36 (vector-ref arg-5 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-5 1))) (let ((e-39 (vector-ref arg-5 2))) (let ((e-40 (vector-ref arg-5 3))) (vector 8 e-38 e-39 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-40)))))) ((9) (let ((e-42 (vector-ref arg-5 1))) (let ((e-43 (vector-ref arg-5 2))) (let ((e-44 (vector-ref arg-5 3))) (vector 9 e-42 e-43 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-44)))))) ((10) (let ((e-46 (vector-ref arg-5 1))) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (vector 10 e-46 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinderConAlt arg-2 arg-3 arg-4 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-5 1))) (let ((e-52 (vector-ref arg-5 2))) (let ((e-53 (vector-ref arg-5 3))) (let ((e-54 (vector-ref arg-5 4))) (vector 11 e-51 (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinderConstAlt arg-2 arg-3 arg-4 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45CaseOpts-shiftBinder arg-2 arg-3 arg-4 eta-0)) e-54))))))) ((12) (let ((e-56 (vector-ref arg-5 1))) (let ((e-57 (vector-ref arg-5 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-5 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-5 1))) (let ((e-62 (vector-ref arg-5 2))) (vector 14 e-61 e-62)))))))
(define CompilerC-45CaseOpts-liftOutLambda (lambda (arg-2 ext-0 ext-1) (CompilerC-45CaseOpts-shiftBinder '() arg-2 ext-0 ext-1)))
(define CompilerC-45CaseOpts-tryLiftDef (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (unbox arg-2))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 3))) (let ((u--scC-39 (CompilerC-45CaseOpts-liftOutLambda '() arg-1 e-6))) (box (box u--scC-39)))))(else '()))))))
(define CompilerC-45CaseOpts-tryLiftOut (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-5 (vector-ref e-2 0))) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (let ((e-9 (vector-ref e-2 4))) (case (vector-ref e-9 0) ((2) (let ((e-13 (vector-ref e-9 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45CaseOpts-tryLiftOut arg-1 e-3) (lambda (u--asC-39) (let ((u--scC-39 (CompilerC-45CaseOpts-liftOutLambda e-8 arg-1 e-13))) (box (cons (vector e-5 e-6 e-7 e-8 u--scC-39) u--asC-39)))))))(else '()))))))))))))
(define CompilerC-45CaseOpts-tryLiftOutConst (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-2) '() (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (case (vector-ref e-6 0) ((2) (let ((e-10 (vector-ref e-6 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45CaseOpts-tryLiftOutConst arg-1 e-3) (lambda (u--asC-39) (let ((u--scC-39 (CompilerC-45CaseOpts-liftOutLambda '() arg-1 e-10))) (box (cons (cons e-5 u--scC-39) u--asC-39)))))))(else '()))))))))))
(define CompilerC-45CaseOpts-n--9629-3561-u--defLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-2 (unbox arg-6))) (case (vector-ref e-2 0) ((2) 1)(else 0))))))
(define CompilerC-45CaseOpts-n--9629-3783-u--defLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-2 (unbox arg-6))) (case (vector-ref e-2 0) ((2) 1)(else 0))))))
(define CompilerC-45CaseOpts-caseLam (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((10) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((sc1 (let ((sc2 (CompilerC-45CaseOpts-allLams e-3))) (cond ((equal? sc2 1) (CompilerC-45CaseOpts-n--9629-3561-u--defLam e-4 e-3 e-2 e-1 arg-1 e-4)) (else 0))))) (cond ((equal? sc1 1) (let ((act-1 (CompilerC-45CaseOpts-getName arg-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (CompilerC-45CaseOpts-tryLiftOut e-5 e-3))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen caseLam 1") clam-1) (let ((e-6 (unbox sc3))) (let ((sc4 (CompilerC-45CaseOpts-tryLiftDef e-5 e-4))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen caseLam 2") clam-1) (let ((e-7 (unbox sc4))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45CaseOpts-caseLamConAlt arg-1 eta-0 eta-1))) e-6 '()) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (if (null? e-7) (vector 1 '()) (let ((e-9 (unbox e-7))) ((let ((eff-0 (CompilerC-45CaseOpts-caseLam arg-1 e-9))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-1 e-5 (vector 10 e-1 (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-2) e-8 e-9)))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))))))) eff-0) clam-0)))))) (else (let ((act-1 ((CompilerC-45CaseOpts-caseLam arg-1 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45CaseOpts-caseLamConAlt arg-1 eta-1 eta-2))) e-3 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (if (null? e-4) (vector 1 '()) (let ((e-7 (unbox e-4))) ((let ((eff-0 (CompilerC-45CaseOpts-caseLam arg-1 e-7))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 10 e-1 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))) ((11) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((sc1 (let ((sc2 (CompilerC-45CaseOpts-allLamsConst e-8))) (cond ((equal? sc2 1) (CompilerC-45CaseOpts-n--9629-3783-u--defLam e-9 e-8 e-7 e-6 arg-1 e-9)) (else 0))))) (cond ((equal? sc1 1) (let ((act-1 (CompilerC-45CaseOpts-getName arg-1 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc3 (CompilerC-45CaseOpts-tryLiftOutConst e-5 e-8))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen caseLam 1") clam-2) (let ((e-1 (unbox sc3))) (let ((sc4 (CompilerC-45CaseOpts-tryLiftDef e-5 e-9))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen caseLam 2") clam-2) (let ((e-2 (unbox sc4))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CompilerC-45CaseOpts-caseLamConstAlt arg-1 eta-0 eta-1))) e-1 '()) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (if (null? e-2) (vector 1 '()) (let ((e-3 (unbox e-2))) ((let ((eff-0 (CompilerC-45CaseOpts-caseLam arg-1 e-3))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-1))) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-6 e-5 (vector 11 e-6 (CoreC-45CompileExpr-u--weaken_Weaken_CExp e-7) e-10 e-11)))))) eff-0) eta-0)))))))) eff-0) clam-2)))))))))))))) eff-0) clam-0)))))) (else (let ((act-1 ((CompilerC-45CaseOpts-caseLam arg-1 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CompilerC-45CaseOpts-caseLamConstAlt arg-1 eta-1 eta-2))) e-8 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (if (null? e-9) (vector 1 '()) (let ((e-2 (unbox e-9))) ((let ((eff-0 (CompilerC-45CaseOpts-caseLam arg-1 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 11 e-6 e-5 e-10 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-11 e-12 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-13) clam-0))))) ((3) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (let ((e-18 (vector-ref arg-2 4))) (let ((e-19 (vector-ref arg-2 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 3 e-15 e-16 e-17 e-5 eta-2))))))) (CompilerC-45CaseOpts-caseLam arg-1 e-18) eta-0)) (CompilerC-45CaseOpts-caseLam arg-1 e-19) clam-0))))))) ((4) (let ((e-21 (vector-ref arg-2 1))) (let ((e-22 (vector-ref arg-2 2))) (let ((e-23 (vector-ref arg-2 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 4 e-21 e-5 eta-2))))))) (CompilerC-45CaseOpts-caseLam arg-1 e-22) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CaseOpts-caseLam arg-1 eta-0)) e-23 '()) clam-0))))) ((5) (let ((e-25 (vector-ref arg-2 1))) (let ((e-26 (vector-ref arg-2 2))) (let ((e-27 (vector-ref arg-2 3))) (let ((e-28 (vector-ref arg-2 4))) (let ((e-29 (vector-ref arg-2 5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 5 e-25 e-26 e-27 e-28 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CaseOpts-caseLam arg-1 eta-0)) e-29 '()) clam-0))))))) ((6) (let ((e-31 (vector-ref arg-2 1))) (let ((e-32 (vector-ref arg-2 2))) (let ((e-33 (vector-ref arg-2 3))) (let ((e-34 (vector-ref arg-2 4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-31 e-32 e-33 e-5)))))) (CoreC-45Core-traverseVect (lambda (eta-0) (CompilerC-45CaseOpts-caseLam arg-1 eta-0)) e-34) clam-0)))))) ((7) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-36 e-37 e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45CaseOpts-caseLam arg-1 eta-0)) e-38 '()) clam-0))))) ((8) (let ((e-40 (vector-ref arg-2 1))) (let ((e-41 (vector-ref arg-2 2))) (let ((e-42 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 8 e-40 e-41 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-42) clam-0))))) ((9) (let ((e-44 (vector-ref arg-2 1))) (let ((e-45 (vector-ref arg-2 2))) (let ((e-46 (vector-ref arg-2 3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 9 e-44 e-45 e-5)))))) (CompilerC-45CaseOpts-caseLam arg-1 e-46) clam-0)))))(else (vector 1 arg-2))))))
(define CompilerC-45CaseOpts-n--10283-4152-u--doCaseLam (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.CaseOpts.NextName" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45CaseOpts-caseLam e-5 e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-0 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))(else (vector 1 arg-2)))))
(define CompilerC-45CaseOpts-caseLamDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) (vector 1 (vector 0 )) (let ((e-26 (unbox e-19))) (let ((act-3 (CompilerC-45CaseOpts-n--10283-4152-u--doCaseLam arg-1 arg-0 e-26 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-27 (vector-ref act-3 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-setCompiled arg-0 arg-1 e-27 eta-1)))) eff-0) clam-0))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45ConstantFold-findConstAlt (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant arg-1 e-5))) (cond ((equal? sc2 1) (box e-6)) (else (CompilerC-45OptsC-45ConstantFold-findConstAlt arg-1 e-3 arg-3)))))))))))
(define CompilerC-45OptsC-45ConstantFold-foldableOp (lambda (arg-1) (case (vector-ref arg-1 0) ((37) 0) ((36) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (cond ((equal? e-0 0) 0)(else (cond ((equal? e-1 0) 0)(else (let ((sc1 (DataC-45Maybe-isJust (CoreC-45TTC-45Primitive-intKind e-0)))) (cond ((equal? sc1 1) (DataC-45Maybe-isJust (CoreC-45TTC-45Primitive-intKind e-1))) (else 0))))))))))(else 1))))
(define LibrariesC-45DataC-45ListC-45SizeOf-sizedView (lambda (arg-2) (cond ((equal? arg-2 0) '())(else (let ((e-4 (- arg-2 1))) (box e-4))))))
(define CompilerC-45OptsC-45ConstantFold-u--weakenNs_Weaken_WkCExp (lambda (arg-2 arg-3) (let ((e-3 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons (LibrariesC-45DataC-45ListC-45SizeOf-C-43 arg-2 e-3) e-5)))))
(define CompilerC-45OptsC-45ConstantFold-u--weaken_Weaken_WkCExp (lambda (ext-0) (CompilerC-45OptsC-45ConstantFold-u--weakenNs_Weaken_WkCExp (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) ext-0)))
(define CompilerC-45OptsC-45ConstantFold-case--lookupC-44go-3042 (lambda (arg-2 arg-5 arg-6 arg-8 arg-12 arg-13 arg-15) (cond ((equal? arg-13 0) (if (null? arg-15) (CompilerC-45OptsC-45ConstantFold-n--9246-2948-u--go arg-2 arg-5 arg-6 arg-8 arg-12) (let ((e-3 (unbox arg-15))) (cond ((equal? arg-8 0) (vector 0 0))(else (let ((e-0 (- arg-8 1))) (let ((sc3 (CompilerC-45OptsC-45ConstantFold-n--9246-2948-u--go arg-2 arg-5 arg-6 e-0 (vector 2 e-3 arg-12)))) (case (vector-ref sc3 0) ((0) (let ((e-2 (vector-ref sc3 1))) (vector 0 (CoreC-45TTC-45VarC-45Var-later e-2)))) (else (let ((e-5 (vector-ref sc3 1))) (vector 1 (CompilerC-45OptsC-45ConstantFold-u--weaken_Weaken_WkCExp e-5))))))))))))(else (let ((e-3 (unbox arg-15))) (cond ((equal? arg-8 0) (vector 0 0))(else (let ((e-0 (- arg-8 1))) (let ((sc1 (CompilerC-45OptsC-45ConstantFold-n--9246-2948-u--go arg-2 arg-5 arg-6 e-0 (vector 2 e-3 arg-12)))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (vector 0 (CoreC-45TTC-45VarC-45Var-later e-2)))) (else (let ((e-5 (vector-ref sc1 1))) (vector 1 (CompilerC-45OptsC-45ConstantFold-u--weaken_Weaken_WkCExp e-5))))))))))))))
(define CompilerC-45OptsC-45ConstantFold-n--9246-2948-u--go (lambda (arg-2 arg-5 arg-6 arg-8 arg-12) (cond ((equal? arg-8 0) (case (vector-ref arg-12 0) ((1) (let ((e-9 (vector-ref arg-12 1))) (vector 1 (cons 0 e-9))))(else (let ((e-3 (vector-ref arg-12 1))) (let ((e-4 (vector-ref arg-12 2))) (CompilerC-45OptsC-45ConstantFold-case--lookupC-44go-3042 arg-2 arg-5 arg-6 arg-8 e-4 e-3 (LibrariesC-45DataC-45ListC-45SizeOf-sizedView e-3)))))))(else (let ((e-5 (- arg-8 1))) (case (vector-ref arg-12 0) ((1) (let ((e-15 (vector-ref arg-12 2))) (CompilerC-45OptsC-45ConstantFold-n--9246-2948-u--go arg-2 arg-5 arg-6 e-5 e-15)))(else (let ((e-3 (vector-ref arg-12 1))) (let ((e-4 (vector-ref arg-12 2))) (CompilerC-45OptsC-45ConstantFold-case--lookupC-44go-3042 arg-2 arg-5 arg-6 arg-8 e-4 e-3 (LibrariesC-45DataC-45ListC-45SizeOf-sizedView e-3)))))))))))
(define CompilerC-45OptsC-45ConstantFold-lookup (lambda (arg-2 arg-3 arg-4) (let ((sc0 (CompilerC-45OptsC-45ConstantFold-n--9246-2948-u--go arg-3 arg-4 arg-2 arg-3 arg-4))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2 arg-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-14 (car e-5))) (let ((e-16 (cdr e-5))) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp e-14 e-16)))))))))
(define CompilerC-45OptsC-45ConstantFold-replace (lambda (arg-1) (case (vector-ref arg-1 0) ((0) 1) ((12) 1)(else 0))))
(define CompilerC-45OptsC-45ConstantFold-wk (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((2) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (vector 2 (LibrariesC-45DataC-45ListC-45SizeOf-C-43 arg-3 e-3) e-4))))(else (vector 2 arg-3 arg-4)))))
(define CompilerC-45OptsC-45ConstantFold-n--9699-3683-u--commutative (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-7 12) 0)(else 1))))
(define CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cond ((equal? arg-7 0) (vector 6 arg-7 arg-8 arg-9 arg-10))(else (let ((e-0 (- arg-7 1))) (cond ((equal? e-0 0) (vector 6 arg-7 arg-8 arg-9 arg-10))(else (let ((e-1 (- e-0 1))) (cond ((equal? e-1 0) (case (vector-ref arg-9 0) ((0) (let ((e-2 (vector-ref arg-9 1))) (if (null? arg-10) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-6 (car arg-10))) (let ((e-7 (cdr arg-10))) (case (vector-ref e-6 0) ((12) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-7) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-13 (car e-7))) (let ((e-14 (cdr e-7))) (if (null? e-14) (let ((u--x (vector 12 e-9 e-10))) (let ((sc6 (CompilerC-45OptsC-45ConstantFold-n--9699-3683-u--commutative arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2))) (cond ((equal? sc6 1) (vector 6 2 arg-8 (vector 0 e-2) (cons e-13 (cons u--x '())))) (else (vector 6 2 arg-8 (vector 0 e-2) (cons u--x (cons e-13 '()))))))) (vector 6 arg-7 arg-8 arg-9 arg-10))))))))(else (vector 6 arg-7 arg-8 arg-9 arg-10)))))))) ((2) (let ((e-3 (vector-ref arg-9 1))) (if (null? arg-10) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-18 (car arg-10))) (let ((e-19 (cdr arg-10))) (case (vector-ref e-18 0) ((12) (let ((e-21 (vector-ref e-18 1))) (let ((e-22 (vector-ref e-18 2))) (if (null? e-19) (vector 6 arg-7 arg-8 arg-9 arg-10) (let ((e-25 (car e-19))) (let ((e-26 (cdr e-19))) (if (null? e-26) (let ((u--x (vector 12 e-21 e-22))) (let ((sc6 (CompilerC-45OptsC-45ConstantFold-n--9699-3683-u--commutative arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))) (cond ((equal? sc6 1) (vector 6 2 arg-8 (vector 2 e-3) (cons e-25 (cons u--x '())))) (else (vector 6 2 arg-8 (vector 2 e-3) (cons u--x (cons e-25 '()))))))) (vector 6 arg-7 arg-8 arg-9 arg-10))))))))(else (vector 6 arg-7 arg-8 arg-9 arg-10))))))))(else (vector 6 arg-7 arg-8 arg-9 arg-10))))(else (vector 6 arg-7 arg-8 arg-9 arg-10)))))))))))
(define CompilerC-45OptsC-45ConstantFold-n--9699-4051-u--foldAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector e-1 e-2 e-3 e-4 (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-1) (CompilerC-45OptsC-45ConstantFold-wk (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4) arg-6) e-5)))))))))
(define CompilerC-45OptsC-45ConstantFold-n--9699-4090-u--foldAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (cons e-1 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-6 e-2))))))
(define CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((8) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (box (vector 12 e-1 e-2)))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((12) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (case (vector-ref e-2 0) ((0) '()) ((12) '())(else (box (vector 8 e-1 e-2)))))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32constFold-3496 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((12) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (case (vector-ref e-2 0) ((5) (let ((e-3 (vector-ref e-2 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer e-3 0))) (cond ((equal? sc2 1) (vector 12 e-1 (vector 5 e-3))) (else (vector 12 e-1 (vector 5 0)))))))(else (vector 4 arg-5 (vector 1 arg-3 arg-2) (cons arg-7 '())))))))(else (vector 4 arg-5 (vector 1 arg-3 arg-2) (cons arg-7 '()))))))
(define CompilerC-45OptsC-45ConstantFold-constFold (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (CompilerC-45OptsC-45ConstantFold-lookup e-3 e-2 arg-2)))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (vector 1 e-6 e-7)))) ((2) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (vector 2 e-9 e-10 (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend (cons e-10 '()) arg-1) (CompilerC-45OptsC-45ConstantFold-wk (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-10 '())) arg-2) e-11)))))) ((3) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((u--val (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-16))) (let ((sc1 (CompilerC-45OptsC-45ConstantFold-replace u--val))) (cond ((equal? sc1 1) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 (vector 1 u--val arg-2) e-17)) (else (vector 3 e-13 e-14 e-15 u--val (CompilerC-45OptsC-45ConstantFold-constFold (PreludeC-45TypesC-45List-tailRecAppend (cons e-14 '()) arg-1) (CompilerC-45OptsC-45ConstantFold-wk (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-14 '())) arg-2) e-17)))))))))))) ((4) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (case (vector-ref e-20 0) ((1) (let ((e-64 (vector-ref e-20 1))) (let ((e-65 (vector-ref e-20 2))) (if (null? e-21) (vector 4 e-19 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-21)) (let ((e-67 (car e-21))) (let ((e-68 (cdr e-21))) (if (null? e-68) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-65 csegen-31))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32constFold-3496 arg-1 e-65 e-64 e-67 e-19 arg-2 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-67))) (else (vector 4 e-19 (vector 1 e-64 e-65) (cons (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-67) '()))))) (vector 4 e-19 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-21)))))))))(else (vector 4 e-19 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-20) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-21)))))))) ((5) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 5 e-23 e-24 e-25 e-26 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-27)))))))) ((6) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((e-32 (vector-ref arg-3 4))) (cond ((equal? e-29 0) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))))(else (let ((e-70 (- e-29 1))) (cond ((equal? e-70 0) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))))(else (let ((e-71 (- e-70 1))) (cond ((equal? e-71 0) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))))(else (let ((e-72 (- e-71 1))) (cond ((equal? e-72 0) (case (vector-ref e-31 0) ((37) (if (null? e-32) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))) (let ((e-75 (car e-32))) (let ((e-76 (cdr e-32))) (case (vector-ref e-75 0) ((13) (if (null? e-76) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))) (let ((e-81 (car e-76))) (let ((e-82 (cdr e-76))) (case (vector-ref e-81 0) ((13) (if (null? e-82) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))) (let ((e-87 (car e-82))) (let ((e-88 (cdr e-82))) (if (null? e-88) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-87) (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))))))))(else (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf))))))))))))))))(else (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf))))))))))))))))(else (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))))))(else (let ((u--xsC-39 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-32))) (let ((u--e (CompilerC-45OptsC-45ConstantFold-n--9699-3684-u--constRight arg-1 e-29 e-32 e-31 e-30 arg-2 e-29 e-30 e-31 u--xsC-39))) (DataC-45Maybe-fromMaybe (lambda () u--e) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CompilerC-45OptsC-45ConstantFold-foldableOp e-31)) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45Vect-u--traverse_Traversable_C-40VectC-32C-36kC-41 csegen-255 (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-3686-u--toNF arg-1 e-29 e-32 e-31 e-30 arg-2 eta-0)) u--xsC-39) (lambda (u--nfs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((CoreC-45Primitives-getOp e-31 arg-1) u--nfs) (lambda (u--nf) (CompilerC-45OptsC-45ConstantFold-n--9699-3685-u--fromNF arg-1 e-29 e-32 e-31 e-30 arg-2 u--nf)))))))))))))))))))))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (vector 7 e-34 e-35 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-36)))))) ((8) (let ((e-38 (vector-ref arg-3 1))) (let ((e-39 (vector-ref arg-3 2))) (let ((e-40 (vector-ref arg-3 3))) (vector 8 e-38 e-39 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-40)))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 e-43 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-44)))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (let ((e-49 (vector-ref arg-3 4))) (vector 10 e-46 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-47) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-4051-u--foldAlt arg-1 e-49 e-48 e-47 e-46 arg-2 eta-0)) e-48) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-49))))))) ((11) (let ((e-51 (vector-ref arg-3 1))) (let ((e-52 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 3))) (let ((e-54 (vector-ref arg-3 4))) (let ((u--scC-39 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-52))) (case (vector-ref u--scC-39 0) ((12) (let ((e-2 (vector-ref u--scC-39 2))) (let ((sc2 (CompilerC-45OptsC-45ConstantFold-findConstAlt e-2 e-53 e-54))) (if (null? sc2) (vector 11 e-51 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-4090-u--foldAlt arg-1 e-54 e-53 e-52 e-51 arg-2 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-54)) (let ((e-3 (unbox sc2))) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-3))))))(else (vector 11 e-51 (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 e-52) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-n--9699-4090-u--foldAlt arg-1 e-54 e-53 e-52 e-51 arg-2 eta-0)) e-53) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-constFold arg-1 arg-2 eta-0)) e-54)))))))))) ((12) (let ((e-56 (vector-ref arg-3 1))) (let ((e-57 (vector-ref arg-3 2))) (vector 12 e-56 e-57)))) ((13) (let ((e-59 (vector-ref arg-3 1))) (vector 13 e-59))) (else (let ((e-61 (vector-ref arg-3 1))) (let ((e-62 (vector-ref arg-3 2))) (vector 14 e-61 e-62)))))))
(define CompilerC-45OptsC-45ConstantFold-initSubst (lambda (arg-0) (vector 2 (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-0) (vector 0 ))))
(define CompilerC-45OptsC-45ConstantFold-constFoldCDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (box (vector 0 e-0 (CompilerC-45OptsC-45ConstantFold-constFold e-0 (CompilerC-45OptsC-45ConstantFold-initSubst e-0) e-1))))))(else '()))))
(define CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32constantFold-4339 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (if (null? arg-7) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-7))) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "compiler.const-fold" 50 (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-0 arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "constant folding " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append "\xa;\x9;old def: " (string-append (CoreC-45CompileExpr-u--show_Show_CDef arg-6) (string-append "\xa;\x9;new def: " (CoreC-45CompileExpr-u--show_Show_CDef e-1)))))))))) eff-0) eta-0)))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Context-setCompiled arg-0 (vector 8 arg-3) e-1 ext-0))))))))
(define CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32constantFold-4318 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox arg-6))) (lambda (eta-0) (CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32constantFold-4339 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1 (CompilerC-45OptsC-45ConstantFold-constFoldCDef e-1) eta-0))))))
(define CompilerC-45OptsC-45ConstantFold-constantFold (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((_-0 (box (cons e-8 e-7)))) (CompilerC-45OptsC-45ConstantFold-case--caseC-32blockC-32inC-32constantFold-4318 arg-0 arg-1 e-5 e-8 e-7 _-0 (let ((e-19 (vector-ref e-7 19))) e-19))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45CaseOpts-n--10415-4282-u--updateAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (vector e-1 e-2 e-3 e-4 (vector 10 arg-6 e-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45CompileExpr-u--weakenNs_Weaken_CConAlt (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4) eta-1)) arg-2) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4) eta-1)) arg-1))))))))))
(define CompilerC-45CaseOpts-n--10415-4283-u--updateDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector 10 arg-6 arg-7 arg-2 arg-1)))
(define CompilerC-45CaseOpts-doCaseOfCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 10 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-n--10415-4282-u--updateAlt arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45CaseOpts-n--10415-4283-u--updateDef arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-4))))
(define CompilerC-45CaseOpts-n--10497-4357-u--updateAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (cons e-1 (vector 11 arg-6 e-2 arg-2 arg-1))))))
(define CompilerC-45CaseOpts-n--10497-4358-u--updateDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (vector 11 arg-6 arg-7 arg-2 arg-1)))
(define CompilerC-45CaseOpts-doCaseOfConstCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (vector 11 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45CaseOpts-n--10497-4357-u--updateAlt arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-3) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CompilerC-45CaseOpts-n--10497-4358-u--updateDef arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-4))))
(define CompilerC-45CaseOpts-n--10555-4399-u--conCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-5 (vector-ref arg-8 4))) (case (vector-ref e-5 0) ((5) 1)(else 0)))))
(define CompilerC-45CaseOpts-n--10555-4400-u--isCon (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((5) 1)(else 0))))
(define CompilerC-45CaseOpts-n--10555-4398-u--canCaseOfCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) 1 (let ((e-3 (cdr arg-8))) (if (null? e-3) (if (null? arg-9) 1 (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4399-u--conCase arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-8))) (cond ((equal? sc3 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4400-u--isCon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0))) arg-9)) (else 0)))) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4399-u--conCase arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-8))) (cond ((equal? sc2 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4400-u--isCon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0))) arg-9)) (else 0))))))))
(define CompilerC-45CaseOpts-n--10555-4528-u--constCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-2 (cdr arg-8))) (case (vector-ref e-2 0) ((12) 1)(else 0))))))
(define CompilerC-45CaseOpts-n--10555-4529-u--isConst (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((12) 1)(else 0))))
(define CompilerC-45CaseOpts-n--10555-4527-u--canCaseOfCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) 1 (let ((e-3 (cdr arg-8))) (if (null? e-3) (if (null? arg-9) 1 (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4528-u--constCase arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-8))) (cond ((equal? sc3 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4529-u--isConst arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0))) arg-9)) (else 0)))) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4528-u--constCase arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0)) arg-8))) (cond ((equal? sc2 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (eta-0) (CompilerC-45CaseOpts-n--10555-4529-u--isConst arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-0))) arg-9)) (else 0))))))))
(define CompilerC-45CaseOpts-tryCaseOfCase (lambda (arg-1) (case (vector-ref arg-1 0) ((10) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-2 0) ((10) (let ((e-11 (vector-ref e-2 1))) (let ((e-12 (vector-ref e-2 2))) (let ((e-13 (vector-ref e-2 3))) (let ((e-14 (vector-ref e-2 4))) (let ((sc2 (CompilerC-45CaseOpts-n--10555-4398-u--canCaseOfCase e-14 e-13 e-12 e-11 e-4 e-3 e-1 e-13 e-14))) (cond ((equal? sc2 1) (box (CompilerC-45CaseOpts-doCaseOfCase e-11 e-12 e-13 e-14 e-3 e-4))) (else '()))))))))(else '()))))))) ((11) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (case (vector-ref e-7 0) ((11) (let ((e-16 (vector-ref e-7 1))) (let ((e-17 (vector-ref e-7 2))) (let ((e-18 (vector-ref e-7 3))) (let ((e-19 (vector-ref e-7 4))) (let ((sc2 (CompilerC-45CaseOpts-n--10555-4527-u--canCaseOfCase e-19 e-18 e-17 e-16 e-9 e-8 e-6 e-18 e-19))) (cond ((equal? sc2 1) (box (CompilerC-45CaseOpts-doCaseOfConstCase e-16 e-17 e-18 e-19 e-8 e-9))) (else '()))))))))(else '())))))))(else '()))))
(define CompilerC-45CaseOpts-n--10820-4642-u--go (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) arg-3)(else (let ((e-0 (- arg-2 1))) (PreludeC-45Types-maybe (lambda () arg-3) (lambda () (lambda (eta-0) (CompilerC-45CaseOpts-n--10820-4642-u--go arg-1 e-0 eta-0))) (CompilerC-45CaseOpts-tryCaseOfCase arg-3)))))))
(define CompilerC-45CaseOpts-caseOfCase (lambda (arg-1) (CompilerC-45CaseOpts-n--10820-4642-u--go arg-1 5 arg-1)))
(define CompilerC-45Inline-genName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-extendLoc (lambda (arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 (cons (vector 0 ) arg-4)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (CompilerC-45Inline-genName arg-2 "cv" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45Inline-extendLoc arg-2 arg-3 arg-4 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (vector 1 e-2 e-5 e-7) (cons (vector 1 arg-3 e-5) e-4)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45CompileExpr-refsToLocals (lambda (arg-2 arg-3) (case (vector-ref arg-2 0) ((0) arg-3)(else (CoreC-45CompileExpr-mkLocals 0 arg-2 arg-3)))))
(define CompilerC-45Inline-evalAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-1 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((e-5 (vector-ref arg-8 4))) (let ((act-1 (CompilerC-45Inline-extendLoc arg-3 arg-4 arg-6 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((act-2 ((CompilerC-45Inline-eval (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-0) arg-1 arg-2 arg-3 arg-5 e-7 arg-7 e-5) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-4 (CoreC-45CompileExpr-refsToLocals e-8 e-9)))))) eff-0) clam-1)))))))))) eff-0) ext-0))))))))))))
(define CompilerC-45Inline-evalConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 e-5)))))) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) ext-0)))))
(define CompilerC-45Inline-evalLocal (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-1) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-7 (vector 0 arg-9 arg-5)))) (let ((e-3 (cdr arg-1))) (let ((e-7 (car arg-8))) (let ((e-8 (cdr arg-8))) (cond ((equal? arg-9 0) (if (null? arg-7) (lambda (eta-0) (vector 1 e-7)) (CompilerC-45Inline-eval e-3 arg-2 arg-3 arg-4 arg-6 e-8 arg-7 (CoreC-45CompileExpr-u--weakenNs_Weaken_CExp (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-3) e-7))))(else (let ((e-9 (- arg-9 1))) (CompilerC-45Inline-evalLocal e-3 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-8 e-9))))))))))
(define LibrariesC-45DataC-45ListC-45LengthMatch-checkLengthMatch (lambda (arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) (box 0) '()) (let ((e-3 (cdr arg-2))) (if (null? arg-3) '() (let ((e-11 (cdr arg-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45ListC-45LengthMatch-checkLengthMatch e-3 e-11) (lambda (bind-0) (box (+ bind-0 1))))))))))
(define CompilerC-45Inline-extend (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) (cond ((equal? arg-5 0) arg-2)(else (blodwen-error-quit "Nat case not covered"))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-9 (cdr arg-4))) (cond ((equal? arg-5 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-16 (- arg-5 1))) (cons e-2 (CompilerC-45Inline-extend arg-2 e-3 e-9 e-16)))))))))))
(define CompilerC-45Inline-n--10709-4827-u--matches (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23) (if (null? arg-21) (if (null? arg-23) (CoreC-45Name-u--C-61C-61_Eq_Name arg-20 arg-22) 0) (let ((e-1 (unbox arg-21))) (if (null? arg-23) 0 (let ((e-4 (unbox arg-23))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-1 e-4)))))))
(define CompilerC-45Inline-pickAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-7 0) ((5) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (if (null? arg-8) (if (null? arg-9) (lambda (eta-0) (vector 1 '())) (let ((e-6 (unbox arg-9))) (let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) (let ((e-8 (car arg-8))) (let ((e-9 (cdr arg-8))) (let ((e-11 (vector-ref e-8 0))) (let ((e-12 (vector-ref e-8 1))) (let ((e-13 (vector-ref e-8 2))) (let ((e-14 (vector-ref e-8 3))) (let ((e-15 (vector-ref e-8 4))) (let ((u--con (vector 5 e-1 e-2 e-3 e-4 e-5))) (let ((sc2 (CompilerC-45Inline-n--10709-4827-u--matches e-12 arg-1 e-5 e-4 e-3 e-2 e-1 u--con e-14 arg-0 e-15 e-13 e-11 e-9 arg-9 arg-6 arg-5 arg-4 arg-3 arg-2 e-2 e-4 e-11 e-13))) (cond ((equal? sc2 1) (let ((sc3 (LibrariesC-45DataC-45ListC-45LengthMatch-checkLengthMatch e-5 e-14))) (if (null? sc3) (lambda (eta-0) (vector 1 '())) (let ((e-6 (unbox sc3))) (let ((u--envC-39 (CompilerC-45Inline-extend arg-5 e-5 e-14 e-6))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval (PreludeC-45TypesC-45List-tailRecAppend e-14 arg-0) arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-15) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-7))))) eff-0) eta-0))))))))))) (else (CompilerC-45Inline-pickAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--con e-9 arg-9)))))))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45Inline-pickConstAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-7 0) ((12) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (if (null? arg-8) (if (null? arg-9) (lambda (eta-0) (vector 1 '())) (let ((e-3 (unbox arg-9))) (let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))))) (let ((e-5 (car arg-8))) (let ((e-6 (cdr arg-8))) (if (null? e-5) (lambda (eta-0) (vector 1 '())) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-2 e-8))) (cond ((equal? sc3 1) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-9) eta-0))) (else (CompilerC-45Inline-pickConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (vector 12 e-1 e-2) e-6 arg-9)))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45Inline-refToLocal (lambda (arg-1 arg-2 arg-3) (CoreC-45CompileExpr-refsToLocals (vector 1 arg-2 arg-1 (vector 0 )) arg-3)))
(define CompilerC-45Inline-largest (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (let ((e-4 (vector-ref arg-1 3))) ((e-4 e-2) arg-2)))) (cond ((equal? sc1 1) (CompilerC-45Inline-largest arg-1 e-2 e-3)) (else (CompilerC-45Inline-largest arg-1 arg-2 e-3)))))))))
(define CompilerC-45Inline-usedCon (lambda (arg-1 arg-2 arg-4) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (let ((eff-0 (let ((sc0 CoreC-45TTC-45Var-WeakenVar)) (let ((e-6 (cdr sc0))) ((((e-6 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4)) arg-2))))) (CompilerC-45Inline-used (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-1) eff-0 e-5))))))
(define CompilerC-45Inline-usedConst (lambda (arg-1 arg-2 arg-4) (let ((e-2 (cdr arg-4))) (CompilerC-45Inline-used arg-1 arg-2 e-2))))
(define CompilerC-45Inline-used (lambda (arg-1 arg-2 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((sc1 (or (and (= arg-2 e-2) 1) 0))) (cond ((equal? sc1 1) 1) (else 0))))) ((2) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (CompilerC-45Inline-used (cons e-7 arg-1) (+ arg-2 1) e-8)))) ((3) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (cond ((equal? e-12 1) (let ((u--usedl (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-13) (CompilerC-45Inline-used (cons e-11 arg-1) (+ arg-2 1) e-14) 63))) (let ((sc2 (PreludeC-45EqOrd-u--C-62_Ord_Int u--usedl 0))) (cond ((equal? sc2 1) (blodwen-toSignedInt 1000 63)) (else u--usedl))))) ((equal? e-12 0) (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-13) (CompilerC-45Inline-used (cons e-11 arg-1) (+ arg-2 1) e-14) 63))(else 0))))))) ((4) (let ((e-17 (vector-ref arg-4 2))) (let ((e-18 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldr_Foldable_List csegen-1939 (CompilerC-45Inline-used arg-1 arg-2 e-17) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-18))))) ((5) (let ((e-24 (vector-ref arg-4 5))) (PreludeC-45Types-u--foldr_Foldable_List csegen-1939 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-24)))) ((6) (let ((e-29 (vector-ref arg-4 4))) (DataC-45Vect-u--foldr_Foldable_C-40VectC-32C-36nC-41 csegen-1939 0 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-29)))) ((7) (let ((e-33 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldr_Foldable_List csegen-1939 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0)) e-33)))) ((8) (let ((e-37 (vector-ref arg-4 3))) (CompilerC-45Inline-used arg-1 arg-2 e-37))) ((9) (let ((e-41 (vector-ref arg-4 3))) (CompilerC-45Inline-used arg-1 arg-2 e-41))) ((10) (let ((e-44 (vector-ref arg-4 2))) (let ((e-45 (vector-ref arg-4 3))) (let ((e-46 (vector-ref arg-4 4))) (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-44) (CompilerC-45Inline-largest csegen-231 (PreludeC-45Types-maybe (lambda () (blodwen-toSignedInt 0 63)) (lambda () (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0))) e-46) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45Inline-usedCon arg-1 arg-2 eta-0)) e-45)) 63))))) ((11) (let ((e-49 (vector-ref arg-4 2))) (let ((e-50 (vector-ref arg-4 3))) (let ((e-51 (vector-ref arg-4 4))) (bs+ (CompilerC-45Inline-used arg-1 arg-2 e-49) (CompilerC-45Inline-largest csegen-231 (PreludeC-45Types-maybe (lambda () (blodwen-toSignedInt 0 63)) (lambda () (lambda (eta-0) (CompilerC-45Inline-used arg-1 arg-2 eta-0))) e-51) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CompilerC-45Inline-usedConst arg-1 arg-2 eta-0)) e-50)) 63)))))(else 0))))
(define CoreC-45CompileExpr-u--showPrec_Show_C-40CExpC-32C-36varsC-41 (lambda (arg-0 arg-1 arg-2) (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-0 arg-2)))
(define CompilerC-45Inline-n--10583-4262-u--updateLoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-15 arg-16) (if (null? arg-13) arg-15 (cond ((equal? arg-12 0) (let ((e-8 (cdr arg-15))) (cons arg-16 e-8)))(else (let ((e-0 (- arg-12 1))) (let ((e-11 (cdr arg-13))) (let ((e-15 (car arg-15))) (let ((e-16 (cdr arg-15))) (cons e-15 (CompilerC-45Inline-n--10583-4262-u--updateLoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-0 e-11 e-16 arg-16)))))))))))
(define CompilerC-45Inline-n--10583-4261-u--update (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-12 0) ((0) (let ((e-2 (vector-ref arg-12 1))) (CompilerC-45Inline-n--10583-4262-u--updateLoc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 arg-11 arg-13 arg-14)))(else arg-13))))
(define CompilerC-45Inline-takeFromStack (lambda (arg-2 arg-3 arg-4) (if (null? arg-3) (if (null? arg-4) (box (cons arg-2 arg-3)) '()) (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (if (null? arg-4) (if (null? arg-4) (box (cons arg-2 arg-3)) '()) (let ((e-7 (cdr arg-4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CompilerC-45Inline-takeFromStack arg-2 e-4 e-7) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-5 (cdr _-0))) (box (cons (cons e-3 e-2) e-5)))))))))))))
(define CompilerC-45Inline-tryApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (lambda (clam-0) (let ((sc1 (CompilerC-45Inline-takeFromStack arg-6 arg-5 e-0))) (if (null? sc1) (vector 1 '()) (let ((e-2 (unbox sc1))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-1 ((CompilerC-45Inline-eval (PreludeC-45TypesC-45List-tailRecAppend e-0 arg-0) arg-1 arg-2 arg-3 arg-4 e-5 e-6 e-1) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box e-7))))) eff-0) clam-0))))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CompilerC-45Inline-unloadApp (lambda (arg-1 arg-2 arg-3) (CompilerC-45Inline-unload (DataC-45List-drop arg-1 arg-2) (vector 4 (CoreC-45CompileExpr-getFC arg-3) arg-3 (DataC-45List-take arg-1 arg-2)))))
(define CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-3467 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2)))) (let ((e-1 (unbox arg-14))) (let ((u--arity (CompilerC-45Inline-getArity e-1))) (let ((u--gdefFlags (let ((e-12 (vector-ref arg-12 12))) e-12))) (lambda (clam-0) (let ((sc1 (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 0 ) u--gdefFlags))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-832 arg-2 arg-6))) (cond ((equal? sc3 1) 0) (else (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 1 ) u--gdefFlags))) (cond ((equal? sc4 1) 0) (else 1))))))) (else 0))))) (cond ((equal? sc1 1) (let ((act-1 ((CompilerC-45Inline-tryApply arg-0 arg-1 arg-8 arg-7 (cons arg-2 arg-6) arg-4 arg-5 e-1) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (DataC-45Maybe-fromMaybe (lambda () (CompilerC-45Inline-unloadApp u--arity arg-4 (vector 1 arg-3 arg-2))) e-5))))) eff-0) clam-0)))))) (else (vector 1 (CompilerC-45Inline-unloadApp u--arity arg-4 (vector 1 arg-3 arg-2)))))))))))))
(define CompilerC-45Inline-case--eval-3217 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (cond ((equal? e-2 1) (if (null? e-3) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-8))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2)))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-3467 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-5 e-1 _-0 (let ((e-19 (vector-ref e-1 19))) e-19))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (lambda (clam-0) (if (null? e-6) (let ((act-1 (let ((act-1 (unbox arg-8))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2)))) (let ((e-1 (unbox e-8))) (let ((_-0 (box e-1))) (CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-3467 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-7 e-1 _-0 (let ((e-19 (vector-ref e-1 19))) e-19))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (let ((act-1 (CompilerC-45Inline-genName arg-7 "world" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CompilerC-45Inline-genName arg-7 "act" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--world (lambda (vars-3345) (vector 1 arg-3 e-7)))) (lambda (eta-1) (let ((act-3 ((CompilerC-45Inline-eval '() arg-1 arg-8 arg-7 arg-6 '() '() (vector 4 arg-3 e-8 (cons (vector 1 arg-3 e-10) (cons (u--world 'erased) '())))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 arg-3 e-7 (CompilerC-45Inline-refToLocal e-7 e-7 (vector 3 arg-3 e-10 1 (vector 4 arg-3 e-5 (cons (u--world 'erased) '())) (CompilerC-45Inline-refToLocal e-10 e-10 e-11)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-11 (car e-9))) (let ((e-12 (cdr e-9))) (let ((act-1 (CompilerC-45Inline-genName arg-7 "act" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45Inline-eval '() arg-1 arg-8 arg-7 arg-6 '() '() (vector 4 arg-3 e-8 (cons (vector 1 arg-3 e-7) (cons e-11 '())))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload e-12 (vector 3 arg-3 e-7 1 (vector 4 arg-3 e-5 (cons e-11 '())) (CompilerC-45Inline-refToLocal e-7 e-7 e-10))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-8))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (CompilerC-45Inline-unload arg-4 (vector 1 arg-3 arg-2)))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CompilerC-45Inline-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32eval-3467 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-2 e-5 e-1 _-0 (let ((e-19 (vector-ref e-1 19))) e-19))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))
(define CompilerC-45Inline-eval (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-68 (vector-ref arg-7 1))) (let ((e-69 (vector-ref arg-7 2))) (CompilerC-45Inline-evalLocal arg-0 arg-1 arg-2 arg-3 e-69 arg-4 arg-6 arg-5 e-68)))) ((1) (let ((e-72 (vector-ref arg-7 1))) (let ((e-73 (vector-ref arg-7 2))) (lambda (eta-0) (let ((act-1 (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-73 csegen-1940))) (cond ((equal? sc1 1) (CoreC-45ContextC-45Log-log arg-2 "compiler.inline.io_bind" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Attempting to inline io_bind, its stack is: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CompileExpr-u--showPrec_Show_C-40CExpC-32C-36varsC-41 arg-1 u--d u--x)))) arg-6) '())))) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CompilerC-45Inline-case--eval-3217 arg-0 arg-1 e-73 e-72 arg-6 arg-5 arg-4 arg-3 arg-2 (cons (CoreC-45Name-u--C-61C-61_Eq_Name e-73 csegen-1940) arg-6)) eta-0))))))))(else (if (null? arg-6) (case (vector-ref arg-7 0) ((2) (let ((e-59 (vector-ref arg-7 1))) (let ((e-60 (vector-ref arg-7 2))) (let ((e-61 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 (CompilerC-45Inline-genName arg-3 "lamv" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-eval (cons e-60 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-59 e-5) arg-5) '() e-61) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-59 e-60 (CompilerC-45Inline-refToLocal e-5 e-60 e-6)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-7 0) ((3) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (cond ((equal? e-3 1) (lambda (eta-0) (let ((act-1 (CompilerC-45Inline-genName arg-3 "letv" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) '() e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 3 e-1 e-2 1 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (else (let ((u--u (CompilerC-45Inline-used (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1)) 0 e-5))) (lambda (clam-0) (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_Int u--u 1))) (cond ((equal? sc3 1) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-6 arg-5) arg-6 e-5))) eff-0) clam-0)))))) (else (let ((act-1 (CompilerC-45Inline-genName arg-3 "letv" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) arg-6 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-1 e-2 0 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))))) ((4) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (lambda (clam-1) (case (vector-ref e-8 0) ((1) (let ((e-52 (vector-ref e-8 1))) (let ((e-53 (vector-ref e-8 2))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-53 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--f (vector 1 e-52 e-53))) (lambda (clam-2) (if (null? e-6) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-9 '()) clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 4 e-7 (vector 1 e-52 e-53) e-10)))))) eff-0) clam-2))))) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-9 '()) clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-10 arg-6) u--f))) eff-0) clam-2)))))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-0)) e-9 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-6) e-8))) eff-0) clam-1)))))))))))) ((5) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((e-15 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-15 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 5 e-11 e-12 e-13 e-14 e-5)))))) eff-0) eta-0)))))))))))) ((6) (let ((e-17 (vector-ref arg-7 1))) (let ((e-18 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 3))) (let ((e-20 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-20) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 6 e-17 e-18 e-19 e-5)))))) eff-0) eta-0))))))))))) ((7) (let ((e-22 (vector-ref arg-7 1))) (let ((e-23 (vector-ref arg-7 2))) (let ((e-24 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-24 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 7 e-22 e-23 e-5)))))) eff-0) eta-0)))))))))) ((8) (let ((e-26 (vector-ref arg-7 1))) (let ((e-27 (vector-ref arg-7 2))) (let ((e-28 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-28) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((9) (let ((e-3 (vector-ref e-5 3))) (CompilerC-45Inline-eval '() arg-1 arg-2 arg-3 arg-4 '() arg-6 e-3)))(else (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 8 e-26 e-27 e-5)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-32) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 9 e-30 e-31 e-5)))))) eff-0) eta-0)))))))))) ((10) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (let ((e-37 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-35) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--envC-39 (CompilerC-45Inline-n--10583-4261-u--update arg-0 arg-1 e-37 e-36 e-35 e-34 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-35 arg-5 e-5))) (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-pickAlt arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-5 e-36 e-37) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-6) (let ((act-3 (if (null? e-37) (vector 1 '()) (let ((e-2 (unbox e-37))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) clam-3))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CompilerC-45Inline-evalAlt arg-0 arg-1 arg-2 arg-3 e-34 arg-4 u--envC-39 arg-6 eta-3 eta-4))) e-36 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 10 e-34 e-5 e-8 e-7)))))) eff-0) eta-2)))))))) eff-0) clam-3))))) (let ((e-2 (unbox e-6))) (vector 1 e-2)))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))) ((11) (let ((e-39 (vector-ref arg-7 1))) (let ((e-40 (vector-ref arg-7 2))) (let ((e-41 (vector-ref arg-7 3))) (let ((e-42 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-40) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-pickConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-41 e-42) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-6) (let ((act-3 (if (null? e-42) (vector 1 '()) (let ((e-2 (unbox e-42))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) clam-4))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CompilerC-45Inline-evalConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-3 eta-4))) e-41 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 11 e-39 e-5 e-8 e-7)))))) eff-0) eta-2)))))))) eff-0) clam-4))))) (let ((e-2 (unbox e-6))) (vector 1 e-2)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((12) (let ((e-44 (vector-ref arg-7 1))) (let ((e-45 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 12 e-44 e-45))))))) ((13) (let ((e-47 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 13 e-47)))))) (else (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 14 e-49 e-50)))))))))) (let ((e-56 (car arg-6))) (let ((e-57 (cdr arg-6))) (case (vector-ref arg-7 0) ((2) (let ((e-64 (vector-ref arg-7 2))) (let ((e-65 (vector-ref arg-7 3))) (CompilerC-45Inline-eval (cons e-64 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-56 arg-5) e-57 e-65))))(else (case (vector-ref arg-7 0) ((3) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (cond ((equal? e-3 1) (lambda (eta-0) (let ((act-1 (CompilerC-45Inline-genName arg-3 "letv" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) '() e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 3 e-1 e-2 1 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (else (let ((u--u (CompilerC-45Inline-used (cons e-2 (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1)) 0 e-5))) (lambda (clam-5) (let ((sc3 (PreludeC-45EqOrd-u--C-60_Ord_Int u--u 1))) (cond ((equal? sc3 1) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons e-6 arg-5) arg-6 e-5))) eff-0) clam-5)))))) (else (let ((act-1 (CompilerC-45Inline-genName arg-3 "letv" clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CompilerC-45Inline-eval (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 (cons (vector 1 e-1 e-6) arg-5) arg-6 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-4) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-1 e-2 0 e-8 (CompilerC-45Inline-refToLocal e-6 e-2 e-7)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5)))))))))))))))))) ((4) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (lambda (clam-6) (case (vector-ref e-8 0) ((1) (let ((e-52 (vector-ref e-8 1))) (let ((e-53 (vector-ref e-8 2))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-53 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--f (vector 1 e-52 e-53))) (lambda (clam-7) (if (null? e-6) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-9 '()) clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 4 e-7 (vector 1 e-52 e-53) e-10)))))) eff-0) clam-7))))) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-9 '()) clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-10 arg-6) u--f))) eff-0) clam-7)))))))))) eff-0) eta-0)))))))) eff-0) clam-6))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-0)) e-9 '()) clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-6) e-8))) eff-0) clam-6)))))))))))) ((5) (let ((e-11 (vector-ref arg-7 1))) (let ((e-12 (vector-ref arg-7 2))) (let ((e-13 (vector-ref arg-7 3))) (let ((e-14 (vector-ref arg-7 4))) (let ((e-15 (vector-ref arg-7 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-15 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 5 e-11 e-12 e-13 e-14 e-5)))))) eff-0) eta-0)))))))))))) ((6) (let ((e-17 (vector-ref arg-7 1))) (let ((e-18 (vector-ref arg-7 2))) (let ((e-19 (vector-ref arg-7 3))) (let ((e-20 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseVect (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-20) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 6 e-17 e-18 e-19 e-5)))))) eff-0) eta-0))))))))))) ((7) (let ((e-22 (vector-ref arg-7 1))) (let ((e-23 (vector-ref arg-7 2))) (let ((e-24 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() eta-1)) e-24 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 7 e-22 e-23 e-5)))))) eff-0) eta-0)))))))))) ((8) (let ((e-26 (vector-ref arg-7 1))) (let ((e-27 (vector-ref arg-7 2))) (let ((e-28 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-28) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((9) (let ((e-3 (vector-ref e-5 3))) (CompilerC-45Inline-eval '() arg-1 arg-2 arg-3 arg-4 '() arg-6 e-3)))(else (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 8 e-26 e-27 e-5)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-30 (vector-ref arg-7 1))) (let ((e-31 (vector-ref arg-7 2))) (let ((e-32 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-32) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 9 e-30 e-31 e-5)))))) eff-0) eta-0)))))))))) ((10) (let ((e-34 (vector-ref arg-7 1))) (let ((e-35 (vector-ref arg-7 2))) (let ((e-36 (vector-ref arg-7 3))) (let ((e-37 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-35) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--envC-39 (CompilerC-45Inline-n--10583-4261-u--update arg-0 arg-1 e-37 e-36 e-35 e-34 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 e-35 arg-5 e-5))) (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-pickAlt arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-5 e-36 e-37) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-8) (if (null? e-6) (let ((act-3 (if (null? e-37) (vector 1 '()) (let ((e-2 (unbox e-37))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 u--envC-39 arg-6 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) clam-8))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CompilerC-45Inline-evalAlt arg-0 arg-1 arg-2 arg-3 e-34 arg-4 u--envC-39 arg-6 eta-3 eta-4))) e-36 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 10 e-34 e-5 e-8 e-7)))))) eff-0) eta-2)))))))) eff-0) clam-8))))) (let ((e-2 (unbox e-6))) (vector 1 e-2)))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))) ((11) (let ((e-39 (vector-ref arg-7 1))) (let ((e-40 (vector-ref arg-7 2))) (let ((e-41 (vector-ref arg-7 3))) (let ((e-42 (vector-ref arg-7 4))) (lambda (eta-0) (let ((act-1 ((CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() e-40) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CompilerC-45Inline-pickConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-41 e-42) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-9) (if (null? e-6) (let ((act-3 (if (null? e-42) (vector 1 '()) (let ((e-2 (unbox e-42))) ((let ((eff-0 (CompilerC-45Inline-eval arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-2))) clam-9))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CompilerC-45Inline-evalConstAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-3 eta-4))) e-41 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CompilerC-45CaseOpts-caseOfCase (vector 11 e-39 e-5 e-8 e-7)))))) eff-0) eta-2)))))))) eff-0) clam-9))))) (let ((e-2 (unbox e-6))) (vector 1 e-2)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((12) (let ((e-44 (vector-ref arg-7 1))) (let ((e-45 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 12 e-44 e-45))))))) ((13) (let ((e-47 (vector-ref arg-7 1))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 13 e-47)))))) (else (let ((e-49 (vector-ref arg-7 1))) (let ((e-50 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (CompilerC-45Inline-unload arg-6 (vector 14 e-49 e-50)))))))))))))))))
(define CompilerC-45Inline-doEval (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Compiler.Inline.LVar" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "compiler.inline.eval" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-2) (string-append ": " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-0 arg-3)))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CompilerC-45Inline-eval '() arg-0 arg-1 e-5 '() '() '() arg-3) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "compiler.inline.eval" 10 (lambda () (string-append "Inlined: " (CoreC-45CompileExpr-u--show_Show_C-40CExpC-32C-36varsC-41 arg-0 e-7))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-inline (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-1 (CompilerC-45Inline-doEval e-0 arg-0 arg-1 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-0 e-5))))) eff-0) ext-0))))))))(else (vector 1 arg-2)))))
(define CompilerC-45Inline-inlineDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-19 (vector-ref e-1 19))) (if (null? e-19) (vector 1 (vector 0 )) (let ((e-26 (unbox e-19))) (let ((act-3 (CompilerC-45Inline-inline arg-0 arg-1 e-26 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-27 (vector-ref act-3 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-setCompiled arg-0 arg-1 e-27 eta-1)))) eff-0) clam-0))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45InlineHeuristics-isVar (lambda (arg-0 arg-2) (case (vector-ref arg-2 0) ((0) 1) ((1) 1) ((8) (let ((e-11 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 e-11))) ((9) (let ((e-15 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 e-15)))(else 0))))
(define CompilerC-45OptsC-45InlineHeuristics-simple (lambda (arg-0 arg-2) (case (vector-ref arg-2 0) ((0) 1) ((1) 1) ((2) 0) ((3) 0) ((4) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (case (vector-ref e-20 0) ((1) (let ((e-65 (vector-ref e-20 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-65))) (cond ((equal? sc2 1) 0) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-21))))))(else (let ((sc1 (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 e-20))) (cond ((equal? sc1 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-21)) (else 0)))))))) ((5) (let ((e-27 (vector-ref arg-2 5))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-27))) ((6) (let ((e-32 (vector-ref arg-2 4))) (DataC-45Vect-u--foldMap_Foldable_C-40VectC-32C-36nC-41 csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-32))) ((7) (let ((e-36 (vector-ref arg-2 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45InlineHeuristics-isVar arg-0 eta-0)) e-36))) ((8) (let ((e-40 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-simple arg-0 e-40))) ((9) (let ((e-44 (vector-ref arg-2 3))) (CompilerC-45OptsC-45InlineHeuristics-simple arg-0 e-44))) ((10) 0) ((11) 0) ((12) 1) ((13) 1) (else 0))))
(define CompilerC-45OptsC-45InlineHeuristics-inlineCDef (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (CompilerC-45OptsC-45InlineHeuristics-simple arg-0 e-1)))(else 0))))
(define CompilerC-45OptsC-45InlineHeuristics-case--caseC-32blockC-32inC-32inlineHeuristics-2014 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox arg-6))) (let ((sc1 (CompilerC-45OptsC-45InlineHeuristics-inlineCDef arg-1 e-1))) (cond ((equal? sc1 1) (lambda (clam-0) (let ((sc2 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref arg-4 9))) e-9)))) (cond ((equal? sc2 2) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 1 ) (let ((e-12 (vector-ref arg-4 12))) e-12)))) (cond ((equal? sc3 1) (vector 1 (vector 0 ))) (else (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compiler.inline.heuristic" 25 (lambda () (string-append "inlining heuristic decided to inline: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Context-setFlag arg-0 (vector 2 ) (vector 8 arg-3) (vector 0 ) clam-0))))))))(else (vector 1 (vector 0 ))))))) (else (lambda (eta-0) (vector 1 (vector 0 ))))))))))
(define CompilerC-45OptsC-45InlineHeuristics-inlineHeuristics (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((_-0 (box (cons e-8 e-7)))) (CompilerC-45OptsC-45InlineHeuristics-case--caseC-32blockC-32inC-32inlineHeuristics-2014 arg-0 arg-1 e-5 e-8 e-7 _-0 (let ((e-19 (vector-ref e-7 19))) e-19))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45OptsC-45Identity-isUnsucc (lambda (arg-0 arg-1 arg-4 arg-5) (case (vector-ref arg-5 0) ((6) (let ((e-1 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (cond ((equal? e-1 0) '())(else (let ((e-5 (- e-1 1))) (cond ((equal? e-5 0) '())(else (let ((e-6 (- e-5 1))) (cond ((equal? e-6 0) (case (vector-ref e-3 0) ((1) (if (null? e-4) '() (let ((e-10 (car e-4))) (let ((e-11 (cdr e-4))) (case (vector-ref e-10 0) ((0) (let ((e-14 (vector-ref e-10 1))) (if (null? e-11) '() (let ((e-19 (car e-11))) (let ((e-20 (cdr e-11))) (case (vector-ref e-19 0) ((12) (let ((e-23 (vector-ref e-19 2))) (if (null? e-20) (let ((sc8 (CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 arg-4 e-14))) (cond ((equal? sc8 1) (box (cons e-23 0))) (else '()))) '())))(else '())))))))(else '()))))))(else '())))(else '()))))))))))))(else '()))))
(define CompilerC-45OptsC-45Identity-maybeVarEq (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (let ((e-2 (unbox arg-6))) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 arg-4 arg-5 e-2)))))
(define CompilerC-45OptsC-45Identity-unsuccIdentity (lambda (arg-0 arg-1 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((6) (let ((e-1 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (cond ((equal? e-1 0) 0)(else (let ((e-5 (- e-1 1))) (cond ((equal? e-5 0) 0)(else (let ((e-6 (- e-5 1))) (cond ((equal? e-6 0) (case (vector-ref e-3 0) ((0) (if (null? e-4) 0 (let ((e-10 (car e-4))) (let ((e-11 (cdr e-4))) (if (null? e-11) 0 (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (case (vector-ref e-14 0) ((12) (let ((e-18 (vector-ref e-14 2))) (if (null? e-15) (let ((sc7 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant arg-3 e-18))) (cond ((equal? sc7 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-4 '() '() e-10)) (else 0))) 0)))(else 0)))))))))(else 0)))(else 0))))))))))))(else 0))))
(define CompilerC-45OptsC-45Identity-n--8498-2463-u--makeArgsC-39 (lambda (arg-1 arg-3 arg-4) (if (null? arg-3) '() (let ((e-3 (cdr arg-3))) (cons (arg-4 0) (CompilerC-45OptsC-45Identity-n--8498-2463-u--makeArgsC-39 arg-1 e-3 (lambda (eta-0) (arg-4 (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) eta-0)))))))))))
(define CompilerC-45OptsC-45Identity-makeArgs (lambda (arg-1) (CompilerC-45OptsC-45Identity-n--8498-2463-u--makeArgsC-39 arg-1 arg-1 (lambda (eta-0) eta-0))))
(define CompilerC-45OptsC-45Identity-n--8566-3380-u--altEq (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-1 (vector-ref arg-10 0))) (let ((e-4 (vector-ref arg-10 3))) (let ((e-5 (vector-ref arg-10 4))) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 (let ((sc0 CoreC-45TTC-45Var-WeakenVar)) (let ((e-6 (cdr sc0))) ((((e-6 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-4)) arg-9))) (box (cons e-1 (CompilerC-45OptsC-45Identity-makeArgs e-4))) arg-7 e-5))))))
(define CompilerC-45OptsC-45Identity-n--8566-3420-u--altEq (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-9 arg-8 (box e-1) e-2)))))
(define CompilerC-45OptsC-45Identity-n--8566-3028-u--eqArgs (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) (if (null? arg-13) 1 0) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (if (null? arg-13) 0 (let ((e-6 (car arg-13))) (let ((e-7 (cdr arg-13))) (let ((sc2 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 e-2 '() '() e-6))) (cond ((equal? sc2 1) (CompilerC-45OptsC-45Identity-n--8566-3028-u--eqArgs arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3 e-7)) (else 0)))))))))))
(define CompilerC-45OptsC-45Identity-cexpIdentity (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-74 (vector-ref arg-6 1))) (CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 arg-3 e-74))) ((1) 0) ((2) 0) ((3) (let ((e-87 (vector-ref arg-6 3))) (let ((e-88 (vector-ref arg-6 4))) (let ((e-89 (vector-ref arg-6 5))) (cond ((equal? e-87 1) 0)(else (let ((sc1 (let ((sc2 (CompilerC-45OptsC-45Identity-isUnsucc arg-0 arg-1 arg-3 e-88))) (if (null? sc2) 0 (let ((e-1 (unbox sc2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CompilerC-45OptsC-45Identity-unsuccIdentity arg-0 arg-1 e-5 e-6 e-89)))))))) (cond ((equal? sc1 1) 1) (else (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 (let ((sc2 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) arg-3))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-1)))) e-3))))) arg-4) arg-5 e-89)))))))))) ((4) (let ((e-92 (vector-ref arg-6 2))) (let ((e-93 (vector-ref arg-6 3))) (case (vector-ref e-92 0) ((1) (let ((e-96 (vector-ref e-92 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-96))) (cond ((equal? sc2 1) ((let ((sc3 (PreludeC-45Types-getAt arg-1 e-93))) (if (null? sc3) (lambda () 0) (let ((e-1 (unbox sc3))) (lambda () (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 arg-4 arg-5 e-1))))))) (else 0)))))(else 0)))))(else (if (null? arg-4) (case (vector-ref arg-6 0) ((5) 0)(else (case (vector-ref arg-6 0) ((6) (let ((e-15 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (cond ((equal? e-15 0) 0)(else (let ((e-41 (- e-15 1))) (cond ((equal? e-41 0) 0)(else (let ((e-42 (- e-41 1))) (cond ((equal? e-42 0) (case (vector-ref e-17 0) ((0) (if (null? e-18) 0 (let ((e-46 (car e-18))) (let ((e-47 (cdr e-18))) (if (null? e-47) 0 (let ((e-50 (car e-47))) (let ((e-51 (cdr e-47))) (if (null? e-51) (case (vector-ref e-50 0) ((12) (let ((e-2 (vector-ref e-50 2))) (case (vector-ref e-46 0) ((4) (let ((e-4 (vector-ref e-46 2))) (let ((e-3 (vector-ref e-46 3))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 2))) (let ((sc10 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-6))) (cond ((equal? sc10 1) ((let ((sc11 (PreludeC-45Types-getAt arg-1 e-3))) (if (null? sc11) (lambda () 0) (let ((e-8 (unbox sc11))) (case (vector-ref e-8 0) ((6) (let ((e-12 (vector-ref e-8 1))) (let ((e-10 (vector-ref e-8 3))) (let ((e-9 (vector-ref e-8 4))) (cond ((equal? e-12 0) (lambda () 0))(else (let ((e-13 (- e-12 1))) (cond ((equal? e-13 0) (lambda () 0))(else (let ((e-14 (- e-13 1))) (cond ((equal? e-14 0) (case (vector-ref e-10 0) ((1) (if (null? e-9) (lambda () 0) (let ((e-21 (car e-9))) (let ((e-20 (cdr e-9))) (if (null? e-20) (lambda () 0) (let ((e-23 (car e-20))) (let ((e-22 (cdr e-20))) (case (vector-ref e-23 0) ((12) (let ((e-24 (vector-ref e-23 2))) (if (null? e-22) (lambda () (let ((sc19 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-2 e-24))) (cond ((equal? sc19 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-21)) (else 0)))) (lambda () 0))))(else (lambda () 0))))))))))(else (lambda () 0))))(else (lambda () 0)))))))))))))(else (lambda () 0)))))))) (else 0)))))(else 0)))))(else 0))))(else 0)) 0))))))))(else 0)))(else 0)))))))))))) ((7) 0) ((8) 0) ((9) 0) ((10) (let ((e-32 (vector-ref arg-6 1))) (let ((e-33 (vector-ref arg-6 2))) (let ((e-34 (vector-ref arg-6 3))) (let ((e-35 (vector-ref arg-6 4))) (let ((sc2 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-33))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--8566-3380-u--altEq arg-0 arg-1 e-32 e-35 e-34 e-33 arg-5 arg-4 arg-3 eta-0)) e-34))) (cond ((equal? sc3 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-35)) (else 0)))) (else 0)))))))) ((11) (let ((e-37 (vector-ref arg-6 1))) (let ((e-38 (vector-ref arg-6 2))) (let ((e-39 (vector-ref arg-6 3))) (let ((e-40 (vector-ref arg-6 4))) (let ((sc2 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-38))) (cond ((equal? sc2 1) (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--8566-3420-u--altEq arg-0 arg-1 e-40 e-39 e-38 e-37 arg-5 arg-4 arg-3 eta-0)) e-39))) (cond ((equal? sc3 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-40)) (else 0)))) (else 0))))))))(else (if (null? arg-5) (case (vector-ref arg-6 0) ((12) 0)(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))) (let ((e-6 (unbox arg-5))) (case (vector-ref arg-6 0) ((12) (let ((e-10 (vector-ref arg-6 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-10)))(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))))))))) (let ((e-54 (unbox arg-4))) (if (null? e-54) (case (vector-ref arg-6 0) ((6) (let ((e-15 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (cond ((equal? e-15 0) 0)(else (let ((e-41 (- e-15 1))) (cond ((equal? e-41 0) 0)(else (let ((e-42 (- e-41 1))) (cond ((equal? e-42 0) (case (vector-ref e-17 0) ((0) (if (null? e-18) 0 (let ((e-46 (car e-18))) (let ((e-47 (cdr e-18))) (if (null? e-47) 0 (let ((e-50 (car e-47))) (let ((e-51 (cdr e-47))) (if (null? e-51) (case (vector-ref e-50 0) ((12) (let ((e-2 (vector-ref e-50 2))) (case (vector-ref e-46 0) ((4) (let ((e-4 (vector-ref e-46 2))) (let ((e-3 (vector-ref e-46 3))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 2))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-6))) (cond ((equal? sc11 1) ((let ((sc12 (PreludeC-45Types-getAt arg-1 e-3))) (if (null? sc12) (lambda () 0) (let ((e-8 (unbox sc12))) (case (vector-ref e-8 0) ((6) (let ((e-12 (vector-ref e-8 1))) (let ((e-10 (vector-ref e-8 3))) (let ((e-9 (vector-ref e-8 4))) (cond ((equal? e-12 0) (lambda () 0))(else (let ((e-13 (- e-12 1))) (cond ((equal? e-13 0) (lambda () 0))(else (let ((e-14 (- e-13 1))) (cond ((equal? e-14 0) (case (vector-ref e-10 0) ((1) (if (null? e-9) (lambda () 0) (let ((e-21 (car e-9))) (let ((e-20 (cdr e-9))) (if (null? e-20) (lambda () 0) (let ((e-23 (car e-20))) (let ((e-22 (cdr e-20))) (case (vector-ref e-23 0) ((12) (let ((e-24 (vector-ref e-23 2))) (if (null? e-22) (lambda () (let ((sc20 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-2 e-24))) (cond ((equal? sc20 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-21)) (else 0)))) (lambda () 0))))(else (lambda () 0))))))))))(else (lambda () 0))))(else (lambda () 0)))))))))))))(else (lambda () 0)))))))) (else 0)))))(else 0)))))(else 0))))(else 0)) 0))))))))(else 0)))(else 0)))))))))))) ((7) 0) ((8) 0) ((9) 0) ((10) (let ((e-32 (vector-ref arg-6 1))) (let ((e-33 (vector-ref arg-6 2))) (let ((e-34 (vector-ref arg-6 3))) (let ((e-35 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-33))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--8566-3380-u--altEq arg-0 arg-1 e-32 e-35 e-34 e-33 arg-5 arg-4 arg-3 eta-0)) e-34))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-35)) (else 0)))) (else 0)))))))) ((11) (let ((e-37 (vector-ref arg-6 1))) (let ((e-38 (vector-ref arg-6 2))) (let ((e-39 (vector-ref arg-6 3))) (let ((e-40 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-38))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--8566-3420-u--altEq arg-0 arg-1 e-40 e-39 e-38 e-37 arg-5 arg-4 arg-3 eta-0)) e-39))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-40)) (else 0)))) (else 0))))))))(else (if (null? arg-5) (case (vector-ref arg-6 0) ((12) 0)(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))) (let ((e-6 (unbox arg-5))) (case (vector-ref arg-6 0) ((12) (let ((e-10 (vector-ref arg-6 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-10)))(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))))))) (let ((e-58 (car e-54))) (let ((e-59 (cdr e-54))) (case (vector-ref arg-6 0) ((5) (let ((e-61 (vector-ref arg-6 1))) (let ((e-62 (vector-ref arg-6 2))) (let ((e-63 (vector-ref arg-6 3))) (let ((e-64 (vector-ref arg-6 4))) (let ((e-65 (vector-ref arg-6 5))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-58 e-62))) (cond ((equal? sc3 1) (CompilerC-45OptsC-45Identity-n--8566-3028-u--eqArgs arg-0 arg-1 e-61 e-63 e-64 e-58 e-59 e-65 e-62 arg-5 arg-3 e-59 e-65)) (else 0)))))))))(else (case (vector-ref arg-6 0) ((6) (let ((e-15 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 3))) (let ((e-18 (vector-ref arg-6 4))) (cond ((equal? e-15 0) 0)(else (let ((e-41 (- e-15 1))) (cond ((equal? e-41 0) 0)(else (let ((e-42 (- e-41 1))) (cond ((equal? e-42 0) (case (vector-ref e-17 0) ((0) (if (null? e-18) 0 (let ((e-46 (car e-18))) (let ((e-47 (cdr e-18))) (if (null? e-47) 0 (let ((e-50 (car e-47))) (let ((e-51 (cdr e-47))) (if (null? e-51) (case (vector-ref e-50 0) ((12) (let ((e-2 (vector-ref e-50 2))) (case (vector-ref e-46 0) ((4) (let ((e-4 (vector-ref e-46 2))) (let ((e-3 (vector-ref e-46 3))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 2))) (let ((sc11 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-6))) (cond ((equal? sc11 1) ((let ((sc12 (PreludeC-45Types-getAt arg-1 e-3))) (if (null? sc12) (lambda () 0) (let ((e-8 (unbox sc12))) (case (vector-ref e-8 0) ((6) (let ((e-12 (vector-ref e-8 1))) (let ((e-10 (vector-ref e-8 3))) (let ((e-9 (vector-ref e-8 4))) (cond ((equal? e-12 0) (lambda () 0))(else (let ((e-13 (- e-12 1))) (cond ((equal? e-13 0) (lambda () 0))(else (let ((e-14 (- e-13 1))) (cond ((equal? e-14 0) (case (vector-ref e-10 0) ((1) (if (null? e-9) (lambda () 0) (let ((e-21 (car e-9))) (let ((e-20 (cdr e-9))) (if (null? e-20) (lambda () 0) (let ((e-23 (car e-20))) (let ((e-22 (cdr e-20))) (case (vector-ref e-23 0) ((12) (let ((e-24 (vector-ref e-23 2))) (if (null? e-22) (lambda () (let ((sc20 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-2 e-24))) (cond ((equal? sc20 1) (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-21)) (else 0)))) (lambda () 0))))(else (lambda () 0))))))))))(else (lambda () 0))))(else (lambda () 0)))))))))))))(else (lambda () 0)))))))) (else 0)))))(else 0)))))(else 0))))(else 0)) 0))))))))(else 0)))(else 0)))))))))))) ((7) 0) ((8) 0) ((9) 0) ((10) (let ((e-32 (vector-ref arg-6 1))) (let ((e-33 (vector-ref arg-6 2))) (let ((e-34 (vector-ref arg-6 3))) (let ((e-35 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-33))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--8566-3380-u--altEq arg-0 arg-1 e-32 e-35 e-34 e-33 arg-5 arg-4 arg-3 eta-0)) e-34))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-35)) (else 0)))) (else 0)))))))) ((11) (let ((e-37 (vector-ref arg-6 1))) (let ((e-38 (vector-ref arg-6 2))) (let ((e-39 (vector-ref arg-6 3))) (let ((e-40 (vector-ref arg-6 4))) (let ((sc3 (CompilerC-45OptsC-45Identity-cexpIdentity arg-0 arg-1 arg-3 '() '() e-38))) (cond ((equal? sc3 1) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CompilerC-45OptsC-45Identity-n--8566-3420-u--altEq arg-0 arg-1 e-40 e-39 e-38 e-37 arg-5 arg-4 arg-3 eta-0)) e-39))) (cond ((equal? sc4 1) (CompilerC-45OptsC-45Identity-maybeVarEq arg-0 arg-1 arg-3 arg-4 arg-5 e-40)) (else 0)))) (else 0))))))))(else (if (null? arg-5) (case (vector-ref arg-6 0) ((12) 0)(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))) (let ((e-6 (unbox arg-5))) (case (vector-ref arg-6 0) ((12) (let ((e-10 (vector-ref arg-6 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-10)))(else (case (vector-ref arg-6 0) ((13) 0) (else 0)))))))))))))))))))
(define CompilerC-45OptsC-45Identity-checkIdentity (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CompilerC-45OptsC-45Identity-cexpIdentity arg-1 arg-4 e-2 '() '() arg-3))) (cond ((equal? sc1 1) (box arg-4)) (else (CompilerC-45OptsC-45Identity-checkIdentity arg-1 e-3 arg-3 (+ arg-4 1))))))))))
(define CompilerC-45OptsC-45Identity-calcIdentity (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (CompilerC-45OptsC-45Identity-checkIdentity arg-0 (CompilerC-45OptsC-45Identity-makeArgs e-0) e-1 0))))(else '()))))
(define CompilerC-45OptsC-45Identity-setIdentity (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExactI arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((sc4 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (let ((e-19 (vector-ref e-7 19))) e-19) (lambda (eta-1) (CompilerC-45OptsC-45Identity-calcIdentity arg-1 eta-1))))) (if (null? sc4) (vector 1 (vector 0 )) (let ((e-2 (unbox sc4))) (let ((act-3 (CoreC-45Context-setFlag arg-0 (vector 2 ) (vector 8 e-8) (vector 12 e-2) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (CompilerC-45OptsC-45Identity-rewriteIdentityFlag arg-0 (vector 8 e-8) clam-0)))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CompilerC-45Inline-n--15529-7166-u--transform (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 (vector 0 ))))(else (let ((e-0 (- arg-1 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-inlineDef arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-mergeLamDef arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45CaseOpts-caseLamDef arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-fixArityDef arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45InlineHeuristics-inlineHeuristics arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45ConstantFold-constantFold arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CompilerC-45OptsC-45Identity-setIdentity arg-0 eta-1 eta-2))) arg-2) eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else ((CompilerC-45Inline-n--15529-7166-u--transform arg-0 e-0 arg-2) eta-0))))))))))))))))))))))))))))
(define CompilerC-45Inline-compileAndInlineAll (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ns (LibrariesC-45DataC-45NameMap-keys (let ((e-24 (vector-ref e-5 24))) e-24)))) (lambda (eta-0) (let ((act-2 ((CoreC-45Core-filterM (lambda (eta-1) (lambda (eta-2) (CompilerC-45Inline-n--15529-7165-u--nonErased arg-0 eta-1 eta-2))) u--ns) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CompilerC-45CompileExpr-compileDef arg-0 eta-2 eta-3))) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CompilerC-45OptsC-45Identity-rewriteIdentityFlag arg-0 eta-2 eta-3))) e-6) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CompilerC-45Inline-n--15529-7166-u--transform arg-0 3 e-6) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CompilerC-45Inline-updateCallGraph arg-0 eta-2 eta-3))) e-6) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45Context-getSession arg-0 eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((sc7 (DataC-45List-isNil (let ((e-22 (vector-ref e-11 22))) e-22)))) (cond ((equal? sc7 1) (lambda (eta-2) (vector 1 (vector 0 )))) (else (CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CompilerC-45Inline-addArityHash arg-0 eta-2 eta-3))) e-6)))))) eff-0) eta-1)))))))))))))))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-initHash (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 (blodwen-toSignedInt 5381 63) e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45UnifyState-checkDelayedHoles (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--hs (LibrariesC-45DataC-45IntMap-toList (let ((e-3 (vector-ref e-5 3))) e-3)))) (lambda (clam-0) (let ((sc1 (DataC-45List-isNil u--hs))) (cond ((equal? sc1 1) (vector 1 '())) (else (vector 1 (box (vector 32 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) u--hs))))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-getTotality (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (vector 1 (let ((e-10 (vector-ref e-1 10))) e-10))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setVisibility (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 (LibrariesC-45DataC-45WithDefault-specified arg-3) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-2)) eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TerminationC-45Positivity-blockingAssertTotal (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--at csegen-2366)) (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact u--at (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) arg-3 (lambda (eta-1) (let ((act-3 (CoreC-45Context-setVisibility arg-1 arg-2 u--at 0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (arg-3 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Context-setVisibility arg-1 arg-2 u--at 2 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-8))))))) eff-0) eta-1)))))))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Core-anyM (lambda (arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((eff-0 (arg-1 e-2))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (cond ((equal? e-5 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM arg-1 e-3))))) eff-1) world-0))))))))))))
(define CoreC-45TerminationC-45Positivity-isAssertTotal (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45Context-getFullName arg-1 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 csegen-2366))))) eff-0) ext-0)))))))(else (vector 1 0)))))
(define CoreC-45TerminationC-45Positivity-nameIn (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (CoreC-45TTC-45Binder-binderType e-3)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-2) (vector 1 1))) (else (let ((u--nm (vector 1 e-1 (vector 0 ) (vector 2 (string-append "NAMEIN_" (CoreC-45Name-u--show_Show_Name e-2)) 0)))) (let ((u--arg (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() u--nm))) (lambda (eta-2) (let ((act-3 (((e-4 arg-1) u--arg) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 e-7))) eff-0) eta-2)))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((1) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CoreC-45TerminationC-45Positivity-isAssertTotal arg-0 e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-1))) e-8 '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-anyM (lambda (eta-1) (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 eta-1)) e-9))) eff-0) clam-0)))))) (else (vector 1 0)))))) eff-0) eta-0))))))))) ((3) (let ((e-11 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 5))) (lambda (clam-1) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 e-11 arg-2))) (cond ((equal? sc1 1) (vector 1 1)) (else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-14 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-anyM (lambda (eta-0) (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 eta-0)) e-5))) eff-0) clam-1)))))))))))) ((2) (let ((e-20 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-1))) e-20 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-anyM (lambda (eta-1) (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 eta-1)) e-5))) eff-0) eta-0)))))))) ((5) (let ((e-24 (vector-ref arg-3 3))) (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 e-24)))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45TerminationC-45Positivity-posArgs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 1 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Checking parameter for positivity") '() e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((CoreC-45TerminationC-45Positivity-posArg arg-0 arg-1 arg-2 e-5) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (case (vector-ref e-7 0) ((1) (lambda (eta-1) (CoreC-45TerminationC-45Positivity-posArgs arg-0 arg-1 arg-2 e-3 eta-1)))(else (lambda (eta-1) (vector 1 e-7)))))) eff-0) eta-0))))))))))) eff-0) ext-0))))))))))
(define CoreC-45TerminationC-45Positivity-n--8659-13831-u--splitParams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (cons '() '()) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((u--nf (vector 3 arg-4 arg-3 arg-0 arg-1 arg-2))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-9 arg-10))) (cond ((equal? sc1 1) (let ((sc2 (CoreC-45TerminationC-45Positivity-n--8659-13831-u--splitParams arg-0 arg-1 arg-2 arg-3 arg-4 u--nf arg-6 arg-7 arg-8 (+ arg-9 1) arg-10 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (cons e-2 e-5) e-4))))) (else (let ((sc2 (CoreC-45TerminationC-45Positivity-n--8659-13831-u--splitParams arg-0 arg-1 arg-2 arg-3 arg-4 u--nf arg-6 arg-7 arg-8 (+ arg-9 1) arg-10 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons e-5 (cons e-2 e-4))))))))))))))
(define CoreC-45TerminationC-45Positivity-posArg (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (lambda (eta-0) (let ((act-1 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Found a type constructor") '() arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (let ((act-2 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-1 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--nf (vector 3 e-1 e-2 e-3 e-4 e-5))) (lambda (clam-0) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-1 (string-append (CoreC-45Name-u--show_Show_Name e-2) " not a data type")) clam-0) (let ((e-8 (unbox e-7))) (case (vector-ref e-8 0) ((6) (let ((e-14 (vector-ref e-8 3))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" 50 (lambda () (DataC-45String-unwords (cons (CoreC-45Name-u--show_Show_Name e-2) (cons "has" (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-14)) (cons "parameters" '())))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-17 (vector-ref act-3 1))) (vector 0 e-17))) (else (vector 1 (CoreC-45TerminationC-45Positivity-n--8659-13831-u--splitParams e-3 e-4 e-5 e-2 e-1 u--nf arg-2 arg-1 arg-0 0 e-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-5))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-1 (string-append (CoreC-45Name-u--show_Show_Name e-2) " not a data type")) clam-0))))))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (let ((act-3 (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 eta-1)) e-8 '()) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Core-anyM (lambda (eta-1) (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 eta-1)) e-10))) eff-0) clam-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-10 0) (lambda (eta-1) (CoreC-45TerminationC-45Positivity-posArgs arg-0 arg-1 arg-2 e-9 eta-1))) (else (lambda (eta-1) (vector 1 (vector 2 (vector 0 )))))))) eff-0) clam-1)))))))))) eff-0) eta-0))))))))))))))) ((0) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (lambda (clam-2) (case (vector-ref e-9 0) ((2) (let ((e-23 (vector-ref e-9 4))) (let ((act-1 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Found a Pi-type") '() arg-3 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-23) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 e-6) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-11 1) (lambda (eta-1) (vector 1 (vector 2 (vector 0 ))))) (else (let ((u--nm (vector 1 e-7 (vector 0 ) (vector 2 (string-append "POSCHECK_" (CoreC-45Name-u--show_Show_Name e-8)) 1)))) (let ((u--arg (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() u--nm))) (lambda (eta-1) (let ((act-4 (((e-10 arg-1) u--arg) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45TerminationC-45Positivity-posArg arg-0 arg-1 arg-2 e-12))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))))(else (let ((act-1 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Reached the catchall") '() arg-3 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))))))))))) ((1) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (CoreC-45TerminationC-45Positivity-isAssertTotal arg-0 e-13 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nf (vector 1 e-12 e-13 e-14))) (lambda (clam-3) (cond ((equal? e-5 0) (let ((act-2 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Found an application") '() u--nf clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-1))) e-14 '()) clam-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-anyM (lambda (eta-2) (CoreC-45TerminationC-45Positivity-nameIn arg-0 arg-1 arg-2 eta-2)) e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cond ((equal? e-8 1) (vector 2 (vector 0 ))) (else (vector 1 ))))))) eff-0) eta-1)))))))) eff-0) clam-3))))))))) (else (let ((act-2 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Trusting an assertion") '() u--nf clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))))))))) eff-0) eta-0)))))))))) ((5) (let ((e-18 (vector-ref arg-3 3))) (CoreC-45TerminationC-45Positivity-posArg arg-0 arg-1 arg-2 e-18)))(else (lambda (eta-0) (let ((act-1 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Reached the catchall") '() arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))))))))
(define CoreC-45TerminationC-45Positivity-checkPosArgs (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-9) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45TerminationC-45Positivity-posArg arg-0 arg-1 arg-2 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-10 0) ((1) (let ((u--nm (vector 1 e-1 (vector 0 ) (vector 2 (string-append "POSCHECK_" (CoreC-45Name-u--show_Show_Name e-2)) 0)))) (let ((u--arg (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() u--nm))) (lambda (eta-1) (let ((act-3 (((e-4 arg-1) u--arg) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45TerminationC-45Positivity-checkPosArgs arg-0 arg-1 arg-2 e-11))) eff-0) eta-1)))))))))(else (lambda (eta-1) (vector 1 e-10)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (let ((act-1 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Giving up on non-Pi type") '() arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (vector 1 (vector 1 ))))))))))))(else (let ((act-1 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 50 (lambda () "Giving up on non-Pi type") '() arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 1 ))))))))))
(define CoreC-45TerminationC-45References-case--caseC-32blockC-32inC-32totRefs-13442 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) (lambda (eta-0) (vector 1 arg-4))) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-3 "totality" 20 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-3 csegen-54 arg-0 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Totality unchecked for " (CoreC-45Name-u--show_Show_Name e-5)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-4))))))(else (lambda (clam-0) (case (vector-ref arg-4 0) ((2) (let ((e-0 (vector-ref arg-4 1))) (case (vector-ref e-0 0) ((1) (let ((e-1 (vector-ref e-0 1))) (CoreC-45Context-toFullNames arg-3 csegen-2365 (vector 2 (vector 1 (cons arg-0 e-1))) clam-0)))(else (CoreC-45Context-toFullNames arg-3 csegen-2365 (vector 2 (vector 1 (cons arg-0 '()))) clam-0)))))(else (CoreC-45Context-toFullNames arg-3 csegen-2365 (vector 2 (vector 1 (cons arg-0 '()))) clam-0))))))))
(define CoreC-45TerminationC-45References-totRefs (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 (vector 1 )) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (CoreC-45TerminationC-45References-totRefs arg-0 arg-1 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-1 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 e-5)) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CoreC-45TerminationC-45References-case--caseC-32blockC-32inC-32totRefs-13442 e-2 e-3 arg-1 arg-0 e-5 e-1 _-0 (let ((e-10 (vector-ref e-1 10))) (let ((e-29 (car e-10))) e-29)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45TerminationC-45References-totRefsIn (lambda (arg-1 arg-2 arg-3) (lambda (eta-0) (CoreC-45TerminationC-45References-totRefs arg-1 arg-2 (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 8 -1) arg-3)) eta-0))))
(define CoreC-45TerminationC-45Positivity-checkCon (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-lookupTyExact arg-3 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" 20 (lambda () (string-append "Couldn't find constructor " (CoreC-45Name-u--show_Show_Name arg-3))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 0 ))))) (let ((e-2 (unbox e-5))) (let ((act-2 ((CoreC-45TerminationC-45References-totRefsIn arg-0 arg-1 e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() arg-1 '() e-2) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45Normalise-logNF '() arg-0 "totality.positivity" 20 (lambda () "Checking the type ") '() e-7 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else ((CoreC-45TerminationC-45Positivity-checkPosArgs arg-0 arg-1 arg-2 e-7) eta-0))))))) eff-0) clam-1))))))(else (vector 1 e-6)))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define CoreC-45TerminationC-45Positivity-checkData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 1 )) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" 40 (lambda () (string-append "Checking positivity of constructor " (CoreC-45Name-u--show_Show_Name e-2))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45TerminationC-45Positivity-checkCon arg-0 arg-1 arg-2 e-2 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-6 0) ((1) (lambda (eta-0) (CoreC-45TerminationC-45Positivity-checkData arg-0 arg-1 arg-2 e-3 eta-0)))(else (lambda (eta-0) (vector 1 e-6)))))) eff-0) ext-0)))))))))))))
(define CoreC-45Context-lookupDefTyExact (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupExactBy csegen-1314 ext-2 ext-1 ext-0)))
(define CoreC-45TerminationC-45Positivity-calcPositive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality.positivity" 6 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Calculating positivity: " (CoreC-45Name-u--show_Show_Name e-6)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-lookupDefTyExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-7))) (lambda (clam-0) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append (CoreC-45Name-u--show_Show_Name arg-2) " not a data type")) clam-0) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (case (vector-ref e-9 0) ((6) (let ((e-12 (vector-ref e-9 6))) (let ((e-13 (vector-ref e-9 7))) (let ((act-4 ((CoreC-45TerminationC-45References-totRefsIn arg-0 e-5 e-8) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-18 0) ((1) (let ((act-5 (let ((act-5 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-log arg-0 "totality.positivity" 30 (lambda () (string-append "Now checking constructors of " (CoreC-45Name-u--show_Show_Name e-19))) eta-1)))) eff-0) clam-1))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45TerminationC-45Positivity-blockingAssertTotal arg-0 arg-1 (lambda (eta-1) (CoreC-45TerminationC-45Positivity-checkData arg-0 e-5 (cons arg-2 e-12) e-13 eta-1)) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-20 e-13))))) eff-0) clam-1)))))))))(else (vector 1 (cons e-18 e-13))))))) eff-0) clam-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append (CoreC-45Name-u--show_Show_Name arg-2) " not a data type")) clam-0))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setTerminating (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (let ((e-26 (cdr e-10))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 (cons arg-3 e-26) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))))) eta-2)) eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Termination-case--checkPositive-14083 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((act-1 (CoreC-45TerminationC-45Positivity-calcPositive arg-2 arg-1 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (CoreC-45Context-setTerminating arg-2 arg-1 arg-3 e-2 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (u--c) (lambda (eta-0) (CoreC-45Context-setTerminating arg-2 arg-1 u--c e-2 eta-0))) e-3) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 e-2)))))))))))) eff-0) ext-0))))))(else (vector 1 arg-5)))))
(define CoreC-45Termination-checkPositive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getTotality arg-0 arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality.positivity" 6 (lambda (eta-2) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-54 e-5 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (string-append "Checking positivity: " (CoreC-45Name-u--show_Show_Name e-7)))))) eff-0) eta-2)))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Termination-case--checkPositive-14083 arg-2 arg-1 arg-0 e-5 e-6 (let ((e-0 (car e-6))) e-0) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Context-findSetTotal (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((6) (let ((e-4 (vector-ref e-2 1))) (box e-4)))(else (CoreC-45ContextC-45Context-findSetTotal e-3))))))))
(define CoreC-45Context-getDefaultTotalityOption (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 3))) (let ((e-48 (vector-ref e-40 2))) e-48))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDeclsC-45Totality-n--6913-13420-u--checkCovering (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (vector 1 '()))(else (vector 1 (box (vector 11 arg-2 arg-0 arg-3)))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-lookupOrd (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (let ((e-12 (vector-ref arg-2 1))) ((e-12 arg-3) e-6)))) (cond ((equal? sc2 0) '()) ((equal? sc2 1) (box e-7)) (else (LibrariesC-45DataC-45SparseMatrixC-45Vector-lookupOrd arg-2 arg-3 e-3)))))))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector1-lookupOrd (lambda (arg-2 arg-3 arg-4) (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((sc2 (let ((e-11 (vector-ref arg-2 1))) ((e-11 arg-3) e-5)))) (cond ((equal? sc2 0) '()) ((equal? sc2 1) (box e-6)) (else (LibrariesC-45DataC-45SparseMatrixC-45Vector-lookupOrd arg-2 arg-3 e-2))))))))))
(define CoreC-45TerminationC-45SizeChange-n--8989-5957-u--selfDecArc (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-1035 (LibrariesC-45DataC-45SparseMatrixC-45Vector1-lookupOrd csegen-1647 e-2 e-3) (box 0))))))
(define CoreC-45TerminationC-45SizeChange-checkNonDesc (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45TerminationC-45SizeChange-n--8989-5957-u--selfDecArc arg-0 eta-0)) (let ((e-0 (car arg-0))) e-0)))) (cond ((equal? sc0 1) '()) (else (box arg-0))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-dot (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (let ((e-2 (vector-ref arg-1 1))) e-2) (if (null? arg-3) (let ((e-2 (vector-ref arg-1 1))) e-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-8 (car arg-3))) (let ((e-9 (cdr arg-3))) (let ((e-12 (car e-8))) (let ((e-13 (cdr e-8))) (let ((u--xs (cons (cons e-5 e-6) e-2))) (let ((u--ys (cons (cons e-12 e-13) e-9))) (let ((sc6 (PreludeC-45EqOrd-u--compare_Ord_Integer e-5 e-12))) (cond ((equal? sc6 0) (LibrariesC-45DataC-45SparseMatrixC-45Vector-dot arg-1 e-2 u--ys)) ((equal? sc6 1) (let ((e-10 (vector-ref arg-1 0))) ((e-10 (let ((e-14 (vector-ref arg-1 2))) ((e-14 e-6) e-13))) (LibrariesC-45DataC-45SparseMatrixC-45Vector-dot arg-1 e-2 e-9)))) (else (LibrariesC-45DataC-45SparseMatrixC-45Vector-dot arg-1 u--xs e-9))))))))))))))))))
(define LibrariesC-45DataC-45SparseMatrix-multRow (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--z (LibrariesC-45DataC-45SparseMatrixC-45Vector-dot (Builtin-snd arg-1) (DataC-45List1-forget e-7) (DataC-45List1-forget arg-3)))) (let ((sc2 (let ((sc3 (Builtin-fst arg-1))) (let ((e-1 (car sc3))) ((e-1 u--z) (let ((sc4 (Builtin-snd arg-1))) (let ((e-9 (vector-ref sc4 1))) e-9))))))) (cond ((equal? sc2 1) (LibrariesC-45DataC-45SparseMatrix-multRow arg-1 e-3 arg-3)) (else (cons (cons e-6 u--z) (LibrariesC-45DataC-45SparseMatrix-multRow arg-1 e-3 arg-3)))))))))))))
(define LibrariesC-45DataC-45SparseMatrix-multTranspose (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (LibrariesC-45DataC-45SparseMatrix-multRow arg-1 arg-2 e-7))) (if (null? sc2) (LibrariesC-45DataC-45SparseMatrix-multTranspose arg-1 arg-2 e-3) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (cons (cons e-6 (cons e-5 e-4)) (LibrariesC-45DataC-45SparseMatrix-multTranspose arg-1 arg-2 e-3)))))))))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-insert (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) (cons (cons arg-1 arg-2) '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--ys (cons (cons e-6 e-7) e-3))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Integer arg-1 e-6))) (cond ((equal? sc2 0) (cons (cons arg-1 arg-2) u--ys)) ((equal? sc2 1) u--ys) (else (cons (cons e-6 e-7) (LibrariesC-45DataC-45SparseMatrixC-45Vector-insert arg-1 arg-2 e-3)))))))))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector1-insert (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((u--ys (cons (cons e-5 e-6) e-2))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Integer arg-1 e-5))) (cond ((equal? sc2 0) (cons (cons arg-1 arg-2) (cons (cons e-5 e-6) e-2))) ((equal? sc2 1) u--ys) (else (cons (cons e-5 e-6) (LibrariesC-45DataC-45SparseMatrixC-45Vector-insert arg-1 arg-2 e-2))))))))))))
(define LibrariesC-45DataC-45SparseMatrix-n--5229-2321-u--spreadHeads (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) arg-6 (if (null? arg-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (DataC-45List1-singleton (cons arg-4 e-3)))))) arg-5) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (let ((e-12 (car e-8))) (let ((e-13 (cdr e-8))) (let ((u--xs (cons (cons e-5 e-6) e-2))) (let ((u--yss (cons (cons e-12 e-13) e-9))) (let ((sc6 (PreludeC-45EqOrd-u--compare_Ord_Integer e-5 e-12))) (cond ((equal? sc6 0) (cons (cons e-5 (DataC-45List1-singleton (cons arg-4 e-6))) (LibrariesC-45DataC-45SparseMatrix-n--5229-2321-u--spreadHeads arg-1 arg-2 arg-3 arg-4 e-2 u--yss))) ((equal? sc6 1) (cons (cons e-12 (LibrariesC-45DataC-45SparseMatrixC-45Vector1-insert arg-4 e-6 e-13)) (LibrariesC-45DataC-45SparseMatrix-n--5229-2321-u--spreadHeads arg-1 arg-2 arg-3 arg-4 e-2 e-9))) (else (cons (cons e-12 e-13) (LibrariesC-45DataC-45SparseMatrix-n--5229-2321-u--spreadHeads arg-1 arg-2 arg-3 arg-4 u--xs e-9)))))))))))))))))))
(define LibrariesC-45DataC-45SparseMatrix-transpose (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45SparseMatrix-n--5229-2321-u--spreadHeads e-6 e-7 e-3 e-6 (DataC-45List1-forget e-7) (LibrariesC-45DataC-45SparseMatrix-transpose e-3)))))))))
(define LibrariesC-45DataC-45SparseMatrix-mult (lambda (arg-1 ext-0 ext-1) (LibrariesC-45DataC-45SparseMatrix-multTranspose arg-1 (LibrariesC-45DataC-45SparseMatrix-transpose ext-0) ext-1)))
(define CoreC-45TerminationC-45SizeChange-composeChange (lambda (ext-0 ext-1) (LibrariesC-45DataC-45SparseMatrix-mult csegen-2362 ext-0 ext-1)))
(define PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (unbox arg-1))) (box e-2)))))
(define LibrariesC-45DataC-45NameMap-treeMap (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (vector 0 e-1 (arg-3 e-2))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (vector 1 (LibrariesC-45DataC-45NameMap-treeMap arg-3 e-5) e-6 (LibrariesC-45DataC-45NameMap-treeMap arg-3 e-7)))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (vector 2 (LibrariesC-45DataC-45NameMap-treeMap arg-3 e-10) e-11 (LibrariesC-45DataC-45NameMap-treeMap arg-3 e-12) e-13 (LibrariesC-45DataC-45NameMap-treeMap arg-3 e-14)))))))))))
(define LibrariesC-45DataC-45NameMap-u--map_Functor_NameMap (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cons e-2 (LibrariesC-45DataC-45NameMap-treeMap arg-2 e-3)))))))
(define CoreC-45TerminationC-45SizeChange-lookupSet (lambda (arg-1 arg-2 arg-3) (DataC-45Maybe-fromMaybe (lambda () (LibrariesC-45DataC-45SortedSet-empty arg-1)) (LibrariesC-45DataC-45NameMap-lookup arg-2 arg-3))))
(define LibrariesC-45DataC-45NameMap-treeMapWithKey (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (vector 0 e-1 ((arg-3 e-1) e-2))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (vector 1 (LibrariesC-45DataC-45NameMap-treeMapWithKey arg-3 e-5) e-6 (LibrariesC-45DataC-45NameMap-treeMapWithKey arg-3 e-7)))))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-13 (vector-ref arg-4 4))) (let ((e-14 (vector-ref arg-4 5))) (vector 2 (LibrariesC-45DataC-45NameMap-treeMapWithKey arg-3 e-10) e-11 (LibrariesC-45DataC-45NameMap-treeMapWithKey arg-3 e-12) e-13 (LibrariesC-45DataC-45NameMap-treeMapWithKey arg-3 e-14)))))))))))
(define LibrariesC-45DataC-45NameMap-mapWithKey (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cons e-2 (LibrariesC-45DataC-45NameMap-treeMapWithKey arg-2 e-3)))))))
(define CoreC-45TerminationC-45SizeChange-n--9038-6005-u--filterEndos (lambda (arg-0 arg-1 ext-0) (LibrariesC-45DataC-45NameMap-mapWithKey (lambda (u--f) (lambda (u--m) (PreludeC-45TypesC-45List-filterAppend '() arg-1 (LibrariesC-45DataC-45SortedSet-toList (CoreC-45TerminationC-45SizeChange-lookupSet csegen-2299 u--f u--m))))) ext-0)))
(define CoreC-45TerminationC-45SizeChange-findLoops (lambda (arg-0) (let ((u--loops (CoreC-45TerminationC-45SizeChange-n--9038-6005-u--filterEndos arg-0 (lambda (u--a) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-1044 (CoreC-45TerminationC-45SizeChange-composeChange (let ((e-0 (car u--a))) e-0) (let ((e-0 (car u--a))) e-0)) (let ((e-0 (car u--a))) e-0))) arg-0))) (LibrariesC-45DataC-45NameMap-u--map_Functor_NameMap (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 arg-8474 arg-8477))) '()) (lambda (eta-1) (CoreC-45TerminationC-45SizeChange-checkNonDesc eta-1)) eta-0)) u--loops))))
(define LibrariesC-45DataC-45NameMap-treeFoldl (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (((arg-3 arg-4) e-1) e-2)))) ((1) (let ((e-5 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 3))) (LibrariesC-45DataC-45NameMap-treeFoldl arg-3 (LibrariesC-45DataC-45NameMap-treeFoldl arg-3 arg-4 e-5) e-7)))) (else (let ((e-10 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 5))) (LibrariesC-45DataC-45NameMap-treeFoldl arg-3 (LibrariesC-45DataC-45NameMap-treeFoldl arg-3 (LibrariesC-45DataC-45NameMap-treeFoldl arg-3 arg-4 e-10) e-12) e-14))))))))
(define LibrariesC-45DataC-45NameMap-foldlNames (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) arg-3 (let ((e-3 (cdr arg-4))) (LibrariesC-45DataC-45NameMap-treeFoldl arg-2 arg-3 e-3)))))
(define CoreC-45TerminationC-45SizeChange-n--9098-6072-u--findNonTerminating (lambda (arg-0 ext-0) (LibrariesC-45DataC-45NameMap-foldlNames (lambda (u--acc) (lambda (u--g) (lambda (u--m) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons u--g __infixTupleSection-0)) u--m) u--acc)))) '() ext-0)))
(define CoreC-45TerminationC-45SizeChange-findNonTerminatingLoop (lambda (arg-0) (CoreC-45TerminationC-45SizeChange-n--9098-6072-u--findNonTerminating arg-0 (CoreC-45TerminationC-45SizeChange-findLoops arg-0))))
(define CoreC-45TerminationC-45SizeChange-initSCSet LibrariesC-45DataC-45NameMap-empty)
(define CoreC-45Core-foldlC (lambda (arg-3 arg-4 arg-5 ext-0) (let ((e-2 (vector-ref arg-3 1))) (((((e-2 'erased) 'erased) (lambda (u--ma) (lambda (u--b) (lambda (world-0) (let ((act-1 (u--ma world-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Basics-flip arg-4 u--b e-7))) eff-0) world-0))))))))) (lambda (eta-0) (vector 1 arg-5))) ext-0))))
(define CoreC-45TerminationC-45SizeChange-case--prefixCallSeqC-44go-5882 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-2 (let ((e-1 (unbox arg-4))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-6 arg-3))) (cond ((equal? sc2 1) arg-2) (else (CoreC-45TerminationC-45SizeChange-n--8882-5867-u--go arg-0 arg-1 e-6 (cons (cons e-5 arg-3) arg-2)))))))))))
(define CoreC-45TerminationC-45SizeChange-n--8882-5867-u--go (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45TerminationC-45SizeChange-case--prefixCallSeqC-44go-5882 arg-0 arg-1 arg-3 arg-2 (LibrariesC-45DataC-45NameMap-lookup arg-2 arg-1))))
(define CoreC-45TerminationC-45SizeChange-prefixCallSeq (lambda (arg-0 arg-1) (CoreC-45TerminationC-45SizeChange-n--8882-5867-u--go arg-1 arg-0 arg-1 '())))
(define CoreC-45TerminationC-45SizeChange-setPrefixTerminating (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (lambda (clam-0) (if (null? e-3) (vector 1 (vector 0 )) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (CoreC-45Context-setTerminating arg-0 e-6 e-7 (vector 2 (vector 2 e-3 arg-2)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((CoreC-45TerminationC-45SizeChange-setPrefixTerminating arg-0 e-3 arg-2) clam-0)))))))))))))
(define CoreC-45TerminationC-45SizeChange-n--9181-6185-u--addCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((u--work (LibrariesC-45DataC-45SortedSet-insert e-15 e-7))) (let ((sc4 (LibrariesC-45DataC-45NameMap-lookup (let ((e-1 (vector-ref e-10 1))) e-1) e-6))) (if (null? sc4) (cons (cons e-10 e-2) (cons (LibrariesC-45DataC-45NameMap-insert (let ((e-1 (vector-ref e-10 1))) e-1) (cons e-14 (let ((e-1 (vector-ref arg-0 1))) e-1)) e-6) u--work)) (cons e-2 (cons e-6 u--work)))))))))))))))
(define CoreC-45TerminationC-45SizeChange-n--9181-6186-u--isNonTerminating (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-10 (vector-ref e-2 10))) (let ((e-28 (car e-10))) (case (vector-ref e-28 0) ((2) 1)(else 0))))))))
(define CoreC-45TerminationC-45SizeChange-n--9181-6187-u--isUnchecked (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-10 (vector-ref e-2 10))) (let ((e-28 (car e-10))) (case (vector-ref e-28 0) ((0) 1)(else 0))))))))
(define CoreC-45TerminationC-45SizeChange-n--9181-6188-u--resolveCall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-0 (vector-ref arg-7 0))) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-0 (let ((e-35 (vector-ref arg-4 0))) e-35)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-5 "totality.termination.calc" 7 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Not found: " (cons (CoreC-45Name-u--show_Show_Name e-0) '()))))) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 arg-6)))) (let ((e-3 (unbox e-5))) (vector 1 (cons (cons e-3 (cons e-2 (cons (let ((e-26 (vector-ref arg-0 1))) e-26) (cons (let ((e-26 (vector-ref e-3 1))) e-26) (cons e-1 (cons (cons e-2 (let ((e-26 (vector-ref e-3 1))) e-26)) '())))))) arg-6))))))) eff-0) ext-0))))))))))
(define CoreC-45TerminationC-45SizeChange-addFunctions (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-2) (vector 1 (vector 1 (cons arg-4 arg-3))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 ((CoreC-45Core-foldlC csegen-14 (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45TerminationC-45SizeChange-n--9181-6188-u--resolveCall e-2 e-3 arg-4 arg-3 arg-1 arg-0 eta-0 eta-1 eta-2)))) '() (let ((e-21 (vector-ref e-2 21))) e-21)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (DataC-45List-find (lambda (eta-0) (CoreC-45TerminationC-45SizeChange-n--9181-6186-u--isNonTerminating e-2 e-3 arg-4 arg-3 arg-1 arg-0 eta-0)) e-5))) (if (null? sc2) (let ((sc3 (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (CoreC-45TerminationC-45SizeChange-n--9181-6185-u--addCall e-2 e-3 arg-4 arg-3 arg-1 arg-0 eta-0 eta-1))) (cons e-3 (cons arg-3 arg-4)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CoreC-45TerminationC-45SizeChange-n--9181-6187-u--isUnchecked e-2 e-3 arg-4 arg-3 arg-1 arg-0 eta-0)) e-5)))) (let ((e-6 (car sc3))) (let ((e-4 (cdr sc3))) (let ((e-8 (car e-4))) (let ((e-7 (cdr e-4))) (lambda (eta-0) (CoreC-45TerminationC-45SizeChange-addFunctions arg-0 arg-1 e-6 e-8 e-7 eta-0))))))) (let ((e-4 (unbox sc2))) (let ((e-7 (car e-4))) (let ((e-6 (cdr e-4))) (let ((e-9 (car e-6))) (let ((u--g (let ((e-1 (vector-ref e-7 1))) e-1))) (let ((u--init (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45TerminationC-45SizeChange-prefixCallSeq arg-3 (let ((e-1 (vector-ref e-2 1))) e-1)) (cons (cons e-9 u--g) '())))) (lambda (eta-0) (let ((act-2 ((CoreC-45TerminationC-45SizeChange-setPrefixTerminating arg-0 u--init u--g) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (vector 1 (vector 0 (vector 2 (vector 2 u--init u--g)))))))))))))))))) eff-0) ext-0))))))))))
(define CoreC-45TerminationC-45SizeChange-initWork (lambda (arg-0 arg-1 arg-2) (lambda (eta-0) (CoreC-45TerminationC-45SizeChange-addFunctions arg-0 arg-1 (cons arg-2 '()) (LibrariesC-45DataC-45NameMap-insert (let ((e-1 (vector-ref arg-2 1))) e-1) (cons (let ((e-0 (vector-ref arg-2 0))) e-0) (let ((e-1 (vector-ref arg-2 1))) e-1)) LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45SortedSet-empty (vector (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-832 csegen-2334 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-832 csegen-2334 arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-861 csegen-2345 arg-1626 arg-1629))))) eta-0))))
(define CoreC-45ContextC-45Context-refersTo (lambda (arg-0) (PreludeC-45Types-maybe (lambda () LibrariesC-45DataC-45NameMap-empty) (lambda () (lambda (eta-0) eta-0)) (let ((e-13 (vector-ref arg-0 13))) e-13))))
(define LibrariesC-45DataC-45SortedSet-u--foldl_Foldable_SortedSet (lambda (arg-2 arg-3 arg-4) (PreludeC-45Types-u--foldl_Foldable_List arg-2 arg-3 (LibrariesC-45DataC-45SortedSet-toList arg-4))))
(define CoreC-45TerminationC-45SizeChange-foldl (lambda (arg-1 arg-2 ext-0) (LibrariesC-45DataC-45NameMap-foldlNames (lambda (u--acc) (lambda (u--f) (lambda (eta-0) (LibrariesC-45DataC-45NameMap-foldlNames (lambda (acc-0) (lambda (u--g) (lambda (eta-1) (LibrariesC-45DataC-45SortedSet-u--foldl_Foldable_SortedSet (lambda (acc-1) (lambda (u--c) ((((arg-1 acc-1) u--f) u--g) u--c))) acc-0 eta-1)))) u--acc eta-0)))) arg-2 ext-0)))
(define CoreC-45TerminationC-45SizeChange-lookupMap (lambda (arg-1 arg-2) (DataC-45Maybe-fromMaybe (lambda () LibrariesC-45DataC-45NameMap-empty) (LibrariesC-45DataC-45NameMap-lookup arg-1 arg-2))))
(define CoreC-45TerminationC-45SizeChange-insertGraph (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--s_f (CoreC-45TerminationC-45SizeChange-lookupMap arg-0 arg-3))) (let ((u--s_fg (CoreC-45TerminationC-45SizeChange-lookupSet csegen-2299 arg-1 u--s_f))) (LibrariesC-45DataC-45NameMap-insert arg-0 (LibrariesC-45DataC-45NameMap-insert arg-1 (LibrariesC-45DataC-45SortedSet-insert arg-2 u--s_fg) u--s_f) arg-3)))))
(define CoreC-45TerminationC-45SizeChange-composeGraph (lambda (arg-0 arg-1) (cons (CoreC-45TerminationC-45SizeChange-composeChange (let ((e-0 (car arg-0))) e-0) (let ((e-0 (car arg-1))) e-0)) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-1 (cdr arg-0))) e-1) (let ((e-1 (cdr arg-1))) e-1)))))
(define CoreC-45TerminationC-45SizeChange-lookupGraphs (lambda (arg-0 arg-1 ext-0) (CoreC-45TerminationC-45SizeChange-lookupSet csegen-2299 arg-1 (CoreC-45TerminationC-45SizeChange-lookupMap arg-0 ext-0))))
(define CoreC-45TerminationC-45SizeChange-postCompose (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((u--ch (CoreC-45TerminationC-45SizeChange-composeGraph arg-6 arg-1))) (let ((sc0 (LibrariesC-45DataC-45SortedSet-contains u--ch (CoreC-45TerminationC-45SizeChange-lookupGraphs arg-4 arg-0 arg-2)))) (cond ((equal? sc0 1) arg-3) (else (LibrariesC-45DataC-45SortedSet-insert (cons arg-4 (cons arg-0 u--ch)) arg-3)))))))
(define CoreC-45TerminationC-45SizeChange-preCompose (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((u--ch (CoreC-45TerminationC-45SizeChange-composeGraph arg-1 arg-6))) (let ((sc0 (LibrariesC-45DataC-45SortedSet-contains u--ch (CoreC-45TerminationC-45SizeChange-lookupGraphs arg-0 arg-5 arg-2)))) (cond ((equal? sc0 1) arg-3) (else (LibrariesC-45DataC-45SortedSet-insert (cons arg-0 (cons arg-5 u--ch)) arg-3)))))))
(define CoreC-45TerminationC-45SizeChange-selectCod (lambda (arg-0 arg-1) (LibrariesC-45DataC-45NameMap-u--map_Functor_NameMap (lambda (u--m) (LibrariesC-45DataC-45NameMap-insert arg-0 (CoreC-45TerminationC-45SizeChange-lookupSet csegen-2299 arg-0 u--m) LibrariesC-45DataC-45NameMap-empty)) arg-1)))
(define CoreC-45TerminationC-45SizeChange-selectDom (lambda (arg-0 arg-1) (LibrariesC-45DataC-45NameMap-insert arg-0 (CoreC-45TerminationC-45SizeChange-lookupMap arg-0 arg-1) LibrariesC-45DataC-45NameMap-empty)))
(define CoreC-45TerminationC-45SizeChange-addGraph (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--s (CoreC-45TerminationC-45SizeChange-insertGraph arg-1 arg-2 arg-3 arg-5))) (let ((u--after (CoreC-45TerminationC-45SizeChange-selectDom arg-2 u--s))) (let ((u--work_pre (CoreC-45TerminationC-45SizeChange-foldl (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45TerminationC-45SizeChange-preCompose arg-1 arg-3 u--s eta-0 eta-1 eta-2 eta-3))))) arg-4 u--after))) (let ((u--before (CoreC-45TerminationC-45SizeChange-selectCod arg-1 u--s))) (let ((u--work_post (CoreC-45TerminationC-45SizeChange-foldl (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (CoreC-45TerminationC-45SizeChange-postCompose arg-2 arg-3 u--s eta-0 eta-1 eta-2 eta-3))))) u--work_pre u--before))) (CoreC-45TerminationC-45SizeChange-transitiveClosure arg-0 u--work_post u--s))))))))
(define LibrariesC-45DataC-45SortedMap-treeMin (lambda (arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (cons e-3 e-4)))) ((1) (let ((e-9 (vector-ref arg-4 1))) (LibrariesC-45DataC-45SortedMap-treeMin e-9))) (else (let ((e-16 (vector-ref arg-4 1))) (LibrariesC-45DataC-45SortedMap-treeMin e-16))))))
(define LibrariesC-45DataC-45SortedMap-min (lambda (arg-2) (case (vector-ref arg-2 0) ((0) '()) (else (let ((e-7 (vector-ref arg-2 3))) (box (LibrariesC-45DataC-45SortedMap-treeMin e-7)))))))
(define LibrariesC-45DataC-45SortedMap-pop (lambda (arg-2) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45SortedMap-min arg-2) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (box (cons (cons e-2 e-3) (LibrariesC-45DataC-45SortedMap-delete e-2 arg-2)))))))))
(define LibrariesC-45DataC-45SortedSet-pop (lambda (arg-1) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45SortedMap-pop arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-2))) (box (cons e-6 e-3)))))))))
(define CoreC-45TerminationC-45SizeChange-transitiveClosure (lambda (arg-0 arg-1 arg-2) (let ((sc0 (LibrariesC-45DataC-45SortedSet-pop arg-1))) (if (null? sc0) arg-2 (let ((e-2 (unbox sc0))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (CoreC-45TerminationC-45SizeChange-addGraph arg-0 e-9 e-13 e-14 e-6 arg-2))))))))))))
(define CoreC-45Name-caseFn (lambda (arg-0) (case (vector-ref arg-0 0) ((6) 1) ((4) (let ((e-3 (vector-ref arg-0 2))) (CoreC-45Name-caseFn e-3))) ((0) (let ((e-5 (vector-ref arg-0 2))) (CoreC-45Name-caseFn e-5)))(else 0))))
(define CoreC-45TerminationC-45SizeChange-n--9909-6821-u--addCasesC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45NameMap-keys arg-4))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-4))) (if (null? sc1) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getFullName arg-2 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc3 (CoreC-45Name-caseFn e-5))) (cond ((equal? sc3 1) (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-3 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (CoreC-45TerminationC-45SizeChange-n--9909-6821-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-insert e-2 (vector 0 ) arg-4) e-3) (let ((e-1 (unbox e-6))) (CoreC-45TerminationC-45SizeChange-n--9909-6821-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-insert e-2 (vector 0 ) arg-4) (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1)) e-3)))))) eff-0) eta-1))))))) (else (CoreC-45TerminationC-45SizeChange-n--9909-6821-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-insert e-2 (vector 0 ) arg-4) e-3)))))) eff-0) eta-0)))))) (CoreC-45TerminationC-45SizeChange-n--9909-6821-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 arg-4 e-3))))))))
(define CoreC-45TerminationC-45SizeChange-n--9909-6820-u--addCases (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CoreC-45TerminationC-45SizeChange-n--9909-6821-u--addCasesC-39 arg-0 arg-1 arg-2 arg-3 LibrariesC-45DataC-45NameMap-empty arg-4)))
(define CoreC-45TerminationC-45SizeChange-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcTerminating-7137 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 (vector 1 ))) (let ((e-2 (unbox arg-11))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name (let ((e-1 (vector-ref arg-4 1))) e-1) e-5))) (cond ((equal? sc2 1) (vector 1 (vector 2 (vector 3 (let ((e-1 (cdr e-6))) e-1))))) (else (let ((act-1 (CoreC-45Context-setTerminating arg-2 (vector 2 ) e-5 (vector 2 (vector 3 (let ((e-1 (cdr e-6))) e-1))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((u--init (CoreC-45TerminationC-45SizeChange-prefixCallSeq arg-8 e-5))) (let ((act-2 ((CoreC-45TerminationC-45SizeChange-setPrefixTerminating arg-2 u--init e-5) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (vector 2 (vector 2 u--init e-5))))))))))))))))))))
(define CoreC-45TerminationC-45SizeChange-calcTerminating (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality.termination.calc" 7 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Calculating termination: " (CoreC-45Name-u--show_Show_Name e-6)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 clam-0) (let ((e-1 (unbox e-7))) (let ((act-4 (let ((act-4 ((CoreC-45TerminationC-45SizeChange-n--9909-6820-u--addCases arg-2 arg-1 arg-0 e-5 (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45TerminationC-45References-totRefs arg-0 e-5 (DataC-45List-nub csegen-832 e-8) eta-1)))) eff-0) clam-0))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((_-0 (box e-1))) (lambda (clam-1) (case (vector-ref e-8 0) ((1) (let ((act-5 ((CoreC-45TerminationC-45SizeChange-initWork arg-0 e-5 e-1) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((_-1 (vector 1 ))) (case (vector-ref e-9 0) ((1) (let ((e-2 (vector-ref e-9 1))) (let ((e-11 (car e-2))) (let ((e-10 (cdr e-2))) (let ((u--s (CoreC-45TerminationC-45SizeChange-transitiveClosure arg-0 e-11 CoreC-45TerminationC-45SizeChange-initSCSet))) (let ((_-2 (vector 1 (cons e-11 e-10)))) (CoreC-45TerminationC-45SizeChange-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcTerminating-7137 arg-2 arg-1 arg-0 e-5 e-1 _-0 _-1 e-11 e-10 _-2 u--s (CoreC-45TerminationC-45SizeChange-findNonTerminatingLoop u--s)))))))) (else (let ((e-10 (vector-ref e-9 1))) (lambda (eta-1) (vector 1 e-10)))))))) eff-0) clam-1))))))(else (vector 1 e-8))))))) eff-0) clam-0)))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Termination-case--checkTerminating-13992 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((act-1 (CoreC-45TerminationC-45SizeChange-calcTerminating arg-2 arg-1 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-setTerminating arg-2 arg-1 arg-0 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) ext-0))))))(else (vector 1 arg-4)))))
(define CoreC-45Termination-checkTerminating (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-getTotality arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality.termination" 6 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Checking termination: " (CoreC-45Name-u--show_Show_Name e-6)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Termination-case--checkTerminating-13992 arg-2 arg-1 arg-0 e-5 (let ((e-0 (car e-5))) e-0) eta-0))))))) eff-0) ext-0)))))))
(define CoreC-45Termination-case--caseC-32blockC-32inC-32checkTotal-14236 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-7 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (PreludeC-45Types-u--map_Functor_Maybe csegen-1315 e-5))) (if (null? sc2) (lambda (eta-0) (let ((act-2 (let ((sc3 (PreludeC-45Basics-flip csegen-2286 csegen-2287 e-5))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-1 (unbox sc3))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-2 csegen-54 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys e-1) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-log arg-2 "totality" 5 (lambda () (string-append "  Mutually defined with:" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-6))) eta-1)))) eff-0) eta-0)))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Termination-checkTerminating arg-2 arg-1 arg-5 eta-0))))) (let ((e-1 (unbox sc2))) (lambda (clam-0) (case (vector-ref e-1 0) ((6) (CoreC-45Termination-checkPositive arg-2 arg-1 arg-5 clam-0))(else (let ((act-2 (let ((sc3 (PreludeC-45Basics-flip csegen-2286 csegen-2287 e-5))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-2 (unbox sc3))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-toFullNames arg-2 csegen-54 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys e-2) '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-log arg-2 "totality" 5 (lambda () (string-append "  Mutually defined with:" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-6))) eta-0)))) eff-0) clam-0)))))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Termination-checkTerminating arg-2 arg-1 arg-5 clam-0)))))))))))) eff-0) ext-0))))))(else (vector 1 arg-8)))))
(define CoreC-45Termination-case--checkTotal-14176 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45Context-undefinedName arg-2 arg-1 arg-0 eta-0)) (let ((e-1 (unbox arg-4))) (let ((u--n (vector 8 e-1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getTotality arg-2 arg-1 u--n eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "totality" 5 (lambda (eta-2) (let ((act-2 (CoreC-45Context-toFullNames arg-2 csegen-54 u--n eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (string-append "Checking totality: " (CoreC-45Name-u--show_Show_Name e-6)))))) eff-0) eta-2)))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Termination-case--caseC-32blockC-32inC-32checkTotal-14236 arg-0 arg-1 arg-2 arg-3 e-1 u--n e-5 e-7 (let ((e-0 (car e-5))) e-0) eta-2)))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))))
(define CoreC-45Termination-checkTotal (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Termination-case--checkTotal-14176 arg-2 arg-1 arg-0 e-5 (CoreC-45Context-getNameID arg-2 (let ((e-0 (vector-ref e-5 0))) e-0))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDeclsC-45Totality-n--6913-13421-u--checkTotality (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45ContextC-45Log-logTime arg-1 3 (lambda () (string-append "Checking Termination " (CoreC-45Name-u--show_Show_Name arg-0))) (lambda (eta-1) (CoreC-45Termination-checkTotal arg-1 arg-2 arg-0 eta-1)) eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Context-getTotality arg-1 arg-2 arg-0 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45ProcessDeclsC-45Totality-n--6913-13420-u--checkCovering arg-0 arg-1 arg-2 (let ((e-1 (cdr e-6))) e-1) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (PreludeC-45Types-maybe (let ((e-0 (car e-6))) (case (vector-ref e-0 0) ((2) (let ((e-2 (vector-ref e-0 1))) (lambda () (lambda (eta-1) (vector 1 (box (vector 12 arg-2 arg-0 e-2)))))))(else (lambda () (lambda (eta-1) (vector 1 '())))))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 (box eta-1))))) e-7))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessDeclsC-45Totality-checkTotalityOK (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((2) (vector 1 '())) ((6) (vector 1 '()))(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-35 (vector-ref e-5 0))) e-35)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-2 (unbox e-6))) (let ((u--fc (let ((e-27 (vector-ref e-2 0))) e-27))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-getDefaultTotalityOption arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--treq (DataC-45Maybe-fromMaybe (lambda () e-7) (CoreC-45ContextC-45Context-findSetTotal (let ((e-12 (vector-ref e-2 12))) e-12))))) (lambda (eta-2) (let ((act-4 (let ((e-18 (vector-ref e-2 18))) (case (vector-ref e-18 0) ((6) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Termination-checkPositive arg-0 u--fc arg-1 eta-3)) eta-2))(else (vector 1 (vector 0 ))))))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((u--tot (let ((e-10 (vector-ref e-2 10))) e-10))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-0 "totality" 3 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-1) (string-append " must be: " (CoreC-45TT-u--show_Show_TotalReq u--treq)))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (cond ((equal? u--treq 2) (vector 1 '())) ((equal? u--treq 1) (TTImpC-45ProcessDeclsC-45Totality-n--6913-13420-u--checkCovering arg-1 arg-0 u--fc (let ((e-3 (cdr u--tot))) e-3) eta-2)) (else (TTImpC-45ProcessDeclsC-45Totality-n--6913-13421-u--checkTotality arg-1 arg-0 u--fc eta-2)))))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-1 (unbox e-6))) (let ((u--fc (let ((e-0 (vector-ref e-1 0))) e-0))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-getDefaultTotalityOption arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--treq (DataC-45Maybe-fromMaybe (lambda () e-7) (CoreC-45ContextC-45Context-findSetTotal (let ((e-12 (vector-ref e-1 12))) e-12))))) (lambda (eta-2) (let ((act-4 (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((6) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Termination-checkPositive arg-0 u--fc arg-1 eta-3)) eta-2))(else (vector 1 (vector 0 ))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--tot (let ((e-10 (vector-ref e-1 10))) e-10))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-0 "totality" 3 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-1) (string-append " must be: " (CoreC-45TT-u--show_Show_TotalReq u--treq)))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (cond ((equal? u--treq 2) (vector 1 '())) ((equal? u--treq 1) (TTImpC-45ProcessDeclsC-45Totality-n--6913-13420-u--checkCovering arg-1 arg-0 u--fc (let ((e-2 (cdr u--tot))) e-2) eta-2)) (else (TTImpC-45ProcessDeclsC-45Totality-n--6913-13421-u--checkTotality arg-1 arg-0 u--fc eta-2)))))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))
(define TTImpC-45ProcessDeclsC-45Totality-getTotalityErrors (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45ProcessDeclsC-45Totality-checkTotalityOK arg-0 eta-1)) (LibrariesC-45DataC-45NameMap-keys (let ((e-33 (vector-ref e-5 5))) e-33)) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-2) eta-2) e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addDirective (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) arg-1))) (if (null? sc1) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "Unknown code generator " arg-1) "\xa;") clam-0))) (vector 1 act-2)) (let ((e-2 (unbox sc1))) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-34 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 (cons (cons e-2 arg-2) e-20) e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-addDocString (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-0 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "doc.record" 50 (lambda () (string-append "Adding doc for " (string-append (CoreC-45Name-u--show_Show_Name arg-2) (string-append " (aka " (string-append (CoreC-45Name-u--show_Show_Name e-5) " in current NS)"))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-1))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-1 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-14 (vector-ref e-7 5))) (let ((e-13 (vector-ref e-7 6))) (let ((e-12 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (vector e-0 e-1 e-2 e-3 e-4 e-14 (LibrariesC-45DataC-45NameMap-insert e-5 (vector 0 ) e-13) (LibrariesC-45DataC-45ANameMap-addName e-5 arg-3 e-12) e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-0))))))) eff-0) ext-0)))))))
(define CoreC-45Context-getVisibility (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 arg-1 arg-2) clam-0) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-9 (vector-ref e-1 9))) e-9))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TT-u--C-47C-61_Eq_Visibility (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-61C-61_Eq_Visibility arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Context-ambiguousName (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45Core-filterM (lambda (u--x) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 e-5)))))) (lambda (eta-1) (CoreC-45Context-getVisibility arg-1 arg-2 u--x eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Visibility e-5 0))))) eff-0) eta-0))))))) arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (CoreC-45Context-undefinedName arg-1 arg-2 arg-3 eta-0)) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 17 arg-2 e-5) eta-0))))) eff-0) ext-0)))))))
(define CoreC-45Context-lookupNameBy (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtName arg-2 arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons e-6 (arg-1 e-7)))))))) e-5))))) eff-0) ext-0)))))))
(define CoreC-45Context-lookupDefName (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupNameBy csegen-1315 ext-2 ext-1 ext-0)))
(define CoreC-45Context-checkUnambig (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-7 (cdr e-1))) (if (null? e-7) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-9 (car e-7))) (lambda (clam-0) (if (null? e-2) (vector 1 (vector 8 e-9)) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-0)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addNameDirective (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (LibrariesC-45DataC-45NameMap-insert e-5 arg-3 e-15) e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) ext-0)))))))
(define PreludeC-45TypesC-45List-filter (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (cons e-2 (PreludeC-45TypesC-45List-filter arg-1 e-3))) (else (PreludeC-45TypesC-45List-filter arg-1 e-3)))))))))
(define TTImpC-45TTImp-mapAltType (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((2) (let ((e-1 (vector-ref arg-2 1))) (vector 2 (arg-1 e-1))))(else arg-2))))
(define TTImpC-45TTImp-mapFieldUpdateTerm (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (vector 0 e-1 (arg-1 e-2))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (vector 1 e-4 (arg-1 e-5))))))))
(define TTImpC-45BindImplicits-doBind (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((1) (let ((e-68 (vector-ref e-2 1))) (case (vector-ref e-68 0) ((0) (let ((e-69 (vector-ref e-68 1))) (PreludeC-45Types-maybe (lambda () (vector 0 e-1 e-2)) (lambda () (lambda (eta-0) (vector 17 e-1 eta-0))) (DataC-45List-lookup csegen-22 e-69 arg-0))))(else arg-1))))(else arg-1))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (let ((u--nsC-39 (if (null? e-7) arg-0 (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (PreludeC-45TypesC-45List-filter (lambda (u--x) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (Builtin-fst u--x) e-3)) arg-0)))(else arg-0))))(else arg-0)))))) (vector 1 e-4 e-5 e-6 e-7 (TTImpC-45BindImplicits-doBind u--nsC-39 e-8) (TTImpC-45BindImplicits-doBind u--nsC-39 e-9)))))))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (let ((u--nsC-39 (if (null? e-14) arg-0 (let ((e-1 (unbox e-14))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (PreludeC-45TypesC-45List-filter (lambda (u--x) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (Builtin-fst u--x) e-3)) arg-0)))(else arg-0))))(else arg-0)))))) (vector 2 e-11 e-12 e-13 e-14 (TTImpC-45BindImplicits-doBind u--nsC-39 e-15) (TTImpC-45BindImplicits-doBind u--nsC-39 e-16)))))))))) ((8) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (vector 8 e-18 (TTImpC-45BindImplicits-doBind arg-0 e-19) (TTImpC-45BindImplicits-doBind arg-0 e-20)))))) ((9) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (let ((e-24 (vector-ref arg-1 3))) (vector 9 e-22 (TTImpC-45BindImplicits-doBind arg-0 e-23) (TTImpC-45BindImplicits-doBind arg-0 e-24)))))) ((10) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (vector 10 e-26 (TTImpC-45BindImplicits-doBind arg-0 e-27) e-28 (TTImpC-45BindImplicits-doBind arg-0 e-29))))))) ((11) (let ((e-31 (vector-ref arg-1 1))) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (vector 11 e-31 (TTImpC-45BindImplicits-doBind arg-0 e-32) (TTImpC-45BindImplicits-doBind arg-0 e-33)))))) ((18) (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (let ((e-37 (vector-ref arg-1 3))) (let ((e-38 (vector-ref arg-1 4))) (let ((e-39 (vector-ref arg-1 5))) (vector 18 e-35 e-36 e-37 e-38 (TTImpC-45BindImplicits-doBind arg-0 e-39)))))))) ((19) (let ((e-41 (vector-ref arg-1 1))) (let ((e-42 (vector-ref arg-1 2))) (let ((e-43 (vector-ref arg-1 3))) (vector 19 e-41 e-42 (TTImpC-45BindImplicits-doBind arg-0 e-43)))))) ((20) (let ((e-45 (vector-ref arg-1 1))) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (vector 20 e-45 e-46 (TTImpC-45BindImplicits-doBind arg-0 e-47)))))) ((21) (let ((e-49 (vector-ref arg-1 1))) (let ((e-50 (vector-ref arg-1 2))) (vector 21 e-49 (TTImpC-45BindImplicits-doBind arg-0 e-50))))) ((22) (let ((e-52 (vector-ref arg-1 1))) (let ((e-53 (vector-ref arg-1 2))) (vector 22 e-52 (TTImpC-45BindImplicits-doBind arg-0 e-53))))) ((23) (let ((e-55 (vector-ref arg-1 1))) (let ((e-56 (vector-ref arg-1 2))) (vector 23 e-55 (TTImpC-45BindImplicits-doBind arg-0 e-56))))) ((26) (let ((e-58 (vector-ref arg-1 1))) (let ((e-59 (vector-ref arg-1 2))) (vector 26 e-58 (TTImpC-45BindImplicits-doBind arg-0 e-59))))) ((13) (let ((e-61 (vector-ref arg-1 1))) (let ((e-62 (vector-ref arg-1 2))) (let ((e-63 (vector-ref arg-1 3))) (vector 13 e-61 (TTImpC-45TTImp-mapAltType (lambda (eta-0) (TTImpC-45BindImplicits-doBind arg-0 eta-0)) e-62) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45BindImplicits-doBind arg-0 eta-0)) e-63)))))) ((7) (let ((e-65 (vector-ref arg-1 1))) (let ((e-66 (vector-ref arg-1 2))) (let ((e-67 (vector-ref arg-1 3))) (vector 7 e-65 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-mapFieldUpdateTerm (lambda (eta-1) (TTImpC-45BindImplicits-doBind arg-0 eta-1)) eta-0)) e-66) (TTImpC-45BindImplicits-doBind arg-0 e-67))))))(else arg-1)))))
(define CoreC-45Context-isUnboundImplicits (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 3))) (let ((e-49 (vector-ref e-40 1))) e-49))))))) eff-0) ext-0)))))))
(define TTImpC-45BindImplicits-bindNames (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-isUnboundImplicits arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (let ((u--ns (DataC-45List-nub csegen-2536 (TTImpC-45Utils-findBindableNames arg-1 '() '() arg-2)))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "elab.bindnames" 10 (lambda () (string-append "Found names :" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2689 u--ns))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (cons (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 1 (vector 0 eta-1))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) u--ns)) (TTImpC-45BindImplicits-doBind u--ns arg-2))))))))) (else (lambda (eta-0) (vector 1 (cons '() arg-2))))))) eff-0) ext-0)))))))
(define TTImpC-45TTImp-getFC (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-4 (vector-ref arg-1 1))) e-4)) ((2) (let ((e-11 (vector-ref arg-1 1))) e-11)) ((3) (let ((e-18 (vector-ref arg-1 1))) e-18)) ((4) (let ((e-26 (vector-ref arg-1 1))) e-26)) ((5) (let ((e-32 (vector-ref arg-1 1))) e-32)) ((6) (let ((e-36 (vector-ref arg-1 1))) e-36)) ((7) (let ((e-42 (vector-ref arg-1 1))) e-42)) ((8) (let ((e-46 (vector-ref arg-1 1))) e-46)) ((10) (let ((e-50 (vector-ref arg-1 1))) e-50)) ((9) (let ((e-55 (vector-ref arg-1 1))) e-55)) ((11) (let ((e-59 (vector-ref arg-1 1))) e-59)) ((12) (let ((e-63 (vector-ref arg-1 1))) e-63)) ((13) (let ((e-66 (vector-ref arg-1 1))) e-66)) ((14) (let ((e-70 (vector-ref arg-1 1))) e-70)) ((15) (let ((e-74 (vector-ref arg-1 1))) e-74)) ((28) (let ((e-77 (vector-ref arg-1 1))) e-77)) ((30) (let ((e-80 (vector-ref arg-1 1))) e-80)) ((31) (let ((e-83 (vector-ref arg-1 1))) e-83)) ((29) (let ((e-87 (vector-ref arg-1 1))) e-87)) ((17) (let ((e-89 (vector-ref arg-1 1))) e-89)) ((16) (let ((e-92 (vector-ref arg-1 1))) e-92)) ((19) (let ((e-96 (vector-ref arg-1 1))) e-96)) ((20) (let ((e-100 (vector-ref arg-1 1))) e-100)) ((21) (let ((e-104 (vector-ref arg-1 1))) e-104)) ((22) (let ((e-107 (vector-ref arg-1 1))) e-107)) ((23) (let ((e-110 (vector-ref arg-1 1))) e-110)) ((24) (let ((e-113 (vector-ref arg-1 1))) e-113)) ((25) (let ((e-116 (vector-ref arg-1 1))) e-116)) ((26) (let ((e-119 (vector-ref arg-1 1))) e-119)) ((27) (let ((e-122 (vector-ref arg-1 1))) e-122)) ((18) (let ((e-126 (vector-ref arg-1 1))) e-126)) ((32) (let ((e-132 (vector-ref arg-1 1))) e-132)) (else (let ((e-135 (vector-ref arg-1 1))) e-135)))))
(define TTImpC-45BindImplicits-bindUsings (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 (TTImpC-45TTImp-getFC e-15) e-6 e-10 e-14 e-15 (TTImpC-45BindImplicits-bindUsings e-3 arg-1)))))))))))))
(define TTImpC-45Utils-findIBindVars (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-5) (TTImpC-45Utils-findIBindVars e-6))))) ((2) (let ((e-12 (vector-ref arg-0 5))) (let ((e-13 (vector-ref arg-0 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-12) (TTImpC-45Utils-findIBindVars e-13))))) ((8) (let ((e-16 (vector-ref arg-0 2))) (let ((e-17 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-16) (TTImpC-45Utils-findIBindVars e-17))))) ((10) (let ((e-20 (vector-ref arg-0 2))) (let ((e-22 (vector-ref arg-0 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-20) (TTImpC-45Utils-findIBindVars e-22))))) ((9) (let ((e-25 (vector-ref arg-0 2))) (let ((e-26 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-25) (TTImpC-45Utils-findIBindVars e-26))))) ((11) (let ((e-29 (vector-ref arg-0 2))) (let ((e-30 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-29) (TTImpC-45Utils-findIBindVars e-30))))) ((17) (let ((e-33 (vector-ref arg-0 2))) (cons (vector 1 (vector 0 e-33)) '()))) ((20) (let ((e-37 (vector-ref arg-0 3))) (TTImpC-45Utils-findIBindVars e-37))) ((21) (let ((e-40 (vector-ref arg-0 2))) (TTImpC-45Utils-findIBindVars e-40))) ((22) (let ((e-43 (vector-ref arg-0 2))) (TTImpC-45Utils-findIBindVars e-43))) ((13) (let ((e-47 (vector-ref arg-0 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findIBindVars eta-0)) e-47))) ((7) (let ((e-50 (vector-ref arg-0 2))) (let ((e-51 (vector-ref arg-0 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-51) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45Utils-findIBindVars (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-50)))))(else '()))))
(define TTImpC-45BindImplicits-getUsing (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-10) (let ((u--ns (DataC-45List-nub csegen-832 (TTImpC-45Utils-findIBindVars e-11)))) (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-832 arg-0 u--ns))) (cond ((equal? sc4 1) (cons (cons e-6 (cons AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (cons (vector 2 ) (cons '() e-11)))) (TTImpC-45BindImplicits-getUsing arg-0 e-3))) (else (TTImpC-45BindImplicits-getUsing arg-0 e-3))))) (let ((e-13 (unbox e-10))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name arg-0 e-13))) (cond ((equal? sc4 1) (cons (cons e-6 (cons csegen-30 (cons (vector 0 ) (cons (box arg-0) e-11)))) (TTImpC-45BindImplicits-getUsing arg-0 e-3))) (else (TTImpC-45BindImplicits-getUsing arg-0 e-3)))))))))))))))
(define TTImpC-45BindImplicits-getUsings (lambda (arg-0 arg-1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (TTImpC-45BindImplicits-getUsing eta-1 eta-2))) arg-1 eta-0)) arg-0)))
(define TTImpC-45BindImplicits-n--8791-7383-u--tag (lambda (arg-0 arg-1 arg-3 arg-4) (DataC-45List-u--zip_Zippable_List (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-2) (bs+ arg-2 arg-3 63)) (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 0 (blodwen-toSignedInt (PreludeC-45TypesC-45List-lengthTR arg-4) 63))) arg-4)))
(define TTImpC-45BindImplicits-addUsing (lambda (arg-0 arg-1) (let ((u--ns (DataC-45List-nub csegen-832 (TTImpC-45Utils-findIBindVars arg-1)))) (let ((u--bs (DataC-45List-nubBy (lambda (u--x) (lambda (u--y) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (Builtin-fst u--x) (Builtin-fst u--y)))) (TTImpC-45BindImplicits-getUsings u--ns (TTImpC-45BindImplicits-n--8791-7383-u--tag arg-1 arg-0 0 arg-0))))) (TTImpC-45BindImplicits-bindUsings (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) u--bs) arg-1)))))
(define DataC-45List1-fromList (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (box (cons e-2 e-3)))))))
(define TTImpC-45Utils-findUniqueBindableNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--assoc (DataC-45List-nub csegen-2536 (TTImpC-45Utils-findBindableNames arg-2 arg-3 arg-4 arg-5)))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (let ((e-20 (vector-ref e-5 20))) e-20))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ctxt (let ((e-0 (vector-ref e-6 0))) e-0))) (lambda (eta-1) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-55 (PreludeC-45Basics-flip csegen-1298 u--assoc (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((act-3 ((CoreC-45Context-lookupCtxtName (vector 1 (vector 0 e-2)) u--ctxt) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--ns (PreludeC-45Basics-flip csegen-1631 e-7 (lambda (lamc-1) (let ((e-8 (car lamc-1))) (let ((e-4 (cdr lamc-1))) (let ((e-9 (cdr e-4))) (let ((e-18 (vector-ref e-9 18))) (case (vector-ref e-18 0) ((7) '())(else (box e-8))))))))))) (lambda (eta-2) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-3) (cons e-2 eta-3)) (DataC-45List1-fromList u--ns))))))) eff-0) clam-1))))))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc4 (DataC-45List1-fromList e-7))) (if (null? sc4) (lambda (eta-2) (vector 1 (vector 0 ))) (let ((e-1 (unbox sc4))) (CoreC-45Context-recordWarning arg-0 (vector 2 arg-1 e-1))))))) eff-0) eta-1))))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 )))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 u--assoc))))))))
(define TTImpC-45BindImplicits-bindTypeNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-isUnboundImplicits arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 ((TTImpC-45Utils-findUniqueBindableNames arg-0 arg-1 1 arg-3 '() arg-4) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--btm (TTImpC-45BindImplicits-doBind e-6 arg-4))) (lambda (eta-0) (vector 1 (TTImpC-45BindImplicits-addUsing arg-2 u--btm)))))) eff-0) clam-0)))))) (else (vector 1 arg-4)))))) eff-0) ext-0)))))))
(define DataC-45List-tails (lambda (arg-1) (cons arg-1 (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (DataC-45List-tails e-3))))))
(define DataC-45List-isInfixOfBy (lambda (arg-2 arg-3 arg-4) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (DataC-45List-isPrefixOfBy arg-2 arg-3 eta-0)) (DataC-45List-tails arg-4))))
(define DataC-45List-isInfixOf (lambda (arg-1 ext-0 ext-1) (DataC-45List-isInfixOfBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define DataC-45String-isInfixOf (lambda (arg-0 arg-1) (DataC-45List-isInfixOf csegen-17 (PreludeC-45Types-fastUnpack arg-0) (PreludeC-45Types-fastUnpack arg-1))))
(define CoreC-45Core-killWarningLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (vector 0 CoreC-45FC-emptyFC e-1))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 4))) (vector 1 e-2 CoreC-45FC-emptyFC e-4 e-5))))) ((2) (let ((e-7 (vector-ref arg-0 2))) (vector 2 CoreC-45FC-emptyFC e-7))) ((3) (let ((e-9 (vector-ref arg-0 2))) (let ((e-10 (vector-ref arg-0 3))) (let ((e-11 (vector-ref arg-0 4))) (vector 3 CoreC-45FC-emptyFC e-9 e-10 e-11))))) ((4) (let ((e-13 (vector-ref arg-0 2))) (vector 4 CoreC-45FC-emptyFC (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (cons CoreC-45FC-emptyFC CoreC-45FC-emptyFC))))) e-13)))) ((5) (let ((e-15 (vector-ref arg-0 2))) (let ((e-16 (vector-ref arg-0 3))) (vector 5 CoreC-45FC-emptyFC e-15 (PreludeC-45Types-u--map_Functor_Maybe csegen-1007 e-16))))) (else (let ((e-18 (vector-ref arg-0 2))) (vector 6 CoreC-45FC-emptyFC e-18))))))
(define CoreC-45Core-killErrorLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (vector 0 (CoreC-45Core-killErrorLoc e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (vector 1 e-1 CoreC-45FC-emptyFC e-3 e-4 e-5 e-6))))))) ((2) (let ((e-7 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 3))) (let ((e-10 (vector-ref arg-0 4))) (let ((e-11 (vector-ref arg-0 5))) (let ((e-12 (vector-ref arg-0 6))) (vector 2 e-7 CoreC-45FC-emptyFC e-9 e-10 e-11 e-12))))))) ((3) (let ((e-13 (vector-ref arg-0 1))) (let ((e-16 (vector-ref arg-0 4))) (let ((e-17 (vector-ref arg-0 5))) (let ((e-18 (vector-ref arg-0 6))) (vector 3 e-13 CoreC-45FC-emptyFC CoreC-45FC-emptyFC e-16 e-17 e-18)))))) ((4) (let ((e-19 (vector-ref arg-0 1))) (let ((e-21 (vector-ref arg-0 3))) (let ((e-22 (vector-ref arg-0 4))) (let ((e-23 (vector-ref arg-0 5))) (vector 4 e-19 CoreC-45FC-emptyFC e-21 e-22 e-23)))))) ((5) (let ((e-24 (vector-ref arg-0 1))) (let ((e-26 (vector-ref arg-0 3))) (let ((e-27 (vector-ref arg-0 4))) (let ((e-28 (vector-ref arg-0 5))) (let ((e-29 (vector-ref arg-0 6))) (let ((e-30 (vector-ref arg-0 7))) (vector 5 e-24 CoreC-45FC-emptyFC e-26 e-27 e-28 e-29 (CoreC-45Core-killErrorLoc e-30))))))))) ((6) (let ((e-31 (vector-ref arg-0 1))) (let ((e-33 (vector-ref arg-0 3))) (let ((e-34 (vector-ref arg-0 4))) (vector 6 e-31 CoreC-45FC-emptyFC e-33 e-34))))) ((7) (let ((e-36 (vector-ref arg-0 2))) (vector 7 CoreC-45FC-emptyFC e-36))) ((8) (let ((e-38 (vector-ref arg-0 2))) (let ((e-39 (vector-ref arg-0 3))) (vector 8 CoreC-45FC-emptyFC e-38 e-39)))) ((9) (let ((e-41 (vector-ref arg-0 2))) (vector 9 CoreC-45FC-emptyFC e-41))) ((10) (let ((e-43 (vector-ref arg-0 2))) (let ((e-44 (vector-ref arg-0 3))) (vector 10 CoreC-45FC-emptyFC e-43 e-44)))) ((11) (let ((e-46 (vector-ref arg-0 2))) (let ((e-47 (vector-ref arg-0 3))) (vector 11 CoreC-45FC-emptyFC e-46 e-47)))) ((12) (let ((e-49 (vector-ref arg-0 2))) (let ((e-50 (vector-ref arg-0 3))) (vector 12 CoreC-45FC-emptyFC e-49 e-50)))) ((13) (let ((e-52 (vector-ref arg-0 2))) (let ((e-53 (vector-ref arg-0 3))) (vector 13 CoreC-45FC-emptyFC e-52 e-53)))) ((14) (let ((e-55 (vector-ref arg-0 2))) (let ((e-56 (vector-ref arg-0 3))) (let ((e-57 (vector-ref arg-0 4))) (vector 14 CoreC-45FC-emptyFC e-55 e-56 e-57))))) ((15) (let ((e-58 (vector-ref arg-0 1))) (let ((e-60 (vector-ref arg-0 3))) (let ((e-61 (vector-ref arg-0 4))) (let ((e-62 (vector-ref arg-0 5))) (vector 15 e-58 CoreC-45FC-emptyFC e-60 e-61 e-62)))))) ((16) (let ((e-63 (vector-ref arg-0 1))) (let ((e-65 (vector-ref arg-0 3))) (let ((e-66 (vector-ref arg-0 4))) (vector 16 e-63 CoreC-45FC-emptyFC e-65 e-66))))) ((17) (let ((e-68 (vector-ref arg-0 2))) (vector 17 CoreC-45FC-emptyFC e-68))) ((18) (let ((e-69 (vector-ref arg-0 1))) (let ((e-71 (vector-ref arg-0 3))) (let ((e-72 (vector-ref arg-0 4))) (vector 18 e-69 CoreC-45FC-emptyFC e-71 e-72))))) ((19) (let ((e-73 (vector-ref arg-0 1))) (let ((e-75 (vector-ref arg-0 3))) (let ((e-76 (vector-ref arg-0 4))) (let ((e-77 (vector-ref arg-0 5))) (vector 19 e-73 CoreC-45FC-emptyFC e-75 e-76 e-77)))))) ((20) (let ((e-79 (vector-ref arg-0 2))) (let ((e-80 (vector-ref arg-0 3))) (vector 20 CoreC-45FC-emptyFC e-79 e-80)))) ((21) (let ((e-81 (vector-ref arg-0 1))) (vector 21 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-2 (CoreC-45Core-killErrorLoc e-3))))) e-81)))) ((22) (let ((e-82 (vector-ref arg-0 1))) (let ((e-84 (vector-ref arg-0 3))) (vector 22 e-82 CoreC-45FC-emptyFC e-84)))) ((23) (let ((e-86 (vector-ref arg-0 2))) (vector 23 CoreC-45FC-emptyFC e-86))) ((24) (let ((e-88 (vector-ref arg-0 2))) (let ((e-89 (vector-ref arg-0 3))) (vector 24 CoreC-45FC-emptyFC e-88 e-89)))) ((25) (let ((e-91 (vector-ref arg-0 2))) (vector 25 CoreC-45FC-emptyFC e-91))) ((26) (let ((e-93 (vector-ref arg-0 2))) (vector 26 CoreC-45FC-emptyFC e-93))) ((27) (let ((e-94 (vector-ref arg-0 1))) (let ((e-96 (vector-ref arg-0 3))) (let ((e-97 (vector-ref arg-0 4))) (let ((e-98 (vector-ref arg-0 5))) (vector 27 e-94 CoreC-45FC-emptyFC e-96 e-97 e-98)))))) ((28) (let ((e-99 (vector-ref arg-0 1))) (let ((e-101 (vector-ref arg-0 3))) (let ((e-102 (vector-ref arg-0 4))) (vector 28 e-99 CoreC-45FC-emptyFC e-101 e-102))))) ((29) (let ((e-103 (vector-ref arg-0 1))) (let ((e-105 (vector-ref arg-0 3))) (let ((e-106 (vector-ref arg-0 4))) (let ((e-107 (vector-ref arg-0 5))) (vector 29 e-103 CoreC-45FC-emptyFC e-105 e-106 e-107)))))) ((30) (let ((e-108 (vector-ref arg-0 1))) (let ((e-110 (vector-ref arg-0 3))) (let ((e-111 (vector-ref arg-0 4))) (let ((e-112 (vector-ref arg-0 5))) (let ((e-113 (vector-ref arg-0 6))) (vector 30 e-108 CoreC-45FC-emptyFC e-110 e-111 e-112 e-113))))))) ((31) (let ((e-114 (vector-ref arg-0 1))) (let ((e-116 (vector-ref arg-0 3))) (let ((e-117 (vector-ref arg-0 4))) (let ((e-118 (vector-ref arg-0 5))) (let ((e-119 (vector-ref arg-0 6))) (vector 31 e-114 CoreC-45FC-emptyFC e-116 e-117 e-118 e-119))))))) ((32) (let ((e-120 (vector-ref arg-0 1))) (vector 32 e-120))) ((33) (let ((e-121 (vector-ref arg-0 1))) (let ((e-123 (vector-ref arg-0 3))) (let ((e-124 (vector-ref arg-0 4))) (let ((e-125 (vector-ref arg-0 5))) (let ((e-126 (vector-ref arg-0 6))) (vector 33 e-121 CoreC-45FC-emptyFC e-123 e-124 e-125 e-126))))))) ((34) (let ((e-127 (vector-ref arg-0 1))) (let ((e-129 (vector-ref arg-0 3))) (let ((e-130 (vector-ref arg-0 4))) (let ((e-131 (vector-ref arg-0 5))) (vector 34 e-127 CoreC-45FC-emptyFC e-129 e-130 e-131)))))) ((35) (let ((e-133 (vector-ref arg-0 2))) (let ((e-134 (vector-ref arg-0 3))) (let ((e-135 (vector-ref arg-0 4))) (let ((e-136 (vector-ref arg-0 5))) (vector 35 CoreC-45FC-emptyFC e-133 e-134 e-135 e-136)))))) ((36) (let ((e-138 (vector-ref arg-0 2))) (vector 36 CoreC-45FC-emptyFC e-138))) ((37) (let ((e-140 (vector-ref arg-0 2))) (vector 37 CoreC-45FC-emptyFC e-140))) ((38) (let ((e-142 (vector-ref arg-0 2))) (vector 38 CoreC-45FC-emptyFC e-142))) ((39) (let ((e-144 (vector-ref arg-0 2))) (vector 39 CoreC-45FC-emptyFC e-144))) ((40) (let ((e-145 (vector-ref arg-0 1))) (let ((e-147 (vector-ref arg-0 3))) (let ((e-148 (vector-ref arg-0 4))) (vector 40 e-145 CoreC-45FC-emptyFC e-147 e-148))))) ((41) (let ((e-149 (vector-ref arg-0 1))) (let ((e-151 (vector-ref arg-0 3))) (let ((e-152 (vector-ref arg-0 4))) (let ((e-153 (vector-ref arg-0 5))) (vector 41 e-149 CoreC-45FC-emptyFC e-151 e-152 e-153)))))) ((42) (let ((e-154 (vector-ref arg-0 1))) (let ((e-156 (vector-ref arg-0 3))) (let ((e-157 (vector-ref arg-0 4))) (vector 42 e-154 CoreC-45FC-emptyFC e-156 e-157))))) ((43) (let ((e-159 (vector-ref arg-0 2))) (let ((e-160 (vector-ref arg-0 3))) (vector 43 CoreC-45FC-emptyFC e-159 e-160)))) ((44) (let ((e-161 (vector-ref arg-0 1))) (let ((e-163 (vector-ref arg-0 3))) (let ((e-164 (vector-ref arg-0 4))) (vector 44 e-161 CoreC-45FC-emptyFC e-163 e-164))))) ((45) (let ((e-165 (vector-ref arg-0 1))) (let ((e-167 (vector-ref arg-0 3))) (let ((e-168 (vector-ref arg-0 4))) (let ((e-169 (vector-ref arg-0 5))) (let ((e-170 (vector-ref arg-0 6))) (vector 45 e-165 CoreC-45FC-emptyFC e-167 e-168 e-169 e-170))))))) ((46) (let ((e-172 (vector-ref arg-0 2))) (vector 46 CoreC-45FC-emptyFC e-172))) ((47) (let ((e-173 (vector-ref arg-0 1))) (let ((e-175 (vector-ref arg-0 3))) (let ((e-176 (vector-ref arg-0 4))) (let ((e-177 (vector-ref arg-0 5))) (vector 47 e-173 CoreC-45FC-emptyFC e-175 e-176 e-177)))))) ((48) (let ((e-178 (vector-ref arg-0 1))) (vector 48 (CoreC-45Core-killErrorLoc e-178)))) ((49) (let ((e-180 (vector-ref arg-0 2))) (vector 49 CoreC-45FC-emptyFC e-180))) ((50) (let ((e-181 (vector-ref arg-0 1))) (vector 50 e-181))) ((51) (let ((e-182 (vector-ref arg-0 1))) (let ((e-183 (vector-ref arg-0 2))) (vector 51 e-182 e-183)))) ((52) (let ((e-184 (vector-ref arg-0 1))) (vector 52 e-184))) ((53) (vector 53 CoreC-45FC-emptyFC)) ((54) (vector 54 CoreC-45FC-emptyFC)) ((55) (vector 55 CoreC-45FC-emptyFC)) ((56) (let ((e-189 (vector-ref arg-0 2))) (vector 56 CoreC-45FC-emptyFC e-189))) ((57) (let ((e-190 (vector-ref arg-0 1))) (vector 57 (DataC-45List1-u--map_Functor_List1 csegen-1007 e-190)))) ((58) (let ((e-192 (vector-ref arg-0 2))) (vector 58 CoreC-45FC-emptyFC e-192))) ((59) (let ((e-193 (vector-ref arg-0 1))) (vector 59 e-193))) ((60) (vector 60 )) ((61) (let ((e-194 (vector-ref arg-0 1))) (vector 61 e-194))) ((62) (let ((e-195 (vector-ref arg-0 1))) (vector 62 e-195))) ((63) (let ((e-197 (vector-ref arg-0 2))) (vector 63 CoreC-45FC-emptyFC e-197))) ((64) (let ((e-199 (vector-ref arg-0 2))) (vector 64 CoreC-45FC-emptyFC e-199))) ((65) (let ((e-200 (vector-ref arg-0 1))) (vector 65 e-200))) ((66) (vector 66 CoreC-45FC-emptyFC)) ((67) (let ((e-203 (vector-ref arg-0 2))) (let ((e-204 (vector-ref arg-0 3))) (vector 67 CoreC-45FC-emptyFC e-203 (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (CoreC-45Core-killErrorLoc eta-0)) e-204))))) ((68) (let ((e-206 (vector-ref arg-0 2))) (let ((e-207 (vector-ref arg-0 3))) (vector 68 CoreC-45FC-emptyFC e-206 (CoreC-45Core-killErrorLoc e-207))))) ((69) (let ((e-209 (vector-ref arg-0 2))) (let ((e-210 (vector-ref arg-0 3))) (vector 69 CoreC-45FC-emptyFC e-209 (CoreC-45Core-killErrorLoc e-210))))) ((70) (let ((e-212 (vector-ref arg-0 2))) (let ((e-213 (vector-ref arg-0 3))) (vector 70 CoreC-45FC-emptyFC e-212 (CoreC-45Core-killErrorLoc e-213))))) ((71) (let ((e-215 (vector-ref arg-0 2))) (let ((e-216 (vector-ref arg-0 3))) (vector 71 CoreC-45FC-emptyFC e-215 (CoreC-45Core-killErrorLoc e-216))))) ((72) (let ((e-217 (vector-ref arg-0 1))) (let ((e-218 (vector-ref arg-0 2))) (vector 72 (CoreC-45Core-killErrorLoc e-217) e-218)))) (else (let ((e-219 (vector-ref arg-0 1))) (vector 73 (CoreC-45Core-killWarningLoc e-219)))))))
(define IdrisC-45Error-checkError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--err (CoreC-45Core-killErrorLoc arg-4))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 e-5)))))) (lambda (eta-1) (IdrisC-45Error-perror arg-0 arg-1 arg-2 u--err eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--msg (DataC-45String-unwords (DataC-45String-words arg-3)))) (let ((u--str (DataC-45String-unwords (DataC-45String-words e-5)))) (lambda (eta-1) (vector 1 (DataC-45String-isInfixOf u--msg u--str))))))) eff-0) eta-0)))))))))
(define IdrisC-45Syntax-n--13013-3770-u--getName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-3 (vector-ref arg-5 2))) e-3)))
(define IdrisC-45Syntax-definedInData (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (cons e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-n--13013-3770-u--getName e-1 e-3 e-4 e-5 e-2 eta-0)) e-5)))))))) (else (let ((e-8 (vector-ref arg-0 2))) (cons e-8 '()))))))
(define IdrisC-45Syntax-definedIn (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((0) (let ((e-9 (vector-ref e-2 5))) (let ((e-31 (vector-ref e-9 2))) (cons e-31 (IdrisC-45Syntax-definedIn e-3))))) ((2) (let ((e-15 (vector-ref e-2 5))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedInData e-15) (IdrisC-45Syntax-definedIn e-3)))) ((3) (let ((e-19 (vector-ref e-2 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-19) (IdrisC-45Syntax-definedIn e-3)))) ((4) (let ((e-23 (vector-ref e-2 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-23) (IdrisC-45Syntax-definedIn e-3)))) ((11) (let ((e-27 (vector-ref e-2 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-27) (IdrisC-45Syntax-definedIn e-3))))(else (IdrisC-45Syntax-definedIn e-3))))))))
(define IdrisC-45Desugar-addNS (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-1 (unbox arg-0))) (case (vector-ref arg-1 0) ((0) arg-1)(else (vector 0 e-1 arg-1)))))))
(define IdrisC-45Desugar-bindFun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 8 u--fc (vector 0 u--fc (IdrisC-45Desugar-addNS arg-1 (vector 1 (vector 0 ">>=")))) arg-2) arg-3))))
(define IdrisC-45Desugar-bindBangs (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) arg-2 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (IdrisC-45Desugar-bindBangs e-3 arg-1 (IdrisC-45Desugar-bindFun e-10 arg-1 e-11 (vector 2 (vector 2 ) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-6) (vector 32 e-10 0) arg-2))))))))))))
(define CoreC-45Metadata-addSemanticDefault (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 e-4 e-10 e-6 e-7 e-8 (LibrariesC-45DataC-45PosMap-insert (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) arg-1 e-9))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45TTImp-apply (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--fFC (TTImpC-45TTImp-getFC arg-1))) (TTImpC-45TTImp-apply (vector 8 (DataC-45Maybe-fromMaybe (lambda () u--fFC) (CoreC-45FC-mergeFC u--fFC (TTImpC-45TTImp-getFC e-2))) arg-1 e-2) e-3)))))))
(define IdrisC-45Desugar-getClauseFn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (lambda (eta-0) (vector 1 e-2)))) ((8) (let ((e-5 (vector-ref arg-0 2))) (IdrisC-45Desugar-getClauseFn e-5))) ((9) (let ((e-9 (vector-ref arg-0 2))) (IdrisC-45Desugar-getClauseFn e-9))) ((10) (let ((e-13 (vector-ref arg-0 2))) (IdrisC-45Desugar-getClauseFn e-13)))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (TTImpC-45TTImp-getFC arg-0) "Head term in pattern must be a function name") eta-0))))))
(define CoreC-45Core-iwhen (lambda (arg-1 arg-2) (cond ((equal? arg-1 1) (let ((eff-0 (arg-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (box e-5)))))) eff-0 eta-0)))) (else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45Core-iunless (lambda (arg-1 arg-2) (CoreC-45Core-iwhen (cond ((equal? arg-1 1) 0) (else 1)) arg-2)))
(define CoreC-45Core-iwhenJust (lambda (arg-2 arg-3) (if (null? arg-2) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox arg-2))) (arg-3 e-1)))))
(define IdrisC-45Syntax-u--showPrec_Show_PTerm (lambda (ext-0 ext-1) (IdrisC-45Syntax-showPTermPrec (lambda (eta-0) eta-0) ext-0 ext-1)))
(define IdrisC-45Syntax-u--show_Show_PTerm (lambda (arg-0) (IdrisC-45Syntax-u--showPrec_Show_PTerm (vector 0 ) arg-0)))
(define IdrisC-45Desugar-desugarLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-5 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-iunless arg-6 (lambda () (IdrisC-45Desugar-getClauseFn e-5))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45BindImplicits-bindNames arg-1 arg-6 e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "desugar.lhs" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Desugared " (cons (IdrisC-45Syntax-u--show_Show_PTerm arg-7) (cons " to " (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-3) '())))))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 ((CoreC-45Core-iwhenJust e-6 (lambda (u--nm) (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 u--nm e-2))) (cond ((equal? sc5 1) ((let ((u--fc (IdrisC-45Syntax-getPTermLoc arg-7))) (lambda () (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--fc (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Declaration name (" (cons (CoreC-45Name-u--show_Show_Name u--nm) (cons ") shadowed by a pattern variable." '()))))) eta-2)))))) (else (lambda (eta-2) (vector 1 (vector 0 )))))))) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (vector 1 (cons e-6 (cons e-2 e-3)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-desugarWithProblem (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-1 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (cons e-1 (cons e-5 e-3))))))) (lambda (eta-0) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-2 eta-0)) ext-0))))))
(define TTImpC-45TTImp-mkWithClause (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (if (null? e-2) (vector 1 arg-1 arg-2 e-5 e-9 e-10 arg-4 arg-5) (let ((e-13 (car e-2))) (let ((e-14 (cdr e-2))) (let ((u--vfc (CoreC-45FC-virtualiseFC arg-1))) (vector 1 arg-1 arg-2 e-5 e-9 e-10 arg-4 (cons (TTImpC-45TTImp-mkWithClause arg-1 (vector 8 u--vfc arg-2 (vector 17 u--vfc "arg")) (cons e-13 e-14) arg-4 arg-5) '()))))))))))))))
(define IdrisC-45Desugar-desugarClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) e-4 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-desugarLHS arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 (PreludeC-45TypesC-45List-tailRecAppend e-10 arg-5) e-3 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--rhsC-39 (if (null? e-5) e-11 (vector 5 e-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5) e-11)))) (lambda (eta-1) (vector 1 (cons e-8 (vector 0 e-1 e-9 u--rhsC-39))))))) eff-0) clam-0)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (let ((e-9 (vector-ref arg-7 4))) (let ((e-10 (vector-ref arg-7 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-0 eta-2)) eta-1))) e-10 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-desugarLHS arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-7 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((e-13 (car e-3))) (let ((e-12 (cdr e-3))) (let ((act-3 ((CoreC-45Core-traverseList1 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarWithProblem arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45TypesC-45List-tailRecAppend e-13 arg-5) eta-1 eta-2))) e-8) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-2 (TTImpC-45TTImp-mkWithClause e-6 e-12 e-14 e-9 e-5)))))) eff-0) clam-1)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) (else (let ((e-12 (vector-ref arg-7 1))) (let ((e-13 (vector-ref arg-7 2))) (let ((act-1 (IdrisC-45Desugar-desugarLHS arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-7 (cdr e-3))) (vector 1 (cons e-2 (vector 2 e-12 e-7))))))))) eff-0) ext-0)))))))))))
(define IdrisC-45Desugar-desugarFnOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (vector 1 e-1))) ((1) (let ((e-3 (vector-ref arg-6 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-0 eta-1))) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-5))))) eff-0) ext-0))))))) (else (let ((e-5 (vector-ref arg-6 1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-0 eta-1))) e-5 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-6))))) eff-0) ext-0))))))))))
(define IdrisC-45SyntaxC-45Builtin-eqName (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "==="))))
(define IdrisC-45SyntaxC-45Builtin-heqName (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "~=~"))))
(define IdrisC-45Desugar-desugarTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-2 (vector-ref arg-8 1))) (let ((e-3 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 3))) (let ((e-5 (vector-ref arg-8 4))) (let ((e-6 (vector-ref arg-8 5))) (case (vector-ref e-4 0) ((1) (let ((e-16 (vector-ref e-4 1))) (lambda (clam-0) (case (vector-ref e-16 0) ((0) (let ((e-17 (vector-ref e-16 1))) (cond ((equal? e-17 "=") (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 13 e-2 (vector 0 ) (cons (TTImpC-45TTImp-apply (vector 0 e-3 IdrisC-45SyntaxC-45Builtin-eqName) (cons e-7 (cons e-8 '()))) (cons (TTImpC-45TTImp-apply (vector 0 e-3 IdrisC-45SyntaxC-45Builtin-heqName) (cons e-7 (cons e-8 '()))) '()))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((equal? e-17 "$") (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-2 e-7 e-8))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-2 (vector 8 e-2 (vector 0 e-3 e-4) e-7) e-8))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-2 (vector 8 e-2 (vector 0 e-3 e-4) e-7) e-8))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-2 (vector 8 e-2 (vector 0 e-3 e-4) e-7) e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((1) (let ((e-9 (vector-ref arg-8 1))) (let ((e-10 (vector-ref arg-8 2))) (let ((e-11 (vector-ref arg-8 3))) (let ((e-12 (vector-ref arg-8 4))) (case (vector-ref e-11 0) ((1) (let ((e-18 (vector-ref e-11 1))) (case (vector-ref e-18 0) ((0) (let ((e-19 (vector-ref e-18 1))) (cond ((equal? e-19 "-") (case (vector-ref e-12 0) ((2) (let ((e-22 (vector-ref e-12 1))) (case (vector-ref e-22 0) ((15) (let ((e-24 (vector-ref e-22 1))) (let ((e-25 (vector-ref e-22 2))) (let ((u--newFC (DataC-45Maybe-fromMaybe (lambda () (vector 2 )) (CoreC-45FC-mergeFC e-9 e-24)))) (let ((u--continue (lambda (eta-0) (IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 2 (vector 15 u--newFC eta-0)))))) (case (vector-ref e-25 0) ((0) (let ((e-0 (vector-ref e-25 1))) (u--continue (vector 0 (bs- 0 e-0 63))))) ((1) (let ((e-1 (vector-ref e-25 1))) (u--continue (vector 1 (bs- 0 e-1 7))))) ((2) (let ((e-2 (vector-ref e-25 1))) (u--continue (vector 2 (bs- 0 e-2 15))))) ((3) (let ((e-3 (vector-ref e-25 1))) (u--continue (vector 3 (bs- 0 e-3 31))))) ((4) (let ((e-4 (vector-ref e-25 1))) (u--continue (vector 4 (bs- 0 e-4 63))))) ((5) (let ((e-5 (vector-ref e-25 1))) (u--continue (vector 5 (- 0 e-5)))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 2 (vector 15 e-24 e-25))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-9 (vector 0 e-10 (vector 1 (vector 0 "negate"))) e-5))))) eff-0) eta-0)))))))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-9 (vector 0 e-10 (vector 1 (vector 0 "negate"))) e-5))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-9 (vector 0 e-10 (vector 1 (vector 0 "negate"))) e-5))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-9 (vector 0 e-10 e-11) e-5))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-9 (vector 0 e-10 e-11) e-5))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-9 (vector 0 e-10 e-11) e-5))))) eff-0) eta-0))))))))))))) (else (let ((e-15 (vector-ref arg-8 1))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-15))))))
(define IdrisC-45Desugar-desugarUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-5))))) eff-0) ext-0)))))))) (else (let ((e-4 (vector-ref arg-8 1))) (let ((e-5 (vector-ref arg-8 2))) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-4 e-6))))) eff-0) ext-0)))))))))))
(define IdrisC-45SyntaxC-45Builtin-dpairname (vector 0 CoreC-45NameC-45Namespace-dpairNS (vector 1 (vector 0 "DPair"))))
(define IdrisC-45Syntax-getLoc (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-4 (vector-ref arg-1 1))) e-4)) ((2) (let ((e-9 (vector-ref arg-1 1))) e-9)) ((3) (let ((e-14 (vector-ref arg-1 1))) e-14)) ((4) (let ((e-21 (vector-ref arg-1 1))) e-21)) ((5) (let ((e-27 (vector-ref arg-1 1))) e-27)) (else (let ((e-30 (vector-ref arg-1 1))) e-30)))))
(define IdrisC-45Desugar-initBangs (lambda (ext-0) (vector 0 '() ext-0)))
(define CoreC-45FC-isConcreteFC (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (box (cons e-0 (cons e-1 e-2)))))))(else '()))))
(define IdrisC-45Desugar-seqFun (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 8 u--fc (vector 0 u--fc (IdrisC-45Desugar-addNS arg-1 (vector 1 (vector 0 ">>")))) arg-2) arg-3))))
(define IdrisC-45Desugar-expandDo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-7 "Do block cannot be empty") eta-0)) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((0) (let ((e-39 (vector-ref e-2 2))) (if (null? e-3) (lambda (eta-0) (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-39 eta-0)) (lambda (clam-0) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (IdrisC-45Syntax-getLoc e-2) "Last statement in do block must be an expression") clam-0) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45Desugar-seqFun e-5 arg-8 e-7 e-8))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (let ((e-11 (vector-ref e-2 4))) (let ((act-1 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-11 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((sc7 (CoreC-45FC-isConcreteFC e-9))) (if (null? sc7) (vector 1 (vector 0 )) (let ((e-1 (unbox sc7))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-10))) '()) eta-1)))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-bindFun e-8 arg-8 e-5 (vector 2 e-9 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-10) (vector 32 (CoreC-45FC-virtualiseFC e-8) 0) e-6))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((2) (let ((e-13 (vector-ref e-2 1))) (let ((e-14 (vector-ref e-2 2))) (let ((e-15 (vector-ref e-2 3))) (let ((e-16 (vector-ref e-2 4))) (let ((act-1 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 0 arg-6 arg-8 e-14 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-15 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-4) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 1 eta-2 eta-4)) eta-3))) e-16 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-6))) (lambda (eta-2) (let ((act-5 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--psC-39 arg-7 arg-8 e-3) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--fc (CoreC-45FC-virtualiseFC e-13))) (let ((u--patFC (CoreC-45FC-virtualiseFC (TTImpC-45TTImp-getFC e-4)))) (lambda (eta-3) (vector 1 (IdrisC-45Desugar-bindFun u--fc arg-8 e-8 (vector 2 (vector 2 ) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box (vector 2 "_" 0)) (vector 32 u--fc 0) (vector 4 u--fc '() (vector 0 u--patFC (vector 2 "_" 0)) (vector 32 u--fc 0) (cons (vector 0 e-13 e-4 e-10) e-9)))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((3) (let ((e-18 (vector-ref e-2 1))) (let ((e-19 (vector-ref e-2 2))) (let ((e-20 (vector-ref e-2 3))) (let ((e-21 (vector-ref e-2 4))) (let ((e-22 (vector-ref e-2 5))) (let ((e-23 (vector-ref e-2 6))) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-8)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-23) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-22 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((sc9 (CoreC-45FC-isConcreteFC e-19))) (if (null? sc9) (vector 1 (vector 0 )) (let ((e-1 (unbox sc9))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-20))) '()) eta-3)))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((u--bind (vector 3 e-18 e-19 e-21 e-20 e-7 e-6 e-8))) (let ((act-6 (let ((act-6 (unbox e-5))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-10 1))) e-1) arg-8 u--bind))))) eff-0) eta-3)))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) ((4) (let ((e-25 (vector-ref e-2 1))) (let ((e-26 (vector-ref e-2 2))) (let ((e-27 (vector-ref e-2 3))) (let ((e-28 (vector-ref e-2 4))) (let ((e-29 (vector-ref e-2 5))) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-8)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 0 arg-6 arg-8 e-26 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-27 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45BindImplicits-bindNames arg-1 0 e-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((act-5 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-28) clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-6) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 1 eta-4 eta-6)) eta-5))) e-29 '()) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-6))) (lambda (eta-4) (let ((act-7 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--psC-39 arg-7 arg-8 e-3) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (let ((act-8 (unbox e-5))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--fc (CoreC-45FC-virtualiseFC e-25))) (lambda (eta-6) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-13 1))) e-1) arg-8 (vector 4 u--fc '() e-10 e-7 (cons (vector 0 u--fc e-4 e-12) e-11)))))))) eff-0) eta-5)))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) clam-2)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))) ((5) (let ((e-31 (vector-ref e-2 1))) (let ((e-32 (vector-ref e-2 2))) (let ((act-1 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 eta-1)) e-32 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-31 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) eta-2) e-6) e-5))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) (else (let ((e-34 (vector-ref e-2 1))) (let ((e-35 (vector-ref e-2 2))) (let ((act-1 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-35 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 14 e-34 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))(else (lambda (clam-1) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (IdrisC-45Syntax-getLoc e-2) "Last statement in do block must be an expression") clam-1) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-6 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45Desugar-seqFun e-5 arg-8 e-7 e-8))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))) ((1) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (let ((e-11 (vector-ref e-2 4))) (let ((act-1 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-11 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((sc5 (CoreC-45FC-isConcreteFC e-9))) (if (null? sc5) (vector 1 (vector 0 )) (let ((e-1 (unbox sc5))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-10))) '()) eta-1)))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-bindFun e-8 arg-8 e-5 (vector 2 e-9 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-10) (vector 32 (CoreC-45FC-virtualiseFC e-8) 0) e-6))))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))) ((2) (let ((e-13 (vector-ref e-2 1))) (let ((e-14 (vector-ref e-2 2))) (let ((e-15 (vector-ref e-2 3))) (let ((e-16 (vector-ref e-2 4))) (let ((act-1 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 0 arg-6 arg-8 e-14 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-15 clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-4) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 1 eta-2 eta-4)) eta-3))) e-16 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-7 arg-6))) (lambda (eta-2) (let ((act-5 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--psC-39 arg-7 arg-8 e-3) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--fc (CoreC-45FC-virtualiseFC e-13))) (let ((u--patFC (CoreC-45FC-virtualiseFC (TTImpC-45TTImp-getFC e-4)))) (lambda (eta-3) (vector 1 (IdrisC-45Desugar-bindFun u--fc arg-8 e-8 (vector 2 (vector 2 ) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box (vector 2 "_" 0)) (vector 32 u--fc 0) (vector 4 u--fc '() (vector 0 u--patFC (vector 2 "_" 0)) (vector 32 u--fc 0) (cons (vector 0 e-13 e-4 e-10) e-9)))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) clam-4)))))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))) ((3) (let ((e-18 (vector-ref e-2 1))) (let ((e-19 (vector-ref e-2 2))) (let ((e-20 (vector-ref e-2 3))) (let ((e-21 (vector-ref e-2 4))) (let ((e-22 (vector-ref e-2 5))) (let ((e-23 (vector-ref e-2 6))) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-8)) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-23) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-22 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((sc7 (CoreC-45FC-isConcreteFC e-19))) (if (null? sc7) (vector 1 (vector 0 )) (let ((e-1 (unbox sc7))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-1 (cons (cons e-1 (cons 5 (box e-20))) '()) eta-3)))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((u--bind (vector 3 e-18 e-19 e-21 e-20 e-7 e-6 e-8))) (let ((act-6 (let ((act-6 (unbox e-5))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-10 1))) e-1) arg-8 u--bind))))) eff-0) eta-3)))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))))) ((4) (let ((e-25 (vector-ref e-2 1))) (let ((e-26 (vector-ref e-2 2))) (let ((e-27 (vector-ref e-2 3))) (let ((e-28 (vector-ref e-2 4))) (let ((e-29 (vector-ref e-2 5))) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-8)) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 0 arg-6 arg-8 e-26 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-27 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45BindImplicits-bindNames arg-1 0 e-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((act-5 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 e-28) clam-5))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-6) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 1 eta-4 eta-6)) eta-5))) e-29 '()) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend e-9 arg-6))) (lambda (eta-4) (let ((act-7 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--psC-39 arg-7 arg-8 e-3) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (let ((act-8 (unbox e-5))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--fc (CoreC-45FC-virtualiseFC e-25))) (lambda (eta-6) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-13 1))) e-1) arg-8 (vector 4 u--fc '() e-10 e-7 (cons (vector 0 u--fc e-4 e-12) e-11)))))))) eff-0) eta-5)))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) clam-5)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))) ((5) (let ((e-31 (vector-ref e-2 1))) (let ((e-32 (vector-ref e-2 2))) (let ((act-1 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 eta-1)) e-32 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-31 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) eta-2) e-6) e-5))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))) (else (let ((e-34 (vector-ref e-2 1))) (let ((e-35 (vector-ref e-2 2))) (let ((act-1 ((IdrisC-45Desugar-expandDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-3 arg-2 arg-4 arg-5 arg-6 arg-8 e-35 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 14 e-34 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))))))
(define IdrisC-45Desugar-expandList (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (vector 1 (vector 0 arg-8 (vector 1 (vector 0 "Nil")))) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-expandList arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-6 (vector 1 (vector 0 "::"))) (cons e-5 (cons e-8 '()))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define IdrisC-45Desugar-expandSnocList (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (vector 1 (vector 0 arg-8 (vector 1 (vector 0 "Lin")))) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 ((IdrisC-45Desugar-expandSnocList arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-6 (vector 1 (vector 0 ":<"))) (cons e-5 (cons e-8 '()))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define IdrisC-45Syntax-isStrLiteral (lambda (arg-0) (case (vector-ref arg-0 0) ((1) '()) (else (let ((e-4 (vector-ref arg-0 1))) (let ((e-5 (vector-ref arg-0 2))) (box (cons e-4 e-5))))))))
(define DataC-45List-head (lambda (arg-1) (let ((e-1 (car arg-1))) e-1)))
(define IdrisC-45Desugar-case--expandStringC-44mergeStrLit-14491 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (if (null? e-2) (if (null? e-3) '() (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (cons e-10 (IdrisC-45Desugar-n--15554-14372-u--mergeStrLit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11))))) (let ((u--fc (Builtin-fst (DataC-45List-head e-2)))) (let ((u--lit (PreludeC-45Types-fastConcat (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-2)))) (cons (vector 0 u--fc u--lit) (IdrisC-45Desugar-n--15554-14372-u--mergeStrLit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3)))))))))
(define IdrisC-45Desugar-n--15554-14372-u--mergeStrLit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (IdrisC-45Desugar-case--expandStringC-44mergeStrLit-14491 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (DataC-45List-spanBy (lambda (eta-0) (IdrisC-45Syntax-isStrLiteral eta-0)) arg-11))))
(define IdrisC-45Desugar-n--15554-14373-u--notEmpty (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-2 (vector-ref arg-11 2))) (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-2 ""))) (else 1))))
(define IdrisC-45SyntaxC-45Builtin-consName (vector 0 CoreC-45NameC-45Namespace-preludeNS (vector 1 (vector 0 "::"))))
(define IdrisC-45SyntaxC-45Builtin-interpolateName (vector 0 CoreC-45NameC-45Namespace-preludeNS (vector 1 (vector 0 "interpolate"))))
(define IdrisC-45SyntaxC-45Builtin-nilName (vector 0 CoreC-45NameC-45Namespace-preludeNS (vector 1 (vector 0 "Nil"))))
(define IdrisC-45Desugar-n--15554-14374-u--strInterpolate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (vector 0 (vector 2 ) IdrisC-45SyntaxC-45Builtin-nilName) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((u--xFC (CoreC-45FC-virtualiseFC (TTImpC-45TTImp-getFC e-2)))) (TTImpC-45TTImp-apply (vector 0 u--xFC IdrisC-45SyntaxC-45Builtin-consName) (cons (vector 8 u--xFC (vector 0 (vector 2 ) IdrisC-45SyntaxC-45Builtin-interpolateName) e-2) (cons (IdrisC-45Desugar-n--15554-14374-u--strInterpolate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) '())))))))))
(define IdrisC-45Desugar-n--15554-14375-u--toRawImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (lambda (clam-0) (let ((sc1 (ParserC-45SupportC-45Escaping-unescape arg-1 e-2))) (if (null? sc1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Invalid escape sequence: " (cons (PreludeC-45Show-u--show_Show_String e-2) '())))) clam-0) (let ((e-3 (unbox sc1))) (vector 1 (vector 28 e-1 (vector 10 e-3)))))))))) (else (let ((e-5 (vector-ref arg-11 2))) (IdrisC-45Desugar-desugarB arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 e-5))))))
(define IdrisC-45Desugar-expandString (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-n--15554-14375-u--toRawImp arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (IdrisC-45Desugar-n--15554-14373-u--notEmpty arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) (IdrisC-45Desugar-n--15554-14372-u--mergeStrLit arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-10)) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (if (null? e-5) (vector 28 arg-8 (vector 10 "")) (let ((u--vfc (CoreC-45FC-virtualiseFC arg-8))) (vector 8 u--vfc (vector 10 u--vfc (vector 0 u--vfc (vector 0 CoreC-45NameC-45Namespace-preludeNS (vector 1 (vector 0 "concat")))) (vector 1 (vector 0 "t")) (vector 0 u--vfc (vector 0 CoreC-45NameC-45Namespace-preludeNS (vector 1 (vector 0 "List"))))) (IdrisC-45Desugar-n--15554-14374-u--strInterpolate arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromCharName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-48 (vector-ref e-37 2))) e-48))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromDeclsName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-44 (vector-ref e-37 6))) e-44))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromDoubleName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-47 (vector-ref e-37 3))) e-47))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromIntegerName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-50 (vector-ref e-37 0))) e-50))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromNameName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-45 (vector-ref e-37 5))) e-45))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromStringName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-49 (vector-ref e-37 1))) e-49))))))) eff-0) ext-0)))))))
(define CoreC-45Context-fromTTImpName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-37 (vector-ref e-4 6))) (let ((e-46 (vector-ref e-37 4))) e-46))))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-idiomise (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((13) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (vector 13 e-1 (TTImpC-45TTImp-mapAltType (lambda (eta-0) (IdrisC-45Desugar-idiomise e-1 arg-1 arg-2 eta-0)) e-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Desugar-idiomise e-1 arg-1 arg-2 eta-0)) e-3)))))) ((8) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (let ((u--app (vector 1 (vector 0 "<*>")))) (let ((u--nm (PreludeC-45Types-maybe (lambda () u--app) (lambda () (lambda (arg-4) (vector 0 arg-4 u--app))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe arg-2 (lambda () arg-1))))) (vector 8 u--fc (vector 8 u--fc (vector 0 u--fc u--nm) (IdrisC-45Desugar-idiomise e-5 arg-1 arg-2 e-6)) e-7))))))))(else (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (let ((u--pur (vector 1 (vector 0 "pure")))) (let ((u--nm (PreludeC-45Types-maybe (lambda () u--pur) (lambda () (lambda (arg-4) (vector 0 arg-4 u--pur))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe arg-2 (lambda () arg-1))))) (vector 8 u--fc (vector 0 u--fc u--nm) arg-3))))))))
(define TTImpC-45TTImp-logRaw (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (cond ((equal? arg-1 "") (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append (arg-4) (string-append ": " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-5)))))) "\xa;") clam-0))) (vector 1 act-2)))(else (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-1 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append (arg-4) (string-append ": " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-5)))))))) "\xa;") clam-0))) (vector 1 act-2))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-maybeIApp (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (unbox arg-1))) (let ((u--fc (CoreC-45FC-virtualiseFC arg-0))) (vector 8 u--fc (vector 0 u--fc e-2) arg-2))))))
(define IdrisC-45SyntaxC-45Builtin-mkdpairname (vector 0 CoreC-45NameC-45Namespace-dpairNS (vector 1 (vector 0 "MkDPair"))))
(define IdrisC-45SyntaxC-45Builtin-mkpairname (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "MkPair"))))
(define IdrisC-45SyntaxC-45Builtin-pairname (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "Pair"))))
(define LibrariesC-45UtilsC-45Shunting-output (lambda (arg-2 arg-3) (if (null? arg-2) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-0))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-0)))))) (let ((e-5 (car arg-2))) (let ((e-6 (cdr arg-2))) (case (vector-ref arg-3 0) ((0) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (let ((e-27 (vector-ref arg-3 4))) (case (vector-ref e-27 0) ((3) (lambda (eta-0) (vector 1 (cons (vector 1 e-24 e-25 e-26 e-5) e-6))))(else (if (null? e-6) (lambda (clam-2) (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-2)))) (let ((e-14 (car e-6))) (let ((e-15 (cdr e-6))) (lambda (clam-1) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (vector 1 (cons (vector 0 e-18 e-19 e-20 e-14 e-5) e-15))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-1))))))))))))))))(else (if (null? e-6) (lambda (clam-4) (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-4)))) (let ((e-14 (car e-6))) (let ((e-15 (cdr e-6))) (lambda (clam-2) (case (vector-ref arg-3 0) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (let ((e-20 (vector-ref arg-3 3))) (vector 1 (cons (vector 0 e-18 e-19 e-20 e-14 e-5) e-15))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 1))) (vector 1 (cons (vector 2 e-2) arg-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-2))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-emit (lambda (arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((LibrariesC-45UtilsC-45Shunting-output e-5 arg-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (set-box! arg-2 e-6))) (vector 1 act-3))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45UtilsC-45Shunting-getPrec (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) ((2) (let ((e-2 (vector-ref arg-0 1))) e-2)) (else (let ((e-3 (vector-ref arg-0 1))) e-3)))))
(define LibrariesC-45UtilsC-45Shunting-isLAssoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define LibrariesC-45UtilsC-45Shunting-higher (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (lambda (clam-0) (let ((sc1 (or (and (= e-1 (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)) 1) 0))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Operator '" (string-append (let ((e-3 (car arg-1))) (e-3 arg-3)) "' is non-associative"))) clam-0)) (else (vector 1 (PreludeC-45Types-u--C-62_Ord_Nat e-1 (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)))))))))(else (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (let ((e-0 (vector-ref arg-6 1))) (let ((sc1 (or (and (= (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) e-0) 1) 0))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Operator '" (string-append (let ((e-1 (car arg-1))) (e-1 arg-5)) "' is non-associative"))) clam-0)) (else (vector 1 (PreludeC-45Types-u--C-62_Ord_Nat (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) e-0)))))))(else (vector 1 (let ((sc0 (PreludeC-45Types-u--C-62_Ord_Nat (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)))) (cond ((equal? sc0 1) 1) (else (let ((sc1 (or (and (= (LibrariesC-45UtilsC-45Shunting-getPrec arg-4) (LibrariesC-45UtilsC-45Shunting-getPrec arg-6)) 1) 0))) (cond ((equal? sc1 1) (LibrariesC-45UtilsC-45Shunting-isLAssoc arg-4)) (else 0))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-processStack (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((act-1 ((LibrariesC-45UtilsC-45Shunting-higher arg-2 e-6 e-14 e-15 arg-5 arg-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--x (cons e-6 (cons e-10 (cons e-14 e-15))))) (lambda (clam-1) (cond ((equal? e-5 1) (let ((act-2 (LibrariesC-45UtilsC-45Shunting-emit arg-3 (vector 0 e-6 e-10 e-14 e-15) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((LibrariesC-45UtilsC-45Shunting-processStack arg-2 arg-3 e-3 arg-5 arg-6) clam-1))))) (else (vector 1 (cons u--x e-3)))))))) eff-0) clam-0)))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-n--7674-5369-u--mkOp (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 0 e-2 e-6 e-10 e-11)))))))))
(define LibrariesC-45UtilsC-45Shunting-shunt (lambda (arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (LibrariesC-45UtilsC-45Shunting-emit arg-3 (LibrariesC-45UtilsC-45Shunting-n--7674-5369-u--mkOp arg-2 arg-4 arg-3 eta-0) eta-1))) arg-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-3))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-1) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (vector 1 e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Invalid input to shunting") clam-1)))))))) eff-0) clam-0)))))))) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (case (vector-ref e-1 0) ((1) (let ((e-6 (vector-ref e-1 1))) (let ((act-1 (LibrariesC-45UtilsC-45Shunting-emit arg-3 (vector 1 e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else ((LibrariesC-45UtilsC-45Shunting-shunt arg-2 arg-3 arg-4 e-2) clam-0)))))) (else (let ((e-9 (vector-ref e-1 1))) (let ((e-10 (vector-ref e-1 2))) (let ((e-11 (vector-ref e-1 3))) (let ((e-12 (vector-ref e-1 4))) (let ((act-1 ((LibrariesC-45UtilsC-45Shunting-processStack arg-2 arg-3 arg-4 e-11 e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (LibrariesC-45UtilsC-45Shunting-shunt arg-2 arg-3 (cons (cons e-9 (cons e-10 (cons e-11 e-12))) e-5) e-2))) eff-0) clam-0)))))))))))))))))
(define LibrariesC-45UtilsC-45Shunting-parseOps (lambda (arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Libraries.Utils.Shunting.Out" ) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (LibrariesC-45UtilsC-45Shunting-shunt arg-2 e-5 '() arg-3))) eff-0) ext-0)))))))
(define DataC-45List-partition (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (DataC-45List-partition arg-1 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (arg-1 e-2))) (cond ((equal? sc2 1) (cons (cons e-2 e-5) e-4)) (else (cons e-5 (cons e-2 e-4)))))))))))))
(define IdrisC-45Desugar-mkPrec (lambda (arg-0 ext-0) (cond ((equal? arg-0 0) (vector 0 ext-0)) ((equal? arg-0 1) (vector 1 ext-0)) ((equal? arg-0 2) (vector 2 ext-0)) (else (vector 3 ext-0)))))
(define IdrisC-45Desugar-n--14251-9460-u--isCompatible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (u--fxC-39) (let ((sc0 (IdrisC-45Syntax-u--C-61C-61_Eq_Fixity (let ((e-2 (vector-ref arg-5 2))) e-2) (let ((e-2 (vector-ref u--fxC-39 2))) e-2)))) (cond ((equal? sc0 1) (or (and (= (let ((e-3 (vector-ref arg-5 3))) e-3) (let ((e-3 (vector-ref u--fxC-39 3))) e-3)) 1) 0)) (else 0)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) ext-0))))
(define IdrisC-45Desugar-n--14251-9461-u--warnConflict (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (CoreC-45Context-recordWarning arg-3 (vector 6 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "operator fixity is ambiguous, we are picking " (cons (CoreC-45Name-u--show_Show_Name arg-5) (cons " out of :\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons " - " (cons (CoreC-45Name-u--show_Show_Name e-2) (cons ", precedence level " (cons (PreludeC-45Show-u--show_Show_Nat (let ((e-4 (vector-ref e-3 3))) e-4)) '())))))))) arg-6)) (cons "\xa;To remove this warning, use `%hide` with the fixity to remove\xa;For example: %hide " (cons (CoreC-45Name-u--show_Show_Name arg-5) '())))))))))))
(define IdrisC-45Desugar-case--caseC-32blockC-32inC-32checkConflictingFixities-9697 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-3) (cond ((equal? e-2 1) (let ((e-6 (car e-3))) (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "'" (cons arg-6 (cons "' is not a prefix operator" '()))))) eta-0)) (let ((e-9 (car e-6))) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (let ((u--extraFixities (PreludeC-45TypesC-45List-tailRecAppend arg-8 (PreludeC-45TypesC-45List-filterAppend '() csegen-3962 arg-9)))) (lambda (eta-0) (let ((act-1 (let ((sc6 (IdrisC-45Desugar-n--14251-9460-u--isCompatible arg-0 arg-1 arg-2 arg-3 arg-4 e-15 u--extraFixities))) (cond ((equal? sc6 1) (vector 1 (vector 0 ))) (else ((IdrisC-45Desugar-n--14251-9461-u--warnConflict arg-0 arg-1 arg-2 arg-3 arg-4 e-14 u--extraFixities) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-mkPrec (let ((e-8 (vector-ref e-15 2))) e-8) (let ((e-4 (vector-ref e-15 3))) e-4)))))))))))))) (else (let ((e-19 (cdr e-3))) (if (null? e-19) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "'" (cons arg-6 (cons "' is not an infix operator" '()))))) eta-0)) (let ((e-21 (car e-19))) (let ((e-26 (car e-21))) (let ((e-27 (cdr e-21))) (let ((u--extraFixities (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-filterAppend '() csegen-3963 arg-8) arg-9))) (lambda (eta-0) (let ((act-1 (let ((sc6 (IdrisC-45Desugar-n--14251-9460-u--isCompatible arg-0 arg-1 arg-2 arg-3 arg-4 e-27 u--extraFixities))) (cond ((equal? sc6 1) (vector 1 (vector 0 ))) (else ((IdrisC-45Desugar-n--14251-9461-u--warnConflict arg-0 arg-1 arg-2 arg-3 arg-4 e-26 u--extraFixities) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-mkPrec (let ((e-6 (vector-ref e-27 2))) e-6) (let ((e-4 (vector-ref e-27 3))) e-4))))))))))))))) (let ((e-30 (car e-3))) (let ((e-31 (cdr e-3))) (if (null? e-30) (if (null? e-31) (lambda (clam-0) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Name-isOpChar eta-0)) (PreludeC-45Types-fastUnpack arg-6)))) (cond ((equal? sc4 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Unknown operator '" (cons arg-6 (cons "'" '()))))) clam-0)) (else (vector 1 (vector 2 1)))))) (cond ((equal? e-2 1) (let ((e-6 (car e-3))) (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "'" (cons arg-6 (cons "' is not a prefix operator" '()))))) eta-0)) (let ((e-9 (car e-6))) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (let ((u--extraFixities (PreludeC-45TypesC-45List-tailRecAppend arg-8 (PreludeC-45TypesC-45List-filterAppend '() csegen-3962 arg-9)))) (lambda (eta-0) (let ((act-1 (let ((sc8 (IdrisC-45Desugar-n--14251-9460-u--isCompatible arg-0 arg-1 arg-2 arg-3 arg-4 e-15 u--extraFixities))) (cond ((equal? sc8 1) (vector 1 (vector 0 ))) (else ((IdrisC-45Desugar-n--14251-9461-u--warnConflict arg-0 arg-1 arg-2 arg-3 arg-4 e-14 u--extraFixities) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-mkPrec (let ((e-8 (vector-ref e-15 2))) e-8) (let ((e-4 (vector-ref e-15 3))) e-4)))))))))))))) (else (let ((e-19 (cdr e-3))) (if (null? e-19) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "'" (cons arg-6 (cons "' is not an infix operator" '()))))) eta-0)) (let ((e-21 (car e-19))) (let ((e-26 (car e-21))) (let ((e-27 (cdr e-21))) (let ((u--extraFixities (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-filterAppend '() csegen-3963 arg-8) arg-9))) (lambda (eta-0) (let ((act-1 (let ((sc8 (IdrisC-45Desugar-n--14251-9460-u--isCompatible arg-0 arg-1 arg-2 arg-3 arg-4 e-27 u--extraFixities))) (cond ((equal? sc8 1) (vector 1 (vector 0 ))) (else ((IdrisC-45Desugar-n--14251-9461-u--warnConflict arg-0 arg-1 arg-2 arg-3 arg-4 e-26 u--extraFixities) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-mkPrec (let ((e-6 (vector-ref e-27 2))) e-6) (let ((e-4 (vector-ref e-27 3))) e-4)))))))))))))))) (cond ((equal? e-2 1) (let ((e-6 (car e-3))) (if (null? e-6) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "'" (cons arg-6 (cons "' is not a prefix operator" '()))))) eta-0)) (let ((e-9 (car e-6))) (let ((e-14 (car e-9))) (let ((e-15 (cdr e-9))) (let ((u--extraFixities (PreludeC-45TypesC-45List-tailRecAppend arg-8 (PreludeC-45TypesC-45List-filterAppend '() csegen-3962 arg-9)))) (lambda (eta-0) (let ((act-1 (let ((sc7 (IdrisC-45Desugar-n--14251-9460-u--isCompatible arg-0 arg-1 arg-2 arg-3 arg-4 e-15 u--extraFixities))) (cond ((equal? sc7 1) (vector 1 (vector 0 ))) (else ((IdrisC-45Desugar-n--14251-9461-u--warnConflict arg-0 arg-1 arg-2 arg-3 arg-4 e-14 u--extraFixities) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-mkPrec (let ((e-8 (vector-ref e-15 2))) e-8) (let ((e-4 (vector-ref e-15 3))) e-4)))))))))))))) (else (let ((e-19 (cdr e-3))) (if (null? e-19) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "'" (cons arg-6 (cons "' is not an infix operator" '()))))) eta-0)) (let ((e-21 (car e-19))) (let ((e-26 (car e-21))) (let ((e-27 (cdr e-21))) (let ((u--extraFixities (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-filterAppend '() csegen-3963 arg-8) arg-9))) (lambda (eta-0) (let ((act-1 (let ((sc7 (IdrisC-45Desugar-n--14251-9460-u--isCompatible arg-0 arg-1 arg-2 arg-3 arg-4 e-27 u--extraFixities))) (cond ((equal? sc7 1) (vector 1 (vector 0 ))) (else ((IdrisC-45Desugar-n--14251-9461-u--warnConflict arg-0 arg-1 arg-2 arg-3 arg-4 e-26 u--extraFixities) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (IdrisC-45Desugar-mkPrec (let ((e-6 (vector-ref e-27 2))) e-6) (let ((e-4 (vector-ref e-27 3))) e-4)))))))))))))))))))))))
(define IdrisC-45Desugar-case--checkConflictingFixities-9662 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (IdrisC-45Desugar-case--caseC-32blockC-32inC-32checkConflictingFixities-9697 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-2 e-3 (cons arg-2 (cons e-2 e-3)))))))
(define IdrisC-45Desugar-checkConflictingFixities (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--op (CoreC-45Name-nameRoot arg-4))) (let ((u--foundFixities (LibrariesC-45DataC-45ANameMap-lookupName (vector 1 (vector 0 u--op)) (let ((e-0 (vector-ref e-5 0))) e-0)))) (IdrisC-45Desugar-case--checkConflictingFixities-9662 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 u--op u--foundFixities (DataC-45List-partition csegen-273 u--foundFixities)))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-toTokList (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((27) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-1 (IdrisC-45Desugar-checkConflictingFixities arg-0 arg-1 0 e-1 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-toTokList arg-0 arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 1 e-4) (cons (vector 0 e-1 e-2 e-3 e-6) e-7)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((28) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (let ((act-1 (IdrisC-45Desugar-checkConflictingFixities arg-0 arg-1 1 e-7 e-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Desugar-toTokList arg-0 arg-1 e-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 0 e-7 e-8 e-9 e-5) e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))(else (vector 1 (cons (vector 1 arg-2) '()))))))
(define IdrisC-45Desugar-n--15601-14761-u--mapLast (lambda (arg-0 arg-1 arg-2 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (if (null? e-3) (cons (arg-4 e-2) '()) (cons e-2 (IdrisC-45Desugar-n--15601-14761-u--mapLast arg-0 arg-1 arg-2 arg-4 e-3))))))))
(define IdrisC-45Desugar-n--15601-14760-u--dropLastNL (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45Desugar-n--15601-14761-u--mapLast arg-0 arg-1 arg-2 (lambda (eta-0) (IdrisC-45Desugar-n--15601-14761-u--mapLast arg-0 arg-1 arg-2 (lambda (lcase-0) (case (vector-ref lcase-0 0) ((0) (let ((e-1 (vector-ref lcase-0 1))) (let ((e-2 (vector-ref lcase-0 2))) (vector 0 e-1 (Builtin-fst (DataC-45String-break (lambda (eta-1) (PreludeC-45Types-isNL eta-1)) e-2))))))(else lcase-0))) eta-0)) ext-0)))
(define DataC-45ListC-45Views-snocListHelp (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) arg-2 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (DataC-45ListC-45Views-snocListHelp (PreludeC-45TypesC-45List-tailRecAppend arg-1 (cons e-2 '())) (vector 1 e-2 arg-1 arg-2) e-3))))))
(define DataC-45ListC-45Views-snocList (lambda (arg-1) (DataC-45ListC-45Views-snocListHelp '() (vector 0 ) arg-1)))
(define LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (arg-2 e-2))) (if (null? sc1) (LibrariesC-45DataC-45ListC-45Extra-findBy arg-2 e-3) (let ((e-4 (unbox sc1))) (box e-4)))))))))
(define IdrisC-45Syntax-isStrInterp (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-1 (vector-ref arg-0 1))) (box e-1))) (else '()))))
(define IdrisC-45Desugar-with--trimMultilineC-44trimLast-14774 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 arg-5 "Expected new line") eta-0)))(else (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-7) (lambda (clam-0) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 csegen-3961 (PreludeC-45Types-fastUnpack e-10)))) (cond ((equal? sc5 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 e-9 "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") clam-0)) (else (vector 1 e-2))))) (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))(else (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))))))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (if (null? e-1) (lambda (eta-0) (vector 1 arg-0)) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-7) (lambda (clam-1) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 csegen-3961 (PreludeC-45Types-fastUnpack e-10)))) (cond ((equal? sc5 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 e-9 "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") clam-1)) (else (vector 1 e-2))))) (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))(else (let ((u--fc (DataC-45Maybe-fromMaybe (lambda () arg-2) (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (eta-0) (IdrisC-45Syntax-isStrInterp eta-0)) e-1)))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 u--fc "Closing delimiter of multiline strings cannot be preceded by non-whitespace characters") eta-0)))))))))))))
(define IdrisC-45Desugar-n--15601-14762-u--trimLast (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (IdrisC-45Desugar-with--trimMultilineC-44trimLast-14774 arg-4 arg-1 arg-3 arg-4 (DataC-45ListC-45Views-snocList arg-4) arg-3)))
(define DataC-45List-splitAt (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) (cons '() arg-2))(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) (cons '() '()) (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (let ((sc1 (DataC-45List-splitAt e-0 e-4))) (let ((e-2 (car sc1))) (let ((e-5 (cdr sc1))) (cons (cons e-3 e-2) e-5))))))))))))
(define IdrisC-45Desugar-case--trimMultilineC-44trimLeft-14930 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 csegen-3961 e-2))) (cond ((equal? sc1 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 arg-4 "Line is less indented than the closing delimiter") eta-0))) (else (let ((u--str (let ((sc2 (PreludeC-45Types-u--null_Foldable_List e-3))) (cond ((equal? sc2 1) "\xa;") (else (PreludeC-45Types-fastPack e-3)))))) (lambda (eta-0) (vector 1 (cons (vector 0 arg-4 u--str) '())))))))))))
(define IdrisC-45Desugar-case--trimMultilineC-44trimLeft-15069 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 csegen-3961 e-2))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45TypesC-45List-lengthTR e-2) arg-6)))))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 arg-4 "Line is less indented than the closing delimiter") clam-0)) (else (vector 1 (cons (vector 0 arg-4 (PreludeC-45Types-fastPack e-3)) arg-5))))))))))
(define IdrisC-45Desugar-n--15601-14763-u--trimLeft (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (if (null? e-3) (IdrisC-45Desugar-case--trimMultilineC-44trimLeft-14930 arg-0 arg-1 arg-2 e-6 e-5 arg-3 (DataC-45List-splitAt arg-3 (PreludeC-45Types-fastUnpack e-6))) (IdrisC-45Desugar-case--trimMultilineC-44trimLeft-15069 arg-0 arg-1 arg-2 e-6 e-5 e-3 arg-3 (DataC-45List-splitAt arg-3 (PreludeC-45Types-fastUnpack e-6)))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 64 arg-2 "Line is less indented than the closing delimiter") eta-0)))))))))
(define IdrisC-45Desugar-trimMultiline (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((IdrisC-45Desugar-n--15601-14762-u--trimLast arg-2 arg-1 arg-0 arg-0 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-n--15601-14763-u--trimLeft arg-2 arg-1 arg-0 arg-1 eta-1)) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) eta-2) (IdrisC-45Desugar-n--15601-14760-u--dropLastNL arg-2 arg-1 arg-0 e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-u--C-61C-61_Eq_Side (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define CoreC-45Name-mbApplyNS (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (unbox arg-0))) (vector 0 e-2 arg-1)))))
(define IdrisC-45Desugar-n--15371-13774-u--guard (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (vector 0 e-1 (vector 7 e-1 (vector 0 e-1 (CoreC-45Name-mbApplyNS arg-11 (vector 1 (vector 0 "guard")))) e-2)))))(else arg-12))))
(define IdrisC-45Desugar-n--15371-13775-u--toPure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 0 arg-2 (vector 7 arg-2 (vector 0 arg-2 (CoreC-45Name-mbApplyNS arg-11 (vector 1 (vector 0 "pure")))) arg-12))))
(define IdrisC-45Desugar-desugarB (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ns (let ((e-3 (vector-ref e-5 2))) e-3))) (let ((u--pur (vector 1 (vector 0 "pure")))) (lambda (clam-0) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-2 u--pur))) (cond ((equal? sc2 0) (vector 1 (vector 0 e-1 e-2))) (else (vector 1 (vector 0 e-1 (PreludeC-45Types-maybe (lambda () u--pur) (lambda () (lambda (arg-9) (vector 0 arg-9 u--pur))) u--ns))))))))))) eff-0) eta-0))))))))) ((1) (let ((e-4 (vector-ref arg-8 1))) (let ((e-5 (vector-ref arg-8 2))) (let ((e-6 (vector-ref arg-8 3))) (let ((e-7 (vector-ref arg-8 4))) (let ((e-8 (vector-ref arg-8 5))) (let ((e-9 (vector-ref arg-8 6))) (let ((u--psC-39 (PreludeC-45Types-maybe (lambda () arg-7) (lambda () (lambda (arg-9) (cons arg-9 arg-7))) e-7))) (lambda (eta-0) (let ((act-1 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 u--psC-39 eta-1 eta-2))) e-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-8) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--psC-39 e-9) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 1 e-4 e-5 e-10 e-7 e-11 e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (let ((e-11 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 2))) (let ((e-13 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 4))) (let ((e-15 (vector-ref arg-8 5))) (let ((e-16 (vector-ref arg-8 6))) (case (vector-ref e-14 0) ((0) (let ((e-209 (vector-ref e-14 1))) (let ((e-210 (vector-ref e-14 2))) (case (vector-ref e-210 0) ((1) (let ((e-213 (vector-ref e-210 1))) (let ((u--pat (vector 0 e-209 (vector 1 e-213)))) (let ((u--n (vector 1 e-213))) (lambda (clam-1) (let ((sc3 (CoreC-45Name-isPatternVariable e-213))) (cond ((equal? sc3 1) (let ((act-1 (let ((sc4 (CoreC-45FC-isConcreteFC e-209))) (if (null? sc4) (vector 1 (vector 0 )) (let ((e-1 (unbox sc4))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-2 (cons (cons e-1 (cons 5 (box u--n))) '()) clam-1)))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 eta-0 eta-1))) e-13) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-15) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 (cons u--n arg-7) e-16 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-11 e-12 e-6 (box u--n) e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) (else (let ((act-1 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 eta-0 eta-1))) e-13) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-15) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 1 (vector 0 e-11 u--pat e-16 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 (vector 2 ) e-12 e-5 (box (vector 2 "lamc" 0)) e-6 (vector 4 e-11 '() csegen-3980 (vector 32 e-11 0) (cons (Builtin-snd e-7) '()))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))) ((2) (lambda (eta-0) (let ((act-1 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 eta-1 eta-2))) e-13) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 (cons e-210 arg-7) e-16 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-11 e-12 e-5 (box e-210) e-6 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 eta-1 eta-2))) e-13) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 1 (vector 0 e-11 e-14 e-16 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 (vector 2 ) e-12 e-5 (box (vector 2 "lamc" 0)) e-6 (vector 4 e-11 '() csegen-3980 (vector 32 e-11 0) (cons (Builtin-snd e-7) '()))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((25) (lambda (eta-0) (let ((act-1 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 eta-1 eta-2))) e-13) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-16 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-11 e-12 e-5 '() e-6 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 1 arg-7 eta-1 eta-2))) e-13) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 1 (vector 0 e-11 e-14 e-16 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 (vector 2 ) e-12 e-5 (box (vector 2 "lamc" 0)) e-6 (vector 4 e-11 '() csegen-3980 (vector 32 e-11 0) (cons (Builtin-snd e-7) '()))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))) ((3) (let ((e-18 (vector-ref arg-8 1))) (let ((e-19 (vector-ref arg-8 2))) (let ((e-20 (vector-ref arg-8 3))) (let ((e-21 (vector-ref arg-8 4))) (let ((e-22 (vector-ref arg-8 5))) (let ((e-23 (vector-ref arg-8 6))) (let ((e-24 (vector-ref arg-8 7))) (lambda (clam-0) (case (vector-ref e-20 0) ((0) (let ((e-217 (vector-ref e-20 1))) (let ((e-218 (vector-ref e-20 2))) (if (null? e-24) (let ((act-1 (let ((sc3 (CoreC-45FC-isConcreteFC e-217))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-1 (unbox sc3))) (CoreC-45Metadata-addSemanticDecorations arg-3 arg-2 (cons (cons e-1 (cons 5 (box e-218))) '()) clam-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-21) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-22) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 (cons e-218 arg-7) e-23 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-18 e-217 e-19 e-218 e-6 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-22) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-4) (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 1 eta-2 eta-4)) eta-3))) (cons (vector 0 e-18 e-20 e-23 '()) e-24) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-18 '() e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-22) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-21) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-4) (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 1 eta-2 eta-4)) eta-3))) (cons (vector 0 e-18 e-20 e-23 '()) e-24) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-18 '() e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))) ((4) (let ((e-26 (vector-ref arg-8 1))) (let ((e-27 (vector-ref arg-8 2))) (let ((e-28 (vector-ref arg-8 3))) (let ((e-29 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarFnOpt arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 eta-1 eta-2))) e-27 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-28) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--scrty (vector 32 (CoreC-45FC-virtualiseFC e-26) 0))) (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-3972 (lambda (eta-5) (IdrisC-45Desugar-desugarClause arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 1 eta-3 eta-5)) eta-4))) e-29 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 4 e-26 e-5 e-6 u--scrty e-7))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((5) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-33 (vector-ref arg-8 3))) (let ((u--psC-39 (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Syntax-definedIn e-32) arg-7))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-2 arg-4 arg-3 arg-5 u--psC-39 eta-1)) e-32 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 u--psC-39 e-33 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-31 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-3) eta-3) e-5) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((7) (let ((e-35 (vector-ref arg-8 1))) (let ((e-36 (vector-ref arg-8 2))) (let ((e-37 (vector-ref arg-8 3))) (lambda (clam-3) (case (vector-ref e-36 0) ((6) (let ((e-222 (vector-ref e-36 2))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Desugar-desugarUpdate arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 eta-0 eta-1))) e-222 '()) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-37) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-35 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))(else (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-36) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-37) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-35 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))))))) ((6) (let ((e-39 (vector-ref arg-8 1))) (let ((e-40 (vector-ref arg-8 2))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (let ((u--vfc (CoreC-45FC-virtualiseFC e-39))) (vector 2 u--vfc AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 0 u--vfc (vector 2 "rec" 0)) (vector 25 u--vfc) (vector 7 u--vfc (vector 6 e-39 e-40) (vector 0 u--vfc (vector 2 "rec" 0))))))))) ((10) (let ((e-42 (vector-ref arg-8 1))) (let ((e-43 (vector-ref arg-8 2))) (let ((e-44 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-43) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-44) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-42 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((8) (let ((e-46 (vector-ref arg-8 1))) (let ((e-47 (vector-ref arg-8 2))) (let ((e-48 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-47) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-48) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 11 e-46 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-50 (vector-ref arg-8 1))) (let ((e-51 (vector-ref arg-8 2))) (let ((e-52 (vector-ref arg-8 3))) (let ((e-53 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-51) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-53) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 10 e-50 e-5 e-52 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((11) (let ((e-55 (vector-ref arg-8 1))) (let ((e-56 (vector-ref arg-8 2))) (let ((e-57 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-57) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 20 e-55 e-56 e-5))))) eff-0) eta-0)))))))))) ((12) (let ((e-59 (vector-ref arg-8 1))) (let ((e-60 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 21 e-59 e-5))))) eff-0) eta-0))))))))) ((13) (let ((e-62 (vector-ref arg-8 1))) (let ((e-63 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-63) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 22 e-62 e-5))))) eff-0) eta-0))))))))) ((31) (let ((e-65 (vector-ref arg-8 1))) (let ((e-66 (vector-ref arg-8 2))) (let ((e-67 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-66) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-67) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 13 e-65 (vector 0 ) (cons (TTImpC-45TTImp-apply (vector 0 e-65 (vector 1 (vector 0 "==="))) (cons e-5 (cons e-6 '()))) (cons (TTImpC-45TTImp-apply (vector 0 e-65 (vector 1 (vector 0 "~=~"))) (cons e-5 (cons e-6 '()))) '()))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((32) (let ((e-70 (vector-ref arg-8 2))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-70))) ((27) (let ((e-72 (vector-ref arg-8 1))) (let ((e-73 (vector-ref arg-8 2))) (let ((e-74 (vector-ref arg-8 3))) (let ((e-75 (vector-ref arg-8 4))) (let ((e-76 (vector-ref arg-8 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Desugar-toTokList arg-0 arg-2 (vector 27 e-72 e-73 e-74 e-75 e-76) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (LibrariesC-45UtilsC-45Shunting-parseOps csegen-65 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-6))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((28) (let ((e-78 (vector-ref arg-8 1))) (let ((e-79 (vector-ref arg-8 2))) (let ((e-80 (vector-ref arg-8 3))) (let ((e-81 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 (IdrisC-45Desugar-toTokList arg-0 arg-2 (vector 28 e-78 e-79 e-80 e-81) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (LibrariesC-45UtilsC-45Shunting-parseOps csegen-65 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45Desugar-desugarTree arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-6))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((29) (let ((e-83 (vector-ref arg-8 1))) (let ((e-84 (vector-ref arg-8 2))) (let ((e-85 (vector-ref arg-8 3))) (let ((e-86 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (LibrariesC-45DataC-45ANameMap-lookupName e-85 (IdrisC-45Syntax-prefixes e-5)))) (if (null? sc2) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 2 e-83 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 0 e-83 (vector 2 "arg" 0)) (vector 25 e-83) (vector 27 e-83 e-84 e-85 (vector 0 e-83 (vector 2 "arg" 0)) e-86))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 28 e-83 e-84 e-85 e-86)))))) eff-0) eta-0))))))))))) ((30) (let ((e-88 (vector-ref arg-8 1))) (let ((e-89 (vector-ref arg-8 2))) (let ((e-90 (vector-ref arg-8 3))) (let ((e-91 (vector-ref arg-8 4))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 2 e-88 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 0 e-88 (vector 2 "arg" 0)) (vector 25 e-88) (vector 27 e-88 e-89 e-91 e-90 (vector 0 e-88 (vector 2 "arg" 0)))))))))) ((14) (let ((e-93 (vector-ref arg-8 1))) (let ((e-94 (vector-ref arg-8 2))) (lambda (eta-0) (vector 1 (vector 12 e-93 e-94)))))) ((15) (let ((e-96 (vector-ref arg-8 1))) (let ((e-97 (vector-ref arg-8 2))) (lambda (clam-4) (case (vector-ref e-97 0) ((5) (let ((e-223 (vector-ref e-97 1))) (let ((act-1 (CoreC-45Context-fromIntegerName arg-2 clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 13 e-96 (vector 2 (vector 28 e-96 (vector 5 e-223))) (cons (vector 28 e-96 (vector 5 e-223)) (cons (vector 28 e-96 (vector 0 (blodwen-toSignedInt e-223 63))) '()))))) (let ((e-2 (unbox e-5))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-96))) (lambda (eta-0) (vector 1 (vector 8 u--vfc (vector 0 u--vfc e-2) (vector 28 e-96 (vector 5 e-223)))))))))) eff-0) clam-4))))))) ((11) (let ((e-224 (vector-ref e-97 1))) (let ((act-1 (CoreC-45Context-fromCharName arg-2 clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 28 e-96 (vector 11 e-224)))) (let ((e-2 (unbox e-5))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-96))) (lambda (eta-0) (vector 1 (vector 8 u--vfc (vector 0 u--vfc e-2) (vector 28 e-96 (vector 11 e-224)))))))))) eff-0) clam-4))))))) ((12) (let ((e-225 (vector-ref e-97 1))) (let ((act-1 (CoreC-45Context-fromDoubleName arg-2 clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 28 e-96 (vector 12 e-225)))) (let ((e-2 (unbox e-5))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-96))) (lambda (eta-0) (vector 1 (vector 8 u--vfc (vector 0 u--vfc e-2) (vector 28 e-96 (vector 12 e-225)))))))))) eff-0) clam-4)))))))(else (vector 1 (vector 28 e-96 e-97)))))))) ((16) (let ((e-99 (vector-ref arg-8 1))) (let ((e-100 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-100) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--q (vector 23 e-99 e-5))) (lambda (clam-5) (cond ((equal? arg-6 1) (let ((act-2 (CoreC-45Context-fromTTImpName arg-2 clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45Desugar-maybeIApp e-99 e-6 u--q))))) eff-0) clam-5))))))(else (vector 1 u--q))))))) eff-0) eta-0))))))))) ((17) (let ((e-102 (vector-ref arg-8 1))) (let ((e-103 (vector-ref arg-8 2))) (let ((u--q (vector 24 e-102 e-103))) (lambda (clam-6) (cond ((equal? arg-6 1) (let ((act-1 (CoreC-45Context-fromNameName arg-2 clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (IdrisC-45Desugar-maybeIApp e-102 e-5 u--q))))) eff-0) clam-6))))))(else (vector 1 u--q)))))))) ((18) (let ((e-105 (vector-ref arg-8 1))) (let ((e-106 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-2 arg-4 arg-3 arg-5 arg-7 eta-1)) e-106 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--dls (vector 25 e-105 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5)))) (lambda (clam-7) (cond ((equal? arg-6 1) (let ((act-2 (CoreC-45Context-fromDeclsName arg-2 clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45Desugar-maybeIApp e-105 e-6 u--dls))))) eff-0) clam-7))))))(else (vector 1 u--dls))))))) eff-0) eta-0))))))))) ((19) (let ((e-108 (vector-ref arg-8 1))) (let ((e-109 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-109) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 26 e-108 e-5))))) eff-0) eta-0))))))))) ((20) (let ((e-111 (vector-ref arg-8 1))) (let ((e-112 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-112) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 27 e-111 1 e-5))))) eff-0) eta-0))))))))) ((21) (let ((e-114 (vector-ref arg-8 1))) (let ((e-115 (vector-ref arg-8 2))) (let ((e-116 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 (cond ((equal? e-115 1) ((let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (cons (vector 1 (vector 0 e-116)) e-8) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))) eta-0)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 30 e-114 e-116)))))))))) ((22) (let ((e-118 (vector-ref arg-8 1))) (lambda (eta-0) (vector 1 (vector 29 e-118))))) ((23) (let ((e-120 (vector-ref arg-8 1))) (let ((e-121 (vector-ref arg-8 2))) (let ((e-122 (vector-ref arg-8 3))) (let ((e-123 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-123) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 18 e-120 e-121 1 e-122 e-5))))) eff-0) eta-0))))))))))) ((24) (let ((e-125 (vector-ref arg-8 1))) (let ((e-126 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-126) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 19 e-125 4 e-5))))) eff-0) eta-0))))))))) ((25) (let ((e-128 (vector-ref arg-8 1))) (lambda (eta-0) (vector 1 (vector 32 e-128 1))))) ((26) (let ((e-130 (vector-ref arg-8 1))) (lambda (eta-0) (let ((act-1 (let ((sc1 (IdrisC-45Desugar-u--C-61C-61_Eq_Side arg-6 0))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-130 "? is not a valid pattern") eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 32 e-130 0)))))))) ((34) (let ((e-132 (vector-ref arg-8 1))) (let ((e-133 (vector-ref arg-8 2))) (let ((e-134 (vector-ref arg-8 3))) (let ((e-135 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-fromStringName arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Desugar-trimMultiline e-132 e-134 e-135 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Desugar-expandString arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-132 e-133 e-6 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (IdrisC-45Desugar-maybeIApp e-132 e-5 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((33) (let ((e-137 (vector-ref arg-8 1))) (let ((e-138 (vector-ref arg-8 2))) (let ((e-139 (vector-ref arg-8 3))) (if (null? e-139) (lambda (eta-0) (let ((act-1 (CoreC-45Context-fromStringName arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (IdrisC-45Desugar-maybeIApp e-137 e-5 (vector 28 e-137 (vector 10 ""))))))) eff-0) eta-0)))))) (let ((e-228 (car e-139))) (let ((e-229 (cdr e-139))) (case (vector-ref e-228 0) ((0) (let ((e-231 (vector-ref e-228 1))) (let ((e-232 (vector-ref e-228 2))) (lambda (clam-1) (if (null? e-229) (let ((sc4 (ParserC-45SupportC-45Escaping-unescape e-138 e-232))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-137 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Invalid escape sequence: " (cons (PreludeC-45Show-u--show_Show_String e-232) '())))) clam-1) (let ((e-1 (unbox sc4))) (let ((act-1 (CoreC-45Context-fromStringName arg-2 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (IdrisC-45Desugar-maybeIApp e-137 e-5 (vector 28 e-231 (vector 10 e-1))))))) eff-0) clam-1)))))))) (IdrisC-45Desugar-expandString arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-137 e-138 e-139 clam-1))))))(else (lambda (eta-0) (IdrisC-45Desugar-expandString arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-137 e-138 e-139 eta-0))))))))))) ((35) (let ((e-141 (vector-ref arg-8 1))) (let ((e-142 (vector-ref arg-8 2))) (let ((e-143 (vector-ref arg-8 3))) (IdrisC-45Desugar-expandDo arg-0 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-141 e-142 e-143))))) ((36) (let ((e-145 (vector-ref arg-8 1))) (let ((e-146 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-146) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--bn (vector 2 "bind" (let ((e-0 (vector-ref e-6 0))) e-0)))) (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (vector (bs+ e-0 1 63) (cons (cons u--bn (cons e-145 e-5)) e-1) e-2))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (CoreC-45FC-virtualiseFC e-145) u--bn))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((37) (let ((e-148 (vector-ref arg-8 1))) (let ((e-149 (vector-ref arg-8 2))) (let ((e-150 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-150) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45TTImp-logRaw arg-2 "desugar.idiom" 10 (lambda () "Desugaring idiom for") e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--val (IdrisC-45Desugar-idiomise e-148 (let ((e-2 (vector-ref e-7 2))) e-2) e-149 e-5))) (lambda (eta-2) (let ((act-4 (TTImpC-45TTImp-logRaw arg-2 "desugar.idiom" 10 (lambda () "Desugared to") u--val eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 u--val)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))) ((38) (let ((e-153 (vector-ref arg-8 2))) (let ((e-154 (vector-ref arg-8 3))) (IdrisC-45Desugar-expandList arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-153 e-154)))) ((39) (let ((e-157 (vector-ref arg-8 2))) (let ((e-158 (vector-ref arg-8 3))) (IdrisC-45Desugar-expandSnocList arg-0 arg-1 arg-2 arg-4 arg-3 arg-5 arg-6 arg-7 e-157 e-158)))) ((40) (let ((e-160 (vector-ref arg-8 1))) (let ((e-161 (vector-ref arg-8 2))) (let ((e-162 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-161) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-162) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--pval (TTImpC-45TTImp-apply (vector 0 e-160 IdrisC-45SyntaxC-45Builtin-mkpairname) (cons e-5 (cons e-6 '()))))) (lambda (eta-2) (vector 1 (vector 13 e-160 (vector 2 u--pval) (cons (TTImpC-45TTImp-apply (vector 0 e-160 IdrisC-45SyntaxC-45Builtin-pairname) (cons e-5 (cons e-6 '()))) (cons u--pval '())))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((41) (let ((e-164 (vector-ref arg-8 1))) (let ((e-165 (vector-ref arg-8 2))) (let ((e-166 (vector-ref arg-8 3))) (let ((e-167 (vector-ref arg-8 4))) (let ((e-168 (vector-ref arg-8 5))) (case (vector-ref e-166 0) ((0) (let ((e-237 (vector-ref e-166 1))) (let ((e-238 (vector-ref e-166 2))) (lambda (clam-2) (case (vector-ref e-238 0) ((1) (case (vector-ref e-167 0) ((25) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-168) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--pval (TTImpC-45TTImp-apply (vector 0 e-165 IdrisC-45SyntaxC-45Builtin-mkdpairname) (cons (vector 0 e-237 e-238) (cons e-5 '()))))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-237))) (lambda (eta-0) (let ((act-2 (let ((sc5 (CoreC-45FC-isConcreteFC e-237))) (if (null? sc5) (vector 1 (vector 0 )) (let ((e-1 (unbox sc5))) ((CoreC-45Metadata-addSemanticDefault arg-3 (cons e-1 (cons 5 (box e-238)))) eta-0)))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 13 e-164 (vector 2 u--pval) (cons (TTImpC-45TTImp-apply (vector 0 e-165 IdrisC-45SyntaxC-45Builtin-dpairname) (cons (vector 32 u--vfc 0) (cons (vector 2 e-237 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-238) (vector 32 u--vfc 0) e-5) '()))) (cons u--pval '())))))))))))) eff-0) clam-2))))))(else (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-167) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-168) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-165 IdrisC-45SyntaxC-45Builtin-dpairname) (cons e-5 (cons (vector 2 e-237 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-238) e-5 e-6) '()))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))(else (case (vector-ref e-167 0) ((25) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-166) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-168) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-165 IdrisC-45SyntaxC-45Builtin-mkdpairname) (cons e-5 (cons e-6 '()))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-164 "Invalid dependent pair type") clam-2)))))))))(else (lambda (clam-11) (case (vector-ref e-167 0) ((25) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-166) clam-11))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-168) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45TTImp-apply (vector 0 e-165 IdrisC-45SyntaxC-45Builtin-mkdpairname) (cons e-5 (cons e-6 '()))))))) eff-0) eta-0)))))))) eff-0) clam-11))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-164 "Invalid dependent pair type") clam-11)))))))))))) ((42) (let ((e-170 (vector-ref arg-8 1))) (lambda (eta-0) (vector 1 (vector 13 e-170 (vector 2 (vector 0 e-170 (vector 1 (vector 0 "MkUnit")))) (cons (vector 0 e-170 (vector 1 (vector 0 "Unit"))) (cons (vector 0 e-170 (vector 1 (vector 0 "MkUnit"))) '()))))))) ((43) (let ((e-172 (vector-ref arg-8 1))) (let ((e-173 (vector-ref arg-8 2))) (let ((e-174 (vector-ref arg-8 3))) (let ((e-175 (vector-ref arg-8 4))) (let ((u--fc (CoreC-45FC-virtualiseFC e-172))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-173) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-174 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-175 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 4 u--fc '() e-5 (vector 0 u--fc (vector 1 (vector 0 "Bool"))) (cons (vector 0 u--fc (vector 0 u--fc (vector 1 (vector 0 "True"))) e-6) (cons (vector 0 u--fc (vector 0 u--fc (vector 1 (vector 0 "False"))) e-7) '()))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((44) (let ((e-177 (vector-ref arg-8 1))) (let ((e-178 (vector-ref arg-8 2))) (let ((e-179 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ns (let ((e-2 (vector-ref e-5 2))) e-2))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 35 e-177 u--ns (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45Desugar-n--15371-13774-u--guard e-179 e-178 e-177 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--ns eta-1)) e-179) (cons (IdrisC-45Desugar-n--15371-13775-u--toPure e-179 e-178 e-177 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--ns e-178) '()))))))) eff-0) eta-0)))))))))) ((45) (let ((e-181 (vector-ref arg-8 1))) (let ((e-182 (vector-ref arg-8 2))) (let ((e-183 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-182) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-183) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 14 e-181 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((46) (let ((e-185 (vector-ref arg-8 1))) (let ((e-186 (vector-ref arg-8 2))) (let ((e-187 (vector-ref arg-8 3))) (let ((e-188 (vector-ref arg-8 4))) (let ((u--fc (CoreC-45FC-virtualiseFC e-185))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (if (null? e-187) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFromTo"))) (cons e-186 (cons e-188 '()))) (let ((e-2 (unbox e-187))) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFromThenTo"))) (cons e-186 (cons e-2 (cons e-188 '()))))))))))))) ((47) (let ((e-190 (vector-ref arg-8 1))) (let ((e-191 (vector-ref arg-8 2))) (let ((e-192 (vector-ref arg-8 3))) (let ((u--fc (CoreC-45FC-virtualiseFC e-190))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (if (null? e-192) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFrom"))) (cons e-191 '())) (let ((e-2 (unbox e-192))) (IdrisC-45Syntax-papply u--fc (vector 0 u--fc (vector 1 (vector 0 "rangeFromThen"))) (cons e-191 (cons e-2 '()))))))))))) ((50) (let ((e-194 (vector-ref arg-8 1))) (let ((e-195 (vector-ref arg-8 2))) (let ((e-196 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-196) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 31 e-194 e-195 e-5))))) eff-0) eta-0)))))))))) ((48) (let ((e-199 (vector-ref arg-8 2))) (let ((e-200 (vector-ref arg-8 3))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--x) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (vector 7 e-2 (vector 0 e-2 e-3) u--x))))) e-199 e-200))))) ((49) (let ((e-202 (vector-ref arg-8 1))) (let ((e-203 (vector-ref arg-8 2))) (let ((u--vfc (CoreC-45FC-virtualiseFC e-202))) (let ((u--var (vector 0 u--vfc (vector 2 "paRoot" 0)))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 2 e-202 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) u--var (vector 25 u--vfc) (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--r) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (vector 7 e-2 (vector 0 e-2 e-3) u--r))))) u--var e-203)))))))) (else (let ((e-205 (vector-ref arg-8 1))) (let ((e-206 (vector-ref arg-8 2))) (let ((e-207 (vector-ref arg-8 3))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 33 e-205 e-206 e-5)))))) (IdrisC-45Desugar-desugarB arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-207) eta-0)))))))))
(define IdrisC-45Desugar-desugarDo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.Desugar.Bang" ) (IdrisC-45Desugar-initBangs arg-7)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Desugar-desugarB arg-0 e-5 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (IdrisC-45Desugar-bindBangs (let ((e-1 (vector-ref e-7 1))) e-1) arg-7 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-desugar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (IdrisC-45Desugar-desugarDo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() arg-7 ext-0)))
(define IdrisC-45Desugar-desugarType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((e-1 (vector-ref arg-6 0))) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (let ((e-5 (vector-ref arg-6 4))) (let ((act-1 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-3 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-5 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-1 (let ((e-9 (vector-ref e-7 9))) e-9) arg-5 e-8 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector e-1 e-2 e-3 e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))
(define IdrisC-45Desugar-desugarData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (let ((act-1 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-2 arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (if (null? eta-2) (lambda (eta-3) (vector 1 '())) (let ((e-8 (unbox eta-2))) (let ((eff-0 (eta-1 e-8))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))))))) e-3 (lambda (u--tycon) (lambda (eta-1) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 u--tycon eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45BindImplicits-bindTypeNames arg-1 e-1 (let ((e-9 (vector-ref e-7 9))) e-9) arg-5 e-8 eta-2)))) eff-0) eta-1)))))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45Desugar-desugarType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-2 eta-3))) e-5 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-1 e-2 e-8 e-4 e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))) (else (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (let ((act-1 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-8 arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-9 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-7 (let ((e-13 (vector-ref e-6 9))) e-13) arg-5 e-10 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-7 e-8 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))
(define IdrisC-45DocC-45String-addDocStringNS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-0 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nC-39 (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (let ((e-1 (vector-ref e-5 2))) (vector 0 (CoreC-45NameC-45Namespace-C-60C-46C-62 e-0 arg-2) e-1))))(else (vector 0 arg-2 e-5))))) (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-1))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-13 (vector-ref e-6 5))) (let ((e-12 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (vector e-0 e-1 e-2 e-3 e-4 e-13 (LibrariesC-45DataC-45NameMap-insert u--nC-39 (vector 0 ) e-12) (LibrariesC-45DataC-45ANameMap-addName u--nC-39 arg-4 e-7) e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-3))))) eff-1) world-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45Desugar-n--15880-16972-u--toRF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((1) (let ((e-0 (vector-ref arg-13 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (vector 1 (vector 1 e-1))))(else arg-13))))(else arg-13))))
(define IdrisC-45Desugar-desugarField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((e-6 (vector-ref arg-7 5))) (let ((act-1 (IdrisC-45DocC-45String-addDocStringNS arg-1 arg-0 arg-6 e-5 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((act-2 (IdrisC-45DocC-45String-addDocStringNS arg-1 arg-0 arg-6 (IdrisC-45Desugar-n--15880-16972-u--toRF e-6 e-5 e-4 e-3 e-2 e-1 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5) e-2 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-1 eta-2))) e-4) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-6 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-1 (let ((e-14 (vector-ref e-9 9))) e-14) arg-5 e-11 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector e-1 e-3 e-10 e-5 e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))))))
(define TTImpC-45TTImp-mapNestedName (lambda (arg-1 arg-2) (let ((sc0 (DataC-45List-lookup csegen-832 arg-2 arg-1))) (if (null? sc0) arg-2 (let ((e-1 (unbox sc0))) (if (null? e-1) arg-2 (let ((e-4 (car e-1))) (if (null? e-4) arg-2 (let ((e-7 (unbox e-4))) e-7)))))))))
(define IdrisC-45ElabC-45Implementation-n--11647-13557-u--dropGot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (IdrisC-45ElabC-45Implementation-n--11647-13557-u--dropGot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-8) (CoreC-45Name-u--C-47C-61_Eq_Name arg-8 e-6)) arg-6) e-3)))(else (IdrisC-45ElabC-45Implementation-n--11647-13557-u--dropGot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))
(define TTImpC-45Utils-substLocTy (lambda (arg-0 arg-1) (let ((e-3 (vector-ref arg-1 2))) (let ((e-4 (vector-ref arg-1 3))) (vector arg-0 arg-0 e-3 (TTImpC-45Utils-substLoc arg-0 e-4))))))
(define TTImpC-45Utils-substLocData (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (vector 0 arg-0 e-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (TTImpC-45Utils-substLoc arg-0 eta-0)) e-3) e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocTy arg-0 eta-0)) e-5))))))) (else (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (vector 1 arg-0 e-8 (TTImpC-45Utils-substLoc arg-0 e-9))))))))
(define TTImpC-45Utils-substLocDecl (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (vector 0 arg-0 e-2 e-3 e-4 (TTImpC-45Utils-substLocTy arg-0 e-5))))))) ((2) (let ((e-8 (vector-ref arg-1 2))) (let ((e-9 (vector-ref arg-1 3))) (vector 2 arg-0 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-0 eta-0)) e-9))))) ((1) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (vector 1 arg-0 e-12 e-13 (TTImpC-45Utils-substLocData arg-0 e-14)))))) ((5) (let ((e-17 (vector-ref arg-1 2))) (let ((e-18 (vector-ref arg-1 3))) (vector 5 arg-0 e-17 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocDecl arg-0 eta-0)) e-18))))) ((6) (let ((e-21 (vector-ref arg-1 2))) (let ((e-22 (vector-ref arg-1 3))) (vector 6 arg-0 e-21 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocDecl arg-0 eta-0)) e-22)))))(else arg-1))))
(define TTImpC-45Utils-substLoc (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (vector 0 arg-0 e-2))) ((1) (let ((e-5 (vector-ref arg-1 2))) (let ((e-6 (vector-ref arg-1 3))) (let ((e-7 (vector-ref arg-1 4))) (let ((e-8 (vector-ref arg-1 5))) (let ((e-9 (vector-ref arg-1 6))) (vector 1 arg-0 e-5 e-6 e-7 (TTImpC-45Utils-substLoc arg-0 e-8) (TTImpC-45Utils-substLoc arg-0 e-9)))))))) ((2) (let ((e-12 (vector-ref arg-1 2))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (let ((e-15 (vector-ref arg-1 5))) (let ((e-16 (vector-ref arg-1 6))) (vector 2 arg-0 e-12 e-13 e-14 (TTImpC-45Utils-substLoc arg-0 e-15) (TTImpC-45Utils-substLoc arg-0 e-16)))))))) ((3) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (let ((e-22 (vector-ref arg-1 5))) (let ((e-23 (vector-ref arg-1 6))) (let ((e-24 (vector-ref arg-1 7))) (vector 3 arg-0 arg-0 e-20 e-21 (TTImpC-45Utils-substLoc arg-0 e-22) (TTImpC-45Utils-substLoc arg-0 e-23) (TTImpC-45Utils-substLoc arg-0 e-24)))))))) ((4) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((e-29 (vector-ref arg-1 4))) (let ((e-30 (vector-ref arg-1 5))) (vector 4 arg-0 e-27 (TTImpC-45Utils-substLoc arg-0 e-28) (TTImpC-45Utils-substLoc arg-0 e-29) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-0 eta-0)) e-30))))))) ((5) (let ((e-33 (vector-ref arg-1 2))) (let ((e-34 (vector-ref arg-1 3))) (vector 5 arg-0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocDecl arg-0 eta-0)) e-33) (TTImpC-45Utils-substLoc arg-0 e-34))))) ((8) (let ((e-37 (vector-ref arg-1 2))) (let ((e-38 (vector-ref arg-1 3))) (vector 8 arg-0 (TTImpC-45Utils-substLoc arg-0 e-37) (TTImpC-45Utils-substLoc arg-0 e-38))))) ((10) (let ((e-41 (vector-ref arg-1 2))) (let ((e-42 (vector-ref arg-1 3))) (let ((e-43 (vector-ref arg-1 4))) (vector 10 arg-0 (TTImpC-45Utils-substLoc arg-0 e-41) e-42 (TTImpC-45Utils-substLoc arg-0 e-43)))))) ((9) (let ((e-46 (vector-ref arg-1 2))) (let ((e-47 (vector-ref arg-1 3))) (vector 9 arg-0 (TTImpC-45Utils-substLoc arg-0 e-46) (TTImpC-45Utils-substLoc arg-0 e-47))))) ((11) (let ((e-50 (vector-ref arg-1 2))) (let ((e-51 (vector-ref arg-1 3))) (vector 11 arg-0 (TTImpC-45Utils-substLoc arg-0 e-50) (TTImpC-45Utils-substLoc arg-0 e-51))))) ((13) (let ((e-54 (vector-ref arg-1 2))) (let ((e-55 (vector-ref arg-1 3))) (vector 13 arg-0 e-54 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLoc arg-0 eta-0)) e-55))))) ((15) (let ((e-58 (vector-ref arg-1 2))) (vector 15 arg-0 (TTImpC-45Utils-substLoc arg-0 e-58)))) ((18) (let ((e-62 (vector-ref arg-1 3))) (let ((e-63 (vector-ref arg-1 4))) (let ((e-64 (vector-ref arg-1 5))) (vector 18 arg-0 arg-0 e-62 e-63 (TTImpC-45Utils-substLoc arg-0 e-64)))))) ((19) (let ((e-67 (vector-ref arg-1 2))) (let ((e-68 (vector-ref arg-1 3))) (vector 19 arg-0 e-67 (TTImpC-45Utils-substLoc arg-0 e-68))))) ((20) (let ((e-71 (vector-ref arg-1 2))) (let ((e-72 (vector-ref arg-1 3))) (vector 20 arg-0 e-71 (TTImpC-45Utils-substLoc arg-0 e-72))))) ((21) (let ((e-75 (vector-ref arg-1 2))) (vector 21 arg-0 (TTImpC-45Utils-substLoc arg-0 e-75)))) ((22) (let ((e-78 (vector-ref arg-1 2))) (vector 22 arg-0 (TTImpC-45Utils-substLoc arg-0 e-78)))) ((7) (let ((e-81 (vector-ref arg-1 2))) (let ((e-82 (vector-ref arg-1 3))) (vector 7 arg-0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-mapFieldUpdateTerm (lambda (eta-1) (TTImpC-45Utils-substLoc arg-0 eta-1)) eta-0)) e-81) (TTImpC-45Utils-substLoc arg-0 e-82)))))(else arg-1))))
(define TTImpC-45Utils-substLocClause (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (vector 0 arg-0 (TTImpC-45Utils-substLoc arg-0 e-2) (TTImpC-45Utils-substLoc arg-0 e-3))))) ((1) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (let ((e-11 (vector-ref arg-1 7))) (vector 1 arg-0 (TTImpC-45Utils-substLoc arg-0 e-6) e-7 (TTImpC-45Utils-substLoc arg-0 e-8) e-9 e-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-0 eta-0)) e-11))))))))) (else (let ((e-14 (vector-ref arg-1 2))) (vector 2 arg-0 (TTImpC-45Utils-substLoc arg-0 e-14)))))))
(define TTImpC-45TTImp-n--13745-7046-u--expandNS (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-2 CoreC-45NameC-45Namespace-emptyNS))) (cond ((equal? sc0 1) arg-3) (else (case (vector-ref arg-3 0) ((1) (vector 0 arg-2 arg-3)) ((2) (vector 0 arg-2 arg-3)) ((4) (vector 0 arg-2 arg-3))(else arg-3)))))))
(define TTImpC-45TTImp-n--13755-7303-u--fldnsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (PreludeC-45Types-maybe (lambda () arg-13) (lambda () (lambda (u--f) (CoreC-45NameC-45Namespace-C-60C-46C-62 arg-13 (CoreC-45NameC-45Namespace-mkNamespace u--f)))) arg-11)))
(define TTImpC-45TTImp-n--13745-7047-u--getFieldName (lambda (arg-0 arg-1 arg-2) (let ((e-4 (vector-ref arg-2 3))) e-4)))
(define TTImpC-45TTImp-n--13755-7305-u--fnsUN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-n--13745-7047-u--getFieldName arg-0 arg-1 eta-0)) arg-7)))
(define TTImpC-45TTImp-n--13755-7306-u--toRF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((1) (let ((e-0 (vector-ref arg-14 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (vector 1 (vector 1 e-1))))(else arg-14))))(else arg-14))))
(define TTImpC-45TTImp-n--13755-7304-u--fnsRF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-n--13755-7306-u--toRF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 eta-0)) (TTImpC-45TTImp-n--13755-7305-u--fnsUN arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13))))
(define TTImpC-45TTImp-n--13755-7302-u--all (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (cons (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-13 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 (TTImpC-45TTImp-n--13755-7303-u--fldnsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) eta-0)) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-n--13755-7304-u--fnsRF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (TTImpC-45TTImp-n--13755-7305-u--fnsUN arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13))))))
(define TTImpC-45TTImp-n--13745-7048-u--getName (lambda (arg-0 arg-1 arg-2) (let ((e-3 (vector-ref arg-2 2))) e-3)))
(define TTImpC-45TTImp-n--13745-7045-u--defName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-5 (vector-ref arg-4 5))) (LibrariesC-45DataC-45SortedSet-insert (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 (TTImpC-45TTImp-n--13745-7048-u--getName arg-0 arg-1 e-5)) arg-3))) ((2) (let ((e-8 (vector-ref arg-4 2))) (LibrariesC-45DataC-45SortedSet-insert (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 e-8) arg-3))) ((1) (let ((e-14 (vector-ref arg-4 4))) (case (vector-ref e-14 0) ((0) (let ((e-39 (vector-ref e-14 2))) (let ((e-42 (vector-ref e-14 5))) (PreludeC-45Types-u--foldl_Foldable_List csegen-847 arg-3 (cons (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 e-39) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 (TTImpC-45TTImp-n--13745-7048-u--getName arg-0 arg-1 eta-0))) e-42)))))) ((1) (let ((e-45 (vector-ref e-14 2))) (LibrariesC-45DataC-45SortedSet-insert (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 e-45) arg-3)))(else arg-3)))) ((3) (let ((e-18 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (TTImpC-45TTImp-n--13745-7045-u--defName arg-0 arg-1 arg-2 eta-0 eta-1))) arg-3 e-18))) ((5) (let ((e-22 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (TTImpC-45TTImp-n--13745-7045-u--defName arg-0 arg-1 arg-2 eta-0 eta-1))) arg-3 e-22))) ((6) (let ((e-25 (vector-ref arg-4 2))) (let ((e-26 (vector-ref arg-4 3))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (TTImpC-45TTImp-n--13745-7045-u--defName arg-0 arg-1 (CoreC-45NameC-45Namespace-C-60C-46C-62 arg-2 e-25) eta-0 eta-1))) arg-3 e-26)))) ((4) (let ((e-28 (vector-ref arg-4 1))) (let ((e-29 (vector-ref arg-4 2))) (let ((e-30 (vector-ref arg-4 3))) (let ((e-31 (vector-ref arg-4 4))) (let ((e-32 (vector-ref arg-4 5))) (let ((e-48 (vector-ref e-32 0))) (let ((e-49 (vector-ref e-32 1))) (let ((e-50 (vector-ref e-32 2))) (let ((e-51 (vector-ref e-32 3))) (let ((e-52 (vector-ref e-32 4))) (let ((e-53 (vector-ref e-32 5))) (PreludeC-45Types-u--foldl_Foldable_List csegen-847 arg-3 (cons (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 e-52) (TTImpC-45TTImp-n--13755-7302-u--all arg-0 arg-1 e-28 e-30 e-31 e-48 e-50 e-53 e-52 e-51 e-49 e-29 arg-3 arg-2))))))))))))))) ((9) (let ((e-35 (vector-ref arg-4 2))) (PreludeC-45Types-u--foldl_Foldable_List csegen-847 arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-n--13745-7046-u--expandNS arg-0 arg-1 arg-2 eta-0)) e-35))))(else arg-3))))
(define TTImpC-45TTImp-definedInBlock (lambda (arg-0 arg-1) (LibrariesC-45DataC-45SortedSet-toList (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (TTImpC-45TTImp-n--13745-7045-u--defName arg-1 arg-0 arg-0 eta-0 eta-1))) csegen-862 arg-1))))
(define TTImpC-45Utils-substNamesTyC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (vector e-1 e-2 e-3 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-4))))))))
(define TTImpC-45Utils-substNamesDataC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-3) e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesTyC-39 arg-0 arg-1 arg-2 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 1 e-7 e-8 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-9)))))))))
(define TTImpC-45Utils-substNamesDeclC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (vector 0 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesTyC-39 arg-0 arg-1 arg-2 e-5)))))))) ((2) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (vector 2 e-7 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-9)))))) ((1) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (vector 1 e-11 e-12 e-13 (TTImpC-45Utils-substNamesDataC-39 arg-0 arg-1 arg-2 e-14))))))) ((5) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (vector 5 e-16 e-17 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-18)))))) ((6) (let ((e-20 (vector-ref arg-3 1))) (let ((e-21 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 3))) (vector 6 e-20 e-21 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-22))))))(else arg-3))))
(define TTImpC-45Utils-substNamesC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-0 0) (case (vector-ref arg-3 0) ((0) (let ((e-81 (vector-ref arg-3 1))) (let ((e-82 (vector-ref arg-3 2))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-832 e-82 arg-1))) (cond ((equal? sc2 1) (vector 0 e-81 e-82)) (else (let ((sc3 (DataC-45List-lookup csegen-832 e-82 arg-2))) (if (null? sc3) (vector 0 e-81 e-82) (let ((e-1 (unbox sc3))) e-1)))))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-4))) (vector 1 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-5) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-6)))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-11))) (vector 2 e-8 e-9 e-10 e-11 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-12) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-13)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((u--boundC-39 (cons e-18 arg-1))) (vector 3 e-15 e-16 e-17 e-18 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-19) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-20) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-21))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 4 e-23 e-24 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-25) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-27)))))))) ((5) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-definedInBlock CoreC-45NameC-45Namespace-emptyNS e-30) arg-1))) (vector 5 e-29 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-30) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-31))))))) ((8) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (let ((e-35 (vector-ref arg-3 3))) (vector 8 e-33 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-34) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-35)))))) ((10) (let ((e-37 (vector-ref arg-3 1))) (let ((e-38 (vector-ref arg-3 2))) (let ((e-39 (vector-ref arg-3 3))) (let ((e-40 (vector-ref arg-3 4))) (vector 10 e-37 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-38) e-39 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-40))))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-43) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-44)))))) ((11) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (vector 11 e-46 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-47) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-48)))))) ((13) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (vector 13 e-50 e-51 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-52)))))) ((15) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (vector 15 e-54 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-55))))) ((18) (let ((e-57 (vector-ref arg-3 1))) (let ((e-58 (vector-ref arg-3 2))) (let ((e-59 (vector-ref arg-3 3))) (let ((e-60 (vector-ref arg-3 4))) (let ((e-61 (vector-ref arg-3 5))) (vector 18 e-57 e-58 e-59 e-60 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-61)))))))) ((19) (let ((e-63 (vector-ref arg-3 1))) (let ((e-64 (vector-ref arg-3 2))) (let ((e-65 (vector-ref arg-3 3))) (vector 19 e-63 e-64 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-65)))))) ((20) (let ((e-67 (vector-ref arg-3 1))) (let ((e-68 (vector-ref arg-3 2))) (let ((e-69 (vector-ref arg-3 3))) (vector 20 e-67 e-68 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-69)))))) ((21) (let ((e-71 (vector-ref arg-3 1))) (let ((e-72 (vector-ref arg-3 2))) (vector 21 e-71 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-72))))) ((22) (let ((e-74 (vector-ref arg-3 1))) (let ((e-75 (vector-ref arg-3 2))) (vector 22 e-74 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-75))))) ((7) (let ((e-77 (vector-ref arg-3 1))) (let ((e-78 (vector-ref arg-3 2))) (let ((e-79 (vector-ref arg-3 3))) (vector 7 e-77 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-mapFieldUpdateTerm (lambda (eta-1) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-1)) eta-0)) e-78) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-79))))))(else arg-3))))) ((equal? arg-0 1) (case (vector-ref arg-3 0) ((17) (let ((e-84 (vector-ref arg-3 1))) (let ((e-85 (vector-ref arg-3 2))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-832 (vector 1 (vector 0 e-85)) arg-1))) (cond ((equal? sc2 1) (vector 17 e-84 e-85)) (else (let ((sc3 (DataC-45List-lookup csegen-832 (vector 1 (vector 0 e-85)) arg-2))) (if (null? sc3) (vector 17 e-84 e-85) (let ((e-1 (unbox sc3))) e-1)))))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-4))) (vector 1 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-5) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-6)))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-11))) (vector 2 e-8 e-9 e-10 e-11 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-12) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-13)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((u--boundC-39 (cons e-18 arg-1))) (vector 3 e-15 e-16 e-17 e-18 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-19) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-20) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-21))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 4 e-23 e-24 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-25) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-27)))))))) ((5) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-definedInBlock CoreC-45NameC-45Namespace-emptyNS e-30) arg-1))) (vector 5 e-29 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-30) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-31))))))) ((8) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (let ((e-35 (vector-ref arg-3 3))) (vector 8 e-33 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-34) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-35)))))) ((10) (let ((e-37 (vector-ref arg-3 1))) (let ((e-38 (vector-ref arg-3 2))) (let ((e-39 (vector-ref arg-3 3))) (let ((e-40 (vector-ref arg-3 4))) (vector 10 e-37 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-38) e-39 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-40))))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-43) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-44)))))) ((11) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (vector 11 e-46 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-47) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-48)))))) ((13) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (vector 13 e-50 e-51 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-52)))))) ((15) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (vector 15 e-54 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-55))))) ((18) (let ((e-57 (vector-ref arg-3 1))) (let ((e-58 (vector-ref arg-3 2))) (let ((e-59 (vector-ref arg-3 3))) (let ((e-60 (vector-ref arg-3 4))) (let ((e-61 (vector-ref arg-3 5))) (vector 18 e-57 e-58 e-59 e-60 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-61)))))))) ((19) (let ((e-63 (vector-ref arg-3 1))) (let ((e-64 (vector-ref arg-3 2))) (let ((e-65 (vector-ref arg-3 3))) (vector 19 e-63 e-64 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-65)))))) ((20) (let ((e-67 (vector-ref arg-3 1))) (let ((e-68 (vector-ref arg-3 2))) (let ((e-69 (vector-ref arg-3 3))) (vector 20 e-67 e-68 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-69)))))) ((21) (let ((e-71 (vector-ref arg-3 1))) (let ((e-72 (vector-ref arg-3 2))) (vector 21 e-71 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-72))))) ((22) (let ((e-74 (vector-ref arg-3 1))) (let ((e-75 (vector-ref arg-3 2))) (vector 22 e-74 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-75))))) ((7) (let ((e-77 (vector-ref arg-3 1))) (let ((e-78 (vector-ref arg-3 2))) (let ((e-79 (vector-ref arg-3 3))) (vector 7 e-77 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-mapFieldUpdateTerm (lambda (eta-1) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-1)) eta-0)) e-78) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-79))))))(else arg-3)))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-4))) (vector 1 e-1 e-2 e-3 e-4 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-5) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-6)))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((u--boundC-39 (PreludeC-45Types-maybe (lambda () arg-1) (lambda () (lambda (u--n) (cons u--n arg-1))) e-11))) (vector 2 e-8 e-9 e-10 e-11 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-12) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-13)))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((u--boundC-39 (cons e-18 arg-1))) (vector 3 e-15 e-16 e-17 e-18 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-19) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-20) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-21))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (vector 4 e-23 e-24 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-25) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-26) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesClauseC-39 arg-0 arg-1 arg-2 eta-0)) e-27)))))))) ((5) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-definedInBlock CoreC-45NameC-45Namespace-emptyNS e-30) arg-1))) (vector 5 e-29 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesDeclC-39 arg-0 arg-1 arg-2 eta-0)) e-30) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-31))))))) ((8) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (let ((e-35 (vector-ref arg-3 3))) (vector 8 e-33 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-34) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-35)))))) ((10) (let ((e-37 (vector-ref arg-3 1))) (let ((e-38 (vector-ref arg-3 2))) (let ((e-39 (vector-ref arg-3 3))) (let ((e-40 (vector-ref arg-3 4))) (vector 10 e-37 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-38) e-39 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-40))))))) ((9) (let ((e-42 (vector-ref arg-3 1))) (let ((e-43 (vector-ref arg-3 2))) (let ((e-44 (vector-ref arg-3 3))) (vector 9 e-42 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-43) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-44)))))) ((11) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (vector 11 e-46 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-47) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-48)))))) ((13) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (vector 13 e-50 e-51 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-0)) e-52)))))) ((15) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (vector 15 e-54 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-55))))) ((18) (let ((e-57 (vector-ref arg-3 1))) (let ((e-58 (vector-ref arg-3 2))) (let ((e-59 (vector-ref arg-3 3))) (let ((e-60 (vector-ref arg-3 4))) (let ((e-61 (vector-ref arg-3 5))) (vector 18 e-57 e-58 e-59 e-60 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-61)))))))) ((19) (let ((e-63 (vector-ref arg-3 1))) (let ((e-64 (vector-ref arg-3 2))) (let ((e-65 (vector-ref arg-3 3))) (vector 19 e-63 e-64 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-65)))))) ((20) (let ((e-67 (vector-ref arg-3 1))) (let ((e-68 (vector-ref arg-3 2))) (let ((e-69 (vector-ref arg-3 3))) (vector 20 e-67 e-68 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-69)))))) ((21) (let ((e-71 (vector-ref arg-3 1))) (let ((e-72 (vector-ref arg-3 2))) (vector 21 e-71 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-72))))) ((22) (let ((e-74 (vector-ref arg-3 1))) (let ((e-75 (vector-ref arg-3 2))) (vector 22 e-74 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-75))))) ((7) (let ((e-77 (vector-ref arg-3 1))) (let ((e-78 (vector-ref arg-3 2))) (let ((e-79 (vector-ref arg-3 3))) (vector 7 e-77 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-mapFieldUpdateTerm (lambda (eta-1) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 eta-1)) eta-0)) e-78) (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 arg-2 e-79))))))(else arg-3))))))
(define TTImpC-45Utils-substNamesClauseC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 eta-0))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (TTImpC-45Utils-findBindableNames 1 arg-1 '() e-2))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-2) arg-1)))) (vector 0 e-1 (TTImpC-45Utils-substNamesC-39 arg-0 '() '() e-2) (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-3))))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (let ((e-9 (vector-ref arg-3 5))) (let ((e-10 (vector-ref arg-3 6))) (let ((e-11 (vector-ref arg-3 7))) (let ((u--boundC-39 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 eta-0))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (TTImpC-45Utils-findBindableNames 1 arg-1 '() e-6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45Utils-findIBindVars e-6) arg-1)))) (vector 1 e-5 (TTImpC-45Utils-substNamesC-39 arg-0 '() '() e-6) e-7 (TTImpC-45Utils-substNamesC-39 arg-0 u--boundC-39 arg-2 e-8) e-9 e-10 e-11)))))))))) (else (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (vector 2 e-13 (TTImpC-45Utils-substNamesC-39 arg-0 arg-1 '() e-14))))))))
(define TTImpC-45Utils-substNamesClause (lambda (ext-0 ext-1 ext-2) (TTImpC-45Utils-substNamesClauseC-39 0 ext-0 ext-1 ext-2)))
(define IdrisC-45ElabC-45Implementation-n--11647-13559-u--specialiseMeth (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cons arg-6 (vector 10 arg-5 (vector 0 arg-5 arg-6) (vector 1 (vector 0 "__con")) (vector 0 arg-5 arg-4)))))
(define IdrisC-45ElabC-45Implementation-n--11647-13558-u--extendBody (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) (cons arg-8 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (DataC-45List-lookup csegen-832 e-2 arg-1))) (if (null? sc1) (IdrisC-45ElabC-45Implementation-n--11647-13558-u--extendBody arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-2 arg-6) e-3 arg-8) (let ((e-4 (unbox sc1))) (let ((u--mupdates (PreludeC-45TypesC-45List-tailRecAppend arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--11647-13559-u--specialiseMeth arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) arg-2)))) (let ((u--csC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substNamesClause '() u--mupdates eta-0)) e-4))) (IdrisC-45ElabC-45Implementation-n--11647-13558-u--extendBody arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 (cons (vector 2 arg-5 e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45Utils-substLocClause arg-5 eta-0)) u--csC-39)) arg-8))))))))))))
(define IdrisC-45ElabC-45Implementation-addDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--missing (IdrisC-45ElabC-45Implementation-n--11647-13557-u--dropGot arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-3 arg-5))) (IdrisC-45ElabC-45Implementation-n--11647-13558-u--extendBody arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 '() u--missing arg-5))))
(define IdrisC-45ElabC-45Implementation-bindConstraints (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (vector 1 arg-0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-1 e-6 e-7 (IdrisC-45ElabC-45Implementation-bindConstraints arg-0 arg-1 e-3 arg-3)))))))))
(define IdrisC-45ElabC-45Implementation-bindImpls (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (vector 1 e-6 e-10 e-18 (box e-14) e-19 (IdrisC-45ElabC-45Implementation-bindImpls e-3 arg-1)))))))))))))))
(define IdrisC-45Syntax-u--C-61C-61_Eq_Pass (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 2) (cond ((equal? arg-1 2) 1)(else 0)))(else 0))))
(define IdrisC-45Syntax-defPass (lambda (arg-0) (let ((sc0 (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 0))) (cond ((equal? sc0 1) 1) (else (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 2))))))
(define CoreC-45Context-addToSave (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref e-5 0))) e-0) arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-34 (vector-ref e-5 5))) (let ((e-33 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45NameMap-insert e-6 (vector 0 ) e-34) e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 (LibrariesC-45DataC-45NameMap-insert e-6 (vector 0 ) e-24) e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45Elab-addHoleToSave (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((u--ms (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-1)))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-addToSave arg-0 arg-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-addToSave arg-0 eta-2 eta-3))) u--ms) eta-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-addPolyConstraint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((u--x (vector 1 e-1 (vector 2 e-5 e-6 e-7) e-3))) (let ((e-0 (vector-ref e-8 0))) (let ((e-18 (vector-ref e-8 1))) (let ((e-17 (vector-ref e-8 2))) (let ((e-16 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-15 (vector-ref e-8 5))) (let ((e-14 (vector-ref e-8 6))) (let ((e-13 (vector-ref e-8 7))) (let ((e-12 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (vector e-0 e-18 e-17 e-16 e-4 e-15 (cons (vector arg-0 arg-2 arg-3 arg-4 u--x arg-6) e-14) e-13 e-12 e-9 e-10 e-11))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))))(else (lambda (eta-0) (vector 1 (vector 0 )))))))))(else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define TTImpC-45ElabC-45Check-addBindIfUnsolved (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-1 (vector-ref arg-7 0))) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((e-6 (vector-ref arg-7 5))) (let ((e-7 (vector-ref arg-7 6))) (let ((e-8 (vector-ref arg-7 7))) (let ((e-9 (vector-ref arg-7 8))) (let ((e-10 (vector-ref arg-7 9))) (let ((e-11 (vector-ref arg-7 10))) (let ((e-12 (vector-ref arg-7 11))) (let ((e-13 (vector-ref arg-7 12))) (let ((e-14 (vector-ref arg-7 13))) (vector e-1 e-2 e-3 e-4 e-5 e-6 (let ((u--st (vector e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14))) (cons (cons arg-1 (cons arg-2 (cons arg-0 (cons arg-4 (cons arg-3 (cons arg-5 (cons arg-6 (let ((e-25 (vector-ref u--st 3))) e-25)))))))) e-7)) e-8 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-addAmbig (lambda (arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) eta-0) (lambda (clam-0) (if (null? arg-1) clam-0 (let ((e-5 (cdr arg-1))) (if (null? e-5) clam-0 (let ((e-1 (unbox arg-2))) (let ((e-0 (vector-ref clam-0 0))) (let ((e-8 (vector-ref clam-0 1))) (let ((e-2 (vector-ref clam-0 2))) (let ((e-3 (vector-ref clam-0 3))) (let ((e-7 (vector-ref clam-0 4))) (let ((e-6 (vector-ref clam-0 5))) (vector e-0 e-8 e-2 e-3 e-7 (cons e-1 e-6))))))))))))))))
(define TTImpC-45ElabC-45Delayed-ambiguous (lambda (arg-0) (case (vector-ref arg-0 0) ((18) 1) ((17) 1) ((20) 1) ((68) (let ((e-11 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-11))) ((69) (let ((e-14 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-14))) ((70) (let ((e-17 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-17))) ((71) (let ((e-20 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Delayed-ambiguous e-20))) ((5) (let ((e-27 (vector-ref arg-0 7))) (TTImpC-45ElabC-45Delayed-ambiguous e-27)))(else 0))))
(define TTImpC-45ElabC-45Check-tryError (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-5))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-3))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-branch arg-2 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-5 (arg-6 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45Context-commit arg-2 eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 (vector 1 e-9)))))))) eff-0) eta-4)))))) (lambda (u--err) (lambda (eta-4) (let ((act-5 (let ((act-5 (set-box! arg-4 e-5))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (set-box! arg-5 e-6))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 (set-box! arg-3 e-7))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (let ((act-8 (unbox arg-2))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (let ((act-9 (set-box! arg-2 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-40 (vector-ref e-8 5))) (let ((e-39 (vector-ref e-8 6))) (let ((e-38 (vector-ref e-8 7))) (let ((e-37 (vector-ref e-8 8))) (let ((e-36 (vector-ref e-8 9))) (let ((e-35 (vector-ref e-8 10))) (let ((e-34 (vector-ref e-8 11))) (let ((e-33 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-31 (vector-ref e-8 31))) (let ((e-32 (vector-ref e-8 32))) (vector e-0 e-1 e-2 e-3 e-4 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 (let ((e-46 (vector-ref e-12 27))) e-46) e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (vector 1 (vector 0 u--err)))))))) eff-0) eta-4)))))))))))))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-n--17524-7686-u--anyOneErrs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (if (null? arg-8) (if (null? arg-9) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "No elaborators provided") eta-0)) (let ((e-6 (car arg-9))) (let ((e-7 (cdr arg-9))) (lambda (clam-0) (if (null? e-6) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 21 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-9 '())) clam-0) (let ((e-12 (cdr e-7))) (CoreC-45Core-u--throw_Catchable_Core_Error e-12 clam-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 21 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-9 '())) clam-0)))))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (lambda (clam-1) (let ((e-15 (car e-2))) (let ((e-16 (cdr e-2))) (let ((act-1 (TTImpC-45ElabC-45Check-tryError arg-0 arg-6 arg-5 arg-4 arg-3 e-16 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-4 (vector-ref e-5 1))) (lambda (eta-0) (vector 1 e-4)))) (else (let ((e-6 (vector-ref e-5 1))) (TTImpC-45ElabC-45Check-n--17524-7686-u--anyOneErrs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 (cons arg-9 (cons e-15 e-6)))))))) eff-0) clam-1)))))))))))))
(define TTImpC-45ElabC-45Check-anyOne (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (TTImpC-45ElabC-45Check-n--17524-7686-u--anyOneErrs arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-6 '())))
(define CoreC-45Context-getAmbigLimit (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 3))) (let ((e-47 (vector-ref e-40 3))) e-47))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Ambiguity-checkAmbigDepth (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-getAmbigLimit arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ambs (let ((e-6 (vector-ref arg-4 5))) e-6))) (lambda (clam-0) (let ((sc1 (PreludeC-45Types-u--C-62_Ord_Nat (PreludeC-45TypesC-45List-lengthTR u--ambs) e-5))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 20 arg-3 (vector 8 (let ((e-2 (vector-ref e-6 1))) e-2)) u--ambs) eta-0)))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Delayed-deeper (lambda (arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--d (let ((e-11 (vector-ref e-5 10))) e-11))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-2 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 e-8 e-9 e-10 (+ u--d 1) e-12 e-13 e-14))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (arg-3 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-2))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (set-box! arg-2 (let ((e-1 (vector-ref e-8 0))) (let ((e-2 (vector-ref e-8 1))) (let ((e-3 (vector-ref e-8 2))) (let ((e-4 (vector-ref e-8 3))) (let ((e-18 (vector-ref e-8 4))) (let ((e-17 (vector-ref e-8 5))) (let ((e-16 (vector-ref e-8 6))) (let ((e-15 (vector-ref e-8 7))) (let ((e-9 (vector-ref e-8 8))) (let ((e-10 (vector-ref e-8 9))) (let ((e-12 (vector-ref e-8 11))) (let ((e-13 (vector-ref e-8 12))) (let ((e-14 (vector-ref e-8 13))) (vector e-1 e-2 e-3 e-4 e-18 e-17 e-16 e-15 e-9 e-10 u--d e-12 e-13 e-14))))))))))))))))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-handle (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (TTImpC-45ElabC-45Check-tryError arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (lambda (eta-0) (vector 1 e-2)))) (else (let ((e-6 (vector-ref e-5 1))) (arg-7 e-6)))))) eff-0) ext-0)))))))
(define CoreC-45Normalise-logGlueNF (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm arg-7) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-6 arg-6 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-68 e-8 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (cond ((equal? arg-2 "") (let ((act-6 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9)))))) "\xa;") eta-3))) (vector 1 act-6)))(else (let ((act-6 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9)))))))) "\xa;") eta-3))) (vector 1 act-6))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Delayed-n--9745-13443-u--newBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) arg-6)(else (vector 0 (CoreC-45TTC-45Binder-binderLoc arg-6) (CoreC-45TTC-45Binder-multiplicity arg-6) (vector 1 ) (CoreC-45TTC-45Binder-binderType arg-6))))))
(define TTImpC-45ElabC-45Delayed-mkClosedElab (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) (lambda (clam-0) (let ((act-1 (arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (vector 1 e-2))))) eff-0) clam-0)))))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (TTImpC-45ElabC-45Delayed-mkClosedElab e-3 arg-1 e-9 (lambda (eta-0) (let ((act-1 (arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-6 (car e-5))) (let ((u--bC-39 (TTImpC-45ElabC-45Delayed-n--9745-13443-u--newBinder e-2 e-3 e-9 e-8 arg-3 arg-1 e-8))) (lambda (eta-1) (vector 1 (cons (vector 3 arg-1 e-2 u--bC-39 e-6) (CoreC-45NormaliseC-45Eval-gErased arg-1)))))))) eff-0) eta-0))))))))))))))
(define CoreC-45Env-abstractEnvType (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (case (vector-ref e-8 0) ((1) (let ((e-11 (vector-ref e-8 1))) (let ((e-12 (vector-ref e-8 2))) (let ((e-13 (vector-ref e-8 3))) (let ((e-14 (vector-ref e-8 4))) (CoreC-45Env-abstractEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 1 e-11 e-12 e-13 e-14) arg-3))))))) ((2) (let ((e-16 (vector-ref e-8 1))) (let ((e-17 (vector-ref e-8 2))) (let ((e-18 (vector-ref e-8 3))) (let ((e-19 (vector-ref e-8 4))) (CoreC-45Env-abstractEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 2 e-16 e-17 e-18 e-19) arg-3)))))))(else (let ((u--bnd (vector 2 (CoreC-45TTC-45Binder-binderLoc e-8) (CoreC-45TTC-45Binder-multiplicity e-8) (vector 1 ) (CoreC-45TTC-45Binder-binderType e-8)))) (CoreC-45Env-abstractEnvType e-3 arg-1 e-9 (vector 3 arg-1 e-2 u--bnd arg-3))))))))))))
(define CoreC-45UnifyState-addHoleName (lambda (arg-0 arg-1 arg-2 arg-3) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector (LibrariesC-45DataC-45IntMap-insert arg-3 (cons arg-1 arg-2) e-0) e-1 (LibrariesC-45DataC-45IntMap-insert arg-3 (cons arg-1 arg-2) e-2) e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45UnifyState-n--12065-6740-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 0 arg-5 arg-3 '())))) u--args)))
(define CoreC-45UnifyState-newDelayed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((u--hty (CoreC-45Env-abstractEnvType arg-0 arg-3 arg-5 arg-7))) (let ((u--hole (CoreC-45Context-newDef arg-3 arg-6 arg-4 '() u--hty (LibrariesC-45DataC-45WithDefault-specified 2) (vector 12 )))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-addDef arg-2 arg-6 u--hole eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-2 "unify.delay" 10 (lambda () (string-append "Added delayed elaborator " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1833 (cons arg-6 e-5)))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45UnifyState-addHoleName arg-1 arg-3 arg-6 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (cons e-5 (vector 2 arg-3 arg-6 e-5 (CoreC-45UnifyState-n--12065-6740-u--envArgs arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1))))))))))))) eff-0) eta-0))))))))))
(define CoreC-45UnifyState-n--11407-6121-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-3 arg-0 arg-8 arg-6 '())))) u--args)))
(define CoreC-45UnifyState-newMetaLets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--hty (cond ((equal? arg-10 1) (CoreC-45Env-abstractFullEnvType arg-0 arg-3 arg-5 arg-7)) (else (CoreC-45Env-abstractEnvType arg-0 arg-3 arg-5 arg-7))))) (let ((u--hole (let ((sc0 (CoreC-45Context-newDef arg-3 arg-6 arg-4 '() u--hty (LibrariesC-45DataC-45WithDefault-specified 2) arg-8))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (let ((e-4 (vector-ref sc0 4))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (let ((e-8 (vector-ref sc0 8))) (let ((e-9 (vector-ref sc0 9))) (let ((e-10 (vector-ref sc0 10))) (let ((e-11 (vector-ref sc0 11))) (let ((e-12 (vector-ref sc0 12))) (let ((e-13 (vector-ref sc0 13))) (let ((e-14 (vector-ref sc0 14))) (let ((e-15 (vector-ref sc0 15))) (let ((e-17 (vector-ref sc0 17))) (let ((e-18 (vector-ref sc0 18))) (let ((e-19 (vector-ref sc0 19))) (let ((e-20 (vector-ref sc0 20))) (let ((e-21 (vector-ref sc0 21))) (let ((e-22 (vector-ref sc0 22))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 arg-9 e-17 e-18 e-19 e-20 e-21 e-22)))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "unify.meta" 5 (lambda () (string-append "Adding new meta " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1832 (cons arg-6 (cons arg-3 arg-4))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-1 "unify.meta" 10 (lambda () (string-append "New meta type " (CoreC-45Name-u--show_Show_Name arg-6))) u--hty eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-addDef arg-1 arg-6 u--hole eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45UnifyState-addHoleName arg-2 arg-3 arg-6 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (cons e-7 (vector 2 arg-3 arg-6 e-7 (CoreC-45UnifyState-n--11407-6121-u--envArgs arg-10 arg-9 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1)))))))))) eff-0) eta-0))))))))))))))))
(define CoreC-45UnifyState-newMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (CoreC-45UnifyState-newMetaLets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 0)))
(define TTImpC-45ElabC-45Check-metaVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 0)) 1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-3 (cdr e-5))) (vector 1 e-3))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-uniVar (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45UnifyState-genName arg-0 arg-1 "u" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-addDef arg-0 e-5 (CoreC-45Context-newDef arg-2 e-5 csegen-30 '() (vector 10 arg-2 (vector 0 )) (LibrariesC-45DataC-45WithDefault-specified 2) (vector 0 )) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Delayed-n--10039-13720-u--mkExpected (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (if (null? arg-12) (let ((act-1 (CoreC-45UnifyState-genName arg-11 arg-9 "delayTy" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-11 arg-9 arg-7 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-11 arg-9 arg-7 csegen-30 arg-5 e-5 (vector 11 arg-7 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-12))) (vector 1 e-1)))))
(define TTImpC-45ElabC-45Delayed-delayOnFailure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nos (let ((e-12 (vector-ref e-5 5))) e-12))) (lambda (eta-0) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (arg-11 0) (lambda (u--err) (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45ElabC-45Delayed-n--10039-13720-u--mkExpected arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-8 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (arg-9 u--err))) (cond ((equal? sc3 1) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "delayed" clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-getTerm e-7) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45UnifyState-newDelayed arg-0 arg-3 arg-1 arg-5 csegen-1416 arg-7 e-8 e-9))) eff-0) eta-3))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-6 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.delay" 5 (lambda () (string-append "Postponing elaborator " (string-append (CoreC-45Name-u--show_Show_Name e-8) (string-append " at " (string-append (CoreC-45FC-u--show_Show_FC arg-5) " for"))))) arg-7 e-7 clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "elab.delay" 10 (lambda () (string-append "Due to error " (CoreC-45Core-u--show_Show_Error u--err))) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (let ((act-8 (unbox arg-1))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-9 ((let ((eff-0 (lambda (world-0) (let ((act-9 (unbox arg-3))) (vector 1 act-9))))) (lambda (world-0) (let ((act-9 (eff-0 world-0))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-1 (lambda (world-1) (let ((act-10 (set-box! arg-3 (let ((e-0 (vector-ref e-13 0))) (let ((e-1 (vector-ref e-13 1))) (let ((e-22 (vector-ref e-13 2))) (let ((e-21 (vector-ref e-13 3))) (let ((e-4 (vector-ref e-13 4))) (let ((e-20 (vector-ref e-13 5))) (let ((e-19 (vector-ref e-13 6))) (let ((e-18 (vector-ref e-13 7))) (let ((e-17 (vector-ref e-13 8))) (let ((e-16 (vector-ref e-13 9))) (let ((e-15 (vector-ref e-13 10))) (let ((e-14 (vector-ref e-13 11))) (vector e-0 e-1 e-22 e-21 e-4 e-20 e-19 e-18 e-17 e-16 (cons (cons arg-10 (cons e-2 (cons (let ((e-45 (vector-ref e-12 10))) e-45) (TTImpC-45ElabC-45Delayed-mkClosedElab arg-0 arg-5 arg-7 (lambda (eta-5) (TTImpC-45ElabC-45Delayed-deeper arg-4 (lambda (eta-6) (let ((act-10 (let ((act-10 (unbox arg-3))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-23 (vector-ref act-10 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-10 1))) ((let ((eff-1 (let ((u--nosC-39 (let ((e-30 (vector-ref e-23 5))) e-30))) (lambda (eta-7) (let ((act-11 (let ((act-11 (set-box! arg-3 (let ((e-35 (vector-ref e-23 0))) (let ((e-34 (vector-ref e-23 1))) (let ((e-33 (vector-ref e-23 2))) (let ((e-32 (vector-ref e-23 3))) (let ((e-31 (vector-ref e-23 4))) (let ((e-29 (vector-ref e-23 6))) (let ((e-28 (vector-ref e-23 7))) (let ((e-27 (vector-ref e-23 8))) (let ((e-26 (vector-ref e-23 9))) (let ((e-25 (vector-ref e-23 10))) (let ((e-24 (vector-ref e-23 11))) (vector e-35 e-34 e-33 e-32 e-31 u--nos e-29 e-28 e-27 e-26 e-25 e-24))))))))))))))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-24 (vector-ref act-11 1))) (vector 0 e-24))) (else (let ((act-12 ((arg-11 1) eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-25 (vector-ref act-12 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-12 1))) ((let ((eff-1 (lambda (eta-8) (let ((act-13 (let ((act-13 (unbox arg-3))) (vector 1 act-13)))) (case (vector-ref act-13 0) ((0) (let ((e-26 (vector-ref act-13 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-13 1))) ((let ((eff-1 (lambda (eta-9) (let ((act-14 (let ((act-14 (set-box! arg-3 (let ((e-38 (vector-ref e-26 0))) (let ((e-37 (vector-ref e-26 1))) (let ((e-36 (vector-ref e-26 2))) (let ((e-35 (vector-ref e-26 3))) (let ((e-34 (vector-ref e-26 4))) (let ((e-32 (vector-ref e-26 6))) (let ((e-31 (vector-ref e-26 7))) (let ((e-30 (vector-ref e-26 8))) (let ((e-29 (vector-ref e-26 9))) (let ((e-28 (vector-ref e-26 10))) (let ((e-27 (vector-ref e-26 11))) (vector e-38 e-37 e-36 e-35 e-34 u--nosC-39 e-32 e-31 e-30 e-29 e-28 e-27))))))))))))))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-27 (vector-ref act-14 1))) (vector 0 e-27))) (else (vector 1 e-25))))))) eff-1) eta-8)))))))) eff-1) eta-7)))))))))))) eff-1) eta-6)))))) eta-5)))))) e-15) e-14)))))))))))))))) (vector 1 act-10))))) eff-1) world-0))))))) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 e-7)))))))) eff-0) clam-1)))))))))))))))) eff-0) eta-3)))))))) eff-0) clam-0)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-0))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-n--16334-6612-u--abandon (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((7) 1) ((68) (let ((e-4 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--16334-6612-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-4))) ((69) (let ((e-7 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--16334-6612-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7))) ((70) (let ((e-10 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--16334-6612-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-10))) ((71) (let ((e-13 (vector-ref arg-10 3))) (TTImpC-45ElabC-45Check-n--16334-6612-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-13))) ((21) (let ((e-14 (vector-ref arg-10 1))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45ElabC-45Check-n--16334-6612-u--abandon arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (Builtin-snd eta-0))) e-14)))(else 0))))
(define TTImpC-45ElabC-45Check-successful (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (vector 1 '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ncons (cond ((equal? arg-6 1) 0) (else (PreludeC-45TypesC-45List-length (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1))))))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-5))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-3))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-branch arg-2 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-5 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "elab" 5 (lambda (eta-5) (let ((act-5 ((PreludeC-45Types-maybe (lambda () csegen-2472) (lambda () (lambda (eta-6) (lambda (eta-7) (CoreC-45Context-toFullNames arg-2 csegen-54 eta-6 eta-7)))) e-6) eta-5))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (string-append "Running " (CoreC-45Name-u--show_Show_Name e-11)))))) eff-0) eta-5)))))) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (e-7 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (let ((act-7 (unbox arg-4))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--nconsC-39 (cond ((equal? arg-6 1) 0) (else (PreludeC-45TypesC-45List-length (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-13 1))) e-1))))))) (lambda (eta-6) (let ((act-8 (let ((act-8 (unbox arg-5))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-9 (let ((act-9 (unbox arg-3))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-10 (let ((act-10 (unbox arg-2))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-11 (let ((act-11 (set-box! arg-4 e-5))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 (let ((act-12 (set-box! arg-5 e-8))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((act-13 (let ((act-13 (set-box! arg-3 e-9))) (vector 1 act-13)))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((act-14 (let ((act-14 (set-box! arg-2 e-10))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((act-15 (CoreC-45ContextC-45Log-unverifiedLogC arg-2 "elab" 5 (lambda (eta-10) (let ((act-15 ((PreludeC-45Types-maybe (lambda () csegen-2472) (lambda () (lambda (eta-11) (lambda (eta-12) (CoreC-45Context-toFullNames arg-2 csegen-54 eta-11 eta-12)))) e-6) eta-10))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-11) (vector 1 (string-append "Success " (string-append (CoreC-45Name-u--show_Show_Name e-21) (string-append " (" (string-append (PreludeC-45Show-u--show_Show_Nat u--nconsC-39) (string-append " - " (string-append (PreludeC-45Show-u--show_Show_Nat u--ncons) ")")))))))))) eff-0) eta-10)))))) eta-9))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((act-16 ((TTImpC-45ElabC-45Check-successful arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) eta-9))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-10) (vector 1 (cons (vector 1 (cons (PreludeC-45Types-prim__integerToNat (- u--nconsC-39 u--ncons)) (cons e-12 (cons e-16 (cons e-13 (cons e-14 e-15)))))) e-22))))) eff-0) eta-9))))))))))))))))))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6))))))))) eff-0) eta-5)))))))) eff-0) eta-4))))))))) (lambda (u--err) (lambda (eta-4) (let ((act-5 (let ((act-5 (set-box! arg-4 e-5))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (let ((act-6 (set-box! arg-5 e-8))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (let ((act-7 (set-box! arg-3 e-9))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (let ((act-8 (set-box! arg-2 e-10))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (let ((sc10 (TTImpC-45ElabC-45Check-n--16334-6612-u--abandon arg-1 e-6 e-7 e-3 arg-6 arg-5 arg-4 arg-3 arg-2 u--err))) (cond ((equal? sc10 1) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-4)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 ((TTImpC-45ElabC-45Check-successful arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3) eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (cons (vector 0 (cons e-6 u--err)) e-16))))) eff-0) eta-4)))))))))))))))))))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45ElabC-45Check-n--16899-7144-u--getDepthError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((20) (box arg-9))(else '()))))
(define TTImpC-45ElabC-45Check-n--16899-7143-u--depthError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-7 (cdr e-2))) (PreludeC-45Types-maybe (lambda () (TTImpC-45ElabC-45Check-n--16899-7143-u--depthError arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)) (lambda () (lambda (eta-0) (box eta-0))) (TTImpC-45ElabC-45Check-n--16899-7144-u--getDepthError arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-7))))))))
(define TTImpC-45ElabC-45Check-n--16899-7145-u--getRes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-10 (car e-3))) (cons (let ((e-0 (vector-ref e-10 0))) e-0) e-6)))))))
(define TTImpC-45ElabC-45Check-n--16899-7142-u--altError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11) (if (null? arg-11) (let ((sc1 (TTImpC-45ElabC-45Check-n--16899-7143-u--depthError arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10))) (if (null? sc1) (vector 21 arg-10) (let ((e-2 (unbox sc1))) e-2))) (vector 18 arg-0 arg-3 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Check-n--16899-7145-u--getRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-0)) arg-11)))))
(define TTImpC-45ElabC-45Check-case--exactlyOneC-39C-44getRight-7163 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 arg-12) (if (null? arg-12) (let ((sc1 (PreludeC-45TypesC-45List-filterAppend '() csegen-2471 arg-12))) (if (null? sc1) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-1 (car sc1))) (let ((e-2 (cdr sc1))) (if (null? e-1) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-6 (cdr e-1))) (if (null? e-2) (vector 1 e-6) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12))))))))) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? e-1) (let ((sc2 (PreludeC-45TypesC-45List-filterAppend '() csegen-2471 arg-12))) (if (null? sc2) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-4 (car sc2))) (let ((e-3 (cdr sc2))) (if (null? e-4) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-6 (cdr e-4))) (if (null? e-3) (vector 1 e-6) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12))))))))) (let ((e-6 (cdr e-1))) (if (null? e-2) (vector 1 e-6) (let ((sc3 (PreludeC-45TypesC-45List-filterAppend '() csegen-2471 arg-12))) (if (null? sc3) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (if (null? e-4) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)) (let ((e-7 (cdr e-4))) (if (null? e-3) (vector 1 e-7) (vector 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-12)))))))))))))))))
(define TTImpC-45ElabC-45Check-n--16899-7146-u--getRight (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11) (TTImpC-45ElabC-45Check-case--exactlyOneC-39C-44getRight-7163 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 (DataC-45Either-rights arg-11))))
(define TTImpC-45ElabC-45Check-exactlyOneC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Check-successful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (TTImpC-45ElabC-45Check-n--16899-7146-u--getRight arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 1))) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (lambda (clam-2) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (let ((e-20 (car e-17))) (let ((e-21 (cdr e-17))) (let ((act-2 (let ((act-2 (set-box! arg-3 e-16))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (let ((act-3 (set-box! arg-4 e-20))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 (let ((act-4 (set-box! arg-2 e-21))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 (let ((act-5 (set-box! arg-1 e-12))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((act-6 (CoreC-45Context-commit arg-1 clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (vector 1 e-8))))))))))))))))))))))))))) (else (let ((e-6 (vector-ref sc2 1))) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Check-n--16899-7142-u--altError arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45Either-lefts e-5) e-6) eta-1)))))))) eff-0) eta-0)))))) (let ((e-1 (car arg-8))) (let ((e-2 (cdr arg-8))) (if (null? e-1) (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Check-successful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc3 (TTImpC-45ElabC-45Check-n--16899-7146-u--getRight arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5))) (case (vector-ref sc3 0) ((1) (let ((e-3 (vector-ref sc3 1))) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (lambda (clam-1) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (let ((e-20 (car e-17))) (let ((e-21 (cdr e-17))) (let ((act-2 (let ((act-2 (set-box! arg-3 e-16))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (let ((act-3 (set-box! arg-4 e-20))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (let ((act-4 (set-box! arg-2 e-21))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (let ((act-5 (set-box! arg-1 e-12))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45Context-commit arg-1 clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (vector 1 e-8))))))))))))))))))))))))))) (else (let ((e-6 (vector-ref sc3 1))) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Check-n--16899-7142-u--altError arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45Either-lefts e-5) e-6) eta-1)))))))) eff-0) eta-0)))))) (let ((e-6 (cdr e-1))) (if (null? e-2) e-6 (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Check-successful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc4 (TTImpC-45ElabC-45Check-n--16899-7146-u--getRight arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7))) (case (vector-ref sc4 0) ((1) (let ((e-3 (vector-ref sc4 1))) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (lambda (clam-0) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (let ((e-20 (car e-17))) (let ((e-21 (cdr e-17))) (let ((act-2 (let ((act-2 (set-box! arg-3 e-16))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (let ((act-3 (set-box! arg-4 e-20))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (let ((act-4 (set-box! arg-2 e-21))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (let ((act-5 (set-box! arg-1 e-12))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45Context-commit arg-1 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (vector 1 e-8))))))))))))))))))))))))))) (else (let ((e-8 (vector-ref sc4 1))) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Check-n--16899-7142-u--altError arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45Either-lefts e-7) e-8) eta-1)))))))) eff-0) eta-0))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-getName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (box e-2))) ((8) (let ((e-5 (vector-ref arg-0 2))) (TTImpC-45ElabC-45Ambiguity-getName e-5))) ((10) (let ((e-9 (vector-ref arg-0 2))) (TTImpC-45ElabC-45Ambiguity-getName e-9))) ((9) (let ((e-14 (vector-ref arg-0 2))) (TTImpC-45ElabC-45Ambiguity-getName e-14)))(else '()))))
(define CoreC-45Unify-inLHS (cons 1 0))
(define CoreC-45Unify-inTerm (cons 1 1))
(define CoreC-45Normalise-logTermNF (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (CoreC-45Normalise-logTermNFC-39 arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 clam-0)) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Ambiguity-mightMatchArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-2 arg-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45Ambiguity-mightMatchD arg-0 arg-1 arg-2 e-5 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cond ((equal? e-7 2) 0)(else 1)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Ambiguity-mightMatchArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-3) (if (null? arg-4) (vector 1 1) (vector 1 0)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? arg-4) (vector 1 0) (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (let ((act-1 (TTImpC-45ElabC-45Ambiguity-mightMatchArg arg-0 arg-1 arg-2 e-2 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 e-3 e-7)) (else (lambda (eta-0) (vector 1 0)))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-mightMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-61 (vector-ref arg-4 1))) (let ((e-63 (vector-ref arg-4 3))) (let ((e-64 (vector-ref arg-4 4))) (case (vector-ref e-63 0) ((2) (lambda (eta-0) (let ((act-1 (((e-64 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-61 (vector 0 )))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Ambiguity-mightMatchD arg-0 arg-1 arg-2 arg-3 e-5))) eff-0) eta-0)))))))(else (case (vector-ref arg-3 0) ((0) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (vector 1 1))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((3) (let ((e-14 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((3) (let ((e-44 (vector-ref arg-4 2))) (let ((e-47 (vector-ref arg-4 5))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-14 e-44))) (cond ((equal? sc3 1) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-17) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-47)) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))) eff-0) clam-1)))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((2) (let ((e-21 (vector-ref arg-3 3))) (let ((e-23 (vector-ref arg-3 5))) (lambda (clam-2) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-21 e-51))) (cond ((equal? sc3 1) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-23) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-53)) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-5) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))) eff-0) clam-2)))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((8) (let ((e-26 (vector-ref arg-3 2))) (lambda (clam-3) (case (vector-ref arg-4 0) ((8) (let ((e-56 (vector-ref arg-4 2))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-56))) (cond ((equal? sc3 1) (vector 1 0)) (else (vector 1 2))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2)))))))) ((10) (lambda (clam-4) (case (vector-ref arg-4 0) ((10) (vector 1 0))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-10) (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))))))(else (case (vector-ref arg-3 0) ((0) (lambda (clam-5) (case (vector-ref arg-4 0) ((0) (vector 1 1))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((3) (let ((e-14 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 5))) (lambda (clam-6) (case (vector-ref arg-4 0) ((3) (let ((e-44 (vector-ref arg-4 2))) (let ((e-47 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-14 e-44))) (cond ((equal? sc2 1) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-17) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-47)) clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-13) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))) eff-0) clam-6)))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((2) (let ((e-21 (vector-ref arg-3 3))) (let ((e-23 (vector-ref arg-3 5))) (lambda (clam-7) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-21 e-51))) (cond ((equal? sc2 1) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-mightMatchArgs arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-23) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-53)) clam-7))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-16) (cond ((equal? e-5 1) (vector 1 0)) (else (vector 1 2)))))) eff-0) clam-7)))))) (else (vector 1 2)))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))) ((8) (let ((e-26 (vector-ref arg-3 2))) (lambda (clam-8) (case (vector-ref arg-4 0) ((8) (let ((e-56 (vector-ref arg-4 2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-26 e-56))) (cond ((equal? sc2 1) (vector 1 0)) (else (vector 1 2))))))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2)))))))) ((10) (lambda (clam-9) (case (vector-ref arg-4 0) ((10) (vector 1 0))(else (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-21) (case (vector-ref arg-4 0) ((1) (vector 1 1)) ((9) (vector 1 1))(else (vector 1 2))))))))))
(define TTImpC-45ElabC-45Ambiguity-stripDelay (lambda (arg-1) (case (vector-ref arg-1 0) ((5) (let ((e-3 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Ambiguity-stripDelay e-3)))(else arg-1))))
(define TTImpC-45ElabC-45Ambiguity-mightMatchD (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (TTImpC-45ElabC-45Ambiguity-mightMatch arg-0 arg-1 arg-2 (TTImpC-45ElabC-45Ambiguity-stripDelay arg-3) (TTImpC-45ElabC-45Ambiguity-stripDelay arg-4))))
(define TTImpC-45ElabC-45Ambiguity-couldBeName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-lookupTyExact arg-4 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 1) (let ((e-2 (unbox e-5))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() arg-2 '() e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45Ambiguity-mightMatchD arg-0 arg-1 arg-2 arg-3 e-6))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Ambiguity-couldBeFn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (TTImpC-45ElabC-45Ambiguity-couldBeName arg-0 arg-1 arg-2 arg-3 e-2 clam-0))) ((13) (vector 1 0))(else (vector 1 1))))))
(define TTImpC-45TTImp-getFn (lambda (arg-1) (case (vector-ref arg-1 0) ((8) (let ((e-2 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-2))) ((11) (let ((e-6 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-6))) ((10) (let ((e-10 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-10))) ((9) (let ((e-15 (vector-ref arg-1 2))) (TTImpC-45TTImp-getFn e-15))) ((18) (let ((e-22 (vector-ref arg-1 5))) (TTImpC-45TTImp-getFn e-22))) ((19) (let ((e-26 (vector-ref arg-1 3))) (TTImpC-45TTImp-getFn e-26)))(else arg-1))))
(define TTImpC-45ElabC-45Ambiguity-couldBe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-3 0) ((3) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-couldBeFn arg-0 arg-1 arg-2 arg-3 (TTImpC-45TTImp-getFn arg-4)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-6 0) (vector 1 (box (cons 1 arg-4)))) ((equal? e-6 1) (vector 1 (box (cons 0 arg-4)))) (else (vector 1 '())))))) eff-0) ext-0)))))) ((8) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-couldBeFn arg-0 arg-1 arg-2 arg-3 (TTImpC-45TTImp-getFn arg-4)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-5 0) (vector 1 (box (cons 1 arg-4)))) ((equal? e-5 1) (vector 1 (box (cons 0 arg-4)))) (else (vector 1 '())))))) eff-0) ext-0)))))) ((10) (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-couldBeFn arg-0 arg-1 arg-2 arg-3 (TTImpC-45TTImp-getFn arg-4)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-5 0) (vector 1 (box (cons 1 arg-4)))) ((equal? e-5 1) (vector 1 (box (cons 0 arg-4)))) (else (vector 1 '())))))) eff-0) ext-0))))))(else (vector 1 (box (cons 0 arg-4)))))))
(define TTImpC-45ElabC-45Ambiguity-filterCore (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 ((arg-1 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Ambiguity-filterCore arg-1 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-5 1) (vector 1 (cons e-2 e-6))) (else (vector 1 e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Ambiguity-n--15798-4769-u--notOverloadableFn (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 2))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 1) (vector 1 0))))) eff-0) ext-0)))))))(else (vector 1 1)))))
(define TTImpC-45ElabC-45Ambiguity-notOverloadable (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 1) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-n--15798-4769-u--notOverloadableFn e-2 e-3 arg-0 (TTImpC-45TTImp-getFn e-3) eta-0))))))))
(define TTImpC-45ElabC-45Ambiguity-pruneByType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ElabC-45Ambiguity-couldBe arg-1 arg-0 e-5 (TTImpC-45ElabC-45Ambiguity-stripDelay arg-4) eta-1 eta-2))) arg-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--matches (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) eta-1) e-6))) (lambda (eta-1) (let ((act-3 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.prune" 10 (lambda () "Prune by") arg-3 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "elab.prune" 10 (lambda () (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2608 u--matches)) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-2) (Builtin-fst eta-2)) u--matches))) (cond ((equal? sc4 1) (let ((act-5 (TTImpC-45ElabC-45Ambiguity-filterCore (lambda (eta-2) (TTImpC-45ElabC-45Ambiguity-notOverloadable e-5 eta-2)) u--matches eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (CoreC-45ContextC-45Log-log arg-1 "elab.prune" 10 (lambda () (string-append "Keep " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2608 e-9))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-9)))))))) eff-0) eta-1)))))) (else (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) u--matches))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc5 (DataC-45List-isNil e-9))) (cond ((equal? sc5 1) (vector 1 arg-5)) (else (vector 1 e-9))))))) eff-0) eta-1))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Context-defaultPI (vector '() 0 0))
(define CoreC-45UnifyState-handleUnify (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45UnifyState-tryErrorUnify arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (lambda (eta-0) (vector 1 e-2)))) (else (let ((e-6 (vector-ref e-5 1))) (arg-5 e-6)))))) eff-0) ext-0)))))))
(define CoreC-45Unify-inMatch (cons 1 2))
(define CoreC-45Unify-recoverable (lambda (arg-0) (case (vector-ref arg-0 0) ((7) 0) ((68) (let ((e-4 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-4))) ((69) (let ((e-7 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-7))) ((70) (let ((e-10 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-10))) ((71) (let ((e-13 (vector-ref arg-0 3))) (CoreC-45Unify-recoverable e-13))) ((5) (let ((e-20 (vector-ref arg-0 7))) (CoreC-45Unify-recoverable e-20))) ((72) (let ((e-21 (vector-ref arg-0 1))) (CoreC-45Unify-recoverable e-21)))(else 1))))
(define CoreC-45UnifyState-removeGuess (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 (LibrariesC-45DataC-45IntMap-delete arg-1 e-1) e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45NormaliseC-45Eval-continueNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (CoreC-45NormaliseC-45Eval-applyToStack arg-2 CoreC-45Value-defaultOpts arg-0 arg-1 arg-3 arg-4 '())))
(define CoreC-45UnifyState-deleteConstraint (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 (LibrariesC-45DataC-45IntMap-delete arg-1 e-4) e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Unify-u--show_Show_AddLazy (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "NoLazy") ((1) "AddForce") (else "AddDelay"))))
(define CoreC-45Unify-u--show_Show_UnifyMode (lambda (arg-0) (cond ((equal? arg-0 0) "InLHS") ((equal? arg-0 1) "InTerm") ((equal? arg-0 2) "InMatch") (else "InSearch"))))
(define CoreC-45Unify-case--retry-28129 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 CoreC-45Unify-success) (let ((e-2 (unbox arg-5))) (case (vector-ref e-2 0) ((1) (vector 1 CoreC-45Unify-success)) (else (let ((e-3 (vector-ref e-2 1))) (let ((e-4 (vector-ref e-2 2))) (let ((e-5 (vector-ref e-2 3))) (let ((e-6 (vector-ref e-2 4))) (let ((e-7 (vector-ref e-2 5))) (let ((e-8 (vector-ref e-2 6))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-3 e-9 e-6 e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-3 e-9 e-6 e-8) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-3) (let ((act-4 (CoreC-45Normalise-logNF e-3 arg-0 "unify.retry" 5 (lambda () (string-append "Retrying " (string-append (PreludeC-45Show-u--show_Show_Int arg-1) (string-append " " (CoreC-45Unify-u--show_Show_UnifyMode (let ((e-1 (cdr arg-2))) e-1)))))) e-6 e-10 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((act-5 (CoreC-45Normalise-logNF e-3 arg-0 "unify.retry" 5 (lambda () "....with") e-6 e-11 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "unify.retry" 5 (cond ((equal? e-5 1) (lambda () "(lazy allowed)")) (else (lambda () "(no lazy)"))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((act-7 (cond ((equal? e-5 1) (((((CoreC-45Unify-unifyWithLazy (csegen-2479) e-3 arg-0 arg-3 arg-2 e-4) e-6) e-10) e-11) eta-3)) (else (((((CoreC-45Unify-unify (csegen-2479) e-3 arg-0 arg-3 (CoreC-45Unify-lower arg-2) e-4) e-6) e-10) e-11) eta-3))))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-0 (vector-ref e-15 0))) (if (null? e-0) (let ((act-8 (CoreC-45ContextC-45Log-log arg-0 "unify.retry" 5 (lambda () (string-append "Success " (CoreC-45Unify-u--show_Show_AddLazy (let ((e-18 (vector-ref e-15 3))) e-18)))) clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-18 (vector-ref act-8 1))) (vector 0 e-18))) (else (let ((act-9 ((CoreC-45UnifyState-deleteConstraint arg-3 arg-1) clam-1))) (case (vector-ref act-9 0) ((0) (let ((e-19 (vector-ref act-9 1))) (vector 0 e-19))) (else (vector 1 e-15))))))) (let ((act-8 (CoreC-45ContextC-45Log-log arg-0 "unify.retry" 5 (lambda () (string-append "Constraints " (CoreC-45Unify-u--show_Show_AddLazy (let ((e-18 (vector-ref e-15 3))) e-18)))) clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-18 (vector-ref act-8 1))) (vector 0 e-18))) (else (vector 1 e-15))))))))) eff-0) eta-3))))))))))))))) (lambda (u--err) (lambda (eta-3) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-clearDefs e-12 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-3 e-13 e-6 e-10 eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-7 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-3 e-13 e-6 e-11 eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 5 e-3 e-4 (let ((e-0 (vector-ref e-12 0))) e-0) e-6 e-14 e-15 u--err) eta-7)))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))))
(define CoreC-45Unify-retry (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Unify-case--retry-28129 arg-0 arg-3 arg-2 arg-1 e-5 (LibrariesC-45DataC-45IntMap-lookup arg-3 (let ((e-4 (vector-ref e-5 4))) e-4))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-abandonIfCycle (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 (vector 0 )) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-1 arg-0 e-5 arg-2 arg-3 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Cycle in search") eta-1))) (else (lambda (eta-1) (CoreC-45AutoSearch-abandonIfCycle arg-0 arg-1 arg-2 arg-3 e-3 eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45AutoSearch-n--13763-6219-u--drop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13 arg-14) (if (null? arg-14) '() (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-12 arg-13))) (cond ((equal? sc1 1) (cons e-2 (CoreC-45AutoSearch-n--13763-6219-u--drop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (+ arg-12 1) arg-13 e-3))) (else (CoreC-45AutoSearch-n--13763-6219-u--drop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (+ arg-12 1) arg-13 e-3)))))))))
(define CoreC-45AutoSearch-n--13763-6218-u--concrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-4 (vector-ref arg-12 4))) (lambda (eta-0) (let ((act-1 (((e-4 arg-11) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-6 (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--13763-6218-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 0))) eff-0) eta-0))))))))) ((3) (let ((e-6 (vector-ref arg-12 1))) (let ((e-7 (vector-ref arg-12 2))) (let ((e-10 (vector-ref arg-12 5))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getSearchData arg-10 e-6 0 e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--argsC-39 (CoreC-45AutoSearch-n--13763-6219-u--drop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 0 (let ((e-0 (car e-5))) e-0) e-10))) (CoreC-45Core-traverse_ (lambda (u--parg) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-10 arg-0 arg-11 u--parg) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--13763-6218-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-11 0))) eff-0) eta-1))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) u--argsC-39))))) eff-0) eta-0)))))))))) ((2) (let ((e-16 (vector-ref arg-12 5))) (CoreC-45Core-traverse_ (lambda (u--parg) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-10 arg-0 arg-11 u--parg) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--13763-6218-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 0))) eff-0) eta-0))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-16)))) ((1) (let ((e-19 (vector-ref arg-12 2))) (lambda (clam-0) (case (vector-ref e-19 0) ((2) (let ((e-22 (vector-ref e-19 1))) (let ((e-23 (vector-ref e-19 2))) (cond ((equal? arg-13 1) (let ((act-1 (CoreC-45Context-lookupDefExact e-22 (let ((e-0 (vector-ref arg-11 0))) e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 31 '() arg-8 e-22 e-23 '() arg-5) clam-1) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((7) (let ((e-3 (vector-ref e-1 2))) (let ((sc6 (let ((e-0 (car e-3))) e-0))) (cond ((equal? sc6 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 31 '() arg-8 e-22 e-23 '() arg-5) clam-1))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 31 '() arg-8 e-22 e-23 '() arg-5) clam-1)))))))) eff-0) clam-0)))))) ((equal? arg-13 0) (let ((act-1 (CoreC-45Context-lookupDefExact e-22 (let ((e-0 (vector-ref arg-11 0))) e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-8 (let ((e-0 (vector-ref arg-11 0))) e-0) '() arg-5 '()) clam-2) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((7) (let ((e-3 (vector-ref e-1 2))) (let ((sc6 (let ((e-0 (car e-3))) e-0))) (cond ((equal? sc6 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-8 (let ((e-0 (vector-ref arg-11 0))) e-0) '() arg-5 '()) clam-2))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-8 (let ((e-0 (vector-ref arg-11 0))) e-0) '() arg-5 '()) clam-2)))))))) eff-0) clam-0))))))(else (vector 1 (vector 0 )))))))(else (vector 1 (vector 0 )))))))(else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define CoreC-45AutoSearch-concreteDets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (if (null? arg-9) (vector 1 (vector 0 )) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((act-1 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-7 arg-8))) (cond ((equal? sc1 1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Normalise-logNF arg-0 arg-1 "auto.determining" 10 (lambda () "Checking that the following argument is concrete") arg-5 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else ((CoreC-45AutoSearch-n--13763-6218-u--concrete arg-0 e-2 e-3 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 1) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (+ arg-7 1) arg-8 e-3 ext-0)))))))))
(define CoreC-45Context-isPairType (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-4 (vector-ref e-5 4))) (lambda (clam-0) (let ((e-39 (vector-ref e-4 4))) (if (null? e-39) (vector 1 0) (let ((e-44 (unbox e-39))) (let ((act-2 (CoreC-45Context-getFullName arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-45 (vector-ref act-2 1))) (vector 0 e-45))) (else (let ((e-45 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getFullName arg-0 (let ((e-48 (vector-ref e-44 0))) e-48) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-46 (vector-ref act-3 1))) (vector 0 e-46))) (else (let ((e-46 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-45 e-46))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-checkConcreteDets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((3) (let ((e-2 (vector-ref arg-7 2))) (let ((e-5 (vector-ref arg-7 5))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-isPairType arg-1 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-7 1) (if (null? e-5) (lambda (eta-1) (let ((act-3 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-8))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-5) eta-2)))) eff-0) eta-1)))))) (let ((e-9 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-9) (lambda (eta-1) (let ((act-3 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-10))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-5) eta-2)))) eff-0) eta-1)))))) (let ((e-10 (cdr e-9))) (if (null? e-8) (lambda (eta-1) (let ((act-3 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-12))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-5) eta-2)))) eff-0) eta-1)))))) (let ((e-13 (car e-8))) (let ((e-12 (cdr e-8))) (lambda (clam-0) (if (null? e-13) (let ((act-3 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-14))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5) eta-1)))) eff-0) clam-0))))) (let ((e-14 (cdr e-13))) (if (null? e-12) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-6 e-10) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-6 e-14) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-16 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-17 eta-2))))))) eff-0) eta-1)))))))) eff-0) clam-0))))) (let ((act-3 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-16))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-5) eta-1)))) eff-0) clam-0)))))))))))))))))) (else (lambda (eta-1) (let ((act-3 (CoreC-45Context-getSearchData arg-1 arg-3 arg-4 e-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-54 e-2 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45ContextC-45Log-log arg-1 "auto.determining" 10 (lambda () (string-append "Determining arguments for " (string-append (CoreC-45Name-u--show_Show_Name e-9) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-895 (let ((e-0 (car e-8))) e-0)))))) eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (CoreC-45AutoSearch-concreteDets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 (let ((e-0 (car e-8))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-5) eta-2))))))) eff-0) eta-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))(else (vector 1 (vector 0 ))))))
(define CoreC-45AutoSearch-successful (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-branch arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-3 (e-2 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 (unbox arg-2))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (let ((act-5 (unbox arg-1))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (let ((act-6 (set-box! arg-2 e-5))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (let ((act-7 (set-box! arg-1 e-6))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 e-3 eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (cons (vector 1 (cons e-7 (cons e-9 e-8))) e-12))))) eff-0) eta-5)))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) (lambda (u--err) (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-2 e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (let ((act-4 (set-box! arg-1 e-6))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 e-3 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (vector 0 u--err) e-9))))) eff-0) eta-2))))))))))))) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45AutoSearch-n--10409-3248-u--normRes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-3))) (CoreC-45Normalise-normaliseHoles arg-7 arg-0 e-6 arg-4 e-2 clam-0)))))))
(define CoreC-45AutoSearch-case--exactlyOne-3282 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-5 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-3 '()) eta-1)))) eff-0) eta-0)))))) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (if (null? e-1) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CoreC-45AutoSearch-n--10409-3248-u--normRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-3)) arg-9 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 19 arg-0 arg-5 arg-4 e-6 e-7) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-0) (if (null? e-7) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45AutoSearch-n--10409-3248-u--normRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2)) arg-9 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 19 arg-0 arg-5 arg-4 e-8 e-9) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-2) (let ((act-1 (let ((act-1 (set-box! arg-6 e-11))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (let ((act-2 (set-box! arg-7 e-10))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (CoreC-45Context-commit arg-7 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 e-6)))))))))) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45AutoSearch-n--10409-3248-u--normRes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2)) arg-9 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 19 arg-0 arg-5 arg-4 e-8 e-9) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))))
(define CoreC-45AutoSearch-exactlyOne (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (let ((act-1 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 arg-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45AutoSearch-case--exactlyOne-3282 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (DataC-45Either-rights e-5)))) eff-0) clam-0))))) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (if (null? e-2) (CoreC-45Core-u--catch_Catchable_Core_Error e-1 (lambda (lcase-0) (lambda (clam-1) (case (vector-ref lcase-0 0) ((30) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-1))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-5 '()) eta-0)))) eff-0) clam-1))))))))) clam-0) (let ((act-1 (CoreC-45AutoSearch-successful arg-0 arg-1 arg-2 arg-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45AutoSearch-case--exactlyOne-3282 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (DataC-45Either-rights e-5)))) eff-0) clam-0))))))))))))
(define LibrariesC-45DataC-45ListC-45SizeOf-sucR (lambda (arg-3) (+ arg-3 1)))
(define CoreC-45AutoSearch-getUsableEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (let ((u--rest (CoreC-45AutoSearch-getUsableEnv e-3 arg-2 arg-3 (LibrariesC-45DataC-45ListC-45SizeOf-sucR arg-4) e-9))) (let ((sc2 (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (CoreC-45TTC-45Binder-multiplicity e-8) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) (cond ((equal? sc3 1) 1) (else (AlgebraC-45Semiring-isErased csegen-931 arg-3)))))) (cond ((equal? sc2 1) (cons (cons (vector 0 (CoreC-45TTC-45Binder-binderLoc e-8) '() arg-4) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc3))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-sucR arg-4)) (CoreC-45TTC-45Binder-binderType e-8))))) u--rest)) (else u--rest))))))))))
(define CoreC-45Context-fstName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-1) (box (let ((e-1 (vector-ref eta-1 1))) e-1)))) (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 4))) e-39))))))) eff-0) ext-0)))))))
(define CoreC-45Context-sndName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-1) (box (let ((e-2 (vector-ref eta-1 2))) e-2)))) (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-4 4))) e-39))))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-n--11403-4122-u--ambig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((19) 1)(else 0))))
(define CoreC-45AutoSearch-n--9316-2163-u--impl (lambda (arg-1 arg-3) (let ((e-3 (vector-ref arg-3 2))) (case (vector-ref e-3 0) ((1) 0)(else 1)))))
(define CoreC-45AutoSearch-impLast (lambda (arg-1) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (let ((sc0 (CoreC-45AutoSearch-n--9316-2163-u--impl arg-1 eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) arg-1) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CoreC-45AutoSearch-n--9316-2163-u--impl arg-1 eta-0)) arg-1))))
(define CoreC-45Unify-setInvertible (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 clam-0) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 1 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-1)) clam-0)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-2 "sa" eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-10 arg-5 e-9 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-4 e-7))) (lambda (eta-3) (let ((act-5 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 e-6 u--argRig arg-5 e-11 e-12 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 0)) 0) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-15 (car e-13))) (let ((e-14 (cdr e-13))) (let ((act-6 (CoreC-45Unify-setInvertible arg-1 arg-3 (vector 8 e-15) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-16 (vector-ref act-6 1))) (vector 0 e-16))) (else (let ((act-7 (let ((act-7 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-5 e-14)) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-17 (vector-ref act-7 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-7 1))) ((let ((eff-0 (CoreC-45AutoSearch-mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-17))) eff-0) clam-1))))))) (case (vector-ref act-7 0) ((0) (let ((e-17 (vector-ref act-7 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-19 (car e-17))) (let ((e-18 (cdr e-17))) (vector 1 (cons (cons (vector e-15 u--argRig e-8 e-14 e-12) e-19) e-18))))))) eff-0) clam-1))))))))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))(else (vector 1 (cons '() arg-6)))))))(else (vector 1 (cons '() arg-6)))))))
(define CoreC-45Normalise-normaliseScope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-1 ((CoreC-45Normalise-normaliseScope arg-0 (cons e-2 arg-1) arg-2 (cons e-3 arg-3) e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-1 e-2 e-3 e-5))))) eff-0) clam-0))))))))))(else (CoreC-45Normalise-normalise arg-0 arg-1 arg-2 arg-3 arg-4 clam-0))))))
(define CoreC-45Unify-getVarsTm (lambda (arg-1 arg-2) (if (null? arg-2) (box '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (case (vector-ref e-2 0) ((0) (let ((e-8 (vector-ref e-2 3))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1032 e-8 arg-1))) (cond ((equal? sc2 1) '()) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Unify-getVarsTm (cons e-8 arg-1) e-3) (lambda (u--xsC-39) (box (cons e-8 u--xsC-39)))))))))(else '())))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnvTm-15835 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (box (cons e-2 (cons (CoreC-45Unify-updateVars arg-7 e-3) e-3)))))))
(define CoreC-45Unify-case--patternEnvTm-15794 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (unbox arg-7))) (CoreC-45Unify-case--caseC-32blockC-32inC-32patternEnvTm-15835 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 (CoreC-45Unify-toThin arg-0 e-2))))))
(define CoreC-45Unify-patternEnvTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Unify-case--patternEnvTm-15794 arg-2 arg-4 arg-3 arg-1 arg-0 e-5 e-6 (CoreC-45Unify-getVarsTm '() arg-4)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-updateSolution (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Unify-patternEnvTm arg-1 arg-2 arg-0 arg-3 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 0)) (let ((e-7 (unbox e-6))) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (lambda (clam-0) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (let ((sc6 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term arg-5 e-10))) (if (null? sc6) (vector 1 0) (let ((e-12 (unbox sc6))) (let ((act-3 ((CoreC-45Context-lookupCtxtExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-13) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen: no definition") clam-1) (let ((e-14 (unbox e-13))) (CoreC-45Unify-tryInstantiate arg-1 arg-2 arg-0 e-9 e-1 CoreC-45Unify-inTerm arg-3 e-2 e-3 (PreludeC-45TypesC-45List-lengthTR e-4) e-14 e-11 arg-5 e-12 clam-1)))))) eff-0) clam-0))))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))(else (vector 1 0)))))
(define CoreC-45Unify-solveIfUndefined (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((2) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--metavar (vector 2 e-1 e-2 e-3 e-4))) (if (null? e-6) (lambda (eta-2) (vector 1 0)) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((7) (lambda (eta-2) (CoreC-45Unify-updateSolution arg-0 arg-1 arg-2 arg-3 u--metavar arg-5 eta-2)))(else (lambda (eta-2) (vector 1 0))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((10) (let ((e-7 (vector-ref arg-4 2))) (case (vector-ref e-7 0) ((2) (let ((e-9 (vector-ref e-7 1))) (CoreC-45Unify-solveIfUndefined arg-0 arg-1 arg-2 arg-3 e-9 arg-5)))(else (lambda (eta-0) (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45AutoSearch-case--caseC-32blockC-32inC-32searchIfHole-2345 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (case (vector-ref arg-17 0) ((7) (let ((act-1 (cond ((equal? arg-6 1) ((CoreC-45Normalise-normaliseScope arg-11 '() arg-14 '() (let ((e-2 (vector-ref arg-15 2))) e-2)) ext-0)) (else (vector 1 arg-4))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Normalise-normaliseScope arg-11 arg-0 arg-14 arg-3 (let ((e-6 (vector-ref arg-2 4))) e-6)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45AutoSearch-searchType arg-0 arg-11 arg-10 arg-9 arg-13 arg-8 arg-7 arg-1 arg-5 0 e-5 arg-3 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Normalise-logTermNF arg-0 arg-11 "auto" 5 (lambda () "Solved arg") arg-3 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Normalise-logTermNF arg-0 arg-11 "auto" 5 (lambda () "Arg meta") arg-3 (let ((e-4 (vector-ref arg-2 3))) e-4) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45Unify-solveIfUndefined arg-0 arg-11 arg-10 arg-3 (let ((e-4 (vector-ref arg-2 3))) e-4) e-6) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-9 1) (vector 1 (vector 0 ))) (else (let ((act-6 (((((CoreC-45Unify-unify (csegen-2476) arg-0 arg-11 arg-10 CoreC-45Unify-inTerm arg-9) arg-3) (let ((e-4 (vector-ref arg-2 3))) e-4)) e-6) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-11 (vector-ref e-10 0))) (if (null? e-11) (vector 1 (vector 0 )) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-9 (let ((e-44 (vector-ref arg-14 0))) e-44) '() arg-4 '()) clam-0)))))) eff-0) clam-1)))))))))) eff-0) eta-1)))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))(else (vector 1 (vector 0 ))))))
(define CoreC-45AutoSearch-searchIfHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (cond ((equal? arg-7 0) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) eta-1)))) eff-0) eta-0)))))))(else (let ((e-0 (- arg-7 1))) (let ((u--hole (let ((e-1 (vector-ref arg-11 0))) e-1))) (let ((u--rig (let ((e-2 (vector-ref arg-11 1))) e-2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 u--hole) (let ((e-34 (vector-ref e-5 0))) e-34)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-36 (vector-ref e-7 0))) e-36) '() arg-9 '()) eta-3)))) eff-0) eta-2)))))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (lambda (eta-2) (CoreC-45AutoSearch-case--caseC-32blockC-32inC-32searchIfHole-2345 arg-0 e-0 arg-11 arg-10 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--hole u--rig e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18) eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define CoreC-45AutoSearch-n--10914-3668-u--usableLocalArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-10 arg-11))) (cond ((equal? sc1 1) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-9 arg-3 e-5 e-2) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45AutoSearch-usableLocal arg-3 arg-9 arg-8 arg-7 arg-6 e-6))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (cond ((equal? e-6 1) (CoreC-45AutoSearch-n--10914-3668-u--usableLocalArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (+ arg-10 1) arg-11 e-3)) (else (lambda (eta-2) (vector 1 0)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (else (CoreC-45AutoSearch-n--10914-3668-u--usableLocalArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (+ arg-10 1) arg-11 e-3)))))))))
(define CoreC-45AutoSearch-usableLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (clam-0) (case (vector-ref e-2 0) ((2) (let ((e-25 (vector-ref e-2 1))) (case (vector-ref e-25 0) ((3) (vector 1 1))(else (vector 1 0))))) ((0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 eta-1)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-3) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45AutoSearch-usableLocal arg-0 arg-1 arg-2 arg-3 arg-4 eta-1)) e-6 '()))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-2) eta-2) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 1))))))) ((3) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((e-9 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getSearchData arg-1 arg-2 (cond ((equal? arg-3 1) 0) (else 1)) e-6 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--10914-3668-u--usableLocalArg e-5 e-7 e-8 arg-0 e-9 e-6 arg-4 arg-3 arg-2 arg-1 0 (let ((e-0 (car e-10))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-9)))) eff-0) eta-0)))))))))))) ((2) (let ((e-15 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 eta-2)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-15) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45AutoSearch-usableLocal arg-0 arg-1 arg-2 arg-3 arg-4 eta-2)) e-6 '()))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-3) eta-3) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((0) (let ((e-17 (vector-ref arg-5 1))) (let ((e-19 (vector-ref arg-5 3))) (let ((e-20 (vector-ref arg-5 4))) (lambda (clam-1) (case (vector-ref e-19 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-20 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-4 (vector 10 e-17 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45AutoSearch-usableLocal arg-0 arg-1 arg-2 arg-3 arg-4 e-6))) eff-0) eta-0)))))))) eff-0) clam-1))))))(else (vector 1 1)))))))) ((9) (lambda (eta-0) (vector 1 0)))(else (lambda (eta-0) (vector 1 1))))))
(define CoreC-45AutoSearch-n--11403-4124-u--clearEnvType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-16 arg-18 arg-19) (cond ((equal? arg-16 0) (let ((e-4 (car arg-19))) (let ((e-5 (cdr arg-19))) (cons (vector 0 (CoreC-45TTC-45Binder-binderLoc e-4) (CoreC-45TTC-45Binder-multiplicity e-4) (vector 1 ) (vector 10 arg-18 (vector 0 ))) e-5))))(else (let ((e-0 (- arg-16 1))) (let ((e-9 (car arg-19))) (let ((e-10 (cdr arg-19))) (cons e-9 (CoreC-45AutoSearch-n--11403-4124-u--clearEnvType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-0 arg-18 e-10)))))))))
(define CoreC-45AutoSearch-n--11403-4123-u--clearEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-14 0) ((0) (let ((e-2 (vector-ref arg-14 1))) (let ((e-4 (vector-ref arg-14 3))) (CoreC-45AutoSearch-n--11403-4124-u--clearEnvType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-4 e-2 arg-15))))(else arg-15))))
(define CoreC-45AutoSearch-n--11403-4125-u--findDirect (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-1 ((CoreC-45AutoSearch-mkArgs arg-0 arg-13 arg-12 arg-11 arg-10 arg-4 arg-17) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (CoreC-45Normalise-logTermNF arg-0 arg-13 "auto" 10 (lambda () "Trying") arg-4 (arg-16 arg-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45Normalise-logNF arg-0 arg-13 "auto" 10 (lambda () "Type") arg-4 arg-17 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-13 "auto" 10 (lambda () "For target") arg-4 arg-18 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-13 arg-12 CoreC-45Unify-inTerm arg-11) arg-4) arg-18) e-3) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-0 (vector-ref e-9 0))) (if (null? e-0) (let ((act-6 ((CoreC-45AutoSearch-usableLocal arg-0 arg-13 arg-11 arg-9 arg-4 arg-17) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (cond ((equal? e-11 1) (let ((u--candidate (CoreC-45TTC-45Term-apply arg-11 (arg-16 arg-1) (PreludeC-45TypesC-45List-mapAppend '() csegen-3823 e-2)))) (lambda (eta-0) (let ((act-7 (CoreC-45Normalise-logTermNF arg-0 arg-13 "auto" 10 (lambda () "Local var candidate ") arg-4 u--candidate eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((u--envC-39 (CoreC-45AutoSearch-n--11403-4123-u--clearEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-1 arg-4))) (let ((act-8 ((CoreC-45Core-traverse_ (lambda (eta-1) (CoreC-45AutoSearch-searchIfHole arg-0 arg-13 arg-12 arg-11 arg-9 arg-8 0 arg-7 arg-6 arg-5 u--envC-39 eta-1)) (CoreC-45AutoSearch-impLast e-2)) eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (vector 1 u--candidate))))))))))) (else (lambda (eta-0) (let ((act-7 (CoreC-45Normalise-logNF arg-0 arg-13 "auto" 10 (lambda () "Can't use ") arg-4 arg-17 eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-11 (let ((e-45 (vector-ref arg-14 0))) e-45) '() arg-5 '()) eta-0))))))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-11 (let ((e-43 (vector-ref arg-14 0))) e-43) '() arg-5 '()) clam-1)))))) eff-0) clam-0))))))))))))))))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-n--11403-4126-u--findPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-17 0) ((3) (let ((e-2 (vector-ref arg-17 2))) (let ((e-5 (vector-ref arg-17 5))) (if (null? e-5) (lambda (eta-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-12 (cdr e-7))) (if (null? e-8) (lambda (eta-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-14 (car e-8))) (let ((e-15 (cdr e-8))) (if (null? e-14) (lambda (eta-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) (let ((e-19 (cdr e-14))) (lambda (clam-0) (if (null? e-15) (CoreC-45UnifyState-handleUnify arg-13 arg-12 0 (lambda (eta-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-1 arg-16 arg-17 arg-18 eta-0)) (lambda (u--e) (lambda (clam-1) (let ((sc6 (CoreC-45AutoSearch-n--11403-4122-u--ambig arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 u--e))) (cond ((equal? sc6 1) (CoreC-45Core-u--throw_Catchable_Core_Error u--e clam-1)) (else (let ((act-1 (let ((act-1 (CoreC-45Context-fstName arg-13 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-11 (let ((e-0 (vector-ref arg-14 0))) e-0) '() arg-5 '()) eta-0))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) e-6))) eff-0) clam-1))))))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Context-sndName arg-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-11 (let ((e-0 (vector-ref arg-14 0))) e-0) '() arg-5 '()) eta-1))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) e-9))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-isPairType arg-13 e-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-10 1) (let ((act-4 (CoreC-45Context-clearDefs arg-14 clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-13 arg-0 e-13 arg-4 e-12 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-13 arg-0 e-13 arg-4 e-19 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-17 (vector-ref act-6 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45AutoSearch-exactlyOne arg-0 arg-13 arg-12 arg-11 arg-4 arg-5 arg-18 (cons (lambda (eta-4) (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-13 arg-0 arg-14 e-12) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-20 (vector-ref act-7 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-7 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--11403-4126-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (lambda (u--arg) (CoreC-45TTC-45Term-apply arg-11 (vector 1 arg-11 (vector 1 ) e-6) (cons e-16 (cons e-17 (cons (arg-16 u--arg) '()))))) e-20 arg-18))) eff-0) eta-4)))))) (cons (lambda (eta-4) (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-13 arg-0 arg-14 e-19) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-20 (vector-ref act-7 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-7 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--11403-4126-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (lambda (u--arg) (CoreC-45TTC-45Term-apply arg-11 (vector 1 arg-11 (vector 1 ) e-9) (cons e-16 (cons e-17 (cons (arg-16 u--arg) '()))))) e-20 arg-18))) eff-0) eta-4)))))) '()))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) clam-2)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-11 (let ((e-0 (vector-ref arg-14 0))) e-0) '() arg-5 '()) clam-2)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))) clam-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 clam-0))))))))))))))))(else (lambda (eta-0) (CoreC-45AutoSearch-n--11403-4125-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0))))))
(define CoreC-45AutoSearch-searchLocalWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-10 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45AutoSearch-n--11403-4126-u--findPos arg-0 e-2 e-3 arg-12 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-2 (lambda (eta-1) eta-1) e-6 arg-12))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45AutoSearch-searchLocalVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--elabs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (lambda (eta-0) (CoreC-45AutoSearch-searchLocalWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 u--t arg-11 eta-0))) (CoreC-45AutoSearch-getUsableEnv arg-0 arg-3 arg-4 0 arg-10)))) (CoreC-45AutoSearch-exactlyOne arg-0 arg-1 arg-2 arg-3 arg-10 arg-9 arg-11 u--elabs))))
(define CoreC-45AutoSearch-n--8796-7147-u--ambig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((19) 1)(else 0))))
(define CoreC-45AutoSearch-anyOne (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-5 '()) eta-0)))) eff-0) clam-0))))) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (CoreC-45Core-u--catch_Catchable_Core_Error e-2 (lambda (lcase-0) (lambda (clam-1) (case (vector-ref lcase-0 0) ((30) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-1))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-5 '()) eta-0)))) eff-0) clam-1))))))))) clam-0) (CoreC-45UnifyState-tryUnify arg-1 arg-2 e-2 (CoreC-45AutoSearch-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) clam-0))))))))
(define CoreC-45Context-getNS (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2))))) eff-0) ext-0)))))))
(define CoreC-45Context-getNestedNS (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-3 (vector-ref e-5 3))) e-3))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-isPairNF (lambda (arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (CoreC-45Context-isPairType arg-1 e-2 clam-0))) ((0) (let ((e-7 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (case (vector-ref e-9 0) ((2) (let ((act-1 (((e-10 arg-4) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-2 (vector 10 e-7 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45AutoSearch-isPairNF arg-1 arg-2 e-5 arg-4))) eff-0) clam-0))))))(else (vector 1 0)))))))(else (vector 1 0))))))
(define CoreC-45Context-visibleIn (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (cond ((equal? arg-2 0) (CoreC-45NameC-45Namespace-isParentOf e-0 arg-0))(else 1))))(else 1))))
(define CoreC-45Context-visibleInAny (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (u--ns) (CoreC-45Context-visibleIn u--ns arg-1 arg-2)) arg-0)))
(define CoreC-45AutoSearch-searchName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Context-getNS arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-getNestedNS arg-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc4 (CoreC-45Context-visibleInAny (cons e-6 e-7) (let ((e-1 (vector-ref e-3 1))) e-1) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-3 9))) e-9))))) (cond ((equal? sc4 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) clam-1))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 7 ) (let ((e-12 (vector-ref e-3 12))) e-12)))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((u--ty (let ((e-27 (vector-ref e-3 2))) e-27))) (let ((u--namety (let ((e-18 (vector-ref e-3 18))) (case (vector-ref e-18 0) ((5) (let ((e-30 (vector-ref e-18 1))) (let ((e-29 (vector-ref e-18 2))) (vector 2 e-30 e-29)))) ((6) (let ((e-35 (vector-ref e-18 1))) (let ((e-34 (vector-ref e-18 2))) (vector 3 e-35 e-34))))(else (vector 1 )))))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-10 u--ty) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" 10 (lambda () (string-append "Searching Name " (CoreC-45Name-u--show_Show_Name e-2))) arg-10 e-8 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 ((CoreC-45AutoSearch-mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-10 e-8) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-11 (car e-10))) (let ((e-4 (cdr e-10))) (let ((act-7 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 CoreC-45Unify-inTerm arg-3) arg-10) arg-11) e-4) clam-2))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-0 (vector-ref e-12 0))) (if (null? e-0) (let ((act-8 ((CoreC-45AutoSearch-isPairNF arg-1 arg-10 e-8 e-5) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--candidate (CoreC-45TTC-45Term-apply arg-3 (vector 1 arg-3 u--namety e-2) (PreludeC-45TypesC-45List-mapAppend '() csegen-3823 e-11)))) (lambda (eta-2) (let ((act-9 (CoreC-45Normalise-logTermNF arg-0 arg-1 "auto" 10 (lambda () "Candidate ") arg-10 u--candidate eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-16 (vector-ref act-9 1))) (vector 0 e-16))) (else (let ((act-10 ((CoreC-45Core-traverse_ (lambda (eta-3) (CoreC-45AutoSearch-searchIfHole arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 e-15 arg-7 arg-8 arg-9 arg-10 eta-3)) (CoreC-45AutoSearch-impLast e-11)) eta-2))) (case (vector-ref act-10 0) ((0) (let ((e-17 (vector-ref act-10 1))) (vector 0 e-17))) (else (vector 1 u--candidate))))))))))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-47 (vector-ref e-5 0))) e-47) '() arg-9 '()) clam-0)))))) eff-0) clam-2)))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))))))))) eff-0) ext-0)))))))))
(define CoreC-45AutoSearch-n--13280-5828-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-17 arg-15) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc2 (CoreC-45Context-visibleInAny arg-16 arg-17 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-1 9))) e-9))))) (cond ((equal? sc2 1) (vector 1 (box (cons arg-17 e-1)))) (else (vector 1 '()))))))))) eff-0) ext-0)))))))
(define CoreC-45AutoSearch-searchNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (if (null? arg-12) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-9 '()) eta-0)))) eff-0) ext-0))))) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45AutoSearch-n--13280-5828-u--visible arg-0 e-2 e-3 arg-13 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) (cons (let ((e-35 (vector-ref e-5 2))) e-35) (let ((e-34 (vector-ref e-5 3))) e-34)) eta-1 eta-2))) (cons e-2 e-3) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--visns (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) eta-1) e-6))) (let ((u--elabs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (lambda (eta-2) (CoreC-45AutoSearch-searchName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 eta-1 eta-2))) u--visns))) (cond ((equal? arg-11 1) (CoreC-45AutoSearch-anyOne arg-0 arg-1 arg-2 arg-3 arg-10 arg-9 u--elabs)) (else (CoreC-45AutoSearch-exactlyOne arg-0 arg-1 arg-2 arg-3 arg-10 arg-9 arg-13 u--elabs))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45AutoSearch-n--8796-7148-u--tryGroups (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-13) (if (null? arg-15) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-12))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-10 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-3 '()) eta-1)))) eff-0) eta-0)))))) (lambda (clam-1) (let ((e-1 (car arg-15))) (let ((e-2 (cdr arg-15))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CoreC-45UnifyState-handleUnify arg-12 arg-11 0 (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-12 "auto" 5 (lambda (eta-1) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-getFullName arg-12 eta-2 eta-3))) e-6 '()) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Search: Trying " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-7)) (string-append " names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-7)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-12 "auto" 5 (lambda () "For target") arg-2 arg-14 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (CoreC-45AutoSearch-searchNames arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 (cons arg-1 arg-7) arg-6 arg-5 arg-3 arg-2 e-5 e-6 arg-14 eta-0)))))))) (lambda (u--err) (let ((sc4 (CoreC-45AutoSearch-n--8796-7147-u--ambig arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 u--err))) (cond ((equal? sc4 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))) (else (CoreC-45AutoSearch-n--8796-7148-u--tryGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (box (DataC-45Maybe-fromMaybe (lambda () u--err) arg-13)) arg-14 e-2))))) clam-1))))))) (let ((e-8 (unbox arg-13))) (if (null? arg-15) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error e-8 eta-0)) (lambda (clam-0) (let ((e-1 (car arg-15))) (let ((e-2 (cdr arg-15))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (CoreC-45UnifyState-handleUnify arg-12 arg-11 0 (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-12 "auto" 5 (lambda (eta-1) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-getFullName arg-12 eta-2 eta-3))) e-6 '()) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Search: Trying " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-7)) (string-append " names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-7)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-12 "auto" 5 (lambda () "For target") arg-2 arg-14 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (CoreC-45AutoSearch-searchNames arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 (cons arg-1 arg-7) arg-6 arg-5 arg-3 arg-2 e-5 e-6 arg-14 eta-0)))))))) (lambda (u--err) (let ((sc4 (CoreC-45AutoSearch-n--8796-7147-u--ambig arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 u--err))) (cond ((equal? sc4 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-0))) (else (CoreC-45AutoSearch-n--8796-7148-u--tryGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (box (DataC-45Maybe-fromMaybe (lambda () u--err) arg-13)) arg-14 e-2))))) clam-0)))))))))))
(define CoreC-45AutoSearch-searchType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (case (vector-ref arg-12 0) ((3) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 ((CoreC-45AutoSearch-searchType (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-7 arg-8 arg-9 arg-10 (cons e-3 arg-11) e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) e-5))))) eff-0) clam-0)))))))))) ((1) (let ((act-1 ((CoreC-45AutoSearch-searchType (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-7 arg-8 arg-9 arg-10 (cons e-3 arg-11) e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-1 e-2 e-3 e-5))))) eff-0) clam-0))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45AutoSearch-abandonIfCycle arg-0 arg-1 arg-11 arg-12 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((u--tryingC-39 (cons arg-12 arg-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-11 arg-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (case (vector-ref e-7 0) ((3) (let ((e-12 (vector-ref e-7 1))) (let ((e-11 (vector-ref e-7 2))) (let ((e-10 (vector-ref e-7 3))) (let ((e-9 (vector-ref e-7 4))) (let ((e-8 (vector-ref e-7 5))) (let ((u--nty (vector 3 e-12 e-11 e-10 e-9 e-8))) (lambda (clam-1) (let ((sc5 (or (and (= e-9 (PreludeC-45TypesC-45List-lengthTR e-8)) 1) 0))) (cond ((equal? sc5 1) (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" 10 (lambda () "Next target") arg-11 u--nty clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((act-5 (CoreC-45Context-getSearchData arg-1 arg-3 arg-5 e-11 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-6 (cond ((equal? arg-9 1) (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-5 arg-11 arg-10 (vector 3 e-12 e-11 e-10 e-9 e-8) eta-1)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((sc9 (cond ((equal? arg-5 1) arg-9) (else 0)))) (cond ((equal? sc9 1) ((CoreC-45AutoSearch-n--8796-7148-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-16 (cdr e-14))) e-16)) eta-1)) (else (CoreC-45UnifyState-handleUnify arg-1 arg-2 0 (CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 u--nty) (lambda (u--e) (let ((sc10 (CoreC-45AutoSearch-n--8796-7147-u--ambig arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--e))) (cond ((equal? sc10 1) (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error u--e eta-2))) (else (CoreC-45AutoSearch-n--8796-7148-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-16 (cdr e-14))) e-16)))))) eta-1)))))))))) eff-0) clam-1))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-10 '()) clam-1))))))))))))(else (lambda (eta-1) (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" 10 (lambda () "Next target: ") arg-11 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else ((CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 e-7) eta-1))))))))) eff-0) eta-0)))))))))))) eff-0) clam-0))))))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45AutoSearch-abandonIfCycle arg-0 arg-1 arg-11 arg-12 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--tryingC-39 (cons arg-12 arg-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-11 arg-12) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (case (vector-ref e-7 0) ((3) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-8 (vector-ref e-7 5))) (let ((u--nty (vector 3 e-1 e-2 e-3 e-4 e-8))) (lambda (clam-2) (let ((sc4 (or (and (= e-4 (PreludeC-45TypesC-45List-lengthTR e-8)) 1) 0))) (cond ((equal? sc4 1) (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" 10 (lambda () "Next target") arg-11 u--nty clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 (CoreC-45Context-getSearchData arg-1 arg-3 arg-5 e-2 clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-6 (cond ((equal? arg-9 1) (CoreC-45AutoSearch-checkConcreteDets arg-0 arg-1 arg-2 arg-3 arg-5 arg-11 arg-10 (vector 3 e-1 e-2 e-3 e-4 e-8) eta-1)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((sc8 (cond ((equal? arg-5 1) arg-9) (else 0)))) (cond ((equal? sc8 1) ((CoreC-45AutoSearch-n--8796-7148-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-12 (cdr e-10))) e-12)) eta-1)) (else (CoreC-45UnifyState-handleUnify arg-1 arg-2 0 (CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 u--nty) (lambda (u--e) (let ((sc9 (CoreC-45AutoSearch-n--8796-7147-u--ambig arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--e))) (cond ((equal? sc9 1) (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error u--e eta-2))) (else (CoreC-45AutoSearch-n--8796-7148-u--tryGroups arg-0 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() u--nty (let ((e-12 (cdr e-10))) e-12)))))) eta-1)))))))))) eff-0) clam-2))))))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) '() arg-10 '()) clam-2))))))))))))(else (lambda (eta-1) (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-1 "auto" 10 (lambda () "Next target: ") arg-11 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((CoreC-45AutoSearch-searchLocalVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--tryingC-39 arg-7 arg-8 arg-10 arg-11 e-7) eta-1))))))))) eff-0) eta-0)))))))))))) eff-0) clam-0))))))))))
(define CoreC-45Unify-search (lambda (ext-10 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-0) (let ((act-1 (CoreC-45Normalise-logTermNF ext-10 ext-1 "auto" 3 (lambda () "Initial target: ") ext-9 ext-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-log ext-1 "auto" 3 (lambda () (string-append "Running search with defaults " (PreludeC-45Show-u--show_Show_Bool ext-5))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45AutoSearch-searchType ext-10 ext-1 ext-2 ext-3 ext-4 ext-5 '() ext-6 ext-7 1 (CoreC-45Env-abstractEnvType ext-10 ext-3 ext-9 ext-8) ext-9 ext-8) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45Normalise-logTermNF ext-10 ext-1 "auto" 3 (lambda () "Result") ext-9 e-7 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) ext-0)))))))))))))
(define CoreC-45Unify-unionAll (lambda (arg-0) (if (null? arg-0) csegen-2499 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) e-2 (CoreC-45Unify-union e-2 (CoreC-45Unify-unionAll e-3))))))))
(define CoreC-45Unify-u--C-61C-61_Eq_SolveMode (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0))) ((equal? arg-0 3) (cond ((equal? arg-1 3) 1)(else 0)))(else 0))))
(define CoreC-45Unify-delayMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (vector 7 (CoreC-45TTC-45Term-getLoc arg-4) arg-1 arg-3 arg-4))(else (let ((e-0 (- arg-2 1))) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (vector 3 e-2 e-3 e-4 (CoreC-45Unify-delayMeta (cons e-3 arg-0) arg-1 e-0 (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) arg-3))) e-5)))))))(else (vector 7 (CoreC-45TTC-45Term-getLoc arg-4) arg-1 arg-3 arg-4))))))))
(define CoreC-45Unify-forceMeta (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (vector 8 (CoreC-45TTC-45Term-getLoc arg-3) arg-1 arg-3))(else (let ((e-0 (- arg-2 1))) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (vector 3 e-2 e-3 e-4 (CoreC-45Unify-forceMeta arg-1 e-0 e-5)))))))(else (vector 8 (CoreC-45TTC-45Term-getLoc arg-3) arg-1 arg-3))))))))
(define CoreC-45GetType-chkBinder (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45GetType-chk arg-0 arg-1 arg-2 (CoreC-45TTC-45Binder-binderType arg-3))))
(define CoreC-45GetType-chkConstant (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 9 arg-1 (vector 13 0))) ((1) (vector 9 arg-1 (vector 13 1))) ((2) (vector 9 arg-1 (vector 13 2))) ((3) (vector 9 arg-1 (vector 13 3))) ((4) (vector 9 arg-1 (vector 13 4))) ((5) (vector 9 arg-1 (vector 13 5))) ((6) (vector 9 arg-1 (vector 13 6))) ((7) (vector 9 arg-1 (vector 13 7))) ((8) (vector 9 arg-1 (vector 13 8))) ((9) (vector 9 arg-1 (vector 13 9))) ((10) (vector 9 arg-1 (vector 13 10))) ((11) (vector 9 arg-1 (vector 13 11))) ((12) (vector 9 arg-1 (vector 13 12))) ((14) (vector 9 arg-1 (vector 13 13)))(else (vector 11 arg-1 (vector 2 "top" 0))))))
(define CoreC-45GetType-chkMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-3 arg-4))))) eff-0) eta-0)))))) (case (vector-ref arg-4 0) ((0) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (if (null? arg-5) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-3 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 40 arg-0 arg-2 arg-3 e-10) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-11 (car arg-5))) (let ((e-12 (cdr arg-5))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45GetType-chk arg-0 arg-1 arg-3 e-11) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 e-11)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45GetType-chkMeta arg-0 arg-1 arg-2 arg-3 e-13 e-12))) eff-0) eta-1)))))))) eff-0) eta-0))))))) eff-0) clam-0)))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-3 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 40 arg-0 arg-2 arg-3 e-6) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-5 arg-3 arg-4 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 40 arg-0 arg-2 arg-3 e-6) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define CoreC-45GetType-discharge (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 2 e-1 e-2 e-3 e-4) arg-5)))))) ((1) (let ((e-6 (vector-ref arg-3 1))) (let ((e-7 (vector-ref arg-3 2))) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 1 e-6 e-7 e-8 e-9) arg-5)))))) ((2) arg-4) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 5 e-16 e-17 e-19) arg-5))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (vector 3 arg-1 arg-2 (vector 4 e-21 e-22 e-23 e-24) arg-5)))))) (else arg-4))))
(define CoreC-45GetType-chk (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45TTC-45Binder-binderType (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-0 e-4 arg-2))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact e-9 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 e-7 e-9 clam-0) (let ((e-1 (unbox e-6))) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 e-1))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact (vector 8 e-13) (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 e-11 e-12 clam-1) (let ((e-1 (unbox e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-2 e-1) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45GetType-chkMeta arg-0 arg-1 e-11 arg-2 e-7 e-14))) eff-0) clam-1)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45GetType-chkBinder arg-0 arg-1 arg-2 e-18) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45GetType-chk (cons e-17 arg-0) arg-1 (cons e-18 arg-2) e-19) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45GetType-discharge e-16 e-17 e-18 e-7 e-8)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-22) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-6 0) ((0) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-23) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else ((let ((eff-0 (lambda (eta-3) (let ((act-5 (((e-4 e-11) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-2 e-23)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-11 arg-2 e-13))))) eff-0) eta-3)))))))) eff-0) eta-2))))))) eff-0) clam-0))))))(else (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-5) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 40 arg-0 e-21 arg-2 e-7) eta-2)))) eff-0) clam-0))))))))))(else (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-5) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 40 arg-0 e-21 arg-2 e-7) eta-2)))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((5) (let ((e-28 (vector-ref arg-3 4))) (CoreC-45GetType-chk arg-0 arg-1 arg-2 e-28))) ((6) (let ((e-30 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gType e-30 (vector 2 "top" 0)))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-37 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-37) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-7 arg-2 (vector 5 e-34 e-35 e-6)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-41 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45GetType-chk arg-0 arg-1 arg-2 e-41) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (case (vector-ref e-6 0) ((5) (let ((e-3 (vector-ref e-6 3))) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45Normalise-glueBack arg-1 arg-0 e-7 arg-2 e-3))))) eff-0) clam-3)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-39 "Not a delayed type") clam-3)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (CoreC-45GetType-chkConstant e-43 e-44))))))) ((11) (let ((e-46 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gType e-46 (vector 2 "top" 0)))))) (else (let ((e-49 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (CoreC-45NormaliseC-45Eval-gErased e-49))))))))
(define CoreC-45GetType-getType (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45GetType-chk arg-0 arg-1 arg-2 arg-3)))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-29212 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-15) (let ((act-1 (let ((e-3 (vector-ref arg-14 3))) (case (vector-ref e-3 0) ((0) (vector 1 arg-12)) ((1) (let ((e-4 (vector-ref e-3 1))) (vector 1 (CoreC-45Unify-forceMeta e-4 arg-11 arg-12)))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-1 ((CoreC-45GetType-getType '() arg-6 '() arg-12) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" 5 (lambda () "Retry Delay") arg-12 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Unify-delayMeta '() e-4 arg-11 e-7 arg-12))))) eff-0) eta-0))))))))))) eff-0) ext-0))))))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-23 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-17 (vector-ref arg-8 17))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (let ((e-22 (vector-ref arg-8 22))) (vector e-0 e-1 e-2 e-3 e-4 e-23 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (vector 1 (vector '() 1 0) '() (vector 1 0 e-5) (vector 1 0 e-5) '()) e-19 e-20 e-21 e-22))))))))))))))))))))))))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" 5 (lambda () (string-append "Resolved " (CoreC-45Name-u--show_Show_Name arg-2))) e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-1)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45UnifyState-removeGuess arg-5 arg-0) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (let ((e-1 (vector-ref arg-14 1))) e-1))))))))))))))) eff-0) ext-0))))) (let ((act-1 (let ((e-3 (vector-ref arg-14 3))) (case (vector-ref e-3 0) ((0) (vector 1 arg-12)) ((1) (let ((e-4 (vector-ref e-3 1))) (vector 1 (CoreC-45Unify-forceMeta e-4 arg-11 arg-12)))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-1 ((CoreC-45GetType-getType '() arg-6 '() arg-12) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" 5 (lambda () "Retry Delay (constrained)") arg-12 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Unify-delayMeta '() e-4 arg-11 e-7 arg-12))))) eff-0) eta-0))))))))))) eff-0) ext-0))))))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-23 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-17 (vector-ref arg-8 17))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (let ((e-22 (vector-ref arg-8 22))) (vector e-0 e-1 e-2 e-3 e-4 e-23 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (vector 9 e-5 arg-11 arg-15) e-19 e-20 e-21 e-22))))))))))))))))))))))))) (lambda (eta-0) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-1)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 0)))))))) eff-0) ext-0))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-29836 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-17 (vector-ref arg-8 17))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (let ((e-22 (vector-ref arg-8 22))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (vector 1 (vector '() 1 0) '() (vector 1 0 arg-12) (vector 1 0 arg-12) '()) e-19 e-20 e-21 e-22))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" 5 (lambda () (string-append "Resolved " (CoreC-45Name-u--show_Show_Name arg-2))) arg-12 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-1)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45UnifyState-removeGuess arg-5 arg-0) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (let ((e-1 (vector-ref arg-15 1))) e-1))))))))))))) (let ((u--gdef (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-17 (vector-ref arg-8 17))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (let ((e-22 (vector-ref arg-8 22))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (vector 9 arg-12 arg-11 arg-16) e-19 e-20 e-21 e-22))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 0)))))))))
(define CoreC-45Unify-case--caseC-32blockC-32inC-32retryGuess-28696 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((8) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (lambda (eta-0) (CoreC-45UnifyState-handleUnify arg-6 arg-5 0 (lambda (eta-1) (let ((act-1 (CoreC-45Unify-search '() arg-6 arg-5 arg-1 e-0 (CoreC-45Unify-u--C-61C-61_Eq_SolveMode arg-3 1) e-1 e-2 (let ((e-23 (vector-ref arg-8 2))) e-23) '() eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--gdef (let ((e-26 (vector-ref arg-8 0))) (let ((e-25 (vector-ref arg-8 1))) (let ((e-24 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-23 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (let ((e-7 (vector-ref arg-8 7))) (let ((e-8 (vector-ref arg-8 8))) (let ((e-9 (vector-ref arg-8 9))) (let ((e-10 (vector-ref arg-8 10))) (let ((e-11 (vector-ref arg-8 11))) (let ((e-12 (vector-ref arg-8 12))) (let ((e-13 (vector-ref arg-8 13))) (let ((e-14 (vector-ref arg-8 14))) (let ((e-15 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-17 (vector-ref arg-8 17))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (let ((e-22 (vector-ref arg-8 22))) (vector e-26 e-25 e-24 e-3 e-4 e-23 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (vector 1 CoreC-45ContextC-45Context-defaultPI '() (vector 1 0 e-5) (vector 1 0 e-5) '()) e-19 e-20 e-21 e-22))))))))))))))))))))))))) (lambda (eta-2) (let ((act-2 (CoreC-45Normalise-logTermNF '() arg-6 "unify.retry" 5 (lambda () (string-append "Solved " (CoreC-45Name-u--show_Show_Name arg-2))) '() e-5 eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Context-addDef arg-6 (vector 8 arg-0) u--gdef eta-3)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 ((CoreC-45UnifyState-removeGuess arg-5 arg-0) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (vector 1 1)))))))))))))) eff-0) eta-1)))))) (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((31) (let ((e-6 (vector-ref lcase-0 3))) (let ((e-3 (vector-ref lcase-0 4))) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-6 "unify.retry" 5 (lambda () (string-append "Failed (det " (string-append (CoreC-45Name-u--show_Show_Name arg-2) (string-append " " (string-append (CoreC-45Name-u--show_Show_Name e-6) ")"))))) (let ((e-29 (vector-ref arg-8 2))) e-29) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((act-2 (CoreC-45Unify-setInvertible arg-6 arg-1 (vector 8 e-3) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (vector 1 0))))))))))(else (let ((act-1 (CoreC-45Normalise-logTermNF '() arg-6 "unify.retry" 5 (lambda () (string-append "Search failed at " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-0) (string-append " for " (CoreC-45Name-u--show_Show_Name arg-2))))) '() (let ((e-23 (vector-ref arg-8 2))) e-23) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (cond ((equal? arg-3 3) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-0))(else (let ((sc2 (CoreC-45Unify-recoverable lcase-0))) (cond ((equal? sc2 1) (vector 1 0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-1 (let ((e-36 (vector-ref arg-7 0))) e-36) '() (let ((e-24 (vector-ref arg-8 2))) e-24) (box lcase-0)) clam-0))))))))))))) eta-0)))))) ((9) (let ((e-3 (vector-ref arg-10 1))) (let ((e-4 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-10 3))) (if (null? e-5) (let ((u--umode (cond ((equal? arg-3 2) CoreC-45Unify-inMatch)(else arg-4)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Unify-retry arg-6 arg-5 u--umode eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--csAll (CoreC-45Unify-unionAll e-6))) (CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-29836 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5 e-4 e-3 u--umode e-6 u--csAll (let ((e-0 (vector-ref u--csAll 0))) e-0))))) eff-0) eta-0))))))) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (let ((u--umode (cond ((equal? arg-3 2) CoreC-45Unify-inMatch)(else arg-4)))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-retry arg-6 arg-5 u--umode e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-29212 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7 e-4 e-3 u--umode e-6 (let ((e-0 (vector-ref e-6 0))) e-0) eta-1)))) eff-0) eta-0))))))) (let ((u--umode (cond ((equal? arg-3 2) CoreC-45Unify-inMatch)(else arg-4)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Unify-retry arg-6 arg-5 u--umode eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--csAll (CoreC-45Unify-unionAll e-6))) (CoreC-45Unify-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32retryGuess-29836 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5 e-4 e-3 u--umode e-6 u--csAll (let ((e-0 (vector-ref u--csAll 0))) e-0))))) eff-0) eta-0)))))))))))))))(else (lambda (eta-0) (vector 1 0))))))
(define CoreC-45Unify-retryGuess (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-1) (vector 1 0)) (let ((e-4 (unbox e-8))) (let ((bind-0 (box e-4))) (CoreC-45Unify-case--caseC-32blockC-32inC-32retryGuess-28696 e-2 e-6 e-7 arg-3 arg-2 arg-1 arg-0 e-5 e-4 bind-0 (let ((e-18 (vector-ref e-4 18))) e-18))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define CoreC-45Unify-solveConstraints (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Unify-retryGuess arg-0 arg-1 arg-2 arg-3 eta-1)) (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1)) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) eta-1) e-6))) (cond ((equal? sc2 1) (CoreC-45Unify-solveConstraints arg-0 arg-1 arg-2 0 clam-0)) (else (vector 1 (vector 0 )))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-try (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (TTImpC-45ElabC-45Check-tryError arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (lambda (eta-0) (vector 1 e-2)))) (else arg-7)))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Ambiguity-checkAlternative (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (case (vector-ref arg-12 0) ((2) (let ((e-1 (vector-ref arg-12 1))) (let ((act-1 (TTImpC-45ElabC-45Ambiguity-checkAmbigDepth arg-1 arg-4 arg-11 arg-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genName arg-1 arg-3 "altTy" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-6 (vector 11 arg-11 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-14) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-0) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 (box e-6) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-ambiguous eta-1)) 1 (lambda (u--delayed) (lambda (eta-1) (let ((act-3 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-6) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--expC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-8)) (else e-6)))) (lambda (eta-2) (let ((act-5 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.ambiguous" 5 (lambda () (PreludeC-45Types-fastConcat (cons "Ambiguous elaboration at " (cons (CoreC-45FC-u--show_Show_FC arg-11) (cons ":\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (string-append "  " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 eta-3))) arg-13)) (cons "With default. Target type " '()))))))) arg-10 u--expC-39 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--expC-39) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-10 e-10 arg-13 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "elab.prune" 5 (lambda () (string-append "Pruned " (string-append (PreludeC-45Show-u--show_Show_Nat (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-13) (PreludeC-45TypesC-45List-lengthTR e-10)))) (string-append " alts." (string-append " Kept:\xa;" (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-mapAppend '() csegen-2610 e-10))))))) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (cond ((equal? u--delayed 1) (TTImpC-45ElabC-45Check-try arg-0 arg-1 arg-2 arg-3 arg-4 (TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-11 arg-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-4) (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-10 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-8) arg-9 arg-10 u--t (box u--expC-39) eta-4)))) e-10)) (lambda (eta-4) (let ((act-8 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 5 (lambda () "All failed, running default") eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-10 (TTImpC-45ElabC-45Ambiguity-getName e-1)) arg-8) arg-9 arg-10 e-1 (box u--expC-39) eta-4))))) eta-3)) (else ((TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 1 arg-11 arg-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-4) (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-10 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-8) arg-9 arg-10 u--t (box u--expC-39) eta-4)))) e-10)) eta-3))))))))) eff-0) eta-2)))))))))))) eff-0) eta-1)))))))))) eta-0))))) eff-0) ext-0))))))))))(else (let ((act-1 (TTImpC-45ElabC-45Ambiguity-checkAmbigDepth arg-1 arg-4 arg-11 arg-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--exp) (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--exp) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-10 e-6 arg-13 eta-1)))) eff-0) eta-0)))))))) arg-14) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-0) (let ((act-3 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "altTy" eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-7 (vector 11 arg-11 e-8) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) arg-14) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 (box e-7) (lambda (eta-2) (TTImpC-45ElabC-45Delayed-ambiguous eta-2)) 1 (lambda (u--delayed) (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--expC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-8)) (else e-7)))) (lambda (eta-3) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--expC-39) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-10 e-9 arg-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.ambiguous" 5 (lambda () (PreludeC-45Types-fastConcat (cons "Ambiguous elaboration" (cons " (kept " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-9)) (cons " out of " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-13)) (cons " candidates)" (cons " (" (cons (cond ((equal? u--delayed 1) "") (else "not ")) (cons "delayed)" (cons " at " (cons (CoreC-45FC-u--show_Show_FC arg-11) (cons ":\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-mapAppend '() csegen-2610 e-9)) (cons "Target type " '())))))))))))))))) arg-10 u--expC-39 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((u--tryall (lambda (clam-1) (case (vector-ref arg-12 0) ((0) (TTImpC-45ElabC-45Check-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 clam-1))(else (TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cond ((equal? u--delayed 1) 0) (else 1)) arg-11 arg-10 clam-1)))))) ((u--tryall (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-5) (let ((act-7 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-9 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-8) arg-9 arg-10 u--t (box u--expC-39) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 10 (lambda () (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-65 (TTImpC-45ElabC-45Ambiguity-getName u--t)) " success")) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.ambiguous" 10 (lambda () "Result") arg-10 (Builtin-fst e-11) eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (vector 1 e-11)))))))))))))))) eff-0) eta-5)))))))) e-9)) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2))))))) eta-1))))) eff-0) eta-0)))))) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (lambda (eta-0) (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-1 arg-14 eta-0)) (lambda (eta-0) (let ((act-3 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "altTy" eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-7 (vector 11 arg-11 e-8) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) arg-14) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 (box e-7) (lambda (eta-2) (TTImpC-45ElabC-45Delayed-ambiguous eta-2)) 1 (lambda (u--delayed) (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--expC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-8)) (else e-7)))) (lambda (eta-3) (let ((act-5 (let ((act-5 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--expC-39) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45Ambiguity-pruneByType arg-0 arg-1 arg-3 arg-10 e-9 arg-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.ambiguous" 5 (lambda () (PreludeC-45Types-fastConcat (cons "Ambiguous elaboration" (cons " (kept " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-9)) (cons " out of " (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-13)) (cons " candidates)" (cons " (" (cons (cond ((equal? u--delayed 1) "") (else "not ")) (cons "delayed)" (cons " at " (cons (CoreC-45FC-u--show_Show_FC arg-11) (cons ":\xa;" (cons (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-mapAppend '() csegen-2610 e-9)) (cons "Target type " '())))))))))))))))) arg-10 u--expC-39 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((u--tryall (lambda (clam-0) (case (vector-ref arg-12 0) ((0) (TTImpC-45ElabC-45Check-anyOne arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 clam-0))(else (TTImpC-45ElabC-45Check-exactlyOneC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cond ((equal? u--delayed 1) 0) (else 1)) arg-11 arg-10 clam-0)))))) ((u--tryall (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--t) (cons (TTImpC-45ElabC-45Ambiguity-getName u--t) (lambda (eta-5) (let ((act-7 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ((TTImpC-45ElabC-45Ambiguity-addAmbig e-9 (TTImpC-45ElabC-45Ambiguity-getName u--t)) arg-8) arg-9 arg-10 u--t (box u--expC-39) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((act-9 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((act-10 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 10 (lambda () (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-65 (TTImpC-45ElabC-45Ambiguity-getName u--t)) " success")) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((act-11 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.ambiguous" 10 (lambda () "Result") arg-10 (Builtin-fst e-11) eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-3 (vector-ref act-11 1))) (vector 0 e-3))) (else (vector 1 e-11)))))))))))))))) eff-0) eta-5)))))))) e-9)) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2))))))) eta-1))))) eff-0) eta-0)))))))))))) eff-0) ext-0))))))))))))
(define CoreC-45Metadata-addNameLoc (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getFullName arg-1 arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc2) (vector 1 (vector 0 )) (let ((e-1 (unbox sc2))) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-12 e-2 e-3 e-4 (LibrariesC-45DataC-45PosMap-insert (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) (cons e-1 e-6) e-11) e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-3)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NormaliseC-45Eval-isFromTerm (lambda (arg-1) (let ((e-1 (vector-ref arg-1 0))) e-1)))
(define CoreC-45Context-isLazyActive (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 3))) (let ((e-50 (vector-ref e-40 0))) e-50))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-u--show_Show_ElabMode (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "InType") ((1) (let ((e-0 (vector-ref arg-0 1))) (string-append "InLHS " (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-0)))) ((2) "InExpr") (else "InTransform"))))
(define TTImpC-45ElabC-45Check-convertWithLazy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--umode (let ((e-0 (vector-ref arg-6 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-1 (CoreC-45Context-isLazyActive arg-1 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--lazy (cond ((equal? e-5 1) arg-4) (else 0)))) (lambda (eta-2) (let ((act-2 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.unify" 5 (lambda () (string-append "Unifying " (string-append (PreludeC-45Show-u--show_Show_Bool arg-4) (string-append " " (TTImpC-45ElabC-45Check-u--show_Show_ElabMode (let ((e-0 (vector-ref arg-6 0))) e-0)))))) arg-7 arg-8 eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.unify" 5 (lambda () "....with") arg-7 arg-9 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((sc3 (let ((sc4 (CoreC-45NormaliseC-45Eval-isFromTerm arg-8))) (cond ((equal? sc4 1) (CoreC-45NormaliseC-45Eval-isFromTerm arg-9)) (else 0))))) (cond ((equal? sc3 1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45NormaliseC-45Eval-getTerm arg-9) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (cond ((equal? u--lazy 1) ((((CoreC-45Unify-unifyWithLazy (csegen-2476) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9)) (else ((((CoreC-45Unify-unify (csegen-2476) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) (else (let ((act-4 ((CoreC-45NormaliseC-45Eval-getNF arg-1 arg-8) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45NormaliseC-45Eval-getNF arg-1 arg-9) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (cond ((equal? u--lazy 1) ((((CoreC-45Unify-unifyWithLazy (csegen-2479) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9)) (else ((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-2 u--umode arg-5) arg-7) e-8) e-9))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((sc4 (let ((e-1 (vector-ref e-8 1))) e-1))) (cond ((equal? sc4 1) (CoreC-45Unify-solveConstraints arg-1 arg-2 u--umode 0 eta-3)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-8))))))) eff-0) eta-2))))))))))))))) eff-0) eta-1)))))) (lambda (u--err) (lambda (eta-1) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm arg-9) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (CoreC-45Unify-solveConstraints arg-1 arg-2 u--umode 0 eta-4)) (lambda (err-0) (lambda (eta-4) (vector 1 (vector 0 )))) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 5 arg-0 arg-5 (let ((e-0 (vector-ref e-8 0))) e-0) arg-7 e-5 e-6 u--err) eta-4)))) eff-0) eta-3))))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) eta-0)))))
(define CoreC-45UnifyState-case--dumpHoleC-44dumpConstraint-8098 (lambda (arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (vector 1 (vector 0 )) (let ((e-2 (unbox arg-9))) (case (vector-ref e-2 0) ((1) (cond ((equal? arg-0 "") (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) ": \x9;Resolved")) "\xa;") clam-0))) (vector 1 act-1)))(else (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-0 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) ": \x9;Resolved")))) "\xa;") clam-0))) (vector 1 act-1))))) (else (let ((e-3 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 3))) (let ((e-6 (vector-ref e-2 4))) (let ((e-7 (vector-ref e-2 5))) (let ((e-8 (vector-ref e-2 6))) (let ((act-1 (let ((act-1 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 arg-8 e-6 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-4 csegen-68 e-9 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 arg-8 e-6 e-8 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-toFullNames arg-4 csegen-68 e-11 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (cond ((equal? arg-0 "") (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "\x9;  " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-10) (string-append " =?= " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-12))))))) "\xa;") eta-3))) (vector 1 act-5)))(else (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-0 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "\x9;  " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-10) (string-append " =?= " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-12))))))))) "\xa;") eta-3))) (vector 1 act-5))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((act-2 (CoreC-45Context-clearDefs arg-8 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 e-10 e-6 e-7 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-toFullNames arg-4 csegen-68 e-11 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-4 e-3 e-10 e-6 e-8 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45Context-toFullNames arg-4 csegen-68 e-13 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45ContextC-45Log-log arg-4 arg-0 5 (lambda () (string-append "\x9;    from " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-12) (string-append " =?= " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-3 e-14) (cond ((equal? e-5 1) "\xa;\x9;(lazy allowed)") (else ""))))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))))))
(define CoreC-45UnifyState-n--13539-8068-u--dumpConstraint (lambda (arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45UnifyState-case--dumpHoleC-44dumpConstraint-8098 arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-6 (LibrariesC-45DataC-45IntMap-lookup arg-6 (let ((e-4 (vector-ref e-5 4))) e-4))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-case--caseC-32blockC-32inC-32dumpHole-8460 (lambda (arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (clam-0) (if (null? arg-10) (vector 1 (vector 0 )) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (case (vector-ref e-2 0) ((9) (let ((e-4 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 3))) (let ((act-1 (let ((act-1 (CoreC-45Context-getFullName arg-4 (vector 8 arg-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-7 '() e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-4 csegen-68 e-8 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-7 '() e-4 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (cond ((equal? arg-0 "") (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "!" (string-append (CoreC-45Name-u--show_Show_Name e-7) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-9) (string-append "\xa;\x9;  = " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-10) "\xa;\x9;when"))))))))) "\xa;") eta-3))) (vector 1 act-5)))(else (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-0 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "!" (string-append (CoreC-45Name-u--show_Show_Name e-7) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-9) (string-append "\xa;\x9;  = " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-10) "\xa;\x9;when"))))))))))) "\xa;") eta-3))) (vector 1 act-5))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else ((CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--13539-8068-u--dumpConstraint arg-0 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) e-6) clam-0))))))) ((7) (let ((e-8 (vector-ref e-2 2))) (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-7 '() e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (cond ((equal? arg-0 "") (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "?" (string-append (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-8 1))) e-1)) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5) (let ((sc4 (let ((e-0 (car e-8))) e-0))) (cond ((equal? sc4 1) " (ImplBind)") (else (string-append "" (let ((sc5 (let ((e-15 (vector-ref arg-8 15))) e-15))) (cond ((equal? sc5 1) " (Invertible)") (else "")))))))))))))) "\xa;") eta-0))) (vector 1 act-2)))(else (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-0 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "?" (string-append (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-8 1))) e-1)) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5) (let ((sc3 (let ((e-0 (car e-8))) e-0))) (cond ((equal? sc3 1) " (ImplBind)") (else (string-append "" (let ((sc4 (let ((e-15 (vector-ref arg-8 15))) e-15))) (cond ((equal? sc4 1) " (Invertible)") (else "")))))))))))))))) "\xa;") eta-0))) (vector 1 act-2))))))) eff-0) clam-0))))))) ((8) (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-4 '() arg-7 '() e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-4 csegen-68 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (cond ((equal? arg-0 "") (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "Search " (string-append (PreludeC-45Show-u--show_Show_Int arg-2) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6))))))) "\xa;") eta-1))) (vector 1 act-3)))(else (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-0 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-3) (string-append ": " (string-append "Search " (string-append (PreludeC-45Show-u--show_Show_Int arg-2) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6))))))))) "\xa;") eta-1))) (vector 1 act-3))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((1) (let ((act-1 (CoreC-45Normalise-normalise arg-4 '() arg-7 '() e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalise arg-4 '() arg-7 '() (vector 1 CoreC-45FC-emptyFC (vector 1 ) (vector 8 arg-2)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-log arg-4 arg-0 4 (lambda () (string-append "Solved: " (string-append (PreludeC-45Show-u--show_Show_Int arg-2) (string-append " : " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5) (string-append " = " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6))))))) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((10) (let ((act-1 (CoreC-45Normalise-normalise arg-4 '() arg-7 '() e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-log arg-4 arg-0 4 (lambda () (string-append "Bound: " (string-append (PreludeC-45Show-u--show_Show_Int arg-2) (string-append " : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5))))) eta-0)))) eff-0) clam-0)))))) ((12) (let ((act-1 (CoreC-45Normalise-normalise arg-4 '() arg-7 '() e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-log arg-4 arg-0 4 (lambda () (string-append "Delayed elaborator : " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5))) eta-0)))) eff-0) clam-0))))))(else (vector 1 (vector 0 ))))))))))
(define CoreC-45UnifyState-dumpHole (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-5) (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (vector 1 (vector 0 ))) (let ((e-2 (unbox e-7))) (let ((bind-0 (box e-2))) (CoreC-45UnifyState-case--caseC-32blockC-32inC-32dumpHole-8460 arg-2 arg-5 arg-4 arg-1 arg-0 e-5 e-6 e-2 bind-0 (cons (let ((e-18 (vector-ref e-2 18))) e-18) (let ((e-26 (vector-ref e-2 2))) e-26)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-dumpConstraints (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-7 1) ((let ((u--hs (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1)) (LibrariesC-45DataC-45IntMap-toList (cond ((equal? arg-5 1) (let ((e-0 (vector-ref e-5 0))) e-0)) (else (let ((e-2 (vector-ref e-5 2))) e-2))))))) (lambda () (lambda (clam-0) (let ((sc4 (DataC-45List-isNil u--hs))) (cond ((equal? sc4 1) (vector 1 (vector 0 ))) (else (let ((act-4 (cond ((equal? arg-2 "") (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) ": --- CONSTRAINTS AND HOLES ---")) "\xa;") clam-0))) (vector 1 act-4)))(else (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) ": --- CONSTRAINTS AND HOLES ---")))) "\xa;") clam-0))) (vector 1 act-4)))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CoreC-45UnifyState-dumpHole arg-0 arg-1 arg-2 arg-4 eta-2 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) u--hs)) clam-0)))))))))))) (else (lambda (eta-2) (vector 1 (vector 0 ))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) eff-0) ext-0)))))))
(define CoreC-45Normalise-logGlue (lambda (arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogging arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm arg-7) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-68 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (cond ((equal? arg-2 "") (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8)))))) "\xa;") eta-2))) (vector 1 act-5)))(else (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append "LOG " (string-append arg-2 (string-append ":" (string-append (PreludeC-45Show-u--show_Show_Nat arg-4) (string-append ": " (string-append (arg-5) (string-append ": " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8)))))))) "\xa;") eta-2))) (vector 1 act-5))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-case--checkExp-8561 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (clam-0) (let ((e-3 (vector-ref arg-11 3))) (case (vector-ref e-3 0) ((0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" 5 (lambda () "Solved") arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (cons arg-3 arg-2)))))) ((1) (let ((e-4 (vector-ref e-3 1))) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" 5 (lambda () "Force") arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 (CoreC-45Normalise-logGlue arg-0 arg-10 "elab" 5 (lambda () "Got") arg-5 arg-2 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (CoreC-45Normalise-logGlue arg-0 arg-10 "elab" 5 (lambda () "Exp") arg-5 arg-1 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (vector 1 (cons (vector 8 arg-4 e-4 arg-3) arg-1))))))))))))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" 5 (lambda () "Delay") arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (vector 1 (cons (vector 7 arg-4 e-4 e-5 arg-3) arg-1)))))))) eff-0) clam-0)))))))))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-10 "elab" 5 (lambda () "Not solved") arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-10))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm arg-1) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45UnifyState-newConstant arg-0 arg-9 arg-10 arg-4 arg-7 arg-5 arg-3 e-8 arg-12) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45UnifyState-dumpConstraints arg-9 arg-10 "elab" 5 0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-3 (vector-ref arg-11 3))) (case (vector-ref e-3 0) ((0) (vector 1 (cons e-9 arg-2))) ((1) (let ((e-4 (vector-ref e-3 1))) (vector 1 (cons (vector 8 arg-4 e-4 arg-3) arg-1)))) (else (let ((e-4 (vector-ref e-3 1))) (let ((act-7 ((CoreC-45NormaliseC-45Eval-getTerm arg-2) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (cons (vector 7 arg-4 e-4 e-11 arg-3) arg-1))))) eff-0) eta-4))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) eff-0) eta-0))))))))))))
(define TTImpC-45ElabC-45Check-checkExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (if (null? arg-10) (vector 1 (cons arg-8 arg-9)) (let ((e-1 (unbox arg-10))) (let ((act-1 ((TTImpC-45ElabC-45Check-convertWithLazy arg-0 arg-1 arg-2 arg-3 1 arg-7 arg-5 arg-6 arg-9 e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Check-case--checkExp-8561 arg-0 e-1 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 (let ((e-0 (vector-ref e-5 0))) e-0)))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Check-concrete (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-2 (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Check-concrete arg-1 arg-2 e-5))) eff-0) clam-0))))))(else (vector 1 0))))))) ((2) (vector 1 1)) ((3) (vector 1 1)) ((8) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))))
(define TTImpC-45ElabC-45App-n--12236-4643-u--countConstructors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((3) (let ((e-2 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((sc1 (or (and (= (PreludeC-45TypesC-45List-lengthTR e-5) e-4) 1) 0))) (cond ((equal? sc1 1) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (vector 1 '())) (let ((e-8 (unbox e-7))) (lambda (clam-1) (let ((e-18 (vector-ref e-8 18))) (case (vector-ref e-18 0) ((6) (let ((e-32 (vector-ref e-18 7))) (vector 1 (box (PreludeC-45TypesC-45List-lengthTR e-32)))))(else (vector 1 '()))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ElabC-45App-n--12236-4644-u--dotTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((19) arg-8) ((17) arg-8) ((32) arg-8) ((18) (let ((e-11 (vector-ref arg-8 1))) (let ((e-12 (vector-ref arg-8 2))) (let ((e-13 (vector-ref arg-8 3))) (let ((e-14 (vector-ref arg-8 4))) (let ((e-15 (vector-ref arg-8 5))) (case (vector-ref e-15 0) ((17) arg-8) ((32) arg-8)(else (vector 18 e-11 e-12 e-13 e-14 (vector 19 e-11 3 arg-8))))))))))(else (vector 19 (TTImpC-45TTImp-getFC arg-8) 3 arg-8)))))
(define TTImpC-45ElabC-45App-dotErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (let ((sc1 (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-0))) (cond ((equal? sc2 1) 0) (else (AlgebraC-45Semiring-isErased csegen-931 arg-6)))))) (cond ((equal? sc1 1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45App-n--12236-4643-u--countConstructors arg-0 e-0 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.app.dot" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Found " (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-895 e-7) (cons " constructors for type" '()))))) (CoreC-45Env-mkEnv CoreC-45FC-emptyFC arg-0) e-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((sc6 (let ((sc7 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-1032 e-7 (box 1)))) (cond ((equal? sc7 1) 1) (else (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-1032 e-7 (box 0))))))) (cond ((equal? sc6 1) (vector 1 arg-7)) (else (let ((act-5 ((PreludeC-45Types-maybe (lambda () (lambda (eta-3) (vector 1 '()))) (lambda () (lambda (u--n) (CoreC-45Context-lookupCtxtExact u--n (let ((e-37 (vector-ref e-5 0))) e-37)))) arg-3) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-9) (vector 1 (TTImpC-45ElabC-45App-n--12236-4644-u--dotTerm arg-0 e-0 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-7)) (let ((e-1 (unbox e-9))) (let ((sc9 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-4 (let ((e-4 (vector-ref e-1 4))) e-4)))) (cond ((equal? sc9 1) (vector 1 arg-7)) (else (vector 1 (TTImpC-45ElabC-45App-n--12236-4644-u--dotTerm arg-0 e-0 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 arg-7)))))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (vector 1 arg-7))))))(else (vector 1 arg-7))))))
(define TTImpC-45ElabC-45App-isHole (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-2 (vector-ref arg-1 2))) (case (vector-ref e-2 0) ((2) 1)(else 0))))(else 0))))
(define TTImpC-45ElabC-45App-needsDelayExpr (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (lambda (eta-0) (vector 1 0))) (else (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (if (null? e-6) 0 (let ((e-3 (cdr e-6))) (if (null? e-3) 0 1))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((8) (let ((e-5 (vector-ref arg-2 2))) (TTImpC-45ElabC-45App-needsDelayExpr arg-0 1 e-5))) ((9) (let ((e-9 (vector-ref arg-2 2))) (TTImpC-45ElabC-45App-needsDelayExpr arg-0 1 e-9))) ((10) (let ((e-13 (vector-ref arg-2 2))) (TTImpC-45ElabC-45App-needsDelayExpr arg-0 1 e-13))) ((2) (lambda (eta-0) (vector 1 1))) ((4) (lambda (eta-0) (vector 1 1))) ((5) (lambda (eta-0) (vector 1 1))) ((7) (lambda (eta-0) (vector 1 1))) ((13) (lambda (eta-0) (vector 1 1))) ((12) (lambda (eta-0) (vector 1 1))) ((14) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))))
(define TTImpC-45ElabC-45App-needsDelayLHS (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 1))) ((8) (let ((e-5 (vector-ref arg-1 2))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-5))) ((9) (let ((e-9 (vector-ref arg-1 2))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-9))) ((10) (let ((e-13 (vector-ref arg-1 2))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-13))) ((13) (lambda (eta-0) (vector 1 1))) ((18) (let ((e-25 (vector-ref arg-1 5))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-25))) ((12) (lambda (eta-0) (vector 1 1))) ((28) (lambda (eta-0) (vector 1 1))) ((29) (lambda (eta-0) (vector 1 1))) ((33) (let ((e-37 (vector-ref arg-1 3))) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 e-37)))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ElabC-45App-needsDelay (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-1 0) ((1) (TTImpC-45ElabC-45App-needsDelayLHS arg-0 arg-3))(else (TTImpC-45ElabC-45App-needsDelayExpr arg-0 arg-2 arg-3)))))
(define CoreC-45UnifyState-addDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-4 arg-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-4 arg-8) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-2))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-2 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-15 (vector-ref e-8 5))) (let ((e-14 (vector-ref e-8 6))) (let ((e-13 (vector-ref e-8 7))) (let ((e-12 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (vector e-0 e-1 e-2 e-3 e-4 e-15 e-14 (cons (cons arg-5 (cons arg-7 (vector 0 arg-0 arg-3 0 arg-4 e-6 e-7))) e-13) e-12 e-9 e-10 e-11)))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Dot-registerDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (CoreC-45UnifyState-genName arg-1 arg-3 "dotTm" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm arg-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-7 arg-5 arg-6 e-5 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45UnifyState-addDot arg-0 arg-1 arg-3 arg-7 arg-6 e-5 arg-9 arg-8 e-7 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--tm (cond ((equal? arg-8 4) (vector 10 arg-7 (vector 2 e-7)))(else e-7)))) (vector 1 (cons u--tm arg-10))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-checkValidPattern (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "elab.app.lhs" 50 (lambda () (string-append "Checking that " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 arg-8) " is a valid pattern"))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (case (vector-ref arg-8 0) ((3) (let ((e-3 (vector-ref arg-8 3))) (case (vector-ref e-3 0) ((0) (TTImpC-45ElabC-45Dot-registerDot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 2 arg-8 arg-9 ext-0))(else (vector 1 (cons arg-8 arg-9))))))(else (vector 1 (cons arg-8 arg-9)))))))))
(define CoreC-45Normalise-glueClosure (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (vector 0 (lambda (eta-0) (let ((act-1 (CoreC-45Context-clearDefs arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-0 arg-1 e-5 arg-3 arg-4 eta-1)))) eff-0) eta-0)))))) (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 arg-4)))))
(define TTImpC-45ElabC-45App-onLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 1)(else 0))))
(define TTImpC-45ElabC-45App-n--12265-5440-u--checkLtoR (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (let ((act-1 (let ((act-1 (unbox arg-24))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-logNF arg-0 arg-24 "elab" 10 (lambda () "Full function type") arg-14 (vector 0 arg-13 arg-11 (vector 2 arg-13 arg-17 (vector 1 ) arg-10) arg-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-24 "elab" 10 (lambda (eta-1) (let ((act-3 ((PreludeC-45Types-maybe (lambda () (lambda (eta-2) (vector 1 '()))) (lambda () (lambda (u--t) (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm u--t) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-toFullNames arg-24 csegen-68 e-7 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (box e-8))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) arg-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Overall expected type: " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-7)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((TTImpC-45ElabC-45Check-check arg-0 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 arg-17 (let ((e-0 (vector-ref arg-16 0))) (let ((e-1 (vector-ref arg-16 1))) (let ((e-3 (vector-ref arg-16 3))) (let ((e-4 (vector-ref arg-16 4))) (let ((e-8 (vector-ref arg-16 5))) (vector e-0 e-1 0 e-3 e-4 e-8)))))) arg-15 arg-14 arg-26 (box (CoreC-45Normalise-glueClosure arg-24 arg-0 e-5 arg-14 arg-10))) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (let ((sc4 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc4 1) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (TTImpC-45ElabC-45App-checkValidPattern arg-0 arg-24 arg-23 arg-22 arg-21 arg-18 arg-14 arg-13 e-2 e-3 eta-1)))) (else (vector 1 e-8)))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-6 (CoreC-45Normalise-logGlueNF arg-0 arg-24 "elab" 10 (lambda () "Got arg type") arg-14 e-3 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (let ((act-7 (unbox arg-24))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--fntm (vector 4 arg-13 arg-12 e-2))) (lambda (eta-2) (let ((act-8 (((arg-9 e-11) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-14 e-2)) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 u--fntm e-12 (cons arg-1 (+ arg-2 1)) arg-7 arg-6 arg-5 arg-25 arg-3 eta-3)))) eff-0) eta-2))))))))) eff-0) clam-0))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-addNoSolve (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45IntMap-insert arg-1 (vector 0 ) e-12) e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ElabC-45Check-argVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (CoreC-45UnifyState-newMetaLets arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 0)) 0 1)))
(define TTImpC-45ElabC-45Check-convert (lambda (arg-0 arg-1 arg-2 arg-3 ext-0 ext-1 ext-2 ext-3 ext-4) (TTImpC-45ElabC-45Check-convertWithLazy arg-0 arg-1 arg-2 arg-3 0 ext-0 ext-1 ext-2 ext-3 ext-4)))
(define CoreC-45UnifyState-genMVName (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (CoreC-45UnifyState-genName arg-0 arg-1 (CoreC-45Name-displayUserName e-0) clam-0))) ((2) (let ((e-1 (vector-ref arg-2 1))) (CoreC-45UnifyState-genName arg-0 arg-1 e-1 clam-0)))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-inCurrentNS arg-0 (vector 2 (CoreC-45Name-u--show_Show_Name arg-2) (let ((e-8 (vector-ref e-5 8))) e-8)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 e-7)))) eff-0) eta-0))))))))))) eff-0) clam-0))))))))))
(define CoreC-45UnifyState-removeNoSolve (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 (LibrariesC-45DataC-45IntMap-delete arg-1 e-12) e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-updateDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (let ((sc3 (arg-2 (let ((e-18 (vector-ref e-1 18))) e-18)))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-2 (unbox sc3))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 arg-1 (let ((e-0 (vector-ref e-1 0))) (let ((e-26 (vector-ref e-1 1))) (let ((e-25 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-26 e-25 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-2 e-19 e-20 e-21 '())))))))))))))))))))))) eta-1)) clam-0))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkRestAppC-44checkRtoL-6957 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 arg-42 arg-43 arg-44 arg-45 arg-46 arg-47 arg-48 ext-0) (if (null? arg-48) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (CoreC-45Unify-updateSolution arg-0 arg-24 arg-22 arg-14 arg-32 arg-42 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-36)))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-37) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45UnifyState-newConstant arg-0 arg-22 arg-24 arg-13 arg-18 arg-14 arg-36 e-5 arg-48))) eff-0) ext-0))))))))
(define TTImpC-45ElabC-45App-n--12265-5441-u--checkRtoL (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (let ((act-1 (let ((act-1 (unbox arg-24))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45UnifyState-genMVName arg-24 arg-22 arg-11) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-24 arg-0 e-7 arg-14 arg-10 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((TTImpC-45ElabC-45Check-argVar arg-0 arg-24 arg-22 (TTImpC-45TTImp-getFC arg-26) arg-17 arg-14 e-6 e-8) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((u--fntm (vector 4 arg-13 arg-12 e-3))) (lambda (eta-4) (let ((act-6 (CoreC-45ContextC-45Log-logTerm arg-0 arg-24 "elab" 10 (lambda () "...as") e-3 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (((arg-9 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-14 e-3)) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 u--fntm e-11 (cons arg-1 (+ arg-2 1)) arg-7 arg-6 arg-5 arg-25 arg-3 eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-3))) (lambda (clam-0) (let ((e-13 (car e-12))) (let ((e-4 (cdr e-12))) (let ((act-9 (let ((act-9 (unbox arg-24))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-14 (vector-ref act-9 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-24 arg-0 e-14 arg-14 e-8) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-15 (vector-ref act-10 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-11 (CoreC-45Normalise-logNF arg-0 arg-24 "elab" 10 (lambda () (string-append "Now trying " (string-append (CoreC-45Name-u--show_Show_Name e-6) (string-append " " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-26))))) arg-14 e-15 eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-16 (vector-ref act-11 1))) (vector 0 e-16))) (else (let ((act-12 (let ((sc13 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc13 1) (((case (vector-ref e-15 0) ((1) (let ((e-18 (vector-ref e-15 2))) (case (vector-ref e-18 0) ((2) (let ((e-20 (vector-ref e-18 2))) (lambda () (lambda (eta-8) (let ((act-12 ((CoreC-45Context-lookupCtxtExact (vector 8 e-20) (let ((e-0 (vector-ref e-14 0))) e-0)) eta-8))) (case (vector-ref act-12 0) ((0) (let ((e-22 (vector-ref act-12 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-12 1))) ((let ((eff-0 (if (null? e-22) (lambda (eta-9) (vector 1 (vector 0 ))) (let ((e-23 (unbox e-22))) (let ((sc18 (AlgebraC-45Semiring-isErased csegen-931 (let ((e-39 (vector-ref e-23 7))) e-39)))) (cond ((equal? sc18 1) (CoreC-45UnifyState-addNoSolve arg-22 e-20)) (else (lambda (eta-9) (vector 1 (vector 0 )))))))))) eff-0) eta-8)))))))))(else (lambda () (lambda (eta-8) (vector 1 (vector 0 ))))))))(else (lambda () (lambda (eta-8) (vector 1 (vector 0 ))))))) eta-7)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-12 0) ((0) (let ((e-17 (vector-ref act-12 1))) (vector 0 e-17))) (else (let ((act-13 ((TTImpC-45ElabC-45Check-check arg-0 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 arg-17 (let ((e-0 (vector-ref arg-16 0))) (let ((e-1 (vector-ref arg-16 1))) (let ((e-20 (vector-ref arg-16 3))) (let ((e-19 (vector-ref arg-16 4))) (let ((e-18 (vector-ref arg-16 5))) (vector e-0 e-1 0 e-20 e-19 e-18)))))) arg-15 arg-14 arg-26 (box (CoreC-45Normalise-glueBack arg-24 arg-0 e-14 arg-14 e-15))) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-18 (vector-ref act-13 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 (let ((sc15 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc15 1) (((case (vector-ref e-15 0) ((1) (let ((e-20 (vector-ref e-15 2))) (case (vector-ref e-20 0) ((2) (let ((e-22 (vector-ref e-20 2))) (lambda () (CoreC-45UnifyState-removeNoSolve arg-22 e-22))))(else (lambda () (lambda (eta-9) (vector 1 (vector 0 ))))))))(else (lambda () (lambda (eta-9) (vector 1 (vector 0 ))))))) eta-8)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-14 0) ((0) (let ((e-19 (vector-ref act-14 1))) (vector 0 e-19))) (else (let ((act-15 (let ((sc16 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc16 1) (let ((e-21 (car e-18))) (let ((e-20 (cdr e-18))) (TTImpC-45ElabC-45App-checkValidPattern arg-0 arg-24 arg-23 arg-22 arg-21 arg-18 arg-14 arg-13 e-21 e-20 eta-8)))) (else (vector 1 e-18)))))) (case (vector-ref act-15 0) ((0) (let ((e-20 (vector-ref act-15 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-15 1))) ((let ((eff-0 (let ((_-1 (cons e-13 e-4))) (lambda (clam-1) (let ((e-22 (car e-20))) (let ((e-21 (cdr e-20))) (let ((act-16 (let ((act-16 (unbox arg-24))) (vector 1 act-16)))) (case (vector-ref act-16 0) ((0) (let ((e-23 (vector-ref act-16 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-17 (CoreC-45ContextC-45Log-logTerm arg-0 arg-24 "elab" 10 (lambda () (string-append "Solving " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-3) " with"))) e-22 eta-9))) (case (vector-ref act-17 0) ((0) (let ((e-24 (vector-ref act-17 1))) (vector 0 e-24))) (else (let ((act-18 ((CoreC-45Unify-solveIfUndefined arg-0 arg-24 arg-22 arg-14 e-3 e-22) eta-9))) (case (vector-ref act-18 0) ((0) (let ((e-25 (vector-ref act-18 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-19 (let ((_-2 (cons e-22 e-21))) (cond ((equal? e-25 1) (vector 1 e-13)) (else (let ((act-19 ((TTImpC-45ElabC-45Check-convert arg-0 arg-24 arg-22 arg-21 arg-13 arg-16 arg-14 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-14 e-3) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-14 e-22)) eta-10))) (case (vector-ref act-19 0) ((0) (let ((e-26 (vector-ref act-19 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-11) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkRestAppC-44checkRtoL-6957 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-26 arg-25 e-5 e-6 e-7 e-8 e-2 e-3 _-0 u--fntm e-11 e-13 e-4 _-1 e-14 e-15 e-18 e-22 e-21 _-2 e-23 e-25 e-26 (let ((e-0 (vector-ref e-26 0))) e-0) eta-11)))) eff-0) eta-10)))))))))) (case (vector-ref act-19 0) ((0) (let ((e-26 (vector-ref act-19 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-20 (let ((sc22 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-16 0))) e-0)))) (cond ((equal? sc22 1) (let ((act-20 (CoreC-45Context-updateDef arg-24 (vector 8 e-2) csegen-2498 eta-11))) (case (vector-ref act-20 0) ((0) (let ((e-27 (vector-ref act-20 1))) (vector 0 e-27))) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 (CoreC-45Unify-solveIfUndefined arg-0 arg-24 arg-22 arg-14 e-3 e-22) eta-11))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-20 0) ((0) (let ((e-27 (vector-ref act-20 1))) (vector 0 e-27))) (else (let ((act-21 (CoreC-45Context-updateDef arg-24 (vector 8 e-2) (lambda (u--def) (case (vector-ref u--def 0) ((1) (let ((e-0 (vector-ref u--def 1))) (let ((e-1 (vector-ref u--def 2))) (let ((e-30 (vector-ref u--def 3))) (let ((e-29 (vector-ref u--def 4))) (let ((e-28 (vector-ref u--def 5))) (box (vector 1 (let ((e-33 (vector-ref e-0 0))) (let ((e-31 (vector-ref e-0 2))) (vector e-33 1 e-31))) e-1 e-30 e-29 e-28))))))))(else '()))) eta-11))) (case (vector-ref act-21 0) ((0) (let ((e-28 (vector-ref act-21 1))) (vector 0 e-28))) (else (let ((act-22 ((CoreC-45UnifyState-removeHole arg-22 e-2) eta-11))) (case (vector-ref act-22 0) ((0) (let ((e-29 (vector-ref act-22 1))) (vector 0 e-29))) (else (vector 1 (cons e-26 e-4)))))))))))))) eff-0) eta-10)))))))) eff-0) eta-9))))))))))) eff-0) clam-1))))))))))) eff-0) eta-8))))))))))) eff-0) eta-7)))))))))))))) eff-0) eta-6)))))))) eff-0) clam-0))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-n--12265-5442-u--invalidArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (case (vector-ref arg-25 0) ((27) 1)(else 0))))
(define TTImpC-45ElabC-45App-checkRestApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 ext-0) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45App-dotErased arg-0 arg-1 arg-15 e-2 e-3 (let ((e-0 (vector-ref arg-9 0))) e-0) arg-8 arg-18) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (cond ((equal? arg-22 1) (vector 1 1)) (else (let ((act-3 (((arg-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-11 (vector 10 arg-12 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ElabC-45Check-concrete e-5 arg-11 e-7))) eff-0) eta-1))))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-5 arg-15) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((TTImpC-45ElabC-45App-needsDelay arg-1 (let ((e-0 (vector-ref arg-9 0))) e-0) e-7 arg-18) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc6 (let ((sc7 (let ((sc8 (TTImpC-45ElabC-45App-isHole e-8))) (cond ((equal? sc8 1) e-7) (else 0))))) (cond ((equal? sc7 1) 1) (else e-9))))) (cond ((equal? sc6 1) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-4) (TTImpC-45ElabC-45App-n--12265-5441-u--checkRtoL arg-0 e-2 e-3 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 e-6 eta-4)) (lambda (u--err) (lambda (clam-1) (let ((sc7 (TTImpC-45ElabC-45App-n--12265-5442-u--invalidArg arg-0 e-2 e-3 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--err))) (cond ((equal? sc7 1) (TTImpC-45ElabC-45App-n--12265-5440-u--checkLtoR arg-0 e-2 e-3 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 e-6 clam-1)) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-1)))))) clam-0)) (else (TTImpC-45ElabC-45App-n--12265-5440-u--checkLtoR arg-0 e-2 e-3 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 e-6 clam-0))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45App-findNamed (lambda (arg-0 arg-1) (let ((sc0 (DataC-45List-partition (lambda (eta-0) (CoreC-45Name-u--C-61C-61_Eq_Name (Builtin-fst eta-0) arg-0)) arg-1))) (if (null? sc0) '() (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) '() (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (box (cons e-5 (PreludeC-45TypesC-45List-tailRecAppend e-6 e-3))))))))))))
(define CoreC-45TTC-45BinderC-45PiInfo-isImplicit (lambda (arg-1) (case (vector-ref arg-1 0) ((1) 0)(else 1))))
(define TTImpC-45ElabC-45App-isImplicitAs (lambda (arg-0) (case (vector-ref arg-0 0) ((18) (let ((e-3 (vector-ref arg-0 3))) (let ((e-5 (vector-ref arg-0 5))) (cond ((equal? e-3 0) (case (vector-ref e-5 0) ((32) 1)(else 0)))(else 0)))))(else 0))))
(define CoreC-45Context-getAutoImplicitLimit (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 3))) (let ((e-46 (vector-ref e-40 4))) e-46))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-n--11935-6618-u--envArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 0 arg-7 arg-3 '())))) u--args)))
(define CoreC-45UnifyState-newSearch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--hty (CoreC-45Env-abstractEnvType arg-0 arg-3 arg-7 arg-9))) (let ((u--hole (CoreC-45Context-newDef arg-3 arg-8 arg-4 '() u--hty (LibrariesC-45DataC-45WithDefault-specified 2) (vector 8 arg-4 arg-5 arg-6)))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "unify.search" 10 (lambda () (string-append "Adding new search " (string-append (CoreC-45FC-u--show_Show_FC arg-3) (string-append " " (CoreC-45Name-u--show_Show_Name arg-8))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Normalise-logTermNF '() arg-1 "unify.search" 10 (lambda () "New search type") '() u--hty eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-addDef arg-1 arg-8 u--hole eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45UnifyState-addGuessName arg-2 arg-3 arg-8 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (cons e-7 (vector 2 arg-3 arg-8 e-7 (CoreC-45UnifyState-n--11935-6618-u--envArgs arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1)))))))))) eff-0) eta-0))))))))))))))))
(define TTImpC-45ElabC-45Check-n--14650-5118-u--find (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (if (null? arg-13) '() (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-12 e-6))) (cond ((equal? sc2 1) (box e-7)) (else (let ((e-5 (car e-7))) (let ((e-4 (cdr e-7))) (if (null? e-5) (TTImpC-45ElabC-45Check-n--14650-5118-u--find arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-3) (let ((e-8 (unbox e-5))) (let ((u--t (cons (box e-8) e-4))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name arg-12 e-8))) (cond ((equal? sc5 1) (box u--t)) (else (TTImpC-45ElabC-45Check-n--14650-5118-u--find arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-3)))))))))))))))))))
(define CoreC-45TTC-45Term-getArgs (lambda (ext-0) (Builtin-snd (CoreC-45TTC-45Term-getFnArgs ext-0))))
(define TTImpC-45ElabC-45Check-n--14650-5119-u--useVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) arg-13 (let ((e-12 (car arg-12))) (let ((e-13 (cdr arg-12))) (case (vector-ref arg-13 0) ((3) (let ((e-15 (vector-ref arg-13 1))) (let ((e-16 (vector-ref arg-13 2))) (let ((e-17 (vector-ref arg-13 3))) (let ((e-18 (vector-ref arg-13 4))) (case (vector-ref e-17 0) ((2) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (let ((e-23 (vector-ref e-17 4))) (vector 3 e-15 e-16 (vector 1 e-20 e-21 e-12 e-23) (TTImpC-45ElabC-45Check-n--14650-5119-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons e-16 arg-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) e-13) e-18))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45Check-n--14650-5119-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons e-2 arg-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc4 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc4))) (((e-10 'erased) 'erased) eta-0)))) arg-12) e-4)))))))(else arg-13)))))))(else arg-13)))))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45Check-n--14650-5119-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons e-2 arg-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc3))) (((e-10 'erased) 'erased) eta-0)))) arg-12) e-4)))))))(else arg-13)))))))(else arg-13)))))))))
(define TTImpC-45ElabC-45Check-case--caseC-32blockC-32inC-32searchVarC-44envHints-5577 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-19) (lambda (eta-0) (vector 1 (cons arg-14 (cons arg-15 arg-16)))) (let ((e-1 (unbox arg-19))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-10 (cdr e-6))) (let ((u--nC-39 (PreludeC-45Types-maybe (lambda () arg-11) (lambda () (lambda (eta-0) eta-0)) e-5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-10))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact u--nC-39 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-2) (vector 1 (cons arg-14 (cons arg-15 arg-16)))) (let ((e-2 (unbox e-8))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref e-2 18))) e-18))))) (let ((u--app ((e-10 arg-8) u--nt))) (let ((u--tyenv (TTImpC-45ElabC-45Check-n--14650-5119-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-0 (CoreC-45TTC-45Term-getArgs u--app) (let ((e-29 (vector-ref e-2 2))) e-29)))) (let ((u--binder (vector 1 arg-8 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (let ((sc6 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-3 (cdr sc6))) ((((e-3 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-14)) u--app))) (let ((sc6 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-3 (cdr sc6))) ((((e-3 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-14)) u--tyenv)))))) (lambda (eta-2) (let ((act-3 (CoreC-45Context-toFullNames arg-10 csegen-54 u--nC-39 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (cons e-11 arg-14) (cons (lambda (u--t) (arg-15 (vector 3 arg-8 e-11 u--binder u--t))) (cons u--binder arg-16))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))
(define TTImpC-45ElabC-45Check-n--14650-5117-u--envHints (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (if (null? arg-11) (vector 1 (cons '() (cons (lambda (eta-0) eta-0) arg-12))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 (TTImpC-45ElabC-45Check-n--14650-5117-u--envHints arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 arg-12 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((e-8 (car e-4))) (let ((e-7 (cdr e-4))) (let ((act-2 (CoreC-45Context-toFullNames arg-10 csegen-54 e-2 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 (cons e-6 (cons e-8 e-7)))) (TTImpC-45ElabC-45Check-case--caseC-32blockC-32inC-32searchVarC-44envHints-5577 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-3 arg-12 e-6 e-8 e-7 _-0 e-9 (TTImpC-45ElabC-45Check-n--14650-5118-u--find arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-9 arg-3))))) eff-0) clam-0)))))))))))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Check-searchVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-n--14650-5117-u--envHints arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (LibrariesC-45DataC-45NameMap-keys (let ((e-10 (vector-ref e-5 10))) e-10)) arg-7 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-3 ((CoreC-45UnifyState-newSearch (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7 arg-9 (let ((sc4 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc4))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-2)) arg-10)))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (cdr e-9))) (vector 1 (e-8 e-4)))))) eff-0) clam-0)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-n--11968-3735-u--metavarImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (case (vector-ref arg-24 0) ((1) 1) ((3) 1)(else 0))))
(define TTImpC-45ElabC-45App-makeAutoImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (lambda (clam-0) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((sc1 (TTImpC-45ElabC-45App-n--11968-3735-u--metavarImp arg-0 e-2 e-3 arg-22 arg-21 arg-20 arg-19 arg-18 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-9 0))) e-0)))) (cond ((equal? sc1 1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-14) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-11 arg-15 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-12 arg-8 arg-11 e-6 e-8 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--fntm (vector 4 arg-12 arg-13 e-9))) (lambda (eta-4) (let ((act-6 (((arg-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-11 e-9)) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 (unbox arg-4))) (vector 1 act-7))))) (lambda (world-0) (let ((act-7 (eff-0 world-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-1 (lambda (world-1) (let ((act-8 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-8 (vector 2 ) arg-11 e-9 e-8 e-11)))) (vector 1 act-8))))) eff-1) world-0))))))) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 arg-11 arg-12 u--fntm e-10 (cons e-2 (+ e-3 1)) arg-18 arg-19 arg-20 arg-21 arg-22 eta-5))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-14) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_Closure arg-1 arg-0 (vector 0 0 (box 10)) e-5 arg-11 arg-15 eta-3)) (lambda (u--err) (lambda (eta-3) (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-11 arg-15 eta-3))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-4))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Context-getAutoImplicitLimit arg-1 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (TTImpC-45ElabC-45Check-searchVar arg-0 arg-1 arg-3 arg-12 arg-8 e-10 (vector 8 (let ((e-22 (vector-ref e-9 1))) e-22)) arg-11 arg-10 e-6 e-8 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--fntm (vector 4 arg-12 arg-13 e-11))) (lambda (eta-6) (let ((act-8 (((arg-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-11 e-11)) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 arg-11 arg-12 u--fntm e-12 (cons e-2 (+ e-3 1)) arg-18 arg-19 arg-20 arg-21 arg-22 eta-7)))) eff-0) eta-6))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45ElabC-45App-n--12060-4031-u--metavarImp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (case (vector-ref arg-25 0) ((1) 1) ((3) 1)(else 0))))
(define TTImpC-45ElabC-45App-makeDefImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23) (lambda (clam-0) (let ((e-2 (car arg-18))) (let ((e-3 (cdr arg-18))) (let ((sc1 (TTImpC-45ElabC-45App-n--12060-4031-u--metavarImp arg-0 e-2 e-3 arg-23 arg-22 arg-21 arg-20 arg-19 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-9 0))) e-0)))) (cond ((equal? sc1 1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-14) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-11 arg-16 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-12 arg-8 arg-11 e-6 e-8 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--fntm (vector 4 arg-12 arg-13 e-9))) (lambda (eta-4) (let ((act-6 (((arg-17 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-11 e-9)) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 (unbox arg-4))) (vector 1 act-7))))) (lambda (world-0) (let ((act-7 (eff-0 world-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-1 (lambda (world-1) (let ((act-8 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-8 (vector 2 ) arg-11 e-9 e-8 e-11)))) (vector 1 act-8))))) eff-1) world-0))))))) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 arg-11 arg-12 u--fntm e-10 (cons e-2 (+ e-3 1)) arg-19 arg-20 arg-21 arg-22 arg-23 eta-5))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-6 arg-11 arg-15 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--fntm (vector 4 arg-12 arg-13 e-7))) (lambda (eta-2) (let ((act-4 (((arg-17 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-11 e-7)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 arg-11 arg-12 u--fntm e-8 (cons e-2 (+ e-3 1)) arg-19 arg-20 arg-21 arg-22 arg-23 eta-3)))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45ElabC-45App-makeImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 ext-0) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45UnifyState-genMVName arg-1 arg-3 arg-14) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-7 arg-11 arg-15 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-12 arg-8 arg-11 e-6 e-8 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--fntm (vector 4 arg-12 arg-13 e-9))) (lambda (eta-4) (let ((act-6 (((arg-16 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-11 e-9)) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (let ((sc7 (let ((e-12 (vector-ref arg-9 3))) e-12))) (cond ((equal? sc7 1) ((let ((eff-0 (lambda (world-0) (let ((act-7 (unbox arg-4))) (vector 1 act-7))))) (lambda (world-0) (let ((act-7 (eff-0 world-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-1 (lambda (world-1) (let ((act-8 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-8 (vector 0 ) arg-11 e-9 e-8 e-11)))) (vector 1 act-8))))) eff-1) world-0))))))) eta-5)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 arg-10 arg-11 arg-12 u--fntm e-10 (cons e-2 (+ e-3 1)) arg-18 arg-19 arg-20 arg-21 arg-22 eta-5))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-11156 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 ext-0) (if (null? arg-37) (vector 1 arg-35) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-34) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45UnifyState-newConstant arg-4 arg-19 arg-21 arg-11 arg-15 arg-12 (Builtin-fst arg-35) e-5 arg-37) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-6 (CoreC-45NormaliseC-45Eval-gnf arg-4 arg-12 arg-27)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))
(define TTImpC-45ElabC-45App-findBindAllExpPattern (lambda (ext-0) (DataC-45List-lookup csegen-832 (vector 1 (vector 2 )) ext-0)))
(define TTImpC-45ElabC-45App-case--withC-32blockC-32inC-32checkAppWithC-39-8786 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (if (null? arg-25) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-1) (TTImpC-45ElabC-45App-isImplicitAs eta-1)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-23)))))) (cond ((equal? sc2 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-3 arg-5 arg-6 arg-9 arg-10 arg-12 arg-13 arg-14 (CoreC-45Normalise-glueBack arg-3 arg-0 e-5 arg-12 arg-2) arg-18 clam-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-13 arg-12 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-23)) arg-14) clam-0))))))) eff-0) eta-0)))))) (let ((e-1 (unbox arg-25))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-9 arg-21))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 u--argRig arg-10 arg-11 arg-12 arg-13 arg-14 arg-24 arg-22 arg-20 arg-15 e-1 '() arg-16 arg-23 arg-17 arg-18 eta-0)))))))
(define TTImpC-45ElabC-45App-with--checkAppWithC-39-8737 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (if (null? arg-2) (TTImpC-45ElabC-45App-case--withC-32blockC-32inC-32checkAppWithC-39-8786 arg-3 arg-4 arg-9 arg-25 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-8 arg-7 arg-6 arg-5 arg-1 arg-0 (TTImpC-45ElabC-45App-findBindAllExpPattern arg-1)) (let ((e-1 (unbox arg-2))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-10 (cdr e-5))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-19 arg-6))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-3 arg-25 arg-24 arg-23 arg-22 arg-21 arg-20 arg-19 u--argRig arg-18 arg-17 arg-16 arg-15 arg-14 arg-0 arg-5 arg-7 arg-13 e-10 '() arg-12 e-6 arg-11 arg-10 eta-0))))))))))
(define TTImpC-45ElabC-45App-checkAppWithC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-13 0) ((0) (let ((e-9 (vector-ref arg-13 1))) (let ((e-10 (vector-ref arg-13 2))) (let ((e-11 (vector-ref arg-13 3))) (let ((e-12 (vector-ref arg-13 4))) (case (vector-ref e-11 0) ((2) (let ((e-18 (vector-ref e-11 1))) (let ((e-19 (vector-ref e-11 2))) (let ((e-20 (vector-ref e-11 3))) (let ((e-21 (vector-ref e-11 4))) (case (vector-ref e-20 0) ((1) (if (null? arg-15) (TTImpC-45ElabC-45App-with--checkAppWithC-39-8737 e-10 arg-17 (TTImpC-45ElabC-45App-findNamed e-10 arg-17) arg-0 e-18 e-21 e-19 e-12 e-9 arg-13 arg-19 arg-18 arg-16 arg-14 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (let ((e-28 (car arg-15))) (let ((e-29 (cdr arg-15))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-28 e-29 arg-16 arg-17 arg-18 arg-19 eta-0))))))) ((0) (if (null? arg-15) (if (null? arg-16) (if (null? arg-17) (if (null? arg-19) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc7 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc7) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-2 (unbox sc7))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0))))))))) (let ((e-35 (unbox arg-19))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-35) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ty (vector 0 e-9 e-10 (vector 2 e-18 e-19 (vector 0 ) e-21) e-12))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-2) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-10 u--ty) (box e-35) eta-2)))(else (let ((sc11 (let ((e-16 (vector-ref arg-8 4))) e-16))) (cond ((equal? sc11 1) (lambda (eta-2) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-3) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-10 u--ty) (box e-35) eta-3)) (lambda (u--err) (lambda (eta-3) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-35) eta-3))) eta-2))) (else (lambda (eta-2) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-35) eta-2)))))))))(else (let ((sc10 (let ((e-8 (vector-ref arg-8 4))) e-8))) (cond ((equal? sc10 1) (lambda (eta-2) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-3) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-10 u--ty) (box e-35) eta-3)) (lambda (u--err) (lambda (eta-3) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-35) eta-3))) eta-2))) (else (lambda (eta-2) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-35) eta-2)))))))))(else (let ((sc9 (let ((e-4 (vector-ref arg-8 4))) e-4))) (cond ((equal? sc9 1) (lambda (eta-2) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-3) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-10 u--ty) (box e-35) eta-3)) (lambda (u--err) (lambda (eta-3) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-35) eta-3))) eta-2))) (else (lambda (eta-2) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-35) eta-2)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc6 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc6) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-2 (unbox sc6))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc5) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-2 (unbox sc5))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc4 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc4) (lambda (eta-0) (TTImpC-45ElabC-45App-makeImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-2 (unbox sc4))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0))))))))))) ((2) (if (null? arg-15) (if (null? arg-16) (if (null? arg-17) (if (null? arg-19) (if (null? arg-16) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc8 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc8) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 '() arg-17 arg-18 arg-19) (let ((e-1 (unbox sc8))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 '() e-6 arg-18 arg-19 eta-0))))))))) (let ((e-37 (car arg-16))) (let ((e-38 (cdr arg-16))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19) arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-37 arg-15 e-38 arg-17 arg-18 arg-19 eta-0))))) (let ((e-44 (unbox arg-19))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-44) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ty (vector 0 e-9 e-10 (vector 2 e-18 e-19 (vector 2 ) e-21) e-12))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((2) (lambda (eta-2) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-10 u--ty) (box e-44) eta-2)))(else (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-44))))))(else (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-44))))))(else (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 '() '() '() arg-18 (box e-44))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) (if (null? arg-16) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc7 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc7) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 '() arg-17 arg-18 arg-19) (let ((e-1 (unbox sc7))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 '() e-6 arg-18 arg-19 eta-0))))))))) (let ((e-37 (car arg-16))) (let ((e-38 (cdr arg-16))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19) arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-37 arg-15 e-38 arg-17 arg-18 arg-19 eta-0)))))) (if (null? arg-16) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc6 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc6) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 '() arg-17 arg-18 arg-19) (let ((e-1 (unbox sc6))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 '() e-6 arg-18 arg-19 eta-0))))))))) (let ((e-37 (car arg-16))) (let ((e-38 (cdr arg-16))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19) arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-37 arg-15 e-38 arg-17 arg-18 arg-19 eta-0)))))) (if (null? arg-16) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc5) (TTImpC-45ElabC-45App-makeAutoImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 arg-15 '() arg-17 arg-18 arg-19) (let ((e-1 (unbox sc5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 '() e-6 arg-18 arg-19 eta-0))))))))) (let ((e-37 (car arg-16))) (let ((e-38 (cdr arg-16))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19) arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-37 arg-15 e-38 arg-17 arg-18 arg-19 eta-0))))))) ((3) (let ((e-26 (vector-ref e-20 1))) (if (null? arg-15) (if (null? arg-16) (if (null? arg-17) (if (null? arg-19) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc7 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc7) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (unbox sc7))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0))))))))) (let ((e-49 (unbox arg-19))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-49) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ty (vector 0 e-9 e-10 (vector 2 e-18 e-19 (vector 3 e-26) e-21) e-12))) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((3) (let ((e-15 (vector-ref e-8 1))) (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Closure arg-1 arg-0 e-6 arg-10 e-26 e-15 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-16 1) (lambda (eta-3) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-6 arg-10 u--ty) (box e-49) eta-3))) (else (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 '() '() '() arg-18 (box e-49)))))) eff-0) eta-2))))))))(else (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 '() '() '() arg-18 (box e-49))))))(else (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 '() '() '() arg-18 (box e-49))))))(else (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 '() '() '() arg-18 (box e-49))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc6 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc6) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (unbox sc6))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc5) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (unbox sc5))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0)))))))))) (let ((u--argRig (AlgebraC-45ZeroOneOmega-rigMult arg-7 e-19))) (let ((sc4 (TTImpC-45ElabC-45App-findNamed e-10 arg-17))) (if (null? sc4) (TTImpC-45ElabC-45App-makeDefImplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-26 e-21 e-12 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (unbox sc4))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-13 (cdr e-5))) (lambda (eta-0) (TTImpC-45ElabC-45App-checkRestApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--argRig arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-21 e-12 arg-14 e-13 arg-15 arg-16 e-6 arg-18 arg-19 eta-0))))))))))))(else (if (null? arg-14) (lambda (clam-22) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-23) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-23)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-23))))))) eff-0) clam-22)))))) (let ((e-3 (car arg-14))) (let ((e-4 (cdr arg-14))) (lambda (clam-5) (if (null? arg-15) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-21) (let ((sc6 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc6 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-21)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-21))))))) eff-0) clam-5))))) (let ((e-6 (car arg-15))) (let ((e-7 (cdr arg-15))) (let ((act-1 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" 10 (lambda () "Function type") arg-10 arg-13 clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" 10 (lambda () "Function ") arg-12 clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-5))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-13 (vector 11 arg-11 e-15) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-16))) (lambda (eta-3) (let ((act-7 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-14 (vector 11 arg-11 e-15) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (box u--argTyG)) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-8 1))) ((let ((eff-0 (let ((e-2 (car e-22))) (let ((e-23 (cdr e-22))) (let ((u--fntm (vector 4 arg-11 arg-12 e-2))) (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-24 (vector-ref act-9 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-24 arg-10 e-17) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-25 (vector-ref act-10 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 e-13 (vector 2 arg-11 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-16) (let ((sc15 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc15))) (((e-1 'erased) 'erased) e-17))))))) (lambda (eta-7) (let ((act-11 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected function type") arg-10 u--expfnty eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-26 (vector-ref act-11 1))) (vector 0 e-26))) (else (let ((act-12 (if (null? arg-19) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-19))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected result type") arg-10 e-1 eta-7))))) (case (vector-ref act-12 0) ((0) (let ((e-27 (vector-ref act-12 1))) (vector 0 e-27))) (else (let ((act-13 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 u--fntm e-25 (cons e-3 (+ e-4 1)) e-7 arg-16 arg-17 arg-18 arg-19) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-28 (vector-ref act-13 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-11 arg-8 arg-10 (CoreC-45Normalise-glueBack arg-1 arg-0 e-24 arg-10 arg-13) u--expfnty) eta-8))) (case (vector-ref act-14 0) ((0) (let ((e-29 (vector-ref act-14 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-14 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-23))) (lambda (eta-9) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-11156 e-3 e-4 e-6 e-7 arg-0 arg-19 arg-18 arg-17 arg-16 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-13 e-14 e-15 e-16 u--argTyG e-17 e-2 e-23 _-0 u--fntm e-24 e-25 u--expfnty e-28 e-29 (let ((e-0 (vector-ref e-29 0))) e-0) eta-9))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5)))))))))))))))))))))))))(else (if (null? arg-14) (lambda (clam-26) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-27) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc4 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-27)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-27))))))) eff-0) clam-26)))))) (let ((e-3 (car arg-14))) (let ((e-4 (cdr arg-14))) (lambda (clam-6) (if (null? arg-15) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-25) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-25)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-25))))))) eff-0) clam-6))))) (let ((e-6 (car arg-15))) (let ((e-7 (cdr arg-15))) (let ((act-1 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" 10 (lambda () "Function type") arg-10 arg-13 clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" 10 (lambda () "Function ") arg-12 clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-13 (vector 11 arg-11 e-15) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-16))) (lambda (eta-3) (let ((act-7 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-14 (vector 11 arg-11 e-15) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (box u--argTyG)) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-8 1))) ((let ((eff-0 (let ((e-2 (car e-18))) (let ((e-19 (cdr e-18))) (let ((u--fntm (vector 4 arg-11 arg-12 e-2))) (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-20 (vector-ref act-9 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-20 arg-10 e-17) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-21 (vector-ref act-10 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 e-13 (vector 2 arg-11 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-16) (let ((sc14 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc14))) (((e-1 'erased) 'erased) e-17))))))) (lambda (eta-7) (let ((act-11 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected function type") arg-10 u--expfnty eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-22 (vector-ref act-11 1))) (vector 0 e-22))) (else (let ((act-12 (if (null? arg-19) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-19))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected result type") arg-10 e-1 eta-7))))) (case (vector-ref act-12 0) ((0) (let ((e-23 (vector-ref act-12 1))) (vector 0 e-23))) (else (let ((act-13 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 u--fntm e-21 (cons e-3 (+ e-4 1)) e-7 arg-16 arg-17 arg-18 arg-19) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-24 (vector-ref act-13 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-11 arg-8 arg-10 (CoreC-45Normalise-glueBack arg-1 arg-0 e-20 arg-10 arg-13) u--expfnty) eta-8))) (case (vector-ref act-14 0) ((0) (let ((e-25 (vector-ref act-14 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-14 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-19))) (lambda (eta-9) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-11156 e-3 e-4 e-6 e-7 arg-0 arg-19 arg-18 arg-17 arg-16 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-13 e-14 e-15 e-16 u--argTyG e-17 e-2 e-19 _-0 u--fntm e-20 e-21 u--expfnty e-24 e-25 (let ((e-0 (vector-ref e-25 0))) e-0) eta-9))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6))))))))))))))))))))))))) ((5) (let ((e-14 (vector-ref arg-13 1))) (let ((e-15 (vector-ref arg-13 2))) (let ((e-16 (vector-ref arg-13 3))) (case (vector-ref e-16 0) ((0) (let ((e-51 (vector-ref e-16 1))) (let ((e-52 (vector-ref e-16 2))) (let ((e-53 (vector-ref e-16 3))) (let ((e-54 (vector-ref e-16 4))) (case (vector-ref e-53 0) ((2) (let ((e-56 (vector-ref e-53 1))) (let ((e-57 (vector-ref e-53 2))) (let ((e-58 (vector-ref e-53 3))) (let ((e-59 (vector-ref e-53 4))) (let ((u--ty (vector 0 e-51 e-52 (vector 2 e-56 e-57 e-58 e-59) e-54))) (let ((sc3 (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-8 0))) e-0)))) (cond ((equal? sc3 1) (lambda (eta-0) (let ((act-1 (let ((sc4 (CoreC-45TTC-45BinderC-45PiInfo-isImplicit e-58))) (cond ((equal? sc4 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 53 arg-11) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (if (null? arg-15) (if (null? arg-16) (if (null? arg-17) (let ((act-2 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 u--ty arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-28) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-3) clam-28))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-2 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 6 e-14 e-15 e-7))))))) eff-0) clam-28)))))))))) eff-0) eta-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 54 arg-11) eta-0)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 54 arg-11) eta-0)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 54 arg-11) eta-0))))))) (else (TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (vector 8 e-14 e-15 arg-12) u--ty arg-14 arg-15 arg-16 arg-17 arg-18 arg-19))))))))))(else (if (null? arg-14) (lambda (clam-31) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-32) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-32)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-32))))))) eff-0) clam-31)))))) (let ((e-3 (car arg-14))) (let ((e-4 (cdr arg-14))) (lambda (clam-7) (if (null? arg-15) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-30) (let ((sc6 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc6 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-30)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-30))))))) eff-0) clam-7))))) (let ((e-6 (car arg-15))) (let ((e-7 (cdr arg-15))) (let ((act-1 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" 10 (lambda () "Function type") arg-10 arg-13 clam-7))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" 10 (lambda () "Function ") arg-12 clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-9 (vector 11 arg-11 e-11) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-12))) (lambda (eta-3) (let ((act-7 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-10 (vector 11 arg-11 e-11) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (box u--argTyG)) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-8 1))) ((let ((eff-0 (let ((e-2 (car e-17))) (let ((e-18 (cdr e-17))) (let ((u--fntm (vector 4 arg-11 arg-12 e-2))) (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-19 (vector-ref act-9 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-19 arg-10 e-13) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-20 (vector-ref act-10 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 e-9 (vector 2 arg-11 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-12) (let ((sc15 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc15))) (((e-1 'erased) 'erased) e-13))))))) (lambda (eta-7) (let ((act-11 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected function type") arg-10 u--expfnty eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-21 (vector-ref act-11 1))) (vector 0 e-21))) (else (let ((act-12 (if (null? arg-19) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-19))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected result type") arg-10 e-1 eta-7))))) (case (vector-ref act-12 0) ((0) (let ((e-22 (vector-ref act-12 1))) (vector 0 e-22))) (else (let ((act-13 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 u--fntm e-20 (cons e-3 (+ e-4 1)) e-7 arg-16 arg-17 arg-18 arg-19) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-23 (vector-ref act-13 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-11 arg-8 arg-10 (CoreC-45Normalise-glueBack arg-1 arg-0 e-19 arg-10 arg-13) u--expfnty) eta-8))) (case (vector-ref act-14 0) ((0) (let ((e-24 (vector-ref act-14 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-14 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-18))) (lambda (eta-9) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-11156 e-3 e-4 e-6 e-7 arg-0 arg-19 arg-18 arg-17 arg-16 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 e-10 e-11 e-12 u--argTyG e-13 e-2 e-18 _-0 u--fntm e-19 e-20 u--expfnty e-23 e-24 (let ((e-0 (vector-ref e-24 0))) e-0) eta-9))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7)))))))))))))))))))))))))(else (if (null? arg-14) (lambda (clam-35) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-36) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc4 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-36)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-36))))))) eff-0) clam-35)))))) (let ((e-3 (car arg-14))) (let ((e-4 (cdr arg-14))) (lambda (clam-8) (if (null? arg-15) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-34) (let ((sc5 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc5 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-34)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-34))))))) eff-0) clam-8))))) (let ((e-6 (car arg-15))) (let ((e-7 (cdr arg-15))) (let ((act-1 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" 10 (lambda () "Function type") arg-10 arg-13 clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" 10 (lambda () "Function ") arg-12 clam-8))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-8))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-9 (vector 11 arg-11 e-11) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-12))) (lambda (eta-3) (let ((act-7 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-10 (vector 11 arg-11 e-11) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (box u--argTyG)) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-8 1))) ((let ((eff-0 (let ((e-2 (car e-17))) (let ((e-18 (cdr e-17))) (let ((u--fntm (vector 4 arg-11 arg-12 e-2))) (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-19 (vector-ref act-9 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-19 arg-10 e-13) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-20 (vector-ref act-10 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 e-9 (vector 2 arg-11 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-12) (let ((sc14 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc14))) (((e-1 'erased) 'erased) e-13))))))) (lambda (eta-7) (let ((act-11 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected function type") arg-10 u--expfnty eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-21 (vector-ref act-11 1))) (vector 0 e-21))) (else (let ((act-12 (if (null? arg-19) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-19))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected result type") arg-10 e-1 eta-7))))) (case (vector-ref act-12 0) ((0) (let ((e-22 (vector-ref act-12 1))) (vector 0 e-22))) (else (let ((act-13 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 u--fntm e-20 (cons e-3 (+ e-4 1)) e-7 arg-16 arg-17 arg-18 arg-19) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-23 (vector-ref act-13 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-11 arg-8 arg-10 (CoreC-45Normalise-glueBack arg-1 arg-0 e-19 arg-10 arg-13) u--expfnty) eta-8))) (case (vector-ref act-14 0) ((0) (let ((e-24 (vector-ref act-14 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-14 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-18))) (lambda (eta-9) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-11156 e-3 e-4 e-6 e-7 arg-0 arg-19 arg-18 arg-17 arg-16 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 e-10 e-11 e-12 u--argTyG e-13 e-2 e-18 _-0 u--fntm e-19 e-20 u--expfnty e-23 e-24 (let ((e-0 (vector-ref e-24 0))) e-0) eta-9))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-8))))))))))))))))))))))))(else (if (null? arg-14) (lambda (clam-39) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-40) (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc3 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-40)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-40))))))) eff-0) clam-39)))))) (let ((e-3 (car arg-14))) (let ((e-4 (cdr arg-14))) (lambda (clam-9) (if (null? arg-15) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-38) (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ElabC-45App-isImplicitAs eta-0)) (PreludeC-45TypesC-45List-tailRecAppend arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (PreludeC-45TypesC-45List-filterAppend '() csegen-2599 arg-17)))))) (cond ((equal? sc4 1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 arg-12 (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 arg-13) arg-19 clam-38)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 27 arg-0 arg-11 arg-10 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 "<auto>"))) arg-16) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-17)) arg-12) clam-38))))))) eff-0) clam-9))))) (let ((e-6 (car arg-15))) (let ((e-7 (cdr arg-15))) (let ((act-1 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.with" 10 (lambda () "Function type") arg-10 arg-13 clam-9))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.with" 10 (lambda () "Function ") arg-12 clam-9))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45UnifyState-genName arg-1 arg-3 "argTy" clam-9))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "retTy" eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-9 (vector 11 arg-11 e-11) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--argTyG (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-12))) (lambda (eta-3) (let ((act-7 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-10 (vector 11 arg-11 e-11) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6 (box u--argTyG)) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (let ((e-2 (car e-14))) (let ((e-15 (cdr e-14))) (let ((u--fntm (vector 4 arg-11 arg-12 e-2))) (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-16 (vector-ref act-9 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-16 arg-10 e-13) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-17 (vector-ref act-10 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--expfnty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 e-9 (vector 2 arg-11 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-12) (let ((sc13 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc13))) (((e-1 'erased) 'erased) e-13))))))) (lambda (eta-7) (let ((act-11 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected function type") arg-10 u--expfnty eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-18 (vector-ref act-11 1))) (vector 0 e-18))) (else (let ((act-12 (if (null? arg-19) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-19))) (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.with" 10 (lambda () "Expected result type") arg-10 e-1 eta-7))))) (case (vector-ref act-12 0) ((0) (let ((e-19 (vector-ref act-12 1))) (vector 0 e-19))) (else (let ((act-13 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 u--fntm e-17 (cons e-3 (+ e-4 1)) e-7 arg-16 arg-17 arg-18 arg-19) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-20 (vector-ref act-13 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 ((TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-11 arg-8 arg-10 (CoreC-45Normalise-glueBack arg-1 arg-0 e-16 arg-10 arg-13) u--expfnty) eta-8))) (case (vector-ref act-14 0) ((0) (let ((e-21 (vector-ref act-14 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-14 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-15))) (lambda (eta-9) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWithC-39-11156 e-3 e-4 e-6 e-7 arg-0 arg-19 arg-18 arg-17 arg-16 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 e-10 e-11 e-12 u--argTyG e-13 e-2 e-15 _-0 u--fntm e-16 e-17 u--expfnty e-20 e-21 (let ((e-0 (vector-ref e-21 0))) e-0) eta-9))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9))))))))))))))))))))))
(define TTImpC-45ElabC-45Check-isLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define CoreC-45TTC-45Term-isCon (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (box (cons e-0 e-1))))) ((3) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (box (cons e-2 e-3)))))(else '()))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkAppWith-11642 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26) (if (null? arg-26) (lambda (eta-0) (vector 1 arg-20)) (let ((e-1 (unbox arg-26))) (lambda (clam-0) (if (null? e-1) (vector 1 arg-20) (let ((e-5 (cdr e-1))) (let ((sc2 (or (and (= e-5 (PreludeC-45TypesC-45List-lengthTR arg-25)) 1) 0))) (cond ((equal? sc2 1) (vector 1 arg-20)) (else (TTImpC-45ElabC-45Dot-registerDot arg-0 arg-19 arg-18 arg-17 arg-16 arg-13 arg-10 arg-9 6 (Builtin-fst arg-20) (Builtin-snd arg-20) clam-0)))))))))))
(define TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWith-11582 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (if (null? arg-22) (lambda (eta-0) (vector 1 arg-20)) (let ((e-2 (car arg-22))) (let ((e-3 (cdr arg-22))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkAppWith-11642 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-5 e-7 e-6 e-3 (CoreC-45TTC-45Term-isCon e-6))))))(else (lambda (eta-0) (vector 1 arg-20)))))))))
(define TTImpC-45ElabC-45App-checkAppWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 ext-0) (let ((act-1 ((TTImpC-45ElabC-45App-checkAppWithC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (TTImpC-45ElabC-45Check-isLHS (let ((e-0 (vector-ref arg-8 0))) e-0)))) (if (null? sc1) (lambda (eta-0) (vector 1 e-5)) (let ((e-1 (unbox sc1))) (TTImpC-45ElabC-45App-case--caseC-32blockC-32inC-32checkAppWith-11582 arg-0 arg-19 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-1 (CoreC-45TTC-45Term-getFnArgs (Builtin-fst e-5)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-getPrimNames (lambda (arg-0 ext-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (CoreC-45Core-C-60C-42C-62 (lambda (eta-5) (CoreC-45Core-C-60C-42C-62 csegen-1325 (lambda (eta-6) (CoreC-45Context-fromIntegerName arg-0 eta-6)) eta-5)) (lambda (eta-5) (CoreC-45Context-fromStringName arg-0 eta-5)) eta-4)) (lambda (eta-4) (CoreC-45Context-fromCharName arg-0 eta-4)) eta-3)) (lambda (eta-3) (CoreC-45Context-fromDoubleName arg-0 eta-3)) eta-2)) (lambda (eta-2) (CoreC-45Context-fromTTImpName arg-0 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-fromNameName arg-0 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-fromDeclsName arg-0 eta-0)) ext-0)))
(define CoreC-45Options-primNamesToList (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (DataC-45List-catMaybes (cons e-0 (cons e-1 (cons e-2 (cons e-3 (cons e-4 (cons e-5 (cons e-6 '())))))))))))))))))
(define CoreC-45Context-getPrimitiveNames (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45Options-primNamesToList e-5)))))) (lambda (eta-0) (CoreC-45Context-getPrimNames arg-0 eta-0)) ext-0)))
(define CoreC-45FC-startPos (lambda (arg-0) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) e-6))))
(define CoreC-45FC-startLine (lambda (ext-0) (Builtin-fst (CoreC-45FC-startPos ext-0))))
(define CoreC-45TTC-45TermC-45Subst-substBinder (lambda (arg-3 arg-4 arg-5 arg-6) (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 eta-0)) arg-6)))
(define CoreC-45TTC-45TermC-45Subst-substTerms (lambda (arg-3 arg-4 arg-5 arg-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 eta-0)) arg-6)))
(define CoreC-45TTC-45TermC-45Subst-substTerm (lambda (arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (CoreC-45TTC-45Subst-find CoreC-45TTC-45Term-WeakenTerm (lambda (vars-5343) (lambda (lamc-0) (vector 0 e-2 e-3 lamc-0))) arg-3 arg-4 e-4 arg-5))))) ((1) (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (vector 2 e-11 e-12 e-13 (CoreC-45TTC-45TermC-45Subst-substTerms arg-3 arg-4 arg-5 e-14))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (vector 3 e-16 e-17 (CoreC-45TTC-45TermC-45Subst-substBinder arg-3 arg-4 arg-5 e-18) (CoreC-45TTC-45TermC-45Subst-substTerm (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3) arg-4 arg-5 e-19))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (vector 4 e-21 (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-22) (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-23)))))) ((5) (let ((e-25 (vector-ref arg-6 1))) (let ((e-26 (vector-ref arg-6 2))) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (vector 5 e-25 e-26 (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-27) (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-28))))))) ((6) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (vector 6 e-30 e-31 (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-32)))))) ((7) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (vector 7 e-34 e-35 (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-36) (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-37))))))) ((8) (let ((e-39 (vector-ref arg-6 1))) (let ((e-40 (vector-ref arg-6 2))) (let ((e-41 (vector-ref arg-6 3))) (vector 8 e-39 e-40 (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-41)))))) ((9) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-6 1))) (let ((e-47 (vector-ref arg-6 2))) (case (vector-ref e-47 0) ((1) (vector 10 e-46 (vector 1 ))) ((0) (vector 10 e-46 (vector 0 ))) (else (let ((e-54 (vector-ref e-47 1))) (vector 10 e-46 (vector 2 (CoreC-45TTC-45TermC-45Subst-substTerm arg-3 arg-4 arg-5 e-54))))))))) (else (let ((e-49 (vector-ref arg-6 1))) (let ((e-50 (vector-ref arg-6 2))) (vector 11 e-49 e-50)))))))
(define CoreC-45TTC-45TermC-45Subst-substs (lambda (arg-2 arg-3 arg-4) (CoreC-45TTC-45TermC-45Subst-substTerm 0 arg-2 arg-3 arg-4)))
(define CoreC-45TTC-45TermC-45Subst-subst (lambda (arg-2 arg-3) (CoreC-45TTC-45TermC-45Subst-substs (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) (cons arg-2 '()) arg-3)))
(define CoreC-45Metadata-substEnv (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-9 (cdr arg-2))) (CoreC-45Metadata-substEnv e-3 arg-1 e-9 (CoreC-45TTC-45TermC-45Subst-subst (vector 1 arg-1 (vector 0 ) e-2) arg-3))))))))
(define CoreC-45Metadata-addNameType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getFullName arg-1 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (CoreC-45FC-isConcreteFC arg-3))) (if (null? sc2) (vector 1 (vector 0 )) (let ((e-1 (unbox sc2))) (let ((act-3 (let ((act-3 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 (cons (cons e-1 (cons e-6 (cons 0 (CoreC-45Metadata-substEnv arg-0 arg-3 arg-5 arg-6)))) e-12) e-2 e-3 e-4 e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-log arg-1 "metadata.names" 7 (lambda () (string-append (CoreC-45Name-u--show_Show_Name e-6) (string-append " at line " (PreludeC-45Show-u--show_Show_Int (bs+ (blodwen-toSignedInt 1 63) (CoreC-45FC-startLine e-1) 63))))) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-isAllPublic (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-0 (vector-ref e-5 0))) (let ((e-37 (vector-ref e-0 8))) e-37)))))) eff-0) ext-0)))))))
(define CoreC-45NameC-45Namespace-n--4957-8396-u--go (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons (cons e-2 e-3) (CoreC-45NameC-45Namespace-n--4957-8396-u--go arg-0 e-3)))))))
(define CoreC-45NameC-45Namespace-allParents (lambda (arg-0) (CoreC-45NameC-45Namespace-n--4957-8396-u--go arg-0 arg-0)))
(define CoreC-45Context-n--30324-25294-u--visible (lambda (arg-0 arg-1 arg-2) (CoreC-45NameC-45Namespace-isParentOf arg-2 arg-0)))
(define CoreC-45Context-isVisible (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) (CoreC-45Context-n--30324-25294-u--visible arg-1 arg-0 eta-1)) (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45NameC-45Namespace-allParents (let ((e-2 (vector-ref e-5 2))) e-2)) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-3 (vector-ref e-5 3))) e-3) (let ((e-0 (vector-ref e-5 0))) (let ((e-38 (vector-ref e-0 7))) e-38))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-checkVisibleNS (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (let ((act-1 (CoreC-45Context-isVisible arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-5 1) (let ((act-2 (CoreC-45Context-isAllPublic arg-0 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getNS arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-getNestedNS arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc6 (cond ((equal? e-6 1) 1) (else (CoreC-45Context-visibleInAny (cons e-7 e-8) (vector 0 e-0 e-1) arg-3))))) (cond ((equal? sc6 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 8 arg-1 (vector 0 e-0 e-1) '()) clam-2))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 8 arg-1 (vector 0 e-0 e-1) (box e-0)) clam-1)))))) eff-0) ext-0))))))))(else (vector 1 (vector 0 ))))))
(define CoreC-45Env-defined (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (let ((sc2 (CoreC-45Name-nameEq arg-1 e-2))) (if (null? sc2) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Env-defined e-3 arg-1 e-9) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) (box (cons (+ e-5 1) e-4)))))) (box (cons 0 (CoreC-45TTC-45Binder-multiplicity e-8))))))))))))
(define AlgebraC-45Semiring-isLinear (lambda (arg-1 ext-0) (AlgebraC-45Semiring-elimSemi arg-1 0 1 (lambda (eta-0) 0) ext-0)))
(define CoreC-45Name-isSourceName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (CoreC-45Name-isSourceName e-1))) ((1) 1) ((2) 0) ((3) (let ((e-5 (vector-ref arg-0 1))) (CoreC-45Name-isSourceName e-5))) ((4) (let ((e-8 (vector-ref arg-0 2))) (CoreC-45Name-isSourceName e-8))) ((5) (let ((e-10 (vector-ref arg-0 2))) (CoreC-45Name-isSourceName e-10))) ((6) 0) ((7) 0) (else 0))))
(define CoreC-45Name-case--isUnsafeBuiltin-9826 (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref e-3 0) ((1) (let ((e-4 (vector-ref e-3 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (let ((sc3 (let ((sc4 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-2 CoreC-45NameC-45Namespace-builtinNS))) (cond ((equal? sc4 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-2 CoreC-45NameC-45Namespace-emptyNS)))))) (cond ((equal? sc3 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) eta-0) (cons (DataC-45String-isPrefixOf "assert_" e-5) (cons (PreludeC-45Types-elem csegen-14 csegen-22 e-5 (cons "prim__believe_me" (cons "believe_me" (cons "prim__crash" (cons "idris_crash" '()))))) '())))) (else 0)))))(else 0))))(else 0)))))))
(define CoreC-45Name-isUnsafeBuiltin (lambda (arg-0) (CoreC-45Name-case--isUnsafeBuiltin-9826 arg-0 (CoreC-45Name-splitNS arg-0))))
(define CoreC-45Metadata-n--8986-6209-u--nameTypeDecoration (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) 5) ((1) 2) ((2) 3) (else 1))))
(define CoreC-45Metadata-nameDecoration (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-isUnsafeBuiltin arg-0))) (cond ((equal? sc0 1) 7) (else (CoreC-45Metadata-n--8986-6209-u--nameTypeDecoration arg-1 arg-0 arg-1))))))
(define TTImpC-45ElabC-45App-n--10719-1888-u--checkDeprecation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 2 ) (let ((e-12 (vector-ref arg-10 12))) e-12)))) (cond ((equal? sc0 1) (CoreC-45Context-recordWarning arg-8 (vector 5 arg-9 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-10 1))) e-1)) (cons " is deprecated and will be removed in a future version." '()))) (box (cons arg-9 (let ((e-1 (vector-ref arg-10 1))) e-1)))))) (else (lambda (eta-0) (vector 1 (vector 0 ))))))))
(define AlgebraC-45Preorder-C-60 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((sc1 (Builtin-fst arg-1))) (let ((e-1 (vector-ref sc1 0))) ((e-1 arg-2) arg-3))))) (cond ((equal? sc0 1) (let ((sc1 (Builtin-snd arg-1))) (let ((e-2 (cdr sc1))) ((e-2 arg-2) arg-3)))) (else 0)))))
(define TTImpC-45ElabC-45App-n--10719-1889-u--rigSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (CoreC-45Context-getFullName arg-8 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (AlgebraC-45Preorder-C-60 csegen-2567 arg-9 arg-10))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 14 arg-2 e-5 arg-9 arg-10) clam-0)) (else (vector 1 (vector 0 )))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-case--getNameType-1968 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (let ((act-1 (let ((act-1 (unbox arg-8))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-8 arg-2 arg-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-8 arg-2 arg-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-7 (cdr e-1))) (lambda (clam-1) (if (null? e-7) (CoreC-45Context-ambiguousName arg-8 arg-2 arg-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-1) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (if (null? e-2) (let ((act-3 (TTImpC-45ElabC-45App-checkVisibleNS arg-8 arg-2 (let ((e-30 (vector-ref e-10 1))) e-30) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-24 (vector-ref e-10 9))) e-24)) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 (let ((sc8 (TTImpC-45ElabC-45App-onLHS arg-5))) (cond ((equal? sc8 1) (vector 1 (vector 0 ))) (else ((TTImpC-45ElabC-45App-n--10719-1888-u--checkDeprecation arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-2 e-10) clam-1)))))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 (TTImpC-45ElabC-45App-n--10719-1889-u--rigSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-28 (vector-ref e-10 7))) e-28) arg-4 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref e-10 18))) e-18))))) (let ((act-6 (CoreC-45ContextC-45Log-log arg-8 "ide-mode.highlight" 8 (lambda () (string-append "getNameType is trying to add something for: " (string-append (CoreC-45Name-u--show_Show_Name (let ((e-33 (vector-ref e-10 1))) e-33)) (string-append " (" (string-append (CoreC-45FC-u--show_Show_FC arg-2) ")"))))) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((act-7 (let ((sc11 (CoreC-45Name-isSourceName (let ((e-34 (vector-ref e-10 1))) e-34)))) (cond ((equal? sc11 1) (let ((sc12 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc12) (vector 1 (vector 0 )) (let ((e-3 (unbox sc12))) (let ((u--decor (let ((sc13 (let ((e-26 (vector-ref e-10 11))) e-26))) (cond ((equal? sc13 1) 7) (else (CoreC-45Metadata-nameDecoration (let ((e-35 (vector-ref e-10 1))) e-35) u--nt)))))) (let ((act-7 (CoreC-45ContextC-45Log-log arg-8 "ide-mode.highlight" 7 (lambda () (string-append "getNameType is adding " (string-append (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration u--decor) (string-append ": " (CoreC-45Name-u--show_Show_Name (let ((e-35 (vector-ref e-10 1))) e-35)))))) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (CoreC-45Metadata-addSemanticDecorations arg-7 arg-8 (cons (cons e-3 (cons u--decor (box (let ((e-36 (vector-ref e-10 1))) e-36)))) '()) clam-1))))))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (vector 1 (cons (vector 1 arg-2 u--nt (vector 8 e-9)) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-3 (let ((e-34 (vector-ref e-10 2))) e-34)))))))))))))))))))) (CoreC-45Context-ambiguousName arg-8 arg-2 arg-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-1))))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-1 (unbox arg-9))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-1 (TTImpC-45ElabC-45App-n--10719-1889-u--rigSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 arg-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--binder (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-0 e-5 arg-3))) (let ((u--bty (CoreC-45TTC-45Binder-binderType u--binder))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-8 "metadata.names" 7 (lambda () "getNameType is adding \x2193;") clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Metadata-addNameType arg-0 arg-8 arg-7 arg-2 arg-1 arg-3 u--bty clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((sc5 (AlgebraC-45Semiring-isLinear csegen-931 e-6))) (cond ((equal? sc5 1) ((let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-6))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-6 (let ((e-21 (vector-ref e-10 0))) (let ((e-2 (vector-ref e-10 1))) (let ((e-3 (vector-ref e-10 2))) (let ((e-4 (vector-ref e-10 3))) (let ((e-20 (vector-ref e-10 4))) (let ((e-19 (vector-ref e-10 5))) (let ((e-18 (vector-ref e-10 6))) (let ((e-17 (vector-ref e-10 7))) (let ((e-16 (vector-ref e-10 8))) (let ((e-15 (vector-ref e-10 9))) (let ((e-11 (vector-ref e-10 10))) (let ((e-12 (vector-ref e-10 11))) (let ((e-13 (vector-ref e-10 12))) (let ((e-14 (vector-ref e-10 13))) (vector e-21 e-2 e-3 e-4 e-20 e-19 e-18 e-17 e-16 e-15 e-11 (cons e-5 e-12) e-13 e-14)))))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))) clam-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45ContextC-45Log-log arg-8 "ide-mode.highlight" 8 (lambda () (string-append "getNameType is trying to add Bound: " (string-append (CoreC-45Name-u--show_Show_Name arg-1) (string-append " (" (string-append (CoreC-45FC-u--show_Show_FC arg-2) ")"))))) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((sc7 (CoreC-45Name-isSourceName arg-1))) (cond ((equal? sc7 1) (let ((sc8 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc8) (vector 1 (vector 0 )) (let ((e-2 (unbox sc8))) (let ((act-6 (CoreC-45ContextC-45Log-log arg-8 "ide-mode.highlight" 7 (lambda () (string-append "getNameType is adding Bound: " (CoreC-45Name-u--show_Show_Name arg-1))) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (CoreC-45Metadata-addSemanticDecorations arg-7 arg-8 (cons (cons e-2 (cons 5 (box arg-1))) '()) clam-0)))))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 0 arg-2 (box (CoreC-45TTC-45Binder-isLet u--binder)) e-5) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-3 u--bty))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45App-getNameType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (TTImpC-45ElabC-45App-case--getNameType-1968 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45Env-defined arg-0 arg-8 arg-6))))
(define TTImpC-45ElabC-45App-n--11320-2455-u--useVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-11) arg-12 (let ((e-12 (car arg-11))) (let ((e-13 (cdr arg-11))) (case (vector-ref arg-12 0) ((3) (let ((e-15 (vector-ref arg-12 1))) (let ((e-16 (vector-ref arg-12 2))) (let ((e-17 (vector-ref arg-12 3))) (let ((e-18 (vector-ref arg-12 4))) (case (vector-ref e-17 0) ((2) (let ((e-20 (vector-ref e-17 1))) (let ((e-21 (vector-ref e-17 2))) (let ((e-23 (vector-ref e-17 4))) (vector 3 e-15 e-16 (vector 1 e-20 e-21 e-12 e-23) (TTImpC-45ElabC-45App-n--11320-2455-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-16 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) e-13) e-18))))))(else (case (vector-ref arg-12 0) ((3) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45App-n--11320-2455-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-2 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc4 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc4))) (((e-10 'erased) 'erased) eta-0)))) arg-11) e-4)))))))(else arg-12)))))))(else arg-12)))))))))(else (case (vector-ref arg-12 0) ((3) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (TTImpC-45ElabC-45App-n--11320-2455-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons e-2 arg-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc3))) (((e-10 'erased) 'erased) eta-0)))) arg-11) e-4)))))))(else arg-12)))))))(else arg-12)))))))))
(define TTImpC-45ElabC-45App-case--getVarType-2537 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45App-getNameType arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-3 arg-2 arg-1) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-2 (cons 0 e-3)))))))) eff-0) eta-0)))))) (let ((e-2 (unbox arg-10))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--arglen (PreludeC-45TypesC-45List-lengthTR e-9))) (let ((u--nC-39 (DataC-45Maybe-fromMaybe (lambda () arg-1) e-5))) (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact u--nC-39 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-1) (CoreC-45Context-undefinedName arg-9 arg-2 u--nC-39 eta-1)) (let ((e-3 (unbox e-8))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref e-3 18))) e-18))))) (let ((u--tm ((e-10 arg-2) u--nt))) (let ((u--tyenv (TTImpC-45ElabC-45App-n--11320-2455-u--useVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-0 (CoreC-45TTC-45Term-getArgs u--tm) (let ((e-30 (vector-ref e-3 2))) e-30)))) (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45App-checkVisibleNS arg-9 arg-2 (let ((e-1 (vector-ref e-3 1))) e-1) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-24 (vector-ref e-3 9))) e-24)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (CoreC-45ContextC-45Log-logTerm arg-0 arg-9 "elab" 5 (lambda () (string-append "Type of " (CoreC-45Name-u--show_Show_Name u--nC-39))) u--tyenv eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45ContextC-45Log-logTerm arg-0 arg-9 "elab" 5 (lambda () "Expands to") u--tm eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-9 "elab" 5 (lambda () (string-append "Arg length " (PreludeC-45Show-u--show_Show_Nat u--arglen))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45ContextC-45Log-log arg-9 "metadata.names" 7 (lambda () "getVarType is adding \x2193;") eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45Metadata-addNameType arg-0 arg-9 arg-8 arg-2 arg-1 arg-3 u--tyenv eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (let ((sc12 (CoreC-45Name-isSourceName (let ((e-1 (vector-ref e-3 1))) e-1)))) (cond ((equal? sc12 1) (let ((sc13 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc13) (vector 1 (vector 0 )) (let ((e-1 (unbox sc13))) (let ((u--decor (CoreC-45Metadata-nameDecoration (let ((e-37 (vector-ref e-3 1))) e-37) u--nt))) (let ((act-9 (CoreC-45ContextC-45Log-log arg-9 "ide-mode.highlight" 7 (lambda () (string-append "getNameType is adding " (string-append (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration u--decor) (string-append ": " (CoreC-45Name-u--show_Show_Name (let ((e-37 (vector-ref e-3 1))) e-37)))))) eta-1))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (CoreC-45Metadata-addSemanticDecorations arg-8 arg-9 (cons (cons e-1 (cons u--decor (box (let ((e-38 (vector-ref e-3 1))) e-38)))) '()) eta-1))))))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (vector 1 (cons u--tm (cons u--arglen (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-3 u--tyenv))))))))))))))))))))))))))))))))) eff-0) eta-0)))))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ElabC-45App-getVarType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (TTImpC-45ElabC-45App-case--getVarType-2537 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45List-lookup csegen-832 arg-9 arg-6))))
(define TTImpC-45TTImp-isIPrimVal (lambda (arg-1) (case (vector-ref arg-1 0) ((28) (let ((e-2 (vector-ref arg-1 2))) (box e-2)))(else '()))))
(define CoreC-45Context-n--34160-29001-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) 0 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (CoreC-45Name-splitNS e-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-4 arg-3))) (cond ((equal? sc3 1) (CoreC-45NameC-45Namespace-isApproximationOf e-5 arg-2)) (else 0))))) (cond ((equal? sc2 1) 1) (else (CoreC-45Context-n--34160-29001-u--go arg-0 arg-1 arg-2 arg-3 e-3))))))))))))
(define CoreC-45Context-isPrimName (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-splitNS arg-1))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (CoreC-45Context-n--34160-29001-u--go arg-1 arg-0 e-2 e-3 arg-0))))))
(define CoreC-45Value-withAll (vector 0 0 1 1 0 '() '() 1))
(define CoreC-45Normalise-normaliseAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 CoreC-45Value-withAll arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Normalise-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32normalisePrims-8715 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (lambda (clam-0) (if (null? arg-14) (vector 1 '()) (let ((e-1 (unbox arg-14))) (let ((sc1 (arg-9 e-1))) (cond ((equal? sc1 1) (let ((act-1 (let ((act-1 (unbox arg-10))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (cond ((equal? arg-7 1) (CoreC-45Normalise-normaliseAll arg-10 arg-1 e-5 arg-2 arg-3 eta-0)) (else (CoreC-45Normalise-normalise arg-10 arg-1 e-5 arg-2 arg-3 eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 '())))))))))
(define CoreC-45Normalise-case--caseC-32blockC-32inC-32normalisePrims-8678 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (vector 1 '())) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (CoreC-45Normalise-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32normalisePrims-8715 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2 e-1 (arg-8 e-1)))))))
(define CoreC-45Normalise-normalisePrims (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (CoreC-45Context-getFullName arg-1 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (CoreC-45Context-isPrimName arg-6 e-5))) (cond ((equal? sc1 1) (CoreC-45Normalise-case--caseC-32blockC-32inC-32normalisePrims-8678 arg-2 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-1 e-5 (PreludeC-45TypesC-45List-reverse arg-8)))(else (lambda (eta-0) (vector 1 '()))))))) eff-0) ext-0)))))))
(define PreludeC-45Num-u--abs_Abs_Integer (lambda (arg-0) (let ((sc0 (PreludeC-45EqOrd-u--C-60_Ord_Integer arg-0 0))) (cond ((equal? sc0 1) (- 0 arg-0)) (else arg-0)))))
(define TTImpC-45ElabC-45App-n--22594-12140-u--boundSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23) (case (vector-ref arg-23 0) ((1) 1)(else (case (vector-ref arg-22 0) ((5) (let ((e-0 (vector-ref arg-22 1))) (PreludeC-45EqOrd-u--C-60_Ord_Integer (PreludeC-45Num-u--abs_Abs_Integer e-0) 100))) ((10) (let ((e-1 (vector-ref arg-22 1))) (PreludeC-45Types-u--C-60_Ord_Nat (PreludeC-45TypesC-45String-length e-1) 10)))(else 1))))))
(define TTImpC-45ElabC-45App-n--22454-12117-u--normalisePrims (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (let ((act-1 (CoreC-45Normalise-normalisePrims arg-17 arg-18 (lambda (arg-22) (TTImpC-45ElabC-45App-n--22594-12140-u--boundSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-21 arg-20 arg-19 arg-22 (let ((e-0 (vector-ref arg-10 0))) e-0))) (lambda (eta-0) (TTImpC-45TTImp-isIPrimVal eta-0)) (TTImpC-45ElabC-45App-onLHS (let ((e-0 (vector-ref arg-10 0))) e-0)) arg-19 arg-1 arg-6 (Builtin-fst arg-21) arg-20 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (DataC-45Maybe-fromMaybe (lambda () (Builtin-fst arg-21)) e-5) (Builtin-snd arg-21)))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45App-n--22454-12118-u--updateElabInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (case (vector-ref arg-19 0) ((1) (if (null? arg-21) (lambda (eta-0) (vector 1 arg-22)) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (lambda (clam-0) (case (vector-ref e-2 0) ((28) (if (null? e-3) (let ((act-1 (CoreC-45Context-getFullName arg-17 arg-20 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc5 (CoreC-45Context-isPrimName arg-18 e-7))) (cond ((equal? sc5 1) (vector 1 (let ((e-1 (vector-ref arg-22 1))) (let ((e-10 (vector-ref arg-22 2))) (let ((e-9 (vector-ref arg-22 3))) (let ((e-4 (vector-ref arg-22 4))) (let ((e-8 (vector-ref arg-22 5))) (vector (vector 2 ) e-1 e-10 e-9 e-4 e-8)))))))) (else (vector 1 arg-22))))))) eff-0) clam-0))))) (vector 1 arg-22)))(else (vector 1 arg-22))))))))(else (lambda (eta-0) (vector 1 arg-22))))))
(define TTImpC-45ElabC-45App-checkApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (case (vector-ref arg-12 0) ((8) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-1 e-2 (cons e-3 arg-13) arg-14 arg-15 arg-16))))) ((9) (let ((e-5 (vector-ref arg-12 1))) (let ((e-6 (vector-ref arg-12 2))) (let ((e-7 (vector-ref arg-12 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5 e-6 arg-13 (cons e-7 arg-14) arg-15 arg-16))))) ((10) (let ((e-9 (vector-ref arg-12 1))) (let ((e-10 (vector-ref arg-12 2))) (let ((e-11 (vector-ref arg-12 3))) (let ((e-12 (vector-ref arg-12 4))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-9 e-10 arg-13 arg-14 (cons (cons e-11 e-12) arg-15) arg-16)))))) ((0) (let ((e-14 (vector-ref arg-12 1))) (let ((e-15 (vector-ref arg-12 2))) (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45App-getVarType arg-0 arg-1 arg-2 arg-4 (let ((e-0 (vector-ref arg-8 0))) e-0) arg-7 arg-9 arg-10 e-14 e-15) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-7) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-getPrimitiveNames arg-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45App-n--22454-12118-u--updateElabInfo arg-0 e-15 e-14 arg-16 arg-15 arg-14 arg-13 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 (let ((e-0 (vector-ref arg-8 0))) e-0) e-15 arg-13 arg-8) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Metadata-addNameLoc arg-2 arg-1 e-14 e-15 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "elab" 10 (lambda (eta-4) (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-12 arg-10 e-8 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 ((PreludeC-45Types-maybe (lambda () (lambda (eta-7) (vector 1 '()))) (lambda () (lambda (u--t) (lambda (eta-7) (let ((act-8 ((CoreC-45NormaliseC-45Eval-getTerm u--t) eta-7))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-9 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-12 arg-10 e-16 eta-8))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-10 (CoreC-45Context-toFullNames arg-1 csegen-68 e-17 eta-9))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-10) (vector 1 (box e-18))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) arg-16) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-9 (CoreC-45Context-getFullName arg-1 e-15 eta-7))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-10 (CoreC-45Context-toFullNames arg-1 csegen-68 e-13 eta-8))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-9) (vector 1 (string-append "Checking application of " (string-append (CoreC-45Name-u--show_Show_Name e-17) (string-append " (" (string-append (CoreC-45Name-u--show_Show_Name e-15) (string-append ")" (string-append " to " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 arg-13) (string-append "\xa;\x9;Function type " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-18) (string-append "\xa;\x9;Expected app type " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-16))))))))))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((u--fn (TTImpC-45TTImp-mapNestedName arg-9 e-15))) (let ((act-7 (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-10 arg-9 arg-10 arg-11 e-2 e-8 (cons (box u--fn) e-6) arg-13 arg-14 arg-15 0 arg-16 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45App-n--22454-12117-u--normalisePrims arg-0 e-15 e-14 arg-16 arg-15 arg-14 arg-13 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-9 arg-10 e-13 eta-4)))) eff-0) eta-3))))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 '() eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-3) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45App-checkAppWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2 e-6 (cons '() 0) arg-13 arg-14 arg-15 0 arg-16 eta-1)))) eff-0) clam-1)))))))))) eff-0) eta-0))))))))))
(define TTImpC-45ElabC-45Check-implBindVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) (CoreC-45ContextC-45Context-holeInit 1)) 1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-3 (cdr e-5))) (vector 1 e-3))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45ImplicitBind-case--mkOuterHole-13462 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-mkOuterHole arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 '() eta-0)) (let ((e-2 (unbox arg-12))) (let ((u--env (let ((e-3 (vector-ref arg-9 2))) e-3))) (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45Check-implBindVar (let ((e-1 (vector-ref arg-9 0))) e-1) arg-7 arg-6 arg-5 arg-4 u--env arg-3 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-5 arg-10) (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-2 arg-10)))))) eff-0) eta-0)))))))))))
(define TTImpC-45ElabC-45ImplicitBind-mkOuterHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-8) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--sub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((u--env (let ((e-3 (vector-ref e-5 2))) e-3))) (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genName arg-2 arg-3 (string-append "type_of_" (CoreC-45Name-nameRoot arg-6)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-uniVar arg-2 arg-3 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-metaVar (let ((e-1 (vector-ref e-5 0))) e-1) arg-2 arg-3 arg-4 csegen-30 u--env e-6 (vector 11 arg-4 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45ContextC-45Log-log arg-2 "elab.implicits" 10 (lambda () (string-append "Made metavariable for type of " (string-append (CoreC-45Name-u--show_Show_Name arg-6) (string-append ": " (CoreC-45Name-u--show_Show_Name e-6))))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (set-box! arg-1 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-6 arg-5 (vector 1 ) arg-7 (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-8 u--sub) (vector 11 arg-4 e-7) e-5)))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (TTImpC-45ElabC-45Check-implBindVar (let ((e-1 (vector-ref e-5 0))) e-1) arg-2 arg-3 arg-4 arg-5 u--env arg-6 e-8 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-11 u--sub) (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-8 u--sub)))))) eff-0) eta-3)))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-8))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--sub (let ((e-4 (vector-ref e-5 3))) e-4))) (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45ImplicitBind-case--mkOuterHole-13462 arg-0 e-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 u--sub e-6 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-6 u--sub)))) eff-0) eta-0))))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--11250-13775-u--bindInner (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((0) (box arg-13))(else (if (null? arg-11) '() (let ((e-1 (car arg-11))) (let ((e-2 (cdr arg-11))) (if (null? arg-12) '() (let ((e-6 (car arg-12))) (let ((e-7 (cdr arg-12))) (case (vector-ref arg-14 0) ((1) (let ((e-12 (vector-ref arg-14 1))) (TTImpC-45ElabC-45ImplicitBind-n--11250-13775-u--bindInner arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-7 (vector 3 arg-6 e-1 e-6 arg-13) e-12)))(else '()))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--11250-13776-u--mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) '())(else (if (null? arg-11) '() (let ((e-2 (cdr arg-11))) (case (vector-ref arg-12 0) ((1) (let ((e-7 (vector-ref arg-12 1))) (cons (vector 0 arg-6 '() 0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (car sc2))) (((e-4 'erased) 'erased) eta-0)))) (TTImpC-45ElabC-45ImplicitBind-n--11250-13776-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 e-7)))))(else '()))))))))
(define TTImpC-45ElabC-45ImplicitBind-case--mkPatternHole-13926 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (TTImpC-45ElabC-45ImplicitBind-mkPatternHole arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 '()) (let ((e-2 (unbox arg-14))) (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45Check-implBindVar (let ((e-1 (vector-ref arg-10 0))) e-1) arg-8 arg-7 arg-6 arg-5 arg-12 arg-4 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (CoreC-45TTC-45Term-apply arg-6 (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-5 arg-11) (TTImpC-45ElabC-45ImplicitBind-n--11250-13776-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-0 arg-11)) (cons arg-13 (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-2 arg-11))))))) eff-0) eta-0))))))))))
(define TTImpC-45ElabC-45ImplicitBind-mkPatternHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((act-1 (TTImpC-45ElabC-45ImplicitBind-mkOuterHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (cons e-4 (cons e-3 e-3)))))))) eff-0) clam-0))))))(else (if (null? arg-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 (string-append "Unknown type for pattern variable " (CoreC-45Name-u--show_Show_Name arg-6))) clam-0) (let ((e-1 (unbox arg-9))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--sub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((u--env (let ((e-3 (vector-ref e-5 2))) e-3))) (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45ImplicitBind-case--mkPatternHole-13926 arg-0 e-1 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 u--sub u--env e-6 (TTImpC-45ElabC-45ImplicitBind-n--11250-13775-u--bindInner arg-0 e-1 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-7 e-6 u--sub)))) eff-0) eta-0)))))))))) eff-0) clam-0))))))))))))
(define TTImpC-45ElabC-45Check-noteLHSPatVar (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 (cons arg-3 e-8) e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))))(else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define TTImpC-45ElabC-45Check-notePatVar (lambda (arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 e-8 (cons arg-2 e-9) e-10 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ElabC-45As-n--10699-8369-u--rigAsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (cond ((equal? arg-17 0) (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-10))) (cond ((equal? sc1 1) csegen-30) (else arg-10)))) (else (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-10))) (cond ((equal? sc1 1) csegen-1416) (else arg-10)))))))
(define TTImpC-45ElabC-45As-n--10699-8368-u--rigAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (TTImpC-45ElabC-45As-n--10699-8369-u--rigAsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-4)))
(define TTImpC-45ElabC-45As-n--10699-8371-u--rigPatC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (cond ((equal? arg-17 0) (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-10))) (cond ((equal? sc1 1) csegen-1416) (else arg-10)))) (else (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-10))) (cond ((equal? sc1 1) csegen-30) (else arg-10)))))))
(define TTImpC-45ElabC-45As-n--10699-8370-u--rigPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (TTImpC-45ElabC-45As-n--10699-8371-u--rigPatC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-4)))
(define TTImpC-45ElabC-45As-checkAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (let ((u--elabmode (let ((e-0 (vector-ref arg-8 0))) e-0))) (lambda (clam-0) (case (vector-ref u--elabmode 0) ((1) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (vector 3 arg-14 (let ((e-2 (vector-ref e-5 1))) e-2)))) (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45Check-noteLHSPatVar arg-4 u--elabmode arg-14) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45ElabC-45Check-notePatVar arg-4 u--n) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((sc4 (DataC-45List-lookup csegen-832 u--n (let ((e-17 (vector-ref e-5 4))) e-17)))) (if (null? sc4) (let ((act-4 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (TTImpC-45ElabC-45As-n--10699-8370-u--rigPat arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) arg-8 arg-9 arg-10 arg-15 arg-16) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((act-5 ((TTImpC-45ElabC-45ImplicitBind-mkPatternHole arg-0 arg-4 arg-1 arg-3 arg-12 arg-7 u--n arg-10 (let ((e-1 (vector-ref arg-8 1))) e-1) arg-16) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (let ((act-6 (CoreC-45ContextC-45Log-log arg-1 "elab.as" 5 (lambda () (string-append "Added as pattern name " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (u--d) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-1) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x))))) (cons u--n (cons (TTImpC-45ElabC-45As-n--10699-8368-u--rigAs arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (cons e-10 (cons e-12 e-11))))))) clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((act-7 (let ((act-7 (unbox arg-1))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-8 ((let ((eff-0 (lambda (world-0) (let ((act-8 (unbox arg-4))) (vector 1 act-8))))) (lambda (world-0) (let ((act-8 (eff-0 world-0))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-8 1))) ((let ((eff-1 (lambda (world-1) (let ((act-9 (set-box! arg-4 (let ((e-1 (vector-ref e-15 0))) (let ((e-28 (vector-ref e-15 1))) (let ((e-27 (vector-ref e-15 2))) (let ((e-26 (vector-ref e-15 3))) (let ((e-25 (vector-ref e-15 4))) (let ((e-24 (vector-ref e-15 5))) (let ((e-23 (vector-ref e-15 6))) (let ((e-22 (vector-ref e-15 7))) (let ((e-21 (vector-ref e-15 8))) (let ((e-20 (vector-ref e-15 9))) (let ((e-19 (vector-ref e-15 10))) (let ((e-18 (vector-ref e-15 11))) (let ((e-17 (vector-ref e-15 12))) (let ((e-16 (vector-ref e-15 13))) (vector e-1 e-28 e-27 e-26 (cons (cons u--n (vector 1 arg-0 (TTImpC-45ElabC-45As-n--10699-8368-u--rigAs arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (vector 1 ) e-10 e-12 e-2)) e-25) (cons (cons u--n (vector 1 arg-0 (TTImpC-45ElabC-45As-n--10699-8368-u--rigAs arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (vector 1 ) e-10 e-11 e-2)) e-24) e-23 e-22 e-21 e-20 e-19 e-18 e-17 e-16)))))))))))))))))) (vector 1 act-9))))) eff-1) world-0))))))) eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((act-9 (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-12 e-10 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-12) (box e-3) eta-1))) (case (vector-ref act-9 0) ((0) (let ((e-16 (vector-ref act-9 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-3) (let ((e-18 (car e-16))) (let ((e-17 (cdr e-16))) (let ((act-10 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" 7 (lambda () "checkAs is adding \x2193;") clam-3))) (case (vector-ref act-10 0) ((0) (let ((e-19 (vector-ref act-10 1))) (vector 0 e-19))) (else (let ((act-11 (let ((act-11 ((CoreC-45NormaliseC-45Eval-getTerm e-17) clam-3))) (case (vector-ref act-11 0) ((0) (let ((e-20 (vector-ref act-11 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 arg-12 arg-14 arg-10 e-20 eta-2)))) eff-0) clam-3))))))) (case (vector-ref act-11 0) ((0) (let ((e-20 (vector-ref act-11 1))) (vector 0 e-20))) (else (vector 1 (cons (vector 5 arg-11 arg-13 e-18 e-2) e-3))))))))))))) eff-0) eta-1))))))))))) eff-0) clam-2)))))))))))))) eff-0) clam-1)))))))))) eff-0) eta-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 36 arg-11 arg-14) eta-0))))))))))))) eff-0) clam-0))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "elab.as" 2 (lambda () (string-append "Bad @-pattern " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-15))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-11 "@-patterns only allowed in pattern clauses") clam-0))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--13382-15628-u--getBinds (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-10 arg-11 arg-12 arg-13) (if (null? arg-10) (cons (CoreC-45TT-refsToLocals arg-11 arg-12) (CoreC-45TT-refsToLocals arg-11 arg-13)) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((0) (let ((e-13 (vector-ref e-11 2))) (let ((e-14 (vector-ref e-11 3))) (let ((e-16 (vector-ref e-11 5))) (let ((sc4 (TTImpC-45ElabC-45ImplicitBind-n--13382-15628-u--getBinds arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 (vector 1 e-6 e-10 arg-11) arg-12 arg-13))) (let ((e-5 (car sc4))) (let ((e-4 (cdr sc4))) (let ((u--btyC-39 (CoreC-45TT-refsToLocals arg-11 e-16))) (case (vector-ref arg-6 0) ((0) (let ((e-0 (vector-ref arg-6 1))) (cons (vector 3 arg-7 e-6 (vector 2 arg-7 e-0 (vector 0 ) u--btyC-39) e-5) (vector 11 arg-7 (vector 2 "top" 0)))))(else (cons (vector 3 arg-7 e-6 (vector 3 arg-7 e-13 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (let ((sc5 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-8 (cdr sc5))) (((e-8 'erased) 'erased) (CoreC-45TTC-45Bounds-sizeOf arg-11)))) e-14) u--btyC-39) e-5) (vector 3 arg-7 e-6 (vector 5 arg-7 e-13 u--btyC-39) e-4)))))))))))) (else (let ((e-18 (vector-ref e-11 2))) (let ((e-21 (vector-ref e-11 5))) (let ((e-22 (vector-ref e-11 6))) (let ((sc4 (TTImpC-45ElabC-45ImplicitBind-n--13382-15628-u--getBinds arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 (vector 1 e-6 e-10 arg-11) arg-12 arg-13))) (let ((e-5 (car sc4))) (let ((e-4 (cdr sc4))) (let ((u--btyC-39 (CoreC-45TT-refsToLocals arg-11 e-21))) (let ((u--bpatC-39 (CoreC-45TT-refsToLocals arg-11 e-22))) (cons (vector 3 arg-7 e-6 (vector 4 arg-7 e-18 u--bpatC-39 u--btyC-39) e-5) (vector 3 arg-7 e-6 (vector 4 arg-7 e-18 u--bpatC-39 u--btyC-39) e-4)))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--13382-15629-u--tidyName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 2))) (TTImpC-45ElabC-45ImplicitBind-n--13382-15629-u--tidyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-1))) ((3) (let ((e-2 (vector-ref arg-8 1))) (TTImpC-45ElabC-45ImplicitBind-n--13382-15629-u--tidyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-2))) ((5) (let ((e-5 (vector-ref arg-8 2))) (TTImpC-45ElabC-45ImplicitBind-n--13382-15629-u--tidyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5)))(else arg-8))))
(define TTImpC-45ElabC-45ImplicitBind-bindImplVars (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-2 0) ((3) (cons arg-6 arg-7))(else (let ((u--imps (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (TTImpC-45ElabC-45ImplicitBind-n--13382-15629-u--tidyName arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-2) (cons e-2 e-3))))) arg-5))) (TTImpC-45ElabC-45ImplicitBind-n--13382-15628-u--getBinds arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--imps (vector 0 ) arg-6 arg-7))))))
(define TTImpC-45ElabC-45ImplicitBind-n--12478-14852-u--swapP (lambda (arg-2 arg-7 arg-9) (cond ((equal? arg-9 0) 0)(else (let ((e-0 (- arg-9 1))) (+ (+ e-0 1) 1))))))
(define TTImpC-45ElabC-45ImplicitBind-swapIsVarH (lambda (arg-5) (cond ((equal? arg-5 0) 1)(else (let ((e-0 (- arg-5 1))) (TTImpC-45ElabC-45ImplicitBind-n--12478-14852-u--swapP e-0 arg-5 e-0))))))
(define TTImpC-45ElabC-45ImplicitBind-swapIsVar (lambda (arg-4 arg-5) (if (null? arg-4) (TTImpC-45ElabC-45ImplicitBind-swapIsVarH arg-5) (let ((e-3 (cdr arg-4))) (cond ((equal? arg-5 0) 0)(else (let ((e-4 (- arg-5 1))) (let ((eff-0 (TTImpC-45ElabC-45ImplicitBind-swapIsVar e-3 e-4))) (+ eff-0 1)))))))))
(define TTImpC-45ElabC-45ImplicitBind-swapVars (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((eff-0 (TTImpC-45ElabC-45ImplicitBind-swapIsVar arg-3 e-4))) (vector 0 e-2 e-3 eff-0)))))) ((1) (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 eta-0)) e-14))))))) ((3) (let ((e-16 (vector-ref arg-4 1))) (let ((e-17 (vector-ref arg-4 2))) (let ((e-18 (vector-ref arg-4 3))) (let ((e-19 (vector-ref arg-4 4))) (vector 3 e-16 e-17 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 eta-0)) e-18) (TTImpC-45ElabC-45ImplicitBind-swapVars (cons e-17 arg-3) e-19))))))) ((4) (let ((e-21 (vector-ref arg-4 1))) (let ((e-22 (vector-ref arg-4 2))) (let ((e-23 (vector-ref arg-4 3))) (vector 4 e-21 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-22) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-23)))))) ((5) (let ((e-25 (vector-ref arg-4 1))) (let ((e-26 (vector-ref arg-4 2))) (let ((e-27 (vector-ref arg-4 3))) (let ((e-28 (vector-ref arg-4 4))) (vector 5 e-25 e-26 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-27) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-28))))))) ((6) (let ((e-30 (vector-ref arg-4 1))) (let ((e-31 (vector-ref arg-4 2))) (let ((e-32 (vector-ref arg-4 3))) (vector 6 e-30 e-31 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-32)))))) ((7) (let ((e-34 (vector-ref arg-4 1))) (let ((e-35 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 3))) (let ((e-37 (vector-ref arg-4 4))) (vector 7 e-34 e-35 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-36) (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-37))))))) ((8) (let ((e-39 (vector-ref arg-4 1))) (let ((e-40 (vector-ref arg-4 2))) (let ((e-41 (vector-ref arg-4 3))) (vector 8 e-39 e-40 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-41)))))) ((9) (let ((e-43 (vector-ref arg-4 1))) (let ((e-44 (vector-ref arg-4 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-4 1))) (let ((e-47 (vector-ref arg-4 2))) (case (vector-ref e-47 0) ((1) (vector 10 e-46 (vector 1 ))) ((0) (vector 10 e-46 (vector 0 ))) (else (let ((e-54 (vector-ref e-47 1))) (vector 10 e-46 (vector 2 (TTImpC-45ElabC-45ImplicitBind-swapVars arg-3 e-54))))))))) (else (let ((e-49 (vector-ref arg-4 1))) (let ((e-50 (vector-ref arg-4 2))) (vector 11 e-49 e-50)))))))
(define TTImpC-45ElabC-45ImplicitBind-push (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 1))) (let ((e-9 (vector-ref e-3 2))) (let ((e-10 (vector-ref e-3 3))) (let ((e-11 (vector-ref e-3 4))) (case (vector-ref e-10 0) ((0) (let ((u--tm (vector 3 e-1 (vector 3 e-5 e-6) (vector 2 e-8 e-9 (vector 0 ) e-11) e-4))) (let ((sc4 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-11 (vector 1 (vector 0 ))))) (if (null? sc4) (vector 3 arg-1 arg-2 arg-3 u--tm) (let ((e-7 (unbox sc4))) (vector 3 e-1 (vector 3 e-5 e-6) (vector 2 e-8 e-9 (vector 0 ) e-7) (TTImpC-45ElabC-45ImplicitBind-push (cons (vector 3 e-5 e-6) arg-0) arg-1 arg-2 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (let ((sc5 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-13 (car sc5))) (((e-13 'erased) 'erased) eta-0)))) arg-3) (TTImpC-45ElabC-45ImplicitBind-swapVars '() e-4))))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4))))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4))))))))(else (vector 3 arg-1 arg-2 arg-3 arg-4)))))
(define TTImpC-45ElabC-45ImplicitBind-n--13292-15533-u--liftImpsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-2 0) ((3) (let ((e-10 (vector-ref e-2 1))) (let ((e-11 (vector-ref e-2 2))) (case (vector-ref e-3 0) ((2) (let ((e-15 (vector-ref e-3 3))) (case (vector-ref e-15 0) ((0) (vector 3 e-1 (vector 3 e-10 e-11) e-3 (TTImpC-45ElabC-45ImplicitBind-n--13292-15533-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cons (vector 3 e-10 e-11) arg-5) e-4)))(else (case (vector-ref e-3 0) ((2) (TTImpC-45ElabC-45ImplicitBind-push arg-5 e-1 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-n--13292-15533-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-5) e-4)))(else arg-6))))))(else (case (vector-ref e-3 0) ((2) (TTImpC-45ElabC-45ImplicitBind-push arg-5 e-1 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-n--13292-15533-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-5) e-4)))(else arg-6)))))))(else (case (vector-ref e-3 0) ((2) (TTImpC-45ElabC-45ImplicitBind-push arg-5 e-1 e-2 e-3 (TTImpC-45ElabC-45ImplicitBind-n--13292-15533-u--liftImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-5) e-4)))(else arg-6)))))))))(else arg-6))))
(define TTImpC-45ElabC-45ImplicitBind-liftImps (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (if (null? arg-2) arg-2 (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (case (vector-ref e-4 0) ((11) (let ((e-6 (vector-ref e-4 1))) (let ((e-7 (vector-ref e-4 2))) (cons (TTImpC-45ElabC-45ImplicitBind-n--13292-15533-u--liftImpsC-39 arg-0 e-0 e-3 e-7 e-6 arg-0 e-3) (vector 11 e-6 e-7)))))(else arg-2)))))))(else arg-2))))
(define TTImpC-45ElabC-45ImplicitBind-bindImplicits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-3 0) ((3) (vector 1 (cons arg-7 arg-8)))(else (vector 1 (TTImpC-45ElabC-45ImplicitBind-liftImps arg-1 arg-3 (TTImpC-45ElabC-45ImplicitBind-bindImplVars arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8)))))))
(define CoreC-45UnifyState-getCurrentHoles (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define CoreC-45Unify-n--27278-30400-u--anySame (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 0) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Unify-n--27278-30400-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-1)) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-9 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (if (null? e-9) (case (vector-ref e-4 0) ((1) (let ((e-12 (vector-ref e-4 1))) (let ((e-11 (vector-ref e-4 2))) (cond ((equal? e-12 0) (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-2 '() e-5 '() arg-4 e-11 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-13 1) (lambda (eta-2) (vector 1 1))) (else (lambda (eta-2) (CoreC-45Unify-n--27278-30400-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-2)))))) eff-0) eta-1)))))))(else (lambda (eta-1) (CoreC-45Unify-n--27278-30400-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-1)))))))(else (lambda (eta-1) (CoreC-45Unify-n--27278-30400-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-1)))) (lambda (eta-1) (CoreC-45Unify-n--27278-30400-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-1))))))(else (lambda (eta-1) (CoreC-45Unify-n--27278-30400-u--anySame arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Unify-checkArgsSame (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 eta-1)) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-9 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (if (null? e-9) (case (vector-ref e-4 0) ((1) (let ((e-12 (vector-ref e-4 1))) (let ((e-11 (vector-ref e-4 2))) (cond ((equal? e-12 0) (lambda (eta-1) (let ((act-3 (CoreC-45Unify-n--27278-30400-u--anySame e-2 e-3 arg-1 arg-0 e-11 e-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-13 1) (lambda (eta-2) (vector 1 1))) (else (lambda (eta-2) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 eta-2)))))) eff-0) eta-1)))))))(else (lambda (eta-1) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 eta-1)))))))(else (lambda (eta-1) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 eta-1)))) (lambda (eta-1) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 eta-1))))))(else (lambda (eta-1) (CoreC-45Unify-checkArgsSame arg-0 arg-1 e-3 eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Unify-n--27624-30694-u--getHoleName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 2))) (case (vector-ref e-2 0) ((2) (let ((e-9 (vector-ref e-2 1))) (vector 1 (box e-9))))(else (vector 1 '())))))(else (vector 1 '())))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-n--27624-30693-u--checkConstraint (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (if (null? e-3) (vector 1 (vector 0 )) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-7 0) ((0) (let ((e-8 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (let ((e-11 (vector-ref e-7 4))) (let ((e-12 (vector-ref e-7 5))) (let ((e-13 (vector-ref e-7 6))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-8 e-5 e-11 e-12) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-8 e-5 e-11 e-13) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Normalise-logNF e-8 arg-0 "unify.constraint" 10 (lambda () "Dot") e-11 e-15 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45Normalise-logNF e-8 arg-0 "unify.constraint" 10 (lambda () "  =") e-11 e-14 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45UnifyState-handleUnify arg-0 arg-1 0 (lambda (eta-4) (let ((act-7 (let ((act-7 (unbox arg-0))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 ((CoreC-45Context-getPosition e-2 (let ((e-0 (vector-ref e-19 0))) e-0)) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-21 (car e-20))) (let ((act-9 (CoreC-45Unify-n--27624-30694-u--getHoleName arg-0 arg-1 (vector 2 e-9 e-2 e-21 '()) clam-1))) (case (vector-ref act-9 0) ((0) (let ((e-22 (vector-ref act-9 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 (((((CoreC-45Unify-unify (csegen-2479) e-8 arg-0 arg-1 CoreC-45Unify-inMatch e-9) e-11) e-14) e-15) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-23 (vector-ref act-10 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-11 (let ((act-11 (unbox arg-0))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-24 (vector-ref act-11 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-12 ((PreludeC-45Types-maybe (lambda () (lambda (eta-9) (vector 1 0))) (lambda () (lambda (u--n) (lambda (eta-9) (let ((act-12 (CoreC-45Context-lookupDefExact u--n (let ((e-0 (vector-ref e-24 0))) e-0) eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-25 (vector-ref act-12 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-25) (CoreC-45Context-undefinedName arg-0 e-9 u--n clam-2) (let ((e-1 (unbox e-25))) (vector 1 (case (vector-ref e-1 0) ((7) 0)(else 1)))))))) eff-0) eta-9)))))))) e-22) eta-8))) (case (vector-ref act-12 0) ((0) (let ((e-25 (vector-ref act-12 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-13 (CoreC-45Unify-checkArgsSame arg-1 arg-0 (let ((e-27 (vector-ref e-23 2))) e-27) eta-9))) (case (vector-ref act-13 0) ((0) (let ((e-26 (vector-ref act-13 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-13 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc17 (let ((sc18 (DataC-45List-isNil (let ((e-0 (vector-ref e-23 0))) e-0)))) (cond ((equal? sc18 1) (cond ((equal? e-25 1) 1) (else e-26))) (else 1))))) (cond ((equal? sc17 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Dot pattern match fail") clam-2)) (else (vector 1 (vector 0 )))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) clam-1))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))) (lambda (u--err) (lambda (clam-3) (case (vector-ref u--err 0) ((61) (let ((act-7 (let ((act-7 (unbox arg-0))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (CoreC-45Context-lookupTyExact e-2 (let ((e-50 (vector-ref e-19 0))) e-50) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-20) (CoreC-45Context-undefinedName arg-0 e-9 e-2 clam-4) (let ((e-1 (unbox e-20))) (let ((act-9 (CoreC-45Normalise-logTermNF '() arg-0 "unify.constraint" 5 (lambda () "Dot type") '() e-1 clam-4))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 (let ((act-10 (set-box! arg-1 (let ((e-32 (vector-ref e-18 0))) (let ((e-31 (vector-ref e-18 1))) (let ((e-30 (vector-ref e-18 2))) (let ((e-29 (vector-ref e-18 3))) (let ((e-4 (vector-ref e-18 4))) (let ((e-28 (vector-ref e-18 5))) (let ((e-27 (vector-ref e-18 6))) (let ((e-25 (vector-ref e-18 8))) (let ((e-24 (vector-ref e-18 9))) (let ((e-23 (vector-ref e-18 10))) (let ((e-22 (vector-ref e-18 11))) (vector e-32 e-31 e-30 e-29 e-4 e-28 e-27 '() e-25 e-24 e-23 e-22))))))))))))))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 (CoreC-45Context-clearDefs e-19 clam-4))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-23 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-12 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-8 e-23 e-11 e-14 eta-5))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-24 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-13 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 e-8 e-23 e-11 e-15 eta-6))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 45 e-8 e-9 e-11 e-6 e-24 e-25) eta-7)))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) clam-4)))))))))))))))) eff-0) eta-4)))))))) eff-0) clam-3))))))(else (let ((act-7 (let ((act-7 (set-box! arg-1 (let ((e-0 (vector-ref e-18 0))) (let ((e-1 (vector-ref e-18 1))) (let ((e-27 (vector-ref e-18 2))) (let ((e-26 (vector-ref e-18 3))) (let ((e-4 (vector-ref e-18 4))) (let ((e-25 (vector-ref e-18 5))) (let ((e-24 (vector-ref e-18 6))) (let ((e-22 (vector-ref e-18 8))) (let ((e-21 (vector-ref e-18 9))) (let ((e-20 (vector-ref e-18 10))) (let ((e-19 (vector-ref e-18 11))) (vector e-0 e-1 e-27 e-26 e-4 e-25 e-24 '() e-22 e-21 e-20 e-19))))))))))))))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-3)))))))) eta-3)))) eff-0) eta-2)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))(else (vector 1 (vector 0 )))))))))))))
(define CoreC-45Unify-checkDots (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-getCurrentHoles arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (CoreC-45Unify-n--27624-30693-u--checkConstraint arg-1 arg-0 eta-2)) (PreludeC-45TypesC-45List-reverse (let ((e-7 (vector-ref e-5 7))) e-7))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45UnifyState-getCurrentHoles arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-5 (unbox arg-0))) (vector 1 act-5))))) (lambda (world-0) (let ((act-5 (eff-0 world-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-1 (lambda (world-1) (let ((act-6 (set-box! arg-0 (let ((e-0 (vector-ref e-9 0))) (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-16 (vector-ref e-9 5))) (let ((e-15 (vector-ref e-9 6))) (let ((e-13 (vector-ref e-9 8))) (let ((e-12 (vector-ref e-9 9))) (let ((e-10 (vector-ref e-9 10))) (let ((e-11 (vector-ref e-9 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 '() e-13 e-12 e-10 e-11))))))))))))))) (vector 1 act-6))))) eff-1) world-0))))))))) eff-0) eta-1)))))))))) eff-0) eta-0))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45ImplicitBind-checkPolyConstraint (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-9 (vector-ref e-7 2))) (case (vector-ref e-9 0) ((2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-5) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45ElabC-45Check-concrete e-6 e-2 e-14) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-15 1) (let ((act-5 (CoreC-45Context-clearDefs e-6 clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 44 e-0 e-1 e-2 e-3) eta-2)))) eff-0) clam-2))))) (else (vector 1 (vector 0 ))))))) eff-0) eta-1)))))))) eff-0) clam-0))))))(else (vector 1 (vector 0 ))))))(else (vector 1 (vector 0 ))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))
(define TTImpC-45ElabC-45Check-clearBindIfUnsolved (lambda (ext-0) (let ((e-1 (vector-ref ext-0 0))) (let ((e-2 (vector-ref ext-0 1))) (let ((e-3 (vector-ref ext-0 2))) (let ((e-4 (vector-ref ext-0 3))) (let ((e-5 (vector-ref ext-0 4))) (let ((e-6 (vector-ref ext-0 5))) (let ((e-8 (vector-ref ext-0 7))) (let ((e-9 (vector-ref ext-0 8))) (let ((e-10 (vector-ref ext-0 9))) (let ((e-11 (vector-ref ext-0 10))) (let ((e-12 (vector-ref ext-0 11))) (let ((e-13 (vector-ref ext-0 12))) (let ((e-14 (vector-ref ext-0 13))) (vector e-1 e-2 e-3 e-4 e-5 e-6 '() e-8 e-9 e-10 e-11 e-12 e-13 e-14))))))))))))))))
(define TTImpC-45ElabC-45Check-clearToBind (lambda (arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((sc1 (TTImpC-45ElabC-45Check-clearBindIfUnsolved e-5))) (let ((e-1 (vector-ref sc1 0))) (let ((e-2 (vector-ref sc1 1))) (let ((e-3 (vector-ref sc1 2))) (let ((e-4 (vector-ref sc1 3))) (let ((e-15 (vector-ref sc1 4))) (let ((e-6 (vector-ref sc1 5))) (let ((e-7 (vector-ref sc1 6))) (let ((e-8 (vector-ref sc1 7))) (let ((e-9 (vector-ref sc1 8))) (let ((e-10 (vector-ref sc1 9))) (let ((e-11 (vector-ref sc1 10))) (let ((e-12 (vector-ref sc1 11))) (let ((e-13 (vector-ref sc1 12))) (let ((e-14 (vector-ref sc1 13))) (vector e-1 e-2 e-3 e-4 e-15 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--x) (PreludeC-45Types-elem csegen-14 csegen-832 (Builtin-fst u--x) arg-2)) e-6) e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45TTC-45Binder-forgetDef (lambda (arg-2) (case (vector-ref arg-2 0) ((1) (vector 1 )) ((0) (vector 0 )) ((2) (vector 2 )) (else (vector 0 )))))
(define TTImpC-45ElabC-45ImplicitBind-case--bindUnsolvedC-44makeBoundVar-14190 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-68 arg-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Can't bind implicit " (string-append (CoreC-45Name-u--show_Show_Name arg-15) (string-append " of type " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-8 e-5))))) eta-0)))) eff-0) ext-0))))) (let ((e-2 (unbox arg-16))) (let ((act-1 (CoreC-45UnifyState-genVarName arg-6 arg-3 (CoreC-45Name-nameRoot arg-15) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-metaVar arg-7 arg-6 arg-3 arg-2 arg-14 arg-12 e-5 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--pC-39 (CoreC-45TTC-45Binder-forgetDef arg-13))) (lambda (eta-1) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-5))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-5 (let ((e-1 (vector-ref e-7 0))) (let ((e-18 (vector-ref e-7 1))) (let ((e-3 (vector-ref e-7 2))) (let ((e-4 (vector-ref e-7 3))) (let ((e-17 (vector-ref e-7 4))) (let ((e-16 (vector-ref e-7 5))) (let ((e-15 (vector-ref e-7 6))) (let ((e-8 (vector-ref e-7 7))) (let ((e-9 (vector-ref e-7 8))) (let ((e-10 (vector-ref e-7 9))) (let ((e-11 (vector-ref e-7 10))) (let ((e-12 (vector-ref e-7 11))) (let ((e-13 (vector-ref e-7 12))) (let ((e-14 (vector-ref e-7 13))) (vector e-1 e-18 e-3 e-4 e-17 (cons (cons e-5 (vector 0 arg-4 arg-14 u--pC-39 (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-6 arg-10) (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-2 arg-10))) e-16) e-15 e-8 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 (CoreC-45TTC-45Term-u--thin_IsScoped_Term e-6 arg-11))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--11714-14135-u--makeBoundVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-case--bindUnsolvedC-44makeBoundVar-14190 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term arg-15 arg-13) eta-0))))
(define TTImpC-45ElabC-45ImplicitBind-n--11714-14136-u--mkImplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (lambda (clam-0) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((e-26 (car e-23))) (let ((e-27 (cdr e-23))) (let ((act-1 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-8 0))) e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 (vector 0 )) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((7) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-6 e-10 arg-8 e-14 e-26 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45ImplicitBind-n--11714-14135-u--makeBoundVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-10 e-2 e-6 e-18 arg-9 e-27 arg-10 e-9))) eff-0) clam-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45Log-logTerm e-10 arg-6 "elab.implicits" 5 (lambda () "Added unbound implicit") e-9 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 ((((CoreC-45Unify-unify (csegen-2476) e-10 arg-6 arg-3 (case (vector-ref arg-1 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm)) arg-2) e-14) e-22) e-9) eta-0))))))) eff-0) clam-1))))))(else (vector 1 (vector 0 ))))))))) eff-0) clam-0))))))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-bindUnsolved (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (vector 1 (vector 0 )))(else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--bifs (let ((e-7 (vector-ref e-5 6))) e-7))) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "elab.implicits" 5 (lambda () (string-append "Bindable unsolved implicits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) u--bifs)))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (eta-2) (TTImpC-45ElabC-45ImplicitBind-n--11714-14136-u--mkImplicit arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 (let ((e-1 (vector-ref e-5 0))) e-1) e-6 (let ((e-3 (vector-ref e-5 2))) e-3) (let ((e-4 (vector-ref e-5 3))) e-4) eta-2)) (let ((e-15 (vector-ref e-5 6))) e-15)) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Check-n--11292-1965-u--insertAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) arg-7 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45NameMap-insert e-6 e-7 (TTImpC-45ElabC-45Check-n--11292-1965-u--insertAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7)))))))))
(define TTImpC-45ElabC-45Check-bindingMetas (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 5))) (CoreC-45TT-getMetas e-4))) (else (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (let ((e-9 (vector-ref arg-1 5))) (let ((e-10 (vector-ref arg-1 6))) (TTImpC-45ElabC-45Check-n--11292-1965-u--insertAll e-5 e-10 e-9 e-8 e-7 e-6 (LibrariesC-45DataC-45NameMap-toList (CoreC-45TT-getMetas e-9)) (CoreC-45TT-getMetas e-10))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--14107-16261-u--insert (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (cons arg-9 '()) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-5 (car arg-12))) (let ((e-6 (cdr arg-12))) (let ((e-9 (car e-5))) (let ((e-10 (cdr e-5))) (let ((u--used (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--n) (PreludeC-45Types-elem csegen-14 csegen-832 u--n arg-10)) (LibrariesC-45DataC-45NameMap-keys (TTImpC-45ElabC-45Check-bindingMetas e-10))))) (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 u--used))) (cond ((equal? sc4 1) (cons (cons e-2 e-3) (cons (cons e-9 e-10) e-6))) (else (cons (cons e-9 e-10) (TTImpC-45ElabC-45ImplicitBind-n--14107-16261-u--insert arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (cons e-2 e-3) arg-10 (cons e-9 arg-11) e-6)))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-n--14107-16260-u--depSort (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) '() (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (TTImpC-45ElabC-45ImplicitBind-n--14107-16261-u--insert arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 arg-9 '() (TTImpC-45ElabC-45ImplicitBind-n--14107-16260-u--depSort arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3)))))))
(define TTImpC-45ElabC-45Check-bindingTerm (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-3 (vector-ref arg-1 4))) e-3)) (else (let ((e-8 (vector-ref arg-1 4))) e-8)))))
(define TTImpC-45ElabC-45Check-bindingType (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 5))) e-4)) (else (let ((e-9 (vector-ref arg-1 5))) e-9)))))
(define CoreC-45Core-allM (lambda (arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((eff-0 (arg-1 e-2))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (cond ((equal? e-5 1) (CoreC-45Core-allM arg-1 e-3)) (else (lambda (eta-0) (vector 1 0)))))) eff-1) world-0))))))))))))
(define CoreC-45Coverage-n--9042-5065-u--clash (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((1) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-2 0) ((2) (let ((e-16 (vector-ref e-2 1))) (case (vector-ref arg-5 0) ((1) (let ((e-22 (vector-ref arg-5 2))) (case (vector-ref e-22 0) ((2) (let ((e-24 (vector-ref e-22 1))) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-16 e-24)))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2)))(else 0))))))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2)))(else 0)))))) ((3) (let ((e-18 (vector-ref e-2 1))) (case (vector-ref arg-5 0) ((1) (let ((e-28 (vector-ref arg-5 2))) (case (vector-ref e-28 0) ((3) (let ((e-30 (vector-ref e-28 1))) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-18 e-30)))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2)))(else 0))))))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2)))(else 0))))))(else (case (vector-ref arg-5 0) ((9) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2))) ((11) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-2)))(else 0)))))) ((9) (let ((e-6 (vector-ref arg-4 2))) (case (vector-ref arg-5 0) ((9) (let ((e-34 (vector-ref arg-5 2))) (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-6 e-34))) ((1) (let ((e-37 (vector-ref arg-5 2))) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-37)))) ((11) 1)(else 0)))) ((11) (case (vector-ref arg-5 0) ((1) (let ((e-44 (vector-ref arg-5 2))) (DataC-45Maybe-isJust (CoreC-45TTC-45Term-isCon e-44)))) ((9) 1)(else 0)))(else 0))))
(define CoreC-45Coverage-n--9042-5068-u--findN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-4 (vector-ref arg-5 3))) (or (and (= arg-4 e-4) 1) 0)))(else (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-5))) (if (null? sc0) 0 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Coverage-n--9042-5068-u--findN arg-0 arg-1 arg-2 arg-3 arg-4 eta-0)) e-3))(else 0))))(else 0))))))))))
(define CoreC-45Coverage-n--9042-5067-u--conflictTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((0) (let ((e-10 (vector-ref arg-4 3))) (let ((sc1 (CoreC-45TTC-45Term-getFnArgs arg-5))) (if (null? sc1) 0 (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Coverage-n--9042-5068-u--findN arg-0 arg-1 arg-2 arg-3 e-10 eta-0)) e-3))(else 0))))(else 0))))))))(else (case (vector-ref arg-5 0) ((0) (let ((e-4 (vector-ref arg-5 3))) (let ((sc1 (CoreC-45TTC-45Term-getFnArgs arg-4))) (if (null? sc1) 0 (let ((e-6 (car sc1))) (let ((e-5 (cdr sc1))) (case (vector-ref e-6 0) ((1) (let ((e-8 (vector-ref e-6 2))) (case (vector-ref e-8 0) ((2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Coverage-n--9042-5068-u--findN arg-0 arg-1 arg-2 arg-3 e-4 eta-0)) e-5))(else 0))))(else 0))))))))(else (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-4))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (CoreC-45TTC-45Term-getFnArgs arg-5))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (CoreC-45Coverage-n--9042-5065-u--clash arg-0 arg-1 arg-2 arg-3 e-2 e-5))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (CoreC-45Coverage-n--9042-5067-u--conflictTm arg-0 arg-1 arg-2 arg-3 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List e-3 e-4)))))))))))))))))
(define CoreC-45Coverage-n--9042-5066-u--conflictArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 0 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-6))) (cond ((equal? sc3 1) (CoreC-45Coverage-n--9042-5067-u--conflictTm arg-0 arg-1 arg-2 arg-3 arg-5 e-7)) (else 0))))) (cond ((equal? sc2 1) 1) (else (CoreC-45Coverage-n--9042-5066-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))))))))))
(define CoreC-45Coverage-conflictMatch (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Coverage-n--9042-5066-u--conflictArgs arg-0 e-6 e-7 e-3 e-6 e-7 e-3))) (cond ((equal? sc2 1) 1) (else (CoreC-45Coverage-conflictMatch arg-0 e-3)))))))))))
(define CoreC-45Coverage-n--9603-5586-u--conflictArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-7) (if (null? arg-8) (vector 1 (box '())) (vector 1 (box '()))) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (if (null? arg-8) (vector 1 (box '())) (let ((e-6 (car arg-8))) (let ((e-7 (cdr arg-8))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-5 arg-0 arg-4 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-5 '() arg-4 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Coverage-n--9603-5587-u--conflictNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 e-8) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-9) (vector 1 '()) (let ((e-1 (unbox e-9))) (let ((act-4 ((CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 e-7) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-10) (vector 1 '()) (let ((e-4 (unbox e-10))) (vector 1 (box (PreludeC-45TypesC-45List-tailRecAppend e-1 e-4)))))))) eff-0) clam-2)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Coverage-n--9603-5587-u--conflictNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-34 (vector-ref arg-8 4))) (let ((u--xC-39 (vector 2 (CoreC-45Name-u--show_Show_Name e-32) arg-6))) (lambda (eta-0) (let ((act-1 (((e-34 arg-4) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-31 (vector 0 ) u--xC-39))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Coverage-n--9603-5587-u--conflictNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) arg-7 e-5))) eff-0) eta-0))))))))))) ((1) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (case (vector-ref e-37 0) ((1) (let ((e-40 (vector-ref e-37 1))) (let ((e-41 (vector-ref e-37 2))) (case (vector-ref e-40 0) ((0) (if (null? e-38) (lambda (eta-0) (let ((act-1 (CoreC-45Context-clearDefs arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 arg-0 e-5 arg-3 arg-7 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box (cons (cons e-41 e-6) '())))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc6 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc6 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc6 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-0) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc6 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '())))))))(else (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc4 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc4 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc4 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-1) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc4 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '()))))))))))(else (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc3 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc3 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-2) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc3 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '()))))))))))(else (case (vector-ref arg-7 0) ((2) (let ((e-3 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((2) (let ((e-18 (vector-ref arg-8 3))) (let ((e-20 (vector-ref arg-8 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-3 e-18))) (cond ((equal? sc2 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-20))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((3) (let ((e-8 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 5))) (case (vector-ref arg-8 0) ((3) (let ((e-23 (vector-ref arg-8 2))) (let ((e-26 (vector-ref arg-8 5))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-8 e-23))) (cond ((equal? sc2 1) (CoreC-45Coverage-n--9603-5586-u--conflictArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-11) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-26))) (else (lambda (eta-0) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 (box '())))))))) ((8) (let ((e-14 (vector-ref arg-7 2))) (lambda (clam-3) (case (vector-ref arg-8 0) ((8) (let ((e-29 (vector-ref arg-8 2))) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-14 e-29))) (cond ((equal? sc2 1) (vector 1 (box '()))) (else (vector 1 '()))))))(else (vector 1 (box '())))))))(else (lambda (eta-0) (vector 1 (box '())))))))))
(define CoreC-45Coverage-case--caseC-32blockC-32inC-32conflict-6217 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-8) (vector 1 0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((5) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-5 '() arg-4 '() e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Coverage-n--9603-5587-u--conflictNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 arg-2 e-7))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (vector 1 1) (let ((e-8 (unbox e-7))) (vector 1 (CoreC-45Coverage-conflictMatch arg-0 e-8))))))) eff-0) clam-0))))))(else (vector 1 0)))))))))
(define CoreC-45Coverage-conflict (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox e-5))) (let ((_-0 (box e-1))) (CoreC-45Coverage-case--caseC-32blockC-32inC-32conflict-6217 arg-0 arg-5 arg-4 arg-3 arg-2 arg-1 e-1 _-0 (cons (let ((e-18 (vector-ref e-1 18))) e-18) (let ((e-2 (vector-ref e-1 2))) e-2)))))))) eff-0) ext-0)))))))
(define CoreC-45Coverage-isEmpty (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-5 (vector-ref arg-4 5))) (let ((act-1 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-0) (vector 1 0)) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((6) (let ((e-11 (vector-ref e-7 5))) (let ((e-9 (vector-ref e-7 7))) (let ((sc4 (let ((e-15 (cdr e-11))) e-15))) (cond ((equal? sc4 1) (lambda (eta-0) (vector 1 0))) (else (CoreC-45Core-allM (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-conflict arg-0 arg-1 arg-2 arg-3 (vector 3 e-1 e-2 e-3 e-4 e-5) eta-0 eta-1))) e-9)))))))(else (lambda (eta-0) (vector 1 0)))))))) eff-0) ext-0)))))))))))(else (vector 1 0)))))
(define TTImpC-45ElabC-45ImplicitBind-normaliseType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 CoreC-45Value-withHoles arg-2 arg-3 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-1 (vector 0 0 (box 5)) arg-2 arg-3 e-5 eta-1)))) eff-0) eta-0)))))) (lambda (u--err) (lambda (eta-0) (CoreC-45Normalise-normalise arg-0 arg-1 arg-2 arg-3 arg-4 eta-0))) ext-0)))
(define TTImpC-45ElabC-45ImplicitBind-n--14107-16262-u--normBindingTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (let ((e-3 (vector-ref arg-10 4))) (let ((e-4 (vector-ref arg-10 5))) (let ((act-1 (case (vector-ref arg-3 0) ((2) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 arg-9 arg-2 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Coverage-isEmpty arg-1 arg-8 arg-9 arg-2 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-6 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Empty pattern in coverage check") clam-0)) (else (vector 1 (vector 0 ))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))(else (vector 1 (vector 0 )))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 (TTImpC-45ElabC-45ImplicitBind-normaliseType arg-8 arg-1 arg-9 arg-2 e-4 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 arg-1 e-1 e-2 e-3 e-6))))) eff-0) ext-0))))))))))))) (else (let ((e-6 (vector-ref arg-10 2))) (let ((e-7 (vector-ref arg-10 3))) (let ((e-8 (vector-ref arg-10 4))) (let ((e-9 (vector-ref arg-10 5))) (let ((e-10 (vector-ref arg-10 6))) (let ((act-1 (case (vector-ref arg-3 0) ((2) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 arg-9 arg-2 e-9) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Coverage-isEmpty arg-1 arg-8 arg-9 arg-2 e-11 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-12 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Empty pattern in coverage check") clam-1)) (else (vector 1 (vector 0 ))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))(else (vector 1 (vector 0 )))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (TTImpC-45ElabC-45ImplicitBind-normaliseType arg-8 arg-1 arg-9 arg-2 e-9 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Normalise-normaliseHoles arg-8 arg-1 arg-9 arg-2 e-10 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 arg-1 e-6 e-7 e-8 e-12 e-13))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))))
(define CoreC-45UnifyState-isCurrentHole (lambda (arg-0 arg-1 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45Maybe-isJust (LibrariesC-45DataC-45IntMap-lookup arg-1 e-5))))))) (lambda (eta-0) (CoreC-45UnifyState-getCurrentHoles arg-0 eta-0)) ext-0)))
(define TTImpC-45ElabC-45ImplicitBind-case--getToBindC-44normImps-16655 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-12 arg-11) (let ((e-2 (car arg-15))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-isCurrentHole arg-6 e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc3 (cond ((equal? e-9 1) (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 e-6 arg-12))) (cond ((equal? sc5 1) 0) (else 1)))) (else 0)))) (cond ((equal? sc3 1) (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 (cons e-6 arg-12) arg-11) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45ElabC-45ImplicitBind-n--14107-16262-u--normBindingTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-10 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (cons e-6 e-11) e-10))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (else (TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-12 arg-11)))))) eff-0) eta-0)))))))))(else (TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-13 arg-12 arg-11)))))))
(define TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-6 0) ((3) (let ((e-8 (vector-ref e-6 1))) (let ((e-9 (vector-ref e-6 2))) (let ((act-1 (CoreC-45Normalise-logTermNF arg-1 arg-8 "elab.implicits" 10 (lambda () (string-append "Implicit pattern var " (CoreC-45Name-u--show_Show_Name (vector 3 e-8 e-9)))) arg-2 (TTImpC-45ElabC-45Check-bindingType e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-832 (vector 3 e-8 e-9) arg-10))) (cond ((equal? sc4 1) ((TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) clam-0)) (else (let ((act-2 ((TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (vector 3 e-8 e-9) arg-10) e-3) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45ElabC-45ImplicitBind-n--14107-16262-u--normBindingTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-7 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons (vector 3 e-8 e-9) e-11) e-10))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))(else (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-8 arg-1 arg-9 arg-2 (TTImpC-45ElabC-45Check-bindingTerm e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-1 arg-8 "elab.implicits" 10 (lambda () (string-append "Normalising implicit " (CoreC-45Name-u--show_Show_Name e-6))) e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((TTImpC-45ElabC-45ImplicitBind-case--getToBindC-44normImps-16655 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 e-7 e-3 arg-10 arg-9 e-5 (CoreC-45TTC-45Term-getFnArgs e-5)) eta-0))))))) eff-0) clam-0)))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-getToBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-6 0) ((3) (vector 1 '()))(else (let ((act-1 (CoreC-45Unify-solveConstraints arg-1 arg-3 (case (vector-ref arg-5 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm)) 0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (TTImpC-45ElabC-45ImplicitBind-bindUnsolved arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Unify-solveConstraints arg-1 arg-3 (case (vector-ref arg-5 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm)) 0 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-5 (let ((act-5 (unbox arg-2))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--tob (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--x) (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 (Builtin-fst u--x) arg-8))) (cond ((equal? sc5 1) 0) (else 1)))) (let ((e-18 (vector-ref e-9 5))) e-18))))) (lambda (eta-1) (let ((act-6 ((TTImpC-45ElabC-45ImplicitBind-n--14107-16263-u--normImps arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-8 '() u--tob) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--hnames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-10))) (let ((u--resC-39 (TTImpC-45ElabC-45ImplicitBind-n--14107-16260-u--depSort arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--hnames e-10))) (lambda (eta-2) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "elab.implicits" 10 (lambda () (string-append "Bound names: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2575 e-10))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45ContextC-45Log-log arg-1 "elab.implicits" 10 (lambda () (string-append "Sorted: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2575 u--resC-39))) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (vector 1 u--resC-39)))))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))))))))
(define CoreC-45UnifyState-removeHoleName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (CoreC-45Context-getNameID arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)))) (if (null? sc1) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox sc1))) (CoreC-45UnifyState-removeHole arg-1 e-1)))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45ImplicitBind-implicitBind (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((7) (let ((act-3 (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-1) (box (vector 10 ))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45UnifyState-removeHoleName arg-0 arg-1 arg-2 clam-0)))))(else (vector 1 (vector 0 ))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define PreludeC-45Basics-curry (lambda (arg-3 arg-4 arg-5) (arg-3 (cons arg-4 arg-5))))
(define TTImpC-45ElabC-45Delayed-mismatchNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((3) (let ((e-26 (vector-ref arg-4 2))) (let ((e-29 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-26))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-7 (car arg-9215))) (let ((e-6 (cdr arg-9215))) (cons (arg-9201 e-7) (arg-9208 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-7 (car arg-9236))) (let ((e-6 (cdr arg-9236))) (cons (arg-9229 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-7 (car arg-9250))) (let ((e-6 (cdr arg-9250))) (cons e-7 (arg-9243 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-29))))))))(else (lambda (eta-0) (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((2) (let ((e-33 (vector-ref arg-4 3))) (let ((e-35 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-33))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-35))))))))(else (lambda (eta-0) (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref arg-4 0) ((8) (let ((e-38 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-14 e-38))))(else (vector 1 0)))))) ((5) (let ((e-18 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-42 (vector-ref arg-4 3))) (TTImpC-45ElabC-45Delayed-mismatchNF arg-0 arg-1 arg-2 e-18 e-42)))(else (lambda (eta-0) (vector 1 0)))))) ((6) (let ((e-23 (vector-ref arg-3 4))) (lambda (clam-1) (case (vector-ref arg-4 0) ((6) (let ((e-47 (vector-ref arg-4 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-47) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45Delayed-mismatchNF arg-0 arg-1 arg-2 e-5 e-6))) eff-0) eta-0)))))))) eff-0) clam-1)))))))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ElabC-45Delayed-mismatch (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45Delayed-mismatchNF arg-0 arg-1 arg-2 e-5 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Delayed-contra (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((3) (let ((e-17 (vector-ref arg-4 2))) (let ((e-20 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-17))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-7 (car arg-9215))) (let ((e-6 (cdr arg-9215))) (cons (arg-9201 e-7) (arg-9208 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-7 (car arg-9236))) (let ((e-6 (cdr arg-9236))) (cons (arg-9229 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-7 (car arg-9250))) (let ((e-6 (cdr arg-9250))) (cons e-7 (arg-9243 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-20))))))))(else (lambda (eta-0) (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((2) (let ((e-24 (vector-ref arg-4 3))) (let ((e-26 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-24))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Delayed-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-26)))))))) ((8) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref arg-4 0) ((8) (let ((e-32 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-14 e-32)))) ((2) (vector 1 1))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ElabC-45Delayed-recoverable (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (let ((e-5 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--defs (let ((e-38 (vector-ref e-6 1))) (let ((e-37 (vector-ref e-6 2))) (let ((e-36 (vector-ref e-6 3))) (let ((e-35 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-2 e-38 e-37 e-36 e-35 e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-5) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45ElabC-45Delayed-contra arg-0 e-0 u--defs e-7 e-8) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cond ((equal? e-9 1) 0) (else 1)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))))) ((2) (let ((e-6 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (let ((e-10 (vector-ref arg-1 5))) (let ((e-11 (vector-ref arg-1 6))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--defs (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-39 (vector-ref e-5 5))) (let ((e-38 (vector-ref e-5 6))) (let ((e-37 (vector-ref e-5 7))) (let ((e-36 (vector-ref e-5 8))) (let ((e-35 (vector-ref e-5 9))) (let ((e-34 (vector-ref e-5 10))) (let ((e-33 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-8 e-1 e-2 e-3 e-4 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-11) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45ElabC-45Delayed-contra arg-0 e-6 u--defs e-12 e-13) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cond ((equal? e-14 1) 0) (else 1)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))))) ((7) (lambda (eta-0) (vector 1 0))) ((14) (lambda (eta-0) (vector 1 0))) ((68) (let ((e-20 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-20))) ((69) (let ((e-23 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-23))) ((70) (let ((e-26 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-26))) ((71) (let ((e-29 (vector-ref arg-1 3))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-29))) ((5) (let ((e-36 (vector-ref arg-1 7))) (TTImpC-45ElabC-45Delayed-recoverable arg-0 e-36)))(else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Delayed-u--show_Show_RetryError (lambda (arg-0) (cond ((equal? arg-0 0) "RecoverableErrors") (else "AllErrors"))))
(define TTImpC-45ElabC-45Delayed-n--12583-15969-u--better (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-15 0) ((49) arg-14)(else (case (vector-ref arg-14 0) ((49) arg-15)(else arg-14))))))
(define TTImpC-45ElabC-45Delayed-retryDelayedC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (cons arg-6 (PreludeC-45TypesC-45List-reverse arg-7)))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-10) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--d (cons e-6 (cons e-10 (cons e-14 e-15))))) (if (null? e-8) (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) (let ((e-1 (unbox e-8))) (case (vector-ref e-1 0) ((12) (lambda (eta-1) (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-4))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "elab.retry" 5 (lambda (eta-4) (let ((act-4 (CoreC-45Context-getFullName arg-1 (vector 8 e-10) eta-4))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (string-append (PreludeC-45Show-u--show_Show_Nat (let ((e-18 (vector-ref e-9 10))) e-18)) (string-append ": Retrying delayed hole " (CoreC-45Name-u--show_Show_Name e-12))))))) eff-0) eta-4)))))) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 ((let ((eff-0 (lambda (world-0) (let ((act-5 (unbox arg-3))) (vector 1 act-5))))) (lambda (world-0) (let ((act-5 (eff-0 world-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-1 (lambda (world-1) (let ((act-6 (set-box! arg-3 (let ((e-0 (vector-ref e-13 0))) (let ((e-25 (vector-ref e-13 1))) (let ((e-24 (vector-ref e-13 2))) (let ((e-23 (vector-ref e-13 3))) (let ((e-4 (vector-ref e-13 4))) (let ((e-22 (vector-ref e-13 5))) (let ((e-21 (vector-ref e-13 6))) (let ((e-20 (vector-ref e-13 7))) (let ((e-19 (vector-ref e-13 8))) (let ((e-18 (vector-ref e-13 9))) (let ((e-16 (vector-ref e-13 11))) (vector e-0 e-25 e-24 e-23 e-4 e-22 e-21 e-20 e-19 e-18 '() e-16))))))))))))))) (vector 1 act-6))))) eff-1) world-0))))))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 ((let ((eff-0 (lambda (world-0) (let ((act-6 (unbox arg-1))) (vector 1 act-6))))) (lambda (world-0) (let ((act-6 (eff-0 world-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-6 1))) ((let ((eff-1 (lambda (world-1) (let ((act-7 (set-box! arg-1 (let ((e-0 (vector-ref e-16 0))) (let ((e-47 (vector-ref e-16 1))) (let ((e-46 (vector-ref e-16 2))) (let ((e-45 (vector-ref e-16 3))) (let ((e-4 (vector-ref e-16 4))) (let ((e-44 (vector-ref e-16 5))) (let ((e-43 (vector-ref e-16 6))) (let ((e-42 (vector-ref e-16 7))) (let ((e-41 (vector-ref e-16 8))) (let ((e-40 (vector-ref e-16 9))) (let ((e-38 (vector-ref e-16 11))) (let ((e-37 (vector-ref e-16 12))) (let ((e-36 (vector-ref e-16 13))) (let ((e-35 (vector-ref e-16 14))) (let ((e-34 (vector-ref e-16 15))) (let ((e-33 (vector-ref e-16 16))) (let ((e-17 (vector-ref e-16 17))) (let ((e-18 (vector-ref e-16 18))) (let ((e-19 (vector-ref e-16 19))) (let ((e-20 (vector-ref e-16 20))) (let ((e-21 (vector-ref e-16 21))) (let ((e-22 (vector-ref e-16 22))) (let ((e-23 (vector-ref e-16 23))) (let ((e-24 (vector-ref e-16 24))) (let ((e-25 (vector-ref e-16 25))) (let ((e-26 (vector-ref e-16 26))) (let ((e-27 (vector-ref e-16 27))) (let ((e-28 (vector-ref e-16 28))) (let ((e-29 (vector-ref e-16 29))) (let ((e-30 (vector-ref e-16 30))) (let ((e-31 (vector-ref e-16 31))) (let ((e-32 (vector-ref e-16 32))) (vector e-0 e-47 e-46 e-45 e-4 e-44 e-43 e-42 e-41 e-40 e-14 e-38 e-37 e-36 e-35 e-34 e-33 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-7))))) eff-1) world-0))))))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (e-15 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (let ((act-8 (unbox arg-3))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--dsC-39 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse (let ((e-20 (vector-ref e-18 10))) e-20)) e-3))) (lambda (eta-5) (let ((act-9 (CoreC-45Context-updateDef arg-1 (vector 8 e-10) (lambda (eta-6) (box (vector 1 (vector '() 1 0) '() (vector 1 0 e-17) (vector 1 0 e-17) '()))) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 (CoreC-45ContextC-45Log-logTerm '() arg-1 "elab.update" 5 (lambda () (string-append "Resolved delayed hole " (PreludeC-45Show-u--show_Show_Int e-10))) e-17 eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 (CoreC-45Normalise-logTermNF '() arg-1 "elab.update" 5 (lambda () (string-append "Resolved delayed hole NF " (PreludeC-45Show-u--show_Show_Int e-10))) '() e-17 eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 ((CoreC-45UnifyState-removeHole arg-3 e-10) eta-5))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 arg-7 u--dsC-39) eta-5))))))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))))))))))) eff-0) eta-2)))))) (lambda (u--err) (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "elab" 5 (lambda (eta-3) (let ((act-3 (CoreC-45Context-getFullName arg-1 (vector 8 e-10) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append (TTImpC-45ElabC-45Delayed-u--show_Show_RetryError arg-5) (string-append ":Error in " (string-append (CoreC-45Name-u--show_Show_Name e-9) (string-append "\xa;" (CoreC-45Core-u--show_Show_Error u--err))))))))) eff-0) eta-3)))))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (cond ((equal? arg-5 0) (let ((act-4 ((TTImpC-45ElabC-45Delayed-recoverable arg-1 u--err) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (cond ((equal? e-12 1) (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-6 (cons u--d arg-7) e-3)) (else (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-3)))))) eff-0) eta-2)))))) (else (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-3) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO csegen-26 (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-3) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-3))))) (lambda (u--errC-39) (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error (TTImpC-45ElabC-45Delayed-n--12583-15969-u--better arg-0 e-6 e-10 e-14 e-15 u--d e-3 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--err u--errC-39) eta-3))) eta-2)))))))) eta-1)))(else (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))))
(define TTImpC-45ElabC-45Delayed-retryDelayed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 0 0 '() arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (CoreC-45Unify-solveConstraints arg-1 arg-3 arg-5 0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (cond ((equal? e-2 1) (TTImpC-45ElabC-45Delayed-retryDelayed arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 clam-0)) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-0 arg-1 arg-2 arg-3 arg-4 1 0 '() e-3) clam-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Unify-n--27047-30178-u--afterStart (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (let ((e-2 (car arg-6))) (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-2 arg-2))))
(define CoreC-45Unify-solveConstraintsAfter (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Unify-retryGuess arg-0 arg-1 arg-3 arg-4 eta-1)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (CoreC-45Unify-n--27047-30178-u--afterStart arg-4 arg-3 arg-2 arg-1 arg-0 eta-1)) (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1))) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) eta-1) e-6))) (cond ((equal? sc2 1) (CoreC-45Unify-solveConstraintsAfter arg-0 arg-1 arg-2 arg-3 0 clam-0)) (else (vector 1 (vector 0 )))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45ImplicitBind-solvePolyConstraint (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (vector-ref arg-2 0))) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-9 (vector-ref e-7 2))) (case (vector-ref e-9 0) ((2) (vector 1 (vector 0 )))(else (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-5) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) e-0 arg-0 arg-1 CoreC-45Unify-inLHS e-1) e-2) e-7) e-11))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (csegen-2568 clam-0))))))))(else (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-continueNF arg-0 e-0 e-6 e-2 e-5) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 ((((CoreC-45Unify-unify (csegen-2479) e-0 arg-0 arg-1 CoreC-45Unify-inLHS e-1) e-2) e-7) e-8))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (csegen-2568 clam-0))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define TTImpC-45ElabC-45Check-updateEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 4))) (let ((e-6 (vector-ref arg-5 5))) (let ((e-8 (vector-ref arg-5 7))) (let ((e-9 (vector-ref arg-5 8))) (let ((e-10 (vector-ref arg-5 9))) (let ((e-11 (vector-ref arg-5 10))) (let ((e-12 (vector-ref arg-5 11))) (let ((e-13 (vector-ref arg-5 12))) (let ((e-14 (vector-ref arg-5 13))) (vector arg-1 e-2 arg-2 arg-3 e-5 e-6 arg-4 e-8 e-9 e-10 e-11 e-12 e-13 e-14)))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-checkBindHere (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--oldenv (let ((e-3 (vector-ref e-5 2))) e-3))) (let ((u--oldsub (let ((e-4 (vector-ref e-5 3))) e-4))) (let ((u--oldbif (let ((e-7 (vector-ref e-5 6))) e-7))) (let ((u--dontbind (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (let ((e-6 (vector-ref e-5 5))) e-6)))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-4 (TTImpC-45ElabC-45Check-updateEnv arg-0 arg-10 (vector 0 ) '() e-5)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-getNextEntry arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (let ((e-0 (vector-ref arg-8 0))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-8 (vector-ref arg-8 5))) (vector e-0 arg-12 e-2 1 e-4 e-8))))) arg-9 arg-10 arg-13 arg-14) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-2) (let ((act-5 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (let ((act-6 (unbox arg-3))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (TTImpC-45ElabC-45Delayed-retryDelayed arg-0 arg-1 arg-2 arg-3 arg-4 u--solvemode (let ((e-12 (vector-ref e-10 10))) e-12) eta-4)) (lambda (u--err) (lambda (eta-4) (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 (unbox arg-3))) (vector 1 act-7))))) (lambda (world-0) (let ((act-7 (eff-0 world-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-1 (lambda (world-1) (let ((act-8 (set-box! arg-3 (let ((e-0 (vector-ref e-11 0))) (let ((e-1 (vector-ref e-11 1))) (let ((e-20 (vector-ref e-11 2))) (let ((e-19 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-18 (vector-ref e-11 5))) (let ((e-17 (vector-ref e-11 6))) (let ((e-16 (vector-ref e-11 7))) (let ((e-15 (vector-ref e-11 8))) (let ((e-14 (vector-ref e-11 9))) (let ((e-12 (vector-ref e-11 11))) (vector e-0 e-1 e-20 e-19 e-4 e-18 e-17 e-16 e-15 e-14 '() e-12))))))))))))))) (vector 1 act-8))))) eff-1) world-0))))))) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-4)))))) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (let ((act-8 (unbox arg-3))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--cons (let ((e-18 (vector-ref e-12 6))) e-18))) (lambda (eta-4) (let ((act-9 (let ((act-9 (set-box! arg-3 (let ((e-0 (vector-ref e-12 0))) (let ((e-1 (vector-ref e-12 1))) (let ((e-21 (vector-ref e-12 2))) (let ((e-20 (vector-ref e-12 3))) (let ((e-4 (vector-ref e-12 4))) (let ((e-19 (vector-ref e-12 5))) (let ((e-17 (vector-ref e-12 7))) (let ((e-16 (vector-ref e-12 8))) (let ((e-15 (vector-ref e-12 9))) (let ((e-14 (vector-ref e-12 10))) (let ((e-13 (vector-ref e-12 11))) (vector e-0 e-1 e-21 e-20 e-4 e-19 '() e-17 e-16 e-15 e-14 e-13))))))))))))))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 ((CoreC-45Core-traverse_ (lambda (eta-5) (lambda (eta-6) (TTImpC-45ElabC-45ImplicitBind-solvePolyConstraint arg-1 arg-3 eta-5 eta-6))) u--cons) eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 ((CoreC-45Core-traverse_ (lambda (eta-5) (lambda (eta-6) (TTImpC-45ElabC-45ImplicitBind-checkPolyConstraint arg-1 eta-5 eta-6))) u--cons) eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 (CoreC-45Unify-solveConstraintsAfter arg-1 arg-3 e-7 (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))) 1 eta-4))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((act-13 (CoreC-45Unify-checkDots arg-3 arg-1 eta-4))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((act-14 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.implicits" 5 (lambda () "Binding names") e-2 eta-4))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((act-15 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.implicits" 5 (lambda () "Normalised") arg-10 e-2 eta-4))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((act-16 (TTImpC-45ElabC-45ImplicitBind-getToBind arg-0 arg-1 arg-4 arg-3 arg-11 (let ((e-0 (vector-ref arg-8 0))) e-0) arg-12 arg-10 u--dontbind eta-4))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-17 ((TTImpC-45ElabC-45Check-clearToBind arg-4 u--dontbind) eta-5))) (case (vector-ref act-17 0) ((0) (let ((e-4 (vector-ref act-17 1))) (vector 0 e-4))) (else (let ((act-18 ((let ((eff-0 (lambda (world-0) (let ((act-18 (unbox arg-4))) (vector 1 act-18))))) (lambda (world-0) (let ((act-18 (eff-0 world-0))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-1 (lambda (world-1) (let ((act-19 (set-box! arg-4 (TTImpC-45ElabC-45Check-updateEnv (let ((e-1 (vector-ref e-5 0))) e-1) u--oldenv u--oldsub u--oldbif (let ((e-1 (vector-ref e-22 0))) (let ((e-34 (vector-ref e-22 1))) (let ((e-33 (vector-ref e-22 2))) (let ((e-4 (vector-ref e-22 3))) (let ((e-31 (vector-ref e-22 5))) (let ((e-30 (vector-ref e-22 6))) (let ((e-29 (vector-ref e-22 7))) (let ((e-28 (vector-ref e-22 8))) (let ((e-27 (vector-ref e-22 9))) (let ((e-26 (vector-ref e-22 10))) (let ((e-25 (vector-ref e-22 11))) (let ((e-24 (vector-ref e-22 12))) (let ((e-23 (vector-ref e-22 13))) (vector e-1 e-34 e-33 e-4 '() e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23)))))))))))))))))) (vector 1 act-19))))) eff-1) world-0))))))) eta-5))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (let ((act-19 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-5))) (case (vector-ref act-19 0) ((0) (let ((e-4 (vector-ref act-19 1))) (vector 0 e-4))) (else (let ((e-23 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-20 (let ((act-20 (unbox arg-1))) (vector 1 act-20)))) (case (vector-ref act-20 0) ((0) (let ((e-4 (vector-ref act-20 1))) (vector 0 e-4))) (else (let ((e-24 (vector-ref act-20 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-21 (let ((act-21 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-24 arg-10 e-2 eta-7))) (case (vector-ref act-21 0) ((0) (let ((e-4 (vector-ref act-21 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-22 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-24 arg-10 e-23 eta-8))) (case (vector-ref act-22 0) ((0) (let ((e-4 (vector-ref act-22 1))) (vector 0 e-4))) (else (let ((e-26 (vector-ref act-22 1))) ((let ((eff-0 (lambda (eta-9) (TTImpC-45ElabC-45ImplicitBind-bindImplicits arg-1 arg-0 arg-11 arg-12 e-24 arg-10 e-20 e-25 e-26 eta-9)))) eff-0) eta-8)))))))) eff-0) eta-7))))))) (case (vector-ref act-21 0) ((0) (let ((e-4 (vector-ref act-21 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-26 (car e-25))) (let ((e-4 (cdr e-25))) (let ((act-22 ((CoreC-45Core-traverse_ (lambda (eta-8) (lambda (eta-9) (TTImpC-45ElabC-45ImplicitBind-implicitBind arg-1 arg-3 eta-8 eta-9))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-8) (Builtin-fst eta-8)) e-20)) clam-0))) (case (vector-ref act-22 0) ((0) (let ((e-27 (vector-ref act-22 1))) (vector 0 e-27))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 e-26 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-4) arg-14 clam-0))))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))))))))) eff-0) eta-4)))))))))))))))))))))))))))))) eff-0) eta-3))))))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-bindingRig (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) e-1)) (else (let ((e-6 (vector-ref arg-1 2))) e-6)))))
(define TTImpC-45ElabC-45ImplicitBind-n--15268-17315-u--isIncompatible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-14))) (cond ((equal? sc1 1) 1) (else (AlgebraC-45Semiring-isLinear csegen-931 arg-15)))))) (cond ((equal? sc0 1) (AlgebraC-45Preorder-C-60 csegen-2567 csegen-1416 (AlgebraC-45ZeroOneOmega-rigPlus arg-14 arg-15))) (else 0)))))
(define TTImpC-45ElabC-45ImplicitBind-n--15268-17314-u--combine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (let ((sc0 (TTImpC-45ElabC-45ImplicitBind-n--15268-17315-u--isIncompatible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15 arg-16))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-3 2 arg-14) ext-0)) (else (vector 1 (vector 0 )))))))
(define TTImpC-45ElabC-45ImplicitBind-case--caseC-32blockC-32inC-32checkBindVar-17784 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (if (null? arg-18) (let ((act-1 ((TTImpC-45ElabC-45ImplicitBind-mkPatternHole arg-0 arg-10 arg-13 arg-11 arg-3 arg-7 arg-16 arg-4 (let ((e-1 (vector-ref arg-6 1))) e-1) arg-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-2 (let ((e-1 (vector-ref arg-6 1))) (case (vector-ref e-1 0) ((0) (CoreC-45Unify-setInvertible arg-13 arg-3 arg-16 clam-0))(else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-13 "elab.implicits" 5 (lambda () (string-append "Added Bound implicit " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (u--d) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (u--d) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d x-2))))) x-1)) (lambda (u--d) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) u--d x-1))))) x-0)) (lambda (u--d) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) u--d x-0))))) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (x-0) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-0) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-0) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-0 x-2))))) x-1)) (lambda (d-0) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) d-0 x-1))))) x-0)) (lambda (d-0) (lambda (x-0) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-1) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-1)) (lambda (d-1) (lambda (x-1) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-1)))) (cons (lambda (x-1) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-1) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-1 x-2))))) x-1)) (lambda (d-1) (lambda (x-1) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2)))) (cons (lambda (x-2) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 x-2)) (lambda (d-2) (lambda (x-2) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 d-2 x-2))))) d-1 x-1))))) d-0 x-0))))) u--d u--x))))) (cons arg-16 (cons arg-7 (cons e-2 (cons e-6 e-7))))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 ((let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-10))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-10 (let ((e-1 (vector-ref e-10 0))) (let ((e-22 (vector-ref e-10 1))) (let ((e-21 (vector-ref e-10 2))) (let ((e-4 (vector-ref e-10 3))) (let ((e-20 (vector-ref e-10 4))) (let ((e-19 (vector-ref e-10 5))) (let ((e-18 (vector-ref e-10 6))) (let ((e-17 (vector-ref e-10 7))) (let ((e-16 (vector-ref e-10 8))) (let ((e-15 (vector-ref e-10 9))) (let ((e-11 (vector-ref e-10 10))) (let ((e-12 (vector-ref e-10 11))) (let ((e-13 (vector-ref e-10 12))) (let ((e-14 (vector-ref e-10 13))) (vector e-1 e-22 e-21 e-4 (cons (cons arg-16 (vector 0 arg-0 arg-7 (vector 1 ) e-2 e-6)) e-20) (cons (cons arg-16 (vector 0 arg-0 arg-7 (vector 1 ) e-2 e-7)) e-19) e-18 e-17 e-16 e-15 e-11 e-12 e-13 e-14)))))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45ContextC-45Log-log arg-13 "metadata.names" 7 (lambda () "checkBindVar is adding \x2193;") clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45Metadata-addNameType arg-0 arg-13 arg-12 arg-3 (vector 1 arg-2) arg-4 e-6 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45Metadata-addNameLoc arg-12 arg-13 arg-3 (vector 1 arg-2) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-13 arg-11 arg-10 arg-7 arg-6 arg-4 arg-3 e-2 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 e-6) arg-1 clam-0)))))))))))))))))))))))))) eff-0) ext-0))))) (let ((e-2 (unbox arg-18))) (let ((act-1 (TTImpC-45ElabC-45ImplicitBind-n--15268-17314-u--combine arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (vector 1 arg-2) arg-7 (TTImpC-45ElabC-45Check-bindingRig e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((u--tm (TTImpC-45ElabC-45Check-bindingTerm e-2))) (let ((u--ty (TTImpC-45ElabC-45Check-bindingType e-2))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-13 "metadata.names" 7 (lambda () "checkBindVar is adding \x2193;") ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (CoreC-45Metadata-addNameType arg-0 arg-13 arg-12 arg-3 (vector 1 arg-2) arg-4 u--ty ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 (CoreC-45Metadata-addNameLoc arg-12 arg-13 arg-3 (vector 1 arg-2) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-13 arg-11 arg-10 arg-7 arg-6 arg-4 arg-3 u--tm (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 u--ty) arg-1 ext-0)))))))))))))))))))
(define TTImpC-45ElabC-45ImplicitBind-checkBindVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((u--elabmode (let ((e-0 (vector-ref arg-8 0))) e-0))) (let ((sc0 (let ((e-1 (vector-ref arg-8 1))) (case (vector-ref e-1 0) ((0) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) 1)) (CoreC-45Env-defined arg-0 (vector 1 arg-12) arg-10)))(else 0))))) (cond ((equal? sc0 0) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--n (vector 3 (vector 1 arg-12) (let ((e-2 (vector-ref e-5 1))) e-2)))) (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Check-noteLHSPatVar arg-4 u--elabmode (vector 1 arg-12)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45ElabC-45Check-notePatVar arg-4 u--n) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (unbox arg-4))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((sc5 (CoreC-45FC-isConcreteFC arg-11))) (if (null? sc5) (vector 1 (vector 0 )) (let ((e-1 (unbox sc5))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.highlight" 7 (lambda () (string-append "getNameType is adding Bound: " (CoreC-45Name-u--show_Show_Name u--n))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (CoreC-45Metadata-addSemanticDecorations arg-2 arg-1 (cons (cons e-1 (cons 5 (box u--n))) '()) eta-2))))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45ImplicitBind-case--caseC-32blockC-32inC-32checkBindVar-17784 arg-0 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--elabmode e-5 u--n e-8 (DataC-45List-lookup csegen-832 u--n (let ((e-19 (vector-ref e-8 4))) e-19)) eta-2))))))) eff-0) eta-1))))))))))))))) eff-0) eta-0)))))))(else (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 0 arg-11 (vector 1 arg-12)) arg-13)))))))
(define AlgebraC-45Semiring-branchOne (lambda (arg-2 arg-3 arg-4 arg-5) (let ((sc0 (AlgebraC-45Semiring-isLinear arg-2 arg-5))) (cond ((equal? sc0 1) (arg-3)) (else (arg-4))))))
(define CoreC-45TTC-45Binder-setMultiplicity (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (vector 0 e-1 arg-2 e-3 e-4))))) ((1) (let ((e-6 (vector-ref arg-1 1))) (let ((e-8 (vector-ref arg-1 3))) (let ((e-9 (vector-ref arg-1 4))) (vector 1 e-6 arg-2 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 3))) (let ((e-14 (vector-ref arg-1 4))) (vector 2 e-11 arg-2 e-13 e-14))))) ((3) (let ((e-16 (vector-ref arg-1 1))) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (vector 3 e-16 arg-2 e-18 e-19))))) ((4) (let ((e-21 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 3))) (let ((e-24 (vector-ref arg-1 4))) (vector 4 e-21 arg-2 e-23 e-24))))) (else (let ((e-26 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 3))) (vector 5 e-26 arg-2 e-28)))))))
(define TTImpC-45ElabC-45Case-toRig1 (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 (CoreC-45TTC-45Binder-multiplicity e-4)))) (cond ((equal? sc2 1) (cons (CoreC-45TTC-45Binder-setMultiplicity e-4 csegen-1416) e-5)) (else (cons e-4 e-5)))))))(else (let ((e-0 (- arg-2 1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (cons e-9 (TTImpC-45ElabC-45Case-toRig1 e-0 e-10)))))))))
(define TTImpC-45ElabC-45Case-allow (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (unbox arg-1))) (TTImpC-45ElabC-45Case-toRig1 e-2 arg-2)))))
(define CoreC-45UnifyState-applyToFull (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 1 arg-1 arg-3 '())))) (CoreC-45TTC-45Term-apply arg-1 arg-2 u--args))))
(define TTImpC-45ElabC-45Case-explicitPi (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (car arg-1))) (let ((e-4 (cdr arg-1))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 1))) (let ((e-8 (vector-ref e-3 2))) (let ((e-10 (vector-ref e-3 4))) (cons (vector 2 e-7 e-8 (vector 1 ) e-10) (TTImpC-45ElabC-45Case-explicitPi e-4))))))(else (cons e-3 (TTImpC-45ElabC-45Case-explicitPi e-4)))))))))
(define TTImpC-45ElabC-45Utils-n--8499-8314-u--notErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) 1 (if (null? arg-9) 0 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((9) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((1) (TTImpC-45ElabC-45Utils-n--8499-8314-u--notErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (+ arg-7 1) arg-8 e-3))(else (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-7 arg-8))) (cond ((equal? sc3 1) 1) (else (TTImpC-45ElabC-45Utils-n--8499-8314-u--notErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (+ arg-7 1) arg-8 e-3))))))))(else (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-7 arg-8))) (cond ((equal? sc2 1) 1) (else (TTImpC-45ElabC-45Utils-n--8499-8314-u--notErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (+ arg-7 1) arg-8 e-3))))))))))))
(define TTImpC-45ElabC-45Utils-detagSafe (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((act-1 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-0) (vector 1 0)) (let ((e-7 (unbox e-6))) (lambda (clam-0) (case (vector-ref e-7 0) ((6) (let ((e-9 (vector-ref e-7 8))) (if (null? e-9) (vector 1 0) (let ((e-16 (unbox e-9))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-0))) e-5 '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-17 (vector-ref act-2 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (TTImpC-45ElabC-45Utils-n--8499-8314-u--notErased e-1 e-3 e-4 e-5 e-2 arg-1 arg-0 0 e-16 e-17))))) eff-0) clam-0)))))))))(else (vector 1 0)))))))) eff-0) ext-0)))))))))))(else (vector 1 0)))))
(define TTImpC-45ElabC-45Utils-findErasedFrom (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc2 1) (vector 1 )) (else (vector 0 ))))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45Utils-findErasedFrom arg-0 arg-1 (+ arg-2 1) e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-9) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45ElabC-45Utils-detagSafe arg-0 arg-1 e-13 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-14 (vector-ref act-4 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--dtC-39 (cond ((equal? e-14 1) (cons arg-2 e-11)) (else e-11)))) (lambda (eta-2) (vector 1 (let ((sc7 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc7 1) (cons (cons arg-2 e-12) u--dtC-39)) (else (cons e-12 u--dtC-39))))))))) eff-0) eta-1)))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (vector 1 (cons '() '()))))))))(else (vector 1 (cons '() '())))))))
(define TTImpC-45ElabC-45Utils-findErased (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-findErasedFrom arg-0 e-5 0 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Case-findImpsIn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-8 0) ((0) (TTImpC-45ElabC-45Case-findImpsIn (cons e-2 arg-0) arg-1 (cons e-3 arg-2) (cons (cons e-2 (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc3))) (((e-10 'erased) 'erased) e-9)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (cons (Builtin-fst u--x) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc3))) (((e-10 'erased) 'erased) (Builtin-snd u--x)))))) arg-3)) e-4))(else (TTImpC-45ElabC-45Case-findImpsIn (cons e-2 arg-0) arg-1 (cons e-3 arg-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (cons (Builtin-fst u--x) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc2))) (((e-10 'erased) 'erased) (Builtin-snd u--x)))))) arg-3) e-4))))))(else (TTImpC-45ElabC-45Case-findImpsIn (cons e-2 arg-0) arg-1 (cons e-3 arg-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (cons (Builtin-fst u--x) (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-6 (car sc1))) (((e-6 'erased) 'erased) (Builtin-snd u--x)))))) arg-3) e-4)))))))(else (lambda (clam-0) (let ((sc0 (DataC-45List-isNil arg-3))) (cond ((equal? sc0 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 28 arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-reverse arg-3)) clam-0)))))))))
(define TTImpC-45ElabC-45Case-findScrutinee (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) '() (let ((e-1 (car arg-0))) (let ((e-2 (cdr arg-0))) (if (null? arg-1) '() (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (case (vector-ref arg-2 0) ((0) (let ((e-9 (vector-ref arg-2 1))) (let ((e-10 (vector-ref arg-2 2))) (let ((sc3 (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-10))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45TTC-45Binder-isLet e-6))) (cond ((equal? sc5 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc3 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Case-findScrutinee e-2 e-7 (vector 0 e-9 e-10)) csegen-965)))))))(else '()))))))))))
(define CoreC-45UnifyState-genCaseName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Context-inCurrentNS arg-0 (vector 6 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8)) eta-0))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Case-getNestData (lambda (arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (cons e-6 e-10)))))))))
(define CoreC-45Normalise-normaliseSizeLimit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-4 arg-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-1 (vector 0 0 (box arg-3)) arg-2 arg-4 e-5 eta-1)))) eff-0) eta-0)))))) (lambda (u--err) (lambda (eta-0) (vector 1 arg-5))) ext-0)))
(define CoreC-45Context-addLogLevel (lambda (arg-0 arg-1) (if (null? arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-35 0))) (let ((e-44 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-47 (vector-ref e-35 4))) (let ((e-48 (vector-ref e-35 5))) (let ((e-49 (vector-ref e-35 6))) (let ((e-50 (vector-ref e-35 7))) (let ((e-53 (vector-ref e-35 10))) (let ((e-54 (vector-ref e-35 11))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 (vector e-68 e-44 e-45 e-46 e-47 e-48 e-49 e-50 0 CoreC-45OptionsC-45Log-defaultLogLevel e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))) (let ((e-2 (unbox arg-1))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-44 (vector-ref e-4 0))) (let ((e-43 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-69 (vector-ref e-35 0))) (let ((e-68 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-47 (vector-ref e-35 4))) (let ((e-48 (vector-ref e-35 5))) (let ((e-49 (vector-ref e-35 6))) (let ((e-50 (vector-ref e-35 7))) (let ((e-52 (vector-ref e-35 9))) (let ((e-53 (vector-ref e-35 10))) (let ((e-54 (vector-ref e-35 11))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-34 e-3 (vector e-44 e-43 (vector e-69 e-68 e-45 e-46 e-47 e-48 e-49 e-50 1 (CoreC-45OptionsC-45Log-insertLogLevel e-2 e-52) e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))))
(define TTImpC-45ProcessBuiltin-getConsGDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--c (let ((e-0 (vector-ref e-5 0))) e-0))) (PreludeC-45Basics-flip csegen-1298 arg-2 (lambda (u--n) (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName u--n u--c) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 u--n (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-2))) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 u--n (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-6) eta-1)) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-0) (if (null? e-7) (CoreC-45Context-ambiguousName arg-0 arg-1 u--n (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-6) clam-0) (let ((e-10 (cdr e-7))) (if (null? e-2) (vector 1 (cons e-8 e-10)) (CoreC-45Context-ambiguousName arg-0 arg-1 u--n (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-6) clam-0))))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessBuiltin-n--9108-9711-u--isNatFlag (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((11) (let ((e-0 (vector-ref arg-3 1))) (case (vector-ref e-0 0) ((8) 1) ((9) 1)(else 0))))(else 0))))
(define TTImpC-45ProcessBuiltin-n--9108-9710-u--hasNatFlag (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45ProcessBuiltin-n--9108-9711-u--isNatFlag arg-0 arg-1 arg-2 eta-0)) (let ((e-12 (vector-ref e-3 12))) e-12)))))
(define TTImpC-45ProcessBuiltin-isNatural (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 (vector 2 ) arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((6) (let ((e-27 (vector-ref e-18 7))) (let ((act-3 (TTImpC-45ProcessBuiltin-getConsGDef arg-0 arg-1 e-27 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-34 (vector-ref act-3 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-2) (TTImpC-45ProcessBuiltin-n--9108-9710-u--hasNatFlag arg-0 arg-2 arg-1 eta-2)) e-34))))) eff-0) clam-0)))))))(else (vector 1 0))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessBuiltin-showDefType (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "undefined") ((1) "function") ((2) "external function") ((3) "foreign function") ((4) "builtin function") ((5) "data constructor") ((6) "type constructor") ((7) "hole") ((8) "search") ((9) "guess") ((10) "bound name") ((11) "universe level") (else "delayed"))))
(define TTImpC-45ProcessBuiltin-getNEArgs (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getNEArgs arg-0 (CoreC-45TTC-45TermC-45Subst-subst e-6 e-4)))) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-getNEArgs (cons e-2 arg-0) e-4)) (else (cons (cons arg-0 e-9) (TTImpC-45ProcessBuiltin-getNEArgs (cons e-2 arg-0) e-4))))))))(else '()))))))(else '()))))
(define TTImpC-45ProcessBuiltin-getFirstNEType (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45ProcessBuiltin-getNEArgs arg-0 arg-1))) (if (null? sc0) '() (let ((e-2 (car sc0))) (box e-2))))))
(define TTImpC-45ProcessBuiltin-getReturnType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getReturnType arg-0 (CoreC-45TTC-45TermC-45Subst-subst e-6 e-4)))) ((2) (TTImpC-45ProcessBuiltin-getReturnType (cons e-2 arg-0) e-4))(else '()))))))(else (box (cons arg-0 arg-1))))))
(define TTImpC-45ProcessBuiltin-isStrict (lambda (arg-1) (case (vector-ref arg-1 0) ((0) 1) ((1) 1) ((2) (let ((e-14 (vector-ref arg-1 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ProcessBuiltin-isStrict eta-0)) e-14))) ((3) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict (CoreC-45TTC-45Binder-binderType e-18)))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-19)) (else 0)))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (let ((e-23 (vector-ref arg-1 3))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict e-22))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-23)) (else 0)))))) ((5) (let ((e-27 (vector-ref arg-1 3))) (let ((e-28 (vector-ref arg-1 4))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict e-27))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-28)) (else 0)))))) ((6) 0) ((7) (let ((e-36 (vector-ref arg-1 3))) (let ((e-37 (vector-ref arg-1 4))) (let ((sc1 (TTImpC-45ProcessBuiltin-isStrict e-36))) (cond ((equal? sc1 1) (TTImpC-45ProcessBuiltin-isStrict e-37)) (else 0)))))) ((8) (let ((e-41 (vector-ref arg-1 3))) (TTImpC-45ProcessBuiltin-isStrict e-41))) ((9) 1) ((10) 1) (else 1))))
(define TTImpC-45ProcessBuiltin-n--9269-9865-u--checkTyS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--type (let ((e-2 (vector-ref arg-5 2))) e-2))) (let ((sc0 (TTImpC-45ProcessBuiltin-getFirstNEType '() u--type))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Expected a non-erased argument, found none.") eta-0)) (let ((e-1 (unbox sc0))) (let ((e-6 (cdr e-1))) (lambda (clam-0) (let ((sc2 (TTImpC-45ProcessBuiltin-getReturnType '() u--type))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Unexpected type " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() u--type))) clam-0) (let ((e-2 (unbox sc2))) (let ((e-7 (cdr e-2))) (let ((act-1 (let ((sc4 (TTImpC-45ProcessBuiltin-termConMatch e-6 e-7))) (cond ((equal? sc4 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Incorrect type for 'S'-like constructor for " (string-append (CoreC-45Name-u--show_Show_Name arg-1) "."))) clam-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (let ((sc5 (TTImpC-45ProcessBuiltin-isStrict e-6))) (cond ((equal? sc5 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 "Natural builtin does not support lazy types.") clam-0)))))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (vector 0 ))))))))))))))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32checkNatConsC-44checkCon-10166 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((5) (let ((e-1 (vector-ref arg-10 2))) (let ((sc1 (PreludeC-45Types-prim__integerToNat (- e-1 (PreludeC-45TypesC-45List-lengthTR (let ((e-3 (vector-ref arg-5 3))) e-3)))))) (cond ((equal? sc1 0) (lambda (clam-0) (if (null? arg-7) (vector 1 (cons (box arg-4) arg-8)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Multiple 'Z'-like constructors for " (string-append (CoreC-45Name-u--show_Show_Name arg-1) "."))) clam-0))))(else (let ((e-3 (- (PreludeC-45Types-prim__integerToNat (- e-1 (PreludeC-45TypesC-45List-lengthTR (let ((e-3 (vector-ref arg-5 3))) e-3)))) 1))) (lambda (clam-0) (cond ((equal? e-3 0) (if (null? arg-8) (let ((act-1 ((TTImpC-45ProcessBuiltin-n--9269-9865-u--checkTyS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (cons arg-7 (box arg-4)))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Multiple 'S'-like constructors for " (string-append (CoreC-45Name-u--show_Show_Name arg-1) "."))) clam-0)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Constructor " (string-append (CoreC-45Name-u--show_Show_Name arg-4) " doesn't match any pattern for Natural."))) clam-0))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-0 (string-append "Expected data constructor, found:" (TTImpC-45ProcessBuiltin-showDefType arg-10))) eta-0))))))
(define TTImpC-45ProcessBuiltin-n--9269-9863-u--checkCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((_-0 (cons e-6 e-4))) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32checkNatConsC-44checkCon-10166 arg-0 arg-1 arg-2 arg-3 e-2 e-3 arg-5 e-6 e-4 _-0 (let ((e-18 (vector-ref e-3 18))) e-18))))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessBuiltin-checkNatCons (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessBuiltin-n--9269-9863-u--checkCon arg-3 arg-2 arg-1 arg-0 eta-0 eta-1 eta-2)))) (lambda (eta-0) (vector 1 (cons '() '()))) arg-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (lambda (clam-0) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 (string-append "No 'Z'-like constructors for " (string-append (CoreC-45Name-u--show_Show_Name arg-2) "."))) clam-0) (if (null? e-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 (string-append "No 'S'-like constructors for " (string-append (CoreC-45Name-u--show_Show_Name arg-2) "."))) clam-0) (vector 1 (vector 0 ))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processBuiltinNatural-10709 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((6) (let ((e-6 (vector-ref arg-9 7))) (let ((act-1 (TTImpC-45ProcessBuiltin-getConsGDef arg-0 arg-2 e-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-8 (vector-ref act-1 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ProcessBuiltin-checkNatCons (let ((e-41 (vector-ref arg-3 0))) e-41) e-8 arg-5 arg-2 eta-0)))) eff-0) ext-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Expected a type constructor, found " (string-append (TTImpC-45ProcessBuiltin-showDefType arg-9) "."))) ext-0)))))
(define TTImpC-45ProcessBuiltin-processBuiltinNatural (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "builtin.Natural" 5 (lambda () (string-append "Processing %builtin Natural " (string-append (CoreC-45Name-u--show_Show_Name arg-2) "."))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-2))) e-7) eta-1)) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) eta-1)) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (lambda (clam-0) (if (null? e-8) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) clam-0) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (if (null? e-2) (let ((act-4 (TTImpC-45ProcessBuiltin-isNatural arg-0 arg-1 e-9 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((_-0 (cons (cons e-9 (cons e-11 e-10)) '()))) (cond ((equal? e-12 0) (lambda (eta-1) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processBuiltinNatural-10709 arg-0 arg-2 arg-1 e-5 e-11 e-9 e-10 _-0 0 (let ((e-18 (vector-ref e-10 18))) e-18) eta-1))) (else (lambda (eta-1) (vector 1 (vector 0 )))))))) eff-0) clam-0))))) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) clam-0)))))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessBuiltin-n--8335-8991-u--isInteger (lambda (arg-1 arg-2 arg-3 arg-4 arg-6) (case (vector-ref arg-6 0) ((9) (let ((e-2 (vector-ref arg-6 2))) (case (vector-ref e-2 0) ((13) (let ((e-3 (vector-ref e-2 1))) (cond ((equal? e-3 5) 1)(else 0))))(else 0))))(else 0))))
(define TTImpC-45ProcessBuiltin-getNEIntegerIndex (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getNEIntegerIndex (CoreC-45TTC-45TermC-45Subst-subst e-6 e-4)))) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 2 e-6 e-7 e-8 e-9))) (let ((sc2 (let ((sc3 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc3 1) 0) (else (TTImpC-45ProcessBuiltin-n--8335-8991-u--isInteger e-1 e-2 e-4 u--b e-9)))))) (cond ((equal? sc2 1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-0) (+ arg-0 1)) eta-0))) (TTImpC-45ProcessBuiltin-getNEIntegerIndex e-4))) (else (TTImpC-45ProcessBuiltin-getNEIntegerIndex e-4))))))))))(else '())))))))(else (box '())))))
(define TTImpC-45ProcessBuiltin-getTypeCons (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 3))) (box (CoreC-45TTC-45Var-nameAt arg-0 e-4)))) ((1) (let ((e-9 (vector-ref arg-1 3))) (box e-9))) ((2) '()) ((3) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (case (vector-ref e-18 0) ((1) (let ((e-3 (vector-ref e-18 3))) (TTImpC-45ProcessBuiltin-getTypeCons arg-0 (CoreC-45TTC-45TermC-45Subst-subst e-3 e-19))))(else '()))))) ((4) (let ((e-22 (vector-ref arg-1 2))) (TTImpC-45ProcessBuiltin-getTypeCons arg-0 e-22)))(else '()))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-11720 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (if (null? arg-18) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "No type constructor found for return type of " (string-append arg-3 "."))) ext-0) (let ((e-1 (unbox arg-18))) (let ((act-1 (TTImpC-45ProcessBuiltin-isNatural arg-0 arg-2 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-5 1) (CoreC-45Context-setFlag arg-0 arg-2 (vector 8 arg-6) (vector 12 arg-15) clam-1)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "Return type is not a 'Nat'-like type") clam-1)))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-11672 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Unexpected type " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-9))) eta-0)) (let ((e-1 (unbox arg-16))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (lambda (eta-0) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-11720 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-5 e-6 (TTImpC-45ProcessBuiltin-getTypeCons e-5 e-6) eta-0))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processIntegerToNat-11573 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (case (vector-ref arg-10 0) ((1) (let ((e-0 (vector-ref arg-10 1))) (let ((e-1 (vector-ref arg-10 2))) (let ((e-2 (vector-ref arg-10 3))) (let ((e-3 (vector-ref arg-10 4))) (let ((e-4 (vector-ref arg-10 5))) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-0 "builtin.IntegerToNatural" 25 (lambda () (string-append "Type of " arg-3)) arg-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((sc2 (TTImpC-45ProcessBuiltin-getNEIntegerIndex arg-9))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Unexpected arity while processing %builtin IntegerToNatural " (string-append arg-3 " (getNEIntegerIndex returned Nothing)"))) ext-0) (let ((e-6 (unbox sc2))) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "No unrestricted arguments of type `Integer` found for " (string-append arg-3 "."))) ext-0) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (if (null? e-7) ((TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processIntegerToNat-11672 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-0 e-1 e-2 e-3 e-4 e-8 (TTImpC-45ProcessBuiltin-getReturnType '() arg-9)) ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "More than one unrestricted arguments of type `Integer` found for " (string-append arg-3 "."))) ext-0)))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Expected function definition, found " (string-append (TTImpC-45ProcessBuiltin-showDefType arg-10) "."))) ext-0)))))
(define TTImpC-45ProcessBuiltin-processIntegerToNat (lambda (arg-0 arg-1 arg-2) (let ((u--show_fn (CoreC-45Name-u--show_Show_Name arg-2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "builtin.IntegerToNatural" 5 (lambda () (string-append "Processing %builtin IntegerToNatural " (string-append u--show_fn "."))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-2))) e-7) eta-2)) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (lambda (eta-2) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) eta-2)) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (lambda (clam-0) (if (null? e-8) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) clam-0) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (if (null? e-2) (let ((act-4 (CoreC-45Context-toFullNames arg-0 csegen-68 (let ((e-30 (vector-ref e-10 2))) e-30) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((_-0 (cons (cons e-9 (cons e-11 e-10)) '()))) (lambda (eta-2) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processIntegerToNat-11573 arg-0 arg-2 arg-1 u--show_fn e-5 e-9 e-11 e-10 _-0 e-12 (let ((e-18 (vector-ref e-10 18))) e-18) eta-2))))) eff-0) clam-0))))) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) clam-0)))))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))
(define TTImpC-45ProcessBuiltin-getNEIndex (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 3))) (TTImpC-45ProcessBuiltin-getNEIndex (CoreC-45TTC-45TermC-45Subst-subst e-6 e-4)))) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc2 1) (TTImpC-45ProcessBuiltin-getNEIndex e-4)) (else (box 0))))))(else '())))))(else '()))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-11039 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (if (null? arg-17) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "No type constructor found for non-erased arguement of " (string-append arg-3 "."))) ext-0) (let ((e-1 (unbox arg-17))) (let ((act-1 (TTImpC-45ProcessBuiltin-isNatural arg-0 arg-2 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((sc3 (TTImpC-45ProcessBuiltin-getNEIndex arg-14))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Couldn't find non-erased argument.") clam-0) (let ((e-2 (unbox sc3))) (CoreC-45Context-setFlag arg-0 arg-2 (vector 8 arg-6) (vector 12 e-2) clam-0))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "Non-erased argument is not a 'Nat'-like type.") clam-0)))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-10991 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "No arguments found for " (string-append arg-3 "."))) eta-0)) (let ((e-1 (car arg-15))) (let ((e-2 (cdr arg-15))) (if (null? e-1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "More than 1 non-erased arguments found for " (string-append arg-3 "."))) eta-0)) (let ((e-6 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-2) (lambda (eta-0) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-11039 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-6 e-7 (TTImpC-45ProcessBuiltin-getTypeCons e-6 e-7) eta-0)) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "More than 1 non-erased arguments found for " (string-append arg-3 "."))) eta-0)))))))))))
(define TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processNatToInteger-10933 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((1) (let ((e-0 (vector-ref arg-9 1))) (let ((e-1 (vector-ref arg-9 2))) (let ((e-2 (vector-ref arg-9 3))) (let ((e-3 (vector-ref arg-9 4))) (let ((e-4 (vector-ref arg-9 5))) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-68 (let ((e-25 (vector-ref arg-7 2))) e-25) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-0 "builtin.NaturalToInteger" 25 (lambda () (string-append "Type of " arg-3)) e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else ((TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processNatToInteger-10991 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-0 e-1 e-2 e-4 e-3 e-5 (TTImpC-45ProcessBuiltin-getNEArgs '() e-5)) eta-0))))))) eff-0) ext-0)))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Expected function definition, found " (string-append (TTImpC-45ProcessBuiltin-showDefType arg-9) "."))) ext-0)))))
(define TTImpC-45ProcessBuiltin-processNatToInteger (lambda (arg-0 arg-1 arg-2) (let ((u--show_fn (CoreC-45Name-u--show_Show_Name arg-2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "builtin.NaturalToInteger" 5 (lambda () (string-append "Processing %builtin NaturalToInteger " (string-append u--show_fn "."))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-2))) e-7) eta-2)) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) (lambda (eta-2) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) eta-2)) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (if (null? e-8) (lambda (eta-2) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) eta-2)) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (if (null? e-2) (let ((_-0 (cons (cons e-9 (cons e-11 e-10)) '()))) (lambda (eta-2) (TTImpC-45ProcessBuiltin-case--caseC-32blockC-32inC-32processNatToInteger-10933 arg-0 arg-2 arg-1 u--show_fn e-5 e-9 e-11 e-10 _-0 (let ((e-18 (vector-ref e-10 18))) e-18) eta-2))) (lambda (eta-2) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) e-4))) e-7) eta-2)))))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))
(define TTImpC-45ProcessBuiltin-processBuiltin (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-5 0) (lambda (eta-0) (TTImpC-45ProcessBuiltin-processBuiltinNatural arg-1 arg-4 arg-6 eta-0))) ((equal? arg-5 1) (TTImpC-45ProcessBuiltin-processNatToInteger arg-1 arg-4 arg-6)) (else (TTImpC-45ProcessBuiltin-processIntegerToNat arg-1 arg-4 arg-6)))))
(define CoreC-45ContextC-45Context-defaultFlags (cons 0 0))
(define CoreC-45Context-getNextTypeTag (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 (bs+ e-6 1 63) e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (let ((e-33 (vector-ref e-5 6))) e-33)))))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Data-n--7473-1714-u--toNothing (lambda (arg-1 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-7 (let ((e-1 (unbox arg-7))) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (let ((u--tm (box (vector 0 e-4 e-5 e-6)))) (let ((sc2 (or (and (= arg-1 e-6) 1) 0))) (cond ((equal? sc2 1) '()) (else u--tm))))))))(else arg-7))))))
(define CoreC-45ContextC-45Data-dropReps (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-2) (cons e-2 (CoreC-45ContextC-45Data-dropReps e-3)) (let ((e-5 (unbox e-2))) (case (vector-ref e-5 0) ((0) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((e-10 (vector-ref e-5 3))) (cons (box (vector 0 e-8 e-9 e-10)) (CoreC-45ContextC-45Data-dropReps (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45ContextC-45Data-n--7473-1714-u--toNothing e-10 e-9 e-8 e-3 eta-0)) e-3)))))))(else (cons e-2 (CoreC-45ContextC-45Data-dropReps e-3)))))))))))
(define CoreC-45Core-n--12957-11103-u--goTerm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) ((arg-1 arg-2) arg-3)) ((1) ((arg-1 arg-2) arg-3)) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (let ((eff-0 (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 eta-0)) e-14 '()))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 2 e-11 e-12 e-13 e-5)))))) eff-0 eta-0))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((e-19 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (let ((eff-0 (CoreC-45CoreC-45Binder-traverse (lambda (eta-1) (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 eta-1)) e-18))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 3 e-16 e-17 e-5 eta-3))))))) eff-0 eta-1))) (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 (cons e-17 arg-2) e-19) eta-0)))))))) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (let ((eff-0 (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-22))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 4 e-21 e-5 eta-3))))))) eff-0 eta-1))) (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-23) eta-0))))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (let ((eff-0 (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-27))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 5 e-25 e-26 e-5 eta-3))))))) eff-0 eta-1))) (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-28) eta-0)))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (let ((eff-0 (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-32))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 6 e-30 e-31 e-5)))))) eff-0 eta-0)))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (let ((eff-0 (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-36))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (vector 7 e-34 e-35 e-5 eta-3))))))) eff-0 eta-1))) (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-37) eta-0)))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (lambda (world-0) (let ((act-1 (eta-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (eta-1 e-5))) eff-0) world-0)))))))) (arg-1 arg-2) (let ((eff-0 (CoreC-45Core-n--12957-11103-u--goTerm arg-0 arg-1 arg-2 e-41))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 8 e-39 e-40 e-5)))))) eff-0 eta-0)))))))) ((9) ((arg-1 arg-2) arg-3)) ((10) ((arg-1 arg-2) arg-3)) (else ((arg-1 arg-2) arg-3)))))
(define CoreC-45Core-mapTermM (lambda (arg-0 arg-1 ext-0) (CoreC-45Core-n--12957-11103-u--goTerm arg-1 arg-0 arg-1 ext-0)))
(define CoreC-45Normalise-n--8376-7259-u--act (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-3 arg-0 "eval.eta" 10 (lambda () "  Considering") arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (case (vector-ref arg-4 0) ((3) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((0) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-4 0) ((4) (let ((e-11 (vector-ref e-4 1))) (let ((e-12 (vector-ref e-4 2))) (let ((e-13 (vector-ref e-4 3))) (case (vector-ref e-13 0) ((0) (let ((e-16 (vector-ref e-13 1))) (let ((e-17 (vector-ref e-13 2))) (let ((e-18 (vector-ref e-13 3))) (cond ((equal? e-18 0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm (cons e-2 arg-3) arg-0 "eval.eta" 10 (lambda () "  Shrinking candidate") e-12 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((u--shrunk (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-12 (vector 1 (vector 0 ))))) (let ((u--tm (vector 3 e-1 e-2 (vector 0 e-6 e-7 e-8 e-9) (vector 4 e-11 e-12 (vector 0 e-16 e-17 0))))) (if (null? u--shrunk) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "eval.eta" 10 (lambda () "  Failure!") ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (vector 1 u--tm)))) (let ((e-14 (unbox u--shrunk))) (let ((act-3 (CoreC-45ContextC-45Log-logTerm arg-3 arg-0 "eval.eta" 10 (lambda () "  Success!") e-14 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (vector 1 e-14))))))))))))(else (vector 1 arg-4)))))))(else (vector 1 arg-4)))))))(else (vector 1 arg-4))))))))(else (vector 1 arg-4))))))))(else (vector 1 arg-4))))))))
(define CoreC-45Normalise-etaContract (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm arg-1 arg-0 "eval.eta" 5 (lambda () "Attempting to eta contract subterms of") arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Normalise-normalise arg-0 arg-1 e-5 (CoreC-45Env-mkEnv (vector 2 ) arg-1) arg-2 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-logTerm arg-1 arg-0 "eval.eta" 5 (lambda () "Evaluated to") e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45Core-mapTermM (lambda (vars-7520) (lambda (eta-2) (lambda (eta-3) (CoreC-45Normalise-n--8376-7259-u--act arg-0 arg-1 arg-2 vars-7520 eta-2 eta-3)))) arg-1 arg-2) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (CoreC-45ContextC-45Log-logTerm arg-1 arg-0 "eval.eta" 5 (lambda () "Result of eta-contraction") e-9 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 e-9))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Data-n--7613-1843-u--couldBeParam (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Normalise-etaContract arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (case (vector-ref e-5 0) ((0) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (box (vector 0 e-2 e-3 e-4))))))(else '())))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Data-n--7613-1906-u--mergeArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) '() (let ((e-1 (unbox arg-4))) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (case (vector-ref arg-5 0) ((0) (let ((e-12 (vector-ref arg-5 3))) (let ((sc3 (or (and (= e-6 e-12) 1) 0))) (cond ((equal? sc3 1) (box (vector 0 e-4 e-5 e-6))) (else '())))))(else '()))))))(else '()))))))
(define CoreC-45ContextC-45Data-updateParams (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (CoreC-45ContextC-45Data-dropReps e-5)))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45ContextC-45Data-n--7613-1843-u--couldBeParam arg-0 arg-1 arg-3 eta-0 eta-1))) arg-3 '()) ext-0) (let ((e-2 (unbox arg-2))) (vector 1 (CoreC-45ContextC-45Data-dropReps (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (CoreC-45ContextC-45Data-n--7613-1906-u--mergeArg arg-0 arg-1 e-2 arg-3 eta-0 eta-1))) e-2 arg-3)))))))
(define CoreC-45ContextC-45Data-case--getPs-2139 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 arg-4)) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-7 arg-3))) (cond ((equal? sc2 1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (lambda (eta-0) (CoreC-45ContextC-45Data-updateParams arg-0 arg-1 arg-4 e-3 eta-0)) clam-0)) (else (vector 1 arg-4))))))(else (vector 1 arg-4)))))))))
(define CoreC-45ContextC-45Data-getPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((2) (lambda (eta-0) (let ((act-1 ((CoreC-45ContextC-45Data-getPs arg-0 (cons e-2 arg-1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-3) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-10 (car sc2))) (((e-10 'erased) 'erased) eta-3)))) eta-2)) eta-1)) arg-2) arg-3 e-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-5) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe arg-5 (lambda (u--tm) (CoreC-45TTC-45Term-u--shrink_IsScoped_Term u--tm (vector 1 (vector 0 )))))) eta-2)) e-5))))) eff-0) eta-0)))))))(else (CoreC-45ContextC-45Data-case--getPs-2139 arg-0 arg-1 arg-4 arg-3 arg-2 (CoreC-45TTC-45Term-getFnArgs arg-4))))))))(else (CoreC-45ContextC-45Data-case--getPs-2139 arg-0 arg-1 arg-4 arg-3 arg-2 (CoreC-45TTC-45Term-getFnArgs arg-4))))))
(define CoreC-45ContextC-45Data-getConPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45ContextC-45Data-getPs arg-0 arg-1 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45ContextC-45Data-getConPs arg-0 (cons e-2 arg-1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-3) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-11 (car sc3))) (((e-11 'erased) 'erased) eta-3)))) eta-2)) eta-1)) e-5) arg-3 e-4))) eff-0) eta-0)))))))) ((1) (let ((e-13 (vector-ref e-3 3))) (CoreC-45ContextC-45Data-getConPs arg-0 arg-1 arg-2 arg-3 (CoreC-45TTC-45TermC-45Subst-subst e-13 e-4))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2868 (CoreC-45ContextC-45Data-getPs arg-0 arg-1 arg-2 arg-3 arg-4) eta-0))))))))(else (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-2868 (CoreC-45ContextC-45Data-getPs arg-0 arg-1 arg-2 arg-3 arg-4) eta-0))))))
(define DataC-45List-intersectAllBy (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--x) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (PreludeC-45Types-elemBy csegen-14 arg-1 u--x eta-0)) e-3)) e-2))))))
(define DataC-45List-intersectAll (lambda (arg-1 ext-0) (DataC-45List-intersectAllBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0)))
(define CoreC-45ContextC-45Data-paramPos (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45ContextC-45Data-getConPs arg-0 '() '() arg-1 eta-0)) arg-2 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (DataC-45List-intersectAll csegen-1032 e-5)))))) eff-0) ext-0))))))))
(define CoreC-45ContextC-45Data-n--8261-2454-u--conVisibility (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-9 1) 0)(else arg-9))))
(define CoreC-45ContextC-45Data-n--8261-2452-u--addDataConstructors (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) (lambda (eta-0) (vector 1 arg-11)) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((u--condef (CoreC-45Context-newDef e-4 e-5 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-7 e-7 (LibrariesC-45DataC-45WithDefault-specified (CoreC-45ContextC-45Data-n--8261-2454-u--conVisibility arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-6)) (vector 5 arg-9 e-6 '())))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-5 arg-11) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-8 (vector-ref act-1 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-8) (let ((act-2 (CoreC-45Context-addCtxt e-5 u--condef arg-11 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (let ((e-10 (cdr e-9))) (CoreC-45ContextC-45Data-n--8261-2452-u--addDataConstructors arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (bs+ arg-9 1 63) e-3 e-10)))) eff-0) clam-0))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 e-4 e-5) clam-0))))) eff-0) eta-0))))))))))))))))
(define CoreC-45ContextC-45Data-n--8261-2453-u--allDet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-9 0) '())(else (let ((e-0 (- arg-9 1))) (PreludeC-45Types-u--rangeFromTo_Range_Nat 0 e-0))))))
(define CoreC-45ContextC-45Data-addData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (let ((e-0 (car arg-4))) (let ((e-1 (cdr arg-4))) (let ((e-2 (vector-ref e-0 0))) (let ((e-3 (vector-ref e-0 1))) (let ((e-4 (vector-ref e-0 2))) (let ((e-5 (vector-ref e-0 3))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getNextTypeTag arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--allPos (CoreC-45ContextC-45Data-n--8261-2453-u--allDet e-5 e-4 e-3 e-2 e-1 arg-3 arg-2 arg-1 arg-0 e-4))) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Data-paramPos arg-0 (vector 8 arg-3) (PreludeC-45TypesC-45List-mapAppend '() csegen-2851 e-1) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--paramPositions (DataC-45Maybe-fromMaybe (lambda () u--allPos) e-8))) (lambda (eta-2) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "declare.data.parameters" 20 (lambda () (string-append "Positions of parameters for datatype" (string-append (CoreC-45Name-u--show_Show_Name e-3) (string-append ": [" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (PreludeC-45Show-u--show_Show_Nat eta-3)) u--paramPositions)) "]"))))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((u--tydef (CoreC-45Context-newDef e-2 e-3 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-1 e-5 (LibrariesC-45DataC-45WithDefault-specified arg-2) (vector 6 e-7 e-4 u--paramPositions u--allPos CoreC-45ContextC-45Context-defaultFlags '() (PreludeC-45TypesC-45List-mapAppend '() csegen-2852 e-1) '())))) (let ((act-5 (CoreC-45Context-addCtxt e-3 u--tydef (let ((e-42 (vector-ref e-6 0))) e-42) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-12 (car e-10))) (let ((e-11 (cdr e-10))) (let ((act-6 ((CoreC-45ContextC-45Data-n--8261-2452-u--addDataConstructors e-5 e-4 e-3 e-2 e-1 arg-3 arg-2 arg-1 arg-0 0 e-1 e-11) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (let ((act-7 (set-box! arg-0 (let ((e-45 (vector-ref e-6 1))) (let ((e-44 (vector-ref e-6 2))) (let ((e-43 (vector-ref e-6 3))) (let ((e-42 (vector-ref e-6 4))) (let ((e-41 (vector-ref e-6 5))) (let ((e-40 (vector-ref e-6 6))) (let ((e-39 (vector-ref e-6 7))) (let ((e-38 (vector-ref e-6 8))) (let ((e-37 (vector-ref e-6 9))) (let ((e-36 (vector-ref e-6 10))) (let ((e-35 (vector-ref e-6 11))) (let ((e-34 (vector-ref e-6 12))) (let ((e-33 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-13 e-45 e-44 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (vector 1 e-12))))))) eff-0) clam-1)))))))))) eff-0) eta-2))))))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Context-addHashWithNames (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-toFullNames arg-1 arg-3 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-addHash arg-1 arg-2 e-5))) eff-0) ext-0)))))))
(define CoreC-45Context-addHintFor (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toResolvedNames arg-0 csegen-54 arg-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--hs (let ((sc3 (LibrariesC-45DataC-45NameMap-lookup e-6 (let ((e-33 (vector-ref e-5 7))) e-33)))) (if (null? sc3) '() (let ((e-1 (unbox sc3))) e-1))))) (lambda (clam-0) (cond ((equal? arg-5 1) (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-35 e-34 (LibrariesC-45DataC-45NameMap-insert e-6 (cons (cons e-7 arg-4) u--hs) e-33) e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-4))) (else (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-35 e-34 (LibrariesC-45DataC-45NameMap-insert e-6 (cons (cons e-7 arg-4) u--hs) e-33) e-8 e-9 e-10 (cons (cons e-6 (cons e-7 arg-4)) e-11) e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-4)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addMutData (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 (cons arg-1 e-1) e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ProcessData-n--13858-4405-u--isNullary (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalise arg-2 '() e-5 '() (let ((e-3 (vector-ref arg-3 3))) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45ProcessData-hasArgs 0 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessData-calcEnum (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45Core-allM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessData-n--13858-4405-u--isNullary arg-2 arg-1 arg-0 eta-0 eta-1))) arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (u--c) (lambda (eta-0) (CoreC-45Context-setFlag arg-0 arg-1 u--c (vector 11 (vector 4 (PreludeC-45TypesC-45List-lengthTR arg-2))) eta-0))) (PreludeC-45TypesC-45List-mapAppend '() csegen-2852 arg-2)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 1))))) (else (vector 1 0)))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessData-shaped (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalise arg-0 '() e-5 '() (let ((e-4 (vector-ref e-2 3))) e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc3 ((arg-1 'erased) e-6))) (cond ((equal? sc3 1) (lambda (eta-1) (vector 1 (box (let ((e-1 (vector-ref e-2 1))) e-1))))) (else (lambda (eta-1) (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4052) (arg-1 'erased)) e-3 eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessData-calcListy (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (lambda (clam-0) (if (null? e-2) (let ((act-1 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4081) csegen-2860) arg-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 0) (let ((e-3 (unbox e-5))) (let ((act-2 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 11 (vector 3 )) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 1))))))))) eff-0) clam-0))))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) (let ((act-1 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4140) csegen-2853) arg-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cs (cons e-1 (cons e-5 '())))) (lambda (clam-2) (if (null? e-7) (vector 1 0) (let ((e-3 (unbox e-7))) (let ((act-2 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4172) csegen-2860) u--cs clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-8) (vector 1 0) (let ((e-4 (unbox e-8))) (let ((act-3 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 11 (vector 2 )) clam-3))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((act-4 (CoreC-45Context-setFlag arg-0 arg-1 e-4 (vector 11 (vector 3 )) clam-3))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (vector 1 1)))))))))))) eff-0) clam-2))))))))))) eff-0) clam-0))))) (vector 1 0)))))))))))
(define TTImpC-45ProcessData-calcMaybe (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (lambda (clam-0) (if (null? e-2) (vector 1 0) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (let ((act-1 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4280) csegen-2853) arg-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cs (cons e-1 (cons e-4 '())))) (lambda (clam-1) (if (null? e-6) (vector 1 0) (let ((e-3 (unbox e-6))) (let ((act-2 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4312) csegen-2856) u--cs clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-7) (vector 1 0) (let ((e-8 (unbox e-7))) (let ((act-3 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 11 (vector 5 )) clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((act-4 (CoreC-45Context-setFlag arg-0 arg-1 e-8 (vector 11 (vector 6 )) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (vector 1 1)))))))))))) eff-0) clam-1))))))))))) eff-0) clam-0))))) (vector 1 0)))))))))))
(define TTImpC-45ProcessData-firstArg (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc2 1) (TTImpC-45ProcessData-firstArg e-4)) (else (box e-9)))))))(else '())))))(else '()))))
(define TTImpC-45ProcessData-typeCon (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-2 0) ((3) (box e-3))(else '()))))) ((4) (let ((e-6 (vector-ref arg-1 2))) (TTImpC-45ProcessData-typeCon e-6)))(else '()))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-4701 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (lambda (clam-0) (if (null? arg-13) (vector 1 0) (let ((e-1 (unbox arg-13))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 arg-3))) (cond ((equal? sc1 1) (let ((act-1 (CoreC-45Context-setFlag arg-5 arg-4 arg-6 (vector 11 (vector 8 )) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Context-setFlag arg-5 arg-4 arg-8 (vector 11 (vector 9 )) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 1)))))))) (else (vector 1 0)))))))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-4663 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-11))) (TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-4701 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-1 (TTImpC-45ProcessData-typeCon e-1))))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-4632 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox arg-10))) (TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-4663 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-1 (TTImpC-45ProcessData-firstArg (let ((e-3 (vector-ref e-1 3))) e-3)))))))
(define TTImpC-45ProcessData-calcNaty (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 0)) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (lambda (clam-0) (if (null? e-2) (vector 1 0) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (let ((act-1 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4551) csegen-2853) arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cs (cons e-1 (cons e-4 '())))) (lambda (clam-1) (if (null? e-6) (vector 1 0) (let ((e-3 (unbox e-6))) (let ((act-2 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4585) csegen-2856) u--cs clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 (box e-3))) (if (null? e-7) (lambda (eta-0) (vector 1 0)) (let ((e-8 (unbox e-7))) (let ((_-1 (box e-8))) (TTImpC-45ProcessData-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32calcNaty-4632 e-4 e-1 u--cs arg-2 arg-1 arg-0 e-3 _-0 e-8 _-1 (DataC-45List-find (lambda (u--con) (CoreC-45Name-u--C-61C-61_Eq_Name (let ((e-11 (vector-ref u--con 1))) e-11) e-8)) u--cs)))))))) eff-0) clam-1))))))))))) eff-0) clam-0))))) (vector 1 0)))))))))))
(define TTImpC-45ProcessData-calcRecord (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 0) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (if (null? e-2) (let ((act-1 (CoreC-45Context-setFlag arg-0 arg-1 (let ((e-5 (vector-ref e-1 1))) e-5) (vector 11 (vector 7 )) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 1)))) (vector 1 0))))))))
(define TTImpC-45ProcessData-calcUnity (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 0) (let ((e-2 (cdr arg-3))) (if (null? e-2) (let ((act-1 (TTImpC-45ProcessData-shaped arg-0 (lambda (vs-4961) csegen-2853) arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 0) (let ((e-3 (unbox e-5))) (let ((act-2 (CoreC-45Context-setFlag arg-0 arg-1 e-3 (vector 11 (vector 10 )) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 1))))))))) eff-0) clam-0))))) (vector 1 0)))))))
(define TTImpC-45ProcessData-calcConInfo (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((TTImpC-45ProcessData-calcNaty arg-0 arg-1 arg-2 arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 ((TTImpC-45ProcessData-calcUnity arg-0 arg-1 arg-2 arg-3) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-6 0) (let ((act-3 ((TTImpC-45ProcessData-calcListy arg-0 arg-1 arg-3) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-7 0) (let ((act-4 ((TTImpC-45ProcessData-calcMaybe arg-0 arg-1 arg-3) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-8 0) (let ((act-5 (TTImpC-45ProcessData-calcEnum arg-0 arg-1 arg-3 clam-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-4) (cond ((equal? e-9 0) (let ((act-6 ((TTImpC-45ProcessData-calcRecord arg-0 arg-1 arg-3) clam-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-5) (cond ((equal? e-10 0) (vector 1 (vector 0 ))) (else (vector 1 (vector 0 ))))))) eff-0) clam-4)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-3)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-2)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-1)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessData-checkRetType (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-2 (vector 10 e-1 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessData-checkRetType arg-1 arg-2 e-10 arg-4))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (arg-4 arg-3)))))))(else (arg-4 arg-3)))))
(define TTImpC-45ProcessData-checkFamily (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (TTImpC-45ProcessData-checkRetType arg-1 arg-5 arg-6 (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((10) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 10 arg-2 arg-3 arg-4) clam-0)) ((3) (let ((e-5 (vector-ref lcase-0 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-5))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 10 arg-2 arg-3 arg-4) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 10 arg-2 arg-3 arg-4) clam-0))))))))
(define TTImpC-45Elab-n--13867-15765-u--bindImpsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (lambda (clam-0) (if (null? arg-19) (vector 1 arg-20) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-6 (car e-2))) (let ((act-1 ((TTImpC-45Elab-n--13867-15765-u--bindImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3 arg-20) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 arg-17 csegen-30 (vector 0 ) (box e-6) (vector 32 arg-17 1) e-5))))) eff-0) clam-0))))))))))))
(define TTImpC-45Elab-n--13867-15764-u--bindImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (case (vector-ref arg-20 0) ((16) (let ((e-1 (vector-ref arg-20 1))) (let ((e-2 (vector-ref arg-20 2))) (let ((e-3 (vector-ref arg-20 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45Elab-n--13867-15765-u--bindImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 16 e-1 e-2 e-5))))) eff-0) eta-0))))))))))(else (TTImpC-45Elab-n--13867-15765-u--bindImpsC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20)))))
(define TTImpC-45Elab-checkTermSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-1 (case (vector-ref arg-8 0) ((0) (CoreC-45Context-branch arg-2 ext-0))(else (let ((act-1 (unbox arg-2))) (vector 1 act-1)))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-3))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Core-u--catch_Catchable_Core_Error (TTImpC-45Elab-elabTermSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (box arg-15)) (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((28) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-1 (vector-ref lcase-0 2))) (let ((e-2 (vector-ref lcase-0 3))) (let ((e-3 (vector-ref lcase-0 4))) (let ((act-4 (let ((act-4 (set-box! arg-2 e-5))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (let ((act-5 (set-box! arg-4 e-6))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (let ((act-6 (set-box! arg-3 e-7))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 ((TTImpC-45Elab-n--13867-15764-u--bindImps arg-0 arg-1 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-0 e-1 e-2 e-3 arg-14) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (TTImpC-45Elab-elabTermSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-11 (box arg-15)))) eff-0) clam-0)))))))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-0))))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (case (vector-ref arg-8 0) ((0) (CoreC-45Context-commit arg-2 eta-3))(else (vector 1 (vector 0 )))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (Builtin-fst e-8)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45Elab-checkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (TTImpC-45Elab-checkTermSub arg-0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-10 (vector 0 ) arg-11 arg-12 ext-0)))
(define CoreC-45Normalise-getValArity (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-2 (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Normalise-getValArity arg-1 arg-2 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (+ e-10 1))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 0)))))))(else (vector 1 0))))))
(define CoreC-45Normalise-getArity (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Normalise-getValArity arg-2 arg-3 e-5))) eff-0) ext-0)))))))
(define CoreC-45Context-resolveName (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (vector 1 e-0)))(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-getPosition arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 ((CoreC-45Context-setCtxt arg-0 e-3) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessData-n--11308-2064-u--updateNSApp (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name e-2 arg-2))) (cond ((equal? sc1 1) (vector 0 e-1 arg-1)) (else (vector 0 e-1 e-2))))))) ((8) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (vector 8 e-4 (TTImpC-45ProcessData-n--11308-2064-u--updateNSApp arg-0 arg-1 arg-2 e-5) e-6))))) ((9) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (vector 9 e-8 (TTImpC-45ProcessData-n--11308-2064-u--updateNSApp arg-0 arg-1 arg-2 e-9) e-10))))) ((10) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (vector 10 e-12 (TTImpC-45ProcessData-n--11308-2064-u--updateNSApp arg-0 arg-1 arg-2 e-13) e-14 e-15))))))(else arg-3))))
(define TTImpC-45ProcessData-updateNS (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (vector 1 e-1 e-2 e-3 e-4 e-5 (TTImpC-45ProcessData-updateNS arg-0 arg-1 e-6)))))))))(else (TTImpC-45ProcessData-n--11308-2064-u--updateNSApp arg-2 arg-1 arg-0 arg-2)))))
(define CoreC-45Core-wrapError (lambda (arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 (arg-1 e-2)))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 e-5))))) arg-2 ext-0)))
(define TTImpC-45ElabC-45Utils-wrapErrorC (lambda (arg-1 arg-2 ext-0) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-2376 1 arg-1))) (cond ((equal? sc0 1) ext-0) (else (lambda (eta-0) (CoreC-45Core-wrapError arg-2 ext-0 eta-0)))))))
(define TTImpC-45ProcessData-checkCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((e-1 (vector-ref arg-12 0))) (let ((e-3 (vector-ref arg-12 2))) (let ((e-4 (vector-ref arg-12 3))) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ty_raw (TTImpC-45ProcessData-updateNS arg-10 arg-11 e-4))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "declare.data.constructor" 5 (lambda () (string-append "Checking constructor type " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--ty_raw))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "declare.data.constructor" 10 (lambda () (string-append "Updated " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-84 (cons arg-10 arg-11)))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-8 0))) e-0)) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-9) (let ((act-6 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 e-1 clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-7 (let ((act-7 (CoreC-45Context-resolveName arg-1 e-5 eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-wrapErrorC arg-6 (lambda (eta-3) (vector 69 e-1 e-5 eta-3)) (lambda (eta-3) (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-11 (vector 0 ) arg-6 arg-7 arg-8 (vector 16 e-1 csegen-2373 u--ty_raw) (CoreC-45NormaliseC-45Eval-gType e-1 e-10) eta-3))))) eff-0) eta-2))))))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-8 (let ((act-8 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-8 arg-8 e-11) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (TTImpC-45ProcessData-checkFamily arg-1 e-1 e-5 arg-11 arg-8 e-12))) eff-0) eta-3))))))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((u--fullty (CoreC-45Env-abstractEnvType arg-0 e-1 arg-8 e-11))) (let ((act-9 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data.constructor" 5 (lambda () (string-append "Constructor " (CoreC-45Name-u--show_Show_Name e-5))) '() u--fullty eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-13 (vector-ref act-9 1))) (vector 0 e-13))) (else (let ((act-10 ((CoreC-45Core-traverse_ (lambda (eta-4) (lambda (eta-5) (CoreC-45Context-addToSave arg-1 eta-4 eta-5))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-11))) eta-3))) (case (vector-ref act-10 0) ((0) (let ((e-14 (vector-ref act-10 1))) (vector 0 e-14))) (else (let ((act-11 (CoreC-45Context-addToSave arg-1 e-5 eta-3))) (case (vector-ref act-11 0) ((0) (let ((e-15 (vector-ref act-11 1))) (vector 0 e-15))) (else (let ((act-12 (CoreC-45ContextC-45Log-log arg-1 "declare.data.constructor" 10 (lambda () (string-append "Saving from " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-11))))))) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-16 (vector-ref act-12 1))) (vector 0 e-16))) (else (let ((act-13 (cond ((equal? arg-9 2) (let ((act-13 (CoreC-45Context-addHashWithNames arg-1 csegen-1357 csegen-54 e-5 eta-3))) (case (vector-ref act-13 0) ((0) (let ((e-17 (vector-ref act-13 1))) (vector 0 e-17))) (else (let ((act-14 (CoreC-45Context-addHashWithNames arg-1 (csegen-1374) csegen-68 u--fullty eta-3))) (case (vector-ref act-14 0) ((0) (let ((e-18 (vector-ref act-14 1))) (vector 0 e-18))) (else (CoreC-45ContextC-45Log-log arg-1 "module.hash" 15 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-4) eta-4) (cons "Adding hash for data constructor: " (cons (CoreC-45Name-u--show_Show_Name e-5) '())))) eta-3))))))))(else (vector 1 (vector 0 )))))) (case (vector-ref act-13 0) ((0) (let ((e-17 (vector-ref act-13 1))) (vector 0 e-17))) (else (let ((act-14 (CoreC-45Normalise-getArity arg-1 '() e-8 '() u--fullty eta-3))) (case (vector-ref act-14 0) ((0) (let ((e-18 (vector-ref act-14 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector e-1 e-5 e-18 u--fullty))))) eff-0) eta-3))))))))))))))))))))))))))) eff-0) eta-2)))))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 e-1 e-5) clam-1))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessData-checkIsType (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (TTImpC-45ProcessData-checkRetType arg-1 arg-4 arg-5 (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((10) (vector 1 (vector 0 )))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 9 arg-2 arg-3) clam-0))))))))
(define LibrariesC-45DataC-45WithDefault-collapseDefaults (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (if (null? arg-4) (vector 1 arg-2) (let ((e-12 (unbox arg-4))) (vector 1 e-12))) (let ((e-2 (unbox arg-3))) (if (null? arg-4) (vector 1 e-2) (let ((e-7 (unbox arg-4))) (let ((sc2 (let ((e-3 (cdr arg-1))) ((e-3 e-2) e-7)))) (cond ((equal? sc2 1) (vector 0 (cons e-2 e-7))) (else (vector 1 e-2))))))))))
(define CoreC-45Context-dropMutData (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-2) (CoreC-45Name-u--C-47C-61_Eq_Name arg-2 arg-1)) e-1) e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ProcessData-getRelevantArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (AlgebraC-45Semiring-branchZero csegen-931 (lambda () (TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (+ arg-2 1) arg-3 arg-4 e-5)) (case (vector-ref e-10 0) ((8) (let ((e-11 (vector-ref e-10 2))) (case (vector-ref e-11 0) ((13) (let ((e-13 (vector-ref e-11 1))) (cond ((equal? e-13 13) (lambda () (lambda (eta-1) (let ((act-3 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (+ arg-2 1) arg-3 0 e-14))) eff-0) eta-1))))))))(else (lambda () (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (let ((act-3 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (+ arg-2 1) (box arg-2) 0 e-14))) eff-0) eta-1))))))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 '())))) arg-3))))))(else (lambda () (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (let ((act-3 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (+ arg-2 1) (box arg-2) 0 e-13))) eff-0) eta-1))))))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 '())))) arg-3))))))(else (lambda () (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (let ((act-3 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-getRelevantArg arg-0 arg-1 (+ arg-2 1) (box arg-2) 0 e-11))) eff-0) eta-1))))))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 '())))) arg-3)))) e-7))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons arg-4 __infixTupleSection-0)) arg-3))))))))(else (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons arg-4 __infixTupleSection-0)) arg-3)))))))
(define TTImpC-45ProcessData-findNewtype (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 (vector 0 )) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (if (null? e-2) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-3 (vector-ref e-1 3))) e-3)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessData-getRelevantArg arg-0 e-5 0 '() 1 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-3 (unbox e-6))) (CoreC-45Context-updateDef arg-0 (let ((e-8 (vector-ref e-1 1))) e-8) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-7 (vector-ref lcase-0 2))) (box (vector 5 e-0 e-7 (box e-3))))))(else '()))) clam-1)))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (vector 1 (vector 0 )))))))))
(define TTImpC-45ProcessData-n--11928-2616-u--getPats (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-5 (vector-ref arg-3 5))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45NormaliseC-45Eval-evalClosure arg-1 '() arg-2 (Builtin-snd eta-0))) e-5 '())))(else (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45ProcessData-n--11928-2617-u--getRetType (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ProcessData-n--11928-2617-u--getRetType arg-0 arg-1 arg-2 e-5))) eff-0) clam-0))))))(else (vector 1 arg-3)))))))(else (vector 1 arg-3))))))
(define TTImpC-45ProcessData-getIndexPats (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ProcessData-n--11928-2617-u--getRetType arg-1 arg-0 e-5 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-n--11928-2616-u--getPats arg-1 arg-0 e-5 e-7))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define DataC-45List-n--8477-8928-u--spreadHeads (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? arg-4) (cons (cons e-2 '()) (DataC-45List-n--8477-8928-u--spreadHeads arg-1 arg-2 e-3 '())) (let ((e-6 (car arg-4))) (let ((e-7 (cdr arg-4))) (cons (cons e-2 e-6) (DataC-45List-n--8477-8928-u--spreadHeads arg-1 arg-2 e-3 e-7))))))))))
(define DataC-45List-transpose (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (DataC-45List-n--8477-8928-u--spreadHeads e-2 e-3 e-2 (DataC-45List-transpose e-3)))))))
(define TTImpC-45ProcessData-n--12048-2757-u--disjointArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (lambda (eta-0) (vector 1 0)) (if (null? arg-4) (lambda (eta-0) (vector 1 0)) (lambda (clam-0) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (let ((act-1 ((TTImpC-45ProcessData-n--12048-2756-u--disjoint arg-0 arg-1 arg-2 e-1 e-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-6 1) (lambda (eta-0) (vector 1 1))) (else (TTImpC-45ProcessData-n--12048-2757-u--disjointArgs arg-0 arg-1 arg-2 e-2 e-5))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ProcessData-n--12048-2756-u--disjoint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((2) (let ((e-3 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((2) (let ((e-18 (vector-ref arg-4 3))) (let ((e-20 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-3 e-18))) (cond ((equal? sc2 1) (vector 1 1)) (else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-6 (Builtin-snd eta-1))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-6 (Builtin-snd eta-2))) e-20 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-n--12048-2757-u--disjointArgs arg-0 arg-1 arg-2 e-7 e-8))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))(else (vector 1 0))))))) ((3) (let ((e-8 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-23 (vector-ref arg-4 2))) (let ((e-26 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-8 e-23))) (cond ((equal? sc2 1) (vector 1 1)) (else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-5 (Builtin-snd eta-1))) e-11 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() e-5 (Builtin-snd eta-2))) e-26 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessData-n--12048-2757-u--disjointArgs arg-0 arg-1 arg-2 e-6 e-12))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))))(else (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (let ((e-29 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-14 e-29))))(else (vector 1 0))))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessData-n--12048-2755-u--allDisjointWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 1)) (lambda (clam-0) (case (vector-ref arg-3 0) ((9) (vector 1 0))(else (let ((e-1 (car arg-4))) (let ((e-2 (cdr arg-4))) (let ((act-1 ((TTImpC-45ProcessData-n--12048-2756-u--disjoint arg-0 arg-1 arg-2 arg-3 e-1) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (TTImpC-45ProcessData-n--12048-2755-u--allDisjointWith arg-0 arg-1 arg-2 arg-3 e-2)) (else (lambda (eta-0) (vector 1 0)))))) eff-0) clam-0)))))))))))))
(define TTImpC-45ProcessData-n--12048-2754-u--allDisjoint (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 1) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((9) (vector 1 0))(else (let ((act-1 ((TTImpC-45ProcessData-n--12048-2754-u--allDisjoint arg-0 arg-1 arg-2 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (TTImpC-45ProcessData-n--12048-2755-u--allDisjointWith arg-0 arg-1 arg-2 e-2 e-3)) (else (lambda (eta-0) (vector 1 0)))))) eff-0) clam-0)))))))))))))
(define TTImpC-45ProcessData-n--12048-2758-u--getDisjointPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (TTImpC-45ProcessData-n--12048-2758-u--getDisjointPos arg-0 arg-1 arg-2 (+ arg-3 1) e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ProcessData-n--12048-2754-u--allDisjoint arg-0 arg-1 arg-2 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-6 1) (vector 1 (cons arg-3 e-5))) (else (vector 1 e-5)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessData-getDetags (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) (vector 1 (box '())) (let ((e-3 (cdr arg-2))) (if (null? e-3) (vector 1 (box '())) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessData-getIndexPats arg-0 eta-0 eta-1))) arg-2 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ProcessData-n--12048-2758-u--getDisjointPos arg-2 arg-1 arg-0 0 (DataC-45List-transpose e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (vector 1 (box e-6)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))
(define CoreC-45Context-n--27134-22386-u--getPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((3) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (case (vector-ref e-4 0) ((2) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-832 e-3 arg-6))) (cond ((equal? sc2 1) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-n--27134-22386-u--getPos arg-0 arg-1 arg-2 arg-3 (+ arg-5 1) (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-4) (CoreC-45Name-u--C-47C-61_Eq_Name arg-4 e-3)) arg-6) e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons arg-5 e-6))))) eff-0) eta-0))))))) (else (CoreC-45Context-n--27134-22386-u--getPos arg-0 arg-1 arg-2 arg-3 (+ arg-5 1) arg-6 e-5)))))(else (lambda (clam-0) (if (null? arg-6) (vector 1 '()) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Unknown determining arguments: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) arg-6)))) clam-0)))))))))(else (lambda (clam-1) (if (null? arg-6) (vector 1 '()) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append "Unknown determining arguments: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) arg-6)))) clam-1)))))))
(define CoreC-45Context-setDetermining (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (clam-0) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((6) (let ((e-33 (vector-ref e-18 1))) (let ((e-32 (vector-ref e-18 2))) (let ((e-31 (vector-ref e-18 3))) (let ((e-29 (vector-ref e-18 5))) (let ((e-28 (vector-ref e-18 6))) (let ((e-27 (vector-ref e-18 7))) (let ((e-26 (vector-ref e-18 8))) (let ((act-3 ((CoreC-45Context-n--27134-22386-u--getPos arg-3 arg-2 arg-1 arg-0 0 arg-3 (let ((e-54 (vector-ref e-1 2))) e-54)) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-34 (vector-ref act-3 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-2) (box (vector 6 e-33 e-32 e-31 e-34 e-29 e-28 e-27 e-26))) eta-1)))) eff-0) clam-0)))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append (CoreC-45Name-u--show_Show_Name (let ((e-47 (vector-ref e-1 1))) e-47)) " is not a type constructor [setDetermining]")) clam-0))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-case--caseC-32blockC-32inC-32setExternal-22995 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((6) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((e-3 (vector-ref arg-7 4))) (let ((e-4 (vector-ref arg-7 5))) (let ((e-5 (vector-ref arg-7 6))) (let ((e-6 (vector-ref arg-7 7))) (let ((e-7 (vector-ref arg-7 8))) (let ((u--flC-39 (let ((e-9 (car e-4))) (cons e-9 arg-0)))) (lambda (eta-0) (CoreC-45Context-updateDef arg-3 arg-1 (lambda (eta-1) (box (vector 6 e-0 e-1 e-2 e-3 u--flC-39 e-5 e-6 e-7))) eta-0))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-5 1))) e-1)) " is not a type constructor [setDetermining]")) eta-0))))))
(define CoreC-45Context-setExternal (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CoreC-45Context-case--caseC-32blockC-32inC-32setExternal-22995 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-case--caseC-32blockC-32inC-32setUniqueSearch-22837 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((6) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((e-3 (vector-ref arg-7 4))) (let ((e-4 (vector-ref arg-7 5))) (let ((e-5 (vector-ref arg-7 6))) (let ((e-6 (vector-ref arg-7 7))) (let ((e-7 (vector-ref arg-7 8))) (let ((u--flC-39 (let ((e-8 (cdr e-4))) (cons arg-0 e-8)))) (lambda (eta-0) (CoreC-45Context-updateDef arg-3 arg-1 (lambda (eta-1) (box (vector 6 e-0 e-1 e-2 e-3 u--flC-39 e-5 e-6 e-7))) eta-0))))))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 (string-append (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-5 1))) e-1)) " is not a type constructor [setDetermining]")) eta-0))))))
(define CoreC-45Context-setUniqueSearch (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (CoreC-45Context-case--caseC-32blockC-32inC-32setUniqueSearch-22837 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessData-processDataOpt (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((1) (vector 1 (vector 0 ))) ((0) (let ((e-0 (vector-ref arg-3 1))) (CoreC-45Context-setDetermining arg-0 arg-1 arg-2 e-0 ext-0))) ((2) (CoreC-45Context-setUniqueSearch arg-0 arg-1 arg-2 1 ext-0)) ((3) (CoreC-45Context-setExternal arg-0 arg-1 arg-2 1 ext-0)) (else (vector 1 (vector 0 ))))))
(define CoreC-45Context-setDetags (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (lambda (clam-0) (case (vector-ref e-18 0) ((6) (let ((e-33 (vector-ref e-18 1))) (let ((e-32 (vector-ref e-18 2))) (let ((e-31 (vector-ref e-18 3))) (let ((e-30 (vector-ref e-18 4))) (let ((e-29 (vector-ref e-18 5))) (let ((e-28 (vector-ref e-18 6))) (let ((e-27 (vector-ref e-18 7))) (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-1) (box (vector 6 e-33 e-32 e-31 e-30 e-29 e-28 e-27 arg-3))) clam-0)))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append (CoreC-45Name-u--show_Show_Name (let ((e-47 (vector-ref e-1 1))) e-47)) " is not a type constructor [setDetermining]")) clam-0))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setMutWith (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((e-18 (vector-ref e-1 18))) (lambda (clam-0) (case (vector-ref e-18 0) ((6) (let ((e-33 (vector-ref e-18 1))) (let ((e-32 (vector-ref e-18 2))) (let ((e-31 (vector-ref e-18 3))) (let ((e-30 (vector-ref e-18 4))) (let ((e-29 (vector-ref e-18 5))) (let ((e-27 (vector-ref e-18 7))) (let ((e-26 (vector-ref e-18 8))) (CoreC-45Context-updateDef arg-0 arg-2 (lambda (eta-1) (box (vector 6 e-33 e-32 e-31 e-30 e-29 arg-3 e-27 e-26))) clam-0)))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append (CoreC-45Name-u--show_Show_Name (let ((e-47 (vector-ref e-1 1))) e-47)) " is not a type constructor [setMutWith]")) clam-0))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Utils-updateErasable (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (let ((act-3 (TTImpC-45ElabC-45Utils-findErased arg-0 (let ((e-2 (vector-ref e-1 2))) e-2) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 arg-1 (let ((e-0 (vector-ref e-1 0))) (let ((e-28 (vector-ref e-1 1))) (let ((e-27 (vector-ref e-1 2))) (let ((e-25 (vector-ref e-1 5))) (let ((e-24 (vector-ref e-1 6))) (let ((e-23 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-28 e-27 e-2 e-3 e-25 e-24 e-23 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22)))))))))))))))))))))) eta-1)) clam-1)))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TT-u--compare_Ord_Visibility (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 1) 0) ((equal? arg-1 2) 0) (else 1))) ((equal? arg-0 1) (cond ((equal? arg-1 2) 0) ((equal? arg-1 1) 1) (else 2))) (else (cond ((equal? arg-1 2) 1) ((equal? arg-1 0) 2) (else 2))))))
(define CoreC-45TT-u--C-62_Ord_Visibility (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Ordering (CoreC-45TT-u--compare_Ord_Visibility arg-0 arg-1) 2)))
(define CoreC-45TT-u--max_Ord_Visibility (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45TT-u--C-62_Ord_Visibility arg-0 arg-1))) (cond ((equal? sc0 1) arg-0) (else arg-1)))))
(define TTImpC-45ProcessData-case--caseC-32blockC-32inC-32processData-7305 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (lambda (clam-0) (case (vector-ref arg-24 0) ((1) (let ((e-2 (vector-ref arg-24 1))) (vector 1 e-2))) (else (let ((e-5 (vector-ref arg-24 1))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((act-1 ((CoreC-45Context-recordWarning arg-16 (vector 3 arg-7 e-8 e-9 arg-17)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45TT-u--max_Ord_Visibility e-8 e-9)))))))))))))
(define TTImpC-45ProcessData-processData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (case (vector-ref arg-12 0) ((1) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-9 '() arg-0 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-9 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (CoreC-45Context-resolveName arg-1 e-5 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-wrapErrorC arg-6 (lambda (eta-4) (vector 69 arg-9 e-5 eta-4)) (TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10 (vector 0 ) arg-6 arg-7 arg-8 (vector 16 arg-9 csegen-2373 e-6) (box (CoreC-45NormaliseC-45Eval-gType e-1 e-9)))))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((e-11 (car e-10))) (let ((u--fullty (CoreC-45Env-abstractEnvType arg-0 e-1 arg-8 e-11))) (lambda (eta-4) (let ((act-7 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" 5 (lambda () (string-append "data " (CoreC-45Name-u--show_Show_Name e-5))) '() u--fullty eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((act-8 (let ((act-8 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-7 arg-8 e-11) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-8 1))) ((let ((eff-0 (TTImpC-45ProcessData-checkIsType arg-1 arg-9 e-5 arg-8 e-13))) eff-0) eta-4))))))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (let ((act-9 (CoreC-45Normalise-getArity arg-1 '() e-7 '() u--fullty eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-14 (vector-ref act-9 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-10 (CoreC-45Context-addDef arg-1 e-5 (CoreC-45Context-newDef arg-9 e-5 csegen-1416 arg-0 u--fullty arg-10 (vector 6 0 e-14 '() '() CoreC-45ContextC-45Context-defaultFlags '() '() '())) eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-15 (vector-ref act-10 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-11 ((CoreC-45Context-addMutData arg-1 (vector 8 e-15)) eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-16 (vector-ref act-11 1))) (vector 0 e-16))) (else (let ((act-12 (let ((act-12 (unbox arg-1))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-17 (vector-ref act-12 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-13 ((CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-8) (CoreC-45Context-setMutWith arg-1 arg-9 u--n (let ((e-49 (vector-ref e-17 1))) e-49) eta-8))) (let ((e-49 (vector-ref e-17 1))) e-49)) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-18 (vector-ref act-13 1))) (vector 0 e-18))) (else (let ((act-14 ((CoreC-45Core-traverse_ (lambda (eta-8) (lambda (eta-9) (CoreC-45Context-addToSave arg-1 eta-8 eta-9))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-11))) eta-7))) (case (vector-ref act-14 0) ((0) (let ((e-19 (vector-ref act-14 1))) (vector 0 e-19))) (else (let ((act-15 (CoreC-45Context-addToSave arg-1 e-5 eta-7))) (case (vector-ref act-15 0) ((0) (let ((e-20 (vector-ref act-15 1))) (vector 0 e-20))) (else (let ((act-16 (CoreC-45ContextC-45Log-log arg-1 "declare.data" 10 (lambda () (string-append "Saving from " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-11))))))) eta-7))) (case (vector-ref act-16 0) ((0) (let ((e-21 (vector-ref act-16 1))) (vector 0 e-21))) (else (let ((sc19 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 arg-10))) (cond ((equal? sc19 0) (vector 1 (vector 0 )))(else (let ((act-17 (CoreC-45Context-addHashWithNames arg-1 csegen-1357 csegen-54 e-5 eta-7))) (case (vector-ref act-17 0) ((0) (let ((e-22 (vector-ref act-17 1))) (vector 0 e-22))) (else (let ((act-18 (CoreC-45Context-addHashWithNames arg-1 (csegen-1374) csegen-68 u--fullty eta-7))) (case (vector-ref act-18 0) ((0) (let ((e-23 (vector-ref act-18 1))) (vector 0 e-23))) (else (CoreC-45ContextC-45Log-log arg-1 "module.hash" 15 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-8) eta-8) (cons "Adding hash for data declaration with name " (cons (CoreC-45Name-u--show_Show_Name e-5) '())))) eta-7))))))))))))))))))))))))) eff-0) eta-6))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))))))))))) eff-0) eta-3)))))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-5) clam-1))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) (else (let ((e-5 (vector-ref arg-12 1))) (let ((e-6 (vector-ref arg-12 2))) (let ((e-7 (vector-ref arg-12 3))) (let ((e-8 (vector-ref arg-12 4))) (let ((e-9 (vector-ref arg-12 5))) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 e-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "declare.data" 1 (lambda () (string-append "Processing " (CoreC-45Name-u--show_Show_Name e-10))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (if (null? eta-3) (lambda (eta-4) (vector 1 '())) (let ((e-2 (unbox eta-3))) (let ((eff-0 (eta-2 e-2))) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-4))))))) e-7 (lambda (u--ty_raw) (lambda (eta-2) (let ((act-4 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-9 '() arg-0 u--ty_raw eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-9 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 (CoreC-45Context-resolveName arg-1 e-10 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-wrapErrorC arg-6 (lambda (eta-5) (vector 69 arg-9 e-10 eta-5)) (TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-15 (vector 0 ) arg-6 arg-7 arg-8 (vector 16 arg-9 csegen-2373 e-13) (box (CoreC-45NormaliseC-45Eval-gType e-5 e-14)))))) eff-0) eta-4))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-15))) (let ((act-7 (let ((act-7 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-12 arg-8 e-2) clam-2))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-7 1))) ((let ((eff-0 (TTImpC-45ProcessData-checkIsType arg-1 arg-9 e-10 arg-8 e-16))) eff-0) clam-2))))))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (vector 1 (cons (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-2)) (CoreC-45Env-abstractEnvType arg-0 e-5 arg-8 e-2)))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--metas (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-2) (Builtin-fst eta-2))) e-13))) (let ((u--mfullty (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (Builtin-snd eta-2)) e-13))) (lambda (eta-2) (let ((act-5 ((CoreC-45Context-lookupCtxtExact e-10 (let ((e-0 (vector-ref e-12 0))) e-0)) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (if (null? e-14) (if (null? u--mfullty) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-9 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-4) eta-4) (cons "Missing telescope for data definition " (cons (CoreC-45Name-u--show_Show_Name e-6) '())))) eta-3) (let ((e-2 (unbox u--mfullty))) (vector 1 (cons '() (cons (LibrariesC-45DataC-45WithDefault-collapseDefault 0 arg-10) e-2))))) (let ((e-2 (unbox e-14))) (let ((act-6 (let ((u--ndefm (box e-2))) ((TTImpC-45ProcessData-case--caseC-32blockC-32inC-32processData-7305 e-9 e-8 e-7 e-6 e-5 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-10 e-12 e-13 u--metas u--mfullty e-2 u--ndefm (LibrariesC-45DataC-45WithDefault-collapseDefaults (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45TT-u--C-61C-61_Eq_Visibility arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45TT-u--C-47C-61_Eq_Visibility arg-686 arg-689)))) 0 (let ((e-28 (vector-ref e-2 9))) e-28) arg-10)) eta-3)))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (let ((e-18 (vector-ref e-2 18))) (case (vector-ref e-18 0) ((6) (let ((e-37 (vector-ref e-18 6))) (let ((e-36 (vector-ref e-18 7))) (lambda (clam-0) (if (null? e-36) (if (null? u--mfullty) (vector 1 (cons e-37 (cons e-15 (let ((e-63 (vector-ref e-2 2))) e-63)))) (let ((e-43 (unbox u--mfullty))) (let ((act-7 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-1 '() e-12 '() e-43 (let ((e-64 (vector-ref e-2 2))) e-64) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-44 (vector-ref act-7 1))) (vector 0 e-44))) (else (let ((e-44 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-4) (cond ((equal? e-44 1) (vector 1 (cons e-37 (cons e-15 e-43)))) (else (let ((act-8 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" 1 (lambda () "Previous") '() (let ((e-65 (vector-ref e-2 2))) e-65) clam-4))) (case (vector-ref act-8 0) ((0) (let ((e-45 (vector-ref act-8 1))) (vector 0 e-45))) (else (let ((act-9 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" 1 (lambda () "Now") '() e-43 clam-4))) (case (vector-ref act-9 0) ((0) (let ((e-46 (vector-ref act-9 1))) (vector 0 e-46))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-10) clam-4)))))))))))) eff-0) clam-0))))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-10) clam-0))))))(else (lambda (eta-4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-10) eta-4))))))) eff-0) eta-3))))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-15))) (let ((e-3 (cdr e-15))) (let ((e-17 (car e-3))) (let ((e-16 (cdr e-3))) (let ((act-7 (CoreC-45Normalise-logTermNF '() arg-1 "declare.data" 5 (lambda () (string-append "data " (CoreC-45Name-u--show_Show_Name e-10))) '() e-16 clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45Normalise-getArity arg-1 '() e-12 '() e-16 clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-9 (CoreC-45Context-addDef arg-1 e-10 (CoreC-45Context-newDef arg-9 e-10 csegen-1416 arg-0 e-16 (LibrariesC-45DataC-45WithDefault-specified e-17) (vector 6 0 e-19 '() '() CoreC-45ContextC-45Context-defaultFlags '() '() '())) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-10 (cond ((equal? e-17 0) (vector 1 (vector 0 )))(else (let ((act-10 (CoreC-45Context-addHashWithNames arg-1 csegen-1357 csegen-54 e-10 eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 (CoreC-45Context-addHashWithNames arg-1 (csegen-1374) csegen-68 e-16 eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (CoreC-45ContextC-45Log-log arg-1 "module.hash" 15 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-6) eta-6) (cons "Adding hash for data declaration with name " (cons (CoreC-45Name-u--show_Show_Name e-10) '())))) eta-5))))))))))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((u--cvis (let ((sc13 (CoreC-45TT-u--C-61C-61_Eq_Visibility e-17 1))) (cond ((equal? sc13 1) 0) (else e-17))))) (let ((act-11 ((CoreC-45Core-traverseC-39 (lambda (eta-6) (lambda (eta-7) (TTImpC-45ProcessData-checkCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--cvis e-6 (vector 8 e-20) eta-6 eta-7))) e-9 '()) eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-11 1))) ((let ((eff-0 (let ((u--ddef (cons (vector e-5 e-10 e-19 e-16) e-22))) (lambda (eta-6) (let ((act-12 (PreludeC-45IO-u--map_Functor_IO csegen-26 (CoreC-45ContextC-45Data-addData arg-1 arg-0 e-17 e-20 u--ddef) eta-6))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((act-13 (let ((sc15 (PreludeC-45Types-elem csegen-14 csegen-2850 (vector 4 ) e-8))) (cond ((equal? sc15 1) (vector 1 (vector 0 ))) (else ((TTImpC-45ProcessData-findNewtype arg-1 e-22) eta-6)))))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((act-14 (let ((act-14 (unbox arg-1))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-7) (let ((act-15 (CoreC-45ContextC-45Log-log arg-1 "declare.data" 3 (lambda () (string-append (CoreC-45Name-u--show_Show_Name e-10) (string-append " defined in a mutual block with " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-2)))) eta-7))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((act-16 (CoreC-45Context-setMutWith arg-1 arg-9 (vector 8 e-20) e-2 eta-7))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((act-17 ((CoreC-45Core-traverse_ (lambda (eta-8) (lambda (eta-9) (TTImpC-45ProcessData-processDataOpt arg-1 arg-9 (vector 8 e-20) eta-8 eta-9))) e-8) eta-7))) (case (vector-ref act-17 0) ((0) (let ((e-4 (vector-ref act-17 1))) (vector 0 e-4))) (else (let ((act-18 ((CoreC-45Context-dropMutData arg-1 (vector 8 e-20)) eta-7))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (let ((act-19 ((TTImpC-45ProcessData-getDetags arg-1 arg-9 (PreludeC-45TypesC-45List-mapAppend '() csegen-2851 e-22)) eta-7))) (case (vector-ref act-19 0) ((0) (let ((e-4 (vector-ref act-19 1))) (vector 0 e-4))) (else (let ((e-30 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-20 (CoreC-45Context-setDetags arg-1 arg-9 (vector 8 e-20) e-30 eta-8))) (case (vector-ref act-20 0) ((0) (let ((e-4 (vector-ref act-20 1))) (vector 0 e-4))) (else (let ((act-21 ((CoreC-45Core-traverse_ (lambda (eta-9) (lambda (eta-10) (CoreC-45Context-addToSave arg-1 eta-9 eta-10))) u--metas) eta-8))) (case (vector-ref act-21 0) ((0) (let ((e-4 (vector-ref act-21 1))) (vector 0 e-4))) (else (let ((act-22 (CoreC-45Context-addToSave arg-1 e-10 eta-8))) (case (vector-ref act-22 0) ((0) (let ((e-4 (vector-ref act-22 1))) (vector 0 e-4))) (else (let ((act-23 (CoreC-45ContextC-45Log-log arg-1 "declare.data" 10 (lambda () (string-append "Saving from " (string-append (CoreC-45Name-u--show_Show_Name e-10) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 u--metas))))) eta-8))) (case (vector-ref act-23 0) ((0) (let ((e-4 (vector-ref act-23 1))) (vector 0 e-4))) (else (let ((u--connames (PreludeC-45TypesC-45List-mapAppend '() csegen-2852 e-22))) (let ((act-24 (let ((sc26 (PreludeC-45Types-elem csegen-14 csegen-2850 (vector 1 ) e-8))) (cond ((equal? sc26 1) (vector 1 (vector 0 ))) (else ((CoreC-45Core-traverse_ (lambda (u--x) (lambda (eta-9) (CoreC-45Context-addHintFor arg-1 arg-9 (vector 8 e-20) u--x 1 0 eta-9))) u--connames) eta-8)))))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (TTImpC-45ProcessData-calcConInfo arg-1 arg-9 (vector 8 e-20) e-22 eta-8))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else (let ((act-26 ((CoreC-45Core-traverse_ (lambda (eta-9) (lambda (eta-10) (TTImpC-45ElabC-45Utils-updateErasable arg-1 eta-9 eta-10))) (cons (vector 8 e-20) u--connames)) eta-8))) (case (vector-ref act-26 0) ((0) (let ((e-4 (vector-ref act-26 1))) (vector 0 e-4))) (else (if (null? arg-11) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-11))) (let ((act-27 (CoreC-45ContextC-45Log-log arg-1 "declare.data" 5 (lambda () (string-append "setting totality flag for " (string-append (CoreC-45Name-u--show_Show_Name e-10) " and its constructors"))) eta-8))) (case (vector-ref act-27 0) ((0) (let ((e-4 (vector-ref act-27 1))) (vector 0 e-4))) (else ((PreludeC-45Basics-flip csegen-63 (cons e-10 (PreludeC-45TypesC-45List-mapAppend '() csegen-2852 e-22)) (lambda (u--n) (lambda (eta-9) (CoreC-45Context-setFlag arg-1 arg-9 u--n (vector 6 e-1) eta-9)))) eta-8))))))))))))))))))))))))))))))) eff-0) eta-7)))))))))))))))))))) eff-0) eta-6)))))))))))))) eff-0) eta-5)))))))))))) eff-0) eta-4)))))))) eff-0) clam-1))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) eff-0) ext-0))))))))))))))
(define CoreC-45CaseC-45CaseTree-n--7868-11012-u--getAltSet (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45CaseC-45CaseTree-n--7868-11014-u--getSet arg-1 arg-2 arg-3 arg-5 e-4))) ((1) (let ((e-8 (vector-ref arg-6 3))) (CoreC-45CaseC-45CaseTree-n--7868-11014-u--getSet arg-1 arg-2 arg-3 arg-5 e-8))) ((2) (let ((e-11 (vector-ref arg-6 2))) (CoreC-45CaseC-45CaseTree-n--7868-11014-u--getSet arg-1 arg-2 arg-3 arg-5 e-11))) (else (let ((e-13 (vector-ref arg-6 1))) (CoreC-45CaseC-45CaseTree-n--7868-11014-u--getSet arg-1 arg-2 arg-3 arg-5 e-13))))))
(define CoreC-45CaseC-45CaseTree-n--7868-11013-u--getAltSets (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (CoreC-45CaseC-45CaseTree-n--7868-11013-u--getAltSets arg-1 arg-2 arg-3 (CoreC-45CaseC-45CaseTree-n--7868-11012-u--getAltSet arg-1 arg-2 arg-3 arg-5 e-2) e-3))))))
(define CoreC-45CaseC-45CaseTree-n--7868-11014-u--getSet (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-5 (vector-ref arg-6 4))) (CoreC-45CaseC-45CaseTree-n--7868-11013-u--getAltSets arg-1 arg-2 arg-3 arg-5 e-5))) ((1) (let ((e-8 (vector-ref arg-6 2))) (((arg-3 'erased) arg-5) e-8))) ((2) arg-5) (else arg-5))))
(define CoreC-45CaseC-45CaseTree-getNames (lambda (arg-1 arg-2 arg-3) (CoreC-45CaseC-45CaseTree-n--7868-11014-u--getSet arg-3 arg-2 arg-1 arg-2 arg-3)))
(define CoreC-45CaseC-45CaseTree-addRefs (lambda (arg-1 arg-2 ext-0) (CoreC-45CaseC-45CaseTree-getNames (lambda (vs-11133) (lambda (eta-0) (lambda (eta-1) (CoreC-45TT-addRefs 0 arg-1 eta-0 eta-1)))) arg-2 ext-0)))
(define CoreC-45CaseC-45CaseTree-getMetas (lambda (ext-0) (CoreC-45CaseC-45CaseTree-getNames (lambda (vs-11147) (lambda (eta-0) (lambda (eta-1) (CoreC-45TT-addMetas 0 eta-0 eta-1)))) LibrariesC-45DataC-45NameMap-empty ext-0)))
(define TTImpC-45ProcessDef-n--24873-14622-u--dropErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-4) (vector 1 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (TTImpC-45ProcessDef-n--24873-14622-u--dropErased arg-0 arg-1 arg-2 arg-3 e-3 arg-5 eta-1)) (let ((e-1 (unbox e-6))) (let ((sc4 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (let ((e-7 (vector-ref e-1 7))) e-7) csegen-30))) (cond ((equal? sc4 1) (lambda (eta-1) (TTImpC-45ProcessDef-n--24873-14622-u--dropErased arg-0 arg-1 arg-2 arg-3 e-3 arg-5 eta-1))) (else (lambda (eta-1) (TTImpC-45ProcessDef-n--24873-14622-u--dropErased arg-0 arg-1 arg-2 arg-3 e-3 (LibrariesC-45DataC-45NameMap-delete e-2 arg-5) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32calcRefs-14787 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) (let ((e-2 (vector-ref arg-7 3))) (let ((e-3 (vector-ref arg-7 4))) (let ((u--refs (cond ((equal? arg-2 1) (let ((e-14 (vector-ref arg-5 14))) e-14)) (else (let ((e-13 (vector-ref arg-5 13))) e-13))))) (if (null? u--refs) (let ((u--tree (cond ((equal? arg-2 1) e-3) (else e-2)))) (let ((u--metas (CoreC-45CaseC-45CaseTree-getMetas u--tree))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-addToSave arg-3 eta-1 eta-2))) (LibrariesC-45DataC-45NameMap-keys u--metas)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((u--refs_all (CoreC-45CaseC-45CaseTree-addRefs arg-1 u--metas u--tree))) (let ((act-2 (cond ((equal? arg-2 1) (TTImpC-45ProcessDef-n--24873-14622-u--dropErased arg-0 arg-1 arg-2 arg-3 (LibrariesC-45DataC-45NameMap-keys u--refs_all) u--refs_all eta-0)) (else (vector 1 u--refs_all))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (clam-0) (cond ((equal? arg-2 1) (CoreC-45Context-addDef arg-3 arg-0 (let ((e-29 (vector-ref arg-5 0))) (let ((e-28 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-26 (vector-ref arg-5 3))) (let ((e-25 (vector-ref arg-5 4))) (let ((e-24 (vector-ref arg-5 5))) (let ((e-23 (vector-ref arg-5 6))) (let ((e-7 (vector-ref arg-5 7))) (let ((e-8 (vector-ref arg-5 8))) (let ((e-9 (vector-ref arg-5 9))) (let ((e-10 (vector-ref arg-5 10))) (let ((e-11 (vector-ref arg-5 11))) (let ((e-12 (vector-ref arg-5 12))) (let ((e-13 (vector-ref arg-5 13))) (let ((e-15 (vector-ref arg-5 15))) (let ((e-16 (vector-ref arg-5 16))) (let ((e-17 (vector-ref arg-5 17))) (let ((e-18 (vector-ref arg-5 18))) (let ((e-19 (vector-ref arg-5 19))) (let ((e-20 (vector-ref arg-5 20))) (let ((e-21 (vector-ref arg-5 21))) (let ((e-22 (vector-ref arg-5 22))) (vector e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (box e-6) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) clam-0)) (else (CoreC-45Context-addDef arg-3 arg-0 (let ((e-29 (vector-ref arg-5 0))) (let ((e-28 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-26 (vector-ref arg-5 3))) (let ((e-25 (vector-ref arg-5 4))) (let ((e-24 (vector-ref arg-5 5))) (let ((e-23 (vector-ref arg-5 6))) (let ((e-7 (vector-ref arg-5 7))) (let ((e-8 (vector-ref arg-5 8))) (let ((e-9 (vector-ref arg-5 9))) (let ((e-10 (vector-ref arg-5 10))) (let ((e-11 (vector-ref arg-5 11))) (let ((e-12 (vector-ref arg-5 12))) (let ((e-14 (vector-ref arg-5 14))) (let ((e-15 (vector-ref arg-5 15))) (let ((e-16 (vector-ref arg-5 16))) (let ((e-17 (vector-ref arg-5 17))) (let ((e-18 (vector-ref arg-5 18))) (let ((e-19 (vector-ref arg-5 19))) (let ((e-20 (vector-ref arg-5 20))) (let ((e-21 (vector-ref arg-5 21))) (let ((e-22 (vector-ref arg-5 22))) (vector e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 (box e-6) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) clam-0)))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (TTImpC-45ProcessDef-calcRefs arg-3 arg-2 arg-1 eta-2 eta-3))) (LibrariesC-45DataC-45NameMap-keys e-6)) eta-1))))))) eff-0) eta-0)))))))))))) (lambda (eta-0) (vector 1 (vector 0 ))))))))(else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define TTImpC-45ProcessDef-calcRefs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32calcRefs-14787 arg-3 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TerminationC-45CallGraph-delazy (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((6) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((u--tmC-39 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-3))) (cond ((equal? e-2 0) (vector 6 e-1 e-2 u--tmC-39))(else u--tmC-39))))))) ((7) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((u--tyC-39 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-7))) (let ((u--tmC-39 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-8))) (cond ((equal? e-6 0) (vector 7 e-5 e-6 u--tyC-39 u--tmC-39))(else u--tmC-39))))))))) ((8) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (cond ((equal? e-11 0) (vector 8 e-10 e-11 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-12)))(else (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-12))))))) ((2) (let ((e-14 (vector-ref arg-2 1))) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (let ((e-17 (vector-ref arg-2 4))) (vector 2 e-14 e-15 e-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-delazy arg-1 eta-0)) e-17))))))) ((3) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (vector 3 e-19 e-20 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-delazy arg-1 eta-0)) e-21) (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-22))))))) ((4) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (vector 4 e-24 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-25) (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-26)))))) ((5) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (vector 5 e-28 e-29 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-30) (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-31)))))))(else arg-2))))
(define CoreC-45TerminationC-45CallGraph-n--8811-9909-u--findSCbinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-3 (vector-ref arg-10 3))) (CoreC-45TerminationC-45CallGraph-findSC arg-1 arg-9 arg-8 arg-7 arg-6 arg-5 e-3)))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45TerminationC-45CallGraph-n--8811-9983-u--conIfGuarded (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (case (vector-ref e-2 0) ((1) (let ((act-1 (let ((act-1 (unbox arg-6))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (vector 1 e-1 (vector 1 ) e-3)) (let ((e-4 (unbox e-6))) (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 10 ) (let ((e-12 (vector-ref e-4 12))) e-12)))) (cond ((equal? sc5 1) (vector 1 (vector 1 e-1 (vector 2 0 0) e-3))) (else (vector 1 (vector 1 e-1 (vector 1 ) e-3)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 arg-7)))))))(else (vector 1 arg-7))))))
(define CoreC-45Normalise-normaliseOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-3 arg-4 e-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Value-withArgHoles (vector 0 1 0 0 0 '() '() 1))
(define CoreC-45Value-tcOnly (let ((sc0 CoreC-45Value-withArgHoles)) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (vector e-0 e-1 e-2 e-3 1 e-5 e-6 e-7))))))))))
(define CoreC-45TerminationC-45CallGraph-findInCase (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality" 10 (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 csegen-68 eta-1 eta-2))) e-10 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "Looking in case args " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-2 u--d u--x)))) e-5)))))) eff-0) eta-0)))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Normalise-logTermNF e-2 arg-0 "totality" 10 (lambda () "        =") e-6 e-11 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45Normalise-normaliseOpts arg-0 e-2 CoreC-45Value-tcOnly arg-1 e-6 e-11 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45TerminationC-45CallGraph-findSC e-2 arg-0 arg-1 e-6 arg-2 e-10 (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-9)))) eff-0) clam-0))))))))))))))))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-n--4363-1511-u--go (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (let ((sc2 (Builtin-fst arg-1))) (let ((e-1 (car sc2))) ((e-1 e-2) (let ((sc3 (Builtin-snd arg-1))) (let ((e-7 (vector-ref sc3 1))) e-7))))))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45SparseMatrixC-45Vector-n--4363-1511-u--go arg-1 (+ arg-2 1) e-3)) (else (cons (cons arg-2 e-2) (LibrariesC-45DataC-45SparseMatrixC-45Vector-n--4363-1511-u--go arg-1 (+ arg-2 1) e-3))))))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-fromList (lambda (arg-1 ext-0) (LibrariesC-45DataC-45SparseMatrixC-45Vector-n--4363-1511-u--go arg-1 0 ext-0)))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector1-fromList (lambda (arg-1 ext-0) (DataC-45List1-fromList (LibrariesC-45DataC-45SparseMatrixC-45Vector-fromList arg-1 ext-0))))
(define LibrariesC-45DataC-45SparseMatrix-n--5158-2238-u--go (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cons (cons arg-2 e-2) (LibrariesC-45DataC-45SparseMatrix-n--5158-2238-u--go arg-1 (+ arg-2 1) e-3)))))))
(define LibrariesC-45DataC-45SparseMatrix-n--5145-2231-u--withIndex (lambda (arg-1 ext-0) (LibrariesC-45DataC-45SparseMatrix-n--5158-2238-u--go arg-1 0 ext-0)))
(define LibrariesC-45DataC-45SparseMatrix-fromListList (lambda (arg-1 ext-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons e-2 __infixTupleSection-0)) (LibrariesC-45DataC-45SparseMatrixC-45Vector1-fromList arg-1 e-3))))) (LibrariesC-45DataC-45SparseMatrix-n--5145-2231-u--withIndex arg-1 ext-0))))
(define CoreC-45TerminationC-45CallGraph-n--10540-11270-u--urhs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-2 (vector-ref arg-10 1))) (vector 10 e-2 (vector 0 )))) ((1) (let ((e-7 (vector-ref arg-10 1))) (let ((e-8 (vector-ref arg-10 2))) (let ((e-9 (vector-ref arg-10 3))) (vector 1 e-7 e-8 e-9))))) ((2) (let ((e-11 (vector-ref arg-10 1))) (let ((e-12 (vector-ref arg-10 2))) (let ((e-13 (vector-ref arg-10 3))) (let ((e-14 (vector-ref arg-10 4))) (vector 2 e-11 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 eta-0)) e-14))))))) ((4) (let ((e-16 (vector-ref arg-10 1))) (let ((e-17 (vector-ref arg-10 2))) (let ((e-18 (vector-ref arg-10 3))) (vector 4 e-16 (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-17) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-18)))))) ((5) (let ((e-20 (vector-ref arg-10 1))) (let ((e-21 (vector-ref arg-10 2))) (let ((e-22 (vector-ref arg-10 3))) (let ((e-23 (vector-ref arg-10 4))) (vector 5 e-20 e-21 (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-22) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-23))))))) ((6) (let ((e-25 (vector-ref arg-10 1))) (let ((e-26 (vector-ref arg-10 2))) (let ((e-27 (vector-ref arg-10 3))) (vector 6 e-25 e-26 (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-27)))))) ((7) (let ((e-29 (vector-ref arg-10 1))) (let ((e-30 (vector-ref arg-10 2))) (let ((e-31 (vector-ref arg-10 3))) (let ((e-32 (vector-ref arg-10 4))) (vector 7 e-29 e-30 (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-31) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-32))))))) ((8) (let ((e-34 (vector-ref arg-10 1))) (let ((e-35 (vector-ref arg-10 2))) (let ((e-36 (vector-ref arg-10 3))) (vector 8 e-34 e-35 (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-36)))))) ((3) (let ((e-38 (vector-ref arg-10 1))) (let ((e-39 (vector-ref arg-10 2))) (let ((e-40 (vector-ref arg-10 3))) (let ((e-41 (vector-ref arg-10 4))) (vector 3 e-38 e-39 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 eta-0)) e-40) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-39 arg-6) (cons e-39 arg-8) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--vt) (cons (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) (Builtin-fst u--vt)))) (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) (Builtin-snd u--vt)))))) arg-9) e-41))))))) ((9) (let ((e-43 (vector-ref arg-10 1))) (let ((e-44 (vector-ref arg-10 2))) (vector 9 e-43 e-44)))) ((10) (let ((e-46 (vector-ref arg-10 1))) (let ((e-47 (vector-ref arg-10 2))) (case (vector-ref e-47 0) ((1) (vector 10 e-46 (vector 1 ))) ((0) (vector 10 e-46 (vector 0 ))) (else (let ((e-54 (vector-ref e-47 1))) (vector 10 e-46 (vector 2 (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-54))))))))) (else (let ((e-49 (vector-ref arg-10 1))) (let ((e-50 (vector-ref arg-10 2))) (vector 11 e-49 e-50)))))))
(define CoreC-45TerminationC-45CallGraph-n--10540-11269-u--lookupTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (case (vector-ref arg-10 0) ((5) (let ((e-13 (vector-ref arg-10 1))) (let ((e-14 (vector-ref arg-10 2))) (let ((e-16 (vector-ref arg-10 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TerminationC-45CallGraph-n--10540-11269-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-16 arg-11) (lambda (u--tmC-39) (box (vector 5 e-13 e-14 u--tmC-39 (CoreC-45TerminationC-45CallGraph-n--10540-11270-u--urhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-16)))))))))(else (let ((e-1 (car arg-11))) (let ((e-2 (cdr arg-11))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (case (vector-ref e-5 0) ((5) (let ((e-8 (vector-ref e-5 1))) (let ((e-9 (vector-ref e-5 2))) (let ((e-10 (vector-ref e-5 3))) (let ((e-11 (vector-ref e-5 4))) (let ((sc4 (CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-10 e-10))) (cond ((equal? sc4 1) (box e-6)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TerminationC-45CallGraph-n--10540-11269-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (cons (cons e-11 e-6) e-2)) (lambda (u--tmC-39) (box (vector 5 e-8 e-9 (CoreC-45TerminationC-45CallGraph-n--10540-11270-u--urhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-10) u--tmC-39))))))))))))(else (let ((sc3 (CoreC-45TTC-45Term-u--C-61C-61_Eq_C-40TermC-32C-36varsC-41 arg-10 e-5))) (cond ((equal? sc3 1) (box e-6)) (else (CoreC-45TerminationC-45CallGraph-n--10540-11269-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2)))))))))))))))
(define CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (CoreC-45TerminationC-45CallGraph-n--10540-11269-u--lookupTm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-7 arg-8 arg-9 arg-8))) (if (null? sc0) (CoreC-45TerminationC-45CallGraph-n--10540-11270-u--urhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-7 arg-8 arg-9) (let ((e-2 (unbox sc0))) e-2)))))
(define CoreC-45TerminationC-45CallGraph-n--8924-11249-u--updatePat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (CoreC-45TerminationC-45CallGraph-n--8924-11250-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9)))
(define CoreC-45TerminationC-45CallGraph-n--8924-11248-u--matchArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--patMatch (PreludeC-45TypesC-45List-reverse (DataC-45List-u--zip_Zippable_List arg-1 (CoreC-45TTC-45Term-getArgs e-10))))) (cons e-2 (cons e-6 (cons (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-n--8924-11249-u--updatePat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-0 e-2 u--patMatch eta-0)) arg-2) e-11))))))))))))
(define CoreC-45TerminationC-45CallGraph-getCasePats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45Context-lookupDefExact arg-3 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((1) (let ((e-6 (vector-ref e-1 5))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "totality" 20 (lambda () (DataC-45String-unwords (cons "Looking at the" (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-6)) (cons "cases of" (cons (CoreC-45Name-u--show_Show_Name arg-3) '())))))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((u--pdefsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-n--8924-11248-u--matchArgs arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 eta-0)) e-6))) (let ((act-3 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality" 20 (lambda (eta-0) (let ((act-3 ((PreludeC-45Basics-flip csegen-1298 e-6 (lambda (lamc-0) (let ((e-10 (car lamc-0))) (let ((e-9 (cdr lamc-0))) (lambda (clam-1) (let ((e-11 (cdr e-9))) (let ((e-14 (car e-11))) (let ((e-13 (cdr e-11))) (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-68 e-14 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-toFullNames arg-0 csegen-68 e-13 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "    " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-10 e-15) (string-append " => " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-10 e-16)))))))) eff-0) eta-1)))))))) eff-0) clam-1))))))))))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((PreludeC-45Basics-flip csegen-1298 u--pdefsC-39 (lambda (lamc-0) (let ((e-11 (car lamc-0))) (let ((e-10 (cdr lamc-0))) (lambda (clam-2) (let ((e-12 (cdr e-10))) (let ((e-15 (car e-12))) (let ((e-14 (cdr e-12))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-0 csegen-68 eta-2 eta-3))) e-15 '()) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Context-toFullNames arg-0 csegen-68 e-14 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (string-append "    " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-11 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 e-11 u--d u--x)))) e-16) (string-append " => " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-11 e-17)))))))) eff-0) eta-2)))))))) eff-0) clam-2))))))))))))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (DataC-45String-fastUnlines (cons "Updated" (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons "  to:" e-10)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (vector 1 (box u--pdefsC-39)))))))))))(else (vector 1 '())))))))) eff-0) ext-0)))))))
(define CoreC-45TerminationC-45CallGraph-case--asserted-11139 (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 3))) (if (null? e-3) '() (let ((e-10 (cdr e-3))) (if (null? e-10) '() (let ((e-13 (cdr e-10))) (if (null? e-13) '() (let ((e-15 (car e-13))) (let ((e-16 (cdr e-13))) (if (null? e-16) '() (let ((e-19 (cdr e-16))) (if (null? e-19) (let ((sc7 (CoreC-45Name-u--C-61C-61_Eq_Name e-7 arg-2))) (cond ((equal? sc7 1) (box e-15)) (else '()))) '()))))))))))))(else '())))))))
(define CoreC-45TerminationC-45CallGraph-asserted (lambda (arg-1 arg-2) (CoreC-45TerminationC-45CallGraph-case--asserted-11139 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-2))))
(define CoreC-45TerminationC-45CallGraph-plusLazy (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) 0)(else (AlgebraC-45SizeChange-u--C-124C-43C-124_Semiring_SizeChange arg-0 (arg-1))))))
(define CoreC-45TerminationC-45CallGraph-knownOr (lambda (arg-0 arg-1) (cond ((equal? arg-0 2) (arg-1))(else arg-0))))
(define CoreC-45TerminationC-45CallGraph-sizeCompareApp (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((4) (let ((e-2 (vector-ref arg-1 2))) (CoreC-45TerminationC-45CallGraph-sizeCompare e-2 arg-2)))(else 2))))
(define CoreC-45TerminationC-45CallGraph-sizeCompareConArgs (lambda (arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45TerminationC-45CallGraph-sizeCompare arg-1 e-2))) (cond ((equal? sc1 2) (CoreC-45TerminationC-45CallGraph-sizeCompareConArgs arg-1 e-3))(else 1))))))))
(define CoreC-45TerminationC-45CallGraph-sizeCompareCon (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-2))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 2))) (case (vector-ref e-5 0) ((2) (CoreC-45TerminationC-45CallGraph-sizeCompareConArgs arg-1 e-3))(else 0))))(else 0)))))))
(define CoreC-45TerminationC-45CallGraph-sizeCompare (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((10) (let ((e-7 (vector-ref arg-2 2))) (case (vector-ref e-7 0) ((2) (let ((e-14 (vector-ref e-7 1))) (CoreC-45TerminationC-45CallGraph-sizeCompare arg-1 e-14)))(else 2)))) ((5) (let ((e-11 (vector-ref arg-2 3))) (let ((e-12 (vector-ref arg-2 4))) (CoreC-45TerminationC-45CallGraph-knownOr (CoreC-45TerminationC-45CallGraph-sizeCompare arg-1 e-11) (lambda () (CoreC-45TerminationC-45CallGraph-sizeCompare arg-1 e-12))))))(else (case (vector-ref arg-1 0) ((5) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (CoreC-45TerminationC-45CallGraph-knownOr (CoreC-45TerminationC-45CallGraph-sizeCompare e-3 arg-2) (lambda () (CoreC-45TerminationC-45CallGraph-sizeCompare e-4 arg-2))))))(else (let ((sc0 (CoreC-45TerminationC-45CallGraph-sizeCompareCon arg-1 arg-2))) (cond ((equal? sc0 1) 0) (else (CoreC-45TerminationC-45CallGraph-knownOr (CoreC-45TerminationC-45CallGraph-sizeCompareApp arg-1 arg-2) (let ((sc1 (CoreC-45TerminationC-45CallGraph-sizeEq arg-1 arg-2))) (cond ((equal? sc1 1) (lambda () 1)) (else (lambda () 2))))))))))))))
(define CoreC-45TerminationC-45CallGraph-sizeCompareAsserted (lambda (arg-1 arg-2) (if (null? arg-1) 2 (let ((e-1 (unbox arg-1))) (let ((sc1 (CoreC-45TerminationC-45CallGraph-sizeCompare e-1 arg-2))) (cond ((equal? sc1 2) 2)(else 0)))))))
(define CoreC-45TerminationC-45CallGraph-mkChange (lambda (arg-1 arg-2 arg-3 arg-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--p) (CoreC-45TerminationC-45CallGraph-plusLazy (CoreC-45TerminationC-45CallGraph-sizeCompareAsserted (CoreC-45TerminationC-45CallGraph-asserted arg-2 arg-4) u--p) (lambda () (CoreC-45TerminationC-45CallGraph-sizeCompare arg-4 u--p)))) arg-3)))
(define CoreC-45TerminationC-45CallGraph-findSCcall (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (CoreC-45Context-getFullName arg-1 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "totality.termination.sizechange" 10 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-1 csegen-54 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Looking under " (CoreC-45Name-u--show_Show_Name e-6)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Context-u--resolved_HasNames_Name (let ((e-0 (vector-ref arg-2 0))) e-0) (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "assert_smaller")))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Core-cond (cons (cons (lambda () (CoreC-45Name-u--C-61C-61_Eq_Name e-5 csegen-2366)) (lambda () (lambda (eta-1) (vector 1 '())))) (cons (cons (lambda () (CoreC-45Name-caseFn e-5)) (lambda () (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-2)) arg-8 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45TerminationC-45CallGraph-getCasePats arg-1 arg-0 arg-2 e-5 arg-5 arg-8 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (CoreC-45TerminationC-45CallGraph-findInCase arg-1 arg-2 arg-4 eta-4)) (DataC-45Maybe-fromMaybe (lambda () '()) e-9) '()) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-5) eta-5) (PreludeC-45TypesC-45List-tailRecAppend e-8 e-10)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) '())) (lambda () (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-2)) arg-8 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (cons (vector e-5 (LibrariesC-45DataC-45SparseMatrix-fromListList csegen-2362 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (CoreC-45TerminationC-45CallGraph-mkChange arg-2 e-7 arg-5 eta-3)) arg-8)) arg-6) '()) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-3) eta-3) e-8)))))) eff-0) eta-1)))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45TerminationC-45CallGraph-n--8811-9984-u--handleCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-7 0) ((1) (let ((e-1 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 3))) (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (CoreC-45Name-caseFn e-5))) (cond ((equal? sc2 1) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-1 e-3 arg-8 eta-0)) clam-1)) (else (vector 1 '()))))))) eff-0) ext-0))))))))(else (vector 1 '())))))
(define CoreC-45TerminationC-45CallGraph-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32findSC-10300 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (cond ((equal? e-2 3) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-1) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-1))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-2)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-2))))) eff-0) clam-1)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-1)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-1)))))))))) (let ((e-14 (car e-3))) (let ((e-15 (cdr e-3))) (lambda (clam-0) (case (vector-ref e-14 0) ((1) (let ((e-18 (vector-ref e-14 2))) (case (vector-ref e-18 0) ((2) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 3 arg-2 eta-0)) e-15 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-0))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-15 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-0)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-15 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-0)))))))))))) ((equal? e-2 2) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-8) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-8))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-8))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-9) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-9))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-9)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-9))))) eff-0) clam-8)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-8)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-8)))))))))) (let ((e-24 (car e-3))) (let ((e-25 (cdr e-3))) (case (vector-ref e-24 0) ((1) (let ((e-27 (vector-ref e-24 1))) (let ((e-28 (vector-ref e-24 2))) (let ((e-29 (vector-ref e-24 3))) (case (vector-ref e-28 0) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45Context-lookupTyExact e-29 (let ((e-0 (vector-ref arg-5 0))) e-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-5) (let ((act-2 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 2 arg-2 e-27 e-29 e-25 clam-3)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 2 arg-2 e-27 e-29 e-25 clam-3))))) eff-0) eta-0)))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-4) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-4))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-4))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-5) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-5))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-5)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-5))))) eff-0) clam-4)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-4)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-4))))))))))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-6) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-6))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-6))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-7) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-7)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-7))))) eff-0) clam-6)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-6)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-6)))))))))))))))) ((equal? e-2 0) (if (null? e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-15) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-15))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-15))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-16) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-16))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-16)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-16))))) eff-0) clam-15)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-15)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-15)))))))))) (let ((e-34 (car e-3))) (let ((e-35 (cdr e-3))) (case (vector-ref e-34 0) ((1) (let ((e-37 (vector-ref e-34 1))) (let ((e-38 (vector-ref e-34 2))) (let ((e-39 (vector-ref e-34 3))) (case (vector-ref e-38 0) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45Context-lookupTyExact e-39 (let ((e-0 (vector-ref arg-5 0))) e-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-10) (if (null? e-5) (let ((act-2 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-10))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 2 arg-2 e-37 e-39 e-35 clam-10)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 2 arg-2 e-37 e-39 e-35 clam-10))))) eff-0) eta-0)))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-11) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-11))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-11))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-11))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-12) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-12))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-12)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-12))))) eff-0) clam-11)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-11))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-11)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-11))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-11))))))))))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-13) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-13))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-13))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-13))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-14) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-14))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-14)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-14))))) eff-0) clam-13)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-13))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-13)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-13))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-13))))))))))))))))(else (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-17) (case (vector-ref e-6 0) ((1) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (case (vector-ref e-10 0) ((1) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-6 csegen-54 e-11 clam-17))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "totality" 50 (lambda (eta-1) (vector 1 (string-append "Looking up type of " (CoreC-45Name-u--show_Show_Name e-5)))) eta-0)))) eff-0) clam-17))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45Context-lookupTyExact e-11 (let ((e-0 (vector-ref arg-5 0))) e-0) clam-17))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-18) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-6 "totality" 50 (lambda () "Lookup failed") clam-18))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-18)))) (CoreC-45TerminationC-45CallGraph-findSCcall arg-0 arg-6 arg-5 arg-4 1 arg-2 e-9 e-11 e-7 clam-18))))) eff-0) clam-17)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-17))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-17)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-6 arg-5 arg-4 1 arg-2 eta-0)) e-7 '()) clam-17))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-17))))))))))))))))
(define CoreC-45TerminationC-45CallGraph-case--findSC-10231 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-1 (CoreC-45TerminationC-45CallGraph-n--8811-9984-u--handleCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (let ((act-2 ((CoreC-45TerminationC-45CallGraph-n--8811-9983-u--conIfGuarded arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 '())) (CoreC-45TerminationC-45CallGraph-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32findSC-10300 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-3 _-0 e-6 (cons arg-3 (cons e-6 e-3)))))) eff-0) clam-1))))) (let ((e-4 (unbox e-5))) (vector 1 e-4)))))) eff-0) ext-0)))))))))
(define CoreC-45TerminationC-45CallGraph-findSC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45TerminationC-45CallGraph-n--8811-9909-u--findSCbinder e-12 arg-0 e-14 e-13 e-11 arg-5 arg-4 arg-3 arg-2 arg-1 e-13) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45TerminationC-45CallGraph-findSC (cons e-12 arg-0) arg-1 arg-2 (cons e-13 arg-3) arg-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) eta-2)))) arg-5) e-14) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (cond ((equal? arg-4 2) (case (vector-ref arg-6 0) ((7) (let ((e-9 (vector-ref arg-6 4))) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-1 arg-2 arg-3 3 arg-5 e-9)))(else (case (vector-ref arg-6 0) ((7) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4)))(else (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-case--findSC-10231 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-6) eta-0)))))))(else (case (vector-ref arg-6 0) ((7) (let ((e-4 (vector-ref arg-6 4))) (CoreC-45TerminationC-45CallGraph-findSC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4)))(else (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-case--findSC-10231 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-6) eta-0))))))))))
(define CoreC-45TerminationC-45CallGraph-findCalls (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--pargs (CoreC-45TTC-45Term-getArgs (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-10)))) (lambda (eta-0) (let ((act-1 (CoreC-45Normalise-normaliseOpts arg-0 e-2 CoreC-45Value-tcOnly arg-1 e-6 e-11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45TerminationC-45CallGraph-findSC e-2 arg-0 arg-1 e-6 0 u--pargs (CoreC-45TerminationC-45CallGraph-delazy arg-1 e-5)))) eff-0) eta-0)))))))))))))))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_SCCall (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45Name-u--C-61C-61_Eq_Name (let ((e-0 (vector-ref arg-0 0))) e-0) (let ((e-0 (vector-ref arg-1 0))) e-0)))) (cond ((equal? sc0 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-1044 (let ((e-1 (vector-ref arg-0 1))) e-1) (let ((e-1 (vector-ref arg-1 1))) e-1))) (else 0)))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_SCCall (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SCCall arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45TerminationC-45CallGraph-getSC (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((1) (let ((e-4 (vector-ref arg-2 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45TerminationC-45CallGraph-findCalls arg-0 arg-1 eta-0)) e-4 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (DataC-45List-nub (cons (lambda (arg-676) (lambda (arg-679) (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SCCall arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_SCCall arg-686 arg-689)))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5)))))) eff-0) ext-0)))))))(else (vector 1 '())))))
(define CoreC-45TerminationC-45CallGraph-calculateSizeChange (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality.termination.sizechange" 5 (lambda (eta-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "Calculating Size Change: " (CoreC-45Name-u--show_Show_Name e-5)))))) eff-0) eta-0)))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-7))) (lambda (eta-1) (CoreC-45TerminationC-45CallGraph-getSC arg-0 e-6 (let ((e-18 (vector-ref e-1 18))) e-18) eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45Env-bindEnv (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) arg-3 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-2))) (let ((e-9 (cdr arg-2))) (CoreC-45Env-bindEnv e-3 arg-1 e-9 (vector 3 arg-1 e-2 (vector 3 (CoreC-45TTC-45Binder-binderLoc e-8) (CoreC-45TTC-45Binder-multiplicity e-8) (vector 1 ) (CoreC-45TTC-45Binder-binderType e-8)) arg-3)))))))))
(define CoreC-45Metadata-n--11348-8529-u--toPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8) (if (null? arg-8) '() (let ((e-3 (car arg-8))) (let ((e-4 (cdr arg-8))) (case (vector-ref e-3 0) ((0) (let ((e-7 (vector-ref e-3 1))) (let ((e-8 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 3))) (let ((e-10 (vector-ref e-3 4))) (cons (vector 3 e-7 e-8 e-9 e-10) (CoreC-45Metadata-n--11348-8529-u--toPat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4)))))))(else (cons e-3 (CoreC-45Metadata-n--11348-8529-u--toPat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4)))))))))
(define CoreC-45Metadata-addLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-1 csegen-68 (CoreC-45Env-bindEnv arg-0 arg-3 (CoreC-45Metadata-n--11348-8529-u--toPat arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-5) arg-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (CoreC-45FC-isNonEmptyFC arg-3))) (if (null? sc2) (vector 1 (vector 0 )) (let ((e-1 (unbox sc2))) (let ((act-3 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector (cons (cons e-1 (cons arg-4 e-6)) e-0) e-12 e-2 e-3 e-4 e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-3)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDef-n--17660-8516-u--lookupAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-6))) (cond ((equal? sc2 1) (cons e-7 (TTImpC-45ProcessDef-n--17660-8516-u--lookupAll arg-0 arg-1 arg-2 arg-3 arg-4 e-3))) (else (TTImpC-45ProcessDef-n--17660-8516-u--lookupAll arg-0 arg-1 arg-2 arg-3 arg-4 e-3)))))))))))
(define AlgebraC-45Preorder-glb (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (vector-ref arg-1 0))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) arg-2) (else arg-3)))))
(define AlgebraC-45Preorder-lub (lambda (arg-1 arg-2 arg-3) (let ((sc0 (let ((e-1 (vector-ref arg-1 0))) ((e-1 arg-2) arg-3)))) (cond ((equal? sc0 1) arg-3) (else arg-2)))))
(define TTImpC-45ProcessDef-n--17660-8514-u--combine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (AlgebraC-45ZeroOneOmega-rigPlus arg-4 arg-5) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) (cond ((equal? sc1 1) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 (AlgebraC-45Preorder-glb csegen-2382 arg-4 arg-5)))) (cond ((equal? sc2 1) 0) (else (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega (AlgebraC-45Preorder-glb csegen-2382 arg-4 arg-5) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-3 2 arg-0) ext-0)) (else (vector 1 (AlgebraC-45Preorder-lub csegen-2382 arg-4 arg-5)))))))
(define TTImpC-45ProcessDef-n--17660-8515-u--combineAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (TTImpC-45ProcessDef-n--17660-8514-u--combine arg-0 arg-1 arg-2 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ProcessDef-n--17660-8515-u--combineAll arg-0 arg-1 arg-2 arg-3 e-5 e-3 eta-0)))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessDef-n--17660-8517-u--notN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (CoreC-45Name-u--C-47C-61_Eq_Name arg-0 e-2))))
(define TTImpC-45ProcessDef-case--combineLinear-8701 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (let ((act-1 ((TTImpC-45ProcessDef-combineLinear arg-3 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (cons arg-0 arg-1) e-5))))) eff-0) ext-0))))) (let ((act-1 (TTImpC-45ProcessDef-n--17660-8515-u--combineAll arg-0 arg-1 arg-2 arg-3 arg-1 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ProcessDef-combineLinear arg-3 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (TTImpC-45ProcessDef-n--17660-8517-u--notN arg-0 arg-1 arg-2 arg-3 eta-1)) arg-2)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons arg-0 e-5) e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))
(define TTImpC-45ProcessDef-combineLinear (lambda (arg-0 arg-1) (if (null? arg-1) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (eta-0) (TTImpC-45ProcessDef-case--combineLinear-8701 e-6 e-7 e-3 arg-0 (TTImpC-45ProcessDef-n--17660-8516-u--lookupAll e-6 e-7 e-3 arg-0 e-6 e-3) eta-0)))))))))
(define TTImpC-45TTImp-n--8207-1806-u--wknName (lambda (arg-1 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (PreludeC-45TypesC-45List-mapAppend '() (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-4 (cdr sc3))) (((e-4 'erased) 'erased) arg-3))) e-10) (lambda (u--fc) (lambda (u--nt) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc3))) ((((e-4 'erased) 'erased) arg-3) ((e-11 u--fc) u--nt)))))))))))))))))
(define TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames (lambda (arg-2 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImp-n--8207-1806-u--wknName arg-3 arg-2 eta-0)) arg-3)))
(define TTImpC-45TTImp-u--weaken_Weaken_NestedNames (lambda (ext-0) (TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) ext-0)))
(define TTImpC-45ProcessDef-with--extendEnv-7371 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (if (null? arg-2) csegen-2617 (TTImpC-45ProcessDef-extendEnv (cons arg-0 arg-4) (cons (vector 3 arg-13 arg-12 arg-11 arg-10) arg-18) (vector 1 arg-17) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-16) arg-14 arg-15))))
(define TTImpC-45ProcessDef-with--extendEnv-7461 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-2) csegen-2617 (TTImpC-45ProcessDef-extendEnv (cons arg-0 arg-4) (cons (vector 1 arg-14 arg-13 arg-11 arg-12) arg-19) (vector 1 arg-18) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-17) arg-15 arg-16))))
(define TTImpC-45ProcessDef-extendEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((3) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((3) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref arg-6 0) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (case (vector-ref e-18 0) ((5) (let ((e-21 (vector-ref e-18 1))) (let ((e-22 (vector-ref e-18 2))) (let ((e-23 (vector-ref e-18 3))) (TTImpC-45ProcessDef-with--extendEnv-7371 e-2 e-17 (CoreC-45Name-nameEq e-2 e-17) 'erased arg-1 e-16 e-21 e-22 e-23 e-1 e-9 e-8 e-7 e-6 e-4 e-19 arg-4 arg-3 arg-2)))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6)))))))))))))) ((4) (let ((e-11 (vector-ref e-3 1))) (let ((e-12 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((e-14 (vector-ref e-3 4))) (case (vector-ref arg-6 0) ((3) (let ((e-25 (vector-ref arg-6 1))) (let ((e-26 (vector-ref arg-6 2))) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (case (vector-ref e-27 0) ((4) (let ((e-30 (vector-ref e-27 1))) (let ((e-31 (vector-ref e-27 2))) (let ((e-32 (vector-ref e-27 3))) (let ((e-33 (vector-ref e-27 4))) (TTImpC-45ProcessDef-with--extendEnv-7461 e-2 e-26 (CoreC-45Name-nameEq e-2 e-26) 'erased arg-1 e-25 e-30 e-31 e-33 e-32 e-1 e-13 e-14 e-12 e-11 e-4 e-28 arg-4 arg-3 arg-2))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6))))))))))))))(else (lambda (eta-0) (vector 1 (cons arg-1 (cons arg-3 (cons arg-2 (cons arg-4 (cons arg-5 arg-6)))))))))))
(define TTImpC-45ProcessDef-n--16605-7603-u--accessible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((1) (cond ((equal? arg-4 1) arg-7) (else csegen-30)))(else arg-7))))
(define TTImpC-45ProcessDef-n--16605-7604-u--findLinArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-8 0) ((0) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (case (vector-ref e-7 0) ((2) (let ((e-10 (vector-ref e-7 1))) (let ((e-11 (vector-ref e-7 2))) (let ((e-12 (vector-ref e-7 3))) (let ((e-13 (vector-ref e-7 4))) (if (null? arg-9) (lambda (clam-1) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-1 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-14))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) (let ((e-15 (car arg-9))) (let ((e-16 (cdr arg-9))) (case (vector-ref e-15 0) ((5) (let ((e-19 (vector-ref e-15 2))) (let ((e-20 (vector-ref e-15 3))) (let ((e-21 (vector-ref e-15 4))) (let ((u--ty (vector 0 e-5 e-6 (vector 2 e-10 e-11 e-12 e-13) e-8))) (let ((sc4 (AlgebraC-45Semiring-isLinear csegen-931 e-11))) (cond ((equal? sc4 1) (cond ((equal? e-19 0) (TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--ty (cons e-21 e-16))) (else (TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--ty (cons e-20 e-16))))) (else (lambda (eta-0) (let ((act-1 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--ty (cons e-20 '())) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--ty (cons e-21 e-16)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-14))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (let ((e-24 (vector-ref e-15 1))) (let ((e-26 (vector-ref e-15 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--a (CoreC-45TTC-45Var-nameAt arg-6 e-26))) (lambda (clam-0) (let ((sc5 (PreludeC-45Types-u--C-60_Ord_Nat e-26 arg-3))) (cond ((equal? sc5 1) (let ((act-2 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-24 (vector 0 ) e-6))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (cons u--a (AlgebraC-45ZeroOneOmega-rigMult e-11 arg-7)) e-17))))) eff-0) eta-1)))))))) eff-0) clam-0)))))) (else (let ((act-2 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-24 (vector 0 ) e-6))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-14 e-16))) eff-0) clam-0)))))))))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 (AlgebraC-45ZeroOneOmega-rigMult e-11 arg-7) e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (((e-8 e-9) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-5 (vector 0 ) e-6))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-17 e-16) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-14 e-18))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))))(else (lambda (clam-2) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-1 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))))))))))(else (lambda (clam-3) (if (null? arg-9) (vector 1 '()) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (let ((act-1 ((TTImpC-45ProcessDef-findLinear arg-6 arg-5 0 arg-3 arg-7 e-1) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))))))))
(define TTImpC-45ProcessDef-case--findLinear-8188 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (if (null? e-3) (vector 1 '()) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-9) (vector 1 '()) (let ((e-1 (unbox e-9))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-5 '() e-8 '() e-1) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessDef-n--16605-7604-u--findLinArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-0 (TTImpC-45ProcessDef-n--16605-7603-u--accessible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-2) e-10 e-3))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (vector 1 '())))))))))
(define TTImpC-45ProcessDef-findLinear (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-2 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 4))) (TTImpC-45ProcessDef-findLinear (cons e-2 arg-0) arg-1 arg-2 (+ arg-3 1) arg-4 e-4)))) ((5) (let ((e-9 (vector-ref arg-5 4))) (TTImpC-45ProcessDef-findLinear arg-0 arg-1 arg-2 arg-3 arg-4 e-9)))(else (TTImpC-45ProcessDef-case--findLinear-8188 arg-0 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-5))))))
(define TTImpC-45TTImp-findIBinds (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-5) (TTImpC-45TTImp-findIBinds e-6))))) ((2) (let ((e-12 (vector-ref arg-1 5))) (let ((e-13 (vector-ref arg-1 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-12) (TTImpC-45TTImp-findIBinds e-13))))) ((8) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-16) (TTImpC-45TTImp-findIBinds e-17))))) ((9) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-20) (TTImpC-45TTImp-findIBinds e-21))))) ((10) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-24) (TTImpC-45TTImp-findIBinds e-26))))) ((11) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-29) (TTImpC-45TTImp-findIBinds e-30))))) ((18) (let ((e-35 (vector-ref arg-1 4))) (let ((e-36 (vector-ref arg-1 5))) (case (vector-ref e-35 0) ((1) (let ((e-76 (vector-ref e-35 1))) (case (vector-ref e-76 0) ((0) (let ((e-77 (vector-ref e-76 1))) (cons e-77 (TTImpC-45TTImp-findIBinds e-36))))(else (TTImpC-45TTImp-findIBinds e-36)))))(else (TTImpC-45TTImp-findIBinds e-36)))))) ((19) (let ((e-40 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-40))) ((13) (let ((e-44 (vector-ref arg-1 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45TTImp-findIBinds eta-0)) e-44))) ((20) (let ((e-48 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-48))) ((21) (let ((e-51 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-51))) ((22) (let ((e-54 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-54))) ((23) (let ((e-57 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-57))) ((26) (let ((e-60 (vector-ref arg-1 2))) (TTImpC-45TTImp-findIBinds e-60))) ((27) (let ((e-64 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-64))) ((16) (let ((e-68 (vector-ref arg-1 3))) (TTImpC-45TTImp-findIBinds e-68))) ((17) (let ((e-71 (vector-ref arg-1 2))) (cons e-71 '()))) ((7) (let ((e-74 (vector-ref arg-1 2))) (let ((e-75 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findIBinds e-75) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45TTImp-findIBinds (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-74)))))(else '()))))
(define TTImpC-45TTImp-n--12686-6142-u--updateNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) '() (let ((e-1 (car arg-10))) (let ((e-2 (cdr arg-10))) (if (null? e-1) (box e-2) (let ((sc2 (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-832 (box arg-9) e-1))) (cond ((equal? sc2 1) (box e-2)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45TTImp-n--12686-6142-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2) (lambda (u--nsC-39) (box (cons e-1 u--nsC-39)))))))))))))
(define TTImpC-45TTImp-n--12686-6140-u--findImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-11) (case (vector-ref arg-12 0) ((0) (let ((e-16 (vector-ref arg-12 1))) (let ((e-17 (vector-ref arg-12 2))) (let ((e-18 (vector-ref arg-12 3))) (let ((e-19 (vector-ref arg-12 4))) (lambda (clam-1) (case (vector-ref e-18 0) ((2) (let ((e-23 (vector-ref e-18 3))) (case (vector-ref e-23 0) ((1) (let ((act-1 (((e-19 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-16 (vector 0 )))) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? arg-10) (let ((sc6 (TTImpC-45TTImp-n--12686-6142-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc6) (lambda (eta-0) (vector 1 '())) (let ((e-2 (unbox sc6))) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2 '() e-5)))) (let ((e-1 (car arg-10))) (if (null? e-1) (let ((sc7 (TTImpC-45TTImp-n--12686-6142-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc7) (lambda (eta-0) (vector 1 '())) (let ((e-3 (unbox sc7))) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 '() e-5)))) (let ((e-4 (unbox e-1))) (case (vector-ref e-4 0) ((1) (let ((e-6 (vector-ref e-4 1))) (case (vector-ref e-6 0) ((2) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5))(else (let ((sc8 (TTImpC-45TTImp-n--12686-6142-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc8) (lambda (eta-0) (vector 1 '())) (let ((e-3 (unbox sc8))) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 '() e-5))))))))(else (let ((sc7 (TTImpC-45TTImp-n--12686-6142-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-10))) (if (null? sc7) (lambda (eta-0) (vector 1 '())) (let ((e-3 (unbox sc7))) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 '() e-5)))))))))))) eff-0) clam-1)))))) ((2) (let ((act-1 (((e-19 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-16 (vector 0 )))) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc5 (TTImpC-45TTImp-n--12686-6142-u--updateNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-17 arg-9))) (if (null? sc5) (lambda (eta-0) (let ((act-2 ((TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons e-17 (vector 2 )) e-6))))) eff-0) eta-0)))))) (let ((e-2 (unbox sc5))) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 arg-10 '() e-5)))))) eff-0) clam-1))))))(else (let ((act-1 (((e-19 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-16 (vector 0 )))) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-845 (box e-17) arg-9))) (cond ((equal? sc4 1) (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5)) (else (lambda (eta-0) (let ((act-2 ((TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 '() e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons e-17 (CoreC-45TTC-45Binder-forgetDef e-23)) e-6))))) eff-0) eta-0))))))))))) eff-0) clam-1)))))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 50 (lambda () (string-append "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-11))) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 '()))))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 50 (lambda () (string-append "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-11))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 '()))))))) (let ((e-2 (cdr arg-11))) (case (vector-ref arg-12 0) ((0) (let ((e-5 (vector-ref arg-12 1))) (let ((e-7 (vector-ref arg-12 3))) (let ((e-8 (vector-ref arg-12 4))) (lambda (clam-0) (case (vector-ref e-7 0) ((2) (let ((e-12 (vector-ref e-7 3))) (case (vector-ref e-12 0) ((1) (let ((act-1 (((e-8 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-5 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-9))) eff-0) clam-0))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 50 (lambda () (string-append "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-11))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 '()))))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 50 (lambda () (string-append "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-11))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 '())))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 50 (lambda () (string-append "Giving up with the following locals left: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-11))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 '())))))))))))
(define TTImpC-45TTImp-n--12686-6141-u--impAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (if (null? e-2) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (case (vector-ref e-6 0) ((1) (let ((e-11 (vector-ref e-6 1))) (case (vector-ref e-11 0) ((0) (let ((e-12 (vector-ref e-11 1))) (case (vector-ref e-7 0) ((2) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 17 arg-9 e-12))))(else (case (vector-ref e-7 0) ((0) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1))))) ((3) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1)))))(else (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))(else (case (vector-ref e-7 0) ((0) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1))))) ((3) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1)))))(else (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))(else (case (vector-ref e-7 0) ((0) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1))))) ((3) (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 (vector 10 arg-9 arg-11 e-6 (vector 18 arg-9 (vector 2 ) 0 e-6 (vector 32 arg-9 1)))))(else (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))))))))
(define TTImpC-45TTImp-n--12662-6065-u--setAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (case (vector-ref arg-7 0) ((8) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((act-1 (TTImpC-45TTImp-n--12662-6065-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons '() arg-6) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-1 e-5 e-3))))) eff-0) ext-0))))))))) ((9) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-7 (vector-ref arg-7 3))) (let ((act-1 (TTImpC-45TTImp-n--12662-6065-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 (cons '() arg-5) arg-6 e-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-5 e-8 e-7))))) eff-0) ext-0))))))))) ((10) (let ((e-9 (vector-ref arg-7 1))) (let ((e-10 (vector-ref arg-7 2))) (let ((e-11 (vector-ref arg-7 3))) (let ((e-12 (vector-ref arg-7 4))) (let ((act-1 (TTImpC-45TTImp-n--12662-6065-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 (cons (box e-11) arg-5) (cons (box e-11) arg-6) e-10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-9 e-5 e-11 e-12))))) eff-0) ext-0)))))))))) ((11) (let ((e-14 (vector-ref arg-7 1))) (let ((e-15 (vector-ref arg-7 2))) (let ((e-16 (vector-ref arg-7 3))) (let ((act-1 (TTImpC-45TTImp-n--12662-6065-u--setAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-15 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 11 e-14 e-5 e-16))))) eff-0) ext-0))))))))) ((0) (let ((e-18 (vector-ref arg-7 1))) (let ((e-19 (vector-ref arg-7 2))) (let ((act-1 (CoreC-45Context-lookupTyExact (vector 8 arg-3) (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (let ((act-2 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 30 (lambda () (string-append "Could not find variable " (PreludeC-45Show-u--show_Show_Int arg-3))) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 0 e-18 e-19))))) (let ((e-2 (unbox e-5))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-4 '() arg-2 '() e-2) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((TTImpC-45TTImp-n--12686-6140-u--findImps arg-0 arg-1 arg-2 arg-3 arg-4 e-19 e-18 arg-6 arg-5 arg-5 arg-6 arg-1 e-6) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-log arg-4 "declare.def.lhs.implicits" 30 (lambda () (string-append "\xa;  In the type of " (string-append (PreludeC-45Show-u--show_Show_Int arg-3) (string-append ": " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-2) (string-append "\xa;  Using locals: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-1) (string-append "\xa;  Found implicits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-839 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-839 u--d u--x)))) e-7))))))))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (vector 1 (TTImpC-45TTImp-n--12686-6141-u--impAs arg-0 arg-1 arg-2 arg-3 arg-4 e-19 e-18 arg-6 arg-5 (CoreC-45FC-virtualiseFC e-18) e-7 (vector 0 e-18 e-19))))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))) eff-0) ext-0))))))))(else (vector 1 arg-7)))))
(define TTImpC-45TTImp-implicitsAs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--implicits (TTImpC-45TTImp-findIBinds arg-4))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "declare.def.lhs.implicits" 30 (lambda () (string-append "Found implicits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--implicits))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (TTImpC-45TTImp-n--12662-6065-u--setAs arg-4 arg-3 arg-2 arg-1 arg-0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (box eta-1)) (PreludeC-45TypesC-45List-tailRecAppend arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 1 (vector 0 eta-1))) u--implicits))) '() arg-4 eta-0))))))))
(define CoreC-45Env-letToLam (lambda (arg-1) (if (null? arg-1) '() (let ((e-4 (car arg-1))) (let ((e-5 (cdr arg-1))) (case (vector-ref e-4 0) ((1) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-10 (vector-ref e-4 4))) (cons (vector 0 e-7 e-8 (vector 1 ) e-10) (CoreC-45Env-letToLam e-5))))))(else (cons e-4 (CoreC-45Env-letToLam e-5)))))))))
(define TTImpC-45TTImp-lhsInCurrentNS (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((8) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-1 e-5 e-3))))) eff-0) eta-0)))))))))) ((9) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 9 e-5 e-8 e-7))))) eff-0) eta-0)))))))))) ((10) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((e-12 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 10 e-9 e-5 e-11 e-12))))) eff-0) eta-0))))))))))) ((11) (let ((e-14 (vector-ref arg-3 1))) (let ((e-15 (vector-ref arg-3 2))) (let ((e-16 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-2 e-15) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 11 e-14 e-5 e-16))))) eff-0) eta-0)))))))))) ((0) (let ((e-18 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref e-19 0) ((0) (vector 1 arg-3))(else (let ((sc1 (DataC-45List-lookup csegen-832 e-19 arg-2))) (if (null? sc1) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 e-19 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-18 e-5))))) eff-0) clam-0))))) (vector 1 (vector 0 e-18 e-19))))))))))(else (lambda (eta-0) (vector 1 arg-3))))))
(define CoreC-45Metadata-setHoleLHS (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 (box arg-1) e-4 e-10 e-6 e-7 e-8 e-9))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ProcessDef-setLinear (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((3) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 3 e-6 e-7 e-8 e-9))) (let ((sc2 (DataC-45List-lookup csegen-832 e-2 arg-1))) (if (null? sc2) (vector 3 e-1 e-2 u--b (TTImpC-45ProcessDef-setLinear arg-1 e-4)) (let ((e-5 (unbox sc2))) (vector 3 e-1 e-2 (CoreC-45TTC-45Binder-setMultiplicity u--b e-5) (TTImpC-45ProcessDef-setLinear arg-1 e-4))))))))))) ((5) (let ((e-11 (vector-ref e-3 1))) (let ((e-12 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((u--b (vector 5 e-11 e-12 e-13))) (let ((sc2 (DataC-45List-lookup csegen-832 e-2 arg-1))) (if (null? sc2) (vector 3 e-1 e-2 u--b (TTImpC-45ProcessDef-setLinear arg-1 e-4)) (let ((e-5 (unbox sc2))) (vector 3 e-1 e-2 (CoreC-45TTC-45Binder-setMultiplicity u--b e-5) (TTImpC-45ProcessDef-setLinear arg-1 e-4))))))))))(else arg-2)))))))(else arg-2))))
(define TTImpC-45ProcessDef-checkLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45TTImp-logRaw arg-1 "declare.def.lhs" 30 (lambda () "Raw LHS: ") arg-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (cond ((equal? arg-6 1) (vector 1 arg-13)) (else ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-10 arg-13) eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45TTImp-logRaw arg-1 "declare.def.lhs" 30 (lambda () "Raw LHS in current NS: ") e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45Context-isUnboundImplicits arg-1 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 ((CoreC-45Context-setUnboundImplicits arg-1 1) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (TTImpC-45BindImplicits-bindNames arg-1 0 e-7 eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-3 (cdr e-11))) (let ((act-8 ((CoreC-45Context-setUnboundImplicits arg-1 e-9) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (TTImpC-45TTImp-logRaw arg-1 "declare.def.lhs" 30 (lambda () "Raw LHS with implicits bound") e-3 clam-0))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 (cond ((equal? arg-6 1) (vector 1 e-3)) (else ((TTImpC-45TTImp-implicitsAs arg-1 arg-8 e-5 arg-0 e-3) clam-0))))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-11 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "declare.def.lhs" 5 (lambda (eta-4) (let ((act-11 (CoreC-45Context-getFullName arg-1 (vector 8 arg-8) eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (string-append "Checking LHS of " (CoreC-45Name-u--show_Show_Name e-15)))))) eff-0) eta-4)))))) eta-3))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 (CoreC-45ContextC-45Log-log arg-1 "declare.def.lhs" 10 (lambda () (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-14)) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((act-13 (CoreC-45Normalise-logEnv arg-0 arg-1 "declare.def.lhs" 5 "In env" arg-11 eta-3))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((u--lhsMode (cond ((equal? arg-6 1) (vector 3 )) (else (vector 1 arg-7))))) (let ((act-14 (let ((act-14 (CoreC-45Context-getFullName arg-1 (vector 8 arg-8) eta-3))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-wrapErrorC arg-9 (lambda (eta-4) (vector 70 arg-12 e-18 eta-4)) (TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8 u--lhsMode arg-9 arg-10 arg-11 (vector 16 arg-12 (vector 1 ) e-14) '())))) eff-0) eta-3))))))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-19 (car e-18))) (let ((e-4 (cdr e-18))) (let ((act-15 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" 5 (lambda () "Checked LHS term") e-19 clam-1))) (case (vector-ref act-15 0) ((0) (let ((e-20 (vector-ref act-15 1))) (vector 0 e-20))) (else (let ((act-16 ((CoreC-45NormaliseC-45Eval-getTerm e-4) clam-1))) (case (vector-ref act-16 0) ((0) (let ((e-21 (vector-ref act-16 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-17 (let ((act-17 (unbox arg-1))) (vector 1 act-17)))) (case (vector-ref act-17 0) ((0) (let ((e-22 (vector-ref act-17 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-17 1))) ((let ((eff-0 (let ((u--lhsenv (CoreC-45Env-letToLam arg-11))) (lambda (eta-5) (let ((act-18 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-22 u--lhsenv e-19 eta-5))) (case (vector-ref act-18 0) ((0) (let ((e-23 (vector-ref act-18 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-19 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-22 arg-11 e-21 eta-6))) (case (vector-ref act-19 0) ((0) (let ((e-24 (vector-ref act-19 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-20 ((TTImpC-45ProcessDef-findLinear arg-0 arg-1 1 0 csegen-1416 e-23) eta-7))) (case (vector-ref act-20 0) ((0) (let ((e-25 (vector-ref act-20 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-20 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-21 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" 10 (lambda () "Checked LHS term after normalise") e-23 eta-8))) (case (vector-ref act-21 0) ((0) (let ((e-26 (vector-ref act-21 1))) (vector 0 e-26))) (else (let ((act-22 (CoreC-45ContextC-45Log-log arg-1 "declare.def.lhs" 5 (lambda () (string-append "Linearity of names in " (string-append (PreludeC-45Show-u--show_Show_Int arg-8) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2652 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2652 u--d u--x)))) e-25))))) eta-8))) (case (vector-ref act-22 0) ((0) (let ((e-27 (vector-ref act-22 1))) (vector 0 e-27))) (else (let ((act-23 ((TTImpC-45ProcessDef-combineLinear arg-12 e-25) eta-8))) (case (vector-ref act-23 0) ((0) (let ((e-28 (vector-ref act-23 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-23 1))) ((let ((eff-0 (let ((u--lhstm_lin (TTImpC-45ProcessDef-setLinear e-28 e-23))) (let ((u--lhsty_lin (TTImpC-45ProcessDef-setLinear e-28 e-24))) (lambda (eta-9) (let ((act-24 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" 3 (lambda () "LHS term") u--lhstm_lin eta-9))) (case (vector-ref act-24 0) ((0) (let ((e-29 (vector-ref act-24 1))) (vector 0 e-29))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "declare.def.lhs" 5 (lambda () "LHS type") u--lhsty_lin eta-9))) (case (vector-ref act-25 0) ((0) (let ((e-30 (vector-ref act-25 1))) (vector 0 e-30))) (else (let ((act-26 ((CoreC-45Metadata-setHoleLHS arg-2 (CoreC-45Env-bindEnv arg-0 arg-12 arg-11 u--lhstm_lin)) eta-9))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((act-27 ((TTImpC-45ProcessDef-extendEnv arg-0 arg-11 (vector 0 ) arg-10 u--lhstm_lin u--lhsty_lin) eta-9))) (case (vector-ref act-27 0) ((0) (let ((e-32 (vector-ref act-27 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-27 1))) ((let ((eff-0 (lambda (eta-10) (vector 1 (cons e-14 e-32))))) eff-0) eta-9))))))))))))))))))) eff-0) eta-8)))))))))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))) eff-0) eta-4)))))))) eff-0) clam-1))))))))))))) eff-0) eta-3)))))))))))))))))) eff-0) clam-0))))))))))))))) eff-0) eta-2))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-clearHoleLHS (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 '() e-4 e-10 e-6 e-7 e-8 e-9))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Env-findUsedInBinder (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-3) e-4)))) ((4) (let ((e-8 (vector-ref arg-3 3))) (let ((e-9 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-8) e-9))))(else (CoreC-45Env-findUsed arg-0 arg-1 arg-2 (CoreC-45TTC-45Binder-binderType arg-3))))))
(define CoreC-45Env-n--5978-3773-u--dropS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-2 0) (CoreC-45Env-n--5978-3773-u--dropS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))(else (let ((e-4 (- e-2 1))) (cons e-4 (CoreC-45Env-n--5978-3773-u--dropS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))
(define CoreC-45Env-n--5978-3668-u--eqNat (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-8 arg-9)))
(define CoreC-45Env-n--5978-3748-u--findUsedArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) arg-8 (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (CoreC-45Env-n--5978-3748-u--findUsedArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CoreC-45Env-findUsed arg-0 arg-7 arg-8 e-2) e-3))))))
(define CoreC-45Env-findUsed (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((sc1 (PreludeC-45Types-elemBy csegen-14 (lambda (eta-0) (lambda (eta-1) (CoreC-45Env-n--5978-3668-u--eqNat arg-0 e-4 e-3 e-2 arg-2 arg-1 eta-0 eta-1))) e-4 arg-2))) (cond ((equal? sc1 1) arg-2) (else (CoreC-45Env-findUsedInBinder arg-0 arg-1 (cons e-4 arg-2) (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-0 e-4 arg-1))))))))) ((2) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (CoreC-45Env-n--5978-3748-u--findUsedArgs arg-0 e-7 e-8 e-9 e-10 arg-2 arg-1 arg-1 arg-2 e-10)))))) ((3) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (CoreC-45Env-n--5978-3773-u--dropS arg-0 e-13 e-15 e-14 e-12 arg-2 arg-1 (CoreC-45Env-findUsed (cons e-13 arg-0) (cons e-14 arg-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (+ eta-0 1)) (CoreC-45Env-findUsedInBinder arg-0 arg-1 arg-2 e-14)) e-15))))))) ((4) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-18) e-19)))) ((5) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-23) e-24)))) ((6) (let ((e-28 (vector-ref arg-3 3))) (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-28))) ((7) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (CoreC-45Env-findUsed arg-0 arg-1 (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-32) e-33)))) ((8) (let ((e-37 (vector-ref arg-3 3))) (CoreC-45Env-findUsed arg-0 arg-1 arg-2 e-37)))(else arg-2))))
(define CoreC-45Env-toVar (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (cdr arg-0))) (cond ((equal? arg-1 0) (box 0))(else (let ((e-3 (- arg-1 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Env-toVar e-2 e-3) csegen-965))))))))
(define CoreC-45Env-findUsedLocs (lambda (arg-0 arg-1 arg-2) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CoreC-45Env-toVar arg-0 eta-0)) (CoreC-45Env-findUsed arg-0 arg-1 '() arg-2))))
(define CoreC-45Env-isUsed (lambda (arg-2 arg-3) (if (null? arg-3) 0 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (or (and (= arg-2 e-2) 1) 0))) (cond ((equal? sc1 1) 1) (else (CoreC-45Env-isUsed arg-2 e-3)))))))))
(define CoreC-45Env-mkShrinkSub (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (let ((sc1 (CoreC-45Env-isUsed 0 arg-3))) (cond ((equal? sc1 1) (cons (cons arg-1 '()) (vector 2 (vector 0 )))) (else (cons '() (vector 1 (vector 0 )))))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45Env-mkShrinkSub e-2 e-3 (CoreC-45TTC-45Var-dropFirst arg-3)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (CoreC-45Env-isUsed 0 arg-3))) (cond ((equal? sc2 1) (cons (cons arg-1 e-5) (vector 2 e-4))) (else (cons e-5 (vector 1 e-4)))))))))))))
(define CoreC-45Env-mkShrink (lambda (arg-1 arg-2) (if (null? arg-1) (cons '() (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CoreC-45Env-mkShrinkSub e-2 e-3 arg-2))))))
(define CoreC-45Env-findSubEnv (lambda (arg-0 arg-1 arg-2) (CoreC-45Env-mkShrink arg-0 (CoreC-45Env-findUsedLocs arg-0 arg-1 arg-2))))
(define TTImpC-45ProcessDef-hasEmptyPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-2 arg-3 (CoreC-45TTC-45Binder-binderType e-3)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Coverage-isEmpty arg-0 arg-1 arg-2 arg-3 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ProcessDef-hasEmptyPat (cons e-2 arg-0) arg-1 arg-2 (cons e-3 arg-3) e-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cond ((equal? e-6 1) 1) (else e-7)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))(else (vector 1 0)))))
(define TTImpC-45ProcessDef-mismatchNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((3) (let ((e-34 (vector-ref arg-4 2))) (let ((e-37 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-34))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-7 (car arg-9215))) (let ((e-6 (cdr arg-9215))) (cons (arg-9201 e-7) (arg-9208 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-7 (car arg-9236))) (let ((e-6 (cdr arg-9236))) (cons (arg-9229 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-7 (car arg-9250))) (let ((e-6 (cdr arg-9250))) (cons e-7 (arg-9243 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-37)))))))) ((8) (lambda (eta-0) (vector 1 1))) ((0) (lambda (eta-0) (vector 1 1))) ((10) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((2) (let ((e-52 (vector-ref arg-4 3))) (let ((e-54 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-52))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-54)))))))) ((8) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref arg-4 0) ((8) (let ((e-60 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-14 e-60)))) ((2) (vector 1 1)) ((0) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0)))))) ((5) (let ((e-18 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((5) (let ((e-84 (vector-ref arg-4 3))) (TTImpC-45ProcessDef-mismatchNF arg-0 arg-1 arg-2 e-18 e-84)))(else (lambda (eta-0) (vector 1 0)))))) ((6) (let ((e-23 (vector-ref arg-3 4))) (lambda (clam-1) (case (vector-ref arg-4 0) ((6) (let ((e-89 (vector-ref arg-4 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-23) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-89) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessDef-mismatchNF arg-0 arg-1 arg-2 e-5 e-6))) eff-0) eta-0)))))))) eff-0) clam-1)))))))(else (vector 1 0)))))) ((0) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))) ((10) (lambda (clam-3) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((0) (vector 1 1))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-mismatch (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-0 arg-1 arg-2 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessDef-mismatchNF arg-0 arg-1 arg-2 e-5 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessDef-impossibleOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((3) (let ((e-25 (vector-ref arg-4 2))) (let ((e-28 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-2 e-25))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-7 (car arg-9215))) (let ((e-6 (cdr arg-9215))) (cons (arg-9201 e-7) (arg-9208 e-6))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-7 (car arg-9236))) (let ((e-6 (cdr arg-9236))) (cons (arg-9229 e-7) e-6)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-7 (car arg-9250))) (let ((e-6 (cdr arg-9250))) (cons e-7 (arg-9243 e-6)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-5 e-28)))))))) ((8) (lambda (eta-0) (vector 1 1))) ((0) (lambda (eta-0) (vector 1 1))) ((10) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))) ((2) (let ((e-9 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 5))) (case (vector-ref arg-4 0) ((2) (let ((e-43 (vector-ref arg-4 3))) (let ((e-45 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-9 e-43))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 1))) (else (CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-11 e-45)))))))) ((8) (lambda (eta-0) (vector 1 1)))(else (lambda (eta-0) (vector 1 0))))))) ((8) (let ((e-14 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref arg-4 0) ((8) (let ((e-51 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-14 e-51)))) ((2) (vector 1 1)) ((0) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0)))))) ((0) (lambda (clam-1) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((10) (vector 1 1))(else (vector 1 0))))) ((10) (lambda (clam-2) (case (vector-ref arg-4 0) ((8) (vector 1 1)) ((3) (vector 1 1)) ((0) (vector 1 1))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-impossibleErrOK (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 3))) (let ((e-3 (vector-ref arg-2 4))) (let ((e-4 (vector-ref arg-2 5))) (let ((e-5 (vector-ref arg-2 6))) (let ((u--defs (let ((e-37 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (let ((e-35 (vector-ref arg-1 3))) (let ((e-34 (vector-ref arg-1 4))) (let ((e-33 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (let ((e-31 (vector-ref arg-1 31))) (let ((e-32 (vector-ref arg-1 32))) (vector e-2 e-37 e-36 e-35 e-34 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessDef-impossibleOK arg-0 e-0 u--defs e-6 e-7))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (let ((e-11 (vector-ref arg-2 6))) (let ((u--defs (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-38 (vector-ref arg-1 6))) (let ((e-37 (vector-ref arg-1 7))) (let ((e-36 (vector-ref arg-1 8))) (let ((e-35 (vector-ref arg-1 9))) (let ((e-34 (vector-ref arg-1 10))) (let ((e-33 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (let ((e-31 (vector-ref arg-1 31))) (let ((e-32 (vector-ref arg-1 32))) (vector e-8 e-1 e-2 e-3 e-4 e-5 e-38 e-37 e-36 e-35 e-34 e-33 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-11) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessDef-impossibleOK arg-0 e-6 u--defs e-5 e-12))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((45) (let ((e-15 (vector-ref arg-2 4))) (lambda (clam-0) (cond ((equal? e-15 3) (vector 1 1))(else (vector 1 0)))))) ((4) (lambda (eta-0) (vector 1 1))) ((21) (let ((e-23 (vector-ref arg-2 1))) (CoreC-45Core-anyM (lambda (eta-0) (TTImpC-45ProcessDef-impossibleErrOK arg-0 arg-1 eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-23)))) ((5) (let ((e-30 (vector-ref arg-2 7))) (TTImpC-45ProcessDef-impossibleErrOK arg-0 arg-1 e-30)))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45ProcessDef-n--18911-10663-u--keepOldEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-23 arg-24 arg-25) (case (vector-ref arg-24 0) ((0) (cons arg-23 (vector 0 )))(else (case (vector-ref arg-25 0) ((0) (cons arg-23 (vector 0 )))(else (let ((e-1 (car arg-23))) (let ((e-2 (cdr arg-23))) (case (vector-ref arg-24 0) ((1) (let ((e-7 (vector-ref arg-24 1))) (case (vector-ref arg-25 0) ((1) (let ((e-17 (vector-ref arg-25 1))) (let ((sc3 (TTImpC-45ProcessDef-n--18911-10663-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2 e-7 e-17))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons e-4 (vector 1 e-3))))))) (else (let ((e-22 (vector-ref arg-25 1))) (let ((sc3 (TTImpC-45ProcessDef-n--18911-10663-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2 e-7 e-22))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons (cons e-1 e-4) (vector 2 e-3)))))))))) (else (let ((e-12 (vector-ref arg-24 1))) (case (vector-ref arg-25 0) ((1) (let ((e-27 (vector-ref arg-25 1))) (let ((sc3 (TTImpC-45ProcessDef-n--18911-10663-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2 e-12 e-27))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons (cons e-1 e-4) (vector 2 e-3))))))) (else (let ((e-32 (vector-ref arg-25 1))) (let ((sc3 (TTImpC-45ProcessDef-n--18911-10663-u--keepOldEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2 e-12 e-32))) (let ((e-4 (car sc3))) (let ((e-3 (cdr sc3))) (cons (cons e-1 e-4) (vector 2 e-3)))))))))))))))))))
(define CoreC-45Env-shrinkEnv (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (box arg-2))(else (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (case (vector-ref arg-3 0) ((1) (let ((e-9 (vector-ref arg-3 1))) (CoreC-45Env-shrinkEnv e-4 e-9))) (else (let ((e-14 (vector-ref arg-3 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Env-shrinkEnv e-4 e-14) (lambda (u--envC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkBinder e-3 e-14) (lambda (u--bC-39) (box (cons u--bC-39 u--envC-39)))))))))))))))
(define TTImpC-45ElabC-45Utils-plicit (lambda (arg-1) (case (vector-ref arg-1 0) ((2) (let ((e-3 (vector-ref arg-1 3))) (CoreC-45TTC-45Binder-forgetDef e-3))) ((3) (let ((e-8 (vector-ref arg-1 3))) (CoreC-45TTC-45Binder-forgetDef e-8)))(else (vector 1 )))))
(define CoreC-45TT-refToLocal (lambda (arg-1 arg-2 arg-3) (CoreC-45TT-refsToLocals (vector 1 arg-2 arg-1 (vector 0 )) arg-3)))
(define TTImpC-45ElabC-45Utils-bindNotReq (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-1) (cons arg-6 arg-7) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-10 (car arg-4))) (let ((e-11 (cdr arg-4))) (case (vector-ref arg-5 0) ((0) (let ((u--tmptm (CoreC-45TTC-45TermC-45Subst-subst (vector 1 arg-2 (vector 0 ) (vector 2 "arg" arg-3)) arg-7))) (let ((sc3 (TTImpC-45ElabC-45Utils-bindNotReq e-3 arg-2 (bs+ (blodwen-toSignedInt 1 63) arg-3 63) e-11 (vector 0 ) arg-6 u--tmptm))) (let ((e-5 (car sc3))) (let ((e-4 (cdr sc3))) (cons e-5 (CoreC-45TT-refToLocal (vector 2 "arg" arg-3) e-2 e-4))))))) ((2) (let ((e-18 (vector-ref arg-5 1))) (let ((u--tmptm (CoreC-45TTC-45TermC-45Subst-subst (vector 1 arg-2 (vector 0 ) (vector 2 "arg" arg-3)) arg-7))) (let ((sc3 (TTImpC-45ElabC-45Utils-bindNotReq e-3 arg-2 (bs+ (blodwen-toSignedInt 1 63) arg-3 63) e-11 e-18 arg-6 u--tmptm))) (let ((e-5 (car sc3))) (let ((e-4 (cdr sc3))) (cons e-5 (CoreC-45TT-refToLocal (vector 2 "arg" arg-3) e-2 e-4)))))))) (else (let ((e-23 (vector-ref arg-5 1))) (TTImpC-45ElabC-45Utils-bindNotReq e-3 arg-2 arg-3 e-11 e-23 (cons (cons (TTImpC-45ElabC-45Utils-plicit e-10) e-2) arg-6) (vector 3 arg-2 e-2 (vector 2 (CoreC-45TTC-45Binder-binderLoc e-10) (CoreC-45TTC-45Binder-multiplicity e-10) (vector 1 ) (CoreC-45TTC-45Binder-binderType e-10)) arg-7))))))))))))
(define TTImpC-45ElabC-45Utils-n--9537-9263-u--notLets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-7 (car arg-8))) (let ((e-8 (cdr arg-8))) (let ((sc2 (CoreC-45TTC-45Binder-isLet e-7))) (cond ((equal? sc2 1) (TTImpC-45ElabC-45Utils-n--9537-9263-u--notLets arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 e-3 e-8)) (else (TTImpC-45ElabC-45Utils-n--9537-9263-u--notLets arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-6) e-3 e-8)))))))))))
(define TTImpC-45ElabC-45Utils-bindReq (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-4 0) ((0) (box (cons arg-5 (cons (TTImpC-45ElabC-45Utils-n--9537-9263-u--notLets arg-1 arg-6 arg-5 arg-3 arg-2 '() arg-1 arg-3) (CoreC-45Env-abstractEnvType arg-1 arg-2 arg-3 arg-6)))))(else (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (case (vector-ref arg-4 0) ((2) (let ((e-12 (vector-ref arg-4 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-shrinkBinder e-6 e-12) (lambda (u--bC-39) (TTImpC-45ElabC-45Utils-bindReq e-2 arg-2 e-7 e-12 (cons (cons (TTImpC-45ElabC-45Utils-plicit e-6) e-1) arg-5) (vector 3 arg-2 e-1 (vector 2 (CoreC-45TTC-45Binder-binderLoc e-6) (CoreC-45TTC-45Binder-multiplicity e-6) (vector 1 ) (CoreC-45TTC-45Binder-binderType u--bC-39)) arg-6)))))) (else (let ((e-17 (vector-ref arg-4 1))) (TTImpC-45ElabC-45Utils-bindReq e-2 arg-2 e-7 e-17 arg-5 arg-6))))))))))))
(define CoreC-45Normalise-n--9336-8187-u--repArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-5 eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Normalise-n--9336-8188-u--repSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (u--c) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 u--c) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Normalise-n--9336-8188-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5))) eff-0) eta-0))))))) e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (vector 2 "tmp" arg-6))) (lambda (eta-0) (let ((act-2 (let ((act-2 (((e-4 arg-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-4 (vector 1 e-1 (vector 0 ) u--xC-39))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 (bs+ arg-6 1 63) arg-5 arg-4 arg-3 arg-2 e-6 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-1 e-2 e-5 (CoreC-45TT-refsToLocals (vector 1 e-2 u--xC-39 (vector 0 )) e-6)))))) eff-0) eta-0))))))))) eff-0) clam-0)))))))))) ((1) (let ((e-6 (vector-ref arg-8 1))) (let ((e-7 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (if (null? e-8) (let ((act-1 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 (vector 1 e-6 e-7 '()) eta-0)))) eff-0) clam-0))))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Normalise-n--9336-8187-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1 eta-2))) eta-0)) e-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 (vector 1 e-6 e-7 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-9 e-5))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((2) (let ((e-10 (vector-ref arg-8 1))) (let ((e-11 (vector-ref arg-8 2))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-13 (vector-ref arg-8 4))) (let ((e-14 (vector-ref arg-8 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Normalise-n--9336-8187-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1 eta-2))) eta-0)) e-14 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-6 arg-4 (vector 2 e-10 e-11 e-12 e-13 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-7 e-5))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))) ((3) (let ((e-16 (vector-ref arg-8 1))) (let ((e-17 (vector-ref arg-8 2))) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (let ((e-20 (vector-ref arg-8 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Normalise-n--9336-8187-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1 eta-2))) eta-0)) e-20 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-6 arg-4 (vector 3 e-16 e-17 e-18 e-19 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-7 e-5))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))) ((4) (let ((e-22 (vector-ref arg-8 1))) (let ((e-23 (vector-ref arg-8 2))) (let ((e-24 (vector-ref arg-8 3))) (let ((e-25 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45Normalise-n--9336-8188-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-24) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Normalise-n--9336-8188-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-25) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-22 e-23 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((5) (let ((e-27 (vector-ref arg-8 1))) (let ((e-28 (vector-ref arg-8 2))) (let ((e-29 (vector-ref arg-8 3))) (let ((act-1 ((CoreC-45Normalise-n--9336-8188-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-29) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-27 e-28 e-5))))) eff-0) clam-0))))))))) ((6) (let ((e-31 (vector-ref arg-8 1))) (let ((e-32 (vector-ref arg-8 2))) (let ((e-33 (vector-ref arg-8 3))) (let ((e-34 (vector-ref arg-8 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 e-33) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-5 eta-0)))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-0 arg-5 e-34) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Normalise-replaceC-39 arg-7 arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 e-6 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-31 e-32 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((7) (let ((e-36 (vector-ref arg-8 1))) (let ((e-37 (vector-ref arg-8 2))) (let ((e-38 (vector-ref arg-8 3))) (let ((e-39 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Core-traversePair (lambda (eta-1) (lambda (eta-2) (CoreC-45Normalise-n--9336-8187-u--repArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-1 eta-2))) eta-0)) e-39 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Normalise-n--9336-8188-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-38) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 8 e-36 e-37 e-6) e-5))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((9) (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (case (vector-ref e-42 0) ((2) (let ((e-45 (vector-ref e-42 1))) (let ((act-1 ((CoreC-45Normalise-n--9336-8188-u--repSub arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-45) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-41 (vector 2 e-5)))))) eff-0) clam-0)))))))(else (let ((act-1 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-8 eta-0)))) eff-0) clam-0))))))))))(else (let ((act-1 (CoreC-45Context-clearDefs arg-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 arg-0 e-5 arg-4 arg-8 eta-0)))) eff-0) clam-0))))))))))
(define CoreC-45Normalise-replaceC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-0 arg-1 arg-3 arg-4 arg-5 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (lambda (eta-0) (vector 1 arg-6))) (else (CoreC-45Normalise-n--9336-8188-u--repSub arg-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 arg-7))))) eff-0) ext-0)))))))
(define CoreC-45Normalise-replace (lambda (arg-0 arg-1 ext-5 ext-1 ext-2 ext-3 ext-4 ext-0) (CoreC-45Normalise-replaceC-39 arg-0 arg-1 0 ext-5 ext-1 ext-2 ext-3 ext-4 ext-0)))
(define TTImpC-45TTImp-u--C-61C-61_Eq_WithFlag (lambda (arg-0 arg-1) 1))
(define TTImpC-45TTImp-u--C-47C-61_Eq_WithFlag (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45TTImp-u--C-61C-61_Eq_WithFlag arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45ProcessDef-n--18911-10666-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (CoreC-45FC-virtualiseFC arg-6)))
(define TTImpC-45ProcessDef-n--20152-10748-u--wargn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-22 arg-23 arg-24) (vector 2 "warg" 0)))
(define TTImpC-45ProcessDef-n--20337-10933-u--wargn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39) (vector 2 "warg" 0)))
(define TTImpC-45ProcessDef-n--20152-10749-u--wargs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-22 arg-23 arg-24) (cons (TTImpC-45ProcessDef-n--20152-10748-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-22 arg-23 arg-24) '())))
(define TTImpC-45ProcessDef-n--20337-10934-u--wargs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39) (cons arg-21 (cons (TTImpC-45ProcessDef-n--20337-10933-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39) '()))))
(define TTImpC-45ProcessDef-n--18911-10662-u--bindWithArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-22 arg-23 arg-24 arg-25) (if (null? arg-24) (let ((u--scenv (cons (vector 2 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) arg-23) arg-25))) (let ((u--var (vector 0 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (box 0) 0))) (let ((u--binder (lambda (eta-0) (vector 3 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (TTImpC-45ProcessDef-n--20152-10748-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-25 arg-23 arg-22) (vector 2 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) arg-22 (vector 1 ) arg-23) eta-0)))) (lambda (eta-0) (vector 1 (cons (TTImpC-45ProcessDef-n--20152-10749-u--wargs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-25 arg-23 arg-22) (cons u--scenv (cons u--var u--binder)))))))) (let ((e-2 (unbox arg-24))) (lambda (clam-0) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-1 (let ((act-1 (unbox arg-20))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--eqName (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "Equal"))))) (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact u--eqName (let ((e-0 (vector-ref e-7 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Cannot find builtin Equal") clam-1) (let ((e-1 (unbox e-8))) (case (vector-ref e-1 0) ((6) (let ((e-14 (vector-ref e-1 1))) (let ((e-3 (vector-ref e-1 2))) (let ((e-4 (vector-ref e-1 3))) (let ((e-13 (vector-ref e-1 4))) (let ((e-12 (vector-ref e-1 5))) (let ((e-11 (vector-ref e-1 6))) (let ((e-10 (vector-ref e-1 7))) (let ((e-9 (vector-ref e-1 8))) (let ((act-3 (CoreC-45Context-toResolvedNames arg-20 csegen-54 u--eqName clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--eqTyCon (vector 1 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (vector 3 e-14 e-3) e-15))) (let ((u--wvalTyC-39 (let ((sc7 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-17 (car sc7))) (((e-17 'erased) 'erased) arg-23))))) (let ((u--eqTy (CoreC-45TTC-45Term-apply (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) u--eqTyCon (cons u--wvalTyC-39 (cons u--wvalTyC-39 (cons (let ((sc7 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-17 (car sc7))) (((e-17 'erased) 'erased) e-6))) (cons (vector 0 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (box 0) 0) '()))))))) (let ((u--scenv (cons (vector 2 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 0 ) u--eqTy) (cons (vector 2 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) arg-23) arg-25)))) (let ((u--var (vector 0 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (box 0) 1))) (let ((u--binder (lambda (u--t) (vector 3 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (TTImpC-45ProcessDef-n--20337-10933-u--wargn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5 e-6 arg-25 arg-23 arg-22 e-7 u--eqName e-4 e-13 e-12 e-11 e-10 e-9 e-3 e-14 e-8 e-15 u--eqTyCon) (vector 2 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) arg-22 (vector 1 ) arg-23) (vector 3 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) e-5 (vector 2 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) arg-22 (vector 0 ) u--eqTy) u--t))))) (lambda (eta-1) (vector 1 (cons (TTImpC-45ProcessDef-n--20337-10934-u--wargs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5 e-6 arg-25 arg-23 arg-22 e-7 u--eqName e-4 e-13 e-12 e-11 e-10 e-9 e-3 e-14 e-8 e-15 u--eqTyCon) (cons u--scenv (cons u--var u--binder))))))))))))) eff-0) clam-1))))))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Cannot find builtin Equal") clam-1)))))))) eff-0) eta-0))))))))) eff-0) clam-0))))))))))))
(define TTImpC-45ProcessDef-n--18911-10665-u--mkExplicit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-22) (if (null? arg-22) '() (let ((e-4 (car arg-22))) (let ((e-5 (cdr arg-22))) (case (vector-ref e-4 0) ((2) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-10 (vector-ref e-4 4))) (cons (vector 2 e-7 e-8 (vector 1 ) e-10) (TTImpC-45ProcessDef-n--18911-10665-u--mkExplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5))))))(else (cons e-4 (TTImpC-45ProcessDef-n--18911-10665-u--mkExplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5)))))))))
(define CoreC-45Env-allVars (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (let ((e-9 (cdr arg-1))) (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc2 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) eta-0)))) (CoreC-45Env-allVars e-3 e-9))))))))
(define CoreC-45Env-allVarsNoLet (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (let ((e-8 (car arg-1))) (let ((e-9 (cdr arg-1))) (case (vector-ref e-8 0) ((1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) (CoreC-45Env-allVars e-3 e-9)))(else (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc2 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) eta-0)))) (CoreC-45Env-allVars e-3 e-9)))))))))))
(define CoreC-45UnifyState-applyTo (lambda (arg-0 arg-1 arg-2 arg-3) (let ((u--args (PreludeC-45TypesC-45List-reverse (CoreC-45UnifyState-mkConstantAppArgs arg-0 0 arg-1 arg-3 '())))) (CoreC-45TTC-45Term-apply arg-1 arg-2 u--args))))
(define TTImpC-45ProcessDef-applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-resolveName arg-1 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-3 (cons (box arg-3) (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVarsNoLet arg-0 arg-2)) (lambda (u--fc) (lambda (u--nt) (CoreC-45UnifyState-applyTo arg-0 u--fc (vector 1 u--fc u--nt (vector 8 e-5)) arg-2)))))))))) eff-0) ext-0)))))))
(define TTImpC-45TTImp-n--14863-8147-u--app (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (vector 8 (TTImpC-45TTImp-getFC arg-4) arg-4 arg-6) (let ((e-2 (unbox arg-5))) (vector 10 (TTImpC-45TTImp-getFC arg-4) arg-4 e-2 arg-6)))))
(define TTImpC-45TTImp-gapply (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (TTImpC-45TTImp-gapply (PreludeC-45Basics-uncurry (lambda (eta-0) (lambda (eta-1) (TTImpC-45TTImp-n--14863-8147-u--app e-2 e-3 arg-1 arg-1 eta-0 eta-1))) e-2) e-3))))))
(define CoreC-45UnifyState-genWithName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Context-inCurrentNS arg-0 (vector 7 arg-2 (let ((e-8 (vector-ref e-5 8))) e-8)) eta-0))))))) eff-0) ext-0)))))))
(define TTImpC-45WithClause-n--9359-10402-u--dropWithArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (cond ((equal? arg-10 0) (lambda (eta-0) (vector 1 (cons arg-11 '()))))(else (let ((e-0 (- arg-10 1))) (lambda (clam-0) (case (vector-ref arg-11 0) ((8) (let ((e-3 (vector-ref arg-11 2))) (let ((e-4 (vector-ref arg-11 3))) (let ((act-1 ((TTImpC-45WithClause-n--9359-10402-u--dropWithArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-0 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-5))) (let ((e-6 (cdr e-5))) (vector 1 (cons e-7 (cons e-4 e-6)))))))) eff-0) clam-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-7 "Badly formed 'with' clause") clam-0)))))))))
(define CoreC-45Name-isBasic (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define CoreC-45Name-isUN (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (box (cons CoreC-45NameC-45Namespace-emptyNS e-0)))) ((0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (let ((e-4 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons (CoreC-45NameC-45Namespace-C-60C-46C-62 e-1 e-4) e-3)))) (CoreC-45Name-isUN e-2)))))(else '()))))
(define TTImpC-45WithClause-getArgMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) arg-3 (cond ((equal? arg-2 1) (if (null? arg-5) (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc5 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup csegen-22 u--n arg-4)))))))) (if (null? sc5) (let ((u--arg (vector 32 arg-0 1))) (let ((sc6 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc6 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc5))) e-2))))) (let ((e-7 (unbox arg-5))) (if (null? e-7) (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc6 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup csegen-22 u--n arg-4)))))))) (if (null? sc6) (let ((u--arg (vector 32 arg-0 1))) (let ((sc7 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc7 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc6))) e-2))))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-10 0) ((2) (let ((sc5 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-11) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup csegen-22 u--n arg-4)))))))) (if (null? sc5) (let ((u--arg (vector 12 arg-0 500))) (let ((sc6 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc6 1) (vector 18 arg-0 arg-0 0 e-11 u--arg)) (else u--arg)))) (let ((e-1 (unbox sc5))) e-1))))(else (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc6 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup csegen-22 u--n arg-4)))))))) (if (null? sc6) (let ((u--arg (vector 32 arg-0 1))) (let ((sc7 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc7 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc6))) e-2)))))))))))))(else (let ((e-1 (unbox arg-5))) (let ((e-5 (cdr e-1))) (let ((sc3 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isUN e-5) (lambda (lamc-0) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Name-isBasic e-3) (lambda (u--n) (DataC-45List-lookup csegen-22 u--n arg-4)))))))) (if (null? sc3) (let ((u--arg (vector 32 arg-0 1))) (let ((sc4 (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-1)))) (cond ((equal? sc4 1) (vector 18 arg-0 arg-0 0 e-5 u--arg)) (else u--arg)))) (let ((e-2 (unbox sc3))) e-2))))))))))
(define TTImpC-45WithClause-getHeadLoc (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 1))) (lambda (eta-0) (vector 1 e-1)))) ((8) (let ((e-5 (vector-ref arg-0 2))) (TTImpC-45WithClause-getHeadLoc e-5))) ((9) (let ((e-9 (vector-ref arg-0 2))) (TTImpC-45WithClause-getHeadLoc e-9))) ((10) (let ((e-13 (vector-ref arg-0 2))) (TTImpC-45WithClause-getHeadLoc e-13)))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Could not find head of LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-0))) eta-0))))))
(define CoreC-45Metadata-addSemanticAlias (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-10 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 e-4 e-10 e-6 e-7 (LibrariesC-45DataC-45PosMap-insert (lambda (eta-0) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-0)) (cons arg-1 arg-2) e-8) e-9)))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45WithClause-addAlias (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (let ((sc0 (CoreC-45FC-isConcreteFC arg-2))) (if (null? sc0) (vector 1 (vector 0 )) (let ((e-1 (unbox sc0))) (let ((sc1 (CoreC-45FC-isConcreteFC arg-3))) (if (null? sc1) (vector 1 (vector 0 )) (let ((e-2 (unbox sc1))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.highlight.alias" 25 (lambda () (string-append "Adding alias: " (string-append (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2043 e-1) (string-append " -> " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2043 e-2))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else ((CoreC-45Metadata-addSemanticAlias arg-0 e-1 e-2) clam-0)))))))))))))
(define TTImpC-45WithClause-mergeMatches (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (DataC-45List-lookup csegen-22 e-6 e-5))) (if (null? sc3) (vector 1 (cons (cons e-6 e-7) e-5)) (let ((e-4 (unbox sc3))) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-7 e-4) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (vector 1 e-5)))))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45WithClause-matchAll (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-6 e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-tailRecAppend e-8 e-5)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45WithClause-matchFail (lambda (arg-1 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "With clause does not match parent") ext-0)))
(define TTImpC-45WithClause-matchAny (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (TTImpC-45WithClause-matchFail arg-2 clam-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45Core-u--catch_Catchable_Core_Error (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-3 e-6 e-7) (lambda (u--err) (TTImpC-45WithClause-matchAny arg-0 arg-1 arg-2 arg-3 e-3)) clam-0)))))))))
(define TTImpC-45WithClause-getMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((17) (let ((e-133 (vector-ref arg-3 1))) (let ((e-134 (vector-ref arg-3 2))) (lambda (clam-0) (case (vector-ref arg-4 0) ((17) (let ((e-139 (vector-ref arg-4 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (vector 1 (cons (cons e-134 arg-4) '()))))) (TTImpC-45WithClause-addAlias arg-0 arg-1 e-139 e-133) clam-0)))(else (vector 1 (cons (cons e-134 arg-4) '())))))))) ((32) (lambda (eta-0) (vector 1 '())))(else (case (vector-ref arg-4 0) ((19) (let ((e-130 (vector-ref arg-4 2))) (cond ((equal? e-130 4) (lambda (eta-0) (vector 1 '())))(else (case (vector-ref arg-3 0) ((0) (let ((e-68 (vector-ref arg-3 1))) (let ((e-69 (vector-ref arg-3 2))) (case (vector-ref e-69 0) ((0) (let ((e-97 (vector-ref e-69 1))) (let ((e-98 (vector-ref e-69 2))) (case (vector-ref arg-4 0) ((0) (let ((e-100 (vector-ref arg-4 1))) (let ((e-101 (vector-ref arg-4 2))) (case (vector-ref e-101 0) ((0) (let ((e-102 (vector-ref e-101 1))) (let ((e-103 (vector-ref e-101 2))) (lambda (clam-0) (let ((sc5 (let ((sc6 (CoreC-45Name-u--C-61C-61_Eq_Name e-98 e-103))) (cond ((equal? sc6 1) (CoreC-45NameC-45Namespace-isParentOf e-102 e-97)) (else 0))))) (cond ((equal? sc5 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-100 e-68) clam-0)) (else (TTImpC-45WithClause-matchFail e-100 clam-0))))))))(else (lambda (clam-1) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-98 e-101))) (cond ((equal? sc4 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-100 e-68) clam-1)) (else (TTImpC-45WithClause-matchFail e-100 clam-1))))))))))(else (case (vector-ref arg-4 0) ((0) (let ((e-95 (vector-ref arg-4 1))) (let ((e-96 (vector-ref arg-4 2))) (lambda (clam-2) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-69 e-96))) (cond ((equal? sc4 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-95 e-68) clam-2)) (else (TTImpC-45WithClause-matchFail e-95 clam-2))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-3) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-3))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-4) (let ((sc7 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc7 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-4)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-5) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-5))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-5)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-5))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-6) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-6))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-7) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-7)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-8) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-8))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-9) (let ((sc7 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc7 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-9)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-10) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-10))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-10))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-10))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-10)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-10))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-10))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-11) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-11))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-12) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-12)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-13) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-13))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-14) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-14)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-15) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-15))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-15)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-15))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-16) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-16))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-17) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-17)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))))(else (case (vector-ref arg-4 0) ((0) (let ((e-95 (vector-ref arg-4 1))) (let ((e-96 (vector-ref arg-4 2))) (lambda (clam-18) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-69 e-96))) (cond ((equal? sc3 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-95 e-68) clam-18)) (else (TTImpC-45WithClause-matchFail e-95 clam-18))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-19) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-19))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-20) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-20)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-21) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-21))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-21))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-21))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-21)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-21))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-21))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-22) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-22))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-23) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-23)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-24) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-24))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-25) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-25)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-26) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-26))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-26))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-26))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-26)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-26))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-26))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-27) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-27))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-28) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-28)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-29) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-29))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-30) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-30)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-31) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-31))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-31))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-31))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-31)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-31))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-31))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-32) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-32))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-33) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-33)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))))) ((1) (let ((e-72 (vector-ref arg-3 2))) (let ((e-73 (vector-ref arg-3 3))) (let ((e-74 (vector-ref arg-3 4))) (let ((e-75 (vector-ref arg-3 5))) (let ((e-76 (vector-ref arg-3 6))) (case (vector-ref arg-4 0) ((1) (let ((e-105 (vector-ref arg-4 1))) (let ((e-106 (vector-ref arg-4 2))) (let ((e-107 (vector-ref arg-4 3))) (let ((e-108 (vector-ref arg-4 4))) (let ((e-109 (vector-ref arg-4 5))) (let ((e-110 (vector-ref arg-4 6))) (let ((sc3 (let ((sc4 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-72 e-106))) (cond ((equal? sc4 1) (let ((sc5 (CoreC-45TTC-45Binder-eqPiInfoBy (lambda (_-9477) (lambda (_-9480) 1)) e-73 e-107))) (cond ((equal? sc5 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-832 e-74 e-108)) (else 0)))) (else 0))))) (cond ((equal? sc3 1) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-75 e-109) (cons (cons e-76 e-110) '())))) (else (lambda (eta-0) (TTImpC-45WithClause-matchFail e-105 eta-0))))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-34) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-34))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-35) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-35)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-36) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-36))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-36))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-36))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-36)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-36))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-36))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-37) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-37))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-38) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-38)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-39) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-39))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-40) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-40)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-41) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-41))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-41))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-41))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-41)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-41))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-41))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-42) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-42))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-43) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-43)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-44) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-44))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-45) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-45)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-46) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-46))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-46))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-46))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-46)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-46))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-46))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-47) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-47))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-48) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-48)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))))) ((8) (let ((e-79 (vector-ref arg-3 2))) (let ((e-80 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-113 (vector-ref arg-4 2))) (let ((e-114 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-79 e-113) (cons (cons e-80 e-114) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-49) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-49))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-50) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-50)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-51) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-51))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-51))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-51))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-51)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-51))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-51))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-52) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-52))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-53) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-53)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-54) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-54))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-55) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-55)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-56) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-56))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-56))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-56))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-56)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-56))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-56))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-57) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-57))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-58) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-58)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-59) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-59))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-60) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-60)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-61) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-61))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-61))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-61))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-61)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-61))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-61))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-62) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-62))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-63) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-63)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))) ((9) (let ((e-83 (vector-ref arg-3 2))) (let ((e-84 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((9) (let ((e-117 (vector-ref arg-4 2))) (let ((e-118 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-83 e-117) (cons (cons e-84 e-118) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-64) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-64))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-65) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-65)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-66) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-66))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-66))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-66))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-66)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-66))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-66))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-67) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-67))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-68) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-68)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-69) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-69))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-70) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-70)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-71) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-71))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-71))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-71))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-71)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-71))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-71))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-72) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-72))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-73) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-73)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-74) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-74))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-75) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-75)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-76) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-76))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-76))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-76))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-76)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-76))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-76))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-77) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-77))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-78) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-78)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))) ((10) (let ((e-87 (vector-ref arg-3 2))) (let ((e-88 (vector-ref arg-3 3))) (let ((e-89 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((10) (let ((e-120 (vector-ref arg-4 1))) (let ((e-121 (vector-ref arg-4 2))) (let ((e-122 (vector-ref arg-4 3))) (let ((e-123 (vector-ref arg-4 4))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-88 e-122))) (cond ((equal? sc3 1) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-87 e-121) (cons (cons e-89 e-123) '())))) (else (lambda (eta-0) (TTImpC-45WithClause-matchFail e-120 eta-0))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-79) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-79))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-80) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-80)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-81) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-81))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-81))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-81))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-81)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-81))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-81))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-82) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-82))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-83) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-83)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-84) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-84))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-85) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-85)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-86) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-86))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-86))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-86))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-86)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-86))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-86))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-87) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-87))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-88) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-88)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-89) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-89))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-90) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-90)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-91) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-91))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-91))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-91))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-91)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-91))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-91))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-92) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-92))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-93) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-93)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))) ((11) (let ((e-92 (vector-ref arg-3 2))) (let ((e-93 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((11) (let ((e-126 (vector-ref arg-4 2))) (let ((e-127 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-92 e-126) (cons (cons e-93 e-127) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-94) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-94))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-95) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-95)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-96) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-96))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-96))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-96))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-96)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-96))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-96))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-97) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-97))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-98) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-98)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-99) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-99))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-100) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-100)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-101) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-101))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-101))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-101))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-101)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-101))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-101))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-102) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-102))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-103) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-103)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-104) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-104))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-105) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-105)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-106) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-106))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-106))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-106))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-106)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-106))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-106))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-107) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-107))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-108) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-108)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-109) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-109))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-110) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-110)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-111) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-111))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-111))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-111))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-111)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-111))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-111))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-112) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-112))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-113) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-113)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-114) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-114))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-115) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-115)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-116) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-116))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-116))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-116))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-116)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-116))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-116))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-117) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-117))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-118) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-118)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-119) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-119))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-120) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-120)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-121) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-121))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-121))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-121))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-121)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-121))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-121))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-122) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-122))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-123) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-123)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))))(else (case (vector-ref arg-3 0) ((0) (let ((e-68 (vector-ref arg-3 1))) (let ((e-69 (vector-ref arg-3 2))) (case (vector-ref e-69 0) ((0) (let ((e-97 (vector-ref e-69 1))) (let ((e-98 (vector-ref e-69 2))) (case (vector-ref arg-4 0) ((0) (let ((e-100 (vector-ref arg-4 1))) (let ((e-101 (vector-ref arg-4 2))) (case (vector-ref e-101 0) ((0) (let ((e-102 (vector-ref e-101 1))) (let ((e-103 (vector-ref e-101 2))) (lambda (clam-124) (let ((sc4 (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name e-98 e-103))) (cond ((equal? sc5 1) (CoreC-45NameC-45Namespace-isParentOf e-102 e-97)) (else 0))))) (cond ((equal? sc4 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-100 e-68) clam-124)) (else (TTImpC-45WithClause-matchFail e-100 clam-124))))))))(else (lambda (clam-125) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-98 e-101))) (cond ((equal? sc3 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-100 e-68) clam-125)) (else (TTImpC-45WithClause-matchFail e-100 clam-125))))))))))(else (case (vector-ref arg-4 0) ((0) (let ((e-95 (vector-ref arg-4 1))) (let ((e-96 (vector-ref arg-4 2))) (lambda (clam-126) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-69 e-96))) (cond ((equal? sc3 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-95 e-68) clam-126)) (else (TTImpC-45WithClause-matchFail e-95 clam-126))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-127) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-127))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-128) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-128)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-129) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-129))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-129))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-129))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-129)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-129))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-129))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-130) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-130))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-131) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-131)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-132) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-132))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-133) (let ((sc6 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc6 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-133)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-134) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-134))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-134))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-134))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-134)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-134))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-134))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-135) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-135))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-136) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-136)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-137) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-137))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-138) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-138)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-139) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-139))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-139))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-139))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-139)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-139))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-139))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-140) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-140))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-141) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-141)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))))(else (case (vector-ref arg-4 0) ((0) (let ((e-95 (vector-ref arg-4 1))) (let ((e-96 (vector-ref arg-4 2))) (lambda (clam-142) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-69 e-96))) (cond ((equal? sc2 1) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (TTImpC-45WithClause-addAlias arg-0 arg-1 e-95 e-68) clam-142)) (else (TTImpC-45WithClause-matchFail e-95 clam-142))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-143) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-143))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-144) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-144)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-145) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-145))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-145))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-145))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-145)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-145))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-145))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-146) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-146))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-147) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-147)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-148) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-148))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-149) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-149)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-150) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-150))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-150))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-150))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-150)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-150))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-150))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-151) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-151))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-152) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-152)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-153) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-153))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-154) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-154)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-155) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-155))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-155))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-155))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-155)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-155))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-155))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-156) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-156))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-157) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-157)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))))) ((1) (let ((e-72 (vector-ref arg-3 2))) (let ((e-73 (vector-ref arg-3 3))) (let ((e-74 (vector-ref arg-3 4))) (let ((e-75 (vector-ref arg-3 5))) (let ((e-76 (vector-ref arg-3 6))) (case (vector-ref arg-4 0) ((1) (let ((e-105 (vector-ref arg-4 1))) (let ((e-106 (vector-ref arg-4 2))) (let ((e-107 (vector-ref arg-4 3))) (let ((e-108 (vector-ref arg-4 4))) (let ((e-109 (vector-ref arg-4 5))) (let ((e-110 (vector-ref arg-4 6))) (let ((sc2 (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-72 e-106))) (cond ((equal? sc3 1) (let ((sc4 (CoreC-45TTC-45Binder-eqPiInfoBy (lambda (_-9477) (lambda (_-9480) 1)) e-73 e-107))) (cond ((equal? sc4 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-832 e-74 e-108)) (else 0)))) (else 0))))) (cond ((equal? sc2 1) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-75 e-109) (cons (cons e-76 e-110) '())))) (else (lambda (eta-0) (TTImpC-45WithClause-matchFail e-105 eta-0))))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-158) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-158))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-159) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-159)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-160) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-160))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-160))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-160))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-160)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-160))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-160))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-161) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-161))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-162) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-162)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-163) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-163))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-164) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-164)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-165) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-165))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-165))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-165))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-165)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-165))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-165))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-166) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-166))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-167) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-167)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-168) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-168))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-169) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-169)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-170) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-170))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-170))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-170))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-170)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-170))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-170))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-171) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-171))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-172) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-172)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))))) ((8) (let ((e-79 (vector-ref arg-3 2))) (let ((e-80 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((8) (let ((e-113 (vector-ref arg-4 2))) (let ((e-114 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-79 e-113) (cons (cons e-80 e-114) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-173) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-173))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-174) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-174)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-175) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-175))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-175))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-175))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-175)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-175))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-175))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-176) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-176))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-177) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-177)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-178) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-178))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-179) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-179)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-180) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-180))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-180))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-180))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-180)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-180))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-180))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-181) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-181))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-182) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-182)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-183) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-183))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-184) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-184)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-185) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-185))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-185))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-185))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-185)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-185))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-185))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-186) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-186))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-187) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-187)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))) ((9) (let ((e-83 (vector-ref arg-3 2))) (let ((e-84 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((9) (let ((e-117 (vector-ref arg-4 2))) (let ((e-118 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-83 e-117) (cons (cons e-84 e-118) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-188) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-188))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-189) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-189)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-190) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-190))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-190))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-190))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-190)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-190))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-190))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-191) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-191))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-192) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-192)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-193) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-193))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-194) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-194)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-195) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-195))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-195))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-195))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-195)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-195))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-195))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-196) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-196))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-197) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-197)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-198) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-198))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-199) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-199)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-200) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-200))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-200))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-200))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-200)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-200))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-200))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-201) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-201))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-202) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-202)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))) ((10) (let ((e-87 (vector-ref arg-3 2))) (let ((e-88 (vector-ref arg-3 3))) (let ((e-89 (vector-ref arg-3 4))) (case (vector-ref arg-4 0) ((10) (let ((e-120 (vector-ref arg-4 1))) (let ((e-121 (vector-ref arg-4 2))) (let ((e-122 (vector-ref arg-4 3))) (let ((e-123 (vector-ref arg-4 4))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-88 e-122))) (cond ((equal? sc2 1) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-87 e-121) (cons (cons e-89 e-123) '())))) (else (lambda (eta-0) (TTImpC-45WithClause-matchFail e-120 eta-0))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-203) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-203))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-204) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-204)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-205) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-205))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-205))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-205))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-205)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-205))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-205))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-206) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-206))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-207) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-207)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-208) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-208))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-209) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-209)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-210) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-210))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-210))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-210))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-210)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-210))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-210))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-211) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-211))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-212) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-212)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-213) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-213))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-214) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-214)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-215) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-215))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-215))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-215))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-215)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-215))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-215))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-216) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-216))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-217) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-217)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))) ((11) (let ((e-92 (vector-ref arg-3 2))) (let ((e-93 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((11) (let ((e-126 (vector-ref arg-4 2))) (let ((e-127 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 arg-2 (cons (cons e-92 e-126) (cons (cons e-93 e-127) '()))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-218) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-218))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-219) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-219)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-220) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-220))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-220))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-220))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-220)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-220))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-220))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-221) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-221))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-222) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-222)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-223) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-223))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-224) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc5 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-224)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-225) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-225))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-225))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-225))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-225)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-225))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-225))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-226) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-226))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-227) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-227)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-228) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-228))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-229) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-229)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-230) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-230))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-230))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-230))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-230)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-230))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-230))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-231) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-231))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-232) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-232)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-3 0) ((10) (let ((e-51 (vector-ref arg-3 2))) (let ((e-53 (vector-ref arg-3 4))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-51 arg-4) (cons (cons e-53 e-53) '())))))) ((9) (let ((e-56 (vector-ref arg-3 2))) (let ((e-57 (vector-ref arg-3 3))) (TTImpC-45WithClause-matchAll arg-0 arg-1 1 (cons (cons e-56 arg-4) (cons (cons e-57 e-57) '()))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-233) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-233))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-234) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-234)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-235) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-235))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-235))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-235))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-235)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-235))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-235))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-236) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-236))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-237) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-237)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))) ((equal? arg-2 0) (case (vector-ref arg-3 0) ((10) (let ((e-60 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-60 arg-4))) ((9) (let ((e-65 (vector-ref arg-3 2))) (TTImpC-45WithClause-getMatch arg-0 arg-1 0 e-65 arg-4)))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-238) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-238))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-239) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc4 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-239)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-240) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-240))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-240))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-240))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-240)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-240))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-240))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-241) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-241))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-242) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-242)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))))))))(else (case (vector-ref arg-4 0) ((10) (let ((e-41 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-41 eta-0)))) ((9) (let ((e-46 (vector-ref arg-4 1))) (lambda (eta-0) (TTImpC-45WithClause-matchFail e-46 eta-0))))(else (case (vector-ref arg-3 0) ((13) (let ((e-17 (vector-ref arg-3 1))) (let ((e-19 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((13) (let ((e-29 (vector-ref arg-4 3))) (TTImpC-45WithClause-matchAny arg-0 arg-1 e-17 arg-2 (DataC-45List-u--zip_Zippable_List e-19 e-29))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-243) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-243))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-244) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc3 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-244)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))) ((18) (let ((e-24 (vector-ref arg-3 4))) (let ((e-25 (vector-ref arg-3 5))) (case (vector-ref e-24 0) ((1) (let ((e-30 (vector-ref e-24 1))) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (case (vector-ref arg-4 0) ((18) (let ((e-34 (vector-ref arg-4 2))) (let ((e-36 (vector-ref arg-4 4))) (let ((e-37 (vector-ref arg-4 5))) (lambda (clam-245) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (case (vector-ref e-38 0) ((0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 e-37) clam-245))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 (vector 18 e-34 CoreC-45FC-emptyFC 0 e-36 (vector 32 e-34 1))) e-5)))) eff-0) clam-245))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-245))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-245)))))))))(else (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) clam-245))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) clam-245))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45WithClause-mergeMatches arg-0 arg-1 arg-2 (cons (cons e-31 arg-4) e-5)))) eff-0) eta-0))))))))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4)))))(else (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 e-25 arg-4))))))(else (case (vector-ref arg-4 0) ((18) (let ((e-15 (vector-ref arg-4 5))) (TTImpC-45WithClause-getMatch arg-0 arg-1 arg-2 arg-3 e-15)))(else (case (vector-ref arg-3 0) ((29) (lambda (clam-246) (case (vector-ref arg-4 0) ((29) (vector 1 '()))(else (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) clam-246))))) ((28) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (case (vector-ref arg-4 0) ((28) (let ((e-9 (vector-ref arg-4 2))) (lambda (clam-247) (let ((sc2 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-4 e-9))) (cond ((equal? sc2 1) (vector 1 '())) (else (TTImpC-45WithClause-matchFail e-3 clam-247)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0)))))))(else (lambda (eta-0) (TTImpC-45WithClause-matchFail (TTImpC-45TTImp-getFC arg-3) eta-0))))))))))))))))))))
(define TTImpC-45WithClause-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getNewLHS-10725 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (if (null? arg-21) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-7 "Badly formed 'with' clause") ext-0) (let ((e-1 (car arg-21))) (let ((e-2 (cdr arg-21))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" 5 (lambda () (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-16) (string-append " against " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-19) (string-append " dropping " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 (cons e-1 e-2))))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 ((TTImpC-45WithClause-getMatch arg-8 arg-9 1 arg-16 arg-19) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" 5 (lambda () (string-append "Matches: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2659 e-6))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((u--params (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (TTImpC-45WithClause-getArgMatch arg-10 (vector 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) 0 e-1 e-6 eta-1)) arg-3))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" 5 (lambda () (string-append "Parameters: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 u--params))) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 ((TTImpC-45WithClause-getHeadLoc arg-1) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--newlhs (TTImpC-45TTImp-apply (vector 0 e-9 arg-4) (PreludeC-45TypesC-45List-tailRecAppend u--params e-2)))) (lambda (eta-1) (let ((act-6 (CoreC-45ContextC-45Log-log arg-9 "declare.def.clause.with" 5 (lambda () (string-append "New LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--newlhs))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (vector 1 u--newlhs)))))))) eff-0) eta-0))))))))))))))) eff-0) ext-0)))))))))))))
(define TTImpC-45WithClause-getNewLHS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--vploc (CoreC-45FC-virtualiseFC arg-3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--9359-10402-u--dropWithArgs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-4 arg-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.with" 20 (lambda () (string-append "Parent LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-8))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.with" 20 (lambda () (string-append "Modified LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-2))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (CoreC-45Context-isUnboundImplicits arg-1 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45Context-setUnboundImplicits arg-1 1) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (TTImpC-45BindImplicits-bindNames arg-1 0 arg-8 eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((_-0 (cons e-2 e-3))) (lambda (clam-1) (let ((e-11 (car e-10))) (let ((e-4 (cdr e-10))) (let ((act-7 (TTImpC-45BindImplicits-bindNames arg-1 0 e-2 clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-7 1))) ((let ((eff-0 (let ((_-1 (cons e-11 e-4))) (lambda (clam-2) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (let ((act-8 ((CoreC-45Context-setUnboundImplicits arg-1 e-8) clam-2))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((act-9 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.with" 20 (lambda () (string-append "Parent LHS (with implicits): " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-4))) clam-2))) (case (vector-ref act-9 0) ((0) (let ((e-16 (vector-ref act-9 1))) (vector 0 e-16))) (else (let ((act-10 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.with" 20 (lambda () (string-append "Modified LHS (with implicits): " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-13))) clam-2))) (case (vector-ref act-10 0) ((0) (let ((e-17 (vector-ref act-10 1))) (vector 0 e-17))) (else (let ((_-2 (cons e-14 e-13))) (TTImpC-45WithClause-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getNewLHS-10725 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--vploc e-2 e-3 _-0 e-8 e-11 e-4 _-1 e-14 e-13 _-2 (PreludeC-45TypesC-45List-reverse e-3) clam-2))))))))))))))))) eff-0) clam-1))))))))))) eff-0) eta-1))))))))))) eff-0) clam-0)))))))))))))))) eff-0) eta-0)))))))))
(define TTImpC-45WithClause-n--10048-10994-u--withApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) arg-9 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (TTImpC-45WithClause-n--10048-10994-u--withApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 11 arg-8 arg-9 e-2) e-3))))))
(define TTImpC-45WithClause-n--10048-10993-u--updateWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-9 0) ((11) (let ((e-6 (vector-ref arg-9 2))) (let ((e-7 (vector-ref arg-9 3))) (TTImpC-45WithClause-n--10048-10993-u--updateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 (cons e-7 arg-10)))))(else (lambda (clam-0) (if (null? arg-10) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-8 "Badly formed 'with' application") clam-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" 10 (lambda () (string-append "With-app: Matching " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-0) (string-append " against " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-9))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((TTImpC-45WithClause-getMatch arg-6 arg-7 0 arg-0 arg-9) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((TTImpC-45WithClause-getHeadLoc arg-9) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" 10 (lambda () (string-append "Result: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2659 e-6))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((u--newrhs (TTImpC-45TTImp-apply (vector 0 e-7 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (TTImpC-45WithClause-getArgMatch arg-8 (vector 2 ) 1 e-2 e-6 eta-2)) arg-2)))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" 10 (lambda () (string-append "With args for RHS: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2629 arg-2))) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-7 "declare.def.clause.with" 10 (lambda () (string-append "New RHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--newrhs))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (vector 1 (TTImpC-45WithClause-n--10048-10994-u--withApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--newrhs e-3))))))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))
(define TTImpC-45WithClause-n--10048-10996-u--wrhsC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-5))))) eff-0) ext-0)))))))))(else (vector 1 arg-8)))))
(define TTImpC-45WithClause-n--10048-10995-u--wrhs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (let ((e-5 (vector-ref arg-8 5))) (let ((e-6 (vector-ref arg-8 6))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-1 e-2 e-3 e-4 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((2) (let ((e-8 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-10 (vector-ref arg-8 3))) (let ((e-11 (vector-ref arg-8 4))) (let ((e-12 (vector-ref arg-8 5))) (let ((e-13 (vector-ref arg-8 6))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-13) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-8 e-9 e-10 e-11 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((3) (let ((e-15 (vector-ref arg-8 1))) (let ((e-16 (vector-ref arg-8 2))) (let ((e-17 (vector-ref arg-8 3))) (let ((e-18 (vector-ref arg-8 4))) (let ((e-19 (vector-ref arg-8 5))) (let ((e-20 (vector-ref arg-8 6))) (let ((e-21 (vector-ref arg-8 7))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-19) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-20) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-21) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 3 e-15 e-16 e-17 e-18 e-5 e-6 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((4) (let ((e-23 (vector-ref arg-8 1))) (let ((e-24 (vector-ref arg-8 2))) (let ((e-25 (vector-ref arg-8 3))) (let ((e-26 (vector-ref arg-8 4))) (let ((e-27 (vector-ref arg-8 5))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-25) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-26) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (TTImpC-45WithClause-n--10048-10996-u--wrhsC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-3 eta-4))) e-27 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 4 e-23 e-24 e-5 e-6 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((5) (let ((e-29 (vector-ref arg-8 1))) (let ((e-30 (vector-ref arg-8 2))) (let ((e-31 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-31) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-29 e-30 e-5))))) eff-0) eta-0)))))))))) ((7) (let ((e-33 (vector-ref arg-8 1))) (let ((e-34 (vector-ref arg-8 2))) (let ((e-35 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-35) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-33 e-34 e-5))))) eff-0) eta-0)))))))))) ((8) (let ((e-37 (vector-ref arg-8 1))) (let ((e-38 (vector-ref arg-8 2))) (let ((e-39 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-38) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-39) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-37 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-41 (vector-ref arg-8 1))) (let ((e-42 (vector-ref arg-8 2))) (let ((e-43 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-42) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-43) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-41 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((10) (let ((e-45 (vector-ref arg-8 1))) (let ((e-46 (vector-ref arg-8 2))) (let ((e-47 (vector-ref arg-8 3))) (let ((e-48 (vector-ref arg-8 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-46) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-48) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 10 e-45 e-5 e-47 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((11) (let ((e-50 (vector-ref arg-8 1))) (let ((e-51 (vector-ref arg-8 2))) (let ((e-52 (vector-ref arg-8 3))) (TTImpC-45WithClause-n--10048-10993-u--updateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-50 e-51 (cons e-52 '())))))) ((14) (let ((e-54 (vector-ref arg-8 1))) (let ((e-55 (vector-ref arg-8 2))) (let ((e-56 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-55) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-56) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 14 e-54 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((20) (let ((e-58 (vector-ref arg-8 1))) (let ((e-59 (vector-ref arg-8 2))) (let ((e-60 (vector-ref arg-8 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-60) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 20 e-58 e-59 e-5))))) eff-0) eta-0)))))))))) ((21) (let ((e-62 (vector-ref arg-8 1))) (let ((e-63 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-63) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 21 e-62 e-5))))) eff-0) eta-0))))))))) ((22) (let ((e-65 (vector-ref arg-8 1))) (let ((e-66 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 ((TTImpC-45WithClause-n--10048-10995-u--wrhs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-66) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 22 e-65 e-5))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (vector 1 arg-8))))))
(define TTImpC-45WithClause-withRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (TTImpC-45WithClause-n--10048-10995-u--wrhs arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-6)))
(define TTImpC-45ProcessDef-n--18911-10664-u--mkClauseWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 ext-0) (case (vector-ref arg-25 0) ((0) (let ((e-1 (vector-ref arg-25 1))) (let ((e-2 (vector-ref arg-25 2))) (let ((e-3 (vector-ref arg-25 3))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 20 (lambda () "PatClause") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 ((TTImpC-45WithClause-getNewLHS arg-20 arg-19 e-1 arg-21 arg-9 arg-22 arg-23 arg-24 e-2) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((TTImpC-45WithClause-withRHS arg-20 arg-19 e-1 arg-21 arg-22 arg-23 e-3 arg-24) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-6 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))) ((1) (let ((e-5 (vector-ref arg-25 1))) (let ((e-6 (vector-ref arg-25 2))) (let ((e-7 (vector-ref arg-25 3))) (let ((e-8 (vector-ref arg-25 4))) (let ((e-9 (vector-ref arg-25 5))) (let ((e-10 (vector-ref arg-25 6))) (let ((e-11 (vector-ref arg-25 7))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 20 (lambda () "WithClause") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((TTImpC-45WithClause-getNewLHS arg-20 arg-19 e-5 arg-21 arg-9 arg-22 arg-23 arg-24 e-6) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((TTImpC-45WithClause-withRHS arg-20 arg-19 e-5 arg-21 arg-22 arg-23 e-8 arg-24) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (TTImpC-45ProcessDef-n--18911-10664-u--mkClauseWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 (+ arg-21 1) arg-22 arg-23 arg-24 eta-2 eta-3))) e-11 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-5 e-13 e-7 e-14 e-9 e-10 e-15))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))) (else (let ((e-13 (vector-ref arg-25 1))) (let ((e-14 (vector-ref arg-25 2))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 20 (lambda () "ImpossibleClause") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((TTImpC-45WithClause-getNewLHS arg-20 arg-19 e-13 arg-21 arg-9 arg-22 arg-23 arg-24 e-14) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-13 e-6))))) eff-0) ext-0))))))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-12795 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 arg-42 arg-43 arg-44 arg-45 arg-46 arg-47 arg-48 arg-49 arg-50 arg-51 arg-52 arg-53 arg-54) (if (null? arg-54) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Impossible happened: With abstraction failure #4") eta-0)) (let ((e-1 (unbox arg-54))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((u--wargNames (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (box eta-0)) e-5) (cons '() (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (box eta-0)) arg-48))))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-20 "declare.def.clause.with" 3 (lambda () "With function type") e-10 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 5 (lambda () (string-append "Argument names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2629 u--wargNames))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (CoreC-45Context-toFullNames arg-20 csegen-54 (vector 8 arg-11) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Context-prettyName arg-20 e-11) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45UnifyState-genWithName arg-20 arg-18 e-12 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-addDef arg-20 e-11 (let ((sc6 (CoreC-45Context-newDef (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) e-11 (let ((sc7 (AlgebraC-45Semiring-isErased csegen-931 arg-15))) (cond ((equal? sc7 1) csegen-30) (else AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) arg-7 e-10 (LibrariesC-45DataC-45WithDefault-specified arg-14) (vector 0 )))) (let ((e-0 (vector-ref sc6 0))) (let ((e-30 (vector-ref sc6 1))) (let ((e-2 (vector-ref sc6 2))) (let ((e-3 (vector-ref sc6 3))) (let ((e-4 (vector-ref sc6 4))) (let ((e-29 (vector-ref sc6 5))) (let ((e-28 (vector-ref sc6 6))) (let ((e-27 (vector-ref sc6 7))) (let ((e-26 (vector-ref sc6 8))) (let ((e-25 (vector-ref sc6 9))) (let ((e-24 (vector-ref sc6 10))) (let ((e-23 (vector-ref sc6 11))) (let ((e-12 (vector-ref sc6 12))) (let ((e-13 (vector-ref sc6 13))) (let ((e-14 (vector-ref sc6 14))) (let ((e-15 (vector-ref sc6 15))) (let ((e-16 (vector-ref sc6 16))) (let ((e-17 (vector-ref sc6 17))) (let ((e-18 (vector-ref sc6 18))) (let ((e-19 (vector-ref sc6 19))) (let ((e-20 (vector-ref sc6 20))) (let ((e-21 (vector-ref sc6 21))) (let ((e-22 (vector-ref sc6 22))) (vector e-0 e-30 e-2 e-3 e-4 e-29 e-28 e-27 e-26 e-25 e-24 e-23 (cons (vector 6 arg-13) e-12) e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((let ((eff-0 (let ((u--toWarg (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (PreludeC-45Types-maybe eta-2 eta-3 eta-4)))) (lambda () (lambda (u--pn) (cons (cons '() (vector 0 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (Builtin-snd u--pn))) '()))) (lambda () (cons (cons '() arg-3) (if (null? arg-2) '() (let ((u--fc CoreC-45FC-emptyFC)) (let ((u--refl (vector 0 u--fc (vector 0 CoreC-45NameC-45Namespace-builtinNS (vector 1 (vector 0 "Refl")))))) (cons (cons arg-2 (vector 10 u--fc u--refl (vector 1 (vector 0 "x")) arg-3)) '()))))))))) (let ((u--rhs_in (TTImpC-45TTImp-gapply (vector 0 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) e-11) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--nm) (cons '() (vector 0 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) u--nm))) e-9) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 u--toWarg u--wargNames))))) (lambda (eta-2) (let ((act-5 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 3 (lambda () (string-append "Applying to with argument " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--rhs_in))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (CoreC-45Context-getFullName arg-20 (vector 8 arg-11) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-wrapErrorC arg-10 (lambda (eta-3) (vector 71 arg-6 e-14 eta-3)) (lambda (eta-3) (TTImpC-45Elab-checkTermSub arg-7 arg-22 arg-20 arg-19 arg-18 arg-17 arg-16 arg-11 arg-29 arg-10 arg-25 arg-53 arg-8 arg-23 u--rhs_in (CoreC-45NormaliseC-45Eval-gnf arg-22 arg-53 arg-27) eta-3))))) eff-0) eta-2))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (TTImpC-45ProcessDef-n--18911-10664-u--mkClauseWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 1 e-11 u--wargNames arg-21 eta-4 eta-5))) arg-0 '()) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 3 (lambda () (string-append "With clauses: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2025 e-15))) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (TTImpC-45ProcessDef-applyEnv arg-7 arg-20 arg-8 e-11 eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-9 1))) ((let ((eff-0 (let ((u--nestC-39C-39 (cons e-17 arg-9))) (let ((u--wdef (vector 2 arg-6 e-11 e-15))) (lambda (eta-5) (let ((act-10 ((TTImpC-45ElabC-45Check-processDecl arg-7 arg-20 arg-19 arg-18 arg-17 arg-16 '() u--nestC-39C-39 arg-8 u--wdef) eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (vector 1 (vector 1 (vector arg-22 arg-53 arg-26 e-14))))))))))) eff-0) eta-4))))))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))))) eff-0) eta-1))))))) eff-0) eta-0)))))))))))))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-12298 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 ext-0) (if (null? arg-41) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Impossible happened: With abstraction failure #3") ext-0) (let ((e-1 (unbox arg-41))) (let ((act-1 ((TTImpC-45ProcessDef-n--18911-10662-u--bindWithArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-4 arg-40 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 arg-39)) arg-2) e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--bnr (TTImpC-45ElabC-45Utils-bindNotReq arg-22 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) 0 arg-24 arg-38 '() arg-27))) (let ((u--notreqns (Builtin-fst u--bnr))) (let ((u--notreqty (Builtin-snd u--bnr))) (lambda (eta-0) (let ((act-2 (let ((sc5 (PreludeC-45Types-elem csegen-14 (cons (lambda (arg-676) (lambda (arg-679) (TTImpC-45TTImp-u--C-61C-61_Eq_WithFlag arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (TTImpC-45TTImp-u--C-47C-61_Eq_WithFlag arg-686 arg-689)))) (vector 0 ) arg-1))) (cond ((equal? sc5 1) (CoreC-45Context-clearDefs arg-34 eta-0)) (else (vector 1 arg-34)))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-20 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-37) e-8 e-6 (let ((sc6 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc6))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-2)) arg-39)))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-20 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-37) e-8 e-6 (let ((sc7 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc7))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-2)) u--notreqty)))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Normalise-replace arg-20 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-37) e-8 e-6 e-9 e-10 e-12 eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--bNotReq (e-11 e-9))) (let ((u--envC-39 (TTImpC-45ProcessDef-n--18911-10665-u--mkExplicit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-24))) (let ((_-0 (cons e-2 (cons e-6 (cons e-10 e-11))))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-12795 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 e-1 e-2 e-6 e-10 e-11 _-0 u--bnr u--notreqns u--notreqty e-8 e-9 u--bNotReq u--envC-39 (TTImpC-45ElabC-45Utils-bindReq arg-22 (TTImpC-45ProcessDef-n--18911-10666-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) u--envC-39 arg-38 '() u--bNotReq))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-11993 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 ext-0) (let ((e-2 (car arg-37))) (let ((e-3 (cdr arg-37))) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-22 arg-20 "declare.def.clause.with" 5 (lambda () "With value type") arg-36 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45ContextC-45Log-log arg-20 "declare.def.clause.with" 5 (lambda () (string-append "Using vars " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-2))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((sc3 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term arg-35 e-3))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Impossible happened: With abstraction failure #1") ext-0) (let ((e-1 (unbox sc3))) (let ((sc4 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term arg-36 e-3))) (if (null? sc4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Impossible happened: With abstraction failure #2") ext-0) (let ((e-4 (unbox sc4))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-12298 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 e-2 e-3 e-1 e-4 (CoreC-45Env-shrinkEnv arg-24 e-3) ext-0)))))))))))))))))
(define TTImpC-45ProcessDef-checkClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (case (vector-ref arg-14 0) ((2) (let ((e-1 (vector-ref arg-14 1))) (let ((e-2 (vector-ref arg-14 2))) (let ((act-1 ((TTImpC-45TTImp-lhsInCurrentNS arg-1 arg-12 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45UnifyState-handleUnify arg-1 arg-3 0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-isUnboundImplicits arg-1 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Context-setUnboundImplicits arg-1 1) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-3 (cdr e-8))) (let ((act-5 ((CoreC-45Context-setUnboundImplicits arg-1 e-6) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause.impossible" 5 (lambda () (string-append "Checking " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-3))) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((act-7 (CoreC-45Normalise-logEnv arg-0 arg-1 "declare.def.clause.impossible" 5 "In env" arg-13 clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((act-8 ((TTImpC-45Elab-elabTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-10 (vector 1 arg-6) arg-11 arg-12 arg-13 (vector 16 e-1 (vector 1 ) e-3) '()) clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-14 (car e-12))) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-15 (vector-ref act-9 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-10 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-15 arg-13 e-14 eta-3))) (case (vector-ref act-10 0) ((0) (let ((e-16 (vector-ref act-10 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-11 (TTImpC-45ProcessDef-hasEmptyPat arg-0 arg-1 e-15 arg-13 e-16 eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-17 (vector-ref act-11 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-11 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-17 1) (vector 1 (vector 0 e-5))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 6 arg-0 e-1 arg-13 (vector 0 e-16)) clam-3)))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) clam-2))))))))) eff-0) clam-1)))))))))))))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))) (lambda (u--err) (lambda (clam-4) (case (vector-ref u--err 0) ((6) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-4))(else (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ProcessDef-impossibleErrOK arg-1 e-6 u--err) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-5) (cond ((equal? e-7 1) (vector 1 (vector 0 e-5))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 6 arg-0 e-1 arg-13 (vector 1 u--err)) clam-5)))))) eff-0) eta-1)))))))) eff-0) clam-4))))))))) eta-0)))) eff-0) ext-0)))))))) ((0) (let ((e-4 (vector-ref arg-14 1))) (let ((e-5 (vector-ref arg-14 2))) (let ((e-6 (vector-ref arg-14 3))) (let ((act-1 (TTImpC-45ProcessDef-checkLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 arg-6 arg-10 arg-11 arg-12 arg-13 e-4 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((u--rhsMode (let ((sc8 (AlgebraC-45Semiring-isErased csegen-931 arg-6))) (cond ((equal? sc8 1) (vector 0 )) (else (vector 2 )))))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "declare.def.clause" 5 (lambda () (string-append "Checking RHS " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-6))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-12 (vector-ref act-2 1))) (vector 0 e-12))) (else (let ((act-3 (CoreC-45Normalise-logEnv e-9 arg-1 "declare.def.clause" 5 "In env" e-14 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((act-4 (let ((act-4 (CoreC-45Context-getFullName arg-1 (vector 8 arg-10) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-logTime arg-1 3 (lambda () (string-append "Check RHS " (CoreC-45FC-u--show_Show_FC e-4))) (TTImpC-45ElabC-45Utils-wrapErrorC arg-11 (lambda (eta-2) (vector 71 e-4 e-16 eta-2)) (lambda (eta-2) (TTImpC-45Elab-checkTermSub arg-0 e-9 arg-1 arg-2 arg-3 arg-4 arg-5 arg-10 u--rhsMode arg-11 e-18 e-14 arg-13 e-10 e-6 (CoreC-45NormaliseC-45Eval-gnf e-9 e-14 e-23) eta-2))) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45Metadata-clearHoleLHS arg-2) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((act-6 (CoreC-45ContextC-45Log-logTerm e-9 arg-1 "declare.def.clause" 3 (lambda () "RHS term") e-16 eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-20 (vector-ref act-6 1))) (vector 0 e-20))) (else (let ((act-7 (cond ((equal? arg-9 1) (let ((act-7 (CoreC-45Context-addHashWithNames arg-1 (csegen-1374) csegen-68 e-22 eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-21 (vector-ref act-7 1))) (vector 0 e-21))) (else (let ((act-8 (CoreC-45Context-addHashWithNames arg-1 (csegen-1374) csegen-68 e-16 eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-24 (vector-ref act-8 1))) (vector 0 e-24))) (else (CoreC-45ContextC-45Log-log arg-1 "module.hash" 15 (lambda () "Adding hash for def.") eta-1)))))))) (else (vector 1 (vector 0 )))))) (case (vector-ref act-7 0) ((0) (let ((e-21 (vector-ref act-7 1))) (vector 0 e-21))) (else (let ((act-8 (case (vector-ref e-16 0) ((2) (CoreC-45Metadata-addLHS e-9 arg-1 arg-2 (TTImpC-45TTImp-getFC e-5) (CoreC-45Env-length arg-13) e-14 e-22 eta-1))(else (vector 1 (vector 0 )))))) (case (vector-ref act-8 0) ((0) (let ((e-24 (vector-ref act-8 1))) (vector 0 e-24))) (else (vector 1 (vector 1 (vector e-9 e-14 e-22 e-16)))))))))))))))))) eff-0) eta-0)))))))))))))))))))))))))) eff-0) ext-0))))))))) (else (let ((e-8 (vector-ref arg-14 1))) (let ((e-9 (vector-ref arg-14 2))) (let ((e-10 (vector-ref arg-14 3))) (let ((e-11 (vector-ref arg-14 4))) (let ((e-12 (vector-ref arg-14 5))) (let ((e-13 (vector-ref arg-14 6))) (let ((e-14 (vector-ref arg-14 7))) (let ((act-1 (TTImpC-45ProcessDef-checkLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 arg-6 arg-10 arg-11 arg-12 arg-13 e-8 e-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-16 (car e-7))) (let ((e-15 (cdr e-7))) (let ((e-18 (car e-15))) (let ((e-17 (cdr e-15))) (let ((e-20 (car e-17))) (let ((e-19 (cdr e-17))) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((u--wmode (let ((sc8 (let ((sc9 (AlgebraC-45Semiring-isErased csegen-931 arg-6))) (cond ((equal? sc9 1) 1) (else (AlgebraC-45Semiring-isErased csegen-931 e-10)))))) (cond ((equal? sc8 1) (vector 0 )) (else (vector 2 )))))) (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Context-getFullName arg-1 (vector 8 arg-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-wrapErrorC arg-11 (lambda (eta-1) (vector 71 e-8 e-21 eta-1)) (TTImpC-45Elab-elabTermSub arg-0 e-6 arg-1 arg-2 arg-3 arg-4 arg-5 arg-10 u--wmode arg-11 e-20 e-18 arg-13 e-16 e-11 '())))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 (cons e-2 (cons e-6 (cons e-16 (cons e-18 (cons e-20 (cons e-22 e-23)))))))) (lambda (clam-6) (let ((e-24 (car e-21))) (let ((e-4 (cdr e-21))) (let ((act-3 ((CoreC-45Metadata-clearHoleLHS arg-2) clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-25 (vector-ref act-3 1))) (vector 0 e-25))) (else (let ((act-4 (CoreC-45ContextC-45Log-logTerm e-6 arg-1 "declare.def.clause.with" 5 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "With value (at quantity " (cons (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-10) (cons ")" '()))))) e-24 clam-6))) (case (vector-ref act-4 0) ((0) (let ((e-26 (vector-ref act-4 1))) (vector 0 e-26))) (else (let ((act-5 (CoreC-45ContextC-45Log-logTerm e-6 arg-1 "declare.def.clause.with" 3 (lambda () "Required type") e-23 clam-6))) (case (vector-ref act-5 0) ((0) (let ((e-27 (vector-ref act-5 1))) (vector 0 e-27))) (else (let ((act-6 ((CoreC-45NormaliseC-45Eval-getTerm e-4) clam-6))) (case (vector-ref act-6 0) ((0) (let ((e-28 (vector-ref act-6 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-7 (let ((act-7 (unbox arg-1))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-29 (vector-ref act-7 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-8 (CoreC-45Normalise-normaliseHoles arg-1 e-6 e-29 e-18 e-24 eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-30 (vector-ref act-8 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 (CoreC-45Normalise-normaliseHoles arg-1 e-6 e-29 e-18 e-28 eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-31 (vector-ref act-9 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-9 1))) ((let ((eff-0 (let ((_-1 (cons e-24 e-4))) (lambda (eta-4) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32checkClause-11993 e-14 e-13 e-12 e-11 e-10 e-9 e-8 arg-0 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-6 e-16 e-18 e-20 e-22 e-23 _-0 u--wmode e-24 e-4 _-1 e-28 e-29 e-30 e-31 (TTImpC-45ProcessDef-n--18911-10663-u--keepOldEnv e-14 e-13 e-12 e-11 e-10 e-9 e-8 arg-0 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 e-16 (let ((sc17 (CoreC-45Env-findSubEnv e-6 e-18 e-30))) (let ((e-32 (cdr sc17))) e-32))) eta-4))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-6)))))))))))))))))))) eff-0) eta-0))))))))))))))))))))) eff-0) ext-0))))))))))))))))
(define CoreC-45Termination-n--8210-13404-u--checkNotFn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-4 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox e-5))) (lambda (clam-0) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((5) (vector 1 1))(else (vector 1 (let ((sc2 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega (let ((e-40 (vector-ref e-1 7))) e-40) csegen-30))) (cond ((equal? sc2 1) 1) (else (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 10 ) (let ((e-35 (vector-ref e-1 12))) e-35)))))))))))))) eff-0) ext-0)))))))
(define CoreC-45Termination-n--8210-13406-u--guardedNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((2) (vector 1 1)) ((1) (let ((e-8 (vector-ref arg-6 2))) (case (vector-ref e-8 0) ((1) (let ((e-12 (vector-ref e-8 2))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-12 (let ((e-0 (vector-ref arg-4 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (vector 1 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 10 ) (let ((e-23 (vector-ref e-1 12))) e-23)))))))) eff-0) clam-0)))))))(else (vector 1 0)))))(else (vector 1 0))))))
(define CoreC-45Termination-n--8210-13405-u--guarded (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-2 arg-3 e-6 arg-4 arg-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Termination-n--8210-13406-u--guardedNF arg-0 arg-1 arg-2 arg-3 e-5 arg-4 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-8 1) (let ((act-5 ((CoreC-45Context-lookupCtxtExact arg-0 (let ((e-0 (vector-ref e-5 0))) e-0)) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (if (null? e-9) (lambda (eta-3) (vector 1 0)) (let ((e-1 (unbox e-9))) (CoreC-45Core-allM (lambda (eta-3) (lambda (eta-4) (CoreC-45Termination-n--8210-13404-u--checkNotFn arg-0 arg-1 arg-2 e-5 eta-3 eta-4))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1))))))) eff-0) clam-0)))))) (else (vector 1 0)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Termination-n--8210-13403-u--allGuarded (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (lambda (eta-0) (vector 1 1)) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (lambda (clam-0) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-15 (cdr e-11))) (let ((act-1 (CoreC-45Termination-n--8210-13405-u--guarded arg-0 arg-1 arg-2 e-6 e-10 e-15 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (CoreC-45Termination-n--8210-13403-u--allGuarded arg-0 arg-1 arg-2 e-3)) (else (lambda (eta-0) (vector 1 0)))))) eff-0) clam-0))))))))))))))))
(define CoreC-45Termination-checkIfGuarded (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "totality.termination.guarded" 6 (lambda (eta-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "Check if Guarded: " (CoreC-45Name-u--show_Show_Name e-5)))))) eff-0) eta-0)))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-lookupDefExact arg-2 (let ((e-0 (vector-ref e-6 0))) e-0) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (vector 1 (vector 0 )) (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((1) (let ((e-8 (vector-ref e-1 5))) (let ((act-4 ((CoreC-45Termination-n--8210-13403-u--allGuarded arg-2 arg-1 arg-0 e-8) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-10 1) (CoreC-45Context-setFlag arg-0 arg-1 arg-2 (vector 10 ) clam-1)) (else (vector 1 (vector 0 ))))))) eff-0) clam-0)))))))(else (vector 1 (vector 0 ))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Utils-isUsed (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-3 (car arg-4))) (cond ((equal? e-3 0) 1)(else 0))))(else (let ((e-0 (- arg-2 1))) (let ((e-8 (cdr arg-4))) (TTImpC-45ElabC-45Utils-isUsed e-0 e-8)))))))
(define TTImpC-45ElabC-45Utils-setUsedVar (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (if (null? arg-4) arg-4 (let ((e-3 (car arg-4))) (let ((e-4 (cdr arg-4))) (cond ((equal? e-3 1) (cons 0 e-4))(else arg-4))))))(else (let ((e-0 (- arg-2 1))) (let ((e-7 (car arg-4))) (let ((e-8 (cdr arg-4))) (cons e-7 (TTImpC-45ElabC-45Utils-setUsedVar e-0 e-8)))))))))
(define TTImpC-45ElabC-45Utils-setUsed (lambda (arg-2 arg-3) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-3))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-3 (TTImpC-45ElabC-45Utils-setUsedVar arg-2 e-5)))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ElabC-45Utils-dropUsed (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr arg-2))) (TTImpC-45ElabC-45Utils-dropUsed e-3 e-7))))))
(define TTImpC-45ElabC-45Utils-extendUsed (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-3 (cdr arg-2))) (cons arg-1 (TTImpC-45ElabC-45Utils-extendUsed arg-1 e-3 arg-3))))))
(define TTImpC-45ElabC-45Utils-inExtended (lambda (arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "TTImp.Elab.Utils.Used" ) (TTImpC-45ElabC-45Utils-extendUsed arg-2 arg-3 e-5)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((arg-5 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (let ((act-4 (unbox e-6))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (set-box! arg-4 (TTImpC-45ElabC-45Utils-dropUsed arg-3 e-8)))) (vector 1 act-5))))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Utils-n--10132-9852-u--allInlineSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 1) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 ((TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-5 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (lambda (eta-0) (TTImpC-45ElabC-45Utils-n--10132-9852-u--allInlineSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 eta-0))) (else (lambda (eta-0) (vector 1 0)))))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Utils-n--10132-9917-u--binderInlineSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-3 (vector-ref arg-6 3))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-5 e-3)))(else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Utils-termInlineSafe (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-4 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (TTImpC-45ElabC-45Utils-isUsed e-4 e-5))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-2 ((TTImpC-45ElabC-45Utils-setUsed e-4 arg-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (vector 1 1)))))))))) eff-0) eta-0)))))))) ((2) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (lambda (eta-0) (TTImpC-45ElabC-45Utils-n--10132-9852-u--allInlineSafe arg-0 e-10 e-9 e-8 e-7 arg-1 e-10 eta-0))))))) ((3) (let ((e-12 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 3))) (let ((e-15 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Utils-n--10132-9917-u--binderInlineSafe arg-0 e-13 e-15 e-14 e-12 arg-1 e-14) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (TTImpC-45ElabC-45Utils-inExtended 2 (cons e-13 '()) arg-1 (lambda (u--uC-39) (TTImpC-45ElabC-45Utils-termInlineSafe (cons e-13 arg-0) u--uC-39 e-15)) clam-0)) (else (vector 1 0)))))) eff-0) eta-0))))))))))) ((4) (let ((e-18 (vector-ref arg-2 2))) (let ((e-19 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-18) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-19)) (else (lambda (eta-1) (vector 1 0)))))) eff-0) eta-0))))))))) ((5) (let ((e-24 (vector-ref arg-2 4))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-24))) ((6) (let ((e-28 (vector-ref arg-2 3))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-28))) ((7) (let ((e-33 (vector-ref arg-2 4))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-33))) ((8) (let ((e-37 (vector-ref arg-2 3))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-37)))(else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Utils-caseAltInlineSafe (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (lambda (eta-0) (TTImpC-45ElabC-45Utils-inExtended 1 e-3 arg-1 (lambda (u--uC-39) (TTImpC-45ElabC-45Utils-caseInlineSafe (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) u--uC-39 e-4)) eta-0))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (lambda (eta-0) (TTImpC-45ElabC-45Utils-inExtended 1 (cons e-6 (cons e-7 '())) arg-1 (lambda (u--uC-39) (TTImpC-45ElabC-45Utils-caseInlineSafe (cons e-6 (cons e-7 arg-0)) u--uC-39 e-8)) eta-0)))))) ((2) (let ((e-11 (vector-ref arg-2 2))) (TTImpC-45ElabC-45Utils-caseInlineSafe arg-0 arg-1 e-11))) (else (let ((e-13 (vector-ref arg-2 1))) (TTImpC-45ElabC-45Utils-caseInlineSafe arg-0 arg-1 e-13))))))
(define TTImpC-45ElabC-45Utils-n--10471-10096-u--altsSafe (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 ext-0) (if (null? arg-7) (vector 1 1) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-1 (let ((act-1 (unbox arg-6))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45Utils-caseAltInlineSafe arg-0 arg-6 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-6 1) (let ((act-3 (let ((act-3 (set-box! arg-6 e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (TTImpC-45ElabC-45Utils-n--10471-10096-u--altsSafe arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 e-3 clam-1))))) (else (vector 1 0)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Utils-caseInlineSafe (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (TTImpC-45ElabC-45Utils-isUsed e-2 e-6))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-2 ((TTImpC-45ElabC-45Utils-setUsed e-2 arg-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (TTImpC-45ElabC-45Utils-n--10471-10096-u--altsSafe arg-0 e-1 e-5 e-4 e-2 arg-1 e-5 clam-0)))))))))) eff-0) eta-0))))))))))) ((1) (let ((e-8 (vector-ref arg-2 2))) (TTImpC-45ElabC-45Utils-termInlineSafe arg-0 arg-1 e-8))) ((2) (lambda (eta-0) (vector 1 1))) (else (lambda (eta-0) (vector 1 1))))))
(define TTImpC-45ElabC-45Utils-initUsedCase (lambda (arg-0) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (if (null? e-3) (cons 1 '()) (cons 2 (TTImpC-45ElabC-45Utils-initUsedCase e-3)))))))
(define TTImpC-45ElabC-45Utils-canInlineCaseBlock (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 0) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 2))) (let ((e-8 (vector-ref e-1 4))) (let ((act-3 ((CoreC-45Core-newRef (vector "TTImp.Elab.Utils.Used" ) (TTImpC-45ElabC-45Utils-initUsedCase e-3)) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ElabC-45Utils-caseInlineSafe e-3 e-9 e-8))) eff-0) clam-0))))))))(else (vector 1 0)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define DataC-45List-C-92C-92 (lambda (arg-1 ext-0 ext-1) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (DataC-45List-delete arg-1 eta-2 eta-3))) eta-0 eta-1))) ext-0 ext-1)))
(define CoreC-45CaseC-45Util-tagIs (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-1 e-2))) ((2) 0) ((1) 0) (else 1))))
(define CoreC-45CaseC-45CaseBuilder-findReached (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-findReachedAlts eta-0)) e-5))) ((1) (let ((e-7 (vector-ref arg-1 1))) (cons e-7 '())))(else '()))))
(define CoreC-45CaseC-45CaseBuilder-findReachedAlts (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 4))) (CoreC-45CaseC-45CaseBuilder-findReached e-4))) ((1) (let ((e-8 (vector-ref arg-1 3))) (CoreC-45CaseC-45CaseBuilder-findReached e-8))) ((2) (let ((e-11 (vector-ref arg-1 2))) (CoreC-45CaseC-45CaseBuilder-findReached e-11))) (else (let ((e-13 (vector-ref arg-1 1))) (CoreC-45CaseC-45CaseBuilder-findReached e-13))))))
(define CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaultsC-44dropRep-18151 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((u--extraClauses (PreludeC-45Types-listBind e-3 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-findReachedAlts eta-0))))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--24820-18089-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 (LibrariesC-45DataC-45SortedSet-fromList csegen-231 u--extraClauses)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons arg-10 e-5) (LibrariesC-45DataC-45SortedSet-union arg-12 e-4))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--24820-18089-u--dropRep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (cons '() arg-7) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (let ((u--c (vector 0 e-5 e-6 e-7 e-8))) (CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaultsC-44dropRep-18151 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 e-8 e-6 e-5 u--c e-3 arg-7 (DataC-45List-partition (lambda (eta-0) (let ((sc2 (CoreC-45CaseC-45Util-tagIs e-6 eta-0))) (cond ((equal? sc2 1) 0) (else 1)))) e-3))))))))(else (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--24820-18089-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons e-2 e-5) e-4)))))))))))
(define CoreC-45CaseC-45Util-n--6935-6771-u--addTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-8 (let ((e-0 (vector-ref arg-6 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox e-5))) (lambda (clam-0) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((5) (let ((e-27 (vector-ref e-18 1))) (let ((e-26 (vector-ref e-18 2))) (vector 1 (box (vector arg-8 e-27 e-26))))))(else (vector 1 '()))))))))) eff-0) ext-0)))))))
(define CoreC-45CaseC-45Util-getCons (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (CoreC-45Context-lookupDefExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Called `getCons` on something that is not a Type constructor") clam-0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((6) (let ((e-8 (vector-ref e-7 7))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45CaseC-45Util-n--6935-6771-u--addTy arg-1 e-1 e-3 e-4 e-5 e-2 arg-2 arg-0 eta-0 eta-1))) e-8 '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-16 (vector-ref act-2 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (DataC-45List-catMaybes e-16))))) eff-0) clam-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Called `getCons` on something that is not a Type constructor") clam-0)))))))) eff-0) ext-0)))))))))))(else (vector 1 '())))))
(define CoreC-45CaseC-45Util-n--7223-7011-u--emptyRHSalt (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-4))))))) ((1) (let ((e-6 (vector-ref arg-7 1))) (let ((e-7 (vector-ref arg-7 2))) (let ((e-8 (vector-ref arg-7 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-8)))))) ((2) (let ((e-10 (vector-ref arg-7 1))) (let ((e-11 (vector-ref arg-7 2))) (vector 2 e-10 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-11))))) (else (let ((e-13 (vector-ref arg-7 1))) (vector 3 (CoreC-45CaseC-45Util-emptyRHS arg-6 e-13)))))))
(define CoreC-45CaseC-45Util-emptyRHS (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector 0 e-1 e-2 e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45Util-n--7223-7011-u--emptyRHSalt e-1 e-5 e-4 e-2 arg-1 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (vector 1 e-7 (vector 10 arg-1 (vector 0 )))))(else arg-2))))
(define PreludeC-45Types-take (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cons e-2 (PreludeC-45Types-take e-0 (e-3))))))))))
(define PreludeC-45Types-u--rangeFrom_Range_C-36a (lambda (arg-1 arg-2) (PreludeC-45Types-countFrom arg-2 (lambda (arg-0) (let ((sc0 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-1 (vector-ref sc0 0))) (let ((e-6 (vector-ref e-1 0))) ((e-6 (let ((sc0 (Builtin-snd (Builtin-snd arg-1)))) (let ((e-9 (vector-ref sc0 0))) (let ((e-10 (vector-ref e-9 2))) (e-10 1))))) arg-0))))))))
(define CoreC-45CaseC-45CaseTree-insertCaseAltNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45CaseTree-insertCaseNames (LibrariesC-45DataC-45ListC-45SizeOf-C-43 (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-3) arg-3) arg-4 e-4))))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45CaseTree-insertCaseNames (LibrariesC-45DataC-45ListC-45SizeOf-suc (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-3)) arg-4 e-8)))))) ((2) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (vector 2 e-10 (CoreC-45CaseC-45CaseTree-insertCaseNames arg-3 arg-4 e-11))))) (else (let ((e-13 (vector-ref arg-5 1))) (vector 3 (CoreC-45CaseC-45CaseTree-insertCaseNames arg-3 arg-4 e-13)))))))
(define CoreC-45CaseC-45CaseTree-insertCaseNames (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (let ((eff-0 (CoreC-45TTC-45Var-insertNVarNames arg-3 arg-4 e-2))) (vector 0 e-1 eff-0 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-insertCaseAltNames arg-3 arg-4 eta-0)) e-5)))))))) ((1) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (vector 1 e-7 (CoreC-45TTC-45Term-insertNames arg-3 arg-4 e-8))))) ((2) (let ((e-10 (vector-ref arg-5 1))) (vector 2 e-10))) (else (vector 3 )))))
(define CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (lambda (arg-2 arg-3) (CoreC-45CaseC-45CaseTree-insertCaseNames 0 arg-2 arg-3)))
(define CoreC-45CaseC-45Util-mkAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-0 (vector-ref arg-3 0))) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-0 e-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 2 "m" eta-0)) (PreludeC-45Types-take e-2 (PreludeC-45Types-u--rangeFrom_Range_C-36a csegen-235 (blodwen-toSignedInt 0 63)))) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree e-2 (CoreC-45CaseC-45Util-emptyRHS arg-1 arg-2))))))))
(define CoreC-45CaseC-45CaseBuilder-n--24820-18090-u--rep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (let ((e-1 (vector-ref arg-6 1))) (let ((act-1 (CoreC-45CaseC-45Util-getCons arg-5 arg-0 arg-3 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45CaseC-45Util-mkAlt arg-0 arg-4 e-1 eta-1)) e-5))))) eff-0) ext-0)))))))(else (vector 1 (cons arg-6 '()))))))
(define LibrariesC-45DataC-45SortedMap-u--null_Foldable_C-40SortedMapC-32C-36kC-41 (lambda (arg-2) (case (vector-ref arg-2 0) ((0) 1) (else 0))))
(define LibrariesC-45DataC-45SortedSet-u--null_Foldable_SortedSet (lambda (arg-1) (LibrariesC-45DataC-45SortedMap-u--null_Foldable_C-40SortedMapC-32C-36kC-41 arg-1)))
(define LibrariesC-45DataC-45SortedSet-u--show_Show_C-40SortedSetC-32C-36kC-41 (lambda (arg-1 ext-0) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 (LibrariesC-45DataC-45SortedSet-toList ext-0))))
(define CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaults-18308 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((u--extraClauseIdxsC-39 (let ((sc1 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-1) (+ (PreludeC-45TypesC-45List-lengthTR e-2) 1)) 1) 0))) (cond ((equal? sc1 1) e-3) (else csegen-2802))))) (lambda (eta-0) (let ((act-1 (let ((sc1 (LibrariesC-45DataC-45SortedSet-u--null_Foldable_SortedSet u--extraClauseIdxsC-39))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-log arg-5 "compile.casetree.clauses" 25 (lambda () (string-append "Marking the following clause indices as unreachable under the current branch of the tree: " (LibrariesC-45DataC-45SortedSet-u--show_Show_C-40SortedSetC-32C-36kC-41 csegen-495 u--extraClauseIdxsC-39))) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 u--extraClauseIdxsC-39))))))))))
(define CoreC-45CaseC-45CaseBuilder-identifyUnreachableDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((8) csegen-2826) ((10) csegen-2826)(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-n--24820-18090-u--rep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 eta-0 eta-1))) arg-5 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-case--identifyUnreachableDefaults-18308 arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 e-5 (CoreC-45CaseC-45CaseBuilder-n--24820-18089-u--dropRep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-5) csegen-2802)))) eff-0) ext-0)))))))))
(define CoreC-45CaseC-45CaseBuilder-n--25259-18442-u--findExtraAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-9 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-8 arg-7 e-4)))) ((1) (let ((e-6 (vector-ref arg-10 1))) (let ((e-7 (vector-ref arg-10 2))) (let ((e-8 (vector-ref arg-10 3))) (CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-9 (cons e-6 (cons e-7 arg-0)) arg-8 arg-7 e-8))))) ((2) (let ((e-11 (vector-ref arg-10 2))) (CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-9 arg-0 arg-8 arg-7 e-11))) (else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45CaseC-45CaseBuilder-findExtraDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (let ((u--fenv (CoreC-45Env-mkEnv arg-2 arg-1))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-3 u--fenv e-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-identifyUnreachableDefaults arg-0 arg-1 arg-2 arg-3 e-6 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-2832 (CoreC-45Core-traverseC-39 (lambda (eta-3) (CoreC-45CaseC-45CaseBuilder-n--25259-18442-u--findExtraAlts arg-1 e-5 e-4 e-2 e-1 arg-4 arg-3 arg-2 arg-0 eta-3)) e-5 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45SortedSet-toList e-7) e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45CaseC-45CaseBuilder-n--23868-17231-u--getNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (cons '() 0) (let ((e-3 (cdr arg-9))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--23868-17231-u--getNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (cons (vector 2 "arg" arg-8) e-5) (LibrariesC-45DataC-45ListC-45SizeOf-suc e-4)))))))))
(define CoreC-45CaseC-45CaseBuilder-getNPs (lambda (arg-2) (let ((e-3 (vector-ref arg-2 1))) e-3)))
(define CoreC-45CaseC-45CaseBuilder-highScore (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) (cond ((equal? arg-5 1) '()) (else (box arg-4))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (car arg-2))) (let ((e-8 (cdr arg-2))) (let ((u--next (lambda (eta-0) (lambda (eta-1) (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-highScore (DataC-45List-snoc arg-0 e-2) e-3 e-8 eta-0 eta-1 eta-2)))))) (let ((sc2 (PreludeC-45EqOrd-u--compare_Ord_Int e-7 arg-3))) (cond ((equal? sc2 0) (((u--next arg-3) arg-4) arg-5)) ((equal? sc2 1) (((u--next arg-3) arg-4) 1)) (else (((u--next e-7) (cons e-2 (CoreC-45TTC-45Var-weakenNVar (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-0) 0))) 0))))))))))))
(define CoreC-45CaseC-45CaseBuilder-highScoreIdx (lambda (arg-1 arg-2 arg-3) (let ((e-4 (cdr arg-3))) (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (CoreC-45CaseC-45CaseBuilder-highScore '() (cons arg-1 arg-2) (cons e-7 e-8) (bs- e-7 1 63) (cons arg-1 0) 0))))))
(define CoreC-45CaseC-45CaseBuilder-applyHeuristics (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (CoreC-45CaseC-45CaseBuilder-highScoreIdx arg-1 arg-2 arg-3) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (CoreC-45CaseC-45CaseBuilder-highScoreIdx arg-1 arg-2 arg-3) (lambda () (CoreC-45CaseC-45CaseBuilder-applyHeuristics arg-1 arg-2 (e-2 arg-3) e-3))))))))
(define DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 (lambda (arg-4 arg-5 arg-6) (if (null? arg-5) '() (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (cons ((arg-4 e-3) e-8) (DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 arg-4 e-4 e-9)))))))))
(define CoreC-45CaseC-45CaseBuilder-n--19231-12956-u--scoreFirstColumn (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9) (if (null? arg-9) (cons '() (cons 0 '())) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-7 (car e-2))) (let ((e-8 (cdr e-2))) (let ((u--ps (cons arg-1 arg-2))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-n--19231-12956-u--scoreFirstColumn arg-1 arg-2 arg-3 arg-4 arg-5 u--ps e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((e-6 (car e-4))) (let ((e-9 (cdr e-4))) (cons (cons e-8 e-5) (cons (+ e-6 1) (cons (arg-5 (let ((e-11 (vector-ref e-7 2))) e-11)) e-9))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--19231-12955-u--scoreColumns (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) '() (let ((e-3 (cdr arg-7))) (let ((u--ps (cons arg-1 arg-2))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--19231-12956-u--scoreFirstColumn arg-1 arg-2 arg-3 arg-4 arg-5 u--ps arg-8))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((e-7 (cdr e-4))) (cons e-7 (CoreC-45CaseC-45CaseBuilder-n--19231-12955-u--scoreColumns arg-1 arg-2 arg-3 arg-4 arg-5 u--ps e-3 e-5)))))))))))
(define CoreC-45CaseC-45CaseBuilder-consScoreHeuristic (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (if (null? e-6) arg-3 (let ((u--columnScores (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (PreludeC-45Interfaces-sum csegen-189 csegen-1914 eta-0)) (CoreC-45CaseC-45CaseBuilder-n--19231-12955-u--scoreColumns e-1 e-2 e-7 e-6 arg-2 arg-1 (cons e-1 e-2) e-6)))) (let ((u--ysC-39 (DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 csegen-1939 e-7 u--columnScores))) (cons e-6 u--ysC-39))))))))))
(define CoreC-45CaseC-45CaseBuilder-headConsPenalty (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45CaseC-45CaseBuilder-headConsPenalty arg-0 e-2))) ((1) (let ((e-6 (vector-ref arg-1 4))) (arg-0 e-6))) ((2) (let ((e-10 (vector-ref arg-1 3))) (arg-0 e-10))) ((3) 0) ((4) 0) ((5) (let ((e-21 (vector-ref arg-1 4))) (CoreC-45CaseC-45CaseBuilder-headConsPenalty arg-0 e-21))) ((6) 0) (else 0))))
(define CoreC-45CaseC-45CaseBuilder-heuristicA (lambda (arg-1 ext-0) (CoreC-45CaseC-45CaseBuilder-consScoreHeuristic arg-1 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-headConsPenalty (lambda (eta-1) (bs- 0 (blodwen-toSignedInt eta-1 63) 63)) eta-0)) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-heuristicB (lambda (arg-1 ext-0) (CoreC-45CaseC-45CaseBuilder-consScoreHeuristic arg-1 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-headConsPenalty (lambda (u--arity) (let ((sc0 (or (and (= u--arity 0) 1) 0))) (cond ((equal? sc0 1) 0) (else -1)))) eta-0)) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-n--19512-13209-u--isBlank (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((6) 1)(else 0))))
(define CoreC-45CaseC-45CaseBuilder-n--19512-13210-u--scores (lambda (arg-2 arg-3 arg-4 arg-5 arg-8) (if (null? arg-8) '() (let ((e-4 (car arg-8))) (let ((e-5 (cdr arg-8))) (let ((u--score (let ((sc1 (CoreC-45CaseC-45CaseBuilder-n--19512-13209-u--isBlank arg-2 arg-3 arg-4 arg-5 (let ((e-7 (vector-ref e-4 2))) e-7)))) (cond ((equal? sc1 1) 0) (else 1))))) (cons u--score (CoreC-45CaseC-45CaseBuilder-n--19512-13210-u--scores arg-2 arg-3 arg-4 arg-5 e-5))))))))
(define CoreC-45CaseC-45CaseBuilder-heuristicF (lambda (arg-2 arg-3) (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (if (null? e-3) arg-3 (let ((e-7 (car e-3))) (let ((e-8 (cdr e-3))) (let ((u--columnScores (CoreC-45CaseC-45CaseBuilder-n--19512-13210-u--scores arg-2 e-7 e-8 e-4 e-7))) (let ((u--ysC-39 (DataC-45Vect-u--zipWith_Zippable_C-40VectC-32C-36kC-41 csegen-1939 e-4 u--columnScores))) (cons (cons e-7 e-8) u--ysC-39))))))))))
(define CoreC-45CaseC-45CaseBuilder-zeroedScore (lambda (arg-2 arg-3) (cons arg-3 (DataC-45Vect-replicate (+ (PreludeC-45TypesC-45List-lengthTR arg-2) 1) 0))))
(define CoreC-45CaseC-45CaseBuilder-nextIdxByScore (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-3 0) (cons arg-1 0))(else (if (null? arg-4) (cond (else (DataC-45Maybe-fromMaybe (lambda () (cons arg-1 0)) (CoreC-45CaseC-45CaseBuilder-applyHeuristics arg-1 arg-2 (CoreC-45CaseC-45CaseBuilder-zeroedScore arg-2 arg-5) (cons (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-heuristicF arg-2 eta-0)) (cons (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-heuristicB (cons arg-1 arg-2) eta-0)) (cons (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-heuristicA (cons arg-1 arg-2) eta-0)) '()))))))) (cons arg-1 0))))))
(define CoreC-45TTC-45Var-dropIsVar (lambda (arg-2 arg-3) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cond ((equal? arg-3 0) e-2)(else (let ((e-3 (- arg-3 1))) (cons e-1 (CoreC-45TTC-45Var-dropIsVar e-2 e-3)))))))))
(define CoreC-45TTC-45Var-isNVar (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (CoreC-45Name-nameEq arg-0 e-2))) (if (null? sc1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45TTC-45VarC-45NVar-later eta-0)) (CoreC-45TTC-45Var-isNVar arg-0 e-3)) (box 0))))))))
(define CoreC-45TTC-45Term-resolveNamesBinder (lambda (arg-0 arg-1) (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TTC-45Term-resolveNames arg-0 eta-0)) arg-1)))
(define CoreC-45TTC-45Term-resolveNamesTerms (lambda (arg-0 arg-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TTC-45Term-resolveNames arg-0 eta-0)) arg-1)))
(define CoreC-45TTC-45Term-resolveNames (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (case (vector-ref e-2 0) ((0) (let ((sc2 (CoreC-45TTC-45Var-isNVar e-3 arg-0))) (if (null? sc2) (vector 1 e-1 (vector 0 ) e-3) (let ((e-4 (unbox sc2))) (vector 0 e-1 (box 0) e-4)))))(else arg-1)))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((e-8 (vector-ref arg-1 4))) (vector 2 e-5 e-6 e-7 (CoreC-45TTC-45Term-resolveNamesTerms arg-0 e-8))))))) ((3) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (let ((e-12 (vector-ref arg-1 3))) (let ((e-13 (vector-ref arg-1 4))) (vector 3 e-10 e-11 (CoreC-45TTC-45Term-resolveNamesBinder arg-0 e-12) (CoreC-45TTC-45Term-resolveNames (cons e-11 arg-0) e-13))))))) ((4) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (vector 4 e-15 (CoreC-45TTC-45Term-resolveNames arg-0 e-16) (CoreC-45TTC-45Term-resolveNames arg-0 e-17)))))) ((5) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (let ((e-22 (vector-ref arg-1 4))) (vector 5 e-19 e-20 (CoreC-45TTC-45Term-resolveNames arg-0 e-21) (CoreC-45TTC-45Term-resolveNames arg-0 e-22))))))) ((6) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (vector 6 e-24 e-25 (CoreC-45TTC-45Term-resolveNames arg-0 e-26)))))) ((7) (let ((e-28 (vector-ref arg-1 1))) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (let ((e-31 (vector-ref arg-1 4))) (vector 7 e-28 e-29 (CoreC-45TTC-45Term-resolveNames arg-0 e-30) (CoreC-45TTC-45Term-resolveNames arg-0 e-31))))))) ((8) (let ((e-33 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (let ((e-35 (vector-ref arg-1 3))) (vector 8 e-33 e-34 (CoreC-45TTC-45Term-resolveNames arg-0 e-35))))))(else arg-1))))
(define CoreC-45CaseC-45CaseBuilder-n--21674-15806-u--altGroups (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 '()))) (lambda () (lambda (u--e) (lambda (eta-0) (vector 1 (cons (vector 3 u--e) '()))))) arg-4) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (lambda (clam-0) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (let ((e-9 (vector-ref e-2 4))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-match (PreludeC-45TypesC-45List-tailRecAppend e-6 arg-3) (PreludeC-45TypesC-45List-tailRecAppend e-6 arg-1) arg-12 arg-11 arg-10 arg-9 arg-8 e-9 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-6) eta-1)) arg-4)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-n--21674-15806-u--altGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 0 e-7 e-8 e-6 e-5) e-10))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((1) (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (let ((e-14 (vector-ref e-2 3))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-match (cons e-12 (cons e-13 arg-3)) (cons e-12 (cons e-13 arg-1)) arg-12 arg-11 arg-10 arg-9 arg-8 e-14 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-12 (cons e-13 '()))) eta-1)) arg-4)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-n--21674-15806-u--altGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 1 e-12 e-13 e-5) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) (else (let ((e-17 (vector-ref e-2 1))) (let ((e-18 (vector-ref e-2 2))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-match arg-3 arg-1 arg-12 arg-11 arg-10 arg-9 arg-8 e-18 arg-4) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-n--21674-15806-u--altGroups arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 2 e-17 e-5) e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-caseGroups (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 arg-12 ext-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--21674-15806-u--altGroups arg-0 arg-2 arg-8 arg-1 arg-12 arg-11 arg-10 arg-7 arg-6 arg-5 arg-4 arg-3 arg-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 arg-0 arg-8 (CoreC-45TTC-45Term-resolveNames arg-1 arg-10) e-5))))) eff-0) ext-0)))))))
(define CoreC-45TT-substName (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((sc1 (CoreC-45Name-nameEq arg-1 e-3))) (if (null? sc1) (vector 1 e-1 e-2 e-3) arg-2)))))) ((2) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TT-substName arg-1 arg-2 eta-0)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (let ((e-13 (vector-ref arg-3 4))) (vector 3 e-10 e-11 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (CoreC-45TT-substName arg-1 arg-2 eta-0)) e-12) (CoreC-45TT-substName arg-1 (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) arg-2))) e-13))))))) ((4) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (vector 4 e-15 (CoreC-45TT-substName arg-1 arg-2 e-16) (CoreC-45TT-substName arg-1 arg-2 e-17)))))) ((5) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (vector 5 e-19 e-20 e-21 (CoreC-45TT-substName arg-1 arg-2 e-22))))))) ((6) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 3))) (vector 6 e-24 e-25 (CoreC-45TT-substName arg-1 arg-2 e-26)))))) ((7) (let ((e-28 (vector-ref arg-3 1))) (let ((e-29 (vector-ref arg-3 2))) (let ((e-30 (vector-ref arg-3 3))) (let ((e-31 (vector-ref arg-3 4))) (vector 7 e-28 e-29 (CoreC-45TT-substName arg-1 arg-2 e-30) (CoreC-45TT-substName arg-1 arg-2 e-31))))))) ((8) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (let ((e-35 (vector-ref arg-3 3))) (vector 8 e-33 e-34 (CoreC-45TT-substName arg-1 arg-2 e-35))))))(else arg-3))))
(define CoreC-45CaseC-45CaseBuilder-C-43C-43 (lambda (arg-3 arg-4) (if (null? arg-3) arg-4 (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons e-4 (CoreC-45CaseC-45CaseBuilder-C-43C-43 e-5 arg-4)))))))
(define CoreC-45TTC-45Primitive-primTypeEq (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) (box (vector 0 )))(else '()))) ((equal? arg-0 1) (cond ((equal? arg-1 1) (box (vector 0 )))(else '()))) ((equal? arg-0 2) (cond ((equal? arg-1 2) (box (vector 0 )))(else '()))) ((equal? arg-0 3) (cond ((equal? arg-1 3) (box (vector 0 )))(else '()))) ((equal? arg-0 4) (cond ((equal? arg-1 4) (box (vector 0 )))(else '()))) ((equal? arg-0 5) (cond ((equal? arg-1 5) (box (vector 0 )))(else '()))) ((equal? arg-0 10) (cond ((equal? arg-1 10) (box (vector 0 )))(else '()))) ((equal? arg-0 11) (cond ((equal? arg-1 11) (box (vector 0 )))(else '()))) ((equal? arg-0 12) (cond ((equal? arg-1 12) (box (vector 0 )))(else '()))) ((equal? arg-0 13) (cond ((equal? arg-1 13) (box (vector 0 )))(else '())))(else '()))))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Bits16 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits16 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits16 arg-686 arg-689)))) ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Bits32 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits32 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits32 arg-686 arg-689)))) ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Bits64 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits64 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits64 arg-686 arg-689)))) ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Bits8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Bits8 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Bits8 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Bits8 arg-686 arg-689)))) ext-0 ext-1)))
(define DecidableC-45Equality-u--decEq_DecEq_Char (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a csegen-17 ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int16 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Int16 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int16 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int16 arg-686 arg-689)))) ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int32 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Int32 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int32 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int32 arg-686 arg-689)))) ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int64 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Int64 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int64 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int64 arg-686 arg-689)))) ext-0 ext-1)))
(define PreludeC-45EqOrd-u--C-47C-61_Eq_Int8 (lambda (arg-0 arg-1) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define DecidableC-45Equality-u--decEq_DecEq_Int8 (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int8 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int8 arg-686 arg-689)))) ext-0 ext-1)))
(define DecidableC-45Equality-u--decEq_DecEq_Integer (lambda (ext-0 ext-1) (DecidableC-45Equality-u--decEq_DecEq_FromEqC-36a csegen-722 ext-0 ext-1)))
(define CoreC-45TTC-45Primitive-constantEq (lambda (arg-0 arg-1) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-14 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Int e-0 e-14))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((1) (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((1) (let ((e-15 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Int8 e-1 e-15))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((2) (let ((e-2 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((2) (let ((e-16 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Int16 e-2 e-16))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((3) (let ((e-3 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((3) (let ((e-17 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Int32 e-3 e-17))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((4) (let ((e-4 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((4) (let ((e-18 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Int64 e-4 e-18))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((6) (let ((e-5 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((6) (let ((e-19 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Bits8 e-5 e-19))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((7) (let ((e-6 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((7) (let ((e-20 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Bits16 e-6 e-20))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((8) (let ((e-7 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((8) (let ((e-21 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Bits32 e-7 e-21))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((9) (let ((e-8 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((9) (let ((e-22 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Bits64 e-8 e-22))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((5) (let ((e-9 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((5) (let ((e-23 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Integer e-9 e-23))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((10) (let ((e-10 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((10) (let ((e-24 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_String e-10 e-24))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((11) (let ((e-11 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((11) (let ((e-25 (vector-ref arg-1 1))) (let ((sc2 (DecidableC-45Equality-u--decEq_DecEq_Char e-11 e-25))) (case (vector-ref sc2 0) ((0) (box (vector 0 ))) (else '())))))(else '())))) ((12) (case (vector-ref arg-1 0) ((12) '())(else '()))) ((13) (let ((e-13 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((13) (let ((e-27 (vector-ref arg-1 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--xy) (vector 0 )) (CoreC-45TTC-45Primitive-primTypeEq e-13 e-27))))(else '())))) ((14) (case (vector-ref arg-1 0) ((14) (box (vector 0 )))(else '())))(else '()))))
(define CoreC-45CaseC-45CaseBuilder-checkGroupMatch (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (case (vector-ref arg-4 0) ((0) (let ((e-5 (vector-ref arg-4 1))) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) (if (null? e-8) (vector 3 ) (let ((e-10 (car e-8))) (let ((sc3 (LibrariesC-45DataC-45ListC-45LengthMatch-checkLengthMatch arg-3 e-5))) (if (null? sc3) (vector 3 ) (let ((e-2 (unbox sc3))) (let ((sc4 (CoreC-45Name-nameEq e-0 e-6))) (if (null? sc4) (vector 3 ) (let ((sc5 (DecidableC-45Equality-u--decEq_DecEq_Int e-1 e-7))) (case (vector-ref sc5 0) ((0) (vector 0 e-1 e-2))(else (vector 3 ))))))))))))))))(else (vector 3 )))))) ((1) (if (null? arg-3) (case (vector-ref arg-4 0) ((1) (let ((e-23 (vector-ref arg-4 3))) (if (null? e-23) (vector 3 ) (let ((e-25 (car e-23))) (vector 1 )))))(else (vector 3 ))) (vector 3 ))) ((2) (let ((e-2 (vector-ref arg-2 1))) (if (null? arg-3) (case (vector-ref arg-4 0) ((2) (let ((e-36 (vector-ref arg-4 1))) (let ((e-37 (vector-ref arg-4 2))) (if (null? e-37) (vector 3 ) (let ((e-39 (car e-37))) (let ((sc4 (CoreC-45TTC-45Primitive-constantEq e-2 e-36))) (if (null? sc4) (vector 3 ) (vector 2 ))))))))(else (vector 3 ))) (vector 3 ))))(else (vector 3 )))))
(define CoreC-45CaseC-45CaseBuilder-nextName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))) eff-0) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_ArgType (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (vector 0 e-1 (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-3 (cdr sc1))) ((((e-3 'erased) 'erased) arg-2) e-2))))))) ((1) (let ((e-4 (vector-ref arg-3 1))) (vector 1 (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-2 (cdr sc1))) ((((e-2 'erased) 'erased) arg-2) e-4)))))) (else (vector 2 )))))
(define CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 (lambda (arg-3 arg-4) (let ((e-2 (vector-ref arg-4 0))) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (vector (+ arg-3 e-2) e-3 e-4 (CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_ArgType arg-3 e-6))))))))
(define CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_C-40PatInfoC-32C-36pC-41 (lambda (ext-0) (CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 (LibrariesC-45DataC-45ListC-45SizeOf-suc 0) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-weaken (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons (CoreC-45CaseC-45CaseBuilder-u--weaken_Weaken_C-40PatInfoC-32C-36pC-41 e-4) (CoreC-45CaseC-45CaseBuilder-weaken arg-1 arg-2 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-nextNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-5) (vector 1 (cons '() (cons 0 '()))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45CaseC-45CaseBuilder-nextName arg-1 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--env (CoreC-45Env-mkEnv arg-3 arg-0))) (lambda (eta-2) (let ((act-4 (if (null? arg-6) (vector 1 (cons '() (vector 2 ))) (let ((e-4 (unbox arg-6))) (case (vector-ref e-4 0) ((0) (let ((e-11 (vector-ref e-4 1))) (let ((e-9 (vector-ref e-4 3))) (let ((e-8 (vector-ref e-4 4))) (case (vector-ref e-9 0) ((2) (let ((e-14 (vector-ref e-9 2))) (let ((e-12 (vector-ref e-9 4))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-0 e-5 e-12) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-16 0) ((9) (let ((act-5 (((e-8 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts u--env (vector 1 e-11 (vector 0 ) e-7))) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-18 (vector-ref act-5 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (box e-18) (vector 2 )))))) eff-0) clam-1))))))(else (let ((act-5 (((e-8 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts u--env (vector 1 e-11 (vector 0 ) e-7))) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-6 u--env e-16 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-18 (vector-ref act-6 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (box e-17) (vector 0 e-14 e-18)))))) eff-0) eta-3)))))))) eff-0) clam-1)))))))))) eff-0) eta-2))))))))(else (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-6 u--env e-4 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons '() (vector 1 e-12)))))) eff-0) eta-2)))))))))))(else (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-6 u--env e-4 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons '() (vector 1 e-8)))))) eff-0) eta-2))))))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45CaseC-45CaseBuilder-nextNames arg-0 arg-1 arg-2 arg-3 arg-4 e-3 (Builtin-fst e-8) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (let ((u--argTy (let ((sc8 (Builtin-snd e-8))) (case (vector-ref sc8 0) ((2) (vector 2 )) ((0) (let ((e-14 (vector-ref sc8 1))) (let ((e-13 (vector-ref sc8 2))) (vector 0 e-14 (let ((sc9 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-15 (cdr sc9))) ((((e-15 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-suc e-12)) e-13))))))) (else (let ((e-13 (vector-ref sc8 1))) (vector 1 (let ((sc9 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-14 (cdr sc9))) ((((e-14 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-suc e-12)) e-13)))))))))) (lambda (eta-4) (vector 1 (cons (cons e-7 e-10) (cons (LibrariesC-45DataC-45ListC-45SizeOf-suc e-12) (cons (vector 0 e-7 e-2 u--argTy) (CoreC-45CaseC-45CaseBuilder-weaken e-7 (PreludeC-45TypesC-45List-tailRecAppend e-10 arg-0) e-11))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16601-10559-u--update (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-3 0) ((6) (let ((e-5 (vector-ref e-3 2))) (box (cons e-5 e-2))))(else '())))))))
(define CoreC-45CaseC-45CaseBuilder-updateNames (lambda (ext-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--16601-10559-u--update eta-0)) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update (lambda (arg-3 arg-4 arg-5 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (let ((e-1 (vector-ref arg-7 2))) (let ((e-2 (vector-ref arg-7 3))) (let ((sc1 (DataC-45List-lookup csegen-832 e-1 arg-5))) (if (null? sc1) (vector 0 e-0 e-1 (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 e-2)) (let ((e-3 (unbox sc1))) (vector 0 e-0 e-3 (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 e-2))))))))) ((1) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (let ((e-5 (vector-ref arg-7 3))) (let ((e-6 (vector-ref arg-7 4))) (let ((e-7 (vector-ref arg-7 5))) (vector 1 e-3 e-4 e-5 e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 eta-0)) e-7)))))))) ((2) (let ((e-8 (vector-ref arg-7 1))) (let ((e-9 (vector-ref arg-7 2))) (let ((e-10 (vector-ref arg-7 3))) (let ((e-11 (vector-ref arg-7 4))) (vector 2 e-8 e-9 e-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 eta-0)) e-11))))))) ((4) (let ((e-12 (vector-ref arg-7 1))) (let ((e-13 (vector-ref arg-7 2))) (let ((e-14 (vector-ref arg-7 3))) (let ((e-15 (vector-ref arg-7 4))) (vector 4 e-12 e-13 (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 e-14) (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 e-15))))))) ((5) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (let ((e-19 (vector-ref arg-7 4))) (vector 5 e-16 e-17 (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 e-18) (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update arg-3 arg-4 arg-5 e-19))))))) ((6) (let ((e-20 (vector-ref arg-7 1))) (let ((e-21 (vector-ref arg-7 2))) (let ((sc1 (DataC-45List-lookup csegen-832 e-21 arg-5))) (if (null? sc1) (vector 6 e-20 e-21) (let ((e-2 (unbox sc1))) (vector 6 e-20 e-2)))))))(else arg-7))))
(define CoreC-45CaseC-45CaseBuilder-updatePatNames (lambda (arg-2 arg-3) (if (null? arg-3) '() (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (cons (let ((e-2 (vector-ref e-4 0))) (let ((e-3 (vector-ref e-4 1))) (let ((e-7 (vector-ref e-4 2))) (let ((e-6 (vector-ref e-4 3))) (vector e-2 e-3 (CoreC-45CaseC-45CaseBuilder-n--16633-10611-u--update e-5 e-4 arg-2 e-7) e-6))))) (CoreC-45CaseC-45CaseBuilder-updatePatNames arg-2 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-weakenNs (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (cons (CoreC-45CaseC-45CaseBuilder-u--weakenNs_Weaken_C-40PatInfoC-32C-36pC-41 arg-3 e-4) (CoreC-45CaseC-45CaseBuilder-weakenNs arg-3 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-newPats (lambda (arg-3 arg-4 arg-5) (if (null? arg-3) (cond ((equal? arg-4 0) '())(else (blodwen-error-quit "Nat case not covered"))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? arg-4 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-12 (- arg-4 1))) (let ((e-16 (car arg-5))) (let ((e-17 (cdr arg-5))) (cons (let ((e-7 (vector-ref e-16 0))) (let ((e-5 (vector-ref e-16 1))) (let ((e-6 (vector-ref e-16 3))) (vector e-7 e-5 e-2 e-6)))) (CoreC-45CaseC-45CaseBuilder-newPats e-3 e-12 e-17))))))))))))
(define CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConG-11238 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-11 0) ((0) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (let ((e-10 (vector-ref arg-11 4))) (if (null? e-10) (lambda (clam-2) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-14 arg-13 arg-12 arg-19 arg-18 arg-17 arg-16) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-2)))))) (let ((e-12 (car e-10))) (let ((e-13 (cdr e-10))) (let ((e-16 (vector-ref e-12 0))) (let ((e-17 (vector-ref e-12 1))) (let ((e-18 (vector-ref e-12 2))) (let ((e-19 (vector-ref e-12 3))) (case (vector-ref arg-15 0) ((0) (let ((e-31 (vector-ref arg-15 2))) (let ((u--newps (CoreC-45CaseC-45CaseBuilder-newPats arg-12 e-31 e-17))) (let ((u--l (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-7))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (DataC-45List-u--zip_Zippable_List e-7 arg-12)) (CoreC-45CaseC-45CaseBuilder-weakenNs u--l arg-19)))) (let ((u--newclause (vector e-16 (CoreC-45CaseC-45CaseBuilder-C-43C-43 u--newps u--patsC-39) arg-18 (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-2 (cdr sc3))) ((((e-2 'erased) 'erased) u--l) arg-17)))))) (lambda (eta-0) (vector 1 (cons (vector 0 e-7 e-8 e-9 (cons (vector e-16 e-17 e-18 e-19) (PreludeC-45TypesC-45List-tailRecAppend e-13 (cons u--newclause '())))) arg-16)))))))))(else (lambda (clam-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-14 arg-13 arg-12 arg-19 arg-18 arg-17 arg-16) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-0))))))))))))))))))))(else (lambda (clam-3) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-14 arg-13 arg-12 arg-19 arg-18 arg-17 arg-16) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-3))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) (lambda (eta-0) (let ((act-1 (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-11 (vector 1 (vector 0 "->"))))) (cond ((equal? sc1 1) (vector 1 (vector 0 arg-6 (vector 2 "_" 0) (vector 2 arg-6 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 1 CoreC-45Value-defaultOpts (CoreC-45Env-mkEnv arg-6 arg-9) (vector 10 arg-6 (vector 2 "top" 0)))) (lambda (u--d) (lambda (u--a) (lambda (eta-1) (vector 1 (vector 0 arg-6 (vector 2 "_" 1) (vector 2 arg-6 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 1 CoreC-45Value-defaultOpts (CoreC-45Env-mkEnv arg-6 arg-9) (vector 9 arg-6 (vector 0 )))) (lambda (d-0) (lambda (a-0) (lambda (eta-2) (vector 1 (vector 10 arg-6 (vector 2 "top" 0)))))))))))))) (else (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact arg-11 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (vector 9 arg-6 (vector 0 )))) (let ((e-1 (unbox e-6))) (CoreC-45NormaliseC-45Eval-nf arg-7 arg-9 e-5 (CoreC-45Env-mkEnv arg-6 arg-9) e-1))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-nextNames arg-9 arg-8 arg-7 arg-6 "e" arg-13 (box e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (DataC-45List-u--zip_Zippable_List e-2 arg-13)) (CoreC-45CaseC-45CaseBuilder-weakenNs e-8 arg-14)))) (let ((u--clause (vector arg-4 (CoreC-45CaseC-45CaseBuilder-C-43C-43 e-7 u--patsC-39) arg-15 (let ((sc5 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc5))) ((((e-4 'erased) 'erased) e-8) arg-16)))))) (lambda (eta-2) (vector 1 (cons (vector 0 e-2 arg-11 arg-12 (cons u--clause '())) '()))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConG-11238 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-2 arg-13 arg-12 arg-11 (CoreC-45CaseC-45CaseBuilder-checkGroupMatch (vector 0 arg-11 arg-12) arg-13 e-2) e-3 arg-16 arg-15 arg-14))))))
(define CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConstG-11813 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-11 0) ((2) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (if (null? e-8) (lambda (clam-2) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10835-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-12 arg-17 arg-16 arg-15 arg-14) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-2)))))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((e-14 (vector-ref e-10 0))) (let ((e-15 (vector-ref e-10 1))) (let ((e-16 (vector-ref e-10 2))) (let ((e-17 (vector-ref e-10 3))) (case (vector-ref arg-13 0) ((2) (let ((u--newclause (vector e-14 arg-17 arg-16 arg-15))) (lambda (eta-0) (vector 1 (cons (vector 2 e-7 (cons (vector e-14 e-15 e-16 e-17) (PreludeC-45TypesC-45List-tailRecAppend e-11 (cons u--newclause '())))) arg-14)))))(else (lambda (clam-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10835-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-12 arg-17 arg-16 arg-15 arg-14) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-0))))))))))))))))))(else (lambda (clam-3) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10835-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-12 arg-17 arg-16 arg-15 arg-14) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-3))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16869-10835-u--addConstG (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (lambda (eta-0) (vector 1 (cons (vector 2 arg-11 (cons (vector arg-4 arg-12 arg-13 arg-14) '())) '()))) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addConstG-11813 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-2 arg-11 (CoreC-45CaseC-45CaseBuilder-checkGroupMatch (vector 2 arg-11) '() e-2) e-3 arg-14 arg-13 arg-12))))))
(define CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addDelayG-11612 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-11 0) ((1) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (if (null? e-9) (lambda (clam-2) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10836-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-2)))))) (let ((e-11 (car e-9))) (let ((e-12 (cdr e-9))) (let ((e-15 (vector-ref e-11 0))) (let ((e-16 (vector-ref e-11 1))) (let ((e-17 (vector-ref e-11 2))) (let ((e-18 (vector-ref e-11 3))) (case (vector-ref arg-12 0) ((1) (let ((u--l (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-7 (cons e-8 '()))))) (let ((u--newps (CoreC-45CaseC-45CaseBuilder-newPats (cons arg-18 (cons arg-17 '())) 2 e-16))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (cons (cons e-7 arg-18) (cons (cons e-8 arg-17) '()))) (CoreC-45CaseC-45CaseBuilder-weakenNs u--l arg-16)))) (let ((u--newclause (vector e-15 (CoreC-45CaseC-45CaseBuilder-C-43C-43 u--newps u--patsC-39) arg-15 (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-2 (cdr sc3))) ((((e-2 'erased) 'erased) u--l) arg-14)))))) (lambda (eta-0) (vector 1 (cons (vector 1 e-7 e-8 (cons (vector e-15 e-16 e-17 e-18) (PreludeC-45TypesC-45List-tailRecAppend e-12 (cons u--newclause '())))) arg-13))))))))(else (lambda (clam-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10836-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-0)))))))))))))))))))(else (lambda (clam-3) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10836-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons arg-11 e-5))))) eff-0) clam-3))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--16869-10836-u--addDelayG (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (let ((u--dty (vector 0 arg-6 (vector 2 "a" 0) (vector 2 arg-6 csegen-30 (vector 1 ) (vector 1 CoreC-45Value-defaultOpts (CoreC-45Env-mkEnv arg-6 arg-9) (vector 10 arg-6 (vector 2 "top" 0)))) (lambda (u--d) (lambda (u--a) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-7 arg-9 u--d u--a) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 arg-6 (vector 2 "x" 0) (vector 2 arg-6 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) u--a) (lambda (u--dv) (lambda (u--av) (lambda (eta-2) (vector 1 (vector 5 arg-6 2 e-5)))))))))) eff-0) eta-0))))))))))) (lambda (eta-0) (let ((act-1 (CoreC-45CaseC-45CaseBuilder-nextNames arg-9 arg-8 arg-7 arg-6 "e" (cons arg-11 (cons arg-12 '())) (box u--dty) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-2808 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (if (null? e-2) csegen-2808 (let ((e-7 (car e-2))) (let ((e-6 (cdr e-2))) (if (null? e-6) csegen-2808 (let ((e-8 (car e-6))) (let ((e-9 (cdr e-6))) (if (null? e-9) (if (null? e-3) csegen-2808 (let ((e-13 (car e-3))) (let ((e-14 (cdr e-3))) (let ((u--patsC-39 (CoreC-45CaseC-45CaseBuilder-updatePatNames (CoreC-45CaseC-45CaseBuilder-updateNames (cons (cons e-7 arg-11) (cons (cons e-8 arg-12) '()))) (CoreC-45CaseC-45CaseBuilder-weakenNs e-13 arg-13)))) (let ((u--clause (vector arg-4 (CoreC-45CaseC-45CaseBuilder-C-43C-43 e-14 u--patsC-39) arg-14 (let ((sc7 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc7))) ((((e-4 'erased) 'erased) e-13) arg-15)))))) (lambda (eta-1) (vector 1 (cons (vector 1 e-7 e-8 (cons u--clause '())) '())))))))) csegen-2808)))))))))))) eff-0) eta-0))))))) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (CoreC-45CaseC-45CaseBuilder-with--groupConsC-44addDelayG-11612 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-2 (CoreC-45CaseC-45CaseBuilder-checkGroupMatch (vector 1 ) '() e-2) e-3 arg-15 arg-14 arg-13 arg-12 arg-11))))))
(define CoreC-45CaseC-45CaseBuilder-n--16869-10837-u--addGroup (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 arg-12 arg-13 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-13 0) ((0) (let ((e-0 (vector-ref arg-13 1))) (let ((e-1 (vector-ref arg-13 2))) (let ((e-2 (vector-ref arg-13 3))) (CoreC-45CaseC-45CaseBuilder-n--16869-10837-u--addGroup arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 arg-12 e-2 arg-15 arg-16 (CoreC-45TT-substName e-1 (vector 0 e-0 (box 1) arg-12) arg-17) arg-18))))) ((1) (let ((e-3 (vector-ref arg-13 1))) (let ((e-4 (vector-ref arg-13 2))) (let ((e-5 (vector-ref arg-13 3))) (let ((e-6 (vector-ref arg-13 4))) (let ((e-7 (vector-ref arg-13 5))) (let ((sc1 (or (and (= e-6 (PreludeC-45TypesC-45List-lengthTR e-7)) 1) 0))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-4 e-5 e-7 arg-15 arg-16 arg-17 arg-18)) (else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 e-3 arg-5 (vector 3 e-4)) eta-0))))))))))) ((2) (let ((e-8 (vector-ref arg-13 1))) (let ((e-9 (vector-ref arg-13 2))) (let ((e-10 (vector-ref arg-13 3))) (let ((e-11 (vector-ref arg-13 4))) (let ((sc1 (or (and (= e-10 (PreludeC-45TypesC-45List-lengthTR e-11)) 1) 0))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-9 0 e-11 arg-15 arg-16 arg-17 arg-18)) (else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 e-8 arg-5 (vector 3 e-9)) eta-0)))))))))) ((4) (let ((e-14 (vector-ref arg-13 3))) (let ((e-15 (vector-ref arg-13 4))) (CoreC-45CaseC-45CaseBuilder-n--16869-10834-u--addConG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 (vector 1 (vector 0 "->")) 0 (cons e-14 (cons e-15 '())) arg-15 arg-16 arg-17 arg-18)))) ((5) (let ((e-18 (vector-ref arg-13 3))) (let ((e-19 (vector-ref arg-13 4))) (CoreC-45CaseC-45CaseBuilder-n--16869-10836-u--addDelayG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-18 e-19 arg-15 arg-16 arg-17 arg-18)))) ((3) (let ((e-21 (vector-ref arg-13 2))) (CoreC-45CaseC-45CaseBuilder-n--16869-10835-u--addConstG arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-21 arg-15 arg-16 arg-17 arg-18)))(else (lambda (eta-0) (vector 1 arg-18))))))
(define CoreC-45CaseC-45CaseBuilder-n--16869-10838-u--gc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-12)) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (let ((e-9 (vector-ref e-2 3))) (lambda (clam-0) (let ((e-13 (car e-7))) (let ((e-14 (cdr e-7))) (let ((e-17 (vector-ref e-13 0))) (let ((e-19 (vector-ref e-13 2))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-n--16869-10837-u--addGroup arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-17 e-19 e-14 e-8 e-9 arg-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-n--16869-10838-u--gc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5 e-3))) eff-0) clam-0))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-groupCons (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (CoreC-45CaseC-45CaseBuilder-n--16869-10838-u--gc arg-0 arg-1 arg-2 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-1 arg-2 '() arg-8)))
(define CoreC-45TTC-45Var-isVar (lambda (arg-0 arg-1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) eta-0) (CoreC-45TTC-45Var-isNVar arg-0 arg-1))))
(define CoreC-45CaseC-45CaseTree-mkTerm (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-2))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((e-6 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-1 5))) (CoreC-45TTC-45Term-apply e-3 (vector 1 e-3 (vector 2 e-5 e-6) e-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 eta-0)) e-7)))))))) ((2) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (CoreC-45TTC-45Term-apply e-8 (vector 1 e-8 (vector 3 0 e-10) e-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 eta-0)) e-11))))))) ((3) (let ((e-12 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 2))) (vector 9 e-12 e-13)))) ((4) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (vector 3 e-14 e-15 (vector 2 e-14 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-16)) (CoreC-45CaseC-45CaseTree-mkTerm (cons e-15 arg-0) e-17))))))) ((5) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (vector 7 e-18 e-19 (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-20) (CoreC-45CaseC-45CaseTree-mkTerm arg-0 e-21))))))) ((6) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (let ((sc1 (CoreC-45TTC-45Var-isVar e-23 arg-0))) (if (null? sc1) (vector 1 e-22 (vector 0 ) e-23) (let ((e-1 (unbox sc1))) (vector 0 e-22 '() e-1))))))) (else (let ((e-25 (vector-ref arg-1 2))) e-25)))))
(define CoreC-45CaseC-45CaseBuilder-updatePats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-1) (lambda (clam-0) (vector 1 '())) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (case (vector-ref arg-4 0) ((0) (let ((e-11 (vector-ref arg-4 1))) (let ((e-13 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 4))) (case (vector-ref e-13 0) ((2) (let ((e-17 (vector-ref e-13 2))) (let ((e-19 (vector-ref e-13 4))) (if (null? arg-5) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (lambda (clam-1) (let ((e-6 (vector-ref e-8 3))) (case (vector-ref e-6 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-10 (vector-ref act-1 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-15 arg-3 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-20 (vector-ref act-3 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (let ((e-24 (vector-ref e-8 0))) (let ((e-23 (vector-ref e-8 1))) (let ((e-22 (vector-ref e-8 2))) (vector e-24 e-23 e-22 (vector 1 e-20))))) e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))(else (vector 1 (cons e-8 e-9)))))))) (let ((e-23 (car arg-5))) (let ((e-24 (cdr arg-5))) (lambda (clam-0) (let ((e-6 (vector-ref e-23 3))) (case (vector-ref e-6 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-8 (vector-ref act-1 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-2 arg-0 e-9 arg-3 e-19 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (((e-14 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-11 (vector 0 ) e-2))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45CaseC-45CaseBuilder-updatePats arg-0 e-3 arg-2 arg-3 e-15 e-24) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-20 (vector-ref act-5 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (let ((e-26 (vector-ref e-23 0))) (let ((e-25 (vector-ref e-23 1))) (let ((e-22 (vector-ref e-23 2))) (vector e-26 e-25 e-22 (vector 0 e-17 e-10))))) e-20))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 (cons e-23 e-24))))))))))))(else (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (lambda (clam-2) (let ((e-6 (vector-ref e-8 3))) (case (vector-ref e-6 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-10 (vector-ref act-1 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-15 arg-3 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (let ((e-20 (vector-ref e-8 0))) (let ((e-19 (vector-ref e-8 1))) (let ((e-18 (vector-ref e-8 2))) (vector e-20 e-19 e-18 (vector 1 e-16))))) e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))(else (vector 1 (cons e-8 e-9))))))))))))))(else (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (lambda (clam-3) (let ((e-6 (vector-ref e-8 3))) (case (vector-ref e-6 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-10 (vector-ref act-1 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-2 arg-0 e-11 arg-3 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (let ((e-16 (vector-ref e-8 0))) (let ((e-15 (vector-ref e-8 1))) (let ((e-14 (vector-ref e-8 2))) (vector e-16 e-15 e-14 (vector 1 e-12))))) e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))(else (vector 1 (cons e-8 e-9)))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-case--substInPatInfo-6225 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (let ((act-1 (let ((act-1 (unbox arg-8))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 e-5 (CoreC-45Env-mkEnv arg-7 arg-1) e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-6 0) ((1) (vector 1 (cons (let ((e-11 (vector-ref arg-4 0))) (let ((e-10 (vector-ref arg-4 1))) (let ((e-9 (vector-ref arg-4 2))) (vector e-11 e-10 e-9 (vector 0 e-1 (CoreC-45TT-substName arg-6 arg-5 e-2)))))) arg-2)))(else (vector 1 (cons arg-4 arg-2))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) ((1) (let ((e-4 (vector-ref arg-9 1))) (let ((act-1 (let ((act-1 (unbox arg-8))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--env (CoreC-45Env-mkEnv arg-7 arg-1))) (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-8 arg-1 e-5 u--env (CoreC-45TT-substName arg-6 arg-5 e-4)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-7 0) ((0) (let ((e-1 (vector-ref e-7 1))) (let ((e-3 (vector-ref e-7 3))) (let ((e-8 (vector-ref e-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-11 (vector-ref e-3 2))) (let ((e-9 (vector-ref e-3 4))) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-8 arg-1 e-6 u--env e-9 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (((e-8 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts u--env (vector 1 e-1 (vector 0 ) arg-3))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((CoreC-45CaseC-45CaseBuilder-updatePats arg-1 arg-0 arg-8 u--env e-14 arg-2) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (let ((e-19 (vector-ref arg-4 0))) (let ((e-18 (vector-ref arg-4 1))) (let ((e-17 (vector-ref arg-4 2))) (vector e-19 e-18 e-17 (vector 0 e-11 e-13))))) e-15))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) clam-0))))))))(else (vector 1 (cons arg-4 arg-2))))))))(else (vector 1 (cons arg-4 arg-2))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))) (else (vector 1 (cons arg-4 arg-2))))))
(define CoreC-45CaseC-45CaseBuilder-substInPatInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-case--substInPatInfo-6225 arg-2 arg-1 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 (let ((e-6 (vector-ref arg-7 3))) e-6) eta-0))))
(define CoreC-45CaseC-45CaseBuilder-substInPats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-1) (vector 1 '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-6))) (let ((e-9 (cdr arg-6))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-substInPatInfo e-2 arg-0 e-3 arg-2 arg-3 arg-4 arg-5 e-8 e-9) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-0 e-3 arg-2 arg-3 arg-4 arg-5 e-4) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-6 e-7))))) eff-0) clam-2)))))))))) eff-0) clam-0)))))))))))))
(define CoreC-45CaseC-45CaseBuilder-substInClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (vector-ref arg-5 0))) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (lambda (clam-0) (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (let ((e-13 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-9 1))) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-9 3))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-2 arg-3 arg-4 arg-0 (CoreC-45CaseC-45CaseTree-mkTerm arg-1 e-15) e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-2 (cons (vector e-13 e-14 e-15 e-17) e-6) e-4 e-5))))) eff-0) clam-0))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-conRule (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-8) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (vector 2 "No constructor clauses")))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-9) (let ((e-2 (car arg-8))) (let ((e-6 (vector-ref e-2 0))) (let ((e-7 (vector-ref e-2 1))) (lambda (clam-0) (let ((e-13 (car e-7))) (let ((e-17 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-13 1))) (let ((e-21 (vector-ref e-13 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-substInClause arg-0 arg-1 arg-2 arg-4 arg-5 eta-0)) arg-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-groupCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (case (vector-ref e-21 0) ((0) (let ((e-4 (vector-ref e-21 2))) (vector 1 e-4)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 arg-5 arg-6 (vector 4 )) eta-1))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-caseGroups e-18 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-17 e-11 e-10 arg-9 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--21768-16131-u--updateVar (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (vector-ref arg-10 0))) (let ((e-3 (vector-ref arg-10 1))) (let ((e-4 (vector-ref arg-10 2))) (let ((e-5 (vector-ref arg-10 3))) (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (lambda (clam-0) (let ((e-13 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-9 1))) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-9 3))) (case (vector-ref e-15 0) ((6) (let ((e-18 (vector-ref e-15 1))) (let ((e-19 (vector-ref e-15 2))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-0 arg-8 arg-7 arg-3 (vector 0 e-18 (box 0) e-13) e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector (cons e-19 e-2) e-6 e-4 (CoreC-45TT-substName e-19 (vector 0 e-18 (box 0) e-13) e-5)))))) eff-0) clam-0)))))))) ((0) (let ((e-20 (vector-ref e-15 1))) (let ((e-21 (vector-ref e-15 2))) (let ((e-22 (vector-ref e-15 3))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-0 arg-8 arg-7 arg-3 (CoreC-45CaseC-45CaseTree-mkTerm arg-1 e-22) e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--rhsC-39 (CoreC-45TT-substName e-21 (vector 0 e-20 (box 1) e-13) e-5))) (CoreC-45CaseC-45CaseBuilder-n--21768-16131-u--updateVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector e-2 (cons (vector e-13 e-14 e-22 e-17) e-6) e-4 u--rhsC-39))))) eff-0) clam-0)))))))))(else (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-substInPats arg-1 arg-0 arg-8 arg-7 arg-3 (CoreC-45CaseC-45CaseTree-mkTerm arg-1 e-15) e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-2 e-6 e-4 e-5))))) eff-0) clam-0))))))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-varRule (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--21768-16131-u--updateVar arg-2 arg-1 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 eta-0)) arg-8 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-match arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-5 arg-9))) eff-0) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-mixture (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-9 0) ((0) (let ((e-3 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 3))) (let ((e-6 (vector-ref arg-9 4))) (let ((e-7 (vector-ref arg-9 5))) (if (null? e-3) (lambda (clam-0) (vector 1 arg-10)) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mixture arg-0 arg-1 arg-2 arg-3 arg-4 e-5 arg-6 arg-7 arg-8 e-7 arg-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-conRule arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 e-6 e-8) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((1) (let ((e-8 (vector-ref arg-9 1))) (let ((e-10 (vector-ref arg-9 3))) (let ((e-11 (vector-ref arg-9 4))) (let ((e-12 (vector-ref arg-9 5))) (if (null? e-8) (lambda (clam-1) (vector 1 arg-10)) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mixture arg-0 arg-1 arg-2 arg-3 arg-4 e-10 arg-6 arg-7 arg-8 e-12 arg-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-varRule arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 e-11 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))(else (lambda (clam-2) (vector 1 arg-10))))))
(define CoreC-45CaseC-45CaseBuilder-getPatInfo (lambda (arg-2) (if (null? arg-2) '() (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (cons (let ((e-7 (vector-ref e-4 2))) e-7) (CoreC-45CaseC-45CaseBuilder-getPatInfo e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-namesFrom (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (cons e-1 (CoreC-45CaseC-45CaseBuilder-namesFrom e-2))))) ((1) (let ((e-7 (vector-ref arg-0 5))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesFrom eta-0)) e-7))) ((2) (let ((e-11 (vector-ref arg-0 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesFrom eta-0)) e-11))) ((4) (let ((e-14 (vector-ref arg-0 3))) (let ((e-15 (vector-ref arg-0 4))) (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45CaseC-45CaseBuilder-namesFrom e-14) (CoreC-45CaseC-45CaseBuilder-namesFrom e-15))))) ((5) (let ((e-18 (vector-ref arg-0 3))) (let ((e-19 (vector-ref arg-0 4))) (PreludeC-45TypesC-45List-tailRecAppend (CoreC-45CaseC-45CaseBuilder-namesFrom e-18) (CoreC-45CaseC-45CaseBuilder-namesFrom e-19))))) ((6) (let ((e-21 (vector-ref arg-0 2))) (cons e-21 '())))(else '()))))
(define CoreC-45CaseC-45CaseBuilder-namesIn (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 e-1 arg-0))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-2)) (else 0)))))) ((1) (let ((e-7 (vector-ref arg-1 5))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 eta-0)) e-7))) ((2) (let ((e-11 (vector-ref arg-1 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 eta-0)) e-11))) ((4) (let ((e-14 (vector-ref arg-1 3))) (let ((e-15 (vector-ref arg-1 4))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-14))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-15)) (else 0)))))) ((5) (let ((e-18 (vector-ref arg-1 3))) (let ((e-19 (vector-ref arg-1 4))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-18))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-namesIn arg-0 e-19)) (else 0)))))) ((6) (let ((e-21 (vector-ref arg-1 2))) (PreludeC-45Types-elem csegen-14 csegen-832 e-21 arg-0)))(else 1))))
(define CoreC-45CaseC-45CaseBuilder-n--14204-8489-u--splitCon (lambda (arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((sc0 (or (and (= arg-13 (PreludeC-45TypesC-45List-lengthTR arg-14)) 1) 0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 (lambda (arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((1) (let ((e-3 (vector-ref arg-13 4))) (let ((e-4 (vector-ref arg-13 5))) (CoreC-45CaseC-45CaseBuilder-n--14204-8489-u--splitCon arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3 e-4)))) ((2) (let ((e-7 (vector-ref arg-13 3))) (let ((e-8 (vector-ref arg-13 4))) (CoreC-45CaseC-45CaseBuilder-n--14204-8489-u--splitCon arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-7 e-8)))) ((3) 0) ((4) 0) ((5) 0)(else 1))))
(define CoreC-45CaseC-45CaseBuilder-n--14204-8488-u--getClauseType (lambda (arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-13) (case (vector-ref arg-14 0) ((0) (let ((e-5 (vector-ref arg-14 3))) (CoreC-45CaseC-45CaseBuilder-n--14204-8488-u--getClauseType arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5 arg-15)))(else (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-1))) (cond ((equal? sc2 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))(else (CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))) (let ((e-6 (unbox arg-13))) (case (vector-ref arg-14 0) ((1) (let ((e-10 (vector-ref arg-14 4))) (let ((e-11 (vector-ref arg-14 5))) (case (vector-ref arg-15 0) ((0) (let ((e-13 (vector-ref arg-15 1))) (let ((sc3 (let ((sc4 (AlgebraC-45Semiring-isErased csegen-931 e-13))) (cond ((equal? sc4 1) (let ((sc5 (AlgebraC-45Semiring-isErased csegen-931 e-6))) (cond ((equal? sc5 1) 0) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-namesIn (PreludeC-45TypesC-45List-tailRecAppend arg-11 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-namesFrom eta-1)) (CoreC-45CaseC-45CaseBuilder-getPatInfo arg-8))) eta-0)) e-11))))) (else 0))))) (cond ((equal? sc3 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--14204-8489-u--splitCon arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-10 e-11))))))(else (case (vector-ref arg-14 0) ((0) (let ((e-5 (vector-ref arg-14 3))) (CoreC-45CaseC-45CaseBuilder-n--14204-8488-u--getClauseType arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5 arg-15)))(else (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((sc3 (AlgebraC-45Semiring-isErased csegen-931 e-1))) (cond ((equal? sc3 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))(else (CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))))))(else (case (vector-ref arg-14 0) ((0) (let ((e-5 (vector-ref arg-14 3))) (CoreC-45CaseC-45CaseBuilder-n--14204-8488-u--getClauseType arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-5 arg-15)))(else (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-1))) (cond ((equal? sc2 1) 1) (else (CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14))))))(else (CoreC-45CaseC-45CaseBuilder-n--14204-8487-u--clauseTypeC-39 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14)))))))))))
(define CoreC-45CaseC-45CaseBuilder-clauseType (lambda (arg-3 arg-4) (let ((e-2 (vector-ref arg-4 0))) (let ((e-3 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 2))) (let ((e-5 (vector-ref arg-4 3))) (let ((e-9 (car e-3))) (let ((e-10 (cdr e-3))) (let ((e-13 (vector-ref e-9 0))) (let ((e-14 (vector-ref e-9 1))) (let ((e-15 (vector-ref e-9 2))) (let ((e-17 (vector-ref e-9 3))) (CoreC-45CaseC-45CaseBuilder-n--14204-8488-u--getClauseType e-13 e-14 e-17 e-15 e-10 e-5 e-4 e-2 arg-3 arg-3 e-15 e-17)))))))))))))
(define CoreC-45CaseC-45CaseBuilder-with--partition-8895 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-5 0) ((0) (let ((e-3 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 3))) (let ((e-6 (vector-ref arg-5 4))) (let ((e-7 (vector-ref arg-5 5))) (if (null? e-3) (let ((sc4 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc4 0) (vector 0 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))) (else (vector 1 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc2 0) (vector 0 (cons arg-0 arg-1) arg-2 e-5 (cons arg-6 e-6) e-7)) (else (vector 1 (cons arg-0 arg-1) arg-2 (PreludeC-45TypesC-45List-tailRecAppend e-6 e-5) (cons arg-6 '()) (vector 0 (cons arg-0 arg-1) arg-2 e-5 e-6 e-7))))))))))) ((1) (let ((e-8 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 3))) (let ((e-11 (vector-ref arg-5 4))) (let ((e-12 (vector-ref arg-5 5))) (if (null? e-8) (let ((sc4 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc4 0) (vector 0 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))) (else (vector 1 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))))) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc2 0) (vector 0 (cons arg-0 arg-1) arg-2 (PreludeC-45TypesC-45List-tailRecAppend e-11 e-10) (cons arg-6 '()) (vector 1 (cons arg-0 arg-1) arg-2 e-10 e-11 e-12))) (else (vector 1 (cons arg-0 arg-1) arg-2 e-10 (cons arg-6 e-11) e-12))))))))))(else (let ((sc2 (CoreC-45CaseC-45CaseBuilder-clauseType arg-4 arg-6))) (cond ((equal? sc2 0) (vector 0 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 ))) (else (vector 1 (cons arg-0 arg-1) arg-2 '() (cons arg-6 '()) (vector 2 )))))))))
(define CoreC-45CaseC-45CaseBuilder-partition (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (vector 2 ) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CoreC-45CaseC-45CaseBuilder-with--partition-8895 arg-0 arg-1 arg-2 e-3 arg-3 (CoreC-45CaseC-45CaseBuilder-partition arg-0 arg-1 arg-2 arg-3 e-3) e-2))))))
(define CoreC-45CaseC-45CaseBuilder-getFirstArgType (lambda (arg-3) (let ((e-3 (car arg-3))) (let ((e-6 (vector-ref e-3 3))) e-6))))
(define CoreC-45CaseC-45CaseBuilder-n--19983-13678-u--headEq (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-11 0) ((0) (let ((e-6 (vector-ref arg-11 3))) (case (vector-ref e-6 0) ((2) (case (vector-ref arg-12 0) ((0) (let ((e-35 (vector-ref arg-12 3))) (case (vector-ref e-35 0) ((2) 1)(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((3) (let ((e-10 (vector-ref arg-11 2))) (case (vector-ref arg-12 0) ((3) (let ((e-44 (vector-ref arg-12 2))) (CoreC-45Name-u--C-61C-61_Eq_Name e-10 e-44)))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((8) (let ((e-16 (vector-ref arg-11 2))) (case (vector-ref arg-12 0) ((8) (let ((e-50 (vector-ref arg-12 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-16 e-50)))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((10) (case (vector-ref arg-12 0) ((10) 1)(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))) ((1) (let ((e-22 (vector-ref arg-11 2))) (case (vector-ref e-22 0) ((1) (let ((e-56 (vector-ref e-22 2))) (case (vector-ref arg-12 0) ((1) (let ((e-59 (vector-ref arg-12 2))) (case (vector-ref e-59 0) ((1) (let ((e-63 (vector-ref e-59 2))) (if (null? arg-13) (CoreC-45Name-u--C-61C-61_Eq_Name e-56 e-63) (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0)))))) ((9) (if (null? arg-13) 1 (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))(else (case (vector-ref arg-12 0) ((9) (if (null? arg-13) 1 0))(else 0))))))
(define CoreC-45CaseC-45CaseBuilder-n--19983-13679-u--sameTypeAs (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (lambda (clam-0) (if (null? arg-13) (vector 1 (vector 0 )) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-9 arg-2 e-7 arg-5 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc4 (CoreC-45CaseC-45CaseBuilder-n--19983-13678-u--headEq arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-8 arg-7))) (cond ((equal? sc4 1) (CoreC-45CaseC-45CaseBuilder-n--19983-13679-u--sameTypeAs arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-3)) (else (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 arg-8 arg-6 (vector 1 )) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 arg-8 arg-6 (vector 1 )) clam-0)))))))))
(define CoreC-45CaseC-45CaseBuilder-sameType (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (if (null? arg-9) (vector 1 (vector 0 )) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (CoreC-45CaseC-45CaseBuilder-getFirstArgType e-2))) (case (vector-ref sc2 0) ((0) (let ((e-4 (vector-ref sc2 2))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-4 arg-2 e-5 arg-8 e-4) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-n--19983-13679-u--sameTypeAs arg-2 e-2 e-3 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-6 e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-getFirstArgType eta-0)) e-3)))) eff-0) clam-1)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 arg-5 arg-7 (vector 1 )) clam-1))))))) eff-0) ext-0))))))))))
(define CoreC-45CaseC-45CaseBuilder-getScore (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 (CoreC-45CaseC-45CaseBuilder-sameType arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (CoreC-45Env-mkEnv arg-5 arg-2) arg-8 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 1 (vector 0 ))))))) (lambda (lcase-0) (lambda (clam-0) (case (vector-ref lcase-0 0) ((43) (let ((e-2 (vector-ref lcase-0 3))) (vector 1 (vector 0 e-2))))(else (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-0))))) ext-0)))
(define CoreC-45CaseC-45CaseBuilder-getFirstPat (lambda (arg-3) (let ((e-3 (car arg-3))) (let ((e-5 (vector-ref e-3 2))) e-5))))
(define CoreC-45CaseC-45CaseBuilder-n--20481-14100-u--dropAs (lambda (arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-2 (vector-ref arg-5 3))) e-2))(else arg-5))))
(define CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs (lambda (arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 1 (case (vector-ref arg-5 0) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (let ((e-3 (vector-ref arg-5 4))) (if (null? arg-6) 0 (let ((e-22 (car arg-6))) (let ((e-23 (cdr arg-6))) (case (vector-ref e-22 0) ((2) (let ((e-25 (vector-ref e-22 2))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-25))) (cond ((equal? sc4 1) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs arg-3 arg-4 (vector 2 e-0 e-1 e-2 e-3) e-23)) (else 0)))))(else 0)))))))))) ((1) (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((e-6 (vector-ref arg-5 3))) (let ((e-7 (vector-ref arg-5 4))) (let ((e-8 (vector-ref arg-5 5))) (if (null? arg-6) 0 (let ((e-29 (car arg-6))) (let ((e-30 (cdr arg-6))) (case (vector-ref e-29 0) ((1) (let ((e-32 (vector-ref e-29 2))) (let ((e-33 (vector-ref e-29 3))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-32))) (cond ((equal? sc4 1) (let ((sc5 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 e-33))) (cond ((equal? sc5 1) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs arg-3 arg-4 (vector 1 e-4 e-5 e-6 e-7 e-8) e-30)) (else 0)))) (else 0))))))(else 0))))))))))) ((3) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (if (null? arg-6) 0 (let ((e-37 (car arg-6))) (let ((e-38 (cdr arg-6))) (case (vector-ref e-37 0) ((3) (let ((e-40 (vector-ref e-37 2))) (let ((sc4 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-10 e-40))) (cond ((equal? sc4 1) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs arg-3 arg-4 (vector 3 e-9 e-10) e-38)) (else 0)))))(else 0)))))))) ((4) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (if (null? arg-6) 0 (let ((e-42 (car arg-6))) (let ((e-43 (cdr arg-6))) (case (vector-ref e-42 0) ((4) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs arg-3 arg-4 (vector 4 e-11 e-12 e-13 e-14) e-43))(else 0)))))))))) ((5) (let ((e-15 (vector-ref arg-5 1))) (let ((e-16 (vector-ref arg-5 2))) (let ((e-17 (vector-ref arg-5 3))) (let ((e-18 (vector-ref arg-5 4))) (if (null? arg-6) 0 (let ((e-49 (car arg-6))) (let ((e-50 (cdr arg-6))) (case (vector-ref e-49 0) ((5) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs arg-3 arg-4 (vector 5 e-15 e-16 e-17 e-18) e-50))(else 0)))))))))) ((6) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (if (null? arg-6) 0 (let ((e-56 (car arg-6))) (let ((e-57 (cdr arg-6))) (case (vector-ref e-56 0) ((6) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs arg-3 arg-4 (vector 6 e-19 e-20) e-57))(else 0))))))))(else 0)))))
(define CoreC-45CaseC-45CaseBuilder-samePat (lambda (arg-3) (if (null? arg-3) 1 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45CaseC-45CaseBuilder-n--20481-14101-u--samePatAs e-2 e-3 (CoreC-45CaseC-45CaseBuilder-n--20481-14100-u--dropAs e-2 e-3 (CoreC-45CaseC-45CaseBuilder-getFirstPat e-2)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--20481-14100-u--dropAs e-2 e-3 (CoreC-45CaseC-45CaseBuilder-getFirstPat eta-0))) e-3)))))))
(define CoreC-45CaseC-45CaseBuilder-tail (lambda (arg-3) (let ((e-4 (cdr arg-3))) e-4)))
(define CoreC-45CaseC-45CaseBuilder-pickNextViable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-2) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-samePat arg-8))) (cond ((equal? sc1 1) (vector 1 (cons arg-0 0))) (else (let ((act-1 (CoreC-45CaseC-45CaseBuilder-getScore arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-5 0) ((1) (vector 1 (cons arg-0 0))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 arg-5 arg-7 e-6) clam-1))))))) eff-0) clam-0)))))))) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (CoreC-45CaseC-45CaseBuilder-samePat arg-8))) (cond ((equal? sc1 1) (vector 1 (cons arg-0 0))) (else (let ((act-1 (CoreC-45CaseC-45CaseBuilder-getScore arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (case (vector-ref e-5 0) ((1) (vector 1 (cons arg-0 0)))(else (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-pickNextViable e-2 arg-1 e-3 arg-3 arg-4 arg-5 arg-6 arg-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-tail eta-0)) arg-8)) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons e-7 (+ e-4 1)))))))) eff-0) clam-3)))))))))) eff-0) clam-0))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-dropPat (lambda (arg-3 arg-5) (cond ((equal? arg-3 0) (let ((e-5 (cdr arg-5))) e-5))(else (let ((e-0 (- arg-3 1))) (let ((e-9 (car arg-5))) (let ((e-10 (cdr arg-5))) (cons e-9 (CoreC-45CaseC-45CaseBuilder-dropPat e-0 e-10)))))))))
(define CoreC-45CaseC-45CaseBuilder-getPat (lambda (arg-3 arg-5) (cond ((equal? arg-3 0) (let ((e-4 (car arg-5))) e-4))(else (let ((e-0 (- arg-3 1))) (let ((e-10 (cdr arg-5))) (CoreC-45CaseC-45CaseBuilder-getPat e-0 e-10)))))))
(define CoreC-45CaseC-45CaseBuilder-moveFirst (lambda (arg-3 arg-5) (cons (CoreC-45CaseC-45CaseBuilder-getPat arg-3 arg-5) (CoreC-45CaseC-45CaseBuilder-dropPat arg-3 arg-5))))
(define CoreC-45CaseC-45CaseBuilder-shuffleVars (lambda (arg-3 arg-5) (cond ((equal? arg-3 0) arg-5)(else (let ((e-2 (vector-ref arg-5 0))) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (vector e-2 (CoreC-45CaseC-45CaseBuilder-moveFirst arg-3 e-3) e-4 e-5)))))))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (string-append "Known " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-1) (string-append " " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-2))))))) ((1) (let ((e-4 (vector-ref arg-1 1))) (string-append "Stuck " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-4)))) (else "Unknown"))))
(define CoreC-45CaseC-45CaseBuilder-n--12646-7066-u--showAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) "" (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? e-3) (if (null? arg-5) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-8 2))) e-4)) (string-append " [" (string-append (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-8 3))) e-6)) (string-append "]" (string-append ", " (CoreC-45CaseC-45CaseBuilder-n--12646-7066-u--showAll arg-0 arg-1 arg-2 arg-3 e-3 e-9)))))))))) (let ((e-14 (car arg-5))) (let ((e-15 (cdr arg-5))) (if (null? e-15) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-14 2))) e-4)) (string-append " [" (string-append (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-14 3))) e-6)) "]"))))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-8 2))) e-4)) (string-append " [" (string-append (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-8 3))) e-6)) (string-append "]" (string-append ", " (CoreC-45CaseC-45CaseBuilder-n--12646-7066-u--showAll arg-0 arg-1 arg-2 arg-3 e-3 e-9)))))))))))))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " " (string-append (CoreC-45CaseC-45CaseTree-u--show_Show_Pat (let ((e-4 (vector-ref e-8 2))) e-4)) (string-append " [" (string-append (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40ArgTypeC-32C-36nsC-41 arg-3 (let ((e-6 (vector-ref e-8 3))) e-6)) (string-append "]" (string-append ", " (CoreC-45CaseC-45CaseBuilder-n--12646-7066-u--showAll arg-0 arg-1 arg-2 arg-3 e-3 e-9))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2) (string-append "[" (string-append (CoreC-45CaseC-45CaseBuilder-n--12646-7066-u--showAll arg-0 arg-1 arg-2 arg-0 arg-1 arg-2) "]"))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2) (let ((e-3 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 3))) (string-append (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-0 arg-1 e-3) (string-append " => " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (let ((e-6 (vector-ref arg-3 4))) (let ((e-7 (vector-ref arg-3 5))) (string-append (DataC-45String-fastUnlines (cons "CON" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (string-append "  " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-4 e-3 eta-0))) e-6))) (string-append "\xa;, " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 e-5 e-7))))))))) ((1) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (string-append (DataC-45String-fastUnlines (cons "VAR" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (string-append "  " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-9 e-8 eta-0))) e-11))) (string-append "\xa;, " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 e-10 e-12)))))))))(else "NONE"))))
(define CoreC-45CaseC-45CaseBuilder-case--match-15388 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((u--prioritizedClauses (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-shuffleVars e-3 eta-0)) arg-4))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-pickNextViable e-2 arg-0 (CoreC-45TTC-45Var-dropIsVar (cons arg-2 arg-1) e-3) arg-9 arg-8 arg-7 arg-5 arg-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-getNPs eta-1)) u--prioritizedClauses)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.pick" 25 (lambda () (string-append "Picked " (string-append (CoreC-45Name-u--show_Show_Name e-6) " as the next split"))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((u--clausesC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-shuffleVars e-4 eta-1)) u--prioritizedClauses))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.clauses" 25 (lambda () (DataC-45String-fastUnlines (cons "Using clauses:" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (string-append "  " (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-0 (cons e-6 (CoreC-45TTC-45Var-dropIsVar (cons e-2 (CoreC-45TTC-45Var-dropIsVar (cons arg-2 arg-1) e-3)) e-4)) eta-1))) u--clausesC-39)))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((u--ps (CoreC-45CaseC-45CaseBuilder-partition e-6 (CoreC-45TTC-45Var-dropIsVar (cons e-2 (CoreC-45TTC-45Var-dropIsVar (cons arg-2 arg-1) e-3)) e-4) arg-0 arg-5 u--clausesC-39))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.partition" 25 (lambda () (string-append "Got Partition:\xa;" (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40PartitionsC-32C-36psC-41 u--clausesC-39 u--ps))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 ((CoreC-45CaseC-45CaseBuilder-mixture e-6 arg-0 (CoreC-45TTC-45Var-dropIsVar (cons e-2 (CoreC-45TTC-45Var-dropIsVar (cons arg-2 arg-1) e-3)) e-4) arg-9 arg-8 u--clausesC-39 arg-7 arg-6 arg-5 u--ps arg-3) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-10) (let ((act-6 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.intermediate" 25 (lambda () "match: No clauses") clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (vector 1 (vector 2 "No clauses"))))) (let ((e-11 (unbox e-10))) (let ((act-6 (CoreC-45ContextC-45Log-log arg-8 "compile.casetree.intermediate" 25 (lambda () (string-append "match: new case tree " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 arg-0 e-11))) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (vector 1 e-11))))))))) eff-0) clam-0))))))))))))))))))))) eff-0) eta-0)))))))))))
(define CoreC-45CaseC-45CaseBuilder-match (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-1) (if (null? arg-7) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (vector 2 "No patterns")))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-8) (let ((e-6 (car arg-7))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (lambda (clam-0) (case (vector-ref e-13 0) ((10) (let ((e-17 (vector-ref e-13 2))) (case (vector-ref e-17 0) ((1) (vector 1 (vector 3 )))(else (vector 1 (vector 1 e-12 e-13))))))(else (vector 1 (vector 1 e-12 e-13)))))))))) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((u--nps (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-getNPs eta-0)) arg-7))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getSession arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-case--match-15388 arg-0 e-2 e-1 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 u--nps e-5 (CoreC-45CaseC-45CaseBuilder-nextIdxByScore e-1 e-2 (let ((e-24 (vector-ref e-5 24))) e-24) arg-6 u--nps)))) eff-0) eta-0))))))))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40ArgTypeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-2) ext-0)))) ((1) (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO csegen-2809 (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (else (vector 1 (vector 2 ))))))
(define CoreC-45Context-u--full_HasNames_Pat (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 csegen-1278 (lambda (eta-2) (vector 1 e-0)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 e-1 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-2 eta-0)) ext-0))))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((e-6 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 csegen-1281 (lambda (eta-4) (vector 1 e-3)) eta-3)) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_Name arg-0 e-4 eta-3)) eta-2)) (lambda (eta-2) (vector 1 e-5)) eta-1)) (lambda (eta-1) (vector 1 e-6)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 arg-2 eta-0))) e-7 '()) ext-0))))))) ((2) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-1284 (lambda (eta-3) (vector 1 e-8)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-9 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-10)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 arg-2 eta-0))) e-11 '()) ext-0)))))) ((3) (vector 1 arg-1)) ((4) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-1287 (lambda (eta-3) (vector 1 e-14)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 e-15 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-16 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-17 eta-0)) ext-0)))))) ((5) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-1290 (lambda (eta-3) (vector 1 e-18)) eta-2)) (lambda (eta-2) (vector 1 e-19)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-20 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Pat arg-0 e-21 eta-0)) ext-0)))))) ((6) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-22 e-5)))))) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_Name arg-0 e-23 eta-0)) ext-0)))) (else (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-24 e-5)))))) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-25) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Pat arg-2 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40ArgTypeC-32C-36varsC-41 arg-2 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector e-2 e-3 e-5 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 csegen-2815 (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 arg-2 e-4 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-5 eta-0)) ext-0))))))
(define CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-2812 (CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-u--full_HasNames_Name arg-2 eta-3 eta-4))) e-2 '()) eta-2)) (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-3 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-4)) eta-0)) (CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-2 e-5) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-n--12820-7230-u--prettyAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-8 (car arg-5))) (let ((e-9 (cdr arg-5))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (CoreC-45CaseC-45CaseTree-u--pretty_Pretty_IdrisSyntax_Pat (let ((e-4 (vector-ref e-8 2))) e-4))))) (CoreC-45CaseC-45CaseBuilder-n--12820-7230-u--prettyAll arg-0 arg-1 arg-2 arg-3 e-3 e-9)))))))))
(define CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_IdrisSyntax_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (CoreC-45CaseC-45CaseBuilder-n--12820-7230-u--prettyAll arg-0 arg-1 arg-2 arg-0 arg-1 arg-2))))
(define CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_IdrisSyntax_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2) (let ((e-3 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_IdrisSyntax_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-0 arg-1 e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-fatArrow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-5)))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40ArgTypeC-32C-36varsC-41 (lambda (arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 0 e-1 e-5)))))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-2) ext-0)))) ((1) (let ((e-4 (vector-ref arg-2 1))) (PreludeC-45IO-u--map_Functor_IO csegen-2809 (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-4) ext-0))) (else (vector 1 (vector 2 ))))))
(define CoreC-45Context-u--resolved_HasNames_Pat (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 csegen-1278 (lambda (eta-2) (vector 1 e-0)) eta-1)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-1) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-2 eta-0)) ext-0))))) ((1) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((e-6 (vector-ref arg-1 4))) (let ((e-7 (vector-ref arg-1 5))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 csegen-1281 (lambda (eta-4) (vector 1 e-3)) eta-3)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-4) eta-2)) (lambda (eta-2) (vector 1 e-5)) eta-1)) (lambda (eta-1) (vector 1 e-6)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 arg-2 eta-0))) e-7 '()) ext-0))))))) ((2) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (let ((e-11 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-1284 (lambda (eta-3) (vector 1 e-8)) eta-2)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-9) eta-1)) (lambda (eta-1) (vector 1 e-10)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (arg-2) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 arg-2 eta-0))) e-11 '()) ext-0)))))) ((3) (vector 1 arg-1)) ((4) (let ((e-14 (vector-ref arg-1 1))) (let ((e-15 (vector-ref arg-1 2))) (let ((e-16 (vector-ref arg-1 3))) (let ((e-17 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-1287 (lambda (eta-3) (vector 1 e-14)) eta-2)) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-15) eta-1)) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-16 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-17 eta-0)) ext-0)))))) ((5) (let ((e-18 (vector-ref arg-1 1))) (let ((e-19 (vector-ref arg-1 2))) (let ((e-20 (vector-ref arg-1 3))) (let ((e-21 (vector-ref arg-1 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-1290 (lambda (eta-3) (vector 1 e-18)) eta-2)) (lambda (eta-2) (vector 1 e-19)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-20 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--resolved_HasNames_Pat arg-0 e-21 eta-0)) ext-0)))))) ((6) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 6 e-22 e-5)))))) (CoreC-45Context-u--resolved_HasNames_Name arg-0 e-23) ext-0)))) (else (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 7 e-24 e-5)))))) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-0 e-25) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_Pat arg-2 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40ArgTypeC-32C-36varsC-41 arg-2 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector e-2 e-3 e-5 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-4 (car arg-3))) (let ((e-5 (cdr arg-3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 csegen-2815 (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatInfoC-32C-36nC-41C-32C-36varsC-41 arg-2 e-4 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-5 eta-0)) ext-0))))))
(define CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-2 arg-3 ext-0) (let ((e-2 (vector-ref arg-3 0))) (let ((e-3 (vector-ref arg-3 1))) (let ((e-4 (vector-ref arg-3 2))) (let ((e-5 (vector-ref arg-3 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 csegen-2812 (CoreC-45Core-traverseC-39 (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_Name arg-2 eta-3)) e-2 '()) eta-2)) (lambda (eta-2) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-2 e-3 eta-2)) eta-1)) (lambda (eta-1) (vector 1 e-4)) eta-0)) (CoreC-45Context-u--resolved_HasNames_C-40TermC-32C-36varsC-41 arg-2 e-5) ext-0)))))))
(define CoreC-45CaseC-45CaseBuilder-u--showPrec_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-0 arg-1 arg-3)))
(define CoreC-45CaseC-45CaseBuilder-n--23440-16790-u--mkNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-8) (cond ((equal? arg-10 0) (lambda (eta-0) (vector 1 '())))(else (blodwen-error-quit "Nat case not covered"))) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-8 (car arg-9))) (let ((e-9 (cdr arg-9))) (cond ((equal? arg-10 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-16 (- arg-10 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (if (null? arg-11) (vector 1 (cons '() (vector 2 ))) (let ((e-4 (unbox arg-11))) (case (vector-ref e-4 0) ((0) (let ((e-12 (vector-ref e-4 1))) (let ((e-10 (vector-ref e-4 3))) (let ((e-7 (vector-ref e-4 4))) (case (vector-ref e-10 0) ((2) (let ((e-15 (vector-ref e-10 2))) (let ((e-13 (vector-ref e-10 4))) (let ((act-3 (((e-7 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-12 (vector 0 ) e-2))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-7 '() e-6 '() e-13 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-19 (vector-ref act-4 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (box e-18) (vector 0 e-15 e-19)))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))(else (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 '() e-6 '() e-4 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons '() (vector 1 e-13)))))) eff-0) eta-2)))))))))))(else (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-7 '() e-6 '() e-4 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons '() (vector 1 e-7)))))) eff-0) eta-2))))))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45CaseC-45CaseBuilder-n--23440-16790-u--mkNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3 e-9 e-16 (Builtin-fst e-7)) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (vector 0 e-2 e-8 (Builtin-snd e-7)) (CoreC-45CaseC-45CaseBuilder-weaken e-2 e-3 e-10)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))))
(define CoreC-45CaseC-45CaseBuilder-mkPatClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 43 arg-1 arg-2 (vector 0 )) eta-0))) (lambda () (lambda (u--eq) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45CaseC-45CaseBuilder-n--23440-16790-u--mkNames e-2 e-3 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-3 e-2 u--eq (box e-6)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 20 (lambda () (string-append "Make pat clause for names " (string-append (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40NamedPatsC-32C-36varsC-41C-32C-36todoC-41 arg-3 arg-3 e-7) (string-append " in LHS " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1258) e-2))))) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (vector 1 (vector '() e-7 arg-5 (let ((sc5 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc5))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf arg-3)) e-3))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (LibrariesC-45DataC-45ListC-45LengthMatch-checkLengthMatch arg-3 e-2))))))
(define CoreC-45CaseC-45CaseBuilder-n--23868-17232-u--mkPatClausesFrom (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (if (null? arg-10) (vector 1 '()) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPatClause arg-7 arg-6 arg-5 arg-9 arg-3 arg-8 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-n--23868-17232-u--mkPatClausesFrom arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (bs+ arg-8 1 63) arg-9 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45CaseC-45CaseBuilder-case--patCompile-17358 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((act-1 (CoreC-45CaseC-45CaseBuilder-n--23868-17232-u--mkPatClausesFrom arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 0 e-2 (cons arg-0 arg-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-unverifiedLogC arg-7 "compile.casetree" 5 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-7 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-4) (CoreC-45CaseC-45CaseBuilder-u--full_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-7719 arg-7722 eta-4)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-4) (CoreC-45CaseC-45CaseBuilder-u--resolved_HasNames_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 arg-7729 arg-7732 eta-4))))) eta-2 eta-3))) e-5 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Pattern clauses:\xa;" (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (CoreC-45CaseC-45CaseBuilder-u--pretty_Pretty_IdrisSyntax_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-2 e-2 eta-3)) e-6))))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-7 "compile.casetree" 10 (lambda () (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45CaseC-45CaseBuilder-u--show_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-2 e-2 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45CaseC-45CaseBuilder-u--showPrec_Show_C-40C-40PatClauseC-32C-36varsC-41C-32C-36todoC-41 e-2 e-2 u--d u--x)))) e-5)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 ((CoreC-45Core-newRef (vector "Core.Case.CaseBuilder.PName" ) 0) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45CaseC-45CaseBuilder-match e-2 e-2 e-8 arg-7 arg-6 arg-5 arg-4 e-5 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (CoreC-45CaseC-45CaseTree-u--weakenNs_Weaken_CaseTree e-3 eta-2)) arg-2)) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-2 e-9))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) eff-0) ext-0)))))))))
(define CoreC-45CaseC-45CaseBuilder-patCompile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (vector 1 (cons '() (vector 2 "No definition"))))) (lambda () (lambda (u--e) (lambda (eta-0) (vector 1 (cons '() u--e))))) arg-6) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-case--patCompile-17358 e-2 e-3 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 (CoreC-45CaseC-45CaseBuilder-n--23868-17231-u--getNames e-2 e-3 arg-6 arg-4 arg-3 arg-2 arg-1 arg-0 0 (Builtin-fst e-2)) eta-0)))))))
(define CoreC-45CaseC-45CaseTree-isPConst (lambda (arg-0) (case (vector-ref arg-0 0) ((3) (let ((e-1 (vector-ref arg-0 2))) (box e-1)))(else '()))))
(define CoreC-45CaseC-45CaseBuilder-case--mkPat-16530 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((4) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (lambda (clam-0) (case (vector-ref e-6 0) ((0) (case (vector-ref e-3 0) ((10) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-3 arg-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() e-2 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-5 arg-4 e-8 e-11))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-3 arg-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-10 arg-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 arg-6 arg-4 e-8 e-9))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-3 arg-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-10 arg-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 arg-6 arg-4 e-8 e-9))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-3 arg-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-10 arg-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 arg-6 arg-4 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-3 arg-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-9 '() arg-10 arg-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 arg-6 arg-4 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))
(define CoreC-45CaseC-45CaseBuilder-mkPat (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-1) (case (vector-ref arg-3 0) ((1) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (case (vector-ref e-46 0) ((0) (lambda (eta-0) (vector 1 (vector 6 e-45 e-47))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (clam-0) (case (vector-ref e-2 0) ((2) (let ((e-29 (vector-ref e-2 1))) (let ((e-30 (vector-ref e-2 2))) (vector 1 (vector 1 e-1 e-3 e-29 e-30 arg-1))))) ((3) (let ((e-32 (vector-ref e-2 2))) (vector 1 (vector 2 e-1 e-3 e-32 arg-1)))) ((1) (let ((act-1 (CoreC-45Context-getPrimitiveNames arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalisePrims arg-0 '() (lambda (eta-1) 1) (lambda (eta-1) (CoreC-45CaseC-45CaseTree-isPConst eta-1)) 1 e-5 e-3 arg-1 arg-2 '() eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Unmatchable function: " (CoreC-45Name-u--show_Show_Name e-3))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))) (let ((e-4 (unbox e-6))) (let ((sc7 (CoreC-45TTC-45Term-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 e-4 arg-2))) (cond ((equal? sc7 1) (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-4 e-4)) (else (lambda (eta-1) (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))))) ((3) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (case (vector-ref e-7 0) ((2) (let ((e-34 (vector-ref e-7 1))) (let ((e-35 (vector-ref e-7 2))) (let ((e-36 (vector-ref e-7 3))) (let ((e-37 (vector-ref e-7 4))) (CoreC-45CaseC-45CaseBuilder-case--mkPat-16530 e-34 e-35 e-36 e-37 e-6 e-8 e-5 arg-2 arg-1 arg-0 (CoreC-45TTC-45TermC-45Subst-subst (vector 10 e-5 (vector 0 )) e-8)))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2))))))))))))) ((4) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-12 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 (cons e-5 arg-1) arg-2 e-11))) eff-0) eta-0))))))))) ((5) (let ((e-14 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 3))) (let ((e-17 (vector-ref arg-3 4))) (case (vector-ref e-16 0) ((1) (let ((e-40 (vector-ref e-16 2))) (let ((e-41 (vector-ref e-16 3))) (case (vector-ref e-40 0) ((0) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-17 e-17) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-14 e-41 e-5))))) eff-0) eta-0)))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))) ((7) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-22) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((9) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (lambda (clam-1) (case (vector-ref e-25 0) ((13) (let ((e-42 (vector-ref e-25 1))) (vector 1 (vector 2 e-24 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-42))) 0 '()))))(else (vector 1 (vector 3 e-24 e-25)))))))) ((11) (let ((e-27 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 2 e-27 (vector 1 (vector 0 "Type")) 0 '())))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2))))))))))))))(else (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (clam-2) (case (vector-ref e-2 0) ((2) (let ((e-29 (vector-ref e-2 1))) (let ((e-30 (vector-ref e-2 2))) (vector 1 (vector 1 e-1 e-3 e-29 e-30 arg-1))))) ((3) (let ((e-32 (vector-ref e-2 2))) (vector 1 (vector 2 e-1 e-3 e-32 arg-1)))) ((1) (let ((act-1 (CoreC-45Context-getPrimitiveNames arg-0 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalisePrims arg-0 '() (lambda (eta-1) 1) (lambda (eta-1) (CoreC-45CaseC-45CaseTree-isPConst eta-1)) 1 e-5 e-3 arg-1 arg-2 '() eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Unmatchable function: " (CoreC-45Name-u--show_Show_Name e-3))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))) (let ((e-4 (unbox e-6))) (let ((sc6 (CoreC-45TTC-45Term-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 e-4 arg-2))) (cond ((equal? sc6 1) (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-4 e-4)) (else (lambda (eta-1) (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))))) ((3) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (case (vector-ref e-7 0) ((2) (let ((e-34 (vector-ref e-7 1))) (let ((e-35 (vector-ref e-7 2))) (let ((e-36 (vector-ref e-7 3))) (let ((e-37 (vector-ref e-7 4))) (CoreC-45CaseC-45CaseBuilder-case--mkPat-16530 e-34 e-35 e-36 e-37 e-6 e-8 e-5 arg-2 arg-1 arg-0 (CoreC-45TTC-45TermC-45Subst-subst (vector 10 e-5 (vector 0 )) e-8)))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2))))))))))))) ((4) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-12 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 (cons e-5 arg-1) arg-2 e-11))) eff-0) eta-0))))))))) ((5) (let ((e-14 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 3))) (let ((e-17 (vector-ref arg-3 4))) (case (vector-ref e-16 0) ((1) (let ((e-40 (vector-ref e-16 2))) (let ((e-41 (vector-ref e-16 3))) (case (vector-ref e-40 0) ((0) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-17 e-17) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-14 e-41 e-5))))) eff-0) eta-0)))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))) ((7) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-22) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((9) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (lambda (clam-3) (case (vector-ref e-25 0) ((13) (let ((e-42 (vector-ref e-25 1))) (vector 1 (vector 2 e-24 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-42))) 0 '()))))(else (vector 1 (vector 3 e-24 e-25)))))))) ((11) (let ((e-27 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 2 e-27 (vector 1 (vector 0 "Type")) 0 '())))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (clam-4) (case (vector-ref e-2 0) ((2) (let ((e-29 (vector-ref e-2 1))) (let ((e-30 (vector-ref e-2 2))) (vector 1 (vector 1 e-1 e-3 e-29 e-30 arg-1))))) ((3) (let ((e-32 (vector-ref e-2 2))) (vector 1 (vector 2 e-1 e-3 e-32 arg-1)))) ((1) (let ((act-1 (CoreC-45Context-getPrimitiveNames arg-0 clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normalisePrims arg-0 '() (lambda (eta-1) 1) (lambda (eta-1) (CoreC-45CaseC-45CaseTree-isPConst eta-1)) 1 e-5 e-3 arg-1 arg-2 '() eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Unmatchable function: " (CoreC-45Name-u--show_Show_Name e-3))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))) (let ((e-4 (unbox e-6))) (let ((sc6 (CoreC-45TTC-45Term-u--C-47C-61_Eq_C-40TermC-32C-36varsC-41 e-4 arg-2))) (cond ((equal? sc6 1) (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-4 e-4)) (else (lambda (eta-1) (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))) eff-0) eta-0)))))))) eff-0) clam-4))))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))))) ((3) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (case (vector-ref e-7 0) ((2) (let ((e-34 (vector-ref e-7 1))) (let ((e-35 (vector-ref e-7 2))) (let ((e-36 (vector-ref e-7 3))) (let ((e-37 (vector-ref e-7 4))) (CoreC-45CaseC-45CaseBuilder-case--mkPat-16530 e-34 e-35 e-36 e-37 e-6 e-8 e-5 arg-2 arg-1 arg-0 (CoreC-45TTC-45TermC-45Subst-subst (vector 10 e-5 (vector 0 )) e-8)))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2))))))))))))) ((4) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-12 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 (cons e-5 arg-1) arg-2 e-11))) eff-0) eta-0))))))))) ((5) (let ((e-14 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 3))) (let ((e-17 (vector-ref arg-3 4))) (case (vector-ref e-16 0) ((1) (let ((e-40 (vector-ref e-16 2))) (let ((e-41 (vector-ref e-16 3))) (case (vector-ref e-40 0) ((0) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() e-17 e-17) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-14 e-41 e-5))))) eff-0) eta-0)))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))(else (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-17))))))) ((7) (let ((e-19 (vector-ref arg-3 1))) (let ((e-20 (vector-ref arg-3 2))) (let ((e-21 (vector-ref arg-3 3))) (let ((e-22 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-2 e-22) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-19 e-20 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((9) (let ((e-24 (vector-ref arg-3 1))) (let ((e-25 (vector-ref arg-3 2))) (lambda (clam-5) (case (vector-ref e-25 0) ((13) (let ((e-42 (vector-ref e-25 1))) (vector 1 (vector 2 e-24 (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-42))) 0 '()))))(else (vector 1 (vector 3 e-24 e-25)))))))) ((11) (let ((e-27 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (vector 2 e-27 (vector 1 (vector 0 "Type")) 0 '())))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree" 10 (lambda () (string-append "Catchall: marking " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-3) " as unmatchable"))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 7 (CoreC-45TTC-45Term-getLoc arg-2) arg-2)))))))))))
(define CoreC-45CaseC-45CaseBuilder-argToPat (lambda (arg-0 arg-1) (CoreC-45CaseC-45CaseBuilder-mkPat arg-0 '() arg-1 arg-1)))
(define CoreC-45CaseC-45CaseBuilder-toPatClause (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (CoreC-45TTC-45Term-getFnArgs e-2))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-8 (vector-ref e-5 1))) (let ((e-6 (vector-ref e-5 2))) (let ((e-7 (vector-ref e-5 3))) (case (vector-ref e-6 0) ((1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-getPosition arg-2 (let ((e-0 (vector-ref e-9 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-12 (car e-10))) (let ((act-3 ((CoreC-45Context-getPosition e-7 (let ((e-0 (vector-ref e-9 0))) e-0)) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-15 (car e-13))) (let ((sc9 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-12 e-15))) (cond ((equal? sc9 1) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45CaseC-45CaseBuilder-argToPat arg-0 eta-1)) e-4 '()) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-16 (vector-ref act-4 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-16 e-3))))) eff-0) clam-2)))))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-8 (string-append "Wrong function name in pattern LHS " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-84 (cons arg-2 e-7)))) clam-2)))))))) eff-0) clam-1))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "Not a function name in pattern LHS") clam-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "Not a function name in pattern LHS") clam-0)))))))))))
(define CoreC-45CaseC-45CaseBuilder-simpleCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "compile.casetree" 5 (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (vector 1 csegen-2816)) (lambda (eta-2) (CoreC-45Context-toFullNames arg-0 csegen-68 e-2 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-toFullNames arg-0 csegen-68 e-3 eta-1)) clam-0))))) arg-6 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "simpleCase: Clauses:\xa;" (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45Basics-flip csegen-2819 e-5 (lambda (u--lrhs) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1268 (Builtin-fst u--lrhs)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "=") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1268 (Builtin-snd u--lrhs)))))))))))))) eff-0) eta-0)))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-toPatClause arg-0 arg-1 arg-3 eta-0)) arg-6 '()) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-0 (CoreC-45CaseC-45CaseBuilder-patCompile arg-0 arg-1 arg-3 arg-2 arg-4 e-6 arg-5))) eff-0) eta-0))))))) eff-0) ext-0))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--25365-18545-u--getArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45CaseC-45CaseBuilder-n--25365-18545-u--getArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector 2 "arg" arg-5) e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 '())))))))(else (vector 1 '()))))))
(define CoreC-45CaseC-45CaseBuilder-n--25365-18660-u--getUnreachable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-223 arg-6 arg-7))) (cond ((equal? sc1 1) (CoreC-45CaseC-45CaseBuilder-n--25365-18660-u--getUnreachable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) arg-7 e-3)) (else (cons e-2 (CoreC-45CaseC-45CaseBuilder-n--25365-18660-u--getUnreachable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) arg-7 e-3))))))))))
(define CoreC-45CaseC-45CaseBuilder-n--25365-18661-u--labelPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (cons (cons (string-append "pat" (string-append (PreludeC-45Show-u--show_Show_Int arg-7) ":")) e-2) (CoreC-45CaseC-45CaseBuilder-n--25365-18661-u--labelPat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-7 1 63) e-3)))))))
(define CoreC-45Env-n--7236-4813-u--mkSubstEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (if (null? arg-7) (cons 0 '()) (let ((e-5 (cdr arg-7))) (let ((sc1 (CoreC-45Env-n--7236-4813-u--mkSubstEnv arg-1 arg-2 arg-3 arg-4 (bs+ arg-6 1 63) e-5))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (LibrariesC-45DataC-45ListC-45SizeOf-suc e-2) (cons (vector 1 arg-4 (vector 0 ) (vector 2 arg-3 arg-6)) e-3)))))))))
(define CoreC-45Env-close (lambda (arg-1 arg-2 arg-3 arg-4) (let ((sc0 (CoreC-45Env-n--7236-4813-u--mkSubstEnv arg-4 arg-3 arg-2 arg-1 0 arg-3))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (CoreC-45TTC-45TermC-45Subst-substs e-2 e-3 arg-4))))))
(define CoreC-45CaseC-45CaseBuilder-n--25365-18662-u--toClosed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-5 (vector-ref e-3 1))) (let ((e-6 (vector-ref e-3 2))) (let ((e-7 (vector-ref e-3 3))) (cons (CoreC-45Env-close arg-4 e-2 e-5 e-6) (CoreC-45Env-close arg-4 e-2 e-5 e-7)))))))))
(define CoreC-45CaseC-45CaseBuilder-getPMDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree.getpmdef" 20 (lambda () "getPMDef: No clauses!") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-6 '() arg-4) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45CaseC-45CaseBuilder-n--25365-18545-u--getArgs arg-4 arg-3 arg-2 arg-1 arg-0 0 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-8 (cons (vector 2 "No clauses") '())))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cs (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseBuilder-n--25365-18662-u--toClosed arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 eta-0)) (CoreC-45CaseC-45CaseBuilder-n--25365-18661-u--labelPat arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 0 arg-5)))) (lambda (eta-0) (let ((act-2 (CoreC-45CaseC-45CaseBuilder-simpleCase arg-0 arg-1 arg-2 arg-3 arg-4 '() u--cs eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 (let ((act-3 (CoreC-45Context-toFullNames arg-0 csegen-2622 e-3 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "compile.casetree.getpmdef" 20 (lambda (eta-2) (vector 1 (string-append "Compiled to: " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-2 e-7)))) eta-1)))) eff-0) clam-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((u--reached (CoreC-45CaseC-45CaseBuilder-findReached e-3))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "compile.casetree.clauses" 25 (lambda () (string-append "Reached clauses: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 u--reached))) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 ((CoreC-45CaseC-45CaseBuilder-findExtraDefaults arg-0 e-2 arg-1 e-5 e-3) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--unreachable (CoreC-45CaseC-45CaseBuilder-n--25365-18660-u--getUnreachable arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 0 (DataC-45List-C-92C-92 csegen-223 u--reached e-9) arg-5))) (lambda (eta-1) (vector 1 (cons e-2 (cons e-3 u--unreachable))))))) eff-0) clam-1))))))))))))))))) eff-0) eta-0))))))))) eff-0) ext-0))))))))
(define CoreC-45CaseC-45CaseTree-measureAlts (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 4))) (+ (CoreC-45CaseC-45CaseTree-measure e-4) 1))) ((1) (let ((e-8 (vector-ref arg-1 3))) (+ (CoreC-45CaseC-45CaseTree-measure e-8) 1))) ((2) (let ((e-11 (vector-ref arg-1 2))) (+ (CoreC-45CaseC-45CaseTree-measure e-11) 1))) (else (let ((e-13 (vector-ref arg-1 1))) (+ (CoreC-45CaseC-45CaseTree-measure e-13) 1))))))
(define CoreC-45CaseC-45CaseTree-measure (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 4))) (PreludeC-45Interfaces-sum csegen-110 csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-measureAlts eta-0)) e-5)))) ((1) 0) ((2) 0) (else 0))))
(define TTImpC-45ProcessDef-with--withC-32blockC-32inC-32nameListEq-14584 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-2) '() (box (vector 0 )))))
(define TTImpC-45ProcessDef-with--nameListEq-14577 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) '() (TTImpC-45ProcessDef-with--withC-32blockC-32inC-32nameListEq-14584 arg-4 arg-3 (TTImpC-45ProcessDef-nameListEq arg-3 arg-4) arg-0))))
(define TTImpC-45ProcessDef-nameListEq (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (box (vector 0 )) '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? arg-1) '() (let ((e-6 (car arg-1))) (let ((e-7 (cdr arg-1))) (TTImpC-45ProcessDef-with--nameListEq-14577 e-2 e-6 (CoreC-45Name-nameEq e-2 e-6) e-3 e-7)))))))))
(define CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyAlt (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 (box e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-1)) (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (let ((u--sc (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyTree (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) e-4))) (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) u--sc)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline u--sc))))))))))) ((1) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((e-8 (vector-ref arg-1 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2728 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (let ((u--sc (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyTree (cons e-6 (cons e-7 arg-0)) e-8))) (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) u--sc)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline u--sc)))))))))))) ((2) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (let ((u--sc (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyTree arg-0 e-11))) (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) u--sc)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline u--sc)))))))))) (else (let ((e-13 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2729 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (let ((u--sc (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyTree arg-0 e-13))) (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) u--sc)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline u--sc))))))))))))
(define CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyTree (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 3))) (let ((e-5 (vector-ref arg-1 4))) (let ((u--ann (case (vector-ref e-4 0) ((10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ""))(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2724 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-4)))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-case_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 4 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-1)) u--ann) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-of_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyAlt arg-0 eta-0)) e-5)))))))))))) ((1) (let ((e-8 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TTC-45Term-u--showPrec_Show_C-40TermC-32C-36varsC-41 arg-0 u--d u--x)))) e-8))) ((2) (let ((e-10 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Error:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-10)))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Impossible")))))
(define CoreC-45TT-u--show_Show_Covering (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "covering") ((1) "not covering all cases") (else (let ((e-1 (vector-ref arg-0 1))) (if (null? e-1) (string-append "not covering due to calls to functions " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))) (let ((e-3 (car e-1))) (let ((e-4 (cdr e-1))) (if (null? e-4) (string-append "not covering due to call to function " (CoreC-45Name-u--show_Show_Name e-3)) (string-append "not covering due to calls to functions " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-1))))))))))))
(define TTImpC-45ProcessDef-n--25543-15211-u--matchAny (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8) (case (vector-ref arg-8 0) ((4) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (vector 4 e-1 (TTImpC-45ProcessDef-n--25543-15211-u--matchAny arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2) (vector 10 e-1 (vector 0 ))))))(else arg-8))))
(define TTImpC-45ProcessDef-n--25543-15212-u--mkCrash (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (CoreC-45TTC-45Term-apply arg-1 (vector 1 arg-1 (vector 1 ) (vector 1 (vector 0 "prim__crash"))) (cons (vector 10 arg-1 (vector 0 )) (cons (vector 9 arg-1 (vector 10 arg-8)) '())))))
(define TTImpC-45ProcessDef-n--25543-15210-u--makeErrorClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (vector arg-7 arg-8 (TTImpC-45ProcessDef-n--25543-15211-u--matchAny arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9) (TTImpC-45ProcessDef-n--25543-15212-u--mkCrash arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (string-append "Unhandled input for " (string-append (CoreC-45Name-u--show_Show_Name arg-0) (string-append " at " (CoreC-45FC-u--show_Show_FC arg-1))))))))
(define TTImpC-45ProcessDef-n--25543-15207-u--addErrorCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (if (null? e-3) (cons (vector e-4 e-5 e-6 e-7) (cons (TTImpC-45ProcessDef-n--25543-15210-u--makeErrorClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-5 e-6) '())) (cons e-2 (TTImpC-45ProcessDef-n--25543-15207-u--addErrorCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))))
(define TTImpC-45ProcessDef-n--25543-15208-u--caseName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((6) 1) ((0) (let ((e-3 (vector-ref arg-7 2))) (TTImpC-45ProcessDef-n--25543-15208-u--caseName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3)))(else 0))))
(define TTImpC-45ProcessDef-n--25543-15209-u--getSpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) '() (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((9) (let ((e-4 (vector-ref e-2 1))) (box e-4)))(else (TTImpC-45ProcessDef-n--25543-15209-u--getSpec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))
(define TTImpC-45ProcessDef-n--25543-15213-u--noInline (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) 1 (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (case (vector-ref e-1 0) ((0) 0) ((1) 0)(else (TTImpC-45ProcessDef-n--25543-15213-u--noInline arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2))))))))
(define TTImpC-45ProcessDef-n--25543-15214-u--toClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector e-2 e-6 e-10 e-11)))))))))
(define TTImpC-45PartialEval-bName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-1 e-5)))))))) eff-0) ext-0)))))))
(define TTImpC-45PartialEval-quoteArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (vector 1 '()) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45PartialEval-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45PartialEval-quoteArgsWithFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (TTImpC-45PartialEval-quoteArgs arg-5 arg-6 arg-0 arg-1 arg-2 arg-3 arg-4 arg-7 arg-8 arg-9 arg-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) arg-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (DataC-45List-u--zip_Zippable_List (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-11) e-5))))) eff-0) ext-0)))))))
(define TTImpC-45PartialEval-quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (case (vector-ref arg-11 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-11 1))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define TTImpC-45PartialEval-quoteBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-11 1))) (let ((e-7 (vector-ref arg-11 2))) (let ((e-8 (vector-ref arg-11 3))) (let ((e-9 (vector-ref arg-11 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-9) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-10))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-6 e-7 e-5 e-10))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((2) (let ((e-11 (vector-ref arg-11 1))) (let ((e-12 (vector-ref arg-11 2))) (let ((e-13 (vector-ref arg-11 3))) (let ((e-14 (vector-ref arg-11 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-11 e-12 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((3) (let ((e-16 (vector-ref arg-11 1))) (let ((e-17 (vector-ref arg-11 2))) (let ((e-18 (vector-ref arg-11 3))) (let ((e-19 (vector-ref arg-11 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-19) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-18 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-16 e-17 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((4) (let ((e-21 (vector-ref arg-11 1))) (let ((e-22 (vector-ref arg-11 2))) (let ((e-23 (vector-ref arg-11 3))) (let ((e-24 (vector-ref arg-11 4))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-23) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-24) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-21 e-22 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) (else (let ((e-26 (vector-ref arg-11 1))) (let ((e-27 (vector-ref arg-11 2))) (let ((e-28 (vector-ref arg-11 3))) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-28) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-26 e-27 e-5))))) eff-0) ext-0))))))))))))
(define TTImpC-45PartialEval-n--16020-7109-u--addLater (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-18 arg-19) (if (null? arg-19) arg-18 (let ((e-3 (cdr arg-19))) (let ((eff-0 (TTImpC-45PartialEval-n--16020-7109-u--addLater arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-18 e-3))) (+ eff-0 1))))))
(define TTImpC-45PartialEval-n--16020-7284-u--findName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-15) (case (vector-ref arg-15 0) ((0) '()) (else (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (case (vector-ref e-2 0) ((2) (let ((e-5 (vector-ref e-2 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int arg-2 e-5))) (cond ((equal? sc2 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-n--16020-7284-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3) csegen-965))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-n--16020-7284-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3) csegen-965)))))))))
(define TTImpC-45PartialEval-quoteHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-2 (vector-ref arg-12 1))) (let ((e-3 (vector-ref arg-12 2))) (let ((eff-0 (TTImpC-45PartialEval-n--16020-7109-u--addLater arg-1 e-3 e-2 arg-11 arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-3 arg-0))) (lambda (eta-0) (vector 1 (vector 0 arg-9 e-2 eff-0))))))) ((1) (let ((e-6 (vector-ref arg-12 1))) (let ((e-7 (vector-ref arg-12 2))) (case (vector-ref e-6 0) ((0) (lambda (clam-0) (case (vector-ref e-7 0) ((2) (let ((e-12 (vector-ref e-7 1))) (let ((e-13 (vector-ref e-7 2))) (let ((sc3 (TTImpC-45PartialEval-n--16020-7284-u--findName arg-0 arg-1 e-13 e-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-10))) (if (null? sc3) (vector 1 (vector 1 arg-9 (vector 0 ) (vector 2 e-12 e-13))) (let ((e-1 (unbox sc3))) (vector 1 (vector 0 arg-9 '() e-1))))))))(else (vector 1 (vector 1 arg-9 e-6 e-7))))))(else (lambda (eta-0) (vector 1 (vector 1 arg-9 e-6 e-7)))))))) (else (let ((e-9 (vector-ref arg-12 1))) (let ((e-10 (vector-ref arg-12 2))) (let ((e-11 (vector-ref arg-12 3))) (lambda (eta-0) (let ((act-1 (TTImpC-45PartialEval-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 e-11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 arg-9 e-9 e-10 e-5))))) eff-0) eta-0)))))))))))))
(define TTImpC-45PartialEval-getStatic (lambda (arg-0) (if (null? arg-0) '() (let ((e-2 (unbox arg-0))) (box e-2)))))
(define TTImpC-45PartialEval-dropSpec (lambda (arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (DataC-45List-lookup csegen-1032 arg-1 arg-2))) (if (null? sc1) (cons e-2 (TTImpC-45PartialEval-dropSpec (+ arg-1 1) arg-2 e-3)) (TTImpC-45PartialEval-dropSpec (+ arg-1 1) arg-2 e-3))))))))
(define TTImpC-45PartialEval-getReducible (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (lambda (eta-0) (vector 1 arg-1)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-1))) (if (null? sc1) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-2 0))) e-0)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (TTImpC-45PartialEval-getReducible e-3 arg-1 arg-2) (let ((e-4 (unbox e-5))) (let ((u--refsC-39 (LibrariesC-45DataC-45NameMap-insert e-2 65536 arg-1))) (let ((u--calls (CoreC-45ContextC-45Context-refersTo e-4))) (TTImpC-45PartialEval-getReducible (PreludeC-45TypesC-45List-tailRecAppend (LibrariesC-45DataC-45NameMap-keys u--calls) e-3) u--refsC-39 arg-2))))))) eff-0) eta-0)))))) (TTImpC-45PartialEval-getReducible e-3 arg-1 arg-2))))))))
(define CoreC-45Context-setAllPublic (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-45 (vector-ref e-0 0))) (let ((e-34 (vector-ref e-0 1))) (let ((e-35 (vector-ref e-0 2))) (let ((e-36 (vector-ref e-0 3))) (let ((e-37 (vector-ref e-0 4))) (let ((e-38 (vector-ref e-0 5))) (let ((e-39 (vector-ref e-0 6))) (let ((e-40 (vector-ref e-0 7))) (let ((e-42 (vector-ref e-0 9))) (let ((e-43 (vector-ref e-0 10))) (let ((e-44 (vector-ref e-0 11))) (vector (vector e-45 e-34 e-35 e-36 e-37 e-38 e-39 e-40 arg-1 e-42 e-43 e-44) e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45PartialEval-specialiseTy (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (DataC-45List-lookup csegen-1032 arg-1 arg-2))) (if (null? sc2) (vector 3 e-1 e-2 (vector 2 e-6 e-7 e-8 e-9) (TTImpC-45PartialEval-specialiseTy (cons e-2 arg-0) (+ arg-1 1) arg-2 e-4)) (let ((e-5 (unbox sc2))) (TTImpC-45PartialEval-specialiseTy arg-0 (+ arg-1 1) arg-2 (CoreC-45TTC-45TermC-45Subst-subst e-5 e-4))))))))))(else arg-3)))))))(else arg-3))))
(define TTImpC-45PartialEval-u--show_Show_C-40ArgModeC-39C-32C-36aC-41 (lambda (arg-1 arg-2) (if (null? arg-2) "Dynamic" (let ((e-1 (unbox arg-2))) (string-append "Static " (let ((e-3 (car arg-1))) (e-3 e-1)))))))
(define TTImpC-45PartialEval-u--showPrec_Show_C-40ArgModeC-39C-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (TTImpC-45PartialEval-u--show_Show_C-40ArgModeC-39C-32C-36aC-41 arg-1 arg-3)))
(define TTImpC-45PartialEval-n--12464-3617-u--getAllRefs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) arg-12 (let ((e-1 (car arg-13))) (let ((e-2 (cdr arg-13))) (if (null? e-1) (TTImpC-45PartialEval-n--12464-3617-u--getAllRefs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-2) (let ((e-6 (unbox e-1))) (CoreC-45TT-addRefs 0 (vector 1 (vector 2 )) (TTImpC-45PartialEval-n--12464-3617-u--getAllRefs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-2) e-6))))))))
(define TTImpC-45PartialEval-n--12464-3618-u--identityFlag (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) (box arg-13) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) arg-13) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45Types-u--C-60_Ord_Nat arg-13 e-6))) (lambda () (PreludeC-45Types-u--map_Functor_Maybe (lambda (clam-0) (if (null? e-7) clam-0 (PreludeC-45Types-prim__integerToNat (- clam-0 1)))) (TTImpC-45PartialEval-n--12464-3618-u--identityFlag arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3 arg-13)))))))))))
(define TTImpC-45PartialEval-n--12464-3619-u--propagateFlags (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) '()) ((4) '()) ((12) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 12 eta-0)) (TTImpC-45PartialEval-n--12464-3618-u--identityFlag arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-3 e-0))))(else (box lcase-0)))) ext-0)))
(define TTImpC-45PartialEval-mkSubsts (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (box '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-mkSubsts (+ arg-1 1) arg-2 e-3 arg-4) (lambda (u--subs) (let ((sc1 (DataC-45List-lookup csegen-1032 arg-1 arg-2))) (if (null? sc1) (box u--subs) (let ((e-4 (unbox sc1))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 3))) (box (cons (cons e-5 e-4) u--subs)))) ((5) (let ((e-9 (vector-ref e-2 3))) (let ((e-10 (vector-ref e-2 4))) (case (vector-ref e-9 0) ((0) (let ((e-21 (vector-ref e-9 3))) (case (vector-ref e-10 0) ((0) (let ((e-27 (vector-ref e-10 3))) (box (cons (cons e-21 e-4) (cons (cons e-27 e-4) u--subs)))))(else (case (vector-ref e-10 0) ((0) (let ((e-15 (vector-ref e-10 3))) (box (cons (cons e-15 e-4) u--subs))))(else '()))))))(else (case (vector-ref e-10 0) ((0) (let ((e-15 (vector-ref e-10 3))) (box (cons (cons e-15 e-4) u--subs))))(else '())))))))(else '()))))))))))))
(define TTImpC-45PartialEval-substLoc (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((sc1 (or (and (= arg-1 e-4) 1) 0))) (cond ((equal? sc1 1) arg-2) (else (vector 0 e-2 e-3 e-4)))))))) ((3) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (vector 3 e-7 e-8 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (eta-0) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 eta-0)) e-9) (TTImpC-45PartialEval-substLoc (cons e-8 arg-0) (+ arg-1 1) (let ((sc1 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) arg-2))) e-10))))))) ((2) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((e-15 (vector-ref arg-3 4))) (vector 2 e-12 e-13 e-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 eta-0)) e-15))))))) ((4) (let ((e-17 (vector-ref arg-3 1))) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (vector 4 e-17 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-18) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-19)))))) ((5) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (let ((e-24 (vector-ref arg-3 4))) (vector 5 e-21 e-22 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-23) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-24))))))) ((6) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (vector 6 e-26 e-27 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-28)))))) ((7) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (vector 7 e-30 e-31 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-32) (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-33))))))) ((8) (let ((e-35 (vector-ref arg-3 1))) (let ((e-36 (vector-ref arg-3 2))) (let ((e-37 (vector-ref arg-3 3))) (vector 8 e-35 e-36 (TTImpC-45PartialEval-substLoc arg-0 arg-1 arg-2 e-37))))))(else arg-3))))
(define TTImpC-45PartialEval-substLocs (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (TTImpC-45PartialEval-substLocs arg-0 e-3 (TTImpC-45PartialEval-substLoc arg-0 e-6 e-7 arg-2)))))))))
(define TTImpC-45PartialEval-case--specPatByVar-2417 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-mkSubsts 0 arg-4 e-3 arg-3) (lambda (u--psubs) (let ((u--lhsC-39 (CoreC-45TTC-45Term-apply (CoreC-45TTC-45Term-getLoc e-2) e-2 e-3))) (box (cons arg-0 (cons arg-1 (cons (TTImpC-45PartialEval-substLocs arg-0 u--psubs u--lhsC-39) (TTImpC-45PartialEval-substLocs arg-0 u--psubs arg-3))))))))))))
(define TTImpC-45PartialEval-specPatByVar (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (TTImpC-45PartialEval-case--specPatByVar-2417 e-2 e-6 e-10 e-11 arg-0 (CoreC-45TTC-45Term-getFnArgs e-10))))))))))
(define TTImpC-45PartialEval-specByVar (lambda (arg-0 arg-1) (if (null? arg-1) (box '()) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-specPatByVar arg-0 e-2) (lambda (u--pC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45PartialEval-specByVar arg-0 e-3) (lambda (u--psC-39) (box (cons u--pC-39 u--psC-39)))))))))))
(define TTImpC-45PartialEval-n--11458-2656-u--mkDynNames (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (if (null? e-2) (TTImpC-45PartialEval-n--11458-2656-u--mkDynNames arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3) (let ((e-7 (cdr e-2))) (if (null? e-7) (cons (string-append "_pe" (PreludeC-45Show-u--show_Show_Int arg-10)) (TTImpC-45PartialEval-n--11458-2656-u--mkDynNames arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (bs+ (blodwen-toSignedInt 1 63) arg-10 63) e-3)) (TTImpC-45PartialEval-n--11458-2656-u--mkDynNames arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3)))))))))
(define TTImpC-45Unelab-unelabNoSugar (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 1 0) '() arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (Builtin-fst e-5))))) eff-0) ext-0)))))))
(define TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-10 0) ((0) (let ((e-13 (vector-ref arg-10 2))) (let ((e-14 (vector-ref arg-10 3))) (let ((e-15 (vector-ref arg-10 4))) (case (vector-ref e-14 0) ((2) (let ((e-19 (vector-ref e-14 3))) (case (vector-ref e-19 0) ((1) (if (null? arg-12) (if (null? arg-12) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-52 (car arg-12))) (let ((e-53 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-55 (car arg-13))) (let ((e-56 (cdr arg-13))) (if (null? e-55) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-60 (cdr e-55))) (if (null? e-60) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (vector 0 arg-8 (vector 1 (vector 0 e-52)))) e-53 e-56))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))))))))) (let ((e-64 (car arg-12))) (let ((e-65 (cdr arg-12))) (if (null? arg-13) (if (null? arg-12) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-52 (car arg-12))) (let ((e-53 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-55 (car arg-13))) (let ((e-56 (cdr arg-13))) (if (null? e-55) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-60 (cdr e-55))) (if (null? e-60) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (vector 0 arg-8 (vector 1 (vector 0 e-52)))) e-53 e-56))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))))))))) (let ((e-67 (car arg-13))) (let ((e-68 (cdr arg-13))) (if (null? e-67) (if (null? arg-12) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-52 (car arg-12))) (let ((e-53 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-55 (car arg-13))) (let ((e-56 (cdr arg-13))) (if (null? e-55) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-60 (cdr e-55))) (if (null? e-60) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (vector 0 arg-8 (vector 1 (vector 0 e-52)))) e-53 e-56))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))))))))) (let ((e-72 (cdr e-67))) (if (null? e-72) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-64)))) e-65 e-68))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (if (null? arg-12) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-52 (car arg-12))) (let ((e-53 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-55 (car arg-13))) (let ((e-56 (cdr arg-13))) (if (null? e-55) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-60 (cdr e-55))) (if (null? e-60) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (vector 0 arg-8 (vector 1 (vector 0 e-52)))) e-53 e-56))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))))))))))))))))))))))(else (if (null? arg-12) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-52 (car arg-12))) (let ((e-53 (cdr arg-12))) (if (null? arg-13) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-55 (car arg-13))) (let ((e-56 (cdr arg-13))) (if (null? e-55) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))) (let ((e-60 (cdr e-55))) (if (null? e-60) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (vector 0 arg-8 (vector 1 (vector 0 e-52)))) e-53 e-56))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (case (vector-ref e-19 0) ((1) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-25 (car arg-13))) (let ((e-26 (cdr arg-13))) (if (null? e-25) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-30 (cdr e-25))) (if (null? e-30) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-32 (unbox e-30))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-32 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 8 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-26))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((0) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-34 (car arg-13))) (let ((e-35 (cdr arg-13))) (if (null? e-34) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-39 (cdr e-34))) (if (null? e-39) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-41 (unbox e-39))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-41 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 10 arg-8 arg-11 e-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-35))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((2) (if (null? arg-13) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-43 (car arg-13))) (let ((e-44 (cdr arg-13))) (if (null? e-43) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-48 (cdr e-43))) (if (null? e-48) (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))) (let ((e-50 (unbox e-48))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (((e-15 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-8 (vector 0 )))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45Unelab-unelabNoSugar '() arg-9 '() e-50 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6 (vector 9 arg-8 arg-11 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-7)) arg-12 e-44))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11))))))))))))))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))))(else (if (null? arg-12) (lambda (eta-0) (vector 1 arg-11)) (let ((e-1 (car arg-12))) (let ((e-2 (cdr arg-12))) (if (null? arg-13) (lambda (eta-0) (vector 1 arg-11)) (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (if (null? e-4) (lambda (eta-0) (vector 1 arg-11)) (let ((e-9 (cdr e-4))) (if (null? e-9) (TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 arg-8 arg-11 (vector 0 arg-8 (vector 1 (vector 0 e-1)))) e-2 e-5) (lambda (eta-0) (vector 1 arg-11)))))))))))))))
(define TTImpC-45TTImpC-45Traversals-mapAltType (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (vector 1 )) (else (let ((e-3 (vector-ref arg-2 1))) (vector 2 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-3)))))))
(define TTImpC-45TTImpC-45Traversals-mapIFieldUpdate (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (vector 0 e-1 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-2))))) (else (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (vector 1 e-4 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-5))))))))
(define TTImpC-45TTImpC-45Traversals-mapImpClause (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 0 e-1 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-2) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-3)))))) ((1) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (let ((e-9 (vector-ref arg-2 5))) (let ((e-10 (vector-ref arg-2 6))) (let ((e-11 (vector-ref arg-2 7))) (vector 1 e-5 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-6) e-7 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-8) e-9 e-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpClause arg-1 eta-0)) e-11)))))))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((e-14 (vector-ref arg-2 2))) (vector 2 e-13 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-14))))))))
(define TTImpC-45TTImpC-45Traversals-mapFnOpt (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (vector 1 )) ((2) (vector 2 )) ((3) (vector 3 )) ((4) (vector 4 )) ((5) (let ((e-6 (vector-ref arg-2 1))) (vector 5 e-6))) ((6) (let ((e-8 (vector-ref arg-2 1))) (vector 6 e-8))) ((7) (vector 7 )) ((8) (let ((e-11 (vector-ref arg-2 1))) (vector 8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 eta-0)) e-11)))) ((9) (let ((e-13 (vector-ref arg-2 1))) (vector 9 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 eta-0)) e-13)))) ((10) (vector 10 )) ((11) (let ((e-16 (vector-ref arg-2 1))) (vector 11 e-16))) ((12) (vector 12 )) (else (let ((e-19 (vector-ref arg-2 1))) (vector 13 e-19))))))
(define TTImpC-45TTImpC-45Traversals-mapImpTy (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (vector e-1 e-2 e-3 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-4))))))))
(define TTImpC-45TTImpC-45Traversals-mapImpData (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (vector 0 e-1 e-2 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 eta-0)) e-3) e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpTy arg-1 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (vector 1 e-7 e-8 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-9)))))))))
(define TTImpC-45TTImpC-45Traversals-mapPiInfo (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (vector 0 )) ((1) (vector 1 )) ((2) (vector 2 )) (else (let ((e-4 (vector-ref arg-2 1))) (vector 3 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-4)))))))
(define TTImpC-45TTImpC-45Traversals-mapIField (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector e-1 e-2 (TTImpC-45TTImpC-45Traversals-mapPiInfo arg-1 e-3) e-4 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-5)))))))))
(define TTImpC-45TTImpC-45Traversals-mapImpRecord (lambda (arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (let ((e-6 (vector-ref arg-2 5))) (vector e-1 e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-8 (car eta-0))) (let ((e-7 (cdr eta-0))) (cons e-8 (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (cons e-10 (let ((e-12 (car e-9))) (let ((e-11 (cdr e-9))) (cons (TTImpC-45TTImpC-45Traversals-mapPiInfo arg-1 e-12) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-11))))))))))) e-3) e-4 e-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapIField arg-1 eta-0)) e-6))))))))))
(define TTImpC-45TTImpC-45Traversals-mapImpDecl (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (vector 0 e-1 e-2 e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapFnOpt arg-1 eta-0)) e-4) (TTImpC-45TTImpC-45Traversals-mapImpTy arg-1 e-5)))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (let ((e-9 (vector-ref arg-2 3))) (let ((e-10 (vector-ref arg-2 4))) (vector 1 e-7 e-8 e-9 (TTImpC-45TTImpC-45Traversals-mapImpData arg-1 e-10))))))) ((2) (let ((e-12 (vector-ref arg-2 1))) (let ((e-13 (vector-ref arg-2 2))) (let ((e-14 (vector-ref arg-2 3))) (vector 2 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpClause arg-1 eta-0)) e-14)))))) ((3) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-18 (vector-ref arg-2 3))) (vector 3 e-16 e-17 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpDecl arg-1 eta-0)) e-18)))))) ((4) (let ((e-20 (vector-ref arg-2 1))) (let ((e-21 (vector-ref arg-2 2))) (let ((e-22 (vector-ref arg-2 3))) (let ((e-23 (vector-ref arg-2 4))) (let ((e-24 (vector-ref arg-2 5))) (vector 4 e-20 e-21 e-22 e-23 (TTImpC-45TTImpC-45Traversals-mapImpRecord arg-1 e-24)))))))) ((5) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (vector 5 e-26 e-27 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpDecl arg-1 eta-0)) e-28)))))) ((6) (let ((e-30 (vector-ref arg-2 1))) (let ((e-31 (vector-ref arg-2 2))) (let ((e-32 (vector-ref arg-2 3))) (vector 6 e-30 e-31 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpDecl arg-1 eta-0)) e-32)))))) ((7) (let ((e-34 (vector-ref arg-2 1))) (let ((e-35 (vector-ref arg-2 2))) (let ((e-36 (vector-ref arg-2 3))) (let ((e-37 (vector-ref arg-2 4))) (vector 7 e-34 e-35 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-36) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-37))))))) ((8) (let ((e-39 (vector-ref arg-2 1))) (let ((e-40 (vector-ref arg-2 2))) (vector 8 e-39 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-40))))) ((9) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (vector 9 e-42 e-43 (lambda (vars-8547) (e-44 vars-8547))))))) ((10) (let ((e-46 (vector-ref arg-2 1))) (vector 10 e-46))) (else (let ((e-48 (vector-ref arg-2 1))) (let ((e-49 (vector-ref arg-2 2))) (let ((e-50 (vector-ref arg-2 3))) (vector 11 e-48 e-49 e-50))))))))
(define TTImpC-45TTImpC-45Traversals-mapTTImp (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (arg-1 arg-2)) ((1) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (arg-1 (vector 1 e-4 e-5 (TTImpC-45TTImpC-45Traversals-mapPiInfo arg-1 e-6) e-7 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-8) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-9)))))))))) ((2) (let ((e-11 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-13 (vector-ref arg-2 3))) (let ((e-14 (vector-ref arg-2 4))) (let ((e-15 (vector-ref arg-2 5))) (let ((e-16 (vector-ref arg-2 6))) (arg-1 (vector 2 e-11 e-12 (TTImpC-45TTImpC-45Traversals-mapPiInfo arg-1 e-13) e-14 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-15) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-16)))))))))) ((3) (let ((e-18 (vector-ref arg-2 1))) (let ((e-19 (vector-ref arg-2 2))) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (let ((e-22 (vector-ref arg-2 5))) (let ((e-23 (vector-ref arg-2 6))) (let ((e-24 (vector-ref arg-2 7))) (arg-1 (vector 3 e-18 e-19 e-20 e-21 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-22) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-23) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-24))))))))))) ((4) (let ((e-26 (vector-ref arg-2 1))) (let ((e-27 (vector-ref arg-2 2))) (let ((e-28 (vector-ref arg-2 3))) (let ((e-29 (vector-ref arg-2 4))) (let ((e-30 (vector-ref arg-2 5))) (arg-1 (vector 4 e-26 e-27 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-28) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-29) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpClause arg-1 eta-0)) e-30))))))))) ((5) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (arg-1 (vector 5 e-32 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpDecl arg-1 eta-0)) e-33) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-34))))))) ((6) (let ((e-36 (vector-ref arg-2 1))) (let ((e-37 (vector-ref arg-2 2))) (let ((e-38 (vector-ref arg-2 3))) (let ((e-39 (vector-ref arg-2 4))) (let ((e-40 (vector-ref arg-2 5))) (arg-1 (vector 6 e-36 e-37 e-38 e-39 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-40))))))))) ((7) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (arg-1 (vector 7 e-42 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapIFieldUpdate arg-1 eta-0)) e-43) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-44))))))) ((8) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (let ((e-48 (vector-ref arg-2 3))) (arg-1 (vector 8 e-46 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-47) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-48))))))) ((9) (let ((e-50 (vector-ref arg-2 1))) (let ((e-51 (vector-ref arg-2 2))) (let ((e-52 (vector-ref arg-2 3))) (arg-1 (vector 9 e-50 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-51) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-52))))))) ((10) (let ((e-54 (vector-ref arg-2 1))) (let ((e-55 (vector-ref arg-2 2))) (let ((e-56 (vector-ref arg-2 3))) (let ((e-57 (vector-ref arg-2 4))) (arg-1 (vector 10 e-54 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-55) e-56 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-57)))))))) ((11) (let ((e-59 (vector-ref arg-2 1))) (let ((e-60 (vector-ref arg-2 2))) (let ((e-61 (vector-ref arg-2 3))) (arg-1 (vector 11 e-59 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-60) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-61))))))) ((12) (let ((e-63 (vector-ref arg-2 1))) (let ((e-64 (vector-ref arg-2 2))) (arg-1 (vector 12 e-63 e-64))))) ((13) (let ((e-66 (vector-ref arg-2 1))) (let ((e-67 (vector-ref arg-2 2))) (let ((e-68 (vector-ref arg-2 3))) (arg-1 (vector 13 e-66 (TTImpC-45TTImpC-45Traversals-mapAltType arg-1 e-67) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 eta-0)) e-68))))))) ((14) (let ((e-70 (vector-ref arg-2 1))) (let ((e-71 (vector-ref arg-2 2))) (let ((e-72 (vector-ref arg-2 3))) (arg-1 (vector 14 e-70 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-71) (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-72))))))) ((15) (let ((e-74 (vector-ref arg-2 1))) (let ((e-75 (vector-ref arg-2 2))) (arg-1 (vector 15 e-74 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-75)))))) ((16) (let ((e-77 (vector-ref arg-2 1))) (let ((e-78 (vector-ref arg-2 2))) (let ((e-79 (vector-ref arg-2 3))) (arg-1 (vector 16 e-77 e-78 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-79))))))) ((17) (let ((e-81 (vector-ref arg-2 1))) (let ((e-82 (vector-ref arg-2 2))) (arg-1 (vector 17 e-81 e-82))))) ((18) (let ((e-84 (vector-ref arg-2 1))) (let ((e-85 (vector-ref arg-2 2))) (let ((e-86 (vector-ref arg-2 3))) (let ((e-87 (vector-ref arg-2 4))) (let ((e-88 (vector-ref arg-2 5))) (arg-1 (vector 18 e-84 e-85 e-86 e-87 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-88))))))))) ((19) (let ((e-90 (vector-ref arg-2 1))) (let ((e-91 (vector-ref arg-2 2))) (let ((e-92 (vector-ref arg-2 3))) (arg-1 (vector 19 e-90 e-91 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-92))))))) ((20) (let ((e-94 (vector-ref arg-2 1))) (let ((e-95 (vector-ref arg-2 2))) (let ((e-96 (vector-ref arg-2 3))) (arg-1 (vector 20 e-94 e-95 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-96))))))) ((21) (let ((e-98 (vector-ref arg-2 1))) (let ((e-99 (vector-ref arg-2 2))) (arg-1 (vector 21 e-98 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-99)))))) ((22) (let ((e-101 (vector-ref arg-2 1))) (let ((e-102 (vector-ref arg-2 2))) (arg-1 (vector 22 e-101 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-102)))))) ((23) (let ((e-104 (vector-ref arg-2 1))) (let ((e-105 (vector-ref arg-2 2))) (arg-1 (vector 23 e-104 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-105)))))) ((24) (let ((e-107 (vector-ref arg-2 1))) (let ((e-108 (vector-ref arg-2 2))) (arg-1 (vector 24 e-107 e-108))))) ((25) (let ((e-110 (vector-ref arg-2 1))) (let ((e-111 (vector-ref arg-2 2))) (arg-1 (vector 25 e-110 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapImpDecl arg-1 eta-0)) e-111)))))) ((26) (let ((e-113 (vector-ref arg-2 1))) (let ((e-114 (vector-ref arg-2 2))) (arg-1 (vector 26 e-113 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-114)))))) ((27) (let ((e-116 (vector-ref arg-2 1))) (let ((e-117 (vector-ref arg-2 2))) (let ((e-118 (vector-ref arg-2 3))) (arg-1 (vector 27 e-116 e-117 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-118))))))) ((28) (let ((e-120 (vector-ref arg-2 1))) (let ((e-121 (vector-ref arg-2 2))) (arg-1 (vector 28 e-120 e-121))))) ((29) (let ((e-123 (vector-ref arg-2 1))) (arg-1 (vector 29 e-123)))) ((30) (let ((e-125 (vector-ref arg-2 1))) (let ((e-126 (vector-ref arg-2 2))) (arg-1 (vector 30 e-125 e-126))))) ((31) (let ((e-128 (vector-ref arg-2 1))) (let ((e-129 (vector-ref arg-2 2))) (let ((e-130 (vector-ref arg-2 3))) (arg-1 (vector 31 e-128 e-129 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-130))))))) ((32) (let ((e-132 (vector-ref arg-2 1))) (let ((e-133 (vector-ref arg-2 2))) (arg-1 (vector 32 e-132 e-133))))) (else (let ((e-135 (vector-ref arg-2 1))) (let ((e-136 (vector-ref arg-2 2))) (let ((e-137 (vector-ref arg-2 3))) (arg-1 (vector 33 e-135 e-136 (TTImpC-45TTImpC-45Traversals-mapTTImp arg-1 e-137))))))))))
(define CoreC-45Normalise-normaliseArgHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nfOpts arg-0 arg-1 CoreC-45Value-withArgHoles arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-0 arg-1 arg-2 arg-3 e-5 eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45PartialEval-n--11458-2655-u--getRawArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((8) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (TTImpC-45PartialEval-n--11458-2655-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (vector 0 e-1 e-3) arg-10) e-2))))) ((10) (let ((e-5 (vector-ref arg-11 1))) (let ((e-6 (vector-ref arg-11 2))) (let ((e-7 (vector-ref arg-11 3))) (let ((e-8 (vector-ref arg-11 4))) (TTImpC-45PartialEval-n--11458-2655-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (vector 2 e-5 e-7 e-8) arg-10) e-6)))))) ((9) (let ((e-10 (vector-ref arg-11 1))) (let ((e-11 (vector-ref arg-11 2))) (let ((e-12 (vector-ref arg-11 3))) (TTImpC-45PartialEval-n--11458-2655-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (cons (vector 1 e-10 e-12) arg-10) e-11)))))(else arg-10))))
(define TTImpC-45PartialEval-n--11458-2658-u--reapply (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) arg-10 (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (TTImpC-45PartialEval-n--11458-2658-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 8 e-5 arg-10 e-6) e-3)))) ((2) (let ((e-8 (vector-ref e-2 1))) (let ((e-9 (vector-ref e-2 2))) (let ((e-10 (vector-ref e-2 3))) (TTImpC-45PartialEval-n--11458-2658-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 10 e-8 arg-10 e-9 e-10) e-3))))) (else (let ((e-12 (vector-ref e-2 1))) (let ((e-13 (vector-ref e-2 2))) (TTImpC-45PartialEval-n--11458-2658-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 9 e-12 arg-10 e-13) e-3))))))))))
(define TTImpC-45PartialEval-n--11458-2654-u--dropArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (TTImpC-45PartialEval-n--11458-2658-u--reapply arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (vector 0 arg-8 arg-10) (TTImpC-45PartialEval-dropSpec 0 arg-2 (TTImpC-45PartialEval-n--11458-2655-u--getRawArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 '() arg-11)))))
(define TTImpC-45PartialEval-n--11458-2660-u--unelabPat (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45ContextC-45Log-logTerm e-2 arg-9 "specialise" 20 (lambda () "Unelaborating LHS:") e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (TTImpC-45Unelab-unelabNoSugar e-2 arg-9 e-6 e-10 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45Log-log arg-9 "specialise" 20 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Unelaborating LHS to: " (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-2016 e-8) '())))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((u--lhsC-39 (TTImpC-45PartialEval-n--11458-2654-u--dropArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-8)))) (let ((act-4 (let ((act-4 (unbox arg-9))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (CoreC-45Normalise-normaliseArgHoles arg-9 e-2 e-12 e-6 e-11 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45Unelab-unelabNoSugar e-2 arg-9 e-6 e-13 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--rhs (PreludeC-45Basics-flip (lambda (eta-3) (lambda (eta-4) (TTImpC-45TTImpC-45Traversals-mapTTImp eta-3 eta-4))) e-14 (lambda (lcase-0) (case (vector-ref lcase-0 0) ((30) (let ((e-1 (vector-ref lcase-0 1))) (vector 32 e-1 0)))(else lcase-0)))))) (lambda (eta-3) (vector 1 (vector 0 arg-8 u--lhsC-39 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 u--rhs))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) eff-0) clam-0)))))))))))))))))
(define TTImpC-45PartialEval-getSpecPats (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (TTImpC-45PartialEval-specByVar arg-8 arg-9))) (if (null? sc0) (let ((u--dynnames (TTImpC-45PartialEval-n--11458-2656-u--mkDynNames arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 0 arg-7))) (let ((u--lhs (TTImpC-45TTImp-apply (vector 0 arg-2 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 17 arg-2 eta-0)) u--dynnames)))) (lambda (eta-0) (let ((act-1 ((TTImpC-45PartialEval-n--11458-2657-u--mkRHSargs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-6 (vector 0 arg-2 arg-4) u--dynnames arg-7) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons (vector 0 arg-2 u--lhs e-5) '())))))) eff-0) eta-0)))))))) (let ((e-2 (unbox sc0))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45PartialEval-n--11458-2660-u--unelabPat arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3 eta-1)) e-2 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-5))))) eff-0) eta-0)))))))))))
(define TTImpC-45PartialEval-n--12464-3620-u--showPat (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-2 (vector-ref arg-12 2))) (let ((e-3 (vector-ref arg-12 3))) (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-2) (string-append " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-3))))))(else "Can't happen"))))
(define TTImpC-45PartialEval-n--12464-3621-u--unelabDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (TTImpC-45Unelab-unelabNoSugar e-2 arg-11 e-6 e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-11))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Normalise-normaliseArgHoles arg-11 e-2 e-8 e-6 e-11 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45Unelab-unelabNoSugar e-2 arg-11 e-6 e-9 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 0 arg-6 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-5) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-12)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45PartialEval-case--caseC-32blockC-32inC-32mkSpecDef-4524 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 ext-0) (case (vector-ref arg-23 0) ((1) (let ((e-4 (vector-ref arg-23 5))) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-11 "specialise" 5 (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45PartialEval-n--12464-3621-u--unelabDef arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1)) e-4 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "Attempting to specialise:\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (TTImpC-45PartialEval-n--12464-3620-u--showPat arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-2)) e-5))))))) eff-0) eta-0)))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-11 '() arg-21 '() (let ((e-26 (vector-ref arg-5 2))) e-26)) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-getSpecPats arg-11 arg-6 arg-4 arg-2 arg-1 e-6 arg-3 arg-13 e-4))) eff-0) ext-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-6 (vector 1 ) arg-2) arg-1)) (let ((e-7 (unbox e-6))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-11 "specialise" 5 (lambda () (string-append "New patterns for " (string-append (CoreC-45Name-u--show_Show_Name arg-4) (string-append ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45PartialEval-n--12464-3620-u--showPat arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) e-7)))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 ((TTImpC-45ElabC-45Check-processDecl '() arg-11 arg-10 arg-9 arg-8 arg-7 (cons 2 '()) '() '() (vector 2 arg-6 (vector 8 arg-18) e-7)) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((act-5 ((CoreC-45Context-setAllPublic arg-11 0) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-10 (vector-ref act-5 1))) (vector 0 e-10))) (else (vector 1 arg-14))))))))))))))) eff-0) ext-0))))))))))(else (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-6 (vector 1 ) arg-2) arg-1))))))
(define TTImpC-45PartialEval-mkSpecDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (CoreC-45UnifyState-handleUnify arg-1 arg-3 1 (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setAllPublic arg-1 1) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--staticargs (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (if (null? e-3) '() (let ((e-4 (unbox e-3))) (box (cons e-2 e-4))))))) arg-9))) (let ((u--peapp (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-6 (vector 1 ) arg-8) (TTImpC-45PartialEval-dropSpec 0 u--staticargs arg-11)))) (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-8 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "specialise.declare" 5 (lambda (eta-2) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-54 arg-10 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-5 (if (null? e-3) (vector 1 '()) (let ((e-1 (unbox e-3))) (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-68 e-1 clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (box e-9))))) eff-0) clam-1))))))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-895 (cons (lambda (u--x) (TTImpC-45PartialEval-u--show_Show_C-40ArgModeC-39C-32C-36aC-41 csegen-1268 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45PartialEval-u--showPrec_Show_C-40ArgModeC-39C-32C-36aC-41 csegen-1268 u--d u--x))))) (cons e-2 e-9)))))) eff-0) clam-1))))))))) arg-9 '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Specialising " (string-append (CoreC-45Name-u--show_Show_Name e-8) (string-append " (" (string-append (CoreC-45Name-u--show_Show_Name arg-10) (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-5) eta-5) (cons ") -> " (cons (CoreC-45Name-u--show_Show_Name arg-8) (cons " by " '())))) (CoreC-45NameC-45Namespace-showSep ", " e-9)))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--sty (TTImpC-45PartialEval-specialiseTy '() 0 u--staticargs (let ((e-2 (vector-ref arg-7 2))) e-2)))) (let ((act-5 (CoreC-45Normalise-logTermNF '() arg-1 "specialise" 3 (lambda () (string-append "Specialised type " (CoreC-45Name-u--show_Show_Name arg-8))) '() u--sty clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((u--defflags (TTImpC-45PartialEval-n--12464-3619-u--propagateFlags arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-12 (vector-ref arg-7 12))) e-12)))) (let ((act-6 (CoreC-45ContextC-45Log-log arg-1 "specialise.flags" 20 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Defining " (cons (CoreC-45Name-u--show_Show_Name arg-8) (cons " with flags: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2699 u--defflags) '())))))) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45Context-addDef arg-1 arg-8 (let ((sc7 (CoreC-45Context-newDef arg-6 arg-8 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega '() u--sty (LibrariesC-45DataC-45WithDefault-specified 2) (vector 0 )))) (let ((e-0 (vector-ref sc7 0))) (let ((e-1 (vector-ref sc7 1))) (let ((e-2 (vector-ref sc7 2))) (let ((e-3 (vector-ref sc7 3))) (let ((e-4 (vector-ref sc7 4))) (let ((e-28 (vector-ref sc7 5))) (let ((e-27 (vector-ref sc7 6))) (let ((e-26 (vector-ref sc7 7))) (let ((e-25 (vector-ref sc7 8))) (let ((e-24 (vector-ref sc7 9))) (let ((e-23 (vector-ref sc7 10))) (let ((e-11 (vector-ref sc7 11))) (let ((e-13 (vector-ref sc7 13))) (let ((e-14 (vector-ref sc7 14))) (let ((e-15 (vector-ref sc7 15))) (let ((e-16 (vector-ref sc7 16))) (let ((e-17 (vector-ref sc7 17))) (let ((e-18 (vector-ref sc7 18))) (let ((e-19 (vector-ref sc7 19))) (let ((e-20 (vector-ref sc7 20))) (let ((e-21 (vector-ref sc7 21))) (let ((e-22 (vector-ref sc7 22))) (vector e-0 e-1 e-2 e-3 e-4 e-28 e-27 e-26 e-25 e-24 e-23 e-11 u--defflags e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22)))))))))))))))))))))))) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-8 (CoreC-45Context-addToSave arg-1 (vector 8 e-11) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((u--specnames (TTImpC-45PartialEval-n--12464-3617-u--getAllRefs arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 LibrariesC-45DataC-45NameMap-empty (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) arg-9)))) (let ((act-9 ((CoreC-45Core-traverseC-39 (lambda (u--n) (lambda (eta-3) (vector 1 (cons u--n 1)))) (LibrariesC-45DataC-45NameMap-keys u--specnames) '()) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-10 (let ((act-10 (unbox arg-1))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-11 ((TTImpC-45PartialEval-getReducible (cons arg-10 '()) LibrariesC-45DataC-45NameMap-empty e-14) eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-12 (CoreC-45Context-setFlag arg-1 arg-6 (vector 8 e-11) (vector 9 (PreludeC-45TypesC-45List-tailRecAppend e-13 (LibrariesC-45DataC-45NameMap-toList e-15))) eta-5))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((_-0 '())) (TTImpC-45PartialEval-case--caseC-32blockC-32inC-32mkSpecDef-4524 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 u--staticargs u--peapp _-0 u--sty u--defflags e-11 u--specnames e-13 e-14 e-15 (let ((e-18 (vector-ref arg-7 18))) e-18) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))))) eff-0) clam-0)))))))))))))))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "specialise" 5 (lambda () (string-append "Already specialised " (CoreC-45Name-u--show_Show_Name arg-8))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (vector 1 u--peapp)))))))) eff-0) eta-1))))))))))))) eff-0) eta-0)))))) (lambda (u--err) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "specialise.fail" 1 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-1 csegen-54 arg-10 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Partial evaluation of " (cons (CoreC-45Name-u--show_Show_Name e-5) (cons " failed:\xa;" (cons (CoreC-45Core-u--show_Show_Error u--err) '()))))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-1))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 (LibrariesC-45DataC-45NameMap-insert arg-8 (vector 0 ) e-26) e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-6 (vector 1 ) arg-10) arg-11)))))))))) ext-0)))
(define TTImpC-45PartialEval-traverseArgMode (lambda (arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-1 (unbox arg-3))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (box e-5)))))) (arg-2 e-1) ext-0)))))
(define CoreC-45Hash-u--hash_Hashable_C-40ListC-32C-36aC-41 (lambda (arg-1 ext-0) (CoreC-45Hash-u--hashWithSalt_Hashable_C-40ListC-32C-36aC-41 arg-1 (blodwen-toSignedInt 5381 63) ext-0)))
(define TTImpC-45PartialEval-n--14298-5237-u--dropErased (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-4 arg-5))) (cond ((equal? sc1 1) (cons (vector 10 arg-3 (vector 0 )) (TTImpC-45PartialEval-n--14298-5237-u--dropErased arg-1 arg-2 arg-3 (+ arg-4 1) arg-5 e-3))) (else (cons e-2 (TTImpC-45PartialEval-n--14298-5237-u--dropErased arg-1 arg-2 arg-3 (+ arg-4 1) arg-5 e-3))))))))))
(define TTImpC-45PartialEval-case--eraseInferred-5328 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (lambda (eta-0) (vector 1 e-2)) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((1) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-9) (lambda (eta-1) (vector 1 arg-1)) (let ((e-1 (unbox e-9))) (let ((u--argsE (TTImpC-45PartialEval-n--14298-5237-u--dropErased arg-1 arg-2 e-5 0 (let ((e-26 (vector-ref e-1 6))) e-26) e-3))) (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45PartialEval-eraseInferred arg-2 eta-2)) u--argsE '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-apply e-5 (vector 1 e-5 (vector 1 ) e-7) e-10))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-eraseInferred arg-2 eta-0)) e-3 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-apply (CoreC-45TTC-45Term-getLoc e-2) e-2 e-3))))) eff-0) clam-0))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-eraseInferred arg-2 eta-0)) e-3 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-apply (CoreC-45TTC-45Term-getLoc e-2) e-2 e-3))))) eff-0) clam-0))))))))))))
(define TTImpC-45PartialEval-eraseInferred (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (eta-1) (TTImpC-45PartialEval-eraseInferred arg-1 eta-1)) e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45PartialEval-eraseInferred arg-1 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-1 e-2 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (TTImpC-45PartialEval-case--eraseInferred-5328 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-2))))))
(define CoreC-45NameC-45Scoped-none (lambda (arg-1) (if (null? arg-1) (vector 0 ) (let ((e-3 (cdr arg-1))) (vector 1 (CoreC-45NameC-45Scoped-none e-3))))))
(define TTImpC-45PartialEval-n--14584-5512-u--concrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (CoreC-45TTC-45Term-u--shrink_IsScoped_Term arg-12 (CoreC-45NameC-45Scoped-none arg-11))))
(define TTImpC-45PartialEval-n--14584-5513-u--getSpecArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (lambda (clam-0) (if (null? arg-13) (vector 1 (box '())) (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (let ((e-7 (cdr e-2))) (let ((act-1 ((TTImpC-45PartialEval-n--14584-5513-u--getSpecArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (+ arg-11 1) arg-12 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-11 arg-12))) (cond ((equal? sc4 1) (let ((act-2 (let ((act-2 (unbox arg-10))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Normalise-normaliseHoles arg-10 arg-0 e-8 arg-4 e-7 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45PartialEval-eraseInferred arg-10 e-9) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc8 (TTImpC-45PartialEval-n--14584-5512-u--concrete arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-0 e-10))) (if (null? sc8) (vector 1 '()) (let ((e-4 (unbox sc8))) (vector 1 (box (cons (cons arg-11 (box e-4)) e-1))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) (else (vector 1 (box (cons (cons arg-11 '()) e-1))))))))))) eff-0) clam-0))))))))))))
(define TTImpC-45PartialEval-case--specialise-5888 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (vector 1 '()) (let ((act-1 (CoreC-45Context-toFullNames arg-10 csegen-54 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45PartialEval-n--14584-5513-u--getSpecArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 0 arg-11 arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (let ((act-3 (let ((act-3 (unbox arg-10))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((PreludeC-45Basics-flip csegen-1298 e-1 (lambda (eta-2) (CoreC-45Core-traversePair (lambda (eta-3) (lambda (eta-4) (TTImpC-45PartialEval-traverseArgMode (lambda (u--tm) (lambda (eta-5) (CoreC-45Normalise-normalise arg-10 '() e-7 '() u--tm eta-5))) eta-3 eta-4))) eta-2))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-toFullNames arg-10 csegen-68 eta-3 eta-4))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-3) (TTImpC-45PartialEval-getStatic eta-3)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-8)) '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--nhash (CoreC-45Hash-u--hashWithSalt_Hashable_Name (CoreC-45Hash-u--hash_Hashable_C-40ListC-32C-36aC-41 (csegen-1374) e-9) e-5))) (let ((u--pename (vector 0 CoreC-45NameC-45Namespace-partialEvalNS (vector 1 (vector 0 (string-append "PE_" (string-append (CoreC-45Name-nameRoot e-5) (string-append "_" (ProtocolC-45Hex-asHex (blodwen-toUnsignedInt u--nhash 64)))))))))) (lambda (eta-3) (let ((act-6 (let ((act-6 (unbox arg-10))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc8 (LibrariesC-45DataC-45NameMap-lookup u--pename (let ((e-26 (vector-ref e-10 26))) e-26)))) (if (null? sc8) (PreludeC-45IO-u--map_Functor_IO csegen-1275 (lambda (eta-4) (TTImpC-45PartialEval-mkSpecDef arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-3 u--pename e-8 arg-2 arg-1 eta-4)) clam-2) (vector 1 '())))))) eff-0) eta-3)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))
(define TTImpC-45PartialEval-specialise (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (lambda (eta-0) (TTImpC-45PartialEval-case--specialise-5888 arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-5 (vector-ref arg-8 5))) e-5) eta-0))))
(define TTImpC-45PartialEval-n--16185-8069-u--extendEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-16 arg-17) (case (vector-ref arg-16 0) ((0) arg-17) (else (let ((e-3 (vector-ref arg-16 3))) (cons (vector 0 arg-4 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 10 arg-4 (vector 0 ))) (TTImpC-45PartialEval-n--16185-8069-u--extendEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3 arg-17)))))))
(define TTImpC-45PartialEval-case--caseC-32blockC-32inC-32quoteGenNF-8153 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (let ((act-1 (TTImpC-45PartialEval-quoteArgsWithFC arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-1 arg-8 arg-7 arg-6 arg-5 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-4 (vector 1 ) arg-2) e-5))))) eff-0) ext-0))))) (let ((act-1 (CoreC-45Context-clearDefs arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quoteArgsWithFC arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-1 arg-8 arg-7 arg-6 arg-5 arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45PartialEval-specialise (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) arg-13 arg-12 arg-11 arg-10 arg-9 arg-4 (TTImpC-45PartialEval-n--16185-8069-u--extendEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-6 arg-5) arg-14 arg-2 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (let ((act-4 (TTImpC-45PartialEval-quoteArgsWithFC arg-13 arg-12 arg-11 arg-10 arg-9 arg-0 arg-1 arg-8 e-5 arg-6 arg-5 arg-3 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-4 (vector 1 ) arg-2) e-8))))) eff-0) clam-1))))) (let ((e-1 (unbox e-7))) (vector 1 e-1)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))
(define TTImpC-45PartialEval-quoteGenNF (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (lambda (eta-0) (let ((act-1 (TTImpC-45PartialEval-bName arg-7 "qv" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (((e-4 arg-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-10 (vector 1 e-1 (vector 0 ) e-5))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF (cons e-2 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 1 e-2 e-5 arg-9) arg-10 e-6))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45PartialEval-quoteBinder arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 3 e-1 e-2 e-7 e-6))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((1) (let ((e-6 (vector-ref arg-11 1))) (let ((e-7 (vector-ref arg-11 2))) (let ((e-8 (vector-ref arg-11 3))) (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-50 (vector-ref e-7 1))) (let ((e-51 (vector-ref e-7 2))) (case (vector-ref e-50 0) ((1) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-51 (let ((e-0 (vector-ref arg-8 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-6 arg-0 arg-1 arg-7 arg-8 arg-9 arg-10 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-6 (vector 1 ) e-51) e-9))))) eff-0) eta-0)))))) (let ((e-1 (unbox e-5))) (let ((_-0 (box e-1))) (lambda (eta-0) (TTImpC-45PartialEval-case--caseC-32blockC-32inC-32quoteGenNF-8153 arg-0 arg-1 e-51 e-8 e-6 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 e-1 _-0 (let ((e-26 (vector-ref e-1 5))) e-26) eta-0))))))) eff-0) clam-0))))))(else (let ((act-1 ((TTImpC-45PartialEval-quoteHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 arg-9 arg-10 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-6 arg-0 arg-1 arg-7 arg-8 arg-9 arg-10 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-5 e-9))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))(else (let ((act-1 ((TTImpC-45PartialEval-quoteHead arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-6 arg-9 arg-10 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-6 arg-0 arg-1 arg-7 arg-8 arg-9 arg-10 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-5 e-9))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) ((2) (let ((e-10 (vector-ref arg-11 1))) (let ((e-11 (vector-ref arg-11 2))) (let ((e-12 (vector-ref arg-11 3))) (let ((e-13 (vector-ref arg-11 4))) (let ((e-14 (vector-ref arg-11 5))) (lambda (eta-0) (let ((act-1 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-6 arg-0 arg-1 arg-7 arg-8 arg-9 arg-10 e-14 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-10 (vector 2 e-12 e-13) e-11) e-5))))) eff-0) eta-0)))))))))))) ((3) (let ((e-16 (vector-ref arg-11 1))) (let ((e-17 (vector-ref arg-11 2))) (let ((e-18 (vector-ref arg-11 3))) (let ((e-19 (vector-ref arg-11 4))) (let ((e-20 (vector-ref arg-11 5))) (lambda (eta-0) (let ((act-1 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-6 arg-0 arg-1 arg-7 arg-8 arg-9 arg-10 e-20 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-16 (vector 3 e-18 e-19) e-17) e-5))))) eff-0) eta-0)))))))))))) ((4) (let ((e-22 (vector-ref arg-11 1))) (let ((e-23 (vector-ref arg-11 2))) (let ((e-24 (vector-ref arg-11 3))) (let ((e-25 (vector-ref arg-11 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-24) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-25) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-22 e-23 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((5) (let ((e-27 (vector-ref arg-11 1))) (let ((e-28 (vector-ref arg-11 2))) (let ((e-29 (vector-ref arg-11 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-29) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 e-27 e-28 e-5))))) eff-0) eta-0)))))))))) ((6) (let ((e-31 (vector-ref arg-11 1))) (let ((e-32 (vector-ref arg-11 2))) (let ((e-33 (vector-ref arg-11 3))) (let ((e-34 (vector-ref arg-11 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-34) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-33) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-7) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 7 e-31 e-32 e-8 e-6))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((7) (let ((e-36 (vector-ref arg-11 1))) (let ((e-37 (vector-ref arg-11 2))) (let ((e-38 (vector-ref arg-11 3))) (let ((e-39 (vector-ref arg-11 4))) (lambda (eta-0) (let ((act-1 (TTImpC-45PartialEval-quoteArgsWithFC arg-2 arg-3 arg-4 arg-5 arg-6 arg-0 arg-1 arg-7 arg-8 arg-9 arg-10 e-39 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-38 0) ((6) (let ((e-4 (vector-ref e-38 4))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 arg-1 arg-8 e-4) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC e-7 e-5))))) eff-0) eta-1)))))))) eff-0) clam-1)))))))(else (let ((act-2 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-38) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 8 e-36 e-37 e-6) e-5))))) eff-0) clam-1)))))))))) eff-0) eta-0))))))))))) ((8) (let ((e-41 (vector-ref arg-11 1))) (let ((e-42 (vector-ref arg-11 2))) (lambda (eta-0) (vector 1 (vector 9 e-41 e-42)))))) ((9) (let ((e-44 (vector-ref arg-11 1))) (let ((e-45 (vector-ref arg-11 2))) (lambda (clam-2) (case (vector-ref e-45 0) ((1) (vector 1 (vector 10 e-44 (vector 1 )))) ((0) (vector 1 (vector 10 e-44 (vector 0 )))) (else (let ((e-55 (vector-ref e-45 1))) (let ((act-1 ((TTImpC-45PartialEval-quoteGenNF arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-55) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-44 (vector 2 e-5)))))) eff-0) clam-2)))))))))))) (else (let ((e-47 (vector-ref arg-11 1))) (let ((e-48 (vector-ref arg-11 2))) (lambda (eta-0) (vector 1 (vector 11 e-47 e-48)))))))))
(define TTImpC-45PartialEval-evalRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45PartialEval-quoteGenNF '() arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 e-6 (vector 0 ) arg-6 arg-7))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45PartialEval-findSpecs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((1) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (case (vector-ref e-2 0) ((1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-1 (vector 1 ) e-3) arg-7)) (let ((e-4 (unbox e-6))) (let ((act-3 ((TTImpC-45PartialEval-specialise arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-1 arg-6 e-4 e-3 arg-7) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-7) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 1 e-1 (vector 1 ) e-3) arg-7)) (let ((e-8 (unbox e-7))) (vector 1 e-8)))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 (CoreC-45TTC-45Term-applyStackWithFC arg-8 arg-7)))))))) ((2) (let ((e-5 (vector-ref arg-8 1))) (let ((e-6 (vector-ref arg-8 2))) (let ((e-7 (vector-ref arg-8 3))) (let ((e-8 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() eta-0)) e-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 2 e-5 e-6 e-7 e-9) arg-7))))) eff-0) clam-0)))))))))) ((3) (let ((e-10 (vector-ref arg-8 1))) (let ((e-11 (vector-ref arg-8 2))) (let ((e-12 (vector-ref arg-8 3))) (let ((e-13 (vector-ref arg-8 4))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (eta-0) (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() eta-0)) e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45PartialEval-findSpecs (cons e-11 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-5 arg-6) '() e-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 3 e-10 e-11 e-5 e-6) arg-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((4) (let ((e-15 (vector-ref arg-8 1))) (let ((e-16 (vector-ref arg-8 2))) (let ((e-17 (vector-ref arg-8 3))) (let ((act-1 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-17) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-15 e-5) arg-7) e-16))) eff-0) clam-0))))))))) ((6) (let ((e-19 (vector-ref arg-8 1))) (let ((e-20 (vector-ref arg-8 2))) (let ((e-21 (vector-ref arg-8 3))) (let ((act-1 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-21) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 6 e-19 e-20 e-5) arg-7))))) eff-0) clam-0))))))))) ((7) (let ((e-23 (vector-ref arg-8 1))) (let ((e-24 (vector-ref arg-8 2))) (let ((e-25 (vector-ref arg-8 3))) (let ((e-26 (vector-ref arg-8 4))) (let ((act-1 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-25) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-26) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 7 e-23 e-24 e-5 e-6) arg-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((8) (let ((e-28 (vector-ref arg-8 1))) (let ((e-29 (vector-ref arg-8 2))) (let ((e-30 (vector-ref arg-8 3))) (let ((act-1 ((TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() e-30) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-applyStackWithFC (vector 8 e-28 e-29 e-5) arg-7))))) eff-0) clam-0)))))))))(else (vector 1 (CoreC-45TTC-45Term-applyStackWithFC arg-8 arg-7)))))))
(define TTImpC-45PartialEval-applySpecialise (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-7) (TTImpC-45PartialEval-findSpecs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() arg-8) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toResolvedNames arg-1 csegen-68 arg-8 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-6 e-6) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (TTImpC-45PartialEval-evalRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-68 e-8 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45Normalise-logTermNF arg-0 arg-1 "specialise" 5 (lambda () "New RHS") arg-6 e-9 eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (vector 1 e-9))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define CoreC-45Transform-unload (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (CoreC-45Transform-unload e-3 (vector 4 e-6 arg-2 e-7)))))))))
(define CoreC-45Transform-lookupMatch (lambda (arg-3 arg-5) (case (vector-ref arg-5 0) ((0) '()) (else (let ((e-5 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((sc1 (or (and (= arg-3 e-5) 1) 0))) (cond ((equal? sc1 1) (box e-7)) (else (CoreC-45Transform-lookupMatch arg-3 e-8)))))))))))
(define CoreC-45Transform-case--addMatch-13579 (lambda (arg-3 arg-4 arg-5 arg-7) (if (null? arg-7) (box (vector 1 arg-5 arg-4 arg-3)) (let ((e-2 (unbox arg-7))) (let ((sc1 (CoreC-45TTC-45Term-eqTerm arg-4 e-2))) (cond ((equal? sc1 1) (box arg-3)) (else '())))))))
(define CoreC-45Transform-addMatch (lambda (arg-3 arg-5 arg-6) (CoreC-45Transform-case--addMatch-13579 arg-6 arg-5 arg-3 (CoreC-45Transform-lookupMatch arg-3 arg-6))))
(define CoreC-45Transform-match (lambda (arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (CoreC-45Transform-addMatch e-4 arg-4 arg-2))) ((4) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (case (vector-ref arg-4 0) ((4) (let ((e-12 (vector-ref arg-4 2))) (let ((e-13 (vector-ref arg-4 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-match arg-2 e-8 e-12) (lambda (u--msC-39) (CoreC-45Transform-match u--msC-39 e-9 e-13))))))(else (let ((sc1 (CoreC-45TTC-45Term-eqTerm arg-3 arg-4))) (cond ((equal? sc1 1) (box arg-2)) (else '()))))))))(else (let ((sc0 (CoreC-45TTC-45Term-eqTerm arg-3 arg-4))) (cond ((equal? sc0 1) (box arg-2)) (else '())))))))
(define CoreC-45Transform-tryReplace (lambda (arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 3))) (CoreC-45Transform-lookupMatch e-4 arg-2))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (box (vector 1 e-7 e-8 e-9)))))) ((2) (let ((e-11 (vector-ref arg-3 1))) (let ((e-12 (vector-ref arg-3 2))) (let ((e-13 (vector-ref arg-3 3))) (let ((e-14 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (CoreC-45Transform-tryReplace arg-2 eta-0)) e-14) (lambda (u--asC-39) (box (vector 2 e-11 e-12 e-13 u--asC-39))))))))) ((3) '()) ((4) (let ((e-21 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-23 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-22) (lambda (u--fC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-23) (lambda (u--aC-39) (box (vector 4 e-21 u--fC-39 u--aC-39)))))))))) ((5) (let ((e-25 (vector-ref arg-3 1))) (let ((e-26 (vector-ref arg-3 2))) (let ((e-27 (vector-ref arg-3 3))) (let ((e-28 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-27) (lambda (u--aC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-28) (lambda (u--pC-39) (box (vector 5 e-25 e-26 u--aC-39 u--pC-39))))))))))) ((6) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-32) (lambda (u--tmC-39) (box (vector 6 e-30 e-31 u--tmC-39)))))))) ((7) (let ((e-34 (vector-ref arg-3 1))) (let ((e-35 (vector-ref arg-3 2))) (let ((e-36 (vector-ref arg-3 3))) (let ((e-37 (vector-ref arg-3 4))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-36) (lambda (u--tyC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-37) (lambda (u--tmC-39) (box (vector 7 e-34 e-35 u--tyC-39 u--tmC-39))))))))))) ((8) (let ((e-39 (vector-ref arg-3 1))) (let ((e-40 (vector-ref arg-3 2))) (let ((e-41 (vector-ref arg-3 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryReplace arg-2 e-41) (lambda (u--tmC-39) (box (vector 8 e-39 e-40 u--tmC-39)))))))) ((9) (let ((e-43 (vector-ref arg-3 1))) (let ((e-44 (vector-ref arg-3 2))) (box (vector 9 e-43 e-44))))) ((10) (let ((e-46 (vector-ref arg-3 1))) (let ((e-47 (vector-ref arg-3 2))) (case (vector-ref e-47 0) ((1) (box (vector 10 e-46 (vector 1 )))) ((0) (box (vector 10 e-46 (vector 0 )))) (else (let ((e-54 (vector-ref e-47 1))) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (vector 10 e-46 (vector 2 eta-0))) (CoreC-45Transform-tryReplace arg-2 e-54)))))))) (else (let ((e-49 (vector-ref arg-3 1))) (let ((e-50 (vector-ref arg-3 2))) (box (vector 11 e-49 e-50))))))))
(define CoreC-45Transform-tryApply (lambda (arg-1 arg-2) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((u--trans (vector e-0 e-1 e-2 e-3 e-4))) (let ((sc0 (CoreC-45Transform-match (vector 0 ) e-3 arg-2))) (if (null? sc0) (case (vector-ref arg-2 0) ((4) (let ((e-7 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-5 (vector-ref arg-2 3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Transform-tryApply u--trans e-6) (lambda (u--fC-39) (box (vector 4 e-7 u--fC-39 e-5))))))))(else '())) (let ((e-5 (unbox sc0))) (CoreC-45Transform-tryReplace e-5 e-4))))))))))))
(define CoreC-45Transform-apply (lambda (arg-1 arg-2) (if (null? arg-1) (cons 0 arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (CoreC-45Transform-tryApply e-2 arg-2))) (if (null? sc1) (CoreC-45Transform-apply e-3 arg-2) (let ((e-4 (unbox sc1))) (cons 1 e-4)))))))))
(define CoreC-45Transform-case--trans-14224 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (CoreC-45Transform-unload arg-3 (vector 1 arg-2 (vector 1 ) arg-1)))) (let ((e-2 (unbox arg-8))) (let ((u--fullapp (CoreC-45Transform-unload arg-3 (vector 1 arg-2 (vector 1 ) arg-1)))) (lambda (clam-0) (let ((sc1 (CoreC-45Transform-apply e-2 u--fullapp))) (let ((e-4 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-5))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-5 (cond ((equal? e-5 1) 1) (else e-4))))) (vector 1 act-2))))) eff-1) world-0))))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (vector 1 e-3)))))))))))))
(define CoreC-45Transform-trans (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (case (vector-ref e-2 0) ((1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Transform-case--trans-14224 e-3 e-1 arg-4 arg-3 arg-2 arg-1 e-5 (LibrariesC-45DataC-45NameMap-lookup e-3 (let ((e-13 (vector-ref e-5 13))) e-13))))) eff-0) clam-0))))))(else (vector 1 (CoreC-45Transform-unload arg-4 arg-5)))))))) ((2) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (let ((e-8 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Transform-trans arg-1 arg-2 arg-3 '() eta-0)) e-8 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Transform-unload arg-4 (vector 2 e-5 e-6 e-7 e-9)))))) eff-0) clam-0)))))))))) ((3) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (let ((e-13 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45CoreC-45Binder-traverse (lambda (eta-0) (CoreC-45Transform-trans arg-1 arg-2 arg-3 '() eta-0)) e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Transform-trans arg-1 arg-2 (cons e-5 arg-3) '() e-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Transform-unload arg-4 (vector 3 e-10 e-11 e-5 e-6)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((4) (let ((e-15 (vector-ref arg-5 1))) (let ((e-16 (vector-ref arg-5 2))) (let ((e-17 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-17) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Transform-trans arg-1 arg-2 arg-3 (cons (cons e-15 e-5) arg-4) e-16))) eff-0) clam-0))))))))) ((6) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-21) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Transform-unload arg-4 (vector 6 e-19 e-20 e-5)))))) eff-0) clam-0))))))))) ((7) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (let ((e-25 (vector-ref arg-5 3))) (let ((e-26 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-25) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-26) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Transform-unload arg-4 (vector 7 e-23 e-24 e-5 e-6)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((8) (let ((e-28 (vector-ref arg-5 1))) (let ((e-29 (vector-ref arg-5 2))) (let ((e-30 (vector-ref arg-5 3))) (let ((act-1 ((CoreC-45Transform-trans arg-1 arg-2 arg-3 '() e-30) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Transform-unload arg-4 (vector 8 e-28 e-29 e-5)))))) eff-0) clam-0)))))))))(else (vector 1 (CoreC-45Transform-unload arg-4 arg-5)))))))
(define CoreC-45Transform-transLoop (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-2 0) (lambda (eta-0) (vector 1 arg-4)))(else (let ((e-0 (- arg-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.Transform.Upd" ) 0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Transform-trans arg-1 e-5 arg-3 '() arg-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (cond ((equal? e-7 1) (CoreC-45Transform-transLoop arg-1 e-0 arg-3 e-6)) (else (lambda (eta-3) (vector 1 e-6)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define CoreC-45Transform-applyTransforms (lambda (arg-1 arg-2 arg-3) (CoreC-45Transform-transLoop arg-1 5 arg-2 arg-3)))
(define CoreC-45LinearCheck-count (lambda (arg-1 arg-2) (if (null? arg-2) 0 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (or (and (= arg-1 e-2) 1) 0))) (cond ((equal? sc1 1) (+ (CoreC-45LinearCheck-count arg-1 e-3) 1)) (else (CoreC-45LinearCheck-count arg-1 e-3)))))))))
(define CoreC-45LinearCheck-updateHoleUsageArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 ((CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45LinearCheck-updateHoleUsageArgs arg-1 arg-2 arg-3 arg-4 arg-5 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cond ((equal? e-5 1) 1) (else e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define CoreC-45LinearCheck-updateHoleType (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-7 0) ((3) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (if (null? arg-8) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45LinearCheck-updateHoleUsageArgs arg-2 arg-3 0 arg-5 arg-6 arg-8 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (vector 1 arg-7))))) (let ((e-11 (car arg-8))) (let ((e-12 (cdr arg-8))) (case (vector-ref e-11 0) ((0) (let ((e-17 (vector-ref e-11 3))) (lambda (clam-0) (let ((sc4 (or (and (= arg-5 e-17) 1) 0))) (cond ((equal? sc4 1) (let ((act-1 ((CoreC-45LinearCheck-updateHoleType arg-2 arg-3 0 arg-5 arg-6 e-4 e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cC-39 (cond ((equal? arg-4 1) e-7) (else csegen-30)))) (lambda (eta-0) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 u--cC-39 e-8 e-9) e-5)))))) eff-0) clam-0)))))) (else (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-1032 e-17 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) eta-0) arg-6)))) (cond ((equal? sc5 1) (let ((act-1 ((CoreC-45LinearCheck-updateHoleType arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 csegen-30 e-8 e-9) e-5))))) eff-0) clam-0)))))) (else (let ((act-1 ((CoreC-45LinearCheck-updateHoleType arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 e-7 e-8 e-9) e-5))))) eff-0) clam-0))))))))))))))(else (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (CoreC-45LinearCheck-updateHoleUsage arg-2 arg-3 0 arg-5 arg-6 e-11) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 ((CoreC-45LinearCheck-updateHoleType arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-12) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-1 e-2 (vector 2 e-6 e-7 e-8 e-9) e-10))))) eff-0) eta-0)))))))))))))))))))(else (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45LinearCheck-updateHoleUsageArgs arg-2 arg-3 0 arg-5 arg-6 arg-8 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (vector 1 arg-7))))))))))))(else (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45LinearCheck-updateHoleUsageArgs arg-2 arg-3 0 arg-5 arg-6 arg-8 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-7)))))))))
(define CoreC-45Context-updateTy (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-1) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 (vector 8 arg-1) (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 arg-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-1)) clam-0)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45LinearCheck-case--updateHoleUsage-5184 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((1) (lambda (eta-0) (CoreC-45LinearCheck-updateHoleUsageArgs arg-6 arg-5 arg-4 arg-3 arg-2 e-3 eta-0)))(else (if (null? e-3) (lambda (eta-0) (vector 1 0)) (lambda (eta-0) (CoreC-45LinearCheck-updateHoleUsageArgs arg-6 arg-5 arg-4 arg-3 arg-2 (cons e-2 e-3) eta-0)))))))))
(define CoreC-45LinearCheck-updateHoleUsage (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((3) (let ((e-31 (vector-ref arg-6 3))) (let ((e-32 (vector-ref arg-6 4))) (case (vector-ref e-31 0) ((1) (let ((e-36 (vector-ref e-31 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-36) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 (+ arg-4 1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-2)))) arg-5) e-32) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cond ((equal? e-5 1) 1) (else e-6)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))(else (CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 (+ arg-4 1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc1))) (((e-1 'erased) 'erased) eta-0)))) arg-5) e-32))))))(else (case (vector-ref arg-6 0) ((2) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (CoreC-45LinearCheck-updateHoleUsageArgs arg-1 arg-2 arg-3 arg-4 arg-5 e-4 eta-2)) (let ((e-7 (unbox e-6))) (let ((e-18 (vector-ref e-7 18))) (case (vector-ref e-18 0) ((7) (let ((u--ty (let ((e-52 (vector-ref e-7 2))) e-52))) (lambda (eta-2) (let ((act-3 ((CoreC-45LinearCheck-updateHoleType arg-1 arg-2 arg-3 arg-4 arg-5 u--ty e-4) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-32 (vector-ref act-3 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-updateTy arg-1 e-3 e-32 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-33 (vector-ref act-4 1))) (vector 0 e-33))) (else (let ((act-5 (CoreC-45ContextC-45Log-logTerm '() arg-1 "quantity.hole.update" 5 (lambda () (string-append "New type of " (CoreC-45Name-u--show_Show_Name (let ((e-55 (vector-ref e-7 1))) e-55)))) e-32 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-34 (vector-ref act-5 1))) (vector 0 e-34))) (else (let ((act-6 (CoreC-45ContextC-45Log-logTerm '() arg-1 "quantity.hole.update" 5 (lambda () (string-append "Updated from " (CoreC-45Name-u--show_Show_Name (let ((e-56 (vector-ref e-7 1))) e-56)))) (let ((e-55 (vector-ref e-7 2))) e-55) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-35 (vector-ref act-6 1))) (vector 0 e-35))) (else (vector 1 1))))))))))))) eff-0) eta-2))))))))(else (lambda (eta-2) (CoreC-45LinearCheck-updateHoleUsageArgs arg-1 arg-2 arg-3 arg-4 arg-5 e-4 eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-8) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cond ((equal? e-5 1) 1) (else e-10)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((6) (let ((e-13 (vector-ref arg-6 3))) (CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-13))) ((7) (let ((e-18 (vector-ref arg-6 4))) (CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-18))) ((8) (let ((e-22 (vector-ref arg-6 3))) (CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 arg-3 arg-4 arg-5 e-22)))(else (CoreC-45LinearCheck-case--updateHoleUsage-5184 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-6))))))))
(define CoreC-45LinearCheck-n--17910-12266-u--checkUsageOK (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-13))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-12 1)) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-9 arg-12 arg-1) ext-0)) (else (vector 1 (vector 0 )))))))
(define CoreC-45LinearCheck-checkEnvUsage (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-1) (lambda (clam-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-7))) (let ((e-9 (cdr arg-7))) (let ((u--used_in (CoreC-45LinearCheck-count arg-5 arg-8))) (lambda (eta-0) (let ((act-1 (let ((sc2 (AlgebraC-45Semiring-isLinear csegen-931 (CoreC-45TTC-45Binder-multiplicity e-8)))) (cond ((equal? sc2 1) ((CoreC-45LinearCheck-updateHoleUsage arg-2 arg-3 (or (and (= u--used_in 0) 1) 0) arg-5 '() arg-9) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--used (let ((sc3 (let ((sc4 (AlgebraC-45Semiring-isLinear csegen-931 (AlgebraC-45ZeroOneOmega-rigMult (CoreC-45TTC-45Binder-multiplicity e-8) arg-6)))) (cond ((equal? sc4 1) (cond ((equal? e-5 1) (or (and (= u--used_in 0) 1) 0)) (else 0))) (else 0))))) (cond ((equal? sc3 1) 1) (else u--used_in))))) (lambda (eta-1) (let ((act-2 (CoreC-45LinearCheck-n--17910-12266-u--checkUsageOK e-2 e-3 e-9 e-8 arg-9 arg-8 arg-6 arg-5 arg-4 arg-3 arg-2 u--used (AlgebraC-45ZeroOneOmega-rigMult (CoreC-45TTC-45Binder-multiplicity e-8) arg-6) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((CoreC-45LinearCheck-checkEnvUsage e-3 arg-2 arg-3 arg-4 (LibrariesC-45DataC-45SnocListC-45SizeOf-C-58C-60 arg-5) arg-6 e-9 arg-8 arg-9) eta-1)))))))) eff-0) eta-0))))))))))))))
(define CoreC-45LinearCheck-C-43C-43 (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (CoreC-45LinearCheck-C-43C-43 e-3 arg-2)))))))
(define CoreC-45LinearCheck-discharge (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 0 e-1 e-2 e-3 e-4) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 2 e-1 e-2 e-3 e-4) e-5)) arg-9)))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-5 1))) (let ((e-7 (vector-ref arg-5 2))) (let ((e-8 (vector-ref arg-5 3))) (let ((e-9 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 1 e-6 e-7 e-8 e-9) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 1 e-6 e-7 e-8 e-9) e-5)) arg-9)))))) eff-0) ext-0)))))))))) ((2) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (let ((e-13 (vector-ref arg-5 3))) (let ((e-14 (vector-ref arg-5 4))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 2 e-11 e-12 e-13 e-14) arg-7) (cons arg-6 arg-9)))))))) ((3) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((e-19 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 3 e-16 e-17 e-18 e-19) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 5 e-16 e-17 e-19) e-5)) arg-9)))))) eff-0) ext-0)))))))))) ((4) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 4 e-21 e-22 e-23 e-24) arg-7) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-2 (vector 3 arg-3 arg-4 (vector 4 e-21 e-22 e-23 e-24) e-5)) arg-9)))))) eff-0) ext-0)))))))))) (else (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (let ((e-28 (vector-ref arg-5 3))) (vector 1 (cons (vector 3 arg-3 arg-4 (vector 5 e-26 e-27 e-28) arg-7) (cons arg-6 arg-9))))))))))
(define CoreC-45LinearCheck-doneScope (lambda (arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (cond ((equal? e-2 0) (CoreC-45LinearCheck-doneScope e-3))(else (let ((e-9 (- e-2 1))) (cons e-9 (CoreC-45LinearCheck-doneScope e-3))))))))))
(define CoreC-45LinearCheck-n--10170-11629-u--substMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-16 0) ((3) (let ((e-3 (vector-ref arg-16 2))) (let ((e-4 (vector-ref arg-16 3))) (let ((e-5 (vector-ref arg-16 4))) (case (vector-ref e-4 0) ((0) (if (null? arg-17) (lambda (clam-0) (if (null? arg-17) (vector 1 (CoreC-45TTC-45TermC-45Subst-substs arg-18 arg-19 arg-16)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed metavar solution " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-5))))) clam-0))) (let ((e-17 (car arg-17))) (let ((e-18 (cdr arg-17))) (CoreC-45LinearCheck-n--10170-11629-u--substMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 (cons e-3 arg-14) arg-15 e-5 e-18 (LibrariesC-45DataC-45ListC-45SizeOf-suc arg-18) (cons e-17 arg-19)))))) ((1) (let ((e-14 (vector-ref e-4 3))) (CoreC-45LinearCheck-n--10170-11629-u--substMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (CoreC-45TTC-45TermC-45Subst-subst e-14 e-5) arg-17 arg-18 arg-19)))(else (lambda (clam-1) (if (null? arg-17) (vector 1 (CoreC-45TTC-45TermC-45Subst-substs arg-18 arg-19 arg-16)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed metavar solution " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-5))))) clam-1)))))))))(else (lambda (clam-2) (if (null? arg-17) (vector 1 (CoreC-45TTC-45TermC-45Subst-substs arg-18 arg-19 arg-16)) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed metavar solution " (string-append (CoreC-45Name-u--show_Show_Name arg-8) (string-append " " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() arg-5))))) clam-2)))))))
(define CoreC-45LinearCheck-expandMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-8 0) ((1) (let ((e-0 (vector-ref arg-8 1))) (let ((e-1 (vector-ref arg-8 2))) (let ((e-2 (vector-ref arg-8 3))) (let ((e-3 (vector-ref arg-8 4))) (let ((e-4 (vector-ref arg-8 5))) (lambda (clam-0) (if (null? e-1) (case (vector-ref e-2 0) ((1) (let ((e-7 (vector-ref e-2 1))) (let ((e-8 (vector-ref e-2 2))) (let ((act-1 ((CoreC-45LinearCheck-n--10170-11629-u--substMeta arg-0 e-0 e-3 e-4 e-7 e-8 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() arg-0 e-8 arg-9 0 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5))) eff-0) clam-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed metavar solution " (string-append (CoreC-45Name-u--show_Show_Name arg-6) (string-append " " (CoreC-45ContextC-45Context-u--show_Show_Def arg-8))))) clam-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed metavar solution " (string-append (CoreC-45Name-u--show_Show_Name arg-6) (string-append " " (CoreC-45ContextC-45Context-u--show_Show_Def arg-8))))) clam-0)))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Badly formed metavar solution " (string-append (CoreC-45Name-u--show_Show_Name arg-6) (string-append " " (CoreC-45ContextC-45Context-u--show_Show_Def arg-8))))) eta-0))))))
(define CoreC-45LinearCheck-lcheckBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 csegen-30 arg-4 arg-5 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-7 (car e-5))) (let ((e-6 (cdr e-5))) (let ((e-9 (car e-6))) (vector 1 (cons (vector 0 e-1 e-2 e-3 e-7) (cons e-9 '()))))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 csegen-30 arg-4 arg-5 e-9) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-11 (car e-3))) (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (AlgebraC-45ZeroOneOmega-rigMult arg-3 e-7) arg-4 arg-5 e-8) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-13 (car e-12))) (let ((e-4 (cdr e-12))) (let ((e-14 (cdr e-4))) (vector 1 (cons (vector 1 e-6 e-7 e-13 e-2) (cons e-11 e-14))))))))) eff-0) clam-1))))))))))) eff-0) ext-0)))))))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (AlgebraC-45ZeroOneOmega-rigMult arg-3 e-12) arg-4 arg-5 e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (vector 1 (cons (vector 2 e-11 e-12 e-13 e-2) (cons e-6 '()))))))))) eff-0) ext-0)))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 csegen-30 arg-4 arg-5 e-19) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (vector 1 (cons (vector 3 e-16 e-17 e-18 e-2) (cons e-6 '()))))))))) eff-0) ext-0)))))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (let ((e-24 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 csegen-30 arg-4 arg-5 e-24) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 (AlgebraC-45ZeroOneOmega-rigMult arg-3 e-22) arg-4 arg-5 e-23) clam-5))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-6) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((e-10 (cdr e-4))) (vector 1 (cons (vector 4 e-21 e-22 e-9 e-2) (cons e-6 e-10))))))))) eff-0) clam-5))))))))))) eff-0) ext-0)))))))))) (else (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 csegen-30 arg-4 arg-5 e-28) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-7) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((e-6 (car e-3))) (vector 1 (cons (vector 5 e-26 e-27 e-2) (cons e-6 '()))))))))) eff-0) ext-0))))))))))))
(define CoreC-45LinearCheck-n--10112-9499-u--combineUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-95) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-94) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-93) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-92) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-91) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-90) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-89) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-88) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-87) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-86) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-85) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-84) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-83) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-82) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-81) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-80) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))) (let ((e-22 (car arg-6))) (let ((e-23 (cdr arg-6))) (cond ((equal? e-23 1) (if (null? arg-7) (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-31) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-30) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-29) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-28) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-27) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-26) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-25) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-24) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-23) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-22) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-21) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-20) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-19) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-18) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-17) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-16) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))) (let ((e-27 (cdr arg-7))) (cond ((equal? e-27 2) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 (string-append "Inconsistent usage of " (string-append (CoreC-45Name-u--show_Show_Name e-22) " in case branches"))) eta-0)))(else (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-15) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-14) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-13) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-12) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-11) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-10) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-9) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-8) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-7) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-6) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-5) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-4) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-3) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-2) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-1) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-0) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))))))))))))) ((equal? e-23 2) (if (null? arg-7) (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-63) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-62) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-61) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-60) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-59) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-58) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-57) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-56) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-55) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-54) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-53) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-52) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-51) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-50) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-49) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-48) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))) (let ((e-31 (cdr arg-7))) (cond ((equal? e-31 1) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 (string-append "Inconsistent usage of " (string-append (CoreC-45Name-u--show_Show_Name e-22) " in case branches"))) eta-0)))(else (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-47) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-46) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-45) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-44) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-43) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-42) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-41) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-40) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-39) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-38) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-37) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-36) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-35) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-34) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-33) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-32) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))))))))))))) ((equal? e-23 0) (lambda (eta-0) (vector 1 (cons e-22 0))))(else (if (null? arg-7) (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-79) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-78) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-77) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-76) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-75) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-74) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-73) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-72) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))))))))))))) (let ((e-18 (car arg-7))) (let ((e-19 (cdr arg-7))) (cond ((equal? e-19 0) (lambda (eta-0) (vector 1 (cons e-18 0))))(else (if (null? arg-6) (if (null? arg-7) (if (null? arg-6) (lambda (clam-71) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-70) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-69) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-68) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))) (let ((e-14 (car arg-6))) (let ((e-15 (cdr arg-6))) (cond ((equal? e-15 3) (lambda (eta-0) (vector 1 (cons e-14 3))))(else (if (null? arg-7) (if (null? arg-6) (lambda (clam-67) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-66) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6)))))))))))) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (cond ((equal? e-11 3) (lambda (eta-0) (vector 1 (cons e-10 3))))(else (if (null? arg-6) (lambda (clam-65) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (cond ((equal? e-7 4) (lambda (eta-0) (vector 1 (cons e-6 4))))(else (lambda (clam-64) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-3 4) (vector 1 (cons e-2 4)))(else (vector 1 arg-6))))))))))))))))))))))))))))))))))
(define CoreC-45LinearCheck-n--10112-9500-u--combineUsages (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (if (null? arg-7) (vector 1 '()) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Argument usage lists inconsistent") clam-0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? arg-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Argument usage lists inconsistent") clam-0) (let ((e-6 (car arg-7))) (let ((e-7 (cdr arg-7))) (let ((act-1 ((CoreC-45LinearCheck-n--10112-9499-u--combineUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45LinearCheck-n--10112-9500-u--combineUsages arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-8))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CoreC-45LinearCheck-n--10112-9498-u--combine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (vector 1 '()) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-3) (vector 1 e-2) (let ((act-1 ((CoreC-45LinearCheck-n--10112-9498-u--combine arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45LinearCheck-n--10112-9500-u--combineUsages arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 e-5))) eff-0) clam-0))))))))))))
(define CoreC-45LinearCheck-n--8319-3775-u--showAll (lambda (arg-1 arg-3) (if (null? arg-3) "" (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (CoreC-45TTC-45Var-u--show_Show_C-40VarC-32C-36nsC-41 e-2) (string-append (CoreC-45TTC-45Var-u--show_Show_C-40VarC-32C-36nsC-41 e-2) (string-append ", " (CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 e-3)))))))))
(define CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 (lambda (arg-1) (string-append "[" (string-append (CoreC-45LinearCheck-n--8319-3775-u--showAll arg-1 arg-1) "]"))))
(define CoreC-45LinearCheck-n--10112-9497-u--checkUsageOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-10))) (cond ((equal? sc1 1) (let ((sc2 (cond ((equal? arg-9 1) (PreludeC-45Types-u--C-62_Ord_Nat arg-7 1)) (else 0)))) (cond ((equal? sc2 1) 1) (else (cond ((equal? arg-9 1) 0) (else (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-7 1))))))) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-6 arg-7 arg-8) ext-0)) (else (vector 1 (vector 0 )))))))
(define CoreC-45LinearCheck-n--10112-9503-u--isLocArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (if (null? arg-8) 0 (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (case (vector-ref e-2 0) ((0) (let ((e-8 (vector-ref e-2 3))) (let ((sc2 (or (and (= e-8 arg-7) 1) 0))) (cond ((equal? sc2 1) 1) (else (CoreC-45LinearCheck-n--10112-9503-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-3)))))) ((5) (let ((e-13 (vector-ref e-2 3))) (let ((e-14 (vector-ref e-2 4))) (CoreC-45LinearCheck-n--10112-9503-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (cons e-13 (cons e-14 e-3))))))(else (CoreC-45LinearCheck-n--10112-9503-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-3))))))))
(define CoreC-45LinearCheck-n--10112-9496-u--checkEnvUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-7) (lambda (clam-0) (vector 1 (vector 0 ))) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-8 (car arg-10))) (let ((e-9 (cdr arg-10))) (let ((u--used_in (CoreC-45LinearCheck-count arg-8 arg-11))) (lambda (eta-0) (let ((act-1 (let ((sc2 (AlgebraC-45Semiring-isLinear csegen-931 (CoreC-45TTC-45Binder-multiplicity e-8)))) (cond ((equal? sc2 1) ((CoreC-45LinearCheck-updateHoleUsage arg-5 arg-4 (or (and (= u--used_in 0) 1) 0) arg-8 '() arg-13) eta-0)) (else (vector 1 0)))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--used (let ((sc3 (let ((sc4 (AlgebraC-45Semiring-isLinear csegen-931 (AlgebraC-45ZeroOneOmega-rigMult (CoreC-45TTC-45Binder-multiplicity e-8) arg-9)))) (cond ((equal? sc4 1) (cond ((equal? e-5 1) (or (and (= u--used_in 0) 1) 0)) (else 0))) (else 0))))) (cond ((equal? sc3 1) 1) (else u--used_in))))) (lambda (eta-1) (let ((act-2 (CoreC-45LinearCheck-n--10112-9497-u--checkUsageOK arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (CoreC-45TTC-45Term-getLoc (CoreC-45TTC-45Binder-binderType e-8)) u--used e-2 (CoreC-45LinearCheck-n--10112-9503-u--isLocArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8 arg-12) (AlgebraC-45ZeroOneOmega-rigMult (CoreC-45TTC-45Binder-multiplicity e-8) arg-9) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((CoreC-45LinearCheck-n--10112-9496-u--checkEnvUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 (LibrariesC-45DataC-45SnocListC-45SizeOf-C-58C-60 arg-8) arg-9 e-9 arg-11 arg-12 arg-13) eta-1)))))))) eff-0) eta-0))))))))))))))
(define CoreC-45LinearCheck-n--14843-9568-u--elseCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 ext-0) (let ((act-1 ((CoreC-45LinearCheck-n--10112-9501-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-14 arg-19 arg-16 arg-18 arg-17) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((sc1 (AlgebraC-45Semiring-isErased csegen-931 arg-12))) (cond ((equal? sc1 1) (cons (cons arg-13 1) e-5)) (else (cons (cons arg-13 3) e-5)))))))) eff-0) ext-0)))))))
(define CoreC-45LinearCheck-n--10112-9501-u--getCaseUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-10) (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (if (null? arg-10) (lambda (eta-0) (vector 1 '())) (let ((e-11 (car arg-10))) (let ((e-12 (cdr arg-10))) (let ((sc4 (AlgebraC-45Semiring-isLinear csegen-931 e-7))) (cond ((equal? sc4 1) (lambda (clam-1) (case (vector-ref e-11 0) ((0) (let ((e-5 (vector-ref e-11 3))) (let ((act-1 ((CoreC-45LinearCheck-n--10112-9501-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4 arg-9 e-12 arg-11 arg-12) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-14 (vector-ref act-1 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--used_in (CoreC-45LinearCheck-count e-5 arg-11))) (lambda (eta-0) (let ((act-2 ((CoreC-45LinearCheck-updateHoleUsage arg-5 arg-4 (or (and (= u--used_in 0) 1) 0) e-5 '() arg-12) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ause (let ((sc8 (cond ((equal? e-15 1) (or (and (= u--used_in 0) 1) 0)) (else 0)))) (cond ((equal? sc8 1) 4) (else (let ((sc9 (or (and (= u--used_in 0) 1) 0))) (cond ((equal? sc9 1) 1) (else 2)))))))) (lambda (eta-1) (vector 1 (cons (cons e-2 u--ause) e-14)))))) eff-0) eta-0))))))))) eff-0) clam-1)))))))(else (CoreC-45LinearCheck-n--14843-9568-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 clam-1))))) (else (lambda (eta-0) (CoreC-45LinearCheck-n--14843-9568-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 eta-0)))))))))))))(else (lambda (eta-0) (vector 1 '())))))))))(else (lambda (eta-0) (vector 1 '())))) (let ((e-14 (car arg-10))) (let ((e-15 (cdr arg-10))) (case (vector-ref e-14 0) ((5) (let ((e-20 (vector-ref e-14 4))) (CoreC-45LinearCheck-n--10112-9501-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 (cons e-20 e-15) arg-11 arg-12)))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (if (null? arg-10) (lambda (eta-0) (vector 1 '())) (let ((e-11 (car arg-10))) (let ((e-12 (cdr arg-10))) (let ((sc4 (AlgebraC-45Semiring-isLinear csegen-931 e-7))) (cond ((equal? sc4 1) (lambda (clam-0) (case (vector-ref e-11 0) ((0) (let ((e-5 (vector-ref e-11 3))) (let ((act-1 ((CoreC-45LinearCheck-n--10112-9501-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4 arg-9 e-12 arg-11 arg-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-16 (vector-ref act-1 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--used_in (CoreC-45LinearCheck-count e-5 arg-11))) (lambda (eta-0) (let ((act-2 ((CoreC-45LinearCheck-updateHoleUsage arg-5 arg-4 (or (and (= u--used_in 0) 1) 0) e-5 '() arg-12) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-17 (vector-ref act-2 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ause (let ((sc8 (cond ((equal? e-17 1) (or (and (= u--used_in 0) 1) 0)) (else 0)))) (cond ((equal? sc8 1) 4) (else (let ((sc9 (or (and (= u--used_in 0) 1) 0))) (cond ((equal? sc9 1) 1) (else 2)))))))) (lambda (eta-1) (vector 1 (cons (cons e-2 u--ause) e-16)))))) eff-0) eta-0))))))))) eff-0) clam-0)))))))(else (CoreC-45LinearCheck-n--14843-9568-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 clam-0))))) (else (lambda (eta-0) (CoreC-45LinearCheck-n--14843-9568-u--elseCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-1 e-6 e-8 e-9 e-7 e-2 e-4 e-11 e-12 arg-12 arg-11 arg-9 eta-0)))))))))))))(else (lambda (eta-0) (vector 1 '())))))))))(else (lambda (eta-0) (vector 1 '())))))))))))
(define CoreC-45LinearCheck-n--10112-9502-u--getPUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45Normalise-logEnv e-2 arg-5 "quantity" 10 "Env" e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45ContextC-45Log-logTerm e-2 arg-5 "quantity" 10 (lambda () "LHS") e-10 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45ContextC-45Log-logTerm e-2 arg-5 "quantity" 5 (lambda () "Linear check in case RHS") e-11 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 ((CoreC-45LinearCheck-lcheck e-2 arg-5 arg-4 arg-2 0 e-6 e-11) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-13 (car e-12))) (let ((e-4 (cdr e-12))) (let ((e-14 (cdr e-4))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-5 "quantity" 10 (lambda () (string-append "Used: " (CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 e-14))) clam-1))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else (let ((u--args (CoreC-45TTC-45Term-getArgs e-10))) (let ((act-6 ((CoreC-45LinearCheck-n--10112-9496-u--checkEnvUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 0 arg-2 e-6 e-14 u--args e-13) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-17 (vector-ref act-6 1))) (vector 0 e-17))) (else (let ((act-7 ((CoreC-45LinearCheck-n--10112-9501-u--getCaseUsage arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 arg-6 e-6 u--args e-14 e-11) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-18 (vector-ref act-7 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-8 (CoreC-45ContextC-45Log-log arg-5 "quantity" 10 (lambda () (string-append "Arg usage: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2613 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2613 u--d u--x)))) e-18))) eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-19 (vector-ref act-8 1))) (vector 0 e-19))) (else (vector 1 e-18))))))) eff-0) clam-1)))))))))))))))))) eff-0) clam-0)))))))))))))))))))))))
(define CoreC-45LinearCheck-getArgUsage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45LinearCheck-n--10112-9502-u--getPUsage arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-4 eta-0)) arg-5 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45LinearCheck-n--10112-9498-u--combine arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setLinearCheck (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-1) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-1 (unbox e-6))) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-0 (vector 8 arg-1) (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 arg-2 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-1)) clam-0)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45LinearCheck-n--10142-11062-u--rigSafe (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (CoreC-45Context-getFullName arg-6 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (AlgebraC-45Preorder-C-60 csegen-2567 arg-7 arg-8))) (cond ((equal? sc1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 14 arg-4 e-5 arg-7 arg-8) clam-0)) (else (vector 1 (vector 0 )))))))) eff-0) ext-0)))))))
(define CoreC-45LinearCheck-n--10142-11063-u--updateUsage (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (if (null? arg-8) arg-9 (let ((e-1 (car arg-8))) (let ((e-2 (cdr arg-8))) (case (vector-ref arg-9 0) ((3) (let ((e-4 (vector-ref arg-9 1))) (let ((e-5 (vector-ref arg-9 2))) (let ((e-6 (vector-ref arg-9 3))) (let ((e-7 (vector-ref arg-9 4))) (case (vector-ref e-6 0) ((2) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (let ((e-11 (vector-ref e-6 3))) (let ((e-12 (vector-ref e-6 4))) (let ((u--scC-39 (CoreC-45LinearCheck-n--10142-11063-u--updateUsage arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-7))) (let ((u--cC-39 (cond ((equal? e-1 1) csegen-30) ((equal? e-1 2) csegen-1416) ((equal? e-1 4) e-10) ((equal? e-1 3) e-10) (else e-10)))) (vector 3 e-4 e-5 (vector 2 e-9 u--cC-39 e-11 e-12) u--scC-39))))))))(else arg-9)))))))(else arg-9)))))))
(define CoreC-45LinearCheck-case--lcheckDef-11324 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (if (null? arg-8) (CoreC-45Context-undefinedName arg-6 arg-4 arg-1 ext-0) (let ((e-1 (unbox arg-8))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 e-1) (let ((e-0 (vector-ref arg-7 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (CoreC-45Context-undefinedName arg-6 arg-4 arg-1 clam-1) (let ((e-2 (unbox e-5))) (let ((act-2 (CoreC-45LinearCheck-n--10142-11062-u--rigSafe arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-7 (vector-ref e-2 7))) e-7) arg-3 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((sc4 (let ((e-17 (vector-ref e-2 17))) e-17))) (cond ((equal? sc4 1) (vector 1 (let ((e-25 (vector-ref e-2 2))) e-25))) (else (let ((e-18 (vector-ref e-2 18))) (case (vector-ref e-18 0) ((1) (let ((e-27 (vector-ref e-18 5))) (let ((act-3 (CoreC-45LinearCheck-getArgUsage arg-6 arg-5 (CoreC-45TTC-45Term-getLoc (let ((e-52 (vector-ref e-2 2))) e-52)) arg-3 (let ((e-52 (vector-ref e-2 2))) e-52) e-27 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-32 (vector-ref act-3 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45ContextC-45Log-log arg-6 "quantity" 5 (lambda () (string-append "Overall arg usage " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2612 e-32))) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-33 (vector-ref act-4 1))) (vector 0 e-33))) (else (let ((u--tyC-39 (CoreC-45LinearCheck-n--10142-11063-u--updateUsage arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-32 (let ((e-54 (vector-ref e-2 2))) e-54)))) (let ((act-5 (CoreC-45Context-updateTy arg-6 e-1 u--tyC-39 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-34 (vector-ref act-5 1))) (vector 0 e-34))) (else (let ((act-6 (CoreC-45Context-setLinearCheck arg-6 e-1 1 eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-35 (vector-ref act-6 1))) (vector 0 e-35))) (else (let ((act-7 (CoreC-45ContextC-45Log-logTerm '() arg-6 "quantity" 5 (lambda () (string-append "New type of " (CoreC-45Name-u--show_Show_Name (let ((e-57 (vector-ref e-2 1))) e-57)))) u--tyC-39 eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-36 (vector-ref act-7 1))) (vector 0 e-36))) (else (let ((act-8 (CoreC-45ContextC-45Log-logTerm '() arg-6 "quantity" 5 (lambda () (string-append "Updated from " (CoreC-45Name-u--show_Show_Name (let ((e-58 (vector-ref e-2 1))) e-58)))) (let ((e-57 (vector-ref e-2 2))) e-57) eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-37 (vector-ref act-8 1))) (vector 0 e-37))) (else (vector 1 u--tyC-39)))))))))))))))))))) eff-0) clam-1)))))))(else (vector 1 (let ((e-47 (vector-ref e-2 2))) e-47)))))))))))))))) eff-0) ext-0)))))))))
(define CoreC-45LinearCheck-lcheckDef (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (cond ((equal? arg-5 1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (CoreC-45Context-undefinedName arg-1 arg-3 arg-7 clam-1) (let ((e-1 (unbox e-6))) (vector 1 (let ((e-2 (vector-ref e-1 2))) e-2))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))) (else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45LinearCheck-case--lcheckDef-11324 arg-7 arg-6 arg-4 arg-3 arg-2 arg-1 e-5 (CoreC-45Context-getNameID arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0)))) eff-0) ext-0)))))))))
(define CoreC-45LinearCheck-lcheckMeta (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-9) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 2 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45List-reverse arg-10)) (cons (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-5 arg-11) '())))))) eff-0) eta-0)))))) (let ((e-1 (car arg-9))) (let ((e-2 (cdr arg-9))) (case (vector-ref arg-11 0) ((0) (let ((e-7 (vector-ref arg-11 3))) (let ((e-8 (vector-ref arg-11 4))) (case (vector-ref e-7 0) ((2) (let ((e-11 (vector-ref e-7 2))) (let ((u--checkRig (AlgebraC-45ZeroOneOmega-rigMult e-11 arg-3))) (lambda (eta-0) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 u--checkRig arg-4 arg-5 e-1) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-4 (car e-9))) (let ((e-3 (cdr e-9))) (let ((e-14 (cdr e-3))) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-16 (vector-ref act-2 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-8 e-16) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-5 e-4)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-17 (vector-ref act-3 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--aerased (let ((sc8 (cond ((equal? arg-4 1) (AlgebraC-45Semiring-isErased csegen-931 e-11)) (else 0)))) (cond ((equal? sc8 1) (vector 10 arg-6 (vector 0 ))) (else e-4))))) (lambda (eta-2) (let ((act-4 ((CoreC-45LinearCheck-lcheckMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 (cons u--aerased arg-10) e-17) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-18 (vector-ref act-4 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-20 (car e-18))) (let ((e-19 (cdr e-18))) (let ((e-22 (car e-19))) (let ((e-21 (cdr e-19))) (vector 1 (cons e-20 (cons e-22 (CoreC-45LinearCheck-C-43C-43 e-14 e-21))))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-9 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-10 arg-5 arg-11 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-54 arg-7 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-68 e-11 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 (string-append "Linearity checking failed on metavar " (string-append (CoreC-45Name-u--show_Show_Name e-12) (string-append " (" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-13) " not a function type)"))))) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-6 arg-5 arg-11 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-54 arg-7 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-68 e-7 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 (string-append "Linearity checking failed on metavar " (string-append (CoreC-45Name-u--show_Show_Name e-8) (string-append " (" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-9) " not a function type)"))))) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define CoreC-45LinearCheck-n--10006-6391-u--checkUsageOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((sc0 (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-11))) (cond ((equal? sc1 1) (PreludeC-45Types-u--C-47C-61_Eq_Nat arg-10 1)) (else 0))))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 13 arg-4 arg-10 arg-1) ext-0)) (else (vector 1 (vector 0 )))))))
(define CoreC-45LinearCheck-n--10006-6392-u--eraseLinear (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-11) (if (null? arg-11) '() (let ((e-4 (car arg-11))) (let ((e-5 (cdr arg-11))) (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 (CoreC-45TTC-45Binder-multiplicity e-4)))) (cond ((equal? sc1 1) (cons (CoreC-45TTC-45Binder-setMultiplicity e-4 csegen-30) (CoreC-45LinearCheck-n--10006-6392-u--eraseLinear arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5))) (else (cons e-4 (CoreC-45LinearCheck-n--10006-6392-u--eraseLinear arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5))))))))))
(define CoreC-45LinearCheck-n--10006-6393-u--getZeroes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) '() (let ((e-3 (cdr arg-10))) (let ((e-8 (car arg-11))) (let ((e-9 (cdr arg-11))) (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 (CoreC-45TTC-45Binder-multiplicity e-8)))) (cond ((equal? sc2 1) (cons 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) (CoreC-45LinearCheck-n--10006-6393-u--getZeroes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 e-9)))) (else (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((sc3 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc3))) (((e-1 'erased) 'erased) eta-0)))) (CoreC-45LinearCheck-n--10006-6393-u--getZeroes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 e-9)))))))))))
(define CoreC-45LinearCheck-n--10006-7471-u--needFunctionType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-11 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-8 csegen-68 arg-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-8 csegen-68 e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-3 (string-append "Linearity checking failed on " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-6) (string-append " (" (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7) " not a function type)"))))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45LinearCheck-n--10006-6394-u--rig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-3 0) ((2) (let ((sc1 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc1 1) csegen-30) (else AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))) ((1) arg-7)(else (let ((sc0 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc0 1) csegen-30) (else csegen-1416)))))))
(define CoreC-45LinearCheck-n--10006-5542-u--getName (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (cond ((equal? arg-12 0) (let ((e-2 (car arg-13))) e-2))(else (let ((e-0 (- arg-12 1))) (let ((e-6 (cdr arg-13))) (CoreC-45LinearCheck-n--10006-5542-u--getName arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-0 e-6)))))))
(define CoreC-45LinearCheck-n--10006-5543-u--rigSafe (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((sc0 (AlgebraC-45Preorder-C-60 csegen-2567 arg-11 arg-12))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 14 arg-5 (CoreC-45LinearCheck-n--10006-5542-u--getName arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-0 arg-2) arg-11 arg-12) ext-0)) (else (vector 1 (vector 0 )))))))
(define CoreC-45LinearCheck-n--10006-5813-u--unusedHoleArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 arg-13) (if (null? arg-12) (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (CoreC-45LinearCheck-n--10006-5813-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-4)))))))(else arg-13)))))))(else arg-13)) (let ((e-12 (cdr arg-12))) (case (vector-ref arg-13 0) ((3) (let ((e-14 (vector-ref arg-13 1))) (let ((e-15 (vector-ref arg-13 2))) (let ((e-16 (vector-ref arg-13 3))) (let ((e-17 (vector-ref arg-13 4))) (case (vector-ref e-16 0) ((2) (let ((e-19 (vector-ref e-16 1))) (let ((e-21 (vector-ref e-16 3))) (let ((e-22 (vector-ref e-16 4))) (vector 3 e-14 e-15 (vector 2 e-19 csegen-30 e-21 e-22) (CoreC-45LinearCheck-n--10006-5813-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-12 e-17))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (CoreC-45LinearCheck-n--10006-5813-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-4)))))))(else arg-13)))))))(else arg-13)))))))))(else (case (vector-ref arg-13 0) ((3) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((1) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (vector 3 e-1 e-2 (vector 1 e-6 e-7 e-8 e-9) (CoreC-45LinearCheck-n--10006-5813-u--unusedHoleArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-4)))))))(else arg-13)))))))(else arg-13))))))))
(define CoreC-45LinearCheck-n--10006-5544-u--used (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((sc0 (AlgebraC-45Semiring-isLinear csegen-931 arg-11))) (cond ((equal? sc0 1) (cons arg-0 '())) (else '())))))
(define CoreC-45LinearCheck-lcheck (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 2))) (let ((e-4 (vector-ref arg-6 3))) (let ((u--b (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-0 e-4 arg-5))) (let ((u--rigb (CoreC-45TTC-45Binder-multiplicity u--b))) (let ((u--ty (CoreC-45TTC-45Binder-binderType u--b))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck Local") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 (cond ((equal? arg-4 1) (vector 1 (vector 0 ))) (else (CoreC-45LinearCheck-n--10006-5543-u--rigSafe e-4 arg-0 e-3 e-2 arg-5 arg-4 arg-3 arg-2 arg-1 u--rigb arg-3 eta-0))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (vector 1 (cons (vector 0 e-2 e-3 e-4) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 u--ty) (CoreC-45LinearCheck-n--10006-5544-u--used e-4 arg-0 e-3 e-2 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3)))))))))))))))))) ((1) (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (let ((e-9 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "quantity" 15 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-1 csegen-54 e-9 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "lcheck Ref " (cons (CoreC-45TTC-45Term-u--show_Show_NameType e-8) (cons " " (cons (CoreC-45Name-u--show_Show_Name e-5) '()))))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45LinearCheck-lcheckDef arg-1 arg-2 e-7 arg-3 arg-4 arg-5 e-9 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 1 e-7 e-8 e-9) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 e-6) '())))))) eff-0) eta-0))))))))))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck Meta") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact (vector 8 e-13) (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (CoreC-45Context-undefinedName arg-1 e-11 e-12 eta-2)) (let ((e-1 (unbox e-7))) (let ((u--expand (AlgebraC-45Semiring-branchZero csegen-931 (let ((e-2 (vector-ref e-1 2))) (case (vector-ref e-2 0) ((10) (lambda () 1))(else (lambda () 0)))) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((1) (lambda () 1))(else (lambda () 0)))) arg-3))) (lambda (eta-2) (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "quantity" 10 (lambda (eta-3) (let ((act-4 (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((1) (let ((e-34 (vector-ref e-18 2))) (let ((e-33 (vector-ref e-18 3))) (case (vector-ref e-33 0) ((1) (let ((e-36 (vector-ref e-33 2))) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-68 e-36 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-38 (vector-ref act-4 1))) (vector 0 e-38))) (else (let ((e-38 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 e-34 e-38))))) eff-0) eta-3)))))))(else (vector 1 ""))))))(else (vector 1 "")))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega arg-3) (string-append ": " (string-append (CoreC-45Name-u--show_Show_Name e-12) (string-append " " (string-append (CoreC-45FC-u--show_Show_FC e-11) (string-append "\xa;" (PreludeC-45Show-u--show_Show_String e-8))))))))))) eff-0) eta-3)))))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (cond ((equal? u--expand 1) ((CoreC-45LinearCheck-expandMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-12 e-13 (let ((e-18 (vector-ref e-1 18))) e-18) e-14) eta-2)) (else (let ((u--ty (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((7) (CoreC-45LinearCheck-n--10006-5813-u--unusedHoleArgs arg-0 e-14 e-13 e-12 e-11 arg-5 arg-4 arg-3 arg-2 arg-1 e-14 (let ((e-54 (vector-ref e-1 2))) e-54)))(else (let ((e-52 (vector-ref e-1 2))) e-52)))))) (let ((act-5 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-6 arg-5 u--ty) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45LinearCheck-lcheckMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-11 e-12 e-13 e-14 '() e-9))) eff-0) eta-2))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck Bind") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45UnifyState-handleUnify arg-1 arg-2 0 (lambda (eta-1) (CoreC-45LinearCheck-lcheckBinder arg-0 arg-1 arg-2 (CoreC-45LinearCheck-n--10006-6394-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1) arg-4 arg-5 e-18 eta-1)) (lambda (u--err) (case (vector-ref u--err 0) ((14) (lambda (eta-1) (CoreC-45LinearCheck-lcheckBinder arg-0 arg-1 arg-2 (CoreC-45LinearCheck-n--10006-6394-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1) arg-4 arg-5 (CoreC-45TTC-45Binder-setMultiplicity e-18 csegen-1416) eta-1)))(else (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-1))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--envC-39 (let ((sc5 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega arg-3 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) (cond ((equal? sc5 1) (case (vector-ref e-18 0) ((0) (CoreC-45LinearCheck-n--10006-6392-u--eraseLinear arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1 arg-5))(else arg-5))) (else arg-5))))) (lambda (eta-1) (let ((act-3 ((CoreC-45LinearCheck-lcheck (cons e-17 arg-0) arg-1 arg-2 (CoreC-45LinearCheck-n--10006-6394-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1) arg-4 (cons e-2 u--envC-39) e-19) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (let ((u--used_in (CoreC-45LinearCheck-count 0 e-11))) (lambda (eta-2) (let ((act-4 (let ((sc8 (cond ((equal? arg-4 1) 0) (else (AlgebraC-45Semiring-isLinear csegen-931 (CoreC-45TTC-45Binder-multiplicity e-18)))))) (cond ((equal? sc8 1) ((CoreC-45LinearCheck-updateHoleUsage arg-1 arg-2 (or (and (= u--used_in 0) 1) 0) 0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (let ((sc9 CoreC-45TTC-45Var-WeakenVar)) (let ((e-1 (car sc9))) (((e-1 'erased) 'erased) eta-3)))) (CoreC-45LinearCheck-n--10006-6393-u--getZeroes arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--envC-39)) e-10) eta-2)) (else (vector 1 0)))))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--used (let ((sc9 (let ((sc10 (AlgebraC-45Semiring-isLinear csegen-931 (AlgebraC-45ZeroOneOmega-rigMult (CoreC-45TTC-45Binder-multiplicity e-18) (CoreC-45LinearCheck-n--10006-6394-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1))))) (cond ((equal? sc10 1) (cond ((equal? e-13 1) (or (and (= u--used_in 0) 1) 0)) (else 0))) (else 0))))) (cond ((equal? sc9 1) 1) (else u--used_in))))) (lambda (eta-3) (let ((act-5 (cond ((equal? arg-4 1) (vector 1 (vector 0 ))) (else (CoreC-45LinearCheck-n--10006-6391-u--checkUsageOK arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1 u--used (AlgebraC-45ZeroOneOmega-rigMult (CoreC-45TTC-45Binder-multiplicity e-18) (CoreC-45LinearCheck-n--10006-6394-u--rig arg-0 e-17 e-19 e-18 e-16 arg-5 arg-4 arg-3 arg-2 arg-1)) eta-3))))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45LinearCheck-discharge arg-0 e-15 arg-5 e-16 e-17 e-2 e-8 e-10 e-12 (CoreC-45LinearCheck-C-43C-43 e-7 (CoreC-45LinearCheck-doneScope e-11)) eta-4)))) eff-0) eta-3)))))))))))) eff-0) eta-2))))))))))))) eff-0) eta-1))))))))))))) eff-0) eta-0)))))))))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "quantity" 15 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-1 csegen-68 e-22 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 (CoreC-45Context-toFullNames arg-1 csegen-68 e-23 eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-4) eta-4) (cons "lcheck App " (cons (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-5) (cons " " (cons (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-6) '()))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-22) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-8) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (case (vector-ref e-10 0) ((0) (let ((e-11 (vector-ref e-10 3))) (let ((e-4 (vector-ref e-10 4))) (case (vector-ref e-11 0) ((2) (let ((e-14 (vector-ref e-11 2))) (let ((e-16 (vector-ref e-11 4))) (let ((u--checkRig (AlgebraC-45ZeroOneOmega-rigMult e-14 arg-3))) (lambda (eta-2) (let ((act-5 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 u--checkRig arg-4 arg-5 e-23) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-19 (car e-17))) (let ((e-18 (cdr e-17))) (let ((e-24 (car e-18))) (let ((e-20 (cdr e-18))) (let ((act-6 (((e-4 e-9) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-5 e-19)) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-25 (vector-ref act-6 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--aerased (let ((sc13 (cond ((equal? arg-4 1) (AlgebraC-45Semiring-isErased csegen-931 e-14)) (else 0)))) (cond ((equal? sc13 1) (vector 10 e-21 (vector 0 ))) (else e-19))))) (lambda (eta-3) (let ((act-7 (CoreC-45Context-getSession arg-1 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-26 (vector-ref act-7 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (let ((sc14 (let ((e-40 (vector-ref e-26 11))) e-40))) (cond ((equal? sc14 1) (let ((act-8 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-24) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-27 (vector-ref act-8 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 e-9 e-16) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-28 (vector-ref act-9 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 (CoreC-45NormaliseC-45Convert-u--convert_Convert_NF arg-1 arg-0 e-9 arg-5 e-27 e-28 eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-29 (vector-ref act-10 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-10 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-29 1) (vector 1 (vector 0 ))) (else (let ((act-11 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-1 arg-0 e-9 arg-5 e-16 clam-2))) (case (vector-ref act-11 0) ((0) (let ((e-30 (vector-ref act-11 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-12 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-9 arg-5 e-27 eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-31 (vector-ref act-12 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 arg-0 e-21 (let ((e-0 (vector-ref e-9 0))) e-0) arg-5 e-30 e-31) eta-8)))) eff-0) eta-7)))))))) eff-0) clam-2)))))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-8 0) ((0) (let ((e-27 (vector-ref act-8 1))) (vector 0 e-27))) (else (vector 1 (cons (vector 4 e-21 e-2 u--aerased) (cons (CoreC-45Normalise-glueBack arg-1 arg-0 e-9 arg-5 e-25) (CoreC-45LinearCheck-C-43C-43 e-7 e-20)))))))))) eff-0) eta-3))))))))) eff-0) clam-1)))))))))))) eff-0) eta-2))))))))))(else (lambda (eta-2) (CoreC-45LinearCheck-n--10006-7471-u--needFunctionType arg-0 e-23 e-22 e-21 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-8 eta-2))))))) ((1) (let ((e-12 (vector-ref e-10 2))) (lambda (clam-2) (case (vector-ref e-12 0) ((1) (let ((e-19 (vector-ref e-12 2))) (let ((act-5 ((CoreC-45Context-lookupCtxtExact e-19 (let ((e-0 (vector-ref e-9 0))) e-0)) clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-14) (CoreC-45Context-undefinedName arg-1 e-21 e-19 clam-3) (let ((act-6 ((CoreC-45NormaliseC-45Eval-getTerm e-8) clam-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-2) (CoreC-45LinearCheck-n--10006-7471-u--needFunctionType arg-0 e-23 e-22 e-21 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-8 eta-2)))) eff-0) clam-3)))))))) eff-0) clam-2)))))))(else (CoreC-45LinearCheck-n--10006-7471-u--needFunctionType arg-0 e-23 e-22 e-21 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-8 clam-2)))))) ((9) (let ((e-11 (vector-ref e-10 2))) (lambda (clam-3) (case (vector-ref e-11 0) ((0) (let ((act-5 (cond ((equal? arg-4 1) (vector 1 (vector 0 ))) (else (CoreC-45LinearCheck-n--10006-7471-u--needFunctionType arg-0 e-23 e-22 e-21 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-8 clam-3))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (vector 1 (cons (vector 4 e-21 e-22 e-23) (cons (CoreC-45NormaliseC-45Eval-gErased e-21) '())))))))(else (CoreC-45LinearCheck-n--10006-7471-u--needFunctionType arg-0 e-23 e-22 e-21 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-8 clam-3))))))(else (lambda (eta-2) (CoreC-45LinearCheck-n--10006-7471-u--needFunctionType arg-0 e-23 e-22 e-21 arg-5 arg-4 arg-3 arg-2 arg-1 e-2 e-8 eta-2)))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))))) eff-0) eta-0))))))))))))) ((5) (let ((e-25 (vector-ref arg-6 1))) (let ((e-26 (vector-ref arg-6 2))) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck As") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-27) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-28) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((e-12 (car e-4))) (let ((e-11 (cdr e-4))) (vector 1 (cons (vector 5 e-25 e-26 e-2 e-10) (cons e-12 e-11)))))))))) eff-0) clam-4)))))))))) eff-0) eta-0)))))))))))))) ((6) (let ((e-30 (vector-ref arg-6 1))) (let ((e-31 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck Delayed") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-32) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-6) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-7 (cdr e-3))) (vector 1 (cons (vector 6 e-30 e-31 e-2) (cons (CoreC-45NormaliseC-45Eval-gType e-30 (vector 2 "top" 0)) e-7))))))))) eff-0) eta-0))))))))))))) ((7) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 csegen-30 arg-4 arg-5 e-36) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-7) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-37) clam-7))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-8) (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((e-11 (car e-4))) (let ((e-10 (cdr e-4))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-11) clam-8))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 7 e-34 e-35 e-2 e-9) (cons (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-5 (vector 6 e-34 e-35 e-12)) e-10)))))) eff-0) clam-8)))))))))))) eff-0) clam-7)))))))))) eff-0) eta-0))))))))))) ((8) (let ((e-39 (vector-ref arg-6 1))) (let ((e-41 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck Force") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-41) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-9) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-8) clam-9))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-10) (case (vector-ref e-9 0) ((5) (let ((e-10 (vector-ref e-9 2))) (let ((e-4 (vector-ref e-9 3))) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 8 e-39 e-10 e-2) (cons (CoreC-45Normalise-glueBack arg-1 arg-0 e-11 arg-5 e-4) e-7)))))) eff-0) clam-10))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-39 "Not a delayed type") clam-10)))))) eff-0) clam-9)))))))))))) eff-0) eta-0)))))))))))) ((9) (let ((e-43 (vector-ref arg-6 1))) (let ((e-44 (vector-ref arg-6 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck PrimVal") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 9 e-43 e-44) (cons (CoreC-45NormaliseC-45Eval-gErased e-43) '())))))))))) ((10) (let ((e-46 (vector-ref arg-6 1))) (let ((e-47 (vector-ref arg-6 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck Erased") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 10 e-46 e-47) (cons (CoreC-45NormaliseC-45Eval-gErased e-46) '())))))))))) (else (let ((e-49 (vector-ref arg-6 1))) (let ((e-50 (vector-ref arg-6 2))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "quantity" 15 (lambda () "lcheck TType") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 11 e-49 e-50) (cons (CoreC-45NormaliseC-45Eval-gType e-49 (vector 2 "top" 0)) '())))))))))))))
(define CoreC-45LinearCheck-linearCheck (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "quantity" 5 (lambda () "Linearity check on ") arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Normalise-logEnv arg-0 arg-1 "quantity" 5 "In env" arg-6 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45LinearCheck-lcheck arg-0 arg-1 arg-2 arg-4 arg-5 arg-6 arg-7) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((e-8 (cdr e-3))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "quantity" 5 (lambda () (string-append "Used: " (CoreC-45LinearCheck-u--show_Show_C-40UsageC-32C-36varsC-41 e-8))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (cond ((equal? arg-5 1) (vector 1 (vector 0 ))) (else ((CoreC-45LinearCheck-checkEnvUsage arg-0 arg-1 arg-2 arg-3 0 arg-4 arg-6 e-8 e-2) clam-0))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))))))) eff-0) ext-0)))))))))))))
(define TTImpC-45ProcessDef-n--25543-15215-u--toErased (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45LinearCheck-linearCheck e-2 arg-6 arg-4 arg-7 csegen-1416 1 e-6 e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Transform-applyTransforms arg-6 e-6 e-11) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45PartialEval-applySpecialise e-2 arg-6 arg-5 arg-4 arg-3 arg-2 e-6 arg-8 e-8) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45LinearCheck-linearCheck e-2 arg-6 arg-4 arg-7 csegen-1416 1 e-6 e-9 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-2 (cons e-6 (cons e-5 e-12))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32mkRunTime-15580 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) (let ((e-0 (vector-ref arg-11 1))) (let ((e-1 (vector-ref arg-11 2))) (let ((e-2 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 5))) (let ((u--ty (let ((e-25 (vector-ref arg-8 2))) e-25))) (lambda () (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45ProcessDef-n--25543-15215-u--toErased arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-27 (vector-ref arg-8 0))) e-27) (TTImpC-45ProcessDef-n--25543-15209-u--getSpec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-12 (vector-ref arg-8 12))) e-12)) eta-1)) e-4 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--clauses_init (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (TTImpC-45ProcessDef-n--25543-15214-u--toClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-28 (vector-ref arg-8 0))) e-28) eta-1)) e-5))) (lambda (eta-1) (let ((act-2 (case (vector-ref arg-10 0) ((1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-6 "compile.casetree.missing" 5 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Adding uncovered error to " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2619 u--clauses_init) '())))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (vector 1 (TTImpC-45ProcessDef-n--25543-15207-u--addErrorCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--clauses_init))))))(else (vector 1 u--clauses_init))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45CaseC-45CaseBuilder-getPMDef arg-6 (let ((e-29 (vector-ref arg-8 0))) e-29) '() arg-0 u--ty e-6 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-9 (car e-7))) (let ((e-8 (cdr e-7))) (let ((e-11 (car e-8))) (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "compile.casetree" 5 (lambda (eta-3) (let ((act-4 (CoreC-45Context-toFullNames arg-6 csegen-2622 e-11 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (DataC-45String-fastUnlines (cons (string-append (CoreC-45TT-u--show_Show_Covering arg-10) ":") (cons (string-append "Runtime tree for " (string-append (CoreC-45Name-u--show_Show_Name (let ((e-34 (vector-ref arg-8 1))) e-34)) ":")) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Raw-prettyTree e-9 e-12))) '())))))))) eff-0) eta-3)))))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((act-5 (CoreC-45ContextC-45Log-log arg-6 "compile.casetree" 10 (lambda () (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-9 e-11)) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-6 "compile.casetree.measure" 15 (lambda () (PreludeC-45Show-u--show_Show_Nat (CoreC-45CaseC-45CaseTree-measure e-11))) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((sc9 (TTImpC-45ProcessDef-nameListEq e-1 e-9))) (if (null? sc9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "WAT") clam-0) (let ((act-7 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Context-addDef arg-6 arg-0 (let ((e-38 (vector-ref arg-8 0))) (let ((e-37 (vector-ref arg-8 1))) (let ((e-36 (vector-ref arg-8 2))) (let ((e-35 (vector-ref arg-8 3))) (let ((e-34 (vector-ref arg-8 4))) (let ((e-33 (vector-ref arg-8 5))) (let ((e-32 (vector-ref arg-8 6))) (let ((e-31 (vector-ref arg-8 7))) (let ((e-30 (vector-ref arg-8 8))) (let ((e-29 (vector-ref arg-8 9))) (let ((e-28 (vector-ref arg-8 10))) (let ((e-27 (vector-ref arg-8 11))) (let ((e-26 (vector-ref arg-8 12))) (let ((e-25 (vector-ref arg-8 13))) (let ((e-24 (vector-ref arg-8 14))) (let ((e-23 (vector-ref arg-8 15))) (let ((e-16 (vector-ref arg-8 16))) (let ((e-17 (vector-ref arg-8 17))) (let ((e-19 (vector-ref arg-8 19))) (let ((e-20 (vector-ref arg-8 20))) (let ((e-21 (vector-ref arg-8 21))) (let ((e-22 (vector-ref arg-8 22))) (vector e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-16 e-17 (vector 1 e-0 e-1 e-2 e-11 e-4) e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-3)) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-16 (vector-ref act-7 1))) (vector 0 e-16))) (else (let ((act-8 (CoreC-45Context-toFullNames arg-6 csegen-54 arg-0 clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-17 (vector-ref act-8 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc12 (let ((sc13 (TTImpC-45ProcessDef-n--25543-15208-u--caseName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-17))) (cond ((equal? sc13 1) (TTImpC-45ProcessDef-n--25543-15213-u--noInline arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (let ((e-28 (vector-ref arg-8 12))) e-28))) (else 0))))) (cond ((equal? sc12 1) (let ((act-9 (TTImpC-45ElabC-45Utils-canInlineCaseBlock arg-6 arg-0 clam-1))) (case (vector-ref act-9 0) ((0) (let ((e-18 (vector-ref act-9 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-18 1) (let ((act-10 (CoreC-45ContextC-45Log-unverifiedLogC arg-6 "compiler.inline.eval" 5 (lambda (eta-3) (let ((act-10 (CoreC-45Context-toFullNames arg-6 csegen-54 arg-0 eta-3))) (case (vector-ref act-10 0) ((0) (let ((e-19 (vector-ref act-10 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-5) eta-5) (cons "Marking " (cons (CoreC-45Name-u--show_Show_Name e-19) (cons " for inlining in runtime case tree." '())))))))) eff-0) eta-3)))))) clam-2))) (case (vector-ref act-10 0) ((0) (let ((e-19 (vector-ref act-10 1))) (vector 0 e-19))) (else (CoreC-45Context-setFlag arg-6 arg-1 arg-0 (vector 0 ) clam-2))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-1)))))) (else (vector 1 (vector 0 )))))))) eff-0) clam-0))))))))))))))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))))))(else (lambda () (lambda (eta-0) (vector 1 (vector 0 ))))))))
(define TTImpC-45ProcessDef-mkRunTime (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "compile.casetree" 5 (lambda (eta-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-6 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (string-append "Making run time definition for " (CoreC-45Name-u--show_Show_Name e-5)))))) eff-0) eta-0)))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-6 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-7))) (let ((u--cov (let ((e-10 (vector-ref e-1 10))) (let ((e-27 (cdr e-10))) e-27)))) (let ((sc4 (AlgebraC-45Semiring-isErased csegen-931 (let ((e-23 (vector-ref e-1 7))) e-23)))) (cond ((equal? sc4 1) (lambda (eta-1) (vector 1 (vector 0 )))) (else ((let ((_-0 (box e-1))) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32mkRunTime-15580 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-6 e-1 _-0 u--cov (let ((e-18 (vector-ref e-1 18))) e-18)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessDef-compileRunTime (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessDef-mkRunTime arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) (let ((e-21 (vector-ref e-5 21))) e-21)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessDef-calcRefs arg-0 1 arg-6 eta-1 eta-2))) (let ((e-21 (vector-ref e-5 21))) e-21)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-0))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-0 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-36 (vector-ref e-8 5))) (let ((e-35 (vector-ref e-8 6))) (let ((e-34 (vector-ref e-8 7))) (let ((e-33 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-31 (vector-ref e-8 31))) (let ((e-32 (vector-ref e-8 32))) (vector e-0 e-1 e-2 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 '() e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))) eta-0)))))))))) eff-0) ext-0)))))))
(define PreludeC-45Interfaces-C-62C-61C-62 (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (arg-5 ext-0)) arg-6))))
(define TTImpC-45TTImp-isExplicit (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (box (cons e-1 e-2)))))(else '()))))
(define TTImpC-45TTImp-isIBindVar (lambda (arg-1) (case (vector-ref arg-1 0) ((17) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (box (cons e-1 e-2)))))(else '()))))
(define TTImpC-45TTImp-isIVar (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (box (cons e-1 e-2)))))(else '()))))
(define TTImpC-45ProcessDef-isAlias (lambda (arg-0) (let ((sc0 (TTImpC-45TTImp-getFnArgs arg-0 '()))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45TTImp-isIVar e-2) (lambda (u--hd) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (eta-0) (PreludeC-45Interfaces-C-62C-61C-62 csegen-2648 (lambda (eta-1) (TTImpC-45TTImp-isExplicit eta-1)) (lambda (clam-0) (let ((e-5 (car clam-0))) (let ((e-4 (cdr clam-0))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (box csegen-182) (box e-5)) (TTImpC-45TTImp-isIBindVar e-4))))) eta-0)) e-3) (lambda (u--args) (box (cons u--hd u--args)))))))))))
(define CoreC-45Metadata-addTyDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getFullName arg-1 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (CoreC-45FC-isNonEmptyFC arg-3))) (if (null? sc2) (vector 1 (vector 0 )) (let ((e-1 (unbox sc2))) (let ((act-3 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-12 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-12 (cons (cons e-1 (cons e-6 (cons (CoreC-45Env-length arg-5) (CoreC-45Env-bindEnv arg-0 arg-3 arg-5 arg-6)))) e-2) e-3 e-4 e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-3)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessType-checkForShadowing (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (if (null? e-4) '() (let ((e-8 (unbox e-4))) (case (vector-ref e-8 0) ((1) (let ((e-9 (vector-ref e-8 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (let ((u--argShadowing (TTImpC-45ProcessType-checkForShadowing LibrariesC-45DataC-45StringMap-empty e-5))) (PreludeC-45TypesC-45List-tailRecAppend (let ((sc4 (LibrariesC-45DataC-45StringMap-lookup e-10 arg-0))) (if (null? sc4) (TTImpC-45ProcessType-checkForShadowing (LibrariesC-45DataC-45StringMap-insert e-10 e-1 arg-0) e-6) (let ((e-7 (unbox sc4))) (cons (cons e-10 (cons e-7 e-1)) (TTImpC-45ProcessType-checkForShadowing arg-0 e-6))))) u--argShadowing))))(else '()))))(else '())))))))))(else '()))))
(define TTImpC-45ProcessType-n--11712-2221-u--findInfs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 arg-3) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (TTImpC-45ProcessType-n--11712-2221-u--findInfs arg-0 arg-1 arg-2 arg-3 arg-4 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ProcessType-n--11712-2220-u--findInf arg-0 arg-1 arg-2 e-5 arg-4 e-2))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessType-case--findInferrableC-44findInf-2271 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (vector 1 arg-6) (let ((e-2 (unbox arg-7))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 e-2 arg-6))) (cond ((equal? sc1 1) (vector 1 arg-6)) (else (vector 1 (cons e-2 arg-6))))))))))
(define TTImpC-45ProcessType-n--11712-2220-u--findInf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (case (vector-ref e-2 0) ((1) (let ((e-21 (vector-ref e-2 1))) (let ((e-22 (vector-ref e-2 2))) (case (vector-ref e-21 0) ((0) (if (null? e-3) (TTImpC-45ProcessType-case--findInferrableC-44findInf-2271 arg-0 arg-1 arg-2 e-1 e-22 arg-4 arg-3 (DataC-45List-lookup csegen-832 e-22 arg-4)) (lambda (eta-0) (vector 1 arg-3))))(else (lambda (eta-0) (vector 1 arg-3)))))))(else (lambda (eta-0) (vector 1 arg-3)))))))) ((2) (let ((e-9 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 (Builtin-snd eta-1))) e-9 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ProcessType-n--11712-2221-u--findInfs arg-0 arg-1 arg-2 arg-3 arg-4 e-10 eta-1)))) eff-0) eta-0)))))))) ((3) (let ((e-15 (vector-ref arg-5 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 (Builtin-snd eta-1))) e-15 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ProcessType-n--11712-2221-u--findInfs arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-1)))) eff-0) eta-0)))))))) ((5) (let ((e-19 (vector-ref arg-5 3))) (TTImpC-45ProcessType-n--11712-2220-u--findInf arg-0 arg-1 arg-2 arg-3 arg-4 e-19)))(else (lambda (eta-0) (vector 1 arg-3))))))
(define TTImpC-45ProcessType-n--11712-2219-u--fi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((u--argn (vector 2 "inf" arg-4))) (lambda (eta-0) (let ((act-1 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-1 (vector 0 ) u--argn))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 e-9) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessType-n--11712-2220-u--findInf arg-0 arg-1 arg-2 arg-6 arg-5 e-10))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45ProcessType-n--11712-2219-u--fi arg-0 arg-1 arg-2 (+ arg-3 1) (bs+ (blodwen-toSignedInt 1 63) arg-4 63) (cons (cons u--argn arg-3) arg-5) e-10 e-5) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 e-11)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))(else (TTImpC-45ProcessType-n--11712-2220-u--findInf arg-0 arg-1 arg-2 arg-6 arg-5 arg-7)))))))(else (TTImpC-45ProcessType-n--11712-2220-u--findInf arg-0 arg-1 arg-2 arg-6 arg-5 arg-7)))))
(define TTImpC-45ProcessType-findInferrable (lambda (arg-0 arg-1 arg-2) (TTImpC-45ProcessType-n--11712-2219-u--fi arg-2 arg-1 arg-0 0 0 '() '() arg-2)))
(define CoreC-45Context-addUserHole (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 (LibrariesC-45DataC-45NameMap-insert arg-2 arg-1 e-25) e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ProcessType-getFnString (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((28) (let ((e-2 (vector-ref arg-5 2))) (case (vector-ref e-2 0) ((10) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (let ((act-1 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[foreign]")) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fc (TTImpC-45TTImp-getFC arg-5))) (let ((u--gstr (CoreC-45NormaliseC-45Eval-gnf '() '() (vector 9 u--fc (vector 13 10))))) (lambda (eta-0) (let ((act-2 (TTImpC-45Elab-checkTerm '() arg-0 arg-1 arg-2 arg-3 arg-4 e-5 (vector 2 ) '() '() '() arg-5 u--gstr eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-7 '() e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-8 0) ((8) (let ((e-3 (vector-ref e-8 2))) (case (vector-ref e-3 0) ((10) (let ((e-9 (vector-ref e-3 1))) (vector 1 e-9)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--fc "%foreign calling convention must evaluate to a String") clam-1)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--fc "%foreign calling convention must evaluate to a String") clam-1)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) eff-0) clam-0)))))))))(else (let ((act-1 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[foreign]")) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fc (TTImpC-45TTImp-getFC arg-5))) (let ((u--gstr (CoreC-45NormaliseC-45Eval-gnf '() '() (vector 9 u--fc (vector 13 10))))) (lambda (eta-0) (let ((act-2 (TTImpC-45Elab-checkTerm '() arg-0 arg-1 arg-2 arg-3 arg-4 e-5 (vector 2 ) '() '() '() arg-5 u--gstr eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-7 '() e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-8 0) ((8) (let ((e-2 (vector-ref e-8 2))) (case (vector-ref e-2 0) ((10) (let ((e-3 (vector-ref e-2 1))) (vector 1 e-3)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--fc "%foreign calling convention must evaluate to a String") clam-2)))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 u--fc "%foreign calling convention must evaluate to a String") clam-2)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) eff-0) clam-0))))))))))
(define TTImpC-45ProcessType-n--11327-1977-u--getConvention (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((sc0 (DataC-45String-split csegen-1079 arg-12))) (if (null? sc0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Invalid calling convention") eta-0)) (let ((e-1 (car sc0))) (let ((e-2 (cdr sc0))) (lambda (clam-0) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Invalid calling convention") clam-0) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 1 (cons (DataC-45String-trim e-1) (DataC-45String-trim e-4))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Invalid calling convention") clam-0))))))))))))
(define TTImpC-45ProcessType-initDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-addUserHole arg-1 0 arg-7) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (case (vector-ref e-2 0) ((7) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Normalise-getArity arg-1 arg-0 e-5 arg-8 arg-9 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 2 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((8) (let ((e-6 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Normalise-getArity arg-1 arg-0 e-5 arg-8 arg-9 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (TTImpC-45ProcessType-getFnString arg-1 arg-2 arg-3 arg-4 arg-5 eta-3)) e-6 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 3 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((9) (let ((e-8 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45ProcessType-getFnString arg-1 arg-2 arg-3 arg-4 arg-5 eta-1)) e-8 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45ProcessType-n--11327-1977-u--getConvention arg-0 e-8 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-2)) e-5 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 (set-box! arg-1 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-38 (vector-ref e-7 2))) (let ((e-37 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-36 (vector-ref e-7 5))) (let ((e-35 (vector-ref e-7 6))) (let ((e-34 (vector-ref e-7 7))) (let ((e-33 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (let ((e-12 (vector-ref e-7 12))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (let ((e-25 (vector-ref e-7 25))) (let ((e-26 (vector-ref e-7 26))) (let ((e-27 (vector-ref e-7 27))) (let ((e-28 (vector-ref e-7 28))) (let ((e-29 (vector-ref e-7 29))) (let ((e-30 (vector-ref e-7 30))) (let ((e-31 (vector-ref e-7 31))) (let ((e-32 (vector-ref e-7 32))) (vector e-0 e-1 e-38 e-37 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 (LibrariesC-45DataC-45NameMap-insert arg-7 e-6 e-31) e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else ((TTImpC-45ProcessType-initDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3) eta-3))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))(else (TTImpC-45ProcessType-initDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3))))))))
(define TTImpC-45TTImp-isTotalityReq (lambda (arg-1) (case (vector-ref arg-1 0) ((11) 1)(else 0))))
(define CoreC-45Context-addGlobalHint (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-7 (LibrariesC-45DataC-45NameMap-insert e-5 arg-2 e-8) e-9 e-10 e-11 (cons (cons e-5 arg-2) e-12) e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addLocalHint (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-7 e-8 e-9 (LibrariesC-45DataC-45NameMap-insert e-5 (vector 0 ) e-10) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessFnOpt-getRetTy (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-0) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-getRetTy arg-0 e-5))) eff-0) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-1) "Can only add hints for concrete return types") clam-0))))))) ((3) (let ((e-7 (vector-ref arg-1 2))) (vector 1 e-7)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45Value-getLoc arg-1) "Can only add hints for concrete return types") clam-0))))))
(define CoreC-45Context-setIsEscapeHatch (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 1 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-2)) eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-hasFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (vector 1 (PreludeC-45Types-elem csegen-14 csegen-1319 arg-3 (let ((e-12 (vector-ref e-1 12))) e-12)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessFnOpt-throwIfHasFlag (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-hasFlag arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 arg-4) clam-0)) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-1 (vector 0 ) e-2))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-1))) (cond ((equal? sc5 1) (TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps arg-0 arg-1 arg-2 arg-3 arg-4 e-11)) (else (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-4 '() e-10 '() e-9 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--deps (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 1 (vector 2 )) e-12)))) (lambda (eta-3) (let ((act-5 ((TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps arg-0 arg-1 arg-2 arg-3 arg-4 e-11) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-13 u--deps))))) eff-0) eta-3))))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ProcessFnOpt-n--8247-13709-u--getDepsArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (if (null? arg-6) (vector 1 arg-7) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 ((TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 arg-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ProcessFnOpt-n--8247-13709-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 e-5 eta-0)))) eff-0) ext-0))))))))))
(define TTImpC-45ProcessFnOpt-n--8487-14198-u--splitPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (cons '() '()) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (let ((sc1 (TTImpC-45ProcessFnOpt-n--8487-14198-u--splitPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (+ arg-12 1) arg-13 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-12 arg-13))) (cond ((equal? sc2 1) (cons (cons e-2 e-5) e-4)) (else (cons e-5 (cons e-2 e-4)))))))))))))
(define TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-29 (vector-ref e-3 4))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 e-29) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 arg-7))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-3 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 e-6))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 (CoreC-45TTC-45Binder-binderType e-3)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 0 e-6 arg-7))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-3 (vector 0 )))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 0 e-7 arg-7))) eff-0) eta-1)))))))) eff-0) eta-0))))))) eff-0) clam-0))))))))))) ((1) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-31 (vector-ref e-7 1))) (let ((e-32 (vector-ref e-7 2))) (case (vector-ref e-31 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 (Builtin-snd eta-1))) e-8 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ProcessFnOpt-n--8247-13709-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 0 e-9 arg-7 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45DataC-45NameMap-insert e-32 arg-5 e-9))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 arg-7))))))(else (vector 1 arg-7))))))) ((2) (let ((e-14 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 (Builtin-snd eta-2))) e-14 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45ProcessFnOpt-n--8247-13709-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 0 e-6 arg-7 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (CoreC-45Context-lookupDefExact e-17 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (unbox e-6))) (case (vector-ref e-1 0) ((6) (let ((e-4 (vector-ref e-1 3))) (vector 1 e-4)))(else (vector 1 '())))))))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc3 (TTImpC-45ProcessFnOpt-n--8487-14198-u--splitPs arg-0 arg-1 arg-2 arg-3 arg-4 e-16 e-20 e-19 e-18 e-17 arg-7 arg-5 0 e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) e-20)))) (let ((e-2 (car sc3))) (let ((e-3 (cdr sc3))) (let ((act-3 (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 eta-2)) e-2 '()) clam-3))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45ProcessFnOpt-n--8247-13709-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 1 e-7 arg-7 eta-2)))) eff-0) clam-3))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 eta-3)) e-3 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45ProcessFnOpt-n--8247-13709-u--getDepsArgs arg-0 arg-1 arg-2 arg-3 arg-4 0 e-8 e-7 eta-3)))) eff-0) eta-2)))))))) eff-0) clam-3))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((5) (let ((e-24 (vector-ref arg-6 3))) (TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24 arg-7)))(else (lambda (eta-0) (vector 1 arg-7))))))
(define TTImpC-45ProcessFnOpt-case--processFnOptC-44insertDeps-13739 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (TTImpC-45ProcessFnOpt-n--8247-13711-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 arg-7 arg-6) (let ((e-2 (unbox arg-9))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 e-2 arg-8))) (cond ((equal? sc1 1) (TTImpC-45ProcessFnOpt-n--8247-13711-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-8 arg-7 arg-6)) (else (TTImpC-45ProcessFnOpt-n--8247-13711-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 (cons e-2 arg-8) arg-7 arg-6))))))))
(define TTImpC-45ProcessFnOpt-n--8247-13711-u--insertDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-5 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (TTImpC-45ProcessFnOpt-case--processFnOptC-44insertDeps-13739 arg-0 arg-1 arg-2 arg-3 arg-4 e-2 e-3 arg-6 arg-5 (DataC-45List-lookup csegen-832 e-2 arg-6)))))))
(define TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-1 (vector 0 ) e-2))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-1))) (cond ((equal? sc5 1) (lambda (eta-2) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-4 '() e-5 e-9) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-n--8247-13708-u--getDeps arg-0 arg-1 arg-2 arg-3 arg-4 1 e-12 LibrariesC-45DataC-45NameMap-empty))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--rs (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--x) (let ((sc7 (Builtin-snd u--x))) (cond ((equal? sc7 1) 1) (else (let ((sc8 (PreludeC-45Types-elem csegen-14 csegen-832 (Builtin-fst u--x) arg-6))) (cond ((equal? sc8 1) 0) (else 1))))))) (LibrariesC-45DataC-45NameMap-toList e-12)))) (let ((u--accC-39 (TTImpC-45ProcessFnOpt-n--8247-13711-u--insertDeps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (cons e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) u--rs))))) (TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec arg-0 arg-1 arg-2 arg-3 arg-4 u--accC-39 arg-6 arg-7 e-11))))) eff-0) eta-2))))))) (else (TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-11)))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) eff-0) clam-0)))))))(else (vector 1 arg-5))))))))(else (vector 1 arg-5))))))
(define TTImpC-45ProcessFnOpt-n--8247-13710-u--getNamePos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-n--8247-13710-u--getNamePos arg-0 arg-1 arg-2 arg-3 arg-4 (+ arg-5 1) e-10))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons e-2 arg-5) e-10))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45ProcessFnOpt-processFnOpt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (lambda (eta-0) (CoreC-45Context-setIsEscapeHatch arg-0 arg-1 arg-3 eta-0))) ((1) (lambda (eta-0) (let ((act-1 (TTImpC-45ProcessFnOpt-throwIfHasFlag arg-0 arg-1 arg-3 (vector 1 ) "%noinline and %inline are mutually exclusive" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) eta-0)))))) ((2) (lambda (eta-0) (let ((act-1 (TTImpC-45ProcessFnOpt-throwIfHasFlag arg-0 arg-1 arg-3 (vector 0 ) "%inline and %noinline are mutually exclusive" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 1 ) eta-0)))))) ((3) (lambda (eta-0) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 2 ) eta-0))) ((4) (lambda (eta-0) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 5 ) eta-0)))(else (cond ((equal? arg-2 1) (case (vector-ref arg-4 0) ((5) (let ((e-18 (vector-ref arg-4 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-0) (let ((e-1 (unbox e-6))) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-1) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ProcessFnOpt-getRetTy e-5 e-7))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Context-addHintFor arg-0 arg-1 e-7 arg-3 e-18 0 eta-2)))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))(else (case (vector-ref arg-4 0) ((5) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "elab" 5 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-3 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Adding local hint " (CoreC-45Name-u--show_Show_Name e-5)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Context-addLocalHint arg-0 arg-3 eta-0))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-4 0) ((6) (let ((e-14 (vector-ref arg-4 1))) (lambda (eta-0) (CoreC-45Context-addGlobalHint arg-0 arg-3 e-14 eta-0))))(else (lambda (clam-0) (case (vector-ref arg-4 0) ((6) (let ((e-1 (vector-ref arg-4 1))) (cond ((equal? e-1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%defaulthint is not valid in local definitions") clam-0)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%globalhint is not valid in local definitions") clam-0))))) ((7) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-0)) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-0)) ((9) (vector 1 (vector 0 ))) ((10) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 3 ) clam-0)) ((11) (let ((e-9 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 e-9) clam-0))) ((12) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 8 ) clam-0)) (else (let ((e-12 (vector-ref arg-4 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-2) (let ((e-1 (unbox e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45ProcessFnOpt-n--8247-13710-u--getNamePos arg-2 e-12 arg-3 arg-1 arg-0 0 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps arg-2 e-12 arg-3 arg-1 arg-0 e-7) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec arg-2 e-12 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-5) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-30 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-28 (vector-ref e-1 6))) (let ((e-27 (vector-ref e-1 7))) (let ((e-26 (vector-ref e-1 8))) (let ((e-25 (vector-ref e-1 9))) (let ((e-24 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-23 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-30 e-2 e-3 e-4 e-10 e-28 e-27 e-26 e-25 e-24 e-11 e-23 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-5)) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-2)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))(else (lambda (clam-1) (case (vector-ref arg-4 0) ((6) (let ((e-1 (vector-ref arg-4 1))) (cond ((equal? e-1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%defaulthint is not valid in local definitions") clam-1)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%globalhint is not valid in local definitions") clam-1))))) ((7) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-1)) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-1)) ((9) (vector 1 (vector 0 ))) ((10) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 3 ) clam-1)) ((11) (let ((e-9 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 e-9) clam-1))) ((12) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 8 ) clam-1)) (else (let ((e-12 (vector-ref arg-4 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-4) (let ((e-1 (unbox e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45ProcessFnOpt-n--8247-13710-u--getNamePos arg-2 e-12 arg-3 arg-1 arg-0 0 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps arg-2 e-12 arg-3 arg-1 arg-0 e-7) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec arg-2 e-12 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-5) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-30 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-28 (vector-ref e-1 6))) (let ((e-27 (vector-ref e-1 7))) (let ((e-26 (vector-ref e-1 8))) (let ((e-25 (vector-ref e-1 9))) (let ((e-24 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-23 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-30 e-2 e-3 e-4 e-10 e-28 e-27 e-26 e-25 e-24 e-11 e-23 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-5)) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-4)))))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))))(else (case (vector-ref arg-4 0) ((5) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "elab" 5 (lambda (eta-1) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-3 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Adding local hint " (CoreC-45Name-u--show_Show_Name e-5)))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45Context-addLocalHint arg-0 arg-3 eta-0))))))(else (cond ((equal? arg-2 1) (case (vector-ref arg-4 0) ((6) (let ((e-14 (vector-ref arg-4 1))) (lambda (eta-0) (CoreC-45Context-addGlobalHint arg-0 arg-3 e-14 eta-0))))(else (lambda (clam-2) (case (vector-ref arg-4 0) ((6) (let ((e-1 (vector-ref arg-4 1))) (cond ((equal? e-1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%defaulthint is not valid in local definitions") clam-2)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%globalhint is not valid in local definitions") clam-2))))) ((7) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-2)) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-2)) ((9) (vector 1 (vector 0 ))) ((10) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 3 ) clam-2)) ((11) (let ((e-9 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 e-9) clam-2))) ((12) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 8 ) clam-2)) (else (let ((e-12 (vector-ref arg-4 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-6) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-6) (let ((e-1 (unbox e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45ProcessFnOpt-n--8247-13710-u--getNamePos arg-2 e-12 arg-3 arg-1 arg-0 0 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps arg-2 e-12 arg-3 arg-1 arg-0 e-7) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec arg-2 e-12 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-5) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-30 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-28 (vector-ref e-1 6))) (let ((e-27 (vector-ref e-1 7))) (let ((e-26 (vector-ref e-1 8))) (let ((e-25 (vector-ref e-1 9))) (let ((e-24 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-23 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-30 e-2 e-3 e-4 e-10 e-28 e-27 e-26 e-25 e-24 e-11 e-23 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-5)) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-6)))))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))))))(else (lambda (clam-3) (case (vector-ref arg-4 0) ((6) (let ((e-1 (vector-ref arg-4 1))) (cond ((equal? e-1 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%defaulthint is not valid in local definitions") clam-3)) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "%globalhint is not valid in local definitions") clam-3))))) ((7) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-3)) ((8) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 0 ) clam-3)) ((9) (vector 1 (vector 0 ))) ((10) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 3 ) clam-3)) ((11) (let ((e-9 (vector-ref arg-4 1))) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 6 e-9) clam-3))) ((12) (CoreC-45Context-setFlag arg-0 arg-1 arg-3 (vector 8 ) clam-3)) (else (let ((e-12 (vector-ref arg-4 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-8) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-8) (let ((e-1 (unbox e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-2 (vector-ref e-1 2))) e-2)) clam-8))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45ProcessFnOpt-n--8247-13710-u--getNamePos arg-2 e-12 arg-3 arg-1 arg-0 0 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((TTImpC-45ProcessFnOpt-n--8247-13706-u--collectDDeps arg-2 e-12 arg-3 arg-1 arg-0 e-7) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((TTImpC-45ProcessFnOpt-n--8247-13707-u--collectSpec arg-2 e-12 arg-3 arg-1 arg-0 '() e-9 e-8 e-7) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-5) (CoreC-45Context-addDef arg-0 arg-3 (let ((e-0 (vector-ref e-1 0))) (let ((e-30 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-28 (vector-ref e-1 6))) (let ((e-27 (vector-ref e-1 7))) (let ((e-26 (vector-ref e-1 8))) (let ((e-25 (vector-ref e-1 9))) (let ((e-24 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-23 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-30 e-2 e-3 e-4 e-10 e-28 e-27 e-26 e-25 e-24 e-11 e-23 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-5)) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-8)))))))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))))))))))))))
(define TTImpC-45ProcessType-n--12472-2992-u--isNested (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32) (case (vector-ref arg-32 0) ((5) 1) ((0) (let ((e-3 (vector-ref arg-32 2))) (TTImpC-45ProcessType-n--12472-2992-u--isNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 e-3)))(else 0))))
(define TTImpC-45ProcessType-processType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((e-1 (vector-ref arg-13 0))) (let ((e-2 (vector-ref arg-13 1))) (let ((e-3 (vector-ref arg-13 2))) (let ((e-4 (vector-ref arg-13 3))) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Metadata-addNameLoc arg-2 arg-1 e-2 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "declare.type" 1 (lambda () (string-append "Processing " (CoreC-45Name-u--show_Show_Name e-5))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "declare.type" 5 (lambda () (DataC-45String-unwords (cons "Checking type decl:" (cons (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega arg-10) (cons (CoreC-45Name-u--show_Show_Name e-5) (cons ":" (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-4) '()))))))) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((act-5 (CoreC-45Context-resolveName arg-1 e-5 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-7 ((CoreC-45Context-lookupCtxtExact (vector 8 e-9) (let ((e-0 (vector-ref e-10 0))) e-0)) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-11) (let ((act-8 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-9 clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 ((TTImpC-45ElabC-45Utils-wrapErrorC arg-6 (lambda (eta-4) (vector 68 arg-9 e-5 eta-4)) (lambda (eta-4) (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9 (vector 0 ) (cons 0 arg-6) arg-7 arg-8 (vector 16 arg-9 csegen-2373 e-4) (CoreC-45NormaliseC-45Eval-gType arg-9 e-12) eta-4))) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-13 (vector-ref act-9 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-10 (CoreC-45Normalise-logTermNF '() arg-1 "declare.type" 3 (lambda () (string-append "Type of " (CoreC-45Name-u--show_Show_Name e-5))) '() (CoreC-45Env-abstractFullEnvType arg-0 e-1 arg-8 e-13) eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-14 (vector-ref act-10 1))) (vector 0 e-14))) (else (let ((act-11 ((TTImpC-45ProcessType-initDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-9 e-5 arg-8 e-13 arg-12) eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-15 (vector-ref act-11 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (let ((u--fullty (CoreC-45Env-abstractFullEnvType arg-0 e-1 arg-8 e-13))) (lambda (eta-5) (let ((act-12 (TTImpC-45ElabC-45Utils-findErased arg-1 u--fullty eta-5))) (case (vector-ref act-12 0) ((0) (let ((e-16 (vector-ref act-12 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (let ((_-0 '())) (lambda (clam-2) (let ((e-18 (car e-16))) (let ((e-17 (cdr e-16))) (let ((act-13 (let ((act-13 (unbox arg-1))) (vector 1 act-13)))) (case (vector-ref act-13 0) ((0) (let ((e-19 (vector-ref act-13 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-14 (CoreC-45Context-clearDefs e-19 eta-6))) (case (vector-ref act-14 0) ((0) (let ((e-20 (vector-ref act-14 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-15 (let ((act-15 ((CoreC-45NormaliseC-45Eval-nf arg-1 '() e-19 '() u--fullty) eta-7))) (case (vector-ref act-15 0) ((0) (let ((e-21 (vector-ref act-15 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-15 1))) ((let ((eff-0 (TTImpC-45ProcessType-findInferrable arg-1 e-20 e-21))) eff-0) eta-7))))))) (case (vector-ref act-15 0) ((0) (let ((e-21 (vector-ref act-15 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-16 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-9) (CoreC-45Context-addDef arg-1 (vector 8 e-9) (let ((sc17 (CoreC-45Context-newDef arg-9 e-5 arg-10 arg-0 u--fullty (LibrariesC-45DataC-45WithDefault-specified arg-11) e-15))) (let ((e-0 (vector-ref sc17 0))) (let ((e-43 (vector-ref sc17 1))) (let ((e-42 (vector-ref sc17 2))) (let ((e-39 (vector-ref sc17 5))) (let ((e-37 (vector-ref sc17 7))) (let ((e-36 (vector-ref sc17 8))) (let ((e-35 (vector-ref sc17 9))) (let ((e-34 (vector-ref sc17 10))) (let ((e-33 (vector-ref sc17 11))) (let ((e-32 (vector-ref sc17 12))) (let ((e-31 (vector-ref sc17 13))) (let ((e-30 (vector-ref sc17 14))) (let ((e-29 (vector-ref sc17 15))) (let ((e-28 (vector-ref sc17 16))) (let ((e-27 (vector-ref sc17 17))) (let ((e-26 (vector-ref sc17 18))) (let ((e-25 (vector-ref sc17 19))) (let ((e-24 (vector-ref sc17 20))) (let ((e-23 (vector-ref sc17 21))) (let ((e-22 (vector-ref sc17 22))) (vector e-0 e-43 e-42 e-18 e-17 e-39 e-21 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22)))))))))))))))))))))) eta-9)) eta-8))) (case (vector-ref act-16 0) ((0) (let ((e-22 (vector-ref act-16 1))) (vector 0 e-22))) (else (let ((act-17 (let ((sc18 (PreludeC-45Types-elem csegen-14 csegen-2376 1 arg-6))) (cond ((equal? sc18 1) (vector 1 (vector 0 ))) (else (CoreC-45Context-setLinearCheck arg-1 e-9 1 eta-8)))))) (case (vector-ref act-17 0) ((0) (let ((e-23 (vector-ref act-17 1))) (vector 0 e-23))) (else (let ((act-18 (CoreC-45ContextC-45Log-log arg-1 "declare.type" 2 (lambda () (string-append "Setting options for " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45TTImp-u--show_Show_C-40FnOptC-39C-32C-36nmC-41 csegen-65 u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45TTImp-u--showPrec_Show_C-40FnOptC-39C-32C-36nmC-41 csegen-65 u--d u--x)))) arg-12))))) eta-8))) (case (vector-ref act-18 0) ((0) (let ((e-24 (vector-ref act-18 1))) (vector 0 e-24))) (else (let ((u--name (vector 8 e-9))) (let ((act-19 ((CoreC-45Core-traverse_ (lambda (eta-9) (TTImpC-45ProcessFnOpt-processFnOpt arg-1 arg-9 (let ((sc20 (TTImpC-45ProcessType-n--12472-2992-u--isNested e-4 e-3 e-2 e-1 arg-12 arg-11 arg-10 arg-9 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-9 e-10 _-0 e-12 e-13 e-15 u--fullty e-18 e-17 e-16 e-19 e-20 e-21 u--name e-5))) (cond ((equal? sc20 1) 0) (else 1))) u--name eta-9)) arg-12) eta-8))) (case (vector-ref act-19 0) ((0) (let ((e-25 (vector-ref act-19 1))) (vector 0 e-25))) (else (let ((act-20 (let ((act-20 (CoreC-45Context-getDefaultTotalityOption arg-1 eta-8))) (case (vector-ref act-20 0) ((0) (let ((e-26 (vector-ref act-20 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-20 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc22 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-9) (TTImpC-45TTImp-isTotalityReq eta-9)) arg-12))) (cond ((equal? sc22 1) (vector 1 (vector 0 ))) (else (CoreC-45Context-setFlag arg-1 arg-9 u--name (vector 6 e-26) clam-3))))))) eff-0) eta-8))))))) (case (vector-ref act-20 0) ((0) (let ((e-26 (vector-ref act-20 1))) (vector 0 e-26))) (else (let ((act-21 (CoreC-45Metadata-addTyDecl arg-0 arg-1 arg-2 arg-9 (vector 8 e-9) arg-8 e-13 eta-8))) (case (vector-ref act-21 0) ((0) (let ((e-27 (vector-ref act-21 1))) (vector 0 e-27))) (else (let ((act-22 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" 7 (lambda () "processType is adding \x2193;") eta-8))) (case (vector-ref act-22 0) ((0) (let ((e-28 (vector-ref act-22 1))) (vector 0 e-28))) (else (let ((act-23 (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 e-2 (vector 8 e-9) arg-8 e-13 eta-8))) (case (vector-ref act-23 0) ((0) (let ((e-29 (vector-ref act-23 1))) (vector 0 e-29))) (else (let ((act-24 ((CoreC-45Core-traverse_ (lambda (eta-9) (lambda (eta-10) (CoreC-45Context-addToSave arg-1 eta-9 eta-10))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-13))) eta-8))) (case (vector-ref act-24 0) ((0) (let ((e-30 (vector-ref act-24 1))) (vector 0 e-30))) (else (let ((act-25 (CoreC-45Context-addToSave arg-1 e-5 eta-8))) (case (vector-ref act-25 0) ((0) (let ((e-31 (vector-ref act-25 1))) (vector 0 e-31))) (else (let ((act-26 (CoreC-45ContextC-45Log-log arg-1 "declare.type" 10 (lambda () (string-append "Saving from " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-13))))))) eta-8))) (case (vector-ref act-26 0) ((0) (let ((e-32 (vector-ref act-26 1))) (vector 0 e-32))) (else (let ((act-27 (let ((sc28 (CoreC-45TT-u--C-47C-61_Eq_Visibility arg-11 0))) (cond ((equal? sc28 1) (let ((act-27 (CoreC-45Context-addHashWithNames arg-1 csegen-1357 csegen-54 e-5 eta-8))) (case (vector-ref act-27 0) ((0) (let ((e-33 (vector-ref act-27 1))) (vector 0 e-33))) (else (let ((act-28 (CoreC-45Context-addHashWithNames arg-1 (csegen-1374) csegen-68 e-13 eta-8))) (case (vector-ref act-28 0) ((0) (let ((e-34 (vector-ref act-28 1))) (vector 0 e-34))) (else (CoreC-45ContextC-45Log-log arg-1 "module.hash" 15 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-9) eta-9) (cons "Adding hash for type with name " (cons (CoreC-45Name-u--show_Show_Name e-5) '())))) eta-8)))))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-27 0) ((0) (let ((e-33 (vector-ref act-27 1))) (vector 0 e-33))) (else (let ((act-28 (CoreC-45Context-getSession arg-1 eta-8))) (case (vector-ref act-28 0) ((0) (let ((e-34 (vector-ref act-28 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-28 1))) ((let ((eff-0 (let ((sc30 (let ((e-39 (vector-ref e-34 20))) e-39))) (cond ((equal? sc30 1) (let ((sc31 (DataC-45List1-fromList (TTImpC-45ProcessType-checkForShadowing LibrariesC-45DataC-45StringMap-empty e-4)))) (if (null? sc31) (lambda (eta-9) (vector 1 (vector 0 ))) (let ((e-35 (unbox sc31))) (CoreC-45Context-recordWarning arg-1 (vector 4 arg-9 e-35)))))) (else (lambda (eta-9) (vector 1 (vector 0 )))))))) eff-0) eta-8))))))))))))))))))))))))))))))))))))))))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) clam-2))))))))))) eff-0) eta-5))))))))) eff-0) eta-4))))))))))) eff-0) eta-3)))))))) eff-0) clam-1))))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-5) clam-1))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))))) eff-0) ext-0)))))))))))
(define TTImpC-45ProcessDef-n--26970-16527-u--holeyType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (vector 32 arg-6 0) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--xfc (CoreC-45FC-virtualiseFC e-6))) (vector 1 u--xfc AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box (vector 1 (vector 0 e-7))) (vector 32 u--xfc 0) (TTImpC-45ProcessDef-n--26970-16527-u--holeyType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3))))))))))
(define TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32lookupOrAddAlias-16644 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (lambda (clam-0) (if (null? arg-17) (vector 1 '()) (let ((e-1 (unbox arg-17))) (let ((e-6 (cdr e-1))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-13 "declare.def" 5 (lambda () (string-append "Missing type declaration for the alias " (string-append (CoreC-45Name-u--show_Show_Name arg-5) ". Checking first whether it is a misspelling."))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 ((CoreC-45Context-getSimilarNames arg-13 arg-5) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (vector 1 '()) (let ((e-2 (unbox e-8))) (let ((e-10 (car e-2))) (let ((e-9 (cdr e-2))) (let ((act-3 ((PreludeC-45Basics-flip csegen-1298 e-9 (lambda (lamc-0) (lambda (clam-2) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-12 (car e-3))) (let ((e-11 (cdr e-3))) (let ((act-3 ((CoreC-45Context-lookupCtxtExact e-4 (let ((e-0 (vector-ref arg-15 0))) e-0)) clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-13 (vector-ref act-3 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-13) (lambda (eta-0) (vector 1 '())) (let ((e-14 (unbox e-13))) (lambda (clam-3) (let ((e-18 (vector-ref e-14 18))) (case (vector-ref e-18 0) ((0) (vector 1 (box (cons e-4 (cons e-12 e-11)))))(else (vector 1 '()))))))))) eff-0) clam-2)))))))))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Context-showSimilarNames (let ((e-40 (vector-ref arg-15 2))) e-40) arg-5 e-10 (DataC-45List-catMaybes e-11)))))) eff-0) clam-1)))))))))))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-8) (let ((act-3 (CoreC-45ContextC-45Log-log arg-13 "declare.def" 5 (lambda () "Not a misspelling: go ahead and declare it!") clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (TTImpC-45ProcessType-processType arg-0 arg-13 arg-14 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega 2 '() (vector arg-6 arg-6 arg-5 (TTImpC-45ProcessDef-n--26970-16527-u--holeyType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-6))) clam-4))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (unbox arg-13))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref e-11 0))) e-0)))) eff-0) clam-4))))))))))) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 72 (vector 38 arg-6 arg-5) (cons e-2 e-3)) clam-4))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ProcessDef-lookupOrAddAlias (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-lookupCtxtExact arg-10 (let ((e-0 (vector-ref e-5 0))) e-0)))) eff-0) eta-0)))))) (let ((e-1 (car arg-11))) (let ((e-2 (cdr arg-11))) (lambda (clam-0) (case (vector-ref e-1 0) ((0) (let ((e-4 (vector-ref e-1 1))) (let ((e-5 (vector-ref e-1 2))) (let ((e-6 (vector-ref e-1 3))) (if (null? e-2) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-2 "declare.def.alias" 20 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Looking at " (cons (TTImpC-45TTImp-u--show_Show_C-40ImpClauseC-39C-32C-36nmC-41 csegen-65 e-1) '())))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-10 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--cl (vector 0 e-4 e-5 e-6))) (if (null? e-9) (let ((_-0 '())) (TTImpC-45ProcessDef-case--caseC-32blockC-32inC-32lookupOrAddAlias-16644 arg-0 e-4 e-6 e-5 u--cl arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 _-0 (TTImpC-45ProcessDef-isAlias e-5))) (let ((e-3 (unbox e-9))) (lambda (eta-1) (vector 1 (box e-3)))))))) eff-0) eta-0))))))))))) eff-0) clam-0))))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-lookupCtxtExact arg-10 (let ((e-0 (vector-ref e-7 0))) e-0)))) eff-0) clam-0))))))))))(else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-lookupCtxtExact arg-10 (let ((e-0 (vector-ref e-5 0))) e-0)))) eff-0) clam-0)))))))))))))
(define CoreC-45Context-noDeclaration (lambda (arg-1 arg-2 arg-3 ext-0) (CoreC-45Context-maybeMisspelling arg-1 (vector 38 arg-2 arg-3) arg-3 ext-0)))
(define CoreC-45Context-setCovering (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (let ((e-22 (vector-ref e-1 22))) (let ((e-27 (car e-10))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 (cons e-27 arg-3) e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))))) eta-2)) eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setSizeChange (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 arg-2 (let ((e-0 (vector-ref e-1 0))) (let ((e-25 (vector-ref e-1 1))) (let ((e-2 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-24 (vector-ref e-1 5))) (let ((e-23 (vector-ref e-1 6))) (let ((e-7 (vector-ref e-1 7))) (let ((e-8 (vector-ref e-1 8))) (let ((e-9 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-22 (vector-ref e-1 22))) (vector e-0 e-25 e-2 e-3 e-4 e-24 e-23 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 arg-3 e-22))))))))))))))))))))))) eta-2)) eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDef-toPats (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (cons e-0 (cons e-1 (cons e-2 e-3)))))))))
(define TTImpC-45ProcessDef-warnUnreachable (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (CoreC-45Context-recordWarning arg-0 (vector 1 e-0 (CoreC-45TTC-45Term-getLoc e-2) e-1 e-2)))))))
(define PreludeC-45Interfaces-C-60C-42 (lambda (arg-3 arg-4 arg-5) (let ((e-3 (vector-ref arg-3 2))) ((((e-3 'erased) 'erased) (((let ((eff-0 (let ((e-6 (vector-ref arg-3 0))) e-6))) (lambda (arg-0) (lambda (arg-1) ((((eff-0 'erased) 'erased) arg-0) arg-1)))) (lambda (eta-0) (lambda (eta-1) eta-0))) arg-4)) arg-5))))
(define CoreC-45Core-C-60C-42 (lambda (arg-2 arg-3 ext-0) (let ((act-5 (let ((act-5 (lambda (eta-0) (lambda (eta-1) (PreludeC-45Interfaces-C-60C-42 (vector (lambda (u--b) (lambda (u--a) (lambda (u--func) (lambda (arg-8885) (case (vector-ref arg-8885 0) ((0) (let ((e-2 (vector-ref arg-8885 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-8885 1))) (vector 1 (u--func e-5))))))))) (lambda (u--a) (lambda (arg-9931) (vector 1 arg-9931))) (lambda (u--b) (lambda (u--a) (lambda (arg-9937) (lambda (arg-9944) (case (vector-ref arg-9937 0) ((0) (let ((e-2 (vector-ref arg-9937 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref arg-9937 1))) (case (vector-ref arg-9944 0) ((1) (let ((e-8 (vector-ref arg-9944 1))) (vector 1 (e-5 e-8)))) (else (let ((e-11 (vector-ref arg-9944 1))) (vector 0 e-11)))))))))))) eta-0 eta-1))))) (let ((act-3 (arg-2 ext-0))) (act-5 act-3))))) (let ((act-3 (arg-3 ext-0))) (act-5 act-3)))))
(define CoreC-45Context-withDefStacked (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ds (let ((e-32 (vector-ref e-5 32))) e-32))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 (cons e-32 arg-2)))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Core-C-60C-42 arg-3 (let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-1))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-1 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-35 (vector-ref e-7 5))) (let ((e-34 (vector-ref e-7 6))) (let ((e-33 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (let ((e-12 (vector-ref e-7 12))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (let ((e-25 (vector-ref e-7 25))) (let ((e-26 (vector-ref e-7 26))) (let ((e-27 (vector-ref e-7 27))) (let ((e-28 (vector-ref e-7 28))) (let ((e-29 (vector-ref e-7 29))) (let ((e-30 (vector-ref e-7 30))) (let ((e-31 (vector-ref e-7 31))) (vector e-0 e-1 e-2 e-3 e-4 e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 u--ds)))))))))))))))))))))))))))))))))))) (vector 1 act-4))))) eff-1) world-0))))))) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Coverage-n--12748-8451-u--dropPos (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1032 arg-4 arg-5))) (cond ((equal? sc1 1) (cons (vector 10 arg-3 (vector 0 )) (CoreC-45Coverage-n--12748-8451-u--dropPos arg-1 arg-2 arg-3 (+ arg-4 1) arg-5 e-3))) (else (cons e-2 (CoreC-45Coverage-n--12748-8451-u--dropPos arg-1 arg-2 arg-3 (+ arg-4 1) arg-5 e-3))))))))))
(define CoreC-45Coverage-case--eraseApps-8534 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Coverage-eraseApps arg-2 eta-0)) e-3 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-apply e-5 (vector 1 e-5 (vector 0 ) e-7) e-8))))) eff-0) clam-0))))))(else (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-7 (let ((e-0 (vector-ref e-8 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--eargs (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-1) (let ((e-28 (vector-ref eta-1 3))) e-28))) e-9))) (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Coverage-eraseApps arg-2 eta-2)) (CoreC-45Coverage-n--12748-8451-u--dropPos arg-1 arg-2 e-5 0 u--eargs e-3) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45TTC-45Term-apply e-5 (vector 1 e-5 e-6 e-7) e-10))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Coverage-eraseApps arg-2 eta-0)) e-3 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-apply (CoreC-45TTC-45Term-getLoc e-2) e-2 e-5))))) eff-0) clam-0))))))))))))
(define CoreC-45Coverage-eraseApps (lambda (arg-1 arg-2) (CoreC-45Coverage-case--eraseApps-8534 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-2))))
(define CoreC-45Coverage-match (lambda (arg-1 arg-2) (case (vector-ref arg-1 0) ((0) 1) ((1) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (case (vector-ref e-25 0) ((0) 1)(else (case (vector-ref arg-2 0) ((1) (let ((e-58 (vector-ref arg-2 3))) (CoreC-45Name-u--C-61C-61_Eq_Name e-26 e-58)))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))))))) ((4) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((4) (let ((e-61 (vector-ref arg-2 2))) (let ((e-62 (vector-ref arg-2 3))) (let ((sc2 (CoreC-45Coverage-match e-29 e-61))) (cond ((equal? sc2 1) (CoreC-45Coverage-match e-30 e-62)) (else 0))))))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))))) ((5) (let ((e-35 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((5) (let ((e-67 (vector-ref arg-2 4))) (CoreC-45Coverage-match e-35 e-67)))(else (CoreC-45Coverage-match e-35 arg-2))))) ((6) (let ((e-39 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((6) (let ((e-71 (vector-ref arg-2 3))) (CoreC-45Coverage-match e-39 e-71)))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))))))) ((7) (let ((e-44 (vector-ref arg-1 4))) (case (vector-ref arg-2 0) ((7) (let ((e-76 (vector-ref arg-2 4))) (CoreC-45Coverage-match e-44 e-76)))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))))))) ((8) (let ((e-48 (vector-ref arg-1 3))) (case (vector-ref arg-2 0) ((8) (let ((e-80 (vector-ref arg-2 3))) (CoreC-45Coverage-match e-48 e-80)))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))))))) ((9) (let ((e-51 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((9) (let ((e-83 (vector-ref arg-2 2))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-51 e-83)))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0)))))))))))) ((10) (let ((e-54 (vector-ref arg-1 2))) (case (vector-ref e-54 0) ((2) (let ((e-85 (vector-ref e-54 1))) (CoreC-45Coverage-match e-85 arg-2)))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))))(else (case (vector-ref arg-2 0) ((10) (let ((e-14 (vector-ref arg-2 2))) (case (vector-ref e-14 0) ((2) (let ((e-16 (vector-ref e-14 1))) (CoreC-45Coverage-match arg-1 e-16)))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))(else (case (vector-ref arg-1 0) ((10) 1)(else (case (vector-ref arg-2 0) ((10) 1)(else (case (vector-ref arg-1 0) ((11) (case (vector-ref arg-2 0) ((11) 1)(else 0)))(else 0))))))))))))
(define CoreC-45Coverage-clauseMatches (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45Coverage-eraseApps arg-1 (CoreC-45Env-close (CoreC-45TTC-45Term-getLoc arg-3) "cov" arg-2 arg-3)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toResolvedNames arg-1 csegen-68 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toResolvedNames arg-1 csegen-68 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45Coverage-match e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Coverage-n--13030-8721-u--tryClauses (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-3) (let ((act-1 (CoreC-45Normalise-logTermNF '() arg-2 "coverage" 10 (lambda () "Nothing matches") '() arg-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (box arg-4))))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-4 (vector-ref e-2 0))) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 (CoreC-45Coverage-clauseMatches e-4 arg-2 e-5 e-6 arg-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-8 (vector-ref act-1 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-8 1) (let ((act-2 (CoreC-45Normalise-logTermNF e-4 arg-2 "coverage" 10 (lambda () "Yes") e-5 e-6 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (vector 1 '()))))) (else (let ((act-2 (CoreC-45Normalise-logTermNF e-4 arg-2 "coverage" 10 (lambda () "No match") e-5 e-6 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else ((CoreC-45Coverage-n--13030-8721-u--tryClauses arg-0 arg-1 arg-2 e-3 arg-4) clam-1))))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Coverage-checkMatched (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-0 "coverage" 5 (lambda () "Checking coverage for") arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-68 arg-2 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "coverage" 10 (lambda (eta-1) (vector 1 (string-append "(raw term: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-6) ")")))) eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Coverage-eraseApps arg-0 arg-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45ContextC-45Log-logTerm '() arg-0 "coverage" 5 (lambda () "Erased to") e-7 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "coverage" 5 (lambda (eta-1) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-0 csegen-2583 eta-2 eta-3))) arg-1 '()) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Against clauses:\xa;" (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (CoreC-45ContextC-45Context-u--show_Show_Clause eta-3))) e-9))))))))) eff-0) eta-1)))))) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else ((CoreC-45Coverage-n--13030-8721-u--tryClauses arg-2 arg-1 arg-0 arg-1 e-7) eta-0)))))))))) eff-0) ext-0)))))))))))))
(define CoreC-45Coverage-findTag (lambda (arg-2 arg-3 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 arg-2 e-6))) (cond ((equal? sc2 1) (box e-7)) (else (CoreC-45Coverage-findTag arg-2 arg-3 e-3)))))))))))
(define CoreC-45CaseC-45CaseTree-isDefault (lambda (arg-1) (case (vector-ref arg-1 0) ((3) 1)(else 0))))
(define CoreC-45Coverage-altMatch (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) 1)(else (case (vector-ref arg-1 0) ((1) (case (vector-ref arg-2 0) ((1) 1)(else 0))) ((0) (let ((e-6 (vector-ref arg-1 2))) (case (vector-ref arg-2 0) ((0) (let ((e-18 (vector-ref arg-2 2))) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int e-6 e-18)))(else 0)))) ((2) (let ((e-10 (vector-ref arg-1 1))) (case (vector-ref arg-2 0) ((2) (let ((e-22 (vector-ref arg-2 1))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-10 e-22)))(else 0))))(else 0))))))
(define CoreC-45Coverage-n--10881-6935-u--noneOf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Coverage-altMatch arg-7 eta-0)) arg-6))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Coverage-getMissingAlts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-4 0) ((8) (let ((e-2 (vector-ref arg-4 2))) (case (vector-ref e-2 0) ((13) (let ((e-6 (vector-ref e-2 1))) (lambda (clam-0) (cond ((equal? e-6 13) (let ((sc3 (DataC-45List-isNil arg-5))) (cond ((equal? sc3 1) csegen-2578) (else (vector 1 '())))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 50 (lambda () (string-append "Looking for missing alts at type " (CoreC-45TTC-45Primitive-u--show_Show_Constant e-2))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((sc3 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45CaseC-45CaseTree-isDefault eta-0)) arg-5))) (cond ((equal? sc3 1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 20 (lambda () "Found default") clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 '()))))) (else csegen-2578)))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 50 (lambda () (string-append "Looking for missing alts at type " (CoreC-45TTC-45Primitive-u--show_Show_Constant e-2))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) (CoreC-45CaseC-45CaseTree-isDefault eta-1)) arg-5))) (cond ((equal? sc2 1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 20 (lambda () "Found default") eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 '()))))) (else csegen-2578))))))))))) ((10) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 50 (lambda () "Looking for missing alts at type Type") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) (CoreC-45CaseC-45CaseTree-isDefault eta-1)) arg-5))) (cond ((equal? sc2 1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 20 (lambda () "Found default") eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 '()))))) (else csegen-2578))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "coverage.missing" 50 (lambda () (string-append "Getting constructors for: " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 arg-1 arg-4))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Normalise-logNF arg-1 arg-0 "coverage.missing" 20 (lambda () "Getting constructors for") (CoreC-45Env-mkEnv arg-2 arg-1) arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45CaseC-45Util-getCons arg-0 arg-1 arg-3 arg-4 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-2) (CoreC-45Coverage-n--10881-6935-u--noneOf arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 arg-5 eta-2)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45CaseC-45Util-mkAlt arg-1 arg-2 (vector 2 "Coverage check") eta-2)) e-7)))))) eff-0) eta-0))))))))))))))))
(define CoreC-45Coverage-n--11722-7500-u--dropRep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 2))) (cons e-2 (CoreC-45Coverage-n--11722-7500-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (let ((sc2 (CoreC-45CaseC-45Util-tagIs e-6 eta-0))) (cond ((equal? sc2 1) 0) (else 1)))) e-3)))))(else (cons e-2 (CoreC-45Coverage-n--11722-7500-u--dropRep arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)))))))))
(define CoreC-45Coverage-n--11722-7501-u--rep (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (let ((e-1 (vector-ref arg-6 1))) (let ((act-1 (CoreC-45CaseC-45Util-getCons arg-5 arg-0 arg-3 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45CaseC-45Util-mkAlt arg-0 arg-4 e-1 eta-1)) e-5))))) eff-0) ext-0)))))))(else (vector 1 (cons arg-6 '()))))))
(define CoreC-45Coverage-replaceDefaults (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((8) (vector 1 arg-5)) ((10) (vector 1 arg-5))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Coverage-n--11722-7501-u--rep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 eta-0 eta-1))) arg-5 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Coverage-n--11722-7500-u--dropRep arg-1 arg-5 arg-4 arg-3 arg-2 arg-0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5)))))) eff-0) ext-0)))))))))
(define CoreC-45Coverage-tagIsNot (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 2))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-223 e-2 arg-1))) (cond ((equal? sc1 1) 0) (else 1))))) ((2) 1) ((1) 1) (else 0))))
(define CoreC-45Coverage-addNot (lambda (arg-1 arg-2 arg-4 arg-5) (if (null? arg-5) (cons (cons arg-1 (cons arg-4 '())) '()) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45TTC-45Var-u--C-61C-61_Eq_C-40VarC-32C-36xsC-41 arg-1 e-6))) (cond ((equal? sc2 1) (cons (cons e-6 (cons arg-4 e-7)) e-3)) (else (cons (cons e-6 e-7) (CoreC-45Coverage-addNot arg-1 arg-2 arg-4 e-3))))))))))))
(define CoreC-45Coverage-weakenNs (lambda (arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (cons (cons (let ((sc2 CoreC-45TTC-45Var-WeakenVar)) (let ((e-4 (cdr sc2))) ((((e-4 'erased) 'erased) arg-3) e-6))) e-7) (CoreC-45Coverage-weakenNs arg-3 e-3)))))))))
(define CoreC-45Coverage-n--11849-7613-u--buildArgAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((0) (let ((e-1 (vector-ref arg-14 1))) (let ((e-2 (vector-ref arg-14 2))) (let ((e-3 (vector-ref arg-14 3))) (let ((e-4 (vector-ref arg-14 4))) (let ((u--l (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf e-3))) (let ((u--con (vector 1 arg-11 (vector 2 e-2 u--l) e-1))) (let ((u--psC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TT-substName arg-4 (CoreC-45TTC-45Term-apply arg-11 u--con (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 1 arg-11 (vector 0 ) eta-1)) e-3)) eta-0)) arg-7))) (CoreC-45Coverage-buildArgs arg-12 (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-11 arg-10 (CoreC-45Coverage-weakenNs u--l (cons (cons arg-3 e-2) arg-9)) (CoreC-45Coverage-weakenNs u--l arg-13) u--psC-39 e-4))))))))) ((1) (let ((e-6 (vector-ref arg-14 1))) (let ((e-7 (vector-ref arg-14 2))) (let ((e-8 (vector-ref arg-14 3))) (let ((u--l (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-6 (cons e-7 '()))))) (let ((u--psC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TT-substName arg-4 (vector 7 arg-11 2 (vector 1 arg-11 (vector 0 ) e-6) (vector 1 arg-11 (vector 0 ) e-7)) eta-0)) arg-7))) (CoreC-45Coverage-buildArgs arg-12 (cons e-6 (cons e-7 arg-0)) arg-11 arg-10 (CoreC-45Coverage-weakenNs u--l arg-9) (CoreC-45Coverage-weakenNs u--l arg-13) u--psC-39 e-8))))))) ((2) (let ((e-10 (vector-ref arg-14 1))) (let ((e-11 (vector-ref arg-14 2))) (let ((u--psC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45TT-substName arg-4 (vector 9 arg-11 e-10) eta-0)) arg-7))) (CoreC-45Coverage-buildArgs arg-12 arg-0 arg-11 arg-10 arg-9 arg-13 u--psC-39 e-11))))) (else (let ((e-13 (vector-ref arg-14 1))) (CoreC-45Coverage-buildArgs arg-12 arg-0 arg-11 arg-10 arg-9 arg-13 arg-7 e-13))))))
(define CoreC-45Coverage-n--11849-7614-u--buildArgsAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (lambda (clam-0) (if (null? arg-14) (vector 1 '()) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 ((CoreC-45Coverage-n--11849-7613-u--buildArgAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Coverage-n--11849-7614-u--buildArgsAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (CoreC-45Coverage-addNot arg-3 arg-0 e-6 arg-13) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (let ((act-1 ((CoreC-45Coverage-n--11849-7613-u--buildArgAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Coverage-n--11849-7614-u--buildArgsAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define CoreC-45Coverage-buildArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (let ((u--fenv (CoreC-45Env-mkEnv arg-2 arg-1))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-3 u--fenv e-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Coverage-replaceDefaults arg-0 arg-1 arg-2 arg-3 e-6 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Coverage-getMissingAlts arg-0 arg-1 arg-2 arg-3 e-6 e-7) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--altsC-39 (PreludeC-45TypesC-45List-tailRecAppend e-7 e-8))) (let ((u--altsK (PreludeC-45Types-maybe (lambda () u--altsC-39) (lambda () (lambda (u--t) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-3) (CoreC-45CaseC-45Util-tagIs u--t eta-3)) u--altsC-39))) (CoreC-45Coverage-findTag e-2 arg-1 arg-4)))) (let ((u--altsN (PreludeC-45Types-maybe (lambda () u--altsK) (lambda () (lambda (u--ts) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-3) (CoreC-45Coverage-tagIsNot u--ts eta-3)) u--altsK))) (CoreC-45Coverage-findTag e-2 arg-1 arg-5)))) (CoreC-45Coverage-n--11849-7614-u--buildArgsAlt arg-1 e-5 e-4 e-2 e-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-0 arg-5 u--altsN)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((1) (lambda (eta-0) (vector 1 '()))) ((2) (lambda (eta-0) (vector 1 (cons arg-6 '())))) (else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45Coverage-getMissing (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--psIn (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 arg-2 (vector 0 ) eta-0)) arg-0))) (lambda (eta-0) (let ((act-2 ((CoreC-45Coverage-buildArgs arg-1 arg-0 arg-2 e-5 '() '() u--psIn arg-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--pats (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-6))) (lambda (eta-1) (let ((act-3 (let ((sc2 (PreludeC-45Types-u--null_Foldable_List u--pats))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "coverage.missing" 20 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-3 1))) (vector 1 (LibrariesC-45DataC-45StringC-45Extra-join "\xa;" csegen-14 e-7)))))) (PreludeC-45Basics-flip csegen-1298 u--pats (lambda (u--pat) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-4 1))) (vector 1 (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-7)))))) (lambda (eta-4) (CoreC-45Context-toFullNames arg-1 csegen-68 u--pat eta-4)) eta-3)))) eta-2)) eta-1)))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45TTC-45Term-apply arg-2 (vector 1 arg-2 (vector 1 ) arg-3) eta-2)) e-6))))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Coverage-n--12273-8008-u--isCase (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 2))) (CoreC-45Coverage-n--12273-8008-u--isCase arg-0 arg-1 arg-2 e-1))) ((6) 1)(else 0))))
(define CoreC-45Coverage-n--12273-8009-u--noAssert (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? e-3 1) '()) (else (box e-2)))))))
(define CoreC-45Coverage-n--12273-8010-u--notCovering (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-4 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox e-5))) (let ((e-10 (vector-ref e-1 10))) (lambda (clam-0) (let ((e-25 (cdr e-10))) (case (vector-ref e-25 0) ((0) (vector 1 0))(else (vector 1 1)))))))))) eff-0) ext-0)))))))
(define CoreC-45Coverage-getNonCoveringRefs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-1 arg-2 eta-1)) (let ((e-1 (unbox e-6))) (let ((u--ds (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) (CoreC-45Coverage-n--12273-8009-u--noAssert arg-2 arg-1 arg-0 eta-1)) (LibrariesC-45DataC-45NameMap-toList (CoreC-45ContextC-45Context-refersTo e-1))))) (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-0 csegen-54 eta-2 eta-3))) u--ds '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--cases (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-2) (CoreC-45Coverage-n--12273-8008-u--isCase arg-2 arg-1 arg-0 eta-2)) e-7))) (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Coverage-getNonCoveringRefs arg-0 arg-1 eta-3 eta-4))) u--cases '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-filterM (lambda (eta-4) (lambda (eta-5) (CoreC-45Coverage-n--12273-8010-u--notCovering arg-2 arg-1 arg-0 e-5 eta-4 eta-5))) u--ds) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-9 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-5) eta-5) e-8)))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((act-1 (let ((e-1 (car arg-1))) (((e-1 arg-2) e-2) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box e-5))))) eff-0) ext-0)))))))))
(define TTImpC-45ProcessDef-n--28055-17444-u--simplePat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (case (vector-ref arg-13 0) ((0) 1) ((10) 1) ((5) (let ((e-13 (vector-ref arg-13 4))) (TTImpC-45ProcessDef-n--28055-17444-u--simplePat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-13)))(else 0))))
(define TTImpC-45ProcessDef-n--28055-17440-u--catchAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (let ((e-2 (vector-ref arg-12 2))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (TTImpC-45ProcessDef-n--28055-17444-u--simplePat arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) (CoreC-45TTC-45Term-getArgs e-2)))))
(define TTImpC-45ProcessDef-recoverable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-3 0) ((3) (let ((e-71 (vector-ref arg-3 2))) (let ((e-74 (vector-ref arg-3 5))) (lambda (clam-0) (case (vector-ref arg-4 0) ((3) (let ((e-88 (vector-ref arg-4 2))) (let ((e-91 (vector-ref arg-4 5))) (let ((sc2 (CoreC-45Name-u--C-47C-61_Eq_Name e-71 e-88))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-1 ((CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-74 e-91)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cond ((equal? e-5 1) 0) (else 1)))))) eff-0) clam-0))))))))))) ((8) (vector 1 0)) ((10) (vector 1 0)) ((0) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-1) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc3 1) (vector 1 0)) (else (let ((act-1 ((CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53)) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cond ((equal? e-5 1) 0) (else 1)))))) eff-0) clam-1))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-2) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-3) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-4) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-3) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-6) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-7) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))))))))) ((10) (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-4) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc3 1) (vector 1 0)) (else (let ((act-1 ((CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53)) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cond ((equal? e-5 1) 0) (else 1)))))) eff-0) clam-4))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-5) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-10) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-11) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-6) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-13) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-14) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))))))))) ((0) (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-7) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc3 1) (vector 1 0)) (else (let ((act-1 ((CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53)) clam-7))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cond ((equal? e-5 1) 0) (else 1)))))) eff-0) clam-7))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-8) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-17) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-18) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-9) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-20) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-21) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))))))(else (case (vector-ref arg-4 0) ((3) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((2) (let ((e-42 (vector-ref arg-3 3))) (let ((e-44 (vector-ref arg-3 5))) (lambda (clam-10) (case (vector-ref arg-4 0) ((2) (let ((e-51 (vector-ref arg-4 3))) (let ((e-53 (vector-ref arg-4 5))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-42 e-51))) (cond ((equal? sc2 1) (vector 1 0)) (else (let ((act-1 ((CoreC-45Core-anyM (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-mismatch arg-0 arg-1 arg-2 eta-0 eta-1))) (DataC-45List-u--zipWith_Zippable_List (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-curry (lambda (eta-2) (PreludeC-45Interfaces-mapHom (vector (lambda (u--d) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9201) (lambda (arg-9208) (lambda (arg-9215) (let ((e-2 (car arg-9215))) (let ((e-3 (cdr arg-9215))) (cons (arg-9201 e-2) (arg-9208 e-3))))))))))) (lambda (u--b) (lambda (u--c) (lambda (u--a) (lambda (arg-9229) (lambda (arg-9236) (let ((e-2 (car arg-9236))) (let ((e-3 (cdr arg-9236))) (cons (arg-9229 e-2) e-3)))))))) (lambda (u--a) (lambda (u--d) (lambda (u--b) (lambda (arg-9243) (lambda (arg-9250) (let ((e-2 (car arg-9250))) (let ((e-3 (cdr arg-9250))) (cons e-2 (arg-9243 e-3)))))))))) (lambda (eta-3) (Builtin-snd eta-3)) eta-2)) eta-0 eta-1))) e-44 e-53)) clam-10))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cond ((equal? e-5 1) 0) (else 1)))))) eff-0) clam-10))))))))))) ((8) (vector 1 0))(else (vector 1 1))))))) ((8) (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 0)))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-11) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-24) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-25) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))))))(else (case (vector-ref arg-4 0) ((2) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((1) (lambda (clam-12) (case (vector-ref arg-4 0) ((1) (let ((e-17 (vector-ref arg-4 2))) (case (vector-ref e-17 0) ((1) (vector 1 1))(else (vector 1 0)))))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0)))))) ((8) (let ((e-6 (vector-ref arg-3 2))) (lambda (clam-27) (case (vector-ref arg-4 0) ((8) (let ((e-24 (vector-ref arg-4 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-6 e-24)))) ((0) (vector 1 0))(else (vector 1 0)))))) ((0) (lambda (clam-28) (case (vector-ref arg-4 0) ((8) (vector 1 0))(else (vector 1 0)))))(else (lambda (eta-0) (vector 1 0))))))))))))))
(define TTImpC-45ProcessDef-recoverableErr (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-0 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 3))) (let ((e-3 (vector-ref arg-2 4))) (let ((e-4 (vector-ref arg-2 5))) (let ((e-5 (vector-ref arg-2 6))) (let ((u--defs (let ((e-37 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (let ((e-35 (vector-ref arg-1 3))) (let ((e-34 (vector-ref arg-1 4))) (let ((e-33 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (let ((e-31 (vector-ref arg-1 31))) (let ((e-32 (vector-ref arg-1 32))) (vector e-2 e-37 e-36 e-35 e-34 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "coverage.recover" 10 (lambda () (DataC-45String-fastUnlines (cons "Recovering from CantConvert?" (cons "Checking:" (cons (string-append "  " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-0 e-6)) (cons (string-append "  " (CoreC-45Value-u--show_Show_C-40NFC-32C-36freeC-41 e-0 e-7)) '())))))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else ((TTImpC-45ProcessDef-recoverable arg-0 e-0 u--defs e-6 e-7) eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((2) (let ((e-6 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 3))) (let ((e-9 (vector-ref arg-2 4))) (let ((e-10 (vector-ref arg-2 5))) (let ((e-11 (vector-ref arg-2 6))) (let ((u--defs (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-38 (vector-ref arg-1 6))) (let ((e-37 (vector-ref arg-1 7))) (let ((e-36 (vector-ref arg-1 8))) (let ((e-35 (vector-ref arg-1 9))) (let ((e-34 (vector-ref arg-1 10))) (let ((e-33 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (let ((e-23 (vector-ref arg-1 23))) (let ((e-24 (vector-ref arg-1 24))) (let ((e-25 (vector-ref arg-1 25))) (let ((e-26 (vector-ref arg-1 26))) (let ((e-27 (vector-ref arg-1 27))) (let ((e-28 (vector-ref arg-1 28))) (let ((e-29 (vector-ref arg-1 29))) (let ((e-30 (vector-ref arg-1 30))) (let ((e-31 (vector-ref arg-1 31))) (let ((e-32 (vector-ref arg-1 32))) (vector e-8 e-1 e-2 e-3 e-4 e-5 e-38 e-37 e-36 e-35 e-34 e-33 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-6 u--defs e-9 e-11) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45ProcessDef-recoverable arg-0 e-6 u--defs e-5 e-12))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))) ((45) (let ((e-15 (vector-ref arg-2 4))) (lambda (clam-0) (cond ((equal? e-15 3) (vector 1 1))(else (vector 1 0)))))) ((4) (lambda (eta-0) (vector 1 0))) ((21) (let ((e-23 (vector-ref arg-2 1))) (CoreC-45Core-anyM (lambda (eta-0) (TTImpC-45ProcessDef-recoverableErr arg-0 arg-1 eta-0)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-23)))) ((5) (let ((e-30 (vector-ref arg-2 7))) (TTImpC-45ProcessDef-recoverableErr arg-0 arg-1 e-30)))(else (lambda (eta-0) (vector 1 0))))))
(define TTImpC-45Unelab-unelabNoPatvars (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 2 ) '() arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (Builtin-fst e-5))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDef-n--28121-17567-u--closeEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (lambda (clam-0) (case (vector-ref arg-16 0) ((0) (let ((e-2 (vector-ref arg-16 2))) (let ((e-3 (vector-ref arg-16 3))) (let ((e-4 (vector-ref arg-16 4))) (case (vector-ref e-3 0) ((3) (let ((act-1 (((e-4 arg-15) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 arg-3 (vector 0 ) e-2))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ProcessDef-n--28121-17567-u--closeEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-5))) eff-0) clam-0))))))(else (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-11 '() arg-15 '() arg-16 clam-0)))))))(else (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-11 '() arg-15 '() arg-16 clam-0))))))
(define TTImpC-45ProcessDef-n--28055-17442-u--checkImpossible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-1 (TTImpC-45Unelab-unelabNoPatvars '() arg-11 '() arg-14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--itm (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-5))) (lambda (eta-0) (CoreC-45UnifyState-handleUnify arg-11 arg-9 0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-11))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45ContextC-45Log-log arg-11 "declare.def.impossible" 3 (lambda () (string-append "Checking for impossibility: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--itm))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Context-isUnboundImplicits arg-11 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Context-setUnboundImplicits arg-11 1) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (TTImpC-45BindImplicits-bindNames arg-11 0 u--itm eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-3 (cdr e-10))) (let ((act-7 ((CoreC-45Context-setUnboundImplicits arg-11 e-8) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 ((TTImpC-45Elab-elabTerm '() arg-11 arg-10 arg-9 arg-8 arg-7 arg-12 (vector 1 arg-13) '() '() '() (vector 16 arg-3 (vector 2 ) e-3) '()) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-13 (car e-12))) (let ((act-9 (let ((act-9 (unbox arg-11))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-14 (vector-ref act-9 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-10 (CoreC-45Normalise-normaliseHoles arg-11 '() e-14 '() e-13 eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-15 (vector-ref act-10 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-11 (TTImpC-45ProcessDef-hasEmptyPat '() arg-11 e-14 '() e-15 eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-16 (vector-ref act-11 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-11 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-16 1) (let ((act-12 (CoreC-45ContextC-45Log-log arg-11 "declare.def.impossible" 5 (lambda () "Some empty pat") clam-2))) (case (vector-ref act-12 0) ((0) (let ((e-17 (vector-ref act-12 1))) (vector 0 e-17))) (else (let ((act-13 (let ((act-13 (set-box! arg-11 e-6))) (vector 1 act-13)))) (case (vector-ref act-13 0) ((0) (let ((e-18 (vector-ref act-13 1))) (vector 0 e-18))) (else (vector 1 '())))))))) (else (let ((act-12 (CoreC-45ContextC-45Log-log arg-11 "declare.def.impossible" 5 (lambda () "No empty pat") clam-2))) (case (vector-ref act-12 0) ((0) (let ((e-17 (vector-ref act-12 1))) (vector 0 e-17))) (else (let ((act-13 (CoreC-45Context-clearDefs e-6 clam-2))) (case (vector-ref act-13 0) ((0) (let ((e-18 (vector-ref act-13 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-14 (let ((act-14 ((CoreC-45NormaliseC-45Eval-nf arg-11 '() e-18 '() e-15) eta-6))) (case (vector-ref act-14 0) ((0) (let ((e-19 (vector-ref act-14 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-14 1))) ((let ((eff-0 (TTImpC-45ProcessDef-n--28121-17567-u--closeEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-13 arg-12 e-18 e-19))) eff-0) eta-6))))))) (case (vector-ref act-14 0) ((0) (let ((e-19 (vector-ref act-14 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-15 (let ((act-15 (set-box! arg-11 e-6))) (vector 1 act-15)))) (case (vector-ref act-15 0) ((0) (let ((e-20 (vector-ref act-15 1))) (vector 0 e-20))) (else (vector 1 (box e-19)))))))) eff-0) eta-6)))))))) eff-0) clam-2))))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) clam-1))))))))) eff-0) clam-0)))))))))))) eff-0) eta-3))))))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))) (lambda (u--err) (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-11))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45ProcessDef-recoverableErr arg-11 e-6 u--err) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-7 1) (vector 1 (box arg-14))) (else (vector 1 '())))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) eta-0))))) eff-0) ext-0)))))))
(define TTImpC-45Impossible-n--8191-12776-u--sameRet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1)))(else (case (vector-ref arg-5 0) ((1) (lambda (eta-0) (vector 1 1))) ((9) (lambda (eta-0) (vector 1 1))) ((3) (let ((e-19 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((3) (let ((e-31 (vector-ref arg-6 2))) (lambda (eta-0) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-19 e-31)))))(else (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45Impossible-n--8191-12776-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 0)))))))(else (vector 1 0)))))))) ((8) (let ((e-25 (vector-ref arg-5 2))) (case (vector-ref arg-6 0) ((8) (let ((e-37 (vector-ref arg-6 2))) (lambda (eta-0) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-25 e-37)))))(else (lambda (clam-1) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45Impossible-n--8191-12776-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10))) eff-0) eta-0)))))))) eff-0) clam-1))))))(else (vector 1 0)))))))(else (vector 1 0)))))))) ((10) (case (vector-ref arg-6 0) ((10) (lambda (eta-0) (vector 1 1)))(else (lambda (clam-2) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45Impossible-n--8191-12776-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10))) eff-0) eta-0)))))))) eff-0) clam-2))))))(else (vector 1 0)))))))(else (vector 1 0)))))))(else (lambda (clam-3) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45Impossible-n--8191-12776-u--sameRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10))) eff-0) eta-0)))))))) eff-0) clam-3))))))(else (vector 1 0)))))))(else (vector 1 0))))))))))
(define TTImpC-45Impossible-match (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45Impossible-n--8191-12776-u--sameRet e-2 e-6 e-7 arg-1 arg-0 arg-1 e-8))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define TTImpC-45Impossible-dropNoMatch (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (if (null? arg-1) (lambda (eta-0) (vector 1 arg-2)) (let ((e-2 (unbox arg-1))) (CoreC-45Core-filterM (lambda (eta-0) (TTImpC-45Impossible-match arg-0 e-2 (let ((e-4 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-4 (let ((e-6 (car e-3))) (let ((e-5 (cdr e-3))) (cons e-6 (let ((e-27 (vector-ref e-5 2))) e-27))))))))) arg-2))) (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (if (null? e-5) (lambda (eta-0) (vector 1 (cons e-4 '()))) (if (null? arg-1) (lambda (eta-0) (vector 1 arg-2)) (let ((e-2 (unbox arg-1))) (CoreC-45Core-filterM (lambda (eta-0) (TTImpC-45Impossible-match arg-0 e-2 (let ((e-6 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-6 (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-8 (let ((e-29 (vector-ref e-7 2))) e-29))))))))) arg-2)))))))))
(define TTImpC-45Impossible-badClause (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (CoreC-45TTC-45Term-getLoc arg-1) (string-append "Badly formed impossible clause " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-1268 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2715 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2715 u--d u--x))))) (cons arg-1 (cons arg-2 (cons arg-3 arg-4)))))) ext-0)))
(define TTImpC-45Impossible-nextVar (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (bs+ e-5 1 63)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 1 arg-1 (vector 0 ) (vector 2 "imp" e-5))))))))) eff-0) ext-0)))))))
(define TTImpC-45Impossible-processArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-3 0) ((0) (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((e-6 (vector-ref arg-3 3))) (let ((e-7 (vector-ref arg-3 4))) (case (vector-ref e-6 0) ((2) (let ((e-11 (vector-ref e-6 3))) (let ((e-12 (vector-ref e-6 4))) (case (vector-ref e-11 0) ((1) (if (null? arg-4) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-5 arg-6))) (if (null? sc5) (lambda (eta-1) (TTImpC-45Impossible-badClause arg-2 '() arg-5 arg-6 eta-1)) (let ((e-1 (unbox sc5))) (lambda (clam-0) (let ((e-14 (car e-1))) (let ((e-13 (cdr e-1))) (let ((e-15 (cdr e-14))) (let ((act-2 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 (box e-12) '() '() '()) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-17)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-17) e-18 '() arg-5 e-13))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))))))) eff-0) eta-0)))))) (let ((e-17 (car arg-4))) (let ((e-18 (cdr arg-4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-17 (box e-12) '() '() '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (((e-7 e-13) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-8)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-8) e-14 e-18 arg-5 arg-6))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((0) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc4 (TTImpC-45ElabC-45App-findNamed e-5 arg-6))) (if (null? sc4) (lambda (eta-1) (let ((act-2 (TTImpC-45Impossible-nextVar arg-1 e-4 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-13)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-13) e-14 arg-4 arg-5 arg-6))) eff-0) eta-2)))))))) eff-0) eta-1)))))) (let ((e-2 (unbox sc4))) (lambda (clam-2) (let ((e-14 (car e-2))) (let ((e-13 (cdr e-2))) (let ((e-15 (cdr e-14))) (let ((act-2 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 (box e-12) '() '() '()) clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-17)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-17) e-18 arg-4 arg-5 e-13))) eff-0) eta-1)))))))) eff-0) clam-2)))))))))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (if (null? arg-5) (let ((sc5 (TTImpC-45ElabC-45App-findNamed e-5 arg-6))) (if (null? sc5) (lambda (eta-1) (let ((act-2 (TTImpC-45Impossible-nextVar arg-1 e-4 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-13)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-13) e-14 arg-4 '() arg-6))) eff-0) eta-2)))))))) eff-0) eta-1)))))) (let ((e-2 (unbox sc5))) (lambda (clam-3) (let ((e-14 (car e-2))) (let ((e-13 (cdr e-2))) (let ((e-15 (cdr e-14))) (let ((act-2 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 (box e-12) '() '() '()) clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-17)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-17) e-18 arg-4 '() e-13))) eff-0) eta-1)))))))) eff-0) clam-3)))))))))))) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (lambda (eta-1) (let ((act-2 ((TTImpC-45Impossible-mkTerm arg-0 arg-1 e-1 (box e-12) '() '() '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (((e-7 e-8) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() e-13)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 4 e-4 arg-2 e-13) e-14 arg-4 e-2 arg-6))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))(else (if (null? arg-4) (if (null? arg-5) (lambda (clam-4) (if (null? arg-6) (vector 1 arg-2) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 clam-4))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))))))))(else (if (null? arg-4) (if (null? arg-5) (lambda (clam-5) (if (null? arg-6) (vector 1 arg-2) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 clam-5))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))))))))))(else (if (null? arg-4) (if (null? arg-5) (lambda (clam-6) (if (null? arg-6) (vector 1 arg-2) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 clam-6))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0))) (lambda (eta-0) (TTImpC-45Impossible-badClause arg-2 arg-4 arg-5 arg-6 eta-0)))))))
(define TTImpC-45Impossible-buildApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getPrimitiveNames arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-832 arg-3 e-6))) (cond ((equal? sc2 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't deal with constants here yet") eta-1)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Context-lookupNameBy (lambda (eta-2) eta-2) arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (if (null? arg-4) (vector 1 '()) (let ((e-2 (unbox arg-4))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() e-5 e-2))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-3))) eta-2))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (TTImpC-45Impossible-dropNoMatch arg-0 e-9 e-8))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (if (null? e-9) (lambda (eta-3) (CoreC-45Context-ambiguousName arg-0 arg-2 arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) e-9) eta-3)) (let ((e-1 (car e-9))) (let ((e-2 (cdr e-9))) (if (null? e-1) (lambda (eta-3) (CoreC-45Context-ambiguousName arg-0 arg-2 arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) e-9) eta-3)) (let ((e-10 (cdr e-1))) (lambda (clam-0) (if (null? e-10) (CoreC-45Context-ambiguousName arg-0 arg-2 arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) e-9) clam-0) (let ((e-13 (car e-10))) (let ((e-12 (cdr e-10))) (if (null? e-2) (let ((act-6 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() (let ((e-32 (vector-ref e-12 2))) e-32)) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--head (let ((e-18 (vector-ref e-12 18))) (case (vector-ref e-18 0) ((5) (let ((e-37 (vector-ref e-18 1))) (let ((e-36 (vector-ref e-18 2))) (vector 2 e-37 e-36)))) ((6) (let ((e-42 (vector-ref e-18 1))) (let ((e-41 (vector-ref e-18 2))) (vector 3 e-42 e-41))))(else (vector 1 )))))) (TTImpC-45Impossible-processArgs arg-0 arg-1 (vector 1 arg-2 u--head (vector 8 e-13)) e-14 arg-5 arg-6 arg-7)))) eff-0) clam-0))))) (CoreC-45Context-ambiguousName arg-0 arg-2 arg-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) e-9) clam-0))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45Impossible-mkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (lambda (eta-0) (TTImpC-45Impossible-buildApp arg-0 arg-1 e-1 e-2 arg-3 arg-4 arg-5 arg-6 eta-0))))) ((18) (let ((e-8 (vector-ref arg-2 5))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-8 arg-3 arg-4 arg-5 arg-6))) ((8) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-11 arg-3 (cons e-12 arg-4) arg-5 arg-6)))) ((9) (let ((e-15 (vector-ref arg-2 2))) (let ((e-16 (vector-ref arg-2 3))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-15 arg-3 arg-4 (cons e-16 arg-5) arg-6)))) ((10) (let ((e-19 (vector-ref arg-2 2))) (let ((e-20 (vector-ref arg-2 3))) (let ((e-21 (vector-ref arg-2 4))) (TTImpC-45Impossible-mkTerm arg-0 arg-1 e-19 arg-3 arg-4 arg-5 (cons (cons e-20 e-21) arg-6)))))) ((28) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (lambda (eta-0) (vector 1 (vector 9 e-23 e-24))))))(else (lambda (eta-0) (TTImpC-45Impossible-nextVar arg-1 (TTImpC-45TTImp-getFC arg-2) eta-0))))))
(define TTImpC-45Impossible-n--9677-14149-u--addEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-5) '() (let ((e-3 (cdr arg-5))) (let ((e-8 (car arg-7))) (let ((e-9 (cdr arg-7))) (let ((sc2 (CoreC-45TTC-45Binder-isLet e-8))) (cond ((equal? sc2 1) (TTImpC-45Impossible-n--9677-14149-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 e-9)) (else (cons (vector 32 arg-6 0) (TTImpC-45Impossible-n--9677-14149-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-3 arg-6 e-9)))))))))))
(define TTImpC-45Impossible-n--9677-14151-u--expandNest (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((sc1 (DataC-45List-lookup csegen-832 e-2 arg-2))) (if (null? sc1) (vector 0 e-1 e-2) (let ((e-3 (unbox sc1))) (if (null? e-3) (vector 0 e-1 e-2) (let ((e-4 (car e-3))) (let ((e-5 (cdr e-3))) (if (null? e-4) (vector 0 e-1 e-2) (let ((e-7 (unbox e-4))) (if (null? e-5) (vector 0 e-1 e-2) (vector 0 e-1 e-7)))))))))))))(else arg-5))))
(define TTImpC-45Impossible-n--9677-14150-u--applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((8) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (vector 8 e-1 (TTImpC-45Impossible-n--9677-14150-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-2) e-3))))) ((9) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (let ((e-7 (vector-ref arg-5 3))) (vector 9 e-5 (TTImpC-45Impossible-n--9677-14150-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-6) e-7))))) ((10) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (let ((e-11 (vector-ref arg-5 3))) (let ((e-12 (vector-ref arg-5 4))) (vector 10 e-9 (TTImpC-45Impossible-n--9677-14150-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 e-10) e-11 e-12))))))(else (TTImpC-45TTImp-apply (TTImpC-45Impossible-n--9677-14151-u--expandNest arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (TTImpC-45Impossible-n--9677-14149-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-0 (TTImpC-45TTImp-getFC arg-5) arg-3))))))
(define TTImpC-45Impossible-getImpossibleTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.Normalise.Quote.QVar" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45Impossible-mkTerm arg-1 e-5 (TTImpC-45Impossible-n--9677-14150-u--applyEnv arg-0 arg-4 arg-3 arg-2 arg-1 arg-4) '() '() '() '()))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDef-n--28055-17443-u--getClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (case (vector-ref arg-12 0) ((0) (let ((e-2 (vector-ref arg-12 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 (TTImpC-45Impossible-getImpossibleTerm arg-0 arg-11 arg-4 arg-5 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-11 "declare.def.impossible" 3 (lambda () (string-append "Generated impossible LHS: " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-5))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (box (vector '() '() e-5 (vector 10 (TTImpC-45TTImp-getFC e-2) (vector 1 ))))))))))) eff-0) eta-0)))))) (lambda (u--e) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-11 "declare.def" 5 (lambda () (string-append "Error in getClause " (CoreC-45Core-u--show_Show_Error u--e))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 '())))))) ext-0))) (else (let ((e-5 (vector-ref arg-12 1))) (vector 1 (box e-5)))))))
(define TTImpC-45ProcessDef-n--28055-17441-u--checkCoverage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ProcessDef-n--28055-17443-u--getClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0 eta-1))) arg-15 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-toFullNames arg-11 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-2583 arg-7719 arg-7722 eta-3)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-2583 arg-7729 arg-7732 eta-3))))) eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-log arg-11 "declare.def" 5 (lambda () (DataC-45String-fastUnlines (cons "Using clauses :" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (string-append "  " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-2619 eta-2))) e-6)))) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--covcs (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) eta-1) e-5))) (let ((act-3 (CoreC-45CaseC-45CaseBuilder-getPMDef arg-11 arg-3 (box arg-14) (vector 8 arg-12) arg-13 u--covcs eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((act-4 (CoreC-45ContextC-45Log-unverifiedLogC arg-11 "declare.def" 3 (lambda (eta-1) (let ((act-4 (CoreC-45Context-toFullNames arg-11 csegen-2622 e-9 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append "Working from " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-2 e-10)))))) eff-0) eta-1)))))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (let ((sc6 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) (TTImpC-45ProcessDef-n--28055-17440-u--catchAll arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1)) u--covcs))) (cond ((equal? sc6 1) (let ((act-5 (CoreC-45ContextC-45Log-unverifiedLogC arg-11 "declare.def" 3 (lambda (eta-1) (let ((act-5 (CoreC-45Context-getFullName arg-11 (vector 8 arg-12) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Catch all case in " (cons (CoreC-45Name-u--show_Show_Name e-11) '()))))))) eff-0) eta-1)))))) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (vector 1 '()))))) (else (CoreC-45Coverage-getMissing e-2 arg-11 arg-3 (vector 8 arg-12) e-9 clam-0)))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-6 (CoreC-45ContextC-45Log-unverifiedLogC arg-11 "declare.def" 3 (lambda (eta-2) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-toFullNames arg-11 csegen-68 eta-3 eta-4))) e-11 '()) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45Context-getFullName arg-11 (vector 8 arg-12) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (string-append "Initially missing in " (string-append (CoreC-45Name-u--show_Show_Name e-13) (string-append ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() csegen-969 e-12))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (TTImpC-45ProcessDef-n--28055-17442-u--checkImpossible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14 eta-2 eta-3))) e-11 '()) eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-8 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Coverage-checkMatched arg-11 u--covcs eta-3 eta-4))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-3) eta-3) e-13) '()) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--miss (DataC-45List-catMaybes e-14))) (lambda (clam-1) (let ((sc10 (DataC-45List-isNil u--miss))) (cond ((equal? sc10 1) (let ((act-9 (CoreC-45Coverage-getNonCoveringRefs arg-11 arg-3 (vector 8 arg-12) clam-1))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-15) (vector 1 (vector 0 )) (CoreC-45Context-toFullNames arg-11 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_Covering arg-7719 arg-7722 eta-3)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-3) (CoreC-45Context-u--resolved_HasNames_Covering arg-7729 arg-7732 eta-3))))) (vector 2 e-15) clam-2))))) eff-0) clam-1)))))) (else (vector 1 (vector 1 u--miss))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) clam-0)))))))))))))) eff-0) eta-0)))))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setDefaultTotalityOption (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-50 (vector-ref e-36 0))) (let ((e-44 (vector-ref e-36 1))) (let ((e-46 (vector-ref e-36 3))) (let ((e-47 (vector-ref e-36 4))) (let ((e-48 (vector-ref e-36 5))) (let ((e-49 (vector-ref e-36 6))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector e-50 e-44 arg-1 e-46 e-47 e-48 e-49) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ProcessDef-n--28055-17445-u--withTotality (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13 arg-14 ext-0) (let ((act-1 (CoreC-45Context-getDefaultTotalityOption arg-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-setDefaultTotalityOption arg-11 arg-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Core-u--catch_Catchable_Core_Error (arg-14) (lambda (u--error) (lambda (eta-1) (let ((act-3 ((CoreC-45Context-setDefaultTotalityOption arg-11 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--error eta-1)))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Context-setDefaultTotalityOption arg-11 e-5) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDef-processDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 arg-10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Context-withDefStacked arg-1 e-5 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45ProcessDef-lookupOrAddAlias arg-0 arg-2 arg-1 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5 arg-11) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-3) (CoreC-45Context-noDeclaration arg-1 arg-9 e-5 eta-3)) (let ((e-1 (unbox e-7))) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((0) (let ((u--ty (let ((e-47 (vector-ref e-1 2))) e-47))) (let ((u--hashit (let ((sc5 (CoreC-45TT-u--C-61C-61_Eq_Visibility (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-40 (vector-ref e-1 9))) e-40)) 2))) (cond ((equal? sc5 1) 1) (else (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 0 ) (let ((e-37 (vector-ref e-1 12))) e-37))))))) (let ((u--mult (let ((sc5 (AlgebraC-45Semiring-isErased csegen-931 (let ((e-42 (vector-ref e-1 7))) e-42)))) (cond ((equal? sc5 1) csegen-30) (else csegen-1416))))) (lambda (eta-3) (let ((act-4 (CoreC-45Context-resolveName arg-1 e-5 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-27 (vector-ref act-4 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "declare.def" 5 (lambda () (string-append "Traversing clauses of " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " with mult " (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega u--mult))))) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-28 (vector-ref act-5 1))) (vector 0 e-28))) (else (let ((act-6 (CoreC-45Context-getDefaultTotalityOption arg-1 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-29 (vector-ref act-6 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--treq (DataC-45Maybe-fromMaybe (lambda () e-29) (CoreC-45ContextC-45Context-findSetTotal (let ((e-40 (vector-ref e-1 12))) e-40))))) (lambda (eta-5) (let ((act-7 (TTImpC-45ProcessDef-n--28055-17445-u--withTotality arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--treq (lambda () (CoreC-45Core-traverseC-39 (lambda (eta-6) (lambda (eta-7) (TTImpC-45ProcessDef-checkClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--mult (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-43 (vector-ref e-1 9))) e-43)) u--treq u--hashit e-27 arg-6 arg-7 arg-8 eta-6 eta-7))) arg-11 '())) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-30 (vector-ref act-7 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--pats (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-6) (TTImpC-45ProcessDef-toPats eta-6)) (DataC-45Either-rights e-30)))) (lambda (eta-6) (let ((act-8 (CoreC-45ContextC-45Log-logTime arg-1 3 (lambda () (string-append "Building compile time case tree for " (CoreC-45Name-u--show_Show_Name e-5))) (lambda (eta-7) (CoreC-45CaseC-45CaseBuilder-getPMDef arg-1 arg-9 (box u--mult) e-5 u--ty (DataC-45Either-rights e-30) eta-7)) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-31 (vector-ref act-8 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-33 (car e-31))) (let ((e-32 (cdr e-31))) (let ((e-35 (car e-32))) (let ((e-34 (cdr e-32))) (let ((act-9 ((CoreC-45Core-traverse_ (lambda (eta-7) (TTImpC-45ProcessDef-warnUnreachable arg-1 eta-7)) e-34) clam-0))) (case (vector-ref act-9 0) ((0) (let ((e-36 (vector-ref act-9 1))) (vector 0 e-36))) (else (let ((act-10 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "declare.def" 2 (lambda (eta-7) (let ((act-10 (CoreC-45Context-toFullNames arg-1 csegen-2622 e-35 eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-37 (vector-ref act-10 1))) (vector 0 e-37))) (else (let ((e-37 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (string-append "Case tree for " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ": " (CoreC-45CaseC-45CaseTree-u--show_Show_C-40CaseTreeC-32C-36varsC-41 e-33 e-37)))))))) eff-0) eta-7)))))) clam-0))) (case (vector-ref act-10 0) ((0) (let ((e-37 (vector-ref act-10 1))) (vector 0 e-37))) (else (let ((act-11 (let ((act-11 (unbox arg-1))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-38 (vector-ref act-11 1))) (vector 0 e-38))) (else (let ((e-38 (vector-ref act-11 1))) ((let ((eff-0 (let ((u--pi (let ((sc15 (LibrariesC-45DataC-45NameMap-lookup e-5 (let ((e-46 (vector-ref e-38 25))) e-46)))) (if (null? sc15) CoreC-45ContextC-45Context-defaultPI (let ((e-39 (unbox sc15))) (let ((sc16 CoreC-45ContextC-45Context-defaultPI)) (let ((e-42 (vector-ref sc16 0))) (let ((e-41 (vector-ref sc16 1))) (vector e-42 e-41 e-39))))))))) (lambda (eta-7) (let ((act-12 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-8) (CoreC-45Context-addDef arg-1 (vector 8 e-27) (let ((e-61 (vector-ref e-1 0))) (let ((e-60 (vector-ref e-1 1))) (let ((e-59 (vector-ref e-1 2))) (let ((e-58 (vector-ref e-1 3))) (let ((e-57 (vector-ref e-1 4))) (let ((e-56 (vector-ref e-1 5))) (let ((e-55 (vector-ref e-1 6))) (let ((e-54 (vector-ref e-1 7))) (let ((e-53 (vector-ref e-1 8))) (let ((e-52 (vector-ref e-1 9))) (let ((e-51 (vector-ref e-1 10))) (let ((e-50 (vector-ref e-1 11))) (let ((e-49 (vector-ref e-1 12))) (let ((e-48 (vector-ref e-1 13))) (let ((e-47 (vector-ref e-1 14))) (let ((e-46 (vector-ref e-1 15))) (let ((e-45 (vector-ref e-1 16))) (let ((e-44 (vector-ref e-1 17))) (let ((e-42 (vector-ref e-1 19))) (let ((e-41 (vector-ref e-1 20))) (let ((e-40 (vector-ref e-1 21))) (let ((e-39 (vector-ref e-1 22))) (vector e-61 e-60 e-59 e-58 e-57 e-56 e-55 e-54 e-53 e-52 e-51 e-50 e-49 e-48 e-47 e-46 e-45 e-44 (vector 1 u--pi e-33 e-35 e-35 u--pats) e-42 e-41 e-40 e-39))))))))))))))))))))))) eta-8)) eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-39 (vector-ref act-12 1))) (vector 0 e-39))) (else (let ((act-13 (let ((sc16 (CoreC-45TT-u--C-61C-61_Eq_Visibility (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-53 (vector-ref e-1 9))) e-53)) 2))) (cond ((equal? sc16 1) (((let ((u--rmetas (CoreC-45CaseC-45CaseTree-getMetas e-35))) (lambda () (lambda (eta-8) (let ((act-13 (CoreC-45ContextC-45Log-log arg-1 "declare.def" 10 (lambda () (string-append "Saving from " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (LibrariesC-45DataC-45NameMap-keys u--rmetas)))))) eta-8))) (case (vector-ref act-13 0) ((0) (let ((e-40 (vector-ref act-13 1))) (vector 0 e-40))) (else ((CoreC-45Core-traverse_ (lambda (eta-9) (lambda (eta-10) (CoreC-45Context-addToSave arg-1 eta-9 eta-10))) (LibrariesC-45DataC-45NameMap-keys u--rmetas)) eta-8)))))))) eta-7)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-13 0) ((0) (let ((e-40 (vector-ref act-13 1))) (vector 0 e-40))) (else (let ((act-14 (let ((sc17 (let ((sc18 (CoreC-45Name-isUserName e-5))) (cond ((equal? sc18 1) (CoreC-45TT-u--C-47C-61_Eq_Visibility (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-54 (vector-ref e-1 9))) e-54)) 0)) (else 0))))) (cond ((equal? sc17 1) (((let ((u--tymetas (CoreC-45TT-getMetas (let ((e-61 (vector-ref e-1 2))) e-61)))) (lambda () (CoreC-45Core-traverse_ (lambda (eta-8) (lambda (eta-9) (CoreC-45Context-addToSave arg-1 eta-8 eta-9))) (LibrariesC-45DataC-45NameMap-keys u--tymetas))))) eta-7)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-14 0) ((0) (let ((e-41 (vector-ref act-14 1))) (vector 0 e-41))) (else (let ((act-15 (CoreC-45Context-addToSave arg-1 e-5 eta-7))) (case (vector-ref act-15 0) ((0) (let ((e-42 (vector-ref act-15 1))) (vector 0 e-42))) (else (let ((act-16 ((let ((eff-0 (lambda (world-0) (let ((act-16 (unbox arg-1))) (vector 1 act-16))))) (lambda (world-0) (let ((act-16 (eff-0 world-0))) (case (vector-ref act-16 0) ((0) (let ((e-43 (vector-ref act-16 1))) (vector 0 e-43))) (else (let ((e-43 (vector-ref act-16 1))) ((let ((eff-1 (lambda (world-1) (let ((act-17 (set-box! arg-1 (let ((e-76 (vector-ref e-43 0))) (let ((e-75 (vector-ref e-43 1))) (let ((e-74 (vector-ref e-43 2))) (let ((e-73 (vector-ref e-43 3))) (let ((e-72 (vector-ref e-43 4))) (let ((e-71 (vector-ref e-43 5))) (let ((e-70 (vector-ref e-43 6))) (let ((e-69 (vector-ref e-43 7))) (let ((e-68 (vector-ref e-43 8))) (let ((e-67 (vector-ref e-43 9))) (let ((e-66 (vector-ref e-43 10))) (let ((e-65 (vector-ref e-43 11))) (let ((e-64 (vector-ref e-43 12))) (let ((e-63 (vector-ref e-43 13))) (let ((e-62 (vector-ref e-43 14))) (let ((e-61 (vector-ref e-43 15))) (let ((e-60 (vector-ref e-43 16))) (let ((e-59 (vector-ref e-43 17))) (let ((e-58 (vector-ref e-43 18))) (let ((e-57 (vector-ref e-43 19))) (let ((e-56 (vector-ref e-43 20))) (let ((e-55 (vector-ref e-43 21))) (let ((e-54 (vector-ref e-43 22))) (let ((e-53 (vector-ref e-43 23))) (let ((e-52 (vector-ref e-43 24))) (let ((e-51 (vector-ref e-43 25))) (let ((e-50 (vector-ref e-43 26))) (let ((e-49 (vector-ref e-43 27))) (let ((e-48 (vector-ref e-43 28))) (let ((e-47 (vector-ref e-43 29))) (let ((e-46 (vector-ref e-43 30))) (let ((e-45 (vector-ref e-43 31))) (let ((e-44 (vector-ref e-43 32))) (vector e-76 e-75 e-74 e-73 e-72 e-71 e-70 e-69 e-68 e-67 e-66 e-65 e-64 e-63 e-62 e-61 e-60 e-59 e-58 e-57 e-56 (cons e-5 e-55) e-54 e-53 e-52 e-51 e-50 e-49 e-48 e-47 e-46 e-45 e-44))))))))))))))))))))))))))))))))))))) (vector 1 act-17))))) eff-1) world-0))))))) eta-7))) (case (vector-ref act-16 0) ((0) (let ((e-43 (vector-ref act-16 1))) (vector 0 e-43))) (else (let ((act-17 (CoreC-45Context-toResolvedNames arg-1 csegen-54 csegen-2366 eta-7))) (case (vector-ref act-17 0) ((0) (let ((e-44 (vector-ref act-17 1))) (vector 0 e-44))) (else (let ((e-44 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-18 (CoreC-45ContextC-45Log-logTime arg-1 3 (lambda () (string-append "Building size change graphs " (CoreC-45Name-u--show_Show_Name e-5))) (lambda (clam-1) (let ((sc21 (PreludeC-45Types-elem csegen-14 csegen-2376 1 arg-6))) (cond ((equal? sc21 1) (vector 1 (vector 0 ))) (else (let ((act-18 (TTImpC-45ProcessDef-calcRefs arg-1 0 e-44 (vector 8 e-27) clam-1))) (case (vector-ref act-18 0) ((0) (let ((e-45 (vector-ref act-18 1))) (vector 0 e-45))) (else (let ((act-19 (CoreC-45TerminationC-45CallGraph-calculateSizeChange arg-1 arg-9 e-5 clam-1))) (case (vector-ref act-19 0) ((0) (let ((e-46 (vector-ref act-19 1))) (vector 0 e-46))) (else (let ((e-46 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-20 (CoreC-45Context-setSizeChange arg-1 arg-9 e-5 e-46 eta-9))) (case (vector-ref act-20 0) ((0) (let ((e-47 (vector-ref act-20 1))) (vector 0 e-47))) (else (CoreC-45Termination-checkIfGuarded arg-1 arg-9 e-5 eta-9))))))) eff-0) clam-1)))))))))))) eta-8))) (case (vector-ref act-18 0) ((0) (let ((e-45 (vector-ref act-18 1))) (vector 0 e-45))) (else (let ((act-19 (let ((act-19 (unbox arg-2))) (vector 1 act-19)))) (case (vector-ref act-19 0) ((0) (let ((e-46 (vector-ref act-19 1))) (vector 0 e-46))) (else (let ((e-46 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-20 (CoreC-45ContextC-45Log-logTime arg-1 3 (lambda () (string-append "Checking Coverage " (CoreC-45Name-u--show_Show_Name e-5))) (lambda (eta-10) (TTImpC-45ProcessDef-n--28055-17441-u--checkCoverage arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-27 u--ty u--mult e-30 eta-10)) eta-9))) (case (vector-ref act-20 0) ((0) (let ((e-47 (vector-ref act-20 1))) (vector 0 e-47))) (else (let ((e-47 (vector-ref act-20 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-21 (CoreC-45Context-setCovering arg-1 arg-9 e-5 e-47 eta-10))) (case (vector-ref act-21 0) ((0) (let ((e-48 (vector-ref act-21 1))) (vector 0 e-48))) (else (let ((act-22 (let ((act-22 (set-box! arg-2 e-46))) (vector 1 act-22)))) (case (vector-ref act-22 0) ((0) (let ((e-49 (vector-ref act-22 1))) (vector 0 e-49))) (else (let ((sc26 (PreludeC-45Types-elem csegen-14 csegen-2376 1 arg-6))) (cond ((equal? sc26 1) (vector 1 (vector 0 ))) (else (TTImpC-45ProcessDef-compileRunTime arg-1 arg-2 arg-3 arg-4 arg-5 arg-9 e-44 eta-10))))))))))))) eff-0) eta-9)))))))) eff-0) eta-8))))))))))) eff-0) eta-7)))))))))))))))))))))))) eff-0) clam-0)))))))))))))))))) eff-0) eta-6))))))))) eff-0) eta-5))))))))) eff-0) eta-4))))))))))) eff-0) eta-3))))))))))(else (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-5) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))) eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDecls-processFailing (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-branch arg-1 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-5 (TTImpC-45ProcessDeclsC-45Totality-getTotalityErrors arg-1 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 ((CoreC-45Core-traverse_ (lambda (eta-6) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-6)) arg-11) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (TTImpC-45ProcessDeclsC-45Totality-getTotalityErrors arg-1 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--errs (DataC-45List-C-92C-92 (csegen-2282) e-11 e-9))) (if (null? u--errs) (lambda (eta-6) (let ((act-8 (CoreC-45UnifyState-checkDelayedHoles arg-3 arg-1 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-12) (vector 1 (box (vector 66 arg-9))) (let ((e-2 (unbox e-12))) (CoreC-45Core-u--throw_Catchable_Core_Error e-2 clam-1)))))) eff-0) eta-6)))))) (let ((e-1 (car u--errs))) (let ((e-2 (cdr u--errs))) (let ((errs-0 (cons e-1 e-2))) (lambda (clam-0) (if (null? arg-10) (vector 1 '()) (let ((e-3 (unbox arg-10))) (let ((act-8 (CoreC-45ContextC-45Log-log arg-1 "elab.failing" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-6) eta-6) (cons "Failing block based on " (cons (PreludeC-45Show-u--show_Show_String e-3) (cons " failed with " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-974) errs-0) '())))))) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 ((CoreC-45Core-anyM (lambda (eta-6) (IdrisC-45Error-checkError arg-1 arg-4 arg-5 e-3 eta-6)) errs-0) clam-0))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (cond ((equal? e-13 1) 0) (else 1))) (lambda (_-10649) (box (vector 67 arg-9 e-3 (cons e-1 e-2))))))))) eff-0) clam-0)))))))))))))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))) (lambda (u--err) (lambda (clam-2) (if (null? arg-10) (vector 1 '()) (let ((e-1 (unbox arg-10))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "elab.failing" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-4) eta-4) (cons "Failing block based on " (cons (PreludeC-45Show-u--show_Show_String e-1) (cons " failed with " (cons (CoreC-45Core-u--show_Show_Error u--err) '())))))) clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((IdrisC-45Error-checkError arg-1 arg-4 arg-5 e-1 u--err) clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (cond ((equal? e-10 1) 0) (else 1))) (lambda (_-10649) (box (vector 67 arg-9 e-1 (cons u--err '()))))))))) eff-0) clam-2)))))))))))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 (unbox arg-2))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (let ((act-7 (set-box! arg-3 e-5))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (let ((act-8 (set-box! arg-4 e-6))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 (set-box! arg-2 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-17 (vector-ref e-7 5))) (let ((e-16 (vector-ref e-7 6))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-16 (let ((e-20 (vector-ref e-10 7))) e-20) (let ((e-19 (vector-ref e-10 8))) e-19) (let ((e-18 (vector-ref e-10 9))) e-18)))))))))))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (let ((act-10 (set-box! arg-1 e-8))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (if (null? e-9) (vector 1 (vector 0 )) (let ((e-1 (unbox e-9))) (CoreC-45Core-u--throw_Catchable_Core_Error e-1 eta-5)))))))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessParams-extend (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (TTImpC-45ProcessParams-extend (cons e-2 arg-1) (cons e-3 arg-2) (vector 1 arg-3) (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-4) e-4))(else (cons arg-1 (cons arg-3 (cons arg-2 arg-4)))))))))(else (cons arg-1 (cons arg-3 (cons arg-2 arg-4)))))))
(define TTImpC-45ProcessParams-n--10652-8424-u--mkParamTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) (vector 29 arg-2) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-2 e-10 e-14 (box e-6) e-15 (TTImpC-45ProcessParams-n--10652-8424-u--mkParamTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3)))))))))))))
(define TTImpC-45ProcessParams-n--10652-8423-u--applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (CoreC-45Context-resolveName arg-10 arg-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 8 e-5) (cons '() (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVars arg-11 arg-12)) (lambda (u--fc) (lambda (u--nt) (CoreC-45UnifyState-applyToFull arg-11 u--fc (vector 1 u--fc u--nt (vector 8 e-5)) arg-12)))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessParams-case--processParams-8577 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (lambda (clam-0) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45Normalise-logEnv e-2 arg-10 "declare.param" 5 "Param env" e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (let ((act-2 (unbox arg-10))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--defNames (TTImpC-45TTImp-definedInBlock (let ((e-40 (vector-ref e-8 2))) e-40) arg-0))) (lambda (eta-0) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessParams-n--10652-8423-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-10 eta-1 eta-2))) u--defNames '()) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--nestBlock (PreludeC-45TypesC-45List-tailRecAppend e-9 e-11))) (CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl e-2 arg-10 arg-9 arg-8 arg-7 arg-6 '() u--nestBlock e-10 eta-1)) arg-0)))) eff-0) eta-0))))))))) eff-0) clam-0))))))))))))))))
(define TTImpC-45ProcessParams-processParams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--pty_raw (TTImpC-45ProcessParams-n--10652-8424-u--mkParamTy arg-10 arg-9 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-9))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-8 '() arg-0 (vector 16 arg-8 csegen-2373 u--pty_raw) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "declare.param" 10 (lambda () (string-append "Checking " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-5))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-8 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 -1 (vector 0 ) '() arg-6 arg-7 e-5 (CoreC-45NormaliseC-45Eval-gType arg-8 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (TTImpC-45ProcessParams-case--processParams-8577 arg-10 arg-9 arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--pty_raw e-5 e-7 e-8 (TTImpC-45ProcessParams-extend arg-0 arg-7 (vector 0 ) arg-6 e-8)))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))
(define CoreC-45Context-extendNS (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 (CoreC-45NameC-45Namespace-C-60C-46C-62 e-2 arg-1) e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define TTImpC-45ProcessRecord-n--10778-9284-u--displayParam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-2 (car arg-18))) (let ((e-3 (cdr arg-18))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (CoreC-45TTC-45Term-withPiInfo csegen-835 e-10 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (Algebra-showCount e-6) (cons (CoreC-45Name-u--show_Show_Name e-2) (cons " : " (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-11) '()))))))))))))))
(define TTImpC-45ProcessRecord-n--10778-9287-u--farg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-1 (vector-ref arg-18 0))) (let ((e-2 (vector-ref arg-18 1))) (let ((e-3 (vector-ref arg-18 2))) (let ((e-4 (vector-ref arg-18 3))) (let ((e-5 (vector-ref arg-18 4))) (cons (CoreC-45FC-virtualiseFC e-1) (cons (box e-4) (cons e-2 (cons e-3 e-5)))))))))))
(define TTImpC-45ProcessRecord-n--10778-9288-u--fname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((e-4 (vector-ref arg-18 3))) e-4)))
(define TTImpC-45ProcessRecord-n--10778-9290-u--mkTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-18) arg-19 (let ((e-2 (car arg-18))) (let ((e-3 (cdr arg-18))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (vector 1 e-6 e-14 e-18 e-10 e-19 (TTImpC-45ProcessRecord-n--10778-9290-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-3 arg-19)))))))))))))))
(define TTImpC-45ProcessRecord-n--10778-9292-u--paramNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-18)))
(define TTImpC-45ProcessRecord-n--10877-9360-u--jname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (cons (vector 2 ) (cons (box e-2) (cons csegen-30 (cons (vector 0 ) e-11))))))))))
(define TTImpC-45ProcessRecord-n--10778-9293-u--paramTelescope (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ProcessRecord-n--10877-9360-u--jname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) arg-18)))
(define TTImpC-45ProcessRecord-n--10879-9491-u--apply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) arg-20 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((1) (TTImpC-45ProcessRecord-n--10879-9491-u--apply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 8 (TTImpC-45TTImp-getFC arg-20) arg-20 e-10) e-3))(else (TTImpC-45ProcessRecord-n--10879-9491-u--apply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 10 (TTImpC-45TTImp-getFC arg-20) arg-20 e-6 e-10) e-3))))))))))))
(define TTImpC-45ProcessRecord-n--10778-9295-u--recTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (TTImpC-45ProcessRecord-n--10879-9491-u--apply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-19 arg-18 (vector 0 (CoreC-45FC-virtualiseFC arg-11) arg-18) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (cons (vector 0 (vector 2 ) e-2) e-10))))))) arg-19))))
(define TTImpC-45ProcessRecord-n--10778-9285-u--elabAsData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (let ((u--fc (CoreC-45FC-virtualiseFC arg-11))) (let ((u--conty (TTImpC-45ProcessRecord-n--10778-9290-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (TTImpC-45ProcessRecord-n--10778-9293-u--paramTelescope arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-20) (TTImpC-45ProcessRecord-n--10778-9290-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ProcessRecord-n--10778-9287-u--farg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 eta-0)) arg-0) (TTImpC-45ProcessRecord-n--10778-9295-u--recTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20))))) (let ((u--boundNames (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45ProcessRecord-n--10778-9292-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-20) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ProcessRecord-n--10778-9288-u--fname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 eta-0)) arg-0) arg-8)))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-17 u--fc '() u--boundNames u--conty eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--con (vector (CoreC-45FC-virtualiseFC u--fc) (vector 2 ) arg-19 e-5))) (let ((u--dt (vector 0 u--fc arg-18 '() arg-2 (cons u--con '())))) (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-17 "declare.record" 5 (lambda () (string-append "Record data type " (TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 csegen-65 u--dt))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-17 arg-16 arg-15 arg-14 arg-13 '() arg-9 arg-10 (vector 1 u--fc arg-6 arg-5 u--dt)) eta-1))))))))) eff-0) eta-0)))))))))))
(define CoreC-45Context-isPrefixRecordProjections (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) (let ((e-40 (vector-ref e-4 3))) (let ((e-44 (vector-ref e-40 6))) e-44)))))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define TTImpC-45ProcessRecord-projVis (lambda (arg-0) (cond ((equal? arg-0 2) 2)(else 0))))
(define TTImpC-45Utils-substNames (lambda (ext-0 ext-1 ext-2) (TTImpC-45Utils-substNamesC-39 0 ext-0 ext-1 ext-2)))
(define CoreC-45TTC-45Binder-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 (lambda (arg-1 ext-0 ext-1) (CoreC-45TTC-45Binder-eqPiInfoBy (lambda (eta-0) (lambda (eta-1) (let ((e-1 (car arg-1))) ((e-1 eta-0) eta-1)))) ext-0 ext-1)))
(define TTImpC-45ProcessRecord-n--10778-9283-u--countExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-19) (case (vector-ref arg-19 0) ((3) (let ((e-3 (vector-ref arg-19 3))) (let ((e-4 (vector-ref arg-19 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((1) (+ (TTImpC-45ProcessRecord-n--10778-9283-u--countExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-4) 1))(else (TTImpC-45ProcessRecord-n--10778-9283-u--countExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-4)))))(else 0)))))(else 0))))
(define TTImpC-45ProcessRecord-n--10778-9291-u--nestDrop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((u--assoc (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (PreludeC-45TypesC-45List-lengthTR e-10))))))) arg-9))) (CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-1 (CoreC-45Context-toFullNames arg-17 csegen-54 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-5 e-3))))) eff-0) clam-0))))))))) u--assoc '()))))
(define TTImpC-45ProcessRecord-n--10778-9286-u--elabGetters (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (case (vector-ref arg-25 0) ((3) (let ((e-1 (vector-ref arg-25 1))) (let ((e-2 (vector-ref arg-25 2))) (let ((e-3 (vector-ref arg-25 3))) (let ((e-4 (vector-ref arg-25 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--rig (let ((sc2 (AlgebraC-45Semiring-isErased csegen-931 e-7))) (cond ((equal? sc2 1) csegen-30) (else AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))) (let ((u--isVis (TTImpC-45ProcessRecord-projVis (LibrariesC-45DataC-45WithDefault-collapseDefault 0 arg-6)))) (let ((u--b (vector 2 e-6 e-7 e-8 e-9))) (let ((sc2 (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-21)))) (cond ((equal? sc3 1) 1) (else (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-8)))))) (cond ((equal? sc2 1) (TTImpC-45ProcessRecord-n--10778-9286-u--elabGetters arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (cons e-2 arg-18) arg-19 arg-20 arg-21 (let ((sc3 (let ((sc4 (CoreC-45TTC-45Binder-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 csegen-2838 e-8 (vector 1 )))) (cond ((equal? sc4 1) (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-8))) (cond ((equal? sc5 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc3 1) (+ arg-22 1)) (else arg-22))) arg-23 (cons u--b arg-24) e-4)) (else (let ((u--fldNameStr (CoreC-45Name-nameRoot e-2))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-17 (vector 1 (vector 1 u--fldNameStr)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-inCurrentNS arg-17 (vector 1 (vector 0 u--fldNameStr)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 ((TTImpC-45ProcessRecord-n--10778-9291-u--nestDrop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45Unelab-unelabNest arg-18 arg-17 e-11 arg-24 e-9))) eff-0) eta-2))))))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--tyC-39 (TTImpC-45Utils-substNames arg-8 arg-23 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-11)))) (lambda (eta-3) (let ((act-4 (CoreC-45ContextC-45Log-log arg-17 "declare.record.field" 5 (lambda () (string-append "Field type: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--tyC-39))) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((u--rname (vector 2 "rec" 0))) (let ((act-5 (TTImpC-45BindImplicits-bindTypeNames arg-17 arg-11 '() (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) arg-21) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (TTImpC-45ProcessRecord-n--10778-9288-u--fname arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 eta-4)) arg-0) arg-8)) (TTImpC-45ProcessRecord-n--10778-9290-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (TTImpC-45ProcessRecord-n--10778-9293-u--paramTelescope arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-21) (vector 1 e-1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box u--rname) (TTImpC-45ProcessRecord-n--10778-9295-u--recTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-19 arg-21) u--tyC-39)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--mkProjClaim (lambda (u--nm) (let ((u--ty (vector (vector 2 ) (vector 2 ) u--nm e-13))) (vector 0 e-1 u--rig u--isVis (cons (vector 1 ) '()) u--ty))))) (lambda (eta-4) (let ((act-6 (CoreC-45ContextC-45Log-log arg-17 "declare.record.projection" 5 (lambda () (string-append "Projection " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-13))))) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((act-7 ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-17 arg-16 arg-15 arg-14 arg-13 '() arg-9 arg-10 (u--mkProjClaim e-5)) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (let ((u--lhs_exp (TTImpC-45TTImp-apply (vector 0 e-1 arg-20) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45List-replicateTR '() arg-22 (vector 32 e-1 1)) (PreludeC-45TypesC-45List-tailRecAppend (let ((sc10 (CoreC-45TTC-45Binder-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 csegen-2838 e-8 (vector 1 )))) (cond ((equal? sc10 1) (cons (vector 17 (vector 2 ) u--fldNameStr) '())) (else '()))) (DataC-45List-replicateTR '() (TTImpC-45ProcessRecord-n--10778-9283-u--countExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-4) (vector 32 e-1 1))))))) (let ((u--lhs (vector 8 e-1 (vector 0 e-1 e-5) (let ((sc10 (CoreC-45TTC-45Binder-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 csegen-2838 e-8 (vector 1 )))) (cond ((equal? sc10 1) u--lhs_exp) (else (vector 10 e-1 u--lhs_exp (vector 1 (vector 0 u--fldNameStr)) (vector 17 e-1 u--fldNameStr)))))))) (let ((u--rhs (vector 0 (vector 2 ) (vector 1 (vector 0 u--fldNameStr))))) (let ((act-8 (CoreC-45ContextC-45Log-log arg-17 "declare.record.projection" 5 (lambda () (string-append "Projection " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--lhs) (string-append " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--rhs))))) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-16 (vector-ref act-8 1))) (vector 0 e-16))) (else (let ((act-9 ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-17 arg-16 arg-15 arg-14 arg-13 '() arg-9 arg-10 (vector 2 e-1 e-5 (cons (vector 0 e-1 u--lhs u--rhs) '()))) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-17 (vector-ref act-9 1))) (vector 0 e-17))) (else (let ((act-10 (let ((act-10 (CoreC-45Context-isPrefixRecordProjections arg-17 eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-18 (vector-ref act-10 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-10 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-18 1) (let ((act-11 (CoreC-45ContextC-45Log-log arg-17 "declare.record.projection.prefix" 5 (lambda () (string-append "Prefix projection " (string-append (CoreC-45Name-u--show_Show_Name e-10) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-13))))) clam-0))) (case (vector-ref act-11 0) ((0) (let ((e-19 (vector-ref act-11 1))) (vector 0 e-19))) (else (let ((act-12 ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-17 arg-16 arg-15 arg-14 arg-13 '() arg-9 arg-10 (u--mkProjClaim e-10)) clam-0))) (case (vector-ref act-12 0) ((0) (let ((e-20 (vector-ref act-12 1))) (vector 0 e-20))) (else (let ((lhs-0 (vector 0 e-1 e-10))) (let ((rhs-0 (vector 0 e-1 e-5))) (let ((act-13 (CoreC-45ContextC-45Log-log arg-17 "declare.record.projection.prefix" 5 (lambda () (string-append "Prefix projection " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 lhs-0) (string-append " = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 rhs-0))))) clam-0))) (case (vector-ref act-13 0) ((0) (let ((e-21 (vector-ref act-13 1))) (vector 0 e-21))) (else ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-17 arg-16 arg-15 arg-14 arg-13 '() arg-9 arg-10 (vector 2 e-1 e-10 (cons (vector 0 e-1 lhs-0 rhs-0) '()))) clam-0))))))))))))) (else (vector 1 (vector 0 ))))))) eff-0) eta-4))))))) (case (vector-ref act-10 0) ((0) (let ((e-18 (vector-ref act-10 1))) (vector 0 e-18))) (else (let ((act-11 (CoreC-45Context-isPrefixRecordProjections arg-17 eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-19 (vector-ref act-11 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-11 1))) ((let ((eff-0 (let ((u--updsC-39 (cond ((equal? e-19 1) (cons (cons e-2 (vector 8 e-1 (vector 0 e-1 e-10) (vector 0 e-1 u--rname))) arg-23)) (else (cons (cons e-2 (vector 8 e-1 (vector 0 e-1 e-5) (vector 0 e-1 u--rname))) arg-23))))) (TTImpC-45ProcessRecord-n--10778-9286-u--elabGetters arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (cons e-2 arg-18) arg-19 arg-20 arg-21 (let ((sc14 (CoreC-45TTC-45Binder-u--C-61C-61_Eq_C-40PiInfoC-32C-36tC-41 csegen-2838 e-8 (vector 1 )))) (cond ((equal? sc14 1) (+ arg-22 1)) (else arg-22))) u--updsC-39 (cons u--b arg-24) e-4)))) eff-0) eta-4))))))))))))))))))))))))))) eff-0) eta-3))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))))))(else (lambda (eta-0) (vector 1 (vector 0 ))))))))))(else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define CoreC-45Core-traverseSnocList (lambda (arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (CoreC-45Core-C-60C-42C-62 (let ((eff-0 (CoreC-45Core-traverseSnocList arg-2 e-2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-988 eff-0 eta-0))) (arg-2 e-3) clam-0)))))))
(define TTImpC-45ProcessRecord-n--10878-9811-u--addMissingNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-19) (lambda (eta-0) (let ((act-1 ((PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (CoreC-45Core-traverseSnocList eta-1 eta-2))) arg-20 (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (if (null? e-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Some names have disappeared?! " (cons (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-849 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2840 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2840 u--d u--x))))) e-3) '())))) clam-0) (let ((e-4 (unbox e-2))) (vector 1 (cons e-4 e-3))))))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((sc2 (DataC-45SnocList-u--null_Foldable_SnocList e-5))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-log arg-17 "declare.record.parameters" 50 (lambda () (DataC-45String-fastUnlines (cons "Decided to bind the following extra parameters:" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (string-append "  " (TTImpC-45ProcessRecord-n--10778-9284-u--displayParam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 eta-2))) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-5 '()))))) eta-1)))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-5 arg-21)))))))) eff-0) eta-0)))))) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (if (null? arg-20) (lambda (clam-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Some arguments have disappeared") clam-1)) (let ((e-6 (car arg-20))) (let ((e-7 (cdr arg-20))) (if (null? e-7) (lambda (clam-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Some arguments have disappeared") clam-0)) (let ((e-11 (cdr e-7))) (TTImpC-45ProcessRecord-n--10878-9811-u--addMissingNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-6 (cons (cons e-3 e-11) arg-21))))))))))))
(define TTImpC-45ProcessRecord-n--10878-9812-u--dropLeadingPis (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (if (null? arg-20) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-toFullNames arg-17 csegen-68 arg-21 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45Types-u--null_Foldable_List arg-8))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (CoreC-45ContextC-45Log-unverifiedLogC arg-17 "declare.record.parameters" 60 (lambda (eta-1) (vector 1 (DataC-45String-fastUnlines (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "We elaborated " (cons (CoreC-45Name-u--show_Show_Name arg-18) (cons " in a non-empty local context." '())))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "  Dropped: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-8) '()))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "  Remaining type: " (cons (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-19 e-5) '()))) '())))))) clam-0))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons arg-19 (cons arg-22 arg-21))))))) (let ((e-3 (cdr arg-20))) (case (vector-ref arg-21 0) ((3) (let ((e-6 (vector-ref arg-21 2))) (let ((e-7 (vector-ref arg-21 3))) (let ((e-8 (vector-ref arg-21 4))) (case (vector-ref e-7 0) ((2) (TTImpC-45ProcessRecord-n--10878-9812-u--dropLeadingPis arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (cons e-6 arg-19) e-3 e-8 (cons e-7 arg-22)))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Malformed record type " (cons (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-19 arg-21) '())))) eta-0))))))))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Malformed record type " (cons (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-19 arg-21) '())))) eta-0))))))))
(define TTImpC-45ProcessRecord-killHole (lambda (arg-0) (case (vector-ref arg-0 0) ((30) (let ((e-1 (vector-ref arg-0 1))) (vector 32 e-1 1)))(else arg-0))))
(define TTImpC-45ProcessRecord-n--10878-9813-u--getParameters (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (case (vector-ref arg-20 0) ((1) (let ((e-2 (vector-ref arg-20 2))) (let ((e-3 (vector-ref arg-20 3))) (let ((e-4 (vector-ref arg-20 4))) (let ((e-5 (vector-ref arg-20 5))) (let ((e-6 (vector-ref arg-20 6))) (let ((u--clean (lambda (eta-0) (TTImpC-45TTImpC-45Traversals-mapTTImp (lambda (eta-1) (TTImpC-45ProcessRecord-killHole eta-1)) (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (let ((e-8 (vector-ref eta-1 1))) e-8)) eta-0))))) (TTImpC-45ProcessRecord-n--10878-9813-u--getParameters arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (cons arg-19 (cons e-4 (cons e-2 (cons (CoreC-45TTC-45Binder-u--map_Functor_PiInfo u--clean e-3) (u--clean e-5))))) e-6)))))))) ((29) (lambda (eta-0) (vector 1 arg-19)))(else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Malformed record type " (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-2016 arg-20) '())))) eta-0))))))
(define TTImpC-45ProcessRecord-n--10778-9289-u--mkDataTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (if (null? arg-19) (vector 29 arg-18) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-18 e-10 e-14 (box e-6) e-15 (TTImpC-45ProcessRecord-n--10778-9289-u--mkDataTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3)))))))))))))
(define TTImpC-45ProcessRecord-n--10778-9294-u--preElabAsData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((u--fc (CoreC-45FC-virtualiseFC arg-11))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-17 u--fc '() arg-8 (TTImpC-45ProcessRecord-n--10778-9289-u--mkDataTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 u--fc arg-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--dataTy (vector 16 u--fc csegen-2373 e-5))) (let ((u--dt (vector 0 u--fc arg-18 (box u--dataTy) arg-2 '()))) (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-17 "declare.record" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Pre-declare record data type: " (cons (TTImpC-45TTImp-u--show_Show_C-40ImpDataC-39C-32C-36nmC-41 csegen-65 u--dt) '())))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((TTImpC-45ElabC-45Check-processDecl arg-8 arg-17 arg-16 arg-15 arg-14 arg-13 '() arg-9 arg-10 (vector 1 u--fc arg-6 arg-5 u--dt)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (unbox arg-17))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Context-lookupTyExact arg-18 (let ((e-0 (vector-ref e-8 0))) e-0) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Missing data type " (cons (CoreC-45Name-u--show_Show_Name arg-18) (cons ", despite having just declared it!" '()))))) clam-0) (let ((e-1 (unbox e-9))) (let ((act-6 (CoreC-45ContextC-45Log-log arg-17 "declare.record" 20 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (cons "Obtained type: " (cons (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-1) '())))) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((TTImpC-45ProcessRecord-n--10878-9812-u--dropLeadingPis arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 '() arg-8 e-1 '()) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((e-13 (car e-3))) (let ((e-12 (cdr e-3))) (let ((act-8 (let ((act-8 ((TTImpC-45ProcessRecord-n--10778-9291-u--nestDrop arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (TTImpC-45Unelab-unelabNest e-2 arg-17 e-14 e-13 e-12))) eff-0) clam-1))))))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 (CoreC-45ContextC-45Log-log arg-17 "declare.record.parameters" 30 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-4) eta-4) (cons "Unelaborated type: " (cons (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-2016 e-14) '())))) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 ((TTImpC-45ProcessRecord-n--10878-9813-u--getParameters arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 '() e-14) eta-3))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-10 1))) ((let ((eff-0 (TTImpC-45ProcessRecord-n--10878-9811-u--addMissingNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) arg-3)) e-16 '()))) eff-0) eta-3))))))))))) eff-0) clam-1)))))))))))) eff-0) clam-0))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))))))) eff-0) eta-0)))))))))
(define TTImpC-45ProcessRecord-elabRecord (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 arg-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-inCurrentNS arg-1 arg-16 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ProcessRecord-n--10778-9294-u--preElabAsData arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "declare.record.parameters" 100 (lambda () (DataC-45String-fastUnlines (cons "New list of parameters:" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (string-append "  " (TTImpC-45ProcessRecord-n--10778-9284-u--displayParam arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-3))) e-7)))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45ProcessRecord-n--10778-9285-u--elabAsData arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-7) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45Context-lookupTyExact e-6 (let ((e-0 (vector-ref e-10 0))) e-0) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Adding " (string-append (CoreC-45Name-u--show_Show_Name e-5) "failed"))) clam-0) (let ((e-1 (unbox e-11))) (let ((act-8 (if (null? arg-12) (vector 1 (vector 0 )) (let ((e-2 (unbox arg-12))) (let ((act-8 (CoreC-45ContextC-45Log-log arg-1 "declare.record" 5 (lambda () (string-append "setting totality flag for " (CoreC-45Name-u--show_Show_Name e-5))) clam-0))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (CoreC-45Context-setFlag arg-1 arg-7 e-5 (vector 6 e-2) clam-0)))))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (if (null? arg-10) ((TTImpC-45ProcessRecord-n--10778-9286-u--elabGetters arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() e-5 e-6 e-7 0 '() '() e-1) clam-0) (let ((e-2 (unbox arg-10))) (let ((u--cns (let ((e-41 (vector-ref e-10 2))) e-41))) (let ((u--nns (let ((e-3 (vector-ref e-10 3))) e-3))) (let ((act-9 ((CoreC-45Context-extendNS arg-1 (CoreC-45NameC-45Namespace-mkNamespace e-2)) clam-0))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((act-10 (CoreC-45Context-getNS arg-1 clam-0))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-11 ((TTImpC-45ProcessRecord-n--10778-9286-u--elabGetters arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 '() e-5 e-6 e-7 0 '() '() e-1) eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-3 (vector-ref act-11 1))) (vector 0 e-3))) (else ((let ((eff-0 (lambda (world-0) (let ((act-12 (unbox arg-1))) (vector 1 act-12))))) (lambda (world-0) (let ((act-12 (eff-0 world-0))) (case (vector-ref act-12 0) ((0) (let ((e-3 (vector-ref act-12 1))) (vector 0 e-3))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-1 (lambda (world-1) (let ((act-13 (set-box! arg-1 (let ((e-0 (vector-ref e-16 0))) (let ((e-46 (vector-ref e-16 1))) (let ((e-4 (vector-ref e-16 4))) (let ((e-44 (vector-ref e-16 5))) (let ((e-43 (vector-ref e-16 6))) (let ((e-42 (vector-ref e-16 7))) (let ((e-41 (vector-ref e-16 8))) (let ((e-40 (vector-ref e-16 9))) (let ((e-39 (vector-ref e-16 10))) (let ((e-38 (vector-ref e-16 11))) (let ((e-37 (vector-ref e-16 12))) (let ((e-36 (vector-ref e-16 13))) (let ((e-35 (vector-ref e-16 14))) (let ((e-34 (vector-ref e-16 15))) (let ((e-33 (vector-ref e-16 16))) (let ((e-17 (vector-ref e-16 17))) (let ((e-18 (vector-ref e-16 18))) (let ((e-19 (vector-ref e-16 19))) (let ((e-20 (vector-ref e-16 20))) (let ((e-21 (vector-ref e-16 21))) (let ((e-22 (vector-ref e-16 22))) (let ((e-23 (vector-ref e-16 23))) (let ((e-24 (vector-ref e-16 24))) (let ((e-25 (vector-ref e-16 25))) (let ((e-26 (vector-ref e-16 26))) (let ((e-27 (vector-ref e-16 27))) (let ((e-28 (vector-ref e-16 28))) (let ((e-29 (vector-ref e-16 29))) (let ((e-30 (vector-ref e-16 30))) (let ((e-31 (vector-ref e-16 31))) (let ((e-32 (vector-ref e-16 32))) (vector e-0 e-46 u--cns (cons e-14 u--nns) e-4 e-44 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (vector 1 act-13))))) eff-1) world-0))))))) eta-4))))))) eff-0) clam-0)))))))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessRecord-processRecord (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (let ((e-1 (vector-ref arg-12 0))) (let ((e-2 (vector-ref arg-12 1))) (let ((e-3 (vector-ref arg-12 2))) (let ((e-4 (vector-ref arg-12 3))) (let ((e-5 (vector-ref arg-12 4))) (let ((e-6 (vector-ref arg-12 5))) (TTImpC-45ProcessRecord-elabRecord arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-1 arg-8 arg-7 arg-9 arg-10 arg-11 e-2 e-3 e-4 e-5 e-6 clam-0))))))))))
(define TTImpC-45ElabC-45RunElab-n--12166-989-u--refsC-39 (lambda (arg-0 arg-1 arg-2 arg-3) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo arg-3))))
(define TTImpC-45ElabC-45RunElab-n--12166-988-u--refs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12166-989-u--refsC-39 arg-0 arg-1 arg-2 eta-1))) e-5)))))) (CoreC-45Context-lookupCtxtExact arg-3 (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0)))
(define TTImpC-45ElabC-45RunElab-n--12166-987-u--clos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45NameMap-keys arg-2))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-2))) (if (null? sc1) (let ((u--allC-39 (LibrariesC-45DataC-45NameMap-insert e-2 (vector 0 ) arg-2))) (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45RunElab-n--12166-988-u--refs arg-0 arg-1 arg-3 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nsC-39 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-3))) (TTImpC-45ElabC-45RunElab-n--12166-987-u--clos arg-0 arg-1 u--allC-39 arg-3 u--nsC-39)))) eff-0) eta-0))))))) (TTImpC-45ElabC-45RunElab-n--12166-987-u--clos arg-0 arg-1 arg-2 arg-3 e-3))))))))
(define TTImpC-45ElabC-45RunElab-deepRefersTo (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (DataC-45List-nub csegen-832 e-6)))))) (TTImpC-45ElabC-45RunElab-n--12166-987-u--clos arg-1 arg-0 LibrariesC-45DataC-45NameMap-empty e-5 (TTImpC-45ElabC-45RunElab-n--12166-989-u--refsC-39 arg-1 arg-0 e-5 arg-1)) eta-0)))) eff-0) ext-0)))))))
(define CoreC-45Directory-ensureDirectoryExists (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Directory-mkdirAll arg-0 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-0 e-6) clam-0))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-initEStateSub (lambda (arg-1 arg-2 arg-3 arg-4) (vector arg-1 arg-2 arg-3 arg-4 '() '() '() '() '() '() 0 '() LibrariesC-45DataC-45NameMap-empty LibrariesC-45DataC-45UserNameMap-empty)))
(define TTImpC-45ElabC-45Check-initEState (lambda (arg-0 arg-1 arg-2) (TTImpC-45ElabC-45Check-initEStateSub arg-0 arg-1 arg-2 (vector 0 ))))
(define TTImpC-45ElabC-45Check-initElabInfo (lambda (arg-0) (vector arg-0 (vector 3 ) 0 1 0 '())))
(define TTImpC-45ElabC-45RunElab-n--12019-847-u--getNameType (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((5) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (vector 2 e-0 e-1)))) ((6) (let ((e-3 (vector-ref arg-2 1))) (let ((e-4 (vector-ref arg-2 2))) (vector 3 e-3 e-4))))(else (vector 1 )))))
(define TTImpC-45ElabC-45RunElab-lookupNameInfo (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtName arg-0 arg-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-7 (cdr e-3))) (cons e-2 (TTImpC-45ElabC-45RunElab-n--12019-847-u--getNameType arg-1 arg-0 (let ((e-18 (vector-ref e-7 18))) e-18))))))) e-5))))) eff-0) ext-0)))))))
(define CoreC-45Context-lookupTyName (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupNameBy csegen-1313 ext-2 ext-1 ext-0)))
(define TTImpC-45ElabC-45Delayed-n--13543-16775-u--hasPri (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-9) (let ((e-2 (car arg-9))) (arg-3 e-2))))
(define TTImpC-45ElabC-45Delayed-runDelays (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--olddelayed (let ((e-10 (vector-ref e-5 10))) e-10))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-4 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 '() e-11))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (arg-7 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-4))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45ContextC-45Log-log arg-2 "elab.delay" 2 (lambda () "Rerunning delayed in elaborator") eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (TTImpC-45ElabC-45Check-handle arg-1 arg-2 arg-3 arg-4 arg-5 (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 (TTImpC-45ElabC-45Delayed-retryDelayedC-39 arg-1 arg-2 arg-3 arg-4 arg-5 1 0 '() (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-4) (TTImpC-45ElabC-45Delayed-n--13543-16775-u--hasPri arg-1 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 eta-4)) (let ((e-10 (vector-ref e-8 10))) e-10)))) eta-3)) (lambda (u--err) (lambda (eta-3) (let ((act-6 (let ((act-6 (set-box! arg-4 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-16 (vector-ref e-8 5))) (let ((e-15 (vector-ref e-8 6))) (let ((e-14 (vector-ref e-8 7))) (let ((e-13 (vector-ref e-8 8))) (let ((e-12 (vector-ref e-8 9))) (let ((e-11 (vector-ref e-8 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 e-14 e-13 e-12 u--olddelayed e-11))))))))))))))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-3)))))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 (unbox arg-4))) (vector 1 act-7))))) (lambda (world-0) (let ((act-7 (eff-0 world-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-1 (lambda (world-1) (let ((act-8 (set-box! arg-4 (let ((e-0 (vector-ref e-11 0))) (let ((e-1 (vector-ref e-11 1))) (let ((e-2 (vector-ref e-11 2))) (let ((e-3 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-18 (vector-ref e-11 5))) (let ((e-17 (vector-ref e-11 6))) (let ((e-16 (vector-ref e-11 7))) (let ((e-15 (vector-ref e-11 8))) (let ((e-14 (vector-ref e-11 9))) (let ((e-13 (vector-ref e-11 10))) (let ((e-12 (vector-ref e-11 11))) (vector e-0 e-1 e-2 e-3 e-4 e-18 e-17 e-16 e-15 e-14 (PreludeC-45TypesC-45List-tailRecAppend e-13 u--olddelayed) e-12)))))))))))))))) (vector 1 act-8))))) eff-1) world-0))))))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (vector 1 e-7))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) eff-0) ext-0)))))))
(define TTImpC-45Unelab-unelabUniqueBinders (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (TTImpC-45Unelab-unelabTy arg-0 arg-1 (vector 1 1) '() arg-2 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (Builtin-fst e-5))))) eff-0) ext-0)))))))
(define CoreC-45Reflect-u--reflect_Reflect_C-40SnocListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-basics "Lin") (cons (vector 10 arg-3 (vector 0 )) '()) clam-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((act-1 (((((((let ((eff-0 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (CoreC-45Reflect-u--reflect_Reflect_C-40SnocListC-32C-36aC-41 arg-1 u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792))))))))) (lambda (arg-0) (lambda (arg-8) (lambda (arg-9) (lambda (arg-10) (lambda (arg-11) ((((((eff-0 arg-2) arg-0) arg-8) arg-9) arg-10) arg-11))))))) arg-3) arg-4) arg-5) arg-6) e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((arg-1 arg-2) arg-3) arg-4) arg-5) arg-6) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-2 arg-3 arg-4 (CoreC-45Reflect-basics ":<") (cons (vector 10 arg-3 (vector 0 )) (cons e-5 (cons e-6 '()))) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))
(define CoreC-45Reflect-u--reflect_Reflect_NameType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Bound") clam-0)) ((1) (CoreC-45Reflect-getCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "Func") clam-0)) ((2) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Nat arg-0 arg-1 arg-2 arg-3 arg-4 e-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "DataCon") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) (else (let ((e-2 (vector-ref arg-5 1))) (let ((e-3 (vector-ref arg-5 2))) (let ((act-1 (CoreC-45Reflect-u--reflect_Reflect_Int arg-0 arg-1 arg-2 arg-3 arg-4 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Nat arg-0 arg-1 arg-2 arg-3 arg-4 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "TyCon") (cons e-5 (cons e-6 '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define TTImpC-45ElabC-45RunElab-u--reflect_Reflect_NameInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_NameType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Reflect-appCon arg-0 arg-1 arg-2 (CoreC-45Reflect-reflectiontt "MkNameInfo") (cons e-5 '()) eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 arg-19 ext-0) (let ((act-1 (CoreC-45Context-clearDefs arg-18 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 arg-0 e-5 arg-8 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 arg-10 arg-8 e-6 arg-19) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NameC-45NamespaceC-45ModuleIdent-parent (lambda (arg-0) (if (null? arg-0) '() (let ((e-3 (cdr arg-0))) (box e-3)))))
(define TTImpC-45ElabC-45RunElab-n--12301-1168-u--lookupDir (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (lambda (clam-0) (case (vector-ref arg-18 0) ((2) (let ((e-2 (vector-ref arg-18 2))) (let ((e-5 (vector-ref arg-18 5))) (if (null? e-5) (let ((act-1 (let ((act-1 (unbox arg-16))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-16 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (case (vector-ref e-7 0) ((0) (let ((e-0 (vector-ref e-7 1))) (let ((e-8 (vector-ref e-7 2))) (case (vector-ref e-8 0) ((1) (let ((e-9 (vector-ref e-8 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (let ((sc7 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 CoreC-45NameC-45Namespace-reflectionNS))) (cond ((equal? sc7 1) (let ((u--wd (let ((e-39 (vector-ref e-6 4))) (let ((e-53 (vector-ref e-39 0))) (let ((e-63 (vector-ref e-53 0))) e-63))))) (let ((u--sd (PreludeC-45Types-maybe (lambda () u--wd) (lambda () (lambda (u--sd) (LibrariesC-45UtilsC-45Path-joinPath (cons u--wd (cons u--sd '()))))) (let ((e-39 (vector-ref e-6 4))) (let ((e-53 (vector-ref e-39 0))) (let ((e-62 (vector-ref e-53 1))) e-62)))))) (let ((u--modDir (lambda (u--doParent) (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-13))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--parentIfNeeded (lambda (clam-1) (cond ((equal? u--doParent 1) (CoreC-45NameC-45NamespaceC-45ModuleIdent-parent clam-1)) (else (box clam-1)))))) (let ((u--moduleSuffix (PreludeC-45Types-u--toList_Foldable_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath eta-2)) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45List-headC-39 (let ((e-22 (vector-ref e-11 1))) e-22)) u--parentIfNeeded))))) (lambda (eta-2) (vector 1 (LibrariesC-45UtilsC-45Path-joinPath (cons u--sd u--moduleSuffix)))))))) eff-0) eta-1))))))))) (cond ((equal? e-10 "ProjectDir") (lambda (eta-1) (vector 1 u--wd))) ((equal? e-10 "SourceDir") (lambda (eta-1) (vector 1 u--sd))) ((equal? e-10 "CurrentModuleDir") (u--modDir 1)) ((equal? e-10 "SubmodulesDir") (u--modDir 0)) ((equal? e-10 "BuildDir") (lambda (eta-1) (vector 1 (LibrariesC-45UtilsC-45Path-joinPath (cons u--wd (cons (let ((e-39 (vector-ref e-6 4))) (let ((e-53 (vector-ref e-39 0))) (let ((e-61 (vector-ref e-53 2))) e-61))) '()))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6 "bad lookup dir value" eta-1)))))))) (else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6 (string-append "bad lookup dir namespace " (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0)) eta-1)))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6 (string-append "bad lookup dir fullnames " (CoreC-45Name-u--show_Show_Name e-7)) eta-1))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6 (string-append "bad lookup dir fullnames " (CoreC-45Name-u--show_Show_Name e-7)) eta-1)))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-6 (string-append "bad lookup dir fullnames " (CoreC-45Name-u--show_Show_Name e-7)) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((act-1 (let ((act-1 (unbox arg-16))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 arg-0 e-7 arg-8 arg-18 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 arg-10 arg-8 e-8 "lookup dir is not a data value") eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (let ((act-1 (let ((act-1 (unbox arg-16))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 arg-0 e-6 arg-8 arg-18 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 arg-10 arg-8 e-7 "lookup dir is not a data value") eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))
(define TTImpC-45ElabC-45RunElab-n--12371-3197-u--quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (lambda (clam-0) (case (vector-ref arg-21 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20 "Can't add default lambda" clam-0))))))
(define TTImpC-45ElabC-45RunElab-n--12301-1169-u--reifyFC (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 arg-18) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_FC arg-16 arg-0 arg-17 e-5))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (case (vector-ref e-5 0) ((2) arg-10)(else e-5)))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 arg-19 ext-0) (let ((act-1 (let ((act-1 (unbox arg-16))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((((((arg-18 arg-0) arg-10) e-5) 0) arg-8) arg-19) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nfOpts arg-16 arg-0 CoreC-45Value-withAll e-5 arg-8 e-6))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45RunElab-n--12371-3649-u--unelabType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (lambda (clam-0) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-7 (cdr e-3))) (let ((act-1 (TTImpC-45Unelab-unelabUniqueBinders '() arg-16 '() e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-5)))))) eff-0) clam-0)))))))))))
(define LibrariesC-45UtilsC-45Path-isRelative (lambda (ext-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-isAbsolute ext-0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (if (null? arg-20) 1 (cond ((equal? arg-19 0) (if (null? arg-20) (let ((e-1 (car arg-20))) (let ((e-2 (cdr arg-20))) (cond ((equal? e-1 ".") (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-2))(else (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (+ arg-19 1) e-2))))) (let ((e-5 (car arg-20))) (cond ((equal? e-5 "..") 0)(else (let ((e-1 (car arg-20))) (let ((e-2 (cdr arg-20))) (cond ((equal? e-1 ".") (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-2))(else (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (+ arg-19 1) e-2))))))))))(else (let ((e-3 (- arg-19 1))) (if (null? arg-20) (let ((e-1 (car arg-20))) (let ((e-2 (cdr arg-20))) (cond ((equal? e-1 ".") (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-2))(else (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (+ arg-19 1) e-2))))) (let ((e-8 (car arg-20))) (let ((e-9 (cdr arg-20))) (cond ((equal? e-8 "..") (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3 e-9))(else (let ((e-1 (car arg-20))) (let ((e-2 (cdr arg-20))) (cond ((equal? e-1 ".") (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-2))(else (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 (+ arg-19 1) e-2))))))))))))))))
(define TTImpC-45ElabC-45RunElab-n--12301-1171-u--validatePath (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (let ((sc0 (LibrariesC-45UtilsC-45Path-isRelative arg-18))) (cond ((equal? sc0 1) (lambda (clam-0) (let ((sc1 (TTImpC-45ElabC-45RunElab-n--12376-2228-u--pathDoesNotEscape arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18 arg-17 0 (LibrariesC-45UtilsC-45Path-splitPath arg-18)))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 "path must not escape the directory" clam-0)))))) (else (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 "path must be relative" eta-0))))))))
(define TTImpC-45ElabC-45RunElab-n--12301-1166-u--elabCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (cond ((equal? arg-18 "Pure") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-2 (cdr arg-19))) (if (null? e-2) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (lambda (clam-0) (if (null? e-5) (let ((act-1 (CoreC-45Context-clearDefs arg-17 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 e-6 e-4))) eff-0) clam-0))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-0))))))))) ((equal? arg-18 "Bind") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-9 (cdr arg-19))) (if (null? e-9) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-12 (cdr e-9))) (if (null? e-12) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-14 (car e-12))) (let ((e-15 (cdr e-12))) (if (null? e-15) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-17 (car e-15))) (let ((e-18 (cdr e-15))) (lambda (clam-1) (if (null? e-18) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-14) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-5 arg-7 eta-0)))) eff-0) clam-1))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 arg-0 arg-17 arg-8 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-17) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45NormaliseC-45Eval-applyToStack arg-17 CoreC-45Value-withAll arg-16 arg-0 arg-8 e-7 (cons (cons (CoreC-45TTC-45Term-getLoc e-6) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-withAll arg-8 e-6)) '())) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-10 arg-7 eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-1)))))))))))))) ((equal? arg-18 "Fail") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-22 (cdr arg-19))) (if (null? e-22) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-24 (car e-22))) (let ((e-25 (cdr e-22))) (if (null? e-25) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-27 (car e-25))) (let ((e-28 (cdr e-25))) (lambda (clam-2) (if (null? e-28) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-27) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45RunElab-n--12301-1169-u--reifyFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-24 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 (vector 49 e-6 e-7)) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-2)))))))))))) ((equal? arg-18 "Warn") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-31 (car arg-19))) (let ((e-32 (cdr arg-19))) (if (null? e-32) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-34 (car e-32))) (let ((e-35 (cdr e-32))) (lambda (clam-3) (if (null? e-35) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-34) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (TTImpC-45ElabC-45RunElab-n--12301-1169-u--reifyFC arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-31 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Context-recordWarning arg-16 (vector 6 e-6 e-7)))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2384 (vector 0 ) eta-0))))))) eff-0) clam-3))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-3)))))))))) ((equal? arg-18 "Try") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-39 (cdr arg-19))) (if (null? e-39) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-41 (car e-39))) (let ((e-42 (cdr e-39))) (if (null? e-42) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-44 (car e-42))) (let ((e-45 (cdr e-42))) (lambda (clam-4) (if (null? e-45) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-44) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45UnifyState-tryUnify arg-16 arg-14 (lambda (eta-1) (let ((act-2 (CoreC-45Context-getNextEntry arg-16 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-41) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-7 arg-7 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Unify-solveConstraintsAfter arg-16 arg-14 e-6 CoreC-45Unify-inTerm 3 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) (lambda (eta-1) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 e-5 arg-7 eta-1)) eta-0)))) eff-0) clam-4))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-4)))))))))))) ((equal? arg-18 "LogMsg") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-48 (car arg-19))) (let ((e-49 (cdr arg-19))) (if (null? e-49) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-51 (car e-49))) (let ((e-52 (cdr e-49))) (if (null? e-52) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-54 (car e-52))) (let ((e-55 (cdr e-52))) (lambda (clam-5) (if (null? e-55) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-48) clam-5))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-51) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reify_Reify_Nat arg-16 arg-0 arg-17 e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45ContextC-45Log-unverifiedLogC arg-16 e-7 e-8 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-54) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-9))) eff-0) eta-4)))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2384 (vector 0 ) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-5))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-5))))))))))))) ((equal? arg-18 "LogTerm") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-58 (car arg-19))) (let ((e-59 (cdr arg-19))) (if (null? e-59) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-61 (car e-59))) (let ((e-62 (cdr e-59))) (if (null? e-62) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-64 (car e-62))) (let ((e-65 (cdr e-62))) (if (null? e-65) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-67 (car e-65))) (let ((e-68 (cdr e-65))) (lambda (clam-6) (if (null? e-68) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-58) clam-6))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-61) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reify_Reify_Nat arg-16 arg-0 arg-17 e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45ContextC-45Log-unverifiedLogC arg-16 e-7 e-8 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-64) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-67) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-7 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-9) eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-8 (TTImpC-45Reflect-u--reify_Reify_RawImp arg-16 arg-0 arg-17 e-10 eta-7))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (string-append e-11 (string-append ": " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-12))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2384 (vector 0 ) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-6))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-6)))))))))))))))) ((equal? arg-18 "LogSugaredTerm") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-71 (car arg-19))) (let ((e-72 (cdr arg-19))) (if (null? e-72) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-74 (car e-72))) (let ((e-75 (cdr e-72))) (if (null? e-75) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-77 (car e-75))) (let ((e-78 (cdr e-75))) (if (null? e-78) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-80 (car e-78))) (let ((e-81 (cdr e-78))) (lambda (clam-7) (if (null? e-81) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-71) clam-7))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-74) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reify_Reify_Nat arg-16 arg-0 arg-17 e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45ContextC-45Log-unverifiedLogC arg-16 e-7 e-8 (lambda (eta-4) (let ((act-5 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-77) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-80) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (TTImpC-45Reflect-u--reify_Reify_RawImp arg-16 arg-0 arg-17 e-10 eta-6)))) eff-0) eta-5))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-7 (IdrisC-45Resugar-pterm arg-16 arg-13 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-7) (CoreC-45TT-defaultKindedName eta-7)) e-10) eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-8 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-9) eta-7))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (string-append e-12 (string-append ": " (IdrisC-45Syntax-u--show_Show_IPTerm e-11))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2384 (vector 0 ) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-7))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-7)))))))))))))))) ((equal? arg-18 "Check") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-84 (car arg-19))) (let ((e-85 (cdr arg-19))) (if (null? e-85) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-87 (car e-85))) (let ((e-88 (cdr e-85))) (lambda (clam-8) (if (null? e-88) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-84) clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-87) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-resolveName arg-16 (vector 1 (vector 0 "[elaborator script]")) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (TTImpC-45ElabC-45Check-initEState arg-0 e-7 arg-8)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (TTImpC-45Reflect-u--reify_Reify_RawImp arg-16 arg-0 arg-17 e-6 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-16 arg-15 arg-14 e-8 (lambda (eta-5) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-16 arg-15 arg-14 e-8 arg-13 arg-12 arg-11 (TTImpC-45ElabC-45Check-initElabInfo (vector 2 )) arg-9 arg-8 e-9 (box (CoreC-45Normalise-glueBack arg-16 arg-0 arg-17 arg-8 e-5))) eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-9))) (let ((act-6 (CoreC-45Context-clearDefs arg-17 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-16 arg-0 e-10 arg-8 e-2))) eff-0) clam-0))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-8))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-8)))))))))) ((equal? arg-18 "Quote") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-92 (cdr arg-19))) (if (null? e-92) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-94 (car e-92))) (let ((e-95 (cdr e-92))) (lambda (clam-9) (if (null? e-95) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-94) clam-9))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-16))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 arg-0 e-7 arg-8 e-5 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45Unelab-unelabUniqueBinders arg-0 arg-16 arg-8 e-8 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2385 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-9) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-9))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-9))))))))) ((equal? arg-18 "Lambda") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-98 (car arg-19))) (let ((e-99 (cdr arg-19))) (if (null? e-99) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-101 (car e-99))) (let ((e-102 (cdr e-99))) (if (null? e-102) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-104 (car e-102))) (let ((e-105 (cdr e-102))) (lambda (clam-10) (if (null? e-105) (let ((act-1 (CoreC-45Context-clearDefs arg-17 clam-10))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-104) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (case (vector-ref e-6 0) ((0) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (lambda (clam-11) (case (vector-ref e-3 0) ((0) (let ((e-10 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-3 (CoreC-45UnifyState-genVarName arg-16 arg-14 "x" clam-11))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (((e-4 arg-17) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-withAll arg-8 (vector 1 e-1 (vector 0 ) e-11))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 arg-0 e-5 arg-8 e-12 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--lamsc (CoreC-45TT-refToLocal e-11 e-2 e-13))) (lambda (eta-3) (let ((act-6 ((TTImpC-45ElabC-45RunElab-n--12371-3197-u--quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-101 e-98 e-104 arg-17 e-8) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-16 arg-0 e-5 arg-8 e-9 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--envC-39 (cons (vector 0 e-10 e-7 e-14 e-15) arg-8))) (lambda (eta-5) (let ((act-8 (let ((act-8 ((CoreC-45NormaliseC-45Eval-nf arg-16 (cons e-2 arg-0) arg-17 u--envC-39 u--lamsc) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-16 (vector-ref act-8 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (TTImpC-45ElabC-45RunElab-elabScript (cons e-2 arg-0) arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames arg-9) u--envC-39 e-16 '() eta-6)))) eff-0) eta-5))))))) (case (vector-ref act-8 0) ((0) (let ((e-16 (vector-ref act-8 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-16 (cons e-2 arg-0) e-5 u--envC-39 e-16 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-17 (vector-ref act-9 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-9 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nf arg-16 arg-0 e-5 arg-8 (vector 3 e-1 e-2 (vector 0 e-10 e-7 e-14 e-15) e-17)))) eff-0) eta-6)))))))) eff-0) eta-5))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-11))))))))))(else (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 "Not a lambda" clam-11)))))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 "Not a lambda" eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-10))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-10))))))))))))) ((equal? arg-18 "Goal") (if (null? arg-19) (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (lambda (clam-1) (if (null? arg-7) (let ((act-1 ((CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2385 arg-0 arg-10 arg-17 0 arg-8 '()) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45NormaliseC-45Eval-nfOpts arg-16 arg-0 CoreC-45Value-withAll arg-17 arg-8 e-5))) eff-0) clam-1))))) (let ((e-1 (unbox arg-7))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm e-1) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45Unelab-unelabUniqueBinders arg-0 arg-16 arg-8 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reflect_Reflect_C-40MaybeC-32C-36aC-41 csegen-2385 eta-2 eta-3 eta-4 eta-5 eta-6 eta-7))))))) (box (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-6)) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)))) ((equal? arg-18 "LocalVars") (lambda (clam-12) (if (null? arg-19) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2388 arg-0 clam-12) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-12)))) ((equal? arg-18 "GenSym") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-110 (car arg-19))) (let ((e-111 (cdr arg-19))) (lambda (clam-13) (if (null? e-111) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-110) clam-13))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45UnifyState-genVarName arg-16 arg-14 e-6 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2387 e-6 eta-1)))) eff-0) eta-0)))))))) eff-0) clam-13))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-13))))))) ((equal? arg-18 "InCurrentNS") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-114 (car arg-19))) (let ((e-115 (cdr arg-19))) (lambda (clam-14) (if (null? e-115) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-114) clam-14))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_Name arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-inCurrentNS arg-16 e-6 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2387 e-6 eta-1)))) eff-0) eta-0)))))))) eff-0) clam-14))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-14))))))) ((equal? arg-18 "GetType") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-118 (car arg-19))) (let ((e-119 (cdr arg-19))) (lambda (clam-15) (if (null? e-119) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-118) clam-15))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_Name arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Context-lookupTyName e-6 (let ((e-0 (vector-ref arg-17 0))) e-0) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45ElabC-45RunElab-n--12371-3649-u--unelabType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-118 arg-17 eta-2)) e-6 '()) eta-1)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (lambda (eta-14) (lambda (eta-15) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2387 csegen-2385) eta-9 eta-10 eta-11 eta-12 eta-13 eta-14 eta-15)))))))) eta-3 eta-4 eta-5 eta-6 eta-7 eta-8))))))) e-7 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-15))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-15))))))) ((equal? arg-18 "GetInfo") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-122 (car arg-19))) (let ((e-123 (cdr arg-19))) (lambda (clam-16) (if (null? e-123) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-122) clam-16))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_Name arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45RunElab-lookupNameInfo e-6 (let ((e-0 (vector-ref arg-17 0))) e-0) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (lambda (eta-11) (lambda (eta-12) (lambda (eta-13) (lambda (eta-14) (CoreC-45Reflect-u--reflect_Reflect_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-2387 (lambda (u--vars) (lambda (arg-1780) (lambda (arg-1783) (lambda (u--onLHS) (lambda (arg-1788) (lambda (arg-1792) (lambda (eta-15) (TTImpC-45ElabC-45RunElab-u--reflect_Reflect_NameInfo u--vars arg-1780 arg-1783 u--onLHS arg-1788 arg-1792 eta-15))))))))) eta-8 eta-9 eta-10 eta-11 eta-12 eta-13 eta-14)))))))) eta-2 eta-3 eta-4 eta-5 eta-6 eta-7))))))) e-6 eta-1)))) eff-0) eta-0)))))))) eff-0) clam-16))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-16))))))) ((equal? arg-18 "GetLocalType") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-126 (car arg-19))) (let ((e-127 (cdr arg-19))) (lambda (clam-17) (if (null? e-127) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-126) clam-17))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_Name arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (let ((sc5 (CoreC-45Env-defined arg-0 e-6 arg-8))) (if (null? sc5) (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append (CoreC-45Name-u--show_Show_Name e-6) " is not a local variable") eta-1)) (let ((e-1 (unbox sc5))) (if (null? e-1) (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append (CoreC-45Name-u--show_Show_Name e-6) " is not a local variable") eta-1)) (let ((e-4 (car e-1))) (let ((u--binder (CoreC-45Env-getBinder CoreC-45TTC-45Term-WeakenTerm arg-0 e-4 arg-8))) (let ((u--bty (CoreC-45TTC-45Binder-binderType u--binder))) (lambda (eta-1) (let ((act-3 (TTImpC-45Unelab-unelabUniqueBinders arg-0 arg-16 arg-8 u--bty eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2385 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-8) eta-2)))) eff-0) eta-1)))))))))))))))) eff-0) eta-0)))))))) eff-0) clam-17))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-17))))))) ((equal? arg-18 "GetCons") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-130 (car arg-19))) (let ((e-131 (cdr arg-19))) (lambda (clam-18) (if (null? e-131) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-130) clam-18))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_Name arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-lookupDefExact e-6 (let ((e-0 (vector-ref arg-17 0))) e-0) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (if (null? e-7) (lambda (eta-2) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append (CoreC-45Name-u--show_Show_Name e-6) " is not a type") eta-2)) (let ((e-1 (unbox e-7))) (lambda (clam-19) (case (vector-ref e-1 0) ((6) (let ((e-8 (vector-ref e-1 7))) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2388 e-8 clam-19)))(else (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append (CoreC-45Name-u--show_Show_Name e-6) " is not a type") clam-19))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-18))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-18))))))) ((equal? arg-18 "GetReferredFns") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-134 (car arg-19))) (let ((e-135 (cdr arg-19))) (lambda (clam-20) (if (null? e-135) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-134) clam-20))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_Name arg-16 arg-0 arg-17 e-5))) eff-0) clam-20))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref arg-17 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (lambda (clam-21) (if (null? e-6) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append (CoreC-45Name-u--show_Show_Name e-5) " is not a definition") clam-21) (let ((e-1 (unbox e-6))) (let ((act-3 (TTImpC-45ElabC-45RunElab-deepRefersTo arg-16 e-1 clam-21))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2388 e-7 eta-1)))) eff-0) clam-21))))))))))) eff-0) eta-0)))))))) eff-0) clam-20))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-20))))))) ((equal? arg-18 "GetCurrentFn") (lambda (clam-22) (if (null? arg-19) (let ((act-1 (let ((act-1 (unbox arg-16))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Reflect-u--reflect_Reflect_C-40SnocListC-32C-36aC-41 csegen-2387 eta-1 eta-2 eta-3 eta-4 eta-5 eta-6))))))) (let ((e-32 (vector-ref e-5 32))) e-32) eta-0)))) eff-0) clam-22))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-22)))) ((equal? arg-18 "Declare") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-139 (car arg-19))) (let ((e-140 (cdr arg-19))) (lambda (clam-23) (if (null? e-140) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-139) clam-23))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reify_Reify_C-40ListC-32C-36aC-41 (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (TTImpC-45Reflect-u--reify_Reify_ImpDecl eta-1 eta-2 eta-3 eta-4 eta-5)))))) arg-16 arg-0 arg-17 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (TTImpC-45ElabC-45Check-processDecl '() arg-16 arg-15 arg-14 arg-13 arg-12 '() '() '() eta-2)) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2384 (vector 0 ) eta-1))))))) eff-0) eta-0)))))))) eff-0) clam-23))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-23))))))) ((equal? arg-18 "ReadFile") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-143 (car arg-19))) (let ((e-144 (cdr arg-19))) (if (null? e-144) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-146 (car e-144))) (let ((e-147 (cdr e-144))) (lambda (clam-24) (if (null? e-147) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-143) clam-24))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45RunElab-n--12301-1168-u--lookupDir arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-5))) eff-0) clam-24))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-146) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45RunElab-n--12301-1171-u--validatePath arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((u--fullPath (LibrariesC-45UtilsC-45Path-joinPath (cons e-5 (cons e-6 '()))))) (let ((act-4 (let ((act-4 ((SystemC-45FileC-45Meta-exists csegen-82 u--fullPath) eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--script (vector 2 arg-5 arg-4 arg-3 arg-2 arg-1))) (lambda (clam-25) (cond ((equal? e-8 1) (let ((act-5 ((CoreC-45Core-readFile u--fullPath) clam-25))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2399 (box e-9) eta-2)))) eff-0) clam-25)))))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--script arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2399 '() clam-25))))))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))) eff-0) clam-24))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-24)))))))))) ((equal? arg-18 "WriteFile") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-150 (car arg-19))) (let ((e-151 (cdr arg-19))) (if (null? e-151) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-153 (car e-151))) (let ((e-154 (cdr e-151))) (if (null? e-154) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-156 (car e-154))) (let ((e-157 (cdr e-154))) (lambda (clam-26) (if (null? e-157) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-150) clam-26))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45RunElab-n--12301-1168-u--lookupDir arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-5))) eff-0) clam-26))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-153) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45RunElab-n--12301-1171-u--validatePath arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-156) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Reflect-u--reify_Reify_String arg-16 arg-0 arg-17 e-8))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--fullPath (LibrariesC-45UtilsC-45Path-joinPath (cons e-5 (cons e-6 '()))))) (lambda (eta-2) (let ((act-5 (let ((sc9 (LibrariesC-45UtilsC-45Path-parent u--fullPath))) (if (null? sc9) (vector 1 (vector 0 )) (let ((e-1 (unbox sc9))) (CoreC-45Directory-ensureDirectoryExists e-1 eta-2)))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45Core-writeFile u--fullPath e-8) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2384 (vector 0 ) eta-2))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-26))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-26))))))))))))) ((equal? arg-18 "IdrisDir") (if (null? arg-19) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0)) (let ((e-160 (car arg-19))) (let ((e-161 (cdr arg-19))) (lambda (clam-27) (if (null? e-161) (let ((act-1 (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-16 arg-0 arg-17 e-160) clam-27))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45RunElab-n--12301-1168-u--lookupDir arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-5))) eff-0) clam-27))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1170-u--scriptRet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 csegen-2398 e-5 eta-0)))) eff-0) clam-27))))) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) clam-27)))))))(else (lambda (eta-0) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (string-append "unexpected Elab constructor " (string-append arg-18 (string-append ", or incorrect count of arguments: " (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-19))))) eta-0))))))
(define TTImpC-45ElabC-45RunElab-elabScript (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (case (vector-ref arg-10 0) ((2) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((e-4 (vector-ref arg-10 4))) (let ((e-5 (vector-ref arg-10 5))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-1 csegen-54 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--script (vector 2 e-1 e-2 e-3 e-4 e-5))) (case (vector-ref e-7 0) ((0) (let ((e-0 (vector-ref e-7 1))) (let ((e-8 (vector-ref e-7 2))) (case (vector-ref e-8 0) ((1) (let ((e-9 (vector-ref e-8 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (lambda (clam-0) (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 CoreC-45NameC-45Namespace-reflectionNS))) (cond ((equal? sc6 1) (CoreC-45Core-u--catch_Catchable_Core_Error (TTImpC-45ElabC-45RunElab-n--12301-1166-u--elabCon arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 e-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) e-5)) (lambda (lcase-0) (lambda (clam-1) (case (vector-ref lcase-0 0) ((47) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-1)) ((48) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 clam-1))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 48 lcase-0) clam-1))))) clam-0)) (else (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (string-append "bad reflection namespace " (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0)) clam-0)))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (string-append "bad fullnames " (CoreC-45Name-u--show_Show_Name e-7)) eta-1))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (string-append "bad fullnames " (CoreC-45Name-u--show_Show_Name e-7)) eta-1)))))))(else (lambda (eta-1) (TTImpC-45ElabC-45RunElab-n--12301-1167-u--failWith arg-0 e-5 e-4 e-3 e-2 e-1 u--script arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-6 (string-append "bad fullnames " (CoreC-45Name-u--show_Show_Name e-7)) eta-1))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-clearDefs e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-6 arg-9 arg-10 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 47 arg-0 arg-7 arg-9 e-7 "script is not a data value") eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define IdrisC-45SyntaxC-45Pragmas-u--C-61C-61_Eq_LangExt (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define IdrisC-45SyntaxC-45Pragmas-u--C-47C-61_Eq_LangExt (lambda (arg-0 arg-1) (let ((sc0 (IdrisC-45SyntaxC-45Pragmas-u--C-61C-61_Eq_LangExt arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45Options-isExtension (lambda (arg-0 arg-1) (PreludeC-45Types-elem csegen-14 (cons (lambda (arg-676) (lambda (arg-679) (IdrisC-45SyntaxC-45Pragmas-u--C-61C-61_Eq_LangExt arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (IdrisC-45SyntaxC-45Pragmas-u--C-47C-61_Eq_LangExt arg-686 arg-689)))) arg-0 (let ((e-7 (vector-ref arg-1 7))) e-7))))
(define CoreC-45Context-isExtension (lambda (arg-0 arg-1) (CoreC-45Options-isExtension arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4))))
(define TTImpC-45ProcessRunElab-processRunElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (CoreC-45Context-isExtension 0 e-5))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-9 "%language ElabReflection not enabled") eta-0)))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-resolveName arg-1 (vector 1 (vector 0 "[elaborator script]")) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--n csegen-2401)) (lambda (eta-1) (let ((act-4 (CoreC-45Reflect-getCon arg-0 arg-9 e-5 (CoreC-45Reflect-builtin "Unit") eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Reflect-appCon arg-0 arg-9 e-5 u--n (cons e-8 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7 (vector 2 ) arg-6 arg-7 arg-8 arg-10 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-8 e-9) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 ((CoreC-45NormaliseC-45Eval-nfOpts arg-1 arg-0 CoreC-45Value-withAll e-5 arg-8 e-10) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-6) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-9 arg-7 arg-8 e-11 '() eta-6)) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Term-getFn (lambda (arg-1) (case (vector-ref arg-1 0) ((4) (let ((e-2 (vector-ref arg-1 2))) (CoreC-45TTC-45Term-getFn e-2)))(else arg-1))))
(define CoreC-45Context-getFnName (lambda (arg-0) (let ((e-3 (vector-ref arg-0 3))) (let ((sc0 (CoreC-45TTC-45Term-getFn e-3))) (case (vector-ref sc0 0) ((1) (let ((e-5 (vector-ref sc0 3))) (box e-5)))(else '()))))))
(define CoreC-45Context-case--addTransform-23827 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 "LHS of a transformation must be a function application") ext-0) (let ((e-1 (unbox arg-4))) (let ((act-1 (CoreC-45Context-toResolvedNames arg-2 csegen-54 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toResolvedNames arg-2 csegen-1273 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-toFullNames arg-2 csegen-54 e-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-toFullNames arg-2 csegen-1273 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc5 (LibrariesC-45DataC-45NameMap-lookup e-5 (let ((e-13 (vector-ref arg-3 13))) e-13)))) (if (null? sc5) (let ((act-5 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-37 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (let ((e-35 (vector-ref arg-3 6))) (let ((e-34 (vector-ref arg-3 7))) (let ((e-33 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-10 (vector-ref arg-3 10))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (let ((e-17 (vector-ref arg-3 17))) (let ((e-18 (vector-ref arg-3 18))) (let ((e-19 (vector-ref arg-3 19))) (let ((e-20 (vector-ref arg-3 20))) (let ((e-21 (vector-ref arg-3 21))) (let ((e-22 (vector-ref arg-3 22))) (let ((e-23 (vector-ref arg-3 23))) (let ((e-24 (vector-ref arg-3 24))) (let ((e-25 (vector-ref arg-3 25))) (let ((e-26 (vector-ref arg-3 26))) (let ((e-27 (vector-ref arg-3 27))) (let ((e-28 (vector-ref arg-3 28))) (let ((e-29 (vector-ref arg-3 29))) (let ((e-30 (vector-ref arg-3 30))) (let ((e-31 (vector-ref arg-3 31))) (let ((e-32 (vector-ref arg-3 32))) (vector e-0 e-37 e-2 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert e-5 (cons e-6 '()) e-13) (cons (cons e-7 e-8) e-14) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-5)) (let ((e-2 (unbox sc5))) (let ((act-5 (set-box! arg-2 (let ((e-0 (vector-ref arg-3 0))) (let ((e-38 (vector-ref arg-3 1))) (let ((e-37 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-36 (vector-ref arg-3 5))) (let ((e-35 (vector-ref arg-3 6))) (let ((e-34 (vector-ref arg-3 7))) (let ((e-33 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-10 (vector-ref arg-3 10))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (let ((e-17 (vector-ref arg-3 17))) (let ((e-18 (vector-ref arg-3 18))) (let ((e-19 (vector-ref arg-3 19))) (let ((e-20 (vector-ref arg-3 20))) (let ((e-21 (vector-ref arg-3 21))) (let ((e-22 (vector-ref arg-3 22))) (let ((e-23 (vector-ref arg-3 23))) (let ((e-24 (vector-ref arg-3 24))) (let ((e-25 (vector-ref arg-3 25))) (let ((e-26 (vector-ref arg-3 26))) (let ((e-27 (vector-ref arg-3 27))) (let ((e-28 (vector-ref arg-3 28))) (let ((e-29 (vector-ref arg-3 29))) (let ((e-30 (vector-ref arg-3 30))) (let ((e-31 (vector-ref arg-3 31))) (let ((e-32 (vector-ref arg-3 32))) (vector e-0 e-38 e-37 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert e-5 (cons e-6 e-2) e-13) (cons (cons e-7 e-8) e-14) e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-5)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Context-addTransform (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Context-case--addTransform-23827 arg-2 arg-1 arg-0 e-5 (CoreC-45Context-getFnName arg-2) eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45ProcessTransform-processTransform (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 arg-10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-resolveName arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ProcessDef-checkLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega e-6 arg-6 arg-7 arg-8 arg-9 arg-11 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((e-3 (cdr e-7))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (lambda (clam-0) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((e-22 (car e-19))) (let ((e-23 (cdr e-19))) (let ((act-4 (CoreC-45ContextC-45Log-logTerm e-9 arg-1 "transform.lhs" 3 (lambda () "Transform LHS") e-22 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45Core-wrapError (lambda (eta-2) (vector 71 arg-9 arg-10 eta-2)) (lambda (eta-2) (TTImpC-45Elab-checkTermSub arg-0 e-9 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 (vector 2 ) (cons 3 arg-6) e-18 e-14 arg-8 e-10 arg-12 (CoreC-45NormaliseC-45Eval-gnf e-9 e-14 e-23) eta-2)) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 ((CoreC-45Metadata-clearHoleLHS arg-2) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45ContextC-45Log-logTerm e-9 arg-1 "transform.rhs" 3 (lambda () "Transform RHS") e-13 eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (CoreC-45Context-addTransform arg-1 arg-9 (vector e-9 e-5 e-14 e-22 e-13) eta-2)))))))))) eff-0) clam-0)))))))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45OptionsC-45Log-unsafeMkLogLevel (lambda (ext-0 ext-1) (cons ext-0 ext-1)))
(define CoreC-45Context-withExtendedNS (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cns (let ((e-2 (vector-ref e-5 2))) e-2))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 (CoreC-45NameC-45Namespace-C-60C-46C-62 u--cns arg-2) e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-1296 arg-3 eta-1)) (lambda (eta-1) (lambda (eta-2) (vector 1 (vector 0 eta-1)))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (set-box! arg-1 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-36 (vector-ref e-8 5))) (let ((e-35 (vector-ref e-8 6))) (let ((e-34 (vector-ref e-8 7))) (let ((e-33 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-31 (vector-ref e-8 31))) (let ((e-32 (vector-ref e-8 32))) (vector e-0 e-1 u--cns e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (case (vector-ref e-7 0) ((0) (let ((e-2 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-2 eta-2))) (else (let ((e-10 (vector-ref e-7 1))) (vector 1 e-10)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ProcessDecls-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (let ((e-3 (vector-ref arg-9 3))) (let ((e-4 (vector-ref arg-9 4))) (let ((e-5 (vector-ref arg-9 5))) (lambda (eta-0) (TTImpC-45ProcessType-processType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-1 e-2 e-3 e-4 e-5 eta-0)))))))) ((1) (let ((e-7 (vector-ref arg-9 1))) (let ((e-8 (vector-ref arg-9 2))) (let ((e-9 (vector-ref arg-9 3))) (let ((e-10 (vector-ref arg-9 4))) (lambda (eta-0) (TTImpC-45ProcessData-processData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-7 e-8 e-9 e-10 eta-0))))))) ((2) (let ((e-12 (vector-ref arg-9 1))) (let ((e-13 (vector-ref arg-9 2))) (let ((e-14 (vector-ref arg-9 3))) (lambda (eta-0) (TTImpC-45ProcessDef-processDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-12 e-13 e-14 eta-0)))))) ((3) (let ((e-16 (vector-ref arg-9 1))) (let ((e-17 (vector-ref arg-9 2))) (let ((e-18 (vector-ref arg-9 3))) (TTImpC-45ProcessParams-processParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 e-16 e-17 e-18))))) ((4) (let ((e-21 (vector-ref arg-9 2))) (let ((e-22 (vector-ref arg-9 3))) (let ((e-23 (vector-ref arg-9 4))) (let ((e-24 (vector-ref arg-9 5))) (TTImpC-45ProcessRecord-processRecord arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-21 e-22 e-23 e-24)))))) ((5) (let ((e-26 (vector-ref arg-9 1))) (let ((e-27 (vector-ref arg-9 2))) (let ((e-28 (vector-ref arg-9 3))) (lambda (eta-0) (TTImpC-45ProcessDecls-processFailing arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-26 e-27 e-28 eta-0)))))) ((6) (let ((e-31 (vector-ref arg-9 2))) (let ((e-32 (vector-ref arg-9 3))) (lambda (eta-0) (CoreC-45Context-withExtendedNS arg-1 e-31 (CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-1)) e-32) eta-0))))) ((7) (let ((e-34 (vector-ref arg-9 1))) (let ((e-35 (vector-ref arg-9 2))) (let ((e-36 (vector-ref arg-9 3))) (let ((e-37 (vector-ref arg-9 4))) (lambda (eta-0) (TTImpC-45ProcessTransform-processTransform arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-34 e-35 e-36 e-37 eta-0))))))) ((8) (let ((e-39 (vector-ref arg-9 1))) (let ((e-40 (vector-ref arg-9 2))) (lambda (eta-0) (TTImpC-45ProcessRunElab-processRunElab arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-39 e-40 eta-0))))) ((9) (let ((e-44 (vector-ref arg-9 3))) (((e-44 arg-0) arg-7) arg-8))) ((10) (let ((e-46 (vector-ref arg-9 1))) (CoreC-45Context-addLogLevel arg-1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (CoreC-45OptionsC-45Log-unsafeMkLogLevel eta-1 eta-2))) eta-0)) e-46)))) (else (let ((e-48 (vector-ref arg-9 1))) (let ((e-49 (vector-ref arg-9 2))) (let ((e-50 (vector-ref arg-9 3))) (TTImpC-45ProcessBuiltin-processBuiltin arg-1 arg-7 arg-8 e-48 e-49 e-50))))))))
(define TTImpC-45ElabC-45Check-processDecl (lambda (ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9) (TTImpC-45ProcessDecls-process ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9)))
(define TTImpC-45ElabC-45Case-toRig0 (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (cons (CoreC-45TTC-45Binder-setMultiplicity e-4 csegen-30) e-5))))(else (let ((e-0 (- arg-2 1))) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (cons e-9 (TTImpC-45ElabC-45Case-toRig0 e-0 e-10)))))))))
(define TTImpC-45ElabC-45Case-updateMults (lambda (arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (TTImpC-45ElabC-45Case-updateMults e-3 (TTImpC-45ElabC-45Case-toRig0 e-2 arg-2)))))))
(define TTImpC-45ElabC-45Case-n--13130-2657-u--getArg (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (if (null? e-2) (cond ((equal? arg-10 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-4 (- arg-10 1))) (TTImpC-45ElabC-45Case-n--13130-2657-u--getArg arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-4)))) (let ((e-8 (cdr e-2))) (cond ((equal? arg-10 0) (box e-8))(else (cond ((equal? arg-10 0) (blodwen-error-quit "Nat case not covered"))(else (let ((e-4 (- arg-10 1))) (TTImpC-45ElabC-45Case-n--13130-2657-u--getArg arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 e-4)))))))))))))
(define TTImpC-45ElabC-45Case-n--13130-2658-u--getNameFrom (lambda (arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (TTImpC-45ElabC-45Case-n--13130-2657-u--getArg arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-7 arg-9))) (if (null? sc0) arg-2 (let ((e-2 (unbox sc0))) e-2)))))
(define TTImpC-45ElabC-45Case-bindCaseLocals (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-3) arg-5 (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 6 arg-2 e-6 (DataC-45Maybe-fromMaybe (lambda () e-6) e-10) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Case-n--13130-2658-u--getNameFrom e-6 e-10 e-11 e-3 arg-5 arg-4 arg-2 eta-0)) e-11) (TTImpC-45ElabC-45Case-bindCaseLocals arg-2 e-3 arg-4 arg-5)))))))))))
(define TTImpC-45ElabC-45Case-n--13313-2861-u--getBindName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (case (vector-ref arg-20 0) ((1) (let ((e-0 (vector-ref arg-20 1))) (let ((u--n (vector 1 e-0))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 u--n arg-21))) (cond ((equal? sc1 1) (cons u--n (vector 2 (CoreC-45Name-displayUserName e-0) arg-19))) (else (cons u--n u--n)))))))(else (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-832 arg-20 arg-21))) (cond ((equal? sc0 1) (cons arg-20 (vector 2 "_cn" arg-19))) (else (cons arg-20 arg-20))))))))
(define TTImpC-45ElabC-45Case-n--13313-2859-u--addEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (if (null? arg-19) (cons '() '()) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (let ((e-9 (cdr arg-21))) (let ((u--n (TTImpC-45ElabC-45Case-n--13313-2861-u--getBindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 e-2 arg-22))) (let ((sc2 (TTImpC-45ElabC-45Case-n--13313-2859-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-3 (bs+ arg-20 1 63) e-9 (cons (Builtin-snd u--n) arg-22)))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((u--nsC-39 (cons u--n e-5))) (cons u--nsC-39 (cons (vector 18 arg-10 (vector 2 ) 0 (Builtin-snd u--n) (vector 32 arg-10 1)) e-4)))))))))))))
(define TTImpC-45ElabC-45Case-n--13313-2864-u--nestLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 arg-21) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons e-2 (TTImpC-45TTImp-apply (vector 0 arg-20 (DataC-45Maybe-fromMaybe (lambda () e-2) e-6)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 32 arg-20 0)) e-10))))))))))
(define TTImpC-45ElabC-45Case-n--13313-2860-u--applyNested (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (let ((u--fc (TTImpC-45TTImp-getFC arg-20))) (TTImpC-45Utils-substNames '() (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Case-n--13313-2864-u--nestLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 u--fc eta-0)) arg-19) arg-20))))
(define TTImpC-45ElabC-45Case-n--13313-2865-u--replace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (cond ((equal? arg-19 0) (if (null? arg-21) arg-21 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((u--lhsC-39 (case (vector-ref e-2 0) ((18) (let ((e-1 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-6 (vector-ref e-2 3))) (let ((e-4 (vector-ref e-2 4))) (vector 18 e-1 e-7 e-6 e-4 arg-20))))))(else arg-20)))) (cons u--lhsC-39 e-3))))))(else (let ((e-0 (- arg-19 1))) (if (null? arg-21) arg-21 (let ((e-5 (car arg-21))) (let ((e-6 (cdr arg-21))) (cons e-5 (TTImpC-45ElabC-45Case-n--13313-2865-u--replace arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-0 arg-20 e-6))))))))))
(define TTImpC-45ElabC-45Case-n--13313-2863-u--mkSplit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-21 arg-22 arg-23) (if (null? arg-21) (PreludeC-45TypesC-45List-reverse (cons arg-22 arg-23)) (let ((e-2 (unbox arg-21))) (PreludeC-45TypesC-45List-reverse (TTImpC-45ElabC-45Case-n--13313-2865-u--replace arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 arg-22 arg-23))))))
(define TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-19 0) ((17) (let ((e-2 (vector-ref arg-19 2))) (cons (vector 1 (vector 0 e-2)) '()))) ((8) (let ((e-5 (vector-ref arg-19 2))) (let ((e-6 (vector-ref arg-19 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-5) (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-6))))) ((18) (let ((e-11 (vector-ref arg-19 4))) (let ((e-12 (vector-ref arg-19 5))) (cons e-11 (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-12))))) ((13) (let ((e-16 (vector-ref arg-19 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 eta-0)) e-16)))(else '()))))
(define TTImpC-45ElabC-45Case-n--13313-2866-u--updateClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23) (case (vector-ref arg-23 0) ((0) (let ((e-1 (vector-ref arg-23 1))) (let ((e-2 (vector-ref arg-23 2))) (let ((e-3 (vector-ref arg-23 3))) (let ((sc1 (TTImpC-45ElabC-45Case-n--13313-2859-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-0 0 arg-22 (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((u--argsC-39 (TTImpC-45ElabC-45Case-n--13313-2863-u--mkSplit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 e-2 e-4))) (let ((u--lhsC-39 (TTImpC-45TTImp-apply (vector 0 e-1 arg-19) u--argsC-39))) (vector 0 e-1 (TTImpC-45ElabC-45Case-n--13313-2860-u--applyNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-21 u--lhsC-39) (TTImpC-45ElabC-45Case-bindCaseLocals e-1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Case-getNestData eta-0)) arg-21) e-5 e-3))))))))))) ((1) (let ((e-5 (vector-ref arg-23 1))) (let ((e-6 (vector-ref arg-23 2))) (let ((e-7 (vector-ref arg-23 3))) (let ((e-8 (vector-ref arg-23 4))) (let ((e-9 (vector-ref arg-23 5))) (let ((e-10 (vector-ref arg-23 6))) (let ((e-11 (vector-ref arg-23 7))) (let ((sc1 (TTImpC-45ElabC-45Case-n--13313-2859-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-0 0 arg-22 (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-6)))) (let ((e-3 (cdr sc1))) (let ((u--argsC-39 (TTImpC-45ElabC-45Case-n--13313-2863-u--mkSplit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 e-6 e-3))) (let ((u--lhsC-39 (TTImpC-45TTImp-apply (vector 0 e-5 arg-19) u--argsC-39))) (vector 1 e-5 (TTImpC-45ElabC-45Case-n--13313-2860-u--applyNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-21 u--lhsC-39) e-7 e-8 e-9 e-10 e-11))))))))))))) (else (let ((e-13 (vector-ref arg-23 1))) (let ((e-14 (vector-ref arg-23 2))) (let ((sc1 (TTImpC-45ElabC-45Case-n--13313-2859-u--addEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-0 0 arg-22 (TTImpC-45ElabC-45Case-n--13313-2867-u--usedIn arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-14)))) (let ((e-3 (cdr sc1))) (let ((u--argsC-39 (TTImpC-45ElabC-45Case-n--13313-2863-u--mkSplit arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-20 e-14 e-3))) (let ((u--lhsC-39 (TTImpC-45TTImp-apply (vector 0 e-13 arg-19) u--argsC-39))) (vector 2 e-13 (TTImpC-45ElabC-45Case-n--13313-2860-u--applyNested arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-21 u--lhsC-39))))))))))))
(define TTImpC-45ElabC-45Case-caseBlock (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45ImplicitBind-getToBind arg-0 arg-1 arg-4 arg-3 arg-9 (let ((e-0 (vector-ref arg-8 0))) e-0) (let ((e-1 (vector-ref arg-8 1))) e-1) arg-11 '() eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-1 "elab.case" 5 (lambda () (string-append "Doing a case under unbound implicits " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2575 e-6))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45UnifyState-genVarName arg-1 arg-3 "scr" eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (CoreC-45Context-toFullNames arg-1 csegen-54 (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((CoreC-45Context-prettyName arg-1 e-9) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45UnifyState-genCaseName arg-1 arg-3 e-10 eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--env (TTImpC-45ElabC-45Case-updateMults (let ((e-12 (vector-ref e-5 11))) e-12) arg-11))) (lambda (eta-3) (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 ((CoreC-45Context-lookupCtxtExact (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) (let ((e-0 (vector-ref e-10 0))) e-0)) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--vis (LibrariesC-45DataC-45WithDefault-specified (if (null? e-11) 2 (let ((e-1 (unbox e-11))) (let ((sc8 (CoreC-45TT-u--C-61C-61_Eq_Visibility (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-25 (vector-ref e-1 9))) e-25)) 2))) (cond ((equal? sc8 1) 2) (else 0)))))))) (let ((u--splitOn (TTImpC-45ElabC-45Case-findScrutinee arg-0 u--env arg-13))) (lambda (eta-5) (let ((act-8 (if (null? arg-18) (let ((act-8 (CoreC-45UnifyState-genName arg-1 arg-3 "caseTy" eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-9 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-9 csegen-30 u--env e-12 (vector 11 arg-9 e-13) eta-7)))) eff-0) eta-6)))))))) eff-0) eta-5))))) (let ((e-1 (unbox arg-18))) ((CoreC-45NormaliseC-45Eval-getTerm e-1) eta-5))))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-9 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (TTImpC-45ElabC-45ImplicitBind-bindImplicits arg-1 arg-0 arg-9 (let ((e-1 (vector-ref arg-8 1))) e-1) e-10 u--env e-6 e-12 (vector 11 arg-9 e-13) eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (let ((e-2 (car e-14))) (let ((u--casefnty (CoreC-45Env-abstractFullEnvType arg-0 arg-9 (TTImpC-45ElabC-45Case-allow u--splitOn (TTImpC-45ElabC-45Case-explicitPi u--env)) (PreludeC-45Types-maybe (lambda () (vector 3 arg-9 e-8 (vector 2 arg-9 arg-16 (vector 1 ) arg-15) (let ((sc11 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc11))) (((e-1 'erased) 'erased) e-2))))) (lambda () (lambda (eta-8) e-2)) u--splitOn)))) (lambda (eta-8) (let ((act-11 (CoreC-45Normalise-normaliseSizeLimit arg-1 '() e-10 10 '() u--casefnty eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-12 (TTImpC-45ElabC-45Utils-findErased arg-1 e-15 eta-9))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-17 (car e-16))) (let ((act-13 (CoreC-45Normalise-logEnv arg-0 arg-1 "elab.case" 10 "Case env" u--env clam-0))) (case (vector-ref act-13 0) ((0) (let ((e-18 (vector-ref act-13 1))) (vector 0 e-18))) (else (let ((act-14 (CoreC-45Normalise-logTermNF '() arg-1 "elab.case" 2 (lambda () (string-append "Case function type: " (CoreC-45Name-u--show_Show_Name e-9))) '() e-15 clam-0))) (case (vector-ref act-14 0) ((0) (let ((e-19 (vector-ref act-14 1))) (vector 0 e-19))) (else (let ((act-15 ((CoreC-45Core-traverse_ (lambda (eta-10) (lambda (eta-11) (CoreC-45Context-addToSave arg-1 eta-10 eta-11))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getMetas e-15))) clam-0))) (case (vector-ref act-15 0) ((0) (let ((e-20 (vector-ref act-15 1))) (vector 0 e-20))) (else (let ((act-16 (let ((sc17 (DataC-45List-isNil e-6))) (cond ((equal? sc17 1) (vector 1 (vector 0 ))) (else ((TTImpC-45ElabC-45Case-findImpsIn '() arg-9 '() '() e-15) clam-0)))))) (case (vector-ref act-16 0) ((0) (let ((e-21 (vector-ref act-16 1))) (vector 0 e-21))) (else (let ((act-17 (CoreC-45Context-addDef arg-1 e-9 (let ((sc18 (CoreC-45Context-newDef arg-9 e-9 (let ((sc19 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc19 1) csegen-30) (else AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) '() e-15 u--vis (vector 0 )))) (let ((e-0 (vector-ref sc18 0))) (let ((e-1 (vector-ref sc18 1))) (let ((e-42 (vector-ref sc18 2))) (let ((e-40 (vector-ref sc18 4))) (let ((e-39 (vector-ref sc18 5))) (let ((e-38 (vector-ref sc18 6))) (let ((e-37 (vector-ref sc18 7))) (let ((e-36 (vector-ref sc18 8))) (let ((e-35 (vector-ref sc18 9))) (let ((e-34 (vector-ref sc18 10))) (let ((e-33 (vector-ref sc18 11))) (let ((e-32 (vector-ref sc18 12))) (let ((e-31 (vector-ref sc18 13))) (let ((e-30 (vector-ref sc18 14))) (let ((e-29 (vector-ref sc18 15))) (let ((e-28 (vector-ref sc18 16))) (let ((e-27 (vector-ref sc18 17))) (let ((e-26 (vector-ref sc18 18))) (let ((e-25 (vector-ref sc18 19))) (let ((e-24 (vector-ref sc18 20))) (let ((e-23 (vector-ref sc18 21))) (let ((e-22 (vector-ref sc18 22))) (vector e-0 e-1 e-42 e-17 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 e-23 e-22)))))))))))))))))))))))) clam-0))) (case (vector-ref act-17 0) ((0) (let ((e-22 (vector-ref act-17 1))) (vector 0 e-22))) (else (let ((e-22 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-18 ((CoreC-45Core-traverse_ (lambda (eta-11) (TTImpC-45ProcessFnOpt-processFnOpt arg-1 arg-9 0 e-9 eta-11)) arg-12) eta-10))) (case (vector-ref act-18 0) ((0) (let ((e-23 (vector-ref act-18 1))) (vector 0 e-23))) (else (let ((u--tot (DataC-45Maybe-fromMaybe (lambda () 2) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe e-11 (lambda (bind-0) (CoreC-45ContextC-45Context-findSetTotal (let ((e-34 (vector-ref bind-0 12))) e-34))))))) (let ((act-19 (CoreC-45ContextC-45Log-log arg-1 "elab.case" 5 (lambda () (DataC-45String-unwords (cons "Setting totality requirement for" (cons (CoreC-45Name-u--show_Show_Name e-9) (cons "to" (cons (CoreC-45TT-u--show_Show_TotalReq u--tot) '())))))) eta-10))) (case (vector-ref act-19 0) ((0) (let ((e-24 (vector-ref act-19 1))) (vector 0 e-24))) (else (let ((act-20 (CoreC-45Context-setFlag arg-1 arg-9 (vector 8 e-22) (vector 6 u--tot) eta-10))) (case (vector-ref act-20 0) ((0) (let ((e-25 (vector-ref act-20 1))) (vector 0 e-25))) (else (let ((u--caseRef (vector 1 arg-9 (vector 1 ) (vector 8 e-22)))) (let ((u--applyEnv (CoreC-45UnifyState-applyToFull arg-0 arg-9 u--caseRef u--env))) (let ((u--appTm (PreludeC-45Types-maybe (lambda () (vector 4 arg-9 u--applyEnv arg-14)) (lambda () (lambda (eta-11) u--applyEnv)) u--splitOn))) (let ((u--altsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-11) (TTImpC-45ElabC-45Case-n--13313-2866-u--updateClause arg-0 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9 u--splitOn arg-10 u--env eta-11)) arg-17))) (let ((act-21 (CoreC-45ContextC-45Log-log arg-1 "elab.case" 2 (lambda () (string-append "Nested: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2595 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2595 u--d u--x)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-11) (TTImpC-45ElabC-45Case-getNestData eta-11)) arg-10)))) eta-10))) (case (vector-ref act-21 0) ((0) (let ((e-26 (vector-ref act-21 1))) (vector 0 e-26))) (else (let ((act-22 (CoreC-45ContextC-45Log-log arg-1 "elab.case" 2 (lambda () (string-append "Generated alts: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2025 u--altsC-39))) eta-10))) (case (vector-ref act-22 0) ((0) (let ((e-27 (vector-ref act-22 1))) (vector 0 e-27))) (else (let ((act-23 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.case" 2 (lambda () "Case application") u--env u--appTm eta-10))) (case (vector-ref act-23 0) ((0) (let ((e-28 (vector-ref act-23 1))) (vector 0 e-28))) (else (let ((u--nestC-39 '())) (let ((act-24 (let ((act-24 (unbox arg-3))) (vector 1 act-24)))) (case (vector-ref act-24 0) ((0) (let ((e-29 (vector-ref act-24 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-24 1))) ((let ((eff-0 (let ((u--olddelayed (let ((e-31 (vector-ref e-29 10))) e-31))) (lambda (eta-11) (let ((act-25 (let ((act-25 (set-box! arg-3 (let ((e-0 (vector-ref e-29 0))) (let ((e-1 (vector-ref e-29 1))) (let ((e-39 (vector-ref e-29 2))) (let ((e-38 (vector-ref e-29 3))) (let ((e-37 (vector-ref e-29 4))) (let ((e-36 (vector-ref e-29 5))) (let ((e-35 (vector-ref e-29 6))) (let ((e-34 (vector-ref e-29 7))) (let ((e-33 (vector-ref e-29 8))) (let ((e-32 (vector-ref e-29 9))) (let ((e-30 (vector-ref e-29 11))) (vector e-0 e-1 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-32 '() e-30))))))))))))))) (vector 1 act-25)))) (case (vector-ref act-25 0) ((0) (let ((e-30 (vector-ref act-25 1))) (vector 0 e-30))) (else (let ((act-26 ((TTImpC-45ElabC-45Check-processDecl '() arg-1 arg-2 arg-3 arg-5 arg-6 (cons 1 '()) u--nestC-39 '() (vector 2 arg-9 e-9 u--altsC-39)) eta-11))) (case (vector-ref act-26 0) ((0) (let ((e-31 (vector-ref act-26 1))) (vector 0 e-31))) (else (let ((u--inlineOK (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-12) 1)) u--splitOn))) (let ((act-27 (cond ((equal? u--inlineOK 1) (CoreC-45Context-setFlag arg-1 arg-9 e-9 (vector 0 ) eta-11)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-27 0) ((0) (let ((e-32 (vector-ref act-27 1))) (vector 0 e-32))) (else (let ((act-28 (let ((act-28 (unbox arg-3))) (vector 1 act-28)))) (case (vector-ref act-28 0) ((0) (let ((e-33 (vector-ref act-28 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-28 1))) ((let ((eff-0 (lambda (eta-12) (let ((act-29 (let ((act-29 (set-box! arg-3 (let ((e-0 (vector-ref e-33 0))) (let ((e-1 (vector-ref e-33 1))) (let ((e-43 (vector-ref e-33 2))) (let ((e-42 (vector-ref e-33 3))) (let ((e-41 (vector-ref e-33 4))) (let ((e-40 (vector-ref e-33 5))) (let ((e-39 (vector-ref e-33 6))) (let ((e-38 (vector-ref e-33 7))) (let ((e-37 (vector-ref e-33 8))) (let ((e-36 (vector-ref e-33 9))) (let ((e-34 (vector-ref e-33 11))) (vector e-0 e-1 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 u--olddelayed e-34))))))))))))))) (vector 1 act-29)))) (case (vector-ref act-29 0) ((0) (let ((e-34 (vector-ref act-29 1))) (vector 0 e-34))) (else (vector 1 (cons u--appTm (CoreC-45NormaliseC-45Eval-gnf arg-0 u--env e-2))))))))) eff-0) eta-11))))))))))))))))))) eff-0) eta-10)))))))))))))))))))))))))))))))) eff-0) clam-0))))))))))))))))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Delayed-n--10863-14406-u--mkExpected (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (let ((act-1 (CoreC-45UnifyState-genName arg-10 arg-8 "delayTy" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-10 arg-8 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-10 arg-8 arg-6 csegen-30 arg-4 e-5 (vector 11 arg-6 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-4 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-11))) (vector 1 e-1)))))
(define TTImpC-45ElabC-45Delayed-delayElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nos (let ((e-12 (vector-ref e-5 5))) e-12))) (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genName arg-1 arg-3 "delayed" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Delayed-n--10863-14406-u--mkExpected arg-0 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-8 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45UnifyState-newDelayed arg-0 arg-3 arg-1 arg-5 csegen-1416 arg-7 e-6 e-8))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((act-5 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.delay" 5 (lambda () (string-append "Postponing elaborator " (string-append (CoreC-45Name-u--show_Show_Name e-6) " for"))) arg-7 e-7 clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (let ((act-6 (unbox arg-1))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 (unbox arg-3))) (vector 1 act-7))))) (lambda (world-0) (let ((act-7 (eff-0 world-0))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-1 (lambda (world-1) (let ((act-8 (set-box! arg-3 (let ((e-0 (vector-ref e-11 0))) (let ((e-1 (vector-ref e-11 1))) (let ((e-20 (vector-ref e-11 2))) (let ((e-19 (vector-ref e-11 3))) (let ((e-4 (vector-ref e-11 4))) (let ((e-18 (vector-ref e-11 5))) (let ((e-17 (vector-ref e-11 6))) (let ((e-16 (vector-ref e-11 7))) (let ((e-15 (vector-ref e-11 8))) (let ((e-14 (vector-ref e-11 9))) (let ((e-13 (vector-ref e-11 10))) (let ((e-12 (vector-ref e-11 11))) (vector e-0 e-1 e-20 e-19 e-4 e-18 e-17 e-16 e-15 e-14 (cons (cons arg-9 (cons e-2 (cons (let ((e-43 (vector-ref e-10 10))) e-43) (TTImpC-45ElabC-45Delayed-mkClosedElab arg-0 arg-5 arg-7 (lambda (eta-4) (let ((act-8 (let ((act-8 (unbox arg-3))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-21 (vector-ref act-8 1))) (vector 0 e-21))) (else (let ((e-21 (vector-ref act-8 1))) ((let ((eff-1 (let ((u--nosC-39 (let ((e-28 (vector-ref e-21 5))) e-28))) (lambda (eta-5) (let ((act-9 (let ((act-9 (set-box! arg-3 (let ((e-33 (vector-ref e-21 0))) (let ((e-32 (vector-ref e-21 1))) (let ((e-31 (vector-ref e-21 2))) (let ((e-30 (vector-ref e-21 3))) (let ((e-29 (vector-ref e-21 4))) (let ((e-27 (vector-ref e-21 6))) (let ((e-26 (vector-ref e-21 7))) (let ((e-25 (vector-ref e-21 8))) (let ((e-24 (vector-ref e-21 9))) (let ((e-23 (vector-ref e-21 10))) (let ((e-22 (vector-ref e-21 11))) (vector e-33 e-32 e-31 e-30 e-29 u--nos e-27 e-26 e-25 e-24 e-23 e-22))))))))))))))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-22 (vector-ref act-9 1))) (vector 0 e-22))) (else (let ((act-10 (arg-10 eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-23 (vector-ref act-10 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-10 1))) ((let ((eff-1 (lambda (eta-6) (let ((act-11 (let ((act-11 (unbox arg-3))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-24 (vector-ref act-11 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-11 1))) ((let ((eff-1 (lambda (eta-7) (let ((act-12 (let ((act-12 (set-box! arg-3 (let ((e-36 (vector-ref e-24 0))) (let ((e-35 (vector-ref e-24 1))) (let ((e-34 (vector-ref e-24 2))) (let ((e-33 (vector-ref e-24 3))) (let ((e-32 (vector-ref e-24 4))) (let ((e-30 (vector-ref e-24 6))) (let ((e-29 (vector-ref e-24 7))) (let ((e-28 (vector-ref e-24 8))) (let ((e-27 (vector-ref e-24 9))) (let ((e-26 (vector-ref e-24 10))) (let ((e-25 (vector-ref e-24 11))) (vector e-36 e-35 e-34 e-33 e-32 u--nosC-39 e-30 e-29 e-28 e-27 e-26 e-25))))))))))))))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-25 (vector-ref act-12 1))) (vector 0 e-25))) (else (vector 1 e-23))))))) eff-1) eta-6)))))))) eff-1) eta-5)))))))))))) eff-1) eta-4)))))))))) e-13) e-12)))))))))))))))) (vector 1 act-8))))) eff-1) world-0))))))) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 e-7)))))))) eff-0) clam-0))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Case-n--16499-5508-u--checkConcrete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18) (lambda (clam-0) (case (vector-ref arg-18 0) ((1) (let ((e-2 (vector-ref arg-18 2))) (case (vector-ref e-2 0) ((2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Can't infer type for case scrutinee") clam-0))(else (vector 1 (vector 0 ))))))(else (vector 1 (vector 0 )))))))
(define TTImpC-45ElabC-45Case-n--16499-5507-u--applyTo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-19 0) ((0) (let ((e-1 (vector-ref arg-19 1))) (let ((e-2 (vector-ref arg-19 2))) (let ((e-3 (vector-ref arg-19 3))) (let ((e-4 (vector-ref arg-19 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((1) (let ((act-1 (((e-4 arg-17) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Case-n--16499-5507-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (vector 8 e-1 arg-18 (vector 32 e-1 0)) e-5))) eff-0) clam-0))))))(else (let ((act-1 (((e-4 arg-17) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 arg-6 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Case-n--16499-5507-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 (vector 10 arg-6 arg-18 e-2 (vector 32 arg-6 0)) e-5))) eff-0) clam-0)))))))))(else (vector 1 arg-18)))))))))(else (lambda (eta-0) (vector 1 arg-18))))))
(define TTImpC-45ElabC-45Case-n--16499-5509-u--getRetTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (lambda (clam-0) (case (vector-ref arg-18 0) ((0) (let ((e-1 (vector-ref arg-18 1))) (let ((e-3 (vector-ref arg-18 3))) (let ((e-4 (vector-ref arg-18 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-17) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Case-n--16499-5509-u--getRetTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-5))) eff-0) clam-0))))))(else (vector 1 '()))))))) ((3) (let ((e-7 (vector-ref arg-18 2))) (let ((act-1 (CoreC-45Context-lookupTyExact e-7 (let ((e-0 (vector-ref arg-17 0))) e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-16 '() arg-17 '() e-1) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (cons e-7 e-11)))))) eff-0) clam-1)))))))))) eff-0) clam-0)))))))(else (vector 1 '()))))))
(define TTImpC-45ElabC-45Case-case--checkCaseC-44guessScrType-5827 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (case (vector-ref arg-21 0) ((0) (let ((e-2 (vector-ref arg-21 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-16))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-lookupTyName (TTImpC-45TTImp-mapNestedName arg-8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20) (let ((e-4 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-4) (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20) (let ((e-7 (cdr e-4))) (if (null? e-7) (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20) (let ((e-10 (cdr e-7))) (if (null? e-3) (lambda (eta-2) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-16 '() e-5 '() e-10) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ElabC-45Case-n--16499-5509-u--getRetTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-5 e-11))) eff-0) eta-2))))))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-11) (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20) (let ((e-12 (unbox e-11))) (if (null? e-12) (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (TTImpC-45ElabC-45Case-n--16499-5507-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-5 (vector 0 arg-6 e-14) e-13)))))))) eff-0) eta-2)))))) (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))(else (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-20)))))
(define TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) (lambda (eta-0) (vector 1 (vector 32 arg-6 0))) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (TTImpC-45ElabC-45Case-case--checkCaseC-44guessScrType-5827 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-5 e-7 e-6 e-3 (TTImpC-45TTImp-getFn e-6))))))(else (TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 e-3))))))))
(define TTImpC-45ElabC-45Case-checkCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (TTImpC-45ElabC-45Delayed-delayElab arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 arg-16 0 (lambda (eta-0) (let ((act-1 (case (vector-ref arg-14 0) ((32) ((TTImpC-45ElabC-45Case-n--16499-5510-u--guessScrType arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-15) eta-0))(else (vector 1 arg-14))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-30 arg-8 arg-9 arg-10 e-5 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-6))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((act-4 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.case" 10 (lambda () "Expected scrutinee type") e-2 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((u--chrig (let ((sc5 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc5 1) csegen-30) (else AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))))) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "elab.case" 5 (lambda () (string-append "Checking " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-13) (string-append " at " (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega u--chrig))))) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-3) (let ((act-6 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-4) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--chrig arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (Builtin-fst e-10) (cons (Builtin-snd e-10) u--chrig)))))) eff-0) eta-3)))))) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((14) (let ((e-10 (vector-ref lcase-0 3))) (AlgebraC-45Semiring-branchOne csegen-931 (lambda () (lambda (eta-3) (let ((act-6 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-4) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-1416 arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (Builtin-fst e-11) (cons (Builtin-snd e-11) csegen-1416)))))) eff-0) eta-3))))))) (lambda () (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 eta-3))) e-10)))(else (lambda (eta-3) (CoreC-45Core-u--throw_Catchable_Core_Error lcase-0 eta-3))))) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-11 (car e-10))) (let ((e-4 (cdr e-10))) (let ((e-13 (car e-4))) (let ((e-12 (cdr e-4))) (let ((act-7 ((CoreC-45NormaliseC-45Eval-getTerm e-13) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-14 (vector-ref act-7 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-8 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.case" 5 (lambda () "Scrutinee type") arg-10 e-14 eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-15 (vector-ref act-8 1))) (vector 0 e-15))) (else (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-16 (vector-ref act-9 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-10 (let ((act-10 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-16 arg-10 e-14) eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-17 (vector-ref act-10 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-10 1))) ((let ((eff-0 (TTImpC-45ElabC-45Case-n--16499-5508-u--checkConcrete arg-0 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-17))) eff-0) eta-4))))))) (case (vector-ref act-10 0) ((0) (let ((e-17 (vector-ref act-10 1))) (vector 0 e-17))) (else (TTImpC-45ElabC-45Case-caseBlock arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-11 arg-9 arg-10 arg-12 arg-13 e-11 e-14 e-12 arg-15 arg-16 eta-4))))))) eff-0) eta-3))))))))))) eff-0) clam-1)))))))))))) eff-0) clam-0)))))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) ext-0)))
(define TTImpC-45ElabC-45Local-case--getLocalTerm-3012 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Case Local failed") clam-0) (let ((e-1 (unbox arg-7))) (let ((e-5 (car e-1))) (let ((act-1 ((TTImpC-45ElabC-45Local-getLocalTerm arg-0 arg-6 arg-5 arg-4 (vector 4 arg-5 arg-3 (vector 0 arg-5 '() e-5)) arg-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (vector 1 (cons e-2 (cons e-5 e-3)))))))) eff-0) clam-0)))))))))))
(define TTImpC-45ElabC-45Local-getLocalTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 (cons arg-4 '()))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (TTImpC-45ElabC-45Local-case--getLocalTerm-3012 arg-0 e-2 e-3 arg-4 arg-3 arg-2 arg-1 (CoreC-45Env-defined arg-0 e-2 arg-3)))))))
(define TTImpC-45ElabC-45Local-checkCaseLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-13 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-16) (let ((e-1 (unbox e-6))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref e-1 18))) e-18))))) (let ((u--name (vector 1 arg-11 u--nt arg-13))) (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45Local-getLocalTerm arg-0 arg-1 arg-11 arg-10 u--name arg-14) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "elab.local" 5 (lambda () (string-append "Updating case local " (string-append (CoreC-45Name-u--show_Show_Name arg-12) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2489 e-3))))) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.local" 5 (lambda () "To") arg-10 e-2 clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((u--nestC-39 (cons (cons arg-12 (cons (box arg-13) (cons e-3 (lambda (u--fc) (lambda (nt-0) e-2))))) arg-9))) ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--nestC-39 arg-10 arg-15 arg-16) clam-0))))))))))))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Lazy-n--10808-8500-u--delayError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((49) 1)(else 0))))
(define TTImpC-45ElabC-45Lazy-checkDelay (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genName arg-1 arg-3 "delayTy" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-11 csegen-30 arg-10 e-5 (vector 11 arg-11 e-6) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (lambda () (lambda (eta-0) (lambda (eta-1) (vector 1 eta-0)))) arg-13) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-0) (let ((act-2 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 (box e-5) (lambda (eta-1) (TTImpC-45ElabC-45Lazy-n--10808-8500-u--delayError arg-0 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 eta-1)) 4 (lambda (u--delayed) (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-7 0) ((5) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 (box (CoreC-45Normalise-glueBack arg-1 arg-0 e-8 arg-10 e-3))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((act-6 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-4) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 ((CoreC-45NormaliseC-45Eval-getTerm e-4) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (vector 7 arg-11 e-2 e-12 e-10) (CoreC-45Normalise-glueBack arg-1 arg-0 e-8 arg-10 (vector 5 arg-11 e-2 e-11))))))) eff-0) eta-3)))))))) eff-0) clam-1)))))))))) eff-0) eta-2)))))))) eff-0) clam-0))))))))(else (let ((act-4 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.delay" 5 (lambda () "Expected delay type") arg-10 e-7 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-11 "Can't infer delay type") clam-0))))))))) eff-0) eta-1))))))) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Lazy-checkDelayed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-1 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-5))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (vector 1 (cons (vector 6 arg-11 arg-12 e-2) e-3))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Dot-case--checkDot-8539 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((1) (let ((act-1 ((TTImpC-45ElabC-45Check-check arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (let ((e-5 (vector-ref arg-7 5))) (vector (vector 2 ) e-1 e-2 e-3 e-4 e-5)))))) arg-6 arg-5 arg-2 (box arg-1)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (TTImpC-45ElabC-45Dot-registerDot arg-0 arg-14 arg-13 arg-12 arg-11 arg-8 arg-5 arg-4 arg-3 e-2 arg-1 clam-0))))) eff-0) ext-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 (string-append "Dot pattern not valid here (Not LHS) " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-2))) ext-0)))))
(define TTImpC-45ElabC-45Dot-checkDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-11 (string-append "Dot pattern not valid here (unknown type) " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-13))) eta-0)) (let ((e-2 (unbox arg-14))) (lambda (eta-0) (TTImpC-45ElabC-45Dot-case--checkDot-8539 arg-0 e-2 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-8 0))) e-0) eta-0))))))
(define TTImpC-45ElabC-45Lazy-checkForce (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 '()))) (lambda () (lambda (u--gty) (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF arg-1 u--gty) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 (vector 5 arg-11 2 e-6))))))) eff-0) eta-1)))))))) arg-13) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-3) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-8 0) ((5) (let ((e-9 (vector-ref e-8 2))) (let ((e-4 (vector-ref e-8 3))) (vector 1 (cons (vector 8 arg-11 e-9 e-2) (CoreC-45Normalise-glueBack arg-1 arg-0 e-5 arg-10 e-4))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-11 "Forcing a non-delayed type") clam-1)))))) eff-0) clam-0)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-metaVarI (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-5 arg-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--hinf (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 2))) (case (vector-ref e-2 0) ((2) (let ((sc4 (CoreC-45ContextC-45Context-holeInit 0))) (let ((e-0 (car sc4))) (cons e-0 1))))(else (CoreC-45ContextC-45Context-holeInit 0)))))(else (CoreC-45ContextC-45Context-holeInit 0))))) (CoreC-45UnifyState-newMeta arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (vector 7 (CoreC-45Env-length arg-5) u--hinf) 1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Hole-mkPrecise (lambda (arg-1 arg-2) (lambda (clam-0) (case (vector-ref arg-2 0) ((1) (let ((e-2 (vector-ref arg-2 2))) (case (vector-ref e-2 0) ((2) (let ((e-6 (vector-ref e-2 2))) (CoreC-45Context-updateDef arg-1 (vector 8 e-6) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((7) (let ((e-0 (vector-ref lcase-0 1))) (let ((e-4 (vector-ref lcase-0 2))) (box (vector 7 e-0 (let ((e-9 (car e-4))) (cons e-9 1)))))))(else '()))) clam-0)))(else (vector 1 (vector 0 ))))))(else (vector 1 (vector 0 )))))))
(define TTImpC-45ElabC-45Check-saveHole (lambda (arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-4 e-15 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert arg-2 (vector 0 ) e-13) e-14)))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Metadata-withCurrentLHS (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getFullName arg-0 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 (vector 0 )))) (lambda () (lambda (u--lhs) (lambda (eta-1) (let ((act-3 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-11 (vector-ref e-5 5))) (let ((e-10 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-1 e-2 e-3 (cons (cons e-6 u--lhs) e-4) e-11 e-10 e-7 e-8 e-9)))))))))))))) (vector 1 act-3))))) (let ((e-3 (vector-ref e-5 3))) e-3)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Hole-checkHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (if (null? arg-11) (let ((act-1 (CoreC-45UnifyState-genName arg-1 arg-3 (string-append "type_of_" (CoreC-45Name-u--show_Show_UserName arg-10)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--envC-39 (CoreC-45Env-letToLam arg-8))) (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-9 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-9 csegen-30 u--envC-39 e-5 (vector 11 arg-9 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-inCurrentNS arg-1 (vector 1 arg-10) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-1))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-9 u--envC-39 e-7) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (TTImpC-45ElabC-45Hole-mkPrecise arg-1 e-10))) eff-0) eta-4))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((CoreC-45Context-lookupCtxtExact e-8 (let ((e-0 (vector-ref e-9 0))) e-0)) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-11) (let ((act-8 (TTImpC-45ElabC-45Check-metaVarI arg-0 arg-1 arg-3 arg-9 arg-5 u--envC-39 e-8 e-7 clam-3))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-4) (let ((e-2 (car e-12))) (let ((e-3 (cdr e-12))) (let ((act-9 (CoreC-45Metadata-withCurrentLHS arg-1 arg-2 (vector 8 e-2) clam-4))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 (CoreC-45Metadata-addNameLoc arg-2 arg-1 arg-9 e-8 clam-4))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 ((CoreC-45Context-addUserHole arg-1 0 e-8) clam-4))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 ((TTImpC-45ElabC-45Check-saveHole arg-4 e-8) clam-4))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-8 e-7)))))))))))))))))))) eff-0) clam-3))))) (let ((act-8 (CoreC-45ContextC-45Log-log arg-1 "elab.hole" 1 (lambda () (string-append (CoreC-45Name-u--show_Show_Name e-8) " already defined")) clam-3))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-8) clam-3)))))))) eff-0) eta-4))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-11))) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 (vector 1 arg-10) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-1) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--envC-39 (CoreC-45Env-letToLam arg-8))) (lambda (eta-2) (let ((act-5 (TTImpC-45ElabC-45Check-metaVarI arg-0 arg-1 arg-3 arg-9 arg-5 u--envC-39 e-5 e-8 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-6 (let ((act-6 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-1) clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (TTImpC-45ElabC-45Hole-mkPrecise arg-1 e-10))) eff-0) clam-2))))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45Metadata-withCurrentLHS arg-1 arg-2 (vector 8 e-2) clam-2))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45Metadata-addNameLoc arg-2 arg-1 arg-9 e-5 clam-2))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 ((CoreC-45Context-addUserHole arg-1 0 e-5) clam-2))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 ((TTImpC-45ElabC-45Check-saveHole arg-4 e-5) clam-2))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (vector 1 (cons e-3 e-1)))))))))))))))))))))) eff-0) eta-2))))))))) eff-0) clam-1))))) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "elab.hole" 1 (lambda () (string-append (CoreC-45Name-u--show_Show_Name e-5) " already defined")) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 arg-9 e-5) clam-1)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Binders-checkPiInfo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 ext-0) (case (vector-ref arg-11 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-11 1))) (let ((act-1 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-4 arg-12) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (vector 1 (vector 3 e-2)))))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Binders-n--10640-8301-u--drop (lambda (arg-1 arg-2 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-6 arg-2))) (cond ((equal? sc2 1) (TTImpC-45ElabC-45Binders-n--10640-8301-u--drop arg-1 arg-2 e-3)) (else (cons (cons e-6 e-7) (TTImpC-45ElabC-45Binders-n--10640-8301-u--drop arg-1 arg-2 e-3))))))))))))
(define TTImpC-45ElabC-45Binders-dropName (lambda (arg-1 arg-2) (TTImpC-45ElabC-45Binders-n--10640-8301-u--drop arg-2 arg-1 arg-2)))
(define TTImpC-45ElabC-45Binders-getTyNF (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((3) (vector 1 arg-3))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-2 arg-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-clearDefs e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-7 arg-2 e-6 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Check-n--12604-3220-u--dropSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-10 ext-0) (case (vector-ref arg-10 0) ((1) (let ((e-4 (vector-ref arg-10 1))) (vector 1 e-4)))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Badly formed weakened environment") ext-0)))))
(define TTImpC-45ElabC-45Check-n--12604-3221-u--dropTop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (cond ((equal? arg-7 0) '())(else (let ((e-5 (- arg-7 1))) (box e-5))))))
(define CoreC-45TTC-45Term-shrinkPi (lambda (arg-2 arg-3) (CoreC-45TTC-45Binder-u--traverse_Traversable_PiInfo csegen-255 (lambda (u--t) (CoreC-45TTC-45Term-shrinkTerm u--t arg-3)) arg-2)))
(define TTImpC-45ElabC-45Check-n--12604-3223-u--removeArgVars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (if (null? arg-7) (box '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (case (vector-ref e-2 0) ((0) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (let ((e-8 (vector-ref e-2 3))) (cond ((equal? e-8 0) (TTImpC-45ElabC-45Check-n--12604-3223-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3))(else (let ((e-10 (- e-8 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Check-n--12604-3223-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) (lambda (u--argsC-39) (box (cons (vector 0 e-6 e-7 e-10) u--argsC-39)))))))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-2 (vector 1 (vector 0 ))) (lambda (u--aC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Check-n--12604-3223-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) (lambda (u--argsC-39) (box (cons u--aC-39 u--argsC-39)))))))))))))
(define TTImpC-45ElabC-45Check-case--strengthenedEStateC-44removeArg-3379 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (TTImpC-45ElabC-45Check-n--12604-3223-u--removeArgVars arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3) (lambda (u--argsC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-2 (vector 1 (vector 0 ))) (lambda (u--fC-39) (box (CoreC-45TTC-45Term-apply (CoreC-45TTC-45Term-getLoc e-2) u--fC-39 u--argsC-39))))))))))
(define TTImpC-45ElabC-45Check-n--12604-3222-u--removeArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7) (TTImpC-45ElabC-45Check-case--strengthenedEStateC-44removeArg-3379 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (CoreC-45TTC-45Term-getFnArgs arg-7))))
(define TTImpC-45ElabC-45Check-n--12604-3224-u--strTms (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (case (vector-ref e-3 0) ((0) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (let ((e-6 (vector-ref e-3 3))) (let ((e-7 (vector-ref e-3 4))) (let ((e-8 (vector-ref e-3 5))) (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-9 (vector-ref act-1 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc5 (CoreC-45TTC-45Term-shrinkPi e-6 (vector 1 (vector 0 ))))) (if (null? sc5) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-8) eta-1)) (let ((e-11 (unbox sc5))) (lambda (clam-1) (let ((sc6 (TTImpC-45ElabC-45Check-n--12604-3222-u--removeArg arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9))) (if (null? sc6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-8) clam-1) (let ((e-12 (unbox sc6))) (let ((sc7 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-10 (vector 1 (vector 0 ))))) (if (null? sc7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-8) clam-1) (let ((e-13 (unbox sc7))) (vector 1 (cons e-2 (vector 0 arg-0 e-5 e-11 e-12 e-13))))))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((e-10 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-12 (vector-ref e-3 4))) (let ((e-13 (vector-ref e-3 5))) (let ((e-14 (vector-ref e-3 6))) (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-12 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Normalise-normaliseHoles arg-5 (cons arg-1 arg-0) arg-6 arg-2 e-14 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((sc6 (CoreC-45TTC-45Term-shrinkPi e-11 (vector 1 (vector 0 ))))) (if (null? sc6) (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) eta-2)) (let ((e-8 (unbox sc6))) (let ((sc7 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-5 (vector 1 (vector 0 ))))) (if (null? sc7) (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) eta-2)) (let ((e-15 (unbox sc7))) (lambda (clam-2) (let ((sc8 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-6 (vector 1 (vector 0 ))))) (if (null? sc8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) clam-2) (let ((e-17 (unbox sc8))) (let ((sc9 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-7 (vector 1 (vector 0 ))))) (if (null? sc9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 29 (cons arg-1 arg-0) arg-3 arg-2 e-2 e-13) clam-2) (let ((e-21 (unbox sc9))) (vector 1 (cons e-2 (vector 1 arg-0 e-10 e-8 e-15 e-17 e-21)))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))))
(define TTImpC-45ElabC-45Check-strengthenedEState (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-n--12604-3220-u--dropSub arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 (let ((e-4 (vector-ref e-5 3))) e-4) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (TTImpC-45ElabC-45Check-n--12604-3224-u--strTms arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 e-6 eta-3)) (let ((e-17 (vector-ref e-5 4))) e-17) '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (TTImpC-45ElabC-45Check-n--12604-3224-u--strTms arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 e-6 eta-4)) (let ((e-17 (vector-ref e-5 5))) e-17) '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-17 (vector-ref e-5 6))) (let ((e-16 (vector-ref e-5 7))) (let ((e-15 (vector-ref e-5 8))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 e-7 e-8 e-9 e-17 e-16 e-15 '() e-11 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-5) (TTImpC-45ElabC-45Check-n--12604-3221-u--dropTop arg-1 arg-0 arg-5 arg-4 arg-3 arg-2 eta-5)) e-12) e-13 e-14))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-n--12403-3013-u--wknTms (lambda (arg-0 arg-1 arg-2 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-3 0) ((0) (let ((e-4 (vector-ref e-3 1))) (let ((e-5 (vector-ref e-3 2))) (let ((e-6 (vector-ref e-3 3))) (let ((e-7 (vector-ref e-3 4))) (let ((e-8 (vector-ref e-3 5))) (cons e-2 (vector 0 (cons arg-0 e-4) e-5 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (eta-0) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) eta-0)))) e-6) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-7))) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-8))))))))))) (else (let ((e-9 (vector-ref e-3 1))) (let ((e-10 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-12 (vector-ref e-3 4))) (let ((e-13 (vector-ref e-3 5))) (let ((e-14 (vector-ref e-3 6))) (cons e-2 (vector 1 (cons arg-0 e-9) e-10 (CoreC-45TTC-45Binder-u--map_Functor_PiInfo (lambda (eta-0) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) eta-0)))) e-11) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-12))) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-13))) (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-14)))))))))))))))))
(define TTImpC-45ElabC-45Check-weakenedEState (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-15 (vector-ref e-5 4))) (let ((e-6 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (let ((e-14 (vector-ref e-5 13))) (vector e-1 e-2 e-3 (vector 1 e-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (TTImpC-45ElabC-45Check-n--12403-3013-u--wknTms arg-0 arg-1 arg-2 eta-1)) e-15) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (TTImpC-45ElabC-45Check-n--12403-3013-u--wknTms arg-0 arg-1 arg-2 eta-1)) e-6) e-7 e-8 e-9 '() e-11 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (let ((sc1 CoreC-45TTC-45Var-WeakenVar)) (let ((e-17 (car sc1))) (((e-17 'erased) 'erased) eta-1)))) e-12) e-13 e-14))))))))))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 e-6)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Check-inScope (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (TTImpC-45ElabC-45Check-weakenedEState arg-1 arg-2 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((arg-7 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-strengthenedEState arg-1 arg-2 arg-3 e-5 arg-5 arg-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (set-box! arg-4 e-7))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Binders-findLamRig (lambda (arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (let ((e-2 (unbox arg-2))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getNF arg-1 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((0) (let ((e-3 (vector-ref e-5 3))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (vector 1 e-7)))(else (vector 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))(else (vector 1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Binders-inferLambda (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 ext-0) (let ((act-1 (TTImpC-45ElabC-45Binders-findLamRig arg-1 arg-17 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--rigb (AlgebraC-45Preorder-glb csegen-2382 e-5 arg-12))) (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-30 arg-8 arg-9 arg-10 arg-15 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-6))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-7))) (let ((act-4 (TTImpC-45ElabC-45Binders-checkPiInfo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-12 arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2)) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--envC-39 (cons (vector 0 arg-11 u--rigb e-8 e-2) arg-10))) (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-14 arg-9)))) (lambda (eta-2) (let ((act-5 (TTImpC-45ElabC-45Check-inScope arg-14 arg-0 arg-1 arg-4 arg-11 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-14 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 arg-6 arg-7 arg-8 u--nestC-39 u--envC-39 arg-16 '())) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-10 (car e-9))) (let ((e-4 (cdr e-9))) (let ((act-6 ((CoreC-45NormaliseC-45Eval-getTerm e-4) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--lamty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 arg-14 (vector 2 arg-11 u--rigb e-8 e-2) e-11)))) (lambda (eta-3) (let ((act-7 (CoreC-45Normalise-logGlue arg-0 arg-1 "elab.binder" 5 (lambda () "Inferred lambda type") arg-10 u--lamty eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-12 (vector-ref act-7 1))) (vector 0 e-12))) (else (let ((act-8 ((PreludeC-45Types-maybe (lambda () (lambda (eta-4) (vector 1 (vector 0 )))) (lambda () (lambda (eta-4) (lambda (eta-5) (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.binder" 5 (lambda () "Expected lambda type") arg-10 eta-4 eta-5)))) arg-17) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 (vector 3 arg-11 arg-14 (vector 0 arg-11 u--rigb e-8 e-2) e-10) u--lamty arg-17 eta-3))))))))))) eff-0) clam-1)))))))))) eff-0) eta-2)))))))))) eff-0) clam-0))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Binders-checkLambda (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) (let ((u--rig (let ((sc1 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc1 1) csegen-30) (else csegen-1416))))) (lambda (eta-0) (TTImpC-45ElabC-45Binders-inferLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--rig arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 '() eta-0))) (let ((e-2 (unbox arg-17))) (let ((u--rig (let ((sc1 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc1 1) csegen-30) (else csegen-1416))))) (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-0) (let ((act-1 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Binders-getTyNF arg-0 arg-1 arg-10 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (case (vector-ref e-7 0) ((3) (let ((e-1 (vector-ref e-7 1))) (let ((e-9 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-13 (vector-ref e-3 1))) (let ((e-12 (vector-ref e-3 2))) (let ((e-11 (vector-ref e-3 3))) (let ((e-10 (vector-ref e-3 4))) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 e-13 clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-30 arg-8 arg-9 arg-10 arg-15 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-14))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--exptynf (vector 3 e-1 e-9 (vector 2 e-13 e-12 e-11 e-10) e-4))) (lambda (clam-1) (let ((e-17 (car e-15))) (let ((act-7 (TTImpC-45ElabC-45Binders-checkPiInfo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-12 arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-17)) clam-1))) (case (vector-ref act-7 0) ((0) (let ((e-18 (vector-ref act-7 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--rigb (AlgebraC-45Preorder-glb csegen-2382 arg-12 e-12))) (let ((u--envC-39 (cons (vector 0 arg-11 u--rigb e-18 e-17) arg-10))) (lambda (eta-4) (let ((act-8 (PreludeC-45IO-u--map_Functor_IO csegen-26 (TTImpC-45ElabC-45Check-convert arg-0 arg-1 arg-3 arg-4 arg-11 arg-8 arg-10 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-17) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-10)) eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-19 (vector-ref act-8 1))) (vector 0 e-19))) (else (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-14 arg-9)))) (let ((act-9 (TTImpC-45ElabC-45Check-inScope arg-14 arg-0 arg-1 arg-4 arg-11 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-14 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 arg-6 u--rig arg-8 u--nestC-39 u--envC-39 arg-16 (box (CoreC-45NormaliseC-45Eval-gnf (cons arg-14 arg-0) u--envC-39 (CoreC-45NameC-45Scoped-compat csegen-2277 e-4))))) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-20 (vector-ref act-9 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-22 (car e-20))) (let ((e-21 (cdr e-20))) (let ((act-10 (CoreC-45Normalise-logTermNF arg-0 arg-1 "elab.binder" 10 (lambda () "Lambda type") arg-10 u--exptynf clam-2))) (case (vector-ref act-10 0) ((0) (let ((e-23 (vector-ref act-10 1))) (vector 0 e-23))) (else (let ((act-11 (CoreC-45Normalise-logGlueNF (cons arg-14 arg-0) arg-1 "elab.binder" 10 (lambda () "Got scope type") u--envC-39 e-21 clam-2))) (case (vector-ref act-11 0) ((0) (let ((e-24 (vector-ref act-11 1))) (vector 0 e-24))) (else (let ((act-12 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" 7 (lambda () "checkLambda is adding \x2193;") clam-2))) (case (vector-ref act-12 0) ((0) (let ((e-25 (vector-ref act-12 1))) (vector 0 e-25))) (else (let ((act-13 (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 arg-11 arg-14 arg-10 e-10 clam-2))) (case (vector-ref act-13 0) ((0) (let ((e-26 (vector-ref act-13 1))) (vector 0 e-26))) (else (let ((act-14 (let ((act-14 ((CoreC-45NormaliseC-45Eval-getTerm e-21) clam-2))) (case (vector-ref act-14 0) ((0) (let ((e-27 (vector-ref act-14 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-14 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc19 (AlgebraC-45ZeroOneOmega-u--C-47C-61_Eq_ZeroOneOmega u--rigb e-12))) (cond ((equal? sc19 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 arg-0 arg-11 (let ((e-0 (vector-ref e-8 0))) e-0) arg-10 (vector 3 arg-11 arg-14 (vector 2 e-13 u--rigb e-18 e-17) e-27) (vector 3 arg-11 e-9 (vector 2 e-13 e-12 e-18 e-10) e-4)) clam-3)) (else (vector 1 (vector 0 )))))))) eff-0) clam-2))))))) (case (vector-ref act-14 0) ((0) (let ((e-27 (vector-ref act-14 1))) (vector 0 e-27))) (else (let ((act-15 ((CoreC-45NormaliseC-45Eval-getTerm e-21) clam-2))) (case (vector-ref act-15 0) ((0) (let ((e-28 (vector-ref act-15 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (cons (vector 3 arg-11 arg-14 (vector 0 e-13 u--rigb e-18 e-17) e-22) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 arg-14 (vector 2 e-13 u--rigb e-18 e-17) e-28))))))) eff-0) clam-2))))))))))))))))))))))))) eff-0) eta-4)))))))))))))) eff-0) clam-1)))))))))) eff-0) eta-3)))))))) eff-0) clam-0))))))))))(else (TTImpC-45ElabC-45Binders-inferLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--rig arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (box e-2) clam-0)))))))))(else (lambda (eta-3) (TTImpC-45ElabC-45Binders-inferLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--rig arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (box e-2) eta-3)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))
(define TTImpC-45ElabC-45Binders-weakenExp (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (unbox arg-3))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (CoreC-45NormaliseC-45Eval-gnf (cons arg-0 arg-1) arg-2 (let ((sc2 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc2))) (((e-1 'erased) 'erased) e-5))))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Binders-n--12888-10291-u--linearErr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-19 0) ((14) (let ((e-2 (vector-ref arg-19 3))) (box e-2))) ((68) (let ((e-6 (vector-ref arg-19 3))) (TTImpC-45ElabC-45Binders-n--12888-10291-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-6))) ((69) (let ((e-9 (vector-ref arg-19 3))) (TTImpC-45ElabC-45Binders-n--12888-10291-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-9))) ((70) (let ((e-12 (vector-ref arg-19 3))) (TTImpC-45ElabC-45Binders-n--12888-10291-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-12))) ((71) (let ((e-15 (vector-ref arg-19 3))) (TTImpC-45ElabC-45Binders-n--12888-10291-u--linearErr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-15)))(else '()))))
(define TTImpC-45ElabC-45Binders-checkLet (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (let ((u--rigc (let ((sc0 (AlgebraC-45Semiring-isErased csegen-931 arg-7))) (cond ((equal? sc0 1) csegen-30) (else csegen-1416))))) (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-30 arg-8 arg-9 arg-10 arg-15 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-5))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((act-3 (TTImpC-45ElabC-45Check-handle arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-2) (let ((act-3 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 csegen-2602 (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-rigMult arg-13 u--rigc) (let ((e-0 (vector-ref arg-8 0))) (let ((e-1 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-8 (vector-ref arg-8 3))) (let ((e-7 (vector-ref arg-8 5))) (vector e-0 e-1 e-9 e-8 1 e-7)))))) arg-9 arg-10 arg-16 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (Builtin-fst e-7) (cons (Builtin-snd e-7) (AlgebraC-45ZeroOneOmega-rigMult arg-13 u--rigc))))))) eff-0) eta-2)))))) (lambda (u--err) (let ((sc3 (TTImpC-45ElabC-45Binders-n--12888-10291-u--linearErr arg-0 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--err))) (if (null? sc3) (lambda (eta-2) (let ((act-3 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-rigMult arg-13 u--rigc) arg-8 arg-9 arg-10 arg-16 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (Builtin-fst e-7) (cons (Builtin-snd e-7) (AlgebraC-45ZeroOneOmega-rigMult arg-13 u--rigc))))))) eff-0) eta-2)))))) (let ((e-1 (unbox sc3))) (AlgebraC-45Semiring-branchOne csegen-931 (lambda () (lambda (eta-2) (let ((act-3 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 csegen-2602 (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-1416 arg-8 arg-9 arg-10 arg-16 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (Builtin-fst e-7) (cons (Builtin-snd e-7) csegen-1416)))))) eff-0) eta-2))))))) (lambda () (lambda (eta-2) (let ((act-3 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (AlgebraC-45ZeroOneOmega-rigMult arg-13 u--rigc) arg-8 arg-9 arg-10 arg-16 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (Builtin-fst e-7) (cons (Builtin-snd e-7) (AlgebraC-45ZeroOneOmega-rigMult arg-13 u--rigc))))))) eff-0) eta-2))))))) e-1))))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((e-8 (car e-7))) (let ((e-4 (cdr e-7))) (let ((e-9 (cdr e-4))) (let ((u--envC-39 (cons (vector 0 arg-11 e-9 (vector 1 ) e-2) arg-10))) (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-14 arg-9)))) (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Binders-weakenExp arg-14 arg-0 u--envC-39 arg-18 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-inScope arg-14 arg-0 arg-1 arg-4 arg-11 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-14 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 arg-6 u--rigc arg-8 u--nestC-39 u--envC-39 arg-17 e-11)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (let ((act-6 ((CoreC-45NormaliseC-45Eval-getTerm e-13) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "metadata.names" 7 (lambda () "checkLet is adding \x2193;") eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-16 (vector-ref act-7 1))) (vector 0 e-16))) (else (let ((act-8 (CoreC-45Metadata-addNameType arg-0 arg-1 arg-2 arg-12 arg-14 arg-10 e-2 eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-17 (vector-ref act-8 1))) (vector 0 e-17))) (else (vector 1 (cons (vector 3 arg-11 arg-14 (vector 1 arg-11 e-9 e-8 e-2) e-14) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (vector 3 arg-11 arg-14 (vector 1 arg-11 e-9 e-8 e-2) e-15))))))))))))) eff-0) clam-1)))))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))))) eff-0) clam-0))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define CoreC-45Context-addName (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((8) (let ((e-0 (vector-ref arg-1 1))) (vector 1 e-0)))(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-newEntry arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 ((CoreC-45Context-setCtxt arg-0 e-3) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 e-2))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45Local-n--10613-1755-u--applyEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-9 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--nestedName_in (vector 5 (cons arg-12 (let ((e-8 (vector-ref e-5 8))) e-8)) arg-13))) (let ((act-3 (CoreC-45Context-inCurrentNS arg-11 u--nestedName_in eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-addName arg-11 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons arg-13 (cons (box e-7) (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVars arg-1 arg-4)) (lambda (u--fc) (lambda (u--nt) (CoreC-45UnifyState-applyToFull arg-1 u--fc (vector 1 u--fc u--nt (vector 8 e-8)) arg-4)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Local-n--10613-1756-u--dropLinear (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-13) (if (null? arg-13) '() (let ((e-4 (car arg-13))) (let ((e-5 (cdr arg-13))) (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 (CoreC-45TTC-45Binder-multiplicity e-4)))) (cond ((equal? sc1 1) (cons (CoreC-45TTC-45Binder-setMultiplicity e-4 csegen-30) (TTImpC-45ElabC-45Local-n--10613-1756-u--dropLinear arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5))) (else (cons e-4 (TTImpC-45ElabC-45Local-n--10613-1756-u--dropLinear arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-5))))))))))
(define TTImpC-45ElabC-45Local-n--10613-1757-u--setErased (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-3 (vector-ref arg-12 3))) (let ((e-4 (vector-ref arg-12 4))) (let ((e-5 (vector-ref arg-12 5))) (vector 0 e-1 csegen-30 e-3 e-4 e-5)))))) ((3) (let ((e-7 (vector-ref arg-12 1))) (let ((e-8 (vector-ref arg-12 2))) (let ((e-9 (vector-ref arg-12 3))) (vector 3 e-7 e-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10613-1757-u--setErased arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) e-9)))))) ((6) (let ((e-11 (vector-ref arg-12 1))) (let ((e-12 (vector-ref arg-12 2))) (let ((e-13 (vector-ref arg-12 3))) (vector 6 e-11 e-12 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10613-1757-u--setErased arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) e-13))))))(else arg-12))))
(define TTImpC-45ElabC-45Local-n--10613-1758-u--setPublic (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((0) (let ((e-1 (vector-ref arg-12 1))) (let ((e-2 (vector-ref arg-12 2))) (let ((e-4 (vector-ref arg-12 4))) (let ((e-5 (vector-ref arg-12 5))) (vector 0 e-1 e-2 2 e-4 e-5)))))) ((1) (let ((e-7 (vector-ref arg-12 1))) (let ((e-9 (vector-ref arg-12 3))) (let ((e-10 (vector-ref arg-12 4))) (vector 1 e-7 (LibrariesC-45DataC-45WithDefault-specified 2) e-9 e-10))))) ((4) (let ((e-12 (vector-ref arg-12 1))) (let ((e-13 (vector-ref arg-12 2))) (let ((e-15 (vector-ref arg-12 4))) (let ((e-16 (vector-ref arg-12 5))) (vector 4 e-12 e-13 (LibrariesC-45DataC-45WithDefault-specified 2) e-15 e-16)))))) ((3) (let ((e-18 (vector-ref arg-12 1))) (let ((e-19 (vector-ref arg-12 2))) (let ((e-20 (vector-ref arg-12 3))) (vector 3 e-18 e-19 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10613-1758-u--setPublic arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) e-20)))))) ((6) (let ((e-22 (vector-ref arg-12 1))) (let ((e-23 (vector-ref arg-12 2))) (let ((e-24 (vector-ref arg-12 3))) (vector 6 e-22 e-23 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10613-1758-u--setPublic arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-0)) e-24))))))(else arg-12))))
(define TTImpC-45ElabC-45Local-n--10613-1764-u--updateTyName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-1 (vector-ref arg-13 0))) (let ((e-2 (vector-ref arg-13 1))) (let ((e-3 (vector-ref arg-13 2))) (let ((e-4 (vector-ref arg-13 3))) (vector e-1 e-2 (TTImpC-45TTImp-mapNestedName arg-12 e-3) e-4)))))))
(define TTImpC-45ElabC-45Local-n--10613-1759-u--updateDataName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (let ((e-5 (vector-ref arg-13 5))) (vector 0 e-1 (TTImpC-45TTImp-mapNestedName arg-12 e-2) e-3 e-4 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10613-1764-u--updateTyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 eta-0)) e-5)))))))) (else (let ((e-7 (vector-ref arg-13 1))) (let ((e-8 (vector-ref arg-13 2))) (let ((e-9 (vector-ref arg-13 3))) (vector 1 e-7 (TTImpC-45TTImp-mapNestedName arg-12 e-8) e-9))))))))
(define TTImpC-45ElabC-45Local-n--10613-1762-u--updateRecordNS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) '() (let ((e-2 (unbox arg-13))) (box (CoreC-45Name-u--show_Show_Name (TTImpC-45TTImp-mapNestedName arg-12 (vector 1 (CoreC-45Name-mkUserName e-2)))))))))
(define TTImpC-45ElabC-45Local-n--10613-1760-u--updateFieldName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-1 (vector-ref arg-13 0))) (let ((e-2 (vector-ref arg-13 1))) (let ((e-3 (vector-ref arg-13 2))) (let ((e-4 (vector-ref arg-13 3))) (let ((e-5 (vector-ref arg-13 4))) (vector e-1 e-2 e-3 (TTImpC-45TTImp-mapNestedName arg-12 e-4) e-5))))))))
(define TTImpC-45ElabC-45Local-n--10613-1763-u--updateRecordName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-1 (vector-ref arg-13 0))) (let ((e-2 (vector-ref arg-13 1))) (let ((e-3 (vector-ref arg-13 2))) (let ((e-4 (vector-ref arg-13 3))) (let ((e-5 (vector-ref arg-13 4))) (let ((e-6 (vector-ref arg-13 5))) (vector e-1 (TTImpC-45TTImp-mapNestedName arg-12 e-2) e-3 e-4 (TTImpC-45TTImp-mapNestedName arg-12 e-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Local-n--10613-1760-u--updateFieldName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 eta-0)) e-6))))))))))
(define TTImpC-45ElabC-45Local-n--10613-1761-u--updateName (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-1 (vector-ref arg-13 1))) (let ((e-2 (vector-ref arg-13 2))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (let ((e-5 (vector-ref arg-13 5))) (vector 0 e-1 e-2 e-3 e-4 (TTImpC-45ElabC-45Local-n--10613-1764-u--updateTyName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-5)))))))) ((2) (let ((e-7 (vector-ref arg-13 1))) (let ((e-8 (vector-ref arg-13 2))) (let ((e-9 (vector-ref arg-13 3))) (vector 2 e-7 (TTImpC-45TTImp-mapNestedName arg-12 e-8) e-9))))) ((1) (let ((e-11 (vector-ref arg-13 1))) (let ((e-12 (vector-ref arg-13 2))) (let ((e-13 (vector-ref arg-13 3))) (let ((e-14 (vector-ref arg-13 4))) (vector 1 e-11 e-12 e-13 (TTImpC-45ElabC-45Local-n--10613-1759-u--updateDataName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-14))))))) ((4) (let ((e-16 (vector-ref arg-13 1))) (let ((e-17 (vector-ref arg-13 2))) (let ((e-18 (vector-ref arg-13 3))) (let ((e-19 (vector-ref arg-13 4))) (let ((e-20 (vector-ref arg-13 5))) (vector 4 e-16 (TTImpC-45ElabC-45Local-n--10613-1762-u--updateRecordNS arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-17) e-18 e-19 (TTImpC-45ElabC-45Local-n--10613-1763-u--updateRecordName arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-20))))))))(else arg-13))))
(define TTImpC-45ElabC-45Local-localHelper (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--f (let ((e-2 (vector-ref e-5 1))) e-2))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--vis (PreludeC-45Types-maybe (lambda () 2) (lambda () (lambda (eta-2) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref eta-2 9))) e-9)))) e-7))) (let ((u--mult (PreludeC-45Types-maybe (lambda () csegen-1416) (lambda () (lambda (eta-2) (let ((e-23 (vector-ref eta-2 7))) e-23))) e-7))) (let ((u--nestdeclsVis (let ((sc3 (CoreC-45TT-u--C-61C-61_Eq_Visibility u--vis 2))) (cond ((equal? sc3 1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (TTImpC-45ElabC-45Local-n--10613-1758-u--setPublic arg-1 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 eta-2)) arg-10)) (else arg-10))))) (let ((u--nestdeclsMult (let ((sc3 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega u--mult csegen-30))) (cond ((equal? sc3 1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (TTImpC-45ElabC-45Local-n--10613-1757-u--setErased arg-1 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 eta-2)) u--nestdeclsVis)) (else u--nestdeclsVis))))) (let ((u--defNames (TTImpC-45TTImp-definedInBlock CoreC-45NameC-45Namespace-emptyNS u--nestdeclsMult))) (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (TTImpC-45ElabC-45Local-n--10613-1755-u--applyEnv arg-1 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 u--f eta-3 eta-4))) u--defNames '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--nestC-39 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-8))) (let ((u--envC-39 (TTImpC-45ElabC-45Local-n--10613-1756-u--dropLinear arg-1 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-9))) (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-4))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--olddelayed (let ((e-10 (vector-ref e-9 10))) e-10))) (lambda (eta-4) (let ((act-6 (let ((act-6 (set-box! arg-4 (let ((e-0 (vector-ref e-9 0))) (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-16 (vector-ref e-9 5))) (let ((e-15 (vector-ref e-9 6))) (let ((e-14 (vector-ref e-9 7))) (let ((e-13 (vector-ref e-9 8))) (let ((e-12 (vector-ref e-9 9))) (let ((e-11 (vector-ref e-9 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 e-14 e-13 e-12 '() e-11))))))))))))))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 (unbox arg-2))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--oldhints (let ((e-34 (vector-ref e-11 10))) e-34))) (let ((u--nestdecls (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (TTImpC-45ElabC-45Local-n--10613-1761-u--updateName arg-1 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 u--nestC-39 eta-5)) u--nestdeclsMult))) (lambda (eta-5) (let ((act-8 (CoreC-45ContextC-45Log-log arg-2 "elab.def.local" 20 (lambda () (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2566 u--nestdecls)) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 ((CoreC-45Core-traverse_ (lambda (eta-6) (TTImpC-45ElabC-45Check-processDecl arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 '() u--nestC-39 u--envC-39 eta-6)) u--nestdecls) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 ((let ((eff-0 (lambda (world-0) (let ((act-10 (unbox arg-4))) (vector 1 act-10))))) (lambda (world-0) (let ((act-10 (eff-0 world-0))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-1 (lambda (world-1) (let ((act-11 (set-box! arg-4 (let ((e-0 (vector-ref e-14 0))) (let ((e-1 (vector-ref e-14 1))) (let ((e-2 (vector-ref e-14 2))) (let ((e-3 (vector-ref e-14 3))) (let ((e-4 (vector-ref e-14 4))) (let ((e-21 (vector-ref e-14 5))) (let ((e-20 (vector-ref e-14 6))) (let ((e-19 (vector-ref e-14 7))) (let ((e-18 (vector-ref e-14 8))) (let ((e-17 (vector-ref e-14 9))) (let ((e-15 (vector-ref e-14 11))) (vector e-0 e-1 e-2 e-3 e-4 e-21 e-20 e-19 e-18 e-17 u--olddelayed e-15))))))))))))))) (vector 1 act-11))))) eff-1) world-0))))))) eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 ((arg-11 u--nestC-39) eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-12 ((let ((eff-0 (lambda (world-0) (let ((act-12 (unbox arg-2))) (vector 1 act-12))))) (lambda (world-0) (let ((act-12 (eff-0 world-0))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-1 (lambda (world-1) (let ((act-13 (set-box! arg-2 (let ((e-0 (vector-ref e-16 0))) (let ((e-1 (vector-ref e-16 1))) (let ((e-2 (vector-ref e-16 2))) (let ((e-3 (vector-ref e-16 3))) (let ((e-4 (vector-ref e-16 4))) (let ((e-44 (vector-ref e-16 5))) (let ((e-43 (vector-ref e-16 6))) (let ((e-42 (vector-ref e-16 7))) (let ((e-41 (vector-ref e-16 8))) (let ((e-40 (vector-ref e-16 9))) (let ((e-38 (vector-ref e-16 11))) (let ((e-37 (vector-ref e-16 12))) (let ((e-36 (vector-ref e-16 13))) (let ((e-35 (vector-ref e-16 14))) (let ((e-34 (vector-ref e-16 15))) (let ((e-33 (vector-ref e-16 16))) (let ((e-17 (vector-ref e-16 17))) (let ((e-18 (vector-ref e-16 18))) (let ((e-19 (vector-ref e-16 19))) (let ((e-20 (vector-ref e-16 20))) (let ((e-21 (vector-ref e-16 21))) (let ((e-22 (vector-ref e-16 22))) (let ((e-23 (vector-ref e-16 23))) (let ((e-24 (vector-ref e-16 24))) (let ((e-25 (vector-ref e-16 25))) (let ((e-26 (vector-ref e-16 26))) (let ((e-27 (vector-ref e-16 27))) (let ((e-28 (vector-ref e-16 28))) (let ((e-29 (vector-ref e-16 29))) (let ((e-30 (vector-ref e-16 30))) (let ((e-31 (vector-ref e-16 31))) (let ((e-32 (vector-ref e-16 32))) (vector e-0 e-1 e-2 e-3 e-4 e-44 e-43 e-42 e-41 e-40 u--oldhints e-38 e-37 e-36 e-35 e-34 e-33 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-13))))) eff-1) world-0))))))) eta-6))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (vector 1 e-15))))))) eff-0) eta-5))))))))))))))))))) eff-0) eta-4)))))))))))) eff-0) eta-3)))))))))) eff-0) eta-2))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Local-checkLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (TTImpC-45ElabC-45Local-localHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-9 arg-10 arg-12 (lambda (u--nestC-39) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 u--nestC-39 arg-10 arg-13 arg-14)) ext-0)))
(define TTImpC-45ElabC-45Binders-n--10913-8610-u--getRig (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (case (vector-ref arg-18 0) ((1) arg-11)(else csegen-30))))
(define TTImpC-45ElabC-45Binders-checkPi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((u--pirig (TTImpC-45ElabC-45Binders-n--10913-8610-u--getRig arg-0 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref arg-8 0))) e-0)))) (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--pirig arg-8 arg-9 arg-10 arg-15 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-5))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((act-3 (TTImpC-45ElabC-45Binders-checkPiInfo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-12 arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-2)) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--envC-39 (cons (vector 2 arg-11 arg-12 e-7 e-2) arg-10))) (let ((u--nestC-39 (TTImpC-45TTImp-u--weaken_Weaken_NestedNames (TTImpC-45ElabC-45Binders-dropName arg-14 arg-9)))) (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-inScope arg-14 arg-0 arg-1 arg-4 arg-11 u--envC-39 (lambda (u--eC-39) (TTImpC-45ElabC-45Check-check (cons arg-14 arg-0) arg-1 arg-2 arg-3 u--eC-39 arg-5 arg-6 u--pirig arg-8 u--nestC-39 u--envC-39 arg-16 (box (CoreC-45NormaliseC-45Eval-gType arg-11 e-8)))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-10 (car e-9))) (let ((act-6 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-11 clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-11 (vector-ref act-6 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 (vector 3 arg-11 arg-14 (vector 2 (TTImpC-45TTImp-getFC arg-15) arg-12 e-7 e-2) e-10) (CoreC-45NormaliseC-45Eval-gType arg-11 e-11) arg-17 eta-4)))) eff-0) clam-1))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))) eff-0) clam-0))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define TTImpC-45ElabC-45Prim-checkPrim (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 0 e-0)) (vector 9 arg-1 (vector 13 0))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 1 e-1)) (vector 9 arg-1 (vector 13 1))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 2 e-2)) (vector 9 arg-1 (vector 13 2))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 3 e-3)) (vector 9 arg-1 (vector 13 3))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 4 e-4)) (vector 9 arg-1 (vector 13 4))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 5 e-5)) (vector 9 arg-1 (vector 13 5))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 6 e-6)) (vector 9 arg-1 (vector 13 6))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 7 e-7)) (vector 9 arg-1 (vector 13 7))))) ((8) (let ((e-8 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 8 e-8)) (vector 9 arg-1 (vector 13 8))))) ((9) (let ((e-9 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 9 e-9)) (vector 9 arg-1 (vector 13 9))))) ((10) (let ((e-10 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 10 e-10)) (vector 9 arg-1 (vector 13 10))))) ((11) (let ((e-11 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 11 e-11)) (vector 9 arg-1 (vector 13 11))))) ((12) (let ((e-12 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 12 e-12)) (vector 9 arg-1 (vector 13 12))))) ((13) (let ((e-13 (vector-ref arg-2 1))) (cons (vector 9 arg-1 (vector 13 e-13)) (vector 11 arg-1 (vector 2 "top" 0))))) (else (cons (vector 9 arg-1 (vector 14 )) (vector 9 arg-1 (vector 13 13)))))))
(define TTImpC-45ElabC-45Quote-bindUnqs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-7) (lambda (eta-0) (vector 1 arg-12)) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExactI (CoreC-45Reflect-reflectionttimp "TTImp") (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 e-10 (CoreC-45Reflect-reflectionttimp "TTImp")) clam-1) (let ((e-1 (unbox e-8))) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 e-10 (CoreC-45Reflect-reflectionttimp "TTImp")) clam-1) (let ((e-4 (car e-1))) (let ((act-3 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 e-11 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-11 (vector 1 e-10 (vector 3 0 0) (vector 8 e-4))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (let ((act-4 ((TTImpC-45ElabC-45Quote-bindUnqs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3 arg-8 arg-9 arg-10 arg-11 arg-12) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45NormaliseC-45Eval-getTerm e-13) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-10 e-6 (vector 1 e-10 (AlgebraC-45ZeroOneOmega-rigMult AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-8) e-14 e-16) (CoreC-45TT-refToLocal e-6 e-6 e-15)))))) eff-0) eta-1)))))))) eff-0) clam-2)))))))))) eff-0) clam-1)))))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteClause (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (let ((e-8 (vector-ref arg-3 4))) (let ((e-9 (vector-ref arg-3 5))) (let ((e-10 (vector-ref arg-3 6))) (let ((e-11 (vector-ref arg-3 7))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (TTImpC-45ElabC-45Quote-getUnquoteClause arg-0 arg-1 arg-2 eta-2 eta-3))) e-11 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 e-5 e-12 e-7 e-13 e-9 e-10 e-14))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))) (else (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-13 e-5))))) eff-0) ext-0)))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteTy (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-5))))) eff-0) ext-0)))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteData (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (if (null? e-3) (vector 1 '()) (let ((e-6 (unbox e-3))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-6 eta-0)))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ElabC-45Quote-getUnquoteTy arg-0 arg-1 arg-2 eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-4 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) (else (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-8 e-5))))) eff-0) ext-0))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteField (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-4 e-6))))) eff-0) ext-0))))))))))))
(define TTImpC-45ElabC-45Quote-n--10882-9019-u--unqPair (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-8 arg-7 arg-6 e-11 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 (cons e-6 (cons e-10 e-5))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteRecord (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((e-6 (vector-ref arg-3 5))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45Quote-n--10882-9019-u--unqPair e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-1 arg-0 eta-0)) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ElabC-45Quote-getUnquoteField arg-0 arg-1 arg-2 eta-1 eta-2))) e-6 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector e-1 e-2 e-7 e-4 e-5 e-8))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))
(define TTImpC-45ElabC-45Quote-n--10926-9180-u--unqTuple (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-5 arg-4 arg-3 e-11 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 (cons e-6 (cons e-10 e-5))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ElabC-45Quote-getUnquoteDecl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquoteTy arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-3 e-4 e-6))))) eff-0) ext-0))))))))))) ((1) (let ((e-7 (vector-ref arg-3 1))) (let ((e-8 (vector-ref arg-3 2))) (let ((e-9 (vector-ref arg-3 3))) (let ((e-10 (vector-ref arg-3 4))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquoteData arg-0 arg-1 arg-2 e-10 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-8 e-9 e-5))))) eff-0) ext-0)))))))))) ((2) (let ((e-12 (vector-ref arg-3 1))) (let ((e-13 (vector-ref arg-3 2))) (let ((e-14 (vector-ref arg-3 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteClause arg-0 arg-1 arg-2 eta-0 eta-1))) e-14 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-12 e-13 e-5))))) eff-0) ext-0))))))))) ((3) (let ((e-16 (vector-ref arg-3 1))) (let ((e-17 (vector-ref arg-3 2))) (let ((e-18 (vector-ref arg-3 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (TTImpC-45ElabC-45Quote-n--10926-9180-u--unqTuple e-18 e-17 e-16 arg-2 arg-1 arg-0 eta-0)) e-17 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-0 arg-1 arg-2 eta-1 eta-2))) e-18 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-16 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((4) (let ((e-20 (vector-ref arg-3 1))) (let ((e-21 (vector-ref arg-3 2))) (let ((e-22 (vector-ref arg-3 3))) (let ((e-23 (vector-ref arg-3 4))) (let ((e-24 (vector-ref arg-3 5))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquoteRecord arg-0 arg-1 arg-2 e-24 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 4 e-20 e-21 e-22 e-23 e-5))))) eff-0) ext-0))))))))))) ((6) (let ((e-26 (vector-ref arg-3 1))) (let ((e-27 (vector-ref arg-3 2))) (let ((e-28 (vector-ref arg-3 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-0 arg-1 arg-2 eta-0 eta-1))) e-28 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-26 e-27 e-5))))) eff-0) ext-0))))))))) ((7) (let ((e-30 (vector-ref arg-3 1))) (let ((e-31 (vector-ref arg-3 2))) (let ((e-32 (vector-ref arg-3 3))) (let ((e-33 (vector-ref arg-3 4))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-32 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-33 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-30 e-31 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))(else (vector 1 arg-3)))))
(define TTImpC-45ElabC-45Quote-getUnquoteUpdate (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-5))))) eff-0) ext-0)))))))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-4 e-6))))) eff-0) ext-0)))))))))))
(define TTImpC-45ElabC-45Quote-getUnquote (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (case (vector-ref arg-3 0) ((1) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-5 (vector-ref arg-3 5))) (let ((e-6 (vector-ref arg-3 6))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-1 e-2 e-3 e-4 e-7 e-8))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))) ((2) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (let ((e-10 (vector-ref arg-3 3))) (let ((e-11 (vector-ref arg-3 4))) (let ((e-12 (vector-ref arg-3 5))) (let ((e-13 (vector-ref arg-3 6))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-12 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-8 e-9 e-10 e-11 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))) ((3) (let ((e-15 (vector-ref arg-3 1))) (let ((e-16 (vector-ref arg-3 2))) (let ((e-17 (vector-ref arg-3 3))) (let ((e-18 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-21 (vector-ref arg-3 7))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-19 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-20 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-21 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 3 e-15 e-16 e-17 e-18 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))) ((4) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (let ((e-26 (vector-ref arg-3 4))) (let ((e-27 (vector-ref arg-3 5))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-25 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-26 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (TTImpC-45ElabC-45Quote-getUnquoteClause arg-0 arg-1 arg-2 eta-2 eta-3))) e-27 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 4 e-23 e-24 e-5 e-6 e-7))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) ((5) (let ((e-29 (vector-ref arg-3 1))) (let ((e-30 (vector-ref arg-3 2))) (let ((e-31 (vector-ref arg-3 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-0 arg-1 arg-2 eta-0 eta-1))) e-30 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-31 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 5 e-29 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((7) (let ((e-33 (vector-ref arg-3 1))) (let ((e-34 (vector-ref arg-3 2))) (let ((e-35 (vector-ref arg-3 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquoteUpdate arg-0 arg-1 arg-2 eta-0 eta-1))) e-34 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-35 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-33 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((8) (let ((e-37 (vector-ref arg-3 1))) (let ((e-38 (vector-ref arg-3 2))) (let ((e-39 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-38 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-39 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-37 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((9) (let ((e-41 (vector-ref arg-3 1))) (let ((e-42 (vector-ref arg-3 2))) (let ((e-43 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-42 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-43 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 9 e-41 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((10) (let ((e-45 (vector-ref arg-3 1))) (let ((e-46 (vector-ref arg-3 2))) (let ((e-47 (vector-ref arg-3 3))) (let ((e-48 (vector-ref arg-3 4))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-46 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-48 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 10 e-45 e-5 e-47 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((11) (let ((e-50 (vector-ref arg-3 1))) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-51 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-52 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 11 e-50 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((13) (let ((e-54 (vector-ref arg-3 1))) (let ((e-55 (vector-ref arg-3 2))) (let ((e-56 (vector-ref arg-3 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 eta-0 eta-1))) e-56 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 13 e-54 e-55 e-5))))) eff-0) ext-0))))))))) ((14) (let ((e-58 (vector-ref arg-3 1))) (let ((e-59 (vector-ref arg-3 2))) (let ((e-60 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-59 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-60 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 14 e-58 e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((15) (let ((e-62 (vector-ref arg-3 1))) (let ((e-63 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-63 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 15 e-62 e-5))))) eff-0) ext-0)))))))) ((16) (let ((e-65 (vector-ref arg-3 1))) (let ((e-66 (vector-ref arg-3 2))) (let ((e-67 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-67 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 16 e-65 e-66 e-5))))) eff-0) ext-0))))))))) ((18) (let ((e-69 (vector-ref arg-3 1))) (let ((e-70 (vector-ref arg-3 2))) (let ((e-71 (vector-ref arg-3 3))) (let ((e-72 (vector-ref arg-3 4))) (let ((e-73 (vector-ref arg-3 5))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-73 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 18 e-69 e-70 e-71 e-72 e-5))))) eff-0) ext-0))))))))))) ((19) (let ((e-75 (vector-ref arg-3 1))) (let ((e-76 (vector-ref arg-3 2))) (let ((e-77 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-77 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 19 e-75 e-76 e-5))))) eff-0) ext-0))))))))) ((20) (let ((e-79 (vector-ref arg-3 1))) (let ((e-80 (vector-ref arg-3 2))) (let ((e-81 (vector-ref arg-3 3))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-81 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 20 e-79 e-80 e-5))))) eff-0) ext-0))))))))) ((21) (let ((e-83 (vector-ref arg-3 1))) (let ((e-84 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-84 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 21 e-83 e-5))))) eff-0) ext-0)))))))) ((22) (let ((e-86 (vector-ref arg-3 1))) (let ((e-87 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-87 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 22 e-86 e-5))))) eff-0) ext-0)))))))) ((23) (let ((e-89 (vector-ref arg-3 1))) (let ((e-90 (vector-ref arg-3 2))) (let ((act-1 (TTImpC-45ElabC-45Quote-getUnquote arg-0 arg-1 arg-2 e-90 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 23 e-89 e-5))))) eff-0) ext-0)))))))) ((26) (let ((e-92 (vector-ref arg-3 1))) (let ((e-93 (vector-ref arg-3 2))) (let ((act-1 (CoreC-45UnifyState-genVarName arg-0 arg-2 "q" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-1))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-1 (cons (cons e-5 (cons e-92 e-93)) e-6)))) (vector 1 act-3))))) eff-1) world-0))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 26 e-92 (vector 0 e-92 e-5))))))))) eff-0) ext-0))))))))(else (vector 1 arg-3)))))
(define TTImpC-45ElabC-45Quote-onLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 1)(else 0))))
(define TTImpC-45ElabC-45Quote-checkQuote (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "TTImp.Elab.Quote.Unq" ) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Quote-getUnquote arg-1 e-6 arg-3 arg-12 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45Reflect-u--reflect_Reflect_RawImp arg-0 arg-11 e-5 (TTImpC-45ElabC-45Quote-onLHS (let ((e-0 (vector-ref arg-8 0))) e-0)) arg-10 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox e-6))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Reflect-getCon arg-0 arg-11 e-5 (CoreC-45Reflect-reflectionttimp "TTImp") eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((TTImpC-45ElabC-45Quote-bindUnqs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-9 arg-7 arg-8 arg-9 arg-10 e-8) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (CoreC-45Normalise-normalise arg-1 arg-0 e-5 arg-10 e-11 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 e-12 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-10) arg-13 eta-7)))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Quote-checkQuoteDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "TTImp.Elab.Quote.Unq" ) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (TTImpC-45ElabC-45Quote-getUnquoteDecl arg-1 e-6 arg-3 eta-2 eta-3))) arg-12 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Reflect-u--reflect_Reflect_C-40ListC-32C-36aC-41 (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (TTImpC-45Reflect-u--reflect_Reflect_ImpDecl eta-3 eta-4 eta-5 eta-6 eta-7 eta-8 eta-9)))))))) arg-0 arg-11 e-5 (TTImpC-45ElabC-45Quote-onLHS (let ((e-0 (vector-ref arg-8 0))) e-0)) arg-10 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox e-6))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Reflect-getCon arg-0 arg-11 e-5 (CoreC-45Reflect-reflectionttimp "Decl") eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45Reflect-appCon arg-0 arg-11 e-5 (CoreC-45Reflect-basics "List") (cons e-10 '()) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 ((TTImpC-45ElabC-45Quote-bindUnqs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-9 arg-7 arg-8 arg-9 arg-10 e-8) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 arg-11 e-12 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-11) arg-13 eta-7)))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Quote-checkQuoteName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Reflect-u--reflect_Reflect_Name arg-0 arg-9 e-5 (TTImpC-45ElabC-45Quote-onLHS (let ((e-0 (vector-ref arg-6 0))) e-0)) arg-8 arg-10) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Reflect-getCon arg-0 arg-9 e-5 (CoreC-45Reflect-reflectiontt "Name") eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 e-6 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-8 e-7) arg-11 eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-getRewrite (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-1) (box (let ((e-1 (cdr eta-1))) e-1)))) (let ((e-4 (vector-ref e-5 4))) (let ((e-38 (vector-ref e-4 5))) e-38))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Rewrite-findRewriteLemma (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-getRewrite arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-2 "No rewrite lemma defined") clam-0) (let ((e-2 (unbox e-5))) (vector 1 e-2)))))) eff-0) ext-0)))))))
(define CoreC-45Context-isEqualTy (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-4 (vector-ref e-5 4))) (lambda (clam-0) (let ((e-38 (vector-ref e-4 5))) (if (null? e-38) (vector 1 0) (let ((e-44 (unbox e-38))) (let ((act-2 (CoreC-45Context-getFullName arg-0 arg-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-45 (vector-ref act-2 1))) (vector 0 e-45))) (else (let ((e-45 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getFullName arg-0 (let ((e-47 (car e-44))) e-47) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-46 (vector-ref act-3 1))) (vector 0 e-46))) (else (let ((e-46 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Name-u--C-61C-61_Eq_Name e-45 e-46))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Rewrite-getRewriteTerms (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-5 (vector-ref arg-4 5))) (let ((act-1 (CoreC-45Context-isEqualTy arg-1 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-6 1) (let ((sc3 (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) e-5)))) (if (null? sc3) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 eta-0)) (let ((e-8 (car sc3))) (let ((e-7 (cdr sc3))) (if (null? e-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 eta-0)) (let ((e-10 (car e-7))) (let ((e-9 (cdr e-7))) (lambda (clam-0) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 clam-0) (let ((e-11 (cdr e-9))) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 clam-0) (let ((e-14 (car e-11))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-3 e-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-15 (vector-ref act-2 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-3 e-8) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-3 e-14) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-17 (vector-ref act-4 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-15 (cons e-16 e-17)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))))))) (else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 eta-0)))))) eff-0) ext-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error arg-5 ext-0)))))
(define CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (vector 1 arg-6)))
(define CoreC-45NormaliseC-45Quote-u--quote_Quote_Term (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (csegen-1375 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteGen_Quote_Term arg-0 arg-1 e-5 (vector 1 0 '()) arg-2 arg-3 arg-4 eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Rewrite-elabRewrite (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-1 arg-2 "rwarg" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-4 arg-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Rewrite-getRewriteTerms arg-0 arg-1 arg-3 e-5 e-7 (vector 42 arg-0 arg-3 arg-4 arg-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-8))) (let ((e-3 (cdr e-8))) (let ((e-9 (cdr e-3))) (let ((act-5 (TTImpC-45ElabC-45Rewrite-findRewriteLemma arg-1 arg-3 arg-6 clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-4 arg-5) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.rewrite" 5 (lambda () "Rewriting") arg-4 e-2 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45Normalise-logNF arg-0 arg-1 "elab.rewrite" 5 (lambda () "Rewriting in") arg-4 e-12 eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (CoreC-45Normalise-replace arg-1 arg-0 e-5 arg-4 e-2 (vector 1 arg-3 (vector 0 ) e-6) e-12 eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-10 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "elab.rewrite" 5 (lambda () "Rewritten to") e-15 eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 (CoreC-45Context-clearDefs e-5 eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-12 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-17 arg-4 e-9 eta-6))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-18 (vector-ref act-12 1))) ((let ((eff-0 (let ((u--pred (vector 3 arg-3 e-6 (vector 0 arg-3 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) e-18) (CoreC-45TT-refsToLocals (vector 1 e-6 e-6 (vector 0 )) e-15)))) (lambda (eta-7) (let ((act-13 ((CoreC-45GetType-getType arg-0 arg-1 arg-4 u--pred) eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((e-19 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-14 ((CoreC-45NormaliseC-45Eval-getTerm e-19) eta-8))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-15 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Term arg-1 arg-0 e-5 arg-4 arg-5 eta-9))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-16 (let ((act-16 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-1 arg-0 e-5 arg-4 e-15 e-21 eta-10))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-16 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-22 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 41 arg-0 arg-3 arg-4 arg-6 e-21) clam-1)) (else (vector 1 (vector 0 ))))))) eff-0) eta-10))))))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (vector 1 (vector e-11 u--pred e-20)))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))) eff-0) eta-6)))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))))))))) eff-0) eta-3)))))))) eff-0) clam-0))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Rewrite-rewriteErr (lambda (arg-0) (case (vector-ref arg-0 0) ((42) 1) ((41) 1) ((68) (let ((e-11 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-11))) ((69) (let ((e-14 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-14))) ((70) (let ((e-17 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-17))) ((71) (let ((e-20 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-20))) ((5) (let ((e-27 (vector-ref arg-0 7))) (TTImpC-45ElabC-45Rewrite-rewriteErr e-27)))(else 0))))
(define TTImpC-45ElabC-45Rewrite-checkRewrite (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (if (null? arg-14) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-11 "Can't infer a type for rewrite") ext-0) (let ((e-2 (unbox arg-14))) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 (box e-2) (lambda (eta-0) (TTImpC-45ElabC-45Rewrite-rewriteErr eta-0)) 3 (lambda (u--delayed) (let ((u--vfc (CoreC-45FC-virtualiseFC arg-11))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getNextEntry arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 csegen-30 arg-8 arg-9 arg-10 arg-12 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-4 (car e-6))) (let ((e-3 (cdr e-6))) (let ((act-3 (CoreC-45Unify-solveConstraintsAfter arg-1 arg-3 e-5 CoreC-45Unify-inTerm 0 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-3) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45NormaliseC-45Eval-getTerm e-2) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (cond ((equal? u--delayed 1) (CoreC-45ContextC-45Log-log arg-1 "elab.rewrite" 5 (lambda () "Retrying rewrite") eta-3)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((act-7 (TTImpC-45ElabC-45Rewrite-elabRewrite arg-0 arg-1 arg-3 u--vfc arg-10 e-9 e-8 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (CoreC-45UnifyState-genVarName arg-1 arg-3 "_" eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (CoreC-45UnifyState-genVarName arg-1 arg-3 "_" eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-13 (vector-ref act-9 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (let ((u--pbind (vector 1 u--vfc csegen-30 (let ((e-15 (vector-ref e-11 1))) e-15) (let ((e-14 (vector-ref e-11 2))) e-14)))) (let ((u--rbind (vector 1 u--vfc csegen-30 (let ((sc11 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc11))) (((e-1 'erased) 'erased) e-4))) (let ((sc11 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-1 (car sc11))) (((e-1 'erased) 'erased) e-8)))))) (let ((u--envC-39 (cons u--rbind (cons u--pbind arg-10)))) (lambda (eta-6) (let ((act-10 (TTImpC-45ElabC-45Check-inScope e-13 arg-0 arg-1 arg-4 u--vfc (cons u--pbind arg-10) (lambda (u--eC-39) (lambda (eta-7) (TTImpC-45ElabC-45Check-inScope e-12 (cons e-13 arg-0) arg-1 u--eC-39 u--vfc u--envC-39 (lambda (u--eC-39C-39) (let ((u--offset (LibrariesC-45DataC-45ListC-45SizeOf-mkSizeOf (cons e-12 (cons e-13 '()))))) (TTImpC-45ElabC-45Check-check (cons e-12 (cons e-13 arg-0)) arg-1 arg-2 arg-3 u--eC-39C-39 arg-5 arg-6 arg-7 arg-8 (TTImpC-45TTImp-u--weakenNs_Weaken_NestedNames u--offset arg-9) u--envC-39 (TTImpC-45TTImp-apply (vector 0 u--vfc (let ((e-1 (vector-ref e-11 0))) e-1)) (cons (vector 0 u--vfc e-13) (cons (vector 0 u--vfc e-12) (cons arg-13 '())))) (box (CoreC-45NormaliseC-45Eval-gnf (cons e-12 (cons e-13 arg-0)) u--envC-39 (let ((sc11 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-14 (cdr sc11))) ((((e-14 'erased) 'erased) u--offset) e-9)))))))) eta-7))) eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-14 (vector-ref act-10 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-16 (car e-14))) (let ((e-15 (cdr e-14))) (let ((act-11 ((CoreC-45NormaliseC-45Eval-getTerm e-15) clam-2))) (case (vector-ref act-11 0) ((0) (let ((e-17 (vector-ref act-11 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-11 1))) ((let ((eff-0 (let ((u--binding (lambda (eta-7) (vector 3 u--vfc e-13 u--pbind (vector 3 u--vfc e-12 u--rbind eta-7))))) (lambda (eta-7) (vector 1 (cons (u--binding e-16) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 (u--binding e-17)))))))) eff-0) clam-2)))))))))) eff-0) eta-6))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))))) eff-0) eta-2)))))))) eff-0) clam-1))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ext-0)))))
(define TTImpC-45ElabC-45RunElab-n--16587-5068-u--mkExpected (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-15) (let ((act-1 (CoreC-45UnifyState-genName arg-14 arg-12 "scriptTy" ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-14 arg-12 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45Check-metaVar arg-0 arg-14 arg-12 arg-4 csegen-30 arg-5 e-5 (vector 11 arg-4 e-6) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-15))) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm e-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 e-5)))) eff-0) ext-0)))))))))
(define TTImpC-45ElabC-45RunElab-checkRunElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-1 (TTImpC-45ElabC-45RunElab-n--16587-5068-u--mkExpected arg-0 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((sc2 (cond ((equal? arg-12 1) (CoreC-45Context-isExtension 0 e-6)) (else 1)))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-11 "%language ElabReflection not enabled") eta-1)))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((u--n csegen-2401)) (let ((act-4 (CoreC-45Reflect-appCon arg-0 arg-11 e-6 u--n (cons e-5 '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45ElabC-45Delayed-runDelays arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (eta-3) 1) (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-8))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-9))) (let ((act-6 (CoreC-45Unify-solveConstraints arg-1 arg-3 CoreC-45Unify-inTerm 0 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (let ((act-7 (unbox arg-1))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-8 (let ((act-8 ((CoreC-45NormaliseC-45Eval-nfOpts arg-1 arg-0 CoreC-45Value-withAll e-11 arg-10 e-2) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-4) (TTImpC-45ElabC-45RunElab-elabScript arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7 arg-11 arg-9 arg-10 e-12 (box (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-5)) eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-9 (let ((act-9 (unbox arg-1))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-10 (CoreC-45Context-clearDefs e-13 eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-11 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-1 arg-0 e-14 arg-10 e-12 eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (cons e-15 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-5)))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) clam-0)))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Record-needType (lambda (arg-0) (case (vector-ref arg-0 0) ((22) 1) ((68) (let ((e-5 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-5))) ((69) (let ((e-8 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-8))) ((70) (let ((e-11 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-11))) ((71) (let ((e-14 (vector-ref arg-0 3))) (TTImpC-45ElabC-45Record-needType e-14))) ((5) (let ((e-21 (vector-ref arg-0 7))) (TTImpC-45ElabC-45Record-needType e-21)))(else 0))))
(define TTImpC-45ElabC-45Record-checkForDuplicates (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) arg-2 (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((u--path (TTImpC-45TTImp-getFieldUpdatePath e-2))) (let ((u--dups (let ((sc1 (LibrariesC-45DataC-45SortedSet-contains u--path arg-1))) (cond ((equal? sc1 1) (LibrariesC-45DataC-45SortedSet-insert u--path arg-2)) (else arg-2))))) (TTImpC-45ElabC-45Record-checkForDuplicates e-3 (LibrariesC-45DataC-45SortedSet-insert u--path arg-1) u--dups))))))))
(define TTImpC-45ElabC-45Record-genFieldName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 (bs+ e-8 1 63) e-9 e-10 e-11)))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (string-append arg-1 (PreludeC-45Show-u--show_Show_Int (let ((e-8 (vector-ref e-5 8))) e-8)))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Record-findConName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-lookupDefExact arg-1 (let ((e-0 (vector-ref arg-0 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((6) (let ((e-8 (vector-ref e-1 7))) (lambda (clam-0) (if (null? e-8) (vector 1 '()) (let ((e-11 (car e-8))) (let ((e-12 (cdr e-8))) (if (null? e-12) (vector 1 (box e-11)) (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 '())))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Record-n--10729-7202-u--nheadNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (case (vector-ref e-1 0) ((0) (LibrariesC-45DataC-45SortedSet-singleton csegen-861 e-2))(else csegen-862)))))(else csegen-862))))
(define TTImpC-45ElabC-45Record-getNames (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-1))) e-3 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45ElabC-45Record-getNames arg-0 arg-1 eta-2)) e-5 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (LibrariesC-45DataC-45SortedSet-union (TTImpC-45ElabC-45Record-n--10729-7202-u--nheadNames e-1 e-3 e-2 arg-1 arg-0 e-2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-3) eta-3) e-6)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((2) (let ((e-9 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-1))) e-9 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45ElabC-45Record-getNames arg-0 arg-1 eta-2)) e-10 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-3) eta-3) e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((3) (let ((e-15 (vector-ref arg-2 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45NormaliseC-45Eval-evalClosure arg-0 '() arg-1 (Builtin-snd eta-1))) e-15 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45ElabC-45Record-getNames arg-0 arg-1 eta-2)) e-5 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-2558 (lambda (eta-3) eta-3) e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((5) (let ((e-19 (vector-ref arg-2 3))) (TTImpC-45ElabC-45Record-getNames arg-0 arg-1 e-19)))(else (lambda (eta-0) (vector 1 csegen-862))))))
(define TTImpC-45ElabC-45Record-getRecordType (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-2 (vector-ref arg-2 2))) (box e-2)))(else '()))))
(define TTImpC-45ElabC-45Record-n--11225-7690-u--getExpNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--imp (case (vector-ref e-8 0) ((1) '())(else (box e-2))))) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-2 '() arg-1 e-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Record-getNames arg-2 arg-1 e-5) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--names (LibrariesC-45DataC-45SortedSet-union e-10 arg-3))) (let ((u--expNames (cons (cons (CoreC-45Name-nameRoot e-2) (cons u--imp (TTImpC-45ElabC-45Record-getRecordType '() e-5))) arg-4))) (lambda (eta-2) (let ((act-3 (((e-4 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 1 e-1 (vector 0 ) e-2))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ElabC-45Record-n--11225-7690-u--getExpNames arg-0 arg-1 arg-2 u--names u--expNames e-11))) eff-0) eta-2)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Record-getNames arg-2 arg-1 arg-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (PreludeC-45TypesC-45List-reverse arg-4) (LibrariesC-45DataC-45SortedSet-union e-5 arg-3)))))) eff-0) eta-0)))))))))))))(else (lambda (eta-0) (let ((act-1 ((TTImpC-45ElabC-45Record-getNames arg-2 arg-1 arg-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (PreludeC-45TypesC-45List-reverse arg-4) (LibrariesC-45DataC-45SortedSet-union e-5 arg-3)))))) eff-0) eta-0))))))))))
(define TTImpC-45ElabC-45Record-findFieldsAndTypeArgs (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-lookupTyExact arg-2 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() arg-1 '() e-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((TTImpC-45ElabC-45Record-n--11225-7690-u--getExpNames arg-2 arg-1 arg-0 csegen-862 '() e-6) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Record-replace (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-0 e-6))) (cond ((equal? sc2 1) (cons (cons arg-0 arg-1) e-3)) (else (cons (cons e-6 e-7) (TTImpC-45ElabC-45Record-replace arg-0 arg-1 e-3))))))))))))
(define TTImpC-45ElabC-45Record-n--11613-8108-u--mkArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-11) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((act-1 (TTImpC-45ElabC-45Record-genFieldName arg-9 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45Record-n--11613-8108-u--mkArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-3 arg-12) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--arg (let ((sc5 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (PreludeC-45Basics-flip csegen-2543 arg-12 eta-1)) e-10))) (if (null? sc5) (vector 0 (CoreC-45FC-virtualiseFC arg-8) (vector 1 (vector 0 e-5))) (let ((e-1 (unbox sc5))) (cond ((equal? e-1 1) (vector 32 arg-8 0))(else (vector 0 (CoreC-45FC-virtualiseFC arg-8) (vector 1 (vector 0 e-5)))))))))) (lambda (eta-1) (vector 1 (cons (cons e-6 (vector 0 e-10 e-5 u--arg)) e-8)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define TTImpC-45ElabC-45Record-findPath (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-3) (lambda (clam-0) (case (vector-ref arg-7 0) ((0) (let ((e-4 (vector-ref arg-7 1))) (let ((e-5 (vector-ref arg-7 2))) (vector 1 (vector 0 e-4 e-5 (arg-6 e-5))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 26 arg-2 arg-4) clam-0)))) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? arg-5) (case (vector-ref arg-7 0) ((0) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-2 '()) eta-0)))(else (lambda (clam-0) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (let ((sc3 (DataC-45List-lookup csegen-22 e-2 e-9))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-2 arg-5) clam-0) (let ((e-1 (unbox sc3))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Record-findFieldsAndTypeArgs arg-0 e-5 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 1 e-7 e-8 e-9))) (let ((e-4 (unbox e-6))) (let ((e-11 (car e-4))) (lambda (clam-1) (let ((sc8 (DataC-45List-lookup csegen-22 e-2 e-11))) (if (null? sc8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-2 arg-5) clam-1) (let ((e-12 (unbox sc8))) (let ((e-13 (cdr e-12))) (let ((act-3 ((TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-3 arg-4 e-13 arg-6 e-1) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-7 e-8 (TTImpC-45ElabC-45Record-replace e-2 e-15 e-9)))))) eff-0) clam-1))))))))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))) (let ((e-12 (unbox arg-5))) (case (vector-ref arg-7 0) ((0) (let ((e-16 (vector-ref arg-7 1))) (let ((e-17 (vector-ref arg-7 2))) (let ((e-18 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45ElabC-45Record-findConName e-5 e-12 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 25 arg-2 e-12) clam-3) (let ((e-1 (unbox e-6))) (let ((act-3 (TTImpC-45ElabC-45Record-findFieldsAndTypeArgs arg-0 e-5 e-1 clam-3))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 25 arg-2 e-12) clam-2) (let ((e-4 (unbox e-7))) (let ((e-9 (car e-4))) (let ((e-8 (cdr e-4))) (let ((act-4 ((TTImpC-45ElabC-45Record-n--11613-8108-u--mkArgs e-2 e-3 e-12 e-18 e-17 e-16 arg-6 arg-4 arg-2 arg-1 arg-0 e-9 e-8) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--recC-39 (vector 1 e-16 e-1 e-10))) (TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 (cons e-2 e-3) arg-4 (box e-12) arg-6 u--recC-39)))) eff-0) clam-2)))))))))))) eff-0) clam-3)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))(else (lambda (clam-3) (let ((e-7 (vector-ref arg-7 1))) (let ((e-8 (vector-ref arg-7 2))) (let ((e-9 (vector-ref arg-7 3))) (let ((sc3 (DataC-45List-lookup csegen-22 e-2 e-9))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-2 arg-5) clam-3) (let ((e-1 (unbox sc3))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Record-findFieldsAndTypeArgs arg-0 e-5 e-8 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 (vector 1 e-7 e-8 e-9))) (let ((e-4 (unbox e-6))) (let ((e-11 (car e-4))) (lambda (clam-4) (let ((sc8 (DataC-45List-lookup csegen-22 e-2 e-11))) (if (null? sc8) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 24 arg-2 e-2 arg-5) clam-4) (let ((e-13 (unbox sc8))) (let ((e-14 (cdr e-13))) (let ((act-3 ((TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-3 arg-4 e-14 arg-6 e-1) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-16 (vector-ref act-3 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-7 e-8 (TTImpC-45ElabC-45Record-replace e-2 e-16 e-9)))))) eff-0) clam-4))))))))))))))) eff-0) eta-0)))))))) eff-0) clam-3)))))))))))))))))))))
(define TTImpC-45ElabC-45Record-getSides (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-1 e-1 (box arg-4) (lambda (eta-0) e-2) arg-6)))) (else (let ((e-4 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 2))) (TTImpC-45ElabC-45Record-findPath arg-0 arg-1 arg-2 e-4 e-4 (box arg-4) (lambda (u--n) (TTImpC-45TTImp-apply e-5 (cons (vector 0 (CoreC-45FC-virtualiseFC arg-2) (vector 1 (vector 0 u--n))) '()))) arg-6)))))))
(define TTImpC-45ElabC-45Record-getAllSides (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-3) (vector 1 arg-6) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 ((TTImpC-45ElabC-45Record-getSides arg-0 arg-1 arg-2 e-2 arg-4 arg-5 arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ElabC-45Record-getAllSides arg-0 arg-1 arg-2 e-3 arg-4 arg-5 e-5 eta-0)))) eff-0) ext-0))))))))))
(define TTImpC-45ElabC-45Record-toLHSC-39 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (if (null? e-0) (cons e-0 (vector 17 (CoreC-45FC-virtualiseFC arg-0) e-1)) (cons e-0 (vector 18 arg-0 (CoreC-45FC-virtualiseFC arg-0) 1 (vector 1 (vector 0 e-1)) (vector 32 arg-0 1))))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Record-toLHSC-39 arg-0 (Builtin-snd eta-0))) e-5))) (cons e-3 (TTImpC-45TTImp-gapply (vector 0 arg-0 e-4) u--argsC-39))))))))))
(define TTImpC-45ElabC-45Record-toLHS (lambda (arg-0 arg-1) (Builtin-snd (TTImpC-45ElabC-45Record-toLHSC-39 arg-0 arg-1))))
(define TTImpC-45ElabC-45Record-toRHSC-39 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 3))) (cons e-0 e-2)))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (let ((e-5 (vector-ref arg-1 3))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (TTImpC-45ElabC-45Record-toRHSC-39 arg-0 (Builtin-snd eta-0))) e-5))) (cons e-3 (TTImpC-45TTImp-gapply (vector 0 arg-0 e-4) u--argsC-39))))))))))
(define TTImpC-45ElabC-45Record-toRHS (lambda (arg-0 arg-1) (Builtin-snd (TTImpC-45ElabC-45Record-toRHSC-39 arg-0 arg-1))))
(define TTImpC-45ElabC-45Record-n--12511-8897-u--vloc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (CoreC-45FC-virtualiseFC arg-6)))
(define TTImpC-45ElabC-45Record-n--12511-8896-u--mkClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 0 (TTImpC-45ElabC-45Record-n--12511-8897-u--vloc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (TTImpC-45ElabC-45Record-toLHS (TTImpC-45ElabC-45Record-n--12511-8897-u--vloc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) arg-12) (TTImpC-45ElabC-45Record-toRHS (TTImpC-45ElabC-45Record-n--12511-8897-u--vloc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) arg-12))))
(define TTImpC-45ElabC-45Record-recUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((u--dups (TTImpC-45ElabC-45Record-checkForDuplicates arg-9 csegen-2555 csegen-2555))) (lambda (eta-0) (let ((act-1 (let ((sc0 (LibrariesC-45DataC-45SortedSet-u--null_Foldable_SortedSet u--dups))) (cond ((equal? sc0 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 23 arg-6 (LibrariesC-45DataC-45SortedSet-toList u--dups)) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getNF arg-1 arg-11) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (TTImpC-45ElabC-45Record-getRecordType arg-8 e-7))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 22 arg-0 arg-6 arg-8) clam-0) (let ((e-1 (unbox sc3))) (let ((act-4 (TTImpC-45ElabC-45Record-genFieldName arg-2 "__fld" clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (TTImpC-45ElabC-45Record-getAllSides arg-1 arg-2 arg-6 arg-9 e-1 arg-10 (vector 0 '() e-8 (vector 0 (TTImpC-45ElabC-45Record-n--12511-8897-u--vloc arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (vector 1 (vector 0 e-8)))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 4 (TTImpC-45ElabC-45Record-n--12511-8897-u--vloc arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) '() arg-10 (vector 32 (TTImpC-45ElabC-45Record-n--12511-8897-u--vloc arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) 0) (cons (TTImpC-45ElabC-45Record-n--12511-8896-u--mkClause arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-9) '())))))) eff-0) eta-2)))))))) eff-0) clam-0))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define TTImpC-45ElabC-45Record-checkUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (let ((act-1 (if (null? arg-14) (let ((act-1 (TTImpC-45ElabC-45Check-checkImp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 '() ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-3 (cdr e-5))) (vector 1 e-3))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-14))) (vector 1 e-1))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--solvemode (let ((e-0 (vector-ref arg-8 0))) (case (vector-ref e-0 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm))))) (lambda (eta-0) (TTImpC-45ElabC-45Delayed-delayOnFailure arg-0 arg-1 arg-2 arg-3 arg-4 arg-11 arg-7 arg-10 (box e-5) (lambda (eta-1) (TTImpC-45ElabC-45Record-needType eta-1)) 2 (lambda (u--delayed) (lambda (eta-1) (let ((act-2 (CoreC-45Unify-solveConstraints arg-1 arg-3 u--solvemode 0 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--rectyC-39 (cond ((equal? u--delayed 1) (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-7)) (else e-5)))) (lambda (eta-2) (let ((act-4 (CoreC-45Normalise-logGlueNF arg-0 arg-1 "elab.record" 5 (lambda () (string-append (PreludeC-45Show-u--show_Show_Bool u--delayed) (string-append " record type " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-13)))) arg-10 u--rectyC-39 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45ElabC-45Record-recUpdate arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-11 arg-9 arg-10 arg-12 arg-13 u--rectyC-39) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CoreC-45ContextC-45Log-log arg-1 "elab.record" 5 (lambda () (string-append "Record update: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-9))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-9 arg-14) eta-3))))))) eff-0) eta-2)))))))))))) eff-0) eta-1)))))))))) eta-0))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45UserNameMap-insertFrom (lambda (ext-0 ext-1) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (clam-0) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-1) (lambda (eta-2) (PreludeC-45Basics-flip (lambda (eta-3) (PreludeC-45Basics-uncurry (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (LibrariesC-45DataC-45UserNameMap-insert eta-4 eta-5 eta-6)))) eta-3)) eta-1 eta-2))) eta-0 clam-0))) ext-0 ext-1)))
(define LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 (lambda (arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (arg-3 (cons e-1 e-2))))) ((1) (let ((e-5 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 3))) (LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 arg-3 e-7))) e-5)))) (else (let ((e-10 (vector-ref arg-4 1))) (let ((e-12 (vector-ref arg-4 3))) (let ((e-14 (vector-ref arg-4 5))) (LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 (lambda (arg-0) (cons arg-0 (LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 (lambda (arg-1) (cons arg-1 (LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 arg-3 e-14))) e-12))) e-10))))))))
(define LibrariesC-45DataC-45UserNameMap-treeToList (lambda (ext-0) (LibrariesC-45DataC-45UserNameMap-n--5600-11596-u--treeToListC-39 (lambda (arg-0) (cons arg-0 '())) ext-0)))
(define LibrariesC-45DataC-45UserNameMap-toList (lambda (arg-1) (if (null? arg-1) '() (let ((e-3 (cdr arg-1))) (LibrariesC-45DataC-45UserNameMap-treeToList e-3)))))
(define LibrariesC-45DataC-45UserNameMap-n--6213-12212-u--inserted (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-listBind (LibrariesC-45DataC-45UserNameMap-toList arg-1) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((u--vC-39 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () arg-3) (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-2)) e-3))) (PreludeC-45Types-u--pure_Applicative_List (cons e-2 u--vC-39)))))))))
(define LibrariesC-45DataC-45UserNameMap-mergeWith (lambda (arg-1 arg-2 arg-3) (LibrariesC-45DataC-45UserNameMap-insertFrom (LibrariesC-45DataC-45UserNameMap-n--6213-12212-u--inserted arg-3 arg-2 arg-1) arg-2)))
(define LibrariesC-45DataC-45UserNameMap-mergeLeft (lambda (arg-1 arg-2) (LibrariesC-45DataC-45UserNameMap-mergeWith (lambda (eta-0) (lambda (eta-1) eta-0)) arg-1 arg-2)))
(define CoreC-45Context-withLogLevel (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--logs (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 2))) (let ((e-59 (vector-ref e-41 9))) e-59))))) (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-35 0))) (let ((e-44 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-47 (vector-ref e-35 4))) (let ((e-48 (vector-ref e-35 5))) (let ((e-49 (vector-ref e-35 6))) (let ((e-50 (vector-ref e-35 7))) (let ((e-51 (vector-ref e-35 8))) (let ((e-53 (vector-ref e-35 10))) (let ((e-54 (vector-ref e-35 11))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 (vector e-68 e-44 e-45 e-46 e-47 e-48 e-49 e-50 e-51 (CoreC-45OptionsC-45Log-insertLogLevel arg-2 u--logs) e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (arg-3 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (set-box! arg-1 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-36 (vector-ref e-8 5))) (let ((e-35 (vector-ref e-8 6))) (let ((e-34 (vector-ref e-8 7))) (let ((e-33 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-31 (vector-ref e-8 31))) (let ((e-32 (vector-ref e-8 32))) (let ((e-46 (vector-ref e-4 0))) (let ((e-45 (vector-ref e-4 1))) (let ((e-44 (vector-ref e-4 2))) (let ((e-43 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-71 (vector-ref e-44 0))) (let ((e-70 (vector-ref e-44 1))) (let ((e-69 (vector-ref e-44 2))) (let ((e-68 (vector-ref e-44 3))) (let ((e-47 (vector-ref e-44 4))) (let ((e-48 (vector-ref e-44 5))) (let ((e-49 (vector-ref e-44 6))) (let ((e-50 (vector-ref e-44 7))) (let ((e-51 (vector-ref e-44 8))) (let ((e-53 (vector-ref e-44 10))) (let ((e-54 (vector-ref e-44 11))) (let ((e-55 (vector-ref e-44 12))) (let ((e-56 (vector-ref e-44 13))) (let ((e-57 (vector-ref e-44 14))) (let ((e-58 (vector-ref e-44 15))) (let ((e-59 (vector-ref e-44 16))) (let ((e-60 (vector-ref e-44 17))) (let ((e-61 (vector-ref e-44 18))) (let ((e-62 (vector-ref e-44 19))) (let ((e-63 (vector-ref e-44 20))) (let ((e-64 (vector-ref e-44 21))) (let ((e-65 (vector-ref e-44 22))) (let ((e-66 (vector-ref e-44 23))) (let ((e-67 (vector-ref e-44 24))) (vector e-0 e-1 e-2 e-3 (vector e-46 e-45 (vector e-71 e-70 e-69 e-68 e-47 e-48 e-49 e-50 e-51 u--logs e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-43 e-37 e-38 e-39 e-40 e-41 e-42) e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Term-n--13002-10158-u--resolveNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (if (null? arg-16) (lambda (eta-0) (vector 1 LibrariesC-45DataC-45UserNameMap-empty)) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (lambda (clam-0) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Name-userNameRoot e-7))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "non-UN in \"with\" LHS: " (CoreC-45Name-u--show_Show_Name e-7))) clam-0) (let ((e-4 (unbox sc2))) (let ((act-1 (let ((act-1 (unbox arg-14))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-7 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-14 arg-15 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-8) eta-1)) (let ((e-1 (car e-8))) (let ((e-9 (cdr e-8))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-14 arg-15 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-8) eta-1)) (let ((e-10 (cdr e-1))) (lambda (clam-1) (if (null? e-10) (CoreC-45Context-ambiguousName arg-14 arg-15 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-8) clam-1) (let ((e-12 (cdr e-10))) (if (null? e-9) (let ((act-3 (let ((sc9 (CoreC-45FC-isConcreteFC e-6))) (if (null? sc9) (vector 1 (vector 0 )) (let ((e-14 (unbox sc9))) (let ((u--nt (DataC-45Maybe-fromMaybe (lambda () (vector 1 )) (CoreC-45ContextC-45Context-defNameType (let ((e-18 (vector-ref e-12 18))) e-18))))) (let ((u--decor (CoreC-45Metadata-nameDecoration (let ((e-36 (vector-ref e-12 1))) e-36) u--nt))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-14 "ide-mode.highlight" 7 (lambda () (string-append "`with' unambiguous name is adding " (string-append (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration u--decor) (string-append ": " (CoreC-45Name-u--show_Show_Name (let ((e-36 (vector-ref e-12 1))) e-36)))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-15 (vector-ref act-3 1))) (vector 0 e-15))) (else (CoreC-45Metadata-addSemanticDecorations arg-13 arg-14 (cons (cons e-14 (cons u--decor (box (let ((e-37 (vector-ref e-12 1))) e-37)))) '()) clam-1))))))))))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-15 (vector-ref eta-1 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref eta-1 1))) (vector 1 (LibrariesC-45DataC-45UserNameMap-insert e-4 e-1 e-15)))))) (TTImpC-45ElabC-45Term-n--13002-10158-u--resolveNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-3) clam-1)))) (CoreC-45Context-ambiguousName arg-14 arg-15 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-8) clam-1)))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))
(define TTImpC-45ElabC-45Term-checkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-1 (vector 0 e-1 e-2) '() '() '() arg-12)))) ((1) (let ((e-4 (vector-ref arg-11 1))) (let ((e-5 (vector-ref arg-11 2))) (let ((e-6 (vector-ref arg-11 3))) (let ((e-7 (vector-ref arg-11 4))) (let ((e-8 (vector-ref arg-11 5))) (let ((e-9 (vector-ref arg-11 6))) (if (null? e-7) (lambda (eta-0) (let ((act-1 (case (vector-ref e-6 0) ((1) (CoreC-45UnifyState-genVarName arg-1 arg-3 "arg" eta-0)) ((0) (CoreC-45UnifyState-genVarName arg-1 arg-3 "impArg" eta-0)) ((2) (CoreC-45UnifyState-genVarName arg-1 arg-3 "conArg" eta-0)) (else (CoreC-45UnifyState-genVarName arg-1 arg-3 "defArg" eta-0))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Binders-checkPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-4 e-5 e-6 e-10 e-8 e-9 arg-12))) eff-0) eta-0)))))) (let ((e-140 (unbox e-7))) (case (vector-ref e-140 0) ((1) (let ((e-141 (vector-ref e-140 1))) (case (vector-ref e-141 0) ((2) (TTImpC-45ElabC-45Term-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 1 e-4 e-5 e-6 '() e-8 e-9) arg-12))(else (TTImpC-45ElabC-45Binders-checkPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-4 e-5 e-6 e-140 e-8 e-9 arg-12)))))(else (TTImpC-45ElabC-45Binders-checkPi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-4 e-5 e-6 e-140 e-8 e-9 arg-12)))))))))))) ((2) (let ((e-11 (vector-ref arg-11 1))) (let ((e-12 (vector-ref arg-11 2))) (let ((e-13 (vector-ref arg-11 3))) (let ((e-14 (vector-ref arg-11 4))) (let ((e-15 (vector-ref arg-11 5))) (let ((e-16 (vector-ref arg-11 6))) (if (null? e-14) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-1 arg-3 "_" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Binders-checkLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 e-12 e-13 e-5 e-15 e-16 arg-12))) eff-0) eta-0)))))) (let ((e-143 (unbox e-14))) (TTImpC-45ElabC-45Binders-checkLambda arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-11 e-12 e-13 e-143 e-15 e-16 arg-12)))))))))) ((3) (let ((e-18 (vector-ref arg-11 1))) (let ((e-19 (vector-ref arg-11 2))) (let ((e-20 (vector-ref arg-11 3))) (let ((e-21 (vector-ref arg-11 4))) (let ((e-22 (vector-ref arg-11 5))) (let ((e-23 (vector-ref arg-11 6))) (let ((e-24 (vector-ref arg-11 7))) (TTImpC-45ElabC-45Binders-checkLet arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-18 e-19 e-20 e-21 e-22 e-23 e-24 arg-12))))))))) ((4) (let ((e-26 (vector-ref arg-11 1))) (let ((e-27 (vector-ref arg-11 2))) (let ((e-28 (vector-ref arg-11 3))) (let ((e-29 (vector-ref arg-11 4))) (let ((e-30 (vector-ref arg-11 5))) (lambda (eta-0) (TTImpC-45ElabC-45Case-checkCase arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-26 e-27 e-28 e-29 e-30 arg-12 eta-0)))))))) ((5) (let ((e-32 (vector-ref arg-11 1))) (let ((e-33 (vector-ref arg-11 2))) (let ((e-34 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45Local-checkLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-32 e-33 e-34 arg-12 eta-0)))))) ((6) (let ((e-36 (vector-ref arg-11 1))) (let ((e-37 (vector-ref arg-11 2))) (let ((e-38 (vector-ref arg-11 3))) (let ((e-39 (vector-ref arg-11 4))) (let ((e-40 (vector-ref arg-11 5))) (lambda (eta-0) (TTImpC-45ElabC-45Local-checkCaseLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-36 e-37 e-38 e-39 e-40 arg-12 eta-0)))))))) ((7) (let ((e-42 (vector-ref arg-11 1))) (let ((e-43 (vector-ref arg-11 2))) (let ((e-44 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45Record-checkUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-42 e-43 e-44 arg-12 eta-0)))))) ((8) (let ((e-46 (vector-ref arg-11 1))) (let ((e-47 (vector-ref arg-11 2))) (let ((e-48 (vector-ref arg-11 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-46 e-47 (cons e-48 '()) '() '() arg-12))))) ((9) (let ((e-50 (vector-ref arg-11 1))) (let ((e-51 (vector-ref arg-11 2))) (let ((e-52 (vector-ref arg-11 3))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-50 e-51 '() (cons e-52 '()) '() arg-12))))) ((11) (let ((e-54 (vector-ref arg-11 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-54 "with application not implemented yet") eta-0)))) ((10) (let ((e-58 (vector-ref arg-11 1))) (let ((e-59 (vector-ref arg-11 2))) (let ((e-60 (vector-ref arg-11 3))) (let ((e-61 (vector-ref arg-11 4))) (TTImpC-45ElabC-45App-checkApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-58 e-59 '() '() (cons (cons e-60 e-61) '()) arg-12)))))) ((12) (let ((e-63 (vector-ref arg-11 1))) (let ((e-64 (vector-ref arg-11 2))) (lambda (clam-0) (if (null? arg-12) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genName arg-1 arg-3 "searchTy" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 e-63 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-63 csegen-30 arg-10 e-6 (vector 11 e-63 e-7) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45UnifyState-genName arg-1 arg-3 "search" eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (TTImpC-45ElabC-45Check-searchVar arg-0 arg-1 arg-3 e-63 arg-7 e-64 (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) arg-10 arg-9 e-9 e-8 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (cons e-10 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-8)))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((e-146 (unbox arg-12))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genName arg-1 arg-3 "search" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-146) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (TTImpC-45ElabC-45Check-searchVar arg-0 arg-1 arg-3 e-63 arg-7 e-64 (vector 8 (let ((e-2 (vector-ref e-5 1))) e-2)) arg-10 arg-9 e-6 e-7 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-8 e-146))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))) ((13) (let ((e-66 (vector-ref arg-11 1))) (let ((e-67 (vector-ref arg-11 2))) (let ((e-68 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-checkAlternative arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-66 e-67 e-68 arg-12 eta-0)))))) ((14) (let ((e-70 (vector-ref arg-11 1))) (let ((e-71 (vector-ref arg-11 2))) (let ((e-72 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45Rewrite-checkRewrite arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-70 e-71 e-72 arg-12 eta-0)))))) ((15) (let ((e-75 (vector-ref arg-11 2))) (TTImpC-45ElabC-45Term-checkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-75 arg-12))) ((16) (let ((e-77 (vector-ref arg-11 1))) (let ((e-78 (vector-ref arg-11 2))) (let ((e-79 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45ImplicitBind-checkBindHere arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-77 e-78 e-79 arg-12 eta-0)))))) ((17) (let ((e-81 (vector-ref arg-11 1))) (let ((e-82 (vector-ref arg-11 2))) (TTImpC-45ElabC-45ImplicitBind-checkBindVar arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-81 (vector 0 e-82) arg-12)))) ((18) (let ((e-84 (vector-ref arg-11 1))) (let ((e-85 (vector-ref arg-11 2))) (let ((e-86 (vector-ref arg-11 3))) (let ((e-87 (vector-ref arg-11 4))) (let ((e-88 (vector-ref arg-11 5))) (TTImpC-45ElabC-45As-checkAs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-84 e-85 e-86 e-87 e-88 arg-12))))))) ((19) (let ((e-90 (vector-ref arg-11 1))) (let ((e-91 (vector-ref arg-11 2))) (let ((e-92 (vector-ref arg-11 3))) (TTImpC-45ElabC-45Dot-checkDot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-90 e-91 e-92 arg-12))))) ((20) (let ((e-94 (vector-ref arg-11 1))) (let ((e-95 (vector-ref arg-11 2))) (let ((e-96 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-checkDelayed arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-94 e-95 e-96 arg-12 eta-0)))))) ((21) (let ((e-98 (vector-ref arg-11 1))) (let ((e-99 (vector-ref arg-11 2))) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-checkDelay arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-98 e-99 arg-12 eta-0))))) ((22) (let ((e-101 (vector-ref arg-11 1))) (let ((e-102 (vector-ref arg-11 2))) (lambda (eta-0) (TTImpC-45ElabC-45Lazy-checkForce arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-101 e-102 arg-12 eta-0))))) ((23) (let ((e-104 (vector-ref arg-11 1))) (let ((e-105 (vector-ref arg-11 2))) (lambda (eta-0) (TTImpC-45ElabC-45Quote-checkQuote arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-104 e-105 arg-12 eta-0))))) ((24) (let ((e-107 (vector-ref arg-11 1))) (let ((e-108 (vector-ref arg-11 2))) (lambda (eta-0) (TTImpC-45ElabC-45Quote-checkQuoteName arg-0 arg-1 arg-2 arg-3 arg-4 arg-7 arg-8 arg-9 arg-10 e-107 e-108 arg-12 eta-0))))) ((25) (let ((e-110 (vector-ref arg-11 1))) (let ((e-111 (vector-ref arg-11 2))) (lambda (eta-0) (TTImpC-45ElabC-45Quote-checkQuoteDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-110 e-111 arg-12 eta-0))))) ((26) (let ((e-113 (vector-ref arg-11 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-113 "Can't escape outside a quoted term") eta-0)))) ((27) (let ((e-116 (vector-ref arg-11 1))) (let ((e-117 (vector-ref arg-11 2))) (let ((e-118 (vector-ref arg-11 3))) (lambda (eta-0) (TTImpC-45ElabC-45RunElab-checkRunElab arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-116 e-117 e-118 arg-12 eta-0)))))) ((28) (let ((e-120 (vector-ref arg-11 1))) (let ((e-121 (vector-ref arg-11 2))) (lambda (clam-1) (let ((sc1 (TTImpC-45ElabC-45Prim-checkPrim e-120 e-121))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 e-120 e-2 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-3) arg-12 clam-1)))))))) ((29) (let ((e-123 (vector-ref arg-11 1))) (lambda (eta-0) (let ((act-1 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 e-123 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45ElabC-45Check-checkExp arg-0 arg-1 arg-3 arg-4 arg-7 arg-8 arg-10 e-123 (vector 11 e-123 e-5) (CoreC-45NormaliseC-45Eval-gType e-123 e-5) arg-12 eta-1)))) eff-0) eta-0)))))))) ((30) (let ((e-125 (vector-ref arg-11 1))) (let ((e-126 (vector-ref arg-11 2))) (lambda (eta-0) (TTImpC-45ElabC-45Hole-checkHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-7 arg-8 arg-9 arg-10 e-125 (vector 0 e-126) arg-12 eta-0))))) ((31) (let ((e-129 (vector-ref arg-11 2))) (let ((e-130 (vector-ref arg-11 3))) (lambda (eta-0) (CoreC-45Context-withLogLevel arg-1 e-129 (TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-130 arg-12) eta-0))))) ((32) (let ((e-132 (vector-ref arg-11 1))) (let ((e-133 (vector-ref arg-11 2))) (lambda (clam-2) (if (null? arg-12) (let ((act-1 (CoreC-45UnifyState-genName arg-1 arg-3 "implicit_type" clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 e-132 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-132 csegen-30 arg-10 e-5 (vector 11 e-132 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45UnifyState-genName arg-1 arg-3 "_" eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-132 arg-7 arg-10 e-8 e-7 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((sc7 (cond ((equal? e-133 1) (let ((e-3 (vector-ref arg-8 3))) e-3)) (else 0)))) (cond ((equal? sc7 1) ((let ((eff-0 (lambda (world-0) (let ((act-6 (unbox arg-4))) (vector 1 act-6))))) (lambda (world-0) (let ((act-6 (eff-0 world-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-1 (lambda (world-1) (let ((act-7 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-8 arg-7 (vector 1 ) arg-10 e-9 e-7 e-10)))) (vector 1 act-7))))) eff-1) world-0))))))) eta-4)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 (cons e-9 (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-10 e-7))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))) (let ((e-149 (unbox arg-12))) (let ((act-1 (CoreC-45UnifyState-genName arg-1 arg-3 "_" clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getTerm e-149) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 e-132 arg-7 arg-10 e-5 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((sc5 (cond ((equal? e-133 1) (let ((e-3 (vector-ref arg-8 3))) e-3)) (else 0)))) (cond ((equal? sc5 1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-getTerm e-149) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-5 (unbox arg-4))) (vector 1 act-5))))) (lambda (world-0) (let ((act-5 (eff-0 world-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-1 (lambda (world-1) (let ((act-6 (set-box! arg-4 (TTImpC-45ElabC-45Check-addBindIfUnsolved arg-0 e-5 arg-7 (vector 1 ) arg-10 e-7 e-8 e-9)))) (vector 1 act-6))))) eff-1) world-0))))))))) eff-0) eta-2)))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (cons e-7 e-149)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))))) (else (let ((e-135 (vector-ref arg-11 1))) (let ((e-136 (vector-ref arg-11 2))) (let ((e-137 (vector-ref arg-11 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--13002-10158-u--resolveNames arg-0 e-137 e-136 e-135 arg-12 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-135 e-136) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-4 (let ((e-1 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 3))) (let ((e-16 (vector-ref e-5 4))) (let ((e-15 (vector-ref e-5 5))) (let ((e-7 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 9))) (let ((e-11 (vector-ref e-5 10))) (let ((e-12 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 12))) (vector e-1 e-2 e-3 e-4 e-16 e-15 e-7 e-8 e-9 e-10 e-11 e-12 e-13 (LibrariesC-45DataC-45UserNameMap-mergeLeft e-6 (let ((e-17 (vector-ref e-5 13))) e-17))))))))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((TTImpC-45ElabC-45Check-check arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-137 arg-12) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-4))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 (set-box! arg-4 (let ((e-1 (vector-ref e-9 0))) (let ((e-2 (vector-ref e-9 1))) (let ((e-3 (vector-ref e-9 2))) (let ((e-4 (vector-ref e-9 3))) (let ((e-19 (vector-ref e-9 4))) (let ((e-18 (vector-ref e-9 5))) (let ((e-17 (vector-ref e-9 6))) (let ((e-16 (vector-ref e-9 7))) (let ((e-15 (vector-ref e-9 8))) (let ((e-10 (vector-ref e-9 9))) (let ((e-11 (vector-ref e-9 10))) (let ((e-12 (vector-ref e-9 11))) (let ((e-13 (vector-ref e-9 12))) (vector e-1 e-2 e-3 e-4 e-19 e-18 e-17 e-16 e-15 e-10 e-11 e-12 e-13 (let ((e-20 (vector-ref e-5 13))) e-20)))))))))))))))))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 e-8))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define TTImpC-45ElabC-45Term-onLHS (lambda (arg-0) (case (vector-ref arg-0 0) ((1) 1)(else 0))))
(define TTImpC-45ElabC-45Check-checkImp (lambda (ext-13 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-12 ext-0) (let ((act-1 ((TTImpC-45ElabC-45Term-checkTerm ext-13 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-12) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (let ((sc2 (TTImpC-45ElabC-45Term-onLHS (let ((e-0 (vector-ref ext-8 0))) e-0)))) (cond ((equal? sc2 1) (let ((sc3 (let ((e-2 (vector-ref ext-8 2))) e-2))) (cond ((equal? sc3 1) 0) (else 1)))) (else 0))))) (cond ((equal? sc1 1) (((let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (if (null? ext-12) (lambda () (lambda (eta-1) (vector 1 (vector 0 )))) (let ((e-1 (unbox ext-12))) (lambda () (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-getNF ext-1 e-1) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getNF ext-1 e-3) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45UnifyState-addPolyConstraint ext-13 ext-3 (TTImpC-45TTImp-getFC ext-11) ext-10 e-2 e-6 e-7))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1831-u--lookupUN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-12 arg-13) (if (null? arg-12) '() (let ((e-2 (unbox arg-12))) (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-13)))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1834-u--notLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) 0)(else 1))))
(define TTImpC-45ElabC-45Ambiguity-n--12565-2601-u--allSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16) (if (null? arg-16) (cons (cons '() '()) '()) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (cons (cons '() arg-16) (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (let ((e-5 (car eta-0))) (let ((e-4 (cdr eta-0))) (cons (cons e-2 e-5) e-4)))) (TTImpC-45ElabC-45Ambiguity-n--12565-2601-u--allSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3))))))))
(define TTImpC-45ElabC-45Ambiguity-n--12565-2602-u--alternativeFirstSuccess (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-16) (if (null? arg-16) (vector 13 arg-2 (vector 0 ) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-16)) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (if (null? e-3) e-2 (vector 13 arg-2 (vector 0 ) (DataC-45Vect-u--toList_Foldable_C-40VectC-32C-36nC-41 arg-16))))))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) arg-11 (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-10) (TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 8 e-6 arg-11 e-11) e-3) (let ((e-14 (unbox e-10))) (if (null? e-14) (TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 9 e-6 arg-11 e-11) e-3) (let ((e-17 (unbox e-14))) (TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 10 e-6 arg-11 e-17 e-11) e-3))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1837-u--wrapDot (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-16 0) ((5) arg-17) ((6) arg-17)(else (case (vector-ref arg-13 0) ((1) (if (null? arg-15) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-14 (vector 8 (let ((e-2 (vector-ref arg-12 1))) e-2))))) (cond ((equal? sc2 1) arg-17) (else (vector 19 arg-2 2 arg-17)))) (let ((e-3 (cdr arg-15))) (if (null? e-3) (let ((sc3 (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name arg-14 (vector 8 (let ((e-16 (vector-ref arg-12 1))) e-16))))) (cond ((equal? sc4 1) 1) (else arg-11))))) (cond ((equal? sc3 1) arg-17) (else (vector 19 arg-2 2 arg-17)))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name arg-14 (vector 8 (let ((e-16 (vector-ref arg-12 1))) e-16))))) (cond ((equal? sc3 1) arg-17) (else (vector 19 arg-2 2 arg-17))))))))(else arg-17))))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1833-u--mkTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((sc0 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1319 (vector 8 ) (let ((e-12 (vector-ref arg-14 12))) e-12)))) (cond ((equal? sc1 1) (TTImpC-45ElabC-45Ambiguity-n--12412-1834-u--notLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-8)) (else 0))))) (cond ((equal? sc0 1) (TTImpC-45ElabC-45Ambiguity-n--12565-2602-u--alternativeFirstSuccess arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-14 arg-13 arg-12 arg-11 (DataC-45Vect-reverse (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 27 arg-2 0 (vector 15 arg-2 (TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 0 arg-2 arg-13) e-2))) e-3)))) (TTImpC-45ElabC-45Ambiguity-n--12565-2601-u--allSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-14 arg-13 arg-12 arg-11 arg-4))))) (else (TTImpC-45ElabC-45Ambiguity-n--12412-1837-u--wrapDot arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-8 arg-13 (PreludeC-45TypesC-45List-mapAppend '() csegen-1842 arg-4) (let ((e-18 (vector-ref arg-14 18))) e-18) (TTImpC-45ElabC-45Ambiguity-n--12412-1830-u--buildAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (vector 0 arg-2 arg-13) arg-4)))))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1832-u--mkAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-3 (cdr arg-13))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (TTImpC-45ElabC-45Ambiguity-n--12412-1833-u--mkTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 (vector 8 e-6) e-7))))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1835-u--uniqType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (let ((e-0 (vector-ref arg-11 0))) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (if (null? e-0) (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))) (let ((e-81 (car arg-13))) (let ((e-82 (cdr arg-13))) (if (null? e-81) (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))) (let ((e-86 (cdr e-81))) (if (null? e-86) (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))) (let ((e-90 (cdr e-86))) (case (vector-ref e-90 0) ((28) (let ((e-92 (vector-ref e-90 1))) (let ((e-93 (vector-ref e-90 2))) (case (vector-ref e-93 0) ((5) (let ((e-94 (vector-ref e-93 1))) (if (null? e-82) (vector 2 (vector 28 e-92 (vector 5 e-94))) (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))))))(else (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))))))))(else (if (null? e-1) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (if (null? arg-13) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-63 (car arg-13))) (let ((e-64 (cdr arg-13))) (if (null? e-63) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-68 (cdr e-63))) (if (null? e-68) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))) (let ((e-72 (cdr e-68))) (case (vector-ref e-72 0) ((28) (let ((e-74 (vector-ref e-72 1))) (let ((e-75 (vector-ref e-72 2))) (case (vector-ref e-75 0) ((10) (let ((e-76 (vector-ref e-75 1))) (if (null? e-64) (vector 2 (vector 28 e-74 (vector 10 e-76))) (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))(else (if (null? e-2) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (if (null? arg-13) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-45 (car arg-13))) (let ((e-46 (cdr arg-13))) (if (null? e-45) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-50 (cdr e-45))) (if (null? e-50) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))) (let ((e-54 (cdr e-50))) (case (vector-ref e-54 0) ((28) (let ((e-56 (vector-ref e-54 1))) (let ((e-57 (vector-ref e-54 2))) (case (vector-ref e-57 0) ((11) (let ((e-58 (vector-ref e-57 1))) (if (null? e-46) (vector 2 (vector 28 e-56 (vector 11 e-58))) (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))(else (if (null? e-3) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (if (null? arg-13) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-27 (car arg-13))) (let ((e-28 (cdr arg-13))) (if (null? e-27) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-32 (cdr e-27))) (if (null? e-32) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))) (let ((e-36 (cdr e-32))) (case (vector-ref e-36 0) ((28) (let ((e-38 (vector-ref e-36 1))) (let ((e-39 (vector-ref e-36 2))) (case (vector-ref e-39 0) ((12) (let ((e-40 (vector-ref e-39 1))) (if (null? e-28) (vector 2 (vector 28 e-38 (vector 12 e-40))) (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))(else (if (null? e-4) (vector 1 ) (if (null? arg-13) (vector 1 ) (let ((e-10 (car arg-13))) (let ((e-11 (cdr arg-13))) (if (null? e-10) (vector 1 ) (let ((e-15 (cdr e-10))) (if (null? e-15) (vector 1 ) (let ((e-19 (cdr e-15))) (case (vector-ref e-19 0) ((23) (let ((e-21 (vector-ref e-19 1))) (let ((e-22 (vector-ref e-19 2))) (if (null? e-11) (vector 2 (vector 23 e-21 e-22)) (vector 1 )))))(else (vector 1 ))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(define TTImpC-45ElabC-45Ambiguity-case--expandAmbigNameC-44visible-1878 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 ext-0) (case (vector-ref arg-14 0) ((0) (let ((e-0 (vector-ref arg-14 1))) (let ((e-1 (vector-ref arg-14 2))) (let ((act-1 (CoreC-45Context-isVisible arg-10 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-5 1) (let ((act-2 (CoreC-45Context-getNS arg-10 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getNestedNS arg-10 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45Context-visibleInAny (cons e-6 e-7) (vector 0 e-0 e-1) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref arg-13 9))) e-9))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) (else (vector 1 0)))))) eff-0) ext-0))))))))(else (vector 1 1)))))
(define TTImpC-45ElabC-45Ambiguity-n--12412-1836-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (eta-0) (TTImpC-45ElabC-45Ambiguity-case--expandAmbigNameC-44visible-1878 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-2 e-6 e-7 (let ((e-1 (vector-ref e-7 1))) e-1) eta-0))))))))
(define TTImpC-45ElabC-45Ambiguity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandAmbigName-3121 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (if (null? arg-16) (let ((act-1 ((CoreC-45Context-lookupCtxtName arg-1 (let ((e-0 (vector-ref arg-11 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-filterM (lambda (eta-1) (TTImpC-45ElabC-45Ambiguity-n--12412-1836-u--visible arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 eta-1)) e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-3 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" 50 (lambda () (string-append "Failed to find " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-5))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 arg-5)))) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-3) (let ((act-3 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" 40 (lambda () (string-append "Only one " (CoreC-45Name-u--show_Show_Name (Builtin-fst e-2)))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (TTImpC-45ElabC-45Ambiguity-n--12412-1832-u--mkAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-12 e-2))))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" 10 (lambda () (string-append "Ambiguous: " (DataC-45String-joinBy ", " (PreludeC-45TypesC-45List-mapAppend '() csegen-2603 e-6)))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (vector 13 arg-2 (TTImpC-45ElabC-45Ambiguity-n--12412-1835-u--uniqType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-13 arg-1 arg-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (TTImpC-45ElabC-45Ambiguity-n--12412-1832-u--mkAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-12 eta-1)) e-6))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-16))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-10 "elab.ambiguous" 50 (lambda () (string-append "unambiguous: " (CoreC-45Name-u--show_Show_Name (Builtin-fst e-1)))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (TTImpC-45ElabC-45Ambiguity-n--12412-1832-u--mkAlt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-15 arg-12 e-1)))))))))
(define TTImpC-45ElabC-45Ambiguity-expandAmbigName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-3 0) ((1) (case (vector-ref arg-8 0) ((17) (let ((e-18 (vector-ref arg-8 1))) (let ((e-19 (vector-ref arg-8 2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc3 (PreludeC-45Types-elem csegen-14 csegen-832 (vector 1 (vector 0 e-19)) (let ((e-8 (vector-ref e-5 7))) e-8)))) (cond ((equal? sc3 1) (vector 1 (vector 19 e-18 0 arg-6))) (else (vector 1 arg-6))))))) eff-0) eta-0)))))))))(else (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (clam-1) (let ((sc2 (DataC-45List-lookup csegen-832 e-2 arg-4))) (if (null? sc2) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc4 (CoreC-45Env-defined arg-0 e-2 arg-5))) (if (null? sc4) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getPrimNames arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--prims (CoreC-45Options-primNamesToList e-7))) (let ((u--primApp (CoreC-45Context-isPrimName u--prims e-2))) (lambda (eta-1) (TTImpC-45ElabC-45Ambiguity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandAmbigName-3121 arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-7 u--prims u--primApp (TTImpC-45ElabC-45Ambiguity-n--12412-1831-u--lookupUN arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45Name-userNameRoot e-2) (let ((e-14 (vector-ref e-6 13))) e-14)) eta-1)))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((sc5 (let ((sc6 (DataC-45List-isNil arg-7))) (cond ((equal? sc6 1) 1) (else (TTImpC-45ElabC-45Ambiguity-n--12412-1834-u--notLHS arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3)))))) (cond ((equal? sc5 1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 20 (lambda () (string-append "Defined in env " (CoreC-45Name-u--show_Show_Name e-2))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 arg-6))))) (else (vector 1 (vector 19 e-1 1 arg-6)))))))))) eff-0) clam-1))))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 20 (lambda () (string-append "Nested " (CoreC-45Name-u--show_Show_Name e-2))) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 arg-6)))))))))) ((8) (let ((e-4 (vector-ref arg-8 1))) (let ((e-5 (vector-ref arg-8 2))) (let ((e-6 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-4 (cons '() e-6)) arg-7) e-5 arg-9))))) ((10) (let ((e-8 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-10 (vector-ref arg-8 3))) (let ((e-11 (vector-ref arg-8 4))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-8 (cons (box (box e-10)) e-11)) arg-7) e-9 arg-9)))))) ((9) (let ((e-13 (vector-ref arg-8 1))) (let ((e-14 (vector-ref arg-8 2))) (let ((e-15 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-13 (cons (box '()) e-15)) arg-7) e-14 arg-9)))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 50 (lambda () (string-append "No ambiguity " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-6))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-6))))))))))(else (case (vector-ref arg-8 0) ((0) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (lambda (clam-3) (let ((sc1 (DataC-45List-lookup csegen-832 e-2 arg-4))) (if (null? sc1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (CoreC-45Env-defined arg-0 e-2 arg-5))) (if (null? sc3) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getPrimNames arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--prims (CoreC-45Options-primNamesToList e-7))) (let ((u--primApp (CoreC-45Context-isPrimName u--prims e-2))) (lambda (eta-1) (TTImpC-45ElabC-45Ambiguity-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandAmbigName-3121 arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-7 u--prims u--primApp (TTImpC-45ElabC-45Ambiguity-n--12412-1831-u--lookupUN arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45Name-userNameRoot e-2) (let ((e-14 (vector-ref e-6 13))) e-14)) eta-1)))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (let ((sc4 (let ((sc5 (DataC-45List-isNil arg-7))) (cond ((equal? sc5 1) 1) (else (TTImpC-45ElabC-45Ambiguity-n--12412-1834-u--notLHS arg-0 e-2 e-1 arg-9 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3)))))) (cond ((equal? sc4 1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 20 (lambda () (string-append "Defined in env " (CoreC-45Name-u--show_Show_Name e-2))) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 arg-6))))) (else (vector 1 (vector 19 e-1 1 arg-6)))))))))) eff-0) clam-3))))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 20 (lambda () (string-append "Nested " (CoreC-45Name-u--show_Show_Name e-2))) clam-3))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 arg-6)))))))))) ((8) (let ((e-4 (vector-ref arg-8 1))) (let ((e-5 (vector-ref arg-8 2))) (let ((e-6 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-4 (cons '() e-6)) arg-7) e-5 arg-9))))) ((10) (let ((e-8 (vector-ref arg-8 1))) (let ((e-9 (vector-ref arg-8 2))) (let ((e-10 (vector-ref arg-8 3))) (let ((e-11 (vector-ref arg-8 4))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-8 (cons (box (box e-10)) e-11)) arg-7) e-9 arg-9)))))) ((9) (let ((e-13 (vector-ref arg-8 1))) (let ((e-14 (vector-ref arg-8 2))) (let ((e-15 (vector-ref arg-8 3))) (TTImpC-45ElabC-45Ambiguity-expandAmbigName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (cons (cons e-13 (cons (box '()) e-15)) arg-7) e-14 arg-9)))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "elab.ambiguous" 50 (lambda () (string-append "No ambiguity " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-6))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 arg-6)))))))))))
(define TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((2) (let ((e-17 (vector-ref arg-6 3))) (case (vector-ref e-17 0) ((0) (case (vector-ref arg-7 0) ((0) (let ((e-26 (vector-ref arg-7 3))) (case (vector-ref e-26 0) ((2) (let ((e-31 (vector-ref e-26 3))) (case (vector-ref e-31 0) ((0) (lambda (eta-0) (vector 1 arg-6)))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-1) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-2) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))) ((2) (case (vector-ref arg-7 0) ((0) (let ((e-37 (vector-ref arg-7 3))) (case (vector-ref e-37 0) ((2) (let ((e-42 (vector-ref e-37 3))) (case (vector-ref e-42 0) ((2) (lambda (eta-0) (vector 1 arg-6)))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-3) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-3))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-4) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-4))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-5) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-5))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6)))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-6) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-6))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))(else (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (let ((e-3 (vector-ref arg-7 3))) (let ((e-4 (vector-ref arg-7 4))) (lambda (clam-7) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 0 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7)))))) ((2) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 2 ) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7)))))) ((3) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (((e-4 e-5) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-3 (vector 1 e-1 (vector 0 ) e-10))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-10) (vector 32 e-1 0) e-12))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-7))))))(else (vector 1 arg-6))))))(else (vector 1 arg-6)))))))))(else (lambda (eta-0) (vector 1 arg-6))))))))
(define TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-7 0) ((2) (let ((e-17 (vector-ref arg-7 3))) (case (vector-ref e-17 0) ((0) (case (vector-ref arg-8 0) ((3) (let ((e-28 (vector-ref arg-8 3))) (case (vector-ref e-28 0) ((2) (let ((e-33 (vector-ref e-28 3))) (case (vector-ref e-33 0) ((0) (lambda (eta-0) (vector 1 (box arg-7))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-0) (let ((sc6 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc6 0) ((1) (let ((e-10 (vector-ref sc6 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc6 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-1) (let ((sc5 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-6 (vector-ref sc5 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-2) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-9) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-10) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-11) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-3) (let ((sc5 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-10 (vector-ref sc5 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-4) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-6 (vector-ref sc4 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-5) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-2 (vector-ref sc3 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-18) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-19) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-20) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-6) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-10 (vector-ref sc4 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-7) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-6 (vector-ref sc3 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-8) (let ((sc2 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))) ((2) (case (vector-ref arg-8 0) ((3) (let ((e-39 (vector-ref arg-8 3))) (case (vector-ref e-39 0) ((2) (let ((e-44 (vector-ref e-39 3))) (case (vector-ref e-44 0) ((2) (lambda (eta-0) (vector 1 (box arg-7))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-27) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-28) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-29) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-9) (let ((sc6 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc6 0) ((1) (let ((e-10 (vector-ref sc6 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc6 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-10) (let ((sc5 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-6 (vector-ref sc5 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-11) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-36) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-37) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-38) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-12) (let ((sc5 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-10 (vector-ref sc5 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-13) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-6 (vector-ref sc4 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-14) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-2 (vector-ref sc3 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-45) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-46) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-47) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-15) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-10 (vector-ref sc4 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-16) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-6 (vector-ref sc3 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-17) (let ((sc2 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))) ((3) (case (vector-ref arg-8 0) ((3) (let ((e-50 (vector-ref arg-8 3))) (case (vector-ref e-50 0) ((2) (let ((e-55 (vector-ref e-50 3))) (case (vector-ref e-55 0) ((3) (lambda (eta-0) (vector 1 (box arg-7))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-54) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-55) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-56) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-18) (let ((sc6 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc6 0) ((1) (let ((e-10 (vector-ref sc6 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc6 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-19) (let ((sc5 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-6 (vector-ref sc5 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-20) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-63) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-64) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-65) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-21) (let ((sc5 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc5 0) ((1) (let ((e-10 (vector-ref sc5 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc5 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-22) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-6 (vector-ref sc4 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-23) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-2 (vector-ref sc3 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-72) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-73) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-74) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-24) (let ((sc4 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc4 0) ((1) (let ((e-10 (vector-ref sc4 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc4 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-25) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-6 (vector-ref sc3 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-26) (let ((sc2 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-81) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-82) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-83) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-27) (let ((sc3 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc3 0) ((1) (let ((e-10 (vector-ref sc3 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc3 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-28) (let ((sc2 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-6 (vector-ref sc2 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-29) (let ((sc1 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc1 0) ((1) (let ((e-2 (vector-ref sc1 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc1 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))(else (case (vector-ref arg-8 0) ((3) (let ((e-1 (vector-ref arg-8 1))) (let ((e-2 (vector-ref arg-8 2))) (let ((e-3 (vector-ref arg-8 3))) (let ((e-4 (vector-ref arg-8 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-90) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 0 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((2) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-91) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 2 ) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((3) (lambda (eta-0) (let ((act-1 (CoreC-45UnifyState-genVarName arg-5 arg-4 (CoreC-45Name-nameRoot e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-4) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-92) (if (null? e-10) (vector 1 '()) (let ((e-11 (unbox e-10))) (vector 1 (box (vector 2 e-1 e-7 (vector 3 (vector 32 e-1 0)) (box e-5) (vector 32 e-1 0) e-11)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (lambda (clam-30) (let ((sc2 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc2 0) ((1) (let ((e-10 (vector-ref sc2 2))) (case (vector-ref e-10 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc2 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))(else (lambda (clam-31) (let ((sc1 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc1 0) ((1) (let ((e-6 (vector-ref sc1 2))) (case (vector-ref e-6 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc1 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7)))))))))))))(else (lambda (clam-32) (let ((sc0 (CoreC-45TTC-45Term-getFn arg-8))) (case (vector-ref sc0 0) ((1) (let ((e-2 (vector-ref sc0 2))) (case (vector-ref e-2 0) ((1) (vector 1 '()))(else (vector 1 (box arg-7)))))) ((8) (vector 1 '())) ((3) (let ((e-11 (vector-ref sc0 3))) (case (vector-ref e-11 0) ((0) (vector 1 '()))(else (vector 1 (box arg-7))))))(else (vector 1 (box arg-7))))))))))))
(define TTImpC-45ElabC-45Term-n--12015-8315-u--bindLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-getTerm arg-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45ElabC-45Term-n--12015-8317-u--bindLamTm arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getNF arg-5 arg-7) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45ElabC-45Term-n--12015-8316-u--bindLamNF arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7))) eff-0) clam-0))))) (let ((e-1 (unbox e-6))) (vector 1 e-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45ElabC-45Term-insertImpLam (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-1 (unbox arg-5))) (TTImpC-45ElabC-45Term-n--12015-8315-u--bindLam e-1 arg-4 arg-3 arg-2 arg-1 arg-4 e-1 clam-0))))))
(define TTImpC-45ElabC-45Check-check (lambda (ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-12) (lambda (clam-0) (case (vector-ref ext-11 0) ((15) (let ((e-2 (vector-ref ext-11 2))) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 e-2 ext-12 clam-0))) ((3) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-12 clam-0)) ((5) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-12 clam-0)) ((7) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 ext-11 ext-12 clam-0))(else (let ((act-1 ((TTImpC-45ElabC-45Ambiguity-expandAmbigName ext-0 ext-1 ext-4 (let ((e-0 (vector-ref ext-8 0))) e-0) ext-9 ext-10 ext-11 '() ext-11 ext-12) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-0 (vector-ref ext-8 0))) (lambda (clam-1) (case (vector-ref e-0 0) ((1) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 e-5 ext-12 clam-1))(else (let ((act-2 ((TTImpC-45ElabC-45Term-insertImpLam ext-1 ext-3 ext-10 e-5 ext-12) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45ElabC-45Check-checkImp ext-0 ext-1 ext-2 ext-3 ext-4 ext-5 ext-6 ext-7 ext-8 ext-9 ext-10 e-7 ext-12 eta-0)))) eff-0) clam-1))))))))))) eff-0) clam-0))))))))))
(define CoreC-45UnifyState-addDelayedHoleName (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-14 (vector-ref e-5 2))) (let ((e-13 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-14 (LibrariesC-45DataC-45IntMap-insert e-2 e-3 e-13) e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))))
(define CoreC-45UnifyState-n--12647-7274-u--checkRef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((3) (let ((e-0 (vector-ref arg-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-1 (string-append "Hole cannot depend on an unbound implicit " (CoreC-45Name-u--show_Show_Name e-0))) ext-0)))(else (vector 1 (vector 0 ))))))
(define CoreC-45UnifyState-case--caseC-32blockC-32inC-32checkValidHole-7342 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (case (vector-ref arg-9 0) ((8) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyExact arg-2 (let ((e-36 (vector-ref e-5 0))) e-36) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-3 (unbox e-6))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 30 '() arg-1 (let ((e-38 (vector-ref e-5 0))) e-38) '() e-3 '()) clam-1)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((9) (let ((e-5 (vector-ref arg-9 3))) (if (null? e-5) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-getFullName arg-5 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 8 -1) (let ((e-2 (vector-ref arg-7 2))) e-2))) '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--12647-7274-u--checkRef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) e-6))) eff-0) clam-0))))) (let ((e-7 (car e-5))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (LibrariesC-45DataC-45IntMap-lookup e-7 (let ((e-16 (vector-ref e-6 4))) e-16)))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-1 (unbox sc3))) (case (vector-ref e-1 0) ((0) (let ((e-0 (vector-ref e-1 1))) (let ((e-12 (vector-ref e-1 2))) (let ((e-11 (vector-ref e-1 4))) (let ((e-10 (vector-ref e-1 5))) (let ((e-9 (vector-ref e-1 6))) (let ((act-2 (let ((act-2 (set-box! arg-4 (let ((e-24 (vector-ref e-6 0))) (let ((e-22 (vector-ref e-6 2))) (let ((e-21 (vector-ref e-6 3))) (let ((e-20 (vector-ref e-6 4))) (let ((e-19 (vector-ref e-6 5))) (let ((e-18 (vector-ref e-6 6))) (let ((e-17 (vector-ref e-6 7))) (let ((e-16 (vector-ref e-6 8))) (let ((e-15 (vector-ref e-6 9))) (let ((e-14 (vector-ref e-6 10))) (let ((e-13 (vector-ref e-6 11))) (vector e-24 LibrariesC-45DataC-45IntMap-empty e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-13 (vector-ref act-2 1))) (vector 0 e-13))) (else (let ((act-3 (CoreC-45Context-clearDefs arg-6 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-14 (vector-ref act-3 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-4 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 e-0 e-14 e-11 e-10 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_NF arg-5 e-0 e-14 e-11 e-9 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 2 e-0 e-12 (let ((e-49 (vector-ref arg-6 0))) e-49) e-11 e-15 e-16) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))))))(else (vector 1 (vector 0 )))))))))) eff-0) clam-0)))))))))(else (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-getFullName arg-5 eta-0 eta-1))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45TT-getRefs (vector 8 -1) (let ((e-2 (vector-ref arg-7 2))) e-2))) '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (CoreC-45UnifyState-n--12647-7274-u--checkRef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) e-5))) eff-0) clam-0))))))))))
(define CoreC-45UnifyState-checkValidHole (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-2 arg-2))) (cond ((equal? sc2 1) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-1) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-8))) (let ((_-0 (box e-1))) (CoreC-45UnifyState-case--caseC-32blockC-32inC-32checkValidHole-7342 e-2 e-6 e-7 arg-2 arg-1 arg-0 e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))))))))
(define CoreC-45UnifyState-getGuesses (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-1 (vector-ref e-5 1))) e-1)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define CoreC-45UnifyState-n--13278-7806-u--nameEq (lambda (arg-0 arg-1 arg-2 arg-3 arg-6 arg-7) (let ((e-3 (cdr arg-6))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr arg-7))) (let ((e-15 (cdr e-11))) (CoreC-45Name-u--C-61C-61_Eq_Name e-7 e-15)))))))
(define CoreC-45UnifyState-checkUserHolesAfter (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45UnifyState-getGuesses arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--gs (LibrariesC-45DataC-45IntMap-toList e-5))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "unify.unsolved" 10 (lambda () (string-append "Unsolved guesses " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1838 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1838 u--d u--x)))) u--gs))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-1) (CoreC-45UnifyState-checkValidHole arg-1 arg-0 arg-2 eta-1)) u--gs) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45UnifyState-getCurrentHoles arg-0 eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--hs (LibrariesC-45DataC-45IntMap-toList e-8))) (let ((u--hsC-39 (let ((sc4 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-1) (CoreC-45Name-isUserName eta-1)) (PreludeC-45TypesC-45List-mapAppend '() csegen-1842 u--hs)))) (cond ((equal? sc4 1) '()) (else u--hs))))) (lambda (eta-1) (let ((act-5 (let ((sc4 (cond ((equal? arg-3 1) (let ((sc6 (DataC-45List-isNil u--hsC-39))) (cond ((equal? sc6 1) 0) (else 1)))) (else 0)))) (cond ((equal? sc4 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 32 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-snd eta-2)) (DataC-45List-nubBy (lambda (eta-2) (lambda (eta-3) (CoreC-45UnifyState-n--13278-7806-u--nameEq arg-3 arg-2 arg-1 arg-0 eta-2 eta-3))) u--hs))) eta-1)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (eta-2) (CoreC-45UnifyState-addDelayedHoleName arg-0 eta-2)) u--hsC-39) eta-1))))))))) eff-0) eta-0))))))))))))))) eff-0) ext-0)))))))
(define TTImpC-45Elab-case--doPLetRenames-13614 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (vector 3 arg-4 arg-1 arg-3 (TTImpC-45Elab-doPLetRenames (cons arg-1 arg-0) arg-6 arg-5 arg-2)) (let ((e-1 (unbox arg-7))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (vector 3 arg-4 e-6 (CoreC-45TTC-45Binder-setMultiplicity arg-3 (AlgebraC-45Preorder-lub csegen-2382 e-5 (CoreC-45TTC-45Binder-multiplicity arg-3))) (TTImpC-45Elab-doPLetRenames (cons e-6 arg-0) arg-6 (cons e-6 arg-5) (CoreC-45NameC-45Scoped-compat csegen-2277 arg-2)))))))))
(define TTImpC-45Elab-doPLetRenames (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((4) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 4 e-6 e-7 e-8 e-9))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-2))) (cond ((equal? sc2 1) (CoreC-45TTC-45TermC-45Subst-subst (vector 10 e-1 (vector 0 )) (TTImpC-45Elab-doPLetRenames (cons e-2 arg-0) arg-1 arg-2 e-4))) (else (vector 3 e-1 e-2 u--b (TTImpC-45Elab-doPLetRenames (cons e-2 arg-0) arg-1 arg-2 e-4)))))))))))(else (TTImpC-45Elab-case--doPLetRenames-13614 arg-0 e-2 e-4 e-3 e-1 arg-2 arg-1 (DataC-45List-lookup csegen-832 e-2 arg-1)))))))))(else arg-3))))
(define TTImpC-45Elab-case--findPLetRenames-13423 (lambda (arg-0 arg-1 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((2) (cons (cons arg-12 (cons arg-8 arg-9)) (TTImpC-45Elab-findPLetRenames (cons arg-9 arg-0) arg-10)))(else (TTImpC-45Elab-findPLetRenames (cons arg-9 arg-0) arg-10)))))
(define TTImpC-45Elab-findPLetRenames (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((4) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-8 0) ((0) (let ((e-12 (vector-ref e-8 1))) (let ((e-13 (vector-ref e-8 2))) (let ((e-14 (vector-ref e-8 3))) (TTImpC-45Elab-case--findPLetRenames-13423 arg-0 e-6 e-12 e-13 e-14 e-9 e-7 e-2 e-4 e-1 (CoreC-45TTC-45Var-nameAt arg-0 e-14))))))(else (TTImpC-45Elab-findPLetRenames (cons e-2 arg-0) e-4))))))))(else (TTImpC-45Elab-findPLetRenames (cons e-2 arg-0) e-4))))))))(else '()))))
(define CoreC-45UnifyState-getHoles (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) e-0)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define TTImpC-45Elab-getRigNeeded (lambda (arg-0) (case (vector-ref arg-0 0) ((0) csegen-30) ((1) (let ((e-0 (vector-ref arg-0 1))) (let ((sc1 (AlgebraC-45Semiring-isErased csegen-931 e-0))) (cond ((equal? sc1 1) csegen-30) (else csegen-1416)))))(else csegen-1416))))
(define LibrariesC-45DataC-45IntMap-keys (lambda (ext-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (LibrariesC-45DataC-45IntMap-toList ext-0))))
(define CoreC-45Normalise-tryNormaliseSizeLimit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-0 arg-1 arg-2 arg-4 arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45NormaliseC-45Quote-u--quoteOpts_Quote_NF arg-0 arg-1 (vector 0 0 (box arg-3)) arg-2 arg-4 e-5 eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45Elab-n--11554-13722-u--updateType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (CoreC-45Normalise-tryNormaliseSizeLimit arg-1 '() arg-2 10 '() (let ((e-2 (vector-ref arg-4 2))) e-2) eta-0)) (lambda (u--err) (lambda (eta-0) (CoreC-45Normalise-normaliseHoles arg-1 '() arg-2 '() (let ((e-2 (vector-ref arg-4 2))) e-2) eta-0))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45Context-addDef arg-1 (vector 8 arg-3) (let ((e-0 (vector-ref arg-4 0))) (let ((e-1 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-23 (vector-ref arg-4 5))) (let ((e-6 (vector-ref arg-4 6))) (let ((e-7 (vector-ref arg-4 7))) (let ((e-8 (vector-ref arg-4 8))) (let ((e-9 (vector-ref arg-4 9))) (let ((e-10 (vector-ref arg-4 10))) (let ((e-11 (vector-ref arg-4 11))) (let ((e-12 (vector-ref arg-4 12))) (let ((e-13 (vector-ref arg-4 13))) (let ((e-14 (vector-ref arg-4 14))) (let ((e-15 (vector-ref arg-4 15))) (let ((e-16 (vector-ref arg-4 16))) (let ((e-17 (vector-ref arg-4 17))) (let ((e-18 (vector-ref arg-4 18))) (let ((e-19 (vector-ref arg-4 19))) (let ((e-20 (vector-ref arg-4 20))) (let ((e-21 (vector-ref arg-4 21))) (let ((e-22 (vector-ref arg-4 22))) (vector e-0 e-1 e-5 e-3 e-4 e-23 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-1)) eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45Elab-n--11554-13721-u--normaliseH (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact (vector 8 arg-3) (let ((e-0 (vector-ref arg-2 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-5))) (let ((e-18 (vector-ref e-1 18))) (lambda (clam-0) (case (vector-ref e-18 0) ((7) (TTImpC-45Elab-n--11554-13722-u--updateType arg-0 arg-1 arg-2 arg-3 e-1 clam-0))(else (vector 1 (vector 0 )))))))))) eff-0) ext-0)))))))
(define TTImpC-45Elab-normaliseHoleTypes (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--hs (LibrariesC-45DataC-45IntMap-keys (let ((e-0 (vector-ref e-5 0))) e-0)))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (TTImpC-45Elab-n--11554-13721-u--normaliseH arg-1 arg-0 e-6 eta-1 eta-2))) u--hs))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-restoreHoles (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 arg-1 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45UnifyState-saveHoles (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 LibrariesC-45DataC-45IntMap-empty e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-n--8602-3602-u--tag (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-2 0) 1) ((equal? arg-2 1) 2) ((equal? arg-2 4) 3) ((equal? arg-2 2) 4) (else 5))))
(define CoreC-45UnifyState-u--compare_Ord_DelayReason (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Int (CoreC-45UnifyState-n--8602-3602-u--tag arg-1 arg-0 arg-0) (CoreC-45UnifyState-n--8602-3602-u--tag arg-1 arg-0 arg-1))))
(define TTImpC-45Elab-n--11809-14024-u--addHoles (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18) (if (null? arg-18) arg-16 (let ((e-2 (car arg-18))) (let ((e-3 (cdr arg-18))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (LibrariesC-45DataC-45IntMap-lookup e-6 arg-17))) (if (null? sc2) (TTImpC-45Elab-n--11809-14024-u--addHoles arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 e-3) (TTImpC-45Elab-n--11809-14024-u--addHoles arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (LibrariesC-45DataC-45IntMap-insert e-6 e-7 arg-16) arg-17 e-3))))))))))
(define TTImpC-45Elab-elabTermSub (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((u--incase (PreludeC-45Types-elem csegen-14 csegen-2376 1 arg-9))) (let ((u--inPE (PreludeC-45Types-elem csegen-14 csegen-2376 2 arg-9))) (let ((u--inTrans (PreludeC-45Types-elem csegen-14 csegen-2376 3 arg-9))) (lambda (eta-0) (let ((act-1 (cond ((equal? u--incase 1) (vector 1 LibrariesC-45DataC-45IntMap-empty)) (else (CoreC-45UnifyState-saveHoles arg-4 eta-0))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--olddelayed (let ((e-10 (vector-ref e-6 10))) e-10))) (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-4 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-13 (vector-ref e-6 5))) (let ((e-12 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-11 (vector-ref e-6 11))) (vector e-0 e-1 e-2 e-3 e-4 e-13 e-12 e-7 e-8 e-9 '() e-11))))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Context-getNextEntry arg-2 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-2))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (TTImpC-45ElabC-45Check-initEStateSub arg-0 arg-7 arg-12 arg-13)) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--rigc (TTImpC-45Elab-getRigNeeded arg-8))) (lambda (eta-5) (let ((act-7 ((TTImpC-45ElabC-45Check-check arg-1 arg-2 arg-3 arg-4 e-10 arg-5 arg-6 u--rigc (TTImpC-45ElabC-45Check-initElabInfo arg-8) arg-10 arg-11 arg-14 arg-15) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((u--solvemode (case (vector-ref arg-8 0) ((1) CoreC-45Unify-inLHS)(else CoreC-45Unify-inTerm)))) (lambda (eta-6) (let ((act-8 (CoreC-45Unify-solveConstraints arg-2 arg-4 u--solvemode 0 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (CoreC-45ContextC-45Log-logTerm arg-1 arg-2 "elab" 5 (lambda () "Looking for delayed in ") e-2 eta-6))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((act-10 (let ((act-10 (unbox arg-4))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-11 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-8) (TTImpC-45ElabC-45Delayed-retryDelayed arg-1 arg-2 arg-3 arg-4 e-10 u--solvemode (DataC-45List-sortBy (lambda (u--x) (lambda (u--y) (CoreC-45UnifyState-u--compare_Ord_DelayReason (Builtin-fst u--x) (Builtin-fst u--y)))) (let ((e-16 (vector-ref e-14 10))) e-16)) eta-8)) (lambda (u--err) (lambda (eta-8) (let ((act-11 ((let ((eff-0 (lambda (world-0) (let ((act-11 (unbox arg-4))) (vector 1 act-11))))) (lambda (world-0) (let ((act-11 (eff-0 world-0))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-1 (lambda (world-1) (let ((act-12 (set-box! arg-4 (let ((e-0 (vector-ref e-15 0))) (let ((e-1 (vector-ref e-15 1))) (let ((e-24 (vector-ref e-15 2))) (let ((e-23 (vector-ref e-15 3))) (let ((e-4 (vector-ref e-15 4))) (let ((e-22 (vector-ref e-15 5))) (let ((e-21 (vector-ref e-15 6))) (let ((e-20 (vector-ref e-15 7))) (let ((e-19 (vector-ref e-15 8))) (let ((e-18 (vector-ref e-15 9))) (let ((e-16 (vector-ref e-15 11))) (vector e-0 e-1 e-24 e-23 e-4 e-22 e-21 e-20 e-19 e-18 u--olddelayed e-16))))))))))))))) (vector 1 act-12))))) eff-1) world-0))))))) eta-8))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-8)))))) eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 ((let ((eff-0 (lambda (world-0) (let ((act-12 (unbox arg-4))) (vector 1 act-12))))) (lambda (world-0) (let ((act-12 (eff-0 world-0))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-1 (lambda (world-1) (let ((act-13 (set-box! arg-4 (let ((e-0 (vector-ref e-16 0))) (let ((e-1 (vector-ref e-16 1))) (let ((e-25 (vector-ref e-16 2))) (let ((e-24 (vector-ref e-16 3))) (let ((e-4 (vector-ref e-16 4))) (let ((e-23 (vector-ref e-16 5))) (let ((e-22 (vector-ref e-16 6))) (let ((e-21 (vector-ref e-16 7))) (let ((e-20 (vector-ref e-16 8))) (let ((e-19 (vector-ref e-16 9))) (let ((e-17 (vector-ref e-16 11))) (vector e-0 e-1 e-25 e-24 e-4 e-23 e-22 e-21 e-20 e-19 u--olddelayed e-17))))))))))))))) (vector 1 act-13))))) eff-1) world-0))))))) eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((act-13 (CoreC-45Unify-solveConstraintsAfter arg-2 arg-4 e-8 u--solvemode 2 eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((act-14 (let ((sc14 (cond ((equal? u--incase 1) (DataC-45Maybe-isJust (TTImpC-45ElabC-45Check-isLHS arg-8))) (else 1)))) (cond ((equal? sc14 1) (let ((act-14 (CoreC-45ContextC-45Log-log arg-2 "elab" 5 (lambda () "Resolving default hints") eta-7))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((act-15 (CoreC-45Unify-solveConstraintsAfter arg-2 arg-4 e-8 u--solvemode 1 eta-7))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (CoreC-45Unify-solveConstraintsAfter arg-2 arg-4 e-8 u--solvemode 3 eta-7)))))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((act-15 (CoreC-45UnifyState-dumpConstraints arg-4 arg-2 "elab" 4 0 eta-7))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((act-16 (let ((act-16 (unbox arg-2))) (vector 1 act-16)))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-17 (cond ((equal? u--inPE 1) (CoreC-45Normalise-normaliseHoles arg-2 arg-1 e-20 arg-11 e-2 eta-8)) (else (CoreC-45Normalise-normaliseArgHoles arg-2 arg-1 e-20 arg-11 e-2 eta-8))))) (case (vector-ref act-17 0) ((0) (let ((e-4 (vector-ref act-17 1))) (vector 0 e-4))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-18 (case (vector-ref arg-8 0) ((1) (let ((act-18 (cond ((equal? u--incase 1) (vector 1 (vector 0 ))) (else (CoreC-45UnifyState-checkUserHolesAfter arg-4 arg-2 e-8 1 eta-9))))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (vector 1 e-21))))) ((3) (let ((act-18 (cond ((equal? u--incase 1) (vector 1 (vector 0 ))) (else (CoreC-45UnifyState-checkUserHolesAfter arg-4 arg-2 e-8 1 eta-9))))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (vector 1 e-21)))))(else (cond ((equal? u--incase 1) (vector 1 e-21)) (else (let ((act-18 (CoreC-45UnifyState-checkUserHolesAfter arg-4 arg-2 e-8 (cond ((equal? u--inTrans 1) 1) (else u--inPE)) eta-9))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (CoreC-45LinearCheck-linearCheck arg-1 arg-2 arg-4 (TTImpC-45TTImp-getFC arg-14) u--rigc 0 arg-11 e-21 eta-9)))))))))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-19 (TTImpC-45Elab-normaliseHoleTypes arg-2 arg-4 eta-10))) (case (vector-ref act-19 0) ((0) (let ((e-4 (vector-ref act-19 1))) (vector 0 e-4))) (else (let ((act-20 (cond ((equal? u--incase 1) (vector 1 (vector 0 ))) (else (let ((act-20 (CoreC-45UnifyState-getHoles arg-4 eta-10))) (case (vector-ref act-20 0) ((0) (let ((e-4 (vector-ref act-20 1))) (vector 0 e-4))) (else (let ((e-24 (vector-ref act-20 1))) ((let ((eff-0 (CoreC-45UnifyState-restoreHoles arg-4 (TTImpC-45Elab-n--11809-14024-u--addHoles arg-0 arg-1 arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 LibrariesC-45DataC-45IntMap-empty e-24 (LibrariesC-45DataC-45IntMap-toList e-5))))) eff-0) eta-10))))))))) (case (vector-ref act-20 0) ((0) (let ((e-4 (vector-ref act-20 1))) (vector 0 e-4))) (else (let ((act-21 (let ((act-21 (unbox e-10))) (vector 1 act-21)))) (case (vector-ref act-21 0) ((0) (let ((e-4 (vector-ref act-21 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-22 ((CoreC-45Core-traverse_ (lambda (eta-12) (lambda (eta-13) (TTImpC-45Elab-addHoleToSave arg-2 eta-12 eta-13))) (LibrariesC-45DataC-45NameMap-keys (let ((e-27 (vector-ref e-25 12))) e-27))) eta-11))) (case (vector-ref act-22 0) ((0) (let ((e-4 (vector-ref act-22 1))) (vector 0 e-4))) (else (case (vector-ref arg-8 0) ((1) (let ((u--vs (TTImpC-45Elab-findPLetRenames arg-1 e-22))) (let ((u--ret (TTImpC-45Elab-doPLetRenames arg-1 u--vs '() e-22))) (let ((act-23 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-11))) (case (vector-ref act-23 0) ((0) (let ((e-4 (vector-ref act-23 1))) (vector 0 e-4))) (else (let ((e-27 (vector-ref act-23 1))) ((let ((eff-0 (lambda (eta-12) (vector 1 (cons u--ret (CoreC-45NormaliseC-45Eval-gnf arg-1 arg-11 (TTImpC-45Elab-doPLetRenames arg-1 u--vs '() e-27))))))) eff-0) eta-11))))))))(else (let ((act-23 (CoreC-45UnifyState-dumpConstraints arg-4 arg-2 "elab" 2 0 eta-11))) (case (vector-ref act-23 0) ((0) (let ((e-4 (vector-ref act-23 1))) (vector 0 e-4))) (else (vector 1 (cons e-22 e-3))))))))))))) eff-0) eta-10)))))))))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) eta-7))))))))))))))))))))))) eff-0) eta-6))))))))))))))))) eff-0) eta-5))))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))) eff-0) eta-2)))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define TTImpC-45Elab-elabTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (TTImpC-45Elab-elabTermSub arg-0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-10 (vector 0 ) arg-11 arg-12)))
(define IdrisC-45ElabC-45Implementation-getMethImps (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (case (vector-ref e-8 0) ((0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-3827 (lambda (eta-0) (TTImpC-45Unelab-unelabNoSugar arg-0 arg-1 arg-2 e-9 eta-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45ElabC-45Implementation-getMethImps (cons e-2 arg-0) arg-1 (cons (vector 2 e-6 e-7 (vector 0 ) e-9) arg-2) e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (cons e-2 (cons e-7 (cons '() e-5))) e-10))))) eff-0) eta-0)))))))) eff-0) clam-0)))))) ((3) (let ((e-12 (vector-ref e-8 1))) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-3827 (lambda (eta-0) (TTImpC-45Unelab-unelabNoSugar arg-0 arg-1 arg-2 e-9 eta-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-3827 (lambda (eta-1) (TTImpC-45Unelab-unelabNoSugar arg-0 arg-1 arg-2 e-12 eta-1)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45ElabC-45Implementation-getMethImps (cons e-2 arg-0) arg-1 (cons (vector 2 e-6 e-7 (vector 3 e-12) e-9) arg-2) e-4) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (cons e-2 (cons e-7 (cons (box e-10) e-5))) e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define IdrisC-45Syntax-typePass (lambda (arg-0) (let ((sc0 (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 0))) (cond ((equal? sc0 1) 1) (else (IdrisC-45Syntax-u--C-61C-61_Eq_Pass arg-0 1))))))
(define CoreC-45TT-u--showPrec_Show_TotalReq (lambda (arg-0 arg-1) (CoreC-45TT-u--show_Show_TotalReq arg-1)))
(define IdrisC-45Syntax-u--show_Show_Method (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (string-append "[" (string-append (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45TT-u--show_Show_TotalReq u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45TT-u--showPrec_Show_TotalReq u--d u--x)))) e-2) (string-append "] " (string-append (AlgebraC-45ZeroOneOmega-u--show_Show_ZeroOneOmega e-1) (string-append " " (string-append (CoreC-45Name-u--show_Show_Name e-0) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-3))))))))))))))
(define IdrisC-45Syntax-u--showPrec_Show_Method (lambda (arg-0 arg-1) (IdrisC-45Syntax-u--show_Show_Method arg-1)))
(define IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (CoreC-45FC-virtualiseFC arg-14)))
(define CoreC-45Context-addOpenHint (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-7 e-8 (LibrariesC-45DataC-45NameMap-insert e-5 (vector 0 ) e-9) e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setOpenHints (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 arg-1 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13975-u--addTransform (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "Adding transform for " (string-append (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-22 0))) e-0)) (string-append " : " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 (let ((e-3 (vector-ref arg-22 3))) e-3)) (string-append "\xa;\x9;for " (string-append (CoreC-45Name-u--show_Show_Name arg-20) (string-append " in " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-84 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-84 u--d u--x)))) arg-21))))))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--lhs (vector 10 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-0 (vector-ref arg-22 0))) e-0)) (vector 1 (vector 0 "__con")) (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-20)))) (let ((sc1 (DataC-45List-lookup csegen-832 (CoreC-45Name-dropNS (let ((e-0 (vector-ref arg-22 0))) e-0)) arg-21))) (if (null? sc1) (vector 1 (vector 0 )) (let ((e-1 (unbox sc1))) (let ((u--rhs (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-1))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--lhs) (string-append " ==> " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--rhs)))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45UnifyState-handleUnify arg-19 arg-18 0 (TTImpC-45ElabC-45Check-processDecl arg-8 arg-19 arg-16 arg-18 arg-17 arg-15 '() arg-9 arg-10 (vector 7 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (vector 1 (vector 0 (string-append (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-22 0))) e-0)) (string-append " " (CoreC-45Name-u--show_Show_Name arg-20))))) u--lhs u--rhs)) (lambda (u--err) (lambda (eta-0) (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Can't add transform " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--lhs) (string-append " ==> " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--rhs) (string-append "\xa;\x9;" (CoreC-45Core-u--show_Show_Error u--err))))))) eta-0))) ext-0))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13977-u--applyEnv (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (let ((act-1 (CoreC-45Context-resolveName arg-19 arg-20 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 8 e-5) (cons '() (cons (PreludeC-45TypesC-45List-reverse (CoreC-45Env-allVars arg-8 arg-10)) (lambda (u--fn) (lambda (u--nt) (CoreC-45UnifyState-applyToFull arg-8 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (vector 1 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) u--nt (vector 8 e-5)) arg-10)))))))))) eff-0) ext-0)))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13979-u--autoImpsApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) arg-20 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (IdrisC-45ElabC-45Implementation-n--12017-13979-u--autoImpsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 9 (TTImpC-45TTImp-getFC arg-20) arg-20 e-2) e-3))))))
(define IdrisC-45ElabC-45Implementation-n--12123-14068-u--getArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-29) (case (vector-ref arg-29 0) ((3) (let ((e-2 (vector-ref arg-29 2))) (let ((e-3 (vector-ref arg-29 3))) (let ((e-4 (vector-ref arg-29 4))) (case (vector-ref e-3 0) ((2) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (cons (cons e-2 (cons e-7 (CoreC-45TTC-45Binder-forgetDef e-8))) (IdrisC-45ElabC-45Implementation-n--12123-14068-u--getArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 e-4)))))(else '()))))))(else '()))))
(define IdrisC-45ElabC-45Implementation-n--12017-13982-u--getFieldArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21) (case (vector-ref arg-21 0) ((3) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((e-3 (vector-ref arg-21 3))) (let ((e-4 (vector-ref arg-21 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (cons (cons e-2 (IdrisC-45ElabC-45Implementation-n--12123-14068-u--getArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-1 e-6 e-7 e-8 e-9 e-2 e-4 e-9)) (IdrisC-45ElabC-45Implementation-n--12017-13982-u--getFieldArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-4)))))))(else '())))))))(else '()))))
(define IdrisC-45ElabC-45Implementation-n--12017-13983-u--impsApply (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) arg-20 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (IdrisC-45ElabC-45Implementation-n--12017-13983-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 10 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-20 e-6 e-7) e-3))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13985-u--methNameUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (case (vector-ref e-2 0) ((1) (let ((e-8 (vector-ref e-2 1))) (if (null? e-3) (let ((e-6 (car e-3))) (cons (vector 1 (vector 0 (CoreC-45Name-nameRoot e-2))) e-6)) (let ((e-13 (car e-3))) (cons (vector 1 e-8) e-13))))) ((0) (let ((e-10 (vector-ref e-2 2))) (if (null? e-3) (let ((e-6 (car e-3))) (cons (vector 1 (vector 0 (CoreC-45Name-nameRoot e-2))) e-6)) (let ((e-17 (car e-3))) (let ((e-18 (cdr e-3))) (IdrisC-45ElabC-45Implementation-n--12017-13985-u--methNameUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (cons e-10 (cons e-17 e-18))))))))(else (let ((e-6 (car e-3))) (cons (vector 1 (vector 0 (CoreC-45Name-nameRoot e-2))) e-6))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13978-u--applyTo (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) arg-20 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-11 (cdr e-7))) (case (vector-ref e-11 0) ((1) (IdrisC-45ElabC-45Implementation-n--12017-13978-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 8 (vector 2 ) arg-20 (vector 0 (vector 2 ) e-6)) e-3)) ((2) (IdrisC-45ElabC-45Implementation-n--12017-13978-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 10 (vector 2 ) arg-20 e-6 (vector 0 (vector 2 ) e-6)) e-3)) ((0) (IdrisC-45ElabC-45Implementation-n--12017-13978-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 10 (vector 2 ) arg-20 e-6 (vector 0 (vector 2 ) e-6)) e-3)) (else (IdrisC-45ElabC-45Implementation-n--12017-13978-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 10 (vector 2 ) arg-20 e-6 (vector 0 (vector 2 ) e-6)) e-3)))))))))))
(define IdrisC-45ElabC-45Implementation-n--12128-14307-u--applyUpdate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29) (if (null? arg-29) arg-29 (let ((e-2 (car arg-29))) (let ((e-3 (cdr arg-29))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (if (null? e-3) arg-29 (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (PreludeC-45Types-maybe (lambda () (cons (vector 1 (vector 0 e-5)) (cons e-8 e-9))) (lambda () (lambda (u--nC-39) (cons (vector 1 (vector 0 u--nC-39)) (cons e-8 e-9)))) (DataC-45List-lookup csegen-22 e-5 arg-23)))))))(else arg-29))))(else arg-29)))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13986-u--mkLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-20) arg-21 (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 2 (vector 2 ) e-10 e-11 (box e-6) (vector 32 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) 0) (IdrisC-45ElabC-45Implementation-n--12017-13986-u--mkLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-3 arg-21)))))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13987-u--mkMethField (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 arg-22 arg-23) (let ((e-2 (car arg-23))) (let ((e-3 (cdr arg-23))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((u--argns (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--12128-14307-u--applyUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-2 e-6 e-10 e-14 e-18 e-19 arg-22 arg-21 eta-0)) (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) eta-0)) (DataC-45List-lookup csegen-832 (CoreC-45Name-dropNS e-2) arg-22))))) (let ((u--imps (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-21))) (IdrisC-45ElabC-45Implementation-n--12017-13986-u--mkLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 u--argns (IdrisC-45ElabC-45Implementation-n--12017-13983-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13978-u--applyTo arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 0 (vector 2 ) e-6) u--argns) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons u--n (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (vector 1 (vector 0 (CoreC-45Name-u--show_Show_Name u--n)))))) u--imps)))))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13988-u--mkTopMethDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (let ((e-3 (cdr arg-20))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (let ((u--opts (PreludeC-45Types-maybe (lambda () arg-12) (lambda () (lambda (u--t) (cons (vector 11 u--t) arg-12))) e-18))) (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-14 arg-13 u--opts (vector (vector 2 ) (vector 2 ) e-6 e-19)))))))))))))
(define TTImpC-45TTImp-findImplicits (lambda (arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (if (null? e-4) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6)) (let ((e-73 (unbox e-4))) (case (vector-ref e-73 0) ((1) (let ((e-74 (vector-ref e-73 1))) (case (vector-ref e-74 0) ((0) (let ((e-75 (vector-ref e-74 1))) (cons e-75 (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6)))))(else (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6))))))(else (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-5) (TTImpC-45TTImp-findImplicits e-6)))))))))) ((2) (let ((e-12 (vector-ref arg-1 5))) (let ((e-13 (vector-ref arg-1 6))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-12) (TTImpC-45TTImp-findImplicits e-13))))) ((8) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-16) (TTImpC-45TTImp-findImplicits e-17))))) ((9) (let ((e-20 (vector-ref arg-1 2))) (let ((e-21 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-20) (TTImpC-45TTImp-findImplicits e-21))))) ((10) (let ((e-24 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 4))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-24) (TTImpC-45TTImp-findImplicits e-26))))) ((11) (let ((e-29 (vector-ref arg-1 2))) (let ((e-30 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-29) (TTImpC-45TTImp-findImplicits e-30))))) ((18) (let ((e-36 (vector-ref arg-1 5))) (TTImpC-45TTImp-findImplicits e-36))) ((19) (let ((e-40 (vector-ref arg-1 3))) (TTImpC-45TTImp-findImplicits e-40))) ((13) (let ((e-44 (vector-ref arg-1 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45TTImp-findImplicits eta-0)) e-44))) ((20) (let ((e-48 (vector-ref arg-1 3))) (TTImpC-45TTImp-findImplicits e-48))) ((21) (let ((e-51 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-51))) ((22) (let ((e-54 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-54))) ((23) (let ((e-57 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-57))) ((26) (let ((e-60 (vector-ref arg-1 2))) (TTImpC-45TTImp-findImplicits e-60))) ((27) (let ((e-64 (vector-ref arg-1 3))) (TTImpC-45TTImp-findImplicits e-64))) ((17) (let ((e-67 (vector-ref arg-1 2))) (cons e-67 '()))) ((7) (let ((e-70 (vector-ref arg-1 2))) (let ((e-71 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45TTImp-findImplicits e-71) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) (TTImpC-45TTImp-findImplicits (TTImpC-45TTImp-getFieldUpdateTerm eta-0))) e-70)))))(else '()))))
(define ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 (lambda (arg-4 arg-5 arg-6 ext-0) (let ((e-2 (vector-ref arg-4 1))) ((((e-2 'erased) 'erased) (arg-5 ext-0)) (lambda (_-0) (let ((e-5 (car _-0))) (let ((e-4 (cdr _-0))) ((let ((eff-0 (arg-6 e-4))) eff-0) e-5))))))))
(define TTImpC-45BindImplicits-n--7486-6620-u--f (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (ControlC-45MonadC-45StateC-45State-u--map_Functor_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2675 (lambda (eta-0) (vector 0 e-1 eta-0)) (TTImpC-45BindImplicits-renameIBinds arg-4 arg-3 e-2) ext-0)))) (else (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (ControlC-45MonadC-45StateC-45State-u--map_Functor_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2675 (lambda (eta-0) (vector 1 e-4 eta-0)) (TTImpC-45BindImplicits-renameIBinds arg-4 arg-3 e-5) ext-0)))))))
(define TTImpC-45BindImplicits-n--7486-6691-u--renameAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((2) (let ((e-1 (vector-ref arg-5 1))) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-4 arg-3 e-1) (lambda (bind-0) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 2 bind-0) eta-0))) ext-0)))(else (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 arg-5 ext-0)))))
(define TTImpC-45BindImplicits-renameIBinds (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (if (null? e-4) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 1 e-1 e-2 e-3 e-4 bind-0 bind-1) eta-2))) eta-1))) eta-0)) (let ((e-63 (unbox e-4))) (case (vector-ref e-63 0) ((1) (let ((e-64 (vector-ref e-63 1))) (case (vector-ref e-64 0) ((0) (let ((e-65 (vector-ref e-64 1))) (let ((u--un (vector 1 (vector 0 e-65)))) (let ((sc4 (PreludeC-45Types-elem csegen-14 csegen-22 e-65 arg-0))) (cond ((equal? sc4 1) (let ((u--nC-39 (TTImpC-45Utils-genUniqueStr (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) e-65))) (let ((u--unC-39 (vector 1 (vector 0 u--nC-39)))) (let ((u--scC-39 (TTImpC-45Utils-substNames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 1 (vector 0 eta-0))) (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-3) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-3 e-65)) arg-1)) (cons (cons u--un (vector 0 e-1 u--unC-39)) '()) e-6))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 (cons u--nC-39 arg-1) u--scC-39) (lambda (u--scr) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (u--tyC-39) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (lambda (u--x) (cons u--x u--x)) (lambda (u--upds) (lambda (eta-3) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (lambda (u--y) (cons (cons (cons e-65 u--nC-39) u--upds) (vector 0 ))) (lambda (_-10649) (lambda (eta-4) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 1 e-1 e-2 e-3 (box u--unC-39) u--tyC-39 u--scr) eta-4))) eta-3))) eta-2))) eta-1))) eta-0)))))) (else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (u--scr) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (u--tyC-39) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 1 e-1 e-2 e-3 (box u--un) u--tyC-39 u--scr) eta-2))) eta-1))) eta-0))))))))(else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 1 e-1 e-2 e-3 e-4 bind-0 bind-1) eta-2))) eta-1))) eta-0))))))(else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-5) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-6) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 1 e-1 e-2 e-3 e-4 bind-0 bind-1) eta-2))) eta-1))) eta-0))))))))))))) ((2) (let ((e-8 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-11 (vector-ref arg-2 4))) (let ((e-12 (vector-ref arg-2 5))) (let ((e-13 (vector-ref arg-2 6))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-12) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-13) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 2 e-8 e-9 e-10 e-11 bind-0 bind-1) eta-2))) eta-1))) eta-0))))))))) ((8) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-16) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-17) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 8 e-15 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((9) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-20) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-21) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 9 e-19 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((10) (let ((e-23 (vector-ref arg-2 1))) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (let ((e-26 (vector-ref arg-2 4))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-24) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-26) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 10 e-23 bind-0 e-25 bind-1) eta-2))) eta-1))) eta-0))))))) ((11) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-29) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-30) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 11 e-28 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((18) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (let ((e-34 (vector-ref arg-2 3))) (let ((e-35 (vector-ref arg-2 4))) (let ((e-36 (vector-ref arg-2 5))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-36) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 18 e-32 e-33 e-34 e-35 bind-0) eta-1))) eta-0)))))))) ((19) (let ((e-38 (vector-ref arg-2 1))) (let ((e-39 (vector-ref arg-2 2))) (let ((e-40 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-40) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 19 e-38 e-39 bind-0) eta-1))) eta-0)))))) ((20) (let ((e-42 (vector-ref arg-2 1))) (let ((e-43 (vector-ref arg-2 2))) (let ((e-44 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-44) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 20 e-42 e-43 bind-0) eta-1))) eta-0)))))) ((21) (let ((e-46 (vector-ref arg-2 1))) (let ((e-47 (vector-ref arg-2 2))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-47) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 21 e-46 bind-0) eta-1))) eta-0))))) ((22) (let ((e-49 (vector-ref arg-2 1))) (let ((e-50 (vector-ref arg-2 2))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-50) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 22 e-49 bind-0) eta-1))) eta-0))))) ((7) (let ((e-52 (vector-ref arg-2 1))) (let ((e-53 (vector-ref arg-2 2))) (let ((e-54 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (PreludeC-45Types-u--traverse_Traversable_List csegen-2684 (lambda (eta-1) (lambda (eta-2) (TTImpC-45BindImplicits-n--7486-6620-u--f e-54 e-53 e-52 arg-1 arg-0 eta-1 eta-2))) e-53) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 e-54) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 7 e-52 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((13) (let ((e-56 (vector-ref arg-2 1))) (let ((e-57 (vector-ref arg-2 2))) (let ((e-58 (vector-ref arg-2 3))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (lambda (eta-1) (TTImpC-45BindImplicits-n--7486-6691-u--renameAlt e-58 e-57 e-56 arg-1 arg-0 e-57 eta-1)) (lambda (bind-0) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (PreludeC-45Types-u--traverse_Traversable_List csegen-2684 (lambda (eta-2) (TTImpC-45BindImplicits-renameIBinds arg-0 arg-1 eta-2)) e-58) (lambda (bind-1) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 13 e-56 bind-0 bind-1) eta-2))) eta-1))) eta-0)))))) ((17) (let ((e-60 (vector-ref arg-2 1))) (let ((e-61 (vector-ref arg-2 2))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-22 e-61 arg-0))) (cond ((equal? sc1 1) (let ((u--nC-39 (TTImpC-45Utils-genUniqueStr (PreludeC-45TypesC-45List-tailRecAppend arg-0 arg-1) e-61))) (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (lambda (u--x) (cons u--x u--x)) (lambda (u--upds) (lambda (eta-1) (ControlC-45MonadC-45StateC-45State-u--C-62C-62C-61_Monad_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36mC-41 csegen-2671 (lambda (u--y) (cons (cons (cons e-61 u--nC-39) u--upds) (vector 0 ))) (lambda (_-10649) (lambda (eta-2) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 17 e-60 u--nC-39) eta-2))) eta-1))) eta-0)))) (else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 (vector 17 e-60 e-61) eta-0))))))))(else (lambda (eta-0) (ControlC-45MonadC-45StateC-45State-u--pure_Applicative_C-40C-40StateTC-32C-36stateTypeC-41C-32C-36fC-41 csegen-2671 arg-2 eta-0))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13984-u--methName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (case (vector-ref arg-20 0) ((0) (let ((e-1 (vector-ref arg-20 2))) (IdrisC-45ElabC-45Implementation-n--12017-13984-u--methName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-1)))(else (vector 4 (CoreC-45Name-u--show_Show_Name arg-20) (vector 1 (vector 0 (string-append (CoreC-45Name-u--show_Show_Name arg-20) (string-append "_" (string-append (CoreC-45Name-u--show_Show_Name arg-5) (string-append "_" (string-append (cond ((equal? arg-3 1) (CoreC-45Name-u--show_Show_Name arg-2)) (else "")) (CoreC-45NameC-45Namespace-showSep "_" (PreludeC-45TypesC-45List-mapAppend '() csegen-2610 arg-4))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13976-u--applyCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13984-u--methName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (CoreC-45Name-dropNS arg-21) (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-5)))))) eff-0) ext-0)))))))
(define TTImpC-45BindImplicits-bindTypeNamesUsed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-isUnboundImplicits arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 ((TTImpC-45Utils-findUniqueBindableNames arg-0 arg-1 1 arg-3 arg-2 arg-4) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (TTImpC-45BindImplicits-doBind e-6 arg-4))))) eff-0) clam-0)))))) (else (vector 1 arg-4)))))) eff-0) ext-0)))))))
(define TTImpC-45Utils-substBindVars (lambda (ext-0 ext-1 ext-2) (TTImpC-45Utils-substNamesC-39 1 ext-0 ext-1 ext-2)))
(define IdrisC-45ElabC-45Implementation-n--12017-13980-u--bindImps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-20) arg-21 (let ((e-2 (car arg-20))) (let ((e-3 (cdr arg-20))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (if (null? e-14) (vector 1 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-10 (vector 0 ) (box e-6) e-15 (IdrisC-45ElabC-45Implementation-n--12017-13980-u--bindImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-3 arg-21)) (let ((e-17 (unbox e-14))) (vector 1 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-10 (vector 3 e-17) (box e-6) e-15 (IdrisC-45ElabC-45Implementation-n--12017-13980-u--bindImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-3 arg-21)))))))))))))))
(define IdrisC-45ElabC-45Implementation-case--elabImplementationC-44topMethType-14688 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32) (let ((e-2 (car arg-32))) (let ((e-3 (cdr arg-32))) (let ((u--mty_in (TTImpC-45Utils-substNames arg-8 arg-27 e-3))) (let ((u--mty_iparams (TTImpC-45Utils-substBindVars arg-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--n) (cons u--n (vector 32 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) 0))) arg-23) u--mty_in))) (let ((u--mty_params (TTImpC-45Utils-substNames arg-8 (DataC-45List-u--zip_Zippable_List arg-22 arg-4) u--mty_iparams))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Substitute implicits " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-23) (string-append " parameters " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2707 (DataC-45List-u--zip_Zippable_List arg-22 arg-4)) (string-append " " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--mty_in) (string-append " is " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--mty_params))))))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((u--mbase (IdrisC-45ElabC-45Implementation-n--12017-13980-u--bindImps arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-25 (IdrisC-45ElabC-45Implementation-bindConstraints (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (vector 2 ) arg-6 u--mty_params)))) (let ((u--ibound (TTImpC-45TTImp-findImplicits u--mbase))) (let ((act-2 (TTImpC-45BindImplicits-bindTypeNamesUsed arg-19 arg-14 u--ibound arg-8 u--mbase eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "Method " (string-append (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-20 0))) e-0)) (string-append " ==> " (string-append (CoreC-45Name-u--show_Show_Name arg-28) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-6))))))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "    (initially " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--mty_in) ")"))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((act-5 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Updates " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2707 arg-27))) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "From " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--mbase))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "Name updates " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2689 e-2))) eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "Param names: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 arg-22))) eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 10 (lambda () (string-append "Used names " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--ibound))) eta-1))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((u--ibinds (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) arg-25))) (let ((u--methupdsC-39 (let ((sc10 (DataC-45List-isNil u--ibinds))) (cond ((equal? sc10 1) '()) (else (cons (cons arg-28 (IdrisC-45ElabC-45Implementation-n--12017-13983-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-28) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (cons u--x (vector 17 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (CoreC-45Name-u--show_Show_Name u--x)))) u--ibinds))) '())))))) (vector 1 (cons (cons (let ((e-0 (vector-ref arg-20 0))) e-0) (cons arg-28 (cons e-2 (cons (let ((e-1 (vector-ref arg-20 1))) e-1) (cons (let ((e-14 (vector-ref arg-20 2))) e-14) e-6))))) u--methupdsC-39)))))))))))))))))))))))))))) eff-0) eta-0))))))))))))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13989-u--topMethType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 ext-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13984-u--methName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (let ((e-0 (vector-ref arg-27 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ElabC-45Implementation-n--12017-13976-u--applyCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 eta-1 eta-2))) arg-26 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--mty_in (TTImpC-45Utils-substNames arg-8 e-6 (let ((e-3 (vector-ref arg-27 3))) e-3)))) (IdrisC-45ElabC-45Implementation-case--elabImplementationC-44topMethType-14688 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-27 arg-26 arg-25 arg-24 arg-23 arg-22 arg-21 arg-20 e-5 e-6 e-6 u--mty_in ((TTImpC-45BindImplicits-renameIBinds arg-23 (TTImpC-45TTImp-findImplicits u--mty_in) u--mty_in) '()))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13990-u--topMethTypes (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 ext-0) (if (null? arg-27) (vector 1 '()) (let ((e-2 (car arg-27))) (let ((e-3 (cdr arg-27))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13989-u--topMethType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-6 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-2 (IdrisC-45ElabC-45Implementation-n--12017-13990-u--topMethTypes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (PreludeC-45TypesC-45List-tailRecAppend e-4 arg-20) arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 e-3 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-6 e-7))))) eff-0) clam-1)))))))))) eff-0) ext-0))))))))))
(define TTImpC-45TTImpC-45ImpDecl-getFC (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) e-1)) ((1) (let ((e-7 (vector-ref arg-1 1))) e-7)) ((2) (let ((e-12 (vector-ref arg-1 1))) e-12)) ((3) (let ((e-16 (vector-ref arg-1 1))) e-16)) ((4) (let ((e-20 (vector-ref arg-1 1))) e-20)) ((5) (let ((e-26 (vector-ref arg-1 1))) e-26)) ((6) (let ((e-30 (vector-ref arg-1 1))) e-30)) ((7) (let ((e-34 (vector-ref arg-1 1))) e-34)) ((8) (let ((e-39 (vector-ref arg-1 1))) e-39)) ((9) (let ((e-42 (vector-ref arg-1 1))) e-42)) ((10) (vector 2 )) (else (let ((e-48 (vector-ref arg-1 1))) e-48)))))
(define IdrisC-45ElabC-45Implementation-n--12017-13981-u--findMethName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 ext-0) (let ((sc0 (DataC-45List-lookup csegen-832 arg-22 arg-20))) (if (null? sc0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-21 (string-append (CoreC-45Name-u--show_Show_Name arg-22) (string-append " is not a method of " (CoreC-45Name-u--show_Show_Name arg-5)))) ext-0) (let ((e-2 (unbox sc0))) (vector 1 e-2))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (case (vector-ref arg-21 0) ((0) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13981-u--findMethName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-1 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-5))))) eff-0) ext-0)))))))) ((8) (let ((e-4 (vector-ref arg-21 1))) (let ((e-5 (vector-ref arg-21 2))) (let ((e-6 (vector-ref arg-21 3))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-4 e-7 e-6))))) eff-0) ext-0))))))))) ((9) (let ((e-8 (vector-ref arg-21 1))) (let ((e-9 (vector-ref arg-21 2))) (let ((e-10 (vector-ref arg-21 3))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 9 e-8 e-5 e-10))))) eff-0) ext-0))))))))) ((10) (let ((e-12 (vector-ref arg-21 1))) (let ((e-13 (vector-ref arg-21 2))) (let ((e-14 (vector-ref arg-21 3))) (let ((e-15 (vector-ref arg-21 4))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-12 e-5 e-14 e-15))))) eff-0) ext-0))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (TTImpC-45TTImp-getFC arg-21) "Invalid method definition") ext-0)))))
(define IdrisC-45ElabC-45Implementation-n--12017-13993-u--updateClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (case (vector-ref arg-21 0) ((0) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((e-3 (vector-ref arg-21 3))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-5 e-3))))) eff-0) ext-0))))))))) ((1) (let ((e-5 (vector-ref arg-21 1))) (let ((e-6 (vector-ref arg-21 2))) (let ((e-7 (vector-ref arg-21 3))) (let ((e-8 (vector-ref arg-21 4))) (let ((e-9 (vector-ref arg-21 5))) (let ((e-10 (vector-ref arg-21 6))) (let ((e-11 (vector-ref arg-21 7))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45ElabC-45Implementation-n--12017-13993-u--updateClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 eta-1 eta-2))) e-11 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-5 e-12 e-7 e-8 e-9 e-10 e-13))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))) (else (let ((e-13 (vector-ref arg-21 1))) (let ((e-14 (vector-ref arg-21 2))) (let ((act-1 (IdrisC-45ElabC-45Implementation-n--12017-13991-u--updateApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-14 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-13 e-5))))) eff-0) ext-0)))))))))))
(define IdrisC-45ElabC-45Implementation-n--12017-13992-u--updateBody (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (case (vector-ref arg-21 0) ((2) (let ((e-1 (vector-ref arg-21 1))) (let ((e-2 (vector-ref arg-21 2))) (let ((e-3 (vector-ref arg-21 3))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Implementation-n--12017-13993-u--updateClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 eta-0 eta-1))) e-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45ElabC-45Implementation-n--12017-13981-u--findMethName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-1 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-19 "ide-mode.highlight" 1 (lambda () (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4046 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4046 u--d u--x))))) (cons e-2 (cons e-6 e-1)))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 (vector 2 e-1 e-6 e-5)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (TTImpC-45TTImpC-45ImpDecl-getFC arg-21) "Implementation body can only contain definitions") ext-0)))))
(define IdrisC-45ElabC-45Implementation-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32elabImplementation-17306 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28 arg-29 arg-30 arg-31 arg-32 arg-33 arg-34 arg-35 arg-36 arg-37 arg-38 arg-39 arg-40 arg-41 arg-42 arg-43 arg-44 ext-0) (let ((e-2 (car arg-44))) (let ((e-3 (cdr arg-44))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Added defaults: body is " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2566 e-2))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Missing methods: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 e-3))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (let ((sc3 (DataC-45List-isNil e-3))) (cond ((equal? sc3 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-14 (string-append "Missing methods in " (string-append (CoreC-45Name-u--show_Show_Name arg-5) (string-append ": " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-3)))))) ext-0)))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 (let ((act-4 (unbox arg-19))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--hs (let ((e-9 (vector-ref e-8 9))) e-9))) (lambda (eta-0) (let ((act-5 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 10 (lambda () (string-append "Open hints: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (cons arg-21 arg-1)))) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 ((CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-1) (let ((act-6 (CoreC-45Context-checkUnambig arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) u--n eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Context-addOpenHint arg-19 e-10 eta-2)))) eff-0) eta-1))))))) arg-1) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (let ((act-7 (unbox arg-19))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-8 (IdrisC-45ElabC-45Implementation-n--12017-13990-u--topMethTypes arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 '() arg-21 arg-43 arg-32 (let ((e-1 (vector-ref arg-27 1))) e-1) (let ((e-14 (vector-ref arg-27 2))) e-14) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (let ((e-0 (vector-ref eta-2 0))) e-0)) (let ((e-4 (vector-ref arg-27 4))) e-4)) (let ((e-4 (vector-ref arg-27 4))) e-4) eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-9 ((CoreC-45Core-traverse_ (lambda (eta-3) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-19 arg-16 arg-18 arg-17 arg-15 '() arg-9 arg-10 eta-3)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (IdrisC-45ElabC-45Implementation-n--12017-13988-u--mkTopMethDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-3)) e-12)) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((u--mtops (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst (Builtin-snd eta-3))) e-12))) (let ((u--con (let ((e-0 (vector-ref arg-27 0))) e-0))) (let ((u--ilhs (IdrisC-45ElabC-45Implementation-n--12017-13983-u--impsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 0 (vector 2 ) arg-21) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (cons u--x (vector 17 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (CoreC-45Name-u--show_Show_Name u--x)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) arg-43))))) (let ((act-10 (let ((act-10 (unbox arg-19))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-11 (CoreC-45Normalise-normaliseHoles arg-19 '() e-14 '() arg-30 eta-3))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (let ((u--fldTys (IdrisC-45ElabC-45Implementation-n--12017-13982-u--getFieldArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-15))) (lambda (eta-4) (let ((act-12 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Field types " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4023 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4023 u--d u--x)))) u--fldTys))) eta-4))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((u--irhs (TTImpC-45TTImp-apply (IdrisC-45ElabC-45Implementation-n--12017-13979-u--autoImpsApply arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) u--con) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (vector 12 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) 500)) (let ((e-18 (vector-ref arg-27 3))) e-18))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (IdrisC-45ElabC-45Implementation-n--12017-13987-u--mkMethField arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-43 u--fldTys eta-5)) e-12)))) (let ((u--impFn (vector 2 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (cons (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) u--ilhs u--irhs) '())))) (let ((act-13 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Implementation record: " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 csegen-65 u--impFn))) eta-4))) (case (vector-ref act-13 0) ((0) (let ((e-4 (vector-ref act-13 1))) (vector 0 e-4))) (else (let ((act-14 (cond ((equal? arg-3 1) (CoreC-45Context-addOpenHint arg-19 arg-21 eta-4)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-14 0) ((0) (let ((e-4 (vector-ref act-14 1))) (vector 0 e-4))) (else (let ((act-15 (CoreC-45Context-setFlag arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (vector 7 ) eta-4))) (case (vector-ref act-15 0) ((0) (let ((e-4 (vector-ref act-15 1))) (vector 0 e-4))) (else (let ((act-16 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (lambda (eta-6) (IdrisC-45ElabC-45Implementation-n--12017-13977-u--applyEnv arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-5 eta-6))) (cons arg-21 u--mtops) '()) eta-4))) (case (vector-ref act-16 0) ((0) (let ((e-4 (vector-ref act-16 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (let ((u--nestC-39 (PreludeC-45TypesC-45List-tailRecAppend e-20 arg-9))) (lambda (eta-5) (let ((act-17 ((CoreC-45Core-traverse_ (lambda (eta-6) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-19 arg-16 arg-18 arg-17 arg-15 '() u--nestC-39 arg-10 eta-6)) (cons u--impFn '())) eta-5))) (case (vector-ref act-17 0) ((0) (let ((e-4 (vector-ref act-17 1))) (vector 0 e-4))) (else (let ((act-18 (CoreC-45Context-unsetFlag arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (vector 7 ) eta-5))) (case (vector-ref act-18 0) ((0) (let ((e-4 (vector-ref act-18 1))) (vector 0 e-4))) (else (let ((act-19 (CoreC-45Context-setFlag arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (vector 5 ) eta-5))) (case (vector-ref act-19 0) ((0) (let ((e-4 (vector-ref act-19 1))) (vector 0 e-4))) (else (let ((act-20 (CoreC-45Context-setFlag arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (vector 6 2) eta-5))) (case (vector-ref act-20 0) ((0) (let ((e-4 (vector-ref act-20 1))) (vector 0 e-4))) (else (let ((u--upds (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-6) (IdrisC-45ElabC-45Implementation-n--12017-13985-u--methNameUpdate arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-6)) e-12))) (let ((act-21 ((CoreC-45Core-traverseC-39 (lambda (eta-6) (lambda (eta-7) (IdrisC-45ElabC-45Implementation-n--12017-13992-u--updateBody arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 u--upds eta-6 eta-7))) e-2 '()) eta-5))) (case (vector-ref act-21 0) ((0) (let ((e-4 (vector-ref act-21 1))) (vector 0 e-4))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-22 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 10 (lambda () (string-append "Implementation body: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2566 e-25))) eta-6))) (case (vector-ref act-22 0) ((0) (let ((e-4 (vector-ref act-22 1))) (vector 0 e-4))) (else (let ((act-23 ((CoreC-45Core-traverse_ (lambda (eta-7) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-19 arg-16 arg-18 arg-17 arg-15 '() u--nestC-39 arg-10 eta-7)) e-25) eta-6))) (case (vector-ref act-23 0) ((0) (let ((e-4 (vector-ref act-23 1))) (vector 0 e-4))) (else (let ((act-24 ((CoreC-45Core-traverse_ (lambda (eta-7) (lambda (eta-8) (IdrisC-45ElabC-45Implementation-n--12017-13975-u--addTransform arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-21 u--upds eta-7 eta-8))) (let ((e-4 (vector-ref arg-27 4))) e-4)) eta-6))) (case (vector-ref act-24 0) ((0) (let ((e-4 (vector-ref act-24 1))) (vector 0 e-4))) (else (let ((act-25 (CoreC-45Context-unsetFlag arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (vector 5 ) eta-6))) (case (vector-ref act-25 0) ((0) (let ((e-4 (vector-ref act-25 1))) (vector 0 e-4))) (else ((CoreC-45Context-setOpenHints arg-19 u--hs) eta-6)))))))))))))))) eff-0) eta-5)))))))))))))))))))))) eff-0) eta-4))))))))))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))) eff-0) ext-0))))))))))))))))))
(define IdrisC-45ElabC-45Implementation-case--elabImplementation-16154 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25) (if (null? arg-25) (lambda (eta-0) (CoreC-45Context-ambiguousName arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-25) eta-0)) (let ((e-1 (car arg-25))) (let ((e-2 (cdr arg-25))) (if (null? e-2) (let ((u--cn (Builtin-fst e-1))) (let ((u--cdata (Builtin-snd e-1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-lookupTyExact u--cn (let ((e-0 (vector-ref arg-23 0))) e-0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45Context-undefinedName arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) u--cn clam-0) (let ((e-3 (unbox e-5))) (let ((act-2 (CoreC-45Context-lookupTyExact (let ((e-0 (vector-ref u--cdata 0))) e-0) (let ((e-0 (vector-ref arg-23 0))) e-0) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((_-0 (box e-3))) (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-0 (vector-ref u--cdata 0))) e-0) eta-1)) (let ((e-4 (unbox e-6))) (let ((u--impsp (DataC-45List-nub csegen-22 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (TTImpC-45TTImp-findIBinds eta-1)) arg-4) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (TTImpC-45TTImp-findIBinds eta-1)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-snd eta-1)) arg-6)))))) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-logTerm '() arg-19 "elab.implementation" 3 (lambda () (string-append "Found interface " (CoreC-45Name-u--show_Show_Name u--cn))) e-3 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "\xa;  with params: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (let ((e-11 (vector-ref u--cdata 2))) e-11)) (string-append "\xa;  specialised to: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 arg-4) (string-append "\xa;  and parents: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 (let ((e-10 (vector-ref u--cdata 3))) e-10)) (string-append "\xa;  using implicits: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--impsp) (string-append "\xa;  and methods: " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (IdrisC-45Syntax-u--show_Show_Method u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45Syntax-u--showPrec_Show_Method u--d u--x)))) (let ((e-9 (vector-ref u--cdata 4))) e-9)) (string-append "\xa;" (string-append "\xa;Constructor: " (string-append (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref u--cdata 0))) e-0)) "\xa;")))))))))))))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((act-5 (CoreC-45ContextC-45Log-logTerm '() arg-19 "elab.implementation" 3 (lambda () "Constructor type: ") e-4 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Making implementation " (CoreC-45Name-u--show_Show_Name arg-21))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((u--opts (cond ((equal? arg-3 1) (cons (vector 1 ) '())) (else (cons (vector 1 ) (cons (vector 5 1) '())))))) (let ((u--initTy (IdrisC-45ElabC-45Implementation-bindImpls arg-7 (IdrisC-45ElabC-45Implementation-bindConstraints (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (vector 2 ) arg-6 (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-5) arg-4))))) (let ((act-7 (CoreC-45Context-isUnboundImplicits arg-19 eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--paramBinds (cond ((equal? e-11 1) (TTImpC-45Utils-findBindableNames 1 arg-8 '() u--initTy)) (else '())))) (let ((u--impTy (TTImpC-45BindImplicits-doBind u--paramBinds u--initTy))) (let ((u--impTyDecl (vector 0 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-13 u--opts (vector (vector 2 ) (vector 2 ) arg-21 u--impTy)))) (lambda (eta-2) (let ((act-8 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 5 (lambda () (string-append "Implementation type: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--impTy))) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((act-9 (let ((sc12 (IdrisC-45Syntax-typePass arg-11))) (cond ((equal? sc12 1) (let ((act-9 ((CoreC-45Context-lookupCtxtExactI arg-21 (let ((e-0 (vector-ref arg-23 0))) e-0)) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-13 (vector-ref act-9 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (if (null? e-13) (TTImpC-45ElabC-45Check-processDecl arg-8 arg-19 arg-16 arg-18 arg-17 arg-15 '() arg-9 arg-10 u--impTyDecl) (let ((e-14 (unbox e-13))) (lambda (clam-1) (let ((e-16 (car e-14))) (let ((e-15 (cdr e-14))) (let ((act-10 (TTImpC-45ElabC-45Check-uniVar arg-19 arg-18 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) clam-1))) (case (vector-ref act-10 0) ((0) (let ((e-17 (vector-ref act-10 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-10 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-18 (vector-ref e-15 18))) (case (vector-ref e-18 0) ((0) (let ((act-11 ((TTImpC-45Elab-elabTerm arg-8 arg-19 arg-16 arg-18 arg-17 arg-15 e-16 (vector 0 ) '() arg-9 arg-10 (vector 16 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) csegen-2373 u--impTy) (box (CoreC-45NormaliseC-45Eval-gType (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) e-17))) clam-2))) (case (vector-ref act-11 0) ((0) (let ((e-40 (vector-ref act-11 1))) (vector 0 e-40))) (else (let ((e-40 (vector-ref act-11 1))) ((let ((eff-0 (let ((e-42 (car e-40))) (let ((u--fullty (CoreC-45Env-abstractFullEnvType arg-8 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-10 e-42))) (lambda (eta-3) (let ((act-12 (CoreC-45NormaliseC-45Convert-u--convert_Convert_Term arg-19 '() arg-23 '() u--fullty (let ((e-63 (vector-ref e-15 2))) e-63) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-43 (vector-ref act-12 1))) (vector 0 e-43))) (else (let ((e-43 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-43 1) (vector 1 (vector 0 ))) (else (let ((act-13 (CoreC-45Normalise-logTermNF '() arg-19 "elab.implementation" 1 (lambda () "Previous") '() (let ((e-64 (vector-ref e-15 2))) e-64) clam-3))) (case (vector-ref act-13 0) ((0) (let ((e-44 (vector-ref act-13 1))) (vector 0 e-44))) (else (let ((act-14 (CoreC-45Normalise-logTermNF '() arg-19 "elab.implementation" 1 (lambda () "Now") '() u--fullty clam-3))) (case (vector-ref act-14 0) ((0) (let ((e-45 (vector-ref act-14 1))) (vector 0 e-45))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 1 '() (TTImpC-45TTImp-getFC u--impTy) (let ((e-78 (vector-ref arg-23 0))) e-78) '() u--fullty (let ((e-66 (vector-ref e-15 2))) e-66)) clam-3)))))))))))) eff-0) eta-3)))))))))) eff-0) clam-2))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 39 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21) clam-2))))))) eff-0) clam-1)))))))))))) eff-0) eta-2)))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-9 0) ((0) (let ((e-13 (vector-ref act-9 1))) (vector 0 e-13))) (else (let ((sc13 (IdrisC-45Syntax-defPass arg-11))) (cond ((equal? sc13 1) (if (null? arg-0) (vector 1 (vector 0 )) (let ((e-14 (unbox arg-0))) (let ((act-10 (let ((act-10 (unbox arg-19))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-15 (vector-ref act-10 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-11 (CoreC-45Context-lookupTyExact arg-21 (let ((e-0 (vector-ref e-15 0))) e-0) eta-3))) (case (vector-ref act-11 0) ((0) (let ((e-16 (vector-ref act-11 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-11 1))) ((let ((eff-0 (let ((_-1 (box e-4))) (lambda (clam-4) (if (null? e-16) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Can't happen, can't find type of " (CoreC-45Name-u--show_Show_Name arg-21))) clam-4) (let ((e-17 (unbox e-16))) (let ((act-12 ((IdrisC-45ElabC-45Implementation-getMethImps '() arg-19 '() e-17) clam-4))) (case (vector-ref act-12 0) ((0) (let ((e-18 (vector-ref act-12 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-13 (CoreC-45ContextC-45Log-log arg-19 "elab.implementation" 3 (lambda () (string-append "Bind implicits to each method: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4041 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4041 u--d u--x)))) e-18))) eta-4))) (case (vector-ref act-13 0) ((0) (let ((e-19 (vector-ref act-13 1))) (vector 0 e-19))) (else (let ((_-2 (box e-17))) (IdrisC-45ElabC-45Implementation-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32elabImplementation-17306 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 e-1 u--cn u--cdata e-3 _-0 e-4 _-1 u--impsp u--opts u--initTy e-11 u--paramBinds u--impTy u--impTyDecl e-14 e-15 e-17 _-2 e-18 (IdrisC-45ElabC-45Implementation-addDefaults (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-21 (DataC-45List-u--zip_Zippable_List (let ((e-23 (vector-ref u--cdata 2))) e-23) arg-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (CoreC-45Name-dropNS (let ((e-0 (vector-ref eta-5 0))) e-0))) (let ((e-21 (vector-ref u--cdata 4))) e-21)) (let ((e-20 (vector-ref u--cdata 5))) e-20) e-14) eta-4)))))))) eff-0) clam-4))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) (else (vector 1 (vector 0 ))))))))))))))))) eff-0) eta-1)))))))))))))))))))))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) (lambda (eta-0) (CoreC-45Context-ambiguousName arg-19 (IdrisC-45ElabC-45Implementation-n--12017-13994-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-25) eta-0))))))))
(define IdrisC-45ElabC-45Implementation-elabImplementation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((u--impName_nest (TTImpC-45TTImp-mapNestedName arg-11 arg-17))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-1 u--impName_nest eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-3))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Context-lookupCtxtName arg-14 (let ((e-0 (vector-ref e-7 0))) e-0)) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (IdrisC-45ElabC-45Implementation-case--elabImplementation-16154 arg-19 arg-18 arg-17 arg-16 arg-15 arg-14 arg-13 arg-12 arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--impName_nest e-5 e-6 e-7 e-8 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (u--n) (LibrariesC-45DataC-45ANameMap-lookupName u--n (let ((e-15 (vector-ref e-6 5))) e-15))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) e-8))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define IdrisC-45ElabC-45Interface-getDefault (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (box (cons e-1 (cons '() (cons e-2 e-3))))))))(else '()))))
(define IdrisC-45ElabC-45Interface-getImplParams (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (case (vector-ref e-8 0) ((0) (cons e-2 (IdrisC-45ElabC-45Interface-getImplParams e-4)))(else '()))))(else '()))))))(else '()))))
(define IdrisC-45ElabC-45Interface-namePis (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (case (vector-ref e-3 0) ((2) (if (null? e-4) (vector 1 e-1 e-2 (vector 2 ) (box (vector 2 "i_con" arg-0)) e-5 (IdrisC-45ElabC-45Interface-namePis (bs+ arg-0 1 63) e-6)) (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-namePis arg-0 e-6)))) ((0) (if (null? e-4) (vector 1 e-1 e-2 (vector 0 ) (box (vector 2 "i_imp" arg-0)) e-5 (IdrisC-45ElabC-45Interface-namePis (bs+ arg-0 1 63) e-6)) (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-namePis arg-0 e-6))))(else (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-namePis arg-0 e-6))))))))))) ((16) (let ((e-8 (vector-ref arg-1 1))) (let ((e-9 (vector-ref arg-1 2))) (let ((e-10 (vector-ref arg-1 3))) (vector 16 e-8 e-9 (IdrisC-45ElabC-45Interface-namePis arg-0 e-10))))))(else arg-1))))
(define IdrisC-45ElabC-45Interface-getSig (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-12 (vector-ref e-5 0))) (let ((e-13 (vector-ref e-5 1))) (let ((e-14 (vector-ref e-5 2))) (let ((e-15 (vector-ref e-5 3))) (box (vector e-12 e-2 e-4 e-14 e-13 0 (IdrisC-45ElabC-45Interface-namePis 0 e-15))))))))))) ((1) (let ((e-10 (vector-ref arg-0 4))) (case (vector-ref e-10 0) ((1) (let ((e-17 (vector-ref e-10 1))) (let ((e-18 (vector-ref e-10 2))) (let ((e-19 (vector-ref e-10 3))) (box (vector e-17 csegen-30 (cons (vector 10 ) '()) e-18 CoreC-45FC-emptyFC 1 (IdrisC-45ElabC-45Interface-namePis 0 e-19)))))))(else '()))))(else '()))))
(define IdrisC-45ElabC-45Interface-mkCon (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((u--str (CoreC-45Name-displayUserName e-2))) (vector 0 e-0 (vector 4 (string-append u--str (string-append " at " (CoreC-45FC-u--show_Show_FC arg-0))) (vector 1 (vector 0 (string-append "__mk" u--str))))))))(else (let ((u--str (CoreC-45Name-u--show_Show_Name arg-1))) (vector 4 (string-append u--str (string-append " at " (CoreC-45FC-u--show_Show_FC arg-0))) (vector 1 (vector 0 (string-append "__mk" u--str))))))))))(else (let ((u--str (CoreC-45Name-u--show_Show_Name arg-1))) (vector 4 (string-append u--str (string-append " at " (CoreC-45FC-u--show_Show_FC arg-0))) (vector 1 (vector 0 (string-append "__mk" u--str)))))))))
(define IdrisC-45ElabC-45Interface-sigToDecl (lambda (arg-0) (vector (let ((e-3 (vector-ref arg-0 3))) e-3) (let ((e-1 (vector-ref arg-0 1))) e-1) (let ((e-2 (vector-ref arg-0 2))) e-2) (let ((e-5 (vector-ref arg-0 5))) e-5) (let ((e-6 (vector-ref arg-0 6))) e-6))))
(define IdrisC-45ElabC-45Interface-n--13383-3368-u--findSetTotal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) '() (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((11) (let ((e-5 (vector-ref e-2 1))) (box e-5)))(else (IdrisC-45ElabC-45Interface-n--13383-3368-u--findSetTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3))))))))
(define IdrisC-45ElabC-45Interface-n--13383-3369-u--totMeth (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--treq (IdrisC-45ElabC-45Interface-n--13383-3368-u--findSetTotal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (let ((e-2 (vector-ref arg-9 2))) e-2)))) (lambda (eta-0) (vector 1 (vector (let ((e-0 (vector-ref arg-9 0))) e-0) (let ((e-1 (vector-ref arg-9 1))) e-1) u--treq (let ((e-4 (vector-ref arg-9 4))) e-4)))))))
(define IdrisC-45ElabC-45Interface-updateIfaceSyn (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--13383-3369-u--totMeth arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) arg-7 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--info (vector arg-3 arg-4 arg-5 arg-6 e-5 arg-8))) (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-1))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-13 (vector-ref e-6 5))) (let ((e-12 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (vector e-0 e-1 e-2 e-3 (cons arg-2 e-4) (LibrariesC-45DataC-45ANameMap-addName arg-2 u--info e-13) e-12 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-3))))) eff-1) world-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45ElabC-45Interface-n--12475-2520-u--stripParams (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((e-3 (vector-ref arg-11 3))) (let ((e-4 (vector-ref arg-11 4))) (let ((e-5 (vector-ref arg-11 5))) (let ((e-6 (vector-ref arg-11 6))) (let ((sc1 (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (u--n) (PreludeC-45Types-elem csegen-14 csegen-832 u--n arg-10))) e-4))) (cond ((equal? sc1 1) (IdrisC-45ElabC-45Interface-n--12475-2520-u--stripParams arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6)) (else (vector 1 e-1 e-2 e-3 e-4 e-5 (IdrisC-45ElabC-45Interface-n--12475-2520-u--stripParams arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6))))))))))))(else arg-11))))
(define IdrisC-45ElabC-45Interface-getMethDecl (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--paramNames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-5))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-2 (vector 2 ) '() (PreludeC-45TypesC-45List-tailRecAppend u--paramNames (PreludeC-45TypesC-45List-tailRecAppend arg-6 arg-1)) e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-6 (cons e-2 (IdrisC-45ElabC-45Interface-n--12475-2520-u--stripParams arg-2 e-2 e-6 e-7 arg-6 arg-5 arg-1 arg-4 arg-3 u--paramNames e-5))))))) eff-0) eta-0)))))))))))))
(define IdrisC-45ElabC-45Interface-mkDataTy (lambda (arg-0 arg-1) (if (null? arg-1) (vector 29 arg-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-11 (cdr e-7))) (vector 1 arg-0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-6) e-11 (IdrisC-45ElabC-45Interface-mkDataTy arg-0 e-3))))))))))
(define IdrisC-45ElabC-45Interface-n--12106-2171-u--bhere (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons e-2 (cons e-6 (vector 16 (TTImpC-45TTImp-getFC e-7) csegen-2373 e-7)))))))))
(define IdrisC-45ElabC-45Interface-n--12106-2172-u--bname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (box e-2) (cons e-6 (vector 16 (TTImpC-45TTImp-getFC e-7) csegen-2373 e-7)))))))))
(define IdrisC-45ElabC-45Interface-n--12106-2173-u--jname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (cons (box e-2) (cons e-6 e-7))))))))
(define IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (CoreC-45FC-virtualiseFC arg-9)))
(define IdrisC-45ElabC-45Interface-n--12106-2174-u--mkTy (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-12) arg-13 (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) e-10 arg-11 e-6 e-11 (IdrisC-45ElabC-45Interface-n--12106-2174-u--mkTy arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3 arg-13)))))))))))
(define IdrisC-45ElabC-45Interface-mkIfaceData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--opts (let ((sc0 (DataC-45List-isNil arg-9))) (cond ((equal? sc0 1) (cons (vector 1 ) (cons (vector 2 ) '()))) (else (cons (vector 1 ) (cons (vector 2 ) (cons (vector 0 arg-9) '())))))))) (let ((u--pNames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-8))) (let ((u--retty (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 0 (vector 2 ) eta-0)) u--pNames)))) (let ((u--conty (IdrisC-45ElabC-45Interface-n--12106-2174-u--mkTy arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 (vector 0 ) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--12106-2173-u--jname arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-8) (IdrisC-45ElabC-45Interface-n--12106-2174-u--mkTy arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 (vector 2 ) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--12106-2171-u--bhere arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-5) (IdrisC-45ElabC-45Interface-n--12106-2174-u--mkTy arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 (vector 1 ) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--12106-2172-u--bname arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1 eta-0)) arg-10) u--retty))))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-2 '() (PreludeC-45TypesC-45List-tailRecAppend u--pNames (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-10) arg-0)) u--conty eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--con (vector (IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) (vector 2 ) arg-7 e-5))) (let ((u--bound (PreludeC-45TypesC-45List-tailRecAppend u--pNames (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-10) arg-0)))) (lambda (eta-1) (let ((act-2 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-2 '() u--bound (IdrisC-45ElabC-45Interface-mkDataTy (IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-8) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 (IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-3 '() (vector 0 (IdrisC-45ElabC-45Interface-n--12106-2175-u--vfc arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-0 arg-4 arg-3 arg-2 arg-1) arg-6 (box e-6) u--opts (cons u--con '()))))))) eff-0) eta-1)))))))))) eff-0) eta-0))))))))))))
(define TTImpC-45ProcessDecls-processDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-6 arg-7 eta-0)) arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 1))))))
(define IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (CoreC-45FC-virtualiseFC arg-10)))
(define IdrisC-45ElabC-45Interface-n--13578-3578-u--elabAsData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (u--meth) (IdrisC-45ElabC-45Interface-getMethDecl arg-6 arg-15 arg-8 arg-7 arg-3 arg-17 (cons (let ((e-1 (vector-ref u--meth 1))) e-1) (cons (let ((e-3 (vector-ref u--meth 3))) e-3) (let ((e-6 (vector-ref u--meth 6))) e-6))))) arg-18 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-15 "elab.interface" 5 (lambda () (string-append "Method declarations: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4002 e-5))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45ElabC-45Interface-getMethDecl arg-6 arg-15 arg-8 arg-7 arg-3 arg-17 (cons AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega eta-1))) arg-5 '()) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-log arg-15 "elab.interface" 5 (lambda () (string-append "Constraints: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4003 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4003 u--d u--x)))) e-7))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((IdrisC-45ElabC-45Interface-mkIfaceData arg-6 arg-15 (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) arg-9 arg-8 e-7 arg-4 arg-16 arg-3 arg-2 e-5) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (CoreC-45ContextC-45Log-log arg-15 "elab.interface" 10 (lambda () (string-append "Methods: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4002 e-5))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45ContextC-45Log-log arg-15 "elab.interface" 5 (lambda () (string-append "Making interface data type " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 csegen-65 e-9))) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (TTImpC-45ProcessDecls-processDecls arg-6 arg-15 arg-12 arg-14 arg-13 arg-11 arg-7 arg-8 (cons e-9 '()) eta-3)) eta-2)))))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define IdrisC-45ElabC-45Interface-n--13100-3103-u--bindName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (case (vector-ref arg-12 0) ((1) (let ((e-0 (vector-ref arg-12 1))) (string-append "__bind_" (CoreC-45Name-displayUserName e-0)))) ((0) (let ((e-2 (vector-ref arg-12 2))) (IdrisC-45ElabC-45Interface-n--13100-3103-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2)))(else (CoreC-45Name-u--show_Show_Name arg-12)))))
(define IdrisC-45ElabC-45Interface-n--13100-3104-u--constName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (vector 1 (vector 0 (IdrisC-45ElabC-45Interface-n--13100-3103-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12)))))
(define IdrisC-45ElabC-45Interface-n--13100-3105-u--impsBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (if (null? arg-13) arg-12 (let ((e-2 (car arg-13))) (let ((e-3 (cdr arg-13))) (IdrisC-45ElabC-45Interface-n--13100-3105-u--impsBind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 (vector 9 arg-10 arg-12 (vector 17 arg-10 e-2)) e-3))))))
(define IdrisC-45ElabC-45Interface-getConstraintHint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((u--ity (TTImpC-45TTImp-apply (vector 0 arg-2 arg-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 0 arg-2 eta-0)) arg-9)))) (let ((u--fty (vector 1 arg-2 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) '() u--ity e-3))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-1 arg-2 '() (PreludeC-45TypesC-45List-tailRecAppend arg-8 arg-0) u--fty eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--hintname (vector 4 (string-append "Constraint " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-3)) (vector 1 (vector 0 (string-append "__" (string-append (CoreC-45Name-u--show_Show_Name arg-5) (string-append "_" (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-3))))))))) (let ((u--tydecl (vector 0 arg-2 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega arg-4 (cons (vector 1 ) (cons (vector 5 0) '())) (vector (vector 2 ) (vector 2 ) u--hintname e-5)))) (let ((u--conapp (TTImpC-45TTImp-apply (IdrisC-45ElabC-45Interface-n--13100-3105-u--impsBind e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-0 arg-3 arg-2 arg-1 (vector 0 arg-2 arg-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45ElabC-45Interface-n--13100-3103-u--bindName e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-0 arg-3 arg-2 arg-1 eta-1)) arg-7)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 32 arg-2 1)) arg-8)))) (let ((u--fnclause (vector 0 arg-2 (vector 8 arg-2 (vector 0 arg-2 u--hintname) u--conapp) (vector 0 arg-2 (IdrisC-45ElabC-45Interface-n--13100-3104-u--constName e-2 e-3 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-0 arg-3 arg-2 arg-1 e-2))))) (let ((u--fndef (vector 2 arg-2 u--hintname (cons u--fnclause '())))) (lambda (eta-1) (vector 1 (cons u--hintname (cons u--tydecl (cons u--fndef '())))))))))))) eff-0) eta-0))))))))))))
(define IdrisC-45ElabC-45Interface-n--13578-3582-u--nameCons (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (if (null? arg-17) '() (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((e-7 (cdr e-2))) (cons (cons (vector 1 (vector 0 (string-append "__con" (PreludeC-45Show-u--show_Show_Int arg-16)))) e-7) (IdrisC-45ElabC-45Interface-n--13578-3582-u--nameCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 (bs+ arg-16 1 63) e-3))))))))
(define IdrisC-45ElabC-45Interface-n--13578-3583-u--paramNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-3)))
(define IdrisC-45ElabC-45Interface-n--13578-3579-u--elabConstraintHints (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((u--nconstraints (IdrisC-45ElabC-45Interface-n--13578-3582-u--nameCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 0 arg-5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45ElabC-45Interface-getConstraintHint arg-6 arg-15 (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) arg-8 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 arg-9) arg-4 arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) u--nconstraints) arg-17 (IdrisC-45ElabC-45Interface-n--13578-3583-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) eta-1)) u--nconstraints '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-15 "elab.interface" 5 (lambda () (string-append "Constraint hints from " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3984 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3984 u--d u--x)))) arg-5) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3991 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3991 u--d u--x)))) e-5))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (TTImpC-45ElabC-45Check-processDecl arg-6 arg-15 arg-12 arg-14 arg-13 arg-11 '() arg-7 arg-8 eta-2)) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) (Builtin-snd eta-2)) e-5)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-2) (let ((act-4 (CoreC-45Context-inCurrentNS arg-15 u--n eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Context-setFlag arg-15 (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) e-8 (vector 5 ) eta-3)))) eff-0) eta-2))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-5)) eta-1)))))))))) eff-0) eta-0)))))))))
(define IdrisC-45ElabC-45Interface-bindIFace (lambda (arg-0 arg-1 arg-2) (vector 1 arg-0 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 2 ) (box (vector 1 (vector 0 "__con"))) arg-1 arg-2)))
(define IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) (CoreC-45FC-virtualiseFC arg-16)))
(define IdrisC-45ElabC-45Interface-n--13662-3969-u--applyParams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (if (null? arg-22) arg-21 (let ((e-2 (car arg-22))) (let ((e-3 (cdr arg-22))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (IdrisC-45ElabC-45Interface-n--13662-3969-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 (vector 10 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) arg-21 (vector 1 (vector 0 e-5)) (vector 17 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20) e-5)) e-3)))(else (IdrisC-45ElabC-45Interface-n--13662-3969-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-3)))))(else (IdrisC-45ElabC-45Interface-n--13662-3969-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-3))))))))
(define IdrisC-45ElabC-45Interface-n--13662-3970-u--bindPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (if (null? arg-21) arg-22 (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (TTImpC-45TTImp-getFC e-11) e-10 (vector 0 ) (box e-6) e-11 (IdrisC-45ElabC-45Interface-n--13662-3970-u--bindPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-3 arg-22)))))))))))
(define IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (lambda (clam-0) (case (vector-ref arg-22 0) ((0) (let ((e-1 (vector-ref arg-22 1))) (let ((e-2 (vector-ref arg-22 2))) (let ((sc1 (CoreC-45Name-u--C-47C-61_Eq_Name arg-18 e-2))) (cond ((equal? sc1 1) (vector 1 (vector 0 e-1 e-2))) (else (let ((act-1 (CoreC-45ContextC-45Log-log arg-15 "ide-mode.highlight" 7 (lambda () (string-append "elabDefault is trying to add Function: " (string-append (CoreC-45Name-u--show_Show_Name arg-18) (string-append " (" (string-append (CoreC-45FC-u--show_Show_FC e-1) ")"))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (let ((sc3 (CoreC-45FC-isConcreteFC e-1))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-3 (unbox sc3))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-15 "ide-mode.highlight" 7 (lambda () (string-append "elabDefault is adding Function: " (CoreC-45Name-u--show_Show_Name arg-18))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (CoreC-45Metadata-addSemanticDecorations arg-12 arg-15 (cons (cons e-3 (cons 2 (box arg-18))) '()) clam-0))))))))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (vector 0 e-1 arg-21)))))))))))))) ((8) (let ((e-4 (vector-ref arg-22 1))) (let ((e-5 (vector-ref arg-22 2))) (let ((e-6 (vector-ref arg-22 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 8 e-4 e-7 eta-2))))))) (IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-5) eta-0)) (lambda (eta-0) (vector 1 e-6)) clam-0))))) ((9) (let ((e-8 (vector-ref arg-22 1))) (let ((e-9 (vector-ref arg-22 2))) (let ((e-10 (vector-ref arg-22 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 9 e-8 e-5 eta-2))))))) (IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-9) eta-0)) (lambda (eta-0) (vector 1 e-10)) clam-0))))) ((10) (let ((e-12 (vector-ref arg-22 1))) (let ((e-13 (vector-ref arg-22 2))) (let ((e-14 (vector-ref arg-22 3))) (let ((e-15 (vector-ref arg-22 4))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-2 1))) (vector 1 (lambda (eta-3) (lambda (eta-4) (vector 10 e-12 e-5 eta-3 eta-4)))))))) (IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-13) eta-1)) (lambda (eta-1) (vector 1 e-14)) eta-0)) (lambda (eta-0) (vector 1 e-15)) clam-0))))))(else (vector 1 arg-22))))))
(define IdrisC-45ElabC-45Interface-n--13662-3971-u--changeName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 ext-0) (case (vector-ref arg-22 0) ((0) (let ((e-1 (vector-ref arg-22 1))) (let ((e-2 (vector-ref arg-22 2))) (let ((e-3 (vector-ref arg-22 3))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (lambda (eta-2) (vector 0 e-1 e-5 eta-2))))))) (IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-2) eta-0)) (lambda (eta-0) (vector 1 e-3)) ext-0))))) ((1) (let ((e-5 (vector-ref arg-22 1))) (let ((e-6 (vector-ref arg-22 2))) (let ((e-7 (vector-ref arg-22 3))) (let ((e-8 (vector-ref arg-22 4))) (let ((e-9 (vector-ref arg-22 5))) (let ((e-10 (vector-ref arg-22 6))) (let ((e-11 (vector-ref arg-22 7))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-5) (case (vector-ref eta-5 0) ((0) (let ((e-2 (vector-ref eta-5 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref eta-5 1))) (vector 1 (lambda (eta-6) (lambda (eta-7) (lambda (eta-8) (lambda (eta-9) (lambda (eta-10) (vector 1 e-5 e-12 eta-6 eta-7 eta-8 eta-9 eta-10))))))))))) (IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-6) eta-4)) (lambda (eta-4) (vector 1 e-7)) eta-3)) (lambda (eta-3) (vector 1 e-8)) eta-2)) (lambda (eta-2) (vector 1 e-9)) eta-1)) (lambda (eta-1) (vector 1 e-10)) eta-0)) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45ElabC-45Interface-n--13662-3971-u--changeName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 eta-0 eta-1))) e-11 '()) ext-0))))))))) (else (let ((e-13 (vector-ref arg-22 1))) (let ((e-14 (vector-ref arg-22 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (vector 2 e-13 e-5)))))) (IdrisC-45ElabC-45Interface-n--13662-3972-u--changeNameTerm arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 e-14) ext-0)))))))
(define IdrisC-45ElabC-45Interface-case--elabInterfaceC-44elabDefault-4382 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 ext-0) (if (null? arg-23) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-16 (string-append "No method named " (string-append (CoreC-45Name-u--show_Show_Name arg-18) (string-append " in interface " (CoreC-45Name-u--show_Show_Name arg-4))))) ext-0) (let ((e-1 (unbox arg-23))) (vector 1 (cons (let ((e-5 (vector-ref e-1 1))) e-5) (let ((e-4 (vector-ref e-1 4))) e-4)))))))
(define IdrisC-45ElabC-45Interface-n--13578-3580-u--elabDefault (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((e-2 (car arg-17))) (let ((e-3 (cdr arg-17))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--dn_in (vector 2 (string-append "Default implementation of " (CoreC-45Name-u--show_Show_Name e-10)) 0))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-inCurrentNS arg-15 u--dn_in eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45ElabC-45Interface-case--elabInterfaceC-44elabDefault-4382 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16 u--dn_in e-5 (LibrariesC-45DataC-45ListC-45Extra-findBy (lambda (u--d) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) u--d) (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Name-u--C-61C-61_Eq_Name e-10 (let ((e-0 (vector-ref u--d 0))) e-0))))) arg-16) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((e-9 (car e-8))) (let ((e-4 (cdr e-8))) (let ((u--ity (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16) arg-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (vector 0 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16) eta-2)) (IdrisC-45ElabC-45Interface-n--13578-3583-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15))))) (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (u--d) (let ((u--n (let ((e-0 (vector-ref u--d 0))) e-0))) (lambda (eta-3) (let ((act-3 (CoreC-45Context-inCurrentNS arg-15 u--n eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons u--n (IdrisC-45ElabC-45Interface-n--13662-3969-u--applyParams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16 (vector 0 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16) e-12) (IdrisC-45ElabC-45Interface-n--13578-3583-u--paramNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15))))))) eff-0) eta-3)))))))) arg-16 '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--dty (IdrisC-45ElabC-45Interface-n--13662-3970-u--bindPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16 arg-3 (IdrisC-45ElabC-45Interface-bindIFace (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16) u--ity (TTImpC-45Utils-substNames arg-6 e-12 e-4))))) (lambda (eta-3) (let ((act-4 (TTImpC-45BindImplicits-bindTypeNames arg-15 e-2 '() (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() csegen-3983 arg-16) arg-6) u--dty eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45ContextC-45Log-log arg-15 "elab.interface.default" 5 (lambda () (string-append "Default method " (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-13))))) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-14 (vector-ref act-5 1))) (vector 0 e-14))) (else (let ((u--dtydecl (vector 0 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16) e-9 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 arg-9) '() (vector (vector 2 ) (vector 2 ) e-5 e-13)))) (let ((act-6 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-15 arg-12 arg-14 arg-13 arg-11 '() arg-7 arg-8 u--dtydecl) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-15 (vector-ref act-6 1))) (vector 0 e-15))) (else (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (lambda (eta-6) (IdrisC-45ElabC-45Interface-n--13662-3971-u--changeName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16 e-5 eta-5 eta-6))) e-11 '()) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-16 (vector-ref act-7 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 (CoreC-45ContextC-45Log-log arg-15 "elab.interface.default" 5 (lambda () (string-append "Default method body " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2025 e-16))) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-17 (vector-ref act-8 1))) (vector 0 e-17))) (else (let ((act-9 ((TTImpC-45ElabC-45Check-processDecl arg-6 arg-15 arg-12 arg-14 arg-13 arg-11 '() arg-7 arg-8 (vector 2 (IdrisC-45ElabC-45Interface-n--13662-3973-u--vdfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 e-2 e-6 e-10 e-11 arg-16) e-5 e-16)) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-18 (vector-ref act-9 1))) (vector 0 e-18))) (else (vector 1 (cons e-10 e-11))))))))))) eff-0) eta-4))))))))))))))) eff-0) eta-3))))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))
(define IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (CoreC-45FC-virtualiseFC (let ((e-0 (vector-ref arg-0 0))) e-0))))
(define IdrisC-45ElabC-45Interface-n--12705-2719-u--applyCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (let ((u--name (vector 1 (vector 0 "__con")))) (cons arg-10 (vector 10 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) arg-10) u--name (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) u--name))))))
(define IdrisC-45ElabC-45Interface-n--12705-2720-u--bindName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-0 (vector-ref arg-10 1))) (string-append "__bind_" (CoreC-45Name-displayUserName e-0)))) ((0) (let ((e-2 (vector-ref arg-10 2))) (IdrisC-45ElabC-45Interface-n--12705-2720-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2)))(else (CoreC-45Name-u--show_Show_Name arg-10)))))
(define IdrisC-45ElabC-45Interface-n--12705-2721-u--bindPs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (vector 1 (TTImpC-45TTImp-getFC e-11) e-10 (vector 0 ) (box e-6) e-11 (IdrisC-45ElabC-45Interface-n--12705-2721-u--bindPs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))))))
(define IdrisC-45ElabC-45Interface-n--12705-2722-u--getExplicitArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((1) (let ((e-3 (vector-ref arg-11 3))) (let ((e-6 (vector-ref arg-11 6))) (case (vector-ref e-3 0) ((1) (cons (vector 2 "arg" arg-10) (IdrisC-45ElabC-45Interface-n--12705-2722-u--getExplicitArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 (bs+ arg-10 1 63) e-6)))(else (IdrisC-45ElabC-45Interface-n--12705-2722-u--getExplicitArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-6))))))(else '()))))
(define IdrisC-45ElabC-45Interface-n--12705-2723-u--methName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (vector 1 (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2720-u--bindName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10)))))
(define IdrisC-45ElabC-45Interface-n--12705-2724-u--mkLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-10) arg-11 (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (vector 2 (vector 2 ) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (box e-2) (vector 32 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) 0) (IdrisC-45ElabC-45Interface-n--12705-2724-u--mkLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11)))))))
(define IdrisC-45ElabC-45Interface-getMethToplevel (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((u--paramNames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) arg-8))) (let ((u--ity (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) arg-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 0 (vector 2 ) eta-0)) u--paramNames)))) (let ((u--ty_constr (TTImpC-45Utils-substNames arg-0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Interface-n--12705-2719-u--applyCon arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 eta-0)) arg-7) (let ((e-6 (vector-ref arg-9 6))) e-6)))) (lambda (eta-0) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-1 (vector 2 ) '() arg-0 (IdrisC-45ElabC-45Interface-n--12705-2721-u--bindPs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 arg-8 (IdrisC-45ElabC-45Interface-bindIFace (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) u--ity u--ty_constr)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-inCurrentNS arg-1 (let ((e-3 (vector-ref arg-9 3))) e-3) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--tydecl (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (let ((e-1 (vector-ref arg-9 1))) e-1) arg-3 (let ((sc2 (let ((e-8 (vector-ref arg-9 5))) e-8))) (cond ((equal? sc2 1) (cons (vector 1 ) (cons (vector 10 ) '()))) (else (cons (vector 1 ) '())))) (vector (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (let ((e-4 (vector-ref arg-9 4))) e-4) e-6 e-5)))) (let ((u--conapp (TTImpC-45TTImp-apply (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) arg-5) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (vector 17 (vector 2 ) eta-2)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (IdrisC-45ElabC-45Interface-n--12705-2720-u--bindName arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 eta-2)) arg-7))))) (let ((u--argns (IdrisC-45ElabC-45Interface-n--12705-2722-u--getExplicitArgs arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 0 (let ((e-7 (vector-ref arg-9 6))) e-7)))) (let ((u--fnclause (vector 0 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (vector 10 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) (vector 0 (let ((e-0 (vector-ref arg-9 0))) e-0) e-6) (vector 1 (vector 0 "__con")) u--conapp) (IdrisC-45ElabC-45Interface-n--12705-2724-u--mkLam arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 u--argns (TTImpC-45TTImp-apply (vector 0 (vector 2 ) (IdrisC-45ElabC-45Interface-n--12705-2723-u--methName arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1 (let ((e-3 (vector-ref arg-9 3))) e-3))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (vector 0 (vector 2 ) eta-2)) u--argns)))))) (let ((u--fndef (vector 2 (IdrisC-45ElabC-45Interface-n--12705-2725-u--vfc arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-0 arg-2 arg-1) e-6 (cons u--fnclause '())))) (lambda (eta-2) (vector 1 (cons u--tydecl (cons u--fndef '()))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define IdrisC-45ElabC-45Interface-n--13578-3581-u--elabMethods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ElabC-45Interface-getMethToplevel arg-6 arg-15 arg-8 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 arg-9) arg-4 arg-16 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) arg-5) arg-17 arg-3 eta-0)) arg-18 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fns (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) e-5))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-15 "elab.interface" 5 (lambda () (string-append "Top level methods: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2566 u--fns))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl arg-6 arg-15 arg-12 arg-14 arg-13 arg-11 '() arg-7 arg-8 eta-1)) u--fns) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45Core-traverse_ (lambda (u--n) (lambda (eta-1) (let ((act-4 (CoreC-45Context-inCurrentNS arg-15 u--n eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Context-setFlag arg-15 (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) e-8 (vector 0 ) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45Context-setFlag arg-15 (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) e-8 (vector 5 ) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (CoreC-45Context-setFlag arg-15 (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) e-8 (vector 4 ) eta-2)))))))))) eff-0) eta-1))))))) arg-17) eta-0))))))))))) eff-0) ext-0)))))))
(define IdrisC-45ElabC-45Interface-elabInterface (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-1 (CoreC-45Context-getFullName arg-1 arg-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-inCurrentNS arg-1 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--conName_in (PreludeC-45Types-maybe (lambda () (IdrisC-45ElabC-45Interface-mkCon (IdrisC-45ElabC-45Interface-n--13578-3584-u--vfc arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) e-5)) (lambda () (lambda (eta-1) (Builtin-snd eta-1))) arg-14))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-inCurrentNS arg-1 u--conName_in eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((sc3 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-3) (Builtin-fst eta-3)) arg-14))) (if (null? sc3) (vector 1 (vector 0 )) (let ((e-1 (unbox sc3))) (IdrisC-45DocC-45String-addDocString arg-1 arg-3 e-7 e-1 eta-2)))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--meth_sigs (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-3) (IdrisC-45ElabC-45Interface-getSig eta-3)) arg-15))) (let ((u--meth_decls (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (IdrisC-45ElabC-45Interface-sigToDecl eta-3)) u--meth_sigs))) (let ((u--meth_names (PreludeC-45TypesC-45List-mapAppend '() csegen-3983 u--meth_decls))) (let ((u--defaults (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-3) (IdrisC-45ElabC-45Interface-getDefault eta-3)) arg-15))) (let ((act-5 (IdrisC-45ElabC-45Interface-n--13578-3578-u--elabAsData arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 u--meth_names u--meth_sigs eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((IdrisC-45ElabC-45Interface-n--13578-3579-u--elabConstraintHints arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 u--meth_names) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (IdrisC-45ElabC-45Interface-n--13578-3581-u--elabMethods arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-7 u--meth_names u--meth_sigs eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (IdrisC-45ElabC-45Interface-n--13578-3580-u--elabDefault arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--meth_decls eta-3)) u--defaults '()) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 ((CoreC-45Core-traverseC-39 (lambda (u--mt) (lambda (eta-4) (let ((act-9 (CoreC-45Context-inCurrentNS arg-1 (let ((e-0 (vector-ref u--mt 0))) e-0) eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (let ((e-1 (vector-ref u--mt 1))) (let ((e-2 (vector-ref u--mt 2))) (let ((e-3 (vector-ref u--mt 3))) (let ((e-4 (vector-ref u--mt 4))) (vector e-13 e-1 e-2 e-3 e-4))))))))) eff-0) eta-4))))))) u--meth_decls '()) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-10 (let ((act-10 (unbox arg-1))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-11 (CoreC-45Context-lookupTyExact e-6 (let ((e-0 (vector-ref e-14 0))) e-0) eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (if (null? e-15) (lambda (eta-6) (CoreC-45Context-undefinedName arg-1 arg-6 arg-11 eta-6)) (let ((e-1 (unbox e-15))) (let ((u--implParams (IdrisC-45ElabC-45Interface-getImplParams e-1))) (lambda (eta-6) (IdrisC-45ElabC-45Interface-updateIfaceSyn arg-1 arg-3 e-6 e-7 u--implParams (IdrisC-45ElabC-45Interface-n--13578-3583-u--paramNames arg-15 arg-14 arg-13 arg-12 arg-11 arg-10 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-7) (Builtin-snd eta-7)) arg-10) e-13 e-12 eta-6))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))))))))))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45IMaybe-fromJust (lambda (arg-1) (let ((e-1 (unbox arg-1))) e-1)))
(define CoreC-45Context-hideName (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 (LibrariesC-45DataC-45NameMap-insert arg-0 (vector 0 ) e-10) e-11)))))))))))))))
(define CoreC-45Context-hide (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-8 (car e-1))) (lambda (clam-0) (if (null? e-2) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-38 (vector-ref e-5 1))) (let ((e-37 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-36 (vector-ref e-5 5))) (let ((e-35 (vector-ref e-5 6))) (let ((e-34 (vector-ref e-5 7))) (let ((e-33 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector (CoreC-45Context-hideName e-8 e-0) e-38 e-37 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3)) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45ElabC-45Implementation-n--11499-13393-u--toForward (lambda (arg-0) (cond ((equal? arg-0 #\\) #\/)(else arg-0))))
(define IdrisC-45ElabC-45Implementation-replaceSep (lambda (ext-0) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45ElabC-45Implementation-n--11499-13393-u--toForward eta-0)) (PreludeC-45Types-fastUnpack ext-0)))))
(define IdrisC-45ElabC-45Implementation-mkImplName (lambda (arg-0 arg-1 arg-2) (vector 4 (string-append (CoreC-45Name-u--show_Show_Name arg-1) (string-append " implementation at " (IdrisC-45ElabC-45Implementation-replaceSep (CoreC-45FC-u--show_Show_FC arg-0)))) (vector 1 (vector 0 (string-append "__Impl_" (string-append (CoreC-45Name-u--show_Show_Name arg-1) (string-append "_" (CoreC-45NameC-45Namespace-showSep "_" (PreludeC-45TypesC-45List-mapAppend '() csegen-2610 arg-2))))))))))
(define LibrariesC-45DataC-45UserNameMap-adjust (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45DataC-45UserNameMap-lookup arg-1 arg-3))) (if (null? sc0) arg-3 (let ((e-2 (unbox sc0))) (LibrariesC-45DataC-45UserNameMap-insert arg-1 (arg-2 e-2) arg-3))))))
(define LibrariesC-45DataC-45ANameMap-n--4201-12926-u--deleteFromList (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (LibrariesC-45DataC-45UserNameMap-adjust arg-5 (lambda (eta-0) (PreludeC-45TypesC-45List-filterAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((sc1 (CoreC-45Name-matches e-2 arg-4))) (cond ((equal? sc1 1) 0) (else 1))))) eta-0)) ext-0)))
(define LibrariesC-45DataC-45ANameMap-removeExact (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (let ((u--dictC-39 (LibrariesC-45DataC-45NameMap-delete arg-2 e-1))) (let ((u--nC-39 (CoreC-45Name-userNameRoot arg-2))) (let ((u--hierC-39 (PreludeC-45Types-maybe (lambda () e-2) (lambda () (lambda (u--foundName) (LibrariesC-45DataC-45ANameMap-n--4201-12926-u--deleteFromList arg-1 e-2 e-1 arg-2 u--foundName e-2))) u--nC-39))) (cons u--dictC-39 u--hierC-39))))))))
(define IdrisC-45Syntax-u--show_Show_FixityInfo (lambda (arg-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "fc: " (cons (CoreC-45FC-u--show_Show_FC (let ((e-0 (vector-ref arg-0 0))) e-0)) (cons ", visibility: " (cons (CoreC-45TT-u--show_Show_Visibility (let ((e-1 (vector-ref arg-0 1))) e-1)) (cons ", fixity: " (cons (IdrisC-45Syntax-u--show_Show_Fixity (let ((e-2 (vector-ref arg-0 2))) e-2)) (cons ", precedence: " (cons (PreludeC-45Show-u--show_Show_Nat (let ((e-3 (vector-ref arg-0 3))) e-3)) '())))))))))))
(define IdrisC-45Syntax-u--showPrec_Show_FixityInfo (lambda (arg-0 arg-1) (IdrisC-45Syntax-u--show_Show_FixityInfo arg-1)))
(define IdrisC-45Syntax-removeFixity (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector (LibrariesC-45DataC-45ANameMap-removeExact (cons (lambda (u--x) (IdrisC-45Syntax-u--show_Show_FixityInfo u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45Syntax-u--showPrec_Show_FixityInfo u--d u--x)))) arg-2 e-0) e-1 e-2 e-3 e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setAmbigLimit (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-50 (vector-ref e-36 0))) (let ((e-44 (vector-ref e-36 1))) (let ((e-45 (vector-ref e-36 2))) (let ((e-47 (vector-ref e-36 4))) (let ((e-48 (vector-ref e-36 5))) (let ((e-49 (vector-ref e-36 6))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector e-50 e-44 e-45 arg-1 e-47 e-48 e-49) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setAutoImplicitLimit (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-50 (vector-ref e-36 0))) (let ((e-44 (vector-ref e-36 1))) (let ((e-45 (vector-ref e-36 2))) (let ((e-46 (vector-ref e-36 3))) (let ((e-48 (vector-ref e-36 5))) (let ((e-49 (vector-ref e-36 6))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector e-50 e-44 e-45 e-46 arg-1 e-48 e-49) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setExtension (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 (cons arg-0 e-7) e-8 e-9)))))))))))))
(define CoreC-45Context-setExtension (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setExtension arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromChar (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-13 (vector-ref e-6 3))) (let ((e-14 (vector-ref e-6 4))) (let ((e-15 (vector-ref e-6 5))) (let ((e-16 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 (box arg-0) e-13 e-14 e-15 e-16) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromChar (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromChar arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromDecls (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (let ((e-14 (vector-ref e-6 4))) (let ((e-15 (vector-ref e-6 5))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 e-12 e-13 e-14 e-15 (box arg-0)) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromDecls (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromDecls arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromDouble (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-14 (vector-ref e-6 4))) (let ((e-15 (vector-ref e-6 5))) (let ((e-16 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 e-12 (box arg-0) e-14 e-15 e-16) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromDouble (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromDouble arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromInteger (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (let ((e-14 (vector-ref e-6 4))) (let ((e-15 (vector-ref e-6 5))) (let ((e-16 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector (box arg-0) e-11 e-12 e-13 e-14 e-15 e-16) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromInteger (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromInteger arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromName (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (let ((e-14 (vector-ref e-6 4))) (let ((e-16 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 e-12 e-13 e-14 (box arg-0) e-16) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromName (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromName arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromString (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (let ((e-14 (vector-ref e-6 4))) (let ((e-15 (vector-ref e-6 5))) (let ((e-16 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 (box arg-0) e-12 e-13 e-14 e-15 e-16) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromString (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromString arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setFromTTImp (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (let ((e-10 (vector-ref e-6 0))) (let ((e-11 (vector-ref e-6 1))) (let ((e-12 (vector-ref e-6 2))) (let ((e-13 (vector-ref e-6 3))) (let ((e-15 (vector-ref e-6 5))) (let ((e-16 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 (vector e-10 e-11 e-12 e-13 (box arg-0) e-15 e-16) e-7 e-8 e-9)))))))))))))))))))
(define CoreC-45Context-setFromTTImp (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setFromTTImp arg-1 e-4) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setNFThreshold (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-50 (vector-ref e-36 0))) (let ((e-44 (vector-ref e-36 1))) (let ((e-45 (vector-ref e-36 2))) (let ((e-46 (vector-ref e-36 3))) (let ((e-47 (vector-ref e-36 4))) (let ((e-49 (vector-ref e-36 6))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector e-50 e-44 e-45 e-46 e-47 arg-1 e-49) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setNameFlag (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-7 (cdr e-1))) (if (null? e-7) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (if (null? e-2) (let ((u--flagsC-39 (cons arg-3 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-4) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_DefFlag arg-4 arg-3)) (let ((e-12 (vector-ref e-10 12))) e-12))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Context-addDef arg-0 (vector 8 e-9) (let ((e-0 (vector-ref e-10 0))) (let ((e-30 (vector-ref e-10 1))) (let ((e-29 (vector-ref e-10 2))) (let ((e-3 (vector-ref e-10 3))) (let ((e-4 (vector-ref e-10 4))) (let ((e-28 (vector-ref e-10 5))) (let ((e-27 (vector-ref e-10 6))) (let ((e-26 (vector-ref e-10 7))) (let ((e-25 (vector-ref e-10 8))) (let ((e-24 (vector-ref e-10 9))) (let ((e-23 (vector-ref e-10 10))) (let ((e-11 (vector-ref e-10 11))) (let ((e-13 (vector-ref e-10 13))) (let ((e-14 (vector-ref e-10 14))) (let ((e-15 (vector-ref e-10 15))) (let ((e-16 (vector-ref e-10 16))) (let ((e-17 (vector-ref e-10 17))) (let ((e-18 (vector-ref e-10 18))) (let ((e-19 (vector-ref e-10 19))) (let ((e-20 (vector-ref e-10 20))) (let ((e-21 (vector-ref e-10 21))) (let ((e-22 (vector-ref e-10 22))) (vector e-0 e-30 e-29 e-3 e-4 e-28 e-27 e-26 e-25 e-24 e-23 e-11 u--flagsC-39 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22))))))))))))))))))))))) eta-2)) eta-1))) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Options-setPair (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 (box (vector arg-0 arg-1 arg-2)) e-5 e-6 e-7 e-8 e-9))))))))))))
(define CoreC-45Context-setPair (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-0))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-0 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-36 (vector-ref e-8 5))) (let ((e-35 (vector-ref e-8 6))) (let ((e-34 (vector-ref e-8 7))) (let ((e-33 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-31 (vector-ref e-8 31))) (let ((e-32 (vector-ref e-8 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setPair e-5 e-6 e-7 e-4) e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setPrefixRecordProjections (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-50 (vector-ref e-36 0))) (let ((e-44 (vector-ref e-36 1))) (let ((e-45 (vector-ref e-36 2))) (let ((e-46 (vector-ref e-36 3))) (let ((e-47 (vector-ref e-36 4))) (let ((e-48 (vector-ref e-36 5))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 (vector e-50 e-44 e-45 e-46 e-47 e-48 arg-1) e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Options-setRewrite (lambda (arg-0 arg-1 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-6 (vector-ref ext-0 6))) (let ((e-7 (vector-ref ext-0 7))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 e-4 (box (cons arg-0 arg-1)) e-6 e-7 e-8 e-9))))))))))))
(define CoreC-45Context-setRewrite (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-checkUnambig arg-0 arg-1 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-0))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-4 (vector-ref e-7 4))) (let ((e-35 (vector-ref e-7 5))) (let ((e-34 (vector-ref e-7 6))) (let ((e-33 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (let ((e-12 (vector-ref e-7 12))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (let ((e-25 (vector-ref e-7 25))) (let ((e-26 (vector-ref e-7 26))) (let ((e-27 (vector-ref e-7 27))) (let ((e-28 (vector-ref e-7 28))) (let ((e-29 (vector-ref e-7 29))) (let ((e-30 (vector-ref e-7 30))) (let ((e-31 (vector-ref e-7 31))) (let ((e-32 (vector-ref e-7 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-setRewrite e-6 e-5 e-4) e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-4))))) eff-1) world-0))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setSearchTimeout (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-68 (vector-ref e-35 0))) (let ((e-44 (vector-ref e-35 1))) (let ((e-45 (vector-ref e-35 2))) (let ((e-46 (vector-ref e-35 3))) (let ((e-47 (vector-ref e-35 4))) (let ((e-48 (vector-ref e-35 5))) (let ((e-50 (vector-ref e-35 7))) (let ((e-51 (vector-ref e-35 8))) (let ((e-52 (vector-ref e-35 9))) (let ((e-53 (vector-ref e-35 10))) (let ((e-54 (vector-ref e-35 11))) (let ((e-55 (vector-ref e-35 12))) (let ((e-56 (vector-ref e-35 13))) (let ((e-57 (vector-ref e-35 14))) (let ((e-58 (vector-ref e-35 15))) (let ((e-59 (vector-ref e-35 16))) (let ((e-60 (vector-ref e-35 17))) (let ((e-61 (vector-ref e-35 18))) (let ((e-62 (vector-ref e-35 19))) (let ((e-63 (vector-ref e-35 20))) (let ((e-64 (vector-ref e-35 21))) (let ((e-65 (vector-ref e-35 22))) (let ((e-66 (vector-ref e-35 23))) (let ((e-67 (vector-ref e-35 24))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 (vector e-68 e-44 e-45 e-46 e-47 e-48 arg-1 e-50 e-51 e-52 e-53 e-54 e-55 e-56 e-57 e-58 e-59 e-60 e-61 e-62 e-63 e-64 e-65 e-66 e-67) e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45DesugarC-45Mutual-n--8139-4456-u--mkRecType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-9) (vector 22 arg-8) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-8 e-10 e-14 (box e-6) e-15 (IdrisC-45DesugarC-45Mutual-n--8139-4456-u--mkRecType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3)))))))))))))
(define IdrisC-45DesugarC-45Mutual-getDecl (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((6) (let ((e-104 (vector-ref arg-1 1))) (let ((e-105 (vector-ref arg-1 2))) (let ((e-106 (vector-ref arg-1 3))) (let ((e-108 (vector-ref arg-1 5))) (let ((e-109 (vector-ref arg-1 6))) (let ((e-110 (vector-ref arg-1 7))) (let ((e-111 (vector-ref arg-1 8))) (let ((e-112 (vector-ref arg-1 9))) (let ((e-113 (vector-ref arg-1 10))) (let ((e-114 (vector-ref arg-1 11))) (box (vector 6 e-104 e-105 e-106 arg-0 e-108 e-109 e-110 e-111 e-112 e-113 e-114))))))))))))) ((11) (let ((e-116 (vector-ref arg-1 1))) (let ((e-117 (vector-ref arg-1 2))) (let ((e-118 (vector-ref arg-1 3))) (box (vector 11 e-116 e-117 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl arg-0 eta-0)) e-118)))))))(else (cond ((equal? arg-0 1) (case (vector-ref arg-1 0) ((0) (box arg-1)) ((2) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (let ((e-17 (vector-ref arg-1 3))) (let ((e-18 (vector-ref arg-1 4))) (let ((e-19 (vector-ref arg-1 5))) (case (vector-ref e-19 0) ((0) (let ((e-46 (vector-ref e-19 1))) (let ((e-47 (vector-ref e-19 2))) (let ((e-48 (vector-ref e-19 3))) (if (null? e-48) '() (let ((e-52 (unbox e-48))) (box (vector 2 e-15 e-16 e-17 e-18 (vector 1 e-46 e-47 e-52)))))))))(else '())))))))) ((5) (box arg-1)) ((7) (let ((e-31 (vector-ref arg-1 1))) (let ((e-32 (vector-ref arg-1 2))) (let ((e-33 (vector-ref arg-1 3))) (let ((e-34 (vector-ref arg-1 4))) (let ((e-35 (vector-ref arg-1 5))) (case (vector-ref e-35 0) ((0) (let ((e-54 (vector-ref e-35 1))) (let ((e-55 (vector-ref e-35 2))) (let ((e-56 (vector-ref e-35 3))) (let ((e-57 (vector-ref e-35 4))) (let ((e-58 (vector-ref e-35 5))) (box (vector 2 e-31 e-32 e-33 e-34 (vector 1 e-31 e-54 (IdrisC-45DesugarC-45Mutual-n--8139-4456-u--mkRecType e-56 e-57 e-58 e-55 e-54 e-34 e-33 e-32 e-31 e-55))))))))))(else '())))))))) ((10) (box arg-1)) ((14) (box arg-1))(else '()))) ((equal? arg-0 2) (case (vector-ref arg-1 0) ((0) '()) ((2) (let ((e-70 (vector-ref arg-1 5))) (case (vector-ref e-70 0) ((1) (box arg-1))(else (box arg-1))))) ((5) '()) ((7) (let ((e-86 (vector-ref arg-1 5))) (case (vector-ref e-86 0) ((1) (box arg-1))(else (box arg-1))))) ((10) '()) ((14) '())(else (box arg-1))))(else (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (box (vector 3 e-1 e-2 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl arg-0 eta-0)) e-3))))))) ((4) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (box (vector 4 e-5 e-6 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl arg-0 eta-0)) e-7)))))))(else (cond (else (box arg-1)))))))))))
(define IdrisC-45DesugarC-45Mutual-splitMutual (lambda (arg-0) (cons (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl 1 eta-0)) arg-0) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45DesugarC-45Mutual-getDecl 2 eta-0)) arg-0))))
(define CoreC-45OptionsC-45Log-topics (lambda (arg-0) (let ((e-0 (car arg-0))) e-0)))
(define CoreC-45Context-lookupHiddenCtxtName (lambda (ext-0 ext-1) (CoreC-45Context-lookupCtxtNameC-39 1 ext-0 ext-1)))
(define CoreC-45Context-unhideName (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 (LibrariesC-45DataC-45NameMap-delete arg-0 e-10) e-11)))))))))))))))
(define CoreC-45Context-unhide (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupHiddenCtxtName arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-8 (car e-1))) (lambda (clam-0) (if (null? e-2) (let ((act-3 (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-38 (vector-ref e-5 1))) (let ((e-37 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-36 (vector-ref e-5 5))) (let ((e-35 (vector-ref e-5 6))) (let ((e-34 (vector-ref e-5 7))) (let ((e-33 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector (CoreC-45Context-unhideName e-8 e-0) e-38 e-37 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((sc6 (CoreC-45Context-isHidden e-8 (let ((e-0 (vector-ref e-5 0))) e-0)))) (cond ((equal? sc6 1) (vector 1 (vector 0 ))) (else ((CoreC-45Context-recordWarning arg-0 (vector 6 arg-1 (string-append "Trying to %unhide `" (string-append (CoreC-45Name-u--show_Show_Name e-8) "`, which was not hidden in the first place")))) clam-0))))))) (CoreC-45Context-ambiguousName arg-0 arg-1 arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45OptionsC-45Log-verbosity (lambda (arg-0) (let ((e-1 (cdr arg-0))) e-1)))
(define IdrisC-45Syntax-u--show_Show_PClause (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (if (null? e-4) (DataC-45String-unwords (cons (IdrisC-45Syntax-u--show_Show_PTerm e-2) (cons "=" (cons (IdrisC-45Syntax-u--show_Show_PTerm e-3) '())))) "MkPatClause"))))) ((1) "MkWithClause") (else (let ((e-13 (vector-ref arg-0 2))) (DataC-45String-unwords (cons (IdrisC-45Syntax-u--show_Show_PTerm e-13) (cons "impossible" '()))))))))
(define IdrisC-45Syntax-u--show_Show_PTypeDecl (lambda (arg-0) (let ((e-3 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 4))) (DataC-45String-unwords (cons (CoreC-45Name-u--show_Show_Name e-3) (cons ":" (cons (IdrisC-45Syntax-u--show_Show_PTerm e-5) '()))))))))
(define IdrisC-45Syntax-u--show_Show_PDecl (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-5 (vector-ref arg-0 5))) (string-append (Algebra-showCount e-2) (IdrisC-45Syntax-u--show_Show_PTypeDecl e-5))))) ((1) (let ((e-8 (vector-ref arg-0 2))) (DataC-45String-fastUnlines (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-u--show_Show_PClause eta-0)) e-8)))) ((2) "PData") ((3) "PParameters") ((4) "PUsing") ((5) "PInterface") ((6) "PImplementation") ((7) "PRecord") ((8) (let ((e-53 (vector-ref arg-0 2))) (let ((e-54 (vector-ref arg-0 3))) (DataC-45String-fastUnlines (cons (DataC-45String-unwords (cons "failing" (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (eta-0) (PreludeC-45Types-u--pure_Applicative_List (PreludeC-45Show-u--show_Show_String eta-0)))) e-53))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Syntax-u--show_Show_PDecl eta-0)) e-54)))))) ((9) "PMutual") ((10) "PFixity") ((11) "PNamespace") ((12) "PTransform") ((13) "PRunElabDecl") ((14) "PDirective") (else "PBuiltin"))))
(define IdrisC-45Desugar-n--15982-17680-u--pairToCons (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-15 0) ((40) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45Desugar-n--15982-17680-u--pairToCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2) (IdrisC-45Desugar-n--15982-17680-u--pairToCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3)))))(else (cons arg-15 '())))))
(define IdrisC-45Desugar-n--15982-17679-u--expandConstraint (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (if (null? e-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--x) (cons '() u--x)) (IdrisC-45Desugar-n--15982-17680-u--pairToCons arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-3)) (let ((e-5 (unbox e-2))) (cons (cons (box e-5) e-3) '())))))))
(define IdrisC-45Desugar-n--15982-18749-u--fname (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (let ((e-5 (vector-ref arg-15 4))) e-5)))
(define IdrisC-45Desugar-n--15982-18169-u--isNamed (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-18) (if (null? arg-18) 0 1)))
(define IdrisC-45Desugar-n--15982-18750-u--mkConName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-15 0) ((0) (let ((e-0 (vector-ref arg-15 1))) (let ((e-1 (vector-ref arg-15 2))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((u--str (CoreC-45Name-displayUserName e-2))) (vector 0 e-0 (vector 4 u--str (vector 2 (string-append "__mk" u--str) 0))))))(else (vector 4 (CoreC-45Name-u--show_Show_Name arg-15) (vector 2 (string-append "__mk" (CoreC-45Name-u--show_Show_Name arg-15)) 0)))))))(else (vector 4 (CoreC-45Name-u--show_Show_Name arg-15) (vector 2 (string-append "__mk" (CoreC-45Name-u--show_Show_Name arg-15)) 0))))))
(define IdrisC-45Desugar-n--15982-18707-u--mkRecType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (vector 22 arg-5) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (vector 1 arg-5 e-10 e-14 (box e-6) e-15 (IdrisC-45Desugar-n--15982-18707-u--mkRecType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3)))))))))))))
(define IdrisC-45Desugar-n--15982-17132-u--toIDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (let ((e-3 (vector-ref arg-9 3))) (vector 1 (vector 2 e-1 arg-8 (cons (vector 0 e-1 e-2 e-3) '()))))))) ((1) (let ((e-5 (vector-ref arg-9 1))) (let ((e-6 (vector-ref arg-9 2))) (let ((e-7 (vector-ref arg-9 3))) (let ((e-8 (vector-ref arg-9 4))) (let ((e-9 (vector-ref arg-9 5))) (let ((e-10 (vector-ref arg-9 6))) (let ((e-11 (vector-ref arg-9 7))) (vector 1 (vector 2 e-5 arg-8 (cons (vector 1 e-5 e-6 e-7 e-8 e-9 e-10 e-11) '()))))))))))) (else (let ((e-13 (vector-ref arg-9 1))) (let ((e-14 (vector-ref arg-9 2))) (vector 1 (vector 2 e-13 arg-8 (cons (vector 2 e-13 e-14) '())))))))))
(define IdrisC-45Desugar-desugarDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-5 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarFnOpt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) e-4 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Desugar-desugarType arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector 0 e-1 e-2 e-3 e-6 e-7) '()))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) ((1) (let ((e-7 (vector-ref arg-6 1))) (let ((e-8 (vector-ref arg-6 2))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 eta-1 eta-2))) e-8 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (PreludeC-45Basics-uncurry (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (IdrisC-45Desugar-n--15982-17132-u--toIDef e-8 e-7 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45DataC-45IMaybe-fromJust eta-3) eta-4 eta-5)))) eta-2)) e-5 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (TTImpC-45Parser-collectDefs e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) ((2) (let ((e-10 (vector-ref arg-6 1))) (let ((e-11 (vector-ref arg-6 2))) (let ((e-12 (vector-ref arg-6 3))) (let ((e-13 (vector-ref arg-6 4))) (let ((e-14 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45Desugar-desugarData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-11 e-14 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 1 e-10 e-12 e-13 e-5) '()))))) eff-0) eta-0)))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-17)) eta-1)) e-18 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-11 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-3) (lambda (eta-4) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-3 eta-4))) e-10) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-2 (cons e-6 (cons e-9 e-8))))))) eff-0) eta-2)))))))) eff-0) clam-0))))))))))))) e-17 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (CoreC-45Context-isUnboundImplicits arg-1 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-7 1) (PreludeC-45IO-u--map_Functor_IO csegen-2832 (PreludeC-45Basics-flip csegen-1298 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd (Builtin-snd (Builtin-snd eta-3)))) e-6) (lambda (eta-3) (TTImpC-45Utils-findUniqueBindableNames arg-1 e-16 1 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-4) (Builtin-fst eta-4)) e-17)) '() eta-3))) clam-1)) (else (vector 1 '())))))) eff-0) eta-2))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--paramsb (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (cons e-2 (cons e-9 (cons e-10 (TTImpC-45BindImplicits-doBind e-7 e-11))))))))))) e-6))) (lambda (eta-3) (vector 1 (cons (vector 3 e-16 u--paramsb (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-4) eta-4) e-5)) '())))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((4) (let ((e-20 (vector-ref arg-6 1))) (let ((e-21 (vector-ref arg-6 2))) (let ((e-22 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--oldu (let ((e-9 (vector-ref e-5 9))) e-9))) (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (u--ntm) (lambda (eta-2) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 (Builtin-snd u--ntm) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 (TTImpC-45BindImplicits-bindTypeNames arg-1 e-20 u--oldu arg-5 e-6 eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (Builtin-fst u--ntm) e-7))))) eff-0) eta-3)))))))) eff-0) eta-2))))))) e-21 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-13 (vector-ref e-5 5))) (let ((e-12 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-13 e-12 e-7 e-8 (PreludeC-45TypesC-45List-tailRecAppend e-6 u--oldu) e-10 e-11))))))))))))))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-3)) e-22 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((let ((eff-0 (lambda (world-0) (let ((act-5 (unbox arg-0))) (vector 1 act-5))))) (lambda (world-0) (let ((act-5 (eff-0 world-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-1 (lambda (world-1) (let ((act-6 (set-box! arg-0 (let ((e-0 (vector-ref e-9 0))) (let ((e-1 (vector-ref e-9 1))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-16 (vector-ref e-9 5))) (let ((e-15 (vector-ref e-9 6))) (let ((e-14 (vector-ref e-9 7))) (let ((e-13 (vector-ref e-9 8))) (let ((e-10 (vector-ref e-9 10))) (let ((e-11 (vector-ref e-9 11))) (vector e-0 e-1 e-2 e-3 e-4 e-16 e-15 e-14 e-13 u--oldu e-10 e-11))))))))))))))) (vector 1 act-6))))) eff-1) world-0))))))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-4) eta-4) e-8)))))))) eff-0) eta-2))))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))) ((5) (let ((e-24 (vector-ref arg-6 1))) (let ((e-25 (vector-ref arg-6 2))) (let ((e-26 (vector-ref arg-6 3))) (let ((e-27 (vector-ref arg-6 4))) (let ((e-28 (vector-ref arg-6 5))) (let ((e-29 (vector-ref arg-6 6))) (let ((e-30 (vector-ref arg-6 7))) (let ((e-31 (vector-ref arg-6 8))) (let ((e-32 (vector-ref arg-6 9))) (lambda (eta-0) (let ((act-1 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-27 e-28 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--paramNames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-29))) (let ((u--cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) (IdrisC-45Desugar-n--15982-17679-u--expandConstraint e-32 e-31 e-30 e-29 e-28 e-27 e-26 e-25 e-24 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-1)) e-26))) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (u--ntm) (lambda (eta-1) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 (PreludeC-45TypesC-45List-tailRecAppend arg-5 u--paramNames) (Builtin-snd u--ntm) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (Builtin-fst u--ntm) e-6))))) eff-0) eta-1))))))) u--cons '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-7 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-2 (cons e-8 e-9)))))) eff-0) clam-1))))))))))) e-29 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--mnames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45Name-dropNS eta-2)) (IdrisC-45Syntax-definedIn e-32)))) (lambda (eta-2) (let ((act-4 (let ((act-4 (CoreC-45Context-isUnboundImplicits arg-1 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-8 1) (PreludeC-45IO-u--map_Functor_IO csegen-2832 (PreludeC-45Basics-flip csegen-1298 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-6) (PreludeC-45TypesC-45List-mapAppend '() csegen-1842 e-7)) (lambda (eta-3) (TTImpC-45Utils-findUniqueBindableNames arg-1 e-24 1 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (PreludeC-45TypesC-45List-tailRecAppend u--mnames u--paramNames)) '() eta-3))) clam-3)) (else (vector 1 '())))))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--paramsb (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-10 (car e-3))) (let ((e-9 (cdr e-3))) (let ((u--tmC-39 (TTImpC-45BindImplicits-doBind e-8 e-9))) (cons e-2 (cons e-10 u--tmC-39)))))))) e-7))) (let ((u--consb (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (TTImpC-45BindImplicits-doBind e-8 e-3))))) e-6))) (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (PreludeC-45TypesC-45List-tailRecAppend u--mnames u--paramNames)) eta-4)) e-32 '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (vector 9 e-24 (PreludeC-45Types-maybe (lambda () (cons e-27 '())) (lambda () (lambda (u--n) (cons e-27 (cons (Builtin-snd u--n) '())))) e-31) (lambda (vars-17993) (lambda (u--nest) (lambda (u--env) (lambda (eta-5) (IdrisC-45ElabC-45Interface-elabInterface vars-17993 arg-1 arg-2 arg-0 arg-3 arg-4 e-24 e-25 u--env u--nest u--consb e-27 u--paramsb e-30 e-31 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-6) eta-6) e-9) eta-5)))))) '()))))) eff-0) eta-3)))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))))))))) ((6) (let ((e-34 (vector-ref arg-6 1))) (let ((e-35 (vector-ref arg-6 2))) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (let ((e-38 (vector-ref arg-6 5))) (let ((e-39 (vector-ref arg-6 6))) (let ((e-40 (vector-ref arg-6 7))) (let ((e-41 (vector-ref arg-6 8))) (let ((e-42 (vector-ref arg-6 9))) (let ((e-43 (vector-ref arg-6 10))) (let ((e-44 (vector-ref arg-6 11))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45Desugar-desugarFnOpt arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) e-36 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((PreludeC-45Basics-flip csegen-1298 e-38 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-2) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-15 clam-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-3) (lambda (eta-4) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-3 eta-4))) e-14) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-2 (cons e-6 (cons e-10 (cons e-9 e-8)))))))) eff-0) eta-2)))))))) eff-0) clam-2)))))))))))))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((PreludeC-45Basics-flip csegen-1298 e-39 (lambda (lamc-0) (lambda (clam-5) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-3 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-3 clam-5))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-2 e-7))))) eff-0) clam-5)))))))))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-4 eta-5))) e-41 '()) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (let ((act-5 (CoreC-45Context-isUnboundImplicits arg-1 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-6) (cond ((equal? e-9 1) (PreludeC-45IO-u--map_Functor_IO csegen-2832 (PreludeC-45Basics-flip csegen-1298 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (Builtin-snd eta-5)) e-7) e-8) (lambda (eta-5) (TTImpC-45Utils-findUniqueBindableNames arg-1 e-34 1 arg-5 '() eta-5))) clam-6)) (else (vector 1 '())))))) eff-0) eta-4))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--paramsb (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (TTImpC-45BindImplicits-doBind e-9 eta-5)) e-8))) (let ((u--isb (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-11 (car e-3))) (let ((e-10 (cdr e-3))) (let ((e-13 (car e-10))) (let ((e-12 (cdr e-10))) (let ((e-14 (car e-12))) (let ((e-15 (cdr e-12))) (cons e-2 (cons e-11 (cons e-13 (cons e-14 (TTImpC-45BindImplicits-doBind e-9 e-15)))))))))))))) e-6))) (let ((u--consb (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons e-2 (TTImpC-45BindImplicits-doBind e-9 e-3))))) e-7))) (lambda (eta-5) (let ((act-6 ((PreludeC-45Types-maybe (lambda () (lambda (eta-6) (vector 1 '()))) (lambda () (lambda (u--b) (lambda (eta-6) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-7) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-7)) u--b '()) eta-6))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (box (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-8) eta-8) e-10)))))) eff-0) eta-6)))))))) e-44) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--impname (PreludeC-45Types-maybe (lambda () (IdrisC-45ElabC-45Implementation-mkImplName e-34 e-40 u--paramsb)) (lambda () (lambda (eta-6) eta-6)) e-42))) (lambda (eta-6) (vector 1 (cons (vector 9 e-34 (cons u--impname '()) (lambda (vars-18260) (lambda (u--nest) (lambda (u--env) (IdrisC-45ElabC-45Implementation-elabImplementation vars-18260 arg-1 arg-2 arg-0 arg-3 arg-4 e-34 e-35 e-5 e-37 u--env u--nest u--isb u--consb e-40 u--paramsb (IdrisC-45Desugar-n--15982-18169-u--isNamed e-44 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-42) u--impname e-43 e-10))))) '())))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))))) ((7) (let ((e-46 (vector-ref arg-6 1))) (let ((e-47 (vector-ref arg-6 2))) (let ((e-48 (vector-ref arg-6 3))) (let ((e-49 (vector-ref arg-6 4))) (let ((e-50 (vector-ref arg-6 5))) (case (vector-ref e-50 0) ((1) (let ((e-84 (vector-ref e-50 1))) (let ((e-85 (vector-ref e-50 2))) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (vector 2 e-46 e-47 e-48 e-49 (vector 1 e-46 e-84 (IdrisC-45Desugar-n--15982-18707-u--mkRecType e-85 e-84 e-49 e-48 e-47 e-46 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-85))))))) (else (let ((e-87 (vector-ref e-50 1))) (let ((e-88 (vector-ref e-50 2))) (let ((e-89 (vector-ref e-50 3))) (let ((e-90 (vector-ref e-50 4))) (let ((e-91 (vector-ref e-50 5))) (lambda (eta-0) (let ((act-1 (IdrisC-45DocC-45String-addDocString arg-1 arg-0 e-87 e-47 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (lambda (clam-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-11 clam-3))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45CoreC-45PiInfo-traverse (lambda (eta-2) (lambda (eta-3) (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 eta-2 eta-3))) e-10) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-2 (cons e-6 (cons e-9 e-8))))))) eff-0) eta-1)))))))) eff-0) clam-3))))))))))))) e-88 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--fnames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45Desugar-n--15982-18749-u--fname e-91 e-90 e-89 e-88 e-87 e-49 e-48 e-47 e-46 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-1)) e-91))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-isUnboundImplicits arg-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--bnames (cond ((equal? e-7 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) (TTImpC-45Utils-findBindableNames 1 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (PreludeC-45TypesC-45List-tailRecAppend u--fnames (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) e-88))) '() eta-2)) (PreludeC-45TypesC-45List-mapAppend '() csegen-3974 e-6))) (else '())))) (let ((u--paramsb (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (cons e-2 (cons e-9 (cons e-10 (TTImpC-45BindImplicits-doBind u--bnames e-11))))))))))) e-6))) (let ((u--recName (CoreC-45Name-nameRoot e-87))) (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45Desugar-desugarField arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (IdrisC-45Desugar-n--15982-18749-u--fname e-91 e-90 e-89 e-88 e-87 e-49 e-48 e-47 e-46 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-5)) e-91) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (Builtin-fst eta-5)) e-88))) (CoreC-45NameC-45Namespace-mkNamespace u--recName) eta-3 eta-4))) e-91 '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--conname (PreludeC-45Types-maybe (lambda () (IdrisC-45Desugar-n--15982-18750-u--mkConName e-91 e-90 e-89 e-88 e-87 e-49 e-48 e-47 e-46 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-87)) (lambda () (lambda (eta-3) (Builtin-snd eta-3))) e-90))) (lambda (eta-3) (let ((act-5 (let ((sc6 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-4) (Builtin-fst eta-4)) e-90))) (if (null? sc6) (vector 1 (vector 0 )) (let ((e-1 (unbox sc6))) (IdrisC-45DocC-45String-addDocString arg-1 arg-0 u--conname e-1 eta-3)))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 4 e-46 (box u--recName) e-48 e-49 (vector e-46 e-87 u--paramsb e-89 u--conname e-8)) '()))))))))) eff-0) eta-2))))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))))))))))))))) ((10) (let ((e-52 (vector-ref arg-6 1))) (let ((e-53 (vector-ref arg-6 2))) (let ((e-54 (vector-ref arg-6 3))) (let ((e-55 (vector-ref arg-6 4))) (let ((e-56 (vector-ref arg-6 5))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--updatedNS (vector 0 (CoreC-45NameC-45Namespace-mkNestedNamespace (box (let ((e-2 (vector-ref e-5 2))) e-2)) (IdrisC-45Syntax-u--show_Show_Fixity e-54)) (vector 1 (vector 0 (CoreC-45Name-nameRoot e-56)))))) (lambda (eta-1) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-13 (vector-ref e-6 5))) (let ((e-12 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (vector (LibrariesC-45DataC-45ANameMap-addName u--updatedNS (vector e-52 e-53 e-54 e-55) e-0) e-1 e-2 e-3 e-4 e-13 e-12 e-7 e-8 e-9 e-10 e-11)))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 '())))))))) eff-0) eta-0)))))))))))) ((8) (let ((e-58 (vector-ref arg-6 1))) (let ((e-59 (vector-ref arg-6 2))) (let ((e-60 (vector-ref arg-6 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-3))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-4))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-branch arg-1 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45ContextC-45Log-log arg-1 "desugar.failing" 20 (lambda () (string-append "Desugaring the block:\xa;" (IdrisC-45Syntax-u--show_Show_PDecl arg-6))) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-6) (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-7) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-7)) e-60 '()) eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-8) eta-8) e-11)))))) eff-0) eta-6)))))) (lambda (u--err) (lambda (clam-8) (if (null? e-59) (vector 1 (vector 0 '())) (let ((e-1 (unbox e-59))) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "desugar.failing" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-6) eta-6) (cons "Failing block based on " (cons (PreludeC-45Show-u--show_Show_String e-1) (cons " failed with " (cons (CoreC-45Core-u--show_Show_Error u--err) '())))))) clam-8))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((IdrisC-45Error-checkError arg-1 arg-0 arg-4 e-1 u--err) clam-8))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector 0 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (cond ((equal? e-12 1) 0) (else 1))) (lambda (_-10649) (box (vector 67 e-58 e-1 (cons u--err '())))))))))) eff-0) clam-8)))))))))))) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (let ((act-8 (set-box! arg-2 e-5))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 (unbox arg-3))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-10 (let ((act-10 (set-box! arg-3 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-18 (vector-ref e-6 5))) (let ((e-17 (vector-ref e-6 6))) (vector e-0 e-1 e-2 e-3 e-4 e-18 e-17 (let ((e-21 (vector-ref e-13 7))) e-21) (let ((e-20 (vector-ref e-13 8))) e-20) (let ((e-19 (vector-ref e-13 9))) e-19)))))))))))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 (let ((act-11 (set-box! arg-0 e-8))) (vector 1 act-11)))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (let ((act-12 (set-box! arg-1 e-9))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (case (vector-ref e-11 0) ((1) (let ((e-2 (vector-ref e-11 1))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-8) (case (vector-ref eta-8 0) ((0) (let ((e-3 (vector-ref eta-8 1))) (vector 0 e-3))) (else (vector 1 (cons (vector 5 e-58 e-59 e-2) '()))))) (lambda (eta-8) (CoreC-45ContextC-45Log-log arg-1 "desugar.failing" 20 (lambda () "Success") eta-8)) eta-7))) (else (let ((e-17 (vector-ref e-11 1))) (if (null? e-17) (PreludeC-45IO-u--map_Functor_IO csegen-2660 (lambda (eta-8) (CoreC-45ContextC-45Log-log arg-1 "desugar.failing" 20 (lambda () "Correctly failed") eta-8)) eta-7) (let ((e-18 (unbox e-17))) (CoreC-45Core-u--throw_Catchable_Core_Error e-18 eta-7)))))))))))))))))) eff-0) eta-6))))))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-63 (vector-ref arg-6 2))) (lambda (clam-9) (let ((sc1 (IdrisC-45DesugarC-45Mutual-splitMutual e-63))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) (PreludeC-45TypesC-45List-tailRecAppend e-2 e-3) '()) clam-9))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) clam-9))))))))))) ((11) (let ((e-65 (vector-ref arg-6 1))) (let ((e-66 (vector-ref arg-6 2))) (let ((e-67 (vector-ref arg-6 3))) (lambda (eta-0) (CoreC-45Context-withExtendedNS arg-1 e-66 (lambda (eta-1) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (IdrisC-45Desugar-desugarDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-2)) e-67 '()) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons (vector 6 e-65 e-66 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-3) eta-3) e-5)) '()))))) eff-0) eta-1)))))) eta-0)))))) ((12) (let ((e-69 (vector-ref arg-6 1))) (let ((e-70 (vector-ref arg-6 2))) (let ((e-71 (vector-ref arg-6 3))) (let ((e-72 (vector-ref arg-6 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 0 arg-5 e-71 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45BindImplicits-bindNames arg-1 0 e-5 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-10) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 (PreludeC-45TypesC-45List-tailRecAppend e-2 arg-5) e-72 clam-10))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 7 e-69 (vector 1 (vector 0 e-70)) e-3 e-6) '()))))) eff-0) clam-10)))))))))) eff-0) eta-0))))))))))) ((13) (let ((e-74 (vector-ref arg-6 1))) (let ((e-75 (vector-ref arg-6 2))) (lambda (eta-0) (let ((act-1 (IdrisC-45Desugar-desugar arg-0 arg-1 arg-3 arg-2 arg-4 1 arg-5 e-75 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 8 e-74 e-5) '()))))) eff-0) eta-0))))))))) ((14) (let ((e-77 (vector-ref arg-6 1))) (let ((e-78 (vector-ref arg-6 2))) (lambda (clam-4) (case (vector-ref e-78 0) ((0) (let ((e-0 (vector-ref e-78 1))) (case (vector-ref e-0 0) ((0) (let ((e-31 (vector-ref e-0 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20044) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-hide arg-1 e-77 e-31 eta-0)))))) '())))) (else (let ((e-32 (vector-ref e-0 1))) (let ((e-33 (vector-ref e-0 2))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20078) (lambda (_-20081) (lambda (_-20084) (IdrisC-45Syntax-removeFixity arg-0 e-32 e-33))))) '())))))))) ((1) (let ((e-1 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20113) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-unhide arg-1 e-77 e-1 eta-0)))))) '())))) ((2) (let ((e-2 (vector-ref e-78 1))) (vector 1 (cons (vector 10 (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--i) (cons (CoreC-45OptionsC-45Log-topics u--i) (CoreC-45OptionsC-45Log-verbosity u--i))) e-2)) '())))) ((3) (let ((e-3 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20180) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-lazyActive arg-1 e-3))))) '())))) ((4) (let ((e-4 (vector-ref e-78 1))) (let ((act-1 ((CoreC-45Context-setUnboundImplicits arg-1 e-4) clam-4))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20216) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setUnboundImplicits arg-1 e-4))))) '()))))))) ((21) (let ((e-5 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20249) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setPrefixRecordProjections arg-1 e-5))))) '())))) ((5) (let ((e-6 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20282) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setAmbigLimit arg-1 e-6))))) '())))) ((22) (let ((e-7 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20315) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setAutoImplicitLimit arg-1 e-7))))) '())))) ((23) (let ((e-8 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20348) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setNFThreshold arg-1 e-8))))) '())))) ((24) (let ((e-9 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20381) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setSearchTimeout arg-1 e-9))))) '())))) ((6) (let ((e-10 (vector-ref e-78 1))) (let ((e-11 (vector-ref e-78 2))) (let ((e-12 (vector-ref e-78 3))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20414) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setPair arg-1 e-77 e-10 e-11 e-12 eta-0)))))) '())))))) ((7) (let ((e-13 (vector-ref e-78 1))) (let ((e-14 (vector-ref e-78 2))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20447) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setRewrite arg-1 e-77 e-13 e-14 eta-0)))))) '()))))) ((8) (let ((e-15 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20480) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromInteger arg-1 e-15))))) '())))) ((9) (let ((e-16 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20513) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromString arg-1 e-16))))) '())))) ((10) (let ((e-17 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20546) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromChar arg-1 e-17))))) '())))) ((11) (let ((e-18 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20579) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromDouble arg-1 e-18))))) '())))) ((12) (let ((e-19 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20612) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromTTImp arg-1 e-19))))) '())))) ((13) (let ((e-20 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20645) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromName arg-1 e-20))))) '())))) ((14) (let ((e-21 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20678) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setFromDecls arg-1 e-21))))) '())))) ((15) (let ((e-22 (vector-ref e-78 1))) (let ((e-23 (vector-ref e-78 2))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20711) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-addDirective arg-1 e-22 e-23 eta-0)))))) '()))))) ((16) (let ((e-24 (vector-ref e-78 1))) (let ((e-25 (vector-ref e-78 2))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20744) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-addNameDirective arg-1 e-77 e-24 e-25 eta-0)))))) '()))))) ((17) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20779) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "%start not implemented") eta-0)))))) '()))) ((18) (let ((e-28 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20817) (lambda (u--nest) (lambda (u--env) (lambda (eta-0) (CoreC-45Context-setNameFlag arg-1 e-77 e-28 (vector 4 ) eta-0)))))) '())))) ((19) (let ((e-29 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20851) (lambda (u--nest) (lambda (u--env) (CoreC-45Context-setExtension arg-1 e-29))))) '())))) (else (let ((e-30 (vector-ref e-78 1))) (vector 1 (cons (vector 9 e-77 '() (lambda (vars-20884) (lambda (_-20887) (lambda (_-20890) (CoreC-45Context-setDefaultTotalityOption arg-1 e-30))))) '()))))))))) (else (let ((e-80 (vector-ref arg-6 1))) (let ((e-81 (vector-ref arg-6 2))) (let ((e-82 (vector-ref arg-6 3))) (lambda (eta-0) (vector 1 (cons (vector 11 e-80 e-81 e-82) '()))))))))))
(define CoreC-45Unify-n--27127-30245-u--constraintToHole (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-2) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-8) (vector 1 (vector 0 )) (let ((e-1 (unbox e-8))) (case (vector-ref e-1 0) ((8) (CoreC-45Context-updateDef arg-1 (vector 8 e-2) csegen-2498 clam-1)) ((9) (CoreC-45Context-updateDef arg-1 (vector 8 e-2) csegen-2498 clam-1))(else (vector 1 (vector 0 ))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))
(define CoreC-45Unify-giveUpConstraints (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Unify-n--27127-30245-u--constraintToHole arg-1 arg-0 eta-0)) (LibrariesC-45DataC-45IntMap-toList (let ((e-1 (vector-ref e-5 1))) e-1))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-processDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((11) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (CoreC-45Context-withExtendedNS arg-0 e-2 (lambda (eta-1) (IdrisC-45ProcessIdr-processDecls arg-0 arg-1 arg-2 arg-3 arg-4 e-3 eta-1)) eta-0))))) ((9) (let ((e-6 (vector-ref arg-5 2))) (lambda (clam-0) (let ((sc1 (IdrisC-45DesugarC-45Mutual-splitMutual e-6))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (IdrisC-45ProcessIdr-processDecls arg-0 arg-1 arg-2 arg-3 arg-4 (PreludeC-45TypesC-45List-tailRecAppend e-2 e-3) clam-0)))))))(else (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-1 ((IdrisC-45Desugar-desugarDecl arg-2 arg-0 arg-1 arg-3 arg-4 '() arg-5) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (eta-3) (TTImpC-45ElabC-45Check-processDecl '() arg-0 arg-3 arg-1 arg-2 arg-4 '() '() '() eta-3)) e-5) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 '()))))))) eff-0) eta-1)))))) (lambda (u--err) (lambda (eta-1) (let ((act-1 (CoreC-45Unify-giveUpConstraints arg-0 arg-1 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (cons u--err '()))))))) eta-0))))))
(define IdrisC-45ProcessIdr-processDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-2832 (CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45ProcessIdr-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 eta-0)) arg-5 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45UnifyState-checkDelayedHoles arg-1 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-3 (CoreC-45ContextC-45Log-logTime arg-0 3 (lambda () "Totality check overall") (lambda (eta-1) (TTImpC-45ProcessDeclsC-45Totality-getTotalityErrors arg-0 eta-1)) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-7))))) eff-0) clam-0))))) (let ((e-2 (unbox e-6))) (vector 1 (let ((sc3 (PreludeC-45Types-u--null_Foldable_List e-5))) (cond ((equal? sc3 1) (cons e-2 '())) (else e-5))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Parser-import_ (lambda (arg-0 arg-1) (vector 9 0 (vector 14 (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "import") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-option 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) 1) (IdrisC-45Parser-decoratedKeyword arg-0 "public"))) (lambda (u--reexp) (vector 9 0 (IdrisC-45Parser-decorate arg-0 8 (vector 8 ParserC-45RuleC-45Source-moduleIdent)) (lambda () (lambda (u--ns) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 u--ns (vector 11 1 (IdrisC-45Parser-decorate arg-0 4 (ParserC-45RuleC-45Source-exactIdent "as")) (lambda () (IdrisC-45Parser-decorate arg-0 6 (vector 8 ParserC-45RuleC-45Source-namespaceId))))) (lambda (u--nsAs) (vector 0 (cons u--reexp (cons u--ns u--nsAs))))))))))))) (lambda () (lambda (u--b) (vector 12 0 0 (ParserC-45RuleC-45Source-atEnd arg-1) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector (CoreC-45FC-boundToFC arg-0 u--b) e-2 e-6 e-7))))))))))))))
(define IdrisC-45Parser-progHdr (lambda (arg-0) (vector 10 0 0 (vector 14 (vector 10 0 0 (ParserC-45RuleC-45Source-optDocumentation arg-0) (lambda (u--doc) (vector 10 0 0 (LibrariesC-45TextC-45Parser-option 1 CoreC-45NameC-45Namespace-mainNS (vector 11 1 (IdrisC-45Parser-decoratedKeyword arg-0 "module") (lambda () (IdrisC-45Parser-decorate arg-0 8 (vector 8 ParserC-45RuleC-45Source-moduleIdent))))) (lambda (u--nspace) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-import_ arg-0 eta-0))) (lambda (u--imports) (vector 0 (cons u--doc (cons u--nspace u--imports)))))))))) (lambda (u--b) (vector 10 0 0 (vector 0 (let ((e-1 (vector-ref u--b 0))) e-1)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (vector 0 (vector (CoreC-45FC-boundToFC arg-0 u--b) e-6 e-7 e-2 '()))))))))))))
(define IdrisC-45Parser-prog (lambda (arg-0) (vector 10 0 0 (IdrisC-45Parser-progHdr arg-0) (lambda (u--mod) (vector 10 0 0 (ParserC-45RuleC-45Source-block (lambda (eta-0) (IdrisC-45Parser-topDecl arg-0 eta-0))) (lambda (u--ds) (vector 0 (let ((e-0 (vector-ref u--mod 0))) (let ((e-1 (vector-ref u--mod 1))) (let ((e-2 (vector-ref u--mod 2))) (let ((e-3 (vector-ref u--mod 3))) (vector e-0 e-1 e-2 e-3 (IdrisC-45Parser-collectDefs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) u--ds))))))))))))))
(define ParserC-45Support-fromLitError (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (vector 55 (vector 0 arg-0 (cons e-0 e-1) (cons e-0 (bs+ e-1 1 63))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5403-u--countNLs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (PreludeC-45TypesC-45List-lengthTR (PreludeC-45TypesC-45List-filterAppend '() csegen-679 arg-7))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5404-u--getCols (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((sc0 (DataC-45List-span csegen-678 arg-7))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-3) (bs+ arg-8 (blodwen-toSignedInt (PreludeC-45TypesC-45List-lengthTR e-2) 63) 63) (blodwen-toSignedInt (PreludeC-45TypesC-45List-lengthTR e-2) 63)))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getNext-5531 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (if (null? arg-11) '() (let ((e-1 (unbox arg-11))) (if (null? e-1) '() (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((u--lineC-39 (bs+ arg-9 (blodwen-toSignedInt (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5403-u--countNLs arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4) 63) 63))) (let ((u--colC-39 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5404-u--getCols arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 arg-8))) (let ((u--tokenStr (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-reverse e-4)))) (box (cons u--tokenStr (cons u--lineC-39 (cons u--colC-39 e-5))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5406-u--getNext (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getNext-5531 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-10 arg-9 arg-8 arg-7 (LibrariesC-45TextC-45LexerC-45Core-scan arg-7 '() arg-10))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-5634 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (vector 0 (vector 1 )) (let ((e-1 (unbox arg-10))) (if (null? e-1) (vector 0 (vector 1 )) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (vector 0 (vector 1 )) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-9) (vector 0 (vector 1 )) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((u--tokC-39 (vector (arg-7 e-4) 0 (vector arg-4 arg-3 e-8 e-12)))) (vector 1 (cons (cons u--tokC-39 '()) (cons e-8 (cons e-12 e-13))))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32tokeniseC-44getFirstMatch-6014 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 arg-27 arg-28) (if (null? arg-28) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-1 (unbox arg-28))) (if (null? e-1) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (if (null? e-5) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (if (null? e-9) (vector 0 (vector 2 (cons arg-4 arg-3) (cons arg-16 arg-17))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((u--endTokC-39C-39 (vector (arg-8 e-4) 0 (vector arg-24 arg-25 e-8 e-12)))) (vector 1 (cons (PreludeC-45TypesC-45List-tailRecAppend (cons u--endTokC-39C-39 '()) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse arg-22) (cons arg-21 '()))) (cons e-8 (cons e-12 e-13))))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-5734 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (if (null? arg-15) (vector 0 (vector 1 )) (let ((e-1 (unbox arg-15))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((u--tag (arg-11 e-5))) (let ((u--middle ((arg-10) u--tag))) (let ((u--end (arg-9 u--tag))) (let ((u--beginTokC-39C-39 (vector (arg-12 e-5) 0 (vector arg-4 arg-3 e-9 e-13)))) (let ((sc4 (LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise u--end u--middle e-9 e-13 '() e-14))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (let ((e-8 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-12 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-16 (car e-11))) (let ((e-15 (cdr e-11))) (case (vector-ref e-8 0) ((2) (vector 0 e-8))(else (LibrariesC-45TextC-45LexerC-45Tokenizer-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32tokeniseC-44getFirstMatch-6014 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5 e-9 e-13 e-14 u--middle u--end u--beginTokC-39C-39 e-2 e-8 e-12 e-16 e-15 u--tag (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5406-u--getNext arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 u--end e-12 e-16 e-15)))))))))))))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-6251 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((1) (let ((e-2 (vector-ref arg-10 1))) (vector 1 e-2))) (else (let ((e-5 (vector-ref arg-10 1))) (case (vector-ref e-5 0) ((2) (vector 0 e-5))(else (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5405-u--getFirstMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 (arg-7) arg-9))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5405-u--getFirstMatch (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-7 0) ((0) (let ((e-1 (vector-ref arg-7 1))) (let ((e-2 (vector-ref arg-7 2))) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-5634 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-2 e-1 arg-8 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5406-u--getNext arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-1 arg-4 arg-3 arg-8))))) ((1) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (let ((e-7 (vector-ref arg-7 3))) (let ((e-8 (vector-ref arg-7 4))) (let ((e-9 (vector-ref arg-7 5))) (let ((e-10 (vector-ref arg-7 6))) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-5734 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-10 e-9 e-8 e-7 e-6 e-5 arg-8 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5406-u--getNext arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-5 arg-4 arg-3 arg-8))))))))) (else (let ((e-12 (vector-ref arg-7 1))) (let ((e-13 (vector-ref arg-7 2))) (LibrariesC-45TextC-45LexerC-45Tokenizer-case--tokeniseC-44getFirstMatch-6251 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-13 e-12 arg-8 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5405-u--getFirstMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-12 arg-8))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (cons (PreludeC-45TypesC-45List-reverse arg-5) (cons (vector 0 ) (cons arg-3 (cons arg-4 '())))) (let ((sc1 (LibrariesC-45TextC-45LexerC-45Core-scan arg-1 '() arg-6))) (if (null? sc1) (let ((sc2 (LibrariesC-45TextC-45LexerC-45Tokenizer-n--4358-5405-u--getFirstMatch arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-2 arg-6))) (case (vector-ref sc2 0) ((1) (let ((e-2 (vector-ref sc2 1))) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-9))) (let ((e-13 (cdr e-9))) (let ((e-16 (car e-13))) (let ((e-17 (cdr e-13))) (LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise arg-1 arg-2 e-12 e-16 (PreludeC-45TypesC-45List-tailRecAppend e-8 arg-5) e-17))))))))) (else (let ((e-5 (vector-ref sc2 1))) (cons (PreludeC-45TypesC-45List-reverse arg-5) (cons e-5 (cons arg-3 (cons arg-4 arg-6)))))))) (cons (PreludeC-45TypesC-45List-reverse arg-5) (cons (vector 0 ) (cons arg-3 (cons arg-4 arg-6)))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-lexTo (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45TextC-45LexerC-45Tokenizer-tokenise arg-1 arg-2 0 0 '() (PreludeC-45Types-fastUnpack arg-3)))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (cons e-2 (cons e-6 (cons e-10 (cons e-14 (PreludeC-45Types-fastPack e-15))))))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (lambda (ext-0 ext-1) (vector 2 ext-0 ext-1)))
(define LibrariesC-45TextC-45Lexer-binDigit (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--c) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c #\0))) (cond ((equal? sc0 1) 1) (else (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c #\1)))))))
(define LibrariesC-45TextC-45Lexer-binDigits (LibrariesC-45TextC-45Lexer-some LibrariesC-45TextC-45Lexer-binDigit))
(define LibrariesC-45TextC-45Lexer-binLit (vector 5 (LibrariesC-45TextC-45Lexer-exact "0b") (lambda () LibrariesC-45TextC-45Lexer-binDigits)))
(define LibrariesC-45TextC-45Lexer-binUnderscoredLit (vector 5 LibrariesC-45TextC-45Lexer-binLit (lambda () (LibrariesC-45TextC-45Lexer-many (vector 5 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () LibrariesC-45TextC-45Lexer-binDigits))))))
(define LibrariesC-45TextC-45LexerC-45Core-eof (vector 2 ))
(define LibrariesC-45TextC-45Lexer-hexDigit (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isHexDigit eta-0))))
(define LibrariesC-45TextC-45Lexer-hexDigits (LibrariesC-45TextC-45Lexer-some LibrariesC-45TextC-45Lexer-hexDigit))
(define LibrariesC-45TextC-45Lexer-octDigit (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (PreludeC-45Types-isOctDigit eta-0))))
(define LibrariesC-45TextC-45Lexer-octDigits (LibrariesC-45TextC-45Lexer-some LibrariesC-45TextC-45Lexer-octDigit))
(define LibrariesC-45TextC-45Lexer-n--4599-1473-u--lexStr (lambda (arg-0) (if (null? arg-0) LibrariesC-45TextC-45LexerC-45Core-fail (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-exact e-2) (LibrariesC-45TextC-45Lexer-n--4599-1473-u--lexStr e-3)))))))
(define LibrariesC-45TextC-45Lexer-n--4599-1472-u--control (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-n--4599-1473-u--lexStr (cons "NUL" (cons "SOH" (cons "STX" (cons "ETX" (cons "EOT" (cons "ENQ" (cons "ACK" (cons "BEL" (cons "BS" (cons "HT" (cons "LF" (cons "VT" (cons "FF" (cons "CR" (cons "SO" (cons "SI" (cons "DLE" (cons "DC1" (cons "DC2" (cons "DC3" (cons "DC4" (cons "NAK" (cons "SYN" (cons "ETB" (cons "CAN" (cons "EM" (cons "SUB" (cons "ESC" (cons "FS" (cons "GS" (cons "RS" (cons "US" (cons "SP" (cons "DEL" '()))))))))))))))))))))))))))))))))))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-is #\x) (lambda () LibrariesC-45TextC-45Lexer-hexDigits)) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-is #\o) (lambda () LibrariesC-45TextC-45Lexer-octDigits)) LibrariesC-45TextC-45Lexer-digits))))
(define LibrariesC-45TextC-45Lexer-charLit (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\') (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-escape (LibrariesC-45TextC-45Lexer-is #\\) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45Lexer-n--4599-1472-u--control LibrariesC-45TextC-45Lexer-any)) (LibrariesC-45TextC-45Lexer-isNot #\')))) (lambda () (LibrariesC-45TextC-45Lexer-is #\'))))
(define LibrariesC-45TextC-45Lexer-choiceMap (lambda (arg-2 arg-3 arg-4 arg-5) (let ((e-1 (vector-ref arg-3 0))) (((((e-1 'erased) 'erased) (lambda (u--x) (lambda (u--acc) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (arg-4 u--x) u--acc)))) LibrariesC-45TextC-45LexerC-45Core-fail) arg-5))))
(define LibrariesC-45TextC-45Lexer-choice (lambda (arg-1 arg-2 ext-0) (LibrariesC-45TextC-45Lexer-choiceMap arg-1 arg-2 (lambda (eta-0) eta-0) ext-0)))
(define ParserC-45LexerC-45Source-doubleDash (lambda (arg-0) (vector 6 csegen-305 (LibrariesC-45TextC-45Lexer-choice 1 csegen-14 (cons (vector 5 (LibrariesC-45TextC-45Lexer-is #\}) (lambda () (ParserC-45LexerC-45Source-toEndComment arg-0))) (cons (vector 6 csegen-459 (ParserC-45LexerC-45Source-toEndComment (+ arg-0 1))) '()))))))
(define ParserC-45LexerC-45Source-singleDash (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (ParserC-45LexerC-45Source-doubleDash arg-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-is #\}) (lambda () (ParserC-45LexerC-45Source-toEndComment arg-0))) (ParserC-45LexerC-45Source-toEndComment (+ arg-0 1))))))
(define ParserC-45LexerC-45Source-singleBrace (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () csegen-305)) (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45LexerC-45Core-eof (ParserC-45LexerC-45Source-singleDash (+ arg-0 1))))) (ParserC-45LexerC-45Source-toEndComment (+ arg-0 1)))))
(define ParserC-45LexerC-45Source-toEndComment (lambda (arg-0) (cond ((equal? arg-0 0) LibrariesC-45TextC-45LexerC-45Core-empty)(else (let ((e-0 (- arg-0 1))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--c) (let ((sc0 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\-))) (cond ((equal? sc0 1) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\{))) (cond ((equal? sc1 1) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\"))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char u--c #\')) (else 0)))) (else 0)))) (else 0)))))) (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45LexerC-45Core-eof (ParserC-45LexerC-45Source-toEndComment (+ e-0 1))))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-is #\{) (lambda () (ParserC-45LexerC-45Source-singleBrace e-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45Lexer-is #\-) (lambda () (ParserC-45LexerC-45Source-singleDash e-0))) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45Lexer-charLit (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (arg-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-1 #\')))) (lambda () (ParserC-45LexerC-45Source-toEndComment (+ e-0 1)))) (vector 5 LibrariesC-45TextC-45Lexer-stringLit (lambda () (ParserC-45LexerC-45Source-toEndComment (+ e-0 1)))))))))))))
(define ParserC-45LexerC-45Source-blockComment (vector 5 (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\{) (lambda () (LibrariesC-45TextC-45Lexer-is #\-))) (lambda () csegen-305)) (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45LexerC-45Core-eof (ParserC-45LexerC-45Source-toEndComment 1)))))
(define ParserC-45LexerC-45Source-cgDirective (vector 5 (LibrariesC-45TextC-45Lexer-exact "%cg") (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (vector 5 (vector 5 (vector 5 (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-some LibrariesC-45TextC-45Lexer-space) (lambda () (LibrariesC-45TextC-45Lexer-some csegen-469))) (lambda () (LibrariesC-45TextC-45Lexer-many LibrariesC-45TextC-45Lexer-space))) (lambda () (LibrariesC-45TextC-45Lexer-is #\{))) (lambda () (LibrariesC-45TextC-45Lexer-many (LibrariesC-45TextC-45Lexer-isNot #\})))) (lambda () (LibrariesC-45TextC-45Lexer-is #\}))) csegen-459))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-compose (lambda (ext-0 ext-1 ext-2 ext-3 ext-4 ext-5) (vector 1 ext-0 ext-1 ext-2 ext-3 ext-4 ext-5)))
(define ParserC-45LexerC-45Source-u--show_Show_DebugInfo (lambda (arg-0) (cond ((equal? arg-0 0) "__LOC__") ((equal? arg-0 1) "__FILE__") ((equal? arg-0 2) "__LINE__") (else "__COL__"))))
(define ParserC-45LexerC-45Source-debugInfo (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--di) (cons (ParserC-45LexerC-45Source-u--show_Show_DebugInfo u--di) u--di)) (cons 0 (cons 1 (cons 2 (cons 3 '()))))))
(define LibrariesC-45TextC-45Lexer-digitsUnderscoredLit (vector 5 LibrariesC-45TextC-45Lexer-digits (lambda () (LibrariesC-45TextC-45Lexer-many (vector 5 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () LibrariesC-45TextC-45Lexer-digits))))))
(define ParserC-45LexerC-45Source-docComment (vector 5 (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\|) (lambda () (LibrariesC-45TextC-45Lexer-is #\|))) (lambda () (LibrariesC-45TextC-45Lexer-is #\|))) (lambda () csegen-459)))
(define ParserC-45LexerC-45Source-dotIdent csegen-460)
(define ParserC-45LexerC-45Source-doubleLit (vector 5 (vector 5 (vector 5 LibrariesC-45TextC-45Lexer-digits (lambda () (LibrariesC-45TextC-45Lexer-is #\.))) (lambda () LibrariesC-45TextC-45Lexer-digits)) (lambda () (LibrariesC-45TextC-45Lexer-opt (vector 5 (vector 5 (LibrariesC-45TextC-45Lexer-is #\e) (lambda () (LibrariesC-45TextC-45Lexer-opt (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 (LibrariesC-45TextC-45Lexer-is #\-) (LibrariesC-45TextC-45Lexer-is #\+))))) (lambda () LibrariesC-45TextC-45Lexer-digits))))))
(define ParserC-45LexerC-45Source-n--6514-10627-u--castBin (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\1) 1)(else 0))))
(define ParserC-45LexerC-45Source-n--6514-10628-u--fromBin (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 0) (* (ParserC-45LexerC-45Source-n--6514-10628-u--fromBin arg-0 e-3) 2))(else (+ e-2 (* (ParserC-45LexerC-45Source-n--6514-10628-u--fromBin arg-0 e-3) 2)))))))))
(define ParserC-45LexerC-45Source-fromBinLit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length arg-0) 2))) (cond ((equal? sc0 1) 0) (else (let ((u--num (substring (substring arg-0 1 (string-length arg-0)) 1 (string-length (substring arg-0 1 (string-length arg-0)))))) (ParserC-45LexerC-45Source-n--6514-10628-u--fromBin arg-0 (PreludeC-45TypesC-45List-reverse (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45LexerC-45Source-n--6514-10627-u--castBin arg-0 eta-0)) (PreludeC-45Types-fastUnpack u--num))))))))))
(define ProtocolC-45Hex-fromHexDigit (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7)) ((equal? arg-0 #\8) (box 8)) ((equal? arg-0 #\9) (box 9)) ((equal? arg-0 #\a) (box 10)) ((equal? arg-0 #\b) (box 11)) ((equal? arg-0 #\c) (box 12)) ((equal? arg-0 #\d) (box 13)) ((equal? arg-0 #\e) (box 14)) ((equal? arg-0 #\f) (box 15))(else '()))))
(define ProtocolC-45Hex-n--4720-3816-u--fromHexCharsC-39 (lambda (arg-0 arg-1) (if (null? arg-1) (box 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ProtocolC-45Hex-fromHexDigit (PreludeC-45Types-toLower e-2)) (lambda (u--digit) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ProtocolC-45Hex-n--4720-3816-u--fromHexCharsC-39 (* arg-0 16) e-3) (lambda (u--digits) (box (+ (* u--digit arg-0) u--digits)))))))))))
(define ProtocolC-45Hex-fromHexChars (lambda (ext-0) (ProtocolC-45Hex-n--4720-3816-u--fromHexCharsC-39 1 ext-0)))
(define ProtocolC-45Hex-fromHex (lambda (ext-0) (ProtocolC-45Hex-fromHexChars (PreludeC-45Types-fastUnpack ext-0))))
(define ParserC-45LexerC-45Source-fromHexLit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length arg-0) 2))) (cond ((equal? sc0 1) 0) (else (let ((u--num (substring (substring arg-0 1 (string-length arg-0)) 1 (string-length (substring arg-0 1 (string-length arg-0)))))) (DataC-45Maybe-fromMaybe (lambda () 0) (ProtocolC-45Hex-fromHex (string-reverse u--num)))))))))
(define LibrariesC-45UtilsC-45Octal-fromOctDigit (lambda (arg-0) (cond ((equal? arg-0 #\0) (box 0)) ((equal? arg-0 #\1) (box 1)) ((equal? arg-0 #\2) (box 2)) ((equal? arg-0 #\3) (box 3)) ((equal? arg-0 #\4) (box 4)) ((equal? arg-0 #\5) (box 5)) ((equal? arg-0 #\6) (box 6)) ((equal? arg-0 #\7) (box 7))(else '()))))
(define LibrariesC-45UtilsC-45Octal-n--2859-1319-u--fromOctCharsC-39 (lambda (arg-0 arg-1) (if (null? arg-1) (box 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Octal-fromOctDigit (PreludeC-45Types-toLower e-2)) (lambda (u--digit) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45UtilsC-45Octal-n--2859-1319-u--fromOctCharsC-39 (* arg-0 8) e-3) (lambda (u--digits) (box (+ (* u--digit arg-0) u--digits)))))))))))
(define LibrariesC-45UtilsC-45Octal-fromOctChars (lambda (ext-0) (LibrariesC-45UtilsC-45Octal-n--2859-1319-u--fromOctCharsC-39 1 ext-0)))
(define LibrariesC-45UtilsC-45Octal-fromOct (lambda (ext-0) (LibrariesC-45UtilsC-45Octal-fromOctChars (PreludeC-45Types-fastUnpack ext-0))))
(define ParserC-45LexerC-45Source-fromOctLit (lambda (arg-0) (let ((sc0 (PreludeC-45Types-u--C-60C-61_Ord_Nat (PreludeC-45TypesC-45String-length arg-0) 2))) (cond ((equal? sc0 1) 0) (else (let ((u--num (substring (substring arg-0 1 (string-length arg-0)) 1 (string-length (substring arg-0 1 (string-length arg-0)))))) (DataC-45Maybe-fromMaybe (lambda () 0) (LibrariesC-45UtilsC-45Octal-fromOct (string-reverse u--num)))))))))
(define LibrariesC-45TextC-45Lexer-like (lambda (arg-0) (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--y) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char (PreludeC-45Types-toUpper arg-0) (PreludeC-45Types-toUpper u--y))))))
(define LibrariesC-45TextC-45Lexer-approx (lambda (arg-0) (let ((sc0 (PreludeC-45Types-fastUnpack arg-0))) (if (null? sc0) LibrariesC-45TextC-45LexerC-45Core-fail (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (LibrariesC-45TextC-45LexerC-45Core-concatMap (lambda (eta-0) (LibrariesC-45TextC-45Lexer-like eta-0)) (cons e-2 e-3))))))))
(define LibrariesC-45TextC-45Lexer-hexLit (vector 5 (LibrariesC-45TextC-45Lexer-approx "0x") (lambda () LibrariesC-45TextC-45Lexer-hexDigits)))
(define LibrariesC-45TextC-45Lexer-hexUnderscoredLit (vector 5 LibrariesC-45TextC-45Lexer-hexLit (lambda () (LibrariesC-45TextC-45Lexer-many (vector 5 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () LibrariesC-45TextC-45Lexer-hexDigits))))))
(define ParserC-45LexerC-45Source-holeIdent csegen-436)
(define LibrariesC-45TextC-45LexerC-45Tokenizer-match (lambda (ext-0 ext-1) (vector 0 ext-0 ext-1)))
(define ParserC-45LexerC-45Source-mkDirective (lambda (arg-0) (vector 16 (DataC-45String-trim (PreludeC-45Types-substr 3 (PreludeC-45TypesC-45String-length arg-0) arg-0)))))
(define ParserC-45LexerC-45Source-multilineBegin (vector 5 (vector 5 (vector 6 csegen-303 (LibrariesC-45TextC-45Lexer-exact "\"\"\"")) (lambda () (LibrariesC-45TextC-45Lexer-manyUntil LibrariesC-45TextC-45Lexer-newline LibrariesC-45TextC-45Lexer-space))) (lambda () LibrariesC-45TextC-45Lexer-newline)))
(define ParserC-45LexerC-45Source-multilineEnd (lambda (arg-0) (string-append "\"\"\"" (DataC-45String-replicate arg-0 #\#))))
(define LibrariesC-45TextC-45Lexer-octLit (vector 5 (LibrariesC-45TextC-45Lexer-exact "0o") (lambda () LibrariesC-45TextC-45Lexer-octDigits)))
(define LibrariesC-45TextC-45Lexer-octUnderscoredLit (vector 5 LibrariesC-45TextC-45Lexer-octLit (lambda () (LibrariesC-45TextC-45Lexer-many (vector 5 (LibrariesC-45TextC-45Lexer-is #\_) (lambda () LibrariesC-45TextC-45Lexer-octDigits))))))
(define ParserC-45LexerC-45Source-pragma (vector 5 (LibrariesC-45TextC-45Lexer-is #\%) (lambda () ParserC-45LexerC-45Common-identNormal)))
(define ParserC-45LexerC-45Source-stringBegin (vector 6 csegen-303 (LibrariesC-45TextC-45Lexer-is #\")))
(define ParserC-45LexerC-45Source-stringEnd (lambda (arg-0) (string-append "\"" (DataC-45String-replicate arg-0 #\#))))
(define LibrariesC-45TextC-45Lexer-someUntil (lambda (arg-1 arg-2) (LibrariesC-45TextC-45Lexer-some (vector 6 (LibrariesC-45TextC-45LexerC-45Core-reject arg-1) arg-2))))
(define ParserC-45LexerC-45Source-stringTokens (lambda (arg-0 arg-1) (let ((u--escapeChars (string-append "\\" (DataC-45String-replicate arg-1 #\#)))) (let ((u--interpStart (string-append u--escapeChars "{"))) (let ((u--escapeLexer (LibrariesC-45TextC-45Lexer-escape (LibrariesC-45TextC-45Lexer-exact u--escapeChars) LibrariesC-45TextC-45Lexer-any))) (let ((u--charLexer (LibrariesC-45TextC-45Lexer-non (LibrariesC-45TextC-45Lexer-exact (cond ((equal? arg-0 1) (ParserC-45LexerC-45Source-multilineEnd arg-1)) (else (ParserC-45LexerC-45Source-stringEnd arg-1))))))) (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-someUntil (LibrariesC-45TextC-45Lexer-exact u--interpStart) (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 u--escapeLexer u--charLexer)) (lambda (u--x) (vector 7 u--x))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (LibrariesC-45TextC-45Lexer-exact u--interpStart) (lambda (eta-0) (vector 5 )) (lambda (eta-0) (vector 0 )) (lambda () (lambda (_-10855) (ParserC-45LexerC-45Source-rawTokens))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-is #\})) (lambda (eta-0) (vector 6 )))))))))))
(define LibrariesC-45TextC-45Lexer-symbol (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (u--x) (let ((sc0 (let ((sc1 (PreludeC-45Types-isSpace u--x))) (cond ((equal? sc1 1) 1) (else (PreludeC-45Types-isAlphaNum u--x)))))) (cond ((equal? sc0 1) 0) (else 1))))))
(define ParserC-45LexerC-45Source-validSymbol (LibrariesC-45TextC-45Lexer-some (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) (CoreC-45Name-isOpChar eta-0)))))
(define PreludeC-45Types-count (lambda (arg-2 arg-3 ext-0) (let ((e-6 (vector-ref arg-2 5))) (((((e-6 'erased) 'erased) (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45InterfacesC-45NumC-45Semigroup-u--C-60C-43C-62_Semigroup_AdditiveC-36a csegen-110 arg-8474 arg-8477))) (PreludeC-45InterfacesC-45NumC-45Monoid-u--neutral_Monoid_AdditiveC-36a csegen-110))) (lambda (u--x) (let ((sc0 (arg-3 u--x))) (cond ((equal? sc0 1) 1) (else 0))))) ext-0))))
(define ParserC-45LexerC-45Source-n--6676-10866-u--countHashtag (lambda (ext-0) (PreludeC-45Types-count csegen-14 (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-0 #\#)) (PreludeC-45Types-fastUnpack ext-0))))
(define ParserC-45LexerC-45Source-fixityKeywords (cons "infixl" (cons "infixr" (cons "infix" (cons "prefix" '())))))
(define ParserC-45LexerC-45Source-keywords (PreludeC-45TypesC-45List-tailRecAppend (cons "data" (cons "module" (cons "where" (cons "let" (cons "in" (cons "do" (cons "record" (cons "auto" (cons "default" (cons "implicit" (cons "failing" (cons "mutual" (cons "namespace" (cons "parameters" (cons "with" (cons "proof" (cons "impossible" (cons "case" (cons "of" (cons "if" (cons "then" (cons "else" (cons "forall" (cons "rewrite" (cons "using" (cons "interface" (cons "implementation" (cons "open" (cons "import" (cons "public" (cons "export" (cons "private" '())))))))))))))))))))))))))))))))) (PreludeC-45TypesC-45List-tailRecAppend ParserC-45LexerC-45Source-fixityKeywords (cons "total" (cons "partial" (cons "covering" '()))))))
(define ParserC-45LexerC-45Source-n--6676-10867-u--parseIdent (lambda (arg-0) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-22 arg-0 ParserC-45LexerC-45Source-keywords))) (cond ((equal? sc0 1) (vector 18 arg-0)) (else (vector 9 arg-0))))))
(define ParserC-45LexerC-45Source-n--6676-10868-u--parseNamespace (lambda (arg-0) (let ((sc0 (CoreC-45NameC-45Namespace-mkNamespacedIdent arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) (ParserC-45LexerC-45Source-n--6676-10867-u--parseIdent e-3) (let ((e-6 (unbox e-2))) (vector 10 e-6 e-3))))))))
(define ParserC-45LexerC-45Source-n--6676-10869-u--removeOptionalLeadingSpace (lambda (arg-0) (let ((sc0 (DataC-45String-strM arg-0))) (if (null? sc0) arg-0 (let ((e-0 (car sc0))) (let ((e-1 (cdr sc0))) (cond ((equal? e-0 #\ ) e-1)(else arg-0))))))))
(define ParserC-45LexerC-45Source-n--6676-10870-u--removeUnderscores (lambda (arg-0) (PreludeC-45Types-fastPack (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-1) (PreludeC-45EqOrd-u--C-47C-61_Eq_Char arg-1 #\_)) (PreludeC-45Types-fastUnpack arg-0)))))
(define ParserC-45LexerC-45Source-rawTokens (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Common-comment (lambda (eta-0) (vector 14 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-blockComment (lambda (eta-0) (vector 14 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-docComment (lambda (eta-0) (vector 15 (ParserC-45LexerC-45Source-n--6676-10869-u--removeOptionalLeadingSpace (LibrariesC-45DataC-45StringC-45Extra-drop 3 eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-cgDirective (lambda (eta-0) (ParserC-45LexerC-45Source-mkDirective eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-holeIdent (lambda (u--x) (vector 8 (substring u--x 1 (string-length u--x))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (LibrariesC-45TextC-45Lexer-choice 1 csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact eta-0)) ParserC-45LexerC-45Source-groupSymbols)) (lambda (eta-0) (vector 12 eta-0)) (lambda (eta-0) eta-0) (lambda () (lambda (_-11037) (ParserC-45LexerC-45Source-rawTokens))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact (ParserC-45LexerC-45Source-groupClose eta-0))) (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-choice 1 csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact (Builtin-fst eta-0))) ParserC-45LexerC-45Source-debugInfo)) (lambda (eta-0) (vector 20 (DataC-45Maybe-fromMaybe (lambda () 0) (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (DataC-45List-lookup csegen-22 eta-1 eta-2))) ParserC-45LexerC-45Source-debugInfo eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-choice 1 csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact eta-0)) ParserC-45LexerC-45Source-symbols)) (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-doubleLit (lambda (eta-0) (vector 1 (cast-string-double eta-0)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-binUnderscoredLit (lambda (eta-0) (vector 2 (ParserC-45LexerC-45Source-fromBinLit (ParserC-45LexerC-45Source-n--6676-10870-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-hexUnderscoredLit (lambda (eta-0) (vector 2 (ParserC-45LexerC-45Source-fromHexLit (ParserC-45LexerC-45Source-n--6676-10870-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-octUnderscoredLit (lambda (eta-0) (vector 2 (ParserC-45LexerC-45Source-fromOctLit (ParserC-45LexerC-45Source-n--6676-10870-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-digitsUnderscoredLit (lambda (eta-0) (vector 2 (cast-string-int (ParserC-45LexerC-45Source-n--6676-10870-u--removeUnderscores eta-0))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose ParserC-45LexerC-45Source-multilineBegin (lambda (u--begin) (vector 3 (ParserC-45LexerC-45Source-n--6676-10866-u--countHashtag u--begin) 0)) (lambda (eta-0) (ParserC-45LexerC-45Source-n--6676-10866-u--countHashtag eta-0)) (lambda () (lambda (eta-0) (ParserC-45LexerC-45Source-stringTokens 1 eta-0))) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact (ParserC-45LexerC-45Source-multilineEnd eta-0))) (lambda (eta-0) (vector 4 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose ParserC-45LexerC-45Source-stringBegin (lambda (u--begin) (vector 3 (ParserC-45LexerC-45Source-n--6676-10866-u--countHashtag u--begin) 1)) (lambda (eta-0) (ParserC-45LexerC-45Source-n--6676-10866-u--countHashtag eta-0)) (lambda () (lambda (eta-0) (ParserC-45LexerC-45Source-stringTokens 0 eta-0))) (lambda (u--hashtag) (vector 5 (LibrariesC-45TextC-45Lexer-exact (ParserC-45LexerC-45Source-stringEnd u--hashtag)) (lambda () (LibrariesC-45TextC-45LexerC-45Core-reject (LibrariesC-45TextC-45Lexer-is #\"))))) (lambda (eta-0) (vector 4 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-charLit (lambda (eta-0) (vector 0 (LibrariesC-45UtilsC-45String-stripQuotes eta-0)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-dotIdent (lambda (u--x) (vector 11 (substring u--x 1 (string-length u--x))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Common-namespacedIdent (lambda (eta-0) (ParserC-45LexerC-45Source-n--6676-10868-u--parseNamespace eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Common-identNormal (lambda (eta-0) (ParserC-45LexerC-45Source-n--6676-10867-u--parseIdent eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-pragma (lambda (u--x) (vector 19 (substring u--x 1 (string-length u--x))))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-space (lambda (eta-0) (vector 13 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Source-validSymbol (lambda (eta-0) (vector 12 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-symbol (lambda (eta-0) (vector 21 eta-0)))))))))))))))))))))))))))))))))))))))))))))))))
(define ParserC-45LexerC-45Source-n--7078-11274-u--isNotSpace (lambda (arg-0 arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (case (vector-ref e-1 0) ((13) 0)(else 1)))))
(define ParserC-45LexerC-45Source-n--7078-11275-u--spotComment (lambda (arg-0 arg-1 arg-2) (let ((e-1 (vector-ref arg-2 0))) (case (vector-ref e-1 0) ((14) (vector 0 (LibrariesC-45TextC-45Bounded-u--map_Functor_WithBounds (lambda (eta-0) (vector 0 )) arg-2)))(else (vector 1 arg-2))))))
(define ParserC-45LexerC-45Source-case--lexTo-11350 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) (vector 0 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-6 0) ((0) (if (null? e-7) (vector 0 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (vector 0 e-3) (let ((e-14 (car e-11))) (let ((u--end (cons (vector (vector 17 ) 0 (vector e-10 e-14 e-10 e-14)) '()))) (vector 1 (let ((sc5 (DataC-45Either-partitionEithers (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45LexerC-45Source-n--7078-11275-u--spotComment arg-0 arg-1 eta-0)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (ParserC-45LexerC-45Source-n--7078-11274-u--isNotSpace arg-0 arg-1 eta-0)) e-2))))) (let ((e-5 (car sc5))) (let ((e-4 (cdr sc5))) (cons e-5 (PreludeC-45TypesC-45List-tailRecAppend e-4 u--end)))))))))))))(else (vector 0 e-3))))))))))
(define ParserC-45LexerC-45Source-lexTo (lambda (arg-0 arg-1) (ParserC-45LexerC-45Source-case--lexTo-11350 arg-1 arg-0 (LibrariesC-45TextC-45LexerC-45Tokenizer-lexTo arg-0 (ParserC-45LexerC-45Source-rawTokens) arg-1))))
(define LibrariesC-45TextC-45ParserC-45Core-parseWith (lambda (arg-3 arg-4 arg-5 arg-6) (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-doParse (let ((e-1 (car arg-3))) e-1) (let ((e-2 (cdr arg-3))) e-2) '() 0 arg-5 arg-6))) (case (vector-ref sc0 0) ((0) (let ((e-5 (vector-ref sc0 3))) (vector 0 e-5))) (else (let ((e-9 (vector-ref sc0 1))) (let ((e-10 (vector-ref sc0 2))) (let ((e-12 (vector-ref sc0 4))) (let ((e-13 (vector-ref sc0 5))) (vector 1 (cons e-9 (cons e-10 (cons (let ((e-1 (vector-ref e-12 0))) e-1) e-13)))))))))))))
(define LibrariesC-45TextC-45Literate-untilEOL (LibrariesC-45TextC-45Lexer-manyUntil LibrariesC-45TextC-45Lexer-newline LibrariesC-45TextC-45Lexer-any))
(define LibrariesC-45TextC-45Literate-block (lambda (arg-0 arg-1) (LibrariesC-45TextC-45Lexer-surround (vector 5 (LibrariesC-45TextC-45Lexer-exact arg-0) (lambda () LibrariesC-45TextC-45Literate-untilEOL)) (vector 5 (LibrariesC-45TextC-45Lexer-exact arg-1) (lambda () LibrariesC-45TextC-45Literate-untilEOL)) LibrariesC-45TextC-45Lexer-any)))
(define LibrariesC-45TextC-45Literate-line (lambda (arg-0) (vector 5 (LibrariesC-45TextC-45Lexer-exact arg-0) (lambda () (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45Lexer-newline (vector 5 LibrariesC-45TextC-45Lexer-space (lambda () LibrariesC-45TextC-45Literate-untilEOL)))))))
(define LibrariesC-45TextC-45Literate-notCodeLine (LibrariesC-45TextC-45LexerC-45Core-C-60C-124C-62 LibrariesC-45TextC-45Lexer-newline (vector 5 LibrariesC-45TextC-45Lexer-any (lambda () LibrariesC-45TextC-45Literate-untilEOL))))
(define LibrariesC-45TextC-45Literate-rawTokens (lambda (arg-0 arg-1) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (LibrariesC-45TextC-45Literate-block e-2 e-3) (lambda (eta-0) (vector 0 (DataC-45String-trim e-2) (DataC-45String-trim e-3) eta-0)))))) arg-0) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--m) (cons (LibrariesC-45TextC-45Literate-line u--m) (lambda (eta-0) (vector 2 (DataC-45String-trim u--m) eta-0)))) arg-1) (cons (cons LibrariesC-45TextC-45Literate-notCodeLine (lambda (eta-0) (vector 1 eta-0))) '())))))
(define LibrariesC-45TextC-45Literate-case--lexLiterate-11715 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cond ((equal? e-11 "") (vector 1 e-2))(else (vector 0 (vector e-6 e-10 e-11))))))))))))
(define LibrariesC-45TextC-45Literate-lexLiterate (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45Literate-case--lexLiterate-11715 e-2 e-1 e-0 arg-1 (LibrariesC-45TextC-45LexerC-45Core-lex (LibrariesC-45TextC-45Literate-rawTokens e-0 e-1) arg-1)))))))
(define LibrariesC-45TextC-45Literate-with--withC-32blockC-32inC-32reduce-11494 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (if (null? arg-0) (case (vector-ref arg-1 0) ((0) (LibrariesC-45TextC-45Literate-reduce arg-6 arg-5))(else (let ((e-2 (vector-ref arg-1 2))) (LibrariesC-45TextC-45Literate-reduce arg-6 (cons (DataC-45String-fastUnlines e-2) (cons "\xa;" arg-5)))))) (let ((e-2 (vector-ref arg-1 2))) (LibrariesC-45TextC-45Literate-reduce arg-6 (cons (DataC-45String-fastUnlines e-2) (cons "\xa;" arg-5)))))))
(define LibrariesC-45TextC-45Literate-with--reduce-11479 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-1) (LibrariesC-45TextC-45Literate-reduce arg-6 arg-7) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (LibrariesC-45TextC-45Literate-with--withC-32blockC-32inC-32reduce-11494 e-3 (DataC-45ListC-45Views-snocList e-3) arg-2 arg-3 e-2 arg-7 arg-6 arg-5 arg-4 arg-0))))))
(define LibrariesC-45TextC-45Literate-reduce (lambda (arg-0 arg-1) (if (null? arg-0) (PreludeC-45Types-fastConcat (PreludeC-45TypesC-45List-reverse arg-1)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-5 (vector-ref e-2 0))) (let ((e-6 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 2))) (case (vector-ref e-5 0) ((1) (let ((e-8 (vector-ref e-5 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-8 "\xa;"))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45Literate-reduce e-3 (cons "\xa;" arg-1))) (else (LibrariesC-45TextC-45Literate-reduce e-3 arg-1)))))) ((2) (let ((e-9 (vector-ref e-5 1))) (let ((e-10 (vector-ref e-5 2))) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-9 (DataC-45String-trim e-10)))) (cond ((equal? sc2 1) (LibrariesC-45TextC-45Literate-reduce e-3 (cons "\xa;" arg-1))) (else (LibrariesC-45TextC-45Literate-reduce e-3 (cons (PreludeC-45Types-substr (+ (PreludeC-45TypesC-45String-length e-9) 1) (PreludeC-45TypesC-45String-length e-10) e-10) arg-1)))))))) (else (let ((e-11 (vector-ref e-5 1))) (let ((e-12 (vector-ref e-5 2))) (let ((e-13 (vector-ref e-5 3))) (LibrariesC-45TextC-45Literate-with--reduce-11479 e-13 (DataC-45String-lines e-13) e-6 e-7 e-12 e-11 e-3 arg-1))))))))))))))
(define LibrariesC-45TextC-45Literate-extractCode (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45TextC-45Literate-lexLiterate arg-0 arg-1))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45Literate-reduce eta-0 eta-1))) '() e-5))))))))
(define LibrariesC-45TextC-45Literate-unlit (lambda (ext-0 ext-1) (LibrariesC-45TextC-45Literate-extractCode ext-0 ext-1)))
(define ParserC-45Unlit-unlit (lambda (arg-0 arg-1) (if (null? arg-0) (vector 1 arg-1) (let ((e-2 (unbox arg-0))) (LibrariesC-45TextC-45Literate-unlit e-2 arg-1)))))
(define PreludeC-45TypesC-45SnocList-reverseOnto (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (PreludeC-45TypesC-45SnocList-reverseOnto (cons arg-1 e-3) e-2))))))
(define PreludeC-45TypesC-45SnocList-reverse (lambda (ext-0) (PreludeC-45TypesC-45SnocList-reverseOnto '() ext-0)))
(define PreludeC-45TypesC-45SnocList-tailRecAppend (lambda (arg-1 arg-2) (PreludeC-45TypesC-45SnocList-reverseOnto arg-1 (PreludeC-45TypesC-45SnocList-reverse arg-2))))
(define ParserC-45RuleC-45Source-u--C-60C-43C-62_Semigroup_ParsingState (lambda (arg-0 arg-1) (let ((e-1 (car arg-0))) (let ((e-2 (cdr arg-0))) (let ((e-4 (car arg-1))) (let ((e-5 (cdr arg-1))) (cons (PreludeC-45TypesC-45SnocList-tailRecAppend e-1 e-4) (PreludeC-45TypesC-45List-tailRecAppend e-2 e-5))))))))
(define ParserC-45RuleC-45Source-u--neutral_Monoid_ParsingState (cons '() '()))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquote ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squote (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\'))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squotes (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-enclose LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squote LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squote ext-0)))
(define ParserC-45LexerC-45Source-u--pretty_Pretty_Void_Token (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "character") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-squotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-0))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "double") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Double e-1))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "literal") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Integer e-2))))) ((3) (let ((e-4 (vector-ref arg-0 2))) (cond ((equal? e-4 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string begin")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "multiline string begin"))))) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string end")) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string interp begin")) ((6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string interp end")) ((7) (let ((e-5 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "string") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-5))))) ((8) (let ((e-6 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "hole identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-6)))) ((9) (let ((e-7 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-7)))) ((10) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "namespaced identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_Namespace e-8) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dot) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-9)))))) ((11) (let ((e-10 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "dot+identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-10)))) ((12) (let ((e-11 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "symbol") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-11)))) ((13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "space")) ((14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "comment")) ((15) (let ((e-12 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "doc comment:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-12))))) ((16) (let ((e-13 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "CGDirective") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-13)))) ((17) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "end of input")) ((18) (let ((e-14 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-14))) ((19) (let ((e-15 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "pragma") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-15)))) ((20) (let ((e-16 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (ParserC-45LexerC-45Source-u--show_Show_DebugInfo e-16)))) (else (let ((e-17 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "Unrecognised") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-17)))))))
(define ParserC-45LexerC-45Source-u--prettyPrec_Pretty_Void_Token (lambda (arg-0 arg-1) (ParserC-45LexerC-45Source-u--pretty_Pretty_Void_Token arg-1)))
(define ParserC-45LexerC-45Source-u--show_Show_Token (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (string-append "character " (PreludeC-45Show-u--show_Show_String e-0)))) ((1) (let ((e-1 (vector-ref arg-0 1))) (string-append "double " (PreludeC-45Show-u--show_Show_Double e-1)))) ((2) (let ((e-2 (vector-ref arg-0 1))) (string-append "literal " (PreludeC-45Show-u--show_Show_Integer e-2)))) ((3) (let ((e-4 (vector-ref arg-0 2))) (cond ((equal? e-4 1) "string begin") (else "multiline string begin")))) ((4) "string end") ((5) "string interp begin") ((6) "string interp end") ((7) (let ((e-5 (vector-ref arg-0 1))) (string-append "string " (PreludeC-45Show-u--show_Show_String e-5)))) ((8) (let ((e-6 (vector-ref arg-0 1))) (string-append "hole identifier " e-6))) ((9) (let ((e-7 (vector-ref arg-0 1))) (string-append "identifier " e-7))) ((10) (let ((e-8 (vector-ref arg-0 1))) (let ((e-9 (vector-ref arg-0 2))) (string-append "namespaced identifier " (string-append (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-8) (string-append "." (PreludeC-45Show-u--show_Show_String e-9))))))) ((11) (let ((e-10 (vector-ref arg-0 1))) (string-append "dot+identifier " e-10))) ((12) (let ((e-11 (vector-ref arg-0 1))) (string-append "symbol " e-11))) ((13) "whitespace") ((14) "comment") ((15) (let ((e-12 (vector-ref arg-0 1))) (string-append "doc comment: \"" (string-append e-12 "\"")))) ((16) (let ((e-13 (vector-ref arg-0 1))) (string-append "CGDirective " e-13))) ((17) "end of input") ((18) (let ((e-14 (vector-ref arg-0 1))) e-14)) ((19) (let ((e-15 (vector-ref arg-0 1))) (string-append "pragma " e-15))) ((20) (let ((e-16 (vector-ref arg-0 1))) (ParserC-45LexerC-45Source-u--show_Show_DebugInfo e-16))) (else (let ((e-17 (vector-ref arg-0 1))) (string-append "Unrecognised " e-17))))))
(define ParserC-45LexerC-45Source-u--showPrec_Show_Token (lambda (arg-0 arg-1) (ParserC-45LexerC-45Source-u--show_Show_Token arg-1)))
(define DataC-45SnocList-u--cast_Cast_C-40SnocListC-32C-36aC-41_C-40ListC-32C-36aC-41 (lambda (arg-1) (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-1 '())))
(define ParserC-45RuleC-45Source-toState (lambda (arg-0) (let ((e-1 (car arg-0))) (let ((e-2 (cdr arg-0))) (cons (DataC-45SnocList-u--cast_Cast_C-40SnocListC-32C-36aC-41_C-40ListC-32C-36aC-41 e-1) e-2)))))
(define ParserC-45Source-n--5810-5761-u--state (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (let ((sc0 (ParserC-45RuleC-45Source-toState arg-12))) (let ((e-1 (car sc0))) (let ((e-2 (cdr sc0))) (cons (PreludeC-45TypesC-45List-tailRecAppend arg-16 e-1) e-2))))))
(define ParserC-45Source-runParserTo (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ParserC-45Unlit-unlit arg-3 arg-5))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLitError arg-2 e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (u--str) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ParserC-45LexerC-45Source-lexTo arg-4 u--str))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (ParserC-45Support-fromLexError arg-2 e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc1 (LibrariesC-45TextC-45ParserC-45Core-parseWith (cons (lambda (arg-8474) (lambda (arg-8477) (ParserC-45RuleC-45Source-u--C-60C-43C-62_Semigroup_ParsingState arg-8474 arg-8477))) ParserC-45RuleC-45Source-u--neutral_Monoid_ParsingState) arg-1 arg-6 e-3))) (case (vector-ref sc1 0) ((0) (let ((e-4 (vector-ref sc1 1))) (vector 0 (ParserC-45Support-fromParsingErrors (cons (cons (lambda (u--x) (ParserC-45LexerC-45Source-u--show_Show_Token u--x)) (lambda (u--d) (lambda (u--x) (ParserC-45LexerC-45Source-u--showPrec_Show_Token u--d u--x)))) (cons (lambda (arg-11067) (ParserC-45LexerC-45Source-u--pretty_Pretty_Void_Token arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (ParserC-45LexerC-45Source-u--prettyPrec_Pretty_Void_Token arg-11073 arg-11076))))) arg-2 e-4)))) (else (let ((e-5 (vector-ref sc1 1))) (vector 1 e-5))))) (lambda (_-1) (let ((_-2 (cons e-2 e-3))) (let ((e-5 (car _-1))) (let ((e-4 (cdr _-1))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((u--cs (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--c) (cons (cons arg-2 (cons (LibrariesC-45TextC-45Bounded-start u--c) (LibrariesC-45TextC-45Bounded-end u--c))) (cons 0 '()))) e-2))) (let ((u--ws (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-9 (car lamc-0))) (let ((e-8 (cdr lamc-0))) (let ((u--mkFC (lambda (u--b) (vector 0 arg-2 (LibrariesC-45TextC-45Bounded-startBounds u--b) (LibrariesC-45TextC-45Bounded-endBounds u--b))))) (vector 0 (PreludeC-45Types-maybe (lambda () (vector 2 )) (lambda () u--mkFC) e-9) e-8))))) e-6))) (vector 1 (cons u--ws (cons (ParserC-45Source-n--5810-5761-u--state arg-1 arg-6 arg-5 arg-4 arg-3 arg-2 u--str e-2 e-3 _-2 e-11 e-5 e-6 e-10 _-1 u--cs u--ws) e-10))))))))))))))))))))))
(define IdrisC-45ProcessIdr-readHeader (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-2) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((IdrisC-45REPLC-45Opts-setCurrentElabSource arg-1 e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((sc3 (ParserC-45Source-runParserTo 0 (vector 0 arg-3) (ParserC-45Unlit-isLitFile arg-2) (LibrariesC-45TextC-45Lexer-is #\:) e-2 (IdrisC-45Parser-progHdr (vector 0 arg-3))))) (case (vector-ref sc3 0) ((1) (let ((e-3 (vector-ref sc3 1))) (let ((e-8 (car e-3))) (let ((e-9 (cdr e-3))) (let ((e-13 (cdr e-9))) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45Context-recordWarning arg-0 eta-0)) e-8) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 e-13))))))))) (else (let ((e-7 (vector-ref sc3 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-7 clam-0)))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 arg-2 e-6) clam-0))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addImported (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (cons arg-1 e-18) e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define LibrariesC-45DataC-45ANameMap-n--4361-13070-u--insertFrom (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (LibrariesC-45DataC-45ANameMap-n--4361-13070-u--insertFrom arg-1 arg-2 arg-3 e-3 (LibrariesC-45DataC-45ANameMap-addName e-6 e-7 arg-5)))))))))
(define LibrariesC-45DataC-45ANameMap-merge (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (LibrariesC-45DataC-45ANameMap-n--4361-13070-u--insertFrom e-2 e-1 arg-2 (LibrariesC-45DataC-45NameMap-toList e-1) arg-2)))))
(define LibrariesC-45DataC-45SortedMap-mergeLeft (lambda (ext-0 ext-1) (LibrariesC-45DataC-45SortedMap-mergeWith (lambda (eta-0) (lambda (eta-1) eta-0)) ext-0 ext-1)))
(define LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 (lambda (arg-2 arg-3) (string-append "fromList " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 arg-2 u--d u--x)))) (LibrariesC-45DataC-45SortedMap-toList arg-3)))))
(define IdrisC-45Desugar-n--14058-9250-u--removePrivate (lambda (arg-0 arg-1 arg-2 ext-0) (LibrariesC-45DataC-45ANameMap-fromList (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (CoreC-45TT-u--C-47C-61_Eq_Visibility (let ((sc0 (Builtin-snd eta-0))) (let ((e-1 (vector-ref sc0 1))) e-1)) 0)) (LibrariesC-45DataC-45ANameMap-toList ext-0)))))
(define IdrisC-45Desugar-extendSyn (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "doc.module" 20 (lambda () (DataC-45String-fastUnlines (cons (string-append "Old (" (string-append (DataC-45String-unwords (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-1)) (let ((e-1 (vector-ref e-5 1))) e-1))) (string-append "): " (LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 csegen-3969 (let ((e-2 (vector-ref e-5 2))) e-2))))) (cons (string-append "New (" (string-append (DataC-45String-unwords (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-1)) (let ((e-1 (vector-ref arg-2 1))) e-1))) (string-append "): " (LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 csegen-3969 (let ((e-2 (vector-ref arg-2 2))) e-2))))) '())))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--filteredFixities (IdrisC-45Desugar-n--14058-9250-u--removePrivate arg-2 arg-1 arg-0 (let ((e-0 (vector-ref arg-2 0))) e-0)))) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-13 (vector-ref e-5 5))) (let ((e-12 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector (LibrariesC-45DataC-45ANameMap-merge u--filteredFixities e-0) e-1 (LibrariesC-45DataC-45SortedMap-mergeLeft (let ((e-23 (vector-ref arg-2 2))) e-23) e-2) (LibrariesC-45DataC-45SortedMap-mergeLeft (let ((e-22 (vector-ref arg-2 3))) e-22) e-3) e-4 (LibrariesC-45DataC-45ANameMap-merge (let ((e-20 (vector-ref arg-2 5))) e-20) e-13) e-12 (LibrariesC-45DataC-45ANameMap-merge (let ((e-18 (vector-ref arg-2 7))) e-18) e-7) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-17 (vector-ref arg-2 8))) e-17) e-8) e-9 e-10 e-11)))))))))))))))) (vector 1 act-3))))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-addAutoHint (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-36 (vector-ref e-6 2))) (let ((e-35 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-36 e-35 e-4 e-34 e-33 e-7 (LibrariesC-45DataC-45NameMap-insert e-5 e-3 e-8) e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) ext-0)))))))))
(define CoreC-45Context-case--addAlias-5700 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) arg-0 (let ((e-2 (unbox arg-4))) (let ((sc1 (LibrariesC-45DataC-45UserNameMap-lookup e-2 arg-0))) (if (null? sc1) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 1 arg-3 arg-2 arg-1) '()) arg-0) (let ((e-3 (unbox sc1))) (LibrariesC-45DataC-45UserNameMap-insert e-2 (cons (vector 1 arg-3 arg-2 arg-1) e-3) arg-0))))))))
(define CoreC-45Context-addAlias (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45Context-case--addAlias-5700 arg-3 arg-2 arg-1 arg-0 (CoreC-45Name-userNameRoot arg-0))))
(define CoreC-45Context-newAlias (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45Context-getPosition arg-1 arg-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (vector 1 (let ((e-0 (vector-ref e-3 0))) (let ((e-1 (vector-ref e-3 1))) (let ((e-14 (vector-ref e-3 2))) (let ((e-13 (vector-ref e-3 3))) (let ((e-4 (vector-ref e-3 4))) (let ((e-12 (vector-ref e-3 5))) (let ((e-6 (vector-ref e-3 6))) (let ((e-7 (vector-ref e-3 7))) (let ((e-8 (vector-ref e-3 8))) (let ((e-9 (vector-ref e-3 9))) (let ((e-10 (vector-ref e-3 10))) (let ((e-11 (vector-ref e-3 11))) (vector e-0 e-1 e-14 (CoreC-45Context-addAlias arg-0 arg-1 e-2 e-13) e-4 e-12 e-6 e-7 e-8 e-9 e-10 e-11))))))))))))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-addContextAlias (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-1 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-3 (CoreC-45Context-newAlias arg-1 arg-2 (let ((e-0 (vector-ref e-5 0))) e-0) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (set-box! arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-7 e-1 e-2 e-3 e-4 e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-4))))) eff-0) clam-0))))) (vector 1 (vector 0 )))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45NameC-45Namespace-n--4832-8283-u--go (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((sc1 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-22 arg-0 (cons e-2 e-3)))) (cond ((equal? sc1 1) arg-1) (else (cons e-2 (CoreC-45NameC-45Namespace-n--4832-8283-u--go arg-0 arg-1 arg-2 e-3))))))))))
(define CoreC-45NameC-45Namespace-replace (lambda (arg-0 arg-1 arg-2) (CoreC-45NameC-45Namespace-n--4832-8283-u--go arg-0 arg-1 arg-2 arg-2)))
(define CoreC-45Name-asName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((4) (let ((e-0 (vector-ref arg-2 1))) (let ((e-1 (vector-ref arg-2 2))) (vector 4 e-0 (CoreC-45Name-asName arg-0 arg-1 e-1))))) ((0) (let ((e-2 (vector-ref arg-2 1))) (let ((e-3 (vector-ref arg-2 2))) (vector 0 (CoreC-45NameC-45Namespace-replace arg-0 arg-1 e-2) e-3))))(else arg-2))))
(define CoreC-45Binary-n--12952-17445-u--completeDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) 0 (let ((e-2 (unbox arg-6))) (let ((e-18 (vector-ref e-2 18))) (case (vector-ref e-18 0) ((0) 0) ((7) 0)(else 1)))))))
(define CoreC-45Binary-addGlobalDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupContextEntry e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((PreludeC-45Types-maybe (lambda () (lambda (eta-2) (vector 1 '()))) (lambda () (lambda (u--p) (lambda (eta-2) (let ((act-3 (CoreC-45Context-decode (let ((e-0 (vector-ref e-5 0))) e-0) (Builtin-fst u--p) 0 (Builtin-snd u--p) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (box e-7))))) eff-0) eta-2)))))))) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((sc4 (CoreC-45Binary-n--12952-17445-u--completeDef e-2 e-3 arg-3 arg-2 arg-1 arg-0 e-7))) (cond ((equal? sc4 1) (vector 1 (vector 0 ))) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Context-addContextEntry arg-0 arg-2 e-2 e-3 eta-3)) eta-2)))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (if (null? arg-3) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-3))) (CoreC-45Context-addContextAlias arg-0 (CoreC-45Name-asName arg-1 e-1 e-2) e-2 eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Context-n--35371-30174-u--addMod (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (if (null? arg-5) (cons (cons arg-3 (cons (cons e-2 '()) e-3)) '()) (let ((e-6 (car arg-5))) (let ((e-7 (cdr arg-5))) (let ((e-10 (car e-6))) (let ((e-11 (cdr e-6))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((sc4 (CoreC-45Options-u--C-61C-61_Eq_CG arg-3 e-10))) (cond ((equal? sc4 1) (cons (cons arg-3 (cons (cons e-2 e-14) (PreludeC-45TypesC-45List-tailRecAppend e-15 e-3))) e-7)) (else (cons (cons e-10 (cons e-14 e-15)) (CoreC-45Context-n--35371-30174-u--addMod arg-0 arg-1 arg-2 arg-3 (cons e-2 e-3) e-7))))))))))))))))
(define CoreC-45Context-n--35371-30175-u--drop (lambda (arg-0 arg-1 arg-2 arg-4 arg-5) (if (null? arg-5) '() (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((sc2 (CoreC-45Options-u--C-61C-61_Eq_CG arg-4 e-6))) (cond ((equal? sc2 1) e-3) (else (cons (cons e-6 e-7) (CoreC-45Context-n--35371-30175-u--drop arg-0 arg-1 arg-2 arg-4 e-3))))))))))))
(define CoreC-45Context-addImportedInc (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--cg (let ((e-4 (vector-ref e-5 4))) e-4))) (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-1331 u--cg (let ((e-22 (vector-ref e-5 22))) e-22)))) (cond ((equal? sc2 1) ((let ((sc3 (DataC-45List-lookup csegen-1331 u--cg arg-2))) (if (null? sc3) (lambda () (lambda (eta-1) (let ((act-3 ((CoreC-45Context-recordWarning arg-0 (vector 6 CoreC-45FC-emptyFC (string-append "No incremental compile data for " (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1)))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (set-box! arg-0 (let ((e-0 (vector-ref e-8 0))) (let ((e-1 (vector-ref e-8 1))) (let ((e-2 (vector-ref e-8 2))) (let ((e-3 (vector-ref e-8 3))) (let ((e-4 (vector-ref e-8 4))) (let ((e-36 (vector-ref e-8 5))) (let ((e-35 (vector-ref e-8 6))) (let ((e-34 (vector-ref e-8 7))) (let ((e-33 (vector-ref e-8 8))) (let ((e-9 (vector-ref e-8 9))) (let ((e-10 (vector-ref e-8 10))) (let ((e-11 (vector-ref e-8 11))) (let ((e-12 (vector-ref e-8 12))) (let ((e-13 (vector-ref e-8 13))) (let ((e-14 (vector-ref e-8 14))) (let ((e-15 (vector-ref e-8 15))) (let ((e-16 (vector-ref e-8 16))) (let ((e-17 (vector-ref e-8 17))) (let ((e-18 (vector-ref e-8 18))) (let ((e-19 (vector-ref e-8 19))) (let ((e-20 (vector-ref e-8 20))) (let ((e-21 (vector-ref e-8 21))) (let ((e-22 (vector-ref e-8 22))) (let ((e-23 (vector-ref e-8 23))) (let ((e-24 (vector-ref e-8 24))) (let ((e-25 (vector-ref e-8 25))) (let ((e-26 (vector-ref e-8 26))) (let ((e-27 (vector-ref e-8 27))) (let ((e-28 (vector-ref e-8 28))) (let ((e-29 (vector-ref e-8 29))) (let ((e-30 (vector-ref e-8 30))) (let ((e-31 (vector-ref e-8 31))) (let ((e-32 (vector-ref e-8 32))) (vector e-0 e-1 e-2 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 (CoreC-45Context-n--35371-30175-u--drop arg-2 arg-1 arg-0 u--cg e-23) e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((sc7 (PreludeC-45EqOrd-u--C-47C-61_Eq_String (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1) ""))) (cond ((equal? sc7 1) (let ((act-6 (CoreC-45Context-getSession arg-0 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-10 0))) (let ((e-1 (vector-ref e-10 1))) (let ((e-2 (vector-ref e-10 2))) (let ((e-3 (vector-ref e-10 3))) (let ((e-4 (vector-ref e-10 4))) (let ((e-30 (vector-ref e-10 5))) (let ((e-29 (vector-ref e-10 6))) (let ((e-28 (vector-ref e-10 7))) (let ((e-27 (vector-ref e-10 8))) (let ((e-26 (vector-ref e-10 9))) (let ((e-25 (vector-ref e-10 10))) (let ((e-11 (vector-ref e-10 11))) (let ((e-12 (vector-ref e-10 12))) (let ((e-13 (vector-ref e-10 13))) (let ((e-14 (vector-ref e-10 14))) (let ((e-15 (vector-ref e-10 15))) (let ((e-16 (vector-ref e-10 16))) (let ((e-17 (vector-ref e-10 17))) (let ((e-18 (vector-ref e-10 18))) (let ((e-19 (vector-ref e-10 19))) (let ((e-20 (vector-ref e-10 20))) (let ((e-21 (vector-ref e-10 21))) (let ((e-22 (vector-ref e-10 22))) (let ((e-23 (vector-ref e-10 23))) (let ((e-24 (vector-ref e-10 24))) (vector e-0 e-1 e-2 e-3 e-4 e-30 e-29 e-28 e-27 e-26 e-25 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (DataC-45List-delete csegen-1331 u--cg e-22) e-23 e-24))))))))))))))))))))))))))))) eff-0) eta-2)))))) (else (vector 1 (vector 0 ))))))))))) eff-0) eta-1)))))))))) (let ((e-2 (unbox sc3))) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (lambda () (lambda (eta-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-37 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-36 (vector-ref e-6 5))) (let ((e-35 (vector-ref e-6 6))) (let ((e-34 (vector-ref e-6 7))) (let ((e-33 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-37 e-3 e-4 e-36 e-35 e-34 e-33 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 (CoreC-45Context-n--35371-30174-u--addMod arg-2 arg-1 arg-0 u--cg (cons e-8 e-7) e-23) e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-3))))))))))) (else (lambda (eta-1) (vector 1 (vector 0 )))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-addTypeHint (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (let ((act-1 (CoreC-45Context-getFullName arg-0 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getFullName arg-0 e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45ContextC-45Log-unverifiedLogC arg-0 "ttc.read" 10 (lambda (eta-2) (vector 1 (string-append (CoreC-45Name-u--show_Show_Name e-5) (string-append " for " (CoreC-45Name-u--show_Show_Name e-8))))) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (CoreC-45Context-addHintFor arg-0 arg-1 e-2 e-6 e-7 1 clam-0)))))))))))
(define CoreC-45Context-clearSavedHints (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 '() '() e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Binary-getNSas (lambda (arg-0) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (cons e-6 e-11)))))))
(define CoreC-45TTC-u--fromBuf_TTC_PrimNames (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector e-5 e-6 e-7 e-8 e-9 e-10 e-11))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-n--11938-16498-u--replaceNS (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (case (vector-ref e-2 0) ((0) arg-9)(else (cons (vector 0 arg-8 e-2) e-3)))))))
(define CoreC-45Binary-readTTCFile (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TT2"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt (string-append "TTC header in " (string-append arg-4 (string-append " " (PreludeC-45Show-u--show_Show_String e-5)))) eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_WastefulInt arg-6 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Binary-checkTTCVersion arg-4 e-7 CoreC-45Binary-ttcVersion eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45TTC-u--fromBuf_TTC_TotalReq arg-6 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1559 arg-6 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-6 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1738 arg-6 eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1752 arg-6 eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1763 arg-6 eta-6))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-11 (let ((e-2 (cdr arg-1))) ((e-2 arg-6) eta-7)))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? arg-3 1) (let ((act-12 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1770 arg-6 clam-0))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-13 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-6 eta-8))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-14 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-48 arg-6 eta-9))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-15 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1774 arg-6 eta-10))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((e-19 (vector-ref act-15 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-16 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-6 eta-11))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-12) (let ((act-17 (CoreC-45TTC-u--fromBuf_TTC_Namespace arg-6 eta-12))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-13) (let ((act-18 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1734 arg-6 eta-13))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-14) (let ((act-19 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1777 arg-6 eta-14))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((e-23 (vector-ref act-19 1))) ((let ((eff-0 (lambda (eta-15) (let ((act-20 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1780 arg-6 eta-15))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((e-24 (vector-ref act-20 1))) ((let ((eff-0 (lambda (eta-16) (let ((act-21 (CoreC-45TTC-u--fromBuf_TTC_PrimNames arg-6 eta-16))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((e-25 (vector-ref act-21 1))) ((let ((eff-0 (lambda (eta-17) (let ((act-22 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1784 arg-6 eta-17))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((e-26 (vector-ref act-22 1))) ((let ((eff-0 (lambda (eta-18) (let ((act-23 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1788 arg-6 eta-18))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else (let ((e-27 (vector-ref act-23 1))) ((let ((eff-0 (lambda (eta-19) (let ((act-24 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1795 arg-6 eta-19))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-28 (vector-ref act-24 1))) ((let ((eff-0 (lambda (eta-20) (let ((act-25 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-1806 arg-6 eta-20))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-29 (vector-ref act-25 1))) ((let ((eff-0 (lambda (eta-21) (vector 1 (vector e-7 e-9 e-10 e-11 e-12 e-13 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-22) (CoreC-45Binary-n--11938-16498-u--replaceNS arg-1 arg-6 arg-5 arg-4 arg-3 arg-2 e-21 eta-22)) e-16) e-17 e-18 e-19 e-14 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-15))))) eff-0) eta-20)))))))) eff-0) eta-19)))))))) eff-0) eta-18)))))))) eff-0) eta-17)))))))) eff-0) eta-16)))))))) eff-0) eta-15)))))))) eff-0) eta-14)))))))) eff-0) eta-13)))))))) eff-0) eta-12)))))))) eff-0) eta-11)))))))) eff-0) eta-10)))))))) eff-0) eta-9)))))))) eff-0) eta-8)))))))) eff-0) clam-0)))))) (else (vector 1 (vector e-7 e-9 e-10 e-11 e-12 e-13 '() '() '() '() '() 0 (CoreC-45NameC-45Namespace-mkNamespace "") '() '() '() csegen-1338 '() '() '() '() e-15))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-resetFirstEntry (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-34 (vector-ref e-0 1))) (let ((e-35 (vector-ref e-0 2))) (let ((e-36 (vector-ref e-0 3))) (let ((e-37 (vector-ref e-0 4))) (let ((e-38 (vector-ref e-0 5))) (let ((e-39 (vector-ref e-0 6))) (let ((e-40 (vector-ref e-0 7))) (let ((e-41 (vector-ref e-0 8))) (let ((e-42 (vector-ref e-0 9))) (let ((e-43 (vector-ref e-0 10))) (let ((e-44 (vector-ref e-0 11))) (vector (vector (let ((e-78 (vector-ref e-5 0))) (let ((e-89 (vector-ref e-78 1))) e-89)) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42 e-43 e-44) e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-0) ext-0)))))))
(define CoreC-45Context-setNS (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 arg-1 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-setNestedNS (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 arg-1 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Binary-updateCGDirectives (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 (DataC-45List-nub (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1331 csegen-22 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1331 csegen-22 arg-686 arg-689)))) (PreludeC-45TypesC-45List-tailRecAppend arg-1 e-20)) e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Binary-updateFExports (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-37 (vector-ref e-5 2))) (let ((e-36 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-37 e-36 e-4 e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 (LibrariesC-45DataC-45NameMap-insert e-6 e-7 e-31) e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else ((CoreC-45Binary-updateFExports arg-0 e-3) eta-0))))))) eff-0) clam-0)))))))))))))
(define CoreC-45Binary-updateNameDirectives (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-37 (vector-ref e-5 2))) (let ((e-36 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-37 e-36 e-4 e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 (LibrariesC-45DataC-45NameMap-insert e-6 e-7 e-15) e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((CoreC-45Binary-updateNameDirectives arg-0 e-3) clam-0))))))))))))
(define CoreC-45Binary-updatePair (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 e-36 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 arg-1 e-37) e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Binary-updatePrimNames (lambda (arg-0 ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-4 (vector-ref ext-0 4))) (let ((e-5 (vector-ref ext-0 5))) (let ((e-6 (vector-ref ext-0 6))) (vector (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-13 (vector-ref arg-0 0))) e-13) e-0) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-12 (vector-ref arg-0 1))) e-12) e-1) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-11 (vector-ref arg-0 2))) e-11) e-2) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-10 (vector-ref arg-0 3))) e-10) e-3) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-9 (vector-ref arg-0 4))) e-9) e-4) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-8 (vector-ref arg-0 5))) e-8) e-5) (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 (let ((e-7 (vector-ref arg-0 6))) e-7) e-6)))))))))))
(define CoreC-45Binary-updatePrims (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 e-36 e-37 e-38 (CoreC-45Binary-updatePrimNames arg-1 e-39) e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Binary-updateRewrite (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (vector e-0 e-1 e-2 e-3 (vector e-43 e-34 e-35 e-36 e-37 (PreludeC-45Types-u--C-60C-43C-62_Semigroup_C-40MaybeC-32C-36aC-41 arg-1 e-38) e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Binary-n--13744-18199-u--addT (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup arg-4 (let ((e-13 (vector-ref e-5 13))) e-13)))) (if (null? sc1) (let ((act-2 (set-box! arg-3 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert arg-4 (cons arg-5 '()) e-13) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2)) (let ((e-2 (unbox sc1))) (let ((act-2 (set-box! arg-3 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-34 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-34 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 (LibrariesC-45DataC-45NameMap-insert arg-4 (cons arg-5 e-2) e-13) e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-updateTransforms (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 (vector 0 )) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toResolvedNames arg-0 csegen-1273 e-7 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Binary-n--13744-18199-u--addT e-6 e-7 e-3 arg-0 e-5 e-8 eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((CoreC-45Binary-updateTransforms arg-0 e-3) clam-0))))))))))))
(define CoreC-45Binary-n--14125-18568-u--alreadyDone (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) 0 (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-15 (cdr e-11))) (let ((sc4 (let ((sc5 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-10 e-10))) (cond ((equal? sc5 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-11 e-15)) (else 0))))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-10 e-10))) (cond ((equal? sc6 1) (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-10 arg-11)) (else 0))))) (cond ((equal? sc5 1) 1) (else (CoreC-45Binary-n--14125-18568-u--alreadyDone arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-3))))))))))))))))
(define CoreC-45Binary-readFromTTC (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1823 (cons arg-8 (cons arg-6 arg-9)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-19 (vector-ref e-5 19))) e-19))))) (cond ((equal? sc1 0) (let ((act-2 (let ((act-2 (set-box! arg-2 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 (cons (cons arg-7 (cons arg-8 (cons arg-6 arg-9))) e-19) e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (LibrariesC-45UtilsC-45Binary-readFromFile arg-7 clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-7 0) ((1) (let ((e-2 (vector-ref e-7 1))) (let ((act-4 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--as (let ((sc6 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-9 arg-8))) (cond ((equal? sc6 1) '()) (else (box arg-9)))))) (lambda (clam-2) (let ((sc6 (CoreC-45Binary-n--14125-18568-u--alreadyDone arg-1 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-8 arg-9 (let ((e-19 (vector-ref e-5 19))) e-19)))) (cond ((equal? sc6 1) (let ((act-5 (CoreC-45Binary-readTTCFile arg-1 arg-2 0 arg-7 u--as e-8 clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--ex (let ((e-22 (vector-ref e-9 21))) e-22))) (lambda (eta-0) (vector 1 (box (cons u--ex (cons (let ((e-4 (vector-ref e-9 3))) e-4) (let ((e-11 (vector-ref e-9 10))) e-11))))))))) eff-0) clam-2)))))) (else (let ((act-5 (CoreC-45Binary-readTTCFile arg-1 arg-2 1 arg-7 u--as e-8 clam-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--ex (let ((e-22 (vector-ref e-9 21))) e-22))) (lambda (eta-0) (let ((act-6 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Binary-addGlobalDef arg-2 arg-8 (let ((e-13 (vector-ref e-9 12))) e-13) u--as eta-1 eta-2))) (let ((e-25 (vector-ref e-9 6))) e-25)) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((act-7 ((CoreC-45Core-traverse_ (lambda (eta-1) (CoreC-45Context-addUserHole arg-2 1 eta-1)) (let ((e-25 (vector-ref e-9 7))) e-25)) eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((act-8 ((CoreC-45Context-setNS arg-2 (let ((e-13 (vector-ref e-9 12))) e-13)) eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((act-9 (cond ((equal? arg-4 1) ((CoreC-45Context-setNestedNS arg-2 (let ((e-14 (vector-ref e-9 13))) e-14)) eta-0)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((act-10 (let ((sc12 (PreludeC-45Types-elem csegen-14 csegen-276 arg-8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst (CoreC-45Binary-getNSas eta-1))) (let ((e-19 (vector-ref e-5 19))) e-19))))) (cond ((equal? sc12 1) (vector 1 (vector 0 ))) (else (let ((act-10 ((CoreC-45Core-traverse_ (lambda (eta-1) (CoreC-45Binary-addTypeHint arg-2 arg-5 eta-1)) (let ((e-26 (vector-ref e-9 9))) e-26)) eta-0))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((act-11 ((CoreC-45Core-traverse_ (lambda (eta-1) (lambda (eta-2) (CoreC-45Binary-addAutoHint arg-2 eta-1 eta-2))) (let ((e-28 (vector-ref e-9 8))) e-28)) eta-0))) (case (vector-ref act-11 0) ((0) (let ((e-3 (vector-ref act-11 1))) (vector 0 e-3))) (else (let ((act-12 (CoreC-45Context-addImportedInc arg-2 arg-8 (let ((e-32 (vector-ref e-9 5))) e-32) eta-0))) (case (vector-ref act-12 0) ((0) (let ((e-3 (vector-ref act-12 1))) (vector 0 e-3))) (else (let ((act-13 ((CoreC-45Binary-updatePair arg-2 (let ((e-24 (vector-ref e-9 14))) e-24)) eta-0))) (case (vector-ref act-13 0) ((0) (let ((e-3 (vector-ref act-13 1))) (vector 0 e-3))) (else (let ((act-14 ((CoreC-45Binary-updateRewrite arg-2 (let ((e-24 (vector-ref e-9 15))) e-24)) eta-0))) (case (vector-ref act-14 0) ((0) (let ((e-3 (vector-ref act-14 1))) (vector 0 e-3))) (else (let ((act-15 ((CoreC-45Binary-updatePrims arg-2 (let ((e-24 (vector-ref e-9 16))) e-24)) eta-0))) (case (vector-ref act-15 0) ((0) (let ((e-3 (vector-ref act-15 1))) (vector 0 e-3))) (else (let ((act-16 ((CoreC-45Binary-updateNameDirectives arg-2 (PreludeC-45TypesC-45List-reverse (let ((e-24 (vector-ref e-9 17))) e-24))) eta-0))) (case (vector-ref act-16 0) ((0) (let ((e-3 (vector-ref act-16 1))) (vector 0 e-3))) (else (let ((act-17 ((CoreC-45Binary-updateCGDirectives arg-2 (let ((e-24 (vector-ref e-9 18))) e-24)) eta-0))) (case (vector-ref act-17 0) ((0) (let ((e-3 (vector-ref act-17 1))) (vector 0 e-3))) (else (let ((act-18 ((CoreC-45Binary-updateTransforms arg-2 (let ((e-24 (vector-ref e-9 19))) e-24)) eta-0))) (case (vector-ref act-18 0) ((0) (let ((e-3 (vector-ref act-18 1))) (vector 0 e-3))) (else ((CoreC-45Binary-updateFExports arg-2 (let ((e-24 (vector-ref e-9 20))) e-24)) eta-0))))))))))))))))))))))))))))))))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((act-11 (cond ((equal? arg-6 1) (vector 1 (vector 0 ))) (else ((CoreC-45Context-clearSavedHints arg-2) eta-0))))) (case (vector-ref act-11 0) ((0) (let ((e-3 (vector-ref act-11 1))) (vector 0 e-3))) (else (let ((act-12 (CoreC-45Context-resetFirstEntry arg-2 eta-0))) (case (vector-ref act-12 0) ((0) (let ((e-3 (vector-ref act-12 1))) (vector 0 e-3))) (else (let ((act-13 ((let ((eff-0 (lambda (world-0) (let ((act-13 (unbox arg-3))) (vector 1 act-13))))) (lambda (world-0) (let ((act-13 (eff-0 world-0))) (case (vector-ref act-13 0) ((0) (let ((e-3 (vector-ref act-13 1))) (vector 0 e-3))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-1 (lambda (world-1) (let ((act-14 (set-box! arg-3 (let ((e-0 (vector-ref e-17 0))) (let ((e-1 (vector-ref e-17 1))) (let ((e-25 (vector-ref e-17 2))) (let ((e-3 (vector-ref e-17 3))) (let ((e-4 (vector-ref e-17 4))) (let ((e-24 (vector-ref e-17 5))) (let ((e-23 (vector-ref e-17 6))) (let ((e-22 (vector-ref e-17 7))) (let ((e-20 (vector-ref e-17 9))) (let ((e-19 (vector-ref e-17 10))) (let ((e-18 (vector-ref e-17 11))) (vector e-0 e-1 e-25 e-3 e-4 e-24 e-23 e-22 (let ((e-36 (vector-ref e-9 11))) e-36) e-20 e-19 e-18))))))))))))))) (vector 1 act-14))))) eff-1) world-0))))))) eta-0))) (case (vector-ref act-13 0) ((0) (let ((e-3 (vector-ref act-13 1))) (vector 0 e-3))) (else (vector 1 (box (cons u--ex (cons (let ((e-4 (vector-ref e-9 3))) e-4) (let ((e-29 (vector-ref e-9 10))) e-29))))))))))))))))))))))))))))))))) eff-0) clam-2)))))))))))) eff-0) clam-1))))))) (else (let ((e-8 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append arg-7 (string-append ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-8)))) clam-1))))))) eff-0) clam-0))))))))) (else (vector 1 '()))))))) eff-0) ext-0)))))))
(define CoreC-45Context-setVisible (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-45 (vector-ref e-0 0))) (let ((e-34 (vector-ref e-0 1))) (let ((e-35 (vector-ref e-0 2))) (let ((e-36 (vector-ref e-0 3))) (let ((e-37 (vector-ref e-0 4))) (let ((e-38 (vector-ref e-0 5))) (let ((e-39 (vector-ref e-0 6))) (let ((e-40 (vector-ref e-0 7))) (let ((e-41 (vector-ref e-0 8))) (let ((e-42 (vector-ref e-0 9))) (let ((e-43 (vector-ref e-0 10))) (let ((e-44 (vector-ref e-0 11))) (vector (vector e-45 e-34 e-35 e-36 e-37 e-38 e-39 (cons arg-1 e-40) e-41 e-42 e-43 e-44) e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45ProcessIdr-readModule (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-1823 (cons arg-6 (cons arg-5 arg-7)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-19 (vector-ref e-5 19))) e-19))))) (cond ((equal? sc1 0) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-nsToPath arg-0 arg-4 arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((act-3 (CoreC-45Binary-readFromTTC csegen-4083 arg-0 arg-1 0 arg-4 arg-5 e-2 arg-6 arg-7 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (cond ((equal? arg-5 1) (CoreC-45Context-setVisible arg-0 arg-6)) (else (lambda (eta-1) (vector 1 (vector 0 ))))) (let ((e-1 (unbox e-7))) (lambda (clam-1) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (let ((e-10 (cdr e-8))) (let ((act-4 (IdrisC-45Desugar-extendSyn arg-2 arg-0 e-9 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 (let ((act-5 (unbox arg-0))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else ((let ((eff-0 (lambda (eta-1) (let ((act-6 (CoreC-45Context-getNS arg-0 eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-7 (cond ((equal? arg-5 1) ((CoreC-45Context-setVisible arg-0 arg-6) eta-2)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((act-8 ((CoreC-45Core-traverse_ (lambda (u--mimp) (let ((u--m (Builtin-fst u--mimp))) (let ((u--reexp (Builtin-fst (Builtin-snd u--mimp)))) (let ((u--as (Builtin-snd (Builtin-snd u--mimp)))) (lambda (clam-2) (let ((sc12 (cond ((equal? u--reexp 1) 1) (else arg-3)))) (cond ((equal? sc12 1) (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 arg-3 arg-4 u--reexp u--m u--as clam-2)) (else (vector 1 (vector 0 )))))))))) e-10) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else ((CoreC-45Context-setNS arg-0 e-14) eta-2)))))))))) eff-0) eta-1)))))))) eff-0) clam-1))))))))))))))) eff-0) clam-0))))))) (else (let ((e-7 (vector-ref e-6 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-7 clam-0))))))) eff-0) eta-0))))))) (else (cond ((equal? arg-5 1) (CoreC-45Context-setVisible arg-0 arg-6)) (else (lambda (eta-0) (vector 1 (vector 0 )))))))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-readImport (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 arg-3 (let ((e-0 (vector-ref arg-4 0))) e-0) 1 (let ((e-2 (vector-ref arg-4 2))) e-2) (let ((e-3 (vector-ref arg-4 3))) e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Context-addImported arg-0 (cons (let ((e-2 (vector-ref arg-4 2))) e-2) (cons (let ((e-1 (vector-ref arg-4 1))) e-1) (let ((e-3 (vector-ref arg-4 3))) e-3)))) ext-0))))))
(define CoreC-45Binary-readImportHashes (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-3 (CoreC-45Binary-getImportHashes arg-0 e-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 e-7)))) eff-0) eta-1)))))) (lambda (u--err) (lambda (eta-1) (vector 1 '()))) eta-0)))) eff-0) clam-0))))))) (else (vector 1 '())))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-readImportMeta (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Directory-nsToPath arg-0 (let ((e-0 (vector-ref arg-2 0))) e-0) (let ((e-2 (vector-ref arg-2 2))) e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 (CoreC-45Binary-readHashes e-2 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-3 (cdr e-6))) (vector 1 (cons (let ((e-1 (vector-ref arg-2 1))) e-1) (cons (let ((e-7 (vector-ref arg-2 3))) e-7) e-3))))))) eff-0) clam-0))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error e-6 clam-0))))))) eff-0) ext-0)))))))
(define CoreC-45UnifyState-resetNextVar (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (vector e-0 e-1 e-2 e-3 e-4 e-12 e-6 e-7 0 e-9 e-10 e-11))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define ParserC-45Source-runParser (lambda (arg-1 arg-2 arg-3 ext-0 ext-1) (ParserC-45Source-runParserTo arg-1 arg-2 arg-3 (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) 0)) ext-0 ext-1)))
(define IdrisC-45ProcessIdr-processMod (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setCurrentElabSource arg-4 arg-8) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45ProcessIdr-readHeader arg-0 arg-4 arg-5 arg-9 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--ns (let ((e-1 (vector-ref e-7 1))) e-1))) (let ((u--allImports (let ((sc3 (let ((sc4 (let ((e-0 (vector-ref e-6 0))) e-0))) (cond ((equal? sc4 1) 1) (else (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent (let ((e-1 (vector-ref e-7 1))) e-1) CoreC-45NameC-45Namespace-preludeNS)))))) (cond ((equal? sc3 1) (let ((e-2 (vector-ref e-7 2))) e-2)) (else (IdrisC-45ProcessIdr-addPrelude (let ((e-2 (vector-ref e-7 2))) e-2))))))) (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45ProcessIdr-readImportMeta arg-0 arg-1 eta-3 eta-4))) u--allImports '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--importInterfaceHashes (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-snd eta-3)) e-8))) (lambda (eta-3) (let ((act-5 (let ((act-5 (unbox arg-0))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "module.hash" 5 (lambda () (string-append "Interface hash of " (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--ns) (string-append ": " (PreludeC-45Show-u--show_Show_Int (let ((e-16 (vector-ref e-9 16))) e-16)))))) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45ContextC-45Log-log arg-0 "module.hash" 5 (lambda () (string-append "Import Interface hashes of " (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--ns) (string-append " hashes:\xa;" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4088 (DataC-45List-sort csegen-4107 u--importInterfaceHashes)))))) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45Binary-readImportHashes arg-6 eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (CoreC-45ContextC-45Log-log arg-0 "module.hash" 5 (lambda () (string-append "Stored interface hashes of " (string-append arg-6 (string-append ":\xa;" (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4088 (DataC-45List-sort csegen-4107 e-12)))))) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((u--isUnchanged (lambda (clam-0) (lambda (clam-1) (lambda (clam-2) (let ((sc9 (let ((e-21 (vector-ref e-6 21))) e-21))) (cond ((equal? sc9 1) (IdrisC-45ProcessIdr-unchangedHash (let ((e-4 (vector-ref e-9 4))) (let ((e-42 (vector-ref e-4 9))) e-42)) clam-0 clam-1 clam-2)) (else (PreludeC-45IO-u--map_Functor_IO csegen-1604 (lambda (eta-6) (IdrisC-45ProcessIdr-isTTCOutdated arg-0 clam-0 (cons clam-1 '()) eta-6)) clam-2))))))))) (let ((act-10 (((u--isUnchanged arg-6) arg-5) eta-5))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-11 (PreludeC-45IO-u--map_Functor_IO csegen-1604 (lambda (eta-7) (IdrisC-45ProcessIdr-missingIncremental arg-0 arg-6 eta-7)) eta-6))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc11 (cond ((equal? e-14 1) (let ((sc13 (PreludeC-45Types-u--C-61C-61_Eq_C-40ListC-32C-36aC-41 csegen-4091 (DataC-45List-sort csegen-4107 u--importInterfaceHashes) (DataC-45List-sort csegen-4107 e-12)))) (cond ((equal? sc13 1) e-15) (else 0)))) (else 0)))) (cond ((equal? sc11 1) (let ((act-12 ((CoreC-45Context-setNS arg-0 u--ns) clam-1))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (vector 1 '()))))) (else (let ((act-12 (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 arg-7 clam-1))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () (string-append "Parsing " arg-5)) (lambda (eta-7) (vector 1 (ParserC-45Source-runParser 0 (vector 0 arg-9) (ParserC-45Unlit-isLitFile arg-5) arg-8 (vector 10 0 0 (IdrisC-45Parser-prog (vector 0 arg-9)) (lambda (u--p) (vector 12 0 0 ParserC-45RuleC-45Source-eoi (vector 0 u--p))))))) clam-1))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (case (vector-ref e-17 0) ((1) (let ((e-2 (vector-ref e-17 1))) (let ((e-19 (car e-2))) (let ((e-18 (cdr e-2))) (lambda (clam-2) (let ((e-21 (car e-18))) (let ((e-20 (cdr e-18))) (let ((e-23 (car e-21))) (let ((e-22 (cdr e-21))) (let ((act-14 ((CoreC-45Core-traverse_ (lambda (eta-7) (CoreC-45Context-recordWarning arg-0 eta-7)) e-19) clam-2))) (case (vector-ref act-14 0) ((0) (let ((e-3 (vector-ref act-14 1))) (vector 0 e-3))) (else (let ((act-15 (CoreC-45ContextC-45Log-log arg-0 "doc.module" 10 (lambda () (DataC-45String-fastUnlines (cons "Recording doc" (cons (let ((e-3 (vector-ref e-7 3))) e-3) (cons (string-append "and imports " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4110 (let ((e-25 (vector-ref e-7 2))) e-25))) (cons (string-append "for module " (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent (let ((e-1 (vector-ref e-7 1))) e-1))) '())))))) clam-2))) (case (vector-ref act-15 0) ((0) (let ((e-3 (vector-ref act-15 1))) (vector 0 e-3))) (else (let ((act-16 ((IdrisC-45Syntax-addModDocInfo arg-2 (let ((e-1 (vector-ref e-7 1))) e-1) (let ((e-3 (vector-ref e-7 3))) e-3) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-7) (let ((e-1 (vector-ref eta-7 1))) e-1)) (let ((e-26 (vector-ref e-7 2))) e-26))) clam-2))) (case (vector-ref act-16 0) ((0) (let ((e-3 (vector-ref act-16 1))) (vector 0 e-3))) (else (let ((act-17 (CoreC-45Metadata-addSemanticDecorations arg-3 arg-0 e-23 clam-2))) (case (vector-ref act-17 0) ((0) (let ((e-3 (vector-ref act-17 1))) (vector 0 e-3))) (else (let ((act-18 ((let ((eff-0 (lambda (world-0) (let ((act-18 (unbox arg-2))) (vector 1 act-18))))) (lambda (world-0) (let ((act-18 (eff-0 world-0))) (case (vector-ref act-18 0) ((0) (let ((e-3 (vector-ref act-18 1))) (vector 0 e-3))) (else (let ((e-28 (vector-ref act-18 1))) ((let ((eff-1 (lambda (world-1) (let ((act-19 (set-box! arg-2 (let ((e-0 (vector-ref e-28 0))) (let ((e-1 (vector-ref e-28 1))) (let ((e-36 (vector-ref e-28 2))) (let ((e-3 (vector-ref e-28 3))) (let ((e-4 (vector-ref e-28 4))) (let ((e-35 (vector-ref e-28 5))) (let ((e-34 (vector-ref e-28 6))) (let ((e-33 (vector-ref e-28 7))) (let ((e-32 (vector-ref e-28 8))) (let ((e-31 (vector-ref e-28 9))) (let ((e-30 (vector-ref e-28 10))) (vector e-0 e-1 e-36 e-3 e-4 e-35 e-34 e-33 e-32 e-31 e-30 e-22))))))))))))))) (vector 1 act-19))))) eff-1) world-0))))))) clam-2))) (case (vector-ref act-18 0) ((0) (let ((e-3 (vector-ref act-18 1))) (vector 0 e-3))) (else (let ((act-19 ((CoreC-45Context-initHash arg-0) clam-2))) (case (vector-ref act-19 0) ((0) (let ((e-3 (vector-ref act-19 1))) (vector 0 e-3))) (else (let ((act-20 ((CoreC-45Core-traverse_ (lambda (eta-7) (IdrisC-45ProcessIdr-addPublicHash arg-0 eta-7)) (DataC-45List-sort (vector (cons (lambda (arg-676) (lambda (arg-679) (PreludeC-45EqOrd-u--C-61C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1814 csegen-4091 arg-676 arg-679))) (lambda (arg-686) (lambda (arg-689) (PreludeC-45EqOrd-u--C-47C-61_Eq_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1814 csegen-4091 arg-686 arg-689)))) (lambda (arg-1566) (lambda (arg-1569) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1566 arg-1569))) (lambda (arg-1576) (lambda (arg-1579) (PreludeC-45EqOrd-u--C-60_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1576 arg-1579))) (lambda (arg-1586) (lambda (arg-1589) (PreludeC-45EqOrd-u--C-62_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1586 arg-1589))) (lambda (arg-1596) (lambda (arg-1599) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1596 arg-1599))) (lambda (arg-1606) (lambda (arg-1609) (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1606 arg-1609))) (lambda (arg-1616) (lambda (arg-1619) (PreludeC-45EqOrd-u--max_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1616 arg-1619))) (lambda (arg-1626) (lambda (arg-1629) (PreludeC-45EqOrd-u--min_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-4122 csegen-4107 arg-1626 arg-1629)))) e-8)) clam-2))) (case (vector-ref act-20 0) ((0) (let ((e-3 (vector-ref act-20 1))) (vector 0 e-3))) (else (let ((act-21 ((CoreC-45UnifyState-resetNextVar arg-1) clam-2))) (case (vector-ref act-21 0) ((0) (let ((e-3 (vector-ref act-21 1))) (vector 0 e-3))) (else (let ((act-22 (let ((sc26 (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent u--ns CoreC-45NameC-45Namespace-mainNS))) (cond ((equal? sc26 1) (let ((sc27 (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_ModuleIdent u--ns arg-9))) (cond ((equal? sc27 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 (let ((e-0 (vector-ref e-20 0))) e-0) (string-append "Module name " (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent u--ns) (string-append " does not match file name " (PreludeC-45Show-u--show_Show_String arg-5))))) clam-2)) (else (vector 1 (vector 0 )))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-22 0) ((0) (let ((e-3 (vector-ref act-22 1))) (vector 0 e-3))) (else (let ((act-23 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Reading imports") (CoreC-45Core-traverse_ (lambda (eta-7) (lambda (eta-8) (IdrisC-45ProcessIdr-readImport arg-0 arg-1 arg-2 0 eta-7 eta-8))) u--allImports) clam-2))) (case (vector-ref act-23 0) ((0) (let ((e-3 (vector-ref act-23 1))) (vector 0 e-3))) (else (let ((act-24 ((CoreC-45Context-setNS arg-0 u--ns) clam-2))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((act-25 (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Processing decls") (lambda (eta-7) (IdrisC-45ProcessIdr-processDecls arg-0 arg-1 arg-2 arg-3 arg-4 (let ((e-4 (vector-ref e-20 4))) e-4) eta-7)) clam-2))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (let ((e-35 (vector-ref act-25 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-26 (let ((sc30 (DataC-45List-isNil e-35))) (cond ((equal? sc30 1) (CoreC-45ContextC-45Log-logTime arg-0 2 (lambda () "Compile defs") (lambda (eta-8) (CompilerC-45Inline-compileAndInlineAll arg-0 eta-8)) eta-7)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-26 0) ((0) (let ((e-3 (vector-ref act-26 1))) (vector 0 e-3))) (else (let ((act-27 ((let ((eff-0 (lambda (world-0) (let ((act-27 (unbox arg-0))) (vector 1 act-27))))) (lambda (world-0) (let ((act-27 (eff-0 world-0))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (let ((e-37 (vector-ref act-27 1))) ((let ((eff-1 (lambda (world-1) (let ((act-28 (set-box! arg-0 (let ((e-0 (vector-ref e-37 0))) (let ((e-1 (vector-ref e-37 1))) (let ((e-66 (vector-ref e-37 2))) (let ((e-3 (vector-ref e-37 3))) (let ((e-4 (vector-ref e-37 4))) (let ((e-65 (vector-ref e-37 5))) (let ((e-64 (vector-ref e-37 6))) (let ((e-63 (vector-ref e-37 7))) (let ((e-62 (vector-ref e-37 8))) (let ((e-61 (vector-ref e-37 9))) (let ((e-60 (vector-ref e-37 10))) (let ((e-59 (vector-ref e-37 11))) (let ((e-58 (vector-ref e-37 12))) (let ((e-57 (vector-ref e-37 13))) (let ((e-56 (vector-ref e-37 14))) (let ((e-55 (vector-ref e-37 15))) (let ((e-54 (vector-ref e-37 16))) (let ((e-52 (vector-ref e-37 18))) (let ((e-51 (vector-ref e-37 19))) (let ((e-50 (vector-ref e-37 20))) (let ((e-49 (vector-ref e-37 21))) (let ((e-48 (vector-ref e-37 22))) (let ((e-47 (vector-ref e-37 23))) (let ((e-46 (vector-ref e-37 24))) (let ((e-45 (vector-ref e-37 25))) (let ((e-44 (vector-ref e-37 26))) (let ((e-43 (vector-ref e-37 27))) (let ((e-42 (vector-ref e-37 28))) (let ((e-41 (vector-ref e-37 29))) (let ((e-40 (vector-ref e-37 30))) (let ((e-39 (vector-ref e-37 31))) (let ((e-38 (vector-ref e-37 32))) (vector e-0 e-1 e-66 e-3 e-4 e-65 e-64 e-63 e-62 e-61 e-60 e-59 e-58 e-57 e-56 e-55 e-54 u--importInterfaceHashes e-52 e-51 e-50 e-49 e-48 e-47 e-46 e-45 e-44 e-43 e-42 e-41 e-40 e-39 e-38)))))))))))))))))))))))))))))))))))) (vector 1 act-28))))) eff-1) world-0))))))) eta-7))) (case (vector-ref act-27 0) ((0) (let ((e-3 (vector-ref act-27 1))) (vector 0 e-3))) (else (vector 1 (box e-35))))))))))) eff-0) clam-2))))))))))))))))))))))))))))))))))))))))))))))) (else (let ((e-18 (vector-ref e-17 1))) (lambda (eta-7) (vector 1 (box (cons e-18 '()))))))))) eff-0) clam-1)))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))))))) eff-0) eta-4)))))))))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) (lambda (u--err) (lambda (eta-0) (vector 1 (box (cons u--err '()))))) ext-0)))
(define CoreC-45Context-setIncData (lambda (arg-0 arg-1 arg-2) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (cons (cons arg-1 arg-2) e-22) e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define LibrariesC-45UtilsC-45Binary-newBinary (lambda (arg-0 arg-1) (vector arg-0 0 arg-1 0)))
(define CoreC-45BinaryC-45Prims-initBinaryS (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 ((DataC-45Buffer-newBuffer csegen-82 arg-0) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-1617 (let ((e-1 (unbox e-5))) (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) (LibrariesC-45UtilsC-45Binary-newBinary e-1 arg-0)))))) eff-0) ext-0)))))))
(define CoreC-45Context-u--full_HasNames_SCCall (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (vector e-5 e-1 e-2))))))) eff-0) ext-0)))))))
(define CoreC-45Context-u--full_HasNames_Totality (lambda (arg-0 arg-1 ext-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Terminating arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Covering arg-0 e-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Context-u--full_HasNames_GlobalDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Def arg-0 (let ((e-18 (vector-ref arg-1 18))) e-18) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-u--full_HasNames_Totality arg-0 (let ((e-10 (vector-ref arg-1 10))) e-10) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-1293) arg-0 (let ((e-13 (vector-ref arg-1 13))) e-13) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 (csegen-1293) arg-0 (let ((e-14 (vector-ref arg-1 14))) e-14) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-5) (lambda (eta-6) (CoreC-45Context-u--full_HasNames_SCCall arg-0 eta-5 eta-6))) (let ((e-21 (vector-ref arg-1 21))) e-21) '()) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-28 (vector-ref arg-1 5))) (let ((e-27 (vector-ref arg-1 6))) (let ((e-26 (vector-ref arg-1 7))) (let ((e-25 (vector-ref arg-1 8))) (let ((e-24 (vector-ref arg-1 9))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-22 (vector-ref arg-1 22))) (vector e-0 e-1 e-5 e-3 e-4 e-28 e-27 e-26 e-25 e-24 e-7 e-11 e-12 e-8 e-9 e-15 e-16 e-17 e-6 e-19 e-20 e-10 e-22)))))))))))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-u--toBuf_TTC_HoleInfo (lambda (arg-0 arg-1 ext-0) (if (null? arg-1) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0) (let ((e-0 (unbox arg-1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-0) ext-0))))))))
(define CoreC-45TTC-u--toBuf_TTC_PMDefInfo (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_HoleInfo arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_TypeFlags (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-1 (cdr arg-1))) e-1)) ext-0))))))
(define CoreC-45TTC-u--toBuf_TTC_Def (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 5))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((act-2 (CoreC-45TTC-u--toBuf_TTC_PMDefInfo arg-0 e-0 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-1 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_C-40CaseTreeC-32C-36varsC-41 e-1 arg-0 e-2 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1580 arg-0 e-4 ext-0)))))))))))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-5) ext-0)))))) ((3) (let ((e-6 (vector-ref arg-1 1))) (let ((e-7 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-6) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1559 arg-0 e-7 ext-0)))))))))) ((4) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Trying to serialise a Builtin") ext-0)) ((5) (let ((e-10 (vector-ref arg-1 1))) (let ((e-11 (vector-ref arg-1 2))) (let ((e-12 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-10) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-11) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1584 arg-0 e-12) ext-0)))))))))))))) ((6) (let ((e-13 (vector-ref arg-1 1))) (let ((e-14 (vector-ref arg-1 2))) (let ((e-15 (vector-ref arg-1 3))) (let ((e-16 (vector-ref arg-1 4))) (let ((e-17 (vector-ref arg-1 5))) (let ((e-18 (vector-ref arg-1 6))) (let ((e-19 (vector-ref arg-1 7))) (let ((e-20 (vector-ref arg-1 8))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 e-13) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-14) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 e-15 ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 e-16 ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45TTC-u--toBuf_TTC_TypeFlags arg-0 e-17 ext-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-18 ext-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-19 ext-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1587 arg-0 e-20) ext-0)))))))))))))))))))))))))))))))))) ((7) (let ((e-21 (vector-ref arg-1 1))) (let ((e-22 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-21) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-0 (car e-22))) e-0)) ext-0)))))))))) ((8) (let ((e-23 (vector-ref arg-1 1))) (let ((e-24 (vector-ref arg-1 2))) (let ((e-25 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 e-23) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-24) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-25) ext-0)))))))))))))) ((9) (let ((e-26 (vector-ref arg-1 1))) (let ((e-27 (vector-ref arg-1 2))) (let ((e-28 (vector-ref arg-1 3))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 e-26) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Nat arg-0 e-27) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1562 arg-0 e-28 ext-0)))))))))))))) ((10) (CoreC-45BinaryC-45Prims-tag arg-0 9 ext-0)) ((12) (CoreC-45BinaryC-45Prims-tag arg-0 10 ext-0)) (else (let ((e-29 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_Integer arg-0 e-29 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_Covering (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1590 arg-0 e-0 ext-0)))))) (else (let ((e-1 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-1 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_PartialReason (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 e-0 ext-0)))))) ((2) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1556 arg-0 e-1 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 e-2) ext-0)))))))))) (else (let ((e-3 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1556 arg-0 e-3 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_Terminating (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (CoreC-45BinaryC-45Prims-tag arg-0 0 ext-0)) ((1) (CoreC-45BinaryC-45Prims-tag arg-0 1 ext-0)) (else (let ((e-0 (vector-ref arg-1 1))) (let ((act-1 (CoreC-45BinaryC-45Prims-tag arg-0 2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_PartialReason arg-0 e-0 ext-0)))))))))
(define CoreC-45TTC-u--toBuf_TTC_Totality (lambda (arg-0 arg-1 ext-0) (let ((e-0 (car arg-1))) (let ((e-1 (cdr arg-1))) (let ((act-1 (CoreC-45TTC-u--toBuf_TTC_Terminating arg-0 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45TTC-u--toBuf_TTC_Covering arg-0 e-1 ext-0))))))))
(define CoreC-45TTC-n--19896-12838-u--cwName (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((6) 1) ((7) 1)(else 0))))
(define CoreC-45TTC-u--toBuf_TTC_GlobalDef (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-38 arg-0 (let ((e-19 (vector-ref arg-1 19))) e-19)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-51 arg-0 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-toList eta-0)) (let ((e-14 (vector-ref arg-1 14))) e-14))) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45TTC-u--toBuf_TTC_FC arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45TTC-u--toBuf_TTC_RigCount arg-0 (let ((e-23 (vector-ref arg-1 7))) e-23)) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45TTC-u--toBuf_TTC_Name arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-51 arg-0 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45DataC-45NameMap-toList eta-0)) (let ((e-13 (vector-ref arg-1 13))) e-13))) ext-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45TTC-u--toBuf_TTC_Def arg-0 (let ((e-18 (vector-ref arg-1 18))) e-18) ext-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((sc7 (let ((sc8 (CoreC-45Name-isUserName (let ((e-1 (vector-ref arg-1 1))) e-1)))) (cond ((equal? sc8 1) 1) (else (CoreC-45TTC-n--19896-12838-u--cwName arg-1 arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1))))))) (cond ((equal? sc7 1) (let ((act-8 ((CoreC-45TTC-u--toBuf_TTC_C-40TermC-32C-36varsC-41 '() arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 (let ((e-3 (vector-ref arg-1 3))) e-3) ext-0))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4) ext-0))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 (let ((e-32 (vector-ref arg-1 5))) e-32) ext-0))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1535 arg-0 (let ((e-32 (vector-ref arg-1 6))) e-32) ext-0))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-0 (let ((e-31 (vector-ref arg-1 8))) e-31) ext-0))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40C-40WithDefaultC-32C-36aC-41C-32C-36defC-41 csegen-1566 arg-0 (let ((e-31 (vector-ref arg-1 9))) e-31)) ext-0))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((act-15 (CoreC-45TTC-u--toBuf_TTC_Totality arg-0 (let ((e-31 (vector-ref arg-1 10))) e-31) ext-0))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((act-16 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-31 (vector-ref arg-1 11))) e-31)) ext-0))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((act-17 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1569 arg-0 (let ((e-31 (vector-ref arg-1 12))) e-31) ext-0))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((act-18 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-29 (vector-ref arg-1 15))) e-29)) ext-0))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((act-19 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Bool arg-0 (let ((e-29 (vector-ref arg-1 16))) e-29)) ext-0))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1572 arg-0 (let ((e-25 (vector-ref arg-1 21))) e-25) ext-0)))))))))))))))))))))))))))))))))))))) (else (vector 1 (vector 0 ))))))))))))))))))))))))))))
(define CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (vector 0 e-1 e-2 e-3 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-4))))))) ((1) (let ((e-6 (vector-ref arg-2 1))) (let ((e-7 (vector-ref arg-2 2))) (let ((e-8 (vector-ref arg-2 3))) (vector 1 e-6 e-7 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-8)))))) ((2) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (vector 2 e-10 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-11))))) (else (let ((e-13 (vector-ref arg-2 1))) (vector 3 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-1 e-13)))))))
(define CoreC-45TTC-45Term-u--trimNS_StripNamespace_Name (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((u--nm (vector 0 e-0 e-1))) (let ((sc1 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace arg-0 e-0))) (cond ((equal? sc1 1) (vector 0 CoreC-45NameC-45Namespace-emptyNS e-1)) (else u--nm)))))))(else arg-1))))
(define CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (vector 1 e-1 e-2 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_Name arg-1 e-3)))))) ((2) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (let ((e-8 (vector-ref arg-2 4))) (vector 2 e-5 e-6 e-7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-3) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-8))))))) ((3) (let ((e-10 (vector-ref arg-2 1))) (let ((e-11 (vector-ref arg-2 2))) (let ((e-12 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 4))) (vector 3 e-10 e-11 (CoreC-45TTC-45Binder-u--map_Functor_Binder (lambda (arg-3) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 arg-3)) e-12) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-13))))))) ((4) (let ((e-15 (vector-ref arg-2 1))) (let ((e-16 (vector-ref arg-2 2))) (let ((e-17 (vector-ref arg-2 3))) (vector 4 e-15 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-16) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-17)))))) ((5) (let ((e-19 (vector-ref arg-2 1))) (let ((e-20 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 3))) (let ((e-22 (vector-ref arg-2 4))) (vector 5 e-19 e-20 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-21) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-22))))))) ((6) (let ((e-24 (vector-ref arg-2 1))) (let ((e-25 (vector-ref arg-2 2))) (let ((e-26 (vector-ref arg-2 3))) (vector 6 e-24 e-25 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-26)))))) ((7) (let ((e-28 (vector-ref arg-2 1))) (let ((e-29 (vector-ref arg-2 2))) (let ((e-30 (vector-ref arg-2 3))) (let ((e-31 (vector-ref arg-2 4))) (vector 7 e-28 e-29 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-30) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-31))))))) ((8) (let ((e-33 (vector-ref arg-2 1))) (let ((e-34 (vector-ref arg-2 2))) (let ((e-35 (vector-ref arg-2 3))) (vector 8 e-33 e-34 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-35))))))(else arg-2))))
(define CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-4 (vector-ref arg-2 3))) (let ((e-5 (vector-ref arg-2 4))) (vector 0 e-1 e-2 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseAltC-32C-36varsC-41 arg-1 eta-0)) e-5))))))) ((1) (let ((e-7 (vector-ref arg-2 1))) (let ((e-8 (vector-ref arg-2 2))) (vector 1 e-7 (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-1 e-8)))))(else arg-2))))
(define CoreC-45Context-n--14271-10031-u--trimNSpat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (cons e-2 (cons e-6 (cons (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-10) (CoreC-45TTC-45Term-u--trimNS_StripNamespace_C-40TermC-32C-36varsC-41 arg-5 e-11))))))))))))
(define CoreC-45Context-u--trimNS_StripNamespace_Def (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (let ((e-2 (vector-ref arg-1 3))) (let ((e-3 (vector-ref arg-1 4))) (let ((e-4 (vector-ref arg-1 5))) (vector 1 e-0 e-1 (CoreC-45CaseC-45CaseTree-u--trimNS_StripNamespace_C-40CaseTreeC-32C-36varsC-41 arg-0 e-2) e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Context-n--14271-10031-u--trimNSpat e-4 e-1 e-3 e-2 e-0 arg-0 eta-0)) e-4))))))))(else arg-1))))
(define CoreC-45Context-u--trimNS_StripNamespace_GlobalDef (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-5 (vector-ref arg-1 5))) (let ((e-6 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-8 (vector-ref arg-1 8))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (let ((e-12 (vector-ref arg-1 12))) (let ((e-13 (vector-ref arg-1 13))) (let ((e-14 (vector-ref arg-1 14))) (let ((e-15 (vector-ref arg-1 15))) (let ((e-16 (vector-ref arg-1 16))) (let ((e-17 (vector-ref arg-1 17))) (let ((e-18 (vector-ref arg-1 18))) (let ((e-19 (vector-ref arg-1 19))) (let ((e-20 (vector-ref arg-1 20))) (let ((e-21 (vector-ref arg-1 21))) (let ((e-22 (vector-ref arg-1 22))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 (CoreC-45Context-u--trimNS_StripNamespace_Def arg-0 e-18) e-19 e-20 e-21 e-22))))))))))))))))))))))))))
(define CoreC-45Binary-n--12475-17013-u--trimName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((u--n (vector 0 e-0 e-1))) (let ((sc1 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_Namespace e-0 arg-4))) (cond ((equal? sc1 1) e-1) (else u--n)))))))(else arg-5))))
(define CoreC-45Binary-getSaveDefs (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-1) (vector 1 arg-2) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref arg-3 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (CoreC-45Binary-getSaveDefs arg-0 e-3 arg-2 arg-3 eta-0)) (let ((e-1 (unbox e-5))) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((4) (lambda (eta-0) (CoreC-45Binary-getSaveDefs arg-0 e-3 arg-2 arg-3 eta-0)))(else (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-initBinaryS (blodwen-toSignedInt 16384 63) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-27 (vector-ref act-2 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (CoreC-45Context-u--full_HasNames_GlobalDef (let ((e-60 (vector-ref arg-3 0))) e-60) e-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-28 (vector-ref act-3 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45TTC-u--toBuf_TTC_GlobalDef e-27 (CoreC-45Context-u--trimNS_StripNamespace_GlobalDef arg-0 e-28) eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-28 (vector-ref act-3 1))) (vector 0 e-28))) (else (let ((act-4 (let ((act-4 (unbox e-27))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-29 (vector-ref act-4 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Binary-getSaveDefs arg-0 e-3 (cons (cons (CoreC-45Binary-n--12475-17013-u--trimName e-2 e-3 arg-3 arg-2 arg-0 (let ((e-51 (vector-ref e-1 1))) e-51)) e-29) arg-2) arg-3 eta-2)))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))))) eff-0) ext-0))))))))))
(define CoreC-45BinaryC-45Prims-initBinary (lambda (ext-0) (let ((act-1 (let ((act-1 ((DataC-45Buffer-newBuffer csegen-82 (blodwen-toSignedInt 655360 63)) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) csegen-1617 (let ((e-1 (unbox e-5))) (CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) (LibrariesC-45UtilsC-45Binary-newBinary e-1 (blodwen-toSignedInt 655360 63))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-n--10367-15037-u--full_aux (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 (PreludeC-45TypesC-45List-reverse arg-5)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 (let ((e-1 (car arg-1))) (((e-1 arg-4) e-2) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Binary-n--10367-15037-u--full_aux arg-1 arg-2 arg-3 arg-4 (cons e-5 arg-5) e-3 eta-0)))) eff-0) ext-0))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (lambda (eta-0) (CoreC-45Binary-n--10367-15037-u--full_aux arg-1 arg-3 arg-2 arg-2 '() arg-3 eta-0))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Name arg-0 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 (cons e-8 e-7)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-0 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-5 e-3))))) eff-0) ext-0)))))))))
(define CoreC-45Binary-n--11003-15641-u--fullPair (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26) (lambda (clam-0) (if (null? arg-26) (vector 1 '()) (let ((e-2 (unbox arg-26))) (let ((e-3 (vector-ref e-2 0))) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-25 e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Name arg-25 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-u--full_HasNames_Name arg-25 e-5 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box (vector e-6 e-7 e-8)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define CoreC-45Binary-n--11003-15642-u--fullPrim (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (let ((e-0 (vector-ref arg-26 0))) (let ((e-1 (vector-ref arg-26 1))) (let ((e-2 (vector-ref arg-26 2))) (let ((e-3 (vector-ref arg-26 3))) (let ((e-4 (vector-ref arg-26 4))) (let ((e-5 (vector-ref arg-26 5))) (let ((e-6 (vector-ref arg-26 6))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (CoreC-45Core-C-60C-42C-62 (lambda (eta-2) (CoreC-45Core-C-60C-42C-62 (lambda (eta-3) (CoreC-45Core-C-60C-42C-62 (lambda (eta-4) (CoreC-45Core-C-60C-42C-62 (lambda (eta-5) (CoreC-45Core-C-60C-42C-62 csegen-1325 (lambda (eta-6) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-0 eta-6)) eta-5)) (lambda (eta-5) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-1 eta-5)) eta-4)) (lambda (eta-4) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-2 eta-4)) eta-3)) (lambda (eta-3) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-3 eta-3)) eta-2)) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-4 eta-2)) eta-1)) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-5 eta-1)) eta-0)) (lambda (eta-0) (CoreC-45Context-u--full_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-6 eta-0)) ext-0))))))))))
(define CoreC-45Binary-n--11003-15643-u--fullRW (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26) (lambda (clam-0) (if (null? arg-26) (vector 1 '()) (let ((e-2 (unbox arg-26))) (let ((e-3 (car e-2))) (let ((e-4 (cdr e-2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-25 e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--full_HasNames_Name arg-25 e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons e-5 e-6)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define CoreC-45Binary-u--full_HasNames_C-40TTCFileC-32C-36eC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((e-6 (vector-ref arg-3 5))) (let ((e-7 (vector-ref arg-3 6))) (let ((e-8 (vector-ref arg-3 7))) (let ((e-9 (vector-ref arg-3 8))) (let ((e-10 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 10))) (let ((e-12 (vector-ref arg-3 11))) (let ((e-13 (vector-ref arg-3 12))) (let ((e-14 (vector-ref arg-3 13))) (let ((e-15 (vector-ref arg-3 14))) (let ((e-16 (vector-ref arg-3 15))) (let ((e-17 (vector-ref arg-3 16))) (let ((e-18 (vector-ref arg-3 17))) (let ((e-19 (vector-ref arg-3 18))) (let ((e-20 (vector-ref arg-3 19))) (let ((e-21 (vector-ref arg-3 20))) (let ((e-22 (vector-ref arg-3 21))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 arg-2 eta-0 eta-1))) e-9 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-23 (vector-ref act-1 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Binary-u--full_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 arg-2 eta-1)) e-10 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-24 (vector-ref act-2 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Binary-n--11003-15641-u--fullPair arg-1 e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-15) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-25 (vector-ref act-3 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Binary-n--11003-15643-u--fullRW arg-1 e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-16) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-26 (vector-ref act-4 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Binary-n--11003-15642-u--fullPrim arg-1 e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-17 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-27 (vector-ref act-5 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 csegen-1728 arg-2 e-18) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-28 (vector-ref act-6 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 csegen-1731 arg-2 e-20) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-29 (vector-ref act-7 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 ((CoreC-45Binary-u--full_HasNames_C-40ListC-32C-36aC-41 csegen-1728 arg-2 e-21) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-30 (vector-ref act-8 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-9 (let ((e-32 (car arg-1))) (((e-32 arg-2) e-22) eta-7)))) (case (vector-ref act-9 0) ((0) (let ((e-31 (vector-ref act-9 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (vector e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-23 e-24 e-11 e-12 e-13 e-14 e-25 e-26 e-27 e-28 e-19 e-29 e-30 e-31))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))))))))))))))))
(define CoreC-45Binary-n--10382-15076-u--resolved_aux (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 (PreludeC-45TypesC-45List-reverse arg-5)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 (let ((e-4 (cdr arg-1))) (((e-4 arg-4) e-2) ext-0)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Binary-n--10382-15076-u--resolved_aux arg-1 arg-2 arg-3 arg-4 (cons e-5 arg-5) e-3 eta-0)))) eff-0) ext-0))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (lambda (eta-0) (CoreC-45Binary-n--10382-15076-u--resolved_aux arg-1 arg-3 arg-2 arg-2 '() arg-3 eta-0))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-6) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 (cons e-8 e-7)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 (lambda (arg-0 arg-1 ext-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-0 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-5 e-3))))) eff-0) ext-0)))))))))
(define CoreC-45Binary-n--11018-15901-u--resolvedPair (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26) (lambda (clam-0) (if (null? arg-26) (vector 1 '()) (let ((e-2 (unbox arg-26))) (let ((e-3 (vector-ref e-2 0))) (let ((e-4 (vector-ref e-2 1))) (let ((e-5 (vector-ref e-2 2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-25 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_Name arg-25 e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-u--resolved_HasNames_Name arg-25 e-5) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (box (vector e-6 e-7 e-8)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define CoreC-45Binary-n--11018-15902-u--resolvedPrim (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26 ext-0) (let ((e-0 (vector-ref arg-26 0))) (let ((e-1 (vector-ref arg-26 1))) (let ((e-2 (vector-ref arg-26 2))) (let ((e-3 (vector-ref arg-26 3))) (let ((e-4 (vector-ref arg-26 4))) (let ((e-5 (vector-ref arg-26 5))) (let ((e-6 (vector-ref arg-26 6))) (let ((act-1 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-2 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-3 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-4 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-5 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45Context-u--resolved_HasNames_C-40MaybeC-32C-36aC-41 csegen-54 arg-25 e-6 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-13 (vector-ref act-7 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector e-7 e-8 e-9 e-10 e-11 e-12 e-13))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))))
(define CoreC-45Binary-n--11018-15903-u--resolvedRW (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26) (lambda (clam-0) (if (null? arg-26) (vector 1 '()) (let ((e-2 (unbox arg-26))) (let ((e-3 (car e-2))) (let ((e-4 (cdr e-2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-25 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--resolved_HasNames_Name arg-25 e-4) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons e-5 e-6)))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))
(define CoreC-45Binary-u--resolved_HasNames_C-40TTCFileC-32C-36eC-41 (lambda (arg-1 arg-2 arg-3 ext-0) (let ((e-1 (vector-ref arg-3 0))) (let ((e-2 (vector-ref arg-3 1))) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (let ((e-6 (vector-ref arg-3 5))) (let ((e-7 (vector-ref arg-3 6))) (let ((e-8 (vector-ref arg-3 7))) (let ((e-9 (vector-ref arg-3 8))) (let ((e-10 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 10))) (let ((e-12 (vector-ref arg-3 11))) (let ((e-13 (vector-ref arg-3 12))) (let ((e-14 (vector-ref arg-3 13))) (let ((e-15 (vector-ref arg-3 14))) (let ((e-16 (vector-ref arg-3 15))) (let ((e-17 (vector-ref arg-3 16))) (let ((e-18 (vector-ref arg-3 17))) (let ((e-19 (vector-ref arg-3 18))) (let ((e-20 (vector-ref arg-3 19))) (let ((e-21 (vector-ref arg-3 20))) (let ((e-22 (vector-ref arg-3 21))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41 arg-2 eta-0 eta-1))) e-9 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-23 (vector-ref act-1 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Binary-u--resolved_HasNames_C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32C-40C-124C-40C-40BuiltinC-46PairC-32NameC-41C-32BoolC-41C-44C-40C-40BuiltinC-46MkPairC-32NameC-41C-32BoolC-41C-124C-41C-41C-124C-41 arg-2 eta-1)) e-10 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-24 (vector-ref act-2 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Binary-n--11018-15901-u--resolvedPair arg-1 e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-15) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-25 (vector-ref act-3 1))) (vector 0 e-25))) (else (let ((e-25 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Binary-n--11018-15903-u--resolvedRW arg-1 e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-16) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-26 (vector-ref act-4 1))) (vector 0 e-26))) (else (let ((e-26 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Binary-n--11018-15902-u--resolvedPrim arg-1 e-22 e-21 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 e-12 e-11 e-10 e-9 e-8 e-7 e-6 e-5 e-4 e-3 e-2 e-1 arg-2 arg-2 e-17 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-27 (vector-ref act-5 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 ((CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 csegen-1728 arg-2 e-18) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-28 (vector-ref act-6 1))) (vector 0 e-28))) (else (let ((e-28 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 csegen-1731 arg-2 e-20) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-29 (vector-ref act-7 1))) (vector 0 e-29))) (else (let ((e-29 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 ((CoreC-45Binary-u--resolved_HasNames_C-40ListC-32C-36aC-41 csegen-1728 arg-2 e-21) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-30 (vector-ref act-8 1))) (vector 0 e-30))) (else (let ((e-30 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-9 (let ((e-31 (cdr arg-1))) (((e-31 arg-2) e-22) eta-7)))) (case (vector-ref act-9 0) ((0) (let ((e-31 (vector-ref act-9 1))) (vector 0 e-31))) (else (let ((e-31 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (vector e-1 e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-23 e-24 e-11 e-12 e-13 e-14 e-25 e-26 e-27 e-28 e-19 e-29 e-30 e-31))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))))))))))))))))
(define CoreC-45TTC-u--toBuf_TTC_PrimNames (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1)) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2)) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-3 (vector-ref arg-1 3))) e-3)) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4)) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-11 (vector-ref arg-1 5))) e-11)) ext-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-41 arg-0 (let ((e-11 (vector-ref arg-1 6))) e-11)) ext-0)))))))))))))))))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_WastefulInt (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer (LibrariesC-45UtilsC-45Binary-avail e-5) 8))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-5 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-5 1))) e-1) 63) arg-1 clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-5)))) (vector 1 act-3)))))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-extendBinary 8 e-5) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (DataC-45Buffer-prim__setInt (let ((e-0 (vector-ref e-6 0))) e-0) (blodwen-toSignedInt (let ((e-1 (vector-ref e-6 1))) e-1) 63) arg-1 eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (set-box! arg-0 (LibrariesC-45UtilsC-45Binary-appended 8 e-6)))) (vector 1 act-4)))))))) eff-0) clam-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-writeTTCFile (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-toFullNames arg-2 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-0) (CoreC-45Binary-u--full_HasNames_C-40TTCFileC-32C-36eC-41 (Builtin-fst arg-1) arg-7719 arg-7722 eta-0)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-0) (CoreC-45Binary-u--resolved_HasNames_C-40TTCFileC-32C-36eC-41 (Builtin-fst arg-1) arg-7729 arg-7732 eta-0))))) arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-3 "TT2") eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_WastefulInt arg-3 (let ((e-1 (vector-ref e-5 0))) e-1) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45TTC-u--toBuf_TTC_TotalReq arg-3 (let ((e-2 (vector-ref e-5 1))) e-2) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1559 arg-3 (let ((e-3 (vector-ref e-5 2))) e-3)) eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-3 (let ((e-4 (vector-ref e-5 3))) e-4)) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1738 arg-3 (let ((e-28 (vector-ref e-5 4))) e-28) eta-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1752 arg-3 (let ((e-28 (vector-ref e-5 5))) e-28) eta-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1763 arg-3 (let ((e-24 (vector-ref e-5 10))) e-24) eta-0))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (let ((sc9 (Builtin-snd arg-1))) (let ((e-1 (car sc9))) (((e-1 arg-3) (let ((e-22 (vector-ref e-5 21))) e-22)) eta-0))))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1770 arg-3 (let ((e-30 (vector-ref e-5 6))) e-30) eta-0))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-41 arg-3 (let ((e-30 (vector-ref e-5 7))) e-30) eta-0))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-48 arg-3 (let ((e-30 (vector-ref e-5 8))) e-30) eta-0))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1774 arg-3 (let ((e-30 (vector-ref e-5 9))) e-30) eta-0))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((act-15 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-3 (let ((e-29 (vector-ref e-5 11))) e-29)) eta-0))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((act-16 (CoreC-45TTC-u--toBuf_TTC_Namespace arg-3 (let ((e-29 (vector-ref e-5 12))) e-29) eta-0))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((act-17 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1734 arg-3 (let ((e-29 (vector-ref e-5 13))) e-29) eta-0))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((act-18 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1777 arg-3 (let ((e-29 (vector-ref e-5 14))) e-29)) eta-0))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((act-19 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40MaybeC-32C-36aC-41 csegen-1780 arg-3 (let ((e-29 (vector-ref e-5 15))) e-29)) eta-0))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((act-20 (CoreC-45TTC-u--toBuf_TTC_PrimNames arg-3 (let ((e-29 (vector-ref e-5 16))) e-29) eta-0))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((act-21 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1784 arg-3 (let ((e-29 (vector-ref e-5 17))) e-29) eta-0))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((act-22 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1788 arg-3 (let ((e-29 (vector-ref e-5 18))) e-29) eta-0))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((act-23 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1795 arg-3 (let ((e-29 (vector-ref e-5 19))) e-29) eta-0))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-1806 arg-3 (let ((e-29 (vector-ref e-5 20))) e-29) eta-0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) eff-0) ext-0)))))))
(define CoreC-45Binary-writeToTTC (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-initBinary ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-3))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Binary-getSaveDefs (let ((e-2 (vector-ref e-6 2))) e-2) (LibrariesC-45DataC-45NameMap-keys (let ((e-35 (vector-ref e-6 5))) e-35)) '() e-6 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45BinaryC-45Prims-hashFileWith (let ((e-4 (vector-ref e-6 4))) (let ((e-37 (vector-ref e-4 9))) e-37)) arg-5 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45Context-getDefaultTotalityOption arg-2 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45ContextC-45Log-log arg-2 "ttc.write" 5 (lambda () (DataC-45String-unwords (cons "Writing" (cons arg-6 (cons "with source hash" (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-493 e-9) (cons "and interface hash" (cons (PreludeC-45Show-u--show_Show_Int (let ((e-16 (vector-ref e-6 16))) e-16)) '())))))))) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45Binary-writeTTCFile arg-1 arg-2 e-5 (vector CoreC-45Binary-ttcVersion e-10 e-9 (let ((e-16 (vector-ref e-6 16))) e-16) (let ((e-17 (vector-ref e-6 17))) e-17) (let ((e-22 (vector-ref e-6 22))) e-22) e-8 (LibrariesC-45DataC-45NameMap-keys (let ((e-25 (vector-ref e-6 25))) e-25)) (let ((e-12 (vector-ref e-6 12))) e-12) (let ((e-33 (vector-ref e-6 11))) e-33) (let ((e-18 (vector-ref e-6 18))) e-18) (let ((e-15 (vector-ref e-7 8))) e-15) (let ((e-2 (vector-ref e-6 2))) e-2) (let ((e-3 (vector-ref e-6 3))) e-3) (let ((e-4 (vector-ref e-6 4))) (let ((e-45 (vector-ref e-4 4))) e-45)) (let ((e-4 (vector-ref e-6 4))) (let ((e-44 (vector-ref e-4 5))) e-44)) (let ((e-4 (vector-ref e-6 4))) (let ((e-43 (vector-ref e-4 6))) e-43)) (LibrariesC-45DataC-45NameMap-toList (let ((e-15 (vector-ref e-6 15))) e-15)) (let ((e-20 (vector-ref e-6 20))) e-20) (let ((e-14 (vector-ref e-6 14))) e-14) (LibrariesC-45DataC-45NameMap-toList (let ((e-31 (vector-ref e-6 31))) e-31)) arg-4) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 (let ((act-9 (unbox e-5))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-10 (LibrariesC-45UtilsC-45Binary-writeToFile arg-6 e-13 eta-6))) (vector 1 act-10))))) eff-0) eta-5))))))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-13 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-14 (vector-ref e-13 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append arg-6 (string-append ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-14)))) clam-0))))))) eff-0) eta-5)))))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-n--12593-9689-u--nfType (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45Normalise-normaliseArgHoles arg-0 '() arg-2 '() e-11 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 (cons e-6 (cons e-10 e-5))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Metadata-normaliseTypes (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Metadata-n--12593-9689-u--nfType arg-1 arg-0 e-6 eta-2)) (let ((e-1 (vector-ref e-5 1))) e-1) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-12 (vector-ref e-5 5))) (let ((e-11 (vector-ref e-5 6))) (let ((e-10 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (vector e-0 e-7 e-2 e-3 e-4 e-12 e-11 e-10 e-8 e-9))))))))))))) (vector 1 act-4))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap (lambda (ext-0) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap csegen-103 '() ext-0)))
(define CoreC-45Metadata-n--12852-9947-u--fullDecls (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 e-5))))) eff-0) ext-0)))))))))
(define CoreC-45Metadata-n--12852-9948-u--fullHLHS (lambda (arg-0 arg-1 arg-2 ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45Metadata-n--12852-9949-u--fullLHS (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 (cons e-6 e-5)))))) eff-0) clam-0))))))))))))
(define CoreC-45Metadata-n--12852-9950-u--fullTy (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-1 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-u--full_HasNames_C-40TermC-32C-36varsC-41 arg-1 e-11) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-2 (cons e-5 (cons e-10 e-8))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define CoreC-45Metadata-u--full_HasNames_Metadata (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (CoreC-45Metadata-n--12852-9949-u--fullLHS arg-1 arg-0 eta-0)) (let ((e-0 (vector-ref arg-1 0))) e-0) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Metadata-n--12852-9950-u--fullTy arg-1 arg-0 eta-1)) (let ((e-1 (vector-ref arg-1 1))) e-1) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (CoreC-45Metadata-n--12852-9950-u--fullTy arg-1 arg-0 eta-2)) (let ((e-2 (vector-ref arg-1 2))) e-2) '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Metadata-n--12852-9948-u--fullHLHS arg-1 arg-0 eta-3 eta-4))) (let ((e-4 (vector-ref arg-1 4))) e-4) '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (CoreC-45Metadata-n--12852-9947-u--fullDecls arg-1 arg-0 eta-4 eta-5))) (LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap (let ((e-13 (vector-ref arg-1 5))) e-13)) '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (let ((e-13 (vector-ref arg-1 6))) (let ((e-12 (vector-ref arg-1 7))) (let ((e-11 (vector-ref arg-1 8))) (let ((e-10 (vector-ref arg-1 9))) (vector e-5 e-6 e-7 '() e-8 (LibrariesC-45DataC-45PosMap-fromList (lambda (eta-5) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-5)) e-9) e-13 e-12 e-11 e-10))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2 ext-1 ext-0) (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 (Builtin-fst arg-1) arg-2 (LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap ext-1) ext-0)))
(define CoreC-45Metadata-u--toBuf_TTC_Metadata (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-2078 arg-0 (let ((e-0 (vector-ref arg-1 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-2086 arg-0 (let ((e-1 (vector-ref arg-1 1))) e-1) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-2086 arg-0 (let ((e-2 (vector-ref arg-1 2))) e-2) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40ListC-32C-36aC-41 csegen-2090 arg-0 (let ((e-4 (vector-ref arg-1 4))) e-4) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2095 arg-0 (let ((e-13 (vector-ref arg-1 5))) e-13) ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45TTC-u--toBuf_TTC_OriginDesc arg-0 (let ((e-13 (vector-ref arg-1 6))) e-13) ext-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2110 arg-0 (let ((e-13 (vector-ref arg-1 7))) e-13) ext-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2115 arg-0 (let ((e-13 (vector-ref arg-1 8))) e-13) ext-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (CoreC-45BinaryC-45Prims-u--toBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2110 arg-0 (let ((e-13 (vector-ref arg-1 9))) e-13) ext-0)))))))))))))))))))))))))))
(define CoreC-45Metadata-u--toBuf_TTC_TTMFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_String arg-0 "TTM") ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45BinaryC-45Prims-u--toBuf_TTC_Int arg-0 (let ((e-0 (car arg-1))) e-0)) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (CoreC-45Metadata-u--toBuf_TTC_Metadata arg-0 (let ((e-1 (cdr arg-1))) e-1) ext-0)))))))))
(define CoreC-45Metadata-writeToTTM (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Metadata-normaliseTypes arg-1 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45BinaryC-45Prims-initBinary ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (CoreC-45Metadata-u--full_HasNames_Metadata (let ((e-0 (vector-ref e-8 0))) e-0) e-7 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Metadata-u--toBuf_TTC_TTMFile e-6 (cons CoreC-45Binary-ttcVersion e-9) eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (let ((act-6 (unbox e-6))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (LibrariesC-45UtilsC-45Binary-writeToFile arg-2 e-10 eta-3))) (vector 1 act-7))))) eff-0) eta-2))))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-10 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-11 (vector-ref e-10 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append arg-2 (string-append ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-11)))) clam-0))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define IdrisC-45Syntax-n--16853-7465-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name arg-3 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((e-1 (car arg-1))) (((e-1 arg-3) e-7) eta-0)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45Syntax-n--16853-7465-u--insertAll arg-1 arg-2 arg-3 (LibrariesC-45DataC-45ANameMap-addName e-5 e-8 arg-4) e-3))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define IdrisC-45Syntax-u--full_HasNames_C-40ANameMapC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (IdrisC-45Syntax-n--16853-7465-u--insertAll arg-1 arg-3 arg-2 LibrariesC-45DataC-45ANameMap-empty (LibrariesC-45DataC-45ANameMap-toList arg-3))))
(define IdrisC-45Syntax-u--full_HasNames_SyntaxInfo (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((IdrisC-45Syntax-u--full_HasNames_C-40ANameMapC-32C-36aC-41 csegen-262 arg-0 (let ((e-5 (vector-ref arg-1 5))) e-5)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-1 eta-2))) (let ((e-8 (vector-ref arg-1 8))) e-8) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-12 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-12 e-7 e-6 e-9 e-10 e-11))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Syntax-n--16868-7515-u--insertAll (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 ((CoreC-45Context-u--resolved_HasNames_Name arg-3 e-6) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((e-4 (cdr arg-1))) (((e-4 arg-3) e-7) eta-0)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45Syntax-n--16868-7515-u--insertAll arg-1 arg-2 arg-3 (LibrariesC-45DataC-45ANameMap-addName e-5 e-8 arg-4) e-3))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define IdrisC-45Syntax-u--resolved_HasNames_C-40ANameMapC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (IdrisC-45Syntax-n--16868-7515-u--insertAll arg-1 arg-3 arg-2 LibrariesC-45DataC-45ANameMap-empty (LibrariesC-45DataC-45ANameMap-toList arg-3))))
(define IdrisC-45Syntax-u--resolved_HasNames_SyntaxInfo (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((IdrisC-45Syntax-u--resolved_HasNames_C-40ANameMapC-32C-36aC-41 csegen-262 arg-0 (let ((e-5 (vector-ref arg-1 5))) e-5)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45Context-u--resolved_HasNames_Name arg-0 eta-1)) (let ((e-8 (vector-ref arg-1 8))) e-8) '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (let ((e-12 (vector-ref arg-1 6))) (let ((e-7 (vector-ref arg-1 7))) (let ((e-9 (vector-ref arg-1 9))) (let ((e-10 (vector-ref arg-1 10))) (let ((e-11 (vector-ref arg-1 11))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-12 e-7 e-6 e-9 e-10 e-11))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-7) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-2 (CoreC-45Directory-getTTCFileName arg-0 arg-7 "ttc" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-logTime arg-0 1 (lambda () (string-append "Elaborating " arg-7)) (lambda (eta-2) (IdrisC-45ProcessIdr-processMod arg-0 arg-2 arg-3 arg-1 arg-4 arg-7 e-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 arg-5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Building") arg-6)) e-2 arg-8 eta-2)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "module" 10 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 arg-5 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Skipping") arg-6)))) clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (vector 1 '())))) (let ((e-1 (unbox e-7))) (let ((sc5 (DataC-45List-isNil e-1))) (cond ((equal? sc5 1) (let ((act-4 (CoreC-45Directory-ctxtPathToNS arg-0 arg-7 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Directory-makeBuildDirectory arg-0 e-8 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((act-6 (let ((act-6 (CoreC-45Context-getSession arg-0 eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (u--cg) (lambda (eta-3) (let ((act-7 (IdrisC-45ProcessIdr-getCG arg-4 arg-0 u--cg eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-11) (let ((act-8 (PreludeC-45IO-prim__putStr (string-append (string-append "No incremental code generator for " (CoreC-45Options-u--show_Show_CG u--cg)) "\xa;") clam-2))) (vector 1 act-8)) (let ((e-3 (unbox e-11))) (let ((act-8 ((CompilerC-45Common-incCompile arg-0 arg-3 e-3 arg-7) clam-2))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (if (null? e-12) (lambda (eta-4) (vector 1 (vector 0 ))) (let ((e-4 (unbox e-12))) (CoreC-45Context-setIncData arg-0 u--cg e-4))))) eff-0) clam-2)))))))))) eff-0) eta-3))))))) (let ((e-22 (vector-ref e-10 22))) e-22)))) eff-0) eta-2))))))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((act-7 (let ((act-7 (let ((act-7 (unbox arg-3))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Binary-writeToTTC (cons (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-4) (IdrisC-45Syntax-u--full_HasNames_SyntaxInfo arg-7719 arg-7722 eta-4)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-4) (IdrisC-45Syntax-u--resolved_HasNames_SyntaxInfo arg-7729 arg-7732 eta-4))))) csegen-4083) arg-0 arg-2 e-11 arg-7 e-6 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((act-8 (CoreC-45Directory-getTTCFileName arg-0 arg-7 "ttm" eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 (CoreC-45Metadata-writeToTTM arg-0 arg-1 e-12 eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (vector 1 '()))))))) eff-0) eta-2))))))))))))))))) eff-0) clam-1)))))) (else (vector 1 e-1))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (u--err) (lambda (eta-0) (vector 1 (cons u--err '())))) clam-0))) (else (let ((e-6 (vector-ref e-5 1))) (vector 1 (cons (vector 51 arg-7 e-6) '())))))))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-slash (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-681 #\/))
(define IdrisC-45ModTree-case--buildMod-11013 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-6 "import" 20 (lambda () (DataC-45String-unwords (PreludeC-45TypesC-45List-tailRecAppend (cons "Checking whether to rebuild " (cons arg-7 (cons (string-append "(" (string-append arg-9 ")")) (cons "with dependencies:" '())))) e-3))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (IdrisC-45ModTree-needsBuilding arg-6 arg-4 arg-7 arg-9 e-3 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (csegen-1985 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 0 arg-8))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (set-box! arg-5 IdrisC-45Syntax-initSyntax))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 (cond ((equal? e-6 1) (((let ((u--pad (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat arg-1)) (PreludeC-45TypesC-45String-length (PreludeC-45Show-u--show_Show_Nat arg-2)))))) (let ((u--msgPrefix (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate u--pad #\ )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 arg-2)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-slash) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 arg-1)) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon))) (let ((u--buildMsg (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2789 (let ((e-1 (vector-ref arg-0 1))) e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-parens (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 arg-7))))) (lambda () (lambda (eta-3) (let ((act-6 (CoreC-45ContextC-45Log-log arg-6 "import.file" 10 (lambda () (string-append "Processing " arg-7)) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (IdrisC-45ProcessIdr-process arg-6 e-8 e-7 arg-5 arg-4 u--msgPrefix u--buildMsg arg-7 arg-8 eta-3)))))))))) eta-2)) (else (vector 1 '()))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (IdrisC-45REPLC-45Common-emitWarningsAndErrors arg-6 arg-4 arg-5 (let ((sc7 (PreludeC-45Types-u--null_Foldable_List e-10))) (cond ((equal? sc7 1) e-2) (else e-10))) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-11 (let ((sc8 (PreludeC-45Types-u--null_Foldable_List e-10))) (cond ((equal? sc8 1) e-2) (else (PreludeC-45TypesC-45List-tailRecAppend e-2 e-10))))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))))
(define IdrisC-45ModTree-buildMod (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45Context-clearCtxt arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((CoreC-45InitPrimitives-addPrimitives arg-0) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45Context-lazyActive arg-0 1) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Context-setUnboundImplicits arg-0 1) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--sourceFile (let ((e-0 (vector-ref arg-6 0))) e-0))) (let ((u--modNamespace (let ((e-1 (vector-ref arg-6 1))) e-1))) (let ((act-5 (CoreC-45Directory-getTTCFileName arg-0 u--sourceFile "ttc" ext-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45Directory-nsToPath arg-0 arg-3 eta-1 eta-2))) (let ((e-2 (vector-ref arg-6 2))) e-2) '()) eta-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45ModTree-case--buildMod-11013 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--sourceFile u--modNamespace e-9 e-10 (DataC-45Either-partitionEithers e-10) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))))))))))))))
(define IdrisC-45ModTree-buildMods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 '()) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (let ((act-1 (IdrisC-45ModTree-buildMod arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (IdrisC-45ModTree-buildMods arg-0 arg-1 arg-2 arg-3 (+ arg-4 1) arg-5 e-3 eta-0)) (lambda (eta-0) (vector 1 e-5))))) eff-0) ext-0))))))))))
(define IdrisC-45ModTree-mkBuildMods (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (let ((e-1 (vector-ref arg-2 1))) (if (null? e-1) (vector 1 (vector 0 )) (let ((e-3 (unbox e-1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (LibrariesC-45DataC-45StringMap-lookup e-3 e-5))) (if (null? sc2) (let ((act-2 ((CoreC-45Core-traverse_ (lambda (eta-0) (IdrisC-45ModTree-mkBuildMods arg-0 arg-1 eta-0)) (let ((e-4 (vector-ref arg-2 2))) e-4)) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (unbox arg-1))) (vector 1 act-3))))) (lambda (world-0) (let ((act-3 (eff-0 world-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-1 (lambda (world-1) (let ((act-4 (set-box! arg-1 (cons (vector e-3 (let ((e-9 (vector-ref arg-2 0))) e-9) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-9 (vector-ref eta-0 0))) e-9)) (let ((e-4 (vector-ref arg-2 2))) e-4))) e-7)))) (vector 1 act-4))))) eff-1) world-0))))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-0))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-0 (LibrariesC-45DataC-45StringMap-insert e-3 (vector 0 ) e-8)))) (vector 1 act-5))))) eff-1) world-0))))))) clam-1))))))) (vector 1 (vector 0 ))))))) eff-0) clam-0)))))))))))
(define IdrisC-45ModTree-mkModTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-276 arg-6 arg-4))) (cond ((equal? sc0 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 59 (PreludeC-45TypesC-45List-tailRecAppend arg-4 (cons arg-6 '()))) ext-0)) (else (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (DataC-45List-lookup csegen-276 arg-6 e-5))) (if (null? sc2) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (CoreC-45Directory-nsToSource arg-0 arg-3 arg-6 eta-1))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) arg-5) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (IdrisC-45ProcessIdr-readHeader arg-0 arg-1 e-6 arg-6 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--imps (PreludeC-45TypesC-45List-mapAppend '() csegen-4143 (let ((e-2 (vector-ref e-7 2))) e-2)))) (lambda (clam-2) (let ((sc5 (PreludeC-45Types-elem csegen-14 csegen-276 arg-6 u--imps))) (cond ((equal? sc5 1) (CoreC-45Core-coreFail (vector 59 (cons arg-6 (cons arg-6 '()))) clam-2)) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45ModTree-mkModTree arg-0 arg-1 arg-2 arg-3 (cons arg-6 arg-4) '() eta-2 eta-3))) u--imps '()) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--mt (vector arg-6 (box e-6) e-8))) (lambda (eta-2) (let ((act-5 ((let ((eff-0 (lambda (world-0) (let ((act-5 (unbox arg-2))) (vector 1 act-5))))) (lambda (world-0) (let ((act-5 (eff-0 world-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-1 (lambda (world-1) (let ((act-6 (set-box! arg-2 (cons (cons arg-6 u--mt) e-9)))) (vector 1 act-6))))) eff-1) world-0))))))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 u--mt)))))))) eff-0) clam-2)))))))))))) eff-0) eta-1)))))))) eff-0) clam-1))))) (let ((e-2 (unbox sc2))) (vector 1 e-2))))))) eff-0) eta-0)))))) (lambda (u--err) (lambda (clam-3) (case (vector-ref u--err 0) ((59) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-3)) ((57) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-3)) ((56) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-3)) ((55) (CoreC-45Core-u--throw_Catchable_Core_Error u--err clam-3))(else (vector 1 (vector arg-6 '() '())))))) ext-0))))))
(define IdrisC-45ModTree-getBuildMods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Idris.ModTree.AllMods" ) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-276 e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (let ((e-1 (vector-ref eta-1 1))) e-1)) arg-3)))) (cond ((equal? sc2 1) (vector 1 '())) (else (let ((act-3 (IdrisC-45ModTree-mkModTree arg-0 arg-1 e-5 arg-2 '() (box arg-4) e-6 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-newRef (vector "Idris.ModTree.DoneMod" ) LibrariesC-45DataC-45StringMap-empty) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-newRef (vector "Idris.ModTree.BuildOrder" ) '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 ((IdrisC-45ModTree-mkBuildMods e-8 e-9 e-7) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 (unbox e-9))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (PreludeC-45TypesC-45List-reverse e-11))))) eff-0) eta-3))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-0))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-readAsMain (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Binary-readFromTTC csegen-4083 arg-0 arg-1 1 (vector 2 ) 1 arg-3 CoreC-45NameC-45Namespace-emptyNS CoreC-45NameC-45Namespace-emptyNS ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Already loaded") eta-0)) (let ((e-1 (unbox e-5))) (lambda (clam-0) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-10 (cdr e-6))) (let ((act-2 (CoreC-45Context-getNS arg-0 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Context-getNestedNS arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (IdrisC-45Desugar-extendSyn arg-2 arg-0 e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (unbox arg-1))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 ((CoreC-45Core-traverse_ (lambda (u--mimp) (let ((u--m (Builtin-fst u--mimp))) (let ((u--as (Builtin-snd (Builtin-snd u--mimp)))) (lambda (eta-3) (let ((act-6 (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 1 CoreC-45FC-emptyFC 1 u--m u--as eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else ((CoreC-45Context-addImported arg-0 (cons u--m (cons 1 u--as))) eta-3)))))))) e-10) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 (CoreC-45Context-getSession arg-0 eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc10 (let ((e-0 (vector-ref e-15 0))) e-0))) (cond ((equal? sc10 1) (vector 1 (vector 0 ))) (else (IdrisC-45ProcessIdr-readModule arg-0 arg-1 arg-2 1 CoreC-45FC-emptyFC 1 CoreC-45NameC-45Namespace-preludeNS CoreC-45NameC-45Namespace-preludeNS clam-1))))))) eff-0) eta-2))))))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 ((let ((eff-0 (lambda (world-0) (let ((act-8 (unbox arg-1))) (vector 1 act-8))))) (lambda (world-0) (let ((act-8 (eff-0 world-0))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-8 1))) ((let ((eff-1 (lambda (world-1) (let ((act-9 (set-box! arg-1 (let ((e-0 (vector-ref e-16 0))) (let ((e-24 (vector-ref e-16 1))) (let ((e-2 (vector-ref e-16 2))) (let ((e-3 (vector-ref e-16 3))) (let ((e-4 (vector-ref e-16 4))) (let ((e-23 (vector-ref e-16 5))) (let ((e-22 (vector-ref e-16 6))) (let ((e-21 (vector-ref e-16 7))) (let ((e-19 (vector-ref e-16 9))) (let ((e-18 (vector-ref e-16 10))) (let ((e-17 (vector-ref e-16 11))) (vector e-0 e-24 e-2 e-3 e-4 e-23 e-22 e-21 (let ((e-28 (vector-ref e-13 8))) e-28) e-19 e-18 e-17))))))))))))))) (vector 1 act-9))))) eff-1) world-0))))))) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 ((CoreC-45Context-setNS arg-0 e-8) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else ((CoreC-45Context-setNestedNS arg-0 e-11) eta-2)))))))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))) eff-0) ext-0)))))))
(define CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (LibrariesC-45DataC-45PosMap-fromList (Builtin-snd arg-1) e-5)))))) (lambda (eta-0) (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 (Builtin-fst arg-1) arg-2 eta-0)) ext-0)))
(define CoreC-45Metadata-u--fromBuf_TTC_Metadata (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-2078 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-2086 arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-2086 arg-0 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40ListC-32C-36aC-41 csegen-2090 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2095 arg-0 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45TTC-u--fromBuf_TTC_OriginDesc arg-0 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2110 arg-0 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2115 arg-0 eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-9 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_C-40PosMapC-32C-36aC-41 csegen-2110 arg-0 eta-7))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-8) (vector 1 (vector e-5 e-6 e-7 '() e-8 e-9 e-10 e-11 e-12 e-13))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-u--fromBuf_TTC_TTMFile (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_String arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_String e-5 "TTM"))) (cond ((equal? sc1 1) (CoreC-45BinaryC-45Prims-corrupt "TTM header" eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45BinaryC-45Prims-u--fromBuf_TTC_Int arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Binary-checkTTCVersion "" e-7 CoreC-45Binary-ttcVersion eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (CoreC-45Metadata-u--fromBuf_TTC_Metadata arg-0 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-7 e-9))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-readFromTTM (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile arg-1 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Metadata-u--fromBuf_TTC_TTMFile e-6 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (set-box! arg-0 (let ((e-1 (cdr e-7))) e-1)))) (vector 1 act-4))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append arg-1 (string-append ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-6)))) clam-0))))))) eff-0) ext-0)))))))
(define IdrisC-45ModTree-u--show_Show_BuildMod (lambda (arg-0) (string-append (let ((e-0 (vector-ref arg-0 0))) e-0) (string-append " [" (string-append (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent eta-0)) (let ((e-2 (vector-ref arg-0 2))) e-2))) "]")))))
(define IdrisC-45ModTree-u--showPrec_Show_BuildMod (lambda (arg-0 arg-1) (IdrisC-45ModTree-u--show_Show_BuildMod arg-1)))
(define IdrisC-45ModTree-buildDeps (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (IdrisC-45ModTree-getBuildMods arg-0 arg-4 (vector 2 ) '() arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "import" 20 (lambda () (string-append "Needs to rebuild: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (IdrisC-45ModTree-u--show_Show_BuildMod u--x)) (lambda (u--d) (lambda (u--x) (IdrisC-45ModTree-u--showPrec_Show_BuildMod u--d u--x)))) e-5))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (IdrisC-45ModTree-buildMods arg-0 arg-1 arg-4 (vector 2 ) 1 (PreludeC-45TypesC-45List-lengthTR e-5) e-5 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (let ((act-4 (CoreC-45Context-clearCtxt arg-0 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((CoreC-45InitPrimitives-addPrimitives arg-0) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (CoreC-45Directory-ctxtPathToNS arg-0 arg-5 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-7 (let ((act-7 (set-box! arg-2 (CoreC-45Metadata-initMetadata (vector 0 e-10))))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45Directory-getTTCFileName arg-0 arg-5 "ttc" eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-9 (CoreC-45ContextC-45Log-log arg-0 "import" 10 (lambda () (string-append "Reloading " (string-append (PreludeC-45Show-u--show_Show_String e-12) (string-append " from " arg-5)))) eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (IdrisC-45ProcessIdr-readAsMain arg-0 arg-3 arg-1 e-12 eta-2))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 (CoreC-45Directory-getTTCFileName arg-0 arg-5 "ttm" eta-2))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-11 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-12 (CoreC-45ContextC-45Log-log arg-0 "import" 10 (lambda () (string-append "Reloading " (PreludeC-45Show-u--show_Show_String e-15))) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((act-13 (CoreC-45Metadata-readFromTTM arg-2 e-15 eta-3))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (vector 1 '())))))))))) eff-0) eta-2)))))))))))))) eff-0) eta-1))))))))))) eff-0) clam-0))))))))))) (vector 1 e-7))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define CoreC-45Options-clearNames (lambda (ext-0) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (let ((e-3 (vector-ref ext-0 3))) (let ((e-8 (vector-ref ext-0 8))) (let ((e-9 (vector-ref ext-0 9))) (vector e-0 e-1 e-2 e-3 '() '() csegen-1338 '() e-8 e-9)))))))))
(define IdrisC-45REPLC-45Common-resetContext (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Context-initDefs eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 (CoreC-45Options-clearNames (let ((e-63 (vector-ref e-5 4))) e-63)) e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((CoreC-45InitPrimitives-addPrimitives arg-0) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (set-box! arg-1 CoreC-45UnifyState-initUState))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (set-box! arg-2 IdrisC-45Syntax-initSyntax))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (set-box! arg-3 (CoreC-45Metadata-initMetadata arg-4)))) (vector 1 act-6))))))))))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Opts-resetProofState (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 '() '() e-12 e-13 e-14 e-15 e-16))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45REPLC-45Common-getFCLine (lambda (ext-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45FC-startLine eta-0)) (CoreC-45FC-isNonEmptyFC ext-0))))
(define IdrisC-45REPLC-45Common-updateErrorLine (lambda (arg-0 arg-1) (if (null? arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 '() e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))) (let ((e-2 (car arg-1))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-19 (vector-ref e-5 2))) (let ((e-18 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-19 e-18 e-4 e-17 e-6 (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45Core-getErrorLoc e-2) (lambda (eta-0) (IdrisC-45REPLC-45Common-getFCLine eta-0))) e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))))
(define IdrisC-45REPL-loadMainFile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-4))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-4 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 '() e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Directory-ctxtPathToNS arg-0 arg-5 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (IdrisC-45REPLC-45Common-resetContext arg-0 arg-1 arg-2 arg-3 (vector 0 e-6) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-5) eta-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-8 0) ((1) (let ((e-2 (vector-ref e-8 1))) (let ((act-5 (CoreC-45ContextC-45Log-logTime arg-0 1 (lambda () "Build deps") (lambda (eta-1) (IdrisC-45ModTree-buildDeps arg-0 arg-2 arg-3 arg-1 arg-4 arg-5 eta-1)) clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-6 ((IdrisC-45REPLC-45Common-updateErrorLine arg-4 e-9) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((act-7 ((IdrisC-45REPLC-45Opts-setSource arg-4 e-2) eta-1))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((act-8 ((IdrisC-45REPLC-45Opts-resetProofState arg-4) eta-1))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (if (null? e-9) (vector 1 (vector 9 arg-5)) (vector 1 (vector 13 arg-5 e-9))))))))))))))) eff-0) clam-0))))))) (else (let ((e-9 (vector-ref e-8 1))) (let ((act-5 ((IdrisC-45REPLC-45Opts-setSource arg-4 "") clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (vector 1 (vector 12 arg-5 e-9))))))))))) eff-0) eta-0))))))))))) eff-0) ext-0))))))))))
(define CoreC-45Options-execBuildDir (lambda (arg-0) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-2 (vector-ref arg-0 2))) e-2) "exec")))
(define CompilerC-45Common-compile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--tmpDir (CoreC-45Options-execBuildDir e-5))) (let ((u--outputDir (CoreC-45Options-outputDirWithDefault e-5))) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-ensureDirectoryExists u--tmpDir eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Directory-ensureDirectoryExists u--outputDir eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-logTime arg-0 1 (lambda () "Code generation overall") (let ((e-0 (vector-ref arg-2 0))) ((((((e-0 arg-0) arg-1) u--tmpDir) u--outputDir) arg-3) arg-4)) eta-0)))))))))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-findCG (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45ProcessIdr-getCG arg-0 arg-1 (let ((e-4 (vector-ref e-5 4))) (let ((e-41 (vector-ref e-4 2))) (let ((e-64 (vector-ref e-41 4))) e-64))) eta-0)))) eff-0) ext-0)))))))
(define IdrisC-45REPL-getItDecls (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-12 (vector-ref e-5 12))) (if (null? e-12) (lambda (eta-0) (vector 1 '())) (let ((e-18 (unbox e-12))) (let ((u--it (vector 1 (vector 0 "it")))) (lambda (eta-0) (vector 1 (cons (vector 0 CoreC-45FC-replFC AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega 0 '() (vector CoreC-45FC-replFC (vector 2 ) u--it (vector 32 CoreC-45FC-replFC 0))) (cons (vector 2 CoreC-45FC-replFC u--it (cons (vector 0 CoreC-45FC-replFC (vector 0 CoreC-45FC-replFC u--it) (vector 0 CoreC-45FC-replFC e-18)) '())) '())))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-prepareExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (IdrisC-45Desugar-desugar arg-2 arg-0 arg-3 arg-1 arg-4 1 '() (vector 7 CoreC-45FC-replFC (vector 0 CoreC-45FC-replFC (vector 1 (vector 0 "unsafePerformIO"))) arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45REPL-getItDecls arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ttimpWithIt (vector 5 CoreC-45FC-replFC e-6 e-5))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-resolveName arg-0 (vector 1 (vector 0 "[input]")) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((TTImpC-45Elab-elabTerm '() arg-0 arg-3 arg-1 arg-2 arg-4 e-7 (vector 2 ) '() '() '() u--ttimpWithIt '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-8))) (let ((act-5 (CoreC-45LinearCheck-linearCheck '() arg-0 arg-1 CoreC-45FC-replFC csegen-1416 1 '() e-2 clam-0))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (CompilerC-45Inline-compileAndInlineAll arg-0 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (vector 1 e-9))))))) eff-0) clam-0))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-compileExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (IdrisC-45ProcessIdr-findCG arg-4 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No such code generator available") clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 16 ))))) (let ((e-1 (unbox e-5))) (let ((act-2 (IdrisC-45REPL-prepareExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CompilerC-45Common-compile arg-0 arg-2 e-1 e-6 arg-6 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 (vector 16 )))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 (vector 17 eta-1))))) e-7))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define CompilerC-45Common-execute (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-getDirs arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--tmpDir (CoreC-45Options-execBuildDir e-5))) (lambda (eta-0) (let ((act-2 (CoreC-45Directory-ensureDirectoryExists u--tmpDir eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-1 (vector-ref arg-2 1))) (((((e-1 arg-0) arg-1) u--tmpDir) arg-3) eta-0))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Opts-getEvalTiming (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define IdrisC-45REPL-execExp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (IdrisC-45ProcessIdr-findCG arg-4 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No such code generator available") clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 16 ))))) (let ((e-1 (unbox e-5))) (let ((act-2 (IdrisC-45REPL-prepareExp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (IdrisC-45REPLC-45Opts-getEvalTiming arg-4 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45ContextC-45Log-logTimeWhen arg-0 e-7 0 (lambda () "Execution") (lambda (eta-1) (CompilerC-45Common-execute arg-0 arg-2 e-1 e-6 eta-1))))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (vector 2 arg-5)))))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45Parser-help (cons (cons (cons "<expr>" '()) (cons (vector 0 ) "Evaluate an expression")) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (cons (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-0) (string-append ":" arg-0)) e-2) (cons e-6 e-10)))))))) IdrisC-45Parser-parserCommandsForHelp)))
(define IdrisC-45Parser-showCmdArg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "") ((1) "name") ((2) "expr") ((3) "keyword|expr") ((4) "decls") ((5) "number") ((6) "number|auto") ((7) "option") ((8) "file") ((9) "module") ((10) "string") ((11) "(on|off)") ((14) (let ((e-0 (vector-ref arg-0 1))) (string-append "[" (string-append (IdrisC-45Parser-showCmdArg e-0) "]")))) ((13) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (string-append (IdrisC-45Parser-showCmdArg e-2) (string-append "|" e-1))))) ((12) (let ((e-3 (vector-ref arg-0 1))) (let ((e-4 (vector-ref arg-0 2))) (string-append e-3 (string-append ":" (IdrisC-45Parser-showCmdArg e-4)))))) (else (IdrisC-45Parser-u--show_Show_CmdArg arg-0)))))
(define IdrisC-45Parser-u--show_Show_CmdArg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "") ((11) "(on|off)") ((15) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45NameC-45Namespace-showSep " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45Parser-u--show_Show_CmdArg eta-0)) e-0))))(else (string-append "<" (string-append (IdrisC-45Parser-showCmdArg arg-0) ">"))))))
(define DataC-45Stream-repeat (lambda (arg-1) (cons arg-1 (lambda () (DataC-45Stream-repeat arg-1)))))
(define IdrisC-45REPL-n--35305-18857-u--makeSpace (lambda (arg-0) (PreludeC-45Types-fastPack (PreludeC-45Types-take arg-0 (DataC-45Stream-repeat #\ )))))
(define IdrisC-45REPL-n--35305-18856-u--col (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (string-append arg-2 (string-append (IdrisC-45REPL-n--35305-18857-u--makeSpace (PreludeC-45Types-prim__integerToNat (- arg-0 (PreludeC-45TypesC-45String-length arg-2)))) (string-append arg-3 (string-append (IdrisC-45REPL-n--35305-18857-u--makeSpace (PreludeC-45Types-prim__integerToNat (- arg-1 (PreludeC-45TypesC-45String-length arg-3)))) arg-4))))))
(define IdrisC-45REPL-n--35305-18855-u--cmdInfo (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (string-append " " (IdrisC-45REPL-n--35305-18856-u--col 18 36 (CoreC-45NameC-45Namespace-showSep " " e-2) (IdrisC-45Parser-u--show_Show_CmdArg e-6) e-7))))))))
(define IdrisC-45REPL-displayHelp (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45REPL-n--35305-18855-u--cmdInfo eta-0)) IdrisC-45Parser-help)))
(define IdrisC-45REPL-handleMissing (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-3126 e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Calls non covering") (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "functions:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-3081 e-3))) (let ((e-1 (car e-3))) (let ((e-4 (cdr e-3))) (if (null? e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "function") (IdrisC-45Pretty-code (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "functions:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith csegen-879 (PreludeC-45TypesC-45List-mapAppend '() csegen-3081 e-3)))))))))))) (else (let ((e-4 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-4) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "All cases covered")))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-underline (PreludeC-45Types-u--pure_Applicative_List (vector 3 4)))
(define IdrisC-45DocC-45Annotations-styleAnn (lambda (arg-0) (case (vector-ref arg-0 0) ((0) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-underline) ((1) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45Terminal-bold) ((2) '()) ((3) '()) ((4) '()) ((5) '()) (else (let ((e-1 (vector-ref arg-0 1))) (IdrisC-45Pretty-syntaxAnn e-1))))))
(define IdrisC-45REPLC-45Common-printDocResult (lambda (arg-0 arg-1 ext-0) (IdrisC-45REPLC-45Common-printWithStatus arg-0 (lambda (eta-0) (lambda (eta-1) (IdrisC-45PrettyC-45Render-render arg-0 (lambda (eta-2) (IdrisC-45DocC-45Annotations-styleAnn eta-2)) eta-0 eta-1))) arg-1 0 ext-0)))
(define IdrisC-45REPLC-45Common-printResult (lambda (arg-0 arg-1 ext-0) (IdrisC-45REPLC-45Common-printWithStatus arg-0 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Pretty-render arg-0 eta-0 eta-1))) arg-1 0 ext-0)))
(define ParserC-45Unlit-relit (lambda (arg-0 arg-1) (if (null? arg-0) arg-1 (let ((e-2 (unbox arg-0))) (DataC-45String-unwords (cons e-2 (cons arg-1 '())))))))
(define IdrisC-45Syntax-u--pretty_Pretty_Void_REPLEval (lambda (arg-0) (cond ((equal? arg-0 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "typecheck")) ((equal? arg-0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "normalise")) ((equal? arg-0 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "execute")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "scheme")))))
(define IdrisC-45Syntax-u--pretty_Pretty_Void_REPLOpt (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "showimplicits") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Bool e-0)))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "shownamespace") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Bool e-1)))))) ((2) (let ((e-2 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "showmachinenames") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Bool e-2)))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "showtypes") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Bool e-3)))))) ((4) (let ((e-4 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "eval") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (IdrisC-45Syntax-u--pretty_Pretty_Void_REPLEval e-4))))) ((5) (let ((e-5 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "editor") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-5))))) ((6) (let ((e-6 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "cg") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-6))))) ((7) (let ((e-7 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "profile") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Bool e-7)))))) (else (let ((e-8 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "evaltiming") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Bool e-8)))))))))
(define IdrisC-45Syntax-u--prettyPrec_Pretty_Void_REPLOpt (lambda (arg-0 arg-1) (IdrisC-45Syntax-u--pretty_Pretty_Void_REPLOpt arg-1)))
(define IdrisC-45REPL-displayResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((1) (let ((e-0 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 e-0 eta-0)))) ((5) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (lambda (clam-0) (if (null? e-2) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-0) (vector 6 eta-0)) e-1) clam-0) (let ((e-30 (unbox e-2))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-0) (vector 6 eta-0)) e-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-0) (vector 6 eta-0)) e-30))) clam-0))))))) ((6) (let ((e-3 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 e-3 eta-0)))) ((7) (let ((e-4 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printDocResult arg-4 e-4 eta-0)))) ((8) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-1) (vector 6 eta-1)) e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-1) (vector 6 eta-1)) e-6))) eta-0))))) ((9) (let ((e-7 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Loaded file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-7)) eta-0)))) ((10) (let ((e-8 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Imported module") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-8)) eta-0)))) ((11) (let ((e-9 (vector-ref arg-5 1))) (let ((e-10 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (IdrisC-45Error-perror arg-0 arg-2 arg-4 e-10 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error loading module") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-9) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) e-5)) eta-1)))) eff-0) eta-0))))))))) ((12) (let ((e-11 (vector-ref arg-5 1))) (let ((e-12 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error loading file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-11) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (SystemC-45FileC-45Error-u--show_Show_FileError e-12)))) eta-0))))) ((13) (let ((e-13 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error(s) building file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-13)) eta-0)))) ((14) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No file can be reloaded") eta-0))) ((15) (let ((e-15 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Current working directory is") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-15))) eta-0)))) ((16) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Compilation failed") eta-0))) ((17) (let ((e-16 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "File") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-16) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "written"))) eta-0)))) ((18) (let ((e-17 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-1) (vector 6 eta-1)) e-17) eta-0)))) ((19) (let ((e-18 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (IdrisC-45REPL-handleMissing eta-1)) e-18)) eta-0)))) ((20) (let ((e-19 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "is") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-3158 e-3)))))) e-19)) eta-0)))) ((22) (let ((e-20 (vector-ref arg-5 1))) (lambda (clam-1) (if (null? e-20) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Logging turned off") clam-1) (let ((e-33 (unbox e-20))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Set log level to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-3952 e-33)) clam-1)))))) ((23) (let ((e-21 (vector-ref arg-5 1))) (lambda (clam-2) (if (null? e-21) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Set consolewidth to auto") clam-2) (let ((e-35 (unbox e-21))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Set consolewidth to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-35)) clam-2)))))) ((24) (let ((e-22 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (cond ((equal? e-22 1) "Set color on") (else "Set color off"))) eta-0)))) ((25) (let ((e-23 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (LibrariesC-45DataC-45Version-showVersion 1 e-23)) eta-0)))) ((3) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 IdrisC-45REPL-displayHelp) eta-0))) ((4) (let ((e-24 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-24) eta-0)))) ((28) (let ((e-25 (vector-ref arg-5 1))) (lambda (clam-0) (case (vector-ref e-25 0) ((0) (let ((e-37 (vector-ref e-25 1))) (case (vector-ref e-37 0) ((0) (vector 1 (vector 0 )))(else (IdrisC-45REPLC-45Common-printResult arg-4 e-37 clam-0))))) ((1) (let ((e-38 (vector-ref e-25 1))) (IdrisC-45REPLC-45Common-printResult arg-4 e-38 clam-0))) ((2) (let ((e-39 (vector-ref e-25 1))) (let ((e-40 (vector-ref e-25 2))) (let ((e-41 (vector-ref e-25 3))) (let ((e-42 (vector-ref e-25 4))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (string-append (ParserC-45Unlit-relit e-39 (string-append (CoreC-45Name-u--show_Show_Name e-40) (string-append " : " (string-append (IdrisC-45Syntax-u--show_Show_IPTerm e-41) "\xa;")))) e-42)) clam-0)))))) ((3) (let ((e-43 (vector-ref e-25 1))) (let ((e-44 (vector-ref e-25 2))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45Unlit-relit e-43 eta-0)) e-44))) clam-0)))) ((4) (let ((e-45 (vector-ref e-25 1))) (let ((e-46 (vector-ref e-25 2))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45Unlit-relit e-45 eta-0)) e-46))) clam-0)))) (else (let ((e-47 (vector-ref e-25 1))) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45NameC-45Namespace-showSep "\xa;" (DataC-45List1-forget e-47))) clam-0))))))) ((21) (let ((e-26 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPLC-45Common-printResult arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 (cons (lambda (arg-11067) (IdrisC-45Syntax-u--pretty_Pretty_Void_REPLOpt arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (IdrisC-45Syntax-u--prettyPrec_Pretty_Void_REPLOpt arg-11073 arg-11076)))) eta-1)) e-26)) eta-0)))) ((0) (lambda (eta-0) (vector 1 (vector 0 )))) ((2) (lambda (eta-0) (vector 1 (vector 0 )))) ((26) (lambda (eta-0) (vector 1 (vector 0 )))) (else (lambda (eta-0) (vector 1 (vector 0 )))))))
(define IdrisC-45Parser-eval (vector 9 0 csegen-4244 (lambda () (lambda (u--tm) (vector 0 (vector 1 u--tm))))))
(define IdrisC-45Parser-nonEmptyCommand (LibrariesC-45TextC-45Parser-choice csegen-14 1 (PreludeC-45TypesC-45List-mapAppend '() csegen-3974 IdrisC-45Parser-parserCommandsForHelp)))
(define IdrisC-45Parser-command (vector 13 0 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (vector 32 )) ParserC-45RuleC-45Source-eoi) (lambda () (vector 13 1 1 IdrisC-45Parser-nonEmptyCommand (lambda () (vector 13 1 1 (vector 11 0 (ParserC-45RuleC-45Source-symbol ":?") (lambda () (vector 10 0 0 IdrisC-45Parser-getHelpType (lambda (u--helpType) (vector 0 (vector 11 u--helpType)))))) (lambda () IdrisC-45Parser-eval)))))))
(define IdrisC-45REPL-parseCmd (vector 10 0 0 IdrisC-45Parser-command (lambda (u--c) (vector 12 0 0 ParserC-45RuleC-45Source-eoi (vector 0 (box u--c))))))
(define IdrisC-45REPL-parseEmptyCmd (vector 10 0 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (lambda (eta-1) eta-1)) ParserC-45RuleC-45Source-eoi) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (vector 0 '())))))
(define IdrisC-45REPL-parseRepl (lambda (arg-0) (let ((sc0 (ParserC-45Source-runParser 0 (vector 2 (vector 0 )) '() arg-0 (vector 13 0 0 IdrisC-45REPL-parseEmptyCmd (lambda () IdrisC-45REPL-parseCmd))))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref sc0 1))) (let ((e-9 (cdr e-5))) (let ((e-13 (cdr e-9))) (vector 1 e-13)))))))))
(define IdrisC-45ProcessIdr-addImport (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45ProcessIdr-readImport arg-0 arg-1 arg-2 1 arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((CoreC-45Context-setNS arg-0 e-5) eta-0))))))) eff-0) ext-0)))))))
(define CoreC-45Context-allNames (lambda (arg-0) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-u--full_HasNames_Name arg-0 eta-0 eta-1))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 8 eta-0)) (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 1 (bs- (let ((e-1 (vector-ref arg-0 1))) e-1) 1 63))) '())))
(define IdrisC-45Resugar-resugarNoPatvars (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (TTImpC-45Unelab-unelabNoPatvars arg-0 arg-1 arg-3 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-toCleanPTerm arg-1 arg-2 IdrisC-45Resugar-startPrec e-5 eta-0)))) eff-0) ext-0)))))))
(define IdrisC-45REPL-displayPatTerm (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-2 '() arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-resugarNoPatvars '() arg-0 arg-1 '() e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (IdrisC-45Syntax-u--show_Show_IPTerm e-5))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45Display-n--10289-9780-u--prettyLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 2))) (CoreC-45Name-prettyOp 1 (let ((e-3 (vector-ref e-2 2))) e-3))))(else (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm arg-7)))))
(define IdrisC-45DocC-45Display-displayClause (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-0 e-2 arg-2 e-6 e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-resugar e-2 arg-0 arg-1 e-6 e-5 eta-0)))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-0 e-2 arg-2 e-6 e-11 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45Resugar-resugar e-2 arg-0 arg-1 e-6 e-8 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Display-n--10289-9780-u--prettyLHS e-2 e-6 e-10 e-11 arg-2 arg-1 arg-0 e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-equals (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-8))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))
(define IdrisC-45IDEModeC-45Holes-case--isHole-9744 (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((7) (let ((e-0 (vector-ref arg-1 1))) (box e-0))) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-0 (vector-ref e-2 0))) (if (null? e-0) '() (let ((e-8 (unbox e-0))) (box e-8)))))) ((0) (box 0))(else '()))))
(define IdrisC-45IDEModeC-45Holes-isHole (lambda (arg-0) (IdrisC-45IDEModeC-45Holes-case--isHole-9744 arg-0 (let ((e-18 (vector-ref arg-0 18))) e-18))))
(define CoreC-45TTC-45Binder-isImplicit (lambda (ext-0) (CoreC-45TTC-45BinderC-45PiInfo-isImplicit (CoreC-45TTC-45Binder-piInfo ext-0))))
(define IdrisC-45IDEModeC-45Holes-showName (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref e-0 0) ((2) 0)(else 1)))) ((2) 0)(else 1))))
(define IdrisC-45IDEModeC-45Holes-extractHoleData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-6 0) (lambda (eta-0) (let ((act-1 (CoreC-45Normalise-normalise arg-1 arg-0 arg-3 arg-4 arg-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-4 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (CoreC-45Context-toFullNames arg-1 csegen-68 arg-7 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-68 e-5 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45ContextC-45Log-log arg-1 "ide-mode.hole" 20 (lambda () (string-append "Return type: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7) (string-append "\xa;  Evaluated to: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8) (string-append "\xa;  Resugared to: " (IdrisC-45Syntax-u--show_Show_IPTerm e-6))))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (vector arg-5 e-6 '())))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (let ((e-0 (- arg-6 1))) (case (vector-ref arg-7 0) ((3) (let ((e-3 (vector-ref arg-7 2))) (let ((e-4 (vector-ref arg-7 3))) (let ((e-5 (vector-ref arg-7 4))) (case (vector-ref e-4 0) ((1) (let ((e-9 (vector-ref e-4 3))) (IdrisC-45IDEModeC-45Holes-extractHoleData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-0 (CoreC-45TTC-45TermC-45Subst-subst e-9 e-5))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45IDEModeC-45Holes-extractHoleData (cons e-3 arg-0) arg-1 arg-2 arg-3 (cons e-4 arg-4) arg-5 e-0 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (IdrisC-45IDEModeC-45Holes-showName e-3))) (cond ((equal? sc2 1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.hole" 10 (lambda () (string-append "Showing name: " (CoreC-45Name-u--show_Show_Name e-3))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((act-3 (let ((act-3 (CoreC-45Normalise-normalise arg-1 arg-0 arg-3 arg-4 (CoreC-45TTC-45Binder-binderType e-4) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-4 e-8 eta-1)))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--premise (vector e-3 e-8 (CoreC-45TTC-45Binder-multiplicity e-4) (CoreC-45TTC-45Binder-isImplicit e-4)))) (lambda (eta-1) (vector 1 (let ((e-10 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-9 (vector-ref e-6 2))) (vector e-10 e-1 (cons u--premise e-9)))))))))) eff-0) clam-0))))))))) (else (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "ide-mode.hole" 10 (lambda () (string-append "Not showing name: " (CoreC-45Name-u--show_Show_Name e-3))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (vector 1 e-6)))))))))) eff-0) eta-0))))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45Normalise-normalise arg-1 arg-0 arg-3 arg-4 arg-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-4 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (CoreC-45Context-toFullNames arg-1 csegen-68 arg-7 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-68 e-5 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45ContextC-45Log-log arg-1 "ide-mode.hole" 20 (lambda () (string-append "Return type: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-7) (string-append "\xa;  Evaluated to: " (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 arg-0 e-8) (string-append "\xa;  Resugared to: " (IdrisC-45Syntax-u--show_Show_IPTerm e-6))))))) eta-4)))) eff-0) eta-3)))))))) eff-0) eta-2))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 (vector arg-5 e-6 '())))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define IdrisC-45IDEModeC-45Holes-n--11311-10170-u--dropShadows (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) '() (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 (let ((e-0 (vector-ref e-2 0))) e-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-0 (vector-ref eta-0 0))) e-0)) e-3)))) (cond ((equal? sc1 1) (IdrisC-45IDEModeC-45Holes-n--11311-10170-u--dropShadows arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)) (else (cons e-2 (IdrisC-45IDEModeC-45Holes-n--11311-10170-u--dropShadows arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3))))))))))
(define IdrisC-45IDEModeC-45Holes-holeData (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((IdrisC-45IDEModeC-45Holes-extractHoleData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getPPrint arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (let ((sc2 (let ((e-0 (vector-ref e-6 0))) e-0))) (cond ((equal? sc2 1) e-5) (else (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (vector e-0 e-1 (IdrisC-45IDEModeC-45Holes-n--11311-10170-u--dropShadows arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-2)))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45Holes-prettyImpBracket (lambda (arg-1 ext-0) (cond ((equal? arg-1 0) ext-0) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-braces ext-0)))))
(define IdrisC-45IDEModeC-45Holes-prettyRigHole (lambda (ext-0) (AlgebraC-45Semiring-elimSemi csegen-931 csegen-934 csegen-937 (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space)) ext-0)))
(define IdrisC-45IDEModeC-45Holes-u--pretty_Pretty_IdrisSyntax_HolesC-46Premise (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45IDEModeC-45Holes-prettyRigHole (let ((e-2 (vector-ref arg-0 2))) e-2)) (IdrisC-45IDEModeC-45Holes-prettyImpBracket (let ((e-3 (vector-ref arg-0 3))) e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 (let ((e-0 (vector-ref arg-0 0))) e-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (let ((e-1 (vector-ref arg-0 1))) e-1))))))))
(define IdrisC-45IDEModeC-45Holes-prettyHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (IdrisC-45IDEModeC-45Holes-holeData arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (vector-ref e-5 2))) (if (null? e-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 (let ((e-6 (vector-ref e-5 0))) e-6)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (let ((e-4 (vector-ref e-5 1))) e-4))))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45Holes-u--pretty_Pretty_IdrisSyntax_HolesC-46Premise eta-0)) (let ((e-3 (vector-ref e-5 2))) e-3)))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (DataC-45String-replicate 30 #\-))) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Name-nameRoot (let ((e-6 (vector-ref e-5 0))) e-6)))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (let ((e-4 (vector-ref e-5 1))) e-4)))))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45Display-displayType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-7 (cdr e-3))) (PreludeC-45Types-maybe (lambda () (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-3 '() (let ((e-26 (vector-ref e-7 2))) e-26) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-5 eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-aliasName arg-0 (let ((e-1 (vector-ref e-7 1))) e-1) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--nm (cond ((equal? arg-2 1) (CoreC-45Name-dropNS e-8)) (else e-8)))) (let ((u--prig (IdrisC-45PrettyC-45Annotations-prettyRig (let ((e-24 (vector-ref e-7 7))) e-24)))) (let ((u--ann (IdrisC-45Pretty-showCategory (lambda (eta-2) eta-2) e-7))) (lambda (eta-2) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--prig (u--ann (CoreC-45Name-prettyOp 1 u--nm))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-5)))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (lambda () (lambda (u--num) (lambda (eta-0) (IdrisC-45IDEModeC-45Holes-prettyHole '() arg-0 arg-1 arg-3 '() e-2 u--num (let ((e-26 (vector-ref e-7 2))) e-26) eta-0)))) (IdrisC-45IDEModeC-45Holes-isHole e-7)))))))
(define IdrisC-45DocC-45Display-displayPats (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (lambda (clam-0) (let ((e-18 (vector-ref e-7 18))) (case (vector-ref e-18 0) ((1) (let ((e-27 (vector-ref e-18 5))) (let ((act-1 ((IdrisC-45DocC-45Display-displayType arg-0 arg-1 arg-2 arg-3 (cons e-2 (cons e-6 e-7))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-32 (vector-ref act-1 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45Display-displayClause arg-0 arg-1 arg-3 eta-1)) e-27 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-33 (vector-ref act-2 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (cons e-32 e-33)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not a pattern matching definition")))))))))))))
(define IdrisC-45REPLC-45Common-n--14365-6965-u--typeSummary (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-0 (let ((e-0 (vector-ref arg-5 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) csegen-2721 (let ((e-1 (unbox e-5))) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-3 '() arg-5 '() (let ((e-2 (vector-ref e-1 2))) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-resugar '() arg-3 arg-2 '() e-6 eta-0)))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-1) (vector 6 eta-1)) e-6))))))) eff-0) clam-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32docsOrSignature-7131 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (lambda (clam-0) (if (null? arg-11) (IdrisC-45REPLC-45Common-n--14365-6965-u--typeSummary arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 clam-0) (IdrisC-45DocC-45String-getDocsForName arg-4 arg-3 arg-2 arg-1 arg-0 csegen-3176 clam-0)))))
(define IdrisC-45REPLC-45Common-docsOrSignature (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtName arg-4 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (CoreC-45Context-undefinedName arg-1 arg-3 arg-4 eta-2)) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (let ((_-0 (cons e-1 e-2))) (let ((u--all (cons e-1 e-2))) (IdrisC-45REPLC-45Common-case--caseC-32blockC-32inC-32docsOrSignature-7131 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 e-2 e-1 _-0 u--all (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (u--n) (LibrariesC-45DataC-45ANameMap-lookupName u--n (let ((e-12 (vector-ref e-5 7))) e-12))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) u--all)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45TTC-45Term-isErased (lambda (arg-1) (case (vector-ref arg-1 0) ((10) 1)(else 0))))
(define IdrisC-45REPLC-45Common-equivTypes (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (CoreC-45TTC-45Term-isErased arg-1))) (cond ((equal? sc0 0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-0 "typesearch.equiv" 10 (lambda () "Candidate: ") arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (CoreC-45Normalise-getArity arg-0 '() e-6 '() arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Normalise-getArity arg-0 '() e-6 '() arg-2 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (or (and (= e-7 e-8) 1) 0))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-7 1) (let ((act-4 (csegen-1985 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-5 (((((CoreC-45Unify-unify (csegen-2476) '() arg-0 e-8 CoreC-45Unify-inTerm (vector 2 )) '()) arg-1) arg-2) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((e-0 (vector-ref e-9 0))) (let ((e-2 (vector-ref e-9 2))) (let ((e-3 (vector-ref e-9 3))) (if (null? e-0) (lambda (clam-0) (if (null? e-2) (case (vector-ref e-3 0) ((0) (vector 1 1))(else (vector 1 0))) (vector 1 0))) (lambda (eta-3) (vector 1 0)))))))) eff-0) eta-2)))))) (lambda (u--err) (lambda (eta-2) (vector 1 0))) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (cond ((equal? e-9 1) (CoreC-45ContextC-45Log-logTerm '() arg-0 "typesearch.equiv" 20 (lambda () "Accepted: ") arg-1 eta-2)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 e-9))))))) eff-0) eta-1)))))))) eff-0) clam-1)))))) (else (vector 1 0)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))(else (vector 1 0))))))
(define IdrisC-45REPL-processLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (TTImpC-45ElabC-45Local-localHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9 arg-10 (lambda (u--nestC-39) (CoreC-45Core-traverse_ (lambda (eta-0) (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7 u--nestC-39 arg-9 eta-0)) arg-11)) ext-0)))
(define IdrisC-45REPL-n--31757-14774-u--execDecl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((IdrisC-45Desugar-desugarDecl arg-3 arg-5 arg-4 arg-2 arg-1 '() arg-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-resolveName arg-5 (vector 1 (vector 0 "[defs]")) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-newRef (vector "TTImp.Elab.Check.EST" ) (TTImpC-45ElabC-45Check-initEStateSub '() e-6 '() (vector 0 ))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (IdrisC-45REPL-getItDecls arg-1 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (IdrisC-45REPL-processLocal '() arg-5 arg-2 arg-4 e-7 arg-3 arg-1 '() '() '() e-8 e-5 eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-execDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-n--31757-14774-u--execDecl arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0 eta-1))) arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 26 )))))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1737-u--parseNameOrConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 2))) (box (vector 0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))) ((15) (let ((e-5 (vector-ref arg-6 2))) (case (vector-ref e-5 0) ((13) (let ((e-8 (vector-ref e-5 1))) (box (vector 1 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8))))(else '())))) ((22) (box (vector 2 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5)))(else '()))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1736-u--parseExprC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((7) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (PreludeC-45Types-u--C-60C-42C-62_Applicative_Maybe (box csegen-103) (IdrisC-45REPLC-45FuzzySearch-n--11833-1737-u--parseNameOrConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3)) (IdrisC-45REPLC-45FuzzySearch-n--11833-1736-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))))(else (PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-7) (cons arg-7 '())) (IdrisC-45REPLC-45FuzzySearch-n--11833-1737-u--parseNameOrConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6))))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1735-u--parseExpr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-5 (vector-ref arg-6 5))) (let ((e-6 (vector-ref arg-6 6))) (case (vector-ref e-6 0) ((25) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--11833-1736-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) (lambda (u--aC-39) (box (cons u--aC-39 '())))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--11833-1736-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5) (lambda (u--aC-39) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--11833-1736-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6) (lambda (u--bC-39) (box (cons u--aC-39 u--bC-39)))))))))))(else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45REPLC-45FuzzySearch-n--11833-1736-u--parseExprC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (u--bC-39) (box (cons '() u--bC-39))))))))
(define LibrariesC-45DataC-45ListC-45Extra-findByC-39 (lambda (arg-1 arg-2) (if (null? arg-2) (cons '() (cons '() '())) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-2))) (cond ((equal? sc1 1) (cons '() (cons (box e-2) e-3))) (else (let ((sc2 (LibrariesC-45DataC-45ListC-45Extra-findByC-39 arg-1 e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (cons (cons e-2 e-5) (cons e-6 e-7)))))))))))))))
(define LibrariesC-45DataC-45ListC-45Extra-case--diffBy-5539 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--ysC-39 (PreludeC-45TypesC-45List-tailRecAppend e-2 e-7))) (if (null? e-6) (cons arg-1 (LibrariesC-45DataC-45ListC-45Extra-diffBy arg-4 arg-2 u--ysC-39)) (LibrariesC-45DataC-45ListC-45Extra-diffBy arg-4 arg-2 u--ysC-39)))))))))
(define LibrariesC-45DataC-45ListC-45Extra-diffBy (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (LibrariesC-45DataC-45ListC-45Extra-case--diffBy-5539 e-2 e-3 arg-3 arg-1 (LibrariesC-45DataC-45ListC-45Extra-findByC-39 (arg-1 e-2) arg-3)))))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8) (case (vector-ref arg-8 0) ((0) arg-7) ((1) (let ((e-9 (vector-ref arg-8 3))) (cons (vector 0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9) arg-7))) ((2) (let ((e-14 (vector-ref arg-8 4))) (PreludeC-45Types-u--foldl_Foldable_List (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0 eta-1))) arg-7 e-14))) ((3) (let ((e-18 (vector-ref arg-8 3))) (let ((e-19 (vector-ref arg-8 4))) (case (vector-ref e-18 0) ((1) (let ((e-54 (vector-ref e-18 3))) (let ((e-55 (vector-ref e-18 4))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-54) e-55) e-19))))(else (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 (CoreC-45TTC-45Binder-binderType e-18)) e-19)))))) ((4) (let ((e-22 (vector-ref arg-8 2))) (let ((e-23 (vector-ref arg-8 3))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-22) e-23)))) ((5) (let ((e-28 (vector-ref arg-8 4))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-28))) ((6) (let ((e-32 (vector-ref arg-8 3))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-32))) ((7) (let ((e-36 (vector-ref arg-8 3))) (let ((e-37 (vector-ref arg-8 4))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-8 3))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 e-41))) ((9) (let ((e-43 (vector-ref arg-8 1))) (let ((e-44 (vector-ref arg-8 2))) (PreludeC-45TypesC-45List-tailRecAppend (DataC-45Maybe-fromMaybe (lambda () '()) (PreludeC-45Types-u--map_Functor_Maybe (lambda (arg-6) (cons arg-6 '())) (IdrisC-45REPLC-45FuzzySearch-n--11833-1737-u--parseNameOrConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (vector 15 e-43 e-44)))) arg-7)))) ((10) arg-7) (else (cons (vector 2 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) arg-7)))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1731-u--eqConst (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((1) (let ((e-6 (vector-ref arg-6 7))) (case (vector-ref arg-7 0) ((1) (let ((e-19 (vector-ref arg-7 7))) (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_PrimType e-6 e-19)))(else 0)))) ((2) (case (vector-ref arg-7 0) ((2) 1)(else 0)))(else 0))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1733-u--isApproximationOf (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-0 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-6 2))) (case (vector-ref arg-7 0) ((0) (let ((e-3 (vector-ref arg-7 1))) (let ((e-4 (vector-ref arg-7 2))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-1 e-4))) (cond ((equal? sc2 1) (CoreC-45NameC-45Namespace-isApproximationOf e-0 e-3)) (else 0))))))(else 0))))) ((1) (let ((e-2 (vector-ref arg-6 1))) (case (vector-ref arg-7 0) ((0) (let ((e-6 (vector-ref arg-7 2))) (case (vector-ref e-6 0) ((1) (let ((e-8 (vector-ref e-6 1))) (CoreC-45Name-u--C-61C-61_Eq_UserName e-2 e-8)))(else 0)))) ((1) (let ((e-7 (vector-ref arg-7 1))) (CoreC-45Name-u--C-61C-61_Eq_UserName e-2 e-7)))(else 0))))(else 0))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1734-u--isApproximationOfC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-6 0) ((0) (let ((e-6 (vector-ref arg-6 7))) (case (vector-ref arg-7 0) ((0) (let ((e-13 (vector-ref arg-7 7))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1733-u--isApproximationOf arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6 e-13)))(else (IdrisC-45REPLC-45FuzzySearch-n--11833-1731-u--eqConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))(else (IdrisC-45REPLC-45FuzzySearch-n--11833-1731-u--eqConst arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1739-u--toFullNamesC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-6 (vector-ref arg-6 7))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-7 (vector-ref eta-0 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (vector 0 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-7)))))) (lambda (eta-0) (CoreC-45Context-toFullNames arg-5 csegen-54 e-6 eta-0)) ext-0)))(else (vector 1 arg-6)))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1732-u--fuzzyMatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((3) (let ((e-7 (vector-ref arg-9 3))) (let ((e-8 (vector-ref arg-9 4))) (let ((u--refsB (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() (CoreC-45TTC-45Binder-binderType e-7)))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--11833-1739-u--toFullNamesC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) u--refsB '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--negC-39 (LibrariesC-45DataC-45ListC-45Extra-diffBy (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--11833-1734-u--isApproximationOfC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) arg-7 e-9))) (IdrisC-45REPLC-45FuzzySearch-n--11833-1732-u--fuzzyMatch arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--negC-39 arg-8 e-8)))) eff-0) eta-0))))))))))(else (if (null? arg-7) (let ((u--refsB (IdrisC-45REPLC-45FuzzySearch-n--11833-1730-u--doFind arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-9))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPLC-45FuzzySearch-n--11833-1739-u--toFullNamesC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-1 eta-2))) u--refsB '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (DataC-45List-isNil (LibrariesC-45DataC-45ListC-45Extra-diffBy (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPLC-45FuzzySearch-n--11833-1734-u--isApproximationOfC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-2 eta-3))) arg-8 e-5)))))) eff-0) eta-0))))))) (lambda (eta-0) (vector 1 0)))))))
(define IdrisC-45REPLC-45FuzzySearch-n--11833-1738-u--predicate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-18 (vector-ref arg-8 18))) (case (vector-ref e-18 0) ((7) (lambda (eta-0) (vector 1 0)))(else (IdrisC-45REPLC-45FuzzySearch-n--11833-1732-u--fuzzyMatch arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (let ((e-43 (vector-ref arg-8 2))) e-43)))))))
(define IdrisC-45REPLC-45FuzzySearch-fuzzySearch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (let ((sc0 (IdrisC-45REPLC-45FuzzySearch-n--11833-1735-u--parseExpr arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-5))) (if (null? sc0) csegen-4077 (let ((e-1 (unbox sc0))) (if (null? e-1) csegen-4077 (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((act-1 (CoreC-45Context-branch arg-0 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--curr (let ((e-2 (vector-ref e-6 2))) e-2))) (let ((u--ctxt (let ((e-0 (vector-ref e-6 0))) e-0))) (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Context-allNames u--ctxt) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (PreludeC-45Basics-flip csegen-3911 u--ctxt eta-2)) e-7 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--defs (PreludeC-45Basics-flip csegen-1631 e-8 (lambda (u--md) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe u--md (lambda (u--d) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Context-visibleIn u--curr (let ((e-28 (vector-ref u--d 1))) e-28) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref u--d 9))) e-9)))) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (DataC-45Maybe-isJust (CoreC-45Name-userNameRoot (let ((e-28 (vector-ref u--d 1))) e-28)))) (lambda (_-10650) (box u--d))))))))))) (lambda (eta-2) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-u--resolved_HasNames_GlobalDef u--ctxt eta-3 eta-4))) u--defs '()) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Core-filterM (lambda (eta-3) (IdrisC-45REPLC-45FuzzySearch-n--11833-1738-u--predicate arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-4 e-5 eta-3)) e-9))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (set-box! arg-0 e-6))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPLC-45Common-docsOrSignature arg-4 arg-0 arg-2 (vector 2 ) eta-2 eta-3))) (PreludeC-45TypesC-45List-mapAppend '() csegen-3912 e-7) '()) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-9)))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))))) eff-0) clam-0))))))))))))))
(define IdrisC-45DocC-45String-summarise (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) csegen-2721 (let ((e-1 (unbox e-6))) (let ((act-3 (IdrisC-45DocC-45String-prettyType arg-0 arg-1 (lambda (eta-1) (vector 6 eta-1)) (let ((e-2 (vector-ref e-1 2))) e-2) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) (IdrisC-45PrettyC-45Annotations-prettyRig (let ((e-23 (vector-ref e-1 7))) e-23))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons ((IdrisC-45Pretty-showCategory (lambda (eta-2) (vector 6 eta-2)) e-1) (IdrisC-45DocC-45String-prettyName arg-2)) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hang 0 e-7) '()))))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-n--18943-16300-u--inNS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (let ((e-1 (vector-ref arg-4 2))) (case (vector-ref e-1 0) ((1) (CoreC-45NameC-45Namespace-isParentOf arg-0 e-0))(else 0)))))(else 0))))
(define IdrisC-45DocC-45String-n--18943-16301-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-4 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 0) (let ((e-1 (unbox e-5))) (vector 1 (CoreC-45TT-u--C-47C-61_Eq_Visibility (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-1 9))) e-9)) 0))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45String-getContents (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-allNames (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--allNs (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (IdrisC-45DocC-45String-n--18943-16300-u--inNS arg-3 arg-2 arg-1 arg-0 eta-1)) e-6))) (lambda (eta-1) (let ((act-3 ((CoreC-45Core-filterM (lambda (eta-2) (lambda (eta-3) (IdrisC-45DocC-45String-n--18943-16301-u--visible arg-3 arg-2 arg-1 arg-0 e-5 eta-2 eta-3))) u--allNs) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-3 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-8)))))) (CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45DocC-45String-summarise arg-1 arg-2 eta-3 eta-4))) (DataC-45List-sort csegen-861 e-7) '()) eta-2)))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45DocC-45Brackets-getDocsForBracket (lambda (arg-0) (cond ((equal? arg-0 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Idiom brackets")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Idiom brackets allow for easier application of `Applicative`s\xa;\xa;Adding two `Maybe Int`s can be written using `<*>` and `pure`\xa;\xa;```idris\xa;addMaybe : Maybe Int -> Maybe Int -> Maybe Int\xa;addMaybe x y = pure (+) <*> x <*> y\xa;```\xa;\xa;This can be expressed more concisely as:\xa;\xa;```idris\xa;addMaybe : Maybe Int -> Maybe Int -> Maybe Int\xa;addMaybe x y= [| x + y |]\xa;```" '()))) '())))))) ((equal? arg-0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Name quotes")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Name quotes convert a raw name into a representation of a name.\xa;This allows elaborator scripts to refer to names the user provides.\xa;\xa;```idris\xa;import Language.Reflection\xa;%language ElabReflection\xa;\xa;nameOfMaybe : Name\xa;nameOfMaybe = `{Maybe}\xa;```\xa;\xa;Names can be qualified, however no disambiguation of names occurs when\xa;quoting them, so if you need a disambiguated name consider using\xa;`Language.Reflection.getType`." '()))) '())))))) ((equal? arg-0 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Term quotes")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "These allow an expression to be interpreted as a syntax tree rather than\xa;an actual expression, so it can be processed by an elaborator script\xa;for compile time codegen or meta-programming.\xa;\xa;```idris\xa;import Language.Reflection\xa;%language ElabReflection\xa;\xa;helloWorld : TTImp\xa;helloWorld = `(putStrLn \"hello world\")\xa;```" '()))) '())))))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Declaration quotes")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Declarations quotes allow multiple declaration\xa;(e.g. type declarations or function definitions) to be quoted\xa;\xa;These can then be passed to a elaborator script for compile time\xa;codegen or meta-programming.\xa;\xa;```idris\xa;import Language.Reflection\xa;%language ElabReflection\xa;\xa;myProgram : List Decl\xa;myProgram = `[\xa;    data Bool = False | True\xa;\xa;    main : IO ()\xa;    main = putStrLn \"hello world\"\xa;]\xa;```\xa;\xa;In this example, `main : IO ()` and\xa;`main = putStrLn \"hello world\"` are different `Decl`s" '()))) '())))))))))
(define IdrisC-45DocC-45Keywords-caseof (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Case block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "The `case ... of ...` construct is dependently typed. This means that if you\xa;are branching over a variable, the branches will have refined types where\xa;that variable has been replaced by the appropriate pattern.\xa;For instance, in the following program" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;assoc : (ma, mb, mc : Maybe a) ->\xa;        ((ma <|> mb) <|> mc) === (ma <|> (mb <|> mc))\xa;assoc ma mb mc = case ma of\xa;  Nothing => Refl\xa;  Just a  => Refl\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "the branches typecheck because in their respective types `ma` has been replaced\xa;either by `Nothing` or `Just a` and that was enough for them to compute to\xa;`(mb <|> mc) === (mb <|> mc)` and `Just a === Just a` respectively. Both of\xa;which can be discharged using `Refl`." '()))) '()))))))))))
(define IdrisC-45DocC-45Keywords-datatypes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "(Co)Data types")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Keyword to introduce a (co)inductive type definition.\xa;You can either use a BNF-style definition for simple types" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;data List a = Nil | (::) a (List a)\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "or a GADT-style definition for indexed types" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;data Vect : Nat -> Type -> Type where\xa;  Nil  : Vect 0 a\xa;  (::) : a -> Vect n a -> Vect (S n) a\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Coinductive data is introduced using the same syntax except\xa;that the type of potentially infinite subterms is wrapped in\xa;an `Inf` type constructor." '()))) '()))))))))))))))
(define IdrisC-45DocC-45Keywords-doblock (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Do block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Do blocks are a popular way to structure (among other things) effectful code.\xa;They are desugared using `(>>=)` and `(>>)` respectively depending on whether\xa;the result of a subcomputation is bound. Let bindings and local definitions\xa;can be used (omitting `in` because the layout is already controlled by the\xa;`do`-based indentation) and desugared to the corresponding `let` constructs.\xa;\xa;For instance the following block\xa;```idris\xa;  do x <- e1\xa;     e2\xa;     let y = e3\xa;     e4\xa;```\xa;is equivalent to the expression `e1 >>= \\ x => e2 >> let y = e3 in e4`." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "By default `(>>=)` and `(>>)` are then selected using the usual type\xa;directed disambiguation mechanisms. Users who want to bypass this implicit\xa;disambiguation step can use a qualified `do`: by writing `M.do` they ensure\xa;Idris will explicitly use `M.(>>=)` and `M.(>>)` during elaboration." '()))) '()))))))))
(define IdrisC-45DocC-45Keywords-failblock (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Fail block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Fail blocks let users check that some code parses but is rejected during elaboration.\xa;In the following example, we make sure that Idris rejects a proof that the character\xa;'a' is equal to 'b' by throwing an error when unifying them." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;failing \"When unifying\"\xa;  noteq : 'a' === 'b'\xa;  noteq = Refl\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "If the (optional) string attached to a failing block does not appear in the error raised,\xa;or if no error is raised then the failing block is itself failing and thus leads to an error.\xa;This lets users document the kind of error the block is meant to document." '()))) '()))))))))))
(define IdrisC-45DocC-45Keywords-fixity (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Fixity declarations")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Operators can be assigned a priority level and associativity. During parsing\xa;operators with a higher priority will collect their arguments first and the\xa;declared associativity will inform how subterms are grouped.\xa;\xa;For instance the expression `a + b * c * d + e` is parsed as\xa;`(a + ((b * c) * d)) + e` because:\xa;  `(+)` is at level 8 and associates to the left\xa;  `(*)` is at level 9 and associates to the left" '()))) '()))))))
(define IdrisC-45DocC-45Keywords-forallquantifier (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Forall quantifier")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "`forall` quantification is syntactic sugar for implicit runtime-irrelevant\xa;universal quantification. That is to say that `forall x, y, z. ...`\xa;desugars to `{0 x, y, z : _} -> ...`." '()))) '()))))))
(define IdrisC-45DocC-45Keywords-ifthenelse (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Boolean conditional")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "The `if ... then ... else ...` construct is dependently typed. This means\xa;that if you are branching over a variable, the branches will have refined\xa;types where that variable has been replaced by either `True` or `False`.\xa;For instance, in the following incomplete program" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;notInvolutive : (b : Bool) -> not (not b) === b\xa;notInvolutive b = if b then ?holeTrue else ?holeFalse\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "the two holes have respective types `True === True` and `False === False`." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "If you do not need the added power granted by dependently typed branches,\xa;consider using the simpler `ifThenElse` function defined in `Prelude`." '()))) '())))))))))))))
(define IdrisC-45DocC-45Keywords-implicitarg (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Implicit arguments")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Implicit arguments can be solved using various strategies. By default\xa;they will be filled in using unification but programmers can use various\xa;keywords to change that." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `auto` will use the same mechanism as interface resolution to build the\xa;  argument. Users can add new hints to the database by adding a `%hint`\xa;  pragma to their declarations. By default all data constructors are hints.\xa;  For instance, the following function\xa;  ```idris\xa;  f : (n : Nat) -> {auto _ : n === Z} -> Nat\xa;  f n = n\xa;  ```\xa;  will only accept arguments that can be automatically proven to be equal\xa;  to zero." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `default` takes a value of the appropriate type and if no argument is\xa;  explicitly passed at a call site, will use that default value.\xa;  For instance, the following function\xa;  ```idris\xa;  f : {default 0 n : Nat} -> Nat\xa;  f = n\xa;  ```\xa;  will return `0` if no argument is passed and its argument otherwise." '()))) '()))))))))))
(define IdrisC-45DocC-45Keywords-importing (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Importing")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Importing a module brings the definition it exports into scope.\xa;Combined with `public` it also re-exports these definitions." '()))) '()))))))
(define IdrisC-45DocC-45Keywords-impossibility (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Impossible branches")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "The `impossible` keyword can be used to dismiss a clause involving an\xa;argument with an uninhabited type. For instance an assumption stating\xa;that 0 is equal to 1:" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;zeroIsNotOne : 0 === 1 -> Void\xa;zeroIsNotOne eq impossible\xa;```" '()))) '()))))))))
(define IdrisC-45DocC-45Keywords-interfacemechanism (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Interfaces")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Interfaces offer ad-hoc polymorphism. Programmers can declare new\xa;interfaces offering a set of methods (some of which may have default\xa;implementations in terms of the interface's other methods) and write\xa;programs generic over all types implementing the interface." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "In the following example we define a `Fail` interface that allows\xa;users to abort in case a computation is doomed to fail. We implement\xa;the `whenJust` construct using this interface and show a couple of\xa;implementations:" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;interface Fail (0 a : Type) where\xa;  fail : a\xa;\xa;whenJust : Fail ret => Maybe a -> (a -> ret) -> ret\xa;whenJust (Just v) k = k v\xa;whenJust Nothing  _ = fail\xa;\xa;implementation Fail Bool where\xa;  fail = False\xa;\xa;Fail (Maybe a) where\xa;  fail = Nothing\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "As you can see the `implementation` keyword is optional. Note that the\xa;proof search machinery powering interface resolution works best if your\xa;implementations are for specific type constructors (here `Bool` and `Maybe`)." '()))) '()))))))))))))
(define IdrisC-45DocC-45Keywords-letbinding (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Let binding")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "The `let` keyword is used for both local definitions and let bindings.\xa;Local definitions are just like top-level definitions except that they are\xa;defined in whatever extended context is available at the definition site.\xa;\xa;Let bindings can be used to bind the result of intermediate computations.\xa;They do not necessitate but can have a type annotation. They will not unfold\xa;in the type of subsequent terms so may not be appropriate in all cases.\xa;\xa;For instance, in the following definition the let-bound value `square`\xa;ensures that `n * n` is only computed once:\xa;```idris\xa;power4 : Nat -> Nat\xa;power4 n = let square := n * n in square * square\xa;```\xa;\xa;It is also possible to pattern-match on the result of the intermediate\xa;computation. The main pattern is written in place of the variable and\xa;an alternative list of clauses can be given using the `|` separator.\xa;For instance, we can shortcut the `square * square` computation in case\xa;the returned value is 0 like so:\xa;```idris\xa;power4 : Nat -> Nat\xa;power4 n = let square@(S _) := n * n\xa;                 | Z => Z\xa;           in square * square\xa;```" '()))) '()))))))
(define IdrisC-45DocC-45Keywords-mutualblock (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Mutual block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Mutual blocks allow users to have inter-dependent declarations. For instance\xa;we can define the `odd` and `even` checks in terms of each other like so:\xa;```idris\xa;mutual\xa;\xa;  odd : Nat -> Bool\xa;  odd Z = False\xa;  odd (S n) = even n\xa;\xa;  even : Nat -> Bool\xa;  even Z = True\xa;  even (S n) = odd n\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Internally this is implemented in terms of the more fundamental\xa;forward-declaration feature: all the mutual declarations come first and then\xa;their definitions. In other words, the earlier example using a `mutual` block\xa;is equivalent to the following\xa;```idris\xa;odd : Nat -> Bool\xa;even : Nat -> Bool\xa;\xa;odd Z = False\xa;odd (S n) = even n\xa;\xa;even Z = True\xa;even (S n) = odd n\xa;```" '()))) '()))))))))
(define IdrisC-45DocC-45Keywords-namespaceblock (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Namespace block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Attempting to declare two functions with the same name in a given module\xa;will lead to a scope error. Putting each one in a different `namespace`\xa;block can help bypass this issue by ensuring that they are assigned distinct\xa;fully qualified names. For instance\xa;```idris\xa;module M\xa;\xa;namespace Zero\xa;  val : Nat\xa;  val = 0\xa;\xa;namespace One\xa;  val : Nat\xa;  val = 1\xa;```\xa;declares a module `M` containing two values `M.Zero.val` and `M.One.val`.\xa;You can use `export` or `public export` to control whether a function\xa;declared in a namespace is available outside of it." '()))) '()))))))
(define IdrisC-45DocC-45Keywords-parametersblock (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Parameters block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Definitions that share a common parameter can be grouped in a parameters\xa;block to avoid having to explicitly pass it around. Outside of the block\xa;all the definitions will take additional arguments corresponding to the\xa;parameters. For instance the functions in the following block all use a\xa;default value `dflt`" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;parameters (dflt : a)\xa;\xa;  head : List a -> a\xa;  head (x :: xs) = x\xa;  head _ = dflt\xa;\xa;  last : List a -> a\xa;  last [x] = x\xa;  last (_ :: xs) = last xs\xa;  last _ = dflt\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "and their respective types outside of the parameters block are\xa;`head : a -> List a -> a` and `last : a -> List a -> a`." '()))) '()))))))))))
(define IdrisC-45DocC-45Keywords-recordtypes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Record types")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Records are data types with a single constructor. Each of the constructor's\xa;argument is given a name and the corresponding projections and record update\xa;functions are automatically generated.\xa;For instance, we can define a type of pairs of natural numbers" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "```idris\xa;record Nat2 where\xa;  constructor MkNat2\xa;  fst : Nat\xa;  snd : Nat\xa;```" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "and we can then immediately use all of `fst`, `snd`, `{ fst := ?h1 }`,\xa;or `{ snd $= ?h2 }` to respectively project values out of a record,\xa;replace values, or update them." '()))) '()))))))))))
(define IdrisC-45DocC-45Keywords-rewriteeq (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Rewrite")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Users can deploy an equality proof to adjust a type by replacing the value\xa;on the left hand side of the equality by that on the right hand side.\xa;For instance, if we know that the types `a` and `b` are propositionally\xa;equal, we can return a value of type `a` as if it had type `b`:\xa;```idris\xa;transport : a === b -> a -> b\xa;transport eq x = rewrite sym eq in x\xa;```" '()))) '()))))))
(define IdrisC-45DocC-45Keywords-totality (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3156 (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Definitions can be individually declared `total`, `covering`, or `partial`.\xa;It is also possible to set the default totality flag for definitions in a\xa;module by using the `%default` pragma." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `total` offers the highest guarantees. Definitions using this flag are\xa;  only accepted if:\xa;    1. their patterns are covering all possible cases;\xa;    2. they are either obviously terminating (for recursive functions)\xa;       or productive (for corecursive functions);\xa;    3. all the auxiliary functions used are total themselves." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `covering` is the default level of guarantees. It only enforces that\xa;  pattern matchings are exhaustive." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `partial` is the absence of any totality requirement: as long as the\xa;  definition typechecks, it is accepted. It is possible to call a partial\xa;  function from a total one by using the `assert_total` escape hatch." '()))) '()))))))))))))
(define IdrisC-45DocC-45Keywords-unusedKeyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Currently unused keyword"))
(define IdrisC-45DocC-45Keywords-visibility (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3154 (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Programmers can decide which parts of a module they expose to the outside\xa;world." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `public export` ensures that both the declaration and the definition\xa;   are accessible from the outside of the module. This means the function\xa;   will be able to reduce in types." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `export` means that only the declaration will be made available to the\xa;  outside world. Users will be able to call the function but its internals\xa;  will not be exposed because it will not reduce in types." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "* `private` means that neither the declaration nor the definition will be\xa;  exported. This is the default and is the ideal setting for auxiliary\xa;  definitions." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "If a forward-declaration for a definition exists, they cannot declare\xa;incompatible visibility modifiers - they either have to match up or at most\xa;one of the two can declare visibility." '()))) '()))))))))))))))
(define IdrisC-45DocC-45Keywords-whereblock (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Where block")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "NB:")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "`where` is used as a layout keyword in `data`, `record`, `interface`,\xa;and `implementation` blocks. This documentation snippet focuses instead\xa;on the `where` blocks introducing local definitions." '())))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "A `where` block allows the introduction of local auxiliary definitions\xa;that are parametrised over the variables bound on the left hand side of\xa;the parent clause (cf. the doc for `parameters`)." '()))) '()))))))))
(define IdrisC-45DocC-45Keywords-withabstraction (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "With abstraction")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "We often need to match on the result of an intermediate computation.\xa;When this intermediate computation additionally appears in the type of the\xa;function being defined, the `with` construct allows us to capture these\xa;occurences so that the observations made in the patterns will be reflected\xa;in the type.\xa;If we additionally need to remember that the link between the patterns and\xa;the intermediate computation we can use the `proof` keyword to retain an\xa;equality proof." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "In the following example we want to implement a `filter` function that not\xa;only returns values that satisfy the input predicate but also proofs that\xa;they do. The `with (p x)` construct introduces a value of type `Bool`\xa;obtained by testing `x` with `p`. The additional `proof eq` part records in\xa;`eq` an equality proof stating that the `True`/`False` patterns in the further\xa;clauses are equal to the result of evaluating `p x`. This is the reason why\xa;we can successfully form `(x ** eq)` in the `True` branch.\xa;```idris\xa;filter : (p : a -> Bool) -> List a -> List (x : a ** p x === True)\xa;filter p [] = []\xa;filter p (x :: xs) with (p x) proof eq\xa;  _ | True = (x ** eq) :: filter p xs\xa;  _ | False = filter p xs\xa;```" '()))) '()))))))))
(define IdrisC-45DocC-45Keywords-keywordsDoc (cons IdrisC-45DocC-45Keywords-datatypes (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Keyword to start a module definition") (cons IdrisC-45DocC-45Keywords-whereblock (cons IdrisC-45DocC-45Keywords-letbinding (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Used by `let` and `rewrite`. See either of them for more details.") (cons IdrisC-45DocC-45Keywords-doblock (cons IdrisC-45DocC-45Keywords-recordtypes (cons IdrisC-45DocC-45Keywords-implicitarg (cons IdrisC-45DocC-45Keywords-implicitarg (cons IdrisC-45DocC-45Keywords-unusedKeyword (cons IdrisC-45DocC-45Keywords-failblock (cons IdrisC-45DocC-45Keywords-mutualblock (cons IdrisC-45DocC-45Keywords-namespaceblock (cons IdrisC-45DocC-45Keywords-parametersblock (cons IdrisC-45DocC-45Keywords-withabstraction (cons IdrisC-45DocC-45Keywords-withabstraction (cons IdrisC-45DocC-45Keywords-impossibility (cons IdrisC-45DocC-45Keywords-caseof (cons IdrisC-45DocC-45Keywords-caseof (cons IdrisC-45DocC-45Keywords-ifthenelse (cons IdrisC-45DocC-45Keywords-ifthenelse (cons IdrisC-45DocC-45Keywords-ifthenelse (cons IdrisC-45DocC-45Keywords-forallquantifier (cons IdrisC-45DocC-45Keywords-rewriteeq (cons csegen-2720 (cons IdrisC-45DocC-45Keywords-interfacemechanism (cons IdrisC-45DocC-45Keywords-interfacemechanism (cons IdrisC-45DocC-45Keywords-unusedKeyword (cons IdrisC-45DocC-45Keywords-importing (cons IdrisC-45DocC-45Keywords-visibility (cons IdrisC-45DocC-45Keywords-visibility (cons IdrisC-45DocC-45Keywords-visibility (cons IdrisC-45DocC-45Keywords-fixity (cons IdrisC-45DocC-45Keywords-fixity (cons IdrisC-45DocC-45Keywords-fixity (cons IdrisC-45DocC-45Keywords-fixity (cons IdrisC-45DocC-45Keywords-totality (cons IdrisC-45DocC-45Keywords-totality (cons IdrisC-45DocC-45Keywords-totality '()))))))))))))))))))))))))))))))))))))))))
(define LibrariesC-45DataC-45ListC-45QuantifiersC-45Extra-lookup (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-10 (car arg-5))) (let ((e-11 (cdr arg-5))) (let ((u--xs (cons e-2 e-3))) (let ((sc2 ((arg-3 (DataC-45List-head u--xs)) arg-4))) (case (vector-ref sc2 0) ((1) (LibrariesC-45DataC-45ListC-45QuantifiersC-45Extra-lookup e-3 arg-3 arg-4 e-11)) (else (box e-10))))))))))))
(define IdrisC-45DocC-45Keywords-getDocsForKeyword (lambda (arg-0) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 arg-0))) (lambda () (lambda (eta-0) eta-0)) (LibrariesC-45DataC-45ListC-45QuantifiersC-45Extra-lookup ParserC-45LexerC-45Source-keywords csegen-511 arg-0 IdrisC-45DocC-45Keywords-keywordsDoc))))
(define CoreC-45TTC-45Traversals-n--5323-7391-u--gos (lambda (arg-2 arg-3 arg-5 arg-6) (if (null? arg-6) arg-5 (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (CoreC-45TTC-45Traversals-n--5323-7391-u--gos arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 arg-5 e-2) e-3))))))
(define CoreC-45TTC-45Traversals-n--5323-7390-u--go (lambda (arg-2 arg-3 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) arg-5) ((1) arg-5) ((2) (let ((e-14 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5323-7391-u--gos arg-2 arg-3 arg-5 e-14))) ((3) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 (let ((e-1 (car arg-2))) ((e-1 arg-5) (CoreC-45TTC-45Binder-u--foldMap_Foldable_Binder arg-2 (lambda (eta-0) (CoreC-45TTC-45Traversals-onConstants arg-2 arg-3 eta-0)) e-18))) e-19)))) ((4) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 arg-5 e-22) e-23)))) ((5) (let ((e-27 (vector-ref arg-6 3))) (let ((e-28 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 arg-5 e-27) e-28)))) ((6) (let ((e-32 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 arg-5 e-32))) ((7) (let ((e-36 (vector-ref arg-6 3))) (let ((e-37 (vector-ref arg-6 4))) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 arg-5 e-36) e-37)))) ((8) (let ((e-41 (vector-ref arg-6 3))) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 arg-5 e-41))) ((9) (let ((e-44 (vector-ref arg-6 2))) (let ((e-1 (car arg-2))) ((e-1 arg-5) (arg-3 e-44))))) ((10) arg-5) (else arg-5))))
(define CoreC-45TTC-45Traversals-onConstants (lambda (arg-2 arg-3 ext-0) (CoreC-45TTC-45Traversals-n--5323-7390-u--go arg-2 arg-3 (let ((e-2 (cdr arg-2))) e-2) ext-0)))
(define CoreC-45TTC-45Traversals-allConstants (lambda (ext-0) (CoreC-45TTC-45Traversals-onConstants (cons csegen-3785 (LibrariesC-45DataC-45SortedSet-empty csegen-3796)) (lambda (eta-0) (LibrariesC-45DataC-45SortedSet-singleton csegen-3796 eta-0)) ext-0)))
(define IdrisC-45DocC-45String-getHintsForPrimitive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "doc.data" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Looking at " (cons (CoreC-45TTC-45Primitive-u--show_Show_Constant arg-2) '())))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (IdrisC-45DocC-45String-getImplDocs arg-0 arg-1 (lambda (u--ty) (let ((u--nms (CoreC-45TTC-45Traversals-allConstants u--ty))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "doc.data" 10 (lambda () (DataC-45String-fastUnlines (cons (string-append "Candidate: " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() u--ty)) (cons (string-append "Containing constants: " (LibrariesC-45DataC-45SortedSet-u--show_Show_C-40SortedSetC-32C-36kC-41 csegen-1860 u--nms)) '())))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (LibrariesC-45DataC-45SortedSet-contains arg-2 u--nms)))))))) ext-0))))))
(define CoreC-45TTC-45Primitive-u--prettyPrec_Pretty_IdrisSyntax_Constant (lambda (arg-0 arg-1) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant arg-1)))
(define IdrisC-45DocC-45String-n--12693-10590-u--primTyDoc (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-3 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of bounded signed integers (backend dependent size)")) ((equal? arg-3 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 8 bits signed integers")) ((equal? arg-3 2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 16 bits signed integers")) ((equal? arg-3 3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 32 bits signed integers")) ((equal? arg-3 4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 64 bits signed integers")) ((equal? arg-3 5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of unbounded signed integers")) ((equal? arg-3 6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 8 bits unsigned integers")) ((equal? arg-3 7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 16 bits unsigned integers")) ((equal? arg-3 8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 32 bits unsigned integers")) ((equal? arg-3 9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of 64 bits unsigned integers")) ((equal? arg-3 10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of strings")) ((equal? arg-3 11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of characters")) ((equal? arg-3 12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of double-precision floating-points")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive type of tokens for IO actions")))))
(define IdrisC-45DocC-45String-n--12693-10589-u--primDoc (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive signed int value (backend-dependent precision)")) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive signed 8 bits value")) ((2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive signed 16 bits value")) ((3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive signed 32 bits value")) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive signed 64 bits value")) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive unsigned int value (backend-dependent precision)")) ((6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive unsigned 8 bits value")) ((7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive unsigned 16 bits value")) ((8) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive unsigned 32 bits value")) ((9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive unsigned 64 bits value")) ((10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive string value")) ((11) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive character value")) ((12) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive double value")) ((13) (let ((e-13 (vector-ref arg-3 1))) (IdrisC-45DocC-45String-n--12693-10590-u--primTyDoc arg-0 arg-1 arg-2 e-13))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Primitive token for IO actions")))))
(define IdrisC-45DocC-45String-getDocsForPrimitive (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (TTImpC-45ElabC-45Prim-checkPrim (vector 2 ) arg-2))) (let ((e-3 (cdr sc0))) (let ((act-1 (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--typeString (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy (cons (lambda (arg-11067) (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (CoreC-45TTC-45Primitive-u--prettyPrec_Pretty_IdrisSyntax_Constant arg-11073 arg-11076)))) (lambda (eta-0) (vector 6 eta-0)) arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-0) (vector 6 eta-0)) e-5))))) (lambda (eta-0) (let ((act-2 (IdrisC-45DocC-45String-getHintsForPrimitive arg-0 arg-1 arg-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons u--typeString (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (IdrisC-45DocC-45String-n--12693-10589-u--primDoc arg-2 arg-1 arg-0 arg-2)) e-6))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))))
(define IdrisC-45DocC-45String-getDocsForPTerm (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (lambda (eta-0) (IdrisC-45DocC-45String-getDocsForName arg-0 arg-1 arg-2 e-1 e-2 csegen-3176 eta-0))))) ((15) (let ((e-5 (vector-ref arg-3 2))) (lambda (eta-0) (IdrisC-45DocC-45String-getDocsForPrimitive arg-1 arg-2 e-5 eta-0)))) ((22) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Type : Type") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "The type of all types is Type. The type of Type is Type.")) '())))))) ((33) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "String Literal") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to a fromString call")) '())))))) ((38) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "List Literal") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to (::) and Nil")) '())))))) ((39) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "SnocList Literal") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to (:<) and Lin")) '())))))) ((40) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Pair Literal") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to MkPair or Pair")) '())))))) ((41) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Dependant Pair Literal") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to MkDPair or DPair")) '())))))) ((42) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Unit Literal") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Desugars to MkUnit or Unit")) '())))))) ((19) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Unquotes")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Unquotes allows us to use TTImp expressions inside a quoted expression.\xa;This is useful when we want to add some computed TTImp while building up\xa;complex expressions.\xa;\xa;```idris\xa;module Quote\xa;\xa;import Language.Reflection\xa;\xa;foo : TTImp -> TTImp\xa;foo expr = `(either ~(expr) x y)\xa;```" '()))) '())))))))) ((11) (let ((e-37 (vector-ref arg-3 2))) (lambda (clam-0) (cond ((equal? e-37 1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Laziness annotation")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Indicates that the values of the type should not be computed until absolutely\xa;necessary.\xa;\xa;Also causes the compiler to automatically insert Delay/Force calls\xa;respectively wherever a computation can be postponed and where a value is\xa;necessary. This can be disabled using the `%auto_lazy off` pragma." '()))) '()))))))) ((equal? e-37 0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Codata (infinite data type) annotation")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Indicates that the data type may be potentially infinite, e.g. Data.Stream.\xa;If the data type IS infinite, it has to be productive, i.e. there has to be at\xa;least one non-empty, finite prefix of the type.\xa;\xa;Also causes the compiler to automatically insert Delay/Force calls\xa;respectively wherever the next part of a potentially infinite structure\xa;occurs, and where we need to look under the next finite prefix of the\xa;structure. This can be disabled using the `%auto_lazy off` pragma." '()))) '())))))))(else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Docs not implemented for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Syntax-u--show_Show_PTerm arg-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "yet"))))))))) ((12) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3248 (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "For `Lazy` types: postpones the computation until a `Force` requires its\xa;                  result.\xa;For `Inf` types: does not try to deconstruct the next part of the codata\xa;                 (potentially infinite data structure).\xa;\xa;Automatically inserted by the compiler unless `%auto_lazy off` is set." '()))) '())))))))) ((13) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons csegen-3248 (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "For `Lazy` types: requires the result of a postponed calculation to be\xa;                  evaluated (see `Delay`).\xa;For `Inf` types: deconstructs the next part of the codata (potentially\xa;                 infinite data structure).\xa;\xa;Automatically inserted by the compiler unless `%auto_lazy off` is set." '()))) '()))))))))(else (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Docs not implemented for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Syntax-u--show_Show_PTerm arg-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "yet")))))))))
(define IdrisC-45DocC-45Keywords-asPattern (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "An as pattern `@` can be used to both pattern match on a variable\xa;and retain a name for the compound expression. E.g. instead of writing\xa;```\xa;last : List a -> Maybe a\xa;last [] = Nothing\xa;last [x] = Just x\xa;last (x :: y :: ys) = last (y :: ys)\xa;```\xa;\xa;where, in the last clasue, we take `y :: ys` apart on the left hand side\xa;before reconstructing it on the right hand side, we can write:\xa;\xa;```\xa;last (x :: xs@(_ :: _)) = last xs\xa;```" '()))))
(define IdrisC-45DocC-45Keywords-bang (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Directive to lift the following effectful expression to the nearest enclosing\xa;(potentially implicit) `do` block. In the following definition for instance\xa;\xa;```\xa;anyM : Monad m => (a -> m Bool) -> List a -> m (Maybe a)\xa;anyM p [] = pure Nothing\xa;anyM p (x :: xs) = if !(p x) then pure (Just x) else anyM p xs\xa;```\xa;\xa;the expression `if !(p x) then pure (Just x) else anyM p xs` is equivalent to\xa;the following `do` block:\xa;\xa;```\xa;do b <- p x\xa;   if b then pure (Just x) else anyM p xs\xa;```" '()))))
(define IdrisC-45DocC-45Keywords-lambdaAbstraction (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "An anonymous function is introduced using a lambda `\\` and binds a\xa;comma-separated list of either variable names or irrefutable patterns\xa;before returning a right hand side using `=>`.\xa;\xa;For instance we can implement `transport` like so:\xa;```\xa;transport : a === b -> a -> b\xa;transport = \\ Refl, v => v\xa;```" '()))))
(define IdrisC-45DocC-45Keywords-fatArrow (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Used for an interface constraint in a type signature or as part of a\xa;lambda abstraction or case block.\xa;\xa;1. Interface constraint" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "`a => b` corresponds to `{auto _ : a} -> b`" '())))) (cons csegen-2720 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "2. Lambda abstraction" '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 IdrisC-45DocC-45Keywords-lambdaAbstraction) (cons csegen-2720 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "3. Case block" '()))) '())))))))))
(define IdrisC-45DocC-45Keywords-rangeSyntax (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "The ellipsis `..` can be used to generate lists or streams of values for\xa;types that implement the `Range` interface.\xa;\xa;Lists can be generated using an initial value, an (optional) second value\xa;and a final one. For instance, we can generate lists of integers like so:\xa;  1. `[1..5]`   evaluates to `[1,2,3,4,5]`\xa;  2. `[1,3..5]` evaluates to `[1, 3, 5]`\xa;\xa;Streams can be generated using an initial value and an optional second value.\xa;For instance the following streams of integers:\xa;  1. `[1..]`   for all positive integers\xa;  2. `[1,3..]` for all positive odds" '()))))
(define IdrisC-45DocC-45Keywords-recordUpdate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Record updates")) (cons csegen-2720 (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "If a record `r` has a field `n` of type `Nat`, it is possible to either\xa;\xa;1. overwrite the current value with `0` by using the assignment symbol `:=`\xa;   like so: `{ n := 0 } r`\xa;\xa;2. modify the current value by adding `2` by using the modification symbol `$=`\xa;   like so: `{ n $= (2 +) } r`.\xa;\xa;Multiple updates can be combined in a single update by grouping a comma-separated\xa;list of assignments and/or modifications like so: `{ a := Z, b $= S } r`." '()))) '()))))))
(define IdrisC-45DocC-45Keywords-tupleSyntax (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Used to build dependent pairs together with parentheses"))
(define IdrisC-45DocC-45Keywords-unusedSymbol (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Currently unused symbol"))
(define IdrisC-45DocC-45Keywords-symbolsDoc (cons csegen-2720 (cons csegen-2720 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "An implicit value either solved by unification or bound\xa;as a pattern or type variable." '()))) (cons csegen-2720 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Start of a pragma") (cons IdrisC-45DocC-45Keywords-lambdaAbstraction (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Type declaration, for instance `id : a -> a`\xa;declares a new toplevel definition `id` of type `a -> a`." '()))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Definition or equality type") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Let binding or record assignment") (cons IdrisC-45DocC-45Keywords-recordUpdate (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Additional patterns showing up in a `with` clause") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Document string attached to the following definition") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Bind in a do block") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Function type") (cons IdrisC-45DocC-45Keywords-fatArrow (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "An implicit value solved by unification.") (cons IdrisC-45DocC-45Keywords-bang (cons IdrisC-45DocC-45Keywords-unusedSymbol (cons IdrisC-45DocC-45Keywords-tupleSyntax (cons IdrisC-45DocC-45Keywords-rangeSyntax (cons csegen-2720 (cons IdrisC-45DocC-45Keywords-asPattern '())))))))))))))))))))))))
(define IdrisC-45DocC-45Keywords-getDocsForSymbol (lambda (arg-0) (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 5 )) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 arg-0))) (lambda () (lambda (eta-0) eta-0)) (LibrariesC-45DataC-45ListC-45QuantifiersC-45Extra-lookup (PreludeC-45TypesC-45List-tailRecAppend ParserC-45LexerC-45Source-symbols ParserC-45LexerC-45Source-reservedInfixSymbols) csegen-511 arg-0 IdrisC-45DocC-45Keywords-symbolsDoc))))
(define IdrisC-45DocC-45String-getDocs (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((3) (let ((e-0 (vector-ref arg-3 1))) (IdrisC-45DocC-45String-getDocsForPTerm arg-0 arg-1 arg-2 e-0))) ((1) (let ((e-1 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45DocC-45Keywords-getDocsForSymbol e-1))))) ((2) (let ((e-2 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45DocC-45Brackets-getDocsForBracket e-2))))) ((0) (let ((e-3 (vector-ref arg-3 1))) (lambda (eta-0) (vector 1 (IdrisC-45DocC-45Keywords-getDocsForKeyword e-3))))) (else (let ((e-4 (vector-ref arg-3 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((sc2 (LibrariesC-45DataC-45SortedMap-lookup e-4 (let ((e-2 (vector-ref e-5 2))) e-2)))) (if (null? sc2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 58 CoreC-45FC-replFC e-4) clam-0) (let ((e-1 (unbox sc2))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-1)))))))) eff-0) eta-0)))))))))))
(define IdrisC-45SyntaxC-45Views-n--8212-9304-u--go (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((7) (let ((e-1 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (lambda (eta-0) ((IdrisC-45SyntaxC-45Views-n--8212-9304-u--go arg-1 arg-2 e-2) (cons (vector 0 e-1 e-3) eta-0))))))) ((10) (let ((e-5 (vector-ref arg-3 1))) (let ((e-6 (vector-ref arg-3 2))) (let ((e-7 (vector-ref arg-3 3))) (lambda (eta-0) ((IdrisC-45SyntaxC-45Views-n--8212-9304-u--go arg-1 arg-2 e-6) (cons (vector 1 e-5 e-7) eta-0))))))) ((9) (let ((e-9 (vector-ref arg-3 1))) (let ((e-10 (vector-ref arg-3 2))) (let ((e-11 (vector-ref arg-3 3))) (let ((e-12 (vector-ref arg-3 4))) (lambda (eta-0) ((IdrisC-45SyntaxC-45Views-n--8212-9304-u--go arg-1 arg-2 e-10) (cons (vector 2 e-9 e-11 e-12) eta-0)))))))) ((32) (let ((e-15 (vector-ref arg-3 2))) (IdrisC-45SyntaxC-45Views-n--8212-9304-u--go arg-1 arg-2 e-15))) ((27) (let ((e-17 (vector-ref arg-3 1))) (let ((e-18 (vector-ref arg-3 2))) (let ((e-19 (vector-ref arg-3 3))) (let ((e-20 (vector-ref arg-3 4))) (let ((e-21 (vector-ref arg-3 5))) (lambda (eta-0) (cons (vector 0 e-18 e-19) (cons (vector 0 e-17 e-20) (cons (vector 0 e-17 e-21) eta-0)))))))))) ((31) (let ((e-23 (vector-ref arg-3 1))) (let ((e-24 (vector-ref arg-3 2))) (let ((e-25 (vector-ref arg-3 3))) (lambda (eta-0) (cons (vector 0 e-23 (arg-2 IdrisC-45SyntaxC-45Builtin-eqName)) (cons (vector 0 e-23 e-24) (cons (vector 0 e-23 e-25) eta-0)))))))) ((40) (let ((e-27 (vector-ref arg-3 1))) (let ((e-28 (vector-ref arg-3 2))) (let ((e-29 (vector-ref arg-3 3))) (lambda (eta-0) (cons (vector 0 e-27 (arg-2 IdrisC-45SyntaxC-45Builtin-pairname)) (cons (vector 0 e-27 e-28) (cons (vector 0 e-27 e-29) eta-0)))))))) ((41) (let ((e-32 (vector-ref arg-3 2))) (let ((e-33 (vector-ref arg-3 3))) (let ((e-34 (vector-ref arg-3 4))) (let ((e-35 (vector-ref arg-3 5))) (lambda (eta-0) (cons (vector 0 e-32 (arg-2 IdrisC-45SyntaxC-45Builtin-dpairname)) (cons (vector 0 e-32 e-33) (cons (vector 0 e-32 e-34) (cons (vector 0 e-32 e-35) eta-0))))))))))(else (lambda (__infixTupleSection-0) (cons arg-3 __infixTupleSection-0))))))
(define IdrisC-45SyntaxC-45Views-getFnArgs (lambda (arg-1 arg-2) ((IdrisC-45SyntaxC-45Views-n--8212-9304-u--go arg-2 arg-1 arg-2) '())))
(define IdrisC-45SyntaxC-45Views-unArg (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 2))) e-2)) ((1) (let ((e-5 (vector-ref arg-1 2))) e-5)) (else (let ((e-9 (vector-ref arg-1 3))) e-9)))))
(define IdrisC-45SyntaxC-45Views-n--8467-9555-u--go (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((32) (let ((e-2 (vector-ref arg-2 2))) (IdrisC-45SyntaxC-45Views-n--8467-9555-u--go arg-1 e-2))) ((2) (let ((e-4 (vector-ref arg-2 1))) (let ((e-5 (vector-ref arg-2 2))) (let ((e-6 (vector-ref arg-2 3))) (let ((e-7 (vector-ref arg-2 4))) (let ((e-8 (vector-ref arg-2 5))) (let ((e-9 (vector-ref arg-2 6))) (lambda (eta-0) ((IdrisC-45SyntaxC-45Views-n--8467-9555-u--go arg-1 e-9) (cons (cons e-7 (vector 0 e-4 e-5 e-6 e-8)) eta-0))))))))))(else (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 arg-2))))))
(define IdrisC-45SyntaxC-45Views-underLams (lambda (arg-1) ((IdrisC-45SyntaxC-45Views-n--8467-9555-u--go arg-1 arg-1) '())))
(define CoreC-45TT-u--showPrec_Show_RawKindedName (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-1 0))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (PreludeC-45Show-showCon arg-0 "MkKindedName" (string-append (PreludeC-45Show-showArg (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-873 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-873 u--d u--x)))) e-0) (string-append (PreludeC-45Show-showArg (csegen-489) e-1) (PreludeC-45Show-showArg (csegen-489) e-2)))))))))
(define CoreC-45TT-u--show_Show_RawKindedName (lambda (arg-0) (CoreC-45TT-u--showPrec_Show_RawKindedName (vector 0 ) arg-0)))
(define IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32displayImpl-10275 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24) (if (null? arg-24) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-5 "doc.implementation" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Invalid name " (cons (CoreC-45TT-u--show_Show_RawKindedName arg-23) '())))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 '()))))) (let ((e-2 (car arg-24))) (let ((e-3 (cdr arg-24))) (case (vector-ref e-3 0) ((4) (let ((e-5 (vector-ref e-3 2))) (let ((u--nm (vector 0 e-2 e-5))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExactI (let ((e-1 (vector-ref arg-23 1))) e-1) (let ((e-0 (vector-ref arg-17 0))) e-0)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-2 (CoreC-45ContextC-45Log-log arg-5 "doc.implementation" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Couldn't find " (cons (CoreC-45Name-u--show_Show_RawName u--nm) '())))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (vector 1 '())))) (let ((e-1 (unbox e-6))) (if (null? e-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-5 "doc.implementation" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Couldn't find " (cons (CoreC-45Name-u--show_Show_RawName u--nm) '())))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (vector 1 '())))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((act-2 ((IdrisC-45DocC-45Display-displayPats arg-5 arg-4 1 arg-17 (cons u--nm (cons e-8 e-7))) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box e-9))))) eff-0) clam-0))))))))))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-5 "doc.implementation" 10 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Invalid name " (cons (CoreC-45TT-u--show_Show_RawKindedName arg-23) '())))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (vector 1 '()))))))))))))
(define IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32displayImpl-10187 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (lambda (clam-0) (if (null? arg-21) (vector 1 '()) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 (CoreC-45ContextC-45Log-log arg-5 "doc.implementation" 20 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Got name " (cons (CoreC-45TT-u--show_Show_RawKindedName e-6) '())))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32displayImpl-10275 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-3 e-5 e-6 (CoreC-45Name-splitNS (let ((e-1 (vector-ref e-6 1))) e-1))) clam-0)))))))(else (vector 1 '())))))))))
(define IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32displayImpl-10134 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32displayImpl-10187 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-3 (IdrisC-45SyntaxC-45Views-getFnArgs (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-3))))))
(define IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32displayImpl-10055 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((act-1 (let ((act-1 (unbox arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-55 (PreludeC-45Basics-flip csegen-1298 e-3 (lambda (u--arg) (IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32displayImpl-10134 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-2 e-3 e-5 u--arg (IdrisC-45SyntaxC-45Views-underLams (IdrisC-45SyntaxC-45Views-unArg u--arg))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (DataC-45List-intersperse (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "") e-6)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define IdrisC-45DocC-45Display-case--displayImpl-9993 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-0 (vector-ref arg-6 1))) (let ((e-1 (vector-ref arg-6 2))) (let ((e-2 (vector-ref arg-6 3))) (let ((e-3 (vector-ref arg-6 4))) (let ((e-4 (vector-ref arg-6 5))) (if (null? e-4) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not an implementation definition")))) (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (if (null? e-6) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not an implementation definition")))) (let ((e-10 (car e-6))) (let ((e-11 (cdr e-6))) (if (null? e-11) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not an implementation definition")))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (lambda (clam-0) (if (null? e-15) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not an implementation definition"))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (if (null? e-7) (let ((act-1 (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-5 e-10 arg-3 e-14 e-19 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-resugar e-10 arg-5 arg-4 e-14 e-5 eta-0)))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45DocC-45Display-case--caseC-32blockC-32inC-32displayImpl-10055 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-0 e-1 e-3 e-10 e-18 e-14 e-19 e-2 e-5 (IdrisC-45SyntaxC-45Views-getFnArgs (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-5) eta-0)))) eff-0) clam-0))))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not an implementation definition")))))))))))))))))))))))(else (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "is not an implementation definition"))))))))
(define IdrisC-45DocC-45Display-displayImpl (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (IdrisC-45DocC-45Display-case--displayImpl-9993 e-2 e-6 e-7 arg-2 arg-1 arg-0 (let ((e-18 (vector-ref e-7 18))) e-18))))))))
(define IdrisC-45SyntaxC-45Views-n--8415-9507-u--go (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((1) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (let ((e-5 (vector-ref arg-2 5))) (let ((e-6 (vector-ref arg-2 6))) (lambda (eta-0) ((IdrisC-45SyntaxC-45Views-n--8415-9507-u--go arg-1 e-6) (cons (cons e-4 (vector 2 e-1 e-2 e-3 e-5)) eta-0)))))))))) ((32) (let ((e-9 (vector-ref arg-2 2))) (IdrisC-45SyntaxC-45Views-n--8415-9507-u--go arg-1 e-9)))(else (lambda (__leftTupleSection-0) (cons __leftTupleSection-0 arg-2))))))
(define IdrisC-45SyntaxC-45Views-underPis (lambda (arg-1) ((IdrisC-45SyntaxC-45Views-n--8415-9507-u--go arg-1 arg-1) '())))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getDocsForImplementation-14545 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 arg-25 arg-26) (if (null? arg-26) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-26))) (let ((e-3 (cdr arg-26))) (if (null? e-2) (lambda (eta-0) (vector 1 0)) (let ((e-6 (car e-2))) (case (vector-ref e-6 0) ((0) (let ((e-9 (vector-ref e-6 1))) (let ((e-10 (vector-ref e-6 2))) (if (null? e-3) (lambda (eta-0) (vector 1 0)) (let ((e-18 (car e-3))) (lambda (clam-0) (case (vector-ref e-18 0) ((0) (let ((e-22 (vector-ref e-18 2))) (let ((sc5 (CoreC-45Name-u--C-61C-61_Eq_Name (CoreC-45Name-dropNS e-10) (CoreC-45Name-dropNS (let ((e-1 (vector-ref e-22 1))) e-1))))) (cond ((equal? sc5 0) (let ((act-1 ((CoreC-45Context-lookupCtxtName e-10 (let ((e-0 (vector-ref arg-13 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-1 "doc.implementation" 50 (lambda () (DataC-45String-unwords (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "Mismatch between " (cons (CoreC-45Name-u--show_Show_Name e-10) (cons " and " (cons (CoreC-45TT-u--show_Show_KindedName e-22) (cons "," '())))))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons "checking whether " (cons (CoreC-45Name-u--show_Show_Name e-10) (cons " exists:" '())))) (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-1) eta-1) (cons (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR e-5)) (cons " candidates" '()))) '()))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (if (null? e-5) (let ((act-3 (let ((sc9 (PreludeC-45Interfaces-C-62C-61C-62 csegen-2648 (lambda (eta-1) (PreludeC-45Interfaces-C-62C-61C-62 csegen-2648 (lambda (eta-2) (PreludeC-45Interfaces-C-62C-61C-62 csegen-2648 (lambda (eta-3) (CoreC-45Name-isUN eta-3)) (lambda (eta-3) (CoreC-45Name-isBasic (Builtin-snd eta-3))) eta-2)) (lambda (eta-2) (PreludeC-45Types-strUncons eta-2)) eta-1)) (lambda (eta-1) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45Types-isUpper (Builtin-fst eta-1)))) e-10))) (if (null? sc9) (vector 1 (vector 0 )) (CoreC-45Context-undefinedName arg-1 e-9 e-10 eta-0))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (vector 1 1)))) (vector 1 0)))))))) eff-0) clam-0)))))) (else (vector 1 1))))))(else (vector 1 0))))))))) ((15) (let ((e-13 (vector-ref e-6 2))) (lambda (clam-1) (if (null? e-3) (vector 1 0) (let ((e-25 (car e-3))) (case (vector-ref e-25 0) ((15) (let ((e-29 (vector-ref e-25 2))) (vector 1 (CoreC-45TTC-45Primitive-u--C-61C-61_Eq_Constant e-13 e-29))))(else (vector 1 0)))))))) ((22) (lambda (clam-2) (if (null? e-3) (vector 1 0) (let ((e-32 (car e-3))) (case (vector-ref e-32 0) ((22) (vector 1 1))(else (vector 1 0)))))))(else (lambda (eta-0) (vector 1 0)))))))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getDocsForImplementation-14403 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 ext-0) (let ((e-2 (car arg-21))) (let ((e-3 (cdr arg-21))) (let ((act-1 ((PreludeC-45Basics-flip csegen-1298 (DataC-45List-u--zip_Zippable_List arg-5 e-3) (lambda (lamc-0) (let ((e-5 (car lamc-0))) (let ((e-4 (cdr lamc-0))) (let ((lamc-1 (cons e-5 e-4))) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getDocsForImplementation-14545 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-2 e-3 e-5 e-4 lamc-1 (cons (IdrisC-45SyntaxC-45Views-getFnArgs (lambda (eta-0) eta-0) (IdrisC-45SyntaxC-45Views-unArg e-5)) (IdrisC-45SyntaxC-45Views-getFnArgs (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) (IdrisC-45SyntaxC-45Views-unArg e-4))))))))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) eta-0) e-5))) (cond ((equal? sc2 1) (vector 1 (box (cons arg-14 (cons arg-15 arg-16))))) (else (vector 1 '()))))))) eff-0) ext-0)))))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getDocsForImplementation-14350 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (let ((e-2 (car arg-19))) (let ((e-3 (cdr arg-19))) (lambda (eta-0) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getDocsForImplementation-14403 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 e-2 e-3 (IdrisC-45SyntaxC-45Views-getFnArgs (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-3) eta-0))))))
(define IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForImplementation-14180 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (vector 1 '())) (let ((e-1 (car arg-7))) (let ((e-2 (cdr arg-7))) (lambda (clam-0) (if (null? e-1) (vector 1 '()) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (if (null? e-2) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-3 (vector-ref eta-0 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (let ((e-3 (cdr e-7))) e-3)))))) (lambda (eta-0) (CoreC-45Context-getSearchData arg-1 arg-4 0 e-5 eta-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (vector 1 '()) (let ((e-4 (car e-7))) (let ((e-3 (cdr e-7))) (if (null? e-4) (vector 1 '()) (let ((e-9 (car e-4))) (let ((e-8 (cdr e-4))) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-55 (PreludeC-45Basics-flip csegen-1298 e-8 (lambda (u--hint) (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExactI u--hint (let ((e-0 (vector-ref e-10 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((_-0 (cons (cons e-9 e-8) e-3))) (lambda (clam-2) (if (null? e-11) (vector 1 '()) (let ((e-12 (unbox e-11))) (let ((e-14 (car e-12))) (let ((e-13 (cdr e-12))) (let ((act-4 ((PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (lambda (world-0) (let ((act-4 (eta-2 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (eta-3 e-15))) eff-0) world-0)))))))) (lambda (eta-2) (lambda (eta-3) (IdrisC-45Resugar-resugar '() arg-1 arg-2 '() eta-2 eta-3))) (lambda (eta-2) (CoreC-45Normalise-normaliseHoles arg-1 '() e-10 '() (let ((e-35 (vector-ref e-13 2))) e-35) eta-2))) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (let ((_-1 (box (cons e-14 e-13)))) (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32getDocsForImplementation-14350 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-6 e-5 e-3 e-9 e-8 _-0 e-10 u--hint e-14 e-13 _-1 e-15 (IdrisC-45SyntaxC-45Views-underPis e-15))))) eff-0) clam-2))))))))))))) eff-0) eta-1)))))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-11) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find an implementation for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Syntax-u--show_Show_PTerm arg-0))))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45Display-displayImpl arg-1 arg-2 e-10 eta-1)) e-11 '()) clam-3))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat e-12)))))) eff-0) clam-3))))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))))))))))) eff-0) clam-0))))) (vector 1 '())))))))))))
(define IdrisC-45DocC-45String-case--getDocsForImplementation-14151 (lambda (arg-0 arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (vector 1 '()) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-6 (vector-ref e-2 2))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45DocC-45String-case--caseC-32blockC-32inC-32getDocsForImplementation-14180 arg-0 arg-1 arg-2 e-6 e-5 e-3 e-7 (LibrariesC-45DataC-45ANameMap-lookupName e-6 (let ((e-14 (vector-ref e-7 5))) e-14))))) eff-0) clam-0))))))))(else (vector 1 '())))))))))
(define IdrisC-45DocC-45String-getDocsForImplementation (lambda (arg-0 arg-1 arg-2) (IdrisC-45DocC-45String-case--getDocsForImplementation-14151 arg-2 arg-1 arg-0 (IdrisC-45SyntaxC-45Views-getFnArgs (lambda (eta-0) eta-0) arg-2))))
(define IdrisC-45REPL-getOptions (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 0 (let ((e-0 (vector-ref e-5 0))) e-0)) (cons (vector 2 (let ((e-1 (vector-ref e-5 1))) e-1)) (cons (vector 1 (let ((e-3 (vector-ref e-5 3))) e-3)) (cons (vector 3 (let ((e-0 (vector-ref e-6 0))) e-0)) (cons (vector 4 (let ((e-1 (vector-ref e-6 1))) e-1)) (cons (vector 5 (let ((e-17 (vector-ref e-6 6))) e-17)) '())))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45Context-n--22796-18383-u--isHole (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-2 (let ((e-0 (vector-ref arg-1 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 1) (let ((e-1 (unbox e-5))) (vector 1 (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((0) 1) ((7) 1)(else 0))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-getUserHoles (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--hs (DataC-45List-sort csegen-861 (LibrariesC-45DataC-45NameMap-keys (let ((e-25 (vector-ref e-5 25))) e-25))))) (CoreC-45Core-filterM (lambda (eta-0) (lambda (eta-1) (CoreC-45Context-n--22796-18383-u--isHole arg-0 e-5 eta-0 eta-1))) u--hs)))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45Holes-getUserHolesData (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--ctxt (let ((e-0 (vector-ref e-5 0))) e-0))) (lambda (eta-0) (let ((act-2 (CoreC-45Context-getUserHoles arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (u--n) (CoreC-45Context-lookupCtxtName u--n u--ctxt)) e-6 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--globs (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-2) eta-2) e-7))) (let ((u--holesWithArgs (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-8 (cdr e-3))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (IdrisC-45IDEModeC-45Holes-isHole e-8) (lambda (u--args) (box (cons e-2 (cons e-8 u--args))))))))) u--globs))) (CoreC-45Core-traverseC-39 (lambda (u--n_gdef_args) (let ((e-2 (car u--n_gdef_args))) (let ((e-3 (cdr u--n_gdef_args))) (lambda (clam-0) (let ((e-9 (car e-3))) (let ((e-8 (cdr e-3))) (IdrisC-45IDEModeC-45Holes-holeData '() arg-0 arg-1 e-5 '() e-2 e-8 (let ((e-29 (vector-ref e-9 2))) e-29) clam-0))))))) u--holesWithArgs '()))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) ext-0)))))))
(define CoreC-45Context-getWorkingDir (lambda (ext-0) (let ((act-1 (let ((act-1 (csegen-1310 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't get current directory") clam-0) (let ((e-1 (unbox e-5))) (vector 1 e-1)))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-inferAndElab (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (IdrisC-45Desugar-desugar arg-3 arg-1 arg-4 arg-2 arg-5 1 arg-0 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45REPL-getItDecls arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--ttimpWithIt (vector 5 CoreC-45FC-replFC e-6 e-5))) (lambda (eta-1) (let ((act-3 (CoreC-45Context-resolveName arg-1 (vector 1 (vector 0 "[input]")) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-3) (let ((act-4 (CoreC-45Context-hide arg-1 CoreC-45FC-replFC (vector 0 CoreC-45NameC-45Namespace-primIONS (vector 1 (vector 0 "::"))) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (CoreC-45Context-hide arg-1 CoreC-45FC-replFC (vector 0 CoreC-45NameC-45Namespace-primIONS (vector 1 (vector 0 "Nil"))) eta-3))))) (lambda (u--err) (lambda (eta-3) (vector 1 (vector 0 )))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45Elab-elabTerm arg-0 arg-1 arg-4 arg-2 arg-3 arg-5 e-7 arg-6 '() '() arg-8 u--ttimpWithIt '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-6 ((CoreC-45NormaliseC-45Eval-getTerm e-3) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons e-2 e-10))))) eff-0) clam-0)))))))))) eff-0) eta-2))))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-replEval (lambda (arg-0 arg-1 arg-2 ext-1 ext-0) (lambda (clam-0) (cond ((equal? arg-2 1) (lambda (eta-0) (CoreC-45Normalise-normaliseOpts arg-0 arg-1 (let ((sc1 CoreC-45Value-withAll)) (let ((e-0 (vector-ref sc1 0))) (let ((e-1 (vector-ref sc1 1))) (let ((e-2 (vector-ref sc1 2))) (let ((e-3 (vector-ref sc1 3))) (let ((e-4 (vector-ref sc1 4))) (let ((e-5 (vector-ref sc1 5))) (let ((e-6 (vector-ref sc1 6))) (vector e-0 e-1 e-2 e-3 e-4 e-5 e-6 0))))))))) ext-1 ext-0 clam-0 eta-0)))(else (lambda (eta-0) (CoreC-45Normalise-normalise arg-0 arg-1 ext-1 ext-0 clam-0 eta-0)))))))
(define IdrisC-45REPL-n--32306-15291-u--elabMode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-7 0) (vector 0 ))(else (vector 2 )))))
(define IdrisC-45REPL-inferAndNormalize (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (IdrisC-45REPL-inferAndElab '() arg-0 arg-1 arg-2 arg-3 arg-4 (IdrisC-45REPL-n--32306-15291-u--elabMode arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-5) arg-6 '() ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-1 (car e-5))) (let ((e-2 (cdr e-5))) (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-0 "repl.eval" 10 (lambda () "Elaborated input") e-1 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--norm (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-replEval arg-0 '() arg-5 eta-0 eta-1))))) (lambda (eta-0) (let ((act-4 ((((u--norm e-7) '()) e-1) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (CoreC-45Normalise-logTermNF '() arg-0 "repl.eval" 5 (lambda () "Normalised") '() e-8 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (vector 1 (cons e-8 e-2)))))))) eff-0) eta-0))))))))) eff-0) clam-0))))))))))))) eff-0) ext-0)))))))
(define TTImpC-45BindImplicits-n--9030-7615-u--piBind (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-4) arg-5 (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (vector 1 arg-2 csegen-30 (vector 0 ) (box (vector 1 (vector 0 e-2))) (vector 32 arg-2 0) (TTImpC-45BindImplicits-n--9030-7615-u--piBind arg-0 arg-1 arg-2 arg-3 e-3 arg-5)))))))
(define TTImpC-45BindImplicits-piBindNames (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((TTImpC-45Utils-findUniqueBindableNames arg-0 arg-1 1 arg-2 '() arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (TTImpC-45BindImplicits-n--9030-7615-u--piBind arg-3 arg-2 arg-1 arg-0 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-5) arg-3))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45Holes-n--10794-9660-u--prettyHole (lambda (arg-0 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 (let ((e-0 (vector-ref arg-1 0))) e-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (let ((e-1 (vector-ref arg-1 1))) e-1))))))
(define IdrisC-45IDEModeC-45Holes-prettyHoles (lambda (arg-0) (if (null? arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "No holes") (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "1 hole") LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (IdrisC-45IDEModeC-45Holes-n--10794-9660-u--prettyHole arg-0 e-2)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (PreludeC-45Show-u--show_Show_Nat (PreludeC-45TypesC-45List-lengthTR arg-0))) csegen-3715) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (IdrisC-45IDEModeC-45Holes-n--10794-9660-u--prettyHole arg-0 eta-0))) arg-0)))))))))
(define CoreC-45Env-mkEnvOnto (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-3 (cdr arg-2))) (cons (vector 3 arg-1 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 10 arg-1 (vector 0 ))) (CoreC-45Env-mkEnvOnto arg-1 e-3 arg-3))))))
(define CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyName (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (let ((sc1 (let ((e-3 (vector-ref e-5 3))) e-3))) (cond ((equal? sc1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-1)) (else (CoreC-45Name-prettyOp 1 (CoreC-45Name-dropNS arg-1))))))))) eff-0) ext-0)))))))
(define CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((act-1 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyName arg-1 e-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyTree (PreludeC-45TypesC-45List-tailRecAppend e-3 arg-0) arg-1 arg-2 (CoreC-45Env-mkEnvOnto CoreC-45FC-emptyFC e-3 arg-3) e-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 (box e-1)) e-5) (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) e-6)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline e-6)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-6 (vector-ref arg-4 1))) (let ((e-7 (vector-ref arg-4 2))) (let ((e-8 (vector-ref arg-4 3))) (let ((act-1 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyTree (PreludeC-45TypesC-45List-tailRecAppend (cons e-6 (cons e-7 '())) arg-0) arg-1 arg-2 (CoreC-45Env-mkEnvOnto CoreC-45FC-emptyFC (cons e-6 (cons e-7 '())) arg-3) e-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2728 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) e-5)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline e-5))))))))))) eff-0) ext-0))))))))) ((2) (let ((e-10 (vector-ref arg-4 1))) (let ((e-11 (vector-ref arg-4 2))) (let ((act-1 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyTree arg-0 arg-1 arg-2 arg-3 e-11 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (CoreC-45TTC-45Primitive-u--pretty_Pretty_IdrisSyntax_Constant e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) e-5)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline e-5)))))))))) eff-0) ext-0)))))))) (else (let ((e-13 (vector-ref arg-4 1))) (let ((act-1 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyTree arg-0 arg-1 arg-2 arg-3 e-13 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2729 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-fatArrow (vector 7 (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces 1) e-5)) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline e-5)))))))))) eff-0) ext-0))))))))))
(define CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyTree (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-4 (vector-ref arg-4 3))) (let ((e-5 (vector-ref arg-4 4))) (let ((act-1 (case (vector-ref e-4 0) ((10) csegen-2721)(else (let ((act-1 (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-3 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-2724 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-6)))))) eff-0) ext-0))))))))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyAlt arg-0 arg-1 arg-2 arg-3 eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-case_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-1) e-6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 IdrisC-45PrettyC-45Annotations-of_ (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-nest 2 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-7)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))) ((1) (let ((e-8 (vector-ref arg-4 2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-5)))))) (lambda (eta-0) (IdrisC-45Resugar-resugar arg-0 arg-1 arg-2 arg-3 e-8 eta-0)) ext-0))) ((2) (let ((e-10 (vector-ref arg-4 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Error:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-10))))) (else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Impossible"))))))
(define CoreC-45ContextC-45PrettyC-45Resugared-prettyDef (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "undefined"))) ((1) (let ((e-1 (vector-ref arg-2 2))) (let ((e-2 (vector-ref arg-2 3))) (let ((act-1 (CoreC-45CaseC-45CaseTreeC-45PrettyC-45Resugared-prettyTree e-1 arg-0 arg-1 (CoreC-45Env-mkEnv CoreC-45FC-emptyFC e-1) e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Arguments") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyList csegen-1260 e-1)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Compile time tree")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-1) (vector 6 eta-1)) e-5)) '()))))))) eff-0) ext-0)))))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (let ((e-6 (vector-ref arg-2 2))) (let ((e-7 (vector-ref arg-2 3))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Data constructor")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "tag:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-5)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "arity:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-6)) '())) (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--n) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "newtype by:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1025 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1025 u--d u--x)))) u--n)) '()))) e-7)))))))))) ((6) (let ((e-8 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) (let ((e-10 (vector-ref arg-2 3))) (let ((e-13 (vector-ref arg-2 6))) (let ((e-14 (vector-ref arg-2 7))) (let ((e-15 (vector-ref arg-2 8))) (vector 1 (let ((u--enum (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ",") eta-0))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Type constructor")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "tag:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-8)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "arity:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-9)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "parameter positions:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1029 e-10)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "constructors:") (u--enum (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--nm) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 6 (vector 2 (box u--nm))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 u--nm))) e-14))) '())))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "mutual with:") (u--enum (PreludeC-45TypesC-45List-mapAppend '() csegen-2726 e-13)))) (PreludeC-45Interfaces-guard csegen-1509 (let ((sc1 (PreludeC-45Types-u--null_Foldable_List e-13))) (cond ((equal? sc1 1) 0) (else 1))))) (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--pos) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "detaggable by:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1029 u--pos)) '()))) e-15))))))))))))))) ((2) (let ((e-16 (vector-ref arg-2 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "External definition")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "arity:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-16)) '()))))))) ((3) (let ((e-17 (vector-ref arg-2 1))) (let ((e-18 (vector-ref arg-2 2))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Foreign definition")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "arity:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-17)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "bindings:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-981 e-18)) '()))))))))) ((4) (let ((e-19 (vector-ref arg-2 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Builtin")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "arity:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-19)) '()))))))) ((7) (let ((e-22 (vector-ref arg-2 2))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Hole")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Implicitly bound name")) (PreludeC-45Interfaces-guard csegen-1509 (let ((e-0 (car e-22))) e-0))))))))) ((8) (let ((e-24 (vector-ref arg-2 2))) (let ((e-25 (vector-ref arg-2 3))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Search")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "depth:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-24)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "in:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-25)) '()))))))))) ((9) (let ((e-26 (vector-ref arg-2 1))) (let ((e-28 (vector-ref arg-2 3))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Guess")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "solution:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1268 e-26)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "when:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-495 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 csegen-495 u--d u--x)))) e-28)) '()))))))))) ((11) (let ((e-29 (vector-ref arg-2 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Universe level #") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1054 e-29))))) ((10) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Bound name"))) (else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Delayed"))))))
(define CoreC-45CompileExprC-45Pretty-prettyCExp (lambda (arg-0 ext-0) (CoreC-45CompileExprC-45Pretty-prettyNamedCExp (CoreC-45CompileExpr-forget arg-0 ext-0))))
(define CoreC-45CompileExprC-45Pretty-prettyCDef (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (if (null? e-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) (CoreC-45CompileExprC-45Pretty-prettyCExp '() e-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 csegen-5272 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 ","))) u--y))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45CompileExprC-45Pretty-prettyName eta-0)) e-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 IdrisC-45PrettyC-45Annotations-fatArrow (CoreC-45CompileExprC-45Pretty-prettyCExp e-0 e-1))))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (let ((e-4 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Data")) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Type"))) e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Constructor"))) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--tag) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "tag:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 u--tag)) '()))) e-2) (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "arity:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-3)) '()) (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--n) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "newtype by:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 u--n)) '()))) e-4)))))))))) ((2) (let ((e-5 (vector-ref arg-0 1))) (let ((e-6 (vector-ref arg-0 2))) (let ((e-7 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Foreign function")) (PreludeC-45TypesC-45List-mapAppend '() csegen-3138 (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "bindings:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyList csegen-702 e-5)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "argument types:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (csegen-1242) u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 (csegen-1242) u--d u--x)))) e-6)) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "return type:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow (csegen-1242) e-7)) '())))))))))) (else (let ((e-8 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Error:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) (CoreC-45CompileExprC-45Pretty-prettyCExp '() e-8))))))))
(define CoreC-45CompileExprC-45Pretty-u--pretty_Pretty_IdrisDocAnn_CDef (lambda (ext-0) (CoreC-45CompileExprC-45Pretty-prettyCDef ext-0)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-columnSpacing 1)
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-columnSep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces LibrariesC-45DataC-45SparseMatrixC-45Pretty-columnSpacing)) u--y))) ext-0)))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-width (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-column (lambda (u--colStart) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-column (lambda (u--colEnd) (arg-2 (bs- u--colEnd u--colStart 63)))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fill (lambda (arg-1 arg-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-width arg-2 (lambda (u--w) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (bs- arg-1 u--w 63))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-hardlineSep (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) u--y))) ext-0)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-header (lambda (arg-1 arg-2) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fill arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1054 eta-0))) (PreludeC-45Types-take arg-2 (PreludeC-45Types-u--rangeFrom_Range_C-36a csegen-1070 0)))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2809-u--prettyNeutral (lambda (arg-2 arg-3) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space))
(define DataC-45List-lastC-39 (lambda (arg-1) (if (null? arg-1) '() (box (DataC-45List-last arg-1)))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-maxIndex (lambda (arg-1) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-fst eta-0)) (DataC-45List-lastC-39 arg-1))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector-length (lambda (ext-0) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (+ eta-0 1))) (LibrariesC-45DataC-45SparseMatrixC-45Vector-maxIndex ext-0))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2810-u--rowLength (lambda (arg-2 arg-3) (LibrariesC-45DataC-45SparseMatrixC-45Vector-length arg-3)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2808-u--go (lambda (arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) '() (cond ((equal? arg-4 0) '())(else (let ((e-0 (- arg-4 1))) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--i (+ e-0 1))) (let ((u--ys (cons (cons e-6 e-7) e-3))) (let ((sc3 (PreludeC-45EqOrd-u--compare_Ord_Integer (PreludeC-45Types-prim__integerToNat (- (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2810-u--rowLength arg-2 arg-3) u--i)) e-6))) (cond ((equal? sc3 0) (cons (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2809-u--prettyNeutral arg-2 arg-3) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2808-u--go arg-2 arg-3 e-0 u--ys))) ((equal? sc3 1) (cons (let ((e-5 (car arg-2))) (e-5 e-7)) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2808-u--go arg-2 arg-3 e-0 e-3))) (else (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2808-u--go arg-2 arg-3 u--i e-3))))))))))))))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-row (lambda (arg-2 arg-3) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2808-u--go arg-2 arg-3 (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5761-2810-u--rowLength arg-2 arg-3) arg-3)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-row1 (lambda (arg-2 arg-3 arg-4) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fill arg-3 eta-0)) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-row arg-2 (DataC-45List1-forget arg-4)))))
(define LibrariesC-45DataC-45SparseMatrixC-45Vector1-maxIndex (lambda (arg-1) (let ((e-1 (car arg-1))) (let ((e-2 (cdr arg-1))) (let ((e-5 (car e-1))) (PreludeC-45Types-maybe (lambda () e-5) (lambda () (lambda (eta-0) (Builtin-fst eta-0))) (DataC-45List-lastC-39 e-2)))))))
(define DataC-45MaybeC-45Semigroup-u--C-60C-43C-62_Semigroup_DeepC-40MaybeC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) (if (null? arg-3) '() (let ((e-5 (unbox arg-3))) (box e-5))) (let ((e-2 (unbox arg-2))) (if (null? arg-3) (box e-2) (let ((e-8 (unbox arg-3))) (box ((arg-1 e-2) e-8))))))))
(define LibrariesC-45DataC-45SparseMatrix-maxColumnIndex (lambda (ext-0) (PreludeC-45Types-u--foldMap_Foldable_List (cons (lambda (arg-8474) (lambda (arg-8477) (DataC-45MaybeC-45Semigroup-u--C-60C-43C-62_Semigroup_DeepC-40MaybeC-32C-36aC-41 csegen-1049 arg-8474 arg-8477))) '()) (lambda (eta-0) (box (LibrariesC-45DataC-45SparseMatrixC-45Vector1-maxIndex (Builtin-snd eta-0)))) ext-0)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3027-u--columnMax (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45SparseMatrix-maxColumnIndex arg-3)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3024-u--columnCount (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45Types-maybe (lambda () 0) (lambda () (lambda (eta-0) (+ eta-0 1))) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3027-u--columnMax arg-2 arg-3 arg-4 arg-5 arg-6))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3025-u--columnLabelSep (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) #\-))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3028-u--columnMaxIndexWidth (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45Types-maybe (lambda () 0) (lambda () csegen-1048) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3027-u--columnMax arg-2 arg-3 arg-4 arg-5 arg-6))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3029-u--columnWidth (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (blodwen-toSignedInt (PreludeC-45Types-u--max_Ord_Nat (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3028-u--columnMaxIndexWidth arg-2 arg-3 arg-4 arg-5 arg-6) arg-4) 63)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3026-u--columnLabelSepLength (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (bs+ (blodwen-toSignedInt (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45String-length arg-5) 1)) 63) (bs* (bs+ (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3029-u--columnWidth arg-2 arg-3 arg-4 arg-5 arg-6) LibrariesC-45DataC-45SparseMatrixC-45Pretty-columnSpacing 63) (blodwen-toSignedInt (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3024-u--columnCount arg-2 arg-3 arg-4 arg-5 arg-6) 63) 63) 63)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3030-u--intersectionLabelSep (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) #\+))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3031-u--rowLabelSep (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) #\|))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3033-u--rowMax (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45SparseMatrixC-45Vector-maxIndex arg-3)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3034-u--rowMaxIndexWidth (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45Types-maybe (lambda () 0) (lambda () csegen-1048) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3033-u--rowMax arg-2 arg-3 arg-4 arg-5 arg-6))))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3032-u--rowLabelWidth (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (blodwen-toSignedInt (PreludeC-45Types-u--max_Ord_Nat (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3034-u--rowMaxIndexWidth arg-2 arg-3 arg-4 arg-5 arg-6) (PreludeC-45TypesC-45String-length arg-6)) 63)))
(define LibrariesC-45DataC-45SparseMatrixC-45Pretty-prettyTable (lambda (arg-2 arg-3 arg-4 arg-5 arg-6) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-hardlineSep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-spaces (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3032-u--rowLabelWidth arg-2 arg-6 arg-5 arg-4 arg-3)) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-columnSep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 arg-4) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-header (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3029-u--columnWidth arg-2 arg-6 arg-5 arg-4 arg-3) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3024-u--columnCount arg-2 arg-6 arg-5 arg-4 arg-3))))) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fill (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3032-u--rowLabelWidth arg-2 arg-6 arg-5 arg-4 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 arg-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (vector 1 (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3030-u--intersectionLabelSep arg-2 arg-6 arg-5 arg-4 arg-3)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-replicateChar (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3026-u--columnLabelSepLength arg-2 arg-6 arg-5 arg-4 arg-3) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3025-u--columnLabelSep arg-2 arg-6 arg-5 arg-4 arg-3)))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fill (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3032-u--rowLabelWidth arg-2 arg-6 arg-5 arg-4 arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-895 e-2)) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-columnSep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-fill (blodwen-toSignedInt (PreludeC-45TypesC-45String-length arg-4) 63) (vector 1 (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3031-u--rowLabelSep arg-2 arg-6 arg-5 arg-4 arg-3))) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-row1 arg-2 (LibrariesC-45DataC-45SparseMatrixC-45Pretty-n--5986-3029-u--columnWidth arg-2 arg-6 arg-5 arg-4 arg-3) e-3))))))) arg-6))))))
(define AlgebraC-45SizeChange-u--pretty_Pretty_Void_SizeChange (lambda (arg-0) (cond ((equal? arg-0 0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "<")) ((equal? arg-0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "=")) (else LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--neutral_Monoid_C-40DocC-32C-36annC-41))))
(define AlgebraC-45SizeChange-u--prettyPrec_Pretty_Void_SizeChange (lambda (arg-0 arg-1) (AlgebraC-45SizeChange-u--pretty_Pretty_Void_SizeChange arg-1)))
(define IdrisC-45REPL-n--21617-5796-u--enumLine (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hcat (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline (PreludeC-45TypesC-45List-mapAppend '() arg-6 arg-7)))))
(define IdrisC-45REPL-n--21617-5794-u--displayChg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--scinfo (lambda (u--s) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 (let ((e-0 (vector-ref u--s 0))) e-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (LibrariesC-45DataC-45SparseMatrixC-45Pretty-prettyTable (cons (lambda (arg-11067) (AlgebraC-45SizeChange-u--pretty_Pretty_Void_SizeChange arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (AlgebraC-45SizeChange-u--prettyPrec_Pretty_Void_SizeChange arg-11073 arg-11076)))) "r" "l" 1 (let ((e-1 (vector-ref u--s 1))) e-1)))))) (IdrisC-45REPL-n--21617-5796-u--enumLine arg-0 arg-1 arg-2 arg-3 arg-4 u--scinfo arg-5))))
(define IdrisC-45REPL-n--21617-5795-u--enum (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ",") (PreludeC-45TypesC-45List-mapAppend '() arg-6 arg-7)))))
(define IdrisC-45REPL-n--21617-5797-u--ifNotNull (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-6) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) arg-6) (PreludeC-45Interfaces-guard csegen-258 (let ((sc0 (PreludeC-45Types-u--null_Foldable_List arg-6))) (cond ((equal? sc0 1) 0) (else 1)))))))
(define IdrisC-45REPL-prettyInfo (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((u--nm (let ((e-1 (vector-ref e-7 1))) e-1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-1966 (let ((e-18 (vector-ref e-7 18))) e-18) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-getFullName arg-0 eta-2 eta-3))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-7)) '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-getFullName arg-0 eta-3 eta-4))) (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersToRuntime e-7)) '()) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (CoreC-45Context-toFullNames arg-0 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-6) (CoreC-45Context-u--full_HasNames_SCCall arg-7719 arg-7722 eta-6)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-6) (CoreC-45Context-u--resolved_HasNames_SCCall arg-7729 arg-7732 eta-6))))) eta-4 eta-5))) (let ((e-21 (vector-ref e-7 21))) e-21) '()) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Context-getPPrint arg-0 eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 ((CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-11 0))) (let ((e-12 (vector-ref e-11 2))) (let ((e-4 (vector-ref e-11 3))) (vector e-0 1 e-12 e-4))))) eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (CoreC-45ContextC-45PrettyC-45Resugared-prettyDef arg-0 arg-1 e-5 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 ((CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-11 0))) (let ((e-14 (vector-ref e-11 2))) (let ((e-4 (vector-ref e-11 3))) (vector e-0 (let ((e-17 (vector-ref e-11 1))) e-17) e-14 e-4))))) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (PreludeC-45TypesC-45List-tailRecAppend (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-7) (vector 6 eta-7)) (IdrisC-45PrettyC-45Annotations-prettyRig (let ((e-30 (vector-ref e-7 7))) e-30))) ((IdrisC-45Pretty-showCategory (lambda (eta-7) (vector 6 eta-7)) e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 u--nm))) (cons e-13 '())) (DataC-45List-catMaybes (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--args) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Erasable args")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1029 u--args))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 (let ((e-33 (vector-ref e-7 3))) e-33))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--args) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Detaggable arg types")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1029 u--args))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 (let ((e-4 (vector-ref e-7 4))) e-4))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--args) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Specialise args")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1029 u--args))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 (let ((e-32 (vector-ref e-7 5))) e-32))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--args) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Inferrable args")) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1029 u--args))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 (let ((e-31 (vector-ref e-7 6))) e-31))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--expr) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Compiled")) (CoreC-45CompileExprC-45Pretty-u--pretty_Pretty_IdrisDocAnn_CDef u--expr))) (let ((e-19 (vector-ref e-7 19))) e-19)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--nms) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Refers to")) (IdrisC-45REPL-n--21617-5795-u--enum e-2 e-6 e-7 arg-1 arg-0 csegen-2726 u--nms))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 e-8)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--nms) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Refers to (runtime)")) (IdrisC-45REPL-n--21617-5795-u--enum e-2 e-6 e-7 arg-1 arg-0 csegen-2726 u--nms))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 e-9)) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--flgs) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Flags")) (IdrisC-45REPL-n--21617-5795-u--enum e-2 e-6 e-7 arg-1 arg-0 (lambda (eta-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-2699 eta-7)) u--flgs))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 (let ((e-25 (vector-ref e-7 12))) e-25))) (cons (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--sz) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45DocC-45Annotations-header (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Size change")) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-indent 2 (IdrisC-45REPL-n--21617-5794-u--displayChg e-2 e-6 e-7 arg-1 arg-0 u--sz)))) (IdrisC-45REPL-n--21617-5797-u--ifNotNull e-2 e-6 e-7 arg-1 arg-0 e-10)) '()))))))))))))))))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define IdrisC-45REPL-rtrim (lambda (arg-0) (string-reverse (DataC-45String-ltrim (string-reverse arg-0)))))
(define IdrisC-45REPL-addClause (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) (cons (IdrisC-45REPL-rtrim arg-0) '()) (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (let ((sc2 (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) (PreludeC-45Types-fastUnpack e-3)))) (cond ((equal? sc2 1) (cons (IdrisC-45REPL-rtrim arg-0) (cons e-3 e-4))) (else (cons e-3 (IdrisC-45REPL-addClause arg-0 0 e-4)))))))))(else (let ((e-0 (- arg-1 1))) (if (null? arg-2) (cons arg-0 '()) (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (cons e-6 (IdrisC-45REPL-addClause arg-0 e-0 e-7))))))))))
(define IdrisC-45REPL-n--23450-7536-u--addW (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-4 0) (if (null? arg-6) '() (let ((e-3 (cdr arg-6))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse arg-5) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45Unlit-relit arg-3 eta-0)) arg-2) e-3)))))(else (let ((e-0 (- arg-4 1))) (if (null? arg-6) (PreludeC-45TypesC-45List-reverse arg-5) (let ((e-6 (car arg-6))) (let ((e-7 (cdr arg-6))) (IdrisC-45REPL-n--23450-7536-u--addW arg-0 arg-1 arg-2 arg-3 e-0 (cons e-6 arg-5) e-7)))))))))
(define IdrisC-45REPL-addMadeCase (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45REPL-n--23450-7536-u--addW arg-3 arg-2 arg-1 arg-0 arg-2 '() arg-3)))
(define IdrisC-45REPL-n--23173-7283-u--replaceStr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 "") "")(else (let ((sc0 (DataC-45String-isPrefixOf arg-4 arg-6))) (cond ((equal? sc0 1) (string-append arg-5 (PreludeC-45Types-fastPack (DataC-45List-drop (PreludeC-45TypesC-45String-length arg-4) (PreludeC-45Types-fastUnpack arg-6))))) (else (string-cons (string-ref arg-6 0) (IdrisC-45REPL-n--23173-7283-u--replaceStr arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (substring arg-6 1 (string-length arg-6)))))))))))
(define IdrisC-45REPL-proofSearch (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (if (null? arg-3) '() (let ((e-3 (car arg-3))) (let ((e-4 (cdr arg-3))) (cons (IdrisC-45REPL-n--23173-7283-u--replaceStr e-3 e-4 arg-1 arg-0 (string-append "?" (CoreC-45Name-u--show_Show_Name arg-0)) arg-1 e-3) e-4)))))(else (let ((e-1 (- arg-2 1))) (if (null? arg-3) '() (let ((e-6 (car arg-3))) (let ((e-7 (cdr arg-3))) (cons e-6 (IdrisC-45REPL-proofSearch arg-0 arg-1 e-1 e-7))))))))))
(define IdrisC-45REPL-n--23279-7386-u--insertInBlank (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (cons (ParserC-45Unlit-relit arg-6 (string-append (CoreC-45Name-u--show_Show_Name arg-4) (string-append " : " (string-append arg-3 "\xa;")))) '()) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (DataC-45String-trim e-2) ""))) (cond ((equal? sc1 1) (cons (string-append "\xa;" (ParserC-45Unlit-relit arg-6 (string-append (CoreC-45Name-u--show_Show_Name arg-4) (string-append " : " (string-append arg-3 "\xa;"))))) e-3)) (else (cons e-2 (IdrisC-45REPL-n--23279-7386-u--insertInBlank arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-3))))))))))
(define IdrisC-45REPL-n--23279-7385-u--addApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (cond ((equal? arg-7 0) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-reverse (IdrisC-45REPL-n--23279-7386-u--insertInBlank arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8)) arg-9))(else (let ((e-0 (- arg-7 1))) (if (null? arg-9) (PreludeC-45TypesC-45List-reverse arg-8) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (IdrisC-45REPL-n--23279-7385-u--addApp arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-0 (cons e-2 arg-8) e-3)))))))))
(define IdrisC-45REPL-addMadeLemma (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (IdrisC-45REPL-n--23279-7385-u--addApp arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-0 arg-4 '() (IdrisC-45REPL-proofSearch arg-1 arg-3 arg-4 arg-5))))
(define IdrisC-45REPL-anyAt (lambda (arg-2 arg-3 arg-4) (arg-2 arg-3)))
(define IdrisC-45REPL-caseSplit (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-1 0) (if (null? arg-2) (cons arg-0 '()) (let ((e-4 (cdr arg-2))) (cons (IdrisC-45REPL-rtrim arg-0) e-4))))(else (let ((e-1 (- arg-1 1))) (if (null? arg-2) (cons arg-0 '()) (let ((e-6 (car arg-2))) (let ((e-7 (cdr arg-2))) (cons e-6 (IdrisC-45REPL-caseSplit arg-0 e-1 e-7))))))))))
(define IdrisC-45REPL-dropLams (lambda (arg-1 arg-2) (cond ((equal? arg-1 0) arg-2)(else (let ((e-0 (- arg-1 1))) (case (vector-ref arg-2 0) ((2) (let ((e-7 (vector-ref arg-2 6))) (IdrisC-45REPL-dropLams e-0 e-7)))(else arg-2)))))))
(define CoreC-45Context-clearTimer (lambda (arg-0) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 '() e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Metadata-findHoleLHS (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (DataC-45List-lookupBy csegen-2144 arg-1 (let ((e-4 (vector-ref e-5 4))) e-4)))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-noResult (lambda (ext-0) (vector 1 '())))
(define TTImpC-45InteractiveC-45ExprSearch-firstLinearOK (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (if (null? arg-6) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-4 (car arg-6))) (let ((e-5 (cdr arg-6))) (let ((e-8 (car e-4))) (let ((e-9 (cdr e-4))) (CoreC-45UnifyState-handleUnify arg-0 arg-2 0 (lambda (eta-0) (let ((act-1 (let ((sc2 (DataC-45List-isNil e-9))) (cond ((equal? sc2 1) (vector 1 (vector 0 ))) (else ((CoreC-45Core-traverse_ (lambda (eta-1) (TTImpC-45ElabC-45Check-processDecl '() arg-0 arg-1 arg-2 arg-3 arg-4 (cons 1 '()) '() '() eta-1)) e-9) eta-0)))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (CoreC-45LinearCheck-linearCheck '() arg-0 arg-2 arg-5 csegen-1416 0 '() e-8 eta-1)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox arg-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Normalise-normaliseHoles arg-0 '() e-10 '() e-8 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (CoreC-45Context-toFullNames arg-0 csegen-68 e-11 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (TTImpC-45Unelab-unelab '() arg-0 '() e-12))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (e-5 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (cons (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-12) (TTImpC-45InteractiveC-45ExprSearch-firstLinearOK arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-13)))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) (lambda (u--err) (lambda (eta-0) (let ((act-1 (e-5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-firstLinearOK arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6))) eff-0) eta-0))))))) clam-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--21359-10373-u--getLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((3) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (case (vector-ref e-3 0) ((3) (TTImpC-45InteractiveC-45ExprSearch-n--21359-10373-u--getLHS arg-0 arg-1 arg-2 (cons e-2 arg-3) e-4)) ((4) (TTImpC-45InteractiveC-45ExprSearch-n--21359-10373-u--getLHS arg-0 arg-1 arg-2 (cons e-2 arg-3) e-4))(else (let ((sc1 (CoreC-45TTC-45Term-getFn arg-4))) (case (vector-ref sc1 0) ((1) (let ((e-5 (vector-ref sc1 3))) (box (vector arg-3 e-5 arg-4))))(else '())))))))))(else (let ((sc0 (CoreC-45TTC-45Term-getFn arg-4))) (case (vector-ref sc0 0) ((1) (let ((e-3 (vector-ref sc0 3))) (box (vector arg-3 e-3 arg-4))))(else '())))))))
(define TTImpC-45InteractiveC-45ExprSearch-getLHSData (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (vector 1 '()) (let ((e-2 (unbox arg-2))) (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-1 '() e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-toFullNames arg-0 csegen-68 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45InteractiveC-45ExprSearch-n--21359-10373-u--getLHS e-2 arg-1 arg-0 '() e-6))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-one (lambda (arg-1 ext-0) (vector 1 (cons arg-1 (lambda (eta-0) (vector 1 '()))))))
(define LibrariesC-45DataC-45Tap-u--map_Functor_C-40TapC-32C-36mC-41 (lambda (arg-3 arg-4 ext-0) (if (null? ext-0) '() (let ((e-4 (car ext-0))) (let ((e-5 (cdr ext-0))) (cons (arg-4 e-4) ((((arg-3 'erased) 'erased) (lambda (eta-0) (LibrariesC-45DataC-45Tap-u--map_Functor_C-40TapC-32C-36mC-41 arg-3 arg-4 eta-0))) e-5)))))))
(define CoreC-45CoreC-45Search-functor (lambda (ext-0 ext-1 ext-2 ext-3) (LibrariesC-45DataC-45Tap-u--map_Functor_C-40TapC-32C-36mC-41 csegen-993 ext-2 ext-3)))
(define TTImpC-45Utils-n--12341-3587-u--defaultNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cons "x" (cons "y" (cons "z" (cons "w" (cons "v" (cons "s" (cons "t" (cons "u" '()))))))))))
(define TTImpC-45Utils-n--12341-3591-u--lookupName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 arg-9) (lambda (clam-0) (if (null? arg-9) (vector 1 '()) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (CoreC-45Context-getFullName arg-6 arg-8 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-getFullName arg-6 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-8))) (cond ((equal? sc4 1) (lambda (eta-1) (vector 1 (box e-7)))) (else (TTImpC-45Utils-n--12341-3591-u--lookupName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-8 e-3)))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45Utils-n--12341-3592-u--namesFor (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (TTImpC-45Utils-n--12341-3591-u--lookupName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 (LibrariesC-45DataC-45NameMap-toList (let ((e-15 (vector-ref arg-5 15))) e-15)))))
(define TTImpC-45Utils-n--12341-3593-u--notBound (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((sc0 (PreludeC-45Types-elem csegen-14 csegen-832 (vector 1 (vector 0 arg-7)) arg-3))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45Utils-n--12341-3589-u--findNamesM (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-3 (vector-ref arg-7 3))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (vector 1 (box (cons "f" (cons "g" '())))))(else (vector 1 '())))))) ((3) (let ((e-7 (vector-ref arg-7 2))) (let ((e-10 (vector-ref arg-7 5))) (if (null? e-10) (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7) (let ((e-20 (car e-10))) (let ((e-21 (cdr e-10))) (if (null? e-20) (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7) (let ((e-25 (cdr e-20))) (if (null? e-21) (lambda (eta-0) (let ((act-1 (CoreC-45Context-u--full_HasNames_Name (let ((e-0 (vector-ref arg-5 0))) e-0) e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc5 (CoreC-45Name-dropNS e-5))) (case (vector-ref sc5 0) ((1) (let ((e-0 (vector-ref sc5 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (cond ((equal? e-1 "List") (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-6 arg-0 arg-5 e-25) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Utils-n--12341-3589-u--findNamesM arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-12) (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7) (let ((e-2 (unbox e-12))) (lambda (eta-3) (vector 1 (box (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-8) (string-append arg-8 "s")) e-2)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) ((equal? e-1 "Maybe") (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-6 arg-0 arg-5 e-25) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Utils-n--12341-3589-u--findNamesM arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-12) (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7) (let ((e-2 (unbox e-12))) (lambda (eta-3) (vector 1 (box (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-8) (string-append "m" arg-8)) e-2)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))) ((equal? e-1 "SnocList") (lambda (eta-1) (let ((act-2 ((CoreC-45NormaliseC-45Eval-evalClosure arg-6 arg-0 arg-5 e-25) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((TTImpC-45Utils-n--12341-3589-u--findNamesM arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-11) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-12) (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7) (let ((e-2 (unbox e-12))) (lambda (eta-3) (vector 1 (box (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-8) (string-append "s" arg-8)) e-2)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))(else (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7)))))(else (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7)))))(else (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7)))))) eff-0) eta-0)))))) (TTImpC-45Utils-n--12341-3592-u--namesFor arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-7)))))))))) ((8) (let ((e-13 (vector-ref arg-7 2))) (let ((u--defaultPos (box (cons "m" (cons "n" (cons "p" (cons "q" '()))))))) (let ((u--defaultInts (box (cons "i" (cons "j" (cons "k" (cons "l" '()))))))) (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-2) (TTImpC-45Utils-n--12341-3593-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-2)) eta-1)) (case (vector-ref e-13 0) ((13) (let ((e-0 (vector-ref e-13 1))) (cond ((equal? e-0 0) u--defaultInts) ((equal? e-0 1) u--defaultInts) ((equal? e-0 2) u--defaultInts) ((equal? e-0 3) u--defaultInts) ((equal? e-0 4) u--defaultInts) ((equal? e-0 5) u--defaultInts) ((equal? e-0 6) u--defaultPos) ((equal? e-0 7) u--defaultPos) ((equal? e-0 8) u--defaultPos) ((equal? e-0 9) u--defaultPos) ((equal? e-0 10) (box (cons "str" '()))) ((equal? e-0 11) (box (cons "c" (cons "d" '())))) ((equal? e-0 12) (box (cons "dbl" '()))) ((equal? e-0 13) (box (cons "wrld" (cons "w" '()))))(else '()))))(else '())))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45Utils-n--12341-3588-u--findNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 ((TTImpC-45Utils-n--12341-3589-u--findNamesM arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (TTImpC-45Utils-n--12341-3593-u--notBound arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 eta-1)) (DataC-45Maybe-fromMaybe (lambda () (TTImpC-45Utils-n--12341-3587-u--defaultNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6)) e-5)))))) eff-0) ext-0)))))))
(define TTImpC-45Utils-n--12251-3499-u--mkVarN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 0) arg-5)(else (string-append arg-5 (PreludeC-45Show-u--show_Show_Int arg-6))))))
(define TTImpC-45Utils-unique (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-0) (TTImpC-45Utils-unique arg-1 arg-1 (bs+ arg-2 1 63) arg-3) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((u--var (TTImpC-45Utils-n--12251-3499-u--mkVarN e-2 e-3 arg-3 arg-2 arg-1 e-2 arg-2))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 (vector 1 (vector 0 u--var)) arg-3))) (cond ((equal? sc1 1) (TTImpC-45Utils-unique e-3 arg-1 arg-2 arg-3)) (else u--var)))))))))
(define TTImpC-45Utils-n--12341-3590-u--getName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-7 0) ((1) (let ((e-0 (vector-ref arg-7 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (let ((u--candidate (let ((sc2 (LibrariesC-45UtilsC-45String-lowerFirst e-1))) (cond ((equal? sc2 1) e-1) (else (DataC-45String-toLower e-1)))))) (TTImpC-45Utils-unique (cons u--candidate arg-8) (cons u--candidate arg-8) 0 arg-9))))(else (TTImpC-45Utils-unique arg-8 arg-8 0 arg-9)))))(else (TTImpC-45Utils-unique arg-8 arg-8 0 arg-9)))))
(define TTImpC-45Utils-getArgName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (TTImpC-45Utils-n--12341-3588-u--findNames arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-6 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (TTImpC-45Utils-n--12341-3590-u--getName arg-0 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-3 e-5 arg-5))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--13276-3225-u--continue (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (set-box! arg-3 arg-5))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (set-box! arg-4 arg-6))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-4 arg-3 arg-7) ext-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-firstSuccess (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (if (null? arg-3) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-3 (e-2 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (TTImpC-45InteractiveC-45ExprSearch-n--13276-3225-u--continue e-2 e-3 arg-2 arg-1 e-5 e-6 e-3 clam-1) (let ((e-8 (car e-7))) (let ((e-4 (cdr e-7))) (vector 1 (cons e-8 (lambda (eta-3) (TTImpC-45InteractiveC-45ExprSearch-n--13276-3225-u--continue e-2 e-3 arg-2 arg-1 e-5 e-6 (cons e-4 e-3) eta-3)))))))))) eff-0) eta-2)))))) (lambda (u--err) (lambda (clam-2) (case (vector-ref u--err 0) ((65) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-2))(else (TTImpC-45InteractiveC-45ExprSearch-n--13276-3225-u--continue e-2 e-3 arg-2 arg-1 e-5 e-6 e-3 clam-2))))) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))
(define TTImpC-45Utils-case--nameNum-3170 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cond ((equal? e-2 "") (cons arg-0 '()))(else (let ((sc1 (PreludeC-45Types-fastUnpack e-3))) (if (null? sc1) (cons arg-0 '()) (let ((e-1 (car sc1))) (let ((e-4 (cdr sc1))) (cond ((equal? e-1 #\_) (cons (string-reverse (PreludeC-45Types-fastPack e-4)) (box (cast-string-boundedInt (string-reverse e-2) 63))))(else (cons arg-0 '())))))))))))))
(define TTImpC-45Utils-nameNum (lambda (arg-0) (TTImpC-45Utils-case--nameNum-3170 arg-0 (DataC-45String-span (lambda (eta-0) (PreludeC-45Types-isDigit eta-0)) (string-reverse arg-0)))))
(define TTImpC-45Utils-nextNameNum (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (cons e-2 (box (PreludeC-45Types-maybe (lambda () (blodwen-toSignedInt 0 63)) (lambda () (lambda (arg-1) (bs+ (blodwen-toSignedInt 1 63) arg-1 63))) e-3)))))))
(define TTImpC-45Utils-unNameNum (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (if (null? e-3) e-2 (let ((e-6 (unbox e-3))) (PreludeC-45Types-fastConcat (cons e-2 (cons "_" (cons (PreludeC-45Show-u--show_Show_Int e-6) '()))))))))))
(define TTImpC-45Utils-n--12075-3311-u--next (lambda (arg-0 arg-1 arg-2 ext-0) (TTImpC-45Utils-unNameNum (TTImpC-45Utils-nextNameNum (TTImpC-45Utils-nameNum ext-0)))))
(define TTImpC-45Utils-n--12075-3312-u--usedName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-lookupTyName (vector 1 (vector 0 arg-0)) (let ((e-0 (vector-ref arg-2 0))) e-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (if (null? e-5) (PreludeC-45Types-elem csegen-14 csegen-22 arg-0 arg-1) 1))))) eff-0) ext-0)))))))
(define TTImpC-45Utils-uniqueBasicName (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (TTImpC-45Utils-n--12075-3312-u--usedName arg-2 arg-1 arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (TTImpC-45Utils-uniqueBasicName arg-0 arg-1 (TTImpC-45Utils-n--12075-3311-u--next arg-2 arg-1 arg-0 arg-2) clam-0)) (else (vector 1 arg-2)))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-getSuccessful (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 ((TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-1 arg-3 arg-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (clam-0) (let ((sc2 (cond ((equal? arg-7 1) (let ((e-0 (vector-ref arg-6 0))) e-0)) (else 0)))) (cond ((equal? sc2 1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--base (PreludeC-45Types-maybe (lambda () "arg") (lambda () (lambda (u--r) (string-append (CoreC-45Name-nameRoot (let ((e-1 (vector-ref u--r 1))) e-1)) "_rhs"))) (let ((e-2 (vector-ref arg-6 2))) e-2)))) (lambda (eta-0) (let ((act-3 (TTImpC-45Utils-uniqueBasicName e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45Name-nameRoot eta-1)) arg-0) u--base eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45UnifyState-newMeta arg-0 arg-1 arg-3 arg-4 arg-5 arg-8 (vector 1 (vector 0 e-7)) arg-9 (vector 7 (CoreC-45Env-length arg-8) (CoreC-45ContextC-45Context-holeInit 0)) 0) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-3 (cdr e-8))) (TTImpC-45InteractiveC-45ExprSearch-one (cons e-3 '()) clam-1))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) clam-0)))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0))))) (lambda (eta-0) (vector 1 e-5))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--12576-2626-u--usableName (lambda (arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((1) 1)(else 0))))
(define TTImpC-45InteractiveC-45ExprSearch-getAllEnv (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-8 (car arg-4))) (let ((e-9 (cdr arg-4))) (let ((u--rest (TTImpC-45InteractiveC-45ExprSearch-getAllEnv e-3 arg-2 (LibrariesC-45DataC-45ListC-45SizeOf-sucR arg-3) e-9))) (let ((u--usable (TTImpC-45InteractiveC-45ExprSearch-n--12576-2626-u--usableName e-2 e-3 e-9 e-8 arg-3 arg-2 e-2))) (cond ((equal? u--usable 1) (cons (cons (vector 0 arg-2 '() arg-3) (let ((sc3 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-4 (cdr sc3))) ((((e-4 'erased) 'erased) (LibrariesC-45DataC-45ListC-45SizeOf-sucR arg-3)) (CoreC-45TTC-45Binder-binderType e-8))))) u--rest)) (else u--rest)))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-mkCandidates (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-one (cons arg-4 arg-5) eta-0)) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (if (null? e-2) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-12 (car e-8))) (let ((e-13 (cdr e-8))) (TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-1 arg-2 (cons (TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-1 arg-2 arg-3 (vector 4 arg-3 arg-4 e-12) (PreludeC-45TypesC-45List-tailRecAppend arg-5 e-13) e-3) (cons (lambda (eta-0) (let ((act-1 (e-9 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (cons e-5 e-3)))) eff-0) eta-0)))))) '())))))))))))))
(define LibrariesC-45DataC-45Tap-traverse (lambda (arg-3 arg-4 arg-5) (if (null? arg-5) (let ((e-1 (vector-ref arg-3 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) '()))) (let ((e-4 (car arg-5))) (let ((e-5 (cdr arg-5))) (let ((e-2 (vector-ref arg-3 1))) ((((e-2 'erased) 'erased) (arg-4 e-4)) (lambda (bind-0) (let ((e-8 (vector-ref arg-3 0))) (let ((e-10 (vector-ref e-8 1))) ((e-10 'erased) (cons bind-0 (let ((e-13 (vector-ref arg-3 1))) ((((e-13 'erased) 'erased) e-5) (lambda (eta-0) (LibrariesC-45DataC-45Tap-traverse arg-3 arg-4 eta-0))))))))))))))))
(define CoreC-45CoreC-45Search-traverse (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Tap-traverse csegen-1005 ext-0 ext-1)))
(define TTImpC-45InteractiveC-45ExprSearch-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32searchIfHole-2918 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (case (vector-ref arg-16 0) ((7) (let ((act-1 (TTImpC-45InteractiveC-45ExprSearch-search arg-9 arg-8 arg-7 arg-6 arg-12 (let ((e-11 (vector-ref arg-5 0))) (let ((e-10 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 5))) (let ((e-6 (vector-ref arg-5 6))) (let ((e-7 (vector-ref arg-5 7))) (let ((e-8 (vector-ref arg-5 8))) (let ((e-9 (vector-ref arg-5 9))) (vector e-11 e-10 e-2 arg-10 1 e-5 e-6 e-7 e-8 e-9))))))))) arg-4 arg-3 (vector 8 arg-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45CoreC-45Search-traverse (lambda (lamc-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-9 arg-0 arg-13 arg-2 (CoreC-45UnifyState-applyTo arg-0 arg-6 e-2 arg-2) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-6 e-3))))) eff-0) clam-1))))))))) e-5))) eff-0) ext-0))))))(else (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-9 arg-0 arg-13 arg-2 (let ((e-4 (vector-ref arg-1 3))) e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-one (cons e-5 '()) eta-0)))) eff-0) ext-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchIfHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (let ((sc0 (let ((e-3 (vector-ref arg-5 3))) e-3))) (cond ((equal? sc0 0) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))(else (let ((e-0 (- (let ((e-3 (vector-ref arg-5 3))) e-3) 1))) (let ((u--hole (let ((e-1 (vector-ref arg-9 0))) e-1))) (let ((u--rig (let ((e-2 (vector-ref arg-9 1))) e-2))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (vector 8 u--hole) (let ((e-34 (vector-ref e-5 0))) e-34)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-2)) (let ((e-1 (unbox e-6))) (let ((_-0 (box e-1))) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32searchIfHole-2918 arg-0 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-0 u--hole u--rig e-5 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18) eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-usableLocal (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((1) (let ((e-2 (vector-ref arg-3 2))) (case (vector-ref e-2 0) ((2) 0)(else 1))))(else 1))))
(define TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 ext-0) (let ((act-1 ((CoreC-45AutoSearch-mkArgs arg-0 arg-14 arg-12 arg-11 arg-9 arg-6 arg-18) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (lambda (clam-0) (let ((sc2 (TTImpC-45InteractiveC-45ExprSearch-usableLocal arg-11 arg-6 arg-18))) (cond ((equal? sc2 1) (CoreC-45UnifyState-tryUnify arg-14 arg-12 (lambda (eta-0) (let ((act-2 (let ((sc3 (let ((sc4 (DataC-45List-isNil e-2))) (cond ((equal? sc4 1) 0) (else arg-10))))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Must apply function") eta-0)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-14 arg-12 CoreC-45Unify-inTerm arg-11) arg-6) arg-19) arg-18) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((e-0 (vector-ref e-7 0))) (if (null? e-0) (TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-14 arg-12 arg-11 (arg-17 arg-16) '() '()) (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't use directly") eta-1)))))) eff-0) eta-0))))))))) (lambda (eta-0) (let ((act-2 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-14 arg-12 CoreC-45Unify-inTerm arg-11) arg-6) arg-19) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((e-0 (vector-ref e-6 0))) (lambda (clam-1) (if (null? e-0) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-searchIfHole arg-0 arg-14 arg-13 arg-12 arg-11 arg-8 arg-7 arg-4 arg-6 eta-1)) e-2 '()) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-14 arg-12 arg-11 (arg-17 arg-16) '() e-8))) eff-0) clam-1))))) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-1)))))) eff-0) eta-0)))))) clam-0)) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--16159-5858-u--findPos (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19) (case (vector-ref arg-18 0) ((3) (let ((e-2 (vector-ref arg-18 2))) (let ((e-5 (vector-ref arg-18 5))) (if (null? e-5) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-7) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-11 (car e-7))) (let ((e-12 (cdr e-7))) (if (null? e-8) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-14 (car e-8))) (let ((e-15 (cdr e-8))) (if (null? e-14) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (let ((e-18 (car e-14))) (let ((e-19 (cdr e-14))) (lambda (clam-0) (if (null? e-15) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-14 arg-13 arg-12 arg-11 arg-9 arg-8 0 arg-6 arg-5 arg-4 (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0)) (cons (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-fstName arg-14 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (PreludeC-45Types-maybe (lambda () (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "No fst") eta-1))) (lambda () (lambda (eta-1) (lambda (eta-2) (vector 1 eta-1)))) e-6))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (CoreC-45Context-sndName arg-14 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (PreludeC-45Types-maybe (lambda () (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "No snd") eta-2))) (lambda () (lambda (eta-2) (lambda (eta-3) (vector 1 eta-2)))) e-9))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-9 (vector-ref act-2 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (CoreC-45Context-isPairType arg-14 e-2 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-10 1) (let ((act-4 (CoreC-45Context-clearDefs arg-15 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-14 arg-0 e-13 arg-6 e-12 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (CoreC-45NormaliseC-45Quote-u--quote_Quote_Closure arg-14 arg-0 e-13 arg-6 e-19 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-17 (vector-ref act-6 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-14 arg-13 arg-12 arg-11 arg-9 arg-8 0 arg-6 arg-5 arg-4 (cons (lambda (eta-6) (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-12) eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-20 (vector-ref act-7 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-7 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--16159-5858-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (lambda (u--arg) (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-11 (vector 1 ) e-6) (cons (cons e-11 e-16) (cons (cons e-18 e-17) (cons (cons arg-11 (arg-17 u--arg)) '()))))) e-20 arg-19))) eff-0) eta-6)))))) (cons (lambda (eta-6) (let ((act-7 ((CoreC-45NormaliseC-45Eval-evalClosure arg-14 arg-0 arg-15 e-19) eta-6))) (case (vector-ref act-7 0) ((0) (let ((e-20 (vector-ref act-7 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-7 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--16159-5858-u--findPos arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 (lambda (u--arg) (CoreC-45TTC-45Term-applyStackWithFC (vector 1 arg-11 (vector 1 ) e-9) (cons (cons e-11 e-16) (cons (cons e-18 e-17) (cons (cons arg-11 (arg-17 u--arg)) '()))))) e-20 arg-19))) eff-0) eta-6)))))) '())) eta-5)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) clam-1)))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-1)))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) '())) clam-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 clam-0))))))))))))))))))(else (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-n--16159-5857-u--findDirect arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 eta-0))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchLocalWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (lambda (clam-0) (if (null? arg-10) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-checkTimer arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-9 arg-11) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-9 e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 0 arg-9 arg-11 arg-12 (cons (TTImpC-45InteractiveC-45ExprSearch-n--16159-5858-u--findPos arg-0 e-6 e-7 e-3 arg-12 arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 (lambda (eta-3) eta-3) e-10 e-9) (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocalWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3 arg-11 arg-12) '())) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (TTImpC-45InteractiveC-45ExprSearch-searchLocalWith arg-0 arg-1 arg-2 arg-3 arg-4 0 arg-5 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45List-reverse (TTImpC-45InteractiveC-45ExprSearch-getAllEnv arg-0 arg-4 0 arg-8)) arg-9 arg-10)))
(define TTImpC-45InteractiveC-45ExprSearch-explicit (lambda (arg-1) (let ((e-3 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((1) 1)(else 0)))))
(define CoreC-45Unify-inSearch (cons 1 3))
(define TTImpC-45InteractiveC-45ExprSearch-n--13757-3712-u--usableName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((1) 1) ((0) (let ((e-2 (vector-ref arg-13 2))) (TTImpC-45InteractiveC-45ExprSearch-n--13757-3712-u--usableName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-2))) ((5) (let ((e-4 (vector-ref arg-13 2))) (TTImpC-45InteractiveC-45ExprSearch-n--13757-3712-u--usableName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-4)))(else 0))))
(define TTImpC-45InteractiveC-45ExprSearch-searchName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-checkTimer arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 (CoreC-45Context-getNS arg-1 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-getNestedNS arg-1 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((sc5 (CoreC-45Context-visibleInAny (cons e-7 e-8) (let ((e-1 (vector-ref e-3 1))) e-1) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-3 9))) e-9))))) (cond ((equal? sc5 1) (let ((u--ty (let ((e-28 (vector-ref e-3 2))) e-28))) (let ((sc6 (TTImpC-45InteractiveC-45ExprSearch-n--13757-3712-u--usableName arg-0 e-2 e-3 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-1 (vector-ref e-3 1))) e-1)))) (cond ((equal? sc6 1) (let ((u--namety (let ((e-18 (vector-ref e-3 18))) (case (vector-ref e-18 0) ((5) (let ((e-31 (vector-ref e-18 1))) (let ((e-30 (vector-ref e-18 2))) (vector 2 e-31 e-30)))) ((6) (let ((e-36 (vector-ref e-18 1))) (let ((e-35 (vector-ref e-18 2))) (vector 3 e-36 e-35))))(else (vector 1 )))))) (lambda (eta-2) (let ((act-5 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" 5 (lambda () (string-append "Trying " (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref e-3 1))) e-1)))) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((act-6 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 u--ty) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 ((CoreC-45AutoSearch-mkArgs arg-0 arg-1 arg-3 arg-4 arg-5 arg-8 e-10) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-12 (car e-11))) (let ((e-4 (cdr e-11))) (let ((act-8 (CoreC-45Normalise-logNF arg-0 arg-1 "interaction.search" 5 (lambda () "Target") arg-8 arg-9 clam-1))) (case (vector-ref act-8 0) ((0) (let ((e-13 (vector-ref act-8 1))) (vector 0 e-13))) (else (let ((act-9 (CoreC-45Normalise-logNF arg-0 arg-1 "interaction.search" 10 (lambda () "App type") arg-8 e-4 clam-1))) (case (vector-ref act-9 0) ((0) (let ((e-14 (vector-ref act-9 1))) (vector 0 e-14))) (else (let ((act-10 (((((CoreC-45Unify-unify (csegen-2479) arg-0 arg-1 arg-3 CoreC-45Unify-inSearch arg-4) arg-8) arg-9) e-4) clam-1))) (case (vector-ref act-10 0) ((0) (let ((e-15 (vector-ref act-10 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-10 1))) ((let ((eff-0 (let ((e-0 (vector-ref e-15 0))) (lambda (clam-0) (if (null? e-0) (let ((act-11 ((CoreC-45Core-traverse_ (lambda (eta-4) (TTImpC-45InteractiveC-45ExprSearch-searchIfHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-10 arg-8 eta-4)) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-4) (TTImpC-45InteractiveC-45ExprSearch-explicit eta-4)) e-12)) clam-0))) (case (vector-ref act-11 0) ((0) (let ((e-18 (vector-ref act-11 1))) (vector 0 e-18))) (else (let ((act-12 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (TTImpC-45InteractiveC-45ExprSearch-searchIfHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-10 arg-8 eta-4)) e-12 '()) clam-0))) (case (vector-ref act-12 0) ((0) (let ((e-19 (vector-ref act-12 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-12 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-mkCandidates arg-0 arg-1 arg-3 arg-4 (vector 1 arg-4 u--namety e-2) '() e-19))) eff-0) clam-0)))))))) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)))))) eff-0) clam-1)))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))))))(else (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-2)))))))(else (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--14822-4641-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-15 arg-13) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc2 (CoreC-45Context-visibleInAny arg-14 arg-15 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-1 9))) e-9))))) (cond ((equal? sc2 1) (vector 1 (box (cons arg-15 e-1)))) (else (vector 1 '()))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (lambda (clam-0) (if (null? arg-11) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-checkTimer arg-1 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--14822-4641-u--visible arg-0 e-2 e-3 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-0 (vector-ref e-5 0))) e-0) (cons (let ((e-36 (vector-ref e-5 2))) e-36) (let ((e-35 (vector-ref e-5 3))) e-35)) eta-1 eta-2))) (cons e-2 e-3) '()) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--visns (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-1) eta-1) e-7))) (lambda (eta-1) (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 arg-9) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "interaction.search" 10 (lambda () (string-append "Searching " (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (Builtin-fst eta-3)) u--visns)) " for "))) arg-9 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-8 arg-9 arg-10 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (lambda (eta-4) (TTImpC-45InteractiveC-45ExprSearch-searchName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-8 arg-10 eta-3 eta-4))) u--visns) eta-2))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))) eff-0) clam-0)))))))))))
(define CoreC-45Context-startTimer (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-getTime ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-34 (vector-ref e-6 5))) (let ((e-33 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-0 e-1 e-2 e-3 e-4 e-34 e-33 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 (box (cons (+ e-5 (* arg-1 1000000)) arg-2)) e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--11723-1799-u--count (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) csegen-3814 (cond ((equal? arg-5 0) csegen-3814)(else (let ((e-0 (- arg-5 1))) (cond ((equal? e-0 0) (lambda (clam-0) (if (null? arg-6) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (let ((act-1 (let ((act-1 (e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--11723-1799-u--count arg-1 arg-2 arg-3 arg-4 e-0 e-5))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((e-6 (cdr e-5))) (vector 1 (cons (cons e-3 e-2) e-6))))))) eff-0) clam-0))))))) (let ((e-7 (car arg-6))) (let ((e-8 (cdr arg-6))) (vector 1 (cons (cons e-7 '()) e-8)))))))(else (lambda (clam-2) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (let ((act-1 (let ((act-1 (e-4 clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--11723-1799-u--count arg-1 arg-2 arg-3 arg-4 e-0 e-5))) eff-0) clam-2))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (let ((e-2 (car e-5))) (let ((e-6 (cdr e-5))) (vector 1 (cons (cons e-3 e-2) e-6))))))) eff-0) clam-2))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchN (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Context-startTimer arg-1 (let ((e-6 (vector-ref e-5 6))) e-6) "expression search" eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (CoreC-45UnifyState-tryUnify arg-1 arg-2 (lambda (eta-0) (let ((act-2 (arg-4 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45InteractiveC-45ExprSearch-n--11723-1799-u--count arg-4 arg-3 arg-2 arg-1 arg-3 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-clearTimer arg-1) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (eta-0) (let ((act-2 ((CoreC-45Context-clearTimer arg-1) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else csegen-3813)))) ext-0))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--17293-6874-u--toApp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-14) (case (vector-ref arg-14 0) ((2) (let ((e-1 (vector-ref arg-14 1))) (let ((e-3 (vector-ref arg-14 3))) (let ((e-4 (vector-ref arg-14 4))) (CoreC-45TTC-45Term-apply e-1 (vector 1 e-1 (vector 1 ) (vector 8 e-3)) e-4)))))(else arg-14))))
(define TTImpC-45InteractiveC-45ExprSearch-makeHelper (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (vector 1 '())) (let ((e-4 (car arg-10))) (let ((e-5 (cdr arg-10))) (let ((e-8 (car e-4))) (let ((e-9 (cdr e-4))) (let ((sc2 (let ((e-3 (vector-ref arg-6 3))) e-3))) (cond ((equal? sc2 0) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)))(else (let ((e-0 (- (let ((e-3 (vector-ref arg-6 3))) e-3) 1))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "interaction.search" 10 (lambda () "Local app") e-8 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref arg-6 9))) (if (null? e-10) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0) (let ((e-16 (unbox e-10))) (let ((act-2 (CoreC-45UnifyState-genVarName arg-1 arg-3 "cval" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-17 (vector-ref act-2 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45UnifyState-genCaseName arg-1 arg-3 "search" eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-18 (vector-ref act-3 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Context-inCurrentNS arg-1 e-18 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-19 (vector-ref act-4 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--envC-39 (cons (vector 0 arg-4 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) arg-8) arg-7))) (lambda (eta-3) (let ((act-5 (TTImpC-45ElabC-45Check-metaVar (cons e-17 arg-0) arg-1 arg-3 arg-4 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega u--envC-39 e-19 (let ((sc7 CoreC-45TTC-45Term-WeakenTerm)) (let ((e-21 (car sc7))) (((e-21 'erased) 'erased) arg-9))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-20 (vector-ref act-5 1))) (vector 0 e-20))) (else (let ((e-20 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--scope (TTImpC-45InteractiveC-45ExprSearch-n--17293-6874-u--toApp arg-0 e-8 e-9 e-5 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-20))) (lambda (eta-4) (let ((act-6 (CoreC-45Context-updateDef arg-1 e-19 (lambda (eta-5) (box (vector 0 ))) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-21 (vector-ref act-6 1))) (vector 0 e-21))) (else (let ((u--def (vector 4 arg-4 (vector 3 arg-4 e-17 (vector 0 arg-4 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) arg-8) u--scope) e-8))) (let ((act-7 (CoreC-45Normalise-logTermNF arg-0 arg-1 "interaction.search" 10 (lambda () "Binding def") arg-7 u--def eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-22 (vector-ref act-7 1))) (vector 0 e-22))) (else (let ((act-8 (let ((act-8 (unbox arg-1))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-23 (vector-ref act-8 1))) (vector 0 e-23))) (else (let ((e-23 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (CoreC-45Context-lookupTyExact e-19 (let ((e-56 (vector-ref e-23 0))) e-56) eta-5))) (case (vector-ref act-9 0) ((0) (let ((e-24 (vector-ref act-9 1))) (vector 0 e-24))) (else (let ((e-24 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-24) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Can't happen") clam-0) (let ((e-25 (unbox e-24))) (let ((act-10 (CoreC-45Normalise-logTermNF '() arg-1 "interaction.search" 10 (lambda () "Type of scope name") '() e-25 clam-0))) (case (vector-ref act-10 0) ((0) (let ((e-26 (vector-ref act-10 1))) (vector 0 e-26))) (else (let ((act-11 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-1 arg-3 1 ((((e-16 (let ((e-36 (vector-ref arg-6 0))) (let ((e-34 (vector-ref arg-6 2))) (let ((e-32 (vector-ref arg-6 4))) (let ((e-28 (vector-ref arg-6 8))) (let ((e-27 (vector-ref arg-6 9))) (vector e-36 0 e-34 e-0 e-32 1 0 1 e-28 e-27))))))) e-19) 0) e-25) clam-0))) (case (vector-ref act-11 0) ((0) (let ((e-27 (vector-ref act-11 1))) (vector 0 e-27))) (else (let ((e-27 (vector-ref act-11 1))) ((let ((eff-0 (if (null? e-27) (lambda (eta-6) (let ((act-12 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" 10 (lambda () "No results") eta-6))) (case (vector-ref act-12 0) ((0) (let ((e-28 (vector-ref act-12 1))) (vector 0 e-28))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult eta-6))))) (let ((e-29 (car e-27))) (if (null? e-29) (lambda (eta-6) (let ((act-12 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" 10 (lambda () "No results") eta-6))) (case (vector-ref act-12 0) ((0) (let ((e-30 (vector-ref act-12 1))) (vector 0 e-30))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult eta-6))))) (let ((e-31 (car e-29))) (let ((u--helperdef (vector 2 arg-4 e-19 (Builtin-snd e-31)))) (lambda (eta-6) (let ((act-12 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" 10 (lambda () (string-append "Def: " (TTImpC-45TTImp-u--show_Show_C-40ImpDeclC-39C-32C-36nmC-41 csegen-65 u--helperdef))) eta-6))) (case (vector-ref act-12 0) ((0) (let ((e-32 (vector-ref act-12 1))) (vector 0 e-32))) (else (vector 1 (cons (cons u--def (cons u--helperdef e-9)) (lambda (eta-7) (let ((act-13 (e-5 eta-7))) (case (vector-ref act-13 0) ((0) (let ((e-33 (vector-ref act-13 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-13 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-makeHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-33))) eff-0) eta-7))))))))))))))))))) eff-0) clam-0))))))))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))))))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--18116-7592-u--matchable (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (lambda (clam-0) (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-14) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-6 (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--18116-7592-u--matchable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5))) eff-0) clam-0))))))(else (vector 1 0))))))) ((3) (vector 1 1))(else (vector 1 0))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--18116-7591-u--applyLocal (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-16 0) ((0) (let ((e-3 (vector-ref arg-16 3))) (let ((e-4 (vector-ref arg-16 4))) (lambda (clam-0) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((act-1 (let ((act-1 (((e-4 arg-14) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-6 (vector 10 arg-10 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--18116-7592-u--matchable arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 e-5))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-5 1) (let ((act-2 (CoreC-45UnifyState-genVarName arg-13 arg-11 "cty" clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (TTImpC-45ElabC-45Check-uniVar arg-13 arg-11 arg-10 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-13 arg-11 e-6 csegen-30 arg-6 e-10 (vector 11 arg-10 e-11) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--optsC-39 (let ((e-0 (vector-ref arg-8 0))) (let ((e-21 (vector-ref arg-8 1))) (let ((e-20 (vector-ref arg-8 2))) (let ((e-19 (vector-ref arg-8 3))) (let ((e-18 (vector-ref arg-8 4))) (let ((e-16 (vector-ref arg-8 6))) (let ((e-15 (vector-ref arg-8 7))) (let ((e-14 (vector-ref arg-8 8))) (let ((e-13 (vector-ref arg-8 9))) (vector e-0 e-21 e-20 e-19 e-18 1 e-16 e-15 e-14 e-13)))))))))))) (lambda (eta-2) (let ((act-5 ((TTImpC-45InteractiveC-45ExprSearch-searchLocalWith arg-0 arg-13 arg-12 arg-11 arg-10 1 arg-9 u--optsC-39 arg-7 arg-6 (cons (cons arg-1 arg-2) '()) e-12 arg-4) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-makeHelper arg-0 arg-13 arg-12 arg-11 arg-10 arg-9 arg-8 arg-6 e-12 arg-17 e-13))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1)))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-1)))))) eff-0) clam-0)))))))(else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)))))))(else (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0))))))
(define TTImpC-45InteractiveC-45ExprSearch-tryIntermediateWith (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (lambda (clam-0) (if (null? arg-9) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (car arg-9))) (let ((e-3 (cdr arg-9))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 e-7) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-8 arg-10 arg-11 (cons (TTImpC-45InteractiveC-45ExprSearch-n--18116-7591-u--applyLocal arg-0 e-6 e-7 e-3 arg-11 arg-10 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-6 e-8 arg-10) (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3 arg-10 arg-11) '())) eta-1)))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-tryIntermediate (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateWith arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (PreludeC-45TypesC-45List-reverse (TTImpC-45InteractiveC-45ExprSearch-getAllEnv arg-0 arg-4 0 arg-8)) arg-9 arg-10)))
(define LibrariesC-45DataC-45Tap-filter (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (let ((e-1 (vector-ref arg-2 0))) (let ((e-5 (vector-ref e-1 1))) ((e-5 'erased) '()))) (let ((e-4 (car arg-4))) (let ((e-5 (cdr arg-4))) (let ((u--mxs (let ((e-2 (vector-ref arg-2 1))) ((((e-2 'erased) 'erased) e-5) (lambda (eta-0) (LibrariesC-45DataC-45Tap-filter arg-2 arg-3 eta-0)))))) (let ((sc1 (arg-3 e-4))) (cond ((equal? sc1 1) (let ((e-1 (vector-ref arg-2 0))) (let ((e-7 (vector-ref e-1 1))) ((e-7 'erased) (cons e-4 u--mxs))))) (else u--mxs)))))))))
(define CoreC-45CoreC-45Search-filter (lambda (ext-0 ext-1) (LibrariesC-45DataC-45Tap-filter csegen-1005 ext-0 ext-1)))
(define TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) (case (vector-ref arg-14 0) ((0) 0) ((1) (let ((e-50 (vector-ref arg-14 3))) (case (vector-ref arg-15 0) ((1) (let ((e-59 (vector-ref arg-15 3))) (CoreC-45Name-u--C-47C-61_Eq_Name e-50 e-59)))(else (case (vector-ref arg-15 0) ((3) 0)(else (case (vector-ref arg-14 0) ((4) (let ((e-21 (vector-ref arg-14 2))) (let ((e-22 (vector-ref arg-14 3))) (case (vector-ref arg-15 0) ((4) (let ((e-31 (vector-ref arg-15 2))) (let ((e-32 (vector-ref arg-15 3))) (let ((sc3 (TTImpC-45InteractiveC-45ExprSearch-n--15199-4977-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-21 e-31))) (cond ((equal? sc3 1) 1) (else (TTImpC-45InteractiveC-45ExprSearch-n--15199-4977-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-22 e-32)))))))(else (case (vector-ref arg-15 0) ((10) 0)(else (case (vector-ref arg-14 0) ((11) (case (vector-ref arg-15 0) ((11) 0)(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))) ((5) (let ((e-12 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-12 arg-15)))(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))))))))) ((9) (let ((e-25 (vector-ref arg-14 2))) (case (vector-ref arg-15 0) ((9) (let ((e-35 (vector-ref arg-15 2))) (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-25 e-35)))(else (case (vector-ref arg-15 0) ((10) 0)(else (case (vector-ref arg-14 0) ((11) (case (vector-ref arg-15 0) ((11) 0)(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))) ((5) (let ((e-12 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-12 arg-15)))(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1)))))))))) ((10) 0)(else (case (vector-ref arg-15 0) ((10) 0)(else (case (vector-ref arg-14 0) ((11) (case (vector-ref arg-15 0) ((11) 0)(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))) ((5) (let ((e-12 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-12 arg-15)))(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1)))))))))))))) ((3) 0)(else (case (vector-ref arg-15 0) ((3) 0)(else (case (vector-ref arg-14 0) ((4) (let ((e-21 (vector-ref arg-14 2))) (let ((e-22 (vector-ref arg-14 3))) (case (vector-ref arg-15 0) ((4) (let ((e-31 (vector-ref arg-15 2))) (let ((e-32 (vector-ref arg-15 3))) (let ((sc2 (TTImpC-45InteractiveC-45ExprSearch-n--15199-4977-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-21 e-31))) (cond ((equal? sc2 1) 1) (else (TTImpC-45InteractiveC-45ExprSearch-n--15199-4977-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-22 e-32)))))))(else (case (vector-ref arg-15 0) ((10) 0)(else (case (vector-ref arg-14 0) ((11) (case (vector-ref arg-15 0) ((11) 0)(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))) ((5) (let ((e-12 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-12 arg-15)))(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))))))))) ((9) (let ((e-25 (vector-ref arg-14 2))) (case (vector-ref arg-15 0) ((9) (let ((e-35 (vector-ref arg-15 2))) (CoreC-45TTC-45Primitive-u--C-47C-61_Eq_Constant e-25 e-35)))(else (case (vector-ref arg-15 0) ((10) 0)(else (case (vector-ref arg-14 0) ((11) (case (vector-ref arg-15 0) ((11) 0)(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))) ((5) (let ((e-12 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-12 arg-15)))(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1)))))))))) ((10) 0)(else (case (vector-ref arg-15 0) ((10) 0)(else (case (vector-ref arg-14 0) ((11) (case (vector-ref arg-15 0) ((11) 0)(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))) ((5) (let ((e-12 (vector-ref arg-14 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-12 arg-15)))(else (case (vector-ref arg-15 0) ((5) (let ((e-4 (vector-ref arg-15 4))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-4)))(else 1))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--15199-4975-u--appsDiff (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15 arg-16 arg-17) (case (vector-ref arg-14 0) ((1) (let ((e-4 (vector-ref arg-14 2))) (let ((e-5 (vector-ref arg-14 3))) (case (vector-ref e-4 0) ((2) (case (vector-ref arg-15 0) ((1) (let ((e-30 (vector-ref arg-15 2))) (let ((e-31 (vector-ref arg-15 3))) (case (vector-ref e-30 0) ((2) (let ((sc4 (CoreC-45Name-u--C-47C-61_Eq_Name e-5 e-31))) (cond ((equal? sc4 1) 1) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))))))(else (case (vector-ref arg-15 0) ((1) (let ((e-23 (vector-ref arg-15 3))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc4 1) (let ((sc5 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-16) (PreludeC-45TypesC-45List-lengthTR arg-17)) 1) 0))) (cond ((equal? sc5 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-15 0) ((0) 1)(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))))))))(else (case (vector-ref arg-15 0) ((1) (let ((e-23 (vector-ref arg-15 3))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc3 1) (let ((sc4 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-16) (PreludeC-45TypesC-45List-lengthTR arg-17)) 1) 0))) (cond ((equal? sc4 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-15 0) ((0) 1)(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0)))))))) ((3) (case (vector-ref arg-15 0) ((1) (let ((e-36 (vector-ref arg-15 2))) (let ((e-37 (vector-ref arg-15 3))) (case (vector-ref e-36 0) ((3) (let ((sc4 (CoreC-45Name-u--C-47C-61_Eq_Name e-5 e-37))) (cond ((equal? sc4 1) 1) (else (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))))))(else (case (vector-ref arg-15 0) ((1) (let ((e-23 (vector-ref arg-15 3))) (let ((sc4 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc4 1) (let ((sc5 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-16) (PreludeC-45TypesC-45List-lengthTR arg-17)) 1) 0))) (cond ((equal? sc5 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-15 0) ((0) 1)(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))))))))(else (case (vector-ref arg-15 0) ((1) (let ((e-23 (vector-ref arg-15 3))) (let ((sc3 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc3 1) (let ((sc4 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-16) (PreludeC-45TypesC-45List-lengthTR arg-17)) 1) 0))) (cond ((equal? sc4 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-15 0) ((0) 1)(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))))))(else (case (vector-ref arg-15 0) ((1) (let ((e-23 (vector-ref arg-15 3))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-5 e-23))) (cond ((equal? sc2 1) (let ((sc3 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-16) (PreludeC-45TypesC-45List-lengthTR arg-17)) 1) 0))) (cond ((equal? sc3 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (PreludeC-45Basics-uncurry (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 eta-1 eta-2))) eta-0)) (DataC-45List-u--zip_Zippable_List arg-16 arg-17))) (else 0)))) (else 0)))))(else (case (vector-ref e-4 0) ((2) (case (vector-ref arg-15 0) ((0) 1)(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0)))))))))) ((0) (case (vector-ref arg-15 0) ((1) (let ((e-42 (vector-ref arg-15 2))) (case (vector-ref e-42 0) ((2) 1)(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0)))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0))))(else (if (null? arg-16) (if (null? arg-17) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4976-u--argDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) 0) 0)))))
(define TTImpC-45InteractiveC-45ExprSearch-n--15199-4977-u--structDiff (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-14))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (CoreC-45TTC-45Term-getFnArgs arg-15))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4975-u--appsDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 e-2 e-5 e-3 e-4)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--15199-4978-u--structDiffTm (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 arg-15) (let ((e-2 (car arg-15))) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4977-u--structDiff arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-14 e-2))))
(define TTImpC-45InteractiveC-45ExprSearch-tryRecursive (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtExact (let ((e-1 (vector-ref arg-11 1))) e-1) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (unbox e-6))) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 arg-9) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-searchName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-12 (vector-ref arg-6 5))) (let ((e-11 (vector-ref arg-6 6))) (let ((e-10 (vector-ref arg-6 7))) (let ((e-8 (vector-ref arg-6 8))) (let ((e-9 (vector-ref arg-6 9))) (vector e-0 e-1 '() e-3 e-4 e-12 e-11 e-10 e-8 e-9)))))))))) arg-7 arg-8 e-7 arg-10 (cons (let ((e-1 (vector-ref arg-11 1))) e-1) e-2) eta-1)))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45CoreC-45Search-traverse (lambda (lamc-0) (lambda (clam-1) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-4 (CoreC-45Context-toFullNames arg-1 csegen-68 e-4 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons e-8 e-3))))) eff-0) clam-1))))))))) e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45CoreC-45Search-filter (lambda (eta-2) (TTImpC-45InteractiveC-45ExprSearch-n--15199-4978-u--structDiffTm arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (let ((e-3 (vector-ref arg-11 2))) e-3) eta-2)) e-8))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--18683-8091-u--isSingleCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (lambda (clam-0) (case (vector-ref arg-13 0) ((0) (let ((e-1 (vector-ref arg-13 1))) (let ((e-3 (vector-ref arg-13 3))) (let ((e-4 (vector-ref arg-13 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-12) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--18683-8091-u--isSingleCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-5))) eff-0) clam-0))))))(else (vector 1 0))))))) ((3) (let ((e-7 (vector-ref arg-13 2))) (let ((act-1 (CoreC-45Context-lookupDefExact e-7 (let ((e-0 (vector-ref arg-12 0))) e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 0)) (let ((e-1 (unbox e-5))) (case (vector-ref e-1 0) ((6) (let ((e-12 (vector-ref e-1 7))) (lambda (clam-1) (if (null? e-12) (vector 1 0) (let ((e-16 (cdr e-12))) (if (null? e-16) (vector 1 1) (vector 1 0)))))))(else (lambda (eta-0) (vector 1 0)))))))) eff-0) clam-0)))))))(else (vector 1 0))))))
(define TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (lambda (clam-0) (if (null? arg-11) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0) (let ((e-2 (unbox arg-11))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyExact (let ((e-1 (vector-ref e-2 1))) e-1) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-1) (let ((e-1 (unbox e-6))) (let ((act-3 (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-1 '() e-5 '() e-1) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-n--18683-8091-u--isSingleCon arg-0 e-2 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 e-7))) eff-0) clam-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-7 1) (let ((act-4 (CoreC-45UnifyState-genVarName arg-1 arg-3 "cty" clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (TTImpC-45ElabC-45Check-uniVar arg-1 arg-3 arg-4 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (TTImpC-45ElabC-45Check-metaVar arg-0 arg-1 arg-3 arg-4 csegen-30 arg-8 e-8 (vector 11 arg-4 e-9) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--optsC-39 (let ((e-0 (vector-ref arg-6 0))) (let ((e-17 (vector-ref arg-6 1))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-14 (vector-ref arg-6 6))) (let ((e-13 (vector-ref arg-6 7))) (let ((e-12 (vector-ref arg-6 8))) (let ((e-11 (vector-ref arg-6 9))) (vector e-0 e-17 '() e-3 e-4 1 e-14 e-13 e-12 e-11))))))))))) (lambda (eta-3) (let ((act-7 (CoreC-45ContextC-45Log-logTerm arg-0 arg-1 "interaction.search" 10 (lambda () "Trying recursive search for") arg-9 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((act-8 (CoreC-45ContextC-45Log-unverifiedLogC arg-1 "interaction.search" 10 (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-5) (case (vector-ref eta-5 0) ((0) (let ((e-3 (vector-ref eta-5 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref eta-5 1))) (vector 1 (CoreC-45Name-u--show_Show_Name e-12)))))) (lambda (eta-5) (CoreC-45Context-toFullNames arg-1 csegen-54 (let ((e-4 (vector-ref e-2 1))) e-4) eta-5)) eta-4)) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-3 (vector-ref act-8 1))) (vector 0 e-3))) (else (let ((act-9 (let ((act-9 (CoreC-45Context-toFullNames arg-1 csegen-68 (let ((e-3 (vector-ref e-2 2))) e-3) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (CoreC-45ContextC-45Log-logTerm (let ((e-0 (vector-ref e-2 0))) e-0) arg-1 "interaction.search" 10 (lambda () "LHS") e-13 eta-4)))) eff-0) eta-3))))))) (case (vector-ref act-9 0) ((0) (let ((e-3 (vector-ref act-9 1))) (vector 0 e-3))) (else (let ((act-10 (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--optsC-39 arg-7 arg-8 e-10 arg-10 e-2 eta-3))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-makeHelper arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 u--optsC-39 arg-8 e-10 arg-9 e-14))) eff-0) eta-3)))))))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-2))))))(else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-2)))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-case--searchType-8925 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-11 "interaction.search" 10 (lambda () "Searching locals only at") arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--tryInt (let ((sc2 (let ((e-10 (vector-ref arg-6 5))) e-10))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--tryIntRec (let ((sc2 (let ((sc3 (let ((e-4 (vector-ref arg-6 4))) e-4))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (let ((e-8 (vector-ref arg-6 8))) e-8))) (cond ((equal? sc4 1) 0) (else 1)))))))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-2 (vector-ref arg-6 2))) e-2)) '())))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 1 arg-4 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '()) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-2 (vector-ref arg-6 2))) (if (null? e-2) '() (let ((e-11 (unbox e-2))) (cons (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-11 eta-1)) '())))) u--tryIntRec))) eta-0))))))) (let ((e-2 (car arg-12))) (let ((e-3 (cdr arg-12))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (case (vector-ref e-6 0) ((3) (let ((e-9 (vector-ref e-6 2))) (let ((act-1 (let ((act-1 (unbox arg-11))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (clam-1) (let ((sc4 (or (and (= (PreludeC-45TypesC-45List-lengthTR e-3) e-9) 1) 0))) (cond ((equal? sc4 1) (let ((act-2 (CoreC-45Context-getSearchData arg-11 arg-8 0 e-7 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--allHints (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-0) eta-0) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-1 (cdr e-11))) e-1))) arg-5))) (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45Log-log arg-11 "interaction.search" 10 (lambda () (string-append "Hints found for " (string-append (CoreC-45Name-u--show_Show_Name e-7) (string-append " " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-65 u--allHints))))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((u--tries (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) (cons (TTImpC-45InteractiveC-45ExprSearch-searchNames arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 u--allHints) '())))) (let ((u--tryRec (let ((e-19 (vector-ref arg-6 2))) (if (null? e-19) '() (let ((e-20 (unbox e-19))) (cons (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-20 eta-1)) '())))))) (let ((u--tryIntRec (let ((sc7 (let ((e-14 (vector-ref arg-6 8))) e-14))) (cond ((equal? sc7 1) (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-19 (vector-ref arg-6 2))) e-19)) '())) (else '()))))) (let ((u--tryInt (let ((sc7 (let ((e-17 (vector-ref arg-6 5))) e-17))) (cond ((equal? sc7 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--allns (let ((sc7 (let ((e-4 (vector-ref arg-6 4))) e-4))) (cond ((equal? sc7 1) (PreludeC-45TypesC-45List-tailRecAppend u--tryRec (PreludeC-45TypesC-45List-tailRecAppend u--tryInt u--tries))) (else (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend u--tries (PreludeC-45TypesC-45List-tailRecAppend u--tryRec u--tryIntRec)))))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 1 arg-4 arg-2 arg-3 u--allns eta-0))))))))))))) eff-0) clam-1)))))) (else (TTImpC-45InteractiveC-45ExprSearch-noResult clam-1))))))) eff-0) clam-0))))))(else (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-11 "interaction.search" 10 (lambda () "Searching locals only at") arg-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((u--tryInt (let ((sc3 (let ((e-13 (vector-ref arg-6 5))) e-13))) (cond ((equal? sc3 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--tryIntRec (let ((sc3 (let ((sc4 (let ((e-4 (vector-ref arg-6 4))) e-4))) (cond ((equal? sc4 1) 1) (else (let ((sc5 (let ((e-10 (vector-ref arg-6 8))) e-10))) (cond ((equal? sc5 1) 0) (else 1)))))))) (cond ((equal? sc3 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-15 (vector-ref arg-6 2))) e-15)) '())))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 1 arg-4 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '()) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-15 (vector-ref arg-6 2))) (if (null? e-15) '() (let ((e-16 (unbox e-15))) (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-16 eta-0)) '())))) u--tryIntRec))) clam-0)))))))))))(else (let ((act-1 (CoreC-45ContextC-45Log-logTerm arg-0 arg-11 "interaction.search" 10 (lambda () "Searching locals only at") arg-2 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((u--tryInt (let ((sc2 (let ((e-10 (vector-ref arg-6 5))) e-10))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediate arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '())))))) (let ((u--tryIntRec (let ((sc2 (let ((sc3 (let ((e-4 (vector-ref arg-6 4))) e-4))) (cond ((equal? sc3 1) 1) (else (let ((sc4 (let ((e-8 (vector-ref arg-6 8))) e-8))) (cond ((equal? sc4 1) 0) (else 1)))))))) (cond ((equal? sc2 1) '()) (else (cons (TTImpC-45InteractiveC-45ExprSearch-tryIntermediateRec arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 (let ((e-12 (vector-ref arg-6 2))) e-12)) '())))))) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 1 arg-4 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend u--tryInt (PreludeC-45TypesC-45List-tailRecAppend (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3) '()) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-12 (vector-ref arg-6 2))) (if (null? e-12) '() (let ((e-13 (unbox e-12))) (cons (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-tryRecursive arg-0 arg-11 arg-10 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-2 arg-3 e-13 eta-0)) '())))) u--tryIntRec))) clam-0))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (cond ((equal? arg-10 0) (case (vector-ref arg-11 0) ((3) (let ((e-12 (vector-ref arg-11 1))) (let ((e-13 (vector-ref arg-11 2))) (let ((e-14 (vector-ref arg-11 3))) (let ((e-15 (vector-ref arg-11 4))) (case (vector-ref e-14 0) ((2) (let ((e-17 (vector-ref e-14 1))) (let ((e-18 (vector-ref e-14 2))) (let ((e-19 (vector-ref e-14 3))) (let ((e-20 (vector-ref e-14 4))) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-getSuccessful arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 0 arg-8 e-20 arg-9 (cons (TTImpC-45InteractiveC-45ExprSearch-searchLocal arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (vector 3 e-12 e-13 e-14 e-15) arg-9) (cons (lambda (eta-1) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 e-5 arg-8 e-20) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-3 (TTImpC-45Utils-getArgName arg-0 arg-1 e-5 e-13 '() arg-0 e-6 eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--nC-39 (vector 1 (vector 0 e-7)))) (let ((u--envC-39 (cons e-14 arg-8))) (let ((u--scC-39 (CoreC-45NameC-45Scoped-compat csegen-2277 e-15))) (lambda (eta-4) (let ((act-4 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" 10 (lambda () (string-append "Introduced lambda, search for " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons u--nC-39 arg-0) u--scC-39))) eta-4))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45InteractiveC-45ExprSearch-searchType (cons u--nC-39 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--envC-39 arg-9 0 u--scC-39) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (CoreC-45CoreC-45Search-functor 'erased 'erased (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (cons (vector 3 e-12 u--nC-39 (vector 0 e-17 e-18 e-19 e-20) e-2) e-3)))) e-9))))) eff-0) eta-4)))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))) '())) eta-0)))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-8925 arg-0 arg-10 arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-11)))))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-8925 arg-0 arg-10 arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-11)))))(else (let ((e-0 (- arg-10 1))) (case (vector-ref arg-11 0) ((3) (let ((e-2 (vector-ref arg-11 1))) (let ((e-3 (vector-ref arg-11 2))) (let ((e-4 (vector-ref arg-11 3))) (let ((e-5 (vector-ref arg-11 4))) (case (vector-ref e-4 0) ((2) (let ((e-7 (vector-ref e-4 1))) (let ((e-8 (vector-ref e-4 2))) (let ((e-9 (vector-ref e-4 3))) (let ((e-10 (vector-ref e-4 4))) (let ((u--envC-39 (cons e-4 arg-8))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-1 "interaction.search" 10 (lambda () (string-append "Introduced lambda, search for " (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 (cons e-3 arg-0) e-5))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((act-2 ((TTImpC-45InteractiveC-45ExprSearch-searchType (cons e-3 arg-0) arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 u--envC-39 arg-9 e-0 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45CoreC-45Search-functor 'erased 'erased (lambda (lamc-0) (let ((e-13 (car lamc-0))) (let ((e-12 (cdr lamc-0))) (cons (vector 3 e-2 e-3 (vector 0 e-7 e-8 e-9 e-10) e-13) e-12)))) e-11))))) eff-0) eta-0)))))))))))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-8925 arg-0 arg-10 arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-11)))))))))(else (TTImpC-45InteractiveC-45ExprSearch-case--searchType-8925 arg-0 arg-10 arg-11 arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 (CoreC-45TTC-45Term-getFnArgs arg-11)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchHole (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 (CoreC-45Normalise-normalise arg-0 '() arg-10 '() (let ((e-2 (vector-ref arg-11 2))) e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTerm '() arg-0 "interaction.search" 10 (lambda () "Normalised type") e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (CoreC-45Context-checkTimer arg-0 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45ExprSearch-searchType '() arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 '() arg-9 arg-8 e-5) eta-0)))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--12540-9942-u--lookupHoleName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExactI arg-9 arg-10) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 ((CoreC-45Context-lookupCtxtName arg-9 arg-10) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (vector 1 (box e-1)) (vector 1 '())))))))) eff-0) clam-0))))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (box (cons arg-9 (cons e-7 e-6))))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-search (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45InteractiveC-45ExprSearch-n--12540-9942-u--lookupHoleName arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-8 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-8) " not found")) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Context-undefinedName arg-0 arg-3 arg-8 eta-1))))) (let ((e-1 (unbox e-6))) (if (null? e-1) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-8) " not found")) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Context-undefinedName arg-0 arg-3 arg-8 eta-1))))) (let ((e-4 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (lambda (eta-1) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-8) " not found")) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (CoreC-45Context-undefinedName arg-0 arg-3 arg-8 eta-1))))) (let ((e-9 (cdr e-7))) (let ((e-18 (vector-ref e-9 18))) (lambda (clam-0) (case (vector-ref e-18 0) ((7) (let ((e-31 (vector-ref e-18 1))) (TTImpC-45InteractiveC-45ExprSearch-searchHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-31 arg-7 e-5 e-9 clam-0))) ((8) (let ((act-3 (CoreC-45Normalise-getArity arg-0 '() e-5 '() (let ((e-53 (vector-ref e-9 2))) e-53) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-33 (vector-ref act-3 1))) (vector 0 e-33))) (else (let ((e-33 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-searchHole arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-4 e-33 arg-7 e-5 e-9 eta-1)))) eff-0) clam-0))))))(else (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" 10 (lambda () (string-append (CoreC-45Name-u--show_Show_Name arg-8) " not a hole")) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-30 (vector-ref act-3 1))) (vector 0 e-30))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Not a hole: " (string-append (CoreC-45Name-u--show_Show_Name e-4) (string-append " in " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-65 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-32 (vector-ref eta-1 1))) e-32)) (let ((e-38 (vector-ref arg-5 2))) e-38))))))) clam-0))))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--21669-10689-u--lookupHoleName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 ((CoreC-45Context-lookupCtxtExactI arg-9 (let ((e-0 (vector-ref arg-10 0))) e-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 ((CoreC-45Context-lookupCtxtName arg-9 (let ((e-0 (vector-ref arg-10 0))) e-0)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 '()) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-2) (vector 1 (box e-1)) (vector 1 '())))))))) eff-0) clam-0))))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (box (cons arg-9 (cons e-7 e-6))))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearchOpts (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45InteractiveC-45ExprSearch-n--21669-10689-u--lookupHoleName arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 arg-7 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-undefinedName arg-0 arg-6 arg-7 eta-1)) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (let ((e-18 (vector-ref e-10 18))) (case (vector-ref e-18 0) ((7) (lambda (eta-1) (let ((act-3 (let ((act-3 (CoreC-45Context-getFullName arg-0 (vector 8 e-9) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-32 (vector-ref act-3 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Metadata-findHoleLHS arg-1 e-32 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-32 (vector-ref act-3 1))) (vector 0 e-32))) (else (let ((e-32 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "interaction.search" 10 (lambda () (string-append "LHS hole data " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 (cons csegen-65 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-1268 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40MaybeC-32C-36aC-41 csegen-1268 u--d u--x))))) (cons e-8 e-32)))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-33 (vector-ref act-4 1))) (vector 0 e-33))) (else (let ((act-5 (let ((sc8 (let ((e-42 (vector-ref arg-5 1))) e-42))) (cond ((equal? sc8 1) (let ((act-5 (TTImpC-45InteractiveC-45ExprSearch-getLHSData arg-0 e-5 e-32 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-34 (vector-ref act-5 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (let ((e-44 (vector-ref arg-5 0))) (let ((e-43 (vector-ref arg-5 1))) (let ((e-41 (vector-ref arg-5 3))) (let ((e-40 (vector-ref arg-5 4))) (let ((e-39 (vector-ref arg-5 5))) (let ((e-38 (vector-ref arg-5 6))) (let ((e-37 (vector-ref arg-5 7))) (let ((e-36 (vector-ref arg-5 8))) (let ((e-35 (vector-ref arg-5 9))) (vector e-44 e-43 e-34 e-41 e-40 e-39 e-38 e-37 e-36 e-35)))))))))))))) eff-0) eta-2)))))) (else (vector 1 arg-5)))))) (case (vector-ref act-5 0) ((0) (let ((e-34 (vector-ref act-5 1))) (vector 0 e-34))) (else (let ((e-34 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (PreludeC-45IO-u--map_Functor_IO csegen-2832 (PreludeC-45Basics-flip csegen-1298 arg-8 (lambda (u--hint) (lambda (eta-4) (let ((act-6 (let ((act-6 (unbox arg-0))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-35 (vector-ref act-6 1))) (vector 0 e-35))) (else (let ((e-35 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CoreC-45Context-lookupCtxtName u--hint (let ((e-68 (vector-ref e-35 0))) e-68)) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-36 (vector-ref act-7 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-7) (vector 8 (Builtin-fst (Builtin-snd eta-7)))) e-36))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-35 (vector-ref act-6 1))) (vector 0 e-35))) (else (let ((e-35 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (TTImpC-45InteractiveC-45ExprSearch-search arg-0 arg-1 arg-2 arg-6 (let ((e-51 (vector-ref e-10 7))) e-51) e-34 e-35 (let ((e-56 (vector-ref e-10 2))) e-56) e-8 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-36 (vector-ref act-7 1))) (vector 0 e-36))) (else (let ((e-36 (vector-ref act-7 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-firstLinearOK arg-0 arg-1 arg-2 arg-3 arg-4 arg-6 e-36))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))))) eff-0) eta-1))))))) ((1) (let ((e-33 (vector-ref e-18 2))) (let ((e-32 (vector-ref e-18 3))) (lambda (clam-0) (if (null? e-33) (case (vector-ref e-32 0) ((1) (let ((e-35 (vector-ref e-32 2))) (let ((act-3 (let ((act-3 (CoreC-45Normalise-normaliseHoles arg-0 '() e-5 '() e-35 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-37 (vector-ref act-3 1))) (vector 0 e-37))) (else (let ((e-37 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Context-toFullNames arg-0 csegen-68 e-37 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-38 (vector-ref act-4 1))) (vector 0 e-38))) (else (let ((e-38 (vector-ref act-4 1))) ((let ((eff-0 (TTImpC-45Unelab-unelab '() arg-0 '() e-38))) eff-0) eta-1)))))))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-37 (vector-ref act-3 1))) (vector 0 e-37))) (else (let ((e-37 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-one (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 csegen-259 e-37) eta-1)))) eff-0) clam-0)))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Name is already defined") clam-0))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Name is already defined") clam-0))))))(else (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-6 "Name is already defined") eta-1))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-initSearchOpts (lambda (arg-0 arg-1) (vector 0 arg-0 '() arg-1 0 0 1 0 0 '())))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearchC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-3 ext-1 ext-2 ext-0) (TTImpC-45InteractiveC-45ExprSearch-exprSearchOpts arg-0 arg-1 arg-2 arg-3 arg-4 (TTImpC-45InteractiveC-45ExprSearch-initSearchOpts 1 5) ext-3 ext-1 ext-2 ext-0)))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (CoreC-45Context-startTimer arg-0 (let ((e-6 (vector-ref e-5 6))) e-6) "expression search" eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (TTImpC-45InteractiveC-45ExprSearch-exprSearchC-39 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45Context-clearTimer arg-0) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 e-6))))))) eff-0) ext-0))))))))))
(define LibrariesC-45DataC-45PosMap-searchPos (lambda (arg-1 arg-2 ext-0) (LibrariesC-45DataC-45PosMap-inRange arg-1 arg-2 arg-2 ext-0)))
(define IdrisC-45REPL-n--24188-8193-u--cmp (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (let ((e-14 (car arg-4))) (let ((e-15 (cdr arg-4))) (let ((e-18 (car e-14))) (let ((e-19 (cdr e-14))) (let ((e-22 (car e-15))) (let ((e-23 (cdr e-15))) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 (cons (bs- e-10 e-6 63) (bs- e-11 e-7 63)) (cons (bs- e-22 e-18 63) (bs- e-23 e-19 63)))))))))))))))))
(define CoreC-45NameC-45Namespace-isInPathOf (lambda (arg-0 arg-1) (PreludeC-45Types-elem csegen-14 csegen-22 arg-0 arg-1)))
(define IdrisC-45REPL-n--24188-8191-u--checkAsNamespace (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-0 (vector-ref arg-4 1))) (CoreC-45NameC-45Namespace-isInPathOf arg-3 e-0)))(else 0))))
(define IdrisC-45REPL-n--24188-8195-u--matchingRoots (lambda (arg-0 arg-1 arg-2 ext-0 ext-1) (PreludeC-45Basics-on (lambda (eta-0) (lambda (eta-1) (PreludeC-45EqOrd-u--C-61C-61_Eq_String eta-0 eta-1))) (lambda (eta-0) (CoreC-45Name-nameRoot eta-0)) ext-0 ext-1)))
(define IdrisC-45REPL-case--findInTreeC-44startsWithUpper-8279 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 "") (if (null? arg-4) 0 (let ((e-0 (car arg-4))) (let ((sc3 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc3 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (cast-int-char (blodwen-toSignedInt 160 63)))))))))(else (let ((e-0 (car arg-4))) (let ((sc1 (PreludeC-45Types-isUpper e-0))) (cond ((equal? sc1 1) 1) (else (PreludeC-45EqOrd-u--C-62_Ord_Char e-0 (cast-int-char (blodwen-toSignedInt 160 63)))))))))))
(define IdrisC-45REPL-n--24188-8196-u--startsWithUpper (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45REPL-case--findInTreeC-44startsWithUpper-8279 arg-0 arg-1 arg-2 arg-3 (DataC-45String-strM arg-3))))
(define IdrisC-45REPL-n--24188-8192-u--checkCandidate (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (IdrisC-45REPL-n--24188-8195-u--matchingRoots arg-0 arg-1 arg-2 arg-1 arg-3))) (cond ((equal? sc0 1) 1) (else ((case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-1 (vector-ref e-0 1))) (lambda () (let ((sc3 (IdrisC-45REPL-n--24188-8196-u--startsWithUpper arg-0 arg-1 arg-2 e-1))) (cond ((equal? sc3 1) (IdrisC-45REPL-n--24188-8191-u--checkAsNamespace arg-0 arg-1 arg-2 e-1 arg-3)) (else 0))))))(else (lambda () 0)))))(else (lambda () 0)))))))))
(define IdrisC-45REPL-n--24188-8194-u--match (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-3 (cdr arg-3))) (let ((sc1 (CoreC-45Name-matches arg-1 e-3))) (cond ((equal? sc1 1) (IdrisC-45REPL-n--24188-8192-u--checkCandidate arg-0 arg-1 arg-2 e-3)) (else 0))))))
(define IdrisC-45REPL-findInTree (lambda (arg-0 arg-1 arg-2) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (DataC-45List-headC-39 (DataC-45List-sortBy (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-on (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPL-n--24188-8193-u--cmp arg-2 arg-1 arg-0 eta-2 eta-3))) (lambda (eta-2) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-2)) eta-0 eta-1))) (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (IdrisC-45REPL-n--24188-8194-u--match arg-2 arg-1 arg-0 eta-0)) (LibrariesC-45DataC-45PosMap-searchPos csegen-2146 arg-0 arg-2)))))))
(define CoreC-45Metadata-findEntryWith (lambda (ext-0 ext-1) (DataC-45List-find (lambda (eta-1) (PreludeC-45Basics-uncurry ext-0 eta-1)) ext-1)))
(define CoreC-45Metadata-findTyDeclAt (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Metadata-findEntryWith arg-1 (let ((e-2 (vector-ref e-5 2))) e-2)))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-findTypeAt (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (Builtin-snd eta-1)) (CoreC-45Metadata-findEntryWith arg-1 (let ((e-1 (vector-ref e-5 1))) e-1))))))) eff-0) ext-0)))))))
(define ParserC-45LexerC-45Common-isIdentNormal (lambda (ext-0) (let ((sc0 (PreludeC-45Types-fastUnpack ext-0))) (if (null? sc0) 0 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (let ((sc1 (ParserC-45LexerC-45Common-isIdentStart 2 e-2))) (cond ((equal? sc1 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 csegen-771 e-3)) (else 0)))))))))
(define IdrisC-45IDEModeC-45CaseSplit-fnName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-5 (vector-ref e-0 1))) (let ((sc2 (ParserC-45LexerC-45Common-isIdentNormal e-5))) (cond ((equal? sc2 1) e-5) (else (cond ((equal? arg-0 1) (string-append "(" (string-append e-5 ")"))) (else "op")))))))(else (CoreC-45Name-nameRoot arg-1))))) ((0) (let ((e-2 (vector-ref arg-1 2))) (IdrisC-45IDEModeC-45CaseSplit-fnName arg-0 e-2))) ((4) (let ((e-3 (vector-ref arg-1 1))) e-3))(else (CoreC-45Name-nameRoot arg-1)))))
(define TTImpC-45InteractiveC-45CaseSplit-explicitlyBound (lambda (arg-0 arg-1) (lambda (clam-0) (case (vector-ref arg-1 0) ((0) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((2) (let ((act-1 (((e-4 arg-0) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-1 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45InteractiveC-45CaseSplit-explicitlyBound arg-0 e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-2 e-10))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45Utils-getArgNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (case (vector-ref e-3 0) ((2) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((act-1 (case (vector-ref e-8 0) ((1) (let ((act-1 ((CoreC-45NormaliseC-45Eval-evalClosure arg-1 arg-0 arg-2 e-9) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45Utils-getArgName arg-0 arg-1 arg-2 e-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-10 '()))))) eff-0) eta-0)))))))) eff-0) clam-0))))))(else (vector 1 '()))))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (((e-4 arg-2) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts arg-5 (vector 10 e-1 (vector 0 )))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Utils-getArgNames arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (vector 1 (vector 0 eta-2))) e-5) arg-4) arg-5 e-10) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend e-5 e-11))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (vector 1 '()))))))))(else (vector 1 '()))))))
(define TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-explicitlyBound arg-1 arg-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45Utils-getArgNames '() arg-0 arg-1 e-5 '() '() arg-3))) eff-0) eta-0)))))))(else (let ((e-0 (- arg-2 1))) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-2 (vector-ref arg-3 1))) (let ((e-5 (vector-ref arg-3 4))) (let ((act-1 (((e-5 arg-1) (CoreC-45NormaliseC-45Eval-toClosure CoreC-45Value-defaultOpts '() (vector 10 e-2 (vector 0 )))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames arg-0 arg-1 e-0 e-6))) eff-0) clam-0))))))))(else (vector 1 '())))))))))
(define IdrisC-45REPLC-45Opts-getSource (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-17 (vector-ref e-5 5))) e-17)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define IdrisC-45REPLC-45Opts-getSourceLine (lambda (arg-0 arg-1 ext-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getSource arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45DataC-45ListC-45Extra-elemAt (DataC-45String-lines e-5) (PreludeC-45Types-prim__integerToNat (bs- arg-1 1 63))))))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45Literate-with--isLiterateLine-11813 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-2) (cons '() arg-2) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((e-8 (vector-ref e-5 0))) (case (vector-ref e-8 0) ((2) (let ((e-11 (vector-ref e-8 1))) (let ((e-12 (vector-ref e-8 2))) (if (null? e-6) (if (null? e-3) (cons '() arg-2) (let ((e-17 (cdr e-3))) (if (null? e-17) (cons '() arg-2) (let ((e-21 (cdr e-17))) (cond ((equal? e-21 "") (cons (box e-11) e-12))(else (cons '() arg-2))))))) (cons '() arg-2)))))(else (cons '() arg-2)))))))))))
(define LibrariesC-45TextC-45Literate-isLiterateLine (lambda (arg-0 arg-1) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (LibrariesC-45TextC-45Literate-with--isLiterateLine-11813 e-1 e-0 arg-1 (LibrariesC-45TextC-45LexerC-45Core-lex (LibrariesC-45TextC-45Literate-rawTokens e-0 e-1) arg-1) e-2))))))
(define ParserC-45Unlit-n--4693-6215-u--try (lambda (arg-0 arg-1) (let ((sc0 (LibrariesC-45TextC-45Literate-isLiterateLine arg-1 arg-0))) (if (null? sc0) '() (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) '() (let ((e-5 (unbox e-2))) (box (cons (box e-5) e-3))))))))))
(define ParserC-45Unlit-n--4693-6216-u--walk (lambda (arg-0) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-n--4693-6215-u--try arg-0 ParserC-45Unlit-styleBird) (lambda () (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-n--4693-6215-u--try arg-0 ParserC-45Unlit-styleOrg) (lambda () (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-n--4693-6215-u--try arg-0 ParserC-45Unlit-styleCMark) (lambda () (ParserC-45Unlit-n--4693-6215-u--try arg-0 ParserC-45Unlit-styleTeX)))))))))
(define ParserC-45Unlit-isLitLine (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () (cons '() arg-0)) (ParserC-45Unlit-n--4693-6216-u--walk arg-0))))
(define CoreC-45FC-onLine (lambda (arg-0 arg-1) (let ((e-3 (cdr arg-1))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int arg-0 (Builtin-fst e-6)))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Int arg-0 (Builtin-fst e-7))) (else 0))))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--13905-4250-u--indent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() (PreludeC-45Types-prim__integerToNat (Builtin-snd (CoreC-45FC-startPos arg-6))) #\ )) (let ((e-1 (unbox arg-5))) (ParserC-45Unlit-relit (box e-1) (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() (PreludeC-45Types-prim__integerToNat (PreludeC-45EqOrd-u--max_Ord_Int 0 (bs- (Builtin-snd (CoreC-45FC-startPos arg-6)) 1 63))) #\ )))))))
(define IdrisC-45IDEModeC-45CaseSplit-getClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Metadata-findTyDeclAt arg-1 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine (bs- arg-3 1 63) u--p))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-0) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((act-3 (CoreC-45Context-getFullName arg-0 e-9 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-14) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames arg-0 e-5 e-13 e-12))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (IdrisC-45REPLC-45Opts-getSourceLine arg-2 arg-3 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-15) (vector 1 '()) (let ((e-2 (unbox e-15))) (let ((sc10 (ParserC-45Unlit-isLitLine e-2))) (let ((e-4 (car sc10))) (vector 1 (box (string-append (IdrisC-45IDEModeC-45CaseSplit-n--13905-4250-u--indent arg-4 arg-3 arg-2 arg-1 arg-0 e-4 e-8) (string-append (IdrisC-45IDEModeC-45CaseSplit-fnName 1 e-11) (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-5) (string-append " " arg-5)) e-12)) (string-append " = ?" (string-append (IdrisC-45IDEModeC-45CaseSplit-fnName 0 e-11) "_rhs")))))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Opts-getLitStyle (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-4 (vector-ref e-5 4))) e-4)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define CoreC-45Metadata-findLHSAt (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45Metadata-findEntryWith (lambda (u--loc) (lambda (u--tm) ((arg-1 u--loc) (Builtin-snd u--tm)))) (let ((e-0 (vector-ref e-5 0))) e-0)))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45CaseSplit-combine (lambda (arg-0 arg-1) (if (null? arg-0) (if (null? arg-1) (vector 0 (vector 0 )) (vector 1 (PreludeC-45TypesC-45List-reverse arg-1))) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((2) (TTImpC-45InteractiveC-45CaseSplit-combine e-3 arg-1))(else (TTImpC-45InteractiveC-45CaseSplit-combine e-3 (cons e-2 arg-1)))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getDefining (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-4 (vector-ref arg-1 4))) (TTImpC-45InteractiveC-45CaseSplit-getDefining e-4)))(else (let ((sc0 (CoreC-45TTC-45Term-getFn arg-1))) (case (vector-ref sc0 0) ((1) (let ((e-3 (vector-ref sc0 3))) (box e-3)))(else '())))))))
(define TTImpC-45InteractiveC-45CaseSplit-findAllVars (lambda (arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((3) (cons e-2 (TTImpC-45InteractiveC-45CaseSplit-findAllVars e-4))) ((1) (cons e-2 (TTImpC-45InteractiveC-45CaseSplit-findAllVars e-4))) ((4) (cons e-2 (TTImpC-45InteractiveC-45CaseSplit-findAllVars e-4)))(else (PreludeC-45Types-u--toList_Foldable_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45Name-dropNS eta-0)) (TTImpC-45InteractiveC-45CaseSplit-getDefining arg-1)))))))))(else (PreludeC-45Types-u--toList_Foldable_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45Name-dropNS eta-0)) (TTImpC-45InteractiveC-45CaseSplit-getDefining arg-1)))))))
(define TTImpC-45InteractiveC-45CaseSplit-findTyName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((3) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (let ((e-4 (vector-ref arg-5 4))) (case (vector-ref e-3 0) ((3) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--b (vector 3 e-6 e-7 e-8 e-9))) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name arg-4 e-2))) (cond ((equal? sc2 1) (lambda (eta-0) (let ((act-1 ((CoreC-45NormaliseC-45Eval-nf arg-1 arg-0 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((3) (let ((e-13 (vector-ref e-5 2))) (vector 1 (box e-13))))(else (vector 1 '())))))) eff-0) eta-0))))))) (else (TTImpC-45InteractiveC-45CaseSplit-findTyName (cons e-2 arg-0) arg-1 arg-2 (cons u--b arg-3) arg-4 e-4))))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findTyName (cons e-2 arg-0) arg-1 arg-2 (cons e-3 arg-3) arg-4 e-4)))))))(else (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45InteractiveC-45CaseSplit-findCons (lambda (arg-0 arg-1 arg-2 ext-0) (let ((sc0 (TTImpC-45InteractiveC-45CaseSplit-getDefining arg-2))) (if (null? sc0) (vector 1 (vector 0 (vector 1 arg-1 "Can't find function name on LHS"))) (let ((e-2 (unbox sc0))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45InteractiveC-45CaseSplit-findTyName '() arg-0 e-5 '() arg-1 arg-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 (vector 0 (vector 1 arg-1 (string-append "Can't find type of " (string-append (CoreC-45Name-u--show_Show_Name arg-1) " in LHS"))))) (let ((e-3 (unbox e-6))) (let ((act-3 (CoreC-45Context-lookupDefExact e-3 (let ((e-0 (vector-ref e-5 0))) e-0) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (vector 1 (vector 0 (vector 1 arg-1 (string-append "Not a type constructor " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-1947 e-7))))) (let ((e-1 (unbox e-7))) (case (vector-ref e-1 0) ((6) (let ((e-8 (vector-ref e-1 7))) (let ((act-4 (CoreC-45Context-toFullNames arg-0 csegen-54 e-3 clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-15 (vector-ref act-4 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (CoreC-45Context-toFullNames arg-0 csegen-54 eta-2 eta-3))) e-8 '()) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-16 (vector-ref act-5 1))) (vector 0 e-16))) (else (let ((e-16 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 1 (cons e-2 (cons e-15 e-16))))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))(else (vector 1 (vector 0 (vector 1 arg-1 (string-append "Not a type constructor " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-1947 e-7)))))))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-recordUpdate (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--nupdates (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-2 (car eta-0))) (let ((e-3 (cdr eta-0))) (cons e-2 (vector 0 arg-1 e-3))))) (let ((e-0 (car e-5))) e-0)))) (lambda (eta-0) (let ((act-2 (set-box! arg-0 (let ((e-0 (car e-5))) (let ((e-1 (cdr e-5))) (cons e-0 (cons (cons arg-2 (TTImpC-45Utils-substNames '() u--nupdates arg-3)) e-1))))))) (vector 1 act-2)))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45CaseSplit-findUpdates (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-32 (vector-ref arg-2 1))) (let ((e-33 (vector-ref arg-2 2))) (lambda (clam-0) (case (vector-ref arg-3 0) ((0) (let ((e-44 (vector-ref arg-3 2))) (let ((act-1 (CoreC-45Context-lookupTyExact e-44 (let ((e-0 (vector-ref arg-1 0))) e-0) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((sc5 (DataC-45List-lookup csegen-832 e-44 (let ((e-0 (car e-6))) e-0)))) (if (null? sc5) (let ((act-3 (set-box! arg-0 (let ((e-0 (car e-6))) (let ((e-1 (cdr e-6))) (cons (cons (cons e-44 e-33) e-0) e-1)))))) (vector 1 act-3)) (let ((e-2 (unbox sc5))) (let ((act-3 (set-box! arg-0 (let ((e-0 (car e-6))) (let ((e-1 (cdr e-6))) (cons e-0 (cons (cons e-33 (vector 0 e-32 e-2)) e-1))))))) (vector 1 act-3)))))))) eff-0) clam-1))))) (TTImpC-45InteractiveC-45CaseSplit-recordUpdate arg-0 e-32 e-33 (vector 0 e-32 e-44) clam-1))))) eff-0) clam-0)))))))(else (TTImpC-45InteractiveC-45CaseSplit-recordUpdate arg-0 e-32 e-33 arg-3 clam-0))))))) ((8) (let ((e-36 (vector-ref arg-2 2))) (let ((e-37 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((8) (let ((e-47 (vector-ref arg-3 2))) (let ((e-48 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-36 e-47) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-37 e-48) eta-0))))))))(else (case (vector-ref arg-3 0) ((9) (let ((e-29 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-29)))(else (case (vector-ref arg-2 0) ((10) (let ((e-19 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((10) (let ((e-24 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 e-24) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-21 e-26) eta-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 arg-3))))))(else (case (vector-ref arg-3 0) ((10) (let ((e-14 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-14)))(else (case (vector-ref arg-2 0) ((18) (let ((e-11 (vector-ref arg-2 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-11 arg-3)))(else (case (vector-ref arg-3 0) ((18) (let ((e-5 (vector-ref arg-3 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-5)))(else (lambda (eta-0) (vector 1 (vector 0 )))))))))))))))))) ((9) (let ((e-40 (vector-ref arg-2 2))) (let ((e-41 (vector-ref arg-2 3))) (case (vector-ref arg-3 0) ((9) (let ((e-51 (vector-ref arg-3 2))) (let ((e-52 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-40 e-51) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-41 e-52) eta-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-40 arg-3))))))(else (case (vector-ref arg-3 0) ((9) (let ((e-29 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-29)))(else (case (vector-ref arg-2 0) ((10) (let ((e-19 (vector-ref arg-2 2))) (let ((e-21 (vector-ref arg-2 4))) (case (vector-ref arg-3 0) ((10) (let ((e-24 (vector-ref arg-3 2))) (let ((e-26 (vector-ref arg-3 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 e-24) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-21 e-26) eta-0))))))))(else (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-19 arg-3))))))(else (case (vector-ref arg-3 0) ((10) (let ((e-14 (vector-ref arg-3 2))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-14)))(else (case (vector-ref arg-2 0) ((18) (let ((e-11 (vector-ref arg-2 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 e-11 arg-3)))(else (case (vector-ref arg-3 0) ((18) (let ((e-5 (vector-ref arg-3 5))) (TTImpC-45InteractiveC-45CaseSplit-findUpdates arg-0 arg-1 arg-2 e-5)))(else (lambda (eta-0) (vector 1 (vector 0 )))))))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getUpdates (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "TTImp.Interactive.CaseSplit.UPD" ) (cons '() '())) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((TTImpC-45InteractiveC-45CaseSplit-findUpdates e-5 arg-0 arg-1 arg-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (let ((act-3 (unbox e-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (let ((e-1 (cdr e-7))) e-1))))) eff-0) eta-0))))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45CaseSplit-mkCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 2 (vector 0 )))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-3) (let ((act-4 ((CoreC-45Context-setAllPublic arg-0 1) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 ((TTImpC-45Elab-elabTerm '() arg-0 e-5 arg-1 arg-2 arg-3 arg-4 (vector 1 csegen-30) '() '() '() (vector 16 (TTImpC-45TTImp-getFC arg-6) (vector 1 ) arg-6) '()) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-9))) (let ((act-6 ((CoreC-45Context-setAllPublic arg-0 0) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((act-7 (let ((act-7 (set-box! arg-0 e-6))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (let ((act-8 (set-box! arg-1 e-7))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (PreludeC-45IO-u--map_Functor_IO csegen-3827 (lambda (eta-4) (TTImpC-45Unelab-unelabNoSugar '() arg-0 '() e-2 eta-4)) clam-0))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-10 (CoreC-45ContextC-45Log-log arg-0 "interaction.casesplit" 3 (lambda () (string-append "Original LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 arg-5))) eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((act-11 (CoreC-45ContextC-45Log-log arg-0 "interaction.casesplit" 3 (lambda () (string-append "New LHS: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-13))) eta-4))) (case (vector-ref act-11 0) ((0) (let ((e-4 (vector-ref act-11 1))) (vector 0 e-4))) (else (let ((act-12 (TTImpC-45InteractiveC-45CaseSplit-getUpdates e-6 arg-5 e-13 eta-4))) (case (vector-ref act-12 0) ((0) (let ((e-4 (vector-ref act-12 1))) (vector 0 e-4))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 0 e-13 e-16))))) eff-0) eta-4)))))))))))))) eff-0) clam-0)))))))))))))))))) eff-0) eta-3))))))))) (lambda (u--err) (lambda (eta-3) (let ((act-4 (let ((act-4 (set-box! arg-0 e-6))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (set-box! arg-1 e-7))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (case (vector-ref u--err 0) ((5) (let ((e-0 (vector-ref u--err 1))) (let ((e-2 (vector-ref u--err 3))) (let ((e-3 (vector-ref u--err 4))) (let ((e-4 (vector-ref u--err 5))) (let ((e-11 (vector-ref u--err 6))) (let ((u--defs (let ((e-43 (vector-ref e-6 1))) (let ((e-42 (vector-ref e-6 2))) (let ((e-41 (vector-ref e-6 3))) (let ((e-40 (vector-ref e-6 4))) (let ((e-39 (vector-ref e-6 5))) (let ((e-38 (vector-ref e-6 6))) (let ((e-37 (vector-ref e-6 7))) (let ((e-36 (vector-ref e-6 8))) (let ((e-35 (vector-ref e-6 9))) (let ((e-34 (vector-ref e-6 10))) (let ((e-33 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (let ((e-17 (vector-ref e-6 17))) (let ((e-18 (vector-ref e-6 18))) (let ((e-19 (vector-ref e-6 19))) (let ((e-20 (vector-ref e-6 20))) (let ((e-21 (vector-ref e-6 21))) (let ((e-22 (vector-ref e-6 22))) (let ((e-23 (vector-ref e-6 23))) (let ((e-24 (vector-ref e-6 24))) (let ((e-25 (vector-ref e-6 25))) (let ((e-26 (vector-ref e-6 26))) (let ((e-27 (vector-ref e-6 27))) (let ((e-28 (vector-ref e-6 28))) (let ((e-29 (vector-ref e-6 29))) (let ((e-30 (vector-ref e-6 30))) (let ((e-31 (vector-ref e-6 31))) (let ((e-32 (vector-ref e-6 32))) (vector e-2 e-43 e-42 e-41 e-40 e-39 e-38 e-37 e-36 e-35 e-34 e-33 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))) (let ((act-6 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-4) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 ((CoreC-45NormaliseC-45Eval-nf arg-0 e-0 u--defs e-3 e-11) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-13 (vector-ref act-7 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-8 ((TTImpC-45ProcessDef-impossibleOK arg-0 e-0 u--defs e-12 e-13) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-14 (vector-ref act-8 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-14 1) (vector 1 (vector 1 arg-6))) (else (vector 1 (vector 2 ))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3))))))))))))(else (vector 1 (vector 2 )))))))))))) eta-2)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45TTImpC-45Arg-apply (lambda (arg-1 arg-2) (if (null? arg-2) arg-1 (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (case (vector-ref e-1 0) ((0) (let ((e-5 (vector-ref e-1 1))) (let ((e-6 (vector-ref e-1 2))) (TTImpC-45TTImpC-45Arg-apply (vector 8 e-5 arg-1 e-6) e-2)))) ((1) (let ((e-8 (vector-ref e-1 1))) (let ((e-9 (vector-ref e-1 2))) (TTImpC-45TTImpC-45Arg-apply (vector 9 e-8 arg-1 e-9) e-2)))) (else (let ((e-11 (vector-ref e-1 1))) (let ((e-12 (vector-ref e-1 2))) (let ((e-13 (vector-ref e-1 3))) (TTImpC-45TTImpC-45Arg-apply (vector 10 e-11 arg-1 e-12 e-13) e-2)))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-expandCon (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyExact arg-3 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 arg-1 arg-3 clam-0) (let ((e-1 (unbox e-6))) (let ((act-3 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() e-1) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((TTImpC-45Utils-getArgNames '() arg-0 e-5 '() arg-2 '() e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (TTImpC-45TTImp-apply (vector 0 arg-1 arg-3) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-3) (vector 17 arg-1 eta-3)) e-8)))))) eff-0) eta-1)))))))) eff-0) clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45CaseSplit-updateArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((sc1 (PreludeC-45Types-elem csegen-14 csegen-832 e-2 arg-1))) (cond ((equal? sc1 1) (lambda (clam-0) (let ((sc2 (CoreC-45Name-u--C-61C-61_Eq_Name e-2 arg-2))) (cond ((equal? sc2 1) (TTImpC-45InteractiveC-45CaseSplit-expandCon arg-0 e-1 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-5) (CoreC-45Name-u--C-47C-61_Eq_Name arg-5 e-2)) arg-1) arg-3 clam-0)) (else (vector 1 (vector 32 e-1 1))))))) (else (lambda (eta-0) (vector 1 (vector 0 e-1 e-2))))))))) ((8) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((e-6 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-6) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 e-4 e-7 e-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((9) (let ((e-8 (vector-ref arg-4 1))) (let ((e-9 (vector-ref arg-4 2))) (let ((e-10 (vector-ref arg-4 3))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-9) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-10) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 9 e-8 e-5 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((10) (let ((e-12 (vector-ref arg-4 1))) (let ((e-13 (vector-ref arg-4 2))) (let ((e-14 (vector-ref arg-4 3))) (let ((e-15 (vector-ref arg-4 4))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-13) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-15) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 10 e-12 e-5 e-14 e-6))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((18) (let ((e-21 (vector-ref arg-4 5))) (TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-21)))(else (lambda (eta-0) (vector 1 (vector 32 (TTImpC-45TTImp-getFC arg-4) 1)))))))
(define TTImpC-45InteractiveC-45CaseSplit-update (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-1 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-5))))) eff-0) ext-0)))))))) ((1) (let ((e-4 (vector-ref arg-4 1))) (let ((e-5 (vector-ref arg-4 2))) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-4 e-6))))) eff-0) ext-0)))))))) (else (let ((e-7 (vector-ref arg-4 1))) (let ((e-8 (vector-ref arg-4 2))) (let ((e-9 (vector-ref arg-4 3))) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-updateArg arg-0 arg-1 arg-2 arg-3 e-9) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-7 e-8 e-5))))) eff-0) ext-0))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-case--newLHS-14639 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((u--keep (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (vector 0 arg-5 (vector 32 arg-5 1))) (DataC-45List-take arg-4 e-3)))) (let ((u--ups (DataC-45List-drop arg-4 e-3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45InteractiveC-45CaseSplit-update arg-6 arg-3 arg-2 arg-1 eta-1 eta-2))) u--ups '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (TTImpC-45TTImpC-45Arg-apply e-2 (PreludeC-45TypesC-45List-tailRecAppend u--keep e-5)))))) eff-0) eta-0))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-newLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (TTImpC-45InteractiveC-45CaseSplit-case--newLHS-14639 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (TTImpC-45TTImp-getFnArgs arg-6 '()))))
(define TTImpC-45InteractiveC-45CaseSplit-substLets (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((3) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (let ((e-4 (vector-ref arg-1 4))) (case (vector-ref e-3 0) ((1) (let ((e-8 (vector-ref e-3 3))) (TTImpC-45InteractiveC-45CaseSplit-substLets arg-0 (CoreC-45TTC-45TermC-45Subst-subst e-8 e-4)))) ((4) (let ((e-13 (vector-ref e-3 3))) (TTImpC-45InteractiveC-45CaseSplit-substLets arg-0 (CoreC-45TTC-45TermC-45Subst-subst e-13 e-4))))(else (vector 3 e-1 e-2 e-3 (TTImpC-45InteractiveC-45CaseSplit-substLets (cons e-2 arg-0) e-4)))))))))(else arg-1))))
(define TTImpC-45InteractiveC-45CaseSplit-u--show_Show_ClauseUpdate (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append "Valid: " (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-0) (string-append "\xa;" (string-append "Updates: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2707 e-1)))))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (string-append "Impossible: " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 e-2)))) (else "Invalid"))))
(define TTImpC-45InteractiveC-45CaseSplit-u--showPrec_Show_ClauseUpdate (lambda (arg-0 arg-1) (TTImpC-45InteractiveC-45CaseSplit-u--show_Show_ClauseUpdate arg-1)))
(define TTImpC-45InteractiveC-45CaseSplit-getSplitsLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((u--lhs (TTImpC-45InteractiveC-45CaseSplit-substLets '() arg-7))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-logTerm '() arg-1 "interaction.casesplit" 3 (lambda () "Splitting") arg-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--usedns (TTImpC-45InteractiveC-45CaseSplit-findAllVars arg-7))) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45InteractiveC-45CaseSplit-findCons arg-1 arg-8 u--lhs eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (case (vector-ref e-7 0) ((1) (let ((e-1 (vector-ref e-7 1))) (lambda (clam-0) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (let ((e-11 (cdr e-8))) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO csegen-3827 (lambda (eta-2) (TTImpC-45Unelab-unelabNoSugar '() arg-1 '() u--lhs eta-2)) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Core-traverseC-39 (lambda (u--c) (TTImpC-45InteractiveC-45CaseSplit-newLHS arg-1 arg-5 arg-6 u--usedns arg-8 u--c e-12)) e-11 '()) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc8 (CoreC-45Context-getNameID e-9 (let ((e-0 (vector-ref e-6 0))) e-0)))) (if (null? sc8) (CoreC-45Context-undefinedName arg-1 arg-5 e-9 clam-1) (let ((e-2 (unbox sc8))) (let ((act-6 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (TTImpC-45InteractiveC-45CaseSplit-mkCase arg-1 arg-2 arg-3 arg-4 e-2 e-12 eta-3 eta-4))) e-13 '()) clam-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45ContextC-45Log-log arg-1 "interaction.casesplit" 3 (lambda () (string-append "Found cases: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (TTImpC-45InteractiveC-45CaseSplit-u--show_Show_ClauseUpdate u--x)) (lambda (u--d) (lambda (u--x) (TTImpC-45InteractiveC-45CaseSplit-u--showPrec_Show_ClauseUpdate u--d u--x)))) e-14))) eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (vector 1 (TTImpC-45InteractiveC-45CaseSplit-combine e-14 '())))))))) eff-0) clam-1))))))))))) eff-0) eta-2)))))))) eff-0) clam-0))))))))))) (else (let ((e-3 (vector-ref e-7 1))) (lambda (eta-2) (vector 1 (vector 0 e-3)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-getSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45Metadata-findLHSAt arg-1 arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 0 (vector 2 )))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (TTImpC-45InteractiveC-45CaseSplit-getSplitsLHS arg-1 arg-0 arg-2 arg-3 arg-4 (CoreC-45FC-justFC e-7) e-9 e-10 arg-6))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-lookupDefTyName (lambda (ext-2 ext-1 ext-0) (CoreC-45Context-lookupNameBy csegen-1314 ext-2 ext-1 ext-0)))
(define IdrisC-45IDEModeC-45MakeClause-n--5294-9416-u--addBrackets (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 0) arg-4) (else (string-append "(" (string-append arg-4 ")"))))))
(define IdrisC-45IDEModeC-45MakeClause-n--5294-9417-u--addCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (IdrisC-45IDEModeC-45MakeClause-n--5294-9416-u--addBrackets arg-0 arg-1 arg-2 arg-2 (string-append e-2 (string-append "\xa;" (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() (+ arg-3 (cond ((equal? arg-2 1) 6) (else 5))) #\ )) e-3))))))))
(define IdrisC-45IDEModeC-45MakeClause-n--5294-9419-u--replaceStr (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (cond ((equal? arg-6 "") "")(else (let ((sc0 (DataC-45String-isPrefixOf arg-4 arg-6))) (cond ((equal? sc0 1) (string-append (IdrisC-45IDEModeC-45MakeClause-n--5294-9417-u--addCase arg-0 arg-1 arg-2 arg-3 arg-5) (PreludeC-45Types-fastPack (DataC-45List-drop (PreludeC-45TypesC-45String-length arg-4) (PreludeC-45Types-fastUnpack arg-6))))) (else (string-cons (string-ref arg-6 0) (IdrisC-45IDEModeC-45MakeClause-n--5294-9419-u--replaceStr arg-0 arg-1 arg-2 (+ arg-3 1) arg-4 arg-5 (substring arg-6 1 (string-length arg-6)))))))))))
(define IdrisC-45IDEModeC-45MakeClause-n--5294-9418-u--newLines (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45MakeClause-n--5294-9419-u--replaceStr arg-0 arg-1 arg-2 0 (string-append "?" (CoreC-45Name-u--show_Show_Name arg-1)) arg-3 arg-0)))
(define IdrisC-45IDEModeC-45MakeClause-makeCase (lambda (arg-0 arg-1 arg-2) (let ((u--capp (cons "case _ of" (string-append "case_val => ?" (CoreC-45Name-u--show_Show_Name arg-1))))) (IdrisC-45IDEModeC-45MakeClause-n--5294-9418-u--newLines arg-2 arg-1 arg-0 u--capp))))
(define TTImpC-45InteractiveC-45GenerateDef-fnName (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (case (vector-ref e-0 0) ((0) (let ((e-5 (vector-ref e-0 1))) (let ((sc2 (ParserC-45LexerC-45Common-isIdentNormal e-5))) (cond ((equal? sc2 1) e-5) (else (cond ((equal? arg-0 1) (string-append "(" (string-append e-5 ")"))) (else "op")))))))(else (CoreC-45Name-nameRoot arg-1))))) ((0) (let ((e-2 (vector-ref arg-1 2))) (TTImpC-45InteractiveC-45GenerateDef-fnName arg-0 e-2))) ((4) (let ((e-3 (vector-ref arg-1 1))) e-3))(else (CoreC-45Name-nameRoot arg-1)))))
(define TTImpC-45Utils-uniqueHoleName (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45Utils-uniqueBasicName arg-1 (PreludeC-45TypesC-45List-tailRecAppend arg-2 (let ((e-11 (vector-ref e-5 11))) e-11)) arg-3 eta-0)))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12277-1237-u--mkUniqueName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((30) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45Utils-uniqueHoleName arg-3 e-5 '() e-2 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 30 e-1 e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))(else (vector 1 arg-5)))))
(define TTImpC-45InteractiveC-45GenerateDef-uniqueRHS (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 1))) (let ((e-2 (vector-ref arg-2 2))) (let ((e-3 (vector-ref arg-2 3))) (let ((act-1 (TTImpC-45InteractiveC-45GenerateDef-n--12277-1237-u--mkUniqueName e-3 e-2 e-1 arg-1 arg-0 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-5))))) eff-0) ext-0)))))))))(else (vector 1 arg-2)))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12343-1323-u--dropLams (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (cond ((equal? arg-9 0) arg-10)(else (let ((e-0 (- arg-9 1))) (case (vector-ref arg-10 0) ((2) (let ((e-7 (vector-ref arg-10 6))) (TTImpC-45InteractiveC-45GenerateDef-n--12343-1323-u--dropLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-0 e-7)))(else arg-10)))))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12343-1324-u--updateRHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (vector 0 e-1 e-2 arg-10)))) ((1) (let ((e-5 (vector-ref arg-9 1))) (let ((e-6 (vector-ref arg-9 2))) (let ((e-7 (vector-ref arg-9 3))) (let ((e-8 (vector-ref arg-9 4))) (let ((e-9 (vector-ref arg-9 5))) (let ((e-10 (vector-ref arg-9 6))) (let ((e-11 (vector-ref arg-9 7))) (vector 1 e-5 e-6 e-7 e-8 e-9 e-10 e-11))))))))) (else (let ((e-13 (vector-ref arg-9 1))) (let ((e-14 (vector-ref arg-9 2))) (vector 2 e-13 e-14)))))))
(define TTImpC-45InteractiveC-45GenerateDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandClause-1463 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 ext-0) (case (vector-ref arg-16 0) ((2) (let ((e-2 (vector-ref arg-16 2))) (let ((e-3 (vector-ref arg-16 3))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupDefExact (vector 8 e-3) (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "No searchable hole on RHS") clam-0) (let ((e-7 (unbox e-6))) (case (vector-ref e-7 0) ((7) (let ((e-9 (vector-ref e-7 1))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" 10 (lambda () (string-append "Expression search for " (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1833 (cons e-2 e-3)))) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-10 (vector-ref act-3 1))) (vector 0 e-10))) (else (let ((act-4 (TTImpC-45InteractiveC-45ExprSearch-exprSearchOpts arg-0 arg-8 arg-7 arg-6 arg-5 arg-3 arg-4 (vector 8 e-3) '() clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-11 (vector-ref act-4 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45CoreC-45Search-traverse (lambda (u--rhsC-39) (let ((u--rhsraw (TTImpC-45InteractiveC-45GenerateDef-n--12343-1323-u--dropLams arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-9 u--rhsC-39))) (lambda (eta-1) (let ((act-5 (CoreC-45Normalise-logTermNF arg-11 arg-0 "interaction.generate" 5 (lambda () "Got clause") arg-14 arg-13 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-12 (vector-ref act-5 1))) (vector 0 e-12))) (else (let ((act-6 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" 5 (lambda () (string-append "        = " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 u--rhsraw))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-13 (vector-ref act-6 1))) (vector 0 e-13))) (else (vector 1 (cons (TTImpC-45InteractiveC-45GenerateDef-n--12343-1324-u--updateRHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 u--rhsraw) '()))))))))))) e-11))) eff-0) clam-0))))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "No searchable hole on RHS") clam-0)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 arg-4 "No searchable hole on RHS") ext-0)))))
(define TTImpC-45InteractiveC-45GenerateDef-expandClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (TTImpC-45InteractiveC-45GenerateDef-uniqueRHS arg-0 arg-3 arg-8 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (TTImpC-45ProcessDef-checkClause '() arg-0 arg-1 arg-2 arg-3 arg-4 csegen-1416 0 2 0 arg-7 '() '() '() e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (let ((_-0 (vector 1 e-2))) (let ((e-0 (vector-ref e-2 0))) (let ((e-1 (vector-ref e-2 1))) (let ((e-4 (vector-ref e-2 2))) (let ((e-3 (vector-ref e-2 3))) (let ((u--clause (vector e-0 e-1 e-4 e-3))) (lambda (eta-1) (TTImpC-45InteractiveC-45GenerateDef-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32expandClause-1463 arg-0 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 e-5 _-0 e-0 e-3 e-4 e-1 u--clause (CoreC-45TTC-45Term-getFn e-3) eta-1)))))))))) (else (lambda (eta-1) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-1)))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45GenerateDef-splittableNames (lambda (arg-0) (case (vector-ref arg-0 0) ((8) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (case (vector-ref e-3 0) ((17) (let ((e-15 (vector-ref e-3 2))) (PreludeC-45TypesC-45List-tailRecAppend (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-2) (cons (vector 1 (vector 0 e-15)) '()))))(else (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-2)))))) ((9) (let ((e-6 (vector-ref arg-0 2))) (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-6))) ((10) (let ((e-10 (vector-ref arg-0 2))) (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-10)))(else '()))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 1))) (let ((e-2 (vector-ref arg-10 2))) (case (vector-ref e-2 0) ((1) (let ((e-16 (vector-ref e-2 1))) (case (vector-ref e-16 0) ((0) (let ((e-19 (vector-ref e-16 1))) (vector 17 e-1 e-19)))(else arg-10)))) ((2) (vector 32 e-1 1))(else arg-10))))) ((8) (let ((e-4 (vector-ref arg-10 1))) (let ((e-5 (vector-ref arg-10 2))) (let ((e-6 (vector-ref arg-10 3))) (vector 8 e-4 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-5) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-6)))))) ((9) (let ((e-8 (vector-ref arg-10 1))) (let ((e-9 (vector-ref arg-10 2))) (let ((e-10 (vector-ref arg-10 3))) (vector 9 e-8 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-9) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-10)))))) ((10) (let ((e-12 (vector-ref arg-10 1))) (let ((e-13 (vector-ref arg-10 2))) (let ((e-14 (vector-ref arg-10 3))) (let ((e-15 (vector-ref arg-10 4))) (vector 10 e-12 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-13) e-14 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-15)))))))(else arg-10))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11) (case (vector-ref arg-11 0) ((0) (let ((e-1 (vector-ref arg-11 1))) (let ((e-2 (vector-ref arg-11 2))) (let ((sc1 (DataC-45List-lookup csegen-832 e-2 arg-10))) (if (null? sc1) (vector 0 e-1 e-2) (let ((e-3 (unbox sc1))) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-3))))))) ((17) (let ((e-4 (vector-ref arg-11 1))) (let ((e-5 (vector-ref arg-11 2))) (let ((sc1 (DataC-45List-lookup csegen-832 (vector 1 (vector 0 e-5)) arg-10))) (if (null? sc1) (vector 17 e-4 e-5) (let ((e-2 (unbox sc1))) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1864-u--fixNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 e-2))))))) ((8) (let ((e-7 (vector-ref arg-11 1))) (let ((e-8 (vector-ref arg-11 2))) (let ((e-9 (vector-ref arg-11 3))) (vector 8 e-7 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-8) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-9)))))) ((9) (let ((e-11 (vector-ref arg-11 1))) (let ((e-12 (vector-ref arg-11 2))) (let ((e-13 (vector-ref arg-11 3))) (vector 9 e-11 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-12) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-13)))))) ((10) (let ((e-15 (vector-ref arg-11 1))) (let ((e-16 (vector-ref arg-11 2))) (let ((e-17 (vector-ref arg-11 3))) (let ((e-18 (vector-ref arg-11 4))) (vector 10 e-15 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-16) e-17 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 e-18)))))))(else arg-11))))
(define TTImpC-45InteractiveC-45GenerateDef-n--12961-1866-u--valid (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10) (case (vector-ref arg-10 0) ((0) (let ((e-1 (vector-ref arg-10 2))) (box e-1)))(else '()))))
(define TTImpC-45InteractiveC-45GenerateDef-trySplit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((act-1 ((TTImpC-45InteractiveC-45CaseSplit-getSplitsLHS arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 arg-7 arg-9) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-1 (vector-ref e-5 1))) (vector 1 (cons arg-9 (PreludeC-45TypesC-45List-mapAppend '() (lambda (u--ups) (vector 0 arg-5 (TTImpC-45InteractiveC-45GenerateDef-n--12961-1865-u--updateLHS arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 u--ups arg-6) arg-8)) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (TTImpC-45InteractiveC-45GenerateDef-n--12961-1866-u--valid arg-9 arg-8 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)) e-1))))))(else (vector 1 (cons arg-9 '()))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45GenerateDef-generateSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((2) (vector 1 '())) ((1) (vector 1 '())) (else (let ((e-12 (vector-ref arg-8 1))) (let ((e-13 (vector-ref arg-8 2))) (let ((e-14 (vector-ref arg-8 3))) (let ((act-1 ((TTImpC-45Elab-elabTerm '() arg-1 arg-0 arg-2 arg-3 arg-4 arg-7 (vector 1 csegen-1416) '() '() '() (vector 16 arg-5 (vector 1 ) e-13) '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((u--splitnames (let ((sc3 (let ((e-6 (vector-ref arg-6 6))) e-6))) (cond ((equal? sc3 1) (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-13)) (else (PreludeC-45TypesC-45List-reverse (TTImpC-45InteractiveC-45GenerateDef-splittableNames e-13))))))) (CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (TTImpC-45InteractiveC-45GenerateDef-trySplit arg-0 arg-1 arg-2 arg-3 arg-4 e-12 e-13 e-2 e-14 eta-0 eta-1))) u--splitnames '()))))) eff-0) ext-0))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-trySearch (lambda (arg-1 arg-2 arg-3 arg-4) (TTImpC-45InteractiveC-45ExprSearch-firstSuccess arg-1 arg-2 (cons arg-3 (cons arg-4 '())))))
(define TTImpC-45InteractiveC-45ExprSearch-combine (lambda (arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (vector 1 '()) (let ((e-4 (car arg-6))) (let ((e-5 (cdr arg-6))) (if (null? arg-7) (vector 1 '()) (let ((e-10 (car arg-7))) (let ((e-11 (cdr arg-7))) (vector 1 (cons ((arg-5 e-4) e-10) (TTImpC-45InteractiveC-45ExprSearch-trySearch arg-3 arg-4 (lambda (eta-0) (let ((act-1 (e-11 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45InteractiveC-45ExprSearch-one e-4 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-combine arg-3 arg-4 arg-5 e-7 e-6))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (TTImpC-45InteractiveC-45ExprSearch-trySearch arg-3 arg-4 (lambda (eta-0) (let ((act-1 (e-5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45InteractiveC-45ExprSearch-one e-10 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-combine arg-3 arg-4 arg-5 e-6 e-7))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (eta-0) (let ((act-1 (e-5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (e-11 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-combine arg-3 arg-4 arg-5 e-6 e-7))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-collectClauses (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-2) (TTImpC-45InteractiveC-45ExprSearch-one '() ext-0) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((act-1 (TTImpC-45InteractiveC-45GenerateDef-collectClauses arg-0 arg-1 e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45ExprSearch-combine arg-0 arg-1 csegen-3808 e-2 e-5))) eff-0) ext-0))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-tryAllSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (if (null? e-7) (TTImpC-45InteractiveC-45GenerateDef-tryAllSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" 5 (lambda () (string-append "Splitting on " (CoreC-45Name-u--show_Show_Name e-6))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((TTImpC-45InteractiveC-45ExprSearch-trySearch arg-0 arg-2 (lambda (eta-1) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (TTImpC-45InteractiveC-45GenerateDef-mkSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 eta-2)) e-7 '()) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (TTImpC-45InteractiveC-45GenerateDef-collectClauses arg-0 arg-2 e-8 eta-2)))) eff-0) eta-1)))))) (TTImpC-45InteractiveC-45GenerateDef-tryAllSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-3)) eta-0)))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-mkSplits (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (TTImpC-45InteractiveC-45ExprSearch-trySearch arg-0 arg-2 (lambda (clam-0) (let ((sc0 (let ((e-7 (vector-ref arg-6 7))) e-7))) (cond ((equal? sc0 1) (TTImpC-45InteractiveC-45ExprSearch-noResult clam-0)) (else (TTImpC-45InteractiveC-45GenerateDef-expandClause arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 clam-0))))) (lambda (eta-0) (let ((act-1 (TTImpC-45InteractiveC-45GenerateDef-generateSplits arg-1 arg-0 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "interaction.generate" 5 (lambda () (string-append "Splits: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3803 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-3803 u--d u--x)))) e-5))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45GenerateDef-tryAllSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (let ((e-0 (vector-ref arg-6 0))) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((e-11 (vector-ref arg-6 5))) (let ((e-10 (vector-ref arg-6 6))) (let ((e-9 (vector-ref arg-6 9))) (vector e-0 e-1 e-2 e-3 e-4 e-11 e-10 0 1 e-9))))))))) arg-7 e-5) eta-1))))))) eff-0) eta-0)))))))))
(define TTImpC-45InteractiveC-45GenerateDef-makeDefFromType (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (CoreC-45UnifyState-tryUnify arg-0 arg-2 (lambda (eta-0) (let ((act-1 (CoreC-45Context-branch arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (let ((act-4 ((CoreC-45NormaliseC-45Eval-nf arg-0 '() e-5 '() arg-9) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45CaseSplit-getEnvArgNames arg-0 e-5 arg-8 e-8))) eff-0) eta-3))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--pre_env (DataC-45List-replicateTR '() arg-8 (vector 32 arg-5 1)))) (lambda (eta-4) (let ((act-5 (TTImpC-45Utils-uniqueHoleName arg-3 e-5 '() (string-append (TTImpC-45InteractiveC-45GenerateDef-fnName 0 arg-7) "_rhs") eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--initcs (vector 0 arg-5 (TTImpC-45TTImp-apply (vector 0 arg-5 arg-7) (PreludeC-45TypesC-45List-tailRecAppend u--pre_env (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-5) (vector 17 arg-5 eta-5)) e-8))) (vector 30 arg-5 e-9)))) (lambda (clam-0) (let ((sc5 (CoreC-45Context-getNameID arg-7 (let ((e-0 (vector-ref e-5 0))) e-0)))) (if (null? sc5) (CoreC-45Context-undefinedName arg-0 arg-5 arg-7 clam-0) (let ((e-1 (unbox sc5))) (let ((act-6 ((TTImpC-45InteractiveC-45GenerateDef-mkSplits arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 e-1 u--initcs) clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (let ((act-7 (set-box! arg-0 e-5))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (let ((act-8 (set-box! arg-1 e-6))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 (set-box! arg-2 e-7))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (vector 1 (CoreC-45CoreC-45Search-functor 'erased 'erased (lambda (u--c) (cons arg-5 u--c)) e-10)))))))))))))) eff-0) clam-0)))))))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) ext-0)))
(define TTImpC-45InteractiveC-45GenerateDef-makeDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (CoreC-45Metadata-findTyDeclAt arg-1 arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-noResult eta-0)) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (lambda (clam-0) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((act-2 (CoreC-45Context-getFullName arg-0 e-9 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45ContextC-45Log-logTerm '() arg-0 "interaction.generate" 5 (lambda () (string-append "Searching for " (CoreC-45Name-u--show_Show_Name e-8))) e-14 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((u--opts (let ((sc7 (TTImpC-45InteractiveC-45ExprSearch-initSearchOpts 1 5))) (let ((e-0 (vector-ref sc7 0))) (let ((e-19 (vector-ref sc7 1))) (let ((e-2 (vector-ref sc7 2))) (let ((e-3 (vector-ref sc7 3))) (let ((e-4 (vector-ref sc7 4))) (let ((e-18 (vector-ref sc7 5))) (let ((e-17 (vector-ref sc7 6))) (let ((e-16 (vector-ref sc7 7))) (let ((e-15 (vector-ref sc7 8))) (vector e-0 e-19 e-2 e-3 e-4 e-18 e-17 e-16 e-15 (box (lambda (eta-1) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (TTImpC-45InteractiveC-45GenerateDef-makeDefFromType arg-0 arg-1 arg-2 arg-3 arg-4 (CoreC-45FC-justFC e-7) eta-1 eta-2 eta-3 eta-4 eta-5)))))))))))))))))))) (TTImpC-45InteractiveC-45GenerateDef-makeDefFromType arg-0 arg-1 arg-2 arg-3 arg-4 (CoreC-45FC-justFC e-7) u--opts e-8 e-13 e-14 eta-0)))))))) eff-0) clam-0)))))))))))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45ExprSearch-n--11917-1990-u--returnBatch (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (if (null? arg-6) (TTImpC-45InteractiveC-45ExprSearch-searchSort arg-5 arg-4 arg-3 arg-7 arg-1 clam-0) (let ((e-2 (car arg-6))) (let ((e-3 (cdr arg-6))) (vector 1 (cons e-2 (TTImpC-45InteractiveC-45ExprSearch-n--11917-1990-u--returnBatch arg-1 arg-2 arg-3 arg-4 arg-5 e-3 arg-7)))))))))
(define TTImpC-45InteractiveC-45ExprSearch-searchSort (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (let ((sc2 (DataC-45List-isNil e-2))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 '()))) (else (TTImpC-45InteractiveC-45ExprSearch-n--11917-1990-u--returnBatch arg-5 arg-4 arg-3 arg-2 arg-1 (DataC-45List-sortBy arg-5 e-2) e-3)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45GenerateDef-makeDefSort (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (TTImpC-45InteractiveC-45ExprSearch-searchSort arg-0 arg-2 arg-6 (lambda (eta-0) (TTImpC-45InteractiveC-45GenerateDef-makeDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-8 eta-0)) (lambda (u--x) (lambda (u--y) ((arg-7 (Builtin-snd u--x)) (Builtin-snd u--y)))) ext-0)))
(define TTImpC-45InteractiveC-45MakeLemma-bindable (lambda (arg-1 arg-2) (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-2))) (if (null? sc0) 0 (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (case (vector-ref e-6 0) ((3) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) e-3)) ((2) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) e-3))(else 0)))) ((6) (let ((e-11 (vector-ref e-2 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) (cons e-11 e-3)))) ((7) (let ((e-16 (vector-ref e-2 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) (cons e-16 e-3)))) ((8) (let ((e-20 (vector-ref e-2 3))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 eta-0)) (cons e-20 e-3)))) ((0) (let ((e-25 (vector-ref e-2 3))) (if (null? e-3) (or (and (= arg-1 e-25) 1) 0) 0)))(else 0))))))))
(define TTImpC-45InteractiveC-45MakeLemma-bindableArg (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((3) (let ((e-3 (vector-ref arg-2 3))) (let ((e-4 (vector-ref arg-2 4))) (case (vector-ref e-3 0) ((2) (let ((e-9 (vector-ref e-3 4))) (let ((sc2 (TTImpC-45InteractiveC-45MakeLemma-bindable arg-1 e-9))) (cond ((equal? sc2 1) 1) (else (TTImpC-45InteractiveC-45MakeLemma-bindableArg (+ arg-1 1) e-4))))))(else 0)))))(else 0))))
(define TTImpC-45InteractiveC-45MakeLemma-hiddenName (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-0 (vector-ref arg-0 1))) (cond ((equal? e-0 "_") 1)(else 0))))(else 0))))
(define TTImpC-45InteractiveC-45MakeLemma-used (lambda (ext-0) (let ((sc0 (AlgebraC-45Semiring-isErased csegen-931 ext-0))) (cond ((equal? sc0 1) 0) (else 1)))))
(define TTImpC-45InteractiveC-45MakeLemma-getArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-4 0) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normalise arg-1 arg-0 e-5 arg-3 arg-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-3827 (TTImpC-45Unelab-unelab arg-0 arg-1 arg-3 e-6) eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (cons '() e-6))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))(else (let ((e-0 (- arg-4 1))) (lambda (clam-0) (case (vector-ref arg-5 0) ((3) (let ((e-3 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (case (vector-ref e-4 0) ((2) (let ((e-8 (vector-ref e-4 2))) (let ((e-10 (vector-ref e-4 4))) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normalise arg-1 arg-0 e-6 arg-3 e-10 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-3827 (TTImpC-45Unelab-unelab arg-0 arg-1 arg-3 e-11) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-11 (vector-ref act-2 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45Utils-uniqueBasicName e-6 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45Name-nameRoot eta-2)) arg-0) (CoreC-45Name-nameRoot e-3) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--xC-39 (vector 1 (vector 0 e-12)))) (lambda (eta-2) (let ((act-4 ((TTImpC-45InteractiveC-45MakeLemma-getArgs (cons u--xC-39 arg-0) arg-1 arg-2 (cons e-4 arg-3) e-0 (CoreC-45NameC-45Scoped-compat csegen-2277 e-5)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-13 (vector-ref act-4 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-4 1))) ((let ((eff-0 (let ((e-15 (car e-13))) (let ((e-14 (cdr e-13))) (let ((u--mn (let ((sc7 (AlgebraC-45ZeroOneOmega-u--C-61C-61_Eq_ZeroOneOmega e-8 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega))) (cond ((equal? sc7 1) (let ((sc8 (CoreC-45TTC-45Term-u--shrink_IsScoped_Term e-5 (vector 1 (vector 0 ))))) (if (null? sc8) (box u--xC-39) '()))) (else (box u--xC-39)))))) (let ((u--pC-39 (let ((sc7 (let ((sc8 (TTImpC-45InteractiveC-45MakeLemma-used e-8))) (cond ((equal? sc8 1) (let ((sc9 (TTImpC-45InteractiveC-45MakeLemma-bindableArg 0 e-5))) (cond ((equal? sc9 1) 0) (else (let ((sc10 (TTImpC-45InteractiveC-45MakeLemma-hiddenName e-3))) (cond ((equal? sc10 1) 0) (else 1))))))) (else 0))))) (cond ((equal? sc7 1) (vector 1 )) (else (vector 0 )))))) (lambda (eta-3) (vector 1 (cons (cons (cons e-3 (cons u--mn (cons u--pC-39 (cons e-8 e-11)))) e-15) e-14))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normalise arg-1 arg-0 e-6 arg-3 arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-3827 (TTImpC-45Unelab-unelab arg-0 arg-1 arg-3 e-7) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons '() e-7))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))(else (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normalise arg-1 arg-0 e-5 arg-3 arg-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-3827 (TTImpC-45Unelab-unelab arg-0 arg-1 arg-3 e-6) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons '() e-6))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-n--10236-5771-u--getArg (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) '() (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) '() (let ((e-7 (cdr e-3))) (if (null? e-7) '() (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (case (vector-ref e-10 0) ((1) (if (null? e-11) '() (box (vector 0 arg-2 e-2))))(else '()))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-mkApp (lambda (arg-0 arg-1 arg-2) (TTImpC-45TTImp-apply (vector 0 arg-0 arg-1) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (TTImpC-45InteractiveC-45MakeLemma-n--10236-5771-u--getArg arg-2 arg-1 arg-0 eta-0)) arg-2))))
(define TTImpC-45InteractiveC-45MakeLemma-mkType (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) arg-2 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((e-14 (car e-11))) (let ((e-15 (cdr e-11))) (let ((e-18 (car e-15))) (let ((e-19 (cdr e-15))) (vector 1 arg-0 e-18 e-14 e-10 e-19 (TTImpC-45InteractiveC-45MakeLemma-mkType arg-0 e-3 arg-2))))))))))))))
(define TTImpC-45InteractiveC-45MakeLemma-makeLemma (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (CoreC-45Normalise-normalise arg-1 '() e-5 '() arg-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (TTImpC-45InteractiveC-45MakeLemma-getArgs '() arg-1 arg-2 '() arg-5 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-6))) (let ((e-3 (cdr e-6))) (vector 1 (cons (TTImpC-45InteractiveC-45MakeLemma-mkType arg-3 e-2 e-3) (TTImpC-45InteractiveC-45MakeLemma-mkApp arg-3 arg-4 e-2)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45MakeClause-n--5101-9231-u--pref (lambda (arg-0 arg-1 arg-2 arg-3) (ParserC-45Unlit-relit arg-2 (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-3 #\ )))))
(define IdrisC-45IDEModeC-45MakeClause-n--5101-9229-u--mkWithArg (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (string-append (IdrisC-45IDEModeC-45MakeClause-n--5101-9231-u--pref arg-0 arg-1 arg-2 arg-3) (string-append arg-4 "with (_)"))))
(define IdrisC-45IDEModeC-45MakeClause-showRHSName (lambda (arg-0) (let ((u--fn (CoreC-45Name-u--show_Show_Name (CoreC-45Name-dropNS arg-0)))) (let ((sc0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-107 (lambda (eta-0) (CoreC-45Name-isOpChar eta-0)) (PreludeC-45Types-fastUnpack u--fn)))) (cond ((equal? sc0 1) "op") (else u--fn))))))
(define IdrisC-45IDEModeC-45MakeClause-n--5101-9230-u--mkWithPat (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (string-append (IdrisC-45IDEModeC-45MakeClause-n--5101-9231-u--pref arg-0 arg-1 arg-2 (+ arg-3 2)) (string-append arg-4 (string-append "| with_pat = ?" (string-append (IdrisC-45IDEModeC-45MakeClause-showRHSName arg-1) "_rhs"))))))
(define IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-2 0) (if (null? arg-3) (if (null? arg-3) '() (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\() (cons #\( (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (+ arg-2 1) e-2))) ((equal? e-1 #\{) (cons #\{ (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (+ arg-2 1) e-2))) ((equal? e-1 #\)) (cons #\) (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2))) ((equal? e-1 #\}) (cons #\} (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2)))(else (cons e-1 (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 arg-2 e-2))))))) (let ((e-5 (car arg-3))) (cond ((equal? e-5 #\=) '())(else (if (null? arg-3) '() (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\() (cons #\( (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (+ arg-2 1) e-2))) ((equal? e-1 #\{) (cons #\{ (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (+ arg-2 1) e-2))) ((equal? e-1 #\)) (cons #\) (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2))) ((equal? e-1 #\}) (cons #\} (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2)))(else (cons e-1 (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 arg-2 e-2))))))))))))(else (if (null? arg-3) '() (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cond ((equal? e-1 #\() (cons #\( (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (+ arg-2 1) e-2))) ((equal? e-1 #\{) (cons #\{ (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (+ arg-2 1) e-2))) ((equal? e-1 #\)) (cons #\) (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2))) ((equal? e-1 #\}) (cons #\} (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 (DataC-45Nat-pred arg-2) e-2)))(else (cons e-1 (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 arg-2 e-2)))))))))))
(define IdrisC-45IDEModeC-45MakeClause-case--makeWith-9352 (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((u--isrc (let ((sc1 (DataC-45String-span (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (cons (PreludeC-45TypesC-45String-length e-5) e-4)))))) (let ((u--indent (Builtin-fst u--isrc))) (let ((u--src (Builtin-snd u--isrc))) (let ((u--lhs (PreludeC-45Types-fastPack (IdrisC-45IDEModeC-45MakeClause-n--5101-9232-u--readLHS arg-0 arg-1 0 (PreludeC-45Types-fastUnpack u--src))))) (string-append (IdrisC-45IDEModeC-45MakeClause-n--5101-9229-u--mkWithArg arg-0 arg-1 e-2 u--indent u--lhs) (string-append "\xa;" (IdrisC-45IDEModeC-45MakeClause-n--5101-9230-u--mkWithPat arg-0 arg-1 e-2 u--indent u--lhs)))))))))))
(define IdrisC-45IDEModeC-45MakeClause-makeWith (lambda (arg-0 arg-1) (IdrisC-45IDEModeC-45MakeClause-case--makeWith-9352 arg-1 arg-0 (ParserC-45Unlit-isLitLine arg-1))))
(define TTImpC-45InteractiveC-45GenerateDef-bindableUsed (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((u--lhsns (TTImpC-45Utils-findIBindVars e-2))) (let ((u--rhsns (TTImpC-45Utils-findAllNames '() e-3))) (box (cons u--lhsns (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--x) (PreludeC-45Types-elem csegen-14 csegen-832 u--x u--lhsns)) u--rhsns))))))))(else '()))))
(define TTImpC-45InteractiveC-45GenerateDef-n--14466-3162-u--getProp (lambda (arg-0 arg-1) (if (null? arg-1) (cons 0 0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (TTImpC-45InteractiveC-45GenerateDef-n--14466-3162-u--getProp arg-0 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (TTImpC-45InteractiveC-45GenerateDef-bindableUsed e-2))) (if (null? sc2) (cons e-5 e-4) (let ((e-6 (unbox sc2))) (let ((e-8 (car e-6))) (let ((e-7 (cdr e-6))) (cons (+ e-5 (PreludeC-45TypesC-45List-lengthTR (DataC-45List-nub csegen-832 e-8))) (+ e-4 (PreludeC-45TypesC-45List-lengthTR (DataC-45List-nub csegen-832 e-7)))))))))))))))))
(define TTImpC-45InteractiveC-45GenerateDef-case--propBindableUsed-3257 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((sc1 (or (and (= e-2 0) 1) 0))) (cond ((equal? sc1 1) 1.0) (else (/ (exact->inexact e-3) (exact->inexact e-2)))))))))
(define TTImpC-45InteractiveC-45GenerateDef-propBindableUsed (lambda (arg-0) (TTImpC-45InteractiveC-45GenerateDef-case--propBindableUsed-3257 arg-0 (TTImpC-45InteractiveC-45GenerateDef-n--14466-3162-u--getProp arg-0 arg-0))))
(define TTImpC-45InteractiveC-45GenerateDef-mostUsed (lambda (arg-0 arg-1) (PreludeC-45EqOrd-u--compare_Ord_Double (TTImpC-45InteractiveC-45GenerateDef-propBindableUsed arg-1) (TTImpC-45InteractiveC-45GenerateDef-propBindableUsed arg-0))))
(define TTImpC-45InteractiveC-45ExprSearch-nextResult (lambda (arg-1 arg-2 arg-3 ext-0) (CoreC-45UnifyState-tryUnify arg-1 arg-2 (lambda (eta-0) (let ((act-1 (arg-3 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (vector 1 '()) (let ((e-4 (car e-5))) (let ((e-6 (cdr e-5))) (vector 1 (box (cons e-4 e-6))))))))) eff-0) eta-0)))))) (lambda (eta-0) (vector 1 '())) ext-0)))
(define IdrisC-45REPL-case--nextGenDef-7836 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (if (null? arg-5) (vector 1 '()) (let ((e-1 (unbox arg-5))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-1 (TTImpC-45InteractiveC-45ExprSearch-nextResult arg-3 arg-2 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref arg-4 0))) (let ((e-20 (vector-ref arg-4 1))) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-19 (vector-ref arg-4 5))) (let ((e-18 (vector-ref arg-4 6))) (let ((e-17 (vector-ref arg-4 7))) (let ((e-8 (vector-ref arg-4 8))) (let ((e-9 (vector-ref arg-4 9))) (let ((e-10 (vector-ref arg-4 10))) (let ((e-12 (vector-ref arg-4 12))) (let ((e-13 (vector-ref arg-4 13))) (let ((e-14 (vector-ref arg-4 14))) (let ((e-15 (vector-ref arg-4 15))) (let ((e-16 (vector-ref arg-4 16))) (vector e-0 e-20 e-2 e-3 e-4 e-19 e-18 e-17 e-8 e-9 e-10 '() e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 '())))) (let ((e-2 (unbox e-7))) (let ((e-9 (car e-2))) (let ((e-8 (cdr e-2))) (let ((act-2 (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref arg-4 0))) (let ((e-23 (vector-ref arg-4 1))) (let ((e-22 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((e-4 (vector-ref arg-4 4))) (let ((e-21 (vector-ref arg-4 5))) (let ((e-20 (vector-ref arg-4 6))) (let ((e-19 (vector-ref arg-4 7))) (let ((e-18 (vector-ref arg-4 8))) (let ((e-17 (vector-ref arg-4 9))) (let ((e-10 (vector-ref arg-4 10))) (let ((e-12 (vector-ref arg-4 12))) (let ((e-13 (vector-ref arg-4 13))) (let ((e-14 (vector-ref arg-4 14))) (let ((e-15 (vector-ref arg-4 15))) (let ((e-16 (vector-ref arg-4 16))) (vector e-0 e-23 e-22 e-3 e-4 e-21 e-20 e-19 e-18 e-17 e-10 (box (cons e-5 e-8)) e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (cond ((equal? arg-0 0) (vector 1 (box (cons e-5 e-9))))(else (let ((e-0 (- arg-0 1))) (IdrisC-45REPL-nextGenDef arg-3 arg-2 arg-1 e-0 clam-1)))))))))))))) eff-0) clam-0))))))))))))
(define IdrisC-45REPL-nextGenDef (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45REPL-case--nextGenDef-7836 arg-3 arg-2 arg-1 arg-0 e-5 (let ((e-11 (vector-ref e-5 11))) e-11)))) eff-0) ext-0)))))))
(define IdrisC-45REPL-case--nextProofSearch-7615 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (lambda (clam-0) (if (null? arg-4) (vector 1 '()) (let ((e-1 (unbox arg-4))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (let ((act-1 (TTImpC-45InteractiveC-45ExprSearch-nextResult arg-2 arg-1 e-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref arg-3 0))) (let ((e-20 (vector-ref arg-3 1))) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-19 (vector-ref arg-3 5))) (let ((e-18 (vector-ref arg-3 6))) (let ((e-17 (vector-ref arg-3 7))) (let ((e-8 (vector-ref arg-3 8))) (let ((e-9 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (vector e-0 e-20 e-2 e-3 e-4 e-19 e-18 e-17 e-8 e-9 '() e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 '())))) (let ((e-2 (unbox e-7))) (let ((e-9 (car e-2))) (let ((e-8 (cdr e-2))) (let ((act-2 (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref arg-3 0))) (let ((e-23 (vector-ref arg-3 1))) (let ((e-22 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (let ((e-21 (vector-ref arg-3 5))) (let ((e-20 (vector-ref arg-3 6))) (let ((e-19 (vector-ref arg-3 7))) (let ((e-18 (vector-ref arg-3 8))) (let ((e-17 (vector-ref arg-3 9))) (let ((e-11 (vector-ref arg-3 11))) (let ((e-12 (vector-ref arg-3 12))) (let ((e-13 (vector-ref arg-3 13))) (let ((e-14 (vector-ref arg-3 14))) (let ((e-15 (vector-ref arg-3 15))) (let ((e-16 (vector-ref arg-3 16))) (vector e-0 e-23 e-22 e-3 e-4 e-21 e-20 e-19 e-18 e-17 (box (cons e-5 e-8)) e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 (box (cons e-5 e-9))))))))))))) eff-0) clam-0))))))))))))
(define IdrisC-45REPL-nextProofSearch (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45REPL-case--nextProofSearch-7615 arg-2 arg-1 arg-0 e-5 (let ((e-10 (vector-ref e-5 10))) e-10)))) eff-0) ext-0)))))))
(define IdrisC-45REPL-printClause (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (let ((e-2 (vector-ref arg-4 2))) (let ((e-3 (vector-ref arg-4 3))) (let ((act-1 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (ParserC-45Unlit-relit arg-2 (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-3 #\ )) (string-append (IdrisC-45Syntax-u--show_Show_IPTerm e-5) (string-append " = " (IdrisC-45Syntax-u--show_Show_IPTerm e-6))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))) ((1) (let ((e-6 (vector-ref arg-4 2))) (let ((e-7 (vector-ref arg-4 3))) (let ((e-8 (vector-ref arg-4 4))) (let ((e-9 (vector-ref arg-4 5))) (let ((e-11 (vector-ref arg-4 7))) (let ((act-1 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-6) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-1) (CoreC-45TT-defaultKindedName eta-1)) e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPL-printClause arg-0 arg-1 arg-2 (+ arg-3 2) eta-2 eta-3))) e-11 '()) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (string-append (ParserC-45Unlit-relit arg-2 (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-3 #\ )) (string-append (IdrisC-45Syntax-u--show_Show_IPTerm e-12) (string-append " with " (string-append (AlgebraC-45Semiring-elimSemi csegen-931 "0 " "1 " (lambda (eta-3) "") e-7) (string-append "(" (string-append (IdrisC-45Syntax-u--show_Show_IPTerm e-13) (string-append ")" (string-append (PreludeC-45Types-maybe (lambda () "") (lambda () csegen-851) e-9) "\xa;"))))))))) (CoreC-45NameC-45Namespace-showSep "\xa;" e-14)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) (else (let ((e-14 (vector-ref arg-4 2))) (let ((act-1 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (ParserC-45Unlit-relit arg-2 (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-3 #\ )) (string-append (IdrisC-45Syntax-u--show_Show_IPTerm e-5) " impossible"))))))) eff-0) ext-0))))))))))
(define CoreC-45FC-startCol (lambda (ext-0) (Builtin-snd (CoreC-45FC-startPos ext-0))))
(define IdrisC-45IDEModeC-45CaseSplit-isWhitespace (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define DataC-45SnocList-findIndex (lambda (arg-1 arg-2) (if (null? arg-2) '() (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (arg-1 e-3))) (cond ((equal? sc1 1) (box 0)) (else (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (+ eta-0 1)) (DataC-45SnocList-findIndex arg-1 e-2))))))))))
(define IdrisC-45IDEModeC-45TokenLine-toString (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) ((1) (let ((e-1 (vector-ref arg-0 1))) e-1)) ((2) (let ((e-2 (vector-ref arg-0 1))) (string-append "?" e-2))) ((3) "{") ((4) "}") ((5) "=") ((6) "@") (else (let ((e-3 (vector-ref arg-0 1))) e-3)))))
(define IdrisC-45IDEModeC-45CaseSplit-n--12838-3242-u--calcIndent (lambda (arg-0 arg-1 arg-2) (let ((sc0 (DataC-45List-splitAt arg-1 arg-2))) (let ((e-2 (car sc0))) (PreludeC-45Types-u--foldr_Foldable_List (lambda (u--e) (lambda (u--a) (+ u--a (PreludeC-45TypesC-45String-length (IdrisC-45IDEModeC-45TokenLine-toString u--e))))) 0 e-2)))))
(define IdrisC-45IDEModeC-45CaseSplit-n--12838-3243-u--isNameOf (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((1) (let ((e-0 (vector-ref arg-1 1))) (cond ((equal? e-0 "of") 1)(else 0))))(else 0))))
(define IdrisC-45IDEModeC-45CaseSplit-case--getCaseStmtType-3320 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (if (null? e-1) (case (vector-ref e-2 0) ((2) (let ((sc3 (DataC-45SnocList-findIndex (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--12838-3243-u--isNameOf arg-0 eta-0)) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-0)))) (if (null? sc3) '() (let ((e-4 (unbox sc3))) (let ((u--ofIndex (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-0) e-4)))) (box (vector 0 (IdrisC-45IDEModeC-45CaseSplit-n--12838-3242-u--calcIndent arg-0 u--ofIndex arg-0))))))))(else '())) (let ((e-6 (cdr e-1))) (case (vector-ref e-6 0) ((2) (case (vector-ref e-2 0) ((7) (let ((e-8 (vector-ref e-2 1))) (cond ((equal? e-8 ")") (let ((sc5 (DataC-45SnocList-findIndex (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--12838-3243-u--isNameOf arg-0 eta-0)) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-0)))) (if (null? sc5) (box (vector 2 )) (let ((e-3 (unbox sc5))) (let ((u--ofIndex (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-0) e-3)))) (box (vector 1 (IdrisC-45IDEModeC-45CaseSplit-n--12838-3242-u--calcIndent arg-0 u--ofIndex arg-0))))))))(else (case (vector-ref e-2 0) ((2) (let ((sc5 (DataC-45SnocList-findIndex (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--12838-3243-u--isNameOf arg-0 eta-0)) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-0)))) (if (null? sc5) '() (let ((e-4 (unbox sc5))) (let ((u--ofIndex (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-0) e-4)))) (box (vector 0 (IdrisC-45IDEModeC-45CaseSplit-n--12838-3242-u--calcIndent arg-0 u--ofIndex arg-0))))))))(else '()))))))(else (case (vector-ref e-2 0) ((2) (let ((sc4 (DataC-45SnocList-findIndex (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--12838-3243-u--isNameOf arg-0 eta-0)) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-0)))) (if (null? sc4) '() (let ((e-4 (unbox sc4))) (let ((u--ofIndex (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-0) e-4)))) (box (vector 0 (IdrisC-45IDEModeC-45CaseSplit-n--12838-3242-u--calcIndent arg-0 u--ofIndex arg-0))))))))(else '())))))(else (case (vector-ref e-2 0) ((2) (let ((sc3 (DataC-45SnocList-findIndex (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--12838-3243-u--isNameOf arg-0 eta-0)) (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() arg-0)))) (if (null? sc3) '() (let ((e-4 (unbox sc3))) (let ((u--ofIndex (PreludeC-45Types-prim__integerToNat (- (PreludeC-45TypesC-45List-lengthTR arg-0) e-4)))) (box (vector 0 (IdrisC-45IDEModeC-45CaseSplit-n--12838-3242-u--calcIndent arg-0 u--ofIndex arg-0))))))))(else '())))))))))))
(define IdrisC-45IDEModeC-45CaseSplit-getCaseStmtType (lambda (arg-0) (let ((u--nws (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (let ((sc0 (IdrisC-45IDEModeC-45CaseSplit-isWhitespace eta-0))) (cond ((equal? sc0 1) 0) (else 1)))) arg-0))) (IdrisC-45IDEModeC-45CaseSplit-case--getCaseStmtType-3320 arg-0 u--nws (PreludeC-45TypesC-45SnocList-C-60C-62C-60 '() u--nws)))))
(define IdrisC-45IDEModeC-45CaseSplit-n--11984-2480-u--bracket (lambda (arg-0 arg-1 arg-2 arg-3 arg-5) (case (vector-ref arg-5 0) ((0) arg-5) ((38) arg-5) ((39) arg-5) ((40) arg-5) ((42) arg-5) ((44) arg-5) ((15) arg-5)(else (vector 32 CoreC-45FC-emptyFC arg-5)))))
(define IdrisC-45IDEModeC-45CaseSplit-toStrUpdate (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (case (vector-ref e-4 0) ((0) (let ((e-5 (vector-ref e-4 1))) (let ((act-1 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (cons e-5 (IdrisC-45Syntax-u--show_Show_IPTerm (IdrisC-45IDEModeC-45CaseSplit-n--11984-2480-u--bracket e-5 e-3 arg-1 arg-0 e-6))) '()))))) eff-0) clam-0)))))))(else (vector 1 '())))))(else (vector 1 '())))))))))
(define IdrisC-45IDEModeC-45CaseSplit-getReplaces (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-toStrUpdate arg-0 arg-1 eta-0)) arg-3 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-1) eta-1) e-5))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45CaseSplit-with--dropLast-3437 (lambda (arg-0 arg-1) (if (null? arg-0) (case (vector-ref arg-1 0) ((0) '())(else (let ((e-2 (vector-ref arg-1 2))) e-2))) (let ((e-2 (vector-ref arg-1 2))) e-2))))
(define IdrisC-45IDEModeC-45CaseSplit-dropLast (lambda (arg-0) (IdrisC-45IDEModeC-45CaseSplit-with--dropLast-3437 arg-0 (DataC-45ListC-45Views-snocList arg-0))))
(define IdrisC-45IDEModeC-45CaseSplit-rtrim (lambda (ext-0) (string-reverse (DataC-45String-ltrim (string-reverse ext-0)))))
(define IdrisC-45IDEModeC-45CaseSplit-parenTrim (lambda (ext-0) (IdrisC-45IDEModeC-45CaseSplit-rtrim (PreludeC-45Types-fastPack (IdrisC-45IDEModeC-45CaseSplit-dropLast (PreludeC-45Types-fastUnpack ext-0))))))
(define IdrisC-45IDEModeC-45CaseSplit-with--handleHoleNameParen-3591 (lambda (arg-0 arg-1) (if (null? arg-0) (case (vector-ref arg-1 0) ((0) '())(else (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-parenTrim eta-0)) e-2) (cons e-1 '())))))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-parenTrim eta-0)) e-2) (cons e-1 '())))))))
(define IdrisC-45IDEModeC-45CaseSplit-handleHoleNameParen (lambda (arg-0) (IdrisC-45IDEModeC-45CaseSplit-with--handleHoleNameParen-3591 arg-0 (DataC-45ListC-45Views-snocList arg-0))))
(define IdrisC-45IDEModeC-45CaseSplit-onelineIndent (lambda (arg-0 ext-0) (DataC-45String-indent arg-0 (PreludeC-45Types-fastPack (DataC-45List-drop arg-0 (PreludeC-45Types-fastUnpack ext-0))))))
(define IdrisC-45IDEModeC-45CaseSplit-handleOneline (lambda (arg-0 arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-onelineIndent arg-0 eta-0)) e-3)))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--13148-3567-u--handleMiddle (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cons (IdrisC-45IDEModeC-45CaseSplit-parenTrim (IdrisC-45IDEModeC-45CaseSplit-onelineIndent arg-3 e-2)) (IdrisC-45IDEModeC-45CaseSplit-n--13148-3567-u--handleMiddle arg-0 arg-1 arg-2 arg-3 e-3)))))))
(define IdrisC-45IDEModeC-45CaseSplit-with--handleOnelineParen-3549 (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (case (vector-ref arg-1 0) ((0) '())(else (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45IDEModeC-45CaseSplit-n--13148-3567-u--handleMiddle e-1 e-2 e-3 arg-2 e-2) (cons (IdrisC-45IDEModeC-45CaseSplit-onelineIndent arg-2 e-1) '()))))))) (let ((e-1 (vector-ref arg-1 1))) (let ((e-2 (vector-ref arg-1 2))) (let ((e-3 (vector-ref arg-1 3))) (PreludeC-45TypesC-45List-tailRecAppend (IdrisC-45IDEModeC-45CaseSplit-n--13148-3567-u--handleMiddle e-1 e-2 e-3 arg-2 e-2) (cons (IdrisC-45IDEModeC-45CaseSplit-onelineIndent arg-2 e-1) '()))))))))
(define IdrisC-45IDEModeC-45CaseSplit-handleOnelineParen (lambda (arg-0 arg-1) (IdrisC-45IDEModeC-45CaseSplit-with--handleOnelineParen-3549 arg-1 (DataC-45ListC-45Views-snocList arg-1) arg-0)))
(define IdrisC-45IDEModeC-45CaseSplit-handleCaseStmtType (lambda (arg-0 arg-1) (if (null? arg-0) '() (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref arg-1 0) ((0) (let ((e-4 (vector-ref arg-1 1))) (IdrisC-45IDEModeC-45CaseSplit-handleOneline e-4 (cons e-2 e-3)))) ((1) (let ((e-5 (vector-ref arg-1 1))) (cons (IdrisC-45IDEModeC-45CaseSplit-parenTrim e-2) (IdrisC-45IDEModeC-45CaseSplit-handleOnelineParen e-5 e-3))))(else (IdrisC-45IDEModeC-45CaseSplit-handleHoleNameParen arg-0))))))))
(define IdrisC-45IDEModeC-45CaseSplit-showImpossible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (IdrisC-45Resugar-pterm arg-0 arg-1 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-0) (CoreC-45TT-defaultKindedName eta-0)) arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (PreludeC-45Types-fastPack (DataC-45List-replicateTR '() arg-3 #\ )) (string-append (IdrisC-45Syntax-u--show_Show_IPTerm e-5) " impossible")))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45TokenLine-holeIdent csegen-436)
(define IdrisC-45IDEModeC-45TokenLine-srcTokens (cons (cons ParserC-45LexerC-45Common-identNormal (lambda (eta-0) (vector 1 eta-0))) (cons (cons IdrisC-45IDEModeC-45TokenLine-holeIdent (lambda (u--x) (vector 2 (substring u--x 1 (string-length u--x))))) (cons (cons LibrariesC-45TextC-45Lexer-space (lambda (eta-0) (vector 0 eta-0))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\{) (lambda (eta-0) (vector 3 ))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\}) (lambda (eta-0) (vector 4 ))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\=) (lambda (eta-0) (vector 5 ))) (cons (cons (LibrariesC-45TextC-45Lexer-is #\@) (lambda (eta-0) (vector 6 ))) (cons (cons LibrariesC-45TextC-45Lexer-any (lambda (eta-0) (vector 7 eta-0))) '())))))))))
(define IdrisC-45IDEModeC-45TokenLine-case--tokens-991 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((e-11 (cdr e-7))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() csegen-4712 e-2) (let ((sc3 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-11 ""))) (cond ((equal? sc3 1) '()) (else (cons (vector 7 e-11) '())))))))))))
(define IdrisC-45IDEModeC-45TokenLine-tokens (lambda (arg-0) (IdrisC-45IDEModeC-45TokenLine-case--tokens-991 arg-0 (LibrariesC-45TextC-45LexerC-45Core-lex IdrisC-45IDEModeC-45TokenLine-srcTokens arg-0))))
(define IdrisC-45IDEModeC-45CaseSplit-doUpdates (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (case (vector-ref e-2 0) ((1) (let ((e-4 (vector-ref e-2 1))) (if (null? e-3) (lambda (clam-1) (let ((sc3 (DataC-45List-lookup csegen-22 e-4 arg-3))) (if (null? sc3) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 1 e-4) e-5))))) eff-0) clam-1))))) (let ((e-5 (unbox sc3))) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 7 e-5) e-6))))) eff-0) clam-1))))))))) (let ((e-7 (car e-3))) (let ((e-8 (cdr e-3))) (lambda (clam-0) (case (vector-ref e-7 0) ((6) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-8) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 1 e-4) (cons (vector 6 ) e-5)))))) eff-0) clam-0))))))(else (let ((sc3 (DataC-45List-lookup csegen-22 e-4 arg-3))) (if (null? sc3) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 1 e-4) e-5))))) eff-0) clam-0))))) (let ((e-5 (unbox sc3))) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 7 e-5) e-6))))) eff-0) clam-0)))))))))))))))) ((6) (lambda (clam-1) (if (null? e-3) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 e-5))))) eff-0) clam-1))))) (let ((e-10 (car e-3))) (let ((e-11 (cdr e-3))) (case (vector-ref e-10 0) ((3) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-11) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 6 ) (cons (vector 3 ) e-5)))))) eff-0) clam-1))))))(else (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) clam-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons e-2 e-5))))) eff-0) clam-1)))))))))))) ((3) (let ((sc2 (DataC-45List-span (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-isWhitespace eta-0)) e-3))) (let ((e-5 (car sc2))) (let ((e-4 (cdr sc2))) (if (null? e-4) (lambda (eta-0) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend '() e-6)))))) eff-0) eta-0)))))) (let ((e-1 (car e-4))) (let ((e-6 (cdr e-4))) (case (vector-ref e-1 0) ((1) (let ((e-7 (vector-ref e-1 1))) (let ((sc5 (DataC-45List-span (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-isWhitespace eta-0)) e-6))) (let ((e-9 (car sc5))) (let ((e-8 (cdr sc5))) (if (null? e-8) (lambda (eta-0) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-6) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-10 (vector-ref act-1 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 e-10)))))))) eff-0) eta-0)))))) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (lambda (clam-2) (case (vector-ref e-11 0) ((4) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons (vector 4 ) e-10)))) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-12 (vector-ref act-1 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (cons (vector 0 " ") (cons (vector 5 ) (cons (vector 0 " ") e-12)))))))))) eff-0) clam-2)))))) ((5) (let ((sc8 (DataC-45List-span (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-isWhitespace eta-0)) e-10))) (let ((e-13 (car sc8))) (let ((e-12 (cdr sc8))) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-12) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-14 (vector-ref act-1 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 (cons (vector 5 ) (PreludeC-45TypesC-45List-tailRecAppend e-13 e-14)))))))))) eff-0) clam-2)))))))))(else (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-6) clam-2))) (case (vector-ref act-1 0) ((0) (let ((e-12 (vector-ref act-1 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend e-5 (cons (vector 1 e-7) (PreludeC-45TypesC-45List-tailRecAppend e-9 e-12)))))))) eff-0) clam-2))))))))))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (vector 3 ) (PreludeC-45TypesC-45List-tailRecAppend '() e-7)))))) eff-0) eta-0))))))))))))))) ((2) (let ((e-5 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (TTImpC-45Utils-uniqueHoleName arg-0 arg-2 e-6 e-5 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (let ((act-3 (set-box! arg-1 (cons e-7 e-6)))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((act-4 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons (vector 2 e-7) e-9))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))(else (lambda (eta-0) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 arg-3 e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-2 e-5))))) eff-0) eta-0)))))))))))))
(define IdrisC-45IDEModeC-45CaseSplit-updateAll (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (if (null? arg-4) (vector 1 '()) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((act-1 ((IdrisC-45IDEModeC-45CaseSplit-doUpdates arg-0 arg-1 arg-2 e-2 arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45IDEModeC-45CaseSplit-updateAll arg-0 arg-1 arg-2 arg-3 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) (IdrisC-45IDEModeC-45TokenLine-toString eta-2)) e-5) e-6))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--13261-3675-u--getBad (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((1) (let ((e-0 (vector-ref arg-6 1))) (box e-0)))(else '()))))
(define IdrisC-45IDEModeC-45CaseSplit-n--13261-3676-u--getIndent (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) arg-6 (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (cond ((equal? e-2 #\ ) (IdrisC-45IDEModeC-45CaseSplit-n--13261-3676-u--getIndent arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (+ arg-6 1) e-3))(else arg-6)))))))
(define IdrisC-45IDEModeC-45CaseSplit-n--13261-3677-u--getValid (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 2))) (box e-1)))(else '()))))
(define IdrisC-45IDEModeC-45CaseSplit-case--updateCase-3740 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (if (null? arg-7) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "No file loaded") ext-0) (let ((e-2 (unbox arg-7))) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 e-2) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-3 (vector-ref e-5 1))) (let ((u--thisline (LibrariesC-45DataC-45ListC-45Extra-elemAt (DataC-45String-lines e-3) (PreludeC-45Types-prim__integerToNat arg-1)))) (if (null? u--thisline) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "File too short!") eta-0)) (let ((e-4 (unbox u--thisline))) (let ((u--valid (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--13261-3677-u--getValid arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) arg-2))) (let ((u--bad (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-n--13261-3675-u--getBad arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 eta-0)) arg-2))) (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-5 "interaction.casesplit" 3 (lambda () (string-append "Valid: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2710 u--valid))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (CoreC-45ContextC-45Log-log arg-5 "interaction.casesplit" 3 (lambda () (string-append "Bad: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-835 u--bad))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((sc6 (DataC-45List-isNil u--valid))) (cond ((equal? sc6 1) (let ((u--indent (IdrisC-45IDEModeC-45CaseSplit-n--13261-3676-u--getIndent arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 0 (PreludeC-45Types-fastUnpack e-4)))) ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45IDEModeC-45CaseSplit-showImpossible arg-5 arg-4 arg-3 u--indent eta-1 eta-2))) u--bad '()) eta-0))) (else (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (IdrisC-45IDEModeC-45CaseSplit-getReplaces arg-5 arg-4 arg-3 eta-1 eta-2))) u--valid '()) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--stok (IdrisC-45IDEModeC-45TokenLine-tokens e-4))) (lambda (eta-1) (let ((act-5 (let ((act-5 (unbox arg-5))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-9 (vector-ref act-5 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 ((CoreC-45Core-newRef (vector "Idris.IDEMode.CaseSplit.UPD" ) '()) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (IdrisC-45IDEModeC-45CaseSplit-updateAll arg-4 e-10 e-9 u--stok e-8 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (let ((sc11 (IdrisC-45IDEModeC-45CaseSplit-getCaseStmtType u--stok))) (if (null? sc11) e-11 (let ((e-12 (unbox sc11))) (IdrisC-45IDEModeC-45CaseSplit-handleCaseStmtType e-11 e-12)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))))))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 e-2 e-6) eta-0))))))) eff-0) ext-0)))))))))
(define IdrisC-45IDEModeC-45CaseSplit-updateCase (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-2))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45IDEModeC-45CaseSplit-case--updateCase-3740 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 (let ((e-3 (vector-ref e-5 3))) e-3) eta-0)))) eff-0) ext-0)))))))
(define IdrisC-45REPL-case--updateFile-7057 (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (if (null? arg-3) (vector 1 (vector 0 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)) (let ((e-1 (unbox arg-3))) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 e-1) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((let ((eff-0 (lambda (world-0) (let ((act-2 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 (string-append e-1 "~") e-2) world-0))) (vector 1 act-2))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 e-1 (DataC-45String-fastUnlines (arg-0 (DataC-45String-lines e-2)))) world-0))) (vector 1 act-3))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (vector 1 (vector 0 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-emptyDoc)))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 e-1 e-6) clam-1))))))) eff-0) ext-0)))))))))
(define IdrisC-45REPL-updateFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45REPL-case--updateFile-7057 arg-1 arg-0 e-5 (let ((e-3 (vector-ref e-5 3))) e-3) eta-0)))) eff-0) ext-0)))))))
(define CoreC-45FC-within (lambda (arg-0 arg-1) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-7 (cdr arg-1))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 (cons e-2 e-3) e-10))) (cond ((equal? sc3 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 (cons e-2 e-3) e-11)) (else 0))))))))))
(define TTImpC-45InteractiveC-45CaseSplit-u--show_Show_SplitError (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "No valid case splits") ((1) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append "Can't split on " (string-append (CoreC-45Name-u--show_Show_Name e-0) (string-append " (" (string-append e-1 ")"))))))) (else "No clause to split here"))))
(define IdrisC-45DocC-45Display-displayTerm (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-0 '() arg-2 '() arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45Resugar-resugar '() arg-0 arg-1 '() e-5 eta-0)))) eff-0) ext-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-5))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-n--24730-8720-u--prettyLocalName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (case (vector-ref arg-8 0) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-8)) ((0) (let ((e-2 (vector-ref arg-8 2))) (case (vector-ref e-2 0) ((1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-8))(else (let ((sc1 (CoreC-45Name-userNameRoot arg-8))) (if (null? sc1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Name-nameRoot arg-8)) (let ((e-3 (unbox sc1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2733 e-3))))))))(else (let ((sc0 (CoreC-45Name-userNameRoot arg-8))) (if (null? sc0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Name-nameRoot arg-8)) (let ((e-1 (unbox sc0))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2733 e-1))))))))
(define IdrisC-45REPL-case--processEdit-8952 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (let ((e-2 (car arg-14))) (let ((e-3 (cdr arg-14))) (if (null? e-3) (lambda (clam-2) (if (null? e-2) (CoreC-45Context-undefinedName arg-7 CoreC-45FC-replFC arg-10 clam-2) (let ((e-5 (unbox e-2))) (vector 1 (vector 0 e-5))))) (let ((e-10 (unbox e-3))) (if (null? e-10) (lambda (clam-1) (if (null? e-2) (CoreC-45Context-undefinedName arg-7 CoreC-45FC-replFC arg-10 clam-1) (let ((e-5 (unbox e-2))) (vector 1 (vector 0 e-5))))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (if (null? e-14) (lambda (clam-0) (if (null? e-2) (CoreC-45Context-undefinedName arg-7 CoreC-45FC-replFC arg-10 clam-0) (let ((e-5 (unbox e-2))) (vector 1 (vector 0 e-5))))) (let ((e-18 (cdr e-14))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-4 (vector-ref eta-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) e-5)))))) (lambda (eta-1) (IdrisC-45DocC-45Display-displayTerm arg-7 arg-5 arg-8 e-18 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45REPL-n--24730-8720-u--prettyLocalName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-13) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon e-5))))))) eff-0) eta-0)))))))))))))))))
(define CoreC-45TTC-45Views-underPis (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (cons '() (cons arg-2 arg-3)))(else (case (vector-ref arg-3 0) ((3) (let ((e-2 (vector-ref arg-3 2))) (let ((e-3 (vector-ref arg-3 3))) (let ((e-4 (vector-ref arg-3 4))) (case (vector-ref e-3 0) ((2) (let ((e-6 (vector-ref e-3 1))) (let ((e-7 (vector-ref e-3 2))) (let ((e-8 (vector-ref e-3 3))) (let ((e-9 (vector-ref e-3 4))) (let ((u--bd (vector 2 e-6 e-7 e-8 e-9))) (let ((sc2 (CoreC-45TTC-45Views-underPis (bs- arg-1 1 63) (cons u--bd arg-2) e-4))) (let ((e-10 (car sc2))) (let ((e-5 (cdr sc2))) (let ((e-12 (car e-5))) (let ((e-11 (cdr e-5))) (cons (cons e-10 e-2) (cons e-12 e-11))))))))))))) ((4) (let ((e-13 (vector-ref e-3 3))) (CoreC-45TTC-45Views-underPis arg-1 arg-2 (CoreC-45TTC-45TermC-45Subst-subst e-13 e-4))))(else (cons '() (cons arg-2 arg-3))))))))(else (cons '() (cons arg-2 arg-3))))))))
(define CoreC-45Env-lengthExplicitPi (lambda (arg-2) (if (null? arg-2) 0 (let ((e-4 (car arg-2))) (let ((e-5 (cdr arg-2))) (case (vector-ref e-4 0) ((2) (let ((e-9 (vector-ref e-4 3))) (case (vector-ref e-9 0) ((1) (+ (CoreC-45Env-lengthExplicitPi e-5) 1))(else (CoreC-45Env-lengthExplicitPi e-5)))))(else (CoreC-45Env-lengthExplicitPi e-5))))))))
(define TTImpC-45Utils-n--12201-3439-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 0) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45List-reverse arg-2))))(else (let ((e-0 (- arg-3 1))) (lambda (eta-0) (let ((act-1 (TTImpC-45Utils-uniqueHoleName arg-1 arg-0 arg-2 arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45Utils-n--12201-3439-u--go arg-0 arg-1 (cons e-5 arg-2) e-0 e-5))) eff-0) eta-0)))))))))))
(define TTImpC-45Utils-uniqueHoleNames (lambda (arg-0 arg-1 ext-0 ext-1) (TTImpC-45Utils-n--12201-3439-u--go arg-1 arg-0 '() ext-0 ext-1)))
(define TTImpC-45InteractiveC-45Intro-case--caseC-32blockC-32inC-32introCon-5097 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (case (vector-ref arg-15 0) ((6) (let ((e-6 (vector-ref arg-15 7))) (let ((u--gty (CoreC-45NormaliseC-45Eval-gnf arg-0 arg-8 arg-9))) (lambda (eta-0) (let ((act-1 ((PreludeC-45Basics-flip csegen-1298 e-6 (lambda (u--cons) (lambda (eta-1) (let ((act-1 ((CoreC-45Context-lookupCtxtExact u--cons (let ((e-40 (vector-ref arg-11 0))) e-40)) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-8 (vector-ref act-1 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-8) (lambda (eta-2) (vector 1 '())) (let ((e-9 (unbox e-8))) (let ((u--nargs (CoreC-45Env-lengthExplicitPi (Builtin-fst (let ((sc3 (CoreC-45TTC-45Views-underPis -1 '() (let ((e-30 (vector-ref e-9 2))) e-30)))) (let ((e-10 (cdr sc3))) e-10)))))) (lambda (eta-2) (let ((act-2 ((TTImpC-45Utils-uniqueHoleNames arg-2 arg-11 u--nargs (CoreC-45Name-nameRoot arg-7)) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-10 (vector-ref act-2 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--new_holes (PreludeC-45TypesC-45List-mapAppend '() csegen-3874 e-10))) (let ((u--pcons (IdrisC-45Syntax-papply CoreC-45FC-replFC (vector 0 CoreC-45FC-replFC u--cons) u--new_holes))) (lambda (eta-3) (let ((act-3 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-3 (IdrisC-45Desugar-desugar arg-2 arg-1 arg-3 arg-4 arg-5 1 arg-0 u--pcons eta-4))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-4 (TTImpC-45Elab-checkTerm arg-0 arg-1 arg-3 arg-4 arg-2 arg-5 arg-6 (vector 2 ) '() '() arg-8 e-11 u--gty eta-5))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-5 (let ((act-5 (unbox arg-1))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-6 (CoreC-45Normalise-normaliseHoles arg-1 arg-0 e-13 arg-8 e-12 eta-7))) (case (vector-ref act-6 0) ((0) (let ((e-14 (vector-ref act-6 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-7 ((TTImpC-45Unelab-unelab arg-0 arg-1 arg-8 e-14) eta-8))) (case (vector-ref act-7 0) ((0) (let ((e-15 (vector-ref act-7 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-9) (vector 1 (box e-15))))) eff-0) eta-8)))))))) eff-0) eta-7)))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))) (lambda (_-5267) (lambda (eta-4) (vector 1 '()))) eta-3))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-4 (let ((act-4 (set-box! arg-1 arg-11))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-12 (vector-ref act-4 1))) (vector 0 e-12))) (else (let ((act-5 (let ((act-5 (set-box! arg-4 arg-12))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-13 (vector-ref act-5 1))) (vector 0 e-13))) (else (vector 1 e-11)))))))))) eff-0) eta-3)))))))))) eff-0) eta-2))))))))))) eff-0) eta-1)))))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-8 (vector-ref act-1 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (DataC-45List-catMaybes e-8))))) eff-0) eta-0)))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define TTImpC-45InteractiveC-45Intro-introCon (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact arg-9 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (vector 1 '())) (let ((e-1 (unbox e-7))) (let ((_-0 (box e-1))) (TTImpC-45InteractiveC-45Intro-case--caseC-32blockC-32inC-32introCon-5097 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10 arg-9 e-5 e-6 e-1 _-0 (let ((e-18 (vector-ref e-1 18))) e-18))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45Intro-introLam (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 ext-0) (let ((act-1 ((TTImpC-45Unelab-unelab arg-0 arg-1 arg-8 arg-11) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (TTImpC-45Utils-uniqueHoleName arg-2 e-6 '() (CoreC-45Name-nameRoot arg-7) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--iintrod (vector 2 CoreC-45FC-replFC arg-10 (vector 1 ) (box arg-9) e-5 (vector 30 CoreC-45FC-replFC e-7)))) (lambda (eta-2) (vector 1 u--iintrod))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45Intro-intro (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((3) (let ((e-2 (vector-ref arg-9 2))) (let ((e-3 (vector-ref arg-9 3))) (let ((e-4 (vector-ref arg-9 4))) (case (vector-ref e-3 0) ((1) (let ((e-13 (vector-ref e-3 4))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1603 (TTImpC-45InteractiveC-45Intro-intro arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 (CoreC-45TTC-45TermC-45Subst-subst e-13 e-4)) eta-0)))) ((2) (let ((e-16 (vector-ref e-3 2))) (let ((e-17 (vector-ref e-3 3))) (let ((e-18 (vector-ref e-3 4))) (case (vector-ref e-17 0) ((1) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-3165 (lambda (eta-1) (TTImpC-45InteractiveC-45Intro-introLam arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-2 e-16 e-18 eta-1)) eta-0)))(else (let ((sc2 (CoreC-45TTC-45Term-getFnArgs arg-9))) (if (null? sc2) (lambda (eta-0) (vector 1 '())) (let ((e-6 (car sc2))) (case (vector-ref e-6 0) ((1) (let ((e-8 (vector-ref e-6 2))) (let ((e-7 (vector-ref e-6 3))) (lambda (clam-0) (case (vector-ref e-8 0) ((3) (TTImpC-45InteractiveC-45Intro-introCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-7 arg-9 clam-0))(else (vector 1 '())))))))(else (lambda (eta-0) (vector 1 '())))))))))))))(else (let ((sc1 (CoreC-45TTC-45Term-getFnArgs arg-9))) (if (null? sc1) (lambda (eta-0) (vector 1 '())) (let ((e-6 (car sc1))) (case (vector-ref e-6 0) ((1) (let ((e-8 (vector-ref e-6 2))) (let ((e-7 (vector-ref e-6 3))) (lambda (clam-1) (case (vector-ref e-8 0) ((3) (TTImpC-45InteractiveC-45Intro-introCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-7 arg-9 clam-1))(else (vector 1 '())))))))(else (lambda (eta-0) (vector 1 '()))))))))))))) ((6) (let ((e-8 (vector-ref arg-9 3))) (TTImpC-45InteractiveC-45Intro-intro arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-8)))(else (let ((sc0 (CoreC-45TTC-45Term-getFnArgs arg-9))) (if (null? sc0) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car sc0))) (case (vector-ref e-2 0) ((1) (let ((e-6 (vector-ref e-2 2))) (let ((e-7 (vector-ref e-2 3))) (lambda (clam-2) (case (vector-ref e-6 0) ((3) (TTImpC-45InteractiveC-45Intro-introCon arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-7 arg-9 clam-2))(else (vector 1 '())))))))(else (lambda (eta-0) (vector 1 '())))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-9562 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15) (lambda (clam-0) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 ((TTImpC-45InteractiveC-45Intro-intro (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) arg-7 arg-5 arg-4 arg-6 arg-3 arg-10 arg-0 e-6 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Don't know what to do."))) (let ((e-1 (car e-5))) (let ((e-4 (cdr e-5))) (let ((act-2 ((CoreC-45Core-traverseList1 (lambda (eta-0) (lambda (eta-1) (IdrisC-45Resugar-pterm arg-7 arg-5 eta-0 eta-1))) (cons e-1 e-4)) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (unbox arg-5))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--brack (PreludeC-45Types-elemBy csegen-14 csegen-2144 arg-0 (let ((e-13 (vector-ref e-9 8))) e-13)))) (let ((u--introds (DataC-45List1-u--map_Functor_List1 (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket CoreC-45FC-replFC eta-1)) (else eta-1))))) e-8))) (cond ((equal? arg-2 1) (if (null? u--introds) (lambda (eta-1) csegen-3876) (let ((e-11 (car u--introds))) (let ((e-10 (cdr u--introds))) (lambda (clam-2) (if (null? e-10) (IdrisC-45REPL-updateFile arg-3 (lambda (eta-1) (IdrisC-45REPL-proofSearch arg-0 e-11 (PreludeC-45Types-prim__integerToNat (bs- arg-1 1 63)) eta-1)) clam-2) csegen-3876)))))) (else (lambda (eta-1) (vector 1 (vector 5 u--introds))))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))))) eff-0) clam-0))))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-9519 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((7) (let ((e-0 (vector-ref arg-13 1))) (let ((e-1 (vector-ref arg-13 2))) (IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-9562 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-1 e-0 (CoreC-45TTC-45Views-underPis (blodwen-toSignedInt e-0 63) '() (let ((e-2 (vector-ref arg-11 2))) e-2))))))(else (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "is not a refinable hole")))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-10166 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16) (lambda (clam-0) (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (case (vector-ref arg-0 0) ((0) (let ((e-4 (vector-ref arg-0 2))) (let ((act-1 ((CoreC-45Context-lookupCtxtName e-4 (let ((e-0 (vector-ref arg-9 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 1 '()))) (let ((e-9 (car e-5))) (let ((e-8 (cdr e-5))) (let ((u--sizes (DataC-45List1-u--map_Functor_List1 (lambda (lamc-0) (let ((e-10 (cdr lamc-0))) (let ((e-12 (cdr e-10))) (let ((u--ctxt (CoreC-45TTC-45Views-underPis -1 '() (let ((e-34 (vector-ref e-12 2))) e-34)))) (CoreC-45Env-lengthExplicitPi (Builtin-fst (let ((e-14 (cdr u--ctxt))) e-14))))))) (cons e-9 e-8)))) (let ((sc5 (DataC-45List1-u--foldMap_Foldable_List1 csegen-186 (lambda (arg-17) (or (and (= (let ((e-11 (car u--sizes))) e-11) arg-17) 1) 0)) u--sizes))) (cond ((equal? sc5 1) (let ((u--arity (+ arg-15 (let ((e-11 (car u--sizes))) e-11)))) (lambda (eta-0) (vector 1 (vector 1 (box u--arity))))))(else (lambda (eta-0) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Ambiguous name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "(couldn't infer arity)"))))))))))))))) eff-0) clam-0)))))))(else (vector 1 (vector 1 '())))))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-5 0) ((1) (let ((e-4 (vector-ref e-5 1))) (let ((act-2 (if (null? e-4) (let ((act-2 (let ((act-2 (unbox arg-7))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((act-3 (unbox arg-6))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-5))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Context-branch arg-8 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (IdrisC-45REPL-inferAndElab (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) arg-8 arg-7 arg-6 arg-5 arg-4 (vector 2 ) arg-0 e-6 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (let ((act-7 (set-box! arg-7 e-8))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-13 (vector-ref act-7 1))) (vector 0 e-13))) (else (let ((act-8 (let ((act-8 (set-box! arg-6 e-9))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-14 (vector-ref act-8 1))) (vector 0 e-14))) (else (let ((act-9 (let ((act-9 (set-box! arg-5 e-10))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-15 (vector-ref act-9 1))) (vector 0 e-15))) (else (let ((act-10 (let ((act-10 (set-box! arg-8 e-11))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-16 (vector-ref act-10 1))) (vector 0 e-16))) (else (let ((u--tele (CoreC-45TTC-45Views-underPis -1 e-6 (let ((e-17 (cdr e-12))) e-17)))) (vector 1 (CoreC-45Env-lengthExplicitPi (Builtin-fst (let ((e-17 (cdr u--tele))) e-17)))))))))))))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-1))))) (let ((e-1 (unbox e-4))) (vector 1 e-1))))) (case (vector-ref act-2 0) ((0) (let ((e-8 (vector-ref act-2 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--size_tele_hole (CoreC-45Env-lengthExplicitPi (Builtin-fst (let ((sc5 (CoreC-45TTC-45Views-underPis -1 '() (let ((e-29 (vector-ref arg-12 2))) e-29)))) (let ((e-9 (cdr sc5))) e-9)))))) (lambda (clam-2) (let ((sc5 (PreludeC-45Types-u--C-62C-61_Ord_Nat e-8 u--size_tele_hole))) (cond ((equal? sc5 1) (let ((act-3 (let ((u--n (PreludeC-45Types-prim__integerToNat (- e-8 u--size_tele_hole)))) (let ((act-3 ((TTImpC-45Utils-uniqueHoleNames arg-6 arg-9 u--n (CoreC-45Name-nameRoot arg-1)) clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--new_holes (PreludeC-45TypesC-45List-mapAppend '() csegen-3874 e-9))) (let ((u--pcall (IdrisC-45Syntax-papply CoreC-45FC-replFC arg-0 u--new_holes))) (lambda (eta-0) (let ((act-4 (IdrisC-45Desugar-desugar arg-6 arg-8 arg-5 arg-7 arg-4 1 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) u--pcall eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-10 (vector-ref act-4 1))) (vector 0 e-10))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--gty (CoreC-45NormaliseC-45Eval-gnf (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) e-6 e-7))) (lambda (eta-1) (let ((act-5 (TTImpC-45Elab-checkTerm (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) arg-8 arg-5 arg-7 arg-6 arg-4 arg-11 (vector 2 ) '() '() e-6 e-10 u--gty eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-11 (vector-ref act-5 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (let ((act-6 (unbox arg-8))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-12 (vector-ref act-6 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (CoreC-45Normalise-normaliseHoles arg-8 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) e-12 e-6 e-11 eta-3))) (case (vector-ref act-7 0) ((0) (let ((e-13 (vector-ref act-7 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-8 (IdrisC-45Resugar-resugar (PreludeC-45TypesC-45SnocList-C-60C-62C-62 e-2 '()) arg-8 arg-6 e-6 e-13 eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-14 (vector-ref act-8 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-9 (let ((act-9 (unbox arg-6))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-15 (vector-ref act-9 1))) (vector 0 e-15))) (else (let ((e-15 (vector-ref act-9 1))) ((let ((eff-0 (let ((u--brack (PreludeC-45Types-elemBy csegen-14 csegen-2144 arg-1 (let ((e-19 (vector-ref e-15 8))) e-19)))) (lambda (eta-6) (vector 1 (IdrisC-45Syntax-u--show_Show_IPTerm (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket CoreC-45FC-replFC e-14)) (else e-14)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))) eff-0) clam-2)))))))) (case (vector-ref act-3 0) ((0) (let ((e-9 (vector-ref act-3 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? arg-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-0) (IdrisC-45REPL-proofSearch arg-1 e-9 (PreludeC-45Types-prim__integerToNat (bs- arg-2 1 63)) eta-0)) clam-3)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-9)))))))) eff-0) clam-2))))))(else (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Cannot seem to refine") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-1) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "by") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (IdrisC-45Syntax-u--show_Show_PTerm arg-0)) '())))))))))))))) eff-0) clam-1))))))) (else (let ((e-8 (vector-ref e-5 1))) (vector 1 (vector 1 e-8)))))))) eff-0) clam-0))))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-10121 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (case (vector-ref arg-14 0) ((7) (let ((e-0 (vector-ref arg-14 1))) (let ((e-1 (vector-ref arg-14 2))) (IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-10166 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 e-1 e-0 (CoreC-45TTC-45Views-underPis (blodwen-toSignedInt e-0 63) '() (let ((e-2 (vector-ref arg-12 2))) e-2))))))(else (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 arg-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "is not a refinable hole")))))))))
(define IdrisC-45REPL-dropLamsTm (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-1 0) (cons arg-0 (cons arg-2 arg-3)))(else (let ((e-0 (- arg-1 1))) (case (vector-ref arg-3 0) ((3) (let ((e-3 (vector-ref arg-3 2))) (let ((e-4 (vector-ref arg-3 3))) (let ((e-5 (vector-ref arg-3 4))) (IdrisC-45REPL-dropLamsTm (cons e-3 arg-0) e-0 (cons e-4 arg-2) e-5)))))(else (cons arg-0 (cons arg-2 arg-3)))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-11962 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (lambda (clam-0) (let ((e-2 (car arg-22))) (let ((e-3 (cdr arg-22))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((act-1 (IdrisC-45Resugar-resugar e-2 arg-8 arg-6 e-6 e-7 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--itmC-39 (cond ((equal? arg-11 1) (IdrisC-45Resugar-addBracket CoreC-45FC-replFC e-5)) (else e-5)))) (lambda (clam-1) (cond ((equal? arg-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-0) (IdrisC-45REPL-proofSearch arg-1 (IdrisC-45Syntax-u--show_Show_IPTerm u--itmC-39) (PreludeC-45Types-prim__integerToNat (bs- arg-2 1 63)) eta-0)) clam-1)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-0) (vector 6 eta-0)) u--itmC-39))))))))) eff-0) clam-0))))))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-11856 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 ext-0) (if (null? arg-20) csegen-3872 (let ((e-0 (unbox arg-20))) (let ((act-1 (CoreC-45Normalise-normaliseHoles arg-8 '() arg-9 '() arg-17 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-11962 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 e-0 e-5 (IdrisC-45REPL-dropLamsTm '() e-0 '() e-5)))) eff-0) ext-0)))))))))
(define IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-12702 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 arg-24 ext-0) (let ((e-2 (car arg-24))) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-0) (lambda (eta-1) (IdrisC-45REPL-printClause arg-8 arg-6 e-2 arg-21 eta-0 eta-1))) arg-19 '()) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? arg-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-0) (IdrisC-45REPL-addClause (DataC-45String-fastUnlines e-5) (PreludeC-45Types-prim__integerToNat arg-2) eta-0)) clam-0)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-753 e-5))))))))) eff-0) ext-0))))))))
(define IdrisC-45REPL-processEdit (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((e-1 (vector-ref arg-5 2))) (let ((e-2 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-3))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--name (DataC-45Maybe-fromMaybe (lambda () e-2) (IdrisC-45REPL-findInTree (cons (bs- e-0 1 63) e-1) e-2 (let ((e-11 (vector-ref e-6 5))) e-11))))) (lambda (eta-2) (let ((act-3 ((CoreC-45Context-lookupCtxtName u--name (let ((e-37 (vector-ref e-5 0))) e-37)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (if (null? e-7) (vector 1 '()) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (IdrisC-45DocC-45Display-displayType arg-0 arg-2 0 e-5 eta-4)) e-7 '()) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-3892 e-8))))))) eff-0) eta-3)))))))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-5 (CoreC-45Metadata-findTypeAt arg-3 (lambda (eta-5) (lambda (eta-6) (IdrisC-45REPL-anyAt (lambda (eta-7) (CoreC-45FC-within (cons (bs- e-0 1 63) e-1) eta-7)) eta-5 eta-6))) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (IdrisC-45REPL-case--processEdit-8952 e-2 e-1 e-0 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 u--name e-7 e-8 e-9 (cons e-8 e-9)))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((1) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (let ((e-5 (vector-ref arg-5 3))) (let ((e-6 (vector-ref arg-5 4))) (let ((u--find (lambda (clam-0) (let ((sc1 (PreludeC-45EqOrd-u--C-62_Ord_Int e-5 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (CoreC-45FC-within (cons (bs- e-4 1 63) (bs- e-5 1 63)) clam-0)) (else (CoreC-45FC-onLine (bs- e-4 1 63) clam-0))))))) (lambda (eta-0) (let ((act-1 (TTImpC-45InteractiveC-45CaseSplit-getSplits arg-0 arg-3 arg-1 arg-2 arg-4 (lambda (eta-1) (lambda (eta-2) (IdrisC-45REPL-anyAt u--find eta-1 eta-2))) e-6 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-7 0) ((1) (let ((e-1 (vector-ref e-7 1))) (let ((act-2 (IdrisC-45IDEModeC-45CaseSplit-updateCase arg-0 arg-2 arg-4 e-1 (bs- e-4 1 63) (bs- e-5 1 63) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-3 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-caseSplit (DataC-45String-fastUnlines e-8) (PreludeC-45Types-prim__integerToNat (bs- e-4 1 63)) eta-1)) clam-1)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-753 e-8))))))))) eff-0) clam-0))))))) (else (let ((e-8 (vector-ref e-7 1))) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (TTImpC-45InteractiveC-45CaseSplit-u--show_Show_SplitError e-8)))))))))) eff-0) eta-0)))))))))))) ((2) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45CaseSplit-getClause arg-0 arg-3 arg-4 e-8 e-9 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-1) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-9) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "not defined here"))))) (let ((e-1 (unbox e-5))) (lambda (clam-1) (cond ((equal? e-7 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-1) (IdrisC-45REPL-addClause e-1 (PreludeC-45Types-prim__integerToNat e-8) eta-1)) clam-1)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-1)))))))))) eff-0) eta-0)))))))))) ((4) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-12 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-12))))) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-12))))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-12))))) (let ((e-9 (car e-7))) (let ((e-13 (cdr e-7))) (if (null? e-2) (let ((_-0 (cons (cons e-8 (cons e-9 e-13)) '()))) (IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-9519 e-12 e-11 e-10 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-8 e-9 e-13 _-0 (let ((e-18 (vector-ref e-13 18))) e-18))) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-12))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((3) (let ((e-13 (vector-ref arg-5 1))) (let ((e-14 (vector-ref arg-5 2))) (let ((e-15 (vector-ref arg-5 3))) (let ((e-16 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-15 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-15))))) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-15))))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (if (null? e-7) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-15))))) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (if (null? e-2) (let ((_-0 (cons (cons e-8 (cons e-9 e-10)) '()))) (IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-10121 e-16 e-15 e-14 e-13 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-8 e-9 e-10 _-0 (let ((e-18 (vector-ref e-10 18))) e-18))) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Could not find hole named") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-15))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((5) (let ((e-17 (vector-ref arg-5 1))) (let ((e-18 (vector-ref arg-5 2))) (let ((e-19 (vector-ref arg-5 3))) (let ((e-20 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--brack (PreludeC-45Types-elemBy csegen-14 csegen-2144 e-19 (let ((e-8 (vector-ref e-6 8))) e-8)))) (lambda (eta-2) (let ((act-3 (CoreC-45Context-lookupDefName e-19 (let ((e-0 (vector-ref e-5 0))) e-0) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-3) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Unknown name") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-19))))) (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) csegen-3895 (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (if (null? e-8) csegen-3895 (let ((e-10 (car e-8))) (let ((e-11 (cdr e-8))) (case (vector-ref e-11 0) ((7) (let ((e-12 (vector-ref e-11 1))) (if (null? e-2) (let ((u--searchtm (lambda (eta-3) (TTImpC-45InteractiveC-45ExprSearch-exprSearch arg-0 arg-3 arg-1 arg-2 arg-4 CoreC-45FC-replFC e-19 e-20 eta-3)))) (lambda (eta-3) (let ((act-4 ((let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-4))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-14 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-4 (let ((e-0 (vector-ref e-14 0))) (let ((e-32 (vector-ref e-14 1))) (let ((e-31 (vector-ref e-14 2))) (let ((e-3 (vector-ref e-14 3))) (let ((e-4 (vector-ref e-14 4))) (let ((e-30 (vector-ref e-14 5))) (let ((e-29 (vector-ref e-14 6))) (let ((e-28 (vector-ref e-14 7))) (let ((e-27 (vector-ref e-14 8))) (let ((e-26 (vector-ref e-14 9))) (let ((e-24 (vector-ref e-14 11))) (let ((e-23 (vector-ref e-14 12))) (let ((e-22 (vector-ref e-14 13))) (let ((e-21 (vector-ref e-14 14))) (let ((e-15 (vector-ref e-14 15))) (let ((e-16 (vector-ref e-14 16))) (vector e-0 e-32 e-31 e-3 e-4 e-30 e-29 e-28 e-27 e-26 (box (cons e-19 u--searchtm)) e-24 e-23 e-22 e-21 e-15 e-16)))))))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 (IdrisC-45REPL-nextProofSearch arg-0 arg-1 arg-4 eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 (if (null? e-15) csegen-3894 (let ((e-3 (unbox e-15))) (let ((e-16 (cdr e-3))) (let ((u--tmC-39 (IdrisC-45REPL-dropLams e-12 e-16))) (lambda (eta-4) (let ((act-6 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-5) (CoreC-45TT-defaultKindedName eta-5)) u--tmC-39) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-22 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--itmC-39 (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket CoreC-45FC-replFC e-22)) (else e-22)))) (lambda (clam-2) (cond ((equal? e-17 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-5) (IdrisC-45REPL-proofSearch e-19 (IdrisC-45Syntax-u--show_Show_IPTerm u--itmC-39) (PreludeC-45Types-prim__integerToNat (bs- e-18 1 63)) eta-5)) clam-2)) (else (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-5) (vector 6 eta-5)) u--itmC-39))))))))) eff-0) eta-4)))))))))))) eff-0) eta-3)))))))))) csegen-3895))) ((1) (let ((e-14 (vector-ref e-11 1))) (let ((e-15 (vector-ref e-11 2))) (let ((e-16 (vector-ref e-11 3))) (let ((e-22 (vector-ref e-11 4))) (let ((e-21 (vector-ref e-11 5))) (if (null? e-15) (case (vector-ref e-16 0) ((1) (let ((e-24 (vector-ref e-16 1))) (let ((e-23 (vector-ref e-16 2))) (if (null? e-2) (let ((bind-0 (cons (cons e-9 (cons e-10 (vector 1 e-14 '() (vector 1 e-24 e-23) e-22 e-21))) '()))) (lambda (eta-3) (IdrisC-45REPL-case--caseC-32blockC-32inC-32processEdit-11856 e-20 e-19 e-18 e-17 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 u--brack e-22 e-21 e-24 e-9 e-10 e-23 e-14 bind-0 (let ((e-0 (vector-ref e-14 0))) e-0) eta-3))) csegen-3895))))(else csegen-3895)) csegen-3895)))))))(else csegen-3895))))))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((6) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (IdrisC-45REPL-nextProofSearch arg-0 arg-1 arg-4 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-7) csegen-3896 (let ((e-1 (unbox e-7))) (let ((e-9 (car e-1))) (let ((e-8 (cdr e-1))) (let ((act-4 (CoreC-45Context-lookupDefName e-9 (let ((e-0 (vector-ref e-5 0))) e-0) clam-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-4 1))) ((let ((eff-0 (if (null? e-10) csegen-3895 (let ((e-3 (car e-10))) (let ((e-2 (cdr e-10))) (if (null? e-3) csegen-3895 (let ((e-11 (cdr e-3))) (if (null? e-11) csegen-3895 (let ((e-13 (cdr e-11))) (case (vector-ref e-13 0) ((7) (let ((e-16 (vector-ref e-13 1))) (if (null? e-2) (let ((u--brack (PreludeC-45Types-elemBy csegen-14 csegen-2144 e-9 (let ((e-20 (vector-ref e-6 8))) e-20)))) (let ((u--tmC-39 (IdrisC-45REPL-dropLams e-16 e-8))) (lambda (eta-3) (let ((act-5 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-4) (CoreC-45TT-defaultKindedName eta-4)) u--tmC-39) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--itmC-39 (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket CoreC-45FC-replFC e-17)) (else e-17)))) (lambda (eta-4) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-prettyBy csegen-3035 (lambda (eta-5) (vector 6 eta-5)) u--itmC-39))))))) eff-0) eta-3)))))))) csegen-3895)))(else csegen-3895))))))))))) eff-0) clam-3)))))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))) ((7) (let ((e-21 (vector-ref arg-5 1))) (let ((e-22 (vector-ref arg-5 2))) (let ((e-23 (vector-ref arg-5 3))) (let ((e-24 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Metadata-findTyDeclAt arg-3 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine (bs- e-22 1 63) u--p))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Can't find declaration for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-23) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "on line") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-495 e-22))))))) (let ((e-1 (unbox e-6))) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-4) (let ((e-9 (car e-7))) (let ((e-10 (cdr e-7))) (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (let ((act-3 (CoreC-45Context-lookupDefExact e-9 (let ((e-0 (vector-ref e-5 0))) e-0) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (let ((_-0 (box (cons e-8 (cons e-9 (cons e-13 e-14)))))) (if (null? e-11) (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Can't find declaration for") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-23))))) (let ((e-2 (unbox e-11))) (case (vector-ref e-2 0) ((0) (let ((u--searchdef (lambda (eta-2) (TTImpC-45InteractiveC-45GenerateDef-makeDefSort arg-0 arg-3 arg-1 arg-2 arg-4 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine (bs- e-22 1 63) u--p))) 16 (lambda (eta-3) (lambda (eta-4) (TTImpC-45InteractiveC-45GenerateDef-mostUsed eta-3 eta-4))) e-9 eta-2)))) (lambda (eta-2) (let ((act-4 ((let ((eff-0 (lambda (world-0) (let ((act-4 (unbox arg-4))) (vector 1 act-4))))) (lambda (world-0) (let ((act-4 (eff-0 world-0))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-1 (lambda (world-1) (let ((act-5 (set-box! arg-4 (let ((e-0 (vector-ref e-12 0))) (let ((e-32 (vector-ref e-12 1))) (let ((e-31 (vector-ref e-12 2))) (let ((e-3 (vector-ref e-12 3))) (let ((e-4 (vector-ref e-12 4))) (let ((e-30 (vector-ref e-12 5))) (let ((e-29 (vector-ref e-12 6))) (let ((e-28 (vector-ref e-12 7))) (let ((e-27 (vector-ref e-12 8))) (let ((e-26 (vector-ref e-12 9))) (let ((e-25 (vector-ref e-12 10))) (let ((e-19 (vector-ref e-12 12))) (let ((e-18 (vector-ref e-12 13))) (let ((e-17 (vector-ref e-12 14))) (let ((e-15 (vector-ref e-12 15))) (let ((e-16 (vector-ref e-12 16))) (vector e-0 e-32 e-31 e-3 e-4 e-30 e-29 e-28 e-27 e-26 e-25 (box (cons e-22 u--searchdef)) e-19 e-18 e-17 e-15 e-16)))))))))))))))))))) (vector 1 act-5))))) eff-1) world-0))))))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 (IdrisC-45REPL-nextGenDef arg-0 arg-1 arg-4 e-24 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-5 1))) ((let ((eff-0 (let ((bind-0 (box (vector 0 )))) (if (null? e-15) csegen-3894 (let ((e-3 (unbox e-15))) (let ((e-17 (car e-3))) (let ((e-16 (cdr e-3))) (let ((e-19 (car e-16))) (let ((e-18 (cdr e-16))) (let ((u--l (PreludeC-45Types-prim__integerToNat (CoreC-45FC-startCol (CoreC-45FC-toNonEmptyFC e-19))))) (lambda (eta-3) (let ((act-6 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-22 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-20 (vector-ref act-6 1))) ((let ((eff-0 (let ((_-1 (box (cons e-17 (cons e-19 e-18))))) (if (null? e-20) csegen-3899 (let ((e-4 (unbox e-20))) (let ((_-2 (box e-4))) (lambda (eta-4) (IdrisC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32processEdit-12702 e-24 e-23 e-22 e-21 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-14 e-13 e-8 e-9 _-0 bind-0 u--searchdef e-17 e-19 e-18 _-1 u--l e-4 _-2 (ParserC-45Unlit-isLitLine e-4) eta-4)))))))) eff-0) eta-3)))))))))))))))) eff-0) eta-2)))))))))))(else (lambda (eta-2) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Already defined"))))))))))) eff-0) clam-4)))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (lambda (eta-0) (let ((act-1 (IdrisC-45REPL-nextGenDef arg-0 arg-1 arg-4 0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-1) csegen-3896) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (let ((e-9 (car e-6))) (let ((e-10 (cdr e-6))) (let ((u--l (PreludeC-45Types-prim__integerToNat (CoreC-45FC-startCol (CoreC-45FC-toNonEmptyFC e-9))))) (lambda (eta-1) (let ((act-2 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-7 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-5) (if (null? e-8) csegen-3898 (let ((e-2 (unbox e-8))) (let ((sc7 (ParserC-45Unlit-isLitLine e-2))) (let ((e-4 (car sc7))) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (lambda (eta-3) (IdrisC-45REPL-printClause arg-0 arg-2 e-4 u--l eta-2 eta-3))) e-10 '()) clam-5))) (case (vector-ref act-3 0) ((0) (let ((e-11 (vector-ref act-3 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-753 e-11))))))) eff-0) clam-5)))))))))))) eff-0) eta-1))))))))))))))) eff-0) eta-0))))))) ((9) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (let ((e-27 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--brack (PreludeC-45Types-elemBy csegen-14 csegen-2144 e-27 (let ((e-8 (vector-ref e-6 8))) e-8)))) (lambda (eta-2) (let ((act-3 (IdrisC-45REPL-lookupDefTyName e-27 (let ((e-0 (vector-ref e-5 0))) e-0) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) csegen-3904 (let ((e-1 (car e-7))) (let ((e-2 (cdr e-7))) (if (null? e-1) csegen-3904 (let ((e-8 (cdr e-1))) (if (null? e-8) csegen-3904 (let ((e-10 (cdr e-8))) (if (null? e-10) csegen-3904 (let ((e-13 (car e-10))) (let ((e-14 (cdr e-10))) (lambda (clam-6) (case (vector-ref e-13 0) ((7) (let ((e-15 (vector-ref e-13 1))) (if (null? e-2) (let ((act-4 (TTImpC-45InteractiveC-45MakeLemma-makeLemma arg-3 arg-0 arg-2 CoreC-45FC-replFC e-27 e-15 e-14 clam-6))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-5) (let ((e-4 (car e-12))) (let ((e-3 (cdr e-12))) (let ((act-5 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-3) (CoreC-45TT-defaultKindedName eta-3)) e-4) clam-5))) (case (vector-ref act-5 0) ((0) (let ((e-17 (vector-ref act-5 1))) (vector 0 e-17))) (else (let ((e-17 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (IdrisC-45Resugar-pterm arg-0 arg-2 (TTImpC-45TTImpC-45Functor-u--map_Functor_RawImpC-39 (lambda (eta-4) (CoreC-45TT-defaultKindedName eta-4)) e-3) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-18 (vector-ref act-6 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-6 1))) ((let ((eff-0 (let ((u--pappstr (IdrisC-45Syntax-u--show_Show_IPTerm (cond ((equal? u--brack 1) (IdrisC-45Resugar-addBracket CoreC-45FC-replFC e-18)) (else e-18))))) (lambda (eta-4) (let ((act-7 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-26 eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-19 (vector-ref act-7 1))) (vector 0 e-19))) (else (let ((e-19 (vector-ref act-7 1))) ((let ((eff-0 (if (null? e-19) csegen-3899 (let ((e-20 (unbox e-19))) (let ((sc16 (ParserC-45Unlit-isLitLine e-20))) (let ((e-22 (car sc16))) (lambda (clam-7) (cond ((equal? e-25 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-5) (IdrisC-45REPL-addMadeLemma e-22 e-27 (IdrisC-45Syntax-u--show_Show_IPTerm e-17) u--pappstr (PreludeC-45Types-u--max_Ord_Nat 0 (PreludeC-45Types-prim__integerToNat (bs- e-26 1 63))) eta-5)) clam-7)) (else (vector 1 (vector 2 e-22 e-27 e-17 u--pappstr))))))))))) eff-0) eta-4))))))))) eff-0) eta-3)))))))) eff-0) clam-5)))))))))) eff-0) clam-6))))) csegen-3903)))(else csegen-3903))))))))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((10) (let ((e-28 (vector-ref arg-5 1))) (let ((e-29 (vector-ref arg-5 2))) (let ((e-30 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getLitStyle arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 (unbox arg-2))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--brack (PreludeC-45Types-elemBy csegen-14 csegen-2144 e-30 (let ((e-8 (vector-ref e-6 8))) e-8)))) (lambda (eta-2) (let ((act-3 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-29 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) csegen-3908 (let ((e-1 (unbox e-7))) (let ((sc5 (ParserC-45Unlit-unlit e-5 e-1))) (case (vector-ref sc5 0) ((1) (let ((e-2 (vector-ref sc5 1))) (let ((sc6 (ParserC-45Unlit-isLitLine e-1))) (let ((e-4 (car sc6))) (let ((u--c (DataC-45String-lines (IdrisC-45IDEModeC-45MakeClause-makeCase u--brack e-30 e-2)))) (lambda (clam-8) (cond ((equal? e-28 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-3) (IdrisC-45REPL-addMadeCase e-4 u--c (PreludeC-45Types-u--max_Ord_Nat 0 (PreludeC-45Types-prim__integerToNat (bs- e-29 1 63))) eta-3)) clam-8)) (else (vector 1 (vector 4 e-4 u--c)))))))))) (else csegen-3906))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) (else (let ((e-31 (vector-ref arg-5 1))) (let ((e-32 (vector-ref arg-5 2))) (let ((e-33 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getLitStyle arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (IdrisC-45REPLC-45Opts-getSourceLine arg-4 e-32 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) csegen-3908 (let ((e-1 (unbox e-6))) (let ((sc4 (ParserC-45Unlit-unlit e-5 e-1))) (case (vector-ref sc4 0) ((1) (let ((e-2 (vector-ref sc4 1))) (let ((sc5 (ParserC-45Unlit-isLitLine e-1))) (let ((e-4 (car sc5))) (let ((u--w (DataC-45String-lines (IdrisC-45IDEModeC-45MakeClause-makeWith e-33 e-2)))) (lambda (clam-9) (cond ((equal? e-31 1) (IdrisC-45REPL-updateFile arg-4 (lambda (eta-2) (IdrisC-45REPL-addMadeCase e-4 u--w (PreludeC-45Types-u--max_Ord_Nat 0 (PreludeC-45Types-prim__integerToNat (bs- e-32 1 63))) eta-2)) clam-9)) (else (vector 1 (vector 3 e-4 u--w)))))))))) (else csegen-3906))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))))
(define CoreC-45SchemeEvalC-45Compile-nextName (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (set-box! arg-0 (+ e-5 1)))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 e-5))))))) eff-0) ext-0)))))))
(define CoreC-45SchemeEvalC-45Quote-quoteArgs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (CoreC-45Core-traverseC-39 (lambda (u--arg) (lambda (eta-0) (let ((act-1 (u--arg eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5))) eff-0) eta-0))))))) arg-6 '())))
(define CoreC-45SchemeEvalC-45Quote-quotePi (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-6 1))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45SchemeEvalC-45Quote-quoteBinder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45SchemeEvalC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((e-9 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-9) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 1 e-6 e-7 e-10 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((2) (let ((e-11 (vector-ref arg-6 1))) (let ((e-12 (vector-ref arg-6 2))) (let ((e-13 (vector-ref arg-6 3))) (let ((e-14 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-14) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45SchemeEvalC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-13 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 e-11 e-12 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-19) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45SchemeEvalC-45Quote-quotePi arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-18 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 3 e-16 e-17 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) ((4) (let ((e-21 (vector-ref arg-6 1))) (let ((e-22 (vector-ref arg-6 2))) (let ((e-23 (vector-ref arg-6 3))) (let ((e-24 (vector-ref arg-6 4))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-23) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 4 e-21 e-22 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))) (else (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-28) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 5 e-26 e-27 e-5))))) eff-0) ext-0))))))))))))
(define CoreC-45SchemeEvalC-45Quote-n--7364-9237-u--addLater (lambda (arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 arg-13) (if (null? arg-13) arg-12 (let ((e-3 (cdr arg-13))) (let ((eff-0 (CoreC-45SchemeEvalC-45Quote-n--7364-9237-u--addLater arg-0 arg-2 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-12 e-3))) (+ eff-0 1))))))
(define CoreC-45SchemeEvalC-45Quote-n--7364-9387-u--findName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-10) (case (vector-ref arg-10 0) ((0) '()) (else (let ((e-2 (vector-ref arg-10 2))) (let ((e-3 (vector-ref arg-10 3))) (let ((sc1 (CoreC-45Name-u--C-61C-61_Eq_Name arg-2 e-2))) (cond ((equal? sc1 1) (box 0)) (else (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (CoreC-45SchemeEvalC-45Quote-n--7364-9387-u--findName arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-3) csegen-965))))))))))
(define CoreC-45SchemeEvalC-45Quote-quoteHead (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-2 (vector-ref arg-7 1))) (let ((eff-0 (CoreC-45SchemeEvalC-45Quote-n--7364-9237-u--addLater arg-2 e-2 arg-6 arg-1 arg-5 arg-4 arg-3 arg-0 e-2 arg-1))) (lambda (eta-0) (vector 1 (vector 0 arg-4 '() eff-0)))))) ((1) (let ((e-5 (vector-ref arg-7 1))) (let ((e-6 (vector-ref arg-7 2))) (lambda (eta-0) (vector 1 (let ((sc1 (CoreC-45SchemeEvalC-45Quote-n--7364-9387-u--findName arg-1 arg-2 e-6 e-5 arg-6 arg-5 arg-4 arg-3 arg-0 arg-5))) (if (null? sc1) (vector 1 arg-4 e-5 e-6) (let ((e-1 (unbox sc1))) (vector 0 arg-4 '() e-1))))))))) (else (let ((e-8 (vector-ref arg-7 1))) (let ((e-9 (vector-ref arg-7 2))) (let ((e-10 (vector-ref arg-7 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-5 arg-6 e-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 2 arg-4 e-8 e-9 e-5))))) eff-0) eta-0)))))))))))))
(define CoreC-45TTC-45Primitive-primTypeTag (lambda (arg-0) (cond ((equal? arg-0 0) 3) ((equal? arg-0 5) 4) ((equal? arg-0 6) 5) ((equal? arg-0 7) 6) ((equal? arg-0 8) 7) ((equal? arg-0 9) 8) ((equal? arg-0 10) 9) ((equal? arg-0 11) 10) ((equal? arg-0 12) 11) ((equal? arg-0 13) 12) ((equal? arg-0 1) 13) ((equal? arg-0 2) 14) ((equal? arg-0 3) 15) (else 16))))
(define CoreC-45SchemeEvalC-45Compile-compileConstant (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (vector 8 -100 (cons (vector 2 e-0) '())))) ((1) (let ((e-1 (vector-ref arg-1 1))) (vector 8 -101 (cons (vector 2 e-1) '())))) ((2) (let ((e-2 (vector-ref arg-1 1))) (vector 8 -102 (cons (vector 2 e-2) '())))) ((3) (let ((e-3 (vector-ref arg-1 1))) (vector 8 -103 (cons (vector 2 e-3) '())))) ((4) (let ((e-4 (vector-ref arg-1 1))) (vector 8 -104 (cons (vector 2 e-4) '())))) ((5) (let ((e-5 (vector-ref arg-1 1))) (vector 8 -105 (cons (vector 2 e-5) '())))) ((6) (let ((e-6 (vector-ref arg-1 1))) (vector 8 -106 (cons (vector 2 e-6) '())))) ((7) (let ((e-7 (vector-ref arg-1 1))) (vector 8 -107 (cons (vector 2 e-7) '())))) ((8) (let ((e-8 (vector-ref arg-1 1))) (vector 8 -108 (cons (vector 2 e-8) '())))) ((9) (let ((e-9 (vector-ref arg-1 1))) (vector 8 -109 (cons (vector 2 e-9) '())))) ((10) (let ((e-10 (vector-ref arg-1 1))) (vector 4 e-10))) ((11) (let ((e-11 (vector-ref arg-1 1))) (vector 5 e-11))) ((12) (let ((e-12 (vector-ref arg-1 1))) (vector 3 e-12))) ((13) (let ((e-13 (vector-ref arg-1 1))) (vector 8 -1 (cons (vector 2 (CoreC-45TTC-45Primitive-primTypeTag e-13)) (cons (vector 4 (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-13)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name (vector 1 (vector 0 (CoreC-45TTC-45Primitive-u--show_Show_PrimType e-13)))) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC arg-0) '()))))))) (else (vector 0 )))))
(define CoreC-45SchemeEvalC-45Compile-compilePiInfo (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (case (vector-ref arg-4 0) ((0) (vector 1 (vector 0 ))) ((1) (vector 1 (vector 1 ))) ((2) (vector 1 (vector 2 ))) (else (let ((e-4 (vector-ref arg-4 1))) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45SchemeEvalC-45Compile-compileWhyErased (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((1) (vector 1 (vector 1 ))) ((0) (vector 1 (vector 0 ))) (else (let ((e-3 (vector-ref arg-5 1))) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-5))))) eff-0) ext-0))))))))))
(define CoreC-45SchemeEvalC-45Compile-getSchVar (lambda (arg-2 arg-4) (cond ((equal? arg-2 0) (let ((e-3 (car arg-4))) (case (vector-ref e-3 0) ((0) (let ((e-5 (vector-ref e-3 1))) e-5)) (else (let ((e-6 (vector-ref e-3 1))) (string-append "'" e-6))))))(else (let ((e-0 (- arg-2 1))) (let ((e-10 (cdr arg-4))) (CoreC-45SchemeEvalC-45Compile-getSchVar e-0 e-10)))))))
(define CoreC-45SchemeEvalC-45Compile-schName (lambda (arg-0) (string-append "ct-" (CoreC-45SchemeEvalC-45Compile-schVarName arg-0))))
(define CoreC-45SchemeEvalC-45ToScheme-toSchemePi (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (vector 2 0)) ((1) (vector 2 1)) ((2) (vector 2 2)) (else (let ((e-4 (vector-ref arg-0 1))) (vector 7 e-4))))))
(define CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (vector 2 0)) ((0) (vector 2 1)) (else (let ((e-3 (vector-ref arg-0 1))) (vector 7 e-3))))))
(define CoreC-45SchemeEvalC-45Compile-unload (lambda (arg-0 arg-1) (if (null? arg-1) arg-0 (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 "ct-app") (cons arg-0 (cons e-2 '()))) e-3))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason (lambda (arg-0) (cond ((equal? arg-0 0) (vector 2 0)) ((equal? arg-0 1) (vector 2 1)) (else (vector 2 2)))))
(define CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount (lambda (arg-0) (let ((sc0 (AlgebraC-45Semiring-isErased csegen-931 arg-0))) (cond ((equal? sc0 1) (vector 2 0)) (else (let ((sc1 (AlgebraC-45Semiring-isLinear csegen-931 arg-0))) (cond ((equal? sc1 1) (vector 2 1)) (else (vector 2 2)))))))))
(define CoreC-45SchemeEvalC-45Compile-compileStk (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-59 (vector-ref arg-5 3))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 11 (CoreC-45SchemeEvalC-45Compile-getSchVar e-59 arg-3)) arg-4))))) ((1) (let ((e-62 (vector-ref arg-5 1))) (let ((e-63 (vector-ref arg-5 2))) (let ((e-64 (vector-ref arg-5 3))) (lambda (clam-0) (case (vector-ref e-63 0) ((0) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 6 (CoreC-45Name-u--show_Show_Name e-64)) arg-4))) ((2) (let ((e-75 (vector-ref e-63 1))) (let ((e-76 (vector-ref e-63 2))) (let ((sc2 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-4) e-76) 1) 0))) (cond ((equal? sc2 1) (let ((act-1 (CoreC-45Context-toResolvedNames arg-2 csegen-54 e-64 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-75 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-62) arg-4))))))) eff-0) clam-0)))))) (else (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-64)) '()) arg-4)))))))) ((3) (let ((e-77 (vector-ref e-63 1))) (let ((e-78 (vector-ref e-63 2))) (let ((sc2 (or (and (= (PreludeC-45TypesC-45List-lengthTR arg-4) e-78) 1) 0))) (cond ((equal? sc2 1) (let ((act-1 (CoreC-45Context-toResolvedNames arg-2 csegen-54 e-64 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 -1 (cons (vector 2 e-77) (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-64)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-62) arg-4))))))))) eff-0) clam-0)))))) (else (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-64)) '()) arg-4))))))))(else (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-64)) '()) arg-4))))))))) ((2) (let ((e-67 (vector-ref arg-5 2))) (let ((e-69 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 eta-1)) e-69 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 17 (vector 11 (CoreC-45SchemeEvalC-45Compile-schName e-67)) '()) (cons (vector 2 (PreludeC-45TypesC-45List-lengthTR e-69)) (PreludeC-45TypesC-45List-tailRecAppend arg-4 e-5))))))) eff-0) eta-0))))))))) ((3) (let ((e-72 (vector-ref arg-5 2))) (let ((e-73 (vector-ref arg-5 3))) (let ((e-74 (vector-ref arg-5 4))) (case (vector-ref e-73 0) ((1) (let ((e-82 (vector-ref e-73 3))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-72) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-82) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-74) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (CoreC-45SchemeEvalC-45Compile-unload (vector 13 u--xC-39 e-6 e-7) arg-4))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) ((2) (let ((e-86 (vector-ref e-73 2))) (let ((e-87 (vector-ref e-73 3))) (let ((e-88 (vector-ref e-73 4))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-72) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-88) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-74) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-87 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 8 -3 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-86) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-72) '())))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))) ((3) (let ((e-91 (vector-ref e-73 2))) (let ((e-92 (vector-ref e-73 3))) (let ((e-93 (vector-ref e-73 4))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-72) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-93) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-74) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-92 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 8 -12 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-91) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-72) '())))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))))) ((5) (let ((e-96 (vector-ref e-73 2))) (let ((e-97 (vector-ref e-73 3))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-72) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-97) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-74) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 8 -13 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-96) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-72) '()))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))) ((4) (let ((e-100 (vector-ref e-73 2))) (let ((e-101 (vector-ref e-73 3))) (let ((e-102 (vector-ref e-73 4))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-72) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-101) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-102) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-74) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 8 -14 (cons (vector 12 (cons u--xC-39 '()) e-8) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-100) (cons e-6 (cons e-7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-72) '())))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))(else (if (null? arg-4) (case (vector-ref arg-5 0) ((3) (let ((e-37 (vector-ref arg-5 2))) (let ((e-38 (vector-ref arg-5 3))) (let ((e-39 (vector-ref arg-5 4))) (case (vector-ref e-38 0) ((0) (let ((e-42 (vector-ref e-38 2))) (let ((e-43 (vector-ref e-38 3))) (let ((e-44 (vector-ref e-38 4))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-37) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-44) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-39) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-43 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 8 -8 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-42) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-37) '())))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '())))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '()))))))))))) (let ((e-33 (car arg-4))) (let ((e-34 (cdr arg-4))) (case (vector-ref arg-5 0) ((3) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (case (vector-ref e-48 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-47) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) e-34 e-49) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 17 (vector 12 (cons u--xC-39 '()) e-6) (cons e-33 '())))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '())))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '()))))))))))))))))))))(else (if (null? arg-4) (case (vector-ref arg-5 0) ((3) (let ((e-37 (vector-ref arg-5 2))) (let ((e-38 (vector-ref arg-5 3))) (let ((e-39 (vector-ref arg-5 4))) (case (vector-ref e-38 0) ((0) (let ((e-42 (vector-ref e-38 2))) (let ((e-43 (vector-ref e-38 3))) (let ((e-44 (vector-ref e-38 4))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-37) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-44) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) '() e-39) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 (CoreC-45SchemeEvalC-45Compile-compilePiInfo arg-1 arg-2 arg-3 e-43 eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 8 -8 (cons (vector 12 (cons u--xC-39 '()) e-7) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_RigCount e-42) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemePi e-8) (cons e-6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-37) '())))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '())))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '()))))))))))) (let ((e-33 (car arg-4))) (let ((e-34 (cdr arg-4))) (case (vector-ref arg-5 0) ((3) (let ((e-47 (vector-ref arg-5 2))) (let ((e-48 (vector-ref arg-5 3))) (let ((e-49 (vector-ref arg-5 4))) (case (vector-ref e-48 0) ((0) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--xC-39 (string-append (CoreC-45SchemeEvalC-45Compile-schVarName e-47) (string-append "-" (PreludeC-45Show-u--show_Show_Integer e-5))))) (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 (cons (vector 0 u--xC-39) arg-3) e-34 e-49) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 17 (vector 12 (cons u--xC-39 '()) e-6) (cons e-33 '())))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '())))))))))))))))(else (case (vector-ref arg-5 0) ((4) (let ((e-2 (vector-ref arg-5 2))) (let ((e-3 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-3) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 (cons e-5 arg-4) e-2))) eff-0) eta-0))))))))) ((5) (let ((e-8 (vector-ref arg-5 4))) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-8))) ((6) (let ((e-11 (vector-ref arg-5 2))) (let ((e-12 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 arg-4 e-12) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -15 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-11) (cons e-5 '()))))))) eff-0) eta-0))))))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (let ((e-16 (vector-ref arg-5 3))) (let ((e-17 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-16) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-17) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 8 -4 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-15) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-14) (cons (vector 12 '() e-5) (cons (vector 12 '() e-6) '()))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))) ((8) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 17 (vector 11 "ct-doForce") (cons e-5 (cons (vector 8 -5 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_LazyReason e-20) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-19) (cons (vector 12 '() e-5) '())))) '()))))))) eff-0) eta-0)))))))))) ((9) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-compileConstant e-23 e-24)))))) ((10) (let ((e-26 (vector-ref arg-5 1))) (let ((e-27 (vector-ref arg-5 2))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-compileWhyErased arg-1 arg-2 arg-3 arg-4 e-27 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 -6 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-26) (cons (CoreC-45SchemeEvalC-45ToScheme-toSchemeWhy e-5) '()))))))) eff-0) eta-0))))))))) (else (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (vector 1 (vector 8 -7 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC e-29) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-30) '()))))))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-compile (lambda (arg-1 arg-2 arg-3 arg-4) (CoreC-45SchemeEvalC-45Compile-compileStk arg-1 arg-2 arg-3 '() arg-4)))
(define CoreC-45SchemeEvalC-45Compile-n--7684-2115-u--vars (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (vector 0 ) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (vector 1 e-2 (CoreC-45SchemeEvalC-45Compile-n--7684-2115-u--vars arg-0 arg-1 e-3)))))))
(define CoreC-45SchemeEvalC-45Compile-blockedAppWith (lambda (arg-0 arg-1) (vector 8 -2 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-0) (cons (CoreC-45SchemeEvalC-45Compile-n--7684-2115-u--vars arg-1 arg-0 arg-1) '())))))
(define CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) (else (let ((e-1 (vector-ref arg-0 1))) (string-append "'" e-1))))))
(define CoreC-45SchemeEvalC-45Compile-bindArgs (lambda (arg-1 arg-2 arg-3 arg-4) (if (null? arg-2) arg-4 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (vector 8 -9 (cons (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-1 (PreludeC-45TypesC-45List-reverse arg-3)) (cons (vector 12 (cons (CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar e-2) '()) (CoreC-45SchemeEvalC-45Compile-bindArgs arg-1 e-3 (cons (vector 11 (CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar e-2)) arg-3) arg-4)) '()))))))))
(define CoreC-45SchemeEvalC-45Compile-blockedMetaApp (lambda (arg-0) (vector 12 (cons "arity-0" '()) (vector 8 -10 (cons (vector 1 (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-0) (vector 11 "arity-0")) (cons (vector 0 ) '()))))))
(define CoreC-45SchemeEvalC-45Builtins-mkArgList (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) '())(else (let ((e-0 (- arg-1 1))) (cons (string-append "x-" (PreludeC-45Show-u--show_Show_Int arg-0)) (CoreC-45SchemeEvalC-45Builtins-mkArgList (bs+ arg-0 1 63) e-0)))))))
(define CoreC-45SchemeEvalC-45Builtins-add (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct+") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct+") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s+") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u+") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct+") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-bits16 (lambda (arg-0) (vector 8 -107 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-bits32 (lambda (arg-0) (vector 8 -108 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-bits64 (lambda (arg-0) (vector 8 -109 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-bits8 (lambda (arg-0) (vector 8 -106 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int16 (lambda (arg-0) (vector 8 -102 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int32 (lambda (arg-0) (vector 8 -103 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int64 (lambda (arg-0) (vector 8 -104 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-int8 (lambda (arg-0) (vector 8 -101 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-integer (lambda (arg-0) (vector 8 -105 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-wrap (lambda (arg-0) (lambda (clam-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (CoreC-45SchemeEvalC-45Builtins-integer clam-0) (let ((e-2 (unbox e-0))) (cond ((equal? e-2 8) (CoreC-45SchemeEvalC-45Builtins-int8 clam-0)) ((equal? e-2 16) (CoreC-45SchemeEvalC-45Builtins-int16 clam-0)) ((equal? e-2 32) (CoreC-45SchemeEvalC-45Builtins-int32 clam-0)) ((equal? e-2 64) (CoreC-45SchemeEvalC-45Builtins-int64 clam-0))(else (CoreC-45SchemeEvalC-45Builtins-integer clam-0))))))) ((1) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 8) (CoreC-45SchemeEvalC-45Builtins-bits8 clam-0)) ((equal? e-1 16) (CoreC-45SchemeEvalC-45Builtins-bits16 clam-0)) ((equal? e-1 32) (CoreC-45SchemeEvalC-45Builtins-bits32 clam-0)) ((equal? e-1 64) (CoreC-45SchemeEvalC-45Builtins-bits64 clam-0))(else (CoreC-45SchemeEvalC-45Builtins-integer clam-0)))))(else (CoreC-45SchemeEvalC-45Builtins-integer clam-0))))))
(define CoreC-45SchemeEvalC-45Builtins-applyIntCast (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((0) (let ((e-8 (vector-ref arg-1 1))) (if (null? e-8) arg-2 (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((u--k (vector 0 (box e-4)))) (let ((sc5 (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc5 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '()))))))))))) (else (let ((e-3 (vector-ref arg-1 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap arg-1) (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((u--k (vector 0 (box e-7)))) (let ((sc5 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc5 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-7 1 63)) '()))))))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc4 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc4 1) arg-2) (else (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-6) '())))))))))))))))(else (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-2 (vector-ref arg-1 1))) (let ((e-4 (unbox e-2))) (let ((u--k (vector 0 (box e-4)))) (let ((sc3 (CoreC-45TTC-45Primitive-u--C-62C-61_Ord_Precision (box e-4) e-0))) (cond ((equal? sc3 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '()))))))))))) (else (let ((e-3 (vector-ref arg-1 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap arg-1) (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))))) (else (let ((e-1 (vector-ref arg-0 1))) (case (vector-ref arg-1 0) ((0) (let ((e-5 (vector-ref arg-1 1))) (let ((e-7 (unbox e-5))) (let ((u--k (vector 0 (box e-7)))) (let ((sc3 (PreludeC-45EqOrd-u--C-62_Ord_Int e-7 e-1))) (cond ((equal? sc3 1) arg-2) (else ((CoreC-45SchemeEvalC-45Builtins-wrap u--k) (vector 17 (vector 11 "ct-cast-signed") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-7 1 63)) '()))))))))))) (else (let ((e-6 (vector-ref arg-1 1))) (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int e-6 e-1))) (cond ((equal? sc2 1) arg-2) (else (vector 17 (vector 11 "ct-cast-unsigned") (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-6) '()))))))))))))))))
(define CoreC-45SchemeEvalC-45Builtins-canonical (lambda (arg-1 arg-2 arg-3) (if (null? arg-2) arg-3 (let ((e-3 (car arg-2))) (let ((e-4 (cdr arg-2))) (vector 14 (vector 17 (vector 11 "ct-isConstant") (cons e-3 '())) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 e-4 arg-3) arg-1))))))
(define CoreC-45SchemeEvalC-45Builtins-case--applyCast-3905 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cond ((equal? arg-1 10) (vector 17 (vector 11 "string") (cons arg-0 '())))(else arg-2)) (let ((e-2 (unbox arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (if (null? e-3) (CoreC-45SchemeEvalC-45Builtins-integer (vector 17 (vector 11 "char->integer") (cons arg-0 '()))) (let ((e-5 (unbox e-3))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-char-boundedInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-5 1 63)) '())))))))) (else (let ((e-4 (vector-ref e-2 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-char-boundedUInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))))))))
(define CoreC-45SchemeEvalC-45Builtins-case--applyCast-4062 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cond ((equal? arg-1 12) (vector 17 (vector 11 "ct-cast-string-double") (cons arg-0 '())))(else arg-2)) (let ((e-2 (unbox arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (if (null? e-3) (CoreC-45SchemeEvalC-45Builtins-integer (vector 17 (vector 11 "ct-cast-string-int") (cons arg-0 '()))) (let ((e-5 (unbox e-3))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-string-boundedInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-5 1 63)) '())))))))) (else (let ((e-4 (vector-ref e-2 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-cast-string-boundedUInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))))))))
(define CoreC-45SchemeEvalC-45Builtins-case--applyCast-4243 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (cond ((equal? arg-1 10) (vector 17 (vector 11 "number->string") (cons arg-0 '())))(else arg-2)) (let ((e-2 (unbox arg-3))) (case (vector-ref e-2 0) ((0) (let ((e-3 (vector-ref e-2 1))) (if (null? e-3) (CoreC-45SchemeEvalC-45Builtins-integer (vector 17 (vector 11 "ct-exact-truncate") (cons arg-0 '()))) (let ((e-5 (unbox e-3))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-exact-truncate-boundedInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-5 1 63)) '())))))))) (else (let ((e-4 (vector-ref e-2 1))) ((CoreC-45SchemeEvalC-45Builtins-wrap e-2) (vector 17 (vector 11 "ct-exact-truncate-boundedUInt") (cons arg-0 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-4) '())))))))))))
(define CoreC-45SchemeEvalC-45Builtins-applyCast (lambda (arg-0 arg-1 arg-2 arg-3) (cond ((equal? arg-1 11) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (CoreC-45SchemeEvalC-45Builtins-case--applyCast-3905 arg-3 arg-2 arg-0 (CoreC-45TTC-45Primitive-intKind arg-2))))(else (cond ((equal? arg-2 11) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc1 (CoreC-45TTC-45Primitive-intKind arg-1))) (if (null? sc1) arg-0 (vector 17 (vector 11 "ct-cast-int-char") (cons arg-3 '()))))))(else (cond ((equal? arg-1 10) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (CoreC-45SchemeEvalC-45Builtins-case--applyCast-4062 arg-3 arg-2 arg-0 (CoreC-45TTC-45Primitive-intKind arg-2))))(else (cond ((equal? arg-2 10) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc1 (CoreC-45TTC-45Primitive-intKind arg-1))) (if (null? sc1) (cond ((equal? arg-1 12) (vector 17 (vector 11 "number->string") (cons arg-3 '())))(else arg-0)) (vector 17 (vector 11 "ct-cast-number-string") (cons arg-3 '()))))))(else (cond ((equal? arg-1 12) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (CoreC-45SchemeEvalC-45Builtins-case--applyCast-4243 arg-3 arg-2 arg-0 (CoreC-45TTC-45Primitive-intKind arg-2))))(else (cond ((equal? arg-2 12) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc1 (CoreC-45TTC-45Primitive-intKind arg-1))) (if (null? sc1) (cond ((equal? arg-1 10) (vector 17 (vector 11 "ct-cast-string-double") (cons arg-3 '())))(else arg-0)) (vector 17 (vector 11 "ct-int-double") (cons arg-3 '()))))))(else (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-3 '()) (let ((sc0 (CoreC-45TTC-45Primitive-intKind arg-1))) (if (null? sc0) arg-0 (let ((e-5 (unbox sc0))) (let ((sc1 (CoreC-45TTC-45Primitive-intKind arg-2))) (if (null? sc1) arg-0 (let ((e-7 (unbox sc1))) (CoreC-45SchemeEvalC-45Builtins-applyIntCast e-5 e-7 arg-3))))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Builtins-binOp (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-2 (cons arg-3 '())) (vector 17 (vector 11 arg-1) (cons arg-2 (cons arg-3 '()))))))
(define CoreC-45SchemeEvalC-45Builtins-int (lambda (arg-0) (vector 8 -100 (cons arg-0 '()))))
(define CoreC-45SchemeEvalC-45Builtins-boolOp (lambda (arg-0 arg-1 arg-2 arg-3) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-2 (cons arg-3 '())) (CoreC-45SchemeEvalC-45Builtins-int (vector 17 (vector 11 "or") (cons (vector 17 (vector 11 "and") (cons (vector 17 (vector 11 arg-1) (cons arg-2 (cons arg-3 '()))) (cons (vector 2 1) '()))) (cons (vector 2 0) '())))))))
(define CoreC-45SchemeEvalC-45Builtins-div (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct/") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct/") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s/") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u/") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct/") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-mod (lambda (arg-0 arg-1) (vector 17 (vector 11 "ct-mod") (cons arg-0 (cons arg-1 '())))))
(define CoreC-45SchemeEvalC-45Builtins-mul (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct*") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct*") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s*") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u*") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct*") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-shl (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct-shl") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct-shl") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-bits-shl-signed") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-bits-shl") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct-shl") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-shr (lambda (arg-0 arg-1 arg-2) (vector 17 (vector 11 "ct-shr") (cons arg-1 (cons arg-2 '())))))
(define CoreC-45SchemeEvalC-45Builtins-sub (lambda (arg-0 arg-1 arg-2) (if (null? arg-0) (vector 17 (vector 11 "ct-") (cons arg-1 (cons arg-2 '()))) (let ((e-1 (unbox arg-0))) (case (vector-ref e-1 0) ((0) (let ((e-2 (vector-ref e-1 1))) (if (null? e-2) (vector 17 (vector 11 "ct-") (cons arg-1 (cons arg-2 '()))) (let ((e-4 (unbox e-2))) (vector 17 (vector 11 "ct-s-") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int (bs- e-4 1 63)) '())))))))) ((1) (let ((e-3 (vector-ref e-1 1))) (vector 17 (vector 11 "ct-u-") (cons arg-1 (cons arg-2 (cons (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int e-3) '()))))))(else (vector 17 (vector 11 "ct-") (cons arg-1 (cons arg-2 '())))))))))
(define CoreC-45SchemeEvalC-45Builtins-testPartial (lambda (arg-0 arg-1) (vector 13 "p-0" arg-1 (vector 14 (vector 17 (vector 11 "ct-isConstant") (cons (vector 11 "p-0") '())) (vector 11 "p-0") arg-0))))
(define CoreC-45SchemeEvalC-45Builtins-unaryOp (lambda (arg-0 arg-1 arg-2) (CoreC-45SchemeEvalC-45Builtins-canonical arg-0 (cons arg-2 '()) (vector 17 (vector 11 arg-1) (cons arg-2 '())))))
(define CoreC-45SchemeEvalC-45Builtins-applyOp (lambda (arg-1 arg-2 arg-3) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (cond ((equal? e-0 12) (if (null? arg-3) (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TTC-45Primitive-intKind e-0) e-20 e-24)))))) (let ((e-29 (car arg-3))) (let ((e-30 (cdr arg-3))) (if (null? e-30) (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TTC-45Primitive-intKind e-0) e-20 e-24)))))) (let ((e-33 (car e-30))) (let ((e-34 (cdr e-30))) (if (null? e-34) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "+" e-29 e-33) (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TTC-45Primitive-intKind e-0) e-20 e-24))))))))))))))(else (let ((e-20 (car arg-3))) (let ((e-21 (cdr arg-3))) (let ((e-24 (car e-21))) (let ((e-25 (cdr e-21))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-20 (cons e-24 '())) (CoreC-45SchemeEvalC-45Builtins-add (CoreC-45TTC-45Primitive-intKind e-0) e-20 e-24)))))))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (cond ((equal? e-1 12) (if (null? arg-3) (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TTC-45Primitive-intKind e-1) e-38 e-42)))))) (let ((e-47 (car arg-3))) (let ((e-48 (cdr arg-3))) (if (null? e-48) (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TTC-45Primitive-intKind e-1) e-38 e-42)))))) (let ((e-51 (car e-48))) (let ((e-52 (cdr e-48))) (if (null? e-52) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "-" e-47 e-51) (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TTC-45Primitive-intKind e-1) e-38 e-42))))))))))))))(else (let ((e-38 (car arg-3))) (let ((e-39 (cdr arg-3))) (let ((e-42 (car e-39))) (let ((e-43 (cdr e-39))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-38 (cons e-42 '())) (CoreC-45SchemeEvalC-45Builtins-sub (CoreC-45TTC-45Primitive-intKind e-1) e-38 e-42)))))))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (cond ((equal? e-2 12) (if (null? arg-3) (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TTC-45Primitive-intKind e-2) e-56 e-60)))))) (let ((e-65 (car arg-3))) (let ((e-66 (cdr arg-3))) (if (null? e-66) (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TTC-45Primitive-intKind e-2) e-56 e-60)))))) (let ((e-69 (car e-66))) (let ((e-70 (cdr e-66))) (if (null? e-70) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "*" e-65 e-69) (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TTC-45Primitive-intKind e-2) e-56 e-60))))))))))))))(else (let ((e-56 (car arg-3))) (let ((e-57 (cdr arg-3))) (let ((e-60 (car e-57))) (let ((e-61 (cdr e-57))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-56 (cons e-60 '())) (CoreC-45SchemeEvalC-45Builtins-mul (CoreC-45TTC-45Primitive-intKind e-2) e-56 e-60)))))))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (cond ((equal? e-3 12) (if (null? arg-3) (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TTC-45Primitive-intKind e-3) e-74 e-78)))))) (let ((e-83 (car arg-3))) (let ((e-84 (cdr arg-3))) (if (null? e-84) (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TTC-45Primitive-intKind e-3) e-74 e-78)))))) (let ((e-87 (car e-84))) (let ((e-88 (cdr e-84))) (if (null? e-88) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "/" e-83 e-87) (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TTC-45Primitive-intKind e-3) e-74 e-78))))))))))))))(else (let ((e-74 (car arg-3))) (let ((e-75 (cdr arg-3))) (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-74 (cons e-78 '())) (CoreC-45SchemeEvalC-45Builtins-div (CoreC-45TTC-45Primitive-intKind e-3) e-74 e-78)))))))))) ((5) (let ((e-4 (vector-ref arg-2 1))) (cond ((equal? e-4 12) (if (null? arg-3) (let ((e-92 (car arg-3))) (let ((e-93 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-92 '()) (vector 17 (vector 11 "ct-neg") (cons e-92 '()))))) (let ((e-97 (car arg-3))) (let ((e-98 (cdr arg-3))) (if (null? e-98) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "-" e-97) (let ((e-92 (car arg-3))) (let ((e-93 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-92 '()) (vector 17 (vector 11 "ct-neg") (cons e-92 '()))))))))))(else (let ((e-92 (car arg-3))) (let ((e-93 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-92 '()) (vector 17 (vector 11 "ct-neg") (cons e-92 '()))))))))) ((4) (let ((e-102 (car arg-3))) (let ((e-103 (cdr arg-3))) (let ((e-106 (car e-103))) (let ((e-107 (cdr e-103))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-102 (cons e-106 '())) (CoreC-45SchemeEvalC-45Builtins-mod e-102 e-106))))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (let ((e-111 (car arg-3))) (let ((e-112 (cdr arg-3))) (let ((e-115 (car e-112))) (let ((e-116 (cdr e-112))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-111 (cons e-115 '())) (CoreC-45SchemeEvalC-45Builtins-shl (CoreC-45TTC-45Primitive-intKind e-6) e-111 e-115)))))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (let ((e-120 (car arg-3))) (let ((e-121 (cdr arg-3))) (let ((e-124 (car e-121))) (let ((e-125 (cdr e-121))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-120 (cons e-124 '())) (CoreC-45SchemeEvalC-45Builtins-shr (CoreC-45TTC-45Primitive-intKind e-7) e-120 e-124)))))))) ((8) (let ((e-129 (car arg-3))) (let ((e-130 (cdr arg-3))) (let ((e-133 (car e-130))) (let ((e-134 (cdr e-130))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "ct-and" e-129 e-133)))))) ((9) (let ((e-138 (car arg-3))) (let ((e-139 (cdr arg-3))) (let ((e-142 (car e-139))) (let ((e-143 (cdr e-139))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "ct-or" e-138 e-142)))))) ((10) (let ((e-147 (car arg-3))) (let ((e-148 (cdr arg-3))) (let ((e-151 (car e-148))) (let ((e-152 (cdr e-148))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "ct-xor" e-147 e-151)))))) ((11) (let ((e-11 (vector-ref arg-2 1))) (cond ((equal? e-11 11) (if (null? arg-3) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-165 (car arg-3))) (let ((e-166 (cdr arg-3))) (if (null? e-166) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-169 (car e-166))) (let ((e-170 (cdr e-166))) (if (null? e-170) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char<?" e-165 e-169) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))))))))))) ((equal? e-11 10) (if (null? arg-3) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-174 (car arg-3))) (let ((e-175 (cdr arg-3))) (if (null? e-175) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-178 (car e-175))) (let ((e-179 (cdr e-175))) (if (null? e-179) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string<?" e-174 e-178) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))))))))))) ((equal? e-11 12) (if (null? arg-3) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-183 (car arg-3))) (let ((e-184 (cdr arg-3))) (if (null? e-184) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))) (let ((e-187 (car e-184))) (let ((e-188 (cdr e-184))) (if (null? e-188) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "<" e-183 e-187) (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160)))))))))))))(else (let ((e-156 (car arg-3))) (let ((e-157 (cdr arg-3))) (let ((e-160 (car e-157))) (let ((e-161 (cdr e-157))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<" e-156 e-160))))))))) ((12) (let ((e-12 (vector-ref arg-2 1))) (cond ((equal? e-12 11) (if (null? arg-3) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-201 (car arg-3))) (let ((e-202 (cdr arg-3))) (if (null? e-202) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-205 (car e-202))) (let ((e-206 (cdr e-202))) (if (null? e-206) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char<=?" e-201 e-205) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))))))))))) ((equal? e-12 10) (if (null? arg-3) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-210 (car arg-3))) (let ((e-211 (cdr arg-3))) (if (null? e-211) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-214 (car e-211))) (let ((e-215 (cdr e-211))) (if (null? e-215) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string<=?" e-210 e-214) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))))))))))) ((equal? e-12 12) (if (null? arg-3) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-219 (car arg-3))) (let ((e-220 (cdr arg-3))) (if (null? e-220) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))) (let ((e-223 (car e-220))) (let ((e-224 (cdr e-220))) (if (null? e-224) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "<=" e-219 e-223) (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196)))))))))))))(else (let ((e-192 (car arg-3))) (let ((e-193 (cdr arg-3))) (let ((e-196 (car e-193))) (let ((e-197 (cdr e-193))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct<=" e-192 e-196))))))))) ((13) (let ((e-13 (vector-ref arg-2 1))) (cond ((equal? e-13 11) (if (null? arg-3) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-237 (car arg-3))) (let ((e-238 (cdr arg-3))) (if (null? e-238) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-241 (car e-238))) (let ((e-242 (cdr e-238))) (if (null? e-242) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char=?" e-237 e-241) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))))))))))) ((equal? e-13 10) (if (null? arg-3) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-246 (car arg-3))) (let ((e-247 (cdr arg-3))) (if (null? e-247) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-250 (car e-247))) (let ((e-251 (cdr e-247))) (if (null? e-251) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string=?" e-246 e-250) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))))))))))) ((equal? e-13 12) (if (null? arg-3) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-255 (car arg-3))) (let ((e-256 (cdr arg-3))) (if (null? e-256) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))) (let ((e-259 (car e-256))) (let ((e-260 (cdr e-256))) (if (null? e-260) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "=" e-255 e-259) (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232)))))))))))))(else (let ((e-228 (car arg-3))) (let ((e-229 (cdr arg-3))) (let ((e-232 (car e-229))) (let ((e-233 (cdr e-229))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct=" e-228 e-232))))))))) ((14) (let ((e-14 (vector-ref arg-2 1))) (cond ((equal? e-14 11) (if (null? arg-3) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-273 (car arg-3))) (let ((e-274 (cdr arg-3))) (if (null? e-274) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-277 (car e-274))) (let ((e-278 (cdr e-274))) (if (null? e-278) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char>=?" e-273 e-277) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))))))))))) ((equal? e-14 10) (if (null? arg-3) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-282 (car arg-3))) (let ((e-283 (cdr arg-3))) (if (null? e-283) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-286 (car e-283))) (let ((e-287 (cdr e-283))) (if (null? e-287) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string>=?" e-282 e-286) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))))))))))) ((equal? e-14 12) (if (null? arg-3) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-291 (car arg-3))) (let ((e-292 (cdr arg-3))) (if (null? e-292) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))) (let ((e-295 (car e-292))) (let ((e-296 (cdr e-292))) (if (null? e-296) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 ">=" e-291 e-295) (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268)))))))))))))(else (let ((e-264 (car arg-3))) (let ((e-265 (cdr arg-3))) (let ((e-268 (car e-265))) (let ((e-269 (cdr e-265))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>=" e-264 e-268))))))))) ((15) (let ((e-15 (vector-ref arg-2 1))) (cond ((equal? e-15 11) (if (null? arg-3) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-309 (car arg-3))) (let ((e-310 (cdr arg-3))) (if (null? e-310) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-313 (car e-310))) (let ((e-314 (cdr e-310))) (if (null? e-314) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "char>?" e-309 e-313) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))))))))))) ((equal? e-15 10) (if (null? arg-3) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-318 (car arg-3))) (let ((e-319 (cdr arg-3))) (if (null? e-319) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-322 (car e-319))) (let ((e-323 (cdr e-319))) (if (null? e-323) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "string>?" e-318 e-322) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))))))))))) ((equal? e-15 12) (if (null? arg-3) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-327 (car arg-3))) (let ((e-328 (cdr arg-3))) (if (null? e-328) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))) (let ((e-331 (car e-328))) (let ((e-332 (cdr e-328))) (if (null? e-332) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 ">" e-327 e-331) (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304)))))))))))))(else (let ((e-300 (car arg-3))) (let ((e-301 (cdr arg-3))) (let ((e-304 (car e-301))) (let ((e-305 (cdr e-301))) (CoreC-45SchemeEvalC-45Builtins-boolOp arg-1 "ct>" e-300 e-304))))))))) ((16) (let ((e-336 (car arg-3))) (let ((e-337 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-336 '()) (vector 8 -100 (cons (vector 17 (vector 11 "string-length") (cons e-336 '())) '())))))) ((17) (let ((e-341 (car arg-3))) (let ((e-342 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-341 '()) (vector 17 (vector 11 "string-ref") (cons e-341 (cons (vector 2 0) '()))))))) ((18) (let ((e-346 (car arg-3))) (let ((e-347 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-346 '()) (vector 17 (vector 11 "substring") (cons e-346 (cons (vector 2 1) (cons (vector 17 (vector 11 "string-length") (cons e-346 '())) '())))))))) ((19) (let ((e-351 (car arg-3))) (let ((e-352 (cdr arg-3))) (let ((e-355 (car e-352))) (let ((e-356 (cdr e-352))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-351 (cons e-355 '())) (CoreC-45SchemeEvalC-45Builtins-testPartial arg-1 (vector 17 (vector 11 "ct-string-ref") (cons e-351 (cons e-355 '())))))))))) ((20) (let ((e-360 (car arg-3))) (let ((e-361 (cdr arg-3))) (let ((e-364 (car e-361))) (let ((e-365 (cdr e-361))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-360 (cons e-364 '())) (vector 17 (vector 11 "ct-string-cons") (cons e-360 (cons e-364 '()))))))))) ((21) (let ((e-369 (car arg-3))) (let ((e-370 (cdr arg-3))) (let ((e-373 (car e-370))) (let ((e-374 (cdr e-370))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-369 (cons e-373 '())) (vector 17 (vector 11 "string-append") (cons e-369 (cons e-373 '()))))))))) ((22) (let ((e-378 (car arg-3))) (let ((e-379 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-378 '()) (vector 17 (vector 11 "ct-string-reverse") (cons e-378 '())))))) ((23) (let ((e-383 (car arg-3))) (let ((e-384 (cdr arg-3))) (let ((e-387 (car e-384))) (let ((e-388 (cdr e-384))) (let ((e-391 (car e-388))) (let ((e-392 (cdr e-388))) (CoreC-45SchemeEvalC-45Builtins-canonical arg-1 (cons e-383 (cons e-387 (cons e-391 '()))) (vector 17 (vector 11 "ct-string-substr") (cons e-383 '())))))))))) ((24) (let ((e-396 (car arg-3))) (let ((e-397 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flexp" e-396)))) ((25) (let ((e-401 (car arg-3))) (let ((e-402 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "fllog" e-401)))) ((26) (let ((e-406 (car arg-3))) (let ((e-407 (cdr arg-3))) (let ((e-410 (car e-407))) (let ((e-411 (cdr e-407))) (CoreC-45SchemeEvalC-45Builtins-binOp arg-1 "expt" e-406 e-410)))))) ((27) (let ((e-415 (car arg-3))) (let ((e-416 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flsin" e-415)))) ((28) (let ((e-420 (car arg-3))) (let ((e-421 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flcos" e-420)))) ((29) (let ((e-425 (car arg-3))) (let ((e-426 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "fltan" e-425)))) ((30) (let ((e-430 (car arg-3))) (let ((e-431 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flasin" e-430)))) ((31) (let ((e-435 (car arg-3))) (let ((e-436 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flacos" e-435)))) ((32) (let ((e-440 (car arg-3))) (let ((e-441 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flatan" e-440)))) ((33) (let ((e-445 (car arg-3))) (let ((e-446 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flsqrt" e-445)))) ((34) (let ((e-450 (car arg-3))) (let ((e-451 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flfloor" e-450)))) ((35) (let ((e-455 (car arg-3))) (let ((e-456 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-unaryOp arg-1 "flceiling" e-455)))) ((36) (let ((e-16 (vector-ref arg-2 1))) (let ((e-17 (vector-ref arg-2 2))) (let ((e-460 (car arg-3))) (let ((e-461 (cdr arg-3))) (CoreC-45SchemeEvalC-45Builtins-applyCast arg-1 e-16 e-17 e-460)))))) ((37) (let ((e-466 (cdr arg-3))) (let ((e-470 (cdr e-466))) (let ((e-473 (car e-470))) (let ((e-474 (cdr e-470))) e-473))))) (else (let ((e-479 (cdr arg-3))) (let ((e-483 (cdr e-479))) arg-1))))))
(define CoreC-45SchemeEvalC-45Builtins-n--10819-5544-u--vars (lambda (arg-0 arg-1 arg-2 arg-4 arg-6) (if (null? arg-6) (vector 0 ) (let ((e-3 (car arg-6))) (let ((e-4 (cdr arg-6))) (vector 1 (vector 11 e-3) (CoreC-45SchemeEvalC-45Builtins-n--10819-5544-u--vars arg-0 arg-1 arg-2 arg-4 e-4)))))))
(define CoreC-45SchemeEvalC-45Builtins-n--10802-5536-u--makeBlockedApp (lambda (arg-0 arg-1 arg-2 arg-4) (vector 8 -2 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45Builtins-n--10819-5544-u--vars arg-0 arg-1 arg-2 arg-4 arg-4) '())))))
(define CoreC-45SchemeEvalC-45Builtins-n--10802-5535-u--bindArgs (lambda (arg-0 arg-1 arg-2 arg-5 arg-6 arg-7) (if (null? arg-5) (CoreC-45SchemeEvalC-45Builtins-applyOp (CoreC-45SchemeEvalC-45Builtins-n--10802-5536-u--makeBlockedApp arg-0 arg-1 arg-2 arg-7) arg-1 (DataC-45Vect-u--map_Functor_C-40VectC-32C-36nC-41 (lambda (eta-0) (vector 11 eta-0)) arg-7)) (let ((e-3 (car arg-5))) (let ((e-4 (cdr arg-5))) (vector 8 -9 (cons (CoreC-45SchemeEvalC-45Builtins-n--10802-5536-u--makeBlockedApp arg-0 arg-1 arg-2 (DataC-45Vect-reverse arg-6)) (cons (vector 12 (cons e-3 '()) (CoreC-45SchemeEvalC-45Builtins-n--10802-5535-u--bindArgs arg-0 arg-1 arg-2 e-4 (cons e-3 arg-6) arg-7)) '()))))))))
(define CoreC-45SchemeEvalC-45Builtins-compileBuiltin (lambda (arg-0 arg-1 arg-2) (let ((u--args (CoreC-45SchemeEvalC-45Builtins-mkArgList 0 arg-0))) (CoreC-45SchemeEvalC-45Builtins-n--10802-5535-u--bindArgs arg-0 arg-2 arg-1 u--args '() u--args))))
(define CoreC-45SchemeEvalC-45Compile-n--9368-4079-u--caseType (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11) (if (null? arg-11) (lambda (eta-0) (vector 1 (vector 0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9))) (let ((e-2 (car arg-11))) (let ((e-3 (cdr arg-11))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-9))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-9 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-10) (lambda (eta-2) (vector 1 (vector 1 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9))) (let ((e-1 (unbox e-10))) (lambda (clam-0) (let ((e-18 (vector-ref e-1 18))) (case (vector-ref e-18 0) ((5) (vector 1 (vector 0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9))) ((6) (vector 1 (vector 1 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))(else (vector 1 (vector 0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((1) (lambda (eta-0) (vector 1 (vector 2 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))) ((2) (lambda (eta-0) (vector 1 (vector 3 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9)))) (else (CoreC-45SchemeEvalC-45Compile-n--9368-4079-u--caseType arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 e-3))))))))
(define CoreC-45SchemeEvalC-45Compile-getArgName (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 "carg" (blodwen-toSignedInt e-5 63)))))) eff-0) ext-0)))))))
(define CoreC-45SchemeEvalC-45Compile-extend (lambda (arg-1 arg-2 arg-3 ext-0) (if (null? arg-2) (vector 1 (cons '() arg-3)) (let ((e-3 (cdr arg-2))) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45SchemeEvalC-45Compile-extend arg-1 e-3 arg-3 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (vector 1 (cons (cons e-5 e-7) (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-5)) e-4)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))))
(define CoreC-45SchemeEvalC-45Compile-n--9412-4415-u--project (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 arg-17) (if (null? arg-16) arg-17 (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-2) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-15) (cons (vector 2 arg-14) '()))) (CoreC-45SchemeEvalC-45Compile-n--9412-4415-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 (bs+ arg-14 1 63) arg-15 e-3 arg-17)))))))
(define CoreC-45SchemeEvalC-45Compile-n--9412-4413-u--bindArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 ext-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-extend arg-1 arg-15 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (CoreC-45SchemeEvalC-45Compile-n--9412-4415-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 3 arg-14 e-2 e-6)))))) (CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 e-3 arg-16) clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45SchemeEvalC-45Compile-n--9412-4414-u--makeAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((0) (let ((e-2 (vector-ref arg-15 2))) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9412-4413-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (cons (vector 2 e-2) e-5)))))) eff-0) ext-0)))))))))(else (vector 1 '())))))
(define CoreC-45SchemeEvalC-45Compile-n--9368-4080-u--makeDefault (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-10) (if (null? arg-10) (lambda (eta-0) (vector 1 arg-8)) (let ((e-2 (car arg-10))) (let ((e-3 (cdr arg-10))) (case (vector-ref e-2 0) ((3) (let ((e-5 (vector-ref e-2 1))) (CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 arg-7 e-5)))(else (CoreC-45SchemeEvalC-45Compile-n--9368-4080-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 e-3))))))))
(define CoreC-45SchemeEvalC-45Compile-n--9368-4081-u--toSchemeConCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45SchemeEvalC-45Compile-n--9412-4414-u--makeAlt arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var eta-1 eta-2))) arg-13 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-n--9368-4080-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--caseblock (vector 15 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 0) '()))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-2) eta-2) e-5) (box e-6)))) (lambda (eta-2) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isDataCon") (cons (vector 11 u--var) '())) u--caseblock arg-8)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define CoreC-45SchemeEvalC-45Compile-n--9413-4996-u--makeAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 ext-0) (case (vector-ref arg-15 0) ((2) (let ((e-1 (vector-ref arg-15 1))) (let ((e-2 (vector-ref arg-15 2))) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 arg-7 e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (cons (vector 17 (vector 11 "equal?") (cons (vector 11 arg-14) (cons (CoreC-45SchemeEvalC-45Compile-compileConstant CoreC-45FC-emptyFC e-1) '()))) e-5)))))) eff-0) ext-0))))))))(else (vector 1 '())))))
(define CoreC-45SchemeEvalC-45Compile-n--9368-4082-u--toSchemeConstCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (CoreC-45SchemeEvalC-45Compile-n--9413-4996-u--makeAlt arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var eta-1 eta-2))) arg-13 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-n--9368-4080-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--caseblock (vector 16 (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-2) eta-2) e-5) (box e-6)))) (lambda (eta-2) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isConstant") (cons (vector 11 u--var) '())) u--caseblock arg-8)))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define CoreC-45SchemeEvalC-45Compile-n--9368-4083-u--toSchemeDelayCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (if (null? arg-13) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (car arg-13))) (let ((e-2 (cdr arg-13))) (case (vector-ref e-1 0) ((1) (let ((e-6 (vector-ref e-1 3))) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--svsC-39 (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-7)) (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-8)) arg-7)))) (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 u--svsC-39 e-6) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isDelay") (cons (vector 11 u--var) '())) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-7) (vector 17 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 3) '()))) '()) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-8) (vector 17 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 4) '()))) '()) e-9)) arg-8))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))(else (CoreC-45SchemeEvalC-45Compile-n--9368-4083-u--toSchemeDelayCases arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 e-2))))))))
(define CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16) (if (null? arg-15) (lambda (eta-0) (vector 1 arg-16)) (let ((e-2 (car arg-15))) (let ((e-3 (cdr arg-15))) (case (vector-ref e-2 0) ((0) (let ((e-5 (vector-ref e-2 1))) (let ((e-7 (vector-ref e-2 3))) (let ((e-8 (vector-ref e-2 4))) (case (vector-ref e-5 0) ((1) (let ((e-9 (vector-ref e-5 1))) (case (vector-ref e-9 0) ((0) (let ((e-10 (vector-ref e-9 1))) (cond ((equal? e-10 "->") (if (null? e-7) (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16) (let ((e-13 (cdr e-7))) (if (null? e-13) (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16) (let ((e-16 (cdr e-13))) (if (null? e-16) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45SchemeEvalC-45Compile-getArgName arg-1 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--svsC-39 (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-11)) (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-14)) arg-7)))) (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 u--svsC-39 e-8) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-17 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isPi") (cons (vector 11 arg-14) '())) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-11) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-14) (cons (vector 2 4) '()))) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-14) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-14) (cons (vector 2 1) '()))) e-17)) arg-16))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))))(else (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))(else (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))(else (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16)))))))(else (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 arg-16))))))))
(define CoreC-45SchemeEvalC-45Compile-n--9415-4639-u--project (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 arg-17) (if (null? arg-16) arg-17 (let ((e-2 (car arg-16))) (let ((e-3 (cdr arg-16))) (vector 13 (CoreC-45SchemeEvalC-45Compile-schVarName e-2) (vector 17 (vector 11 "vector-ref") (cons (vector 11 arg-15) (cons (vector 2 arg-14) '()))) (CoreC-45SchemeEvalC-45Compile-n--9415-4639-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 (bs+ arg-14 1 63) arg-15 e-3 arg-17)))))))
(define CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15 arg-16 ext-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-extend arg-1 arg-15 arg-7 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref eta-0 1))) (vector 1 (CoreC-45SchemeEvalC-45Compile-n--9415-4639-u--project arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 5 arg-14 e-2 e-6)))))) (CoreC-45SchemeEvalC-45Compile-compileCase arg-1 arg-9 arg-8 e-3 arg-16) clam-0)))))) eff-0) ext-0)))))))
(define CoreC-45SchemeEvalC-45Compile-n--9415-4638-u--makeAlt (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 arg-15) (case (vector-ref arg-15 0) ((0) (let ((e-1 (vector-ref arg-15 1))) (let ((e-3 (vector-ref arg-15 3))) (let ((e-4 (vector-ref arg-15 4))) (case (vector-ref e-1 0) ((1) (let ((e-5 (vector-ref e-1 1))) (case (vector-ref e-5 0) ((0) (let ((e-6 (vector-ref e-5 1))) (cond ((equal? e-6 "->") (if (null? e-3) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7)))))) eff-0) eta-0)))))) (let ((e-9 (cdr e-3))) (lambda (clam-0) (if (null? e-9) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7)))))) eff-0) clam-0))))) (let ((e-12 (cdr e-9))) (if (null? e-12) (vector 1 '()) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7)))))) eff-0) clam-0))))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-7 (vector-ref act-1 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-7)))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-6)))))) eff-0) eta-0))))))))))(else (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-n--9415-4637-u--bindArgs arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-12 arg-14 e-3 e-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (box (cons (vector 4 (CoreC-45Name-u--show_Show_Name e-1)) e-5)))))) eff-0) eta-0))))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define CoreC-45SchemeEvalC-45Compile-n--9368-4084-u--toSchemeTyConCases (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-11 arg-13) (let ((u--var (CoreC-45SchemeEvalC-45Compile-getSchVar arg-11 arg-7))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (CoreC-45SchemeEvalC-45Compile-n--9415-4638-u--makeAlt arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var eta-1)) arg-13 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45SchemeEvalC-45Compile-n--9368-4080-u--makeDefault arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-n--9415-4636-u--addPiMatch arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 arg-9 arg-13 arg-11 u--var arg-13 (vector 15 (vector 17 (vector 11 "vector-ref") (cons (vector 11 u--var) (cons (vector 2 2) '()))) (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-2) eta-2) e-5) (box e-6))))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 14 (vector 17 (vector 11 "ct-isTypeMatchable") (cons (vector 11 u--var) '())) e-6 arg-8))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))
(define CoreC-45SchemeEvalC-45Compile-compileCase (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-1 (vector-ref arg-5 1))) (let ((e-2 (vector-ref arg-5 2))) (let ((e-4 (vector-ref arg-5 3))) (let ((e-5 (vector-ref arg-5 4))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-n--9368-4079-u--caseType arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-5) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-6 0) ((0) (CoreC-45SchemeEvalC-45Compile-n--9368-4081-u--toSchemeConCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5)) ((1) (CoreC-45SchemeEvalC-45Compile-n--9368-4084-u--toSchemeTyConCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5)) ((2) (CoreC-45SchemeEvalC-45Compile-n--9368-4083-u--toSchemeDelayCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5)) (else (CoreC-45SchemeEvalC-45Compile-n--9368-4082-u--toSchemeConstCases arg-1 e-1 e-5 e-4 e-2 arg-4 arg-3 arg-2 e-2 e-5))))) eff-0) eta-0))))))))))) ((1) (let ((e-8 (vector-ref arg-5 2))) (CoreC-45SchemeEvalC-45Compile-compile arg-1 arg-2 arg-4 e-8)))(else (lambda (eta-0) (vector 1 arg-3))))))
(define CoreC-45SchemeEvalC-45Compile-mkArgs (lambda (arg-0 ext-0) (if (null? arg-0) (vector 1 '()) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-mkArgs e-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (cons (vector 0 (CoreC-45SchemeEvalC-45Compile-schVarName e-2)) e-5))))) eff-0) ext-0))))))))))
(define CoreC-45SchemeEvalC-45Compile-varObjs (lambda (arg-1) (if (null? arg-1) '() (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (cons (vector 11 (CoreC-45SchemeEvalC-45Compile-u--show_Show_SVar e-2)) (CoreC-45SchemeEvalC-45Compile-varObjs e-3)))))))
(define CoreC-45SchemeEvalC-45Compile-n--10909-5703-u--mkArgNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (cond ((equal? arg-7 0) '())(else (let ((e-0 (- arg-7 1))) (cons (vector 2 "arg" arg-6) (CoreC-45SchemeEvalC-45Compile-n--10909-5703-u--mkArgNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (bs+ arg-6 1 63) e-0)))))))
(define CoreC-45SchemeEvalC-45Compile-n--10909-5811-u--mkArgNs (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (cond ((equal? arg-12 0) '())(else (let ((e-0 (- arg-12 1))) (cons (vector 2 "arg" arg-11) (CoreC-45SchemeEvalC-45Compile-n--10909-5811-u--mkArgNs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 (bs+ arg-11 1 63) e-0)))))))
(define CoreC-45SchemeEvalC-45Compile-compileBody (lambda (arg-0 arg-1 arg-2 arg-3) (case (vector-ref arg-3 0) ((0) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 '())))) ((1) (let ((e-0 (vector-ref arg-3 1))) (let ((e-1 (vector-ref arg-3 2))) (let ((e-2 (vector-ref arg-3 3))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.SchemeEval.Compile.Sym" ) 0) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45SchemeEvalC-45Compile-mkArgs e-1 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--blk (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 (CoreC-45SchemeEvalC-45Compile-varObjs e-6)))) (lambda (eta-2) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compileCase e-5 arg-0 u--blk e-6 e-2) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--bodyC-39 (cond ((equal? arg-1 1) (vector 14 (vector 17 (vector 11 "ct-isBlockAll") '()) u--blk e-7)) (else u--blk)))) (lambda (clam-0) (let ((e-10 (vector-ref e-0 0))) (if (null? e-10) (vector 1 (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-6 '() u--bodyC-39)) (vector 1 (vector 12 (cons "h-0" '()) (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-6 '() u--bodyC-39))))))))) eff-0) eta-2))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))) ((2) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 '())))) ((3) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedAppWith arg-2 '())))) ((4) (let ((e-8 (vector-ref arg-3 1))) (let ((e-9 (vector-ref arg-3 2))) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Builtins-compileBuiltin e-8 arg-2 e-9)))))) ((5) (let ((e-10 (vector-ref arg-3 1))) (let ((e-11 (vector-ref arg-3 2))) (let ((e-12 (vector-ref arg-3 3))) (cond ((equal? e-11 0) (lambda (eta-0) (let ((act-1 (CoreC-45Context-toResolvedNames arg-0 csegen-54 arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 e-10 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name e-5) csegen-5241)))))) eff-0) eta-0)))))))(else (let ((u--args (CoreC-45SchemeEvalC-45Compile-n--10909-5703-u--mkArgNs arg-1 e-12 e-11 e-10 arg-2 arg-0 0 e-11))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-mkArgs u--args eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--body (vector 8 e-10 (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC CoreC-45FC-emptyFC) (PreludeC-45TypesC-45List-mapAppend '() csegen-5242 u--args)))))) (lambda (eta-1) (vector 1 (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-5 '() u--body)))))) eff-0) eta-0))))))))))))) ((6) (let ((e-13 (vector-ref arg-3 1))) (let ((e-14 (vector-ref arg-3 2))) (let ((e-15 (vector-ref arg-3 3))) (let ((e-16 (vector-ref arg-3 4))) (let ((e-17 (vector-ref arg-3 5))) (let ((e-18 (vector-ref arg-3 6))) (let ((e-19 (vector-ref arg-3 7))) (let ((e-20 (vector-ref arg-3 8))) (cond ((equal? e-14 0) (lambda (eta-0) (vector 1 (vector 8 -1 (cons (vector 2 e-13) (cons (vector 4 (CoreC-45Name-u--show_Show_Name arg-2)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) csegen-5241)))))))(else (let ((u--args (CoreC-45SchemeEvalC-45Compile-n--10909-5811-u--mkArgNs arg-1 e-20 e-19 e-18 e-17 e-16 e-15 e-14 e-13 arg-2 arg-0 0 e-14))) (lambda (eta-0) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-mkArgs u--args eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--body (vector 8 -1 (cons (vector 2 e-13) (cons (vector 4 (CoreC-45Name-u--show_Show_Name arg-2)) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_Name arg-2) (cons (CoreC-45SchemeEvalC-45ToScheme-u--toScheme_Scheme_FC CoreC-45FC-emptyFC) (PreludeC-45TypesC-45List-mapAppend '() csegen-5242 u--args)))))))) (lambda (eta-1) (vector 1 (CoreC-45SchemeEvalC-45Compile-bindArgs arg-2 e-5 '() u--body)))))) eff-0) eta-0)))))))))))))))))) ((7) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((8) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((9) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((10) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) ((11) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))) (else (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Compile-blockedMetaApp arg-2)))))))
(define LibrariesC-45UtilsC-45Scheme-evalSchemeStr (lambda (arg-0) (let ((u--obj (LibrariesC-45UtilsC-45Scheme-prim__evalScheme arg-0))) (lambda (clam-0) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim__evalOkay u--obj) (blodwen-toSignedInt 1 63)))) (cond ((equal? sc0 1) (box (LibrariesC-45UtilsC-45Scheme-prim__evalResult u--obj))) (else '())))))))
(define LibrariesC-45UtilsC-45Scheme-n--3198-1541-u--showAlt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (string-append "((" (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-2) (string-append ") " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-3) ")"))))))))
(define LibrariesC-45UtilsC-45Scheme-n--3198-1597-u--showAlt (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (string-append "(" (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-2) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-3) ")"))))))))
(define LibrariesC-45UtilsC-45Scheme-n--3198-1542-u--showDef (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) "" (let ((e-2 (unbox arg-4))) (string-append " (else " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-2) ")"))))))
(define LibrariesC-45UtilsC-45Scheme-n--3198-1598-u--showDef (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) "" (let ((e-2 (unbox arg-3))) (string-append " (else " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-2) ")"))))))
(define LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) "" (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (if (null? e-3) e-2 (string-append e-2 (string-append arg-1 (LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep arg-0 arg-1 e-3)))))))))
(define LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) "'()") ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (string-append "(cons " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-2) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-3) ")"))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Integer e-5))) ((3) (let ((e-7 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_Double e-7))) ((4) (let ((e-9 (vector-ref arg-1 1))) (PreludeC-45Show-u--show_Show_String e-9))) ((5) (let ((e-11 (vector-ref arg-1 1))) (let ((sc1 (let ((sc2 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int (cast-char-boundedInt e-11 63) (blodwen-toSignedInt 32 63)))) (cond ((equal? sc2 1) (PreludeC-45EqOrd-u--C-60_Ord_Int (cast-char-boundedInt e-11 63) (blodwen-toSignedInt 127 63))) (else 0))))) (cond ((equal? sc1 1) (string-append "#\\" (string e-11))) (else (string-append "(integer->char " (string-append (PreludeC-45Show-u--show_Show_Int (cast-char-boundedInt e-11 63)) ")"))))))) ((6) (let ((e-13 (vector-ref arg-1 1))) (string-append "'" e-13))) ((8) (let ((e-15 (vector-ref arg-1 1))) (let ((e-16 (vector-ref arg-1 2))) (string-append "(vector " (string-append (PreludeC-45Show-u--show_Show_Integer e-15) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep arg-0 " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 eta-0)) e-16)) ")"))))))) ((7) (let ((e-18 (vector-ref arg-1 1))) (string-append "(box " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-18) ")")))) ((10) (let ((e-19 (vector-ref arg-1 1))) (let ((e-20 (vector-ref arg-1 2))) (string-append "(define (" (string-append e-19 (string-append ") " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-20) ")"))))))) ((11) (let ((e-21 (vector-ref arg-1 1))) e-21)) ((12) (let ((e-22 (vector-ref arg-1 1))) (let ((e-23 (vector-ref arg-1 2))) (string-append "(lambda (" (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep arg-0 " " e-22) (string-append ") " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-23) ")"))))))) ((13) (let ((e-24 (vector-ref arg-1 1))) (let ((e-25 (vector-ref arg-1 2))) (let ((e-26 (vector-ref arg-1 3))) (string-append "(let ((" (string-append e-24 (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-25) (string-append ")) " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-26) ")")))))))))) ((14) (let ((e-27 (vector-ref arg-1 1))) (let ((e-28 (vector-ref arg-1 2))) (let ((e-29 (vector-ref arg-1 3))) (string-append "(if " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-27) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-28) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-29) ")")))))))))) ((15) (let ((e-30 (vector-ref arg-1 1))) (let ((e-31 (vector-ref arg-1 2))) (let ((e-32 (vector-ref arg-1 3))) (string-append "(case " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-30) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep arg-0 " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--3198-1541-u--showAlt arg-0 e-32 e-31 e-30 eta-0)) e-31)) (string-append (LibrariesC-45UtilsC-45Scheme-n--3198-1542-u--showDef arg-0 e-32 e-31 e-30 e-32) ")"))))))))) ((16) (let ((e-33 (vector-ref arg-1 1))) (let ((e-34 (vector-ref arg-1 2))) (string-append "(cond " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep arg-0 " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--3198-1597-u--showAlt arg-0 e-34 e-33 eta-0)) e-33)) (string-append (LibrariesC-45UtilsC-45Scheme-n--3198-1598-u--showDef arg-0 e-34 e-33 e-34) ")")))))) (else (let ((e-35 (vector-ref arg-1 1))) (let ((e-36 (vector-ref arg-1 2))) (string-append "(" (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 e-35) (string-append " " (string-append (LibrariesC-45UtilsC-45Scheme-n--3191-1347-u--showSep arg-0 " " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 eta-0)) e-36)) ")"))))))))))
(define LibrariesC-45UtilsC-45Scheme-evalSchemeObj (lambda (arg-0) (let ((u--str (LibrariesC-45UtilsC-45Scheme-n--3191-1348-u--toString arg-0 arg-0))) (LibrariesC-45UtilsC-45Scheme-evalSchemeStr u--str))))
(define CoreC-45ContextC-45Context-u--C-61C-61_Eq_SchemeMode (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (cond ((equal? arg-1 0) 1)(else 0))) ((equal? arg-0 1) (cond ((equal? arg-1 1) 1)(else 0)))(else 0))))
(define CoreC-45ContextC-45Context-u--C-47C-61_Eq_SchemeMode (lambda (arg-0 arg-1) (let ((sc0 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SchemeMode arg-0 arg-1))) (cond ((equal? sc0 1) 0) (else 1)))))
(define CoreC-45SchemeEvalC-45Compile-compileDef (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (CoreC-45Context-toFullNames arg-0 csegen-54 arg-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Context-lookupCtxtExact e-5 (let ((e-0 (vector-ref e-6 0))) e-0)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-2) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 CoreC-45FC-emptyFC e-5) eta-2)) (let ((e-1 (unbox e-7))) (let ((sc4 (let ((e-22 (vector-ref e-1 22))) (if (null? e-22) 1 (let ((e-27 (unbox e-22))) (let ((e-29 (car e-27))) (CoreC-45ContextC-45Context-u--C-47C-61_Eq_SchemeMode e-29 arg-1))))))) (cond ((equal? sc4 1) (let ((u--redok (let ((sc5 (CoreC-45ContextC-45Context-u--C-61C-61_Eq_SchemeMode arg-1 0))) (cond ((equal? sc5 1) 1) (else (CoreC-45Context-reducibleInAny (cons (let ((e-2 (vector-ref e-6 2))) e-2) (let ((e-3 (vector-ref e-6 3))) e-3)) (let ((e-26 (vector-ref e-1 1))) e-26) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-1 9))) e-9)))))))) (lambda (eta-2) (let ((act-4 (let ((act-4 (CoreC-45Context-toResolvedNames arg-0 csegen-54 e-5 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (CoreC-45Context-toFullNames arg-0 csegen-1966 (let ((e-18 (vector-ref e-1 18))) e-18) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compileBody arg-0 u--redok e-8 e-9))) eff-0) eta-3)))))))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--schdef (vector 10 (CoreC-45SchemeEvalC-45Compile-schName e-5) e-8))) (lambda (eta-3) (let ((act-5 (let ((act-5 ((LibrariesC-45UtilsC-45Scheme-evalSchemeObj u--schdef) eta-3))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-9) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Compiling " (string-append (CoreC-45Name-u--show_Show_Name e-5) " failed"))) clam-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-4) (CoreC-45Context-addDef arg-0 e-5 (let ((e-0 (vector-ref e-1 0))) (let ((e-29 (vector-ref e-1 1))) (let ((e-28 (vector-ref e-1 2))) (let ((e-3 (vector-ref e-1 3))) (let ((e-4 (vector-ref e-1 4))) (let ((e-27 (vector-ref e-1 5))) (let ((e-26 (vector-ref e-1 6))) (let ((e-25 (vector-ref e-1 7))) (let ((e-24 (vector-ref e-1 8))) (let ((e-23 (vector-ref e-1 9))) (let ((e-10 (vector-ref e-1 10))) (let ((e-11 (vector-ref e-1 11))) (let ((e-12 (vector-ref e-1 12))) (let ((e-13 (vector-ref e-1 13))) (let ((e-14 (vector-ref e-1 14))) (let ((e-15 (vector-ref e-1 15))) (let ((e-16 (vector-ref e-1 16))) (let ((e-17 (vector-ref e-1 17))) (let ((e-18 (vector-ref e-1 18))) (let ((e-19 (vector-ref e-1 19))) (let ((e-20 (vector-ref e-1 20))) (let ((e-21 (vector-ref e-1 21))) (vector e-0 e-29 e-28 e-3 e-4 e-27 e-26 e-25 e-24 e-23 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 (box (cons arg-1 u--schdef))))))))))))))))))))))))) eta-4)) clam-0))))) eff-0) eta-3))))))))) eff-0) eta-2))))))))(else (lambda (eta-2) (vector 1 (vector 0 )))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define CoreC-45SchemeEvalC-45Evaluate-getAllNames (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 arg-1)) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((sc1 (LibrariesC-45DataC-45NameMap-lookup e-2 arg-1))) (if (null? sc1) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtExact e-2 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-0 arg-1 e-3) (let ((e-1 (unbox e-6))) (CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-0 (LibrariesC-45DataC-45NameMap-insert e-2 (vector 0 ) arg-1) (PreludeC-45TypesC-45List-tailRecAppend e-3 (LibrariesC-45DataC-45NameMap-keys (CoreC-45ContextC-45Context-refersTo e-1)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-0 arg-1 e-3))))))))
(define SystemC-45Info-codegen "chez")
(define CoreC-45SchemeEvalC-45Compile-initEvalWith (lambda (arg-0 arg-1 ext-0) (cond ((equal? arg-1 "chez") (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc2 (let ((e-30 (vector-ref e-5 30))) e-30))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-2 (CoreC-45Directory-readDataFile arg-0 "chez/ct-support.ss" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr (string-append "(begin " (string-append e-6 ")"))) eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-7) (vector 1 0) (let ((act-4 (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-36 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-36 e-2 e-3 e-4 e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 1 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 1)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (u--err) (lambda (eta-0) (vector 1 0))) clam-1))))))) eff-0) ext-0)))))) ((equal? arg-1 "racket") (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-3) (let ((sc2 (let ((e-30 (vector-ref e-5 30))) e-30))) (cond ((equal? sc2 1) (vector 1 1)) (else (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (let ((act-2 (CoreC-45Directory-readDataFile arg-0 "racket/ct-support.rkt" eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr (string-append "(begin " (string-append e-6 ")"))) eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-7) (vector 1 0) (let ((act-4 (let ((act-4 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-36 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-35 (vector-ref e-5 5))) (let ((e-34 (vector-ref e-5 6))) (let ((e-33 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (vector e-0 e-36 e-2 e-3 e-4 e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 1 e-31 e-32)))))))))))))))))))))))))))))))))))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 1)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))) (lambda (u--err) (lambda (eta-0) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (CoreC-45Core-u--show_Show_Error u--err) "\xa;") eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 0)))))) clam-3))))))) eff-0) ext-0))))))(else (vector 1 0)))))
(define CoreC-45SchemeEvalC-45Compile-initialiseSchemeEval (lambda (arg-0) (lambda (eta-0) (CoreC-45SchemeEvalC-45Compile-initEvalWith arg-0 SystemC-45Info-codegen eta-0))))
(define CoreC-45SchemeEvalC-45Evaluate-n--7683-3092-u--mkEnv (lambda (arg-1 arg-2 arg-3 arg-4 arg-6 arg-7 arg-8) (lambda (clam-0) (if (null? arg-7) (vector 1 (cons arg-8 '())) (let ((e-4 (car arg-7))) (let ((e-5 (cdr arg-7))) (case (vector-ref e-4 0) ((1) (let ((e-9 (vector-ref e-4 3))) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-n--7683-3092-u--mkEnv arg-1 arg-2 arg-3 arg-4 arg-6 e-5 arg-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-11))) (let ((e-3 (cdr e-11))) (let ((act-3 ((CoreC-45SchemeEvalC-45Compile-compile arg-6 arg-4 e-3 e-9) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-12 (vector-ref act-3 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--n (string-append "let-var-" (PreludeC-45Show-u--show_Show_Integer e-6)))) (lambda (eta-1) (vector 1 (cons (lambda (u--x) (vector 13 u--n e-12 (e-2 u--x))) (cons (vector 0 u--n) e-3))))))) eff-0) clam-1)))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))(else (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-6 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-n--7683-3092-u--mkEnv arg-1 arg-2 arg-3 arg-4 arg-6 e-5 arg-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-2 (car e-7))) (let ((e-3 (cdr e-7))) (vector 1 (cons e-2 (cons (vector 1 (string-append "free-" (PreludeC-45Show-u--show_Show_Integer e-6))) e-3)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-seval (lambda (arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((CoreC-45ContextC-45Log-logTimeWhen arg-1 0 0 (lambda () "Scheme eval") (CoreC-45SchemeEvalC-45Compile-initialiseSchemeEval arg-1)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (cond ((equal? e-5 1) (let ((u--ms (CoreC-45TT-getRefs (vector 2 "" 0) arg-4))) (let ((u--rs (CoreC-45TT-addMetas 0 u--ms arg-4))) (lambda (eta-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-getAllNames arg-1 LibrariesC-45DataC-45NameMap-empty (LibrariesC-45DataC-45NameMap-keys u--rs)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (CoreC-45SchemeEvalC-45Compile-compileDef arg-1 arg-2 eta-2 eta-3))) (LibrariesC-45DataC-45NameMap-keys e-6)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Core-newRef (vector "Core.SchemeEval.Compile.Sym" ) 0) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45SchemeEvalC-45Evaluate-n--7683-3092-u--mkEnv arg-4 arg-3 arg-2 arg-1 e-8 arg-3 (lambda (eta-3) eta-3)) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-9))) (let ((e-3 (cdr e-9))) (let ((act-6 (let ((act-6 (CoreC-45Context-toFullNames arg-1 csegen-68 arg-4 clam-0))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Compile-compile e-8 arg-1 e-3 e-10))) eff-0) clam-0))))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (let ((act-7 ((LibrariesC-45UtilsC-45Scheme-evalSchemeObj (e-2 e-10)) eta-3))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-11) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Compiling expression failed") clam-1) (let ((e-1 (unbox e-11))) (vector 1 (cons e-1 e-3))))))) eff-0) eta-3)))))))) eff-0) clam-0)))))))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) eff-0) eta-0))))))))) (else (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Loading scheme support failed") eta-0)))))) eff-0) ext-0)))))))
(define CoreC-45SchemeEvalC-45Quote-quoteGen (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (case (vector-ref arg-6 0) ((0) (let ((e-1 (vector-ref arg-6 1))) (let ((e-2 (vector-ref arg-6 2))) (let ((e-3 (vector-ref arg-6 3))) (let ((e-4 (vector-ref arg-6 4))) (let ((act-1 (CoreC-45SchemeEvalC-45Compile-nextName arg-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--var (vector 1 (vector 0 (string-append "b-" (PreludeC-45Show-u--show_Show_Integer e-5)))))) (lambda (eta-0) (let ((act-2 (CoreC-45SchemeEvalC-45Evaluate-seval arg-0 0 arg-5 (vector 1 e-1 (vector 0 ) u--var) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((e-4 e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 (cons e-2 arg-1) arg-2 arg-3 (vector 1 e-2 u--var arg-4) arg-5 e-7))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-7 (vector-ref act-3 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45SchemeEvalC-45Quote-quoteBinder arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-3 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-8 (vector-ref act-4 1))) (vector 0 e-8))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 3 e-1 e-2 e-8 e-7))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) clam-0)))))))))) ((1) (let ((e-6 (vector-ref arg-6 1))) (let ((e-7 (vector-ref arg-6 2))) (let ((e-8 (vector-ref arg-6 3))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteHead arg-0 arg-1 arg-2 arg-3 e-6 arg-4 arg-5 e-7) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-8) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (CoreC-45TTC-45Term-apply e-6 e-5 e-9))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))) ((2) (let ((e-10 (vector-ref arg-6 1))) (let ((e-11 (vector-ref arg-6 2))) (let ((e-12 (vector-ref arg-6 3))) (let ((e-13 (vector-ref arg-6 4))) (let ((e-14 (vector-ref arg-6 5))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-14) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-apply e-10 (vector 1 e-10 (vector 2 e-12 e-13) e-11) e-5))))) eff-0) clam-0))))))))))) ((3) (let ((e-16 (vector-ref arg-6 1))) (let ((e-17 (vector-ref arg-6 2))) (let ((e-18 (vector-ref arg-6 3))) (let ((e-19 (vector-ref arg-6 4))) (let ((e-20 (vector-ref arg-6 5))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteArgs arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-20) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (CoreC-45TTC-45Term-apply e-16 (vector 1 e-16 (vector 3 e-18 e-19) e-17) e-5))))) eff-0) clam-0))))))))))) ((4) (let ((e-22 (vector-ref arg-6 1))) (let ((e-23 (vector-ref arg-6 2))) (let ((e-24 (vector-ref arg-6 3))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-24) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 6 e-22 e-23 e-5))))) eff-0) clam-0))))))))) ((5) (let ((e-26 (vector-ref arg-6 1))) (let ((e-27 (vector-ref arg-6 2))) (let ((e-28 (vector-ref arg-6 3))) (let ((e-29 (vector-ref arg-6 4))) (let ((act-1 (let ((act-1 (e-29 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5))) eff-0) clam-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (e-28 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-26 e-27 e-6 e-5))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))) ((6) (let ((e-31 (vector-ref arg-6 1))) (let ((e-32 (vector-ref arg-6 2))) (let ((e-33 (vector-ref arg-6 3))) (case (vector-ref e-33 0) ((5) (let ((e-4 (vector-ref e-33 4))) (let ((act-1 (e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-5))) eff-0) clam-0)))))))(else (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-33) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 8 e-31 e-32 e-5))))) eff-0) clam-0))))))))))) ((7) (let ((e-35 (vector-ref arg-6 1))) (let ((e-36 (vector-ref arg-6 2))) (vector 1 (vector 9 e-35 e-36))))) ((8) (let ((e-38 (vector-ref arg-6 1))) (let ((e-39 (vector-ref arg-6 2))) (case (vector-ref e-39 0) ((1) (vector 1 (vector 10 e-38 (vector 1 )))) ((0) (vector 1 (vector 10 e-38 (vector 0 )))) (else (let ((e-46 (vector-ref e-39 1))) (let ((act-1 ((CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-46) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 10 e-38 (vector 2 e-5)))))) eff-0) clam-0))))))))))) (else (let ((e-41 (vector-ref arg-6 1))) (let ((e-42 (vector-ref arg-6 2))) (vector 1 (vector 11 e-41 e-42)))))))))
(define CoreC-45SchemeEvalC-45Quote-quote (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45Core-newRef (vector "Core.SchemeEval.Compile.Sym" ) 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Quote-quoteGen arg-0 '() arg-1 e-5 (vector 0 ) arg-2 arg-3))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Opts-setEvalTiming (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 arg-1 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45REPL-setOpt (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setPPrint arg-0 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (vector e-0 e-1 e-2 e-3))))))) eff-0) eta-0)))))))) ((1) (let ((e-1 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-4 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (vector e-0 e-4 e-2 e-1))))))) eff-0) eta-0)))))))) ((2) (let ((e-2 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-4 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (vector e-0 e-2 e-4 e-3))))))) eff-0) eta-0)))))))) ((3) (let ((e-3 (vector-ref arg-2 1))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-18 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-3 e-1 e-2 e-18 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))))) ((4) (let ((e-4 (vector-ref arg-2 1))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-5 0))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-18 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-4 e-2 e-3 e-18 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))))) ((5) (let ((e-5 (vector-ref arg-2 1))) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-1))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-1 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-18 (vector-ref e-6 5))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (vector e-0 e-1 e-2 e-3 e-4 e-18 e-5 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))))) ((6) (let ((e-6 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((sc2 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) e-6))) (if (null? sc2) (lambda (eta-1) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No such code generator available") eta-1)) (let ((e-1 (unbox sc2))) (CoreC-45Context-setCG arg-0 e-1)))))) eff-0) eta-0)))))))) ((7) (let ((e-7 (vector-ref arg-2 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-25 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-2 e-3 e-4 e-26 e-6 e-25 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-7 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))) eff-0) eta-0)))))))) (else (let ((e-8 (vector-ref arg-2 1))) (IdrisC-45REPLC-45Opts-setEvalTiming arg-1 e-8))))))
(define CoreC-45SchemeEvalC-45Evaluate-invalidS (lambda (ext-0) (vector 1 (vector 8 CoreC-45FC-emptyFC (vector 0 )))))
(define LibrariesC-45UtilsC-45Scheme-isChar (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isChar arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isFloat (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isFloat arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isInteger (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isInteger arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isProcedure (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isProcedure arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isString (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isString arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isSymbol (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isSymbol arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isVector (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isVector arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isBox (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isBox arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-isPair (lambda (arg-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_Int (LibrariesC-45UtilsC-45Scheme-prim_isPair arg-0) (blodwen-toSignedInt 1 63))))
(define LibrariesC-45UtilsC-45Scheme-n--3527-1672-u--readVector (lambda (arg-0 arg-1 arg-2 arg-3) (let ((sc0 (PreludeC-45EqOrd-u--C-61C-61_Eq_Integer arg-1 arg-2))) (cond ((equal? sc0 1) '()) (else (cons (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeVectorRef arg-3 arg-2)) (LibrariesC-45UtilsC-45Scheme-n--3527-1672-u--readVector arg-0 arg-1 (+ arg-2 1) arg-3)))))))
(define LibrariesC-45UtilsC-45Scheme-decodeObj (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isInteger arg-0))) (cond ((equal? sc0 1) (vector 2 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-0))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isVector arg-0))) (cond ((equal? sc1 1) (vector 8 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger (LibrariesC-45UtilsC-45Scheme-unsafeVectorRef arg-0 0)) (LibrariesC-45UtilsC-45Scheme-n--3527-1672-u--readVector arg-0 (LibrariesC-45UtilsC-45Scheme-unsafeVectorLength arg-0) 1 arg-0))) (else (let ((sc2 (LibrariesC-45UtilsC-45Scheme-isPair arg-0))) (cond ((equal? sc2 1) (vector 1 (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeFst arg-0)) (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeSnd arg-0)))) (else (let ((sc3 (LibrariesC-45UtilsC-45Scheme-isFloat arg-0))) (cond ((equal? sc3 1) (vector 3 (LibrariesC-45UtilsC-45Scheme-unsafeGetFloat arg-0))) (else (let ((sc4 (LibrariesC-45UtilsC-45Scheme-isString arg-0))) (cond ((equal? sc4 1) (vector 4 (LibrariesC-45UtilsC-45Scheme-unsafeGetString arg-0))) (else (let ((sc5 (LibrariesC-45UtilsC-45Scheme-isChar arg-0))) (cond ((equal? sc5 1) (vector 5 (LibrariesC-45UtilsC-45Scheme-unsafeGetChar arg-0))) (else (let ((sc6 (LibrariesC-45UtilsC-45Scheme-isSymbol arg-0))) (cond ((equal? sc6 1) (vector 6 (LibrariesC-45UtilsC-45Scheme-unsafeReadSymbol arg-0))) (else (let ((sc7 (LibrariesC-45UtilsC-45Scheme-isProcedure arg-0))) (cond ((equal? sc7 1) (vector 9 arg-0)) (else (let ((sc8 (LibrariesC-45UtilsC-45Scheme-isBox arg-0))) (cond ((equal? sc8 1) (vector 7 (LibrariesC-45UtilsC-45Scheme-decodeObj (LibrariesC-45UtilsC-45Scheme-unsafeUnbox arg-0)))) (else (vector 0 ))))))))))))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfBinder (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-decodeObj arg-4))) (case (vector-ref sc0 0) ((9) (let ((e-0 (vector-ref sc0 1))) (vector 1 (vector 0 CoreC-45FC-emptyFC arg-8 (((((arg-3 'erased) CoreC-45FC-emptyFC) arg-5) arg-6) arg-7) (lambda (u--tm) (let ((e-1 (car u--tm))) (let ((u--sc (LibrariesC-45UtilsC-45Scheme-unsafeApply e-0 e-1))) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 u--sc))))))))(else (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0)))))))
(define CoreC-45SchemeEvalC-45Evaluate-getArgList (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isPair arg-0))) (cond ((equal? sc0 1) (cons (LibrariesC-45UtilsC-45Scheme-unsafeFst arg-0) (CoreC-45SchemeEvalC-45Evaluate-getArgList (LibrariesC-45UtilsC-45Scheme-unsafeSnd arg-0)))) (else '())))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteBinderName (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () (vector 1 (vector 0 "x"))) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj arg-0)))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (lambda (arg-0) (box (vector 2 ))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteFC (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () CoreC-45FC-emptyFC) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_FC (LibrariesC-45UtilsC-45Scheme-decodeObj arg-0)))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_LazyReason (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 0) (box 0)) ((equal? e-1 1) (box 1))(else (box 2)))))(else (box 2)))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteLazyReason (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () 2) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_LazyReason (LibrariesC-45UtilsC-45Scheme-decodeObj arg-0)))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (lambda (arg-2 arg-3 arg-4) (let ((e-2 (cdr arg-2))) (let ((sc1 (e-2 (LibrariesC-45UtilsC-45Scheme-decodeObj arg-3)))) (if (null? sc1) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-3 (unbox sc1))) (arg-4 e-3)))))))
(define CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 0) (box csegen-30)) ((equal? e-1 1) (box csegen-1416))(else (box AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))(else (box AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega)))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteRigCount (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_RigCount (LibrariesC-45UtilsC-45Scheme-decodeObj arg-0)))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteTypeLevel (lambda (arg-0) (DataC-45Maybe-fromMaybe (lambda () (vector 2 "top" 0)) (CoreC-45SchemeEvalC-45ToScheme-u--fromScheme_Scheme_Name (LibrariesC-45UtilsC-45Scheme-decodeObj arg-0)))))
(define CoreC-45SchemeEvalC-45Evaluate-quoteWhyErased (lambda (arg-1 arg-2) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isInteger arg-2))) (cond ((equal? sc0 1) (let ((sc1 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-2))) (cond ((equal? sc1 0) (vector 1 (vector 1 )))(else (vector 1 (vector 0 )))))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isBox arg-2))) (cond ((equal? sc1 1) (let ((act-1 ((arg-1 (LibrariesC-45UtilsC-45Scheme-unsafeUnbox arg-2)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 2 e-5))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 )))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfPLet (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-decodeObj arg-3))) (case (vector-ref sc0 0) ((9) (let ((e-0 (vector-ref sc0 1))) (vector 1 (vector 0 CoreC-45FC-emptyFC arg-7 (vector 4 CoreC-45FC-emptyFC arg-4 arg-5 arg-6) (lambda (u--tm) (let ((e-1 (car u--tm))) (let ((u--sc (LibrariesC-45UtilsC-45Scheme-unsafeApply e-0 e-1))) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 u--sc))))))))(else (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0)))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfPiInfo (lambda (arg-1 arg-2 arg-3) (lambda (clam-0) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isInteger arg-3))) (cond ((equal? sc0 1) (let ((sc1 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-3))) (cond ((equal? sc1 0) (vector 1 (vector 0 ))) ((equal? sc1 1) (vector 1 (vector 1 ))) ((equal? sc1 2) (vector 1 (vector 2 )))(else (vector 1 (vector 1 )))))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isBox arg-3))) (cond ((equal? sc1 1) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 (LibrariesC-45UtilsC-45Scheme-unsafeUnbox arg-3)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 3 e-5))))) eff-0) clam-0)))))) (else (vector 1 (vector 1 )))))))))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits16 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toUnsignedInt e-1 16))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits32 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toUnsignedInt e-1 32))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits64 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toUnsignedInt e-1 64))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits8 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toUnsignedInt e-1 8))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int16 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toSignedInt e-1 15))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int32 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toSignedInt e-1 31))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int64 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toSignedInt e-1 63))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int8 (lambda (arg-0) (case (vector-ref arg-0 0) ((2) (let ((e-1 (vector-ref arg-0 1))) (box (blodwen-toSignedInt e-1 7))))(else '()))))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits16 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits32 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits64 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits8 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int16 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int32 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int64 (lambda (arg-0) (vector 2 arg-0)))
(define LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int8 (lambda (arg-0) (vector 2 arg-0)))
(define CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-7117 (lambda (arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (case (vector-ref arg-9 0) ((9) (let ((e-0 (vector-ref arg-9 1))) (let ((u--tm (lambda (eta-0) (let ((act-1 (let ((act-1 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr "(ct-setBlockAll #t)") eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-7 (LibrariesC-45UtilsC-45Scheme-unsafeForce arg-8)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 ((LibrariesC-45UtilsC-45Scheme-evalSchemeStr "(ct-setBlockAll #f)") eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-7) (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-1) (vector 1 e-6))))) eff-0) eta-1)))))))) eff-0) clam-0))))))))) eff-0) eta-0)))))))) (let ((u--ty (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-7 (LibrariesC-45UtilsC-45Scheme-unsafeForce e-0)))) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC arg-4))) (let ((u--r (CoreC-45SchemeEvalC-45Evaluate-quoteLazyReason arg-3))) (lambda (eta-0) (vector 1 (vector 5 u--fc u--r u--ty u--tm)))))))))(else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfVector (lambda (arg-1 arg-2 arg-3 arg-4) (cond ((equal? arg-3 -2) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-11 (cdr arg-4))) (if (null? e-11) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-13 (car e-11))) (let ((e-14 (cdr e-11))) (if (null? e-14) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-16 (car e-14))) (let ((e-17 (cdr e-14))) (if (null? e-17) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-13 (lambda (u--fname) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) (CoreC-45SchemeEvalC-45Evaluate-getArgList e-16)))) (lambda (eta-0) (vector 1 (vector 1 CoreC-45FC-emptyFC (vector 1 (vector 1 ) u--fname) u--args)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -10) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-21 (cdr arg-4))) (if (null? e-21) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-23 (car e-21))) (let ((e-24 (cdr e-21))) (if (null? e-24) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-26 (car e-24))) (let ((e-27 (cdr e-24))) (if (null? e-27) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5207 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5207 arg-1849))) e-23 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((u--arity (PreludeC-45Types-prim__integerToNat e-3))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) (CoreC-45SchemeEvalC-45Evaluate-getArgList e-26)))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Context-toFullNames arg-1 csegen-54 e-2 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((CoreC-45Context-getPosition e-6 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-8 (car e-7))) (vector 1 (vector 1 CoreC-45FC-emptyFC (vector 2 e-6 e-8 (DataC-45List-take u--arity u--args)) (DataC-45List-drop u--arity u--args))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -11) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-31 (cdr arg-4))) (if (null? e-31) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-33 (car e-31))) (let ((e-34 (cdr e-31))) (if (null? e-34) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-36 (car e-34))) (let ((e-37 (cdr e-34))) (if (null? e-37) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-33) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((1) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((u--argsC-39 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-1)) (CoreC-45SchemeEvalC-45Evaluate-getArgList e-36)))) (lambda (eta-1) (vector 1 (vector 1 e-1 e-2 (PreludeC-45TypesC-45List-tailRecAppend e-3 u--argsC-39)))))))))(else (lambda (eta-1) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-1)))))) eff-0) eta-0)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -1) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-41 (cdr arg-4))) (if (null? e-41) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-43 (car e-41))) (let ((e-44 (cdr e-41))) (if (null? e-44) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-47 (cdr e-44))) (if (null? e-47) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-49 (car e-47))) (let ((e-50 (cdr e-47))) (if (null? e-50) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-52 (car e-50))) (let ((e-53 (cdr e-50))) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-49 (lambda (u--cname) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5206 e-43 (lambda (u--tag) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-52))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-53))) (lambda (eta-0) (vector 1 (vector 3 u--fc u--cname (blodwen-toSignedInt u--tag 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args))))))))))))))))))))))) ((equal? arg-3 -15) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-56 (cdr arg-4))) (if (null? e-56) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-58 (car e-56))) (let ((e-59 (cdr e-56))) (if (null? e-59) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-61 (car e-59))) (let ((e-62 (cdr e-59))) (if (null? e-62) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-61) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--r (CoreC-45SchemeEvalC-45Evaluate-quoteLazyReason e-58))) (lambda (eta-1) (vector 1 (vector 4 CoreC-45FC-emptyFC u--r e-5)))))) eff-0) eta-0)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -4) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-65 (car arg-4))) (let ((e-66 (cdr arg-4))) (if (null? e-66) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-68 (car e-66))) (let ((e-69 (cdr e-66))) (if (null? e-69) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-71 (car e-69))) (let ((e-72 (cdr e-69))) (if (null? e-72) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-74 (car e-72))) (let ((e-75 (cdr e-72))) (if (null? e-75) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-77 (car e-75))) (let ((e-78 (cdr e-75))) (if (null? e-78) (let ((sc7 (LibrariesC-45UtilsC-45Scheme-decodeObj e-77))) (case (vector-ref sc7 0) ((9) (let ((e-0 (vector-ref sc7 1))) (CoreC-45SchemeEvalC-45Evaluate-case--caseC-32blockC-32inC-32snfVector-7117 arg-1 e-65 e-68 e-71 e-74 e-77 arg-2 e-0 (LibrariesC-45UtilsC-45Scheme-decodeObj e-74))))(else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))))))) ((equal? arg-3 -5) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-82 (cdr arg-4))) (if (null? e-82) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-84 (car e-82))) (let ((e-85 (cdr e-82))) (if (null? e-85) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-87 (car e-85))) (let ((e-88 (cdr e-85))) (if (null? e-88) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-90 (car e-88))) (let ((e-91 (cdr e-88))) (if (null? e-91) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-90) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-87))) (let ((u--r (CoreC-45SchemeEvalC-45Evaluate-quoteLazyReason e-84))) (lambda (eta-1) (vector 1 (vector 6 u--fc u--r e-5))))))) eff-0) eta-0)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))) ((equal? arg-3 -6) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-95 (cdr arg-4))) (if (null? e-95) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-97 (car e-95))) (let ((e-98 (cdr e-95))) (if (null? e-98) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-100 (car e-98))) (let ((e-101 (cdr e-98))) (if (null? e-101) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-97))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-quoteWhyErased (lambda (eta-1) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-1)) e-100) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 8 u--fc e-5))))) eff-0) eta-0))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -7) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-105 (cdr arg-4))) (if (null? e-105) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-107 (car e-105))) (let ((e-108 (cdr e-105))) (if (null? e-108) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-110 (car e-108))) (let ((e-111 (cdr e-108))) (if (null? e-111) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-107))) (let ((u--u (CoreC-45SchemeEvalC-45Evaluate-quoteTypeLevel e-110))) (lambda (eta-0) (vector 1 (vector 9 u--fc u--u))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))) ((equal? arg-3 -8) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-115 (cdr arg-4))) (if (null? e-115) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-117 (car e-115))) (let ((e-118 (cdr e-115))) (if (null? e-118) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-120 (car e-118))) (let ((e-121 (cdr e-118))) (if (null? e-121) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-123 (car e-121))) (let ((e-124 (cdr e-121))) (if (null? e-124) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-126 (car e-124))) (let ((e-127 (cdr e-124))) (if (null? e-127) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-129 (car e-127))) (let ((e-130 (cdr e-127))) (if (null? e-130) (let ((u--name (CoreC-45SchemeEvalC-45Evaluate-quoteBinderName e-129))) (let ((u--rig (CoreC-45SchemeEvalC-45Evaluate-quoteRigCount e-120))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-126) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-snfPiInfo arg-1 arg-2 e-123) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7484) csegen-5211) e-117 u--rig e-6 e-5 u--name))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))))))))) ((equal? arg-3 -3) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-134 (cdr arg-4))) (if (null? e-134) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-136 (car e-134))) (let ((e-137 (cdr e-134))) (if (null? e-137) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-139 (car e-137))) (let ((e-140 (cdr e-137))) (if (null? e-140) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-142 (car e-140))) (let ((e-143 (cdr e-140))) (if (null? e-143) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-145 (car e-143))) (let ((e-146 (cdr e-143))) (if (null? e-146) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-148 (car e-146))) (let ((e-149 (cdr e-146))) (if (null? e-149) (let ((u--name (CoreC-45SchemeEvalC-45Evaluate-quoteBinderName e-148))) (let ((u--rig (CoreC-45SchemeEvalC-45Evaluate-quoteRigCount e-139))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-145) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-snfPiInfo arg-1 arg-2 e-142) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7541) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (vector 2 eta-2 eta-3 eta-4 eta-5)))))) e-136 u--rig e-6 e-5 u--name))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))))))))) ((equal? arg-3 -12) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-153 (cdr arg-4))) (if (null? e-153) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-155 (car e-153))) (let ((e-156 (cdr e-153))) (if (null? e-156) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-158 (car e-156))) (let ((e-159 (cdr e-156))) (if (null? e-159) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-161 (car e-159))) (let ((e-162 (cdr e-159))) (if (null? e-162) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-164 (car e-162))) (let ((e-165 (cdr e-162))) (if (null? e-165) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-167 (car e-165))) (let ((e-168 (cdr e-165))) (if (null? e-168) (let ((u--name (CoreC-45SchemeEvalC-45Evaluate-quoteBinderName e-167))) (let ((u--rig (CoreC-45SchemeEvalC-45Evaluate-quoteRigCount e-158))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-164) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-snfPiInfo arg-1 arg-2 e-161) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7598) (lambda (eta-2) (lambda (eta-3) (lambda (eta-4) (lambda (eta-5) (vector 3 eta-2 eta-3 eta-4 eta-5)))))) e-155 u--rig e-6 e-5 u--name))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))))))))) ((equal? arg-3 -13) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-172 (cdr arg-4))) (if (null? e-172) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-174 (car e-172))) (let ((e-175 (cdr e-172))) (if (null? e-175) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-177 (car e-175))) (let ((e-178 (cdr e-175))) (if (null? e-178) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-180 (car e-178))) (let ((e-181 (cdr e-178))) (if (null? e-181) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-183 (car e-181))) (let ((e-184 (cdr e-181))) (if (null? e-184) (let ((u--name (CoreC-45SchemeEvalC-45Evaluate-quoteBinderName e-183))) (let ((u--rig (CoreC-45SchemeEvalC-45Evaluate-quoteRigCount e-177))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-180) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-7647) (lambda (u--fc) (lambda (u--r) (lambda (u--p) (lambda (u--t) (vector 5 u--fc u--r u--t)))))) e-174 u--rig (vector 1 ) e-5 u--name))) eff-0) eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))))))))))) ((equal? arg-3 -14) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-188 (cdr arg-4))) (if (null? e-188) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-190 (car e-188))) (let ((e-191 (cdr e-188))) (if (null? e-191) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-193 (car e-191))) (let ((e-194 (cdr e-191))) (if (null? e-194) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-196 (car e-194))) (let ((e-197 (cdr e-194))) (if (null? e-197) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc9 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc9 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-199 (car e-197))) (let ((e-200 (cdr e-197))) (if (null? e-200) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc10 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc10 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-202 (car e-200))) (let ((e-203 (cdr e-200))) (if (null? e-203) (let ((u--name (CoreC-45SchemeEvalC-45Evaluate-quoteBinderName e-202))) (let ((u--rig (CoreC-45SchemeEvalC-45Evaluate-quoteRigCount e-193))) (lambda (eta-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-199) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-196) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Evaluate-snfPLet arg-1 arg-2 e-190 u--rig e-6 e-5 u--name))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc11 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc11 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))))))))))))) ((equal? arg-3 -9) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-207 (cdr arg-4))) (if (null? e-207) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-209 (car e-207))) (let ((e-210 (cdr e-207))) (if (null? e-210) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-213 (cdr e-210))) (if (null? e-213) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 e-209) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc8 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc8 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))))) ((equal? arg-3 -100) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-217 (cdr arg-4))) (if (null? e-217) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-219 (car e-217))) (let ((e-220 (cdr e-217))) (if (null? e-220) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5199 e-219 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 0 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -101) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-224 (cdr arg-4))) (if (null? e-224) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-226 (car e-224))) (let ((e-227 (cdr e-224))) (if (null? e-227) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int8 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int8 arg-1849))) e-226 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 1 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -102) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-231 (cdr arg-4))) (if (null? e-231) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-233 (car e-231))) (let ((e-234 (cdr e-231))) (if (null? e-234) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int16 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int16 arg-1849))) e-233 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 2 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -103) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-238 (cdr arg-4))) (if (null? e-238) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-240 (car e-238))) (let ((e-241 (cdr e-238))) (if (null? e-241) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int32 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int32 arg-1849))) e-240 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 3 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -104) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-245 (cdr arg-4))) (if (null? e-245) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-247 (car e-245))) (let ((e-248 (cdr e-245))) (if (null? e-248) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Int64 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Int64 arg-1849))) e-247 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 4 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -105) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-252 (cdr arg-4))) (if (null? e-252) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-254 (car e-252))) (let ((e-255 (cdr e-252))) (if (null? e-255) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5206 e-254 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 5 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -106) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-259 (cdr arg-4))) (if (null? e-259) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-261 (car e-259))) (let ((e-262 (cdr e-259))) (if (null? e-262) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits8 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits8 arg-1849))) e-261 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 6 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -107) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-266 (cdr arg-4))) (if (null? e-266) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-268 (car e-266))) (let ((e-269 (cdr e-266))) (if (null? e-269) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits16 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits16 arg-1849))) e-268 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 7 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -108) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-273 (cdr arg-4))) (if (null? e-273) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-275 (car e-273))) (let ((e-276 (cdr e-273))) (if (null? e-276) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits32 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits32 arg-1849))) e-275 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 8 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))))) ((equal? arg-3 -109) (if (null? arg-4) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc5 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc5 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-280 (cdr arg-4))) (if (null? e-280) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc6 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc6 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))) (let ((e-282 (car e-280))) (let ((e-283 (cdr e-280))) (if (null? e-283) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS (cons (lambda (arg-1843) (LibrariesC-45UtilsC-45Scheme-u--toScheme_Scheme_Bits64 arg-1843)) (lambda (arg-1849) (LibrariesC-45UtilsC-45Scheme-u--fromScheme_Scheme_Bits64 arg-1849))) e-282 (lambda (u--xC-39) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 9 u--xC-39)))))) (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc7 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc7 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0))))))))))))))))))))(else (if (null? arg-4) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-2 (cdr arg-4))) (if (null? e-2) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (let ((sc3 (PreludeC-45EqOrd-u--C-62C-61_Ord_Integer arg-3 0))) (cond ((equal? sc3 1) (CoreC-45SchemeEvalC-45Evaluate-quoteOrInvalidS csegen-5205 e-4 (lambda (u--cname) (let ((u--fc (CoreC-45SchemeEvalC-45Evaluate-quoteFC e-7))) (let ((u--args (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 arg-2 eta-0)) e-8))) (lambda (eta-0) (vector 1 (vector 2 u--fc u--cname (blodwen-toSignedInt arg-3 63) (PreludeC-45TypesC-45List-lengthTR u--args) u--args)))))))) (else (lambda (eta-0) (CoreC-45SchemeEvalC-45Evaluate-invalidS eta-0)))))))))))))))))
(define CoreC-45SchemeEvalC-45Compile-getName (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) e-0)) (else (let ((e-1 (vector-ref arg-0 1))) e-1)))))
(define CoreC-45SchemeEvalC-45Evaluate-n--11549-8402-u--findName (lambda (arg-1 arg-2 arg-3 arg-5 arg-6) (if (null? arg-5) (vector 1 CoreC-45FC-emptyFC (vector 1 (vector 1 ) (vector 1 (vector 0 arg-6))) '()) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_String (CoreC-45SchemeEvalC-45Compile-getName e-2) arg-6))) (cond ((equal? sc1 1) (vector 1 CoreC-45FC-emptyFC (vector 0 0) '())) (else (let ((sc2 (CoreC-45SchemeEvalC-45Evaluate-n--11549-8402-u--findName arg-1 arg-2 arg-3 e-3 arg-6))) (case (vector-ref sc2 0) ((1) (let ((e-1 (vector-ref sc2 1))) (let ((e-5 (vector-ref sc2 2))) (case (vector-ref e-5 0) ((0) (let ((e-6 (vector-ref e-5 1))) (vector 1 e-1 (vector 0 (+ e-6 1)) '())))(else (vector 1 CoreC-45FC-emptyFC (vector 1 (vector 1 ) (vector 1 (vector 0 arg-6))) '()))))))(else (vector 1 CoreC-45FC-emptyFC (vector 1 (vector 1 ) (vector 1 (vector 0 arg-6))) '()))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-snfC-39 (lambda (arg-1 arg-2 arg-3) (let ((sc0 (LibrariesC-45UtilsC-45Scheme-isVector arg-3))) (cond ((equal? sc0 1) (CoreC-45SchemeEvalC-45Evaluate-snfVector arg-1 arg-2 (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger (LibrariesC-45UtilsC-45Scheme-unsafeVectorRef arg-3 0)) (LibrariesC-45UtilsC-45Scheme-unsafeVectorToList arg-3))) (else (let ((sc1 (LibrariesC-45UtilsC-45Scheme-isProcedure arg-3))) (cond ((equal? sc1 1) (CoreC-45SchemeEvalC-45Evaluate-snfBinder arg-1 arg-2 (lambda (ty-8656) csegen-5211) arg-3 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega (vector 1 ) (vector 8 CoreC-45FC-emptyFC (vector 0 )) (vector 1 (vector 0 "x")))) (else (let ((sc2 (LibrariesC-45UtilsC-45Scheme-isSymbol arg-3))) (cond ((equal? sc2 1) (lambda (eta-0) (vector 1 (CoreC-45SchemeEvalC-45Evaluate-n--11549-8402-u--findName arg-1 arg-3 arg-2 arg-2 (LibrariesC-45UtilsC-45Scheme-unsafeReadSymbol arg-3))))) (else (let ((sc3 (LibrariesC-45UtilsC-45Scheme-isFloat arg-3))) (cond ((equal? sc3 1) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 12 (LibrariesC-45UtilsC-45Scheme-unsafeGetFloat arg-3)))))) (else (let ((sc4 (LibrariesC-45UtilsC-45Scheme-isInteger arg-3))) (cond ((equal? sc4 1) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 0 (blodwen-toSignedInt (LibrariesC-45UtilsC-45Scheme-unsafeGetInteger arg-3) 63)))))) (else (let ((sc5 (LibrariesC-45UtilsC-45Scheme-isString arg-3))) (cond ((equal? sc5 1) (lambda (eta-0) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 10 (LibrariesC-45UtilsC-45Scheme-unsafeGetString arg-3)))))) (else (lambda (clam-0) (let ((sc6 (LibrariesC-45UtilsC-45Scheme-isChar arg-3))) (cond ((equal? sc6 1) (vector 1 (vector 7 CoreC-45FC-emptyFC (vector 11 (LibrariesC-45UtilsC-45Scheme-unsafeGetChar arg-3))))) (else (CoreC-45SchemeEvalC-45Evaluate-invalidS clam-0)))))))))))))))))))))))))
(define CoreC-45SchemeEvalC-45Evaluate-toSNF (lambda (arg-1 arg-2) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (CoreC-45SchemeEvalC-45Evaluate-snfC-39 arg-1 e-2 e-1)))))
(define CoreC-45SchemeEval-snfAll (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((CoreC-45SchemeEvalC-45Compile-initialiseSchemeEval arg-0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 1) (let ((act-2 (CoreC-45SchemeEvalC-45Evaluate-seval arg-0 0 arg-2 arg-3 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45SchemeEvalC-45Evaluate-toSNF arg-0 e-6))) eff-0) clam-0))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Scheme evaluator not available") clam-0)))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-case--process-16470 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 (vector 14 ))) (let ((e-2 (unbox arg-6))) (let ((u--line (PreludeC-45Types-maybe (lambda () '()) (lambda () (lambda (u--i) (cons (string-append "+" (PreludeC-45Show-u--show_Show_Int (bs+ u--i 1 63))) '()))) (let ((e-7 (vector-ref arg-5 7))) e-7)))) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Escaped-system csegen-82 (PreludeC-45TypesC-45List-tailRecAppend (cons (let ((e-6 (vector-ref arg-5 6))) e-6) (cons e-2 '())) u--line)) world-0))) (vector 1 act-1))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (IdrisC-45REPL-loadMainFile arg-4 arg-3 arg-2 arg-1 arg-0 e-2 eta-0))))))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-emptyTree (cons '() '()))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath (lambda (arg-0 arg-1) (LibrariesC-45UtilsC-45Path-u--show_Show_Path (LibrariesC-45UtilsC-45Path-C-47C-62 arg-0 arg-1))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-directoryExists (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((SystemC-45Directory-openDir csegen-82 (LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath arg-0 arg-1)) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 ((SystemC-45Directory-closeDir csegen-82 e-2) ext-0))) 1))) (else 0)))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-go (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 ((SystemC-45Directory-nextDirEntry csegen-82 arg-1) ext-0))) (case (vector-ref act-1 0) ((0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) arg-2) (SystemC-45Directory-closeDir csegen-82 arg-1) ext-0)) (else (let ((e-5 (vector-ref act-1 1))) (if (null? e-5) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) arg-2) (SystemC-45Directory-closeDir csegen-82 arg-1) ext-0) (let ((e-8 (unbox e-5))) (let ((sc2 (PreludeC-45Types-elem csegen-14 csegen-22 e-8 (cons "." (cons ".." '()))))) (cond ((equal? sc2 0) (let ((act-2 (LibrariesC-45SystemC-45DirectoryC-45Tree-directoryExists arg-0 e-8 ext-0))) (let ((u--acc (cond ((equal? act-2 1) (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cons e-1 (cons (cons e-8 (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-explore (LibrariesC-45UtilsC-45Path-C-47C-62 arg-0 e-8) eta-0))) e-2))))) (else (let ((e-1 (car arg-2))) (let ((e-2 (cdr arg-2))) (cons (cons e-8 e-1) e-2))))))) (LibrariesC-45SystemC-45DirectoryC-45Tree-go arg-0 arg-1 u--acc ext-0))))(else (LibrariesC-45SystemC-45DirectoryC-45Tree-go arg-0 arg-1 arg-2 ext-0))))))))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-explore (lambda (arg-0 ext-0) (let ((act-1 ((SystemC-45Directory-openDir csegen-82 (LibrariesC-45UtilsC-45Path-u--show_Show_Path arg-0)) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (LibrariesC-45SystemC-45DirectoryC-45Tree-go arg-0 e-2 LibrariesC-45SystemC-45DirectoryC-45Tree-emptyTree ext-0))) (else LibrariesC-45SystemC-45DirectoryC-45Tree-emptyTree)))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-depthFirst (lambda (arg-1 arg-2 arg-3 arg-4) (let ((u--next (PreludeC-45Types-u--foldr_Foldable_List (lambda (lamc-0) (lambda (clam-0) (lambda (clam-1) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-1 (e-3 clam-1))) ((LibrariesC-45SystemC-45DirectoryC-45Tree-depthFirst (lambda (root-6391) (arg-1 root-6391)) (LibrariesC-45UtilsC-45Path-C-47C-62 arg-2 e-2) act-1 clam-0) clam-1))))))) arg-4 (let ((e-2 (cdr arg-3))) e-2)))) (PreludeC-45Types-u--foldr_Foldable_List (lambda (u--fn) (lambda (u--def) (((arg-1 arg-2) u--fn) (lambda () u--def)))) u--next (let ((e-1 (car arg-3))) e-1)))))
(define IdrisC-45REPL-n--32451-17304-u--toPaths (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (LibrariesC-45SystemC-45DirectoryC-45Tree-depthFirst (lambda (root-17325) (lambda (u--x) (lambda (eta-0) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (arg-8) (cons (LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath root-17325 u--x) arg-8)) (eta-0) eta-4))))) arg-6 arg-7 (lambda (eta-0) '()))))
(define IdrisC-45REPL-case--process-17374 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (if (null? arg-8) (lambda (eta-0) (vector 1 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Package not found in the known search directories")))) (let ((e-1 (unbox arg-8))) (let ((u--packageDirPath (LibrariesC-45UtilsC-45Path-parse e-1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (LibrariesC-45SystemC-45DirectoryC-45Tree-explore u--packageDirPath eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((IdrisC-45REPL-n--32451-17304-u--toPaths arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 (LibrariesC-45UtilsC-45Path-parse "") e-5) eta-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 ((PreludeC-45Basics-flip csegen-1298 e-6 (lambda (u--entry) (let ((u--entryC-39 (LibrariesC-45UtilsC-45Path-dropExtensions u--entry))) (let ((u--sp (DataC-45List1-forget (DataC-45String-split (lambda (arg-9) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-9 LibrariesC-45UtilsC-45Path-dirSeparator)) u--entryC-39)))) (let ((u--ns (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-3) eta-3) (DataC-45List-intersperse "." u--sp)))) (let ((u--nsC-39 (CoreC-45NameC-45Namespace-mkNamespace u--ns))) (lambda (eta-3) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-3 (IdrisC-45ProcessIdr-addImport arg-5 arg-4 arg-3 (vector CoreC-45FC-emptyFC 0 u--nsC-39 u--nsC-39) eta-4))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 '()))))) (lambda (u--err) (lambda (eta-4) (vector 1 (box u--err)))) eta-3)))))))) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--errsC-39 (DataC-45List-catMaybes e-7))) (lambda (eta-3) (let ((act-4 (if (null? u--errsC-39) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "Done")) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-4) (lambda (eta-5) (IdrisC-45Error-display arg-5 arg-3 arg-1 eta-4 eta-5))) u--errsC-39 '()) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-8))))) eff-0) eta-3)))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-4) (vector 1 (vector 6 e-8))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))
(define IdrisC-45REPL-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPL-execDecls arg-0 arg-1 arg-2 arg-3 arg-4 e-0 eta-0)))) ((1) (let ((e-1 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--emode (let ((e-18 (vector-ref e-5 1))) e-18))) (lambda (clam-0) (cond ((equal? u--emode 2) (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 e-1 eta-1)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 (vector 2 e-1)))))) ((equal? u--emode 3) (let ((act-2 (IdrisC-45REPL-inferAndElab '() arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 ) e-1 '() clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-3 (car e-6))) (let ((act-3 (let ((act-3 (IdrisC-45REPLC-45Opts-getEvalTiming arg-4 clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45ContextC-45Log-logTimeWhen arg-0 e-7 0 (lambda () "Evaluation") (lambda (eta-1) (let ((act-4 (CoreC-45SchemeEval-snfAll arg-0 '() '() e-3 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (CoreC-45SchemeEvalC-45Quote-quote arg-0 '() '() e-8 eta-2)))) eff-0) eta-1))))))))) eff-0) clam-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45ContextC-45Log-logTimeWhen arg-0 0 0 (lambda () "Resugar") (lambda (eta-2) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-7 eta-2))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 5 e-8 '()))))) eff-0) eta-1)))))))) eff-0) clam-1))))))))) eff-0) clam-0))))))(else (let ((act-2 (let ((act-2 (IdrisC-45REPLC-45Opts-getEvalTiming arg-4 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45ContextC-45Log-logTimeWhen arg-0 e-6 0 (lambda () "Evaluation") (lambda (eta-1) (IdrisC-45REPL-inferAndNormalize arg-0 arg-1 arg-2 arg-3 arg-4 u--emode e-1 eta-1))))) eff-0) clam-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-3 (car e-6))) (let ((e-2 (cdr e-6))) (let ((act-3 (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-3 clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 (unbox arg-4))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((u--norm (lambda (eta-3) (lambda (eta-4) (IdrisC-45REPL-replEval arg-0 '() u--emode eta-3 eta-4))))) (lambda (eta-3) (let ((act-6 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-4 (vector-ref eta-4 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref eta-4 1))) (vector 1 (vector 4 "it" e-10)))))) (lambda (eta-4) (CoreC-45UnifyState-genName arg-0 arg-1 "evalResult" eta-4)) eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-7 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-5) (CoreC-45Context-addDef arg-0 e-10 (CoreC-45Context-newDef CoreC-45FC-replFC e-10 AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega '() e-2 LibrariesC-45DataC-45WithDefault-defaulted (vector 1 CoreC-45ContextC-45Context-defaultPI '() (vector 1 0 e-3) (vector 1 0 e-3) '())) eta-5)) eta-4))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 (CoreC-45Context-addToSave arg-0 e-10 eta-4))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((act-9 (let ((act-9 (set-box! arg-4 (let ((e-0 (vector-ref e-9 0))) (let ((e-27 (vector-ref e-9 1))) (let ((e-26 (vector-ref e-9 2))) (let ((e-25 (vector-ref e-9 3))) (let ((e-4 (vector-ref e-9 4))) (let ((e-24 (vector-ref e-9 5))) (let ((e-23 (vector-ref e-9 6))) (let ((e-22 (vector-ref e-9 7))) (let ((e-21 (vector-ref e-9 8))) (let ((e-20 (vector-ref e-9 9))) (let ((e-19 (vector-ref e-9 10))) (let ((e-18 (vector-ref e-9 11))) (let ((e-13 (vector-ref e-9 13))) (let ((e-14 (vector-ref e-9 14))) (let ((e-15 (vector-ref e-9 15))) (let ((e-16 (vector-ref e-9 16))) (vector e-0 e-27 e-26 e-25 e-4 e-24 e-23 e-22 e-21 e-20 e-19 e-18 (box e-10) e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((sc11 (let ((e-0 (vector-ref e-9 0))) e-0))) (cond ((equal? sc11 1) (let ((act-10 (let ((act-10 ((((u--norm e-8) '()) e-2) eta-4))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-14 eta-5)))) eff-0) eta-4))))))) (case (vector-ref act-10 0) ((0) (let ((e-4 (vector-ref act-10 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 5 e-7 (box e-14)))))) eff-0) eta-4)))))) (else (vector 1 (vector 5 e-7 '()))))))))))))))))) eff-0) eta-3))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-2)))))))))) eff-0) clam-0))))))))))) eff-0) eta-0)))))))) ((2) (let ((e-2 (vector-ref arg-5 1))) (case (vector-ref e-2 0) ((0) (let ((e-28 (vector-ref e-2 1))) (let ((e-29 (vector-ref e-2 2))) (case (vector-ref e-29 0) ((1) (let ((e-30 (vector-ref e-29 1))) (lambda (clam-0) (case (vector-ref e-30 0) ((0) (let ((e-31 (vector-ref e-30 1))) (cond ((equal? e-31 "it") (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-12 (vector-ref e-5 12))) (if (null? e-12) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 7 e-28 (vector 1 (vector 0 "it"))) eta-0)) (let ((e-19 (unbox e-12))) (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 (vector 0 e-28 e-19)))))))) eff-0) clam-0))))))(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-29 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-4) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-28 e-29 clam-4) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45Display-displayType arg-0 arg-2 0 e-5 eta-1)) e-6 '()) clam-4))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-3892 e-7))))))) eff-0) clam-4))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))(else (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-29 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-5) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-28 e-29 clam-5) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45Display-displayType arg-0 arg-2 0 e-5 eta-1)) e-6 '()) clam-5))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-3892 e-7))))))) eff-0) clam-5))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))(else (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-29 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-6) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-28 e-29 clam-6) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-2) (IdrisC-45DocC-45Display-displayType arg-0 arg-2 0 e-5 eta-2)) e-6 '()) clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-3892 e-7))))))) eff-0) clam-6))))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))))))(else (lambda (eta-0) (let ((act-1 (IdrisC-45REPL-inferAndElab '() arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 ) e-2 '() eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-7) (let ((e-1 (car e-5))) (let ((e-3 (cdr e-5))) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (CoreC-45Normalise-normaliseHoles arg-0 '() e-6 '() e-1 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-7 eta-2)))) eff-0) eta-1))))))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (CoreC-45Normalise-normalise arg-0 '() e-6 '() e-3 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (IdrisC-45Resugar-resugar '() arg-0 arg-2 '() e-8 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 8 e-7 e-8))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-7)))))))))) eff-0) eta-0)))))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (let ((e-0 (vector-ref e-5 0))) e-0)))))) (lambda (eta-1) (CoreC-45Context-getPPrint arg-0 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45REPL-setOpt arg-0 arg-4 (vector 0 1)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 e-3)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((IdrisC-45REPL-setOpt arg-0 arg-4 (vector 0 e-5)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 e-7))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) ((4) (let ((e-4 (vector-ref arg-5 1))) (lambda (clam-8) (case (vector-ref e-4 0) ((0) (let ((e-33 (vector-ref e-4 1))) (let ((e-34 (vector-ref e-4 2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-34 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-9) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 e-33 e-34 clam-9) (let ((act-3 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45Display-displayPats arg-0 arg-2 0 e-5 eta-1)) e-6 '()) clam-9))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep (PreludeC-45TypesC-45List-mapAppend '() csegen-3892 e-7))))))) eff-0) clam-9))))))))) eff-0) eta-0)))))))) eff-0) clam-8))))))))(else (let ((act-1 ((IdrisC-45DocC-45String-getDocsForImplementation arg-2 arg-0 e-4) clam-8))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-10) (if (null? e-5) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Error: could not find definition of " (cons (IdrisC-45Syntax-u--show_Show_PTerm e-4) '())))))) (let ((e-1 (unbox e-5))) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-0) (vector 6 eta-0)) e-1)))))))) eff-0) clam-8)))))))))) ((5) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-3 (vector-ref e-5 3))) (lambda (clam-1) (if (null? e-3) (vector 1 (vector 14 )) (let ((e-18 (unbox e-3))) (IdrisC-45REPL-loadMainFile arg-0 arg-1 arg-2 arg-3 arg-4 e-18 clam-1))))))) eff-0) eta-0))))))) ((6) (let ((e-5 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-4))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-4 (let ((e-0 (vector-ref e-6 0))) (let ((e-1 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-4 (vector-ref e-6 4))) (let ((e-18 (vector-ref e-6 5))) (let ((e-17 (vector-ref e-6 6))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (vector e-0 e-1 e-2 (box e-5) e-4 e-18 e-17 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0))))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (IdrisC-45REPL-loadMainFile arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))))))) ((7) (let ((e-6 (vector-ref arg-5 1))) (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (let ((act-1 (IdrisC-45ProcessIdr-addImport arg-0 arg-1 arg-2 (vector CoreC-45FC-emptyFC 0 e-6 e-6) eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 10 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-6))))))) (lambda (u--err) (lambda (eta-1) (vector 1 (vector 11 (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-6) u--err)))) eta-0)))) ((18) (let ((e-7 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-setWorkingDir arg-0 e-7 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (CoreC-45Context-getWorkingDir eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 15 e-6))))) eff-0) eta-0))))))))))) ((19) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getWorkingDir eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 15 e-5))))) eff-0) eta-0))))))) ((8) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-4))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45REPL-case--process-16470 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 (let ((e-3 (vector-ref e-5 3))) e-3)))) eff-0) eta-0))))))) ((9) (let ((e-8 (vector-ref arg-5 1))) (let ((e-9 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 e-8 e-9 eta-0))))) ((10) (let ((e-10 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 e-10 eta-0)))) ((11) (let ((e-11 (vector-ref arg-5 1))) (lambda (clam-11) (if (null? e-11) (vector 1 (vector 3 )) (let ((e-35 (unbox e-11))) (vector 1 (vector 4 e-35))))))) ((12) (let ((e-12 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-branch arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--curr (let ((e-2 (vector-ref e-5 2))) e-2))) (let ((u--ctxt (let ((e-0 (vector-ref e-5 0))) e-0))) (lambda (eta-1) (let ((act-2 (IdrisC-45Desugar-desugar arg-2 arg-0 arg-3 arg-1 arg-4 1 '() e-12 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-3 (TTImpC-45BindImplicits-piBindNames arg-0 CoreC-45FC-replFC '() e-6 eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-4 ((TTImpC-45Elab-elabTerm '() arg-0 arg-3 arg-1 arg-2 arg-4 0 (vector 0 ) '() '() '() e-7 '()) eta-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-12) (let ((e-2 (car e-8))) (let ((act-5 (CoreC-45Context-toResolvedNames arg-0 csegen-68 e-2 clam-12))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (let ((act-6 ((CoreC-45Context-allNames u--ctxt) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((CoreC-45Core-traverseC-39 (lambda (eta-6) (PreludeC-45Basics-flip csegen-3911 u--ctxt eta-6)) e-10 '()) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--defs (PreludeC-45Basics-flip csegen-1631 e-11 (lambda (u--md) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe u--md (lambda (u--d) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (CoreC-45Context-visibleIn u--curr (let ((e-1 (vector-ref u--d 1))) e-1) (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-26 (vector-ref u--d 9))) e-26)))) (lambda (_-10649) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (DataC-45Maybe-isJust (CoreC-45Name-userNameRoot (let ((e-1 (vector-ref u--d 1))) e-1)))) (lambda (_-10650) (box u--d))))))))))) (lambda (eta-6) (let ((act-8 ((CoreC-45Core-traverseC-39 (lambda (eta-7) (lambda (eta-8) (CoreC-45Context-u--resolved_HasNames_GlobalDef u--ctxt eta-7 eta-8))) u--defs '()) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-8 1))) ((let ((eff-0 (CoreC-45Core-filterM (lambda (u--def) (lambda (eta-7) (IdrisC-45REPLC-45Common-equivTypes arg-0 (let ((e-33 (vector-ref u--def 2))) e-33) e-9 eta-7))) e-13))) eff-0) eta-6))))))))) eff-0) eta-5)))))))) eff-0) eta-4))))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (let ((act-7 (set-box! arg-0 e-5))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-4 (vector-ref act-7 1))) (vector 0 e-4))) (else (let ((act-8 ((CoreC-45Core-traverseC-39 (lambda (eta-6) (lambda (eta-7) (IdrisC-45REPLC-45Common-docsOrSignature arg-4 arg-0 arg-2 CoreC-45FC-replFC eta-6 eta-7))) (PreludeC-45TypesC-45List-mapAppend '() csegen-3912 e-10) '()) eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (vector 1 (vector 7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vsep e-13)))))) eff-0) eta-5))))))))))) eff-0) eta-4)))))))) eff-0) clam-12))))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))) eff-0) eta-0)))))))) ((20) (let ((e-13 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-13 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-13) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 CoreC-45FC-replFC e-13 clam-13) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (vector 19 e-7)))))) (CoreC-45Core-traverseC-39 (lambda (u--fn) (lambda (eta-2) (let ((act-3 (CoreC-45Context-getTotality arg-0 CoreC-45FC-replFC u--fn eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-1 (cdr e-7))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (IdrisC-45REPL-displayPatTerm arg-0 arg-2 e-5 eta-3 eta-4))) e-2 '()) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 0 u--fn e-8))))) eff-0) clam-2))))))) ((2) (let ((e-2 (vector-ref e-1 1))) (let ((act-4 ((CoreC-45Core-traverseC-39 (lambda (eta-3) (lambda (eta-4) (CoreC-45Context-getFullName arg-0 eta-3 eta-4))) e-2 '()) clam-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (vector 1 u--fn e-8))))) eff-0) clam-2)))))))(else (vector 1 (vector 2 u--fn)))))))) eff-0) eta-2))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) '()) clam-13))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((21) (let ((e-14 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-14 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-15) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 CoreC-45FC-replFC e-14 clam-15) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref eta-2 1))) (vector 1 (vector 20 e-7)))))) (CoreC-45Core-traverseC-39 (lambda (u--fn) (lambda (eta-2) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (CoreC-45Termination-checkTotal arg-0 CoreC-45FC-replFC u--fn eta-3)) eta-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 (CoreC-45Context-getTotality arg-0 CoreC-45FC-replFC u--fn eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Context-toFullNames arg-0 (cons (lambda (arg-7719) (lambda (arg-7722) (lambda (eta-4) (CoreC-45Context-u--full_HasNames_Totality arg-7719 arg-7722 eta-4)))) (lambda (arg-7729) (lambda (arg-7732) (lambda (eta-4) (CoreC-45Context-u--resolved_HasNames_Totality arg-7729 arg-7732 eta-4))))) e-8 eta-3)))) eff-0) eta-2))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (cons u--fn e-8))))) eff-0) eta-2)))))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) '()) clam-15))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((22) (let ((e-15 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45DocC-45String-getDocs arg-4 arg-0 arg-2 e-15) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-5))))) eff-0) eta-0)))))))) ((23) (let ((e-16 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45DocC-45String-getContents arg-4 arg-0 arg-2 e-16 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 7 e-5))))) eff-0) eta-0)))))))) ((14) (let ((e-17 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (let ((act-2 ((CoreC-45Context-lookupCtxtName e-17 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-traverseC-39 (lambda (eta-2) (IdrisC-45REPL-prettyInfo arg-0 arg-2 eta-2)) e-6 '()))) eff-0) eta-1))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hardline e-6))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) ((15) (let ((e-18 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPL-setOpt arg-0 arg-4 e-18) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))) ((16) (lambda (eta-0) (let ((act-1 (IdrisC-45REPL-getOptions arg-0 arg-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 21 e-5))))) eff-0) eta-0))))))) ((24) (let ((e-19 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Context-addLogLevel arg-0 e-19) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 22 e-19)))))))) ((25) (let ((e-20 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setConsoleWidth arg-4 e-20) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 23 e-20)))))))) ((26) (let ((e-21 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setColor arg-4 e-21) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 24 e-21)))))))) ((27) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45Holes-getUserHolesData arg-0 arg-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-2) (vector 6 eta-2)) (IdrisC-45IDEModeC-45Holes-prettyHoles e-5))))))) eff-0) eta-0))))))) ((28) (let ((e-22 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Context-getPPrint arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((CoreC-45Context-setPPrint arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-3 (vector-ref e-5 3))) (vector e-0 e-1 0 e-3))))) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 ((IdrisC-45REPL-processEdit arg-0 arg-1 arg-2 arg-3 arg-4 e-22) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Context-setPPrint arg-0 e-5) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 (vector 28 e-7)))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) ((17) (let ((e-23 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Context-getSession arg-0 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Context-setSession arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-26 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-25 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (vector e-0 e-1 e-2 e-3 e-4 (cons e-23 e-26) e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-25 e-24))))))))))))))))))))))))))))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))) ((29) (let ((e-24 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 ((System-system csegen-82 e-24) world-0))) (vector 1 act-1))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))))) ((31) (lambda (eta-0) (vector 1 (vector 27 )))) ((32) (lambda (eta-0) (vector 1 (vector 0 )))) ((30) (lambda (eta-0) (vector 1 (vector 25 IdrisC-45Version-version)))) ((33) (let ((e-25 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 (CoreC-45Directory-extraSearchDirectories arg-0 eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (IdrisC-45REPL-case--process-17374 e-25 arg-4 arg-3 arg-2 arg-1 arg-0 e-5 e-6 (DataC-45List-find (lambda (u--d) (DataC-45String-isInfixOf e-25 (DataC-45Maybe-fromMaybe (lambda () u--d) (LibrariesC-45UtilsC-45Path-fileName u--d)))) e-6)))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) (else (let ((e-26 (vector-ref arg-5 1))) (IdrisC-45REPLC-45FuzzySearch-fuzzySearch arg-0 arg-1 arg-2 arg-3 arg-4 e-26))))))
(define IdrisC-45REPL-processCatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45Context-branch arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (unbox arg-4))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-5 ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45Context-commit arg-0 eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 e-9))))))) eff-0) eta-4)))))) (lambda (u--err) (lambda (eta-4) (let ((act-5 (let ((act-5 (set-box! arg-0 e-5))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (set-box! arg-1 e-6))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 (set-box! arg-2 e-7))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (let ((act-8 (set-box! arg-4 e-8))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (IdrisC-45Error-display arg-0 arg-2 arg-4 u--err eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 1 e-13))))) eff-0) eta-4))))))))))))))))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-interpret (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setCurrentElabSource arg-4 arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((sc1 (IdrisC-45REPL-parseRepl arg-5))) (case (vector-ref sc1 0) ((0) (let ((e-2 (vector-ref sc1 1))) (let ((act-2 (IdrisC-45Error-perror arg-0 arg-2 arg-4 e-2 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-6))))) eff-0) ext-0))))))) (else (let ((e-6 (vector-ref sc1 1))) (if (null? e-6) (vector 1 (vector 0 )) (let ((e-8 (unbox e-6))) (IdrisC-45REPL-processCatch arg-0 arg-1 arg-2 arg-3 arg-4 e-8 ext-0))))))))))))
(define IdrisC-45REPL-replCmd (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (cond ((equal? arg-5 "") (vector 1 (vector 0 )))(else (let ((act-1 (IdrisC-45REPL-interpret arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45REPL-displayResult arg-0 arg-1 arg-2 arg-3 arg-4 e-5))) eff-0) ext-0)))))))))
(define IdrisC-45SetOptions-postOptions (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) (lambda (eta-0) (vector 1 1)) (case (vector-ref arg-5 0) ((12) (if (null? arg-6) (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 csegen-3841 e-3 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 0)))))))))) ((2) (let ((e-4 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 0 (vector 2 ) (vector 1 (vector 0 e-4))) eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 0)))))))))) ((0) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 0)))))) ((34) (let ((e-5 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45REPL-replCmd arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 0)))))))(else (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2))))) (let ((e-9 (car arg-6))) (let ((e-10 (cdr arg-6))) (case (vector-ref e-9 0) ((1) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-10) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 0))))))(else (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 csegen-3841 e-3 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 0)))))))))) ((2) (let ((e-4 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 0 (vector 2 ) (vector 1 (vector 0 e-4))) eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 0)))))))))) ((0) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 0)))))) ((34) (let ((e-5 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45REPL-replCmd arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 0)))))))(else (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2)))))))))))(else (let ((e-1 (car arg-6))) (let ((e-2 (cdr arg-6))) (case (vector-ref e-1 0) ((1) (let ((e-3 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-compileExp arg-0 arg-1 arg-2 arg-3 arg-4 csegen-3841 e-3 eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (vector 1 0)))))))))) ((2) (let ((e-4 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-1) (IdrisC-45REPL-execExp arg-0 arg-1 arg-2 arg-3 arg-4 (vector 0 (vector 2 ) (vector 1 (vector 0 e-4))) eta-1)) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((act-2 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 0)))))))))) ((0) (lambda (eta-0) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 0)))))) ((34) (let ((e-5 (vector-ref e-1 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45REPL-replCmd arg-0 arg-1 arg-2 arg-3 arg-4 e-5 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 0)))))))(else (IdrisC-45SetOptions-postOptions arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 e-2))))))))))
(define IdrisC-45Package-errorMsg (DataC-45String-fastUnlines (cons "Not all command line options can be used to override package options.\xa;" (cons "Overridable options are:" (cons "    --quiet" (cons "    --verbose" (cons "    --timing" (cons "    --log <log level>" (cons "    --dumpcases <file>" (cons "    --dumplifted <file>" (cons "    --dumpvmcode <file>" (cons "    --debug-elab-check" (cons "    --codegen <cg>" (cons "    --inc <cg>" (cons "    --directive <directive>" (cons "    --build-dir <dir>" (cons "    --output-dir <dir>" '())))))))))))))))))
(define IdrisC-45Package-n--25915-17461-u--optType (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((23) (let ((e-0 (vector-ref arg-1 1))) (let ((e-1 (vector-ref arg-1 2))) (vector 0 arg-0 e-0 e-1)))) ((14) (vector 1 arg-0)) ((17) (vector 1 arg-0)) ((37) (vector 1 arg-0)) ((20) (vector 1 arg-0)) ((43) (vector 1 arg-0)) ((32) (vector 1 arg-0)) ((30) (vector 1 arg-0)) ((31) (vector 1 arg-0)) ((33) (vector 1 arg-0)) ((38) (vector 1 arg-0)) ((3) (vector 1 arg-0)) ((44) (vector 1 arg-0)) ((4) (vector 1 arg-0)) ((7) (vector 1 arg-0)) ((8) (vector 1 arg-0)) ((40) (vector 1 arg-0)) ((42) (vector 1 arg-0)) ((9) (vector 1 arg-0)) ((18) (vector 2 arg-0)) ((19) (vector 2 arg-0)) ((13) (vector 2 arg-0))(else (vector 3 arg-0)))))
(define IdrisC-45Package-with--partitionOptsC-44pOptUpdate-17515 (lambda (arg-0 arg-1 arg-2 ext-0) (case (vector-ref arg-2 0) ((0) (let ((e-1 (vector-ref arg-2 2))) (let ((e-2 (vector-ref arg-2 3))) (let ((e-5 (vector-ref ext-0 0))) (let ((e-4 (vector-ref ext-0 1))) (let ((e-3 (vector-ref ext-0 2))) (vector (cons (cons e-1 e-2) e-5) e-4 e-3))))))) ((1) (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (let ((e-2 (vector-ref ext-0 2))) (vector e-0 (cons arg-1 e-1) e-2))))) ((2) ext-0) (else (let ((e-0 (vector-ref ext-0 0))) (let ((e-1 (vector-ref ext-0 1))) (vector e-0 e-1 1)))))))
(define IdrisC-45Package-n--25915-17462-u--pOptUpdate (lambda (arg-0 arg-1 ext-0) (IdrisC-45Package-with--partitionOptsC-44pOptUpdate-17515 arg-0 arg-1 (IdrisC-45Package-n--25915-17461-u--optType arg-0 arg-1) ext-0)))
(define IdrisC-45Package-partitionOpts (lambda (arg-0) (PreludeC-45Types-u--foldr_Foldable_List (lambda (eta-0) (lambda (eta-1) (IdrisC-45Package-n--25915-17462-u--pOptUpdate arg-0 eta-0 eta-1))) (vector '() '() 0) arg-0)))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-n--5230-5775-u--dirsC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45Basics-flip csegen-1631 arg-1 (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 ((arg-3 arg-0) e-2)) (lambda (_-10649) (box (cons e-2 (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (LibrariesC-45SystemC-45DirectoryC-45Tree-filter (lambda (root-5834) (arg-4 root-5834)) (lambda (root-5839) (arg-3 root-5839)) (LibrariesC-45UtilsC-45Path-C-47C-62 arg-0 e-2) eta-1)) e-3 eta-0))))))))))))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-n--5230-5776-u--filesC-39 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45TypesC-45List-filterAppend '() (arg-4 arg-0) arg-2)))
(define LibrariesC-45SystemC-45DirectoryC-45Tree-filter (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-1 (car arg-3))) (let ((e-2 (cdr arg-3))) (cons (LibrariesC-45SystemC-45DirectoryC-45Tree-n--5230-5776-u--filesC-39 arg-2 e-2 e-1 arg-1 arg-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-n--5230-5775-u--dirsC-39 arg-2 e-2 e-1 arg-1 arg-0))))))
(define IdrisC-45PackageC-45Init-case--isModuleIdent-7145 (lambda (arg-0 arg-1) (if (null? arg-1) 0 (let ((e-2 (car arg-1))) (let ((sc1 (PreludeC-45Types-isUpper e-2))) (cond ((equal? sc1 1) (PreludeC-45Types-u--foldMap_Foldable_List csegen-186 (lambda (eta-0) (PreludeC-45Types-isAlphaNum eta-0)) arg-1)) (else 0)))))))
(define IdrisC-45PackageC-45Init-isModuleIdent (lambda (arg-0) (IdrisC-45PackageC-45Init-case--isModuleIdent-7145 arg-0 (PreludeC-45Types-fastUnpack arg-0))))
(define IdrisC-45PackageC-45Init-n--5032-7168-u--validDirectory (lambda (arg-0 arg-1 ext-0) (IdrisC-45PackageC-45Init-isModuleIdent ext-0)))
(define PreludeC-45Interfaces-u--C-60C-43C-62_Semigroup_SemigroupAlternativeC-40C-36fC-32C-36aC-41 (lambda (arg-2 arg-3 arg-4) (let ((e-3 (vector-ref arg-2 2))) (((e-3 'erased) arg-3) (lambda () arg-4)))))
(define PreludeC-45Interfaces-u--neutral_Monoid_MonoidAlternativeC-40C-36fC-32C-36aC-41 (lambda (arg-2) (let ((e-2 (vector-ref arg-2 1))) (e-2 'erased))))
(define DataC-45List-n--7963-8443-u--go (lambda (arg-3 arg-4 arg-5 arg-6) (if (null? arg-5) (box (cons (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-4 '()) arg-6)) (if (null? arg-6) '() (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (let ((e-4 (car arg-6))) (let ((e-5 (cdr arg-6))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe ((arg-3 e-1) e-4) (lambda (bind-0) (DataC-45List-n--7963-8443-u--go arg-3 (cons arg-4 bind-0) e-2 e-5)))))))))))
(define DataC-45List-prefixOfBy (lambda (arg-3 ext-0 ext-1) (DataC-45List-n--7963-8443-u--go arg-3 '() ext-0 ext-1)))
(define DataC-45List-suffixOfBy (lambda (arg-3 arg-4 arg-5) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45List-prefixOfBy arg-3 (PreludeC-45TypesC-45List-reverse arg-4) (PreludeC-45TypesC-45List-reverse arg-5)) (lambda (_-0) (let ((e-2 (car _-0))) (let ((e-3 (cdr _-0))) (box (cons (PreludeC-45TypesC-45List-reverse e-3) (PreludeC-45TypesC-45List-reverse e-2)))))))))
(define ParserC-45Unlit-n--4461-5996-u--err (lambda (arg-0) (Builtin-idris_crash "Internal error: all literate extensions should start with a \".\"")))
(define ParserC-45Unlit-case--caseC-32blockC-32inC-32hasLitFileExt-6064 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (ParserC-45Unlit-n--4461-5996-u--err arg-0) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cond ((equal? e-1 "") (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (DataC-45List-suffixOfBy (lambda (u--v) (lambda (u--w) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) u--v) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--v u--w))))) e-2 arg-3) (lambda (_-0) (let ((e-4 (car _-0))) (let ((e-3 (cdr _-0))) (box (cons (string-append arg-2 (arg-1 e-4)) (arg-1 e-3))))))))(else (ParserC-45Unlit-n--4461-5996-u--err arg-0))))))))
(define ParserC-45Unlit-hasLitFileExt (lambda (arg-0) (let ((u--toExtension (lambda (eta-0) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (arg-1) (string-append "." arg-1)) eta-0)))) (let ((sc0 (LibrariesC-45UtilsC-45Path-splitExtensions arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (PreludeC-45Basics-flip (lambda (eta-0) (lambda (eta-1) (PreludeC-45Types-u--foldMap_Foldable_List (cons (lambda (arg-8474) (lambda (arg-8477) (PreludeC-45Interfaces-u--C-60C-43C-62_Semigroup_SemigroupAlternativeC-40C-36fC-32C-36aC-41 csegen-258 arg-8474 arg-8477))) (PreludeC-45Interfaces-u--neutral_Monoid_MonoidAlternativeC-40C-36fC-32C-36aC-41 csegen-258)) eta-0 eta-1))) ParserC-45Unlit-listOfExtensionsLiterate (lambda (u--candidate) (ParserC-45Unlit-case--caseC-32blockC-32inC-32hasLitFileExt-6064 arg-0 u--toExtension e-2 e-3 u--candidate (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (PreludeC-45Types-fastPack eta-0)) (DataC-45List-split csegen-1713 (PreludeC-45Types-fastUnpack u--candidate))))))))))))
(define CoreC-45Directory-n--8556-5857-u--isPureCode (lambda (arg-0) (let ((sc0 (LibrariesC-45UtilsC-45Path-splitFileName arg-0))) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-3 "idr")) (lambda (_-10649) (box (cons e-2 ".idr")))))))))
(define CoreC-45Directory-splitIdrisFileName (lambda (arg-0) (PreludeC-45Types-u--C-60C-124C-62_Alternative_Maybe (ParserC-45Unlit-hasLitFileExt arg-0) (lambda () (CoreC-45Directory-n--8556-5857-u--isPureCode arg-0)))))
(define IdrisC-45PackageC-45Init-n--5032-7169-u--validFile (lambda (arg-0 arg-1 arg-2) (let ((sc0 (CoreC-45Directory-splitIdrisFileName arg-2))) (if (null? sc0) 0 (let ((e-2 (unbox sc0))) (let ((e-5 (car e-2))) (IdrisC-45PackageC-45Init-isModuleIdent e-5)))))))
(define IdrisC-45PackageC-45Init-packageTree (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-filter (lambda (root-7233) (lambda (eta-1) (IdrisC-45PackageC-45Init-n--5032-7169-u--validFile arg-0 root-7233 eta-1))) (lambda (root-7238) (lambda (eta-1) (IdrisC-45PackageC-45Init-n--5032-7168-u--validDirectory arg-0 root-7238 eta-1))) arg-0 eta-0)) (lambda (eta-0) (LibrariesC-45SystemC-45DirectoryC-45Tree-explore arg-0 eta-0)) ext-0)))
(define IdrisC-45PackageC-45Init-n--5110-7250-u--go (lambda (arg-0 arg-1 arg-2) (lambda (clam-0) (if (null? arg-2) arg-1 (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (let ((e-6 (car e-2))) (let ((e-7 (cdr e-2))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (e-11 clam-0))) (let ((u--mods (PreludeC-45Basics-flip csegen-2819 (let ((e-1 (car act-1))) e-1) (lambda (u--entry) (let ((u--fname (Builtin-fst (LibrariesC-45UtilsC-45Path-splitExtensions u--entry)))) (let ((u--mod (cons u--fname e-6))) (let ((u--fp (LibrariesC-45SystemC-45DirectoryC-45Tree-toFilePath e-10 u--entry))) (cons u--mod u--fp)))))))) (let ((u--dirs (PreludeC-45Basics-flip csegen-2819 (let ((e-4 (cdr act-1))) e-4) (lambda (lamc-0) (let ((e-5 (car lamc-0))) (let ((e-4 (cdr lamc-0))) (cons (cons e-5 e-6) (cons (LibrariesC-45UtilsC-45Path-C-47C-62 e-10 e-5) e-4)))))))) ((IdrisC-45PackageC-45Init-n--5110-7250-u--go arg-0 (PreludeC-45TypesC-45List-tailRecAppend u--mods arg-1) (PreludeC-45TypesC-45List-tailRecAppend u--dirs e-3)) clam-0))))))))))))))
(define IdrisC-45PackageC-45Init-findModules (lambda (arg-0 ext-0) (let ((act-1 ((PreludeC-45Types-maybe (lambda () csegen-1310) (lambda () (lambda (eta-0) (lambda (eta-1) (box eta-0)))) arg-0) ext-0))) (if (null? act-1) '() (let ((e-1 (unbox act-1))) (let ((u--root (LibrariesC-45UtilsC-45Path-parse e-1))) (let ((act-2 (IdrisC-45PackageC-45Init-packageTree u--root ext-0))) (let ((act-3 ((IdrisC-45PackageC-45Init-n--5110-7250-u--go arg-0 '() (cons (cons '() (cons u--root (lambda (eta-0) act-2))) '())) ext-0))) (DataC-45List-sortBy (lambda (u--a) (lambda (u--b) (PreludeC-45EqOrd-u--compare_Ord_String (Builtin-snd u--a) (Builtin-snd u--b)))) act-3)))))))))
(define IdrisC-45PackageC-45Init-prompt (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (PreludeC-45IO-prim__putStr arg-0 ext-0))) (csegen-3886 ext-0)))) (PreludeC-45IO-prim__getStr ext-0))))
(define IdrisC-45PackageC-45Init-case--interactiveC-44mstring-7530 (lambda (arg-0 arg-1) (cond ((equal? arg-1 "") '())(else (box arg-1)))))
(define IdrisC-45PackageC-45Init-n--5395-7520-u--mstring (lambda (arg-0) (IdrisC-45PackageC-45Init-case--interactiveC-44mstring-7530 arg-0 (DataC-45String-trim arg-0))))
(define IdrisC-45PackageC-45Init-interactive (lambda (ext-0) (let ((act-1 (IdrisC-45PackageC-45Init-prompt "Package name: " ext-0))) (let ((act-2 (IdrisC-45PackageC-45Init-prompt "Package authors: " ext-0))) (let ((act-3 (IdrisC-45PackageC-45Init-prompt "Package options: " ext-0))) (let ((act-4 (IdrisC-45PackageC-45Init-prompt "Source directory: " ext-0))) (let ((u--sourcedir (IdrisC-45PackageC-45Init-n--5395-7520-u--mstring act-4))) (let ((act-5 (IdrisC-45PackageC-45Init-findModules u--sourcedir ext-0))) (let ((u--pkg (let ((sc0 (IdrisC-45PackageC-45Types-initPkgDesc (DataC-45Maybe-fromMaybe (lambda () "project") (IdrisC-45PackageC-45Init-n--5395-7520-u--mstring act-1))))) (let ((e-0 (vector-ref sc0 0))) (let ((e-1 (vector-ref sc0 1))) (let ((e-2 (vector-ref sc0 2))) (let ((e-4 (vector-ref sc0 4))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (let ((e-8 (vector-ref sc0 8))) (let ((e-9 (vector-ref sc0 9))) (let ((e-10 (vector-ref sc0 10))) (let ((e-11 (vector-ref sc0 11))) (let ((e-13 (vector-ref sc0 13))) (let ((e-14 (vector-ref sc0 14))) (let ((e-17 (vector-ref sc0 17))) (let ((e-18 (vector-ref sc0 18))) (let ((e-19 (vector-ref sc0 19))) (let ((e-20 (vector-ref sc0 20))) (let ((e-21 (vector-ref sc0 21))) (let ((e-22 (vector-ref sc0 22))) (let ((e-23 (vector-ref sc0 23))) (let ((e-24 (vector-ref sc0 24))) (vector e-0 e-1 e-2 (IdrisC-45PackageC-45Init-n--5395-7520-u--mstring act-2) e-4 e-5 e-6 e-7 e-8 e-9 e-10 e-11 act-5 e-13 e-14 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons CoreC-45FC-emptyFC __infixTupleSection-0)) (IdrisC-45PackageC-45Init-n--5395-7520-u--mstring act-3)) u--sourcedir e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24))))))))))))))))))))))))) u--pkg)))))))))
(define IdrisC-45Package-localPackageFile (lambda (arg-0 ext-0) (if (null? arg-0) (let ((act-1 (CoreC-45Context-getWorkingDir ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (LibrariesC-45SystemC-45DirectoryC-45Tree-explore (LibrariesC-45UtilsC-45Path-parse e-5) eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--candidates (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) eta-1) (let ((e-1 (car e-6))) e-1)))) (lambda (clam-0) (let ((sc3 (PreludeC-45TypesC-45List-filterAppend '() csegen-3863 u--candidates))) (if (null? sc3) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 62 "No .ipkg file supplied and none could be found in the working directory.") clam-0) (let ((e-1 (car sc3))) (let ((e-2 (cdr sc3))) (if (null? e-2) (vector 1 e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 62 "No .ipkg file supplied and the working directory contains more than one.") clam-0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))) (let ((e-1 (unbox arg-0))) (vector 1 e-1)))))
(define CoreC-45Core-wrapRef (lambda (arg-3 arg-4 arg-5 arg-6) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-4))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (let ((eff-1 (lambda (eta-0) (CoreC-45Core-u--catch_Catchable_Core_Error arg-6 (lambda (u--err) (let ((eff-1 (arg-5 e-5))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else ((let ((eff-2 (let ((eff-2 (lambda (world-2) (let ((act-3 (set-box! arg-4 e-5))) (vector 1 act-3))))) (lambda (world-2) (let ((act-3 (eff-2 world-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-3 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error u--err eta-1)))) eff-3) world-2)))))))) eff-2) world-1))))))) eta-0)))) (lambda (world-1) (let ((act-2 (eff-1 world-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-2 (let ((eff-2 (arg-5 e-5))) (lambda (world-2) (let ((act-3 (eff-2 world-2))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-3 (let ((eff-3 (lambda (world-3) (let ((act-4 (set-box! arg-4 e-5))) (vector 1 act-4))))) (lambda (world-3) (let ((act-4 (eff-3 world-3))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((let ((eff-4 (lambda (eta-0) (vector 1 e-6)))) eff-4) world-3)))))))) eff-3) world-2)))))))) eff-2) world-1))))))))) eff-1) world-0)))))))))
(define CoreC-45Context-n--31897-26835-u--resetCtxt (lambda (arg-1 arg-2) (let ((u--dir (let ((e-4 (vector-ref arg-2 4))) (let ((e-42 (vector-ref e-4 0))) (let ((e-52 (vector-ref e-42 0))) e-52))))) (let ((eff-0 (lambda (world-0) (let ((act-1 ((SystemC-45Directory-changeDir csegen-82 u--dir) world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))))
(define CoreC-45Context-withCtxt (lambda (arg-1 ext-0) (CoreC-45Core-wrapRef (vector "Core.Context.Ctxt" ) arg-1 (lambda (eta-0) (CoreC-45Context-n--31897-26835-u--resetCtxt arg-1 eta-0)) ext-0)))
(define IdrisC-45REPLC-45Opts-withROpts (lambda (arg-1 ext-0) (CoreC-45Core-wrapRef (vector "Idris.REPL.Opts.ROpts" ) arg-1 (lambda (_-6388) (lambda (eta-0) (vector 1 (vector 0 )))) ext-0)))
(define IdrisC-45Syntax-withSyn (lambda (arg-1 ext-0) (CoreC-45Core-wrapRef (vector "Idris.Syntax.Syn" ) arg-1 (lambda (_-7782) (lambda (eta-0) (vector 1 (vector 0 )))) ext-0)))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgVersion (lambda (ext-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion ext-0))))
(define IdrisC-45PackageC-45Types-n--5137-5879-u--operator (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (string-append (cond ((equal? arg-4 1) ">") (else "<")) (cond ((equal? arg-5 1) "=") (else ""))))))
(define IdrisC-45PackageC-45Types-n--5137-5878-u--bounds (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (if (null? arg-6) '() (let ((e-2 (unbox arg-6))) (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45PackageC-45Types-n--5137-5879-u--operator arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgVersion e-2)))))))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgVersionBounds (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (eta-0) (lambda (eta-1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-surround (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 " && ") eta-0 eta-1))) (DataC-45List-catMaybes (cons (IdrisC-45PackageC-45Types-n--5137-5878-u--bounds e-3 e-2 e-1 e-0 1 e-1 e-0) (cons (IdrisC-45PackageC-45Types-n--5137-5878-u--bounds e-3 e-2 e-1 e-0 0 e-3 e-2) '()))))))))))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_Depends (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (let ((e-0 (car arg-0))) e-0)) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgVersionBounds (let ((e-1 (cdr arg-0))) e-1)))))
(define IdrisC-45PackageC-45Types-u--prettyPrec_Pretty_Void_Depends (lambda (arg-0 arg-1) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_Depends arg-1)))
(define IdrisC-45PackageC-45Types-n--7937-8586-u--comment (lambda (arg-0 arg-1) (let ((u--ws (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "--") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-words arg-1)))) (let ((u--commSoftLine (vector 7 (lambda () (vector 1 #\ )) (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hcat (cons (vector 3 ) (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "-- ") '()))))))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (vector 3 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-concatWith (lambda (u--x) (lambda (u--y) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 u--x u--commSoftLine) u--y))) u--ws))))))
(define IdrisC-45PackageC-45Types-n--7937-8587-u--field (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (DataC-45List-catMaybes (cons (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "--")) (cons (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String arg-2)) (cons (PreludeC-45Interfaces-C-42C-62 csegen-255 (PreludeC-45Interfaces-guard csegen-258 arg-1) (box LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals)) '()))))) (let ((e-2 (unbox arg-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (DataC-45List-catMaybes (cons (box (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String arg-2)) (cons (PreludeC-45Interfaces-C-42C-62 csegen-255 (PreludeC-45Interfaces-guard csegen-258 arg-1) (box LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals)) (cons (box e-2) '())))))))))
(define IdrisC-45PackageC-45Types-n--7937-8588-u--seqField (lambda (arg-0 arg-2 arg-3 arg-4) (if (null? arg-4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "--") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String arg-3) (cons LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals '())))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String arg-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-equals (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-align (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-sep (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-punctuate LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-comma (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (let ((e-2 (car arg-2))) (e-2 eta-0))) arg-4)))))))))
(define IdrisC-45PackageC-45Types-n--7937-8589-u--strField (lambda (arg-0 arg-1 ext-0) (IdrisC-45PackageC-45Types-n--7937-8587-u--field arg-0 1 arg-1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_String eta-0))) ext-0))))
(define IdrisC-45PackageC-45Types-n--7937-8590-u--verField (lambda (arg-0 arg-1 ext-0) (IdrisC-45PackageC-45Types-n--7937-8587-u--field arg-0 1 arg-1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgVersion eta-0)) ext-0))))
(define IdrisC-45PackageC-45Types-n--7937-8591-u--verSeqField (lambda (arg-0 arg-1 ext-0) (IdrisC-45PackageC-45Types-n--7937-8587-u--field arg-0 0 arg-1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgVersionBounds eta-0)) ext-0))))
(define IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgDesc (lambda (arg-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "package") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (let ((e-0 (vector-ref arg-0 0))) e-0))) (cons (IdrisC-45PackageC-45Types-n--7937-8590-u--verField arg-0 "version" (let ((e-1 (vector-ref arg-0 1))) e-1)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "authors" (let ((e-3 (vector-ref arg-0 3))) e-3)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "maintainers" (let ((e-4 (vector-ref arg-0 4))) e-4)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "license" (let ((e-5 (vector-ref arg-0 5))) e-5)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "brief" (let ((e-6 (vector-ref arg-0 6))) e-6)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "readme" (let ((e-7 (vector-ref arg-0 7))) e-7)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "homepage" (let ((e-8 (vector-ref arg-0 8))) e-8)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "sourceloc" (let ((e-9 (vector-ref arg-0 9))) e-9)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "bugtracker" (let ((e-10 (vector-ref arg-0 10))) e-10)) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "the Idris2 version required (e.g. langversion >= 0.5.1)") (cons (IdrisC-45PackageC-45Types-n--7937-8591-u--verSeqField arg-0 "langversion" (let ((e-2 (vector-ref arg-0 2))) e-2)) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "packages to add to search path") (cons (IdrisC-45PackageC-45Types-n--7937-8588-u--seqField arg-0 (cons (lambda (arg-11067) (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_Depends arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (IdrisC-45PackageC-45Types-u--prettyPrec_Pretty_Void_Depends arg-11073 arg-11076)))) "depends" (let ((e-11 (vector-ref arg-0 11))) e-11)) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "modules to install") (cons (IdrisC-45PackageC-45Types-n--7937-8588-u--seqField arg-0 csegen-2789 "modules" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-fst eta-0)) (let ((e-12 (vector-ref arg-0 12))) e-12))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "main file (i.e. file to load at REPL)") (cons (IdrisC-45PackageC-45Types-n--7937-8587-u--field arg-0 1 "main" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (CoreC-45NameC-45Namespace-u--pretty_Pretty_Void_ModuleIdent (Builtin-fst eta-0))) (let ((e-13 (vector-ref arg-0 13))) e-13))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "name of executable") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "executable" (let ((e-14 (vector-ref arg-0 14))) e-14)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "opts" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-15 (vector-ref arg-0 15))) e-15))) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "sourcedir" (let ((e-16 (vector-ref arg-0 16))) e-16)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "builddir" (let ((e-17 (vector-ref arg-0 17))) e-17)) (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "outputdir" (let ((e-18 (vector-ref arg-0 18))) e-18)) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "script to run before building") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "prebuild" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-19 (vector-ref arg-0 19))) e-19))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "script to run after building") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "postbuild" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-20 (vector-ref arg-0 20))) e-20))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "script to run after building, before installing") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "preinstall" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-21 (vector-ref arg-0 21))) e-21))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "script to run after installing") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "postinstall" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-22 (vector-ref arg-0 22))) e-22))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "script to run before cleaning") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "preclean" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-23 (vector-ref arg-0 23))) e-23))) (cons (IdrisC-45PackageC-45Types-n--7937-8586-u--comment arg-0 "script to run after cleaning") (cons (IdrisC-45PackageC-45Types-n--7937-8589-u--strField arg-0 "postclean" (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-24 (vector-ref arg-0 24))) e-24))) '())))))))))))))))))))))))))))))))))))))))
(define IdrisC-45PackageC-45TypesC-45Version-inBounds (lambda (arg-0 arg-1) (let ((e-0 (car arg-0))) (let ((e-1 (cdr arg-0))) (let ((e-4 (car e-0))) (let ((e-5 (cdr e-0))) (let ((e-8 (car e-5))) (let ((e-9 (cdr e-5))) (let ((u--v (cons e-4 (cons e-8 (cons e-9 '()))))) (let ((sc3 (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (u--vC-39) (let ((sc4 (let ((e-6 (vector-ref arg-1 1))) e-6))) (cond ((equal? sc4 1) (IdrisC-45PackageC-45Types-u--C-62C-61_Ord_PkgVersion u--v u--vC-39)) (else (let ((sc5 (IdrisC-45PackageC-45Types-u--C-62_Ord_PkgVersion u--v u--vC-39))) (cond ((equal? sc5 1) 1) (else (let ((sc6 (IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion u--v u--vC-39))) (cond ((equal? sc6 1) (PreludeC-45Types-u--C-47C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-22 e-1 '())) (else 0))))))))))) (let ((e-7 (vector-ref arg-1 0))) e-7)))) (cond ((equal? sc3 1) (PreludeC-45Types-maybe (lambda () 1) (lambda () (lambda (u--vC-39) (let ((sc4 (let ((e-3 (vector-ref arg-1 3))) e-3))) (cond ((equal? sc4 1) (let ((sc5 (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion u--v u--vC-39))) (cond ((equal? sc5 1) 1) (else (let ((sc6 (IdrisC-45PackageC-45Types-u--C-61C-61_Eq_PkgVersion u--v u--vC-39))) (cond ((equal? sc6 1) (PreludeC-45Types-u--C-61C-61_Eq_C-40MaybeC-32C-36aC-41 csegen-22 e-1 '())) (else 0))))))) (else (IdrisC-45PackageC-45Types-u--C-60_Ord_PkgVersion u--v u--vC-39)))))) (let ((e-2 (vector-ref arg-1 2))) e-2))) (else 0))))))))))))
(define IdrisC-45Package-case--assertIdrisCompatibility-12214 (lambda (arg-0 arg-1) (lambda (clam-0) (if (null? arg-1) (vector 1 (vector 0 )) (let ((e-1 (unbox arg-1))) (let ((sc1 (IdrisC-45PackageC-45TypesC-45Version-inBounds IdrisC-45Version-version e-1))) (cond ((equal? sc1 1) (vector 1 (vector 0 ))) (else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 CoreC-45FC-emptyFC (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (cons " requires Idris2 " (cons (IdrisC-45PackageC-45Types-u--show_Show_PkgVersionBounds e-1) (cons " but the installed version of Idris2 is " (cons (LibrariesC-45DataC-45Version-u--show_Show_Version IdrisC-45Version-version) (cons "." '())))))))) clam-0)))))))))
(define IdrisC-45Package-assertIdrisCompatibility (lambda (arg-0) (IdrisC-45Package-case--assertIdrisCompatibility-12214 arg-0 (let ((e-2 (vector-ref arg-0 2))) e-2))))
(define IdrisC-45Package-compileMain (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 0 e-5))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (csegen-1985 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (IdrisC-45REPL-loadMainFile arg-0 e-7 arg-1 e-6 arg-2 arg-4 eta-3)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (IdrisC-45REPL-compileExp arg-0 e-7 arg-1 e-6 arg-2 (vector 0 CoreC-45FC-replFC arg-3) arg-5 eta-3)) eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45ModTree-getAllBuildMods (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (if (null? arg-5) (vector 1 arg-4) (let ((e-2 (car arg-5))) (let ((e-3 (cdr arg-5))) (let ((act-1 (IdrisC-45ModTree-getBuildMods arg-0 arg-2 arg-3 arg-4 e-2 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45ModTree-getAllBuildMods arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-tailRecAppend e-5 arg-4) e-3 eta-0)))) eff-0) ext-0))))))))))
(define IdrisC-45ModTree-n--16690-11723-u--dropLater (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-4) '() (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cons e-2 (IdrisC-45ModTree-n--16690-11723-u--dropLater arg-0 arg-1 arg-2 arg-3 (PreludeC-45TypesC-45List-filterAppend '() (lambda (u--x) (PreludeC-45EqOrd-u--C-47C-61_Eq_String (let ((e-0 (vector-ref u--x 0))) e-0) (let ((e-0 (vector-ref e-2 0))) e-0))) e-3))))))))
(define IdrisC-45ModTree-buildAll (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (IdrisC-45ModTree-getAllBuildMods arg-0 arg-1 arg-2 (vector 2 ) '() arg-3 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--modsC-39 (IdrisC-45ModTree-n--16690-11723-u--dropLater arg-3 arg-2 arg-1 arg-0 e-5))) (lambda (eta-0) (IdrisC-45ModTree-buildMods arg-0 arg-1 arg-2 (vector 2 ) 1 (PreludeC-45TypesC-45List-lengthTR u--modsC-39) u--modsC-39 eta-0))))) eff-0) ext-0)))))))
(define IdrisC-45Package-runScript (lambda (arg-0) (lambda (clam-0) (if (null? arg-0) (vector 1 (vector 0 )) (let ((e-2 (unbox arg-0))) (let ((e-5 (car e-2))) (let ((e-6 (cdr e-2))) (let ((act-1 (let ((act-1 ((System-system csegen-82 e-6) clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((sc3 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int e-7 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc3 1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 e-5 "Script failed") clam-1)) (else (vector 1 (vector 0 )))))))) eff-0) clam-0))))))))))))
(define IdrisC-45Package-prepareCompilation (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((IdrisC-45Package-processOptions arg-0 arg-2 (let ((e-15 (vector-ref arg-3 15))) e-15)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (IdrisC-45Package-addDeps arg-0 arg-1 arg-2 arg-3 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (IdrisC-45SetOptions-preOptions arg-0 arg-2 arg-4) ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((IdrisC-45Package-runScript (let ((e-19 (vector-ref arg-3 19))) e-19)) ext-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((u--toBuild (PreludeC-45Types-maybe (lambda () (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-12 (vector-ref arg-3 12))) e-12))) (lambda () (lambda (u--m) (cons (Builtin-snd u--m) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (Builtin-snd eta-0)) (let ((e-12 (vector-ref arg-3 12))) e-12))))) (let ((e-13 (vector-ref arg-3 13))) e-13)))) (IdrisC-45ModTree-buildAll arg-0 arg-1 arg-2 u--toBuild ext-0))))))))))))))))
(define IdrisC-45Package-build (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((IdrisC-45Package-assertIdrisCompatibility arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (IdrisC-45Package-prepareCompilation arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-3 (let ((e-14 (vector-ref arg-3 14))) (if (null? e-14) (vector 1 (vector 0 )) (let ((e-27 (unbox e-14))) (let ((e-39 (vector-ref arg-3 13))) (if (null? e-39) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 CoreC-45FC-emptyFC "No main module given") clam-0) (let ((e-53 (unbox e-39))) (let ((e-55 (car e-53))) (let ((e-54 (cdr e-53))) (let ((u--mainName (vector 0 e-55 (vector 1 (vector 0 "main"))))) (let ((act-3 (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Now compiling the executable: " (cons e-27 '()))) "\xa;") clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-56 (vector-ref act-3 1))) (vector 0 e-56))) (else (IdrisC-45Package-compileMain arg-0 arg-1 arg-2 u--mainName e-54 e-27 clam-0))))))))))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((IdrisC-45Package-runScript (let ((e-20 (vector-ref arg-3 20))) e-20)) clam-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (vector 1 '()))))))) (vector 1 e-6))))) eff-0) ext-0))))))))))
(define IdrisC-45Package-check (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((IdrisC-45Package-assertIdrisCompatibility arg-3) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (IdrisC-45Package-prepareCompilation arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-6) (let ((act-3 ((IdrisC-45Package-runScript (let ((e-20 (vector-ref arg-3 20))) e-20)) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 '())))) (vector 1 e-6))))) eff-0) ext-0))))))))))
(define LibrariesC-45DataC-45StringTrie-empty (vector 1 LibrariesC-45DataC-45StringMap-empty))
(define DataC-45These-bifold (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-2 (vector-ref arg-2 1))) e-2)) ((1) (let ((e-5 (vector-ref arg-2 1))) e-5)) (else (let ((e-8 (vector-ref arg-2 1))) (let ((e-9 (vector-ref arg-2 2))) ((arg-1 e-8) e-9)))))))
(define IdrisC-45Package-bitraverseC (lambda (arg-4 arg-5 arg-6 ext-0) (case (vector-ref arg-6 0) ((0) (let ((e-2 (vector-ref arg-6 1))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 0 eta-1)))) (arg-4 e-2) ext-0))) ((1) (let ((e-5 (vector-ref arg-6 1))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (vector 1 (lambda (eta-1) (vector 1 eta-1)))) (arg-5 e-5) ext-0))) (else (let ((e-8 (vector-ref arg-6 1))) (let ((e-9 (vector-ref arg-6 2))) (CoreC-45Core-C-60C-42C-62 (lambda (eta-0) (CoreC-45Core-C-60C-42C-62 (lambda (eta-1) (vector 1 (lambda (eta-2) (lambda (eta-3) (vector 2 eta-2 eta-3))))) (arg-4 e-8) eta-0)) (arg-5 e-9) ext-0)))))))
(define IdrisC-45Package-n--24112-15822-u--go (lambda (arg-1 arg-3 arg-4 arg-5 arg-6 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (DataC-45These-bifold (let ((e-1 (car arg-1))) e-1) e-5)))))) (lambda (eta-0) (IdrisC-45Package-bitraverseC (arg-3 arg-5) (lambda (u--sm) (CoreC-45Core-foldlC csegen-14 (lambda (u--x) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((u--ksC-39 (PreludeC-45TypesC-45List-tailRecAppend arg-5 (cons e-2 '())))) (lambda (eta-1) (let ((act-1 (IdrisC-45Package-n--24112-15822-u--go arg-1 arg-3 arg-4 u--ksC-39 e-3 eta-1))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-2 ((arg-4 u--ksC-39) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (vector 1 (let ((e-1 (car arg-1))) ((e-1 (let ((e-8 (car arg-1))) ((e-8 u--x) e-5))) e-6)))))) eff-0) eta-2)))))))) eff-0) eta-1))))))))))) (let ((e-2 (cdr arg-1))) e-2) (LibrariesC-45DataC-45StringMap-toList u--sm))) arg-6 eta-0)) ext-0)))
(define IdrisC-45Package-foldWithKeysC (lambda (arg-2 arg-3 arg-4 ext-1 ext-0) (IdrisC-45Package-n--24112-15822-u--go arg-2 arg-4 arg-3 '() ext-1 ext-0)))
(define IdrisC-45Package-n--24252-15947-u--delete (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 ((SystemC-45FileC-45ReadWrite-removeFile csegen-82 arg-4) ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "Removed: " arg-4) "\xa;") clam-0))) (vector 1 act-2))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define IdrisC-45Package-n--24252-15948-u--deleteBin (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (let ((u--ttFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (LibrariesC-45UtilsC-45Path-joinPath arg-5)) arg-6))) (lambda (eta-0) (let ((act-1 (IdrisC-45Package-n--24252-15947-u--delete arg-0 arg-1 arg-2 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--ttFile "ttc") eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (IdrisC-45Package-n--24252-15947-u--delete arg-0 arg-1 arg-2 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--ttFile "ttm") eta-0))))))))
(define IdrisC-45Package-n--24252-15949-u--deleteFolder (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (IdrisC-45Package-n--24252-15947-u--delete arg-0 arg-1 arg-2 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (LibrariesC-45UtilsC-45Path-joinPath arg-5)) ext-0)))
(define IdrisC-45Package-clean (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((IdrisC-45Package-runScript (let ((e-23 (vector-ref arg-2 23))) e-23)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--pkgmods (PreludeC-45Types-maybe (lambda () (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) (let ((e-12 (vector-ref arg-2 12))) e-12))) (lambda () (lambda (u--m) (cons (Builtin-fst u--m) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) (let ((e-12 (vector-ref arg-2 12))) e-12))))) (let ((e-13 (vector-ref arg-2 13))) e-13)))) (let ((u--toClean (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (u--mod) (if (null? u--mod) '() (let ((e-2 (car u--mod))) (let ((e-3 (cdr u--mod))) (box (cons e-3 e-2)))))) u--pkgmods))) (let ((act-3 (CoreC-45Context-getWorkingDir eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--d (let ((e-4 (vector-ref e-5 4))) (let ((e-45 (vector-ref e-4 0))) e-45)))) (lambda (eta-1) (let ((act-4 (CoreC-45Directory-ttcBuildDirectory arg-0 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((u--builddir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-7 e-8) "ttc"))) (let ((u--outputdir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-7 (CoreC-45Options-outputDirWithDefault u--d)))) (let ((u--pkgTrie (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--trie) (lambda (u--ksv) (let ((u--ks (Builtin-fst u--ksv))) (let ((u--v (Builtin-snd u--ksv))) (LibrariesC-45DataC-45StringTrie-insertWith (PreludeC-45TypesC-45List-reverse u--ks) (lambda (eta-2) (PreludeC-45Types-maybe (lambda () (cons u--v '())) (lambda () (lambda (arg-4) (cons u--v arg-4))) eta-2)) u--trie))))) LibrariesC-45DataC-45StringTrie-empty u--toClean))) (lambda (eta-2) (let ((act-5 (IdrisC-45Package-foldWithKeysC csegen-3774 (lambda (eta-3) (lambda (eta-4) (IdrisC-45Package-n--24252-15949-u--deleteFolder arg-3 arg-2 arg-1 arg-0 u--builddir eta-3 eta-4))) (lambda (u--ks) (lambda (eta-3) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-5) (case (vector-ref eta-5 0) ((0) (let ((e-2 (vector-ref eta-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref eta-5 1))) (vector 1 (PreludeC-45Types-u--foldMap_Foldable_List csegen-3774 (lambda (eta-6) eta-6) e-9)))))) (CoreC-45Core-traverseC-39 (lambda (eta-5) (IdrisC-45Package-n--24252-15948-u--deleteBin arg-3 arg-2 arg-1 arg-0 u--builddir u--ks eta-5)) eta-3 '()) eta-4)))) u--pkgTrie eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (IdrisC-45Package-n--24252-15949-u--deleteFolder arg-3 arg-2 arg-1 arg-0 u--builddir '() eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((PreludeC-45Types-maybe (lambda () (lambda (eta-3) (vector 1 (vector 0 )))) (lambda () (lambda (u--e) (lambda (eta-3) (IdrisC-45Package-n--24252-15947-u--delete arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--outputdir u--e) eta-3)))) (let ((e-14 (vector-ref arg-2 14))) e-14)) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else ((IdrisC-45Package-runScript (let ((e-24 (vector-ref arg-2 24))) e-24)) eta-2)))))))))))))))) eff-0) eta-1))))))))) eff-0) eta-0))))))))))))) eff-0) ext-0)))))))
(define IdrisC-45Package-installDir (lambda (arg-0) (string-append (let ((e-0 (vector-ref arg-0 0))) e-0) (string-append "-" (IdrisC-45PackageC-45Types-u--show_Show_PkgVersion (DataC-45Maybe-fromMaybe (lambda () (cons 0 '())) (let ((e-1 (vector-ref arg-0 1))) e-1)))))))
(define SystemC-45FileC-45Buffer-readBufferData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Buffer-prim__readBufferData arg-2 arg-3 arg-4 arg-5 eta-0))))) (lambda (u--read) (let ((sc1 (PreludeC-45EqOrd-u--C-62C-61_Ord_Int u--read (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 u--read)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (vector 1 )))))))))))))))
(define SystemC-45FileC-45Buffer-createBufferFromFile (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 0)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45FileC-45Meta-fileSize arg-1 e-6)) (lambda (_-1) (case (vector-ref _-1 0) ((1) (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-16 (vector-ref e-14 1))) ((((e-16 'erased) 'erased) (DataC-45Buffer-newBuffer arg-1 e-12)) (lambda (_-2) (if (null? _-2) (let ((e-19 (car arg-1))) (let ((e-22 (vector-ref e-19 0))) (let ((e-24 (vector-ref e-22 1))) ((e-24 'erased) (vector 0 (vector 1 )))))) (let ((e-18 (unbox _-2))) (let ((e-20 (car arg-1))) (let ((e-22 (vector-ref e-20 1))) ((((e-22 'erased) 'erased) (SystemC-45FileC-45Buffer-readBufferData arg-1 e-6 e-18 0 e-12)) (lambda (_-3) (case (vector-ref _-3 0) ((1) (let ((e-26 (car arg-1))) (let ((e-28 (vector-ref e-26 1))) ((((e-28 'erased) 'erased) (SystemC-45FileC-45Handle-closeFile arg-1 e-6)) (lambda (_-10649) (let ((e-31 (car arg-1))) (let ((e-34 (vector-ref e-31 0))) (let ((e-36 (vector-ref e-34 1))) ((e-36 'erased) (vector 1 e-18)))))))))) (else (let ((e-24 (vector-ref _-3 1))) (let ((e-26 (car arg-1))) (let ((e-29 (vector-ref e-26 0))) (let ((e-31 (vector-ref e-29 1))) ((e-31 'erased) (vector 0 e-24)))))))))))))))))))) (else (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 0 e-12)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 e-6))))))))))))))
(define SystemC-45FileC-45Buffer-writeBufferData (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45Buffer-prim__writeBufferData arg-2 arg-3 arg-4 arg-5 eta-0))))) (lambda (u--written) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--written arg-5))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (vector 0 ))))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 0 (cons (vector 2 ) u--written)))))))))))))))
(define SystemC-45FileC-45Buffer-writeBufferToFile (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Handle-openFile arg-1 arg-2 1)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (SystemC-45FileC-45Buffer-writeBufferData arg-1 e-6 arg-3 0 arg-4)) (lambda (_-1) (case (vector-ref _-1 0) ((1) (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-16 (vector-ref e-14 1))) ((((e-16 'erased) 'erased) (SystemC-45FileC-45Handle-closeFile arg-1 e-6)) (lambda (_-10649) (let ((e-19 (car arg-1))) (let ((e-22 (vector-ref e-19 0))) (let ((e-24 (vector-ref e-22 1))) ((e-24 'erased) (vector 1 e-12))))))))))) (else (let ((e-12 (vector-ref _-1 1))) (let ((e-14 (car arg-1))) (let ((e-17 (vector-ref e-14 0))) (let ((e-19 (vector-ref e-17 1))) ((e-19 'erased) (vector 0 e-12)))))))))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 (cons e-6 (blodwen-toSignedInt 0 63))))))))))))))))
(define SystemC-45File-copyFile (lambda (arg-1 arg-2 arg-3) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (SystemC-45FileC-45Buffer-createBufferFromFile arg-1 arg-2)) (lambda (_-0) (case (vector-ref _-0 0) ((1) (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (DataC-45Buffer-prim__bufferSize e-6)))))) (lambda (bind-0) (SystemC-45FileC-45Buffer-writeBufferToFile arg-1 arg-3 e-6 bind-0))))))) (else (let ((e-6 (vector-ref _-0 1))) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 0 (cons e-6 (blodwen-toSignedInt 0 63))))))))))))))))
(define IdrisC-45Package-installBuildArtifactFrom (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((u--filename_trunk (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-5))) (let ((u--filename (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--filename_trunk arg-2)))) (let ((u--modPath (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 arg-5))))) (let ((u--destNest (LibrariesC-45UtilsC-45Path-joinPath u--modPath))) (let ((u--destPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 u--destNest))) (let ((u--destFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-4 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 u--filename_trunk arg-2)))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Directory-mkdirAll u--destPath eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "Installing " (string-append u--filename (string-append " to " u--destPath))) "\xa;") clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (let ((act-3 ((SystemC-45File-copyFile csegen-82 u--filename u--destFile) clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-7 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-8 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (DataC-45String-fastUnlines (cons (string-append "Can't copy file " (string-append u--filename (string-append " to " u--destPath))) (cons (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5517 e-8) '())))) clam-1))))))) eff-0) clam-0))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (DataC-45String-fastUnlines (cons (string-append "Can't make directories " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--modPath)) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-6) '())))) clam-0))))))) eff-0) eta-0))))))))))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32installFrom-12822 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12) (if (null? arg-12) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox arg-12))) (let ((u--srcFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 e-1)))) (let ((u--destFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 e-1)))) (lambda (clam-0) (let ((sc1 (LibrariesC-45UtilsC-45Path-splitParent u--destFile))) (if (null? sc1) (vector 1 '()) (let ((e-2 (unbox sc1))) (let ((e-5 (car e-2))) (let ((act-1 (CoreC-45Directory-ensureDirectoryExists e-5 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (vector 1 (box (cons u--srcFile u--destFile)))))))))))))))))
(define IdrisC-45Package-installFrom (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((IdrisC-45Package-installBuildArtifactFrom arg-0 arg-1 "ttc" arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 ((IdrisC-45Package-installBuildArtifactFrom arg-0 arg-1 "ttm" arg-2 arg-3 arg-4) ext-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--filename_trunk (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath arg-4))) (let ((u--modPath (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 arg-4))))) (let ((u--destNest (LibrariesC-45UtilsC-45Path-joinPath u--modPath))) (let ((u--destPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-3 u--destNest))) (let ((u--installCodeGenFiles (lambda (u--cg) (lambda (eta-0) (let ((act-3 (IdrisC-45ProcessIdr-getCG arg-0 arg-1 u--cg eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (vector 1 '())) (let ((e-1 (unbox e-7))) (let ((_-0 (box e-1))) (IdrisC-45Package-case--caseC-32blockC-32inC-32installFrom-12822 arg-4 arg-3 arg-2 arg-1 arg-0 u--filename_trunk u--modPath u--destNest u--destPath u--cg e-1 _-0 (let ((e-3 (vector-ref e-1 3))) e-3))))))) eff-0) eta-0))))))))) (let ((act-3 (let ((act-3 (CoreC-45Context-getSession arg-1 ext-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (CoreC-45Core-traverseC-39 u--installCodeGenFiles (let ((e-22 (vector-ref e-7 22))) e-22) '()))) eff-0) ext-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--objPaths (PreludeC-45TypesC-45List-mapMaybeAppend '() (lambda (eta-0) eta-0) e-7))) (CoreC-45Core-traverse_ (lambda (lamc-0) (lambda (clam-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-4 (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "Installing " (string-append e-2 (string-append " to " u--destPath))) "\xa;") clam-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-0) (let ((act-5 ((SystemC-45File-copyFile csegen-82 e-2 e-3) eta-0))) (vector 1 act-5))) clam-0)))))))) u--objPaths)))) eff-0) ext-0))))))))))))))))))
(define SystemC-45FileC-45Permissions-n--2758-965-u--getM (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) 4) ((equal? arg-1 1) 2) (else 1))))
(define SystemC-45FileC-45Permissions-n--2758-966-u--getMs (lambda (arg-0 ext-0) (PreludeC-45Interfaces-sum csegen-189 csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (SystemC-45FileC-45Permissions-n--2758-965-u--getM arg-0 eta-0)) ext-0))))
(define SystemC-45FileC-45Permissions-mkMode (lambda (arg-0) (bs+ (bs+ (bs* (SystemC-45FileC-45Permissions-n--2758-966-u--getMs arg-0 (let ((e-0 (vector-ref arg-0 0))) e-0)) 64 63) (bs* (SystemC-45FileC-45Permissions-n--2758-966-u--getMs arg-0 (let ((e-1 (vector-ref arg-0 1))) e-1)) 8 63) 63) (SystemC-45FileC-45Permissions-n--2758-966-u--getMs arg-0 (let ((e-2 (vector-ref arg-0 2))) e-2)) 63)))
(define SystemC-45FileC-45Permissions-chmod (lambda (arg-1 arg-2 arg-3) (SystemC-45FileC-45Permissions-chmodRaw arg-1 arg-2 (SystemC-45FileC-45Permissions-mkMode arg-3))))
(define IdrisC-45Package-case--installSrcFrom-13091 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Unexpected failure when installing source file:\xa;" (string-append arg-6 "\xa;Can't extract file extension."))) eta-0)) (let ((e-1 (unbox arg-7))) (let ((u--modPath (PreludeC-45TypesC-45List-reverse (DataC-45Maybe-fromMaybe (lambda () '()) (DataC-45List-tailC-39 arg-0))))) (let ((u--destNest (LibrariesC-45UtilsC-45Path-joinPath u--modPath))) (let ((u--destPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 u--destNest))) (let ((u--destFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-2 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 arg-5 e-1)))) (lambda (eta-0) (let ((act-1 (let ((act-1 (CoreC-45Directory-mkdirAll u--destPath eta-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append "Installing " (string-append arg-6 (string-append " to " u--destPath))) "\xa;") clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((act-3 (let ((act-3 (let ((act-3 (CompilerC-45Common-exists u--destFile clam-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-7 1) (let ((act-4 (let ((act-4 ((SystemC-45FileC-45Permissions-chmod csegen-82 u--destFile (vector csegen-829 csegen-829 csegen-829)) clam-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-8 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-9 (vector-ref e-8 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 62 (SystemC-45FileC-45Error-u--show_Show_FileError e-9)) clam-2))))))) eff-0) clam-1)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((act-4 (let ((act-4 ((SystemC-45File-copyFile csegen-82 arg-6 u--destFile) clam-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (clam-3) (case (vector-ref e-8 0) ((1) (let ((act-5 (let ((act-5 ((SystemC-45FileC-45Permissions-chmod csegen-82 u--destFile (vector (cons 0 '()) (cons 0 '()) (cons 0 '()))) clam-3))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-4) (case (vector-ref e-9 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-10 (vector-ref e-9 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 62 (SystemC-45FileC-45Error-u--show_Show_FileError e-10)) clam-4))))))) eff-0) clam-3)))))) (else (let ((e-9 (vector-ref e-8 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (DataC-45String-fastUnlines (cons (string-append "Can't copy file " (string-append arg-6 (string-append " to " u--destPath))) (cons (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-5517 e-9) '())))) clam-3))))))) eff-0) clam-0)))))))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (DataC-45String-fastUnlines (cons (string-append "Can't make directories " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-493 u--modPath)) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-6) '())))) clam-0))))))) eff-0) eta-0))))))))))))))
(define IdrisC-45Package-installSrcFrom (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (let ((u--srcfile (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-2))) (let ((u--srcPath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 arg-1 e-3))) (IdrisC-45Package-case--installSrcFrom-13091 e-2 e-3 arg-2 arg-1 arg-0 u--srcfile u--srcPath (LibrariesC-45UtilsC-45Path-extension u--srcPath))))))))
(define CoreC-45Directory-libInstallDirectory (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Directory-pkgGlobalDirectory arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-5 arg-1))))) eff-0) ext-0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString (lambda (arg-1) (case (vector-ref arg-1 0) ((0) "") ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (string-append (DataC-45String-singleton e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString (e-3)))))) ((2) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (string-append e-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString (e-7)))))) ((3) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (string-append (string-append (DataC-45String-singleton (integer->char 10)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-textSpaces e-9)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString e-10))))) ((4) (let ((e-13 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString e-13))) (else (let ((e-15 (vector-ref arg-1 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString e-15))))))
(define CoreC-45Directory-srcInstallDirectory (lambda (arg-0 ext-1 ext-0) (CoreC-45Directory-libInstallDirectory arg-0 ext-1 ext-0)))
(define CoreC-45Directory-ttcInstallDirectory (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Directory-libInstallDirectory arg-0 arg-1 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-5 (PreludeC-45Show-u--show_Show_Int CoreC-45Binary-ttcVersion)))))) eff-0) ext-0)))))))
(define IdrisC-45Package-n--21702-13640-u--savePkgMetadata (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((sc0 (IdrisC-45PackageC-45Types-initPkgDesc (let ((e-0 (vector-ref arg-5 0))) e-0)))) (let ((e-0 (vector-ref sc0 0))) (let ((e-2 (vector-ref sc0 2))) (let ((e-3 (vector-ref sc0 3))) (let ((e-4 (vector-ref sc0 4))) (let ((e-5 (vector-ref sc0 5))) (let ((e-6 (vector-ref sc0 6))) (let ((e-7 (vector-ref sc0 7))) (let ((e-8 (vector-ref sc0 8))) (let ((e-9 (vector-ref sc0 9))) (let ((e-10 (vector-ref sc0 10))) (let ((e-12 (vector-ref sc0 12))) (let ((e-13 (vector-ref sc0 13))) (let ((e-14 (vector-ref sc0 14))) (let ((e-15 (vector-ref sc0 15))) (let ((e-16 (vector-ref sc0 16))) (let ((e-17 (vector-ref sc0 17))) (let ((e-18 (vector-ref sc0 18))) (let ((e-19 (vector-ref sc0 19))) (let ((e-20 (vector-ref sc0 20))) (let ((e-21 (vector-ref sc0 21))) (let ((e-22 (vector-ref sc0 22))) (let ((e-23 (vector-ref sc0 23))) (let ((e-24 (vector-ref sc0 24))) (vector e-0 (let ((e-48 (vector-ref arg-5 1))) e-48) e-2 e-3 e-4 e-5 e-6 e-7 e-8 e-9 e-10 (let ((e-38 (vector-ref arg-5 11))) e-38) e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24)))))))))))))))))))))))))))
(define IdrisC-45Package-install (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Directory-ttcBuildDirectory arg-0 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--lib (IdrisC-45Package-installDir arg-2))) (lambda (eta-1) (let ((act-3 (let ((act-3 ((System-getEnv csegen-82 "DESTDIR") eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--destdir (DataC-45Maybe-fromMaybe (lambda () "") e-7))) (lambda (eta-2) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-3) (case (vector-ref eta-3 0) ((0) (let ((e-2 (vector-ref eta-3 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref eta-3 1))) (vector 1 (string-append u--destdir e-8)))))) (lambda (eta-3) (CoreC-45Directory-libInstallDirectory arg-0 u--lib eta-3)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-4) (case (vector-ref eta-4 0) ((0) (let ((e-2 (vector-ref eta-4 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref eta-4 1))) (vector 1 (string-append u--destdir e-9)))))) (lambda (eta-4) (CoreC-45Directory-ttcInstallDirectory arg-0 u--lib eta-4)) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-5) (case (vector-ref eta-5 0) ((0) (let ((e-2 (vector-ref eta-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref eta-5 1))) (vector 1 (string-append u--destdir e-10)))))) (lambda (eta-5) (CoreC-45Directory-srcInstallDirectory arg-0 u--lib eta-5)) eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 ((IdrisC-45Package-runScript (let ((e-21 (vector-ref arg-2 21))) e-21)) eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((u--toInstall (PreludeC-45Types-maybe (lambda () (let ((e-12 (vector-ref arg-2 12))) e-12)) (lambda () (lambda (arg-5) (cons arg-5 (let ((e-12 (vector-ref arg-2 12))) e-12)))) (let ((e-13 (vector-ref arg-2 13))) e-13)))) (let ((act-8 (CoreC-45Context-getWorkingDir eta-5))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-9 (let ((act-9 (CoreC-45Directory-mkdirAll e-8 eta-6))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-13 0) ((1) (let ((act-10 ((CoreC-45Core-traverse_ (lambda (eta-7) (lambda (eta-8) (IdrisC-45Package-installFrom arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-12 e-6) e-9 (Builtin-fst eta-7) eta-8))) u--toInstall) clam-0))) (case (vector-ref act-10 0) ((0) (let ((e-3 (vector-ref act-10 1))) (vector 0 e-3))) (else (let ((act-11 (cond ((equal? arg-4 1) ((CoreC-45Core-traverse_ (lambda (eta-7) (IdrisC-45Package-installSrcFrom arg-0 e-12 e-10 eta-7)) u--toInstall) clam-0)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-11 0) ((0) (let ((e-3 (vector-ref act-11 1))) (vector 0 e-3))) (else (let ((u--pkgFile (LibrariesC-45UtilsC-45Path-C-60C-47C-62 e-8 (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (let ((e-0 (vector-ref arg-2 0))) e-0) "ipkg")))) (let ((act-12 (let ((act-12 (PreludeC-45IO-prim__putStr (string-append (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-7) eta-7) (cons "Installing package file for " (cons (let ((e-0 (vector-ref arg-2 0))) e-0) (cons " to " (cons e-8 '()))))) "\xa;") clam-0))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-3 (vector-ref act-12 1))) (vector 0 e-3))) (else (let ((u--pkgStr (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45String-renderString (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgDesc (IdrisC-45Package-n--21702-13640-u--savePkgMetadata arg-4 arg-3 arg-2 arg-1 arg-0 arg-2)))))) (let ((act-13 (CoreC-45ContextC-45Log-log arg-0 "package.depends" 25 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-7) eta-7) (cons "  package file:\xa;" (cons u--pkgStr '())))) clam-0))) (case (vector-ref act-13 0) ((0) (let ((e-3 (vector-ref act-13 1))) (vector 0 e-3))) (else (let ((act-14 ((let ((eff-0 (lambda (world-0) (let ((act-14 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--pkgFile u--pkgStr) world-0))) (vector 1 act-14))))) (lambda (eta-7) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-7))) clam-0))) (case (vector-ref act-14 0) ((0) (let ((e-3 (vector-ref act-14 1))) (vector 0 e-3))) (else ((IdrisC-45Package-runScript (let ((e-22 (vector-ref arg-2 22))) e-22)) clam-0))))))))))))))))))) (else (let ((e-14 (vector-ref e-13 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (DataC-45String-fastUnlines (cons (string-append "Can't make directory " e-8) (cons (SystemC-45FileC-45Error-u--show_Show_FileError e-14) '())))) clam-0))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) eff-0) eta-1))))))))) eff-0) eta-0)))))))) eff-0) ext-0))))))
(define IdrisC-45PackageC-45Types-cssFiles (cons (cons "Default" "default") (cons (cons "Alternative" "alternative") (cons (cons "Black & White" "blackandwhite") '()))))
(define IdrisC-45Pretty-prettyImport (lambda (arg-0) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "import")) (cond ((equal? e-1 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "public")))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "")))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2789 e-2) (let ((sc0 (CoreC-45NameC-45Namespace-u--C-47C-61_Eq_Namespace e-2 e-3))) (cond ((equal? sc0 1) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-space (IdrisC-45PrettyC-45Annotations-keyword (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-504 "as"))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-2757 e-3))) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "")))))))))))
(define IdrisC-45DocC-45HTML-htmlFooter (string-append "</div><footer>Produced by Idris 2 version " (string-append csegen-1994 "</footer></body></html>")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2545-u--isSafe (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\") 0) ((equal? arg-1 #\<) 0) ((equal? arg-1 #\>) 0) ((equal? arg-1 #\&) 0) ((equal? arg-1 #\') 0) ((equal? arg-1 (integer->char 9)) 1) ((equal? arg-1 (integer->char 10)) 1) ((equal? arg-1 (integer->char 13)) 1)(else (let ((sc0 (PreludeC-45EqOrd-u--C-62C-61_Ord_Char arg-1 #\ ))) (cond ((equal? sc0 1) (PreludeC-45EqOrd-u--C-60C-61_Ord_Char arg-1 #\~)) (else 0)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2544-u--htmlQuote (lambda (arg-0 arg-1) (cond ((equal? arg-1 #\") "&quot;") ((equal? arg-1 #\<) "&lt;") ((equal? arg-1 #\>) "&gt;") ((equal? arg-1 #\&) "&amp;") ((equal? arg-1 #\') "&apos;")(else (string-append "&#" (string-append (PreludeC-45Show-u--show_Show_Int (cast-char-boundedInt arg-1 63)) ";"))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-case--htmlEscapeC-44go-2642 (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (cond ((equal? e-3 "") (cons e-2 arg-2))(else (let ((u--c (string-ref e-3 0))) (let ((u--escaped (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2544-u--htmlQuote arg-0 u--c))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2543-u--go arg-0 (cons u--escaped (cons e-2 arg-2)) (substring e-3 1 (string-length e-3)))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2543-u--go (lambda (arg-0 arg-1 arg-2) (cond ((equal? arg-2 "") arg-1)(else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-case--htmlEscapeC-44go-2642 arg-0 arg-2 arg-1 (DataC-45String-span (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2545-u--isSafe arg-0 eta-0)) arg-2))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (lambda (arg-0) (PreludeC-45Types-fastConcat (PreludeC-45TypesC-45List-reverse (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-n--3710-2543-u--go arg-0 '() arg-0)))))
(define IdrisC-45DocC-45HTML-htmlPreamble (lambda (arg-0 arg-1 arg-2) (let ((u--title (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape arg-0))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "<!DOCTYPE html><html lang=\"en\">\xa;\xa;<head>\xa;  <meta charset=\"utf-8\">\xa;  <title>" (cons u--title (cons "</title>\xa;  <link rel=\"stylesheet\" type=\"text/css\" id=\"" (cons "preferredStyle" (cons "\" href=\"" (cons arg-1 (cons "default" (cons ".css\">\xa;  <script>\xa;    /* Updates the stylesheet to use the preferred one.\xa;       Note that we set the link to root ++ sourceLoc because the config\xa;       is shared across the whole website, so the root may differ from\xa;       page to page.\xa;    */\xa;    function setStyleSource (sourceLoc) {\xa;      document.getElementById(\"" (cons "preferredStyle" (cons "\").href = \"" (cons arg-1 (cons "\" + sourceLoc + \".css\";\xa;      document.getElementById(\"" (cons "selectPreferredStyle" (cons "\").value = sourceLoc;\xa;    }\xa;    /* Initialises the preferred style sheet:\xa;       1. if there is a stored value then use that\xa;          otherwise select the default\xa;       2. set both the css link href & the drop down menu selected option\xa;    */\xa;    function initStyleSource () {\xa;      var preferredStyle = localStorage.getItem(\"" (cons "stylefile" (cons "\");\xa;      if (preferredStyle !== null) {\xa;        setStyleSource(preferredStyle);\xa;      } else {\xa;        setStyleSource(\"" (cons "default" (cons "\");\xa;      };\xa;    }\xa;    function saveStyleSource (preferredStyle) {\xa;      localStorage." (cons "stylefile" (cons " = preferredStyle;\xa;    }\xa;    </script>\xa;</head>\xa;\xa;<body class=\"" (cons arg-2 (cons "\">\xa;<header>\xa;  <strong>Idris2Doc</strong> : " (cons u--title (cons "\xa;  <nav><a href=\"" (cons arg-1 (cons "index.html\">Index</a>\xa;\xa;  <select id=\"" (cons "selectPreferredStyle" (cons "\">\xa;    " (cons (DataC-45String-fastUnlines (PreludeC-45Basics-flip csegen-2819 IdrisC-45PackageC-45Types-cssFiles (lambda (u--css) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "<option value=\"" (cons (let ((e-1 (cdr u--css))) e-1) (cons "\">" (cons (let ((e-0 (car u--css))) e-0) (cons "</option>" '()))))))))) (cons "\xa;  </select>\xa;  </nav>\xa;\xa;  <script>\xa;  /* We start by initialising the style source */\xa;  initStyleSource();\xa;\xa;  /* This listens for changes on the drop down menu and updates the\xa;     css used for the current page when a selection is made.\xa;  */\xa;  document.getElementById(\"" (cons "selectPreferredStyle" (cons "\").addEventListener(\"change\", function(){\xa;    var selected = this.options[this.selectedIndex].value; /* the option chosen */\xa;    setStyleSource (selected);\xa;    saveStyleSource (selected);\xa;  });\xa;</script>\xa;\xa;</header>\xa;<div class=\"container\">" '()))))))))))))))))))))))))))))))))))))
(define IdrisC-45DocC-45HTML-n--9697-4694-u--moduleLink (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (string-append "<li><a class=\"code\" href=\"docs/" (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-2) (string-append ".html\">" (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-2) "</a></li>")))))))
(define IdrisC-45DocC-45HTML-renderDocIndex (lambda (arg-0) (PreludeC-45Types-fastConcat (PreludeC-45TypesC-45List-tailRecAppend (cons (IdrisC-45DocC-45HTML-htmlPreamble (let ((e-0 (vector-ref arg-0 0))) e-0) "" "index") (cons "<h1>Package " (cons (let ((e-0 (vector-ref arg-0 0))) e-0) (cons " - Namespaces</h1>" (cons "<ul class=\"names\">" '()))))) (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45DocC-45HTML-n--9697-4694-u--moduleLink arg-0 eta-0)) (let ((e-12 (vector-ref arg-0 12))) e-12)) (cons "</ul>" (cons IdrisC-45DocC-45HTML-htmlFooter '())))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--sdocToTreeParser-4148 (lambda (arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (if (null? e-3) (cons '() '()) (if (null? e-2) (if (null? e-3) (cons '() '()) (let ((e-11 (unbox e-3))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-11))) (let ((e-5 (unbox e-2))) (if (null? e-3) (cons (box (vector 4 arg-1 e-5)) '()) (let ((e-9 (unbox e-3))) (let ((sc4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-9))) (let ((e-6 (car sc4))) (let ((e-4 (cdr sc4))) (if (null? e-6) (cons (box (vector 4 arg-1 e-5)) e-4) (let ((e-7 (unbox e-6))) (cons (box (vector 5 (cons (vector 4 arg-1 e-5) (cons e-7 '())))) e-4)))))))))))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser (lambda (arg-1) (case (vector-ref arg-1 0) ((0) (cons (box (vector 0 )) '())) ((1) (let ((e-2 (vector-ref arg-1 1))) (let ((e-3 (vector-ref arg-1 2))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser (e-3)))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (if (null? e-5) (cons (box (vector 1 e-2)) e-4) (let ((e-6 (unbox e-5))) (cons (box (vector 5 (cons (vector 1 e-2) (cons e-6 '())))) e-4))))))))) ((2) (let ((e-5 (vector-ref arg-1 1))) (let ((e-6 (vector-ref arg-1 2))) (let ((e-7 (vector-ref arg-1 3))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser (e-7)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (if (null? e-2) (cons (box (vector 2 e-5 e-6)) e-3) (let ((e-8 (unbox e-2))) (cons (box (vector 5 (cons (vector 2 e-5 e-6) (cons e-8 '())))) e-3)))))))))) ((3) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (let ((sc1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-10))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (if (null? e-2) (cons (box (vector 3 e-9)) e-3) (let ((e-5 (unbox e-2))) (cons (box (vector 5 (cons (vector 3 e-9) (cons e-5 '())))) e-3))))))))) ((4) (let ((e-12 (vector-ref arg-1 1))) (let ((e-13 (vector-ref arg-1 2))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--sdocToTreeParser-4148 e-12 e-13 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser e-13))))) (else (let ((e-15 (vector-ref arg-1 1))) (cons '() (box e-15)))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--fromStreamC-44flatten-4368 (lambda (arg-1 arg-2 arg-3 arg-4) (case (vector-ref arg-4 0) ((5) (let ((e-1 (vector-ref arg-4 1))) (vector 5 (cons arg-2 e-1))))(else (vector 5 (cons arg-2 (cons arg-4 '())))))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4334-u--flatten (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((5) (let ((e-1 (vector-ref arg-2 1))) (if (null? e-1) arg-2 (let ((e-3 (car e-1))) (let ((e-4 (cdr e-1))) (if (null? e-4) arg-2 (let ((e-6 (car e-4))) (let ((e-7 (cdr e-4))) (case (vector-ref e-6 0) ((0) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4334-u--flatten arg-1 e-3) arg-2)) ((5) (let ((e-10 (vector-ref e-6 1))) (if (null? e-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-case--fromStreamC-44flatten-4368 arg-1 e-3 e-10 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4334-u--flatten arg-1 (vector 5 e-10))) arg-2)))(else arg-2))))))))))(else arg-2))))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4335-u--internalError (lambda (arg-1) (vector 2 (blodwen-toSignedInt (PreludeC-45TypesC-45String-length "<internal pretty printing error>") 63) "<internal pretty printing error>")))
(define LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-fromStream (lambda (arg-1) (let ((sc0 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-sdocToTreeParser arg-1))) (if (null? sc0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4335-u--internalError arg-1) (let ((e-2 (car sc0))) (let ((e-3 (cdr sc0))) (if (null? e-2) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4335-u--internalError arg-1) (let ((e-5 (unbox e-2))) (if (null? e-3) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4334-u--flatten arg-1 e-5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-n--4281-4335-u--internalError arg-1))))))))))
(define IdrisC-45DocC-45HTML-n--9382-4381-u--go (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) (case (vector-ref arg-1 0) ((3) arg-1)(else (case (vector-ref arg-1 0) ((5) (let ((e-1 (vector-ref arg-1 1))) (vector 5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45DocC-45HTML-n--9382-4381-u--go arg-0 eta-0)) e-1)))) ((4) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((2) (vector 4 (vector 2 ) (IdrisC-45DocC-45HTML-n--9382-4381-u--go 1 e-4)))(else (vector 4 e-3 (IdrisC-45DocC-45HTML-n--9382-4381-u--go 0 e-4)))))))(else arg-1))))) ((equal? arg-0 1) (case (vector-ref arg-1 0) ((3) (vector 0 ))(else (case (vector-ref arg-1 0) ((5) (let ((e-1 (vector-ref arg-1 1))) (vector 5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45DocC-45HTML-n--9382-4381-u--go arg-0 eta-0)) e-1)))) ((4) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((2) (vector 4 (vector 2 ) (IdrisC-45DocC-45HTML-n--9382-4381-u--go 1 e-4)))(else (vector 4 e-3 (IdrisC-45DocC-45HTML-n--9382-4381-u--go 0 e-4)))))))(else arg-1)))))(else (case (vector-ref arg-1 0) ((5) (let ((e-1 (vector-ref arg-1 1))) (vector 5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45DocC-45HTML-n--9382-4381-u--go arg-0 eta-0)) e-1)))) ((4) (let ((e-3 (vector-ref arg-1 1))) (let ((e-4 (vector-ref arg-1 2))) (case (vector-ref e-3 0) ((2) (vector 4 (vector 2 ) (IdrisC-45DocC-45HTML-n--9382-4381-u--go 1 e-4)))(else (vector 4 e-3 (IdrisC-45DocC-45HTML-n--9382-4381-u--go 0 e-4)))))))(else arg-1))))))
(define IdrisC-45DocC-45HTML-removeNewlinesFromDeclarations (lambda (ext-0) (IdrisC-45DocC-45HTML-n--9382-4381-u--go 0 ext-0)))
(define IdrisC-45DocC-45HTML-getNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-0)))(else ""))))
(define IdrisC-45DocC-45HTML-packageInternal (lambda (arg-0 arg-1 ext-0) (case (vector-ref arg-1 0) ((0) (let ((e-0 (vector-ref arg-1 1))) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (vector 1 1)))) (lambda (eta-1) (CoreC-45Directory-nsToSource arg-0 CoreC-45FC-emptyFC e-0 eta-1)) eta-0)) (lambda (_-3924) (lambda (eta-0) (vector 1 0))) ext-0)))(else (vector 1 0)))))
(define IdrisC-45DocC-45HTML-hasNS (lambda (arg-0) (case (vector-ref arg-0 0) ((0) 1)(else 0))))
(define IdrisC-45DocC-45HTML-with--tryCanonicalName-3836 (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (cond ((equal? arg-1 1) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName arg-0 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (vector 1 '())) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (vector 1 '())) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-0) (if (null? e-7) (vector 1 '()) (if (null? e-2) (vector 1 (box e-8)) (vector 1 '())))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))) (else (vector 1 '())))))
(define IdrisC-45DocC-45HTML-tryCanonicalName (lambda (arg-0 arg-1 arg-2) (lambda (eta-0) (IdrisC-45DocC-45HTML-with--tryCanonicalName-3836 arg-2 (IdrisC-45DocC-45HTML-hasNS arg-2) arg-1 arg-0 eta-0))))
(define IdrisC-45DocC-45HTML-addLink (lambda (arg-0 arg-1 arg-2 ext-0) (if (null? arg-1) (vector 1 arg-2) (let ((e-2 (unbox arg-1))) (let ((act-1 ((IdrisC-45DocC-45HTML-tryCanonicalName arg-0 CoreC-45FC-emptyFC e-2) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 (string-append (string-append "<span class=\"implicit\">" arg-2) "</span>")) (let ((e-1 (unbox e-5))) (let ((act-2 (IdrisC-45DocC-45HTML-packageInternal arg-0 e-1 clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-6 1) (vector 1 (PreludeC-45Types-fastConcat (cons "<a class=\"type\" href=\"" (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (IdrisC-45DocC-45HTML-getNS e-1)) (cons ".html#" (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (CoreC-45Name-u--show_Show_Name e-1)) (cons "\">" (cons arg-2 (cons "</a>" '())))))))))) (else (vector 1 (PreludeC-45Types-fastConcat (cons "<span class=\"type resolved\" title=\"" (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (CoreC-45Name-u--show_Show_Name e-1)) (cons "\">" (cons arg-2 (cons "</span>" '())))))))))))) eff-0) clam-1)))))))))) eff-0) ext-0)))))))))
(define IdrisC-45DocC-45HTML-renderHtml (lambda (arg-0 arg-1) (case (vector-ref arg-1 0) ((0) (lambda (eta-0) (vector 1 ""))) ((1) (let ((e-2 (vector-ref arg-1 1))) (lambda (clam-0) (cond ((equal? e-2 #\ ) (vector 1 "&ensp;"))(else (vector 1 (string e-2))))))) ((2) (let ((e-5 (vector-ref arg-1 2))) (lambda (eta-0) (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape e-5))))) ((3) (lambda (eta-0) (vector 1 "<br>"))) ((4) (let ((e-9 (vector-ref arg-1 1))) (let ((e-10 (vector-ref arg-1 2))) (lambda (clam-0) (case (vector-ref e-9 0) ((2) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (string-append "<dl class=\"decls\">" e-5) "</dl>"))))) eff-0) clam-0)))))) ((3) (let ((e-13 (vector-ref e-9 1))) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append "<dt id=\"" (string-append (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape (CoreC-45Name-u--show_Show_Name e-13)) (string-append (string-append "\"><code>" e-5) "</code></dt>"))))))) eff-0) clam-0))))))) ((4) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (string-append "<dd>" e-5) "</dd>"))))) eff-0) clam-0)))))) ((5) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (string-append "<pre>" e-5) "</pre>"))))) eff-0) clam-0)))))) ((6) (let ((e-14 (vector-ref e-9 1))) (case (vector-ref e-14 0) ((2) (let ((e-15 (vector-ref e-14 1))) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45DocC-45HTML-addLink arg-0 e-15 (string-append (string-append "<span class=\"name constructor\">" e-5) "</span>") eta-0)))) eff-0) clam-0))))))) ((1) (let ((e-16 (vector-ref e-14 1))) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45DocC-45HTML-addLink arg-0 e-16 (string-append (string-append "<span class=\"name type\">" e-5) "</span>") eta-0)))) eff-0) clam-0))))))) ((3) (let ((e-17 (vector-ref e-14 1))) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (IdrisC-45DocC-45HTML-addLink arg-0 (box e-17) (string-append (string-append "<span class=\"name function\">" e-5) "</span>") eta-0)))) eff-0) clam-0))))))) ((5) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (string-append "<span class=\"keyword\">" e-5) "</span>"))))) eff-0) clam-0)))))) ((4) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (string-append "<span class=\"boundvar\">" e-5) "</span>"))))) eff-0) clam-0))))))(else (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append "<!-- ann ignored START -->" (string-append e-5 "<!-- ann END -->")))))) eff-0) clam-0))))))))) ((0) (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append (string-append "<b>" e-5) "</b>"))))) eff-0) clam-0))))))(else (let ((act-1 ((IdrisC-45DocC-45HTML-renderHtml arg-0 e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (string-append "<!-- ann ignored START -->" (string-append e-5 "<!-- ann END -->")))))) eff-0) clam-0))))))))))) (else (let ((e-12 (vector-ref arg-1 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45DocC-45HTML-renderHtml arg-0 eta-1)) e-12 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45Types-fastConcat e-5))))) eff-0) eta-0)))))))))))
(define IdrisC-45DocC-45HTML-docDocToHtml (lambda (arg-0 arg-1) (let ((u--dt (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45SimpleDocTree-fromStream (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-layoutUnbounded arg-1)))) (IdrisC-45DocC-45HTML-renderHtml arg-0 (IdrisC-45DocC-45HTML-removeNewlinesFromDeclarations u--dt)))))
(define IdrisC-45DocC-45HTML-preserveLayout (lambda (arg-0) (string-append "<pre>" (string-append arg-0 "</pre>"))))
(define IdrisC-45DocC-45HTML-renderModuleDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((u--mdoc (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-0) (IdrisC-45DocC-45HTML-preserveLayout (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45RenderC-45HTML-htmlEscape eta-0)))) arg-2))) (let ((u--mexp (PreludeC-45Types-maybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "")) (lambda () (lambda (eta-0) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat eta-0))) arg-3))) (lambda (eta-0) (let ((act-1 ((IdrisC-45DocC-45HTML-docDocToHtml arg-0 u--mexp) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-2 ((IdrisC-45DocC-45HTML-docDocToHtml arg-0 (DataC-45Maybe-fromMaybe (lambda () (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "")) arg-4)) eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (PreludeC-45Types-fastConcat (cons (IdrisC-45DocC-45HTML-htmlPreamble (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1) "../" "namespace") (cons "<div id=\"module-header\">" (cons "<h1>" (cons (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-1) (cons "</h1>" (cons u--mdoc (cons "</div>" (cons (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-3) "<h2>Reexports</h2>")) arg-3) (cons "<code>" (cons e-5 (cons "</code>" (cons (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-3) "<h2>Definitions</h2>")) arg-4) (cons e-6 (cons IdrisC-45DocC-45HTML-htmlFooter '()))))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))))
(define IdrisC-45DocC-45String-shortNamesConfig (vector 1 0 0 1))
(define IdrisC-45Package-n--22181-14093-u--fileError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (vector 1 (cons (vector 51 arg-5 arg-6) '()))))
(define CoreC-45FC-origin (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) e-2))))
(define IdrisC-45Package-n--22181-14094-u--visible (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (let ((e-18 (vector-ref arg-5 18))) (case (vector-ref e-18 0) ((5) 0)(else (CoreC-45TT-u--C-47C-61_Eq_Visibility (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-36 (vector-ref arg-5 9))) e-36)) 0))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-14691 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22) (case (vector-ref arg-22 0) ((0) (let ((e-0 (vector-ref arg-22 1))) (lambda (clam-0) (let ((sc1 (CoreC-45NameC-45Namespace-u--C-61C-61_Eq_ModuleIdent arg-12 e-0))) (cond ((equal? sc1 1) (let ((sc2 (IdrisC-45Package-n--22181-14094-u--visible arg-0 arg-1 arg-2 arg-3 arg-4 arg-19))) (cond ((equal? sc2 1) (vector 1 (box arg-19)))(else (vector 1 '())))))(else (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "doc.module.definitions" 60 (lambda () (DataC-45String-unwords (cons (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-12) ":") (cons (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-19 1))) e-1)) (cons "was defined in" (cons (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-0) '())))))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 '()))))))))))(else (lambda (eta-0) (vector 1 '()))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-14641 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21) (if (null? arg-21) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-4 "doc.module.definitions" 70 (lambda () (DataC-45String-unwords (cons (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent arg-12) ":") (cons (CoreC-45Name-u--show_Show_Name (let ((e-1 (vector-ref arg-19 1))) e-1)) (cons "has an empty FC" '()))))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 '()))))) (let ((e-1 (unbox arg-21))) (IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-14691 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 e-1 (CoreC-45FC-origin e-1))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-15532 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 ext-0) (if (null? arg-15) (let ((act-1 ((IdrisC-45Package-runScript (let ((e-20 (vector-ref arg-1 20))) e-20)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 '())))) (vector 1 arg-15))))
(define IdrisC-45Package-makeDoc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (IdrisC-45Package-prepareCompilation arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-5) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--build (let ((e-4 (vector-ref e-6 4))) (let ((e-44 (vector-ref e-4 0))) (let ((e-52 (vector-ref e-44 2))) e-52))))) (let ((u--docBase (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--build "docs"))) (let ((u--docDir (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "docs"))) (lambda (eta-0) (let ((act-3 (let ((act-3 (CoreC-45Directory-mkdirAll u--docDir eta-0))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((_-0 '())) (lambda (clam-1) (case (vector-ref e-7 0) ((1) (let ((act-4 (csegen-1985 clam-1))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 ((CoreC-45Context-setPPrint arg-0 (vector 0 1 0 0)) eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((act-6 (PreludeC-45IO-u--map_Functor_IO csegen-2832 (PreludeC-45Basics-flip csegen-1298 (let ((e-12 (vector-ref arg-3 12))) e-12) (lambda (lamc-0) (let ((_-1 (vector 1 (vector 0 )))) (lambda (clam-2) (let ((e-4 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((act-6 (IdrisC-45ProcessIdr-addImport arg-0 e-8 arg-1 (vector CoreC-45FC-emptyFC 0 e-4 e-4) clam-2))) (case (vector-ref act-6 0) ((0) (let ((e-10 (vector-ref act-6 1))) (vector 0 e-10))) (else (let ((act-7 (let ((act-7 (unbox arg-0))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-11 (vector-ref act-7 1))) (vector 0 e-11))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((u--ctxt (let ((e-0 (vector-ref e-11 0))) e-0))) (lambda (eta-2) (let ((act-8 (PreludeC-45IO-u--map_Functor_IO csegen-55 (PreludeC-45Basics-flip csegen-1298 (PreludeC-45Types-u--rangeFromTo_Range_C-36a csegen-235 1 (bs- (let ((e-1 (vector-ref u--ctxt 1))) e-1) 1 63)) (lambda (u--i) (lambda (eta-3) (let ((act-8 ((CoreC-45Context-lookupCtxtExact (vector 8 u--i) u--ctxt) eta-3))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((lamc-1 (cons e-4 e-3))) (if (null? e-12) (lambda (eta-4) (vector 1 '())) (let ((e-1 (unbox e-12))) (let ((_-2 (box e-1))) (IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-14641 arg-4 arg-3 arg-2 arg-1 arg-0 _-0 e-6 u--build u--docBase u--docDir _-1 e-8 e-4 e-3 lamc-1 e-4 e-11 u--ctxt u--i e-1 _-2 (CoreC-45FC-isNonEmptyFC (let ((e-0 (vector-ref e-1 0))) e-0))))))))) eff-0) eta-3)))))))) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-12 (vector-ref act-8 1))) (vector 0 e-12))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((u--outputFilePath (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docDir (string-append (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-4) ".html")))) (lambda (eta-3) (let ((act-9 ((PreludeC-45Basics-flip csegen-1298 (DataC-45List-sortBy (lambda (eta-4) (lambda (eta-5) (PreludeC-45Basics-on (lambda (eta-6) (lambda (eta-7) (PreludeC-45EqOrd-u--compare_Ord_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-231 csegen-231 eta-6 eta-7))) (lambda (eta-6) (CoreC-45FC-startPos (CoreC-45FC-toNonEmptyFC (let ((e-0 (vector-ref eta-6 0))) e-0)))) eta-4 eta-5))) e-12) (lambda (u--def) (lambda (eta-4) (IdrisC-45DocC-45String-getDocsForName arg-2 arg-0 arg-1 CoreC-45FC-emptyFC (let ((e-1 (vector-ref u--def 1))) e-1) IdrisC-45DocC-45String-shortNamesConfig eta-4)))) eta-3))) (case (vector-ref act-9 0) ((0) (let ((e-13 (vector-ref act-9 1))) (vector 0 e-13))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (let ((u--allDecls (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-annotate (vector 2 ) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat e-13)))) (lambda (eta-4) (let ((act-10 (let ((act-10 (unbox arg-1))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-14 (vector-ref act-10 1))) (vector 0 e-14))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (let ((u--modDoc (LibrariesC-45DataC-45SortedMap-lookup e-4 (let ((e-24 (vector-ref e-14 2))) e-24)))) (lambda (eta-5) (let ((act-11 (CoreC-45ContextC-45Log-log arg-0 "doc.module" 10 (lambda () (DataC-45String-unwords (cons "Looked up doc for" (cons (CoreC-45NameC-45Namespace-u--show_Show_ModuleIdent e-4) (cons "and got:" (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-493 u--modDoc) '())))))) eta-5))) (case (vector-ref act-11 0) ((0) (let ((e-15 (vector-ref act-11 1))) (vector 0 e-15))) (else (let ((act-12 (CoreC-45ContextC-45Log-log arg-0 "doc.module" 100 (lambda () (string-append "from: " (LibrariesC-45DataC-45SortedMap-u--show_Show_C-40C-40SortedMapC-32C-36kC-41C-32C-36vC-41 csegen-3969 (let ((e-25 (vector-ref e-14 2))) e-25)))) eta-5))) (case (vector-ref act-12 0) ((0) (let ((e-16 (vector-ref act-12 1))) (vector 0 e-16))) (else (let ((u--mreexports (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (LibrariesC-45DataC-45SortedMap-lookup e-4 (let ((e-25 (vector-ref e-14 3))) e-25)) (lambda (u--docs) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (let ((sc15 (PreludeC-45Types-u--null_Foldable_List u--docs))) (cond ((equal? sc15 1) 0) (else 1)))) (lambda (_-10649) (box u--docs))))))) (let ((act-13 (if (null? u--mreexports) (vector 1 (vector 0 )) (let ((e-1 (unbox u--mreexports))) (CoreC-45ContextC-45Log-log arg-0 "doc.module" 15 (lambda () (DataC-45String-unwords (cons "All imported:" (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-4110 e-1) '())))) eta-5))))) (case (vector-ref act-13 0) ((0) (let ((e-17 (vector-ref act-13 1))) (vector 0 e-17))) (else (let ((u--modExports (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-6) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-7) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-reAnnotate (lambda (eta-8) (vector 6 eta-8)) (IdrisC-45Pretty-prettyImport eta-7))) eta-6)) u--mreexports))) (let ((act-14 (let ((act-14 ((IdrisC-45DocC-45HTML-renderModuleDoc arg-0 e-4 u--modDoc u--modExports (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-6) u--allDecls) (PreludeC-45Interfaces-guard csegen-258 (let ((sc16 (PreludeC-45Types-u--null_Foldable_List e-13))) (cond ((equal? sc16 1) 0) (else 1)))))) eta-5))) (case (vector-ref act-14 0) ((0) (let ((e-18 (vector-ref act-14 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-15 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--outputFilePath e-18) eta-6))) (vector 1 act-15))))) eff-0) eta-5))))))) (case (vector-ref act-14 0) ((0) (let ((e-18 (vector-ref act-14 1))) (vector 0 e-18))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (clam-3) (case (vector-ref e-18 0) ((1) (vector 1 '())) (else (let ((e-19 (vector-ref e-18 1))) (IdrisC-45Package-n--22181-14093-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "index.html") e-19 clam-3))))))) eff-0) eta-5)))))))))))))))))))) eff-0) eta-4))))))))) eff-0) eta-3))))))))) eff-0) eta-2))))))))) eff-0) clam-2)))))))))))))) eta-1))) (case (vector-ref act-6 0) ((0) (let ((e-3 (vector-ref act-6 1))) (vector 0 e-3))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (let ((_-1 (vector 1 (vector 0 )))) (lambda (clam-2) (if (null? e-10) (let ((act-7 (let ((act-7 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "index.html") (IdrisC-45DocC-45HTML-renderDocIndex arg-3)) clam-2))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-3 (vector-ref act-7 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (let ((_-2 '())) (lambda (clam-3) (case (vector-ref e-11 0) ((1) (let ((act-8 ((PreludeC-45Basics-flip csegen-1298 IdrisC-45PackageC-45Types-cssFiles (lambda (u--cssFile) (let ((u--fn (string-append (let ((e-1 (cdr u--cssFile))) e-1) ".css"))) (lambda (eta-2) (let ((act-8 (CoreC-45Directory-readDataFile arg-0 (string-append "docs/" u--fn) eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-9 (let ((act-9 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase u--fn) e-12) eta-3))) (vector 1 act-9)))) (case (vector-ref act-9 0) ((0) (let ((e-4 (vector-ref act-9 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (clam-4) (case (vector-ref e-13 0) ((1) (vector 1 '())) (else (let ((e-14 (vector-ref e-13 1))) (IdrisC-45Package-n--22181-14093-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase u--fn) e-14 clam-4))))))) eff-0) eta-3)))))))) eff-0) eta-2))))))))) clam-3))) (case (vector-ref act-8 0) ((0) (let ((e-4 (vector-ref act-8 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (let ((_-3 (vector 1 (vector 0 )))) (lambda (eta-2) (IdrisC-45Package-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32makeDoc-15532 arg-4 arg-3 arg-2 arg-1 arg-0 _-0 e-6 u--build u--docBase u--docDir _-1 e-8 _-2 _-3 e-12 (PreludeC-45Types-u--foldMap_Foldable_List csegen-57 (lambda (eta-3) eta-3) e-12) eta-2))))) eff-0) clam-3)))))) (else (let ((e-12 (vector-ref e-11 1))) (IdrisC-45Package-n--22181-14093-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--docBase "index.html") e-12 clam-3)))))))) eff-0) clam-2))))) (vector 1 e-10)))))) eff-0) eta-1))))))))))) eff-0) clam-1)))))) (else (let ((e-8 (vector-ref e-7 1))) (IdrisC-45Package-n--22181-14093-u--fileError arg-4 arg-3 arg-2 arg-1 arg-0 u--docDir e-8 clam-1)))))))) eff-0) eta-0))))))))))) eff-0) clam-0))))) (vector 1 e-5))))) eff-0) ext-0)))))))
(define IdrisC-45REPL-handleResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (case (vector-ref arg-5 0) ((27) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Bye for now!") ext-0))(else (let ((act-1 ((IdrisC-45REPL-displayResult arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (IdrisC-45REPL-repl arg-0 arg-1 arg-2 arg-3 arg-4 ext-0))))))))
(define IdrisC-45REPL-n--35205-18093-u--prompt (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (cond ((equal? arg-5 0) "[tc] ") ((equal? arg-5 1) "") ((equal? arg-5 2) "[exec] ") (else "[scheme] "))))
(define IdrisC-45REPL-repl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (CoreC-45Context-getNS arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-4))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (IdrisC-45REPL-n--35205-18093-u--prompt arg-4 arg-3 arg-2 arg-1 arg-0 (let ((e-1 (vector-ref e-6 1))) e-1)) (string-append (CoreC-45NameC-45Namespace-u--show_Show_Namespace e-5) "> ")) world-0))) (vector 1 act-3))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((let ((eff-0 (lambda (world-0) (let ((act-4 (csegen-3886 world-0))) (vector 1 act-4))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((act-5 (let ((act-5 (PreludeC-45IO-prim__getStr eta-1))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 (let ((act-6 ((SystemC-45FileC-45ReadWrite-fEOF csegen-82 SystemC-45FileC-45Virtual-stdin) eta-2))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-10 1) (let ((act-7 ((let ((eff-0 (lambda (world-0) (let ((act-7 (PreludeC-45IO-prim__putStr "\xa;" world-0))) (vector 1 act-7))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-3))) clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "Bye for now!") clam-0))))) (else (let ((act-7 (IdrisC-45REPL-interpret arg-0 arg-1 arg-2 arg-3 arg-4 e-9 clam-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-3) (IdrisC-45REPL-handleResult arg-0 arg-1 arg-2 arg-3 arg-4 e-11 eta-3)))) eff-0) clam-0)))))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Package-runRepl (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (csegen-1985 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-1) (vector 1 (vector 2 (vector 0 ))))) (lambda () (lambda (u--fname) (lambda (eta-1) (let ((act-2 (CoreC-45Directory-ctxtPathToNS arg-0 u--fname eta-1))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-2) (vector 1 (vector 0 e-6))))) eff-0) eta-1)))))))) arg-3) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata e-6)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (if (null? arg-3) (vector 1 (vector 0 )) (let ((e-2 (unbox arg-3))) (let ((act-4 (IdrisC-45REPL-loadMainFile arg-0 e-5 arg-1 e-7 arg-2 e-2 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (IdrisC-45REPL-displayErrors arg-0 e-5 arg-1 e-7 arg-2 e-8 eta-3)))) eff-0) eta-2))))))))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (IdrisC-45REPL-repl arg-0 e-5 arg-1 e-7 arg-2 eta-2))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Package-case--caseC-32blockC-32inC-32processPackage-16687 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (if (null? arg-7) (lambda (eta-0) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Tried to split empty string") eta-0)) (let ((e-1 (unbox arg-7))) (lambda (clam-0) (if (null? e-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 "Tried to split empty string") clam-0) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (let ((sc2 (DataC-45String-isSuffixOf ".ipkg" e-5))) (cond ((equal? sc2 1) (let ((act-1 (CoreC-45Context-setWorkingDir arg-5 e-4 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (IdrisC-45Package-parsePkgFile arg-5 arg-4 arg-3 1 e-5 clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (let ((e-17 (vector-ref e-7 17))) (if (null? e-17) (vector 1 (vector 0 )) (let ((e-30 (unbox e-17))) ((CoreC-45Context-setBuildDir arg-5 e-30) eta-0)))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 ((CoreC-45Context-setOutputDir arg-5 (let ((e-18 (vector-ref e-7 18))) e-18)) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (cond ((equal? arg-0 0) (let ((act-5 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-7 arg-2 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-10) (vector 1 (vector 0 )) (let ((act-6 (csegen-1969 clam-1))) (vector 1 act-6)))))) eff-0) eta-0)))))) ((equal? arg-0 3) (let ((act-5 (IdrisC-45Package-makeDoc arg-5 arg-4 arg-3 e-7 arg-2 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-10) (vector 1 (vector 0 )) (let ((act-6 (csegen-1969 clam-2))) (vector 1 act-6)))))) eff-0) eta-0)))))) ((equal? arg-0 1) (let ((act-5 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-7 arg-2 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-10) (IdrisC-45Package-install arg-5 arg-3 e-7 arg-2 0 clam-1) (let ((act-6 (csegen-1969 clam-1))) (vector 1 act-6)))))) eff-0) eta-0)))))) ((equal? arg-0 2) (let ((act-5 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-7 arg-2 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-10) (IdrisC-45Package-install arg-5 arg-3 e-7 arg-2 1 clam-2) (let ((act-6 (csegen-1969 clam-2))) (vector 1 act-6)))))) eff-0) eta-0)))))) ((equal? arg-0 4) (let ((act-5 (IdrisC-45Package-check arg-5 arg-4 arg-3 e-7 arg-2 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-10) (vector 1 (vector 0 )) (let ((act-6 (csegen-1969 clam-3))) (vector 1 act-6)))))) eff-0) eta-0)))))) ((equal? arg-0 5) (IdrisC-45Package-clean arg-5 arg-3 e-7 arg-2 eta-0)) ((equal? arg-0 6) (let ((act-5 (IdrisC-45Package-build arg-5 arg-4 arg-3 e-7 arg-2 eta-0))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-3) (if (null? e-10) (IdrisC-45Package-runRepl arg-5 arg-4 arg-3 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (Builtin-snd eta-1)) (let ((e-13 (vector-ref e-7 13))) e-13)) clam-3) (let ((act-6 (csegen-1969 clam-3))) (vector 1 act-6)))))) eff-0) eta-0)))))) (else (vector 1 (vector 0 ))))))))))))) eff-0) clam-0)))))))))(else (let ((act-1 (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (string-append "Packages must have an '.ipkg' extension: " (string-append (PreludeC-45Show-u--show_Show_String arg-6) ".")) "\xa;") clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (csegen-1969 clam-0))) (vector 1 act-2))))))))))))))))
(define IdrisC-45Package-processPackage (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (CoreC-45Context-withCtxt arg-0 (IdrisC-45Syntax-withSyn arg-1 (IdrisC-45REPLC-45Opts-withROpts arg-2 (lambda (clam-0) (cond ((equal? e-2 7) (let ((act-1 (let ((act-1 (IdrisC-45PackageC-45Init-interactive clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fp (DataC-45Maybe-fromMaybe (lambda () (string-append (let ((e-0 (vector-ref e-5 0))) e-0) ".ipkg")) e-3))) (lambda (eta-0) (let ((act-2 (let ((act-2 (CompilerC-45Common-exists u--fp eta-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-6 0) (let ((act-3 (let ((act-3 ((SystemC-45FileC-45ReadWrite-writeFile csegen-82 u--fp (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--show_Show_C-40DocC-32C-36annC-41 (IdrisC-45PackageC-45Types-u--pretty_Pretty_Void_PkgDesc e-5))) clam-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-2) (case (vector-ref e-7 0) ((1) (vector 1 (vector 0 ))) (else (let ((e-8 (vector-ref e-7 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 51 u--fp e-8) clam-2))))))) eff-0) clam-1))))))(else (CoreC-45Core-u--throw_Catchable_Core_Error (vector 49 CoreC-45FC-emptyFC (string-append "File " (string-append u--fp " already exists"))) clam-1)))))) eff-0) eta-0))))))))) eff-0) clam-0))))))(else (let ((act-1 (IdrisC-45Package-localPackageFile e-3 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45Package-case--caseC-32blockC-32inC-32processPackage-16687 e-2 e-3 arg-3 arg-2 arg-1 arg-0 e-5 (LibrariesC-45UtilsC-45Path-splitParent e-5)))) eff-0) clam-0)))))))))))))))
(define IdrisC-45Package-processPackageOpts (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (vector 1 (IdrisC-45Package-partitionOpts arg-3)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (if (null? e-0) (vector 1 0) (let ((e-4 (car e-0))) (let ((e-6 (cdr e-0))) (let ((act-2 (let ((u--cmds (cons e-4 e-6))) (cond ((equal? e-2 1) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append IdrisC-45Package-errorMsg "\xa;") clam-0))) (vector 1 act-2))) (else ((CoreC-45Core-traverse_ (lambda (eta-0) (IdrisC-45Package-processPackage arg-0 arg-1 arg-2 e-1 eta-0)) u--cmds) clam-0)))))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (vector 1 1))))))))))))) eff-0) ext-0)))))))
(define IdrisC-45ProcessIdr-readPrelude (lambda (arg-0 arg-1 arg-2 arg-3 ext-0) (let ((act-1 (IdrisC-45ProcessIdr-readImport arg-0 arg-1 arg-2 arg-3 IdrisC-45ProcessIdr-prelude ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((CoreC-45Context-setNS arg-0 CoreC-45NameC-45Namespace-mainNS) ext-0))))))
(define IdrisC-45REPLC-45Opts-getOutput (lambda (arg-0 ext-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-2 (vector-ref eta-0 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-0 1))) (vector 1 (let ((e-8 (vector-ref e-5 8))) e-8)))))) (lambda (eta-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))) ext-0)))
(define IdrisC-45IDEModeC-45REPL-getFLine (lambda (arg-0 ext-0) (let ((act-1 ((SystemC-45FileC-45ReadWrite-fGetLine csegen-82 arg-0) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) e-2)) (else (let ((act-2 (PreludeC-45IO-prim__putStr "Failed to read a line\xa;" ext-0))) (csegen-1969 ext-0)))))))
(define SystemC-45FileC-45ReadWrite-fGetChar (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (SystemC-45FileC-45ReadWrite-prim__readChar arg-2 eta-0))))) (lambda (u--c) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (SystemC-45FileC-45Error-fileError arg-1 arg-2)) (lambda (u--ferr) (cond ((equal? u--ferr 1) (SystemC-45FileC-45Error-returnError arg-1)) (else (SystemC-45FileC-45Support-ok arg-1 (cast-int-char u--c))))))))))))))
(define IdrisC-45IDEModeC-45REPL-getChar (lambda (arg-0 ext-0) (let ((act-1 ((SystemC-45FileC-45ReadWrite-fEOF csegen-82 arg-0) ext-0))) (cond ((equal? act-1 1) (let ((act-2 (PreludeC-45IO-prim__putStr "Alas the file is done, aborting\xa;" ext-0))) (csegen-1969 ext-0))) (else (let ((act-2 ((SystemC-45FileC-45ReadWrite-fGetChar csegen-82 arg-0) ext-0))) (case (vector-ref act-2 0) ((1) (let ((e-2 (vector-ref act-2 1))) e-2)) (else (let ((act-3 (PreludeC-45IO-prim__putStr "Failed to read a character\xa;" ext-0))) (csegen-1969 ext-0))))))))))
(define IdrisC-45IDEModeC-45REPL-getNChars (lambda (arg-0 arg-1) (cond ((equal? arg-1 0) (lambda (eta-0) '()))(else (let ((e-0 (- arg-1 1))) (lambda (world-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-getChar arg-0 world-0))) (let ((act-2 ((IdrisC-45IDEModeC-45REPL-getNChars arg-0 e-0) world-0))) (cons act-1 act-2)))))))))
(define IdrisC-45IDEModeC-45REPL-getInput (lambda (arg-0 ext-0) (let ((act-1 ((IdrisC-45IDEModeC-45REPL-getNChars arg-0 6) ext-0))) (let ((sc0 (ProtocolC-45Hex-fromHexChars (PreludeC-45TypesC-45List-reverse act-1)))) (if (null? sc0) (let ((act-2 (IdrisC-45IDEModeC-45REPL-getFLine arg-0 ext-0))) (cons '() (string-append (PreludeC-45Types-fastPack act-1) act-2))) (let ((e-2 (unbox sc0))) (let ((act-2 ((IdrisC-45IDEModeC-45REPL-getNChars arg-0 (PreludeC-45Types-prim__integerToNat e-2)) ext-0))) (cons (box (PreludeC-45Types-fastPack act-1)) (PreludeC-45Types-fastPack act-2)))))))))
(define ProtocolC-45SExpC-45Parser-n--5056-4557-u--isEOI (lambda (arg-0) (case (vector-ref arg-0 0) ((7) 1)(else 0))))
(define ProtocolC-45SExpC-45Parser-eoi (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 (lambda (eta-0) (vector 0 )) (vector 2 "Expected end of input" (lambda (eta-0) (ProtocolC-45SExpC-45Parser-n--5056-4557-u--isEOI eta-0)))))
(define ProtocolC-45SExpC-45Parser-stringTokens (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-someUntil (LibrariesC-45TextC-45Lexer-is #\") csegen-647) (lambda (eta-0) (vector 0 eta-0))))
(define ProtocolC-45SExpC-45Parser-symbols (cons "(" (cons ":" (cons ")" '()))))
(define ProtocolC-45SExpC-45Parser-ideTokens (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-choice 1 csegen-14 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (LibrariesC-45TextC-45Lexer-exact eta-0)) ProtocolC-45SExpC-45Parser-symbols)) (lambda (eta-0) (vector 2 eta-0))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match LibrariesC-45TextC-45Lexer-digits (lambda (eta-0) (vector 1 (cast-string-int eta-0)))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-compose (LibrariesC-45TextC-45Lexer-is #\") (lambda (eta-0) (vector 4 0)) (lambda (eta-0) (vector 0 )) (lambda () (lambda (eta-0) ProtocolC-45SExpC-45Parser-stringTokens)) (lambda (eta-0) (LibrariesC-45TextC-45Lexer-is #\")) (lambda (eta-0) (vector 5 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-C-60C-124C-62 (LibrariesC-45TextC-45LexerC-45Tokenizer-match (LibrariesC-45TextC-45Lexer-some csegen-649) (lambda (eta-0) (vector 6 ))) (lambda () (LibrariesC-45TextC-45LexerC-45Tokenizer-match ParserC-45LexerC-45Common-identAllowDashes (lambda (eta-0) (vector 3 eta-0))))))))))))
(define LibrariesC-45TextC-45LexerC-45Tokenizer-lex (lambda (arg-1 arg-2) (LibrariesC-45TextC-45LexerC-45Tokenizer-lexTo (LibrariesC-45TextC-45LexerC-45Core-pred (lambda (eta-0) 0)) arg-1 arg-2)))
(define ProtocolC-45SExpC-45Parser-notWhitespace (lambda (arg-0) (let ((e-1 (vector-ref arg-0 0))) (case (vector-ref e-1 0) ((6) 0)(else 1)))))
(define ProtocolC-45SExpC-45Parser-case--idelex-4466 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (vector 0 e-3) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (case (vector-ref e-6 0) ((0) (if (null? e-7) (vector 0 e-3) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (if (null? e-11) (vector 0 e-3) (let ((e-14 (car e-11))) (vector 1 (PreludeC-45TypesC-45List-tailRecAppend (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (ProtocolC-45SExpC-45Parser-notWhitespace eta-0)) e-2) (cons (vector (vector 7 ) 0 (vector e-10 e-14 e-10 e-14)) '())))))))))(else (vector 0 e-3))))))))))
(define ProtocolC-45SExpC-45Parser-idelex (lambda (arg-0) (ProtocolC-45SExpC-45Parser-case--idelex-4466 arg-0 (LibrariesC-45TextC-45LexerC-45Tokenizer-lex ProtocolC-45SExpC-45Parser-ideTokens arg-0))))
(define ProtocolC-45SExpC-45Parser-ideParser (lambda (arg-1 arg-2 arg-3) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (ProtocolC-45SExpC-45Parser-idelex arg-2))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (vector 0 e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (u--toks) (PreludeC-45Types-u--C-62C-62C-61_Monad_C-40EitherC-32C-36eC-41 (let ((sc0 (LibrariesC-45TextC-45ParserC-45Core-parseWith csegen-3774 arg-1 arg-3 u--toks))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (vector 1 e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5))))) (lambda (_-0) (let ((e-3 (cdr _-0))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (vector 1 e-10))))))))))
(define ProtocolC-45SExpC-45Parser-exactIdent (lambda (arg-0) (vector 1 (string-append "Expected " arg-0) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))))(else '()))))))
(define ProtocolC-45SExpC-45Parser-identifierSExp (vector 1 "Expected name" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((3) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ProtocolC-45SExpC-45Parser-intLit (vector 1 "Expected integer literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((1) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ProtocolC-45SExpC-45Parser-simpleStrLit (vector 1 "Expected string literal" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((0) (let ((e-0 (vector-ref lcase-0 1))) (ParserC-45SupportC-45Escaping-unescape 0 e-0)))(else '())))))
(define ProtocolC-45SExpC-45Parser-strBegin (vector 1 "Expected string begin" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((4) (let ((e-0 (vector-ref lcase-0 1))) (box e-0)))(else '())))))
(define ProtocolC-45SExpC-45Parser-strEnd (vector 1 "Expected string end" (lambda (lcase-0) (case (vector-ref lcase-0 0) ((5) (box (vector 0 )))(else '())))))
(define ProtocolC-45SExpC-45Parser-simpleStr (vector 10 1 1 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-0)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) (vector 10 1 0 (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 (lambda (eta-0) (lambda (eta-1) eta-1)) ProtocolC-45SExpC-45Parser-strBegin) csegen-2165)) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 0 u--f (LibrariesC-45TextC-45Parser-option 1 "" ProtocolC-45SExpC-45Parser-simpleStrLit))))) (lambda (u--f) (LibrariesC-45TextC-45ParserC-45Core-u--map_Functor_C-40C-40C-40GrammarC-32C-36stateC-41C-32C-36tokC-41C-32C-36cC-41 1 u--f ProtocolC-45SExpC-45Parser-strEnd))))
(define ProtocolC-45SExpC-45Parser-symbol (lambda (arg-0) (vector 1 (string-append "Expected '" (string-append arg-0 "'")) (lambda (lcase-0) (case (vector-ref lcase-0 0) ((2) (let ((e-0 (vector-ref lcase-0 1))) (PreludeC-45Interfaces-guard csegen-258 (PreludeC-45EqOrd-u--C-61C-61_Eq_String e-0 arg-0))))(else '()))))))
(define ProtocolC-45SExpC-45Parser-sexp (lambda () (vector 13 1 1 (vector 11 1 (ProtocolC-45SExpC-45Parser-symbol ":") (lambda () (vector 11 0 (ProtocolC-45SExpC-45Parser-exactIdent "True") (lambda () (vector 0 (vector 2 1)))))) (lambda () (vector 13 1 1 (vector 11 1 (ProtocolC-45SExpC-45Parser-symbol ":") (lambda () (vector 11 0 (ProtocolC-45SExpC-45Parser-exactIdent "False") (lambda () (vector 0 (vector 2 0)))))) (lambda () (vector 13 1 1 (vector 9 0 ProtocolC-45SExpC-45Parser-intLit (lambda () (lambda (u--i) (vector 0 (vector 3 u--i))))) (lambda () (vector 13 1 1 (vector 9 0 ProtocolC-45SExpC-45Parser-simpleStr (lambda () (lambda (u--str) (vector 0 (vector 1 u--str))))) (lambda () (vector 13 1 1 (vector 11 1 (ProtocolC-45SExpC-45Parser-symbol ":") (lambda () (vector 9 0 ProtocolC-45SExpC-45Parser-identifierSExp (lambda () (lambda (u--x) (vector 0 (vector 4 u--x))))))) (lambda () (vector 11 1 (ProtocolC-45SExpC-45Parser-symbol "(") (lambda () (vector 10 0 1 (LibrariesC-45TextC-45Parser-many (ProtocolC-45SExpC-45Parser-sexp)) (lambda (u--xs) (vector 11 0 (ProtocolC-45SExpC-45Parser-symbol ")") (lambda () (vector 0 (vector 0 u--xs))))))))))))))))))))
(define ProtocolC-45SExpC-45Parser-parseSExp (lambda (arg-0) (ProtocolC-45SExpC-45Parser-ideParser 1 arg-0 (vector 9 0 (ProtocolC-45SExpC-45Parser-sexp) (lambda () (lambda (u--c) (vector 12 0 0 ProtocolC-45SExpC-45Parser-eoi (vector 0 u--c))))))))
(define ProtocolC-45SExpC-45Parser-u--pretty_Pretty_Void_SExpToken (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "literal") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String (PreludeC-45Show-u--show_Show_Integer e-0))))) ((4) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string begin")) ((5) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "string end")) ((0) (let ((e-2 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "string") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-dquotes (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-2))))) ((3) (let ((e-3 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "identifier") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-3)))) ((2) (let ((e-4 (vector-ref arg-0 1))) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "symbol") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String e-4)))) ((6) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--pretty_Pretty_Void_String "space")) (else (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "end of input")))))
(define ProtocolC-45SExpC-45Parser-u--prettyPrec_Pretty_Void_SExpToken (lambda (arg-0 arg-1) (ProtocolC-45SExpC-45Parser-u--pretty_Pretty_Void_SExpToken arg-1)))
(define ProtocolC-45SExpC-45Parser-u--show_Show_SExpToken (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (string-append "literal " (PreludeC-45Show-u--show_Show_Integer e-0)))) ((4) "string begin") ((5) "string end") ((0) (let ((e-2 (vector-ref arg-0 1))) (string-append "string " (PreludeC-45Show-u--show_Show_String e-2)))) ((3) (let ((e-3 (vector-ref arg-0 1))) (string-append "identifier " e-3))) ((2) (let ((e-4 (vector-ref arg-0 1))) (string-append "symbol " e-4))) ((6) " ") (else "end of input"))))
(define ProtocolC-45SExpC-45Parser-u--showPrec_Show_SExpToken (lambda (arg-0 arg-1) (ProtocolC-45SExpC-45Parser-u--show_Show_SExpToken arg-1)))
(define IdrisC-45IDEModeC-45Parser-u--cast_Cast_SExpError_Error (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (ParserC-45Support-fromLexError (vector 2 (vector 0 )) e-0))) (else (let ((e-1 (vector-ref arg-0 1))) (ParserC-45Support-fromParsingErrors (cons (cons (lambda (u--x) (ProtocolC-45SExpC-45Parser-u--show_Show_SExpToken u--x)) (lambda (u--d) (lambda (u--x) (ProtocolC-45SExpC-45Parser-u--showPrec_Show_SExpToken u--d u--x)))) (cons (lambda (arg-11067) (ProtocolC-45SExpC-45Parser-u--pretty_Pretty_Void_SExpToken arg-11067)) (lambda (arg-11073) (lambda (arg-11076) (ProtocolC-45SExpC-45Parser-u--prettyPrec_Pretty_Void_SExpToken arg-11073 arg-11076))))) (vector 2 (vector 0 )) e-1))))))
(define IdrisC-45IDEModeC-45Parser-parseSExp (lambda (arg-0) (let ((sc0 (ProtocolC-45SExpC-45Parser-parseSExp arg-0))) (case (vector-ref sc0 0) ((0) (let ((e-2 (vector-ref sc0 1))) (vector 0 (IdrisC-45IDEModeC-45Parser-u--cast_Cast_SExpError_Error e-2)))) (else (let ((e-5 (vector-ref sc0 1))) (vector 1 e-5)))))))
(define ProtocolC-45SExp-u--fromSExp_FromSExpable_C-40ListC-32C-36aC-41 (lambda (arg-1 arg-2) (case (vector-ref arg-2 0) ((0) (let ((e-0 (vector-ref arg-2 1))) (PreludeC-45Types-u--traverse_Traversable_List csegen-255 (lambda (arg-0) (arg-1 arg-0)) e-0)))(else '()))))
(define ProtocolC-45SExp-u--fromSExp_FromSExpable_String (lambda (arg-0) (case (vector-ref arg-0 0) ((1) (let ((e-0 (vector-ref arg-0 1))) (box e-0)))(else '()))))
(define ProtocolC-45IDEC-45Command-u--fromSExp_FromSExpable_Hints (lambda (arg-0) (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) eta-0) (ProtocolC-45SExp-u--fromSExp_FromSExpable_C-40ListC-32C-36aC-41 (lambda (eta-0) (ProtocolC-45SExp-u--fromSExp_FromSExpable_String eta-0)) arg-0))))
(define ProtocolC-45IDEC-45Command-n--2982-6518-u--getMode (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (PreludeC-45EqOrd-u--C-61C-61_Eq_String arg-4 "all")))
(define ProtocolC-45IDEC-45Command-getIDECommand (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) '() (let ((e-3 (car e-0))) (let ((e-4 (cdr e-0))) (case (vector-ref e-3 0) ((4) (let ((e-5 (vector-ref e-3 1))) (cond ((equal? e-5 "interpret") (if (null? e-4) '() (let ((e-7 (car e-4))) (let ((e-8 (cdr e-4))) (case (vector-ref e-7 0) ((1) (let ((e-9 (vector-ref e-7 1))) (if (null? e-8) (box (vector 0 e-9)) '())))(else '())))))) ((equal? e-5 "load-file") (if (null? e-4) '() (let ((e-12 (car e-4))) (let ((e-13 (cdr e-4))) (case (vector-ref e-12 0) ((1) (let ((e-14 (vector-ref e-12 1))) (if (null? e-13) (box (vector 1 e-14 '())) (let ((e-17 (car e-13))) (let ((e-18 (cdr e-13))) (case (vector-ref e-17 0) ((3) (let ((e-19 (vector-ref e-17 1))) (if (null? e-18) (box (vector 1 e-14 (box e-19))) '())))(else '())))))))(else '())))))) ((equal? e-5 "type-of") (if (null? e-4) '() (let ((e-22 (car e-4))) (let ((e-23 (cdr e-4))) (case (vector-ref e-22 0) ((1) (let ((e-24 (vector-ref e-22 1))) (if (null? e-23) (box (vector 2 e-24 '())) (let ((e-27 (car e-23))) (let ((e-28 (cdr e-23))) (case (vector-ref e-27 0) ((3) (let ((e-29 (vector-ref e-27 1))) (if (null? e-28) '() (let ((e-31 (car e-28))) (let ((e-32 (cdr e-28))) (case (vector-ref e-31 0) ((3) (let ((e-33 (vector-ref e-31 1))) (if (null? e-32) (box (vector 2 e-24 (box (cons e-29 e-33)))) '())))(else '())))))))(else '())))))))(else '())))))) ((equal? e-5 "name-at") (if (null? e-4) '() (let ((e-36 (car e-4))) (let ((e-37 (cdr e-4))) (case (vector-ref e-36 0) ((1) (let ((e-38 (vector-ref e-36 1))) (if (null? e-37) (box (vector 3 e-38 '())) (let ((e-41 (car e-37))) (let ((e-42 (cdr e-37))) (case (vector-ref e-41 0) ((3) (let ((e-43 (vector-ref e-41 1))) (if (null? e-42) '() (let ((e-45 (car e-42))) (let ((e-46 (cdr e-42))) (case (vector-ref e-45 0) ((3) (let ((e-47 (vector-ref e-45 1))) (if (null? e-46) (box (vector 3 e-38 (box (cons e-43 e-47)))) '())))(else '())))))))(else '())))))))(else '())))))) ((equal? e-5 "case-split") (if (null? e-4) '() (let ((e-50 (car e-4))) (let ((e-51 (cdr e-4))) (case (vector-ref e-50 0) ((3) (let ((e-52 (vector-ref e-50 1))) (if (null? e-51) '() (let ((e-54 (car e-51))) (let ((e-55 (cdr e-51))) (case (vector-ref e-54 0) ((3) (let ((e-56 (vector-ref e-54 1))) (if (null? e-55) '() (let ((e-59 (car e-55))) (let ((e-60 (cdr e-55))) (case (vector-ref e-59 0) ((1) (let ((e-61 (vector-ref e-59 1))) (if (null? e-60) (box (vector 4 e-52 e-56 e-61)) '())))(else '()))))))) ((1) (let ((e-57 (vector-ref e-54 1))) (if (null? e-55) (box (vector 4 e-52 0 e-57)) '())))(else '())))))))(else '())))))) ((equal? e-5 "add-clause") (if (null? e-4) '() (let ((e-65 (car e-4))) (let ((e-66 (cdr e-4))) (case (vector-ref e-65 0) ((3) (let ((e-67 (vector-ref e-65 1))) (if (null? e-66) '() (let ((e-69 (car e-66))) (let ((e-70 (cdr e-66))) (case (vector-ref e-69 0) ((1) (let ((e-71 (vector-ref e-69 1))) (if (null? e-70) (box (vector 5 e-67 e-71)) '())))(else '())))))))(else '())))))) ((equal? e-5 "add-missing") (if (null? e-4) '() (let ((e-74 (car e-4))) (let ((e-75 (cdr e-4))) (case (vector-ref e-74 0) ((3) (let ((e-76 (vector-ref e-74 1))) (if (null? e-75) '() (let ((e-78 (car e-75))) (let ((e-79 (cdr e-75))) (case (vector-ref e-78 0) ((1) (let ((e-80 (vector-ref e-78 1))) (if (null? e-79) (box (vector 6 e-76 e-80)) '())))(else '())))))))(else '())))))) ((equal? e-5 "proof-search") (if (null? e-4) '() (let ((e-83 (car e-4))) (let ((e-84 (cdr e-4))) (case (vector-ref e-83 0) ((3) (let ((e-85 (vector-ref e-83 1))) (if (null? e-84) '() (let ((e-87 (car e-84))) (let ((e-88 (cdr e-84))) (case (vector-ref e-87 0) ((1) (let ((e-89 (vector-ref e-87 1))) (if (null? e-88) (box (vector 9 e-85 e-89 '() 0)) (let ((e-92 (car e-88))) (let ((e-93 (cdr e-88))) (if (null? e-93) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--hsC-39) (vector 9 e-85 e-89 u--hsC-39 0)) (ProtocolC-45IDEC-45Command-u--fromSExp_FromSExpable_Hints e-92)) (let ((e-96 (car e-93))) (let ((e-97 (cdr e-93))) (case (vector-ref e-96 0) ((4) (let ((e-98 (vector-ref e-96 1))) (if (null? e-97) (PreludeC-45Types-u--map_Functor_Maybe (lambda (u--hsC-39) (vector 9 e-85 e-89 u--hsC-39 (ProtocolC-45IDEC-45Command-n--2982-6518-u--getMode e-85 e-89 e-92 e-98 e-98))) (ProtocolC-45IDEC-45Command-u--fromSExp_FromSExpable_Hints e-92)) '())))(else '()))))))))))(else '())))))))(else '())))))) ((equal? e-5 "intro") (if (null? e-4) '() (let ((e-101 (car e-4))) (let ((e-102 (cdr e-4))) (case (vector-ref e-101 0) ((3) (let ((e-103 (vector-ref e-101 1))) (if (null? e-102) '() (let ((e-105 (car e-102))) (let ((e-106 (cdr e-102))) (case (vector-ref e-105 0) ((1) (let ((e-107 (vector-ref e-105 1))) (if (null? e-106) (box (vector 7 e-103 e-107)) '())))(else '())))))))(else '())))))) ((equal? e-5 "refine") (if (null? e-4) '() (let ((e-110 (car e-4))) (let ((e-111 (cdr e-4))) (case (vector-ref e-110 0) ((3) (let ((e-112 (vector-ref e-110 1))) (if (null? e-111) '() (let ((e-114 (car e-111))) (let ((e-115 (cdr e-111))) (case (vector-ref e-114 0) ((1) (let ((e-116 (vector-ref e-114 1))) (if (null? e-115) '() (let ((e-118 (car e-115))) (let ((e-119 (cdr e-115))) (case (vector-ref e-118 0) ((1) (let ((e-120 (vector-ref e-118 1))) (if (null? e-119) (box (vector 8 e-112 e-116 e-120)) '())))(else '())))))))(else '())))))))(else '())))))) ((equal? e-5 "generate-def") (if (null? e-4) '() (let ((e-123 (car e-4))) (let ((e-124 (cdr e-4))) (case (vector-ref e-123 0) ((3) (let ((e-125 (vector-ref e-123 1))) (if (null? e-124) '() (let ((e-127 (car e-124))) (let ((e-128 (cdr e-124))) (case (vector-ref e-127 0) ((1) (let ((e-129 (vector-ref e-127 1))) (if (null? e-128) (box (vector 11 e-125 e-129)) '())))(else '())))))))(else '())))))) ((equal? e-5 "make-lemma") (if (null? e-4) '() (let ((e-132 (car e-4))) (let ((e-133 (cdr e-4))) (case (vector-ref e-132 0) ((3) (let ((e-134 (vector-ref e-132 1))) (if (null? e-133) '() (let ((e-136 (car e-133))) (let ((e-137 (cdr e-133))) (case (vector-ref e-136 0) ((1) (let ((e-138 (vector-ref e-136 1))) (if (null? e-137) (box (vector 13 e-134 e-138)) '())))(else '())))))))(else '())))))) ((equal? e-5 "make-case") (if (null? e-4) '() (let ((e-141 (car e-4))) (let ((e-142 (cdr e-4))) (case (vector-ref e-141 0) ((3) (let ((e-143 (vector-ref e-141 1))) (if (null? e-142) '() (let ((e-145 (car e-142))) (let ((e-146 (cdr e-142))) (case (vector-ref e-145 0) ((1) (let ((e-147 (vector-ref e-145 1))) (if (null? e-146) (box (vector 14 e-143 e-147)) '())))(else '())))))))(else '())))))) ((equal? e-5 "make-with") (if (null? e-4) '() (let ((e-150 (car e-4))) (let ((e-151 (cdr e-4))) (case (vector-ref e-150 0) ((3) (let ((e-152 (vector-ref e-150 1))) (if (null? e-151) '() (let ((e-154 (car e-151))) (let ((e-155 (cdr e-151))) (case (vector-ref e-154 0) ((1) (let ((e-156 (vector-ref e-154 1))) (if (null? e-155) (box (vector 15 e-152 e-156)) '())))(else '())))))))(else '())))))) ((equal? e-5 "docs-for") (if (null? e-4) '() (let ((e-159 (car e-4))) (let ((e-160 (cdr e-4))) (case (vector-ref e-159 0) ((1) (let ((e-161 (vector-ref e-159 1))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (if (null? e-160) (box '()) (let ((e-2 (car e-160))) (let ((e-6 (cdr e-160))) (case (vector-ref e-2 0) ((4) (let ((e-7 (vector-ref e-2 1))) (cond ((equal? e-7 "overview") (if (null? e-6) (box (box 0)) '())) ((equal? e-7 "full") (if (null? e-6) (box (box 1)) '()))(else '()))))(else '()))))) (lambda (u--modeOpt) (box (vector 16 e-161 u--modeOpt))))))(else '())))))) ((equal? e-5 "apropos") (if (null? e-4) '() (let ((e-163 (car e-4))) (let ((e-164 (cdr e-4))) (case (vector-ref e-163 0) ((1) (let ((e-165 (vector-ref e-163 1))) (if (null? e-164) (box (vector 18 e-165)) '())))(else '())))))) ((equal? e-5 "directive") (if (null? e-4) '() (let ((e-168 (car e-4))) (let ((e-169 (cdr e-4))) (case (vector-ref e-168 0) ((1) (let ((e-170 (vector-ref e-168 1))) (if (null? e-169) (box (vector 17 e-170)) '())))(else '())))))) ((equal? e-5 "metavariables") (if (null? e-4) '() (let ((e-173 (car e-4))) (let ((e-174 (cdr e-4))) (case (vector-ref e-173 0) ((3) (let ((e-175 (vector-ref e-173 1))) (if (null? e-174) (box (vector 19 e-175)) '())))(else '())))))) ((equal? e-5 "who-calls") (if (null? e-4) '() (let ((e-178 (car e-4))) (let ((e-179 (cdr e-4))) (case (vector-ref e-178 0) ((1) (let ((e-180 (vector-ref e-178 1))) (if (null? e-179) (box (vector 20 e-180)) '())))(else '())))))) ((equal? e-5 "calls-who") (if (null? e-4) '() (let ((e-183 (car e-4))) (let ((e-184 (cdr e-4))) (case (vector-ref e-183 0) ((1) (let ((e-185 (vector-ref e-183 1))) (if (null? e-184) (box (vector 21 e-185)) '())))(else '())))))) ((equal? e-5 "browse-namespace") (if (null? e-4) '() (let ((e-188 (car e-4))) (let ((e-189 (cdr e-4))) (case (vector-ref e-188 0) ((1) (let ((e-190 (vector-ref e-188 1))) (if (null? e-189) (box (vector 22 e-190)) '())))(else '())))))) ((equal? e-5 "normalise-term") (if (null? e-4) '() (let ((e-193 (car e-4))) (let ((e-194 (cdr e-4))) (case (vector-ref e-193 0) ((1) (let ((e-195 (vector-ref e-193 1))) (if (null? e-194) (box (vector 23 e-195)) '())))(else '())))))) ((equal? e-5 "show-term-implicits") (if (null? e-4) '() (let ((e-198 (car e-4))) (let ((e-199 (cdr e-4))) (case (vector-ref e-198 0) ((1) (let ((e-200 (vector-ref e-198 1))) (if (null? e-199) (box (vector 24 e-200)) '())))(else '())))))) ((equal? e-5 "hide-term-implicits") (if (null? e-4) '() (let ((e-203 (car e-4))) (let ((e-204 (cdr e-4))) (case (vector-ref e-203 0) ((1) (let ((e-205 (vector-ref e-203 1))) (if (null? e-204) (box (vector 25 e-205)) '())))(else '())))))) ((equal? e-5 "elaborate-term") (if (null? e-4) '() (let ((e-208 (car e-4))) (let ((e-209 (cdr e-4))) (case (vector-ref e-208 0) ((1) (let ((e-210 (vector-ref e-208 1))) (if (null? e-209) (box (vector 26 e-210)) '())))(else '())))))) ((equal? e-5 "print-definition") (if (null? e-4) '() (let ((e-213 (car e-4))) (let ((e-214 (cdr e-4))) (case (vector-ref e-213 0) ((1) (let ((e-215 (vector-ref e-213 1))) (if (null? e-214) (box (vector 27 e-215)) '())))(else '())))))) ((equal? e-5 "repl-completions") (if (null? e-4) '() (let ((e-218 (car e-4))) (let ((e-219 (cdr e-4))) (case (vector-ref e-218 0) ((1) (let ((e-220 (vector-ref e-218 1))) (if (null? e-219) (box (vector 28 e-220)) '())))(else '())))))) ((equal? e-5 "enable-syntax") (if (null? e-4) '() (let ((e-223 (car e-4))) (let ((e-224 (cdr e-4))) (case (vector-ref e-223 0) ((2) (let ((e-225 (vector-ref e-223 1))) (if (null? e-224) (box (vector 29 e-225)) '())))(else '())))))) ((equal? e-5 "get-options") (if (null? e-4) (box (vector 31 )) '()))(else '()))))(else '()))))))) ((4) (let ((e-1 (vector-ref arg-0 1))) (cond ((equal? e-1 "proof-search-next") (box (vector 10 ))) ((equal? e-1 "generate-def-next") (box (vector 12 ))) ((equal? e-1 "version") (box (vector 30 )))(else '()))))(else '()))))
(define ProtocolC-45IDEC-45Command-u--fromSExp_FromSExpable_IDECommand (lambda (ext-0) (ProtocolC-45IDEC-45Command-getIDECommand ext-0)))
(define IdrisC-45IDEModeC-45Commands-getMsg (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) '() (let ((e-2 (car e-0))) (let ((e-3 (cdr e-0))) (if (null? e-3) '() (let ((e-5 (car e-3))) (let ((e-6 (cdr e-3))) (case (vector-ref e-5 0) ((3) (let ((e-7 (vector-ref e-5 1))) (if (null? e-6) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (ProtocolC-45IDEC-45Command-u--fromSExp_FromSExpable_IDECommand e-2) (lambda (u--cmd) (box (cons u--cmd e-7)))) '())))(else '()))))))))))(else '()))))
(define IdrisC-45IDEModeC-45REPL-returnFromIDE (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45Commands-send arg-0 arg-1 (vector 1 arg-3 arg-2))))
(define IdrisC-45IDEModeC-45REPL-printIDEError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-1 arg-0 (lambda (eta-0) (IdrisC-45IDEModeC-45Pretty-annToProperties eta-0)) arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-returnFromIDE arg-1 arg-2 arg-3 (PreludeC-45Basics-uncurry (lambda (eta-0) (lambda (eta-1) (vector 2 eta-0 eta-1))) e-5)))) eff-0) ext-0)))))))
(define ProtocolC-45IDEC-45Formatting-mkFormat (lambda (ext-0) (cons '() (box ext-0))))
(define IdrisC-45IDEModeC-45Pretty-docToProperties (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (box (ProtocolC-45IDEC-45Formatting-mkFormat 2))) ((1) (box (ProtocolC-45IDEC-45Formatting-mkFormat 0))) ((2) '()) ((3) '()) ((4) '()) ((5) '()) (else (let ((e-1 (vector-ref arg-0 1))) (IdrisC-45IDEModeC-45Pretty-syntaxToProperties e-1))))))
(define IdrisC-45REPL-handleMissingC-39 (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (string-append (CoreC-45Name-u--show_Show_Name e-0) (string-append ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" e-1)))))) ((1) (let ((e-2 (vector-ref arg-0 1))) (let ((e-3 (vector-ref arg-0 2))) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append ": Calls non covering function" (if (null? e-3) (string-append "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-3))) (let ((e-1 (car e-3))) (let ((e-4 (cdr e-3))) (if (null? e-4) (string-append " " (CoreC-45Name-u--show_Show_Name e-1)) (string-append "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-3)))))))))))) (else (let ((e-4 (vector-ref arg-0 1))) (string-append (CoreC-45Name-u--show_Show_Name e-4) ": All cases covered"))))))
(define IdrisC-45IDEModeC-45Holes-impBracket (lambda (arg-0 arg-1) (cond ((equal? arg-0 0) arg-1) (else (string-append "{" (string-append arg-1 "}"))))))
(define IdrisC-45IDEModeC-45Holes-premiseIDE (lambda (arg-0) (cons (string-append " " (string-append (Algebra-showCount (let ((e-2 (vector-ref arg-0 2))) e-2)) (string-append " " (IdrisC-45IDEModeC-45Holes-impBracket (let ((e-3 (vector-ref arg-0 3))) e-3) (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-0 0))) e-0)))))) (IdrisC-45Syntax-u--show_Show_IPTerm (let ((e-1 (vector-ref arg-0 1))) e-1)))))
(define IdrisC-45IDEModeC-45Holes-holeIDE (lambda (arg-0) (vector (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-0 0))) e-0)) (IdrisC-45Syntax-u--show_Show_IPTerm (let ((e-1 (vector-ref arg-0 1))) e-1)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45Holes-premiseIDE eta-0)) (let ((e-2 (vector-ref arg-0 2))) e-2)))))
(define IdrisC-45IDEModeC-45REPL-printIDEResult (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45REPL-returnFromIDE arg-0 arg-1 arg-2 (vector 0 arg-3 '()))))
(define IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (IdrisC-45IDEModeC-45REPL-returnFromIDE arg-0 arg-1 arg-2 (vector 0 e-2 e-3))))))
(define IdrisC-45IDEModeC-45REPL-u--cast_Cast_REPLEval_String (lambda (arg-0) (cond ((equal? arg-0 0) "typecheck") ((equal? arg-0 1) "normalise") ((equal? arg-0 2) "execute") (else "scheme"))))
(define IdrisC-45IDEModeC-45REPL-u--cast_Cast_REPLOpt_REPLOption (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (vector "show-implicits" 0 e-0))) ((1) (let ((e-1 (vector-ref arg-0 1))) (vector "show-namespace" 0 e-1))) ((2) (let ((e-2 (vector-ref arg-0 1))) (vector "show-machinenames" 0 e-2))) ((3) (let ((e-3 (vector-ref arg-0 1))) (vector "show-types" 0 e-3))) ((4) (let ((e-4 (vector-ref arg-0 1))) (vector "eval" 2 (IdrisC-45IDEModeC-45REPL-u--cast_Cast_REPLEval_String e-4)))) ((5) (let ((e-5 (vector-ref arg-0 1))) (vector "editor" 1 e-5))) ((6) (let ((e-6 (vector-ref arg-0 1))) (vector "cg" 1 e-6))) ((7) (let ((e-7 (vector-ref arg-0 1))) (vector "profile" 0 e-7))) (else (let ((e-8 (vector-ref arg-0 1))) (vector "evaltiming" 0 e-8))))))
(define CoreC-45TT-u--show_Show_PartialReason (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "not strictly positive") ((1) (let ((e-0 (vector-ref arg-0 1))) (if (null? e-0) (string-append "possibly not terminating due to calls to " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-0))) (let ((e-5 (car e-0))) (let ((e-6 (cdr e-0))) (if (null? e-6) (string-append "possibly not terminating due to call to " (CoreC-45Name-u--show_Show_Name e-5)) (string-append "possibly not terminating due to calls to " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-0))))))))) ((2) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (if (null? e-1) (string-append "possibly not terminating due to function " (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " being reachable via " (CoreC-45NameC-45Namespace-showSep " -> " (PreludeC-45TypesC-45List-mapAppend '() csegen-870 e-1))))) (let ((e-10 (cdr e-1))) (if (null? e-10) (string-append "possibly not terminating due to call  to " (CoreC-45Name-u--show_Show_Name e-2)) (string-append "possibly not terminating due to function " (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " being reachable via " (CoreC-45NameC-45Namespace-showSep " -> " (PreludeC-45TypesC-45List-mapAppend '() csegen-870 e-1))))))))))) (else (let ((e-3 (vector-ref arg-0 1))) (string-append "possibly not terminating due to recursive path " (CoreC-45NameC-45Namespace-showSep " -> " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name (Builtin-snd eta-0))) e-3))))))))
(define CoreC-45TT-u--show_Show_Terminating (lambda (arg-0) (case (vector-ref arg-0 0) ((0) "not yet checked") ((1) "terminating") (else (let ((e-0 (vector-ref arg-0 1))) (CoreC-45TT-u--show_Show_PartialReason e-0))))))
(define CoreC-45TT-n--8734-6736-u--showTot (lambda (arg-0 arg-1 arg-2) (case (vector-ref arg-1 0) ((1) (case (vector-ref arg-2 0) ((0) "total")(else (CoreC-45TT-u--show_Show_Covering arg-2))))(else (case (vector-ref arg-2 0) ((0) (CoreC-45TT-u--show_Show_Terminating arg-1))(else (string-append (CoreC-45TT-u--show_Show_Covering arg-2) (string-append "; " (CoreC-45TT-u--show_Show_Terminating arg-1)))))))))
(define CoreC-45TT-u--show_Show_Totality (lambda (arg-0) (let ((u--t (let ((e-0 (car arg-0))) e-0))) (let ((u--c (let ((e-1 (cdr arg-0))) e-1))) (CoreC-45TT-n--8734-6736-u--showTot arg-0 u--t u--c)))))
(define IdrisC-45IDEModeC-45REPL-n--18574-5290-u--sexpOriginDesc (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (case (vector-ref arg-8 0) ((0) (let ((e-0 (vector-ref arg-8 1))) (let ((act-1 (let ((act-1 (unbox arg-7))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--wdir (let ((e-4 (vector-ref e-5 4))) (let ((e-44 (vector-ref e-4 0))) (let ((e-54 (vector-ref e-44 0))) e-54))))) (let ((u--pkg_dirs (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-9) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-9 ".")) (PreludeC-45TypesC-45List-tailRecAppend (let ((e-4 (vector-ref e-5 4))) (let ((e-44 (vector-ref e-4 0))) (let ((e-48 (vector-ref e-44 6))) e-48))) (let ((e-4 (vector-ref e-5 4))) (let ((e-44 (vector-ref e-4 0))) (let ((e-47 (vector-ref e-44 7))) e-47))))))) (let ((u--exts CoreC-45Directory-listOfExtensionsStr)) (lambda (eta-0) (let ((act-2 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-2) (case (vector-ref eta-2 0) ((0) (let ((e-2 (vector-ref eta-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-2 1))) (vector 1 (box (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--wdir e-6))))))) (lambda (eta-2) (CoreC-45Directory-nsToSource arg-7 CoreC-45FC-replFC e-0 eta-2)) eta-1)) (lambda (eta-1) (lambda (eta-2) (CoreC-45Directory-firstAvailable arg-7 (PreludeC-45Types-listBind u--pkg_dirs (lambda (u--pkg_dir) (let ((u--pkg_dir_abs (let ((sc2 (LibrariesC-45UtilsC-45Path-isRelative u--pkg_dir))) (cond ((equal? sc2 1) (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--wdir u--pkg_dir)) (else u--pkg_dir))))) (PreludeC-45Types-listBind u--exts (lambda (u--ext) (PreludeC-45Types-u--pure_Applicative_List (LibrariesC-45UtilsC-45Path-C-60C-47C-62 u--pkg_dir_abs (LibrariesC-45UtilsC-45Path-C-60C-46C-62 (CoreC-45NameC-45NamespaceC-45ModuleIdent-toPath e-0) u--ext)))))))) eta-2))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-6) (vector 1 "(File-Not-Found)") (let ((e-1 (unbox e-6))) (vector 1 e-1)))))) eff-0) eta-0))))))))))) eff-0) ext-0))))))) ((1) (let ((e-1 (vector-ref arg-8 1))) (vector 1 e-1))) (else (vector 1 "(Interactive)")))))
(define IdrisC-45IDEModeC-45REPL-n--18574-5289-u--constructFileContext (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8) (let ((e-2 (car arg-8))) (let ((e-3 (cdr arg-8))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (lambda (clam-0) (let ((e-14 (car e-10))) (let ((e-15 (cdr e-10))) (let ((e-18 (car e-11))) (let ((e-19 (cdr e-11))) (let ((act-1 (IdrisC-45Pretty-render arg-3 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-1260 e-2) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45IDEModeC-45REPL-n--18574-5290-u--sexpOriginDesc arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 e-6 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (cons e-5 (cons e-8 (vector e-14 e-15 e-18 e-19))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))))))))))))
(define IdrisC-45IDEModeC-45REPL-displayIDEResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (case (vector-ref e-0 0) ((1) (let ((e-8 (vector-ref e-0 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 e-8 eta-0)))) ((3) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 IdrisC-45REPL-displayHelp))) ((4) (let ((e-9 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 e-9)))) ((5) (let ((e-10 (vector-ref e-0 1))) (let ((e-11 (vector-ref e-0 2))) (lambda (clam-0) (if (null? e-11) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-0) (IdrisC-45IDEModeC-45Pretty-syntaxToProperties eta-0)) (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 0 e-2) e-3)))))) eff-0) clam-0))))) (let ((e-38 (unbox e-11))) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-0) (IdrisC-45IDEModeC-45Pretty-syntaxToProperties eta-0)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-10) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-38))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 0 e-2) e-3)))))) eff-0) clam-0))))))))))) ((6) (let ((e-12 (vector-ref e-0 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45Pretty-annToProperties eta-1)) e-12 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 0 e-2) e-3)))))) eff-0) eta-0)))))))) ((7) (let ((e-13 (vector-ref e-0 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45Pretty-docToProperties eta-1)) e-13 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 0 e-2) e-3)))))) eff-0) eta-0)))))))) ((8) (let ((e-14 (vector-ref e-0 1))) (let ((e-15 (vector-ref e-0 2))) (lambda (eta-0) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45Pretty-syntaxToProperties eta-1)) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-14) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 ":") (IdrisC-45Pretty-u--pretty_Pretty_IdrisSyntax_IPTerm e-15))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 0 e-2) e-3)))))) eff-0) eta-0))))))))) ((9) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 1 ))) ((12) (let ((e-17 (vector-ref e-0 1))) (let ((e-18 (vector-ref e-0 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error loading file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--C-60C-43C-62_Semigroup_C-40DocC-32C-36annC-41 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-17) LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Symbols-colon) (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (SystemC-45FileC-45Error-u--show_Show_FileError e-18)))) eta-0))))) ((13) (let ((e-19 (vector-ref e-0 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Error(s) building file") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-19)) eta-0)))) ((14) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "No file can be reloaded") eta-0))) ((15) (let ((e-21 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Current working directory is \"" (cons e-21 (cons "\"" '())))))))) ((16) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Compilation failed") eta-0))) ((17) (let ((e-22 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "File " (cons e-22 (cons " written" '())))))))) ((18) (let ((e-23 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (IdrisC-45Syntax-u--show_Show_IPTerm e-23))))) ((19) (let ((e-24 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45REPL-handleMissingC-39 eta-0)) e-24)))))) ((20) (let ((e-25 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " is " (CoreC-45TT-u--show_Show_Totality e-3)))))) e-25)))))) ((22) (let ((e-26 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (string-append "Set loglevel to " (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-3952 e-26)))))) ((21) (let ((e-27 (vector-ref e-0 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 8 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-u--cast_Cast_REPLOpt_REPLOption eta-0)) e-27))))) ((25) (let ((e-28 (vector-ref e-0 1))) (let ((e-2 (car e-28))) (let ((e-4 (car e-2))) (let ((e-3 (cdr e-2))) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 2 (vector e-4 e-6 e-7 (let ((e-5 (cdr e-28))) e-5))))))))))) ((28) (let ((e-29 (vector-ref e-0 1))) (case (vector-ref e-29 0) ((0) (let ((e-39 (vector-ref e-29 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45Pretty-renderWithDecorations arg-0 arg-4 (lambda (eta-1) (IdrisC-45IDEModeC-45Pretty-annToProperties eta-1)) e-39 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResultWithHighlight arg-0 arg-5 arg-6 (let ((e-2 (car e-5))) (let ((e-3 (cdr e-5))) (cons (vector 0 e-2) e-3)))))) eff-0) eta-0)))))))) ((1) (let ((e-40 (vector-ref e-29 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-printIDEError arg-4 arg-0 arg-5 arg-6 e-40 eta-0)))) ((5) (let ((e-41 (vector-ref e-29 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 9 e-41)))) ((2) (let ((e-42 (vector-ref e-29 1))) (let ((e-43 (vector-ref e-29 2))) (let ((e-44 (vector-ref e-29 3))) (let ((e-45 (vector-ref e-29 4))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 3 (cons e-45 (ParserC-45Unlit-relit e-42 (string-append (CoreC-45Name-u--show_Show_Name e-43) (string-append " : " (IdrisC-45Syntax-u--show_Show_IPTerm e-44)))))))))))) ((3) (let ((e-46 (vector-ref e-29 1))) (let ((e-47 (vector-ref e-29 2))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45Unlit-relit e-46 eta-0)) e-47))))))) (else (let ((e-48 (vector-ref e-29 1))) (let ((e-49 (vector-ref e-29 2))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (ParserC-45Unlit-relit e-48 eta-0)) e-49)))))))))) ((23) (let ((e-30 (vector-ref e-0 1))) (let ((u--width (if (null? e-30) "auto" (let ((e-1 (unbox e-30))) (PreludeC-45Show-u--show_Show_Nat e-1))))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 (string-append "Set consolewidth to " u--width)))))) ((0) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 ""))) ((2) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 ""))) ((10) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 ""))) ((11) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 ""))) ((24) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 ""))) ((26) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 ""))) (else (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 "")))))) ((3) (let ((e-1 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 5 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (IdrisC-45IDEModeC-45Holes-holeIDE eta-0)) e-1))))) ((1) (let ((e-2 (vector-ref arg-7 1))) (let ((e-3 (vector-ref arg-7 2))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 6 e-2 e-3))))) ((2) (let ((e-4 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 7 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (CoreC-45Name-u--show_Show_Name eta-0)) e-4))))) ((4) (let ((e-5 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 e-5)))) ((5) (let ((e-6 (vector-ref arg-7 1))) (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 0 e-6)))) (else (let ((e-7 (vector-ref arg-7 1))) (lambda (eta-0) (let ((act-1 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (IdrisC-45IDEModeC-45REPL-n--18574-5289-u--constructFileContext e-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 arg-0 (let ((e-2 (car eta-1))) (let ((e-3 (cdr eta-1))) (cons e-2 (CoreC-45FC-toNonEmptyFC e-3)))))) e-7 '()) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (IdrisC-45IDEModeC-45REPL-printIDEResult arg-0 arg-5 arg-6 (vector 4 e-5)))) eff-0) eta-0)))))))))))
(define IdrisC-45IDEModeC-45REPL-idePutStrLn (lambda (arg-0 arg-1 arg-2 arg-3) (IdrisC-45IDEModeC-45Commands-send arg-0 arg-1 (vector 3 arg-3 arg-2))))
(define IdrisC-45IDEModeC-45REPL-handleIDEResult (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (case (vector-ref arg-7 0) ((0) (let ((e-0 (vector-ref arg-7 1))) (case (vector-ref e-0 0) ((27) (IdrisC-45IDEModeC-45REPL-idePutStrLn arg-0 arg-5 arg-6 "Bye for now!"))(else (IdrisC-45IDEModeC-45REPL-displayIDEResult arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))(else (IdrisC-45IDEModeC-45REPL-displayIDEResult arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7)))))
(define IdrisC-45Parser-aPTerm csegen-4244)
(define CoreC-45Core-n--12342-10459-u--go (lambda (arg-2 arg-3 arg-4) (if (null? arg-4) (lambda (eta-0) (vector 1 (PreludeC-45TypesC-45SnocList-C-60C-62C-62 arg-3 '()))) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (let ((eff-0 (arg-2 e-2))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (CoreC-45Core-n--12342-10459-u--go arg-2 ((PreludeC-45Types-maybe (lambda () (lambda (eta-0) eta-0)) (lambda () (lambda (eta-0) (lambda (eta-1) (PreludeC-45Basics-flip (lambda (eta-2) (lambda (eta-3) (cons eta-2 eta-3))) eta-0 eta-1)))) e-5) arg-3) e-3))) eff-1) world-0))))))))))))
(define CoreC-45Core-mapMaybeM (lambda (arg-2 ext-0) (CoreC-45Core-n--12342-10459-u--go arg-2 '() ext-0)))
(define TTImpC-45InteractiveC-45Completion-case--nameCompletion-2122 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6) (lambda (clam-0) (let ((e-3 (cdr arg-6))) (let ((sc1 (DataC-45String-isPrefixOf arg-0 (CoreC-45Name-nameRoot e-3)))) (cond ((equal? sc1 1) (let ((act-1 ((CoreC-45Context-lookupCtxtExact arg-5 (let ((e-0 (vector-ref arg-2 0))) e-0)) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-5) (vector 1 '()) (let ((e-1 (unbox e-5))) (let ((sc4 (CoreC-45Context-visibleIn arg-3 arg-5 (LibrariesC-45DataC-45WithDefault-collapseDefault 0 (let ((e-9 (vector-ref e-1 9))) e-9))))) (cond ((equal? sc4 1) (vector 1 (box e-3))) (else (vector 1 '()))))))))) eff-0) clam-0)))))) (else (vector 1 '()))))))))
(define TTImpC-45InteractiveC-45Completion-nameCompletion (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.completion" 30 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Looking at name completions for " (cons (PreludeC-45Show-u--show_Show_String arg-1) '())))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--cns (let ((e-2 (vector-ref e-6 2))) e-2))) (lambda (eta-0) (let ((act-3 (let ((act-3 ((CoreC-45Context-allNames (let ((e-0 (vector-ref e-6 0))) e-0)) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (PreludeC-45Basics-flip (lambda (eta-1) (lambda (eta-2) (CoreC-45Core-mapMaybeM eta-1 eta-2))) e-7 (lambda (u--nsn) (lambda (eta-1) (let ((act-4 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.completion" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-2) eta-2) (cons "Looking at " (cons (CoreC-45Name-u--show_Show_Name u--nsn) '())))) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else ((TTImpC-45InteractiveC-45Completion-case--nameCompletion-2122 arg-1 arg-0 e-6 u--cns e-7 u--nsn (CoreC-45Name-splitNS u--nsn)) eta-1))))))))) eff-0) eta-0))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45Name-u--show_Show_Name eta-2)) (DataC-45List-nub csegen-832 e-7)))))) eff-0) eta-0))))))))) eff-0) ext-0))))))))))
(define TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32parseTask-1762 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cond ((equal? e-3 "") (box (cons arg-1 (vector 2 '() e-2))))(else (let ((u--prag (string-append "%" e-2))) (let ((sc1 (DataC-45String-break csegen-3961 e-3))) (let ((e-5 (car sc1))) (let ((e-4 (cdr sc1))) (let ((sc2 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-0) (PreludeC-45EqOrd-u--C-61C-61_Eq_String u--prag (IdrisC-45SyntaxC-45Pragmas-u--show_Show_KwPragma eta-0))) IdrisC-45SyntaxC-45Pragmas-allPragmas))) (if (null? sc2) '() (let ((e-1 (car sc2))) (let ((e-6 (cdr sc2))) (if (null? e-6) (box (cons (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons arg-1 (cons u--prag (cons e-5 '())))) (vector 2 (box e-1) e-4))) '())))))))))))))))
(define TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32parseTask-1968 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (let ((e-2 (car arg-4))) (let ((e-3 (cdr arg-4))) (cond ((equal? e-2 "") '())(else (box (cons e-3 (vector 0 e-2)))))))))
(define TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32parseTask-1746 (lambda (arg-0 arg-1 arg-2 arg-3) (if (null? arg-3) (TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32parseTask-1968 arg-0 arg-1 arg-2 arg-3 (let ((sc1 (DataC-45String-break csegen-5694 (string-reverse arg-0)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (string-reverse e-2) (string-reverse e-3)))))) (let ((e-0 (car arg-3))) (let ((e-1 (cdr arg-3))) (cond ((equal? e-0 #\%) (let ((u--focus (string-cons #\% e-1))) (TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32parseTask-1762 arg-0 arg-1 e-1 u--focus (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-1)))) ((equal? e-0 #\:) (box (cons arg-1 (vector 1 e-1))))(else (TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32parseTask-1968 arg-0 arg-1 arg-2 arg-3 (let ((sc1 (DataC-45String-break csegen-5694 (string-reverse arg-0)))) (let ((e-2 (car sc1))) (let ((e-3 (cdr sc1))) (cons (string-reverse e-2) (string-reverse e-3)))))))))))))
(define TTImpC-45InteractiveC-45Completion-case--parseTask-1733 (lambda (arg-0 arg-1) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32parseTask-1746 arg-0 e-2 e-3 (DataC-45String-strM e-3))))))
(define TTImpC-45InteractiveC-45Completion-parseTask (lambda (arg-0) (TTImpC-45InteractiveC-45Completion-case--parseTask-1733 arg-0 (DataC-45String-break csegen-3961 arg-0))))
(define TTImpC-45InteractiveC-45Completion-case--oneOfCompletion-2307 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (box arg-2))))
(define TTImpC-45InteractiveC-45Completion-oneOfCompletion (lambda (arg-0 arg-1) (TTImpC-45InteractiveC-45Completion-case--oneOfCompletion-2307 arg-1 arg-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-2) (DataC-45String-isPrefixOf arg-0 arg-2)) arg-1))))
(define TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32pragmaCompletionC-44go-2579 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 ext-0) (if (null? arg-6) (vector 1 '()) (vector 1 (box (cons "" (PreludeC-45TypesC-45List-mapAppend '() csegen-5692 arg-6)))))))
(define TTImpC-45InteractiveC-45Completion-case--pragmaCompletionC-44go-2548 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 '())) (let ((e-0 (car arg-5))) (let ((e-1 (cdr arg-5))) (cond ((equal? e-0 #\") (let ((here-0 (string-cons #\" e-1))) (lambda (eta-0) (TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32pragmaCompletionC-44go-2579 arg-0 arg-1 arg-2 arg-3 e-1 here-0 (PreludeC-45TypesC-45List-filterAppend '() (lambda (eta-1) (DataC-45String-isPrefixOf e-1 (Builtin-fst eta-1))) CoreC-45OptionsC-45Log-knownTopics) eta-0))))(else (lambda (eta-0) (vector 1 '())))))))))
(define TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go (lambda (arg-0 arg-1 arg-2 arg-3 arg-4) (if (null? arg-3) (lambda (clam-23) (vector 1 '())) (let ((e-5 (car arg-3))) (let ((e-6 (cdr arg-3))) (case (vector-ref e-5 0) ((0) (if (null? arg-4) (lambda (clam-1) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-1)))))))) (let ((e-14 (car arg-4))) (let ((e-15 (cdr arg-4))) (cond ((equal? e-15 "") (lambda (eta-0) (let ((act-1 (TTImpC-45InteractiveC-45Completion-nameCompletion arg-2 e-14 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (if (null? e-7) (vector 1 '()) (vector 1 (box (cons "" e-7))))))) eff-0) eta-0)))))))(else (lambda (clam-0) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-0)))))))))))))) ((4) (if (null? arg-4) (lambda (clam-3) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-3)))))))) (let ((e-18 (car arg-4))) (let ((e-19 (cdr arg-4))) (cond ((equal? e-19 "") (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons "" __infixTupleSection-0)) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-18 (cons "on" (cons "off" '())))))))(else (lambda (clam-2) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-2)))))))))))))) ((5) (if (null? arg-4) (lambda (clam-5) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-5)))))))) (let ((e-22 (car arg-4))) (let ((e-23 (cdr arg-4))) (cond ((equal? e-23 "") (TTImpC-45InteractiveC-45Completion-case--pragmaCompletionC-44go-2548 arg-0 arg-1 arg-2 e-6 e-22 (DataC-45String-strM e-22)))(else (lambda (clam-4) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-4)))))))))))))) ((8) (if (null? arg-4) (lambda (clam-7) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-7)))))))) (let ((e-26 (car arg-4))) (let ((e-27 (cdr arg-4))) (cond ((equal? e-27 "") (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons "" __infixTupleSection-0)) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-26 csegen-800)))))(else (lambda (clam-6) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-6)))))))))))))) ((9) (if (null? arg-4) (lambda (clam-9) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-9)))))))) (let ((e-30 (car arg-4))) (let ((e-31 (cdr arg-4))) (cond ((equal? e-31 "") (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons "" __infixTupleSection-0)) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-30 (cons "partial" (cons "covering" (cons "total" '()))))))))(else (lambda (clam-8) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc4 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc4))) (let ((e-3 (cdr sc4))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-8))))))))))))))(else (lambda (clam-10) (if (null? arg-4) (vector 1 '()) (let ((e-9 (car arg-4))) (let ((e-10 (cdr arg-4))) (let ((sc2 (DataC-45String-break csegen-3961 e-10))) (let ((e-2 (car sc2))) (let ((e-3 (cdr sc2))) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (case (vector-ref eta-0 0) ((0) (let ((e-4 (vector-ref eta-0 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref eta-0 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (let ((e-8 (car eta-1))) (let ((e-4 (cdr eta-1))) (cons (string-append (string-append e-9 e-2) e-8) e-4)))) e-7)))))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go arg-0 arg-1 arg-2 e-6 (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) e-3)) clam-10)))))))))))))))
(define TTImpC-45InteractiveC-45Completion-case--pragmaCompletion-2378 (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) '() (box (cons "" arg-2)))))
(define TTImpC-45InteractiveC-45Completion-pragmaCompletion (lambda (arg-0 arg-1 arg-2) (if (null? arg-1) (lambda (eta-0) (vector 1 (TTImpC-45InteractiveC-45Completion-case--pragmaCompletion-2378 arg-2 arg-0 (PreludeC-45Basics-flip csegen-1631 IdrisC-45SyntaxC-45Pragmas-allPragmas (lambda (u--prag) (let ((prag-0 (IdrisC-45SyntaxC-45Pragmas-u--show_Show_KwPragma u--prag))) (PreludeC-45Types-u--C-62C-62C-61_Monad_Maybe (PreludeC-45Interfaces-guard csegen-258 (DataC-45String-isPrefixOf (string-append "%" arg-2) prag-0)) (lambda (_-10649) (box prag-0))))))))) (let ((e-2 (unbox arg-1))) (TTImpC-45InteractiveC-45Completion-n--12400-2410-u--go e-2 arg-2 arg-0 (IdrisC-45SyntaxC-45Pragmas-pragmaArgs e-2) (DataC-45String-break (lambda (eta-0) (PreludeC-45Types-isSpace eta-0)) arg-2))))))
(define TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32completion-2905 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) (lambda (eta-0) (vector 1 '())) (let ((e-1 (car arg-5))) (let ((e-2 (cdr arg-5))) (cond ((equal? e-1 "logging") (if (null? e-2) (lambda (eta-0) (vector 1 (box (cons (string-append arg-2 ":logging") (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (string-append " " (PreludeC-45Show-u--show_Show_String (Builtin-fst eta-1)))) CoreC-45OptionsC-45Log-knownTopics))))) (if (null? e-2) (let ((u--commands csegen-5691)) (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (cons arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-6) (string-append ":" arg-6)) eta-1))) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-1 u--commands))))) (cond ((equal? e-1 "logging") (lambda (clam-0) (if (null? e-2) (vector 1 '()) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons (string-append arg-2 ":logging ") __infixTupleSection-0)) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-4 csegen-5693))) (vector 1 '())))))))(else (lambda (eta-0) (vector 1 '())))))))(else (if (null? e-2) (let ((u--commands csegen-5691)) (lambda (eta-0) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-1) (cons arg-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (arg-6) (string-append ":" arg-6)) eta-1))) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-1 u--commands))))) (cond ((equal? e-1 "logging") (lambda (clam-1) (if (null? e-2) (vector 1 '()) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (__infixTupleSection-0) (cons (string-append arg-2 ":logging ") __infixTupleSection-0)) (TTImpC-45InteractiveC-45Completion-oneOfCompletion e-4 csegen-5693))) (vector 1 '())))))))(else (lambda (eta-0) (vector 1 '()))))))))))))
(define TTImpC-45InteractiveC-45Completion-completion (lambda (arg-0 arg-1) (let ((sc0 (TTImpC-45InteractiveC-45Completion-parseTask arg-1))) (if (null? sc0) (lambda (eta-0) (vector 1 '())) (let ((e-1 (unbox sc0))) (if (null? e-1) (lambda (eta-0) (vector 1 '())) (let ((e-4 (car e-1))) (let ((e-5 (cdr e-1))) (case (vector-ref e-5 0) ((0) (let ((e-0 (vector-ref e-5 1))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (box (cons e-4 e-6))))))) (lambda (eta-1) (TTImpC-45InteractiveC-45Completion-nameCompletion arg-0 e-0 eta-1)) eta-0)))) ((2) (let ((e-3 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-6 (vector-ref eta-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref eta-1 1))) (vector 1 (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-2) (let ((e-8 (car eta-2))) (let ((e-7 (cdr eta-2))) (cons (string-append e-4 e-8) e-7)))) e-6)))))) (TTImpC-45InteractiveC-45Completion-pragmaCompletion arg-0 e-3 e-2) eta-0))))) (else (let ((e-3 (vector-ref e-5 1))) (let ((u--task (vector 1 e-3))) (TTImpC-45InteractiveC-45Completion-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32completion-2905 arg-1 arg-0 e-4 e-3 u--task (DataC-45String-words e-3))))))))))))))
(define LibrariesC-45DataC-45PosMap-u--showPrec_Show_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2 arg-3) (PreludeC-45Show-showCon arg-2 "fromList" (PreludeC-45Show-showArg (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 arg-1 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40ListC-32C-36aC-41 arg-1 u--d u--x)))) (LibrariesC-45DataC-45PosMap-u--foldr_Foldable_PosMap csegen-103 '() arg-3)))))
(define LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (lambda (arg-1 arg-2) (LibrariesC-45DataC-45PosMap-u--showPrec_Show_C-40PosMapC-32C-36aC-41 arg-1 (vector 0 ) arg-2)))
(define CoreC-45Metadata-allSemanticHighlighting (lambda (arg-0 arg-1) (let ((u--semHigh (let ((e-7 (vector-ref arg-1 7))) e-7))) (lambda (eta-0) (let ((act-1 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.highlight" 19 (lambda () (string-append "Semantic metadata is: " (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 csegen-2056 u--semHigh))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((u--aliases (PreludeC-45Basics-flip csegen-2145 (let ((e-8 (vector-ref arg-1 8))) e-8) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((u--decors ((PreludeC-45Basics-uncurry csegen-2147 (Builtin-snd e-3)) u--semHigh))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-1) (let ((e-6 (car lamc-1))) (let ((e-4 (cdr lamc-1))) (let ((e-8 (car e-6))) (cons (cons e-8 (Builtin-snd e-2)) e-4))))) u--decors)))))))) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.highlight.alias" 19 (lambda () (string-append "Semantic metadata from aliases is: " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2056 u--aliases))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((u--defaults (PreludeC-45Basics-flip csegen-2145 (let ((e-9 (vector-ref arg-1 9))) e-9) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-8 (car e-2))) (let ((e-7 (cdr e-2))) (let ((u--decor (cons (cons e-8 e-7) e-3))) (let ((sc4 ((PreludeC-45Basics-uncurry csegen-2147 e-7) u--semHigh))) (if (null? sc4) (cons u--decor '()) '()))))))))))) (vector 1 (LibrariesC-45DataC-45PosMap-union (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) (LibrariesC-45DataC-45PosMap-fromList (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) u--aliases) (LibrariesC-45DataC-45PosMap-union (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) (LibrariesC-45DataC-45PosMap-fromList (lambda (eta-1) (LibrariesC-45DataC-45PosMap-u--measure_Measure_C-40C-124C-40C-40BuiltinC-46PairC-32NonEmptyFCC-41C-32C-36aC-41C-44C-40C-40BuiltinC-46MkPairC-32NonEmptyFCC-41C-32C-36aC-41C-124C-41 eta-1)) u--defaults) u--semHigh)))))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-printOutput (lambda (arg-0 arg-1 arg-2 ext-0) (let ((act-1 (let ((act-1 (unbox arg-1))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((e-8 (vector-ref e-5 8))) (case (vector-ref e-8 0) ((1) (lambda (eta-0) (vector 1 (vector 0 )))) (else (let ((e-20 (vector-ref e-8 1))) (let ((e-18 (vector-ref e-8 3))) (IdrisC-45IDEModeC-45Commands-send arg-0 e-18 (vector 2 (vector 1 (cons arg-2 '())) e-20))))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-lwOutputHighlight (lambda (arg-0 arg-1 arg-2) (let ((e-2 (car arg-2))) (let ((e-3 (cdr arg-2))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (IdrisC-45IDEModeC-45SyntaxHighlight-printOutput arg-0 arg-1 (vector 1 (cons (IdrisC-45IDEModeC-45Commands-u--cast_Cast_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32NonEmptyFCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32NonEmptyFCC-41C-124C-41_FileContext (cons e-2 e-6)) e-7)) clam-0))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-outputHighlight (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45IDEModeC-45SyntaxHighlight-printOutput arg-0 arg-1 (vector 0 arg-2) ext-0)))
(define IdrisC-45IDEModeC-45SyntaxHighlight-outputNameSyntax (lambda (arg-0 arg-1 arg-2 arg-3) (let ((e-2 (car arg-3))) (let ((e-3 (cdr arg-3))) (lambda (clam-0) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (let ((e-10 (car e-7))) (let ((e-11 (cdr e-7))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.highlight" 20 (lambda () (string-append "highlighting at " (string-append (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2043 e-6) (string-append ": " (string-append (CoreC-45Name-u--show_Show_Name e-11) (string-append "\xa;As: " (ProtocolC-45IDEC-45Decoration-u--show_Show_Decoration e-10))))))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((sc5 (CoreC-45Name-displayName e-11))) (let ((e-9 (car sc5))) (let ((e-4 (cdr sc5))) (IdrisC-45IDEModeC-45SyntaxHighlight-outputHighlight arg-0 arg-2 (vector (IdrisC-45IDEModeC-45Commands-u--cast_Cast_C-40C-124C-40C-40BuiltinC-46PairC-32FileNameC-41C-32NonEmptyFCC-41C-44C-40C-40BuiltinC-46MkPairC-32FileNameC-41C-32NonEmptyFCC-41C-124C-41_FileContext (cons e-2 e-6)) e-4 0 "" e-10 "" "" (PreludeC-45Types-maybe (lambda () "") (lambda () (lambda (eta-1) (CoreC-45NameC-45Namespace-u--show_Show_Namespace eta-1))) e-9)) eta-0)))))))))) eff-0) clam-0)))))))))))))
(define IdrisC-45IDEModeC-45SyntaxHighlight-outputSyntaxHighlighting (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (let ((act-1 (unbox arg-3))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((sc1 (let ((e-16 (vector-ref e-5 16))) e-16))) (cond ((equal? sc1 1) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (CoreC-45Directory-ctxtPathToNS arg-0 arg-4 eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (eta-2) (let ((act-4 ((CoreC-45Metadata-allSemanticHighlighting arg-0 e-6) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-3 (cdr lamc-0))) (let ((e-10 (car e-3))) (let ((e-9 (cdr e-3))) (if (null? e-9) (IdrisC-45IDEModeC-45SyntaxHighlight-lwOutputHighlight arg-0 arg-3 (cons arg-4 (cons e-2 e-10))) (let ((e-4 (unbox e-9))) (IdrisC-45IDEModeC-45SyntaxHighlight-outputNameSyntax arg-0 arg-2 arg-3 (cons arg-4 (cons e-2 (cons e-10 e-4))))))))))) (LibrariesC-45DataC-45PosMap-u--toList_Foldable_PosMap e-8)))) eff-0) eta-2)))))))) eff-0) eta-1))))))) eff-0) eta-0)))))) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 arg-5))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45REPL-replWrap (lambda (arg-0 ext-0) (let ((act-1 (arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-5))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Opts-setSynHighlightOn (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (vector e-0 e-1 e-2 e-3 e-4 e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 arg-1)))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45IDEModeC-45REPL-todoCmd (lambda (arg-0 arg-1 arg-2 ext-0) (IdrisC-45REPLC-45Common-iputStrLn arg-0 arg-1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow (string-append arg-2 ": command not yet implemented. Hopefully soon!")) ext-0)))
(define IdrisC-45IDEModeC-45REPL-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (lambda (eta-1) (IdrisC-45REPL-interpret arg-0 arg-1 arg-2 arg-3 arg-4 e-0 eta-1)) eta-0)))) ((1) (let ((e-1 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45Package-findIpkg arg-0 arg-4 arg-2 (box e-1) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (let ((u--fname (if (null? e-5) e-1 (let ((e-3 (unbox e-5))) e-3)))) (lambda (eta-1) (IdrisC-45IDEModeC-45REPL-replWrap (lambda (eta-2) (let ((act-2 ((IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 6 u--fname)) eta-2))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-3) (IdrisC-45IDEModeC-45SyntaxHighlight-outputSyntaxHighlighting arg-0 arg-3 arg-2 arg-4 u--fname e-6 eta-3)))) eff-0) eta-2)))))) eta-1))))) eff-0) eta-0)))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (let ((e-4 (vector-ref arg-5 2))) (lambda (clam-0) (if (null? e-4) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName (vector 1 (CoreC-45Name-mkUserName e-3)) (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--dat (PreludeC-45TypesC-45List-mapAppend '() (lambda (lamc-0) (let ((e-2 (car lamc-0))) (let ((e-7 (cdr lamc-0))) (let ((e-8 (cdr e-7))) (cons e-2 (let ((e-0 (vector-ref e-8 0))) e-0)))))) e-6))) (lambda (eta-1) (vector 1 (vector 6 u--dat)))))) eff-0) eta-0)))))))) eff-0) clam-0))))) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "name-at <name> <line> <column>" clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else csegen-5683)))))))) ((2) (let ((e-5 (vector-ref arg-5 1))) (let ((e-6 (vector-ref arg-5 2))) (if (null? e-6) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 2 (vector 0 CoreC-45FC-replFC (vector 1 (CoreC-45Name-mkUserName e-5))))) eta-0)) (let ((e-51 (unbox e-6))) (lambda (clam-0) (let ((e-54 (car e-51))) (let ((e-55 (cdr e-51))) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 0 (blodwen-toSignedInt e-54 63) (blodwen-toSignedInt e-55 63) (vector 1 (CoreC-45Name-mkUserName e-5))))) clam-0))))))))) ((4) (let ((e-7 (vector-ref arg-5 1))) (let ((e-8 (vector-ref arg-5 2))) (let ((e-9 (vector-ref arg-5 3))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 1 0 (blodwen-toSignedInt e-7 63) (blodwen-toSignedInt e-8 63) (vector 1 (CoreC-45Name-mkUserName e-9))))) eta-0)))))) ((5) (let ((e-10 (vector-ref arg-5 1))) (let ((e-11 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 2 0 (blodwen-toSignedInt e-10 63) (vector 1 (CoreC-45Name-mkUserName e-11))))) eta-0))))) ((6) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "add-missing" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else csegen-5683))))) ((7) (let ((e-14 (vector-ref arg-5 1))) (let ((e-15 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 4 0 (blodwen-toSignedInt e-14 63) (vector 1 (vector 0 e-15))))) eta-0))))) ((8) (let ((e-16 (vector-ref arg-5 1))) (let ((e-17 (vector-ref arg-5 2))) (let ((e-18 (vector-ref arg-5 3))) (let ((sc1 (ParserC-45Source-runParser 1 (vector 2 (vector 0 )) '() e-18 IdrisC-45Parser-aPTerm))) (case (vector-ref sc1 0) ((1) (let ((e-2 (vector-ref sc1 1))) (let ((e-9 (cdr e-2))) (lambda (clam-1) (let ((e-13 (cdr e-9))) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 3 0 (blodwen-toSignedInt e-16 63) (vector 1 (vector 0 e-17)) e-13))) clam-1)))))) (else (let ((e-5 (vector-ref sc1 1))) (lambda (eta-0) (vector 1 (vector 0 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (CoreC-45Core-u--show_Show_Error e-5)))))))))))))) ((9) (let ((e-19 (vector-ref arg-5 1))) (let ((e-20 (vector-ref arg-5 2))) (let ((e-21 (vector-ref arg-5 3))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 5 0 (blodwen-toSignedInt e-19 63) (vector 1 (vector 0 e-20)) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (vector 1 (vector 0 eta-1))) e-21)))) eta-0)))))) ((10) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 6 ))) eta-0))) ((11) (let ((e-23 (vector-ref arg-5 1))) (let ((e-24 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 7 0 (blodwen-toSignedInt e-23 63) (vector 1 (vector 0 e-24)) 0))) eta-0))))) ((12) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 8 ))) eta-0))) ((13) (let ((e-25 (vector-ref arg-5 1))) (let ((e-26 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 9 0 (blodwen-toSignedInt e-25 63) (vector 1 (CoreC-45Name-mkUserName e-26))))) eta-0))))) ((14) (let ((e-27 (vector-ref arg-5 1))) (let ((e-28 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 10 0 (blodwen-toSignedInt e-27 63) (vector 1 (CoreC-45Name-mkUserName e-28))))) eta-0))))) ((15) (let ((e-29 (vector-ref arg-5 1))) (let ((e-30 (vector-ref arg-5 2))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 28 (vector 11 0 (blodwen-toSignedInt e-29 63) (vector 1 (CoreC-45Name-mkUserName e-30))))) eta-0))))) ((16) (let ((e-31 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 22 (vector 3 (vector 0 (vector 2 ) (vector 1 (CoreC-45Name-mkUserName e-31)))))) eta-0)))) ((18) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "apropros" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else csegen-5684))))) ((17) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "directive" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else csegen-5684))))) ((20) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "who-calls" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 2 '()))))))) ((21) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "calls-who" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 2 '()))))))) ((22) (let ((e-37 (vector-ref arg-5 1))) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 23 (CoreC-45NameC-45Namespace-mkNamespace e-37))) eta-0)))) ((23) (let ((e-38 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "normalise-term" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 4 e-38)))))))) ((24) (let ((e-39 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "show-term-implicits" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 4 e-39)))))))) ((25) (let ((e-40 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "hide-term-implicits" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 4 e-40)))))))) ((26) (let ((e-41 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "elaborate-term" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 5 e-41)))))))) ((27) (let ((e-42 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-todoCmd arg-0 arg-4 "print-definition" eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-42)))))))))) ((28) (let ((e-43 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((TTImpC-45InteractiveC-45Completion-completion arg-0 e-43) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (if (null? e-5) (vector 1 (vector 0 (vector 1 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-vcat (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-u--fromString_FromString_C-40DocC-32C-36annC-41 "I can't make sense of the completion task:") (cons (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 e-43) '())))))) (let ((e-1 (unbox e-5))) (let ((e-7 (car e-1))) (let ((e-6 (cdr e-1))) (vector 1 (vector 1 e-6 e-7))))))))) eff-0) eta-0)))))))) ((29) (let ((e-44 (vector-ref arg-5 1))) (lambda (eta-0) (let ((act-1 ((IdrisC-45REPLC-45Opts-setSynHighlightOn arg-4 e-44) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 (vector 0 (vector 6 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Syntax highlight option changed to") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-byShow csegen-1024 e-44))))))))))) ((30) (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 30 )) eta-0))) ((19) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO (lambda (eta-1) (case (vector-ref eta-1 0) ((0) (let ((e-2 (vector-ref eta-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref eta-1 1))) (vector 1 (vector 3 e-5)))))) (lambda (eta-1) (IdrisC-45IDEModeC-45Holes-getUserHolesData arg-0 arg-2 eta-1)) eta-0))) (else (lambda (eta-0) (IdrisC-45IDEModeC-45REPL-replWrap (IdrisC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 (vector 16 )) eta-0))))))
(define IdrisC-45IDEModeC-45REPL-processCatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45Context-branch arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (unbox arg-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (let ((act-3 (unbox arg-2))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (let ((act-4 (unbox arg-4))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-4) (let ((act-5 ((IdrisC-45IDEModeC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) eta-4))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-6 (CoreC-45Context-commit arg-0 eta-5))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (vector 1 e-9))))))) eff-0) eta-4)))))) (lambda (u--err) (lambda (eta-4) (let ((act-5 (let ((act-5 (set-box! arg-0 e-5))) (vector 1 act-5)))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 (set-box! arg-1 e-6))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 (let ((act-7 (set-box! arg-2 e-7))) (vector 1 act-7)))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (let ((act-8 (set-box! arg-4 e-8))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (IdrisC-45Error-perror arg-0 arg-2 arg-4 u--err eta-4))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (lambda (eta-5) (vector 1 (vector 0 (vector 1 e-13)))))) eff-0) eta-4))))))))))))))))))) eta-3)))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45REPL-n--19511-5649-u--updateOutput (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getOutput arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (case (vector-ref e-5 0) ((0) (let ((e-1 (vector-ref e-5 2))) (let ((e-2 (vector-ref e-5 3))) (IdrisC-45REPLC-45Opts-setOutput arg-0 (vector 0 arg-5 e-1 e-2)))))(else (lambda (eta-0) (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-5911 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14) (if (null? arg-14) (lambda () (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-printIDEError arg-0 arg-4 arg-5 arg-7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Unrecognised command:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 (ProtocolC-45SExp-u--show_Show_SExp arg-13))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (IdrisC-45IDEModeC-45REPL-loop arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)))))) (let ((e-1 (unbox arg-14))) (let ((e-5 (car e-1))) (let ((e-6 (cdr e-1))) (lambda () (lambda (eta-0) (let ((act-1 (IdrisC-45IDEModeC-45REPL-n--19511-5649-u--updateOutput arg-0 arg-1 arg-2 arg-3 arg-4 e-6 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (IdrisC-45IDEModeC-45REPL-processCatch arg-4 arg-3 arg-2 arg-1 arg-0 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((IdrisC-45IDEModeC-45REPL-handleIDEResult arg-4 arg-3 arg-2 arg-1 arg-0 arg-5 e-6 e-8) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (IdrisC-45IDEModeC-45REPL-loop arg-4 arg-3 arg-2 arg-1 arg-0 eta-1))))))) eff-0) eta-0))))))))))))))))
(define IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-5824 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13) (case (vector-ref arg-13 0) ((0) (let ((e-2 (vector-ref arg-13 1))) (lambda () (lambda (eta-0) (let ((act-1 (let ((act-1 (IdrisC-45Error-perror arg-4 arg-2 arg-0 e-2 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-1) (IdrisC-45IDEModeC-45REPL-printIDEError arg-0 arg-4 arg-5 arg-7 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Parse error:") e-5) eta-1)))) eff-0) eta-0))))))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (IdrisC-45IDEModeC-45REPL-loop arg-4 arg-3 arg-2 arg-1 arg-0 eta-0)))))))) (else (let ((e-5 (vector-ref arg-13 1))) (IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-5911 arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 e-5 (IdrisC-45IDEModeC-45Commands-getMsg e-5)))))))
(define IdrisC-45IDEModeC-45REPL-loop (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getOutput arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (IdrisC-45REPLC-45Common-printError arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Running idemode but output isn't") clam-0)) (else (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((act-2 (let ((act-2 (IdrisC-45IDEModeC-45REPL-getInput e-2 clam-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((u--res (vector 0 e-1 e-2 e-3))) (lambda (clam-1) (let ((e-7 (car e-6))) (let ((e-4 (cdr e-6))) (let ((act-3 (CoreC-45ContextC-45Log-log arg-0 "ide-mode.recv" 50 (lambda () (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Received: " (cons (DataC-45Maybe-fromMaybe (lambda () "") e-7) (cons e-4 '()))))) clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-8 (vector-ref act-3 1))) (vector 0 e-8))) (else (let ((act-4 (let ((act-4 ((SystemC-45FileC-45ReadWrite-fEOF csegen-82 e-2) clam-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-9 (vector-ref act-4 1))) (vector 0 e-9))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (cond ((equal? e-9 1) (lambda (eta-0) (vector 1 (vector 0 )))) (else ((let ((_-0 (cons e-7 e-4))) (IdrisC-45IDEModeC-45REPL-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32loop-5824 arg-4 arg-3 arg-2 arg-1 arg-0 e-3 e-2 e-1 u--res e-7 e-4 _-0 e-9 (IdrisC-45IDEModeC-45Parser-parseSExp e-4)))))))) eff-0) clam-1)))))))))))))) eff-0) clam-0))))))))))))) eff-0) ext-0)))))))
(define IdrisC-45IDEModeC-45REPL-replIDE (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 (IdrisC-45REPLC-45Opts-getOutput arg-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (IdrisC-45REPLC-45Common-printError arg-4 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "Running idemode but output isn't") clam-0)) (else (let ((e-3 (vector-ref e-5 3))) (let ((act-2 ((IdrisC-45IDEModeC-45Commands-send arg-0 e-3 (vector 0 2 1)) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (IdrisC-45IDEModeC-45REPL-loop arg-0 arg-1 arg-2 arg-3 arg-4 clam-0)))))))))) eff-0) ext-0)))))))
(define IdrisC-45REPLC-45Opts-litStyle (lambda (ext-0) (PreludeC-45Types-u--join_Monad_Maybe (PreludeC-45Types-u--map_Functor_Maybe (lambda (eta-0) (ParserC-45Unlit-isLitFile eta-0)) ext-0))))
(define IdrisC-45REPLC-45Opts-setMainFile (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-17 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (vector e-0 e-1 e-2 arg-1 (IdrisC-45REPLC-45Opts-litStyle arg-1) e-17 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45Driver-showInfo (lambda (arg-0 arg-1 arg-2) (if (null? arg-2) (lambda (eta-0) (vector 1 0)) (let ((e-3 (cdr arg-2))) (IdrisC-45Driver-showInfo arg-0 arg-1 e-3)))))
(define CoreC-45ContextC-45Log-n--8658-5497-u--addZeros (lambda (arg-0 arg-1) (if (null? arg-1) "000" (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (if (null? e-3) (string-append "00" (string e-2)) (let ((e-6 (car e-3))) (let ((e-7 (cdr e-3))) (if (null? e-7) (string-append "0" (string-append (string e-2) (string e-6))) (PreludeC-45Types-fastPack arg-1))))))))))
(define CoreC-45ContextC-45Log-n--8658-5498-u--showTimeLog (lambda (arg-0 arg-1) (lambda (clam-0) (let ((e-2 (car arg-1))) (let ((e-3 (cdr arg-1))) (let ((e-7 (cdr e-3))) (let ((act-1 (let ((act-1 (PreludeC-45IO-prim__putStr (string-append e-2 ": ") clam-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (string-append (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer e-7 CoreC-45ContextC-45Log-nano)) (string-append "." (string-append (CoreC-45ContextC-45Log-n--8658-5497-u--addZeros arg-0 (PreludeC-45Types-fastUnpack (PreludeC-45Show-u--show_Show_Integer (PreludeC-45Num-u--div_Integral_Integer (PreludeC-45Num-u--mod_Integral_Integer e-7 CoreC-45ContextC-45Log-nano) CoreC-45ContextC-45Log-micro)))) "s"))) "\xa;") clam-0))) (vector 1 act-2)))))))))))
(define CoreC-45ContextC-45Log-showTimeRecord (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-0) (CoreC-45ContextC-45Log-n--8658-5498-u--showTimeLog arg-0 eta-0)) (LibrariesC-45DataC-45StringMap-toList (let ((e-27 (vector-ref e-5 27))) e-27))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-readMetadata (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 (LibrariesC-45UtilsC-45Binary-readFromFile arg-0 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (case (vector-ref e-5 0) ((1) (let ((e-2 (vector-ref e-5 1))) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Binary.Prims.Bin" ) e-2) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Metadata-u--fromBuf_TTC_TTMFile e-6 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-1 (cdr e-7))) (vector 1 e-1))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) (else (let ((e-6 (vector-ref e-5 1))) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append arg-0 (string-append ": " (SystemC-45FileC-45Error-u--show_Show_FileError e-6)))) clam-0))))))) eff-0) ext-0)))))))
(define CoreC-45Metadata-u--show_Show_Metadata (lambda (arg-0) (let ((e-0 (vector-ref arg-0 0))) (let ((e-1 (vector-ref arg-0 1))) (let ((e-2 (vector-ref arg-0 2))) (let ((e-3 (vector-ref arg-0 3))) (let ((e-4 (vector-ref arg-0 4))) (let ((e-5 (vector-ref arg-0 5))) (let ((e-6 (vector-ref arg-0 6))) (let ((e-7 (vector-ref arg-0 7))) (let ((e-8 (vector-ref arg-0 8))) (let ((e-9 (vector-ref arg-0 9))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (cons "Metadata:\xa; lhsApps: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2120 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2120 u--d u--x)))) e-0) (cons "\xa; names: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2131 e-1) (cons "\xa; type declarations: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2131 e-2) (cons "\xa; current LHS: " (cons (PreludeC-45Show-u--show_Show_C-40MaybeC-32C-36aC-41 csegen-1268 e-3) (cons "\xa; holes: " (cons (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2132 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2132 u--d u--x)))) e-4) (cons "\xa; nameLocMap: " (cons (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2136 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2136 u--d u--x)))) e-5) (cons "\xa; sourceIdent: " (cons (CoreC-45FC-u--show_Show_OriginDesc e-6) (cons "\xa; semanticHighlighting: " (cons (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 csegen-2056 e-7) (cons "\xa; semanticAliases: " (cons (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2140 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-2140 u--d u--x)))) e-8) (cons "\xa; semanticDefaults: " (cons (LibrariesC-45DataC-45PosMap-u--show_Show_C-40PosMapC-32C-36aC-41 csegen-2056 e-9) '())))))))))))))))))))))))))))))))))
(define CoreC-45Metadata-dumpTTM (lambda (arg-0 ext-0) (let ((act-1 (CoreC-45Metadata-readMetadata arg-0 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (CoreC-45Metadata-u--show_Show_Metadata e-5) "\xa;") eta-0))) (vector 1 act-2))))) eff-0) ext-0)))))))
(define IdrisC-45Driver-tryTTM (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((29) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (CoreC-45Metadata-dumpTTM e-4 eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (vector 1 1)))))))(else (IdrisC-45Driver-tryTTM e-3))))))))
(define YaffleC-45Main-processArgs (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) (vector 1 '())) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (lambda (clam-0) (cond ((equal? e-2 "--timing") (if (null? e-3) (vector 1 (box 10)) (let ((act-1 (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (vector 0 )) csegen-2013 clam-0))) (csegen-1969 clam-0)))) (vector 1 act-1))))(else (let ((act-1 (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) (vector 0 )) csegen-2013 clam-0))) (csegen-1969 clam-0)))) (vector 1 act-1))))))))))
(define ParserC-45Source-parseFile (lambda (arg-1 arg-2 arg-3 ext-0) (let ((act-1 ((SystemC-45FileC-45ReadWrite-readFile csegen-82 arg-1) ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (ParserC-45Source-runParser 1 arg-2 (ParserC-45Unlit-isLitFile arg-1) e-2 arg-3))) (else (let ((e-5 (vector-ref act-1 1))) (vector 0 (vector 51 arg-1 e-5))))))))
(define TTImpC-45ProcessDecls-n--15149-14401-u--bindConNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (let ((e-1 (vector-ref arg-9 0))) (let ((e-2 (vector-ref arg-9 1))) (let ((e-3 (vector-ref arg-9 2))) (let ((e-4 (vector-ref arg-9 3))) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-8 e-1 '() arg-1 e-4 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector e-1 e-2 e-3 e-5))))) eff-0) ext-0)))))))))))
(define TTImpC-45ProcessDecls-n--15149-14402-u--bindDataNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 ext-0) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (let ((e-3 (vector-ref arg-9 3))) (let ((e-4 (vector-ref arg-9 4))) (let ((e-5 (vector-ref arg-9 5))) (let ((act-1 (if (null? e-3) (vector 1 '()) (let ((e-6 (unbox e-3))) ((let ((eff-0 (lambda (eta-0) (TTImpC-45BindImplicits-bindTypeNames arg-8 e-1 '() arg-1 e-6 eta-0)))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-1275 eff-0 eta-0))) ext-0))))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-traverseC-39 (lambda (eta-1) (lambda (eta-2) (TTImpC-45ProcessDecls-n--15149-14401-u--bindConNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 eta-1 eta-2))) e-5 '()) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-7 (vector-ref act-2 1))) (vector 0 e-7))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (vector 1 (vector 0 e-1 e-2 e-6 e-4 e-7))))) eff-0) eta-0)))))))) eff-0) ext-0))))))))))) (else (let ((e-7 (vector-ref arg-9 1))) (let ((e-8 (vector-ref arg-9 2))) (let ((e-9 (vector-ref arg-9 3))) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-8 e-7 '() arg-1 e-9 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-8 e-5))))) eff-0) ext-0))))))))))))
(define TTImpC-45ProcessDecls-n--15149-14403-u--bindNames (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9) (lambda (clam-0) (case (vector-ref arg-9 0) ((0) (let ((e-1 (vector-ref arg-9 1))) (let ((e-2 (vector-ref arg-9 2))) (let ((e-3 (vector-ref arg-9 3))) (let ((e-4 (vector-ref arg-9 4))) (let ((e-5 (vector-ref arg-9 5))) (let ((e-12 (vector-ref e-5 0))) (let ((e-13 (vector-ref e-5 1))) (let ((e-14 (vector-ref e-5 2))) (let ((e-15 (vector-ref e-5 3))) (let ((act-1 (TTImpC-45BindImplicits-bindTypeNames arg-8 e-1 '() arg-1 e-15 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-6 (vector-ref act-1 1))) (vector 0 e-6))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 0 e-1 e-2 e-3 e-4 (vector e-12 e-13 e-14 e-6)))))) eff-0) clam-0))))))))))))))) ((1) (let ((e-7 (vector-ref arg-9 1))) (let ((e-8 (vector-ref arg-9 2))) (let ((e-9 (vector-ref arg-9 3))) (let ((e-10 (vector-ref arg-9 4))) (let ((act-1 (TTImpC-45ProcessDecls-n--15149-14402-u--bindDataNames arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 e-10 clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (vector 1 (vector 1 e-7 e-8 e-9 e-5))))) eff-0) clam-0))))))))))(else (vector 1 arg-9))))))
(define TTImpC-45ProcessDecls-processTTImpDecls (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 ((CoreC-45Core-traverse_ (lambda (u--d) (lambda (eta-0) (let ((act-1 ((TTImpC-45ProcessDecls-n--15149-14403-u--bindNames arg-8 arg-0 arg-7 arg-6 arg-5 arg-4 arg-3 arg-2 arg-1 u--d) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (TTImpC-45ElabC-45Check-processDecl arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 '() arg-6 arg-7 e-5))) eff-0) eta-0))))))) arg-8) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 1))))))
(define TTImpC-45Parser-prog (lambda (arg-0) (vector 9 0 (ParserC-45RuleC-45Source-nonEmptyBlock (lambda (eta-0) (TTImpC-45Parser-topDecl arg-0 eta-0))) (lambda () (lambda (u--ds) (vector 0 (TTImpC-45Parser-collectDefs (DataC-45List1-forget u--ds))))))))
(define TTImpC-45ProcessDecls-processTTImpFile (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (CoreC-45Directory-ctxtPathToNS arg-0 arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45ContextC-45Log-logTime arg-0 0 (lambda () "Parsing") (lambda (eta-1) (let ((act-2 (ParserC-45Source-parseFile arg-5 (vector 0 e-5) (vector 9 0 (TTImpC-45Parser-prog (vector 0 e-5)) (lambda () (lambda (u--decls) (vector 12 0 0 ParserC-45RuleC-45Source-eoi (vector 0 u--decls))))) eta-1))) (vector 1 act-2))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (case (vector-ref e-6 0) ((1) (let ((e-2 (vector-ref e-6 1))) (lambda (clam-0) (let ((e-8 (car e-2))) (let ((e-9 (cdr e-2))) (let ((e-13 (cdr e-9))) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-1) (CoreC-45Context-recordWarning arg-0 eta-1)) e-8) clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (CoreC-45ContextC-45Log-logTime arg-0 0 (lambda () "Elaboration") (lambda (eta-1) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-4 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-3) (TTImpC-45ProcessDecls-processTTImpDecls '() arg-0 arg-1 arg-2 arg-3 arg-4 '() '() e-13 eta-3)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((act-5 (CoreC-45UnifyState-checkDelayedHoles arg-2 arg-0 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-3 (vector-ref act-5 1))) (vector 0 e-3))) (else (let ((e-11 (vector-ref act-5 1))) ((let ((eff-0 (lambda (clam-1) (if (null? e-11) (vector 1 1) (let ((e-3 (unbox e-11))) (CoreC-45Core-u--throw_Catchable_Core_Error e-3 clam-1)))))) eff-0) eta-2))))))))) (lambda (u--err) (lambda (eta-2) (let ((act-4 ((let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (CoreC-45Core-u--show_Show_Error u--err) "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-3))) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (vector 1 0)))))) eta-1)) clam-0)))))))))) (else (let ((e-7 (vector-ref e-6 1))) (lambda (eta-1) (let ((act-3 (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (CoreC-45Core-u--show_Show_Error e-7) "\xa;") eta-1))) (vector 1 act-3)))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 0)))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define TTImpC-45Parser-command (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "t") (lambda () (vector 9 0 csegen-2967 (lambda () (lambda (u--tm) (vector 0 (vector 1 u--tm))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "s") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (vector 2 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "es") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (vector 3 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "gd") (lambda () (vector 9 1 ParserC-45RuleC-45Source-intLit (lambda () (lambda (u--l) (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (vector 4 (blodwen-toSignedInt u--l 63) u--n)))))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "missing") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (vector 5 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-keyword "total") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (vector 6 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 1 (ParserC-45RuleC-45Source-exactIdent "di") (lambda () (vector 9 0 ParserC-45RuleC-45Source-name (lambda () (lambda (u--n) (vector 0 (vector 7 u--n))))))))) (lambda () (vector 13 1 1 (vector 11 1 (ParserC-45RuleC-45Source-symbol ":") (lambda () (vector 11 0 (ParserC-45RuleC-45Source-exactIdent "q") (lambda () (vector 0 (vector 8 )))))) (lambda () (vector 9 0 csegen-2967 (lambda () (lambda (u--tm) (vector 0 (vector 0 u--tm))))))))))))))))))))))
(define TTImpC-45InteractiveC-45ExprSearch-exprSearchN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 ext-0) (let ((act-1 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-0 arg-2 arg-6 (lambda (eta-0) (TTImpC-45InteractiveC-45ExprSearch-exprSearch arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 arg-8 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (vector 1 e-2))))) eff-0) ext-0)))))))
(define TTImpC-45InteractiveC-45GenerateDef-makeDefN (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 ext-0) (let ((act-1 (TTImpC-45InteractiveC-45ExprSearch-searchN arg-0 arg-2 arg-6 (lambda (eta-0) (TTImpC-45InteractiveC-45GenerateDef-makeDef arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-7 eta-0)) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (let ((e-2 (car e-5))) (vector 1 e-2))))) eff-0) ext-0)))))))
(define CoreC-45ContextC-45Context-u--show_Show_SCCall (lambda (arg-0) (string-append (CoreC-45Name-u--show_Show_Name (let ((e-0 (vector-ref arg-0 0))) e-0)) (string-append ": " (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (PreludeC-45Show-u--show_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1019 u--x)) (lambda (u--d) (lambda (u--x) (PreludeC-45Show-u--showPrec_Show_C-40C-124C-40C-40BuiltinC-46PairC-32C-36aC-41C-32C-36bC-41C-44C-40C-40BuiltinC-46MkPairC-32C-36aC-41C-32C-36bC-41C-124C-41 csegen-1019 u--d u--x)))) (let ((e-1 (vector-ref arg-0 1))) e-1))))))
(define CoreC-45ContextC-45Context-u--showPrec_Show_SCCall (lambda (arg-0 arg-1) (CoreC-45ContextC-45Context-u--show_Show_SCCall arg-1)))
(define YaffleC-45REPL-showInfo (lambda (arg-0) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (let ((e-7 (cdr e-3))) (let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " ==>\xa;" (string-append "\x9;" (string-append (CoreC-45ContextC-45Context-u--show_Show_Def (let ((e-18 (vector-ref e-7 18))) e-18)) (string-append "\xa;" (string-append "\x9;" (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 (cons (lambda (u--x) (CoreC-45ContextC-45Context-u--show_Show_SCCall u--x)) (lambda (u--d) (lambda (u--x) (CoreC-45ContextC-45Context-u--showPrec_Show_SCCall u--d u--x)))) (let ((e-21 (vector-ref e-7 21))) e-21)) "\xa;"))))))) "\xa;") world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))))))
(define YaffleC-45REPL-n--13090-1190-u--printName (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7) (lambda (clam-0) (let ((e-2 (car arg-7))) (let ((e-3 (cdr arg-7))) (let ((e-7 (cdr e-3))) (let ((act-1 (let ((act-1 (unbox arg-6))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Normalise-normaliseHoles arg-6 '() e-5 '() e-7 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((TTImpC-45Unelab-unelab '() arg-6 '() e-8) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-3 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append (CoreC-45Name-u--show_Show_Name e-2) (string-append " : " (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-2016 e-9))) "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))))))
(define YaffleC-45REPL-process (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (clam-0) (case (vector-ref arg-5 0) ((0) (let ((e-0 (vector-ref arg-5 1))) (let ((act-1 ((TTImpC-45Elab-elabTerm '() arg-0 arg-1 arg-2 arg-3 arg-4 0 (vector 2 ) '() '() '() e-0 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (let ((e-2 (car e-5))) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 (CoreC-45Normalise-normalise arg-0 '() e-6 '() e-2 eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 ((TTImpC-45Unelab-unelab '() arg-0 '() e-7) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-2016 e-8) "\xa;") world-0))) (vector 1 act-5))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))))) eff-0) eta-1))))))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (vector 1 1))))))) eff-0) eta-0)))))))) eff-0) clam-1))))))))) eff-0) clam-0))))))) ((1) (let ((e-1 (vector-ref arg-5 1))) (case (vector-ref e-1 0) ((0) (let ((e-10 (vector-ref e-1 1))) (let ((e-11 (vector-ref e-1 2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyName e-11 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (eta-2) (YaffleC-45REPL-n--13090-1190-u--printName e-10 e-11 arg-4 arg-3 arg-2 arg-1 arg-0 eta-2)) e-6) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 1))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))))(else (let ((act-1 ((TTImpC-45Elab-elabTerm '() arg-0 arg-1 arg-2 arg-3 arg-4 0 (vector 2 ) '() '() '() e-1 '()) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-2) (let ((e-3 (cdr e-5))) (let ((act-2 (let ((act-2 (unbox arg-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-3 ((CoreC-45NormaliseC-45Eval-getTerm e-3) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (CoreC-45Normalise-normaliseHoles arg-0 '() e-6 '() e-7 eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (let ((act-5 ((TTImpC-45Unelab-unelab '() arg-0 '() e-8) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-6 (PreludeC-45IO-prim__putStr (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-2016 e-9) "\xa;") world-0))) (vector 1 act-6))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-3))))) eff-0) eta-2))))))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (vector 1 1))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) clam-2))))))))) eff-0) clam-0))))))))) ((2) (let ((e-2 (vector-ref arg-5 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-3 (vector-ref act-1 1))) (vector 0 e-3))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyName e-2 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-3 (vector-ref act-2 1))) (vector 0 e-3))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-3 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-1) (if (null? e-7) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-1) (let ((e-10 (cdr e-7))) (if (null? e-3) (let ((act-3 (CoreC-45Unify-search '() arg-0 arg-2 (CoreC-45FC-justFC CoreC-45FC-defaultFC) AlgebraC-45ZeroOneOmega-u--top_Top_ZeroOneOmega 0 1000 e-8 e-10 '() clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 (let ((act-4 (unbox arg-0))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (let ((e-12 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 (CoreC-45Normalise-normaliseHoles arg-0 '() e-12 '() e-11 eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-4 (vector-ref act-5 1))) (vector 0 e-4))) (else (let ((e-13 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-6 (let ((act-6 (CoreC-45Context-toFullNames arg-0 csegen-68 e-13 eta-3))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (let ((e-14 (vector-ref act-6 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-7 (PreludeC-45IO-prim__putStr (string-append (CoreC-45TTC-45Term-u--show_Show_C-40TermC-32C-36varsC-41 '() e-14) "\xa;") world-0))) (vector 1 act-7))))) (lambda (eta-4) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-4))))) eff-0) eta-3))))))) (case (vector-ref act-6 0) ((0) (let ((e-4 (vector-ref act-6 1))) (vector 0 e-4))) (else (vector 1 1))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) clam-1))))) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-2 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-1))))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) ((3) (let ((e-3 (vector-ref arg-5 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Context-lookupTyName e-3 (let ((e-0 (vector-ref e-5 0))) e-0) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-6) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-1 (car e-6))) (let ((e-2 (cdr e-6))) (if (null? e-1) (lambda (eta-1) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (Builtin-fst eta-2)) e-6) eta-1)) (let ((e-8 (car e-1))) (let ((e-7 (cdr e-1))) (lambda (clam-2) (if (null? e-7) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-2) (if (null? e-2) (let ((act-3 (TTImpC-45InteractiveC-45ExprSearch-exprSearchN arg-0 arg-1 arg-2 arg-3 arg-4 (CoreC-45FC-justFC CoreC-45FC-defaultFC) 1 e-8 '() clam-2))) (case (vector-ref act-3 0) ((0) (let ((e-4 (vector-ref act-3 1))) (vector 0 e-4))) (else (let ((e-11 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-4 ((CoreC-45Core-traverse_ (lambda (eta-2) (lambda (eta-3) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (TTImpC-45TTImp-u--show_Show_C-40RawImpC-39C-32C-36nmC-41 csegen-65 eta-2) "\xa;") eta-3))) (vector 1 act-4)))) e-11) eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-4 (vector-ref act-4 1))) (vector 0 e-4))) (else (vector 1 1))))))) eff-0) clam-2))))) (CoreC-45Context-ambiguousName arg-0 (CoreC-45FC-justFC CoreC-45FC-defaultFC) e-3 (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6) clam-2)))))))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) ((4) (let ((e-4 (vector-ref arg-5 1))) (let ((e-5 (vector-ref arg-5 2))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (CoreC-45Metadata-findTyDeclAt arg-1 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine e-4 u--p))) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (if (null? e-7) (lambda (eta-1) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (string-append "Can't find declaration for " (CoreC-45Name-u--show_Show_Name e-5)) "\xa;") world-0))) (vector 1 act-3))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 1))))) (let ((e-1 (unbox e-7))) (let ((e-8 (cdr e-1))) (lambda (clam-3) (let ((e-11 (car e-8))) (let ((e-10 (cdr e-8))) (let ((act-3 (let ((act-3 (CoreC-45Context-lookupDefExact e-11 (let ((e-0 (vector-ref e-6 0))) e-0) clam-3))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-3 1))) ((let ((eff-0 (if (null? e-12) (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "Can't find declaration for " (CoreC-45Name-u--show_Show_Name e-5)) "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) (let ((e-2 (unbox e-12))) (case (vector-ref e-2 0) ((0) (lambda (eta-1) (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-2) (let ((act-4 (CoreC-45ContextC-45Log-logTime arg-0 0 (lambda () "Generation") (lambda (eta-3) (TTImpC-45InteractiveC-45GenerateDef-makeDefN arg-0 arg-1 arg-2 arg-3 arg-4 (lambda (u--p) (lambda (u--n) (CoreC-45FC-onLine e-4 u--p))) 1 e-11 eta-3)) eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-3 (vector-ref act-4 1))) (vector 0 e-3))) (else (let ((e-15 (vector-ref act-4 1))) ((let ((eff-0 (if (null? e-15) csegen-2027 (let ((e-16 (car e-15))) (if (null? e-16) csegen-2027 (let ((e-17 (cdr e-16))) (let ((eff-0 (lambda (world-0) (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (PreludeC-45Show-u--show_Show_C-40ListC-32C-36aC-41 csegen-2025 e-17) "\xa;") world-0))) (vector 1 act-5))))) (lambda (eta-3) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-3))))))))) eff-0) eta-2)))))) (lambda (u--err) (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "Can't find a definition for " (CoreC-45Name-u--show_Show_Name e-11)) "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2)))) eta-1)))(else (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr "Already defined\xa;" world-0))) (vector 1 act-4))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))))))))) eff-0) clam-3))))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 1)))))))))))) eff-0) eta-0)))))))) eff-0) clam-0)))))))) ((5) (let ((e-6 (vector-ref arg-5 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-6 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-6) (if (null? e-7) (CoreC-45Context-undefinedName arg-0 CoreC-45FC-emptyFC e-6 clam-6) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (u--fn) (lambda (eta-1) (let ((act-3 (CoreC-45Context-getTotality arg-0 CoreC-45FC-emptyFC u--fn eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-3 1))) ((let ((eff-0 (let ((e-1 (cdr e-8))) (case (vector-ref e-1 0) ((1) (let ((e-2 (vector-ref e-1 1))) (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append (CoreC-45Name-u--show_Show_Name u--fn) (string-append ":\xa;" (CoreC-45NameC-45Namespace-showSep "\xa;" (PreludeC-45TypesC-45List-mapAppend '() csegen-969 e-2)))) "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))))) ((2) (let ((e-2 (vector-ref e-1 1))) (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append (CoreC-45Name-u--show_Show_Name u--fn) (string-append ": Calls non covering function" (if (null? e-2) (string-append "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45Name-u--show_Show_Name eta-2)) e-2))) (let ((e-4 (car e-2))) (let ((e-3 (cdr e-2))) (if (null? e-3) (string-append " " (CoreC-45Name-u--show_Show_Name e-4)) (string-append "s: " (CoreC-45NameC-45Namespace-showSep ", " (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-2) (CoreC-45Name-u--show_Show_Name eta-2)) e-2))))))))) "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2)))))(else (let ((eff-0 (lambda (world-0) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append (CoreC-45Name-u--show_Show_Name u--fn) ": All cases covered") "\xa;") world-0))) (vector 1 act-4))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2)))))))) eff-0) eta-1))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-7)) clam-6))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) ((6) (let ((e-7 (vector-ref arg-5 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Context-lookupCtxtName e-7 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-7) (if (null? e-6) (CoreC-45Context-undefinedName arg-0 CoreC-45FC-emptyFC e-7 clam-7) (let ((act-3 ((CoreC-45Core-traverse_ (lambda (u--fn) (lambda (eta-1) (let ((act-3 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-2) (CoreC-45Termination-checkTotal arg-0 CoreC-45FC-emptyFC u--fn eta-2)) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (CoreC-45Context-getTotality arg-0 CoreC-45FC-emptyFC u--fn eta-1))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-4 1))) ((let ((eff-0 (let ((eff-0 (lambda (world-0) (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (string-append (CoreC-45Name-u--show_Show_Name u--fn) (string-append " is " (CoreC-45TT-u--show_Show_Totality e-9))) "\xa;") world-0))) (vector 1 act-5))))) (lambda (eta-2) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-2))))) eff-0) eta-1)))))))))) (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-1) (Builtin-fst eta-1)) e-6)) clam-7))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (vector 1 1)))))))) eff-0) eta-0)))))))) eff-0) clam-0))))))) ((7) (let ((e-8 (vector-ref arg-5 1))) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 ((CoreC-45Context-lookupCtxtName e-8 (let ((e-0 (vector-ref e-5 0))) e-0)) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (CoreC-45Core-traverse_ (lambda (eta-1) (YaffleC-45REPL-showInfo eta-1)) e-6))) eff-0) eta-0))))))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (vector 1 1))))))) eff-0) clam-0))))))) (else (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr "Bye for now!\xa;" world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) clam-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 0)))))))))
(define YaffleC-45REPL-processCatch (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (CoreC-45Core-u--catch_Catchable_Core_Error (YaffleC-45REPL-process arg-0 arg-1 arg-2 arg-3 arg-4 arg-5) (lambda (u--err) (lambda (eta-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr (string-append (CoreC-45Core-u--show_Show_Error u--err) "\xa;") world-0))) (vector 1 act-1))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (vector 1 1)))))) ext-0)))
(define YaffleC-45REPL-repl (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 ext-0) (let ((act-1 ((let ((eff-0 (lambda (world-0) (let ((act-1 (PreludeC-45IO-prim__putStr "Yaffle> " world-0))) (vector 1 act-1))))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__getStr ext-0))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (let ((sc2 (ParserC-45Source-runParser 1 (vector 2 (vector 0 )) '() e-6 TTImpC-45Parser-command))) (case (vector-ref sc2 0) ((0) (let ((e-2 (vector-ref sc2 1))) (lambda (eta-0) (let ((act-3 ((let ((eff-0 (lambda (world-0) (let ((act-3 (PreludeC-45IO-prim__putStr (string-append (CoreC-45Core-u--show_Show_Error e-2) "\xa;") world-0))) (vector 1 act-3))))) (lambda (eta-1) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-1))) eta-0))) (case (vector-ref act-3 0) ((0) (let ((e-3 (vector-ref act-3 1))) (vector 0 e-3))) (else (YaffleC-45REPL-repl arg-0 arg-1 arg-2 arg-3 arg-4 eta-0))))))) (else (let ((e-7 (vector-ref sc2 1))) (lambda (clam-0) (let ((e-9 (cdr e-7))) (let ((e-13 (cdr e-9))) (let ((act-3 (YaffleC-45REPL-processCatch arg-0 arg-1 arg-2 arg-3 arg-4 e-13 clam-0))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-3 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-10 1) (YaffleC-45REPL-repl arg-0 arg-1 arg-2 arg-3 arg-4 clam-1)) (else (vector 1 (vector 0 ))))))) eff-0) clam-0)))))))))))))) eff-0) ext-0))))))))))
(define YaffleC-45Main-yaffleMain (lambda (arg-0 arg-1 ext-0) (let ((act-1 (CoreC-45Context-initDefs ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 ((CoreC-45Core-newRef (vector "Core.Context.Ctxt" ) e-5) eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 ((YaffleC-45Main-processArgs arg-1) eta-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-4 (CoreC-45Directory-ctxtPathToNS e-6 arg-0 eta-2))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-5 ((CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata (vector 0 e-8))) eta-3))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-6 (csegen-1985 eta-4))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-7 (csegen-1981 eta-5))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((e-11 (vector-ref act-7 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-8 ((CoreC-45Core-newRef (vector "Idris.REPL.Opts.ROpts" ) (IdrisC-45REPLC-45Opts-defaultOpts (box arg-0) (vector 1 1) '())) eta-6))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-9 (if (null? e-7) (vector 1 (vector 0 )) (let ((e-1 (unbox e-7))) ((CoreC-45Context-setLogTimings e-6 e-1) eta-7))))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 ((CoreC-45InitPrimitives-addPrimitives e-6) eta-7))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((act-11 (let ((sc10 (LibrariesC-45UtilsC-45Path-extension arg-0))) (if (null? sc10) (let ((act-11 (csegen-2006 eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (TTImpC-45ProcessDecls-processTTImpFile e-6 e-9 e-10 e-11 e-12 arg-0 eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-16 1) (let ((act-13 (CoreC-45Directory-makeBuildDirectory e-6 e-8 clam-1))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 (CoreC-45Directory-getTTCFileName e-6 arg-0 "ttc" clam-1))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-15 (CoreC-45Binary-writeToTTC csegen-2010 e-6 e-10 (vector 0 ) arg-0 e-18 eta-8))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (csegen-2012 eta-8))))))) eff-0) clam-1))))))))) (else (vector 1 (vector 0 ))))))) eff-0) eta-7)))))))) (let ((e-1 (unbox sc10))) (cond ((equal? e-1 "ttc") (let ((act-11 ((let ((eff-0 (lambda (world-0) (let ((act-11 (PreludeC-45IO-prim__putStr "Processing as TTC\xa;" world-0))) (vector 1 act-11))))) (lambda (eta-8) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-8))) eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (PreludeC-45IO-u--map_Functor_IO csegen-26 (lambda (eta-8) (CoreC-45Binary-readFromTTC csegen-2002 e-6 e-10 1 CoreC-45FC-emptyFC 1 arg-0 CoreC-45NameC-45Namespace-emptyNS CoreC-45NameC-45Namespace-emptyNS eta-8)) eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else ((let ((eff-0 (lambda (world-0) (let ((act-13 (PreludeC-45IO-prim__putStr "Read TTC\xa;" world-0))) (vector 1 act-13))))) (lambda (eta-8) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-8))) eta-7))))))))(else (let ((act-11 (csegen-2006 eta-7))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (TTImpC-45ProcessDecls-processTTImpFile e-6 e-9 e-10 e-11 e-12 arg-0 eta-7))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-16 1) (let ((act-13 (CoreC-45Directory-makeBuildDirectory e-6 e-8 clam-0))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 (CoreC-45Directory-getTTCFileName e-6 arg-0 "ttc" clam-0))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-15 (CoreC-45Binary-writeToTTC csegen-2010 e-6 e-10 (vector 0 ) arg-0 e-18 eta-8))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (csegen-2012 eta-8))))))) eff-0) clam-0))))))))) (else (vector 1 (vector 0 ))))))) eff-0) eta-7))))))))))))))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (YaffleC-45REPL-repl e-6 e-9 e-10 e-11 e-12 eta-7))))))))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))) eff-0) eta-3)))))))) eff-0) eta-2)))))))) eff-0) eta-1)))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Driver-tryYaffle (lambda (arg-0) (if (null? arg-0) (lambda (eta-0) (vector 1 0)) (let ((e-2 (car arg-0))) (let ((e-3 (cdr arg-0))) (case (vector-ref e-2 0) ((28) (let ((e-4 (vector-ref e-2 1))) (lambda (eta-0) (let ((act-1 (YaffleC-45Main-yaffleMain e-4 '() eta-0))) (case (vector-ref act-1 0) ((0) (let ((e-5 (vector-ref act-1 1))) (vector 0 e-5))) (else (vector 1 1)))))))(else (IdrisC-45Driver-tryYaffle e-3))))))))
(define CoreC-45Context-addExtraDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 e-45 e-46 e-47 e-48 (cons arg-1 (PreludeC-45TypesC-45List-filterAppend '() (lambda (arg-2) (PreludeC-45EqOrd-u--C-47C-61_Eq_String arg-2 arg-1)) e-49)) e-50 e-51 e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define CoreC-45Context-addLibDir (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-48 (vector-ref e-43 5))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 e-45 e-46 e-47 e-48 e-49 e-50 (PreludeC-45TypesC-45List-tailRecAppend e-51 (cons arg-1 '())) e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32))))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define SystemC-45FileC-45Meta-isTTY (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-5 (vector-ref e-1 0))) (let ((e-8 (vector-ref e-5 0))) ((((e-8 'erased) 'erased) (lambda (arg-0) (PreludeC-45EqOrd-u--C-47C-61_Eq_Int arg-0 (blodwen-toSignedInt 0 63)))) (let ((e-9 (cdr arg-1))) ((e-9 'erased) (lambda (eta-0) (SystemC-45FileC-45Meta-prim__fileIsTTY arg-2 eta-0))))))))))
(define CoreC-45Context-setPrefix (lambda (arg-0 arg-1) (let ((eff-0 (lambda (world-0) (let ((act-1 (unbox arg-0))) (vector 1 act-1))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-1 (lambda (world-1) (let ((act-2 (set-box! arg-0 (let ((e-0 (vector-ref e-5 0))) (let ((e-1 (vector-ref e-5 1))) (let ((e-2 (vector-ref e-5 2))) (let ((e-3 (vector-ref e-5 3))) (let ((e-4 (vector-ref e-5 4))) (let ((e-33 (vector-ref e-5 5))) (let ((e-6 (vector-ref e-5 6))) (let ((e-7 (vector-ref e-5 7))) (let ((e-8 (vector-ref e-5 8))) (let ((e-9 (vector-ref e-5 9))) (let ((e-10 (vector-ref e-5 10))) (let ((e-11 (vector-ref e-5 11))) (let ((e-12 (vector-ref e-5 12))) (let ((e-13 (vector-ref e-5 13))) (let ((e-14 (vector-ref e-5 14))) (let ((e-15 (vector-ref e-5 15))) (let ((e-16 (vector-ref e-5 16))) (let ((e-17 (vector-ref e-5 17))) (let ((e-18 (vector-ref e-5 18))) (let ((e-19 (vector-ref e-5 19))) (let ((e-20 (vector-ref e-5 20))) (let ((e-21 (vector-ref e-5 21))) (let ((e-22 (vector-ref e-5 22))) (let ((e-23 (vector-ref e-5 23))) (let ((e-24 (vector-ref e-5 24))) (let ((e-25 (vector-ref e-5 25))) (let ((e-26 (vector-ref e-5 26))) (let ((e-27 (vector-ref e-5 27))) (let ((e-28 (vector-ref e-5 28))) (let ((e-29 (vector-ref e-5 29))) (let ((e-30 (vector-ref e-5 30))) (let ((e-31 (vector-ref e-5 31))) (let ((e-32 (vector-ref e-5 32))) (let ((e-43 (vector-ref e-4 0))) (let ((e-34 (vector-ref e-4 1))) (let ((e-35 (vector-ref e-4 2))) (let ((e-36 (vector-ref e-4 3))) (let ((e-37 (vector-ref e-4 4))) (let ((e-38 (vector-ref e-4 5))) (let ((e-39 (vector-ref e-4 6))) (let ((e-40 (vector-ref e-4 7))) (let ((e-41 (vector-ref e-4 8))) (let ((e-42 (vector-ref e-4 9))) (let ((e-53 (vector-ref e-43 0))) (let ((e-44 (vector-ref e-43 1))) (let ((e-45 (vector-ref e-43 2))) (let ((e-46 (vector-ref e-43 3))) (let ((e-47 (vector-ref e-43 4))) (let ((e-49 (vector-ref e-43 6))) (let ((e-50 (vector-ref e-43 7))) (let ((e-51 (vector-ref e-43 8))) (let ((e-52 (vector-ref e-43 9))) (vector e-0 e-1 e-2 e-3 (vector (vector e-53 e-44 e-45 e-46 e-47 arg-1 e-49 e-50 e-51 e-52) e-34 e-35 e-36 e-37 e-38 e-39 e-40 e-41 e-42) e-33 e-6 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))))))))))))))))))))))))) (vector 1 act-2))))) eff-1) world-0)))))))))
(define IdrisC-45Driver-splitPaths (lambda (ext-0) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (DataC-45String-trim eta-0)) (DataC-45String-split csegen-574 ext-0))))
(define CoreC-45Core-traverseList1_ (lambda (arg-2 arg-3) (let ((u--x (let ((e-1 (car arg-3))) e-1))) (let ((u--xs (let ((e-2 (cdr arg-3))) e-2))) (let ((eff-0 (let ((eff-0 (arg-2 u--x))) (lambda (eta-0) (PreludeC-45IO-u--map_Functor_IO csegen-26 eff-0 eta-0))))) (lambda (world-0) (let ((act-1 (eff-0 world-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else ((let ((eff-1 (CoreC-45Core-traverse_ arg-2 u--xs))) eff-1) world-0))))))))))
(define IdrisPaths-yprefix "/opt/local/libexec/idris2")
(define IdrisC-45Driver-updateEnv (lambda (arg-0 arg-1 ext-0) (let ((act-1 (let ((act-1 (unbox arg-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (let ((act-2 (let ((act-2 ((System-getEnv csegen-82 "NO_COLOR") eta-0))) (let ((act-3 ((SystemC-45FileC-45Meta-isTTY csegen-82 SystemC-45FileC-45Virtual-stdout) eta-0))) (let ((sc1 (DataC-45Maybe-isJust act-2))) (cond ((equal? sc1 1) 1) (else (cond ((equal? act-3 1) 0) (else 1))))))))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-3 (cond ((equal? e-6 1) ((IdrisC-45REPLC-45Opts-setColor arg-1 0) eta-1)) (else (vector 1 (vector 0 )))))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((act-4 (let ((act-4 ((System-getEnv csegen-82 "IDRIS2_PREFIX") eta-1))) (vector 1 act-4)))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-5 ((CoreC-45Context-setPrefix arg-0 (DataC-45Maybe-fromMaybe (lambda () IdrisPaths-yprefix) e-8)) eta-2))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((act-6 (let ((act-6 ((System-getEnv csegen-82 "IDRIS2_PATH") eta-2))) (vector 1 act-6)))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((e-10 (vector-ref act-6 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-7 (if (null? e-10) (vector 1 (vector 0 )) (let ((e-1 (unbox e-10))) ((CoreC-45Core-traverseList1_ (lambda (eta-4) (CoreC-45Context-addExtraDir arg-0 eta-4)) (IdrisC-45Driver-splitPaths e-1)) eta-3))))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (let ((act-8 ((System-getEnv csegen-82 "IDRIS2_DATA") eta-3))) (vector 1 act-8)))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((e-12 (vector-ref act-8 1))) ((let ((eff-0 (lambda (eta-4) (let ((act-9 (if (null? e-12) (vector 1 (vector 0 )) (let ((e-1 (unbox e-12))) ((CoreC-45Core-traverseList1_ (lambda (eta-5) (CoreC-45Context-addDataDir arg-0 eta-5)) (IdrisC-45Driver-splitPaths e-1)) eta-4))))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((act-10 (let ((act-10 ((System-getEnv csegen-82 "IDRIS2_LIBS") eta-4))) (vector 1 act-10)))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-11 (if (null? e-14) (vector 1 (vector 0 )) (let ((e-1 (unbox e-14))) ((CoreC-45Core-traverseList1_ (lambda (eta-6) (CoreC-45Context-addLibDir arg-0 eta-6)) (IdrisC-45Driver-splitPaths e-1)) eta-5))))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 (let ((act-12 ((System-getEnv csegen-82 "IDRIS2_PACKAGE_PATH") eta-5))) (vector 1 act-12)))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-13 (if (null? e-16) (vector 1 (vector 0 )) (let ((e-1 (unbox e-16))) ((CoreC-45Core-traverseList1_ (lambda (eta-7) (CoreC-45Context-addPackageDir arg-0 eta-7)) (IdrisC-45Driver-splitPaths e-1)) eta-6))))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((act-14 (let ((act-14 ((System-getEnv csegen-82 "IDRIS2_CG") eta-6))) (vector 1 act-14)))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-15 (if (null? e-18) (vector 1 (vector 0 )) (let ((e-1 (unbox e-18))) (let ((sc15 (CoreC-45Options-getCG (let ((e-4 (vector-ref e-5 4))) e-4) e-1))) (if (null? sc15) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 61 (string-append "Unknown code generator " (PreludeC-45Show-u--show_Show_String e-1))) eta-7) (let ((e-2 (unbox sc15))) ((CoreC-45Context-setCG arg-0 e-2) eta-7)))))))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((act-16 (let ((act-16 ((System-getEnv csegen-82 "IDRIS2_INC_CGS") eta-7))) (vector 1 act-16)))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-17 (if (null? e-20) (vector 1 (vector 0 )) (let ((e-1 (unbox e-20))) ((CoreC-45Core-traverseList1_ (lambda (eta-9) (lambda (eta-10) (IdrisC-45SetOptions-setIncrementalCG arg-0 arg-1 0 eta-9 eta-10))) (DataC-45List1-u--map_Functor_List1 (lambda (eta-9) (DataC-45String-trim eta-9)) (DataC-45String-split (lambda (arg-2) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char arg-2 #\,)) e-1))) eta-8))))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((act-18 (let ((act-18 (unbox arg-0))) (vector 1 act-18)))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-19 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-10) (IdrisC-45SetOptions-addPkgDir arg-0 "prelude" IdrisC-45PackageC-45Types-anyBounds eta-10)) (lambda (eta-10) (lambda (eta-11) (vector 1 (vector 0 )))) eta-9))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((act-20 (CoreC-45Core-u--catch_Catchable_Core_Error (lambda (eta-10) (IdrisC-45SetOptions-addPkgDir arg-0 "base" IdrisC-45PackageC-45Types-anyBounds eta-10)) (lambda (eta-10) (lambda (eta-11) (vector 1 (vector 0 )))) eta-9))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((act-21 ((CoreC-45Context-addDataDir arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-4 (vector-ref e-22 4))) (let ((e-62 (vector-ref e-4 0))) (let ((e-67 (vector-ref e-62 5))) e-67))) (string-append "idris2-" csegen-1634)) "support")) eta-9))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((act-22 ((CoreC-45Context-addLibDir arg-0 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (LibrariesC-45UtilsC-45Path-C-60C-47C-62 (let ((e-4 (vector-ref e-22 4))) (let ((e-63 (vector-ref e-4 0))) (let ((e-68 (vector-ref e-63 5))) e-68))) (string-append "idris2-" csegen-1634)) "lib")) eta-9))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((act-23 (let ((act-23 (csegen-1310 eta-9))) (vector 1 act-23)))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else (let ((e-27 (vector-ref act-23 1))) ((let ((eff-0 (if (null? e-27) csegen-1311 (let ((e-1 (unbox e-27))) (CoreC-45Context-addLibDir arg-0 e-1))))) eff-0) eta-9)))))))))))))))))))) eff-0) eta-8))))))))))) eff-0) eta-7))))))))))) eff-0) eta-6))))))))))) eff-0) eta-5))))))))))) eff-0) eta-4))))))))))) eff-0) eta-3))))))))))) eff-0) eta-2))))))))))) eff-0) eta-1))))))))))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define IdrisC-45Driver-updateREPLOpts (lambda (arg-0 ext-0) (let ((act-1 (let ((act-1 ((System-getEnv csegen-82 "EDITOR") ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (if (null? e-5) (lambda (eta-0) (vector 1 (vector 0 ))) (let ((e-1 (unbox e-5))) (let ((eff-0 (lambda (world-0) (let ((act-2 (unbox arg-0))) (vector 1 act-2))))) (lambda (world-0) (let ((act-2 (eff-0 world-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-1 (lambda (world-1) (let ((act-3 (set-box! arg-0 (let ((e-0 (vector-ref e-6 0))) (let ((e-19 (vector-ref e-6 1))) (let ((e-2 (vector-ref e-6 2))) (let ((e-3 (vector-ref e-6 3))) (let ((e-4 (vector-ref e-6 4))) (let ((e-18 (vector-ref e-6 5))) (let ((e-7 (vector-ref e-6 7))) (let ((e-8 (vector-ref e-6 8))) (let ((e-9 (vector-ref e-6 9))) (let ((e-10 (vector-ref e-6 10))) (let ((e-11 (vector-ref e-6 11))) (let ((e-12 (vector-ref e-6 12))) (let ((e-13 (vector-ref e-6 13))) (let ((e-14 (vector-ref e-6 14))) (let ((e-15 (vector-ref e-6 15))) (let ((e-16 (vector-ref e-6 16))) (vector e-0 e-19 e-2 e-3 e-4 e-18 e-1 e-7 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16)))))))))))))))))))) (vector 1 act-3))))) eff-1) world-0))))))))))) eff-0) ext-0)))))))
(define IdrisC-45Driver-n--15193-2624-u--renderError (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 ext-0) (let ((act-1 (IdrisC-45Error-perror arg-2 arg-3 arg-4 arg-5 ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (eta-0) (let ((act-2 (IdrisC-45Pretty-render arg-4 e-5 eta-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (eta-1) (CoreC-45Core-u--throw_Catchable_Core_Error (vector 62 e-6) eta-1)))) eff-0) eta-0)))))))) eff-0) ext-0)))))))
(define NetworkC-45SocketC-45Data-getErrno (lambda (arg-1) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_errno eta-0))))))
(define NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily (lambda (arg-0) (cond ((equal? arg-0 0) (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_unspec eta-0)))) ((equal? arg-0 1) (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_unix eta-0)))) ((equal? arg-0 2) (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_inet eta-0)))) (else (PrimIO-unsafePerformIO (lambda (eta-0) (NetworkC-45SocketC-45Data-prim__idrnet_af_inet6 eta-0)))))))
(define NetworkC-45SocketC-45Data-getSocketFamily (lambda (arg-0) (DataC-45List-lookup csegen-223 arg-0 (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 0) 0) (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 1) 1) (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 2) 2) (cons (cons (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily 3) 3) '())))))))
(define NetworkC-45SocketC-45Data-n--4359-9662-u--toIntC-39 (lambda (arg-0 ext-0) (cast-string-int ext-0)))
(define NetworkC-45SocketC-45Data-n--4359-9661-u--toInt (lambda (arg-0 arg-1) (blodwen-toSignedInt (NetworkC-45SocketC-45Data-n--4359-9662-u--toIntC-39 arg-0 arg-1) 63)))
(define NetworkC-45SocketC-45Data-n--4359-9660-u--splitted (lambda (arg-0) (DataC-45List1-u--map_Functor_List1 (lambda (eta-0) (NetworkC-45SocketC-45Data-n--4359-9661-u--toInt arg-0 eta-0)) (DataC-45String-split (lambda (u--c) (PreludeC-45EqOrd-u--C-61C-61_Eq_Char u--c #\.)) arg-0))))
(define NetworkC-45SocketC-45Data-parseIPv4 (lambda (arg-0) (let ((sc0 (NetworkC-45SocketC-45Data-n--4359-9660-u--splitted arg-0))) (if (null? sc0) (vector 3 ) (let ((e-1 (car sc0))) (let ((e-2 (cdr sc0))) (if (null? e-2) (vector 3 ) (let ((e-4 (car e-2))) (let ((e-5 (cdr e-2))) (if (null? e-5) (vector 3 ) (let ((e-7 (car e-5))) (let ((e-8 (cdr e-5))) (if (null? e-8) (vector 3 ) (let ((e-10 (car e-8))) (vector 0 e-1 e-4 e-7 e-10)))))))))))))))
(define NetworkC-45SocketC-45Raw-getSockAddr (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_family arg-2 eta-0))))) (lambda (u--addr_family_int) (let ((sc1 (NetworkC-45SocketC-45Data-getSocketFamily u--addr_family_int))) (if (null? sc1) (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Network.Socket.Raw.case block in getSockAddr at Network.Socket.Raw:64:1--75:43")) (let ((e-6 (unbox sc1))) (cond ((equal? e-6 2) (let ((e-8 (car arg-1))) (let ((e-10 (vector-ref e-8 1))) ((((e-10 'erased) 'erased) (let ((e-12 (cdr arg-1))) ((e-12 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_ipv4 arg-2 eta-0))))) (lambda (u--ipv4_addr) (let ((e-13 (car arg-1))) (let ((e-16 (vector-ref e-13 0))) (let ((e-18 (vector-ref e-16 1))) ((e-18 'erased) (NetworkC-45SocketC-45Data-parseIPv4 u--ipv4_addr)))))))))) ((equal? e-6 3) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 1 )))))) ((equal? e-6 1) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-14 (vector-ref e-11 0))) ((((e-14 'erased) 'erased) (lambda (eta-0) (vector 2 eta-0))) (let ((e-15 (cdr arg-1))) ((e-15 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_unix arg-2 eta-0))))))))) ((equal? e-6 0) (let ((e-8 (car arg-1))) (let ((e-11 (vector-ref e-8 0))) (let ((e-13 (vector-ref e-11 1))) ((e-13 'erased) (vector 3 ))))))(else (blodwen-error-quit (string-append "ERROR: " "Unhandled input for Network.Socket.Raw.case block in getSockAddr at Network.Socket.Raw:64:1--75:43")))))))))))))
(define NetworkC-45SocketC-45Raw-sockaddr_free (lambda (arg-1 arg-2) (SystemC-45FFI-free arg-1 arg-2)))
(define NetworkC-45Socket-accept (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_create_sockaddr eta-0))))) (lambda (u--sockaddr_ptr) (let ((e-7 (car arg-1))) (let ((e-9 (vector-ref e-7 1))) ((((e-9 'erased) 'erased) (let ((e-11 (cdr arg-1))) ((e-11 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_accept (let ((e-0 (vector-ref arg-2 0))) e-0) u--sockaddr_ptr eta-0))))) (lambda (u--accept_res) (let ((sc2 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--accept_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc2 1) (let ((e-12 (car arg-1))) (let ((e-15 (vector-ref e-12 0))) (let ((e-18 (vector-ref e-15 0))) ((((e-18 'erased) 'erased) (lambda (eta-0) (vector 0 eta-0))) (NetworkC-45SocketC-45Data-getErrno arg-1)))))) (else (let ((e-13 (vector-ref arg-2 1))) (let ((e-12 (vector-ref arg-2 2))) (let ((e-11 (vector-ref arg-2 3))) (let ((e-15 (car arg-1))) (let ((e-17 (vector-ref e-15 1))) ((((e-17 'erased) 'erased) (NetworkC-45SocketC-45Raw-getSockAddr arg-1 u--sockaddr_ptr)) (lambda (u--sockaddr) (let ((e-20 (car arg-1))) (let ((e-22 (vector-ref e-20 1))) ((((e-22 'erased) 'erased) (NetworkC-45SocketC-45Raw-sockaddr_free arg-1 u--sockaddr_ptr)) (lambda (_-10649) (let ((e-25 (car arg-1))) (let ((e-28 (vector-ref e-25 0))) (let ((e-30 (vector-ref e-28 1))) ((e-30 'erased) (vector 1 (cons (vector u--accept_res e-13 e-12 e-11) u--sockaddr))))))))))))))))))))))))))))))
(define NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketType (lambda (arg-0) (cond ((equal? arg-0 0) 0) ((equal? arg-0 1) 1) ((equal? arg-0 2) 2) (else 3))))
(define NetworkC-45SocketC-45Data-u--show_Show_SocketAddress (lambda (arg-0) (case (vector-ref arg-0 0) ((0) (let ((e-0 (vector-ref arg-0 1))) (let ((e-1 (vector-ref arg-0 2))) (let ((e-2 (vector-ref arg-0 3))) (let ((e-3 (vector-ref arg-0 4))) (PreludeC-45Types-u--foldMap_Foldable_List csegen-59 (lambda (eta-0) eta-0) (DataC-45List-intersperse "." (PreludeC-45TypesC-45List-mapAppend '() (lambda (eta-0) (PreludeC-45Show-u--show_Show_Int eta-0)) (cons e-0 (cons e-1 (cons e-2 (cons e-3 '())))))))))))) ((1) "NOT IMPLEMENTED YET") ((2) (let ((e-4 (vector-ref arg-0 1))) e-4)) (else "Invalid"))))
(define NetworkC-45Socket-n--4082-9347-u--saString (lambda (arg-1 arg-2 arg-3 arg-4 arg-5) (if (null? arg-5) "" (let ((e-1 (unbox arg-5))) (NetworkC-45SocketC-45Data-u--show_Show_SocketAddress e-1)))))
(define NetworkC-45Socket-bind (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_bind (let ((e-0 (vector-ref arg-2 0))) e-0) (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily (let ((e-10 (vector-ref arg-2 1))) e-10)) (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketType (let ((e-9 (vector-ref arg-2 2))) e-9)) (NetworkC-45Socket-n--4082-9347-u--saString arg-1 arg-4 arg-3 arg-2 arg-3) arg-4 eta-0))))) (lambda (u--bind_res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--bind_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc1 1) (NetworkC-45SocketC-45Data-getErrno arg-1)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (blodwen-toSignedInt 0 63))))))))))))))
(define NetworkC-45SocketC-45Raw-getSockPort (lambda (arg-1 arg-2) (let ((e-2 (cdr arg-1))) ((e-2 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_sockaddr_port (let ((e-0 (vector-ref arg-2 0))) e-0) eta-0))))))
(define NetworkC-45SocketC-45Data-BACKLOG 20)
(define NetworkC-45Socket-listen (lambda (arg-1 arg-2) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_listen (let ((e-0 (vector-ref arg-2 0))) e-0) NetworkC-45SocketC-45Data-BACKLOG eta-0))))) (lambda (u--listen_res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--listen_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc1 1) (NetworkC-45SocketC-45Data-getErrno arg-1)) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (blodwen-toSignedInt 0 63))))))))))))))
(define NetworkC-45Socket-socket (lambda (arg-1 arg-2 arg-3 arg-4) (let ((e-1 (car arg-1))) (let ((e-4 (vector-ref e-1 1))) ((((e-4 'erased) 'erased) (let ((e-6 (cdr arg-1))) ((e-6 'erased) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_socket (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketFamily arg-2) (NetworkC-45SocketC-45Data-u--toCode_ToCode_SocketType arg-3) arg-4 eta-0))))) (lambda (u--socket_res) (let ((sc1 (PreludeC-45EqOrd-u--C-61C-61_Eq_Int u--socket_res (blodwen-toSignedInt -1 63)))) (cond ((equal? sc1 1) (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-13 (vector-ref e-10 0))) ((((e-13 'erased) 'erased) (lambda (eta-0) (vector 0 eta-0))) (NetworkC-45SocketC-45Data-getErrno arg-1)))))) (else (let ((e-7 (car arg-1))) (let ((e-10 (vector-ref e-7 0))) (let ((e-12 (vector-ref e-10 1))) ((e-12 'erased) (vector 1 (vector u--socket_res arg-2 arg-3 arg-4)))))))))))))))
(define IdrisC-45IDEModeC-45REPL-socketToFile (lambda (arg-0 ext-0) (let ((e-0 (vector-ref arg-0 0))) (let ((act-1 (PreludeC-45IO-u--map_Functor_IO (lambda (eta-0) eta-0) (lambda (eta-0) (NetworkC-45FFI-prim__idrnet_fdopen e-0 "r+" eta-0)) ext-0))) (let ((act-2 ((SystemC-45FileC-45Error-fileError csegen-82 act-1) ext-0))) (cond ((equal? act-2 1) (vector 0 "Failed to fdopen socket file descriptor")) (else (vector 1 act-1))))))))
(define IdrisC-45IDEModeC-45REPL-initIDESocketFile (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((NetworkC-45Socket-socket csegen-82 2 1 0) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append (PreludeC-45Show-u--show_Show_Int e-2) "\xa;") ext-0))) (let ((act-3 (PreludeC-45IO-prim__putStr "Failed to open socket\xa;" ext-0))) (csegen-1969 ext-0))))) (else (let ((e-5 (vector-ref act-1 1))) (let ((act-2 ((NetworkC-45Socket-bind csegen-82 e-5 (box (vector 2 arg-0)) arg-1) ext-0))) (let ((sc1 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int act-2 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc1 1) (vector 0 (string-append "Failed to bind socket with error: " (PreludeC-45Show-u--show_Show_Int act-2)))) (else (let ((act-3 ((NetworkC-45Socket-listen csegen-82 e-5) ext-0))) (let ((sc2 (PreludeC-45EqOrd-u--C-47C-61_Eq_Int act-3 (blodwen-toSignedInt 0 63)))) (cond ((equal? sc2 1) (vector 0 (string-append "Failed to listen on socket with error: " (PreludeC-45Show-u--show_Show_Int act-3)))) (else (let ((act-4 ((NetworkC-45SocketC-45Raw-getSockPort csegen-82 e-5) ext-0))) (let ((act-5 (PreludeC-45IO-prim__putStr (string-append (PreludeC-45Show-u--show_Show_Int act-4) "\xa;") ext-0))) (let ((act-6 (csegen-3886 ext-0))) (let ((act-7 ((NetworkC-45Socket-accept csegen-82 e-5) ext-0))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 (string-append "Failed to accept on socket with error: " (PreludeC-45Show-u--show_Show_Int e-2))))) (else (let ((e-6 (vector-ref act-7 1))) (let ((e-8 (car e-6))) (IdrisC-45IDEModeC-45REPL-socketToFile e-8 ext-0)))))))))))))))))))))))
(define IdrisC-45Driver-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32stMain-3536 (lambda (arg-0 arg-1 arg-2 arg-3 arg-4 arg-5 arg-6 arg-7 arg-8 arg-9 arg-10 arg-11 arg-12 arg-13 arg-14 arg-15 arg-16 arg-17 arg-18 arg-19 arg-20 arg-21 arg-22 arg-23 ext-0) (let ((e-2 (car arg-23))) (let ((e-3 (cdr arg-23))) (let ((act-1 (let ((act-1 (IdrisC-45IDEModeC-45REPL-initIDESocketFile e-2 e-3 ext-0))) (vector 1 act-1)))) (case (vector-ref act-1 0) ((0) (let ((e-4 (vector-ref act-1 1))) (vector 0 e-4))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-1) (case (vector-ref e-5 0) ((0) (let ((e-4 (vector-ref e-5 1))) (let ((act-2 (let ((act-2 (PreludeC-45IO-prim__putStr (string-append e-4 "\xa;") clam-1))) (vector 1 act-2)))) (case (vector-ref act-2 0) ((0) (let ((e-6 (vector-ref act-2 1))) (vector 0 e-6))) (else (let ((act-3 (csegen-1969 clam-1))) (vector 1 act-3))))))) (else (let ((e-6 (vector-ref e-5 1))) (let ((act-2 ((IdrisC-45REPLC-45Opts-setOutput arg-12 (vector 0 0 e-6 e-6)) clam-1))) (case (vector-ref act-2 0) ((0) (let ((e-4 (vector-ref act-2 1))) (vector 0 e-4))) (else (IdrisC-45IDEModeC-45REPL-replIDE arg-6 arg-16 arg-7 arg-18 arg-12 clam-1)))))))))) eff-0) ext-0)))))))))
(define IdrisC-45Driver-stMain (lambda (arg-0 arg-1 ext-0) (let ((act-1 ((IdrisC-45Driver-tryYaffle arg-1) ext-0))) (case (vector-ref act-1 0) ((0) (let ((e-2 (vector-ref act-1 1))) (vector 0 e-2))) (else (let ((e-5 (vector-ref act-1 1))) ((let ((eff-0 (lambda (clam-0) (cond ((equal? e-5 0) (let ((act-2 ((IdrisC-45Driver-tryTTM arg-1) clam-0))) (case (vector-ref act-2 0) ((0) (let ((e-2 (vector-ref act-2 1))) (vector 0 e-2))) (else (let ((e-6 (vector-ref act-2 1))) ((let ((eff-0 (lambda (clam-1) (cond ((equal? e-6 0) (let ((act-3 (CoreC-45Context-initDefs clam-1))) (case (vector-ref act-3 0) ((0) (let ((e-2 (vector-ref act-3 1))) (vector 0 e-2))) (else (let ((e-7 (vector-ref act-3 1))) ((let ((eff-0 (let ((u--updated (PreludeC-45Types-u--foldl_Foldable_List (lambda (u--o) (lambda (lamc-0) (let ((e-2 (car lamc-0))) (CoreC-45Options-addCG (cons e-2 (vector 8 e-2)) u--o)))) (let ((e-4 (vector-ref e-7 4))) e-4) arg-0))) (lambda (eta-0) (let ((act-4 ((CoreC-45Core-newRef (vector "Core.Context.Ctxt" ) (let ((e-0 (vector-ref e-7 0))) (let ((e-1 (vector-ref e-7 1))) (let ((e-2 (vector-ref e-7 2))) (let ((e-3 (vector-ref e-7 3))) (let ((e-35 (vector-ref e-7 5))) (let ((e-34 (vector-ref e-7 6))) (let ((e-33 (vector-ref e-7 7))) (let ((e-8 (vector-ref e-7 8))) (let ((e-9 (vector-ref e-7 9))) (let ((e-10 (vector-ref e-7 10))) (let ((e-11 (vector-ref e-7 11))) (let ((e-12 (vector-ref e-7 12))) (let ((e-13 (vector-ref e-7 13))) (let ((e-14 (vector-ref e-7 14))) (let ((e-15 (vector-ref e-7 15))) (let ((e-16 (vector-ref e-7 16))) (let ((e-17 (vector-ref e-7 17))) (let ((e-18 (vector-ref e-7 18))) (let ((e-19 (vector-ref e-7 19))) (let ((e-20 (vector-ref e-7 20))) (let ((e-21 (vector-ref e-7 21))) (let ((e-22 (vector-ref e-7 22))) (let ((e-23 (vector-ref e-7 23))) (let ((e-24 (vector-ref e-7 24))) (let ((e-25 (vector-ref e-7 25))) (let ((e-26 (vector-ref e-7 26))) (let ((e-27 (vector-ref e-7 27))) (let ((e-28 (vector-ref e-7 28))) (let ((e-29 (vector-ref e-7 29))) (let ((e-30 (vector-ref e-7 30))) (let ((e-31 (vector-ref e-7 31))) (let ((e-32 (vector-ref e-7 32))) (vector e-0 e-1 e-2 e-3 u--updated e-35 e-34 e-33 e-8 e-9 e-10 e-11 e-12 e-13 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24 e-25 e-26 e-27 e-28 e-29 e-30 e-31 e-32)))))))))))))))))))))))))))))))))) eta-0))) (case (vector-ref act-4 0) ((0) (let ((e-2 (vector-ref act-4 1))) (vector 0 e-2))) (else (let ((e-8 (vector-ref act-4 1))) ((let ((eff-0 (lambda (eta-1) (let ((act-5 (csegen-1981 eta-1))) (case (vector-ref act-5 0) ((0) (let ((e-2 (vector-ref act-5 1))) (vector 0 e-2))) (else (let ((e-9 (vector-ref act-5 1))) ((let ((eff-0 (lambda (eta-2) (let ((act-6 ((CoreC-45Context-setCG e-8 (PreludeC-45Types-maybe (lambda () (vector 0 )) (lambda () (lambda (eta-3) (vector 8 (Builtin-fst eta-3)))) (DataC-45List-headC-39 arg-0))) eta-2))) (case (vector-ref act-6 0) ((0) (let ((e-2 (vector-ref act-6 1))) (vector 0 e-2))) (else (let ((act-7 ((CoreC-45InitPrimitives-addPrimitives e-8) eta-2))) (case (vector-ref act-7 0) ((0) (let ((e-2 (vector-ref act-7 1))) (vector 0 e-2))) (else (let ((act-8 (CoreC-45Context-setWorkingDir e-8 "." eta-2))) (case (vector-ref act-8 0) ((0) (let ((e-2 (vector-ref act-8 1))) (vector 0 e-2))) (else (let ((act-9 (let ((act-9 (CoreC-45Context-getSession e-8 eta-2))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((e-13 (vector-ref act-9 1))) ((let ((eff-0 (let ((sc11 (IdrisC-45Driver-ignoreMissingIpkg arg-1))) (cond ((equal? sc11 1) (CoreC-45Context-setSession e-8 (let ((e-0 (vector-ref e-13 0))) (let ((e-1 (vector-ref e-13 1))) (let ((e-2 (vector-ref e-13 2))) (let ((e-3 (vector-ref e-13 3))) (let ((e-4 (vector-ref e-13 4))) (let ((e-33 (vector-ref e-13 5))) (let ((e-32 (vector-ref e-13 6))) (let ((e-30 (vector-ref e-13 8))) (let ((e-29 (vector-ref e-13 9))) (let ((e-28 (vector-ref e-13 10))) (let ((e-27 (vector-ref e-13 11))) (let ((e-26 (vector-ref e-13 12))) (let ((e-25 (vector-ref e-13 13))) (let ((e-14 (vector-ref e-13 14))) (let ((e-15 (vector-ref e-13 15))) (let ((e-16 (vector-ref e-13 16))) (let ((e-17 (vector-ref e-13 17))) (let ((e-18 (vector-ref e-13 18))) (let ((e-19 (vector-ref e-13 19))) (let ((e-20 (vector-ref e-13 20))) (let ((e-21 (vector-ref e-13 21))) (let ((e-22 (vector-ref e-13 22))) (let ((e-23 (vector-ref e-13 23))) (let ((e-24 (vector-ref e-13 24))) (vector e-0 e-1 e-2 e-3 e-4 e-33 e-32 1 e-30 e-29 e-28 e-27 e-26 e-25 e-14 e-15 e-16 e-17 e-18 e-19 e-20 e-21 e-22 e-23 e-24))))))))))))))))))))))))))) (else (lambda (eta-3) (vector 1 (vector 0 )))))))) eff-0) eta-2))))))) (case (vector-ref act-9 0) ((0) (let ((e-2 (vector-ref act-9 1))) (vector 0 e-2))) (else (let ((u--ide (IdrisC-45SetOptions-ideMode arg-1))) (let ((u--ideSocket (IdrisC-45SetOptions-ideModeSocket arg-1))) (let ((u--outmode (cond ((equal? u--ide 1) csegen-1983) (else (vector 1 2))))) (let ((u--fname (IdrisC-45Driver-findInput arg-1))) (let ((act-10 ((CoreC-45Core-newRef (vector "Idris.REPL.Opts.ROpts" ) (IdrisC-45REPLC-45Opts-defaultOpts u--fname u--outmode arg-0)) eta-2))) (case (vector-ref act-10 0) ((0) (let ((e-2 (vector-ref act-10 1))) (vector 0 e-2))) (else (let ((e-14 (vector-ref act-10 1))) ((let ((eff-0 (lambda (eta-3) (let ((act-11 (IdrisC-45Driver-updateEnv e-8 e-14 eta-3))) (case (vector-ref act-11 0) ((0) (let ((e-2 (vector-ref act-11 1))) (vector 0 e-2))) (else (let ((act-12 ((IdrisC-45Driver-showInfo e-8 e-14 arg-1) eta-3))) (case (vector-ref act-12 0) ((0) (let ((e-2 (vector-ref act-12 1))) (vector 0 e-2))) (else (let ((e-16 (vector-ref act-12 1))) ((let ((eff-0 (lambda (clam-2) (cond ((equal? e-16 1) (vector 1 (vector 0 ))) (else (let ((act-13 ((IdrisC-45SetOptions-preOptions e-8 e-14 arg-1) clam-2))) (case (vector-ref act-13 0) ((0) (let ((e-2 (vector-ref act-13 1))) (vector 0 e-2))) (else (let ((e-17 (vector-ref act-13 1))) ((let ((eff-0 (lambda (clam-3) (cond ((equal? e-17 1) (let ((act-14 (IdrisC-45Package-processPackageOpts e-8 e-9 e-14 arg-1 clam-3))) (case (vector-ref act-14 0) ((0) (let ((e-2 (vector-ref act-14 1))) (vector 0 e-2))) (else (let ((e-18 (vector-ref act-14 1))) ((let ((eff-0 (cond ((equal? e-18 1) (lambda (eta-4) (vector 1 (vector 0 )))) (else (PreludeC-45Basics-flip (lambda (eta-4) (lambda (eta-5) (lambda (eta-6) (CoreC-45Core-u--catch_Catchable_Core_Error eta-4 eta-5 eta-6)))) (lambda (eta-4) (lambda (eta-5) (IdrisC-45Driver-n--15193-2624-u--renderError arg-1 arg-0 e-8 e-9 e-14 eta-4 eta-5))) (lambda (eta-4) (let ((act-15 (let ((sc19 (IdrisC-45Driver-checkVerbose arg-1))) (cond ((equal? sc19 1) ((IdrisC-45REPLC-45Opts-setOutput e-14 (vector 1 2)) eta-4)) (else (vector 1 (vector 0 ))))))) (case (vector-ref act-15 0) ((0) (let ((e-2 (vector-ref act-15 1))) (vector 0 e-2))) (else (let ((act-16 (csegen-1985 eta-4))) (case (vector-ref act-16 0) ((0) (let ((e-2 (vector-ref act-16 1))) (vector 0 e-2))) (else (let ((e-20 (vector-ref act-16 1))) ((let ((eff-0 (lambda (eta-5) (let ((act-17 ((PreludeC-45Types-maybe (lambda () (lambda (eta-6) (vector 1 (vector 2 (vector 0 ))))) (lambda () (lambda (fname-0) (lambda (eta-6) (let ((act-17 (CoreC-45Directory-ctxtPathToNS e-8 fname-0 eta-6))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-7) (vector 1 (vector 0 e-21))))) eff-0) eta-6)))))))) u--fname) eta-5))) (case (vector-ref act-17 0) ((0) (let ((e-2 (vector-ref act-17 1))) (vector 0 e-2))) (else (let ((e-21 (vector-ref act-17 1))) ((let ((eff-0 (lambda (eta-6) (let ((act-18 ((CoreC-45Core-newRef (vector "Core.Metadata.MD" ) (CoreC-45Metadata-initMetadata e-21)) eta-6))) (case (vector-ref act-18 0) ((0) (let ((e-2 (vector-ref act-18 1))) (vector 0 e-2))) (else (let ((e-22 (vector-ref act-18 1))) ((let ((eff-0 (lambda (eta-7) (let ((act-19 (IdrisC-45Driver-updateREPLOpts e-14 eta-7))) (case (vector-ref act-19 0) ((0) (let ((e-2 (vector-ref act-19 1))) (vector 0 e-2))) (else (let ((act-20 (CoreC-45Context-getSession e-8 eta-7))) (case (vector-ref act-20 0) ((0) (let ((e-2 (vector-ref act-20 1))) (vector 0 e-2))) (else (let ((e-24 (vector-ref act-20 1))) ((let ((eff-0 (lambda (eta-8) (let ((act-21 (let ((sc25 (let ((e-2 (vector-ref e-24 2))) e-2))) (cond ((equal? sc25 1) (vector 1 (vector 0 ))) (else (let ((act-21 (IdrisC-45REPLC-45Common-iputStrLn e-8 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-pretty0 csegen-702 IdrisC-45Driver-banner) eta-8))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((sc27 (DataC-45List-isCons arg-0))) (cond ((equal? sc27 1) (IdrisC-45REPLC-45Common-iputStrLn e-8 e-14 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-C-60C-43C-43C-62 (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Util-reflow "With codegen for:") (LibrariesC-45TextC-45PrettyPrintC-45PrettyprinterC-45Doc-hsep (PreludeC-45TypesC-45List-mapAppend '() csegen-1987 arg-0))) eta-8)) (else (vector 1 (vector 0 ))))))))))))) (case (vector-ref act-21 0) ((0) (let ((e-2 (vector-ref act-21 1))) (vector 0 e-2))) (else (let ((act-22 (let ((sc26 (let ((e-3 (vector-ref e-24 3))) e-3))) (cond ((equal? sc26 1) (IdrisC-45Package-findIpkg e-8 e-14 e-9 u--fname eta-8)) (else (vector 1 u--fname)))))) (case (vector-ref act-22 0) ((0) (let ((e-2 (vector-ref act-22 1))) (vector 0 e-2))) (else (let ((e-26 (vector-ref act-22 1))) ((let ((eff-0 (lambda (eta-9) (let ((act-23 ((IdrisC-45REPLC-45Opts-setMainFile e-14 e-26) eta-9))) (case (vector-ref act-23 0) ((0) (let ((e-2 (vector-ref act-23 1))) (vector 0 e-2))) (else (let ((act-24 (if (null? e-26) (CoreC-45ContextC-45Log-logTime e-8 1 (lambda () "Loading prelude") (lambda (eta-10) (let ((act-24 (let ((sc29 (let ((e-0 (vector-ref e-24 0))) e-0))) (cond ((equal? sc29 1) (vector 1 (vector 0 ))) (else (IdrisC-45ProcessIdr-readPrelude e-8 e-20 e-9 1 eta-10)))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (vector 1 (vector 0 )))))) eta-9) (let ((e-2 (unbox e-26))) (CoreC-45ContextC-45Log-logTime e-8 1 (lambda () "Loading main file") (lambda (eta-10) (let ((act-24 (IdrisC-45REPL-loadMainFile e-8 e-20 e-9 e-22 e-14 e-2 eta-10))) (case (vector-ref act-24 0) ((0) (let ((e-3 (vector-ref act-24 1))) (vector 0 e-3))) (else (let ((e-28 (vector-ref act-24 1))) ((let ((eff-0 (lambda (eta-11) (let ((act-25 (IdrisC-45REPL-displayErrors e-8 e-20 e-9 e-22 e-14 e-28 eta-11))) (case (vector-ref act-25 0) ((0) (let ((e-3 (vector-ref act-25 1))) (vector 0 e-3))) (else (vector 1 e-28))))))) eff-0) eta-10)))))) eta-9))))) (case (vector-ref act-24 0) ((0) (let ((e-2 (vector-ref act-24 1))) (vector 0 e-2))) (else (let ((e-28 (vector-ref act-24 1))) ((let ((eff-0 (lambda (eta-10) (let ((act-25 (CoreC-45Core-u--catch_Catchable_Core_Error (IdrisC-45SetOptions-postOptions e-8 e-20 e-9 e-22 e-14 e-28 arg-1) (lambda (u--err) (lambda (eta-11) (CoreC-45Core-C-42C-62 (lambda (eta-12) (IdrisC-45REPLC-45Common-emitError e-8 e-14 e-9 u--err eta-12)) (lambda (eta-12) (vector 1 0)) eta-11))) eta-10))) (case (vector-ref act-25 0) ((0) (let ((e-2 (vector-ref act-25 1))) (vector 0 e-2))) (else (let ((e-29 (vector-ref act-25 1))) ((let ((eff-0 (cond ((equal? e-29 1) (let ((sc31 (cond ((equal? u--ide 1) 1) (else u--ideSocket)))) (cond ((equal? sc31 1) (cond ((equal? u--ideSocket 1) (lambda (eta-11) (IdrisC-45Driver-case--caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32caseC-32blockC-32inC-32stMain-3536 arg-1 arg-0 0 0 e-7 u--updated e-8 e-9 u--ide u--ideSocket u--outmode u--fname e-14 e-16 1 e-18 e-20 e-21 e-22 e-24 e-26 e-28 1 (IdrisC-45CommandLine-ideSocketModeAddress arg-1) eta-11))) (else (lambda (eta-11) (let ((act-26 ((IdrisC-45REPLC-45Opts-setOutput e-14 csegen-1983) eta-11))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (IdrisC-45IDEModeC-45REPL-replIDE e-8 e-20 e-9 e-22 e-14 eta-11)))))))) (else (lambda (eta-11) (let ((act-26 (IdrisC-45REPL-repl e-8 e-20 e-9 e-22 e-14 eta-11))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (CoreC-45ContextC-45Log-showTimeRecord e-8 eta-11))))))))) (else (lambda (eta-11) (let ((act-26 (let ((act-26 (unbox e-14))) (vector 1 act-26)))) (case (vector-ref act-26 0) ((0) (let ((e-2 (vector-ref act-26 1))) (vector 0 e-2))) (else (let ((e-30 (vector-ref act-26 1))) ((let ((eff-0 (lambda (eta-12) (let ((act-27 (CoreC-45ContextC-45Log-showTimeRecord e-8 eta-12))) (case (vector-ref act-27 0) ((0) (let ((e-2 (vector-ref act-27 1))) (vector 0 e-2))) (else (let ((e-41 (vector-ref e-30 7))) (if (null? e-41) (vector 1 (vector 0 )) (let ((act-28 (csegen-1969 eta-12))) (vector 1 act-28)))))))))) eff-0) eta-11)))))))))) eff-0) eta-10)))))))) eff-0) eta-9))))))))))) eff-0) eta-8))))))))))) eff-0) eta-7))))))))))) eff-0) eta-6)))))))) eff-0) eta-5)))))))) eff-0) eta-4)))))))))))))) eff-0) clam-3)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-2)))))))))) eff-0) eta-3))))))))))) eff-0) eta-2)))))))))))))))))))))))) eff-0) eta-1)))))))) eff-0) eta-0))))))))) eff-0) clam-1)))))) (else (vector 1 (vector 0 ))))))) eff-0) clam-0)))))) (else (vector 1 (vector 0 ))))))) eff-0) ext-0)))))))
(define PreludeC-45Interfaces-when (lambda (arg-1 arg-2 arg-3) (cond ((equal? arg-2 1) (arg-3)) (else (let ((e-2 (vector-ref arg-1 1))) ((e-2 'erased) (vector 0 )))))))
(define IdrisC-45Driver-mainWithCodegens (lambda (arg-0 ext-0) (let ((act-1 (IdrisC-45CommandLine-getCmdOpts ext-0))) (case (vector-ref act-1 0) ((1) (let ((e-2 (vector-ref act-1 1))) (let ((act-2 ((IdrisC-45Driver-quitOpts e-2) ext-0))) ((PreludeC-45Interfaces-when csegen-75 act-2 (lambda () (lambda (world-0) (let ((act-3 (LibrariesC-45UtilsC-45Term-setupTerm world-0))) (CoreC-45Core-coreRun (lambda (eta-0) (IdrisC-45Driver-stMain arg-0 e-2 eta-0)) (lambda (u--err) (lambda (world-1) (let ((act-4 (PreludeC-45IO-prim__putStr (string-append (string-append "Uncaught error: " (CoreC-45Core-u--show_Show_Error u--err)) "\xa;") world-1))) (csegen-1969 world-1)))) (lambda (u--res) (lambda (eta-0) (vector 0 ))) world-0))))) ext-0)))) (else (let ((e-5 (vector-ref act-1 1))) (let ((act-2 (PreludeC-45IO-prim__putStr (string-append e-5 "\xa;") ext-0))) (PreludeC-45IO-prim__putStr (string-append IdrisC-45CommandLine-usage "\xa;") ext-0))))))))
(define IdrisC-45Main-main (lambda (ext-0) (IdrisC-45Driver-mainWithCodegens '() ext-0)))
(define PreludeC-45EqOrd-compareInteger (lambda (ext-0 ext-1) (PreludeC-45EqOrd-u--compare_Ord_Integer ext-0 ext-1)))
(collect-request-handler (lambda () (collect) (blodwen-run-finalisers)))
(PrimIO-unsafePerformIO (lambda (eta-0) (IdrisC-45Main-main eta-0)))
  (collect 4)
  (blodwen-run-finalisers)
  
  )